(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   2042485,      49845]
NotebookOptionsPosition[   2022850,      49349]
NotebookOutlinePosition[   2023292,      49366]
CellTagsIndexPosition[   2023249,      49363]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"AppendTo", "[", 
   RowBox[{
   "$Path", ",", 
    "\"\<C:\\\\Program Files\\\\Wolfram \
Research\\\\Mathematica\\\\LevelScheme-3.53\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Get", "[", "\"\<LevelScheme`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ruru", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"m", "\[Rule]", 
      RowBox[{"4.3", " ", 
       SuperscriptBox["10", "6"]}]}], ",", 
     RowBox[{"G", "\[Rule]", 
      RowBox[{"6.67", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "8"}]]}]}], ",", 
     RowBox[{"tM", "\[Rule]", 
      FractionBox["rg", 
       RowBox[{"60", " ", "cc"}]]}], 
     RowBox[{"(*", 
      RowBox[{"min", "/", "M"}], "*)"}], ",", 
     RowBox[{"rg", "\[Rule]", 
      FractionBox[
       RowBox[{"G", " ", "m", " ", "Msun"}], 
       SuperscriptBox["cc", "2"]]}], ",", 
     RowBox[{"dd", "\[Rule]", 
      RowBox[{"8.4", " ", 
       SuperscriptBox["10", "3"], "pc"}]}], ",", 
     RowBox[{"arcsec", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "\[Pi]", " ", "dd"}], 
       RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
     RowBox[{"pc", "\[Rule]", 
      RowBox[{"3.08", " ", 
       SuperscriptBox["10", "18"]}]}], ",", 
     RowBox[{"year", "\[Rule]", 
      RowBox[{"365.35", " ", "86400"}]}], ",", 
     RowBox[{"cc", "\[Rule]", 
      RowBox[{"3.", " ", 
       SuperscriptBox["10", "10"]}]}], ",", 
     RowBox[{"Msun", "\[Rule]", 
      RowBox[{"2.", " ", 
       SuperscriptBox["10", "33"]}]}], ",", 
     RowBox[{"mp", "\[Rule]", 
      RowBox[{"1.67", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "24"}]]}]}], ",", 
     RowBox[{"me", "\[Rule]", 
      RowBox[{"9.1", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "28"}]]}]}], ",", 
     RowBox[{"kb", "\[Rule]", 
      RowBox[{"1.38", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "16"}]]}]}], ",", 
     RowBox[{"h", "\[Rule]", 
      RowBox[{"6.626", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "27"}]]}]}], ",", 
     RowBox[{"ee", "\[Rule]", 
      RowBox[{"4.8", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "10"}]]}]}], ",", 
     RowBox[{"keV", "->", 
      RowBox[{"1000", " ", "1.602", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";", 
  RowBox[{"ruru", "=", 
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"ruru", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1"}], "]"}], "]"}], "\[Rule]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"ruru", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}], "//.", "ruru"}], ")"}]}], 
    "]"}]}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.56864796509368*^9, 3.568647965530481*^9}, {
  3.5695425743903923`*^9, 3.5695426351348267`*^9}, {3.5709834080855284`*^9, 
  3.5709834081755285`*^9}, {3.5745153126705694`*^9, 3.5745153233721886`*^9}, {
  3.575630910419727*^9, 3.5756309120197515`*^9}, {3.5756309438747406`*^9, 
  3.5756310429372625`*^9}, {3.5756311951611023`*^9, 3.57563120086619*^9}, {
  3.5756312723457875`*^9, 3.5756312745058208`*^9}, {3.576851312799863*^9, 
  3.5768513164974203`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"rurux", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"G", "\[Rule]", 
      RowBox[{"6.67", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "8"}]]}]}], ",", 
     RowBox[{"tM", "\[Rule]", 
      FractionBox["rg", 
       RowBox[{"60", " ", "cc"}]]}], 
     RowBox[{"(*", 
      RowBox[{"min", "/", "M"}], "*)"}], ",", 
     RowBox[{"rg", "\[Rule]", 
      FractionBox[
       RowBox[{"G", " ", "m", " ", "Msun"}], 
       SuperscriptBox["cc", "2"]]}], ",", 
     RowBox[{"dd", "\[Rule]", 
      RowBox[{"8.4", " ", 
       SuperscriptBox["10", "3"], "pc"}]}], ",", 
     RowBox[{"arcsec", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "\[Pi]", " ", "dd"}], 
       RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
     RowBox[{"pc", "\[Rule]", 
      RowBox[{"3.08", " ", 
       SuperscriptBox["10", "18"]}]}], ",", 
     RowBox[{"year", "\[Rule]", 
      RowBox[{"365.35", " ", "86400"}]}], ",", 
     RowBox[{"cc", "\[Rule]", 
      RowBox[{"3.", " ", 
       SuperscriptBox["10", "10"]}]}], ",", 
     RowBox[{"Msun", "\[Rule]", 
      RowBox[{"2.", " ", 
       SuperscriptBox["10", "33"]}]}], ",", 
     RowBox[{"mp", "\[Rule]", 
      RowBox[{"1.67", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "24"}]]}]}], ",", 
     RowBox[{"me", "\[Rule]", 
      RowBox[{"9.1", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "28"}]]}]}], ",", 
     RowBox[{"kb", "\[Rule]", 
      RowBox[{"1.38", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "16"}]]}]}], ",", 
     RowBox[{"h", "\[Rule]", 
      RowBox[{"6.626", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "27"}]]}]}], ",", 
     RowBox[{"ee", "\[Rule]", 
      RowBox[{"4.8", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "10"}]]}]}], ",", 
     RowBox[{"keV", "->", 
      RowBox[{"1000", " ", "1.602", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";", 
  RowBox[{"rurux", "=", 
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"rurux", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1"}], "]"}], "]"}], "\[Rule]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"rurux", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}], "//.", "rurux"}], ")"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Frequency \[Nu]=\>\"", ",", 
   RowBox[{"\[Nu]x", "=", "118"}], ",", 
   "\"\<Hz for 10Msun BH \[Implies] \[Tau]=\>\"", ",", 
   RowBox[{
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"\[Nu]x", " ", 
        RowBox[{"10", "/", "m"}]}], ")"}]}], "/", "60"}], "/.", 
    RowBox[{"m", "\[Rule]", 
     RowBox[{"4.3", " ", 
      SuperscriptBox["10", "6"]}]}]}], ",", 
   "\"\<min for Sgr \!\(\*SuperscriptBox[\(A\), \(*\)]\)\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<For GROJ1655-40: main period = \>\"", ",", 
   RowBox[{"\[Nu]\[Nu]", "=", "300"}], 
   RowBox[{"(*", "450", "*)"}], ",", "\"\<Hz = \>\"", ",", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{
      FractionBox[
       RowBox[{"(", 
        RowBox[{"cc", "/", "rg"}], ")"}], "\[Nu]f"], "/.", "rurux"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"m", "\[Rule]", "6.3"}], ",", 
       RowBox[{"\[Nu]f", "\[Rule]", "\[Nu]\[Nu]"}]}], "}"}]}], "]"}], ",", 
   "\"\<M\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<For XTEJ1550-564: main period = \>\"", ",", 
   RowBox[{"\[Nu]\[Nu]", "=", "276"}], ",", "\"\<Hz = \>\"", ",", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{
      FractionBox[
       RowBox[{"(", 
        RowBox[{"cc", "/", "rg"}], ")"}], "\[Nu]f"], "/.", "rurux"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"m", "\[Rule]", "9.1"}], ",", 
       RowBox[{"\[Nu]f", "\[Rule]", "\[Nu]\[Nu]"}]}], "}"}]}], "]"}], ",", 
   "\"\<M\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<For GRS1915+105: main period = \>\"", ",", 
   RowBox[{"\[Nu]\[Nu]", "=", "168"}], ",", "\"\<Hz = \>\"", ",", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{
      FractionBox[
       RowBox[{"(", 
        RowBox[{"cc", "/", "rg"}], ")"}], "\[Nu]f"], "/.", "rurux"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"m", "\[Rule]", "10.1"}], ",", 
       RowBox[{"\[Nu]f", "\[Rule]", "\[Nu]\[Nu]"}]}], "}"}]}], "]"}], ",", 
   "\"\<M\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<For Cyg X1: \!\(\*SubscriptBox[\(\[Nu]\), \(2\)]\) period = \>\"", ",", 
   RowBox[{"\[Nu]\[Nu]", "=", "135"}], ",", "\"\<Hz = \>\"", ",", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{
      FractionBox[
       RowBox[{"(", 
        RowBox[{"cc", "/", "rg"}], ")"}], "\[Nu]f"], "/.", "rurux"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"m", "\[Rule]", "14.8"}], ",", 
       RowBox[{"\[Nu]f", "\[Rule]", "\[Nu]\[Nu]"}]}], "}"}]}], "]"}], ",", 
   "\"\<M\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sug", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"z1", "\[Rule]", 
      RowBox[{"1", "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"1", "-", 
           SuperscriptBox["a", "2"]}], ")"}], 
         RowBox[{"1", "/", "3"}]], 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", "a"}], ")"}], 
           RowBox[{"1", "/", "3"}]], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "-", "a"}], ")"}], 
           RowBox[{"1", "/", "3"}]]}], ")"}]}]}]}], ",", 
     RowBox[{"z2", "\[Rule]", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", 
          SuperscriptBox["a", "2"]}], "+", 
         SuperscriptBox["z1", "2"]}], ")"}], 
       RowBox[{"1", "/", "2"}]]}], ",", 
     RowBox[{"risco", "\[Rule]", 
      RowBox[{"3", "+", "z2", "-", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"3", "-", "z1"}], ")"}], 
          RowBox[{"(", 
           RowBox[{"3", "+", "z1", "+", 
            RowBox[{"2", "z2"}]}], ")"}]}], ")"}], 
        RowBox[{"1", "/", "2"}]]}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sug", "=", 
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"sug", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1"}], "]"}], "]"}], "\[Rule]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"sug", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}], "//.", "sug"}], ")"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<BH rotational frequency\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalOmega]bh", "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{
     FractionBox[
      SuperscriptBox["M", 
       RowBox[{"1", "/", "2"}]], 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"risco", " ", "M"}], ")"}], 
        RowBox[{"3", "/", "2"}]], "+", 
       RowBox[{"a", " ", 
        SuperscriptBox["M", 
         RowBox[{"3", "/", "2"}]]}]}]], ",", 
     RowBox[{"M", ">", "0"}]}], "]"}]}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Orbital timescale \!\(\*SubscriptBox[\(t\), \(orb\)]\)=\>\"", ",", 
    RowBox[{"torb", "=", 
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{"2", "\[Pi]"}], 
         RowBox[{"\[CapitalOmega]bh", " ", "M"}]], 
        FractionBox["rg", "cc"]}], ",", 
       RowBox[{"M", ">", "0"}]}], "]"}]}]}], "]"}], 
  RowBox[{"(*", 
   StyleBox[
    RowBox[{"formula", " ", "9"}],
    FontSize->16,
    FontColor->RGBColor[1, 0, 0]], "*)"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<ISCO frequency for 10\!\(\*SubscriptBox[\(M\), \(\(sun\)\(\\\ \
\)\)]\)BH: \!\(\*SubscriptBox[\(\[Nu]\), \(ISCO\)]\)=\>\"", ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"1", "/", "torb"}], "/.", "sug"}], "/.", "ruru"}], "/.", 
     RowBox[{"m", "\[Rule]", "10"}]}], "/.", 
    RowBox[{"a", "\[Rule]", "0.0"}]}], ",", " ", 
   "\"\<Hz for non-spinning BH\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<ISCO frequency for 10\!\(\*SubscriptBox[\(M\), \(\(sun\)\(\\\ \
\)\)]\)BH: \!\(\*SubscriptBox[\(\[Nu]\), \(ISCO\)]\)=\>\"", ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"1", "/", "torb"}], "/.", "sug"}], "/.", "ruru"}], "/.", 
      RowBox[{"m", "\[Rule]", "10"}]}], "/.", 
     RowBox[{"a", "\[Rule]", "0.94"}]}], ",", " ", 
    "\"\<Hz for spin a=0.94\>\""}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"t0", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"rg", "/", "cc"}], "/", "60"}], "/.", "ruru"}], "/.", 
   RowBox[{"m", "\[Rule]", 
    RowBox[{"4.3", " ", 
     SuperscriptBox["10", "6"]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"t0CK", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     FractionBox["3.4", "4.3"], 
     RowBox[{
      RowBox[{"rg", "/", "cc"}], "/", "60"}]}], "/.", "ruru"}], "/.", 
   RowBox[{"m", "\[Rule]", 
    RowBox[{"4.3", " ", 
     SuperscriptBox["10", "6"]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<t0Dole=\>\"", ",", 
   RowBox[{"t0Dole", "=", 
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox["4.5", "4.3"], 
       RowBox[{
        RowBox[{"rg", "/", "cc"}], "/", "60"}]}], "/.", "ruru"}], "/.", 
     RowBox[{"m", "\[Rule]", 
      RowBox[{"4.3", " ", 
       SuperscriptBox["10", "6"]}]}]}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"11", "/", "t0CK"}], "/.", 
  RowBox[{"m", "\[Rule]", 
   RowBox[{"4.3", " ", 
    SuperscriptBox["10", "6"]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"17", "/", "t0"}], "/.", 
  RowBox[{"m", "\[Rule]", 
   RowBox[{"4.3", " ", 
    SuperscriptBox["10", "6"]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"23", ",", "28", ",", "45"}], "}"}], "/", "t0"}], "/.", 
  RowBox[{"m", "\[Rule]", 
   RowBox[{"4.3", " ", 
    SuperscriptBox["10", "6"]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"2.75", " ", 
   RowBox[{"60", "/", "t0"}]}], "/.", 
  RowBox[{"m", "\[Rule]", 
   RowBox[{"4.3", " ", 
    SuperscriptBox["10", "6"]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"6", ",", "7", ",", "9"}], "}"}], "/", "t0Dole"}], "/.", 
  RowBox[{"m", "\[Rule]", 
   RowBox[{"4.3", " ", 
    SuperscriptBox["10", "6"]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   FractionBox["60", "17"], "48."}], "/.", 
  RowBox[{"m", "\[Rule]", 
   RowBox[{"4.3", " ", 
    SuperscriptBox["10", "6"]}]}]}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJwdxUsogwEAB/CR2g4srB2wKVlSIodPk5p8C3OwYhSuK3MgwtqKZW1jagdj
xUIz81hYidTiZBJ5xsHsRUPUfCdsmUce33+HX788eY+sPZnBYOTQsC9aFI3O
UOT1lPYd85TxpBh9uVecjNlfNaU4cHsjxEFbmYg3S5HS/OMq7HkJSDDxuleP
eTqPDBvShU1YZFwy4fFKV+Ilq1rPp1c8BEfxmkr7hpkx8TsW7EfScumD3W52
4oLMA7+DIvX95sSrI9UnWC4qPsNKk+wSr39c+DBH4Qzhw8HsMG6ViZ9xZx0/
ine98i9cwu39wXPNhSkBeiISYOFae5Y1RL+Z9enC20RG1x09648zgJ3MRh3+
GW5JvLLzeGpboMhvvfscO9UCpdRJkc1tFhVO3ZJosMdyNIT7Rq8MuIOrM2LH
mX0Cjy0uT+MK9r0f/8aJEJ7fmAxjjbnhCf8DZJ7xhg==
  "]],

Cell[BoxData["QPOs"], "Input",
 CellChangeTimes->{{3.576857823953987*^9, 3.576857824423994*^9}}],

Cell[BoxData[{
 RowBox[{
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzt3W1sHMed53EfeS/uRb+xXhIgoDseAb4xDIPQC0PGgTxAggMCFByDILwO
CGljnWjgDMqbM7lZhLKxJh1Es1gvFXu18XmQmMhu6FsNjDOVM23sxBF9ELMR
vaHXIrLjWPSRsceRFEoiKIGShpw5ziOHnJnq6u7q7uru7weNIBZ7unuq+1/z
m+qH+Y9/OvTN/9b0wAMPfOc/bP/PN4+NdP/Znx377pP/fvs//ut3/8fxP23e
/j+j/+6BB36/PU/+/+cAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAJ5ram5mYmLS
Z6LqmZgiOHlQ+AHl+65hYmKqnah6JqYITq4WfnD5vl+YmJhqJ6qeiSmCk6uF
H1zbLbP6n/7z9uRv6ylfke0FWnqhzMzieQR/rfunRjtFn+Nc7ZY4WZr8ayXn
tLqz6v5Jh/4qrEeL7QVafZXp/E5mkC989qOTF0qWm0sduO3NjqamclARZxUP
NiNwx7nkzC4d55LHv/fUbomTpdnosmzPJv8ncT7xZj+G9WixvUCrr3KSQ0xn
kC989qOTF0qWm0sduO3NjqBKRClOPm5JEI9zyZkJKn4tTc+gIv53goovCySo
OKTJfrT0QoJKUOwJKj5mlSAe55IzE1T8WhpBpZGwHi22F0hQcUiT/WjphQSV
oKgNKn5llSAe55IzE1T8WhpBpZGwHi22F0hQcUiT/WjphQSVoKgbVHzJKkE8
ziVnJqj4tTSCSiNhPVpsL5Cg4pAm+9HSCwkqAaJJVgnicS45M0HFr6URVBoJ
69Fie4EEFYc02Y+WXkhQCZCmqrt+fD8BBNs4zsMhakEFTrAfQ4NdKdYoqFSn
TVpPf+ypoNhTWY0mb7bB1bXAbezH0GBXijUKKnviit+bCRPsqaAgqEAV9mNo
sCvFKu0jzip+byZMcJwHBUEFqrAfQ4NdKWYaVPzeQEjhOA8HggrksR9Dg10p
ZhpUyC2BwHEeDgQVyGM/hga7Uqy6fcgqwcVxHg4EFchjP4YGu1Kstn0IKkHE
cR4OBBXIYz+GBrtSjKAC6IOgAkQQJSlWt33IKoAvCCpABFGSYjLtQ1ABvEFQ
ASKIkhQzfZ4Ddy4DCslUHEEFiBRKUoygAniJoAJgD0pSTLLbJKsASmgSVB54
/p+Kk6srAiCDoCIm2T5cWwt4wPugQlYBfEdQEZNvHz9uBbp/88qvpuOx4RN9
XW1GfjuNzp6BoVN/+/fvzX1+M5M1eXU6MWD61XV7gd8aHB4/O3UhZbLA7Mb1
xV9OnX1lZ2PauvoGCq9Nzi/dvK/wbSOyPOivqiOKrkHFQeGrrfochQ8vEFTE
LLWPh0Flc33pwzeHDhkNexujrWck/tHyhqCbkemyqhfY+9I7qVv1lpfNXLs0
eVKwMdt915GRn166ZtrplazNxw5tv6otNp8Rz5i9k57/eXxsqL+rvdTBHh+J
TX6weP2u3Iok17W1lvxui0n7tA0kVqRXapV0g+S2NtIfn4+Pb7dIW36r2rv6
h8biP59P32nQ9L6/NWsiH1QcF76yqs+pLnwvq15ydb5XB4VfQlARs9o+ngSV
u+nkD3qLX15KU3tX37cGtn2rp9OoPtI6eseT6Ua9RKXL2tcz9INYfadHn+vt
3OmI2ocSyxt7FpO98dF4d2tlpUZn7/Hhl4uvLVdNcWrtPvVBw42pdu83Ewf3
mZZndv2z82NPttUtsbYnx85/ti7TO0qt6+7S5NNmXbqbRS3XILncneWZV3Yf
GFUNMvPF3j2X5/dbsyjaQUVF4Suq+pzywvey6mVX53d1UPhlBBUxG+3j8rhK
5tqF8e5Sp1T49vT+wsp61VGcWU+nLp6LffuAUe4lxj+6Ubd4K12WSRncv5n6
36OlHsnoGL2wVv3H7NXkyMHin9r7Y9ML6d1f5bY2ri8m33y+q7Qxnc9Or5h1
JJurye91FDZMtF2Z5emTj5aLsffkxFvnEonE1Juxod5yJ9Y1MrNi9jVEbl25
9flYV2FFXX0DjRwfS35tsjabJDey+sDo6Dn56uR2i5x7a+JkuUGMb7x44eua
xvf3rVnmS1DRI6soKnwlVZ9TXvheVr306ij8KBV+oNluH5eySvbqe893GKWO
aHT6yvpmgxnvXrv0xtH24pwHR5JX6/QSsl1WfrV35v/q0eLMLd9Nrm3t/GF5
6qlCjRi9ry803ph08uVSKR08s3BP0GPdv7EQL2+2oDwrJWy0H33j0rW79ZfQ
MTJzVfDGJNe1bSUx0CbxvcYNshuZXU2OFA8Mo3f8QrpqtqrG7/hecnXPPvLx
rdkR2aCirPBVVH1OceF7WfXyq8tR+PogqIg5aR/1WaX6W8xgYtlkNDVzdWak
GMiNJyavbNX83UKXtd1JLEw8UqyavniqMpS4eW36ucIQcfvRxLJoa3a2vPrl
pe28ubQwlzx/bvK1UycOVw/qNtyurc8mn9ifn2ffiak6g9KVDq3l0NlPd1/M
Z31dO++99cjk7yTHlZ2xsZG3F89+szBP+1OTqZrrF+98PnnswboN4vVbc8qb
/kq7oKKw8BVUfU5F4XtZ9bZWl6PwNUJQEdMqqGxdmXyimJD3PZv4SuJy+uzS
1FNthe1/enKp5kozS11WOYE3NXfF5tfL/1geP9z1j/W3vXztVudw8vruP1UW
sndqtF3ZpckjhU77obGLd+qurXxut+Z7nOV15a0lh1vqbrlLrG9k5f0+9Mpc
3avn1i6MFr927WkQr9+aU34FFX/jisrCV1D1ORWF72XV21ldHoWvDYKKmMP2
UZpVNlLxvsLG7Hs09uv6pbrX/fTsjwuXx70+nbq99482u6zHJxYqi6pU1kOD
01+Kk3n25tLH89s+Xkzv2Xar5Zm9Oze+Pz/Dw0Mzf2iwtuvJ4c563+Ps9Ffl
HvLI2UW5Vq8v/3Up//6Xbpp9hbG8kVup+OHCDK2jszW7uWh1dvTR2gZR9Na8
401/1bT7OSqVqe5OEUyKNkdp4Suo+pyKwvey6m2srrBKCl8dq7Xjck2FjZL2
URNXsr+bPFK8tq1nYkH8LUaOpS7r7tzY/sLMxnPT1yqnOzdXZ75TGFpsNrpf
/qe0pdsDG8rMx9pE5ZlJJ04U2kHwba5S8iZfGczWVTXPrjduQ2mTbJwUNtvI
yjh8x4nprxoso/48it6ad6IYVNQWvoKqz7lR+F5WvcTqquah8FUgqLhKo6Cy
OjO0r7AxNRe22WShy9q5/tx4aqr6nPTOpVz55fQOxX48PfubVHrdaklWU9Fl
3Zobe6wwj8kddhL9VXl1hTmyG9c+W5hLTr+TSJxPzi1Yeafu9Ve3FyYeN2uQ
ykKMRyYWyn2TqrfmnSgGFbWFr6Lqcy4UvpdVL7G6HIWvFkHFVapaz3lQKQ/W
NTcdjqdU5BTZLit7Jz33o9L150bP+MXru3usqmvLqyaj84nnRl+Nv/3eR5e/
uGbxwDcrz8ogcOPvEdkvpvr3N5l9Y5JYV26nN+h5ZWryVF9ny+532t49+Nfv
Xv6jxDt0r7+qjO7WuxKprHL8VI0Sq3prKunQX1XWosNlKooLX03V55QXvpdV
L7G6HIWv1fcUgoqY20FFPqtUDtqmgUS63gybSzOvNniAU97k/M09L5B49NPp
0edKj3/M91ePDU7+a73nKd2/cfnd2NGDjR9Q2d59Yix+/uP0hlQ/a9qHZNOJ
o4UesuXkzGrdR+V+lTi2r1lRUKmc+G48GYdOTn1q9qQp9/qryoUEJxLpxsuu
7O6d40fVW1NJ86DifVZRXPjKqj6ntvC9rHqZ1VH4Hhe+GEFFTHm36V5Q2Zmh
7lT7KmsP037k6ORivScc7qx/feXTj977+7PjLwxUerldk9HWO37+yprpsW/e
h2SXE8c6CtXUd2ah5hK1zMrMyM41aU6Dys4VAs1G1/Nvvv+bL27kH22V3bjx
+8UPJ0e/WXnS1J8n08K3pl9/peytqURQ2UNx4Suu+pyqwvey6uVWR+F7Wvhi
BBUx5e1je1DF76DSnH8u9yu/vCZ14G5t3PwyNZ9MxGPDA927turAqeQ1k3qV
+LKTvbPww0PFYef2Pxk/d7F0XjWznl5MFn8JxWhrKwwU73vs7KeCy8XM17W5
+NaTnUb+GVM/uVz7YKvseuqng+3Ft/boX803+mGNPP36K2VvzTs6BBWP+0xf
g4qlqs85KXwvq15qdRS+t4UveUB6szGB401Qkcoq1u4rLCsc6yZBRXTh+/q1
K/+cGP+T0nHb/Njo7B+l111UeJh2fKSn9FMU5rdYylyQn8veuhw/3t7oeDaO
/ODNvzyU///OL6Y1U/mit3OvQemGxN1mJ4fyw62tQ5O/qvmb+NZF105V23hr
PtMhqFTiiqvbsENt4XtU9Tmrhe9l1cuuTozCV4qg4oRnQcU8rtyeHW0tbsyx
qRXpH08vPdjHblAp2nm8pJWjfZfNtbkflB7H/djZReG3Hdk+JHt75aMfD/d0
7D6SWw4cjU2nbtwqPWbqsbG5WwrWJdzeq9NDD+76HtfweQiNJmfnp2xf/G/j
rfnM46AiiCve9ZlqC9/Tqs/JF76XVW9hdcJlUPgKEVSccKN97F5Y+4eZoYcL
G2P+kKWKyhOBHAWVXPbufOzhmuWUS0DuRza3fhs/XLy8XDhQabUPyW5cz99c
dz6ReGc6+avFL1YLP45W+nn0JmNQ5bpkF+Jxf2X/cQrW35rPPA4qxf/0+0oV
pYXvuOpz7hS+l1VveXWyC6Hw3UJQEXOpfWyNq1RSbvODxxJfSXVYlV+CcBhU
qmauukeyMqi4f2xO4pFPcmdUldRIpW80u6PTZF3ZzcymaUNnb8++2Fr4Wnc4
/tvGa3PvVLWtB1SqfGveiWRQUVr4jqs+507he1n15quj8CNZ+MGlU1DJ5e78
OvZo4Zcdmh89Ob1sdthnM8tvHy3fr6csqFTPXBmUfugvZ9fMBggrP0uxf3zu
rqhSTMuzfD/mq5PzdU+dZ+8tnDkoV2Wyl6uJvqPdmo8VB2AfHZ1dbbwqF/sr
85/8uHNx7KE9P/mh8K15x+OgUpn8PPWTU1r4zqs+50rhe1n1Equj8L0ufMkx
KG82JnDcbh+LJ4A2b8y+fKC4Se3P/N2lPzQ+8rc2lt871d26s4vdCCq5m3Nj
xaHO1u5TH6RFP+q6sZwYKlwFZ3SMXlgTrsrpExUyS4nBwlMCJH7BzWxdlZ9Z
6Tg69Xnd51DtfCh0vDQrenCom/2VnR9RVfjWvONXUKnNKt72meoKX0lQcaHw
vax6idVR+F4XPkHFCc2Cyu7r3o3HTvztewsra7sPtmxmffnS2y/2Fi62N7qP
Hv/GfgVBpfIdatfM24d0YrD4+Mpmo73/lcSl5fW9vdb25vx65w6CfccmPzf5
GSwrT1ToGbuw+1tB5o8LpfZpPTTxsekPbpl3j5WnSBnfODXzxcauN1f9obD/
SHxR2D+62l9VPdLceDJ28euq2e5evfCD0k2dHd9Lru58/1X31ryjT1Dx+gSQ
qsJXUPU5Nwrfy6qXWR2F73HhE1Sc8KB9LN+qvPcevZbOnoGh0e8Xnyk51N9V
eXyB0f0XiVT68tkjCoJK5W7HvSeaN9fmXzvSZlQayihszen81nx/dOhYX/Uz
oLbrIvl7uVWJyzO78W8/7i/V2sGjp996N3lxfv5i8t23Tpeek2m0H/1pasP8
dL7EutZTkyfaK03d951Y/GeJbefemhju7yw9QtxoPzZ15b54de72V9tzXbsw
Xn6keUfPyVcnzxU28mRvW7nxX7zw9e5NVPXWvONxUKn+x0b3Kbu6JbsoKXw1
VZ9TXvheVr3c6ij8yBV+cHnTPtbHVW6vzP7diQN7fqOhatou5Ni7l29sx+Gt
teItew6DiugnXDfXU9Pj/Q8Lk/D2167vS/5+hFx53k1f/FGDFmjtOjm1WPsg
I9vryt5anHqhq+ZnTcpTR+/Yz6+Yr87t/mrbneWZV3qrPjt2prYnx7a/Orn1
1rzjY1DJaZFVHBe+sqrPqS18L6tednUUvjYIKmI+BhXToZXsxrXU3HQ8NnJi
4Mmu/FFqtHU9eXTopb+dSn6S3rmyqnSJvsOgsnP1eLPR9RfvrdRc7J+9k/4k
OXX2leETA+UvU9vf+J4+MTw2EU/84pO03BedPOnyzGZupi5MvX5qaKAn/7ta
26t7Zjj24/PzX7qwrq2N9L8mpyZGTvR1FTuEtq6+EyOx+PTclRty/Y8H/VVx
Oz8+Hx8vf79u7+ofGov/fD4teL6k87fmnagHlQJHha+26nPKCt/LqreyOgpf
CwQVMZ2DChA1HgeV2kmTrAKEjHBcrpmgIkZQAfThe1BplFVc3R4g9AgqTnjZ
PgQVQEyHoMK4CqAcQcUJj9uHrAIIEFSAUCKoOOF7UCGrABUeBxXBPAQVwDME
FTGPYx5BBRGnwxcr20GFrAK4gaAipkNQIasgOoISVHJkFcArBBUxTYIKWQUR
oVVQMd0GggqghA6FH1y+tA9xBagrEEGFrAJYRVBxQregQlZBlOkWVHKNswpx
BZBHUHHCr/YhqAC1CCpAKBFUnPC3fQgqQDWPg4rk/AQVwFUEFTENgwpZBZFF
UAEiiKAi5nv7EFSACj2DShFxBXCJ7x/EmtOhfQgqQJHOQSXH3cqAO3T4INaZ
Du3DoApQRFABIkiHD2KdadI+BBUgp+VdP9U4+wPYw10/TmjSPgyqADntg0qO
QRXAFoKKE5q0D0EFyAUhqOTIKoB1BBUn9GkfblUGCCpAKBFUnNCnfXhWLeBx
ULH3coIKoJY+H8R60qd9CCpAIIJKjqwCKKXPB7GetGofggoiLtBBhcQC2KPV
B7GGtGofggoijqACRJBWH8Qa0rN9iCuIpqAElRy/qgyoo+cHsT70bB+GVhBN
AQoqOZ7/Biii5wexPvRsHy6sRTQFK6jkGFcBVNDzg1gferYPQQXRFIjnqFQj
qAAyeI6KE9q2D0EFERS4oFJEVgHECCpOaN4+BBVESsiCClkFKCKoOKF5+zCo
gkgJ3DUqFWQVwDbNP4h9p3n7cAIIkRLcoJLjBBBgl+YfxL7Tv30IKoiOQAeV
HOMqgC36fxD7KxDtQ1ZBRAQ9qOQYVwGsC8QHsXLZax++2N3adDie2jKZMxDt
wwkgRESIgwpZBWgkEB/EimWWEoOd+XcdlqCSY1AF0RCCoJIjqwAWefdBvJYc
btleUdtAYkVq/sxq6sLbEyPP9HS25Lewrat/aDx+/uP0hlm2MHHnytSz7fvb
2gyCChAw4QgqObIKYIVXH8T3v0o8+2CzZFDJZtLJ8d6OurdRGweem7x8K2tz
MzbXF17vNR49+ZPXn2sJVVDJ8UwVREBogkqOX1gGpHlSkpvrl39ytN1okgoq
2ynlg1PdraUNMw70vfByLHZ6bHigq80o/WP78bitrJK98dF4d0f3ix9eu1UY
3rESVBxO1jfWMoIK9BeIgvKsbAkqgAwXSzK7cfPr5dTCLxNnnu+pZAzToFK5
gKTZaB94bXbldjmQZDM3Pj038rhRHFc59OqltU2L2/PVzPOPGt2nL97YLJ2H
CntQIatAN4EoKC/LlqwCmHKnJDPpxIkGPYw4qGytzb7UUZyzY2Tmambv3zc+
Odu7v7Cc/U9MfmblapWN5cRQu3Ekdmk1n3wiE1TIKtBKIArKy7LNccMyYEav
oJL9cnrwoeJsT00t1Tu5k70z98pDxUUdPLNwL5u7vzL3TkIouXgzs5H66dH2
zqOTixvFxVgPKrbbwjMEFYSex0HFs7DEuAoizo9vKFvrqQ93p4U3hrtazIPK
6szQvsL2GIOJdM1wStHdS7GHiyeSjpxdvFO+mUgw9b356w9jh/a3H5u6cr+c
fcIYVHJkFYRdWINKjnEVRJsOQ6m53EpioM0sqGRvz77YWtyeI5N1x1MKVmdH
Hy0san//1Bcyl9RupeKHBe9dGFf0aD0LyCrqrM/HuvL7dyCRbjxTZj7Wlj8G
TjSM1rBCh4rzaxsYVwkvOhMTOhS+XFC5uzT5dHFjWkdnbzdc1M5s+8fm7kqs
O3tz8f09p4P+YaxvX3PTgaGz5xKJ9xdvNo47erSeBWEIKvd+M3FwX1NbbN68
WLP3Fs4cbG5uPO/WRnr+nTPfPdHXVegB2rsGhmOTv0jdvC+xHfQtPtCh4nys
a7KKYuadSamLON7Tmb9To617YGRiavbKep0Phd1zGp09AyfH3qIz8YJOQaW8
K5tbDsd/23iQY3N15jsPFjdbuNNFVF9Ma28rXBLwrJK5OjOSv6BaJqgU7uRq
ahhU7qaTP+jdueNsZzK6Rt9b2TBbOn2LD3SoOH/rmqCijmln0qiLaO0+9UE6
Ux1WMtdmY/U7E6lHe9GZOKJTULmeHO40myevvDelkkZ9kQwq2seVbGZ9ZWE6
1l985I5JUNme91+mY0+3F9q/7rzZ9LvP5hfV2j3ys0vLa/kZMmvLl342UnhK
j3Eknrov7l3oW3ygQ8URVIJPpjPJblz+Ua+xvaMf7o+9u7CS7yKyG9dSF84W
nvrV/tRkqjJWkl1NjnRs/+MjAxMfLF7fyHccmfX04gcTA4/kO5NDP1y4Q2fi
Ip2Cisw8eTtBRersQD0hvZi2QpxV9IsrdxYnn+/rat/1YdRo524uTh5/smv3
V5t6826k4n35PqT3R5c3qvuQbGb57aP5a7YLF2OL0Ldoh6ACM9KdSXY5cayj
qXnfo+MX13aljM3V5Pfy4zCPnV0sPawrk04MGtudSf9Pr+waZsll1y6cemi7
L+oam7sp3Co6E0ciGlSkBTSo5AI2rlI56ycRVAq7f8/M9eYtHk6tRyZ/t/er
TvaLqf79Tc0dJ6a/ktoqa32L4N58jw7aEItyUCG3yJHtTEo3WbS8MLNa8+zQ
9VQykUi886uV0qBraZmN+xnTJ67TmTiiU1Dx8NSPNB0Gom0LTlCpVq5NqRos
HVd15i3lma7Y/PreF5WCysNDM38QLtxe37J5PXl6oNa38lfg5Zf2yMSCxWcq
R4oOFUdQCQtBZ1IacRXeuFFxb3nq20a988XZ1ZmTLe4Nz9KZlOgUVDy8mFaa
Dt2mE9ENKg2VT/0Y355aviecU+FobeE3u7dnM77x4oWv7f6kZiToUHGa1DVB
xTFBZ1L8XtxxYvrLzM1U8q1XhvrzNwYanb3HR374zvyXG7urtPA7ca1Nza1d
J38ym7qW/2tmbWXh3Vj/w/lfe6l+SFd9dCaO6BRULN+eLBeGHdGh23QiaBer
5FwNKtmN1aXSxbSt3eMf3TAp8npjyA0nQd9S/M3u7Xn2956Zr3fbI3boUHGa
1DVBxbHGnUn2d5NHtvuB//LyuX/c+Q3cnamjdzy5+66fbCZ9MT50yNg7Z1vv
2P+5sm46rkFn4ohOQcWtB745oUmXZZtpUNEvq7gRVPac6q2997AuJX3Ldv/2
3siBffmvXYOJZfOVQoSgQlCxonFnUjo1vK+trbWp/enY9L+srGfyT0q5npp9
6ztdxSRw9pOqRxjcTV/44dEDLbW1bxz47/FLfzDrq+hMHNEpqNh6hL7LNOmy
bJMJKpplFTeCSvlUb+mxb/lvTD0j/2vR5HtQuW/piy+kG/r9zOh+Qd9y/7Op
Y4UbGLvHL1yLxnVvbiKoEFesMA0q29Ph8bnV3R/5hV+w3f5Ty3eTa8VrEDLX
kqcOFEdaTr19aWm1cOpnPb2YfLM4xmL0n71ccy3cLnQmjugVVGz8KKHLNOmy
bCOo7JHduLqYPDOQf06C0TGSXBUdQY5PK2dXL8WO5Puxfd/6u09NHwkFc5EK
KjmyilONO5PNhYlH8l94jaemlmsr887FsfxNx4+Nzd3K/2fx8bbN+w6c+uXe
88X3U5NP5W+FfnBw+iqdiWv0Ciq5rbXZlzqKm9QxMnO19tkYn5zt3V887/PE
5Gcu3/GTJzlY5/6GOEVQqbK5OvNCi3jgLs9h33I3PfO9wrewzsHEUrS+/zig
Q8XpWddkFesEnYm469h103H51+L64qnax1mXb+7YGX6pi87EEc2CyvauWkoM
Fm9SNtoHXptduV2OjtnMjU/PjTxevJbJOPTqpTUv7svSodtUJUpBZfPm/D/E
tk3O138MUzoxkN9x9W5e3uGkb8lupH56tPhcXPOrdrFDh4rTs64JKtYJOpNb
c2OPNQwqpScYdA4nr+fMbsaRu1WHzsQR7YJK/nqhD3YuwzYO9L3w8vYHzunR
492Vh5G2H4+b/7aCGjp0mwpFJqgURnabq58tuUt2afJIfscdm1oR/KCY/b4l
u/ar2KH8Mfxg///81PyOAOzQoeK0rWuyikWCzqQ8ElL3YVzFR5eXL4Msdxc9
Ewu132vK94CYPNKEzsQR/YJKLn/p9fL7470ddTso48Bzby380bOxL227LHui
E1TKXU3tlXL5s71z44fzqzC5zMlu35JZnj5ZuDGtfSixbPrTh7Ag4kGliKAi
TdSZlH++p2tkZmX3H+98Pnnswer+oXSNSr2r2kq/i2p0jF5YE20JnYkjWgaV
gsxq6sLbEyPP9HQW7ghr6+ofGo+f/zi94cGVKTs077Ls0TuuqLpGZW1h4on8
icL2YxMzC4V7DwsX6qf+79SpbxZ6g64/T6aF43L2+pb11OSJwuOYesYvXo/k
MK2LCCo5fgzIAnFnUg4kxuMjU/+8nO8ispn1/zc3Wbw9ubp/uJ+efr7w+6cP
94+fK/3CafXvou47Nvm5G0+mpTMp0bwkfRfK9tH7YhV1F9Nu/O7d8kVNeyfj
0MmpT80el2Srb7k2faL4dOu2rr46D7/edjp5PaLjt855HFS0PeFLVpFj1plk
fp8cf7Ktzs595Gj8k139Q/bW5cnnDhj1joS2J8eTv5d9jgqdSQP6F53OQtk+
et8BpPSun+z68tw7Z08911/8NVWjs2fg5Fj85/Npkx9lL7DVt5Qu0xVM/DSq
fQSVIi5WkSPRmWTvpOffOTMyUPhBdmM7EZwY+eE7C7V3nG67f/PKxcTZl4oP
229qbu/qH6IzUUX/otNZKFsvgA9XQVToUHE6bIMpsgrCJBBFp62wtp5kViGu
wGM6VFxQ6pqsgogISkn6RYdu01UEFWhFh4oLSl0TVBARQSlJv0ShfQgqCAqC
yh48XR9REKCS9EUU2oeggqAgqNRFVkG4Ba4kPRaF9iGoICgIKo0QVBBiQSxJ
L0WhfQgqCAqCSiMEFYRYEEvSS1FoH66nRVAQVBohqCDEgliSXopC+0T5PuUo
7N8wIag0wlW1fgni0RI4NLKYDjdLeiCyWSU0ezA0dKi4IB4V4qBCVnFPEI+W
wKGRxXToNj1GUIGPdKi44B4VBBXvBfdoCRAaWUyHbtN7BBX4RYeKC/RRQVbx
WKCPlqCgkcWi3D4EFeiGoCKDoOKloB8tgUAji0W8fQgq0ApBRR5ZxRvhOFo0
RyOLRbx9Qj+oEvH9GzgEFXkEFW+E42jRHI0sFvH2Cf2VKhHfv4FDULGEoOKB
0BwtOqORxSLePgQVaIWgYgkX1nogNEeLzmhksYi3T+hvVY74/g0cgoolBBUP
hOZo0RmNLEb7hDursH+DhaBiCUHFA6E5WnRGI4vRPgQV6IOgYhVBxW1hOlq0
RSOLVdpHPPm9me6SfMB+ENNLRPZggOhQceE7Kggq7gnf0aIhGllMh27TdwQV
eEaHigvlUUFQcUkojxbd0MhiOnSb+iCowG06VFwojwqCiktCebTohkYWo32q
EVTgL4KKbVxY65JQHi26oZHFaJ89QnYaiP0bLAQV2wgqLgnl0aIbGlmM9qkV
pqzC/g0WgoptBBWXhPJo0Q2NLEb71EVQgS8IKrYJggpZxYlQHi26oZHFaB9T
BBV4hqBimziokFVsC+XRohsaWYz2MUVQgWcIKraZBhWyij2hPFp0QyOL0T6m
CCrwDEFFCbKKQqE/WnRAI4vRPpICmlXYv8FCUFGFrKJKFI4W39HIYrSPpIBe
Vcv+DRaPg4rDydWNdI6gokRQdre/IlJTfqF95AUxq7B/g4WgohZZxbkA7W4f
RaemfEHrWUVQgRM6VFykOlWCikPB2t1+iVRNeY/WsyFAj1hhD+pGh4qL2lFB
VnEiakeLL2hkMR26zcAhqMA2HSouakcFQcWJqB0tvqCRxXToNgMnQM/YZw/q
RoeK02EbPEZWsS2Ux4P3Ilh0CtE+NlgKKv7GFfZvsBBUXEJQsS2Ux4P3Ilh0
CtE+NhBU4BKCiktknltLdKkrlMeD9yJYdArRPjYQVOASj4OKq2vRDUHFnmge
LR6jkcVoHxtsBBW/sgr7N1gIKq4iqNgQ2aPFSzSyGO1jgyCHEFTgBEHFVQQV
GyJ7tHiJRhajfexpFEI0HFRBgHCNiqsIKvBLZItOCdpHLZ1PA0F/BBVXEVTg
l8gWnRK0j1qaX7ICzRFUPEBQgfciXnQO0T5qEVTgBNeoeICgAt1EvCRN0T5q
EVTgBEHFGwQVaIWSFKN91CKowAmCijcYVIFWKEkx2kctggqc4BoVjxFU4A2K
zgnaRzn5rEJcwR4EFY8xqAJvUHRO0D5uI6hAHkHFY5wDgjcoOidoH7cxugJ5
XKPiMYIKdEBJitE+biOoQB5BxXtkFfiOkhRjPMptXLKCajpUHHVdjWfVwneU
pJgO3WakkFUiToeKo673MH20PrkFrqIkxXToNiOFoBJxOlScDtugG/msQlyB
DRSdE7SPxwgqECCo+IugApdQdE7QPh6zdMkK0SVqCCr+IqjAJRSdE7SPx2wE
FbJKdHCNir8IKvAFJSlG+3jPXlYhtEQBQcV3BBV4j5IUo318QVZBXQQV33FV
LbxHSYrRPr5zklXIMCFDUNEBWQUeoyTFaB/fEVRQQVDRBEEFXqIkxWgf36kN
KmSVQCOoaIKgAi9RkmK0j+9sBxX5GOPr+4MF3J6sD4IKFKLonKB9dODw2lpL
gzDQGUFFTwQVOETROUH76IasEmUEFT1xeS0couicoH10Q1CJMq5R0ZOloEJW
gVWUpBjtoxuCSpQRVPREUIGrKEkx2kc3BJUoI6hoi6wC91CSYrSPhggqkUVQ
0ZbVoEJWgTxKUoz20RlBJWoIKtqyEVTIKpBESYrRPpojqEQKQUVnBBW4hJIU
o32CgrgSBQQVnRFU4BJKUoz2CQqGVqKA56gEBUEFllB0TtA+QeFGUCG36Iag
EhQEFVhC0TlB+wSF8qDCMIuGCCoBUptJ6gYVogtyFJ0ztE9QqA0qnA/SE9eo
BBpjLLCHkhSjfYLFyfkdgor+CCqBRlCBPZSkGO0TOPZiBkElEAgqgUZQgT2U
pBjtEzj2AgZBJRAIKoFmKaiQXlBBSYrRPoHjXlAhq/iOoBJo8kGFkRZUoyTF
aJ8gshEtCCqBQFAJNMmgwikh7EFJitE+EUFQCQSCSqBJPlyFoII9IlOS95an
vm3U3pd9OJ7aEr0sMu0TdQSVQCCoBBpBBfZEpiRvzo11NbX3DZ+O7fKj2XRW
9DLJp9DwmJqgI6h4IxAFRdm6xGFQIbpElncluZYcbtleUdtAYkVq/sxq6sLb
EyPP9HS25Lewrat/aDx+/uP0hnAEpJHsl9ODD5mOn9QKRL8KJQgqHghEQVG2
7lEYVMgq0eFVSd7/KvHsg82SQSWbSSfHezvqdlDGgecmL98SjoLUc+83Ewf3
tQwn1yy+LhD9KpRgUMUDgSgoytZVTsZVCCrR5ElJbq5f/snRdqNJKqhsp5QP
TnW3ljbMOND3wsux2Omx4YGuNqP0j+3H41azSn48p+Vw/LdWh2MC0a9CFbKK
2wJRUDpsQ7jJj5kQVCLCt6LLbtz8ejm18MvEmed7KhnDNKhklhKDnYU5jfaB
12ZXbpcDSTZz49NzI48XL4g1Dr16aW1Tflu2UvHDze19Y2+cHT2aDzxGZ+9Q
bGpuecMs7tApRQ1BRWcEldCoGzkIKpHlR9Fl0okTDVYkDipba7MvdRTn7BiZ
uZrZ+/eNT8727i8sZ/8Tk59JD49k78y98lD+VR09w69PJc5NvTl2oru9qfmR
o/FP1uUuppVdFcKFoKIVgkq4cfYnsoIUVIqXvBZme2pqqV6CqESO5qaDZxbu
ZXP3V+beSQglF2/evTH/s9j430wt/LESfbLrn8SPPtJkPDGxILpuhS4LZBUv
6VBx1LVfCCqoy52S3FpPfbg7Lbwx3NViHlRWZ4b2FbbHGEyka4ZTiu5eij1c
PJF05OzinfLNRIKpL57aqLegYubZd3DiN/cavxMduk34ixNAXtKh4qhrvxBU
UJdXJbmSGGgzCyrZ27Mvtha358hk3fGUgtXZ0UeLZ3/6p76wfPtPlcKFK83i
W4F06DbhL65a8ZIOFUdd+4U7gFCXTkHl7tLk08WNaR2dvd1wUTuz7R+buyuz
8nup6b+OxX74/tL96lyzuZr8XkfDc0wldFnIkVW0QVAJPbIKaukUVNbnY12F
ecT3EW+uznznweJmDyTSMivPXk2OHGwyesYupKuuUZk/07u/qf3ZqSt3BC+l
y0IRQUUHBJXQcxJUyCphpVNQuZ4c7jS/jiWXy8zH2oqbLfuk2fKzWYyDA6Ov
TZ47NxX//omu7f889Py7n98XvlKHgWjogKDiDR0qjrr2EUEFtXQKKjLz5O0E
lbbYfINLbmvkH8Myffalof6utmajreupobH4zOIfTV+tQ7cJTRBUPKBDxVHX
PiKooFZkgopNOnSb0ARBxQM6VBx17SOCCmrpFFTcO/Vjnw7dJjRBUPGADhVH
XfuLoII9dAoqrl1M6wBdFioIKr4jqEQQQQU6BRXLtycLZ1ODLgsVBBXfEVQi
iKACnYKK1w98k0GXhQqCiu8IKhGk8OwP8SagdAoqth6h7zIdzphDEwQVD+hQ
cdS1VpRcqcJQTKDpFVRs/Cihy3ToNqEJgooHdKg46lorBBXoFVRyW2uzL3UU
N6ljZOZqzaDKxidne/cXz/s8MfmZy3f85OnQbUITBBUP6FBx1LVWlNz+ozao
EHI8pllQyeUyS4nB4k3KRvvAa7Mrt8uDJvkntp0bedwobK1x6NVLa5sub3Me
XRYqCCq+I6hEkJOg4mQQRn573Hnf2KFdUKk87r64YcaBvhdejsVip0ePd7cZ
pX9sPx6/fMv1sz4FdFmoMH2KPnHFbQSVaKqNBPbSi0tBhaziNv2CyratjeX3
x3s76g75Ggeee2vB/NH3qtBloUImqJBVXOVxUOGEr+YIKqGhR9FZCioFmdXU
hbcnRp7p6WzJv7Ctq39oPH7+4/SGB1em7KBTQoVkUCGruIeggmoeBxUlOQd1
UXRO0HqoIKh4QIeK02EbIMmzE0CqBmRQF0XnBK2HCoKKB3SoOOo6iPwNKpWX
E13cQEmK6dBtQhMEFQ/oUHHUdRC5Paji3hklmKIkxWgfVBBUfEdQQSOuBhU3
hmggj5IUo31QQVDxHUEFjbgXVNwYn4EllKQY7YMKgorvCCoQUBhUXB2fgVWU
pBjtgwpBJiGoeIOgAjFVAYOgohVKUoz2QbVGgYSg4g2CCkz5Hk4IKspRkmK0
D2RwJsgbBBWY8j2cEFSUoyTFdLhZEvojqKiiQ8VR14HmezghqChHSYrp0G1C
fwQVVXSoOOo66HzPJwQVtShJMR26TeiPoKKKDhVHXYeA7xGFuKIQJSlG+0AG
QcUbBBVI8j2ckFUUoiTFaB/IIKh4g6ACSb4nE4KKQpSkGO0DGU6CCqlGHkEF
NvieUggqDlGSYrQPZNgOKuKZCTB7EFRgQ93Y4F4gIagoR0mK0T6QYSOomM7P
KaRaBBXY4GpQkVyph283hChJMdoHMsRBRSaESM7j31vUAkEFqtgYIan7Ksnl
e/fGwoiSFKN9IEN5UOG63LoIKlDF3oAJQcUXlKSYDk91gP7kg4o4hxBUdKg4
6joKCCoBQkmK6dBtIigIKs7pUHHUdRQQVAKEkhTTodtEUFgaVyGo1KVDxVHX
UeDwWlmry1e45RFESYrRPrBEVVaJbFARI6hAFYJKgFCSYrQPbCCouISgAlVc
TSm1y1e12dFESYrRPrCBoOISggpUcSmfNFq+kmVGFiUpRvvABoKKSwgqUMXj
oEJccYKSFKN9YANBxSUEFahCUAkQSlKM9oENBBWXEFSgitspwtUUFDWUpBjt
A3sIKm4gqCAoXL1SN2ooSTHaB7YRVJQjqCAo3L79OVIoSTHaBw4RVBTyOKg4
nFzdSGiOoFKNmnIV7QOHCCoKEVQQFJaCSuijCzXlKtoHDhFUFCKoICjkg0oU
hlmoKVfRenCIK1Us0aHiqGs4JxlUonw+SB4lKaZDt4lAI6hYokPFUddwjqCi
ECUppkO3iUAjqFiiQ8VR13COoKIQJSlG+8AhgopCHgcVvp7ANoKKJRSdE7QP
HCKoKERQQbB4FlSCHnUoOidoHzjkb1AJWbwhqCBYvAkqIRiWoeicoH3gkBtB
RTJ1hG8ohmtUECxOgop88AhBUBGjJMVoHzjkUlAxTR2hPGdEUEGw2A4qlrIH
QSXiaB84RFBRiFM/CBx7WSVqQYWic4L2gUOeBRVVJ4x0RlBBELmdVQgqEUf7
wDn3goraQRj9EVQQUK5mFasjMBqi6JygfaCEe+MqBJWArgWR4lJQsXeqKHAo
STHaB2oRVJwgqCCglAcV2+eJgoiSFKN94B6CilUEFQRUgIKKhjmHkhSjfeAe
gopVXKOCgApKUPFrWIaic4L2gXsIKlYRVBBQBBUxis4J2gfuIahYRVBBQPkS
VOomDXEIIagEEe0D9xBUrCKoIKBMs4TCJCMIG5ZiDEElKGgfuIegYpXHQcXV
tSBSTMc6PAgqVsdbPM4qApSkGDEP7iGo1NKh4qhrKBfooOJ7VqEkxXToNhFW
BJVaOlQcdQ3lCCpOUJJiOnSbCCvTREFQ8TeoUPVQxXZCcB5FJP8qP48bKDon
aD24TcOg4mOw0aHidNgGhI+PQeUB4fW6MpvhduNQdE7QPnCbbkFF50EYggrC
yu2gIvNywRLcfvsUnRO0D9ymVVDR/GwRQQVhRVCh6GyjfeA2q0Gl0b8rySoE
Fc/WAlTzN6hUFuJXUBGjJMVoH7jNRlCRWQJBRfO1ANUCFFS8zzCUpBjtA7d5
HFTE2cPJ2SJ7b98SggrCSklQcbgowWvFy3e7cShJMdoHbgtuUPF++IWggrBS
GFSULLDRKiTXrhYlKUb7wAOhCSpuZxWCCkJMYUpxsjSCSuDQPvBAo896gsoe
3PWDcHOeT+wtSn6NLgUVis4J2gc+IqjsQVBB6BFUKDqraB/4iKCyB0EFoSef
EGwsh6ASSrQPfERQ2YOggtAjqFB0VtE+8BFBZQ+Pg4qrawHqimZQEaMkxWgf
+IigsgdBBaFHUKlFSYrRPvCRS0FFECe0DSqV5RNUEG5BDCqSccV2vKEkxWgf
+IugUrsiggpCLLhBRbxJToZiKEkx2ge+M40BUQsq4TjBBNSlc1CRSTJW35cM
SlKM9oH+bASVRh/6BJUcVQ9fiT/N5T/ffQkqpltOUHED7QP9OQwq1Z/7BJUc
VQ+/2fgoN12O71mFoOIe2gf6I6ioxSMdEBpBCSoUnRO0D/RHUFGLPhMhI0gR
BJUQoH2gP1eDiiAeEFSAQBCEBH+DSmWi6JygfaA/z4LKqtmVt6oihKXNUI6q
R8joH1QeEF6vQkmK0T7Qn/OgYiPSCNYrmEHV21HcgrtR9QgZJ/nBeVCxkWr2
oCTFaB/oT7egUpmNoALowMegYm/4ZQ9KUoz2gf70DCq2AwZBBVAruEGl+q+U
ZCN0WdCfl0FFYc5x8nZcbU+qHiET0KCy56+UZCN0WdCf7/GDoAJoTj4PNMoP
vgeVukMuyNFlIQh8jx8EFSDQZMIDQUVbdFkIHN/TCEEFCBaZSFB3HoKKDiSf
QsNjaqAP39OIYKpURO2/1P6JoAJ4g6Cij+z657+Iv3i8p9Nobu8a+PMz7/zm
WiYrfglBBYHjexoxDSqN0gtBBfCF7aBS998JKnZlM+kPTnW3Nhndg3/z1rlz
b02c7G1rbu1+8cNrwqhCUEHg+J5GrAaVPVmFoAJ4TJ+gYinJqLeWHG7Zrv22
gcSK1PyZ1dSFtydGnunpbMl3Gm1d/UPj8fMfpze27Kw9uzL9bGeT0Xdm4WYp
mGRXL8WOGM09EwvrgtfRZSFwfE8jpgFDHDz0CSp8+0BEaBJUrA65qHb/q8Sz
DzZLBpVsJp0c7+2o2zkYB56bvHzL5IRNzQLvp+JHDKNjJLmarfrHpffPxP7q
R7NfCZZGp4TA8T2NEFSAYCGo5HKb65d/crTdaJIKKuVzNMXewDjQ98LLsdjp
seGBrjaj9I/tx+PWssq95alvG81dY3M3rW46XRYCx/c04iSoaHXqh6pHREQ3
qGQ3bn69nFr4ZeLM8z2VjGEaVDJLicHOwpxG+8Brsyu3y4Ekm7nx6bmRx43i
uMqhVy+tbUpvyvXkcGfTvqF3P/+3X8RPDXS1N6m+mFZ6SwDX+Z5GQhNUXF0L
oA83gor4rxoElUw6caLBZ7o4qGytzb7UUZyzY2Tmambv3zc+Odu7v7Cc/U9M
fiZ7tUp2aeqptqZ9h/q++Uhbz/MTk/+YKF1Ma7Qf/WlqQ5RVCCrhEKk95Xsa
sRFUKn8iqEAV9qM8goqFoJL9cnrwoeJsT00t1QsQ2TtzrzxUXNTBMwv3srn7
K3PvJISSi6ufxg+35Idojv196k453WRvLpzpMxquqISgEg6R2lO+pxF7QaX4
V4IKVGE/ynMSVOr+KQhBZWs99eHutPDGcFeLeVBZnRnaV7w0ZTCRrhlOKbp7
KfZw8UTSkbOLd8o3Ewmmvvi/LeZHVJofGpz+sjqTZK9OD+5rfnBw+mrjpMKh
Hg6R2o91P9Z9jygyQUV+U11twEgdLSHGfpQXyaBSayUx0GYWVLK3Z19sLR5a
RyYbD3Oszo4+Wjz70z/1hdwltTfnxrryiSW1seufiyHncDzV+BwSh3o4RGo/
+hVUZNbSaAsJKlCO/agWQaXg7tLk08XjqnV09nbDRe3Mtn9s7q7U2jNXp4ce
rB1RWZ56yjAeGrt4p/ErOfUTDpHaU4EOKpz6gSrsR7XsBZVGfw1sUFmfj3UV
5mk5HP9t40GOzdWZ7zxYPAIHEmm51WevvXey3TB6X19YL98rlL1+cbzHaD44
khSc+SGohESk9hRBxaFIHS0hxn5Uy3ZQEc8WtKBSuInY/M6gXGY+1lY8AoVn
bXa7m06+3G00GweOvvzmzxJTb7w8cNBobu0e/+iGikfoS24E/BKpPUVQcShS
R0uIsR/VIqhIz5O3E1TaYvMNLrmt5/7NVDI+ejT/4Li2rr4T3z1z/rfrZte4
cKiHQ6T2Y6CDiuSmutqAkTpaQoz9qBZBRXqePLtBxQ5NDnXlm2F7gZZeKDOz
eB7BX+v+qdEwlyb7UfmW1F2aX0FFZjCk0RbaCEXuCevRYnuBVl9lOr+TGeQL
n/3o5IW1TVo3NhRnaBQqTJcQwKDi6qkfmzQ51IN4nEvOTFBRvjSdg4qqjVHS
epZa1ReaFD5BxSFN9qOlFxJUGszj4sW0tlXvLMHk8lYE8jiXnJmgonxpoQ8q
bu/HsB4tthdIUHFIk/1o6YWmQaV6tigFFcu3JwtnU4Og4uSFBJVaBBUlK1LS
epZa1ReaFD5BxSFN9qOlF0p+wEUvqLj3wDf7CCpOXkhQqUVQIaj4uCUEFV9o
sh8tvdDfoNJoZqvv1yK5C2VtPELfZZoc6kE8ziVnJqi4sbTaoFL7jwQVq63q
PU0Kn6DikCb70dIL3QgqObNfMKyeX9+gYuNHCV2myaEexONccmaCihtLqxtU
av+doGKpVb2nSeETVBzSZD9aeiFBpfFsW2uzL3UUN7VjZOZqzaDKxidne/cX
lrP/icnPXL7jJ696ZzExhWByL2k4fLmGQYWJiUlmqhsqLM0vuUxXC1/+GSm5
zFJisHiTstE+8Nrsyu3yoEk2c+PTcyOPG4W3YBx69dLapmg5ivh+ADAxqZ3E
AUBmNoIKExNT9RS5oLIdSNIfnOpuLW2tcaDvhZdjsdjp0ePdbUbpH9uPxy/f
cv2sT5nvxwATE1P1RNUzMYV+8jyl5KwElW1bG8vvj/d21N1448Bzby380eXn
0QIAAJ95mFJyFoNKQWY1deHtiZFnejpb8i9s6+ofGo+f/zi94cGVKQAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAIEj+P8Ge
lDI=
     "], {{0, 381}, {739, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{401.3999999999986, Automatic},
   ImageSizeRaw->{739, 381},
   PlotRange->{{0, 739}, {0, 381}},
   ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], 
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJztnW9s3OadoHvSfbgP/GJ/FGDAdzoB+hIEgeAPhoODdICNBAJkpIFgpA0E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     "], {{0, 373}, {754, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{396.4000000000017, Automatic},
   ImageSizeRaw->{754, 373},
   PlotRange->{{0, 754}, {0, 373}},
   ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]], 
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzsvQlYVde993//97a3b/s8t/cmb9+0SZqmSRtjHOKQxHkewQEUBRxQUZBJ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     "], {{0, 434}, {507, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{253.20000000000098`, Automatic},
   ImageSizeRaw->{507, 434},
   PlotRange->{{0, 507}, {0, 434}}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RMS", " ", "amplitude", " ", "1"}], "-", 
  RowBox[{"2", "%"}]}]}], "Text",
 CellChangeTimes->{
  3.576857890981017*^9, {3.576857977081841*^9, 3.5768579920065713`*^9}, {
   3.5768580862375193`*^9, 3.5768580877250423`*^9}}],

Cell[CellGroupData[{

Cell["VLA data", "Section",
 CellChangeTimes->{{3.5765334335297327`*^9, 3.576533434846808*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dat11", "=", 
   RowBox[{
   "Import", "[", 
    "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\VLA_10May2008X.dat\>\"", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"datt", "=", 
   RowBox[{"dat11", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", 
      RowBox[{"1", ";;", "2"}]}], "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5765334363948965`*^9, 3.576533492866126*^9}, 
   3.576535642573083*^9, {3.5765357150582285`*^9, 3.576535732163207*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"ListPlot", "[", 
    RowBox[{"datt", ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}], ",", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"MovingAverage", "[", 
      RowBox[{"datt", ",", "30"}], "]"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.5765334946402283`*^9, 3.576533503141714*^9}, {
  3.576533539278781*^9, 3.5765336242566414`*^9}, {3.576533983887211*^9, 
  3.576533985367296*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fluxes", "=", 
   RowBox[{"datt", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
  RowBox[{"tim", "=", 
   RowBox[{"datt", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", 
    RowBox[{"ddt_", ",", "func_"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"lmax", "=", 
      RowBox[{"Quotient", "[", 
       RowBox[{"l", ",", "2"}], "]"}]}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ddt", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"LcurveF", "[", "fr", "]"}], "=", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"tim", ",", "fluxes"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Time, M\>\"", ",", "\"\<Flux, Jy\>\""}], "}"}]}]}], 
      "]"}]}], ",", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", 
       RowBox[{"0.0009", ",", "fluxes"}], "]"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0.002", ",", "0.07"}], "}"}]}]}], "]"}]}], "}"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.5765336373083878`*^9, 3.576533657707555*^9}, {
  3.576533760370427*^9, 3.576533804607957*^9}, {3.576534534664714*^9, 
  3.5765345360477934`*^9}, {3.576534577356156*^9, 3.576534579978306*^9}, {
  3.5765347304869146`*^9, 3.5765347442066994`*^9}, {3.5765348119085712`*^9, 
  3.576534849424717*^9}, {3.5765357442969007`*^9, 3.576535748980169*^9}}],

Cell[BoxData[{
 RowBox[{"inter", "=", 
  RowBox[{"Interpolation", "[", 
   RowBox[{"datt", ",", 
    RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmin", "=", 
   RowBox[{"tim", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"tmax", "=", 
   RowBox[{"tim", "[", 
    RowBox[{"[", 
     RowBox[{"-", "1"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"timer", "=", 
   RowBox[{"Range", "[", 
    RowBox[{"tmin", ",", "tmax", ",", "0.0009"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"newdata", "=", 
   RowBox[{"inter", "[", "timer", "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.576534031370927*^9, 3.5765340601505733`*^9}, {
  3.5765341527808714`*^9, 3.5765341875898623`*^9}, {3.576534312971034*^9, 
  3.576534378165763*^9}, {3.5765344293746915`*^9, 3.5765344295837035`*^9}, {
  3.576534460156452*^9, 3.5765344844148397`*^9}, {3.5765347215214014`*^9, 
  3.576534721957426*^9}}],

Cell[BoxData[{
 RowBox[{"Length", "[", "newdata", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "[", "datt", "]"}]}], "Input",
 CellChangeTimes->{{3.576534359200678*^9, 3.5765343741495333`*^9}}],

Cell[BoxData[
 RowBox[{"GraphicsRow", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"timer", ",", "newdata"}], "}"}], "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<Time, M\>\"", ",", "\"\<Flux, Jy\>\""}], "}"}]}]}], 
     "]"}], ",", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", 
       RowBox[{
        RowBox[{"60", " ", "0.0009"}], ",", "newdata"}], "]"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0.002", ",", "0.07"}], "}"}]}]}], "]"}]}], "}"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5765343961937943`*^9, 3.5765344147028522`*^9}, {
  3.5765344470657034`*^9, 3.5765344494708414`*^9}, {3.5765346145412827`*^9, 
  3.576534620649632*^9}, {3.576534864127558*^9, 3.5765348645305815`*^9}, {
  3.5765351606905203`*^9, 3.576535160956536*^9}, {3.5765357627649574`*^9, 
  3.5765357633759923`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[CapitalDelta]t", "=", "0.2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"inter", "[", 
       RowBox[{"t", "+", "\[CapitalDelta]t"}], "]"}], "-", 
      RowBox[{"inter", "[", "t", "]"}]}], ")"}], "2"], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "tmin", ",", 
     RowBox[{"tmax", "-", "\[CapitalDelta]t"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.576534155213011*^9, 3.576534294619984*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.5765341501217194`*^9, 3.576534151589803*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Jon simulation thickdisk7 - to paper", "Section",
 CellChangeTimes->{{3.568505535877073*^9, 3.56850554138708*^9}}],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Units for paper",
 FontColor->RGBColor[0, 0, 1]]], "Subsection",
 CellChangeTimes->{{3.575630838175617*^9, 3.5756308546783705`*^9}}],

Cell[BoxData[{
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Minutes per M: \>\"", ",", " ", 
   RowBox[{"tM", "/.", "ruru"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Periods in M: \>\"", ",", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "6", ",", "7", ",", "9", ",", "17", ",", "23", ",", "28", ",", "45", 
       ",", 
       RowBox[{"2.75", "*", "60"}]}], "}"}], 
     RowBox[{"(*", "min", "*)"}], "/", "tM"}], "/.", "ruru"}], ",", 
   "\"\< \>\"", ",", 
   RowBox[{
    RowBox[{
     RowBox[{"{", "35", "}"}], "/", "tM"}], "/.", "ruru"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"170", "tM"}], "/.", "ruru"}]}], "Input",
 CellChangeTimes->{{3.5756308874158735`*^9, 3.5756308999920664`*^9}, {
  3.57563105969602*^9, 3.5756310599035234`*^9}, {3.575631292484597*^9, 
  3.575631317799486*^9}, {3.5756314688138056`*^9, 3.575631471237343*^9}, {
  3.5756404508135605`*^9, 3.575640452711089*^9}, {3.575647790266498*^9, 
  3.5756478163313985`*^9}, {3.5758910541581564`*^9, 3.5758910790930395`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["180", "\[Pi]"], 
  RowBox[{"ArcCos", "[", "0.9", "]"}]}]], "Input",
 CellChangeTimes->{{3.5756457764440575`*^9, 3.5756457854651966`*^9}, {
  3.5756458218077545`*^9, 3.575645826260323*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "0.94", " ", "1.5517", " ", "2.4840", " ", "0.16992", " ", "147780.66084", 
   " ", "1.003", " ", "e"}], " ", "-", " ", "08"}], "\n", 
 RowBox[{"Temperature", " ", "-", " ", 
  RowBox[{
   FormBox[
    RowBox[{"3.2", "*", 
     SuperscriptBox["10", "10"]}],
    TraditionalForm], "K", " ", "at", " ", "6", "M"}]}]}], "Text",
 CellChangeTimes->{{3.575646358569502*^9, 3.5756463638445826`*^9}, {
  3.575647965808696*^9, 3.575647993225117*^9}}],

Cell[BoxData[{
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Best angle = \>\"", ",", 
   RowBox[{
    FractionBox["180", "\[Pi]"], 
    RowBox[{"(", 
     RowBox[{"\[Pi]", "-", "2.4840"}], ")"}]}], ",", "\"\<deg\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Log", "[", 
  RowBox[{"10", ",", 
   SuperscriptBox["10", "3"]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Log", "[", 
  RowBox[{"10", ",", "1.2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.575646366464623*^9, 3.575646374862252*^9}, {
  3.575647961721133*^9, 3.5756479647861805`*^9}, {3.5756479961776624`*^9, 
  3.575648005176301*^9}, {3.575648042016367*^9, 3.5756480516265144`*^9}}],

Cell[BoxData[
 RowBox[{"35", 
  FractionBox[
   RowBox[{
    RowBox[{"1", "+", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["a", "2"]}]]}], "/.", 
    RowBox[{"a", "\[Rule]", "1"}]}], 
   RowBox[{
    RowBox[{"1", "+", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["a", "2"]}]]}], "/.", 
    RowBox[{"a", "\[Rule]", "0.9375"}]}]]}]], "Input",
 CellChangeTimes->{{3.57564947544189*^9, 3.5756495110244365`*^9}, {
  3.575649589109636*^9, 3.5756495892296376`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Periodograms for Olek\[CloseCurlyQuote]s simulations - spin 0, 0.7, 0.9\
\>", "Subsection",
 CellChangeTimes->{{3.571681430533337*^9, 3.5716814584212656`*^9}, {
   3.571706641843214*^9, 3.5717066523858757`*^9}, {3.571743678382437*^9, 
   3.571743691960146*^9}, 3.5720001394078665`*^9, {3.572000397589332*^9, 
   3.572000399614363*^9}, {3.572001857682763*^9, 3.5720018579477673`*^9}}],

Cell[BoxData[{
 RowBox[{"Dynamic", "[", "fnum", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ntodx", "=", "10."}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"angles", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<Oleka0\>\"", ",", "\"\<th214lo\>\"", ",", 
       "\"\<poliresa0th214fn\>\"", ",", "12424", ",", "22424"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Oleka07\>\"", ",", "\"\<th260lo\>\"", ",", 
       "\"\<poliresa70th260fn\>\"", ",", "4204", ",", "9204"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Oleka09\>\"", ",", "\"\<th252lo\>\"", ",", 
       "\"\<poliresa90th252fn\>\"", ",", "2376", ",", "4876"}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"dix", "[", "1", "]"}], "=", 
    RowBox[{"\"\<E:\\\\GRMHD\\\\Oleka0\\\\spectra\\\\\>\"", "<>", 
     RowBox[{"angles", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1"}], "]"}], "]"}], "<>", "\"\<\\\\\>\""}]}], ",", 
   RowBox[{"{", 
    RowBox[{"o", ",", 
     RowBox[{"Length", "[", "angles", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dix", "[", "2", "]"}], "=", 
   RowBox[{"\"\<E:\\\\GRMHD\\\\Oleka07\\\\spectra\\\\\>\"", "<>", 
    RowBox[{"angles", "[", 
     RowBox[{"[", 
      RowBox[{"2", ",", "1"}], "]"}], "]"}], "<>", "\"\<\\\\\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dix", "[", "3", "]"}], "=", 
   RowBox[{"\"\<E:\\\\GRMHD\\\\Oleka09\\\\spectra\\\\\>\"", "<>", 
    RowBox[{"angles", "[", 
     RowBox[{"[", 
      RowBox[{"3", ",", "1"}], "]"}], "]"}], "<>", "\"\<\\\\\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"dix", "[", "o", "]"}], "=", 
     RowBox[{"\"\<E:\\\\GRMHD\\\\\>\"", "<>", 
      RowBox[{"angles", "[", 
       RowBox[{"[", 
        RowBox[{"o", ",", "1"}], "]"}], "]"}], "<>", 
      "\"\<\\\\spectra\\\\\>\"", "<>", 
      RowBox[{"angles", "[", 
       RowBox[{"[", 
        RowBox[{"o", ",", "2"}], "]"}], "]"}], "<>", "\"\<\\\\\>\""}]}], ";", 
    RowBox[{"fil", "=", 
     RowBox[{
      RowBox[{"dix", "[", "o", "]"}], "<>", "\"\<totspec.dat\>\""}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"FileExistsQ", "[", "fil", "]"}], ",", 
      RowBox[{
       RowBox[{"impx", "[", "o", "]"}], "=", 
       RowBox[{"Get", "[", "fil", "]"}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"impx", "[", "o", "]"}], "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Import", "[", 
           RowBox[{
            RowBox[{"dix", "[", "o", "]"}], "<>", 
            RowBox[{"angles", "[", 
             RowBox[{"[", 
              RowBox[{"o", ",", "3"}], "]"}], "]"}], "<>", 
            RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}],
            "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"fnum", ",", 
            RowBox[{"angles", "[", 
             RowBox[{"[", 
              RowBox[{"o", ",", "4"}], "]"}], "]"}], ",", 
            RowBox[{"angles", "[", 
             RowBox[{"[", 
              RowBox[{"o", ",", "5"}], "]"}], "]"}]}], "}"}]}], "]"}]}], ";", 
       RowBox[{"Put", "[", 
        RowBox[{
         RowBox[{"impx", "[", "o", "]"}], ",", "fil"}], "]"}]}]}], "]"}], ";",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"lop", "[", "o", "]"}], "=", 
     RowBox[{"Length", "[", 
      RowBox[{"impx", "[", "o", "]"}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"o", ",", 
     RowBox[{"Length", "[", "angles", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";", 
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"Ntodx", " ", 
    RowBox[{
     RowBox[{"impx", "[", "1", "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"freqs", "=", 
   RowBox[{
    RowBox[{"impx", "[", "1", "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "All", ",", "2"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", 
  RowBox[{"impx", "[", "1", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", 
  RowBox[{"impx", "[", "2", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", 
  RowBox[{"impx", "[", "3", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.569690907836939*^9, 3.569690966090334*^9}, {
   3.569774735695792*^9, 3.5697747442758074`*^9}, {3.5699453708725615`*^9, 
   3.569945376472972*^9}, {3.5716818143727336`*^9, 3.5716818231503687`*^9}, {
   3.571681869406079*^9, 3.571681931254529*^9}, {3.5716820112457576`*^9, 
   3.571682068499137*^9}, {3.571704713746092*^9, 3.571704717186145*^9}, {
   3.5717059650103164`*^9, 3.5717060068209586`*^9}, 3.571706655735927*^9, 
   3.5717440259253645`*^9, {3.571744062178421*^9, 3.571744254966382*^9}, {
   3.5720004311298475`*^9, 3.572000567256938*^9}, {3.57200066302691*^9, 
   3.5720007510957627`*^9}, {3.572000786993814*^9, 3.572000807946636*^9}, {
   3.5720012533529787`*^9, 3.5720012543854947`*^9}, {3.57200184966514*^9, 
   3.5720018926133003`*^9}, {3.57200205018322*^9, 3.5720022612164617`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"3", ",", "fr", ",", "th"}], "]"}], "=", 
      RowBox[{"Mean", "[", 
       RowBox[{
        RowBox[{"impx", "[", "th", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"4", ",", "fr", ",", "th"}], "]"}], "=", 
      RowBox[{"means", "[", 
       RowBox[{"3", ",", "fr", ",", "th"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"5", ",", "fr", ",", "th"}], "]"}], "=", 
      RowBox[{"means", "[", 
       RowBox[{"3", ",", "fr", ",", "th"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"6", ",", "fr", ",", "th"}], "]"}], "=", "90"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"th", ",", "1", ",", 
      RowBox[{"Length", "[", "angles", "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"fr", ",", "1", ",", 
      RowBox[{"Length", "[", 
       RowBox[{
        RowBox[{"impx", "[", "1", "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tmax", "=", 
    SuperscriptBox["10", "4."]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Papadakis", " ", "&"}], " ", "Lawrence", " ", 
    RowBox[{"(", "1993", ")"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"autovar", "[", 
    RowBox[{"typ_", ",", "mu_", ",", "fr_", ",", "th_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"mult", "=", "mu"}], ";", 
      RowBox[{"binned", "=", 
       FractionBox[
        RowBox[{
         RowBox[{"impx", "[", "th", "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "typ"}], "]"}], "]"}], 
        RowBox[{"means", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]]}], ";", 
      RowBox[{"ll", "=", 
       RowBox[{"Length", "[", "binned", "]"}]}], ";", 
      RowBox[{"me", "=", 
       RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"autovariance", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{"1", ";;", 
                RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], 
            ")"}], ".", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
             "me"}], ")"}]}], "ll"], ",", 
         RowBox[{"{", 
          RowBox[{"shi", ",", "0", ",", 
           RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"f11", "=", 
       RowBox[{"FourierDCT", "[", 
        RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
      RowBox[{"num", "=", 
       RowBox[{"Floor", "[", 
        FractionBox["ll", "2"], "]"}]}], ";", 
      RowBox[{"sur", "=", 
       RowBox[{
        FractionBox[
         SqrtBox["2"], 
         RowBox[{"2", "\[Pi]"}]], 
        SqrtBox["ll"], 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"f11", ",", "2"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"sur", ",", 
        RowBox[{"sur", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"timex", "=", 
       RowBox[{"Ntodx", " ", 
        RowBox[{"ll", "/", 
         RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
      RowBox[{"mint", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
      RowBox[{"maxt", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", 
      RowBox[{"nn", "=", 
       RowBox[{
        RowBox[{"Log", "[", 
         FractionBox["maxt", "mint"], "]"}], "/", 
        RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"tsides", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"mint", " ", 
          SuperscriptBox["mult", "i"]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tbins", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tsides", "[", 
            RowBox[{"[", "i", "]"}], "]"}], ",", 
           RowBox[{"tsides", "[", 
            RowBox[{"[", 
             RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tsizes", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tmeans", "=", 
       RowBox[{"Mean", "[", 
        RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"intergra", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"timex", ",", 
             RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"pergra", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"Exp", "[", 
              RowBox[{"intergra", "[", 
               RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"tx", ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
             RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
             RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        RowBox[{"res", "=", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"tmeans", ",", 
              FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
          "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"pergra", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{"NIntegrate", "[", 
           RowBox[{
            RowBox[{"intergra", "[", 
             RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"tx", ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
            RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
            RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
          RowBox[{"tsizes", "[", 
           RowBox[{"[", "i", "]"}], "]"}]], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"res", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"tmeans", ",", 
            RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}]}]}],
      ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"autorand", "[", 
     RowBox[{"ty_", ",", "mu_", ",", "kf_", ",", "rlist_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"typ", "=", "ty"}], ";", 
       RowBox[{"mult", "=", "mu"}], ";", 
       RowBox[{"k", "=", "kf"}], ";", 
       RowBox[{"binned", "=", "rlist"}], ";", 
       RowBox[{"ll", "=", 
        RowBox[{"Length", "[", "binned", "]"}]}], ";", 
       RowBox[{"merr", "=", 
        RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"autovariance", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{"1", ";;", 
                 RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "merr"}], 
             ")"}], ".", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
              "merr"}], ")"}]}], "ll"], ",", 
          RowBox[{"{", 
           RowBox[{"shi", ",", "0", ",", 
            RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"f11", "=", 
        RowBox[{"FourierDCT", "[", 
         RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
       RowBox[{"num", "=", 
        RowBox[{"Floor", "[", 
         FractionBox["ll", "2"], "]"}]}], ";", 
       RowBox[{"sur", "=", 
        RowBox[{
         FractionBox[
          SqrtBox["2"], 
          RowBox[{"2", "\[Pi]"}]], 
         SqrtBox["ll"], 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{"f11", ",", "2"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sur", ",", 
         RowBox[{"sur", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"timex", "=", 
        RowBox[{"Ntodx", " ", 
         RowBox[{"ll", "/", 
          RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
       RowBox[{"mint", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
       RowBox[{"maxt", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", 
       RowBox[{"nn", "=", 
        RowBox[{
         RowBox[{"Log", "[", 
          FractionBox["maxt", "mint"], "]"}], "/", 
         RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"tsides", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"mint", " ", 
           SuperscriptBox["mult", "i"]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tbins", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"tsides", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"tsides", "[", 
             RowBox[{"[", 
              RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tsizes", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tmeans", "=", 
        RowBox[{"Delete", "[", 
         RowBox[{
          RowBox[{"Mean", "[", 
           RowBox[{"Transpose", "[", "tbins", "]"}], "]"}], ",", 
          RowBox[{"-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"intergra", "=", 
        RowBox[{"Interpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"tra", "=", 
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"timex", ",", 
               RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}]}], "]"}], ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"pergra", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{"Exp", "[", 
               RowBox[{"intergra", "[", 
                RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"tx", ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
              RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
              RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
         RowBox[{"res", "=", 
          RowBox[{"Select", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"tmeans", ",", 
               FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
           "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"pergra", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            FractionBox[
             RowBox[{"NIntegrate", "[", 
              RowBox[{
               RowBox[{"intergra", "[", 
                RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"tx", ",", 
                 RowBox[{"tbins", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"tbins", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
               RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
               RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
             RowBox[{"tsizes", "[", 
              RowBox[{"[", "i", "]"}], "]"}]], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "nn"}], 
             RowBox[{"(*", 
              RowBox[{"+", "1"}], "*)"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"pergra", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"sel", "=", 
            RowBox[{"Select", "[", 
             RowBox[{"timex", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], "<", "#", "<", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "&"}]}], "]"}]}], 
           ";", 
           RowBox[{"inttime", "=", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Flatten", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}], ",", "sel", ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}]}], "}"}], "]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"intxx", "=", 
            RowBox[{
             RowBox[{"intergra", "[", 
              RowBox[{"Log", "[", "tx", "]"}], "]"}], "/.", 
             RowBox[{"tx", "\[Rule]", "inttime"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"deltax", "=", 
            RowBox[{"Differences", "[", "inttime", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{
               FractionBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"intxx", "[", 
                   RowBox[{"[", "kk", "]"}], "]"}], "+", 
                  RowBox[{"intxx", "[", 
                   RowBox[{"[", 
                    RowBox[{"kk", "+", "1"}], "]"}], "]"}]}], ")"}], "2"], 
               RowBox[{"deltax", "[", 
                RowBox[{"[", "kk", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"kk", ",", 
                RowBox[{
                 RowBox[{"Length", "[", "inttime", "]"}], "-", "1"}]}], 
               "}"}]}], "]"}], "/", 
            RowBox[{"tsizes", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nn"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"resy", "=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"tmeans", ",", 
             RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
         "]"}]}]}], ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"3", ",", "1.2", ",", "6"}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"lpl3", "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", "\"\<FourierDCT of autovariance\>\""}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"tofit3", "=", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"A", " ", 
         RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
      RowBox[{"FindFit", "[", 
       RowBox[{
        RowBox[{"Log", "[", "res", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"logpl3", "=", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{"tofit3", ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"res", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"res", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl3", ",", "logpl3"}], "]"}]}], 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5696898764220953`*^9, 3.569689887354763*^9}, {
   3.56972286613972*^9, 3.5697228844700017`*^9}, {3.569760446396062*^9, 
   3.5697604472910633`*^9}, {3.5697633264843206`*^9, 3.569763427478898*^9}, {
   3.5717043231150923`*^9, 3.571704348235478*^9}, {3.5717446001776857`*^9, 
   3.571744630620653*^9}, {3.5717479245377507`*^9, 3.571747951215661*^9}, 
   3.5720012723532705`*^9, {3.5720022571713996`*^9, 3.572002267316555*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ttx", "=", 
   RowBox[{"TimeUsed", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "th", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}], ",", 
   RowBox[{"Dynamic", "[", "fr", "]"}], ",", 
   RowBox[{"Dynamic", "[", "o", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"50", ",", "tmax"}], "}"}], ",", "All"}], "}"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=."}], ";", 
  RowBox[{"fr", "=."}], ";", 
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";", 
  RowBox[{"types", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Flux\>\"", ",", "\"\<LP\>\"", ",", "\"\<EVPA\>\"", ",", 
     "\"\<CP\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{
      StyleBox[
       RowBox[{"autovar", "[", 
        RowBox[{"typ", ",", "3.0", ",", "fr", ",", "th"}], "]"}],
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox[";",
       FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resx", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"res", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"timex", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"sur", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tofit4", "=", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"A", " ", 
           RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
        RowBox[{"FindFit", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"res", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resx", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"#", ",", 
             RowBox[{
              FractionBox[
               RowBox[{
                RowBox[{"tofit4", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                RowBox[{"x", "\[Rule]", "#"}]}], 
               RowBox[{
                RowBox[{"tofit4", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                RowBox[{"x", "\[Rule]", 
                 RowBox[{
                  RowBox[{"res", "[", 
                   RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
              RowBox[{
               RowBox[{"res", "[", 
                RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
          RowBox[{"{", 
           RowBox[{"4", ",", "8"}], "}"}]}], ",", 
         RowBox[{"resx", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"resx", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"#", ",", 
              RowBox[{
               FractionBox[
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", "#"}]}], 
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", 
                  RowBox[{"res", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
               RowBox[{"res", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
           RowBox[{"{", 
            RowBox[{"4", ",", "8"}], "}"}]}], ",", "res", ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"timex", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"sur", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"interand", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"resx", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDfluxx", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"resx", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"autovar", "[", 
        RowBox[{"typ", ",", "1.2", ",", "fr", ",", "th"}], "]"}],
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox[";",
       FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", 
      RowBox[{"nux", "=", "154"}], ";", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"22", " ", "-", " ", 
         RowBox[{"1", "\[Sigma]"}]}], ";", " ", 
        RowBox[{"154", " ", "-", " ", 
         RowBox[{"2", "\[Sigma]"}]}], ";", " ", 
        RowBox[{"2592", " ", "-", " ", 
         RowBox[{"3", "\[Sigma]"}]}], ";", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"7", "/", 
           RowBox[{"(", 
            RowBox[{"1", "-", "#"}], ")"}]}], "&"}], "/@", 
         RowBox[{"{", 
          RowBox[{
          "0.682689492137086", ",", "0.954499736103642", ",", 
           "0.997300203936740"}], "}"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"nam", "=", 
       RowBox[{
        RowBox[{"dix", "[", "th", "]"}], "<>", "\"\<rand\>\"", "<>", 
        RowBox[{"ToString", "[", "fr", "]"}], "<>", "\"\<x\>\"", "<>", 
        RowBox[{"ToString", "[", "typ", "]"}], "<>", "\"\<x\>\"", "<>", 
        RowBox[{"ToString", "[", "nux", "]"}], "<>", "\"\<.dat\>\""}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"FileExistsQ", "[", "nam", "]"}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"tabresy", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"randx", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"RandomVariate", "[", 
                  RowBox[{
                   RowBox[{"NormalDistribution", "[", "]"}], ",", 
                   RowBox[{"lop", "[", "th", "]"}]}], "]"}], "+", 
                 RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"RandomVariate", "[", 
                   RowBox[{
                    RowBox[{"NormalDistribution", "[", "]"}], ",", 
                    RowBox[{"lop", "[", "th", "]"}]}], "]"}]}]}], ")"}], 
               SqrtBox[
                RowBox[{"Exp", "[", 
                 RowBox[{"interand", "[", 
                  RowBox[{"Log", "[", 
                   RowBox[{"Ntodx", " ", 
                    RowBox[{
                    RowBox[{"lop", "[", "th", "]"}], "/", 
                    RowBox[{"Range", "[", 
                    RowBox[{"lop", "[", "th", "]"}], "]"}]}]}], "]"}], "]"}], 
                 "]"}]]}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"rsxx", "=", 
              RowBox[{"4.8", 
               RowBox[{"Re", "[", 
                RowBox[{"InverseFourier", "[", "randx", "]"}], "]"}]}]}], ";", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"+", "me"}], ";"}], 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"-", "for"}], " ", "formal", " ", "correspondence"}], 
               "*)"}], "*)"}], ";", "\[IndentingNewLine]", 
             RowBox[{"resy", "=", 
              StyleBox[
               RowBox[{"autorand", "[", 
                RowBox[{"typ", ",", "1.2", ",", "fr", ",", "rsxx"}], "]"}],
               FontColor->RGBColor[1, 0, 0]]}]}], ",", 
            RowBox[{"{", 
             RowBox[{"o", ",", "nux"}], "}"}]}], "]"}]}], ";", 
         RowBox[{"Put", "[", 
          RowBox[{
           RowBox[{"tabresy", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", "nam"}], 
          "]"}]}], ",", 
        RowBox[{
         RowBox[{"tabresy", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
         RowBox[{"Get", "[", "nam", "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ress", "[", "aa", "]"}], "=", 
         RowBox[{
          RowBox[{"tabresy", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "[", 
          RowBox[{"[", "aa", "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"aa", ",", "nux"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmean", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Exp", "[", 
        FractionBox[
         RowBox[{"Total", "[", 
          RowBox[{"Log", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"ress", "[", "i", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}], "]"}], "nux"],
         "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFrandmean", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"ressmean", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Green", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDflux", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0., 0., 1.]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"res", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}], ",", 
         RowBox[{"Epilog", "\[Rule]", "\[IndentingNewLine]", 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"types", "[", 
                RowBox[{"[", 
                 RowBox[{"typ", "-", "2"}], "]"}], "]"}], "<>", 
               "\"\< at \>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Floor", "[", 
                 RowBox[{"freqs", "[", 
                  RowBox[{"[", "fr", "]"}], "]"}], "]"}], "]"}], "<>", 
               "\"\<GHz\>\""}], ",", "18", ",", "Bold"}], "]"}], ",", 
            RowBox[{"Scaled", "[", 
             RowBox[{"{", 
              RowBox[{"0.3", ",", "0.8"}], "}"}], "]"}]}], "]"}]}]}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resstot", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ress", "[", "i", "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"resst", "=", 
       RowBox[{
        RowBox[{"ress", "[", "1", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmax", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"resst", ",", 
          RowBox[{"Mean", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"RankedMax", "[", 
                RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"RankedMax", "[", 
                RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}]}], "}"}], 
           "]"}]}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmin", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"resst", ",", 
          RowBox[{"Mean", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"RankedMin", "[", 
                RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"RankedMin", "[", 
                RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}]}], "}"}], 
           "]"}]}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFmin", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"ressmin", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Dotted"}], 
           "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFmax", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"ressmax", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"typ", ",", "3", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"th", ",", "1", ",", 
     RowBox[{"Length", "[", "angles", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Computed in \>\"", ",", 
    RowBox[{
     RowBox[{"TimeUsed", "[", "]"}], "-", "ttx"}], ",", "\"\<s\>\""}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"367", "s", " ", "for", " ", "1", "\[Sigma]"}], " ", "\[Implies]",
     " ", 
    RowBox[{
     RowBox[{"2218", "s", 
      RowBox[{"(", 
       RowBox[{"37", "min"}], ")"}], " ", "for", " ", "2", "\[Sigma]"}], " ", 
     "\[Implies]", " ", 
     RowBox[{"36121", "s", 
      RowBox[{"(", 
       RowBox[{"10", "hrs"}], ")"}], " ", "for", " ", "3", "\[Sigma]"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Dimensions", "[", 
     RowBox[{"tabresy", "[", 
      RowBox[{"3", ",", "3"}], "]"}], "]"}], "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"Put", "[", 
       RowBox[{
        RowBox[{"tabresy", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
        RowBox[{"nam", "=", 
         RowBox[{
          RowBox[{"dix", "[", "th", "]"}], "<>", "\"\<rand\>\"", "<>", 
          RowBox[{"ToString", "[", "fr", "]"}], "<>", "\"\<x\>\"", "<>", 
          RowBox[{"ToString", "[", "typ", "]"}], "<>", "\"\<x\>\"", "<>", 
          RowBox[{"ToString", "[", "nux", "]"}], "<>", "\"\<.dat\>\""}]}]}], 
       "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"typ", ",", "3", ",", "6"}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.568658690181983*^9, 3.5686587401332707`*^9}, {
   3.5686588111757956`*^9, 3.5686588548880725`*^9}, {3.5686588922033377`*^9, 
   3.568658925977397*^9}, {3.5686589703906755`*^9, 3.5686589774106874`*^9}, {
   3.568672919401613*^9, 3.5686729589816833`*^9}, {3.5686734755153365`*^9, 
   3.5686734758803368`*^9}, 3.568673902517336*^9, {3.5686740475725393`*^9, 
   3.5686740736925755`*^9}, {3.5686741992477517`*^9, 3.568674207342763*^9}, {
   3.5686743702339907`*^9, 3.568674420479061*^9}, {3.5686746579543934`*^9, 
   3.5686746640944023`*^9}, {3.5686747825547867`*^9, 
   3.5686747836467886`*^9}, {3.568675093166932*^9, 3.5686751107637634`*^9}, {
   3.5686751638818564`*^9, 3.5686751860962954`*^9}, {3.5686752638780317`*^9, 
   3.5686752932372837`*^9}, 3.568676352200344*^9, {3.568676425036872*^9, 
   3.5686764268152747`*^9}, {3.5686765814583464`*^9, 
   3.5686765815051465`*^9}, {3.568676612564801*^9, 3.5686766292880306`*^9}, {
   3.5686768069879427`*^9, 3.568676807112743*^9}, {3.568676887780484*^9, 
   3.5686768878896847`*^9}, {3.5686769802106466`*^9, 
   3.5686770449975605`*^9}, {3.568677177254593*^9, 3.5686771780189943`*^9}, {
   3.5686772390463014`*^9, 3.5686772393739023`*^9}, {3.568677286049184*^9, 
   3.5686773642833214`*^9}, {3.568677400110385*^9, 3.568677400484785*^9}, {
   3.568677507665374*^9, 3.5686775082269745`*^9}, {3.5686775809855022`*^9, 
   3.568677667160054*^9}, {3.568677724162554*^9, 3.568677768326232*^9}, {
   3.5686784189103737`*^9, 3.5686784731984696`*^9}, {3.568678528562967*^9, 
   3.5686785340073767`*^9}, {3.568678600557093*^9, 3.5686786208995285`*^9}, {
   3.5686786550323887`*^9, 3.5686786624268017`*^9}, {3.568678748679353*^9, 
   3.5686787518617587`*^9}, {3.568678943851296*^9, 3.568678944178897*^9}, {
   3.568679095826763*^9, 3.5686790961543636`*^9}, 3.5687143742988043`*^9, {
   3.568718293597542*^9, 3.568718293925143*^9}, {3.568733412817721*^9, 
   3.568733427575347*^9}, {3.5687335444663525`*^9, 3.568733613090873*^9}, {
   3.568733746627107*^9, 3.5687337937547903`*^9}, {3.5687342807418456`*^9, 
   3.5687343666823964`*^9}, {3.5687344259001007`*^9, 
   3.5687344394877243`*^9}, {3.568734477239791*^9, 3.5687345461451116`*^9}, {
   3.5687345797823715`*^9, 3.568734589844389*^9}, {3.5687346756289396`*^9, 
   3.568734677563343*^9}, {3.568734894974286*^9, 3.568734922929535*^9}, {
   3.5687349655332103`*^9, 3.5687349764844294`*^9}, {3.568735012192892*^9, 
   3.56873502830772*^9}, {3.568735147273529*^9, 3.568735195914415*^9}, {
   3.568735337110263*^9, 3.568735339029066*^9}, {3.568735384331546*^9, 
   3.568735388949154*^9}, {3.5687354326448307`*^9, 3.5687354327852306`*^9}, {
   3.568735491519334*^9, 3.568735505184958*^9}, {3.5687364997865577`*^9, 
   3.568736499896558*^9}, {3.568743415518503*^9, 3.568743415643503*^9}, {
   3.568743713589615*^9, 3.5687437136364155`*^9}, {3.5687441249311376`*^9, 
   3.5687441349005547`*^9}, {3.5687456117645607`*^9, 3.568745675733219*^9}, {
   3.568745710904231*^9, 3.5687457803412027`*^9}, {3.568745836047389*^9, 
   3.5687458519833*^9}, {3.568746269593191*^9, 3.5687463055824547`*^9}, {
   3.568746362210554*^9, 3.5687463633961563`*^9}, {3.5687464472712975`*^9, 
   3.5687464474012976`*^9}, {3.568746524051405*^9, 3.5687465241114054`*^9}, {
   3.5687465874514937`*^9, 3.568746587516494*^9}, {3.5687466340115585`*^9, 
   3.5687466340965595`*^9}, {3.5687466830126286`*^9, 3.5687466830926285`*^9}, 
   3.5687467437727137`*^9, {3.568746883758145*^9, 3.5687468841949453`*^9}, {
   3.568746932711031*^9, 3.568746932867031*^9}, {3.5687483065115275`*^9, 
   3.5687483066051273`*^9}, {3.568748356905614*^9, 3.5687483570772142`*^9}, {
   3.5687484849978333`*^9, 3.5687484851070337`*^9}, {3.5687486793365183`*^9, 
   3.5687487039165525`*^9}, 3.5687487503066173`*^9, {3.5687487915866747`*^9, 
   3.568748868616783*^9}, 3.568748930046869*^9, {3.5687648297268953`*^9, 
   3.568764830431896*^9}, {3.5687651183353004`*^9, 3.5687651217753053`*^9}, {
   3.568765172395376*^9, 3.568765172775377*^9}, {3.5687652432954755`*^9, 
   3.5687652504354854`*^9}, {3.5687653239655886`*^9, 
   3.5687654154007163`*^9}, {3.5687654918858232`*^9, 3.568765522375866*^9}, {
   3.568765635131024*^9, 3.5687656600910587`*^9}, {3.5687657746762195`*^9, 
   3.568765779146226*^9}, {3.5687658126242733`*^9, 3.5687658187242823`*^9}, {
   3.5687659304504385`*^9, 3.5687659560604744`*^9}, {3.5687660151155567`*^9, 
   3.5687660156055574`*^9}, {3.5687660518306084`*^9, 3.56876608879066*^9}, {
   3.568766907469807*^9, 3.5687669171198206`*^9}, {3.5687669640798864`*^9, 
   3.5687669661198893`*^9}, {3.5687675173867655`*^9, 
   3.5687675633756466`*^9}, {3.568821997140112*^9, 3.568822020852154*^9}, {
   3.5688220594154215`*^9, 3.568822062551027*^9}, {3.568822107572706*^9, 
   3.568822116667522*^9}, {3.568822153592787*^9, 3.568822194090458*^9}, {
   3.5688227530290003`*^9, 3.5688227588010106`*^9}, {3.5688228373783484`*^9, 
   3.5688228857228336`*^9}, {3.5688229377967253`*^9, 
   3.5688229695895805`*^9}, {3.5688230020376377`*^9, 
   3.5688230069828463`*^9}, {3.56882307145776*^9, 3.568823184807559*^9}, {
   3.5688232887817416`*^9, 3.5688233510570507`*^9}, {3.568823574855044*^9, 
   3.5688235769298477`*^9}, {3.568823624853132*^9, 3.568823626522335*^9}, {
   3.568823907307228*^9, 3.568823937727281*^9}, {3.5688242497905293`*^9, 
   3.5688242498997297`*^9}, {3.5688249598546658`*^9, 3.568824963988673*^9}, {
   3.5688249955007286`*^9, 3.568824998527134*^9}, {3.568825583173684*^9, 
   3.5688256067765255`*^9}, {3.5688257669956055`*^9, 
   3.5688257915968485`*^9}, {3.5688265201971283`*^9, 3.568826526140739*^9}, {
   3.56882670801742*^9, 3.568826716082634*^9}, {3.5688267536163*^9, 
   3.568826758140308*^9}, {3.5696898448366103`*^9, 3.569689848671669*^9}, {
   3.5696899318429465`*^9, 3.569689935898009*^9}, {3.5696900532648115`*^9, 
   3.5696901073531427`*^9}, {3.569690290777461*^9, 3.569690331808091*^9}, {
   3.5696906005022182`*^9, 3.569690621590042*^9}, 3.5696906748008595`*^9, {
   3.5696911680134354`*^9, 3.5696911768160706`*^9}, {3.5696914070181074`*^9, 
   3.5696914071706095`*^9}, {3.5696914461662083`*^9, 
   3.5696914473587265`*^9}, {3.569691554536373*^9, 3.56969156347651*^9}, {
   3.569691629262521*^9, 3.5696916591204796`*^9}, {3.569691693988515*^9, 
   3.5696917502993803`*^9}, {3.5696918200279512`*^9, 
   3.5696918611985836`*^9}, {3.569696129506508*^9, 3.569696201117608*^9}, {
   3.5696967610487103`*^9, 3.569696820434623*^9}, {3.5696968508025894`*^9, 
   3.5696968900581923`*^9}, {3.5697229699763155`*^9, 
   3.5697229710588317`*^9}, {3.569723191150887*^9, 3.569723208733657*^9}, {
   3.569723547730029*^9, 3.5697235478750315`*^9}, {3.5697602313657613`*^9, 
   3.569760234820766*^9}, {3.56976027328082*^9, 3.569760307765868*^9}, 
   3.5697630504886355`*^9, {3.569945540377632*^9, 3.5699455435326366`*^9}, {
   3.569946117072834*^9, 3.569946117228834*^9}, {3.5699465864796576`*^9, 
   3.569946614060506*^9}, {3.5699488662442627`*^9, 3.569948885927105*^9}, {
   3.5699803386893177`*^9, 3.5699803418405232`*^9}, {3.570016662082553*^9, 
   3.570016673626573*^9}, {3.571705919857123*^9, 3.5717059255497103`*^9}, {
   3.571744660763616*^9, 3.5717446715262814`*^9}, {3.57174546117591*^9, 
   3.5717455542208405`*^9}, {3.5717456780862427`*^9, 
   3.5717456782512455`*^9}, {3.5717458119743*^9, 3.571745814396837*^9}, {
   3.5717458885654764`*^9, 3.5717458951955786`*^9}, {3.5717463888046618`*^9, 
   3.571746395032257*^9}, {3.5717476551651134`*^9, 3.5717476672627993`*^9}, {
   3.5717477724744153`*^9, 3.571747772515416*^9}, {3.5717479705434575`*^9, 
   3.5717479706109586`*^9}, {3.571748011251583*^9, 3.571748012111596*^9}, {
   3.5717483015835423`*^9, 3.5717483040085793`*^9}, {3.5720013070138035`*^9, 
   3.572001378728405*^9}, {3.5720015340792923`*^9, 3.57200153590432*^9}, {
   3.572001705347423*^9, 3.572001705527426*^9}, {3.572002281694276*^9, 
   3.5720022831267977`*^9}, 3.5720023499703245`*^9, {3.5720030846176095`*^9, 
   3.572003084752612*^9}, {3.57200392234398*^9, 3.5720039232339935`*^9}, {
   3.572005407494802*^9, 3.5720054091823277`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"th", "=", "1"}], ";", 
  RowBox[{"grgr", "=", 
   RowBox[{"GraphicsGrid", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"sh", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Show", "[", 
        RowBox[{"{", 
         StyleBox[
          RowBox[{
           RowBox[{"PSDflux", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
           RowBox[{"PSDFmax", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
           RowBox[{"PSDFrandmean", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
           RowBox[{"PSDfluxx", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}],
          FontColor->RGBColor[0, 0, 1]], 
         StyleBox["}",
          FontColor->RGBColor[0, 0, 1]]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"typ", ",", "3", ",", "6"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"fr", ",", "1", ",", "3"}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"th", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.571747688595627*^9, 3.57174769464322*^9}, {
  3.5717479804986105`*^9, 3.5717479840736656`*^9}}],

Cell[BoxData[{
 RowBox[{"grgr", "=", 
  RowBox[{"GraphicsGrid", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"sh", "[", 
       RowBox[{"typ", ",", "fr", ",", "1"}], "]"}], "=", 
      RowBox[{"Show", "[", 
       RowBox[{"{", 
        StyleBox[
         RowBox[{
          RowBox[{"PSDflux", "[", 
           RowBox[{"typ", ",", "fr", ",", "1"}], "]"}], ",", 
          RowBox[{"PSDFmax", "[", 
           RowBox[{"typ", ",", "fr", ",", "1"}], "]"}], ",", 
          RowBox[{"PSDFrandmean", "[", 
           RowBox[{"typ", ",", "fr", ",", "1"}], "]"}], ",", 
          RowBox[{"PSDfluxx", "[", 
           RowBox[{"typ", ",", "fr", ",", "1"}], "]"}]}],
         FontColor->RGBColor[0, 0, 1]], 
        StyleBox["}",
         FontColor->RGBColor[0, 0, 1]]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"typ", ",", "3", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"grgr", "=", 
  RowBox[{"GraphicsGrid", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"sh", "[", 
       RowBox[{"typ", ",", "fr", ",", "2"}], "]"}], "=", 
      RowBox[{"Show", "[", 
       RowBox[{"{", 
        StyleBox[
         RowBox[{
          RowBox[{"PSDflux", "[", 
           RowBox[{"typ", ",", "fr", ",", "2"}], "]"}], ",", 
          RowBox[{"PSDFmax", "[", 
           RowBox[{"typ", ",", "fr", ",", "2"}], "]"}], ",", 
          RowBox[{"PSDFrandmean", "[", 
           RowBox[{"typ", ",", "fr", ",", "2"}], "]"}], ",", 
          RowBox[{"PSDfluxx", "[", 
           RowBox[{"typ", ",", "fr", ",", "2"}], "]"}]}],
         FontColor->RGBColor[0, 0, 1]], 
        StyleBox["}",
         FontColor->RGBColor[0, 0, 1]]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"typ", ",", "3", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"grgr", "=", 
  RowBox[{"GraphicsGrid", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"sh", "[", 
       RowBox[{"typ", ",", "fr", ",", "3"}], "]"}], "=", 
      RowBox[{"Show", "[", 
       RowBox[{"{", 
        StyleBox[
         RowBox[{
          RowBox[{"PSDflux", "[", 
           RowBox[{"typ", ",", "fr", ",", "3"}], "]"}], ",", 
          RowBox[{"PSDFmax", "[", 
           RowBox[{"typ", ",", "fr", ",", "3"}], "]"}], ",", 
          RowBox[{"PSDFrandmean", "[", 
           RowBox[{"typ", ",", "fr", ",", "3"}], "]"}], ",", 
          RowBox[{"PSDfluxx", "[", 
           RowBox[{"typ", ",", "fr", ",", "3"}], "]"}]}],
         FontColor->RGBColor[0, 0, 1]], 
        StyleBox["}",
         FontColor->RGBColor[0, 0, 1]]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"typ", ",", "3", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.568765709706128*^9, 3.5687657570961947`*^9}, {
   3.568766150610747*^9, 3.5687661926308055`*^9}, {3.5687676090213265`*^9, 
   3.5687676147465367`*^9}, {3.5687677042756658`*^9, 
   3.5687677075856705`*^9}, {3.568826535828356*^9, 3.568826536140356*^9}, {
   3.5689450632113714`*^9, 3.5689450639601727`*^9}, 3.5696928359807386`*^9, {
   3.56969305541879*^9, 3.569693097186931*^9}, {3.569760309670871*^9, 
   3.5697603130358753`*^9}, {3.569760404331003*^9, 3.5697604079010086`*^9}, {
   3.5697607003894196`*^9, 3.5697607614745045`*^9}, {3.5717061837186756`*^9, 
   3.5717061838786783`*^9}, {3.57174471312192*^9, 3.5717447132344217`*^9}, {
   3.5720015424594207`*^9, 3.572001582297532*^9}, {3.5720027165044556`*^9, 
   3.5720027267971134`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"lk", "=", 
   RowBox[{"Length", "[", "resst", "]"}]}], ";", 
  RowBox[{"lx", "=", 
   RowBox[{"Length", "[", 
    RowBox[{"resx", "[", 
     RowBox[{"3", ",", "3", ",", "1"}], "]"}], "]"}]}], ";", 
  RowBox[{"mx", "=", 
   RowBox[{"1", "/", "30."}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"shift", "[", "2", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lk"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"shix", "[", "2", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lx"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"shift", "[", "1", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"1", "/", "mx"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lk"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"shix", "[", "1", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"1", "/", "mx"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lx"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"shift", "[", "3", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "mx"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lk"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"shix", "[", "3", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "mx"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lx"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"fllab", "[", "3", "]"}], ",", 
      RowBox[{"fllab", "[", "4", "]"}], ",", 
      RowBox[{"fllab", "[", "5", "]"}], ",", 
      RowBox[{"fllab", "[", "6", "]"}]}], "}"}], "=", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Flux at \>\"", ",", "\"\<LP at \>\"", ",", "\"\<EVPA at \>\"", ",", 
      "\"\<CP at \>\""}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"frlab", "[", "1", "]"}], ",", 
      RowBox[{"frlab", "[", "2", "]"}], ",", 
      RowBox[{"frlab", "[", "3", "]"}], ",", 
      RowBox[{"frlab", "[", "6", "]"}], ",", 
      RowBox[{"frlab", "[", "9", "]"}]}], "}"}], "=", 
    RowBox[{"{", 
     RowBox[{
     "\"\<22GHz\>\"", ",", "\"\<43GHz\>\"", ",", "\"\<87GHz\>\"", ",", 
      "\"\<230GHz\>\"", ",", "\"\<857GHz\>\""}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mysize", "=", "16"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"figvx", "=", 
  RowBox[{"Figure", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.21", ",", "0.76"}], "}"}], ",", "\"\<Top - spin 0\>\"", 
        ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.21", ",", "0.74"}], "}"}], ",", 
        "\"\<Middle - spin 0.7\>\"", ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.21", ",", "0.72"}], "}"}], ",", 
        "\"\<Bottom - spin 0.9\>\"", ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Multipanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "3"}], "}"}], ",", 
        RowBox[{"XPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Log10", "[", "20", "]"}], ",", 
           RowBox[{"Log10", "[", "tmax", "]"}]}], "}"}]}], ",", 
        RowBox[{"YPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", 
              SuperscriptBox["10", 
               RowBox[{"-", "7"}]], "]"}], ",", 
             RowBox[{"Log10", "[", 
              SuperscriptBox["10", "2.5"], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", 
              SuperscriptBox["10", 
               RowBox[{"-", "4"}]], "]"}], ",", 
             RowBox[{"Log10", "[", 
              SuperscriptBox["10", "3.5"], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", 
              SuperscriptBox["10", 
               RowBox[{"-", "2"}]], "]"}], ",", 
             RowBox[{"Log10", "[", 
              SuperscriptBox["10", "5.5"], "]"}]}], "}"}]}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
        RowBox[{"XFrameLabels", "\[Rule]", 
         RowBox[{"{", "\"\<Period T [M]\>\"", "}"}]}], ",", 
        RowBox[{"BufferL", "\[Rule]", "6"}], ",", 
        RowBox[{"YFrameLabels", "\[Rule]", "\"\<Periodogram   I(T)\>\""}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"YFrameTicks", "\[Rule]", 
         RowBox[{"LogTicks", "[", 
          RowBox[{
           RowBox[{"-", "10"}], ",", "10"}], "]"}]}], ",", 
        RowBox[{"XFrameTicks", "\[Rule]", 
         RowBox[{"LogTicks", "[", 
          RowBox[{
           RowBox[{"-", "10"}], ",", "10", ",", 
           RowBox[{"TickLabelStep", "\[Rule]", "1"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Background", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PanelLetterCorner", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
        RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SetOptions", "[", 
       RowBox[{"DataSymbol", ",", 
        RowBox[{"SymbolSize", "\[Rule]", "0.001"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SetOptions", "[", 
       RowBox[{"DataLine", ",", 
        RowBox[{"Thickness", "\[Rule]", "1.5"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SetOptions", "[", 
       RowBox[{"DataValues", ",", 
        RowBox[{"AxisScaling", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Log", ",", "Log"}], "}"}]}]}], "]"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FigurePanel", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"typ", "-", "2"}], ",", 
              RowBox[{"fr", "/", "3"}]}], "}"}], ",", 
            RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"pan", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}], "=", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"DataPlot", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"shift", "[", "th", "]"}], 
                   RowBox[{"res", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                  RowBox[{"DataLine", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"Color", "\[Rule]", "Black"}], "}"}]}]}], "]"}], 
                ",", 
                RowBox[{"DataPlot", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"shift", "[", "th", "]"}], 
                   RowBox[{"ressmean", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                  RowBox[{"DataLine", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Color", "\[Rule]", "Black"}], ",", 
                    RowBox[{"Dashing", "\[Rule]", "7"}]}], "}"}]}]}], "]"}], 
                ",", 
                RowBox[{"DataPlot", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"shift", "[", "th", "]"}], 
                   RowBox[{"ressmax", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                  RowBox[{"DataLine", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"Color", "\[Rule]", "Red"}], "}"}]}]}], "]"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"DataPlot", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"shix", "[", "th", "]"}], 
                   RowBox[{"resx", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                  RowBox[{"DataLine", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Color", "\[Rule]", "Green"}], ",", 
                    RowBox[{"Dashing", "\[Rule]", "5"}]}], "}"}]}]}], "]"}]}],
                "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"th", ",", "3"}], "}"}]}], "]"}]}], ";", 
           RowBox[{
            RowBox[{"lab", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}], "=", 
            RowBox[{
             RowBox[{"fllab", "[", "typ", "]"}], "<>", 
             RowBox[{"frlab", "[", "fr", "]"}]}]}], ";", 
           RowBox[{
            RowBox[{"sclab", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}], "=", 
            RowBox[{"ScaledLabel", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0.18", ",", "0.89"}], "}"}], ",", 
              RowBox[{"lab", "[", 
               RowBox[{"typ", ",", "fr"}], "]"}], ",", 
              RowBox[{"Color", "\[Rule]", "Black"}], ",", 
              RowBox[{"Background", "\[Rule]", "White"}], ",", 
              RowBox[{"FontSize", "\[Rule]", 
               RowBox[{"mysize", "-", "1"}]}], ",", 
              RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}]}], ";", 
           RowBox[{"pan", "[", 
            RowBox[{"typ", ",", "fr"}], "]"}]}], ",", 
          RowBox[{"sclab", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"typ", ",", "3", ",", "5"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
       "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.07"}], ",", "1.01"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.07"}], ",", "1.01"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1300", ",", "800"}], "}"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.571746531406852*^9, 3.5717466100180593`*^9}, {
  3.5717485672176228`*^9, 3.5717485898679705`*^9}, {3.5717486209459476`*^9, 
  3.5717486357311745`*^9}, {3.5720017790140553`*^9, 3.5720017895242167`*^9}, {
  3.5720018215422087`*^9, 3.5720018215997095`*^9}, {3.57200195513426*^9, 
  3.5720019921023283`*^9}, {3.5720023674180927`*^9, 3.5720023676680965`*^9}, {
  3.5720026215079966`*^9, 3.5720026718862705`*^9}, {3.572002770777789*^9, 
  3.5720027711127944`*^9}, {3.572002842238887*^9, 3.5720028424513903`*^9}, {
  3.57200291600502*^9, 3.5720029228701253`*^9}, {3.572002954800616*^9, 
  3.572002995686244*^9}, {3.5720067456928577`*^9, 3.572006751837952*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\accretion\\\\! 2013 1spring UMD\\\\Long time \
variability\\\\allspins_high_f_2sigma.eps\>\"", ",", "figvx"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.572003020756629*^9, 3.5720030266767197`*^9}, {
  3.572003881750856*^9, 3.5720039118963194`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\accretion\\\\! 2013 1spring UMD\\\\Long time \
variability\\\\spin0_low_f.eps\>\"", ",", "figvx"}], "]"}]], "Input",
 CellChangeTimes->{{3.5717485568774633`*^9, 3.5717485570724664`*^9}, {
  3.5720030162040586`*^9, 3.572003017124073*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\accretion\\\\! 2013 1spring UMD\\\\Long time \
variability\\\\spin0_high_f.eps\>\"", ",", "figvx"}], "]"}]], "Input",
 CellChangeTimes->{{3.571748464728548*^9, 3.5717485044116573`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Periodograms for Olek\[CloseCurlyQuote]s simulations - spin 0, incl. low \
frequency modeling\
\>", "Subsection",
 CellChangeTimes->{{3.571681430533337*^9, 3.5716814584212656`*^9}, {
   3.571706641843214*^9, 3.5717066523858757`*^9}, {3.571743678382437*^9, 
   3.571743691960146*^9}, 3.5720001394078665`*^9, {3.572003379025633*^9, 
   3.5720033852007275`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Nu]", "=", 
   RowBox[{"86", " ", 
    SuperscriptBox["10", "9"]}]}], ";", 
  RowBox[{"(*", "Hz", "*)"}], 
  RowBox[{"\[Nu]0", "=", 
   FractionBox[
    RowBox[{"ee", " ", "B"}], 
    RowBox[{"2", "\[Pi]", " ", "me", " ", "cc"}]]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Bsolx", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"2", 
          FractionBox[
           SuperscriptBox["B", "2"], 
           RowBox[{"8", "\[Pi]"}]]}], "\[Equal]", 
         RowBox[{
          RowBox[{"\[Rho]", "[", 
           RowBox[{"Log", "[", "r", "]"}], "]"}], " ", "kb", " ", 
          RowBox[{"Tp", "[", "r", "]"}]}]}], "/.", "solful"}], ",", "B"}], 
      "]"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}], "/.", "ruru"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xm", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      FractionBox[
       RowBox[{"2", "\[Nu]"}], 
       RowBox[{"3", "\[Nu]0"}]], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         FractionBox["mp", "me"], 
         SuperscriptBox[
          RowBox[{"cs", "[", 
           RowBox[{"Log", "[", "r", "]"}], "]"}], "2"]}], ")"}], 
       RowBox[{"-", "2"}]]}], "/.", "ruru"}], "/.", "Bsolx"}]}], ";", 
  RowBox[{"eqIRx", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"4.43", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "30"}]], "4", "\[Pi]", " ", 
       RowBox[{"\[Rho]", "[", 
        RowBox[{"Log", "[", "r", "]"}], "]"}], "\[Nu]", 
       FractionBox["4.0505", 
        SuperscriptBox["xm", 
         RowBox[{"1", "/", "6"}]]], 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         FractionBox["0.4", 
          SuperscriptBox["xm", 
           RowBox[{"1", "/", "4"}]]], "+", 
         FractionBox["0.5316", 
          SuperscriptBox["xm", 
           RowBox[{"1", "/", "2"}]]]}], ")"}], 
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", "1.8899"}], " ", 
         SuperscriptBox["xm", 
          RowBox[{"1", "/", "3"}]]}], "]"}], 
       FractionBox[
        RowBox[{"4", "\[Pi]"}], "3"], 
       SuperscriptBox["r", "3"], 
       RowBox[{
        SuperscriptBox["rg", "3"], "/", 
        RowBox[{"BesselK", "[", 
         RowBox[{"2", ",", 
          RowBox[{
           FractionBox["me", "mp"], 
           SuperscriptBox[
            RowBox[{"cs", "[", 
             RowBox[{"Log", "[", "r", "]"}], "]"}], 
            RowBox[{"-", "2"}]]}]}], "]"}]}]}], "\[Equal]", 
      RowBox[{"(", 
       RowBox[{"LIRx", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"2", "\[Pi]", " ", 
           FractionBox[
            SuperscriptBox["\[Nu]", "2"], 
            SuperscriptBox["cc", "2"]], "kb", " ", 
           RowBox[{"Te", "[", "r", "]"}], "4", "\[Pi]", " ", 
           SuperscriptBox["r", "2"], 
           SuperscriptBox["rg", "2"]}], "/.", "ruru"}], "/.", "solful"}]}], 
       ")"}]}], "/.", "solful"}], "/.", "ruru"}]}], ";", 
  RowBox[{"rIRx", "=", 
   RowBox[{"FindRoot", "[", 
    RowBox[{"eqIRx", ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "10"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5749232506595955`*^9, 3.5749233035246696`*^9}}],

Cell[BoxData[{
 RowBox[{"Dynamic", "[", "fnum", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"angles", "=", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{
     "\"\<th214lo\>\"", ",", "\"\<poliresa0th214fn\>\"", ",", "12424", ",", 
      "22424"}], "}"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dix", "[", "1", "]"}], "=", 
   RowBox[{"\"\<E:\\\\GRMHD\\\\Oleka0\\\\spectra\\\\\>\"", "<>", 
    RowBox[{"angles", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1"}], "]"}], "]"}], "<>", "\"\<\\\\\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"dir0", "=", 
     RowBox[{"\"\<E:\\\\GRMHD\\\\Oleka0\\\\spectra\\\\\>\"", "<>", 
      RowBox[{"angles", "[", 
       RowBox[{"[", 
        RowBox[{"o", ",", "1"}], "]"}], "]"}], "<>", "\"\<\\\\\>\""}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"fil", "=", 
     RowBox[{"dir0", "<>", "\"\<totspec.dat\>\""}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"FileExistsQ", "[", "fil", "]"}], ",", 
      RowBox[{
       RowBox[{"impx", "[", "o", "]"}], "=", 
       RowBox[{"Get", "[", "fil", "]"}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"impx", "[", "o", "]"}], "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Import", "[", 
           RowBox[{"dir0", "<>", 
            RowBox[{"angles", "[", 
             RowBox[{"[", 
              RowBox[{"o", ",", "2"}], "]"}], "]"}], "<>", 
            RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}],
            "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"fnum", ",", 
            RowBox[{"angles", "[", 
             RowBox[{"[", 
              RowBox[{"o", ",", "3"}], "]"}], "]"}], ",", 
            RowBox[{"angles", "[", 
             RowBox[{"[", 
              RowBox[{"o", ",", "4"}], "]"}], "]"}]}], "}"}]}], "]"}]}], ";", 
       RowBox[{"Put", "[", 
        RowBox[{
         RowBox[{"impx", "[", "o", "]"}], ",", "fil"}], "]"}]}]}], "]"}]}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"o", ",", 
     RowBox[{"Length", "[", "angles", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";", 
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"10", 
    RowBox[{
     RowBox[{"impx", "[", "1", "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"freqs", "=", 
   RowBox[{
    RowBox[{"impx", "[", "1", "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "All", ",", "2"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", 
  RowBox[{"impx", "[", "1", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.569690907836939*^9, 3.569690966090334*^9}, {
   3.569774735695792*^9, 3.5697747442758074`*^9}, {3.5699453708725615`*^9, 
   3.569945376472972*^9}, {3.5716818143727336`*^9, 3.5716818231503687`*^9}, {
   3.571681869406079*^9, 3.571681931254529*^9}, {3.5716820112457576`*^9, 
   3.571682068499137*^9}, {3.571704713746092*^9, 3.571704717186145*^9}, {
   3.5717059650103164`*^9, 3.5717060068209586`*^9}, 3.571706655735927*^9, 
   3.5717440259253645`*^9, {3.571744062178421*^9, 3.571744254966382*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"3", ",", "fr", ",", "th"}], "]"}], "=", 
      RowBox[{"Mean", "[", 
       RowBox[{
        RowBox[{"impx", "[", "th", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"4", ",", "fr", ",", "th"}], "]"}], "=", 
      RowBox[{"means", "[", 
       RowBox[{"3", ",", "fr", ",", "th"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"5", ",", "fr", ",", "th"}], "]"}], "=", 
      RowBox[{"means", "[", 
       RowBox[{"3", ",", "fr", ",", "th"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"6", ",", "fr", ",", "th"}], "]"}], "=", "90"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"th", ",", "1", ",", 
      RowBox[{"Length", "[", "angles", "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"fr", ",", "1", ",", 
      RowBox[{"Length", "[", 
       RowBox[{
        RowBox[{"impx", "[", "1", "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tmax", "=", 
    SuperscriptBox["10", "4."]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Papadakis", " ", "&"}], " ", "Lawrence", " ", 
    RowBox[{"(", "1993", ")"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"autovar", "[", 
    RowBox[{"typ_", ",", "mu_", ",", "fr_", ",", "th_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"mult", "=", "mu"}], ";", 
      RowBox[{"binned", "=", 
       FractionBox[
        RowBox[{
         RowBox[{"impx", "[", "th", "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "typ"}], "]"}], "]"}], 
        RowBox[{"means", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]]}], ";", 
      RowBox[{"ll", "=", 
       RowBox[{"Length", "[", "binned", "]"}]}], ";", 
      RowBox[{"me", "=", 
       RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"autovariance", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{"1", ";;", 
                RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], 
            ")"}], ".", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
             "me"}], ")"}]}], "ll"], ",", 
         RowBox[{"{", 
          RowBox[{"shi", ",", "0", ",", 
           RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"f11", "=", 
       RowBox[{"FourierDCT", "[", 
        RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
      RowBox[{"num", "=", 
       RowBox[{"Floor", "[", 
        FractionBox["ll", "2"], "]"}]}], ";", 
      RowBox[{"sur", "=", 
       RowBox[{
        FractionBox[
         SqrtBox["2"], 
         RowBox[{"2", "\[Pi]"}]], 
        SqrtBox["ll"], 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"f11", ",", "2"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"sur", ",", 
        RowBox[{"sur", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"timex", "=", 
       RowBox[{"10.", 
        RowBox[{"ll", "/", 
         RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
      RowBox[{"mint", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
      RowBox[{"maxt", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", 
      RowBox[{"nn", "=", 
       RowBox[{
        RowBox[{"Log", "[", 
         FractionBox["maxt", "mint"], "]"}], "/", 
        RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"tsides", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"mint", " ", 
          SuperscriptBox["mult", "i"]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tbins", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tsides", "[", 
            RowBox[{"[", "i", "]"}], "]"}], ",", 
           RowBox[{"tsides", "[", 
            RowBox[{"[", 
             RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tsizes", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tmeans", "=", 
       RowBox[{"Mean", "[", 
        RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"intergra", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"timex", ",", 
             RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"pergra", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"Exp", "[", 
              RowBox[{"intergra", "[", 
               RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"tx", ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
             RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
             RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        RowBox[{"res", "=", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"tmeans", ",", 
              FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
          "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"pergra", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{"NIntegrate", "[", 
           RowBox[{
            RowBox[{"intergra", "[", 
             RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"tx", ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
            RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
            RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
          RowBox[{"tsizes", "[", 
           RowBox[{"[", "i", "]"}], "]"}]], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"res", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"tmeans", ",", 
            RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}]}]}],
      ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"autorand", "[", 
     RowBox[{"ty_", ",", "mu_", ",", "kf_", ",", "rlist_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"typ", "=", "ty"}], ";", 
       RowBox[{"mult", "=", "mu"}], ";", 
       RowBox[{"k", "=", "kf"}], ";", 
       RowBox[{"binned", "=", "rlist"}], ";", 
       RowBox[{"ll", "=", 
        RowBox[{"Length", "[", "binned", "]"}]}], ";", 
       RowBox[{"merr", "=", 
        RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"autovariance", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{"1", ";;", 
                 RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "merr"}], 
             ")"}], ".", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
              "merr"}], ")"}]}], "ll"], ",", 
          RowBox[{"{", 
           RowBox[{"shi", ",", "0", ",", 
            RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"f11", "=", 
        RowBox[{"FourierDCT", "[", 
         RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
       RowBox[{"num", "=", 
        RowBox[{"Floor", "[", 
         FractionBox["ll", "2"], "]"}]}], ";", 
       RowBox[{"sur", "=", 
        RowBox[{
         FractionBox[
          SqrtBox["2"], 
          RowBox[{"2", "\[Pi]"}]], 
         SqrtBox["ll"], 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{"f11", ",", "2"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sur", ",", 
         RowBox[{"sur", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"timex", "=", 
        RowBox[{"10.", 
         RowBox[{"ll", "/", 
          RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
       RowBox[{"mint", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
       RowBox[{"maxt", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", 
       RowBox[{"nn", "=", 
        RowBox[{
         RowBox[{"Log", "[", 
          FractionBox["maxt", "mint"], "]"}], "/", 
         RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"tsides", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"mint", " ", 
           SuperscriptBox["mult", "i"]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tbins", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"tsides", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"tsides", "[", 
             RowBox[{"[", 
              RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tsizes", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tmeans", "=", 
        RowBox[{"Delete", "[", 
         RowBox[{
          RowBox[{"Mean", "[", 
           RowBox[{"Transpose", "[", "tbins", "]"}], "]"}], ",", 
          RowBox[{"-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"intergra", "=", 
        RowBox[{"Interpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"tra", "=", 
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"timex", ",", 
               RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}]}], "]"}], ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"pergra", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{"Exp", "[", 
               RowBox[{"intergra", "[", 
                RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"tx", ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
              RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
              RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
         RowBox[{"res", "=", 
          RowBox[{"Select", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"tmeans", ",", 
               FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
           "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"pergra", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            FractionBox[
             RowBox[{"NIntegrate", "[", 
              RowBox[{
               RowBox[{"intergra", "[", 
                RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"tx", ",", 
                 RowBox[{"tbins", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"tbins", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
               RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
               RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
             RowBox[{"tsizes", "[", 
              RowBox[{"[", "i", "]"}], "]"}]], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "nn"}], 
             RowBox[{"(*", 
              RowBox[{"+", "1"}], "*)"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"pergra", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"sel", "=", 
            RowBox[{"Select", "[", 
             RowBox[{"timex", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], "<", "#", "<", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "&"}]}], "]"}]}], 
           ";", 
           RowBox[{"inttime", "=", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Flatten", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}], ",", "sel", ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}]}], "}"}], "]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"intxx", "=", 
            RowBox[{
             RowBox[{"intergra", "[", 
              RowBox[{"Log", "[", "tx", "]"}], "]"}], "/.", 
             RowBox[{"tx", "\[Rule]", "inttime"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"deltax", "=", 
            RowBox[{"Differences", "[", "inttime", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{
               FractionBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"intxx", "[", 
                   RowBox[{"[", "kk", "]"}], "]"}], "+", 
                  RowBox[{"intxx", "[", 
                   RowBox[{"[", 
                    RowBox[{"kk", "+", "1"}], "]"}], "]"}]}], ")"}], "2"], 
               RowBox[{"deltax", "[", 
                RowBox[{"[", "kk", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"kk", ",", 
                RowBox[{
                 RowBox[{"Length", "[", "inttime", "]"}], "-", "1"}]}], 
               "}"}]}], "]"}], "/", 
            RowBox[{"tsizes", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nn"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"resy", "=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"tmeans", ",", 
             RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
         "]"}]}]}], ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"3", ",", "1.2", ",", "6"}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"lpl3", "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", "\"\<FourierDCT of autovariance\>\""}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"tofit3", "=", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"A", " ", 
         RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
      RowBox[{"FindFit", "[", 
       RowBox[{
        RowBox[{"Log", "[", "res", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"logpl3", "=", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{"tofit3", ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"res", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"res", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl3", ",", "logpl3"}], "]"}]}], 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5696898764220953`*^9, 3.569689887354763*^9}, {
  3.56972286613972*^9, 3.5697228844700017`*^9}, {3.569760446396062*^9, 
  3.5697604472910633`*^9}, {3.5697633264843206`*^9, 3.569763427478898*^9}, {
  3.5717043231150923`*^9, 3.571704348235478*^9}, {3.5717446001776857`*^9, 
  3.571744630620653*^9}, {3.5717479245377507`*^9, 3.571747951215661*^9}, {
  3.5720033316724052`*^9, 3.5720033327124214`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ttx", "=", 
   RowBox[{"TimeUsed", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "th", "]"}], ",", 
   RowBox[{"Dynamic", "[", "fr", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}], ",", 
   RowBox[{"Dynamic", "[", "o", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"50", ",", "tmax"}], "}"}], ",", "All"}], "}"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=."}], ";", 
  RowBox[{"fr", "=."}], ";", 
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";", 
  RowBox[{"types", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Flux\>\"", ",", "\"\<LP\>\"", ",", "\"\<EVPA\>\"", ",", 
     "\"\<CP\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{
      StyleBox[
       RowBox[{"autovar", "[", 
        RowBox[{"typ", ",", "3.0", ",", "fr", ",", "th"}], "]"}],
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox[";",
       FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resx", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"res", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"timex", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"sur", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tofit4", "=", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"A", " ", 
           RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
        RowBox[{"FindFit", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"res", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resx", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"#", ",", 
             RowBox[{
              FractionBox[
               RowBox[{
                RowBox[{"tofit4", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                RowBox[{"x", "\[Rule]", "#"}]}], 
               RowBox[{
                RowBox[{"tofit4", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                RowBox[{"x", "\[Rule]", 
                 RowBox[{
                  RowBox[{"res", "[", 
                   RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
              RowBox[{
               RowBox[{"res", "[", 
                RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
          RowBox[{"{", 
           RowBox[{"4", ",", "8"}], "}"}]}], ",", 
         RowBox[{"resx", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"resx", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"#", ",", 
              RowBox[{
               FractionBox[
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", "#"}]}], 
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", 
                  RowBox[{"res", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
               RowBox[{"res", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
           RowBox[{"{", 
            RowBox[{"4", ",", "8"}], "}"}]}], ",", "res", ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"timex", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"sur", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"interand", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"resx", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDfluxx", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"resx", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"autovar", "[", 
        RowBox[{"typ", ",", "1.2", ",", "fr", ",", "th"}], "]"}],
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox[";",
       FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", 
      RowBox[{"nux", "=", "22"}], ";", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"22", " ", "-", " ", 
         RowBox[{"1", "\[Sigma]"}]}], ";", " ", 
        RowBox[{"154", " ", "-", " ", 
         RowBox[{"2", "\[Sigma]"}]}], ";", " ", 
        RowBox[{"2592", " ", "-", " ", 
         RowBox[{"3", "\[Sigma]"}]}], ";", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"7", "/", 
           RowBox[{"(", 
            RowBox[{"1", "-", "#"}], ")"}]}], "&"}], "/@", 
         RowBox[{"{", 
          RowBox[{
          "0.682689492137086", ",", "0.954499736103642", ",", 
           "0.997300203936740"}], "}"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"nam", "=", 
       RowBox[{
        RowBox[{"dix", "[", "th", "]"}], "<>", "\"\<rand\>\"", "<>", 
        RowBox[{"ToString", "[", "fr", "]"}], "<>", "\"\<x\>\"", "<>", 
        RowBox[{"ToString", "[", "typ", "]"}], "<>", "\"\<x\>\"", "<>", 
        RowBox[{"ToString", "[", "nux", "]"}], "<>", "\"\<.dat\>\""}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"FileExistsQ", "[", "nam", "]"}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"tabresy", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"randx", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"RandomVariate", "[", 
                  RowBox[{
                   RowBox[{"NormalDistribution", "[", "]"}], ",", "10000"}], 
                  "]"}], "+", 
                 RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"RandomVariate", "[", 
                   RowBox[{
                    RowBox[{"NormalDistribution", "[", "]"}], ",", "10000"}], 
                   "]"}]}]}], ")"}], 
               SqrtBox[
                RowBox[{"Exp", "[", 
                 RowBox[{"interand", "[", 
                  RowBox[{"Log", "[", 
                   RowBox[{"100001", "/", 
                    RowBox[{"Range", "[", "10000", "]"}]}], "]"}], "]"}], 
                 "]"}]]}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"rsxx", "=", 
              RowBox[{"4.8", 
               RowBox[{"Re", "[", 
                RowBox[{"InverseFourier", "[", "randx", "]"}], "]"}]}]}], ";", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"+", "me"}], ";"}], 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"-", "for"}], " ", "formal", " ", "correspondence"}], 
               "*)"}], "*)"}], ";", "\[IndentingNewLine]", 
             RowBox[{"resy", "=", 
              StyleBox[
               RowBox[{"autorand", "[", 
                RowBox[{"typ", ",", "1.2", ",", "fr", ",", "rsxx"}], "]"}],
               FontColor->RGBColor[1, 0, 0]]}]}], ",", 
            RowBox[{"{", 
             RowBox[{"o", ",", "nux"}], "}"}]}], "]"}]}], ";", 
         RowBox[{"Put", "[", 
          RowBox[{
           RowBox[{"tabresy", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", "nam"}], 
          "]"}]}], ",", 
        RowBox[{
         RowBox[{"tabresy", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
         RowBox[{"Get", "[", "nam", "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ress", "[", "aa", "]"}], "=", 
         RowBox[{
          RowBox[{"tabresy", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "[", 
          RowBox[{"[", "aa", "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"aa", ",", "nux"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmean", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Exp", "[", 
        FractionBox[
         RowBox[{"Total", "[", 
          RowBox[{"Log", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"ress", "[", "i", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}], "]"}], "nux"],
         "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFrandmean", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"ressmean", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Green", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDflux", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0., 0., 1.]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"res", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}], ",", 
         RowBox[{"Epilog", "\[Rule]", "\[IndentingNewLine]", 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"types", "[", 
                RowBox[{"[", 
                 RowBox[{"typ", "-", "2"}], "]"}], "]"}], "<>", 
               "\"\< at \>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Floor", "[", 
                 RowBox[{"freqs", "[", 
                  RowBox[{"[", "fr", "]"}], "]"}], "]"}], "]"}], "<>", 
               "\"\<GHz\>\""}], ",", "18", ",", "Bold"}], "]"}], ",", 
            RowBox[{"Scaled", "[", 
             RowBox[{"{", 
              RowBox[{"0.3", ",", "0.8"}], "}"}], "]"}]}], "]"}]}]}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resstot", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ress", "[", "i", "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"resst", "=", 
       RowBox[{
        RowBox[{"ress", "[", "1", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmax", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"resst", ",", 
          RowBox[{"Mean", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"RankedMax", "[", 
                RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"RankedMax", "[", 
                RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}]}], "}"}], 
           "]"}]}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmin", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"resst", ",", 
          RowBox[{"Mean", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"RankedMin", "[", 
                RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"RankedMin", "[", 
                RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}]}], "}"}], 
           "]"}]}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFmin", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"ressmin", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Dotted"}], 
           "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFmax", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"ressmax", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"typ", ",", "3", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"th", ",", "1", ",", 
     RowBox[{"Length", "[", "angles", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Computed in \>\"", ",", 
    RowBox[{
     RowBox[{"TimeUsed", "[", "]"}], "-", "ttx"}], ",", "\"\<s\>\""}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"367", "s", " ", "for", " ", "1", "\[Sigma]"}], " ", "\[Implies]",
     " ", 
    RowBox[{
     RowBox[{"2218", "s", 
      RowBox[{"(", 
       RowBox[{"37", "min"}], ")"}], " ", "for", " ", "2", "\[Sigma]"}], " ", 
     "\[Implies]", " ", 
     RowBox[{"36121", "s", 
      RowBox[{"(", 
       RowBox[{"10", "hrs"}], ")"}], " ", "for", " ", "3", "\[Sigma]"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Dimensions", "[", 
     RowBox[{"tabresy", "[", 
      RowBox[{"3", ",", "3"}], "]"}], "]"}], "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"Put", "[", 
       RowBox[{
        RowBox[{"tabresy", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
        RowBox[{"nam", "=", 
         RowBox[{
          RowBox[{"dix", "[", "th", "]"}], "<>", "\"\<rand\>\"", "<>", 
          RowBox[{"ToString", "[", "fr", "]"}], "<>", "\"\<x\>\"", "<>", 
          RowBox[{"ToString", "[", "typ", "]"}], "<>", "\"\<x\>\"", "<>", 
          RowBox[{"ToString", "[", "nux", "]"}], "<>", "\"\<.dat\>\""}]}]}], 
       "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"typ", ",", "3", ",", "6"}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.568658690181983*^9, 3.5686587401332707`*^9}, {
   3.5686588111757956`*^9, 3.5686588548880725`*^9}, {3.5686588922033377`*^9, 
   3.568658925977397*^9}, {3.5686589703906755`*^9, 3.5686589774106874`*^9}, {
   3.568672919401613*^9, 3.5686729589816833`*^9}, {3.5686734755153365`*^9, 
   3.5686734758803368`*^9}, 3.568673902517336*^9, {3.5686740475725393`*^9, 
   3.5686740736925755`*^9}, {3.5686741992477517`*^9, 3.568674207342763*^9}, {
   3.5686743702339907`*^9, 3.568674420479061*^9}, {3.5686746579543934`*^9, 
   3.5686746640944023`*^9}, {3.5686747825547867`*^9, 
   3.5686747836467886`*^9}, {3.568675093166932*^9, 3.5686751107637634`*^9}, {
   3.5686751638818564`*^9, 3.5686751860962954`*^9}, {3.5686752638780317`*^9, 
   3.5686752932372837`*^9}, 3.568676352200344*^9, {3.568676425036872*^9, 
   3.5686764268152747`*^9}, {3.5686765814583464`*^9, 
   3.5686765815051465`*^9}, {3.568676612564801*^9, 3.5686766292880306`*^9}, {
   3.5686768069879427`*^9, 3.568676807112743*^9}, {3.568676887780484*^9, 
   3.5686768878896847`*^9}, {3.5686769802106466`*^9, 
   3.5686770449975605`*^9}, {3.568677177254593*^9, 3.5686771780189943`*^9}, {
   3.5686772390463014`*^9, 3.5686772393739023`*^9}, {3.568677286049184*^9, 
   3.5686773642833214`*^9}, {3.568677400110385*^9, 3.568677400484785*^9}, {
   3.568677507665374*^9, 3.5686775082269745`*^9}, {3.5686775809855022`*^9, 
   3.568677667160054*^9}, {3.568677724162554*^9, 3.568677768326232*^9}, {
   3.5686784189103737`*^9, 3.5686784731984696`*^9}, {3.568678528562967*^9, 
   3.5686785340073767`*^9}, {3.568678600557093*^9, 3.5686786208995285`*^9}, {
   3.5686786550323887`*^9, 3.5686786624268017`*^9}, {3.568678748679353*^9, 
   3.5686787518617587`*^9}, {3.568678943851296*^9, 3.568678944178897*^9}, {
   3.568679095826763*^9, 3.5686790961543636`*^9}, 3.5687143742988043`*^9, {
   3.568718293597542*^9, 3.568718293925143*^9}, {3.568733412817721*^9, 
   3.568733427575347*^9}, {3.5687335444663525`*^9, 3.568733613090873*^9}, {
   3.568733746627107*^9, 3.5687337937547903`*^9}, {3.5687342807418456`*^9, 
   3.5687343666823964`*^9}, {3.5687344259001007`*^9, 
   3.5687344394877243`*^9}, {3.568734477239791*^9, 3.5687345461451116`*^9}, {
   3.5687345797823715`*^9, 3.568734589844389*^9}, {3.5687346756289396`*^9, 
   3.568734677563343*^9}, {3.568734894974286*^9, 3.568734922929535*^9}, {
   3.5687349655332103`*^9, 3.5687349764844294`*^9}, {3.568735012192892*^9, 
   3.56873502830772*^9}, {3.568735147273529*^9, 3.568735195914415*^9}, {
   3.568735337110263*^9, 3.568735339029066*^9}, {3.568735384331546*^9, 
   3.568735388949154*^9}, {3.5687354326448307`*^9, 3.5687354327852306`*^9}, {
   3.568735491519334*^9, 3.568735505184958*^9}, {3.5687364997865577`*^9, 
   3.568736499896558*^9}, {3.568743415518503*^9, 3.568743415643503*^9}, {
   3.568743713589615*^9, 3.5687437136364155`*^9}, {3.5687441249311376`*^9, 
   3.5687441349005547`*^9}, {3.5687456117645607`*^9, 3.568745675733219*^9}, {
   3.568745710904231*^9, 3.5687457803412027`*^9}, {3.568745836047389*^9, 
   3.5687458519833*^9}, {3.568746269593191*^9, 3.5687463055824547`*^9}, {
   3.568746362210554*^9, 3.5687463633961563`*^9}, {3.5687464472712975`*^9, 
   3.5687464474012976`*^9}, {3.568746524051405*^9, 3.5687465241114054`*^9}, {
   3.5687465874514937`*^9, 3.568746587516494*^9}, {3.5687466340115585`*^9, 
   3.5687466340965595`*^9}, {3.5687466830126286`*^9, 3.5687466830926285`*^9}, 
   3.5687467437727137`*^9, {3.568746883758145*^9, 3.5687468841949453`*^9}, {
   3.568746932711031*^9, 3.568746932867031*^9}, {3.5687483065115275`*^9, 
   3.5687483066051273`*^9}, {3.568748356905614*^9, 3.5687483570772142`*^9}, {
   3.5687484849978333`*^9, 3.5687484851070337`*^9}, {3.5687486793365183`*^9, 
   3.5687487039165525`*^9}, 3.5687487503066173`*^9, {3.5687487915866747`*^9, 
   3.568748868616783*^9}, 3.568748930046869*^9, {3.5687648297268953`*^9, 
   3.568764830431896*^9}, {3.5687651183353004`*^9, 3.5687651217753053`*^9}, {
   3.568765172395376*^9, 3.568765172775377*^9}, {3.5687652432954755`*^9, 
   3.5687652504354854`*^9}, {3.5687653239655886`*^9, 
   3.5687654154007163`*^9}, {3.5687654918858232`*^9, 3.568765522375866*^9}, {
   3.568765635131024*^9, 3.5687656600910587`*^9}, {3.5687657746762195`*^9, 
   3.568765779146226*^9}, {3.5687658126242733`*^9, 3.5687658187242823`*^9}, {
   3.5687659304504385`*^9, 3.5687659560604744`*^9}, {3.5687660151155567`*^9, 
   3.5687660156055574`*^9}, {3.5687660518306084`*^9, 3.56876608879066*^9}, {
   3.568766907469807*^9, 3.5687669171198206`*^9}, {3.5687669640798864`*^9, 
   3.5687669661198893`*^9}, {3.5687675173867655`*^9, 
   3.5687675633756466`*^9}, {3.568821997140112*^9, 3.568822020852154*^9}, {
   3.5688220594154215`*^9, 3.568822062551027*^9}, {3.568822107572706*^9, 
   3.568822116667522*^9}, {3.568822153592787*^9, 3.568822194090458*^9}, {
   3.5688227530290003`*^9, 3.5688227588010106`*^9}, {3.5688228373783484`*^9, 
   3.5688228857228336`*^9}, {3.5688229377967253`*^9, 
   3.5688229695895805`*^9}, {3.5688230020376377`*^9, 
   3.5688230069828463`*^9}, {3.56882307145776*^9, 3.568823184807559*^9}, {
   3.5688232887817416`*^9, 3.5688233510570507`*^9}, {3.568823574855044*^9, 
   3.5688235769298477`*^9}, {3.568823624853132*^9, 3.568823626522335*^9}, {
   3.568823907307228*^9, 3.568823937727281*^9}, {3.5688242497905293`*^9, 
   3.5688242498997297`*^9}, {3.5688249598546658`*^9, 3.568824963988673*^9}, {
   3.5688249955007286`*^9, 3.568824998527134*^9}, {3.568825583173684*^9, 
   3.5688256067765255`*^9}, {3.5688257669956055`*^9, 
   3.5688257915968485`*^9}, {3.5688265201971283`*^9, 3.568826526140739*^9}, {
   3.56882670801742*^9, 3.568826716082634*^9}, {3.5688267536163*^9, 
   3.568826758140308*^9}, {3.5696898448366103`*^9, 3.569689848671669*^9}, {
   3.5696899318429465`*^9, 3.569689935898009*^9}, {3.5696900532648115`*^9, 
   3.5696901073531427`*^9}, {3.569690290777461*^9, 3.569690331808091*^9}, {
   3.5696906005022182`*^9, 3.569690621590042*^9}, 3.5696906748008595`*^9, {
   3.5696911680134354`*^9, 3.5696911768160706`*^9}, {3.5696914070181074`*^9, 
   3.5696914071706095`*^9}, {3.5696914461662083`*^9, 
   3.5696914473587265`*^9}, {3.569691554536373*^9, 3.56969156347651*^9}, {
   3.569691629262521*^9, 3.5696916591204796`*^9}, {3.569691693988515*^9, 
   3.5696917502993803`*^9}, {3.5696918200279512`*^9, 
   3.5696918611985836`*^9}, {3.569696129506508*^9, 3.569696201117608*^9}, {
   3.5696967610487103`*^9, 3.569696820434623*^9}, {3.5696968508025894`*^9, 
   3.5696968900581923`*^9}, {3.5697229699763155`*^9, 
   3.5697229710588317`*^9}, {3.569723191150887*^9, 3.569723208733657*^9}, {
   3.569723547730029*^9, 3.5697235478750315`*^9}, {3.5697602313657613`*^9, 
   3.569760234820766*^9}, {3.56976027328082*^9, 3.569760307765868*^9}, 
   3.5697630504886355`*^9, {3.569945540377632*^9, 3.5699455435326366`*^9}, {
   3.569946117072834*^9, 3.569946117228834*^9}, {3.5699465864796576`*^9, 
   3.569946614060506*^9}, {3.5699488662442627`*^9, 3.569948885927105*^9}, {
   3.5699803386893177`*^9, 3.5699803418405232`*^9}, {3.570016662082553*^9, 
   3.570016673626573*^9}, {3.571705919857123*^9, 3.5717059255497103`*^9}, {
   3.571744660763616*^9, 3.5717446715262814`*^9}, {3.57174546117591*^9, 
   3.5717455542208405`*^9}, {3.5717456780862427`*^9, 
   3.5717456782512455`*^9}, {3.5717458119743*^9, 3.571745814396837*^9}, {
   3.5717458885654764`*^9, 3.5717458951955786`*^9}, {3.5717463888046618`*^9, 
   3.571746395032257*^9}, {3.5717476551651134`*^9, 3.5717476672627993`*^9}, {
   3.5717477724744153`*^9, 3.571747772515416*^9}, {3.5717479705434575`*^9, 
   3.5717479706109586`*^9}, {3.571748011251583*^9, 3.571748012111596*^9}, {
   3.5717483015835423`*^9, 3.5717483040085793`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"th", "=", "1"}], ";", 
  RowBox[{"grgr", "=", 
   RowBox[{"GraphicsGrid", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"sh", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Show", "[", 
        RowBox[{"{", 
         StyleBox[
          RowBox[{
           RowBox[{"PSDflux", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
           RowBox[{"PSDFmax", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
           RowBox[{"PSDFrandmean", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
           RowBox[{"PSDfluxx", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}],
          FontColor->RGBColor[0, 0, 1]], 
         StyleBox["}",
          FontColor->RGBColor[0, 0, 1]]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"typ", ",", "3", ",", "6"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"fr", ",", "1", ",", "3"}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"th", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.571747688595627*^9, 3.57174769464322*^9}, {
  3.5717479804986105`*^9, 3.5717479840736656`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"th", "=", "1"}], ";", 
  RowBox[{"grgr", "=", 
   RowBox[{"GraphicsGrid", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"sh", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Show", "[", 
        RowBox[{"{", 
         StyleBox[
          RowBox[{
           RowBox[{"PSDflux", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
           RowBox[{"PSDFmax", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
           RowBox[{"PSDFrandmean", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
           RowBox[{"PSDfluxx", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}],
          FontColor->RGBColor[0, 0, 1]], 
         StyleBox["}",
          FontColor->RGBColor[0, 0, 1]]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"typ", ",", "3", ",", "6"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}],
     "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"th", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.568765709706128*^9, 3.5687657570961947`*^9}, {
   3.568766150610747*^9, 3.5687661926308055`*^9}, {3.5687676090213265`*^9, 
   3.5687676147465367`*^9}, {3.5687677042756658`*^9, 
   3.5687677075856705`*^9}, {3.568826535828356*^9, 3.568826536140356*^9}, {
   3.5689450632113714`*^9, 3.5689450639601727`*^9}, 3.5696928359807386`*^9, {
   3.56969305541879*^9, 3.569693097186931*^9}, {3.569760309670871*^9, 
   3.5697603130358753`*^9}, {3.569760404331003*^9, 3.5697604079010086`*^9}, {
   3.5697607003894196`*^9, 3.5697607614745045`*^9}, {3.5717061837186756`*^9, 
   3.5717061838786783`*^9}, {3.57174471312192*^9, 3.5717447132344217`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"lk", "=", 
   RowBox[{"Length", "[", "resst", "]"}]}], ";", 
  RowBox[{"lx", "=", 
   RowBox[{"Length", "[", 
    RowBox[{"resx", "[", 
     RowBox[{"3", ",", "3", ",", "1"}], "]"}], "]"}]}], ";", 
  RowBox[{"mx", "=", 
   RowBox[{"1", "/", "30."}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"shift", "[", "1", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lk"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"shix", "[", "1", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lx"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"shift", "[", "2", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"1", "/", "mx"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lk"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"shix", "[", "2", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"1", "/", "mx"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lx"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"shift", "[", "3", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "mx"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lk"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"shix", "[", "3", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "mx"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lx"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"fllab", "[", "3", "]"}], ",", 
      RowBox[{"fllab", "[", "4", "]"}], ",", 
      RowBox[{"fllab", "[", "5", "]"}], ",", 
      RowBox[{"fllab", "[", "6", "]"}]}], "}"}], "=", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Flux at \>\"", ",", "\"\<LP at \>\"", ",", "\"\<EVPA at \>\"", ",", 
      "\"\<CP at \>\""}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"frlab", "[", "1", "]"}], ",", 
      RowBox[{"frlab", "[", "2", "]"}], ",", 
      RowBox[{"frlab", "[", "3", "]"}], ",", 
      RowBox[{"frlab", "[", "6", "]"}], ",", 
      RowBox[{"frlab", "[", "9", "]"}]}], "}"}], "=", 
    RowBox[{"{", 
     RowBox[{
     "\"\<22GHz\>\"", ",", "\"\<43GHz\>\"", ",", "\"\<87GHz\>\"", ",", 
      "\"\<230GHz\>\"", ",", "\"\<857GHz\>\""}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mysize", "=", "16"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"figvx", "=", 
  RowBox[{"Figure", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.21", ",", "0.76"}], "}"}], ",", "\"\<Top - face-on\>\"", 
        ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.21", ",", "0.74"}], "}"}], ",", 
        "\"\<Middle - general inclination\>\"", ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.21", ",", "0.72"}], "}"}], ",", 
        "\"\<Bottom - edge-on\>\"", ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Multipanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "3"}], "}"}], ",", 
        RowBox[{"XPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Log10", "[", "20", "]"}], ",", 
           RowBox[{"Log10", "[", "tmax", "]"}]}], "}"}]}], ",", 
        RowBox[{"YPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", 
              SuperscriptBox["10", 
               RowBox[{"-", "6"}]], "]"}], ",", 
             RowBox[{"Log10", "[", "10", "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", 
              SuperscriptBox["10", 
               RowBox[{"-", "3"}]], "]"}], ",", 
             RowBox[{"Log10", "[", "300", "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", "0.1", "]"}], ",", 
             RowBox[{"Log10", "[", 
              SuperscriptBox["10", "4"], "]"}]}], "}"}]}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
        RowBox[{"XFrameLabels", "\[Rule]", 
         RowBox[{"{", "\"\<Period T [M]\>\"", "}"}]}], ",", 
        RowBox[{"BufferL", "\[Rule]", "6"}], ",", 
        RowBox[{"YFrameLabels", "\[Rule]", "\"\<Periodogram   I(T)\>\""}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"YFrameTicks", "\[Rule]", 
         RowBox[{"LogTicks", "[", 
          RowBox[{
           RowBox[{"-", "10"}], ",", "10"}], "]"}]}], ",", 
        RowBox[{"XFrameTicks", "\[Rule]", 
         RowBox[{"LogTicks", "[", 
          RowBox[{
           RowBox[{"-", "10"}], ",", "10", ",", 
           RowBox[{"TickLabelStep", "\[Rule]", "1"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Background", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PanelLetterCorner", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
        RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SetOptions", "[", 
       RowBox[{"DataSymbol", ",", 
        RowBox[{"SymbolSize", "\[Rule]", "0.001"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SetOptions", "[", 
       RowBox[{"DataLine", ",", 
        RowBox[{"Thickness", "\[Rule]", "1.5"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SetOptions", "[", 
       RowBox[{"DataValues", ",", 
        RowBox[{"AxisScaling", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Log", ",", "Log"}], "}"}]}]}], "]"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FigurePanel", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"typ", "-", "2"}], ",", "fr"}], 
             RowBox[{"(*", 
              RowBox[{"/", "3"}], "*)"}], "}"}], ",", 
            RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"pan", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}], "=", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"DataPlot", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"shift", "[", "th", "]"}], 
                   RowBox[{"res", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                  RowBox[{"DataLine", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"Color", "\[Rule]", "Black"}], "}"}]}]}], "]"}], 
                ",", 
                RowBox[{"DataPlot", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"shift", "[", "th", "]"}], 
                   RowBox[{"ressmean", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                  RowBox[{"DataLine", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Color", "\[Rule]", "Black"}], ",", 
                    RowBox[{"Dashing", "\[Rule]", "7"}]}], "}"}]}]}], "]"}], 
                ",", 
                RowBox[{"DataPlot", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"shift", "[", "th", "]"}], 
                   RowBox[{"ressmax", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                  RowBox[{"DataLine", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"Color", "\[Rule]", "Red"}], "}"}]}]}], "]"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"DataPlot", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"shix", "[", "th", "]"}], 
                   RowBox[{"resx", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                  RowBox[{"DataLine", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Color", "\[Rule]", "Green"}], ",", 
                    RowBox[{"Dashing", "\[Rule]", "5"}]}], "}"}]}]}], "]"}]}],
                "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"th", ",", "1"}], "}"}]}], "]"}]}], ";", 
           RowBox[{
            RowBox[{"lab", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}], "=", 
            RowBox[{
             RowBox[{"fllab", "[", "typ", "]"}], "<>", 
             RowBox[{"frlab", "[", "fr", "]"}]}]}], ";", 
           RowBox[{
            RowBox[{"sclab", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}], "=", 
            RowBox[{"ScaledLabel", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0.18", ",", "0.89"}], "}"}], ",", 
              RowBox[{"lab", "[", 
               RowBox[{"typ", ",", "fr"}], "]"}], ",", 
              RowBox[{"Color", "\[Rule]", "Black"}], ",", 
              RowBox[{"Background", "\[Rule]", "White"}], ",", 
              RowBox[{"FontSize", "\[Rule]", 
               RowBox[{"mysize", "-", "1"}]}], ",", 
              RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}]}], ";", 
           RowBox[{"pan", "[", 
            RowBox[{"typ", ",", "fr"}], "]"}]}], ",", 
          RowBox[{"sclab", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"typ", ",", "3", ",", "5"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"fr", ",", "1", ",", "3"}], 
         RowBox[{"(*", 
          RowBox[{"kmin", ",", "kmax", ",", "kstep"}], "*)"}], "}"}]}], 
       "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.07"}], ",", "1.01"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.07"}], ",", "1.01"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1300", ",", "800"}], "}"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.571746531406852*^9, 3.5717466100180593`*^9}, {
  3.5717485672176228`*^9, 3.5717485898679705`*^9}, {3.5717486209459476`*^9, 
  3.5717486357311745`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\accretion\\\\! 2013 1spring UMD\\\\Long time \
variability\\\\spin0_low_f.eps\>\"", ",", "figvx"}], "]"}]], "Input",
 CellChangeTimes->{{3.5717485568774633`*^9, 3.5717485570724664`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\accretion\\\\! 2013 1spring UMD\\\\Long time \
variability\\\\spin0_high_f.eps\>\"", ",", "figvx"}], "]"}]], "Input",
 CellChangeTimes->{{3.571748464728548*^9, 3.5717485044116573`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Comparison of periodogram for fast light vs. correct radiative transfer - \
substantial differences found!\
\>", "Subsection",
 CellChangeTimes->{{3.571681430533337*^9, 3.5716814584212656`*^9}, {
  3.571706641843214*^9, 3.5717066523858757`*^9}}],

Cell[BoxData[{
 RowBox[{"Dynamic", "[", "fnum", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"angles", "=", 
   RowBox[{"{", 
    RowBox[{"\"\<th248lo\>\"", ",", "\"\<th248fast\>\""}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dix", "[", "1", "]"}], "=", 
   RowBox[{"\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\\>\"", "<>", 
    RowBox[{"angles", "[", 
     RowBox[{"[", "1", "]"}], "]"}], "<>", "\"\<\\\\\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dix", "[", "2", "]"}], "=", 
   RowBox[{"\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\\>\"", "<>", 
    RowBox[{"angles", "[", 
     RowBox[{"[", "2", "]"}], "]"}], "<>", "\"\<\\\\\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"dir0", "=", 
     RowBox[{"\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\\>\"", "<>", 
      RowBox[{"angles", "[", 
       RowBox[{"[", "o", "]"}], "]"}], "<>", "\"\<\\\\\>\""}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"fil", "=", 
     RowBox[{"dir0", "<>", "\"\<totspec.dat\>\""}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"FileExistsQ", "[", "fil", "]"}], ",", 
      RowBox[{
       RowBox[{"impx", "[", "o", "]"}], "=", 
       RowBox[{"Get", "[", "fil", "]"}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"impx", "[", "o", "]"}], "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Import", "[", 
           RowBox[{"dir0", "<>", "\"\<poliresa93.75th248fn\>\"", "<>", 
            RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}],
            "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"fnum", ",", "2000", ",", "6999"}], "}"}]}], "]"}]}], ";", 
       RowBox[{"Put", "[", 
        RowBox[{
         RowBox[{"impx", "[", "o", "]"}], ",", "fil"}], "]"}]}]}], "]"}]}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"o", ",", 
     RowBox[{"Length", "[", "angles", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";", 
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"4", 
    RowBox[{
     RowBox[{"impx", "[", "1", "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"freqs", "=", 
   RowBox[{
    RowBox[{"impx", "[", "1", "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "All", ",", "2"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", 
  RowBox[{"impx", "[", "1", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", 
  RowBox[{"impx", "[", "2", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.569690907836939*^9, 3.569690966090334*^9}, {
   3.569774735695792*^9, 3.5697747442758074`*^9}, {3.5699453708725615`*^9, 
   3.569945376472972*^9}, {3.5716818143727336`*^9, 3.5716818231503687`*^9}, {
   3.571681869406079*^9, 3.571681931254529*^9}, {3.5716820112457576`*^9, 
   3.571682068499137*^9}, {3.571704713746092*^9, 3.571704717186145*^9}, {
   3.5717059650103164`*^9, 3.5717060068209586`*^9}, 3.571706655735927*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"3", ",", "fr", ",", "th"}], "]"}], "=", 
      RowBox[{"Mean", "[", 
       RowBox[{
        RowBox[{"impx", "[", "th", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"4", ",", "fr", ",", "th"}], "]"}], "=", 
      RowBox[{"means", "[", 
       RowBox[{"3", ",", "fr", ",", "th"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"5", ",", "fr", ",", "th"}], "]"}], "=", 
      RowBox[{"means", "[", 
       RowBox[{"3", ",", "fr", ",", "th"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"6", ",", "fr", ",", "th"}], "]"}], "=", "90"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"th", ",", "1", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmax", "=", 
   SuperscriptBox["10", "3.2"]}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Papadakis", " ", "&"}], " ", "Lawrence", " ", 
    RowBox[{"(", "1993", ")"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"autovar", "[", 
    RowBox[{"typ_", ",", "mu_", ",", "fr_", ",", "th_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"mult", "=", "mu"}], ";", 
      RowBox[{"binned", "=", 
       FractionBox[
        RowBox[{
         RowBox[{"impx", "[", "th", "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "typ"}], "]"}], "]"}], 
        RowBox[{"means", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]]}], ";", 
      RowBox[{"ll", "=", 
       RowBox[{"Length", "[", "binned", "]"}]}], ";", 
      RowBox[{"me", "=", 
       RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"autovariance", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{"1", ";;", 
                RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], 
            ")"}], ".", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
             "me"}], ")"}]}], "ll"], ",", 
         RowBox[{"{", 
          RowBox[{"shi", ",", "0", ",", 
           RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"f11", "=", 
       RowBox[{"FourierDCT", "[", 
        RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
      RowBox[{"num", "=", 
       RowBox[{"Floor", "[", 
        FractionBox["ll", "2"], "]"}]}], ";", 
      RowBox[{"sur", "=", 
       RowBox[{
        FractionBox[
         SqrtBox["2"], 
         RowBox[{"2", "\[Pi]"}]], 
        SqrtBox["ll"], 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"f11", ",", "2"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"sur", ",", 
        RowBox[{"sur", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"timex", "=", 
       RowBox[{"4.", 
        RowBox[{"ll", "/", 
         RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
      RowBox[{"mint", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
      RowBox[{"maxt", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", 
      RowBox[{"nn", "=", 
       RowBox[{
        RowBox[{"Log", "[", 
         FractionBox["maxt", "mint"], "]"}], "/", 
        RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"tsides", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"mint", " ", 
          SuperscriptBox["mult", "i"]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tbins", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tsides", "[", 
            RowBox[{"[", "i", "]"}], "]"}], ",", 
           RowBox[{"tsides", "[", 
            RowBox[{"[", 
             RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tsizes", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tmeans", "=", 
       RowBox[{"Mean", "[", 
        RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"intergra", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"timex", ",", 
             RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"pergra", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"Exp", "[", 
              RowBox[{"intergra", "[", 
               RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"tx", ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
             RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
             RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        RowBox[{"res", "=", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"tmeans", ",", 
              FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
          "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"pergra", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{"NIntegrate", "[", 
           RowBox[{
            RowBox[{"intergra", "[", 
             RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"tx", ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
            RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
            RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
          RowBox[{"tsizes", "[", 
           RowBox[{"[", "i", "]"}], "]"}]], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"res", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"tmeans", ",", 
            RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}]}]}],
      ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"autorand", "[", 
     RowBox[{"ty_", ",", "mu_", ",", "kf_", ",", "rlist_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"typ", "=", "ty"}], ";", 
       RowBox[{"mult", "=", "mu"}], ";", 
       RowBox[{"k", "=", "kf"}], ";", 
       RowBox[{"binned", "=", "rlist"}], ";", 
       RowBox[{"ll", "=", 
        RowBox[{"Length", "[", "binned", "]"}]}], ";", 
       RowBox[{"merr", "=", 
        RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"autovariance", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{"1", ";;", 
                 RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "merr"}], 
             ")"}], ".", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
              "merr"}], ")"}]}], "ll"], ",", 
          RowBox[{"{", 
           RowBox[{"shi", ",", "0", ",", 
            RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"f11", "=", 
        RowBox[{"FourierDCT", "[", 
         RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
       RowBox[{"num", "=", 
        RowBox[{"Floor", "[", 
         FractionBox["ll", "2"], "]"}]}], ";", 
       RowBox[{"sur", "=", 
        RowBox[{
         FractionBox[
          SqrtBox["2"], 
          RowBox[{"2", "\[Pi]"}]], 
         SqrtBox["ll"], 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{"f11", ",", "2"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sur", ",", 
         RowBox[{"sur", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"timex", "=", 
        RowBox[{"4.", 
         RowBox[{"ll", "/", 
          RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
       RowBox[{"mint", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
       RowBox[{"maxt", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", 
       RowBox[{"nn", "=", 
        RowBox[{
         RowBox[{"Log", "[", 
          FractionBox["maxt", "mint"], "]"}], "/", 
         RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"tsides", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"mint", " ", 
           SuperscriptBox["mult", "i"]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tbins", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"tsides", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"tsides", "[", 
             RowBox[{"[", 
              RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tsizes", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tmeans", "=", 
        RowBox[{"Delete", "[", 
         RowBox[{
          RowBox[{"Mean", "[", 
           RowBox[{"Transpose", "[", "tbins", "]"}], "]"}], ",", 
          RowBox[{"-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"intergra", "=", 
        RowBox[{"Interpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"tra", "=", 
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"timex", ",", 
               RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}]}], "]"}], ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"pergra", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{"Exp", "[", 
               RowBox[{"intergra", "[", 
                RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"tx", ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
              RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
              RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
         RowBox[{"res", "=", 
          RowBox[{"Select", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"tmeans", ",", 
               FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
           "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"pergra", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            FractionBox[
             RowBox[{"NIntegrate", "[", 
              RowBox[{
               RowBox[{"intergra", "[", 
                RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"tx", ",", 
                 RowBox[{"tbins", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"tbins", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
               RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
               RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
             RowBox[{"tsizes", "[", 
              RowBox[{"[", "i", "]"}], "]"}]], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "nn"}], 
             RowBox[{"(*", 
              RowBox[{"+", "1"}], "*)"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"pergra", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"sel", "=", 
            RowBox[{"Select", "[", 
             RowBox[{"timex", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], "<", "#", "<", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "&"}]}], "]"}]}], 
           ";", 
           RowBox[{"inttime", "=", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Flatten", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}], ",", "sel", ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}]}], "}"}], "]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"intxx", "=", 
            RowBox[{
             RowBox[{"intergra", "[", 
              RowBox[{"Log", "[", "tx", "]"}], "]"}], "/.", 
             RowBox[{"tx", "\[Rule]", "inttime"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"deltax", "=", 
            RowBox[{"Differences", "[", "inttime", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{
               FractionBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"intxx", "[", 
                   RowBox[{"[", "kk", "]"}], "]"}], "+", 
                  RowBox[{"intxx", "[", 
                   RowBox[{"[", 
                    RowBox[{"kk", "+", "1"}], "]"}], "]"}]}], ")"}], "2"], 
               RowBox[{"deltax", "[", 
                RowBox[{"[", "kk", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"kk", ",", 
                RowBox[{
                 RowBox[{"Length", "[", "inttime", "]"}], "-", "1"}]}], 
               "}"}]}], "]"}], "/", 
            RowBox[{"tsizes", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nn"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"resy", "=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"tmeans", ",", 
             RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
         "]"}]}]}], ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"3", ",", "1.2", ",", "6"}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"lpl3", "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", "\"\<FourierDCT of autovariance\>\""}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"tofit3", "=", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"A", " ", 
         RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
      RowBox[{"FindFit", "[", 
       RowBox[{
        RowBox[{"Log", "[", "res", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"logpl3", "=", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{"tofit3", ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"res", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"res", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl3", ",", "logpl3"}], "]"}]}], 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5696898764220953`*^9, 3.569689887354763*^9}, {
  3.56972286613972*^9, 3.5697228844700017`*^9}, {3.569760446396062*^9, 
  3.5697604472910633`*^9}, {3.5697633264843206`*^9, 3.569763427478898*^9}, {
  3.5717043231150923`*^9, 3.571704348235478*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ttx", "=", 
   RowBox[{"TimeUsed", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "th", "]"}], ",", 
   RowBox[{"Dynamic", "[", "fr", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}], ",", 
   RowBox[{"Dynamic", "[", "o", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"20", ",", "1500"}], "}"}], ",", "All"}], "}"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=."}], ";", 
  RowBox[{"fr", "=."}], ";", 
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";", 
  RowBox[{"types", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Flux\>\"", ",", "\"\<LP\>\"", ",", "\"\<EVPA\>\"", ",", 
     "\"\<CP\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{
      StyleBox[
       RowBox[{"autovar", "[", 
        RowBox[{"typ", ",", "3.0", ",", "fr", ",", "th"}], "]"}],
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox[";",
       FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resx", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"res", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"timex", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"sur", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tofit4", "=", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"A", " ", 
           RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
        RowBox[{"FindFit", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"res", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resx", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"#", ",", 
             RowBox[{
              FractionBox[
               RowBox[{
                RowBox[{"tofit4", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                RowBox[{"x", "\[Rule]", "#"}]}], 
               RowBox[{
                RowBox[{"tofit4", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                RowBox[{"x", "\[Rule]", 
                 RowBox[{
                  RowBox[{"res", "[", 
                   RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
              RowBox[{
               RowBox[{"res", "[", 
                RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
          RowBox[{"{", 
           RowBox[{"4", ",", "8"}], "}"}]}], ",", 
         RowBox[{"resx", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"resx", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"#", ",", 
              RowBox[{
               FractionBox[
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", "#"}]}], 
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", 
                  RowBox[{"res", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
               RowBox[{"res", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
           RowBox[{"{", 
            RowBox[{"4", ",", "8"}], "}"}]}], ",", "res", ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"timex", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"sur", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"interand", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"resx", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDfluxx", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"resx", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Green", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"autovar", "[", 
        RowBox[{"typ", ",", "1.2", ",", "fr", ",", "th"}], "]"}],
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox[";",
       FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", 
      RowBox[{"nux", "=", "22"}], ";", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"22", " ", "-", " ", 
         RowBox[{"1", "\[Sigma]"}]}], ";", " ", 
        RowBox[{"154", " ", "-", " ", 
         RowBox[{"2", "\[Sigma]"}]}], ";", " ", 
        RowBox[{"2592", " ", "-", " ", 
         RowBox[{"3", "\[Sigma]"}]}], ";", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"7", "/", 
           RowBox[{"(", 
            RowBox[{"1", "-", "#"}], ")"}]}], "&"}], "/@", 
         RowBox[{"{", 
          RowBox[{
          "0.682689492137086", ",", "0.954499736103642", ",", 
           "0.997300203936740"}], "}"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"nam", "=", 
       RowBox[{
        RowBox[{"dix", "[", "th", "]"}], "<>", "\"\<rand\>\"", "<>", 
        RowBox[{"ToString", "[", "fr", "]"}], "<>", "\"\<x\>\"", "<>", 
        RowBox[{"ToString", "[", "typ", "]"}], "<>", "\"\<x\>\"", "<>", 
        RowBox[{"ToString", "[", "nux", "]"}], "<>", "\"\<.dat\>\""}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"FileExistsQ", "[", "nam", "]"}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"tabresy", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"randx", "=", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"RandomVariate", "[", 
                   RowBox[{
                    RowBox[{"NormalDistribution", "[", "]"}], ",", "5000"}], 
                   "]"}], "+", 
                  RowBox[{"\[ImaginaryI]", " ", 
                   RowBox[{"RandomVariate", "[", 
                    RowBox[{
                    RowBox[{"NormalDistribution", "[", "]"}], ",", "5000"}], 
                    "]"}]}]}], ")"}], 
                SqrtBox[
                 RowBox[{"Exp", "[", 
                  RowBox[{"interand", "[", 
                   RowBox[{"Log", "[", 
                    RowBox[{"20000", "/", 
                    RowBox[{"Range", "[", "5000", "]"}]}], "]"}], "]"}], 
                  "]"}]]}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"rsxx", "=", 
               RowBox[{"4.8", 
                RowBox[{"Re", "[", 
                 RowBox[{"InverseFourier", "[", "randx", "]"}], "]"}]}]}], 
              ";"}], 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"+", "me"}], ";"}], 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"-", "for"}], " ", "formal", " ", "correspondence"}], 
               "*)"}], "*)"}], ";", "\[IndentingNewLine]", 
             RowBox[{"resy", "=", 
              StyleBox[
               RowBox[{"autorand", "[", 
                RowBox[{"typ", ",", "1.2", ",", "fr", ",", "rsxx"}], "]"}],
               FontColor->RGBColor[1, 0, 0]]}]}], ",", 
            RowBox[{"{", 
             RowBox[{"o", ",", "nux"}], "}"}]}], "]"}]}], ";", 
         RowBox[{"Put", "[", 
          RowBox[{
           RowBox[{"tabresy", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", "nam"}], 
          "]"}]}], ",", 
        RowBox[{
         RowBox[{"tabresy", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
         RowBox[{"Get", "[", "nam", "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ress", "[", "aa", "]"}], "=", 
         RowBox[{
          RowBox[{"tabresy", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "[", 
          RowBox[{"[", "aa", "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"aa", ",", "nux"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmean", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Exp", "[", 
        FractionBox[
         RowBox[{"Total", "[", 
          RowBox[{"Log", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"ress", "[", "i", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}], "]"}], "nux"],
         "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFrandmean", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"ressmean", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDflux", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0., 0., 1.]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"res", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}], ",", 
         RowBox[{"Epilog", "\[Rule]", "\[IndentingNewLine]", 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"types", "[", 
                RowBox[{"[", 
                 RowBox[{"typ", "-", "2"}], "]"}], "]"}], "<>", 
               "\"\< at \>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Floor", "[", 
                 RowBox[{"freqs", "[", 
                  RowBox[{"[", "fr", "]"}], "]"}], "]"}], "]"}], "<>", 
               "\"\<GHz\>\""}], ",", "18", ",", "Bold"}], "]"}], ",", 
            RowBox[{"Scaled", "[", 
             RowBox[{"{", 
              RowBox[{"0.3", ",", "0.8"}], "}"}], "]"}]}], "]"}]}]}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resstot", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ress", "[", "i", "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"resst", "=", 
       RowBox[{
        RowBox[{"ress", "[", "1", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmax", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"resst", ",", 
          RowBox[{"Mean", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"RankedMax", "[", 
                RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"RankedMax", "[", 
                RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}]}], "}"}], 
           "]"}]}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmin", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"resst", ",", 
          RowBox[{"Mean", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"RankedMin", "[", 
                RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"RankedMin", "[", 
                RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}]}], "}"}], 
           "]"}]}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFmin", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"ressmin", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Dotted"}], 
           "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFmax", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"ressmax", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"typ", ",", "3", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"th", ",", "1", ",", "2"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Computed in \>\"", ",", 
    RowBox[{
     RowBox[{"TimeUsed", "[", "]"}], "-", "ttx"}], ",", "\"\<s\>\""}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"367", "s", " ", "for", " ", "1", "\[Sigma]"}], " ", "\[Implies]",
     " ", 
    RowBox[{
     RowBox[{"2218", "s", 
      RowBox[{"(", 
       RowBox[{"37", "min"}], ")"}], " ", "for", " ", "2", "\[Sigma]"}], " ", 
     "\[Implies]", " ", 
     RowBox[{"36121", "s", 
      RowBox[{"(", 
       RowBox[{"10", "hrs"}], ")"}], " ", "for", " ", "3", "\[Sigma]"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Dimensions", "[", 
     RowBox[{"tabresy", "[", 
      RowBox[{"3", ",", "3"}], "]"}], "]"}], "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"Put", "[", 
       RowBox[{
        RowBox[{"tabresy", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
        RowBox[{"nam", "=", 
         RowBox[{
          RowBox[{"dix", "[", "th", "]"}], "<>", "\"\<rand\>\"", "<>", 
          RowBox[{"ToString", "[", "fr", "]"}], "<>", "\"\<x\>\"", "<>", 
          RowBox[{"ToString", "[", "typ", "]"}], "<>", "\"\<x\>\"", "<>", 
          RowBox[{"ToString", "[", "nux", "]"}], "<>", "\"\<.dat\>\""}]}]}], 
       "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"typ", ",", "3", ",", "6"}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.568658690181983*^9, 3.5686587401332707`*^9}, {
   3.5686588111757956`*^9, 3.5686588548880725`*^9}, {3.5686588922033377`*^9, 
   3.568658925977397*^9}, {3.5686589703906755`*^9, 3.5686589774106874`*^9}, {
   3.568672919401613*^9, 3.5686729589816833`*^9}, {3.5686734755153365`*^9, 
   3.5686734758803368`*^9}, 3.568673902517336*^9, {3.5686740475725393`*^9, 
   3.5686740736925755`*^9}, {3.5686741992477517`*^9, 3.568674207342763*^9}, {
   3.5686743702339907`*^9, 3.568674420479061*^9}, {3.5686746579543934`*^9, 
   3.5686746640944023`*^9}, {3.5686747825547867`*^9, 
   3.5686747836467886`*^9}, {3.568675093166932*^9, 3.5686751107637634`*^9}, {
   3.5686751638818564`*^9, 3.5686751860962954`*^9}, {3.5686752638780317`*^9, 
   3.5686752932372837`*^9}, 3.568676352200344*^9, {3.568676425036872*^9, 
   3.5686764268152747`*^9}, {3.5686765814583464`*^9, 
   3.5686765815051465`*^9}, {3.568676612564801*^9, 3.5686766292880306`*^9}, {
   3.5686768069879427`*^9, 3.568676807112743*^9}, {3.568676887780484*^9, 
   3.5686768878896847`*^9}, {3.5686769802106466`*^9, 
   3.5686770449975605`*^9}, {3.568677177254593*^9, 3.5686771780189943`*^9}, {
   3.5686772390463014`*^9, 3.5686772393739023`*^9}, {3.568677286049184*^9, 
   3.5686773642833214`*^9}, {3.568677400110385*^9, 3.568677400484785*^9}, {
   3.568677507665374*^9, 3.5686775082269745`*^9}, {3.5686775809855022`*^9, 
   3.568677667160054*^9}, {3.568677724162554*^9, 3.568677768326232*^9}, {
   3.5686784189103737`*^9, 3.5686784731984696`*^9}, {3.568678528562967*^9, 
   3.5686785340073767`*^9}, {3.568678600557093*^9, 3.5686786208995285`*^9}, {
   3.5686786550323887`*^9, 3.5686786624268017`*^9}, {3.568678748679353*^9, 
   3.5686787518617587`*^9}, {3.568678943851296*^9, 3.568678944178897*^9}, {
   3.568679095826763*^9, 3.5686790961543636`*^9}, 3.5687143742988043`*^9, {
   3.568718293597542*^9, 3.568718293925143*^9}, {3.568733412817721*^9, 
   3.568733427575347*^9}, {3.5687335444663525`*^9, 3.568733613090873*^9}, {
   3.568733746627107*^9, 3.5687337937547903`*^9}, {3.5687342807418456`*^9, 
   3.5687343666823964`*^9}, {3.5687344259001007`*^9, 
   3.5687344394877243`*^9}, {3.568734477239791*^9, 3.5687345461451116`*^9}, {
   3.5687345797823715`*^9, 3.568734589844389*^9}, {3.5687346756289396`*^9, 
   3.568734677563343*^9}, {3.568734894974286*^9, 3.568734922929535*^9}, {
   3.5687349655332103`*^9, 3.5687349764844294`*^9}, {3.568735012192892*^9, 
   3.56873502830772*^9}, {3.568735147273529*^9, 3.568735195914415*^9}, {
   3.568735337110263*^9, 3.568735339029066*^9}, {3.568735384331546*^9, 
   3.568735388949154*^9}, {3.5687354326448307`*^9, 3.5687354327852306`*^9}, {
   3.568735491519334*^9, 3.568735505184958*^9}, {3.5687364997865577`*^9, 
   3.568736499896558*^9}, {3.568743415518503*^9, 3.568743415643503*^9}, {
   3.568743713589615*^9, 3.5687437136364155`*^9}, {3.5687441249311376`*^9, 
   3.5687441349005547`*^9}, {3.5687456117645607`*^9, 3.568745675733219*^9}, {
   3.568745710904231*^9, 3.5687457803412027`*^9}, {3.568745836047389*^9, 
   3.5687458519833*^9}, {3.568746269593191*^9, 3.5687463055824547`*^9}, {
   3.568746362210554*^9, 3.5687463633961563`*^9}, {3.5687464472712975`*^9, 
   3.5687464474012976`*^9}, {3.568746524051405*^9, 3.5687465241114054`*^9}, {
   3.5687465874514937`*^9, 3.568746587516494*^9}, {3.5687466340115585`*^9, 
   3.5687466340965595`*^9}, {3.5687466830126286`*^9, 3.5687466830926285`*^9}, 
   3.5687467437727137`*^9, {3.568746883758145*^9, 3.5687468841949453`*^9}, {
   3.568746932711031*^9, 3.568746932867031*^9}, {3.5687483065115275`*^9, 
   3.5687483066051273`*^9}, {3.568748356905614*^9, 3.5687483570772142`*^9}, {
   3.5687484849978333`*^9, 3.5687484851070337`*^9}, {3.5687486793365183`*^9, 
   3.5687487039165525`*^9}, 3.5687487503066173`*^9, {3.5687487915866747`*^9, 
   3.568748868616783*^9}, 3.568748930046869*^9, {3.5687648297268953`*^9, 
   3.568764830431896*^9}, {3.5687651183353004`*^9, 3.5687651217753053`*^9}, {
   3.568765172395376*^9, 3.568765172775377*^9}, {3.5687652432954755`*^9, 
   3.5687652504354854`*^9}, {3.5687653239655886`*^9, 
   3.5687654154007163`*^9}, {3.5687654918858232`*^9, 3.568765522375866*^9}, {
   3.568765635131024*^9, 3.5687656600910587`*^9}, {3.5687657746762195`*^9, 
   3.568765779146226*^9}, {3.5687658126242733`*^9, 3.5687658187242823`*^9}, {
   3.5687659304504385`*^9, 3.5687659560604744`*^9}, {3.5687660151155567`*^9, 
   3.5687660156055574`*^9}, {3.5687660518306084`*^9, 3.56876608879066*^9}, {
   3.568766907469807*^9, 3.5687669171198206`*^9}, {3.5687669640798864`*^9, 
   3.5687669661198893`*^9}, {3.5687675173867655`*^9, 
   3.5687675633756466`*^9}, {3.568821997140112*^9, 3.568822020852154*^9}, {
   3.5688220594154215`*^9, 3.568822062551027*^9}, {3.568822107572706*^9, 
   3.568822116667522*^9}, {3.568822153592787*^9, 3.568822194090458*^9}, {
   3.5688227530290003`*^9, 3.5688227588010106`*^9}, {3.5688228373783484`*^9, 
   3.5688228857228336`*^9}, {3.5688229377967253`*^9, 
   3.5688229695895805`*^9}, {3.5688230020376377`*^9, 
   3.5688230069828463`*^9}, {3.56882307145776*^9, 3.568823184807559*^9}, {
   3.5688232887817416`*^9, 3.5688233510570507`*^9}, {3.568823574855044*^9, 
   3.5688235769298477`*^9}, {3.568823624853132*^9, 3.568823626522335*^9}, {
   3.568823907307228*^9, 3.568823937727281*^9}, {3.5688242497905293`*^9, 
   3.5688242498997297`*^9}, {3.5688249598546658`*^9, 3.568824963988673*^9}, {
   3.5688249955007286`*^9, 3.568824998527134*^9}, {3.568825583173684*^9, 
   3.5688256067765255`*^9}, {3.5688257669956055`*^9, 
   3.5688257915968485`*^9}, {3.5688265201971283`*^9, 3.568826526140739*^9}, {
   3.56882670801742*^9, 3.568826716082634*^9}, {3.5688267536163*^9, 
   3.568826758140308*^9}, {3.5696898448366103`*^9, 3.569689848671669*^9}, {
   3.5696899318429465`*^9, 3.569689935898009*^9}, {3.5696900532648115`*^9, 
   3.5696901073531427`*^9}, {3.569690290777461*^9, 3.569690331808091*^9}, {
   3.5696906005022182`*^9, 3.569690621590042*^9}, 3.5696906748008595`*^9, {
   3.5696911680134354`*^9, 3.5696911768160706`*^9}, {3.5696914070181074`*^9, 
   3.5696914071706095`*^9}, {3.5696914461662083`*^9, 
   3.5696914473587265`*^9}, {3.569691554536373*^9, 3.56969156347651*^9}, {
   3.569691629262521*^9, 3.5696916591204796`*^9}, {3.569691693988515*^9, 
   3.5696917502993803`*^9}, {3.5696918200279512`*^9, 
   3.5696918611985836`*^9}, {3.569696129506508*^9, 3.569696201117608*^9}, {
   3.5696967610487103`*^9, 3.569696820434623*^9}, {3.5696968508025894`*^9, 
   3.5696968900581923`*^9}, {3.5697229699763155`*^9, 
   3.5697229710588317`*^9}, {3.569723191150887*^9, 3.569723208733657*^9}, {
   3.569723547730029*^9, 3.5697235478750315`*^9}, {3.5697602313657613`*^9, 
   3.569760234820766*^9}, {3.56976027328082*^9, 3.569760307765868*^9}, 
   3.5697630504886355`*^9, {3.569945540377632*^9, 3.5699455435326366`*^9}, {
   3.569946117072834*^9, 3.569946117228834*^9}, {3.5699465864796576`*^9, 
   3.569946614060506*^9}, {3.5699488662442627`*^9, 3.569948885927105*^9}, {
   3.5699803386893177`*^9, 3.5699803418405232`*^9}, {3.570016662082553*^9, 
   3.570016673626573*^9}, {3.571705919857123*^9, 3.5717059255497103`*^9}}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{"PSDflux", "[", 
    RowBox[{"3", ",", "6", ",", "1"}], "]"}], ",", 
   RowBox[{"PSDflux", "[", 
    RowBox[{"3", ",", "3", ",", "1"}], "]"}], ",", 
   RowBox[{"PSDflux", "[", 
    RowBox[{"4", ",", "6", ",", "1"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"PSDflux", "[", 
    RowBox[{"3", ",", "6", ",", "2"}], "]"}], ",", 
   RowBox[{"PSDflux", "[", 
    RowBox[{"3", ",", "3", ",", "2"}], "]"}], ",", 
   RowBox[{"PSDflux", "[", 
    RowBox[{"4", ",", "6", ",", "2"}], "]"}]}], "}"}]}], "Input",
 CellChangeTimes->{{3.571706345341158*^9, 3.5717063675724993`*^9}, {
  3.5717064552853484`*^9, 3.5717064737806325`*^9}, {3.5717065602994614`*^9, 
  3.571706593877477*^9}}],

Cell[BoxData[
 RowBox[{"GraphicsGrid", "[", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Show", "[", 
     RowBox[{"{", 
      StyleBox[
       RowBox[{
        RowBox[{"PSDflux", "[", 
         RowBox[{"typ", ",", "fr", ",", "1"}], "]"}], ",", 
        RowBox[{"PSDflux", "[", 
         RowBox[{"typ", ",", "fr", ",", "2"}], "]"}]}],
       FontColor->RGBColor[0, 0, 1]], 
      StyleBox["}",
       FontColor->RGBColor[0, 0, 1]]}], 
     StyleBox["]",
      FontColor->RGBColor[0, 0, 1]]}], 
    StyleBox[",",
     FontColor->RGBColor[0, 0, 1]], 
    StyleBox[
     RowBox[{"{", 
      RowBox[{"typ", ",", "3", ",", "6"}], "}"}],
     FontColor->RGBColor[0, 0, 1]], 
    StyleBox[",",
     FontColor->RGBColor[0, 0, 1]], 
    StyleBox[
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}],
     FontColor->RGBColor[0, 0, 1]]}], 
   StyleBox["]",
    FontColor->RGBColor[0, 0, 1]]}], 
  StyleBox["]",
   FontColor->RGBColor[0, 0, 1]]}]], "Input",
 CellChangeTimes->{{3.5717061992614145`*^9, 3.5717062392245283`*^9}, {
  3.5717063394135675`*^9, 3.5717063395510693`*^9}, {3.57170652704395*^9, 
  3.5717065271714525`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"th", "=", "2"}], ";", 
  RowBox[{"grgr", "=", 
   RowBox[{"GraphicsGrid", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"sh", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Show", "[", 
        RowBox[{"{", 
         StyleBox[
          RowBox[{
           RowBox[{"PSDflux", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
           RowBox[{"PSDFmax", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
           RowBox[{"PSDFrandmean", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
           RowBox[{"PSDfluxx", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}],
          FontColor->RGBColor[0, 0, 1]], 
         StyleBox["}",
          FontColor->RGBColor[0, 0, 1]]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"typ", ",", "3", ",", "6"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}],
     "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"th", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.568765709706128*^9, 3.5687657570961947`*^9}, {
   3.568766150610747*^9, 3.5687661926308055`*^9}, {3.5687676090213265`*^9, 
   3.5687676147465367`*^9}, {3.5687677042756658`*^9, 
   3.5687677075856705`*^9}, {3.568826535828356*^9, 3.568826536140356*^9}, {
   3.5689450632113714`*^9, 3.5689450639601727`*^9}, 3.5696928359807386`*^9, {
   3.56969305541879*^9, 3.569693097186931*^9}, {3.569760309670871*^9, 
   3.5697603130358753`*^9}, {3.569760404331003*^9, 3.5697604079010086`*^9}, {
   3.5697607003894196`*^9, 3.5697607614745045`*^9}, {3.5717061837186756`*^9, 
   3.5717061838786783`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Figure QPOcurve.eps",
 FontColor->RGBColor[0, 0, 1]]], "Subsection",
 CellChangeTimes->{
  3.5696103031078925`*^9, {3.5696104222422223`*^9, 3.5696104226572285`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Dynamic", "[", "o", "]"}], ",", 
    RowBox[{"Dynamic", "[", "fnum", "]"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"angles", "=", 
    RowBox[{"{", 
     RowBox[{
     "\"\<th248lo\>\"", ",", "\"\<th296lo\>\"", ",", "\"\<th174lo\>\"", ",", 
      "\"\<th248lo120phi\>\"", ",", "\"\<th248lo240phi\>\""}], "}"}]}], ";"}],
   "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"dir0", "=", 
     RowBox[{"\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\\>\"", "<>", 
      RowBox[{"angles", "[", 
       RowBox[{"[", "o", "]"}], "]"}], "<>", "\"\<\\\\\>\""}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"fil", "=", 
     RowBox[{"dir0", "<>", "\"\<totspec.dat\>\""}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"FileExistsQ", "[", "fil", "]"}], ",", 
      RowBox[{
       RowBox[{"impx", "[", "o", "]"}], "=", 
       RowBox[{"Get", "[", "fil", "]"}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"impx", "[", "o", "]"}], "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Import", "[", 
           RowBox[{"dir0", "<>", "\"\<poliresa93.75\>\"", "<>", 
            RowBox[{"StringTake", "[", 
             RowBox[{
              RowBox[{"angles", "[", 
               RowBox[{"[", "o", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "5"}], "}"}]}], "]"}], "<>", "\"\<fn\>\"", "<>", 
            RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}],
            "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"fnum", ",", "2000", ",", "6999"}], "}"}]}], "]"}]}], ";", 
       RowBox[{"Put", "[", 
        RowBox[{
         RowBox[{"impx", "[", "o", "]"}], ",", "fil"}], "]"}]}]}], "]"}]}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"o", ",", "1", ",", "5"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"4", 
    RowBox[{
     RowBox[{"impx", "[", "1", "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"freqs", "=", 
   RowBox[{
    RowBox[{"impx", "[", "1", "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "All", ",", "2"}], "]"}], "]"}]}], ";", 
  RowBox[{"Dimensions", "[", 
   RowBox[{"impx", "[", "1", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"coe", "=", "1"}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"impx", "[", "1", "]"}], "=", 
     RowBox[{
     "Get", "[", 
      "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\th248lo\\\\totspec.dat\>\"\
", "]"}]}], ";", 
    RowBox[{"nums", "=", 
     RowBox[{"4", 
      RowBox[{
       RowBox[{"impx", "[", "1", "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}]}], ";", 
    RowBox[{"freqs", "=", 
     RowBox[{
      RowBox[{"impx", "[", "1", "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "All", ",", "2"}], "]"}], "]"}]}], ";", 
    RowBox[{
     RowBox[{
      RowBox[{"Dimensions", "[", 
       RowBox[{"impx", "[", "1", "]"}], "]"}], "\[IndentingNewLine]", 
      RowBox[{"impx", "[", "2", "]"}]}], "=", 
     RowBox[{
     "Get", "[", 
      "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\th296lo\\\\totspec.dat\>\"\
", "]"}]}], ";", 
    RowBox[{
     RowBox[{
      RowBox[{"Dimensions", "[", 
       RowBox[{"impx", "[", "2", "]"}], "]"}], "\[IndentingNewLine]", 
      RowBox[{"impx", "[", "3", "]"}]}], "=", 
     RowBox[{
     "Get", "[", 
      "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\th174lo\\\\totspec.dat\>\"\
", "]"}]}], ";", 
    RowBox[{"Dimensions", "[", 
     RowBox[{"impx", "[", "3", "]"}], "]"}]}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5699299964074497`*^9, 3.5699299970938506`*^9}, {
  3.569943011240695*^9, 3.569943138802119*^9}, {3.5699431812341933`*^9, 
  3.5699432058198366`*^9}, {3.569943239905896*^9, 3.5699432400774965`*^9}, {
  3.5699432772835617`*^9, 3.569943292103588*^9}, {3.5699433418492756`*^9, 
  3.5699433453436813`*^9}, {3.5699435708732777`*^9, 3.5699436605890355`*^9}, {
  3.580274895623355*^9, 3.5802749010677643`*^9}, {3.580817073382803*^9, 
  3.580817091634835*^9}, {3.580817123396491*^9, 3.580817123536891*^9}, {
  3.5808171805091915`*^9, 3.580817195610018*^9}, {3.5808172748893566`*^9, 
  3.580817307418414*^9}, {3.580817852001771*^9, 3.5808178521109705`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"shi", "=."}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tab120", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Norm", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"impx", "[", "1", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"1", ";;", 
           RowBox[{
            RowBox[{"-", "1"}], "-", "shi"}]}], ",", "6", ",", "3"}], "]"}], 
        "]"}], "-", 
       RowBox[{
        RowBox[{"impx", "[", "4", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{
           RowBox[{"1", "+", "shi"}], ";;", 
           RowBox[{"-", "1"}]}], ",", "6", ",", "3"}], "]"}], "]"}]}], "]"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"shi", ",", "0", ",", "30"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tab240", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Norm", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"impx", "[", "1", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"1", ";;", 
           RowBox[{
            RowBox[{"-", "1"}], "-", "shi"}]}], ",", "6", ",", "3"}], "]"}], 
        "]"}], "-", 
       RowBox[{
        RowBox[{"impx", "[", "5", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{
           RowBox[{"1", "+", "shi"}], ";;", 
           RowBox[{"-", "1"}]}], ",", "6", ",", "3"}], "]"}], "]"}]}], "]"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"shi", ",", "0", ",", "30"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"tab120", ",", "tab240"}], "}"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Red", ",", "Blue"}], "}"}]}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{
   "PlotLabel", "\[Rule]", 
    "\"\<Shift 120deg and 240deg manifest at 7 and 14 minima\>\""}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fr", "=", "6"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Flpl", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"nums", ",", 
            RowBox[{
             RowBox[{"impx", "[", "i", "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], "}"}], 
          "]"}], "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
            "4"}], ";;", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
            "4"}]}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "5"}], "}"}]}], "]"}], ",", 
      RowBox[{"FrameLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
        "\"\<t [GM/\!\(\*SuperscriptBox[\(c\), \(3\)]\)]\>\"", ",", 
         "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}], "}"}]}], 
      ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Blue", ",", "White", 
         RowBox[{"(*", "Red", "*)"}], ",", "White", 
         RowBox[{"(*", "Green", "*)"}], ",", "Brown", ",", "Black"}], "}"}]}],
       ",", 
      RowBox[{"Joined", "->", "True"}]}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"25500", ",", "26100"}], "}"}], "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GraphicsGrid", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Flpl", "=", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{"nums", ",", 
                 RowBox[{
                  RowBox[{"impx", "[", "i", "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], 
                "}"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                  "4"}], ";;", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                  "4"}]}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ",", 
           RowBox[{"FrameLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<t [GM/\!\(\*SuperscriptBox[\(c\), \(3\)]\)]\>\"", ",", 
              "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}], 
             "}"}]}]}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"LPpl", "=", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{"nums", ",", 
                 RowBox[{
                  RowBox[{"impx", "[", "i", "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], 
                "}"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                  "4"}], ";;", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                  "4"}]}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ",", 
           RowBox[{"PlotRange", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"0", ",", "11.5"}], "}"}]}], ",", 
           RowBox[{"FrameLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<t [GM/\!\(\*SuperscriptBox[\(c\), \(3\)]\)]\>\"", ",", 
              "\"\<LP [%]\>\""}], "}"}]}]}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"EVPApl", "=", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{"nums", ",", 
                 RowBox[{
                  RowBox[{"impx", "[", "i", "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], 
                "}"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                  "4"}], ";;", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                  "4"}]}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ",", 
           RowBox[{"FrameLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<t [GM/\!\(\*SuperscriptBox[\(c\), \(3\)]\)]\>\"", ",", 
              "\"\<EVPA [deg]\>\""}], "}"}]}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"CPpl", "=", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{"nums", ",", 
                 RowBox[{
                  RowBox[{"impx", "[", "i", "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], 
                "}"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                  "4"}], ";;", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                  "4"}]}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ",", 
           RowBox[{"FrameLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<t [GM/\!\(\*SuperscriptBox[\(c\), \(3\)]\)]\>\"", ",", 
              "\"\<CP [%]\>\""}], "}"}]}]}], "]"}]}]}], "}"}]}], "}"}], "]"}],
    "&"}], "/@", 
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"25500", ",", "26100"}], "}"}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.569610717225254*^9, 3.569610730377956*^9}, {
  3.569610783432271*^9, 3.569610868963585*^9}, {3.5696109603699884`*^9, 
  3.5696109604399896`*^9}, {3.569610999310587*^9, 3.5696110663816166`*^9}, {
  3.5696114096353903`*^9, 3.5696114208605623`*^9}, {3.58081791427708*^9, 
  3.5808179436831317`*^9}, {3.58081799376222*^9, 3.5808180060394416`*^9}, {
  3.5808180408275023`*^9, 3.580818059984336*^9}, {3.58081847760107*^9, 
  3.580818484465082*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   StyleBox[
    RowBox[{"Making", " ", "figure", " ", 
     RowBox[{"QPOcurve", ".", "eps"}]}],
    FontSize->16,
    FontColor->RGBColor[1, 0, 0]], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"fr", "=", "6"}], ";", 
    RowBox[{"typ", "=", "4"}], ";", 
    RowBox[{"freqs", "[", 
     RowBox[{"[", "fr", "]"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"ListPlot", ",", 
      RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
      RowBox[{"InterpolationOrder", "\[Rule]", "1"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Black", ",", 
           RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Black", ",", 
           RowBox[{"AbsoluteDashing", "[", "7", "]"}], ",", 
           RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Black", ",", 
           RowBox[{"AbsoluteDashing", "[", "2", "]"}], ",", 
           RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}], "}"}]}], 
      ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"16", ",", "\"\<Times\>\"", ",", "Bold"}], "}"}]}]}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"ListPlot", "[", 
        RowBox[{
         RowBox[{"Fltr", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"1", "+", 
             RowBox[{"1000", "i"}]}], ";;", 
            RowBox[{"1000", 
             RowBox[{"(", 
              RowBox[{"i", "+", "1"}], ")"}]}]}], "]"}], "]"}], ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "2"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "450"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "4"}], "}"}]}], "]"}], ";"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"GraphicsGrid", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{"nums", ",", 
                 RowBox[{"imp", "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], 
                "}"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", "+", 
                 RowBox[{"1000", "i"}]}], ";;", 
                RowBox[{"1000", 
                 RowBox[{"(", 
                  RowBox[{"i", "+", "1"}], ")"}]}]}], "]"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{"nums", ",", 
                 RowBox[{"imp", "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], 
                "}"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", "+", 
                 RowBox[{"1000", "i"}]}], ";;", 
                RowBox[{"1000", 
                 RowBox[{"(", 
                  RowBox[{"i", "+", "1"}], ")"}]}]}], "]"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{"nums", ",", 
                 RowBox[{"imp", "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], 
                "}"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", "+", 
                 RowBox[{"1000", "i"}]}], ";;", 
                RowBox[{"1000", 
                 RowBox[{"(", 
                  RowBox[{"i", "+", "1"}], ")"}]}]}], "]"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{"nums", ",", 
                 RowBox[{"imp", "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], 
                "}"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", "+", 
                 RowBox[{"1000", "i"}]}], ";;", 
                RowBox[{"1000", 
                 RowBox[{"(", 
                  RowBox[{"i", "+", "1"}], ")"}]}]}], "]"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}],
        "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "0", ",", "4"}], "}"}]}], "]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"GraphicsGrid", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Flpl", "=", 
            RowBox[{"ListPlot", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Transpose", "[", 
                  RowBox[{"{", 
                   RowBox[{"nums", ",", 
                    RowBox[{
                    RowBox[{"impx", "[", "i", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], 
                   "}"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}], ";;", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}]}], "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ",", 
              RowBox[{"FrameLabel", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<t [GM/\!\(\*SuperscriptBox[\(c\), \(3\)]\)]\>\"", ",", 
                 "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}], 
                "}"}]}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"LPpl", "=", 
            RowBox[{"ListPlot", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Transpose", "[", 
                  RowBox[{"{", 
                   RowBox[{"nums", ",", 
                    RowBox[{
                    RowBox[{"impx", "[", "i", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], 
                   "}"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}], ";;", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}]}], "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ",", 
              RowBox[{"PlotRange", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"0", ",", "11.5"}], "}"}]}], ",", 
              RowBox[{"FrameLabel", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<t [GM/\!\(\*SuperscriptBox[\(c\), \(3\)]\)]\>\"", ",", 
                 "\"\<LP [%]\>\""}], "}"}]}]}], "]"}]}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"EVPApl", "=", 
            RowBox[{"ListPlot", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Transpose", "[", 
                  RowBox[{"{", 
                   RowBox[{"nums", ",", 
                    RowBox[{
                    RowBox[{"impx", "[", "i", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], 
                   "}"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}], ";;", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}]}], "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ",", 
              RowBox[{"FrameLabel", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<t [GM/\!\(\*SuperscriptBox[\(c\), \(3\)]\)]\>\"", ",", 
                 "\"\<EVPA [deg]\>\""}], "}"}]}]}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"CPpl", "=", 
            RowBox[{"ListPlot", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Transpose", "[", 
                  RowBox[{"{", 
                   RowBox[{"nums", ",", 
                    RowBox[{
                    RowBox[{"impx", "[", "i", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], 
                   "}"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}], ";;", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}]}], "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ",", 
              RowBox[{"FrameLabel", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<t [GM/\!\(\*SuperscriptBox[\(c\), \(3\)]\)]\>\"", ",", 
                 "\"\<CP [%]\>\""}], "}"}]}]}], "]"}]}]}], "}"}]}], "}"}], 
       "]"}], "&"}], "/@", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"25500", ",", "26100"}], "}"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"best", " ", "times", " ", "fr"}], "=", 
      RowBox[{
       RowBox[{"6", ":", " ", "tmin"}], "=", "25500"}]}], ";", 
     RowBox[{"tmax", "=", 
      RowBox[{"26100", ":", " ", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"13000", ",", "13400"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"23400", ",", "23800"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"25000", ",", "25400"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"25500", ",", "25900"}], "}"}]}], "}"}]}]}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"mysize", "=", "16"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"figv", "=", 
    RowBox[{"Figure", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ScaledLabel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.76", ",", "0.94"}], "}"}], ",", 
          "\"\<General inclination\>\"", ",", 
          RowBox[{"Color", "\[Rule]", "Black"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", 
           RowBox[{"mysize", "-", "2"}]}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
          RowBox[{"Offset", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ScaledLabel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.86", ",", "0.83"}], "}"}], ",", "\"\<Face-on\>\"", ",", 
          RowBox[{"Color", "\[Rule]", "Black"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", 
           RowBox[{"mysize", "-", "2"}]}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
          RowBox[{"Offset", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ScaledLabel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.86", ",", "0.805"}], "}"}], ",", "\"\<Edge-on\>\"", ",", 
          RowBox[{"Color", "\[Rule]", "Black"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", 
           RowBox[{"mysize", "-", "2"}]}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
          RowBox[{"Offset", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Multipanel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"4", ",", "1"}], "}"}], ",", 
          RowBox[{"XPlotRanges", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"25500", ",", "26100"}], "}"}], "}"}]}], ",", 
          RowBox[{"YPlotRanges", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"2.55", ",", "3.36"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0.01", ",", "10"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0.1", ",", "179.9"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "2.39"}], ",", 
               RowBox[{"+", "0.44"}]}], "}"}]}], "}"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"XFrameLabels", "\[Rule]", 
           RowBox[{"{", "\"\<t [M]\>\"", "}"}]}], ",", 
          RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
          RowBox[{"YFrameLabels", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\"", ",", 
             "\"\<LP [%]\>\"", ",", "\"\<EVPA [deg]\>\"", ",", 
             "\"\<CP [%]\>\""}], "}"}]}], ",", 
          RowBox[{"BufferL", "\[Rule]", "5"}], ",", 
          RowBox[{"TickFontSize", "\[Rule]", "mysize"}], ",", 
          RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"XFrameTicks", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"LinTicks", "[", 
                RowBox[{"0", ",", "20", ",", "5", ",", "5"}], "]"}], ",", 
               "None"}], "}"}]}], ",", 
            RowBox[{"YFrameTicks", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"LinTicks", "[", 
                  RowBox[{
                   RowBox[{"-", "6"}], ",", "6", ",", "3", ",", "2"}], "]"}], 
                 ",", "None"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"LinTicks", "[", 
                  RowBox[{
                   RowBox[{"-", "6"}], ",", "6", ",", "3", ",", "2"}], "]"}], 
                 ",", "None"}], "}"}]}], "}"}]}], ",", 
            RowBox[{"XPanelSizes", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0.2"}], "}"}]}], ",", 
            RowBox[{"YPanelSizes", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}], ",", 
            RowBox[{"XGapSizes", "\[Rule]", 
             RowBox[{"{", "0.03", "}"}]}], ",", 
            RowBox[{"YGapSizes", "\[Rule]", 
             RowBox[{"{", "0", "}"}]}], ","}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Background", "\[Rule]", "White"}], ",", 
          RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
          RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"PanelLetterCorner", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
          RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"TickNudge", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "5"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "5"}], ",", "0"}], "}"}], ",", "0", ",", "0"}], 
              "}"}]}], ","}], "*)"}], 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FigurePanel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}], ",", 
          RowBox[{"PanelLetter", "\[Rule]", "\"\<(a)\>\""}]}], "]"}], ",", 
        RowBox[{"RawGraphics", "[", 
         RowBox[{"Flpl", ",", 
          RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FigurePanel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"2", ",", "1"}], "}"}], ",", 
          RowBox[{"PanelLetter", "\[Rule]", "\"\<(b)\>\""}]}], "]"}], ",", 
        RowBox[{"RawGraphics", "[", 
         RowBox[{"LPpl", ",", 
          RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FigurePanel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"3", ",", "1"}], "}"}], ",", 
          RowBox[{"PanelLetter", "\[Rule]", "\"\<(c)\>\""}]}], "]"}], ",", 
        RowBox[{"RawGraphics", "[", 
         RowBox[{"EVPApl", ",", 
          RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FigurePanel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"4", ",", "1"}], "}"}], ",", 
          RowBox[{"PanelLetter", "\[Rule]", "\"\<(d)\>\""}]}], "]"}], ",", 
        RowBox[{"RawGraphics", "[", 
         RowBox[{"CPpl", ",", 
          RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.2"}], ",", "1.1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.08"}], ",", "1.04"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"450", ",", "800"}], "}"}]}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Export", "[", 
     RowBox[{
     "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\!svn\\\\figures\\\\QPOcurve.eps\>\"", ",", "figv"}], "]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Blue", ",", "Red", ",", "Green", ",", " ", 
     RowBox[{"{", 
      RowBox[{"\"\<th248\>\"", ",", "\"\<th296\>\"", ",", "\"\<th174\>\""}], 
      "}"}]}], "*)"}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.56953901410575*^9, 3.5695390316385193`*^9}, {
   3.5695390722391434`*^9, 3.569539192555991*^9}, {3.5695392296215606`*^9, 
   3.569539253404426*^9}, {3.5695392951250668`*^9, 3.5695393378832235`*^9}, {
   3.5695398701931553`*^9, 3.569540026525556*^9}, 3.56954016672771*^9, {
   3.5695402357812705`*^9, 3.569540305724845*^9}, {3.5695403731558805`*^9, 
   3.5695403774684467`*^9}, {3.569540452739603*^9, 3.569540458859697*^9}, {
   3.5695405024353657`*^9, 3.569540508362957*^9}, {3.569540567278364*^9, 
   3.5695406031799154`*^9}, {3.5695406352604084`*^9, 3.569540651823163*^9}, {
   3.5695406955288343`*^9, 3.5695407206817207`*^9}, {3.569540771162496*^9, 
   3.5695407792751207`*^9}, {3.569540809518085*^9, 3.569540916082222*^9}, {
   3.569541026943925*^9, 3.569541040239129*^9}, {3.569541155870905*^9, 
   3.569541163866028*^9}, {3.569541304619691*^9, 3.56954131366733*^9}, {
   3.5695413573755016`*^9, 3.569541450066925*^9}, {3.5695421874964366`*^9, 
   3.56954220725424*^9}, {3.5695426825480547`*^9, 3.5695427522666254`*^9}, {
   3.5695431578448563`*^9, 3.5695431810252123`*^9}, {3.5695432173632703`*^9, 
   3.5695432337835226`*^9}, {3.5695432679050474`*^9, 3.569543348676288*^9}, {
   3.5695450139498734`*^9, 3.5695450637081375`*^9}, {3.5696104923007984`*^9, 
   3.5696104945858335`*^9}, {3.5696105295038695`*^9, 
   3.5696105311263943`*^9}, {3.5696111183724155`*^9, 
   3.5696111509954166`*^9}, {3.5696111829084067`*^9, 3.56961119155604*^9}, {
   3.5696112248290505`*^9, 3.5696112254590607`*^9}, {3.5696113307016773`*^9, 
   3.5696113954451723`*^9}, {3.5696114265131493`*^9, 
   3.5696115193470755`*^9}, {3.569944042259306*^9, 3.5699440437101088`*^9}, {
   3.569944091291192*^9, 3.5699442022541866`*^9}, {3.5699442354822454`*^9, 
   3.56994427791432*^9}, {3.569944310019176*^9, 3.5699443109863777`*^9}, {
   3.5699448452608385`*^9, 3.569944996534304*^9}, {3.5699450706968346`*^9, 
   3.5699450730368385`*^9}, {3.56997658330914*^9, 3.5699765862731457`*^9}, {
   3.5735610757174172`*^9, 3.573561078043703*^9}, {3.573561116834799*^9, 
   3.573561210939494*^9}, {3.5808178718762054`*^9, 3.5808178804250207`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Figure QPOfreq.eps",
 FontColor->RGBColor[0, 0, 1]]], "Subsection",
 CellChangeTimes->{
  3.5696103031078925`*^9, {3.5696104222422223`*^9, 3.5696104226572285`*^9}, {
   3.569774480658146*^9, 3.5697744821089487`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"impx", "[", "1", "]"}], "=", 
   RowBox[{
   "Get", "[", 
    "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\th248lo\\\\totspec.dat\>\"", 
    "]"}]}], ";", 
  RowBox[{"nums", "=", 
   RowBox[{"4", 
    RowBox[{
     RowBox[{"impx", "[", "1", "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"freqs", "=", 
   RowBox[{
    RowBox[{"impx", "[", "1", "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "All", ",", "2"}], "]"}], "]"}]}], ";", 
  RowBox[{"Dimensions", "[", 
   RowBox[{"impx", "[", "1", "]"}], "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.569610479330599*^9, 3.5696106022674875`*^9}, {
  3.569610642236602*^9, 3.569610686569783*^9}, {3.5696107481207285`*^9, 
  3.5696107789222016`*^9}, {3.5696894688108344`*^9, 3.569689469555846*^9}, {
  3.569689630875824*^9, 3.5696896558412075`*^9}, {3.5697745082857943`*^9, 
  3.569774508582195*^9}, {3.5699444335415688`*^9, 3.569944435426572*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"GraphicsGrid", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Flpl", "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Transpose", "[", 
                 RowBox[{"{", 
                  RowBox[{"nums", ",", 
                   RowBox[{
                    RowBox[{"impx", "[", "1", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], 
                  "}"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                    "4"}], ";;", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                    "4"}]}], "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], 
                "}"}]}], "]"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<t [GM/\!\(\*SuperscriptBox[\(c\), \(3\)]\)]\>\"", ",", 
                "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}], 
               "}"}]}]}], "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"LPpl", "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Transpose", "[", 
                 RowBox[{"{", 
                  RowBox[{"nums", ",", 
                   RowBox[{
                    RowBox[{"impx", "[", "1", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], 
                  "}"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                    "4"}], ";;", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                    "4"}]}], "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], 
                "}"}]}], "]"}], ",", 
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"0", ",", "11.5"}], "}"}]}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<t [GM/\!\(\*SuperscriptBox[\(c\), \(3\)]\)]\>\"", ",", 
                "\"\<LP [%]\>\""}], "}"}]}]}], "]"}]}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EVPApl", "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Transpose", "[", 
                 RowBox[{"{", 
                  RowBox[{"nums", ",", 
                   RowBox[{
                    RowBox[{"impx", "[", "1", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], 
                  "}"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                    "4"}], ";;", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                    "4"}]}], "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], 
                "}"}]}], "]"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<t [GM/\!\(\*SuperscriptBox[\(c\), \(3\)]\)]\>\"", ",", 
                "\"\<EVPA [deg]\>\""}], "}"}]}]}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"CPpl", "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Transpose", "[", 
                 RowBox[{"{", 
                  RowBox[{"nums", ",", 
                   RowBox[{
                    RowBox[{"impx", "[", "1", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], 
                  "}"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                    "4"}], ";;", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                    "4"}]}], "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], 
                "}"}]}], "]"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<t [GM/\!\(\*SuperscriptBox[\(c\), \(3\)]\)]\>\"", ",", 
                "\"\<CP [%]\>\""}], "}"}]}]}], "]"}]}]}], "}"}]}], "}"}], 
      "]"}], "&"}], "/@", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"25500", ",", "26100"}], "}"}], "}"}]}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.569610717225254*^9, 3.569610730377956*^9}, {
   3.569610783432271*^9, 3.569610868963585*^9}, {3.5696109603699884`*^9, 
   3.5696109604399896`*^9}, {3.569610999310587*^9, 3.5696110663816166`*^9}, {
   3.5696114096353903`*^9, 3.5696114208605623`*^9}, {3.56977452268462*^9, 
   3.569774601620758*^9}, {3.569775459898634*^9, 3.5697754654136415`*^9}, {
   3.569775509543703*^9, 3.5697755347487383`*^9}, 3.5697756087938423`*^9, {
   3.569775755215047*^9, 3.5697757563750486`*^9}, {3.569776617364955*^9, 
   3.569776622804962*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   StyleBox[
    RowBox[{"Making", " ", "figure", " ", 
     RowBox[{"QPOfreq", ".", "eps"}]}],
    FontSize->16,
    FontColor->RGBColor[1, 0, 0]], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"fr", "=."}], ";", 
    RowBox[{"kmin", "=", "3"}], ";", 
    RowBox[{"kmax", "=", "9"}], ";", 
    RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"ListPlot", ",", 
      RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
      RowBox[{"InterpolationOrder", "\[Rule]", "1"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Blue", ",", 
           RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Red", ",", 
           RowBox[{"AbsoluteDashing", "[", "7", "]"}], ",", 
           RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteDashing", "[", "3", "]"}], ",", 
           RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}], "}"}]}], 
      ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"16", ",", "\"\<Times\>\"", ",", "Bold"}], "}"}]}]}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"GraphicsGrid", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Flpl", "=", 
            RowBox[{"ListPlot", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Transpose", "[", 
                  RowBox[{"{", 
                   RowBox[{"nums", ",", 
                    RowBox[{
                    RowBox[{"impx", "[", "1", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], 
                   "}"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}], ";;", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}]}], "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], 
                 "}"}]}], "]"}], ",", 
              RowBox[{"FrameLabel", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                "\"\<t [M]\>\"", ",", 
                 "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}], 
                "}"}]}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"LPpl", "=", 
            RowBox[{"ListPlot", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Transpose", "[", 
                  RowBox[{"{", 
                   RowBox[{"nums", ",", 
                    RowBox[{
                    RowBox[{"impx", "[", "1", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], 
                   "}"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}], ";;", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}]}], "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], 
                 "}"}]}], "]"}], ",", 
              RowBox[{"PlotRange", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"0", ",", "14"}], "}"}]}], ",", 
              RowBox[{"FrameLabel", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"\"\<t [M]\>\"", ",", "\"\<LP [%]\>\""}], "}"}]}]}], 
             "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"EVPApl", "=", 
            RowBox[{"ListPlot", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Transpose", "[", 
                  RowBox[{"{", 
                   RowBox[{"nums", ",", 
                    RowBox[{
                    RowBox[{"impx", "[", "1", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], 
                   "}"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}], ";;", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}]}], "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], 
                 "}"}]}], "]"}], ",", 
              RowBox[{"FrameLabel", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"\"\<t [M]\>\"", ",", "\"\<EVPA [deg]\>\""}], 
                "}"}]}]}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"CPpl", "=", 
            RowBox[{"ListPlot", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Transpose", "[", 
                  RowBox[{"{", 
                   RowBox[{"nums", ",", 
                    RowBox[{
                    RowBox[{"impx", "[", "1", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], 
                   "}"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}], ";;", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/",
                     "4"}]}], "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], 
                 "}"}]}], "]"}], ",", 
              RowBox[{"FrameLabel", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"\"\<t [M]\>\"", ",", "\"\<CP [%]\>\""}], "}"}]}]}], 
             "]"}]}]}], "}"}]}], "}"}], "]"}], "&"}], "/@", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"25500", ",", "26100"}], "}"}], "}"}]}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"best", " ", "times", " ", "fr"}], "=", 
      RowBox[{
       RowBox[{"6", ":", " ", "tmin"}], "=", "25500"}]}], ";", 
     RowBox[{"tmax", "=", 
      RowBox[{"26100", ":", " ", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"13000", ",", "13400"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"23400", ",", "23800"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"25000", ",", "25400"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"25500", ",", "25900"}], "}"}]}], "}"}]}]}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"mysize", "=", "16"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"figv", "=", 
    RowBox[{"Figure", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ScaledLabel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.55", ",", "0.95"}], "}"}], ",", "\"\<857GHz\>\"", ",", 
          RowBox[{"Color", "\[Rule]", "Green"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
          RowBox[{"Offset", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ScaledLabel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.55", ",", "0.865"}], "}"}], ",", "\"\<230GHz\>\"", ",", 
          RowBox[{"Color", "\[Rule]", "Red"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
          RowBox[{"Offset", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ScaledLabel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.55", ",", "0.8"}], "}"}], ",", "\"\<87GHz\>\"", ",", 
          RowBox[{"Color", "\[Rule]", "Blue"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
          RowBox[{"Offset", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Multipanel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"4", ",", "1"}], "}"}], ",", 
          RowBox[{"XPlotRanges", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"25500", ",", "26100"}], "}"}], "}"}]}], ",", 
          RowBox[{"YPlotRanges", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1.7", ",", "3.9"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0.1", ",", "13.9"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0.1", ",", "179.9"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "2.29"}], ",", 
               RowBox[{"-", "0.19"}]}], "}"}]}], "}"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"XFrameLabels", "\[Rule]", 
           RowBox[{"{", "\"\<t [M]\>\"", "}"}]}], ",", 
          RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
          RowBox[{"YFrameLabels", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\"", ",", 
             "\"\<LP [%]\>\"", ",", "\"\<EVPA [deg]\>\"", ",", 
             "\"\<CP [%]\>\""}], "}"}]}], ",", 
          RowBox[{"BufferL", "\[Rule]", "5"}], ",", 
          RowBox[{"TickFontSize", "\[Rule]", "mysize"}], ",", 
          RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"XFrameTicks", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"LinTicks", "[", 
                RowBox[{"0", ",", "20", ",", "5", ",", "5"}], "]"}], ",", 
               "None"}], "}"}]}], ",", 
            RowBox[{"YFrameTicks", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"LinTicks", "[", 
                  RowBox[{
                   RowBox[{"-", "6"}], ",", "6", ",", "3", ",", "2"}], "]"}], 
                 ",", "None"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"LinTicks", "[", 
                  RowBox[{
                   RowBox[{"-", "6"}], ",", "6", ",", "3", ",", "2"}], "]"}], 
                 ",", "None"}], "}"}]}], "}"}]}], ",", 
            RowBox[{"XPanelSizes", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0.2"}], "}"}]}], ",", 
            RowBox[{"YPanelSizes", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}], ",", 
            RowBox[{"XGapSizes", "\[Rule]", 
             RowBox[{"{", "0.03", "}"}]}], ",", 
            RowBox[{"YGapSizes", "\[Rule]", 
             RowBox[{"{", "0", "}"}]}], ","}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Background", "\[Rule]", "White"}], ",", 
          RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
          RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"PanelLetterCorner", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
          RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"TickNudge", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "5"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "5"}], ",", "0"}], "}"}], ",", "0", ",", "0"}], 
              "}"}]}], ","}], "*)"}], 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FigurePanel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}], ",", 
          RowBox[{"PanelLetter", "\[Rule]", "\"\<(a)\>\""}]}], "]"}], ",", 
        RowBox[{"RawGraphics", "[", 
         RowBox[{"Flpl", ",", 
          RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FigurePanel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"2", ",", "1"}], "}"}], ",", 
          RowBox[{"PanelLetter", "\[Rule]", "\"\<(b)\>\""}]}], "]"}], ",", 
        RowBox[{"RawGraphics", "[", 
         RowBox[{"LPpl", ",", 
          RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FigurePanel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"3", ",", "1"}], "}"}], ",", 
          RowBox[{"PanelLetter", "\[Rule]", "\"\<(c)\>\""}]}], "]"}], ",", 
        RowBox[{"RawGraphics", "[", 
         RowBox[{"EVPApl", ",", 
          RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FigurePanel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"4", ",", "1"}], "}"}], ",", 
          RowBox[{"PanelLetter", "\[Rule]", "\"\<(d)\>\""}]}], "]"}], ",", 
        RowBox[{"RawGraphics", "[", 
         RowBox[{"CPpl", ",", 
          RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.2"}], ",", "1.1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.08"}], ",", "1.04"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"450", ",", "800"}], "}"}]}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"Export", "[", 
    RowBox[{
    "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD QPOs\\\\!svn\
\\\\figures\\\\QPOfreq.eps\>\"", ",", "figv"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"YPlotRanges", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2.91", ",", "3.14"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.1", ",", "9.9"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"30.1", ",", "59"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1.99"}], ",", 
          RowBox[{"-", "1.36"}]}], "}"}]}], "}"}]}], ","}], 
    "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.56953901410575*^9, 3.5695390316385193`*^9}, {
   3.5695390722391434`*^9, 3.569539192555991*^9}, {3.5695392296215606`*^9, 
   3.569539253404426*^9}, {3.5695392951250668`*^9, 3.5695393378832235`*^9}, {
   3.5695398701931553`*^9, 3.569540026525556*^9}, 3.56954016672771*^9, {
   3.5695402357812705`*^9, 3.569540305724845*^9}, {3.5695403731558805`*^9, 
   3.5695403774684467`*^9}, {3.569540452739603*^9, 3.569540458859697*^9}, {
   3.5695405024353657`*^9, 3.569540508362957*^9}, {3.569540567278364*^9, 
   3.5695406031799154`*^9}, {3.5695406352604084`*^9, 3.569540651823163*^9}, {
   3.5695406955288343`*^9, 3.5695407206817207`*^9}, {3.569540771162496*^9, 
   3.5695407792751207`*^9}, {3.569540809518085*^9, 3.569540916082222*^9}, {
   3.569541026943925*^9, 3.569541040239129*^9}, {3.569541155870905*^9, 
   3.569541163866028*^9}, {3.569541304619691*^9, 3.56954131366733*^9}, {
   3.5695413573755016`*^9, 3.569541450066925*^9}, {3.5695421874964366`*^9, 
   3.56954220725424*^9}, {3.5695426825480547`*^9, 3.5695427522666254`*^9}, {
   3.5695431578448563`*^9, 3.5695431810252123`*^9}, {3.5695432173632703`*^9, 
   3.5695432337835226`*^9}, {3.5695432679050474`*^9, 3.569543348676288*^9}, {
   3.5695450139498734`*^9, 3.5695450637081375`*^9}, {3.5696104923007984`*^9, 
   3.5696104945858335`*^9}, {3.5696105295038695`*^9, 
   3.5696105311263943`*^9}, {3.5696111183724155`*^9, 
   3.5696111509954166`*^9}, {3.5696111829084067`*^9, 3.56961119155604*^9}, {
   3.5696112248290505`*^9, 3.5696112254590607`*^9}, {3.5696113307016773`*^9, 
   3.5696113954451723`*^9}, {3.5696114265131493`*^9, 
   3.5696115193470755`*^9}, {3.5697745018741827`*^9, 
   3.5697745038397865`*^9}, {3.569775775140075*^9, 3.5697758088051224`*^9}, {
   3.5697758736362305`*^9, 3.569775914664303*^9}, {3.5697759642359858`*^9, 
   3.569776044506098*^9}, {3.569776183687295*^9, 3.5697761883973017`*^9}, {
   3.56977662839997*^9, 3.5697766322499757`*^9}, {3.569944454301598*^9, 
   3.5699444556516*^9}, {3.5699444882894506`*^9, 3.569944491113055*^9}, {
   3.5699445423123455`*^9, 3.5699445704079943`*^9}, {3.5699446086744556`*^9, 
   3.569944733346242*^9}, {3.5699766217920055`*^9, 3.569976640356038*^9}}],

Cell[BoxData[
 RowBox[{"Options", "[", "ScaledLabel", "]"}]], "Input",
 CellChangeTimes->{{3.5699446519545164`*^9, 3.5699446533795185`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Figure imagetotal.eps",
 FontColor->RGBColor[0, 0, 1]]], "Subsection",
 CellChangeTimes->{{3.5696689255383005`*^9, 3.5696689379459915`*^9}, {
  3.569688771085614*^9, 3.569688772983144*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"func", "[", "m_", "]"}], ":=", 
   RowBox[{"Quiet", "[", 
    RowBox[{
     RowBox[{"dir", "=", "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\movies\\\\\>\""}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"namefile", "=", 
      RowBox[{
      "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\images\\\\th296\\\\\>\"", "<>", 
       "\"\<shotimag93.75th296f230fn\>\"", "<>", 
       RowBox[{"ToString", "[", "m", "]"}], "<>", "\"\<_501.dat\>\""}]}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"fi11", "=", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", 
        RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"params", "=", 
      RowBox[{"BinaryReadList", "[", 
       RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"a", "=", 
      RowBox[{"params", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"th", "=", 
      RowBox[{"Round", "[", 
       RowBox[{
        RowBox[{"Round", "[", 
         RowBox[{
          FractionBox["180", "\[Pi]"], 
          RowBox[{"(", 
           RowBox[{"\[Pi]", "-", 
            RowBox[{"params", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "10"}], "]"}], "/",
         "10."}], "]"}]}], ";", 
     RowBox[{"nxy", "=", 
      RowBox[{"Round", "[", 
       RowBox[{"params", "[", 
        RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
     RowBox[{"nu", "=", 
      RowBox[{"Round", "[", 
       RowBox[{"params", "[", 
        RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxy", "=", 
      RowBox[{"params", "[", 
       RowBox[{"[", "5", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"heat", "=", 
      RowBox[{"params", "[", 
       RowBox[{"[", "6", "]"}], "]"}]}], ";", 
     RowBox[{"rnohor", "=", 
      RowBox[{"params", "[", 
       RowBox[{"[", "7", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"freqtab", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"BinaryReadList", "[", 
           RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", 
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{"flen", "+", "1"}], ")"}]}]}], "]"}], ",", "2"}], 
         "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"inten", "=", 
      RowBox[{"BinaryReadList", "[", 
       RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"partres", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"inten", ",", "5"}], "]"}], ",", 
        RowBox[{"nxy", "+", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Close", "[", "fi11", "]"}], ";", 
     RowBox[{"nana", "=", 
      RowBox[{
       RowBox[{"ToString", "[", 
        RowBox[{"Round", "[", 
         RowBox[{"100", " ", "a"}], "]"}], "]"}], "<>", "\"\<th\>\"", "<>", 
       RowBox[{"StringJoin", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", "#", "]"}], "&"}], "/@", 
         RowBox[{"PadLeft", "[", 
          RowBox[{
           RowBox[{"IntegerDigits", "[", 
            RowBox[{"Round", "[", 
             RowBox[{"100", " ", 
              RowBox[{"params", "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], ",", "3"}], 
          "]"}]}], "]"}], "<>", "\"\<f\>\"", "<>", 
       RowBox[{"ToString", "[", "nu", "]"}], "<>", "\"\<s\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"4", "m"}], "]"}], "<>", "\"\<.jpg\>\""}]}], ";", 
     RowBox[{"nameQU", "=", 
      RowBox[{"dir", "<>", "\"\<shotQUa\>\"", "<>", "nana"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"scI", "=", 
        RowBox[{"-", "9."}]}], ";", 
       RowBox[{"scL", "=", 
        RowBox[{"-", "11.1"}]}], ";", 
       RowBox[{"scV", "=", 
        RowBox[{"4", " ", 
         SuperscriptBox["10", 
          RowBox[{"-", "6."}]]}]}], ";"}], 
      RowBox[{"(*", 
       RowBox[{"\[Nu]", "=", 
        RowBox[{"102", "GHz"}]}], "*)"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"scI", "=", 
      RowBox[{"-", "7.1"}]}], ";", 
     RowBox[{"scL", "=", 
      RowBox[{"-", "8.9"}]}], ";", 
     RowBox[{"conlum", "=", "3"}], ";", 
     RowBox[{"conLP", "=", "2.0"}], ";", 
     RowBox[{"scV", "=", 
      RowBox[{"13", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "6."}]]}]}], ";", 
     RowBox[{"(*", 
      RowBox[{"\[Nu]", "=", 
       RowBox[{"231", "GHz", " ", "for", " ", "th238"}]}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"scI", "=", 
      RowBox[{"-", "7.1"}]}], ";", 
     RowBox[{"scL", "=", 
      RowBox[{"-", "8.6"}]}], ";", 
     RowBox[{"conlum", "=", "2.5"}], ";", 
     RowBox[{"conLP", "=", "2.5"}], ";", 
     RowBox[{"scV", "=", 
      RowBox[{"13", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "6."}]]}]}], ";", 
     RowBox[{"(*", 
      RowBox[{"\[Nu]", "=", 
       RowBox[{"231", "GHz", " ", "for", " ", "th296"}]}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"scI", "=", 
        RowBox[{"-", "5.6"}]}], ";", 
       RowBox[{"scL", "=", 
        RowBox[{"-", "6.8"}]}], ";", 
       RowBox[{"scV", "=", 
        RowBox[{"7", " ", 
         SuperscriptBox["10", 
          RowBox[{"-", "6."}]]}]}], ";", 
       RowBox[{"conlum", "=", "9"}], ";", 
       RowBox[{"conLP", "=", "2.5"}], ";"}], 
      RowBox[{"(*", 
       RowBox[{"\[Nu]", "=", 
        RowBox[{"857", "GHz", " ", "for", " ", "th238"}]}], "*)"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"ord", "=", "1"}], ";", 
     RowBox[{"csc", "=", "1.0"}], ";", 
     RowBox[{"sss", "=", "0.6"}], ";", 
     RowBox[{"plpoi", "=", "200"}], ";", 
     RowBox[{"plpoi", "=", "200"}], ";", 
     RowBox[{"Nlines", "=", "30"}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"conlum", "=", "10"}], ";"}], "*)"}], 
     RowBox[{"cLP", "=", "0.95"}], ";", "\[IndentingNewLine]", 
     RowBox[{"li", "=", 
      RowBox[{"ListInterpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{
          SuperscriptBox["10", 
           RowBox[{"-", "10"}]], "+", 
          RowBox[{"partres", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"linQ", "=", 
      RowBox[{"ListInterpolation", "[", 
       RowBox[{
        RowBox[{"partres", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"linU", "=", 
      RowBox[{"ListInterpolation", "[", 
       RowBox[{
        RowBox[{"partres", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", "3"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"linV", "=", 
      RowBox[{"ListInterpolation", "[", 
       RowBox[{
        RowBox[{"partres", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", "4"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], ";", 
     RowBox[{"csc", "=", "1"}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"totI", "[", "m", "]"}], "=", 
      RowBox[{"DensityPlot", "[", 
       RowBox[{
        RowBox[{"rr", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"li", "[", 
              RowBox[{"y", ",", "x"}], "]"}], "-", "scI"}], ")"}], "/", 
           RowBox[{"Log", "[", "conlum", "]"}]}], "+", "1"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", 
          RowBox[{
           RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
          RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"y", ",", 
          RowBox[{
           RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
          RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"PlotPoints", "\[Rule]", "plpoi"}], ",", 
        RowBox[{"ColorFunction", "\[Rule]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"RGBColor", "[", 
            RowBox[{
             RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
             RowBox[{"#1", " ", "csc"}], ",", 
             RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
        RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"Axes", "\[Rule]", "False"}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
           RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
           RowBox[{"FontSize", "\[Rule]", "20"}]}], "}"}]}], 
        RowBox[{"(*", 
         RowBox[{",", 
          RowBox[{"Epilog", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Text", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{
                "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): a=\>\"", "<>", 
                 RowBox[{"ToString", "[", "a", "]"}], "<>", 
                 "\"\<,   \[Nu]=\>\"", "<>", 
                 RowBox[{"ToString", "[", 
                  RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
                 "\"\<GHz,    \[Theta]=\>\"", "<>", 
                 RowBox[{"ToString", "[", "th", "]"}], "<>", 
                 "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", "Pink"}],
                "]"}], ",", 
              RowBox[{"Scaled", "[", 
               RowBox[{"{", 
                RowBox[{"0.5", ",", "0.92"}], "}"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0"}], "}"}], ",", 
              RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
         "*)"}], ",", 
        RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"totV", "=", 
        RowBox[{"DensityPlot", "[", 
         RowBox[{
          RowBox[{"res", "=", 
           RowBox[{"linV", "[", 
            RowBox[{"y", ",", "x"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", 
            RowBox[{
             RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
            RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", 
            RowBox[{
             RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
            RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
          RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
          RowBox[{"ColorFunction", "\[Rule]", 
           RowBox[{"Function", "[", 
            RowBox[{
             RowBox[{"{", "n", "}"}], ",", 
             RowBox[{
              RowBox[{"r", "=", 
               RowBox[{"n", "/", "scV"}]}], ";", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"r", ">", "0"}], ",", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{
                  RowBox[{"2", "r"}], ",", "r", ",", "r"}], "]"}], ",", 
                RowBox[{"RGBColor", "[", 
                 RowBox[{
                  RowBox[{"-", "r"}], ",", 
                  RowBox[{"-", "r"}], ",", 
                  RowBox[{
                   RowBox[{"-", "2"}], "r"}]}], "]"}]}], "]"}]}]}], "]"}]}], 
          ",", 
          RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
          RowBox[{"Frame", "\[Rule]", "True"}], ",", 
          RowBox[{"FrameStyle", "\[Rule]", 
           RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
          RowBox[{"Axes", "\[Rule]", "False"}], ",", 
          RowBox[{"BaseStyle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
             RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
             RowBox[{"FontSize", "\[Rule]", "22"}]}], "}"}]}], ",", 
          RowBox[{"Epilog", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Text", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"\"\<V: a=\>\"", "<>", 
                 RowBox[{"ToString", "[", "a", "]"}], "<>", 
                 "\"\<,  \[Nu]=\>\"", "<>", 
                 RowBox[{"ToString", "[", 
                  RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
                 "\"\<GHz,   \[Theta]=\>\"", "<>", 
                 RowBox[{"ToString", "[", "th", "]"}], "<>", 
                 "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", "Pink"}],
                "]"}], ",", 
              RowBox[{"Scaled", "[", 
               RowBox[{"{", 
                RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0"}], "}"}], ",", 
              RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}], 
          ",", 
          RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], ";"}], 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Red", " ", "-", " ", "positive"}], ",", " ", 
        RowBox[{"Blue", " ", "-", " ", "negative"}]}], "*)"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"totQU", "[", "m", "]"}], "=", 
      RowBox[{"VectorDensityPlot", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"A", "=", 
            RowBox[{"linQ", "[", 
             RowBox[{"y", ",", "x"}], "]"}]}], ";", 
           RowBox[{"B", "=", 
            RowBox[{"linU", "[", 
             RowBox[{"y", ",", "x"}], "]"}]}], ";", 
           RowBox[{"ann", "=", 
            FractionBox[
             RowBox[{"ArcTan", "[", 
              RowBox[{"A", ",", "B"}], "]"}], "2"]}], ";", 
           RowBox[{"Cos", "[", "ann", "]"}]}], ",", 
          RowBox[{"-", 
           RowBox[{"Sin", "[", "ann", "]"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", 
          RowBox[{
           RowBox[{"-", "cLP"}], " ", "sss", " ", "maxy"}], ",", 
          RowBox[{"cLP", " ", "sss", " ", "maxy"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"y", ",", 
          RowBox[{
           RowBox[{"-", "cLP"}], " ", "sss", " ", "maxy"}], ",", 
          RowBox[{"cLP", " ", "sss", " ", "maxy"}]}], "}"}], ",", 
        RowBox[{"VectorPoints", "\[Rule]", "Nlines"}], ",", 
        RowBox[{"VectorStyle", "\[Rule]", 
         RowBox[{"Arrowheads", "[", "0", "]"}]}], ",", 
        RowBox[{"StreamStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Arrowheads", "[", "0", "]"}], ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"1", ",", "0.5", ",", "0.5"}], "]"}]}], "}"}]}], ",", 
        RowBox[{"StreamPoints", "\[Rule]", "Nlines"}], ",", 
        RowBox[{"StreamScale", "\[Rule]", "Full"}], ",", 
        RowBox[{"MaxRecursion", "\[Rule]", "2"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"ColorFunction", "\[Rule]", 
         RowBox[{"Function", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x", ",", "y", ",", "vx", ",", "vy", ",", "n"}], "}"}], 
           ",", 
           RowBox[{
            RowBox[{"w", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  FractionBox["1", "2"], 
                  RowBox[{"Log", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"linQ", "[", 
                    RowBox[{"y", ",", "x"}], "]"}], "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"linU", "[", 
                    RowBox[{"y", ",", "x"}], "]"}], "^", "2"}]}], "]"}]}], 
                 "-", "scL"}], ")"}], "/", 
               RowBox[{"Log", "[", "conLP", "]"}]}], "+", "1"}]}], ";", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"2", " ", "w", " ", "csc"}], ",", 
              RowBox[{"w", " ", "csc"}], ",", 
              RowBox[{"w", " ", "csc"}]}], "]"}]}]}], "]"}]}], ",", 
        RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"Axes", "\[Rule]", "False"}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
           RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
           RowBox[{"FontSize", "\[Rule]", "20"}]}], "}"}]}]}], 
       RowBox[{"(*", 
        RowBox[{",", 
         RowBox[{"Epilog", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
               RowBox[{
               "\"\<\!\(\*SqrtBox[\(\*SuperscriptBox[\(Q\), \(2\)] + \
\*SuperscriptBox[\(U\), \(2\)]\)]\) & field: a=\>\"", "<>", 
                RowBox[{"ToString", "[", "a", "]"}], "<>", 
                "\"\<,  \[Nu]=\>\"", "<>", 
                RowBox[{"ToString", "[", 
                 RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
                "\"\<GHz,   \[Theta]=\>\"", "<>", 
                RowBox[{"ToString", "[", "th", "]"}], "<>", 
                "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", "Pink"}], 
              "]"}], ",", 
             RowBox[{"Scaled", "[", 
              RowBox[{"{", 
               RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0"}], "}"}], ",", 
             RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
        "*)"}], "]"}]}], ";", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"totI", "[", "m", "]"}], ",", 
       RowBox[{"totQU", "[", "m", "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Dynamic", "[", "j", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pltab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"func", "[", "j", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "6380", ",", "6404", ",", "6"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"pltab", "=", 
    RowBox[{"{", 
     RowBox[{"func", "[", "6380", "]"}], "}"}]}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5696689391560097`*^9, 3.569668939578516*^9}, {
   3.5696728884532504`*^9, 3.569672896803378*^9}, {3.5696747052786055`*^9, 
   3.569674747645256*^9}, {3.569674838000145*^9, 3.569674838225148*^9}, {
   3.5696818601674557`*^9, 3.569682002597143*^9}, {3.5696820475228333`*^9, 
   3.5696821268490515`*^9}, {3.569682195163602*^9, 3.5696822086613092`*^9}, {
   3.5696822572550564`*^9, 3.569682257847565*^9}, {3.56968230241325*^9, 
   3.569682326153614*^9}, {3.56968269363526*^9, 3.5696827254782495`*^9}, {
   3.569682996234908*^9, 3.5696830152902007`*^9}, 3.569683056060827*^9, {
   3.5696837667097445`*^9, 3.569683796577703*^9}, 3.569684499033492*^9, 
   3.569684545416705*^9, 3.569684613407749*^9, 3.5696846517208376`*^9, {
   3.569684697259037*^9, 3.5696847373021526`*^9}, {3.5696848079607377`*^9, 
   3.5696848248009963`*^9}, 3.5696848895294905`*^9, {3.5696873443386974`*^9, 
   3.569687345876221*^9}, {3.56968744147869*^9, 3.5696875678081307`*^9}, {
   3.5696876027461677`*^9, 3.5696876532694435`*^9}, 3.5696877316256475`*^9, {
   3.5697750571315465`*^9, 3.569775057583947*^9}, 3.569775247514281*^9, {
   3.5699319856279435`*^9, 3.569931988233148*^9}, {3.5760557780690928`*^9, 
   3.5760557781540937`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"grfl", "=", 
     RowBox[{"GraphicsRow", "[", 
      RowBox[{"pltab", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Export", "[", 
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\!svn\\\\figures\\\\imageflux.eps\>\"", ",", "grfl", ",", 
       RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", " ", 
       RowBox[{"ImageResolution", "\[Rule]", "150"}]}], "]"}], 
     "\[IndentingNewLine]", 
     RowBox[{"grLP", "=", 
      RowBox[{"GraphicsRow", "[", 
       RowBox[{"pltab", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
     "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\!svn\\\\figures\\\\imageLP.eps\>\"", ",", "grLP", ",", 
      RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", " ", 
      RowBox[{"ImageResolution", "\[Rule]", "150"}]}], "]"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ratio", "=", "0.34"}], ";", 
    RowBox[{"ysc", "=", "10"}], ";", 
    RowBox[{"num", "=", "15"}], ";", 
    RowBox[{"xsc", "=", 
     RowBox[{"ratio", " ", "ysc"}]}], ";", 
    RowBox[{
     RowBox[{"fcol", "[", "a_", "]"}], ":=", 
     SuperscriptBox["a", "2."]}], ";", 
    RowBox[{
     RowBox[{"fnI", "[", "i_", "]"}], ":=", 
     SuperscriptBox["2.6", 
      RowBox[{"i", "-", "1."}]]}], ";", 
    RowBox[{"dr", "=", "0.95"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"nf", "[", "scV_", "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"z", "=", 
        RowBox[{"Floor", "[", 
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "scV"}], "]"}], "]"}]}], ";", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"Floor", "[", 
          RowBox[{
           RowBox[{
            SuperscriptBox["10", 
             RowBox[{"-", "z"}]], "scV"}], ",", "0.01"}], "]"}], "]"}], "<>", 
        "\"\<e\>\"", "<>", 
        RowBox[{"ToString", "[", "z", "]"}]}]}], ")"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"legfl", "=", 
      RowBox[{"Graphics", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.8", ",", "1", ",", "1.0"}], "]"}], ",", 
           RowBox[{"Rectangle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"xsc", ",", 
               RowBox[{"1.05", "ysc"}]}], "}"}]}], "]"}]}], "}"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"rr", "=", 
               RowBox[{
                RowBox[{
                 RowBox[{"Log", "[", 
                  RowBox[{"fnI", "[", "i", "]"}], "]"}], "/", 
                 RowBox[{"Log", "[", "conlum", "]"}]}], "+", "1"}]}], ";", 
              RowBox[{"RGBColor", "[", 
               RowBox[{
                RowBox[{"2", "rr", " ", "csc"}], ",", 
                RowBox[{"rr", " ", "csc"}], ",", 
                RowBox[{"rr", " ", "csc"}]}], "]"}]}], ",", 
             RowBox[{"Rectangle", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"0.05", "xsc"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", 
                    FractionBox["0.1", "num"]}], "ysc"}], "+", 
                  RowBox[{"dr", 
                   FractionBox[
                    RowBox[{"ysc", " ", "i"}], 
                    RowBox[{"num", "+", "1"}]], "num"}]}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"0.4", "xsc"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", 
                    FractionBox["0.1", "num"]}], "ysc"}], "+", 
                  RowBox[{"dr", 
                   FractionBox[
                    RowBox[{"ysc", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "num"}], "+", "1"}], ")"}]}], 
                    RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}]}], "}"}],
            ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", "1", ",", 
             FractionBox["1", "num"]}], "}"}]}], "]"}], ",", "Black", ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
               RowBox[{"ToString", "[", 
                RowBox[{"NumberForm", "[", 
                 RowBox[{
                  RowBox[{"fnI", "[", "i", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}]}], "]"}], "]"}], ",", 
               "15"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.7", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "num"}], "+", "0.5"}], ")"}]}], 
                  RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", "1", ",", 
             FractionBox["1", "num"]}], "}"}]}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"\"\<x\>\"", "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"NumberForm", "[", 
                RowBox[{
                 RowBox[{"Exp", "[", "scI", "]"}], ",", "2"}], "]"}], "]"}]}],
              ",", "14", ",", "Bold"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"0.5", "xsc"}], ",", 
             RowBox[{"0.98", "ysc"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}], ",", 
     RowBox[{"legLP", "=", 
      RowBox[{"Graphics", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.8", ",", "1", ",", "1.0"}], "]"}], ",", 
           RowBox[{"Rectangle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"xsc", ",", 
               RowBox[{"1.05", "ysc"}]}], "}"}]}], "]"}]}], "}"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"rr", "=", 
               RowBox[{
                RowBox[{
                 RowBox[{"Log", "[", 
                  RowBox[{"fnI", "[", "i", "]"}], "]"}], "/", 
                 RowBox[{"Log", "[", "conLP", "]"}]}], "+", "1"}]}], ";", 
              RowBox[{"RGBColor", "[", 
               RowBox[{
                RowBox[{"2", "rr", " ", "csc"}], ",", 
                RowBox[{"rr", " ", "csc"}], ",", 
                RowBox[{"rr", " ", "csc"}]}], "]"}]}], ",", 
             RowBox[{"Rectangle", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"0.05", "xsc"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", 
                    FractionBox["0.1", "num"]}], "ysc"}], "+", 
                  RowBox[{"dr", 
                   FractionBox[
                    RowBox[{"ysc", " ", "i"}], 
                    RowBox[{"num", "+", "1"}]], "num"}]}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"0.4", "xsc"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", 
                    FractionBox["0.1", "num"]}], "ysc"}], "+", 
                  RowBox[{"dr", 
                   FractionBox[
                    RowBox[{"ysc", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "num"}], "+", "1"}], ")"}]}], 
                    RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}]}], "}"}],
            ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", "1", ",", 
             FractionBox["1", "num"]}], "}"}]}], "]"}], ",", "Black", ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
               RowBox[{"ToString", "[", 
                RowBox[{"NumberForm", "[", 
                 RowBox[{
                  RowBox[{"fnI", "[", "i", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}]}], "]"}], "]"}], ",", 
               "15"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.7", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "num"}], "+", "0.5"}], ")"}]}], 
                  RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", "1", ",", 
             FractionBox["1", "num"]}], "}"}]}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"\"\<x\>\"", "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"NumberForm", "[", 
                RowBox[{
                 RowBox[{"Exp", "[", "scL", "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"5", ",", "5"}], "}"}]}], "]"}], "]"}]}], ",", "14",
              ",", "Bold"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"0.5", "xsc"}], ",", 
             RowBox[{"0.98", "ysc"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}]}], 
    "}"}]}]}]], "Input",
 CellChangeTimes->{{3.569687166280963*^9, 3.5696871732935705`*^9}, {
  3.569687222966833*^9, 3.5696872262968845`*^9}, {3.5696872676950207`*^9, 
  3.5696872678325224`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"mysize", "=", "16"}], ";", 
    RowBox[{"sixe", "=", 
     RowBox[{"0.22", "+", 
      RowBox[{"sss", " ", "maxy"}]}]}], ";", 
    RowBox[{"siz", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "sixe"}], ",", "sixe"}], "}"}]}], ";", 
    RowBox[{"sLP", "=", 
     RowBox[{"1.07", "+", 
      RowBox[{"sss", " ", "maxy"}]}]}], ";", 
    RowBox[{"sLP", "=", "siz"}], ";", "\[IndentingNewLine]", 
    RowBox[{"lin", "=", 
     RowBox[{"LinTicks", "[", 
      RowBox[{
       RowBox[{"-", "10"}], ",", "10", ",", "5", ",", "5"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"figv", "=", 
     RowBox[{"Figure", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"ScaledLabel", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.55", ",", "0.95"}], "}"}], ",", "\"\<VHaha\>\"", ",", 
            RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
            RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
            RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
            RowBox[{"Offset", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ","}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Multipanel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "6"}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"XPlotRanges", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "siz", ",", "siz", ",", "siz", ",", "siz", ",", "siz", ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "xsc"}], "}"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "siz", ",", "siz", ",", "siz", ",", "siz", ",", "siz", ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "xsc"}], "}"}]}], "}"}]}], "}"}]}], 
             ","}], "*)"}], 
           RowBox[{"YPlotRanges", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
               "siz", ",", "siz", ",", "siz", ",", "siz", ",", "siz", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "0.05"}], "ysc"}], ",", 
                  RowBox[{"1.02", "ysc"}]}], "}"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
               "siz", ",", "siz", ",", "siz", ",", "siz", ",", "siz", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "0.05"}], "ysc"}], ",", 
                  RowBox[{"1.02", "ysc"}]}], "}"}]}], "}"}]}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"XPlotRanges", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "siz", ",", "siz", ",", "siz", ",", "siz", ",", "siz", ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "xsc"}], "}"}]}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"XPanelSizes", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0.3"}], 
             "}"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"XFrameLabels", "\[Rule]", "None"}], ",", 
           RowBox[{"BufferB", "\[Rule]", "6"}], ",", 
           RowBox[{"YFrameLabels", "\[Rule]", 
            RowBox[{"{", "None", "}"}]}], ",", 
           RowBox[{"BufferL", "\[Rule]", "2"}], ",", 
           RowBox[{"TickFontSize", "\[Rule]", "mysize"}], ",", 
           RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"XFrameTicks", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "lin", ",", "lin", ",", "lin", ",", "lin", ",", "lin", ",", 
              "None"}], "}"}]}], ",", 
           RowBox[{"YFrameTicks", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
               "lin", ",", "lin", ",", "lin", ",", "lin", ",", "lin", ",", 
                "None"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
               "lin", ",", "lin", ",", "lin", ",", "lin", ",", "lin", ",", 
                "None"}], "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"XPanelSizes", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"1", ",", "0.2"}], "}"}]}], ",", 
             RowBox[{"YPanelSizes", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1"}], "}"}]}], ",", ",", 
             RowBox[{"YGapSizes", "\[Rule]", 
              RowBox[{"{", "0", "}"}]}], ","}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"XGapSizes", "\[Rule]", "0.00"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Background", "\[Rule]", "White"}], ",", 
           RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
           RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"PanelLetterCorner", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
           RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
           RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
           RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"FigurePanel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"PanelLetter", "\[Rule]", "\"\<(a1)\>\""}]}], "]"}], ",", 
         RowBox[{"RawGraphics", "[", 
          RowBox[{
           RowBox[{"pltab", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"FigurePanel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "2"}], "}"}], ",", 
           RowBox[{"PanelLetter", "\[Rule]", "\"\<(b1)\>\""}]}], "]"}], ",", 
         RowBox[{"RawGraphics", "[", 
          RowBox[{
           RowBox[{"pltab", "[", 
            RowBox[{"[", 
             RowBox[{"2", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"FigurePanel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "3"}], "}"}], ",", 
           RowBox[{"PanelLetter", "\[Rule]", "\"\<(c1)\>\""}]}], "]"}], ",", 
         RowBox[{"RawGraphics", "[", 
          RowBox[{
           RowBox[{"pltab", "[", 
            RowBox[{"[", 
             RowBox[{"3", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"FigurePanel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "4"}], "}"}], ",", 
           RowBox[{"PanelLetter", "\[Rule]", "\"\<(d1)\>\""}]}], "]"}], ",", 
         RowBox[{"RawGraphics", "[", 
          RowBox[{
           RowBox[{"pltab", "[", 
            RowBox[{"[", 
             RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"FigurePanel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "5"}], "}"}], ",", 
           RowBox[{"PanelLetter", "\[Rule]", "\"\<(e1)\>\""}]}], "]"}], ",", 
         RowBox[{"RawGraphics", "[", 
          RowBox[{
           RowBox[{"pltab", "[", 
            RowBox[{"[", 
             RowBox[{"5", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"FigurePanel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "6"}], "}"}], ",", 
           RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
         RowBox[{"RawGraphics", "[", 
          RowBox[{"legfl", ",", 
           RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"FigurePanel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "1"}], "}"}], ",", 
           RowBox[{"PanelLetter", "\[Rule]", "\"\<(a2)\>\""}]}], "]"}], ",", 
         RowBox[{"RawGraphics", "[", 
          RowBox[{
           RowBox[{"pltab", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"FigurePanel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "2"}], "}"}], ",", 
           RowBox[{"PanelLetter", "\[Rule]", "\"\<(b2)\>\""}]}], "]"}], ",", 
         RowBox[{"RawGraphics", "[", 
          RowBox[{
           RowBox[{"pltab", "[", 
            RowBox[{"[", 
             RowBox[{"2", ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"FigurePanel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"PanelLetter", "\[Rule]", "\"\<(c2)\>\""}]}], "]"}], ",", 
         RowBox[{"RawGraphics", "[", 
          RowBox[{
           RowBox[{"pltab", "[", 
            RowBox[{"[", 
             RowBox[{"3", ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"FigurePanel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "4"}], "}"}], ",", 
           RowBox[{"PanelLetter", "\[Rule]", "\"\<(d2)\>\""}]}], "]"}], ",", 
         RowBox[{"RawGraphics", "[", 
          RowBox[{
           RowBox[{"pltab", "[", 
            RowBox[{"[", 
             RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"FigurePanel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "5"}], "}"}], ",", 
           RowBox[{"PanelLetter", "\[Rule]", "\"\<(e2)\>\""}]}], "]"}], ",", 
         RowBox[{"RawGraphics", "[", 
          RowBox[{
           RowBox[{"pltab", "[", 
            RowBox[{"[", 
             RowBox[{"5", ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"FigurePanel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "6"}], "}"}], ",", 
           RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
         RowBox[{"RawGraphics", "[", 
          RowBox[{"legLP", ",", 
           RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.03"}], ",", "1.01"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.07"}], ",", "1.04"}], "}"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1060", ",", "430"}], "}"}]}]}], "]"}]}]}], 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"266", "x258", " ", "for", " ", "1100", "x430"}], ";", " ", 
     RowBox[{"255", "x258", " ", "for", " ", "1050", "x430"}]}], "*)"}], 
   "*)"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.5696835525414543`*^9, 3.56968370588131*^9}, {
   3.5696838329007607`*^9, 3.569684223764264*^9}, {3.5696842549947443`*^9, 
   3.5696843022929707`*^9}, {3.56968433871353*^9, 3.56968445981539*^9}, {
   3.5696845799672356`*^9, 3.5696845984300194`*^9}, {3.5696847851903877`*^9, 
   3.5696847891404486`*^9}, {3.5696848574589977`*^9, 
   3.5696848743042564`*^9}, {3.5696859836132965`*^9, 3.569686047584279*^9}, {
   3.5696861430167456`*^9, 3.569686186154908*^9}, {3.569686232375618*^9, 
   3.569686270041197*^9}, {3.5696863064217553`*^9, 3.5696863191119504`*^9}, {
   3.569686492459613*^9, 3.569686704750374*^9}, {3.569686756211164*^9, 
   3.569686770121378*^9}, {3.5696868554851885`*^9, 3.569686863607814*^9}, {
   3.5696870240852785`*^9, 3.5696870244077835`*^9}, {3.569687068518461*^9, 
   3.5696870871737475`*^9}, 3.5696871259293427`*^9, {3.569687911188405*^9, 
   3.5696879186385193`*^9}, 3.5697750771307817`*^9, {3.576056492355075*^9, 
   3.5760564984412484`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mysize", "=", "16"}], ";", 
  RowBox[{"sixe", "=", 
   RowBox[{"0.22", "+", 
    RowBox[{"sss", " ", "maxy"}]}]}], ";", 
  RowBox[{"siz", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "sixe"}], ",", "sixe"}], "}"}]}], ";", 
  RowBox[{"sLP", "=", 
   RowBox[{"1.07", "+", 
    RowBox[{"sss", " ", "maxy"}]}]}], ";", 
  RowBox[{"sLP", "=", "siz"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lin", "=", 
   RowBox[{"LinTicks", "[", 
    RowBox[{
     RowBox[{"-", "10"}], ",", "10", ",", "5", ",", "5"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"figvx", "=", 
  RowBox[{"Figure", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"ScaledLabel", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.55", ",", "0.95"}], "}"}], ",", "\"\<VHaha\>\"", ",", 
         RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
         RowBox[{"Offset", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ","}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Multipanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "5"}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"XPlotRanges", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "siz", ",", "siz", ",", "siz", ",", "siz", ",", "siz", ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "xsc"}], "}"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "siz", ",", "siz", ",", "siz", ",", "siz", ",", "siz", ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "xsc"}], "}"}]}], "}"}]}], "}"}]}], ","}], 
         "*)"}], 
        RowBox[{"YPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"siz", ",", "siz", ",", "siz", ",", "siz", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}], ",", 
               RowBox[{"1.02", "ysc"}]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"siz", ",", "siz", ",", "siz", ",", "siz", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}], ",", 
               RowBox[{"1.02", "ysc"}]}], "}"}]}], "}"}]}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"XPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"siz", ",", "siz", ",", "siz", ",", "siz", ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "xsc"}], "}"}]}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"XPanelSizes", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "0.3"}], "}"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"XFrameLabels", "\[Rule]", "None"}], ",", 
        RowBox[{"BufferB", "\[Rule]", "6"}], ",", 
        RowBox[{"YFrameLabels", "\[Rule]", 
         RowBox[{"{", "None", "}"}]}], ",", 
        RowBox[{"BufferL", "\[Rule]", "2"}], ",", 
        RowBox[{"TickFontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", "\[IndentingNewLine]", 
        RowBox[{"XFrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"lin", ",", "lin", ",", "lin", ",", "lin", ",", "None"}], 
          "}"}]}], ",", 
        RowBox[{"YFrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"lin", ",", "lin", ",", "lin", ",", "lin", ",", "None"}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"lin", ",", "lin", ",", "lin", ",", "lin", ",", "None"}], 
            "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"XPanelSizes", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0.2"}], "}"}]}], ",", 
          RowBox[{"YPanelSizes", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}]}], ",", ",", 
          RowBox[{"YGapSizes", "\[Rule]", 
           RowBox[{"{", "0", "}"}]}], ","}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"XGapSizes", "\[Rule]", "0.00"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Background", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PanelLetterCorner", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
        RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(a1)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{
        RowBox[{"pltab", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.5", ",", "0.94"}], "}"}], ",", 
        "\"\<\[CapitalDelta]t=24M\>\"", ",", 
        RowBox[{"Color", "\[Rule]", "White"}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(b1)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{
        RowBox[{"pltab", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "1"}], "]"}], "]"}], ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.5", ",", "0.94"}], "}"}], ",", 
        "\"\<\[CapitalDelta]t=48M\>\"", ",", 
        RowBox[{"Color", "\[Rule]", "White"}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "3"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(c1)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{
        RowBox[{"pltab", "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "1"}], "]"}], "]"}], ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.5", ",", "0.94"}], "}"}], ",", 
        "\"\<\[CapitalDelta]t=72M\>\"", ",", 
        RowBox[{"Color", "\[Rule]", "White"}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "4"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(d1)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{
        RowBox[{"pltab", "[", 
         RowBox[{"[", 
          RowBox[{"4", ",", "1"}], "]"}], "]"}], ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.5", ",", "0.94"}], "}"}], ",", 
        "\"\<\[CapitalDelta]t=96M\>\"", ",", 
        RowBox[{"Color", "\[Rule]", "White"}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "5"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"legfl", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(a2)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{
        RowBox[{"pltab", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "2"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(b2)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{
        RowBox[{"pltab", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "2"}], "]"}], "]"}], ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "3"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(c2)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{
        RowBox[{"pltab", "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "2"}], "]"}], "]"}], ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "4"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(d2)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{
        RowBox[{"pltab", "[", 
         RowBox[{"[", 
          RowBox[{"4", ",", "2"}], "]"}], "]"}], ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "5"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"legLP", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.03"}], ",", "1.01"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.07"}], ",", "1.04"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"860", ",", "430"}], "}"}]}]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"266", "x258", " ", "for", " ", "1100", "x430"}], ";", " ", 
    RowBox[{"255", "x258", " ", "for", " ", "1050", "x430"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5697750856483965`*^9, 3.5697751471125045`*^9}, {
  3.5699767050697503`*^9, 3.5699767232905827`*^9}, {3.5699767875566945`*^9, 
  3.569976790115099*^9}, {3.5699768439055905`*^9, 3.5699769107501063`*^9}, {
  3.569976963771399*^9, 3.5699769751750193`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD QPOs\\\\!svn\\\
\\figures\\\\imagetotalx.eps\>\"", ",", "figvx", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", " ", 
   RowBox[{"ImageResolution", "\[Rule]", "150"}]}], "]"}]], "Input",
 CellChangeTimes->{3.569775088128801*^9, 3.576056056250367*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Period=\>\"", ",", 
    FractionBox[
     RowBox[{"26020", "-", "25500"}], "5"]}], "]"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"should", " ", "get", " ", 
     RowBox[{"snapshots", ":", " ", "25620"}]}], ",", " ", "25644", ",", " ", 
    "25668", ",", " ", "25692", ",", " ", "25716"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
   "25620", ",", " ", "25644", ",", " ", "25668", ",", " ", "25692", ",", " ",
     "25716"}], "}"}], "/", "4"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{"25520", ",", "25544", ",", "25568", ",", "25592", ",", "25616"}], 
   "}"}], "/", "4"}]}], "Input",
 CellChangeTimes->{
  3.569674718209804*^9, {3.5699767760438747`*^9, 3.5699767764494753`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"scI", "=", 
   RowBox[{"-", "7.1"}]}], ";", 
  RowBox[{"conlum", "=", "2.5"}], ";", 
  RowBox[{"Quiet", "[", 
   RowBox[{"totI", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"rr", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"li", "[", 
            RowBox[{"y", ",", "x"}], "]"}], "-", "scI"}], ")"}], "/", 
         RowBox[{"Log", "[", "conlum", "]"}]}], "+", "1"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{
           RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "24"}]}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{
            "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): a=\>\"", "<>", 
             RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,   \[Nu]=\>\"", 
             "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
             "\"\<GHz,    \[Theta]=\>\"", "<>", 
             RowBox[{"ToString", "[", "th", "]"}], "<>", 
             "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", "Pink"}], 
           "]"}], ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.92"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"scL", "=", 
   RowBox[{"-", "8.6"}]}], ";", 
  RowBox[{"conLP", "=", "2.5"}], ";", 
  RowBox[{"Quiet", "[", 
   RowBox[{"totQU", "=", 
    RowBox[{"VectorDensityPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"A", "=", 
          RowBox[{"linQ", "[", 
           RowBox[{"y", ",", "x"}], "]"}]}], ";", 
         RowBox[{"B", "=", 
          RowBox[{"linU", "[", 
           RowBox[{"y", ",", "x"}], "]"}]}], ";", 
         RowBox[{"ann", "=", 
          FractionBox[
           RowBox[{"ArcTan", "[", 
            RowBox[{"A", ",", "B"}], "]"}], "2"]}], ";", 
         RowBox[{"Cos", "[", "ann", "]"}]}], ",", 
        RowBox[{"-", 
         RowBox[{"Sin", "[", "ann", "]"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"VectorPoints", "\[Rule]", "100"}], ",", 
      RowBox[{"VectorStyle", "\[Rule]", 
       RowBox[{"Arrowheads", "[", "0", "]"}]}], ",", 
      RowBox[{"StreamStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Arrowheads", "[", "0", "]"}], ",", 
         RowBox[{"RGBColor", "[", 
          RowBox[{"1", ",", "0.5", ",", "0.5"}], "]"}]}], "}"}]}], ",", 
      RowBox[{"StreamPoints", "\[Rule]", "100"}], ",", 
      RowBox[{"StreamScale", "\[Rule]", "Full"}], ",", 
      RowBox[{"MaxRecursion", "\[Rule]", "2"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"Function", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "y", ",", "vx", ",", "vy", ",", "n"}], "}"}], ",", 
         RowBox[{
          RowBox[{"w", "=", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                FractionBox["1", "2"], 
                RowBox[{"Log", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"linQ", "[", 
                    RowBox[{"y", ",", "x"}], "]"}], "^", "2"}], "+", 
                  RowBox[{
                   RowBox[{"linU", "[", 
                    RowBox[{"y", ",", "x"}], "]"}], "^", "2"}]}], "]"}]}], 
               "-", "scL"}], ")"}], "/", 
             RowBox[{"Log", "[", "conLP", "]"}]}], "+", "1"}]}], ";", 
          RowBox[{"RGBColor", "[", 
           RowBox[{
            RowBox[{"2", " ", "w", " ", "csc"}], ",", 
            RowBox[{"w", " ", "csc"}], ",", 
            RowBox[{"w", " ", "csc"}]}], "]"}]}]}], "]"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "22"}]}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{
            "\"\<\!\(\*SqrtBox[\(\*SuperscriptBox[\(Q\), \(2\)] + \
\*SuperscriptBox[\(U\), \(2\)]\)]\) & field: a=\>\"", "<>", 
             RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \[Nu]=\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
             "\"\<GHz,   \[Theta]=\>\"", "<>", 
             RowBox[{"ToString", "[", "th", "]"}], "<>", 
             "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", "Pink"}], 
           "]"}], ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
     "]"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"scV", "=", 
   RowBox[{"13", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "6"}]]}]}], ";", 
  RowBox[{"Quiet", "[", 
   RowBox[{"totV", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"res", "=", 
       RowBox[{"linV", "[", 
        RowBox[{"y", ",", "x"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"Function", "[", 
        RowBox[{
         RowBox[{"{", "n", "}"}], ",", 
         RowBox[{
          RowBox[{"r", "=", 
           RowBox[{"n", "/", "scV"}]}], ";", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"r", ">", "0"}], ",", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"2", "r"}], ",", "r", ",", "r"}], "]"}], ",", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"-", "r"}], ",", 
              RowBox[{"-", "r"}], ",", 
              RowBox[{
               RowBox[{"-", "2"}], "r"}]}], "]"}]}], "]"}]}]}], "]"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "22"}]}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"\"\<V: a=\>\"", "<>", 
             RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \[Nu]=\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
             "\"\<GHz,   \[Theta]=\>\"", "<>", 
             RowBox[{"ToString", "[", "th", "]"}], "<>", 
             "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", "Pink"}], 
           "]"}], ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"Red", " ", "-", " ", "positive"}], ",", " ", 
     RowBox[{"Blue", " ", "-", " ", "negative"}]}], "*)"}], "]"}]}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Figure periodograms.eps",
 FontColor->RGBColor[0, 0, 1]]], "Subsection",
 CellChangeTimes->{{3.5696893910431385`*^9, 3.569689408826412*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Dynamic", "[", "o", "]"}], ",", 
    RowBox[{"Dynamic", "[", "fnum", "]"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";", 
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"angles", "=", 
    RowBox[{"{", 
     RowBox[{
     "\"\<th248lo\>\"", ",", "\"\<th296lo\>\"", ",", "\"\<th174lo\>\"", ",", 
      "\"\<th248lo120phi\>\"", ",", "\"\<th248lo240phi\>\""}], "}"}]}], ";"}],
   "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"dir0", "=", 
     RowBox[{"\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\\>\"", "<>", 
      RowBox[{"angles", "[", 
       RowBox[{"[", "o", "]"}], "]"}], "<>", "\"\<\\\\\>\""}]}], ";", 
    RowBox[{
     RowBox[{"dix", "[", "o", "]"}], "=", "dir0"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"fil", "=", 
     RowBox[{"dir0", "<>", "\"\<totspec.dat\>\""}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"FileExistsQ", "[", "fil", "]"}], ",", 
      RowBox[{
       RowBox[{"impx", "[", "o", "]"}], "=", 
       RowBox[{"Get", "[", "fil", "]"}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"impx", "[", "o", "]"}], "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Import", "[", 
           RowBox[{"dir0", "<>", "\"\<poliresa93.75\>\"", "<>", 
            RowBox[{"StringTake", "[", 
             RowBox[{
              RowBox[{"angles", "[", 
               RowBox[{"[", "o", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "5"}], "}"}]}], "]"}], "<>", "\"\<fn\>\"", "<>", 
            RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}],
            "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"fnum", ",", "2000", ",", "6999"}], "}"}]}], "]"}]}], ";", 
       RowBox[{"Put", "[", 
        RowBox[{
         RowBox[{"impx", "[", "o", "]"}], ",", "fil"}], "]"}]}]}], "]"}], ";", 
    RowBox[{"Print", "[", 
     RowBox[{"o", ",", "\"\< \>\"", ",", 
      RowBox[{"angles", "[", 
       RowBox[{"[", "o", "]"}], "]"}], ",", "\"\< \>\"", ",", 
      RowBox[{"Dimensions", "[", 
       RowBox[{"impx", "[", "o", "]"}], "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"o", ",", "1", ",", "5"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"4", 
    RowBox[{
     RowBox[{"impx", "[", "1", "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"freqs", "=", 
   RowBox[{
    RowBox[{"impx", "[", "1", "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "All", ",", "2"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"coe", "=", "1"}], ";", 
    RowBox[{"kmin", "=", "3"}], ";", 
    RowBox[{"kmax", "=", "9"}], ";", 
    RowBox[{"kstep", "=", "3"}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"dix", "[", "1", "]"}], "=", 
     "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\th248lo\\\\\>\""}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"dix", "[", "2", "]"}], "=", 
     "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\th296lo\\\\\>\""}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"dix", "[", "3", "]"}], "=", 
     "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\th174lo\\\\\>\""}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"impx", "[", "1", "]"}], "=", 
     RowBox[{"Get", "[", 
      RowBox[{
       RowBox[{"dix", "[", "1", "]"}], "<>", "\"\<totspec.dat\>\""}], "]"}]}],
     ";", 
    RowBox[{"nums", "=", 
     RowBox[{"4", 
      RowBox[{
       RowBox[{"impx", "[", "1", "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}]}], ";", 
    RowBox[{"freqs", "=", 
     RowBox[{
      RowBox[{"impx", "[", "1", "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "All", ",", "2"}], "]"}], "]"}]}], ";", 
    RowBox[{
     RowBox[{
      RowBox[{"Dimensions", "[", 
       RowBox[{"impx", "[", "1", "]"}], "]"}], "\[IndentingNewLine]", 
      RowBox[{"impx", "[", "2", "]"}]}], "=", 
     RowBox[{"Get", "[", 
      RowBox[{
       RowBox[{"dix", "[", "2", "]"}], "<>", "\"\<totspec.dat\>\""}], "]"}]}],
     ";", 
    RowBox[{
     RowBox[{
      RowBox[{"Dimensions", "[", 
       RowBox[{"impx", "[", "2", "]"}], "]"}], "\[IndentingNewLine]", 
      RowBox[{"impx", "[", "3", "]"}]}], "=", 
     RowBox[{"Get", "[", 
      RowBox[{
       RowBox[{"dix", "[", "3", "]"}], "<>", "\"\<totspec.dat\>\""}], "]"}]}],
     ";", 
    RowBox[{"Dimensions", "[", 
     RowBox[{"impx", "[", "3", "]"}], "]"}]}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.569690907836939*^9, 3.569690966090334*^9}, {
  3.569774735695792*^9, 3.5697747442758074`*^9}, {3.5699453708725615`*^9, 
  3.569945376472972*^9}, {3.5808186044982586`*^9, 3.580818625741288*^9}, {
  3.580818677087361*^9, 3.5808187394716578`*^9}, {3.5808188407158356`*^9, 
  3.5808188475330477`*^9}}],

Cell[BoxData[{
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"means", "[", 
      RowBox[{"3", ",", "fr", ",", "th"}], "]"}], "=", 
     RowBox[{"Mean", "[", 
      RowBox[{
       RowBox[{"impx", "[", "th", "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}], "]"}]}], ";", 
    RowBox[{
     RowBox[{"means", "[", 
      RowBox[{"4", ",", "fr", ",", "th"}], "]"}], "=", 
     RowBox[{"means", "[", 
      RowBox[{"3", ",", "fr", ",", "th"}], "]"}]}], ";", 
    RowBox[{
     RowBox[{"means", "[", 
      RowBox[{"5", ",", "fr", ",", "th"}], "]"}], "=", 
     RowBox[{"means", "[", 
      RowBox[{"3", ",", "fr", ",", "th"}], "]"}]}], ";", 
    RowBox[{
     RowBox[{"means", "[", 
      RowBox[{"6", ",", "fr", ",", "th"}], "]"}], "=", "90"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"th", ",", "1", ",", 
     RowBox[{"Length", "[", "angles", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmax", "=", 
   SuperscriptBox["10", "3.2"]}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Papadakis", " ", "&"}], " ", "Lawrence", " ", 
    RowBox[{"(", "1993", ")"}]}], "*)"}], 
  RowBox[{"xtab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     SuperscriptBox["2", "i"], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "2", ",", "15"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"autovar", "[", 
    RowBox[{"typ_", ",", "mu_", ",", "fr_", ",", "th_", ",", "under_"}], 
    "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"mult", "=", "mu"}], ";", 
      RowBox[{"binned", "=", 
       FractionBox[
        RowBox[{
         RowBox[{"impx", "[", "th", "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "typ"}], "]"}], "]"}], 
        RowBox[{"means", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]]}], ";", 
      RowBox[{"ll", "=", 
       RowBox[{"Length", "[", "binned", "]"}]}], ";", 
      RowBox[{"me", "=", 
       RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"autovariance", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{"1", ";;", 
                RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], 
            ")"}], ".", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
             "me"}], ")"}]}], "ll"], ",", 
         RowBox[{"{", 
          RowBox[{"shi", ",", "0", ",", 
           RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"f11", "=", 
       RowBox[{"FourierDCT", "[", 
        RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
      RowBox[{"num", "=", 
       RowBox[{"Floor", "[", 
        FractionBox["ll", "2"], "]"}]}], ";", 
      RowBox[{"sur", "=", 
       RowBox[{
        FractionBox[
         SqrtBox["2"], 
         RowBox[{"2", "\[Pi]"}]], 
        SqrtBox["ll"], 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"f11", ",", "2"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"sur", ",", 
        RowBox[{"sur", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"timex", "=", 
       RowBox[{"4.", 
        RowBox[{"ll", "/", 
         RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
      RowBox[{"mint", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
      RowBox[{"maxt", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", 
      RowBox[{"nn", "=", 
       RowBox[{
        RowBox[{"Log", "[", 
         FractionBox["maxt", "mint"], "]"}], "/", 
        RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"tsides", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"mint", " ", 
          SuperscriptBox["mult", "i"]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tbins", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tsides", "[", 
            RowBox[{"[", "i", "]"}], "]"}], ",", 
           RowBox[{"tsides", "[", 
            RowBox[{"[", 
             RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tsizes", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tmeans", "=", 
       RowBox[{"Mean", "[", 
        RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"intergra", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"timex", ",", 
             RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"pergra", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"Exp", "[", 
              RowBox[{"intergra", "[", 
               RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"tx", ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
             RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
             RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        RowBox[{"res", "=", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"tmeans", ",", 
              FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
          "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"pergra", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{"NIntegrate", "[", 
           RowBox[{
            RowBox[{"intergra", "[", 
             RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"tx", ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
            RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
            RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
          RowBox[{"tsizes", "[", 
           RowBox[{"[", "i", "]"}], "]"}]], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"res", "[", 
        RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"tmeans", ",", 
            RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}]}]}],
      ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"autorand", "[", 
     RowBox[{"ty_", ",", "mu_", ",", "kf_", ",", "rlist_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"typ", "=", "ty"}], ";", 
       RowBox[{"mult", "=", "mu"}], ";", 
       RowBox[{"k", "=", "kf"}], ";", 
       RowBox[{"binned", "=", "rlist"}], ";", 
       RowBox[{"ll", "=", 
        RowBox[{"Length", "[", "binned", "]"}]}], ";", 
       RowBox[{"merr", "=", 
        RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"autovariance", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{"1", ";;", 
                 RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "merr"}], 
             ")"}], ".", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
              "merr"}], ")"}]}], "ll"], ",", 
          RowBox[{"{", 
           RowBox[{"shi", ",", "0", ",", 
            RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"f11", "=", 
        RowBox[{"FourierDCT", "[", 
         RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
       RowBox[{"num", "=", 
        RowBox[{"Floor", "[", 
         FractionBox["ll", "2"], "]"}]}], ";", 
       RowBox[{"sur", "=", 
        RowBox[{
         FractionBox[
          SqrtBox["2"], 
          RowBox[{"2", "\[Pi]"}]], 
         SqrtBox["ll"], 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{"f11", ",", "2"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sur", ",", 
         RowBox[{"sur", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"timex", "=", 
        RowBox[{"4.", 
         RowBox[{"ll", "/", 
          RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
       RowBox[{"mint", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
       RowBox[{"maxt", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", 
       RowBox[{"nn", "=", 
        RowBox[{
         RowBox[{"Log", "[", 
          FractionBox["maxt", "mint"], "]"}], "/", 
         RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"tsides", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"mint", " ", 
           SuperscriptBox["mult", "i"]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tbins", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"tsides", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"tsides", "[", 
             RowBox[{"[", 
              RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tsizes", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tmeans", "=", 
        RowBox[{"Delete", "[", 
         RowBox[{
          RowBox[{"Mean", "[", 
           RowBox[{"Transpose", "[", "tbins", "]"}], "]"}], ",", 
          RowBox[{"-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"intergra", "=", 
        RowBox[{"Interpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"tra", "=", 
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"timex", ",", 
               RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}]}], "]"}], ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"pergra", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{"Exp", "[", 
               RowBox[{"intergra", "[", 
                RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"tx", ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
              RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
              RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
         RowBox[{"res", "=", 
          RowBox[{"Select", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"tmeans", ",", 
               FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
           "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"pergra", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            FractionBox[
             RowBox[{"NIntegrate", "[", 
              RowBox[{
               RowBox[{"intergra", "[", 
                RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"tx", ",", 
                 RowBox[{"tbins", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"tbins", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
               RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
               RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
             RowBox[{"tsizes", "[", 
              RowBox[{"[", "i", "]"}], "]"}]], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "nn"}], 
             RowBox[{"(*", 
              RowBox[{"+", "1"}], "*)"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"pergra", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"sel", "=", 
            RowBox[{"Select", "[", 
             RowBox[{"timex", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], "<", "#", "<", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "&"}]}], "]"}]}], 
           ";", 
           RowBox[{"inttime", "=", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Flatten", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}], ",", "sel", ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}]}], "}"}], "]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"intxx", "=", 
            RowBox[{
             RowBox[{"intergra", "[", 
              RowBox[{"Log", "[", "tx", "]"}], "]"}], "/.", 
             RowBox[{"tx", "\[Rule]", "inttime"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"deltax", "=", 
            RowBox[{"Differences", "[", "inttime", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{
               FractionBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"intxx", "[", 
                   RowBox[{"[", "kk", "]"}], "]"}], "+", 
                  RowBox[{"intxx", "[", 
                   RowBox[{"[", 
                    RowBox[{"kk", "+", "1"}], "]"}], "]"}]}], ")"}], "2"], 
               RowBox[{"deltax", "[", 
                RowBox[{"[", "kk", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"kk", ",", 
                RowBox[{
                 RowBox[{"Length", "[", "inttime", "]"}], "-", "1"}]}], 
               "}"}]}], "]"}], "/", 
            RowBox[{"tsizes", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nn"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"resy", "=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"tmeans", ",", 
             RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
         "]"}]}]}], ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"3", ",", "1.2", ",", "6"}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"lpl3", "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", "\"\<FourierDCT of autovariance\>\""}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"tofit3", "=", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"A", " ", 
         RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
      RowBox[{"FindFit", "[", 
       RowBox[{
        RowBox[{"Log", "[", "res", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"logpl3", "=", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{"tofit3", ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"res", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"res", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl3", ",", "logpl3"}], "]"}]}], 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5696898764220953`*^9, 3.569689887354763*^9}, {
   3.56972286613972*^9, 3.5697228844700017`*^9}, {3.569760446396062*^9, 
   3.5697604472910633`*^9}, {3.5697633264843206`*^9, 3.569763427478898*^9}, {
   3.5808251505490136`*^9, 3.5808251679898443`*^9}, {3.5808271342970495`*^9, 
   3.5808271406270585`*^9}, {3.580833516763463*^9, 3.5808335232934723`*^9}, 
   3.581083614952941*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "Testing", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   StyleBox[
    RowBox[{
     RowBox[{"autovar", "[", 
      RowBox[{"3", ",", "1.2", ",", "6", ",", "1", ",", "1"}], "]"}], ";", 
     RowBox[{"autovar", "[", 
      RowBox[{"3", ",", "1.2", ",", "6", ",", "4", ",", "1"}], "]"}], ";", 
     RowBox[{"autovar", "[", 
      RowBox[{"3", ",", "1.2", ",", "6", ",", "5", ",", "1"}], "]"}], ";"}],
    FontColor->GrayLevel[0]], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0]], 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"res", "[", 
       RowBox[{"3", ",", "6", ",", "1", ",", "1"}], "]"}], ",", 
      RowBox[{"res", "[", 
       RowBox[{"3", ",", "6", ",", "4", ",", "1"}], "]"}], ",", 
      RowBox[{"res", "[", 
       RowBox[{"3", ",", "6", ",", "5", ",", "1"}], "]"}]}], "}"}], "]"}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0]], 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"typ", ",", "3", ",", "6"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"th", ",", "1", ",", "3"}], "}"}]}], "}"}], 
    "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.580824813230221*^9, 3.5808248546482935`*^9}, {
  3.5808252748344316`*^9, 3.580825325722721*^9}, {3.5808255630001383`*^9, 
  3.5808255767281623`*^9}, {3.5808257299516315`*^9, 3.5808257422288527`*^9}, {
  3.5808258182789865`*^9, 3.5808258219137926`*^9}, {3.580825881911498*^9, 
  3.580825893923519*^9}, {3.5808846840874004`*^9, 3.5808846870145683`*^9}, {
  3.5810833332008467`*^9, 3.5810833365860524`*^9}, {3.581083410420982*^9, 
  3.5810834670178814`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"lpl", "=", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"res", "[", 
         RowBox[{"3", ",", "6", ",", "4"}], "]"}], ",", 
        RowBox[{"resx", "[", 
         RowBox[{"3", ",", "6", ",", "4"}], "]"}]}], "}"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Black", ",", "Green", ",", "Blue"}], "}"}]}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"power", "-", 
    RowBox[{"law", " ", "fit"}]}], "*)"}], 
  RowBox[{
   RowBox[{"testex", "=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"res", "[", 
        RowBox[{"3", ",", "6", ",", "4"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"1", ";;", "12"}], "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"res", "[", 
        RowBox[{"3", ",", "6", ",", "4"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"16", ";;", 
         RowBox[{"-", "1"}]}], "]"}], "]"}]}], "]"}]}], 
   ";"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plawfit", "=", 
   RowBox[{
    RowBox[{"10", "^", 
     RowBox[{"Fit", "[", 
      RowBox[{
       RowBox[{"Log10", "[", "testex", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "x"}], "}"}], ",", "x"}], "]"}]}], "/.", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"Log10", "[", "x", "]"}]}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"broken", " ", "power"}], "-", 
    RowBox[{"law", " ", "fit"}]}], "*)"}], 
  RowBox[{
   RowBox[{"expr", "=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"x", "<", "t"}], ",", 
      RowBox[{
       RowBox[{"A", " ", "x"}], "+", "B"}], ",", 
      RowBox[{
       RowBox[{"F", " ", "x"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"A", "-", "F"}], ")"}], " ", "t"}], "+", "B"}]}], "]"}]}], 
   ";"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fifi", "=", 
   RowBox[{"FindFit", "[", 
    RowBox[{
     RowBox[{"Log10", "[", "testex", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"expr", ",", 
       RowBox[{
        RowBox[{"Log10", "[", "20", "]"}], "<", "t", "<", 
        RowBox[{"Log10", "[", "1000", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"A", ",", "B", ",", "F", ",", "t"}], "}"}], ",", "x", ",", 
     RowBox[{"Method", "\[Rule]", "NMinimize"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"brokenfit", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"10", "^", "expr"}], "/.", "fifi"}], "/.", 
    RowBox[{"x", "\[Rule]", 
     RowBox[{"Log10", "[", "x", "]"}]}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Break t=\>\"", ",", 
   RowBox[{
    SuperscriptBox["10", "t"], "/.", "fifi"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"plawfit", ",", "brokenfit"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "20", ",", "2000"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", "Red"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"lpl", ",", "pl"}], "]"}]}], "Input",
 CellChangeTimes->{{3.580828037451867*^9, 3.5808280865579357`*^9}, {
   3.5808287831434526`*^9, 3.5808287909444633`*^9}, 3.580828859121559*^9, {
   3.580828906731626*^9, 3.580828907961628*^9}, {3.580828963149706*^9, 
   3.580828969789715*^9}, {3.5808291043435044`*^9, 3.5808291370585504`*^9}, {
   3.58082934292384*^9, 3.5808293718768806`*^9}, {3.5808314563551626`*^9, 
   3.580831467127178*^9}, {3.5808317364005613`*^9, 3.5808317551625876`*^9}, {
   3.58083254052349*^9, 3.5808325727541466`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ttx", "=", 
   RowBox[{"TimeUsed", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "z", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}], ",", 
   RowBox[{"Dynamic", "[", "fr", "]"}], ",", 
   RowBox[{"Dynamic", "[", "th", "]"}], ",", 
   RowBox[{"Dynamic", "[", "under", "]"}], ",", 
   RowBox[{"Dynamic", "[", "o", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"20", ",", "1500"}], "}"}], ",", "All"}], "}"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"typ", "=."}], ";", 
   RowBox[{"fr", "=."}], ";", 
   RowBox[{"th", "=."}], ";", 
   RowBox[{"under", "=."}], ";", 
   RowBox[{"kmin", "=", "3"}], ";", 
   RowBox[{"kmax", "=", "9"}], ";", 
   RowBox[{"kstep", "=", "3"}], ";", 
   RowBox[{"types", "=", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Flux\>\"", ",", "\"\<LP\>\"", ",", "\"\<EVPA\>\"", ",", 
      "\"\<CP\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"fltab", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"3", ",", "6", ",", "4", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "6", ",", "5", ",", "1"}], "}"}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"fltab", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"3", ",", "6", ",", "1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "6", ",", "1", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "6", ",", "1", ",", "3"}], "}"}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"fltab", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"typ", ",", "fr", ",", "th", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"typ", ",", "3", ",", "4"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"th", ",", "1", ",", "3"}], "}"}]}], "]"}], ",", "2"}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"fltab", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"fltab", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", "6", ",", "4", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "6", ",", "5", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "6", ",", "1", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "6", ",", "1", ",", "3"}], "}"}]}], "}"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"fltab", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"typ", ",", "3", ",", "4"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"th", ",", "1", ",", "3"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"under", ",", "1", ",", "3"}], "}"}]}], "]"}], ",", "3"}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"fltab", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"fltab", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", "6", ",", "4", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "6", ",", "5", ",", "1"}], "}"}]}], "}"}]}], 
      "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fltab", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"typ", ",", "3", ",", "4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"th", ",", "1", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"under", ",", "1", ",", "3"}], "}"}]}], "]"}], ",", "3"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"flnew", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"typ", ",", "3", ",", "4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"th", ",", "4", ",", "5"}], "}"}]}], "]"}], ",", "2"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fltab", "=", 
    RowBox[{"Join", "[", 
     RowBox[{"fltab", ",", "flnew"}], "]"}]}], ";"}], "\[IndentingNewLine]"}],
 "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "}"}], "=", 
      RowBox[{"fltab", "[", 
       RowBox[{"[", "z", "]"}], "]"}]}], "]"}], ";", 
    StyleBox["\[IndentingNewLine]",
     FontColor->RGBColor[1, 0, 0]], 
    RowBox[{"Switch", "[", 
     RowBox[{"under", ",", "\[IndentingNewLine]", "1", ",", 
      RowBox[{"(*", 
       RowBox[{
       "standard", " ", "smoothed", " ", "periodogram", " ", "generator"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"autovar", "[", 
         RowBox[{"typ", ",", "3.0", ",", "fr", ",", "th", ",", "under"}], 
         "]"}],
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox[";",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{
        RowBox[{"resx", "[", 
         RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"res", "[", 
           RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"timex", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"sur", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], ";", 
       RowBox[{"tofit4", "=", 
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"A", " ", 
            RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
         RowBox[{"FindFit", "[", 
          RowBox[{
           RowBox[{"Log", "[", 
            RowBox[{"res", "[", 
             RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"resx", "[", 
         RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"#", ",", 
              RowBox[{
               FractionBox[
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", "#"}]}], 
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", 
                  RowBox[{
                   RowBox[{"res", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], 
                    "]"}], "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
               RowBox[{
                RowBox[{"res", "[", 
                 RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], 
                "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
           RowBox[{"{", 
            RowBox[{"4", ",", "8"}], "}"}]}], ",", 
          RowBox[{"resx", "[", 
           RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}]}], 
         "]"}]}]}], ",", "\[IndentingNewLine]", "2", ",", 
      RowBox[{"(*", 
       RowBox[{"power", "-", 
        RowBox[{"law", " ", "fit"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"autovar", "[", 
         RowBox[{"typ", ",", "1.2", ",", "fr", ",", "th", ",", "under"}], 
         "]"}],
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox[";",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"testex", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"res", "[", 
            RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"1", ";;", "12"}], "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"res", "[", 
            RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"16", ";;", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}], "]"}]}], ";", 
       RowBox[{"plawfit", "=", 
        RowBox[{
         RowBox[{"10", "^", 
          RowBox[{"Fit", "[", 
           RowBox[{
            RowBox[{"Log10", "[", "testex", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "x"}], "}"}], ",", "x"}], "]"}]}], "/.", 
         RowBox[{"x", "\[Rule]", 
          RowBox[{"Log10", "[", "x", "]"}]}]}]}], ";", 
       RowBox[{
        RowBox[{"resx", "[", 
         RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"#", ",", 
            RowBox[{"plawfit", "/.", 
             RowBox[{"x", "\[Rule]", "#"}]}]}], "}"}], "&"}], "/@", 
         "xtab"}]}]}], ",", "\[IndentingNewLine]", "3", ",", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"broken", " ", "power"}], "-", 
        RowBox[{"law", " ", "fit"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"autovar", "[", 
         RowBox[{"typ", ",", "1.2", ",", "fr", ",", "th", ",", "under"}], 
         "]"}],
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox[";",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"testex", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"res", "[", 
            RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"1", ";;", "12"}], "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"res", "[", 
            RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"16", ";;", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}], "]"}]}], ";", 
       RowBox[{"expr", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"x", "<", "t"}], ",", 
          RowBox[{
           RowBox[{"A", " ", "x"}], "+", "B"}], ",", 
          RowBox[{
           RowBox[{"F", " ", "x"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"A", "-", "F"}], ")"}], " ", "t"}], "+", "B"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"fifi", "=", 
        RowBox[{"FindFit", "[", 
         RowBox[{
          RowBox[{"Log10", "[", "testex", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"expr", ",", 
            RowBox[{
             RowBox[{"Log10", "[", "20", "]"}], "<", "t", "<", 
             RowBox[{"Log10", "[", "1000", "]"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"A", ",", "B", ",", "F", ",", "t"}], "}"}], ",", "x", ",", 
          RowBox[{"Method", "\[Rule]", "NMinimize"}]}], "]"}]}], ";", 
       RowBox[{
        RowBox[{"tim", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
        RowBox[{
         RowBox[{"10", "^", "t"}], "/.", "fifi"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"brokenfit", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"10", "^", "expr"}], "/.", "fifi"}], "/.", 
         RowBox[{"x", "\[Rule]", 
          RowBox[{"Log10", "[", "x", "]"}]}]}]}], ";", 
       RowBox[{
        RowBox[{"resx", "[", 
         RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"#", ",", 
            RowBox[{"brokenfit", "/.", 
             RowBox[{"x", "\[Rule]", "#"}]}]}], "}"}], "&"}], "/@", 
         "xtab"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{"resx", "=", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"#", ",", 
            RowBox[{
             FractionBox[
              RowBox[{
               RowBox[{"tofit4", "[", 
                RowBox[{"[", 
                 RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
               RowBox[{"x", "\[Rule]", "#"}]}], 
              RowBox[{
               RowBox[{"tofit4", "[", 
                RowBox[{"[", 
                 RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
               RowBox[{"x", "\[Rule]", 
                RowBox[{"res", "[", 
                 RowBox[{"[", 
                  RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
             RowBox[{"res", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
         RowBox[{"{", 
          RowBox[{"4", ",", "8"}], "}"}]}], ",", "res", ",", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"timex", "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"sur", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], "*)"}],
     "\[IndentingNewLine]", 
    RowBox[{"interand", "=", 
     RowBox[{"Interpolation", "[", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{"resx", "[", 
         RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "]"}], 
       ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     StyleBox[
      RowBox[{"PSDfluxx", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}],
      FontColor->RGBColor[0, 0, 1]], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{
       RowBox[{"resx", "[", 
        RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Green", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
          RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
         "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    StyleBox[
     RowBox[{"autovar", "[", 
      RowBox[{"typ", ",", "1.2", ",", "fr", ",", "th", ",", "under"}], "]"}],
     FontColor->RGBColor[1, 0, 0]], 
    StyleBox[";",
     FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", 
    RowBox[{"nux", "=", "2592"}], ";", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"22", " ", "-", " ", 
       RowBox[{"1", "\[Sigma]"}]}], ";", " ", 
      RowBox[{"154", " ", "-", " ", 
       RowBox[{"2", "\[Sigma]"}]}], ";", " ", 
      RowBox[{"2592", " ", "-", " ", 
       RowBox[{"3", "\[Sigma]"}]}], ";", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"7", "/", 
         RowBox[{"(", 
          RowBox[{"1", "-", "#"}], ")"}]}], "&"}], "/@", 
       RowBox[{"{", 
        RowBox[{
        "0.682689492137086", ",", "0.954499736103642", ",", 
         "0.997300203936740"}], "}"}]}]}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"nam", "=", 
     RowBox[{
      RowBox[{"dix", "[", "th", "]"}], "<>", "\"\<rand\>\"", "<>", 
      RowBox[{"ToString", "[", "fr", "]"}], "<>", "\"\<x\>\"", "<>", 
      RowBox[{"ToString", "[", "typ", "]"}], "<>", "\"\<x\>\"", "<>", 
      RowBox[{"ToString", "[", "under", "]"}], "<>", "\"\<x\>\"", "<>", 
      RowBox[{"ToString", "[", "nux", "]"}], "<>", "\"\<.dat\>\""}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"!", 
       RowBox[{"FileExistsQ", "[", "nam", "]"}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"tabresy", "[", 
         RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"randx", "=", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RandomVariate", "[", 
                 RowBox[{
                  RowBox[{"NormalDistribution", "[", "]"}], ",", "5000"}], 
                 "]"}], "+", 
                RowBox[{"\[ImaginaryI]", " ", 
                 RowBox[{"RandomVariate", "[", 
                  RowBox[{
                   RowBox[{"NormalDistribution", "[", "]"}], ",", "5000"}], 
                  "]"}]}]}], ")"}], 
              SqrtBox[
               RowBox[{"Exp", "[", 
                RowBox[{"interand", "[", 
                 RowBox[{"Log", "[", 
                  RowBox[{"20000", "/", 
                   RowBox[{"Range", "[", "5000", "]"}]}], "]"}], "]"}], 
                "]"}]]}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"rsxx", "=", 
             RowBox[{"4.8", 
              RowBox[{"Re", "[", 
               RowBox[{"InverseFourier", "[", "randx", "]"}], "]"}]}]}], 
            ";"}], 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"+", "me"}], ";"}], 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{"-", "for"}], " ", "formal", " ", "correspondence"}], 
             "*)"}], "*)"}], ";", "\[IndentingNewLine]", 
           RowBox[{"resy", "=", 
            StyleBox[
             RowBox[{"autorand", "[", 
              RowBox[{"typ", ",", "1.2", ",", "fr", ",", "rsxx"}], "]"}],
             FontColor->RGBColor[1, 0, 0]]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"o", ",", "nux"}], "}"}]}], "]"}]}], ";", 
       RowBox[{"Put", "[", 
        RowBox[{
         RowBox[{"tabresy", "[", 
          RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], ",", 
         "nam"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"tabresy", "[", 
        RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "=", 
       RowBox[{"Get", "[", "nam", "]"}]}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"ress", "[", "aa", "]"}], "=", 
       RowBox[{
        RowBox[{"tabresy", "[", 
         RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "[", 
        RowBox[{"[", "aa", "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"aa", ",", "nux"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ressmean", "[", 
      RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "=", 
     RowBox[{"Exp", "[", 
      FractionBox[
       RowBox[{"Total", "[", 
        RowBox[{"Log", "[", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ress", "[", "i", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}], "]"}], "nux"], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     StyleBox[
      RowBox[{"PSDFrandmean", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}],
      FontColor->RGBColor[0, 0, 1]], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{
       RowBox[{"ressmean", "[", 
        RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Black", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
          RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
         "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     StyleBox[
      RowBox[{"PSDflux", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}],
      FontColor->RGBColor[0., 0., 1.]], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{
       RowBox[{"res", "[", 
        RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Black", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
         "}"}]}], ",", 
       RowBox[{"Epilog", "\[Rule]", "\[IndentingNewLine]", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"types", "[", 
              RowBox[{"[", 
               RowBox[{"typ", "-", "2"}], "]"}], "]"}], "<>", "\"\< at \>\"", 
             "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Floor", "[", 
               RowBox[{"freqs", "[", 
                RowBox[{"[", "fr", "]"}], "]"}], "]"}], "]"}], "<>", 
             "\"\<GHz\>\""}], ",", "18", ",", "Bold"}], "]"}], ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.3", ",", "0.8"}], "}"}], "]"}]}], "]"}]}]}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"resstot", "[", 
      RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ress", "[", "i", "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"resst", "=", 
     RowBox[{
      RowBox[{"ress", "[", "1", "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ressmax", "[", 
      RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"resst", ",", 
        RowBox[{"Mean", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"RankedMax", "[", 
              RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
            RowBox[{"resstot", "[", 
             RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}]}], 
           ",", 
           RowBox[{
            RowBox[{
             RowBox[{"RankedMax", "[", 
              RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
            RowBox[{"resstot", "[", 
             RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}]}]}], 
          "}"}], "]"}]}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ressmin", "[", 
      RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"resst", ",", 
        RowBox[{"Mean", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"RankedMin", "[", 
              RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
            RowBox[{"resstot", "[", 
             RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}]}], 
           ",", 
           RowBox[{
            RowBox[{
             RowBox[{"RankedMin", "[", 
              RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
            RowBox[{"resstot", "[", 
             RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}]}]}], 
          "}"}], "]"}]}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     StyleBox[
      RowBox[{"PSDFmin", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}],
      FontColor->RGBColor[0., 0., 1.]], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{
       RowBox[{"ressmin", "[", 
        RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Red", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Dotted"}], 
         "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
         "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     StyleBox[
      RowBox[{"PSDFmax", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}],
      FontColor->RGBColor[0, 0, 1]], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{
       RowBox[{"ressmax", "[", 
        RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Red", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
         "}"}]}]}], "]"}]}], ";"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", 
     RowBox[{"Length", "[", "fltab", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"typ", "=."}], ";", 
   RowBox[{"fr", "=."}], ";", 
   RowBox[{"th", "=."}], ";", 
   RowBox[{"under", "=."}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{
      StyleBox[
       RowBox[{"autovar", "[", 
        RowBox[{"typ", ",", "3.0", ",", "fr", ",", "th"}], "]"}],
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox[";",
       FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resx", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"res", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"timex", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"sur", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tofit4", "=", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"A", " ", 
           RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
        RowBox[{"FindFit", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"res", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resx", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"#", ",", 
             RowBox[{
              FractionBox[
               RowBox[{
                RowBox[{"tofit4", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                RowBox[{"x", "\[Rule]", "#"}]}], 
               RowBox[{
                RowBox[{"tofit4", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                RowBox[{"x", "\[Rule]", 
                 RowBox[{
                  RowBox[{"res", "[", 
                   RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
              RowBox[{
               RowBox[{"res", "[", 
                RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
          RowBox[{"{", 
           RowBox[{"4", ",", "8"}], "}"}]}], ",", 
         RowBox[{"resx", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"resx", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"#", ",", 
              RowBox[{
               FractionBox[
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", "#"}]}], 
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", 
                  RowBox[{"res", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
               RowBox[{"res", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
           RowBox[{"{", 
            RowBox[{"4", ",", "8"}], "}"}]}], ",", "res", ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"timex", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"sur", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"interand", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"resx", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDfluxx", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"resx", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Green", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"autovar", "[", 
        RowBox[{"typ", ",", "1.2", ",", "fr", ",", "th"}], "]"}],
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox[";",
       FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", 
      RowBox[{"nux", "=", "2592"}], ";", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"22", " ", "-", " ", 
         RowBox[{"1", "\[Sigma]"}]}], ";", " ", 
        RowBox[{"154", " ", "-", " ", 
         RowBox[{"2", "\[Sigma]"}]}], ";", " ", 
        RowBox[{"2592", " ", "-", " ", 
         RowBox[{"3", "\[Sigma]"}]}], ";", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"7", "/", 
           RowBox[{"(", 
            RowBox[{"1", "-", "#"}], ")"}]}], "&"}], "/@", 
         RowBox[{"{", 
          RowBox[{
          "0.682689492137086", ",", "0.954499736103642", ",", 
           "0.997300203936740"}], "}"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"nam", "=", 
       RowBox[{
        RowBox[{"dix", "[", "th", "]"}], "<>", "\"\<rand\>\"", "<>", 
        RowBox[{"ToString", "[", "fr", "]"}], "<>", "\"\<x\>\"", "<>", 
        RowBox[{"ToString", "[", "typ", "]"}], "<>", "\"\<x\>\"", "<>", 
        RowBox[{"ToString", "[", "nux", "]"}], "<>", "\"\<.dat\>\""}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"FileExistsQ", "[", "nam", "]"}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"tabresy", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"randx", "=", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"RandomVariate", "[", 
                   RowBox[{
                    RowBox[{"NormalDistribution", "[", "]"}], ",", "5000"}], 
                   "]"}], "+", 
                  RowBox[{"\[ImaginaryI]", " ", 
                   RowBox[{"RandomVariate", "[", 
                    RowBox[{
                    RowBox[{"NormalDistribution", "[", "]"}], ",", "5000"}], 
                    "]"}]}]}], ")"}], 
                SqrtBox[
                 RowBox[{"Exp", "[", 
                  RowBox[{"interand", "[", 
                   RowBox[{"Log", "[", 
                    RowBox[{"20000", "/", 
                    RowBox[{"Range", "[", "5000", "]"}]}], "]"}], "]"}], 
                  "]"}]]}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"rsxx", "=", 
               RowBox[{"4.8", 
                RowBox[{"Re", "[", 
                 RowBox[{"InverseFourier", "[", "randx", "]"}], "]"}]}]}], 
              ";"}], 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"+", "me"}], ";"}], 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"-", "for"}], " ", "formal", " ", "correspondence"}], 
               "*)"}], "*)"}], ";", "\[IndentingNewLine]", 
             RowBox[{"resy", "=", 
              StyleBox[
               RowBox[{"autorand", "[", 
                RowBox[{"typ", ",", "1.2", ",", "fr", ",", "rsxx"}], "]"}],
               FontColor->RGBColor[1, 0, 0]]}]}], ",", 
            RowBox[{"{", 
             RowBox[{"o", ",", "nux"}], "}"}]}], "]"}]}], ";", 
         RowBox[{"Put", "[", 
          RowBox[{
           RowBox[{"tabresy", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", "nam"}], 
          "]"}]}], ",", 
        RowBox[{
         RowBox[{"tabresy", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
         RowBox[{"Get", "[", "nam", "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ress", "[", "aa", "]"}], "=", 
         RowBox[{
          RowBox[{"tabresy", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "[", 
          RowBox[{"[", "aa", "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"aa", ",", "nux"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmean", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Exp", "[", 
        FractionBox[
         RowBox[{"Total", "[", 
          RowBox[{"Log", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"ress", "[", "i", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}], "]"}], "nux"],
         "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFrandmean", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"ressmean", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDflux", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0., 0., 1.]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"res", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}], ",", 
         RowBox[{"Epilog", "\[Rule]", "\[IndentingNewLine]", 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"types", "[", 
                RowBox[{"[", 
                 RowBox[{"typ", "-", "2"}], "]"}], "]"}], "<>", 
               "\"\< at \>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Floor", "[", 
                 RowBox[{"freqs", "[", 
                  RowBox[{"[", "fr", "]"}], "]"}], "]"}], "]"}], "<>", 
               "\"\<GHz\>\""}], ",", "18", ",", "Bold"}], "]"}], ",", 
            RowBox[{"Scaled", "[", 
             RowBox[{"{", 
              RowBox[{"0.3", ",", "0.8"}], "}"}], "]"}]}], "]"}]}]}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resstot", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ress", "[", "i", "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"resst", "=", 
       RowBox[{
        RowBox[{"ress", "[", "1", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmax", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"resst", ",", 
          RowBox[{"Mean", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"RankedMax", "[", 
                RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"RankedMax", "[", 
                RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}]}], "}"}], 
           "]"}]}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmin", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"resst", ",", 
          RowBox[{"Mean", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"RankedMin", "[", 
                RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"RankedMin", "[", 
                RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
              RowBox[{"resstot", "[", 
               RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}]}], "}"}], 
           "]"}]}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFmin", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0., 0., 1.]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"ressmin", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Dotted"}], 
           "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFmax", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"ressmax", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"typ", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"th", ",", "1", ",", "3"}], "}"}]}], "]"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Computed in \>\"", ",", 
    RowBox[{
     RowBox[{"TimeUsed", "[", "]"}], "-", "ttx"}], ",", "\"\<s\>\""}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"367", "s", " ", "for", " ", "1", "\[Sigma]"}], " ", "\[Implies]",
     " ", 
    RowBox[{
     RowBox[{"2218", "s", 
      RowBox[{"(", 
       RowBox[{"37", "min"}], ")"}], " ", "for", " ", "2", "\[Sigma]"}], " ", 
     "\[Implies]", " ", 
     RowBox[{"36121", "s", 
      RowBox[{"(", 
       RowBox[{"10", "hrs"}], ")"}], " ", "for", " ", "3", "\[Sigma]"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Dimensions", "[", 
     RowBox[{"tabresy", "[", 
      RowBox[{"3", ",", "3"}], "]"}], "]"}], "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"Put", "[", 
       RowBox[{
        RowBox[{"tabresy", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
        RowBox[{"nam", "=", 
         RowBox[{
          RowBox[{"dix", "[", "th", "]"}], "<>", "\"\<rand\>\"", "<>", 
          RowBox[{"ToString", "[", "fr", "]"}], "<>", "\"\<x\>\"", "<>", 
          RowBox[{"ToString", "[", "typ", "]"}], "<>", "\"\<x\>\"", "<>", 
          RowBox[{"ToString", "[", "nux", "]"}], "<>", "\"\<.dat\>\""}]}]}], 
       "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"typ", ",", "3", ",", "6"}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.568658690181983*^9, 3.5686587401332707`*^9}, {
   3.5686588111757956`*^9, 3.5686588548880725`*^9}, {3.5686588922033377`*^9, 
   3.568658925977397*^9}, {3.5686589703906755`*^9, 3.5686589774106874`*^9}, {
   3.568672919401613*^9, 3.5686729589816833`*^9}, {3.5686734755153365`*^9, 
   3.5686734758803368`*^9}, 3.568673902517336*^9, {3.5686740475725393`*^9, 
   3.5686740736925755`*^9}, {3.5686741992477517`*^9, 3.568674207342763*^9}, {
   3.5686743702339907`*^9, 3.568674420479061*^9}, {3.5686746579543934`*^9, 
   3.5686746640944023`*^9}, {3.5686747825547867`*^9, 
   3.5686747836467886`*^9}, {3.568675093166932*^9, 3.5686751107637634`*^9}, {
   3.5686751638818564`*^9, 3.5686751860962954`*^9}, {3.5686752638780317`*^9, 
   3.5686752932372837`*^9}, 3.568676352200344*^9, {3.568676425036872*^9, 
   3.5686764268152747`*^9}, {3.5686765814583464`*^9, 
   3.5686765815051465`*^9}, {3.568676612564801*^9, 3.5686766292880306`*^9}, {
   3.5686768069879427`*^9, 3.568676807112743*^9}, {3.568676887780484*^9, 
   3.5686768878896847`*^9}, {3.5686769802106466`*^9, 
   3.5686770449975605`*^9}, {3.568677177254593*^9, 3.5686771780189943`*^9}, {
   3.5686772390463014`*^9, 3.5686772393739023`*^9}, {3.568677286049184*^9, 
   3.5686773642833214`*^9}, {3.568677400110385*^9, 3.568677400484785*^9}, {
   3.568677507665374*^9, 3.5686775082269745`*^9}, {3.5686775809855022`*^9, 
   3.568677667160054*^9}, {3.568677724162554*^9, 3.568677768326232*^9}, {
   3.5686784189103737`*^9, 3.5686784731984696`*^9}, {3.568678528562967*^9, 
   3.5686785340073767`*^9}, {3.568678600557093*^9, 3.5686786208995285`*^9}, {
   3.5686786550323887`*^9, 3.5686786624268017`*^9}, {3.568678748679353*^9, 
   3.5686787518617587`*^9}, {3.568678943851296*^9, 3.568678944178897*^9}, {
   3.568679095826763*^9, 3.5686790961543636`*^9}, 3.5687143742988043`*^9, {
   3.568718293597542*^9, 3.568718293925143*^9}, {3.568733412817721*^9, 
   3.568733427575347*^9}, {3.5687335444663525`*^9, 3.568733613090873*^9}, {
   3.568733746627107*^9, 3.5687337937547903`*^9}, {3.5687342807418456`*^9, 
   3.5687343666823964`*^9}, {3.5687344259001007`*^9, 
   3.5687344394877243`*^9}, {3.568734477239791*^9, 3.5687345461451116`*^9}, {
   3.5687345797823715`*^9, 3.568734589844389*^9}, {3.5687346756289396`*^9, 
   3.568734677563343*^9}, {3.568734894974286*^9, 3.568734922929535*^9}, {
   3.5687349655332103`*^9, 3.5687349764844294`*^9}, {3.568735012192892*^9, 
   3.56873502830772*^9}, {3.568735147273529*^9, 3.568735195914415*^9}, {
   3.568735337110263*^9, 3.568735339029066*^9}, {3.568735384331546*^9, 
   3.568735388949154*^9}, {3.5687354326448307`*^9, 3.5687354327852306`*^9}, {
   3.568735491519334*^9, 3.568735505184958*^9}, {3.5687364997865577`*^9, 
   3.568736499896558*^9}, {3.568743415518503*^9, 3.568743415643503*^9}, {
   3.568743713589615*^9, 3.5687437136364155`*^9}, {3.5687441249311376`*^9, 
   3.5687441349005547`*^9}, {3.5687456117645607`*^9, 3.568745675733219*^9}, {
   3.568745710904231*^9, 3.5687457803412027`*^9}, {3.568745836047389*^9, 
   3.5687458519833*^9}, {3.568746269593191*^9, 3.5687463055824547`*^9}, {
   3.568746362210554*^9, 3.5687463633961563`*^9}, {3.5687464472712975`*^9, 
   3.5687464474012976`*^9}, {3.568746524051405*^9, 3.5687465241114054`*^9}, {
   3.5687465874514937`*^9, 3.568746587516494*^9}, {3.5687466340115585`*^9, 
   3.5687466340965595`*^9}, {3.5687466830126286`*^9, 3.5687466830926285`*^9}, 
   3.5687467437727137`*^9, {3.568746883758145*^9, 3.5687468841949453`*^9}, {
   3.568746932711031*^9, 3.568746932867031*^9}, {3.5687483065115275`*^9, 
   3.5687483066051273`*^9}, {3.568748356905614*^9, 3.5687483570772142`*^9}, {
   3.5687484849978333`*^9, 3.5687484851070337`*^9}, {3.5687486793365183`*^9, 
   3.5687487039165525`*^9}, 3.5687487503066173`*^9, {3.5687487915866747`*^9, 
   3.568748868616783*^9}, 3.568748930046869*^9, {3.5687648297268953`*^9, 
   3.568764830431896*^9}, {3.5687651183353004`*^9, 3.5687651217753053`*^9}, {
   3.568765172395376*^9, 3.568765172775377*^9}, {3.5687652432954755`*^9, 
   3.5687652504354854`*^9}, {3.5687653239655886`*^9, 
   3.5687654154007163`*^9}, {3.5687654918858232`*^9, 3.568765522375866*^9}, {
   3.568765635131024*^9, 3.5687656600910587`*^9}, {3.5687657746762195`*^9, 
   3.568765779146226*^9}, {3.5687658126242733`*^9, 3.5687658187242823`*^9}, {
   3.5687659304504385`*^9, 3.5687659560604744`*^9}, {3.5687660151155567`*^9, 
   3.5687660156055574`*^9}, {3.5687660518306084`*^9, 3.56876608879066*^9}, {
   3.568766907469807*^9, 3.5687669171198206`*^9}, {3.5687669640798864`*^9, 
   3.5687669661198893`*^9}, {3.5687675173867655`*^9, 
   3.5687675633756466`*^9}, {3.568821997140112*^9, 3.568822020852154*^9}, {
   3.5688220594154215`*^9, 3.568822062551027*^9}, {3.568822107572706*^9, 
   3.568822116667522*^9}, {3.568822153592787*^9, 3.568822194090458*^9}, {
   3.5688227530290003`*^9, 3.5688227588010106`*^9}, {3.5688228373783484`*^9, 
   3.5688228857228336`*^9}, {3.5688229377967253`*^9, 
   3.5688229695895805`*^9}, {3.5688230020376377`*^9, 
   3.5688230069828463`*^9}, {3.56882307145776*^9, 3.568823184807559*^9}, {
   3.5688232887817416`*^9, 3.5688233510570507`*^9}, {3.568823574855044*^9, 
   3.5688235769298477`*^9}, {3.568823624853132*^9, 3.568823626522335*^9}, {
   3.568823907307228*^9, 3.568823937727281*^9}, {3.5688242497905293`*^9, 
   3.5688242498997297`*^9}, {3.5688249598546658`*^9, 3.568824963988673*^9}, {
   3.5688249955007286`*^9, 3.568824998527134*^9}, {3.568825583173684*^9, 
   3.5688256067765255`*^9}, {3.5688257669956055`*^9, 
   3.5688257915968485`*^9}, {3.5688265201971283`*^9, 3.568826526140739*^9}, {
   3.56882670801742*^9, 3.568826716082634*^9}, {3.5688267536163*^9, 
   3.568826758140308*^9}, {3.5696898448366103`*^9, 3.569689848671669*^9}, {
   3.5696899318429465`*^9, 3.569689935898009*^9}, {3.5696900532648115`*^9, 
   3.5696901073531427`*^9}, {3.569690290777461*^9, 3.569690331808091*^9}, {
   3.5696906005022182`*^9, 3.569690621590042*^9}, 3.5696906748008595`*^9, {
   3.5696911680134354`*^9, 3.5696911768160706`*^9}, {3.5696914070181074`*^9, 
   3.5696914071706095`*^9}, {3.5696914461662083`*^9, 
   3.5696914473587265`*^9}, {3.569691554536373*^9, 3.56969156347651*^9}, {
   3.569691629262521*^9, 3.5696916591204796`*^9}, {3.569691693988515*^9, 
   3.5696917502993803`*^9}, {3.5696918200279512`*^9, 
   3.5696918611985836`*^9}, {3.569696129506508*^9, 3.569696201117608*^9}, {
   3.5696967610487103`*^9, 3.569696820434623*^9}, {3.5696968508025894`*^9, 
   3.5696968900581923`*^9}, {3.5697229699763155`*^9, 
   3.5697229710588317`*^9}, {3.569723191150887*^9, 3.569723208733657*^9}, {
   3.569723547730029*^9, 3.5697235478750315`*^9}, {3.5697602313657613`*^9, 
   3.569760234820766*^9}, {3.56976027328082*^9, 3.569760307765868*^9}, 
   3.5697630504886355`*^9, {3.569945540377632*^9, 3.5699455435326366`*^9}, {
   3.569946117072834*^9, 3.569946117228834*^9}, {3.5699465864796576`*^9, 
   3.569946614060506*^9}, {3.5699488662442627`*^9, 3.569948885927105*^9}, {
   3.5699803386893177`*^9, 3.5699803418405232`*^9}, {3.570016662082553*^9, 
   3.570016673626573*^9}, {3.5808261617759895`*^9, 3.580826166190798*^9}, {
   3.580826421244776*^9, 3.580826421264776*^9}, {3.5808267242852516`*^9, 
   3.580826752189291*^9}, {3.5808267988643565`*^9, 3.5808269101359243`*^9}, {
   3.58082703597291*^9, 3.5808270456839237`*^9}, {3.580827249806226*^9, 
   3.5808273026533003`*^9}, {3.580827367849431*^9, 3.5808273690994325`*^9}, {
   3.5808278897168503`*^9, 3.580827890637252*^9}, {3.5808323701867905`*^9, 
   3.5808324847845917`*^9}, {3.5808325885881743`*^9, 3.580832680565936*^9}, {
   3.5808327466944523`*^9, 3.5808327707184944`*^9}, {3.5808328099681635`*^9, 
   3.5808328151629725`*^9}, {3.5808328482194304`*^9, 
   3.5808328544282413`*^9}, {3.5808333110381737`*^9, 3.58083332243919*^9}, {
   3.580833352523232*^9, 3.5808334779384084`*^9}, {3.5808335548565164`*^9, 
   3.580833683203697*^9}, {3.5808337257297573`*^9, 3.58083372797976*^9}, {
   3.5808337594228044`*^9, 3.5808337823858366`*^9}, {3.580833812639879*^9, 
   3.5808338495339313`*^9}, {3.580833917975032*^9, 3.5808339205450354`*^9}, {
   3.5808339820411215`*^9, 3.5808339950221395`*^9}, {3.580834131925332*^9, 
   3.580834153048362*^9}, {3.5808343970797124`*^9, 3.580834464246807*^9}, {
   3.580834536334968*^9, 3.5808345367949686`*^9}, {3.5808346573611526`*^9, 
   3.580834663672161*^9}, {3.5808349728175955`*^9, 3.580834973957597*^9}, {
   3.580884338580639*^9, 3.5808843402877364`*^9}, {3.5808844041583896`*^9, 
   3.5808844495709867`*^9}, {3.5809712228781366`*^9, 3.580971247227529*^9}, {
   3.5810723977702456`*^9, 3.581072398253273*^9}, {3.581072852560258*^9, 
   3.581072853431308*^9}, {3.5810733920961175`*^9, 3.5810733924411373`*^9}, {
   3.5810753132370005`*^9, 3.5810753137480297`*^9}, {3.581173720334575*^9, 
   3.581173735747402*^9}}],

Cell[BoxData[
 RowBox[{"Flatten", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"typ", ",", "fr", ",", "th", ",", 
       RowBox[{"tim", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"typ", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"th", ",", "1", ",", "3"}], "}"}]}], "]"}], ",", "2"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5809711563033285`*^9, 3.5809712091793528`*^9}, 
   3.580971470056274*^9, {3.580971504849264*^9, 3.5809715323888392`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"lk", "=", 
   RowBox[{"Length", "[", "resst", "]"}]}], ";", 
  RowBox[{"lx", "=", 
   RowBox[{"Length", "[", 
    RowBox[{"resx", "[", 
     RowBox[{"3", ",", "3", ",", "1", ",", "1"}], "]"}], "]"}]}], ";", 
  RowBox[{"lm", "=", 
   RowBox[{"Length", "[", 
    RowBox[{"resx", "[", 
     RowBox[{"3", ",", "3", ",", "1", ",", "2"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mx", "=", 
   RowBox[{"1", "/", "30."}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"shift", "[", "1", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lk"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"shix", "[", "1", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lx"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"shift", "[", "2", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"1", "/", "mx"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lk"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"shix", "[", "2", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"1", "/", "mx"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lx"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"shift", "[", "3", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "mx"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lk"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"shix", "[", "3", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "mx"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lx"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"shiLP", "[", "1", "]"}], "=", 
   RowBox[{"shift", "[", "1", "]"}]}], ";", 
  RowBox[{
   RowBox[{"shiLPx", "[", "1", "]"}], "=", 
   RowBox[{"shix", "[", "1", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"shiLP", "[", "2", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0.01"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lk"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"shiLPx", "[", "2", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0.01"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lx"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"fllab", "[", "3", "]"}], ",", 
      RowBox[{"fllab", "[", "4", "]"}], ",", 
      RowBox[{"fllab", "[", "5", "]"}], ",", 
      RowBox[{"fllab", "[", "6", "]"}]}], "}"}], "=", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Flux at \>\"", ",", "\"\<LP at \>\"", ",", "\"\<EVPA at \>\"", ",", 
      "\"\<CP at \>\""}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"frlab", "[", "3", "]"}], ",", 
      RowBox[{"frlab", "[", "6", "]"}], ",", 
      RowBox[{"frlab", "[", "9", "]"}]}], "}"}], "=", 
    RowBox[{"{", 
     RowBox[{"\"\<87GHz\>\"", ",", "\"\<230GHz\>\"", ",", "\"\<857GHz\>\""}], 
     "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"shim", "[", "1", "]"}], "=", 
   RowBox[{"shix", "[", "1", "]"}]}], ";", 
  RowBox[{
   RowBox[{"shim", "[", "2", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"1", "/", "mx"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lm"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"shim", "[", "3", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "mx"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "lm"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"locs", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Middle - \>\"", ",", "\"\<Top - \>\"", ",", "\"\<Bottom - \>\""}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"meanlocs", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Middle - \>\"", ",", "\"\<Power-law fit\>\"", ",", 
     "\"\<Bottom - \>\""}], "}"}]}], ";", 
  RowBox[{"ypos", "=", 
   RowBox[{"{", 
    RowBox[{"0.16", ",", "0.24", ",", "0.08"}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5696964460373707`*^9, 3.5696964834254446`*^9}, {
   3.569760777369527*^9, 3.5697608006645594`*^9}, {3.5697609922648277`*^9, 
   3.569761051529911*^9}, 3.569762668317176*^9, {3.5697636960825644`*^9, 
   3.5697637042413783`*^9}, {3.569763742258645*^9, 3.569763746767053*^9}, {
   3.5697637911733294`*^9, 3.5697638401886153`*^9}, {3.569763870655469*^9, 
   3.56976387154467*^9}, {3.5735846662005863`*^9, 3.5735847540356855`*^9}, {
   3.5810848203408585`*^9, 3.58108482110526*^9}, {3.5810851431376257`*^9, 
   3.5810852187197585`*^9}, {3.5810889311868253`*^9, 3.581088958299673*^9}, {
   3.5810890305746*^9, 3.581089033413805*^9}, {3.581089063724658*^9, 
   3.5810890644578595`*^9}, {3.5810891215227594`*^9, 3.581089160741228*^9}, {
   3.581089740407047*^9, 3.581089746912258*^9}, {3.581089810232769*^9, 
   3.581089814007976*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mysize", "=", "16"}], ";", 
  RowBox[{"off", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.8"}], ",", "0", ",", "0.3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], ";", 
  RowBox[{"off2", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"4", ",", "4", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.9", ",", "1.0", ",", "4"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"figvy", "=", 
  RowBox[{"Figure", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"SchemeLine", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0.256"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0.256"}], "}"}]}], "}"}], ",", 
        RowBox[{"Thickness", "\[Rule]", "24"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.25", ",", "0.97"}], "}"}], ",", "\"\<Top - face-on\>\"", 
        ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.25", ",", "0.95"}], "}"}], ",", 
        "\"\<Middle - general inclination\>\"", ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.25", ",", "0.93"}], "}"}], ",", 
        "\"\<Bottom - edge-on\>\"", ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Multipanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"4", ",", "2"}], "}"}], ",", 
        RowBox[{"XPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Log10", "[", "20", "]"}], ",", 
           RowBox[{"Log10", "[", "tmax", "]"}]}], "}"}]}], ",", 
        RowBox[{"YPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Log10", "[", 
            SuperscriptBox["10", 
             RowBox[{"-", "7.9"}]], "]"}], ",", 
           RowBox[{"Log10", "[", 
            SuperscriptBox["10", "2.5"], "]"}]}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
        RowBox[{"XFrameLabels", "\[Rule]", 
         RowBox[{"{", "\"\<Period T [M]\>\"", "}"}]}], ",", 
        RowBox[{"BufferL", "\[Rule]", "6"}], ",", 
        RowBox[{"YFrameLabels", "\[Rule]", "\"\<Periodogram   I(T)\>\""}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"YFrameTicks", "\[Rule]", 
         RowBox[{"LogTicks", "[", 
          RowBox[{
           RowBox[{"-", "10"}], ",", "10"}], "]"}]}], ",", 
        RowBox[{"XFrameTicks", "\[Rule]", 
         RowBox[{"LogTicks", "[", 
          RowBox[{
           RowBox[{"-", "10"}], ",", "10", ",", 
           RowBox[{"TickLabelStep", "\[Rule]", "1"}]}], "]"}]}], ",", 
        RowBox[{"YGapSizes", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0.1"}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Background", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PanelLetterCorner", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
        RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SetOptions", "[", 
       RowBox[{"DataSymbol", ",", 
        RowBox[{"SymbolSize", "\[Rule]", "0.001"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SetOptions", "[", 
       RowBox[{"DataLine", ",", 
        RowBox[{"Thickness", "\[Rule]", "1.5"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SetOptions", "[", 
       RowBox[{"DataValues", ",", 
        RowBox[{"AxisScaling", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Log", ",", "Log"}], "}"}]}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"tabplots", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"FigurePanel", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"fr", "/", "3"}], ",", 
                RowBox[{"typ", "-", "2"}]}], "}"}], ",", 
              RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"pan", "[", 
               RowBox[{"typ", ",", "fr"}], "]"}], "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"DataPlot", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"shift", "[", "th", "]"}], 
                    RowBox[{"shiLP", "[", 
                    RowBox[{"typ", "-", "2"}], "]"}], 
                    RowBox[{"res", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}]}], 
                    ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Color", "\[Rule]", "Black"}], "}"}]}]}], "]"}], 
                  ",", 
                  RowBox[{"DataPlot", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"shift", "[", "th", "]"}], 
                    RowBox[{"shiLP", "[", 
                    RowBox[{"typ", "-", "2"}], "]"}], 
                    RowBox[{"ressmean", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}]}], 
                    ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Color", "\[Rule]", "Black"}], ",", 
                    RowBox[{"Dashing", "\[Rule]", "7"}]}], "}"}]}]}], "]"}], 
                  ",", 
                  RowBox[{"DataPlot", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"shift", "[", "th", "]"}], 
                    RowBox[{"shiLP", "[", 
                    RowBox[{"typ", "-", "2"}], "]"}], 
                    RowBox[{"ressmax", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}]}], 
                    ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Color", "\[Rule]", "Red"}], "}"}]}]}], "]"}], 
                  ",", "\[IndentingNewLine]", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{"DataPlot", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"shift", "[", "th", "]"}], 
                    RowBox[{"shiLP", "[", 
                    RowBox[{"typ", "-", "2"}], "]"}], 
                    RowBox[{"ressmax", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "3"}], "]"}]}], 
                    ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Color", "\[Rule]", "Blue"}], "}"}]}]}], "]"}], 
                    ","}], "*)"}], "\[IndentingNewLine]", 
                  RowBox[{"DataPlot", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"shix", "[", "th", "]"}], 
                    RowBox[{"shiLPx", "[", 
                    RowBox[{"typ", "-", "2"}], "]"}], 
                    RowBox[{"resx", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}]}], 
                    ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Color", "\[Rule]", "Green"}], ",", 
                    RowBox[{"Dashing", "\[Rule]", "5"}]}], "}"}]}]}], "]"}], 
                  ",", 
                  RowBox[{"ScaledLabel", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.95", ",", 
                    RowBox[{"ypos", "[", 
                    RowBox[{"[", "th", "]"}], "]"}]}], "}"}], ",", 
                    RowBox[{
                    RowBox[{"locs", "[", 
                    RowBox[{"[", "th", "]"}], "]"}], "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"Round", "[", 
                    RowBox[{
                    RowBox[{"3", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"res", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], 
                    "[", 
                    RowBox[{"[", 
                    RowBox[{"14", ",", "2"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"ressmean", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], 
                    "[", 
                    RowBox[{"[", 
                    RowBox[{"14", ",", "2"}], "]"}], "]"}]}], 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"ressmax", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], 
                    "[", 
                    RowBox[{"[", 
                    RowBox[{"14", ",", "2"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"ressmean", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], 
                    "[", 
                    RowBox[{"[", 
                    RowBox[{"14", ",", "2"}], "]"}], "]"}]}], ")"}]]}], ",", 
                    "0.1"}], "]"}], "]"}], "<>", "\"\<\[Sigma], Q\>\"", "<>", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"timezz", "=", 
                    RowBox[{
                    RowBox[{"res", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], 
                    "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
                    RowBox[{"vals", "=", 
                    RowBox[{
                    RowBox[{"res", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], 
                    "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"interand", "=", 
                    RowBox[{"Interpolation", "[", 
                    RowBox[{
                    RowBox[{"Log", "[", 
                    RowBox[{"resx", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], 
                    "]"}], ",", 
                    RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}],
                     ";", "\[IndentingNewLine]", 
                    RowBox[{"sys", "=", 
                    RowBox[{"Thread", "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"A", " ", 
                    RowBox[{"Exp", "[", 
                    RowBox[{"-", 
                    FractionBox[
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"x", "-", "x0"}], ")"}], "2"], 
                    RowBox[{"2", 
                    SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], "/.", 
                    RowBox[{"x", "->", 
                    RowBox[{"timezz", "[", 
                    RowBox[{"[", 
                    RowBox[{"13", ";;", "15"}], "]"}], "]"}]}]}], ")"}], 
                    "\[Equal]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"vals", "-", 
                    RowBox[{"Exp", "[", 
                    RowBox[{"interand", "[", 
                    RowBox[{"Log", "[", "timezz", "]"}], "]"}], "]"}]}], 
                    ")"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"13", ";;", "15"}], "]"}], "]"}]}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ff", "=", 
                    RowBox[{"FindRoot", "[", 
                    RowBox[{"sys", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"A", ",", 
                    RowBox[{"vals", "[", 
                    RowBox[{"[", "14", "]"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"x0", ",", 
                    RowBox[{"timezz", "[", 
                    RowBox[{"[", "14", "]"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"\[Sigma]", ",", "10"}], "}"}]}], "}"}]}], 
                    "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"QQ", "=", 
                    RowBox[{
                    FractionBox["x0", 
                    RowBox[{"2.", "\[Sigma]", " ", 
                    SqrtBox[
                    RowBox[{"2", 
                    RowBox[{"Log", "[", "2", "]"}]}]]}]], "/.", "ff"}]}], ";", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"QQ", "<", "2"}], ",", "\"\<<2\>\"", ",", 
                    RowBox[{"\"\<=\>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"Round", "[", "QQ", "]"}], "]"}]}]}], "]"}]}], 
                    ")"}]}], ",", 
                    RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
                    RowBox[{"Offset", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}]}]}], "]"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"th", ",", "3"}], "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"lab", "[", 
               RowBox[{"typ", ",", "fr"}], "]"}], "=", 
              RowBox[{
               RowBox[{"fllab", "[", "typ", "]"}], "<>", 
               RowBox[{"frlab", "[", "fr", "]"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"sclab", "[", 
               RowBox[{"typ", ",", "fr"}], "]"}], "=", 
              RowBox[{"ScaledLabel", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0.18", ",", "0.89"}], "}"}], ",", 
                RowBox[{"lab", "[", 
                 RowBox[{"typ", ",", "fr"}], "]"}], ",", 
                RowBox[{"Color", "\[Rule]", "Black"}], ",", 
                RowBox[{"Background", "\[Rule]", "White"}], ",", 
                RowBox[{"FontSize", "\[Rule]", 
                 RowBox[{"mysize", "-", "1"}]}], ",", 
                RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"pan", "[", 
              RowBox[{"typ", ",", "fr"}], "]"}]}], ",", 
            RowBox[{"sclab", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"SchemeArrow", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Log10", "[", "94", "]"}], ",", 
                  RowBox[{
                   RowBox[{"off", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"typ", "-", "2"}], ",", 
                    FractionBox["fr", "3"]}], "]"}], "]"}], "+", "0"}]}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Log10", "[", "94", "]"}], ",", 
                  RowBox[{
                   RowBox[{"off", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"typ", "-", "2"}], ",", 
                    FractionBox["fr", "3"]}], "]"}], "]"}], "-", "1.5"}]}], 
                 "}"}]}], "}"}], ",", 
              RowBox[{"Thickness", "\[Rule]", "2"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"SchemeArrow", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Log10", "[", "1000", "]"}], ",", 
                  RowBox[{
                   RowBox[{"off2", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"typ", "-", "2"}], ",", 
                    FractionBox["fr", "3"]}], "]"}], "]"}], "+", "0"}]}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Log10", "[", "1000", "]"}], ",", 
                  RowBox[{
                   RowBox[{"off2", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"typ", "-", "2"}], ",", 
                    FractionBox["fr", "3"]}], "]"}], "]"}], "-", "1.5"}]}], 
                 "}"}]}], "}"}], ",", 
              RowBox[{"Thickness", "\[Rule]", "2"}]}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"typ", ",", "3", ",", "4"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"meanfits", "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FigurePanel", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"DataPlot", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"shift", "[", "under", "]"}], 
                 RowBox[{"res", "[", 
                  RowBox[{"3", ",", "6", ",", "1", ",", "under"}], "]"}]}], 
                ",", 
                RowBox[{"DataLine", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"Color", "\[Rule]", "Black"}], "}"}]}]}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"DataPlot", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"shift", "[", "under", "]"}], 
                 RowBox[{"ressmean", "[", 
                  RowBox[{"3", ",", "6", ",", "1", ",", "under"}], "]"}]}], 
                ",", 
                RowBox[{"DataLine", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Color", "\[Rule]", "Black"}], ",", 
                   RowBox[{"Dashing", "\[Rule]", "7"}]}], "}"}]}]}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"DataPlot", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"shift", "[", "under", "]"}], 
                 RowBox[{"ressmax", "[", 
                  RowBox[{"3", ",", "6", ",", "1", ",", "under"}], "]"}]}], 
                ",", 
                RowBox[{"DataLine", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"Color", "\[Rule]", "Red"}], "}"}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DataPlot", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"shim", "[", "under", "]"}], 
                 RowBox[{"resx", "[", 
                  RowBox[{"3", ",", "6", ",", "1", ",", "under"}], "]"}]}], 
                ",", 
                RowBox[{"DataLine", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Color", "\[Rule]", "Green"}], ",", 
                   RowBox[{"Dashing", "\[Rule]", "5"}]}], "}"}]}]}], "]"}], 
              ",", 
              RowBox[{"ScaledLabel", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0.95", ",", 
                  RowBox[{"ypos", "[", 
                   RowBox[{"[", "under", "]"}], "]"}]}], "}"}], ",", 
                RowBox[{
                 RowBox[{"locs", "[", 
                  RowBox[{"[", "under", "]"}], "]"}], "<>", 
                 RowBox[{"ToString", "[", 
                  RowBox[{"Round", "[", 
                   RowBox[{
                    RowBox[{"3", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"res", "[", 
                    RowBox[{"3", ",", "6", ",", "1", ",", "under"}], "]"}], 
                    "[", 
                    RowBox[{"[", 
                    RowBox[{"14", ",", "2"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"ressmean", "[", 
                    RowBox[{"3", ",", "6", ",", "1", ",", "under"}], "]"}], 
                    "[", 
                    RowBox[{"[", 
                    RowBox[{"14", ",", "2"}], "]"}], "]"}]}], 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"ressmax", "[", 
                    RowBox[{"3", ",", "6", ",", "1", ",", "under"}], "]"}], 
                    "[", 
                    RowBox[{"[", 
                    RowBox[{"14", ",", "2"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"ressmean", "[", 
                    RowBox[{"3", ",", "6", ",", "1", ",", "under"}], "]"}], 
                    "[", 
                    RowBox[{"[", 
                    RowBox[{"14", ",", "2"}], "]"}], "]"}]}], ")"}]]}], ",", 
                    "0.1"}], "]"}], "]"}], "<>", "\"\<\[Sigma], Q\>\"", "<>", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"timezz", "=", 
                    RowBox[{
                    RowBox[{"res", "[", 
                    RowBox[{"3", ",", "6", ",", "1", ",", "under"}], "]"}], 
                    "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
                   RowBox[{"vals", "=", 
                    RowBox[{
                    RowBox[{"res", "[", 
                    RowBox[{"3", ",", "6", ",", "1", ",", "under"}], "]"}], 
                    "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{"interand", "=", 
                    RowBox[{"Interpolation", "[", 
                    RowBox[{
                    RowBox[{"Log", "[", 
                    RowBox[{"resx", "[", 
                    RowBox[{"3", ",", "6", ",", "1", ",", "under"}], "]"}], 
                    "]"}], ",", 
                    RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}],
                    ";", "\[IndentingNewLine]", 
                   RowBox[{"sys", "=", 
                    RowBox[{"Thread", "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"A", " ", 
                    RowBox[{"Exp", "[", 
                    RowBox[{"-", 
                    FractionBox[
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"x", "-", "x0"}], ")"}], "2"], 
                    RowBox[{"2", 
                    SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], "/.", 
                    RowBox[{"x", "\[Rule]", 
                    RowBox[{"timezz", "[", 
                    RowBox[{"[", 
                    RowBox[{"13", ";;", "15"}], "]"}], "]"}]}]}], ")"}], 
                    "\[Equal]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"vals", "-", 
                    RowBox[{"Exp", "[", 
                    RowBox[{"interand", "[", 
                    RowBox[{"Log", "[", "timezz", "]"}], "]"}], "]"}]}], 
                    ")"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"13", ";;", "15"}], "]"}], "]"}]}], "]"}]}], ";", 
                   "\[IndentingNewLine]", 
                   RowBox[{"ff", "=", 
                    RowBox[{"FindRoot", "[", 
                    RowBox[{"sys", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"A", ",", 
                    RowBox[{"vals", "[", 
                    RowBox[{"[", "14", "]"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"x0", ",", 
                    RowBox[{"timezz", "[", 
                    RowBox[{"[", "14", "]"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"\[Sigma]", ",", "10"}], "}"}]}], "}"}]}], 
                    "]"}]}], ";", "\[IndentingNewLine]", 
                   RowBox[{"QQ", "=", 
                    RowBox[{
                    FractionBox["x0", 
                    RowBox[{"2.", "\[Sigma]", " ", 
                    SqrtBox[
                    RowBox[{"2", 
                    RowBox[{"Log", "[", "2", "]"}]}]]}]], "/.", "ff"}]}], ";", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"QQ", "<", "2"}], ",", "\"\<<2\>\"", ",", 
                    RowBox[{"\"\<=\>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"Round", "[", "QQ", "]"}], "]"}]}]}], "]"}]}], 
                  ")"}]}], ",", 
                RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
                RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
                RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
                RowBox[{"Offset", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "0"}], "}"}]}]}], "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"under", ",", "3"}], "}"}]}], "]"}], ",", 
          RowBox[{"ScaledLabel", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.18", ",", "0.89"}], "}"}], ",", 
            RowBox[{"lab", "[", 
             RowBox[{"3", ",", "6"}], "]"}], ",", 
            RowBox[{"Color", "\[Rule]", "Black"}], ",", 
            RowBox[{"Background", "\[Rule]", "White"}], ",", 
            RowBox[{"FontSize", "\[Rule]", 
             RowBox[{"mysize", "-", "1"}]}], ",", 
            RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
          RowBox[{"ScaledLabel", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.35", ",", "0.92"}], "}"}], ",", 
            "\"\<Top - power-law fit\>\"", ",", 
            RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
            RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
            RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
            RowBox[{"Offset", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ScaledLabel", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.35", ",", "0.84"}], "}"}], ",", 
            "\"\<Middle - smoothed periodogram\>\"", ",", 
            RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
            RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
            RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
            RowBox[{"Offset", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ScaledLabel", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.35", ",", "0.76"}], "}"}], ",", 
            "\"\<Bottom - broken power-law\>\"", ",", 
            RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
            RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
            RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
            RowBox[{"Offset", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}]}], "}"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"thlist", "=", 
        RowBox[{"{", 
         RowBox[{"1", ",", "4", ",", "5"}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"varphi", "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FigurePanel", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "2"}], "}"}], ",", 
            RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"th", "=", 
              RowBox[{"thlist", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}], ";", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"DataPlot", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"shift", "[", "i", "]"}], 
                  RowBox[{"res", "[", 
                   RowBox[{"3", ",", "6", ",", "th", ",", "1"}], "]"}]}], ",", 
                 RowBox[{"DataLine", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Color", "\[Rule]", "Black"}], "}"}]}]}], "]"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"DataPlot", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"shift", "[", "i", "]"}], 
                  RowBox[{"ressmean", "[", 
                   RowBox[{"3", ",", "6", ",", "th", ",", "1"}], "]"}]}], ",", 
                 RowBox[{"DataLine", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Color", "\[Rule]", "Black"}], ",", 
                    RowBox[{"Dashing", "\[Rule]", "7"}]}], "}"}]}]}], "]"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"DataPlot", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"shift", "[", "i", "]"}], 
                  RowBox[{"ressmax", "[", 
                   RowBox[{"3", ",", "6", ",", "th", ",", "1"}], "]"}]}], ",", 
                 RowBox[{"DataLine", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Color", "\[Rule]", "Red"}], "}"}]}]}], "]"}], ",",
                "\[IndentingNewLine]", 
               RowBox[{"DataPlot", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"shix", "[", "i", "]"}], 
                  RowBox[{"resx", "[", 
                   RowBox[{"3", ",", "6", ",", "th", ",", "1"}], "]"}]}], ",", 
                 RowBox[{"DataLine", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Color", "\[Rule]", "Green"}], ",", 
                    RowBox[{"Dashing", "\[Rule]", "5"}]}], "}"}]}]}], "]"}], 
               ",", 
               RowBox[{"ScaledLabel", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0.95", ",", 
                   RowBox[{"ypos", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "}"}], ",", 
                 RowBox[{
                  RowBox[{"locs", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "<>", 
                  RowBox[{"ToString", "[", 
                   RowBox[{"Round", "[", 
                    RowBox[{
                    RowBox[{"3", 
                    FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"res", "[", 
                    RowBox[{"3", ",", "6", ",", "th", ",", "1"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"14", ",", "2"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"ressmean", "[", 
                    RowBox[{"3", ",", "6", ",", "th", ",", "1"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"14", ",", "2"}], "]"}], "]"}]}], 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"ressmax", "[", 
                    RowBox[{"3", ",", "6", ",", "th", ",", "1"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"14", ",", "2"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"ressmean", "[", 
                    RowBox[{"3", ",", "6", ",", "th", ",", "1"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"14", ",", "2"}], "]"}], "]"}]}], ")"}]]}], ",", 
                    "0.1"}], "]"}], "]"}], "<>", "\"\<\[Sigma], Q\>\"", "<>", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"timezz", "=", 
                    RowBox[{
                    RowBox[{"res", "[", 
                    RowBox[{"3", ",", "6", ",", "th", ",", "1"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
                    RowBox[{"vals", "=", 
                    RowBox[{
                    RowBox[{"res", "[", 
                    RowBox[{"3", ",", "6", ",", "th", ",", "1"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"interand", "=", 
                    RowBox[{"Interpolation", "[", 
                    RowBox[{
                    RowBox[{"Log", "[", 
                    RowBox[{"resx", "[", 
                    RowBox[{"3", ",", "6", ",", "th", ",", "1"}], "]"}], 
                    "]"}], ",", 
                    RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}],
                     ";", "\[IndentingNewLine]", 
                    RowBox[{"sys", "=", 
                    RowBox[{"Thread", "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"A", " ", 
                    RowBox[{"Exp", "[", 
                    RowBox[{"-", 
                    FractionBox[
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"x", "-", "x0"}], ")"}], "2"], 
                    RowBox[{"2", 
                    SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], "/.", 
                    RowBox[{"x", "->", 
                    RowBox[{"timezz", "[", 
                    RowBox[{"[", 
                    RowBox[{"13", ";;", "15"}], "]"}], "]"}]}]}], ")"}], 
                    "\[Equal]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"vals", "-", 
                    RowBox[{"Exp", "[", 
                    RowBox[{"interand", "[", 
                    RowBox[{"Log", "[", "timezz", "]"}], "]"}], "]"}]}], 
                    ")"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"13", ";;", "15"}], "]"}], "]"}]}], "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ff", "=", 
                    RowBox[{"FindRoot", "[", 
                    RowBox[{"sys", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"A", ",", 
                    RowBox[{"vals", "[", 
                    RowBox[{"[", "14", "]"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"x0", ",", 
                    RowBox[{"timezz", "[", 
                    RowBox[{"[", "14", "]"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"\[Sigma]", ",", "10"}], "}"}]}], "}"}]}], 
                    "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"QQ", "=", 
                    RowBox[{
                    FractionBox["x0", 
                    RowBox[{"2.", "\[Sigma]", " ", 
                    SqrtBox[
                    RowBox[{"2", 
                    RowBox[{"Log", "[", "2", "]"}]}]]}]], "/.", "ff"}]}], ";", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"QQ", "<", "2"}], ",", "\"\<<2\>\"", ",", 
                    RowBox[{"\"\<=\>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"Round", "[", "QQ", "]"}], "]"}]}]}], "]"}]}], 
                   ")"}]}], ",", 
                 RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
                 RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
                 RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
                 RowBox[{"Offset", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"1", ",", "0"}], "}"}]}]}], "]"}]}], "}"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"Length", "[", "thlist", "]"}]}], "}"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{"th", "=."}], ";", 
           RowBox[{"ScaledLabel", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0.18", ",", "0.89"}], "}"}], ",", 
             RowBox[{"lab", "[", 
              RowBox[{"3", ",", "6"}], "]"}], ",", 
             RowBox[{"Color", "\[Rule]", "Black"}], ",", 
             RowBox[{"Background", "\[Rule]", "White"}], ",", 
             RowBox[{"FontSize", "\[Rule]", 
              RowBox[{"mysize", "-", "1"}]}], ",", 
             RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}]}], ",", 
          RowBox[{"ScaledLabel", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.40", ",", "0.92"}], "}"}], ",", 
            "\"\<Top - angle \[Phi]=120deg\>\"", ",", 
            RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
            RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
            RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
            RowBox[{"Offset", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ScaledLabel", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.40", ",", "0.84"}], "}"}], ",", 
            "\"\<Middle - angle \[Phi]=0deg\>\"", ",", 
            RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
            RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
            RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
            RowBox[{"Offset", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ScaledLabel", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.40", ",", "0.76"}], "}"}], ",", 
            "\"\<Bottom - angle \[Phi]=240deg\>\"", ",", 
            RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
            RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
            RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
            RowBox[{"Offset", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}]}], "}"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"Join", "[", 
        RowBox[{"tabplots", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "meanfits", "}"}], ",", 
           RowBox[{"{", "varphi", "}"}]}], "}"}], ",", "2"}], "]"}]}]}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.08"}], ",", "1.01"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.04"}], ",", "1.01"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"800", ",", "1100"}], "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"figvy", "=", 
    RowBox[{"Figure", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ScaledLabel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.29", ",", "0.74"}], "}"}], ",", "\"\<Top - face-on\>\"",
           ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
          RowBox[{"Offset", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ScaledLabel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.29", ",", "0.72"}], "}"}], ",", 
          "\"\<Middle - general inclination\>\"", ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
          RowBox[{"Offset", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ScaledLabel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.29", ",", "0.70"}], "}"}], ",", 
          "\"\<Bottom - edge-on\>\"", ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
          RowBox[{"Offset", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Multipanel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"3", ",", "2"}], "}"}], ",", 
          RowBox[{"XPlotRanges", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", "20", "]"}], ",", 
             RowBox[{"Log10", "[", "tmax", "]"}]}], "}"}]}], ",", 
          RowBox[{"YPlotRanges", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", 
              SuperscriptBox["10", 
               RowBox[{"-", "7.9"}]], "]"}], ",", 
             RowBox[{"Log10", "[", 
              SuperscriptBox["10", "2.5"], "]"}]}], "}"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
          RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
          RowBox[{"XFrameLabels", "\[Rule]", 
           RowBox[{"{", "\"\<Period T [M]\>\"", "}"}]}], ",", 
          RowBox[{"BufferL", "\[Rule]", "6"}], ",", 
          RowBox[{"YFrameLabels", "\[Rule]", "\"\<Periodogram   I(T)\>\""}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"YFrameTicks", "\[Rule]", 
           RowBox[{"LogTicks", "[", 
            RowBox[{
             RowBox[{"-", "10"}], ",", "10"}], "]"}]}], ",", 
          RowBox[{"XFrameTicks", "\[Rule]", 
           RowBox[{"LogTicks", "[", 
            RowBox[{
             RowBox[{"-", "10"}], ",", "10", ",", 
             RowBox[{"TickLabelStep", "\[Rule]", "1"}]}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Background", "\[Rule]", "White"}], ",", 
          RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
          RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"PanelLetterCorner", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
          RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
          RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"SetOptions", "[", 
         RowBox[{"DataSymbol", ",", 
          RowBox[{"SymbolSize", "\[Rule]", "0.001"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"SetOptions", "[", 
         RowBox[{"DataLine", ",", 
          RowBox[{"Thickness", "\[Rule]", "1.5"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"SetOptions", "[", 
         RowBox[{"DataValues", ",", 
          RowBox[{"AxisScaling", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Log", ",", "Log"}], "}"}]}]}], "]"}], ",", 
        RowBox[{"tabplots", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"FigurePanel", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"fr", "/", "3"}], ",", 
                 RowBox[{"typ", "-", "2"}]}], "}"}], ",", 
               RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"pan", "[", 
                RowBox[{"typ", ",", "fr"}], "]"}], "=", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"DataPlot", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"shift", "[", "th", "]"}], 
                    RowBox[{"shiLP", "[", 
                    RowBox[{"typ", "-", "2"}], "]"}], 
                    RowBox[{"res", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}]}], 
                    ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Color", "\[Rule]", "Black"}], "}"}]}]}], "]"}], 
                   ",", 
                   RowBox[{"DataPlot", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"shift", "[", "th", "]"}], 
                    RowBox[{"shiLP", "[", 
                    RowBox[{"typ", "-", "2"}], "]"}], 
                    RowBox[{"ressmean", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}]}], 
                    ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Color", "\[Rule]", "Black"}], ",", 
                    RowBox[{"Dashing", "\[Rule]", "7"}]}], "}"}]}]}], "]"}], 
                   ",", 
                   RowBox[{"DataPlot", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"shift", "[", "th", "]"}], 
                    RowBox[{"shiLP", "[", 
                    RowBox[{"typ", "-", "2"}], "]"}], 
                    RowBox[{"ressmax", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}]}], 
                    ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Color", "\[Rule]", "Red"}], "}"}]}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"DataPlot", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"shift", "[", "th", "]"}], 
                    RowBox[{"shiLP", "[", 
                    RowBox[{"typ", "-", "2"}], "]"}], 
                    RowBox[{"ressmax", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "3"}], "]"}]}], 
                    ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Color", "\[Rule]", "Blue"}], "}"}]}]}], "]"}], 
                    ","}], "*)"}], "\[IndentingNewLine]", 
                   RowBox[{"DataPlot", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"shix", "[", "th", "]"}], 
                    RowBox[{"shiLPx", "[", 
                    RowBox[{"typ", "-", "2"}], "]"}], 
                    RowBox[{"resx", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}]}], 
                    ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Color", "\[Rule]", "Green"}], ",", 
                    RowBox[{"Dashing", "\[Rule]", "5"}]}], "}"}]}]}], "]"}]}],
                   "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"th", ",", "3"}], "}"}]}], "]"}]}], ";", 
              RowBox[{
               RowBox[{"lab", "[", 
                RowBox[{"typ", ",", "fr"}], "]"}], "=", 
               RowBox[{
                RowBox[{"fllab", "[", "typ", "]"}], "<>", 
                RowBox[{"frlab", "[", "fr", "]"}]}]}], ";", 
              RowBox[{
               RowBox[{"sclab", "[", 
                RowBox[{"typ", ",", "fr"}], "]"}], "=", 
               RowBox[{"ScaledLabel", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0.18", ",", "0.89"}], "}"}], ",", 
                 RowBox[{"lab", "[", 
                  RowBox[{"typ", ",", "fr"}], "]"}], ",", 
                 RowBox[{"Color", "\[Rule]", "Black"}], ",", 
                 RowBox[{"Background", "\[Rule]", "White"}], ",", 
                 RowBox[{"FontSize", "\[Rule]", 
                  RowBox[{"mysize", "-", "1"}]}], ",", 
                 RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}]}], ";", 
              RowBox[{"pan", "[", 
               RowBox[{"typ", ",", "fr"}], "]"}]}], ",", 
             RowBox[{"sclab", "[", 
              RowBox[{"typ", ",", "fr"}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"SchemeArrow", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Log10", "[", "94", "]"}], ",", 
                   RowBox[{
                    RowBox[{"off", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"typ", "-", "2"}], ",", 
                    FractionBox["fr", "3"]}], "]"}], "]"}], "+", "0"}]}], 
                  "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Log10", "[", "94", "]"}], ",", 
                   RowBox[{
                    RowBox[{"off", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"typ", "-", "2"}], ",", 
                    FractionBox["fr", "3"]}], "]"}], "]"}], "-", "1.5"}]}], 
                  "}"}]}], "}"}], ",", 
               RowBox[{"Thickness", "\[Rule]", "2"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"SchemeArrow", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Log10", "[", "1000", "]"}], ",", 
                   RowBox[{
                    RowBox[{"off2", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"typ", "-", "2"}], ",", 
                    FractionBox["fr", "3"]}], "]"}], "]"}], "+", "0"}]}], 
                  "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Log10", "[", "1000", "]"}], ",", 
                   RowBox[{
                    RowBox[{"off2", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"typ", "-", "2"}], ",", 
                    FractionBox["fr", "3"]}], "]"}], "]"}], "-", "1.5"}]}], 
                  "}"}]}], "}"}], ",", 
               RowBox[{"Thickness", "\[Rule]", "2"}]}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"typ", ",", "3", ",", "4"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
          "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.10"}], ",", "1.01"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.07"}], ",", "1.01"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"800", ",", "800"}], "}"}]}]}], "]"}]}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5735664591581025`*^9, 3.573566463203164*^9}, {
   3.5735664947653995`*^9, 3.573566623426626*^9}, {3.573566666606289*^9, 
   3.5735667870643897`*^9}, {3.5735670713437605`*^9, 3.573567071727517*^9}, {
   3.57357300689021*^9, 3.5735730255827475`*^9}, {3.5735732134163833`*^9, 
   3.573573244165106*^9}, {3.5735733331797233`*^9, 3.573573358563613*^9}, {
   3.573573446813219*^9, 3.5735734567458715`*^9}, {3.5735735166385417`*^9, 
   3.5735736350816107`*^9}, {3.573573991612338*^9, 3.5735741497110167`*^9}, {
   3.573574289680667*^9, 3.573574294669244*^9}, {3.573574365970589*^9, 
   3.5735743953742914`*^9}, {3.5735745009776635`*^9, 
   3.5735745073352613`*^9}, {3.5735745416015377`*^9, 
   3.5735745441378264`*^9}, {3.5735746120151196`*^9, 
   3.5735746139063983`*^9}, {3.5735746530212493`*^9, 3.573574672425047*^9}, {
   3.5735747602559032`*^9, 3.5735747780771775`*^9}, {3.573584775724269*^9, 
   3.573584789954238*^9}, {3.5735848269805565`*^9, 3.5735849503709517`*^9}, 
   3.580274831436249*^9, {3.580826060110611*^9, 3.5808260671774235`*^9}, 
   3.5808261952224483`*^9, {3.5810675175931153`*^9, 3.5810675251515474`*^9}, {
   3.5810676928471394`*^9, 3.5810677166705017`*^9}, {3.5810677560977573`*^9, 
   3.5810677968770895`*^9}, {3.5810837233439317`*^9, 
   3.5810837784120283`*^9}, {3.5810838392521353`*^9, 
   3.5810839233362827`*^9}, {3.5810839687011623`*^9, 
   3.5810839941916075`*^9}, {3.5810840623481274`*^9, 
   3.5810840660297337`*^9}, {3.581084143093869*^9, 3.581084218941202*^9}, {
   3.5810843712598696`*^9, 3.581084385143894*^9}, {3.5810844253763647`*^9, 
   3.5810844257195654`*^9}, {3.5810844667320375`*^9, 3.581084513048519*^9}, {
   3.581084571814822*^9, 3.581084624745715*^9}, 3.5810847131364703`*^9, {
   3.581085139190819*^9, 3.5810851395652194`*^9}, 3.581085222682165*^9, {
   3.581085341148773*^9, 3.581085409211693*^9}, {3.5810854546545725`*^9, 
   3.5810855818883963`*^9}, {3.581085638454096*^9, 3.581085766936921*^9}, {
   3.581085802582984*^9, 3.581085810414198*^9}, {3.581087246797101*^9, 
   3.5810872658135347`*^9}, {3.5810873903329535`*^9, 3.581087435900633*^9}, {
   3.5810875211079826`*^9, 3.5810875858792963`*^9}, {3.581088619543078*^9, 
   3.581088700990821*^9}, {3.581088741566492*^9, 3.58108877417155*^9}, {
   3.581088840566266*^9, 3.5810889026075754`*^9}, {3.581088967020088*^9, 
   3.5810890003573465`*^9}, {3.581089088622302*^9, 3.581089118917555*^9}, {
   3.581089163720834*^9, 3.5810891737360516`*^9}, {3.581089220270933*^9, 
   3.5810892451997766`*^9}, {3.5810892795822372`*^9, 3.58108933812914*^9}, {
   3.58108938360322*^9, 3.58108938375922*^9}, {3.5810896605661063`*^9, 
   3.5810897345570364`*^9}, 3.581089828922602*^9, {3.5810898683126717`*^9, 
   3.581089871198676*^9}, {3.5810900232989435`*^9, 3.581090065637418*^9}, {
   3.581090134558339*^9, 3.5810901348859396`*^9}, {3.58109017525881*^9, 
   3.581090208658469*^9}, {3.5810902490313396`*^9, 3.5810903180926614`*^9}, {
   3.581090379913125*^9, 3.5810904132971835`*^9}, {3.5810906796732883`*^9, 
   3.581090680243289*^9}, {3.5810907108363323`*^9, 3.581090744561987*^9}, {
   3.581090787352862*^9, 3.581090790753668*^9}, {3.581090832951742*^9, 
   3.5810908369921494`*^9}, {3.5810911059572215`*^9, 3.581091120231247*^9}, {
   3.581091169480533*^9, 3.581091365730878*^9}, {3.5811722427199125`*^9, 
   3.5811723998131886`*^9}, {3.5811725784064803`*^9, 3.581172610870137*^9}, {
   3.5811726433337946`*^9, 3.5811726992754927`*^9}, {3.581177467345357*^9, 
   3.5811774718693647`*^9}, {3.581788611188488*^9, 3.5817886129402103`*^9}, {
   3.581788674152483*^9, 3.5817886753351336`*^9}, {3.581788787178836*^9, 
   3.581788790457252*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD QPOs\\\\!svn\\\
\\figures\\\\periodograms.eps\>\"", ",", "figvy"}], "]"}]], "Input",
 CellChangeTimes->{{3.569764331698596*^9, 3.569764336753005*^9}, 
   3.5697736695461597`*^9, {3.5697748455171747`*^9, 3.569774874252425*^9}, {
   3.5735670752975717`*^9, 3.5735670753613224`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"typ", "=", "3"}], ";", 
  RowBox[{"fr", "=", "6"}], ";", 
  RowBox[{"th", "=", "1"}], ";", 
  RowBox[{"under", "=", "1"}], ";", 
  RowBox[{"typ", "=."}], ";", 
  RowBox[{"fr", "=."}], ";", 
  RowBox[{"th", "=."}], ";", 
  RowBox[{"under", "=."}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"under", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"timezz", "=", 
      RowBox[{
       RowBox[{"res", "[", 
        RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"vals", "=", 
      RowBox[{
       RowBox[{"res", "[", 
        RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"interand", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"resx", "[", 
          RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "]"}], 
        ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sys", "=", 
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"A", " ", 
           RowBox[{"Exp", "[", 
            RowBox[{"-", 
             FractionBox[
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"x", "-", "x0"}], ")"}], "2"], 
              RowBox[{"2", 
               SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], "/.", 
          RowBox[{"x", "->", 
           RowBox[{"timezz", "[", 
            RowBox[{"[", 
             RowBox[{"13", ";;", "15"}], "]"}], "]"}]}]}], ")"}], "\[Equal]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"vals", "-", 
           RowBox[{"Exp", "[", 
            RowBox[{"interand", "[", 
             RowBox[{"Log", "[", "timezz", "]"}], "]"}], "]"}]}], ")"}], "[", 
         RowBox[{"[", 
          RowBox[{"13", ";;", "15"}], "]"}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ff", "=", 
      RowBox[{"FindRoot", "[", 
       RowBox[{"sys", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"A", ",", 
            RowBox[{"vals", "[", 
             RowBox[{"[", "14", "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x0", ",", 
            RowBox[{"timezz", "[", 
             RowBox[{"[", "14", "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Sigma]", ",", "10"}], "}"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ff", ",", 
       RowBox[{
        FractionBox["x0", 
         RowBox[{"2.", "\[Sigma]", " ", 
          SqrtBox[
           RowBox[{"2", 
            RowBox[{"Log", "[", "2", "]"}]}]]}]], "/.", "ff"}], ",", 
       RowBox[{"Round", "[", 
        RowBox[{
         RowBox[{"3", 
          FractionBox[
           RowBox[{
            RowBox[{
             RowBox[{"res", "[", 
              RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"14", ",", "2"}], "]"}], "]"}], "-", 
            RowBox[{
             RowBox[{"ressmean", "[", 
              RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"14", ",", "2"}], "]"}], "]"}]}], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"ressmax", "[", 
               RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"14", ",", "2"}], "]"}], "]"}], "-", 
             RowBox[{
              RowBox[{"ressmean", "[", 
               RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"14", ",", "2"}], "]"}], "]"}]}], ")"}]]}], ",", 
         "0.1"}], "]"}]}], "}"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"typ", ",", "3", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"th", ",", "1", ",", "3"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"res", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], ",", 
      RowBox[{"resx", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}]}], "}"}], 
    "]"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"ListLogLinearPlot", "[", 
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{"timezz", ",", 
       RowBox[{"1", "-", 
        FractionBox[
         RowBox[{"Exp", "[", 
          RowBox[{"interand", "[", 
           RowBox[{"Log", "[", "timezz", "]"}], "]"}], "]"}], "vals"]}]}], 
      "}"}], "]"}], "]"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5811703599761286`*^9, 3.581170434169859*^9}, {
   3.581170497037969*^9, 3.58117079328249*^9}, {3.581171897960359*^9, 
   3.5811720530079794`*^9}, {3.5811721096984787`*^9, 3.58117211054088*^9}, 
   3.5811739001726913`*^9}],

Cell[BoxData[
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Changes in significance for different \[Phi]:\>\"", ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Quiet", "[", 
      RowBox[{
       RowBox[{"3", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"res", "[", 
            RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
          RowBox[{
           RowBox[{"ressmean", "[", 
            RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}]}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"ressmax", "[", 
             RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
           RowBox[{
            RowBox[{"ressmean", "[", 
             RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}]}], ")"}]]}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i", "\[Rule]", "14"}], ",", 
         RowBox[{"under", "\[Rule]", "1"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"typ", ",", "3", ",", "4"}], 
      RowBox[{"(*", "6", "*)"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"th", ",", "1", ",", "3"}], "}"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.58108830754253*^9, 3.5810883863538685`*^9}, {
  3.5810884251667366`*^9, 3.5810884793144317`*^9}, {3.581332745453455*^9, 
  3.581332764076481*^9}}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"ressmax", "[", 
     RowBox[{"3", ",", "9", ",", "1", ",", "1"}], "]"}], "[", 
    RowBox[{"[", "14", "]"}], "]"}], ",", 
   RowBox[{
    RowBox[{"ressmax", "[", 
     RowBox[{"3", ",", "9", ",", "1", ",", "3"}], "]"}], "[", 
    RowBox[{"[", "14", "]"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabsig", "=", 
   RowBox[{"Quiet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"ressmax", "[", 
         RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "2"}], "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{"ressmean", "[", 
         RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "2"}], "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{"ressmax", "[", 
         RowBox[{"typ", ",", "fr", ",", "th", ",", "3"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "2"}], "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{"ressmean", "[", 
         RowBox[{"typ", ",", "fr", ",", "th", ",", "3"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "2"}], "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{"res", "[", 
         RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"typ", "\[Rule]", "3"}], ",", 
       RowBox[{"fr", "\[Rule]", "9"}], ",", 
       RowBox[{"th", "\[Rule]", "1"}], ",", 
       RowBox[{"i", "\[Rule]", "14"}]}], "}"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ressmax", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], ",", 
      RowBox[{"ressmean", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], ",", 
      RowBox[{"ressmax", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "3"}], "]"}], ",", 
      RowBox[{"ressmean", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "3"}], "]"}], ",", 
      RowBox[{"res", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}]}], "}"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"typ", "\[Rule]", "3"}], ",", 
      RowBox[{"fr", "\[Rule]", "9"}], ",", 
      RowBox[{"th", "\[Rule]", "1"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"tabvar", "=", 
  RowBox[{"Flatten", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Quiet", "[", 
         RowBox[{
          RowBox[{"3", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"res", "[", 
               RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], 
              "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
             RowBox[{
              RowBox[{"ressmean", "[", 
               RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], 
              "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}]}], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"ressmax", "[", 
                RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], 
               "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
              RowBox[{
               RowBox[{"ressmean", "[", 
                RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], 
               "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}]}], ")"}]]}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"i", "\[Rule]", "14"}], ",", 
            RowBox[{"under", "\[Rule]", "#"}]}], "}"}]}], "]"}], "&"}], "/@", 
       RowBox[{"{", 
        RowBox[{"1", ",", "3"}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"typ", ",", "3", ",", "4"}], 
       RowBox[{"(*", "6", "*)"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"th", ",", "1", ",", "3"}], "}"}]}], "]"}], ",", "2"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Shift of 3\[Sigma] curve is = \>\"", ",", 
   RowBox[{"tabyy", "=", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Quiet", "[", 
         RowBox[{
          RowBox[{"3", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"ressmax", "[", 
               RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
             RowBox[{
              RowBox[{"ressmax", "[", 
               RowBox[{"typ", ",", "fr", ",", "th", ",", "3"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}]}], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"ressmax", "[", 
                RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
              RowBox[{
               RowBox[{"ressmean", "[", 
                RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}]}], ")"}]]}], "/.", 
          RowBox[{"{", 
           RowBox[{"i", "\[Rule]", "14"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"typ", ",", "3", ",", "4"}], 
         RowBox[{"(*", "6", "*)"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"th", ",", "1", ",", "3"}], "}"}]}], "]"}], ",", "2"}], 
     "]"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Shift of 3\[Sigma] curve for power-law fit is = \>\"", ",", 
   RowBox[{"tabyy22", "=", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Quiet", "[", 
         RowBox[{
          RowBox[{"3", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"ressmax", "[", 
               RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
             RowBox[{
              RowBox[{"ressmax", "[", 
               RowBox[{"typ", ",", "fr", ",", "th", ",", "2"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}]}], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"ressmax", "[", 
                RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
              RowBox[{
               RowBox[{"ressmean", "[", 
                RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}]}], ")"}]]}], "/.", 
          RowBox[{"{", 
           RowBox[{"i", "\[Rule]", "14"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"typ", ",", "3", ",", "4"}], 
         RowBox[{"(*", "6", "*)"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"th", ",", "1", ",", "3"}], "}"}]}], "]"}], ",", "2"}], 
     "]"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Ratio of 3\[Sigma] bin sizes is = \>\"", ",", 
   RowBox[{"tabxx", "=", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Quiet", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{
             RowBox[{"ressmax", "[", 
              RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
            RowBox[{
             RowBox[{"ressmean", "[", 
              RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"ressmax", "[", 
               RowBox[{"typ", ",", "fr", ",", "th", ",", "3"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
             RowBox[{
              RowBox[{"ressmean", "[", 
               RowBox[{"typ", ",", "fr", ",", "th", ",", "3"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}]}], ")"}]], "/.", 
          RowBox[{"{", 
           RowBox[{"i", "\[Rule]", "14"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"typ", ",", "3", ",", "4"}], 
         RowBox[{"(*", "6", "*)"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"th", ",", "1", ",", "3"}], "}"}]}], "]"}], ",", "2"}], 
     "]"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Percentage \[Sigma] difference = \>\"", ",", 
   RowBox[{"Abs", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"tabvar", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1"}], "]"}], "]"}], 
      RowBox[{"tabvar", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "2"}], "]"}], "]"}]], "-", "1"}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Absolute \[Sigma] difference = \>\"", ",", 
   RowBox[{"Abs", "[", 
    RowBox[{
     RowBox[{"tabvar", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1"}], "]"}], "]"}], "-", 
     RowBox[{"tabvar", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "2"}], "]"}], "]"}]}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"xxvar", "=", 
  RowBox[{"Flatten", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"typ", ",", "fr", ",", "th"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"typ", ",", "3", ",", "4"}], 
       RowBox[{"(*", "6", "*)"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"th", ",", "1", ",", "3"}], "}"}]}], "]"}], ",", "2"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Typical deviation of 3\[Sigma] levels = \>\"", ",", 
    RowBox[{"Median", "[", 
     RowBox[{"Abs", "[", "tabyy", "]"}], "]"}], ",", 
    "\"\<\[Sigma] \[Implies] we take 4\[Sigma] QPOs as significant; deviation \
for power-law fit = \>\"", ",", 
    RowBox[{"Median", "[", 
     RowBox[{"Abs", "[", "tabyy22", "]"}], "]"}], ",", "\"\<\[Sigma]\>\""}], 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Typical ratio of 3\[Sigma] range sizes = \>\"", ",", 
   RowBox[{"Median", "[", "tabxx", "]"}], ",", 
   "\"\< - consistent with 1\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.5810681164403677`*^9, 3.5810681664642286`*^9}, {
   3.5810682380903254`*^9, 3.581068408162053*^9}, 3.5810684761769433`*^9, {
   3.581068511056938*^9, 3.5810686847398725`*^9}, {3.58106873033348*^9, 
   3.581068783223505*^9}, {3.5810688669482937`*^9, 3.5810688754337797`*^9}, {
   3.581068946158825*^9, 3.5810689490659904`*^9}, {3.581068979343723*^9, 
   3.581068983236945*^9}, {3.5810691216558623`*^9, 3.58106913682773*^9}, {
   3.581071928893427*^9, 3.5810719400200634`*^9}, {3.581072349338475*^9, 
   3.5810723501155195`*^9}, 3.581072592776399*^9, {3.58107291238768*^9, 
   3.5810729183080187`*^9}, {3.581073098777341*^9, 3.5810731273249736`*^9}, {
   3.581073163892065*^9, 3.5810732083876104`*^9}, {3.5810732509460444`*^9, 
   3.581073289407244*^9}, 3.5810752814351816`*^9, {3.5810759570748262`*^9, 
   3.581075957247836*^9}, {3.581077623685151*^9, 3.581077627569373*^9}, {
   3.5810776655785465`*^9, 3.5810777525785227`*^9}, {3.5810778066476154`*^9, 
   3.5810779056562786`*^9}, 3.581078081453334*^9, {3.5810781781648655`*^9, 
   3.5810782028782787`*^9}, {3.5810782899242573`*^9, 3.581078368095729*^9}, {
   3.5810806890024767`*^9, 3.5810807589314766`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"th", "=."}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"tres", "=", 
  RowBox[{"Flatten", "[", 
   RowBox[{
    RowBox[{"Quiet", "[", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"3", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"res", "[", 
               RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], 
              "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
             RowBox[{
              RowBox[{"ressmean", "[", 
               RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], 
              "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}]}], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"ressmax", "[", 
                RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], 
               "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
              RowBox[{
               RowBox[{"ressmean", "[", 
                RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], 
               "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}]}], ")"}]]}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"i", "\[Rule]", "14"}], ",", 
            RowBox[{"under", "\[Rule]", "1"}], ",", 
            RowBox[{"th", "\[Rule]", "#"}]}], "}"}]}], "&"}], "/@", 
        RowBox[{"{", 
         RowBox[{"1", ",", "4", ",", "5"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"typ", ",", "3", ",", "4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
      "]"}], "]"}], ",", "1"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Quiet", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"3", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"ressmax", "[", 
             RowBox[{"typ", ",", "fr", ",", "1", ",", "under"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
           RowBox[{
            RowBox[{"ressmax", "[", 
             RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}]}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"ressmax", "[", 
              RowBox[{"typ", ",", "fr", ",", "1", ",", "under"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
            RowBox[{
             RowBox[{"ressmean", "[", 
              RowBox[{"typ", ",", "fr", ",", "1", ",", "under"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], ")"}]]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"i", "\[Rule]", "14"}], ",", 
          RowBox[{"under", "\[Rule]", "1"}], ",", 
          RowBox[{"th", "\[Rule]", "#"}]}], "}"}]}], "&"}], "/@", 
      RowBox[{"{", 
       RowBox[{"4", ",", "5"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"typ", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Quiet", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"3", 
          FractionBox[
           RowBox[{
            RowBox[{
             RowBox[{"res", "[", 
              RowBox[{"typ", ",", "fr", ",", "1", ",", "under"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
            RowBox[{
             RowBox[{"res", "[", 
              RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"ressmax", "[", 
               RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], 
              "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
             RowBox[{
              RowBox[{"ressmean", "[", 
               RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], 
              "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}]}], ")"}]]}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"i", "\[Rule]", "14"}], ",", 
           RowBox[{"under", "\[Rule]", "1"}], ",", 
           RowBox[{"th", "\[Rule]", "#"}]}], "}"}]}], "&"}], "/@", 
       RowBox[{"{", 
        RowBox[{"4", ",", "5"}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"typ", ",", "3", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}],
     "]"}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ddfun", "[", 
   RowBox[{"ll_", "?", "ListQ"}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"lis", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"ll", ",", 
       RowBox[{"{", 
        RowBox[{"ll", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "}"}]}], "]"}]}], ";", 
    RowBox[{"Differences", "[", "lis", "]"}]}], 
   ")"}]}], "\[IndentingNewLine]", 
 RowBox[{"Median", "[", 
  RowBox[{"Abs", "[", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"ddfun", "[", 
       RowBox[{"tres", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"Length", "[", "tres", "]"}]}], "}"}]}], "]"}], "]"}], "]"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.5810821347293406`*^9, 3.581082159424184*^9}, {
   3.5810821910318394`*^9, 3.581082222560495*^9}, {3.5810822605621614`*^9, 
   3.581082313259054*^9}, {3.5810823866113834`*^9, 3.5810823934129953`*^9}, {
   3.5810824306034603`*^9, 3.5810824425374813`*^9}, {3.581086181290553*^9, 
   3.581086240804658*^9}, {3.5810899141299515`*^9, 3.581089949963215*^9}, {
   3.5811740138032904`*^9, 3.581174137651908*^9}, {3.581174371231118*^9, 
   3.5811743746163244`*^9}, {3.581174498871543*^9, 3.581174695572288*^9}, {
   3.5811747340107555`*^9, 3.5811748416997447`*^9}, {3.581174882993017*^9, 
   3.581174946017128*^9}, {3.581174985937598*^9, 3.5811749884336023`*^9}, 
   3.581175094544989*^9}],

Cell[BoxData[
 RowBox[{"ListLogLogPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ressmean", "[", 
      RowBox[{"3", ",", "6", ",", "1", ",", "1"}], "]"}], ",", 
     RowBox[{"ressmean", "[", 
      RowBox[{"3", ",", "6", ",", "4", ",", "1"}], "]"}], ",", 
     RowBox[{"ressmean", "[", 
      RowBox[{"3", ",", "6", ",", "5", ",", "1"}], "]"}], ",", 
     RowBox[{"res", "[", 
      RowBox[{"3", ",", "6", ",", "1", ",", "1"}], "]"}], ",", 
     RowBox[{"res", "[", 
      RowBox[{"3", ",", "6", ",", "4", ",", "1"}], "]"}], ",", 
     RowBox[{"res", "[", 
      RowBox[{"3", ",", "6", ",", "5", ",", "1"}], "]"}], ",", 
     RowBox[{"ressmax", "[", 
      RowBox[{"3", ",", "6", ",", "1", ",", "1"}], "]"}], ",", 
     RowBox[{"ressmax", "[", 
      RowBox[{"3", ",", "6", ",", "4", ",", "1"}], "]"}], ",", 
     RowBox[{"ressmax", "[", 
      RowBox[{"3", ",", "6", ",", "5", ",", "1"}], "]"}]}], "}"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "Red", ",", "Red", ",", "Red", ",", "Black", ",", "Black", ",", "Black", 
      ",", "Blue", ",", "Blue", ",", "Blue"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5810866422482395`*^9, 3.581086736378804*^9}, {
  3.581086792337103*^9, 3.5810868358767796`*^9}}],

Cell[BoxData[{
 RowBox[{"Median", "[", "tabxx", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Median", "[", 
  RowBox[{"Abs", "[", "tabyy", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Histogram", "[", 
  RowBox[{
   RowBox[{"Abs", "[", "tabyy", "]"}], ",", "10", ",", "\"\<PDF\>\""}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.5810777707355614`*^9, 3.5810777764458885`*^9}, {
  3.5810779253094025`*^9, 3.5810779322998023`*^9}, {3.5810781128601303`*^9, 
  3.5810781568986487`*^9}}],

Cell[BoxData[
 RowBox[{"3", "\[Sigma]"}]], "Input",
 CellChangeTimes->{
  3.5810733847566977`*^9, {3.5810753423636665`*^9, 3.581075342960701*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", "\[Sigma]"}], " ", "-", " ", 
  RowBox[{
  "looks", " ", "very", " ", "similar", " ", "to", " ", "results", " ", "for",
    " ", "3", "\[Sigma]"}]}]], "Input",
 CellChangeTimes->{{3.5810753052825456`*^9, 3.5810753360793076`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mm", "=", "212"}], ";", 
  RowBox[{"dm", "=", "19"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Mean = \>\"", ",", 
   RowBox[{"timex", "[", 
    RowBox[{"[", "mm", "]"}], "]"}], ",", "\"\< = \>\"", ",", 
   RowBox[{
    RowBox[{"res", "[", 
     RowBox[{"3", ",", "9", ",", "1", ",", "1"}], "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"14", ",", "1"}], "]"}], "]"}], ",", 
   "\"\<; ratio of max to min = \>\"", ",", 
   FractionBox[
    RowBox[{"timex", "[", 
     RowBox[{"[", 
      RowBox[{"mm", "-", "dm"}], "]"}], "]"}], 
    RowBox[{"timex", "[", 
     RowBox[{"[", 
      RowBox[{"mm", "+", "dm"}], "]"}], "]"}]], ",", 
   "\"\<, while length = \>\"", ",", 
   RowBox[{"Length", "[", 
    RowBox[{"timex", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"mm", "-", "dm"}], ";;", 
       RowBox[{"mm", "+", "dm"}]}], "]"}], "]"}], "]"}], ",", 
   "\"\< length > 20 \[Implies] Papadakis (1993) method is applicable\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"timex", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"mm", "-", "dm"}], ";;", 
      RowBox[{"mm", "+", "dm"}]}], "]"}], "]"}], ",", 
   RowBox[{
    RowBox[{"Abs", "[", "sur", "]"}], "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"mm", "-", "dm"}], ";;", 
      RowBox[{"mm", "+", "dm"}]}], "]"}], "]"}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{"sur", "[", 
   RowBox[{"[", 
    RowBox[{
     RowBox[{"mm", "-", "dm"}], ";;", 
     RowBox[{"mm", "+", "dm"}]}], "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Histogram", "[", 
  RowBox[{
   RowBox[{"Log", "[", 
    RowBox[{"sur", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"mm", "-", "dm"}], ";;", 
       RowBox[{"mm", "+", "dm"}]}], "]"}], "]"}], "]"}], ",", "5", ",", 
   "\"\<PDF\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Histogram", "[", 
  RowBox[{
   RowBox[{"sur", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"mm", "-", "dm"}], ";;", 
      RowBox[{"mm", "+", "dm"}]}], "]"}], "]"}], ",", "5", ",", 
   "\"\<PDF\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.5810706055557365`*^9, 3.5810706483331833`*^9}, {
  3.581070845577465*^9, 3.581070891891114*^9}, {3.5810709564808083`*^9, 
  3.581071071114365*^9}, {3.5810712880737743`*^9, 3.581071365020176*^9}, {
  3.5810714093757124`*^9, 3.5810714229224873`*^9}, {3.5810716432280884`*^9, 
  3.5810717608258142`*^9}, {3.58107180812952*^9, 3.5810718377072115`*^9}, {
  3.58107204153187*^9, 3.581072069419465*^9}}],

Cell[BoxData[
 RowBox[{"ListLogLogPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ressmax", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], ",", 
      RowBox[{"ressmean", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], ",", 
      RowBox[{"ressmax", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "3"}], "]"}], ",", 
      RowBox[{"ressmean", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "3"}], "]"}], ",", 
      RowBox[{"res", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}]}], "}"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"typ", "\[Rule]", "3"}], ",", 
      RowBox[{"fr", "\[Rule]", "9"}], ",", 
      RowBox[{"th", "\[Rule]", "1"}]}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Red", ",", "Blue"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.581067817150249*^9, 3.5810678762606297`*^9}, {
  3.5810679976645737`*^9, 3.581068098378334*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"th", "=", "1"}], ";", 
  RowBox[{"under", "=", "1"}], ";", 
  RowBox[{"grgr", "=", 
   RowBox[{"GraphicsGrid", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"sh", "[", 
        RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], "=", 
       RowBox[{"Show", "[", 
        RowBox[{"{", 
         StyleBox[
          RowBox[{
           RowBox[{"PSDflux", "[", 
            RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], ",", 
           RowBox[{"PSDFmax", "[", 
            RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], ",", 
           RowBox[{"PSDFrandmean", "[", 
            RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}], ",", 
           RowBox[{"PSDfluxx", "[", 
            RowBox[{"typ", ",", "fr", ",", "th", ",", "1"}], "]"}]}],
          FontColor->RGBColor[0, 0, 1]], 
         StyleBox["}",
          FontColor->RGBColor[0, 0, 1]]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"typ", ",", "3", ",", "4"}], 
       RowBox[{"(*", "6", "*)"}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"th", "=."}], ";", 
  RowBox[{"under", "=."}], ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.568765709706128*^9, 3.5687657570961947`*^9}, {
   3.568766150610747*^9, 3.5687661926308055`*^9}, {3.5687676090213265`*^9, 
   3.5687676147465367`*^9}, {3.5687677042756658`*^9, 
   3.5687677075856705`*^9}, {3.568826535828356*^9, 3.568826536140356*^9}, {
   3.5689450632113714`*^9, 3.5689450639601727`*^9}, 3.5696928359807386`*^9, {
   3.56969305541879*^9, 3.569693097186931*^9}, {3.569760309670871*^9, 
   3.5697603130358753`*^9}, {3.569760404331003*^9, 3.5697604079010086`*^9}, {
   3.5697607003894196`*^9, 3.5697607614745045`*^9}, {3.5808340574682274`*^9, 
   3.580834113224306*^9}, {3.5808341633593764`*^9, 3.580834185615415*^9}, {
   3.5808342350804844`*^9, 3.5808342356504855`*^9}, {3.5810679088414936`*^9, 
   3.5810679496458273`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "1", ",", "3"}], "}"}]}], "}"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "3"}], ";", 
  RowBox[{"fr", "=", "6"}], ";", 
  RowBox[{"th", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"frfr", "=", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"sh", "[", 
       RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "=", 
      RowBox[{"Show", "[", 
       RowBox[{"{", 
        StyleBox[
         RowBox[{
          RowBox[{"PSDflux", "[", 
           RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], ",", 
          RowBox[{"PSDFmax", "[", 
           RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], ",", 
          RowBox[{"PSDFrandmean", "[", 
           RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], ",", 
          RowBox[{"PSDfluxx", "[", 
           RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}]}],
         FontColor->RGBColor[0, 0, 1]], 
        StyleBox["}",
         FontColor->RGBColor[0, 0, 1]]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"under", ",", "1", ",", "3"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"under", "=", "1"}], ";", 
  RowBox[{"thtab", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "4", ",", "5"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"hrhr", "=", 
  RowBox[{"GraphicsRow", "[", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"th", "=", 
       RowBox[{"thtab", "[", 
        RowBox[{"[", "thx", "]"}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"sh", "[", 
        RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], "=", 
       RowBox[{"Show", "[", 
        RowBox[{"{", 
         StyleBox[
          RowBox[{
           RowBox[{"PSDflux", "[", 
            RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], ",", 
           RowBox[{"PSDFmax", "[", 
            RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], ",", 
           RowBox[{"PSDFrandmean", "[", 
            RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}], ",", 
           RowBox[{"PSDfluxx", "[", 
            RowBox[{"typ", ",", "fr", ",", "th", ",", "under"}], "]"}]}],
          FontColor->RGBColor[0, 0, 1]], 
         StyleBox["}",
          FontColor->RGBColor[0, 0, 1]]}], "]"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"thx", ",", "1", ",", "3"}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=."}], ";", 
  RowBox[{"fr", "=."}], ";", 
  RowBox[{"th", "=."}], ";", 
  RowBox[{"under", "=."}], ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5808342292294765`*^9, 3.580834308598588*^9}, {
  3.5808343668266697`*^9, 3.5808343671266704`*^9}, {3.580842475043183*^9, 
  3.5808424941052094`*^9}, {3.58084253675027*^9, 3.580842588596342*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"TickFontSize", "\[Rule]", "mysize"}], ",", 
    RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
    RowBox[{"BufferL", "\[Rule]", "5"}], ",", 
    RowBox[{"XPanelSizes", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0.2"}], "}"}]}], ",", 
    RowBox[{"YPanelSizes", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}], ",", 
    RowBox[{"XGapSizes", "\[Rule]", 
     RowBox[{"{", "0.03", "}"}]}], ",", 
    RowBox[{"YGapSizes", "\[Rule]", 
     RowBox[{"{", "0", "}"}]}], ","}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"mysize", "=", "16"}], ";", "\[IndentingNewLine]", 
    RowBox[{"figv", "=", 
     RowBox[{"Figure", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"ScaledLabel", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0.55", ",", "0.95"}], "}"}], ",", "\"\<VHaha\>\"", ",", 
            RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
            RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
            RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
            RowBox[{"Offset", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ","}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Multipanel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4", ",", "3"}], "}"}], ",", 
           RowBox[{"XPlotRanges", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Log10", "[", "20", "]"}], ",", 
              RowBox[{"Log10", "[", "tmax", "]"}]}], "}"}]}], ",", 
           RowBox[{"YPlotRanges", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Log10", "[", 
                 SuperscriptBox["10", 
                  RowBox[{"-", "8"}]], "]"}], ",", 
                RowBox[{"Log10", "[", "3", "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Log10", "[", 
                 RowBox[{"5", "*", 
                  SuperscriptBox[
                   RowBox[{"10", " "}], 
                   RowBox[{"-", "6"}]]}], "]"}], ",", 
                RowBox[{"Log10", "[", "300", "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Log10", "[", 
                 RowBox[{"1", "*", 
                  SuperscriptBox[
                   RowBox[{"10", " "}], 
                   RowBox[{"-", "5"}]]}], "]"}], ",", 
                RowBox[{"Log10", "[", 
                 RowBox[{"3", "*", 
                  SuperscriptBox["10", "5"]}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Log10", "[", 
                 SuperscriptBox[
                  RowBox[{"10", " "}], 
                  RowBox[{"-", "10"}]], "]"}], ",", 
                RowBox[{"Log10", "[", 
                 SuperscriptBox["10", 
                  RowBox[{"-", "1"}]], "]"}]}], "}"}]}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
           RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
           RowBox[{"XFrameLabels", "\[Rule]", 
            RowBox[{"{", "\"\<Period T [M]\>\"", "}"}]}], ",", 
           RowBox[{"BufferL", "\[Rule]", "6"}], ",", 
           RowBox[{"YFrameLabels", "\[Rule]", "\"\<Periodogram   I(T)\>\""}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"YFrameTicks", "\[Rule]", 
            RowBox[{"LogTicks", "[", 
             RowBox[{
              RowBox[{"-", "10"}], ",", "10"}], "]"}]}], ",", 
           RowBox[{"XFrameTicks", "\[Rule]", 
            RowBox[{"LogTicks", "[", 
             RowBox[{
              RowBox[{"-", "10"}], ",", "10", ",", 
              RowBox[{"TickLabelStep", "\[Rule]", "1"}]}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Background", "\[Rule]", "White"}], ",", 
           RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
           RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"PanelLetterCorner", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
           RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
           RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
           RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"SetOptions", "[", 
          RowBox[{"DataSymbol", ",", 
           RowBox[{"SymbolSize", "\[Rule]", "0.001"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"SetOptions", "[", 
          RowBox[{"DataLine", ",", 
           RowBox[{"Thickness", "\[Rule]", "1.5"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"SetOptions", "[", 
          RowBox[{"DataValues", ",", 
           RowBox[{"AxisScaling", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Log", ",", "Log"}], "}"}]}]}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"FigurePanel", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"typ", "-", "2"}], ",", 
                 RowBox[{"fr", "/", "3"}]}], "}"}], ",", 
               RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"pan", "[", 
                RowBox[{"typ", ",", "fr"}], "]"}], "=", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"DataPlot", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"shift", "[", "th", "]"}], 
                    RowBox[{"res", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Color", "\[Rule]", "Black"}], "}"}]}]}], "]"}], 
                   ",", 
                   RowBox[{"DataPlot", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"shift", "[", "th", "]"}], 
                    RowBox[{"ressmean", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Color", "\[Rule]", "Black"}], ",", 
                    RowBox[{"Dashing", "\[Rule]", "7"}]}], "}"}]}]}], "]"}], 
                   ",", 
                   RowBox[{"DataPlot", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"shift", "[", "th", "]"}], 
                    RowBox[{"ressmax", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Color", "\[Rule]", "Red"}], "}"}]}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"DataPlot", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"shix", "[", "th", "]"}], 
                    RowBox[{"resx", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Color", "\[Rule]", "Green"}], ",", 
                    RowBox[{"Dashing", "\[Rule]", "5"}]}], "}"}]}]}], "]"}]}],
                   "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"th", ",", "3"}], "}"}]}], "]"}]}], ";", 
              RowBox[{
               RowBox[{"lab", "[", 
                RowBox[{"typ", ",", "fr"}], "]"}], "=", 
               RowBox[{
                RowBox[{"fllab", "[", "typ", "]"}], "<>", 
                RowBox[{"frlab", "[", "fr", "]"}]}]}], ";", 
              RowBox[{
               RowBox[{"sclab", "[", 
                RowBox[{"typ", ",", "fr"}], "]"}], "=", 
               RowBox[{"ScaledLabel", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0.18", ",", "0.89"}], "}"}], ",", 
                 RowBox[{"lab", "[", 
                  RowBox[{"typ", ",", "fr"}], "]"}], ",", 
                 RowBox[{"Color", "\[Rule]", "Black"}], ",", 
                 RowBox[{"Background", "\[Rule]", "White"}], ",", 
                 RowBox[{"FontSize", "\[Rule]", 
                  RowBox[{"mysize", "-", "1"}]}], ",", 
                 RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}]}], ";", 
              RowBox[{"pan", "[", 
               RowBox[{"typ", ",", "fr"}], "]"}]}], ",", 
             RowBox[{"sclab", "[", 
              RowBox[{"typ", ",", "fr"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"typ", ",", "3", ",", "6"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
          "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.07"}], ",", "1.01"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.05"}], ",", "1.01"}], "}"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1300", ",", "1000"}], "}"}]}]}], "]"}]}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"mysize", "=", "16"}], ";", "\[IndentingNewLine]", 
    RowBox[{"figvx", "=", 
     RowBox[{"Figure", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ScaledLabel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0.21", ",", "0.76"}], "}"}], ",", 
           "\"\<Top - face-on\>\"", ",", 
           RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
           RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
           RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
           RowBox[{"Offset", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ScaledLabel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0.21", ",", "0.74"}], "}"}], ",", 
           "\"\<Middle - general inclination\>\"", ",", 
           RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
           RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
           RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
           RowBox[{"Offset", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ScaledLabel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0.21", ",", "0.72"}], "}"}], ",", 
           "\"\<Bottom - edge-on\>\"", ",", 
           RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
           RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
           RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
           RowBox[{"Offset", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Multipanel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "3"}], "}"}], ",", 
           RowBox[{"XPlotRanges", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Log10", "[", "20", "]"}], ",", 
              RowBox[{"Log10", "[", "tmax", "]"}]}], "}"}]}], ",", 
           RowBox[{"YPlotRanges", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Log10", "[", 
                 SuperscriptBox["10", 
                  RowBox[{"-", "8"}]], "]"}], ",", 
                RowBox[{"Log10", "[", "3", "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Log10", "[", 
                 RowBox[{"5", "*", 
                  SuperscriptBox[
                   RowBox[{"10", " "}], 
                   RowBox[{"-", "6"}]]}], "]"}], ",", 
                RowBox[{"Log10", "[", "300", "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Log10", "[", 
                 RowBox[{"1", "*", 
                  SuperscriptBox[
                   RowBox[{"10", " "}], 
                   RowBox[{"-", "5"}]]}], "]"}], ",", 
                RowBox[{"Log10", "[", 
                 RowBox[{"3", "*", 
                  SuperscriptBox["10", "5"]}], "]"}]}], "}"}]}], "}"}]}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
           RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
           RowBox[{"XFrameLabels", "\[Rule]", 
            RowBox[{"{", "\"\<Period T [M]\>\"", "}"}]}], ",", 
           RowBox[{"BufferL", "\[Rule]", "6"}], ",", 
           RowBox[{"YFrameLabels", "\[Rule]", "\"\<Periodogram   I(T)\>\""}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"YFrameTicks", "\[Rule]", 
            RowBox[{"LogTicks", "[", 
             RowBox[{
              RowBox[{"-", "10"}], ",", "10"}], "]"}]}], ",", 
           RowBox[{"XFrameTicks", "\[Rule]", 
            RowBox[{"LogTicks", "[", 
             RowBox[{
              RowBox[{"-", "10"}], ",", "10", ",", 
              RowBox[{"TickLabelStep", "\[Rule]", "1"}]}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Background", "\[Rule]", "White"}], ",", 
           RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
           RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"PanelLetterCorner", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
           RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
           RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
           RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"SetOptions", "[", 
          RowBox[{"DataSymbol", ",", 
           RowBox[{"SymbolSize", "\[Rule]", "0.001"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"SetOptions", "[", 
          RowBox[{"DataLine", ",", 
           RowBox[{"Thickness", "\[Rule]", "1.5"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"SetOptions", "[", 
          RowBox[{"DataValues", ",", 
           RowBox[{"AxisScaling", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Log", ",", "Log"}], "}"}]}]}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"FigurePanel", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"typ", "-", "2"}], ",", 
                 RowBox[{"fr", "/", "3"}]}], "}"}], ",", 
               RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"pan", "[", 
                RowBox[{"typ", ",", "fr"}], "]"}], "=", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"DataPlot", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"shift", "[", "th", "]"}], 
                    RowBox[{"res", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Color", "\[Rule]", "Black"}], "}"}]}]}], "]"}], 
                   ",", 
                   RowBox[{"DataPlot", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"shift", "[", "th", "]"}], 
                    RowBox[{"ressmean", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Color", "\[Rule]", "Black"}], ",", 
                    RowBox[{"Dashing", "\[Rule]", "7"}]}], "}"}]}]}], "]"}], 
                   ",", 
                   RowBox[{"DataPlot", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"shift", "[", "th", "]"}], 
                    RowBox[{"ressmax", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Color", "\[Rule]", "Red"}], "}"}]}]}], "]"}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"DataPlot", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"shix", "[", "th", "]"}], 
                    RowBox[{"resx", "[", 
                    RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
                    RowBox[{"DataLine", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Color", "\[Rule]", "Green"}], ",", 
                    RowBox[{"Dashing", "\[Rule]", "5"}]}], "}"}]}]}], "]"}]}],
                   "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"th", ",", "3"}], "}"}]}], "]"}]}], ";", 
              RowBox[{
               RowBox[{"lab", "[", 
                RowBox[{"typ", ",", "fr"}], "]"}], "=", 
               RowBox[{
                RowBox[{"fllab", "[", "typ", "]"}], "<>", 
                RowBox[{"frlab", "[", "fr", "]"}]}]}], ";", 
              RowBox[{
               RowBox[{"sclab", "[", 
                RowBox[{"typ", ",", "fr"}], "]"}], "=", 
               RowBox[{"ScaledLabel", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0.18", ",", "0.89"}], "}"}], ",", 
                 RowBox[{"lab", "[", 
                  RowBox[{"typ", ",", "fr"}], "]"}], ",", 
                 RowBox[{"Color", "\[Rule]", "Black"}], ",", 
                 RowBox[{"Background", "\[Rule]", "White"}], ",", 
                 RowBox[{"FontSize", "\[Rule]", 
                  RowBox[{"mysize", "-", "1"}]}], ",", 
                 RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}]}], ";", 
              RowBox[{"pan", "[", 
               RowBox[{"typ", ",", "fr"}], "]"}]}], ",", 
             RowBox[{"sclab", "[", 
              RowBox[{"typ", ",", "fr"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"typ", ",", "3", ",", "5"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
          "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.07"}], ",", "1.01"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.07"}], ",", "1.01"}], "}"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1300", ",", "800"}], "}"}]}]}], "]"}]}]}], 
   "*)"}]}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Figure spectrogram.eps",
 FontColor->RGBColor[0, 0, 1]]], "Subsection",
 CellChangeTimes->{{3.5696893910431385`*^9, 3.569689408826412*^9}, {
  3.5697769401494074`*^9, 3.56977694206441*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";", 
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dix", "[", "1", "]"}], "=", 
   "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\th248lo\\\\\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"impx", "[", "1", "]"}], "=", 
   RowBox[{"Get", "[", 
    RowBox[{
     RowBox[{"dix", "[", "1", "]"}], "<>", "\"\<totspec.dat\>\""}], "]"}]}], 
  ";", 
  RowBox[{"nums", "=", 
   RowBox[{"4", 
    RowBox[{
     RowBox[{"impx", "[", "1", "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"freqs", "=", 
   RowBox[{
    RowBox[{"impx", "[", "1", "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "All", ",", "2"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", 
  RowBox[{"impx", "[", "1", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.569690907836939*^9, 3.569690966090334*^9}, {
  3.569774735695792*^9, 3.5697747442758074`*^9}, {3.569778545552888*^9, 
  3.5697785588753114`*^9}, {3.5699451566685853`*^9, 3.5699451751546183`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"3", ",", "fr", ",", "th"}], "]"}], "=", 
      RowBox[{"Mean", "[", 
       RowBox[{
        RowBox[{"impx", "[", "th", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"4", ",", "fr", ",", "th"}], "]"}], "=", 
      RowBox[{"means", "[", 
       RowBox[{"3", ",", "fr", ",", "th"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"5", ",", "fr", ",", "th"}], "]"}], "=", 
      RowBox[{"means", "[", 
       RowBox[{"3", ",", "fr", ",", "th"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"means", "[", 
       RowBox[{"6", ",", "fr", ",", "th"}], "]"}], "=", "90"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"th", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tmax", "=", 
    SuperscriptBox["10", "3.2"]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Papadakis", " ", "&"}], " ", "Lawrence", " ", 
    RowBox[{"(", "1993", ")"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"autovar", "[", 
    RowBox[{"typ_", ",", "mu_", ",", "fr_", ",", "xmin_", ",", "xmax_"}], 
    "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"mult", "=", "mu"}], ";", 
      RowBox[{"binned", "=", 
       RowBox[{
        RowBox[{"impx", "[", "1", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"xmin", ";;", "xmax"}], ",", "fr", ",", "typ"}], "]"}], 
        "]"}]}], ";", 
      RowBox[{"binned", "/=", 
       RowBox[{"Mean", "[", "binned", "]"}]}], ";", 
      RowBox[{"ll", "=", 
       RowBox[{"Length", "[", "binned", "]"}]}], ";", 
      RowBox[{"me", "=", 
       RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"autovariance", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{"1", ";;", 
                RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], 
            ")"}], ".", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
             "me"}], ")"}]}], "ll"], ",", 
         RowBox[{"{", 
          RowBox[{"shi", ",", "0", ",", 
           RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"f11", "=", 
       RowBox[{"FourierDCT", "[", 
        RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
      RowBox[{"num", "=", 
       RowBox[{"Floor", "[", 
        FractionBox["ll", "2"], "]"}]}], ";", 
      RowBox[{"sur", "=", 
       RowBox[{
        FractionBox[
         SqrtBox["2"], 
         RowBox[{"2", "\[Pi]"}]], 
        SqrtBox["ll"], 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"f11", ",", "2"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"sur", ",", 
        RowBox[{"sur", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"timex", "=", 
       RowBox[{"4.", 
        RowBox[{"ll", "/", 
         RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
      RowBox[{"mint", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
      RowBox[{"maxt", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", 
      RowBox[{"nn", "=", 
       RowBox[{
        RowBox[{"Log", "[", 
         FractionBox["maxt", "mint"], "]"}], "/", 
        RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"tsides", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"mint", " ", 
          SuperscriptBox["mult", "i"]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tbins", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tsides", "[", 
            RowBox[{"[", "i", "]"}], "]"}], ",", 
           RowBox[{"tsides", "[", 
            RowBox[{"[", 
             RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tsizes", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tmeans", "=", 
       RowBox[{"Mean", "[", 
        RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"intergra", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"timex", ",", 
             RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"pergra", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"Exp", "[", 
              RowBox[{"intergra", "[", 
               RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"tx", ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
             RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
             RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        RowBox[{"res", "=", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"tmeans", ",", 
              FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
          "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"pergra", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{"NIntegrate", "[", 
           RowBox[{
            RowBox[{"intergra", "[", 
             RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"tx", ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
            RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
            RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
          RowBox[{"tsizes", "[", 
           RowBox[{"[", "i", "]"}], "]"}]], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"res", "[", 
        RowBox[{"typ", ",", "fr"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"tmeans", ",", 
          RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"hl", "=", 
       RowBox[{"Length", "[", "tmeans", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"tofit", "=", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"A", " ", 
           RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
        RowBox[{"FindFit", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"res", "[", 
            RowBox[{"typ", ",", "fr"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"adj", "=", 
       RowBox[{"tofit", "/.", 
        RowBox[{"x", "\[Rule]", "tmeans"}]}]}], ";", 
      RowBox[{
       RowBox[{"res", "[", 
        RowBox[{"typ", ",", "fr"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"tmeans", ",", 
          RowBox[{
           RowBox[{"Exp", "[", "pergra", "]"}], "/", "adj"}]}], "}"}], 
        "]"}]}]}], ")"}], "//", "Quiet"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5696898764220953`*^9, 3.569689887354763*^9}, {
   3.56972286613972*^9, 3.5697228844700017`*^9}, {3.569760446396062*^9, 
   3.5697604472910633`*^9}, {3.5697633264843206`*^9, 3.569763427478898*^9}, 
   3.569778531715664*^9, {3.5697785770961437`*^9, 3.569778663083494*^9}, {
   3.5697808908090076`*^9, 3.56978092631467*^9}, {3.5697821865364447`*^9, 
   3.5697823222566833`*^9}, {3.569782418945653*^9, 3.569782420661656*^9}, 
   3.569782805920933*^9}],

Cell[BoxData[{
 RowBox[{"Dynamic", "[", "o", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dx", "=", "150"}], ";", 
  RowBox[{"nnn", "=", 
   RowBox[{"Floor", "[", 
    FractionBox["5000", "dx"], "]"}]}], ";", 
  RowBox[{"{", 
   RowBox[{
    FractionBox["5000", "8"], ",", 
    RowBox[{"4", "dx"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabfin", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"autovar", "[", 
      RowBox[{"3", ",", "1.2", ",", "6", ",", 
       RowBox[{
        RowBox[{"dx", " ", "o"}], "+", "1"}], ",", 
       RowBox[{"dx", 
        RowBox[{"(", 
         RowBox[{"o", "+", "1"}], ")"}]}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"o", ",", "0", ",", 
       RowBox[{"nnn", "-", "1"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Dimensions", "[", "tabfin", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5697787096027765`*^9, 3.569778748446844*^9}, 
   3.569778841017407*^9, {3.569778957190811*^9, 3.5697790292473373`*^9}, {
   3.5697790776386223`*^9, 3.569779102832667*^9}, {3.5697791977754335`*^9, 
   3.5697792088514533`*^9}, {3.5697792778659744`*^9, 3.569779289019994*^9}, {
   3.5697793284568634`*^9, 3.5697793285348635`*^9}, {3.569780415070572*^9, 
   3.5697804228861856`*^9}, 3.5697807459003534`*^9, {3.5697812312484055`*^9, 
   3.569781231373206*^9}, {3.569781360198232*^9, 3.569781407871916*^9}, {
   3.5697814924708643`*^9, 3.569781492751665*^9}, {3.569781547429761*^9, 
   3.5697815669453955`*^9}, {3.569782309573861*^9, 3.569782313629868*^9}, {
   3.56978236007115*^9, 3.56978236060155*^9}, {3.5697825127642174`*^9, 
   3.5697825970199656`*^9}, {3.569782752599039*^9, 3.56978275317624*^9}, {
   3.569782809664939*^9, 3.5697828097273393`*^9}, {3.5697828536726165`*^9, 
   3.5697828537194166`*^9}, {3.5697830765190077`*^9, 3.5697830785158114`*^9}, 
   3.56978353306941*^9, 3.5697985518974824`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"90", " ", 
         FractionBox[
          RowBox[{"G", " ", "M"}], 
          SuperscriptBox["cc", "3"]]}], ")"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"G", "\[Rule]", 
         RowBox[{"6.67", " ", 
          SuperscriptBox["10", 
           RowBox[{"-", "8"}]]}]}], ",", 
        RowBox[{"M", "\[Rule]", 
         RowBox[{"10", "Msun"}]}]}], "}"}]}], "/.", "ruru"}], ",", 
    "\"\<Hz\>\""}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"H", " ", "1743"}], "-", 
    RowBox[{
    "322", " ", "has", " ", "10", "Msun", " ", "BH", " ", "and", " ", 
     "oscillations", " ", "at", " ", "165", "Hz", " ", "and", " ", "241", 
     "Hz"}]}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.5699525789815283`*^9, 3.5699526814052954`*^9}, {
  3.5699527499674163`*^9, 3.5699527806370697`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kmax", "=", "12"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"autovar", "[", 
      RowBox[{"5", ",", "1.05", ",", "k", ",", "4000", ",", "4500"}], "]"}], 
     ";", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"tmeans", ",", 
        RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.569950741788128*^9, 3.5699507570605555`*^9}, {
  3.56995079977343*^9, 3.569950863920743*^9}, {3.5699510027765865`*^9, 
  3.569951112148379*^9}, {3.569951161366465*^9, 3.5699515278891087`*^9}, {
  3.569951603736442*^9, 3.5699516038768425`*^9}, {3.5699516357320986`*^9, 
  3.5699516498033233`*^9}, {3.5699535323175907`*^9, 3.5699535532996273`*^9}, {
  3.56995358886769*^9, 3.5699537222323246`*^9}, {3.5699537678880053`*^9, 
  3.56995379356565*^9}, {3.5699538332989197`*^9, 3.5699538527521544`*^9}, {
  3.5699538987874346`*^9, 3.569953919769471*^9}, {3.569953957599538*^9, 
  3.569953981155579*^9}, {3.569954016930441*^9, 3.5699540821385555`*^9}, {
  3.5699541532122803`*^9, 3.569954237327628*^9}, {3.569954696765396*^9, 
  3.569954954041048*^9}, {3.5699550105755477`*^9, 3.5699550131495523`*^9}}],

Cell[BoxData["CP"], "Input",
 CellChangeTimes->{{3.56995496085826*^9, 3.5699549728858814`*^9}}],

Cell[BoxData["EVPA"], "Input",
 CellChangeTimes->{{3.5699549513578434`*^9, 3.5699549697502756`*^9}}],

Cell[BoxData["LP"], "Input",
 CellChangeTimes->{{3.5699549293462048`*^9, 3.5699549305630074`*^9}}],

Cell[BoxData["F"], "Input",
 CellChangeTimes->{3.5699549151813803`*^9}],

Cell[BoxData[
 RowBox[{"CP", ",", "1.1", ",", "12", ",", 
  RowBox[{"4000", "-", "4500"}]}]], "Input",
 CellChangeTimes->{{3.569954554290346*^9, 3.569954565491166*^9}}],

Cell[BoxData[
 RowBox[{"CP", ",", "1.1", ",", "7", ",", 
  RowBox[{"4000", "-", "4500"}]}]], "Input",
 CellChangeTimes->{{3.569954209263179*^9, 3.56995421550319*^9}}],

Cell[BoxData[
 RowBox[{"EVPA", ",", "1.05", ",", "11", ",", 
  RowBox[{"4000", "-", "4500"}]}]], "Input",
 CellChangeTimes->{{3.5699541358650503`*^9, 3.569954149967475*^9}}],

Cell[BoxData[
 RowBox[{"LP", ",", "1.2", ",", "6", ",", 
  RowBox[{"4000", "-", "4500"}]}]], "Input",
 CellChangeTimes->{{3.569953988565592*^9, 3.569953994727603*^9}}],

Cell[BoxData[
 RowBox[{"LP", ",", "1.1", ",", "2", ",", 
  RowBox[{"4000", "-", "4500"}]}]], "Input",
 CellChangeTimes->{{3.569953925323081*^9, 3.5699539547135324`*^9}}],

Cell[BoxData[
 RowBox[{"F", ",", "1.05", ",", "12", ",", 
  RowBox[{"4000", "-", "4500", " ", "-", " ", 
   RowBox[{"high", " ", "frequency", " ", 
    RowBox[{"dominates", "!"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5699538059676723`*^9, 3.5699538207564983`*^9}, {
  3.56995394753752*^9, 3.56995394774032*^9}}],

Cell[BoxData[
 RowBox[{"EVPA", ",", "1.05", ",", "12", ",", 
  RowBox[{"4000", "-", "4500"}]}]], "Input",
 CellChangeTimes->{{3.5699536463693914`*^9, 3.5699536547154055`*^9}}],

Cell[BoxData[
 RowBox[{"F", ",", "1.02", ",", "11", ",", 
  RowBox[{"4500", "-", "5000"}]}]], "Input",
 CellChangeTimes->{{3.5699516266528826`*^9, 3.5699516319100914`*^9}}],

Cell[BoxData[
 RowBox[{"F", ",", "1.1", ",", "11", ",", 
  RowBox[{"4500", "-", "5000"}]}]], "Input",
 CellChangeTimes->{{3.569951443633361*^9, 3.5699514484381695`*^9}}],

Cell[BoxData[
 RowBox[{"LP", ",", "1.1", ",", "11", ",", 
  RowBox[{"4500", "-", "5000"}]}]], "Input",
 CellChangeTimes->{{3.5699514264889307`*^9, 3.569951431278139*^9}}],

Cell[BoxData[
 RowBox[{"LP", ",", "1.1", ",", "10", ",", 
  RowBox[{"4000", "-", "5000"}]}]], "Input",
 CellChangeTimes->{{3.569951264326646*^9, 3.569951268757054*^9}}],

Cell[BoxData[
 RowBox[{"LP", ",", "1.1", ",", "9", ",", 
  RowBox[{"1", "-", "5000"}]}]], "Input",
 CellChangeTimes->{{3.56995120384534*^9, 3.569951209008949*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{3.5735677294006214`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mysize", "=", "18"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dxtab", "=", 
   RowBox[{"8000", "+", 
    RowBox[{"4", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"dx", 
        RowBox[{"(", 
         RowBox[{"o", "+", 
          FractionBox["1", "2"]}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"o", ",", "0", ",", 
         RowBox[{"nnn", "-", "1"}]}], "}"}]}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rat", "=", "6"}], ";", 
  RowBox[{"datt", "=", 
   FractionBox[
    RowBox[{"Transpose", "[", 
     RowBox[{"tabfin", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}], "]"}], "rat"]}], 
  ";", 
  RowBox[{"Dimensions", "[", "datt", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"lper", "=", 
     RowBox[{"Length", "[", "tmeans", "]"}]}], ",", 
    RowBox[{"ltime", "=", 
     RowBox[{"Length", "[", "dxtab", "]"}]}]}], "}"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dapl", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"dxtab", "[", 
          RowBox[{"[", "kk", "]"}], "]"}], ",", 
         RowBox[{"Log10", "[", 
          RowBox[{"tmeans", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], "]"}], ",", 
         RowBox[{"datt", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "kk"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ii", ",", "lper"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"kk", ",", "ltime"}], "}"}]}], "]"}], ",", "1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"topl", "=", 
  RowBox[{"ListDensityPlot", "[", 
   RowBox[{"dapl", ",", 
    RowBox[{"InterpolationOrder", "\[Rule]", "0"}], ",", 
    RowBox[{"ColorFunction", "\[Rule]", 
     RowBox[{"(*", 
      RowBox[{"\"\<TemperatureMap\>\"", ","}], "*)"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"RGBColor", "[", 
        RowBox[{"#1", " ", ",", 
         RowBox[{"2", "#1"}], " ", ",", "#1"}], " ", "]"}], "&"}], ")"}]}], 
    ",", 
    RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
    RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"16", ",", "\"\<Times\>\"", ",", "Bold"}], "}"}]}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", "10.", "]"}], ",", "\"\<10\>\""}], "}"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", "20.", "]"}], ",", "20"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", "50", "]"}], ",", "50"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", "100", "]"}], ",", "100"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", "100", "]"}], ",", "100"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", "200", "]"}], ",", "200"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", "500", "]"}], ",", "500"}], "}"}]}], "}"}],
          ",", "None"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "None"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<Time t [M]\>\"", ",", "\"\<Period T [M]\>\""}], "}"}]}], 
    ",", 
    RowBox[{"PlotLegends", "\[Rule]", 
     RowBox[{"BarLegend", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"RGBColor", "[", " ", 
            RowBox[{
             FractionBox[
              RowBox[{"#1", " "}], "rat"], ",", 
             RowBox[{"2", 
              FractionBox["#1", "rat"]}], " ", ",", 
             FractionBox["#1", "rat"]}], " ", "]"}], "&"}], ")"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "rat"}], "}"}]}], "}"}], ",", 
       RowBox[{"LabelStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"mysize", ",", "Bold"}], "}"}]}], ",", 
       RowBox[{"LegendMarkerSize", "\[Rule]", "450"}]}], "]"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mdotpl", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"Log10", "[", 
         RowBox[{
          RowBox[{"impx", "[", "1", "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "1", ",", 
            RowBox[{"-", "2"}]}], "]"}], "]"}], "]"}]}], "}"}], "]"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"16", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.569797582685096*^9, 3.5697977410725284`*^9}, {
  3.5697977936858363`*^9, 3.569797798783415*^9}, {3.5697978289163775`*^9, 
  3.569797939278073*^9}, {3.5697985264345913`*^9, 3.5697985310596623`*^9}, {
  3.569799072358977*^9, 3.5697990963418455`*^9}, {3.5697991333124127`*^9, 
  3.5697992240988073`*^9}, {3.5697993463606853`*^9, 3.5697994274494305`*^9}, {
  3.56979963966269*^9, 3.569799667373116*^9}, {3.5697997116862965`*^9, 
  3.5697997572144957`*^9}, {3.569799871238747*^9, 3.5697998714387503`*^9}, {
  3.5697999146194134`*^9, 3.5698003179991093`*^9}, {3.573567127586125*^9, 
  3.5735671289873962`*^9}, {3.5735674363411193`*^9, 3.573567476575738*^9}, {
  3.5735677357807198`*^9, 3.57356774164556*^9}, {3.573569793187828*^9, 
  3.573569795160359*^9}, {3.573570405115486*^9, 3.573570410055562*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mysize", "=", "18"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"figv", "=", 
  RowBox[{"Figure", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Multipanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], ",", 
        RowBox[{"XPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"0.95", 
             RowBox[{"dapl", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ",", 
            RowBox[{"1.01", 
             RowBox[{"dapl", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}]}], "}"}], 
          "}"}]}], ",", 
        RowBox[{"YPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log10", "[", 
              RowBox[{"4", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "9"}]]}], "]"}], ",", 
             RowBox[{"Log10", "[", 
              RowBox[{"5", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "8"}]]}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"0.95", 
              RowBox[{"Log10", "[", 
               RowBox[{"tmeans", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ",", 
             RowBox[{"Log10", "[", 
              RowBox[{"1.05", 
               RowBox[{"tmeans", "[", 
                RowBox[{"[", 
                 RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}]}], "}"}]}], 
          "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"XFrameLabels", "\[Rule]", 
         RowBox[{"{", "\"\<t [M]\>\"", "}"}]}], ",", 
        RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
        RowBox[{"YFrameLabels", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<\!\(\*OverscriptBox[\(M\), \(.\)]\) [\!\(\*SubscriptBox[\(M\), \
\(Sun\)]\)\!\(\*SuperscriptBox[\(yr\), \(-1\)]\)]\>\"", ",", 
           "\"\<Period T[M]\>\""}], "}"}]}], ",", 
        RowBox[{"BufferL", "\[Rule]", "8"}], ",", 
        RowBox[{"TickFontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"XFrameTicks", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"LinTicks", "[", 
              RowBox[{"0", ",", "20", ",", "5", ",", "5"}], "]"}], ",", 
             "None"}], "}"}]}], ",", 
          RowBox[{"YFrameTicks", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"LinTicks", "[", 
                RowBox[{
                 RowBox[{"-", "6"}], ",", "6", ",", "3", ",", "2"}], "]"}], 
               ",", "None"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"LinTicks", "[", 
                RowBox[{
                 RowBox[{"-", "6"}], ",", "6", ",", "3", ",", "2"}], "]"}], 
               ",", "None"}], "}"}]}], "}"}]}], ",", 
          RowBox[{"XPanelSizes", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0.2"}], "}"}]}], ",", 
          RowBox[{"YPanelSizes", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}]}], ",", 
          RowBox[{"XGapSizes", "\[Rule]", 
           RowBox[{"{", "0.03", "}"}]}], ",", 
          RowBox[{"YGapSizes", "\[Rule]", 
           RowBox[{"{", "0", "}"}]}], ","}], "*)"}], 
        RowBox[{"YPanelSizes", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"160", ",", "400"}], "}"}]}], ",", 
        RowBox[{"XFrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"10000", ",", "10000"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"15000", ",", "15000"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"20000", ",", "20000"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"25000", ",", "25000"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"YFrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Log10", "[", 
                RowBox[{"5", " ", 
                 SuperscriptBox["10", 
                  RowBox[{"-", "9."}]]}], "]"}], ",", 
               "\"\<5\[Times]\!\(\*SuperscriptBox[\(10\), \(-9\)]\)\>\""}], 
              "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Log10", "[", 
                SuperscriptBox["10", 
                 RowBox[{"-", "8."}]], "]"}], ",", 
               "\"\<\!\(\*SuperscriptBox[\(10\), \(-8\)]\)\>\""}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Log10", "[", 
                RowBox[{"2", " ", 
                 SuperscriptBox["10", 
                  RowBox[{"-", "8."}]]}], "]"}], ",", 
               "\"\<2\[Times]\!\(\*SuperscriptBox[\(10\), \(-8\)]\)\>\""}], 
              "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Log10", "[", 
                RowBox[{"4", " ", 
                 SuperscriptBox["10", 
                  RowBox[{"-", "8."}]]}], "]"}], ",", 
               "\"\<4\[Times]\!\(\*SuperscriptBox[\(10\), \(-8\)]\)\>\""}], 
              "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Log10", "[", "10.", "]"}], ",", "10"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Log10", "[", "20.", "]"}], ",", "20"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Log10", "[", "50", "]"}], ",", "50"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Log10", "[", "100", "]"}], ",", "100"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Log10", "[", "100", "]"}], ",", "100"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Log10", "[", "200", "]"}], ",", "200"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Log10", "[", "500", "]"}], ",", "500"}], "}"}]}], 
            "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"Background", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PanelLetterCorner", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
        RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"TickNudge", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "5"}], ",", "0"}], "}"}], ",", "0", ",", "0"}], 
            "}"}]}], ","}], "*)"}], 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"Mdotpl", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], 
      RowBox[{"(*", 
       RowBox[{"DataPlot", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"nums", ",", 
            RowBox[{
             RowBox[{"impx", "[", "1", "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "1", ",", 
               RowBox[{"-", "2"}]}], "]"}], "]"}]}], "}"}], "]"}], ",", 
         RowBox[{"DataLine", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Color", "\[Rule]", "Black"}], "}"}]}]}], "]"}], "*)"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{
        RowBox[{"topl", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.18"}], ",", "1.12"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.08"}], ",", "1.02"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"600", ",", "700"}], "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Export", "[", 
    RowBox[{
    "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD QPOs\\\\!svn\
\\\\figures\\\\QPOcurve.eps\>\"", ",", "figv"}], "]"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5735672631632075`*^9, 3.573567263216958*^9}, {
   3.5735672997917705`*^9, 3.5735673947037296`*^9}, {3.5735675189441385`*^9, 
   3.5735675477840815`*^9}, {3.5735676074162474`*^9, 3.573567696887122*^9}, {
   3.5735677948878775`*^9, 3.5735678099716096`*^9}, {3.5735680981142864`*^9, 
   3.5735681037378726`*^9}, 3.5735687984995475`*^9, {3.5735688385219126`*^9, 
   3.57356886639659*^9}, {3.573568939385462*^9, 3.5735689889577236`*^9}, {
   3.573569046546608*^9, 3.573569064125128*^9}, {3.5735691088600655`*^9, 
   3.573569277953663*^9}, {3.573569326840664*^9, 3.573569333994524*^9}, {
   3.573569385418064*^9, 3.5735694167640457`*^9}, {3.5735694512965765`*^9, 
   3.5735694968355255`*^9}, {3.573569574921975*^9, 3.573569651779406*^9}, {
   3.573569692476781*^9, 3.573569733784166*^9}, {3.5735697836814327`*^9, 
   3.5735697983279076`*^9}, {3.5735698754638453`*^9, 
   3.5735699353260155`*^9}, {3.5735703752902784`*^9, 3.573570375444031*^9}, {
   3.573570428982853*^9, 3.5735704817466636`*^9}, {3.573570668528534*^9, 
   3.5735706686297855`*^9}}],

Cell[BoxData[
 RowBox[{"sufig", "=", 
  RowBox[{"Show", "[", 
   RowBox[{"figv", ",", 
    RowBox[{"Epilog", "\[Rule]", 
     RowBox[{"Inset", "[", 
      RowBox[{
       RowBox[{"topl", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "1", ",", "1"}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"1.06", ",", "0.33"}], "}"}]}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.573568115420302*^9, 3.5735681312977962`*^9}, {
  3.5735682242824745`*^9, 3.5735683352081785`*^9}, {3.573569827182602*^9, 
  3.573569828046365*^9}, {3.5735699561583357`*^9, 3.573569963349696*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD QPOs\\\\!svn\\\
\\figures\\\\spectrogram.eps\>\"", ",", "sufig", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", " ", 
   RowBox[{"ImageResolution", "\[Rule]", "500"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5735698222790265`*^9, 3.5735698334739485`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Formula for observation time",
 FontColor->RGBColor[0, 0, 1]]], "Subsection",
 CellChangeTimes->{{3.5735769594479494`*^9, 3.5735769806277747`*^9}}],

Cell[BoxData[{
 RowBox[{"Noise", " ", 
  RowBox[{"level", ":", " ", 
   RowBox[{"Pnoise", " ", "/", " ", 
    SqrtBox[
     RowBox[{
     "\[CapitalDelta]\[Nu]", " ", "\[Tau]"}]]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Observed", " ", 
   RowBox[{"level", ":", " ", 
    RowBox[{
     SubscriptBox["F", "\[Nu]"], "\[CapitalDelta]\[Nu]", " ", "A"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Over", " ", "a", " ", "single", " ", 
   RowBox[{"observation", ":", " ", 
    SubscriptBox["N", "ph"]}]}], "=", 
  FractionBox[
   RowBox[{
    SubscriptBox["F", "\[Nu]"], "\[CapitalDelta]\[Nu]", " ", "A", " ", 
    "\[Tau]"}], 
   RowBox[{"h", " ", "\[Nu]"}]]}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "23"}]], 
    FractionBox["erg", 
     RowBox[{"s", " ", 
      SuperscriptBox["cm", "2"], "Hz"}]], "2", "GHz", " ", "6", " ", "\[Pi]", 
    " ", 
    SuperscriptBox["300", "2"], 
    SuperscriptBox["cm", "2"], "4", "*", "60", "s"}], 
   RowBox[{"6.67", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "27"}]], "erg", "*", "s", " ", "230", " ", "GHz"}]], 
  "\[Equal]", 
  FractionBox[
   RowBox[{"2", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "23"}]], "2", " ", "6", " ", "\[Pi]", " ", 
    SuperscriptBox["300", "2"], "4", "*", "60"}], 
   RowBox[{"6.67", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "27"}]], " ", "230"}]], "\[TildeTilde]", 
  RowBox[{
   SuperscriptBox["10", "10"], "ph"}]}]}], "Text",
 CellChangeTimes->{{3.573576983699072*^9, 3.5735769956202545`*^9}, {
  3.5735770280687532`*^9, 3.5735770285450106`*^9}, {3.573577097419819*^9, 
  3.5735770990198436`*^9}, {3.5735771373919344`*^9, 3.5735771589705157`*^9}, {
  3.573578467353368*^9, 3.573578572289481*^9}, {3.5735787299679046`*^9, 
  3.573578747400422*^9}, {3.573578778184145*^9, 3.573578823199087*^9}, {
  3.5735789701263437`*^9, 3.573578975360174*^9}, {3.57357914495053*^9, 
  3.5735792390549755`*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", " ", 
   SuperscriptBox["10", 
    RowBox[{"-", "23"}]], "2", " ", "6", " ", "\[Pi]", " ", 
   SuperscriptBox["300", "2"], "4", "*", "60"}], 
  RowBox[{"6.67", " ", 
   SuperscriptBox["10", 
    RowBox[{"-", "27"}]], " ", "230"}]]], "Input",
 CellChangeTimes->{{3.5735791220919285`*^9, 3.5735791323495865`*^9}, 
   3.573579215853619*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["plotting the spectrum", "Subsection",
 CellChangeTimes->{{3.561934793575229*^9, 3.561934799062543*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"fnum", "=."}], ";", 
   RowBox[{"Dynamic", "[", "fnum", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{
      "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\th238hi\\\\poliresa93.\
75th238fn\>\"", "<>", 
       RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<hi.dat\>\""}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", "2000", ",", "7000", ",", "coe"}], "}"}]}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, 
   3.5486008696865225`*^9, {3.548600915220127*^9, 3.548600929823962*^9}, {
   3.551033749980384*^9, 3.551033750871435*^9}, {3.5510337885625906`*^9, 
   3.5510337966150513`*^9}, {3.5520186449336777`*^9, 3.552018650318986*^9}, {
   3.55771381499922*^9, 3.557713848242878*^9}, {3.557714021184782*^9, 
   3.5577140212159815`*^9}, {3.557735285968544*^9, 3.557735286467745*^9}, {
   3.557735457912046*^9, 3.5577354872556973`*^9}, {3.5577395741124763`*^9, 
   3.5577395758284793`*^9}, {3.557855418955073*^9, 3.5578554191790857`*^9}, {
   3.5588325820031524`*^9, 3.5588325935978155`*^9}, {3.560872762763075*^9, 
   3.560872763870677*^9}, {3.5608728196547747`*^9, 3.560872849887628*^9}, {
   3.56087349695055*^9, 3.560873499446555*^9}, {3.560875165560282*^9, 
   3.560875166028283*^9}, {3.5608801039683924`*^9, 3.560880104514393*^9}, {
   3.5609031767900453`*^9, 3.5609031777421*^9}, {3.561076626864645*^9, 
   3.5610766304058514`*^9}, {3.5612385098749537`*^9, 
   3.5612385397646065`*^9}, {3.569342323782839*^9, 3.569342385552372*^9}, {
   3.569342436098263*^9, 3.5693424416645813`*^9}, {3.5693424738884244`*^9, 
   3.5693424739944305`*^9}}],

Cell[BoxData[
 RowBox[{"Dimensions", "[", "imp", "]"}]], "Input",
 CellChangeTimes->{{3.5693427347293434`*^9, 3.569342742266775*^9}}],

Cell[BoxData[{
 RowBox[{"toout", "=", 
  RowBox[{"Mean", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"imp", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"1", "+", 
         RowBox[{"250", "#"}]}], ",", "All", ",", 
        RowBox[{"2", ";;", 
         RowBox[{"-", "1"}]}]}], "]"}], "]"}], "&"}], "/@", 
    RowBox[{"Range", "[", 
     RowBox[{"0", ",", "20"}], "]"}]}], "]"}]}], "\n", 
 RowBox[{"line", "=", 
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<quick21.dat\>\""}], 
    ",", "toout"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.569342456725443*^9, 3.5693424571804686`*^9}, {
  3.569342754512475*^9, 3.5693427547604895`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<ErrorBarPlots`\>\"", "]"}], ";", 
  RowBox[{"Needs", "[", "\"\<ErrorBarLogPlots`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xFnu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"87.73`", ",", "1.8409545454545453`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.08006092045351851`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"102.`", ",", "1.9076923076923078`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.15168351771484959`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"145.`", ",", "2.2750000000000004`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.2644063431268514`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"230.9`", ",", "2.6372093023255814`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.14137527543005202`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"349.`", ",", "3.1806666666666668`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.12050080682071983`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"674.`", ",", "3.2857142857142856`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.35080083308024784`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"857.`", ",", "2.866666666666667`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.2403700850309327`", "]"}]}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xLPnu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"87.73", ",", "1.420"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.5", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"230.9", ",", "7.3979"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.6579", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"349", ",", "6.499"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.6054", "]"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xCPnu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"231", ",", 
         RowBox[{"-", "1.2"}]}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.3", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"349", ",", 
         RowBox[{"-", "1.5"}]}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.3", "]"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xEVPA", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"88", ",", 
        RowBox[{"-", "4.0166666666666675`"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"231", ",", "111.47500000000001`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"349", ",", "146.89090909090908`"}], "}"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"el", "=", 
   RowBox[{"{", 
    RowBox[{
    "ListLogLogPlot", ",", "ListLogLinearPlot", ",", "ErrorListLogLogPlot", 
     ",", "ErrorListLogLinearPlot"}], "}"}]}], ";", 
  RowBox[{"Clear", "[", "totI", "]"}], ";", 
  RowBox[{"xcol", "=", "Cyan"}], ";", 
  RowBox[{"myf", "=", "14"}], ";", 
  RowBox[{"siz", "=", "380"}], ";", 
  RowBox[{"ord", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"#", ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ","}], "*)"}], 
        RowBox[{
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}]}], "}"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"FrameTicks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"(*", 
           RowBox[{"{", 
            RowBox[{
            "10", ",", "20", ",", "50", ",", "100", ",", "200", ",", "500"}], 
            "}"}], "*)"}], 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "43", ",", "88", ",", "145", ",", "231", ",", "349", ",", "690"}],
             "}"}], ",", "None"}], "}"}]}], "}"}]}]}], "]"}], "&"}], "/@", 
   "el"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ax", "=", "30"}], ";", 
   RowBox[{"Fran", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"80", ",", "900"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1.5", ",", "3.7"}], "}"}]}], "}"}]}], ";", 
   RowBox[{"LPran", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"40", ",", "860"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0.4", ",", "15."}], "}"}]}], "}"}]}], ";", 
   RowBox[{"CPran", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"40", ",", "860"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "2."}], ",", "2.2"}], "}"}]}], "}"}]}], ";", 
   RowBox[{"angran", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"80", ",", "860"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"80", ",", "170"}], "}"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plo", "[", 
    RowBox[{
     RowBox[{"dat_", "?", "StringQ"}], ",", 
     RowBox[{"style_", "?", "ListQ"}], ",", 
     RowBox[{"ax_", "?", "NumberQ"}]}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fff", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Import", "[", "dat", "]"}], "]"}]}], ";", 
     RowBox[{"ftab", "=", 
      RowBox[{"fff", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"Fnusim", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"ftab", ",", 
         RowBox[{"fff", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
     RowBox[{"LPnusim", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"ftab", ",", 
         RowBox[{"fff", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
     RowBox[{"CPnusim", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"ftab", ",", 
         RowBox[{"fff", "[", 
          RowBox[{"[", "5", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
     RowBox[{"angsim", "=", 
      RowBox[{"Delete", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"ftab", ",", 
           RowBox[{"Mod", "[", 
            RowBox[{
             RowBox[{"ax", "+", 
              RowBox[{"fff", "[", 
               RowBox[{"[", "4", "]"}], "]"}]}], ",", "180"}], "]"}]}], "}"}],
          "]"}], ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{"Fnusim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "Fran"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "Null", ",", 
              "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}], 
             "}"}]}], "}"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", "\[IndentingNewLine]", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}], ",", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{"LPnusim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "ord"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "LPran"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Null", ",", "\"\<LP [%]\>\""}], "}"}]}], "}"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}], ",", 
       RowBox[{"ListLogLinearPlot", "[", 
        RowBox[{"CPnusim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "ord"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Null", ",", "\"\<CP [%]\>\""}], "}"}]}], "}"}]}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "CPran"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}], ",", 
       RowBox[{"ListLogLinearPlot", "[", 
        RowBox[{"angsim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "angran"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "Null", ",", "\"\<Electric vector position angle [deg]\>\""}], 
             "}"}]}], "}"}]}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}]}], "}"}]}], 
    ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pldat", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ErrorListLogLogPlot", "[", 
      RowBox[{"xFnu", ",", 
       RowBox[{"Joined", "\[Rule]", "False"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "Fran"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Null", ",", "Null"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "Null", ",", 
            "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}], "}"}]}], 
         "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"ErrorListLogLogPlot", "[", 
       RowBox[{"xFnu", ",", 
        RowBox[{"Joined", "\[Rule]", "False"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "Fran"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<\[Nu] [GHz]\>\"", ",", 
           "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}], "}"}]}], 
        ",", 
        RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}], "*)"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ErrorListLogLogPlot", "[", 
      RowBox[{"xLPnu", ",", 
       RowBox[{"Joined", "\[Rule]", "False"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "LPran"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Null", ",", "Null"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Null", ",", "\"\<LP [%]\>\""}], "}"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}], ",", 
     RowBox[{"ErrorListLogLinearPlot", "[", 
      RowBox[{"xCPnu", ",", 
       RowBox[{"Joined", "\[Rule]", "False"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "CPran"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Null", ",", "Null"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Null", ",", "\"\<CP [%]\>\""}], "}"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}], ",", 
     RowBox[{"ListLogLinearPlot", "[", 
      RowBox[{"xEVPA", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "angran"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Null", ",", "Null"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "Null", ",", "\"\<Electric vector position angle [deg]\>\""}], 
           "}"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"AbsoluteThickness", "[", "6", "]"}], ",", "Blue"}], 
         "}"}]}]}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pl0", "=", 
    RowBox[{"plo", "[", 
     RowBox[{"line", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Red"}], "}"}], 
      ",", "100"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"pl50", "=", 
     RowBox[{"plo", "[", 
      RowBox[{
       RowBox[{"dir", "<>", "\"\<quicka50in21.dat\>\""}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Red"}], "}"}], 
       ",", "62"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"pl70", "=", 
     RowBox[{"plo", "[", 
      RowBox[{
       RowBox[{"dir", "<>", "\"\<quicka70in21.dat\>\""}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", 
         RowBox[{"AbsoluteDashing", "[", 
          RowBox[{"{", 
           RowBox[{"10", ",", "7"}], "}"}], "]"}], ",", "Green"}], "}"}], ",",
        "62"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"pl90", "=", 
     RowBox[{"plo", "[", 
      RowBox[{
       RowBox[{"dir", "<>", "\"\<quicka90in21.dat\>\""}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Cyan"}], "}"}],
        ",", "46"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"pl98", "=", 
     RowBox[{"plo", "[", 
      RowBox[{
       RowBox[{"dir", "<>", "\"\<quicka98in21.dat\>\""}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "DotDashed", 
         ",", "Orange"}], "}"}], ",", "50"}], "]"}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tot", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"pldat", ",", "pl0"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Fnupl", "=", 
  RowBox[{"Show", "[", 
   RowBox[{"tot", "[", 
    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LPnupl", "=", 
   RowBox[{"Show", "[", 
    RowBox[{"tot", "[", 
     RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CPnupl", "=", 
   RowBox[{"Show", "[", 
    RowBox[{"tot", "[", 
     RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"angnupl", "=", 
    RowBox[{"Show", "[", 
     RowBox[{"tot", "[", 
      RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"totimag", "=", 
  RowBox[{"GraphicsGrid", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Fnupl", ",", "angnupl"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"LPnupl", ",", "CPnupl"}], "}"}]}], "}"}], ",", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"ImageSize", "\[Rule]", "900"}], ","}], "*)"}], 
    RowBox[{"Epilog", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Black", ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
           RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.45", ",", "0.55"}], "}"}], "]"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
           RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.46", ",", "0.05"}], "}"}], "]"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
           RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.955", ",", "0.55"}], "}"}], "]"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
           RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.955", ",", "0.05"}], "}"}], "]"}]}], "]"}]}], "}"}]}], 
    ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", 
        RowBox[{"myf", "-", "2"}]}]}], "}"}]}], ",", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<Best fits to observations\>\""}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
   "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\Fnu.eps\>\"", ",", "Fnupl"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
   "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\EVPA.eps\>\"", ",", "angnupl"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
   "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LP.eps\>\"", ",", "LPnupl"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
   "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\CP.eps\>\"", ",", "CPnupl"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"C", ":", 
    RowBox[{
     RowBox[{"\\", "study", "\\", "accretion"}], 
     RowBox[{"\\!", "2009"}], " ", "fall", " ", 
     RowBox[{"cfa", "\\", "GR"}], " ", "Polarized", " ", "modeling"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5619334440530415`*^9, 3.561933451077443*^9}, {
   3.5619335632278576`*^9, 3.561933581144882*^9}, {3.5619338525644064`*^9, 
   3.5619338573966827`*^9}, 3.5693424134429674`*^9, 3.5693425971334734`*^9, {
   3.5693427962678633`*^9, 3.569342817170059*^9}, {3.5693429515607457`*^9, 
   3.569343033736446*^9}, {3.569343085787423*^9, 3.5693431200473824`*^9}, {
   3.5693431587355957`*^9, 3.5693431614067483`*^9}, {3.5693452022549343`*^9, 
   3.569345209519944*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"choice", " ", "of", " ", "angles"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     FractionBox["180", "\[Pi]"], 
     RowBox[{"(", 
      RowBox[{"\[Pi]", "-", "#"}], ")"}]}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"1.745", ",", "2.37", ",", "2.38", ",", "2.967"}], 
    "}"}]}]}]], "Input",
 CellChangeTimes->{{3.5612879539779377`*^9, 3.5612880235852594`*^9}, {
  3.5612887432842417`*^9, 3.561288746054246*^9}, {3.561289230779443*^9, 
  3.561289270979499*^9}, {3.5685052669537725`*^9, 3.5685052719301815`*^9}, {
  3.568505325563075*^9, 3.56850540779082*^9}, {3.5685055499370923`*^9, 
  3.568505554797099*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["lightcurve th=238 (no B cut, no B red, thlimit=0.1) ", "Subsection",
 CellChangeTimes->{{3.5577510472865367`*^9, 3.55775104944654*^9}, {
   3.55883260748061*^9, 3.558832631388977*^9}, {3.560872675917722*^9, 
   3.56087270326457*^9}, {3.5610765919205837`*^9, 3.5610766169586277`*^9}, {
   3.567729128601217*^9, 3.5677291508874917`*^9}, {3.5685060616481857`*^9, 
   3.5685060618041863`*^9}, {3.568506336458269*^9, 3.5685063368950696`*^9}, {
   3.5695842114012527`*^9, 3.569584216751335*^9}, 3.5696103004503517`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dir0", "=", 
   "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\th238lo\\\\\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fil", "=", 
   RowBox[{"dir0", "<>", "\"\<totspec.dat\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"coe", "=", "1"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"imp", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Import", "[", 
        RowBox[{"dir0", "<>", "\"\<poliresa93.75th238fn\>\"", "<>", 
         RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"fnum", ",", "2000", ",", "6999", ",", "coe"}], "}"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Put", "[", 
     RowBox[{"imp", ",", "fil"}], "]"}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Get", "[", "fil", "]"}]}], ";", 
  RowBox[{"Dimensions", "[", "imp", "]"}]}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, 
   3.5486008696865225`*^9, {3.548600915220127*^9, 3.548600929823962*^9}, {
   3.551033749980384*^9, 3.551033750871435*^9}, {3.5510337885625906`*^9, 
   3.5510337966150513`*^9}, {3.5520186449336777`*^9, 3.552018650318986*^9}, {
   3.55771381499922*^9, 3.557713848242878*^9}, {3.557714021184782*^9, 
   3.5577140212159815`*^9}, {3.557735285968544*^9, 3.557735286467745*^9}, {
   3.557735457912046*^9, 3.5577354872556973`*^9}, {3.5577395741124763`*^9, 
   3.5577395758284793`*^9}, {3.557855418955073*^9, 3.5578554191790857`*^9}, {
   3.5588325820031524`*^9, 3.5588325935978155`*^9}, {3.560872762763075*^9, 
   3.560872763870677*^9}, {3.5608728196547747`*^9, 3.560872849887628*^9}, {
   3.56087349695055*^9, 3.560873499446555*^9}, {3.560875165560282*^9, 
   3.560875166028283*^9}, {3.5608801039683924`*^9, 3.560880104514393*^9}, {
   3.5609031767900453`*^9, 3.5609031777421*^9}, {3.561076765174488*^9, 
   3.5610767680448933`*^9}, {3.5677291589449525`*^9, 3.567729159049958*^9}, {
   3.5677293582233505`*^9, 3.567729413559516*^9}, {3.5677295667262764`*^9, 
   3.567729571199532*^9}, {3.5685064387632484`*^9, 3.5685064673268986`*^9}, {
   3.5685068316977386`*^9, 3.568506890634642*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "imp", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"4", 
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"type", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fr", "=", "1"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"1", " ", "-", " ", 
     RowBox[{"43", "GHz"}]}], ",", " ", 
    RowBox[{"11", " ", "-", " ", 
     RowBox[{"5000", "GHz"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", 
                 RowBox[{"(*", "type", "*)"}], "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "3", "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "6", "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "9", "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
   3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
   3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}, 
   3.568506953861553*^9, {3.5686340870447598`*^9, 3.5686340873347597`*^9}, 
   3.568643916133256*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"im1", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "3", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"im2", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "6", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"im3", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "9", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux87.jpg\>\"", ",", "im1", 
   ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux230.jpg\>\"", ",", "im2", 
   ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux857.jpg\>\"", ",", "im3", 
   ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5677313621689696`*^9, 3.567731539914136*^9}, {
  3.567731608730072*^9, 3.567731750697192*^9}, {3.5685070558389325`*^9, 
  3.568507057461335*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tmax", "=", 
    SuperscriptBox["10", "3.2"]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Papadakis", " ", "&"}], " ", "Lawrence", " ", 
    RowBox[{"(", "1993", ")"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"autovar", "[", 
    RowBox[{"ty_", ",", "mu_", ",", "kf_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"typ", "=", "ty"}], ";", 
      RowBox[{"mult", "=", "mu"}], ";", 
      RowBox[{"k", "=", "kf"}], ";", 
      RowBox[{"binned", "=", 
       RowBox[{"imp", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
      RowBox[{"ll", "=", 
       RowBox[{"Length", "[", "binned", "]"}]}], ";", 
      RowBox[{"me", "=", 
       RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"autovariance", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{"1", ";;", 
                RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], 
            ")"}], ".", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
             "me"}], ")"}]}], "ll"], ",", 
         RowBox[{"{", 
          RowBox[{"shi", ",", "0", ",", 
           RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"f11", "=", 
       RowBox[{"FourierDCT", "[", 
        RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
      RowBox[{"num", "=", 
       RowBox[{"Floor", "[", 
        FractionBox["ll", "2"], "]"}]}], ";", 
      RowBox[{"sur", "=", 
       RowBox[{
        FractionBox[
         SqrtBox["2"], 
         RowBox[{"2", "\[Pi]"}]], 
        SqrtBox["ll"], 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"f11", ",", "2"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"sur", ",", 
        RowBox[{"sur", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"timex", "=", 
       RowBox[{"4.", 
        RowBox[{"ll", "/", 
         RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
      RowBox[{"mint", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
      RowBox[{"maxt", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", 
      RowBox[{"nn", "=", 
       RowBox[{
        RowBox[{"Log", "[", 
         FractionBox["maxt", "mint"], "]"}], "/", 
        RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"tsides", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"mint", " ", 
          SuperscriptBox["mult", "i"]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tbins", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tsides", "[", 
            RowBox[{"[", "i", "]"}], "]"}], ",", 
           RowBox[{"tsides", "[", 
            RowBox[{"[", 
             RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tsizes", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tmeans", "=", 
       RowBox[{"Mean", "[", 
        RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"intergra", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"timex", ",", 
             RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"pergra", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"Exp", "[", 
              RowBox[{"intergra", "[", 
               RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"tx", ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
             RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
             RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        RowBox[{"res", "=", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"tmeans", ",", 
              FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
          "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"pergra", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{"NIntegrate", "[", 
           RowBox[{
            RowBox[{"intergra", "[", 
             RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"tx", ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
            RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
            RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
          RowBox[{"tsizes", "[", 
           RowBox[{"[", "i", "]"}], "]"}]], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"res", "[", 
        RowBox[{"ty", ",", "kf"}], "]"}], "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"tmeans", ",", 
            RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}]}]}],
      ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"autorand", "[", 
     RowBox[{"ty_", ",", "mu_", ",", "kf_", ",", "rlist_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"typ", "=", "ty"}], ";", 
       RowBox[{"mult", "=", "mu"}], ";", 
       RowBox[{"k", "=", "kf"}], ";", 
       RowBox[{"binned", "=", "rlist"}], ";", 
       RowBox[{"ll", "=", 
        RowBox[{"Length", "[", "binned", "]"}]}], ";", 
       RowBox[{"merr", "=", 
        RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"autovariance", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{"1", ";;", 
                 RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "merr"}], 
             ")"}], ".", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
              "merr"}], ")"}]}], "ll"], ",", 
          RowBox[{"{", 
           RowBox[{"shi", ",", "0", ",", 
            RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"f11", "=", 
        RowBox[{"FourierDCT", "[", 
         RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
       RowBox[{"num", "=", 
        RowBox[{"Floor", "[", 
         FractionBox["ll", "2"], "]"}]}], ";", 
       RowBox[{"sur", "=", 
        RowBox[{
         FractionBox[
          SqrtBox["2"], 
          RowBox[{"2", "\[Pi]"}]], 
         SqrtBox["ll"], 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{"f11", ",", "2"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sur", ",", 
         RowBox[{"sur", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"timex", "=", 
        RowBox[{"4.", 
         RowBox[{"ll", "/", 
          RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
       RowBox[{"mint", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
       RowBox[{"maxt", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", 
       RowBox[{"nn", "=", 
        RowBox[{
         RowBox[{"Log", "[", 
          FractionBox["maxt", "mint"], "]"}], "/", 
         RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"tsides", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"mint", " ", 
           SuperscriptBox["mult", "i"]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tbins", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"tsides", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"tsides", "[", 
             RowBox[{"[", 
              RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tsizes", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tmeans", "=", 
        RowBox[{"Delete", "[", 
         RowBox[{
          RowBox[{"Mean", "[", 
           RowBox[{"Transpose", "[", "tbins", "]"}], "]"}], ",", 
          RowBox[{"-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"intergra", "=", 
        RowBox[{"Interpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"tra", "=", 
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"timex", ",", 
               RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}]}], "]"}], ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"pergra", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{"Exp", "[", 
               RowBox[{"intergra", "[", 
                RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"tx", ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
              RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
              RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
         RowBox[{"res", "=", 
          RowBox[{"Select", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"tmeans", ",", 
               FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
           "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"pergra", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            FractionBox[
             RowBox[{"NIntegrate", "[", 
              RowBox[{
               RowBox[{"intergra", "[", 
                RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"tx", ",", 
                 RowBox[{"tbins", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"tbins", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
               RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
               RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
             RowBox[{"tsizes", "[", 
              RowBox[{"[", "i", "]"}], "]"}]], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "nn"}], 
             RowBox[{"(*", 
              RowBox[{"+", "1"}], "*)"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"pergra", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"sel", "=", 
            RowBox[{"Select", "[", 
             RowBox[{"timex", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], "<", "#", "<", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "&"}]}], "]"}]}], 
           ";", 
           RowBox[{"inttime", "=", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Flatten", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}], ",", "sel", ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}]}], "}"}], "]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"intxx", "=", 
            RowBox[{
             RowBox[{"intergra", "[", 
              RowBox[{"Log", "[", "tx", "]"}], "]"}], "/.", 
             RowBox[{"tx", "\[Rule]", "inttime"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"deltax", "=", 
            RowBox[{"Differences", "[", "inttime", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{
               FractionBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"intxx", "[", 
                   RowBox[{"[", "kk", "]"}], "]"}], "+", 
                  RowBox[{"intxx", "[", 
                   RowBox[{"[", 
                    RowBox[{"kk", "+", "1"}], "]"}], "]"}]}], ")"}], "2"], 
               RowBox[{"deltax", "[", 
                RowBox[{"[", "kk", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"kk", ",", 
                RowBox[{
                 RowBox[{"Length", "[", "inttime", "]"}], "-", "1"}]}], 
               "}"}]}], "]"}], "/", 
            RowBox[{"tsizes", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nn"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"resy", "=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"tmeans", ",", 
             RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
         "]"}]}]}], ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"3", ",", "1.2", ",", "6"}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"lpl3", "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", "\"\<FourierDCT of autovariance\>\""}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"tofit3", "=", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"A", " ", 
         RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
      RowBox[{"FindFit", "[", 
       RowBox[{
        RowBox[{"Log", "[", "res", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"logpl3", "=", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{"tofit3", ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"res", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"res", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl3", ",", "logpl3"}], "]"}]}], 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5686439274432755`*^9, 3.5686439603749332`*^9}, {
   3.5686451629862075`*^9, 3.5686451856374474`*^9}, {3.5686452238107147`*^9, 
   3.568645224060315*^9}, {3.56864527792721*^9, 3.5686452795340123`*^9}, {
   3.5686475480025587`*^9, 3.5686475486109595`*^9}, {3.5686486517096863`*^9, 
   3.5686486798521357`*^9}, {3.568649804547723*^9, 3.5686498966658845`*^9}, {
   3.568650080917808*^9, 3.568650142881117*^9}, {3.568650191912003*^9, 
   3.568650192473604*^9}, {3.5686504541512637`*^9, 3.568650473729298*^9}, {
   3.5686509820415907`*^9, 3.5686511574618998`*^9}, {3.568651441439598*^9, 
   3.5686514679596443`*^9}, {3.568652600865834*^9, 3.5686526186810656`*^9}, {
   3.5686526510979223`*^9, 3.5686527356666713`*^9}, {3.5686534018536034`*^9, 
   3.5686534150044265`*^9}, {3.5686541196155853`*^9, 
   3.5686541365906086`*^9}, {3.56865418756568*^9, 3.568654188135681*^9}, {
   3.568654261385783*^9, 3.568654264630788*^9}, {3.5686571128482122`*^9, 
   3.5686571159214177`*^9}, {3.5686743062539015`*^9, 3.56867431938892*^9}, {
   3.5686745663492656`*^9, 3.568674568974269*^9}, {3.5686757574482994`*^9, 
   3.5686757867295504`*^9}, {3.5686758566488733`*^9, 3.568675912777772*^9}, 
   3.568675949391036*^9, {3.56867605980803*^9, 3.568676061118432*^9}, {
   3.5686761408813725`*^9, 3.568676141208973*^9}, {3.5686762215179143`*^9, 
   3.568676225854722*^9}, {3.5686762768512115`*^9, 3.5686762805952177`*^9}, {
   3.568676756568654*^9, 3.56867676009426*^9}, {3.5687322632105227`*^9, 
   3.56873226844553*^9}, {3.5687323603038664`*^9, 3.56873240813355*^9}, 
   3.568732799124943*^9, {3.568732924601118*^9, 3.568732926276121*^9}, {
   3.5687334021941023`*^9, 3.568733460023404*^9}, {3.568733522532714*^9, 
   3.5687335375711403`*^9}, {3.5687338285272512`*^9, 
   3.5687338298532534`*^9}, {3.568733990581336*^9, 3.5687340011113544`*^9}, {
   3.568734122885168*^9, 3.568734123306369*^9}, 3.56873427757504*^9, {
   3.568734397804451*^9, 3.568734422483694*^9}, {3.568734709465399*^9, 
   3.568734710526201*^9}, {3.5687675388524036`*^9, 3.5687675394140043`*^9}, {
   3.5688219411048136`*^9, 3.5688219660180573`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ttx", "=", 
   RowBox[{"TimeUsed", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "fr", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}], ",", 
   RowBox[{"Dynamic", "[", "o", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"20", ",", "1500"}], "}"}], ",", "All"}], "}"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=."}], ";", 
  RowBox[{"fr", "=."}], ";", 
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";", 
  RowBox[{"types", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Flux\>\"", ",", "\"\<LP\>\"", ",", "\"\<EVPA\>\"", ",", 
     "\"\<CP\>\""}], "}"}]}], ";", 
  RowBox[{"th", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"Do", "[", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Frequency  = \>\"", ",", 
        RowBox[{"freqs", "[", 
         RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz\>\""}], "]"}], ";"}], 
     "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      StyleBox[
       RowBox[{"autovar", "[", 
        RowBox[{"typ", ",", "3.0", ",", "fr"}], "]"}],
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox[";",
       FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"resx", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"timex", "[", 
               RowBox[{"[", 
                RowBox[{"-", "1"}], "]"}], "]"}], ",", 
              RowBox[{"sur", "[", 
               RowBox[{"[", 
                RowBox[{"-", "1"}], "]"}], "]"}]}], "}"}], "}"}], ",", "res", 
           ",", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"timex", "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"sur", "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"tofit4", "=", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"A", " ", 
             RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
          RowBox[{"FindFit", "[", 
           RowBox[{
            RowBox[{"Log", "[", "resx", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"PrependTo", "[", 
         RowBox[{"resx", ",", 
          RowBox[{"{", 
           RowBox[{"4.", ",", 
            RowBox[{"(*", "0.5", "*)"}], 
            RowBox[{"tofit4", "/.", 
             RowBox[{"x", "\[Rule]", "4."}]}]}], "}"}]}], "]"}], ";"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"PrependTo", "[", 
         RowBox[{"resx", ",", 
          RowBox[{"{", 
           RowBox[{"8.", ",", 
            RowBox[{"tofit4", "/.", 
             RowBox[{"x", "\[Rule]", "8."}]}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"PrependTo", "[", 
         RowBox[{"resx", ",", 
          RowBox[{"{", 
           RowBox[{"4.", ",", 
            RowBox[{"(*", "0.5", "*)"}], 
            RowBox[{"tofit4", "/.", 
             RowBox[{"x", "\[Rule]", "4."}]}]}], "}"}]}], "]"}], ";"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"resx", "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"res", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"timex", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"sur", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tofit4", "=", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"A", " ", 
           RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
        RowBox[{"FindFit", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"res", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"resx", "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"#", ",", 
             RowBox[{
              FractionBox[
               RowBox[{
                RowBox[{"tofit4", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                RowBox[{"x", "\[Rule]", "#"}]}], 
               RowBox[{
                RowBox[{"tofit4", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                RowBox[{"x", "\[Rule]", 
                 RowBox[{
                  RowBox[{"res", "[", 
                   RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
              RowBox[{
               RowBox[{"res", "[", 
                RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
          RowBox[{"{", 
           RowBox[{"4", ",", "8"}], "}"}]}], ",", "resx"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"resx", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"#", ",", 
              RowBox[{
               FractionBox[
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", "#"}]}], 
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", 
                  RowBox[{"res", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
               RowBox[{"res", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
           RowBox[{"{", 
            RowBox[{"4", ",", "8"}], "}"}]}], ",", "res", ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"timex", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"sur", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"interand", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", "resx", "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDfluxx", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{"resx", ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Green", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"autovar", "[", 
        RowBox[{"typ", ",", "1.2", ",", "fr"}], "]"}],
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox[";",
       FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         StyleBox[
          RowBox[{"PSDflux", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
          FontColor->RGBColor[0, 0, 1]], "=", 
         RowBox[{"ListLogLogPlot", "[", 
          RowBox[{"res", ",", 
           RowBox[{"PlotStyle", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Black", ",", 
              RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
           RowBox[{"FrameLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
             "}"}]}]}], "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Print", "[", 
         RowBox[{"Show", "[", 
          RowBox[{
           StyleBox[
            RowBox[{"PSDflux", "[", 
             RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
            FontColor->RGBColor[0, 0, 1]], ",", 
           StyleBox[
            RowBox[{"PSDfluxx", "[", 
             RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
            FontColor->RGBColor[0, 0, 1]]}], "]"}], "]"}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"nux", "=", "154"}], ";", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"22", " ", "-", " ", 
         RowBox[{"1", "\[Sigma]"}]}], ";", " ", 
        RowBox[{"154", " ", "-", " ", 
         RowBox[{"2", "\[Sigma]"}]}], ";", " ", 
        RowBox[{"2592", " ", "-", " ", 
         RowBox[{"3", "\[Sigma]"}]}], ";", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"7", "/", 
           RowBox[{"(", 
            RowBox[{"1", "-", "#"}], ")"}]}], "&"}], "/@", 
         RowBox[{"{", 
          RowBox[{
          "0.682689492137086", ",", "0.954499736103642", ",", 
           "0.997300203936740"}], "}"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"tabresy", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"randx", "=", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"RandomVariate", "[", 
                RowBox[{
                 RowBox[{"NormalDistribution", "[", "]"}], ",", "5000"}], 
                "]"}], "+", 
               RowBox[{"\[ImaginaryI]", " ", 
                RowBox[{"RandomVariate", "[", 
                 RowBox[{
                  RowBox[{"NormalDistribution", "[", "]"}], ",", "5000"}], 
                 "]"}]}]}], ")"}], 
             SqrtBox[
              RowBox[{"Exp", "[", 
               RowBox[{"interand", "[", 
                RowBox[{"Log", "[", 
                 RowBox[{"20000", "/", 
                  RowBox[{"Range", "[", "5000", "]"}]}], "]"}], "]"}], 
               "]"}]]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"rsxx", "=", 
            RowBox[{"4.8", 
             RowBox[{"Re", "[", 
              RowBox[{"InverseFourier", "[", "randx", "]"}], "]"}]}]}], ";"}], 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"+", "me"}], ";"}], 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"-", "for"}], " ", "formal", " ", "correspondence"}], 
            "*)"}], "*)"}], ";", "\[IndentingNewLine]", 
          RowBox[{"resy", "=", 
           StyleBox[
            RowBox[{"autorand", "[", 
             RowBox[{"typ", ",", "1.2", ",", "fr", ",", "rsxx"}], "]"}],
            FontColor->RGBColor[1, 0, 0]]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"o", ",", "nux"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         StyleBox[
          RowBox[{"PSDFrand", "[", "aa", "]"}],
          FontColor->RGBColor[0, 0, 1]], "=", 
         RowBox[{"ListLogLogPlot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ress", "[", "aa", "]"}], "=", 
            RowBox[{"tabresy", "[", 
             RowBox[{"[", "aa", "]"}], "]"}]}], ",", 
           RowBox[{"PlotStyle", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Red", ",", 
              RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
           RowBox[{"FrameLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
             "}"}]}]}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"aa", ",", "nux"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmean", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Exp", "[", 
        FractionBox[
         RowBox[{"Total", "[", 
          RowBox[{"Log", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"ress", "[", "i", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}], "]"}], "nux"],
         "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFrandmean", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"ressmean", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDflux", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0., 0., 1.]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"res", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}], ",", 
         RowBox[{"Epilog", "\[Rule]", "\[IndentingNewLine]", 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"types", "[", 
                RowBox[{"[", 
                 RowBox[{"typ", "-", "2"}], "]"}], "]"}], "<>", 
               "\"\< at \>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Floor", "[", 
                 RowBox[{"freqs", "[", 
                  RowBox[{"[", "fr", "]"}], "]"}], "]"}], "]"}], "<>", 
               "\"\<GHz\>\""}], ",", "18", ",", "Bold"}], "]"}], ",", 
            RowBox[{"Scaled", "[", 
             RowBox[{"{", 
              RowBox[{"0.3", ",", "0.8"}], "}"}], "]"}]}], "]"}]}]}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Print", "[", 
         RowBox[{"Show", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             StyleBox[
              RowBox[{"PSDFrand", "[", "i", "]"}],
              FontColor->RGBColor[0, 0, 1]], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], ",", 
           StyleBox[
            RowBox[{"PSDflux", "[", 
             RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
            FontColor->RGBColor[0, 0, 1]], ",", 
           StyleBox[
            RowBox[{"PSDFrandmean", "[", 
             RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
            FontColor->RGBColor[0, 0, 1]], ",", 
           StyleBox[
            RowBox[{"PSDfluxx", "[", 
             RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
            FontColor->RGBColor[0, 0, 1]]}], "]"}], "]"}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resstot", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ress", "[", "i", "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"resst", "=", 
       RowBox[{
        RowBox[{"ress", "[", "1", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"ressmax", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
         RowBox[{"Max", "@@@", 
          RowBox[{"resstot", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}]}], ";", 
        RowBox[{
         RowBox[{"ressmin", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
         RowBox[{"Min", "@@@", 
          RowBox[{"resstot", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}]}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmax", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Mean", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"RankedMax", "[", 
             RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
           RowBox[{"resstot", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"RankedMax", "[", 
             RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
           RowBox[{"resstot", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}]}], "}"}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmin", "[", 
        RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], "=", 
       RowBox[{"Mean", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"RankedMin", "[", 
             RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
           RowBox[{"resstot", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"RankedMin", "[", 
             RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
           RowBox[{"resstot", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}]}], "}"}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFmin", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"resst", ",", 
            RowBox[{"ressmin", "[", 
             RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], "}"}], "]"}], 
         ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Dotted"}], 
           "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFmax", "[", 
         RowBox[{"typ", ",", "fr", ",", "th"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"resst", ",", 
            RowBox[{"ressmax", "[", 
             RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}], "}"}], "]"}], 
         ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"Print", "[", 
       RowBox[{"Show", "[", 
        StyleBox[
         RowBox[{
          RowBox[{"PSDflux", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
          RowBox[{"PSDFmin", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
          RowBox[{"PSDFmax", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
          RowBox[{"PSDflux", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
          RowBox[{"PSDFrandmean", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
          RowBox[{"PSDfluxx", "[", 
           RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}],
         FontColor->RGBColor[0, 0, 1]], "]"}], "]"}], "*)"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"typ", ",", "3", ",", "6"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Computed in \>\"", ",", 
    RowBox[{
     RowBox[{"TimeUsed", "[", "]"}], "-", "ttx"}], ",", "\"\<s\>\""}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"125", "s", " ", "for", " ", "1", "\[Sigma]"}], " ", "\[Implies]",
     " ", 
    RowBox[{
     RowBox[{"709", "s", 
      RowBox[{"(", 
       RowBox[{"12", "min"}], ")"}], " ", "for", " ", "2", "\[Sigma]"}], " ", 
     "\[Implies]", " ", 
     RowBox[{
     "expected", " ", "3.5", "hrs", " ", "for", " ", "3", "\[Sigma]"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.568658690181983*^9, 3.5686587401332707`*^9}, {
   3.5686588111757956`*^9, 3.5686588548880725`*^9}, {3.5686588922033377`*^9, 
   3.568658925977397*^9}, {3.5686589703906755`*^9, 3.5686589774106874`*^9}, {
   3.568672919401613*^9, 3.5686729589816833`*^9}, {3.5686734755153365`*^9, 
   3.5686734758803368`*^9}, 3.568673902517336*^9, {3.5686740475725393`*^9, 
   3.5686740736925755`*^9}, {3.5686741992477517`*^9, 3.568674207342763*^9}, {
   3.5686743702339907`*^9, 3.568674420479061*^9}, {3.5686746579543934`*^9, 
   3.5686746640944023`*^9}, {3.5686747825547867`*^9, 
   3.5686747836467886`*^9}, {3.568675093166932*^9, 3.5686751107637634`*^9}, {
   3.5686751638818564`*^9, 3.5686751860962954`*^9}, {3.5686752638780317`*^9, 
   3.5686752932372837`*^9}, 3.568676352200344*^9, {3.568676425036872*^9, 
   3.5686764268152747`*^9}, {3.5686765814583464`*^9, 
   3.5686765815051465`*^9}, {3.568676612564801*^9, 3.5686766292880306`*^9}, {
   3.5686768069879427`*^9, 3.568676807112743*^9}, {3.568676887780484*^9, 
   3.5686768878896847`*^9}, {3.5686769802106466`*^9, 
   3.5686770449975605`*^9}, {3.568677177254593*^9, 3.5686771780189943`*^9}, {
   3.5686772390463014`*^9, 3.5686772393739023`*^9}, {3.568677286049184*^9, 
   3.5686773642833214`*^9}, {3.568677400110385*^9, 3.568677400484785*^9}, {
   3.568677507665374*^9, 3.5686775082269745`*^9}, {3.5686775809855022`*^9, 
   3.568677667160054*^9}, {3.568677724162554*^9, 3.568677768326232*^9}, {
   3.5686784189103737`*^9, 3.5686784731984696`*^9}, {3.568678528562967*^9, 
   3.5686785340073767`*^9}, {3.568678600557093*^9, 3.5686786208995285`*^9}, {
   3.5686786550323887`*^9, 3.5686786624268017`*^9}, {3.568678748679353*^9, 
   3.5686787518617587`*^9}, {3.568678943851296*^9, 3.568678944178897*^9}, {
   3.568679095826763*^9, 3.5686790961543636`*^9}, 3.5687143742988043`*^9, {
   3.568718293597542*^9, 3.568718293925143*^9}, {3.568733412817721*^9, 
   3.568733427575347*^9}, {3.5687335444663525`*^9, 3.568733613090873*^9}, {
   3.568733746627107*^9, 3.5687337937547903`*^9}, {3.5687342807418456`*^9, 
   3.5687343666823964`*^9}, {3.5687344259001007`*^9, 
   3.5687344394877243`*^9}, {3.568734477239791*^9, 3.5687345461451116`*^9}, {
   3.5687345797823715`*^9, 3.568734589844389*^9}, {3.5687346756289396`*^9, 
   3.568734677563343*^9}, {3.568734894974286*^9, 3.568734922929535*^9}, {
   3.5687349655332103`*^9, 3.5687349764844294`*^9}, {3.568735012192892*^9, 
   3.56873502830772*^9}, {3.568735147273529*^9, 3.568735195914415*^9}, {
   3.568735337110263*^9, 3.568735339029066*^9}, {3.568735384331546*^9, 
   3.568735388949154*^9}, {3.5687354326448307`*^9, 3.5687354327852306`*^9}, {
   3.568735491519334*^9, 3.568735505184958*^9}, {3.5687364997865577`*^9, 
   3.568736499896558*^9}, {3.568743415518503*^9, 3.568743415643503*^9}, {
   3.568743713589615*^9, 3.5687437136364155`*^9}, {3.5687441249311376`*^9, 
   3.5687441349005547`*^9}, {3.5687456117645607`*^9, 3.568745675733219*^9}, {
   3.568745710904231*^9, 3.5687457803412027`*^9}, {3.568745836047389*^9, 
   3.5687458519833*^9}, {3.568746269593191*^9, 3.5687463055824547`*^9}, {
   3.568746362210554*^9, 3.5687463633961563`*^9}, {3.5687464472712975`*^9, 
   3.5687464474012976`*^9}, {3.568746524051405*^9, 3.5687465241114054`*^9}, {
   3.5687465874514937`*^9, 3.568746587516494*^9}, {3.5687466340115585`*^9, 
   3.5687466340965595`*^9}, {3.5687466830126286`*^9, 3.5687466830926285`*^9}, 
   3.5687467437727137`*^9, {3.568746883758145*^9, 3.5687468841949453`*^9}, {
   3.568746932711031*^9, 3.568746932867031*^9}, {3.5687483065115275`*^9, 
   3.5687483066051273`*^9}, {3.568748356905614*^9, 3.5687483570772142`*^9}, {
   3.5687484849978333`*^9, 3.5687484851070337`*^9}, {3.5687486793365183`*^9, 
   3.5687487039165525`*^9}, 3.5687487503066173`*^9, {3.5687487915866747`*^9, 
   3.568748868616783*^9}, 3.568748930046869*^9, {3.5687648297268953`*^9, 
   3.568764830431896*^9}, {3.5687651183353004`*^9, 3.5687651217753053`*^9}, {
   3.568765172395376*^9, 3.568765172775377*^9}, {3.5687652432954755`*^9, 
   3.5687652504354854`*^9}, {3.5687653239655886`*^9, 
   3.5687654154007163`*^9}, {3.5687654918858232`*^9, 3.568765522375866*^9}, {
   3.568765635131024*^9, 3.5687656600910587`*^9}, {3.5687657746762195`*^9, 
   3.568765779146226*^9}, {3.5687658126242733`*^9, 3.5687658187242823`*^9}, {
   3.5687659304504385`*^9, 3.5687659560604744`*^9}, {3.5687660151155567`*^9, 
   3.5687660156055574`*^9}, {3.5687660518306084`*^9, 3.56876608879066*^9}, {
   3.568766907469807*^9, 3.5687669171198206`*^9}, {3.5687669640798864`*^9, 
   3.5687669661198893`*^9}, {3.5687675173867655`*^9, 
   3.5687675633756466`*^9}, {3.568821997140112*^9, 3.568822020852154*^9}, {
   3.5688220594154215`*^9, 3.568822062551027*^9}, {3.568822107572706*^9, 
   3.568822116667522*^9}, {3.568822153592787*^9, 3.568822194090458*^9}, {
   3.5688227530290003`*^9, 3.5688227588010106`*^9}, {3.5688228373783484`*^9, 
   3.5688228857228336`*^9}, {3.5688229377967253`*^9, 
   3.5688229695895805`*^9}, {3.5688230020376377`*^9, 
   3.5688230069828463`*^9}, {3.56882307145776*^9, 3.568823184807559*^9}, {
   3.5688232887817416`*^9, 3.5688233510570507`*^9}, {3.568823574855044*^9, 
   3.5688235769298477`*^9}, {3.568823624853132*^9, 3.568823626522335*^9}, {
   3.568823907307228*^9, 3.568823937727281*^9}, {3.5688242497905293`*^9, 
   3.5688242498997297`*^9}, {3.5688249598546658`*^9, 3.568824963988673*^9}, {
   3.5688249955007286`*^9, 3.568824998527134*^9}, {3.568825583173684*^9, 
   3.5688256067765255`*^9}, {3.5688257669956055`*^9, 
   3.5688257915968485`*^9}, {3.5688265201971283`*^9, 3.568826526140739*^9}, {
   3.56882670801742*^9, 3.568826716082634*^9}, {3.5688267536163*^9, 
   3.568826758140308*^9}, {3.569760320370886*^9, 3.5697603635209465`*^9}}],

Cell[BoxData[
 RowBox[{"grgr", "=", 
  RowBox[{"GraphicsGrid", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{"{", 
       StyleBox[
        RowBox[{
         RowBox[{"PSDflux", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"PSDFmin", "[", 
            RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ","}], "*)"}], 
         RowBox[{"PSDFmax", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PSDflux", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PSDFrandmean", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}], ",", 
         RowBox[{"PSDfluxx", "[", 
          RowBox[{"typ", ",", "fr", ",", "th"}], "]"}]}],
        FontColor->RGBColor[0, 0, 1]], 
       StyleBox["}",
        FontColor->RGBColor[0, 0, 1]]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"typ", ",", "3", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.568765709706128*^9, 3.5687657570961947`*^9}, {
  3.568766150610747*^9, 3.5687661926308055`*^9}, {3.5687676090213265`*^9, 
  3.5687676147465367`*^9}, {3.5687677042756658`*^9, 3.5687677075856705`*^9}, {
  3.568826535828356*^9, 3.568826536140356*^9}, {3.5689450632113714`*^9, 
  3.5689450639601727`*^9}, {3.569760342775917*^9, 3.5697603450559206`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD QPOs\\\\!svn\\\
\\figures\\\\th238_periodograms.eps\>\"", ",", "grgr"}], "]"}]], "Input",
 CellChangeTimes->{{3.568945076252994*^9, 3.568945130244689*^9}, {
  3.568945182894781*^9, 3.568945205499221*^9}}],

Cell[BoxData[
 RowBox[{"2", "\[Sigma]"}]], "Input",
 CellChangeTimes->{{3.568826562566803*^9, 3.568826563112804*^9}}],

Cell[BoxData[
 RowBox[{"1", "\[Sigma]"}]], "Input",
 CellChangeTimes->{{3.568825796308057*^9, 3.5688257970256586`*^9}}],

Cell[BoxData[
 RowBox[{"CP", ";", 
  RowBox[{"fr", "\[Rule]", "3"}]}]], "Input",
 CellChangeTimes->{{3.5687485468063326`*^9, 3.568748549156336*^9}}],

Cell[BoxData[
 RowBox[{"CP", ";", 
  RowBox[{"fr", "\[Rule]", "6"}]}]], "Input",
 CellChangeTimes->{{3.5687484550925813`*^9, 3.5687484575573854`*^9}}],

Cell[BoxData[
 RowBox[{"CP", ";", 
  RowBox[{"fr", "\[Rule]", "9"}]}]], "Input",
 CellChangeTimes->{{3.5687483390123825`*^9, 3.5687483436611905`*^9}}],

Cell[BoxData[
 RowBox[{"EVPA", ";", 
  RowBox[{"fr", "\[Rule]", "9"}]}]], "Input",
 CellChangeTimes->{{3.5687470477144327`*^9, 3.5687470505224376`*^9}}],

Cell[BoxData[
 RowBox[{"EVPA", ";", 
  RowBox[{"fr", "\[Rule]", "6"}]}]], "Input",
 CellChangeTimes->{{3.5687469178910046`*^9, 3.5687469254102182`*^9}}],

Cell[BoxData[
 RowBox[{"EVPA", ";", 
  RowBox[{"fr", "\[Rule]", "3"}]}]], "Input",
 CellChangeTimes->{{3.568746875848931*^9, 3.5687468789377365`*^9}}],

Cell[BoxData[
 RowBox[{"flux", ";", 
  RowBox[{"fr", "\[Rule]", "3"}]}]], "Input",
 CellChangeTimes->{{3.5687466670126066`*^9, 3.5687466714526124`*^9}}],

Cell[BoxData[
 RowBox[{"flux", ";", 
  RowBox[{"fr", "\[Rule]", "6"}]}]], "Input",
 CellChangeTimes->{{3.5687466193915386`*^9, 3.5687466282915506`*^9}}],

Cell[BoxData[
 RowBox[{"flux", ";", 
  RowBox[{"fr", "\[Rule]", "9"}]}]], "Input",
 CellChangeTimes->{{3.568746580211484*^9, 3.5687465831514874`*^9}}],

Cell[BoxData[
 RowBox[{"LP", ";", 
  RowBox[{"fr", "\[Rule]", "9"}]}]], "Input",
 CellChangeTimes->{{3.56874649912637*^9, 3.5687465097363853`*^9}}],

Cell[BoxData[
 RowBox[{"LP", ",", 
  RowBox[{"fr", "\[Rule]", "6"}]}]], "Input",
 CellChangeTimes->{{3.568746400943822*^9, 3.5687464026754255`*^9}, {
  3.5687464392112865`*^9, 3.5687464393412867`*^9}}],

Cell[BoxData[
 RowBox[{"LP", ",", 
  RowBox[{"fr", "\[Rule]", "3"}]}]], "Input",
 CellChangeTimes->{{3.568746352476137*^9, 3.568746355408942*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"3", ",", "3.0", ",", "k"}], "]"}], ";", 
    RowBox[{
     RowBox[{"PSDfluxx", "[", "k", "]"}], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Red", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
         "}"}]}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"autovar", "[", 
      RowBox[{"3", ",", "1.2", ",", "k"}], "]"}], ";", 
     RowBox[{
      RowBox[{"PSDflux", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{"res", ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}],
           "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"4", ",", "3.0", ",", "k"}], "]"}], ";", 
    RowBox[{
     RowBox[{"PSDLPx", "[", "k", "]"}], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Red", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of LP\>\""}],
          "}"}]}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"4", ",", "1.2", ",", "k"}], "]"}], ";", 
    RowBox[{
     RowBox[{"PSDLP", "[", "k", "]"}], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Green", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of LP\>\""}],
          "}"}]}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"5", ",", "3.0", ",", "k"}], "]"}], ";", 
    RowBox[{
     RowBox[{"PSDEVPAx", "[", "k", "]"}], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Red", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of EVPA\>\""}], 
         "}"}]}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"5", ",", "1.2", ",", "k"}], "]"}], ";", 
    RowBox[{
     RowBox[{"PSDEVPA", "[", "k", "]"}], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Green", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of EVPA\>\""}], 
         "}"}]}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"6", ",", "3.0", ",", "k"}], "]"}], ";", 
    RowBox[{
     RowBox[{"PSDCPx", "[", "k", "]"}], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Red", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of CP\>\""}],
          "}"}]}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"6", ",", "1.2", ",", "k"}], "]"}], ";", 
    RowBox[{
     RowBox[{"PSDCP", "[", "k", "]"}], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Green", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of CP\>\""}],
          "}"}]}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"PSDfluxx", "[", "k", "]"}], ",", 
       RowBox[{"PSDflux", "[", "k", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"PSDLPx", "[", "k", "]"}], ",", 
       RowBox[{"PSDLP", "[", "k", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"PSDEVPAx", "[", "k", "]"}], ",", 
       RowBox[{"PSDEVPA", "[", "k", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"PSDCPx", "[", "k", "]"}], ",", 
       RowBox[{"PSDCP", "[", "k", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}]}],
   "}"}]}], "Input",
 CellChangeTimes->{{3.568507365546276*^9, 3.5685074426416116`*^9}, {
   3.568507653430182*^9, 3.568507670231412*^9}, {3.5685077026638684`*^9, 
   3.568507704130271*^9}, {3.568507891845401*^9, 3.5685078979138117`*^9}, {
   3.568507942171089*^9, 3.5685079423270893`*^9}, {3.5685080221836295`*^9, 
   3.568508059732896*^9}, {3.5685080947237573`*^9, 3.568508094817357*^9}, {
   3.568508125767812*^9, 3.5685081324290233`*^9}, 3.5685081823335114`*^9, {
   3.568631312035143*^9, 3.5686313451696005`*^9}, {3.5686313814396644`*^9, 
   3.5686313872116747`*^9}, {3.568631433060155*^9, 3.568631533181131*^9}, {
   3.5686316424816914`*^9, 3.568631704591778*^9}, {3.568631876516474*^9, 
   3.5686319424109893`*^9}, {3.5686320215655284`*^9, 
   3.5686321689867873`*^9}, {3.568632296891412*^9, 3.568632362817128*^9}, {
   3.5686324452008724`*^9, 3.568632447057276*^9}, {3.5686325368198338`*^9, 
   3.568632562544279*^9}, {3.5686439250096717`*^9, 3.568643926023673*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"typ", "=", "5"}], ";", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"binned", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ll", "=", 
        RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
       RowBox[{"me", "=", 
        RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"autovariance", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{"1", ";;", 
                 RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], 
             ")"}], ".", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
              "me"}], ")"}]}], "ll"], ",", 
          RowBox[{"{", 
           RowBox[{"shi", ",", "0", ",", 
            RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"f11", "=", 
        RowBox[{"FourierDCT", "[", 
         RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
       RowBox[{"num", "=", 
        RowBox[{"Floor", "[", 
         FractionBox["ll", "2"], "]"}]}], ";", 
       RowBox[{"sur", "=", 
        RowBox[{
         FractionBox[
          SqrtBox[
           RowBox[{"2", "ll"}]], 
          RowBox[{"2", "\[Pi]"}]], 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{"f11", ",", "2"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sur", ",", 
         RowBox[{"sur", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"timex", "=", 
        RowBox[{"4.", 
         RowBox[{"ll", "/", 
          RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
       RowBox[{"mint", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
       RowBox[{"maxt", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", 
       RowBox[{"mult", "=", "1.3"}], ";", 
       RowBox[{"nn", "=", 
        RowBox[{
         RowBox[{"Log", "[", 
          FractionBox["maxt", "mint"], "]"}], "/", 
         RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"tsides", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"mint", " ", 
           SuperscriptBox["mult", "i"]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tbins", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"tsides", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"tsides", "[", 
             RowBox[{"[", 
              RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tsizes", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tmeans", "=", 
        RowBox[{"Mean", "[", 
         RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"intergra", "=", 
        RowBox[{"Interpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"timex", ",", 
              RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"pergra", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"NIntegrate", "[", 
           RowBox[{
            RowBox[{"Exp", "[", 
             RowBox[{"intergra", "[", 
              RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"tx", ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
            RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
            RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
       RowBox[{
        RowBox[{"PSDEVPA", "[", "k", "]"}], "=", 
        RowBox[{"ListLogLogPlot", "[", 
         RowBox[{
          RowBox[{"Select", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"tmeans", ",", 
               FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}], 
          ",", 
          RowBox[{"Joined", "\[Rule]", "True"}], ",", 
          RowBox[{"PlotStyle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Green", ",", 
             RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
          RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
          RowBox[{"Frame", "\[Rule]", "True"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
          RowBox[{"FrameStyle", "\[Rule]", 
           RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
          RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
          RowBox[{"FrameLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of EVPA\>\""}], 
            "}"}]}]}], "]"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"typ", "=", "6"}], ";", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"binned", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ll", "=", 
        RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
       RowBox[{"me", "=", 
        RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"autovariance", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{"1", ";;", 
                 RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], 
             ")"}], ".", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
              "me"}], ")"}]}], "ll"], ",", 
          RowBox[{"{", 
           RowBox[{"shi", ",", "0", ",", 
            RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"f11", "=", 
        RowBox[{"FourierDCT", "[", 
         RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
       RowBox[{"num", "=", 
        RowBox[{"Floor", "[", 
         FractionBox["ll", "2"], "]"}]}], ";", 
       RowBox[{"sur", "=", 
        RowBox[{
         FractionBox[
          SqrtBox[
           RowBox[{"2", "ll"}]], 
          RowBox[{"2", "\[Pi]"}]], 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{"f11", ",", "2"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sur", ",", 
         RowBox[{"sur", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"timex", "=", 
        RowBox[{"4.", 
         RowBox[{"ll", "/", 
          RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
       RowBox[{"mint", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
       RowBox[{"maxt", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", 
       RowBox[{"mult", "=", "1.3"}], ";", 
       RowBox[{"nn", "=", 
        RowBox[{
         RowBox[{"Log", "[", 
          FractionBox["maxt", "mint"], "]"}], "/", 
         RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"tsides", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"mint", " ", 
           SuperscriptBox["mult", "i"]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tbins", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"tsides", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"tsides", "[", 
             RowBox[{"[", 
              RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tsizes", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tmeans", "=", 
        RowBox[{"Mean", "[", 
         RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"intergra", "=", 
        RowBox[{"Interpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"timex", ",", 
              RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"pergra", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"NIntegrate", "[", 
           RowBox[{
            RowBox[{"Exp", "[", 
             RowBox[{"intergra", "[", 
              RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"tx", ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
            RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
            RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
       RowBox[{
        RowBox[{"PSDCP", "[", "k", "]"}], "=", 
        RowBox[{"ListLogLogPlot", "[", 
         RowBox[{
          RowBox[{"Select", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"tmeans", ",", 
               FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}], 
          ",", 
          RowBox[{"Joined", "\[Rule]", "True"}], ",", 
          RowBox[{"PlotStyle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Green", ",", 
             RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
          RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
          RowBox[{"Frame", "\[Rule]", "True"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
          RowBox[{"FrameStyle", "\[Rule]", 
           RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
          RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
          RowBox[{"FrameLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of CP\>\""}], 
            "}"}]}]}], "]"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
     "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5485960291688566`*^9, 3.5485960793437266`*^9}, {
   3.5485961723110437`*^9, 3.548596172431051*^9}, {3.548596217990657*^9, 
   3.548596419205166*^9}, {3.5485964747953453`*^9, 3.548596666441307*^9}, {
   3.548596789027318*^9, 3.548596791313449*^9}, {3.54859689729051*^9, 
   3.5485968982145634`*^9}, {3.5485970754817023`*^9, 
   3.5485970810720224`*^9}, {3.548601094181363*^9, 3.548601141526071*^9}, {
   3.548601228014018*^9, 3.5486012455100183`*^9}, {3.5486015052638755`*^9, 
   3.548601513522348*^9}, {3.5486021619624367`*^9, 3.548602208246084*^9}, {
   3.548603191013295*^9, 3.548603202408947*^9}, {3.548603360132968*^9, 
   3.5486034378874154`*^9}, {3.5486037657511683`*^9, 
   3.5486037953368607`*^9}, {3.557735613195719*^9, 3.5577356251141396`*^9}, {
   3.558833419924079*^9, 3.55883343620601*^9}, {3.5588334863698792`*^9, 
   3.558833498806591*^9}, {3.5685071443690877`*^9, 3.568507150811899*^9}, 
   3.56850747579167*^9, {3.568507920471451*^9, 3.5685079254010596`*^9}, {
   3.5685081572330666`*^9, 3.5685081615698743`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDflux", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDLP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDCP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}]}],
   "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5486022164095507`*^9, 3.5486022274141808`*^9}, {
   3.548603444138773*^9, 3.54860345773155*^9}, {3.54860351210266*^9, 
   3.5486035139077635`*^9}, {3.55773962159896*^9, 3.557739623002962*^9}, {
   3.5588327715569944`*^9, 3.55883291345411*^9}, {3.56087287944968*^9, 
   3.5608728801828814`*^9}, {3.568508205000351*^9, 3.5685082241571846`*^9}, 
   3.56850835245181*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"#", ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Blue", ",", 
         RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"ListPlot", ",", "ListLogLogPlot"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"lmax", "=", 
        RowBox[{"Quotient", "[", 
         RowBox[{"l", ",", "2"}], "]"}]}], ";"}], "*)"}], 
     RowBox[{"lmax", "=", "150"}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"4", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveF", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<Flux, Jy\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveLP", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<LP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveEVPA", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<EVPA angle, deg\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveCP", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<CP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGCQAGIQrbT3gKBm3ivHHGcHERA9UWO5JIgOCpqtBKKNCk00
QTSDGJMWiL7kuVgfRJfNvGUEone6VdiA5dd6BYHo5rnPwkB0S8arXBB9Suda
MYjWaJesAdFsRT98tYG0WtkvMN1/5eAuW5D4lotgen7u9wuuQHrW/t9g+gjj
8/sgWuvu6ccg2jRt7TsQPXXa/o8get+dt5xuQPoW+1cw/Y9n5oMMIP0nxf8x
iGb7tOAziN5luQhMn+OszHzfDHRP97tcEO3nx1gMogVUP9eB6PN8N5tAdPiz
ra0gOuP1r24QbWeT0weiV7yasgNE35jZdgBEn1y08iKIrtFYchVEbzq3OOf5
lFeO3RnaRSC6Yofji+RprxxF10/6CKLXcSd9A9EqJRd4UoA0AHSfya8=
  "]],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"nums", ",", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1", ",", "12"}], "]"}], "]"}]}], "}"}], "]"}], 
   ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.568509597296516*^9, 3.568509631398176*^9}, {
  3.5685096636278324`*^9, 3.568509678619459*^9}}],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDflux", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDLP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDEVPA", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDCP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveF", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveLP", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveEVPA", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveCP", "[", "k", "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5588336899835253`*^9, 3.558833763719743*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fr", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "[", 
  RowBox[{"[", "fr", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{
    SuperscriptBox["10", "7"], 
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "fr", ",", "12"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5474244310872493`*^9, 3.5474244563596945`*^9}, {
   3.5474244888795547`*^9, 3.547424515096054*^9}, {3.5474245485119658`*^9, 
   3.547424574191434*^9}, {3.5475470934034843`*^9, 3.5475470957396173`*^9}, 
   3.547547753886261*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Testing temporal analysis", "Subsection",
 CellChangeTimes->{{3.568732426167182*^9, 3.5687324345131965`*^9}}],

Cell[BoxData["lpl5"], "Input",
 CellChangeTimes->{{3.568676122847741*^9, 3.568676127683749*^9}, {
  3.5686761635950127`*^9, 3.5686761639694133`*^9}}],

Cell[BoxData[{
 RowBox[{"AbsoluteTiming", "[", 
  RowBox[{
   RowBox[{"randx", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"RandomVariate", "[", 
       RowBox[{
        RowBox[{"NormalDistribution", "[", "]"}], ",", "5000"}], "]"}], 
      SqrtBox[
       RowBox[{"Exp", "[", 
        RowBox[{"interand", "[", 
         RowBox[{"Log", "[", 
          RowBox[{"20000", "/", 
           RowBox[{"Range", "[", "5000", "]"}]}], "]"}], "]"}], "]"}]]}], "+", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"RandomVariate", "[", 
       RowBox[{
        RowBox[{"NormalDistribution", "[", "]"}], ",", "5000"}], "]"}], 
      SqrtBox[
       RowBox[{"Exp", "[", 
        RowBox[{"interand", "[", 
         RowBox[{"Log", "[", 
          RowBox[{"20000", "/", 
           RowBox[{"Range", "[", "5000", "]"}]}], "]"}], "]"}], "]"}]]}]}]}], 
   ";"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AbsoluteTiming", "[", 
   RowBox[{
    RowBox[{"rsxx", "=", 
     RowBox[{"4.8", 
      RowBox[{"(*", 
       FractionBox[
        RowBox[{"2", "\[Pi]"}], 
        SqrtBox["2"]], "*)"}], 
      RowBox[{"Re", "[", 
       RowBox[{"InverseFourier", "[", "randx", "]"}], "]"}]}]}], ";", 
    RowBox[{"rseq", "=", "rsxx"}], 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"+", "me"}], ";"}], 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"-", "for"}], " ", "formal", " ", "correspondence"}], "*)"}], 
     "*)"}], ";"}], "]"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"AbsoluteTiming", "[", 
    RowBox[{
     RowBox[{"autorand", "[", 
      RowBox[{"3", ",", "1.2", ",", "6"}], "]"}], ";"}], "]"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AbsoluteTiming", "[", 
   RowBox[{
    RowBox[{"f11", "=", 
     RowBox[{"FourierDCT", "[", 
      RowBox[{"autovariance", ",", "1"}], "]"}]}], ";"}], "]"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"AbsoluteTiming", "[", 
    RowBox[{"pergra", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"intergra", "[", 
           RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
        RowBox[{"tsizes", "[", 
         RowBox[{"[", "i", "]"}], "]"}]], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "nn"}], "}"}]}], "]"}]}], "]"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AbsoluteTiming", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"sel", "=", 
       RowBox[{"Select", "[", 
        RowBox[{"timex", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}], "<", "#", "<", 
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "&"}]}], "]"}]}], ";", 
      RowBox[{"inttime", "=", 
       RowBox[{"Reverse", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], ",", "sel", ",", 
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}]}], "}"}], "]"}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"intxx", "=", 
       RowBox[{
        RowBox[{"intergra", "[", 
         RowBox[{"Log", "[", "tx", "]"}], "]"}], "/.", 
        RowBox[{"tx", "\[Rule]", "inttime"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"deltax", "=", 
       RowBox[{"Differences", "[", "inttime", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       FractionBox["0.5", 
        RowBox[{"tsizes", "[", 
         RowBox[{"[", "i", "]"}], "]"}]], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"intxx", "[", 
           RowBox[{"[", 
            RowBox[{"1", ";;", 
             RowBox[{"-", "2"}]}], "]"}], "]"}], "+", 
          RowBox[{"intxx", "[", 
           RowBox[{"[", 
            RowBox[{"2", ";;", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}], ")"}], ".", "deltax"}]}]}],
      "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"intxx", "[", 
              RowBox[{"[", "kk", "]"}], "]"}], "+", 
             RowBox[{"intxx", "[", 
              RowBox[{"[", 
               RowBox[{"kk", "+", "1"}], "]"}], "]"}]}], ")"}], "2"], 
          RowBox[{"deltax", "[", 
           RowBox[{"[", "kk", "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"kk", ",", 
           RowBox[{
            RowBox[{"Length", "[", "inttime", "]"}], "-", "1"}]}], "}"}]}], 
        "]"}], "/", 
       RowBox[{"tsizes", "[", 
        RowBox[{"[", "i", "]"}], "]"}]}], "*)"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "nn"}], "}"}]}], "]"}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"AbsoluteTiming", "[", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"in1", "=", 
      RowBox[{
       RowBox[{"intergra", "[", 
        RowBox[{"Log", "[", "tx", "]"}], "]"}], "/.", 
       RowBox[{"tx", "\[Rule]", 
        RowBox[{"tbins", "[", 
         RowBox[{"[", 
          RowBox[{"i", ",", "1"}], "]"}], "]"}]}]}]}], ";", 
     RowBox[{"in2", "=", 
      RowBox[{
       RowBox[{"intergra", "[", 
        RowBox[{"Log", "[", "tx", "]"}], "]"}], "/.", 
       RowBox[{"tx", "\[Rule]", 
        RowBox[{"tbins", "[", 
         RowBox[{"[", 
          RowBox[{"i", ",", "2"}], "]"}], "]"}]}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"rev", "=", 
      RowBox[{"Reverse", "[", 
       RowBox[{"Select", "[", 
        RowBox[{"tra", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}], "<", 
           RowBox[{"#", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "<", 
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "&"}]}], "]"}], "]"}]}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"inttime", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"rev", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intxx", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"{", 
        RowBox[{"in1", ",", 
         RowBox[{"Log", "[", 
          RowBox[{"rev", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}], ",", "in2"}], 
        "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"deltax", "=", 
      RowBox[{"Differences", "[", "inttime", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"intxx", "[", 
              RowBox[{"[", "kk", "]"}], "]"}], "+", 
             RowBox[{"intxx", "[", 
              RowBox[{"[", 
               RowBox[{"kk", "+", "1"}], "]"}], "]"}]}], ")"}], "2"], 
          RowBox[{"deltax", "[", 
           RowBox[{"[", "kk", "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"kk", ",", 
           RowBox[{
            RowBox[{"Length", "[", "inttime", "]"}], "-", "1"}]}], "}"}]}], 
        "]"}], "/", 
       RowBox[{"tsizes", "[", 
        RowBox[{"[", "i", "]"}], "]"}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      FractionBox["0.5", 
       RowBox[{"tsizes", "[", 
        RowBox[{"[", "i", "]"}], "]"}]], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"intxx", "[", 
          RowBox[{"[", 
           RowBox[{"1", ";;", 
            RowBox[{"-", "2"}]}], "]"}], "]"}], "+", 
         RowBox[{"intxx", "[", 
          RowBox[{"[", 
           RowBox[{"2", ";;", 
            RowBox[{"-", "1"}]}], "]"}], "]"}]}], ")"}], ".", "deltax"}]}]}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "nn"}], "}"}]}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5687143474577665`*^9, 3.568714396379636*^9}, {
  3.5687147380513525`*^9, 3.5687147619817944`*^9}, {3.5687147922146473`*^9, 
  3.5687148389055295`*^9}, {3.5687163620665717`*^9, 3.5687163977166214`*^9}, {
  3.568716583989539*^9, 3.568716610400386*^9}, {3.568716669196889*^9, 
  3.56871674959943*^9}, {3.5687169415109673`*^9, 3.568716941947768*^9}, {
  3.568717198895819*^9, 3.568717256600321*^9}, {3.5687178284983253`*^9, 
  3.568717978476989*^9}, {3.56871805898873*^9, 3.5687180968655963`*^9}, {
  3.568731914724986*^9, 3.5687319152709875`*^9}, {3.5687320881102777`*^9, 
  3.5687321287153344`*^9}, {3.5687321631303825`*^9, 3.568732217120458*^9}}],

Cell[BoxData[{
 RowBox[{"Length", "[", "intxx", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "[", "deltax", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox["0.5", 
   RowBox[{"tsizes", "[", 
    RowBox[{"[", "20", "]"}], "]"}]], 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"intxx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ";;", 
        RowBox[{"-", "2"}]}], "]"}], "]"}], "+", 
     RowBox[{"intxx", "[", 
      RowBox[{"[", 
       RowBox[{"2", ";;", 
        RowBox[{"-", "1"}]}], "]"}], "]"}]}], ")"}], ".", 
   "deltax"}]}]}], "Input",
 CellChangeTimes->{{3.5687319079077744`*^9, 3.568731921932199*^9}, {
  3.568731975565093*^9, 3.5687320265615826`*^9}, {3.5687320931802845`*^9, 
  3.568732094210286*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Timmer", " ", "&"}], " ", "Konig", " ", 
    RowBox[{"(", "1995", ")"}]}], "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"autocovar", "[", 
      RowBox[{"ty_", ",", "mu_", ",", "kf_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"typ", "=", "ty"}], ";", 
        RowBox[{"mult", "=", "mu"}], ";", 
        RowBox[{"k", "=", "kf"}], ";", 
        RowBox[{"binned", "=", 
         RowBox[{"imp", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
        RowBox[{"ll", "=", 
         RowBox[{"Length", "[", "binned", "]"}]}], ";", 
        RowBox[{"me", "=", 
         RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"autocovariance", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{"1", ";;", 
                 RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], ")"}], ".", 
             RowBox[{"(", 
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], 
              ")"}]}], "ll"], ",", 
           RowBox[{"{", 
            RowBox[{"shi", ",", "0", ",", 
             RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"f11", "=", 
         RowBox[{"FourierDCT", "[", 
          RowBox[{"autocovariance", ",", "1"}], "]"}]}], ";", 
        RowBox[{"num", "=", 
         RowBox[{"Floor", "[", 
          FractionBox["ll", "2"], "]"}]}], ";", 
        RowBox[{"sur", "=", 
         RowBox[{
          FractionBox[
           SqrtBox[
            RowBox[{"2", "ll"}]], 
           RowBox[{"2", "\[Pi]"}]], 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{"f11", ",", "2"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"sur", ",", 
          RowBox[{"sur", "[", 
           RowBox[{"[", 
            RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"timex", "=", 
         RowBox[{"4.", 
          RowBox[{"ll", "/", 
           RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
        RowBox[{"mint", "=", 
         RowBox[{"timex", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
        RowBox[{"maxt", "=", 
         RowBox[{"timex", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", 
        RowBox[{"nn", "=", 
         RowBox[{
          RowBox[{"Log", "[", 
           FractionBox["maxt", "mint"], "]"}], "/", 
          RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"tsides", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"mint", " ", 
            SuperscriptBox["mult", "i"]}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"tbins", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"tsides", "[", 
              RowBox[{"[", "i", "]"}], "]"}], ",", 
             RowBox[{"tsides", "[", 
              RowBox[{"[", 
               RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"tsizes", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"tmeans", "=", 
         RowBox[{"Mean", "[", 
          RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"intergra", "=", 
         RowBox[{"Interpolation", "[", 
          RowBox[{
           RowBox[{"Log", "[", 
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"timex", ",", 
               RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
           RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pergra", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           FractionBox[
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{"intergra", "[", 
               RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"tx", ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
              RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
              RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
            RowBox[{"tsizes", "[", 
             RowBox[{"[", "i", "]"}], "]"}]], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        RowBox[{"res", "=", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"tmeans", ",", 
              RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
          "]"}]}]}], ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"four", "[", 
      RowBox[{"ty_", ",", "mu_", ",", "kf_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"typ", "=", "ty"}], ";", 
        RowBox[{"mult", "=", "mu"}], ";", 
        RowBox[{"k", "=", "kf"}], ";", 
        RowBox[{"binned", "=", 
         RowBox[{"imp", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
        RowBox[{"ll", "=", 
         RowBox[{"Length", "[", "binned", "]"}]}], ";", 
        RowBox[{"me", "=", 
         RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"fyy", "=", 
         SuperscriptBox[
          RowBox[{"Abs", "[", 
           RowBox[{"Fourier", "[", 
            RowBox[{"binned", ",", 
             RowBox[{"FourierParameters", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], "]"}], "2"]}], ";", 
        RowBox[{"timer", "=", 
         RowBox[{"20000.", "/", 
          RowBox[{"Range", "[", "5000", "]"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"intergray", "=", 
         RowBox[{"Interpolation", "[", 
          RowBox[{
           RowBox[{"Log", "[", 
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"timer", ",", "fyy"}], "}"}], "]"}], "]"}], ",", 
           RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"num", "=", "ll"}], ";", 
        RowBox[{"timex", "=", 
         RowBox[{"4.", 
          RowBox[{"ll", "/", 
           RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
        RowBox[{"mint", "=", 
         RowBox[{"timer", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
        RowBox[{"maxt", "=", 
         RowBox[{"timer", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", 
        RowBox[{"nn", "=", 
         RowBox[{
          RowBox[{"Log", "[", 
           FractionBox["maxt", "mint"], "]"}], "/", 
          RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"tsides", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"mint", " ", 
            SuperscriptBox["mult", "i"]}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"tbins", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"tsides", "[", 
              RowBox[{"[", "i", "]"}], "]"}], ",", 
             RowBox[{"tsides", "[", 
              RowBox[{"[", 
               RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"tsizes", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"tmeans", "=", 
         RowBox[{"Mean", "[", 
          RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pergray", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             FractionBox[
              RowBox[{"intergray", "[", 
               RowBox[{"Log", "[", "tx", "]"}], "]"}], 
              RowBox[{"tsizes", "[", 
               RowBox[{"[", "i", "]"}], "]"}]], ",", 
             RowBox[{"{", 
              RowBox[{"tx", ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
             RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
             RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"res", "=", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"tmeans", ",", 
            RowBox[{"Exp", "[", "pergray", "]"}]}], "}"}], "]"}]}], ";", 
        RowBox[{"resf", "=", "res"}]}], ")"}], "//", "Quiet"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"autocovar", "[", 
      RowBox[{"3", ",", "1.2", ",", "6"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"lpl4", "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{"res", ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Red", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{
        "PlotLabel", "\[Rule]", "\"\<FourierDCT of autovariance\>\""}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tofit4", "=", 
      RowBox[{
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"A", " ", 
          RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
       RowBox[{"FindFit", "[", 
        RowBox[{
         RowBox[{"Log", "[", "res", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"logpl4", "=", 
      RowBox[{"LogLogPlot", "[", 
       RowBox[{"tofit4", ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", 
          RowBox[{"res", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"res", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Red", ",", 
           RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}],
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"four", "[", 
      RowBox[{"3", ",", "1.2", ",", "6"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"lpl5", "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{"res", ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Red", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{
        "PlotLabel", "\[Rule]", "\"\<FourierDCT of autovariance\>\""}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tofit4", "=", 
      RowBox[{
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"A", " ", 
          RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
       RowBox[{"FindFit", "[", 
        RowBox[{
         RowBox[{"Log", "[", "res", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"logpl4", "=", 
      RowBox[{"LogLogPlot", "[", 
       RowBox[{"tofit4", ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", 
          RowBox[{"res", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"res", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Red", ",", 
           RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}],
      ";"}], "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.5687329365261354`*^9, 3.5687329423761435`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fxx", "=", 
   RowBox[{"Re", "[", 
    RowBox[{"Fourier", "[", "autovariance", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fyy", "=", 
   SuperscriptBox[
    RowBox[{"Abs", "[", 
     RowBox[{"Fourier", "[", 
      RowBox[{"binned", ",", 
       RowBox[{"FourierParameters", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], "]"}], "2"]}], ";", 
  RowBox[{"timer", "=", 
   RowBox[{"20000.", "/", 
    RowBox[{"Range", "[", "5000", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"intergray", "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"timer", ",", "fyy"}], "}"}], "]"}], "]"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pergray", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"intergray", "[", 
          RowBox[{"Log", "[", "tx", "]"}], "]"}], 
         RowBox[{"tsizes", "[", 
          RowBox[{"[", "i", "]"}], "]"}]], ",", 
        RowBox[{"{", 
         RowBox[{"tx", ",", 
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
        RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"intergrax", "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"timer", ",", "fxx"}], "}"}], "]"}], "]"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pergrax", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"intergrax", "[", 
          RowBox[{"Log", "[", "tx", "]"}], "]"}], 
         RowBox[{"tsizes", "[", 
          RowBox[{"[", "i", "]"}], "]"}]], ",", 
        RowBox[{"{", 
         RowBox[{"tx", ",", 
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
        RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"datt", "=", 
      RowBox[{"Select", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           RowBox[{"Exp", "[", "pergray", "]"}]}], "}"}], "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}]}], 
     ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Green", ",", 
        RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
     RowBox[{"PlotLabel", "\[Rule]", "\"\<Fourier transform of data\>\""}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"tmeans", ",", 
          RowBox[{"0.01", 
           RowBox[{"Exp", "[", "pergrax", "]"}]}]}], "}"}], "]"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
     RowBox[{"PlotLabel", "\[Rule]", "\"\<Fourier of autocovariance\>\""}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Show", "[", 
   RowBox[{"lpl1", ",", "lpl2"}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"no", " ", "difference"}], " ", "\[Implies]", " ", 
    RowBox[{
    "will", " ", "be", " ", "using", " ", "the", " ", "power", " ", 
     "spectrum"}]}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5686455591031036`*^9, 3.568645583657547*^9}, {
   3.5686456419548492`*^9, 3.5686456422512493`*^9}, {3.5686457979863234`*^9, 
   3.568645808656742*^9}, {3.568646114417279*^9, 3.568646187753008*^9}, 
   3.5686464398338504`*^9, {3.5686465174761868`*^9, 3.5686465251826005`*^9}, {
   3.568646571639482*^9, 3.5686466756136646`*^9}, {3.5686467270001545`*^9, 
   3.5686468437663603`*^9}, {3.568647221508585*^9, 3.568647314359948*^9}, {
   3.5686476440059166`*^9, 3.568647689370796*^9}, {3.56864859668839*^9, 
   3.5686486449236746`*^9}, {3.568648716886601*^9, 3.5686487175418024`*^9}, {
   3.5686499962252593`*^9, 3.5686500124336877`*^9}, 3.5686500765498004`*^9, {
   3.56865131732578*^9, 3.5686514254183693`*^9}, {3.568651483590872*^9, 
   3.568651487709279*^9}, {3.5686515711538258`*^9, 3.5686515821206446`*^9}, {
   3.568652360563012*^9, 3.5686523608126125`*^9}, 3.5686756426476974`*^9, {
   3.568675681476166*^9, 3.568675694143388*^9}, 3.5686757365130625`*^9}],

Cell[BoxData["Re"], "Input",
 CellChangeTimes->{{3.568675690758182*^9, 3.5686756918345838`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"tofit", "=", 
  RowBox[{
   RowBox[{"Exp", "[", 
    RowBox[{
     RowBox[{"A", " ", 
      RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
   RowBox[{"FindFit", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"#", ",", 
         RowBox[{
          RowBox[{"Interpolation", "[", 
           RowBox[{
            RowBox[{"Log", "[", "datt", "]"}], ",", 
            RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}], "[", "#",
           "]"}]}], "}"}], "&"}], "/@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Log", "[", "25.", "]"}], ",", 
        RowBox[{"Log", "[", "50.", "]"}], ",", 
        RowBox[{"Log", "[", "200.", "]"}], ",", 
        RowBox[{"Log", "[", "400.", "]"}]}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"tofit2", "=", 
  RowBox[{
   RowBox[{"Exp", "[", 
    RowBox[{
     RowBox[{"A", " ", 
      RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
   RowBox[{"FindFit", "[", 
    RowBox[{
     RowBox[{"Log", "[", "datt", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"logpl", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{"tofit", ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"datt", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
       RowBox[{"datt", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"logpl2", "=", 
    RowBox[{"LogLogPlot", "[", 
     RowBox[{"tofit2", ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"datt", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
        RowBox[{"datt", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Red", ",", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"logpl3", "=", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{"tofit3", ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"datt", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"datt", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Black", ",", 
          RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
    ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"lpl1", ",", "logpl", ",", "logpl2"}], 
  RowBox[{"(*", 
   RowBox[{",", "logpl3"}], "*)"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5686487200534067`*^9, 3.5686489711358476`*^9}, {
   3.5686490052531075`*^9, 3.5686491231269145`*^9}, {3.568649211671461*^9, 
   3.5686492984076138`*^9}, {3.5686496112165833`*^9, 3.568649665754279*^9}, 
   3.568650273406546*^9, {3.5686504161183968`*^9, 3.56865042362201*^9}, {
   3.568654217670722*^9, 3.568654219805725*^9}, 3.5687326714117627`*^9}],

Cell[BoxData[
 RowBox[{"3.718630506967869`*^-7", " ", 
  SuperscriptBox["x", "1.8301508317880715`"]}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.5686502064044285`*^9, 3.5686502742957478`*^9, 
  3.568650424074411*^9, 3.5687326714117627`*^9}],

Cell[BoxData[
 RowBox[{"2.7876189265529605`*^-7", " ", 
  SuperscriptBox["x", "1.9316261569492335`"]}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.5686502064044285`*^9, 3.5686502742957478`*^9, 
  3.5686504240900106`*^9, 3.568732671416763*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"tbins", "[", 
  RowBox[{"[", "40", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"timex", "[", 
  RowBox[{"[", 
   RowBox[{"1", ";;", "20"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.568726863838169*^9, 3.5687268822150016`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"num", "\[Rule]", "20"}], ";", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"2", "\[Pi]"}], 
     SqrtBox["2"]], 
    RowBox[{"(", 
     RowBox[{"loglogfit", "  ", "to", "  ", "autocovariance"}], ")"}]}], " ", 
   "-", " ", 
   RowBox[{"poor", " ", "performance"}]}]}]], "Input",
 CellChangeTimes->{{3.5686753364035597`*^9, 3.568675372018422*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"num", "\[Rule]", "10"}], ";", 
  RowBox[{
   FractionBox[
    RowBox[{"2", "\[Pi]"}], 
    SqrtBox["2"]], "x", 
   SqrtBox["autovariance"]}]}]], "Input",
 CellChangeTimes->{{3.5686748376540833`*^9, 3.568674841741291*^9}}],

Cell[BoxData["4.44"], "Input",
 CellChangeTimes->{{3.568674450159103*^9, 3.568674450564103*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"num", "\[Rule]", "10"}], ";", 
  RowBox[{"4.7", "x", 
   SqrtBox["autovariance"]}]}]], "Input",
 CellChangeTimes->{{3.568674131197656*^9, 3.5686741420626717`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"nux", "\[Rule]", "100"}], ";", 
  RowBox[{"4.7", "x", 
   SqrtBox["autovariance"]}]}]], "Input",
 CellChangeTimes->{{3.568673850627263*^9, 3.5686738599722767`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"nux", "\[Rule]", "20"}], ";", " ", 
  RowBox[{"4.7", "x", " ", 
   SqrtBox["autovariance"]}]}]], "Input",
 CellChangeTimes->{{3.5686735157203927`*^9, 3.568673518980397*^9}, {
  3.5686735861468935`*^9, 3.5686736234569454`*^9}}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"intergra", "[", 
    RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"tx", ",", 
     RowBox[{"tbins", "[", 
      RowBox[{"[", 
       RowBox[{"20", ",", "1"}], "]"}], "]"}], ",", 
     RowBox[{"tbins", "[", 
      RowBox[{"[", 
       RowBox[{"20", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5687148652383757`*^9, 3.5687149090120525`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["lightcurve th=296 (no B cut, no B red, thlimit=0.1)", "Subsection",
 CellChangeTimes->{{3.5577510472865367`*^9, 3.55775104944654*^9}, {
  3.55883260748061*^9, 3.558832631388977*^9}, {3.560872675917722*^9, 
  3.56087270326457*^9}, {3.5610765919205837`*^9, 3.5610766169586277`*^9}, {
  3.567729128601217*^9, 3.5677291508874917`*^9}, {3.5685060616481857`*^9, 
  3.5685060618041863`*^9}, {3.568506336458269*^9, 3.5685063368950696`*^9}, {
  3.568629937666959*^9, 3.5686299402097635`*^9}, {3.5686333883639293`*^9, 
  3.56863338881633*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dir0", "=", 
   "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\th296lo\\\\\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fil", "=", 
   RowBox[{"dir0", "<>", "\"\<totspec.dat\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"coe", "=", "1"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"imp", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Import", "[", 
        RowBox[{"dir0", "<>", "\"\<poliresa93.75th296fn\>\"", "<>", 
         RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"fnum", ",", "2000", ",", "6999", ",", "coe"}], "}"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Put", "[", 
     RowBox[{"imp", ",", "fil"}], "]"}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Get", "[", "fil", "]"}]}], ";", 
  RowBox[{"Dimensions", "[", "imp", "]"}]}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, 
   3.5486008696865225`*^9, {3.548600915220127*^9, 3.548600929823962*^9}, {
   3.551033749980384*^9, 3.551033750871435*^9}, {3.5510337885625906`*^9, 
   3.5510337966150513`*^9}, {3.5520186449336777`*^9, 3.552018650318986*^9}, {
   3.55771381499922*^9, 3.557713848242878*^9}, {3.557714021184782*^9, 
   3.5577140212159815`*^9}, {3.557735285968544*^9, 3.557735286467745*^9}, {
   3.557735457912046*^9, 3.5577354872556973`*^9}, {3.5577395741124763`*^9, 
   3.5577395758284793`*^9}, {3.557855418955073*^9, 3.5578554191790857`*^9}, {
   3.5588325820031524`*^9, 3.5588325935978155`*^9}, {3.560872762763075*^9, 
   3.560872763870677*^9}, {3.5608728196547747`*^9, 3.560872849887628*^9}, {
   3.56087349695055*^9, 3.560873499446555*^9}, {3.560875165560282*^9, 
   3.560875166028283*^9}, {3.5608801039683924`*^9, 3.560880104514393*^9}, {
   3.5609031767900453`*^9, 3.5609031777421*^9}, {3.561076765174488*^9, 
   3.5610767680448933`*^9}, {3.5677291589449525`*^9, 3.567729159049958*^9}, {
   3.5677293582233505`*^9, 3.567729413559516*^9}, {3.5677295667262764`*^9, 
   3.567729571199532*^9}, {3.5685064387632484`*^9, 3.5685064673268986`*^9}, {
   3.5685068316977386`*^9, 3.568506890634642*^9}, {3.5686300345415297`*^9, 
   3.568630049579956*^9}, {3.568630216312004*^9, 3.5686302181120067`*^9}, {
   3.5686333939175386`*^9, 3.5686334019827533`*^9}, {3.568633626174114*^9, 
   3.5686336280941167`*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "imp", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"4", 
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"type", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "3", "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "6", "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "9", "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
   3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
   3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}, 
   3.568506953861553*^9, {3.568633339099043*^9, 3.568633339411043*^9}, {
   3.568633509030141*^9, 3.5686335173605556`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fr", "=", "6"}], ";", 
  RowBox[{"typ", "=", "4"}], ";", 
  RowBox[{"freqs", "[", 
   RowBox[{"[", "fr", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Fltr", "=", 
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{"nums", ",", 
       RowBox[{"imp", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "fr", ",", "typ"}], "]"}], "]"}]}], "}"}], 
     "]"}]}], ";", 
   RowBox[{"Length", "[", "Fltr", "]"}]}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"Fltr", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"1", "+", 
            RowBox[{"1000", "i"}]}], ";;", 
           RowBox[{"1000", 
            RowBox[{"(", 
             RowBox[{"i", "+", "1"}], ")"}]}]}], "]"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "2"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "450"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "4"}], "}"}]}], "]"}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"GraphicsGrid", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", 
                RowBox[{"imp", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], "}"}],
               "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", 
                RowBox[{"1000", "i"}]}], ";;", 
               RowBox[{"1000", 
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}]}]}], "]"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", 
                RowBox[{"imp", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}],
               "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", 
                RowBox[{"1000", "i"}]}], ";;", 
               RowBox[{"1000", 
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}]}]}], "]"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", 
                RowBox[{"imp", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}],
               "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", 
                RowBox[{"1000", "i"}]}], ";;", 
               RowBox[{"1000", 
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}]}]}], "]"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", 
                RowBox[{"imp", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}],
               "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", 
                RowBox[{"1000", "i"}]}], ";;", 
               RowBox[{"1000", 
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}]}]}], "]"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "0", ",", "4"}], "}"}]}], "]"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GraphicsGrid", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ListPlot", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}], ";;", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}]}], "]"}], "]"}], ",", 
          RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ListPlot", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}], ";;", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}]}], "]"}], "]"}], ",", 
          RowBox[{"Joined", "\[Rule]", "True"}], ",", 
          RowBox[{"PlotRange", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ListPlot", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}], ";;", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}]}], "]"}], "]"}], ",", 
          RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ListPlot", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}], ";;", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}]}], "]"}], "]"}], ",", 
          RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
    "]"}], "&"}], "/@", 
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"25500", ",", "26100"}], "}"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"best", " ", "times", " ", "fr"}], "=", 
     RowBox[{
      RowBox[{"6", ":", " ", "tmin"}], "=", "25500"}]}], ";", 
    RowBox[{"tmax", "=", 
     RowBox[{"26100", ":", " ", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"13000", ",", "13400"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"23400", ",", "23800"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"25000", ",", "25400"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"25500", ",", "25900"}], "}"}]}], "}"}]}]}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.56953901410575*^9, 3.5695390316385193`*^9}, {
   3.5695390722391434`*^9, 3.569539192555991*^9}, {3.5695392296215606`*^9, 
   3.569539253404426*^9}, {3.5695392951250668`*^9, 3.5695393378832235`*^9}, {
   3.5695398701931553`*^9, 3.569540026525556*^9}, 3.56954016672771*^9, {
   3.5695402357812705`*^9, 3.569540305724845*^9}, {3.5695403731558805`*^9, 
   3.5695403774684467`*^9}, {3.569540452739603*^9, 3.569540458859697*^9}, {
   3.5695405024353657`*^9, 3.569540508362957*^9}, {3.569540567278364*^9, 
   3.5695406031799154`*^9}, {3.5695406352604084`*^9, 3.569540651823163*^9}, {
   3.5695406955288343`*^9, 3.5695407206817207`*^9}, {3.569540771162496*^9, 
   3.5695407792751207`*^9}, {3.569540809518085*^9, 3.569540916082222*^9}, {
   3.569541026943925*^9, 3.569541040239129*^9}, {3.569541155870905*^9, 
   3.569541163866028*^9}, {3.569541304619691*^9, 3.56954131366733*^9}, {
   3.5695413573755016`*^9, 3.569541450066925*^9}, {3.5695419393966246`*^9, 
   3.569541946286731*^9}, {3.5695419940649643`*^9, 3.569542001162574*^9}, {
   3.56960998403899*^9, 3.5696099908440943`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"im1", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "3", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"im2", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "6", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"im3", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "9", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux87face-on.jpg\>\"", ",", 
   "im1", ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux230face-on.jpg\>\"", ",", 
   "im2", ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux857face-on.jpg\>\"", ",", 
   "im3", ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5677313621689696`*^9, 3.567731539914136*^9}, {
  3.567731608730072*^9, 3.567731750697192*^9}, {3.5685070558389325`*^9, 
  3.568507057461335*^9}, {3.5686303043821273`*^9, 3.5686303122021384`*^9}, {
  3.568633678744188*^9, 3.5686336843141956`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tmax", "=", 
    SuperscriptBox["10", "3.2"]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Papadakis", " ", "&"}], " ", "Lawrence", " ", 
    RowBox[{"(", "1993", ")"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"autovar", "[", 
    RowBox[{"ty_", ",", "mu_", ",", "kf_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"typ", "=", "ty"}], ";", 
      RowBox[{"mult", "=", "mu"}], ";", 
      RowBox[{"k", "=", "kf"}], ";", 
      RowBox[{"binned", "=", 
       RowBox[{"imp", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
      RowBox[{"ll", "=", 
       RowBox[{"Length", "[", "binned", "]"}]}], ";", 
      RowBox[{"me", "=", 
       RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"autovariance", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{"1", ";;", 
                RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], 
            ")"}], ".", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
             "me"}], ")"}]}], "ll"], ",", 
         RowBox[{"{", 
          RowBox[{"shi", ",", "0", ",", 
           RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"f11", "=", 
       RowBox[{"FourierDCT", "[", 
        RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
      RowBox[{"num", "=", 
       RowBox[{"Floor", "[", 
        FractionBox["ll", "2"], "]"}]}], ";", 
      RowBox[{"sur", "=", 
       RowBox[{
        FractionBox[
         SqrtBox["2"], 
         RowBox[{"2", "\[Pi]"}]], 
        SqrtBox["ll"], 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"f11", ",", "2"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"sur", ",", 
        RowBox[{"sur", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"timex", "=", 
       RowBox[{"4.", 
        RowBox[{"ll", "/", 
         RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
      RowBox[{"mint", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
      RowBox[{"maxt", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", 
      RowBox[{"nn", "=", 
       RowBox[{
        RowBox[{"Log", "[", 
         FractionBox["maxt", "mint"], "]"}], "/", 
        RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"tsides", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"mint", " ", 
          SuperscriptBox["mult", "i"]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tbins", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tsides", "[", 
            RowBox[{"[", "i", "]"}], "]"}], ",", 
           RowBox[{"tsides", "[", 
            RowBox[{"[", 
             RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tsizes", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tmeans", "=", 
       RowBox[{"Mean", "[", 
        RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"intergra", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"timex", ",", 
             RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"pergra", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"Exp", "[", 
              RowBox[{"intergra", "[", 
               RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"tx", ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
             RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
             RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        RowBox[{"res", "=", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"tmeans", ",", 
              FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
          "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"pergra", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{"NIntegrate", "[", 
           RowBox[{
            RowBox[{"intergra", "[", 
             RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"tx", ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
            RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
            RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
          RowBox[{"tsizes", "[", 
           RowBox[{"[", "i", "]"}], "]"}]], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"res", "[", 
        RowBox[{"ty", ",", "kf"}], "]"}], "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"tmeans", ",", 
            RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}]}]}],
      ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"autorand", "[", 
     RowBox[{"ty_", ",", "mu_", ",", "kf_", ",", "rlist_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"typ", "=", "ty"}], ";", 
       RowBox[{"mult", "=", "mu"}], ";", 
       RowBox[{"k", "=", "kf"}], ";", 
       RowBox[{"binned", "=", "rlist"}], ";", 
       RowBox[{"ll", "=", 
        RowBox[{"Length", "[", "binned", "]"}]}], ";", 
       RowBox[{"merr", "=", 
        RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"autovariance", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{"1", ";;", 
                 RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "merr"}], 
             ")"}], ".", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
              "merr"}], ")"}]}], "ll"], ",", 
          RowBox[{"{", 
           RowBox[{"shi", ",", "0", ",", 
            RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"f11", "=", 
        RowBox[{"FourierDCT", "[", 
         RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
       RowBox[{"num", "=", 
        RowBox[{"Floor", "[", 
         FractionBox["ll", "2"], "]"}]}], ";", 
       RowBox[{"sur", "=", 
        RowBox[{
         FractionBox[
          SqrtBox["2"], 
          RowBox[{"2", "\[Pi]"}]], 
         SqrtBox["ll"], 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{"f11", ",", "2"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sur", ",", 
         RowBox[{"sur", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"timex", "=", 
        RowBox[{"4.", 
         RowBox[{"ll", "/", 
          RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
       RowBox[{"mint", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
       RowBox[{"maxt", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", 
       RowBox[{"nn", "=", 
        RowBox[{
         RowBox[{"Log", "[", 
          FractionBox["maxt", "mint"], "]"}], "/", 
         RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"tsides", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"mint", " ", 
           SuperscriptBox["mult", "i"]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tbins", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"tsides", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"tsides", "[", 
             RowBox[{"[", 
              RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tsizes", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tmeans", "=", 
        RowBox[{"Delete", "[", 
         RowBox[{
          RowBox[{"Mean", "[", 
           RowBox[{"Transpose", "[", "tbins", "]"}], "]"}], ",", 
          RowBox[{"-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"intergra", "=", 
        RowBox[{"Interpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"tra", "=", 
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"timex", ",", 
               RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}]}], "]"}], ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"pergra", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{"Exp", "[", 
               RowBox[{"intergra", "[", 
                RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"tx", ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
              RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
              RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
         RowBox[{"res", "=", 
          RowBox[{"Select", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"tmeans", ",", 
               FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
           "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"pergra", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            FractionBox[
             RowBox[{"NIntegrate", "[", 
              RowBox[{
               RowBox[{"intergra", "[", 
                RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"tx", ",", 
                 RowBox[{"tbins", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"tbins", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
               RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
               RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
             RowBox[{"tsizes", "[", 
              RowBox[{"[", "i", "]"}], "]"}]], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "nn"}], 
             RowBox[{"(*", 
              RowBox[{"+", "1"}], "*)"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"pergra", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"sel", "=", 
            RowBox[{"Select", "[", 
             RowBox[{"timex", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], "<", "#", "<", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "&"}]}], "]"}]}], 
           ";", 
           RowBox[{"inttime", "=", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Flatten", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}], ",", "sel", ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}]}], "}"}], "]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"intxx", "=", 
            RowBox[{
             RowBox[{"intergra", "[", 
              RowBox[{"Log", "[", "tx", "]"}], "]"}], "/.", 
             RowBox[{"tx", "\[Rule]", "inttime"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"deltax", "=", 
            RowBox[{"Differences", "[", "inttime", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{
               FractionBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"intxx", "[", 
                   RowBox[{"[", "kk", "]"}], "]"}], "+", 
                  RowBox[{"intxx", "[", 
                   RowBox[{"[", 
                    RowBox[{"kk", "+", "1"}], "]"}], "]"}]}], ")"}], "2"], 
               RowBox[{"deltax", "[", 
                RowBox[{"[", "kk", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"kk", ",", 
                RowBox[{
                 RowBox[{"Length", "[", "inttime", "]"}], "-", "1"}]}], 
               "}"}]}], "]"}], "/", 
            RowBox[{"tsizes", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nn"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"resy", "=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"tmeans", ",", 
             RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
         "]"}]}]}], ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"3", ",", "1.2", ",", "6"}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"lpl3", "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", "\"\<FourierDCT of autovariance\>\""}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"tofit3", "=", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"A", " ", 
         RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
      RowBox[{"FindFit", "[", 
       RowBox[{
        RowBox[{"Log", "[", "res", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"logpl3", "=", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{"tofit3", ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"res", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"res", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl3", ",", "logpl3"}], "]"}]}], 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5686439274432755`*^9, 3.5686439603749332`*^9}, {
   3.5686451629862075`*^9, 3.5686451856374474`*^9}, {3.5686452238107147`*^9, 
   3.568645224060315*^9}, {3.56864527792721*^9, 3.5686452795340123`*^9}, {
   3.5686475480025587`*^9, 3.5686475486109595`*^9}, {3.5686486517096863`*^9, 
   3.5686486798521357`*^9}, {3.568649804547723*^9, 3.5686498966658845`*^9}, {
   3.568650080917808*^9, 3.568650142881117*^9}, {3.568650191912003*^9, 
   3.568650192473604*^9}, {3.5686504541512637`*^9, 3.568650473729298*^9}, {
   3.5686509820415907`*^9, 3.5686511574618998`*^9}, {3.568651441439598*^9, 
   3.5686514679596443`*^9}, {3.568652600865834*^9, 3.5686526186810656`*^9}, {
   3.5686526510979223`*^9, 3.5686527356666713`*^9}, {3.5686534018536034`*^9, 
   3.5686534150044265`*^9}, {3.5686541196155853`*^9, 
   3.5686541365906086`*^9}, {3.56865418756568*^9, 3.568654188135681*^9}, {
   3.568654261385783*^9, 3.568654264630788*^9}, {3.5686571128482122`*^9, 
   3.5686571159214177`*^9}, {3.5686743062539015`*^9, 3.56867431938892*^9}, {
   3.5686745663492656`*^9, 3.568674568974269*^9}, {3.5686757574482994`*^9, 
   3.5686757867295504`*^9}, {3.5686758566488733`*^9, 3.568675912777772*^9}, 
   3.568675949391036*^9, {3.56867605980803*^9, 3.568676061118432*^9}, {
   3.5686761408813725`*^9, 3.568676141208973*^9}, {3.5686762215179143`*^9, 
   3.568676225854722*^9}, {3.5686762768512115`*^9, 3.5686762805952177`*^9}, {
   3.568676756568654*^9, 3.56867676009426*^9}, {3.5687322632105227`*^9, 
   3.56873226844553*^9}, {3.5687323603038664`*^9, 3.56873240813355*^9}, 
   3.568732799124943*^9, {3.568732924601118*^9, 3.568732926276121*^9}, {
   3.5687334021941023`*^9, 3.568733460023404*^9}, {3.568733522532714*^9, 
   3.5687335375711403`*^9}, {3.5687338285272512`*^9, 
   3.5687338298532534`*^9}, {3.568733990581336*^9, 3.5687340011113544`*^9}, {
   3.568734122885168*^9, 3.568734123306369*^9}, 3.56873427757504*^9, {
   3.568734397804451*^9, 3.568734422483694*^9}, {3.568734709465399*^9, 
   3.568734710526201*^9}, {3.5687675388524036`*^9, 3.5687675394140043`*^9}, {
   3.5688219411048136`*^9, 3.5688219660180573`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ttx", "=", 
   RowBox[{"TimeUsed", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "fr", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}], ",", 
   RowBox[{"Dynamic", "[", "o", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"20", ",", "1500"}], "}"}], ",", "All"}], "}"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=."}], ";", 
  RowBox[{"fr", "=."}], ";", 
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";", 
  RowBox[{"types", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Flux\>\"", ",", "\"\<LP\>\"", ",", "\"\<EVPA\>\"", ",", 
     "\"\<CP\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"Do", "[", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Frequency  = \>\"", ",", 
        RowBox[{"freqs", "[", 
         RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz\>\""}], "]"}], ";"}], 
     "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      StyleBox[
       RowBox[{"autovar", "[", 
        RowBox[{"typ", ",", "3.0", ",", "fr"}], "]"}],
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox[";",
       FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"resx", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"timex", "[", 
               RowBox[{"[", 
                RowBox[{"-", "1"}], "]"}], "]"}], ",", 
              RowBox[{"sur", "[", 
               RowBox[{"[", 
                RowBox[{"-", "1"}], "]"}], "]"}]}], "}"}], "}"}], ",", "res", 
           ",", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"timex", "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"sur", "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"tofit4", "=", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"A", " ", 
             RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
          RowBox[{"FindFit", "[", 
           RowBox[{
            RowBox[{"Log", "[", "resx", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"PrependTo", "[", 
         RowBox[{"resx", ",", 
          RowBox[{"{", 
           RowBox[{"4.", ",", 
            RowBox[{"(*", "0.5", "*)"}], 
            RowBox[{"tofit4", "/.", 
             RowBox[{"x", "\[Rule]", "4."}]}]}], "}"}]}], "]"}], ";"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"PrependTo", "[", 
         RowBox[{"resx", ",", 
          RowBox[{"{", 
           RowBox[{"8.", ",", 
            RowBox[{"tofit4", "/.", 
             RowBox[{"x", "\[Rule]", "8."}]}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"PrependTo", "[", 
         RowBox[{"resx", ",", 
          RowBox[{"{", 
           RowBox[{"4.", ",", 
            RowBox[{"(*", "0.5", "*)"}], 
            RowBox[{"tofit4", "/.", 
             RowBox[{"x", "\[Rule]", "4."}]}]}], "}"}]}], "]"}], ";"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"resx", "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"res", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"timex", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"sur", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tofit4", "=", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"A", " ", 
           RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
        RowBox[{"FindFit", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"res", "[", 
            RowBox[{"typ", ",", "fr"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"resx", "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"#", ",", 
             RowBox[{
              FractionBox[
               RowBox[{
                RowBox[{"tofit4", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                RowBox[{"x", "\[Rule]", "#"}]}], 
               RowBox[{
                RowBox[{"tofit4", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                RowBox[{"x", "\[Rule]", 
                 RowBox[{
                  RowBox[{"res", "[", 
                   RowBox[{"typ", ",", "fr"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
              RowBox[{
               RowBox[{"res", "[", 
                RowBox[{"typ", ",", "fr"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
          RowBox[{"{", 
           RowBox[{"4", ",", "8"}], "}"}]}], ",", "resx"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"resx", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"#", ",", 
              RowBox[{
               FractionBox[
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", "#"}]}], 
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", 
                  RowBox[{"res", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
               RowBox[{"res", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
           RowBox[{"{", 
            RowBox[{"4", ",", "8"}], "}"}]}], ",", "res", ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"timex", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"sur", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"interand", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", "resx", "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDfluxx", "[", 
         RowBox[{"typ", ",", "fr"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{"resx", ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Green", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"autovar", "[", 
        RowBox[{"typ", ",", "1.2", ",", "fr"}], "]"}],
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox[";",
       FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         StyleBox[
          RowBox[{"PSDflux", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}],
          FontColor->RGBColor[0, 0, 1]], "=", 
         RowBox[{"ListLogLogPlot", "[", 
          RowBox[{"res", ",", 
           RowBox[{"PlotStyle", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Black", ",", 
              RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
           RowBox[{"FrameLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
             "}"}]}]}], "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Print", "[", 
         RowBox[{"Show", "[", 
          RowBox[{
           StyleBox[
            RowBox[{"PSDflux", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}],
            FontColor->RGBColor[0, 0, 1]], ",", 
           StyleBox[
            RowBox[{"PSDfluxx", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}],
            FontColor->RGBColor[0, 0, 1]]}], "]"}], "]"}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"nux", "=", "154"}], ";", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"22", " ", "-", " ", 
         RowBox[{"1", "\[Sigma]"}]}], ";", " ", 
        RowBox[{"154", " ", "-", " ", 
         RowBox[{"2", "\[Sigma]"}]}], ";", " ", 
        RowBox[{"2592", " ", "-", " ", 
         RowBox[{"3", "\[Sigma]"}]}], ";", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"7", "/", 
           RowBox[{"(", 
            RowBox[{"1", "-", "#"}], ")"}]}], "&"}], "/@", 
         RowBox[{"{", 
          RowBox[{
          "0.682689492137086", ",", "0.954499736103642", ",", 
           "0.997300203936740"}], "}"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"tabresy", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"randx", "=", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"RandomVariate", "[", 
                RowBox[{
                 RowBox[{"NormalDistribution", "[", "]"}], ",", "5000"}], 
                "]"}], "+", 
               RowBox[{"\[ImaginaryI]", " ", 
                RowBox[{"RandomVariate", "[", 
                 RowBox[{
                  RowBox[{"NormalDistribution", "[", "]"}], ",", "5000"}], 
                 "]"}]}]}], ")"}], 
             SqrtBox[
              RowBox[{"Exp", "[", 
               RowBox[{"interand", "[", 
                RowBox[{"Log", "[", 
                 RowBox[{"20000", "/", 
                  RowBox[{"Range", "[", "5000", "]"}]}], "]"}], "]"}], 
               "]"}]]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"rsxx", "=", 
            RowBox[{"4.8", 
             RowBox[{"Re", "[", 
              RowBox[{"InverseFourier", "[", "randx", "]"}], "]"}]}]}], ";"}], 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"+", "me"}], ";"}], 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"-", "for"}], " ", "formal", " ", "correspondence"}], 
            "*)"}], "*)"}], ";", "\[IndentingNewLine]", 
          RowBox[{"resy", "=", 
           StyleBox[
            RowBox[{"autorand", "[", 
             RowBox[{"typ", ",", "1.2", ",", "fr", ",", "rsxx"}], "]"}],
            FontColor->RGBColor[1, 0, 0]]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"o", ",", "nux"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         StyleBox[
          RowBox[{"PSDFrand", "[", "aa", "]"}],
          FontColor->RGBColor[0, 0, 1]], "=", 
         RowBox[{"ListLogLogPlot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ress", "[", "aa", "]"}], "=", 
            RowBox[{"tabresy", "[", 
             RowBox[{"[", "aa", "]"}], "]"}]}], ",", 
           RowBox[{"PlotStyle", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Red", ",", 
              RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
           RowBox[{"FrameLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
             "}"}]}]}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"aa", ",", "nux"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmean", "[", 
        RowBox[{"typ", ",", "fr"}], "]"}], "=", 
       RowBox[{"Exp", "[", 
        FractionBox[
         RowBox[{"Total", "[", 
          RowBox[{"Log", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"ress", "[", "i", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}], "]"}], "nux"],
         "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFrandmean", "[", 
         RowBox[{"typ", ",", "fr"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"ressmean", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDflux", "[", 
         RowBox[{"typ", ",", "fr"}], "]"}],
        FontColor->RGBColor[0., 0., 1.]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"res", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}], ",", 
         RowBox[{"Epilog", "\[Rule]", "\[IndentingNewLine]", 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"types", "[", 
                RowBox[{"[", 
                 RowBox[{"typ", "-", "2"}], "]"}], "]"}], "<>", 
               "\"\< at \>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Floor", "[", 
                 RowBox[{"freqs", "[", 
                  RowBox[{"[", "fr", "]"}], "]"}], "]"}], "]"}], "<>", 
               "\"\<GHz\>\""}], ",", "18", ",", "Bold"}], "]"}], ",", 
            RowBox[{"Scaled", "[", 
             RowBox[{"{", 
              RowBox[{"0.3", ",", "0.8"}], "}"}], "]"}]}], "]"}]}]}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Print", "[", 
         RowBox[{"Show", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             StyleBox[
              RowBox[{"PSDFrand", "[", "i", "]"}],
              FontColor->RGBColor[0, 0, 1]], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], ",", 
           StyleBox[
            RowBox[{"PSDflux", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}],
            FontColor->RGBColor[0, 0, 1]], ",", 
           StyleBox[
            RowBox[{"PSDFrandmean", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}],
            FontColor->RGBColor[0, 0, 1]], ",", 
           StyleBox[
            RowBox[{"PSDfluxx", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}],
            FontColor->RGBColor[0, 0, 1]]}], "]"}], "]"}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resstot", "[", 
        RowBox[{"typ", ",", "fr"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ress", "[", "i", "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"resst", "=", 
       RowBox[{
        RowBox[{"ress", "[", "1", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"ressmax", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], "=", 
         RowBox[{"Max", "@@@", 
          RowBox[{"resstot", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}]}]}], ";", 
        RowBox[{
         RowBox[{"ressmin", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], "=", 
         RowBox[{"Min", "@@@", 
          RowBox[{"resstot", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}]}]}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmax", "[", 
        RowBox[{"typ", ",", "fr"}], "]"}], "=", 
       RowBox[{"Mean", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"RankedMax", "[", 
             RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
           RowBox[{"resstot", "[", 
            RowBox[{"typ", ",", "fr"}], "]"}]}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"RankedMax", "[", 
             RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
           RowBox[{"resstot", "[", 
            RowBox[{"typ", ",", "fr"}], "]"}]}]}], "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmin", "[", 
        RowBox[{"typ", ",", "fr"}], "]"}], "=", 
       RowBox[{"Mean", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"RankedMin", "[", 
             RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
           RowBox[{"resstot", "[", 
            RowBox[{"typ", ",", "fr"}], "]"}]}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"RankedMin", "[", 
             RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
           RowBox[{"resstot", "[", 
            RowBox[{"typ", ",", "fr"}], "]"}]}]}], "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFmin", "[", 
         RowBox[{"typ", ",", "fr"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"resst", ",", 
            RowBox[{"ressmin", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}]}], "}"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Dotted"}], 
           "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFmax", "[", 
         RowBox[{"typ", ",", "fr"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"resst", ",", 
            RowBox[{"ressmax", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}]}], "}"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"Print", "[", 
       RowBox[{"Show", "[", 
        StyleBox[
         RowBox[{
          RowBox[{"PSDflux", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}], ",", 
          RowBox[{"PSDFmin", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}], ",", 
          RowBox[{"PSDFmax", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}], ",", 
          RowBox[{"PSDflux", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}], ",", 
          RowBox[{"PSDFrandmean", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}], ",", 
          RowBox[{"PSDfluxx", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}]}],
         FontColor->RGBColor[0, 0, 1]], "]"}], "]"}], "*)"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"typ", ",", "3", ",", "6"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Computed in \>\"", ",", 
    RowBox[{
     RowBox[{"TimeUsed", "[", "]"}], "-", "ttx"}], ",", "\"\<s\>\""}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"125", "s", " ", "for", " ", "1", "\[Sigma]"}], " ", "\[Implies]",
     " ", 
    RowBox[{
     RowBox[{"709", "s", 
      RowBox[{"(", 
       RowBox[{"12", "min"}], ")"}], " ", "for", " ", "2", "\[Sigma]"}], " ", 
     "\[Implies]", " ", 
     RowBox[{
     "expected", " ", "3.5", "hrs", " ", "for", " ", "3", "\[Sigma]"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.568658690181983*^9, 3.5686587401332707`*^9}, {
   3.5686588111757956`*^9, 3.5686588548880725`*^9}, {3.5686588922033377`*^9, 
   3.568658925977397*^9}, {3.5686589703906755`*^9, 3.5686589774106874`*^9}, {
   3.568672919401613*^9, 3.5686729589816833`*^9}, {3.5686734755153365`*^9, 
   3.5686734758803368`*^9}, 3.568673902517336*^9, {3.5686740475725393`*^9, 
   3.5686740736925755`*^9}, {3.5686741992477517`*^9, 3.568674207342763*^9}, {
   3.5686743702339907`*^9, 3.568674420479061*^9}, {3.5686746579543934`*^9, 
   3.5686746640944023`*^9}, {3.5686747825547867`*^9, 
   3.5686747836467886`*^9}, {3.568675093166932*^9, 3.5686751107637634`*^9}, {
   3.5686751638818564`*^9, 3.5686751860962954`*^9}, {3.5686752638780317`*^9, 
   3.5686752932372837`*^9}, 3.568676352200344*^9, {3.568676425036872*^9, 
   3.5686764268152747`*^9}, {3.5686765814583464`*^9, 
   3.5686765815051465`*^9}, {3.568676612564801*^9, 3.5686766292880306`*^9}, {
   3.5686768069879427`*^9, 3.568676807112743*^9}, {3.568676887780484*^9, 
   3.5686768878896847`*^9}, {3.5686769802106466`*^9, 
   3.5686770449975605`*^9}, {3.568677177254593*^9, 3.5686771780189943`*^9}, {
   3.5686772390463014`*^9, 3.5686772393739023`*^9}, {3.568677286049184*^9, 
   3.5686773642833214`*^9}, {3.568677400110385*^9, 3.568677400484785*^9}, {
   3.568677507665374*^9, 3.5686775082269745`*^9}, {3.5686775809855022`*^9, 
   3.568677667160054*^9}, {3.568677724162554*^9, 3.568677768326232*^9}, {
   3.5686784189103737`*^9, 3.5686784731984696`*^9}, {3.568678528562967*^9, 
   3.5686785340073767`*^9}, {3.568678600557093*^9, 3.5686786208995285`*^9}, {
   3.5686786550323887`*^9, 3.5686786624268017`*^9}, {3.568678748679353*^9, 
   3.5686787518617587`*^9}, {3.568678943851296*^9, 3.568678944178897*^9}, {
   3.568679095826763*^9, 3.5686790961543636`*^9}, 3.5687143742988043`*^9, {
   3.568718293597542*^9, 3.568718293925143*^9}, {3.568733412817721*^9, 
   3.568733427575347*^9}, {3.5687335444663525`*^9, 3.568733613090873*^9}, {
   3.568733746627107*^9, 3.5687337937547903`*^9}, {3.5687342807418456`*^9, 
   3.5687343666823964`*^9}, {3.5687344259001007`*^9, 
   3.5687344394877243`*^9}, {3.568734477239791*^9, 3.5687345461451116`*^9}, {
   3.5687345797823715`*^9, 3.568734589844389*^9}, {3.5687346756289396`*^9, 
   3.568734677563343*^9}, {3.568734894974286*^9, 3.568734922929535*^9}, {
   3.5687349655332103`*^9, 3.5687349764844294`*^9}, {3.568735012192892*^9, 
   3.56873502830772*^9}, {3.568735147273529*^9, 3.568735195914415*^9}, {
   3.568735337110263*^9, 3.568735339029066*^9}, {3.568735384331546*^9, 
   3.568735388949154*^9}, {3.5687354326448307`*^9, 3.5687354327852306`*^9}, {
   3.568735491519334*^9, 3.568735505184958*^9}, {3.5687364997865577`*^9, 
   3.568736499896558*^9}, {3.568743415518503*^9, 3.568743415643503*^9}, {
   3.568743713589615*^9, 3.5687437136364155`*^9}, {3.5687441249311376`*^9, 
   3.5687441349005547`*^9}, {3.5687456117645607`*^9, 3.568745675733219*^9}, {
   3.568745710904231*^9, 3.5687457803412027`*^9}, {3.568745836047389*^9, 
   3.5687458519833*^9}, {3.568746269593191*^9, 3.5687463055824547`*^9}, {
   3.568746362210554*^9, 3.5687463633961563`*^9}, {3.5687464472712975`*^9, 
   3.5687464474012976`*^9}, {3.568746524051405*^9, 3.5687465241114054`*^9}, {
   3.5687465874514937`*^9, 3.568746587516494*^9}, {3.5687466340115585`*^9, 
   3.5687466340965595`*^9}, {3.5687466830126286`*^9, 3.5687466830926285`*^9}, 
   3.5687467437727137`*^9, {3.568746883758145*^9, 3.5687468841949453`*^9}, {
   3.568746932711031*^9, 3.568746932867031*^9}, {3.5687483065115275`*^9, 
   3.5687483066051273`*^9}, {3.568748356905614*^9, 3.5687483570772142`*^9}, {
   3.5687484849978333`*^9, 3.5687484851070337`*^9}, {3.5687486793365183`*^9, 
   3.5687487039165525`*^9}, 3.5687487503066173`*^9, {3.5687487915866747`*^9, 
   3.568748868616783*^9}, 3.568748930046869*^9, {3.5687648297268953`*^9, 
   3.568764830431896*^9}, {3.5687651183353004`*^9, 3.5687651217753053`*^9}, {
   3.568765172395376*^9, 3.568765172775377*^9}, {3.5687652432954755`*^9, 
   3.5687652504354854`*^9}, {3.5687653239655886`*^9, 
   3.5687654154007163`*^9}, {3.5687654918858232`*^9, 3.568765522375866*^9}, {
   3.568765635131024*^9, 3.5687656600910587`*^9}, {3.5687657746762195`*^9, 
   3.568765779146226*^9}, {3.5687658126242733`*^9, 3.5687658187242823`*^9}, {
   3.5687659304504385`*^9, 3.5687659560604744`*^9}, {3.5687660151155567`*^9, 
   3.5687660156055574`*^9}, {3.5687660518306084`*^9, 3.56876608879066*^9}, {
   3.568766907469807*^9, 3.5687669171198206`*^9}, {3.5687669640798864`*^9, 
   3.5687669661198893`*^9}, {3.5687675173867655`*^9, 
   3.5687675633756466`*^9}, {3.568821997140112*^9, 3.568822020852154*^9}, {
   3.5688220594154215`*^9, 3.568822062551027*^9}, {3.568822107572706*^9, 
   3.568822116667522*^9}, {3.568822153592787*^9, 3.568822194090458*^9}, {
   3.5688227530290003`*^9, 3.5688227588010106`*^9}, {3.5688228373783484`*^9, 
   3.5688228857228336`*^9}, {3.5688229377967253`*^9, 
   3.5688229695895805`*^9}, {3.5688230020376377`*^9, 
   3.5688230069828463`*^9}, {3.56882307145776*^9, 3.568823184807559*^9}, {
   3.5688232887817416`*^9, 3.5688233510570507`*^9}, {3.568823574855044*^9, 
   3.5688235769298477`*^9}, {3.568823624853132*^9, 3.568823626522335*^9}, {
   3.568823907307228*^9, 3.568823937727281*^9}, {3.5688242497905293`*^9, 
   3.5688242498997297`*^9}, {3.5688249598546658`*^9, 3.568824963988673*^9}, {
   3.5688249955007286`*^9, 3.568824998527134*^9}, {3.568825583173684*^9, 
   3.5688256067765255`*^9}, {3.5688257669956055`*^9, 
   3.5688257915968485`*^9}, {3.5688265201971283`*^9, 3.568826526140739*^9}, {
   3.56882670801742*^9, 3.568826716082634*^9}, {3.5688267536163*^9, 
   3.568826758140308*^9}, {3.5689471428856163`*^9, 3.5689471430572166`*^9}, {
   3.5689472945024767`*^9, 3.568947305391296*^9}}],

Cell[BoxData[
 RowBox[{"grgr", "=", 
  RowBox[{"GraphicsGrid", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{"{", 
       StyleBox[
        RowBox[{
         RowBox[{"PSDflux", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"PSDFmin", "[", 
            RowBox[{"typ", ",", "fr"}], "]"}], ","}], "*)"}], 
         RowBox[{"PSDFmax", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], ",", 
         RowBox[{"PSDflux", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], ",", 
         RowBox[{"PSDFrandmean", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], ",", 
         RowBox[{"PSDfluxx", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}]}],
        FontColor->RGBColor[0, 0, 1]], 
       StyleBox["}",
        FontColor->RGBColor[0, 0, 1]]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"typ", ",", "3", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.568765709706128*^9, 3.5687657570961947`*^9}, {
  3.568766150610747*^9, 3.5687661926308055`*^9}, {3.5687676090213265`*^9, 
  3.5687676147465367`*^9}, {3.5687677042756658`*^9, 3.5687677075856705`*^9}, {
  3.568826535828356*^9, 3.568826536140356*^9}, {3.5689450632113714`*^9, 
  3.5689450639601727`*^9}}],

Cell[BoxData[
 RowBox[{"1", "\[Sigma]"}]], "Input",
 CellChangeTimes->{{3.5689472899316688`*^9, 3.568947291195271*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"#", ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Blue", ",", 
         RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"ListPlot", ",", "ListLogLogPlot"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"lmax", "=", 
        RowBox[{"Quotient", "[", 
         RowBox[{"l", ",", "2"}], "]"}]}], ";"}], "*)"}], 
     RowBox[{"lmax", "=", "150"}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"4", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveF", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<Flux, Jy\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveLP", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<LP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveEVPA", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<EVPA angle, deg\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveCP", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<CP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGCQAGIQrbT3gKBm3ivHHGcHERA9UWO5JIgOCpqtBKKNCk00
QTSDGJMWiL7kuVgfRJfNvGUEone6VdiA5dd6BYHo5rnPwkB0S8arXBB9Suda
MYjWaJesAdFsRT98tYG0WtkvMN1/5eAuW5D4lotgen7u9wuuQHrW/t9g+gjj
8/sgWuvu6ccg2jRt7TsQPXXa/o8get+dt5xuQPoW+1cw/Y9n5oMMIP0nxf8x
iGb7tOAziN5luQhMn+OszHzfDHRP97tcEO3nx1gMogVUP9eB6PN8N5tAdPiz
ra0gOuP1r24QbWeT0weiV7yasgNE35jZdgBEn1y08iKIrtFYchVEbzq3OOf5
lFeO3RnaRSC6Yofji+RprxxF10/6CKLXcSd9A9EqJRd4UoA0AHSfya8=
  "]],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"nums", ",", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1", ",", "12"}], "]"}], "]"}]}], "}"}], "]"}], 
   ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.568509597296516*^9, 3.568509631398176*^9}, {
  3.5685096636278324`*^9, 3.568509678619459*^9}}],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDflux", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDLP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDEVPA", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDCP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveF", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveLP", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveEVPA", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveCP", "[", "k", "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5588336899835253`*^9, 3.558833763719743*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fr", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "[", 
  RowBox[{"[", "fr", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{
    SuperscriptBox["10", "7"], 
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "fr", ",", "12"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5474244310872493`*^9, 3.5474244563596945`*^9}, {
   3.5474244888795547`*^9, 3.547424515096054*^9}, {3.5474245485119658`*^9, 
   3.547424574191434*^9}, {3.5475470934034843`*^9, 3.5475470957396173`*^9}, 
   3.547547753886261*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["lightcurve th=174 (no B cut, no B red, thlimit=0.1)", "Subsection",
 CellChangeTimes->{{3.5577510472865367`*^9, 3.55775104944654*^9}, {
  3.55883260748061*^9, 3.558832631388977*^9}, {3.560872675917722*^9, 
  3.56087270326457*^9}, {3.5610765919205837`*^9, 3.5610766169586277`*^9}, {
  3.567729128601217*^9, 3.5677291508874917`*^9}, {3.5685060616481857`*^9, 
  3.5685060618041863`*^9}, {3.568506336458269*^9, 3.5685063368950696`*^9}, {
  3.568629937666959*^9, 3.5686299402097635`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dir0", "=", 
   "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\th174lo\\\\\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fil", "=", 
   RowBox[{"dir0", "<>", "\"\<totspec.dat\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"coe", "=", "1"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"imp", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Import", "[", 
        RowBox[{"dir0", "<>", "\"\<poliresa93.75th174fn\>\"", "<>", 
         RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"fnum", ",", "2000", ",", "6999", ",", "coe"}], "}"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Put", "[", 
     RowBox[{"imp", ",", "fil"}], "]"}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Get", "[", "fil", "]"}]}], ";", 
  RowBox[{"Dimensions", "[", "imp", "]"}]}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, 
   3.5486008696865225`*^9, {3.548600915220127*^9, 3.548600929823962*^9}, {
   3.551033749980384*^9, 3.551033750871435*^9}, {3.5510337885625906`*^9, 
   3.5510337966150513`*^9}, {3.5520186449336777`*^9, 3.552018650318986*^9}, {
   3.55771381499922*^9, 3.557713848242878*^9}, {3.557714021184782*^9, 
   3.5577140212159815`*^9}, {3.557735285968544*^9, 3.557735286467745*^9}, {
   3.557735457912046*^9, 3.5577354872556973`*^9}, {3.5577395741124763`*^9, 
   3.5577395758284793`*^9}, {3.557855418955073*^9, 3.5578554191790857`*^9}, {
   3.5588325820031524`*^9, 3.5588325935978155`*^9}, {3.560872762763075*^9, 
   3.560872763870677*^9}, {3.5608728196547747`*^9, 3.560872849887628*^9}, {
   3.56087349695055*^9, 3.560873499446555*^9}, {3.560875165560282*^9, 
   3.560875166028283*^9}, {3.5608801039683924`*^9, 3.560880104514393*^9}, {
   3.5609031767900453`*^9, 3.5609031777421*^9}, {3.561076765174488*^9, 
   3.5610767680448933`*^9}, {3.5677291589449525`*^9, 3.567729159049958*^9}, {
   3.5677293582233505`*^9, 3.567729413559516*^9}, {3.5677295667262764`*^9, 
   3.567729571199532*^9}, {3.5685064387632484`*^9, 3.5685064673268986`*^9}, {
   3.5685068316977386`*^9, 3.568506890634642*^9}, {3.5686300345415297`*^9, 
   3.568630049579956*^9}, {3.568630216312004*^9, 3.5686302181120067`*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "imp", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"4", 
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"type", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fr", "=", "1"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"1", " ", "-", " ", 
     RowBox[{"43", "GHz"}]}], ",", " ", 
    RowBox[{"11", " ", "-", " ", 
     RowBox[{"5000", "GHz"}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", 
                 RowBox[{"(*", "type", "*)"}], "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "3", "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "6", "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "9", "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
   3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
   3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}, 
   3.568506953861553*^9, {3.568633339099043*^9, 3.568633339411043*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fr", "=", "6"}], ";", 
  RowBox[{"typ", "=", "4"}], ";", 
  RowBox[{"freqs", "[", 
   RowBox[{"[", "fr", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Fltr", "=", 
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{"nums", ",", 
       RowBox[{"imp", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "fr", ",", "typ"}], "]"}], "]"}]}], "}"}], 
     "]"}]}], ";", 
   RowBox[{"Length", "[", "Fltr", "]"}]}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"Fltr", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"1", "+", 
            RowBox[{"1000", "i"}]}], ";;", 
           RowBox[{"1000", 
            RowBox[{"(", 
             RowBox[{"i", "+", "1"}], ")"}]}]}], "]"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "2"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "450"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "4"}], "}"}]}], "]"}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"GraphicsGrid", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", 
                RowBox[{"imp", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], "}"}],
               "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", 
                RowBox[{"1000", "i"}]}], ";;", 
               RowBox[{"1000", 
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}]}]}], "]"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", 
                RowBox[{"imp", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}],
               "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", 
                RowBox[{"1000", "i"}]}], ";;", 
               RowBox[{"1000", 
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}]}]}], "]"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", 
                RowBox[{"imp", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}],
               "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", 
                RowBox[{"1000", "i"}]}], ";;", 
               RowBox[{"1000", 
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}]}]}], "]"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", 
                RowBox[{"imp", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}],
               "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", 
                RowBox[{"1000", "i"}]}], ";;", 
               RowBox[{"1000", 
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}]}]}], "]"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "0", ",", "4"}], "}"}]}], "]"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GraphicsGrid", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ListPlot", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}], ";;", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}]}], "]"}], "]"}], ",", 
          RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ListPlot", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}], ";;", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}]}], "]"}], "]"}], ",", 
          RowBox[{"Joined", "\[Rule]", "True"}], ",", 
          RowBox[{"PlotRange", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "10"}], "}"}]}]}], "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ListPlot", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}], ";;", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}]}], "]"}], "]"}], ",", 
          RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ListPlot", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}], ";;", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "-", "8000"}], ")"}], "/", 
              "4"}]}], "]"}], "]"}], ",", 
          RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
    "]"}], "&"}], "/@", 
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"25500", ",", "26100"}], "}"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"best", " ", "times", " ", "fr"}], "=", 
     RowBox[{
      RowBox[{"6", ":", " ", "tmin"}], "=", "25500"}]}], ";", 
    RowBox[{"tmax", "=", 
     RowBox[{"26100", ":", " ", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"13000", ",", "13400"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"23400", ",", "23800"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"25000", ",", "25400"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"25500", ",", "25900"}], "}"}]}], "}"}]}]}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.56953901410575*^9, 3.5695390316385193`*^9}, {
   3.5695390722391434`*^9, 3.569539192555991*^9}, {3.5695392296215606`*^9, 
   3.569539253404426*^9}, {3.5695392951250668`*^9, 3.5695393378832235`*^9}, {
   3.5695398701931553`*^9, 3.569540026525556*^9}, 3.56954016672771*^9, {
   3.5695402357812705`*^9, 3.569540305724845*^9}, {3.5695403731558805`*^9, 
   3.5695403774684467`*^9}, {3.569540452739603*^9, 3.569540458859697*^9}, {
   3.5695405024353657`*^9, 3.569540508362957*^9}, {3.569540567278364*^9, 
   3.5695406031799154`*^9}, {3.5695406352604084`*^9, 3.569540651823163*^9}, {
   3.5695406955288343`*^9, 3.5695407206817207`*^9}, {3.569540771162496*^9, 
   3.5695407792751207`*^9}, {3.569540809518085*^9, 3.569540916082222*^9}, {
   3.569541026943925*^9, 3.569541040239129*^9}, {3.569541155870905*^9, 
   3.569541163866028*^9}, {3.569541304619691*^9, 3.56954131366733*^9}, {
   3.5695413573755016`*^9, 3.569541450066925*^9}, {3.5695419393966246`*^9, 
   3.569541946286731*^9}, {3.5695419940649643`*^9, 3.569542001162574*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"im1", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "3", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"im2", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "6", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"im3", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "9", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux87edge-on.jpg\>\"", ",", 
   "im1", ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux230edge-on.jpg\>\"", ",", 
   "im2", ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux857edge-on.jpg\>\"", ",", 
   "im3", ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5677313621689696`*^9, 3.567731539914136*^9}, {
  3.567731608730072*^9, 3.567731750697192*^9}, {3.5685070558389325`*^9, 
  3.568507057461335*^9}, {3.5686303043821273`*^9, 3.5686303122021384`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tmax", "=", 
    SuperscriptBox["10", "3.2"]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Papadakis", " ", "&"}], " ", "Lawrence", " ", 
    RowBox[{"(", "1993", ")"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"autovar", "[", 
    RowBox[{"ty_", ",", "mu_", ",", "kf_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"typ", "=", "ty"}], ";", 
      RowBox[{"mult", "=", "mu"}], ";", 
      RowBox[{"k", "=", "kf"}], ";", 
      RowBox[{"binned", "=", 
       RowBox[{"imp", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
      RowBox[{"ll", "=", 
       RowBox[{"Length", "[", "binned", "]"}]}], ";", 
      RowBox[{"me", "=", 
       RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"autovariance", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{"1", ";;", 
                RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], 
            ")"}], ".", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
             "me"}], ")"}]}], "ll"], ",", 
         RowBox[{"{", 
          RowBox[{"shi", ",", "0", ",", 
           RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"f11", "=", 
       RowBox[{"FourierDCT", "[", 
        RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
      RowBox[{"num", "=", 
       RowBox[{"Floor", "[", 
        FractionBox["ll", "2"], "]"}]}], ";", 
      RowBox[{"sur", "=", 
       RowBox[{
        FractionBox[
         SqrtBox["2"], 
         RowBox[{"2", "\[Pi]"}]], 
        SqrtBox["ll"], 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"f11", ",", "2"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"sur", ",", 
        RowBox[{"sur", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"timex", "=", 
       RowBox[{"4.", 
        RowBox[{"ll", "/", 
         RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
      RowBox[{"mint", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
      RowBox[{"maxt", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", 
      RowBox[{"nn", "=", 
       RowBox[{
        RowBox[{"Log", "[", 
         FractionBox["maxt", "mint"], "]"}], "/", 
        RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"tsides", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"mint", " ", 
          SuperscriptBox["mult", "i"]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tbins", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tsides", "[", 
            RowBox[{"[", "i", "]"}], "]"}], ",", 
           RowBox[{"tsides", "[", 
            RowBox[{"[", 
             RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tsizes", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tmeans", "=", 
       RowBox[{"Mean", "[", 
        RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"intergra", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"timex", ",", 
             RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"pergra", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"Exp", "[", 
              RowBox[{"intergra", "[", 
               RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"tx", ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"tbins", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
             RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
             RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
        RowBox[{"res", "=", 
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"tmeans", ",", 
              FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
          "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"pergra", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{"NIntegrate", "[", 
           RowBox[{
            RowBox[{"intergra", "[", 
             RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"tx", ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
              RowBox[{"tbins", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
            RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
            RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
          RowBox[{"tsizes", "[", 
           RowBox[{"[", "i", "]"}], "]"}]], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"res", "[", 
        RowBox[{"ty", ",", "kf"}], "]"}], "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"tmeans", ",", 
            RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}]}]}],
      ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"autorand", "[", 
     RowBox[{"ty_", ",", "mu_", ",", "kf_", ",", "rlist_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"typ", "=", "ty"}], ";", 
       RowBox[{"mult", "=", "mu"}], ";", 
       RowBox[{"k", "=", "kf"}], ";", 
       RowBox[{"binned", "=", "rlist"}], ";", 
       RowBox[{"ll", "=", 
        RowBox[{"Length", "[", "binned", "]"}]}], ";", 
       RowBox[{"merr", "=", 
        RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"autovariance", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{"1", ";;", 
                 RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "merr"}], 
             ")"}], ".", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"binned", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
              "merr"}], ")"}]}], "ll"], ",", 
          RowBox[{"{", 
           RowBox[{"shi", ",", "0", ",", 
            RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"f11", "=", 
        RowBox[{"FourierDCT", "[", 
         RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
       RowBox[{"num", "=", 
        RowBox[{"Floor", "[", 
         FractionBox["ll", "2"], "]"}]}], ";", 
       RowBox[{"sur", "=", 
        RowBox[{
         FractionBox[
          SqrtBox["2"], 
          RowBox[{"2", "\[Pi]"}]], 
         SqrtBox["ll"], 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{"f11", ",", "2"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"sur", ",", 
         RowBox[{"sur", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"timex", "=", 
        RowBox[{"4.", 
         RowBox[{"ll", "/", 
          RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
       RowBox[{"mint", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
       RowBox[{"maxt", "=", 
        RowBox[{"timex", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", 
       RowBox[{"nn", "=", 
        RowBox[{
         RowBox[{"Log", "[", 
          FractionBox["maxt", "mint"], "]"}], "/", 
         RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"tsides", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"mint", " ", 
           SuperscriptBox["mult", "i"]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tbins", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"tsides", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"tsides", "[", 
             RowBox[{"[", 
              RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tsizes", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
           RowBox[{"tbins", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tmeans", "=", 
        RowBox[{"Delete", "[", 
         RowBox[{
          RowBox[{"Mean", "[", 
           RowBox[{"Transpose", "[", "tbins", "]"}], "]"}], ",", 
          RowBox[{"-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"intergra", "=", 
        RowBox[{"Interpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"tra", "=", 
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"timex", ",", 
               RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}]}], "]"}], ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"pergra", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{"Exp", "[", 
               RowBox[{"intergra", "[", 
                RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"tx", ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
              RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
              RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
         RowBox[{"res", "=", 
          RowBox[{"Select", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"tmeans", ",", 
               FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
           "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"pergra", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            FractionBox[
             RowBox[{"NIntegrate", "[", 
              RowBox[{
               RowBox[{"intergra", "[", 
                RowBox[{"Log", "[", "tx", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"tx", ",", 
                 RowBox[{"tbins", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"tbins", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
               RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
               RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], 
             RowBox[{"tsizes", "[", 
              RowBox[{"[", "i", "]"}], "]"}]], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "nn"}], 
             RowBox[{"(*", 
              RowBox[{"+", "1"}], "*)"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"pergra", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"sel", "=", 
            RowBox[{"Select", "[", 
             RowBox[{"timex", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}], "<", "#", "<", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "&"}]}], "]"}]}], 
           ";", 
           RowBox[{"inttime", "=", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Flatten", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "2"}], "]"}], "]"}], ",", "sel", ",", 
                RowBox[{"tbins", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "1"}], "]"}], "]"}]}], "}"}], "]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"intxx", "=", 
            RowBox[{
             RowBox[{"intergra", "[", 
              RowBox[{"Log", "[", "tx", "]"}], "]"}], "/.", 
             RowBox[{"tx", "\[Rule]", "inttime"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"deltax", "=", 
            RowBox[{"Differences", "[", "inttime", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{
               FractionBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"intxx", "[", 
                   RowBox[{"[", "kk", "]"}], "]"}], "+", 
                  RowBox[{"intxx", "[", 
                   RowBox[{"[", 
                    RowBox[{"kk", "+", "1"}], "]"}], "]"}]}], ")"}], "2"], 
               RowBox[{"deltax", "[", 
                RowBox[{"[", "kk", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"kk", ",", 
                RowBox[{
                 RowBox[{"Length", "[", "inttime", "]"}], "-", "1"}]}], 
               "}"}]}], "]"}], "/", 
            RowBox[{"tsizes", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nn"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"resy", "=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"tmeans", ",", 
             RowBox[{"Exp", "[", "pergra", "]"}]}], "}"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], 
         "]"}]}]}], ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"3", ",", "1.2", ",", "6"}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"lpl3", "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", "\"\<FourierDCT of autovariance\>\""}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"tofit3", "=", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"A", " ", 
         RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
      RowBox[{"FindFit", "[", 
       RowBox[{
        RowBox[{"Log", "[", "res", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"logpl3", "=", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{"tofit3", ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"res", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"res", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl3", ",", "logpl3"}], "]"}]}], 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5686439274432755`*^9, 3.5686439603749332`*^9}, {
   3.5686451629862075`*^9, 3.5686451856374474`*^9}, {3.5686452238107147`*^9, 
   3.568645224060315*^9}, {3.56864527792721*^9, 3.5686452795340123`*^9}, {
   3.5686475480025587`*^9, 3.5686475486109595`*^9}, {3.5686486517096863`*^9, 
   3.5686486798521357`*^9}, {3.568649804547723*^9, 3.5686498966658845`*^9}, {
   3.568650080917808*^9, 3.568650142881117*^9}, {3.568650191912003*^9, 
   3.568650192473604*^9}, {3.5686504541512637`*^9, 3.568650473729298*^9}, {
   3.5686509820415907`*^9, 3.5686511574618998`*^9}, {3.568651441439598*^9, 
   3.5686514679596443`*^9}, {3.568652600865834*^9, 3.5686526186810656`*^9}, {
   3.5686526510979223`*^9, 3.5686527356666713`*^9}, {3.5686534018536034`*^9, 
   3.5686534150044265`*^9}, {3.5686541196155853`*^9, 
   3.5686541365906086`*^9}, {3.56865418756568*^9, 3.568654188135681*^9}, {
   3.568654261385783*^9, 3.568654264630788*^9}, {3.5686571128482122`*^9, 
   3.5686571159214177`*^9}, {3.5686743062539015`*^9, 3.56867431938892*^9}, {
   3.5686745663492656`*^9, 3.568674568974269*^9}, {3.5686757574482994`*^9, 
   3.5686757867295504`*^9}, {3.5686758566488733`*^9, 3.568675912777772*^9}, 
   3.568675949391036*^9, {3.56867605980803*^9, 3.568676061118432*^9}, {
   3.5686761408813725`*^9, 3.568676141208973*^9}, {3.5686762215179143`*^9, 
   3.568676225854722*^9}, {3.5686762768512115`*^9, 3.5686762805952177`*^9}, {
   3.568676756568654*^9, 3.56867676009426*^9}, {3.5687322632105227`*^9, 
   3.56873226844553*^9}, {3.5687323603038664`*^9, 3.56873240813355*^9}, 
   3.568732799124943*^9, {3.568732924601118*^9, 3.568732926276121*^9}, {
   3.5687334021941023`*^9, 3.568733460023404*^9}, {3.568733522532714*^9, 
   3.5687335375711403`*^9}, {3.5687338285272512`*^9, 
   3.5687338298532534`*^9}, {3.568733990581336*^9, 3.5687340011113544`*^9}, {
   3.568734122885168*^9, 3.568734123306369*^9}, 3.56873427757504*^9, {
   3.568734397804451*^9, 3.568734422483694*^9}, {3.568734709465399*^9, 
   3.568734710526201*^9}, {3.5687675388524036`*^9, 3.5687675394140043`*^9}, {
   3.5688219411048136`*^9, 3.5688219660180573`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ttx", "=", 
   RowBox[{"TimeUsed", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "fr", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}], ",", 
   RowBox[{"Dynamic", "[", "o", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"20", ",", "1500"}], "}"}], ",", "All"}], "}"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=."}], ";", 
  RowBox[{"fr", "=."}], ";", 
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";", 
  RowBox[{"types", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Flux\>\"", ",", "\"\<LP\>\"", ",", "\"\<EVPA\>\"", ",", 
     "\"\<CP\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"Do", "[", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Frequency  = \>\"", ",", 
        RowBox[{"freqs", "[", 
         RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz\>\""}], "]"}], ";"}], 
     "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      StyleBox[
       RowBox[{"autovar", "[", 
        RowBox[{"typ", ",", "3.0", ",", "fr"}], "]"}],
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox[";",
       FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"resx", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"timex", "[", 
               RowBox[{"[", 
                RowBox[{"-", "1"}], "]"}], "]"}], ",", 
              RowBox[{"sur", "[", 
               RowBox[{"[", 
                RowBox[{"-", "1"}], "]"}], "]"}]}], "}"}], "}"}], ",", "res", 
           ",", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"timex", "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"sur", "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"tofit4", "=", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"A", " ", 
             RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
          RowBox[{"FindFit", "[", 
           RowBox[{
            RowBox[{"Log", "[", "resx", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"PrependTo", "[", 
         RowBox[{"resx", ",", 
          RowBox[{"{", 
           RowBox[{"4.", ",", 
            RowBox[{"(*", "0.5", "*)"}], 
            RowBox[{"tofit4", "/.", 
             RowBox[{"x", "\[Rule]", "4."}]}]}], "}"}]}], "]"}], ";"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"PrependTo", "[", 
         RowBox[{"resx", ",", 
          RowBox[{"{", 
           RowBox[{"8.", ",", 
            RowBox[{"tofit4", "/.", 
             RowBox[{"x", "\[Rule]", "8."}]}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"PrependTo", "[", 
         RowBox[{"resx", ",", 
          RowBox[{"{", 
           RowBox[{"4.", ",", 
            RowBox[{"(*", "0.5", "*)"}], 
            RowBox[{"tofit4", "/.", 
             RowBox[{"x", "\[Rule]", "4."}]}]}], "}"}]}], "]"}], ";"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"resx", "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"res", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"timex", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"sur", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tofit4", "=", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"A", " ", 
           RowBox[{"Log", "[", "x", "]"}]}], "+", "B"}], "]"}], "/.", 
        RowBox[{"FindFit", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"res", "[", 
            RowBox[{"typ", ",", "fr"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"A", " ", "x"}], "+", "B"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"A", ",", "B"}], "}"}], ",", "x"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"resx", "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"#", ",", 
             RowBox[{
              FractionBox[
               RowBox[{
                RowBox[{"tofit4", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                RowBox[{"x", "\[Rule]", "#"}]}], 
               RowBox[{
                RowBox[{"tofit4", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                RowBox[{"x", "\[Rule]", 
                 RowBox[{
                  RowBox[{"res", "[", 
                   RowBox[{"typ", ",", "fr"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
              RowBox[{
               RowBox[{"res", "[", 
                RowBox[{"typ", ",", "fr"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
          RowBox[{"{", 
           RowBox[{"4", ",", "8"}], "}"}]}], ",", "resx"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"resx", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"#", ",", 
              RowBox[{
               FractionBox[
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", "#"}]}], 
                RowBox[{
                 RowBox[{"tofit4", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
                 RowBox[{"x", "\[Rule]", 
                  RowBox[{"res", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}]], 
               RowBox[{"res", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], "&"}], "/@", 
           RowBox[{"{", 
            RowBox[{"4", ",", "8"}], "}"}]}], ",", "res", ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"timex", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"sur", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "}"}]}], "]"}]}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"interand", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", "resx", "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDfluxx", "[", 
         RowBox[{"typ", ",", "fr"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{"resx", ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Green", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"autovar", "[", 
        RowBox[{"typ", ",", "1.2", ",", "fr"}], "]"}],
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox[";",
       FontColor->RGBColor[1, 0, 0]], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         StyleBox[
          RowBox[{"PSDflux", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}],
          FontColor->RGBColor[0, 0, 1]], "=", 
         RowBox[{"ListLogLogPlot", "[", 
          RowBox[{"res", ",", 
           RowBox[{"PlotStyle", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Black", ",", 
              RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
           RowBox[{"FrameLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
             "}"}]}]}], "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Print", "[", 
         RowBox[{"Show", "[", 
          RowBox[{
           StyleBox[
            RowBox[{"PSDflux", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}],
            FontColor->RGBColor[0, 0, 1]], ",", 
           StyleBox[
            RowBox[{"PSDfluxx", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}],
            FontColor->RGBColor[0, 0, 1]]}], "]"}], "]"}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"nux", "=", "154"}], ";", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"22", " ", "-", " ", 
         RowBox[{"1", "\[Sigma]"}]}], ";", " ", 
        RowBox[{"154", " ", "-", " ", 
         RowBox[{"2", "\[Sigma]"}]}], ";", " ", 
        RowBox[{"2592", " ", "-", " ", 
         RowBox[{"3", "\[Sigma]"}]}], ";", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"7", "/", 
           RowBox[{"(", 
            RowBox[{"1", "-", "#"}], ")"}]}], "&"}], "/@", 
         RowBox[{"{", 
          RowBox[{
          "0.682689492137086", ",", "0.954499736103642", ",", 
           "0.997300203936740"}], "}"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"tabresy", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"randx", "=", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"RandomVariate", "[", 
                RowBox[{
                 RowBox[{"NormalDistribution", "[", "]"}], ",", "5000"}], 
                "]"}], "+", 
               RowBox[{"\[ImaginaryI]", " ", 
                RowBox[{"RandomVariate", "[", 
                 RowBox[{
                  RowBox[{"NormalDistribution", "[", "]"}], ",", "5000"}], 
                 "]"}]}]}], ")"}], 
             SqrtBox[
              RowBox[{"Exp", "[", 
               RowBox[{"interand", "[", 
                RowBox[{"Log", "[", 
                 RowBox[{"20000", "/", 
                  RowBox[{"Range", "[", "5000", "]"}]}], "]"}], "]"}], 
               "]"}]]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"rsxx", "=", 
            RowBox[{"4.8", 
             RowBox[{"Re", "[", 
              RowBox[{"InverseFourier", "[", "randx", "]"}], "]"}]}]}], ";"}], 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"+", "me"}], ";"}], 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"-", "for"}], " ", "formal", " ", "correspondence"}], 
            "*)"}], "*)"}], ";", "\[IndentingNewLine]", 
          RowBox[{"resy", "=", 
           StyleBox[
            RowBox[{"autorand", "[", 
             RowBox[{"typ", ",", "1.2", ",", "fr", ",", "rsxx"}], "]"}],
            FontColor->RGBColor[1, 0, 0]]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"o", ",", "nux"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         StyleBox[
          RowBox[{"PSDFrand", "[", "aa", "]"}],
          FontColor->RGBColor[0, 0, 1]], "=", 
         RowBox[{"ListLogLogPlot", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ress", "[", "aa", "]"}], "=", 
            RowBox[{"tabresy", "[", 
             RowBox[{"[", "aa", "]"}], "]"}]}], ",", 
           RowBox[{"PlotStyle", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Red", ",", 
              RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
           RowBox[{"FrameLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
             "}"}]}]}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"aa", ",", "nux"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmean", "[", 
        RowBox[{"typ", ",", "fr"}], "]"}], "=", 
       RowBox[{"Exp", "[", 
        FractionBox[
         RowBox[{"Total", "[", 
          RowBox[{"Log", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"ress", "[", "i", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}], "]"}], "nux"],
         "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFrandmean", "[", 
         RowBox[{"typ", ",", "fr"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"ressmean", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "7", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDflux", "[", 
         RowBox[{"typ", ",", "fr"}], "]"}],
        FontColor->RGBColor[0., 0., 1.]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"res", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}], ",", 
         RowBox[{"Epilog", "\[Rule]", "\[IndentingNewLine]", 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"types", "[", 
                RowBox[{"[", 
                 RowBox[{"typ", "-", "2"}], "]"}], "]"}], "<>", 
               "\"\< at \>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Floor", "[", 
                 RowBox[{"freqs", "[", 
                  RowBox[{"[", "fr", "]"}], "]"}], "]"}], "]"}], "<>", 
               "\"\<GHz\>\""}], ",", "18", ",", "Bold"}], "]"}], ",", 
            RowBox[{"Scaled", "[", 
             RowBox[{"{", 
              RowBox[{"0.3", ",", "0.8"}], "}"}], "]"}]}], "]"}]}]}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Print", "[", 
         RowBox[{"Show", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             StyleBox[
              RowBox[{"PSDFrand", "[", "i", "]"}],
              FontColor->RGBColor[0, 0, 1]], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], ",", 
           StyleBox[
            RowBox[{"PSDflux", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}],
            FontColor->RGBColor[0, 0, 1]], ",", 
           StyleBox[
            RowBox[{"PSDFrandmean", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}],
            FontColor->RGBColor[0, 0, 1]], ",", 
           StyleBox[
            RowBox[{"PSDfluxx", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}],
            FontColor->RGBColor[0, 0, 1]]}], "]"}], "]"}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resstot", "[", 
        RowBox[{"typ", ",", "fr"}], "]"}], "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ress", "[", "i", "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "nux"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"resst", "=", 
       RowBox[{
        RowBox[{"ress", "[", "1", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"ressmax", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], "=", 
         RowBox[{"Max", "@@@", 
          RowBox[{"resstot", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}]}]}], ";", 
        RowBox[{
         RowBox[{"ressmin", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], "=", 
         RowBox[{"Min", "@@@", 
          RowBox[{"resstot", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}]}]}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmax", "[", 
        RowBox[{"typ", ",", "fr"}], "]"}], "=", 
       RowBox[{"Mean", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"RankedMax", "[", 
             RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
           RowBox[{"resstot", "[", 
            RowBox[{"typ", ",", "fr"}], "]"}]}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"RankedMax", "[", 
             RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
           RowBox[{"resstot", "[", 
            RowBox[{"typ", ",", "fr"}], "]"}]}]}], "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ressmin", "[", 
        RowBox[{"typ", ",", "fr"}], "]"}], "=", 
       RowBox[{"Mean", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"RankedMin", "[", 
             RowBox[{"#", ",", "3"}], "]"}], "&"}], "/@", 
           RowBox[{"resstot", "[", 
            RowBox[{"typ", ",", "fr"}], "]"}]}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"RankedMin", "[", 
             RowBox[{"#", ",", "4"}], "]"}], "&"}], "/@", 
           RowBox[{"resstot", "[", 
            RowBox[{"typ", ",", "fr"}], "]"}]}]}], "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFmin", "[", 
         RowBox[{"typ", ",", "fr"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"resst", ",", 
            RowBox[{"ressmin", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}]}], "}"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Dotted"}], 
           "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       StyleBox[
        RowBox[{"PSDFmax", "[", 
         RowBox[{"typ", ",", "fr"}], "]"}],
        FontColor->RGBColor[0, 0, 1]], "=", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"resst", ",", 
            RowBox[{"ressmax", "[", 
             RowBox[{"typ", ",", "fr"}], "]"}]}], "}"}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
           "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"Print", "[", 
       RowBox[{"Show", "[", 
        StyleBox[
         RowBox[{
          RowBox[{"PSDflux", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}], ",", 
          RowBox[{"PSDFmin", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}], ",", 
          RowBox[{"PSDFmax", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}], ",", 
          RowBox[{"PSDflux", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}], ",", 
          RowBox[{"PSDFrandmean", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}], ",", 
          RowBox[{"PSDfluxx", "[", 
           RowBox[{"typ", ",", "fr"}], "]"}]}],
         FontColor->RGBColor[0, 0, 1]], "]"}], "]"}], "*)"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"typ", ",", "3", ",", "6"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Computed in \>\"", ",", 
    RowBox[{
     RowBox[{"TimeUsed", "[", "]"}], "-", "ttx"}], ",", "\"\<s\>\""}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"125", "s", " ", "for", " ", "1", "\[Sigma]"}], " ", "\[Implies]",
     " ", 
    RowBox[{
     RowBox[{"709", "s", 
      RowBox[{"(", 
       RowBox[{"12", "min"}], ")"}], " ", "for", " ", "2", "\[Sigma]"}], " ", 
     "\[Implies]", " ", 
     RowBox[{
     "expected", " ", "3.5", "hrs", " ", "for", " ", "3", "\[Sigma]"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.568658690181983*^9, 3.5686587401332707`*^9}, {
   3.5686588111757956`*^9, 3.5686588548880725`*^9}, {3.5686588922033377`*^9, 
   3.568658925977397*^9}, {3.5686589703906755`*^9, 3.5686589774106874`*^9}, {
   3.568672919401613*^9, 3.5686729589816833`*^9}, {3.5686734755153365`*^9, 
   3.5686734758803368`*^9}, 3.568673902517336*^9, {3.5686740475725393`*^9, 
   3.5686740736925755`*^9}, {3.5686741992477517`*^9, 3.568674207342763*^9}, {
   3.5686743702339907`*^9, 3.568674420479061*^9}, {3.5686746579543934`*^9, 
   3.5686746640944023`*^9}, {3.5686747825547867`*^9, 
   3.5686747836467886`*^9}, {3.568675093166932*^9, 3.5686751107637634`*^9}, {
   3.5686751638818564`*^9, 3.5686751860962954`*^9}, {3.5686752638780317`*^9, 
   3.5686752932372837`*^9}, 3.568676352200344*^9, {3.568676425036872*^9, 
   3.5686764268152747`*^9}, {3.5686765814583464`*^9, 
   3.5686765815051465`*^9}, {3.568676612564801*^9, 3.5686766292880306`*^9}, {
   3.5686768069879427`*^9, 3.568676807112743*^9}, {3.568676887780484*^9, 
   3.5686768878896847`*^9}, {3.5686769802106466`*^9, 
   3.5686770449975605`*^9}, {3.568677177254593*^9, 3.5686771780189943`*^9}, {
   3.5686772390463014`*^9, 3.5686772393739023`*^9}, {3.568677286049184*^9, 
   3.5686773642833214`*^9}, {3.568677400110385*^9, 3.568677400484785*^9}, {
   3.568677507665374*^9, 3.5686775082269745`*^9}, {3.5686775809855022`*^9, 
   3.568677667160054*^9}, {3.568677724162554*^9, 3.568677768326232*^9}, {
   3.5686784189103737`*^9, 3.5686784731984696`*^9}, {3.568678528562967*^9, 
   3.5686785340073767`*^9}, {3.568678600557093*^9, 3.5686786208995285`*^9}, {
   3.5686786550323887`*^9, 3.5686786624268017`*^9}, {3.568678748679353*^9, 
   3.5686787518617587`*^9}, {3.568678943851296*^9, 3.568678944178897*^9}, {
   3.568679095826763*^9, 3.5686790961543636`*^9}, 3.5687143742988043`*^9, {
   3.568718293597542*^9, 3.568718293925143*^9}, {3.568733412817721*^9, 
   3.568733427575347*^9}, {3.5687335444663525`*^9, 3.568733613090873*^9}, {
   3.568733746627107*^9, 3.5687337937547903`*^9}, {3.5687342807418456`*^9, 
   3.5687343666823964`*^9}, {3.5687344259001007`*^9, 
   3.5687344394877243`*^9}, {3.568734477239791*^9, 3.5687345461451116`*^9}, {
   3.5687345797823715`*^9, 3.568734589844389*^9}, {3.5687346756289396`*^9, 
   3.568734677563343*^9}, {3.568734894974286*^9, 3.568734922929535*^9}, {
   3.5687349655332103`*^9, 3.5687349764844294`*^9}, {3.568735012192892*^9, 
   3.56873502830772*^9}, {3.568735147273529*^9, 3.568735195914415*^9}, {
   3.568735337110263*^9, 3.568735339029066*^9}, {3.568735384331546*^9, 
   3.568735388949154*^9}, {3.5687354326448307`*^9, 3.5687354327852306`*^9}, {
   3.568735491519334*^9, 3.568735505184958*^9}, {3.5687364997865577`*^9, 
   3.568736499896558*^9}, {3.568743415518503*^9, 3.568743415643503*^9}, {
   3.568743713589615*^9, 3.5687437136364155`*^9}, {3.5687441249311376`*^9, 
   3.5687441349005547`*^9}, {3.5687456117645607`*^9, 3.568745675733219*^9}, {
   3.568745710904231*^9, 3.5687457803412027`*^9}, {3.568745836047389*^9, 
   3.5687458519833*^9}, {3.568746269593191*^9, 3.5687463055824547`*^9}, {
   3.568746362210554*^9, 3.5687463633961563`*^9}, {3.5687464472712975`*^9, 
   3.5687464474012976`*^9}, {3.568746524051405*^9, 3.5687465241114054`*^9}, {
   3.5687465874514937`*^9, 3.568746587516494*^9}, {3.5687466340115585`*^9, 
   3.5687466340965595`*^9}, {3.5687466830126286`*^9, 3.5687466830926285`*^9}, 
   3.5687467437727137`*^9, {3.568746883758145*^9, 3.5687468841949453`*^9}, {
   3.568746932711031*^9, 3.568746932867031*^9}, {3.5687483065115275`*^9, 
   3.5687483066051273`*^9}, {3.568748356905614*^9, 3.5687483570772142`*^9}, {
   3.5687484849978333`*^9, 3.5687484851070337`*^9}, {3.5687486793365183`*^9, 
   3.5687487039165525`*^9}, 3.5687487503066173`*^9, {3.5687487915866747`*^9, 
   3.568748868616783*^9}, 3.568748930046869*^9, {3.5687648297268953`*^9, 
   3.568764830431896*^9}, {3.5687651183353004`*^9, 3.5687651217753053`*^9}, {
   3.568765172395376*^9, 3.568765172775377*^9}, {3.5687652432954755`*^9, 
   3.5687652504354854`*^9}, {3.5687653239655886`*^9, 
   3.5687654154007163`*^9}, {3.5687654918858232`*^9, 3.568765522375866*^9}, {
   3.568765635131024*^9, 3.5687656600910587`*^9}, {3.5687657746762195`*^9, 
   3.568765779146226*^9}, {3.5687658126242733`*^9, 3.5687658187242823`*^9}, {
   3.5687659304504385`*^9, 3.5687659560604744`*^9}, {3.5687660151155567`*^9, 
   3.5687660156055574`*^9}, {3.5687660518306084`*^9, 3.56876608879066*^9}, {
   3.568766907469807*^9, 3.5687669171198206`*^9}, {3.5687669640798864`*^9, 
   3.5687669661198893`*^9}, {3.5687675173867655`*^9, 
   3.5687675633756466`*^9}, {3.568821997140112*^9, 3.568822020852154*^9}, {
   3.5688220594154215`*^9, 3.568822062551027*^9}, {3.568822107572706*^9, 
   3.568822116667522*^9}, {3.568822153592787*^9, 3.568822194090458*^9}, {
   3.5688227530290003`*^9, 3.5688227588010106`*^9}, {3.5688228373783484`*^9, 
   3.5688228857228336`*^9}, {3.5688229377967253`*^9, 
   3.5688229695895805`*^9}, {3.5688230020376377`*^9, 
   3.5688230069828463`*^9}, {3.56882307145776*^9, 3.568823184807559*^9}, {
   3.5688232887817416`*^9, 3.5688233510570507`*^9}, {3.568823574855044*^9, 
   3.5688235769298477`*^9}, {3.568823624853132*^9, 3.568823626522335*^9}, {
   3.568823907307228*^9, 3.568823937727281*^9}, {3.5688242497905293`*^9, 
   3.5688242498997297`*^9}, {3.5688249598546658`*^9, 3.568824963988673*^9}, {
   3.5688249955007286`*^9, 3.568824998527134*^9}, {3.568825583173684*^9, 
   3.5688256067765255`*^9}, {3.5688257669956055`*^9, 
   3.5688257915968485`*^9}, {3.5688265201971283`*^9, 3.568826526140739*^9}, {
   3.56882670801742*^9, 3.568826716082634*^9}, {3.5688267536163*^9, 
   3.568826758140308*^9}, {3.5689471428856163`*^9, 3.5689471430572166`*^9}, {
   3.5689472945024767`*^9, 3.568947305391296*^9}}],

Cell[BoxData[
 RowBox[{"grgr", "=", 
  RowBox[{"GraphicsGrid", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{"{", 
       StyleBox[
        RowBox[{
         RowBox[{"PSDflux", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"PSDFmin", "[", 
            RowBox[{"typ", ",", "fr"}], "]"}], ","}], "*)"}], 
         RowBox[{"PSDFmax", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], ",", 
         RowBox[{"PSDflux", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], ",", 
         RowBox[{"PSDFrandmean", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}], ",", 
         RowBox[{"PSDfluxx", "[", 
          RowBox[{"typ", ",", "fr"}], "]"}]}],
        FontColor->RGBColor[0, 0, 1]], 
       StyleBox["}",
        FontColor->RGBColor[0, 0, 1]]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"typ", ",", "3", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.568765709706128*^9, 3.5687657570961947`*^9}, {
  3.568766150610747*^9, 3.5687661926308055`*^9}, {3.5687676090213265`*^9, 
  3.5687676147465367`*^9}, {3.5687677042756658`*^9, 3.5687677075856705`*^9}, {
  3.568826535828356*^9, 3.568826536140356*^9}, {3.5689450632113714`*^9, 
  3.5689450639601727`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"#", ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Blue", ",", 
         RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"ListPlot", ",", "ListLogLogPlot"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"lmax", "=", 
        RowBox[{"Quotient", "[", 
         RowBox[{"l", ",", "2"}], "]"}]}], ";"}], "*)"}], 
     RowBox[{"lmax", "=", "150"}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"4", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveF", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<Flux, Jy\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveLP", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<LP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveEVPA", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<EVPA angle, deg\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveCP", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<CP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGCQAGIQrbT3gKBm3ivHHGcHERA9UWO5JIgOCpqtBKKNCk00
QTSDGJMWiL7kuVgfRJfNvGUEone6VdiA5dd6BYHo5rnPwkB0S8arXBB9Suda
MYjWaJesAdFsRT98tYG0WtkvMN1/5eAuW5D4lotgen7u9wuuQHrW/t9g+gjj
8/sgWuvu6ccg2jRt7TsQPXXa/o8get+dt5xuQPoW+1cw/Y9n5oMMIP0nxf8x
iGb7tOAziN5luQhMn+OszHzfDHRP97tcEO3nx1gMogVUP9eB6PN8N5tAdPiz
ra0gOuP1r24QbWeT0weiV7yasgNE35jZdgBEn1y08iKIrtFYchVEbzq3OOf5
lFeO3RnaRSC6Yofji+RprxxF10/6CKLXcSd9A9EqJRd4UoA0AHSfya8=
  "]],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"nums", ",", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1", ",", "12"}], "]"}], "]"}]}], "}"}], "]"}], 
   ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.568509597296516*^9, 3.568509631398176*^9}, {
  3.5685096636278324`*^9, 3.568509678619459*^9}}],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDflux", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDLP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDEVPA", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDCP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveF", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveLP", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveEVPA", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveCP", "[", "k", "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5588336899835253`*^9, 3.558833763719743*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fr", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "[", 
  RowBox[{"[", "fr", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{
    SuperscriptBox["10", "7"], 
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "fr", ",", "12"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5474244310872493`*^9, 3.5474244563596945`*^9}, {
   3.5474244888795547`*^9, 3.547424515096054*^9}, {3.5474245485119658`*^9, 
   3.547424574191434*^9}, {3.5475470934034843`*^9, 3.5475470957396173`*^9}, 
   3.547547753886261*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["lightcurve th=237 (no B cut, B red, thlimit=0.1)", "Subsection",
 CellChangeTimes->{{3.5577510472865367`*^9, 3.55775104944654*^9}, {
  3.55883260748061*^9, 3.558832631388977*^9}, {3.560872675917722*^9, 
  3.56087270326457*^9}, {3.5610765919205837`*^9, 3.5610766169586277`*^9}, {
  3.567729128601217*^9, 3.5677291508874917`*^9}, {3.5685060616481857`*^9, 
  3.5685060618041863`*^9}, {3.568506336458269*^9, 3.5685063368950696`*^9}, {
  3.568514458578314*^9, 3.568514461043118*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dir0", "=", 
   "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\th237lo\\\\\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fil", "=", 
   RowBox[{"dir0", "<>", "\"\<totspec.dat\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"coe", "=", "1"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"imp", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Import", "[", 
        RowBox[{"dir0", "<>", "\"\<poliresa93.75th237fn\>\"", "<>", 
         RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"fnum", ",", "2000", ",", "6999", ",", "coe"}], "}"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Put", "[", 
     RowBox[{"imp", ",", "fil"}], "]"}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Get", "[", "fil", "]"}]}], ";", 
  RowBox[{"Dimensions", "[", "imp", "]"}]}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, 
   3.5486008696865225`*^9, {3.548600915220127*^9, 3.548600929823962*^9}, {
   3.551033749980384*^9, 3.551033750871435*^9}, {3.5510337885625906`*^9, 
   3.5510337966150513`*^9}, {3.5520186449336777`*^9, 3.552018650318986*^9}, {
   3.55771381499922*^9, 3.557713848242878*^9}, {3.557714021184782*^9, 
   3.5577140212159815`*^9}, {3.557735285968544*^9, 3.557735286467745*^9}, {
   3.557735457912046*^9, 3.5577354872556973`*^9}, {3.5577395741124763`*^9, 
   3.5577395758284793`*^9}, {3.557855418955073*^9, 3.5578554191790857`*^9}, {
   3.5588325820031524`*^9, 3.5588325935978155`*^9}, {3.560872762763075*^9, 
   3.560872763870677*^9}, {3.5608728196547747`*^9, 3.560872849887628*^9}, {
   3.56087349695055*^9, 3.560873499446555*^9}, {3.560875165560282*^9, 
   3.560875166028283*^9}, {3.5608801039683924`*^9, 3.560880104514393*^9}, {
   3.5609031767900453`*^9, 3.5609031777421*^9}, {3.561076765174488*^9, 
   3.5610767680448933`*^9}, {3.5677291589449525`*^9, 3.567729159049958*^9}, {
   3.5677293582233505`*^9, 3.567729413559516*^9}, {3.5677295667262764`*^9, 
   3.567729571199532*^9}, {3.5685064387632484`*^9, 3.5685064673268986`*^9}, {
   3.5685068316977386`*^9, 3.568506890634642*^9}, {3.568514464365924*^9, 
   3.568514476621946*^9}, {3.5685146625274725`*^9, 3.568514665631878*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "imp", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"4", 
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"type", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fr", "=", "1"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"1", " ", "-", " ", 
     RowBox[{"43", "GHz"}]}], ",", " ", 
    RowBox[{"11", " ", "-", " ", 
     RowBox[{"5000", "GHz"}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", 
                 RowBox[{"(*", "type", "*)"}], "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "3", "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "6", "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "9", "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
   3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
   3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}, 
   3.568506953861553*^9, {3.5686339307645407`*^9, 3.568633930984541*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"im1", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "3", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"im2", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "6", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"im3", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "9", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux87red.jpg\>\"", ",", "im1",
    ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux230red.jpg\>\"", ",", 
   "im2", ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux857red.jpg\>\"", ",", 
   "im3", ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5677313621689696`*^9, 3.567731539914136*^9}, {
  3.567731608730072*^9, 3.567731750697192*^9}, {3.5685070558389325`*^9, 
  3.568507057461335*^9}, {3.568514805314523*^9, 3.568514808340928*^9}}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "k", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmax", "=", 
   SuperscriptBox["10", "3.2"]}], ";", 
  RowBox[{
   RowBox[{"autovar", "[", 
    RowBox[{"ty_", ",", "mu_", ",", "kf_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"typ", "=", "ty"}], ";", 
      RowBox[{"mult", "=", "mu"}], ";", 
      RowBox[{"k", "=", "kf"}], ";", 
      RowBox[{"binned", "=", 
       RowBox[{"imp", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
      RowBox[{"ll", "=", 
       RowBox[{"Length", "[", "binned", "]"}]}], ";", 
      RowBox[{"me", "=", 
       RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"autovariance", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{"1", ";;", 
                RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], 
            ")"}], ".", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"binned", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
             "me"}], ")"}]}], "ll"], ",", 
         RowBox[{"{", 
          RowBox[{"shi", ",", "0", ",", 
           RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"f11", "=", 
       RowBox[{"FourierDCT", "[", 
        RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
      RowBox[{"num", "=", 
       RowBox[{"Floor", "[", 
        FractionBox["ll", "2"], "]"}]}], ";", 
      RowBox[{"sur", "=", 
       RowBox[{
        FractionBox[
         SqrtBox[
          RowBox[{"2", "ll"}]], 
         RowBox[{"2", "\[Pi]"}]], 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"f11", ",", "2"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"sur", ",", 
        RowBox[{"sur", "[", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"timex", "=", 
       RowBox[{"4.", 
        RowBox[{"ll", "/", 
         RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
      RowBox[{"mint", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
      RowBox[{"maxt", "=", 
       RowBox[{"timex", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", 
      RowBox[{"nn", "=", 
       RowBox[{
        RowBox[{"Log", "[", 
         FractionBox["maxt", "mint"], "]"}], "/", 
        RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"tsides", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"mint", " ", 
          SuperscriptBox["mult", "i"]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tbins", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tsides", "[", 
            RowBox[{"[", "i", "]"}], "]"}], ",", 
           RowBox[{"tsides", "[", 
            RowBox[{"[", 
             RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tsizes", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
          RowBox[{"tbins", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tmeans", "=", 
       RowBox[{"Mean", "[", 
        RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"intergra", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"timex", ",", 
             RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"pergra", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"NIntegrate", "[", 
          RowBox[{
           RowBox[{"Exp", "[", 
            RowBox[{"intergra", "[", 
             RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"tx", ",", 
             RowBox[{"tbins", "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
             RowBox[{"tbins", "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
           RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
           RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
      RowBox[{"res", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"tmeans", ",", 
            FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}]}]}],
      ")"}], "//", "Quiet"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"3", ",", "3.0", ",", "k"}], "]"}], ";", 
    RowBox[{
     RowBox[{"PSDfluxx", "[", "k", "]"}], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Red", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}], 
         "}"}]}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"autovar", "[", 
      RowBox[{"3", ",", "1.2", ",", "k"}], "]"}], ";", 
     RowBox[{
      RowBox[{"PSDflux", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{"res", ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}],
           "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"4", ",", "3.0", ",", "k"}], "]"}], ";", 
    RowBox[{
     RowBox[{"PSDLPx", "[", "k", "]"}], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Red", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of LP\>\""}],
          "}"}]}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"4", ",", "1.2", ",", "k"}], "]"}], ";", 
    RowBox[{
     RowBox[{"PSDLP", "[", "k", "]"}], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Green", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of LP\>\""}],
          "}"}]}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"5", ",", "3.0", ",", "k"}], "]"}], ";", 
    RowBox[{
     RowBox[{"PSDEVPAx", "[", "k", "]"}], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Red", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of EVPA\>\""}], 
         "}"}]}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"5", ",", "1.2", ",", "k"}], "]"}], ";", 
    RowBox[{
     RowBox[{"PSDEVPA", "[", "k", "]"}], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Green", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of EVPA\>\""}], 
         "}"}]}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"6", ",", "3.0", ",", "k"}], "]"}], ";", 
    RowBox[{
     RowBox[{"PSDCPx", "[", "k", "]"}], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Red", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of CP\>\""}],
          "}"}]}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"autovar", "[", 
     RowBox[{"6", ",", "1.2", ",", "k"}], "]"}], ";", 
    RowBox[{
     RowBox[{"PSDCP", "[", "k", "]"}], "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"res", ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Green", ",", 
          RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of CP\>\""}],
          "}"}]}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"PSDfluxx", "[", "k", "]"}], ",", 
       RowBox[{"PSDflux", "[", "k", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"PSDLPx", "[", "k", "]"}], ",", 
       RowBox[{"PSDLP", "[", "k", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"PSDEVPAx", "[", "k", "]"}], ",", 
       RowBox[{"PSDEVPA", "[", "k", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"PSDCPx", "[", "k", "]"}], ",", 
       RowBox[{"PSDCP", "[", "k", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}]}],
   "}"}]}], "Input",
 CellChangeTimes->{{3.568507365546276*^9, 3.5685074426416116`*^9}, {
   3.568507653430182*^9, 3.568507670231412*^9}, {3.5685077026638684`*^9, 
   3.568507704130271*^9}, {3.568507891845401*^9, 3.5685078979138117`*^9}, {
   3.568507942171089*^9, 3.5685079423270893`*^9}, {3.5685080221836295`*^9, 
   3.568508059732896*^9}, {3.5685080947237573`*^9, 3.568508094817357*^9}, {
   3.568508125767812*^9, 3.5685081324290233`*^9}, 3.5685081823335114`*^9, {
   3.568631312035143*^9, 3.5686313451696005`*^9}, {3.5686313814396644`*^9, 
   3.5686313872116747`*^9}, {3.568631433060155*^9, 3.568631533181131*^9}, {
   3.5686316424816914`*^9, 3.568631704591778*^9}, {3.568631876516474*^9, 
   3.5686319424109893`*^9}, {3.5686320215655284`*^9, 
   3.5686321689867873`*^9}, {3.568632296891412*^9, 3.568632362817128*^9}, {
   3.5686324452008724`*^9, 3.568632447057276*^9}, {3.5686325368198338`*^9, 
   3.568632562544279*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"typ", "=", "5"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"tmeans", ",", 
             FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}], 
        ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of EVPA\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "6"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"tmeans", ",", 
             FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}], 
        ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of CP\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5485960291688566`*^9, 3.5485960793437266`*^9}, {
   3.5485961723110437`*^9, 3.548596172431051*^9}, {3.548596217990657*^9, 
   3.548596419205166*^9}, {3.5485964747953453`*^9, 3.548596666441307*^9}, {
   3.548596789027318*^9, 3.548596791313449*^9}, {3.54859689729051*^9, 
   3.5485968982145634`*^9}, {3.5485970754817023`*^9, 
   3.5485970810720224`*^9}, {3.548601094181363*^9, 3.548601141526071*^9}, {
   3.548601228014018*^9, 3.5486012455100183`*^9}, {3.5486015052638755`*^9, 
   3.548601513522348*^9}, {3.5486021619624367`*^9, 3.548602208246084*^9}, {
   3.548603191013295*^9, 3.548603202408947*^9}, {3.548603360132968*^9, 
   3.5486034378874154`*^9}, {3.5486037657511683`*^9, 
   3.5486037953368607`*^9}, {3.557735613195719*^9, 3.5577356251141396`*^9}, {
   3.558833419924079*^9, 3.55883343620601*^9}, {3.5588334863698792`*^9, 
   3.558833498806591*^9}, {3.5685071443690877`*^9, 3.568507150811899*^9}, 
   3.56850747579167*^9, {3.568507920471451*^9, 3.5685079254010596`*^9}, {
   3.5685081572330666`*^9, 3.5685081615698743`*^9}, {3.5685148737060432`*^9, 
   3.5685148739556437`*^9}}],

Cell[BoxData["freqs"], "Input",
 CellChangeTimes->{{3.568508267696861*^9, 3.5685082684768624`*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{"k", ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "9", ",", "kstep"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.56850833546338*^9, 3.5685083551662145`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDflux", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDLP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDCP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}]}],
   "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5486022164095507`*^9, 3.5486022274141808`*^9}, {
   3.548603444138773*^9, 3.54860345773155*^9}, {3.54860351210266*^9, 
   3.5486035139077635`*^9}, {3.55773962159896*^9, 3.557739623002962*^9}, {
   3.5588327715569944`*^9, 3.55883291345411*^9}, {3.56087287944968*^9, 
   3.5608728801828814`*^9}, {3.568508205000351*^9, 3.5685082241571846`*^9}, 
   3.56850835245181*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"#", ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Blue", ",", 
         RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"ListPlot", ",", "ListLogLogPlot"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"lmax", "=", 
        RowBox[{"Quotient", "[", 
         RowBox[{"l", ",", "2"}], "]"}]}], ";"}], "*)"}], 
     RowBox[{"lmax", "=", "150"}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"4", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveF", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<Flux, Jy\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveLP", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<LP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveEVPA", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<EVPA angle, deg\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveCP", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<CP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGCQAGIQrbT3gKBm3ivHHGcHERA9UWO5JIgOCpqtBKKNCk00
QTSDGJMWiL7kuVgfRJfNvGUEone6VdiA5dd6BYHo5rnPwkB0S8arXBB9Suda
MYjWaJesAdFsRT98tYG0WtkvMN1/5eAuW5D4lotgen7u9wuuQHrW/t9g+gjj
8/sgWuvu6ccg2jRt7TsQPXXa/o8get+dt5xuQPoW+1cw/Y9n5oMMIP0nxf8x
iGb7tOAziN5luQhMn+OszHzfDHRP97tcEO3nx1gMogVUP9eB6PN8N5tAdPiz
ra0gOuP1r24QbWeT0weiV7yasgNE35jZdgBEn1y08iKIrtFYchVEbzq3OOf5
lFeO3RnaRSC6Yofji+RprxxF10/6CKLXcSd9A9EqJRd4UoA0AHSfya8=
  "]],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"nums", ",", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1", ",", "12"}], "]"}], "]"}]}], "}"}], "]"}], 
   ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.568509597296516*^9, 3.568509631398176*^9}, {
  3.5685096636278324`*^9, 3.568509678619459*^9}}],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDflux", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDLP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDEVPA", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDCP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveF", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveLP", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveEVPA", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveCP", "[", "k", "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5588336899835253`*^9, 3.558833763719743*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["lightcurve th=237hi (no B cut, B red, thlimit=0.1)", "Subsection",
 CellChangeTimes->{{3.5577510472865367`*^9, 3.55775104944654*^9}, {
  3.55883260748061*^9, 3.558832631388977*^9}, {3.560872675917722*^9, 
  3.56087270326457*^9}, {3.5610765919205837`*^9, 3.5610766169586277`*^9}, {
  3.567729128601217*^9, 3.5677291508874917`*^9}, {3.5685060616481857`*^9, 
  3.5685060618041863`*^9}, {3.568506336458269*^9, 3.5685063368950696`*^9}, {
  3.568514458578314*^9, 3.568514461043118*^9}, {3.56851505965837*^9, 
  3.56851505972077*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dir0", "=", 
   "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\th237hi\\\\\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fil", "=", 
   RowBox[{"dir0", "<>", "\"\<totspec.dat\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"coe", "=", "1"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"imp", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Import", "[", 
        RowBox[{"dir0", "<>", "\"\<poliresa93.75th237fn\>\"", "<>", 
         RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<hi.dat\>\""}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"fnum", ",", "2000", ",", "6999", ",", "coe"}], "}"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Put", "[", 
     RowBox[{"imp", ",", "fil"}], "]"}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Get", "[", "fil", "]"}]}], ";", 
  RowBox[{"Dimensions", "[", "imp", "]"}]}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, 
   3.5486008696865225`*^9, {3.548600915220127*^9, 3.548600929823962*^9}, {
   3.551033749980384*^9, 3.551033750871435*^9}, {3.5510337885625906`*^9, 
   3.5510337966150513`*^9}, {3.5520186449336777`*^9, 3.552018650318986*^9}, {
   3.55771381499922*^9, 3.557713848242878*^9}, {3.557714021184782*^9, 
   3.5577140212159815`*^9}, {3.557735285968544*^9, 3.557735286467745*^9}, {
   3.557735457912046*^9, 3.5577354872556973`*^9}, {3.5577395741124763`*^9, 
   3.5577395758284793`*^9}, {3.557855418955073*^9, 3.5578554191790857`*^9}, {
   3.5588325820031524`*^9, 3.5588325935978155`*^9}, {3.560872762763075*^9, 
   3.560872763870677*^9}, {3.5608728196547747`*^9, 3.560872849887628*^9}, {
   3.56087349695055*^9, 3.560873499446555*^9}, {3.560875165560282*^9, 
   3.560875166028283*^9}, {3.5608801039683924`*^9, 3.560880104514393*^9}, {
   3.5609031767900453`*^9, 3.5609031777421*^9}, {3.561076765174488*^9, 
   3.5610767680448933`*^9}, {3.5677291589449525`*^9, 3.567729159049958*^9}, {
   3.5677293582233505`*^9, 3.567729413559516*^9}, {3.5677295667262764`*^9, 
   3.567729571199532*^9}, {3.5685064387632484`*^9, 3.5685064673268986`*^9}, {
   3.5685068316977386`*^9, 3.568506890634642*^9}, {3.568514464365924*^9, 
   3.568514476621946*^9}, {3.5685146625274725`*^9, 3.568514665631878*^9}, {
   3.568515069392787*^9, 3.5685150768808002`*^9}, {3.568515822700961*^9, 
   3.5685158242609634`*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "imp", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"4", 
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"type", "=", "3"}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"fr", "=", "1"}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"1", " ", "-", " ", 
     RowBox[{"43", "GHz"}]}], ",", " ", 
    RowBox[{"11", " ", "-", " ", 
     RowBox[{"5000", "GHz"}]}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", 
                 RowBox[{"(*", "type", "*)"}], "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
   3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
   3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}, 
   3.568506953861553*^9}],

Cell[BoxData[{
 RowBox[{"gr", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "4", "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "7", "]"}]}], "Input",
 CellChangeTimes->{{3.5677297925331917`*^9, 3.567729842076025*^9}, {
  3.567729972619492*^9, 3.567729981762015*^9}, {3.5677327094310284`*^9, 
  3.5677327107191024`*^9}, {3.568506535296218*^9, 3.5685065357798185`*^9}, {
  3.5685156863207703`*^9, 3.568515697010785*^9}, {3.568515896321064*^9, 
  3.5685158991910677`*^9}, {3.5685159716911697`*^9, 3.5685159759411755`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"im1", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "1", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"im2", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "4", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"im3", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"nums", ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "7", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux87redhi.jpg\>\"", ",", 
   "im1", ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux230redhi.jpg\>\"", ",", 
   "im2", ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux857redhi.jpg\>\"", ",", 
   "im3", ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5677313621689696`*^9, 3.567731539914136*^9}, {
  3.567731608730072*^9, 3.567731750697192*^9}, {3.5685070558389325`*^9, 
  3.568507057461335*^9}, {3.568514805314523*^9, 3.568514808340928*^9}, {
  3.5685160222312403`*^9, 3.5685160384212646`*^9}}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "k", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "3"}], ";", 
  RowBox[{"tmax", "=", 
   SuperscriptBox["10", "3.2"]}], ";", 
  RowBox[{"mult", "=", "1.2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDflux", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"tmeans", ",", 
             FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}], 
        ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}],
           "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "4"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDLP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"tmeans", ",", 
             FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}], 
        ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of LP\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.568507882032984*^9, 3.568507883826987*^9}, {
  3.5685079151206417`*^9, 3.568507915432642*^9}, {3.568508141539439*^9, 
  3.568508152709059*^9}, {3.5685081837999134`*^9, 3.5685081850635157`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"typ", "=", "5"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"tmeans", ",", 
             FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}], 
        ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of EVPA\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "6"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"tmeans", ",", 
             FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "<", "tmax"}], "&"}]}], "]"}], 
        ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of CP\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5485960291688566`*^9, 3.5485960793437266`*^9}, {
   3.5485961723110437`*^9, 3.548596172431051*^9}, {3.548596217990657*^9, 
   3.548596419205166*^9}, {3.5485964747953453`*^9, 3.548596666441307*^9}, {
   3.548596789027318*^9, 3.548596791313449*^9}, {3.54859689729051*^9, 
   3.5485968982145634`*^9}, {3.5485970754817023`*^9, 
   3.5485970810720224`*^9}, {3.548601094181363*^9, 3.548601141526071*^9}, {
   3.548601228014018*^9, 3.5486012455100183`*^9}, {3.5486015052638755`*^9, 
   3.548601513522348*^9}, {3.5486021619624367`*^9, 3.548602208246084*^9}, {
   3.548603191013295*^9, 3.548603202408947*^9}, {3.548603360132968*^9, 
   3.5486034378874154`*^9}, {3.5486037657511683`*^9, 
   3.5486037953368607`*^9}, {3.557735613195719*^9, 3.5577356251141396`*^9}, {
   3.558833419924079*^9, 3.55883343620601*^9}, {3.5588334863698792`*^9, 
   3.558833498806591*^9}, {3.5685071443690877`*^9, 3.568507150811899*^9}, 
   3.56850747579167*^9, {3.568507920471451*^9, 3.5685079254010596`*^9}, {
   3.5685081572330666`*^9, 3.5685081615698743`*^9}, {3.5685148737060432`*^9, 
   3.5685148739556437`*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{"k", ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "9", ",", "kstep"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.56850833546338*^9, 3.5685083551662145`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kmin", "=", "1"}], ";", 
  RowBox[{"kmax", "=", "7"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDflux", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDLP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDCP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], "]"}]}],
   "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5486022164095507`*^9, 3.5486022274141808`*^9}, {
   3.548603444138773*^9, 3.54860345773155*^9}, {3.54860351210266*^9, 
   3.5486035139077635`*^9}, {3.55773962159896*^9, 3.557739623002962*^9}, {
   3.5588327715569944`*^9, 3.55883291345411*^9}, {3.56087287944968*^9, 
   3.5608728801828814`*^9}, {3.568508205000351*^9, 3.5685082241571846`*^9}, 
   3.56850835245181*^9, {3.5685160591012936`*^9, 3.5685160609312963`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kmin", "=", "1"}], ";", 
  RowBox[{"kmax", "=", "7"}], ";", 
  RowBox[{"kstep", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"#", ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Blue", ",", 
         RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"ListPlot", ",", "ListLogLogPlot"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"lmax", "=", 
        RowBox[{"Quotient", "[", 
         RowBox[{"l", ",", "2"}], "]"}]}], ";"}], "*)"}], 
     RowBox[{"lmax", "=", "150"}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"4", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveF", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<Flux, Jy\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveLP", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<LP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveEVPA", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<EVPA angle, deg\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveCP", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<CP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListLogLogPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "kmin", ",", "kmax", ",", "kstep"}], "}"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGCQBGIQrbT3gKBm3ivHHGcHERA9UWO5JIgOCpqtBKKNCk00
QTSDGJMWiL7kuVgfRJfNvGUEone6VdiA5dd6BYHo5rnPwkB0S8arXBB9Suda
MYjWaJesAdFsRT98tYG0WtkvMN1/5eAuW5D4lotgen7u9wuuQHrW/t9g+gjj
8/sgWuvu6ccg2jRt7TsQPXXa/o8get+dt5xuQPoW+1cw/Y9n5oMMIP0nxf8x
iGb7tOAziN5luQhMn+OszHzfDHRP97tcEO3nx1gMogVUP9eB6PN8N5tAdPiz
ra0gOuP1r24QbWeT0weiV7yasgNE35jZdgBEn1y08iKIrtFYchVEbzq3OOf5
lFeO3RnaRSC6Yofji+RprxxF10/6CKLXcSd9A9EqJRd4UoD0zcNtrelAusPk
D5gGAGNP0uQ=
  "]],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"nums", ",", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1", ",", "12"}], "]"}], "]"}]}], "}"}], "]"}], 
   ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.568509597296516*^9, 3.568509631398176*^9}, {
  3.5685096636278324`*^9, 3.568509678619459*^9}}],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDflux", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDLP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDEVPA", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDCP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveF", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveLP", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveEVPA", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveCP", "[", "k", "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5588336899835253`*^9, 3.558833763719743*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["images ", "Subsection",
 CellChangeTimes->{{3.557751054136546*^9, 3.5577510573165507`*^9}, 
   3.5696090266127825`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Clear", "[", "totI", "]"}], ";", 
    RowBox[{"dir", "=", "\"\<E:\\\\GRMHD\\\\Jon\\\\\>\""}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Off", "[", 
     StyleBox[
      RowBox[{"InterpolatingFunction", "::", "dmval"}], "MessageName"], "]"}],
     ";", "\[IndentingNewLine]", 
    RowBox[{"fmin", "=", "6734"}], ";", 
    RowBox[{"fmax", "=", "7034"}], ";", 
    RowBox[{"ind", "=", "2"}], ";", 
    RowBox[{"sep", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"ind", "-", "1"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"fmin", "=", 
       RowBox[{"fmax", "=", "8650"}]}], ";", 
      RowBox[{"ind", "=", "1"}], ";"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"taxx", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"namefile", "=", 
         RowBox[{"dir", "<>", "\"\<shotimag93.75th194f145fn\>\"", "<>", 
          RowBox[{"ToString", "[", "fnum", "]"}], "<>", 
          "\"\<_201.dat\>\""}]}], ";", 
        RowBox[{"fi11", "=", 
         RowBox[{"OpenRead", "[", 
          RowBox[{"namefile", ",", 
           RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
        RowBox[{"params", "=", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"a", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", 
        RowBox[{"th", "=", 
         RowBox[{"Round", "[", 
          RowBox[{
           RowBox[{"Round", "[", 
            RowBox[{
             FractionBox["180", "\[Pi]"], 
             RowBox[{"(", 
              RowBox[{"\[Pi]", "-", 
               RowBox[{"params", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "10"}], "]"}], 
           "/", "10."}], "]"}]}], ";", 
        RowBox[{"nxy", "=", 
         RowBox[{"Round", "[", 
          RowBox[{"params", "[", 
           RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
        RowBox[{"nu", "=", 
         RowBox[{"Round", "[", 
          RowBox[{"params", "[", 
           RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
        RowBox[{"maxy", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "5", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"heat", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "6", "]"}], "]"}]}], ";", 
        RowBox[{"rnohor", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "7", "]"}], "]"}]}], ";", 
        RowBox[{"inten", "=", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
        RowBox[{"Close", "[", "fi11", "]"}], ";", 
        RowBox[{"partres", "=", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{"inten", ",", "5"}], "]"}], ",", 
           RowBox[{"nxy", "+", "1"}]}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"partres", "=", 
     FractionBox[
      RowBox[{"Total", "[", 
       RowBox[{"taxx", ",", 
        RowBox[{"{", "1", "}"}]}], "]"}], "ind"]}], ";", 
    RowBox[{"de", "=", 
     SuperscriptBox["10", 
      RowBox[{"-", "20."}]]}], ";", "\[IndentingNewLine]", 
    RowBox[{"li09", "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{
         RowBox[{"partres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "+", "de"}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"scale09", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"Mean", "[", 
       RowBox[{
        RowBox[{"Sort", "[", 
         RowBox[{"Flatten", "[", 
          RowBox[{"partres", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], "]"}],
         "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"-", "10"}], ";;", 
          RowBox[{"-", "5"}]}], "]"}], "]"}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"csc", "=", "1"}], ";", 
    RowBox[{"mysize", "=", "20"}], ";", 
    RowBox[{"sss", "=", "1."}], ";", "\[IndentingNewLine]", 
    RowBox[{"ph09", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"180", "-", "\[InvisibleSpace]", "120.29"}], ")"}], 
      "\[Degree]"}]}], ";", 
    RowBox[{"(*", 
     RowBox[{
     "from", " ", "actual", " ", "mean", " ", "position", " ", "angles"}], 
     "*)"}], 
    RowBox[{"ph09", "=", "0."}], ";", "\[IndentingNewLine]", 
    RowBox[{"con", "=", "20"}], ";", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
       RowBox[{"contrast", " ", "con"}], "\[Implies]", 
       RowBox[{
       "luminosity", " ", "con", " ", "times", " ", "lower", " ", "is", " ", 
        "black"}]}], ",", 
      RowBox[{"max", " ", "luminosity", " ", "is", " ", "white"}]}], "*)"}], 
    RowBox[{"totI09", "=", 
     RowBox[{"DensityPlot", "[", 
      RowBox[{
       RowBox[{"rr", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"li09", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"y", " ", 
                RowBox[{"Cos", "[", "ph09", "]"}]}], "+", 
               RowBox[{"x", " ", 
                RowBox[{"Sin", "[", "ph09", "]"}]}]}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "y"}], " ", 
                RowBox[{"Sin", "[", "ph09", "]"}]}], "+", 
               RowBox[{"x", " ", 
                RowBox[{"Cos", "[", "ph09", "]"}]}]}]}], "]"}], "-", 
            "scale09"}], ")"}], "/", 
          RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{
          RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
         RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", 
         RowBox[{
          RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
         RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
       RowBox[{"Axes", "\[Rule]", "False"}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
       RowBox[{"PlotPoints", "\[Rule]", "150"}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"RGBColor", "[", 
           RowBox[{
            RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
            RowBox[{"#1", " ", "csc"}], ",", 
            RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
       RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"I05line", "=", 
              RowBox[{
              "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): \
\!\(\*SubscriptBox[\(a\), \(*\)]\)=\>\"", "<>", 
               RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
               "\"\<GHz,   \[Theta]=\>\"", "<>", 
               RowBox[{"ToString", "[", "th", "]"}], "<>", 
               "\"\<\[Degree]\>\""}]}], ",", 
             RowBox[{"mysize", "-", "2"}], ",", "Bold", ",", "Pink"}], "]"}], 
           ",", 
           RowBox[{"Scaled", "[", 
            RowBox[{"{", 
             RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", 
           RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
      "]"}]}]}], "*)"}], "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"LaunchKernels", "[", "]"}], ";", 
    RowBox[{"Print", "[", 
     RowBox[{"Dynamic", "[", "i", "]"}], "]"}], ";", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"CloseKernels", "[", "]"}], ";", 
      RowBox[{"LaunchKernels", "[", "]"}], ";"}]}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"ParallelDo", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"func", "[", "m_", "]"}], ":=", 
      RowBox[{"Quiet", "[", 
       RowBox[{
        RowBox[{
        "dir", "=", "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\movies\\\\\>\""}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"namefile", "=", 
         RowBox[{
         "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\images\\\\th296\\\\\>\"", "<>", 
          "\"\<shotimag93.75th296f230fn\>\"", "<>", 
          RowBox[{"ToString", "[", "m", "]"}], "<>", "\"\<_201.dat\>\""}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"fi11", "=", 
         RowBox[{"OpenRead", "[", 
          RowBox[{"namefile", ",", 
           RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"params", "=", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"a", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", 
        RowBox[{"th", "=", 
         RowBox[{"Round", "[", 
          RowBox[{
           RowBox[{"Round", "[", 
            RowBox[{
             FractionBox["180", "\[Pi]"], 
             RowBox[{"(", 
              RowBox[{"\[Pi]", "-", 
               RowBox[{"params", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "10"}], "]"}], 
           "/", "10."}], "]"}]}], ";", 
        RowBox[{"nxy", "=", 
         RowBox[{"Round", "[", 
          RowBox[{"params", "[", 
           RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
        RowBox[{"nu", "=", 
         RowBox[{"Round", "[", 
          RowBox[{"params", "[", 
           RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
        RowBox[{"maxy", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "5", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"heat", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "6", "]"}], "]"}]}], ";", 
        RowBox[{"rnohor", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "7", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"freqtab", "=", 
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"BinaryReadList", "[", 
              RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", 
               RowBox[{"2", " ", 
                RowBox[{"(", 
                 RowBox[{"flen", "+", "1"}], ")"}]}]}], "]"}], ",", "2"}], 
            "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"inten", "=", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"partres", "=", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{"inten", ",", "5"}], "]"}], ",", 
           RowBox[{"nxy", "+", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Close", "[", "fi11", "]"}], ";", "\n", 
        RowBox[{"nana", "=", 
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{"Round", "[", 
            RowBox[{"100", " ", "a"}], "]"}], "]"}], "<>", "\"\<th\>\"", "<>", 
          RowBox[{"StringJoin", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"ToString", "[", "#", "]"}], "&"}], "/@", 
            RowBox[{"PadLeft", "[", 
             RowBox[{
              RowBox[{"IntegerDigits", "[", 
               RowBox[{"Round", "[", 
                RowBox[{"100", " ", 
                 RowBox[{"params", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], ",", "3"}], 
             "]"}]}], "]"}], "<>", "\"\<f\>\"", "<>", 
          RowBox[{"ToString", "[", "nu", "]"}], "<>", "\"\<s\>\"", "<>", 
          RowBox[{"ToString", "[", 
           RowBox[{"4", "m"}], "]"}], 
          RowBox[{"(*", 
           RowBox[{"StringTake", "[", 
            RowBox[{"namefile", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "12"}], ",", 
               RowBox[{"-", "9"}]}], "}"}]}], "]"}], "*)"}], "<>", 
          "\"\<.jpg\>\""}]}], ";", 
        RowBox[{"nameQU", "=", 
         RowBox[{"dir", "<>", "\"\<shotQUa\>\"", "<>", "nana"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"FileExistsQ", "[", "nameQU", "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"scI", "=", 
             RowBox[{"-", "9."}]}], ";", 
            RowBox[{"scL", "=", 
             RowBox[{"-", "11.1"}]}], ";", 
            RowBox[{"scV", "=", 
             RowBox[{"4", " ", 
              SuperscriptBox["10", 
               RowBox[{"-", "6."}]]}]}], ";"}], 
           RowBox[{"(*", 
            RowBox[{"\[Nu]", "=", 
             RowBox[{"102", "GHz"}]}], "*)"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"scI", "=", 
            RowBox[{"-", "7.1"}]}], ";", 
           RowBox[{"scL", "=", 
            RowBox[{"-", "8.9"}]}], ";", 
           RowBox[{"conlum", "=", "3"}], ";", 
           RowBox[{"conLP", "=", "2.0"}], ";", 
           RowBox[{"scV", "=", 
            RowBox[{"13", " ", 
             SuperscriptBox["10", 
              RowBox[{"-", "6."}]]}]}], ";", 
           RowBox[{"(*", 
            RowBox[{"\[Nu]", "=", 
             RowBox[{"231", "GHz", " ", "for", " ", "th238"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"scI", "=", 
            RowBox[{"-", "7.1"}]}], ";", 
           RowBox[{"scL", "=", 
            RowBox[{"-", "8.6"}]}], ";", 
           RowBox[{"conlum", "=", "2.5"}], ";", 
           RowBox[{"conLP", "=", "2.5"}], ";", 
           RowBox[{"scV", "=", 
            RowBox[{"13", " ", 
             SuperscriptBox["10", 
              RowBox[{"-", "6."}]]}]}], ";", 
           RowBox[{"(*", 
            RowBox[{"\[Nu]", "=", 
             RowBox[{"231", "GHz", " ", "for", " ", "th296"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"scI", "=", 
              RowBox[{"-", "5.6"}]}], ";", 
             RowBox[{"scL", "=", 
              RowBox[{"-", "6.8"}]}], ";", 
             RowBox[{"scV", "=", 
              RowBox[{"7", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "6."}]]}]}], ";", 
             RowBox[{"conlum", "=", "9"}], ";", 
             RowBox[{"conLP", "=", "2.5"}], ";"}], 
            RowBox[{"(*", 
             RowBox[{"\[Nu]", "=", 
              RowBox[{"857", "GHz", " ", "for", " ", "th238"}]}], "*)"}], 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"ord", "=", "1"}], ";", 
           RowBox[{"csc", "=", "1.0"}], ";", 
           RowBox[{"sss", "=", "0.8"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"conlum", "=", "10"}], ";"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"contrast", " ", "con"}], "\[Implies]", 
              RowBox[{
              "luminosity", " ", "con", " ", "times", " ", "lower", " ", "is",
                " ", "black"}]}], ",", 
             RowBox[{"max", " ", "luminosity", " ", "is", " ", "white"}]}], 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"li", "=", 
            RowBox[{"ListInterpolation", "[", 
             RowBox[{
              RowBox[{"Log", "[", 
               RowBox[{
                SuperscriptBox["10", 
                 RowBox[{"-", "10"}]], "+", 
                RowBox[{"partres", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}]}], 
               "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
              RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"linQ", "=", 
            RowBox[{"ListInterpolation", "[", 
             RowBox[{
              RowBox[{"partres", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
              RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"linU", "=", 
            RowBox[{"ListInterpolation", "[", 
             RowBox[{
              RowBox[{"partres", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "All", ",", "3"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
              RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"linV", "=", 
            RowBox[{"ListInterpolation", "[", 
             RowBox[{
              RowBox[{"partres", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "All", ",", "4"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
              RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"scV", "=", 
              FractionBox[
               RowBox[{"Total", "[", 
                RowBox[{"Flatten", "[", 
                 RowBox[{"Abs", "[", 
                  RowBox[{"partres", "[", 
                   RowBox[{"[", 
                    RowBox[{"All", ",", "All", ",", "4"}], "]"}], "]"}], 
                  "]"}], "]"}], "]"}], 
               SuperscriptBox["nxy", "2"]]}], ";", 
             RowBox[{"dat", "=", 
              SqrtBox[
               RowBox[{
                SuperscriptBox[
                 RowBox[{"partres", "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}], "2"], 
                "+", 
                SuperscriptBox[
                 RowBox[{"partres", "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "All", ",", "3"}], "]"}], "]"}], 
                 "2"]}]]}], ";", 
             RowBox[{"scL", "=", 
              RowBox[{"Log", "[", 
               RowBox[{"Max", "[", "dat", "]"}], "]"}]}], ";", 
             RowBox[{"scL", "=", 
              RowBox[{"Log", "[", 
               RowBox[{"3", 
                FractionBox[
                 RowBox[{"Total", "[", 
                  RowBox[{"Flatten", "[", "dat", "]"}], "]"}], 
                 SuperscriptBox["nxy", "2"]]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"scI", "=", 
              RowBox[{"Log", "[", 
               RowBox[{"Max", "[", 
                RowBox[{"partres", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], 
               "]"}]}], ";", 
             RowBox[{"scI", "=", 
              RowBox[{"Log", "[", 
               RowBox[{"5", 
                FractionBox[
                 RowBox[{"Total", "[", 
                  RowBox[{"Flatten", "[", 
                   RowBox[{"partres", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], 
                   "]"}], "]"}], 
                 SuperscriptBox["nxy", "2"]]}], "]"}]}], ";"}], "*)"}], 
           RowBox[{"csc", "=", "1"}], ";", "\[IndentingNewLine]", 
           RowBox[{"totI", "=", 
            RowBox[{"DensityPlot", "[", 
             RowBox[{
              RowBox[{"rr", "=", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"li", "[", 
                    RowBox[{"y", ",", "x"}], "]"}], "-", "scI"}], ")"}], "/", 
                 RowBox[{"Log", "[", "conlum", "]"}]}], "+", "1"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{
                 RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
                RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"y", ",", 
                RowBox[{
                 RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
                RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
              RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
              RowBox[{"ColorFunction", "\[Rule]", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"RGBColor", "[", 
                  RowBox[{
                   RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
                   RowBox[{"#1", " ", "csc"}], ",", 
                   RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
              RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
              RowBox[{"Frame", "\[Rule]", "True"}], ",", 
              RowBox[{"FrameStyle", "\[Rule]", 
               RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
              RowBox[{"Axes", "\[Rule]", "False"}], ",", 
              RowBox[{"BaseStyle", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
                 RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
                 RowBox[{"FontSize", "\[Rule]", "24"}]}], "}"}]}], ",", 
              RowBox[{"Epilog", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Text", "[", 
                 RowBox[{
                  RowBox[{"Style", "[", 
                   RowBox[{
                    RowBox[{
                    "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): \
a=\>\"", "<>", 
                    RowBox[{"ToString", "[", "a", "]"}], "<>", 
                    "\"\<,   \[Nu]=\>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
                    "\"\<GHz,    \[Theta]=\>\"", "<>", 
                    RowBox[{"ToString", "[", "th", "]"}], "<>", 
                    "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", 
                    "Pink"}], "]"}], ",", 
                  RowBox[{"Scaled", "[", 
                   RowBox[{"{", 
                    RowBox[{"0.5", ",", "0.92"}], "}"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"1", ",", "0"}], "}"}], ",", 
                  RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], 
                "}"}]}], ",", 
              RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"scal", "=", 
            RowBox[{"{", 
             RowBox[{"0.02", ",", "0.005"}], "}"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"sc", "=", 
              RowBox[{"30", 
               FractionBox["1", 
                RowBox[{"nxy", " ", "nxy"}]], 
               RowBox[{"Total", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Sort", "[", 
                   RowBox[{"Flatten", "[", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"partres", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "All", ",", "4"}], "]"}], "]"}], 
                    "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"Round", "[", 
                    RowBox[{
                    FractionBox["1", "4"], "nxy", "*", "nxy"}], "]"}], ";;", 
                    RowBox[{"Round", "[", 
                    RowBox[{
                    FractionBox["3", "4"], "nxy", "*", "nxy"}], "]"}]}], 
                   "]"}], "]"}], ",", "2"}], "]"}]}]}], ";"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"totV", "=", 
            RowBox[{"DensityPlot", "[", 
             RowBox[{
              RowBox[{"res", "=", 
               RowBox[{"linV", "[", 
                RowBox[{"y", ",", "x"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{
                 RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
                RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"y", ",", 
                RowBox[{
                 RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
                RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
              RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
              RowBox[{"ColorFunction", "\[Rule]", 
               RowBox[{"Function", "[", 
                RowBox[{
                 RowBox[{"{", "n", "}"}], ",", 
                 RowBox[{
                  RowBox[{"r", "=", 
                   RowBox[{"n", "/", "scV"}]}], ";", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"r", ">", "0"}], ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{
                    RowBox[{"2", "r"}], ",", "r", ",", "r"}], "]"}], ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{
                    RowBox[{"-", "r"}], ",", 
                    RowBox[{"-", "r"}], ",", 
                    RowBox[{
                    RowBox[{"-", "2"}], "r"}]}], "]"}]}], "]"}]}]}], "]"}]}], 
              ",", 
              RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
              RowBox[{"Frame", "\[Rule]", "True"}], ",", 
              RowBox[{"FrameStyle", "\[Rule]", 
               RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
              RowBox[{"Axes", "\[Rule]", "False"}], ",", 
              RowBox[{"BaseStyle", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
                 RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
                 RowBox[{"FontSize", "\[Rule]", "22"}]}], "}"}]}], ",", 
              RowBox[{"Epilog", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Text", "[", 
                 RowBox[{
                  RowBox[{"Style", "[", 
                   RowBox[{
                    RowBox[{"\"\<V: a=\>\"", "<>", 
                    RowBox[{"ToString", "[", "a", "]"}], "<>", 
                    "\"\<,  \[Nu]=\>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
                    "\"\<GHz,   \[Theta]=\>\"", "<>", 
                    RowBox[{"ToString", "[", "th", "]"}], "<>", 
                    "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", 
                    "Pink"}], "]"}], ",", 
                  RowBox[{"Scaled", "[", 
                   RowBox[{"{", 
                    RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"1", ",", "0"}], "}"}], ",", 
                  RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], 
                "}"}]}], ",", 
              RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], 
           ";", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Red", " ", "-", " ", "positive"}], ",", " ", 
             RowBox[{"Blue", " ", "-", " ", "negative"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"totQU", "=", 
            RowBox[{"VectorDensityPlot", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"A", "=", 
                  RowBox[{"linQ", "[", 
                   RowBox[{"y", ",", "x"}], "]"}]}], ";", 
                 RowBox[{"B", "=", 
                  RowBox[{"linU", "[", 
                   RowBox[{"y", ",", "x"}], "]"}]}], ";", 
                 RowBox[{"ann", "=", 
                  FractionBox[
                   RowBox[{"ArcTan", "[", 
                    RowBox[{"A", ",", "B"}], "]"}], "2"]}], ";", 
                 RowBox[{"Cos", "[", "ann", "]"}]}], ",", 
                RowBox[{"-", 
                 RowBox[{"Sin", "[", "ann", "]"}]}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{
                 RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
                RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"y", ",", 
                RowBox[{
                 RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
                RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
              RowBox[{"VectorPoints", "\[Rule]", "100"}], ",", 
              RowBox[{"VectorStyle", "\[Rule]", 
               RowBox[{"Arrowheads", "[", "0", "]"}]}], ",", 
              RowBox[{"StreamStyle", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Arrowheads", "[", "0", "]"}], ",", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"1", ",", "0.5", ",", "0.5"}], "]"}]}], "}"}]}], 
              ",", 
              RowBox[{"StreamPoints", "\[Rule]", "100"}], ",", 
              RowBox[{"StreamScale", "\[Rule]", "Full"}], ",", 
              RowBox[{"MaxRecursion", "\[Rule]", "2"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
              RowBox[{"ColorFunction", "\[Rule]", 
               RowBox[{"Function", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"x", ",", "y", ",", "vx", ",", "vy", ",", "n"}], 
                  "}"}], ",", 
                 RowBox[{
                  RowBox[{"w", "=", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    FractionBox["1", "2"], 
                    RowBox[{"Log", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"linQ", "[", 
                    RowBox[{"y", ",", "x"}], "]"}], "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"linU", "[", 
                    RowBox[{"y", ",", "x"}], "]"}], "^", "2"}]}], "]"}]}], 
                    "-", "scL"}], ")"}], "/", 
                    RowBox[{"Log", "[", "conLP", "]"}]}], "+", "1"}]}], ";", 
                  RowBox[{"RGBColor", "[", 
                   RowBox[{
                    RowBox[{"2", " ", "w", " ", "csc"}], ",", 
                    RowBox[{"w", " ", "csc"}], ",", 
                    RowBox[{"w", " ", "csc"}]}], "]"}]}]}], "]"}]}], ",", 
              RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
              RowBox[{"Frame", "\[Rule]", "True"}], ",", 
              RowBox[{"FrameStyle", "\[Rule]", 
               RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
              RowBox[{"Axes", "\[Rule]", "False"}], ",", 
              RowBox[{"BaseStyle", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
                 RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
                 RowBox[{"FontSize", "\[Rule]", "22"}]}], "}"}]}], ",", 
              RowBox[{"Epilog", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Text", "[", 
                 RowBox[{
                  RowBox[{"Style", "[", 
                   RowBox[{
                    RowBox[{
                    "\"\<\!\(\*SqrtBox[\(\*SuperscriptBox[\(Q\), \(2\)] + \
\*SuperscriptBox[\(U\), \(2\)]\)]\) & field: a=\>\"", "<>", 
                    RowBox[{"ToString", "[", "a", "]"}], "<>", 
                    "\"\<,  \[Nu]=\>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
                    "\"\<GHz,   \[Theta]=\>\"", "<>", 
                    RowBox[{"ToString", "[", "th", "]"}], "<>", 
                    "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", 
                    "Pink"}], "]"}], ",", 
                  RowBox[{"Scaled", "[", 
                   RowBox[{"{", 
                    RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"1", ",", "0"}], "}"}], ",", 
                  RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], 
                "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"name", "=", 
            RowBox[{"dir", "<>", "\"\<shotIa\>\"", "<>", "nana"}]}], ";", 
           RowBox[{"Export", "[", 
            RowBox[{"name", ",", "totI", ",", 
             RowBox[{"\"\<CompressionLevel\>\"", "\[Rule]", "0"}], ",", 
             RowBox[{"\"\<Progressive\>\"", "\[Rule]", "True"}]}], "]"}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"name", "=", 
            RowBox[{"dir", "<>", "\"\<shotVa\>\"", "<>", "nana"}]}], ";", 
           RowBox[{"Export", "[", 
            RowBox[{"name", ",", "totV", ",", 
             RowBox[{"\"\<CompressionLevel\>\"", "\[Rule]", "0"}], ",", 
             RowBox[{"\"\<Progressive\>\"", "\[Rule]", "True"}]}], "]"}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"Export", "[", 
            RowBox[{"nameQU", ",", "totQU", ",", 
             RowBox[{"\"\<CompressionLevel\>\"", "\[Rule]", "0"}], ",", 
             RowBox[{"\"\<Progressive\>\"", "\[Rule]", "True"}]}], "]"}], 
           ";"}]}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{"Export", "[", 
           RowBox[{"name", ",", 
            RowBox[{"totI", "[", "i", "]"}], ",", 
            RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
            RowBox[{"ImageResolution", "\[Rule]", "300"}]}], "]"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"Exit", "[", "]"}], ";"}], "*)"}], "]"}], ";"}], "]"}]}], 
     ";", 
     RowBox[{"func", "[", "j", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", 
      RowBox[{"(*", 
       RowBox[{",", "6435", ",", "6435"}], "*)"}], ",", "6405", ",", "6429", 
      ",", "6"}], "}"}]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"j", ",", 
        RowBox[{"10", "i"}], ",", 
        RowBox[{
         RowBox[{"10", "i"}], "+", "9"}]}], "}"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "406", ",", "447"}], "}"}]}], "]"}], 
   "*)"}]}]], "Input",
 CellChangeTimes->{{3.545492914912758*^9, 3.5454930315594296`*^9}, 
   3.5454931047416153`*^9, {3.557678606764617*^9, 3.5576787168469133`*^9}, {
   3.557681383489436*^9, 3.55768144526997*^9}, {3.5576824130523243`*^9, 
   3.5576824417939677`*^9}, {3.5576825227235966`*^9, 
   3.5576825230106134`*^9}, {3.5576826341629705`*^9, 3.557682634232975*^9}, {
   3.557685315933359*^9, 3.557685316279379*^9}, {3.557685501581978*^9, 
   3.5576855017329865`*^9}, {3.557685570543922*^9, 3.557685570892942*^9}, 
   3.5577398754640636`*^9, {3.5577538926616096`*^9, 3.5577539193616476`*^9}, {
   3.55775771283887*^9, 3.5577577192388787`*^9}, 3.557758065159363*^9, {
   3.557758218902708*^9, 3.5577582376727343`*^9}, 3.557760362214073*^9, {
   3.5577604005941267`*^9, 3.557760417784151*^9}, {3.5577648353749886`*^9, 
   3.5577648356860065`*^9}, {3.5577648952474127`*^9, 
   3.5577649531267233`*^9}, {3.557765015757306*^9, 3.557765049010208*^9}, {
   3.55776508016999*^9, 3.557765110154705*^9}, {3.5577654004993114`*^9, 
   3.557765481451942*^9}, {3.557765543901514*^9, 3.557765560881485*^9}, {
   3.55776567967328*^9, 3.557765679735283*^9}, 3.557765728143052*^9, {
   3.557765801806265*^9, 3.557765802205288*^9}, {3.5577736737455144`*^9, 
   3.5577736742555437`*^9}, {3.5577737328948975`*^9, 
   3.5577737489038134`*^9}, {3.5577789557276263`*^9, 
   3.5577789846612816`*^9}, {3.5577790613486676`*^9, 3.557779078235634*^9}, {
   3.557784723719537*^9, 3.5577847544172926`*^9}, {3.5577849430170803`*^9, 
   3.557784970852672*^9}, {3.557785033862276*^9, 3.557785042188752*^9}, {
   3.557789555936924*^9, 3.5577895695107*^9}, {3.5577898796274376`*^9, 
   3.55778991619753*^9}, {3.557789955229762*^9, 3.5577899627041893`*^9}, {
   3.5577920542588196`*^9, 3.5577920567799635`*^9}, {3.5578211159720545`*^9, 
   3.55782111712012*^9}, {3.5578213312593684`*^9, 3.5578213406629057`*^9}, {
   3.5578272891021376`*^9, 3.55782728932515*^9}, {3.5578278451329403`*^9, 
   3.557827846709031*^9}, {3.5578280463134475`*^9, 3.557828046567462*^9}, {
   3.557835082632902*^9, 3.557835082866915*^9}, {3.5578351663526907`*^9, 
   3.5578351665677023`*^9}, {3.557855550464595*^9, 3.557855550992625*^9}, 
   3.557859023339232*^9, {3.5578639505710535`*^9, 3.5578639507840652`*^9}, {
   3.557864011371531*^9, 3.5578640116275454`*^9}, {3.5578668456226406`*^9, 
   3.5578668458586545`*^9}, {3.557867011487128*^9, 3.557867051000388*^9}, {
   3.55786708530235*^9, 3.557867094361868*^9}, {3.557867131249978*^9, 
   3.5578671823389*^9}, {3.5614072058258524`*^9, 3.561407206247053*^9}, {
   3.561407653593439*^9, 3.5614076791618834`*^9}, {3.561407721079157*^9, 
   3.561407747708404*^9}, {3.56140779096728*^9, 3.561407798689294*^9}, {
   3.561407848874582*^9, 3.561407895597664*^9}, {3.5614086953102684`*^9, 
   3.5614086977126727`*^9}, {3.561408757195577*^9, 3.561408769613199*^9}, {
   3.561408837473318*^9, 3.561408847457336*^9}, {3.561408877970989*^9, 
   3.561408893477417*^9}, {3.5614089485611134`*^9, 3.561408951213118*^9}, {
   3.5614090863561554`*^9, 3.5614091316898355`*^9}, {3.5614174399608326`*^9, 
   3.561417440569234*^9}, {3.5614175144629517`*^9, 3.5614175146229525`*^9}, {
   3.5614175532402124`*^9, 3.5614175841658664`*^9}, {3.5614237469279947`*^9, 
   3.5614238134309115`*^9}, {3.5614238663774047`*^9, 3.561423881961832*^9}, {
   3.5614240331572976`*^9, 3.5614240369169044`*^9}, {3.5614240682417593`*^9, 
   3.5614240802693806`*^9}, {3.5614638921586084`*^9, 3.561463900005422*^9}, {
   3.561464631369692*^9, 3.5614646388109045`*^9}, {3.561465150335803*^9, 
   3.56146515429821*^9}, {3.561465832346079*^9, 3.5614658329388804`*^9}, {
   3.561466364915415*^9, 3.561466446239358*^9}, {3.5614755269015436`*^9, 
   3.5614755389915648`*^9}, {3.566691085249196*^9, 3.566691089055603*^9}, {
   3.566691186976975*^9, 3.566691188193777*^9}, {3.566691307253186*^9, 
   3.566691310232792*^9}, 3.5666913928505363`*^9, 3.5666914370922146`*^9, {
   3.5666915192887588`*^9, 3.5666915276503735`*^9}, {3.566691806142062*^9, 
   3.5666918249244957`*^9}, {3.5666918732533803`*^9, 
   3.5666918733937807`*^9}, {3.5666921287984295`*^9, 3.566692137737245*^9}, {
   3.5695842312640576`*^9, 3.569584236351636*^9}, {3.569584341368249*^9, 
   3.5695843416632533`*^9}, 3.569584430202113*^9, {3.5695849203575068`*^9, 
   3.569584958430591*^9}, {3.5695850896267834`*^9, 3.5695851091145825`*^9}, {
   3.569585218648765*^9, 3.569585219483778*^9}, {3.569585520469402*^9, 
   3.569585566320106*^9}, {3.569585618800912*^9, 3.5695856210109463`*^9}, 
   3.569585737545236*^9, 3.56958586272316*^9, {3.5695860088604045`*^9, 
   3.569586008957906*^9}, {3.5695862417009826`*^9, 3.5695862590612493`*^9}, 
   3.5695863501326494`*^9, {3.569586680425723*^9, 3.5695866991185102`*^9}, {
   3.5695868174728284`*^9, 3.5695868176328306`*^9}, {3.5695869378731785`*^9, 
   3.5695869382506847`*^9}, {3.5695870326771345`*^9, 3.569587087445476*^9}, {
   3.5695871400062833`*^9, 3.569587152231471*^9}, {3.569587369813315*^9, 
   3.569587550148585*^9}, {3.5695876805455875`*^9, 3.569587702093418*^9}, {
   3.5695879788601694`*^9, 3.5695879821702204`*^9}, 3.569588115409767*^9, {
   3.5695882803098*^9, 3.5695882977350674`*^9}, 3.56958840274168*^9, 
   3.5695887543445807`*^9, {3.569588998610335*^9, 3.569589012450547*^9}, {
   3.569589384906268*^9, 3.5695893899388456`*^9}, {3.5695897627270713`*^9, 
   3.569589796885096*^9}, {3.5695901714068494`*^9, 3.5695902229526415`*^9}, {
   3.56959037259744*^9, 3.569590413960575*^9}, {3.569590520059705*^9, 
   3.569590545492595*^9}, {3.569590686736266*^9, 3.569590690456323*^9}, {
   3.569609036277931*^9, 3.569609120394223*^9}, {3.569609235073485*^9, 
   3.569609240306065*^9}, {3.5696093310849595`*^9, 3.5696093390725822`*^9}, {
   3.5696094339215393`*^9, 3.5696094340615416`*^9}, {3.5696094680020623`*^9, 
   3.5696094765896945`*^9}, {3.569609520455368*^9, 3.569609529248003*^9}, {
   3.5696101167760286`*^9, 3.569610121271098*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Period=\>\"", ",", 
    FractionBox[
     RowBox[{"26020", "-", "25500"}], "5"]}], "]"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"should", " ", "get", " ", 
     RowBox[{"snapshots", ":", " ", "25620"}]}], ",", " ", "25644", ",", " ", 
    "25668", ",", " ", "25692", ",", " ", "25716"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
   "25620", ",", " ", "25644", ",", " ", "25668", ",", " ", "25692", ",", " ",
     "25716"}], "}"}], "/", "4"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{"25520", ",", "25544", ",", "35568", ",", "25592", ",", "25616"}], 
   "}"}], "/", "4"}]}], "Input",
 CellChangeTimes->{{3.5695883722237115`*^9, 3.56958837926882*^9}, {
  3.569588469587707*^9, 3.569588508275801*^9}, {3.569588553548997*^9, 
  3.569588578161875*^9}, {3.5695888023528185`*^9, 3.569588803697839*^9}, {
  3.569588888521144*^9, 3.5695889536246433`*^9}, {3.5695893241253347`*^9, 
  3.5695893814787154`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"scI", "=", 
   RowBox[{"-", "7.1"}]}], ";", 
  RowBox[{"conlum", "=", "2.5"}], ";", 
  RowBox[{"Quiet", "[", 
   RowBox[{"totI", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"rr", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"li", "[", 
            RowBox[{"y", ",", "x"}], "]"}], "-", "scI"}], ")"}], "/", 
         RowBox[{"Log", "[", "conlum", "]"}]}], "+", "1"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{
           RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "24"}]}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{
            "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): a=\>\"", "<>", 
             RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,   \[Nu]=\>\"", 
             "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
             "\"\<GHz,    \[Theta]=\>\"", "<>", 
             RowBox[{"ToString", "[", "th", "]"}], "<>", 
             "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", "Pink"}], 
           "]"}], ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.92"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.561423898591461*^9, 3.561423931601119*^9}, {
   3.561465991138758*^9, 3.561466017861605*^9}, {3.5614662480400095`*^9, 
   3.56146624833641*^9}, {3.569590283963578*^9, 3.569590303903885*^9}, 
   3.569590383357605*^9, {3.569609228733387*^9, 3.569609292204362*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"scV", "=", 
   RowBox[{"13", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "6"}]]}]}], ";", 
  RowBox[{"Quiet", "[", 
   RowBox[{"totV", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"res", "=", 
       RowBox[{"linV", "[", 
        RowBox[{"y", ",", "x"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"Function", "[", 
        RowBox[{
         RowBox[{"{", "n", "}"}], ",", 
         RowBox[{
          RowBox[{"r", "=", 
           RowBox[{"n", "/", "scV"}]}], ";", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"r", ">", "0"}], ",", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"2", "r"}], ",", "r", ",", "r"}], "]"}], ",", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"-", "r"}], ",", 
              RowBox[{"-", "r"}], ",", 
              RowBox[{
               RowBox[{"-", "2"}], "r"}]}], "]"}]}], "]"}]}]}], "]"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "22"}]}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"\"\<V: a=\>\"", "<>", 
             RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \[Nu]=\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
             "\"\<GHz,   \[Theta]=\>\"", "<>", 
             RowBox[{"ToString", "[", "th", "]"}], "<>", 
             "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", "Pink"}], 
           "]"}], ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"Red", " ", "-", " ", "positive"}], ",", " ", 
     RowBox[{"Blue", " ", "-", " ", "negative"}]}], "*)"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5614173031594114`*^9, 3.56141742583681*^9}, {
  3.561417464218074*^9, 3.5614175097029457`*^9}, {3.5614239438627405`*^9, 
  3.5614239571851645`*^9}, {3.5614662719860516`*^9, 3.5614663048553095`*^9}, {
  3.5695875975193124`*^9, 3.569587605756939*^9}, {3.569587636702414*^9, 
  3.569587672980471*^9}, {3.5695903370343933`*^9, 3.569590366162341*^9}, {
  3.5696094505667944`*^9, 3.5696094556793733`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"scL", "=", 
   RowBox[{"-", "8.6"}]}], ";", 
  RowBox[{"conLP", "=", "2.5"}], ";", 
  RowBox[{"Quiet", "[", 
   RowBox[{"totQU", "=", 
    RowBox[{"VectorDensityPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"A", "=", 
          RowBox[{"linQ", "[", 
           RowBox[{"y", ",", "x"}], "]"}]}], ";", 
         RowBox[{"B", "=", 
          RowBox[{"linU", "[", 
           RowBox[{"y", ",", "x"}], "]"}]}], ";", 
         RowBox[{"ann", "=", 
          FractionBox[
           RowBox[{"ArcTan", "[", 
            RowBox[{"A", ",", "B"}], "]"}], "2"]}], ";", 
         RowBox[{"Cos", "[", "ann", "]"}]}], ",", 
        RowBox[{"-", 
         RowBox[{"Sin", "[", "ann", "]"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"VectorPoints", "\[Rule]", "100"}], ",", 
      RowBox[{"VectorStyle", "\[Rule]", 
       RowBox[{"Arrowheads", "[", "0", "]"}]}], ",", 
      RowBox[{"StreamStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Arrowheads", "[", "0", "]"}], ",", 
         RowBox[{"RGBColor", "[", 
          RowBox[{"1", ",", "0.5", ",", "0.5"}], "]"}]}], "}"}]}], ",", 
      RowBox[{"StreamPoints", "\[Rule]", "100"}], ",", 
      RowBox[{"StreamScale", "\[Rule]", "Full"}], ",", 
      RowBox[{"MaxRecursion", "\[Rule]", "2"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"Function", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "y", ",", "vx", ",", "vy", ",", "n"}], "}"}], ",", 
         RowBox[{
          RowBox[{"w", "=", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                FractionBox["1", "2"], 
                RowBox[{"Log", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"linQ", "[", 
                    RowBox[{"y", ",", "x"}], "]"}], "^", "2"}], "+", 
                  RowBox[{
                   RowBox[{"linU", "[", 
                    RowBox[{"y", ",", "x"}], "]"}], "^", "2"}]}], "]"}]}], 
               "-", "scL"}], ")"}], "/", 
             RowBox[{"Log", "[", "conLP", "]"}]}], "+", "1"}]}], ";", 
          RowBox[{"RGBColor", "[", 
           RowBox[{
            RowBox[{"2", " ", "w", " ", "csc"}], ",", 
            RowBox[{"w", " ", "csc"}], ",", 
            RowBox[{"w", " ", "csc"}]}], "]"}]}]}], "]"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "22"}]}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{
            "\"\<\!\(\*SqrtBox[\(\*SuperscriptBox[\(Q\), \(2\)] + \
\*SuperscriptBox[\(U\), \(2\)]\)]\) & field: a=\>\"", "<>", 
             RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \[Nu]=\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
             "\"\<GHz,   \[Theta]=\>\"", "<>", 
             RowBox[{"ToString", "[", "th", "]"}], "<>", 
             "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", "Pink"}], 
           "]"}], ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
     "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5614239784792013`*^9, 3.5614240164964685`*^9}, {
  3.561466312889323*^9, 3.5614663434185767`*^9}, {3.5695865115531297`*^9, 
  3.5695866150247188`*^9}, {3.569586733119033*^9, 3.5695867333090353`*^9}, {
  3.5695872273986273`*^9, 3.569587327002657*^9}, {3.5695904193831587`*^9, 
  3.569590502944442*^9}, {3.569609352320286*^9, 3.5696093786931906`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "8.9"}], ";", "2"}]], "Input",
 CellChangeTimes->{{3.569587309549889*^9, 3.569587311052412*^9}}],

Cell[BoxData[
 RowBox[{"-", "9.0"}]], "Input",
 CellChangeTimes->{{3.5695866274824104`*^9, 3.5695866279599175`*^9}}],

Cell[BoxData[
 RowBox[{"-", "8.8"}]], "Input",
 CellChangeTimes->{{3.5695866047445607`*^9, 3.5695866058795786`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", "=", "\"\<G:\\\\GRMHD\\\\movies\\\\\>\""}], ";", 
  RowBox[{"namefile", "=", 
   RowBox[{
   "\"\<G:\\\\mathematica\\\\3DMHD\\\\\>\"", "<>", 
    "\"\<shotimag90th214fn\>\"", "<>", 
    RowBox[{"ToString", "[", 
     RowBox[{"-", "1"}], "]"}], "<>", "\"\<.dat\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fi11", "=", 
   RowBox[{"OpenRead", "[", 
    RowBox[{"namefile", ",", 
     RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"params", "=", 
   RowBox[{"BinaryReadList", "[", 
    RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"a", "=", 
  RowBox[{"params", "[", 
   RowBox[{"[", "1", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"th", "=", 
  RowBox[{
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"params", "[", 
      RowBox[{"[", "2", "]"}], "]"}], " ", "1000"}], "]"}], "/", 
   "1000."}]}], "\[IndentingNewLine]", 
 RowBox[{"nxy", "=", 
  RowBox[{"Round", "[", 
   RowBox[{"params", "[", 
    RowBox[{"[", "3", "]"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"nu", "=", 
  RowBox[{"Round", "[", 
   RowBox[{"params", "[", 
    RowBox[{"[", "4", "]"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"maxy", "=", 
  RowBox[{"params", "[", 
   RowBox[{"[", "5", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"heat", "=", 
  RowBox[{"params", "[", 
   RowBox[{"[", "6", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"rnohor", "=", 
  RowBox[{"params", "[", 
   RowBox[{"[", "7", "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.4849256057654*^9, 3.4849256273402*^9}}],

Cell["6441, 6464, 6490, 6515,6541 (25,26,25,26)", "Text",
 CellChangeTimes->{{3.557879489968542*^9, 3.557879537111825*^9}, {
  3.557880300549551*^9, 3.557880308396365*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["QPO frequency", "Subsection",
 CellChangeTimes->{{3.558225689874842*^9, 3.558225692610999*^9}}],

Cell[BoxData[
 RowBox[{
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJztnI1PG+cdxyP1D3GbS1CCQAl1s6Ioo2oUpcQKVmY1tBlql9Y4IVoIaGJJ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     "], {{0, 54}, {237, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{167.4000000000003, Automatic},
   ImageSizeRaw->{237, 54},
   PlotRange->{{0, 237}, {0, 54}}], ";", " ", 
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJztnf9r22Yex3PcH+Jc3IYkENrSjoX80GMl65LAmRCO3G79Yd2ctA40TX/o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     "], {{0, 52}, {385, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{253.20000000000167`, Automatic},
   ImageSizeRaw->{385, 52},
   PlotRange->{{0, 385}, {0, 52}}]}]], "Text",
 CellChangeTimes->{{3.558225982786596*^9, 3.558225996058355*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ruruSgrA", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"G", "\[Rule]", 
      RowBox[{"6.67", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "8"}]]}]}], ",", 
     RowBox[{"m", "\[Rule]", 
      RowBox[{"4.", " ", 
       SuperscriptBox["10", "6"]}]}], ",", 
     RowBox[{"dd", "\[Rule]", 
      RowBox[{"8.4", " ", 
       SuperscriptBox["10", "3"], "pc"}]}], ",", 
     RowBox[{"rg", "\[Rule]", 
      FractionBox[
       RowBox[{"m", " ", "Msun", " ", "G"}], 
       SuperscriptBox["cc", "2"]]}], ",", 
     RowBox[{"arcsec", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "\[Pi]", " ", "dd"}], 
       RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
     RowBox[{"pc", "\[Rule]", 
      RowBox[{"3.08", " ", 
       SuperscriptBox["10", "18"]}]}], ",", 
     RowBox[{"year", "\[Rule]", 
      RowBox[{"365.35", " ", "86400"}]}], ",", 
     RowBox[{"cc", "\[Rule]", 
      RowBox[{"3.", " ", 
       SuperscriptBox["10", "10"]}]}], ",", 
     RowBox[{"Msun", "\[Rule]", 
      RowBox[{"2.", " ", 
       SuperscriptBox["10", "33"]}]}], ",", 
     RowBox[{"mp", "\[Rule]", 
      RowBox[{"1.67", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "24"}]]}]}], ",", 
     RowBox[{"me", "\[Rule]", 
      RowBox[{"9.1", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "28"}]]}]}], ",", 
     RowBox[{"kb", "\[Rule]", 
      RowBox[{"1.38", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "16"}]]}]}], ",", 
     RowBox[{"h", "\[Rule]", 
      RowBox[{"6.626", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "27"}]]}]}], ",", 
     RowBox[{"ee", "\[Rule]", 
      RowBox[{"4.8", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "10"}]]}]}], ",", 
     RowBox[{"keV", "->", 
      RowBox[{"1000", " ", "1.602", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ruruSgrA", "=", 
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"ruruSgrA", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1"}], "]"}], "]"}], "\[Rule]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"ruruSgrA", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}], "//.", "ruruSgrA"}], 
      ")"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rH", "=", 
   RowBox[{"rg", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["a", "2"]}]]}], ")"}]}]}], ";", 
  RowBox[{"\[CapitalOmega]H", "=", 
   FractionBox[
    RowBox[{"a", " ", "cc"}], 
    RowBox[{"2", "rH"}]]}], ";", 
  RowBox[{"\[CapitalOmega]F", "=", 
   RowBox[{"0.33", 
    RowBox[{"(*", "0.25", "*)"}], "\[CapitalOmega]H"}]}], ";", 
  RowBox[{"TF", "=", 
   FractionBox[
    RowBox[{"2", "\[Pi]"}], "\[CapitalOmega]F"]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"70", 
  FractionBox[
   RowBox[{
    RowBox[{"TF", "/.", "ruruSgrA"}], "/.", 
    RowBox[{"a", "\[Rule]", "0.99"}]}], 
   RowBox[{
    RowBox[{"TF", "/.", "ruruSgrA"}], "/.", 
    RowBox[{"a", "\[Rule]", "0.9375"}]}]]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Found QPO period for 0.9375 spin: \>\"", ",", 
   RowBox[{
    RowBox[{"96", 
     FractionBox["rg", "cc"], 
     FractionBox["1", "60"]}], "/.", "ruruSgrA"}], ",", 
   "\"\<min; while observed: \>\"", " ", ",", 
   RowBox[{"Tobs", "=", "18"}], ",", "\"\<min\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"asp", "=", 
  RowBox[{"FindRoot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Tobs", "*", "60"}], "==", "TF"}], "/.", "ruruSgrA"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "0.999"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sug", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"z1", "\[Rule]", 
      RowBox[{"1", "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"1", "-", 
           SuperscriptBox["a", "2"]}], ")"}], 
         RowBox[{"1", "/", "3"}]], 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", "a"}], ")"}], 
           RowBox[{"1", "/", "3"}]], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "-", "a"}], ")"}], 
           RowBox[{"1", "/", "3"}]]}], ")"}]}]}]}], ",", 
     RowBox[{"z2", "\[Rule]", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", 
          SuperscriptBox["a", "2"]}], "+", 
         SuperscriptBox["z1", "2"]}], ")"}], 
       RowBox[{"1", "/", "2"}]]}], ",", 
     RowBox[{"risco", "\[Rule]", 
      RowBox[{"3", "+", "z2", "-", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"3", "-", "z1"}], ")"}], 
          RowBox[{"(", 
           RowBox[{"3", "+", "z1", "+", 
            RowBox[{"2", "z2"}]}], ")"}]}], ")"}], 
        RowBox[{"1", "/", "2"}]]}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sug", "=", 
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"sug", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1"}], "]"}], "]"}], "\[Rule]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"sug", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}], "//.", "sug"}], ")"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<BH rotational frequency\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalOmega]bh", "=", 
    RowBox[{
     RowBox[{
      FractionBox[
       SuperscriptBox["M", 
        RowBox[{"1", "/", "2"}]], 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"risco", " ", "M"}], ")"}], 
         RowBox[{"3", "/", "2"}]], "+", 
        RowBox[{"a", " ", 
         SuperscriptBox["M", 
          RowBox[{"3", "/", "2"}]]}]}]], "/.", "sug"}], "/.", 
     RowBox[{"M", "\[Rule]", "1"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl", "=", 
   RowBox[{"LogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"2", 
         RowBox[{"\[Pi]", "/", "\[CapitalOmega]H"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"cc", "\[Rule]", "1"}], ",", 
          RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"4", " ", "2", 
         RowBox[{"\[Pi]", "/", "\[CapitalOmega]H"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"cc", "\[Rule]", "1"}], ",", 
          RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}], ",", " ", 
       RowBox[{
        RowBox[{"2", 
         RowBox[{"\[Pi]", "/", "\[CapitalOmega]bh"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"cc", "\[Rule]", "1"}], ",", 
          RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"3", " ", "2", 
         RowBox[{"\[Pi]", "/", "\[CapitalOmega]bh"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"cc", "\[Rule]", "1"}], ",", 
          RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "0.2", ",", "1"}], "}"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"16", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Blue", ",", 
          "Dashed"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Blue"}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Red", ",", 
          "Dashed"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Red"}], "}"}]}],
        "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<spin \!\(\*SubscriptBox[\(a\), \(*\)]\)\>\"", ",", 
        "\"\<Periods M\>\""}], "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Export", "[", 
    RowBox[{
    "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\periods.pdf\>\"", ",", "lpl", ",", 
     RowBox[{"\"\<CompressionLevel\>\"", "\[Rule]", "0"}]}], "]"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"4", " ", "2", 
    RowBox[{"\[Pi]", "/", "\[CapitalOmega]H"}]}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"cc", "\[Rule]", "1"}], ",", 
     RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}], "/.", 
  RowBox[{"a", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{"0.6", ",", "0.9", ",", "1.0"}], "}"}]}]}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQBWIQzXF13ZNjTa8cuXfkvQPRDJs8PoFoL9/yryB6wm15
nuNA+oS9sSSIvvRkpzqIblAXcgDRGjacriB6hpueG4i2+KzpBaIzQo96g+hZ
m0JDQbTh3YxwEJ2/72cmiPa4EJsFouea61deA9I8qW+qQHTB66iwZV2vHJv2
ylSB6IOptXUgOqTsRAuIvuQ/YTaIXsDDugBE59yTuTR30SvHTV94voNoj20X
J80D0gFHw2aB6AgL6XkgWun7pIUgeoPK32UgWqybeTmIfjWxYB2ILnep2wSi
c2Zv2AOibQw5DoBoo7+SZ0H0p2iGyyDa7vD6ZN9lrxzjRJ+AaavMDAY/IO11
8x4jiAYAF5e17g==
  "]],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindRoot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"27", "==", 
      RowBox[{"2", 
       RowBox[{"\[Pi]", "/", "\[CapitalOmega]bh"}]}]}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cc", "\[Rule]", "1"}], ",", 
       RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "0.9"}], "}"}]}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.576858413746051*^9, 3.576858431587325*^9}, {
  3.576858473738473*^9, 3.5768584884846992`*^9}}],

Cell[BoxData[{
 RowBox[{"FindRoot", "[", 
  RowBox[{
   RowBox[{"101", "==", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "2", 
       RowBox[{"\[Pi]", "/", "\[CapitalOmega]H"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cc", "\[Rule]", "1"}], ",", 
        RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "0.9"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FindRoot", "[", 
  RowBox[{
   RowBox[{"101", "==", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"5", " ", "2", 
       RowBox[{"\[Pi]", "/", "\[CapitalOmega]H"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cc", "\[Rule]", "1"}], ",", 
        RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "0.9"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FindRoot", "[", 
  RowBox[{
   RowBox[{"202", "==", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "2", 
       RowBox[{"\[Pi]", "/", "\[CapitalOmega]H"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cc", "\[Rule]", "1"}], ",", 
        RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "0.9"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FindRoot", "[", 
  RowBox[{
   RowBox[{"71", "==", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "2", 
       RowBox[{"\[Pi]", "/", "\[CapitalOmega]H"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cc", "\[Rule]", "1"}], ",", 
        RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "0.9"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FindRoot", "[", 
  RowBox[{
   RowBox[{"107", "==", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "2", 
       RowBox[{"\[Pi]", "/", "\[CapitalOmega]H"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cc", "\[Rule]", "1"}], ",", 
        RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "0.9"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FindRoot", "[", 
  RowBox[{
   RowBox[{"214", "==", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "2", 
       RowBox[{"\[Pi]", "/", "\[CapitalOmega]H"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cc", "\[Rule]", "1"}], ",", 
        RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "0.9"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FindRoot", "[", 
  RowBox[{
   RowBox[{"120", "==", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "2", 
       RowBox[{"\[Pi]", "/", "\[CapitalOmega]H"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cc", "\[Rule]", "1"}], ",", 
        RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "0.9"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FindRoot", "[", 
  RowBox[{
   RowBox[{"120", "==", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"5", " ", "2", 
       RowBox[{"\[Pi]", "/", "\[CapitalOmega]H"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cc", "\[Rule]", "1"}], ",", 
        RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "0.9"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FindRoot", "[", 
  RowBox[{
   RowBox[{"177", "==", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "2", 
       RowBox[{"\[Pi]", "/", "\[CapitalOmega]H"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cc", "\[Rule]", "1"}], ",", 
        RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "0.9"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FindRoot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"2", " ", "177"}], "==", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", "2", 
       RowBox[{"\[Pi]", "/", "\[CapitalOmega]H"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cc", "\[Rule]", "1"}], ",", 
        RowBox[{"rg", "\[Rule]", "1"}]}], "}"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "0.9"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.576853571161146*^9, 3.576853622109929*^9}, {
  3.5768536838448772`*^9, 3.5768537297485824`*^9}, {3.5768537637311044`*^9, 
  3.5768537908945227`*^9}, {3.576854256497676*^9, 3.576854260107731*^9}, {
  3.576854332137838*^9, 3.5768543343378716`*^9}, {3.5768544290478263`*^9, 
  3.576854431450363*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"rH", "=", 
   RowBox[{"rg", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["a", "2"]}]]}], ")"}]}]}], ";", 
  RowBox[{"\[CapitalOmega]H", "=", 
   FractionBox[
    RowBox[{"a", " ", "cc"}], 
    RowBox[{"2", "rH"}]]}], ";", 
  RowBox[{"\[CapitalOmega]F", "=", 
   RowBox[{"0.2", "\[CapitalOmega]H"}]}], ";", 
  RowBox[{"TF", "=", 
   FractionBox[
    RowBox[{"2", "\[Pi]"}], "\[CapitalOmega]F"]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TF", " ", 
    FractionBox["cc", "rg"]}], "/.", 
   RowBox[{"a", "\[Rule]", "0.9375"}]}], "/.", "ruruSgrA"}]}], "Input",
 CellChangeTimes->{{3.5582265412145357`*^9, 3.558226598311802*^9}, {
   3.5582266756882277`*^9, 3.558226679359438*^9}, 3.5582267971911774`*^9, 
   3.558257605197294*^9}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    FractionBox["TF", "60"], "/.", "ruruSgrA"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "0.5", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5582264360615215`*^9, 3.558226455279621*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Jon simulation \
\[OpenCurlyDoubleQuote]thickdisk7\[CloseCurlyDoubleQuote]", "Section",
 CellChangeTimes->{{3.55771366124535*^9, 3.5577136702465653`*^9}}],

Cell[CellGroupData[{

Cell["spin 0.9375 preliminary", "Subsection",
 CellChangeTimes->{{3.5474159445628476`*^9, 3.5474159657700605`*^9}, 
   3.5474863364636946`*^9, {3.5577136794193816`*^9, 3.5577136810729847`*^9}, {
   3.5685055059770308`*^9, 3.568505513927042*^9}}],

Cell[CellGroupData[{

Cell["lightcurve th=157 (B cut, thlimit=0.1), rough_inten", "Subsubsection",
 CellChangeTimes->{{3.5577510472865367`*^9, 3.55775104944654*^9}, {
  3.55883260748061*^9, 3.558832631388977*^9}, {3.560872675917722*^9, 
  3.56087270326457*^9}, {3.5610765919205837`*^9, 3.5610765981449947`*^9}, {
  3.561238496677331*^9, 3.561238501372939*^9}, {3.561289827913183*^9, 
  3.561289828273184*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";", 
  RowBox[{"imp", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{
      "\"\<E:\\\\GRMHD\\\\Jon\\\\thickdisk7\\\\inten_Bsq_thlimit_th157\\\\\
poliresa93.75th157fn\>\"", "<>", 
       RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", 
       RowBox[{"(*", 
        RowBox[{"18500", ",", "19980", ",", "20"}], "*)"}], "5534", ",", 
       "7034", ",", "coe"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, 
   3.5486008696865225`*^9, {3.548600915220127*^9, 3.548600929823962*^9}, {
   3.551033749980384*^9, 3.551033750871435*^9}, {3.5510337885625906`*^9, 
   3.5510337966150513`*^9}, {3.5520186449336777`*^9, 3.552018650318986*^9}, {
   3.55771381499922*^9, 3.557713848242878*^9}, {3.557714021184782*^9, 
   3.5577140212159815`*^9}, {3.557735285968544*^9, 3.557735286467745*^9}, {
   3.557735457912046*^9, 3.5577354872556973`*^9}, {3.5577395741124763`*^9, 
   3.5577395758284793`*^9}, {3.557855418955073*^9, 3.5578554191790857`*^9}, {
   3.5588325820031524`*^9, 3.5588325935978155`*^9}, {3.560872762763075*^9, 
   3.560872763870677*^9}, {3.5608728196547747`*^9, 3.560872849887628*^9}, {
   3.56087349695055*^9, 3.560873499446555*^9}, {3.560875165560282*^9, 
   3.560875166028283*^9}, {3.5608801039683924`*^9, 3.560880104514393*^9}, {
   3.5609031767900453`*^9, 3.5609031777421*^9}, {3.561076626864645*^9, 
   3.5610766304058514`*^9}, {3.5612385098749537`*^9, 
   3.5612385397646065`*^9}, {3.5612898548432207`*^9, 3.5612898611732297`*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "imp", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"type", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fr", "=", "1"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"1", " ", "-", " ", 
     RowBox[{"43", "GHz"}]}], ",", " ", 
    RowBox[{"11", " ", "-", " ", 
     RowBox[{"5000", "GHz"}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", 
                 RowBox[{"(*", "type", "*)"}], "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
  3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
  3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "k", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "3"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDflux", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}],
           "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "4"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDLP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of LP\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "5"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of EVPA\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "6"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of CP\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5485960291688566`*^9, 3.5485960793437266`*^9}, {
  3.5485961723110437`*^9, 3.548596172431051*^9}, {3.548596217990657*^9, 
  3.548596419205166*^9}, {3.5485964747953453`*^9, 3.548596666441307*^9}, {
  3.548596789027318*^9, 3.548596791313449*^9}, {3.54859689729051*^9, 
  3.5485968982145634`*^9}, {3.5485970754817023`*^9, 3.5485970810720224`*^9}, {
  3.548601094181363*^9, 3.548601141526071*^9}, {3.548601228014018*^9, 
  3.5486012455100183`*^9}, {3.5486015052638755`*^9, 3.548601513522348*^9}, {
  3.5486021619624367`*^9, 3.548602208246084*^9}, {3.548603191013295*^9, 
  3.548603202408947*^9}, {3.548603360132968*^9, 3.5486034378874154`*^9}, {
  3.5486037657511683`*^9, 3.5486037953368607`*^9}, {3.557735613195719*^9, 
  3.5577356251141396`*^9}, {3.558833419924079*^9, 3.55883343620601*^9}, {
  3.5588334863698792`*^9, 3.558833498806591*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "3"}], ";", 
  RowBox[{"kmin", "=", "1"}], ";", 
  RowBox[{"kmax", "=", 
   RowBox[{"Length", "[", "freqs", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDflux", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDLP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDCP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5486022164095507`*^9, 3.5486022274141808`*^9}, {
  3.548603444138773*^9, 3.54860345773155*^9}, {3.54860351210266*^9, 
  3.5486035139077635`*^9}, {3.55773962159896*^9, 3.557739623002962*^9}, {
  3.5588327715569944`*^9, 3.55883291345411*^9}, {3.56087287944968*^9, 
  3.5608728801828814`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", 
       RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"lmax", "=", 
      RowBox[{"Quotient", "[", 
       RowBox[{"l", ",", "2"}], "]"}]}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"coe", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveFx", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<Flux, Jy\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveLPx", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<LP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveEVPAx", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<EVPA angle, deg\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveCPx", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<CP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQA2IQrbT3gKBm3ivHHGcHERA9UWO5JIgOCpqtBKKNCk00
QTSDGJMWiL7kuVgfRJfNvGUEone6VdiA5dd6BYHo5rnPwkB0S8arXBB9Suda
MYjWaJesAdFsRT98tYG0WtkvMN1/5eAuW5D4lotgen7u9wuuQHrW/t9g+gjj
8/sgWuvu6ccg2jRt7TsQPXXa/o8get+dt5xuQPoW+1cw/Y9n5oMMIP0nxf8x
iGb7tOAziN5luQhMn+OszHzfDHRP97tcEO3nx1gMogVUP9eB6PN8N5tAdPiz
ra0gOuP1r24QbWeT0weiV7yasgNE35jZdgBEn1y08iKIrtFYchVEX3SQDDDv
eOXYV3YOTAMAHaC2/A==
  "]],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDflux", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDLP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDEVPA", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDCP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveF", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveLP", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveEVPA", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveCP", "[", "k", "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5588336899835253`*^9, 3.558833763719743*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["lightcurve th=244 (B cut, thlimit=0.1), rough_inten", "Subsubsection",
 CellChangeTimes->{{3.5577510472865367`*^9, 3.55775104944654*^9}, {
  3.55883260748061*^9, 3.558832631388977*^9}, {3.560872675917722*^9, 
  3.56087270326457*^9}, {3.5610765919205837`*^9, 3.5610765981449947`*^9}, {
  3.561238496677331*^9, 3.561238501372939*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";", 
  RowBox[{"imp", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{
      "\"\<E:\\\\GRMHD\\\\Jon\\\\thickdisk7\\\\rough_inten_Bsq_thlimit\\\\\
poliresa93.75th244fn\>\"", "<>", 
       RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", 
       RowBox[{"(*", 
        RowBox[{"18500", ",", "19980", ",", "20"}], "*)"}], "5534", ",", 
       "7034", ",", "coe"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, 
   3.5486008696865225`*^9, {3.548600915220127*^9, 3.548600929823962*^9}, {
   3.551033749980384*^9, 3.551033750871435*^9}, {3.5510337885625906`*^9, 
   3.5510337966150513`*^9}, {3.5520186449336777`*^9, 3.552018650318986*^9}, {
   3.55771381499922*^9, 3.557713848242878*^9}, {3.557714021184782*^9, 
   3.5577140212159815`*^9}, {3.557735285968544*^9, 3.557735286467745*^9}, {
   3.557735457912046*^9, 3.5577354872556973`*^9}, {3.5577395741124763`*^9, 
   3.5577395758284793`*^9}, {3.557855418955073*^9, 3.5578554191790857`*^9}, {
   3.5588325820031524`*^9, 3.5588325935978155`*^9}, {3.560872762763075*^9, 
   3.560872763870677*^9}, {3.5608728196547747`*^9, 3.560872849887628*^9}, {
   3.56087349695055*^9, 3.560873499446555*^9}, {3.560875165560282*^9, 
   3.560875166028283*^9}, {3.5608801039683924`*^9, 3.560880104514393*^9}, {
   3.5609031767900453`*^9, 3.5609031777421*^9}, {3.561076626864645*^9, 
   3.5610766304058514`*^9}, {3.5612385098749537`*^9, 3.5612385397646065`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"1336", "+", 
       RowBox[{"5", "#"}]}], ",", "9", ",", "4"}], "]"}], "]"}], "&"}], "/@", 
  RowBox[{"Range", "[", 
   RowBox[{"0", ",", "5"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5618584642670827`*^9, 3.5618585469628277`*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.5619337667955008`*^9, 3.5619338423278213`*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "imp", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}], ";", 
  RowBox[{"xnum", "=", 
   RowBox[{"4", "nums"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"type", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fr", "=", "1"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"1", " ", "-", " ", 
     RowBox[{"43", "GHz"}]}], ",", " ", 
    RowBox[{"11", " ", "-", " ", 
     RowBox[{"5000", "GHz"}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", 
                 RowBox[{"(*", "type", "*)"}], "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
   3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
   3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}, {
   3.5619318633076277`*^9, 3.561931866287798*^9}, 3.5619319396729956`*^9}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "k", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "3"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDflux", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}],
           "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "4"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDLP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of LP\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "5"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of EVPA\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "6"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of CP\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5485960291688566`*^9, 3.5485960793437266`*^9}, {
  3.5485961723110437`*^9, 3.548596172431051*^9}, {3.548596217990657*^9, 
  3.548596419205166*^9}, {3.5485964747953453`*^9, 3.548596666441307*^9}, {
  3.548596789027318*^9, 3.548596791313449*^9}, {3.54859689729051*^9, 
  3.5485968982145634`*^9}, {3.5485970754817023`*^9, 3.5485970810720224`*^9}, {
  3.548601094181363*^9, 3.548601141526071*^9}, {3.548601228014018*^9, 
  3.5486012455100183`*^9}, {3.5486015052638755`*^9, 3.548601513522348*^9}, {
  3.5486021619624367`*^9, 3.548602208246084*^9}, {3.548603191013295*^9, 
  3.548603202408947*^9}, {3.548603360132968*^9, 3.5486034378874154`*^9}, {
  3.5486037657511683`*^9, 3.5486037953368607`*^9}, {3.557735613195719*^9, 
  3.5577356251141396`*^9}, {3.558833419924079*^9, 3.55883343620601*^9}, {
  3.5588334863698792`*^9, 3.558833498806591*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "3"}], ";", 
  RowBox[{"kmin", "=", "1"}], ";", 
  RowBox[{"kmax", "=", 
   RowBox[{"Length", "[", "freqs", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDflux", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDLP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDCP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5486022164095507`*^9, 3.5486022274141808`*^9}, {
  3.548603444138773*^9, 3.54860345773155*^9}, {3.54860351210266*^9, 
  3.5486035139077635`*^9}, {3.55773962159896*^9, 3.557739623002962*^9}, {
  3.5588327715569944`*^9, 3.55883291345411*^9}, {3.56087287944968*^9, 
  3.5608728801828814`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", 
       RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"15", ",", "Bold"}], "}"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"lmax", "=", 
      RowBox[{"Quotient", "[", 
       RowBox[{"l", ",", "2"}], "]"}]}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"coe", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveFx", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"xnum", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<Flux, Jy\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveLPx", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"xnum", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<LP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveEVPAx", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"xnum", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<EVPA angle, deg\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveCPx", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"xnum", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<CP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGCQAmIQrbT3gKBm3ivHHGcHERA9UWO5JIgOCpqtBKKNCk00
QTSDGJMWiL7kuVgfRJfNvGUEone6VdiA5dd6BYHo5rnPwkB0S8arXBB9Suda
MYjWaJesAdFsRT98tYG0WtkvMN1/5eAuW5D4lotgen7u9wuuQHrW/t9g+gjj
8/sgWuvu6ccg2jRt7TsQPXXa/o8get+dt5xuQPoW+1cw/Y9n5oMMIP0nxf8x
iGb7tOAziN5luQhMn+OszHzfDHRP97tcEO3nx1gMogVUP9eB6PN8N5tAdPiz
ra0gOuP1r24QbWeT0weiV7yasgNE35jZdgBEn1y08iKIrtFYchVEX3SQDDDv
eOXYV3YOTMtkCvne6HzlmHZ1iR+IFql71wKimasOd4DoB4oH+0B024b3k0D0
84Kd00D0xJyUmSAaAF8x2+Q=
  "]],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDflux", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDLP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDEVPA", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDCP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveFx", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveLPx", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveEVPAx", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveCPx", "[", "k", "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5588336899835253`*^9, 3.558833763719743*^9}, {
  3.561931430598878*^9, 3.5619314530081596`*^9}}],

Cell[BoxData[
 RowBox[{"LcurveFx", "[", "1", "]"}]], "Input",
 CellChangeTimes->{{3.56193144548973*^9, 3.561931446918812*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
lightcurve th=245 (no B cut, B red, thlimit=0.1)\
\>", "Subsubsection",
 CellChangeTimes->{{3.5577510472865367`*^9, 3.55775104944654*^9}, {
  3.55883260748061*^9, 3.558832631388977*^9}, {3.560872675917722*^9, 
  3.56087270326457*^9}, {3.5610765919205837`*^9, 3.5610766169586277`*^9}, {
  3.567729128601217*^9, 3.5677291508874917`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";", 
  RowBox[{"imp", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{
      "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\th245\\\\poliresa93.\
75th245fn\>\"", "<>", 
       RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", "1965", ",", "7033", ",", "coe"}], "}"}]}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, 
   3.5486008696865225`*^9, {3.548600915220127*^9, 3.548600929823962*^9}, {
   3.551033749980384*^9, 3.551033750871435*^9}, {3.5510337885625906`*^9, 
   3.5510337966150513`*^9}, {3.5520186449336777`*^9, 3.552018650318986*^9}, {
   3.55771381499922*^9, 3.557713848242878*^9}, {3.557714021184782*^9, 
   3.5577140212159815`*^9}, {3.557735285968544*^9, 3.557735286467745*^9}, {
   3.557735457912046*^9, 3.5577354872556973`*^9}, {3.5577395741124763`*^9, 
   3.5577395758284793`*^9}, {3.557855418955073*^9, 3.5578554191790857`*^9}, {
   3.5588325820031524`*^9, 3.5588325935978155`*^9}, {3.560872762763075*^9, 
   3.560872763870677*^9}, {3.5608728196547747`*^9, 3.560872849887628*^9}, {
   3.56087349695055*^9, 3.560873499446555*^9}, {3.560875165560282*^9, 
   3.560875166028283*^9}, {3.5608801039683924`*^9, 3.560880104514393*^9}, {
   3.5609031767900453`*^9, 3.5609031777421*^9}, {3.561076765174488*^9, 
   3.5610767680448933`*^9}, {3.5677291589449525`*^9, 3.567729159049958*^9}, {
   3.5677293582233505`*^9, 3.567729413559516*^9}, {3.5677295667262764`*^9, 
   3.567729571199532*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "imp", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"type", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fr", "=", "1"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"1", " ", "-", " ", 
     RowBox[{"43", "GHz"}]}], ",", " ", 
    RowBox[{"11", " ", "-", " ", 
     RowBox[{"5000", "GHz"}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", 
                 RowBox[{"(*", "type", "*)"}], "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
  3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
  3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}}],

Cell[BoxData[{
 RowBox[{"gr", "[", "3", "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "6", "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "9", "]"}], "\[IndentingNewLine]", 
 RowBox[{"gr", "[", "12", "]"}]}], "Input",
 CellChangeTimes->{{3.5677297925331917`*^9, 3.567729842076025*^9}, {
  3.567729972619492*^9, 3.567729981762015*^9}, {3.5677327094310284`*^9, 
  3.5677327107191024`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"im1", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"4", "nums"}], ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "3", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"im2", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"4", "nums"}], ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "6", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"im3", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"4", "nums"}], ",", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "9", ",", "3"}], "]"}], "]"}]}], "}"}], "]"}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "1000"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "Bold"}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux87.jpg\>\"", ",", "im1", 
   ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux230.jpg\>\"", ",", "im2", 
   ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\spectra\\\\Flux857.jpg\>\"", ",", "im3", 
   ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5677313621689696`*^9, 3.567731539914136*^9}, {
  3.567731608730072*^9, 3.567731750697192*^9}}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "k", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "3"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDflux", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}],
           "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "4"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDLP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of LP\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "5"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of EVPA\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "6"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of CP\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5485960291688566`*^9, 3.5485960793437266`*^9}, {
  3.5485961723110437`*^9, 3.548596172431051*^9}, {3.548596217990657*^9, 
  3.548596419205166*^9}, {3.5485964747953453`*^9, 3.548596666441307*^9}, {
  3.548596789027318*^9, 3.548596791313449*^9}, {3.54859689729051*^9, 
  3.5485968982145634`*^9}, {3.5485970754817023`*^9, 3.5485970810720224`*^9}, {
  3.548601094181363*^9, 3.548601141526071*^9}, {3.548601228014018*^9, 
  3.5486012455100183`*^9}, {3.5486015052638755`*^9, 3.548601513522348*^9}, {
  3.5486021619624367`*^9, 3.548602208246084*^9}, {3.548603191013295*^9, 
  3.548603202408947*^9}, {3.548603360132968*^9, 3.5486034378874154`*^9}, {
  3.5486037657511683`*^9, 3.5486037953368607`*^9}, {3.557735613195719*^9, 
  3.5577356251141396`*^9}, {3.558833419924079*^9, 3.55883343620601*^9}, {
  3.5588334863698792`*^9, 3.558833498806591*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "3"}], ";", 
  RowBox[{"kmin", "=", "1"}], ";", 
  RowBox[{"kmax", "=", 
   RowBox[{"Length", "[", "freqs", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDflux", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDLP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDCP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5486022164095507`*^9, 3.5486022274141808`*^9}, {
  3.548603444138773*^9, 3.54860345773155*^9}, {3.54860351210266*^9, 
  3.5486035139077635`*^9}, {3.55773962159896*^9, 3.557739623002962*^9}, {
  3.5588327715569944`*^9, 3.55883291345411*^9}, {3.56087287944968*^9, 
  3.5608728801828814`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "9"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", 
       RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"lmax", "=", 
      RowBox[{"Quotient", "[", 
       RowBox[{"l", ",", "2"}], "]"}]}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"coe", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveF", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<Flux, Jy\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveLP", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<LP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveEVPA", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<EVPA angle, deg\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveCP", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<CP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQA2IQrbT3gKBm3ivHHGcHERA9UWO5JIgOCpqtBKKNCk00
QTSDGJMWiL7kuVgfRJfNvGUEone6VdiA5dd6BYHo5rnPwkB0S8arXBB9Suda
MYjWaJesAdFsRT98tYG0WtkvMN1/5eAuW5D4lotgen7u9wuuQHrW/t9g+gjj
8/sgWuvu6ccg2jRt7TsQPXXa/o8get+dt5xuQPoW+1cw/Y9n5oMMIP0nxf8x
iGb7tOAziN5luQhMn+OszHzfDHRP97tcEO3nx1gMogVUP9eB6PN8N5tAdPiz
ra0gOuP1r24QbWeT0weiV7yasgNE35jZdgBEn1y08iKIrtFYchVEbzq3OOf5
lFeO3RnaRSAaADUAuPc=
  "]],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDflux", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDLP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDEVPA", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDCP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveF", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveLP", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveEVPA", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveCP", "[", "k", "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5588336899835253`*^9, 3.558833763719743*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fr", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "[", 
  RowBox[{"[", "fr", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{
    SuperscriptBox["10", "7"], 
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "fr", ",", "12"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5474244310872493`*^9, 3.5474244563596945`*^9}, {
   3.5474244888795547`*^9, 3.547424515096054*^9}, {3.5474245485119658`*^9, 
   3.547424574191434*^9}, {3.5475470934034843`*^9, 3.5475470957396173`*^9}, 
   3.547547753886261*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
lightcurve th=263 (no B cut, no B red, thlimit=0.1)\
\>", "Subsubsection",
 CellChangeTimes->{{3.5577510472865367`*^9, 3.55775104944654*^9}, {
  3.55883260748061*^9, 3.558832631388977*^9}, {3.560872675917722*^9, 
  3.56087270326457*^9}, {3.5610765919205837`*^9, 3.5610765981449947`*^9}, {
  3.567729133135476*^9, 3.567729144479125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";", 
  RowBox[{"imp", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{
      "\"\<E:\\\\GRMHD\\\\Jon\\\\thickdisk7\\\\rough_inten_thlimit\\\\\
poliresa93.75th263fn\>\"", "<>", 
       RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", 
       RowBox[{"(*", 
        RowBox[{"18500", ",", "19980", ",", "20"}], "*)"}], "5534", ",", 
       "7034", ",", "coe"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, 
   3.5486008696865225`*^9, {3.548600915220127*^9, 3.548600929823962*^9}, {
   3.551033749980384*^9, 3.551033750871435*^9}, {3.5510337885625906`*^9, 
   3.5510337966150513`*^9}, {3.5520186449336777`*^9, 3.552018650318986*^9}, {
   3.55771381499922*^9, 3.557713848242878*^9}, {3.557714021184782*^9, 
   3.5577140212159815`*^9}, {3.557735285968544*^9, 3.557735286467745*^9}, {
   3.557735457912046*^9, 3.5577354872556973`*^9}, {3.5577395741124763`*^9, 
   3.5577395758284793`*^9}, {3.557855418955073*^9, 3.5578554191790857`*^9}, {
   3.5588325820031524`*^9, 3.5588325935978155`*^9}, {3.560872762763075*^9, 
   3.560872763870677*^9}, {3.5608728196547747`*^9, 3.560872849887628*^9}, {
   3.56087349695055*^9, 3.560873499446555*^9}, {3.560875165560282*^9, 
   3.560875166028283*^9}, {3.5608801039683924`*^9, 3.560880104514393*^9}, {
   3.5609031767900453`*^9, 3.5609031777421*^9}, {3.561076626864645*^9, 
   3.5610766304058514`*^9}, 3.566657261304946*^9}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "imp", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"type", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fr", "=", "1"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"1", " ", "-", " ", 
     RowBox[{"43", "GHz"}]}], ",", " ", 
    RowBox[{"11", " ", "-", " ", 
     RowBox[{"5000", "GHz"}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", 
                 RowBox[{"(*", "type", "*)"}], "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
  3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
  3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "k", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "3"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDflux", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}],
           "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "4"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDLP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of LP\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "5"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of EVPA\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "6"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of CP\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5485960291688566`*^9, 3.5485960793437266`*^9}, {
  3.5485961723110437`*^9, 3.548596172431051*^9}, {3.548596217990657*^9, 
  3.548596419205166*^9}, {3.5485964747953453`*^9, 3.548596666441307*^9}, {
  3.548596789027318*^9, 3.548596791313449*^9}, {3.54859689729051*^9, 
  3.5485968982145634`*^9}, {3.5485970754817023`*^9, 3.5485970810720224`*^9}, {
  3.548601094181363*^9, 3.548601141526071*^9}, {3.548601228014018*^9, 
  3.5486012455100183`*^9}, {3.5486015052638755`*^9, 3.548601513522348*^9}, {
  3.5486021619624367`*^9, 3.548602208246084*^9}, {3.548603191013295*^9, 
  3.548603202408947*^9}, {3.548603360132968*^9, 3.5486034378874154`*^9}, {
  3.5486037657511683`*^9, 3.5486037953368607`*^9}, {3.557735613195719*^9, 
  3.5577356251141396`*^9}, {3.558833419924079*^9, 3.55883343620601*^9}, {
  3.5588334863698792`*^9, 3.558833498806591*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kmin", "=", "3"}], ";", 
  RowBox[{"kmax", "=", "3"}], ";", 
  RowBox[{"kmin", "=", "1"}], ";", 
  RowBox[{"kmax", "=", 
   RowBox[{"Length", "[", "freqs", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDflux", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDLP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDCP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5486022164095507`*^9, 3.5486022274141808`*^9}, {
  3.548603444138773*^9, 3.54860345773155*^9}, {3.54860351210266*^9, 
  3.5486035139077635`*^9}, {3.55773962159896*^9, 3.557739623002962*^9}, {
  3.5588327715569944`*^9, 3.55883291345411*^9}, {3.56087287944968*^9, 
  3.5608728801828814`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", 
       RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"lmax", "=", 
      RowBox[{"Quotient", "[", 
       RowBox[{"l", ",", "2"}], "]"}]}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"coe", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveFx", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<Flux, Jy\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveLPx", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<LP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveEVPAx", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<EVPA angle, deg\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveCPx", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<CP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQA2IQrbT3gKBm3ivHHGcHERA9UWO5JIgOCpqtBKKNCk00
QTSDGJMWiL7kuVgfRJfNvGUEone6VdiA5dd6BYHo5rnPwkB0S8arXBB9Suda
MYjWaJesAdFsRT98tYG0WtkvMN1/5eAuW5D4lotgen7u9wuuQHrW/t9g+gjj
8/sgWuvu6ccg2jRt7TsQPXXa/o8get+dt5xuQPoW+1cw/Y9n5oMMIP0nxf8x
iGb7tOAziN5luQhMn+OszHzfDHRP97tcEO3nx1gMogVUP9eB6PN8N5tAdPiz
ra0gOuP1r24QbWeT0weiV7yasgNE35jZdgBEn1y08iKIrtFYchVEX3SQDDDv
eOXYV3YOTAMAHaC2/A==
  "]],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDflux", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDLP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDEVPA", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDCP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveF", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveLP", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveEVPA", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveCP", "[", "k", "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5588336899835253`*^9, 3.558833763719743*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["lightcurve th=194", "Subsubsection",
 CellChangeTimes->{{3.5577510472865367`*^9, 3.55775104944654*^9}, {
  3.55883260748061*^9, 3.558832631388977*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";", 
  RowBox[{"imp", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{
      "\"\<E:\\\\GRMHD\\\\Jon\\\\thickdisk7\\\\poliresa93.75th194fn\>\"", "<>", 
       RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", 
       RowBox[{"(*", 
        RowBox[{"18500", ",", "19980", ",", "20"}], "*)"}], "6434", ",", 
       "7034", ",", "coe"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, 
   3.5486008696865225`*^9, {3.548600915220127*^9, 3.548600929823962*^9}, {
   3.551033749980384*^9, 3.551033750871435*^9}, {3.5510337885625906`*^9, 
   3.5510337966150513`*^9}, {3.5520186449336777`*^9, 3.552018650318986*^9}, {
   3.55771381499922*^9, 3.557713848242878*^9}, {3.557714021184782*^9, 
   3.5577140212159815`*^9}, {3.557735285968544*^9, 3.557735286467745*^9}, {
   3.557735457912046*^9, 3.5577354872556973`*^9}, {3.5577395741124763`*^9, 
   3.5577395758284793`*^9}, {3.557855418955073*^9, 3.5578554191790857`*^9}, {
   3.5588325820031524`*^9, 3.5588325935978155`*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "imp", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"type", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fr", "=", "1"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"1", " ", "-", " ", 
     RowBox[{"43", "GHz"}]}], ",", " ", 
    RowBox[{"11", " ", "-", " ", 
     RowBox[{"5000", "GHz"}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", 
                 RowBox[{"(*", "type", "*)"}], "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
  3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
  3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "k", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "3"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDflux", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of F\>\""}],
           "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "4"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDLP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of LP\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "5"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of EVPA\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "6"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Period, M\>\"", ",", "\"\<Periodogram I(T) of CP\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5485960291688566`*^9, 3.5485960793437266`*^9}, {
  3.5485961723110437`*^9, 3.548596172431051*^9}, {3.548596217990657*^9, 
  3.548596419205166*^9}, {3.5485964747953453`*^9, 3.548596666441307*^9}, {
  3.548596789027318*^9, 3.548596791313449*^9}, {3.54859689729051*^9, 
  3.5485968982145634`*^9}, {3.5485970754817023`*^9, 3.5485970810720224`*^9}, {
  3.548601094181363*^9, 3.548601141526071*^9}, {3.548601228014018*^9, 
  3.5486012455100183`*^9}, {3.5486015052638755`*^9, 3.548601513522348*^9}, {
  3.5486021619624367`*^9, 3.548602208246084*^9}, {3.548603191013295*^9, 
  3.548603202408947*^9}, {3.548603360132968*^9, 3.5486034378874154`*^9}, {
  3.5486037657511683`*^9, 3.5486037953368607`*^9}, {3.557735613195719*^9, 
  3.5577356251141396`*^9}, {3.558833419924079*^9, 3.55883343620601*^9}, {
  3.5588334863698792`*^9, 3.558833498806591*^9}}],

Cell[BoxData["freqs"], "Input",
 CellChangeTimes->{{3.551367537599634*^9, 3.551367540590805*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"kmin", "=", "3"}], ";", 
   RowBox[{"kmax", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"kmin", "=", "1"}], ";", 
    RowBox[{"kmax", "=", 
     RowBox[{"Length", "[", "freqs", "]"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDflux", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDLP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PSDCP", "[", "k", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5486022164095507`*^9, 3.5486022274141808`*^9}, {
  3.548603444138773*^9, 3.54860345773155*^9}, {3.54860351210266*^9, 
  3.5486035139077635`*^9}, {3.55773962159896*^9, 3.557739623002962*^9}, {
  3.5588327715569944`*^9, 3.55883291345411*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Blue", ",", 
       RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"lmax", "=", 
      RowBox[{"Quotient", "[", 
       RowBox[{"l", ",", "2"}], "]"}]}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"coe", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveF", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<Flux, Jy\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveLP", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<LP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveEVPA", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<EVPA angle, deg\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"LcurveCP", "[", "fr", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<Time, M\>\"", ",", "\"\<CP fraction, %\>\""}], 
               "}"}]}]}], "]"}]}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQBWIQrbT3gKBm3ivHHGcHERA9UWO5JIgOCpqtBKKNCk00
QTSDGJMWiL7kuVgfRJfNvGUEone6VdiA5dd6BYHo5rnPwkB0S8arXBB9Suda
MYjWaJesAdFsRT98tYG0WtkvMN1/5eAuW5D4lotgen7u9wuuQHrW/t9g+gjj
8/sgWuvu6ccg2jRt7TsQPXXa/o8get+dt5xuQPoW+1cw/Y9n5oMMIP0nxf8x
iGb7tOAziN5luQhMn+OszHzfDHRP97tcEO3nx1gMogVUP9eB6PN8N5tAdPiz
ra0gOuP1r24QbWeT0weiV7yasgNE35jZdgBEn1y08iKIrtFYchVEAwDmJq+L

  "]],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDflux", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDLP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDEVPA", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"PSDCP", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveF_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveF", "[", "k", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveLP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveLP", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveEVPA_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveEVPA", "[", "k", "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\LcurveCP_th\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"Floor", "[", 
         RowBox[{"freqs", "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}], "<>", 
       "\"\<.eps\>\""}], ",", 
      RowBox[{"LcurveCP", "[", "k", "]"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", "kmin", ",", "kmax"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5588336899835253`*^9, 3.558833763719743*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fr", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "[", 
  RowBox[{"[", "fr", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{
    SuperscriptBox["10", "7"], 
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "fr", ",", "12"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5474244310872493`*^9, 3.5474244563596945`*^9}, {
   3.5474244888795547`*^9, 3.547424515096054*^9}, {3.5474245485119658`*^9, 
   3.547424574191434*^9}, {3.5475470934034843`*^9, 3.5475470957396173`*^9}, 
   3.547547753886261*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["lightcurve th=290", "Subsubsection",
 CellChangeTimes->{{3.5577510472865367`*^9, 3.55775104944654*^9}, {
  3.55883260748061*^9, 3.5588326144930105`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";", 
  RowBox[{"imp", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{
      "\"\<E:\\\\GRMHD\\\\Jon\\\\thickdisk7\\\\poliresa93.75th290fn\>\"", "<>", 
       RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", 
       RowBox[{"(*", 
        RowBox[{"18500", ",", "19980", ",", "20"}], "*)"}], "6434", ",", 
       "7034", ",", "coe"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, 
   3.5486008696865225`*^9, {3.548600915220127*^9, 3.548600929823962*^9}, {
   3.551033749980384*^9, 3.551033750871435*^9}, {3.5510337885625906`*^9, 
   3.5510337966150513`*^9}, {3.5520186449336777`*^9, 3.552018650318986*^9}, {
   3.55771381499922*^9, 3.557713848242878*^9}, {3.557714021184782*^9, 
   3.5577140212159815`*^9}, {3.557735285968544*^9, 3.557735286467745*^9}, {
   3.557735457912046*^9, 3.5577354872556973`*^9}, {3.5577395741124763`*^9, 
   3.5577395758284793`*^9}, {3.557855418955073*^9, 3.5578554191790857`*^9}, {
   3.5588325820031524`*^9, 3.5588325935978155`*^9}, {3.558832638447381*^9, 
   3.5588326387844*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "imp", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"type", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fr", "=", "1"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"1", " ", "-", " ", 
     RowBox[{"43", "GHz"}]}], ",", " ", 
    RowBox[{"11", " ", "-", " ", 
     RowBox[{"5000", "GHz"}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", 
                 RowBox[{"(*", "type", "*)"}], "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
  3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
  3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}}],

Cell[BoxData[
 RowBox[{"Length", "[", "freqs", "]"}]], "Input",
 CellChangeTimes->{{3.5486021779733524`*^9, 3.5486021812465396`*^9}}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "k", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "3"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDflux", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "4"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDLP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "5"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "6"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"4.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5485960291688566`*^9, 3.5485960793437266`*^9}, {
  3.5485961723110437`*^9, 3.548596172431051*^9}, {3.548596217990657*^9, 
  3.548596419205166*^9}, {3.5485964747953453`*^9, 3.548596666441307*^9}, {
  3.548596789027318*^9, 3.548596791313449*^9}, {3.54859689729051*^9, 
  3.5485968982145634`*^9}, {3.5485970754817023`*^9, 3.5485970810720224`*^9}, {
  3.548601094181363*^9, 3.548601141526071*^9}, {3.548601228014018*^9, 
  3.5486012455100183`*^9}, {3.5486015052638755`*^9, 3.548601513522348*^9}, {
  3.5486021619624367`*^9, 3.548602208246084*^9}, {3.548603191013295*^9, 
  3.548603202408947*^9}, {3.548603360132968*^9, 3.5486034378874154`*^9}, {
  3.5486037657511683`*^9, 3.5486037953368607`*^9}, {3.557735613195719*^9, 
  3.5577356251141396`*^9}}],

Cell[BoxData["freqs"], "Input",
 CellChangeTimes->{{3.551367537599634*^9, 3.551367540590805*^9}}],

Cell[BoxData[{
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PSDflux", "[", "k", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PSDLP", "[", "k", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5486022164095507`*^9, 3.5486022274141808`*^9}, {
  3.548603444138773*^9, 3.54860345773155*^9}, {3.54860351210266*^9, 
  3.5486035139077635`*^9}, {3.55773962159896*^9, 3.557739623002962*^9}}],

Cell[BoxData["194"], "Input",
 CellChangeTimes->{{3.5578554432654634`*^9, 3.5578554452725782`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDflux.eps\>\"", ",", 
   RowBox[{"PSDflux", "[", "5", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.54860297377987*^9, 3.548603007281786*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"lmax", "=", 
      RowBox[{"Quotient", "[", 
       RowBox[{"l", ",", "2"}], "]"}]}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"coe", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "11"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474167180230875`*^9, 3.54741673800823*^9}, {
  3.547416781223702*^9, 3.547416852853799*^9}, {3.547416905638818*^9, 
  3.5474169120651855`*^9}, {3.5474169571027613`*^9, 3.547416982831233*^9}, {
  3.547417059758633*^9, 3.547417234333618*^9}, {3.5474172712067275`*^9, 
  3.5474174553252583`*^9}, {3.5474175026929674`*^9, 3.5474175687977486`*^9}, {
  3.547421295763919*^9, 3.5474212958269224`*^9}, {3.547459030057197*^9, 
  3.5474590305532255`*^9}, {3.5474755917321315`*^9, 3.547475591867139*^9}, {
  3.5474757112189655`*^9, 3.5474757423707476`*^9}, {3.5474758294187264`*^9, 
  3.5474758539871316`*^9}, {3.547476047433196*^9, 3.5474760476572084`*^9}, {
  3.547547396782836*^9, 3.547547418481077*^9}, {3.547547549029544*^9, 
  3.5475475490695467`*^9}}],

Cell[BoxData["194"], "Input",
 CellChangeTimes->{{3.557855449623827*^9, 3.557855450143857*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fr", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "[", 
  RowBox[{"[", "fr", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{
    SuperscriptBox["10", "7"], 
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "fr", ",", "12"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5474244310872493`*^9, 3.5474244563596945`*^9}, {
   3.5474244888795547`*^9, 3.547424515096054*^9}, {3.5474245485119658`*^9, 
   3.547424574191434*^9}, {3.5475470934034843`*^9, 3.5475470957396173`*^9}, 
   3.547547753886261*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["images", "Subsubsection",
 CellChangeTimes->{{3.557751054136546*^9, 3.5577510573165507`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Clear", "[", "totI", "]"}], ";", 
    RowBox[{"dir", "=", "\"\<E:\\\\GRMHD\\\\Jon\\\\\>\""}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Off", "[", 
     StyleBox[
      RowBox[{"InterpolatingFunction", "::", "dmval"}], "MessageName"], "]"}],
     ";", "\[IndentingNewLine]", 
    RowBox[{"fmin", "=", "6734"}], ";", 
    RowBox[{"fmax", "=", "7034"}], ";", 
    RowBox[{"ind", "=", "2"}], ";", 
    RowBox[{"sep", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"ind", "-", "1"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"fmin", "=", 
       RowBox[{"fmax", "=", "8650"}]}], ";", 
      RowBox[{"ind", "=", "1"}], ";"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"taxx", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"namefile", "=", 
         RowBox[{"dir", "<>", "\"\<shotimag93.75th194f145fn\>\"", "<>", 
          RowBox[{"ToString", "[", "fnum", "]"}], "<>", 
          "\"\<_201.dat\>\""}]}], ";", 
        RowBox[{"fi11", "=", 
         RowBox[{"OpenRead", "[", 
          RowBox[{"namefile", ",", 
           RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
        RowBox[{"params", "=", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"a", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", 
        RowBox[{"th", "=", 
         RowBox[{"Round", "[", 
          RowBox[{
           RowBox[{"Round", "[", 
            RowBox[{
             FractionBox["180", "\[Pi]"], 
             RowBox[{"(", 
              RowBox[{"\[Pi]", "-", 
               RowBox[{"params", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "10"}], "]"}], 
           "/", "10."}], "]"}]}], ";", 
        RowBox[{"nxy", "=", 
         RowBox[{"Round", "[", 
          RowBox[{"params", "[", 
           RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
        RowBox[{"nu", "=", 
         RowBox[{"Round", "[", 
          RowBox[{"params", "[", 
           RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
        RowBox[{"maxy", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "5", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"heat", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "6", "]"}], "]"}]}], ";", 
        RowBox[{"rnohor", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "7", "]"}], "]"}]}], ";", 
        RowBox[{"inten", "=", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
        RowBox[{"Close", "[", "fi11", "]"}], ";", 
        RowBox[{"partres", "=", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{"inten", ",", "5"}], "]"}], ",", 
           RowBox[{"nxy", "+", "1"}]}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"partres", "=", 
     FractionBox[
      RowBox[{"Total", "[", 
       RowBox[{"taxx", ",", 
        RowBox[{"{", "1", "}"}]}], "]"}], "ind"]}], ";", 
    RowBox[{"de", "=", 
     SuperscriptBox["10", 
      RowBox[{"-", "20."}]]}], ";", "\[IndentingNewLine]", 
    RowBox[{"li09", "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{
         RowBox[{"partres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "+", "de"}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"scale09", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"Mean", "[", 
       RowBox[{
        RowBox[{"Sort", "[", 
         RowBox[{"Flatten", "[", 
          RowBox[{"partres", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], "]"}],
         "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"-", "10"}], ";;", 
          RowBox[{"-", "5"}]}], "]"}], "]"}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"csc", "=", "1"}], ";", 
    RowBox[{"mysize", "=", "20"}], ";", 
    RowBox[{"sss", "=", "1."}], ";", "\[IndentingNewLine]", 
    RowBox[{"ph09", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"180", "-", "\[InvisibleSpace]", "120.29"}], ")"}], 
      "\[Degree]"}]}], ";", 
    RowBox[{"(*", 
     RowBox[{
     "from", " ", "actual", " ", "mean", " ", "position", " ", "angles"}], 
     "*)"}], 
    RowBox[{"ph09", "=", "0."}], ";", "\[IndentingNewLine]", 
    RowBox[{"con", "=", "20"}], ";", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
       RowBox[{"contrast", " ", "con"}], "\[Implies]", 
       RowBox[{
       "luminosity", " ", "con", " ", "times", " ", "lower", " ", "is", " ", 
        "black"}]}], ",", 
      RowBox[{"max", " ", "luminosity", " ", "is", " ", "white"}]}], "*)"}], 
    RowBox[{"totI09", "=", 
     RowBox[{"DensityPlot", "[", 
      RowBox[{
       RowBox[{"rr", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"li09", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"y", " ", 
                RowBox[{"Cos", "[", "ph09", "]"}]}], "+", 
               RowBox[{"x", " ", 
                RowBox[{"Sin", "[", "ph09", "]"}]}]}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "y"}], " ", 
                RowBox[{"Sin", "[", "ph09", "]"}]}], "+", 
               RowBox[{"x", " ", 
                RowBox[{"Cos", "[", "ph09", "]"}]}]}]}], "]"}], "-", 
            "scale09"}], ")"}], "/", 
          RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{
          RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
         RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", 
         RowBox[{
          RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
         RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
       RowBox[{"Axes", "\[Rule]", "False"}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
       RowBox[{"PlotPoints", "\[Rule]", "150"}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"RGBColor", "[", 
           RowBox[{
            RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
            RowBox[{"#1", " ", "csc"}], ",", 
            RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
       RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"I05line", "=", 
              RowBox[{
              "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): \
\!\(\*SubscriptBox[\(a\), \(*\)]\)=\>\"", "<>", 
               RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
               "\"\<GHz,   \[Theta]=\>\"", "<>", 
               RowBox[{"ToString", "[", "th", "]"}], "<>", 
               "\"\<\[Degree]\>\""}]}], ",", 
             RowBox[{"mysize", "-", "2"}], ",", "Bold", ",", "Pink"}], "]"}], 
           ",", 
           RowBox[{"Scaled", "[", 
            RowBox[{"{", 
             RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", 
           RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
      "]"}]}]}], "*)"}], "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"LaunchKernels", "[", "]"}], ";", 
    RowBox[{"Print", "[", 
     RowBox[{"Dynamic", "[", "i", "]"}], "]"}], ";", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"CloseKernels", "[", "]"}], ";", 
      RowBox[{"LaunchKernels", "[", "]"}], ";"}]}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"ParallelDo", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"func", "[", "m_", "]"}], ":=", 
      RowBox[{"Quiet", "[", 
       RowBox[{
        RowBox[{
        "dir", "=", 
         "\"\<E:\\\\GRMHD\\\\Jon\\\\thickdisk7\\\\movies\\\\\>\""}], ";", 
        RowBox[{"namefile", "=", 
         RowBox[{
         "\"\<E:\\\\GRMHD\\\\Jon\\\\thickdisk7\\\\imag_th263_201\\\\\>\"", 
          "<>", "\"\<shotimag93.75th263f857fn\>\"", "<>", 
          RowBox[{"ToString", "[", "m", "]"}], "<>", "\"\<_201.dat\>\""}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"fi11", "=", 
         RowBox[{"OpenRead", "[", 
          RowBox[{"namefile", ",", 
           RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"params", "=", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"a", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", 
        RowBox[{"th", "=", 
         RowBox[{"Round", "[", 
          RowBox[{
           RowBox[{"Round", "[", 
            RowBox[{
             FractionBox["180", "\[Pi]"], 
             RowBox[{"(", 
              RowBox[{"\[Pi]", "-", 
               RowBox[{"params", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "10"}], "]"}], 
           "/", "10."}], "]"}]}], ";", 
        RowBox[{"nxy", "=", 
         RowBox[{"Round", "[", 
          RowBox[{"params", "[", 
           RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
        RowBox[{"nu", "=", 
         RowBox[{"Round", "[", 
          RowBox[{"params", "[", 
           RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
        RowBox[{"maxy", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "5", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"heat", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "6", "]"}], "]"}]}], ";", 
        RowBox[{"rnohor", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "7", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"freqtab", "=", 
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"BinaryReadList", "[", 
              RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", 
               RowBox[{"2", " ", 
                RowBox[{"(", 
                 RowBox[{"flen", "+", "1"}], ")"}]}]}], "]"}], ",", "2"}], 
            "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"inten", "=", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"partres", "=", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{"inten", ",", "5"}], "]"}], ",", 
           RowBox[{"nxy", "+", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Close", "[", "fi11", "]"}], ";", "\n", 
        RowBox[{"nana", "=", 
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{"Round", "[", 
            RowBox[{"100", " ", "a"}], "]"}], "]"}], "<>", "\"\<th\>\"", "<>", 
          RowBox[{"StringJoin", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"ToString", "[", "#", "]"}], "&"}], "/@", 
            RowBox[{"PadLeft", "[", 
             RowBox[{
              RowBox[{"IntegerDigits", "[", 
               RowBox[{"Round", "[", 
                RowBox[{"100", " ", 
                 RowBox[{"params", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], ",", "3"}], 
             "]"}]}], "]"}], "<>", "\"\<f\>\"", "<>", 
          RowBox[{"ToString", "[", "nu", "]"}], "<>", "\"\<s\>\"", "<>", 
          RowBox[{"StringTake", "[", 
           RowBox[{"namefile", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "12"}], ",", 
              RowBox[{"-", "9"}]}], "}"}]}], "]"}], "<>", "\"\<.jpg\>\""}]}], 
        ";", 
        RowBox[{"nameQU", "=", 
         RowBox[{"dir", "<>", "\"\<shotQUa\>\"", "<>", "nana"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"FileExistsQ", "[", "nameQU", "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"scI", "=", 
             RowBox[{"-", "9."}]}], ";", 
            RowBox[{"scL", "=", 
             RowBox[{"-", "11.1"}]}], ";", 
            RowBox[{"scV", "=", 
             RowBox[{"4", " ", 
              SuperscriptBox["10", 
               RowBox[{"-", "6."}]]}]}], ";", 
            RowBox[{"csc", "=", "1.0"}], ";"}], 
           RowBox[{"(*", 
            RowBox[{"\[Nu]", "=", 
             RowBox[{"102", "GHz"}]}], "*)"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"scI", "=", 
             RowBox[{"-", "7.1"}]}], ";", 
            RowBox[{"scL", "=", 
             RowBox[{"-", "9.0"}]}], ";", 
            RowBox[{"scV", "=", 
             RowBox[{"9", " ", 
              SuperscriptBox["10", 
               RowBox[{"-", "6."}]]}]}], ";", 
            RowBox[{"csc", "=", "1.0"}], ";"}], 
           RowBox[{"(*", 
            RowBox[{"\[Nu]", "=", 
             RowBox[{"231", "GHz"}]}], "*)"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"scI", "=", 
            RowBox[{"-", "5.6"}]}], ";", 
           RowBox[{"scL", "=", 
            RowBox[{"-", "6.1"}]}], ";", 
           RowBox[{"scV", "=", 
            RowBox[{"1.3", " ", 
             SuperscriptBox["10", 
              RowBox[{"-", "6."}]]}]}], ";", 
           RowBox[{"csc", "=", "1.0"}], ";", 
           RowBox[{"(*", 
            RowBox[{"\[Nu]", "=", 
             RowBox[{"857", "GHz"}]}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"li", "=", 
            RowBox[{"ListInterpolation", "[", 
             RowBox[{
              RowBox[{"Log", "[", 
               RowBox[{
                SuperscriptBox["10", 
                 RowBox[{"-", "10"}]], "+", 
                RowBox[{"partres", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}]}], 
               "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
              RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"linQ", "=", 
            RowBox[{"ListInterpolation", "[", 
             RowBox[{
              RowBox[{"partres", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
              RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"linU", "=", 
            RowBox[{"ListInterpolation", "[", 
             RowBox[{
              RowBox[{"partres", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "All", ",", "3"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
              RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"linV", "=", 
            RowBox[{"ListInterpolation", "[", 
             RowBox[{
              RowBox[{"partres", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "All", ",", "4"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
              RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"scV", "=", 
              FractionBox[
               RowBox[{"Total", "[", 
                RowBox[{"Flatten", "[", 
                 RowBox[{"Abs", "[", 
                  RowBox[{"partres", "[", 
                   RowBox[{"[", 
                    RowBox[{"All", ",", "All", ",", "4"}], "]"}], "]"}], 
                  "]"}], "]"}], "]"}], 
               SuperscriptBox["nxy", "2"]]}], ";", 
             RowBox[{"dat", "=", 
              SqrtBox[
               RowBox[{
                SuperscriptBox[
                 RowBox[{"partres", "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}], "2"], 
                "+", 
                SuperscriptBox[
                 RowBox[{"partres", "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "All", ",", "3"}], "]"}], "]"}], 
                 "2"]}]]}], ";", 
             RowBox[{"scL", "=", 
              RowBox[{"Log", "[", 
               RowBox[{"Max", "[", "dat", "]"}], "]"}]}], ";", 
             RowBox[{"scL", "=", 
              RowBox[{"Log", "[", 
               RowBox[{"3", 
                FractionBox[
                 RowBox[{"Total", "[", 
                  RowBox[{"Flatten", "[", "dat", "]"}], "]"}], 
                 SuperscriptBox["nxy", "2"]]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"scI", "=", 
              RowBox[{"Log", "[", 
               RowBox[{"Max", "[", 
                RowBox[{"partres", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], 
               "]"}]}], ";", 
             RowBox[{"scI", "=", 
              RowBox[{"Log", "[", 
               RowBox[{"5", 
                FractionBox[
                 RowBox[{"Total", "[", 
                  RowBox[{"Flatten", "[", 
                   RowBox[{"partres", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], 
                   "]"}], "]"}], 
                 SuperscriptBox["nxy", "2"]]}], "]"}]}], ";"}], "*)"}], 
           RowBox[{"csc", "=", "1"}], ";", "\[IndentingNewLine]", 
           RowBox[{"con", "=", "10"}], ";", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
              RowBox[{"contrast", " ", "con"}], "\[Implies]", 
              RowBox[{
              "luminosity", " ", "con", " ", "times", " ", "lower", " ", "is",
                " ", "black"}]}], ",", 
             RowBox[{"max", " ", "luminosity", " ", "is", " ", "white"}]}], 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"totI", "=", 
            RowBox[{"DensityPlot", "[", 
             RowBox[{
              RowBox[{"rr", "=", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"li", "[", 
                    RowBox[{"y", ",", "x"}], "]"}], "-", "scI"}], ")"}], "/", 
                 RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"y", ",", 
                RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
              RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
              RowBox[{"ColorFunction", "\[Rule]", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"RGBColor", "[", 
                  RowBox[{
                   RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
                   RowBox[{"#1", " ", "csc"}], ",", 
                   RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
              RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
              RowBox[{"Frame", "\[Rule]", "True"}], ",", 
              RowBox[{"FrameStyle", "\[Rule]", 
               RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
              RowBox[{"Axes", "\[Rule]", "False"}], ",", 
              RowBox[{"BaseStyle", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
                 RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
                 RowBox[{"FontSize", "\[Rule]", "24"}]}], "}"}]}], ",", 
              RowBox[{"Epilog", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Text", "[", 
                 RowBox[{
                  RowBox[{"Style", "[", 
                   RowBox[{
                    RowBox[{
                    "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): \
a=\>\"", "<>", 
                    RowBox[{"ToString", "[", "a", "]"}], "<>", 
                    "\"\<,   \[Nu]=\>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
                    "\"\<GHz,    \[Theta]=\>\"", "<>", 
                    RowBox[{"ToString", "[", "th", "]"}], "<>", 
                    "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", 
                    "Pink"}], "]"}], ",", 
                  RowBox[{"Scaled", "[", 
                   RowBox[{"{", 
                    RowBox[{"0.5", ",", "0.92"}], "}"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"1", ",", "0"}], "}"}], ",", 
                  RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], 
                "}"}]}], ",", 
              RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"scal", "=", 
            RowBox[{"{", 
             RowBox[{"0.02", ",", "0.005"}], "}"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"sc", "=", 
              RowBox[{"30", 
               FractionBox["1", 
                RowBox[{"nxy", " ", "nxy"}]], 
               RowBox[{"Total", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Sort", "[", 
                   RowBox[{"Flatten", "[", 
                    RowBox[{"Abs", "[", 
                    RowBox[{"partres", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "All", ",", "4"}], "]"}], "]"}], 
                    "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"Round", "[", 
                    RowBox[{
                    FractionBox["1", "4"], "nxy", "*", "nxy"}], "]"}], ";;", 
                    RowBox[{"Round", "[", 
                    RowBox[{
                    FractionBox["3", "4"], "nxy", "*", "nxy"}], "]"}]}], 
                   "]"}], "]"}], ",", "2"}], "]"}]}]}], ";"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"totV", "=", 
            RowBox[{"DensityPlot", "[", 
             RowBox[{
              RowBox[{"res", "=", 
               RowBox[{"linV", "[", 
                RowBox[{"y", ",", "x"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"y", ",", 
                RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
              RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
              RowBox[{"ColorFunction", "\[Rule]", 
               RowBox[{"Function", "[", 
                RowBox[{
                 RowBox[{"{", "n", "}"}], ",", 
                 RowBox[{
                  RowBox[{"r", "=", 
                   RowBox[{"n", "/", "scV"}]}], ";", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"r", ">", "0"}], ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{
                    RowBox[{"2", "r"}], ",", "r", ",", "r"}], "]"}], ",", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{
                    RowBox[{"-", "r"}], ",", 
                    RowBox[{"-", "r"}], ",", 
                    RowBox[{
                    RowBox[{"-", "2"}], "r"}]}], "]"}]}], "]"}]}]}], "]"}]}], 
              ",", 
              RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
              RowBox[{"Frame", "\[Rule]", "True"}], ",", 
              RowBox[{"FrameStyle", "\[Rule]", 
               RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
              RowBox[{"Axes", "\[Rule]", "False"}], ",", 
              RowBox[{"BaseStyle", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
                 RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
                 RowBox[{"FontSize", "\[Rule]", "22"}]}], "}"}]}], ",", 
              RowBox[{"Epilog", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Text", "[", 
                 RowBox[{
                  RowBox[{"Style", "[", 
                   RowBox[{
                    RowBox[{"\"\<V: a=\>\"", "<>", 
                    RowBox[{"ToString", "[", "a", "]"}], "<>", 
                    "\"\<,  \[Nu]=\>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
                    "\"\<GHz,   \[Theta]=\>\"", "<>", 
                    RowBox[{"ToString", "[", "th", "]"}], "<>", 
                    "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", 
                    "Pink"}], "]"}], ",", 
                  RowBox[{"Scaled", "[", 
                   RowBox[{"{", 
                    RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"1", ",", "0"}], "}"}], ",", 
                  RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], 
                "}"}]}], ",", 
              RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], 
           ";", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Red", " ", "-", " ", "positive"}], ",", " ", 
             RowBox[{"Blue", " ", "-", " ", "negative"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"totQU", "=", 
            RowBox[{"VectorDensityPlot", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"A", "=", 
                  RowBox[{"linQ", "[", 
                   RowBox[{"y", ",", "x"}], "]"}]}], ";", 
                 RowBox[{"B", "=", 
                  RowBox[{"linU", "[", 
                   RowBox[{"y", ",", "x"}], "]"}]}], ";", 
                 RowBox[{"ann", "=", 
                  FractionBox[
                   RowBox[{"ArcTan", "[", 
                    RowBox[{"A", ",", "B"}], "]"}], "2"]}], ";", 
                 RowBox[{"Cos", "[", "ann", "]"}]}], ",", 
                RowBox[{"-", 
                 RowBox[{"Sin", "[", "ann", "]"}]}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"y", ",", 
                RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
              RowBox[{"VectorPoints", "\[Rule]", "100"}], ",", 
              RowBox[{"VectorStyle", "\[Rule]", 
               RowBox[{"Arrowheads", "[", "0", "]"}]}], ",", 
              RowBox[{"StreamStyle", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Arrowheads", "[", "0", "]"}], ",", 
                 RowBox[{"RGBColor", "[", 
                  RowBox[{"1", ",", "0.5", ",", "0.5"}], "]"}]}], "}"}]}], 
              ",", 
              RowBox[{"StreamPoints", "\[Rule]", "100"}], ",", 
              RowBox[{"StreamScale", "\[Rule]", "Full"}], ",", 
              RowBox[{"MaxRecursion", "\[Rule]", "2"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
              RowBox[{"ColorFunction", "\[Rule]", 
               RowBox[{"Function", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"x", ",", "y", ",", "vx", ",", "vy", ",", "n"}], 
                  "}"}], ",", 
                 RowBox[{
                  RowBox[{"w", "=", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    FractionBox["1", "2"], 
                    RowBox[{"Log", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"linQ", "[", 
                    RowBox[{"y", ",", "x"}], "]"}], "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"linU", "[", 
                    RowBox[{"y", ",", "x"}], "]"}], "^", "2"}]}], "]"}]}], 
                    "-", "scL"}], ")"}], "/", 
                    RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ";", 
                  RowBox[{"RGBColor", "[", 
                   RowBox[{
                    RowBox[{"2", " ", "w", " ", "csc"}], ",", 
                    RowBox[{"w", " ", "csc"}], ",", 
                    RowBox[{"w", " ", "csc"}]}], "]"}]}]}], "]"}]}], ",", 
              RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
              RowBox[{"Frame", "\[Rule]", "True"}], ",", 
              RowBox[{"FrameStyle", "\[Rule]", 
               RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
              RowBox[{"Axes", "\[Rule]", "False"}], ",", 
              RowBox[{"BaseStyle", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
                 RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
                 RowBox[{"FontSize", "\[Rule]", "22"}]}], "}"}]}], ",", 
              RowBox[{"Epilog", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Text", "[", 
                 RowBox[{
                  RowBox[{"Style", "[", 
                   RowBox[{
                    RowBox[{
                    "\"\<\!\(\*SqrtBox[\(\*SuperscriptBox[\(Q\), \(2\)] + \
\*SuperscriptBox[\(U\), \(2\)]\)]\) & field: a=\>\"", "<>", 
                    RowBox[{"ToString", "[", "a", "]"}], "<>", 
                    "\"\<,  \[Nu]=\>\"", "<>", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
                    "\"\<GHz,   \[Theta]=\>\"", "<>", 
                    RowBox[{"ToString", "[", "th", "]"}], "<>", 
                    "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", 
                    "Pink"}], "]"}], ",", 
                  RowBox[{"Scaled", "[", 
                   RowBox[{"{", 
                    RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"1", ",", "0"}], "}"}], ",", 
                  RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], 
                "}"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"name", "=", 
            RowBox[{"dir", "<>", "\"\<shotIa\>\"", "<>", "nana"}]}], ";", 
           RowBox[{"Export", "[", 
            RowBox[{"name", ",", "totI", ",", 
             RowBox[{"\"\<CompressionLevel\>\"", "\[Rule]", "0"}], ",", 
             RowBox[{"\"\<Progressive\>\"", "\[Rule]", "True"}]}], "]"}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"name", "=", 
            RowBox[{"dir", "<>", "\"\<shotVa\>\"", "<>", "nana"}]}], ";", 
           RowBox[{"Export", "[", 
            RowBox[{"name", ",", "totV", ",", 
             RowBox[{"\"\<CompressionLevel\>\"", "\[Rule]", "0"}], ",", 
             RowBox[{"\"\<Progressive\>\"", "\[Rule]", "True"}]}], "]"}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"Export", "[", 
            RowBox[{"nameQU", ",", "totQU", ",", 
             RowBox[{"\"\<CompressionLevel\>\"", "\[Rule]", "0"}], ",", 
             RowBox[{"\"\<Progressive\>\"", "\[Rule]", "True"}]}], "]"}], 
           ";"}]}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{"Export", "[", 
           RowBox[{"name", ",", 
            RowBox[{"totI", "[", "i", "]"}], ",", 
            RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
            RowBox[{"ImageResolution", "\[Rule]", "300"}]}], "]"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"Exit", "[", "]"}], ";"}], "*)"}], "]"}], ";"}], "]"}]}], 
     ";", 
     RowBox[{"func", "[", "j", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", 
      RowBox[{"(*", 
       RowBox[{"5534", ",", "7034", ","}], "*)"}], "5534", ",", "7034", ",", 
      "75"}], "}"}]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"j", ",", 
        RowBox[{"10", "i"}], ",", 
        RowBox[{
         RowBox[{"10", "i"}], "+", "9"}]}], "}"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "406", ",", "447"}], "}"}]}], "]"}], 
   "*)"}]}]], "Input",
 CellChangeTimes->{{3.545492914912758*^9, 3.5454930315594296`*^9}, 
   3.5454931047416153`*^9, {3.557678606764617*^9, 3.5576787168469133`*^9}, {
   3.557681383489436*^9, 3.55768144526997*^9}, {3.5576824130523243`*^9, 
   3.5576824417939677`*^9}, {3.5576825227235966`*^9, 
   3.5576825230106134`*^9}, {3.5576826341629705`*^9, 3.557682634232975*^9}, {
   3.557685315933359*^9, 3.557685316279379*^9}, {3.557685501581978*^9, 
   3.5576855017329865`*^9}, {3.557685570543922*^9, 3.557685570892942*^9}, 
   3.5577398754640636`*^9, {3.5577538926616096`*^9, 3.5577539193616476`*^9}, {
   3.55775771283887*^9, 3.5577577192388787`*^9}, 3.557758065159363*^9, {
   3.557758218902708*^9, 3.5577582376727343`*^9}, 3.557760362214073*^9, {
   3.5577604005941267`*^9, 3.557760417784151*^9}, {3.5577648353749886`*^9, 
   3.5577648356860065`*^9}, {3.5577648952474127`*^9, 
   3.5577649531267233`*^9}, {3.557765015757306*^9, 3.557765049010208*^9}, {
   3.55776508016999*^9, 3.557765110154705*^9}, {3.5577654004993114`*^9, 
   3.557765481451942*^9}, {3.557765543901514*^9, 3.557765560881485*^9}, {
   3.55776567967328*^9, 3.557765679735283*^9}, 3.557765728143052*^9, {
   3.557765801806265*^9, 3.557765802205288*^9}, {3.5577736737455144`*^9, 
   3.5577736742555437`*^9}, {3.5577737328948975`*^9, 
   3.5577737489038134`*^9}, {3.5577789557276263`*^9, 
   3.5577789846612816`*^9}, {3.5577790613486676`*^9, 3.557779078235634*^9}, {
   3.557784723719537*^9, 3.5577847544172926`*^9}, {3.5577849430170803`*^9, 
   3.557784970852672*^9}, {3.557785033862276*^9, 3.557785042188752*^9}, {
   3.557789555936924*^9, 3.5577895695107*^9}, {3.5577898796274376`*^9, 
   3.55778991619753*^9}, {3.557789955229762*^9, 3.5577899627041893`*^9}, {
   3.5577920542588196`*^9, 3.5577920567799635`*^9}, {3.5578211159720545`*^9, 
   3.55782111712012*^9}, {3.5578213312593684`*^9, 3.5578213406629057`*^9}, {
   3.5578272891021376`*^9, 3.55782728932515*^9}, {3.5578278451329403`*^9, 
   3.557827846709031*^9}, {3.5578280463134475`*^9, 3.557828046567462*^9}, {
   3.557835082632902*^9, 3.557835082866915*^9}, {3.5578351663526907`*^9, 
   3.5578351665677023`*^9}, {3.557855550464595*^9, 3.557855550992625*^9}, 
   3.557859023339232*^9, {3.5578639505710535`*^9, 3.5578639507840652`*^9}, {
   3.557864011371531*^9, 3.5578640116275454`*^9}, {3.5578668456226406`*^9, 
   3.5578668458586545`*^9}, {3.557867011487128*^9, 3.557867051000388*^9}, {
   3.55786708530235*^9, 3.557867094361868*^9}, {3.557867131249978*^9, 
   3.5578671823389*^9}, {3.5614072058258524`*^9, 3.561407206247053*^9}, {
   3.561407653593439*^9, 3.5614076791618834`*^9}, {3.561407721079157*^9, 
   3.561407747708404*^9}, {3.56140779096728*^9, 3.561407798689294*^9}, {
   3.561407848874582*^9, 3.561407895597664*^9}, {3.5614086953102684`*^9, 
   3.5614086977126727`*^9}, {3.561408757195577*^9, 3.561408769613199*^9}, {
   3.561408837473318*^9, 3.561408847457336*^9}, {3.561408877970989*^9, 
   3.561408893477417*^9}, {3.5614089485611134`*^9, 3.561408951213118*^9}, {
   3.5614090863561554`*^9, 3.5614091316898355`*^9}, {3.5614174399608326`*^9, 
   3.561417440569234*^9}, {3.5614175144629517`*^9, 3.5614175146229525`*^9}, {
   3.5614175532402124`*^9, 3.5614175841658664`*^9}, {3.5614237469279947`*^9, 
   3.5614238134309115`*^9}, {3.5614238663774047`*^9, 3.561423881961832*^9}, {
   3.5614240331572976`*^9, 3.5614240369169044`*^9}, {3.5614240682417593`*^9, 
   3.5614240802693806`*^9}, {3.5614638921586084`*^9, 3.561463900005422*^9}, {
   3.561464631369692*^9, 3.5614646388109045`*^9}, {3.561465150335803*^9, 
   3.56146515429821*^9}, {3.561465832346079*^9, 3.5614658329388804`*^9}, {
   3.561466364915415*^9, 3.561466446239358*^9}, {3.5614755269015436`*^9, 
   3.5614755389915648`*^9}, {3.566691085249196*^9, 3.566691089055603*^9}, {
   3.566691186976975*^9, 3.566691188193777*^9}, {3.566691307253186*^9, 
   3.566691310232792*^9}, 3.5666913928505363`*^9, 3.5666914370922146`*^9, {
   3.5666915192887588`*^9, 3.5666915276503735`*^9}, {3.566691806142062*^9, 
   3.5666918249244957`*^9}, {3.5666918732533803`*^9, 
   3.5666918733937807`*^9}, {3.5666921287984295`*^9, 3.566692137737245*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"scI", "=", 
   RowBox[{"-", "5.6"}]}], ";", 
  RowBox[{"Quiet", "[", 
   RowBox[{"totI", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"rr", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"li", "[", 
            RowBox[{"y", ",", "x"}], "]"}], "-", "scI"}], ")"}], "/", 
         RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{
           RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "24"}]}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{
            "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): a=\>\"", "<>", 
             RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,   \[Nu]=\>\"", 
             "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
             "\"\<GHz,    \[Theta]=\>\"", "<>", 
             RowBox[{"ToString", "[", "th", "]"}], "<>", 
             "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", "Pink"}], 
           "]"}], ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.92"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.561423898591461*^9, 3.561423931601119*^9}, {
  3.561465991138758*^9, 3.561466017861605*^9}, {3.5614662480400095`*^9, 
  3.56146624833641*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"scV", "=", 
   RowBox[{"1.3", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "6"}]]}]}], ";", 
  RowBox[{"Quiet", "[", 
   RowBox[{"totV", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"res", "=", 
       RowBox[{"linV", "[", 
        RowBox[{"y", ",", "x"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"Function", "[", 
        RowBox[{
         RowBox[{"{", "n", "}"}], ",", 
         RowBox[{
          RowBox[{"r", "=", 
           RowBox[{"n", "/", "scV"}]}], ";", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"r", ">", "0"}], ",", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"2", "r"}], ",", "r", ",", "r"}], "]"}], ",", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"-", "r"}], ",", 
              RowBox[{"-", "r"}], ",", 
              RowBox[{
               RowBox[{"-", "2"}], "r"}]}], "]"}]}], "]"}]}]}], "]"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "22"}]}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"\"\<V: a=\>\"", "<>", 
             RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \[Nu]=\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
             "\"\<GHz,   \[Theta]=\>\"", "<>", 
             RowBox[{"ToString", "[", "th", "]"}], "<>", 
             "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", "Pink"}], 
           "]"}], ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"Red", " ", "-", " ", "positive"}], ",", " ", 
     RowBox[{"Blue", " ", "-", " ", "negative"}]}], "*)"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5614173031594114`*^9, 3.56141742583681*^9}, {
  3.561417464218074*^9, 3.5614175097029457`*^9}, {3.5614239438627405`*^9, 
  3.5614239571851645`*^9}, {3.5614662719860516`*^9, 3.5614663048553095`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"scL", "=", 
   RowBox[{"-", "6.1"}]}], ";", 
  RowBox[{"Quiet", "[", 
   RowBox[{"totQU", "=", 
    RowBox[{"VectorDensityPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"A", "=", 
          RowBox[{"linQ", "[", 
           RowBox[{"y", ",", "x"}], "]"}]}], ";", 
         RowBox[{"B", "=", 
          RowBox[{"linU", "[", 
           RowBox[{"y", ",", "x"}], "]"}]}], ";", 
         RowBox[{"ann", "=", 
          FractionBox[
           RowBox[{"ArcTan", "[", 
            RowBox[{"A", ",", "B"}], "]"}], "2"]}], ";", 
         RowBox[{"Cos", "[", "ann", "]"}]}], ",", 
        RowBox[{"-", 
         RowBox[{"Sin", "[", "ann", "]"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"VectorPoints", "\[Rule]", "100"}], ",", 
      RowBox[{"VectorStyle", "\[Rule]", 
       RowBox[{"Arrowheads", "[", "0", "]"}]}], ",", 
      RowBox[{"StreamStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Arrowheads", "[", "0", "]"}], ",", 
         RowBox[{"RGBColor", "[", 
          RowBox[{"1", ",", "0.5", ",", "0.5"}], "]"}]}], "}"}]}], ",", 
      RowBox[{"StreamPoints", "\[Rule]", "100"}], ",", 
      RowBox[{"StreamScale", "\[Rule]", "Full"}], ",", 
      RowBox[{"MaxRecursion", "\[Rule]", "2"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"Function", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "y", ",", "vx", ",", "vy", ",", "n"}], "}"}], ",", 
         RowBox[{
          RowBox[{"w", "=", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                FractionBox["1", "2"], 
                RowBox[{"Log", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"linQ", "[", 
                    RowBox[{"y", ",", "x"}], "]"}], "^", "2"}], "+", 
                  RowBox[{
                   RowBox[{"linU", "[", 
                    RowBox[{"y", ",", "x"}], "]"}], "^", "2"}]}], "]"}]}], 
               "-", "scL"}], ")"}], "/", 
             RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ";", 
          RowBox[{"RGBColor", "[", 
           RowBox[{
            RowBox[{"2", " ", "w", " ", "csc"}], ",", 
            RowBox[{"w", " ", "csc"}], ",", 
            RowBox[{"w", " ", "csc"}]}], "]"}]}]}], "]"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "22"}]}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{
            "\"\<\!\(\*SqrtBox[\(\*SuperscriptBox[\(Q\), \(2\)] + \
\*SuperscriptBox[\(U\), \(2\)]\)]\) & field: a=\>\"", "<>", 
             RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \[Nu]=\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
             "\"\<GHz,   \[Theta]=\>\"", "<>", 
             RowBox[{"ToString", "[", "th", "]"}], "<>", 
             "\"\<\[Degree]\>\""}], ",", "35", ",", "Bold", ",", "Pink"}], 
           "]"}], ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
     "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5614239784792013`*^9, 3.5614240164964685`*^9}, {
  3.561466312889323*^9, 3.5614663434185767`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", "=", "\"\<G:\\\\GRMHD\\\\movies\\\\\>\""}], ";", 
  RowBox[{"namefile", "=", 
   RowBox[{
   "\"\<G:\\\\mathematica\\\\3DMHD\\\\\>\"", "<>", 
    "\"\<shotimag90th214fn\>\"", "<>", 
    RowBox[{"ToString", "[", 
     RowBox[{"-", "1"}], "]"}], "<>", "\"\<.dat\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fi11", "=", 
   RowBox[{"OpenRead", "[", 
    RowBox[{"namefile", ",", 
     RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"params", "=", 
   RowBox[{"BinaryReadList", "[", 
    RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"a", "=", 
  RowBox[{"params", "[", 
   RowBox[{"[", "1", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"th", "=", 
  RowBox[{
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"params", "[", 
      RowBox[{"[", "2", "]"}], "]"}], " ", "1000"}], "]"}], "/", 
   "1000."}]}], "\[IndentingNewLine]", 
 RowBox[{"nxy", "=", 
  RowBox[{"Round", "[", 
   RowBox[{"params", "[", 
    RowBox[{"[", "3", "]"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"nu", "=", 
  RowBox[{"Round", "[", 
   RowBox[{"params", "[", 
    RowBox[{"[", "4", "]"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"maxy", "=", 
  RowBox[{"params", "[", 
   RowBox[{"[", "5", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"heat", "=", 
  RowBox[{"params", "[", 
   RowBox[{"[", "6", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"rnohor", "=", 
  RowBox[{"params", "[", 
   RowBox[{"[", "7", "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.4849256057654*^9, 3.4849256273402*^9}}],

Cell["6441, 6464, 6490, 6515,6541 (25,26,25,26)", "Text",
 CellChangeTimes->{{3.557879489968542*^9, 3.557879537111825*^9}, {
  3.557880300549551*^9, 3.557880308396365*^9}}]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["New ADAF simulations  (2012)", "Section",
 CellChangeTimes->{{3.547415879824145*^9, 3.547415898610219*^9}, {
  3.551033733429437*^9, 3.5510337389957557`*^9}}],

Cell[CellGroupData[{

Cell["spin 0", "Subsection",
 CellChangeTimes->{{3.5474159445628476`*^9, 3.5474159657700605`*^9}, 
   3.5474863364636946`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";", 
  RowBox[{"imp", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{"\"\<E:\\\\GRMHD\\\\ADAFs\\\\a0\\\\poliresa0th184fn\>\"", "<>", 
       RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", 
       RowBox[{"(*", 
        RowBox[{"18500", ",", "19980", ",", "20"}], "*)"}], "10000", ",", 
       "11747", ",", "coe"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, 
   3.5486008696865225`*^9, {3.548600915220127*^9, 3.548600929823962*^9}, {
   3.551033749980384*^9, 3.551033750871435*^9}, {3.5510337885625906`*^9, 
   3.5510337966150513`*^9}, {3.5520186449336777`*^9, 3.552018650318986*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "imp", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"type", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fr", "=", "1"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"1", " ", "-", " ", 
     RowBox[{"43", "GHz"}]}], ",", " ", 
    RowBox[{"11", " ", "-", " ", 
     RowBox[{"5000", "GHz"}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", 
                 RowBox[{"(*", "type", "*)"}], "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
  3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
  3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}}],

Cell[BoxData[
 RowBox[{"Length", "[", "freqs", "]"}]], "Input",
 CellChangeTimes->{{3.5486021779733524`*^9, 3.5486021812465396`*^9}}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "k", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "3"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"10.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDflux", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "4"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"10.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDLP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "5"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"10.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "6"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"10.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5485960291688566`*^9, 3.5485960793437266`*^9}, {
  3.5485961723110437`*^9, 3.548596172431051*^9}, {3.548596217990657*^9, 
  3.548596419205166*^9}, {3.5485964747953453`*^9, 3.548596666441307*^9}, {
  3.548596789027318*^9, 3.548596791313449*^9}, {3.54859689729051*^9, 
  3.5485968982145634`*^9}, {3.5485970754817023`*^9, 3.5485970810720224`*^9}, {
  3.548601094181363*^9, 3.548601141526071*^9}, {3.548601228014018*^9, 
  3.5486012455100183`*^9}, {3.5486015052638755`*^9, 3.548601513522348*^9}, {
  3.5486021619624367`*^9, 3.548602208246084*^9}, {3.548603191013295*^9, 
  3.548603202408947*^9}, {3.548603360132968*^9, 3.5486034378874154`*^9}, {
  3.5486037657511683`*^9, 3.5486037953368607`*^9}}],

Cell[BoxData["freqs"], "Input",
 CellChangeTimes->{{3.551367537599634*^9, 3.551367540590805*^9}}],

Cell[BoxData[{
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PSDflux", "[", "k", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDLP", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5486022164095507`*^9, 3.5486022274141808`*^9}, {
  3.548603444138773*^9, 3.54860345773155*^9}, {3.54860351210266*^9, 
  3.5486035139077635`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDflux.eps\>\"", ",", 
   RowBox[{"PSDflux", "[", "5", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.54860297377987*^9, 3.548603007281786*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"lmax", "=", 
      RowBox[{"Quotient", "[", 
       RowBox[{"l", ",", "2"}], "]"}]}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"coe", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "11"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474167180230875`*^9, 3.54741673800823*^9}, {
  3.547416781223702*^9, 3.547416852853799*^9}, {3.547416905638818*^9, 
  3.5474169120651855`*^9}, {3.5474169571027613`*^9, 3.547416982831233*^9}, {
  3.547417059758633*^9, 3.547417234333618*^9}, {3.5474172712067275`*^9, 
  3.5474174553252583`*^9}, {3.5474175026929674`*^9, 3.5474175687977486`*^9}, {
  3.547421295763919*^9, 3.5474212958269224`*^9}, {3.547459030057197*^9, 
  3.5474590305532255`*^9}, {3.5474755917321315`*^9, 3.547475591867139*^9}, {
  3.5474757112189655`*^9, 3.5474757423707476`*^9}, {3.5474758294187264`*^9, 
  3.5474758539871316`*^9}, {3.547476047433196*^9, 3.5474760476572084`*^9}, {
  3.547547396782836*^9, 3.547547418481077*^9}, {3.547547549029544*^9, 
  3.5475475490695467`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fr", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "[", 
  RowBox[{"[", "fr", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{
    SuperscriptBox["10", "7"], 
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "fr", ",", "12"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5474244310872493`*^9, 3.5474244563596945`*^9}, {
   3.5474244888795547`*^9, 3.547424515096054*^9}, {3.5474245485119658`*^9, 
   3.547424574191434*^9}, {3.5475470934034843`*^9, 3.5475470957396173`*^9}, 
   3.547547753886261*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["spin 0.7", "Subsection",
 CellChangeTimes->{{3.5474159445628476`*^9, 3.5474159657700605`*^9}, 
   3.5474863364636946`*^9, {3.552018680323702*^9, 3.5520186806817226`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";", 
  RowBox[{"imp", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{"\"\<E:\\\\GRMHD\\\\ADAFs\\\\a07\\\\poliresa70th184fn\>\"", "<>", 
       RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", "4559", ",", "5559", ",", "coe"}], "}"}]}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, 
   3.5486008696865225`*^9, {3.548600915220127*^9, 3.548600929823962*^9}, {
   3.551033749980384*^9, 3.551033750871435*^9}, {3.5510337885625906`*^9, 
   3.5510337966150513`*^9}, {3.5520186449336777`*^9, 3.552018650318986*^9}, {
   3.552018685209982*^9, 3.552018712038516*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "imp", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"type", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fr", "=", "1"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"1", " ", "-", " ", 
     RowBox[{"43", "GHz"}]}], ",", " ", 
    RowBox[{"11", " ", "-", " ", 
     RowBox[{"5000", "GHz"}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", 
                 RowBox[{"(*", "type", "*)"}], "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
  3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
  3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "k", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "3"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"10.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDflux", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "4"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"10.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDLP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "5"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"10.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "6"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"10.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5485960291688566`*^9, 3.5485960793437266`*^9}, {
  3.5485961723110437`*^9, 3.548596172431051*^9}, {3.548596217990657*^9, 
  3.548596419205166*^9}, {3.5485964747953453`*^9, 3.548596666441307*^9}, {
  3.548596789027318*^9, 3.548596791313449*^9}, {3.54859689729051*^9, 
  3.5485968982145634`*^9}, {3.5485970754817023`*^9, 3.5485970810720224`*^9}, {
  3.548601094181363*^9, 3.548601141526071*^9}, {3.548601228014018*^9, 
  3.5486012455100183`*^9}, {3.5486015052638755`*^9, 3.548601513522348*^9}, {
  3.5486021619624367`*^9, 3.548602208246084*^9}, {3.548603191013295*^9, 
  3.548603202408947*^9}, {3.548603360132968*^9, 3.5486034378874154`*^9}, {
  3.5486037657511683`*^9, 3.5486037953368607`*^9}}],

Cell[BoxData[{
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PSDflux", "[", "k", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDLP", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5486022164095507`*^9, 3.5486022274141808`*^9}, {
  3.548603444138773*^9, 3.54860345773155*^9}, {3.54860351210266*^9, 
  3.5486035139077635`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDflux.eps\>\"", ",", 
   RowBox[{"PSDflux", "[", "5", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.54860297377987*^9, 3.548603007281786*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"lmax", "=", 
      RowBox[{"Quotient", "[", 
       RowBox[{"l", ",", "2"}], "]"}]}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"coe", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "11"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474167180230875`*^9, 3.54741673800823*^9}, {
  3.547416781223702*^9, 3.547416852853799*^9}, {3.547416905638818*^9, 
  3.5474169120651855`*^9}, {3.5474169571027613`*^9, 3.547416982831233*^9}, {
  3.547417059758633*^9, 3.547417234333618*^9}, {3.5474172712067275`*^9, 
  3.5474174553252583`*^9}, {3.5474175026929674`*^9, 3.5474175687977486`*^9}, {
  3.547421295763919*^9, 3.5474212958269224`*^9}, {3.547459030057197*^9, 
  3.5474590305532255`*^9}, {3.5474755917321315`*^9, 3.547475591867139*^9}, {
  3.5474757112189655`*^9, 3.5474757423707476`*^9}, {3.5474758294187264`*^9, 
  3.5474758539871316`*^9}, {3.547476047433196*^9, 3.5474760476572084`*^9}, {
  3.547547396782836*^9, 3.547547418481077*^9}, {3.547547549029544*^9, 
  3.5475475490695467`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fr", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "[", 
  RowBox[{"[", "fr", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{
    SuperscriptBox["10", "7"], 
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "fr", ",", "12"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5474244310872493`*^9, 3.5474244563596945`*^9}, {
   3.5474244888795547`*^9, 3.547424515096054*^9}, {3.5474245485119658`*^9, 
   3.547424574191434*^9}, {3.5475470934034843`*^9, 3.5475470957396173`*^9}, 
   3.547547753886261*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["New simulations (with cooling 2012)", "Section",
 CellChangeTimes->{{3.547415879824145*^9, 3.547415898610219*^9}}],

Cell[CellGroupData[{

Cell["spin 0", "Subsection",
 CellChangeTimes->{{3.5474159445628476`*^9, 3.5474159657700605`*^9}, 
   3.5474863364636946`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";", 
  RowBox[{"imp", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{"\"\<E:\\\\GRMHD\\\\new\\\\a0\\\\poliresa0th184fn\>\"", "<>", 
       RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", 
       RowBox[{"(*", 
        RowBox[{"18500", ",", "19980", ",", "20"}], "*)"}], "18725", ",", 
       "19999", ",", "coe"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, 
   3.5486008696865225`*^9, {3.548600915220127*^9, 3.548600929823962*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "imp", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"type", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fr", "=", "1"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"1", " ", "-", " ", 
     RowBox[{"43", "GHz"}]}], ",", " ", 
    RowBox[{"11", " ", "-", " ", 
     RowBox[{"5000", "GHz"}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", 
                 RowBox[{"(*", "type", "*)"}], "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
  3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
  3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}}],

Cell[BoxData[
 RowBox[{"Length", "[", "freqs", "]"}]], "Input",
 CellChangeTimes->{{3.5486021779733524`*^9, 3.5486021812465396`*^9}}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Dynamic", "[", "k", "]"}], ",", 
   RowBox[{"Dynamic", "[", "typ", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "3"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"10.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDflux", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "4"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"10.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDLP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "5"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"10.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"typ", "=", "6"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"binned", "=", 
      RowBox[{"imp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "k", ",", "typ"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ll", "=", 
      RowBox[{"Length", "[", "binned", "]"}]}], ";", "\n", 
     RowBox[{"me", "=", 
      RowBox[{"Mean", "[", "binned", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"autovariance", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"ll", "-", "shi"}]}], "]"}], "]"}], "-", "me"}], ")"}],
           ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"binned", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", "+", "shi"}], ";;", "ll"}], "]"}], "]"}], "-", 
            "me"}], ")"}]}], "ll"], ",", 
        RowBox[{"{", 
         RowBox[{"shi", ",", "0", ",", 
          RowBox[{"ll", "-", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"f11", "=", 
      RowBox[{"FourierDCT", "[", 
       RowBox[{"autovariance", ",", "1"}], "]"}]}], ";", 
     RowBox[{"num", "=", 
      RowBox[{"Floor", "[", 
       FractionBox["ll", "2"], "]"}]}], ";", 
     RowBox[{"sur", "=", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"2", "ll"}]], 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"f11", ",", "2"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"2", ";;", "num"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"sur", ",", 
       RowBox[{"sur", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"timex", "=", 
      RowBox[{"10.", 
       RowBox[{"ll", "/", 
        RowBox[{"Range", "[", "num", "]"}]}]}]}], ";", 
     RowBox[{"mint", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"maxt", "=", 
      RowBox[{"timex", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"mult", "=", "1.3"}], ";", 
     RowBox[{"nn", "=", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["maxt", "mint"], "]"}], "/", 
       RowBox[{"Log", "[", "mult", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"tsides", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mint", " ", 
         SuperscriptBox["mult", "i"]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tbins", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tsides", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"tsides", "[", 
           RowBox[{"[", 
            RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tsizes", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}], "-", 
         RowBox[{"tbins", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tmeans", "=", 
      RowBox[{"Mean", "[", 
       RowBox[{"Transpose", "[", "tbins", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"intergra", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"timex", ",", 
            RowBox[{"Abs", "[", "sur", "]"}]}], "}"}], "]"}], "]"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pergra", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"intergra", "[", 
            RowBox[{"Log", "[", "tx", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"tx", ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"tbins", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"AccuracyGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"nn", "+", "1"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], "=", 
      RowBox[{"ListLogLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"tmeans", ",", 
           FractionBox["pergra", "tsizes"]}], "}"}], "]"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Green", ",", 
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", "15"}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time, M\>\"", ",", "\"\<Periodogram I(T)\>\""}], 
          "}"}]}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5485960291688566`*^9, 3.5485960793437266`*^9}, {
  3.5485961723110437`*^9, 3.548596172431051*^9}, {3.548596217990657*^9, 
  3.548596419205166*^9}, {3.5485964747953453`*^9, 3.548596666441307*^9}, {
  3.548596789027318*^9, 3.548596791313449*^9}, {3.54859689729051*^9, 
  3.5485968982145634`*^9}, {3.5485970754817023`*^9, 3.5485970810720224`*^9}, {
  3.548601094181363*^9, 3.548601141526071*^9}, {3.548601228014018*^9, 
  3.5486012455100183`*^9}, {3.5486015052638755`*^9, 3.548601513522348*^9}, {
  3.5486021619624367`*^9, 3.548602208246084*^9}, {3.548603191013295*^9, 
  3.548603202408947*^9}, {3.548603360132968*^9, 3.5486034378874154`*^9}, {
  3.5486037657511683`*^9, 3.5486037953368607`*^9}}],

Cell[BoxData[{
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"PSDflux", "[", "k", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDLP", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDEVPA", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"PSDCP", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5486022164095507`*^9, 3.5486022274141808`*^9}, {
  3.548603444138773*^9, 3.54860345773155*^9}, {3.54860351210266*^9, 
  3.5486035139077635`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring umd\\\\GRMHD \
QPOs\\\\PSDflux.eps\>\"", ",", 
   RowBox[{"PSDflux", "[", "5", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.54860297377987*^9, 3.548603007281786*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"lmax", "=", 
      RowBox[{"Quotient", "[", 
       RowBox[{"l", ",", "2"}], "]"}]}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"coe", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "11"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474167180230875`*^9, 3.54741673800823*^9}, {
  3.547416781223702*^9, 3.547416852853799*^9}, {3.547416905638818*^9, 
  3.5474169120651855`*^9}, {3.5474169571027613`*^9, 3.547416982831233*^9}, {
  3.547417059758633*^9, 3.547417234333618*^9}, {3.5474172712067275`*^9, 
  3.5474174553252583`*^9}, {3.5474175026929674`*^9, 3.5474175687977486`*^9}, {
  3.547421295763919*^9, 3.5474212958269224`*^9}, {3.547459030057197*^9, 
  3.5474590305532255`*^9}, {3.5474755917321315`*^9, 3.547475591867139*^9}, {
  3.5474757112189655`*^9, 3.5474757423707476`*^9}, {3.5474758294187264`*^9, 
  3.5474758539871316`*^9}, {3.547476047433196*^9, 3.5474760476572084`*^9}, {
  3.547547396782836*^9, 3.547547418481077*^9}, {3.547547549029544*^9, 
  3.5475475490695467`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fr", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "[", 
  RowBox[{"[", "fr", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{
    SuperscriptBox["10", "7"], 
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "fr", ",", "12"}], "]"}], "]"}]}]}], ";", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5474244310872493`*^9, 3.5474244563596945`*^9}, {
   3.5474244888795547`*^9, 3.547424515096054*^9}, {3.5474245485119658`*^9, 
   3.547424574191434*^9}, {3.5475470934034843`*^9, 3.5475470957396173`*^9}, 
   3.547547753886261*^9}],

Cell[BoxData["3"], "Input",
 CellChangeTimes->{3.5475477574534655`*^9}],

Cell[BoxData["1"], "Input",
 CellChangeTimes->{3.5475476776399*^9}],

Cell[BoxData["2"], "Input",
 CellChangeTimes->{3.5475476712075324`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["spin 0.7", "Subsection",
 CellChangeTimes->{{3.5474159445628476`*^9, 3.5474159657700605`*^9}, 
   3.5474863364636946`*^9, {3.5474863695195856`*^9, 3.5474863697275977`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"sep", "=", "1"}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{"\"\<E:\\\\GRMHD\\\\new\\\\a07\\\\poliresa70th170fn\>\"", "<>", 
       RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", "8999", ",", "10299", ",", "1"}], "}"}]}], "]"}]}],
   ";"}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.5474863733468046`*^9, 3.5474864179293547`*^9}, {3.5474932232552876`*^9, 
   3.5474932234943013`*^9}, {3.5475000002959123`*^9, 3.547500001070956*^9}, {
   3.547520021450057*^9, 3.5475200218740807`*^9}, {3.547520053809908*^9, 
   3.547520054144927*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "imp", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"type", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fr", "=", "1"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"1", " ", "-", " ", 
     RowBox[{"43", "GHz"}]}], ",", " ", 
    RowBox[{"11", " ", "-", " ", 
     RowBox[{"5000", "GHz"}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", 
                 RowBox[{"(*", "type", "*)"}], "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
  3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
  3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}}],

Cell[BoxData[
 RowBox[{"gr", "[", "5", "]"}]], "Input",
 CellChangeTimes->{{3.547416569789609*^9, 3.5474166804939404`*^9}, {
  3.5474168902769394`*^9, 3.547416890323942*^9}, {3.5474169886675673`*^9, 
  3.5474169887555723`*^9}, {3.5474170559474154`*^9, 3.5474170562994356`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"lmax", "=", 
      RowBox[{"Min", "[", 
       RowBox[{
        RowBox[{"Quotient", "[", 
         RowBox[{"l", ",", "3"}], "]"}], ",", 
        FractionBox["500", "sep"]}], "]"}]}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"sep", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "11"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474167180230875`*^9, 3.54741673800823*^9}, {
  3.547416781223702*^9, 3.547416852853799*^9}, {3.547416905638818*^9, 
  3.5474169120651855`*^9}, {3.5474169571027613`*^9, 3.547416982831233*^9}, {
  3.547417059758633*^9, 3.547417234333618*^9}, {3.5474172712067275`*^9, 
  3.5474174553252583`*^9}, {3.5474175026929674`*^9, 3.5474175687977486`*^9}, {
  3.547421295763919*^9, 3.5474212958269224`*^9}, {3.547459030057197*^9, 
  3.5474590305532255`*^9}, {3.5474755917321315`*^9, 3.547475591867139*^9}, {
  3.5474757112189655`*^9, 3.5474757423707476`*^9}, {3.5474758294187264`*^9, 
  3.5474758539871316`*^9}, {3.547476047433196*^9, 3.5474760476572084`*^9}, {
  3.54748641191201*^9, 3.547486429551019*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["spin 0.9", "Subsection",
 CellChangeTimes->{{3.5475963278545437`*^9, 3.5475963293586297`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=."}], ";", 
  RowBox[{"Dynamic", "[", "fnum", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "1"}], ";", 
  RowBox[{"imp", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{"\"\<E:\\\\GRMHD\\\\new\\\\a0\\\\poliresa90th170fn\>\"", "<>", 
       RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", 
       RowBox[{"(*", 
        RowBox[{"18500", ",", "19980", ",", "20"}], "*)"}], "4000", ",", 
       "5500", ",", "coe"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "imp", "]"}]}], "Input",
 CellChangeTimes->{{3.547415974163541*^9, 3.5474160447305765`*^9}, 
   3.547416311304824*^9, {3.547416351137102*^9, 3.5474163514491205`*^9}, {
   3.5474181494119577`*^9, 3.5474181549082723`*^9}, {3.5474209507851872`*^9, 
   3.5474209510001993`*^9}, {3.547426382506864*^9, 3.5474263828338823`*^9}, {
   3.547457876164198*^9, 3.547457876779233*^9}, {3.547458998564396*^9, 
   3.5474590116041417`*^9}, {3.54746840756122*^9, 3.5474684230891085`*^9}, {
   3.5474755496627254`*^9, 3.5474755510708055`*^9}, {3.54747579136555*^9, 
   3.5474757925326166`*^9}, {3.54747589120426*^9, 3.5474758956285133`*^9}, {
   3.547475944332299*^9, 3.547475948139517*^9}, {3.5474759922360387`*^9, 
   3.547475992308043*^9}, {3.547476063155095*^9, 3.5474760658192472`*^9}, {
   3.547547109338395*^9, 3.5475471235942106`*^9}, {3.5475471798504286`*^9, 
   3.5475471821945624`*^9}, {3.5475473037775164`*^9, 3.547547304417553*^9}, {
   3.547547361649827*^9, 3.5475473649610157`*^9}, {3.547547409839583*^9, 
   3.547547414520851*^9}, {3.547547509656292*^9, 3.5475475097682986`*^9}, {
   3.5475475909999447`*^9, 3.547547622054721*^9}, {3.5475477272227364`*^9, 
   3.5475477319660077`*^9}, {3.5475477813188305`*^9, 3.547547785014042*^9}, {
   3.547596333751881*^9, 3.5475963337918835`*^9}, {3.5475964273112326`*^9, 
   3.5475964432791457`*^9}, {3.547596526278893*^9, 3.5475965437748938`*^9}, {
   3.5476058699013176`*^9, 3.5476058711413884`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nums", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"freqs", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "2"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"type", "=", "3"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"3", " ", "-", " ", "flux"}], ",", " ", 
    RowBox[{"4", " ", "-", " ", 
     RowBox[{"LP", " ", "fraction"}]}], ",", " ", 
    RowBox[{"5", " ", "-", " ", 
     RowBox[{"EVPA", " ", "angle"}]}], ",", " ", 
    RowBox[{"6", " ", "-", " ", 
     RowBox[{"CP", " ", "fraction"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fr", "=", "1"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"1", " ", "-", " ", 
     RowBox[{"43", "GHz"}]}], ",", " ", 
    RowBox[{"11", " ", "-", " ", 
     RowBox[{"5000", "GHz"}]}]}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gr", "[", "fr", "]"}], "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", 
                 RowBox[{"(*", "type", "*)"}], "3"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"nums", ",", 
              RowBox[{"imp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], "}"}], 
            "]"}], ",", 
           RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", 
     RowBox[{"Length", "[", "freqs", "]"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474160560712256`*^9, 3.5474160597944384`*^9}, {
  3.547416115729638*^9, 3.547416299306138*^9}, {3.5474163753614883`*^9, 
  3.54741656701845*^9}, {3.5474590559906807`*^9, 3.547459056558713*^9}, {
  3.5475965411857457`*^9, 3.5475965416567726`*^9}}],

Cell[BoxData[
 RowBox[{"gr", "[", "5", "]"}]], "Input",
 CellChangeTimes->{{3.547416569789609*^9, 3.5474166804939404`*^9}, {
  3.5474168902769394`*^9, 3.547416890323942*^9}, {3.5474169886675673`*^9, 
  3.5474169887555723`*^9}, {3.5474170559474154`*^9, 3.5474170562994356`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"lmax", "=", 
      RowBox[{"Quotient", "[", 
       RowBox[{"l", ",", "2"}], "]"}]}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"coe", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"lmax", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Flux at f=\>\"", ",", 
      RowBox[{"freqs", "[", 
       RowBox[{"[", "fr", "]"}], "]"}], ",", "\"\<GHz \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<LP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<EVPA angle \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "5"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<CP fraction \>\"", ",", 
      RowBox[{
       RowBox[{"data", "=", 
        RowBox[{"imp", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "fr", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{"GraphicsRow", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"nums", ",", "data"}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"sffun", "[", "data", "]"}], "]"}]}], "}"}], "]"}]}]}], 
     "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"fr", ",", "11"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5474167180230875`*^9, 3.54741673800823*^9}, {
  3.547416781223702*^9, 3.547416852853799*^9}, {3.547416905638818*^9, 
  3.5474169120651855`*^9}, {3.5474169571027613`*^9, 3.547416982831233*^9}, {
  3.547417059758633*^9, 3.547417234333618*^9}, {3.5474172712067275`*^9, 
  3.5474174553252583`*^9}, {3.5474175026929674`*^9, 3.5474175687977486`*^9}, {
  3.547421295763919*^9, 3.5474212958269224`*^9}, {3.547459030057197*^9, 
  3.5474590305532255`*^9}, {3.5474755917321315`*^9, 3.547475591867139*^9}, {
  3.5474757112189655`*^9, 3.5474757423707476`*^9}, {3.5474758294187264`*^9, 
  3.5474758539871316`*^9}, {3.547476047433196*^9, 3.5474760476572084`*^9}, {
  3.547547396782836*^9, 3.547547418481077*^9}, {3.547547549029544*^9, 
  3.5475475490695467`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Old", "Section",
 CellChangeTimes->{{3.547415850699479*^9, 3.5474158509864955`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", " ", "=", " ", 
   RowBox[{"NotebookDirectory", "[", "]"}]}], ";", 
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.01", ",", "\"\<axx\>\""}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.1", ",", "\"\<a0\>\"", ",", "125"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.5", ",", "\"\<a05\>\"", ",", "132"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.7", ",", "\"\<a07\>\"", ",", "135"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.9", ",", "\"\<a09\>\"", ",", "137"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.98", ",", "\"\<a098\>\"", ",", "138"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", 
    RowBox[{"a_", ",", "fnum_"}], "]"}], " ", ":=", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"p", "=", 
      RowBox[{
       RowBox[{"Position", "[", 
        RowBox[{"sptab", ",", "a"}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"namefile", " ", "=", " ", 
      RowBox[{"dir", " ", "<>", 
       RowBox[{"sptab", "[", 
        RowBox[{"[", 
         RowBox[{"p", ",", "2"}], "]"}], "]"}], "<>", 
       "\"\<\\\\fieldlines\\\\fieldline\>\"", " ", "<>", " ", 
       RowBox[{"StringJoin", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", "#", "]"}], " ", "&"}], " ", "/@", " ", 
         RowBox[{"PadLeft", "[", 
          RowBox[{
           RowBox[{"IntegerDigits", "[", "fnum", "]"}], ",", " ", "4"}], 
          "]"}]}], "]"}], " ", "<>", " ", "\"\<.bin\>\""}]}], ";", "\n", 
     "   ", 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "256", "*", "64", "*", "32", "*", "4"}]}], ";", "\n",
      "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\n", "   ", 
     RowBox[{"res2m", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"llist", " ", "=", " ", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"BinaryReadList", "[", 
                RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                 RowBox[{"11", "*", "32", "*", "64", "*", "256"}]}], "]"}], 
               ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], ",", " ", 
           "64"}], "]"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], "}"}]}], 
       "]"}]}], ";", "\n", "   ", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"read22", "[", 
     RowBox[{"g_", ",", "fnum_"}], "]"}], ":=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"namefile", " ", "=", " ", 
       RowBox[{
       "\"\<E:\\\\GRMHD\\\\a0500\\\\x64gam\>\"", "<>", "g", "<>", 
        "\"\<\\\\fieldline\>\"", "<>", " ", 
        RowBox[{"StringJoin", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ToString", "[", "#", "]"}], " ", "&"}], " ", "/@", " ", 
          RowBox[{"PadLeft", "[", 
           RowBox[{
            RowBox[{"IntegerDigits", "[", "fnum", "]"}], ",", " ", "4"}], 
           "]"}]}], "]"}], " ", "<>", " ", "\"\<.bin\>\""}]}], ";", "\n", 
      "   ", 
      RowBox[{"siz", " ", "=", " ", 
       RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
      RowBox[{"xs", " ", "=", " ", 
       RowBox[{"11", "*", "256", "*", "64", "*", "64", "*", "4"}]}], ";", 
      "\n", "   ", 
      RowBox[{"fi11", " ", "=", " ", 
       RowBox[{"OpenRead", "[", 
        RowBox[{"namefile", ",", " ", 
         RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
      "\n", "   ", 
      RowBox[{"strrr", " ", "=", " ", 
       RowBox[{"StringJoin", "[", 
        RowBox[{"BinaryReadList", "[", 
         RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
          RowBox[{
           RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
           "xs"}]}], "]"}], "]"}]}], ";", "\n", "   ", 
      RowBox[{"res2m", " ", "=", " ", 
       RowBox[{"Transpose", "[", 
        RowBox[{
         RowBox[{"llist", " ", "=", " ", 
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"Partition", "[", 
               RowBox[{
                RowBox[{"BinaryReadList", "[", 
                 RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                  RowBox[{"11", "*", "64", "*", "64", "*", "256"}]}], "]"}], 
                ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], ",", " ", 
            "64"}], "]"}]}], ",", " ", 
         RowBox[{"{", 
          RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], "}"}]}],
         "]"}]}], ";", "\n", "   ", 
      RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"avg", "[", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"tot\[Phi]", "=", 
      FractionBox[
       RowBox[{"Total", "[", 
        RowBox[{"res2m", ",", 
         RowBox[{"{", "3", "}"}]}], "]"}], "32"]}], ";", 
     RowBox[{"tot\[Theta]", "=", 
      RowBox[{"Total", "[", 
       RowBox[{
        RowBox[{"tot\[Phi]", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", 
           RowBox[{"43", ";;", "44"}], ",", "All"}], "]"}], "]"}], ",", 
        RowBox[{"{", "2", "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"avgpolar", "[", "]"}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"tot\[Phi]", "=", 
       FractionBox[
        RowBox[{"Total", "[", 
         RowBox[{"res2m", ",", 
          RowBox[{"{", "3", "}"}]}], "]"}], "32"]}], ";", 
      RowBox[{"tot\[Theta]", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tot\[Phi]", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"1", ";;", "2"}], ",", "All"}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}]}], ")"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"totr", "=", 
    RowBox[{"Total", "[", 
     RowBox[{
      RowBox[{"tot\[Phi]", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{
          RowBox[{"sptab", "[", 
           RowBox[{"[", 
            RowBox[{"2", ",", "3"}], "]"}], "]"}], ";;", 
          RowBox[{
           RowBox[{"sptab", "[", 
            RowBox[{"[", 
             RowBox[{"2", ",", "3"}], "]"}], "]"}], "+", "10"}]}], ",", "All",
          ",", "All"}], "]"}], "]"}], ",", 
      RowBox[{"{", "1", "}"}]}], "]"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"rtab", "[", 
    RowBox[{"[", 
     RowBox[{"132", ";;", "142"}], "]"}], "]"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.48199863871*^9, 3.4819986488344*^9}, {
   3.4821459308244*^9, 3.4821459311208*^9}, {3.493987362196808*^9, 
   3.493987369450808*^9}, {3.493988095630808*^9, 3.493988190338408*^9}, {
   3.493988438456408*^9, 3.4939884828228083`*^9}, {3.493988857628408*^9, 
   3.4939888821360083`*^9}, {3.493991780335208*^9, 3.4939917805068083`*^9}, {
   3.493993868644808*^9, 3.4939939116852083`*^9}, {3.4939977460092077`*^9, 
   3.4939977574752083`*^9}, {3.4940016246840076`*^9, 3.494001679939208*^9}, {
   3.4940090408772078`*^9, 3.4940090510328083`*^9}, {3.494022681158408*^9, 
   3.494022727708808*^9}, {3.494022772886408*^9, 3.494022793556408*^9}, {
   3.494022941865608*^9, 3.494022946982408*^9}, {3.494030043328808*^9, 
   3.4940300620956078`*^9}, {3.49466948955793*^9, 3.49466949980713*^9}, 
   3.4961603744278*^9, {3.496161391657*^9, 3.4961613917974*^9}, {
   3.4961616749842*^9, 3.4961616767938004`*^9}, {3.4961617668526*^9, 
   3.4961617982086*^9}, {3.4961981307958*^9, 3.4961981324026003`*^9}, {
   3.4961986434898*^9, 3.4961986468126*^9}, {3.4962235051942*^9, 
   3.4962235078929996`*^9}}],

Cell[BoxData[{
 RowBox[{"Dynamic", "[", "n", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tab", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"read11", "[", 
        RowBox[{"0.9", ",", "n"}], "]"}], ";", 
       RowBox[{"avg", "[", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "6950", ",", "7950"}], "}"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", "9607", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.4819986591148*^9, 3.4819986725151997`*^9}, {
   3.4820051704768*^9, 3.482005170976*^9}, {3.493987410650408*^9, 
   3.4939874108376083`*^9}, {3.493988500528808*^9, 3.4939885014492083`*^9}, {
   3.493988833932008*^9, 3.493988850109208*^9}, {3.493988904927608*^9, 
   3.4939889330232077`*^9}, {3.4939891027824078`*^9, 3.493989112173608*^9}, {
   3.4939891813596077`*^9, 3.493989181890008*^9}, {3.493989211935608*^9, 
   3.493989211935608*^9}, {3.4939908469404078`*^9, 3.493990847798408*^9}, {
   3.493991648016008*^9, 3.493991670838808*^9}, {3.493991791660808*^9, 
   3.493991797978808*^9}, {3.493993935163208*^9, 3.4939939428228083`*^9}, {
   3.493994923688408*^9, 3.493994923735208*^9}, {3.493995733063208*^9, 
   3.4939957331412077`*^9}, {3.493996207786808*^9, 3.4939962083484077`*^9}, {
   3.493996239860408*^9, 3.4939962401412077`*^9}, {3.493997761780808*^9, 
   3.493997761968008*^9}, 3.4940017948488083`*^9, 3.4940042977128077`*^9, {
   3.4940063474436083`*^9, 3.4940063474748077`*^9}, {3.4961588695425997`*^9, 
   3.4961588696518*^9}, {3.4961604782146*^9, 3.496160478745*^9}, {
   3.4961623457686*^9, 3.4961623458466*^9}, {3.4961924727226*^9, 
   3.496192473097*^9}, 3.4961975776198*^9, {3.4962375488322673`*^9, 
   3.496237551109867*^9}}],

Cell[BoxData[{
 RowBox[{"Dynamic", "[", "n", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tab", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"read11", "[", 
        RowBox[{"0.9", ",", "n"}], "]"}], ";", 
       RowBox[{"avgpolar", "[", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "0000", ",", "9950", ",", "5"}], "}"}]}], "]"}]}], 
   ";"}], 
  RowBox[{"(*", "9607", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.494030077134008*^9, 3.494030080924808*^9}, {
   3.4940325144780083`*^9, 3.494032514758808*^9}, {3.4961588572654*^9, 
   3.4961588573122*^9}, {3.4961618184105997`*^9, 3.4961618192686*^9}, {
   3.4961624598514*^9, 3.4961624599294*^9}, {3.496163116549*^9, 
   3.4961631166426*^9}, {3.4961635512742*^9, 3.4961635521166*^9}, 
   3.4961981375038*^9, {3.496237554822667*^9, 3.496237561671067*^9}}],

Cell[BoxData[{
 RowBox[{"Dynamic", "[", "n", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tab", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"read22", "[", 
        RowBox[{"\"\<43\>\"", ",", "n"}], "]"}], ";", 
       RowBox[{"avg", "[", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "2999", ",", "9251"}], "}"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", "9607", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.494022996559208*^9, 3.494023018836008*^9}, {
  3.494023204897208*^9, 3.4940232058488083`*^9}}],

Cell[BoxData[{
 RowBox[{"Dynamic", "[", "n", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tab", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"read11", "[", 
        RowBox[{"0.01", ",", "n"}], "]"}], ";", 
       RowBox[{"avgpolar", "[", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "1505", ",", "2490"}], "}"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"thin", "-", 
    RowBox[{"disk", " ", "simulation"}]}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.49466959980313*^9, 3.49466964140833*^9}, {
  3.49466967823993*^9, 3.4946696907823305`*^9}, {3.49466972645953*^9, 
  3.49466975667673*^9}, {3.49467029150713*^9, 3.49467029195953*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", 
  RowBox[{"tot\[Phi]", "=", 
   FractionBox[
    RowBox[{"Total", "[", 
     RowBox[{"res2m", ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], "32"]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", 
  RowBox[{"Total", "[", 
   RowBox[{
    RowBox[{"tot\[Phi]", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", 
       RowBox[{"43", ";;", "53"}], ",", "All"}], "]"}], "]"}], ",", 
    RowBox[{"{", "2", "}"}]}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.4961609407702*^9, 3.4961610198934*^9}, {
  3.4961610685341997`*^9, 3.4961610807022*^9}}],

Cell[BoxData[
 RowBox[{"Dimensions", "[", "tab", "]"}]], "Input",
 CellChangeTimes->{{3.4961611682026*^9, 3.4961611736626*^9}}],

Cell[CellGroupData[{

Cell["Tests", "Subsection",
 CellChangeTimes->{{3.493996357032008*^9, 3.4939963582020082`*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "tab", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ";", 
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"GraphicsRow", ",", 
      RowBox[{"ImageSize", "\[Rule]", "1200"}]}], "]"}], ";"}], "*)"}], 
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"coe", "=", "1"}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"coe", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"l", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"\[Rho]f5", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"63", ";;", "73"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<\[Rho] at 5M\>\""}]}], "]"}], ",", 
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"\[Rho]f10", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"99", ";;", "109"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<\[Rho] at 10M\>\""}]}], "]"}], ",", 
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"\[Rho]f15", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"120", ";;", "130"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<\[Rho] at 15M\>\""}]}], "]"}], ",", 
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"\[Rho]f20", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"135", ";;", "145"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<\[Rho] at 20M\>\""}]}], "]"}]}], 
   "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"Bf5", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"63", ";;", "73"}], ",", 
            RowBox[{"-", "1"}]}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\) at 5M\>\""}]}], "]"}], 
    ",", 
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"Bf10", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"99", ";;", "109"}], ",", 
            RowBox[{"-", "1"}]}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\) at 10M\>\""}]}], "]"}], 
    ",", 
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"Bf15", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"120", ";;", "130"}], ",", 
            RowBox[{"-", "1"}]}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\) at 15M\>\""}]}], "]"}], 
    ",", 
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"Bf20", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"135", ";;", "145"}], ",", 
            RowBox[{"-", "1"}]}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\) at 20M\>\""}]}], "]"}]}], 
   "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "\[Rho]f5", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<SF[\[Rho]] at 5M\>\""}]}], "]"}], 
    ",", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "\[Rho]f10", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<SF[\[Rho]] at 10M\>\""}]}], "]"}], 
    ",", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "\[Rho]f15", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<SF[\[Rho]] at 15M\>\""}]}], "]"}], 
    ",", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "\[Rho]f20", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<SF[\[Rho]] at 20M\>\""}]}], 
     "]"}]}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "Bf5", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<SF[\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\)] at 5M\>\""}]}], "]"}],
     ",", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "Bf10", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<SF[\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\)] at 10M\>\""}]}], 
     "]"}], ",", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "Bf15", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<SF[\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\)] at 15M\>\""}]}], 
     "]"}], ",", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "Bf20", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<SF[\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\)] at 20M\>\""}]}], 
     "]"}]}], "}"}], "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQAWIQvfV+m6cjxyvHYy1rYkB0oLCipROQvnTqIphm09QJ
A9FT9Odkgugcp3ONINo4Z0ETiJ5wc+tiEH1jl8VSEO1UPveAM5BOeSx7AkTH
X3S8DOZPO3kPRP/jnfcCRHt0rgTTLsbMn0D0kvbWHyA65pUMgwuQXvH/hwCI
3s61TxREh6uGqoLpKd+yQPRr6SP5IFpv+Y1qF7B7MmpAdN86vxYQrRUo1AWi
rU6vmAQx5900EM2XFr/OFUiXnJkLpn+9nS6dxvPKkcstUw5E3/hwoQ1E7ztY
3QGid6t/vg6ijyisuQ2i86pnHOwG0qbH24+AaADiopCV
  "]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"n", "=", "70"}], ";", 
  RowBox[{"rtab", "[", 
   RowBox[{"[", "n", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"\[Rho]f5", "=", 
    RowBox[{"Total", "[", 
     RowBox[{
      RowBox[{"tab", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"1300", ";;", "1700"}], ",", 
         RowBox[{"n", ";;", 
          RowBox[{"n", "+", "5"}]}], ",", "1"}], "]"}], "]"}], ",", 
      RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
   RowBox[{"PlotLabel", "\[Rule]", "\"\<\[Rho] at 5M\>\""}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"ListLogLogPlot", "[", 
  RowBox[{
   RowBox[{"sffun", "[", "\[Rho]f5", "]"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotLabel", "\[Rule]", "\"\<SF[\[Rho]] at 5M\>\""}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.4962386446542673`*^9, 3.496238647228267*^9}, {
  3.4962386808930674`*^9, 3.496238782527067*^9}, {3.496238835769867*^9, 
  3.4962389463582673`*^9}, {3.4962391131066675`*^9, 3.4962391131222672`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"rho", ",", "u", ",", 
    RowBox[{"-", 
     RowBox[{"u", "^", "t"}]}], ",", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"T", "^", "r_t"}]}], "/", 
     RowBox[{"(", 
      RowBox[{"rho", " ", 
       RowBox[{"u", "^", "r"}]}], ")"}]}], ",", 
    RowBox[{"u", "^", "t"}], ",", 
    RowBox[{"v", "^", "r"}], ",", 
    RowBox[{"v", "^", "theta"}], ",", 
    RowBox[{"v", "^", "phi"}], ",", 
    RowBox[{"B", "^", "r"}], ",", 
    RowBox[{"B", "^", "theta"}], ",", 
    RowBox[{"B", "^", "phi"}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"ListPlot", ",", 
      RowBox[{"ImageSize", "\[Rule]", "350"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"tab", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "125", ",", "1"}], "]"}], "]"}], ",", 
       RowBox[{"PlotLabel", "\[Rule]", "\"\<\[Rho] at 15M\>\""}]}], "]"}], 
     ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"tab", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "125", ",", "2"}], "]"}], "]"}], ",", 
       RowBox[{"PlotLabel", "\[Rule]", "\"\<U at 15M\>\""}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"tab", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "125", ",", "2"}], "]"}], "]"}], 
        RowBox[{"tab", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "125", ",", "1"}], "]"}], "]"}]], ",", 
       RowBox[{"PlotLabel", "\[Rule]", "\"\<U/\[Rho] at 15M\>\""}]}], "]"}], 
     ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"tab", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "125", ",", "6"}], "]"}], "]"}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(v\), \(r\)]\) at 15M\>\""}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"tab", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "125", ",", "7"}], "]"}], "]"}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(v\), \(\[Theta]\)]\) at 15M\>\""}]}], 
      "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"tab", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "125", ",", "8"}], "]"}], "]"}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(v\), \(\[Phi]\)]\) at 15M\>\""}]}], "]"}],
      ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"tab", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "125", ",", "9"}], "]"}], "]"}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(B\), \(r\)]\) at 15M\>\""}]}], "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"tab", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "125", ",", "10"}], "]"}], "]"}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(B\), \(\[Theta]\)]\) at 15M\>\""}]}], 
      "]"}], ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"tab", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "125", ",", "11"}], "]"}], "]"}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(B\), \(\[Phi]\)]\) at 15M\>\""}]}], 
      "]"}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.4962240729094*^9, 3.4962241126113997`*^9}, {
  3.4962241634782*^9, 3.4962242171577997`*^9}, {3.4962244690666*^9, 
  3.4962246125554*^9}}],

Cell[BoxData[
 RowBox[{"ListDensityPlot", "[", 
  RowBox[{"Log", "[", 
   RowBox[{"tab", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"1", ";;", "1000"}], ",", 
      RowBox[{"1", ";;", "200"}], ",", "1"}], "]"}], "]"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.4962274901082673`*^9, 3.4962274903734674`*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.557713577301602*^9, 3.5577135773952026`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"ListDensityPlot", "[", 
    RowBox[{"Log", "[", 
     RowBox[{"tab", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"1", ";;", "50"}], ",", 
        RowBox[{"1", ";;", "200"}], ",", "1"}], "]"}], "]"}], "]"}], "]"}], 
   ",", 
   RowBox[{"ListDensityPlot", "[", 
    RowBox[{"Log", "[", 
     RowBox[{"tab", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"1", ";;", "50"}], ",", 
        RowBox[{"1", ";;", "200"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], "]"}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.4962270970174675`*^9, 3.496227107594267*^9}, {
  3.4962272478090672`*^9, 3.496227347305867*^9}, {3.4962274190190673`*^9, 
  3.496227424557067*^9}, {3.4962275251458673`*^9, 3.496227544755067*^9}, {
  3.496228222387867*^9, 3.496228227988267*^9}, {3.4962282648510675`*^9, 
  3.4962282763326674`*^9}}],

Cell[BoxData[
 RowBox[{"{", ",", "}"}]], "Input",
 CellChangeTimes->{{3.557713578768005*^9, 3.5577135796416063`*^9}}],

Cell[BoxData[
 RowBox[{"ListDensityPlot", "[", 
  RowBox[{"Log", "[", 
   RowBox[{"Abs", "[", 
    RowBox[{"tab", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"1", ";;", "400"}], ",", 
       RowBox[{"150", ";;", "256"}], ",", 
       RowBox[{"-", "1"}]}], "]"}], "]"}], "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.496227449657467*^9, 3.496227454181467*^9}, {
  3.496230237018667*^9, 3.496230248437867*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.557713580874008*^9, 3.5577135809208083`*^9}}],

Cell[BoxData[
 RowBox[{"ListLogLinearPlot", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"rtab", ",", 
      RowBox[{"Log", "[", 
       RowBox[{"tab", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "All", ",", "1"}], "]"}], "]"}], "]"}]}], "}"}], 
    "]"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.496227914116267*^9, 3.4962279831930676`*^9}, {
  3.4962291065334673`*^9, 3.496229169495067*^9}}],

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"ListPlot", "[", 
    RowBox[{"Log", "[", 
     RowBox[{"tab", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"Round", "[", "u", "]"}], ",", "All", ",", "1"}], "]"}], 
      "]"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "1", ",", "1000"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.496227671271067*^9, 3.496227811359067*^9}, {
  3.4962278469738674`*^9, 3.496227849126667*^9}}],

Cell[BoxData[
 RowBox[{"rtab", "[", 
  RowBox[{"[", "40", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.4962273995658674`*^9, 3.496227405197467*^9}, {
  3.496230571919467*^9, 3.4962305720286674`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"0.9", " ", "-", " ", "7"}], ";;", "8"}]], "Input",
 CellChangeTimes->{{3.4961991643894*^9, 3.4961991701458*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"0.9", " ", "-", " ", "3"}], ";;", "4"}]], "Input",
 CellChangeTimes->{{3.4961985951142*^9, 3.4961985981717997`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"0.9", " ", "-", " ", "43"}], ";;", "44"}]], "Input",
 CellChangeTimes->{{3.4961981228710003`*^9, 3.496198126849*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"0.98", " ", "-", " ", "43"}], ";;", "44"}]], "Input",
 CellChangeTimes->{{3.4961975634393997`*^9, 3.4961975693206*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"spin", " ", "0.98"}], " ", "-", " ", "polar"}]], "Input",
 CellChangeTimes->{{3.4961925075886*^9, 3.4961925086962*^9}, {
  3.4961925480394*^9, 3.4961925491938*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"thin", "  ", "with", "   ", 
   FractionBox["h", "r"]}], "=", 
  RowBox[{
   RowBox[{"0.05", " ", 
    RowBox[{"(", 
     RowBox[{"and", " ", "cooling"}], ")"}]}], " ", "-", " ", 
   "polar"}]}]], "Input",
 CellChangeTimes->{{3.49467080602633*^9, 3.49467080647873*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"thin", "  ", "with", "   ", 
   FractionBox["h", "r"]}], "=", 
  RowBox[{
   RowBox[{"0.05", " ", 
    RowBox[{"(", 
     RowBox[{"and", " ", "cooling"}], ")"}]}], " ", "-", " ", 
   RowBox[{"one", " ", "scale", " ", "height"}]}]}]], "Input",
 CellChangeTimes->{{3.49467025458193*^9, 3.4946702679043303`*^9}, {
  3.49467030890113*^9, 3.49467031771513*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"spin", " ", "0.5"}], " ", "-", " ", "polar"}]], "Input",
 CellChangeTimes->{{3.494034462574808*^9, 3.494034467847608*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"spin", " ", "0.9"}], " ", "-", " ", "polar"}]], "Input",
 CellChangeTimes->{{3.494034416133608*^9, 3.494034422763608*^9}}],

Cell[BoxData[
 RowBox[{"spin", " ", "0.9"}]], "Input",
 CellChangeTimes->{{3.494032505944808*^9, 3.4940325072084084`*^9}}],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"spin", " ", "0.5"}], ";", " ", 
   RowBox[{"\[Gamma]", "=", 
    RowBox[{"4", "/", "3"}]}], ";", " ", 
   RowBox[{"2", "\[Pi]", " ", "simulation"}]}]}]], "Input",
 CellChangeTimes->{{3.4940299264380083`*^9, 3.4940299435668077`*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "tab", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListLogLogPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ";", 
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListPlot", ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ";", 
  RowBox[{"SetOptions", "[", 
   RowBox[{"GraphicsRow", ",", 
    RowBox[{"ImageSize", "\[Rule]", "1200"}]}], "]"}], ";", 
  RowBox[{
   RowBox[{"sffun", "[", "func_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"xf", "=", "func"}], ";", 
     RowBox[{"l", "=", 
      RowBox[{"Length", "[", "xf", "]"}]}], ";", 
     RowBox[{"coe", "=", "1"}], ";", 
     RowBox[{"sf", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"coe", " ", "n"}], ",", 
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], 
             "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", 
               RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
           RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", 
          RowBox[{"l", "-", "1"}]}], "}"}]}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"\[Rho]f5", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"63", ";;", "64"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<\[Rho] at 5M\>\""}]}], "]"}], ",", 
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"\[Rho]f10", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"99", ";;", "100"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<\[Rho] at 10M\>\""}]}], "]"}], ",", 
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"\[Rho]f15", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"120", ";;", "121"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<\[Rho] at 15M\>\""}]}], "]"}], ",", 
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"\[Rho]f20", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"135", ";;", "136"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<\[Rho] at 20M\>\""}]}], "]"}]}], 
   "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"Bf5", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"63", ";;", "64"}], ",", 
            RowBox[{"-", "1"}]}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\) at 5M\>\""}]}], "]"}], 
    ",", 
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"Bf10", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"99", ";;", "100"}], ",", 
            RowBox[{"-", "1"}]}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\) at 10M\>\""}]}], "]"}], 
    ",", 
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"Bf15", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"120", ";;", "130"}], ",", 
            RowBox[{"-", "1"}]}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\) at 15M\>\""}]}], "]"}], 
    ",", 
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"Bf20", "=", 
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"tab", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"135", ";;", "136"}], ",", 
            RowBox[{"-", "1"}]}], "]"}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\) at 20M\>\""}]}], "]"}]}], 
   "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "\[Rho]f5", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<SF[\[Rho]] at 5M\>\""}]}], "]"}], 
    ",", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "\[Rho]f10", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<SF[\[Rho]] at 10M\>\""}]}], "]"}], 
    ",", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "\[Rho]f15", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<SF[\[Rho]] at 15M\>\""}]}], "]"}], 
    ",", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "\[Rho]f20", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<SF[\[Rho]] at 20M\>\""}]}], 
     "]"}]}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "Bf5", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<SF[\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\)] at 5M\>\""}]}], "]"}],
     ",", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "Bf10", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<SF[\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\)] at 10M\>\""}]}], 
     "]"}], ",", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "Bf15", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<SF[\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\)] at 15M\>\""}]}], 
     "]"}], ",", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{
      RowBox[{"sffun", "[", "Bf20", "]"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<SF[\!\(\*SubscriptBox[\(B\), \(\[Phi]\)]\)] at 20M\>\""}]}], 
     "]"}]}], "}"}], "]"}]}], "Input",
 CellChangeTimes->{{3.493988940214808*^9, 3.4939890933912077`*^9}, {
  3.493990857033608*^9, 3.4939908625560083`*^9}, {3.4939910893800077`*^9, 
  3.493991244880808*^9}, {3.493991438445608*^9, 3.493991445013208*^9}, {
  3.493991709682808*^9, 3.493991721772808*^9}, {3.493993988920808*^9, 
  3.4939940489340076`*^9}, {3.493994138056808*^9, 3.493994230299608*^9}, {
  3.493994308939208*^9, 3.493994309298008*^9}, {3.493994384100008*^9, 
  3.4939944361728077`*^9}, {3.4939944969036083`*^9, 3.493994631781208*^9}, {
  3.493994669938808*^9, 3.493994794660808*^9}, {3.493995351705608*^9, 
  3.493995390128408*^9}, {3.4939954867704077`*^9, 3.493995491263208*^9}, {
  3.493995554458808*^9, 3.4939956005724077`*^9}, {3.493995669274808*^9, 
  3.493995703438808*^9}, {3.493996361743208*^9, 3.493996391976008*^9}}],

Cell[BoxData["658"], "Input",
 CellChangeTimes->{{3.4939962030756083`*^9, 3.4939962035436077`*^9}}],

Cell[BoxData["358"], "Input",
 CellChangeTimes->{{3.493995729007208*^9, 3.4939957292880077`*^9}}],

Cell[CellGroupData[{

Cell[BoxData["158"], "Input",
 CellChangeTimes->{{3.493994920287608*^9, 3.4939949209116077`*^9}, 
   3.493995720130808*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[
      {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw91QlQ1HUcBfD1AAsRIwwJUZZDUDlsdZXAa0UQWQ4RFC+MFfKYkBAHMlRk
GYxMcvJgEpAUIUXQVcej1MTZ0iQ6yNFG0JkcVEIEr2HUcPDo+/T3YoZ589nH
251l//v7e6RkxC/prdFodskv8vXPwykaTeHwqNFzDOoByaJi3TD6DcnUl8m2
9FuSNvqG27OVB0mWPJl7jnaRNKXn7KTdJM3TTKtorUFjDrtmjKA9JQd7dr5L
e0vfc2VdR4Kyj2RwcMpJeoRk2vV+BfQoyej8ryJpf9mXHr9kTwdKHqg++ke8
8nuSve/pN9M6yT7D46LpMZLa3yrt6LGSewrjGmYp6+X5jcNSN9HjJP1nuMfS
4yVXL7ngRAdJvp3QeC1O+X3ZOxekV9HByL7WFXSI9Mk1vwfRE8RDH26woSdK
1q29eXCm8iRJ2zuNifRkyctJDTb0FLz/vLGnYpUNkpWnLmQqm+G0vJ2B7KdK
LqyaeT9G9XBn0dLDyppQyW5LfSZ7+P7TnPHsp0lmBde9iFY9/MDuyq/KmjDJ
Y2n6Mvaw78u9K9iHS5YfMoayh7uaRg5lP11yxPdRz6NUD4c9eHFDWRMhuS15
/S/s4VG9kg6znyH5d1FbMXs4/kzxavaRkq63vkhkD2/0P6Bjb5RMdSzrzx7O
qKtqM6oej4e5hZ9XNsN7Hlmr2eN9XPDN3coeXhBalMce/8cH5ZNXsoe3FF5c
zB6fU8+c4nj2cK1rz1T2+NwL+1l07F95xx4v9riOApIaXJQNcOP+oU78e7gp
+uRAZStc0uA4gHtc12tbWt/kHj7hrLPlHva6942Ge/hcjUt3pNrje2VydupU
NsC7n1muKpvh9kFf/qxshT2djYe5x/e6fe/GHdzDR/d3r+cejnjWZxn3YrO3
w/4E7uWcMZ92uBnGPZyfkDGBezhk1p0g7nEuxT9+puce52BwRqWOe9imPmY0
97B76xM/7uGq2k98uU+U7LCs8eYettn3jyf3r7ysjrbCfT475MX9XMm26brh
3MMXw/qO5B6+cvFyAPfw2eIBY7mfh9fv3s73Z4ADQ3JDuIdtXLdM4h5OuNE+
lfv5kg71TRHcwwMee8RyD5dklc7mHh6X357E/QLJIQdvLuUeXumeu4p7OKZX
rJl7WBO7fTP3CyULSp+Wcg//uCuimnu4q/vqMe7hEeX5P3GfJLm8y+Mv7mGL
27bb3MOD1z5/wT38XfZ8V17/iyTHFC4J4vUPH6wek8jrH/Zpm/gpr3/Ymp1V
xv0Hkneb/E5zD5uPBDRzD/sfsH3CPaxvTB/E8ycZf//xCb2yAa6d1/3/eQWX
lfjlKFvhu4nHS7k3SZ456/aDshaeeGv0dT4frF33uJc6b03wyfpmH57HcNew
/GjlCrhjTkGmshXue33u18ot8IfhzXU8vxdLln+0vk1ZC9t1HXJU9w8DbN+Z
G6psgl1zo1bzfgNnPXSwKFe83ie2Klvhs14xHup+1gK7pHWk8v6WIungu6NW
WQvbb+15pGyAv40YYlD3TxMcO/LIJmUzHOo38LJyBRxi2ddf3Z+t8KVlgaOU
W+AFf/4bzvt3qmRbTeAiZa3Y/M75gAxlA/pMbc0aZRN64+ez8pTN6Hdfq8lV
roCPO57O5uvDdmXty+MM/wGmChXP
        "]]},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesOrigin->{0, Automatic},
      PlotLabel->FormBox["\"\[Rho] at 10M\"", TraditionalForm],
      PlotRange->Automatic,
      PlotRangeClipping->True], {193.5, -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[
      {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw91QlQ1HUcBfC/GzamBKYhHpCrmXKEXIkKirtcihgiGGqsssjghaFtokAB
f5RxcEchaQQ1MS/CQPMcJ490JUttIp0kE/PAmYxCsJi8hhT7vvw9mWHefHj7
9sfuf48hc5ckZhg0Tdsqv8hnP39P0LS5aR7ek03qD5L2VbFudA/JhJ7XutG9
JePd9buxyq9K2lrKm+j+klPydtfTHpL1dRFf0EZJY1nPdfRQyUTDlSx6mOTH
w/Kn0sMlQzJc/GkvyfBcmwvtI/mj86X2ScpvSuYlZzbQI7EvPrmHDsD/s9Nz
LR0ombyzKpMOklzgmR5HB0sWmJf60m9JflTe0YseJenYeKJtonKIpO6e0kCP
ljwXu3ovPUbSOXtSKT1W0mOtYwkdKpk12JxIh0nGX3AZRY+TLC5p60+Px/P5
JLIrRjlcclej4TY9QdLJ6XIDbZIscR11VFmH9zuba9ibJdu6blayhz3yztjZ
R0jaomN09vCx8pk57CMlT1iLbOzhq9NWZbGPkgxYNm8xezgktzKTfbSkdXMV
rcMBC314ew15t/ua99gj633NS9njeZlUE7SMPezwC8tlj+tW0vefAvZwSMPV
YvZ4XTW+XMDHq8NjXDvK2ON9sKO49wb28MjA9k3s49AXDPmMPRww8KVq9lMk
44ov17GHtX19DrF/W9K90/8Yezin7oaDfbzkuNGWs+zh1es7n1/fqZK13QIb
2cN9rDOb2CdILq5ee13ZBLst7neLt4f1qlm/KTtgw7X1LdxPk2z5oKiVezh3
2tF27uHzFws6uIeNdYEPuE+UHBC08DH3sF9EpZN6Petw2fYSF2UHHDCn70C+
3pMkuz80jlA2wX/az/H9ocNWi2c097Dt6zNJ3E+XXO60IY17+P1NPlncwzEt
TTncw/en+hZx/45k+OOu1dzD2rymNdzDr/sW0g54y5563l5LlqyoOLiSezje
ciCfe/hCbfYK7uHae1effz7MwOPbdGc+9/DkO8dTuYebXrmZzD182n4+jvuZ
kstG+odzD8fdeurHPdyx4/gg7uG925N6cD9L8rVZ2fd4/eDaVL2Z1x8+lVb9
A6///31lPj9vtHclzcFbP+cetgz2+oR7OHZ3TCH3cI2pdBH3KZLXqzdP5x7u
trIwnHvYmvLdCO7h+R73Xbm3SPbM0B5Fqz28KHlfs7IOHzG4f6/sgPN/X39I
WZst6dY4fAv38Lzlrau4h21FBxdxDy8YMDqB+zmS/lfag7mHkxta+nEPVw6b
0Rml9nBY3xU3lLVUyWsT/6pXNsE5L7rtVtbhhNtjSrmHK5zN2dxb8fy98Y1F
2Qin2wdF8f7gRLdqH2Ur/Ojsut68f9jtYciDyGfeBvdKHP6rsgMe//iXU8rN
cFX9xV3KWprk2JP/2pWN8JPuhTZlE+z1k3eKshVu9U6NUtbh015dfjwfrhpo
7s/zYdfMKgPPh/23BLdFqPPnSh7emP6zshHuZck+qWyCcz4MrVG2wisu+Zcp
6/DGrz5drrwNLnUun63sgJ9mH4hUbobDblu8eX665NKgEa48Hz7yx+H7ZnU+
HJqy4LqyFa55oeFbZR3uzNC+VN4GT9yfV6HsgO1PDPK9/R/pggih
        "]]},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesOrigin->{0, Automatic},
      PlotLabel->FormBox["\"\[Rho] at 15M\"", TraditionalForm],
      PlotRange->Automatic,
      PlotRangeClipping->True], {580.5, -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[
      {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw90QtQVGUcBfCbY7bW+EJeKSiiCCKgAiq46a6K7AqK8hJQ5CU+JyWThlEI
tykUeyHhCylFS9xI1IkxLVI3A3PUnDRUjERI0Jx85CrRQ4f+p76zzDBnfnv2
3O/uvcOycuIW99A0bZf8I///+92gafUHLyTOMqoPJA9sMSXQOsneX+ni6f6S
0bmmONpZ0u6qc9hd8vPLTg57SCbcyXHYS3JNu5/jet6S+11GOc4bIfmTk9Vx
PyMlq6rLk2g/yUG1thTaX9JvSlwqHSB5Me2vNDpIslTrzKDHSm5vbsikx0mu
94l2OBgeUZFOh0heq2xyXD9U0vLY1XH+eMnNyYMd9z9BMnddyWx6ouSqrrAZ
dJik+cYoPR0u+WzfgjH0JMkhDxq8ab1kYaHOhX5J8shSv170ZMmV7aP/iFae
gufRqeugDZKNp45eoo3YZ3ucVLbAT6ueqWY/VbK9vaKMPZyeUZfPfhrut0dl
Fnv4VFW2mf103M/fyYHsYc+Pdg9gHyFpXbmwM0r1cJ/H65uUtRmSiw4urmMP
3+vM3MU+UjJ0yMtvsIc36q5lszdJBgR+amYPX1jVGsDeLNn53MUB7OHs2vqu
mapHupWfbVG2IM//ev00e+xqeh4+xB72L7aWs8fvvOJ8/C328CX/XqvZ4719
Y56Wxh7u61k6i/1sPI/AOj17uDw1bzT7GMnBR1092MOLzr/eh/0cySdtRd1m
1cMdDT52ZW2uZPE8nw5lI2yLyWri9+FbW7vOKdvgu5u/Pcl9rKT1WHMt93Br
fLiVe/jM0PoPuYd3JO4u5T5Ocv/7tzZwD7v4ningHu5/+8U13MO3Hzqv4D5e
8of4PZncw/mXk1K4h/c/1cdyD19/+tpM7hMkz7l3TeUeNtfYJnEPj497EMI9
bKo9Esh9ouTpwgg/7uF92t7h3MMubg+Hcg/XlBV5cj9Pcqy9wIN7uC29nrbA
9vmTh3APp7Ts8+I+SXJkQwvPM8Kr3znjyz3crU0P4P6/fnnUOO6TJTNdsyZw
Dzc/7Hb8frh7rbeBe/hBZOM07lMkgzdFRXIP25ML+XwtsPOgoFncw+5rDTHc
z5f8/vrGOdzDZ3230xZ4medAft8Gt46JieZ+gaT+E38T9/B7xT/zfVrg+hNH
9dzDw2POh3KfKplnzef7NMJfL7nrwz0cNM7O92WDG49HunC/UPKfJ8te4B52
rTZr3MOlf156ZFJ7eMmO0FvKWprkwM9euapshHe6+3ynbIEvR207wj18Iin4
Y+7T8TzD7pRwDxuW38znHr7vbl/CPXw42zaX+wzJUP3JcGUveOeVpd68Htw2
puN55QzYt3jwo0h1fbh33pvNypXw2g+c6pVtcEVIzxrlVvi3PPM2ZS1TclCJ
l0XZC15wNXeFshHut2FronIGbFinTeX5cIdlTgDPhxM6K914Pnxj95c9eD48
2lR2b4Y6P0vy3S/CmpS94Bu5haeUjXBWSPIB5Qw4Z3LdVmUL3O/V4PXKlXCq
U/4yZRu8sW1DrHIr/Mve9nCev0iyek/JMJ4PG6xv63g+3FJ09n6EOh/2vDm2
UdkCHworOaZcCU/cUlahbINzmn8siDD+Cxh5DMU=
        "]]},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesOrigin->{0, Automatic},
      PlotLabel->FormBox["\"\[Rho] at 20M\"", TraditionalForm],
      PlotRange->Automatic,
      PlotRangeClipping->True], {967.5, -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->{872., Automatic},
  PlotRangePadding->{6, 5}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.493988942835608*^9, {3.493988989042808*^9, 3.493989036404408*^9}, {
   3.493989076636808*^9, 3.493989093968408*^9}, 3.493989156774008*^9, 
   3.493990584501608*^9, 3.4939908639600077`*^9, {3.493991097757208*^9, 
   3.493991107164008*^9}, {3.493991158269608*^9, 3.4939912451616077`*^9}, 
   3.493991445356408*^9, 3.493991722381208*^9, 3.493992943658408*^9, 
   3.493994050275608*^9, {3.4939941696936083`*^9, 3.4939942183968077`*^9}, 
   3.493994387298008*^9, {3.493994493128408*^9, 3.493994501552408*^9}, 
   3.493994556542408*^9, 3.493994588553608*^9, {3.493994700499208*^9, 
   3.493994758468808*^9}, 3.493994795050808*^9, 3.493995720146408*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[
      {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw91AlMFGcYBuApqBwVqQgqiEq5QtEoVOXcwnCIouLBvRVwQVDObqqkQWTt
aBBErYWIhLYBlmArElCKEkqlgk1KtcFWoQHS4lFECcplF7Ao0X5fOy+bbDbP
vv873/wzmXk3QR2apCcIQjl9+ff/z7ivINxsbGgfaZX/EAXh07dNW2BDsmfT
rkvwO2QH38xy2Jw8rpw4DS8ln/2qVANbc57gcxC2IV9clZQK25IbFrkmwvbk
F2mbVLAj2U49HAM7kc/7fK6Encn/jFRFwKvJid/e3QmvISu+nrMFdiEXTlr4
w67k9uAwT/h9ckhA3Fp4HTmgfsABXk+eat66At5AHvQtWQq7kZMHh81gd/Lr
yqQFsAf5t/l7jWBP3l/eaz3Yi7wjoeTVsGxvcmao8wSs4Pktj0bhD8iHzhTP
2odspK0Yh33J3V21Olgkx54dnZItsasif5hG7keeHkmZQc7+6YalgPPzJz+/
UjNXtsTuPRlrgjyArK7VX4ycbTyiW4k8kI8/uec95OwFBvPWId9IDs3sVCBn
52YoNyMPIv84XRCFnJ3Y0pSMfBP5mO7aIeTs0svNJ5BvJv/RkX0OOfvAEb0K
5MFkq5u1VcjZVyeTYWELuT/lghY523qioQz5VvI3qfqwxJYMLlci30b+qMOu
Fvl/PtfzPfIQ8kxoaQdydpZh2APk28lPTeOeI2fneUW+NSrnO8jzmssWypbY
jkum7ZHvJE9oHitki+yOGHE31rM/OVCZI7uNbV6wsgL9XWTbK6duoM/2CtA9
Qp8dHbVj7pjcZ8e5pznIFkLJ++ap/GSL7O7AfqVsiT1gZvkx+uw845B89MP4
fty59iX67JjwwzXos/uOPm5Cn32nz+5n9MPJhS8X96LPHr3+5zD6bM1Mh964
3GcvOXDYRLYQwffD/5aFbJF9umeZtWyJ3ah0skGfHeIo2qIfSW7q7LJDn33l
yHf26LPTFRUO6LPr5xs6oh9FrjtYDYvssrxiJ/TZ94cvOaPPjlrctRr9aLJH
WN8a9NmW2b+sRZ89VLDfBX32eHGsK/pKvj7G6nXos+dOD65Hn/2r63I39Nn3
pf0e6H9I7m1P8EaffcIszgd99mcGQyL67OMVyX7o7yYX6Y35os9O7jad7bNN
qm95oc9eNdjrjn4M7+9i4wb02U89nWfPn/3i5Qq4jd0bpcJ6IZbclvEE+xPZ
0S6vsD+JbXPBWoE+26U/BOcrxImCtOj8XexPZB/1L8L+JLKw4vqMP/rsSZv0
jejvofXdufbB6JOFrP3l29HnvLU/LRx9zrsfLFeiryJfze+JlW3DLu/LTcDx
2O0Rxftkq9gpDr+n4vjsAM1TtWwtuzEoPhPz2LYGzlmyH7J1FprDmB9PznU3
12A+WaopOpWD+Zwb1ZlhvYrz+sLbOJ7E9haOY56W12f8nZOO+ZzPyUnHfh5y
HnA7NArzEyjX2lzYhvlkweBMB663yLmXRwXup4r91zJvPC8SO3sqEM+rlvsl
3p1WmM8OO2a1EPN5fc+9PCPM30seio/Rx3yy8OZZ0AzeR+y8N2Y62Sp2tVvd
M7yf2Nrqe4Oytez6fIMneN+xv1AHDYy1/gsqF8tC
        "]]},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesOrigin->{0, Automatic},
      PlotLabel->FormBox[
       "\"\\!\\(\\*SubscriptBox[\\(B\\), \\(\[Phi]\\)]\\) at 15M\"", 
        TraditionalForm],
      PlotRange->Automatic,
      PlotRangeClipping->True], {193.5, -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[
      {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF1A9Qz3ccx/FPbVxURxetiPI7J5SplRbi95Uf/WUV/ad+oouGX1JSi75s
zciuqXaudiZWsnDjbtVW0m8VhbXOLqrV3Yy7TUppsvzM/rzft8+ruXPu4fV5
fj7ul5qTaAhPMhdCfE6/+c//fj3VCnXNQMqF7kb5F4pQnaPtW2ALRQjD5hN9
8FTaK0IaRuFp5PLObZY90vbk1EN6Z9iR+mkGF0/YmZw9tG01rCGf046FwXPJ
4dcG4uF57OdpO+D55Clx5/bAC8kFsfP3w25k92HfA/Cb5KCKQhV2J4uAxsOw
B/nlk+b34bfISXcsx+1JrlW+GO+9yA/iNuXAS8jHLybvg73J28JSd8Nvk4Nt
Xm2FfcindCVR8FKytmtCELyMPHasdDm8nD7P4EejrrAv7f2n782EV5Aj9+SP
f/4ryZUZh1/i66Mlb/3ZtR9WyBN/XdstrSr89cz+sRX7Ktp9Lp6vxc7+ateE
89j96PyRxdtLsLND+kfysa8mn+kMzcXObs5r24tdR/c9tPPfgZ095HkuAfsa
Oh9bPzMSO/tERkwI9rV8/rcgP+zsqKJWH+z+dD7AtNMdO7s2fcYC7AHkup31
GuzsA1+OOGIP5P+/DdPfwM7W9kfYYA+i9/RnSy2xk9Wsw2UTsQfTXlw95zXs
ZNVc2JphDyF7HM8S2Nnup7zG93XkDO9Yc+xkcfnOftwn1tM+pf3e69jZRf/8
//475CvN6yywsz2jR2ERSg5PuQ0rZKFNM4yfZ9s0fQ8b2TWJRyejD6O+6+QS
a/TsVest8PmoZLFPk2+Hnp05yTQLfTidH/M2uaAni4M+/V7oycqnZu069Oyl
Q+VR6DfQ+fdcU3ahZ984u/tD9GTFNLvzDHr2/MTeBvQbyX85tfSgJ4vvCuye
o2dfeiGmyO8nI58f0sW74PsrgnZzTeBKaYVsbK903SCtkpXeqTVJ6Pl8R8fw
+M+HSDqfprX/CD27IzS5BD1ZedWWWYWerOY36OrRR9Fua3x6Gz271SqoDz3Z
+PDdwAH05PtiQfcY+mjaDbpvzH6SPVl9MvWohbTKzrkZbC1tJCunbvnaSIsY
cnFV+nT0bI/ExTPQk8WjQ01O6HnvHDbMQx9LXuF7ZRF6dqG22Qs9+8nKyOXo
yUJd+KeCPo72BNPNNejJasGzjiD07CaTayh6Pp+fbh2BfhNZ8yAmFj3ZmHLd
agt63me4zN6BnizqHA/uQb+Z7v8laW4WerLRsqA7Fz3vI98O5qEnC/9ZV4+h
j6fz15d1fYyebZWc+wl6srhVtLEYPfvSFn0J+gT69+WNtp1GT1aX1pysRE82
BuSMXEbP3tDocBW9nhz3e1abtDN7MMD2Lu4ji9Kvf7gvrSerPdbZA7if9+Cm
ZX9Il5GVwEEPs175Hu9HxtqspO/z/ZML0x2kxRa6L6xrkYu0M1n8nZbtLa2w
P+sN9pfW8/ny85oYaZX3qhc2O6XLeHfLuZqL99mRcSuK8D6fn7d5UgXeT6R9
b8+1arzPHnTS3cD7ZFHzuOUu3ue9LrXgId5nL6mOGsb77Ca/vSa8z+7YWGnW
J9/n+3SG7RbSYiu5ovuxtbQzWV3YGGcrrbBT3dwdpPXs6+UfzJJW2RdCNU7S
ZXzfwLPM2dJGdkl1iWNf47/azd5D
        "]]},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesOrigin->{0, Automatic},
      PlotLabel->FormBox[
       "\"\\!\\(\\*SubscriptBox[\\(B\\), \\(\[Phi]\\)]\\) at 15M\"", 
        TraditionalForm],
      PlotRange->Automatic,
      PlotRangeClipping->True], {580.5, -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[
      {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw91AlMk2cYB/BXY1LF6WpgswzU0hEGGzIRhlRRHxCVWVAoMqBQKRW0CkzF
qfMI+9QC6hwygUxrJPUAxIyAxzgGg8+JCHiAICw6z9ANhzhRTi+yh+x9ICHk
x//5v0+/Axz0G9TxYxljufg98vP/r56FDDQnd02rreG/ACZ0pna6kMejQ3b2
e5Gl6Oal1f5kG/TH6rWhZBkwpii+pifbY96S3pVMlqOH82r2khVo/+PJOWRH
7MvkvQVkJ8xLehZVkp3RykmTm8if4nxcik0H2RXzl2Mlg2Q3tLPLDqsr3LNw
vtI2eBrZHfPA7abPybMx9/RK9SV7YB4VMDWU7Il5hNOKOPIXmL8PVlvIXpgP
OHYbyXPQZX/uzyJ743zCnW4zWYmu2hlXRJ47cn1H7CvI89C/ZShryT543vRj
e26S56OFy61/kBcAg1ceTo/ICzG3VEZ0kgHz+/m6Z9wCWjiunv6Scl9gYk27
sZ9ytLB5/b5Byv1G5pWrhihHs/4Hi8lsEZ4/XC/QvDDioQ3zBij3x/mYf/f0
UT7iaaWBo/sXAzPfyqh4TjlafjZusJvyJXiehyjpohxttvKWjV7fUpyv0//T
QTlal+YYPno/AvD6xneW3aMc3dw7Tn2H8i8xb9nr1075iCPPJ7ZSvgyY9ORA
RzPl6Ex5S9Xo81ABe3Kh5cl1ytGzx07RXKM8EFiiV8OERsoDQUgeU2jTQHkQ
CIZCU2I95UHAsmOXPbtK+XJgfg7lN8jCcjBL7KqA5tkKvB4fyWd0noA2uF3a
RftYMO73M9rR5wN0dbnt7Rs0j86/XXaiiVtExx1pTL1F/RBg3ltOpNL9ALT/
ga8z2qiPdu0LKaD3UQwBwfq2E7tLfTUICU0PfqX7D2r8vI+Lux5SH/Obp0PW
0vMTMd+ou+s9+nxDge3TSlVPqR8KZrnvmU2j7wvm66xyjvZSH+3WEKcYfT9X
Amt6o3jxlvro3QO/9I2p4/2VINj6FCVJuEXMh91nJkziZmHASl9pXG24Ad2p
yjpnR320k4vexZH66N7hy++5Uf8rYA6Z1nuV1Ecrvu0pX0J9tLTgSUoY9dEf
bso1xFM/HNj38W8/2kp9dHdLXWs69dFBofdDTNQPh8yE16d9i6gfAcx4eH66
SP0IEE4J0vOt1I8A0TBjQ//f1Mf5PvvIsNfUj8S/B7tm6eSrvB8J0FH3k0LB
LWBu6T102otbjATZmnPtEhU30wBE2SZZVlFfA0GWiWWyZOprwLXKkL/eSH0N
sJTskooc6keBeN8lelE+9aMgwrc2c0op9aOA9fvNKbhCffTyPNeJbdSPBmHN
792pFupHA6trL0nvoz66fnP0i3H1vI/2V/1o/QE304JcrXK75MgNWpA+1gTu
8+AWtMBkXXkmX+prQQhoX794BfVX4Xn3IhOjqY++/C69wEB9tGeHRPoN9dHK
rfpx31E/BsrjFZn5+6kfAyytY5t3NvVjQDzYeyM4l/oxIAz7VF8ooL4OIO/Y
TO8SbrkOmHv+dvdyOg89e/sZmcitQw+l7Ayvp/Oxb7Vkk80tbjPmPXNrN9+l
fWiDpjvHwv0I7ZhdWvSc9seC0Oi5o+0N7Y/Fff3nt0xo4Psxv3Mt7LCMW4d5
cMS2CmduIRZgaeZDo5LbjLn1DxvlKm4RnaGt3KblfhQLYtbFXYc3cjM9MOc3
NVlGbjn6UvWhg0dpP9pyynCmmPbrQTg79a+uOtqP3t3uYHpI+9HF6hmFr2g/
+uLEBR02jXw/nmeqHHo6i5utxv93pnT7IG45OnfoQNI6blgNAcY2SVgatw7z
n3dcCDrFLaDfBVovFLnN6D1JToX3uMXVIERd/eT6YGPNf2LeHoM=
        "]]},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesOrigin->{0, Automatic},
      PlotLabel->FormBox[
       "\"\\!\\(\\*SubscriptBox[\\(B\\), \\(\[Phi]\\)]\\) at 20M\"", 
        TraditionalForm],
      PlotRange->Automatic,
      PlotRangeClipping->True], {967.5, -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->{872., Automatic},
  PlotRangePadding->{6, 5}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.493988942835608*^9, {3.493988989042808*^9, 3.493989036404408*^9}, {
   3.493989076636808*^9, 3.493989093968408*^9}, 3.493989156774008*^9, 
   3.493990584501608*^9, 3.4939908639600077`*^9, {3.493991097757208*^9, 
   3.493991107164008*^9}, {3.493991158269608*^9, 3.4939912451616077`*^9}, 
   3.493991445356408*^9, 3.493991722381208*^9, 3.493992943658408*^9, 
   3.493994050275608*^9, {3.4939941696936083`*^9, 3.4939942183968077`*^9}, 
   3.493994387298008*^9, {3.493994493128408*^9, 3.493994501552408*^9}, 
   3.493994556542408*^9, 3.493994588553608*^9, {3.493994700499208*^9, 
   3.493994758468808*^9}, 3.493994795144408*^9, 3.493995720177608*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{}, {}, 
       {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwtVns4lVkXl9yO4xznfd9ztjhTZkS5xSdiUpxfiumClOQyKilfvmjcR1QT
1XxSUS5JupGQymnkIxwhUSSa6kua6WJCUcY9t1zmneeZP/azn/WsZ6+19l6/
32/tb3yDNvrJy8nJpbLr7z3IIiSnp0geJ7J9N9nGKcPR6uDtdpPZOP70enBt
qAoOXHxWQf6YjQi3TxXd9zjYcMLMSOFnBXBT98bGf1ZFnuwFefiVIkL7tUPv
c9WgvdppKbmmCNnGzbnTHB76lk5M25kogbvF44tgiIfogxN3A64poVX+3rWg
Bj7+mxRgvU9bGS4z6ivmnlSHcZGCkmWiMnZOZl4d1BEgqT1sn92oMooiRQ7F
kQIUSoNSTb5XQe9XTrXH7wtQX2cTGV6ugg5Xn/2UgEJ/0ZOpAyIOeJ0DHg83
URg3Tt6fF8iBTmBmps5pCuYJf46uqOZArNea7v+EQpNW/8dUgSok+a/LBzk0
Th2ZXfp2iyrM7OM9aQmN+WvTWryuqsIlNqiYhNDQnm5q/LZfFcptCQfdM2mc
a+GO5y7hwk3zUS3dRMPLKGl1814uDjm01u8fpRFQX1r5rIyL+n287CZtBk9K
nw+3jnHRYl9aY+bAYIRXFju5RA12sSsf1exmUDek7uoVooZKUf/mlAQG8l8b
TnCvq8GamV5WJmVw54F1r367GuZ5DqQ5NzO4uuJe3X1NHtbrVTwM6mHQwjvq
P+7MQ/O8reutOELwQhcve3aIB7ki8+ISXSGcbyTa+xXzkHWzIf+LrRCLbEw2
Vb3nwfS33E9iDyGoHiHpJ3xU312kYRcsxMpNk5aKDnzEHnu8MDVOiCsN2T9y
w/lYto/HMb8oRKDdqTv8LD6G5yQftvifECX9p0y1mvhIvbh4Q06DEBEyl+Xf
jvGRF3orIPaNEO5ei6WhOuqwW3jsYuWgEDfFN24/XacOp/C2+rVKIszIbZjx
CVfHRHO2FldThDX50mt659Wx08laNG4owvXlOv7699TxcZW9msZyEdSYmsjg
bnWk6YZ5hDiKMDRd7nlIWYAbiiUPTL1FcAk0bPysKcD0zoD30QEieGYUZImM
BejxT0gLihbByeF+XYeNAF9OxDd+HS9ClMGDcb/1AigPx91OOiPC8cV+r875
CJBzzC9NliMCL5D+dDREgCMd+fZnikT49GrhEdNDAuh2OqxdcFcE8Zz2rqRk
AeT4B3JDm0UIu75McuuyAINSQ0Hc7yJEGKSmJN8SwL5h8vn+LhFy56/9zaJG
AOEEh7vtswiLKP2BjCcCKEgiJGbyBEubZZn32wToNXDTHuITyLRSL5T1CXDV
wHLvJTHBNyt2xUdMC1BpfCXKUJ+goUV3+IsahQCtP7IOWRBI3Ie9ncUUDG/K
Ck+A4L2pjvkPBhR2VEdNLXIkmHt9ssXbisKjOY6PnNwJvJUvZ4jtKUS7vtJ7
sZ2A7qquub6RwurJUd3KAILlix3j+D4UjlhXPxsJJzBwni+030NBkm57L+YA
QVjhzXiXaApOByMvHv6ZYFXM3imzOArLhifa9RIIuLMLoj+mUKipkRgmpRL4
XciV35dJoVf7sWToHMGhDt+EjhsUDqyReDpmE/zfb4SjX0Yhe+hfO5OuEahm
j211qKMg3GywtbKQwOFO926wPD5tRTKqSgmeSpIVNF5TqD5/SvGnKgKfkC1f
HnZRqAqR1vXVEYwck2psGabw0jP8I+cRgcDYTNw8Q6HQ6vRvdU8IKr317s7j
0ki0Gcue+4Ig3D+vcj2h0RdnYct9RRDcMlSz/RsaUqV1SqfbCM5W5UW6GdO4
sa63QtZB0F4xFWNkRWOlsb1bTBfB2BXlnzpW0PCbfyWj/RNrr+tUiXVk7dre
sJe9BLvDx0pmudPYrDiVvG2AwGgu0dy1nUZbT4vdj0MExK1YVhhAo7zJ5qr4
M4FZuXjhuwg2/wcF4jBCWD2Iezt2kMavXguU+li7h/H0G4mnEWpZvFVnlODd
Ocslv6fQ4Oy6NPm3P8favD7vAo1t46nue1g7xa8/xTuPRsTmjdVFbPzvv6tS
nfiFhpz0qoJsmKDWpfpcTDkN1Qf76VC2HiW3WUX999j30O30f8zWa+aQUbaW
1T3S+Nb1Vh9B1pV60ckWGm9XdvkyfxIkFHGMKt/SMDk/8Gmkm8XXYXOv1i4a
vjvDlLzfE5z548SsNwNs/pPfH9jyjsDepmP/4wkatRJ93blvCI4n5OgVzGZ1
Lm2s85eXBNLv+jZGqjHIaW58vPg5we3gXE8TEQNxXqJn868Eri3xJ57OZXB5
Zkd1PNvfhqhVy3cuYKBR8kjsWE/+mW+sriaSP+VrCdYVDazdYMVAKpuRL2Dx
0p0WuqJAwsBeIVfFRcbiW1e5Y/Q7Bqu0rFumSwg+GAxGmbkwOJ5/07PpFoHn
tprVXh4MAhY0j96WEtiZ+KSG+jD4d0WgXD6L18JBrUvR/gz8MizMpLkEjSXF
+aHBDCoWqJe9u0xQFBw25LWXwQ+WVlGulwh863XKzWMYyDb/p5U5T9Cx28B6
Ko6Bz7NqdfOzBMb9idLbJxm4d0r4l9MIAjyUN+w4w0DTmpSuZ/l0Wm/KU+4S
AzWbD22uyQSRonNyJ3MZuCyXe37jFMGFmOfR6uwc0TRdJtlzkmB8e9hUbDGD
BwmWPW2JLN+5GhXvKxiYPVDxXcL6tx516LapZdDtnGO4nj0/ryysJK6Rre/1
JTUuG195nsKm2qcMqm1rzuaw+Zu3ewwMvWRwNNC7NCSd/PN/YO8/YFuffYHt
v++7duMuBgmp8teOXCHQjZyVYtnHQBsjgbYFBL17aj+bjzD46ifF+TyWz16D
v1vqTTHQ4yhWOrD8XfRBHKOqwM4xe4HxfLb/Gc6xE+2qQlQde7Ej6QPbf7lv
mwspIV6/6HS8M0ngYpqpEz5HiAbzrPxjQg3Y3XWdZ6QtxNKZiPQCEw1ERxl9
aNETIn3VG8nYGg1MjK28HGksxLbWLDtTPw3sOi0fzjMXQuumxefSgxrwVtGK
SV8qBN9F/05fugb+AtgS2/Y=
         "]]}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesOrigin->{0., 2.941036853084773},
      CoordinatesToolOptions:>{"DisplayFunction" -> ({
          Exp[
           Part[#, 1]], 
          Exp[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          Exp[
           Part[#, 1]], 
          Exp[
           Part[#, 2]]}& )},
      FrameTicks->{{{{2.302585092994046, 
           FormBox["10", TraditionalForm]}, {2.995732273553991, 
           FormBox["20", TraditionalForm]}, {3.912023005428146, 
           FormBox["50", TraditionalForm]}, {4.605170185988092, 
           FormBox["100", TraditionalForm]}, {5.298317366548036, 
           FormBox["200", TraditionalForm]}, {6.214608098422191, 
           FormBox["500", TraditionalForm]}, {6.907755278982137, 
           FormBox["1000", TraditionalForm]}, {7.600902459542082, 
           FormBox["2000", TraditionalForm]}, {8.517193191416238, 
           FormBox["5000", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}, {{2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {6.396929655216146, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {6.551080335043404, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {6.684611727667927, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {6.802394763324311, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {8.006367567650246, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {8.294049640102028, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}}, {{{0., 
           FormBox["1", TraditionalForm]}, {0.6931471805599453, 
           FormBox["2", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["5", TraditionalForm]}, {2.302585092994046, 
           FormBox["10", TraditionalForm]}, {2.995732273553991, 
           FormBox["20", TraditionalForm]}, {3.912023005428146, 
           FormBox["50", TraditionalForm]}, {4.605170185988092, 
           FormBox["100", TraditionalForm]}, {5.298317366548036, 
           FormBox["200", TraditionalForm]}, {6.214608098422191, 
           FormBox["500", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}, {{0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}}},
      GridLines->{None, None},
      Method->{},
      PlotLabel->FormBox["\"SF[\[Rho]] at 10M\"", TraditionalForm],
      PlotRange->{{0., 5.056245805348308}, {2.941036853084773, 
       5.899352031312459}},
      PlotRangeClipping->True,
      PlotRangePadding->{
        Scaled[0.02], 
        Scaled[0.02]},
      Ticks->{{{0., 
          FormBox["1", TraditionalForm]}, {0.6931471805599453, 
          FormBox["2", TraditionalForm]}, {1.6094379124341003`, 
          FormBox["5", TraditionalForm]}, {2.302585092994046, 
          FormBox["10", TraditionalForm]}, {2.995732273553991, 
          FormBox["20", TraditionalForm]}, {3.912023005428146, 
          FormBox["50", TraditionalForm]}, {4.605170185988092, 
          FormBox["100", TraditionalForm]}, {5.298317366548036, 
          FormBox["200", TraditionalForm]}, {6.214608098422191, 
          FormBox["500", TraditionalForm]}, {1.0986122886681098`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.3862943611198906`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.791759469228055, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.9459101490553132`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.0794415416798357`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.1972245773362196`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.4011973816621555`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.6888794541139363`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.0943445622221, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.248495242049359, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.382026634673881, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.499809670330265, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.703782474656201, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.991464547107982, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}}, {{2.302585092994046, 
          FormBox["10", TraditionalForm]}, {2.995732273553991, 
          FormBox["20", TraditionalForm]}, {3.912023005428146, 
          FormBox["50", TraditionalForm]}, {4.605170185988092, 
          FormBox["100", TraditionalForm]}, {5.298317366548036, 
          FormBox["200", TraditionalForm]}, {6.214608098422191, 
          FormBox["500", TraditionalForm]}, {6.907755278982137, 
          FormBox["1000", TraditionalForm]}, {7.600902459542082, 
          FormBox["2000", TraditionalForm]}, {8.517193191416238, 
          FormBox["5000", TraditionalForm]}, {3.4011973816621555`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.6888794541139363`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.0943445622221, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.248495242049359, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.382026634673881, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.499809670330265, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.703782474656201, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.991464547107982, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {6.396929655216146, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {6.551080335043404, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {6.684611727667927, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {6.802394763324311, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {8.006367567650246, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {8.294049640102028, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}}}], {193.5, -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{}, {}, 
       {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwlVnk41VkDtl/3/u51f8u91zYiLYgYTEJ0XyoZKYo+y9x8MmNq0rRYEpnC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         "]]}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesOrigin->{0., -0.6904233726190161},
      CoordinatesToolOptions:>{"DisplayFunction" -> ({
          Exp[
           Part[#, 1]], 
          Exp[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          Exp[
           Part[#, 1]], 
          Exp[
           Part[#, 2]]}& )},
      FrameTicks->{{{{0., 
           FormBox["1", TraditionalForm]}, {0.6931471805599453, 
           FormBox["2", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["5", TraditionalForm]}, {2.302585092994046, 
           FormBox["10", TraditionalForm]}, {2.995732273553991, 
           FormBox["20", TraditionalForm]}, {3.912023005428146, 
           FormBox["50", TraditionalForm]}, {4.605170185988092, 
           FormBox["100", TraditionalForm]}, {5.298317366548036, 
           FormBox["200", TraditionalForm]}, {6.214608098422191, 
           FormBox["500", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}, {{0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}}, {{{0., 
           FormBox["1", TraditionalForm]}, {0.6931471805599453, 
           FormBox["2", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["5", TraditionalForm]}, {2.302585092994046, 
           FormBox["10", TraditionalForm]}, {2.995732273553991, 
           FormBox["20", TraditionalForm]}, {3.912023005428146, 
           FormBox["50", TraditionalForm]}, {4.605170185988092, 
           FormBox["100", TraditionalForm]}, {5.298317366548036, 
           FormBox["200", TraditionalForm]}, {6.214608098422191, 
           FormBox["500", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}, {{0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}}},
      GridLines->{None, None},
      Method->{},
      PlotLabel->FormBox["\"SF[\[Rho]] at 15M\"", TraditionalForm],
      PlotRange->{{0., 5.056245805348308}, {-0.6904233726190161, 
       5.703849361421655}},
      PlotRangeClipping->True,
      PlotRangePadding->{
        Scaled[0.02], 
        Scaled[0.02]},
      Ticks->{{{0., 
          FormBox["1", TraditionalForm]}, {0.6931471805599453, 
          FormBox["2", TraditionalForm]}, {1.6094379124341003`, 
          FormBox["5", TraditionalForm]}, {2.302585092994046, 
          FormBox["10", TraditionalForm]}, {2.995732273553991, 
          FormBox["20", TraditionalForm]}, {3.912023005428146, 
          FormBox["50", TraditionalForm]}, {4.605170185988092, 
          FormBox["100", TraditionalForm]}, {5.298317366548036, 
          FormBox["200", TraditionalForm]}, {6.214608098422191, 
          FormBox["500", TraditionalForm]}, {1.0986122886681098`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.3862943611198906`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.791759469228055, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.9459101490553132`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.0794415416798357`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.1972245773362196`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.4011973816621555`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.6888794541139363`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.0943445622221, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.248495242049359, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.382026634673881, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.499809670330265, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.703782474656201, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.991464547107982, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}}, {{0., 
          FormBox["1", TraditionalForm]}, {0.6931471805599453, 
          FormBox["2", TraditionalForm]}, {1.6094379124341003`, 
          FormBox["5", TraditionalForm]}, {2.302585092994046, 
          FormBox["10", TraditionalForm]}, {2.995732273553991, 
          FormBox["20", TraditionalForm]}, {3.912023005428146, 
          FormBox["50", TraditionalForm]}, {4.605170185988092, 
          FormBox["100", TraditionalForm]}, {5.298317366548036, 
          FormBox["200", TraditionalForm]}, {6.214608098422191, 
          FormBox["500", TraditionalForm]}, {1.0986122886681098`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.3862943611198906`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.791759469228055, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.9459101490553132`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.0794415416798357`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.1972245773362196`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.4011973816621555`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.6888794541139363`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.0943445622221, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.248495242049359, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.382026634673881, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.499809670330265, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.703782474656201, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.991464547107982, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}}}], {580.5, -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{}, {}, 
       {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw1lgk01lkfx+0Pz+a/PM9joskgg2whJHqfL4WSCWEGabKkmmTIMrJUmGZk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         "]]}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesOrigin->{0., -4.096011438977543},
      CoordinatesToolOptions:>{"DisplayFunction" -> ({
          Exp[
           Part[#, 1]], 
          Exp[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          Exp[
           Part[#, 1]], 
          Exp[
           Part[#, 2]]}& )},
      FrameTicks->{{{{-4.605170185988091, 
           FormBox["0.01`", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["0.1`", TraditionalForm]}, {0, 
           FormBox["1", TraditionalForm]}, {2.302585092994046, 
           FormBox["10", TraditionalForm]}, {4.605170185988092, 
           FormBox["100", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-2.407945608651872, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-0.35667494393873245`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-0.10536051565782616`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}, {{-4.605170185988091, 
           FormBox["\"\"", TraditionalForm]}, {-2.3025850929940455`, 
           FormBox["\"\"", TraditionalForm]}, {0, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-2.8134107167600364`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-2.659260036932778, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-2.5257286443082556`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-2.407945608651872, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-1.203972804325936, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-0.916290731874155, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-0.5108256237659905, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-0.35667494393873245`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-0.2231435513142097, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-0.10536051565782616`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}}, {{{0., 
           FormBox["1", TraditionalForm]}, {0.6931471805599453, 
           FormBox["2", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["5", TraditionalForm]}, {2.302585092994046, 
           FormBox["10", TraditionalForm]}, {2.995732273553991, 
           FormBox["20", TraditionalForm]}, {3.912023005428146, 
           FormBox["50", TraditionalForm]}, {4.605170185988092, 
           FormBox["100", TraditionalForm]}, {5.298317366548036, 
           FormBox["200", TraditionalForm]}, {6.214608098422191, 
           FormBox["500", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}, {{0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}}},
      GridLines->{None, None},
      Method->{},
      PlotLabel->FormBox["\"SF[\[Rho]] at 20M\"", TraditionalForm],
      PlotRange->{{0., 5.056245805348308}, {-4.096011438977543, 
       5.506704079410549}},
      PlotRangeClipping->True,
      PlotRangePadding->{
        Scaled[0.02], 
        Scaled[0.02]},
      Ticks->{{{0., 
          FormBox["1", TraditionalForm]}, {0.6931471805599453, 
          FormBox["2", TraditionalForm]}, {1.6094379124341003`, 
          FormBox["5", TraditionalForm]}, {2.302585092994046, 
          FormBox["10", TraditionalForm]}, {2.995732273553991, 
          FormBox["20", TraditionalForm]}, {3.912023005428146, 
          FormBox["50", TraditionalForm]}, {4.605170185988092, 
          FormBox["100", TraditionalForm]}, {5.298317366548036, 
          FormBox["200", TraditionalForm]}, {6.214608098422191, 
          FormBox["500", TraditionalForm]}, {1.0986122886681098`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.3862943611198906`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.791759469228055, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.9459101490553132`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.0794415416798357`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.1972245773362196`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.4011973816621555`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.6888794541139363`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.0943445622221, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.248495242049359, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.382026634673881, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.499809670330265, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.703782474656201, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.991464547107982, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}}, {{-4.605170185988091, 
          FormBox["0.01`", TraditionalForm]}, {-2.3025850929940455`, 
          FormBox["0.1`", TraditionalForm]}, {0, 
          FormBox["1", TraditionalForm]}, {2.302585092994046, 
          FormBox["10", TraditionalForm]}, {4.605170185988092, 
          FormBox["100", TraditionalForm]}, {-3.912023005428146, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-3.506557897319982, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-3.2188758248682006`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-2.995732273553991, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-2.8134107167600364`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-2.659260036932778, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-2.5257286443082556`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-2.407945608651872, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-1.6094379124341003`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-1.203972804325936, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-0.916290731874155, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-0.6931471805599453, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-0.5108256237659905, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-0.35667494393873245`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-0.2231435513142097, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-0.10536051565782616`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {0.6931471805599453, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.0986122886681098`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.3862943611198906`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.6094379124341003`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.791759469228055, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.9459101490553132`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.0794415416798357`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.1972245773362196`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.995732273553991, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.4011973816621555`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.6888794541139363`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.912023005428146, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.0943445622221, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.248495242049359, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.382026634673881, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.499809670330265, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}}}], {967.5, -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->{872., Automatic},
  PlotRangePadding->{6, 5}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.493988942835608*^9, {3.493988989042808*^9, 3.493989036404408*^9}, {
   3.493989076636808*^9, 3.493989093968408*^9}, 3.493989156774008*^9, 
   3.493990584501608*^9, 3.4939908639600077`*^9, {3.493991097757208*^9, 
   3.493991107164008*^9}, {3.493991158269608*^9, 3.4939912451616077`*^9}, 
   3.493991445356408*^9, 3.493991722381208*^9, 3.493992943658408*^9, 
   3.493994050275608*^9, {3.4939941696936083`*^9, 3.4939942183968077`*^9}, 
   3.493994387298008*^9, {3.493994493128408*^9, 3.493994501552408*^9}, 
   3.493994556542408*^9, 3.493994588553608*^9, {3.493994700499208*^9, 
   3.493994758468808*^9}, 3.493994795409608*^9, 3.4939957202400084`*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{}, {}, 
       {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwtlnk01fkbx+2y3/v5fu+9XNmuhIgk62Q8jFCplBpLmiwZe8kytsbWzEgo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         "]]}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesOrigin->{0., -9.780382624350324},
      CoordinatesToolOptions:>{"DisplayFunction" -> ({
          Exp[
           Part[#, 1]], 
          Exp[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          Exp[
           Part[#, 1]], 
          Exp[
           Part[#, 2]]}& )},
      FrameTicks->{{{{-9.210340371976182, 
           FormBox[
            TemplateBox[{"1", 
              TemplateBox[{"10", 
                RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
               SuperscriptBox]}, "Row", 
             DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
             InterpretationFunction -> (RowBox[{"Row", "[", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
                "]"}]& )], TraditionalForm]}, {-8.517193191416238, 
           FormBox[
            TemplateBox[{"2", 
              TemplateBox[{"10", 
                RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
               SuperscriptBox]}, "Row", 
             DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
             InterpretationFunction -> (RowBox[{"Row", "[", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
                "]"}]& )], TraditionalForm]}, {-7.600902459542082, 
           FormBox[
            TemplateBox[{"5", 
              TemplateBox[{"10", 
                RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
               SuperscriptBox]}, "Row", 
             DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
             InterpretationFunction -> (RowBox[{"Row", "[", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
                "]"}]& )], TraditionalForm]}, {-6.907755278982137, 
           FormBox[
            TagBox[
             InterpretationBox["\"0.001\"", 0.001, AutoDelete -> True], 
             NumberForm[#, {
               DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
            TraditionalForm]}, {-6.214608098422191, 
           FormBox[
            TagBox[
             InterpretationBox["\"0.002\"", 0.002, AutoDelete -> True], 
             NumberForm[#, {
               DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
            TraditionalForm]}, {-5.298317366548036, 
           FormBox[
            TagBox[
             InterpretationBox["\"0.005\"", 0.005, AutoDelete -> True], 
             NumberForm[#, {
               DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
            TraditionalForm]}, {-4.605170185988092, 
           FormBox[
            TagBox[
             InterpretationBox["\"0.010\"", 0.01, AutoDelete -> True], 
             NumberForm[#, {
               DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
            TraditionalForm]}, {-3.912023005428146, 
           FormBox[
            TagBox[
             InterpretationBox["\"0.020\"", 0.02, AutoDelete -> True], 
             NumberForm[#, {
               DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
            TraditionalForm]}, {-2.995732273553991, 
           FormBox[
            TagBox[
             InterpretationBox["\"0.050\"", 0.05, AutoDelete -> True], 
             NumberForm[#, {
               DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
            TraditionalForm]}, {-7.957577403480815, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.418580902748128, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}, {{-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {-7.957577403480815, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.418580902748128, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-5.115995809754082, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-4.961845129926823, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-4.8283137373023015`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-4.710530701645918, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-3.506557897319982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-3.2188758248682006`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}}, {{{0., 
           FormBox["1", TraditionalForm]}, {0.6931471805599453, 
           FormBox["2", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["5", TraditionalForm]}, {2.302585092994046, 
           FormBox["10", TraditionalForm]}, {2.995732273553991, 
           FormBox["20", TraditionalForm]}, {3.912023005428146, 
           FormBox["50", TraditionalForm]}, {4.605170185988092, 
           FormBox["100", TraditionalForm]}, {5.298317366548036, 
           FormBox["200", TraditionalForm]}, {6.214608098422191, 
           FormBox["500", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}, {{0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}}},
      GridLines->{None, None},
      Method->{},
      PlotLabel->FormBox[
       "\"SF[\\!\\(\\*SubscriptBox[\\(B\\), \\(\[Phi]\\)]\\)] at 10M\"", 
        TraditionalForm],
      PlotRange->{{0., 
       5.056245805348308}, {-9.780382624350324, -4.51911080151711}},
      PlotRangeClipping->True,
      PlotRangePadding->{
        Scaled[0.02], 
        Scaled[0.02]},
      Ticks->{{{0., 
          FormBox["1", TraditionalForm]}, {0.6931471805599453, 
          FormBox["2", TraditionalForm]}, {1.6094379124341003`, 
          FormBox["5", TraditionalForm]}, {2.302585092994046, 
          FormBox["10", TraditionalForm]}, {2.995732273553991, 
          FormBox["20", TraditionalForm]}, {3.912023005428146, 
          FormBox["50", TraditionalForm]}, {4.605170185988092, 
          FormBox["100", TraditionalForm]}, {5.298317366548036, 
          FormBox["200", TraditionalForm]}, {6.214608098422191, 
          FormBox["500", TraditionalForm]}, {1.0986122886681098`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.3862943611198906`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.791759469228055, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.9459101490553132`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.0794415416798357`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.1972245773362196`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.4011973816621555`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.6888794541139363`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.0943445622221, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.248495242049359, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.382026634673881, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.499809670330265, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.703782474656201, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.991464547107982, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}}, {{-9.210340371976182, 
          FormBox[
           TemplateBox[{"1", 
             TemplateBox[{"10", 
               RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
              SuperscriptBox]}, "Row", 
            DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
            InterpretationFunction -> (RowBox[{"Row", "[", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
               "]"}]& )], TraditionalForm]}, {-8.517193191416238, 
          FormBox[
           TemplateBox[{"2", 
             TemplateBox[{"10", 
               RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
              SuperscriptBox]}, "Row", 
            DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
            InterpretationFunction -> (RowBox[{"Row", "[", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
               "]"}]& )], TraditionalForm]}, {-7.600902459542082, 
          FormBox[
           TemplateBox[{"5", 
             TemplateBox[{"10", 
               RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
              SuperscriptBox]}, "Row", 
            DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
            InterpretationFunction -> (RowBox[{"Row", "[", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
               "]"}]& )], TraditionalForm]}, {-6.907755278982137, 
          FormBox[
           TagBox[
            InterpretationBox["\"0.001\"", 0.001, AutoDelete -> True], 
            NumberForm[#, {
              DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
           TraditionalForm]}, {-6.214608098422191, 
          FormBox[
           TagBox[
            InterpretationBox["\"0.002\"", 0.002, AutoDelete -> True], 
            NumberForm[#, {
              DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
           TraditionalForm]}, {-5.298317366548036, 
          FormBox[
           TagBox[
            InterpretationBox["\"0.005\"", 0.005, AutoDelete -> True], 
            NumberForm[#, {
              DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
           TraditionalForm]}, {-4.605170185988092, 
          FormBox[
           TagBox[
            InterpretationBox["\"0.010\"", 0.01, AutoDelete -> True], 
            NumberForm[#, {
              DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
           TraditionalForm]}, {-3.912023005428146, 
          FormBox[
           TagBox[
            InterpretationBox["\"0.020\"", 0.02, AutoDelete -> True], 
            NumberForm[#, {
              DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
           TraditionalForm]}, {-2.995732273553991, 
          FormBox[
           TagBox[
            InterpretationBox["\"0.050\"", 0.05, AutoDelete -> True], 
            NumberForm[#, {
              DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
           TraditionalForm]}, {-7.957577403480815, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-7.418580902748128, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-7.264430222920869, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-7.1308988302963465`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-7.013115794639964, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-5.809142990314028, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-5.521460917862246, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-5.115995809754082, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-4.961845129926823, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-4.8283137373023015`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-4.710530701645918, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-3.506557897319982, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-3.2188758248682006`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}}}], {193.5, -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{}, {}, 
       {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwtVns41VkXRupw3M75/Q7O+Z2ba+QaJqRkSdSgIknh9KHxZYTcStEF00y6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         "]]}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesOrigin->{0., -10.404869541071317`},
      CoordinatesToolOptions:>{"DisplayFunction" -> ({
          Exp[
           Part[#, 1]], 
          Exp[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          Exp[
           Part[#, 1]], 
          Exp[
           Part[#, 2]]}& )},
      FrameTicks->{{{{-11.512925464970229`, 
           FormBox[
            TemplateBox[{"1", 
              TemplateBox[{"10", 
                RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> 
               SuperscriptBox]}, "Row", 
             DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
             InterpretationFunction -> (RowBox[{"Row", "[", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
                "]"}]& )], TraditionalForm]}, {-10.819778284410283`, 
           FormBox[
            TemplateBox[{"2", 
              TemplateBox[{"10", 
                RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> 
               SuperscriptBox]}, "Row", 
             DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
             InterpretationFunction -> (RowBox[{"Row", "[", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
                "]"}]& )], TraditionalForm]}, {-9.903487552536127, 
           FormBox[
            TemplateBox[{"5", 
              TemplateBox[{"10", 
                RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> 
               SuperscriptBox]}, "Row", 
             DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
             InterpretationFunction -> (RowBox[{"Row", "[", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
                "]"}]& )], TraditionalForm]}, {-9.210340371976182, 
           FormBox[
            TemplateBox[{"1", 
              TemplateBox[{"10", 
                RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
               SuperscriptBox]}, "Row", 
             DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
             InterpretationFunction -> (RowBox[{"Row", "[", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
                "]"}]& )], TraditionalForm]}, {-8.517193191416238, 
           FormBox[
            TemplateBox[{"2", 
              TemplateBox[{"10", 
                RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
               SuperscriptBox]}, "Row", 
             DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
             InterpretationFunction -> (RowBox[{"Row", "[", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
                "]"}]& )], TraditionalForm]}, {-7.600902459542082, 
           FormBox[
            TemplateBox[{"5", 
              TemplateBox[{"10", 
                RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
               SuperscriptBox]}, "Row", 
             DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
             InterpretationFunction -> (RowBox[{"Row", "[", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
                "]"}]& )], TraditionalForm]}, {-6.907755278982137, 
           FormBox[
            TagBox[
             InterpretationBox["\"0.001\"", 0.001, AutoDelete -> True], 
             NumberForm[#, {
               DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
            TraditionalForm]}, {-6.214608098422191, 
           FormBox[
            TagBox[
             InterpretationBox["\"0.002\"", 0.002, AutoDelete -> True], 
             NumberForm[#, {
               DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
            TraditionalForm]}, {-5.298317366548036, 
           FormBox[
            TagBox[
             InterpretationBox["\"0.005\"", 0.005, AutoDelete -> True], 
             NumberForm[#, {
               DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
            TraditionalForm]}, {-10.41431317630212, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.957577403480815, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.418580902748128, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}, {{-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm]}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {-10.41431317630212, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.957577403480815, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.418580902748128, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-5.809142990314028, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-5.521460917862246, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}}, {{{0., 
           FormBox["1", TraditionalForm]}, {0.6931471805599453, 
           FormBox["2", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["5", TraditionalForm]}, {2.302585092994046, 
           FormBox["10", TraditionalForm]}, {2.995732273553991, 
           FormBox["20", TraditionalForm]}, {3.912023005428146, 
           FormBox["50", TraditionalForm]}, {4.605170185988092, 
           FormBox["100", TraditionalForm]}, {5.298317366548036, 
           FormBox["200", TraditionalForm]}, {6.214608098422191, 
           FormBox["500", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}, {{0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}}},
      GridLines->{None, None},
      Method->{},
      PlotLabel->FormBox[
       "\"SF[\\!\\(\\*SubscriptBox[\\(B\\), \\(\[Phi]\\)]\\)] at 15M\"", 
        TraditionalForm],
      PlotRange->{{0., 
       5.056245805348308}, {-10.404869541071317`, -5.845590921182916}},
      PlotRangeClipping->True,
      PlotRangePadding->{
        Scaled[0.02], 
        Scaled[0.02]},
      Ticks->{{{0., 
          FormBox["1", TraditionalForm]}, {0.6931471805599453, 
          FormBox["2", TraditionalForm]}, {1.6094379124341003`, 
          FormBox["5", TraditionalForm]}, {2.302585092994046, 
          FormBox["10", TraditionalForm]}, {2.995732273553991, 
          FormBox["20", TraditionalForm]}, {3.912023005428146, 
          FormBox["50", TraditionalForm]}, {4.605170185988092, 
          FormBox["100", TraditionalForm]}, {5.298317366548036, 
          FormBox["200", TraditionalForm]}, {6.214608098422191, 
          FormBox["500", TraditionalForm]}, {1.0986122886681098`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.3862943611198906`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.791759469228055, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.9459101490553132`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.0794415416798357`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.1972245773362196`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.4011973816621555`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.6888794541139363`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.0943445622221, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.248495242049359, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.382026634673881, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.499809670330265, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.703782474656201, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.991464547107982, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}}, {{-11.512925464970229`, 
          FormBox[
           TemplateBox[{"1", 
             TemplateBox[{"10", 
               RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> 
              SuperscriptBox]}, "Row", 
            DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
            InterpretationFunction -> (RowBox[{"Row", "[", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
               "]"}]& )], TraditionalForm]}, {-10.819778284410283`, 
          FormBox[
           TemplateBox[{"2", 
             TemplateBox[{"10", 
               RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> 
              SuperscriptBox]}, "Row", 
            DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
            InterpretationFunction -> (RowBox[{"Row", "[", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
               "]"}]& )], TraditionalForm]}, {-9.903487552536127, 
          FormBox[
           TemplateBox[{"5", 
             TemplateBox[{"10", 
               RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> 
              SuperscriptBox]}, "Row", 
            DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
            InterpretationFunction -> (RowBox[{"Row", "[", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
               "]"}]& )], TraditionalForm]}, {-9.210340371976182, 
          FormBox[
           TemplateBox[{"1", 
             TemplateBox[{"10", 
               RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
              SuperscriptBox]}, "Row", 
            DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
            InterpretationFunction -> (RowBox[{"Row", "[", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
               "]"}]& )], TraditionalForm]}, {-8.517193191416238, 
          FormBox[
           TemplateBox[{"2", 
             TemplateBox[{"10", 
               RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
              SuperscriptBox]}, "Row", 
            DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
            InterpretationFunction -> (RowBox[{"Row", "[", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
               "]"}]& )], TraditionalForm]}, {-7.600902459542082, 
          FormBox[
           TemplateBox[{"5", 
             TemplateBox[{"10", 
               RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
              SuperscriptBox]}, "Row", 
            DisplayFunction -> (RowBox[{#, "\[Times]", #2}]& ), 
            InterpretationFunction -> (RowBox[{"Row", "[", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{#, ",", #2}], "}"}], ",", "\"\[Times]\""}], 
               "]"}]& )], TraditionalForm]}, {-6.907755278982137, 
          FormBox[
           TagBox[
            InterpretationBox["\"0.001\"", 0.001, AutoDelete -> True], 
            NumberForm[#, {
              DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
           TraditionalForm]}, {-6.214608098422191, 
          FormBox[
           TagBox[
            InterpretationBox["\"0.002\"", 0.002, AutoDelete -> True], 
            NumberForm[#, {
              DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
           TraditionalForm]}, {-5.298317366548036, 
          FormBox[
           TagBox[
            InterpretationBox["\"0.005\"", 0.005, AutoDelete -> True], 
            NumberForm[#, {
              DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
           TraditionalForm]}, {-10.41431317630212, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-10.126631103850338`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-9.721165995742174, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-9.567015315914915, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-9.433483923290392, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-9.315700887634009, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-7.957577403480815, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-7.418580902748128, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-7.264430222920869, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-7.1308988302963465`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-7.013115794639964, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-5.809142990314028, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-5.521460917862246, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}}}], {580.5, -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{}, {}, 
       {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw1Vgs0lVkbdo0ch/N9n8u53zgit5CI5FVRI4nKcDiKYmqhyOUXlVCTGlJR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         "]]}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesOrigin->{0., -15.487433026673934`},
      CoordinatesToolOptions:>{"DisplayFunction" -> ({
          Exp[
           Part[#, 1]], 
          Exp[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          Exp[
           Part[#, 1]], 
          Exp[
           Part[#, 2]]}& )},
      FrameTicks->{{{{-16.11809565095832, 
           FormBox[
            TemplateBox[{"10", 
              RowBox[{"-", "7"}]}, "Superscript", SyntaxForm -> 
             SuperscriptBox], TraditionalForm]}, {-13.815510557964274`, 
           FormBox[
            TemplateBox[{"10", 
              RowBox[{"-", "6"}]}, "Superscript", SyntaxForm -> 
             SuperscriptBox], TraditionalForm]}, {-11.512925464970229`, 
           FormBox[
            TemplateBox[{"10", 
              RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> 
             SuperscriptBox], TraditionalForm]}, {-9.210340371976182, 
           FormBox[
            TemplateBox[{"10", 
              RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
             SuperscriptBox], TraditionalForm]}, {-6.907755278982137, 
           FormBox["0.001`", TraditionalForm]}, {-15.424948470398375`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-15.01948336229021, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-14.73180128983843, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-14.508657738524219`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-14.326336181730264`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-14.172185501903007`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-14.038654109278484`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-13.9208710736221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}, {{-16.11809565095832, 
           FormBox["\"\"", TraditionalForm]}, {-13.815510557964274`, 
           FormBox["\"\"", TraditionalForm]}, {-11.512925464970229`, 
           FormBox["\"\"", TraditionalForm]}, {-9.210340371976182, 
           FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
           FormBox["\"\"", TraditionalForm]}, {-15.424948470398375`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-15.01948336229021, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-14.73180128983843, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-14.508657738524219`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-14.326336181730264`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-14.172185501903007`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-14.038654109278484`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-13.9208710736221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-13.122363377404328`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-12.716898269296165`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-12.429216196844383`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-12.206072645530174`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-12.02375108873622, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-11.86960040890896, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-11.736069016284437`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-11.618285980628055`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-10.819778284410283`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-10.414313176302118`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-10.126631103850338`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.903487552536127, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.721165995742174, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.567015315914915, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.433483923290392, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-9.315700887634009, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-8.517193191416238, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-8.111728083308073, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.824046010856292, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.600902459542082, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.418580902748127, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.264430222920869, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.1308988302963465`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {-7.013115794639964, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}}, {{{0., 
           FormBox["1", TraditionalForm]}, {0.6931471805599453, 
           FormBox["2", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["5", TraditionalForm]}, {2.302585092994046, 
           FormBox["10", TraditionalForm]}, {2.995732273553991, 
           FormBox["20", TraditionalForm]}, {3.912023005428146, 
           FormBox["50", TraditionalForm]}, {4.605170185988092, 
           FormBox["100", TraditionalForm]}, {5.298317366548036, 
           FormBox["200", TraditionalForm]}, {6.214608098422191, 
           FormBox["500", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}, {{0., 
           FormBox["\"\"", TraditionalForm]}, {0.6931471805599453, 
           FormBox["\"\"", TraditionalForm]}, {1.6094379124341003`, 
           FormBox["\"\"", TraditionalForm]}, {2.302585092994046, 
           FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
           FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
           FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
           FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
           FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
           FormBox["\"\"", TraditionalForm]}, {1.0986122886681098`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.3862943611198906`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.791759469228055, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {1.9459101490553132`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.0794415416798357`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {2.1972245773362196`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.4011973816621555`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {3.6888794541139363`, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.0943445622221, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.248495242049359, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.382026634673881, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {4.499809670330265, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.703782474656201, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}, {5.991464547107982, 
           FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
            Thickness[0.001]}}}}},
      GridLines->{None, None},
      Method->{},
      PlotLabel->FormBox[
       "\"SF[\\!\\(\\*SubscriptBox[\\(B\\), \\(\[Phi]\\)]\\)] at 20M\"", 
        TraditionalForm],
      PlotRange->{{0., 
       5.056245805348308}, {-15.487433026673934`, -5.854752906544622}},
      PlotRangeClipping->True,
      PlotRangePadding->{
        Scaled[0.02], 
        Scaled[0.02]},
      Ticks->{{{0., 
          FormBox["1", TraditionalForm]}, {0.6931471805599453, 
          FormBox["2", TraditionalForm]}, {1.6094379124341003`, 
          FormBox["5", TraditionalForm]}, {2.302585092994046, 
          FormBox["10", TraditionalForm]}, {2.995732273553991, 
          FormBox["20", TraditionalForm]}, {3.912023005428146, 
          FormBox["50", TraditionalForm]}, {4.605170185988092, 
          FormBox["100", TraditionalForm]}, {5.298317366548036, 
          FormBox["200", TraditionalForm]}, {6.214608098422191, 
          FormBox["500", TraditionalForm]}, {1.0986122886681098`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.3862943611198906`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.791759469228055, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {1.9459101490553132`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.0794415416798357`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {2.1972245773362196`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.4011973816621555`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {3.6888794541139363`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.0943445622221, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.248495242049359, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.382026634673881, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {4.499809670330265, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.703782474656201, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {5.991464547107982, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}}, {{-16.11809565095832, 
          FormBox[
           TemplateBox[{"10", 
             RowBox[{"-", "7"}]}, "Superscript", SyntaxForm -> 
            SuperscriptBox], TraditionalForm]}, {-13.815510557964274`, 
          FormBox[
           TemplateBox[{"10", 
             RowBox[{"-", "6"}]}, "Superscript", SyntaxForm -> 
            SuperscriptBox], TraditionalForm]}, {-11.512925464970229`, 
          FormBox[
           TemplateBox[{"10", 
             RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> 
            SuperscriptBox], TraditionalForm]}, {-9.210340371976182, 
          FormBox[
           TemplateBox[{"10", 
             RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
            SuperscriptBox], TraditionalForm]}, {-6.907755278982137, 
          FormBox["0.001`", TraditionalForm]}, {-15.424948470398375`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-15.01948336229021, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-14.73180128983843, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-14.508657738524219`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-14.326336181730264`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-14.172185501903007`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-14.038654109278484`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-13.9208710736221, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-13.122363377404328`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-12.716898269296165`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-12.429216196844383`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-12.206072645530174`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-12.02375108873622, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-11.86960040890896, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-11.736069016284437`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-11.618285980628055`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-10.819778284410283`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-10.414313176302118`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-10.126631103850338`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-9.903487552536127, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-9.721165995742174, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-9.567015315914915, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-9.433483923290392, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-9.315700887634009, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-8.517193191416238, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-8.111728083308073, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-7.824046010856292, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-7.600902459542082, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-7.418580902748127, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-7.264430222920869, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-7.1308988302963465`, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}, {-7.013115794639964, 
          FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
           Thickness[0.001]}}}}], {967.5, -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->{872., Automatic},
  PlotRangePadding->{6, 5}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.493988942835608*^9, {3.493988989042808*^9, 3.493989036404408*^9}, {
   3.493989076636808*^9, 3.493989093968408*^9}, 3.493989156774008*^9, 
   3.493990584501608*^9, 3.4939908639600077`*^9, {3.493991097757208*^9, 
   3.493991107164008*^9}, {3.493991158269608*^9, 3.4939912451616077`*^9}, 
   3.493991445356408*^9, 3.493991722381208*^9, 3.493992943658408*^9, 
   3.493994050275608*^9, {3.4939941696936083`*^9, 3.4939942183968077`*^9}, 
   3.493994387298008*^9, {3.493994493128408*^9, 3.493994501552408*^9}, 
   3.493994556542408*^9, 3.493994588553608*^9, {3.493994700499208*^9, 
   3.493994758468808*^9}, 3.493994795784008*^9, 3.493995720318008*^9}]
}, Closed]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"xf", "=", 
   FractionBox[
    RowBox[{"Total", "[", 
     RowBox[{
      RowBox[{"tab", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", 
         RowBox[{"36", ";;", "42"}], ",", 
         RowBox[{"-", "1"}]}], "]"}], "]"}], ",", 
      RowBox[{"{", "2", "}"}]}], "]"}], "7"]}], ";", 
  RowBox[{"xf", "=", 
   RowBox[{"Total", "[", 
    RowBox[{
     RowBox[{"tab", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", 
        RowBox[{"43", ";;", "53"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], ",", 
     RowBox[{"{", "2", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l", "=", 
   RowBox[{"Length", "[", "xf", "]"}]}], ";", 
  RowBox[{"coe", "=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"sf", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"coe", " ", "n"}], ",", 
       FractionBox[
        RowBox[{"Total", "[", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"RotateLeft", "[", 
              RowBox[{"xf", ",", "n"}], "]"}], "-", "xf"}], ")"}], "2"], "[", 
          RowBox[{"[", 
           RowBox[{"1", ";;", 
            RowBox[{"l", "-", "n"}]}], "]"}], "]"}], "]"}], 
        RowBox[{"l", "-", "n"}]]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", 
       RowBox[{"l", "-", "1"}]}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"ListLogLogPlot", "[", 
  RowBox[{"sf", ",", 
   RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.493992985294808*^9, 3.493993005777608*^9}, {
  3.493993100875208*^9, 3.493993136770808*^9}, {3.493993353985208*^9, 
  3.4939933745616083`*^9}, {3.493993432749608*^9, 3.4939934408460083`*^9}, {
  3.493993485508808*^9, 3.493993501998008*^9}, {3.493993549172408*^9, 
  3.4939935528228083`*^9}, {3.493993588437608*^9, 3.4939936100124083`*^9}, {
  3.493993708261208*^9, 3.4939937116152077`*^9}, {3.493993744422008*^9, 
  3.4939937607084084`*^9}, {3.4939938067908077`*^9, 3.493993815511208*^9}}],

Cell[BoxData[{
 RowBox[{"Tkep", "=", 
  RowBox[{"62", "*", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["20", "6."], ")"}], 
    RowBox[{"3", "/", "2"}]]}]}], "\[IndentingNewLine]", 
 FractionBox[
  RowBox[{"2", "*", "2", 
   RowBox[{"(", 
    RowBox[{"1900", "-", "100"}], ")"}]}], "Tkep"]}], "Input",
 CellChangeTimes->{{3.493990913755208*^9, 3.493990926344408*^9}, {
  3.493991001068408*^9, 3.493991033750408*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "res2m", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", 
  RowBox[{"tot\[Phi]", "=", 
   FractionBox[
    RowBox[{"Total", "[", 
     RowBox[{"res2m", ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], "32"]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", 
  RowBox[{"totr", "=", 
   RowBox[{"Total", "[", 
    RowBox[{
     RowBox[{"tot\[Phi]", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{
         RowBox[{"sptab", "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "3"}], "]"}], "]"}], ";;", 
         RowBox[{
          RowBox[{"sptab", "[", 
           RowBox[{"[", 
            RowBox[{"2", ",", "3"}], "]"}], "]"}], "+", "10"}]}], ",", "All", 
        ",", "All"}], "]"}], "]"}], ",", 
     RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.493987416204008*^9, 3.4939874177016077`*^9}, {
  3.493987552407608*^9, 3.493987630626008*^9}, {3.493988570931608*^9, 
  3.493988606203208*^9}}],

Cell[BoxData[
 RowBox[{"ListLogPlot", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"\[Theta]xx", ",", 
     RowBox[{"totr", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1"}], "]"}], "]"}]}], "}"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.4939886297280083`*^9, 3.493988640460808*^9}, {
  3.493988705341208*^9, 3.493988726635208*^9}}],

Cell[BoxData[
 RowBox[{"sptab", "[", 
  RowBox[{"[", 
   RowBox[{"2", ",", "3"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.4939885376100082`*^9, 3.4939885409172077`*^9}}],

Cell[BoxData[
 RowBox[{"Dimensions", "[", 
  RowBox[{"tot\[Theta]", "=", 
   RowBox[{"Total", "[", 
    RowBox[{
     RowBox[{"tot\[Phi]", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", 
        RowBox[{"36", ";;", "42"}], ",", "All"}], "]"}], "]"}], ",", 
     RowBox[{"{", "2", "}"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.493987632622808*^9, 3.4939876538076077`*^9}, {
  3.493987902159608*^9, 3.493987927478408*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{3.493988680131608*^9}],

Cell[BoxData[
 RowBox[{"rho", ",", " ", "u", ",", " ", 
  RowBox[{"-", "u_t"}], ",", " ", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"T", "^", "r_t"}]}], "/", 
   RowBox[{"(", 
    RowBox[{"rho", " ", 
     RowBox[{"u", "^", "r"}]}], ")"}]}], ",", " ", 
  RowBox[{"u", "^", "t"}], ",", " ", 
  RowBox[{"v", "^", "r"}], ",", " ", 
  RowBox[{"v", "^", "theta"}], ",", " ", 
  RowBox[{"v", "^", "phi"}], ",", " ", 
  RowBox[{"B", "^", "r"}], ",", " ", 
  RowBox[{"B", "^", "theta"}], ",", " ", 
  RowBox[{"B", "^", "phi"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"read11", "[", 
   RowBox[{"0.98", ",", "7000"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.4991822658508*^9, 3.499182286396*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"stt", "=", 
   RowBox[{"StringToStream", "[", "strrr", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"x1min", "=", 
    RowBox[{"Read", "[", 
     RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "5"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"dx1", "=", 
    RowBox[{"Read", "[", 
     RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"off", "=", 
    RowBox[{"Read", "[", 
     RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "6"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Close", "[", "stt", "]"}], ";"}], "\n", 
 RowBox[{"rtab", "=", 
  RowBox[{"off", "+", 
   RowBox[{"Exp", "[", 
    RowBox[{"x1min", "+", 
     RowBox[{"dx1", " ", 
      RowBox[{"Range", "[", 
       RowBox[{"0", ",", "255"}], "]"}]}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"np", "=", "32"}], ";", 
  RowBox[{"\[Theta]xx", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "x2"}], "-", "1"}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", "h"}], ")"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "x2"}], "-", "1"}], ")"}], "7"]}], "+", "1"}], ")"}], 
      FractionBox["\[Pi]", "2"]}], "/.", 
     RowBox[{"h", "\[Rule]", "0.65"}]}], "/.", 
    RowBox[{"x2", "\[Rule]", 
     RowBox[{"(", 
      RowBox[{"x2tab", "=", 
       RowBox[{"N", "[", 
        RowBox[{"Range", "[", 
         RowBox[{
          FractionBox["1", 
           RowBox[{"4", "np"}]], ",", 
          RowBox[{"1", "-", 
           FractionBox["1", 
            RowBox[{"4", "np"}]]}], ",", 
          FractionBox["1", 
           RowBox[{"2", "np"}]]}], "]"}], "]"}]}], ")"}]}]}]}]}]}], "Input",
 CellChangeTimes->{{3.493988682175208*^9, 3.493988698430408*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"np", "=", "32"}], ";", 
  RowBox[{"\[Theta]xx", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "x2"}], "-", "1"}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", "h"}], ")"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "x2"}], "-", "1"}], ")"}], "7"]}], "+", "1"}], ")"}], 
      FractionBox["\[Pi]", "2"]}], "/.", 
     RowBox[{"h", "\[Rule]", "0.13"}]}], "/.", 
    RowBox[{"x2", "\[Rule]", 
     RowBox[{"(", 
      RowBox[{"x2tab", "=", 
       RowBox[{"N", "[", 
        RowBox[{"Range", "[", 
         RowBox[{
          FractionBox["1", 
           RowBox[{"4", "np"}]], ",", 
          RowBox[{"1", "-", 
           FractionBox["1", 
            RowBox[{"4", "np"}]]}], ",", 
          FractionBox["1", 
           RowBox[{"2", "np"}]]}], "]"}], "]"}]}], ")"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.49466955008593*^9, 3.49466955025753*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["180", "\[Pi]"], 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"\[Theta]xx", "[", 
     RowBox[{"[", 
      RowBox[{"62", ";;", "64"}], "]"}], "]"}], "-", 
    FractionBox["\[Pi]", "2"]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.493993827944408*^9, 3.493993843263608*^9}, {
  3.494030002176008*^9, 3.4940300184780083`*^9}}],

Cell[BoxData[{
 RowBox[{"Mean", "[", 
  RowBox[{"rtab", "[", 
   RowBox[{"[", 
    RowBox[{"63", ";;", "73"}], "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Mean", "[", 
  RowBox[{"rtab", "[", 
   RowBox[{"[", 
    RowBox[{"99", ";;", "109"}], "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Mean", "[", 
  RowBox[{"rtab", "[", 
   RowBox[{"[", 
    RowBox[{"120", ";;", "130"}], "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Mean", "[", 
  RowBox[{"rtab", "[", 
   RowBox[{"[", 
    RowBox[{"135", ";;", "145"}], "]"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.493987996430408*^9, 3.493988079859208*^9}, {
  3.493991759150408*^9, 3.493991774734808*^9}, {3.493994080992008*^9, 
  3.493994125623608*^9}, {3.493995500654408*^9, 3.493995544381208*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ruru", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rg", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "6.67", " ", 
        SuperscriptBox["10", 
         RowBox[{"-", "8"}]], "4.5", " ", 
        SuperscriptBox["10", "6"], "2", " ", 
        SuperscriptBox["10", "33"]}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"3", " ", 
          SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
     RowBox[{"arcsec", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
        SuperscriptBox["10", "3"], "3.08", " ", 
        SuperscriptBox["10", "18"]}], 
       RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
     RowBox[{"pc", "\[Rule]", 
      RowBox[{"3.08", " ", 
       SuperscriptBox["10", "18"]}]}], ",", 
     RowBox[{"year", "\[Rule]", 
      RowBox[{"365.35", " ", "86400"}]}], ",", 
     RowBox[{"cc", "\[Rule]", 
      RowBox[{"3.", " ", 
       SuperscriptBox["10", "10"]}]}], ",", 
     RowBox[{"Msun", "\[Rule]", 
      RowBox[{"2.", " ", 
       SuperscriptBox["10", "33"]}]}], ",", 
     RowBox[{"mp", "\[Rule]", 
      RowBox[{"1.26", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "24"}]]}]}], ",", 
     RowBox[{"me", "\[Rule]", 
      RowBox[{"9.1", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "28"}]]}]}], ",", 
     RowBox[{"kb", "\[Rule]", 
      RowBox[{"1.38", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "16"}]]}]}], ",", 
     RowBox[{"h", "\[Rule]", 
      RowBox[{"6.626", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "27"}]]}]}], ",", 
     RowBox[{"ee", "\[Rule]", 
      RowBox[{"4.8", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "10"}]]}]}], ",", 
     RowBox[{"keV", "->", 
      RowBox[{"1000", " ", "1.602", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox[
   RowBox[{"240", " ", 
    FractionBox["rg", 
     RowBox[{"2", "cc"}]]}], "60"], "/.", "ruru"}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox[
   RowBox[{"240", " ", 
    FractionBox["rg", 
     RowBox[{"2", "cc"}]]}], 
   RowBox[{"2", " ", "60"}]], "/.", "ruru"}]}], "Input",
 CellChangeTimes->{{3.4961559679894*^9, 3.4961560171138*^9}, {
  3.4961563939941998`*^9, 3.4961564354434*^9}}]
}, Open  ]]
}, Closed]]
},
WindowSize->{1904, 963},
WindowMargins->{{0, Automatic}, {0, Automatic}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
ShowSelection->True,
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 3189, 90, 161, "Input",
 InitializationCell->True],
Cell[3737, 112, 11309, 335, 761, "Input"],
Cell[15049, 449, 96, 1, 36, "Input"],
Cell[15148, 452, 228841, 3770, 333, "Text"],
Cell[CellGroupData[{
Cell[244014, 4226, 95, 1, 106, "Section"],
Cell[244112, 4229, 534, 14, 60, "Input"],
Cell[244649, 4245, 523, 13, 36, "Input"],
Cell[245175, 4260, 2562, 72, 145, "Input"],
Cell[247740, 4334, 1001, 26, 106, "Input"],
Cell[248744, 4362, 198, 3, 60, "Input"],
Cell[248945, 4367, 1074, 27, 36, "Input"],
Cell[250022, 4396, 536, 14, 64, "Input"],
Cell[250561, 4412, 94, 1, 36, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[250692, 4418, 120, 1, 106, "Section"],
Cell[CellGroupData[{
Cell[250837, 4423, 156, 2, 59, "Subsection"],
Cell[250996, 4427, 1055, 25, 83, "Input"],
Cell[252054, 4454, 227, 5, 54, "Input"],
Cell[252284, 4461, 479, 12, 65, "Text"],
Cell[252766, 4475, 640, 15, 107, "Input"],
Cell[253409, 4492, 493, 16, 68, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[253939, 4513, 393, 6, 48, "Subsection"],
Cell[254335, 4521, 5364, 139, 359, "Input"],
Cell[259702, 4662, 21619, 583, 1326, "Input"],
Cell[281324, 5247, 27197, 611, 909, "Input"],
Cell[308524, 5860, 1238, 33, 60, "Input"],
Cell[309765, 5895, 3774, 92, 106, "Input"],
Cell[313542, 5989, 13048, 336, 633, "Input"],
Cell[326593, 6327, 321, 7, 36, "Input"],
Cell[326917, 6336, 309, 6, 36, "Input"],
Cell[327229, 6344, 257, 5, 36, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[327523, 6354, 369, 7, 48, "Subsection"],
Cell[327895, 6363, 3257, 101, 223, "Input"],
Cell[331155, 6466, 3363, 89, 244, "Input"],
Cell[334521, 6557, 21578, 583, 1326, "Input"],
Cell[356102, 7142, 26636, 603, 886, "Input"],
Cell[382741, 7747, 1238, 33, 60, "Input"],
Cell[383982, 7782, 1796, 40, 75, "Input"],
Cell[385781, 7824, 12518, 329, 625, "Input"],
Cell[398302, 8155, 258, 5, 36, "Input"],
Cell[398563, 8162, 257, 5, 36, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[398857, 8172, 255, 5, 48, "Subsection"],
Cell[399115, 8179, 3218, 84, 290, "Input"],
Cell[402336, 8265, 21240, 574, 1302, "Input"],
Cell[423579, 8841, 26086, 595, 885, "Input"],
Cell[449668, 9438, 759, 19, 59, "Input"],
Cell[450430, 9459, 1160, 35, 27, "Input"],
Cell[451593, 9496, 1749, 40, 75, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[453379, 9541, 189, 3, 48, "Subsection"],
Cell[453571, 9546, 4501, 118, 313, "Input"],
Cell[458075, 9666, 10126, 281, 341, "Input"],
Cell[468204, 9949, 23145, 562, 911, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[491386, 10516, 240, 4, 48, "Subsection"],
Cell[491629, 10522, 1096, 27, 83, "Input"],
Cell[492728, 10551, 7031, 173, 194, "Input"],
Cell[499762, 10726, 19244, 457, 750, "Input"],
Cell[519009, 11185, 140, 2, 36, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[519186, 11192, 213, 3, 48, "Subsection"],
Cell[519402, 11197, 21531, 533, 1044, "Input"],
Cell[540936, 11732, 10851, 288, 520, "Input"],
Cell[551790, 12022, 13116, 313, 681, "Input"],
Cell[564909, 12337, 12607, 320, 696, "Input"],
Cell[577519, 12659, 389, 7, 36, "Input"],
Cell[577911, 12668, 827, 22, 126, "Input"],
Cell[578741, 12692, 2880, 73, 152, "Input"],
Cell[581624, 12767, 4294, 107, 244, "Input"],
Cell[585921, 12876, 3186, 81, 155, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[589144, 12962, 164, 2, 48, "Subsection"],
Cell[589311, 12966, 5185, 140, 428, "Input"],
Cell[594499, 13108, 21585, 585, 1305, "Input"],
Cell[616087, 13695, 1757, 42, 106, "Input"],
Cell[617847, 13739, 3844, 112, 286, "Input"],
Cell[621694, 13853, 53118, 1289, 2149, "Input"],
Cell[674815, 15144, 676, 17, 36, "Input"],
Cell[675494, 15163, 5591, 169, 313, "Input"],
Cell[681088, 15334, 57992, 1309, 2485, "Input"],
Cell[739083, 16645, 393, 7, 36, "Input"],
Cell[739479, 16654, 5333, 147, 296, "Input"],
Cell[744815, 16803, 1823, 47, 92, "Input"],
Cell[746641, 16852, 12713, 320, 610, "Input"],
Cell[759357, 17174, 6703, 178, 267, "Input"],
Cell[766063, 17354, 1274, 29, 60, "Input"],
Cell[767340, 17385, 480, 10, 83, "Input"],
Cell[767823, 17397, 146, 3, 28, "Input"],
Cell[767972, 17402, 268, 6, 28, "Input"],
Cell[768243, 17410, 2568, 72, 201, "Input"],
Cell[770814, 17484, 1021, 25, 52, "Input"],
Cell[771838, 17511, 2081, 45, 121, "Input"],
Cell[773922, 17558, 3185, 82, 259, "Input"],
Cell[777110, 17642, 20434, 477, 971, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[797581, 18124, 213, 3, 48, "Subsection"],
Cell[797797, 18129, 1217, 34, 106, "Input"],
Cell[799017, 18165, 10605, 289, 646, "Input"],
Cell[809625, 18456, 1904, 41, 126, "Input"],
Cell[811532, 18499, 962, 29, 55, "Input"],
Cell[812497, 18530, 1370, 27, 60, "Input"],
Cell[813870, 18559, 95, 1, 28, "Input"],
Cell[813968, 18562, 100, 1, 28, "Input"],
Cell[814071, 18565, 98, 1, 28, "Input"],
Cell[814172, 18568, 71, 1, 28, "Input"],
Cell[814246, 18571, 168, 3, 28, "Input"],
Cell[814417, 18576, 166, 3, 28, "Input"],
Cell[814586, 18581, 173, 3, 28, "Input"],
Cell[814762, 18586, 167, 3, 28, "Input"],
Cell[814932, 18591, 169, 3, 28, "Input"],
Cell[815104, 18596, 312, 6, 28, "Input"],
Cell[815419, 18604, 175, 3, 28, "Input"],
Cell[815597, 18609, 172, 3, 28, "Input"],
Cell[815772, 18614, 169, 3, 28, "Input"],
Cell[815944, 18619, 170, 3, 28, "Input"],
Cell[816117, 18624, 168, 3, 28, "Input"],
Cell[816288, 18629, 163, 3, 28, "Input"],
Cell[816454, 18634, 70, 1, 28, "Input"],
Cell[816527, 18637, 6540, 172, 361, "Input"],
Cell[823070, 18811, 10636, 263, 394, "Input"],
Cell[833709, 19076, 595, 14, 36, "Input"],
Cell[834307, 19092, 395, 7, 28, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[834739, 19104, 171, 2, 48, "Subsection"],
Cell[834913, 19108, 2008, 53, 201, "Text"],
Cell[836924, 19163, 380, 10, 61, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[837341, 19178, 109, 1, 48, "Subsection"],
Cell[837453, 19181, 3004, 52, 105, "Input"],
Cell[840460, 19235, 133, 2, 35, "Input"],
Cell[840596, 19239, 710, 21, 59, "Input"],
Cell[841309, 19262, 19671, 530, 1117, "Input"],
Cell[860983, 19794, 697, 18, 77, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[861717, 19817, 519, 6, 48, "Subsection"],
Cell[862239, 19825, 3531, 66, 197, "Input"],
Cell[865773, 19893, 3917, 109, 312, "Input"],
Cell[869693, 20004, 3063, 86, 151, "Input"],
Cell[872759, 20092, 21964, 569, 1256, "Input"],
Cell[894726, 20663, 28719, 692, 1124, "Input"],
Cell[923448, 21357, 1505, 35, 59, "Input"],
Cell[924956, 21394, 317, 6, 35, "Input"],
Cell[925276, 21402, 117, 2, 35, "Input"],
Cell[925396, 21406, 119, 2, 35, "Input"],
Cell[925518, 21410, 148, 3, 35, "Input"],
Cell[925669, 21415, 150, 3, 27, "Input"],
Cell[925822, 21420, 150, 3, 27, "Input"],
Cell[925975, 21425, 152, 3, 27, "Input"],
Cell[926130, 21430, 152, 3, 27, "Input"],
Cell[926285, 21435, 150, 3, 27, "Input"],
Cell[926438, 21440, 152, 3, 27, "Input"],
Cell[926593, 21445, 152, 3, 27, "Input"],
Cell[926748, 21450, 150, 3, 27, "Input"],
Cell[926901, 21455, 147, 3, 27, "Input"],
Cell[927051, 21460, 201, 4, 27, "Input"],
Cell[927255, 21466, 146, 3, 35, "Input"],
Cell[927404, 21471, 8342, 222, 335, "Input"],
Cell[935749, 21695, 14889, 387, 922, "Input"],
Cell[950641, 22084, 1926, 53, 174, "Input"],
Cell[952570, 22139, 6666, 176, 351, "Input"],
Cell[959239, 22317, 440, 12, 35, "Input"],
Cell[959682, 22331, 3625, 96, 197, "Input"],
Cell[963310, 22429, 1561, 44, 108, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[964908, 22478, 115, 1, 48, "Subsection"],
Cell[965026, 22481, 149, 2, 36, "Input"],
Cell[965178, 22485, 9517, 270, 602, "Input"],
Cell[974698, 22757, 739, 21, 104, "Input"],
Cell[975440, 22780, 14597, 388, 960, "Input"],
Cell[990040, 23170, 5782, 154, 315, "Input"],
Cell[995825, 23326, 96, 1, 36, "Input"],
Cell[CellGroupData[{
Cell[995946, 23331, 3784, 110, 152, "Input"],
Cell[999733, 23443, 280, 6, 38, "Output"],
Cell[1000016, 23451, 281, 6, 38, "Output"]
}, Open  ]],
Cell[1000312, 23460, 260, 6, 60, "Input"],
Cell[1000575, 23468, 390, 12, 61, "Input"],
Cell[1000968, 23482, 256, 8, 53, "Input"],
Cell[1001227, 23492, 96, 1, 36, "Input"],
Cell[1001326, 23495, 198, 5, 33, "Input"],
Cell[1001527, 23502, 199, 5, 41, "Input"],
Cell[1001729, 23509, 261, 6, 41, "Input"],
Cell[1001993, 23517, 461, 13, 36, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1002491, 23535, 539, 7, 48, "Subsection"],
Cell[1003033, 23544, 3737, 69, 198, "Input"],
Cell[1006773, 23615, 3654, 100, 313, "Input"],
Cell[1010430, 23717, 10438, 284, 336, "Input"],
Cell[1020871, 24003, 3185, 87, 152, "Input"],
Cell[1024059, 24092, 21964, 569, 1257, "Input"],
Cell[1046026, 24663, 28312, 690, 1090, "Input"],
Cell[1074341, 25355, 1391, 35, 60, "Input"],
Cell[1075735, 25392, 119, 2, 36, "Input"],
Cell[1075857, 25396, 6666, 176, 352, "Input"],
Cell[1082526, 25574, 440, 12, 36, "Input"],
Cell[1082969, 25588, 3625, 96, 198, "Input"],
Cell[1086597, 25686, 1561, 44, 108, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1088195, 25735, 489, 6, 48, "Subsection"],
Cell[1088687, 25743, 3631, 67, 197, "Input"],
Cell[1092321, 25812, 3913, 109, 335, "Input"],
Cell[1096237, 25923, 10387, 283, 335, "Input"],
Cell[1106627, 26208, 3134, 86, 151, "Input"],
Cell[1109764, 26296, 21964, 569, 1256, "Input"],
Cell[1131731, 26867, 28312, 690, 1089, "Input"],
Cell[1160046, 27559, 1391, 35, 59, "Input"],
Cell[1161440, 27596, 6666, 176, 351, "Input"],
Cell[1168109, 27774, 440, 12, 35, "Input"],
Cell[1168552, 27788, 3625, 96, 197, "Input"],
Cell[1172180, 27886, 1561, 44, 108, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1173778, 27935, 484, 6, 48, "Subsection"],
Cell[1174265, 27943, 3629, 67, 197, "Input"],
Cell[1177897, 28012, 3915, 109, 335, "Input"],
Cell[1181815, 28123, 3118, 86, 151, "Input"],
Cell[1184936, 28211, 14791, 404, 779, "Input"],
Cell[1199730, 28617, 14130, 385, 876, "Input"],
Cell[1213863, 29004, 99, 1, 35, "Input"],
Cell[1213965, 29007, 227, 6, 35, "Input"],
Cell[1214195, 29015, 1926, 53, 174, "Input"],
Cell[1216124, 29070, 6666, 176, 351, "Input"],
Cell[1222793, 29248, 440, 12, 35, "Input"],
Cell[1223236, 29262, 3625, 96, 197, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1226898, 29363, 533, 7, 48, "Subsection"],
Cell[1227434, 29372, 3732, 69, 197, "Input"],
Cell[1231169, 29443, 3644, 101, 266, "Input"],
Cell[1234816, 29546, 539, 8, 82, "Input"],
Cell[1235358, 29556, 3177, 87, 151, "Input"],
Cell[1238538, 29645, 13412, 376, 901, "Input"],
Cell[1251953, 30023, 14130, 385, 876, "Input"],
Cell[1266086, 30410, 227, 6, 35, "Input"],
Cell[1266316, 30418, 1976, 53, 174, "Input"],
Cell[1268295, 30473, 6683, 177, 351, "Input"],
Cell[1274981, 30652, 440, 12, 35, "Input"],
Cell[1275424, 30666, 3625, 96, 197, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1279086, 30767, 125, 2, 48, "Subsection"],
Cell[1279214, 30771, 43013, 969, 1800, "Input"],
Cell[1322230, 31742, 1049, 25, 126, "Input"],
Cell[1323282, 31769, 3165, 77, 152, "Input"],
Cell[1326450, 31848, 3608, 87, 155, "Input"],
Cell[1330061, 31937, 4666, 112, 244, "Input"],
Cell[1334730, 32051, 135, 3, 36, "Input"],
Cell[1334868, 32056, 116, 2, 36, "Input"],
Cell[1334987, 32060, 116, 2, 36, "Input"],
Cell[1335106, 32064, 1682, 48, 244, "Input"],
Cell[1336791, 32114, 172, 2, 38, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[1337000, 32121, 101, 1, 48, "Subsection"],
Cell[1337104, 32124, 7985, 140, 67, "Text"],
Cell[1345092, 32266, 9428, 282, 565, "Input"],
Cell[1354523, 32550, 520, 15, 36, "Input"],
Cell[1355046, 32567, 4555, 136, 244, "Input"],
Cell[1359604, 32705, 851, 26, 101, "Input"],
Cell[1360458, 32733, 266, 7, 53, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1360773, 32746, 160, 2, 106, "Section"],
Cell[CellGroupData[{
Cell[1360958, 32752, 245, 3, 59, "Subsection"],
Cell[CellGroupData[{
Cell[1361228, 32759, 387, 5, 49, "Subsubsection"],
Cell[1361618, 32766, 2925, 49, 82, "Input"],
Cell[1364546, 32817, 3646, 103, 266, "Input"],
Cell[1368195, 32922, 26167, 726, 1763, "Input"],
Cell[1394365, 33650, 1861, 54, 174, "Input"],
Cell[1396229, 33706, 6181, 163, 306, "Input"],
Cell[1402413, 33871, 3625, 96, 197, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1406075, 33972, 338, 4, 40, "Subsubsection"],
Cell[1406416, 33978, 2871, 48, 82, "Input"],
Cell[1409290, 34028, 339, 10, 35, "Input"],
Cell[1409632, 34040, 96, 1, 35, "Input"],
Cell[1409731, 34043, 3779, 105, 266, "Input"],
Cell[1413513, 34150, 26167, 726, 1763, "Input"],
Cell[1439683, 34878, 1861, 54, 174, "Input"],
Cell[1441547, 34934, 6352, 167, 306, "Input"],
Cell[1447902, 35103, 3685, 98, 197, "Input"],
Cell[1451590, 35203, 126, 2, 35, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1451753, 35210, 345, 6, 40, "Subsubsection"],
Cell[1452101, 35218, 2873, 48, 59, "Input"],
Cell[1454977, 35268, 3646, 103, 266, "Input"],
Cell[1458626, 35373, 396, 7, 105, "Input"],
Cell[1459025, 35382, 3084, 88, 151, "Input"],
Cell[1462112, 35472, 26167, 726, 1763, "Input"],
Cell[1488282, 36200, 1861, 54, 174, "Input"],
Cell[1490146, 36256, 6284, 166, 328, "Input"],
Cell[1496433, 36424, 3625, 96, 197, "Input"],
Cell[1500061, 36522, 1561, 44, 108, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1501659, 36571, 346, 6, 40, "Subsubsection"],
Cell[1502008, 36579, 2839, 48, 59, "Input"],
Cell[1504850, 36629, 3646, 103, 266, "Input"],
Cell[1508499, 36734, 26167, 726, 1763, "Input"],
Cell[1534669, 37462, 1861, 54, 174, "Input"],
Cell[1536533, 37518, 6181, 163, 306, "Input"],
Cell[1542717, 37683, 3625, 96, 197, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1546379, 37784, 157, 2, 40, "Subsubsection"],
Cell[1546539, 37788, 2445, 42, 59, "Input"],
Cell[1548987, 37832, 3646, 103, 266, "Input"],
Cell[1552636, 37937, 26167, 726, 1763, "Input"],
Cell[1578806, 38665, 97, 1, 35, "Input"],
Cell[1578906, 38668, 1875, 57, 174, "Input"],
Cell[1580784, 38727, 6157, 163, 306, "Input"],
Cell[1586944, 38892, 3625, 96, 197, "Input"],
Cell[1590572, 38990, 1561, 44, 108, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1592170, 39039, 159, 2, 40, "Subsubsection"],
Cell[1592332, 39043, 2493, 43, 60, "Input"],
Cell[1594828, 39088, 3646, 103, 267, "Input"],
Cell[1598477, 39193, 133, 2, 36, "Input"],
Cell[1598613, 39197, 26005, 722, 1764, "Input"],
Cell[1624621, 39921, 97, 1, 36, "Input"],
Cell[1624721, 39924, 1136, 34, 106, "Input"],
Cell[1625860, 39960, 99, 1, 36, "Input"],
Cell[1625962, 39963, 269, 6, 36, "Input"],
Cell[1626234, 39971, 4949, 128, 165, "Input"],
Cell[1631186, 40101, 95, 1, 36, "Input"],
Cell[1631284, 40104, 1561, 44, 108, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1632882, 40153, 99, 1, 40, "Subsubsection"],
Cell[1632984, 40156, 39660, 907, 1741, "Input"],
Cell[1672647, 41065, 2876, 71, 129, "Input"],
Cell[1675526, 41138, 3282, 80, 155, "Input"],
Cell[1678811, 41220, 4374, 108, 244, "Input"],
Cell[1683188, 41330, 1682, 48, 244, "Input"],
Cell[1684873, 41380, 172, 2, 38, "Text"]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1685106, 41389, 164, 2, 106, "Section"],
Cell[CellGroupData[{
Cell[1685295, 41395, 126, 2, 59, "Subsection"],
Cell[1685424, 41399, 2075, 36, 60, "Input"],
Cell[1687502, 41437, 3646, 103, 267, "Input"],
Cell[1691151, 41542, 133, 2, 36, "Input"],
Cell[1691287, 41546, 25958, 721, 1764, "Input"],
Cell[1717248, 42269, 97, 1, 36, "Input"],
Cell[1717348, 42272, 1111, 34, 106, "Input"],
Cell[1718462, 42308, 269, 6, 36, "Input"],
Cell[1718734, 42316, 4949, 128, 165, "Input"],
Cell[1723686, 42446, 1561, 44, 108, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1725284, 42495, 176, 2, 48, "Subsection"],
Cell[1725463, 42499, 2039, 35, 60, "Input"],
Cell[1727505, 42536, 3646, 103, 267, "Input"],
Cell[1731154, 42641, 25958, 721, 1764, "Input"],
Cell[1757115, 43364, 1111, 34, 106, "Input"],
Cell[1758229, 43400, 269, 6, 36, "Input"],
Cell[1758501, 43408, 4949, 128, 165, "Input"],
Cell[1763453, 43538, 1561, 44, 108, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1765063, 43588, 120, 1, 68, "Section"],
Cell[CellGroupData[{
Cell[1765208, 43593, 126, 2, 59, "Subsection"],
Cell[1765337, 43597, 1921, 34, 60, "Input"],
Cell[1767261, 43633, 3646, 103, 267, "Input"],
Cell[1770910, 43738, 133, 2, 36, "Input"],
Cell[1771046, 43742, 25958, 721, 1764, "Input"],
Cell[1797007, 44465, 1111, 34, 106, "Input"],
Cell[1798121, 44501, 269, 6, 36, "Input"],
Cell[1798393, 44509, 4949, 128, 165, "Input"],
Cell[1803345, 44639, 1561, 44, 108, "Input"],
Cell[1804909, 44685, 71, 1, 36, "Input"],
Cell[1804983, 44688, 67, 1, 36, "Input"],
Cell[1805053, 44691, 71, 1, 36, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1805161, 44697, 178, 2, 48, "Subsection"],
Cell[1805342, 44701, 1558, 29, 60, "Input"],
Cell[1806903, 44732, 3646, 103, 267, "Input"],
Cell[1810552, 44837, 277, 4, 36, "Input"],
Cell[1810832, 44843, 4994, 130, 165, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1815863, 44978, 100, 1, 48, "Subsection"],
Cell[1815966, 44981, 2120, 37, 83, "Input"],
Cell[1818089, 45020, 3633, 103, 244, "Input"],
Cell[1821725, 45125, 277, 4, 36, "Input"],
Cell[1822005, 45131, 4949, 128, 165, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1827003, 45265, 90, 1, 68, "Section"],
Cell[1827096, 45268, 8657, 217, 491, "Input"],
Cell[1835756, 45487, 1703, 31, 60, "Input"],
Cell[1837462, 45520, 868, 20, 60, "Input"],
Cell[1838333, 45542, 560, 15, 60, "Input"],
Cell[1838896, 45559, 708, 18, 60, "Input"],
Cell[1839607, 45579, 602, 16, 80, "Input"],
Cell[1840212, 45597, 127, 2, 36, "Input"],
Cell[CellGroupData[{
Cell[1840364, 45603, 95, 1, 59, "Subsection"],
Cell[1840462, 45606, 8007, 225, 306, "Input"],
Cell[1848472, 45833, 1103, 27, 83, "Input"],
Cell[1849578, 45862, 3711, 107, 225, "Input"],
Cell[1853292, 45971, 324, 9, 36, "Input"],
Cell[1853619, 45982, 94, 1, 36, "Input"],
Cell[1853716, 45985, 892, 23, 36, "Input"],
Cell[1854611, 46010, 117, 2, 36, "Input"],
Cell[1854731, 46014, 426, 11, 36, "Input"],
Cell[1855160, 46027, 94, 1, 36, "Input"],
Cell[1855257, 46030, 486, 13, 36, "Input"],
Cell[1855746, 46045, 478, 13, 36, "Input"],
Cell[1856227, 46060, 200, 4, 36, "Input"],
Cell[1856430, 46066, 147, 3, 36, "Input"],
Cell[1856580, 46071, 151, 3, 36, "Input"],
Cell[1856734, 46076, 152, 3, 36, "Input"],
Cell[1856889, 46081, 154, 3, 36, "Input"],
Cell[1857046, 46086, 199, 4, 36, "Input"],
Cell[1857248, 46092, 304, 9, 54, "Input"],
Cell[1857555, 46103, 391, 10, 54, "Input"],
Cell[1857949, 46115, 157, 3, 36, "Input"],
Cell[1858109, 46120, 157, 3, 36, "Input"],
Cell[1858269, 46125, 122, 2, 36, "Input"],
Cell[1858394, 46129, 284, 7, 36, "Input"],
Cell[1858681, 46138, 8371, 226, 306, "Input"],
Cell[1867055, 46366, 99, 1, 36, "Input"],
Cell[1867157, 46369, 97, 1, 28, "Input"],
Cell[CellGroupData[{
Cell[1867279, 46374, 123, 2, 28, "Input"],
Cell[1867405, 46378, 7090, 128, 251, "Output"],
Cell[1874498, 46508, 7508, 138, 251, "Output"],
Cell[1882009, 46648, 58135, 1017, 251, "Output"],
Cell[1940147, 47667, 70638, 1307, 251, "Output"]
}, Closed]],
Cell[2010800, 48977, 2058, 56, 147, "Input"],
Cell[2012861, 49035, 427, 12, 101, "Input"],
Cell[2013291, 49049, 1003, 27, 103, "Input"],
Cell[2014297, 49078, 369, 10, 36, "Input"],
Cell[2014669, 49090, 175, 4, 36, "Input"],
Cell[2014847, 49096, 437, 11, 36, "Input"],
Cell[2015287, 49109, 68, 1, 36, "Input"],
Cell[2015358, 49112, 530, 15, 36, "Input"],
Cell[2015891, 49129, 168, 4, 36, "Input"],
Cell[2016062, 49135, 2180, 69, 196, "Input"],
Cell[2018245, 49206, 1101, 35, 57, "Input"],
Cell[2019349, 49243, 357, 10, 54, "Input"],
Cell[2019709, 49255, 780, 19, 106, "Input"],
Cell[2020492, 49276, 2330, 69, 210, "Input"]
}, Open  ]]
}, Closed]]
}
]
*)

(* End of internal cache information *)
