(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   3777025,      83834]
NotebookOptionsPosition[   3755035,      83239]
NotebookOutlinePosition[   3755399,      83255]
CellTagsIndexPosition[   3755356,      83252]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["Estimates of times", "Section",
 CellChangeTimes->{{3.484922222701*^9, 3.484922226196*^9}}],

Cell[CellGroupData[{

Cell["Plots", "Section",
 CellChangeTimes->{{3.48486692080214*^9, 3.4848669213411407`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ex", "=", 
   RowBox[{"E1", " ", 
    RowBox[{"Exp", "[", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "k"}], " ", "t"}], "+", "\[Delta]"}], ")"}]}], 
     "]"}]}]}], ";", 
  RowBox[{"Ey", "=", 
   RowBox[{"E2", " ", 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "k", " ", "t"}], "]"}]}]}], ";", 
  RowBox[{"rul", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"E1", "\[Rule]", "1"}], ",", 
     RowBox[{"E2", "\[Rule]", "1"}], ",", 
     RowBox[{"\[Delta]", "\[Rule]", 
      FractionBox["\[Pi]", "2"]}], ",", 
     RowBox[{"k", "\[Rule]", "3"}]}], "}"}]}], ";", 
  RowBox[{"sc", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Re", "[", "Ex", "]"}], "/.", "rul"}], ",", 
      RowBox[{
       RowBox[{"Re", "[", "Ey", "]"}], "/.", "rul"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", 
      RowBox[{"2", "\[Pi]"}]}], "}"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Red", ",", "Blue"}], "}"}]}], ",", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<Ex - red, Ey - blue\>\""}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tplrot", "=", 
  RowBox[{"ParametricPlot3D", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"t", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"u", " ", 
         RowBox[{"Re", "[", "Ex", "]"}]}], "/.", 
        RowBox[{"\[Delta]", "\[Rule]", 
         FractionBox["\[Pi]", "2"]}]}], "/.", "rul"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"u", " ", 
         RowBox[{"Re", "[", "Ey", "]"}]}], "/.", 
        RowBox[{"\[Delta]", "\[Rule]", 
         FractionBox["\[Pi]", "2"]}]}], "/.", "rul"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", 
      RowBox[{"2", "\[Pi]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"u", ",", "0.5", ",", "1"}], "}"}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<t\>\"", ",", "Null", ",", "Null"}], "}"}]}], ",", 
    RowBox[{"Axes", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False", ",", "False"}], "}"}]}], ",", 
    RowBox[{
    "PlotLabel", "\[Rule]", 
     "\"\<clockwise rotation in fixed plane: \[Delta]>0\>\""}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", "Green"}], ",", 
    RowBox[{"Mesh", "\[Rule]", "False"}], ",", 
    RowBox[{"PlotPoints", "\[Rule]", "70"}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"17", ",", "Bold"}], "}"}]}], ",", 
    RowBox[{"BoxStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
    RowBox[{"ViewPoint", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"40", "sc"}], ",", 
       RowBox[{"10", "sc"}], ",", 
       RowBox[{"10", "sc"}]}], "}"}]}], ",", 
    RowBox[{"ViewVertical", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ex", "=", 
   RowBox[{"E1", " ", 
    RowBox[{"Exp", "[", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"k", " ", "z"}], "+", "\[Delta]"}], ")"}]}], "]"}]}]}], ";", 
  RowBox[{"Ey", "=", 
   RowBox[{"E2", " ", 
    RowBox[{"Exp", "[", 
     RowBox[{"\[ImaginaryI]", " ", "k", " ", "z"}], "]"}]}]}], ";", 
  RowBox[{"rul", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"E1", "\[Rule]", "1"}], ",", 
     RowBox[{"E2", "\[Rule]", "1"}], ",", 
     RowBox[{"\[Delta]", "\[Rule]", 
      FractionBox["\[Pi]", "2"]}], ",", 
     RowBox[{"k", "\[Rule]", "3"}]}], "}"}]}], ";", 
  RowBox[{"sc", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Re", "[", "Ex", "]"}], "/.", "rul"}], ",", 
      RowBox[{
       RowBox[{"Re", "[", "Ey", "]"}], "/.", "rul"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"z", ",", "0", ",", 
      RowBox[{"2", "\[Pi]"}]}], "}"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Red", ",", "Blue"}], "}"}]}], ",", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<Ex - red, Ey - blue\>\""}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"zplrot", "=", 
  RowBox[{"ParametricPlot3D", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"z", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"u", " ", 
         RowBox[{"Re", "[", "Ex", "]"}]}], "/.", 
        RowBox[{"\[Delta]", "\[Rule]", 
         FractionBox["\[Pi]", "2"]}]}], "/.", "rul"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"u", " ", 
         RowBox[{"Re", "[", "Ey", "]"}]}], "/.", 
        RowBox[{"\[Delta]", "\[Rule]", 
         FractionBox["\[Pi]", "2"]}]}], "/.", "rul"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"z", ",", "0", ",", 
      RowBox[{"2", "\[Pi]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"u", ",", "0.5", ",", "1"}], "}"}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<z\>\"", ",", "Null", ",", "Null"}], "}"}]}], ",", 
    RowBox[{"Axes", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False", ",", "False"}], "}"}]}], ",", 
    RowBox[{
    "PlotLabel", "\[Rule]", 
     "\"\<right-handed rotation along the ray: \[Delta]>0\>\""}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", "Green"}], ",", 
    RowBox[{"Mesh", "\[Rule]", "False"}], ",", 
    RowBox[{"PlotPoints", "\[Rule]", "70"}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"17", ",", "Bold"}], "}"}]}], ",", 
    RowBox[{"BoxStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
    RowBox[{"ViewPoint", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"40", "sc"}], ",", 
       RowBox[{"10", "sc"}], ",", 
       RowBox[{"10", "sc"}]}], "}"}]}], ",", 
    RowBox[{"ViewVertical", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0"}], "}"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.480435966308799*^9, 3.4804359681807985`*^9}, {
   3.4804361990295987`*^9, 3.4804364627475986`*^9}, {3.480436498783599*^9, 
   3.480436585472799*^9}, {3.4804366335207987`*^9, 3.480436659151599*^9}, {
   3.4804367260755987`*^9, 3.480436729445199*^9}, {3.4804368747621984`*^9, 
   3.480436922310999*^9}, 3.480436958549799*^9, {3.480437017299399*^9, 
   3.480437064192999*^9}, {3.4809512861748*^9, 3.4809513037248*^9}, {
   3.4809514246247997`*^9, 3.4809514819704*^9}, {3.48095151459*^9, 
   3.4809515147616*^9}, {3.4809515537304*^9, 3.4809516627743998`*^9}, {
   3.4809518109588003`*^9, 3.4809518115048*^9}, {3.4809519188328*^9, 
   3.4809519254628*^9}, {3.480952001388*^9, 3.4809520092192*^9}, {
   3.4809530268384*^9, 3.4809530274156*^9}, {3.480954368592*^9, 
   3.4809543717432003`*^9}, {3.4809544206336*^9, 3.4809545138747997`*^9}, {
   3.4809545581788*^9, 3.4809545790828*^9}, {3.4809548021784*^9, 
   3.4809548165615997`*^9}, {3.4809549355428*^9, 3.4809549515172*^9}, {
   3.4809550186127996`*^9, 3.4809550827444*^9}, {3.4809551241935997`*^9, 
   3.4809552018348*^9}, {3.4815862907918*^9, 3.4815863157674*^9}, {
   3.4815899024414*^9, 3.4815899231113997`*^9}, {3.4815900201122*^9, 
   3.4815900612962*^9}, {3.4844144845738*^9, 3.484414487335*^9}, {
   3.4846753756331997`*^9, 3.4846754430408*^9}, {3.4846756172771997`*^9, 
   3.4846756386647997`*^9}, {3.484675772934*^9, 3.4846757746188*^9}, {
   3.4848661729842*^9, 3.4848662061029997`*^9}, {3.4848662610618*^9, 
   3.4848662659446*^9}, {3.4848662964426003`*^9, 3.4848663068946*^9}, {
   3.4848666094098*^9, 3.4848666125298*^9}, {3.4848681407301407`*^9, 
   3.4848681430111403`*^9}, {3.4848701967161407`*^9, 3.4848701975651407`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "dir", "=", 
   "\"\<C:\\\\study\\\\accretion\\\\! 2009 summer cfa\\\\GR Polarized \
Radiative Transfer\\\\\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"dir", "<>", "\"\<tplrot.eps\>\""}], ",", 
   RowBox[{"Rasterize", "[", 
    RowBox[{"tplrot", ",", 
     RowBox[{"RasterSize", "\[Rule]", "500"}]}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"dir", "<>", "\"\<tplrot.jpg\>\""}], ",", "tplrot", ",", 
   RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}], ",", 
   RowBox[{"\"\<Progressive\>\"", "\[Rule]", "True"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"dir", "<>", "\"\<zplrot.eps\>\""}], ",", 
   RowBox[{"Rasterize", "[", 
    RowBox[{"zplrot", ",", 
     RowBox[{"RasterSize", "\[Rule]", "500"}]}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"dir", "<>", "\"\<zplrot.jpg\>\""}], ",", "zplrot", ",", 
    RowBox[{"\"\<CompressionLevel\>\"", "->", "0"}], ",", 
    RowBox[{"\"\<Progressive\>\"", "\[Rule]", "True"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"dir", "<>", "\"\<tplrotx.pdf\>\""}], ",", 
    RowBox[{"Rasterize", "[", 
     RowBox[{"tplrot", ",", 
      RowBox[{"RasterSize", "\[Rule]", "1000"}]}], "]"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"dir", "<>", "\"\<zplrot.pdf\>\""}], ",", 
   RowBox[{"Rasterize", "[", 
    RowBox[{"zplrot", ",", 
     RowBox[{"RasterSize", "\[Rule]", "500"}]}], "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.480953896258*^9, 3.480953935726*^9}, {
   3.4809539783398*^9, 3.4809539929414*^9}, {3.4809542460072002`*^9, 
   3.48095427624*^9}, {3.4809543191400003`*^9, 3.4809543502932*^9}, {
   3.4809547345368*^9, 3.4809547347708*^9}, {3.4809552751392*^9, 
   3.4809552962928*^9}, {3.4809554655996*^9, 3.4809554660208*^9}, {
   3.4809555303084*^9, 3.4809555942528*^9}, {3.4809556371216*^9, 
   3.4809556371996*^9}, {3.4809557457444*^9, 3.4809557459628*^9}, {
   3.4809559206359997`*^9, 3.4809559550184*^9}, {3.4809560078556004`*^9, 
   3.4809560127852*^9}, {3.4809560515355997`*^9, 3.4809560903171997`*^9}, {
   3.480956134441*^9, 3.4809561344722*^9}, {3.4809563215474*^9, 
   3.4809563246362*^9}, {3.4815900823873997`*^9, 3.4815900874886*^9}, {
   3.4815901382198*^9, 3.4815901472054*^9}, {3.4848669297111406`*^9, 
   3.4848669322201405`*^9}, {3.48486699336814*^9, 3.4848670201441402`*^9}, {
   3.4848676369391403`*^9, 3.4848676509591403`*^9}, {3.4848676854381404`*^9, 
   3.4848677048481407`*^9}, {3.4848677970901403`*^9, 
   3.4848677985391407`*^9}, {3.4848691919531403`*^9, 
   3.4848692019841404`*^9}, {3.4848692665101404`*^9, 3.4848692699141407`*^9}, 
   3.4848693156451406`*^9, {3.4848698183881407`*^9, 3.48486981883714*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
New integration (instead of \[Theta] integral left we have \[Xi] integral \
left)\
\>", "Section",
 CellChangeTimes->{{3.4807741455369997`*^9, 3.480774182343*^9}}],

Cell["Gradstein, Ryzhik, p.502", "Text",
 CellChangeTimes->{{3.480776430358*^9, 3.480776437349*^9}}],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzs/W2y47yyMFYquqMH0lPqIXgCHrNHstv2E295300SSCQ+CFJr/bhxrgQk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    "], {{0, 770}, {1505, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->{547.1999999999982, Automatic},
  ImageSizeRaw->{1505, 770},
  PlotRange->{{0, 1505}, {0, 770}}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"p", "\[Equal]", "q", "\[Equal]", "0"}], "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{"p", "=", "0"}], ";", 
    RowBox[{"q", "=", "0."}], ";", 
    RowBox[{"a", "=", "15.4"}], ";", 
    RowBox[{"b", "=", "2.1"}], ";", 
    RowBox[{"m", "=", "2"}], ";", 
    RowBox[{"A", "=", 
     RowBox[{
      SuperscriptBox["p", "2"], "-", 
      SuperscriptBox["q", "2"], "+", 
      SuperscriptBox["a", "2"], "-", 
      SuperscriptBox["b", "2"]}]}], ";", 
    RowBox[{"B", "=", 
     RowBox[{"2", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"p", " ", "q"}], "+", 
        RowBox[{"a", " ", "b"}]}], ")"}]}]}], ";", 
    RowBox[{"CC", "=", 
     RowBox[{
      SuperscriptBox["p", "2"], "+", 
      SuperscriptBox["q", "2"], "-", 
      SuperscriptBox["a", "2"], "-", 
      SuperscriptBox["b", "2"]}]}], ";", 
    RowBox[{"DD", "=", 
     RowBox[{
      RowBox[{"-", "2"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"a", " ", "p"}], "+", 
        RowBox[{"b", " ", "q"}]}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{"InputForm", "[", 
     RowBox[{"NIntegrate", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"p", " ", 
           RowBox[{"Cos", "[", "x", "]"}]}], "+", 
          RowBox[{"q", " ", 
           RowBox[{"Sin", "[", "x", "]"}]}]}], "]"}], 
        RowBox[{"Sin", "[", 
         RowBox[{
          RowBox[{"a", " ", 
           RowBox[{"Cos", "[", "x", "]"}]}], "+", 
          RowBox[{"b", " ", 
           RowBox[{"Sin", "[", "x", "]"}]}], "-", 
          RowBox[{"m", " ", "x"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", 
         RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "]"}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"EvenQ", "[", "m", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"InputForm", "[", 
       RowBox[{"Chop", "[", 
        RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox[
               RowBox[{"A", "+", 
                RowBox[{"\[ImaginaryI]", " ", "B"}]}], 
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"b", "-", "p"}], ")"}], "2"], "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"a", "+", "q"}], ")"}], "2"]}]], ")"}], 
             FractionBox["m", "2"]], 
            RowBox[{"BesselI", "[", 
             RowBox[{"m", ",", 
              SqrtBox[
               RowBox[{"CC", "-", 
                RowBox[{"\[ImaginaryI]", " ", "DD"}]}]]}], "]"}]}], "-", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox[
               RowBox[{"A", "-", 
                RowBox[{"\[ImaginaryI]", " ", "B"}]}], 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{"b", "-", "p"}], ")"}], "2"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{"a", "+", "q"}], ")"}], "2"]}], ")"}]], ")"}], 
             FractionBox["m", "2"]], 
            RowBox[{"BesselI", "[", 
             RowBox[{"m", ",", 
              SqrtBox[
               RowBox[{"CC", "+", 
                RowBox[{"\[ImaginaryI]", " ", "DD"}]}]]}], "]"}]}]}], ")"}]}],
         "]"}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"Print", "[", 
       RowBox[{"InputForm", "[", 
        RowBox[{"Chop", "[", 
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Pi]", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"b", "-", "p"}], ")"}], "2"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"a", "+", "q"}], ")"}], "2"]}], ")"}], 
           RowBox[{
            RowBox[{"-", "m"}], "/", "2."}]], 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"A", "+", 
               RowBox[{"\[ImaginaryI]", " ", "B"}]}], ")"}], 
             FractionBox["m", "2"]], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"A", "-", 
               RowBox[{"\[ImaginaryI]", " ", "B"}]}], ")"}], 
             FractionBox["m", "2"]]}], ")"}], 
          RowBox[{"BesselI", "[", 
           RowBox[{"m", ",", 
            SqrtBox[
             RowBox[{"CC", "+", 
              RowBox[{"\[ImaginaryI]", " ", "DD"}]}]]}], "]"}]}], "]"}], 
        "]"}], "]"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"InputForm", "[", 
       RowBox[{"Chop", "[", 
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Pi]", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{"A", "+", 
               RowBox[{"\[ImaginaryI]", " ", "B"}]}], 
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"b", "-", "p"}], ")"}], "2"], "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"a", "+", "q"}], ")"}], "2"]}]], ")"}], 
            FractionBox["m", "2"]], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{"A", "-", 
               RowBox[{"\[ImaginaryI]", " ", "B"}]}], 
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"b", "-", "p"}], ")"}], "2"], "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"a", "+", "q"}], ")"}], "2"]}]], ")"}], 
            FractionBox["m", "2"]]}], ")"}], 
         RowBox[{"BesselI", "[", 
          RowBox[{"m", ",", 
           SqrtBox[
            RowBox[{"CC", "+", 
             RowBox[{"\[ImaginaryI]", " ", "DD"}]}]]}], "]"}]}], "]"}], "]"}],
       "]"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.480776948837*^9, 3.48077737644*^9}, {3.480777429613*^9, 
  3.48077750024*^9}, {3.480777534343*^9, 3.4807775492139997`*^9}, {
  3.480777579733*^9, 3.480777604946*^9}, {3.480777651046*^9, 
  3.480777905196*^9}, {3.480778018796*^9, 3.480778052895*^9}, {
  3.4807781305150003`*^9, 3.480778161961*^9}, {3.4807784518389997`*^9, 
  3.4807784974040003`*^9}, {3.480778675602*^9, 3.480778682777*^9}, {
  3.480778908197*^9, 3.480778973401*^9}, {3.480780901481*^9, 
  3.480780901929*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"p", "=", "0"}], ";", 
  RowBox[{"q", "=", "0."}], ";", 
  RowBox[{"a", "=", "15.4"}], ";", 
  RowBox[{"b", "=", "2.1"}], ";", 
  RowBox[{"m", "=", "1"}], ";", 
  RowBox[{"Clear", "[", 
   RowBox[{"m", ",", "p", ",", "q", ",", "a", ",", "b"}], "]"}], ";", 
  RowBox[{"A", "=", 
   RowBox[{
    SuperscriptBox["p", "2"], "-", 
    SuperscriptBox["q", "2"], "+", 
    SuperscriptBox["a", "2"], "-", 
    SuperscriptBox["b", "2"]}]}], ";", 
  RowBox[{"B", "=", 
   RowBox[{"2", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"p", " ", "q"}], "+", 
      RowBox[{"a", " ", "b"}]}], ")"}]}]}], ";", 
  RowBox[{"CC", "=", 
   RowBox[{
    SuperscriptBox["p", "2"], "+", 
    SuperscriptBox["q", "2"], "-", 
    SuperscriptBox["a", "2"], "-", 
    SuperscriptBox["b", "2"]}]}], ";", 
  RowBox[{"DD", "=", 
   RowBox[{
    RowBox[{"-", "2"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"a", " ", "p"}], "+", 
      RowBox[{"b", " ", "q"}]}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"expr", "=", 
   RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"A", "+", 
           RowBox[{"\[ImaginaryI]", " ", "B"}]}], 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"b", "-", "p"}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", "q"}], ")"}], "2"]}]], ")"}], 
        FractionBox["m", "2"]], 
       RowBox[{"BesselI", "[", 
        RowBox[{"m", ",", 
         SqrtBox[
          RowBox[{"CC", "-", 
           RowBox[{"\[ImaginaryI]", " ", "DD"}]}]]}], "]"}]}], "-", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"A", "-", 
           RowBox[{"\[ImaginaryI]", " ", "B"}]}], 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"b", "-", "p"}], ")"}], "2"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"a", "+", "q"}], ")"}], "2"]}]], ")"}], 
        FractionBox["m", "2"]], 
       RowBox[{"BesselI", "[", 
        RowBox[{"m", ",", 
         SqrtBox[
          RowBox[{"CC", "+", 
           RowBox[{"\[ImaginaryI]", " ", "DD"}]}]]}], "]"}]}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"exx", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{"expr", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"q", "\[Rule]", "0"}], ",", 
       RowBox[{"p", "\[Rule]", "0"}]}], "}"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", ">", "0"}], ",", 
      RowBox[{"b", ">", "0"}]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"derq", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"D", "[", 
      RowBox[{"expr", ",", "q"}], "]"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"q", "\[Rule]", "0"}], ",", 
       RowBox[{"p", "\[Rule]", "0"}]}], "}"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", ">", "0"}], ",", 
      RowBox[{"b", ">", "0"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.480778778426*^9, 3.480778890209*^9}, {3.480778984972*^9,
   3.480779083124*^9}, {3.4807793742679996`*^9, 3.480779382066*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"a", ",", "b", ",", "y", ",", "m"}], "]"}], ";", 
  RowBox[{"a", "=", 
   RowBox[{"Cos", "[", "y", "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"Sin", "[", "y", "]"}]}], ";", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{"exx", "/.", 
     RowBox[{"m", "\[Rule]", "4"}]}], ",", 
    RowBox[{"y", ">", "0"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.480780827696*^9, 3.480780837667*^9}, {3.480780878257*^9,
   3.480780881737*^9}, {3.480781993801*^9, 3.480782008784*^9}, {
  3.480782065677*^9, 3.480782166208*^9}, {3.4807822165810003`*^9, 
  3.4807822226289997`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"Cos", "[", "y", "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"Sin", "[", "y", "]"}]}], ";", 
  RowBox[{"m", "=", "6"}], ";", 
  RowBox[{"y", "=", "1."}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"InputForm", "[", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{"Sin", "[", 
      RowBox[{
       RowBox[{"a", " ", 
        RowBox[{"Cos", "[", "x", "]"}]}], "+", 
       RowBox[{"b", " ", 
        RowBox[{"Sin", "[", "x", "]"}]}], "-", 
       RowBox[{"m", " ", "x"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"InputForm", "[", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{"Sin", "[", 
      RowBox[{
       RowBox[{"a", " ", 
        RowBox[{"Cos", "[", "x", "]"}]}], "+", 
       RowBox[{"b", " ", 
        RowBox[{"Sin", "[", "x", "]"}]}], "-", 
       RowBox[{"m", " ", "x"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "\[Pi]"}], "}"}]}], "]"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"InputForm", "[", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], 
     RowBox[{
      FractionBox["m", "2"], "+", "1"}]], "2", " ", "\[Pi]", " ", 
    RowBox[{"BesselJ", "[", 
     RowBox[{"m", ",", "1"}], "]"}], " ", 
    RowBox[{"Sin", "[", 
     RowBox[{"m", " ", "y"}], "]"}]}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.480781371926*^9, 3.480781439283*^9}, {3.480781470625*^9,
   3.480781471193*^9}, {3.480781827165*^9, 3.480781952238*^9}, {
  3.480782044841*^9, 3.4807820630950003`*^9}, {3.4807822330299997`*^9, 
  3.480782256781*^9}}],

Cell[BoxData[{
 RowBox[{"TrigExpand", "[", 
  RowBox[{"Cos", "[", 
   RowBox[{"x", "-", "y"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", "y", "]"}], ";", 
  RowBox[{"Clear", "[", 
   RowBox[{"m", ",", "a", ",", "b"}], "]"}], ";", 
  RowBox[{"a", "=", 
   RowBox[{"Cos", "[", "y", "]"}]}], ";", 
  RowBox[{"b", "=", 
   RowBox[{"Sin", "[", "y", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"FullSimplify", "[", 
  RowBox[{"Sin", "[", 
   RowBox[{
    RowBox[{"a", " ", 
     RowBox[{"Cos", "[", "x", "]"}]}], "+", 
    RowBox[{"b", " ", 
     RowBox[{"Sin", "[", "x", "]"}]}], "-", 
    RowBox[{"m", " ", "x"}]}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.480780743152*^9, 3.4807808137650003`*^9}, {
  3.480781979427*^9, 3.480781982347*^9}, {3.480782390021*^9, 
  3.480782393843*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"2", " ", "\[Pi]", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], 
     RowBox[{
      FractionBox["m", "2"], "+", "1"}]], 
    RowBox[{"BesselJ", "[", 
     RowBox[{"m", ",", "1"}], "]"}], 
    RowBox[{"Sin", "[", 
     RowBox[{"m", " ", "y"}], "]"}]}], "\[Rule]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], 
      RowBox[{"Sin", "[", 
       RowBox[{"m", " ", "y"}], "]"}], 
      RowBox[{
       SubsuperscriptBox["\[Integral]", "0", "\[Pi]"], 
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"Cos", "[", "x", "]"}], "]"}], " ", 
        RowBox[{"Cos", "[", 
         RowBox[{"m", " ", "x"}], "]"}], 
        RowBox[{"\[DifferentialD]", "x"}]}]}]}], "  ", "\[LeftArrow]", " ", 
     RowBox[{
      SubsuperscriptBox["\[Integral]", "0", 
       RowBox[{"2", "\[Pi]"}]], 
      RowBox[{
       RowBox[{"Sin", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "m"}], " ", "x"}], "+", 
         RowBox[{"Cos", "[", 
          RowBox[{"x", "-", "y"}], "]"}]}], "]"}], 
       RowBox[{"\[DifferentialD]", "x"}]}]}]}], "\[Rule]", 
    RowBox[{
     RowBox[{
      SubsuperscriptBox["\[Integral]", "y", 
       RowBox[{
        RowBox[{"2", "\[Pi]"}], "+", "y"}]], 
      RowBox[{
       RowBox[{"Sin", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "m"}], " ", "x"}], "-", "my", "+", 
         RowBox[{"Cos", "[", "x", "]"}]}], "]"}], 
       RowBox[{"\[DifferentialD]", "x"}]}]}], 
     RowBox[{"(*", 
      RowBox[{"x", "\[Rule]", 
       RowBox[{"x", "+", "y"}]}], "*)"}], "\[Rule]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"periodic", " ", "\[Implies]", " ", 
       RowBox[{
        RowBox[{"can", "'"}], "t", " ", "shift", " ", "the", " ", "limits", 
        " ", "of", " ", "integration"}]}], "*)"}], 
     RowBox[{
      RowBox[{
       SubsuperscriptBox["\[Integral]", "0", 
        RowBox[{"2", "\[Pi]"}]], 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "m"}], " ", "x"}], "-", "my", "+", 
          RowBox[{"Cos", "[", "x", "]"}]}], "]"}], 
        RowBox[{"\[DifferentialD]", "x"}]}]}], "\[Rule]", 
      RowBox[{
       RowBox[{
        SubsuperscriptBox["\[Integral]", "0", 
         RowBox[{"2", "\[Pi]"}]], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             RowBox[{"Cos", "[", 
              RowBox[{"m", " ", "x"}], "]"}]}], " ", 
            RowBox[{"Cos", "[", 
             RowBox[{"Cos", "[", "x", "]"}], "]"}], " ", 
            RowBox[{"Sin", "[", "my", "]"}]}], "-", 
           RowBox[{
            RowBox[{"Cos", "[", "my", "]"}], " ", 
            RowBox[{"Cos", "[", 
             RowBox[{"Cos", "[", "x", "]"}], "]"}], " ", 
            RowBox[{"Sin", "[", 
             RowBox[{"m", " ", "x"}], "]"}]}], "+", 
           RowBox[{
            RowBox[{"Cos", "[", "my", "]"}], " ", 
            RowBox[{"Cos", "[", 
             RowBox[{"m", " ", "x"}], "]"}], " ", 
            RowBox[{"Sin", "[", 
             RowBox[{"Cos", "[", "x", "]"}], "]"}]}], "-", 
           RowBox[{
            RowBox[{"Sin", "[", "my", "]"}], " ", 
            RowBox[{"Sin", "[", 
             RowBox[{"m", " ", "x"}], "]"}], " ", 
            RowBox[{"Sin", "[", 
             RowBox[{"Cos", "[", "x", "]"}], "]"}]}]}], ")"}], 
         RowBox[{"\[DifferentialD]", "x"}]}]}], "\[Rule]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         SubsuperscriptBox["\[Integral]", "0", 
          RowBox[{"2", "\[Pi]"}]], 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"Cos", "[", 
            RowBox[{"m", " ", "x"}], "]"}]}], " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"Cos", "[", "x", "]"}], "]"}], " ", 
          RowBox[{"Sin", "[", "my", "]"}], 
          RowBox[{"\[DifferentialD]", "x"}]}]}], 
        RowBox[{"(*", 
         RowBox[{"other", " ", "terms", " ", "are", " ", "zero"}], "*)"}], 
        "\[Rule]", 
        RowBox[{
         RowBox[{"-", "2"}], " ", 
         RowBox[{"Sin", "[", "my", "]"}], 
         RowBox[{
          SubsuperscriptBox["\[Integral]", "0", "\[Pi]"], 
          RowBox[{
           RowBox[{"Cos", "[", 
            RowBox[{"m", " ", "x"}], "]"}], " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"Cos", "[", "x", "]"}], "]"}], 
           RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]}]}]}]}]}], 
  RowBox[{"(*", 
   RowBox[{"from", " ", "symmetry"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubsuperscriptBox["\[Integral]", "0", "\[Pi]"], 
   RowBox[{
    RowBox[{"Sin", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "m"}], " ", "x"}], "+", 
      RowBox[{"Cos", "[", 
       RowBox[{"x", "-", "y"}], "]"}]}], "]"}], 
    RowBox[{"\[DifferentialD]", "x"}]}]}], " ", "\[Rule]", 
  RowBox[{
   RowBox[{
    SubsuperscriptBox["\[Integral]", "y", 
     RowBox[{"\[Pi]", "+", "y"}]], 
    RowBox[{
     RowBox[{"Sin", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "m"}], " ", "x"}], "-", "my", "+", 
       RowBox[{"Cos", "[", "x", "]"}]}], "]"}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}], "\[Rule]", " ", 
   RowBox[{
    RowBox[{
     SubsuperscriptBox["\[Integral]", "y", 
      RowBox[{"\[Pi]", "+", "y"}]], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Cos", "[", 
           RowBox[{"m", " ", "x"}], "]"}]}], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"Cos", "[", "x", "]"}], "]"}], " ", 
         RowBox[{"Sin", "[", "my", "]"}]}], "-", 
        RowBox[{
         RowBox[{"Cos", "[", "my", "]"}], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"Cos", "[", "x", "]"}], "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"m", " ", "x"}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"Cos", "[", "my", "]"}], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"m", " ", "x"}], "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"Cos", "[", "x", "]"}], "]"}]}], "-", 
        RowBox[{
         RowBox[{"Sin", "[", "my", "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"m", " ", "x"}], "]"}], " ", 
         RowBox[{"Sin", "[", 
          RowBox[{"Cos", "[", "x", "]"}], "]"}]}]}], ")"}], 
      RowBox[{"\[DifferentialD]", "x"}]}]}], "\[Rule]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      SubsuperscriptBox["\[Integral]", "0", "\[Pi]"], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Cos", "[", 
           RowBox[{"m", " ", "x"}], "]"}]}], " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"Cos", "[", "x", "]"}], "]"}], " ", 
         RowBox[{"Sin", "[", "my", "]"}]}], ")"}], 
       RowBox[{"\[DifferentialD]", "x"}]}]}], "+", 
     RowBox[{
      RowBox[{"Cos", "[", "my", "]"}], 
      RowBox[{
       SubsuperscriptBox["\[Integral]", "y", 
        RowBox[{"\[Pi]", "+", "y"}]], " ", 
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"m", " ", "x"}], "]"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"Cos", "[", "x", "]"}], "]"}], 
        RowBox[{"\[DifferentialD]", "x"}]}]}]}], "-", 
     RowBox[{
      RowBox[{"Sin", "[", "my", "]"}], 
      RowBox[{
       SubsuperscriptBox["\[Integral]", "y", 
        RowBox[{"\[Pi]", "+", "y"}]], " ", 
       RowBox[{
        RowBox[{"Sin", "[", 
         RowBox[{"m", " ", "x"}], "]"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"Cos", "[", "x", "]"}], "]"}], 
        RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]}]}]}]}], "Text",
 CellChangeTimes->{{3.480782532148*^9, 3.4807826346140003`*^9}, {
  3.480782667061*^9, 3.480782698116*^9}, {3.480782819148*^9, 
  3.4807828224440002`*^9}, {3.480787875618*^9, 3.480787950469*^9}, {
  3.480788003163*^9, 3.480788014602*^9}, {3.4807880589110003`*^9, 
  3.480788063752*^9}, {3.4807881099820004`*^9, 3.4807881412060003`*^9}, {
  3.480788173443*^9, 3.48078822204*^9}, {3.480788332608*^9, 
  3.480788409532*^9}, {3.480788493649*^9, 3.4807885203640003`*^9}, {
  3.48078857929*^9, 3.480788595289*^9}, {3.4807886375109997`*^9, 
  3.480788638047*^9}, {3.480788734825*^9, 3.480788772784*^9}, {
  3.480788826028*^9, 3.480788842116*^9}, {3.480788893865*^9, 
  3.480788916832*^9}}],

Cell[BoxData[{
 RowBox[{"TrigExpand", "[", 
  RowBox[{"Sin", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "m"}], " ", "x"}], "-", "my", "+", 
    RowBox[{"Cos", "[", "x", "]"}]}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xoxo", "=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Cos", "[", 
        RowBox[{"m", " ", "x"}], "]"}]}], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"Cos", "[", "x", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", "my", "]"}]}], "-", 
     RowBox[{
      RowBox[{"Cos", "[", "my", "]"}], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"Cos", "[", "x", "]"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"m", " ", "x"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"Cos", "[", "my", "]"}], " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"m", " ", "x"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"Cos", "[", "x", "]"}], "]"}]}], "-", 
     RowBox[{
      RowBox[{"Sin", "[", "my", "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"m", " ", "x"}], "]"}], " ", 
      RowBox[{"Sin", "[", 
       RowBox[{"Cos", "[", "x", "]"}], "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"xoxo", "[", 
       RowBox[{"[", "#", "]"}], "]"}], "/.", 
      RowBox[{"m", "\[Rule]", "2"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}], "&"}], "/@", 
  RowBox[{"Range", "[", "4", "]"}]}]}], "Input",
 CellChangeTimes->{{3.480787967083*^9, 3.48078797201*^9}, {3.480788249667*^9, 
  3.480788299307*^9}}],

Cell[BoxData[
 RowBox[{"Sin", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "m"}], " ", "x"}], "+", 
   RowBox[{"Cos", "[", 
    RowBox[{"x", "-", "y"}], "]"}]}], "]"}]], "Input"],

Cell[BoxData[{
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Sin", "[", 
      RowBox[{"m", " ", "x"}], "]"}], " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"Cos", "[", "x", "]"}], "]"}]}], "/.", 
    RowBox[{"m", "\[Rule]", "2"}]}], ",", "x"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Cos", "[", 
      RowBox[{"m", " ", "x"}], "]"}], " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"Cos", "[", "x", "]"}], "]"}]}], "/.", 
    RowBox[{"m", "\[Rule]", "2"}]}], ",", "x"}], "]"}]}], "Input",
 CellChangeTimes->{{3.480789045241*^9, 3.4807890911549997`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"z", "=", "0.4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Cos", "[", 
      RowBox[{"Cos", "[", "x", "]"}], "]"}], " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"m", " ", "x"}], "]"}]}], "/.", 
    RowBox[{"m", "\[Rule]", "2"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"0", "+", "z"}], ",", 
     RowBox[{"\[Pi]", "+", "z"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Cos", "[", 
      RowBox[{"Cos", "[", "x", "]"}], "]"}], " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"m", " ", "x"}], "]"}]}], "/.", 
    RowBox[{"m", "\[Rule]", "2"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"0", "+", "z"}], ",", 
     RowBox[{"\[Pi]", "+", "z"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Cos", "[", 
      RowBox[{"Sin", "[", "x", "]"}], "]"}], " ", 
     RowBox[{"Sin", "[", 
      RowBox[{"m", " ", "x"}], "]"}]}], "/.", 
    RowBox[{"m", "\[Rule]", "2"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"0", "+", "z"}], ",", 
     RowBox[{"\[Pi]", "+", "z"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Cos", "[", 
      RowBox[{"Sin", "[", "x", "]"}], "]"}], " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"m", " ", "x"}], "]"}]}], "/.", 
    RowBox[{"m", "\[Rule]", "2"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"0", "+", "z"}], ",", 
     RowBox[{"\[Pi]", "+", "z"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Sin", "[", 
      RowBox[{"Cos", "[", "x", "]"}], "]"}], " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"m", " ", "x"}], "]"}]}], "/.", 
    RowBox[{"m", "\[Rule]", "2"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"0", "+", "z"}], ",", 
     RowBox[{"\[Pi]", "+", "z"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Sin", "[", 
      RowBox[{"Cos", "[", "x", "]"}], "]"}], 
     RowBox[{"Sin", "[", 
      RowBox[{"m", " ", "x"}], "]"}]}], "/.", 
    RowBox[{"m", "\[Rule]", "2"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"0", "+", "z"}], ",", 
     RowBox[{"\[Pi]", "+", "z"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.480786613954*^9, 3.480786636689*^9}, {
  3.4807876689110003`*^9, 3.4807877043*^9}, {3.480787808535*^9, 
  3.480787820928*^9}, {3.480788020582*^9, 3.480788049035*^9}, {
  3.480788079909*^9, 3.480788104368*^9}, {3.4807886142980003`*^9, 
  3.480788620834*^9}, {3.4807886514*^9, 3.480788689644*^9}, {
  3.480788725427*^9, 3.480788725642*^9}, {3.480788786245*^9, 
  3.480788818782*^9}, {3.4807888520810003`*^9, 3.480788885834*^9}, {
  3.480789325171*^9, 3.480789325609*^9}}],

Cell[BoxData[{
 RowBox[{
  SubsuperscriptBox["\[Integral]", "0", "\[Pi]"], 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"\[ImaginaryI]", " ", 
     RowBox[{"Cos", "[", "x", "]"}]}]], " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"2", " ", "x"}], "]"}], 
   RowBox[{"\[DifferentialD]", "x"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubsuperscriptBox["\[Integral]", "0", "\[Pi]"], 
  RowBox[{
   RowBox[{"Cos", "[", 
    RowBox[{"Cos", "[", "x", "]"}], "]"}], " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"2", " ", "x"}], "]"}], 
   RowBox[{"\[DifferentialD]", "x"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"\[ImaginaryI]", 
  RowBox[{
   SubsuperscriptBox["\[Integral]", "0", "\[Pi]"], 
   RowBox[{
    RowBox[{"Sin", "[", 
     RowBox[{"Cos", "[", "x", "]"}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"2", " ", "x"}], "]"}], 
    RowBox[{"\[DifferentialD]", "x"}]}]}]}]}], "Input",
 CellChangeTimes->{{3.4807827406549997`*^9, 3.4807828074119997`*^9}}],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"-", "1"}], ")"}], 
    RowBox[{
     FractionBox["m", "2"], "+", "1"}]], 
   SuperscriptBox["\[ImaginaryI]", 
    RowBox[{"-", "m"}]]}], "]"}]], "Input",
 CellChangeTimes->{{3.480782595799*^9, 3.480782597767*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BesselJ", "[", 
    RowBox[{"n", ",", "z"}], "]"}], "\[Equal]", 
   RowBox[{
    FractionBox[
     SuperscriptBox["\[ImaginaryI]", 
      RowBox[{"-", "n"}]], "\[Pi]"], 
    RowBox[{
     SubsuperscriptBox["\[Integral]", "0", "\[Pi]"], 
     RowBox[{
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"\[ImaginaryI]", " ", "z", " ", 
         RowBox[{"Cos", "[", "t", "]"}]}]], " ", 
       RowBox[{"Cos", "[", 
        RowBox[{"n", " ", "t"}], "]"}]}], 
      RowBox[{"\[DifferentialD]", "t"}]}]}]}]}], "/;", 
  RowBox[{
   RowBox[{"Element", "[", 
    RowBox[{"n", ",", "Integers"}], "]"}], "\[And]", 
   RowBox[{"n", ">", "0"}]}]}]]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ff", "[", "B_", "]"}], ":=", 
  RowBox[{"NIntegrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Sin", "[", 
      RowBox[{"(", 
       RowBox[{"B", " ", 
        RowBox[{"Cos", "[", "\[Theta]", "]"}]}], ")"}], "]"}], 
     RowBox[{"Cos", "[", "\[Theta]", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Theta]", ",", "0", ",", "\[Pi]"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Exp", "[", 
     RowBox[{"\[ImaginaryI]", 
      RowBox[{"(", 
       RowBox[{"B", " ", 
        RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ")"}]}], "]"}], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Theta]", ",", "0", ",", "\[Pi]"}], "}"}], ",", 
   RowBox[{"GenerateConditions", "\[Rule]", "False"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Exp", "[", 
     RowBox[{"\[ImaginaryI]", 
      RowBox[{"(", 
       RowBox[{"A", " ", 
        RowBox[{"Cos", "[", "\[Theta]", "]"}]}], ")"}]}], "]"}], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Theta]", ",", "0", ",", "\[Pi]"}], "}"}], ",", 
   RowBox[{"GenerateConditions", "\[Rule]", "False"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.4807746424700003`*^9, 3.480774649085*^9}, {
  3.480774781847*^9, 3.480774794134*^9}, {3.480775666166*^9, 
  3.4807757200889997`*^9}, {3.480775757671*^9, 3.480775803141*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Polarized radiative transfer", "Section",
 CellChangeTimes->{{3.476803574991*^9, 3.476803581406*^9}}],

Cell[CellGroupData[{

Cell["Q, U \[Rule] amplitude & angle", "Subsection",
 CellChangeTimes->{{3.476811135362*^9, 3.476811146153*^9}}],

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"fullsys", "=", 
    RowBox[{"FullSimplify", "[", 
     RowBox[{"Thread", "[", 
      RowBox[{
       RowBox[{"D", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Ic", "[", "s", "]"}], ",", 
           RowBox[{"Qc", "[", "s", "]"}], ",", 
           RowBox[{"Uc", "[", "s", "]"}], ",", 
           RowBox[{"Vc", "[", "s", "]"}]}], "}"}], ",", "s"}], "]"}], 
       "\[Equal]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"jIc", ",", 
           RowBox[{"jQc", " ", 
            RowBox[{"Cos", "[", 
             RowBox[{"2", 
              RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", 
           RowBox[{"jQc", " ", 
            RowBox[{"Sin", "[", 
             RowBox[{"2", 
              RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", "jVc"}], 
          "}"}], "+", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "\[Alpha]Ic"}], ",", 
              RowBox[{
               RowBox[{"-", "\[Alpha]Qc"}], " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", 
                 RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", 
              RowBox[{
               RowBox[{"-", "\[Alpha]Qc"}], " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"2", 
                 RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", 
              RowBox[{"-", "\[Alpha]Vc"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "\[Alpha]Qc"}], " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", 
                 RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", 
              RowBox[{"-", "\[Alpha]Ic"}], ",", 
              RowBox[{"-", "\[Rho]Vc"}], ",", 
              RowBox[{"\[Rho]Qc", " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"2", 
                 RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "\[Alpha]Qc"}], " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"2", 
                 RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", 
              "\[Rho]Vc", ",", 
              RowBox[{"-", "\[Alpha]Ic"}], ",", 
              RowBox[{
               RowBox[{"-", "\[Rho]Qc"}], " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", 
                 RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "\[Alpha]Vc"}], ",", 
              RowBox[{
               RowBox[{"-", "\[Rho]Qc"}], " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"2", 
                 RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", 
              RowBox[{"\[Rho]Qc", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"2", 
                 RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", 
              RowBox[{"-", "\[Alpha]Ic"}]}], "}"}]}], "}"}], ".", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Ic", "[", "s", "]"}], ",", 
            RowBox[{"Qc", "[", "s", "]"}], ",", 
            RowBox[{"Uc", "[", "s", "]"}], ",", 
            RowBox[{"Vc", "[", "s", "]"}]}], "}"}]}]}], ")"}]}], "]"}], 
     "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.47680358244*^9, 3.476803582639*^9}, {3.476803816884*^9, 
  3.47680382263*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"I", "'"}], "[", "s", "]"}], "==", 
     RowBox[{"det", "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"jIc", "/", "fr"}], "/", "fr"}], "+", 
        RowBox[{"fr", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "aIc"}], "*", 
            RowBox[{"yyy", "[", "0", "]"}]}], "-", 
           RowBox[{"aQc", "*", "cos2k", "*", 
            RowBox[{"yyy", "[", "1", "]"}]}], "-", 
           RowBox[{"aQc", "*", "sin2k", "*", 
            RowBox[{"yyy", "[", "2", "]"}]}], "-", 
           RowBox[{"aVc", "*", 
            RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], "}"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Q", "'"}], "[", "s", "]"}], "==", 
     RowBox[{"det", "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"cos2k", "*", "jQc"}], ")"}], "/", "fr"}], "/", "fr"}], 
        "+", 
        RowBox[{"fr", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{"aQc", "*", "cos2k", "*", 
              RowBox[{"yyy", "[", "0", "]"}]}], ")"}]}], "-", 
           RowBox[{"aIc", "*", 
            RowBox[{"yyy", "[", "1", "]"}]}], "-", 
           RowBox[{"rVc", "*", 
            RowBox[{"yyy", "[", "2", "]"}]}], "+", 
           RowBox[{"rQc", "*", "sin2k", "*", 
            RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], "}"}], 
   ",", "\n", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"U", "'"}], "[", "s", "]"}], "==", 
     RowBox[{"det", "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"jQc", "*", "sin2k"}], ")"}], "/", "fr"}], "/", "fr"}], 
        "+", 
        RowBox[{"fr", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{"aQc", "*", "sin2k", "*", 
              RowBox[{"yyy", "[", "0", "]"}]}], ")"}]}], "+", 
           RowBox[{"rVc", "*", 
            RowBox[{"yyy", "[", "1", "]"}]}], "-", 
           RowBox[{"aIc", "*", 
            RowBox[{"yyy", "[", "2", "]"}]}], "-", 
           RowBox[{"cos2k", "*", "rQc", "*", 
            RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], "}"}], 
   ",", "\n", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"V", "'"}], "[", "s", "]"}], "==", 
     RowBox[{"det", "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"jVc", "/", "fr"}], "/", "fr"}], "+", 
        RowBox[{"fr", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{"aVc", "*", 
              RowBox[{"yyy", "[", "0", "]"}]}], ")"}]}], "-", 
           RowBox[{"rQc", "*", "sin2k", "*", 
            RowBox[{"yyy", "[", "1", "]"}]}], "+", 
           RowBox[{"cos2k", "*", "rQc", "*", 
            RowBox[{"yyy", "[", "2", "]"}]}], "-", 
           RowBox[{"aIc", "*", 
            RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], "}"}]}],
   "}"}]], "Input",
 CellChangeTimes->{{3.4768040011210003`*^9, 3.4768040259709997`*^9}, {
  3.476804065111*^9, 3.4768041118120003`*^9}, {3.476804290594*^9, 
  3.476804293659*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"subyy", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"yyy", "[", "1", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"IQ", "[", "s", "]"}], "*", 
       RowBox[{"Cos", "[", 
        RowBox[{"q\[Phi]", "[", "s", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"yyy", "[", "2", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"IQ", "[", "s", "]"}], "*", 
       RowBox[{"Sin", "[", 
        RowBox[{"q\[Phi]", "[", "s", "]"}], "]"}]}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"subff", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"ff", "[", "1", "]"}], "\[Rule]", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"yyy", "[", "1", "]"}], "/.", "subyy"}], ",", "s"}], "]"}]}],
      ",", 
     RowBox[{
      RowBox[{"ff", "[", "2", "]"}], "\[Rule]", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"yyy", "[", "2", "]"}], "/.", "subyy"}], ",", "s"}], 
       "]"}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"sub", "=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"{", 
    RowBox[{"subyy", ",", "subff"}], "}"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.47680433087*^9, 3.476804417494*^9}, {3.476804541712*^9, 
  3.476804603244*^9}, {3.4768046425220003`*^9, 3.4768046818310003`*^9}}],

Cell[BoxData[
 RowBox[{"sys", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ff", "[", "0", "]"}], "==", 
      RowBox[{"det", "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"jIc", "/", "fr"}], "/", "fr"}], "+", 
         RowBox[{"fr", "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "aIc"}], "*", 
             RowBox[{"yyy", "[", "0", "]"}]}], "-", 
            RowBox[{"aQc", "*", "cos2k", "*", 
             RowBox[{"yyy", "[", "1", "]"}]}], "-", 
            RowBox[{"aQc", "*", "sin2k", "*", 
             RowBox[{"yyy", "[", "2", "]"}]}], "-", 
            RowBox[{"aVc", "*", 
             RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ff", "[", "1", "]"}], "==", 
      RowBox[{"det", "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"cos2k", "*", "jQc"}], ")"}], "/", "fr"}], "/", "fr"}], 
         "+", 
         RowBox[{"fr", "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"(", 
              RowBox[{"aQc", "*", "cos2k", "*", 
               RowBox[{"yyy", "[", "0", "]"}]}], ")"}]}], "-", 
            RowBox[{"aIc", "*", 
             RowBox[{"yyy", "[", "1", "]"}]}], "-", 
            RowBox[{"rVc", "*", 
             RowBox[{"yyy", "[", "2", "]"}]}], "+", 
            RowBox[{"rQc", "*", "sin2k", "*", 
             RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], "}"}], 
    ",", "\n", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ff", "[", "2", "]"}], "==", 
      RowBox[{"det", "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"jQc", "*", "sin2k"}], ")"}], "/", "fr"}], "/", "fr"}], 
         "+", 
         RowBox[{"fr", "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"(", 
              RowBox[{"aQc", "*", "sin2k", "*", 
               RowBox[{"yyy", "[", "0", "]"}]}], ")"}]}], "+", 
            RowBox[{"rVc", "*", 
             RowBox[{"yyy", "[", "1", "]"}]}], "-", 
            RowBox[{"aIc", "*", 
             RowBox[{"yyy", "[", "2", "]"}]}], "-", 
            RowBox[{"cos2k", "*", "rQc", "*", 
             RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], "}"}], 
    ",", "\n", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ff", "[", "3", "]"}], "==", 
      RowBox[{"det", "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"jVc", "/", "fr"}], "/", "fr"}], "+", 
         RowBox[{"fr", "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"(", 
              RowBox[{"aVc", "*", 
               RowBox[{"yyy", "[", "0", "]"}]}], ")"}]}], "-", 
            RowBox[{"rQc", "*", "sin2k", "*", 
             RowBox[{"yyy", "[", "1", "]"}]}], "+", 
            RowBox[{"cos2k", "*", "rQc", "*", 
             RowBox[{"yyy", "[", "2", "]"}]}], "-", 
            RowBox[{"aIc", "*", 
             RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], 
     "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.476804299809*^9, 3.4768043245360003`*^9}, {
  3.476804704705*^9, 3.476804705137*^9}}],

Cell[BoxData[
 RowBox[{"InputForm", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Flatten", "[", 
       RowBox[{"sys", "/.", "sub"}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{
      RowBox[{"Flatten", "[", 
       RowBox[{"sys", "/.", "sub"}], "]"}], "[", 
      RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"IQ", "[", "s", "]"}], "\[Rule]", 
      RowBox[{"yyy", "[", "1", "]"}]}], ",", 
     RowBox[{
      RowBox[{"Sin", "[", 
       RowBox[{"q\[Phi]", "[", "s", "]"}], "]"}], "\[Rule]", "sinqs"}], ",", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q\[Phi]", "[", "s", "]"}], "]"}], "\[Rule]", "cosqs"}]}], 
    "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.476805874545*^9, 3.476805929895*^9}, {3.476806367966*^9,
   3.476806376205*^9}}],

Cell[BoxData[
 RowBox[{"soll", "=", 
  RowBox[{
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{"sys", "/.", "sub"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"2", ";;", "3"}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"IQ", "'"}], "[", "s", "]"}], ",", 
         RowBox[{
          RowBox[{"q\[Phi]", "'"}], "[", "s", "]"}]}], "}"}]}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"IQ", "[", "s", "]"}], "\[Rule]", 
      RowBox[{"yyy", "[", "1", "]"}]}], ",", 
     RowBox[{
      RowBox[{"Sin", "[", 
       RowBox[{"q\[Phi]", "[", "s", "]"}], "]"}], "\[Rule]", "sinqs"}], ",", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q\[Phi]", "[", "s", "]"}], "]"}], "\[Rule]", "cosqs"}]}], 
    "}"}]}]}]], "Input",
 CellChangeTimes->{{3.4768047138900003`*^9, 3.4768047243789997`*^9}, {
  3.47680477776*^9, 3.476804842277*^9}, {3.476804905994*^9, 
  3.476804906585*^9}, {3.476805157091*^9, 3.476805184106*^9}, {
  3.476805224617*^9, 3.476805241743*^9}, {3.4768064714890003`*^9, 
  3.476806471617*^9}, {3.476806547396*^9, 3.476806552244*^9}, {
  3.476806587778*^9, 3.47680661*^9}}],

Cell[BoxData[
 RowBox[{"InputForm", "[", 
  RowBox[{
   RowBox[{"Collect", "[", 
    RowBox[{"soll", ",", "fr"}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"IQ", "'"}], "[", "s", "]"}], "\[Rule]", 
      RowBox[{"ff", "[", "1", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"q\[Phi]", "'"}], "[", "s", "]"}], "\[Rule]", 
      RowBox[{"ff", "[", "2", "]"}]}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.476804908983*^9, 3.4768049372790003`*^9}, {
  3.476805068057*^9, 3.476805069023*^9}, {3.476805295506*^9, 3.476805336*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Q, U, V \[Rule] amplitude & 2 angles", "Subsection",
 CellChangeTimes->{{3.476811182927*^9, 3.476811195142*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"fullsys", "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Ic", "[", "s", "]"}], ",", 
          RowBox[{"Qc", "[", "s", "]"}], ",", 
          RowBox[{"Uc", "[", "s", "]"}], ",", 
          RowBox[{"Vc", "[", "s", "]"}]}], "}"}], ",", "s"}], "]"}], 
      "\[Equal]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"jIc", ",", 
          RowBox[{"jQc", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"2", 
             RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", 
          RowBox[{"jQc", " ", 
           RowBox[{"Sin", "[", 
            RowBox[{"2", 
             RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", "jVc"}], 
         "}"}], "+", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "\[Alpha]Ic"}], ",", 
             RowBox[{
              RowBox[{"-", "\[Alpha]Qc"}], " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"2", 
                RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", 
             RowBox[{
              RowBox[{"-", "\[Alpha]Qc"}], " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"2", 
                RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", 
             RowBox[{"-", "\[Alpha]Vc"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "\[Alpha]Qc"}], " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"2", 
                RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", 
             RowBox[{"-", "\[Alpha]Ic"}], ",", 
             RowBox[{"-", "\[Rho]Vc"}], ",", 
             RowBox[{"\[Rho]Qc", " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"2", 
                RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "\[Alpha]Qc"}], " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"2", 
                RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", "\[Rho]Vc",
              ",", 
             RowBox[{"-", "\[Alpha]Ic"}], ",", 
             RowBox[{
              RowBox[{"-", "\[Rho]Qc"}], " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"2", 
                RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "\[Alpha]Vc"}], ",", 
             RowBox[{
              RowBox[{"-", "\[Rho]Qc"}], " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"2", 
                RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", 
             RowBox[{"\[Rho]Qc", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"2", 
                RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", 
             RowBox[{"-", "\[Alpha]Ic"}]}], "}"}]}], "}"}], ".", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Ic", "[", "s", "]"}], ",", 
           RowBox[{"Qc", "[", "s", "]"}], ",", 
           RowBox[{"Uc", "[", "s", "]"}], ",", 
           RowBox[{"Vc", "[", "s", "]"}]}], "}"}]}]}], ")"}]}], "]"}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.47680358244*^9, 3.476803582639*^9}, {3.476803816884*^9, 
   3.47680382263*^9}, 3.4768112019890003`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"I", "'"}], "[", "s", "]"}], "==", 
     RowBox[{"det", "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"jIc", "/", "fr"}], "/", "fr"}], "+", 
        RowBox[{"fr", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "aIc"}], "*", 
            RowBox[{"yyy", "[", "0", "]"}]}], "-", 
           RowBox[{"aQc", "*", "cos2k", "*", 
            RowBox[{"yyy", "[", "1", "]"}]}], "-", 
           RowBox[{"aQc", "*", "sin2k", "*", 
            RowBox[{"yyy", "[", "2", "]"}]}], "-", 
           RowBox[{"aVc", "*", 
            RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], "}"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Q", "'"}], "[", "s", "]"}], "==", 
     RowBox[{"det", "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"cos2k", "*", "jQc"}], ")"}], "/", "fr"}], "/", "fr"}], 
        "+", 
        RowBox[{"fr", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{"aQc", "*", "cos2k", "*", 
              RowBox[{"yyy", "[", "0", "]"}]}], ")"}]}], "-", 
           RowBox[{"aIc", "*", 
            RowBox[{"yyy", "[", "1", "]"}]}], "-", 
           RowBox[{"rVc", "*", 
            RowBox[{"yyy", "[", "2", "]"}]}], "+", 
           RowBox[{"rQc", "*", "sin2k", "*", 
            RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], "}"}], 
   ",", "\n", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"U", "'"}], "[", "s", "]"}], "==", 
     RowBox[{"det", "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"jQc", "*", "sin2k"}], ")"}], "/", "fr"}], "/", "fr"}], 
        "+", 
        RowBox[{"fr", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{"aQc", "*", "sin2k", "*", 
              RowBox[{"yyy", "[", "0", "]"}]}], ")"}]}], "+", 
           RowBox[{"rVc", "*", 
            RowBox[{"yyy", "[", "1", "]"}]}], "-", 
           RowBox[{"aIc", "*", 
            RowBox[{"yyy", "[", "2", "]"}]}], "-", 
           RowBox[{"cos2k", "*", "rQc", "*", 
            RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], "}"}], 
   ",", "\n", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"V", "'"}], "[", "s", "]"}], "==", 
     RowBox[{"det", "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"jVc", "/", "fr"}], "/", "fr"}], "+", 
        RowBox[{"fr", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{"aVc", "*", 
              RowBox[{"yyy", "[", "0", "]"}]}], ")"}]}], "-", 
           RowBox[{"rQc", "*", "sin2k", "*", 
            RowBox[{"yyy", "[", "1", "]"}]}], "+", 
           RowBox[{"cos2k", "*", "rQc", "*", 
            RowBox[{"yyy", "[", "2", "]"}]}], "-", 
           RowBox[{"aIc", "*", 
            RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], "}"}]}],
   "}"}]], "Input",
 CellChangeTimes->{{3.4768040011210003`*^9, 3.4768040259709997`*^9}, {
  3.476804065111*^9, 3.4768041118120003`*^9}, {3.476804290594*^9, 
  3.476804293659*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"subyy", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"yyy", "[", "1", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"IQ", "[", "s", "]"}], "*", 
       RowBox[{"Cos", "[", 
        RowBox[{"q\[Phi]", "[", "s", "]"}], "]"}], 
       RowBox[{"Sin", "[", 
        RowBox[{"qth", "[", "s", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"yyy", "[", "2", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"IQ", "[", "s", "]"}], "*", 
       RowBox[{"Sin", "[", 
        RowBox[{"q\[Phi]", "[", "s", "]"}], "]"}], 
       RowBox[{"Sin", "[", 
        RowBox[{"qth", "[", "s", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"yyy", "[", "3", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"IQ", "[", "s", "]"}], 
       RowBox[{"Cos", "[", 
        RowBox[{"qth", "[", "s", "]"}], "]"}]}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"subff", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"ff", "[", "1", "]"}], "\[Rule]", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"yyy", "[", "1", "]"}], "/.", "subyy"}], ",", "s"}], "]"}]}],
      ",", 
     RowBox[{
      RowBox[{"ff", "[", "2", "]"}], "\[Rule]", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"yyy", "[", "2", "]"}], "/.", "subyy"}], ",", "s"}], "]"}]}],
      ",", 
     RowBox[{
      RowBox[{"ff", "[", "3", "]"}], "\[Rule]", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"yyy", "[", "3", "]"}], "/.", "subyy"}], ",", "s"}], 
       "]"}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"sub", "=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"{", 
    RowBox[{"subyy", ",", "subff"}], "}"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.47680433087*^9, 3.476804417494*^9}, {3.476804541712*^9, 
  3.476804603244*^9}, {3.4768046425220003`*^9, 3.4768046818310003`*^9}, {
  3.476811213361*^9, 3.476811216256*^9}, {3.476811376017*^9, 
  3.476811427014*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"sys", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ff", "[", "0", "]"}], "==", 
       RowBox[{"det", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"jIc", "/", "fr"}], "/", "fr"}], "+", 
          RowBox[{"fr", "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "aIc"}], "*", 
              RowBox[{"yyy", "[", "0", "]"}]}], "-", 
             RowBox[{"aQc", "*", "cos2k", "*", 
              RowBox[{"yyy", "[", "1", "]"}]}], "-", 
             RowBox[{"aQc", "*", "sin2k", "*", 
              RowBox[{"yyy", "[", "2", "]"}]}], "-", 
             RowBox[{"aVc", "*", 
              RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], "}"}],
      ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ff", "[", "1", "]"}], "==", 
       RowBox[{"det", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"cos2k", "*", "jQc"}], ")"}], "/", "fr"}], "/", "fr"}], 
          "+", 
          RowBox[{"fr", "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"(", 
               RowBox[{"aQc", "*", "cos2k", "*", 
                RowBox[{"yyy", "[", "0", "]"}]}], ")"}]}], "-", 
             RowBox[{"aIc", "*", 
              RowBox[{"yyy", "[", "1", "]"}]}], "-", 
             RowBox[{"rVc", "*", 
              RowBox[{"yyy", "[", "2", "]"}]}], "+", 
             RowBox[{"rQc", "*", "sin2k", "*", 
              RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], "}"}],
      ",", "\n", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ff", "[", "2", "]"}], "==", 
       RowBox[{"det", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"jQc", "*", "sin2k"}], ")"}], "/", "fr"}], "/", "fr"}], 
          "+", 
          RowBox[{"fr", "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"(", 
               RowBox[{"aQc", "*", "sin2k", "*", 
                RowBox[{"yyy", "[", "0", "]"}]}], ")"}]}], "+", 
             RowBox[{"rVc", "*", 
              RowBox[{"yyy", "[", "1", "]"}]}], "-", 
             RowBox[{"aIc", "*", 
              RowBox[{"yyy", "[", "2", "]"}]}], "-", 
             RowBox[{"cos2k", "*", "rQc", "*", 
              RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], "}"}],
      ",", "\n", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ff", "[", "3", "]"}], "==", 
       RowBox[{"det", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"jVc", "/", "fr"}], "/", "fr"}], "+", 
          RowBox[{"fr", "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"(", 
               RowBox[{"aVc", "*", 
                RowBox[{"yyy", "[", "0", "]"}]}], ")"}]}], "-", 
             RowBox[{"rQc", "*", "sin2k", "*", 
              RowBox[{"yyy", "[", "1", "]"}]}], "+", 
             RowBox[{"cos2k", "*", "rQc", "*", 
              RowBox[{"yyy", "[", "2", "]"}]}], "-", 
             RowBox[{"aIc", "*", 
              RowBox[{"yyy", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}]}], 
      "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.476804299809*^9, 3.4768043245360003`*^9}, {
   3.476804704705*^9, 3.476804705137*^9}, 3.47681150491*^9}],

Cell[BoxData[
 RowBox[{"InputForm", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Flatten", "[", 
     RowBox[{"sys", "/.", "sub"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"IQ", "[", "s", "]"}], "\[Rule]", 
      RowBox[{"yyy", "[", "1", "]"}]}], ",", 
     RowBox[{
      RowBox[{"Sin", "[", 
       RowBox[{"q\[Phi]", "[", "s", "]"}], "]"}], "\[Rule]", "sinqs"}], ",", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q\[Phi]", "[", "s", "]"}], "]"}], "\[Rule]", "cosqs"}], ",", 
     RowBox[{
      RowBox[{"Sin", "[", 
       RowBox[{"qth", "[", "s", "]"}], "]"}], "\[Rule]", "sinths"}], ",", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"qth", "[", "s", "]"}], "]"}], "\[Rule]", "cosths"}], ",", 
     RowBox[{
      FractionBox["1", 
       SuperscriptBox["fr", "2"]], "\[Rule]", 
      FractionBox["1", "frsq"]}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.476805874545*^9, 3.476805929895*^9}, {3.476806367966*^9,
   3.476806376205*^9}, {3.4768115389969997`*^9, 3.476811575667*^9}, {
  3.47681256021*^9, 3.476812560644*^9}}],

Cell[BoxData[
 RowBox[{"soll", "=", 
  RowBox[{
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{"sys", "/.", "sub"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"2", ";;", "4"}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"IQ", "'"}], "[", "s", "]"}], ",", 
         RowBox[{
          RowBox[{"q\[Phi]", "'"}], "[", "s", "]"}], ",", 
         RowBox[{
          RowBox[{"qth", "'"}], "[", "s", "]"}]}], "}"}]}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"IQ", "[", "s", "]"}], "\[Rule]", 
      RowBox[{"yyy", "[", "1", "]"}]}], ",", 
     RowBox[{
      RowBox[{"Sin", "[", 
       RowBox[{"q\[Phi]", "[", "s", "]"}], "]"}], "\[Rule]", "sinqs"}], ",", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"q\[Phi]", "[", "s", "]"}], "]"}], "\[Rule]", "cosqs"}], ",", 
     RowBox[{
      RowBox[{"Sin", "[", 
       RowBox[{"qth", "[", "s", "]"}], "]"}], "\[Rule]", "sinths"}], ",", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"qth", "[", "s", "]"}], "]"}], "\[Rule]", "cosths"}], ",", 
     RowBox[{
      RowBox[{"Csc", "[", 
       RowBox[{"qth", "[", "s", "]"}], "]"}], "\[Rule]", 
      FractionBox["1", "sinths"]}], ",", " ", 
     RowBox[{
      RowBox[{"Cot", "[", 
       RowBox[{"qth", "[", "s", "]"}], "]"}], "\[Rule]", 
      FractionBox["cosths", "sinths"]}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.4768047138900003`*^9, 3.4768047243789997`*^9}, {
  3.47680477776*^9, 3.476804842277*^9}, {3.476804905994*^9, 
  3.476804906585*^9}, {3.476805157091*^9, 3.476805184106*^9}, {
  3.476805224617*^9, 3.476805241743*^9}, {3.4768064714890003`*^9, 
  3.476806471617*^9}, {3.476806547396*^9, 3.476806552244*^9}, {
  3.476806587778*^9, 3.47680661*^9}, {3.47681159165*^9, 3.476811625953*^9}, {
  3.47681231749*^9, 3.4768123482320004`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{"soll", ",", "fr"}], "]"}], ",", "det"}], "]"}], "/.", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox["fr", "2"]], "\[Rule]", 
   FractionBox["1", "frsq"]}]}]], "Input",
 CellChangeTimes->{{3.476812441335*^9, 3.476812460855*^9}}],

Cell[BoxData[
 RowBox[{"InputForm", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{"Collect", "[", 
       RowBox[{"soll", ",", "fr"}], "]"}], ",", "det"}], "]"}], "/.", 
    RowBox[{
     FractionBox["1", 
      SuperscriptBox["fr", "2"]], "\[Rule]", 
     FractionBox["1", "frsq"]}]}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"IQ", "'"}], "[", "s", "]"}], "\[Rule]", 
      RowBox[{"ff", "[", "1", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"q\[Phi]", "'"}], "[", "s", "]"}], "\[Rule]", 
      RowBox[{"ff", "[", "2", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"qth", "'"}], "[", "s", "]"}], "\[Rule]", 
      RowBox[{"ff", "[", "3", "]"}]}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.476804908983*^9, 3.4768049372790003`*^9}, {
   3.476805068057*^9, 3.476805069023*^9}, {3.476805295506*^9, 
   3.476805336*^9}, {3.476811703491*^9, 3.476811732009*^9}, {3.47681204648*^9,
    3.476812100012*^9}, {3.476812221638*^9, 3.47681223259*^9}, 
   3.4768124298970003`*^9, {3.476812467599*^9, 3.476812468264*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Plots to paper Shcherbakov, Penna, McKinney (2010)", "Section",
 CellChangeTimes->{{3.476803550769*^9, 3.4768035575039997`*^9}, {
  3.485182032718*^9, 3.485182064683*^9}, {3.502020676723*^9, 
  3.5020206787530003`*^9}, {3.5291691109113417`*^9, 3.529169118622783*^9}, {
  3.581240078402495*^9, 3.581240081083499*^9}}],

Cell[CellGroupData[{

Cell["Averaging simulations", "Subsection",
 CellChangeTimes->{{3.520594508779814*^9, 3.5205945141421204`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fnum", "=", "6950"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{"\"\<E:\\\\mathematica\\\\3DMHD\\\\poliresa90th223fn\>\"", "<>", 
       RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", "6950", ",", "9950", ",", "300"}], "}"}]}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"pol", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", "4"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Mean", "[", "pol", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Exp", "[", 
  RowBox[{"Mean", "[", 
   RowBox[{"Log", "[", "pol", "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Median", "[", "pol", "]"}]}], "Input",
 CellChangeTimes->{{3.5205945666781254`*^9, 3.5205946598704557`*^9}, {
  3.5205951341535835`*^9, 3.5205951365377197`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Pi", "/", "2."}], "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", "*", "cas"}], "-", "1"}], ")"}], "/", "50"}]}], "/.", 
  RowBox[{"cas", "\[Rule]", "36"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Pi", "/", "2."}], "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", "*", "cas"}], "-", "1"}], ")"}], "/", "50"}]}], "/.", 
  RowBox[{"cas", "\[Rule]", "21"}]}]}], "Input",
 CellChangeTimes->{{3.5205104716766844`*^9, 3.520510478025895*^9}, {
  3.5205878016361876`*^9, 3.52058780640746*^9}, {3.5205901385378504`*^9, 
  3.5205901387848644`*^9}, {3.520597296753277*^9, 3.520597326264965*^9}, {
  3.5205976257480946`*^9, 3.5205976516475754`*^9}, {3.5206738276062007`*^9, 
  3.520673850307499*^9}, {3.5206738807022376`*^9, 3.5206738811912656`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "New data compilation (Figure 1) - ",
 StyleBox["done",
  FontColor->RGBColor[0, 0, 1]]
}], "Subsection",
 CellChangeTimes->{{3.485182037117*^9, 3.485182043756*^9}, {3.485182131384*^9,
   3.4851821317679996`*^9}, {3.4891537055335326`*^9, 
  3.4891537097143326`*^9}, {3.502627697578*^9, 3.5026276983199997`*^9}}],

Cell[CellGroupData[{

Cell["all linear - best", "Subsubsection",
 CellChangeTimes->{{3.5015902147060003`*^9, 3.501590215633*^9}, {
  3.5285077734068384`*^9, 3.528507777326062*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"her2cm", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\<Herrstein_2cm.xlsx\>\""}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"her13mm", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\<Herrstein_13mm.xlsx\>\""}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"her7mm", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\<Herrstein_7mm.xlsx\>\""}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dat2cm", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "her2cm", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"dat13mm", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "her13mm", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"dat7mm", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "her7mm", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5003970947264996`*^9, 3.5003971236084995`*^9}, {
   3.5003971612944994`*^9, 3.5003971908844995`*^9}, {3.5003973265894995`*^9, 
   3.5003973819054995`*^9}, 3.50100234726*^9, {3.501607540918*^9, 
   3.50160757331*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"F8", "=", 
   RowBox[{"{", 
    RowBox[{"0.73", ",", "0.59", ",", "0.72", ",", "0.69"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F15", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{"dat2cm", ",", 
      RowBox[{"{", 
       RowBox[{"1.1", ",", "0.81", ",", "1.03", ",", "0.92", ",", "0.94"}], 
       "}"}]}], "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F22", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{"dat13mm", ",", 
      RowBox[{"{", 
       RowBox[{
       "1.05", ",", "1.6", ",", "0.94", ",", "1.75", ",", "1.1", ",", "1.05", 
        ",", "1.06"}], "}"}]}], "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F43", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{"dat7mm", ",", 
      RowBox[{"{", 
       RowBox[{
       "1.03", ",", "1.1", " ", ",", "2.02", ",", " ", "1.9", ",", " ", 
        "1.92", ",", " ", "1.78", ",", "2.02", ",", " ", "1.59", ",", " ", 
        "1.99", ",", " ", "1.61", ",", " ", "1.86", " ", ",", "1.66", ",", 
        "1.45", ",", "1.07", ",", "2.3", ",", "1.4", ",", "1.6"}], "}"}]}], 
     "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F88", "=", 
   RowBox[{"{", 
    RowBox[{
    "1.715", ",", " ", "1.352", ",", " ", "2.374", ",", "1.73", ",", "1.2", 
     ",", " ", "1.6", ",", 
     RowBox[{"(*", 
      RowBox[{"3.5", ","}], "*)"}], "1.96", ",", " ", "1.97", ",", " ", 
     "1.69", ",", " ", "1.73", ",", " ", "2.18", ",", "1.8", ",", "1.4", ",", 
     "1.7", ",", " ", "2.2", ",", " ", "1.7", ",", "2.6", ",", "1.2", ",", 
     "2", ",", "2.1", ",", "2.4", ",", "1.9"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F102", "=", 
   RowBox[{"{", 
    RowBox[{
    "1.9", ",", " ", "1.4", " ", ",", "1.8", " ", ",", "1.7", ",", "1.2", ",",
      "2", " ", ",", "2.7", ",", " ", "1.9", ",", " ", "3", " ", ",", "1.2", 
     " ", ",", "1.5", ",", "2.1", ",", "2.4"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F145", "=", 
   RowBox[{"{", 
    RowBox[{
    "1.1", " ", ",", "2.2", ",", " ", "2", " ", ",", "3.6", ",", "2.5", ",", 
     " ", "2.1", ",", "2.9", ",", "1.8"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F230", "=", 
   RowBox[{"{", 
    RowBox[{
    "2", ",", "2.2", ",", "3.6", ",", "1.14", ",", "2.3", ",", " ", "2.7", 
     ",", " ", "2.3", ",", " ", "2.8", ",", " ", "2.6", ",", "2.4", ",", " ", 
     "2.1", ",", " ", "1.9", " ", ",", "2.15", ",", " ", "3.1", ",", " ", 
     "2.4", ",", "4.05", ",", " ", "3.3", ",", " ", "3.8", " ", ",", "1.9", 
     " ", ",", "2.5", ",", " ", "3", " ", ",", "2.5", ",", "0.7", ",", " ", 
     "1.23", ",", " ", "0.87", ",", " ", "1.52", ",", "3.43", ",", " ", 
     "3.86", ",", " ", "3.79", " ", ",", "3.79", " ", ",", "3.33", " ", ",", 
     "4.14", ",", "1.3", ",", " ", "2.5", ",", " ", "1.7", ",", " ", "1.8", 
     ",", "2.4", ",", "2.9", ",", " ", "3.4", ",", "4", ",", "3", ",", "2.8", 
     ",", "4.2"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F345", "=", 
   RowBox[{"{", 
    RowBox[{
    "4.18", " ", ",", "3.31", ",", " ", "2.98", ",", " ", "3.8", ",", "3.79", 
     ",", " ", "3.16", ",", " ", "3.2", " ", ",", "3.18", " ", ",", "2.75", 
     ",", " ", "3.02", ",", " ", "3.31", ",", "3", ",", "2.9", ",", "2.3", 
     ",", "2.83"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"F674", "=", 
   RowBox[{"{", 
    RowBox[{
    "2.9", " ", ",", "3", ",", " ", "3", ",", "3.8", ",", "2", " ", ",", 
     "3.3", " ", ",", "5"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"F857", "=", 
    RowBox[{"{", 
     RowBox[{"2.4", " ", ",", "3", ",", "3.2"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LP43", "=", 
   RowBox[{"{", 
    RowBox[{"0.33", ",", "0.77"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LP88", "=", 
   RowBox[{"{", 
    RowBox[{"1.01", ",", "0.7", ",", "0.96", ",", "2.1", ",", "0.8"}], 
    "}"}]}], ";", 
  RowBox[{"LP88", "=", 
   RowBox[{"0.1", 
    RowBox[{"{", 
     RowBox[{
      FractionBox["39", "1.94"], ",", 
      FractionBox["32", "1.96"], ",", 
      FractionBox["33", "1.71"], ",", 
      FractionBox["34", "1.69"], ",", 
      FractionBox["58", "2.12"], ",", 
      FractionBox["14", "1.98"], ",", 
      FractionBox["16", "1.97"], ",", 
      FractionBox["4", "1.68"], ",", 
      FractionBox["10", "1.76"], ",", 
      FractionBox["35", "2.25"]}], "}"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"LP230", "=", 
   RowBox[{"{", 
    RowBox[{
    "8.8", ",", " ", "8.7", ",", " ", "13.6", ",", " ", "7.8", " ", ",", 
     "9.4", ",", "4.57", ",", " ", "6.84", ",", " ", "5.27", ",", " ", "4.59",
      ",", " ", "4.5", ",", "8", " ", ",", "10", ",", " ", "8", ",", " ", "5",
      ",", "5.9"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LP345", "=", 
    RowBox[{"{", 
     RowBox[{
     "5.38", ",", " ", "5.35", ",", " ", "9.51", ",", " ", "8.25", ",", 
      "6.07", ",", " ", "5.75", ",", " ", "8.52", ",", " ", "5.78", " ", ",", 
      "2.32", ",", " ", "8.17", " ", ",", "6.39"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EVPA88", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "32.6"}], ",", 
     RowBox[{"-", "12.1"}], " ", ",", "26.5", ",", 
     RowBox[{"-", "39.1"}], ",", "15.2", " ", ",", "18"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EVPA230", "=", 
   RowBox[{"{", 
    RowBox[{
    "109", ",", " ", "113", ",", " ", "109", " ", ",", "86", " ", ",", "116", 
     ",", "146.8", " ", ",", "88.6", " ", ",", "122", " ", ",", "134", " ", 
     ",", "84.5", " ", ",", "114.8", ",", "114"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EVPA345", "=", 
   RowBox[{"{", 
    RowBox[{
    "149.7", " ", ",", "141", ",", " ", "148.6", ",", " ", "158.8", ",", 
     "136.7", " ", ",", "155.3", ",", " ", "139.5", " ", ",", "143.2", " ", 
     ",", "156.1", ",", " ", "143.8", " ", ",", "143.1"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"acc", "=", 
   SuperscriptBox["10", 
    RowBox[{"-", "4."}]]}], ";", 
  RowBox[{"Off", "[", 
   StyleBox[
    RowBox[{"HypothesisTestData", "::", "ties"}], "MessageName"], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F8"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(8.4\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F15"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(14.9\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F22"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(22\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F43"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(43\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F88"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(86\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F102"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(102\)]\):      <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F145"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(145\)]\):      <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F230"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(230\)]\):      <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F345"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(345\)]\):      <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F674"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(674\)]\):      <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F857"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(857\)]\):      <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "LP43"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(LP\), \(43\)]\): <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "LP88"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(LP\), \(88\)]\): <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "LP230"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(LP\), \(230\)]\): <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "LP345"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(LP\), \(345\)]\): <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "EVPA88"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(EVPA\), \(88\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "EVPA230"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(EVPA\), \(230\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "EVPA345"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(EVPA\), \(345\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5015902638380003`*^9, 3.501590352803*^9}, {
   3.5015903897860003`*^9, 3.501590426217*^9}, {3.50159047834*^9, 
   3.501590497151*^9}, {3.5015905354110003`*^9, 3.501590750881*^9}, {
   3.501590781151*^9, 3.5015908488780003`*^9}, 3.5015913799300003`*^9, {
   3.5015914166940002`*^9, 3.501591423909*^9}, {3.501591655854*^9, 
   3.501591721481*^9}, {3.50159186769*^9, 3.501591885016*^9}, {
   3.5015921829230003`*^9, 3.501592247523*^9}, {3.50159262338*^9, 
   3.501592648466*^9}, {3.5015929052279997`*^9, 3.501592940244*^9}, {
   3.5015958276429996`*^9, 3.501595942051*^9}, {3.501596018638*^9, 
   3.501596101408*^9}, {3.501596147097*^9, 3.5015961811210003`*^9}, {
   3.501596236457*^9, 3.501596275047*^9}, {3.501596337998*^9, 
   3.5015963874969997`*^9}, {3.501596427756*^9, 3.5015965449230003`*^9}, {
   3.5016050907790003`*^9, 3.501605169929*^9}, {3.5016053413929996`*^9, 
   3.501605341583*^9}, {3.5016054741359997`*^9, 3.501605480842*^9}, {
   3.501605531959*^9, 3.5016055346730003`*^9}, {3.501607636262*^9, 
   3.50160765156*^9}, {3.502031356571*^9, 3.502031366142*^9}, {
   3.502032273814*^9, 3.5020323491619997`*^9}, {3.502033078449*^9, 
   3.5020331721949997`*^9}, {3.502033241663*^9, 3.502033246479*^9}, {
   3.502036839928*^9, 3.502036852491*^9}, {3.5021096936610003`*^9, 
   3.5021097242980003`*^9}, {3.502123550091*^9, 3.502123647668*^9}, {
   3.5021236797939997`*^9, 3.502123690033*^9}, {3.528473224630242*^9, 
   3.5284732278314247`*^9}, 3.528475942447692*^9, {3.528507823141683*^9, 
   3.5285078726475143`*^9}, {3.528633445939211*^9, 3.528633446346718*^9}}],

Cell[BoxData[{
 RowBox[{"meF", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Mean", "[", "#", "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{
    "F8", ",", "F15", ",", "F22", ",", "F43", ",", "F88", ",", "F102", ",", 
     "F145", ",", "F230", ",", "F345", ",", "F674", ",", "F857"}], 
    "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"deF", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"StandardDeviation", "[", "#", "]"}], "/", 
     SqrtBox[
      RowBox[{"Length", "[", "#", "]"}]]}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{
    "F8", ",", "F15", ",", "F22", ",", "F43", ",", "F88", ",", "F102", ",", 
     "F145", ",", "F230", ",", "F345", ",", "F674", ",", "F857"}], 
    "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"meLP", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Mean", "[", "#", "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"LP43", ",", "LP88", ",", "LP230", ",", "LP345"}], 
    "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"deLP", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"StandardDeviation", "[", "#", "]"}], "/", 
      SqrtBox[
       RowBox[{"Length", "[", "#", "]"}]]}], "&"}], "/@", 
    RowBox[{"{", 
     RowBox[{"LP43", ",", "LP88", ",", "LP230", ",", "LP345"}], "}"}]}]}], 
  ";", 
  RowBox[{
   RowBox[{"deLP", "[", 
    RowBox[{"[", "2", "]"}], "]"}], "=", "0.50"}], ";", 
  "deLP"}], "\[IndentingNewLine]", 
 RowBox[{"meEVPA", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Mean", "[", "#", "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"EVPA88", ",", "EVPA230", ",", "EVPA345"}], 
    "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"deEVPA", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"StandardDeviation", "[", "#", "]"}], "/", 
     SqrtBox[
      RowBox[{"Length", "[", "#", "]"}]]}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"EVPA88", ",", "EVPA230", ",", "EVPA345"}], 
    "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fr", "=", 
   RowBox[{"{", 
    RowBox[{
    "8", ",", "15", ",", "22", ",", "43", ",", "88", ",", "102", ",", "145", 
     ",", "230", ",", "345", ",", "674", ",", "857"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl", "=", 
   RowBox[{"ListLogLinearPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"fr", ",", 
          RowBox[{"meF", "-", "deF"}]}], "}"}], "]"}], ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"fr", ",", 
          RowBox[{"meF", "+", "deF"}]}], "}"}], "]"}]}], "}"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"LogLinearPlot", "[", 
    RowBox[{
     RowBox[{"2.87", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["x", "230"], ")"}], "0.45"], 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["x", "1100"], ")"}], "2"]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "8", ",", "857"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
        RowBox[{"AbsoluteDashing", "[", 
         RowBox[{"{", 
          RowBox[{"5", ",", "5"}], "}"}], "]"}], ",", "Red"}], "}"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"pl", ",", "lpl"}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.501597017703*^9, 3.501597217396*^9}, {3.501600425366*^9,
    3.501600622352*^9}, {3.501600673749*^9, 3.5016006740439997`*^9}, {
   3.5016007157539997`*^9, 3.5016007165039997`*^9}, {3.501605548356*^9, 
   3.5016056474630003`*^9}, {3.501626647962*^9, 3.50162671467*^9}, {
   3.5020348833459997`*^9, 3.5020349593*^9}, {3.502036695076*^9, 
   3.502036695826*^9}, {3.502109750834*^9, 3.502109769191*^9}, {
   3.5021141450550003`*^9, 3.502114167293*^9}, {3.502114225579*^9, 
   3.502114239594*^9}, {3.528476050672882*^9, 3.528476069392953*^9}, 
   3.528507914769924*^9, {3.528549323535039*^9, 3.5285493757683415`*^9}}],

Cell[BoxData[{"freqLP", "\[IndentingNewLine]", "meLP", "\[IndentingNewLine]", 
 RowBox[{"xLP", "=", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"freqLP", ",", "meLP"}], "}"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"xLPnu", "=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"Partition", "[", 
     RowBox[{"xLP", ",", "1"}], "]"}], ",", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"ErrorBar", "/@", "deLP"}], ",", "1"}], "]"}], ",", "2"}], 
   "]"}]}], "\[IndentingNewLine]", "xLPnu"}], "Input",
 CellChangeTimes->{{3.546560034048491*^9, 3.5465600453281364`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<ErrorBarPlots`\>\"", "]"}], ";", 
  RowBox[{"Needs", "[", "\"\<ErrorBarLogPlots`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"freq", "=", 
   RowBox[{"{", 
    RowBox[{
    "8.450", ",", "14.90", ",", "22.50", ",", "43.00", ",", "87.73", ",", 
     "102.0", ",", "145.0", ",", "230.9", ",", "349.0", ",", "674.0", ",", 
     "857.0"}], "}"}]}], ";", 
  RowBox[{"freqLP", "=", 
   RowBox[{"{", 
    RowBox[{"43", ",", "87.73", ",", "230.9", ",", "349"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fnu", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"freq", ",", "meF"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xFnu", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Partition", "[", 
      RowBox[{"Fnu", ",", "1"}], "]"}], ",", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"ErrorBar", "/@", "deF"}], ",", "1"}], "]"}], ",", "2"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"el", "=", 
   RowBox[{"{", 
    RowBox[{
    "LogLogPlot", ",", "ListLogLogPlot", ",", "ListLogLinearPlot", ",", 
     "ErrorListLogLogPlot", ",", "ErrorListLogLinearPlot"}], "}"}]}], ";", 
  RowBox[{"Clear", "[", "totI", "]"}], ";", 
  RowBox[{"xcol", "=", "Cyan"}], ";", 
  RowBox[{"myf", "=", "14"}], ";", 
  RowBox[{"siz", "=", "380"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"#", ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ","}], "*)"}], 
        RowBox[{
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}]}], "}"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"FrameTicks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"(*", 
           RowBox[{"{", 
            RowBox[{
            "10", ",", "20", ",", "50", ",", "100", ",", "200", ",", "500"}], 
            "}"}], "*)"}], 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "8", ",", "15", ",", "22", ",", "43", ",", "88", ",", "145", ",", 
             "231", ",", "349", ",", "690"}], "}"}], ",", "None"}], "}"}]}], 
        "}"}]}]}], "]"}], "&"}], "/@", "el"}], ";", 
  RowBox[{"lpl1", "=", 
   RowBox[{"ErrorListLogLogPlot", "[", 
    RowBox[{"xFnu", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"7", ",", "950"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.6", ",", "3.9"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Null", ",", "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}],
          "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}]}], 
    RowBox[{"(*", 
     RowBox[{",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsolutePointSize", "[", "6", "]"}], ",", "Blue"}], 
        "}"}]}]}], "*)"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"freq", ",", 
          RowBox[{"meF", "+", "deF"}]}], "}"}], "]"}], ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"freq", ",", 
          RowBox[{"meF", "-", "deF"}]}], "}"}], "]"}]}], "}"}], ",", 
     RowBox[{"Filling", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], "}"}]}], ",", 
     RowBox[{"FillingStyle", "\[Rule]", "LightCyan"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"7", ",", "950"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.6", ",", "3.9"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Null", ",", "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}],
          "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "0.5", "]"}]}]}], 
    RowBox[{"(*", 
     RowBox[{",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"PointSize", "[", "0.02", "]"}], ",", "xcol", ",", 
         RowBox[{"Point", "[", 
          RowBox[{"Log", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"8.45", ",", "0.72"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"14.9", ",", "1.03"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"23", ",", "1.1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"43", ",", "1.4"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"93", ",", "1.9"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"220", ",", "3.8"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"350", ",", "4.1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"690", ",", "2.7"}], "}"}]}], "}"}], "]"}], "]"}]}], 
        "}"}]}]}], "*)"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{
     RowBox[{"2.87", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["x", "230"], ")"}], "0.45"], 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["x", "1100"], ")"}], "2"]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "8.45", ",", "857"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
        RowBox[{"AbsoluteDashing", "[", 
         RowBox[{"{", 
          RowBox[{"5", ",", "5"}], "}"}], "]"}], ",", "Red"}], "}"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Fnupl", "=", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl", ",", "lpl1", ",", "pl"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"freqLP", "=", 
   RowBox[{"{", 
    RowBox[{"43", ",", "87.73", ",", "230.9", ",", "349"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xLP", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"freqLP", ",", "meLP"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xLPnu", "=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"Partition", "[", 
       RowBox[{"xLP", ",", "1"}], "]"}], ",", 
      RowBox[{"Partition", "[", 
       RowBox[{
        RowBox[{"ErrorBar", "/@", "deLP"}], ",", "1"}], "]"}], ",", "2"}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ErrorListLogLogPlot", "[", 
    RowBox[{"xLPnu", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"35", ",", "400"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.3", ",", "10"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Null", ",", "\"\<LP [%]\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"freqLP", ",", 
          RowBox[{"meLP", "+", 
           RowBox[{"1.2", "deLP"}]}]}], "}"}], "]"}], ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"freqLP", ",", 
          RowBox[{"meLP", "-", 
           RowBox[{"0.85", "deLP"}]}]}], "}"}], "]"}]}], "}"}], ",", 
     RowBox[{"Filling", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], "}"}]}], ",", 
     RowBox[{"FillingStyle", "\[Rule]", "LightCyan"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"35", ",", "400"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.3", ",", "10"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Null", ",", "\"\<LP [%]\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "0.5", "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LPnupl", "=", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl", ",", "lpl1"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CPnu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"8.45", ",", 
       RowBox[{"-", "0.25"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14.90", ",", 
       RowBox[{"-", "0.62"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"231", ",", 
       RowBox[{"-", "1.2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"349", ",", 
       RowBox[{"-", "1.5"}]}], "}"}]}], "}"}]}], ";", 
  RowBox[{"CPf", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "CPnu", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"CPtr", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "CPnu", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"freqCP", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "CPnu", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"meCP", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "CPnu", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dCP", "=", 
   RowBox[{"{", 
    RowBox[{"0.06", ",", "0.26", ",", "0.3", ",", "0.3"}], "}"}]}], ";", 
  RowBox[{"xCPnu", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Partition", "[", 
      RowBox[{"CPnu", ",", "1"}], "]"}], ",", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"ErrorBar", "/@", "dCP"}], ",", "1"}], "]"}], ",", "2"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ErrorListLogLinearPlot", "[", 
    RowBox[{"xCPnu", ",", 
     RowBox[{"Joined", "\[Rule]", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"7", ",", "400"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "2."}], ",", 
          RowBox[{"-", "0.1"}]}], "}"}]}], "}"}]}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Null", ",", "\"\<CP [%]\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl", "=", 
   RowBox[{"ListLogLinearPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"freqCP", ",", 
          RowBox[{"meCP", "+", "dCP"}]}], "}"}], "]"}], ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"freqCP", ",", 
          RowBox[{"meCP", "-", "dCP"}]}], "}"}], "]"}]}], "}"}], ",", 
     RowBox[{"Filling", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], "}"}]}], ",", 
     RowBox[{"FillingStyle", "\[Rule]", "LightCyan"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"7", ",", "400"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "2."}], ",", 
          RowBox[{"-", "0.1"}]}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Null", ",", "\"\<CP [%]\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "0.5", "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CPnupl", "=", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl", ",", "lpl1"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"freqEVPA", "=", 
   RowBox[{"{", 
    RowBox[{"88", ",", "231", ",", "349"}], "}"}]}], ";", 
  RowBox[{"xEVPA", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"freqEVPA", ",", "meEVPA"}], "}"}], "]"}]}], ";", 
  RowBox[{"ran", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"75", ",", "400"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "30."}], ",", "170"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xEVPAnu", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Partition", "[", 
      RowBox[{"xEVPA", ",", "1"}], "]"}], ",", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"ErrorBar", "/@", "deEVPA"}], ",", "1"}], "]"}], ",", "2"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ErrorListLogLinearPlot", "[", 
    RowBox[{"xEVPAnu", ",", 
     RowBox[{"Joined", "\[Rule]", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "ran"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lpl", "=", 
    RowBox[{"ListLogLinearPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"freqEVPA", ",", 
           RowBox[{"meEVPA", "+", "deEVPA"}]}], "}"}], "]"}], ",", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"freqEVPA", ",", 
           RowBox[{"meEVPA", "-", "deEVPA"}]}], "}"}], "]"}]}], "}"}], ",", 
      RowBox[{"Filling", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"1", "\[Rule]", 
         RowBox[{"{", "2", "}"}]}], "}"}]}], ",", 
      RowBox[{"FillingStyle", "\[Rule]", "LightCyan"}], ",", 
      RowBox[{"FrameLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Null", ",", "Null"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
          "Null", ",", "\"\<Electric vector position angle [deg]\>\""}], 
          "}"}]}], "}"}]}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", "ran"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "0.5", "]"}]}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"sol", "=", 
     RowBox[{"FindFit", "[", 
      RowBox[{
       RowBox[{"xEVPA", "[", 
        RowBox[{"[", 
         RowBox[{"2", ";;", "3"}], "]"}], "]"}], ",", 
       RowBox[{"A", "+", 
        FractionBox["B", 
         SuperscriptBox["f", "2"]]}], ",", 
       RowBox[{"{", 
        RowBox[{"A", ",", "B"}], "}"}], ",", "f"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"lfi", "=", 
     RowBox[{"LogLinearPlot", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"A", "+", 
         FractionBox["B", 
          SuperscriptBox["f", "2"]]}], "/.", "sol"}], ",", 
       RowBox[{"{", 
        RowBox[{"f", ",", "70", ",", "400"}], "}"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "ran"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "0.5", "]"}]}]}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"EVPAnupl", "=", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl", ",", "lpl1"}], 
     RowBox[{"(*", 
      RowBox[{",", "lfi"}], "*)"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"totimag", "=", 
   RowBox[{"GraphicsGrid", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Fnupl", ",", "EVPAnupl"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"LPnupl", ",", "CPnupl"}], "}"}]}], "}"}], ",", 
     RowBox[{"Epilog", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Black", ",", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
            RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"ImageScaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.43", ",", "0.53"}], "}"}], "]"}]}], "]"}], ",", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
            RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"ImageScaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.43", ",", "0.03"}], "}"}], "]"}]}], "]"}], ",", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
            RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"ImageScaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.955", ",", "0.53"}], "}"}], "]"}]}], "]"}], ",", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
            RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"ImageScaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.955", ",", "0.03"}], "}"}], "]"}]}], "]"}]}], "}"}]}], 
     ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", 
         RowBox[{"myf", "-", "2"}]}]}], "}"}]}], ",", 
     RowBox[{
     "PlotLabel", "\[Rule]", "\"\<Compilation of observations\>\""}]}], 
    "]"}]}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ","}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
   "dir", "=", 
    "\"\<C:\\\\study\\\\accretion\\\\! 2009 3fall cfa\\\\GR Polarized \
modeling\\\\!svn\\\\\>\""}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"dir", "<>", "\"\<SED.eps\>\""}], ",", "totimag", ",", 
     RowBox[{"\"\<EmbeddedFonts\>\"", "\[Rule]", "True"}]}], "]"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"dir", "<>", "\"\<SED.pdf\>\""}], ",", "totimag"}], "]"}], 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5020436574110003`*^9, 3.502043716951*^9}, {
   3.5020437635810003`*^9, 3.502043838344*^9}, {3.502043880822*^9, 
   3.502044000814*^9}, {3.502044034076*^9, 3.502044046251*^9}, {
   3.502044137105*^9, 3.5020442680290003`*^9}, {3.5020443093050003`*^9, 
   3.5020444196879997`*^9}, {3.502044592623*^9, 3.502044611196*^9}, 
   3.502044655959*^9, {3.502108851251*^9, 3.502108857632*^9}, {
   3.5021090746549997`*^9, 3.502109087068*^9}, {3.502109173495*^9, 
   3.502109173582*^9}, {3.5021098318059998`*^9, 3.502109851605*^9}, {
   3.502111572615*^9, 3.5021115730810003`*^9}, {3.502112634289*^9, 
   3.502112634836*^9}, {3.5021127668900003`*^9, 3.5021127718570004`*^9}, {
   3.502113139858*^9, 3.5021131401029997`*^9}, {3.502113249834*^9, 
   3.502113250142*^9}, {3.502113341284*^9, 3.502113383547*^9}, {
   3.502113639508*^9, 3.502113643571*^9}, {3.5021143063389997`*^9, 
   3.5021143067790003`*^9}, {3.502121674262*^9, 3.502121706863*^9}, {
   3.502121800462*^9, 3.502121830835*^9}, {3.502121892653*^9, 
   3.5021220093459997`*^9}, {3.5102490853046*^9, 3.5102491199706*^9}, {
   3.5102492954636*^9, 3.5102493045806*^9}, {3.5102494512536*^9, 
   3.5102494816666*^9}, {3.5284763600995803`*^9, 3.5284763859790606`*^9}, {
   3.528476425764336*^9, 3.528476479585415*^9}, {3.528476509887148*^9, 
   3.5284765112282248`*^9}, {3.528549392858604*^9, 3.5285494825874825`*^9}, 
   3.5285495981692705`*^9, 3.528549629619754*^9, {3.5285497185536194`*^9, 
   3.5285497513166227`*^9}, {3.5285497863121605`*^9, 
   3.5285498027499127`*^9}, {3.546559950266699*^9, 3.5465599520257998`*^9}}],

Cell[BoxData[{
 RowBox[{"Length", "[", 
  RowBox[{"ror", "=", 
   RowBox[{"{", 
    RowBox[{
    "0.01", ",", "3", ",", "3", ",", "3", ",", "3", ",", "3", ",", "3", ",", 
     "3", ",", "3", ",", "3", ",", "3"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Mean", "[", "ror", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Exp", "[", 
  RowBox[{"Mean", "[", 
   RowBox[{"Log", "[", "ror", "]"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5285505111939993`*^9, 3.5285505473590584`*^9}}],

Cell["\<\
200 cores at a time \[Implies] 25 tasks at a time; 6hr - each task
7*50=350 tasks\
\>", "Text",
 CellChangeTimes->{{3.5020370185360003`*^9, 3.5020370488719997`*^9}, {
  3.50203959971*^9, 3.502039647865*^9}, {3.5020396788719997`*^9, 
  3.502039698783*^9}, {3.5020397473900003`*^9, 3.5020397493719997`*^9}}],

Cell[BoxData[{
 RowBox[{"Print", "[", 
  RowBox[{
   RowBox[{
    FractionBox["350", "25"], "*", 
    RowBox[{"6", "/", "24."}]}], ",", "\"\< days to finish\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
   RowBox[{"350", "*", "8", "*", "6"}], ",", "\"\< CPU-hours\>\""}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.502039763192*^9, 3.502039803219*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["old new", "Subsubsection",
 CellChangeTimes->{{3.5015902080179996`*^9, 3.501590208722*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Fnu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"8.45", ",", " ", "0.68982013"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14.90", " ", ",", "0.904431774"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22.50", " ", ",", "1.070321246"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"43.00", " ", ",", "1.15943163"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"87.73", " ", ",", "1.58443741"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"102.00", ",", " ", "1.415119175"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"145.00", " ", ",", "2.24570193"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"230.86", " ", ",", "2.181905886"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"349.00", " ", ",", "3.065050156"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"674.00", " ", ",", "3.2033626"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"857.00", " ", ",", "2.786327907"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LPnu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"22.50", ",", " ", "0.19"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"43.00", " ", ",", "0.504083326"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"87.73", " ", ",", "1.11"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"230.86", ",", " ", "7.61271"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"349.00", " ", ",", "7.03"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"angnu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"22.50", " ", ",", "131"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"43.00", ",", " ", "94.25"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"87.73", ",", " ", "102.7777778"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"230.86", ",", " ", "117"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"349.00", ",", " ", "148.1428571"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CPnu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"8.45", ",", 
       RowBox[{"-", "0.25"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14.90", ",", 
       RowBox[{"-", "0.62"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"230", ",", 
       RowBox[{"-", "1.2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"349", ",", 
       RowBox[{"-", "1.5"}]}], "}"}]}], "}"}]}], ";", 
  RowBox[{"dFnu", "=", "0.33"}], ";", 
  RowBox[{"dCP", "=", "0.27"}], ";", 
  RowBox[{"dlogLP", "=", "0.26"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ff", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "Fnu", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"Ftr", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "Fnu", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"LPf", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "LPnu", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"LPtr", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "LPnu", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CPf", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "CPnu", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"CPtr", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "CPnu", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.486141864737*^9, 3.486141883528*^9}, {3.486141983391*^9,
   3.486141984398*^9}, {3.4861424447390003`*^9, 3.48614248221*^9}, {
  3.486142660151*^9, 3.486142662804*^9}, {3.486142842783*^9, 
  3.4861428615699997`*^9}, {3.4876872873761997`*^9, 3.4876872890931997`*^9}, {
  3.4885686045518*^9, 3.4885686061158*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"el", "=", 
   RowBox[{"{", 
    RowBox[{"ListLogLogPlot", ",", "ListLogLinearPlot", ",", "LogLogPlot"}], 
    "}"}]}], ";", 
  RowBox[{"Clear", "[", "totI", "]"}], ";", 
  RowBox[{"xcol", "=", "Green"}], ";", 
  RowBox[{"siz", "=", "280"}], ";", 
  RowBox[{"myf", "=", "15"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"#", ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ","}], "*)"}], 
        RowBox[{
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}]}], "}"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}]}], 
     RowBox[{"(*", 
      RowBox[{",", 
       RowBox[{"FrameTicks", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"(*", 
            RowBox[{"{", 
             RowBox[{
             "10", ",", "20", ",", "50", ",", "100", ",", "200", ",", "500"}],
              "}"}], "*)"}], 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "43", ",", "87", ",", "145", ",", "230", ",", "345", ",", 
              "690"}], "}"}], ",", "None"}], "}"}]}], "}"}]}]}], "*)"}], 
     "]"}], "&"}], "/@", "el"}], ";", 
  RowBox[{"lpl", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"Ff", ",", 
          RowBox[{"Ftr", "+", "dFnu"}]}], "}"}], "]"}], ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"Ff", ",", 
          RowBox[{"Ftr", "-", "dFnu"}]}], "}"}], "]"}]}], "}"}], ",", 
     RowBox[{"Filling", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], "}"}]}], ",", 
     RowBox[{"FillingStyle", "\[Rule]", "LightRed"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0.4", ",", "4.7"}], "}"}]}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Null", ",", "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}],
          "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}]}], 
    RowBox[{"(*", 
     RowBox[{",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"PointSize", "[", "0.02", "]"}], ",", "xcol", ",", 
         RowBox[{"Point", "[", 
          RowBox[{"Log", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"23", ",", "1.2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"43", ",", "1.7"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"93", ",", "2.2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"220", ",", "3.8"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"350", ",", "4.1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"690", ",", "2.7"}], "}"}]}], "}"}], "]"}], "]"}]}], 
        "}"}]}]}], "*)"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{
     RowBox[{"0.295", 
      SuperscriptBox["x", "0.4"], 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["x", "1300"], ")"}], "2"]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "8.45", ",", "857"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
        RowBox[{"AbsoluteDashing", "[", 
         RowBox[{"{", 
          RowBox[{"5", ",", "5"}], "}"}], "]"}], ",", "Red"}], "}"}]}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0.4", ",", "4.7"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Fnupl", "=", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl", ",", "pl", ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", "0.4", "]"}], ",", 
         RowBox[{"Log", "[", "4.7", "]"}]}], "}"}]}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"LPf", ",", 
          RowBox[{"LPtr", "+", 
           RowBox[{"dlogLP", "*", "LPtr"}]}]}], "}"}], "]"}], ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"LPf", ",", 
          RowBox[{"LPtr", "-", 
           RowBox[{"dlogLP", "*", "LPtr"}]}]}], "}"}], "]"}]}], "}"}], ",", 
     RowBox[{"Filling", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], "}"}]}], ",", 
     RowBox[{"FillingStyle", "\[Rule]", "LightRed"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], 
     RowBox[{"(*", 
      RowBox[{",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"PointSize", "[", "0.02", "]"}], ",", "xcol", ",", 
          RowBox[{"Point", "[", 
           RowBox[{"Log", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"348", ",", "8"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"220", " ", ",", "5"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"68", ",", "2.1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"43", ",", "0.8"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"22", ",", "0.2"}], "}"}]}], "}"}], "]"}], "]"}]}], 
         "}"}]}]}], "*)"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Null", ",", "\"\<LP [%]\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LPnupl", "=", 
    RowBox[{"Show", "[", "lpl", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl", "=", 
   RowBox[{"ListLogLinearPlot", "[", 
    RowBox[{"angnu", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"PointSize", "[", "0.02", "]"}], ",", "xcol", ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "2"}], ",", 
          RowBox[{"Point", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Log", "[", "348", "]"}], ",", "155"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Log", "[", "230", "]"}], ",", "120"}], "}"}]}], "}"}],
            "]"}]}], "}"}]}], ","}], "*)"}], 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Null", ",", "\"\<Electric vector position angle [deg]\>\""}], 
         "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"87", ",", "380"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"85", ",", "157"}], "}"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"angnupl", "=", 
    RowBox[{"Show", "[", "lpl", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl", "=", 
   RowBox[{"ListLogLinearPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"CPf", ",", 
          RowBox[{"CPtr", "+", "dCP"}]}], "}"}], "]"}], ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"CPf", ",", 
          RowBox[{"CPtr", "-", "dCP"}]}], "}"}], "]"}]}], "}"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"Filling", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], "}"}]}], ",", 
     RowBox[{"FillingStyle", "\[Rule]", "LightRed"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Null", ",", "\"\<CP [%]\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"8", ",", "380"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1.9"}], ",", "0"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CPnupl", "=", 
   RowBox[{"Show", "[", "lpl", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"totimag", "=", 
   RowBox[{"GraphicsGrid", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Fnupl", ",", "angnupl"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"LPnupl", ",", "CPnupl"}], "}"}]}], "}"}], ",", 
     RowBox[{"Epilog", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Black", ",", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
            RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"ImageScaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.43", ",", "0.55"}], "}"}], "]"}]}], "]"}], ",", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
            RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"ImageScaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.43", ",", "0.05"}], "}"}], "]"}]}], "]"}], ",", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
            RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"ImageScaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.955", ",", "0.56"}], "}"}], "]"}]}], "]"}], ",", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
            RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"ImageScaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.955", ",", "0.05"}], "}"}], "]"}]}], "]"}]}], "}"}]}], 
     ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", 
         RowBox[{"myf", "-", "2"}]}]}], "}"}]}]}], 
    RowBox[{"(*", 
     RowBox[{",", 
      RowBox[{
      "PlotLabel", "\[Rule]", "\"\<Compilation of observations\>\""}]}], 
     "*)"}], "]"}]}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ","}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dir", "=", 
   "\"\<C:\\\\study\\\\accretion\\\\! 2009 fall cfa\\\\GR Polarized \
modeling\\\\\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dir", "=", 
   "\"\<D:\\\\DISKC\\\\study\\\\accretion\\\\conferences\\\\2010 November - \
Ins and Outs of the Black Holes\\\\\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"dir", "<>", "\"\<SED.eps\>\""}], ",", "totimag", ",", 
   RowBox[{"\"\<EmbeddedFonts\>\"", "\[Rule]", "All"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"dir", "<>", "\"\<SED.pdf\>\""}], ",", "totimag"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.4759427976610003`*^9, 3.4759429073599997`*^9}, {
   3.47594500891*^9, 3.475945013862*^9}, {3.475947413034*^9, 
   3.475947457392*^9}, {3.475948472541*^9, 3.4759485057609997`*^9}, {
   3.477141906354*^9, 3.477141908999*^9}, {3.4795558601400003`*^9, 
   3.479555897153*^9}, {3.479566896282*^9, 3.479566896823*^9}, {
   3.485170592652*^9, 3.485170611361*^9}, {3.485170721567*^9, 
   3.485170838171*^9}, {3.4851708693459997`*^9, 3.4851709693570004`*^9}, {
   3.485171136889*^9, 3.4851714099449997`*^9}, {3.485173706782*^9, 
   3.48517375741*^9}, {3.486139373553*^9, 3.486139412207*^9}, {
   3.486141840446*^9, 3.4861418612650003`*^9}, {3.486141990278*^9, 
   3.486142059615*^9}, {3.486142292883*^9, 3.486142297307*^9}, {
   3.486142351409*^9, 3.4861423890880003`*^9}, {3.486142498704*^9, 
   3.486142500073*^9}, {3.486142625439*^9, 3.486142753959*^9}, {
   3.4861428290220003`*^9, 3.4861428296400003`*^9}, {3.486142953604*^9, 
   3.486142993158*^9}, {3.486143054363*^9, 3.4861430566689997`*^9}, {
   3.48614311933*^9, 3.486143277134*^9}, {3.4861433453970003`*^9, 
   3.4861433647060003`*^9}, {3.4861434638640003`*^9, 
   3.4861435219049997`*^9}, {3.486143591889*^9, 3.4861435940559998`*^9}, {
   3.4861436348780003`*^9, 3.486143636324*^9}, {3.486143672192*^9, 
   3.486143675696*^9}, {3.486143713796*^9, 3.486143725557*^9}, {
   3.486143756288*^9, 3.486143757109*^9}, {3.4876873556542*^9, 
   3.4876873692072*^9}, {3.4881811555621324`*^9, 3.4881811586951323`*^9}, {
   3.4881811941791325`*^9, 3.4881812086161327`*^9}, {3.4883890021563997`*^9, 
   3.4883890044904003`*^9}, {3.4883890349994*^9, 3.4883891105994*^9}, {
   3.4883891647944*^9, 3.4883891658664*^9}, {3.4883892670924*^9, 
   3.4883892675464*^9}, {3.4883893393374*^9, 3.4883893531264*^9}, {
   3.4883894130564003`*^9, 3.4883894533674*^9}, {3.4883895078364*^9, 
   3.4883895345144*^9}, {3.4883895720453997`*^9, 3.4883896064854*^9}, {
   3.4883896524754*^9, 3.4883896533494*^9}, {3.4883896835734*^9, 
   3.4883897262414*^9}, {3.4883897609474*^9, 3.4883897762324*^9}, {
   3.4883898170894003`*^9, 3.4883898199344*^9}, 3.4883898832164*^9, {
   3.4883899162134*^9, 3.4883899165884*^9}, {3.4885633095828*^9, 
   3.4885633154108*^9}, {3.4885665891928*^9, 3.4885666134458*^9}, {
   3.4885666447858*^9, 3.4885667396008*^9}, {3.4885667776837997`*^9, 
   3.4885668345058002`*^9}, {3.4885670247118*^9, 3.4885670332138*^9}, {
   3.4885670653408003`*^9, 3.4885670710298*^9}, {3.4885671098458*^9, 
   3.4885671123848*^9}, {3.4885685993198*^9, 3.4885686306948*^9}, {
   3.4891533897895327`*^9, 3.4891534021915326`*^9}, {3.4891534554499326`*^9, 
   3.4891535243083324`*^9}, {3.4891564869379325`*^9, 3.489156487359133*^9}, {
   3.4986899087408924`*^9, 3.4986899126698923`*^9}, {3.4986899612278924`*^9, 
   3.4986900004958925`*^9}, {3.4986900389648924`*^9, 
   3.4986900975498924`*^9}, {3.4986901583188925`*^9, 
   3.4986901712218924`*^9}, {3.4986915613728924`*^9, 3.498691565725892*^9}, {
   3.4987873231968*^9, 3.4987873356048*^9}, {3.4987873725318003`*^9, 
   3.4987873970708*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"PlotStyle", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", 
     RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", 
     RowBox[{"Directive", "[", 
      RowBox[{"Blue", ",", 
       RowBox[{"PointSize", "[", "Large", "]"}]}], "]"}]}], "}"}]}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.486143368951*^9, 3.4861433698780003`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["new", "Subsubsection",
 CellChangeTimes->{{3.5015902147060003`*^9, 3.501590215633*^9}, {
  3.528550411412467*^9, 3.528550411769972*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"her2cm", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\<Herrstein_2cm.xlsx\>\""}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"her13mm", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\<Herrstein_13mm.xlsx\>\""}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"her7mm", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\<Herrstein_7mm.xlsx\>\""}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dat2cm", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "her2cm", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"dat13mm", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "her13mm", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"dat7mm", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "her7mm", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5003970947264996`*^9, 3.5003971236084995`*^9}, {
   3.5003971612944994`*^9, 3.5003971908844995`*^9}, {3.5003973265894995`*^9, 
   3.5003973819054995`*^9}, 3.50100234726*^9, {3.501607540918*^9, 
   3.50160757331*^9}}],

Cell[BoxData[{
 RowBox[{"200", " ", 
  SuperscriptBox["1.052", "30"]}], "\[IndentingNewLine]", 
 RowBox[{"1.108", "*", "12", "*", "30"}], "\[IndentingNewLine]", 
 RowBox[{"400", "*", "0.035"}]}], "Input",
 CellChangeTimes->{{3.510331862799*^9, 3.510331880368*^9}, 
   3.5103321856400003`*^9, {3.510332324288*^9, 3.5103323376940002`*^9}, {
   3.51033254685*^9, 3.51033254937*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"LP88", " ", "from", " ", "Macquart", " ", "et", " ", 
    RowBox[{"al", ".", " ", "2006"}]}], "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{"data", "=", 
     RowBox[{"0.1", 
      RowBox[{"{", 
       RowBox[{
        FractionBox["39", "1.94"], ",", 
        FractionBox["32", "1.96"], ",", 
        FractionBox["33", "1.71"], ",", 
        FractionBox["34", "1.69"], ",", 
        FractionBox["58", "2.12"], ",", 
        FractionBox["14", "1.98"], ",", 
        FractionBox["16", "1.97"], ",", 
        FractionBox["4", "1.68"], ",", 
        FractionBox["10", "1.76"], ",", 
        FractionBox["35", "2.25"]}], "}"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"md", "=", 
    RowBox[{"Exp", "[", 
     RowBox[{"Mean", "[", 
      RowBox[{"Log", "[", "data", "]"}], "]"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"hah", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{"md", "-", "0.5"}], "]"}], "-", 
       RowBox[{"Log", "[", "md", "]"}]}], ",", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{"md", "+", "0.5"}], "]"}], "-", 
       RowBox[{"Log", "[", "md", "]"}]}]}], "}"}]}], "\[IndentingNewLine]", 
   RowBox[{"gm", "=", 
    RowBox[{"GeometricMean", "[", 
     RowBox[{"Abs", "[", "hah", "]"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{"\"\<LP88=\>\"", ",", "md", ",", "\"\<+(\>\"", ",", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"Log", "[", "md", "]"}], "+", "gm"}], "]"}], "-", "md"}], 
     ",", "\"\<)\>\"", ",", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"Log", "[", "md", "]"}], "-", "gm"}], "]"}], "-", "md"}]}], 
    "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"acc", "=", 
     SuperscriptBox["10", 
      RowBox[{"-", "3."}]]}], ";", 
    RowBox[{"err", "=", 
     RowBox[{"Floor", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
        SqrtBox[
         RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}]}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.528473734402399*^9, 3.528473823908519*^9}, {
  3.5284738803417463`*^9, 3.5284739684717875`*^9}, {3.528474014870441*^9, 
  3.5284740215748243`*^9}, {3.5284748292070184`*^9, 3.528474880497952*^9}, {
  3.5284749111937075`*^9, 3.5284749521550503`*^9}, {3.528475046783463*^9, 
  3.5284750794113293`*^9}, {3.5284754854025507`*^9, 3.5284755288990383`*^9}, {
  3.5284755702364025`*^9, 3.5284755898995275`*^9}, {3.528475626395615*^9, 
  3.528475681019739*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"F8", "=", 
   RowBox[{"{", 
    RowBox[{"0.73", ",", "0.59", ",", "0.72", ",", "0.69"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F15", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{"dat2cm", ",", 
      RowBox[{"{", 
       RowBox[{"1.1", ",", "0.81", ",", "1.03", ",", "0.92", ",", "0.94"}], 
       "}"}]}], "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F22", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{"dat13mm", ",", 
      RowBox[{"{", 
       RowBox[{
       "1.05", ",", "1.6", ",", "0.94", ",", "1.75", ",", "1.1", ",", "1.05", 
        ",", "1.06"}], "}"}]}], "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F43", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{"dat7mm", ",", 
      RowBox[{"{", 
       RowBox[{
       "1.03", ",", "1.1", " ", ",", "2.02", ",", " ", "1.9", ",", " ", 
        "1.92", ",", " ", "1.78", ",", "2.02", ",", " ", "1.59", ",", " ", 
        "1.99", ",", " ", "1.61", ",", " ", "1.86", " ", ",", "1.66", ",", 
        "1.45", ",", "1.07", ",", "2.3", ",", "1.4", ",", "1.6"}], "}"}]}], 
     "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F88", "=", 
   RowBox[{"{", 
    RowBox[{
    "1.715", ",", " ", "1.352", ",", " ", "2.374", ",", "1.73", ",", "1.2", 
     ",", " ", "1.6", ",", 
     RowBox[{"(*", 
      RowBox[{"3.5", ","}], "*)"}], "1.96", ",", " ", "1.97", ",", " ", 
     "1.69", ",", " ", "1.73", ",", " ", "2.18", ",", "1.8", ",", "1.4", ",", 
     "1.7", ",", " ", "2.2", ",", " ", "1.7", ",", "2.6", ",", "1.2", ",", 
     "2", ",", "2.1", ",", "2.4", ",", "1.9"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F102", "=", 
   RowBox[{"{", 
    RowBox[{
    "1.9", ",", " ", "1.4", " ", ",", "1.8", " ", ",", "1.7", ",", "1.2", ",",
      "2", " ", ",", "2.7", ",", " ", "1.9", ",", " ", "3", " ", ",", "1.2", 
     " ", ",", "1.5", ",", "2.1", ",", "2.4"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F145", "=", 
   RowBox[{"{", 
    RowBox[{
    "1.1", " ", ",", "2.2", ",", " ", "2", " ", ",", "3.6", ",", "2.5", ",", 
     " ", "2.1", ",", "2.9", ",", "1.8"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F230", "=", 
   RowBox[{"{", 
    RowBox[{
    "2", ",", "2.2", ",", "3.6", ",", "1.14", ",", "2.3", ",", " ", "2.7", 
     ",", " ", "2.3", ",", " ", "2.8", ",", " ", "2.6", ",", "2.4", ",", " ", 
     "2.1", ",", " ", "1.9", " ", ",", "2.15", ",", " ", "3.1", ",", " ", 
     "2.4", ",", "4.05", ",", " ", "3.3", ",", " ", "3.8", " ", ",", "1.9", 
     " ", ",", "2.5", ",", " ", "3", " ", ",", "2.5", ",", "0.7", ",", " ", 
     "1.23", ",", " ", "0.87", ",", " ", "1.52", ",", "3.43", ",", " ", 
     "3.86", ",", " ", "3.79", " ", ",", "3.79", " ", ",", "3.33", " ", ",", 
     "4.14", ",", "1.3", ",", " ", "2.5", ",", " ", "1.7", ",", " ", "1.8", 
     ",", "2.4", ",", "2.9", ",", " ", "3.4", ",", "4", ",", "3", ",", "2.8", 
     ",", "4.2"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F345", "=", 
   RowBox[{"{", 
    RowBox[{
    "4.18", " ", ",", "3.31", ",", " ", "2.98", ",", " ", "3.8", ",", "3.79", 
     ",", " ", "3.16", ",", " ", "3.2", " ", ",", "3.18", " ", ",", "2.75", 
     ",", " ", "3.02", ",", " ", "3.31", ",", "3", ",", "2.9", ",", "2.3", 
     ",", "2.83"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"F674", "=", 
   RowBox[{"{", 
    RowBox[{
    "2.9", " ", ",", "3", ",", " ", "3", ",", "3.8", ",", "2", " ", ",", 
     "3.3", " ", ",", "5"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"F857", "=", 
    RowBox[{"{", 
     RowBox[{"2.4", " ", ",", "3", ",", "3.2"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LP43", "=", 
   RowBox[{"{", 
    RowBox[{"0.33", ",", "0.77"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LP88", "=", 
   RowBox[{"{", 
    RowBox[{"1.01", ",", "0.7", ",", "0.96", ",", "2.1", ",", "0.8"}], 
    "}"}]}], ";", 
  RowBox[{"LP88", "=", 
   RowBox[{"0.1", 
    RowBox[{"{", 
     RowBox[{
      FractionBox["39", "1.94"], ",", 
      FractionBox["32", "1.96"], ",", 
      FractionBox["33", "1.71"], ",", 
      FractionBox["34", "1.69"], ",", 
      FractionBox["58", "2.12"], ",", 
      FractionBox["14", "1.98"], ",", 
      FractionBox["16", "1.97"], ",", 
      FractionBox["4", "1.68"], ",", 
      FractionBox["10", "1.76"], ",", 
      FractionBox["35", "2.25"]}], "}"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"LP230", "=", 
   RowBox[{"{", 
    RowBox[{
    "8.8", ",", " ", "8.7", ",", " ", "13.6", ",", " ", "7.8", " ", ",", 
     "9.4", ",", "4.57", ",", " ", "6.84", ",", " ", "5.27", ",", " ", "4.59",
      ",", " ", "4.5", ",", "8", " ", ",", "10", ",", " ", "8", ",", " ", "5",
      ",", "5.9"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LP345", "=", 
    RowBox[{"{", 
     RowBox[{
     "5.38", ",", " ", "5.35", ",", " ", "9.51", ",", " ", "8.25", ",", 
      "6.07", ",", " ", "5.75", ",", " ", "8.52", ",", " ", "5.78", " ", ",", 
      "2.32", ",", " ", "8.17", " ", ",", "6.39"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EVPA88", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "32.6"}], ",", 
     RowBox[{"-", "12.1"}], " ", ",", "26.5", ",", 
     RowBox[{"-", "39.1"}], ",", "15.2", " ", ",", "18"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EVPA230", "=", 
   RowBox[{"{", 
    RowBox[{
    "109", ",", " ", "113", ",", " ", "109", " ", ",", "86", " ", ",", "116", 
     ",", "146.8", " ", ",", "88.6", " ", ",", "122", " ", ",", "134", " ", 
     ",", "84.5", " ", ",", "114.8", ",", "114"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EVPA345", "=", 
   RowBox[{"{", 
    RowBox[{
    "149.7", " ", ",", "141", ",", " ", "148.6", ",", " ", "158.8", ",", 
     "136.7", " ", ",", "155.3", ",", " ", "139.5", " ", ",", "143.2", " ", 
     ",", "156.1", ",", " ", "143.8", " ", ",", "143.1"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"acc", "=", 
   SuperscriptBox["10", 
    RowBox[{"-", "3."}]]}], ";", 
  RowBox[{"Off", "[", 
   StyleBox[
    RowBox[{"HypothesisTestData", "::", "ties"}], "MessageName"], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F8"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(8.4\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F15"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(14.9\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F22"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(22\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F43"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(43\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F88"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(86\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F102"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(102\)]\):      <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F145"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(145\)]\):      <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F230"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(230\)]\):      <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F345"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(345\)]\):      <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F674"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(674\)]\):      <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "F857"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(F\), \(857\)]\):      <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Log", "[", "LP43", "]"}]}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Log(\!\(\*SubscriptBox[\(LP\), \(43\)]\)): <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{"Mean", "[", "data", "]"}], "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Log", "[", "LP88", "]"}]}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Log(\!\(\*SubscriptBox[\(LP\), \(86\)]\)): <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{"Mean", "[", "data", "]"}], "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Log", "[", "LP230", "]"}]}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Log(\!\(\*SubscriptBox[\(LP\), \(230\)]\)): <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{"Mean", "[", "data", "]"}], "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Log", "[", "LP345", "]"}]}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Log(\!\(\*SubscriptBox[\(LP\), \(345\)]\)): <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{"Mean", "[", "data", "]"}], "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "EVPA88"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(EVPA\), \(88\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "EVPA230"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(EVPA\), \(230\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", "EVPA345"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SubscriptBox[\(EVPA\), \(345\)]\):       <x>=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"Mean", "[", "data", "]"}], ",", "acc"}], "]"}], ",", 
    "\"\< \[Sigma]=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"StandardDeviation", "[", "data", "]"}], "/", 
       SqrtBox[
        RowBox[{"Length", "[", "data", "]"}]]}], ",", "acc"}], "]"}], ",", 
    "\"\< p=\>\"", ",", 
    RowBox[{"Floor", "[", 
     RowBox[{
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}], ",", "acc"}], "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5015902638380003`*^9, 3.501590352803*^9}, {
   3.5015903897860003`*^9, 3.501590426217*^9}, {3.50159047834*^9, 
   3.501590497151*^9}, {3.5015905354110003`*^9, 3.501590750881*^9}, {
   3.501590781151*^9, 3.5015908488780003`*^9}, 3.5015913799300003`*^9, {
   3.5015914166940002`*^9, 3.501591423909*^9}, {3.501591655854*^9, 
   3.501591721481*^9}, {3.50159186769*^9, 3.501591885016*^9}, {
   3.5015921829230003`*^9, 3.501592247523*^9}, {3.50159262338*^9, 
   3.501592648466*^9}, {3.5015929052279997`*^9, 3.501592940244*^9}, {
   3.5015958276429996`*^9, 3.501595942051*^9}, {3.501596018638*^9, 
   3.501596101408*^9}, {3.501596147097*^9, 3.5015961811210003`*^9}, {
   3.501596236457*^9, 3.501596275047*^9}, {3.501596337998*^9, 
   3.5015963874969997`*^9}, {3.501596427756*^9, 3.5015965449230003`*^9}, {
   3.5016050907790003`*^9, 3.501605169929*^9}, {3.5016053413929996`*^9, 
   3.501605341583*^9}, {3.5016054741359997`*^9, 3.501605480842*^9}, {
   3.501605531959*^9, 3.5016055346730003`*^9}, {3.501607636262*^9, 
   3.50160765156*^9}, {3.502031356571*^9, 3.502031366142*^9}, {
   3.502032273814*^9, 3.5020323491619997`*^9}, {3.502033078449*^9, 
   3.5020331721949997`*^9}, {3.502033241663*^9, 3.502033246479*^9}, {
   3.502036839928*^9, 3.502036852491*^9}, {3.5021096936610003`*^9, 
   3.5021097242980003`*^9}, {3.502123550091*^9, 3.502123647668*^9}, {
   3.5021236797939997`*^9, 3.502123690033*^9}, {3.528473224630242*^9, 
   3.5284732278314247`*^9}, 3.528475942447692*^9}],

Cell[BoxData[{
 RowBox[{"meF", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Mean", "[", "#", "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{
    "F8", ",", "F15", ",", "F22", ",", "F43", ",", "F88", ",", "F102", ",", 
     "F145", ",", "F230", ",", "F345", ",", "F674", ",", "F857"}], 
    "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"deF", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"StandardDeviation", "[", "#", "]"}], "/", 
     SqrtBox[
      RowBox[{"Length", "[", "#", "]"}]]}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{
    "F8", ",", "F15", ",", "F22", ",", "F43", ",", "F88", ",", "F102", ",", 
     "F145", ",", "F230", ",", "F345", ",", "F674", ",", "F857"}], 
    "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"meLP", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Exp", "[", 
     RowBox[{"Mean", "[", "#", "]"}], "]"}], "&"}], "/@", 
   RowBox[{"Log", "[", 
    RowBox[{"{", 
     RowBox[{"LP43", ",", "LP88", ",", "LP230", ",", "LP345"}], "}"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"deLP", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"StandardDeviation", "[", "#", "]"}], "/", 
      SqrtBox[
       RowBox[{"Length", "[", "#", "]"}]]}], "&"}], "/@", 
    RowBox[{"Log", "[", 
     RowBox[{"{", 
      RowBox[{"LP43", ",", "LP88", ",", "LP230", ",", "LP345"}], "}"}], 
     "]"}]}]}], ";", 
  RowBox[{
   RowBox[{"deLP", "[", 
    RowBox[{"[", "2", "]"}], "]"}], "=", "0.45"}], ";", 
  "deLP"}], "\[IndentingNewLine]", 
 RowBox[{"meEVPA", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Mean", "[", "#", "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"EVPA88", ",", "EVPA230", ",", "EVPA345"}], 
    "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"deEVPA", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"StandardDeviation", "[", "#", "]"}], "/", 
     SqrtBox[
      RowBox[{"Length", "[", "#", "]"}]]}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"EVPA88", ",", "EVPA230", ",", "EVPA345"}], 
    "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fr", "=", 
   RowBox[{"{", 
    RowBox[{
    "8", ",", "15", ",", "22", ",", "43", ",", "88", ",", "102", ",", "145", 
     ",", "230", ",", "345", ",", "674", ",", "857"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl", "=", 
   RowBox[{"ListLogLinearPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"fr", ",", 
          RowBox[{"meF", "-", "deF"}]}], "}"}], "]"}], ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"fr", ",", 
          RowBox[{"meF", "+", "deF"}]}], "}"}], "]"}]}], "}"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"LogLinearPlot", "[", 
    RowBox[{
     RowBox[{"2.87", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["x", "230"], ")"}], "0.45"], 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["x", "1100"], ")"}], "2"]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "8", ",", "857"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
        RowBox[{"AbsoluteDashing", "[", 
         RowBox[{"{", 
          RowBox[{"5", ",", "5"}], "}"}], "]"}], ",", "Red"}], "}"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"pl", ",", "lpl"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.501597017703*^9, 3.501597217396*^9}, {3.501600425366*^9,
   3.501600622352*^9}, {3.501600673749*^9, 3.5016006740439997`*^9}, {
  3.5016007157539997`*^9, 3.5016007165039997`*^9}, {3.501605548356*^9, 
  3.5016056474630003`*^9}, {3.501626647962*^9, 3.50162671467*^9}, {
  3.5020348833459997`*^9, 3.5020349593*^9}, {3.502036695076*^9, 
  3.502036695826*^9}, {3.502109750834*^9, 3.502109769191*^9}, {
  3.5021141450550003`*^9, 3.502114167293*^9}, {3.502114225579*^9, 
  3.502114239594*^9}, {3.528476050672882*^9, 3.528476069392953*^9}}],

Cell[BoxData[
 RowBox[{"2.87", 
  SuperscriptBox[
   RowBox[{"(", 
    FractionBox["x", "230"], ")"}], "0.45"], 
  RowBox[{"Exp", "[", 
   RowBox[{"-", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["x", "1100"], ")"}], "2"]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5021222438450003`*^9, 3.502122244908*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.502630209009*^9, 3.502630346558*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<ErrorBarPlots`\>\"", "]"}], ";", 
  RowBox[{"Needs", "[", "\"\<ErrorBarLogPlots`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"freq", "=", 
   RowBox[{"{", 
    RowBox[{
    "8.450", ",", "14.90", ",", "22.50", ",", "43.00", ",", "87.73", ",", 
     "102.0", ",", "145.0", ",", "230.9", ",", "349.0", ",", "674.0", ",", 
     "857.0"}], "}"}]}], ";", 
  RowBox[{"freqLP", "=", 
   RowBox[{"{", 
    RowBox[{"43", ",", "87.73", ",", "230.9", ",", "349"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fnu", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"freq", ",", "meF"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xFnu", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Partition", "[", 
      RowBox[{"Fnu", ",", "1"}], "]"}], ",", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"ErrorBar", "/@", "deF"}], ",", "1"}], "]"}], ",", "2"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"el", "=", 
   RowBox[{"{", 
    RowBox[{
    "LogLogPlot", ",", "ListLogLogPlot", ",", "ListLogLinearPlot", ",", 
     "ErrorListLogLogPlot", ",", "ErrorListLogLinearPlot"}], "}"}]}], ";", 
  RowBox[{"Clear", "[", "totI", "]"}], ";", 
  RowBox[{"xcol", "=", "Cyan"}], ";", 
  RowBox[{"myf", "=", "14"}], ";", 
  RowBox[{"siz", "=", "380"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"#", ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ","}], "*)"}], 
        RowBox[{
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}]}], "}"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"FrameTicks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"(*", 
           RowBox[{"{", 
            RowBox[{
            "10", ",", "20", ",", "50", ",", "100", ",", "200", ",", "500"}], 
            "}"}], "*)"}], 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "8", ",", "15", ",", "22", ",", "43", ",", "88", ",", "145", ",", 
             "231", ",", "349", ",", "690"}], "}"}], ",", "None"}], "}"}]}], 
        "}"}]}]}], "]"}], "&"}], "/@", "el"}], ";", 
  RowBox[{"lpl1", "=", 
   RowBox[{"ErrorListLogLogPlot", "[", 
    RowBox[{"xFnu", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"7", ",", "950"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.6", ",", "3.9"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Null", ",", "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}],
          "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}]}], 
    RowBox[{"(*", 
     RowBox[{",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsolutePointSize", "[", "6", "]"}], ",", "Blue"}], 
        "}"}]}]}], "*)"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"freq", ",", 
          RowBox[{"meF", "+", "deF"}]}], "}"}], "]"}], ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"freq", ",", 
          RowBox[{"meF", "-", "deF"}]}], "}"}], "]"}]}], "}"}], ",", 
     RowBox[{"Filling", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], "}"}]}], ",", 
     RowBox[{"FillingStyle", "\[Rule]", "LightCyan"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"7", ",", "950"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.6", ",", "3.9"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Null", ",", "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}],
          "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "0.5", "]"}]}]}], 
    RowBox[{"(*", 
     RowBox[{",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"PointSize", "[", "0.02", "]"}], ",", "xcol", ",", 
         RowBox[{"Point", "[", 
          RowBox[{"Log", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"8.45", ",", "0.72"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"14.9", ",", "1.03"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"23", ",", "1.1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"43", ",", "1.4"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"93", ",", "1.9"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"220", ",", "3.8"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"350", ",", "4.1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"690", ",", "2.7"}], "}"}]}], "}"}], "]"}], "]"}]}], 
        "}"}]}]}], "*)"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{
     RowBox[{"2.87", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["x", "230"], ")"}], "0.45"], 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["x", "1100"], ")"}], "2"]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "8.45", ",", "857"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", 
        RowBox[{"AbsoluteDashing", "[", 
         RowBox[{"{", 
          RowBox[{"5", ",", "5"}], "}"}], "]"}], ",", "Red"}], "}"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Fnupl", "=", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl", ",", "lpl1", ",", "pl"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"freqLP", "=", 
   RowBox[{"{", 
    RowBox[{"43", ",", "87.73", ",", "230.9", ",", "349"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"posLP", "=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"Log", "[", "meLP", "]"}], "+", "deLP"}], "]"}], "-", "meLP"}],
     ")"}]}], ";", 
  RowBox[{"posLPx", "=", 
   RowBox[{"0.85", "posLP"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"negLP", "=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"Log", "[", "meLP", "]"}], "-", "deLP"}], "]"}], "-", "meLP"}],
     ")"}]}], ";", 
  RowBox[{"negLPx", "=", 
   RowBox[{"1.2", "negLP"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xLP", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"freqLP", ",", "meLP"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xLPnu", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Partition", "[", 
      RowBox[{"xLP", ",", "1"}], "]"}], ",", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"ErrorBar", "/@", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"posLPx", ",", "negLPx"}], "}"}], "]"}]}], ",", "1"}], 
      "]"}], ",", "2"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ErrorListLogLogPlot", "[", 
    RowBox[{"xLPnu", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"35", ",", "400"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.3", ",", "10"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Null", ",", "\"\<LP [%]\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"freqLP", ",", 
          RowBox[{"meLP", "+", "posLP"}]}], "}"}], "]"}], ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"freqLP", ",", 
          RowBox[{"meLP", "+", "negLP"}]}], "}"}], "]"}]}], "}"}], ",", 
     RowBox[{"Filling", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], "}"}]}], ",", 
     RowBox[{"FillingStyle", "\[Rule]", "LightCyan"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"35", ",", "400"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.3", ",", "10"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Null", ",", "\"\<LP [%]\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "0.5", "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LPnupl", "=", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl", ",", "lpl1"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CPnu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"8.45", ",", 
       RowBox[{"-", "0.25"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14.90", ",", 
       RowBox[{"-", "0.62"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"231", ",", 
       RowBox[{"-", "1.2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"349", ",", 
       RowBox[{"-", "1.5"}]}], "}"}]}], "}"}]}], ";", 
  RowBox[{"CPf", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "CPnu", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"CPtr", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "CPnu", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"freqCP", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "CPnu", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"meCP", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "CPnu", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dCP", "=", 
   RowBox[{"{", 
    RowBox[{"0.06", ",", "0.26", ",", "0.3", ",", "0.3"}], "}"}]}], ";", 
  RowBox[{"xCPnu", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Partition", "[", 
      RowBox[{"CPnu", ",", "1"}], "]"}], ",", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"ErrorBar", "/@", "dCP"}], ",", "1"}], "]"}], ",", "2"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ErrorListLogLinearPlot", "[", 
    RowBox[{"xCPnu", ",", 
     RowBox[{"Joined", "\[Rule]", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"7", ",", "400"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "2."}], ",", 
          RowBox[{"-", "0.1"}]}], "}"}]}], "}"}]}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Null", ",", "\"\<CP [%]\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl", "=", 
   RowBox[{"ListLogLinearPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"freqCP", ",", 
          RowBox[{"meCP", "+", "dCP"}]}], "}"}], "]"}], ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"freqCP", ",", 
          RowBox[{"meCP", "-", "dCP"}]}], "}"}], "]"}]}], "}"}], ",", 
     RowBox[{"Filling", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], "}"}]}], ",", 
     RowBox[{"FillingStyle", "\[Rule]", "LightCyan"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"7", ",", "400"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "2."}], ",", 
          RowBox[{"-", "0.1"}]}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Null", ",", "\"\<CP [%]\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "0.5", "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CPnupl", "=", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl", ",", "lpl1"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"freqEVPA", "=", 
   RowBox[{"{", 
    RowBox[{"88", ",", "231", ",", "349"}], "}"}]}], ";", 
  RowBox[{"xEVPA", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"freqEVPA", ",", "meEVPA"}], "}"}], "]"}]}], ";", 
  RowBox[{"ran", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"75", ",", "400"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "30."}], ",", "170"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xEVPAnu", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Partition", "[", 
      RowBox[{"xEVPA", ",", "1"}], "]"}], ",", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"ErrorBar", "/@", "deEVPA"}], ",", "1"}], "]"}], ",", "2"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ErrorListLogLinearPlot", "[", 
    RowBox[{"xEVPAnu", ",", 
     RowBox[{"Joined", "\[Rule]", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "ran"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lpl", "=", 
    RowBox[{"ListLogLinearPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"freqEVPA", ",", 
           RowBox[{"meEVPA", "+", "deEVPA"}]}], "}"}], "]"}], ",", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"freqEVPA", ",", 
           RowBox[{"meEVPA", "-", "deEVPA"}]}], "}"}], "]"}]}], "}"}], ",", 
      RowBox[{"Filling", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"1", "\[Rule]", 
         RowBox[{"{", "2", "}"}]}], "}"}]}], ",", 
      RowBox[{"FillingStyle", "\[Rule]", "LightCyan"}], ",", 
      RowBox[{"FrameLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Null", ",", "Null"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
          "Null", ",", "\"\<Electric vector position angle [deg]\>\""}], 
          "}"}]}], "}"}]}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", "ran"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "0.5", "]"}]}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"sol", "=", 
     RowBox[{"FindFit", "[", 
      RowBox[{
       RowBox[{"xEVPA", "[", 
        RowBox[{"[", 
         RowBox[{"2", ";;", "3"}], "]"}], "]"}], ",", 
       RowBox[{"A", "+", 
        FractionBox["B", 
         SuperscriptBox["f", "2"]]}], ",", 
       RowBox[{"{", 
        RowBox[{"A", ",", "B"}], "}"}], ",", "f"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"lfi", "=", 
     RowBox[{"LogLinearPlot", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"A", "+", 
         FractionBox["B", 
          SuperscriptBox["f", "2"]]}], "/.", "sol"}], ",", 
       RowBox[{"{", 
        RowBox[{"f", ",", "70", ",", "400"}], "}"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "ran"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "0.5", "]"}]}]}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"EVPAnupl", "=", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl", ",", "lpl1"}], 
     RowBox[{"(*", 
      RowBox[{",", "lfi"}], "*)"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"totimag", "=", 
   RowBox[{"GraphicsGrid", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Fnupl", ",", "EVPAnupl"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"LPnupl", ",", "CPnupl"}], "}"}]}], "}"}], ",", 
     RowBox[{"Epilog", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Black", ",", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
            RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"ImageScaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.43", ",", "0.53"}], "}"}], "]"}]}], "]"}], ",", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
            RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"ImageScaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.43", ",", "0.03"}], "}"}], "]"}]}], "]"}], ",", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
            RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"ImageScaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.955", ",", "0.53"}], "}"}], "]"}]}], "]"}], ",", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
            RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"ImageScaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.955", ",", "0.03"}], "}"}], "]"}]}], "]"}]}], "}"}]}], 
     ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", 
         RowBox[{"myf", "-", "2"}]}]}], "}"}]}], ",", 
     RowBox[{
     "PlotLabel", "\[Rule]", "\"\<Compilation of observations\>\""}]}], 
    "]"}]}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ","}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dir", "=", 
   "\"\<C:\\\\study\\\\accretion\\\\! 2009 3fall cfa\\\\GR Polarized modeling\
\\\\svn\\\\harm_roman\\\\\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"dir", "<>", "\"\<SED.eps\>\""}], ",", "totimag", ",", 
    RowBox[{"\"\<EmbeddedFonts\>\"", "\[Rule]", "True"}]}], "]"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"dir", "<>", "\"\<SED.pdf\>\""}], ",", "totimag"}], "]"}], 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5020436574110003`*^9, 3.502043716951*^9}, {
   3.5020437635810003`*^9, 3.502043838344*^9}, {3.502043880822*^9, 
   3.502044000814*^9}, {3.502044034076*^9, 3.502044046251*^9}, {
   3.502044137105*^9, 3.5020442680290003`*^9}, {3.5020443093050003`*^9, 
   3.5020444196879997`*^9}, {3.502044592623*^9, 3.502044611196*^9}, 
   3.502044655959*^9, {3.502108851251*^9, 3.502108857632*^9}, {
   3.5021090746549997`*^9, 3.502109087068*^9}, {3.502109173495*^9, 
   3.502109173582*^9}, {3.5021098318059998`*^9, 3.502109851605*^9}, {
   3.502111572615*^9, 3.5021115730810003`*^9}, {3.502112634289*^9, 
   3.502112634836*^9}, {3.5021127668900003`*^9, 3.5021127718570004`*^9}, {
   3.502113139858*^9, 3.5021131401029997`*^9}, {3.502113249834*^9, 
   3.502113250142*^9}, {3.502113341284*^9, 3.502113383547*^9}, {
   3.502113639508*^9, 3.502113643571*^9}, {3.5021143063389997`*^9, 
   3.5021143067790003`*^9}, {3.502121674262*^9, 3.502121706863*^9}, {
   3.502121800462*^9, 3.502121830835*^9}, {3.502121892653*^9, 
   3.5021220093459997`*^9}, {3.5102490853046*^9, 3.5102491199706*^9}, {
   3.5102492954636*^9, 3.5102493045806*^9}, {3.5102494512536*^9, 
   3.5102494816666*^9}, {3.5284763600995803`*^9, 3.5284763859790606`*^9}, {
   3.528476425764336*^9, 3.528476479585415*^9}, {3.528476509887148*^9, 
   3.5284765112282248`*^9}}],

Cell["\<\
200 cores at a time \[Implies] 25 tasks at a time; 6hr - each task
7*50=350 tasks\
\>", "Text",
 CellChangeTimes->{{3.5020370185360003`*^9, 3.5020370488719997`*^9}, {
  3.50203959971*^9, 3.502039647865*^9}, {3.5020396788719997`*^9, 
  3.502039698783*^9}, {3.5020397473900003`*^9, 3.5020397493719997`*^9}}],

Cell[BoxData[{
 RowBox[{"Print", "[", 
  RowBox[{
   RowBox[{
    FractionBox["350", "25"], "*", 
    RowBox[{"6", "/", "24."}]}], ",", "\"\< days to finish\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
   RowBox[{"350", "*", "8", "*", "6"}], ",", "\"\< CPU-hours\>\""}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.502039763192*^9, 3.502039803219*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Dynamical model: velocity, density, B (Figure 4, 5) - ",
 StyleBox["done",
  FontColor->RGBColor[0, 0, 1]],
 "           ",
 StyleBox["(figures 2, 3 are made outside)",
  FontSize->10]
}], "Subsection",
 CellChangeTimes->{{3.486728186241*^9, 3.486728215639*^9}, {
  3.4891537356571326`*^9, 3.4891537396195326`*^9}, {3.502627699617*^9, 
  3.502627700368*^9}, {3.529164255712641*^9, 3.529164282520174*^9}}],

Cell[CellGroupData[{

Cell["Initial setup (just run once)", "Subsubsection",
 CellChangeTimes->{{3.486059037139606*^9, 3.4860590644907017`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"AppendTo", "[", 
   RowBox[{
   "$Path", ",", 
    "\"\<C:\\\\Program Files\\\\Wolfram \
Research\\\\Mathematica\\\\LevelScheme-3.52\>\""}], "]"}], ";", 
  RowBox[{"Get", "[", "\"\<LevelScheme`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "din", "=", 
   "\"\<C:\\\\study\\\\accretion\\\\! 2009 3fall cfa\\\\GR Polarized modeling\
\\\\Bob_shcherbakov2010\\\\\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dout", "=", 
   "\"\<C:\\\\study\\\\accretion\\\\! 2009 3fall cfa\\\\GR Polarized modeling\
\\\\\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n1", "=", "256"}], ";", 
  RowBox[{"n2", "=", "64"}], ";", 
  RowBox[{"ntot", "=", 
   RowBox[{"n1", " ", "n2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"a", "=", "0.9"}], ";", 
   RowBox[{"rhor", "=", "1.4"}], ";", 
   RowBox[{"risco", "=", "2.3"}], ";", 
   RowBox[{"Rout", "=", "20"}], ";", 
   RowBox[{"ymax", "=", "6"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"blackhole", "=", 
   RowBox[{"Graphics", "[", 
    RowBox[{"Disk", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], ",", "rhor"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ISCOline", "=", 
    RowBox[{"Graphics", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"RGBColor", "[", 
        RowBox[{"1", ",", "1", ",", "1"}], "]"}], ",", 
       RowBox[{"Thickness", "[", "Large", "]"}], ",", 
       RowBox[{"Dashing", "[", 
        RowBox[{"{", 
         RowBox[{"Small", ",", "Small"}], "}"}], "]"}], ",", 
       RowBox[{"Line", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"risco", ",", 
            RowBox[{"-", "ymax"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"risco", ",", "ymax"}], "}"}]}], "}"}], "]"}]}], "}"}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{"ListDensityPlot", ",", 
     RowBox[{"Mesh", "\[Rule]", "False"}], ",", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"ColorFunction", "\[Rule]", "GrayLevel"}], ","}], " ", "*)"}], 
     RowBox[{"ColorFunction", "\[Rule]", "\"\<DarkRainbow\>\""}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "}"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<r/M\>\"", ",", "\"\<z/M\>\""}], "}"}]}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "3"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "Rout"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "ymax"}], ",", "ymax"}], "}"}], ",", "All"}], "}"}]}], 
     ",", 
     RowBox[{"RegionFunction", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "y", ",", "z"}], "}"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Norm", "[", "x", "]"}], "<", "Rout"}], " ", "&&", 
         RowBox[{
          RowBox[{"Norm", "[", "y", "]"}], "<", "ymax"}], "&&", " ", 
         RowBox[{
          RowBox[{"Norm", "[", 
           RowBox[{
            SuperscriptBox["x", "2"], "+", 
            SuperscriptBox["y", "2"]}], "]"}], ">", 
          RowBox[{
           SuperscriptBox["0.98", "2"], "rhor"}]}]}]}], "]"}]}]}], "]"}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"ListContourPlot", ",", 
    RowBox[{"Contours", "\[Rule]", "10"}], ",", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"ContourLabels", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"Round", "[", "#3", "]"}], ",", 
             RowBox[{"FontSize", "\[Rule]", "myfontsize"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"#1", ",", "#2"}], "}"}]}], "]"}], "&"}], ")"}]}], ","}], 
     "*)"}], 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"ColorFunction", "\[Rule]", "GrayLevel"}], ","}], "*)"}], 
    RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}], ",", 
    RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
       RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "}"}]}], ",", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"FrameStyle", "\[Rule]", "$TextStyle"}], ","}], "*)"}], 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<r/M\>\"", ",", "\"\<z/M\>\""}], "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "Rout"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "ymax"}], ",", "ymax"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"RegionFunction", "\[Rule]", 
     RowBox[{"Function", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "y", ",", "z"}], "}"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Norm", "[", "x", "]"}], "<", "Rout"}], " ", "&&", 
        RowBox[{
         RowBox[{"Norm", "[", "y", "]"}], "<", "ymax"}], "&&", " ", 
        RowBox[{
         RowBox[{"Norm", "[", 
          RowBox[{
           SuperscriptBox["x", "2"], "+", 
           SuperscriptBox["y", "2"]}], "]"}], ">", 
         RowBox[{
          SuperscriptBox["0.98", "2"], "rhor"}]}]}]}], "]"}]}]}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.473721696857315*^9, 3.4737217053846607`*^9}, {
   3.473721739920866*^9, 3.473721740194209*^9}, {3.4739045850366907`*^9, 
   3.473904591336821*^9}, {3.474861364933064*^9, 3.4748613938592663`*^9}, {
   3.486058545965501*^9, 3.48605854629078*^9}, {3.486058585375409*^9, 
   3.4860586130413218`*^9}, {3.486059030148364*^9, 3.4860590305832*^9}, {
   3.4860591060101337`*^9, 3.486059106910787*^9}, {3.486059215759385*^9, 
   3.486059217436496*^9}, {3.486059251346848*^9, 3.4860592515663843`*^9}, {
   3.486059728881339*^9, 3.4860597295492697`*^9}, {3.486060723382163*^9, 
   3.48606073589791*^9}, {3.486391149903*^9, 3.486391151141*^9}, {
   3.486391198948*^9, 3.486391210737*^9}, {3.4863912965480003`*^9, 
   3.486391334828*^9}, {3.486391415104*^9, 3.4863914346029997`*^9}, {
   3.4863914878129997`*^9, 3.486391493498*^9}, 3.4863918958310003`*^9, {
   3.48639214484*^9, 3.486392158349*^9}, {3.48639220442*^9, 
   3.4863922747209997`*^9}, {3.486392306231*^9, 3.4863923112869997`*^9}, 
   3.486392933818*^9, {3.4863956375264606`*^9, 3.486395639226861*^9}, {
   3.486728035958*^9, 3.4867280382469997`*^9}, {3.502122601384*^9, 
   3.502122621291*^9}, {3.502122665211*^9, 3.502122707725*^9}, {
   3.529160511588489*^9, 3.5291605121965237`*^9}, {3.5291607524312644`*^9, 
   3.529160754541385*^9}, {3.529161133983088*^9, 3.529161136711244*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Snapshot panel", "Subsubsection",
 CellChangeTimes->{{3.486059037139606*^9, 3.4860590386357803`*^9}, {
  3.486059224275392*^9, 3.486059227833602*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"array", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"din", "<>", "\"\<timeshot14000M/checkmri.dat\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"array", "[", 
     RowBox[{"[", 
      RowBox[{"ii", ",", "2"}], "]"}], "]"}], "=", "0"}], ",", 
   RowBox[{"{", 
    RowBox[{"ii", ",", "1", ",", "ntot", ",", "n2"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"array", "[", 
     RowBox[{"[", 
      RowBox[{"ii", ",", "2"}], "]"}], "]"}], "=", "\[Pi]"}], ",", 
   RowBox[{"{", 
    RowBox[{"ii", ",", "64", ",", "ntot", ",", "n2"}], "}"}]}], "]"}], "\n", 
 RowBox[{
  RowBox[{"i", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"myr", "=", 
      RowBox[{"array", "[", 
       RowBox[{"[", 
        RowBox[{"ii", ",", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"mytheta", "=", 
      RowBox[{"array", "[", 
       RowBox[{"[", 
        RowBox[{"ii", ",", "2"}], "]"}], "]"}]}], ";", 
     RowBox[{"myx", "=", 
      RowBox[{"myr", " ", 
       RowBox[{"Sin", "[", "mytheta", "]"}]}]}], ";", 
     RowBox[{"myy", "=", 
      RowBox[{"myr", " ", 
       RowBox[{"Cos", "[", "mytheta", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", "  ", 
      RowBox[{
       RowBox[{
       "This", " ", "loop", " ", "grabs", " ", "all", " ", "the", " ", "data",
         " ", "in", " ", "a", " ", "box", " ", "stretching", " ", "from", " ",
         "the", " ", "horizon", " ", "to", " ", "Rout"}], ",", " ", 
       RowBox[{
        RowBox[{"and", " ", "from"}], " ", "-", 
        RowBox[{"ymax", " ", "to", " ", 
         RowBox[{"ymax", ".", "  ", "It"}], " ", "speeds", " ", "up", " ", 
         "the", " ", "plot", " ", "generation", " ", "and", " ", "helps", " ",
          "with", " ", "the", " ", "color", " ", 
         RowBox[{"scale", ".", "  ", "Note"}], " ", "that", " ", "we", " ", 
         "start", " ", "slightly", " ", "inside", " ", "the", " ", "horizon", 
         " ", "and", " ", "extend", " ", "to", " ", "slightly", " ", 
         "outside", " ", 
         RowBox[{"Rout", ":", " ", 
          RowBox[{
          "this", " ", "avoids", " ", "white", " ", "regions", " ", "at", " ",
            "the", " ", "plot", " ", 
           RowBox[{"edges", "."}]}]}]}]}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"myr", "\[GreaterEqual]", 
         RowBox[{"0.98", " ", "rhor"}]}], "&&", 
        RowBox[{"myx", "\[LessEqual]", " ", "Rout"}], "&&", 
        RowBox[{
         RowBox[{"-", "ymax"}], "\[LessEqual]", "myy", "\[LessEqual]", 
         "ymax"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"i", "=", 
         RowBox[{"i", "+", "1"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"rr", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "1"}], "]"}], "]"}]}], ";", 
        RowBox[{
         RowBox[{"theta", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "2"}], "]"}], "]"}]}], ";", 
        RowBox[{
         RowBox[{"lamMRI", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "3"}], "]"}], "]"}]}], ";", 
        RowBox[{
         RowBox[{"beta", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "4"}], "]"}], "]"}]}], ";", 
        RowBox[{
         RowBox[{"rho", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "5"}], "]"}], "]"}]}], ";", 
        RowBox[{
         RowBox[{"bsq", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "6"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"vel1", "[", "i", "]"}], "=", 
           RowBox[{"array", "[", 
            RowBox[{"[", 
             RowBox[{"ii", ",", "7"}], "]"}], "]"}]}], ";", 
          RowBox[{
           RowBox[{"vel2", "[", "i", "]"}], "=", 
           RowBox[{"array", "[", 
            RowBox[{"[", 
             RowBox[{"ii", ",", "8"}], "]"}], "]"}]}], ";"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "r", " ", "and", " ", "theta", " ", "lab", " ", "frame", " ", 
          "magnetic", " ", "field", " ", "components"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"B1", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "13"}], "]"}], "]"}]}], ";", 
        RowBox[{
         RowBox[{"B2", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "14"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"x", "[", "i", "]"}], "=", 
         RowBox[{
          RowBox[{"rr", "[", "i", "]"}], 
          RowBox[{"Sin", "[", 
           RowBox[{"theta", "[", "i", "]"}], "]"}]}]}], ";", 
        RowBox[{
         RowBox[{"y", "[", "i", "]"}], "=", 
         RowBox[{
          RowBox[{"rr", "[", "i", "]"}], 
          RowBox[{"Cos", "[", 
           RowBox[{"theta", "[", "i", "]"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "r", " ", "and", " ", "theta", " ", "velocities", " ", "in", " ", 
          "the", " ", "locally", " ", "flat", " ", "frame"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"myvel1", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "11"}], "]"}], "]"}]}], ";", 
        RowBox[{
         RowBox[{"myvel2", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "12"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Convert", " ", "to", " ", "magnetic", " ", "and", " ", "velocity", 
          " ", "fields", " ", "to", " ", "cartesian", " ", "coordinates", " ",
           "x", " ", "and", " ", "y", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"a", ".", "k", ".", "a", ".", " ", "r"}], " ", "and", " ",
             "z"}], ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Bx", "[", "i", "]"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Sin", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"B1", "[", "i", "]"}]}], "+", 
          RowBox[{
           RowBox[{"Cos", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"B2", "[", "i", "]"}]}]}]}], ";", 
        RowBox[{
         RowBox[{"By", "[", "i", "]"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Cos", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"B1", "[", "i", "]"}]}], "-", 
          RowBox[{
           RowBox[{"Sin", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"B2", "[", "i", "]"}]}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"vx", "[", "i", "]"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Sin", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"myvel1", "[", "i", "]"}]}], "+", 
          RowBox[{
           RowBox[{"Cos", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"myvel2", "[", "i", "]"}]}]}]}], ";", 
        RowBox[{
         RowBox[{"vy", "[", "i", "]"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Cos", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"myvel1", "[", "i", "]"}]}], "-", 
          RowBox[{
           RowBox[{"Sin", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"myvel2", "[", "i", "]"}]}]}]}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Continue", "[", "]"}]}], "]"}]}], "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"ii", ",", "1", ",", "ntot"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Create", " ", "tables", " ", "of", " ", "velocity", " ", "and", " ", 
    "magnetic", " ", "field", " ", "for", " ", "plotting"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabB", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"rr", "[", "ii", "]"}], 
          RowBox[{"Sin", "[", 
           RowBox[{"theta", "[", "ii", "]"}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"rr", "[", "ii", "]"}], 
          RowBox[{"Cos", "[", 
           RowBox[{"theta", "[", "ii", "]"}], "]"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Bx", "[", "ii", "]"}], ",", 
         RowBox[{"By", "[", "ii", "]"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "1", ",", "i"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tabv", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"rr", "[", "ii", "]"}], 
           RowBox[{"Sin", "[", 
            RowBox[{"theta", "[", "ii", "]"}], "]"}]}], ",", 
          RowBox[{
           RowBox[{"rr", "[", "ii", "]"}], 
           RowBox[{"Cos", "[", 
            RowBox[{"theta", "[", "ii", "]"}], "]"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"vx", "[", "ii", "]"}], ",", 
          RowBox[{"vy", "[", "ii", "]"}]}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "1", ",", "i"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\n", 
  RowBox[{"(*", " ", 
   RowBox[{"Create", " ", "v", " ", "plots"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mysize", "=", "20"}], ";", 
  RowBox[{"bsqarray", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x", "[", "i", "]"}], ",", 
       RowBox[{"y", "[", "i", "]"}], ",", 
       RowBox[{"rho", "[", "i", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "ntot"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"bsqplot", "=", 
    RowBox[{"ListDensityPlot", "[", 
     RowBox[{"bsqarray", ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"GrayLevel", "[", 
          SuperscriptBox["#", 
           RowBox[{"1", "/", "2"}]], "]"}], "&"}], ")"}]}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "Rout"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "ymax"}], ",", "ymax"}], "}"}]}], "}"}]}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Magnetic", " ", "field", " ", "stream", " ", "lines"}], " ", 
   "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Bstream1", "=", 
    RowBox[{"ListStreamPlot", "[", 
     RowBox[{"tabv", ",", 
      RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"StreamStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"Red", ",", 
         RowBox[{"Thickness", "[", "0.003", "]"}]}], "]"}]}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "Rout"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "ymax"}], ",", "ymax"}], "}"}], ",", "All"}], "}"}]}],
       ",", 
      RowBox[{"StreamPoints", "\[Rule]", "200"}]}], "]"}]}], ";"}], "\n", 
  RowBox[{"(*", " ", "Combined", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"shotfigwithhole", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"bsqplot", ",", "Bstream1"}], "}"}], ",", "ISCOline", ",", 
     "blackhole"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"shotfig", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"bsqplot", ",", "Bstream1"}], "}"}], ",", "ISCOline"}], "]"}]}],
   "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Create", " ", "B", " ", "plots"}], " ", "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"mysize", "=", "20"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"bsqarray", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x", "[", "i", "]"}], ",", 
       RowBox[{"y", "[", "i", "]"}], ",", 
       RowBox[{"bsq", "[", "i", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "ntot"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"bsqplot", "=", 
    RowBox[{"ListDensityPlot", "[", 
     RowBox[{"bsqarray", ",", "\[IndentingNewLine]", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"GrayLevel", "[", 
          SuperscriptBox["#", 
           RowBox[{"1", "/", "2"}]], "]"}], "&"}], ")"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "Rout"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "ymax"}], ",", "ymax"}], "}"}]}], "}"}]}]}], "]"}]}], 
   ";"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{"Magnetic", " ", "field", " ", "stream", " ", "lines"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Bstream1", "=", 
    RowBox[{"ListStreamPlot", "[", 
     RowBox[{"tabB", ",", 
      RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"StreamStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"Red", ",", 
         RowBox[{"Thickness", "[", "0.003", "]"}]}], "]"}]}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "Rout"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "ymax"}], ",", "ymax"}], "}"}], ",", "All"}], "}"}]}],
       ",", 
      RowBox[{"StreamPoints", "\[Rule]", "200"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Combined", " ", "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"shotfigwithholeB", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"bsqplot", ",", "Bstream1"}], "}"}], ",", "ISCOline", ",", 
     "blackhole"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"shotfigB", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"bsqplot", ",", "Bstream1"}], "}"}], ",", "ISCOline"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.473721746910077*^9, 3.473721820182495*^9}, {
   3.473721901182987*^9, 3.4737219084064693`*^9}, {3.473904221202067*^9, 
   3.473904234501606*^9}, 3.47390441293296*^9, {3.4739046905712*^9, 
   3.473904691593081*^9}, {3.473904758214375*^9, 3.473904785707958*^9}, {
   3.4860589499613247`*^9, 3.486059015964347*^9}, {3.4860591220941277`*^9, 
   3.486059193240893*^9}, {3.486059240813663*^9, 3.4860592726249723`*^9}, {
   3.486059413435246*^9, 3.486059444101307*^9}, {3.4860597344334917`*^9, 
   3.4860597354557858`*^9}, {3.486060962959914*^9, 3.4860609675157833`*^9}, {
   3.486061558418633*^9, 3.486061566747822*^9}, {3.486391525389*^9, 
   3.486391526074*^9}, 3.486728026816*^9, {3.4867280568380003`*^9, 
   3.486728101924*^9}, {3.5024575169440002`*^9, 3.502457517009*^9}, {
   3.502457612486*^9, 3.502457612575*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Saturated state", "Subsubsection",
 CellChangeTimes->{{3.486059037139606*^9, 3.4860590386357803`*^9}, {
  3.486059224275392*^9, 3.486059227833602*^9}, {3.4860593935071793`*^9, 
  3.486059399777689*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"array", "=", 
    RowBox[{"Import", "[", 
     RowBox[{"din", "<>", "\"\<averaged14000to20000M/checkmri.dat\>\""}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"array", "[", 
     RowBox[{"[", 
      RowBox[{"ii", ",", "2"}], "]"}], "]"}], "=", "0"}], ",", 
   RowBox[{"{", 
    RowBox[{"ii", ",", "1", ",", "ntot", ",", "n2"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"array", "[", 
      RowBox[{"[", 
       RowBox[{"ii", ",", "2"}], "]"}], "]"}], "=", "\[Pi]"}], ",", 
    RowBox[{"{", 
     RowBox[{"ii", ",", "64", ",", "ntot", ",", "n2"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"i", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"myr", "=", 
      RowBox[{"array", "[", 
       RowBox[{"[", 
        RowBox[{"ii", ",", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"mytheta", "=", 
      RowBox[{"array", "[", 
       RowBox[{"[", 
        RowBox[{"ii", ",", "2"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"myx", "=", 
      RowBox[{"myr", " ", 
       RowBox[{"Sin", "[", "mytheta", "]"}]}]}], ";", 
     RowBox[{"myy", "=", 
      RowBox[{"myr", " ", 
       RowBox[{"Cos", "[", "mytheta", "]"}]}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", "  ", 
      RowBox[{
       RowBox[{
       "This", " ", "loop", " ", "grabs", " ", "all", " ", "the", " ", "data",
         " ", "in", " ", "a", " ", "box", " ", "stretching", " ", "from", " ",
         "the", " ", "horizon", " ", "to", " ", "Rout"}], ",", " ", 
       RowBox[{
        RowBox[{"and", " ", "from"}], " ", "-", 
        RowBox[{"ymax", " ", "to", " ", 
         RowBox[{"ymax", ".", "  ", "It"}], " ", "speeds", " ", "up", " ", 
         "the", " ", "plot", " ", "generation", " ", "and", " ", "helps", " ",
          "with", " ", "the", " ", "color", " ", 
         RowBox[{"scale", ".", "  ", "Note"}], " ", "that", " ", "we", " ", 
         "start", " ", "slightly", " ", "inside", " ", "the", " ", "horizon", 
         " ", "and", " ", "extend", " ", "to", " ", "slightly", " ", 
         "outside", " ", 
         RowBox[{"Rout", ":", " ", 
          RowBox[{
          "this", " ", "avoids", " ", "white", " ", "regions", " ", "at", " ",
            "the", " ", "plot", " ", 
           RowBox[{"edges", "."}]}]}]}]}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"myr", "\[GreaterEqual]", 
         RowBox[{"0.98", " ", "rhor"}]}], "&&", 
        RowBox[{"myx", "\[LessEqual]", "Rout"}], "&&", 
        RowBox[{
         RowBox[{"-", "ymax"}], "\[LessEqual]", "myy", "\[LessEqual]", 
         "ymax"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"i", "=", 
         RowBox[{"i", "+", "1"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"rr", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "1"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"theta", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "2"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"lamMRI", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "3"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"beta", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "4"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"rho", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "5"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"bsq", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "6"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"vel1", "[", "i", "]"}], "=", 
           RowBox[{"array", "[", 
            RowBox[{"[", 
             RowBox[{"ii", ",", "7"}], "]"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"vel2", "[", "i", "]"}], "=", 
           RowBox[{"array", "[", 
            RowBox[{"[", 
             RowBox[{"ii", ",", "8"}], "]"}], "]"}]}], ";"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "r", " ", "and", " ", "theta", " ", "lab", " ", "frame", " ", 
          "magnetic", " ", "field", " ", "components"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"B1", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "13"}], "]"}], "]"}]}], ";", 
        RowBox[{
         RowBox[{"B2", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "14"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"x", "[", "i", "]"}], "=", 
         RowBox[{
          RowBox[{"rr", "[", "i", "]"}], 
          RowBox[{"Sin", "[", 
           RowBox[{"theta", "[", "i", "]"}], "]"}]}]}], ";", 
        RowBox[{
         RowBox[{"y", "[", "i", "]"}], "=", 
         RowBox[{
          RowBox[{"rr", "[", "i", "]"}], 
          RowBox[{"Cos", "[", 
           RowBox[{"theta", "[", "i", "]"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "r", " ", "and", " ", "theta", " ", "velocities", " ", "in", " ", 
          "the", " ", "locally", " ", "flat", " ", "frame"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"myvel1", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "11"}], "]"}], "]"}]}], ";", 
        RowBox[{
         RowBox[{"myvel2", "[", "i", "]"}], "=", 
         RowBox[{"array", "[", 
          RowBox[{"[", 
           RowBox[{"ii", ",", "12"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Convert", " ", "to", " ", "magnetic", " ", "and", " ", "velocity", 
          " ", "fields", " ", "to", " ", "cartesian", " ", "coordinates", " ",
           "x", " ", "and", " ", "y", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"a", ".", "k", ".", "a", ".", " ", "r"}], " ", "and", " ",
             "z"}], ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Bx", "[", "i", "]"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Sin", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"B1", "[", "i", "]"}]}], "+", 
          RowBox[{
           RowBox[{"Cos", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"B2", "[", "i", "]"}]}]}]}], ";", 
        RowBox[{
         RowBox[{"By", "[", "i", "]"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Cos", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"B1", "[", "i", "]"}]}], "-", 
          RowBox[{
           RowBox[{"Sin", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"B2", "[", "i", "]"}]}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"vx", "[", "i", "]"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Sin", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"myvel1", "[", "i", "]"}]}], "+", 
          RowBox[{
           RowBox[{"Cos", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"myvel2", "[", "i", "]"}]}]}]}], ";", 
        RowBox[{
         RowBox[{"vy", "[", "i", "]"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Cos", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"myvel1", "[", "i", "]"}]}], "-", 
          RowBox[{
           RowBox[{"Sin", "[", 
            RowBox[{"theta", "[", "i", "]"}], "]"}], 
           RowBox[{"myvel2", "[", "i", "]"}]}]}]}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Continue", "[", "]"}]}], "]"}]}], "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"ii", ",", "1", ",", "ntot"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Create", " ", "tables", " ", "of", " ", "velocity", " ", "and", " ", 
    "magnetic", " ", "field", " ", "for", " ", "plotting"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabv", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"rr", "[", "ii", "]"}], 
          RowBox[{"Sin", "[", 
           RowBox[{"theta", "[", "ii", "]"}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"rr", "[", "ii", "]"}], 
          RowBox[{"Cos", "[", 
           RowBox[{"theta", "[", "ii", "]"}], "]"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"vx", "[", "ii", "]"}], ",", 
         RowBox[{"vy", "[", "ii", "]"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ii", ",", "1", ",", "i"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tabB", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"rr", "[", "ii", "]"}], 
           RowBox[{"Sin", "[", 
            RowBox[{"theta", "[", "ii", "]"}], "]"}]}], ",", 
          RowBox[{
           RowBox[{"rr", "[", "ii", "]"}], 
           RowBox[{"Cos", "[", 
            RowBox[{"theta", "[", "ii", "]"}], "]"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Bx", "[", "ii", "]"}], ",", 
          RowBox[{"By", "[", "ii", "]"}]}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"ii", ",", "1", ",", "i"}], "}"}]}], "]"}]}], ";"}], "\n", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Create", " ", "v", " ", "plots"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rout", "=", "20"}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"mysize", "=", "16"}], ";"}], "*)"}], 
  RowBox[{"bsqarray", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x", "[", "i", "]"}], ",", 
       RowBox[{"y", "[", "i", "]"}], ",", 
       RowBox[{"rho", "[", "i", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "ntot"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"bsqplot2", "=", 
    RowBox[{"ListDensityPlot", "[", 
     RowBox[{"bsqarray", ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"GrayLevel", "[", 
          SuperscriptBox["#", 
           RowBox[{"1", "/", "2"}]], "]"}], "&"}], ")"}]}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "Rout"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "ymax"}], ",", "ymax"}], "}"}]}], "}"}]}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Magnetic", " ", "field", " ", "stream", " ", "lines"}], " ", 
   "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Bstream2", "=", 
    RowBox[{"ListStreamPlot", "[", 
     RowBox[{"tabv", ",", "\[IndentingNewLine]", 
      RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"StreamStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"Red", ",", 
         RowBox[{"Thickness", "[", "0.003", "]"}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "Rout"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "ymax"}], ",", "ymax"}], "}"}], ",", "All"}], "}"}]}],
       ",", "\[IndentingNewLine]", 
      RowBox[{"StreamPoints", "\[Rule]", "200"}]}], "]"}]}], ";"}], "\n", 
  RowBox[{"(*", " ", "Combined", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"satfigwhole", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"bsqplot2", ",", "Bstream2"}], "}"}], ",", "ISCOline", ",", 
     "blackhole"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"satfig", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"bsqplot2", ",", "Bstream2"}], "}"}], ",", "ISCOline"}], 
    "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Create", " ", "B", " ", "plots"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"Rout", "=", "20"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mysize", "=", "20"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"bsqarray", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x", "[", "i", "]"}], ",", 
       RowBox[{"y", "[", "i", "]"}], ",", 
       RowBox[{"bsq", "[", "i", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "ntot"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"bsqplot2", "=", 
    RowBox[{"ListDensityPlot", "[", 
     RowBox[{"bsqarray", ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"GrayLevel", "[", 
          SuperscriptBox["#", 
           RowBox[{"1", "/", "2"}]], "]"}], "&"}], ")"}]}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "Rout"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "ymax"}], ",", "ymax"}], "}"}]}], "}"}]}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Magnetic", " ", "field", " ", "stream", " ", "lines"}], " ", 
   "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Bstream2", "=", 
    RowBox[{"ListStreamPlot", "[", 
     RowBox[{"tabB", ",", 
      RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"StreamStyle", "\[Rule]", 
       RowBox[{"Directive", "[", 
        RowBox[{"Red", ",", 
         RowBox[{"Thickness", "[", "0.003", "]"}]}], "]"}]}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "Rout"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "ymax"}], ",", "ymax"}], "}"}], ",", "All"}], "}"}]}],
       ",", 
      RowBox[{"StreamPoints", "\[Rule]", "200"}]}], "]"}]}], ";"}], "\n", 
  RowBox[{"(*", " ", "Combined", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"satfigwholeB", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"bsqplot2", ",", "Bstream2"}], "}"}], ",", "ISCOline", ",", 
     "blackhole"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"satfigB", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"bsqplot2", ",", "Bstream2"}], "}"}], ",", "ISCOline"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.473721746910077*^9, 3.473721820182495*^9}, {
   3.473721901182987*^9, 3.4737219084064693`*^9}, {3.473904221202067*^9, 
   3.473904234501606*^9}, 3.47390441293296*^9, {3.4739046905712*^9, 
   3.473904691593081*^9}, {3.473904758214375*^9, 3.473904785707958*^9}, {
   3.4860589499613247`*^9, 3.486059015964347*^9}, {3.4860591220941277`*^9, 
   3.486059193240893*^9}, {3.486059240813663*^9, 3.4860592726249723`*^9}, {
   3.486059303158854*^9, 3.4860593907477818`*^9}, {3.48605974087052*^9, 
   3.48605974168118*^9}, {3.48605987022514*^9, 3.486059871664624*^9}, {
   3.48606055448892*^9, 3.486060559076057*^9}, {3.486061628820092*^9, 
   3.4860616355683823`*^9}, {3.486391698593*^9, 3.486391699616*^9}, {
   3.486727834862*^9, 3.486727854678*^9}, {3.486727992369*^9, 
   3.486727995583*^9}, {3.486728121967*^9, 3.486728124507*^9}, {
   3.50245769309*^9, 3.502457716692*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Combined, 2-panel figure", "Subsubsection",
 CellChangeTimes->{{3.486059341194628*^9, 3.486059346690666*^9}, {
  3.486059403834628*^9, 3.4860594061136627`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ratio", "=", "0.25"}], ";", 
  RowBox[{"ysc", "=", "10"}], ";", 
  RowBox[{"num", "=", "10"}], ";", 
  RowBox[{"xsc", "=", 
   RowBox[{"ratio", " ", "ysc"}]}], ";", 
  RowBox[{
   RowBox[{"fcol", "[", "a_", "]"}], ":=", 
   SuperscriptBox["a", "2."]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gr", "=", 
   RowBox[{"Graphics", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"RGBColor", "[", 
         RowBox[{"0.8", ",", "1", ",", "1.0"}], "]"}], ",", 
        RowBox[{"Rectangle", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{
             RowBox[{"-", "0.05"}], "ysc"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"xsc", ",", 
            RowBox[{"1.05", "ysc"}]}], "}"}]}], "]"}]}], "}"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"GrayLevel", "[", "i", "]"}], ",", 
          RowBox[{"Rectangle", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"0.05", "xsc"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 FractionBox["0.1", "num"]}], "ysc"}], "+", 
               RowBox[{
                FractionBox[
                 RowBox[{"ysc", " ", "i"}], 
                 RowBox[{"num", "+", "1"}]], "num"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"0.4", "xsc"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 FractionBox["0.1", "num"]}], "ysc"}], "+", 
               FractionBox[
                RowBox[{"ysc", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"i", " ", "num"}], "+", "1"}], ")"}]}], 
                RowBox[{"num", "+", "1"}]]}]}], "}"}]}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "1", ",", 
          FractionBox["1", "num"]}], "}"}]}], "]"}], ",", "Black", ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"ToString", "[", 
             RowBox[{"NumberForm", "[", 
              RowBox[{
               RowBox[{"fcol", "[", "i", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}]}], "]"}], "]"}], ",", "16"}], 
           "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"0.6", "xsc"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               FractionBox["0.1", "num"]}], "ysc"}], "+", 
             FractionBox[
              RowBox[{"ysc", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"i", " ", "num"}], "+", "0.5"}], ")"}]}], 
              RowBox[{"num", "+", "1"}]]}]}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "1", ",", 
          FractionBox["1", "num"]}], "}"}]}], "]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"gr", ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "xsc"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "0.05"}], "ysc"}], ",", "ysc"}], "}"}]}], "}"}]}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.502129646547*^9, 3.502129653307*^9}, {3.5021297056*^9, 
   3.5021299671800003`*^9}, {3.502130171939*^9, 3.502130177856*^9}, {
   3.5021302665550003`*^9, 3.502130354127*^9}, {3.502198434785*^9, 
   3.50219843788*^9}, {3.502452148104*^9, 3.502452202293*^9}, {
   3.502455133999*^9, 3.502455400816*^9}, {3.502455441406*^9, 
   3.502455714793*^9}, {3.50245574988*^9, 3.502455769021*^9}, {
   3.502455816708*^9, 3.502455816795*^9}, {3.502455980579*^9, 
   3.5024560181280003`*^9}, {3.5024560566870003`*^9, 3.502456057013*^9}, {
   3.5024561147790003`*^9, 3.502456115547*^9}, {3.502456145977*^9, 
   3.502456146041*^9}, {3.502456340414*^9, 3.5024563450299997`*^9}, {
   3.502456437481*^9, 3.502456454575*^9}, {3.502456549299*^9, 
   3.5024565493859997`*^9}, {3.5024567835810003`*^9, 
   3.5024568541800003`*^9}, {3.502457008764*^9, 3.502457093533*^9}, {
   3.502457129922*^9, 3.502457169335*^9}, {3.5024572012139997`*^9, 
   3.502457221542*^9}, {3.502457282362*^9, 3.502457296112*^9}, {
   3.502457334216*^9, 3.5024573634379997`*^9}, {3.502457430657*^9, 
   3.5024574602060003`*^9}, {3.50245755513*^9, 3.502457561506*^9}, {
   3.502457760488*^9, 3.502457760566*^9}, 3.502458213052*^9, {
   3.5025573781324*^9, 3.5025574190794*^9}}],

Cell[BoxData[{
 RowBox[{"figv", "=", 
  RowBox[{"Figure", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.55", ",", "0.98"}], "}"}], ",", 
        "\"\<Velocity (field) and density (color)\>\"", ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Multipanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "2"}], "}"}], ",", 
        RowBox[{"XPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "Rout"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "xsc"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"YPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "ymax"}], ",", "ymax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}], ",", 
               RowBox[{"1.02", "ysc"}]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "ymax"}], ",", "ymax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}], ",", "ysc"}], "}"}]}], 
            "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"XFrameLabels", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<cylindrical   \!\(\*SubscriptBox[\(r\), \(c\)]\)/M\>\"", ",", 
           "None"}], "}"}]}], ",", 
        RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
        RowBox[{"YFrameLabels", "\[Rule]", "\"\<height   z/M\>\""}], ",", 
        RowBox[{"BufferL", "\[Rule]", "5"}], ",", 
        RowBox[{"TickFontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", "\[IndentingNewLine]", 
        RowBox[{"XFrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"LinTicks", "[", 
            RowBox[{"0", ",", "20", ",", "5", ",", "5"}], "]"}], ",", 
           "None"}], "}"}]}], ",", 
        RowBox[{"YFrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"LinTicks", "[", 
              RowBox[{
               RowBox[{"-", "6"}], ",", "6", ",", "3", ",", "2"}], "]"}], ",",
              "None"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"LinTicks", "[", 
              RowBox[{
               RowBox[{"-", "6"}], ",", "6", ",", "3", ",", "2"}], "]"}], ",",
              "None"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"XPanelSizes", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0.2"}], "}"}]}], ",", 
        RowBox[{"YPanelSizes", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}], ",", 
        RowBox[{"XGapSizes", "\[Rule]", 
         RowBox[{"{", "0.03", "}"}]}], ",", 
        RowBox[{"YGapSizes", "\[Rule]", 
         RowBox[{"{", "0", "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"Background", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PanelLetterCorner", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
        RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
        RowBox[{"TickNudge", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "5"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5"}], ",", "0"}], "}"}], ",", "0", ",", "0"}], 
          "}"}]}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(a)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"shotfig", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"Graphics", "[", 
        RowBox[{"Disk", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"rhor", ",", 
            RowBox[{"rhor", "-", 
             RowBox[{"3", "ymax"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "\[Pi]"}], "/", "2"}], ",", 
            RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}], "]"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(b)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"satfig", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"Graphics", "[", 
        RowBox[{"Disk", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"rhor", ",", 
            RowBox[{"rhor", "-", "ymax"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "\[Pi]"}], "/", "2"}], ",", 
            RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}], "]"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"gr", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "2"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"gr", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.2"}], ",", "1.1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.17"}], ",", "1.1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", 
     RowBox[{"12", "*", "2", "*", 
      RowBox[{"{", 
       RowBox[{"26", ",", "24"}], "}"}]}]}]}], "]"}]}], "\n", 
 RowBox[{"figB", "=", 
  RowBox[{"Figure", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.55", ",", "0.98"}], "}"}], ",", 
        "\"\<b direction (field) and \!\(\*SuperscriptBox[\(b\), \(2\)]\) \
(color)\>\"", ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Multipanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "2"}], "}"}], ",", 
        RowBox[{"XPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "Rout"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "xsc"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"YPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "ymax"}], ",", "ymax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}], ",", 
               RowBox[{"1.02", "ysc"}]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "ymax"}], ",", "ymax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}], ",", "ysc"}], "}"}]}], 
            "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"XFrameLabels", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<cylindrical   \!\(\*SubscriptBox[\(r\), \(c\)]\)/M\>\"", ",", 
           "None"}], "}"}]}], ",", 
        RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
        RowBox[{"YFrameLabels", "\[Rule]", "\"\<height   z/M\>\""}], ",", 
        RowBox[{"BufferL", "\[Rule]", "5"}], ",", 
        RowBox[{"TickFontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", "\[IndentingNewLine]", 
        RowBox[{"XFrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"LinTicks", "[", 
            RowBox[{"0", ",", "20", ",", "5", ",", "5"}], "]"}], ",", 
           "None"}], "}"}]}], ",", 
        RowBox[{"YFrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"LinTicks", "[", 
              RowBox[{
               RowBox[{"-", "6"}], ",", "6", ",", "3", ",", "2"}], "]"}], ",",
              "None"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"LinTicks", "[", 
              RowBox[{
               RowBox[{"-", "6"}], ",", "6", ",", "3", ",", "2"}], "]"}], ",",
              "None"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"XPanelSizes", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0.2"}], "}"}]}], ",", 
        RowBox[{"YPanelSizes", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}], ",", 
        RowBox[{"XGapSizes", "\[Rule]", 
         RowBox[{"{", "0.03", "}"}]}], ",", 
        RowBox[{"YGapSizes", "\[Rule]", 
         RowBox[{"{", "0", "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"Background", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PanelLetterCorner", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
        RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
        RowBox[{"TickNudge", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "5"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5"}], ",", "0"}], "}"}], ",", "0", ",", "0"}], 
          "}"}]}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(a)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"shotfigB", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"Graphics", "[", 
        RowBox[{"Disk", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"rhor", ",", 
            RowBox[{"rhor", "-", 
             RowBox[{"3", "ymax"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "\[Pi]"}], "/", "2"}], ",", 
            RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}], "]"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(b)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"satfigB", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"Graphics", "[", 
        RowBox[{"Disk", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"rhor", ",", 
            RowBox[{"rhor", "-", "ymax"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "\[Pi]"}], "/", "2"}], ",", 
            RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "]"}], "]"}], "]"}], ",", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"gr", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "2"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"gr", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.2"}], ",", "1.1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.17"}], ",", "1.1"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", 
     RowBox[{"12", "*", "2", "*", 
      RowBox[{"{", 
       RowBox[{"26", ",", "24"}], "}"}]}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.502451788715*^9, 3.502451788741*^9}, {
   3.5024518199040003`*^9, 3.502451875125*^9}, {3.5024519327209997`*^9, 
   3.502452128704*^9}, {3.5024522217869997`*^9, 3.5024522294189997`*^9}, {
   3.502452878352*^9, 3.502452888159*^9}, {3.502453011801*^9, 
   3.5024530721809998`*^9}, {3.502453157514*^9, 3.502453212606*^9}, {
   3.5024533137139997`*^9, 3.502453334608*^9}, {3.5024533704370003`*^9, 
   3.502453370709*^9}, {3.502453436483*^9, 3.5024534617530003`*^9}, 
   3.502453500775*^9, {3.502454009144*^9, 3.5024541046029997`*^9}, {
   3.5024541443199997`*^9, 3.502454144898*^9}, {3.502454244277*^9, 
   3.502454445895*^9}, {3.502454497429*^9, 3.502454550777*^9}, {
   3.502454650789*^9, 3.502454651467*^9}, {3.5024546996730003`*^9, 
   3.5024548061219997`*^9}, {3.502455016927*^9, 3.502455047501*^9}, {
   3.5024550967*^9, 3.502455102849*^9}, {3.502455783619*^9, 
   3.5024559768859997`*^9}, {3.502456036701*^9, 3.502456036972*^9}, {
   3.5024560719700003`*^9, 3.5024561382060003`*^9}, {3.5024561919639997`*^9, 
   3.502456228401*^9}, {3.5024567685369997`*^9, 3.502456774592*^9}, {
   3.502457411126*^9, 3.5024574128050003`*^9}, {3.502457994153*^9, 
   3.5024580019560003`*^9}, {3.502458233028*^9, 3.5024582361800003`*^9}, {
   3.50341435921*^9, 3.503414369986*^9}, {3.5102330604206*^9, 
   3.5102330626106*^9}}],

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"dout", "<>", "\"\<vfield.eps\>\""}], ",", "figv", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "150"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"dout", "<>", "\"\<Bfield.eps\>\""}], ",", "figB", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "150"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.473709782238513*^9, 3.473709831773883*^9}, {
   3.473710084033079*^9, 3.473710085590307*^9}, {3.48639185883*^9, 
   3.486391869973*^9}, {3.486391950826*^9, 3.4863919613120003`*^9}, {
   3.486391993683*^9, 3.4863920444040003`*^9}, {3.4863925097530003`*^9, 
   3.486392510201*^9}, 3.486727711158*^9, {3.486727761387*^9, 
   3.486727770947*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Tp & Te plot (Figure 4) - ",
 StyleBox["done",
  FontColor->RGBColor[0, 0, 1]]
}], "Subsection",
 CellChangeTimes->{{3.485208151784046*^9, 3.485208156056046*^9}, {
  3.4891537235359325`*^9, 3.4891537264999323`*^9}, {3.503080947299*^9, 
  3.5030809483599997`*^9}, {3.509206137701*^9, 3.509206138635*^9}, {
  3.509207866051*^9, 3.5092078697279997`*^9}, {3.5285504196150928`*^9, 
  3.5285504206476088`*^9}, {3.5291618909933863`*^9, 3.5291618919214396`*^9}, {
  3.53999376746521*^9, 3.5399937683762617`*^9}, {3.5399953758032017`*^9, 
  3.539995383557645*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "2"}], ";", 
  RowBox[{"fr", "=", "5"}], ";", 
  RowBox[{"rhonor", "=", "988988.82"}], ";", 
  RowBox[{"heat", "=", "0.37012"}], ";", 
  RowBox[{"th", "=", "1.8407"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"atab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
     ",", "\"\<098\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nmtab", "=", 
   RowBox[{"{", 
    RowBox[{"8", ",", "8", ",", "8", ",", "9", ",", "9"}], "}"}]}], ";", 
  RowBox[{"ncuttab", "=", 
   RowBox[{"{", 
    RowBox[{"145", ",", "147", ",", "149", ",", "153", ",", "162"}], "}"}]}], 
  ";", 
  RowBox[{"a", "=", 
   RowBox[{"atab", "[", 
    RowBox[{"[", "sp", "]"}], "]"}]}], ";", 
  RowBox[{"nm", "=", 
   RowBox[{"nmtab", "[", 
    RowBox[{"[", "sp", "]"}], "]"}]}], ";", 
  RowBox[{"ncut", "=", 
   RowBox[{"ncuttab", "[", 
    RowBox[{"[", "sp", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xx", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\a\>\"", "<>", 
     RowBox[{"sptab", "[", 
      RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<\\\\Tsmap\>\"", "<>", 
     RowBox[{"sptab", "[", 
      RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<.dat\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoout", "=", "130"}], ";", 
  RowBox[{"rmax", "=", 
   RowBox[{"3.4", " ", 
    SuperscriptBox["10", "5"]}]}], ";", 
  RowBox[{"rcut", "=", 
   RowBox[{"xx", "[", 
    RowBox[{"[", 
     RowBox[{"ncut", ",", "1"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhopo", "=", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"Log", "[", 
      RowBox[{
       RowBox[{"rhoout", "/", "rhonor"}], "/", 
       RowBox[{
        RowBox[{"xx", "[", 
         RowBox[{"[", "ncut", "]"}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}], "/", 
    RowBox[{"Log", "[", 
     RowBox[{"rmax", "/", "rcut"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"rhocon", "=", 
   RowBox[{"rhonor", "*", 
    RowBox[{"xx", "[", 
     RowBox[{"[", 
      RowBox[{"ncut", ",", "3"}], "]"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Ucon", "=", 
   RowBox[{"xx", "[", 
    RowBox[{"[", 
     RowBox[{"ncut", ",", "2"}], "]"}], "]"}]}], ";", 
  RowBox[{"ruru", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rg", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "6.67", " ", 
        SuperscriptBox["10", 
         RowBox[{"-", "8"}]], "4.5", " ", 
        SuperscriptBox["10", "6"], "2", " ", 
        SuperscriptBox["10", "33"]}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"3", " ", 
          SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
     RowBox[{"arcsec", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
        SuperscriptBox["10", "3"], "3.08", " ", 
        SuperscriptBox["10", "18"]}], 
       RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
     RowBox[{"pc", "\[Rule]", 
      RowBox[{"3.08", " ", 
       SuperscriptBox["10", "18"]}]}], ",", 
     RowBox[{"year", "\[Rule]", 
      RowBox[{"365.35", " ", "86400"}]}], ",", 
     RowBox[{"cc", "\[Rule]", 
      RowBox[{"3.", " ", 
       SuperscriptBox["10", "10"]}]}], ",", 
     RowBox[{"Msun", "\[Rule]", 
      RowBox[{"2.", " ", 
       SuperscriptBox["10", "33"]}]}], ",", 
     RowBox[{"mp", "\[Rule]", 
      RowBox[{"1.67", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "24"}]]}]}], ",", 
     RowBox[{"me", "\[Rule]", 
      RowBox[{"9.1", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "28"}]]}]}], ",", 
     RowBox[{"kb", "\[Rule]", 
      RowBox[{"1.38", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "16"}]]}]}], ",", 
     RowBox[{"h", "\[Rule]", 
      RowBox[{"6.626", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "27"}]]}]}], ",", 
     RowBox[{"ee", "\[Rule]", 
      RowBox[{"4.8", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "10"}]]}]}], ",", 
     RowBox[{"keV", "->", 
      RowBox[{"1000", " ", "1.602", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rategs", "=", 
    RowBox[{
     RowBox[{"4.594", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "8"}]], 
      RowBox[{"Msun", "/", "year"}]}], "/.", "ruru"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"7.6*^17", 
    RowBox[{"g", "/", "s"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rtab", "=", 
   RowBox[{"xx", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"rntab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"rcut", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["rcut", "rmax"], ")"}], 
       RowBox[{"-", 
        FractionBox["i", "100"]}]]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "100"}], "}"}]}], "]"}]}], ";", 
  RowBox[{"\[Rho]fun", "=", 
   RowBox[{"rhocon", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["r", "rcut"], ")"}], 
     RowBox[{"-", "rhopo"}]]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vrvr", "=", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["rategs", 
      RowBox[{"2", " ", "cc", " ", "mp", " ", 
       SuperscriptBox["rg", "2"], 
       SuperscriptBox["r", "2"], "\[Rho]inter", " "}]]}], "/.", "ruru"}]}], 
  ";", 
  RowBox[{"dcap", "=", 
   RowBox[{"(", 
    RowBox[{"2.", "-", 
     FractionBox["0.49", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"0.7", "+", " ", 
         SuperscriptBox["cser", "2"]}], ")"}], "2"]]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Tsfun", "=", 
    RowBox[{"Ucon", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["r", "rcut"], ")"}], 
      RowBox[{"-", "0.98"}]]}]}], ";", 
   RowBox[{"Tstab", "=", 
    RowBox[{"xx", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"1", ";;", "ncut"}], ",", 
       RowBox[{"1", ";;", "2"}]}], "]"}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Tsinter", "=", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"Interpolation", "[", 
        RowBox[{"Log", "[", 
         RowBox[{"Join", "[", 
          RowBox[{"Tstab", ",", 
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"rntab", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"Tsfun", "/.", 
                 RowBox[{"r", "\[Rule]", "#"}]}], "&"}], "/@", "rntab"}]}], 
             "}"}], "]"}]}], "]"}], "]"}], "]"}], "[", 
       RowBox[{"Log", "[", "r", "]"}], "]"}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Tsinter", "=", 
   RowBox[{
    RowBox[{"Interpolation", "[", 
     RowBox[{"Join", "[", 
      RowBox[{"Tstab", ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"rntab", ",", 
          RowBox[{
           RowBox[{
            RowBox[{"Tsfun", "/.", 
             RowBox[{"r", "\[Rule]", "#"}]}], "&"}], "/@", "rntab"}]}], "}"}],
         "]"}]}], "]"}], "]"}], "[", "r", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sysm", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"tail", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Dts", "=", 
              RowBox[{"D", "[", 
               RowBox[{"Tsinter", ",", "r"}], "]"}]}], ";", 
             RowBox[{"\[Nu]c", "=", 
              RowBox[{"8.9", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "11"}]], 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox[
                  RowBox[{"Te", "[", "r", "]"}], 
                  RowBox[{"3", " ", 
                   SuperscriptBox["10", "10"]}]], ")"}], 
                RowBox[{"-", 
                 FractionBox["3", "2"]}]], 
               FractionBox["\[Rho]fun", 
                SuperscriptBox["10", "7"]]}]}]}], ")"}], 
           FractionBox[
            RowBox[{"2", " ", "mp", " ", 
             SuperscriptBox["rg", "3"], 
             SuperscriptBox["r", "2"], "\[Rho]fun", " "}], "rategs"], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Tp", "[", "r", "]"}], "-", 
             RowBox[{"Te", "[", "r", "]"}]}], ")"}]}], "+", 
          RowBox[{"2", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              FractionBox[
               SqrtBox[
                RowBox[{"Tp", "[", "r", "]"}]], 
               RowBox[{
                SqrtBox[
                 RowBox[{"Tp", "[", "r", "]"}]], "+", 
                RowBox[{"heat", 
                 SqrtBox[
                  RowBox[{"Te", "[", "r", "]"}]]}]}]], ")"}], "-", 
             RowBox[{
              FractionBox["1", "dcap"], 
              RowBox[{"(", 
               RowBox[{"1", 
                FractionBox[
                 RowBox[{"heat", 
                  SqrtBox[
                   RowBox[{"Te", "[", "r", "]"}]]}], 
                 RowBox[{
                  SqrtBox[
                   RowBox[{"Tp", "[", "r", "]"}]], "+", 
                  RowBox[{"heat", 
                   SqrtBox[
                    RowBox[{"Te", "[", "r", "]"}]]}]}]]}], ")"}]}]}], ")"}], 
           "Dts"}]}]}], ";", 
        RowBox[{
         RowBox[{
          RowBox[{"Te", "'"}], "[", "r", "]"}], "==", 
         FractionBox[
          RowBox[{
           RowBox[{"2", "Dts"}], "-", "tail"}], 
          RowBox[{"dcap", "+", "1"}]]}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Tp", "'"}], "[", "r", "]"}], "\[Equal]", 
        RowBox[{"tail", "+", 
         FractionBox[
          RowBox[{
           RowBox[{"2", "Dts"}], "-", "tail"}], 
          RowBox[{"dcap", "+", "1"}]]}]}]}], "}"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Theta]e", "\[Rule]", 
        FractionBox[
         RowBox[{"kb", " ", 
          RowBox[{"Te", "[", "r", "]"}]}], 
         RowBox[{"me", " ", 
          SuperscriptBox["cc", "2"]}]]}], ",", 
       RowBox[{"cser", "\[Rule]", 
        SqrtBox[
         FractionBox[
          RowBox[{"kb", " ", 
           RowBox[{"Te", "[", "r", "]"}]}], 
          RowBox[{"me", " ", 
           SuperscriptBox["cc", "2"]}]]]}], ",", 
       RowBox[{"cspr", "\[Rule]", 
        SqrtBox[
         FractionBox[
          RowBox[{"kb", " ", 
           RowBox[{"Tp", "[", "r", "]"}]}], 
          RowBox[{"mp", " ", 
           SuperscriptBox["cc", "2"]}]]]}]}], "}"}]}], "/.", "ruru"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{"FindRoot", "::", "\"\<lstol\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tosol", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{"sysm", ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"Tp", "[", "r", "]"}], "==", "Tsinter"}], ",", 
         RowBox[{
          RowBox[{"Te", "[", "r", "]"}], "\[Equal]", "Tsinter"}]}], "}"}], "/.", 
       RowBox[{"r", "\[Rule]", "rmax"}]}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"solnew", "=", 
   RowBox[{
    RowBox[{"NDSolve", "[", 
     RowBox[{"tosol", ",", 
      RowBox[{"{", 
       RowBox[{"Tp", ",", "Te"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"r", ",", 
        RowBox[{"rtab", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", "rmax"}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"lpl00", "=", 
  RowBox[{"LogLogPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Tp", "[", "r", "]"}], "/.", "solnew"}], ",", 
      RowBox[{
       RowBox[{"Te", "[", "r", "]"}], "/.", "solnew"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", 
      RowBox[{"rtab", "[", 
       RowBox[{"[", "nm", "]"}], "]"}], ",", "rmax"}], "}"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<T [K]\>\"", ",", "None"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "\"\<r/M\>\"", ",", 
         "\"\<proton temperature \!\(\*SubscriptBox[\(T\), \(p\)]\) (red) & \
electron temperature \!\(\*SubscriptBox[\(T\), \(e\)]\) (blue)\>\""}], 
        "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Red"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Blue"}], 
        "}"}]}], "}"}]}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ","}], "*)"}], 
      RowBox[{
       RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", "19"}]}], "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "\"\<C:\\\\study\\\\accretion\\\\! 2009 3fall cfa\\\\GR Polarized modeling\
\\\\!svn\\\\\>\"", "<>", "\"\<TpTe.eps\>\""}], ",", "lpl00", ",", 
   RowBox[{"\"\<EmbeddedFonts\>\"", "\[Rule]", "All"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"ListLogLogPlot", "[", 
  RowBox[{
   RowBox[{"mode", "=", 
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Transpose", "[", "xx", "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{"rhonor", " ", 
        RowBox[{
         RowBox[{"Transpose", "[", "xx", "]"}], "[", 
         RowBox[{"[", "3", "]"}], "]"}]}]}], "}"}], "]"}]}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox[
   RowBox[{"Tp", "[", "6.", "]"}], 
   RowBox[{"Te", "[", "6.", "]"}]], "/.", "solnew"}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox[
   RowBox[{"Tp", "[", "3", "]"}], 
   RowBox[{"Te", "[", "3", "]"}]], "/.", "solnew"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<\!\(\*SubscriptBox[\(T\), \(e\)]\)(6M)=\>\"", ",", 
   RowBox[{
    RowBox[{"Te", "[", "6", "]"}], "/.", "solnew"}], ",", 
   "\"\<; \!\(\*SubscriptBox[\(n\), \(e\)]\)(6M)=\>\"", ",", 
   RowBox[{
    RowBox[{"Interpolation", "[", "mode", "]"}], "[", "6", "]"}], ",", 
   "\"\<; density slope = \>\"", ",", "rhopo"}], "]"}]}], "Input",
 CellChangeTimes->{{3.4834636103388*^9, 3.4834636696968*^9}, {
   3.4834637181972*^9, 3.483463909968*^9}, {3.483464244042*^9, 
   3.4834642699692*^9}, 3.4834643070192003`*^9, {3.4834643425248003`*^9, 
   3.483464342712*^9}, {3.4834645751052*^9, 3.483464580222*^9}, {
   3.4834648283087997`*^9, 3.4834648597584*^9}, {3.4834652891484003`*^9, 
   3.483465387678*^9}, {3.4837022693568*^9, 3.4837022740992002`*^9}, {
   3.4837023050028*^9, 3.4837023305712*^9}, {3.4837026416782*^9, 
   3.4837026653901997`*^9}, {3.4837026982438*^9, 3.4837026983218*^9}, {
   3.4837027290694*^9, 3.4837027606126003`*^9}, {3.4840698681808*^9, 
   3.4840699216264*^9}, 3.485208388984046*^9, {3.485208529511046*^9, 
   3.485208603911046*^9}, {3.485208654916046*^9, 3.485208708461046*^9}, 
   3.485208744427046*^9, {3.485208803725046*^9, 3.485208890702046*^9}, {
   3.485209192250046*^9, 3.485209204334046*^9}, {3.485209253309046*^9, 
   3.485209267858046*^9}, 3.4852103478810463`*^9, {3.4857920823640003`*^9, 
   3.48579212046*^9}, {3.485792420144*^9, 3.485792453256*^9}, {
   3.485792808851*^9, 3.4857928245880003`*^9}, {3.4857928657390003`*^9, 
   3.485792894493*^9}, {3.485792955922*^9, 3.485793011389*^9}, {
   3.485793051638*^9, 3.485793058948*^9}, {3.485793487336*^9, 
   3.485793561616*^9}, 3.486740559784*^9, {3.486742375961*^9, 
   3.486742378665*^9}, {3.4885675499298*^9, 3.4885675529208*^9}, {
   3.4885678747158003`*^9, 3.4885678773658*^9}, {3.4891536399979324`*^9, 
   3.4891536416047325`*^9}, {3.4891577579713326`*^9, 
   3.4891577591101327`*^9}, {3.5030807263459997`*^9, 3.503080747664*^9}, {
   3.503080837502*^9, 3.503080850752*^9}, {3.509207139373*^9, 
   3.509207149191*^9}, {3.509207608068*^9, 3.5092076116429996`*^9}, {
   3.5092076487060003`*^9, 3.509207665234*^9}, {3.509207708679*^9, 
   3.509207710389*^9}, {3.5291608035001855`*^9, 3.5291608037722006`*^9}, {
   3.5291612076333003`*^9, 3.529161225402317*^9}, {3.529161264758568*^9, 
   3.5291612761312184`*^9}, {3.529161356670825*^9, 3.5291614097748623`*^9}, {
   3.5291616354937725`*^9, 3.529161647229444*^9}, {3.5291616921250114`*^9, 
   3.5291616977633343`*^9}, {3.529161736135529*^9, 3.5291617783669443`*^9}, {
   3.5294078757726765`*^9, 3.529407875946686*^9}, {3.5294080224990683`*^9, 
   3.5294080348987775`*^9}, {3.5294083280455446`*^9, 
   3.5294083390951767`*^9}, {3.52940837482522*^9, 3.529408383535719*^9}, {
   3.53841855380435*^9, 3.5384186045742536`*^9}, {3.5384186375761414`*^9, 
   3.5384186396842623`*^9}, {3.5384196786576877`*^9, 
   3.5384196966137147`*^9}, {3.5384198354066534`*^9, 3.538419861031119*^9}, {
   3.5386705304670625`*^9, 3.5386705313561134`*^9}, {3.5386706125007544`*^9, 
   3.5386706125607576`*^9}, {3.5386706530990763`*^9, 3.53867066154856*^9}, {
   3.5399947759008894`*^9, 3.5399948828510065`*^9}, {3.539994945473588*^9, 
   3.5399949713410673`*^9}, {3.539997550219571*^9, 3.5399976148832693`*^9}}],

Cell[BoxData[
 RowBox[{"a", "=", "0.9"}]], "Input",
 CellChangeTimes->{{3.485793570899*^9, 3.485793581672*^9}}],

Cell[BoxData[
 RowBox[{"a", "=", "0.5"}]], "Input",
 CellChangeTimes->{{3.485793069631*^9, 3.485793073717*^9}, {3.485793576432*^9,
   3.485793579008*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"833898.", 
     RowBox[{"(*", "boosted", "*)"}], "         ", "-", "\[Beta]"}], "=", 
    "0.77"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"density", " ", "profile"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"3.91*^6", " ", 
   RowBox[{"(*", 
    RowBox[{"non", "-", "boosted"}], "*)"}], "-", "\[Beta]"}], "=", "0.92", 
  " "}]}], "Input",
 CellChangeTimes->{{3.5092076270550003`*^9, 3.509207631599*^9}, {
  3.509207686851*^9, 3.509207702267*^9}, {3.5092077914700003`*^9, 
  3.509207852626*^9}, {3.5303824003797207`*^9, 3.530382406899093*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"1", "x"}], "\[Implies]", 
  "18.93765242910726"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"2", "x"}], "\[Implies]", 
  "18.82422022299976"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"10", "x"}], "\[Implies]", 
  "18.39189809962393"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"100", "x"}], "\[Implies]", "16.4558742874107"}]}], "Input",
 CellChangeTimes->{{3.5384185933046093`*^9, 3.538418654073085*^9}, {
  3.5384194592911406`*^9, 3.5384194606182165`*^9}}],

Cell[CellGroupData[{

Cell["fitting", "Subsubsection",
 CellChangeTimes->{{3.509281274493*^9, 3.509281275317*^9}}],

Cell[BoxData[
 RowBox[{"lpl00", "=", 
  RowBox[{"LogLogPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        SuperscriptBox["10", "11.2"], "/", 
        SuperscriptBox["r", "0.7"]}], "/.", "solnew"}], ",", 
      RowBox[{
       RowBox[{"Te", "[", "r", "]"}], "/.", "solnew"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", 
      RowBox[{"rtab", "[", 
       RowBox[{"[", "nm", "]"}], "]"}], ",", "rmax"}], "}"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<T [K]\>\"", ",", "None"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "\"\<r/M\>\"", ",", 
         "\"\<electron temperature \!\(\*SubscriptBox[\(T\), \(e\)]\) & fit\>\
\""}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Red"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Blue"}], 
        "}"}]}], "}"}]}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ","}], "*)"}], 
      RowBox[{
       RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", "19"}]}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5092811543640003`*^9, 3.50928125605*^9}, 
   3.509290558127*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"lpl00", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         SuperscriptBox["10", "12.7"], "/", "r"}], "/.", "solnew"}], ",", 
       RowBox[{
        RowBox[{"Tp", "[", "r", "]"}], "/.", "solnew"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"rtab", "[", 
        RowBox[{"[", "nm", "]"}], "]"}], ",", "rmax"}], "}"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\"\<T [K]\>\"", ",", "None"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "\"\<r/M\>\"", ",", 
          "\"\<proton temperature \!\(\*SubscriptBox[\(T\), \(p\)]\) & \
fit\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Red"}], "}"}],
         ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Blue"}], 
         "}"}]}], "}"}]}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ","}], "*)"}], 
       RowBox[{
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "19"}]}], "}"}]}]}], "]"}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.5092812788970003`*^9, 3.509281294727*^9}, {
  3.509290577549*^9, 3.509290583403*^9}}],

Cell[BoxData[{
 RowBox[{"mode", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "1"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"mode", "[", 
  RowBox[{"[", 
   RowBox[{
    RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5092906729189997`*^9, 3.509290680667*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"l3", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"mode", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl3", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["10", "6.8"], "/", "r"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"mode", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
       RowBox[{"mode", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"l3", ",", "pl3"}], "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.509290621291*^9, 3.509290734144*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Fitting new data (Figure 7) - ",
 StyleBox["done",
  FontColor->RGBColor[0, 0, 1]]
}], "Subsection",
 CellChangeTimes->{{3.485182022574*^9, 3.4851820272209997`*^9}, {
   3.485182068828*^9, 3.4851820710109997`*^9}, {3.4851821305030003`*^9, 
   3.485182130631*^9}, {3.4891537117891326`*^9, 3.4891537142695327`*^9}, {
   3.502031177785*^9, 3.502031177936*^9}, {3.502640606113*^9, 
   3.502640607071*^9}, {3.5092061412349997`*^9, 3.5092061415150003`*^9}, {
   3.5092131023269997`*^9, 3.509213103085*^9}, {3.528550422635139*^9, 
   3.528550422785141*^9}, {3.5291641454173317`*^9, 3.5291641455453396`*^9}, {
   3.5291657014943347`*^9, 3.5291657023983865`*^9}, {3.5291715216372275`*^9, 
   3.529171521885242*^9}, {3.529182524785309*^9, 3.529182525265336*^9}, {
   3.53999377008736*^9, 3.5399937709014063`*^9}, 3.539996761748473*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<ErrorBarPlots`\>\"", "]"}], ";", 
  RowBox[{"Needs", "[", "\"\<ErrorBarLogPlots`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xFnu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"87.73`", ",", "1.8409545454545453`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.08006092045351851`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"102.`", ",", "1.9076923076923078`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.15168351771484959`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"145.`", ",", "2.2750000000000004`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.2644063431268514`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"230.9`", ",", "2.6372093023255814`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.14137527543005202`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"349.`", ",", "3.1806666666666668`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.12050080682071983`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"674.`", ",", "3.2857142857142856`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.35080083308024784`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"857.`", ",", "2.866666666666667`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.2403700850309327`", "]"}]}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xLPnu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"87.73", ",", "1.420"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.5", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"230.9", ",", "7.3979"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.6579", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"349", ",", "6.499"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.6054", "]"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xCPnu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"231", ",", 
         RowBox[{"-", "1.2"}]}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.3", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"349", ",", 
         RowBox[{"-", "1.5"}]}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.3", "]"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xEVPA", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"88", ",", 
        RowBox[{"-", "4.0166666666666675`"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"231", ",", "111.47500000000001`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"349", ",", "146.89090909090908`"}], "}"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"el", "=", 
   RowBox[{"{", 
    RowBox[{
    "ListLogLogPlot", ",", "ListLogLinearPlot", ",", "ErrorListLogLogPlot", 
     ",", "ErrorListLogLinearPlot"}], "}"}]}], ";", 
  RowBox[{"Clear", "[", "totI", "]"}], ";", 
  RowBox[{"xcol", "=", "Cyan"}], ";", 
  RowBox[{"myf", "=", "14"}], ";", 
  RowBox[{"siz", "=", "280"}], ";", 
  RowBox[{"ord", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"#", ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ","}], "*)"}], 
        RowBox[{
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}]}], "}"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"FrameTicks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"(*", 
           RowBox[{"{", 
            RowBox[{
            "10", ",", "20", ",", "50", ",", "100", ",", "200", ",", "500"}], 
            "}"}], "*)"}], 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "43", ",", "88", ",", "145", ",", "231", ",", "349", ",", "690"}],
             "}"}], ",", "None"}], "}"}]}], "}"}]}]}], "]"}], "&"}], "/@", 
   "el"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ax", "=", "30"}], ";", 
   RowBox[{"Fran", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"40", ",", "900"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0.8", ",", "3.7"}], "}"}]}], "}"}]}], ";", 
   RowBox[{"LPran", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"40", ",", "860"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0.4", ",", "15."}], "}"}]}], "}"}]}], ";", 
   RowBox[{"CPran", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"40", ",", "860"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "2."}], ",", "2.2"}], "}"}]}], "}"}]}], ";", 
   RowBox[{"angran", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"80", ",", "860"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"80", ",", "170"}], "}"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plo", "[", 
    RowBox[{
     RowBox[{"dat_", "?", "StringQ"}], ",", 
     RowBox[{"style_", "?", "ListQ"}], ",", 
     RowBox[{"ax_", "?", "NumberQ"}]}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fff", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Import", "[", "dat", "]"}], "]"}]}], ";", 
     RowBox[{"ftab", "=", 
      RowBox[{"fff", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"Fnusim", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"ftab", ",", 
         RowBox[{"fff", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
     RowBox[{"LPnusim", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"ftab", ",", 
         RowBox[{"fff", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
     RowBox[{"CPnusim", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"ftab", ",", 
         RowBox[{"fff", "[", 
          RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
     RowBox[{"angsim", "=", 
      RowBox[{"Delete", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"ftab", ",", 
           RowBox[{"ax", "+", 
            RowBox[{"fff", "[", 
             RowBox[{"[", "5", "]"}], "]"}]}]}], "}"}], "]"}], ",", "1"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{"Fnusim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "Fran"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "Null", ",", 
              "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}], 
             "}"}]}], "}"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", "\[IndentingNewLine]", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}], ",", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{"LPnusim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "ord"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "LPran"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Null", ",", "\"\<LP [%]\>\""}], "}"}]}], "}"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}], ",", 
       RowBox[{"ListLogLinearPlot", "[", 
        RowBox[{"CPnusim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "ord"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Null", ",", "\"\<CP [%]\>\""}], "}"}]}], "}"}]}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "CPran"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}], ",", 
       RowBox[{"ListLogLinearPlot", "[", 
        RowBox[{"angsim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "angran"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "Null", ",", "\"\<Electric vector position angle [deg]\>\""}], 
             "}"}]}], "}"}]}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}]}], "}"}]}], 
    ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pldat", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ErrorListLogLogPlot", "[", 
      RowBox[{"xFnu", ",", 
       RowBox[{"Joined", "\[Rule]", "False"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "Fran"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Null", ",", "Null"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "Null", ",", 
            "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}], "}"}]}], 
         "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ErrorListLogLogPlot", "[", 
      RowBox[{"xLPnu", ",", 
       RowBox[{"Joined", "\[Rule]", "False"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "LPran"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Null", ",", "Null"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Null", ",", "\"\<LP [%]\>\""}], "}"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}], ",", 
     RowBox[{"ErrorListLogLinearPlot", "[", 
      RowBox[{"xCPnu", ",", 
       RowBox[{"Joined", "\[Rule]", "False"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "CPran"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Null", ",", "Null"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Null", ",", "\"\<CP [%]\>\""}], "}"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}], ",", 
     RowBox[{"ListLogLinearPlot", "[", 
      RowBox[{"xEVPA", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "angran"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Null", ",", "Null"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "Null", ",", "\"\<Electric vector position angle [deg]\>\""}], 
           "}"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"AbsoluteThickness", "[", "6", "]"}], ",", "Blue"}], 
         "}"}]}]}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dir", "=", 
   "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\deepthought\\\
\\\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dir", "=", 
   "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2012Feb_full\\\\new60\\\\add\
\\\\\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl0", "=", 
   RowBox[{"plo", "[", 
    RowBox[{
     RowBox[{"dir", "<>", "\"\<quicka0in21.dat\>\""}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", 
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"3", ",", "5"}], "}"}], "]"}], ",", "Brown"}], "}"}], ",", 
     "22"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl50", "=", 
   RowBox[{"plo", "[", 
    RowBox[{
     RowBox[{"dir", "<>", "\"\<quicka50in21.dat\>\""}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Red"}], "}"}], 
     ",", "62"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl70", "=", 
   RowBox[{"plo", "[", 
    RowBox[{
     RowBox[{"dir", "<>", "\"\<quicka70in21.dat\>\""}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", 
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"10", ",", "7"}], "}"}], "]"}], ",", "Green"}], "}"}], ",", 
     "62"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl90", "=", 
   RowBox[{"plo", "[", 
    RowBox[{
     RowBox[{"dir", "<>", "\"\<quicka90in21.dat\>\""}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Cyan"}], "}"}], 
     ",", "46"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pl98", "=", 
    RowBox[{"plo", "[", 
     RowBox[{
      RowBox[{"dir", "<>", "\"\<quicka98in21.dat\>\""}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "DotDashed", ",",
         "Orange"}], "}"}], ",", "50"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tot", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{
     "pl70", ",", "pl98", ",", "pl0", ",", "pl90", ",", "pl50", ",", 
      "pldat"}], "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fnupl", "=", 
   RowBox[{"Show", "[", 
    RowBox[{"tot", "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LPnupl", "=", 
   RowBox[{"Show", "[", 
    RowBox[{"tot", "[", 
     RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CPnupl", "=", 
   RowBox[{"Show", "[", 
    RowBox[{"tot", "[", 
     RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"angnupl", "=", 
    RowBox[{"Show", "[", 
     RowBox[{"tot", "[", 
      RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"totimag", "=", 
  RowBox[{"GraphicsGrid", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Fnupl", ",", "angnupl"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"LPnupl", ",", "CPnupl"}], "}"}]}], "}"}], ",", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"ImageSize", "\[Rule]", "900"}], ","}], "*)"}], 
    RowBox[{"Epilog", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Black", ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
           RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.45", ",", "0.55"}], "}"}], "]"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
           RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.46", ",", "0.05"}], "}"}], "]"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
           RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.955", ",", "0.55"}], "}"}], "]"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", 
           RowBox[{"myf", "+", "2"}], ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.955", ",", "0.05"}], "}"}], "]"}]}], "]"}]}], "}"}]}], 
    ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", 
        RowBox[{"myf", "-", "2"}]}]}], "}"}]}], ",", 
    RowBox[{"PlotLabel", "\[Rule]", "\"\<Best fits to observations\>\""}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "\"\<C:\\\\study\\\\accretion\\\\! 2009 3fall cfa\\\\GR Polarized modeling\
\\\\!svn\\\\\>\"", "<>", "\"\<SEDfit.eps\>\""}], ",", "totimag", ",", 
   RowBox[{"\"\<EmbeddedFonts\>\"", "\[Rule]", "All"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"C", ":", 
    RowBox[{
     RowBox[{"\\", "study", "\\", "accretion"}], 
     RowBox[{"\\!", "2009"}], " ", "fall", " ", 
     RowBox[{"cfa", "\\", "GR"}], " ", "Polarized", " ", "modeling"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.502628378965*^9, 3.502628728263*^9}, {3.5026287885*^9, 
   3.502628870776*^9}, {3.50262927498*^9, 3.502629287866*^9}, {
   3.502629449369*^9, 3.502629467468*^9}, {3.5026297565369997`*^9, 
   3.502629760493*^9}, 3.5026300378129997`*^9, {3.502630165902*^9, 
   3.5026301743780003`*^9}, {3.502630357251*^9, 3.502630415388*^9}, {
   3.502630469059*^9, 3.50263047513*^9}, {3.5026305303269997`*^9, 
   3.502630542965*^9}, {3.502630694778*^9, 3.502630717468*^9}, {
   3.502630797225*^9, 3.502630801821*^9}, {3.50263116152*^9, 
   3.502631220987*^9}, {3.502635699691*^9, 3.502635707273*^9}, {
   3.5026357539849997`*^9, 3.502635762177*^9}, {3.5026358116429996`*^9, 
   3.502635891623*^9}, {3.5026359406879997`*^9, 3.5026359532679996`*^9}, {
   3.502635998973*^9, 3.502636046553*^9}, {3.502636296105*^9, 
   3.502636306257*^9}, {3.502636348116*^9, 3.502636394304*^9}, {
   3.502636464976*^9, 3.502636511539*^9}, {3.5026366564440002`*^9, 
   3.502636657256*^9}, {3.5026367042679996`*^9, 3.502636723674*^9}, {
   3.502636770766*^9, 3.5026368143*^9}, {3.50263687842*^9, 
   3.502636937432*^9}, {3.502636985539*^9, 3.502637028352*^9}, {
   3.502637097574*^9, 3.50263710215*^9}, {3.502637144525*^9, 
   3.502637236678*^9}, {3.5026374416470003`*^9, 3.502637447557*^9}, {
   3.502637612638*^9, 3.5026376297209997`*^9}, 3.5026377162*^9, {
   3.502641863994*^9, 3.502641875248*^9}, {3.503063135024*^9, 
   3.503063137177*^9}, {3.509209665115*^9, 3.509209678043*^9}, {
   3.5092097130220003`*^9, 3.50920975479*^9}, {3.5092100123780003`*^9, 
   3.509210014481*^9}, {3.529162305448092*^9, 3.529162429738201*^9}, {
   3.5291626010079966`*^9, 3.5291626014560223`*^9}, {3.529162682921682*^9, 
   3.5291627741979027`*^9}, {3.529162864954094*^9, 3.529162865634133*^9}, 
   3.529163184583376*^9, 3.529163228930912*^9, {3.529163276011605*^9, 
   3.5291633036101837`*^9}, {3.5291633498708296`*^9, 
   3.5291633949234066`*^9}, {3.52916393697141*^9, 3.5291639377614546`*^9}, {
   3.5291640076344514`*^9, 3.529164013498787*^9}, {3.529165338140552*^9, 
   3.5291653394646273`*^9}, {3.529165403766306*^9, 3.529165411436744*^9}, {
   3.5399965394127564`*^9, 3.539996594992935*^9}, {3.5399966296969204`*^9, 
   3.5399967316827536`*^9}, {3.5399976502382917`*^9, 3.539997655088569*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"(", 
   RowBox[{"\[Pi]", "-", "1.9056"}], ")"}], " ", 
  FractionBox["180", "\[Pi]"]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"\[Pi]", "-", "2.1439"}], ")"}], 
  FractionBox["180", "\[Pi]"]}]}], "Input",
 CellChangeTimes->{{3.539995779430288*^9, 3.5399958633420873`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"if", 
   RowBox[{"(", 
    RowBox[{"sp", "\[Equal]", "0"}], ")"}], 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rhonor", "=", "1030713.25"}], ";", 
     RowBox[{"heat", "=", "0.42107"}], ";", 
     RowBox[{"th", "=", "0.7328"}], ";", 
     RowBox[{"fdiff", "=", "60"}], ";"}], "}"}]}], "//", "4.2802"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"if", 
    RowBox[{"(", 
     RowBox[{"sp", "\[Equal]", "1"}], ")"}], 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"rhonor", "=", "767789.57"}], ";", 
      RowBox[{"heat", "=", "0.42077"}], ";", 
      RowBox[{"th", "=", "1.9056"}], ";", 
      RowBox[{"fdiff", "=", "60"}], ";"}], "}"}]}], "//", "2.4738"}], "//", 
  RowBox[{"update", " ", "Mar2012"}]}], "\n", 
 RowBox[{
  RowBox[{"if", 
   RowBox[{"(", 
    RowBox[{"sp", "\[Equal]", "2"}], ")"}], 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rhonor", "=", "817113.52"}], ";", 
     RowBox[{"heat", "=", "0.37239"}], ";", 
     RowBox[{"th", "=", "2.0159"}], ";", 
     RowBox[{"fdiff", "=", "60"}], ";"}], "}"}]}], "//", "3.0837"}], "\n", 
 RowBox[{
  RowBox[{"if", 
   RowBox[{"(", 
    RowBox[{"sp", "\[Equal]", "3"}], ")"}], 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rhonor", "=", "656228.94"}], ";", 
     RowBox[{"heat", "=", "0.39849"}], ";", 
     RowBox[{"th", "=", "2.2074"}], ";", 
     RowBox[{"fdiff", "=", "60"}], ";"}], "}"}]}], "//", "4.1912"}], "\n", 
 RowBox[{
  RowBox[{"if", 
   RowBox[{"(", 
    RowBox[{"sp", "\[Equal]", "4"}], ")"}], 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rhonor", "=", "397281.19"}], ";", 
     RowBox[{"heat", "=", "0.41343"}], ";", 
     RowBox[{"th", "=", "2.1439"}], ";", 
     RowBox[{"fdiff", "=", "60"}], ";"}], "}"}]}], "//", "3.0059"}]}], "Input",
 CellChangeTimes->{{3.539995651787987*^9, 3.53999565253903*^9}, 
   3.5399957715948396`*^9}],

Cell[BoxData[{
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnY2RrMYOhXG9SJyCEyCHF4ITcAiERmh4falVafR7aJq9+3O+Klddz4iW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    "], {{0, 50}, {511, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->{267.7999999999993, Automatic},
  ImageSizeRaw->{511, 50},
  PlotRange->{{0, 511}, {0, 50}}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Q", " ", 
   RowBox[{"\[OpenCurlyDoubleQuote]", "points", "\[CloseCurlyDoubleQuote]"}], 
   " ", "North"}], ",", 
  RowBox[{"U", " ", "45", " ", "toward", " ", "East", " ", 
   RowBox[{"(*", "Myers", "*)"}]}]}]}], "Input",
 CellChangeTimes->{{3.4857151741540003`*^9, 3.485715184592*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "How CP, LP are produced for spin 0.5 fit (Figure 8, 9) + Huang et al. \
(Figure x) - ",
 StyleBox["done",
  FontColor->RGBColor[0, 0, 1]]
}], "Subsection",
 CellChangeTimes->{{3.485182022574*^9, 3.4851820272209997`*^9}, {
   3.485182068828*^9, 3.4851820710109997`*^9}, {3.4851821305030003`*^9, 
   3.485182130631*^9}, {3.485214518634046*^9, 3.485214522361046*^9}, {
   3.485793987738*^9, 3.485793991736*^9}, {3.4891539732451324`*^9, 
   3.4891539795163326`*^9}, {3.499625311199112*^9, 3.4996253223687115`*^9}, {
   3.502641954354*^9, 3.5026419552980003`*^9}, {3.509206143731*^9, 
   3.5092061440109997`*^9}, {3.509298560304*^9, 3.509298561551*^9}, {
   3.528550429792749*^9, 3.528550430645262*^9}, {3.529164521422838*^9, 
   3.52916452337495*^9}, {3.5291649111241283`*^9, 3.5291649157803946`*^9}, {
   3.5291691609182024`*^9, 3.5291691623662853`*^9}, {3.5291715189170723`*^9, 
   3.529171519277093*^9}, 3.52918253705801*^9, {3.529182604624875*^9, 
   3.529182604968895*^9}, {3.5399937729665246`*^9, 3.5399937732645416`*^9}, {
   3.540226290755782*^9, 3.5402262930899153`*^9}, {3.540300678216488*^9, 
   3.540300679408556*^9}, {3.540315097818242*^9, 3.540315101074428*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<ErrorBarPlots`\>\"", "]"}], ";", 
  RowBox[{"Needs", "[", "\"\<ErrorBarLogPlots`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xFnu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"87.73`", ",", "1.8409545454545453`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.08006092045351851`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"102.`", ",", "1.9076923076923078`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.15168351771484959`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"145.`", ",", "2.2750000000000004`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.2644063431268514`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"230.9`", ",", "2.6372093023255814`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.14137527543005202`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"349.`", ",", "3.1806666666666668`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.12050080682071983`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"674.`", ",", "3.2857142857142856`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.35080083308024784`", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"857.`", ",", "2.866666666666667`"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.2403700850309327`", "]"}]}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xLPnu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"87.73", ",", "1.420"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.5", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"230.9", ",", "7.3979"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.6579", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"349", ",", "6.499"}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.6054", "]"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xCPnu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"231", ",", 
         RowBox[{"-", "1.2"}]}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.3", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"349", ",", 
         RowBox[{"-", "1.5"}]}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", "0.3", "]"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xEVPA", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"88", ",", 
        RowBox[{"-", "4.0166666666666675`"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"231", ",", "111.47500000000001`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"349", ",", "146.89090909090908`"}], "}"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"el", "=", 
   RowBox[{"{", 
    RowBox[{
    "ListLogLogPlot", ",", "ListLogLinearPlot", ",", "ErrorListLogLogPlot", 
     ",", "ErrorListLogLinearPlot"}], "}"}]}], ";", 
  RowBox[{"Clear", "[", "totI", "]"}], ";", 
  RowBox[{"xcol", "=", "Cyan"}], ";", 
  RowBox[{"myf", "=", "14"}], ";", 
  RowBox[{"siz", "=", "280"}], ";", 
  RowBox[{"ord", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"#", ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ","}], "*)"}], 
        RowBox[{
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}]}], "}"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"FrameTicks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"(*", 
           RowBox[{"{", 
            RowBox[{
            "10", ",", "20", ",", "50", ",", "100", ",", "200", ",", "500"}], 
            "}"}], "*)"}], 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "43", ",", "88", ",", "145", ",", "231", ",", "349", ",", "690"}],
             "}"}], ",", "None"}], "}"}]}], "}"}]}]}], "]"}], "&"}], "/@", 
   "el"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ax", "=", "30"}], ";", 
   RowBox[{"Fran", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"40", ",", "900"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0.8", ",", "3.7"}], "}"}]}], "}"}]}], ";", 
   RowBox[{"LPran", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"40", ",", "860"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0.3", ",", "25."}], "}"}]}], "}"}]}], ";", 
   RowBox[{"CPran", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"40", ",", "860"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "2."}], ",", "1.2"}], "}"}]}], "}"}]}], ";", 
   RowBox[{"angran", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"135", ",", "860"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"90", ",", "170"}], "}"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plo", "[", 
    RowBox[{
     RowBox[{"dat_", "?", "StringQ"}], ",", 
     RowBox[{"style_", "?", "ListQ"}], ",", 
     RowBox[{"ax_", "?", "NumberQ"}]}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fff", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Import", "[", "dat", "]"}], "]"}]}], ";", 
     RowBox[{"ftab", "=", 
      RowBox[{"fff", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"Fnusim", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"ftab", ",", 
         RowBox[{"fff", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
     RowBox[{"LPnusim", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"ftab", ",", 
         RowBox[{"fff", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
     RowBox[{"CPnusim", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"ftab", ",", 
         RowBox[{"fff", "[", 
          RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
     RowBox[{"angsim", "=", 
      RowBox[{"Delete", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"ftab", ",", 
           RowBox[{"Mod", "[", 
            RowBox[{
             RowBox[{"ax", "+", 
              RowBox[{"fff", "[", 
               RowBox[{"[", "5", "]"}], "]"}], "-", "180"}], ",", "180"}], 
            "]"}]}], "}"}], "]"}], ",", "1"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{"Fnusim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "Fran"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "Null", ",", 
              "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}], 
             "}"}]}], "}"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", "\[IndentingNewLine]", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}], ",", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{"LPnusim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "ord"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "LPran"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Null", ",", "\"\<LP [%]\>\""}], "}"}]}], "}"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}], ",", 
       RowBox[{"ListLogLinearPlot", "[", 
        RowBox[{"CPnusim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "ord"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Null", ",", "\"\<CP [%]\>\""}], "}"}]}], "}"}]}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "CPran"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}], ",", 
       RowBox[{"ListLogLinearPlot", "[", 
        RowBox[{"angsim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "angran"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "Null", ",", "\"\<Electric vector position angle [deg]\>\""}], 
             "}"}]}], "}"}]}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}]}], "}"}]}], 
    ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pldat", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ErrorListLogLogPlot", "[", 
      RowBox[{"xFnu", ",", 
       RowBox[{"Joined", "\[Rule]", "False"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "Fran"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Null", ",", "Null"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "Null", ",", 
            "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}], "}"}]}], 
         "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ErrorListLogLogPlot", "[", 
      RowBox[{"xLPnu", ",", 
       RowBox[{"Joined", "\[Rule]", "False"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "LPran"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Null", ",", "Null"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Null", ",", "\"\<LP [%]\>\""}], "}"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}], ",", 
     RowBox[{"ErrorListLogLinearPlot", "[", 
      RowBox[{"xCPnu", ",", 
       RowBox[{"Joined", "\[Rule]", "False"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "CPran"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Null", ",", "Null"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Null", ",", "\"\<CP [%]\>\""}], "}"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}]}], "]"}], ",", 
     RowBox[{"ListLogLinearPlot", "[", 
      RowBox[{"xEVPA", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "angran"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Null", ",", "Null"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "Null", ",", "\"\<Electric vector position angle [deg]\>\""}], 
           "}"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"AbsoluteThickness", "[", "6", "]"}], ",", "Blue"}], 
         "}"}]}]}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "fname", "=", 
   "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2012Feb_full\\\\quicka50in21\
\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl50all", "=", 
   RowBox[{"plo", "[", 
    RowBox[{
     RowBox[{"fname", "<>", "\"\<_all.dat\>\""}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Red"}], "}"}], 
     ",", "61"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl50jVc0", "=", 
   RowBox[{"plo", "[", 
    RowBox[{
     RowBox[{"fname", "<>", "\"\<_jVc0.dat\>\""}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "DotDashed", ",", 
       "Orange"}], "}"}], ",", "61"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl50rQc0", "=", 
   RowBox[{"plo", "[", 
    RowBox[{
     RowBox[{"fname", "<>", "\"\<_rQc0.dat\>\""}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", 
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"3", ",", "5"}], "}"}], "]"}], ",", "Brown"}], "}"}], ",", 
     "65"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl50rVc0", "=", 
   RowBox[{"plo", "[", 
    RowBox[{
     RowBox[{"fname", "<>", "\"\<_rVc0.dat\>\""}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", 
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"10", ",", "7"}], "}"}], "]"}], ",", "Green"}], "}"}], ",", 
     "80"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tot", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{
     "pl50rVc0", ",", "pl50rQc0", ",", "pl50jVc0", ",", "pl50all", ",", 
      "pldat"}], "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"CPnupl", "=", 
  RowBox[{"Show", "[", 
   RowBox[{"tot", "[", 
    RowBox[{"[", "3", "]"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
   "dir", "=", 
    "\"\<C:\\\\study\\\\accretion\\\\! 2009 3fall cfa\\\\GR Polarized \
modeling\\\\!svn\\\\\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl50rVc0", "=", 
   RowBox[{"plo", "[", 
    RowBox[{
     RowBox[{"fname", "<>", "\"\<_rVc0.dat\>\""}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", 
       RowBox[{"AbsoluteDashing", "[", 
        RowBox[{"{", 
         RowBox[{"10", ",", "7"}], "}"}], "]"}], ",", "Green"}], "}"}], ",", 
     "50"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pl50Bp15", "=", 
    RowBox[{"plo", "[", 
     RowBox[{
      RowBox[{"fname", "<>", "\"\<_Bp15.dat\>\""}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "DotDashed", ",",
         "Black"}], "}"}], ",", "62"}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"rVc", "*=", 
    RowBox[{"5", " ", "leads", " ", "to", " ", "worse", " ", "resutls"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tot", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"(*", 
      RowBox[{"pl50Bp15", ","}], "*)"}], 
     RowBox[{"pl50rVc0", ",", "pl50all", ",", "pldat"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LPnupl", "=", 
   RowBox[{"Show", "[", 
    RowBox[{"tot", "[", 
     RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"angnupl", "=", 
   RowBox[{"Show", "[", 
    RowBox[{"tot", "[", 
     RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"LPangpl", "=", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"LPnupl", ",", "angnupl"}], "}"}], ",", 
    RowBox[{"Epilog", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Black", ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", "myf", ",", "Bold"}], "]"}], 
         ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.94", ",", "0.15"}], "}"}], "]"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<\[Nu] [GHz]\>\"", ",", "myf", ",", "Bold"}], "]"}], 
         ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.44", ",", "0.15"}], "}"}], "]"}]}], "]"}]}], "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"dir", "<>", "\"\<CPpl.eps\>\""}], ",", "CPnupl"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"dir", "<>", "\"\<LPangpl.eps\>\""}], ",", "LPangpl"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.5026400910030003`*^9, 3.502640091448*^9}, {
   3.502640239097*^9, 3.5026402402790003`*^9}, 3.502640384824*^9, {
   3.5026404829440002`*^9, 3.502640497109*^9}, {3.502640564832*^9, 
   3.5026405659709997`*^9}, {3.502640721308*^9, 3.502640745034*^9}, {
   3.5026409599969997`*^9, 3.5026409602130003`*^9}, {3.502641300684*^9, 
   3.502641302291*^9}, {3.502641522517*^9, 3.502641530634*^9}, {
   3.5026415783529997`*^9, 3.5026416177539997`*^9}, {3.502641915551*^9, 
   3.50264191712*^9}, {3.5092944205880003`*^9, 3.509294422052*^9}, {
   3.509296374507*^9, 3.509296399666*^9}, {3.509296462888*^9, 
   3.509296503071*^9}, {3.509296685571*^9, 3.5092966890810003`*^9}, {
   3.5092967222980003`*^9, 3.509296767078*^9}, {3.509296971234*^9, 
   3.509296985738*^9}, 3.509297267099*^9, {3.5092973006800003`*^9, 
   3.509297341495*^9}, {3.509297406707*^9, 3.509297435592*^9}, {
   3.5092975547720003`*^9, 3.5092975747679996`*^9}, {3.5291665663558016`*^9, 
   3.529166621375949*^9}, {3.5291666877207437`*^9, 3.5291667765168223`*^9}, {
   3.5291668277867546`*^9, 3.5291668419605656`*^9}, {3.529166881344818*^9, 
   3.5291668825518875`*^9}, {3.5291670660953856`*^9, 3.529167175809661*^9}, {
   3.529167728588278*^9, 3.529167819947503*^9}, {3.529168628124728*^9, 
   3.5291686296828175`*^9}, {3.5291825758912315`*^9, 
   3.5291825759702363`*^9}, {3.5296860374828496`*^9, 
   3.5296860375296497`*^9}, {3.5296861490074453`*^9, 3.52968616295387*^9}, {
   3.540311431216524*^9, 3.5403114548938785`*^9}, {3.5403115183095055`*^9, 
   3.540311578927973*^9}, {3.5403116182222204`*^9, 3.5403116834899535`*^9}, {
   3.5403117735701056`*^9, 3.5403117745201597`*^9}, {3.540311823877983*^9, 
   3.540311891097828*^9}}],

Cell[CellGroupData[{

Cell["conference", "Subsubsection",
 CellChangeTimes->{{3.502641940251*^9, 3.502641941171*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ord", "=", "2"}], ";", 
  RowBox[{
  "dir", "=", 
   "\"\<C:\\\\study\\\\accretion\\\\conferences\\\\2010 November - Ins and \
Outs of the Black Holes\\\\\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dir", "=", 
   "\"\<C:\\\\study\\\\accretion\\\\! 2010 summer cfa\\\\from \
Lei\\\\paper\\\\\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fff", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"Import", "[", 
     RowBox[{"dir", "<>", "\"\<poliresa90th223fn-1boo-exact.dat\>\""}], "]"}],
     "]"}]}], ";", 
  RowBox[{"ftab", "=", 
   RowBox[{"fff", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LPnu", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"ftab", ",", 
      RowBox[{"fff", "[", 
       RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
  RowBox[{"CPnu", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"ftab", ",", 
      RowBox[{"fff", "[", 
       RowBox[{"[", "6", "]"}], "]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fff", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"Import", "[", 
     RowBox[{"dir", "<>", "\"\<poliresa90th223fn-1boo-approx.dat\>\""}], 
     "]"}], "]"}]}], ";", 
  RowBox[{"ftab", "=", 
   RowBox[{"fff", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"CPapprox", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"ftab", ",", 
      RowBox[{"fff", "[", 
       RowBox[{"[", "6", "]"}], "]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LPapprox", "=", 
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{"ftab", ",", 
       RowBox[{"fff", "[", 
        RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"el", "=", 
   RowBox[{"{", 
    RowBox[{"ListLogLogPlot", ",", "ListLogLinearPlot"}], "}"}]}], ";", 
  RowBox[{"Clear", "[", "totI", "]"}], ";", 
  RowBox[{"xcol", "=", "Cyan"}], ";", 
  RowBox[{"siz", "=", "320"}], ";", 
  RowBox[{"myf", "=", "15"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"#", ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}]}], "}"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"FrameTicks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "43", ",", "88", ",", "145", ",", "231", ",", "349", ",", "690"}],
             "}"}], ",", "None"}], "}"}]}], "}"}]}]}], "]"}], "&"}], "/@", 
   "el"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"LPnu", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "ord"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"80", ",", "860"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1.", ",", "12."}], "}"}]}], "}"}]}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "\"\<                                                       \[Nu] \
[GHz]\>\"", ",", "\"\<LP [%]\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Green"}], 
       "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"LPapprox", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "ord"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Null", ",", "\"\<LP [%]\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", 
        RowBox[{"AbsoluteDashing", "[", 
         RowBox[{"{", 
          RowBox[{"10", ",", "7"}], "}"}], "]"}], ",", "Red"}], "}"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LPnupl", "=", 
    RowBox[{"Show", "[", 
     RowBox[{"lpl1", ",", "lpl2"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ListLogLinearPlot", "[", 
    RowBox[{"CPnu", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "ord"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"80", ",", "860"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "5."}], ",", "1"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "\"\<                                                       \[Nu] \
[GHz]\>\"", ",", "\"\<CP [%]\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Green"}], 
       "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl2", "=", 
   RowBox[{"ListLogLinearPlot", "[", 
    RowBox[{"CPapprox", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "ord"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Null", ",", "Null"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Null", ",", "\"\<CP [%]\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", 
        RowBox[{"AbsoluteDashing", "[", 
         RowBox[{"{", 
          RowBox[{"10", ",", "7"}], "}"}], "]"}], ",", "Red"}], "}"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CPpl", "=", 
   RowBox[{"Show", "[", 
    RowBox[{"lpl1", ",", "lpl2"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res", "=", 
   RowBox[{"GraphicsRow", "[", 
    RowBox[{"{", 
     RowBox[{"LPnupl", ",", "CPpl"}], "}"}], "]"}]}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"dir", "<>", "\"\<approx.pdf\>\""}], ",", "res"}], "]"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"dir", "<>", "\"\<fRoman.eps\>\""}], ",", "res"}], "]"}]}], "Input",
 CellChangeTimes->{{3.4987835441018*^9, 3.4987835932158003`*^9}, {
   3.4987836454807997`*^9, 3.4987837187158003`*^9}, {3.4987840440928*^9, 
   3.4987842177198*^9}, {3.4987842579868*^9, 3.4987843232258*^9}, {
   3.4987843566368*^9, 3.4987843659068003`*^9}, {3.4987847321977997`*^9, 
   3.4987848022598*^9}, {3.4987848448328*^9, 3.4987849372388*^9}, {
   3.4987886889368*^9, 3.4987886921717997`*^9}, {3.4996254177895117`*^9, 
   3.4996254185505114`*^9}, {3.4996254705695114`*^9, 
   3.4996254712935114`*^9}, {3.499625525662512*^9, 3.4996255787815113`*^9}, {
   3.4996257683155117`*^9, 3.4996258748115115`*^9}, {3.4996259410285115`*^9, 
   3.499625941537512*^9}, {3.4996260008735113`*^9, 3.4996260184695115`*^9}, {
   3.4996261036185117`*^9, 3.4996261121045113`*^9}, 3.4996262099405117`*^9, {
   3.5092976972349997`*^9, 3.509297699618*^9}, {3.5092982001400003`*^9, 
   3.5092982334119997`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Behavior near best fit (Figure 10) -- reduced to 1 figure from 2 figures - ",
 StyleBox["deleted",
  FontColor->RGBColor[1, 0, 0]]
}], "Subsection",
 CellChangeTimes->{{3.485898334041*^9, 3.485898340388*^9}, {3.485899299355*^9,
    3.485899300737*^9}, {3.4891541474035325`*^9, 3.4891541513815327`*^9}, {
   3.502627692347*^9, 3.502627693057*^9}, {3.5092061459709997`*^9, 
   3.509206146258*^9}, {3.509377437054*^9, 3.509377438028*^9}, {
   3.52855043380031*^9, 3.5285504339678135`*^9}, {3.52916468282207*^9, 
   3.5291647001490607`*^9}, {3.529242700079401*^9, 3.529242703991625*^9}, {
   3.529242962302399*^9, 3.5292429637174797`*^9}, 3.5293166764702616`*^9, 
   3.529321835813529*^9, {3.5399937756526785`*^9, 3.5399937761067047`*^9}, {
   3.539993819935211*^9, 3.539993822731371*^9}}],

Cell[CellGroupData[{

Cell["new - series of snapshots", "Subsubsection",
 CellChangeTimes->{{3.5291826466082764`*^9, 3.529182652632621*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"AppendTo", "[", 
   RowBox[{
   "$Path", ",", 
    "\"\<C:\\\\Program Files\\\\Wolfram \
Research\\\\Mathematica\\\\LevelScheme-3.52\>\""}], "]"}], ";", 
  RowBox[{"Get", "[", "\"\<LevelScheme`\>\"", "]"}], ";", 
  RowBox[{"tofit", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"8.450", ",", "0.6898", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.2500"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14.90", ",", "0.9044", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.6200"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22.50", ",", "1.070", ",", "0.1900", ",", "131.0", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"43.00", ",", "1.159", ",", "0.5041", ",", "94.25", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"87.73", ",", "1.841", ",", "1.42", ",", 
       RowBox[{"-", "4."}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"102.0", ",", "1.908", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"145.0", ",", "2.275", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"230.9", ",", "2.637", ",", "7.4", ",", "111.5", ",", 
       RowBox[{"-", "1.200"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"349.0", ",", "3.181", ",", "6.5", ",", "146.9", ",", 
       RowBox[{"-", "1.500"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"674.0", ",", "3.286", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"857.0", ",", "2.867", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"dFnu", "=", 
    RowBox[{"{", 
     RowBox[{
     "1.", ",", "1.", ",", "1.", ",", "1.", ",", "0.080", ",", "0.1517", ",", 
      "0.2644", ",", "0.1414", ",", "0.1205", ",", "0.3508", ",", "0.2404"}], 
     "}"}]}], ";", 
   RowBox[{"dCP", "=", "0.30"}], ";", 
   RowBox[{"dLP", "=", 
    RowBox[{"{", 
     RowBox[{"0.5", ",", "0.66", ",", "0.61"}], "}"}]}], 
   ";"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "0.4"}], ";", 
  RowBox[{"mc", "=", "2.5"}], ";", 
  RowBox[{"myf", "=", "12"}], ";", 
  RowBox[{"siz", "=", "350"}], ";", 
  RowBox[{"del", "=", "0.12"}], ";", 
  RowBox[{"flen", "=", "7"}], ";", 
  RowBox[{"nP", "=", "12"}], ";", 
  RowBox[{"nF", "=", "7"}], ";", 
  RowBox[{"Mdot", "=", 
   SuperscriptBox["10", 
    RowBox[{"-", "8"}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"func", "[", 
    RowBox[{"pl_", ",", "fra_"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"ycp", "=", "pl"}], ";", 
     RowBox[{"xmin", "=", 
      RowBox[{"Min", "[", 
       RowBox[{"ycp", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1", ",", "All", ",", "1"}], "]"}], "]"}], "]"}]}],
      ";", 
     RowBox[{"xmax", "=", 
      RowBox[{"Max", "[", 
       RowBox[{"ycp", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1", ",", "All", ",", "1"}], "]"}], "]"}], "]"}]}],
      ";", 
     RowBox[{"ymin", "=", 
      RowBox[{"Min", "[", 
       RowBox[{"ycp", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1", ",", "All", ",", "2"}], "]"}], "]"}], "]"}]}],
      ";", 
     RowBox[{"ymax", "=", 
      RowBox[{"Max", "[", 
       RowBox[{"ycp", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1", ",", "All", ",", "2"}], "]"}], "]"}], "]"}]}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"sizx", "=", 
      RowBox[{"fra", 
       RowBox[{"(", 
        RowBox[{"xmax", "-", "xmin"}], ")"}]}]}], ";", 
     RowBox[{"sizy", "=", 
      RowBox[{"fra", 
       RowBox[{"(", 
        RowBox[{"ymax", "-", "ymin"}], ")"}]}]}], ";", 
     RowBox[{"coords", "=", 
      RowBox[{"ycp", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2", ",", "3", ",", "All", ",", "2"}], "]"}], 
       "]"}]}], ";", 
     RowBox[{"pos1", "=", 
      RowBox[{"Position", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ar", "=", 
            RowBox[{"Delete", "[", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{
                RowBox[{
                 FractionBox[
                  RowBox[{
                   RowBox[{"coords", "[", 
                    RowBox[{"[", "#", "]"}], "]"}], "-", 
                   RowBox[{"coords", "[", 
                    RowBox[{"[", "nn", "]"}], "]"}]}], 
                  RowBox[{"{", 
                   RowBox[{"sizx", ",", "sizy"}], "}"}]], "&"}], "/@", 
                RowBox[{"Range", "[", 
                 RowBox[{"Length", "[", "coords", "]"}], "]"}]}], "]"}], ",", 
              "nn"}], "]"}]}], ";", 
           RowBox[{"obst", "=", "False"}], ";", 
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"kk", "=", "1"}], ",", 
             RowBox[{"kk", "<", "nn"}], ",", 
             RowBox[{"kk", "++"}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"ar", "[", 
                   RowBox[{"[", 
                    RowBox[{"kk", ",", "1"}], "]"}], "]"}], "<", "1"}], ")"}],
                 "&&", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"ar", "[", 
                   RowBox[{"[", 
                    RowBox[{"kk", ",", "2"}], "]"}], "]"}], "<", "1"}], 
                 ")"}]}], ",", 
               RowBox[{"obst", "=", "True"}]}], "]"}]}], "]"}], ";", "obst"}],
           ",", 
          RowBox[{"{", 
           RowBox[{"nn", ",", 
            RowBox[{
             RowBox[{"Length", "[", "coords", "]"}], "-", "1"}]}], "}"}]}], 
         "]"}], ",", "True"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"pos2", "=", 
      RowBox[{"Position", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"axx", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"1.3", 
               FractionBox[
                RowBox[{
                 RowBox[{"coords", "[", 
                  RowBox[{"[", "#", "]"}], "]"}], "-", 
                 RowBox[{"{", 
                  RowBox[{"xmin", ",", "ymin"}], "}"}]}], 
                RowBox[{"{", 
                 RowBox[{"sizx", ",", "sizy"}], "}"}]]}], "&"}], "/@", 
             RowBox[{"Range", "[", 
              RowBox[{"Length", "[", "coords", "]"}], "]"}]}]}], ";", 
           RowBox[{"obst", "=", "False"}], ";", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"axx", "[", 
                 RowBox[{"[", 
                  RowBox[{"nn", ",", "1"}], "]"}], "]"}], "<", "1"}], ")"}], "||", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"axx", "[", 
                 RowBox[{"[", 
                  RowBox[{"nn", ",", "2"}], "]"}], "]"}], "<", "1"}], ")"}]}],
              ",", 
             RowBox[{"obst", "=", "True"}]}], "]"}], ";", "obst"}], ",", 
          RowBox[{"{", 
           RowBox[{"nn", ",", 
            RowBox[{"Length", "[", "coords", "]"}]}], "}"}]}], "]"}], ",", 
        "True"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"pos3", "=", 
      RowBox[{"Position", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"axx", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"1.3", 
               FractionBox[
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"xmax", ",", "ymax"}], "}"}], "-", 
                 RowBox[{"coords", "[", 
                  RowBox[{"[", "#", "]"}], "]"}]}], 
                RowBox[{"{", 
                 RowBox[{"sizx", ",", "sizy"}], "}"}]]}], "&"}], "/@", 
             RowBox[{"Range", "[", 
              RowBox[{"Length", "[", "coords", "]"}], "]"}]}]}], ";", 
           RowBox[{"obst", "=", "False"}], ";", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"axx", "[", 
                 RowBox[{"[", 
                  RowBox[{"nn", ",", "1"}], "]"}], "]"}], "<", "1"}], ")"}], "||", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"axx", "[", 
                 RowBox[{"[", 
                  RowBox[{"nn", ",", "2"}], "]"}], "]"}], "<", "1"}], ")"}]}],
              ",", 
             RowBox[{"obst", "=", "True"}]}], "]"}], ";", "obst"}], ",", 
          RowBox[{"{", 
           RowBox[{"nn", ",", 
            RowBox[{"Length", "[", "coords", "]"}]}], "}"}]}], "]"}], ",", 
        "True"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"posit", "=", 
      RowBox[{"Union", "[", 
       RowBox[{"pos1", ",", "pos2", ",", "pos3"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"ycp", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2", ",", "3"}], "]"}], "]"}], "=", 
      RowBox[{"Delete", "[", 
       RowBox[{
        RowBox[{"ycp", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "2", ",", "3"}], "]"}], "]"}], ",", "posit"}], 
       "]"}]}], ";", "\[IndentingNewLine]", "ycp"}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fmin", "=", "6950"}], ";", 
  RowBox[{"fmax", "=", "9950"}], ";", 
  RowBox[{"ind", "=", "11"}], ";", 
  RowBox[{"sep", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"ind", "-", "1"}], ")"}]}]}], ";", 
  RowBox[{"gat", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Import", "[", 
        RowBox[{
        "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\\
deepthought\\\\4\\\\poliresa50th203fn\>\"", "<>", 
         RowBox[{"ToString", "[", "fnum", "]"}], "<>", 
         "\"\<booch_cr.dat\>\""}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}]}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"Total", "[", 
       RowBox[{"gat", ",", 
        RowBox[{"{", "2", "}"}]}], "]"}], "ind"], ",", "flen"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mmord", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"len", "=", 
   RowBox[{"Length", "[", "imp", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"len", "\[Equal]", 
     SuperscriptBox[
      RowBox[{"Round", "[", 
       RowBox[{"par", "=", 
        RowBox[{"Sqrt", "[", "len", "]"}]}], "]"}], "2"]}], ",", 
    RowBox[{"impx", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{"imp", ",", "par"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}]}], 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"hmin", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", "11"}], "]"}], "]"}], "]"}]}], 
   ";", 
   RowBox[{"hmax", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", 
        RowBox[{"-", "1"}], ",", "11"}], "]"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"hmin", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"impx", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}], "]"}]}], 
    ";", 
    RowBox[{"hmax", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"impx", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", 
         RowBox[{"-", "1"}], ",", "8"}], "]"}], "]"}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rhomin", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", "12"}], "]"}], "]"}], "]"}]}], 
   ";", 
   RowBox[{"rhomax", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}], ",", "1", ",", "12"}], "]"}], "]"}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"thmin", "=", 
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", 
    RowBox[{"thmax", "=", 
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabb", "=", 
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           RowBox[{"tofit", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{
               RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
              "2"}], "]"}], "]"}], "-", 
           RowBox[{"impx", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], "]"}]}], 
          RowBox[{"dFnu", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
           "]"}]], ")"}], "2"], "]"}], 
      RowBox[{"nF", "-", "3"}]], "&"}], "/@", 
    RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnu3", "=", 
    RowBox[{"ListInterpolation", "[", 
     RowBox[{"tabb", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"rhomin", ",", "rhomax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"hmin", ",", "hmax"}], "}"}]}], "}"}], ",", 
      RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"for", " ", "heat"}], ";", " ", 
    RowBox[{"for", " ", "rhonor", " ", "in", " ", 
     RowBox[{"C", "++"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabb", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      FractionBox["1", 
       RowBox[{"nP", "-", "3"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                "2"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], 
              "]"}]}], 
            RowBox[{"dFnu", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
             "]"}]], ")"}], "2"], "]"}], "+", 
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "4"}], ";;", 
                 RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "6"}], 
               "]"}], "]"}]}], "dCP"], ")"}], "2"], "]"}], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{"5", ",", "3"}], "]"}], "]"}], "-", 
            RowBox[{"impx", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "7"}], ",", "#", ",", "All", ",", "4"}], "]"}], 
             "]"}]}], 
           RowBox[{"dLP", "[", 
            RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "4"}], ";;", 
                 RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "4"}], 
               "]"}], "]"}]}], 
            RowBox[{"dLP", "[", 
             RowBox[{"[", 
              RowBox[{"2", ";;", "3"}], "]"}], "]"}]], ")"}], "2"], "]"}]}], 
       ")"}]}], "&"}], "/@", 
    RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lipFnuCPLP3", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{"tabb", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"rhomin", ",", "rhomax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"hmin", ",", "hmax"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lcp09", "=", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"lipFnu3", "[", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{"Mdot", " ", "rhonor"}], "]"}], ",", 
       RowBox[{"Log", "[", "heat", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"heat", ",", 
       RowBox[{"Exp", "[", "hmin", "]"}], ",", 
       RowBox[{"Exp", "[", "hmax", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"rhonor", ",", 
       FractionBox[
        RowBox[{"Exp", "[", "rhomin", "]"}], "Mdot"], ",", 
       FractionBox[
        RowBox[{"Exp", "[", "rhomax", "]"}], "Mdot"]}], "}"}], ",", 
     RowBox[{"Contours", "\[Rule]", "40"}], ",", 
     RowBox[{"ContourLabels", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Framed", "[", "#3", "]"}], ",", 
            RowBox[{"myf", "-", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], ")"}]}],
      ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Ratio Tp/Te\>\"", ",", 
        "\"\<Accretion rate [\!\(\*SuperscriptBox[\(10\), \(-8\)]\)Msun/year]\
\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"(*", 
        RowBox[{"\"\<Times\>\"", ","}], "*)"}], "myf", "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
         RowBox[{"coe", 
          RowBox[{"(", 
           RowBox[{"#", "-", "mc"}], ")"}]}], "]"}], "&"}], ")"}]}], ",", 
     RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.5"}], ",", 
     RowBox[{"PlotRegion", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xcp09", "=", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"lipFnuCPLP3", "[", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{"Mdot", " ", "rhonor"}], "]"}], ",", 
       RowBox[{"Log", "[", "heat", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"heat", ",", 
       RowBox[{"Exp", "[", "hmin", "]"}], ",", 
       RowBox[{"Exp", "[", "hmax", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"rhonor", ",", 
       FractionBox[
        RowBox[{"Exp", "[", "rhomin", "]"}], "Mdot"], ",", 
       FractionBox[
        RowBox[{"Exp", "[", "rhomax", "]"}], "Mdot"]}], "}"}], ",", 
     RowBox[{"Contours", "\[Rule]", "40"}], ",", 
     RowBox[{"ContourLabels", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Framed", "[", "#3", "]"}], ",", 
            RowBox[{"myf", "-", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], ")"}]}],
      ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Ratio Tp/Te\>\"", ",", 
        "\"\<Accretion rate [\!\(\*SuperscriptBox[\(10\), \(-8\)]\)Msun/year]\
\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"(*", 
        RowBox[{"\"\<Times\>\"", ","}], "*)"}], "myf", "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
         RowBox[{"coe", 
          RowBox[{"(", 
           RowBox[{"#", "-", "mc"}], ")"}]}], "]"}], "&"}], ")"}]}], ",", 
     RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.5"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lcp09", "=", 
   RowBox[{"func", "[", 
    RowBox[{"lcp09", ",", "del"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xcp09", "=", 
    RowBox[{"func", "[", 
     RowBox[{"xcp09", ",", "del"}], "]"}]}], ";", 
   RowBox[{"xmin09", "=", "xmin"}], ";", 
   RowBox[{"xmax09", "=", "xmax"}], ";", 
   RowBox[{"ymin09", "=", "ymin"}], ";", 
   RowBox[{"ymax09", "=", "ymax"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"figchcr", "=", 
    RowBox[{"Figure", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ScaledLabel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0.54", ",", "1"}], "}"}], ",", 
          "\"\<\!\(\*SubscriptBox[\(a\), \(*\)]\)=0.5: \
\!\(\*SuperscriptBox[SubscriptBox[\(\[Chi]\), \(F\)], \
\(2\)]\)/\!\(\*SubscriptBox[\(dof\), \(F\)]\)(a) and total \
\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\)/dof(b)\>\"", ",", 
          RowBox[{"FontSize", "\[Rule]", "myf"}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
          RowBox[{"Offset", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
        RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1"}], "}"}], ",", 
          RowBox[{"XPlotRanges", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"xmin09", ",", "xmax09"}], "}"}]}], ",", 
          RowBox[{"YPlotRanges", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"ymin09", ",", "ymax09"}], "}"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"XFrameLabels", "\[Rule]", 
           RowBox[{"(*", 
            RowBox[{"textit", "["}], "*)"}], "\"\<Tp/Te at 6M\>\""}], ",", 
          RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
          RowBox[{
          "YFrameLabels", "\[Rule]", 
           "\"\<\!\(\*OverscriptBox[\(M\), \(.\)]\) \
[\!\(\*SuperscriptBox[\(10\), \(-8\)]\)\!\(\*SubscriptBox[\(M\), \(\
\[CircleDot]\)]\) \!\(\*SuperscriptBox[\(yr\), \(-1\)]\)]\>\""}], ",", 
          RowBox[{"BufferL", "\[Rule]", "7"}], ",", "\[IndentingNewLine]", 
          RowBox[{"TickFontSize", "\[Rule]", "myf"}], ",", 
          RowBox[{"FontSize", "\[Rule]", "myf"}], ",", "\[IndentingNewLine]", 
          RowBox[{"XPanelSizes", "\[Rule]", 
           RowBox[{"{", "1", "}"}]}], ",", 
          RowBox[{"YPanelSizes", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}]}], ",", 
          RowBox[{"YGapSizes", "\[Rule]", 
           RowBox[{"{", "0.1", "}"}]}], ",", 
          RowBox[{"Background", "\[Rule]", "White"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
          RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
          RowBox[{"PanelLetterCorner", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
          RowBox[{"TickNudge", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "5"}], ",", "0"}], "}"}], ",", "0", ",", "0"}], 
            "}"}]}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
        RowBox[{"FigurePanel", "[", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"RawGraphics", "[", 
         RowBox[{"lcp09", ",", 
          RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
        RowBox[{"FigurePanel", "[", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}], "]"}], ",", 
        RowBox[{"RawGraphics", "[", 
         RowBox[{"xcp09", ",", 
          RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.26"}], ",", "1.10"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.14"}], ",", "1.10"}], "}"}]}], "}"}]}], 
      "\[IndentingNewLine]", ",", 
      RowBox[{"ImageSize", "\[Rule]", 
       RowBox[{"12", "*", "2", "*", 
        RowBox[{"{", 
         RowBox[{"11", ",", 
          RowBox[{
           FractionBox["12", "10"], "11"}]}], "}"}]}]}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"gat", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Import", "[", 
        RowBox[{
        "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\\
deepthought\\\\4\\\\poliresa50th203fn\>\"", "<>", 
         RowBox[{"ToString", "[", "fnum", "]"}], "<>", 
         "\"\<booch_th.dat\>\""}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}]}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"Total", "[", 
       RowBox[{"gat", ",", 
        RowBox[{"{", "2", "}"}]}], "]"}], "ind"], ",", "flen"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"len", "=", 
    RowBox[{"Length", "[", "imp", "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"min", " ", "\[Chi]sq"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"len", "\[Equal]", 
     SuperscriptBox[
      RowBox[{"Round", "[", 
       RowBox[{"par", "=", 
        RowBox[{"Sqrt", "[", "len", "]"}]}], "]"}], "2"]}], ",", 
    RowBox[{"impx", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{"imp", ",", "par"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}]}], 
   "]"}], ";", 
  RowBox[{"mmord", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hmin", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"impx", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1", ",", "1", ",", "11"}], "]"}], "]"}], "]"}]}], 
  ";", 
  RowBox[{"hmax", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"impx", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1", ",", 
       RowBox[{"-", "1"}], ",", "11"}], "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"thmin", "=", 
   RowBox[{
    FractionBox["180", "\[Pi]"], 
    RowBox[{"(", 
     RowBox[{"\[Pi]", "-", 
      RowBox[{"impx", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", "1", ",", "13"}], "]"}], "]"}]}], 
     ")"}]}]}], ";", 
  RowBox[{"thmax", "=", 
   RowBox[{
    FractionBox["180", "\[Pi]"], 
    RowBox[{"(", 
     RowBox[{"\[Pi]", "-", 
      RowBox[{"impx", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}], ",", "1", ",", "13"}], "]"}], "]"}]}], ")"}]}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabb", "=", 
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           RowBox[{"tofit", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{
               RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
              "2"}], "]"}], "]"}], "-", 
           RowBox[{"impx", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], "]"}]}], 
          RowBox[{"dFnu", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
           "]"}]], ")"}], "2"], "]"}], 
      RowBox[{"nF", "-", "3"}]], "&"}], "/@", 
    RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnu3", "=", 
    RowBox[{"ListInterpolation", "[", 
     RowBox[{"tabb", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"thmin", ",", "thmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"hmin", ",", "hmax"}], "}"}]}], "}"}], ",", 
      RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"for", " ", "heat"}], ";", " ", 
    RowBox[{"for", " ", "th", " ", "in", " ", 
     RowBox[{"C", "++"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabb", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      FractionBox["1", 
       RowBox[{"nP", "-", "3"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                "2"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], 
              "]"}]}], 
            RowBox[{"dFnu", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
             "]"}]], ")"}], "2"], "]"}], "+", 
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "4"}], ";;", 
                 RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "6"}], 
               "]"}], "]"}]}], "dCP"], ")"}], "2"], "]"}], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{"5", ",", "3"}], "]"}], "]"}], "-", 
            RowBox[{"impx", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "7"}], ",", "#", ",", "All", ",", "4"}], "]"}], 
             "]"}]}], 
           RowBox[{"dLP", "[", 
            RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "4"}], ";;", 
                 RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "4"}], 
               "]"}], "]"}]}], 
            RowBox[{"dLP", "[", 
             RowBox[{"[", 
              RowBox[{"2", ";;", "3"}], "]"}], "]"}]], ")"}], "2"], "]"}]}], 
       ")"}]}], "&"}], "/@", 
    RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnuCPLP3", "=", 
    RowBox[{"ListInterpolation", "[", 
     RowBox[{"tabb", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"thmin", ",", "thmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"hmin", ",", "hmax"}], "}"}]}], "}"}], ",", 
      RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lcp09", "=", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"lipFnu3", "[", 
      RowBox[{"th", ",", 
       RowBox[{"Log", "[", "heat", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"th", ",", "thmin", ",", "thmax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"heat", ",", 
       RowBox[{"Exp", "[", "hmin", "]"}], ",", 
       RowBox[{"Exp", "[", "hmax", "]"}]}], "}"}], ",", 
     RowBox[{"Contours", "\[Rule]", "40"}], ",", 
     RowBox[{"ContourLabels", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Framed", "[", 
             RowBox[{"0.01", 
              RowBox[{"Round", "[", 
               RowBox[{"100", "#3"}], "]"}]}], "]"}], ",", 
            RowBox[{"myf", "-", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], ")"}]}],
      ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Inclination angle \[Theta]\>\"", ",", "\"\<Ratio Tp/Te\>\""}], 
       "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", "myf", "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
         RowBox[{"coe", 
          RowBox[{"(", 
           RowBox[{"#", "-", "mc"}], ")"}]}], "]"}], "&"}], ")"}]}], ",", 
     RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.5"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xcp09", "=", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"lipFnuCPLP3", "[", 
      RowBox[{"th", ",", 
       RowBox[{"Log", "[", "heat", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"th", ",", "thmin", ",", "thmax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"heat", ",", 
       RowBox[{"Exp", "[", "hmin", "]"}], ",", 
       RowBox[{"Exp", "[", "hmax", "]"}]}], "}"}], ",", 
     RowBox[{"Contours", "\[Rule]", "40"}], ",", 
     RowBox[{"ContourLabels", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Framed", "[", 
             RowBox[{"0.01", 
              RowBox[{"Round", "[", 
               RowBox[{"100", "#3"}], "]"}]}], "]"}], ",", 
            RowBox[{"myf", "-", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], ")"}]}],
      ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Inclination angle \[Theta], deg\>\"", ",", 
        "\"\<Ratio Tp/Te\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", "myf", "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
         RowBox[{"coe", 
          RowBox[{"(", 
           RowBox[{"#", "-", "mc"}], ")"}]}], "]"}], "&"}], ")"}]}], ",", 
     RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.5"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lcp09", "=", 
   RowBox[{"func", "[", 
    RowBox[{"lcp09", ",", "del"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xcp09", "=", 
   RowBox[{"func", "[", 
    RowBox[{"xcp09", ",", "del"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xmin09", "=", "xmin"}], ";", 
   RowBox[{"xmax09", "=", "xmax"}], ";", 
   RowBox[{"ymin09", "=", "ymin"}], ";", 
   RowBox[{"ymax09", "=", "ymax"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"figchth", "=", 
   RowBox[{"Figure", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ScaledLabel", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.54", ",", "1"}], "}"}], ",", 
         "\"\<\!\(\*SubscriptBox[\(a\), \
\(*\)]\)=0.5:\!\(\*SuperscriptBox[SubscriptBox[\(\[Chi]\), \(F\)], \
\(2\)]\)/\!\(\*SubscriptBox[\(dof\), \(F\)]\) (c) and total \
\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\)/dof (d)\>\"", ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
         RowBox[{"Offset", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
       RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}], ",", 
         RowBox[{"XPlotRanges", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"xmin09", ",", "xmax09"}], "}"}]}], ",", 
         RowBox[{"YPlotRanges", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"ymin09", ",", "ymax09"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"XFrameLabels", "\[Rule]", 
          RowBox[{"(*", 
           RowBox[{"textit", "["}], "*)"}], 
          "\"\<Inclination angle \[Theta] [deg]\>\""}], ",", 
         RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
         RowBox[{"YFrameLabels", "\[Rule]", "\"\<Tp/Te at 6M\>\""}], ",", 
         RowBox[{"BufferL", "\[Rule]", "6"}], ",", "\[IndentingNewLine]", 
         RowBox[{"TickFontSize", "\[Rule]", "myf"}], ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}], ",", "\[IndentingNewLine]", 
         RowBox[{"XPanelSizes", "\[Rule]", 
          RowBox[{"{", "1", "}"}]}], ",", 
         RowBox[{"YPanelSizes", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}]}], ",", 
         RowBox[{"YGapSizes", "\[Rule]", 
          RowBox[{"{", "0.1", "}"}]}], ",", 
         RowBox[{"Background", "\[Rule]", "White"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
         RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
         RowBox[{"PanelLetterCorner", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
         RowBox[{"TickNudge", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "5"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "5"}], ",", "0"}], "}"}], ",", "0", ",", "0"}], 
           "}"}]}], ",", 
         RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
       RowBox[{"FigurePanel", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"PanelLetter", "\[Rule]", "\"\<(c)\>\""}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"RawGraphics", "[", 
        RowBox[{"lcp09", ",", 
         RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
       RowBox[{"FigurePanel", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}], ",", 
         RowBox[{"PanelLetter", "\[Rule]", "\"\<(d)\>\""}]}], "]"}], ",", 
       RowBox[{"RawGraphics", "[", 
        RowBox[{"xcp09", ",", 
         RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.26"}], ",", "1.10"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.14"}], ",", "1.10"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", 
      RowBox[{"12", "*", "2", "*", 
       RowBox[{"{", 
        RowBox[{"11", ",", 
         RowBox[{"11", " ", 
          FractionBox["12", "10"]}]}], "}"}]}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"chisq", "=", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{"figchcr", ",", "figchth"}], "}"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
   "dout", "=", 
    "\"\<C:\\\\study\\\\accretion\\\\! 2009 3fall cfa\\\\GR Polarized \
modeling\\\\!svn\\\\\>\""}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"dout", "<>", "\"\<fitFFLPCP.eps\>\""}], ",", "chisq", ",", 
     RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
     RowBox[{"ImageResolution", "\[Rule]", "500"}]}], "]"}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.529234824561947*^9, 3.5292348563017626`*^9}, {
  3.529234970496294*^9, 3.529235040398292*^9}, {3.529235181352354*^9, 
  3.5292351816903734`*^9}, {3.529235642928755*^9, 3.529235714105826*^9}, {
  3.529235837365876*^9, 3.5292358495755744`*^9}, {3.5292358847935886`*^9, 
  3.5292358887528152`*^9}, {3.5292360005912123`*^9, 3.52923600667756*^9}, {
  3.529236051763139*^9, 3.5292361386151066`*^9}, {3.5292361965544205`*^9, 
  3.529236241604997*^9}, {3.5292362720007358`*^9, 3.529236320364502*^9}, {
  3.529236725485674*^9, 3.52923674780595*^9}, {3.529236907882106*^9, 
  3.52923690864915*^9}, {3.5292372904959908`*^9, 3.5292372923170943`*^9}, {
  3.52923734520712*^9, 3.5292373479582767`*^9}, {3.5292374162761846`*^9, 
  3.529237427701838*^9}, {3.5293165930364895`*^9, 3.5293165985998077`*^9}, {
  3.529320638717059*^9, 3.5293206540769377`*^9}, {3.5303737342570467`*^9, 
  3.5303737383822823`*^9}}],

Cell["\<\
8450 87.73 1.94386 1.004 19.259 0.436 2.026 0.38340 924989.0000 0.0000 19.02 \
4.8004e-08 1.9304
8450 102.00 2.08052 0.644 96.064 0.886 2.184 0.38340 924989.0000 0.0000 19.02 \
4.8004e-08 1.9304
8450 145.00 2.58200 0.922 166.664 0.601 2.807 0.38340 924989.0000 0.0000 \
19.02 4.8004e-08 1.9304
8450 230.86 3.27173 5.067 17.492 -0.829 3.727 0.38340 924989.0000 0.0000 \
19.02 4.8004e-08 1.9304
8450 349.00 3.43729 1.381 1.663 -0.047 4.003 0.38340 924989.0000 0.0000 19.02 \
4.8004e-08 1.9304
8450 674.00 2.74813 19.506 104.639 0.133 3.176 0.38340 924989.0000 0.0000 \
19.02 4.8004e-08 1.9304
8450 857.00 2.33092 21.511 99.152 0.337 2.684 0.38340 924989.0000 0.0000 \
19.02 4.8004e-08 1.9304


8450 87.73 2.00994 0.478 93.094 0.275 2.103 0.38340 924989.0000 0.0000 19.02 \
4.8004e-08 2.0330
8450 102.00 2.14889 1.542 25.738 0.859 2.267 0.38340 924989.0000 0.0000 19.02 \
4.8004e-08 2.0330
8450 145.00 2.63764 3.007 97.954 0.290 2.883 0.38340 924989.0000 0.0000 19.02 \
4.8004e-08 2.0330
8450 230.86 3.26116 7.450 153.486 -1.280 3.735 0.38340 924989.0000 0.0000 \
19.02 4.8004e-08 2.0330
8450 349.00 3.35526 4.967 48.042 -0.615 3.934 0.38340 924989.0000 0.0000 \
19.02 4.8004e-08 2.0330
8450 674.00 2.63600 15.608 84.905 -0.151 3.078 0.38340 924989.0000 0.0000 \
19.02 4.8004e-08 2.0330
8450 857.00 2.23570 16.029 85.849 0.145 2.603 0.38340 924989.0000 0.0000 \
19.02 4.8004e-08 2.0330

8450 87.73 2.07416 0.230 169.373 0.135 2.182 0.38340 924989.0000 0.0000 19.02 \
4.8004e-08 2.1304
8450 102.00 2.21315 0.519 108.141 0.730 2.351 0.38340 924989.0000 0.0000 \
19.02 4.8004e-08 2.1304
8450 145.00 2.68819 0.708 81.439 -0.030 2.949 0.38340 924989.0000 0.0000 \
19.02 4.8004e-08 2.1304
8450 230.86 3.23499 4.037 19.754 -1.625 3.725 0.38340 924989.0000 0.0000 \
19.02 4.8004e-08 2.1304
8450 349.00 3.27113 3.520 96.282 -1.024 3.866 0.38340 924989.0000 0.0000 \
19.02 4.8004e-08 2.1304
8450 674.00 2.54285 9.086 80.409 -0.378 3.010 0.38340 924989.0000 0.0000 \
19.02 4.8004e-08 2.1304
8450 857.00 2.16376 9.396 82.494 -0.034 2.556 0.38340 924989.0000 0.0000 \
19.02 4.8004e-08 2.1304
\
\>", "Text",
 CellChangeTimes->{{3.5303740069506435`*^9, 3.530374036221318*^9}, {
  3.5303740844560766`*^9, 3.5303740859771633`*^9}}],

Cell[BoxData[{
 RowBox[{"lipFnuCPLP3", "[", 
  RowBox[{"64", ",", 
   RowBox[{"Log", "[", "19.", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Exp", "[", 
  RowBox[{"{", 
   RowBox[{"hmin", ",", "hmax"}], "}"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5303738101113853`*^9, 3.5303738245202093`*^9}, {
  3.5303738570240684`*^9, 3.530373871095873*^9}}],

Cell[BoxData[{
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Runtime = \>\"", ",", 
   RowBox[{"90.", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["40", "9"], ")"}], "2"], 
    FractionBox["1", "60"]}], ",", "\"\< hrs\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"40", " ", "40", " ", "7"}]}], "Input",
 CellChangeTimes->{{3.5292019135696507`*^9, 3.529201931234661*^9}, {
  3.52923456393904*^9, 3.52923459190664*^9}, {3.5292375496228113`*^9, 
  3.5292375532540193`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["to paper", "Subsubsection",
 CellChangeTimes->{{3.4858980169224157`*^9, 3.4858980207756157`*^9}, {
   3.485899444649*^9, 3.485899447535*^9}, {3.4864423493964*^9, 
   3.4864423502363997`*^9}, 3.508262988726*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "Get", "[", 
   "\"\<C:\\\\Program Files\\\\Wolfram \
Research\\\\Mathematica\\\\LevelScheme-3.45\\\\LevelScheme.m\>\"", "]"}], ";", 
  RowBox[{"tofit", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"8.450", ",", "0.6898", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.2500"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14.90", ",", "0.9044", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.6200"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22.50", ",", "1.070", ",", "0.1900", ",", "131.0", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"43.00", ",", "1.159", ",", "0.5041", ",", "94.25", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"87.73", ",", "1.841", ",", "1.026", ",", 
       RowBox[{"-", "4."}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"102.0", ",", "1.908", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"145.0", ",", "2.275", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"230.9", ",", "2.637", ",", "7.015", ",", "111.5", ",", 
       RowBox[{"-", "1.200"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"349.0", ",", "3.181", ",", "6.143", ",", "146.9", ",", 
       RowBox[{"-", "1.500"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"674.0", ",", "3.286", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"857.0", ",", "2.867", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
    "}"}]}], ";", 
  RowBox[{"(*", 
   RowBox[{"8.45", " ", "-", " ", 
    RowBox[{"43", "GHz"}], " ", "-", " ", 
    RowBox[{"still", " ", "old", " ", "data"}]}], "*)"}], 
  RowBox[{"flen", "=", "7"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"dFnu", "=", 
    RowBox[{"{", 
     RowBox[{
     "1.", ",", "1.", ",", "1.", ",", "1.", ",", "0.080", ",", "0.1517", ",", 
      "0.2644", ",", "0.1414", ",", "0.1205", ",", "0.3508", ",", "0.2404"}], 
     "}"}]}], ";", 
   RowBox[{"dCP", "=", "0.30"}], ";", 
   RowBox[{"dlogLP", "=", 
    RowBox[{"{", 
     RowBox[{"0.19", ",", "0.086", ",", "0.115"}], "}"}]}], 
   ";"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coe", "=", "0.6"}], ";", 
  RowBox[{"mc", "=", "4.0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myf", "=", "12"}], ";", 
  RowBox[{"siz", "=", "350"}], ";", 
  RowBox[{"del", "=", "0.11"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"func", "[", 
     RowBox[{"pl_", ",", "fra_"}], "]"}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"ycp", "=", "pl"}], ";", 
      RowBox[{"xmin", "=", 
       RowBox[{"Min", "[", 
        RowBox[{"ycp", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "All", ",", "1"}], "]"}], "]"}], 
        "]"}]}], ";", 
      RowBox[{"xmax", "=", 
       RowBox[{"Max", "[", 
        RowBox[{"ycp", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "All", ",", "1"}], "]"}], "]"}], 
        "]"}]}], ";", 
      RowBox[{"ymin", "=", 
       RowBox[{"Min", "[", 
        RowBox[{"ycp", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "All", ",", "2"}], "]"}], "]"}], 
        "]"}]}], ";", 
      RowBox[{"ymax", "=", 
       RowBox[{"Max", "[", 
        RowBox[{"ycp", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "All", ",", "2"}], "]"}], "]"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"sizx", "=", 
       RowBox[{"fra", 
        RowBox[{"(", 
         RowBox[{"xmax", "-", "xmin"}], ")"}]}]}], ";", 
      RowBox[{"sizy", "=", 
       RowBox[{"fra", 
        RowBox[{"(", 
         RowBox[{"ymax", "-", "ymin"}], ")"}]}]}], ";", 
      RowBox[{"coords", "=", 
       RowBox[{"ycp", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "2", ",", "3", ",", "All", ",", "2"}], "]"}], 
        "]"}]}], ";", 
      RowBox[{"pos1", "=", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ar", "=", 
             RowBox[{"Delete", "[", 
              RowBox[{
               RowBox[{"Abs", "[", 
                RowBox[{
                 RowBox[{
                  FractionBox[
                   RowBox[{
                    RowBox[{"coords", "[", 
                    RowBox[{"[", "#", "]"}], "]"}], "-", 
                    RowBox[{"coords", "[", 
                    RowBox[{"[", "nn", "]"}], "]"}]}], 
                   RowBox[{"{", 
                    RowBox[{"sizx", ",", "sizy"}], "}"}]], "&"}], "/@", 
                 RowBox[{"Range", "[", 
                  RowBox[{"Length", "[", "coords", "]"}], "]"}]}], "]"}], ",",
                "nn"}], "]"}]}], ";", 
            RowBox[{"obst", "=", "False"}], ";", 
            RowBox[{"For", "[", 
             RowBox[{
              RowBox[{"kk", "=", "1"}], ",", 
              RowBox[{"kk", "<", "nn"}], ",", 
              RowBox[{"kk", "++"}], ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"ar", "[", 
                    RowBox[{"[", 
                    RowBox[{"kk", ",", "1"}], "]"}], "]"}], "<", "1"}], ")"}],
                  "&&", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"ar", "[", 
                    RowBox[{"[", 
                    RowBox[{"kk", ",", "2"}], "]"}], "]"}], "<", "1"}], 
                  ")"}]}], ",", 
                RowBox[{"obst", "=", "True"}]}], "]"}]}], "]"}], ";", 
            "obst"}], ",", 
           RowBox[{"{", 
            RowBox[{"nn", ",", 
             RowBox[{
              RowBox[{"Length", "[", "coords", "]"}], "-", "1"}]}], "}"}]}], 
          "]"}], ",", "True"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"pos2", "=", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"axx", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"1.3", 
                FractionBox[
                 RowBox[{
                  RowBox[{"coords", "[", 
                   RowBox[{"[", "#", "]"}], "]"}], "-", 
                  RowBox[{"{", 
                   RowBox[{"xmin", ",", "ymin"}], "}"}]}], 
                 RowBox[{"{", 
                  RowBox[{"sizx", ",", "sizy"}], "}"}]]}], "&"}], "/@", 
              RowBox[{"Range", "[", 
               RowBox[{"Length", "[", "coords", "]"}], "]"}]}]}], ";", 
            RowBox[{"obst", "=", "False"}], ";", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"axx", "[", 
                  RowBox[{"[", 
                   RowBox[{"nn", ",", "1"}], "]"}], "]"}], "<", "1"}], ")"}], 
               "||", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"axx", "[", 
                  RowBox[{"[", 
                   RowBox[{"nn", ",", "2"}], "]"}], "]"}], "<", "1"}], 
                ")"}]}], ",", 
              RowBox[{"obst", "=", "True"}]}], "]"}], ";", "obst"}], ",", 
           RowBox[{"{", 
            RowBox[{"nn", ",", 
             RowBox[{"Length", "[", "coords", "]"}]}], "}"}]}], "]"}], ",", 
         "True"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"pos3", "=", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"axx", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"1.3", 
                FractionBox[
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"xmax", ",", "ymax"}], "}"}], "-", 
                  RowBox[{"coords", "[", 
                   RowBox[{"[", "#", "]"}], "]"}]}], 
                 RowBox[{"{", 
                  RowBox[{"sizx", ",", "sizy"}], "}"}]]}], "&"}], "/@", 
              RowBox[{"Range", "[", 
               RowBox[{"Length", "[", "coords", "]"}], "]"}]}]}], ";", 
            RowBox[{"obst", "=", "False"}], ";", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"axx", "[", 
                  RowBox[{"[", 
                   RowBox[{"nn", ",", "1"}], "]"}], "]"}], "<", "1"}], ")"}], 
               "||", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"axx", "[", 
                  RowBox[{"[", 
                   RowBox[{"nn", ",", "2"}], "]"}], "]"}], "<", "1"}], 
                ")"}]}], ",", 
              RowBox[{"obst", "=", "True"}]}], "]"}], ";", "obst"}], ",", 
           RowBox[{"{", 
            RowBox[{"nn", ",", 
             RowBox[{"Length", "[", "coords", "]"}]}], "}"}]}], "]"}], ",", 
         "True"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"posit", "=", 
       RowBox[{"Union", "[", 
        RowBox[{"pos1", ",", "pos2", ",", "pos3"}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"ycp", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "2", ",", "3"}], "]"}], "]"}], "=", 
       RowBox[{"Delete", "[", 
        RowBox[{
         RowBox[{"ycp", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "2", ",", "3"}], "]"}], "]"}], ",", "posit"}], 
        "]"}]}], ";", "\[IndentingNewLine]", "ycp"}], ")"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"imp", "=", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{
       "Import", "[", 
        "\"\<E:\\\\mathematica\\\\analysis\\\\poliresa50th189fn-1booch_cr.dat\
\>\"", "]"}], ",", "7"}], "]"}]}], ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{
     "Import", "[", 
      "\"\<E:\\\\mathematica\\\\analysis\\\\poliresa90th223fn-1booch_cr.dat\>\
\"", "]"}], ",", "7"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mmord", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"len", "=", 
   RowBox[{"Length", "[", "imp", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"len", "\[Equal]", 
     SuperscriptBox[
      RowBox[{"Round", "[", 
       RowBox[{"par", "=", 
        RowBox[{"Sqrt", "[", "len", "]"}]}], "]"}], "2"]}], ",", 
    RowBox[{"impx", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{"imp", ",", "par"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}]}], 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"hmin", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", "11"}], "]"}], "]"}], "]"}]}], 
   ";", 
   RowBox[{"hmax", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", 
        RowBox[{"-", "1"}], ",", "11"}], "]"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"hmin", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"impx", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}], "]"}]}], 
    ";", 
    RowBox[{"hmax", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"impx", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", 
         RowBox[{"-", "1"}], ",", "8"}], "]"}], "]"}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rhomin", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", "12"}], "]"}], "]"}], "]"}]}], 
   ";", 
   RowBox[{"rhomax", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}], ",", "1", ",", "12"}], "]"}], "]"}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"thmin", "=", 
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", 
    RowBox[{"thmax", "=", 
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabb", "=", 
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           RowBox[{"tofit", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{
               RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
              "2"}], "]"}], "]"}], "-", 
           RowBox[{"impx", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], "]"}]}], 
          RowBox[{"dFnu", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
           "]"}]], ")"}], "2"], "]"}], 
      RowBox[{"7", "-", "3"}]], "&"}], "/@", 
    RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnu3", "=", 
    RowBox[{"ListInterpolation", "[", 
     RowBox[{"tabb", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"rhomin", ",", "rhomax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"hmin", ",", "hmax"}], "}"}]}], "}"}], ",", 
      RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"for", " ", "heat"}], ";", " ", 
    RowBox[{"for", " ", "rhonor", " ", "in", " ", 
     RowBox[{"C", "++"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabb", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      FractionBox["1", 
       RowBox[{"12", "-", "3"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                "2"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], 
              "]"}]}], 
            RowBox[{"dFnu", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
             "]"}]], ")"}], "2"], "]"}], "+", 
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "4"}], ";;", 
                 RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "6"}], 
               "]"}], "]"}]}], "dCP"], ")"}], "2"], "]"}], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"Log", "[", 
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
            RowBox[{"Log", "[", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"-", "7"}], ",", "#", ",", "All", ",", "4"}], "]"}], 
              "]"}], "]"}]}], 
           RowBox[{"dlogLP", "[", 
            RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"Log", "[", 
              RowBox[{"tofit", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}], 
             "-", 
             RowBox[{"Log", "[", 
              RowBox[{"impx", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "4"}], ";;", 
                  RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "4"}], 
                "]"}], "]"}], "]"}]}], 
            RowBox[{"dlogLP", "[", 
             RowBox[{"[", 
              RowBox[{"2", ";;", "3"}], "]"}], "]"}]], ")"}], "2"], "]"}]}], 
       ")"}]}], "&"}], "/@", 
    RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnuCPLP3", "=", 
    RowBox[{"ListInterpolation", "[", 
     RowBox[{"tabb", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"rhomin", ",", "rhomax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"hmin", ",", "hmax"}], "}"}]}], "}"}], ",", 
      RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lcp09", "=", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"lipFnu3", "[", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{
         SuperscriptBox["10", 
          RowBox[{"-", "9"}]], "rhonor"}], "]"}], ",", 
       RowBox[{"Log", "[", "heat", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"heat", ",", 
       RowBox[{"Exp", "[", "hmin", "]"}], ",", 
       RowBox[{"Exp", "[", "hmax", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"rhonor", ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomin", "]"}]}], ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomax", "]"}]}]}], "}"}], ",", 
     RowBox[{"Contours", "\[Rule]", "40"}], ",", 
     RowBox[{"ContourLabels", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Framed", "[", "#3", "]"}], ",", 
            RowBox[{"myf", "-", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], ")"}]}],
      ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Ratio Tp/Te\>\"", ",", 
        "\"\<Accretion rate [\!\(\*SuperscriptBox[\(10\), \(-9\)]\)Msun/year]\
\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"(*", 
        RowBox[{"\"\<Times\>\"", ","}], "*)"}], "myf", "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
         RowBox[{"coe", 
          RowBox[{"(", 
           RowBox[{"#", "-", "mc"}], ")"}]}], "]"}], "&"}], ")"}]}], ",", 
     RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.5"}], ",", 
     RowBox[{"PlotRegion", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xcp09", "=", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"lipFnuCPLP3", "[", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{
         SuperscriptBox["10", 
          RowBox[{"-", "9"}]], "rhonor"}], "]"}], ",", 
       RowBox[{"Log", "[", "heat", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"heat", ",", 
       RowBox[{"Exp", "[", "hmin", "]"}], ",", 
       RowBox[{"Exp", "[", "hmax", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"rhonor", ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomin", "]"}]}], ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomax", "]"}]}]}], "}"}], ",", 
     RowBox[{"Contours", "\[Rule]", "40"}], ",", 
     RowBox[{"ContourLabels", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Framed", "[", "#3", "]"}], ",", 
            RowBox[{"myf", "-", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], ")"}]}],
      ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Ratio Tp/Te\>\"", ",", 
        "\"\<Accretion rate in \!\(\*SuperscriptBox[\(10\), \
\(-9\)]\)Msun/year\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"(*", 
        RowBox[{"\"\<Times\>\"", ","}], "*)"}], "myf", "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
         RowBox[{"coe", 
          RowBox[{"(", 
           RowBox[{"#", "-", "mc"}], ")"}]}], "]"}], "&"}], ")"}]}], ",", 
     RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.5"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lcp09", "=", 
   RowBox[{"func", "[", 
    RowBox[{"lcp09", ",", "del"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xcp09", "=", 
    RowBox[{"func", "[", 
     RowBox[{"xcp09", ",", "del"}], "]"}]}], ";", 
   RowBox[{"xmin09", "=", "xmin"}], ";", 
   RowBox[{"xmax09", "=", "xmax"}], ";", 
   RowBox[{"ymin09", "=", "ymin"}], ";", 
   RowBox[{"ymax09", "=", "ymax"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"imp", "=", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{
       "Import", "[", 
        "\"\<E:\\\\mathematica\\\\analysis\\\\poliresa50th221fn-1nobch_cr.dat\
\>\"", "]"}], ",", "7"}], "]"}]}], ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{
     "Import", "[", 
      "\"\<E:\\\\mathematica\\\\analysis\\\\poliresa90th218fn-1nobch_cr.dat\>\
\"", "]"}], ",", "7"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mmord", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"len", "=", 
   RowBox[{"Length", "[", "imp", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"len", "\[Equal]", 
     SuperscriptBox[
      RowBox[{"Round", "[", 
       RowBox[{"par", "=", 
        RowBox[{"Sqrt", "[", "len", "]"}]}], "]"}], "2"]}], ",", 
    RowBox[{"impx", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{"imp", ",", "par"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}]}], 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"hmin", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", "11"}], "]"}], "]"}], "]"}]}], 
   ";", 
   RowBox[{"hmax", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", 
        RowBox[{"-", "1"}], ",", "11"}], "]"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"hmin", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"impx", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}], "]"}]}], 
    ";", 
    RowBox[{"hmax", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"impx", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", 
         RowBox[{"-", "1"}], ",", "8"}], "]"}], "]"}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rhomin", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", "12"}], "]"}], "]"}], "]"}]}], 
   ";", 
   RowBox[{"rhomax", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}], ",", "1", ",", "12"}], "]"}], "]"}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"thmin", "=", 
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", 
    RowBox[{"thmax", "=", 
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabb", "=", 
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           RowBox[{"tofit", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{
               RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
              "2"}], "]"}], "]"}], "-", 
           RowBox[{"impx", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], "]"}]}], 
          RowBox[{"dFnu", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
           "]"}]], ")"}], "2"], "]"}], 
      RowBox[{"7", "-", "3"}]], "&"}], "/@", 
    RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnu3", "=", 
    RowBox[{"ListInterpolation", "[", 
     RowBox[{"tabb", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"rhomin", ",", "rhomax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"hmin", ",", "hmax"}], "}"}]}], "}"}], ",", 
      RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"for", " ", "heat"}], ";", " ", 
    RowBox[{"for", " ", "rhonor", " ", "in", " ", 
     RowBox[{"C", "++"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabb", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      FractionBox["1", 
       RowBox[{"12", "-", "3"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                "2"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], 
              "]"}]}], 
            RowBox[{"dFnu", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
             "]"}]], ")"}], "2"], "]"}], "+", 
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "4"}], ";;", 
                 RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "6"}], 
               "]"}], "]"}]}], "dCP"], ")"}], "2"], "]"}], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"Log", "[", 
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
            RowBox[{"Log", "[", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"-", "7"}], ",", "#", ",", "All", ",", "4"}], "]"}], 
              "]"}], "]"}]}], 
           RowBox[{"dlogLP", "[", 
            RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"Log", "[", 
              RowBox[{"tofit", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}], 
             "-", 
             RowBox[{"Log", "[", 
              RowBox[{"impx", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "4"}], ";;", 
                  RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "4"}], 
                "]"}], "]"}], "]"}]}], 
            RowBox[{"dlogLP", "[", 
             RowBox[{"[", 
              RowBox[{"2", ";;", "3"}], "]"}], "]"}]], ")"}], "2"], "]"}]}], 
       ")"}]}], "&"}], "/@", 
    RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lipFnuCPLP3", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{"tabb", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"rhomin", ",", "rhomax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"hmin", ",", "hmax"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lcp05", "=", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"lipFnu3", "[", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{
         SuperscriptBox["10", 
          RowBox[{"-", "9"}]], "rhonor"}], "]"}], ",", 
       RowBox[{"Log", "[", "heat", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"heat", ",", 
       RowBox[{"Exp", "[", "hmin", "]"}], ",", 
       RowBox[{"Exp", "[", "hmax", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"rhonor", ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomin", "]"}]}], ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomax", "]"}]}]}], "}"}], ",", 
     RowBox[{"Contours", "\[Rule]", "40"}], ",", 
     RowBox[{"ContourLabels", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Framed", "[", "#3", "]"}], ",", 
            RowBox[{"myf", "-", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], ")"}]}],
      ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Ratio Tp/Te\>\"", ",", 
        "\"\<Accretion rate in \!\(\*SuperscriptBox[\(10\), \
\(-9\)]\)Msun/year\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", "myf", "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
         RowBox[{"coe", 
          RowBox[{"(", 
           RowBox[{"#", "-", "mc"}], ")"}]}], "]"}], "&"}], ")"}]}], ",", 
     RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.5"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xcp05", "=", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"lipFnuCPLP3", "[", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{
         SuperscriptBox["10", 
          RowBox[{"-", "9"}]], "rhonor"}], "]"}], ",", 
       RowBox[{"Log", "[", "heat", "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"heat", ",", 
       RowBox[{"Exp", "[", "hmin", "]"}], ",", 
       RowBox[{"Exp", "[", "hmax", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"rhonor", ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomin", "]"}]}], ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomax", "]"}]}]}], "}"}], ",", 
     RowBox[{"Contours", "\[Rule]", "40"}], ",", 
     RowBox[{"ContourLabels", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Framed", "[", "#3", "]"}], ",", 
            RowBox[{"myf", "-", "2"}], ",", "Bold"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], ")"}]}],
      ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Ratio Tp/Te\>\"", ",", 
        "\"\<Accretion rate in \!\(\*SuperscriptBox[\(10\), \
\(-9\)]\)Msun/year\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", "myf", "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
         RowBox[{"coe", 
          RowBox[{"(", 
           RowBox[{"#", "-", "mc"}], ")"}]}], "]"}], "&"}], ")"}]}], ",", 
     RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.5"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lcp05", "=", 
   RowBox[{"func", "[", 
    RowBox[{"lcp05", ",", "del"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xcp05", "=", 
    RowBox[{"func", "[", 
     RowBox[{"xcp05", ",", "del"}], "]"}]}], ";", 
   RowBox[{"xmin05", "=", "xmin"}], ";", 
   RowBox[{"xmax05", "=", "xmax"}], ";", 
   RowBox[{"ymin05", "=", "ymin"}], ";", 
   RowBox[{"ymax05", "=", "ymax"}], ";"}], "\[IndentingNewLine]", 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fig09", "=", 
   RowBox[{"Figure", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ScaledLabel", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.54", ",", "1"}], "}"}], ",", 
         "\"\<\!\(\*SubscriptBox[\(a\), \(*\)]\)=0.9(RMS \
b):\!\(\*SuperscriptBox[SubscriptBox[\(\[Chi]\), \(F\)], \
\(2\)]\)/\!\(\*SubscriptBox[\(dof\), \(F\)]\)(a) and total \
\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\)/dof(b)\>\"", ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
         RowBox[{"Offset", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
       RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}], ",", 
         RowBox[{"XPlotRanges", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"xmin09", ",", "xmax09"}], "}"}]}], ",", 
         RowBox[{"YPlotRanges", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"ymin09", ",", "ymax09"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"XFrameLabels", "\[Rule]", 
          RowBox[{"(*", 
           RowBox[{"textit", "["}], "*)"}], "\"\<Tp/Te at 6M\>\""}], ",", 
         RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
         RowBox[{
         "YFrameLabels", "\[Rule]", 
          "\"\<\!\(\*OverscriptBox[\(M\), \(.\)]\) [\!\(\*SuperscriptBox[\(10\
\), \(-9\)]\)\!\(\*SubscriptBox[\(M\), \(\[CircleDot]\)]\) \
\!\(\*SuperscriptBox[\(yr\), \(-1\)]\)]\>\""}], ",", 
         RowBox[{"BufferL", "\[Rule]", "7"}], ",", "\[IndentingNewLine]", 
         RowBox[{"TickFontSize", "\[Rule]", "myf"}], ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}], ",", "\[IndentingNewLine]", 
         RowBox[{"XPanelSizes", "\[Rule]", 
          RowBox[{"{", "1", "}"}]}], ",", 
         RowBox[{"YPanelSizes", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}]}], ",", 
         RowBox[{"YGapSizes", "\[Rule]", 
          RowBox[{"{", "0.1", "}"}]}], ",", 
         RowBox[{"Background", "\[Rule]", "White"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
         RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
         RowBox[{"PanelLetterCorner", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
         RowBox[{"TickNudge", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "5"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "5"}], ",", "0"}], "}"}], ",", "0", ",", "0"}], 
           "}"}]}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
       RowBox[{"FigurePanel", "[", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"RawGraphics", "[", 
        RowBox[{"lcp09", ",", 
         RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
       RowBox[{"FigurePanel", "[", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], "]"}], ",", 
       RowBox[{"RawGraphics", "[", 
        RowBox[{"xcp09", ",", 
         RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.26"}], ",", "1.10"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.14"}], ",", "1.10"}], "}"}]}], "}"}]}], 
     "\[IndentingNewLine]", ",", 
     RowBox[{"ImageSize", "\[Rule]", 
      RowBox[{"12", "*", "2", "*", 
       RowBox[{"{", 
        RowBox[{"11", ",", 
         RowBox[{
          FractionBox["12", "10"], "11"}]}], "}"}]}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fig05", "=", 
   RowBox[{"Figure", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ScaledLabel", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.54", ",", "1"}], "}"}], ",", 
         "\"\<\!\(\*SubscriptBox[\(a\), \(*\)]\)=0.9(lin \
b):\!\(\*SuperscriptBox[SubscriptBox[\(\[Chi]\), \(F\)], \
\(2\)]\)/\!\(\*SubscriptBox[\(dof\), \(F\)]\)(c) and total \
\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\)/dof(d)\>\"", ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
         RowBox[{"Offset", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
       RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}], ",", 
         RowBox[{"XPlotRanges", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"xmin", ",", "xmax"}], "}"}]}], ",", 
         RowBox[{"YPlotRanges", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"ymin", ",", "ymax"}], "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"XFrameLabels", "\[Rule]", 
          RowBox[{"(*", 
           RowBox[{"textit", "["}], "*)"}], "\"\<Tp/Te at 6M\>\""}], ",", 
         RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
         RowBox[{
         "YFrameLabels", "\[Rule]", 
          "\"\<\!\(\*OverscriptBox[\(M\), \(.\)]\) [\!\(\*SuperscriptBox[\(10\
\), \(-9\)]\)\!\(\*SubscriptBox[\(M\), \(\[CircleDot]\)]\) \
\!\(\*SuperscriptBox[\(yr\), \(-1\)]\)]\>\""}], ",", 
         RowBox[{"BufferL", "\[Rule]", "6"}], ",", "\[IndentingNewLine]", 
         RowBox[{"TickFontSize", "\[Rule]", "myf"}], ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}], ",", "\[IndentingNewLine]", 
         RowBox[{"XPanelSizes", "\[Rule]", 
          RowBox[{"{", "1", "}"}]}], ",", 
         RowBox[{"YPanelSizes", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}]}], ",", 
         RowBox[{"YGapSizes", "\[Rule]", 
          RowBox[{"{", "0.1", "}"}]}], ",", 
         RowBox[{"Background", "\[Rule]", "White"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
         RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
         RowBox[{"PanelLetterCorner", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
         RowBox[{"TickNudge", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "5"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "5"}], ",", "0"}], "}"}], ",", "0", ",", "0"}], 
           "}"}]}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
       RowBox[{"FigurePanel", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"PanelLetter", "\[Rule]", "\"\<(c)\>\""}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"RawGraphics", "[", 
        RowBox[{"lcp05", ",", 
         RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
       RowBox[{"FigurePanel", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}], ",", 
         RowBox[{"PanelLetter", "\[Rule]", "\"\<(d)\>\""}]}], "]"}], ",", 
       RowBox[{"RawGraphics", "[", 
        RowBox[{"xcp05", ",", 
         RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.26"}], ",", "1.10"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.14"}], ",", "1.10"}], "}"}]}], "}"}]}], 
     "\[IndentingNewLine]", ",", 
     RowBox[{"ImageSize", "\[Rule]", 
      RowBox[{"12", "*", "2", "*", 
       RowBox[{"{", 
        RowBox[{"11", ",", 
         RowBox[{
          FractionBox["12", "10"], "11"}]}], "}"}]}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
 RowBox[{"chisq", "=", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{"fig09", ",", "fig05"}], "}"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dout", "=", 
   "\"\<C:\\\\study\\\\accretion\\\\! 2009 fall cfa\\\\GR Polarized \
modeling\\\\\>\""}], ";", 
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"dout", "<>", "\"\<fitFFLPCP.eps\>\""}], ",", "chisq", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "500"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.4828815248972*^9, 3.4828815249284*^9}, {
   3.4828820445176*^9, 3.4828820446424*^9}, {3.4828822936652*^9, 
   3.4828823011532*^9}, {3.4843074276977997`*^9, 3.4843074281502*^9}, 
   3.4843075464762*^9, {3.4843079516862*^9, 3.4843079517642*^9}, {
   3.4843080370962*^9, 3.4843080371898003`*^9}, {3.4843084549578*^9, 
   3.4843084557222*^9}, {3.4843087334178*^9, 3.4843087344474*^9}, {
   3.4843089825654*^9, 3.4843089836418*^9}, {3.4843093097441998`*^9, 
   3.484309310883*^9}, {3.4843093847178*^9, 3.484309384983*^9}, {
   3.4843096946429996`*^9, 3.4843096951734*^9}, {3.4843934028486*^9, 
   3.4843934593206*^9}, {3.4843948275916*^9, 3.4843951134772*^9}, {
   3.4843952257816*^9, 3.4843952289172*^9}, {3.4843953598168*^9, 
   3.484395370612*^9}, {3.4843955238664*^9, 3.4843955375944*^9}, {
   3.4843959418684*^9, 3.4843959419308*^9}, {3.4843960801272*^9, 
   3.4843960802052*^9}, {3.4843966115880003`*^9, 3.4843966516488*^9}, {
   3.4843970255652*^9, 3.48439702569*^9}, {3.4843973343048*^9, 
   3.4843973343672*^9}, {3.4844158645804*^9, 3.4844158648143997`*^9}, {
   3.4844902285268*^9, 3.4844902288543997`*^9}, {3.4844937845008*^9, 
   3.4844938187896*^9}, {3.4844939961127996`*^9, 3.4844940010892*^9}, {
   3.4845153205952*^9, 3.4845153241988*^9}, {3.4845215022214003`*^9, 
   3.4845215127046003`*^9}, {3.4856083978822365`*^9, 3.485608412546237*^9}, {
   3.485608763265437*^9, 3.4856087649034367`*^9}, {3.485610046335437*^9, 
   3.485610049720637*^9}, {3.4857050917882156`*^9, 3.4857050930362153`*^9}, {
   3.4857106035334153`*^9, 3.485710609445815*^9}, {3.4857952778846154`*^9, 
   3.4857952779470153`*^9}, {3.4857958875482154`*^9, 
   3.4857958980782156`*^9}, {3.4858613839618154`*^9, 
   3.4858613959270153`*^9}, {3.4858628533570156`*^9, 3.485862857038615*^9}, {
   3.485899458183*^9, 3.48589946025*^9}, {3.486146409041*^9, 
   3.4861464549560003`*^9}, {3.4861464938570004`*^9, 3.4861465114379997`*^9}, 
   3.4861465588719997`*^9, {3.4861684785690002`*^9, 3.486168507309*^9}, {
   3.4863963392174606`*^9, 3.486396352796461*^9}, {3.486397041595461*^9, 
   3.4863970688114605`*^9}, {3.4863978499554605`*^9, 3.486397850022461*^9}, {
   3.486397892576461*^9, 3.486397898513461*^9}, {3.4863979394674606`*^9, 
   3.486397966081461*^9}, {3.4863980159464607`*^9, 3.4863980205284605`*^9}, {
   3.486398059582461*^9, 3.486398121202461*^9}, {3.4863982121434608`*^9, 
   3.486398283299461*^9}, {3.486400056528*^9, 3.48640005927*^9}, {
   3.486401708198*^9, 3.486401777843*^9}, {3.486402205325*^9, 
   3.4864022090299997`*^9}, {3.486402601217*^9, 3.4864026508129997`*^9}, {
   3.486402697969*^9, 3.486402698479*^9}, {3.486402733447*^9, 
   3.486402734005*^9}, {3.4864336908344*^9, 3.4864336954304*^9}, {
   3.4864342429863997`*^9, 3.4864342457184*^9}, {3.4864342770724*^9, 
   3.4864342779133997`*^9}, {3.4885923033438*^9, 3.4885924018157997`*^9}, {
   3.4885927656177998`*^9, 3.4885927663448*^9}, {3.4885930602108*^9, 
   3.4885930621498003`*^9}, {3.4885931119558*^9, 3.4885932214598*^9}, {
   3.4885932698198*^9, 3.4885932711368*^9}, {3.4885956074388*^9, 
   3.4885956237118*^9}, {3.489154236011533*^9, 3.4891542516115327`*^9}, {
   3.5009172988780003`*^9, 3.500917310245*^9}, {3.5009177876359997`*^9, 
   3.500917805493*^9}, {3.500917874072*^9, 3.500917877071*^9}, {
   3.500940665328*^9, 3.500940675494*^9}, {3.500940718816*^9, 
   3.500940722226*^9}, {3.500940762218*^9, 3.500940771863*^9}, {
   3.5009949324379997`*^9, 3.500994932606*^9}, {3.5009950663929996`*^9, 
   3.500995073424*^9}, {3.5009951375220003`*^9, 3.500995172882*^9}, {
   3.501008974487*^9, 3.501008991781*^9}, {3.5015185155480003`*^9, 
   3.50151851696*^9}, {3.501518638955*^9, 3.501518639342*^9}, {
   3.5015188139110003`*^9, 3.5015188139890003`*^9}, {3.501518894483*^9, 
   3.50151889748*^9}, 3.501519715104*^9, {3.501527325274*^9, 
   3.5015273448459997`*^9}, {3.502467599117*^9, 3.502467600446*^9}, {
   3.502467645724*^9, 3.502467664203*^9}, {3.502467728929*^9, 
   3.5024677698719997`*^9}, {3.502467846352*^9, 3.5024678741099997`*^9}, {
   3.5024680536800003`*^9, 3.502468072288*^9}, 3.50246945462*^9, {
   3.502469502413*^9, 3.502469502527*^9}, 3.502470212026*^9, {
   3.502562379415*^9, 3.5025623822542*^9}, {3.5025624285861998`*^9, 
   3.5025624287422*^9}, {3.5025628386322002`*^9, 3.5025628415025997`*^9}, {
   3.5025628776478*^9, 3.5025628796289997`*^9}, {3.5025641546210003`*^9, 
   3.5025642003914003`*^9}, {3.5025642652718*^9, 3.5025642735086*^9}, {
   3.5026261898129997`*^9, 3.502626189934*^9}, {3.5026264031870003`*^9, 
   3.5026264221470003`*^9}, 3.502649239692*^9, {3.50428741575*^9, 
   3.5042874340810003`*^9}, {3.5043636178050003`*^9, 3.50436362616*^9}, {
   3.504366871751*^9, 3.504366872742*^9}, 3.504366907657*^9, {
   3.504366940061*^9, 3.504367059454*^9}, {3.504367150685*^9, 
   3.50436715148*^9}, {3.508262988776*^9, 3.508263018117*^9}, {
   3.508263053115*^9, 3.508263076023*^9}, {3.5082631324440002`*^9, 
   3.508263166592*^9}, {3.509376718727*^9, 3.509376718797*^9}, {
   3.509376817001*^9, 3.509376818098*^9}, {3.509377097894*^9, 
   3.50937717609*^9}, 3.5094077740109997`*^9, {3.50940780433*^9, 
   3.5094078333859997`*^9}, {3.5094509477019997`*^9, 3.509450948711*^9}, {
   3.5101488699656*^9, 3.5101488780095997`*^9}, {3.5101489519726*^9, 
   3.5101489586646*^9}, {3.5102332526026*^9, 3.5102332526906*^9}, {
   3.5102332872226*^9, 3.5102332873346*^9}, {3.5291826309053783`*^9, 
   3.5291826328504896`*^9}, {3.5292347165747705`*^9, 3.529234719375931*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"imp", "=", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{
       "Import", "[", 
        "\"\<E:\\\\mathematica\\\\analysis\\\\poliresa50th189fn-1booch_th.dat\
\>\"", "]"}], ",", "7"}], "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"imp", "=", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{
       "Import", "[", 
        "\"\<E:\\\\mathematica\\\\analysis\\\\poliresa90th223fn-1booch_th.dat\
\>\"", "]"}], ",", "7"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"del", "=", "0.15"}], ";", 
    RowBox[{"len", "=", 
     RowBox[{"Length", "[", "imp", "]"}]}], ";"}], 
   RowBox[{"(*", 
    RowBox[{"min", " ", "\[Chi]sq"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"len", "\[Equal]", 
       SuperscriptBox[
        RowBox[{"Round", "[", 
         RowBox[{"par", "=", 
          RowBox[{"Sqrt", "[", "len", "]"}]}], "]"}], "2"]}], ",", 
      RowBox[{"impx", "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"imp", ",", "par"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}]}], 
     "]"}], ";", 
    RowBox[{"mmord", "=", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"hmin", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"impx", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", "1", ",", "11"}], "]"}], "]"}], "]"}]}], 
    ";", 
    RowBox[{"hmax", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"impx", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", 
         RowBox[{"-", "1"}], ",", "11"}], "]"}], "]"}], "]"}]}], ";", 
    RowBox[{"thmin", "=", 
     RowBox[{
      FractionBox["180", "\[Pi]"], 
      RowBox[{"(", 
       RowBox[{"\[Pi]", "-", 
        RowBox[{"impx", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "1", ",", "13"}], "]"}], "]"}]}], 
       ")"}]}]}], ";", 
    RowBox[{"thmax", "=", 
     RowBox[{
      FractionBox["180", "\[Pi]"], 
      RowBox[{"(", 
       RowBox[{"\[Pi]", "-", 
        RowBox[{"impx", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}], ",", "1", ",", "13"}], "]"}], "]"}]}], 
       ")"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tabb", "=", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                "2"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], 
              "]"}]}], 
            RowBox[{"dFnu", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
             "]"}]], ")"}], "2"], "]"}], 
        RowBox[{"7", "-", "3"}]], "&"}], "/@", 
      RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lipFnu3", "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{"tabb", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"hmin", ",", "hmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], ";"}], 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"for", " ", "heat"}], ";", " ", 
     RowBox[{"for", " ", "th", " ", "in", " ", 
      RowBox[{"C", "++"}]}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tabb", "=", 
     RowBox[{
      RowBox[{
       RowBox[{
        FractionBox["1", 
         RowBox[{"12", "-", "3"}]], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Total", "[", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                  "2"}], "]"}], "]"}], "-", 
               RowBox[{"impx", "[", 
                RowBox[{"[", 
                 RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], 
                "]"}]}], 
              RowBox[{"dFnu", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
               "]"}]], ")"}], "2"], "]"}], "+", 
          RowBox[{"Total", "[", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
               RowBox[{"impx", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], ";;", 
                   RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "6"}], 
                 "]"}], "]"}]}], "dCP"], ")"}], "2"], "]"}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox[
             RowBox[{
              RowBox[{"Log", "[", 
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
              RowBox[{"Log", "[", 
               RowBox[{"impx", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"-", "7"}], ",", "#", ",", "All", ",", "4"}], "]"}],
                 "]"}], "]"}]}], 
             RowBox[{"dlogLP", "[", 
              RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
          RowBox[{"Total", "[", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{"tofit", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}], 
               "-", 
               RowBox[{"Log", "[", 
                RowBox[{"impx", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], ";;", 
                    RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "4"}], 
                  "]"}], "]"}], "]"}]}], 
              RowBox[{"dlogLP", "[", 
               RowBox[{"[", 
                RowBox[{"2", ";;", "3"}], "]"}], "]"}]], ")"}], "2"], "]"}]}],
          ")"}]}], "&"}], "/@", 
      RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lipFnuCPLP3", "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{"tabb", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"hmin", ",", "hmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lcp09", "=", 
     RowBox[{"ContourPlot", "[", 
      RowBox[{
       RowBox[{"lipFnu3", "[", 
        RowBox[{"th", ",", 
         RowBox[{"Log", "[", "heat", "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"th", ",", "thmin", ",", "thmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", 
         RowBox[{"Exp", "[", "hmin", "]"}], ",", 
         RowBox[{"Exp", "[", "hmax", "]"}]}], "}"}], ",", 
       RowBox[{"Contours", "\[Rule]", "40"}], ",", 
       RowBox[{"ContourLabels", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"Framed", "[", 
               RowBox[{"0.01", 
                RowBox[{"Round", "[", 
                 RowBox[{"100", "#3"}], "]"}]}], "]"}], ",", 
              RowBox[{"myf", "-", "2"}], ",", "Bold"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"#1", ",", "#2"}], "}"}], ",", 
            RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], 
         ")"}]}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<Inclination angle \[Theta]\>\"", ",", "\"\<Ratio Tp/Te\>\""}], 
         "}"}]}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", "myf", "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
           RowBox[{"coe", 
            RowBox[{"(", 
             RowBox[{"#", "-", "mc"}], ")"}]}], "]"}], "&"}], ")"}]}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", "0.5"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xcp09", "=", 
     RowBox[{"ContourPlot", "[", 
      RowBox[{
       RowBox[{"lipFnuCPLP3", "[", 
        RowBox[{"th", ",", 
         RowBox[{"Log", "[", "heat", "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"th", ",", "thmin", ",", "thmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", 
         RowBox[{"Exp", "[", "hmin", "]"}], ",", 
         RowBox[{"Exp", "[", "hmax", "]"}]}], "}"}], ",", 
       RowBox[{"Contours", "\[Rule]", "40"}], ",", 
       RowBox[{"ContourLabels", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"Framed", "[", 
               RowBox[{"0.01", 
                RowBox[{"Round", "[", 
                 RowBox[{"100", "#3"}], "]"}]}], "]"}], ",", 
              RowBox[{"myf", "-", "2"}], ",", "Bold"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"#1", ",", "#2"}], "}"}], ",", 
            RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], 
         ")"}]}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<Inclination angle \[Theta], deg\>\"", ",", 
          "\"\<Ratio Tp/Te\>\""}], "}"}]}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", "myf", "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
           RowBox[{"coe", 
            RowBox[{"(", 
             RowBox[{"#", "-", "mc"}], ")"}]}], "]"}], "&"}], ")"}]}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", "0.5"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lcp09", "=", 
     RowBox[{"func", "[", 
      RowBox[{"lcp09", ",", "del"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xcp09", "=", 
     RowBox[{"func", "[", 
      RowBox[{"xcp09", ",", "del"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xmin09", "=", "xmin"}], ";", 
    RowBox[{"xmax09", "=", "xmax"}], ";", 
    RowBox[{"ymin09", "=", "ymin"}], ";", 
    RowBox[{"ymax09", "=", "ymax"}], ";"}], "\[IndentingNewLine]", "\n", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"imp", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{
        RowBox[{
        "Import", "[", 
         "\"\<E:\\\\mathematica\\\\analysis\\\\poliresa50th221fn-1nobch_th.\
dat\>\"", "]"}], ",", "7"}], "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"imp", "=", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{
       "Import", "[", 
        "\"\<E:\\\\mathematica\\\\analysis\\\\poliresa90th218fn-1nobch_th.dat\
\>\"", "]"}], ",", "7"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"len", "=", 
     RowBox[{"Length", "[", "imp", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"len", "\[Equal]", 
       SuperscriptBox[
        RowBox[{"Round", "[", 
         RowBox[{"par", "=", 
          RowBox[{"Sqrt", "[", "len", "]"}]}], "]"}], "2"]}], ",", 
      RowBox[{"impx", "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"imp", ",", "par"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}]}], 
     "]"}], ";", 
    RowBox[{"mmord", "=", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"hmin", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"impx", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", "1", ",", "11"}], "]"}], "]"}], "]"}]}], 
    ";", 
    RowBox[{"hmax", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"impx", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", 
         RowBox[{"-", "1"}], ",", "11"}], "]"}], "]"}], "]"}]}], ";", 
    RowBox[{"thmin", "=", 
     RowBox[{
      FractionBox["180", "\[Pi]"], 
      RowBox[{"(", 
       RowBox[{"\[Pi]", "-", 
        RowBox[{"impx", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "1", ",", "13"}], "]"}], "]"}]}], 
       ")"}]}]}], ";", 
    RowBox[{"thmax", "=", 
     RowBox[{
      FractionBox["180", "\[Pi]"], 
      RowBox[{"(", 
       RowBox[{"\[Pi]", "-", 
        RowBox[{"impx", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}], ",", "1", ",", "13"}], "]"}], "]"}]}], 
       ")"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tabb", "=", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                "2"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], 
              "]"}]}], 
            RowBox[{"dFnu", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
             "]"}]], ")"}], "2"], "]"}], 
        RowBox[{"7", "-", "3"}]], "&"}], "/@", 
      RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lipFnu3", "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{"tabb", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"hmin", ",", "hmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], ";"}], 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"for", " ", "heat"}], ";", " ", 
     RowBox[{"for", " ", "th", " ", "in", " ", 
      RowBox[{"C", "++"}]}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tabb", "=", 
     RowBox[{
      RowBox[{
       RowBox[{
        FractionBox["1", 
         RowBox[{"12", "-", "3"}]], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Total", "[", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                  "2"}], "]"}], "]"}], "-", 
               RowBox[{"impx", "[", 
                RowBox[{"[", 
                 RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], 
                "]"}]}], 
              RowBox[{"dFnu", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
               "]"}]], ")"}], "2"], "]"}], "+", 
          RowBox[{"Total", "[", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
               RowBox[{"impx", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], ";;", 
                   RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "6"}], 
                 "]"}], "]"}]}], "dCP"], ")"}], "2"], "]"}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox[
             RowBox[{
              RowBox[{"Log", "[", 
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
              RowBox[{"Log", "[", 
               RowBox[{"impx", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"-", "7"}], ",", "#", ",", "All", ",", "4"}], "]"}],
                 "]"}], "]"}]}], 
             RowBox[{"dlogLP", "[", 
              RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
          RowBox[{"Total", "[", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{"tofit", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}], 
               "-", 
               RowBox[{"Log", "[", 
                RowBox[{"impx", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], ";;", 
                    RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "4"}], 
                  "]"}], "]"}], "]"}]}], 
              RowBox[{"dlogLP", "[", 
               RowBox[{"[", 
                RowBox[{"2", ";;", "3"}], "]"}], "]"}]], ")"}], "2"], "]"}]}],
          ")"}]}], "&"}], "/@", 
      RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lipFnuCPLP3", "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{"tabb", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"hmin", ",", "hmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lcp05", "=", 
     RowBox[{"ContourPlot", "[", 
      RowBox[{
       RowBox[{"lipFnu3", "[", 
        RowBox[{"th", ",", 
         RowBox[{"Log", "[", "heat", "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"th", ",", "thmin", ",", "thmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", 
         RowBox[{"Exp", "[", "hmin", "]"}], ",", 
         RowBox[{"Exp", "[", "hmax", "]"}]}], "}"}], ",", 
       RowBox[{"Contours", "\[Rule]", "40"}], ",", 
       RowBox[{"ContourLabels", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"Framed", "[", 
               RowBox[{"0.01", 
                RowBox[{"Round", "[", 
                 RowBox[{"100", "#3"}], "]"}]}], "]"}], ",", 
              RowBox[{"myf", "-", "2"}], ",", "Bold"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"#1", ",", "#2"}], "}"}], ",", 
            RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], 
         ")"}]}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<Inclination angle \[Theta]\>\"", ",", "\"\<Ratio Tp/Te\>\""}], 
         "}"}]}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", "myf", "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
           RowBox[{"coe", 
            RowBox[{"(", 
             RowBox[{"#", "-", "mc"}], ")"}]}], "]"}], "&"}], ")"}]}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", "0.5"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xcp05", "=", 
     RowBox[{"ContourPlot", "[", 
      RowBox[{
       RowBox[{"lipFnuCPLP3", "[", 
        RowBox[{"th", ",", 
         RowBox[{"Log", "[", "heat", "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"th", ",", "thmin", ",", "thmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", 
         RowBox[{"Exp", "[", "hmin", "]"}], ",", 
         RowBox[{"Exp", "[", "hmax", "]"}]}], "}"}], ",", 
       RowBox[{"Contours", "\[Rule]", "40"}], ",", 
       RowBox[{"ContourLabels", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"Framed", "[", 
               RowBox[{"0.01", 
                RowBox[{"Round", "[", 
                 RowBox[{"100", "#3"}], "]"}]}], "]"}], ",", 
              RowBox[{"myf", "-", "2"}], ",", "Bold"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"#1", ",", "#2"}], "}"}], ",", 
            RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], 
         ")"}]}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
         "\"\<Inclination angle \[Theta], deg\>\"", ",", 
          "\"\<Ratio Tp/Te\>\""}], "}"}]}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", "myf", "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
           RowBox[{"coe", 
            RowBox[{"(", 
             RowBox[{"#", "-", "mc"}], ")"}]}], "]"}], "&"}], ")"}]}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", "0.5"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lcp05", "=", 
     RowBox[{"func", "[", 
      RowBox[{"lcp05", ",", "del"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xcp05", "=", 
     RowBox[{"func", "[", 
      RowBox[{"xcp05", ",", "del"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xmin05", "=", "xmin"}], ";", 
    RowBox[{"xmax05", "=", "xmax"}], ";", 
    RowBox[{"ymin05", "=", "ymin"}], ";", 
    RowBox[{"ymax05", "=", "ymax"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.4858838610502157`*^9, 3.4858838966182156`*^9}, 
   3.485883995756215*^9, {3.4858840536322155`*^9, 3.485884084598215*^9}, {
   3.4858841598838153`*^9, 3.4858841872150154`*^9}, {3.4858843623874154`*^9, 
   3.4858843851166153`*^9}, {3.4858847378326154`*^9, 
   3.4858847408122153`*^9}, {3.485884797081415*^9, 3.4858848075334153`*^9}, {
   3.4858850795506153`*^9, 3.485885083325815*^9}, {3.4858851184258156`*^9, 
   3.4858851327622156`*^9}, {3.485900264152*^9, 3.4859002891359997`*^9}, {
   3.4859003222799997`*^9, 3.485900369835*^9}, {3.4859004017939997`*^9, 
   3.485900447152*^9}, {3.4859008880699997`*^9, 3.485900908041*^9}, {
   3.485901226112*^9, 3.4859012313310003`*^9}, {3.486168529913*^9, 
   3.486168529994*^9}, {3.4864363169894*^9, 3.4864365222824*^9}, {
   3.4864368030874*^9, 3.4864368334983997`*^9}, {3.4864404135364*^9, 
   3.4864404208824*^9}, {3.4864404511893997`*^9, 3.4864404551194*^9}, {
   3.4864419416464*^9, 3.4864419551054*^9}, {3.4864419966534*^9, 
   3.4864420353114*^9}, {3.4885950438718*^9, 3.4885951231317997`*^9}, {
   3.4885956501078*^9, 3.4885956619558*^9}, {3.5009181670629997`*^9, 
   3.500918204102*^9}, {3.500945067347*^9, 3.500945081197*^9}, {
   3.50102890885*^9, 3.501028909184*^9}, {3.501028955572*^9, 
   3.501028959943*^9}, {3.501519094303*^9, 3.5015191340769997`*^9}, {
   3.50151925392*^9, 3.50151925781*^9}, {3.501519333006*^9, 
   3.5015193526940002`*^9}, {3.501519390442*^9, 3.501519418618*^9}, {
   3.50151946524*^9, 3.5015194856289997`*^9}, {3.502467885974*^9, 
   3.502467920837*^9}, {3.502468246691*^9, 3.5024682481140003`*^9}, 
   3.502469517704*^9, {3.5024699509820004`*^9, 3.502470005356*^9}, 
   3.502470044156*^9, 3.502470263777*^9, {3.5025624737014*^9, 
   3.5025624737794*^9}, {3.502562570671*^9, 3.5025625745554*^9}, 
   3.5025626086882*^9, 3.5025626475634003`*^9, {3.5025640530025997`*^9, 
   3.5025640569337997`*^9}, {3.5025640907858*^9, 3.5025641490986*^9}, {
   3.5025642062258*^9, 3.502564215851*^9}, {3.502626196118*^9, 
   3.502626196277*^9}, {3.504287444663*^9, 3.5042874562980003`*^9}, 
   3.5082629889519997`*^9, 3.5082632758970003`*^9, {3.508263570741*^9, 
   3.5082635873859997`*^9}, {3.508263803928*^9, 3.50826380758*^9}, {
   3.508263837708*^9, 3.508263838717*^9}, {3.509376731141*^9, 
   3.5093767312349997`*^9}, 3.509407788791*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fig09", "=", 
   RowBox[{"Figure", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ScaledLabel", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.54", ",", "1"}], "}"}], ",", 
         "\"\<\!\(\*SubscriptBox[\(a\), \(*\)]\)=0.9(RMS \
b):\!\(\*SuperscriptBox[SubscriptBox[\(\[Chi]\), \(F\)], \
\(2\)]\)/\!\(\*SubscriptBox[\(dof\), \(F\)]\)(a) and total \
\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\)/dof(b)\>\"", ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
         RowBox[{"Offset", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
       RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}], ",", 
         RowBox[{"XPlotRanges", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"xmin09", ",", "xmax09"}], "}"}]}], ",", 
         RowBox[{"YPlotRanges", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"ymin09", ",", "ymax09"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"XFrameLabels", "\[Rule]", 
          RowBox[{"(*", 
           RowBox[{"textit", "["}], "*)"}], 
          "\"\<Inclination angle \[Theta] [deg]\>\""}], ",", 
         RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
         RowBox[{"YFrameLabels", "\[Rule]", "\"\<Tp/Te at 6M\>\""}], ",", 
         RowBox[{"BufferL", "\[Rule]", "6"}], ",", "\[IndentingNewLine]", 
         RowBox[{"TickFontSize", "\[Rule]", "myf"}], ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}], ",", "\[IndentingNewLine]", 
         RowBox[{"XPanelSizes", "\[Rule]", 
          RowBox[{"{", "1", "}"}]}], ",", 
         RowBox[{"YPanelSizes", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}]}], ",", 
         RowBox[{"YGapSizes", "\[Rule]", 
          RowBox[{"{", "0.1", "}"}]}], ",", 
         RowBox[{"Background", "\[Rule]", "White"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
         RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
         RowBox[{"PanelLetterCorner", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
         RowBox[{"TickNudge", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "5"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "5"}], ",", "0"}], "}"}], ",", "0", ",", "0"}], 
           "}"}]}], ",", 
         RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
       RowBox[{"FigurePanel", "[", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"RawGraphics", "[", 
        RowBox[{"lcp09", ",", 
         RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
       RowBox[{"FigurePanel", "[", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], "]"}], ",", 
       RowBox[{"RawGraphics", "[", 
        RowBox[{"xcp09", ",", 
         RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.26"}], ",", "1.10"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.14"}], ",", "1.10"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", 
      RowBox[{"12", "*", "2", "*", 
       RowBox[{"{", 
        RowBox[{"11", ",", 
         RowBox[{"11", " ", 
          FractionBox["12", "10"]}]}], "}"}]}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fig05", "=", 
   RowBox[{"Figure", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ScaledLabel", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.54", ",", "1"}], "}"}], ",", 
         "\"\<\!\(\*SubscriptBox[\(a\), \(*\)]\)=0.9(lin \
b):\!\(\*SuperscriptBox[SubscriptBox[\(\[Chi]\), \(F\)], \
\(2\)]\)/\!\(\*SubscriptBox[\(dof\), \(F\)]\)(c) and total \
\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\)/dof(d)\>\"", ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
         RowBox[{"Offset", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
       RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}], ",", 
         RowBox[{"XPlotRanges", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"xmin05", ",", "xmax05"}], "}"}]}], ",", 
         RowBox[{"YPlotRanges", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"ymin05", ",", "ymax05"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"XFrameLabels", "\[Rule]", 
          RowBox[{"(*", 
           RowBox[{"textit", "["}], "*)"}], 
          "\"\<Inclination angle \[Theta] [deg]\>\""}], ",", 
         RowBox[{"BufferB", "\[Rule]", "4"}], ",", 
         RowBox[{"YFrameLabels", "\[Rule]", "\"\<Tp/Te at 6M\>\""}], ",", 
         RowBox[{"BufferL", "\[Rule]", "6"}], ",", "\[IndentingNewLine]", 
         RowBox[{"TickFontSize", "\[Rule]", "myf"}], ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}], ",", "\[IndentingNewLine]", 
         RowBox[{"XPanelSizes", "\[Rule]", 
          RowBox[{"{", "1", "}"}]}], ",", 
         RowBox[{"YPanelSizes", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}]}], ",", 
         RowBox[{"YGapSizes", "\[Rule]", 
          RowBox[{"{", "0.1", "}"}]}], ",", 
         RowBox[{"Background", "\[Rule]", "White"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
         RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
         RowBox[{"PanelLetterCorner", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
         RowBox[{"TickNudge", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "5"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "5"}], ",", "0"}], "}"}], ",", "0", ",", "0"}], 
           "}"}]}], ",", 
         RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
       RowBox[{"FigurePanel", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"PanelLetter", "\[Rule]", "\"\<(c)\>\""}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"RawGraphics", "[", 
        RowBox[{"lcp05", ",", 
         RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
       RowBox[{"FigurePanel", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}], ",", 
         RowBox[{"PanelLetter", "\[Rule]", "\"\<(d)\>\""}]}], "]"}], ",", 
       RowBox[{"RawGraphics", "[", 
        RowBox[{"xcp05", ",", 
         RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.26"}], ",", "1.10"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.14"}], ",", "1.10"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", 
      RowBox[{"12", "*", "2", "*", 
       RowBox[{"{", 
        RowBox[{"11", ",", 
         RowBox[{"11", " ", 
          FractionBox["12", "10"]}]}], "}"}]}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\n", 
 RowBox[{"chisq", "=", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{"fig09", ",", "fig05"}], "}"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dout", "=", 
   "\"\<C:\\\\study\\\\accretion\\\\! 2009 fall cfa\\\\GR Polarized \
modeling\\\\\>\""}], ";", 
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"dout", "<>", "\"\<fitthFFLPCP.eps\>\""}], ",", "chisq", ",", 
    RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", 
    RowBox[{"ImageResolution", "\[Rule]", "500"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.4748618905642767`*^9, 3.474861940503355*^9}, {
   3.4748619779128838`*^9, 3.474861981533142*^9}, {3.474862476788208*^9, 
   3.474862477771343*^9}, {3.474862511446033*^9, 3.474862515512307*^9}, {
   3.4748627977306633`*^9, 3.4748628170351954`*^9}, {3.486060291426551*^9, 
   3.486060291504018*^9}, {3.486060356795478*^9, 3.48606036077973*^9}, {
   3.486060410818349*^9, 3.48606042982097*^9}, {3.4860604829999847`*^9, 
   3.486060516055204*^9}, {3.486060942797173*^9, 3.4860609498265667`*^9}, {
   3.486392460209*^9, 3.4863924927539997`*^9}, {3.486394839106*^9, 
   3.486394846752*^9}, {3.486396595895461*^9, 3.4863966000384607`*^9}, {
   3.4863966657314606`*^9, 3.486396753461461*^9}, {3.486396876366461*^9, 
   3.486396900452461*^9}, {3.4863969472034607`*^9, 3.4863970224594607`*^9}, {
   3.4863970931864605`*^9, 3.486397152918461*^9}, {3.486397224832461*^9, 
   3.486397288619461*^9}, {3.486397778725461*^9, 3.486397810740461*^9}, {
   3.486398150562461*^9, 3.486398197600461*^9}, {3.4863982987504606`*^9, 
   3.486398416102461*^9}, {3.486398448819461*^9, 3.4863984492424607`*^9}, {
   3.48640277619*^9, 3.486402906844*^9}, {3.4864330930274*^9, 
   3.4864331353984003`*^9}, {3.4864336777274*^9, 3.4864337149634*^9}, {
   3.4864342163674*^9, 3.4864342964524*^9}, {3.4864343388964*^9, 
   3.4864343398014*^9}, {3.4864356143834*^9, 3.4864356341554003`*^9}, {
   3.4864357370544*^9, 3.4864357672024*^9}, {3.4864358215074*^9, 
   3.4864358808594*^9}, {3.4864359344624*^9, 3.4864359426664*^9}, {
   3.4864360554974003`*^9, 3.4864361351084003`*^9}, {3.4864361913004*^9, 
   3.4864361920474*^9}, {3.4864368530024*^9, 3.4864369503714*^9}, {
   3.4864369896963997`*^9, 3.4864370002743998`*^9}, {3.4864404723984003`*^9, 
   3.4864404891764*^9}, {3.4864420458684*^9, 3.4864420666214*^9}, {
   3.4885950320137997`*^9, 3.4885950326208*^9}, {3.4885951428118*^9, 
   3.4885952169908*^9}, {3.4885953489458*^9, 3.4885953902058*^9}, {
   3.4885956660797997`*^9, 3.4885957084217997`*^9}, {3.4891543499695325`*^9, 
   3.4891543627771325`*^9}, {3.4891544270491323`*^9, 3.489154452040333*^9}, {
   3.4891563441511326`*^9, 3.4891563489247327`*^9}, 3.5015189213859997`*^9, {
   3.502468099335*^9, 3.5024681015030003`*^9}, {3.5025630751594*^9, 
   3.5025630758302*^9}, {3.5025643031018*^9, 3.5025643102778*^9}, {
   3.502626534615*^9, 3.502626548627*^9}, 3.5026492519440002`*^9, 
   3.5043671929370003`*^9, 3.504367223332*^9, 3.508262988958*^9, {
   3.508263849542*^9, 3.508263851446*^9}, {3.509377299587*^9, 
   3.509377301054*^9}, {3.5094078698059998`*^9, 3.5094078711400003`*^9}, {
   3.509450974133*^9, 3.509450974924*^9}, {3.5099008468789997`*^9, 
   3.509900856271*^9}, {3.5101489154386*^9, 3.5101489219955997`*^9}, {
   3.5101489784026003`*^9, 3.5101489804926*^9}, {3.5102332622756*^9, 
   3.5102332765966*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Round", "[", 
  RowBox[{"2418620.", 
   FractionBox[
    RowBox[{"4.9", " ", 
     SuperscriptBox["10", 
      RowBox[{"-", "8"}]]}], 
    RowBox[{"Mean", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Exp", "[", "rhomin", "]"}], ",", 
       RowBox[{"Exp", "[", "rhomax", "]"}]}], "}"}], "]"}]]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox["\[Pi]", "180"], 
  RowBox[{"(", 
   RowBox[{"180", "-", "28."}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{"2", 
  FractionBox["180", "\[Pi]"], 
  "0.15"}], "\[IndentingNewLine]", "2.23054"}], "Input",
 CellChangeTimes->{{3.5082632933199997`*^9, 3.508263387784*^9}, {
  3.508263418727*^9, 3.508263432734*^9}, {3.508263995606*^9, 
  3.508264049299*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{
       {GrayLevel[1], Opacity[1], 
        RectangleBox[{0, 0.5238095238095238}, {1, 1}]}, 
       {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
        GraphicsComplexBox[CompressedData["
1:eJxknQuc1sP3x5ei/kRRlIRFCNHmF0KaVAilUghhdfuFkCRRWAkpshHSTSUU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         "], {{
           {RGBColor[0.178927, 0.305394, 0.933501], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNl8tv1FUUx+/0QZ0Sh2FoWlpFGEtDp6sCoUALrGg1EUUoYmzLI7qByMMN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               "]], PolygonBox[CompressedData["
1:eJwlk0tsDGAUhU91hkwbrUwnM6ZJxWRMzFjRBrXowsJjgUQlHu10g0RTtGyo
qaSkTbxWlh0bLRJlgQ01xGNhyUZX2BGP2NhZeXwnd3GT8//33HvPvf/9C4fH
+keXSOrDElg1J61MSjeWSrvz0rEu6eUy6QB3Q2npb1aaTgVnCO4sdhmsVul+
URqGs6lJ6myTvpWl3/Cn4O+CcxHuYEWap+Bq/FXwzYz0gtgPLdIk8Q049+DO
IWaQXK0F6Q64SM6WQnDM/YhdAP8sR65e/CPwJ+H8ol4N/d3o3+J8qbiz7ww1
NzRTk5hx8NlK4D7urhPfIGcaPR3YM/D82sjVT/674AX0PoLfA/8N+An2kPMD
bIRce8jxR3F3nPMt/FfBV7BtnBP4h/EvLme+60KztZuzHX8P/dTxfeJc51yD
k1/BG6DnaInZ5qN2AdsI3gHnGtwZYm5n4g38Fp55in5PrpHammPmbzukU6WY
nTWOgbvLEeuarv28GL33wj9I/Cw5m4j/gg10hSZr84zas6HJ2qxhZyV6dK/u
cY7Yx5nQ+hk7QXyVfvcnY6e8W94p75bfuCkXM/QsPWPP2hqsZR+cQ+CncObB
7+hvKhc76l313QLnH+WYrXfwezne1G/7Ho21UsQ41hqmwXvTsZveidfUq3N3
Phk7490ZSEdt76R382s5djvVLq3iPFGK3OuJHwcvVsLnmXl2rzLhc85z+EfT
sUudvOkEb5vIxmw24z+dCzNuUH8r/R4pBdc74F34l42/4T/ov2iOuf6Dl8id
zMZb+U/NoOU/EoSH8w==
               "]]}]}, 
           {RGBColor[0.926163064, 0.744968184, 0.259447272], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmXlw1dUVx3/vJRHIS/KeMZMHlS08X5MXUZTNUWwVrFbt2BYHTUCsrYJa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               "]], PolygonBox[CompressedData["
1:eJwllmdslWUUx09Lq7SlXChv7qVhXi719i0bxCjoB8UAgaBAZLQsBUFmEZGy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               "]]}]}, 
           {RGBColor[
            0.8399984720000001, 0.3084513600000005, 0.18593588800000005`], 
            EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmnl0VdUVxm9CAuQleS8+Ql6iYUieyct7lqB2EG2rRbpWFVBbFWSoBYIG
aRHR0lkBITgAFhNAnNB2LbVdy65WhipotbXWkSEiSucC2lFbWxzBSle/H992
tX9czsl55+6zzz57f/s7+9LSdcX588uTJHlJ/wxQ+5NMkuxTZ2dZknyjJUlu
HJgkd2eT5ObKJNlUlyTnanxonfurNfa42p/rOUvvXFdIktraJFmu9uFiklSr
f6QhSa4uJUla/RsKfm9zyDkv4zlrtO61+q1K/SVqp+aSpF6yF6vfoba+OknK
KpJknX5fq+cSzf9pPklyGv+Z2vnS80BVkjRqzQVaq1Hj3ZLRUO3+p7S3N6RH
n2Rs1pwZVV6LNXpC/2V6Vuh5Us8RzW8IPdnrd7T/T2isYmSSTG+THrLJDzT2
rvawQM8S6fMb/dYluadJfrPWHKbnUOL9s8eV0muV5q7WU6Xn0UbZQ/q8qt/f
0tMo+/2oPkl+JTmzJGeF9vVdrTFE716jd5vK/e4CyXxN792s/pXq/1PvXq85
KzTnjDKPI39StfXAVrtrrfPsxPvkzD4zwPu8RePnqr0i9sK72BXbnaHx9yR/
g9bbpn1dK3v9vcLrb894Pu9dmvZ87Dwj43XZ+y+1l5nayxi9u1JrPhU2XqPn
WT036d3TpMdL1d7/AcnfVWbfuyXt/puJ99Qf++3SeKfWGaXns+qPVnss8yXv
xHKfBb8x55wyj42O8V0hBzttl63P1Jp35z22K+T3Sf9ePQfL/N7bcb7jNfaO
+k16hmmtt8o852PNSTJFv+8bkSTDNf7xAf6NGDpU7r1gs53a4wkam1Ry/8vy
o94y67lY73+jZDtcrjN/SO0BzX1Pv31V83bp76+ovb3e/r9Ucy8sd2wekozX
dEYrtMYB+fzFx8i+mjOqw/pW1FrnzZJ7gd65XrGSytj+vRVun4v+2uhzPq/o
LF7Wc1y5Y4Kzq5ZOG+rtN+N0puM0NkRjx+rvU9Q2lts/sS99zg6fxXcZu1Xv
vqv+RUXvqb/aOJCr89/0Z4MlOtf/VHh9fAL5yGsK+dfozH6VSpJFagfIBuV6
/qV522qEO3pW6t0Rwo6H1P+HbPNl9V/V2Gmyz516lmjuGNnwEfXvV//r6rdX
2r/xbfAO2z4j+fNafJ43Zf0+chZK3lzpuDxj3Huo6BghVsA3sBJsZAwfxT+X
S96+Kv/2/GDFn8aPVPjvXj2HNaem6PHlWuvzbfaDi9ss6+aYw9ngn4PV/570
Wafx0U16MrYbMtfVWU/O9ETJvELjJxf9+9lh23El6/+YZGyotE0464OVtiU6
j9XexsS5VsmWZ8vm78v+m/V7Hzqp/0al32F+ldY4VfMHq10vHXZIfp/GLxqk
81V/htbtz7jfm9gX8clN2m+/bLpRcp6QPhNTXou4OrPO508cFSX3i9K/pDZT
9F6u07tbCz67u3LGiisCx+bq706NX1nyus/ruavCOQ58wRc5C2y2X3rfm/NZ
rJbM81O2A3ucONC+hV+NLfo9fJn45yzAdTD+mRrnMjCPPbPfKc221X2S/aL0
PE/zpkmfp/LOET/UWnulw1TN/8cA73t4te3MGDIZJ7dM0d8zJXO3ZE2RnN9J
3kDZcLF+GxQtuqInOQGdp0nOVrUPhv60xMVUjbcUHC//kt821xmPwKJH6o1V
l2uvlZK7SHKX532m4CzYD7b2hp2fzlvnB7LGj2cDQ6ok40KN3yN7pdQ+VWP7
g/V9gbH4L7l7jdqbwhc35hyH4CZnydw14fPYuy/67RGvV0aOeC3m15SMeZOz
9s/VETvYbI6e/fp7zvHWrVvtl463/uwDvFoVeRabHIy/2cOkyKf8fVPMIbbI
r3fo3LbGXpmzJWuM/kyr/FV2vlu6vS8779G8e8udH6/Su3v1933ltsHaStsB
3H438s6C6GPvtWFX9j6+1X5RJ5k35i2fdRZK5o2B1X2B6cz/SNG/fVTtNW3O
NeQczpIzZa07JOckze3OOn89OMg5DH/Fb/fAzYZ5fIrab2n+L6X/1XCxWnML
eMVX885d89qca6aDBZI7S22XnrexYZ05ATZYJ7kXaf6PtW53ymttqrS/vJyy
z7wauMae8LG1/5ez1kWfPAJvezvlfLUy7MAa9N9L7BP4xosjPbYixl9KuX8k
8kxj5KxPFy1jkWxwcYXzHOfOvnaEH+CnxAu+V63xz9f5d+yBXeBR7zR4DrHF
OayKvePPa4ILba+27mDm0fyi8ctC91Wxl/7geOgGp4YflmSryyVnXsacpltn
cxy4q71+u2R/2JC3bPgQ8h8OfvjhMp8POp+u/pPVjgtid5valNqTNX55m/vf
k/7rI4+DhegHhz4jOAH2u6vemMp5g6vjpcdurf2VvLl2T9wXDpd7nZODc2Zr
zSPLssb+CeIyrfKNp+RvD0vmfXpu1XqTi+Zjo4LjwSPIr/AH8Luq2vH+47xx
Z0veY4Nj/HCl+8TnXK354mBjPX6P/7e32H+eDP+YmrUf3iA5O7T+2LRzI/kE
+fgn+6uKPZGziBv8nDzCGshflTWXgFNcNcz2/lLW+yde4OdwOzhep/jb1KJt
/n3t+2HZYan2uCTrHDs9zuvkyO8nFW3bx+Mu0xMt50Ju513wclSTc/rTkrm0
zefwnGRPIWdLzqSi/a4nfA9+d2ZwvJ68eeayvO8Th0NnYmJs8IR7cubAGzXn
rrzfv1LrvCBb3SGZu9V+oc3+N6vN+PeA4vy8wErOZInG/yQ9WjT3z2q/WTCP
XaR2ftH8eaHmvKl+p+a8pXas3ptc7jtIf7tkSOaedp81MuHJ8KlUjbl1d9r3
Ft6Z1uzc+ochwugKxzmxfWGz83+X/HB6s/PxviG2C346rtwxSPxxT4VLIg9d
GKPl3nhtm3Fxl2ye0fmeK53rSj6X9uBd4Dh4/qGC30N/3uVOSL78Tt5+sTVy
EC3xie9gX+x8f73zz9YYhyM/Wm3bco95J3LK6c3O/wd0Z+lq85y79e78NvOO
Lx5vjgaHgadNK3qtOzRnhuY8ov6d9fZBfBFbjWzwHX2F9O8sGY9OVNspf9ui
Pf4iZ4zb8UFurbYPsJeGuGeDTYw98sG9NWU8Iq5mthmr5sj/pzZbt98PsT9x
dn2JuRJnBAeD791W533MjrwDJsGBZ0f/3bAJGHJ6xDS+zJ2sN8apFdxa5xgn
x4NnYARjt8U4vL43ODoxQHxx9xmaNgaCA3AxuBl8DJ1vrzOXWxNcGrxmjBgh
l1MDuD36pbhXws3YB/rD4edljQFgyZSsZYD9n47f8YmfNnrdxxrNL/qDe2MX
9gBHJf/D7cgLj+ddM6GO0ldw/rpF7WXyickan6v2hDrrxF2csUnBe6glwG2o
J1xf4TsD/pQZ6L/xwy015vc36u85KdeLiB3O/pbQYXfEL3G8t9pchTrB49rD
OZL1M7W/qHSfs+aesT54KZiE74NLYBB2m9hk/ghvJJZ60vZn4oTzpQ6EHd6K
egScD/xbHnkK+TvjLkOe4Zw/qIPBLUeHv8AXj94FZLsJml9bco7A5th+2iBz
feIc3gT2wT2oG1BTWBycc1jwzh7F3dPSdVnReeb5kEPtCfw9q8nx937g1dCC
+eXX8uaTF6Q9vyv8AT/s7zCfh9ezTnOsiy/3x/2ImhS1qTHNrnmBQ8+325bD
Yz4YiW6nBCcgT5GvyHPkU+6D5BhiYWDR5w8e4QPnZO0X4A1+hD9xDyQnP5c2
XhcLlpOWLp/T2PlpYxjYzZ2NOESfUrwLn4PXfUvv/ajGfA4/fKbeNjqpyfsd
HrUbOPfe0Ac/LsW+XglM5k5Bzrw2/iY3cmckrsmHcC1y4p2S0ZWx36eiZoP/
UQebmTFmgXUzov/trH3o49JnZqtxDDzDj96Ie/T2Idbvw0XHCPEBtvbGXYQ7
171RazsUZ3drYB34cXvk2Yai71fUCZ6o9P0aPz+l6D53bvwa/4abwi3Y86ny
29El75M6WZP6UzXn0pzv+uRU8ulRPhV3qxbNmaU583O2DfhPXhta6dwPPlPP
mRfj5O39afsudpoV9uFvxvEv/HZWYDXy5se7XWFbbMB+kQ9ONhW93tKC9Xwj
dMuFHbAH9aKDoT/3mMEZczVyCDYDk5G3J2TCd4gX4gEu+FLE7KiC880Jaidm
fQ6/G+G5YNsNgeFbqiwTPtAZnOBQcERqGtS2OV9ibHONMZNYAcPHRe6gXnFq
ne9k1BnhxnBk6hrIvCznGtiAqAcS/+DA1/NeZ1zUUI4rGH+bC655wVd+kjMP
gA+UZ43l89L2WfLGs4Ods9ZGLiAnkJ/XRR2eewn3Ge4mu+JeQow0FbyfYwuu
BxGDxCL1LWpVnCn7LsXeV8e7+PZfGhzDDQXn/nsipqg7lccery+Ye/FtAV+Y
Ef6ALtyriB/8ZUPwq/+ETbEnvLI24zsltmGcXMldqjN0WhD5vypyQmPkBXxn
QNQbwSXqe9T5wBLWxTd+O9K8e410nJQy7oP5D+btn/gp+Y78cbTGnDIHYoxc
xBziZVGb89/iNscrdSXil1iujzmP6vx6uPfJDq9XOSeSG8GAWeF7J0QO434K
h6FeQX78dXxr4JtDi/C9UzZvbbcd9wR+cg/vCjl8D9kUXI19fy4wmTxDfiLX
LC8aw5/VWZ9Wsv2p67ze4DrUyPAj+DB3fux/ZpzLmODEG3LWBbuBe8QV8TUh
a7vjA/Dyo/wlbELM7g6cmZ12TgHX4Z6bI9531ntd+DjnvLXK8Qj32xH8b3PU
EMjvcJCxcaegPp2r+99Z5WLO4ah/gjPD260vXJj7CtwS+yzNGxN2dfh+wL0D
meRDYp1ciD9SO6COsS7qQPA5bEAOOMqtS67r5SXnr63OPQOyxq5LU947eAnv
3B93Mu6q5GD8bHXkl1OLPtcXCsY3sIr4p0VP8GXyMeZt+3UWjQX3Gdtd8Fqz
tP6gouX3ZH0fYl/ciXIF7+tvDebr4PofR/juvj5yKP77ROSj7R2uhVITPV4y
L9GcfNF1ROoo3Bs4T86VXP8nzc+p/8cOj3HOo+I7z2fDJ+Gwl4SduRNQV4Ir
bota/b8bjM3ECr69MfTBhq+lXReFs1MXmR56YDPmIwdO8EpgC/XEg1Xm8Uta
3H8h57NCFnLwu+xA+zxnuz94P5h5IPgG34S4224rmEvfGbXChrT3e1LUMHm3
N75JTYg6CL42Puqy1DjRgXl8CyLPkTvgU+wdHwDf4MtLgj9vD3x4NO+c9Fje
spEJr1oWd3++NeFb4AgYAkcBa6/r8P0Ubg2v5k6Pz8CvyF3kMGpGL4fd2O++
nDGmvuC8eiTuDtzR4XhwvYV5c/rb6p2XhkXdCl/rDn+DlyF/Z9jy5ZDP+b4e
Z7w/Ygq7IZc9oD987UD0+TZMffHNBvMU5JA3eZCL/N7wR3gYuNsdNQSw5P7I
73w72hKYU4DDaU570fdKfHVx1BuTyBd8G+b7wTK+n8d3mnTReFCT8R1vxjHO
JRNaHd8N4Q/wFLCPnNF9jH1sZdH1w8vCPq/Edy6+d1HHAjPh+Ts7rMMOtQ/U
u/54VZt9vjrWpfaGTaghU7c4P3D/rFbXts5utS2Hhj5wt6eDv60s2JfwKWp7
jfFdmbsKv1MH4Gw2RQyCPRPjuw81FzD+omZzNPZ7KGJnbZzj3qLtMyLn39CB
PLIsa0yvLDrH1wauDi1a/3pqSx3+1vLJVscgPvTBd+f18W1oYcQj32zBGTjw
BRGPQ0Mf/B7/H9/keDkn4jFdcn9KzvdIzoO75NVRy6KmxbesuXFG5G3+PwTY
Qq0Tuy8YZv+aE3P6IpeRF6h5U/vmbLApZw3nAOc2BUaB0xsD08iZvHtzfL/b
EnI451TY57+Dq5KM
               "]], PolygonBox[CompressedData["
1:eJwtl3lwleUVxl+SANkv3lzyJZUA4RJu7tUEnS4KWrTYGdlpKZCboBVSk4iQ
0LHquBECJIalpSBiFyDqjGU641gRKCAVlGm1VgQNSOyOa7Ut2lbAVoud/p55
+OPMnPc75z37e875qpuXzenICSGcBvKARCqEWXw4URjCcPA/AtmSEDZBu/mi
EHrTIbxcGsIkYHU8hPWc40NCuD43hKOJEKaPCWEedz/gPA38UEUIM6CvKAhh
SHUIOdxpRNYalB2E9hwwE/qH0JdDX4O+UvTVDg6hG3wRMlqQlx0aQtOIEL6I
vtvRvQMbj5SFcJJzUSyEEmB0FMKx2hDWIrsTea+Ar0ZGEfJmQ18AfRw6Lh8U
QoSMd6G/U2u8HHgbvBB557k/AfsLwC+vND6JO0uxPVsVwl5s2YzMG4nHtmQI
Wwstcyv4SPTtLQ5hP/BheQjN2N8KvZE7C7C/F54XoBUWhfBz8NXo+DW63wD6
wLtqQpiLby9x7uGcB1yRa55u2QMsK7VO6d7F+e+ce7HnH+hbw7e3Cq1Dut4Z
FcLnsW0R/ldnQvgaPuRz3sx5FucWfGiDvwn7bsC+XOjbOD9ETqbi+7fx94Wh
vqO7jyCzAntOYv9ybF2OjLIS56w35Tu6+xk+bKce/opNvcQzxrcK6A9zfzL3
y4A+8A3kpANb2oF6ZLXHLXsA6ET+Pu6c5v5K6mE/+HhytAVdv4B+E/SOyL4t
VP4zjqFiWc/5DHhdrXN1Cn2Xgk8lH3PwbyM1OBd/f5NwrPORtwt75nPnh5zP
QJ+CLSuROWFYCP/Gnx/Ae2nKtf0i8a0DT9Y69k3wZ4nlafxdj70HoFdDX4Z9
zTHH9H10fzYcnfl+E89S+4eg90BfjM5adN+DDQPwvg7cC35JyrpUwweg/7Pc
spVz5f4l6FNyLeM6bH2IcwRvA/ZuAW/l2wlow4nfXuQ1pC/4wv0s+KqUaQmg
EVueAR5XrHk/beD3E4Op8E4BSuDfAH8c+RHxehZ5mzlfk2OdD4L3ACUlrinV
Vg/3r+fuq/j8HrW4ImVdBfCsTPmN663rzv3gebzPT4ll4M5RYjswmjwXuKYb
kTU65belGCvWxznv4v5s7r8GfiJlXG9Ob08+yJd6eBaDf5lvU6EVIOM8ubgX
/kpqO48796k+yfFBfPstPMvx76ecC4nv03xrUu+B52/ofgD4CP1dKfsiG2Vr
NzZ+pdQ9Ur1SOVVubwXS4IeQmUDW1cTsEXinE6NssE3V+NuX8Nt5nprbRO6e
hGd2jm1qpt6rLvQX9dBJ1O9pYjqQ7/f7Bv1wHfRBedaxHnwJd54H70f+NGQ1
EYM92LoI+B32luLDa9xfjA8fwz8KenHMPVW9dQhwZa59Ggp+61jihu6RyFwC
/lzStaAa+APy9sPzdXi3Y8M+8Crk5cfcMxurXAOqhUJ8OIttG/Hx8DDX8Cr1
E2w4Rz7mIGM49/ck3Su/wXkj9k/kW3OBcz4hbZtlu970FHJbx7el8M7jzhPw
D057VqmHqpeOA9o4twI14JPR341987H/LWxt59slmmXc7wBPpG3LLHhiGdsg
W97Ehg5q9fi4EK7l7s18GwtvMm28gvuHsf02eK7Lsc4UtKHVnoWq32vIXwsy
j8as82NyUcJ5esw1WQyeSbt2JEOynqE+XkH2MeBO4nXlCM9S1dCXwCfD3w3/
g8Tkx/D2UFP9JZ4Zl0HbmnAti0e8T+Hz9sHuwerF2xLurQeAbyL/v+XOpWok
TaxfrvXbPEm878a/Mcj4Fuc67OuLu4eqlxYAu8HXJV1rDyNjLfgTwP/y3FNi
qi1gIfSnsOEK8GEZx1o1pFo6g862Eu8g/ZFnlmaXZtBZbHs65VxpRmhW9EWe
Favorwc4v8l5XZ7fSwNvbULGtC54tkG7o8axPIc/j2JbT9K7g+50q1+O8Kx4
AP4s+PfxcRP4KXjaycctkXuLZuCjcfss38Xzk8g84u1B5wbFR/VDrBqVY2z5
ld4jvGuh3w3v57B5d7FnZpTyTqLdRG9Ib0kxV+yfhOc95SayL8rhROTV1zr3
mpGalZqJmo2aQZpF30P/WWrrKuL3WOSYKDb7kDdKuxIxHx9zzy4GH0N91xe7
p4wEPwF0FbvmVftZZMyMuWaLMp6xmrWamZqdV1Xad9Wsarclsu+qGdWOaka1
IxmlGe9o2tW0Ex5mPj6e8K6gmlHtaCZrNqsn1SH7g3Lbrp6o3WtapXdD9Uz1
zrNp7wLa6bTbnSl379ZOMwb+9znvLPbM1extoac9xt252NsG/iP0f6JZij0L
atwz1DvUMw5ia+tY86rHqtdWpN0btpCPSLtI5N1HOqTrWMK7snqeel95yrnU
zn0K3sXIm19kG2RLadqzVzlRbtQz1Dvkr2bBvLRnuXaWHci++sJ8mwFcC74d
n9YO8878BXg70VmU628bwBfV+K1rR1xY4x1Qs0Q7/E0XeaborBqoJt87Ir+F
f+FjV7V1SNce6BdjTwMxv3iQa7qeXJwv99vXDqJdpDPlWaser15/PLIsvXG9
9REpy9IOvwrbzylfg9wj1SuXYuOnOZ7J7TWekZqV8umr+HdZxrukdszxGb9p
ve0j+LiT+OyMe3YpRorVdM7/oZ6q+HaE2v1Z3LhmiGZJa+Rerp1Hu8+SuP8F
NCMH0v7n0L9HNfBu2v8w+pfRjNWs1QzSLFJObxnrGaNZox3rbfDxla4VxSwL
7x1Jz2rV3O2q90rXnnq4evmN2omLHIM7k/4n079ZAzlaiD9/LvO/kmbk75nH
LybdW/RPsQf5p8r8L6KdQbvDXUn/6ykGM+LeibQbqQdV4u+r47yr6M33g0/E
nom57iHfjXuGa5bLphvAV9R4dxePeH8ZubfrH64feZ1J71baIWZy/76kd13t
fNr9ZlS6N6lH7oZ+W41zpxpQLfyp7IKv+Pc6/v0l7dhrJ/sO8v8PWx4OtA==

               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1mXuU1VUVx38McweYGeZxZ7h30EvDPO/cC6z0j9RUlLTMB6IpAmqYPDTU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               "]], PolygonBox[CompressedData["
1:eJwtl3lw1OUZx1/JuSG7JNlkN8HEsDl23cVMS/8QKkJxbBmV2AMkCdhYkiBF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               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1mXlwldUZxj8CSQhJCMmNuaiXhoR7c/OhhWn/UFtwwQUEO8hiAlZkd6Zq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               "]], PolygonBox[CompressedData["
1:eJwtl3ts1eUZx9+2QOmdnhZOp6eWtufSc0CMM6IORgSnCBiEXjHBCi1LRAal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               "]], 
              PolygonBox[{{8932, 8931, 5057, 2883, 9300}, {9303, 2884, 5058, 
               8931, 8932}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1WGtwlNUZPiE3coHNZpPdIBuTbL7st18oKoIXECII1IohgQTEFgQKndoC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               "]], PolygonBox[CompressedData["
1:eJwtl3101XUdx79jg7EHN+6uuxfdb227/La7OwolMZnHbWCaQWMwxoMFMoRO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               "]], 
              PolygonBox[{{9298, 2882, 5053, 8927, 8928}, {8928, 8927, 5052, 
               2881, 9295}, {5109, 2915, 9342, 8940, 8941}, {8941, 8940, 9346,
                2916, 5110}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNWHtwlNUVv5BNSEhgs7vJ7sJuWDZsstk0KpSHSQwBCo4hAuFR2w5IsM5Y
wkCBVgu+QXC0wnQIWERbkEC1oEDrFFBgeNS2QtIWrHQEgmCs8rAUS8tDQgLY
34/fcaZ/fHPvd79zzz3P3zn3iz84Z+Lsrs65812cS8O4Osu5mV7nHkx3LjPD
uUfwPs/jXGdfzTswPhp1bkY356YUOrc55Fwf0NZj/CzTuTqst4NR35Rz1Rj/
nOfchYDoH8O+fThnMZ5KPAd7OncW4xk85TizFjRnsacD8048syBPxCuaBjwj
ejg3DE8DzrsJnnNB/xx4XoVM90CJX/udW4LvW7F+HHw+9GqfB8/3IOsVrJWX
OBfDnhbM78LaLvCpBH0p1u7s5VwC67OSzi3zSE7u3QqaAaAJcB/ObsYzHU9/
6NwGutsx9sW3IaApA89toB+EeQRrn8Am4zN09jHI8w+PZKLsWbBnGO+9o6KP
YnzRL7vRfpfBazf0Kit2bj14VmU7Nzzh3DWvbET7DEtofQTGxlznluOpAf8L
2DcYfPZ0kayNtk5bck4ZqAf19ZgvuJff/x6DXSD34ZjWVthe6rcb6yvB+yHI
l4e9m+HfQz21n+9HY/q+NQz7x0R/Od+5uzPEk3YnPXlyzwHQTIAenT7n/gO6
/fjuhx3uL4COkO8YbFsH3VZ1hy1hj4J06b+3i2LpmtlhKuTJxd43KU+m/E/d
Gc+M5WbY+e0sxSp53Auew2G3hYiHHQHNx2DtUr5kTECGtTnObc+UTPPhl+ng
dwfk2Y5nFOLsT0nFxTugaQbNyULJWQ4+F/O1lgmaMzjvNJ61eD6POFeIPecw
zo0jfmGXX4D3W5CtG+lwRoVX+ZCJ9/E4Kx9rk/zyZyxdenVaDFCfmf1wFs69
WazvBUZzP+QYDb3qMbZBz92wwbchz1S818BHG/yy2TWP7PmvlOajQnpv94jP
F9BrL+ivBGTb1p6y76qU5i9h/G6pZPm5X7p24jmFZw78+B70XRwXRpCGtL8L
Kya6Q54N0P0ZzD/CeXWguQt63QDPcynJMDIkXelr6jYHOm2Evlvh9ydA8y5k
eBzjLNihBet3Q4ZdHtnkvFMcUZ6irvInaYhplI/faN8fZ4gPbbwY9nkIZzzL
XEvJL2NCim/GLPHKQe6fgEdr0Llp+DYJsuVBr6MBYWAOfNGUo/hgHFyPCR9v
YDwcENbVIMYmeIUhxBrGPWPtQr5whPlWiLUCr+LkCRxb3ku2etIve3HO2CaW
TM4QnqSnSR9iwFmc2QA+HWnCue0Y7wGfQxHNj+Gs1+CLXZh/nC+diPuMjxMh
4SrxlfnKvCUOvAyaDIvVFYY5tMvDkHU1eM/wCUeI3ZT5y5ToR4fE433jcxts
lAteg2HDQdi7AzLcDr2rg9LjANbyMY/Ajtmg/U1Y9iFOvGD4syVPNjiXJTs0
emQX4jfzjb6iDCfyxZ/nMN9oz6pe8i1pqMsq5Eg1zgrg+9BizaswVuCpwrwc
4xA8lZi/CNqVJVr3g760WFj9X/h2FWxeYbauhD6jcNZ12KTaePKcAaYv5SJ+
kIZx8lZY899iDAdVN1i7SuLCslRcfh6eo/hPepWTzJNFWcqlj8w/xBTqFcD7
nTnK4eUlmudC5o6UaGpC0od6+fyy5Wqz5yfAuRFY34azMrNUt+ibSYj/lXjP
w94dHs3LcFZhXLGzEXyOeFWDb9V7syFt9kCpeA7H2nth1ccM0E8qVP3vDr1b
worZaFB1k3yIv5y3Wh2lHLQF7UCM/VYP5Thpj1ntpwxHbe/JsOhPhEVzxNb/
CF1GYu82q+dHTObDWeo52G+U58hutCWxn2c12Zkj7VziHH3AGGw1Gch/bqFy
cD58vgCY4sP3athhRrrOIP9NwJtXwaPeyee0yZau8g191A5fdcS0TpsRN4mf
NxBX0+LiU49xVC/x2Y84PFvkXBfIvLhE+lBn1vrjYckwJKjcYw4uhGzPJ6Tf
sBL5lT6dkNQZPOuDmOoJMYI+HpuuHGT+sO6wvhKf2SOxT3uWto3KT8xp1hvu
Y4ykJxXvrJMjihUPjItMW6+AzRqR20vBZwHWp1k/yf5osk99XhHknAyZfgae
v4K+/YFTezBvDQuXKed+fPeA5zrwPxFUXZ2eK/z9aUp4tATjmh5aXwr7f461
V3PUl9woFgYSC/l9vdEQS5nnzPHe+JYBvh+k1HsyH4i9rfn6TqwNWp7UJYXN
rDOkoU6sweyHqSf1LYZej8IXD8DW3ygWvjZab7Y5W/heZn0C5aFOZ6y3I9ax
36k2nst66jzuoU7saYihrEtNpiPHdTY/bnLd6jFiwvNufvUF7dYn0MccScNa
xx6XMcva3mE1ugFyzchVD/OjqO4EvWH/hmzlEuNssGHpIIyD44qXp3DWgJDy
ezDGiqBoGZt/jal+H8T4/WzFLTH3eFA+25LSGTzrEZxZ5ZUcxBTWWfaL7BWJ
KcSW8XaPYY3ke5rFz0XE0piUbDcW45N4/oD5UxhbEuo9MtFrXMX7PsjfLynb
EIf32F2mwXT/CrKewvpNjAOKhSHEYNqN65R1qFe2qvq/vrbSelvOucZ+Js2r
WCTOEGPYuzPuPF59r4M8jZBzXErYQlypsZjhOmOAdo0YNjJHW4yuwe40pCfu
M4YowzDYqg10z5eqbs8wGsbsXpMzzWQgdrEusT8jJtNGtNXBhM6MWj9wOSA7
M1+JTcSoK8jp2pDqFvuFM4Zdp4tkS9r0lh996k82p3SXY9zVwo93AC+GYv2y
T1jH+k/ZFlk9/NpeHImBn4FvDWS5ZPzmGaZRF+In7dy/UH3R6YjybLrJ0Wj9
BfkwHrmXOXXJ9GIcMZ6I+cyfH6SElRP96p1OWc/JPvmM9aWMe8b/75Pq9fl9
CnrnN/Jka95v1to94rTtPWVz5v5am9/srnsdeb2blI/3YbwPukzBt44i9Txj
re/pNJ6U4WmTgbn4l4Rq/kKf7l2810zE2k6P7EP86ZInX7+cUG2jvv8OKM4u
GA3vG7x3RODbT4vE56TJQswlllJeyk3/EH+IodxfaHfqXyJ3XsmUf9kzNZnd
qDP7P9Yg3kfHJ7X3PtjtOwWKx/ex3gYcXoP9m2KyGX1AW03xiYa07DEpE2tu
VlCxxn7ktlL9DynD+HpAtYY1Z1Fc8vKfAf8j8M4Yhrzrw5JzXViYM9H6e+bx
BOsruDbB7q1fsa7xPSQcqLZ7H/FgqM0pO++MX9c5jhsgQyfsmcveOCjZOaf8
o32K7f6Q51qRbFyU1F2a95166HtvSHHA+w1judnyhfce9gbsFXl/Iq4wFxb2
FI6wT2EeF1gufxzRWcynyYWKe/ZuvEOyZtSD/xv95N83Mdb4dP8Yh5jpY5hA
TBqS0HpbkfxTZfnOOGDdZCwRg9lnsHbWZiuueL/jfbHCbNVpdzr6mTnLder/
t5Qw6lBK+3bZXvY4O43/D5OSk/LOtnsr76/xuPbwDk0eaYa3w6PaG6Lv8G09
4nmmT2dW2rmvWey+jnFiUvRh0G+Myaf/jKiWcS/rGfWnHS765H/a4db932KJ
MfPNvurFB2K8ntJZ48BzWUj4/HCpejjWzWcS6jlow/yQ+NG+5MnalWH5sMAn
zG5OqDdlDDzNu5L9z9keUN4x5+j3BvuvRAzkeTy3EfxHY/8w6FODsQV8rkOv
Zoy1tv4O+DyWkM4vlOif2q07MnvbhGKJ8ZuK6g61E/RvByQD/y2xT2Q9IjYN
DCmGPk3pPtdksl0NqM8YyPtFVHpRv2PWE/LuztimbIwBrrGv5Xy+9V3zMLaD
z0zMlydUQ5oN99mjMR+YC+zLaAfaoxP0s7H2Euibwur92AP2L1Ze8b9CY0I8
V2BcmRD9KoxrYtK3JCp8TbN6+mVAuch/MEsS0mtpQv8ciSv5peoXKVOyRDWK
uMr+lrbi/Y01mLamzR9PSG7mcpn5sNn8GCxVjAVKFdOMVcYseXMP5eH/Mv4r
Gws+UwtUN17xqwdiPCWS4tdiNajO/gmwl+TdmP0a/2sOCuluxP9qxICI4UB7
kWTnPxLaYZPJ2WA8Ke9Ru7u1md9qzXdpSfWyGax3Sa0fCOjfLvv1PiXC1Qbr
tXh3Yx1h3HwYEHZeg5znU7pXf4Hxf+GVQUY=
               "]], PolygonBox[CompressedData["
1:eJwtl3101XUdx7/jwnbHJnDvZbsXd/E6vLvbXZo8P+7JkJhD2JiH/gAd5Tkl
BCGVmhgZkFHh6YjnhEiJgWmaYpmAKYcyNcYwhaw8CqagWdqyPAXm2Mbs9fZ9
//ie8/n+Ps/P31/1tdd3rhkWQujlDOf8JRXC0uIQSktDmHphCJ2xEBbzfXc5
+FrwlYZ3cSLc18dD2Aj9g6KvDmEoF0LPyBDmI/Qc8OZ0CGtLQmiGvgHeH2VC
mM59G/gfAt+VDWFNWQiN4OeA/059CCfPC+Ey7pfB34TMJ5CdGQEPum5FXgxD
fw3/6UQIk5MhjB8dQprzZh5bkJcA/xvw/wP/LfgPoS8bCWET8FjkXwXtanx6
BN6HkNkK7U3wzBtnn+W7bB6CPw/PPdx7Od3Qd0K/EFtKOAu4z+X+Ffy/Y1QI
V6L/p3H7fi/ncuQ9S4w+hT+Xc/ZDX3IROonP9fhcNBaepGU9hvx++Ic4jdhX
URRCB7j/VOB/FH50PEZuzoGfAz4Kz0Lwl3Kug/YVvl2Hb03gN2DL7ejbivzD
xCuFb3vx9xDwa8T4x8T2Xs4wbGvj2wfE5lHs/TP+Pg9PE/drkb8ZWVnwRyLO
1xPgn4anWfnhPI7uR6F5d5RrRLVyJ/FfhW9zkD8bXQOF+pG+InjjxKehvJDv
nI9g1cA2eGfkzCsZW7POqXJ7AWcK+o5mHI+p5Od8bDvG/VfcJ3Hfi30NxHxz
sWtCtbE/YdvlQwb6nqxjoRwcyTpmit1JYjQR+h11IZzCt33Q/B78W3nrfhP8
JPC/SDkX0ind/dTLDeQuyrfF+LpkPPKxZQsylnJ/gxjcCH4e+MfhnYJ/K8pc
o7PALSYm28A/yb0S+RuwcUyhvs9g+53kY0+Zc6rcbsS+Y8jejv1v1YTwu1rX
1i7ytRf+AWhmjXaNtHOvAX87vszmPgiuHP3tJc55Cv0XIG829/nQtGLvTfj8
WfTtRuYXua8gPsdHu8amJl0zyqVyfgL+o8gcDr6Ycz74l/KGD+DDOO7PZ9xb
itEAsVqUtC2yUbb248OykbbxLPAV4Ivx5Wl0fAh+Uda2yd924G/w7Vl0T8P+
dcCDMedDNaHaKMO/qnLX88vEryXnWaJ8q/c0gzSLmlSD4Jpzvqvfv03sG8G3
lHsGvp5yTBVb1dRaZkEibl7xiHcu+D78O8v5J/b0TfDsmQF+Us498HEvcKZx
n8yZWe4a2II/UWRuKvWMWkPtxOKmFc/HvVDp/lDPzMq559X7TcTvI/TV1LnW
ThCPLHBF0rWkGuyo9UzWbJYO6foJPn0f+w5Afz/w4qRlaeZo9vwy5VpVzQ6S
r178OTjMNfE17O3JuNfU04eB/wVP7WjHoBd4TNy+y0f5uht5jcjbQX7uh35T
oX5b4e9A3pmY8QH6t8l/bZ1nVxefloG7O+tZqZwoN8XI74D+FPL6kHc241zr
Wz9wFzHsJz41fLsG+BDf3kPWIDKPIDtb69q6G3s/RN858H+VLOLxZfK/I27e
udA/B+2+pGHNcM3yOmhm4f9G7vOx76mE79uRsQtZaXRsANeMzW3Y/j7zuzvi
HlAvTK/0/vo8+InEZwoxjpZ6Rj+nWYzMIs1m9ViNZ6xm7R+hWV7tb8JNQOe7
VXxH5oGoc6bcvV5hvGT8vcYxVWwb0Nectc2yvYX7Au4PM1/GRDzzl5O/Vmxo
Q/ZOaGbgSzrtWat60Cz7LTG4rcg74BngFPY9Ndwz7Crun47Zf+34C+E9HXOu
lXPNrpasbZFNr1V4RmhWHORU419n1r0uetWKdpB20Spq7BJmUQn5uSc4X934
W522LulU7HurHJudxOQk8lOF/aUY/SnjHa9cHEHH6otsg2xRDd6HvNuyzo16
WL08Ep/fiTgmfYqlZl7UNf8etr0K//6Ia2An8jvQ1x+xje1pzxTNFuV4Mrn+
W5V7Tz34ALVzBv6DUfsgX1bGzLuC+1r07015f4nmZeTfkLbvovmqahGanohn
4GzgZZyVJbZhKXBV0rFtw6cl5OcfhfioRlQr/05Y1zvIH4Z9L6Jjf9RvBL0V
HiZGQyOd81uJ/VbkrSQfx5jBL1A769LWp33RQPxbs6595UO10J3wW0g10gJt
F/gryvzmugb4MxM8/zWzK7QryfGA9j069iTd4+p17ayF8FcV6lHzXm8j9bB6
WTkqhX9e3LmVDy/A25f320o7pQ15L2a9C7TjtevVs+pd7cAD2NpV7V6Tj3ck
7ZN80/y7Gd6Ker8VOrGxEngR8reO8o7Wrl7AfUTE39qB9+T9NrgRnlexrztj
WDNJs+kU+Xgy4h55A3jZeL/9NMOuBr4FnZ8r8wzWLNYbVG9RvblnjvObSvtY
M+bnKe9s2auc3EysHsm4F1Rvmv3FtX67q2ZGAK+C/r7zrGMdumYW+k87d3rW
O0W75Tj+bM/7zay3s3KkXPXUebbqzb+KWtkCzVFox8LzPeD1hfeMdDTWeWdr
dz8DzdeB/xuzLvXQrpR3jmaNcryPfNyVt271nHrvlrx59ebW23t1rd/2qtEv
1bomVZuy4buK/1jbojf7F7gfTrgXVINX49+0pN92euPoraN/DP1r6I2xHvoH
Mt5dypFy1ZX3rtfM/BmyL673bNI/Qh2181LGs1gz5zT1WYbNY8pd40vI37G8
d5veTH+Q/wm/9RQjxerinHOt+yU5v8m13yRjoMYzT/3/NjZ9hK4PEp5V2inf
xJ8fxN07+mfSv9P4Os97zac88j85wb5o3l0K/GDGtaGZ8FDGM1+zX/aqNyem
XZvimZR2D6oXtTMHM54Zmh2qt/exZShj20TzCvcrs941skG2LMz7X0k9ol5J
1LuX9E+2nFwcTzke8ucE8Cdy7j3FpB74/9VIDdU=
               "]], 
              PolygonBox[{{8956, 8955, 9780, 3130, 9782}, {9701, 3073, 9703, 
               8929, 8930}, {9362, 2923, 5112, 8959, 8960}, {9293, 2880, 5048,
                8923, 8924}, {9355, 2920, 5111, 8955, 8956}, {8924, 8923, 
               5047, 2879, 9289}, {8930, 8929, 9281, 2876, 5026}, {9367, 2926,
                5115, 8963, 8964}, {8960, 8959, 9784, 3132, 9786}, {8964, 
               8963, 9788, 3134, 9790}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNWHlwVWcV/xISAlney3svyUua4Mty38u9ATokgQQsVSpIA7TTxWWm7Vhq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               "]], PolygonBox[CompressedData["
1:eJwtl3lw1OUZx1/kDpvE7CbZhSzdhGySXY5pCiSAimUKMsHogGj/kI7asaMz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               "]], 
              PolygonBox[{{8095, 2198, 5593, 7118, 7119}, {7119, 7118, 5592, 
               2197, 8092}, {8949, 8948, 9772, 3124, 9774}, {5160, 2944, 9417,
                8968, 8969}, {5028, 5027, 8103, 2203, 8105}, {8969, 8968, 
               9421, 2945, 5161}, {8027, 2166, 8026, 5027, 5028}, {9340, 2914,
                5105, 8948, 8949}, {9696, 3070, 9698, 8925, 8926}, {7203, 
               7202, 8091, 2196, 5589}, {8746, 2620, 8748, 7202, 7203}, {8926,
                8925, 9272, 2873, 5020}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFWHlwlOUdfnNByLWbLNlN2CWb7H7Z7AYCdQTkLoMQap0OjtNqUY4p/cMp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               "]], PolygonBox[CompressedData["
1:eJwtl3twlNUZxk9IgiHX2SS72ZA1m8uXZHeBqCOoCLQKIejYDo7TarVeRvQf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               "]], PolygonBox[CompressedData["
1:eJwtkDFLQlEcxY+CFYZDqEuvfJpPcMmxQdGloD3Upa0PUEuhGOlHEBdpsZKg
oUU0yIaWoG+QoDk61GcoSPpd7hsO97xzzv9/z7upk7Oj06CkGAiB8I6UC0sR
zi9H+gbxLXzgZKVWRDrYkA49qbQujaLSlOwMbLLkHO0B74fvX5BEa6C9oAXS
UhCU4AW0PrMfZCb+vNkzRCvi7ZNJM3sFf4OHmFsBVVdKrEq35MrwChjHpWdw
DE/iLejchrfXpI5ru5t/mGXoxL455yd3zf2Opusjd1zgOTGrG38XbQ+tG7W9
Tf9XtEu0FLklmT/whFZHS6DdkO2BPvdec/+9a3ub/u/kmuQ8ctugBh94dsfS
fwfzHnfM5/HyeP/erT1R
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFl22QlWUZx292YXdBd2P3nD0cOGc5Z88+e/ac48tE0iSspQgrszhiQ4aW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               "]], PolygonBox[CompressedData["
1:eJwtl2lslFUUhi8UmNLSynSm09aZMm2ZThcFJWCCRVyKQJAIigtGBAVRDKCi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               "]], PolygonBox[CompressedData["
1:eJwlkMsuQ1EYRleIW9vEpadCiNJzaSIxkBjwFtIBRiI1Jy5ziZGIEYm2KQPe
wFMYuTxAGRIegImBtXMGK9+3/733f1to7jf2+oAJGZDfGvzIXQKHRZiMYEW/
qu+U4dm7F0llrQB1dXQWxmRQv2RsRO3NwJtsVeF4GDbVj3H4lG/zfEk8D3/e
JWocQ02aGTRKsKtWPc/Jtn7d2I6aybI+zfIcIVeoHXo4t8aF+Z4qcKW/1F+r
3Sm4kba+JR2ZHvJNOe8x9Lph7Mj3D/4t2X9RCnLfD2f+rbiHA3dwm+T7CXt6
1Z8aW4zy3sMMj8ZOjNWjvPcwQ9s6Lemlzuvdu/oPp7E0bg==
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1lltsVFUUhjcFWigFmc50GJgpM0xnDjMQgQSE4INKFQQEhMqlgYCVq0EC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               "]], PolygonBox[CompressedData["
1:eJwtlltsVFUUhjcFaRkKMpcOAz0wQzsztKBEEaw8KcaGi1QERUCFIHILEvBF
uSYqMYhRIigomniJQCBQaEQgRoMIiBViaEsa0fgmUNFIAgSEiAl+f/552Mna
Z93X+tfaZ8jcZVOXloUQdnB6cAo1IeztHsKYniEUoRO5EK5UhNAT5ulMCL0K
IRxDriUWQgz6Ds4+6K4+2KgLYX3WurLxU1UIgxKWF387/Nv5EI4G6wR0B8M/
DnkR/k74k/E5Hd4MzuPQV7H3G/5nl4dwPhlCLfr39Q7hH84p7PctOBbp70J/
XmRZ6aTSITzFKRL7Or5NKoZQTT7TiO8rkh4IPTtnnmSmIzsS+/dyVmJrFWck
38p6hfAKMs3Yvo2/rcExBuy9Wx9CZ98Qvue+CfrJQdQE+5ewvyFlG7I1Cpuj
OUsi11L+L5LPl+T3ObEeoV63q0PYw7eNZb7/y30bOgXkT/GtP/YaqEkjvoYT
T/fINmW7je/tnLFx8+vh30J/UW0IJ7hvqQyhg1xGINtA7VZQrwZk/6u2rHRk
+0KVfT9EDgeIrRn5l5Efh/4M9J/D5yzkfyXmJPcY97HB/e4N3Y9cl2N7FDpD
0V1Y69rc4lsrvA78tXMewPcYzmLoj9Fdhr1J+GvExmXuu8m3jVqsgF+Gv+vY
209sNfTrFrK9qckOZFs4r5a7R+rVlBpjRz2aBW9xjestTLwAfQOfTfDWEE//
OtdAtRiN/TriPajeQ08g32ew9xH3WvRPEk8qZQzKlmYiTixNJXvvI38TPIxI
O7Z5yOTh7yOnoeWW2Qu9Af11wgb6b3M/j/45TjmxVXBWZ90PYWAV9JSiY1FM
B4jl66x5kvkGein1+VTziv0l0BPB4FFku7hPgB7IfE1E/1HONGydQqYF+Tew
8V7SGBQWbxLPYOJ9LOteqCdnkO2i5tsrnMMN7n9w31FhfOxiH7Ty7QfOZvS2
cN7KOjfluBHbuyLXYzfx7Iy8A7QLNP9ziKcP83J3D++EGPRyarE65p7uQ/7O
lGdP/b0r55nX7GvHfID/ZZFrLUwMgd9RMFaEmeXENYx+XK/wzLdnjCHxr3Ha
kD1TsD3tlBrqOxP5PL7mIH8V+QOR+6+YXtduTHr23sTmWnI9VutaPwz/OPSf
WWO3EZm/sq6ZaqeaqXbPpt0L9eQJ7SP6Mwm6iTOz6B6Jv4Z4DhPPAnIq9nKN
yqnPySr7VgxlxJauM5a1gzbS71lp25LN6di6FHetlKNyHRs5trPYuER8XaX+
a0YWwRtCjg0xz3QPzRb3lTH3YC/3bpF9a19o1wxPGzuqbwf1+hEfrQVjWthe
x7dR8F5CZib+vqj2rpD9FuhC3rtCO+N+5B+scS01L5ot7UTtI2G+mVh/Lu0L
4b0T+ve4aX1bmzHGhDXF/Bq2zlabrxn5BXplaZ8onoPUckHBu1ozsxD6UNa9
Us92429uznjQGzEALCZS3gXChLCxKelZ0kydwPYjRfO1sxuhW/PGuvB9Anp8
0btc780E6Pa83y+9kaehh+Vca+VQD30hbqwKs8J2JmFsah83oZ+oK+1y+Pdo
38ZLuw8b88m/rOi3SpjsBv133LVXj3Pwt2Y8q4r/Q+g+CfvWzHZyP0pO33FO
U6s2TpRwLsLjtYx3una73hi9NVUp56f8PyGezrR3o3bIQWr7bd7YFsY1C/V5
717loFyEEfVGPVqVdI90F4bWZ/ym621XfnqLtBO0G7Qv+uH7xdI+0Mxr9i9n
/VapJuMivzl6e/TG662vTBi7kh+ArcOl/aiavIP/c0n7kk/9i+hNUi0zxF9O
PY9ExoYwot1xM+7dqDd9v+a/6Le3EZ1tCfuQL8Wo3aU3Vb1UT6+Q32d5Y0M1
TKfcY/H1Bu/J+x9L+1N46Q4eLmesK//Cqv6h9C8kTD2P7tM510Z4nYqveNqx
CxP61zoUuVfCbDLlfyjp65+sUv96kXutHTQfWwPIYXyl3yS9TTszzlczo9nR
mymeZCbD/x/Dmm6B
               "]], PolygonBox[CompressedData["
1:eJwtkM1KAmEYhQ9F2i9UY1mNYNo0RJuCDG8h+pGQCGsZtc1dErSLkKg2pdCu
K2hVtE03mQU6VnolQduej8/Fw3nnfO/vJA7y2eMeSdPQB9WYVIGjWckfkA7R
PV/aGpb2fftmcsYWpMKINIq+uVIN4kkpPSgl0BA5YXiekJ4gF5dSIak4Jblz
0gzs0m+Tvjl00ZNWh6SyI31Q/wllakpwB0WWvHWsb95LxCnyfer6+Q6bmfDQ
K10wozEv/fIeoC38L3gk9wQvFpHGme/AC94pXhxvku8oBOx70y9dMbfCXVXX
5pqaDLuusfO2b+8zd56Td0l+nbo685bpF6FvjfgdmvgN6BD/8faDfnfjNtpm
tw5s0CdPnwwaMLMFAX4T7rk3Tf6SZ28xN0U9O6vg2HrTx8NbwbvGeyU+I05G
7P92u/eZO7Psv84dO+g/0i5I6g==
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlmlsVFUUxy+F0m0Ah+m0AzMww/S9SVGiCQaBTygIiopQAoQixkhUwLAJ
GhBZRMUNFCmgEVBBdtsimAomWioRbFlCwe2bC1CiBQyxGMElwd8/5354Oeed
d+7Zz/++ftPmjp+T55z7maczz4qEcwO7Ojc67dyMpHNDkH0dOjcu69wVFMZC
3w2cm1fi3CbojZRzjeisjjpXWmryjcircs4dQt6rp3MPFTg3sxj7XZybi/4e
yTPOLcXWQuRLoI9nTWc6dlZytgY7E7DXo9K5rfhNY9OFJr8BvxH5iIhzZdgv
R28B8m3Ib4JvIaEB2K/kfTDHBmNzdQy7yH/Az7Pwy+GPwA8MLMeh6NyH35HY
3Izt0Z6/N2fv4svx9QDvo+AnlTk3Jme5J5DvIK8l5JnF70TkTch7I4/6eKYi
b6W2E6htCfISctlAzJP5/mFg8W+HFnt5ETQPm7XkfiyODs/MQueG0ZdUhXP1
1Oo6+n/xfImvNcR/gnxqkN+M7DT8OvhB8FfpY47Y5nN2DbnH4RuRre3v3Pfd
OQOtJp9K+tOEzy+SpuOw8VjG7B9G3srZe5CPTFm/lXsb9n8NrNdvaAaIrRa/
7ciasZNAP0r9stiqI5c6ZLcFFptiTPIMgu8N7Yuvaej/hp9cYLkoJ/VJ/VqE
/C583ImvTsRwytezJ+fGkts86lMFPePn9n74BPHUYecK9n4PrC9vYqMSm3uJ
5yC6K7FzO3YKkWV4hsBfRmch/pbh9xtko3I2b5q7bvRsKXFOwu+JhM11lvqd
gS+CvwX+I86u4ewBYjicNF+n6WE9cfdD53lsFvdx7n3sdINeK7Tcdb4ZH7Oh
04l9V8p87YZOyFku5cirSu1sCWdbmJUOZuYYtD1h9scQQ3tfi38BsWxj5laT
1zVsHA2t/ic1LwnLd4X2vcL8yv/knM1YEtl68u4csW+aA81DNd8j2Hkbv7vR
X8z5leTwHPRv8q0ktuvQ7Unr1wLk/3h5LfH86+Xq56HQet1MPAV+5tPwefTr
DnQ+4/uZMvOvGHcQ8zBivhSab8XQPbQ8le9x+B3I1yHPh1+RtRqqliN9H++G
7vQ7G6GWb7EDjfgt41xtYLOt/W72O5WPrMHPubCtwGNLE/Yb/Vxp71UX1SdJ
vRd7nKkm92d8bOrJCHSGE8PwnPVkva9t0u91E/bKMjbbwowLnD3I2TiyNs93
pG0ONA8H0I/5vauHL8jZnmpfJ5ZaHbqElqvwVvjbOTS56nSSuVxF715NG74L
56PUe1zObMr2FI8PnZi36lKreTdsrPK4OjRteCHcOERv/wwsF2HVI8RdUeTc
oxmbA/X9UtQwV3uqfRUuCB9OEMunnhdm6B7SfbScOnyMPIr9/UnDO9W5K/G0
xm2/tGea03xfzyO8l6P/VdL2QXuxn56fjdmdVJgx2itiOX+CnS3QReg34Hcb
NbkQN+wUr33ekDZME7bN4rlBbHOg7yQs5uPoP5U23T34ycuafgs6P0VtnjNR
mwnNxsucG1Bme7+V2P7wWF2etTyUj+byYmh8OzQVWJwRenc+bt8HZe1d8qex
8UrC7s0GvvfLWM919x71NVkbM1zTTJ4K7T6WTqSn4YLwoTiwu189OkvMr8Ws
/vuwsY/4t1CTc3GbRc3k+ZjdJ/k+5kuBzacwuCNh86N7Rnez7sQezNF7Kctd
NZgfs3rOxn5raLmoJ7oPhI2z0L0Q2EzqnhEuqJ6q60sew19MGOaq/rvgO/l/
Bv1TCN+l04b+k/o/YCZnQH/sbvuiGXjQz4lw9AX/L3QO/Za44dJOYvsutHnT
3E31uVxO2L0iHLhKjOs9ri5L2yNeWFsTs3nQHOlfRLvzrXqasTugT8ZmSLNU
IfzzMxPC/5eyGmoXyysNA69Fbfdk5/WY4ZFw6Rfk0Yz1RZihedJc6V9Ad5Xu
rCewNx4+TR2mZOz+Fr5dDOyfSXZuha/w+rrrNvW3em2Gfu7vNd2lx3x9hN8P
p2yvqpAX5Wy/CoW3HreF3/XE/AH57oX+D65zdJc=
               "]], PolygonBox[CompressedData["
1:eJwtlmlslFUUhi8t0HbaKl/LDIMzOO10praaSIIpmpgoQZYYN0BAlJggiSBC
EXEBGxBRW6KAQFkSN3arWBBIUNRYMFEMEYIh6k8TERrDYlA0gFvweX2/Hzdz
zneWe5b3nDv105+YMLckhLCd05czuCaEA/yerA5hY1MIyboQ9qMwsX8IKeiz
UQgjkLckQsjkOeh/Dt+L/lb0J6OzuCyEepzdmwrhWDGE57HfXBrCN9AduRDa
OevTIWzgVNbY96/lIQzAdhmy5dARPl6pDaHIt3/L7bN6IDFwRw++bsdmEHRX
JoTuUse0Hfoa/B2EPkU8m5GfL4SwM2F+C/xl+F0Jx7sN/gI2jfgexbfh5FNE
Phz7TvhG6HPEeJj4cxUhTCWW61KOVTEfQ1bOt6nYl5JvA7JLkWPbhM6unHOS
/nR0ZmdDuAGdir7mr0U2Pm/78+QwDvpE0rby0ZV2zIpdOf1CPJua3Bv16OeC
c1Au6sFF+CXYDMN2Hj7u4/5XqWE78e/E/4fkeor4bkJ+oZK86MfMhhBaiadf
FbnCH+L+dmybiOlP9N/F3yrst/FtH/4q0FmP7SfcuQZf5zi34K8D+aKca654
VfOJjSG8lPZ985Hfn7NOR9zf3fgfEbn26sFvGfdAvO7/C/6nyPm0YjMW26+S
tted6/DdkjceSon/TNGYVX268TGO+/sMwRf59VCfK9R/JN9GojuPHF6nXmPh
R8E/Bb8VPgV+7qjyN8muHuj+C8+7sB+EfDSyMZy7kJ8u+u51nIvwk1OWSedO
+Gbiu5VYBpHPIfJpicwn4T+Dn5TyXbpzdKNnSP0URqfA58HIInR3EH899O6k
e6eavkz+VQMt14xoVi5hs6K/e3oc3/Nzrq16+CT0bvWo3Pz7YOMxbJrA9kZ0
xuNrIfcf4f613H+I3G6kJjcH80OhX8NmJWcFflZyvi0aXx/Qg++gt2SNb8W7
GXoB/r6uto8m7E8X3Bv1SFieST1mJTwDD6M/PetZ0rdHqd1savQ4527uuofT
r+DZ1IyWQPdkXEvVVLVOFByr7ivTrCc9C8LQi9Qrl/e+EH7q8p5JzeIldLLU
opocNlDfT4lvCvH1hV8b4/0B+D0ZY1cYFBYPxPfPgt8Kf7LW+1I5KJeF8Evi
/ZclntXk+3G1650Am09nLNOOfAbdacgfJP6x2knYNxQ8u6rxCuRni94NwvxJ
7mvF/ko8H93w+zPuhfSXo5/Ne1drP/6d8QxqFmUzH/mepHnhqT3tGWuN5XPQ
74xcC9WkirujlHeV4isDaweznq8GMDSN+kXUKF3m/gyPnIN0f7gqhDeb6V+j
7QeD9wro8kbT6v8J4nmkzr7k8x9sv8h4dtRfzc6aWvNziHEMsc6N81cOymVv
1rOqmY3A86mCZ1+Y64W+LedeqWer8HU443jlrwv7PlnXShgpybqmrTF+llKf
RdRzQcIz15U1xoV1fVuc9w7VLv2efNc026d8K+YvM45ZvO7s5P7qIcaCZnAa
tX02nhdh/AC+umu9C7WT27DNkcOWUmPqOWSTmoynTvrTB/3r4/mQD83ee1m/
ndoPQ/FfU+e3SxiNoE9ofwfPvGa/JZ4f8W3wP0aeJflTbL8X/BZpP/0Bfabg
t0j7/iz0jHh+5b+X+OoiY0H5llCfdI37of5eoJ7bCt692oHahW8UvJu1o8fD
V8b1UY7K9YW8+6uclua9c7V7tfNGDmafkNMMThl25Zwdtd512nl7qN9bzcai
MCgsHoz/DyinHuiOtGurGi+DfqjOb7/wNAA8fRT/n1DO+1TrZvda87gaem+8
H/Qf5mjSNVfthZd3tA/iedcdbcQ2Op4PzfwE8lma824S/g4nvXO0e/TmVtLf
3qTfYu10/Xdpi/e1ejhMucT79X/MF/xGy147rBT7KwVjRfXULhpS592nnf02
sRxF5wgnqbeQU1VjfEt+nHrMifel/tPov9DljPGpN1tv+X8ebWrg
               "]], PolygonBox[CompressedData["
1:eJwlkD0vg2EUhu+QUq3U4G1JVdp6+zb+gMREojSiNbQhIQaNiI9KaGIwSGxF
Qg2kDAYGI+0PEGIxUIO/wM4gYSOuJ+9w5Twf59znPie+sJFfb5IUBg9cJaRN
v9RlSQFb6oBnR9ohaatTanB+gdNuqQr7UenAK+0R/eT6YDQppdqlNPGTnA/I
haQR3lK8vQelS2rq1Hz3SD9Q4XwIr/zVmqVb3oa5r5I3RKzQ+wjuI9IdFGKS
3SbNE6fweoxn4StG/7jtahrtGrUXaLyhm6F3Gg/ZpKthtEyuqfFQe4LGNFrh
PmnAJ0WIv2j8wTl7KfFvWe6MZtaWXumBtot4WIJlaNDnGv9nzFym9y445CYg
YPaGxqzl7tXsdxwvY3iaIM5RH2WmfMjdmdmd6W08bKNTZo5H9HOcS5xvOBf5
W4MZNKto+xy3l+kZwnMQnnj74q9O/iS1WcjAIN5XqPUyRysU6NtP/yI+/gFF
GEhB
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlVtslVUQhUfE3i+Uc1oO/KfpafufpmjUiKKJD1ZpFQVLECmiPiAGr0QI
DVGq1qQBuUrRxBsUURQaWk1EoqilISYUIeCLJkaNV1AUaKEQFDHR6jeu/XCy
58y/9uw1s9fMrr5/8axFo8zsML+L+d1Qa/YDjpV1Zk1ps1fw3Vdmttr/jzbr
rDA7FZs9V2i2td7sziqzdvDLU2Yz+b8p1+wf9h1JmO3Gn8e+o8Euzpgt5NsO
Yo7BPhuZNWDfSPyFVbJPug3+cuJ/kgU33uxmzn2ecx8n/in8P4EZqTa7tICz
qsXD+QzD63XstdgnsNuLzRrB3E7cwqz438X3Y3xbA+YX1v3lZj0kPgKXHZzb
Cc8FcBlVY3YZezOcdYZvWfIaZv0UfC/4ndg7q+TvYd9T4Nuwt5DfMWpRxVm3
wbk/K859rOfrxOUE9kA4t4s486hFP/697L01Kf7H4TYX/wH4HCded1oxn+ac
t8hhA5gLYLoD51PEnJ5UHU7jH12k3P3bMvBn8B8hl9xYtS1gvalA/PvhcTIr
/GTiv5hSjp5rQ5lwk/BX8Lsau5x1IKuY+1hb4Bnlm81m/S0Wf7+HVnLbQpxC
7O6UzjlCzBUp+d/FbqaGIzncOdhi9m7Gnw++IyX7bTDL4NBHfc5Sg95I3Crh
MCOpOvzJvpakdFuNfucE27V8N/aP2FnsSnCTwC+t19nOoSKW/lx7F4g9yP91
YE6yDgV7WlKa8Fp6vddjJ6lbZ0I6dj0XjqV2xJmMvY84f7C3k73N7P016G0q
dl+kvR+z/h4w52Ll43ltjaRF18aEGnF1zhkw09BPL/UvJZdbsHuwC2vVV95f
h6hZqlr5ltA3G2PVbUqdtOj66aWGa+C9Aswq8qjHn4v/pbT05zqcDn49/vlo
aDn2rEh5XQ/+1dC/S8m1tk7nen83ZaT/fHJsh/eT2G+A/RIOe8CvAX9PuAvn
+GbwTyXGlPHqC++PazljLHt3RepV79nRWe13/Nfsy+WswTyznIzu2+96NrEb
2T8PLZ2mDnPrNTeK2Tst5O59+W2sHNcRL4V9FbUtAbsxzCKfQ6tDfa7Abkuo
/lWxtOiafAzsqqDJz/GXJNWn3q/nY2nSezS/0uw1cpnJ9yeIdR3cNqSkY9/r
MfaHPvIe7Sb+RuIf9JnAvnN5upslCc3YvdQ1G2ZCETFbg99n8N4wZ3xG+v15
juPQ5AeR6rkW7GdgzoE5xDoh5O41SAcN+2zeHji0RLobr3kFcSYGnWwC81BG
eeWQXzrEWUb8iow4l7P+XK4ZNJjVe+DvwiLivR/4+D1HNarJYJlq/b8mE5oR
PivOR9Kca+87MF0T9R75u+TvkGujtFLzwu9lAfh7M9LAUEo973qbS63GweXK
Iu13Hs6nMake8HNfTmlO+Uwoi9Xb3qcNfO8P+vf+Lg537fcwplb9+D34Mvwd
4N9Li4fzeYc8dqbl38V6kP+rqU9HlfTtdYipwd+hPvOJmV8nrpew1pLjEPg8
/CvhUwJmeyQNed3aiHM6zO1riPNFrJlQBK+HI81Vn68Lg30H9rGEtPVgWjjH
fxVLW66lxXyfwblp5vkcP5c9a+FwuFwzwjXgWvC78Ts6iv+BtGImwA+nVP9n
ifcv/i78F3kfpDUfKsEsIWYHMVtZ/wqzzt9hf+/9bcqDz0AkHXpP+BzxebKV
tSApuzmjGnmtNqOLpqTOMs56JqW9ruVtkerWzfpNrPvye3sh1ND78tGg57xK
zV+fwwfYuyihuj2Cbze/BJiPIr3xnovPvNKggW3Ezgl84jrNIK+D63FPmPn+
bqxLKM6Hkc7zc72fCsNddBHnP3lOWkY=
               "]], PolygonBox[CompressedData["
1:eJwtlmto1XUYx5/NuftmZ9dT/7N2PJ5zON0ITIl6I6UFjSSdbpUEoyLRFyXq
lKzmJdeamy0qsHYrMl1tFKywqTkSUnJEEQVRUWmzm+7ihdFFCOvz9fm/eNjz
O8/9+1z+m/vIuvonss1sD5QDrSs3a+GHvllmJUmz+gqz5VBRjVkxtDYwu5xr
drHIbKjS7LmEWRPvj7B9MmL2fsxsR55ZUGC2tMosHx83oXsOehv973gfQXeo
0Ox7+JX4Pkm8h4vxleZv3KwH+1F0muAX4n8xujnIf8H+s6jZCPpT+WYFyIux
P8G7luQHiP0rPncR60CJ2W7yyUVnEt0mfD6GfEut2a3kO0h9x/H3CbQDeQr5
BWrbTP2boLPXmk1AN1LDJeRbkPdjnx/32MphHL3Sq81Owd9F/KvgSzLkBDXj
axP0IzkspJbrqeHyXLMZ8usivxHy60I2jc4ouXTh4x385YJxP7EOIn8ReUnK
fSvGg9TaGXFshNEy4nyVdOwH8f81fFEZfnjnYfMlWDVH/K38nwbLN6nhqTyv
SbU9T8xWfA+RwxC5rI45VsIsgfxY4Pl3C6/Ae67eX4COk9unKX9rJtYgHwtc
9wbyySbeZMTxfhZ/G8H+26TnOk59veRfVebzoHdPxjG7gl259+JYpdvKx0vU
cz7wXt2Bj0X4Pkz8Q9BJ+FPQdnS2QfcRaxlUE/fahUEMfj/2pXnuU75zsF2S
4zPYAL4LwnlrIZ8o+azFZk3cd0C78EE433HmewX4nK70/imnYeJVl3l/TmPf
p/qo93XkM2D0ObF2pn3WFa8Rf63YdOR7D9qp92jKd0U7k4dtW9p1lWM7/GC5
x9LMrsd2HvkmoHep6z0oTU43478aykW/oMLrV79rqWM84r1Tz9Q79URYCJN9
2A8HPgvKZxexfkr6rqqefup5JuG7phlqEVYVPosp8HgU/48Hfjt0QzZgPxDi
3U6MsUrPQbnIvhDbOuLfU+s9U++uSfhuqt8BfCX6M+H+/oa/npjPtvr5GvxU
1O+P+vEQunemfR/022L4DmzKsF2Nj9uIsz/qu6aeDcD3XedYvYpNL3xDOL+a
+Xr4DHhtpvb54FWT9J1SfOVURbwJfutE9iE6L6A7mfJbpRiKtS/ETzO+V/cu
47utHS+o8R2/suv4+Av5FymfFc3MhsBvhG7Fbn6bRv4Pvy0yx+gS/IpMeEuQ
/4l8fsJ3Q/XptmR43867gnhHeDei3wBlESdbs5Z03/IhX72B+1aM7sB3VLup
/L9Bd1WV91o9/zfmOyu5dvrutN94ze80NJryHdDsCIO6tM+Q3tqRH/C3jZ5s
hV4Gq1eifnN1ezfSt2Yomfb+6N7Og/876VgJM2GpmVM+veSzhHmqpt5bCj3/
i+RfHvfZUc8y5B4J91HzuR7/Y+ifgGbzey5kNe5L34/l+J9OeS91E86l/Buo
b6EwFJZn+e1ec/kE/NK4z7Z2pI54Z/DZEc5HfcZJvGZmCtnOqOeinFrhsxJ+
OzWDW3n3hvdSM90Nf0g1hfP8BlgfDry36vECZmUWOtlJv4m6jT9HvBfqiW6L
bpZ2RftxPuo1zw5tZKtvpmoXBv/FfKekr5sXAd/apO+CdmJOxmMqtnIaIZc9
Ub8dumlt9HV7re++bkAbeDfiL1bg3+ySCt8Z4SGM/sD3majLpHM/unNq/Pbp
+7cK/YmI91Y9rgKrgyEeykGzrp4pf/0P8Lv6mfBvr/Z5FN2Vcf/fRPUMU99Q
zHulmKX4P4rOx9BesH2r0jEW1rohBwK/IXorZif1ZIXzohnUbjxQ4bkq5yLw
zk/77GqGC+D/B022VeY=
               "]], PolygonBox[CompressedData["
1:eJwtkTkvhFEUhl8jjBlLwiyWGcwqQhT4AUpbMCSiprIkI0FBg0lIGFuCkoZO
KDVTkFhCGH+BSmELyUyhIZ4vV/Hknu8s733P/YIjkwNxm6QayIOHkJQGZ0Rq
KpQmXFK7W1olfibnDkseGApIfofU65VeKqRXuGbuCmaZaaa/in5bVMqB5Tpp
uEjaoP+pVHqEADQ6qTNz45GOcqVddOZrpQXwkG+lXs6Z8UlZ+AlKDeRE7ozv
c4jhb98ujeNpFMYgxZ0feDjjvKH3NmR8W/5f8JWk1sHcJfUv4uuo2dva/xgv
e3hJ4KUTH1215m7LwxRxokC6oGeGPafhjtkMGg9R8w7We/Swp4/3GcTLIb0H
0MasG58pdNL03EOIvjf07PRFuLuM+in1EHEYevC4iXYWz368V/9jxd/ktqj1
0hNDuw/64TdfiuNrB/1tSJBb4Y5FzhO0j+EeP0lyS+Qq0aqAT/TW0etGL0Dc
QjznMv/U+rcl9ea/+qkVERdDF71r5N4iRsPScrDLO9phr9nR2vUP/g1ZDA==

               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlX1o1WUUx49ube1Fbd575x33brve3V0GC5yxJMQ0m2Kpq7XN+iORWDhZ
6dxsm9aWSm4zSnuhrGyFRMRerIiKyqCilILIPyp6cSr1h9Qw3SoWUSD0+Xae
P34839/5nec853zP9zm/xW07mzvnmtn7PDk8ByJmRflmLybMGmt4LzL7NmPW
zbth/7XCrA2ff/LMWrAtqTSr59Nkidn92PsJdjpt1pxwn02sLyTNdisma3fW
bGWu2VCp2Ucx/K8220qMDvZsxmdL0h/hopRZHzHngHuJ8zL5DJPPefL5JeNx
7sC2N262lLPmEGND1OwsOZRVmW0MuA58G/gcuBx8C3gSHAOvBZ8B14IniTlE
/JtkC/hH1tvD3uvxySP/qzg3S/6HOHcZ53aRf3vWuVqBbwvPefyX4z/It2vI
/w3y30pdo3CVR12nqH2Q2h+s9FyV5/qoc604ildf4tyeYG+c2sZo0HPgT9k7
Cn4K/FnAs+DVUefnXMbrVM6N2BbwvgR7l/gj5gliTpNLKzVkqGUWfDzheb7J
2kx+n7P3AvWtwn8l/jPYvyPOIHFGarz36u8K8n8r6TFb2VcY9b2V4KKAFW8c
/wXEr8V/OfgIOb9E7mMp70VRGfXzrRNOXsf+ROB2B7bfwFvAj8BBDs8Ie+8m
xuPkfzP5XyGvQ+AGcH612dNx5+okcY4lHIu/S+CPwRewv8rzPPiThPdVXPXD
eUfKe9dE7tuzrg1p5JXgvw7/Kux1xXDH+hjnrubcfzOue+n/JDmcrvb70hNx
rUurueVoOOa1i4Nh7Kuw/5FxrejcfcSciHmNHfg8kHD996nvxJyB/3G+78n6
uTp/IOs8iI/9WedBfPyVcZ8W+jWfGvYSZ4JeFZS7fyv2pfR3WaFZRdq5UI1X
FptNhZ5KL9KWNBbDp4rnBvwzadeB9PAD5zwacf1I73VBz7vJZSbpGpPWZuKO
W8BtCa9R/TxV7Vh1N7F/gL378f0m3IWvWUvwyxB/mn1Phnu0i9zyoj5bjmIr
LnM+xatmh2bIPUmfC5oPP+F/OeFxrsP2XsLvl+7ZmjAH7mXfmQrv4zZqmia3
PHp9udq1Kw2Psu9Sxs9qhoOJoO2D+P9c4flvB/8eeNMdHeb9gOoixuGE36nN
lT53dG4XXA0Fnyrst4YZpfuhPbI/AyfNYbZIp//nCm7ANrfa+34n+ayl/oUF
vPP9rpTfnSn2Hk34bB/RPME+y11blPLzFH+Q87/CrwX/Auw51Hgt/OexNhH3
nXloDK5K0343L4I/DJrRfRpPusaOs25kfyk5bEj5jJb+Dd1dDHdZeb0b5sCx
mOet/IvL/V32D/jeEf4p6klDpfexnxj7wAfJ/wt8Hw7zX9/zU56/6tDsUJ6a
07vC/0v3siD4fIm9M+L9ku50H3Qv/qbe+wrdRzpbE3Sif91YxPUjHVWGOVkA
/1NhTtaW+JzVvF1InB0hvnTRD299xO0p8fkhfepfcjjMLvVwPXgRvDWmfH5p
dr3GWe0R70UuMXvVL2rvYd0U+itepUVpcgqfsxn/F+ifqf+ctLQu6ndGNT1L
j26M+v39PuMzQrNiGlxDDn8SP5Lyu6o7+3bS//3icCf5PBT3vmsuxmt8rtZT
X3fEay8hzh7OGqDeobRrXfyIp3n496Kl+aztaed6m7iJe981I/vCf0pz6D94
gSnZ
               "]], PolygonBox[CompressedData["
1:eJw1lm1olmUUx09t7f3Fu+fZfNazuWfP7j0pRWXJigJHufAtZ2hWZEQNzdZq
m7UXcXNKe5XIl961D31JNpUiJkQzzSSTCvpY1JwEESE2thQjCrR+f87dhwPX
uc+5zvlf/3Ouc901ze3r2q43s9eRbGRelVkp8kTcbCNyKm32OdIeM+tAxpLY
c83qC8wWB2YNtWZLkeGM2QiyD/tYFt+I9RrrVcQ4R4IGgs+EZr8mzM6iz883
a0qZjZfhj5yoMzuJFCw0y0c2sXcz8inyFvGWEO8T1mvLzarY+1SO2e/EWs63
dyJ7I+sV1WZteWZ95HgRvKvJUY5/P5gPV5otQ78x3zEUgu0sZ/sKuQlsSSQf
yQsdk7BNsx4uNDtWTG5wBei3o3eiF6J3kfM6YnehF6M/nnJ8yldC/Ca+TWAb
Ys8Ue+c4Y04RnIJ5hr1vgmkM7JfBHGfveTidRq7VmP2L3MX6HrieR7yj+N8J
1jDX+W3A1kX8TiRF7BpkL/zsKfcaqpYt7Hkvy/log49Z8k2yN6Qec6xDfGfJ
vR4+v4PPA3zrIX43ObeTqyrttVbNjxBrNzUezXgO5fqC88xxtl7itxK/OOXx
nsT/F/RvEx5b32SbxH8G/1uRLPB+hn4c+Zo83yA5KedDe3JT3oPqxQRcVCCP
pBy/6r8h5Zjl+zwYn2X/lphjEabTxL24wOzBPK9RN7ZDnGEcPgbwGUafT4wr
eX7mHPLsSkRc8W0VvdQd1Vcxtpe5aG1824qtM+ZrfVOuoALekX1wsx8J4eoO
6n0DfOewnk16/XrxP0mskZhz+wz6beTrDJx74XmXWnyU9NrLfqDMa6xaq2fV
u4PEHEAeBftjyIWEc6MeVC8ejOqpMy4Cz3Npx6L6tLDeGPWHOGsBywJiV4Xe
U+qtg9gL8e1n/ynyv/0/f+hd4D1S6b2uO7aS+EX03DLinyfeOvBMVHqvqWYf
s/6Z8y3O8R5QL8yS6/5snxGr8f8L/QH0afQm9B3kGMnzeg2B7+bA75pq8nLS
76DuomrwEvrTlX429Zt6+1Los0fxH4r7jDkR9Zx6Lxu8S7FPYV+JfRv5BvP8
zAPk+yfCJzxrsR+Nzit+NYvqAs+vmVCKr0XxfsK/Me49q94toSdKkRJ8ikOf
cZp14lTc1sPJHmrXWu268h/gPNfIdxVpo8btGe8R9YJ6YjQWxYx6Tr13NeJP
/K8n/8NxX+tbPth2ZlxXjXaxHow5t6rp+0mf4cPRHddd1x0Wn+rhWvTejHOh
eH2s18RdF0d/kvtCxLf4XIFtSdpnnWbeLHxPJn1Wa2YfT/rM1exNIBWh97jO
pztxWPWt8FiKWcR6edx1cfwb/j0Zr63yb2PdkXHuZd/Keoj8fQXRvIPfD8q8
99SDO9Dnkj5L9Wb9obsQ9bt64Ay+98H3vdU+kzWb25Pea6q5an8x8NqpZqpd
LOWzXDNsM3Vbk/K3Tu9NAdjL0p5Le8pZfxjdb834WvTehGNrJUYj8TZg/zvS
D4Hn1cDfIr1J5zj/3fjUIxP4HUu6j3wVo59YV6L7Jw6G0x5TdsVspra7A3+f
Bon3PfEWoS8MfAZoFujN19uvnlXvdlQ7dp3hNLleSfu80f3uDnwGaRbpn0D/
Bi/EfJ5qxjSDb0vaZ7X42Qu2y8glZIS9o8hU4P2hN78b/F/W+WzS/jOse6p9
9qhf92PPDv0tUU1V21sCr6dmbECuH0N/e3VGnXVTtc9e2cfBlh/32uifoJFa
/RA6F/LX2/1Gwu+HZtBO9v4HnbIypQ==
               "]], PolygonBox[CompressedData["
1:eJwlkbsvg1EYxp+41K0VpariUqVuicQgQaiEIEHc4k+Q1iRtJO5laqlFWLAI
YSASE2ZsGFnEYGSThlgMxe/kG34573fey3me9/NNRibCaZIqIRNCZVIQzoul
cLY04JXGGqRLhzTOmSqXfmG9WlrJlRad0iffX3BJ3wX4ybWTayEXoj/KnCDn
SZF0CgHiH5s0QW0HcSdse6QtWCKOU7/otWpNz0etZLNLSU5njVQAr3405Ek9
LmmDdxLwyF2MuxF0BlxW/MSdnXoHROrwBL3kXjA9TVyJ1la0VnAeoecYDvFy
AH1VUmGO1O+27k3+jr0k0LeKvgd67sHGG028NYXWUXpK6Bmi5w0/79DNe2vk
X/yWduOhlNgD+WidY7f16N/lzR1opPebNzzM+vOxb0jBXrq07LG8GE/P9MeZ
28V8F7Vf9DS4rRlm1hlak+Rv2Vs2tTmwz90Oc67w0oqHNsgi35shbdIbYydx
mOU+xrwFr/VfzP8ppL+ZeTP4vMb3DSzDPPuLVls7M7szno33Qea52cUw2v4B
MzNW+A==
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlm1M1XUUx8+Uh5tctMv9Y5f+V7hc7r1ckoplm4Xo1HTUMnD5wpohRoBQ
lvgQ4lUKEHschssgmQtn9MDYbM7a2NCVL2rrRS9aW0+rXA5qy1IzV6s0+5yd
34u7czj/73l++FHatPXBp2aJyBS/2fxWlIg8HhBZDs1JihzKEwlA+1PG58KH
ikTac0TmQd/wRYK5IjHwa+eLxLNEfomKrPcMr3q3h0TunCNSFBfJQ74H/D0x
kW508uGPYaMxLPInNu9Ath/8JLFMY6fe2ZyAn0Q/Q7DNYJ+DH0b3CvJMocjz
BN+JnasJkYP4/Q/ai+4SdM/Cj/PtVTCHwb5ITE1BdKBn+LuHfDvwO4TNfcT5
Wtxwij+O3lFi/Qq/ueS7BNxm8DXQwYhIH/Kd8KOuDv3ENonuLjANyO9Cdyfy
QeLcpPGR40ZoBd8awaShCX6LyPcb8t4XNptdJVZTtXkEfJ+TR5CtpIZfw6fK
yBO7S8mxPi0yU0xdsTkNzRBbFb6ul1p9tc7F5PUJv4PkWEpNFmOrGfwR4v0J
fAP4OuIdxmYn+Br4/DLLvQafe6lXA3XbA53B7jXwrdh+AN8n8kVeIP53iLMM
3ZYS66X2dDWYT13vppifdZ716BoxnMPvAuJfRa9O822Emr9LPAeQvw3/Ifx2
7N9Kfb7A/qwFxIv9t4htALsBrS30Ps/kWXxvDZsv9bkoZLU9Ceb9pOV+Bvlc
cKPgq8uZU998heP2U/4l33qgNdc+X47avOncVXvG/4GsJ2wxbAQb4lsV9hfi
82HfcgkQ+yMRm88ucrkhYfJx+H4wY/BThfZNMWdvtl5qT78De5X6v448G1l3
xPgxsC9HTPcU/FHX3zeh+8PG625t882m7kc9MQ9S83+wuTZmOzhG/J9hJwtf
Cer/d8Iw/0J3RGz+hwstN83xgG/90PqM+NYDrXk2tewk5wy598WtplrbEPIN
nvE3wm9nbh5ifibIZTRqfc+ADxTZnuq+XsL3ADFchn6bMHkd+DWeyX9H9phv
s6cz2J6yWvWj2+T2a0vY9kR71wu/2+1CV8RqpzXMwk4kZnM+RCzvMRuVzMnn
5LHS1edY1GZR+6V9q0b+sd4Bz3ZPd7AtZTujuzON/RNp25GKAmbI3ZkP0qaj
urVg/YTNoe6i+lBf2pNl5XZXK9Gdidrd05t6EX4IzAXo6ULr+wVynYPOb+xv
MGY10lp9ie1Vvu1dLfSS070b/yPoNoGvojaey/0Q33uJs5E4T2Ijx8V5U8xm
V3O/Tq5B7N5G/fOgv/q24xeTNpdazzrfeqk9PRy1b4rRe5BPf9uIp5y8go7P
g+4lt3X4bcb/PHcnZ3u2n1qfv/C7zLP7oze4OGF3oIIejUftjbg/Zjqqq7f2
lKuP7lZ5yHpahF63u13anx+crr4zq+dbzDqPA1HbhSSyJ8M2Y/fqXrteL/fs
duuMZcdtjnWek+S1wt1kxW5zc94B3c1vA/xxsBO+3SK9Sbpv6msTPlvcvdL3
bbHD6JugM62zfS5he6j7WKl3ydnclbKeae9uIYYdvuWrefe4nj6bMt+KTxfY
LOpMLiywG6e7/BG2W+MWj96DdvgnqH8b9EqZ2dT9KHDvvs7p+YjNp77Pa9z8
6xuy1PVL341aty8/Ip/r5qeDXB8tsdk471t9tc4t8FuIdT2xbU3ZTup86py+
ErX+biaep93/BtrDn92b9Uzc3jnd8e/5/j9w0zFj
               "]], PolygonBox[CompressedData["
1:eJwtll1slFUQhid0LYVuabdbll13y7bL7lqkCv6FyI8RSlED8QJI/CnY2tLS
EkuphYIFCRYBtRRKrBQJgkSiEBITohckhCgmXnhpTFSqBiUQElFEJRpNUZ/X
+S4mmfOdOTPvzLxzzlfd3LVs3TgzO4iEkHeSZiXjzVYWmb0+2Wxr3GwLsiht
Vo/0582awmbDxWaFObPdMbPFE8zaCzmXMLueMjvA+R0TzXZFzLprzNYj5Vmz
aCDSP8qYfYysjZp1IBemmo0i7ehrkPP4/gTpBsMCsIzhvwls4Sqzn1mHADtI
rBNVHv8wMR+rMLuGzTT0Y9icBm8b61uF7kO+DssH+/eDbyb45nHmKwqwnJza
yK1oitle/HVwppx8LoF1PrGeYL+T/Zpyswb0lUgf613k/3TY8w9jv4FvT4Ud
z7hK7IjXkPQclWtpwn0rRqLarJe93QVmtdS+B/2Ocvcln734ukztV7FOYL+M
XJ+Lei2Uz/fU607sG8PeE/VmOutV6M8g21i/FnOswrw575i1HqJ/f2U9hmIN
sr7BOsf5J8Oeg3L5POLYhHElWKqx2U/tPisx21jjMRRrP+fH2LsKproit+8m
n9pyz/dR8J8C/5v0rJJ6fkrNC6n9CvBVT3DO/JLymqg2R1k3sP9ghe/JZhXn
98Q8V+W8Pe+cEXfEGXEnnvHeqsdHid/Ct2ZkOfoK5CYxRgJ/ir0z5rkq5+68
11i13oJNMbFzMefaBtal7C1Bzpj3ZCn6QMzzV8235h2jfCvGHM4XJ7yf4qi4
GqJGB6lNH/m3gWtJzOPJ31Xq+wgY/0Bvp4bH4OsR5C1kDt/nIhvJr4f8evE/
Qi7PR3wtfPtYvxz13DW/0+D/l8SbG3KOzwfPWXwdL/AZeZb9X7Pee3FAXA7h
vyDjnBV3Lwbnv+b8Qs7P4Eyj7gZ8nJQN602si/A3yHqAGrSEvX+T4P/jSc93
LTYL0s4ZcecuajgV36vzPnvC9xD+W4N57cFmIrbjE74nDEXoD1c4Fq1HOd+V
99nUjP6T8jM6ezc5TWI/G/G1fLbgO1Tps6meq/dfRByLMPVw9lbWuayeqrd5
9nNIKd/LkH5q00e9M8S7Rr/a845H8TvQ9ya9FqrJGWr9Q9y5Ls5fQt+E9Ma9
p+rtN/gejfg37V2e7HeX+vMTvv6c5vOmGbyJ/gA1XM3+faxns5/I+p5skuiX
U85P4buC/hJ86Cf+u/RgGPu6Kue28NST37aMc09nNoJjBvPaHPYeqpeLYm6r
Mws5O6XK8xH/4ugzwdNc5JxdhP+hlHNRnBRX69Lee3HgRfIbTvlZ7Yu743P+
lmimNdt6Y/TWaGY1u39n/a7SnaW7rKzSuSV8+1j/S00OBfPUGvVv2lMOr+a9
Z+qd3iC9RfOqPL5ymIP+QdJrqZrOJm5x1rkjzog7TSmff705xdi/TX/WoM8i
3xfI52zOYwvDOfT5aZ9d1aMRPOvx35V0DolLQwE/tmNzHl/vJ32WhOFU0jko
LqqfH+Z8hjXLepN34u8ENu8h9+DrXmQx81CvuaQOtapF0nutnu/A/raA77p/
9FbrTZc/3RFHsN0c91yEWdhrAzya8emsW9PORd0Z5zh78Xa/23XHX+He3R/z
u113fIT5/C7i/lSjuWl/o/RWaf46wfNGxv8NdKffoLaRoJ+68/X2rsk4f1Tz
NvQyZNZEjz8A1m+D91gzt4C8ryd9TzYRbOuD+1OcPATeCxGvrXLqifud2h70
r4/1OjB2InvQB5EfUz47mvEd+OtKe6/+7xn4j6d8FnRn6+5+Bf+nS/y+/429
34P3Rd+W0ssR8BzQvY2fXs1u1PmieRijX6eCeJq/k+j/AbAsOVs=
               "]], PolygonBox[CompressedData["
1:eJwlkcsrhGEYxU8YZCgyNKJx19SIIWNhFCVWpIxCLlOT3JlJzOQWZooSojRK
FlYuS3+By7/Aiq3CwsaW5Pf2LU7ne8/7PM85z/uVh8J9CymSyoANPFZLD+Cm
QDpLlYaKpeZKyQfWaqTRbGkD/iyRPsBOnpTIkpIVUj+1AdBaKk1mShfMOHBK
+yCCtoUWhv3UtIBz7sfRfGj3fF/id0jtPOcFkEmOE7s04JDa8G8HCXxW8Yvm
Wf4mRxFaE5oTTjL3FIzSH2P2CPxB7Sd4c0kdaO9wmJoICNI/Buw8wBd3WXAD
Pl4QY89h9l2Bo8xZBksgzoPF88mJPsD9HNxJxi6HldFk3UULcbcH/1RJR+zR
67De0bznH9oxWgCthbMffKMdoHU7LH+Tw+Q2+T3Ay4657NhOhhmydsBrvNc6
eKb3CUzgF8B3vZA5buk2R+pxW3em5p7+OxAhfx1e2Wi1+HhAhN5BehfhRvwa
gIvanAz+JW/lxi+Irwe+4nxdbOU2+TfpCdK7Ddvo+U1nf+5T+U4DXnpC9NbD
L8x9BVNglp2mK6x/YP7FPxc0WBg=
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtln1M1WUUx08m8o5c7kXu9XK5CPd35cWXZENEsIDSbNGYrVqZjJRKchNq
CIEaBv0h6nwhMPojjZXrZc2WWf4R/7iyZWsZlbOazUKthm3ptGaBWZ+z8/zx
23Pu85zne96+5zx3zrq2+1unicgXfLfync0VyZ8uUj9L5HRMpFLlIpEVAZH+
VJGNcZHxmMkXWIcKRPpSRF5krfWLFLP/V6HIOc62I//M2hoUGQB8IFskOSSy
fobIMPq/YmswUWRHvsjf3ClBPxFbfxYaznXWUFSkDL++94k8AX4p+/+x/xL3
h7g7AcYIZ2Po1Hsie2eK/JEu8jW/T6eJfMN3mBiew++j+LmYux+gdwmcdmzV
EOdszl8BZyd+luPbDtZW7G5LEjmOz+f5vYb9cdYLTs7OEukG830wF4HZhn4v
idzNeYPzo75EZCmxpSeLVLO+FbZYitCt4Hca+5Wsh9HfB84oMXVwfyH4m4Lm
+yculleJ8SvWOnS343MNPidERF5webiE/5nkuhSdOLqD2EpmP4CthJDVcQv3
xvLwGz8fI5fz0SvDbgCMFZ7lUHOpOdJcTYF3WevC/pucPwzmJL59B8YB/D4D
zvSQxa95uIp+ZoHlcAKcE8Xmf0qOyA1X38exewVfK/BnP7r/FlpNNxYZt5RX
58E5wP0vsbsAuweRTyFXIHfGbX9ulnFUuToO3r1OPoRc5rM8a75vCZmtTZxX
eZZDzeUjLpaP2Xsb2w+S6xiYJ/D3jPIGvUnns3Kzhu9DYkxCv53aLODuDz7L
teb8afCeihtOC+tgtnH+dfb386VQi5fDhn8zw2xsnWV10T77cbbhvAu+R82u
gb8E/bV+q5fWrQNbXfjQQ952xY0XpfjchE4XOsu4l8e3Gt5GWNNixqvj6PfE
LfZi9CsCxpkBalit/YDOSs9yoTlpAW9z3HJelGW10RoJeBWOG7d7xgPVfwg/
03Mstk+p+VHXX8c868GpDONyrcvhKvan5tDD5KeWu51Ry88wcp/fZN1rdByr
xN+TxZa3z1i3Bi0nNejEfMbP1JjNAo1Le2IL+T+JP3vQf7LIeKh8XAlmgL67
m9yXuzxXYbcJuYu8fcS9tcjdyKPIdej70L8L/ZnIl9n3kHfGLRblRW/ccliF
XB8xfip/n3E8aWOtC9g8/Ak/NzieKO9SwHwD/SZ8bw5bLBqTzlzlxjX2Owps
Ru1DPhg2Xim/Stw80Rn5qOPAoqhhKWYLOI1u/3Nq1Re3Hi/JslmsOHlh6w3t
kevca8CfIPGuYj3lcpvC2k5eM5MNV2e3zvBCcDrdXe2zJDfbE0OWC83JTeJt
dhxeHjV+KE/WE9+eXMOdRm7uidhM6wfvrM9m4G3KZb/VSHvinXzry3nYvdMz
fOVvVshmfBIcLPOMtzozbsSM88r9XW6263zqDhr3RrLtDVCufot+RdhsKS+0
D7Ufx9jvY3+Z2tW54mZdOecLPZN17z7P+KAcH3F10Tn0T8z80X5a4lnvaA/V
h80H7YPp+DSP/QTWI1Gz9TvnqTnWP9VzLTaN0Ueedru8pZGP34I293T+6czV
GBvBOMTZcq0Xa0bEZoXODK2B1kJ76FzQeKVv4GrsTeld1tfyrY76VuvcVw4o
F3S+KJe6uLcOeTO90By1+aJzxk+sae4d7PFbfjXGB8B83m/7+k4Oubep12/v
k8oDOgfQn6AW72GzKmC9r+/MMTdPjrCmh4wn+gYO55r/2h9trtfmR20Wa+0u
wvmlDkdnyQz3xmkf9Ls3tCFi/z/0f8jigM0gnT8hMH9x/08u5trbqf04ibzN
xaKxal9pTrT/rsSs9/WNGnU5uVpo80/nj87AZ937rhxPdjW9g/pu8Fv+12D/
f0f9VPg=
               "]], PolygonBox[CompressedData["
1:eJwtlW1M1XUUx88QCS5gci/g1XuDq/deuFdRG80AMRRNrY1Cm1kyUbTUHnGg
GbSl4Wo9TdQ0dWVOe/BNmUux1daratM3lVFrPWyalra00mmtlWV9vpz/i7Od
3/+c/znnex7HLl99R2eOme2AcqH148x6QmYJHj9FzVrSZsf5foRvt8FPS5gV
F5iNQb4zbjYxaVYDdVeZrYE6Ks16881u4p+NMWRhs0H4r4rMmqrNzsdcJp1l
6H5QZvYY/JQ8s+fxdwPfaqHZ6M2Bqvg/Da3F9iPQIvxX4H/7NWZ1pWYl15kd
IJZB7E/F/hL+7cFeH6CeiJjNK3f9beifiXuMivXNjNlb0CQwfUI8h8A3Gf71
uGOP8s88fNXx7VPkh5HXwzfwrSjAf4J4Z/LtM+QDyGfB1+N/Bf4vg6cN/6dT
Zs8Umi0kvieJJYG8DfnWYWZ7wBch37X8W0B823m3gmdGrsfUAt8y3mzztWaf
895XYlYddpl0ikeb/Rh3bBux8RTyV7CxG5oMfz10HJqA/tFis9UBZmFXTpXb
c3HPpXKkXK2PeO6Uw6XE2g7GxVAPdeqFWrF9O9SMbCY0P+298Rv238VuGTYX
g70Ee83kanzY++dX5IczjkFYPuK9kvcKanEv1EQtp0O3pD2X0h9APiHs+rJ/
hHczvneQux5ibCfWXbxDxH8X8fYT3/djzE5CZyrMzkIR8r8l5Pi7+P9U1OMr
Jb65xJcJe33PI38b+ZS094LeB6Uf9INmYgO1Opo1uzrC7GPkxaPMsmGv/y+8
30F/erX3o/p9BvzwoJ6z8fdGwjEK6174fVA3MXdBHeBYBuUgWwOeC+AZgbwp
7b0n+4ewH610rMK8MeI+5EsxHcs6RmFVzUeCPV3utmRzE1gWBPnrJX/38H9o
lNfiCv9/yP83lno/qR80a5eSnj/a0C4kPcfyr37dhq2KmPeyerqC2L4l503w
V8jxA9jviLgv+WxBtz3mMuk8XOY5Vq5Vg9q051BYhfnxKsest3LcmPYaSV81
6kX+J5jqlG98NBL7pZTLNCMX4ecnfJZVw+/iPgPKjzAdwN5Y+rFb+WJG/wVf
H/laQD5XEWM+87Wqyt9PIz+BvdcCvLXY3xvznh7qVez1oZs72mNpwN9w+M3o
9EPvgfV9aC39NznPd4R2RX7G/f/Nt0XoJYmnJuQ5auO9i392QjXwE6FVGe89
7dRX0W0odX/KwcW471j1g3owjP+tMa+VdsxE9A+C+WewZKHfwTuoeSzxGdes
n0w5VmFWLl4c57a1I3bA/5H0f2VjXZn3jHrnS/QL6aXGmO8+4duDfGHMsQmj
cv0FdI5/j/HuBsvZscwqtFLYghnQLCyBlsZ852j3aKY12/sTPkuaqVuZrU1R
31cb8NdJPr/B/iT8tfNO8U6GvZZDNaU+90U8HvWfelU3RrfmJXy8DH1d4rVV
jTuxXR/gkb3tZU7i5aMr6jVRbbL4Gg89G/Vbppu2nPeDVb77dQNOpfwG6H0n
dH+V70ztNu34VmrTF/F6acY061sTwa0D77pyz6lyqx56NOo3T7dPO3IE+ejP
em6V48PY2x33W6Wb3YitLcFbN6ye9yxsjizw/dCPrCfqu3VoR0S9JqqNdpR2
lWZWuVMO7+b7tGqvvfqtgPoXpnxXaL6K4OeW+67Vzv0Be/nBvdBNyIO/udxv
heSno37jdetzwDIMemGc3zbtpLPElwp77pRD5XYgmD/Zm5P2mrcH97eO+BYH
+0YzlYut/5I+6+pHzd7luM+qZmhqqd+YoVuD/nPYf6jSe2uox6jN1ZTPuvbR
P/B56A/P+E3UbSxKeC73Iw/BX0n5LtN++wv+f7taT8A=
               "]], PolygonBox[CompressedData["
1:eJwlkt9Lk2EUx7+4zelaxni32Krla6btZ1uLqPSmDazujMAbIa3cKETsIgZb
BINoFAZ1UxSlkL+uS/BCywvrP9BrqaAU6sbLYHTR5+G5+HAO73nO93vO87w9
t+9dn26TdBJ8cKZbqvFh3JEK5GchEJJS1CaOSrs90h587JN+H5A+ELeob8Pe
cerwC9Kc3zki/UT4Kecuh6VMr5SFoiuFOqUSceGYtAh5+nMQO4GfX3qFVxbv
0+3S/aj0OiK9gXVYgxvUzlGboRYnH+2QXOIsfXPwA98n+Jbw7cfzFHSQ++EK
vmH8rxLn4T34Y9Id9BbIm/Q/hs/41NG92W1nNLNeox6ld9i1mkb7br80EpQm
iWHmLwQkhziDxjP4Tt83aLLfI2ovqU2g+QDtjYj1Mp4tzlz0Sg8PS2W0KjDO
9zHw0ZOhtxcNf4L3YLd/ePvI2+Er9S/wl29JakXer4sZ9/E4RPSwtxdS+CYh
AQXeKIX2On1rUHasbguNEvUiXII6/8MtaoPoHGT3Adfeo7lPs5/Zc5M9GnhN
cf4d+VvIk+e40ypvtMJ/8gft1T47p5nXzGPmuoBeEN3zrv0R05yrOHYmM9sn
tGpoj6H3HK8X4IlLbbBMzxC9S8QGZ2vcUTVk79vc+3+ZbF2K
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlV1slFUQhifQllJoybJf6dpvt7vs9tt2a4oohpZsoUi1NKZYMP61BigQ
rVKhiiIY1CIW04LlR6EUiom0akQj4k8U9UJjNBLhQoGmRhHakOCtNwYEL3wm
cy6+nLOz78y85z0zc2av7bp/4yQR+ZZvMt+vZSIZ1rMhkY0Rkeo8kd/Y7/BF
cqeItMdF/LjZO/n/Ub4M+zbWpoTIVjD5nshXxSIjBNyLX3dYZAr2p/A7UyHS
i/1F/j9K3LPkaoqJvAYuD8yMpMhHgchf00S6KkVqiPkDBHOIWeT2k9gP4XsG
3zjYS8oDDgv4Pw+fZwrJx1o6m/xTRQ6lRLYkDePNJN8skbIckbGoyFo4bSdm
HzG6sM8H30ucVfD8GExRCRhifUfMdtbF2Memi9SztpD7ODy/qLQ8alefFvy/
hNsI8afjfwLbQTgUltj/PyHw6YzhNd5hzvIz+FmB4RR/gZgH4LwfTS4Tpxr7
JwUiV8pF9vA7CqYBvn2+afs667181zhjE+v3GYtTQM4KfE/iO47vEbgNgr9O
jH7i72N/kf3j5DsPn2Nw+bHUakBroRX8KPrMR/Nux2cCfBt3ugV7bdzuRu9F
76fZcWjn/yr++5t9Nbadrn7WYduM1geogSFqYJrTR/lGwdxO3kIw9b5hbnCH
uyJWS1pTylU5byeXz3+1uSKbiNHmG+cU/Kt8y6v5Wx3PbzjLQ2Gz36pcbuHM
7HNYW4nfQ/yniZ/n7EnqpNHVyTlyfuhq8nhgGqlWzVUiA04fwe+lsNXSTXLl
x62eta4Xx+x+9Z5XO/vLYatvjfkL9oPu7HPZL0pYrV6G15vY98JtD9x+L7He
0R5KBFYPc7jbGs846F2t8e0sm8Bvc3yeIOcy8O+Tq5n1KrqV4VtArkhgtVFJ
nGyFnWsh6z9RqxOtl81p69M0muxz9aP/X+Wc4/Acp14609aP5WBqHR/VpiNt
Z09hnxyzOBrvSsS0XYrGqcDsOg8m4HadmMs5x23Y34bzHNaLpZZLc64JG2aJ
nsu3vfqtdLPoXMh0UX0CfOvD5juB7zsJy6VctIa0lu6A712uZ4vh+Qgxd6Dh
BjScWmK9XVdh/awYxa6P2L30g5kHj3X53F/cdFQ9y8jbwPcu/Jew1vINs69h
zXX9spA4C5y9G5sfmIY62+a6s29TLV3enpDVouqmM+xSuWmrGp9KW64e8DFw
GTj8hya73Xzw6N3PiHm+iFqiUSbKLZfe2/PEynLG/fB5IGJn7yw2fVXbFmLc
5+qn17OZrv34dbH1lfbXw2j8Af4nyLXVs3dC+137fie/38N3aWCaavyV2AfZ
t6NbNdiBlM1GnbufVxq+CfyTLs6r4Od5Nn/Go9Yn2i9v+TYf1a7zaX3a9NeZ
9y/2w9hvRm2mKH4sZGdTDqeoqXrPMI/h1xhYXs0/6ma6viF9ns355YG9bfrG
ZRP26f4o8Xvd+6V9v8G9m/pOTrge+ZNcWc965xr4Z9NWnzrX9f3Q+CsC46F8
bkRt9ukMvJPYzTHTtiVm+up+WcxmhM4Kfd90FutdPBexeaH1Oejbu6s1oLUw
Cp86NL/A+kLS3pE3ovaWK+ck2DTfKjADxBgO2YztgONM7A9iD8Vtdiu3RmLe
7epca/BTcCPsFwU2i3UmrwYzjFYN6HksYXNWZ9RpNHnFM3wd+D/cbF8BZpd7
E3V26jzVOabzrN+da4Zvd693GoNPUdJqstu3/tc5cJKY2cDiK6+hqN3XPQmb
j8qhA/z/K2xArQ==
               "]], PolygonBox[CompressedData["
1:eJwtlltsVVUQhgekpdACOe055bTn0HN62UgRiBQs1IK1iAVJsYiKXGy5RVAS
QAREg4JBHgpBagtIjaIokZsI6IMomqhcFJUoiTY1UQkEA+qLBKMCFeP3Z/bD
JGvtNWvmn1kz/+zieUunLuluZjuRHkhXsVl5b7N/Ms3qE2YLkfU3mRXx7SJn
z8TMmtl/19espdysM2I2nHstfFsUN5uY8LuyMYCzkSmz+VlmWzmv4WzszdzN
MfuX+8e535Y0S+L4BCAyomavc+ezPma7ss2qA7NG7qzjLqo2k/WpQsej/UnW
b6TN7upl9nJP7HN/HDq1SGOeWRMyBn8tnB/ER3Z/s79Lzf5CniSOVUgK3SIJ
OFPCOsj9v4X/8fh/nrMMbA8nntwS7PDtV87OEeNP+D8D3kvZ/k1nt6B/mbPp
xNyC/YfAsIrYmtgPxP6cPM/P7ezPFJlVoT8a2YruNumznoYUY7cEWQie0Rlm
N8jXSYLOx8dXxH4YPHGtsfElMgu7DyMluWYLsF+jnJCbGuLvzPEc9CL+R7B3
jPj2gvde7peh/zX2fuPbPs52cKcW3XZiriafa/J9L5uZBcSJr/FZHn8N/oKU
x6YYZ7L/mBx9hFwhx38iUc4fzPL62EJcsxP+dnrDuayX4HMxYmVm3ZD6wV4f
+8DXAL4mzj4B2072t7Ifgc0K5DbWlch56qcVrIVgrAfrjojrH+Rb/QBqusCx
KwbF1gn+MVleU9Px/wVgDvXwHJ1iHWDzXXL7OzbewfdadHah+xzxPUt8ffu7
vt7jc/R3Rjyfu8FXx93LYPsD2cN6L5JD/FPx1xM8a7m/Meb7TPbN2G5AroJv
GTYy8RfjPY6QjiJ8XKCf7gPziz39WwPrp2Oe/3LuNHI+hzufcvdN/Ffh71Xy
8RT62cR7J/n4udDfSvW5nLtFgdeO3ns/d1uxWY1uB/GN4r2P83bHkFqwjkOG
qGazvKansT8X2hMGYRmb9t6dxbc7WM9Peb8oX/NYDySe0+b5PIC/aK7rCl9l
2jEJm3robbD17u+9Kn44QX6vJ8PeRn818ViBYxXmtrT3mHptKDYXk49mvlWG
8YyOhj0Q8sM1bPUr8dzrTfuWuM2asL4zCtynfKsGF4B3c7lznThvNb5OR7x+
VT8P4G9o2O/KUTvnvbHRC9mO7XZJwmtfHLmN9bjAuUUcI65TDamW1OMJ+HV7
qfeqauwl1venvbZV4yOI5/tBnh/pdLCuSzi3imNHkO8PCh2baryjyDlD9mWv
D7ndEPe3UfwbWS+IOReJkyYlnJO0V03OzXOOVj7kM4f7YwLnZuEXV76nfgm8
ZlQ7E/K9dlWDE8H+S7HPDvX7jLj3lGpBNVHKvatJ5xr1p7jmMOeHkAr1OjIy
jE/8MgM8qYj3ivBN5uw/cnSj1DlEXDIk4lytGlyXcE5TravmFw2kxgPvFfXM
axHnqCthz6p37047dsVQB54j6L8fxqhY93C+G7kHbpmEdCZdV/3ZwXryAOce
cZC46yg5+RC5ju2uUu8p9ZZmkGbR/hCfODiB/a6w3jXT1uH/aMzfSjU7O+Uz
TbNNnC/ubyPGVmQosQxDVsQ9V8rZStbrI45NHPICOIYFzqXCJ67clHBuEieJ
my6UOf8Jz/kyn0maTcuw9UTcOVpcrZgUm2JSbFeRa6U+szS79CZ6m4qo+1YN
q5a7R50vNPM3J50jxZXfcOdbpDLqvase3oD+DxHvbfV4AfF3p7e6ISvIzcp8
nwGaBaoZ1c65Mn9rzcizZX5neshfg4k1FXhsijHNembcuVR8ptk2JeRj9YB6
40BYr9JfTv1MCXw2iR+qma1byEEbcpFYLiFt3GmN+T+F/i2q0s53inkU634h
H2gm5oJtTZ6/rfKvWSFOFDeqBl9Jes6V+6XI43GvOdVeM7FvyHeOl758nOW8
PvDZrpmk2TQh8NmkvWa/ZqTeQm/yI/YfTTkfqF8eY/0/IVVx5Q==
               "]], PolygonBox[CompressedData["
1:eJwlkc8rw3EYx98UY6LGaMt+2NbKysiPmPwoXHaRKBxImrtRfhwcRNTmwkY4
SfNzipTiwMFZ4kC5Osj+BMTB69sOr57v5/k8z/v9fJ+PJxIdmMyV5II8WLBK
+0VSnV9q8EmNsELuiFwPuXbOHTBlk6IQdEvjBVINMUbdKXW91HVR0230Gzqw
Z5Hui6VItfTnkQJm6ZfYVUkdhJ3SI/6HVdIxnMB8uTQHl/QH8qURW1bT0O4n
l8Yrjmct2kGweiWTiRx6yxXMWyil0Cm0S2bY5X4HfKXSA15r9LiZ2wVOqCfn
oPeVZbTzT2/EIc7DsIhPCr8Qvi34hyCJdhsec3jloJ9rz+7G2FGYumPqV+kb
LWN2qMdjAt0m4rtDSjDrFvMkYRPWA9JLiXRF7zXcwCzaM/BF/S71G3g+M/cT
mMHFHj/YY5raDH7nxFu07rzZGY1ZO8kdcLfELBl0PiGOTjOzR9H+oeYbTLzN
NG/kRjdOPgZ9vMsFvmfUe5k7yDtM8g4J3iUJ2zDGP/m5C7GnVrDwPUjOSkxw
TsI/c0xRkQ==
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlXto1WUYxx8vmdmanJ1z5tnO0XPztzNJ1NyUUqcyqaXRhUkrNbosshTU
Ver6o6ml6RTNtaFp1h8KEQgDKzRSuogkSUKEU4OipAtZOmjdhyl9vj3vHz/e
9/e+z+X7fJ/Lm29d1bxyqJkd5xvGN69kdnmUWU/RbGHOrI/LqQmzu8aa9V5v
1s5+ezi/mjKrGcN+uNky9A7UmL1+o9mzyEyaYLai3Gwya2fabAfGtyWxXWvW
MsSsrcKsvMA9vkazrq80m4Gd6fiZjP7L+DqXMevC14wbzNZw34PcNGQuZNz2
JXw9DY527G7G/l9gPhCZ4cI+i5ndHzdby33vOHyG/cSs2YvYmoWdK9hZVek2
f2JfBs4p4gGZu9kTkmWxcxL9P0agw9lg3qwbX6W0y0n+HDI94NwF5n7snCTm
LjCXw8065IZzPoBeGf9ny8xOcL8M3Y6RZk+xLsXRAOf9tb5KVxyJL/G2HRtv
5Zz/O+HnGDwvAvPbYL8n8v0T6HYGeUP+ODKLOX+30vM5Er5qsLk05TKSvYO7
OL5uz3n84kEcd6D/JjIfIrNzgvP8PPvRYJ0ID09i473Iz3WveBRXA3GczXju
zrNmsNOPfBa9aym3vxKf6bzHKJ62Bs4nxTw3ylEbsqfRP8L5C5zvC/vp4DxI
nPvwOw7/14qe6wIyryCzBr89rGdyXhdzyfnstOdOOVwQalhcNsZd5gTxHsLI
fmxOx+Zrkef9FDYb0f0T3X/Bewjc7cR4BF7rsHMKmT0xj1v8iusLRdeVjdYK
57uJg7qE94v6aUuok0vgrA/n6qdeMLwBhgjd6xIeSzcyuch7KsuaAk8Xeeki
F4vgqBZsP+Qdh/DMAte60Juy/RLfL+wbwJUPdtSj60Kv/YP9vTnXLYB3V9Jr
+7a015bqamHkNaT4GollY+idefjahv1L2G/G/s6kY7sZ3Sv6h5OjcPurcoTf
31nnwHkb8hfJxclqs6/Af4b94WrPo3q3IcgsHucciSv1VkfAPAW/M0uO5z7k
twYMjdgfWkUfYLNbMyPufgc43xx4uJd9c9xrciw4z9Z6X/SxLkt5bavGZUs2
OxNef6q9L8ByuOBxfc/9DvYb2G+KeQ2plt6JPN/K+6Mlr3H1s+ZjP7L9ZX53
OfS4zqeC4zf8Tkt736o3t8DlAmJIIjOf9ee8z7cv4ak+6/X8UNzzqrg2gXMt
GFbj4znWFSnPhXKyIcyfq/DZkfA6rwfn7qJjepW1O/RgLOtzSvLSWxR3bPVp
rwnVxu6kvw2q+b2s3yKfYf8Na2vJY9KboFhlX//Lw3zTnNM8VY8MFj1m2f8A
bEl8tzAPx7C2hn6sA+etCa+BTniYzVcOJw2so6q8DjXLHym5v8dZ2xI+HzLo
/p13HtQ3c8IcEH9HQx6HjDcrRt536j/hvRzyNSzUUp6+WJ1wmfHIpiO3rzn0
WPAr/5pBquEH8HOa//k3mX0MDwfB2gTmrZVel7JpVT7LVFeJCo9T8WoOPRz3
maPZsyTledf79h0cNcLPGvZzw1yal/Y+Ub/MjPs7p/m5kP3yUM/nY/42qJeb
Iu8f9ZHe2+ZQ5x8xExrGOp/q72KYM+JP80Vz5vOYx6YY+1RLca+T9Zztj5xP
9YfmuGpJNVVR8HdkI/tnUl4/mjG3hFrSW7oN+U3o7in4O/H/e8H9g2G+fY2v
wYzPKM2qEVWOXzOsPu4zRLNE/XQsvJufhNnyKeuP1c6heuhi4GqxsIBjCXwW
sj4X1Efv17g/+W1B5j/f+VCa
               "]], PolygonBox[CompressedData["
1:eJwtlm1M1XUUx49CBgoUXC4C917gcoV7qVYWVoqQCJlP05kkqRQplg40JJXU
aamFKKVpNi3EXvSiLXt405bp1B7etExbs0DbStNavUjZqqWbUa7P13NffMfv
9z/nnofvefgRbVk5t324me0DqeBazCzO310jzYY4R0JmgyPMGtLMXg6anQmb
vXKz2WbkO0rN9qJzmfNAhlnGaLPpJWbBdNe5K9esrdjsOX77dgp/sTU/YPYo
KOd7HIRBCCzPN1sB/gP9BHQvwVzn3JXtvmRvAN+5OWaHiG8N39bif12eWQ3+
niLGlAJsJMy+yPT43yozezGU9E0MrfiJgqY0z2kucdyK/BaQw/cAGM1v8kA+
KAB1kLEw1XOs57yvxP3tJZ7x5DeIvz/JvXEYOjrDR2KU2W+gHb46ia8qGd9w
4usgp2fJbw8xreJcg70s5J3Yuwl7M4llBpgGpoOzSb7F6TRsbS9x3+JnJff6
iFk15y7i64WPM/A1Fn52Yn8p9s8Xmp0Dq4llDZiMfi3oRW8/qIWDZ4inG/1f
0RuHz7+INYG9f6LEF/faioOJnFfzm86RHu+rxPZGqftWDCPJ72vkp8Aj+J4H
SqnXCeKpQj4C+ftw+h44CN4FC9HpSPpv4rwEH4P460e/hXN1xH8v+zWcJ8Dv
eLAFrl4Ap8PeDwH4eQhu2vOcG3G0jfuUEpdJpw/dJ6hRMxiL77tBb7J/y6lf
S47HpNiOkdfxUudAXPwNJ5PgJpTtd3F0D/fqkMv0TbJ3yrz26oE/sH2syOxo
kfe8el8xK/Zq9GrACmqyHByG+yOgODlv6tE9fN+M7qZcz1m5f4nOD8hrkXcE
vcdu+OPbfPi7iK+6NOd0Ev5OZPs8h4nvJ3KZGHCZdH5G93yR25LNcQG3qbvs
LcDeMu5Lg96T6s2v0L8f+RXkzei3BP0uDh5A/i/yIbAB2UYQzfHe1wzsohZr
yeUDajOV+0HuVuByzZRmSxyIiwFsnCnyGdAsRMijCGSxY3aje5keaSaxC2Gv
t3ZGJbbXg3VgFr0yGxRGvbZpWdhM+ExrthNwWRHzGdAsaOY1+ydVX/Mdol1y
FftXwH5i6wPDxvhukbwdeU+e56KcZuBvMd8WgQnYqgJXY97bmrE6+LidXHan
+A5o5P4ROpeo39PEd2cFO7PCz9L/rsR3rnbvHXDUSj0yi/2uHgljK517Gujm
vA3sCPnsawf0iLuIx/YJ8R4gt4tR7wX1xCzkU/G/AP5+x99WeJtT5rN+iXsP
9yfJZQl4kO9TQH/CudTMaPc/FvDaqwfUG/Uh7w3d1RvF/OYA+R3Hfx/+H0Y+
J+Q9pd5qzPdeU8+pF7UztDs0E5qNb7Jdrh7XbB0qp4cyPN5u4vsl5vVQPhc4
75TNJF9t2DlS7rrK8SjnT8s9N+X4OecwNvuS8TUlvKfUW4PY3BfzHlIvaWdo
d7Qn3xf1yHXkY/j9m6Oc38f52BDw2qrGsZDPuGZdHIrLhiTfiuEl4j9Hb/0I
NlPrLSW+k7SbNiDbCLpyPX7lfJh4t+f6b2VjNnqb8JGqt5Z4s9hXr8c8dvW8
en9P2He1dvb6Uq/BjVoQc4jff1/o/amdUEPs8ZC/TcphHvdFcbelnbyY82d6
4zO9Z9W74kz2VOMo99a47269iW1xnwHNgnaYdpl6UFyJsxjf15X6W679fIpY
V2H/aLrPeIj4Nwbdl3yexN6HZT4b+vYx56Gwvw16I65xvi/ib43ulRF/8/T2
6c3R27Ms33tDPRIs9popHs3ITPTPZrtcM6ZZUw1Ui0p4HSduw/62aF/pf4/X
kvzqDZ/M/bZsr4Vq8jxcfktPny7yN1Fv4/8TU0tk
               "]], PolygonBox[CompressedData["
1:eJwtkckrhHEcxp/s+za2GGOGxnaw5zAHIfsJByUX5iR72WNEyUgmk4OyHRw5
uSiFoxMXYznY/Qs0UiifNw6fvr/3912e5/3+bM6htsEASTYIhj2r1BAu7RMn
E6UpKMqWCsFul3YipVHuXlKlZ5jI4jtCGifmU5MHFuq2qBumbixJqgmTXi3S
Y5r0BFvM3oRPs+QIklzJUjl9ZVBB7y69Lnr7md8HWZlSJzNsxPsU6Q7Oc6Wm
aOmCWEdPLRzl4CdKOmCeidoEiIdi/isqXapH08S/1ZP3oX0FKeTbme3BZyw1
cbBKnYM6L9FPzQeM4GcbX1b73y6MnZT/e3XmSV3QDdXMjqG30vq3H2NPho6h
10guiVwzuVv2cQPXQJsO2cspOzyBd2OPzHWYpFz85cA6/tYCpRL8WeKlDPjm
0fwhUhV3K/TN8Q4e4gNajzCPzhyU4v2aR57lvEF+gbpl+qsy8As/eAgKZefo
fXH+Bi96XvQG8J+Ovhnc3Hm4W0IvjO9wuKL2Hg9n+L/k7IMnfJnReCW2UNsK
bliEWPSLyBWgf0rtG70d6B5zPoEZztPQw2wX79JL/AUf+l/y
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlVts1FUQxie2aoFCKbvdlt3udre63QLaFiwEUUgpXgIIShWCiUaoINe0
IbTcQqtCDA+AYnwQUIJGUW5Ro8GoEZWoEWOJl2KjITbURlGRIhg1GlB/k+88
bM7Z+c98M/PN5WSaW5tarjCzj/nl8WtJm2292uxEuVlb1OxHPtZeY3Z/tdk9
+WbXZs3OZ8wqB5sNcL6VMrtwlVlNwuy1mNl8dG5Fpz9u1of8lyqzw8jnIW9A
/mrQmcG9ARs+W6rY7HuwNhPAMez+KTO7AZ0V6OZXgAHOUHR3VZodIrZpSflw
nEXEVT1S+O5nLPK53B9A/kaVdNznoZjkTdhOykp/ITrDE8IvxU+U++PE8Aex
RIJf/95MPGO4D6mQjdvWg3EGvcfQ/5yYD8bEzxjkuQpxMj9i1h44vB0ON3H/
mfuN3Aehc1eB2ZYSsw3IzyCfgXwj/vLI8S94nYvfHDgn4GclfvuHmH3GfW9W
9z2cLSXi7QK2dfj7Bv0XkbeVKLZeYjtcpdydgzjfdmPbis/3S+HmSnySxxyP
lRj24PcoPLdyP4huU5BnKoTr+G+CuTnkMgu/i3JmvxWaLea8zLdaanoWnM6E
7qOJ+Tzf9w0y+zpf+bvtI2A05/TtQc66hHjzntpXJT6d12VlqstWcro7cNJU
ptp7fScT1x3870BnATp/0rvH8ftEWrV02wKwZ6eU1wRy6gC3gXieQWcOtg+j
sxjbTv6PQ/5oWj3kvM1OKgfPZQs4F4l3eBE1gbvMMN178pVf9TDlWFykby7/
tVr3c5wXq6XTPsLs6WLFWQt+zSjV4khWeK7v+L8XCstxfE58XqYTw/rQMweI
89Jg+XadDuQ/Ia+H4yfh4Qj6q7GbmVCOS8jxU+QJdBvhYBjf8uGzLaM5915d
DUaWmCaisx6drrh6zGd0Vqjd6wSSN1I669CZFBG33jvz8HE9vf1KSnF4PBuj
mgHHfwHbmUnV1/fK4ax61Xt2fpl8eV9/V649sK1SPer8HKNnpyRU62Z0usn/
PnKvhb+euHB8Lr0fTxWqFm7vOD3g9aTUw2+je4n7TOK8zDkn8NOL7ZpK8XOa
WPqIOcu8PEuMNUNVe6/LdvxOxO+qmGbVZ3YDGFl+58Gv5jyJv+3IV6P7Ljrj
8HU0pTn32h2Ch4awb6+Dn1Xcu5HXRbX7POb+cvWx90mGnukOmLchOx1i6+ec
xvx8S2yNnFPg9iA6O8GfHdEe8z3aG/hpL5E/9+v7fiE2A9gu4Lwl4BSVir+B
wOHUmDh5Cv+jI/Lr3BSG/en78iNyG0+OH3JuSKv3jqO/hft4uGqJqVe8Z84h
XxnVPm9Mau973VuJbVPg4e8yzYPX/QPiWYr+fvTr0X8ZnFZie853W0Sc5xKa
f++NXeBNTQrf3431we+YpHaZ77SV/s4khTkhqZ3lM36SmegqFz/rsD0SV894
7/h+dNs78fleSvP4CfprA77PTUF4R7aVqAZeixXE3pXTrJ0q1a7xfjsA9uRQ
r5uTmmOfeZ/l5Tndl3HuhOsB5nw35xdpzVSO+VszQvO/H/lLccXjcXWEd2Q5
uZbzu5e67MDnV3y7iXt3Sv2dCLVtHiH8XeA8H94Xf3P8/fZ3vA/sH8Kb3hBR
/3kffglP//kuRp4GY2LYA75r/w3yy5xjw273t3FkeINKOWujqvV08GYETO/x
vuDrLPO4KLy//g4vzWkGl3Cuy2j234lpZ14MvD0U9HuKtSO8H6bhf29atfY+
GpXUTPkOXhJq4TugM+xP57guxOb96G+P1zSZ0M71+V0bFb/O80by/h/vaVys

               "]], PolygonBox[CompressedData["
1:eJwtlntM1WUYx5/CJLwjBzycC3BAOJjLG+CYiiNta2ZTAzRTt4pIyZjIFDOH
tyypsLZmf5S01XReUlpL04ax0Na8lK6V5mylVrZKM0nbMptWn6/P74/vzvv8
3ud+e0+itrFq0e1m1g56gSsJs/w+ZiM5r4qafZxp1nKnWUqq2UroykKzWTBe
QGhdyKwGuhq8xLkNHMoxK4N/ZYrZRPgXDzZruMMsMcDsUrHZZnh/6mt2urfZ
3ojZqZhZCfpOoG8k8seh22QLH1rzze5Lmn3bz+wydC26JmSYjQc/Yuc8qIqb
zUT+V+RXIV8a+Cd6JXQCmSPEUs63lGyzhcQzHv+S2K8Om/1e7L6lDzSbj61p
gb5fkH8G+aHoq4H+GXopdAMyzZwfRkcs16yryOwj8H6W2W4wPOCX/Ar46+Ff
ADLhzQKfp+N3X8+BcvEJsgfBHmQ/AFcKyCu5a0R+HHGegn84vk5TDZBvwP+K
wP+Z6K3PdF3S+Rb6jpC/vcQbxYejnJvwYTGIcRcHz2W6LumsQ35JntnLqZ7/
Js5nyOl3YBZ3D4Fq/KkC3fh4AEzEpwowB5654Bw4C0r5VgZO57h/qu+oDLcp
23PJ8zwwiBgG5npOlJsK7mYH/fQsfu7A1g1qfYpv2znH6aFXUjznVehbEvJa
NNITm/HnjYj3mnruU2wPQd8mctHVn19y9yE8+8B65FrBpgLvJfXUoCFma8nH
1KC/W7A1ifrvSnX5OfjbLn3gKLo+A8fTPffqoa/Uf2Gnb8Wc4zlT7s4GuWmN
+izN4D4t123K9h+gLuk1VT0uoqMfvPPwZwz0FeUPegb+TgedxLAfvIvOu7nv
Uf3JRyn+7sDfNmLanu89qF7UTGo2rzPPyT6ub7R8GYaNNLP3mMkRnMdmeK+p
546RyxroalAA71AwBWDWVnM/Neo2ZGsnNidie2ehyz/PfQfnJ5Ie29fUbxt+
J7N9FjWTxZxbQk5rxkbD/zj8PQH/I5z3Rbx31NPq7QND3NdefDvGfTLqsSsm
xfY3uAbCfM8GC+C5ir4R1K8j6T2kXtK3eugtRd4/mtGtnJ/k25/cbSUnRdh6
OuSzq/upxPco95f7ec20i+SjfNW3xzj3j3rtVEPN1kV8uQBOE8c34PV0z5dq
VBL3GdAsJIg9H+wu8t7XDOzhvCbktPI1rtBr3hnsGO2aFdGgV7E3n95JzfXe
Uo/dxF5Lht+rp2/QK1/GfL61T9fiSyTXd5fm6UF489iPdfhfRvzrmf9L8P8G
NnJ+DbSDyjTfoX/xvRKZH3p7D53g7mbY5cuhN+R5zIpdO0K74u0in1XlvJnY
puT5rpFP93MuIZ4xoAyMBWv5NibN34Qz2NtV5PVQv3QEO6g72JnandfDrk/8
/4R9B2kXHcKHw+CLiPemerSc7xPi3ruqiWpTgc0JIMo5Bp4K+f29+LAFX2Zn
+OxoJrvI54io0+q/bO3y4P2Sz6vhn57hudXOCsE7PO5vj/I3jPNd9OOwAt/J
2s2j+TYKrGZm14DJwf6R/XXQi7K8Nsrxv8Q3Mu66VJM387ymqq3ezGMxfzNF
K78noZfn+53eg2Wcm6l38QDv9xL69GS6947e/B7opiyvpez9F/YcyBf51BDy
nXhrtzKfEfpzUpbrlo1KeJcmfFY1s93M0+F03x/a0Q+EfSdLXvruIZaDwXyr
n5YnPGbZUw0quC8O5l07bxbztT/LedWD5yO+k7WbzyH7PXgn4rtKNrdF/I3S
W6X/DPrvoBqr1uo59Z5yoFzozVk22P8D6L+AdsJCzp3BPtJ+19urnajdeC3Y
Pdpx2gfK6dVi3yHSp51Wm/QeUa8ohsKov0F6i7TTtdsnRz038rcy6v+h9F9K
b67e3o0xz6/e9Fc5v4gPL2TqgTe7DfwPzy1iyA==
               "]], PolygonBox[CompressedData["
1:eJwlkUsrxGEUh3+ug1EUM8a4zmjISDGZaQolrCi5LUZZWSgWZiUrhuRWSLFg
jMSGDSmMlZXiAyil3CcL41I+gPJM/8XTed9z3vM7l9cxFOwdS5ZUCmkwUyRN
wx+OzgzuFu5WKQS+EunQJO2WS2fcT6G1SrrPltqxwXwpbJYKXVJ1heSGQrRs
sIbOAHr2MrTI92RKU9gGcrxwTL1a4kfYvjypH6JO6Rxi6LjQdePzoeWFS955
eD+IbhJ3wQLnbnwmasyj7aXGAvazWPqCK3K8xK+xTbxvhk+H9JouvdulD85x
+AFnlvTrMHaR2EkEnRb0Jpm5jj3UwzL1VlOkEZuUQ81cyCkw9tHGPtbpewN2
2EeM/vdcxjyJuWL08AbjaMyhcWc39pDYxzK1/NRawb7QwzM8QYh3PdS64e01
3JLfyDyjaARhlniA+AP+R9ggfx2+md2fKk1YjX4SfW3BDzNuYiMuY78vnMOc
t6EDAuSckBOtlC7Aic8B+5yDzHhAzMzMNexvmLqL9LAEVnwWKIA4sS7+7R8g
y1mr
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNln1o1WUUx88yszJ0btc5793Lndvd3b2TmpmjfMkSM3zJ3FwENv/IFUrL
1uYrusyRTVxOQUzMhEHmpmaZZQahzTKbSvpHmKZRhhZKDiGxIKXs8+U8QX88
nPN7ft/nvHzPec7vVzSnofql28zsJKsPqyrbrPcOs2ih2byk2c27zbqKzYYl
zKpvN6stM0sMdb0zBxz7Veiz2D8ZN9vTz2xmvtk3BWal2Jmea5YC34D+YJZZ
WdCTyPXDzOrQC9m/Ba4SO43YHJLvehP6rQFmy+8x+5DnLaXua3uOx6TYdiB/
LnJfxweZ3ch1m38hJ/LuF5J7i3PXsXGOtZfz6zPN1rGasX2CmH8FU0I8NWnH
1RFP5hDHbsHGc0nXtXdqoGP0/HKOx6l4d4PZn2E2N+lxa7+A/W1xj6E+YnYN
jm4Qcyc2j+K/h9XOqudMtC8rZRbjTA91eJNctnK2Cz7vY6+O89vRj7C3Oe66
9mbkO+fi/lSeWQV+V8PrqrjzcBMeojGvaQc16WB/wl1mK4nxIs8/sT+Wmp+K
uv4tchTPaorzvG8G34b98ojnrvjP4ONYnu8fRT4BfiH4dQXuT35V2+MBIxt7
eEer2BHy2ol+FUycuKaHszn028iYY/IGOUfy9XzS66Ra94LLBFdzp9naweBD
nKOx9zh+l9PAs9ifBqdTWQ/w/Cz7bciV7FfEHFOL3hzz/Rb0vcQ6HzvDsfcV
vXSe2M7Bw0zOtoB5AczBqOt9qGFJzOOvAb8p6jErvx9Z44mtQb6y3eb3BY4T
/gP0P3O9RnXw/yq8bICfi/A0It9rrZq3xr0H4ll+r9TzE3j/YsR7ST11f8DP
ZW8/divw+0mB568c10S9HuJ2Kv6bIt7n6nf1vu6Aek7c6nlOhsv2/+lHw3N7
6FXVXVyIh56o8y7+R2Q7dl2wqbq1B/yKAe5LfnqCTWHUS7Mz/S6dD3aezvU6
q3aqteS0oKuWetYd0zmdl335kq77OCPX54Bmj3gX/9XBpvwrL8WimBTDDym3
Uca9/gP8ZDi8jnw97f6+jnjfqE+uke+YlMfSTMHXRlzXXkvAtMS8P8TPlWL3
I7/C1ab9eSz4Q2CWkfeYLM9J8SkvcaZ8FOfmYp95G4t9FqgfSqj5yCJ/v4iz
M9M+0x7jjrzPjGtCP1DmXJwLM1P3Sj0wDx76oj9Jjq2DfUaoD0/Qe4/QEwOZ
CRPoyeQQ50TcaNZrzucnvF+FP5vnc0r8PYP/M1G/L7o3S1mXsfMFNrpy/Ky+
G42h99Lkcm+4F7pznQGTTPhMV59PIsdd5NJI/DuQu0Ne75V6btIryb0bfSn6
6CyfF7qD4+B/SYhhMXJxlnMlzoYHv9sAfoytRZz9CPl5mesPgZ0f7pe+G1+W
eo0OIU+H2ah5WRvuVyW+csJc1XxN5ftMLke+hp13+8MrvvrB+SUwGWAeznau
zmJvfMIxjyKXge9AL0d/BfuTqFEvvg7/FwMxvs27C2C2IveF+BV7N1xfIt+F
5FjNu11gnko41+K8IeLfDMWWJrYLeT5z2tibDK4L/FTk6ojrn2L7jYjbqUl4
v6pvxyE7ifs74t+JfId61RPDJvC/F3iO/0S9X9V3A4lrUtL7UH06Menf8X2c
GxXxGDT/5E9+p+DrYKnXVLVtD7NR2N4873/NRf2XiPOh8FmS7fF04XcJdsfC
w8a4f781V05jZ0q2x6YYj6X8f+I4MpVwzocj/446RrXqTy8Vcgcvw+caalFF
LfoXem+pxw5jZ1Xa51IrckGR878I+RsrztkrRT4LNBOuoleFuaT/lGHh26Fv
4HxiTXO2AXkg5P4Zcra+bfjtBtPIu3IwC5ArIv6tr6aO/wKKtnUB
               "]], PolygonBox[CompressedData["
1:eJwtlntMlmUYxm9LSzEPwMcHvPDBp/B9CGyKoSQdpFxhmhqhyy1zKw+JIyVR
KPGwDtqms39cB7WJtFDMXGQHax1sOh3qslzzMG3VRJtN6DCX5Wxlv8v7/ePa
nud97uc+Xvf9vMPmNNQuvsnM2kBfMD/DrLK/WfIWs0eyzA7nmq2/1WzUALOW
uNmDBWYTwdtJs3ZwT7HZ6sFmvSjZEDFbmfD1lKFma0rMStPNSsA57nSD7/PM
qtAvo+V8b2W/FTzMugbMYp3K+U/YH89+VI7ZSJCdahaAdYHZipvNypDZi2zf
fO6yXoa+achPxecp4AnieBJ8HjX7DJzn3gVQHSMuAv0Z+Ub8PU5MjxFbJzGu
Zr8PneXoO4n9HcifGmH2521ms4lnA/EsKMJuH7N/UszqWDdwv4T7Zej8C7tL
2ZeG+xPkbgs6NoOD6D0E3ou6vQb0F2eb7SxwXXPQ2ZzGnpwuwd62gZyTy/nY
uMb5HvTNY12PjxfwvR6ZTci+i76lrBvBbvYvl3jux5Cjtawr0vxMMp2cZ5DL
CLgyDH/B9JjHLp/k21W+JbH3G/4VIreEbxXY3ojMK3GvgWqR4CwJLiKfj/yP
yJ8iziOZZr+i6xfwLGetxLAV7B1u9gloxv+miHNIXFKNVCvlSLmSjGTFGXFn
LmfdA52PNeT30zyv/Q0OYH8h53VgGzbaQB/5JO4is47vmakeTy/fopy9E3ht
xXFx/STnJ8Dv+PoHGEU+Ooh1HXfe4Psschj0c44/znohvteBMciNBUfh/3XO
3idH91GfQdyJpzh/T2Nrf6bnQjlZif6/8X8Sttfj/0r8eT3ptVRNF6G3NOL9
NgT5qrjf0d2L4Ct0reBOC3gK3i8AG/Gpa6j7WI/9Y9j8GnRz7zxYEPF4JnC/
FX13ZHh/qV4nAue0uH0a/4vQX0nOx4Fp6kkwGBszwv6ayvd4jnNDOVVuxakb
3MJGTcxrsC2suWpfF/XZoZiO0g8p+V4b1Wgy+kan+yx4gXx8iT+11HhRuJ/O
+kyu95J6qlH+I1+R7jEq1mPhuXpwMefzuTMPzAFzwXeBxyqODsTfnXCrA4zH
16qwhqqlvuksn36Zi/xo9K1CX0WOc41QrJx1XZbnQjkZmu8yklV/dOPL0VTn
qjj7JpemZflefPsmzKlyqxgUS2nCe109v4tc1Yb9qJyqt19F/93o78J+L/rb
hzs3VdPbkd3O/Xb1l3oHTAjnm/j0NLU/n+u+ycd69GXneC+oflfDGaBZ0J/v
A0Bhts/GWnQkWMfT3LZmwHViOY6NbwPniLgijolr+/l2AMQSflc6lmC/GJ0j
wKPwbiY4E3hvqEcuce+/wLlQTX5Wcd4R9qdm8OwMnzGJUMcNXZnOVXFe3N+c
9FgV8xbWh8l/V6q/AXoLSpSjsJ+VO70xems0AzULB4NBYA221oKeAueeODgS
uaY0n82awZd5CxoiHpvsBcRalO2zXPNTb8mdyD9H7ZaDffhzF/sW1ivAQfYf
RP1MMl+wbxrmva0e1+wURyrD96cQ+x8j04xsBxyZhL3CmNdDnHgNe1sK/G3Q
/NnEujPq8k3gQ+5Wpvla36RLPsn+LvTVoq+H/SVwTjMjcB/lq2baEWbbHvbL
2LcjX5XwmahcKqfF+PJR1OUV44Gkz0D5cpZ9NesHinytN3RGif8z6N9hO9gB
dkddv3I4glyOS/O1vsm2aqLaqKfV22dD/miGaZY9H/XZpn4YjT+XA5+tmrFX
yGVPnnNLHPtXZ3HvB/H5Ge52BV5vzaCxmkfUtwy8iNxL6r10nx+yp3+TCVGf
zZpnR3K9p9RbmhnX8O9Qqs8KzYyJWd6T6k29UXqrZma5Lf0D/YC+yQmvreqj
2g3J9Pwpp/eTuxkJr5VqJu7kxdx3cSCH9b0Jr43ypVzqH0f/OqqpaptEJgGW
c9YCHkr3+aV/pn7Mr7eQaUv6m6y3+X/USHJP
               "]], PolygonBox[CompressedData["
1:eJwl0ktsjGEUxvETil6YpjFECJ2iI9FixFYUCwmNS6t0rbOpiDatW42dCgm2
pAs6Lq0mIyyERCruhB0LVladTZtoykIidn5fZvHPOd/7nvOc8z4zTT39nX3z
ImI9FqC8MmIKP5siMrURSxoi7jdHnFSUWxoxJh/HxzURH/AePuOmnln5nmq9
4jd937HL5VhdxHA6Yv+6iAPYJG9FXyZiYw1tcRAt8gEx524rutQexptsRGGx
WWKH70OYlA85e5mtaCbaT+RnnD0VLy+LOGiXqkZvWBWRQruafXjoflDdI3GD
/TqrIiaWR9zxfRfP7J/T+1zcrG8LHjgfR0ndgN6SvOh+dqGd+HJbPop3fHiL
fvPbaPxwdpaXM942JE7qf4FR79ztrCj2eutx/FG7V89fsWDmBbS5r1e3M1Px
LPFuWH4R/1ZE5M2/JH+tZ5veV+Invn9GPVI4be40jVNiu/dO+D2upCs+Jn4e
cVZydi1d8TvxPU+7B3X866BbKxbsfR4tq3mxKGLE3N80f2EOV+dHHNNTY+9q
XOdBl96U3jLNKdwyq2xWPvGHzg6M8PIET+/RnqHT6H83LX7h41fcMGe7/c+5
b1afRSudIp1CuvKbJr9tN82jeMyDOb6stcN/2VFqfQ==
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1lXto1WUYx58uWk53ljtncztnO7ue24arNLF1G3bR5liZTRwkUVqIuiyU
FDOzSBfEaBHdtDhzVlMiJCEzW2uUFptRlHQxyy6rwCjYKq3wrz5fnrc/frzv
7/193+f5Pt/n8qtZfu/iteea2Zs85/GcrjHrYXM2bvZMtdnLF5jVV5oV83zI
96enmw2F8+Uxs5pys5vPN+sv5azWrJ19A9hrsZMEPwS+pdIxe/m+JWL2+VTO
C8wWRs3W47ygymxSwv3K/6xKtyN7Tfg4BmYjPjfybXiS2egMs/vwN3eK2eOc
D6R5nwaedazCeW7hvJsY6tnvgkj7RWZ/F7rvw5yfmGx2VdI5idscfH7EndeI
awH71sDtITA7eH4DPx2OazLYwddTDWa7S/2u4tvW4LYfTLkWOo+xX1GCDeIa
qzN7Al+PEPeTrPdUe1wzY35P3H6E65/4uvFCs63c6wKTI8Y1rP8E7sIsxu73
rO+m/UzfpOfz4K4B/wD+W8CcBLMfzPYGj7+bNZ1wTeLkZRW+f4JDnnuDWddw
TrHZTXB9G3vzsLEEPoRng+Bbef+O/QFsrsbHJfjazN3CqZ5XcZgZ8tXC+cfo
/C26zY26XtItS+7ew2aK89YyNA+Y1qT7kK+/4DqEj0Hs3QKXNDW2FsxlcLuT
Ow3sJ6iFM9PcZgH+DoN/B3wH+FTA17PWY7eL7+mo39HdL/DzKX5Psj/FWXuZ
8xnhPJrwXCvnE0nH3873QeJdRk43gI9Qr79yPgXsG2nXSpqlK70v1DfzqJPj
cDuaAxdxrplz8Ae+l/1ezl8Ndav6rSj3mn8RP6tDXo5i547/44VLJthX/0kv
6TZKHP3U02Nw6GPNRj1exT0RfMmn+lZ9UYqNce40sS/mrAdfW+F3dc7zqBxK
T9WWauyKYtdU2i5JeT6Ulzb2R8D8AOZKMAdr3W+e85Kg4SK4jKFDL5xPVHjd
qH6awWfLvJdHqIfdce+Ru6j57SU+ByIJz4fyMkwsh6jPLmKZxd1/eV9Ij5xl
/Sbpvfw+Ni6Nua916LOMejtUZHYba2GoqzEw80NelJ9ImDnd+NyccE1OYy9N
DHm0yLL+HPe8K/+qtc6I69OB3T7s35Bx/VT/0q8zrMJ8gK1jcNuJjXyR41UD
OXK9FJv7Sn2WSYf7qatV8HgYPgfBV0X97nPqjxrXRzq9AqdfsP9SymeTZtSC
qPez+vpi4mgL9aw+ezbudsRFdVhc5LU4mvPcKYeaj7p7BBsbYh57P+dfxV03
6TcSeP6Btp3wbEL/17l3vMI1V57Xh5lfBH4pmE1wziVcE+VCulxX5ucdJc5F
mopPG+912OxNegzicyDpOOE3waU24XvZzvMtC76PdQ9PI/sB1kVlrpXm7kDO
+WuGqefVR7+zH6/2nL5V6jlQLm4F2Bz1maDZoH+StF2BvcwM166HnM+Oer2p
7q6v9P+F/hstYZ43xtyu7I+nvYfVy9Xl3tvq8WburYv53fmVrrU0z6Tch3x9
Sb2/kPaaV+3nw13NiV0prxPVi+a75vzl9MWpOj838MPhH6d/nf6F6v0qMCur
vM5V7/tC36m+dgZfO1gbwwxRT+8JM0r/h23Ymc3Mf7Ta/xmKa2XM+0018DW1
0B712agZOTnh+4KEcxK3/XH/l0urM2j7SZjDn7HeXeb9qBnwH7ReQuA=
               "]], PolygonBox[CompressedData["
1:eJwtlX1M1WUUx0/5imDFvVy4XLgXLnAvXDBMKhDpZS0VEcmXarE0N6VWJmLT
VbPUbL0tc1l/pJtb2B/5wlaareUqkVZCU0OXUTPMalpbjTZTk1p/VJ/vzu+P
7/a8nOec83yfc75PcvnqRV1Xm9nrYCzIFJmtG2NWwTjN+FjG7HSO2U/MjzI+
A0LXmmVdY1ZZYHYhbbaEg1ux+YPx9SmzKaC13GweWFxt9hH27djHOPtfzOxf
sCFithEMF3N2gtmNWWad+WZHcj22crgzarYUVI83mzvR7O+E2S34mJztPpfg
ewe+TrFfz/4y/CXJuRQU4CcKFrN2P3gZu81gPbkNcX4D+TTh67Uys2cnmQ0Q
MxQ3e5/5ATAlzF3Ad0F+GfLrIL+9Gb8rprab8fI8s7fZv4397aXkHvf5S/h8
g/gPst8B+tkbANXEzwQciatcch0h/xT2Eey3w+E2sIozXWAh/haAE5w9CQqw
zwcxUFTknIrbUXJaWWlWgm0CFIFicC8xDuH7R/JdxLiiEL/EayffQfzdFPJ5
F+d3EjfNnTspiI3wvw++WuA/FfD7BfzPZ34XOMH4JGjF5yf4/wH/LYzvAB8z
P8v89pRzLK6fAVu4z0F8bsL3L7zBLvYbybGN+jlPzEfZz+JOvwV8jCbhOOW2
OvMr9fQ7GAG15DkVLAg7f1Xk100+zfh7Z4Lfr4f3+od4Wzi7Fv8t2A7AcT9o
5g5zQD8xjoBh7M6Ai3DSN85r+gLjWzOeu2pOtddEjBlgGr7qwKdVZlcmO8ef
w990aq0BDOHrG9AU8t6RjWx7wSFQz3oDaAw5d5fZP8z6jJC/1Z/M+5gPwMko
47brzF6odhvZiuMP0m4jW71BL/MGcvoePnLgYz55bg/6o5Z5O3lF4acArIGb
teCpfK9d1Ww67mvaUw2plp5IOhfi5EnGs6ixnfReN7ibfKZGPJZiHidWSch7
ST21lT7aR07vpv3OuvvRmNvG2Z/IO3xbFWjJVfRJyHOWv7PYNHKXSUE9lLPW
SqydZd5byreS/DbzRg1ZHvNcsfuU72HO9BHrfNLnijnIvDnstTAHf5cSfgfd
RRo3m7vNY78VjCsxGw/WxVyLarDfg/3CiNeaai5MbvsTzq043oZtirMVYA/j
veDVhOeuO7Sx3pNwX/JZxvnL2FwCV1gfBZsirnXSvGVR1wT1gs6Px/5iwnPX
Hebi7/Gkvw3Ltpbx13pvkM25nFyvcdW6NFBaOIjhlwnvYfWyeli9rJyV+4vV
XmvSyOervQcVX/eNEP9p+L4Bvk8RvzbPNVfaII1oi7rmSnulUdIqaUZ9wE9J
2HtMvaYeUa9Ik6XNH2J3EJyLubZKY0eom5o8j6WY64ldR410srcKvMl+R9S5
UI8/FPUaUi2pRu8h/+dK/W+Rhk/D12H894Ix1N1YUIm+dGe7/u2m7h/DfjUY
xddfoIcYe9Ou2dLuXfkeWznsSHsPq5f3M34PnCt37ZSG1oQ9R9lLk2bGXWMV
SzHT+LuZtfmB/q0gv95cf0u9aVXUORAX6sGfYx5DsfQn6G/QH6u/Vj2mXpse
cu29D/sMWv9wnvuWxtbF/Y6KL81PsV9V4H+H/nT97d0pz116+xbjFdg/Ao7R
W8eL/U/S3zSTmLNAaaH71x2Sha6J0kZxLK7z496b6tFXSp1zcT8SaPlnMe9V
9ah6VX+StFt8rclzDddc+abxfyD4P5RjVdg1diioedX+ylL/q/Xep4u9B9WL
D1BrSyP+Z+jv0B+vv/6rmGuNNEdaNjv4P/Rmeuv/AVQxRqI=
               "]], PolygonBox[CompressedData["
1:eJwlkkkoBFAYx/9hJsscLGNpxjJjy56apJAThSHbwYmEkyxzcrKWONA42VIj
S7YSFxxdzBys5aKUo3JQshfCb5rDr+/13vf/f9/73rN39Df1BUlKAQNsJEu5
odI20WaV7JCVIXkipAGzVJUmVcNPgvQNM6nSWLjkJprJqw+RVuOkuUxpHirJ
rYBF1j0maYk4EosPNZ6p8WuR/mDKJhWHSS608UlSApiipAh4sEt3RumSvGG0
Q/CINoe9dnrwofVCDpo66nvwOOL8EA4gnXtNoP0k9wM6Oc+mVg+afc4L6GWP
6KWWD7rwHw6WGsg9Z/8CZiCNPDfRGSPVgpXZWGCZvSzOGtG9o7lmoL1494ML
8snNgzXmc88cN4hX7F9CMz230PMuPbWhb4Vj/DK4mxOvs0TpFAbJLaTnbvJe
IyVkuuFOJ8zGC19oauhhFP0L+6+WwDv532udmbuY/SaxKDqw3mG9Bdv+d8HT
gfe4LfCm/rf9wO8d3vzzodYTfmWsb+nLwV1KWJeCkY9jgAnqTjMzA/NIpDkr
zDLLSf7GCn9jHu9yaiwQO/lHXfAPV4hehA==
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlF2IlGUUxw+rrpYmju/M+u67zuzMjvPOGq2SmB9ZoSh+kKCmN4FoLHbh
x6oXoheJRhdWflUKLUkoiqyulAgKZh/eaCJqu4oEtXaV26ZkubKYYoH+/pzn
4uV55sz//M/X/zyl1g1vra8xsz18g/gWRGZ9tWZPErM1zWbV4WZ/l80W8p17
3qylYrYtZ/Yx4Kdg1tWZTR5s1jMWXzDfgGkGM7jB7A48Owtmd8vOI74yPkBt
JvaDTWY7wH/J+TU8bz9n1l00+yBj9iOYA9jHwIO7xdjSerOlxOoEu7fJ4/4f
gy2ZjYJnYJTZv/D2EncgcR/5luDoqzq+Dd8rfL0jzY6NNxuR8Xxugk/Ju4f7
odRsSMi/ttGsnZx+p0mtWa9ZtW+nB3OJPQ7MGWI+CvZ75HI/8RyUy5K82W9w
nko9tnLIYesY7zkc5zyAfTG1f0ecf/CZN4yecx6mxiNDyQ/8u1nP4TKYi3yd
2Kdi/y/xeb0PvptvLZhF5LUL391guijul7Hez7VF95Hvq5xN9LMN3xNNPifV
W0Pd1uj59yfeO/WwQzXC24p9Izyvc99CvYvoQw81b+W+T5rJOv/0vPdCPfkL
++bEeT6FZ2XW68rnfU6K9QT7VfmDnwhn1OD8S3Jev/CNnD+DacM+Dfs7sfNL
j49Dbh9Ry21mvfwFsz85d5HrYXzr8q4n9WE/Mz8d7CvIpYv+t9H/fmyPQz/V
14PYl2G/hP1+0TEPOCdkvbfvcZ9B3rXM6zXO+UEPl+CP886v+JqB8JuK3i/V
tTrx2nRvoNb6gFdeq8Kspbt+dPPZCOJzvgF/Gf6vCq5LzWth5LskDZ8j7g54
u7Gfxbau6D3R3JLI7R/yfzO/C9x/yHgf1c9bmgMDStnTGvZ0DbVPQqtXIY7C
XF4C+2bss16R892TnvUGdIW91j4Vgg5LxJwb+Xylqe/B/Mp9SsG1Ip6V8EyM
/H24R/xjqb8heksqsec2RXpgN78Ak+MsBd0W6127ur882vuu/p+CvxpqHIBv
fdZ927mfTP0d03vWGHtdLfB3Yr9Fmq/Acyf0oaPidSrP44n7iyeL/XyoZVLk
mpa2L2S8Ntm/5f8XK84p7svhDWmo97dAb8JUYs0OM72Y8XiK2wJnJfIeaqeV
n/LUHNr5naK3zwu+J7LfSPzN0ts1Gc5ZgfNowT/dpZ0HQUvX6rwv6k8auy6l
z+sMsBziaoZ/hD3SPklP0s9O7UWYnfZe+pMOPym4VqSZ1fD/xO9p5Lkq5++j
5jKHWH2ht9LaxqDPh7HPWLOuJr6f2tPeqr/1evPnsR/PAK6D+Gg=
               "]], PolygonBox[CompressedData["
1:eJwtlUuIFWQYhr/U5lrQucyZc5lz5pw5cy4FBk5GN1oUWmaBZSpJoTHkorGp
YBZSRkELK4soKEwazcvC2ii1cpyx22ialhYRlNpGzIqG0qlgatXz8p7FC//l
+97/u/+V4adWPjkvIsbAAnApH3GhLaLaFTFbidhcjnitPWKIy5FMxOvsb+mM
2MPZ+nTEN32+X8jZBu7HMr7fzVm2GPERfB+CZiriWjDWGzHFfYk3GtmIF0oR
z4O7uVsGDiH7I3dPXx3Rloj4j/1F9oPY8zf2LKxFTLA+i63XsZ7EnvvhO48T
G7BnshlxGd2DyOyrR6zs4d0O/IHjDt5rsG/r8BtTcJ9vRDyC/FH4fsCXX1r7
xfh7kfWugYj3QANfmmCc9ZYu+5djvx3b6/Btmh+RKkTclIw4B9csHIexpVDw
XZWzXtaX5Cvyr3D2KPbcmLQvslm27yrZ3tPYtwX7Hs9bX29s424CLGrd54nX
wz3eD7JfBt8hOCbAELw3gBPofwk6iGUnKKPTD7Zx9g5YDt89JctI9nPWn+kM
ruXgJOub4d9IfKutHCqXg5zXwLPoPAP2sX6/ZJ/lu3K0v24ZydbRaYChlGOv
HNzG+ZGEcyOf5fs4Ou/W7YN82U09jVwVMYpMJccbvPXcfNtTgytTdC6Uk7cS
tlm2H4PrODiL/Cjy13B/tOIYKBafcP4pWJE1l3z8WvYnXJuq0TuRn2BPWcQI
HP3IVlKWlw070W+0+CVTZV3PWn8G/c3obyq7N9Qj11Ofv+ede9XAH7z3Xd66
4vie9WJydob9g9RfHX+bNdeyzuqsl2Sda+VctTCPmvq11R+phHtQ7w1zNofs
ATj3g3PY8lPFPaZem0X3r1aMFCvVhGpjDevVYBKuqYR7Ttx640reWkq8l4CT
+PUV+Cfrt/SmfL3QcC+ph35m/Xbd+dvejX3YP11xLuRvDd1FSedWMpJ9ecB8
4niR99cjsw7MYdO/oB0b2kAX6AYby5aVzhOs76LRllZdQ6qlDBw9CetIN5nw
bNOM+zPvmMk/zZg59sNpzxLNlMPwfZt37pWjU6x3wrmj7hgoFqeRWdvpnn+g
6BpXrSvmir16UL0oHekuaHq2qQc+5r6cs/9r4DgBV3/Rs1UzVLNUNaRaGgWn
2G8d8CxWPb3KOolPiYJ9lK+rmQeretyT6s2tec8K1YtmxeWyucR5vNcxVCzv
5e4+UMjZ/1XcH0O2yL4PjPP2jox1Zlrzu0le0jXnVvlTr65Lux9lv/4K1Zxq
bw927AW34t8H7fZ3L/JXEI9o+o/QXzFD7hrdjpFidabPs1j1pFn9Jj6/Ib/h
SYEvyrZVNj+W9p8hXXH8VnWPq9enwZG8Y6y3ZcMI8i+14qP5o79CNuleORnI
eUZqVj7E3VownfAs10y+Hf//B2uL+s0=
               "]], PolygonBox[CompressedData["
1:eJwtkcsrRGEYxh+Mu2RmjIxb43ZmFNlYUHYyclkIIzaUrJSxsxJWygZTUuQ6
amaUhdgQFi6ljD9D01hMbguXld/pWPz63vNenu95v1M9MTMQTJdUBZnwQ/AN
v/CcJfmd0k6JtA1tldJRtnTvkcZd0lyG1Fsq3dB7C/dl0h20E2flSF56zmqk
U2hCx8iXErXSKPkROKGvzrwDDSfaDli3S0t50i4zrnppk5lgsdTJnB9S4CXX
7LR0Tf0nvIUKpDdDSsILXJA7h1fDqr1z9nFnL6xyb5J7beXMsMt0Ln0eq9+c
q8RHmD0P0N6DfUgx08VOb5xj+B2HK7xewmeRVITnu2ppkXoC7W78zRMvgAu9
Fpu0gs4ahCBGPgoRYCXN8m4bxAZ3bHLa8eaAdJ/1bkmziTgNnvAahy50B9GN
4fmB7yH22CWucLOD23oH8z1iDfzLQumRmo8ZL1zT30//Frlj0wOeO9hpiPcJ
wCe5D9M/8TL/+Qt/0X+dCGeA2jA0Up+iHqfezXcPHBKHYZJaK/vEyf0BimVe
mQ==
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlFlsjGEUhk9rqapJq9P5OzM1v5mOzjCxG0HEhUgbihtSImhFqARRIUgq
sVRqTSTWKLUkhEYktgsRTUyQ2EoIsVxK1HLRhtjvPCfnu/jznTnzfu95z/Yl
ljfNW5cvIrv5+vDdHSHSOlAkx/kpLVIfEPnM+ZXvfT+R4iqRksEiCTA9CZGd
vkgl9+7h61shsgmSOSGRa/z3tr/IzahIhyeysFCkKy5yG3sx9jfsC/z3Gkwc
jivYb7Avc76MG6YxKZIOi0wh7sZykVflpkG1HBkkcphvTV9wcI7jzOI/gJjt
aNvPWYeOkQPghr8YXuTJaOwGcjpQLLKUs9fF0pjxoMhqivEITM7hC8nruWdx
tpLTb/zd6GwGE0hYXI3/M26YZ9j3+C9L3IaQaUwELIfHYOqIddYzLsWnyO+q
yz0dNF13AqZNtaqGW2jIB7OK2g6DMwfPB3SWR0QeYq/lbgV2A1wb8Pdwby9f
Ag17OHtT5I+d5W46ZDwP4PuStlrMzIgE6es7Yh0Du9o3nhnoqXJ4jX9Ue02s
ycTpwO7SOuC/gT0G/uucRb7VcAh3p4UNfx/9s0I2G4vA1+BvVhtfO/Fu0a+a
pP1W/wkwB6Nmv6NOB12+9WUWWznbiVObMf1/yKM7bTX7yOkNtpkspXgFFWar
77rjWQbP37D1bqVnHHpXZ+upbzN5nviNUburM657kC00TKnjPI7/DPrfY08o
JU+0xrjbSaxk2OxE2PZBcy/iXkmV8bSiZVbG+j2b84+bqx9wRsJWc639pLDd
1foNj4FF8zmCTyfeevAZ+h6OmL/Ns1poPtrbqa5W2rdrUdtH3cuTnuGV7wxc
5wroP/bmqPVUe6sxFBPD/1VnArtL5zxlu/eL83vKdkd3ekXSMPVJ41LOQ3C0
UItt9Hev7iW8PnOyw7ceaC90lkcETduNqPVD+/JiCHk4jPY/b7hIE3nlc9Zy
fyA8I0MWQ2OFiLkQfwn+Rb7pUD1P4auOWY+0VxcrbV/GUr8q1yPt2yM3t7X4
/rn5133SudT5DNG3Bb7t0SXexgdomk/upz3bb+2F7rjv3hDdg5x7S8fTi4lp
q8O+Svut/lOVNt865y3kHgpa/bdgLymzvMq0lu6d1PcyFjH9uvfVQdOp+/rE
s3y1V3lDReaicxf18R1e817haqvvVpubgVExe+P0nXkStfnTOZwZtLdA34Rx
1KrTvT/6ftS4uFqnZof/yf/JoOnUHfoP52/cNg==
               "]], PolygonBox[CompressedData["
1:eJwtlW1olWUYxy/d3NYqtsfjmc95judsZ6ed40a+0XKmUFk6bSKFoiK+DKSU
ZmVEGvihQhCXRYR+SMqloBGMIHEDaRMasw9hyz4klYkfor1g2pzO1CjC35/r
+fCH637u675e/9f15LbtWvPaVDPbA0qB1ZqtrjB7g4+tCbN9kdneErN5fDud
NbtVMDv0kNlhcBv5vXqztyvN9oNvGs02zjbrf9js/Sqz55rQ4f1ImVmO++rA
7EhsrwP7ddj/CJuPYHsInT3c/VBjtpNANj1gNl5nVsKbNG8vcn+c+9VJ16/n
vCQ0W8i5mnOGcwPnY+h8Bn7LmV0GB7Gf4343PkvTZnPRnwMS6MwAO4m3A/yV
xx/4h2/3wL/gP3A48HyU3yfk2o29R+N4k8RfBD8j/1+Of+6u5zxX5XyX9y/g
63nwMnIHuA6ugXF0b4AB0Fzh9chi63POJ8GT5PIU2Bu5L/lch50rOa+HfH7F
3YNpz43QrBz5bOC1qEJ/PXaWgqfB13zvA9/yZgf6qNoAchqfETiA3KmaoJMI
vAaqRSs+sxWezx3ObaHHqpgHsTtEjzbQq0vYW54h99D9qycbuD8XeK/UM/V6
/nSzVziv5c053p4F/eClGWbbwRD974j7fxN+9Sn2rMeoWNMpf7+O++941x15
LVQTcaUW3ax6jm49eIZ4loZeU9X2x1lmF8CbvN0NmotmC0qdw48j79c3bB+n
n5uJ57HpntsEHOiDJ6fx9wv+dnGewvmtuD/KT9xcgP6v6H+AvW6aMivh9RLn
P0T3WI3Hrhyy5HKS8wlQj5wHf8LBq3nnpLj5BzFdmma2BX8jRc9JuYnj4nov
PnrAKG/GwHDRdcVZcTdDT1aR3+/E0E4+M1Mu61uI/GqN57sV/VHeFkKfP834
ZMFnSLN0SLMATkQ+i6q3uHg+ci5Vkn8b9V2ZcK6IM+9wrsNebegzp9nrItaj
IEVcEeiM94d6cC/0GdOs6ds+4m/BxkLQh5/+yN/obQ996gWppM+eOPAl94OB
z4JmoiX0mdS9etaYcI6L62t4t1a7BDkf+YxoVpINZmcqvYcJ5Oakz5I4ncfe
qibfbe3Uqw25J+aDfCiWaYFzQ99OcXcm8Ppo5lKh7wDtgo/xdQSsyHrtpFPF
9xKEqWmfQc1iVYP3Xz2qRl7Z5L717aeZZs8mfFdrZ09hd38a10/91y6eqPNZ
Uk8v0Osmev669jH37/J+Y+S10o7sJJberO968bU19BqpVpohzdJysCz0mdRs
LqEXizPOYXH5JvYmwC24MQkWcdcS60j3i0avp2b8PPpdNb4LNA8ZYvu74P8W
xXub2MeKzk3lq1kQx8X1YTAS72ztbs2AZqGcmpUFPkOaJXFG3NE33Sln5S5+
6182Gf/PnsB+MfQdqV0pzoq72/NeP8X7IvJsbBVjzog7yYzvCvVHs/R9vL+U
43jBd4Z2hzh1lPN9DwMEkQ==
               "]], PolygonBox[CompressedData["
1:eJwVkL0rBHAYxz+dd6XIeefO3SkGkpKzYHEMEpHBQsnL5krMlEFhopCOrGQR
mxsUAwsG/4Bict5mBh/Dp+f5fZ/3X2QqOTIfACokR2JVEJWTKGwWwrE2WA2l
0lwGhfnQH4IG/bksSKt3+I7LuBQb7zDWqN4kS/WwKI+10JYN0+XwHoGIvTPa
N3MycmHOuUwE4dmFzvS31bdk0n7t9r2yf0qiudBVCUPqw3Km1mr8QturnpA1
/YjaujZQA1nSUgcD7rDvDpf2T8u1jBbAjTZuvFPqrXlyRqwUQvpheY3BiwSa
IFnkX5XAqix7x4Z/dO99D7Jn7q7s/O/pf866f4/7dMupWrM7nWhnvXNGbp07
5vw77af6h7zLgn+QcP6q9w1aQxi+7PUtQXc8yoNDB6TkQH7Vf2TF2pD5fdb9
AcPPQNU=
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlG9olWUYxm9yS9fmdJ61c84793beHedZp9VEkgURRGa1LJCCQCiItEU6
kpKgvoQk05YWQn8MTCKJog9GkhFYkbi+hI0IwaAPEYREY5uY/zJG9Lu4ng9n
z7Pnve7rvu6/xVM7HnnuuojYx28Rv0/7Iza1RNSrEe/2RIxy7++LqFUiVl4f
caIroqOI2NMWMdyIuMh9H4YXsogz5YjJZREPNCOGsH8e/C2cT3RH/I6Tr2oR
Z7H5BM5WsPe3GnMOv3N8G4dzSz3iDvz9wtsUb934K6StN2JhRcS34NfnEUf4
NZdEfMj56I0RL6HhNTRU8bcdzBHiuLTaPv7mvAjns2golyImILyMr3/Q8njS
NoGvVnxhHufQcCI3fgNxz2N/oCPiNPm4BG4Htpd5Wwwel/E1f36t23ZyIKKF
2PaC6SycF+VnNxp7S+YU99VO/Hc6F6dq1iztV8DvBH8f+OXgf+D9Gd6OEs+b
N0T8hp/Ng+CI6xBvn+FjCe9HOccy49/LHb84h8nZTN06pfdBarOfGm1sOo/K
5wAf78JfmXxu521N4bqohuIS5zYwp9v8rpzeU3HOlftXMt/PFs61vu8iB+18
u7KYfoHjscx13Mk963NfHUZjKfWSeqov9Vhvxd+E6QbbXfVd/fhyzTnbX3dP
iHMvnH+lPL+Kz5v4fwG/NWkH/zH3Meo8wv8txLgKzLal7gHl8bubXY9JfB4D
/xDvxzmXU8uD7RHLOKc7jJHvWXz9gc45nK/KnMNBzm+Sr1vRPE9vbcHHec7/
qs7/QXhGiK0Af4paTBeJh4+jqe7r0VZJPVzmnMiNX4vd8dQD8+q11Evq641g
2onr4dz5VU5Owr8u+RLHVmymsB3jvHuF71ODnjHN2hrefloZ8T333V2OR3Ft
Vj9UrO1etL0zYA3qx11phpvoPJ87FuVmtOm8qk/XJg1v5Mkftk/XzSVOxa15
Um+Ja6jPObyNc0PJnOIeanOfSN8BbH7m/W3OvOT7STB70lxrvpVr5fzLLtde
nKrP1h5zvcj988wzq7mfT/tnmu9VuM7AeSjzPAvzRZfr+eRS94R2n/QsKntn
yXYWjj/rzo9qNZP6RHXeRLwNavR+7vlT/ylH0qv71VbPj+boBexeBzOe/KnX
1XfanTMN7yvtVMWs2N/KvK+1tz/qsU7Zy3Yu7a7Z1d43P3aY63DmGBXrZMJK
g3a0+EtV7z712DEw/zas5xrnB8m2n9yva3g2bue8lmZcO1s6pOdO7fKyuS80
vNdU9wWwI4V3/3Bh/+NJw/8iDfW+
               "]], PolygonBox[CompressedData["
1:eJwtlW1olWUYxy/35tbczs7OOds5j9vZnjPn0ZMvo1oqFrky3Iup9KFM+mAv
pE1JKipLEFJ82RALUqIkfCEVNifilEQRV9SHKDFRMA1ECMkUDWGzDIl+f67n
w59zPfd9vf6v675O+Oqa598qMrN3QQnYGJhtAEezZsNgQcqsqdwsLDNrT5vd
yJv9XWrWW8Uv8lZ01xabvYmTiQmz95vNplWYbQEl9Wad8gFi6NWAf7AZq3Af
l7hfwdmPZR5DsaY3mh0Yb7YYnS/qzCqxvcf3eXSy+F+L/gfgOXQXgfv4W00u
/TGzi/ibi/0SCrlELbOR34nyK+B/H752gh1gNrXMARNBA74rue/h/HJo9mvo
HIiLJ7ifm3Yb2QbIGdBK7Mngvaje74l3rsEsScwu4l+Dj5eTZsvw8RLYim0f
yGEbgheRl4KPs167OHgDvWP4W1jhPgJ8NVJzA9jO3SfgeJxzYv1AzSunmM3E
fgb4hvMTIJHx2LJPIn8X994phmLdjfonzv5FbsXZae7LuS9Qzzp0PgKjnI8F
7lO+VbNq78thX212dgLzgH0Smwf05wI+vkJ/ZCo9rnadM1O9J+rNa8S7k/ee
qXfiVNx+Sax8VH8Nde7Peq/Us6e5H5tstgY+FpDzKHIh4/J1OOioNatP+OxJ
fz3xTzb77GiGpsHffO6fAeOazIpAO/5Lyp3D/zLOobjc/hD9bTVrq/XZ6ef7
ALUOq3a+y/k+zFz8lfdaPq80u4V8vcXvZf8H8llmdnWF5zxKLr/Uuayz23zv
CHyWNdOVKedYXNcQJw5ixLhX6m9kM/Je7vaAr8F+0I7NY6AFbiaBY5wNgwxn
AcglvBfqSRO17gr8OyC/cXGfWc1uEefFoJT+HGRWfqafj+ZdR7rK8dPAz3Sn
nJTbIGcDskWvBDye91mQjw+prxvfXSmfec1+b/S+1eMlnF9tca7E2RXkVRH/
6sdNvo+EzrXujwReY0v0ZvR2FFOxxYm4qaPeVMJ3gnbDrpznqpwfIbeegtm2
mJ91IcdavXfLifkn9y8Q76eoX+rVpmZ/P9KpQfe30PkQh7vVC3R2gywJNoFB
OB7Ieg7KRTtRu1ExuwseQ7H6+L4A1yN6j9q3zGsb9dyJ+BAH4kI7UrtSb1pv
ewj5UMS5uFeP1WudDUU7QbtBO0u7S29Yb1k7rRH/vfio5/t3vp8lv8+i+VNN
qu1U4NzrTcxSTOZ/VZm/Ib2lh6nx7TLnSFxpJ+tOOmnuHgRei2q6j5yL9p92
2FHsq0L/L9COfB3bFDrJwP8T9N+gNySuxflN5Bkp38XKvzntPVQvtVO0W07G
/U41dmBfDKebI//679GZ7rTTJhGnNvTdLJ0E8ivs5OVgBN1vQWfBe6OdqP+2
maHvFtXchnw7cO7E4ZPkNo+cnkp7z9X7/wEfNPcp
               "]], PolygonBox[CompressedData["
1:eJwtkbsvg3EUhl+tS2mJ8rXVRm+IJoZOrcukSS2ExeCyuKUqVBhsjIa6RGIW
CRK1SbS1SlwmEQP/goloR1MHz5d2eHLO9zuX95zzhVe2p7csknzQAFcBacAm
5bCjXVICnkLSI3i8UqZResYP4gfgpkc6aiEf66Dmr0myY7s7JT9k8D3028Am
+R6DOfxZmIcH+lU6pAI9J5ulPHbJkJYh6ZJ2rPRkuF1y98CKb4E+YvX0jfPW
Fpay1LZi025pDU54D9N7iPnHyZ2AQ94OIGvG2HWGPr/90qlDKmNj5MRhsVda
gDd3NVYiNkWNHb0ocYM6l6+qY+rFItI7eYNYp1NqhxICX+j/mBrstMl8ZewH
fMItcRt3u8MWybmHqJ97cr9X4hf0vQRLUKqDfXSPucU3eUVmKUAe1vl5Xm46
wp7DcM5bhDnPAlUdUy/NLi9oJbhzjvprCBGvoGXQd7UWT9X2Nvf/B57oR7A=

               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlV1olmUYxy+2aZlOe7/2bE+97/Zubc+0UkcYBUH2wYogD94DrSCcKzVS
7CTE6KCgiEok2lEdCFmsg3QHfUAlZEzQgwkxQg2k6JNZtiX2YTWi+v353wcP
1/Ve9/Xxv677f91vc/yJ1p62iJjga+e7rjtiN8qGWsSuzohH+UY7Il5bHjGO
fm5JxCLy+FURP+C/UNg+X9h3e/LvqUR8tjTi/UbEjpRHscuxn8S+JY/4tyfi
Q/QN+PxS+Px0FvEBZ+NgmGo6Xnmew3aAbxZ9Kbb3+iLeuiKivx5RKkXwM/7g
vK034jt87qZOmR7GyPMlde5D77+SHMTW+Ggz3i0Z+46E7WOSPE5sDf9tne5Z
9ttw3kueTeRoYX9xWcQJ7N+C+UF+f4W8kBuDsNyBX06tJ6nzbG78z+u8bsyf
4riWHHPM8G1m9WvhuZ3JjFWYS+R4oelaq5Aby57358QeGHDsVmxj6NO6iyHj
Fv4by56pZttO3emm77SBfgq9gv8M8mDuWlVqnW66x3Fsm3Pf0Uvk2KxYMF5P
7uPUboFnGvlU6uFmsB8BwyV8RvCdRJ9F/43zKnfwGOQ6R9//pbt+fdB5lf8h
6uzJXVf1v8jMub8Kz0izGiA2Z/7X4P9Ryf1rDvPIqT7fwyniXkncqFNzZ5ex
rSTnVOJSTo8Xy8YwTP2fcvNEfNGZfMQ75VLObwrPRfOZxH6Z2KP4jxCbJf/v
6elQbi51lJxX+dXraOLDww2fyecwtn/I8wgzeQD7YtJb6H8m/U700qC5V0be
Co6ZFfSD7Ow2HvG62m0MwpKl+dSQFwpz92fkYtrJS4X3Qf3uIv/XPcajPdif
uCROaffE97/xX8/s3mSG65BjYDuPzxnsI4X9FTeQ+a73YfsxzXMnOa/OPat7
0UfX+D2Y6PKbIh7Ow9Ujy5xfvDkx7Dfl5LDjlWeOHDcV5v+SzPeq+13B+dN8
17Jfd9UcrzzCIV/to+5PvBQHxIVVaY+Ub27I+6K92Zp2Zzvy/JB5dTu9znaZ
8+L+xm5z+JBwDRm/9kk9q6b4fnml70i7LH6o9xL41zPnd7Ddgu8b5NyEvrbu
d0Sc34dPR+a4vX3GLpyal+bdSr0sJMzCKz/5txNXTfteQR5uGKfwilviUj/6
Qp97UU9daR/lu63q/dI7OtlvbL3kuQF8Z5nDUext2hl8fq+bx+LzMbg8gT7I
/F9t+C3Wveynl09WexbHVvvuNYca9oP030svz2TmurCJ76qhWuvKfiOErVzx
f4v8dydMwqb5zaTd1N5XuIOXmVW56fdXs7tnjeup7v0N74B24SLyf6v3/4A=

               "]], PolygonBox[CompressedData["
1:eJwtlVuIlGUYxx/3oObuyM6O48x8ul87M82OrroHw9RIK7K1XPFiL4oEUUet
NUUhIVaEFFMpDUpxVdq6aKUuKpXoSKC4ll4YHm5cUSHzwEqyq5ko6kX2+/N8
F3943u993ufwfw5ftrS2Y02ZmXWBCnAuZbYiZrYc/FM02zXWrK3Cv/3LedEY
s31VZks53+T8fmB2erhZZpTZhaxZbcKsE4Pvlput4a4BFEBj0mwS2Ij9J3l7
DP1S3uwhNi5Wur9HyHfrzc7ibzU4g++Qt6uxtQybj2rNKnn/wRNmHej3oz8D
fI3uyWqzmciDoBTzGOMFs8kZt9fLmxbiq866/nbOCeQwbVYHxoHx4DIx/Qku
gkugFZ07FW4jj+/movuSDdnqJL63wFxyewXEyb8m4d901x2S/0jn4znsp7lL
gfe42whyac9NOT6F/AyYBrbybhvogo8mYr0BX0vIvznruXwLpiNvzXp9xMk2
5OsNZn2j3N5V5HJi/iriR7H3xc2OghZ8tMp33mshvofwdQobCc6IdpP4Xgcn
qG9ADi8mvSbSVQ0/x9559PvBO+itA98AzFoJ/weQPwM9YBg+y8CJCdSRt9fR
uUF8d4pe+1XgPLH+zv3DmOcwwP2RuMeimP7Az2/Rvd6/AB87sf0J2C2uQVfg
XKsHxya8JqrNtIjbOXD6Uug9qd4Ux+J6KndPg+/iHv8SbMQQ1nM3fqTH0Ib+
vcBlfdvAXTnnn+GnknMDfs4VvVbH6emTKc9ZuStGxboZnfnoXuXN34HPmPJ/
U/2c8pqoNnPQexk8X+u5Kmdxo2+6e5W389Q/dWb7R5i1U/891GawwWsv/oaQ
73J/e0Q0o/AREHMm9JqoNk1RP98fbXZ4IrpFn23N5C3khVH9c8Q8D789vP00
9B5Xr+cj/x3478H/3EazN2Lek22NvhO0G85i42Nsrch7bMpHtZyU8X7SfGlW
W4rerwPotCIHfMuA3hx+wOJav9NMaDZ2BG5bPh7XmH2Ud/51v577wXrnTz2u
XlePqld7yWF/6DOv2W9Hng8O4uNAzneAdoFmVLOqHlev/0QtfwSdxL5ygu8I
7YoP2TXbCx6DYhHfm3gXB78il8FfDv766p0rcbaUXToQeC+oJ/7D/7rQZ02c
vxb4G70dxzlFnM+CmWmvgWqxD597Cx6TYruW8dlTD19G/jLwXtb5C+Qp8Pf2
cO+XQ8Syh7fdBc9ZuWunareKQ3GpnpKu3ozB3uisc6saVaTcRnuUTz29cAsf
Q2AWcc9O+o4X95r54xFn4k4+5XtL9P9Qj5ah/0vcc1XOzeR3ZKL3pvypNx4U
fVeov7T7NHOVET9B2v8x+tdop2u3d0e7oYpv1UmfMc2a/hFD2Eqm/a1szAgd
kjXTt+Hqr6LPsnr6CvKO0GdB9ami/5vIeQGx9MPv5DrvAfXC9+TxQwTJB4n1
EChF+0n/hF2h56hc1SM13P0P/7MO9Q==
               "]], PolygonBox[CompressedData["
1:eJwlkLsvQ3EYhp8Ql16W9hzVniDapLOEqRIGtbgt3SVSi5AwsPgbpIPBLdJB
O2N0megokZj8ASYLBmIS8ZwYnnxfvvd87+97T7G+VdvsArLSI+0RaMmZrCmE
AWQGYKUbmhEUnEdyUoarXvgtwJH9sUzkYVwa6qV+2LPuS9n+wFpRm5R5feak
qu+Q2q7aTuxrv229y8C9fA3DRx98Wge9Iy+XRbiQc6l7U6jftD5TsuHuize9
6t0umUPGDPZsrkP9FtUXZElu/e5b7UGfIAmP1jf33uU0B7UEdEbNa75IsnHG
FCyH5nZ+LWnfTElavyf9GtH/PNYDd9ad3djPqK/6L398r2o/K3+1oDQh
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlVuIlWUUhpemo3sODXvPbPfup73Z2617N9PJ8SI7UELEeECCpG7GypiS
smASmmwiQigCLxp1skSx83TRheRNRV1UDh2QkVIDQzDy0EmhsiYJEoqet/e7
+Pm+f33r/9a73vWu9deHH107Mjsi9vBcwrN9cUTWFtFdZt+MWJ2L2Lkg4uKl
EYc7I96eE/FBLeJ27AX5XhaxBttefCYaEUNzI3awTnI+I99ZEdOliDu6Io61
fMfZdt9TKDuWYm68IuJUR8T7+Yg877dwzy/4f459kP1ww999lTAcJt4IMf4E
ywzrKp4T+O1c7HsmhK0K7nncV4w41+7vF4FnsG78u7njBmIc5c7rWX/LIjZB
wjTn79WM4XGwfwaGcXyWFyJO47eOXE6xjpbs879v0d/qjsH+iK3dEStYvykZ
1+/47wbTabDtYX2kYn6Wc76U+6ZzzvMQcY7w7JtjLo+kfD9MnIv7p4nxJbyd
r5hX1Uh5LWuZnzdY15D7MIW9HI6rPBvBdiUYZ1rm6gVyX9hlf/HSydk9+LzE
3S9ytgH7OPVv64n4lFgrsOeSz0FqPpjZ/iRxjvNOGvEPeLYkbOUex1PcJrab
E54/4HCS/SF8HsM+xr7G/mow5vnmQXz2YutO+6mK89SdT+H/Ts35SpsDZX87
lXdsYdjPfiLzfjb7t1qu3Y/4N0rW5QD1LfGMiwd09TNn2/D5gjpvxucA9pWc
n8H+PPYfmsYkPDdKs5nz+qRursVhk1pfm/AoJ+GWfxd53MZ7bn7Erax31l3r
u+rmVByux36hYH7E05KWdfBxn/mSfQn2v9Jetd2UmcNR1oMLjPN7cPamntpf
dw3E2wWw9PbYX9w/V7K2ivh8zTNKLmu5J9DD3+3WpXjSu/biUXy+jM/5nPV/
fK61q/N14L2qbP3fRM23Ndxv2xvWvfR/DN95ZetHOjqQ+lX9k6+7pqqt+BVv
E+B8k/zPMHfu73d9al3ukVa/tft6y3G0l4ZXFp3LQ+A8m3pZfdlbdw+1geEc
HC6iB79teBZprolrzS/NsUbF2GYSPmlLNR0Fz0d97striDurwxxpvr3WMrZX
WX9N+arv1Ruq7+rMvP7bab6eaHm/Wb4N4znJOp6ZH/Wiclbuk32eAcKpHNSX
qoH4l37H2oxJ69E0N6RL6bMjs9ZG0mw5SbwhcH7H+lPTfaHZplm1Kt15b2YO
pYvryt6L111prmpO74KTreQzuTDi7qo5eLhijMIqPoVdNVOMZ9Xj6P8Z1oGk
bWl8rOa5tb5g3ahey4j/SsuYNeOHUp7Ka0f6v0i/wjuUdKiYsstH/wnlugWf
DcQrEveBqmeWuJ1f9L9NPdKouk+0f5ecLvaiG/4XJ8jlvoKxCaNquzRpb6rP
/a5Z+x8exRGB
               "]], PolygonBox[CompressedData["
1:eJwtlW1olXUYxu9N3ZrbzPNs55ztoT2ds2M7bqA0i9IvRZGrJAJXUShaLaQ3
mIJmgyKTXoh0hltBH3qjFfRhYUVEX9IsCnK9EDSSfJsVuaAwLKgWab+r63y4
4P4///t/v133fT/loc2Dw/URMQLmg/XViDMIZ1siHkQeL0asaI0ogZc5b04j
hsE35Yhp8Arfurn7eWHEnkrEZCni+iZsgJ3cb8wiNoD9uYgDYHvVtv9Gf2sS
8VLVtvfw7bNCxJPols6L2DYv4rKOiAvAEAHeyzlDbk4t69sfvB8r2N9T50cM
9JEAPs4tjngUvZ1gGW9KDRFd2HwY261tEXfX2/5G7kfwH/ifwEaFXDvQL4I8
KIA3yWcNd2vROVS0Tdl+HDxRg+T6fMQ88BDyF/jrIL9/iWMG++t5exobU7xf
TE2W1NlmDvk49+tanYNqd4zz4QV+cxJ5d4/P0jnB+V3yS7F/vDni6YvIhZzy
5LaFfGbxvY973MQGzo3E/wtvruD9EfAr8nTR8v8cVc2JuJkils/Lzlm5r8Tu
qsw5KJcpfG7BfqUr4gb6Yy3vDxDvW2AfKPG9DMYLzk35PoK9XfTEV3A7BfqV
DzZ2peZIXB3lfkmz88lTv4S7HOhGroAz2B7G1iFwM/be4c3boJUYF4E2+Eza
3JPqzYLqkVlHuivx+TW+R4j/4k54T53LbGPEXHvEDuoxsMA+XkT3SnpqtMX9
eIraL+fb5HzbWFW1T/lOiK0NdIGTxD4DxuFjlDebWsyZuMsT8zrkN7DRjvxC
an7m8J8S53V8+7DJHG3jYoYYT3Q6B+UyRn1Gm2xjL/J7OfuSz+fxl4Aba+9z
yNNV96p67A5yaaE2zeBW/N6WmlNxe5q738AzFc+u9NWb//BtDgyicxO4PHVv
qcc2cW4EDZk5FJc9tXls4v4avq8A/Zk5FJefLnUtVeNPkCd6I75f5Bq/Rqz7
e90bqvEHyIOpZ1M74LHMM6vZ/RjOGshjdd5nzXQ/PJxC/ydwFr1z4LnUva8a
703dQ+olzbRmWztHu0d8q7e+63IvqCfasf8jtf+hxoG46MXmUtlGDuzdnrhW
s9gYpXZ3Ju4tcVSkfrtVm8w1V+2v7fNuUj9otu/CxhAYQ2c88wyr9zUDR7C3
HHvLEs+UZus+4nu/zjv5fuTfa/OgHF6vmENxqRgV6+rMXIiTFD+3lD072uHa
5cXMvaf6HO50DspFM6pZ1QwqHu2YhHr1l70b6/g2yf09NX60Q3PkN9FNfgu9
E1LsrUnNlTgSVw1F9/6X2D/Y63+C/g3q+e3at+Im75qr9uo59d6f5PRX4hnT
rB3l7hgoaDY6XSPVSjtVu0Y7R7taO0dnzeCz7KILiSdL3dPqbdVMtdPO1+7X
P0f9qZ58lfg+4v3Bst/orf5x+teJM3H3bdn7UDt+B+dLqdElHeZc3G+t7Rfp
SPeBomdTMzrAuafPtdA/s9rnmdRsXkWOV4P/AJCeC+4=
               "]], PolygonBox[CompressedData["
1:eJwtkTsvg2EYhq9o9BAS0WpVk0qrapI4/gFNGCXsdWgk3TBYLQaTDiUR/gSz
hWARhz/gEOdiF8TC1TBcee73/d7nfu4nX7a0MDnfAMSlUQqKEVnqhEwQ+pIQ
8Nwg72m48G45BVsJGI/AXsbeDkjIcw9UmqFmncnBrOx2wY7cqrub4C0KWX0y
cmDvhB771g3nrUtVygZqif31132e9FvT98SZX/Z/SsF3kTCMWh//vz9YD7Nw
JHPex/1ettbM+yI5dcr8be7U7j5JuTH3tbSqv0Pe++bKbK/qS2vUHDE51/NM
TmUxAL16VPNw506b+b8d67tO23/sjDHnFdVT0i8ld/ow94B6UMLOK+pT8V3Q
c0hQ/5hlW797fdO+Wan/B/dYtQ45c1h+ATE8PVQ=
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlW1olXUYxm8z3Ut7PXPnnB09Z3s4uWdnrjfdlz71YmT0ISQMnEW1NU2T
NN/mpwKDiHC9rFn0qaJmUBrZCIwoRQmzCArKoIJ0zCi2BJUIKsJ+F9fz4c/9
5//cL9d93S9PMrL93m1XRcQ7nIWcbxoiznB2LIoYbI5YxXmC+8oK3+sjbkSu
SyLWL4i43BPR1BGxCQfjvDdm98NlbIu+P837q4WIXfi4DrtWdE4vjpjk/TD2
t/D+SxqR74q4++qI1/IRdSVsAfNJYr/yI38H8LMT/Yt9EX8Q40JdxDzye/Cu
zXAerUZ0IfPYFov2U+2MOI7OrYscbxD/3eT6V1vEhsQ5jyJPcbahvxmfC7Dd
IEKwrXHvBvMWsGzH9ivuHeSxGv3PsL0DuY93oEe0R0zVImZbIg4in+LbGvKa
5OMJ8F5piqjg97cMwyg+q83GIM7F0xDnXWz2JcYrnr7lvhO727DbXXDcuxLz
KD4f4X28F3/4fx55jtPaGHGJHKeXOOYDqWOIw0P4T4l7qjWiF/kG37bzPonv
J0vOfSG5v1A1njf5fgQcZ8B8fc5cqzfUB4opbpXnXKP5X877513m5Dx8rsg4
HAHvXnzNYXN/6niKe5/qRbz/4KhacQ+mLcYqn9c2G/PqqmMd7TP+GmcL70ux
+RfbsiT4PiVWd8l9MZj1hnJNM/1DxP4dDEOpuVcNlKfqJj42o3Mwtf6Kfmqa
+v3tmvNRXu+3O1fhE7Yfyu6NrcTdlTM3Y9h9kBrDEeR8o/XFj2qt2Ir7SjYj
G+EhV+9eUS+OJO7vYeQE8rsG83UTXLWgt67iOqlez5Tcr7p/BPfHsnol4HqJ
fniUfCeQl/rM7W4wXkNdusDcUHSeyvfZguMorngrJMY7nDM+4dRMaz41X/8Q
6/ZO9+f6kmunuqnXTibuw1nijhXcz+rriaq5eBmZEnej+hDZTz5BXt34q+P+
JzzUc7+nZP+agxuKviumerC11f10M/rD7Ip80fiFXVxdpv9n8HMSHpaV3Btr
0f06cU8ep45f5t0Xr1OjJbzvx74TeTrvXhgG54Wc/Q9ge6Xi+dUct6P3HPpt
ieMprmqvnlJequ9EVjfF2FtwD6uXFefvFnN1Dh6nwXMeeaLm98UF7y/xnCPW
bM46M+g8CIYOuHqo4p2rPVnPXmrJajpNXmN8W4rOHuTZ1LOqPXG2xxiERTMk
fMKmN+moTspZuf+K/kDinfRe6j7a1OR5H8g4nwfXTzXX4kfkQDbv4vhA3rra
hW0ZVy/i+2LGp+q2P9t/mqO3asaimog76Su2YmpmdR/K5jcB/46y95v23Nay
Z+exsvte/a+9tZK4U/hZjv6H2T6UXa7g3Jcl7gn1Rk/Jsyc/0tOu1f9DnDye
7X/NunzJ56p+7yflIPwPl7yTR0v+H2hXjJfcq+pT9cbHffa5JvFOFFf6z+if
qu/aH/pXzGX/i5le1+KLvP89wvBz2XM2lcW9E1/HuO8B1/8XMAjq
               "]], PolygonBox[CompressedData["
1:eJwtlVtsVGUQx6fQK7S7dJfurfTAseyuWwUjNUHjBY2BEh+MQU0QEbmUipJQ
QKwmwoMRokalLcXIkzfgQYm2EhN9UGuNkeqLidhEjBSaaqJFIiWYWJqiv3/m
PPyTOeeb+c98c/vCzZ1rdswys/2gHPyWNTtZaTZTZZZpMHstZ5bi/xW+qwKz
ttBssMbsC3Av8vQ8s/Qcs2FsNqJbQseqzTZBeimBTdrsBMTH0F+G/hHI7uP7
S75X8d0AXkVeXGd2AN1J+OLwfQ7fAviWcP50hdn72NyIPEp8Z0EaPxnQzr8f
alznDez/bjK7SKzrZpvtw74R5MAgel+Bo0WzAr7GY8RUMtvO2feVfgfdZeA6
s37wJ7FPgNYWj303/IfhP0X828o9xvMFs7fge5LvTs7fRq7OcGdQQ+7mgJHQ
ueWjE18PEnOs2u83Df8oNiuwba81O4ecxGaa+LOcx+CpxWYuuILuP+BW5OVg
KzwdoDzw2qhG35CXO7C/vcF1pBtHnor45sLXh2Ib8Xbgr5v4t+S8dopRsS4A
vdy3RI5e5r4XEl5L1bQFX6nA+dQj5/F3F993gkn0LoOjJc/vt3G4yV0C/g5q
MRv7ZegNcMdbOH8AnIK/u9nsFfw9Qg4OIt9GvEl0F8J/A/EeLHisT4Ae5IdD
z/XaMrOHkMeiflVMuus7Refaiv8i/s8QTxy5FX+L8VeVNKsEbcS1GjyG/kSt
6/yi2Fvcthn9d4seo2L9iRg3Rz2kXlJNVJv2KH9j+L883+zDeq+F+q+M+C9d
771TpN8mkZ9Bfw+4iu40GKz3u+rOG8jPNvp3B7YB+JjzSvxPxXxG5uP3g6LP
wh/EfAL5k6z7Us//he2j0X3+Ayuw3Yuv58EMvX0NHMi5vmJ8AXl90X3JRrlY
DnZVuM8h8tFV9Fzr/FnkpdxpCdhLrPvAPXDsxr6R+Lv4vpr1eqtnLtIPp4n5
R7BGvQ9eL3ivqwcPp7wHVV/d6aNF9F7Ba63zUb4HyE9/vc+UZuu5wH3J5018
B9S8CfTl4cv7zGp2f6WXzkaQ3IBOCqwMffdoB72J/zJispxziOsQHL153wHa
BZo5zZ56XL0+1OS1Vs3jSY9ZsauH60PPsXK9E85dOd8B2gXD5OU7sDDns6/9
8TX6x0u+i7RTxrj7noT3ygh8WzhfFOlrZ9ysO2Q8t8pxBrmHu03AdQH0Ir9E
zYt1PoPadY9jvyHnNVAtfi+4L50f47w18NkUX1XOZ1azq532Xsl3gHaBOI+j
X5PxXaId1Rj4jGhW1DPqnVX8Wxn4ztXuPdTsseXpoTT+P2UG7q7wN+Qz5DPk
5GcwQ16vgSnu/2/COcSlmdXsamf0F70n1BviOIe8FN0R83qmsp4z5U5vwjrk
MPC3TDtiHN1qatYxy/vn/pz7lG/1mHpNb5DeIuVUuU3Bka3wN0xvmXqsL+oR
9cqm0HfDabAROQZ/XdJzrtxrBjWLQ8SwHT9h2mdXPa/dliSfCdANV0/eOcSl
HZxIe8+qd6Uj3dWhv716M7o4f6rJuRPUcH3gPbcz2jHaNeMF7zXVfJh+P1nv
9dO+TEVvqN5S1UC1WBvNs3JUm/QZ16xrZ2p3aoY1yy/yb3/gMSv2OLHNA/8D
KQEi6Q==
               "]], PolygonBox[CompressedData["
1:eJwljj1LggEUhZ/KygQ/8C3sA9OXpkAl0CVqVGqu9iBKcLAWhcCm6i/VVlCT
9ReioFkijAZNgh5peDiXey7nnvDobO90EkjJtDwtQVeiC/A9C5FVyMrIOXD3
qvcmOWeisK7HMkzIaB5+5CULzzPQdNfWX/HuXC0uQkkazjn9gvOWOdtym4cb
aWfgfg5qIXyloS8b3k+ZUVav5UoupW7xWKA6n8jxONc6Ff8+2uHdzg9q3JuE
HOgnzNlXB+YOZdfbHTl0F+ht2iVlr6Ssufs1I1Sr9rmzVyvz33Pct2f2h/6n
2jHjQv4AjcgsHA==
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtVV1sVGUQHSh1e7dlF7a4t73a2it273ZRS/yJolUf5McXE6MkJkojhQrb
Eq01lieVFxONEqNY44ORkiiSgMYSpGqNhBhNTSwqbbW0aKsPamwTfx4qVKLx
HM48bGb2u/PNz5kz88Xbeu59dKmZfYZfBX7lGrOxZWZN+JMKzfYGZvnY7Dno
7ZVml0M/kphds9zsMGQ6Y1ad0bcT+D2B3yncf6rR7GE4vrbO7A34+Dtttgvf
1uB/D3yvu9RsOtF5T85sIJBP2rxSUPz3V5m9gHyKON+C8whyCPbb4X8Id9fh
/3HIsUrpT0OOIM9hyEGcXxaZfXyJ2Ubk0oh4nfC5BGd56B3Qf1htNocYZ1Nm
7zYoV+bcB/u9zWaz1YgPeShRDm8nuk8/V8BHqlb2rLXS9X3wsxUYHUOOHZCD
9WYwtS9xnobN58jnGdjvXmHWCtz2INdP8G0E5w9Gqn/cMVyL74s1slnISp7G
+Xb47VgCrIHb+pLw74R+K/QJ2LRB9jcrT9Z9rl76Mdy7gHrvh96HWDuQx0nE
vRn6bZH6MhKrh+PLFOMl9GIU+ouQhxFnHvn8hv+DV6JO1os448j/F2A4Blnn
mOchz3usA4j/3wrh8CTO30tUx1WhuEbOBfB1dew8gLwDNexBzQdgM4P7R+Gz
oVE4EDti8X0gG+bK/nRnxRNyYXdWfKDvmYz8tzk+ZxH/rRbZvpnIlr2gfRE2
z+PObEFnjMVzygX3yZybM+LouOvEirLg+k7YlrPi77+J+Pbtas1Ll+fZm5U9
/Q17j4nLh0WzP1DDB0XxnfoEsPsmVP7sc021ZpN1fZFSb9gX5rzWefUq7L+D
TSfwrAK364Dh4EqzHwuqcSSPesnjKuANbOsahTPxbo/ESXKTvCF/fq9Xz5jj
FPA7RR1xJhPVyh6wXs4bObCYE5/Iq9ZI+ZE/vD/UZHY3clsfC7d3HM8dgeac
M84aFp1vX4eaiynE2hDrLn20J/K5BfKxRPY9kG2oK4+6upDLXE5cJWennEus
tatFccst2iHsLef2hkhzwfnoy4pP/L4tVp+4Y/4qqnd/Qj4SieecrVafo1sQ
vxd5/IN8Hoc0x3a6XjFZM7nD7+wfa7wuVk9T3rczgWZxrl78IY8WUMtH8FMT
6dsJn9V9BXG9H7LSe10BOdskTGeaNMfUiS19T7r/yaJ4eQZyfyCf3D8zfvdl
+KytUw7cnXfG4uMmyP5QPL4enJxuUS/Yk5aSZqBU0r7j3rsv0r5nH3d57pxh
5s8dRi61+xvC3C7mkBNuxK87lv0AYs4H0umj0Kj+/pwTbrzPGSRXGOurUO8N
+3IXcuiKxbXjq7TXiEscai7T/pZdCNVT7jDuLO6ueczCUfw/iX6VG4TVvOdw
MNE9vpOc42HnU6ZWc/Qp7F/Li7fkb7fH4h7gO8d8mBfrHvDa74mE2+ZIc7/f
z3s9H+7UgnOJOyQXir9bnUc8C/xN4ttUgVyquEORf5rvc6C3mfVzVjmzm3G+
Mq0akeLF2WZfRkPZ05b82em7jXuk7HN0O3r9q88ae8J7Yz5T54raTechH/Ld
Qmx6/A26EWcP+LvG9419m3AeEsdh9/NTQXEPIuaaWJhsKAn7027DnU5cn0XO
S2vln3FYK3k36ruFM8ddNODnjBVEmq/lkd5s4nwEO/P1ULvgppKwGXF8/gfs
9VyL
               "]], PolygonBox[CompressedData["
1:eJwtlVtsVFUUhhftlLl0eple5kan4Uig0ykNChg1EYyC0RcV0cSoGGlttQWl
1ggkvvBiNFEeEMEXoxAjmoAXUAoIL0TFqkGkFKEUkaCgoeUiJaBQY/x+1zz8
OWufvW7732utHbT3LFxWYmYvgxBIBmaro2bxcrOdU8z2sq6Mme2ZaDYpazZW
bXYJNCDnwNqpZotx0FFqtg55X8bsa3A6Z3YGxNNm5SAKYqAETABWz7fefcjX
gkazB0EvNt+GiQu21ZnNI4cdxM9WmK1MmQVgP4kuLTN7tMnscWz7yS2JzjXy
6mTdoTyxvQzO1ZiNggK+W8CfebNplcSpIl98XWDvPJjOXiv4nty/AyHkMhDB
Vxjshoc9IJl1LsTJReIFrCeDmzjLTPAs8lIwzt4/YDY+ZjW6D/l6GOzD/jjn
G6nzM+vs8iFfE/Exxl4anTJ4uoG9APxGjqfBZTBW4z7le900s6449vD/JvK/
Obffhv2xjOeoXL9gHcX/RzmPrRxitWZt/Ftc5EzcfUlO/UX+u9GtyLptOGKW
J7dxfF7POGfiTjrS1Z19he3cRteVzRX25xaICd+D3Nkc5D5st4Nz2J0HBTh9
h3rrBCcmkyM5RcD9xH0ArKGmTlKLbZyvNu0xFOs6Z+7l/qvJqarea0y11kPM
qzH3Kd+qMdWaYiq2clAuq7j/O5C342MF8m3U1w7kLYn/1e0R4o1TH2dqvL4V
fwT7IXQOUXsD4Af2N6bc18/EW0K8VejfyHlngL+otQb+PYHu58SsQXcz9q3E
2oD+dPb6mjz2cny8zf4ROPk97PGf4/w78XGxwntAvXAPNofN/+1ibyo2h0Le
szPZu5DxXlTOf5DLT1M8d3G4Gi7no3Nf1H3MQy6F6050e9CZQ7y+Oq8l3Vl3
s9lnrDdXOufqzRfx2TbBe+gS8d+g5p6Oek+uQe5Pmr3G3bwOTrF+hfy6ONsz
oBm+F3He0bj7lO9Nza67CI7eR16P/S+VXtNrse9B/1rcORW3y1ifDfm/55E/
APkKj6FYr6bcVzfrFuJ1cMYjUc/5MeRCwXNRjnnkY8QcCHlOw8gninyJvxHi
Hcf/YfwNgh/xfW/WuRJnYbi7Gx/vRl3nIPvvob+kynP6EHkr2F3mMT5t8pml
2aUa2ILcQYxyzhYDR/M+4zTrxOlJ+mF51mtBNdmLfDPYS2/VUQ8HAp9RmlWa
uZq9nfwbivqZ1+PrhSbvFXEm7p5Ctx000ysFsDHj/lVzgzmfoZqlmg8Lsj7z
NPvU8+p9zSDNolPIv4INKa/9UfBS4JAsTlqQby3mm2Qm3M4hBgP3r5n9ZLHH
1esH+T8Q+MzU7NRM0mxqC7x3xGF74Hequ1VPbeI8+1Pei+JwPntDeedSd6C7
+DvvvageV6/fUvBeUw+rl2cV/C1QD6mXrlY7t8p5NvEPpPzuNVOG0e8qzrsE
62/I5xPmxccJf9P0tsU445Xi/I6k/U3R26I3SG+Rzqiz3onvu7L+JuptnIRO
A9iacFvNcM3y0rSv5TPC/kPF90Mcist4cT5rxuut1purt1c5KbeuRude5ymp
9ZiKvYL/K8Fwxt8KxdPbkyBeddrfHL09rYHPqqPgrZTfue5eM1ezV/+0p5pT
7f0H7QE3bg==
               "]], 
              PolygonBox[{{6186, 6185, 7785, 2070, 7784}, {7723, 7722, 5407, 
               868, 6647}, {7690, 2037, 5386, 6601, 6602}, {7708, 7707, 7709, 
               1713, 4830}, {7634, 2022, 7638, 6763, 6764}, {5363, 5362, 7618,
                1735, 6749}, {9611, 3039, 9616, 6160, 6161}, {7799, 7798, 
               7797, 613, 4869}, {9951, 3210, 9952, 4337, 4338}, {7661, 7660, 
               7659, 21, 6576}, {5426, 5425, 7764, 1723, 6680}, {7743, 2055, 
               7742, 4850, 4851}, {5434, 879, 6187, 7778, 7779}, {7597, 2011, 
               7596, 4872, 4873}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1VEtIlFEU/jLHVKx5ODUPmqEp1JlxF0ER1EAPCCKCslpERWXRRIzZJqjJ
IHNauCtbGRQtjAJdRGMPaDM9IOntIstqKII2IaKEgop9H+e2uNz7n/ud853z
nXP/xJG2XbkKAO1cC7n2LQb2cF3yAF1c571AcQEwFgAGq4CZCPA+BFyhfWsa
uExMwWOYkSaghb5rae/02J3sE/Qp0reYAEqL7G6YXHmvxRfPBvp08LyR+7cV
zIF+aeJPJiz+LXK2M/5qJvksCLxgzAHG9MSB6YjlNst9tMZ4xTHJnB/RniGm
OWE851y8LpdbjjGn64Az3D8Tf5BizMeAlfQ5xLM/DOyMAs8Zp6YeOMUz6fGR
mOa41fWHfl/ov5e1v2Wehx1m1gd8dTH9xH5YxZjMf4bYXwGLLx7VqXrbaPvu
8Mtpv9oIbKsEri8DHiaMS1p2kLuVmLmAcYhLeUlb1d/p6lSNN5nPBa/1VT2V
5vrWuVd30qHJ+pl3vXjA73XETyeB3dwLtKeYX8b1SL1SDaplmPlsSRvmdcj4
+5dYD24T00D/kaT1Oe94TzvNpX02ZfgiiyjQfz/v+2j/y3ML44/TPs9ziLXP
cX8Tshn7P2vKTzVcpBb3pKF83bxJs6qozcBTnu+4fJTXWepbon1T1Pqq/vZT
V0+92XUv7aWpZjUTNXsv44wTN0b7BPdPSdOmlfxr4salufvh+vuKPZ9KWm7K
cdBpK401W8J0NwC/YzbPLyPWe81ALe9TadNE2viWmuY/ibkfs77f9VtOym1z
1N6G3kiW9zF+U1pM+OxOmB7aRwLGJc4TcZulNLnqwhZfPPoHaJ41l3pjwg+R
t6Le8PI7yhWsBtYT/4SxytTkccy4lUMpaPNScP8COF/Nb1/MNN/OvK5xzrOc
hx63S3NpP+TeeG3calAt5UabCc1Gd8T6Ks0rGWfK9V3v8l3IZn6UOt+ImFbS
bNL5HiO+2s2G+rbDvXHlpZ6pL+WAvVv1Qv+GJHtxnPWkuVeEbSYH/PYOVVeO
2ANRiy+efyuGzXc=
               "]], PolygonBox[CompressedData["
1:eJwtlElszGEYxt/unabVRcd0JpnGkHamI0IqlsSWCInEwdZyKK2lRB0UZ3Wy
HHBp3RxwIdYQphHiIrZEKam1lTQRRVSrF1Ha4vd45/Dk//2/73u3533eL7at
dd2eTDNrBNkgt8IsB2SBbLC20qwo32wSZ9GI2Z2YWWGB2a1cs3z+T1abtRSa
rcS4nfV42KyTswxspgb5guE8sxB7mfhbmDQ7UGx2FDwPmX0pM/sMqokTB5vw
2QB+lZj9Br/KzUbBGfyeBbtqzA7lmF0hoRbWF0rNOLa6LLMf+AthOwV8x3YE
DETNBol/lfgPsO8BTdxtpOj3xM0jv9yg16zasyNem2ocwv71dLNX4HiV2QnQ
j01Tpvt4wf4Wci6n1maRONmsi3hPwCXyugw+cX8AfCXuIHgBf0F83yfG6ki6
RrCG9VpQD+rAV4oaBAUVnqviFbJeAn8Hi50DcbGEu4vBI/w+Bqly56YvAD/8
98XNNhaZtWGzCNtp3I2BWmqeE/QaVat6Nkp+HeTeDrKoJRucgdMjOR5zKfan
+T+c43u78f8hzac4+ViW7jl8pPD3g7OZlf4v/8Nl3hP1JkAOBaCV/C5mEBsN
7WX9p9z7Jb38JVYG9gZ68dUHViRdO8phBvF/ljif97i/FH9v8LGeeuvAU+yT
3N/J/Qbu17DeEXGtSDNbFZ+c6om/gfu92IbZq0hrSFp6FvKzevAu7j1Vb8fY
HwffyWk47BqWlm/i+F6ez0QH8zAPH3Plh1y7Y865uFcMxVJNqk0alBaXRbwW
1SStXOfsWtg1JW2pJ+qNeq7eayY0Gz2cvYx6TspNM6PZORb2evvJ6TbnKWpo
g4sF1NPJ+mHYZ0Oci/tzceeqivPzcdeUtDWLWLPB/KRzKx+niDOJvSKQIPea
oHMkrqS5bs5vYnsj5hyJq/+aDDhH4kozr9nXjGhWNCOalQlpIe6alXb1Zujt
GE147tLMz4RrKJDOQbncjXqtqnkz/6siPmviU1rRjK1Jz5hmbX/ctVfL/X3p
mIqtmdfs7yW31krvoXrZpXkodo1Ja83kXJPhe8vJbyz9/mmm9FZ+K/NZ0Axo
FpIV/lbozdjOf3+1v63SaCLpb67e3nzOAuBqqc+C+qO3bBgMRV0T0sZEyM/1
xo6w/zbhvVNOb1h3cicVdhvZ/gMHsuDj
               "]], 
              PolygonBox[{{6704, 6703, 5434, 2068, 7776}, {7790, 612, 4866, 
               7791, 7792}, {7636, 7635, 7634, 20, 6556}, {7666, 2030, 5377, 
               6581, 6582}, {8629, 1717, 6647, 8627, 8628}, {7609, 2015, 7613,
                6747, 6748}, {5355, 5354, 7597, 1732, 6733}, {9613, 9612, 
               9611, 607, 4833}, {7689, 7688, 7690, 1710, 4824}, {7679, 606, 
               4830, 7680, 7681}, {5424, 2061, 7761, 6689, 6690}, {5417, 5416,
                7743, 1720, 6662}, {7572, 1730, 4869, 7570, 7571}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkU8rBFAUxQ+mGaaIYcw8NWpspCxIKSk+gQVlx8ZKKX8WPoMPwMI3sGDj
b1nJ0sYU8idrM1MjI5RGit/tvsXr3c4995zz3i0urc2tNksa5bRwvjqlTFq6
KkqHnOOk9BKkdJ/UTv+dfjUjnYDXwW+o96mvC1KAs4LIWFZq65cWEU7kpQoz
qwz/DUozcGbh1HrQCa5vPrVYl9E7C675geYw/A3401n3MPyI/g+a3eRZoL+O
V2jFo9/zWc4ceIqZBWaf4TcKnucW/WTecesPcZapO+C/RX3z/81JvdQHXdID
eCUlPXGXgs/uk7kJv0/wP/Ct4Hl2qQ9jftMzP/MtU28Gf3uFt99H3HK9Bv/P
d7vRTfP/p9yPkWN/OUW+SziJbve2DBfwk32e396xjdYdeXYK/i+W55x6IO5l
BM5k1JngbsQ3fuc8t/H3unx/xre5ao9ntuy1WM+D13NeW79U9B2N226jr+3n
H7sJWyA=
               "]], PolygonBox[CompressedData["
1:eJwtk81LVGEUxo86WQwkzlUb74RDFwk3LXITRFBB7mqj0E4hWwWB6T9Qf0Dl
xmXTIhdJH5s0KIqKNn0hRGpKX5RhzoCVmvkxNB/9Hs9d/OC973vOec/7nOdG
Zy/0DNSaWRckoNJhNrDbbKLebCk0m2o3ewf/2C/Bjgxx8KvR7DcUidmCEpRh
MfDc6k6zjqzZIWKH6szCXWaDfE+2mS1wdoeYe8QH7KXgA3kfIU0819t55bCu
pKkLK+Stwgw50/CZ2C+wt8Xv0p0F9k+T001uEzW6Wa82kwuXObsCY6n4jJhl
6s5zNkP+c/KPEP+Gt76Gr9T+Bp3sHYQz9NgPm+TsITZPzhz9PKNmL7X6EHE2
cI2klXpUr5/i8zXia8h/FfHmpN93lLq36ecWrFN3A4b3m12FeWp9h4fEP4A/
1FmDJTRPkn+f/J98z9HrbLvnKPe9NIIcZ9dDr6na0kBavGTvBVRYV+Fuyt+j
mWg2P0LXUh7Ic9d46LPS+QbxNRIPLhJ7CRKt/na9sb7VNZJWilGselAv48RO
QAHybd6DejFyqvGMNesxzm7CSbQ5BVv0sAnHWB/PuOfkPXlO3pPHNH/pUQh8
xpr1I2o8hsMZ11qa/230Gqp1DU1zkc9Ys5bH5XXdqbt1p+4ux97eh8+iFp+J
ZiOPyCsrod+tHuTFoax7XZ4/kHGNt7VO+1tVQ7XWNZvQPSwv6x/QvyCNpJU8
IW8Um91rmlGJGokmf488O0LcKDVuhD5zzb42617TPN6yvxz3t+0Z3vsUnkT+
D+tf1gw1yzI9VALvSb3Jc/KeZr4Q319Mu2bS7gS5XdAA5+r8n02y/g/RhsNC

               "]], 
              PolygonBox[{{4862, 4861, 7790, 2073, 7793}, {4826, 4825, 7679, 
               2035, 7682}, {7654, 605, 4824, 7655, 7656}, {7611, 7610, 7609, 
               19, 6535}, {10239, 3438, 10238, 9174, 9175}, {8649, 2578, 8648,
                6704, 6705}, {8636, 872, 6662, 8637, 8638}, {7665, 7664, 7666,
                1707, 4818}, {5351, 849, 6733, 7590, 7591}, {7641, 2023, 5369,
                6561, 6562}, {6643, 6642, 8629, 2570, 4331}, {6724, 6723, 
               7572, 2004, 5345}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkU8rhFEYxQ9C/saYiXfqVa9JVqb4BD6AlZ2yoWzJN7C0smbBQsm/jY0V
DTspE4aJWajJAgupSYkF4/d47uK+z/Oee+655zk3mVucWmiUNMpqYl2npBmA
aixtRdJui1Sh/6Sfh5BkpNVEOgUfz0rltFRslZbhPHE218H+sHSb8/6B+gh+
CP8OjVrs+r/90n3g1EfQiZyTHpSOYr93M3Ifxi+iUeeuaTycg6+AA2m7l8+A
47Z/E3S60blMuY7pffU4fxLPe4nzD+C+sveG/2dqOdxrc7/D74TfDH8j5GD7
+azPbhkcR65jepaL5fMT+d3mwWayLGxGm3UdXr1NWqMWWF3t0gl1LGhe0Df0
eT+LxkTWPZt3+zfcuDv4qOD5hXkL9FX6s9gz+s/K3ot8M/D3yec78llsplLg
2DssRa5vWZbwN4TPKsBHOFujXgW8SP0DrjhcjQ==
               "]], PolygonBox[CompressedData["
1:eJwtk01sTGEUhl8dNH6aTG9nwp2aSUYXNmzslEQX7KzsJFYSS6QStpYs2GuC
FWmjFrQbUunYWVWLUj9pUpIyE4M2rdY0tJ7XuYsnuXPO+c7Pe85Uz1w4eb5N
Ui9shiMl6TAcgl6YSqVJGK5KD+A4tmPwqSB9hitlaaJdqm2VNnVJ67uk0yQ8
lSPZbmmUtyOwQuwqrOFvwSr8hi3k2klox3ZpnPzfiW3CAiwaYorknqPGOLXm
89K5Dukhtpf4l2EJvmFvwvM0ajeJrxO/pyh1Qx17I40e3It7cC8XK1I/7KeP
A7DGmxa8TqTpJGb0rNbE2ozimyX3EPVvZzmd+xG9j8AGb9aTyOnc9zolfmpj
mzSAP4etrRKaWtun5BuDq3xfS0Nza7/MLL/yoZG1miHmHdyF9+2Rs5/4Z1CD
txhmYDib3zuYymz2eSbP9oQeHldDM2s30SPt3RGaWts7aczmGX8UYufefS2r
1SiHtq4x5v0UYjfe0Qp9DjHvIPzkewEmiX9RjhvwLdyqhhbuv485G7yvwyV8
l+Ejjg9JaGSt/uyL3tzjq57oaTart0T+v7w5m4sbavF9vzN8jvGuTpSiljUb
LEdP7s01Xds38/920ri96TRuyzVd+2Apbts3/ob4LnpKKtGje/XOvft53n2B
G3A9jZ16t74p39ZRbrCvGDv2rm/iGyjHG7/9Sg/1fNjss4bWcjH7L/iGfcv/
AOf1raw=
               "]], 
              PolygonBox[{{9163, 9162, 4832, 2850, 9167}, {8600, 2559, 8604, 
               6724, 6725}, {7629, 604, 4818, 7630, 7631}, {4341, 4340, 8649, 
               1727, 6702}, {8630, 869, 6646, 8632, 8633}, {9176, 2851, 4834, 
               9162, 9163}, {6518, 6517, 5351, 2009, 7588}, {7700, 1712, 4829,
                7698, 7699}, {4820, 4819, 7654, 2028, 7657}, {4328, 4327, 
               10239, 2851, 9171}, {7640, 7639, 7641, 1704, 4812}, {7552, 
               1997, 7551, 4862, 4863}, {7616, 2016, 5361, 6540, 6541}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkU8oRFEYxU+mKLPheXrdl6veUsJetrO1sLCZjdhTbC0sWVizUUqaKcmC
lEJjYwoTVsRCKYuRKcqfSYrzOXdx3z3ve7/7feedm03OjE23ABjiynENpkAn
948OoJ/6uBWY98BvJL1A3dULNNuAmHuZ73fUW9yrZIpstke9xhWTf06AIwds
U3+y9hUD4xy0y9qc16wNPg4yIN8O7HO/9erT5Nllcps8W/HijL+mtxeuPPU7
v5+E/j9kTiPx69SNRB7MSynT3BWyr6FeZrMrvu9Q5/gvi2HWIfkH+hwlP+H0
zZj7SLmYh2Fm8xiYAvVAyGqW7E0kPxUnH9ZziXokFW/njDPecj0LuVXJ1slN
kenpBi5C3fKoBZ/nTvdhZ/tScca/Ofm2WZbZd6L/tbwvWX/iHdW8ZvzPinQf
5tPyKznxllMh+FylrifSlkfDKXPLvuiUg93hH4S7Xp8=
               "]], PolygonBox[CompressedData["
1:eJwtkjFPVFEQhU/AsApBcV2Db5PdZENFYYOxMRb+AgsLGhqirZFgoX8BGi0N
FtK4iIIx0WhiELAWFt4KSxAbjVl0SVBRCgIN38m84kveu3fmzJk7U7k5cuNO
m6TLcAKmz0qFDmkjJ02UpP1E6uK8q1N6X5G+c/YNanlpBYa5v94ukaYhvq+d
ly6clBbQuFiUDno5p8AgMYd8j5M7BlUSpuBHj5RD+yXx8+Tv9Eb9LepPE5dC
Mxf5z7ifhRlIqV2HbuodcP+KnBrnH2AOnuP1BXxMQts1Zvl/k4SWNVfRHue/
mvXbLEgNNNehxd0OvIO38IS4SfgMdThdls7APn7/wx78gyNiD0uhYa2lJLy5
vnt9lNX3m3zKR03Xds+75H/NR7x7OlcOTWsvoLlYipqu3UBnA/bgVnvMaJfv
K8WYhWdytRie7f03df7AJc4GoOG68Jo3OdUZGi3i1vukNdiELxn+XoLlvtgJ
+/WbjRG/wlkNmvS2DS341RMa1vKMPCvvjHfHM/BbuMeU/If8P6iEJ3vzTng3
Jjh7DFVynsIosXeT8GAvq5BCqxC74vf7yzv9JGY7CQ/24p7du2fkWXmmnu1c
tiveEe/KTLZbaabtntzbfc7uJeHBXvqLsdve8dvl6Nm917PdsEd79Y57148B
itCd5w==
               "]], 
              PolygonBox[{{4330, 2569, 8626, 6630, 6631}, {6614, 6613, 7700, 
               2040, 5389}, {7595, 2010, 5353, 6518, 6519}, {4814, 4813, 7629,
                2021, 7632}, {8602, 8601, 8600, 846, 6121}, {7604, 603, 4812, 
               7605, 7606}, {7615, 7614, 7616, 1701, 4806}, {7676, 1709, 4823,
                7674, 7675}, {5334, 5333, 7552, 1726, 6699}, {4305, 17, 6702, 
               8590, 8591}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtUc8rRGEUPZkiY8Pz6vVNvcVnsmHpv7BkZ+kPoFjY+7Ejyc5miig8sxIp
NSlZScavsmBDppmNyI6Fc7p38XXPu9855zv3vjg9OzHTBWCEp8SzmwPb3cBC
AH6Jv3qAP9Yjfh+w/0a8yjNI/J4BH/1AL3U3VaBNXCZuBdPL55Dca97FPuCZ
9SoBpvhgg/1993whXhoGxhngITW9fDr06/CuIOeRumKImfjYWgTWo+EmOa3M
8iiX9PJZJj4PppXHVjTO3gA5VfNXXvHEv0/NV54rzPLkPmMV4IScV+7hmPXS
89eJ74LNrh1ceL+W22zC38w1WjEf+WlOzatdnnm2U9Zb34/2VHet/BqJ7XCe
nE2eSfrsMOOc71b/qpmYZ8HeZ2qcWrB/o3k3ctOov8h+2/vax09mfen+AYJw
WW4=
               "]], PolygonBox[CompressedData["
1:eJwtks0r5WEUx09DhGZcF93u1L31SxYsbPwXluyYBdbzUmOWbMiCjYXFtfEu
915ZjxSK1Ghwh8Kk5P2liCKxuBufr/NbfOp0znme832+5wk6fzR//2BmDVAI
kwmzCRiImw1CDrZhE7bgPxzAx2qzTzBA726x2VSR2U/yI5CCv1HOwBj1UbiN
md1B42ezpgKzfInZUGC2Qe2PoHcDeoi7oY6+ejiq8vsruf+G811xn6Wcag/k
7mM+Q7OkWdqvqF3DOHEL847p/y2tsANp8hnogHZogy9wWGMWlJmV4sUe8Ty5
OeYVkZgLXJO0fU2afUu6B/JiO/TqMmJ2AcvEK6Fn8k451ZRT7QUNr3AWCe9m
RpZ8f617I4/6iP/hSS7qmqVdmqU9jZZM4Jp0fp7zS+QjaCpP+o60K+1Au5DH
8ro39KOVpa+Tn61wb+WndvkU85p6nokX4n63ZkhrIW99LPbcIrVTPD6pcg/l
pTyX99qJdrMf9V6dyXP/QsJ3ofuH4+6BvFglXoNzeZLwN+vtv4i7YBqdMxX+
h/SXMuSyCd+Zdqce9coTeZMK/2KOHWLn+053iN8AsDWFKA==
               "]], 
              PolygonBox[{{7569, 1555, 6121, 5343, 5344}, {7593, 7592, 7595, 
               1698, 4799}, {7651, 1706, 4817, 7649, 7650}, {6594, 6593, 7676,
                2033, 5380}, {7583, 602, 4806, 7584, 7585}, {7693, 9, 6610, 
               7695, 7696}, {5331, 842, 6699, 7548, 7549}, {4808, 4807, 7604, 
               2014, 7607}, {4516, 4515, 4305, 2555, 8876}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkTtLA1EQhQ8KKj5CDDFyhRUjRtBfI6lV0NpHpYUQRGIawcJC8IEsokEF
e8HCysYoBk2RgIXiq7CwtfUbZovZM3Pmzjl37ubnl4tLbZLGiHbiYVx66ZE2
C1Ipou6UGlnpOiPFHdIqXJ26Bn/H2TgvTTG4EKR3ej/wH+B31vkt+NeUtN7r
ulXqC3ROwHLBuQq4T30GX2N2OrjXHHgbOW998zPfFbhScH3zv8q5x9GE9Dvo
vPnvJpqmcTkqbXdLp/3S4rCUZtfJIemQXhPNA/ATssvegLlHYhad1IDvbPeZ
CV4b3yS/z7j+HvnXCO+CTgvfNPp/5H3gebLvU+RheZ25m+Be5vnGTIPzO/Qr
keuY3kbk93zms5b8izJ4TLTIY/AfuL5NWg==
               "]], PolygonBox[CompressedData["
1:eJwtk81LlGEUxQ+WGSUxDlPxBk8wgkH+Af0d0TqFWkctyo0gUaMtImlRQRAl
paJjZctRN5UfoDI0CwUHGrWkKCra2qJFv9N9FwfeuV/n3HueKV++duFqm6Rz
4CDYyqT+A9J+h1Q4LQ33SB+PSi1wh+8Z8lWwnaQdUOf7sKLnA99zxGrgAd8P
QQXcBstFaQU8PSvtHouZ9TPSXXLn6W3C95y+iS5p9Ii0zu8b/G4/ji4wT90C
eAymDhGnZrocGqzlNfFZ8Ouk9BNUic2kmOFZY/RcJP+yO+bf7EQv/BPMGC+H
RmvdK0ifC7Gjd71P/0bev4D+OWK1LGpc+7ck/SBfJT9J/Bn1Wx2x0290fAff
wD3io0Y5uK3hFVo26K9T3wDD5C9lwWXOT6XYwbu8hfsdaBSDy5x7KW7sW3sH
7+IZnmW/NunfBq1SaLCWNfpXi+GRvVoDqylizvWewneFpiHfj9nXs5jhWbuF
uL09eJSFp/Z2lto3YCC/t/fzre2R6615mvorud++0ZMUHvgefhO1E9IS+cUs
PLf3lRRarOlWihv4FtZkbX6T3tU7j5Afz4LLnNZqTdb2np7FYryh+dxDe/mH
3H4KTnM3SzHLnIMpbuj5fq+VnvDQXn7hll9BX+6Xd25Q+yLFW/aOQ+RG8v/P
f8+5xT92vaCv
               "]], 
              PolygonBox[{{6117, 6116, 7569, 2003, 7567}, {7669, 8, 6590, 
               7671, 7672}, {4802, 4801, 7583, 2008, 7586}, {7578, 2007, 7582,
                6123, 6124}, {6574, 6573, 7651, 2026, 5372}, {7626, 1703, 
               4811, 7624, 7625}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtUC1LQ2EYPfgxi2FcdOMNN1yHV/ZjLAZlrC24pkWrortqEwauDGzOcJcW
9sEQEdyQiayaNLhiMFgGRs/hecPLezjPOef5iCqHOwcLADb5Fvk+1oBtgiMH
XITA/hJwyeIf8e8KMOc/yhnf3AL2CkCZuEtuSE+Z3uV1oEFdicEPAfDOzCm9
V8w5Cw3X+L/FwMkqcFsEXmLLVPZXFqAEA2e9xSf8U2e86uotfkx9Qv4uA3SY
2YqAe+JrcjfO8ID8Y2DzaK4nj1Pifs7mn8amk37CenvD+GNy33m7iW4jnXjV
G5Hxu+zzk7fMZmj76w7PznbWvufk634ezSiPvJ/MrHqsvJ6fR3ed0DOj95X/
OLAda9Se+n21d+rvrP7/tFtLIA==
               "]], PolygonBox[CompressedData["
1:eJwtkssrhGEUxp+MiCymSaNv8ZVZGPljbOw0jYUFG5eNKEIuW4xCuUUzWGIj
wkIuaeSWFSmUzNrCwmKU3+l8i1/f+57zvs8573O+VGd/W1+FpGaohM2UtAE9
gdQLU7BVJcVq+RL/iEvvsEh8CSZD6b5aKtdIOfJ7xHahXC/9wUFSyiA8Vifd
paXXeKSF5jjnxmA08JpW+ynuWqY5gXapQfqCOdY5KEA+9Dt2twOy8ECtR5hu
krqierfUOyKHlDIx6TjwHixnZ67TrmnaxwnpBAY408rZdkw5Y79Pbg/OWV8k
/M329ktiV1AktsNbPilSZP8Ob6F7YF6YpmkPEhsK3RPzZpvcDrywfoZhciOh
17Ba+eit6y3er3l4mPSZ2GxWya1FPVgvy8RWYJb1TOiemXdbxAqBz8xmV2ok
1+g1rfZs4P3bTGw25qF5WcSbm7T3uB1pmJb9A3bW7iywP024V+ZZN/uLwL3+
xo/f6M329mw0q59698ruz7P/BzZxcsE=
               "]], 
              PolygonBox[{{6554, 6553, 7626, 2019, 5364}, {9930, 9929, 7541, 
               1115, 5814}, {7601, 1700, 4805, 7599, 7600}, {7580, 7579, 7578,
                601, 4798}, {5342, 845, 6120, 7565, 7566}, {7644, 7, 6570, 
               7646, 7647}, {7547, 7546, 7555, 1998, 5335}, {5829, 1126, 7557,
                8421, 8422}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkLFKA2EQhAdFJUREjsNwRcADPbHyPbSzSm2XgLENRi0sJIVKKi20CRFb
tTAIgoUSFYPNNSJc1CrgQwh+y16x7P47M7uzf7yxtV4fk7RAjBPfZel3SsrI
vTlpd1p6S6STSJoE/5mVmmBrkD9DqUvdBXgKpNfE+YPEeca/QHcAp8KSHpw6
7w7AKb3RvFQtSH32PBa8trkfoWfb0yAG+EnpPQSuPaf3zo4ddt2ifc7rPvls
SVqZkGolqbUoDYvw6f2hrzDzKnK9zdmk3ovcv91Rzb2ZR9OlM+7jPnD/bTjN
nN+JpcvIZ9rsY7AUn1+hY8ZpgN/lWvuDduze9qmviQz+DXm75Pevxr7D+CN6
Gfe0uGtIPlp2P4fkl/xe+4N/aCZMTg==
               "]], PolygonBox[CompressedData["
1:eJwtUr8vQ2EUPX42fkaalzYdXtIObdPJ/8FmoBOJhQ4YNSqIEI1QIWkHz0DQ
lUkkWFAGC11EvMZAmkiM7M7JfcNJvu+e7557zn0vMTk3MtsKIE20E80okGWh
HgJKLvAVB3JdwC2xQG4jCTR6gOE24NUBqgnglCjFgB3CI/aJX3J/RIUaZeI6
DNwQ/gDwTizzzQpRSwGLvUCR8FPWo95dcnvEA3trrml6QY9614h1Yp7cU8g8
X1E/z9pxJ9DSTX+cs0p+sMM8y/td2HifPefkDtLG6Y3H8wn7SSPLfNUgk7LJ
s7xP8DxOPNPji2OZlG2KtenAs7xrJ9pNhSgTo6yNEW+O7U47bcatR73l4O0M
z0eB/0PeL8KWTRnz9HsfsV1pZ4/cVy1iWm4fd0T/m659O/VcsvfHsazKXKD2
WcyyfbP24dqONEszczHTkJZmaFYhanfN0L/wGTf/9X5gOwMMJezfUE3cVsY4
7bSYtAzS1/wl6jdSpi1Naf8DGCpqYw==
               "]], 
              PolygonBox[{{7619, 6, 6550, 7621, 7622}, {7575, 1697, 4798, 
               7573, 7574}, {9048, 9047, 5813, 3196, 9926}, {5329, 5328, 9930,
                3197, 9928}, {9931, 3197, 5814, 9047, 9048}, {6487, 6486, 
               5342, 2002, 7562}, {5330, 1995, 7543, 6494, 6495}, {6533, 6532,
                7601, 2012, 5356}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtUMFKQlEUHIxnKATxCOQtDB/ak/6hIKJFmWA9EcKNIARvZfuivUhtWuTC
gn6jhW0iC1ypBAUFUf5C22gOcxeXuXfOnDlzbtg+iTspACWeBZ7JCrDHSysA
dsvAN7kNH6iGwGMG2CcmGd23PWDTl8a0NdbuyW8RD3meea8TR3lqFtlDXF2S
ZseTr/V+FYCznPw+I6BRBB6yQJN4xRwN5vllrjhU3zm1g7K8bojH1NylgVvW
rznjlbP6eb2Nb7P+U1DuCrmPSHOfiJfr4q3eXZP/BbleqH94oyZx/kNfOyUu
/6nLPGfvgdvX9j5y+cfsnS0Df+T75F8iedofv0fS2K71QLzNHDnePGxn230Q
aIbNsn9qOf2U9X9VxkXa
               "]], PolygonBox[CompressedData["
1:eJwtkT1LgnEUxQ9pRUEQIonDE/6pHulDtERLL1AYUTQKgTnoqr2ADVn0QtHg
YkM19BEqh1wiCxojMlAoW+srROdwn+EH9/5f7j33XJfOp3JdAEZJmNSHgEwf
8EQWHLASB5bJgQcckjTjix7gj/evg8AW801yybdXZDsGTHUDNd7PMz8at1w1
jxl/JYBJ5g/M53if5d91kiN50mbNFikx3iHnSWB4wGrsjwFlnu2SnyjwS6qM
l0JApxdoUN9tBLghBcZF0vatX4eztRhfs2e43/6c8e+MM216s0Ht9xGb7431
Kp5pKAU91btICuSdGpskG7NZpbGaNI/k1R3r1Mh31Gqp5hr/7fGu7JlGaZ11
5oU0yPtH37TWqbHBuEmmQ5Z/MK448171Mqz34tud3jz7pkna5Km8lUfySjvS
rhad7VZ+phh/Jqyf5tduVkesns4mghk0izRLu3asXRcCL07JSdx2pt39A83m
Yg0=
               "]], 
              PolygonBox[{{7545, 7544, 5330, 841, 6483}, {6511, 6510, 7575, 
               2005, 5347}, {4318, 2564, 8614, 6543, 6544}, {8599, 2558, 8598,
                6487, 6488}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkTFLgmEUhQ+lgWIgH9GHg/C9GOmfqK3BFC110NwkaKtZqMDFpYZwaaq/
ES6JDtIfCCooDIcwaXfsXM47vNzL9dxznu/qOhe18zUAO3zrfOU8MEoC7Rww
TgBnfKcx4DtSP2M9cpo9bwNFJ93rLnCXAeL0+EoDFfYPG8Atf6/xvVBTZz32
8wH76xA44MIikpd5ljhvUvNIzT37m6x6my0j6W1vLxDnCTn/tphB+D41rZzm
9h11n9WlRzcUp/H+0GdOzv1AXNOEfHue/5P8I8/zS23D87RYLzPKssy2zzrM
a998zNfyLPeJ/u+8Sz8FvLFWnTRXoTIsy242KQCrTfIVdBfbtft9+N0xWcpO
97f/YRiIx27zD5/0Rgo=
               "]], PolygonBox[CompressedData["
1:eJwtkD9LQgEUxQ9mRkEQEsUbgveW6EM0tDgZpK+p1f6BQbYaNbTkp9ChLxFO
4SKNggXVFBpI9QUa+x2uw4Fz/5177s0arfyyICkBRfC1Lk3BKYkz8JlK58vS
36q0W5aqmXRSjNw+/IPe0ZLULUl1+h/IFVakfEG6IX5fk95AE34B9qhP2TNk
/gB+uxn8GeTEV/S0kvBgL0fwXil2eFednspieKjBv9OIrTlLw7O9d6n1stjZ
nGtaezK/ZwDa7D4m1wBjPL6AnzS0rfkLH+zE7Z7xrDWt7RnPvm6HlmeeNqTH
cvzCfjtbAXPf0Kd2n8RvkNcd/DCL273Pt12TayfxM//uH6H5QoA=
               "]], 
              PolygonBox[{{8587, 8586, 9944, 3206, 9946}, {10057, 10056, 4668,
                3576, 10434}, {9046, 9045, 9050, 2751, 9049}, {5825, 3206, 
               9945, 9045, 9046}, {10058, 2751, 4669, 10056, 10057}, {4308, 
               4307, 8599, 1694, 6484}, {4314, 2562, 8610, 6521, 6522}, {8588,
                1693, 6483, 8586, 8587}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtUD1LA1EQHPwoAgmkkBwBizuCuSSFJP4DSxUULAJpBRUSoilVLO200Ubt
BGv9C5oDA1ZWCgaxEEHUf2DlDPOKZfftzuzM22Rjd31nAsAcY5KxVQbWWHzO
AO9V4CEHrCbAdQVYnAb2IuCY7z/2T5jHVdfqvbDenAKyEtDNmbvN9x3fR3ng
mfMee4+h36MWE16LwGwBeMtb4ys2/zu2D/kZlL1D/D4xF6k5l8xZzdwl1uep
56f02a7Yz5D6zYK50m01nOcTh+oRMZ2AF0+e5O2AuvuRfX3Qz03qXQsNz4QZ
E/sbe/8P8y0xLWLOImNVy5P+3Q0enoq+21Xd99WtDom/L9mDbqn/6F/LqbXl
YVizTjPszAJ+hZh/L39EaQ==
               "]], PolygonBox[CompressedData["
1:eJwtkLtKQ1EQRTcai0guqIjhQopchCRaGT9AsBTUkJAUidr4BIOPUkGs/AFj
oTYiWOsvJBEU7E0TxdbXH1i5hrnFgjkzZ/bM7Gj9oLI/ICkDCfjKSrtJqTMs
rU1KNxFJ4tKgtB1Km7ABryNSD97GpT6UyVXgNC290N+EX7S6E9IWwn+8+znp
J+u1s5TUpnaBfguW6S3BEf3zQ9IeXOalE95PSd/Jdrudci3T7NB/zZ9M4D13
7PtMbifhPR/Mm52WZgLPFYnnxvw20/tEr5fzXWzeQuRYbHrHzB6F95TPuMr7
zXZ7lV1r0KJeDHzGPfXD0L0yL5vE52nXsz8P1Bvk6qF7Zt59x36bZ+Zdt+Cz
beZjwWdU455G7LF5bZ6Zd0toLsIKt6/CP0vzRJo=
               "]], 
              PolygonBox[{{9052, 9051, 10058, 3292, 5905}, {6479, 6478, 8588, 
               2554, 4303}, {10059, 1125, 9049, 10060, 10061}, {4310, 2560, 
               8606, 6499, 6500}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkbtKA2EUhMdbETEagyQEG9eFLGsTFCUPYKk2ARGCNiJqFS8QsfAFLLVR
KzXaKhhfwCLYWnkjKNj5BrbOMH/xc/7Ld+bMzkbrO7VGL4Aprj6uqwxwPAQc
DAB/g8B4FljpATZKfn/LmZnj/Us/0C0DbdZ6AvxOAPPsOyoC0xTcHQFmWF9z
7pXGY+LeB9atCPik1ibrbMl6k+zdjrxvk6lmzcvPR2pPrRi4ib2/IHPPVSFz
UjQrf+LlvRL8d8eARZqoc85TAfgZJke9y9T7a9ZayYzYJWp+MYeFxB6rwUMn
47P2d3xrsJ5y7nLIR9+qmbrX3E5glcta7KqclJdye0/NyrO+uZm4by8PfJf9
L54LzlKM2NGie1dj56U+ZXYeNPXeCvncsu7nrdkMfsXrfJY4o0Py/+IIS5c=

               "]], PolygonBox[CompressedData["
1:eJwlkDFLwlEUxX9lDYpRNPhHnP4IPWpIisIP0KomQQTi1FCbWYM49AUaSyHb
hFoTtG+Q4mqTFlFfo7VzufAOnPvufeee8+Lzq5PGMpARVoR6HkYiP2koB+jG
0BGOs1AVehEU1+ArCZe6v1V9tAotoaK6pplSAnQ4Fb/ehLMlmEnzQPUoOD+U
xpv4Ytv3/aXgU3x/B5rr0JDeq/r30i9oNic8BvdgXmYb8CG0I+/Z+2d5X2zB
XHhXoLFwEbvXiVCO3aN5vVO+X809RL7LdgykXwme3Tx9q/8UXNvqnvhL3mvL
dKNsu9LrJ93znrwPg2ezP7K/mmZ8l83Y7D8ILDea
               "]], 
              PolygonBox[{{10657, 3809, 5824, 9942, 9943}, {4304, 4303, 10656,
                3809, 10655}, {8593, 844, 6482, 8595, 8596}, {5827, 5826, 
               10059, 3293, 10062}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkb9Kg0EQxMc/ESKaT1IYUlgcgeSzF99CER8hhXYGbRL56mAtWNhpxBdQ
Cx/APthF4hOks7QRnF/2imX39mZn5+ZSf3B6sSqpdKw5brakSSGNnZ+cF87l
ivS7Kf25/lmP2DP43f1iJzBT9767MX/ci6D+2JXukmfr0m0KTvi5qzZc14Pr
oB3ny6Z035Kua9KLOR72JfR9es+sG7om7s09d7gdOPQwCw86OaPnrReYV+eR
ccNaYI6so7L2sxQ8cHD/Zd6Gtc2cH4vg4I1XzeB97oQH7GIHmtB20g4c3E7L
N43yLvyBCw/psavKWPQs8UX4AobZeZ6fZq/hxmO4ylw3sj646VMv8p/h7TC/
iV3nKfbi6z8riUlP
               "]], 
              PolygonBox[{{6480, 2, 2557, 8596}, {9122, 1230, 3854, 10712}, {
               9124, 2808, 1230, 9122}, {10711, 3854, 3305, 10074}, {5827, 
               3207, 3205, 9943}, {10162, 3382, 2522, 8552}, {8552, 2522, 
               2465, 5922}, {5922, 2465, 1659, 6452}, {10657, 3205, 2, 
               10655}, {10101, 3325, 2808, 4722}, {10074, 3305, 3207, 9947}, {
               10161, 1401, 3382, 10163}, {8550, 379, 1401, 8551}, {4721, 
               1659, 3325, 10101}}]}]}}, {{}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{8525, 8550, 8551, 6040, 10161, 10163, 10162, 8552, 5922, 
             6452, 4721, 10101, 4722, 9124, 9122, 10712, 10711, 10074, 9947, 
             10062, 5827, 9943, 10657, 10655, 4304, 6480, 8596, 8593}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4310, 6500, 4309, 6485, 6490, 5339, 6482, 8595, 6479, 
             4303, 10656, 5824, 9942, 5826, 10059, 10061, 9052, 5905, 10136, 
             10137, 9123, 6008, 10135, 6033, 10158, 6034, 10157, 10802, 10801,
              8494, 5830, 9950, 8526, 6012, 8424, 9053}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4314, 6522, 4313, 6507, 6512, 5348, 6502, 8606, 6499, 
             4308, 6484, 6489, 5338, 6481, 8594, 6478, 8588, 8587, 9946, 5825,
              9046, 9049, 10060, 9051, 10058, 10057, 10434, 10433, 8418, 6009,
              8521, 9941, 5823, 8426, 8427, 6014, 8425, 8423, 4670}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4318, 6544, 4317, 6529, 6534, 5357, 6524, 8610, 6521, 
             4312, 6506, 6511, 5347, 6501, 8605, 6498, 4307, 8599, 6488, 7563,
              4793, 7559, 4791, 7545, 6483, 8586, 9944, 9945, 9045, 9050, 
             4669, 10056, 4668, 8416, 8417, 8524, 8523, 5822, 8528, 8529, 
             8531, 8530, 6013, 8527, 8512}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{5994, 10139, 10140, 9608, 10636, 10637, 8419, 8522, 6010,
              8420, 6011, 9949, 9948, 9925, 9926, 9048, 9931, 9928, 5329, 
             6495, 5330, 7544, 4790, 7558, 4792, 7562, 6487, 8598, 6504, 4797,
              7574, 7575, 6510, 6505, 4311, 6520, 8609, 6523, 5356, 6533, 
             6528, 4316, 6543, 8614, 6546, 5365, 6555, 7622, 7619}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{7644, 7647, 6575, 5373, 6566, 6564, 4320, 6550, 7621, 
             6554, 5364, 6545, 8613, 6542, 4315, 6527, 6532, 7601, 7600, 4803,
              7587, 6526, 8608, 6509, 7580, 4798, 7573, 4796, 6503, 8597, 
             6486, 5342, 7566, 6118, 7568, 4795, 7543, 6494, 5328, 9930, 5814,
              9047, 5813, 9933, 9927, 5828, 10138, 5829, 8422, 5337, 7547, 
             5335, 9607, 7554, 8592}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4306, 7553, 7555, 7546, 5336, 8421, 7557, 9606, 9604, 
             9932, 10653, 5815, 9934, 8875, 7541, 9929, 5327, 6493, 7542, 
             4794, 7567, 6117, 7565, 6120, 5341, 6516, 4800, 7594, 6124, 7578,
              7579, 6508, 8607, 6525, 7586, 4802, 7599, 4805, 6531, 8612, 
             6548, 7608, 4809, 7625, 7626, 6553, 7620, 6549, 4319, 6563, 6565,
              5372, 6574, 7646, 6570, 4322, 6584, 6586, 5381, 6595, 7672, 
             7669}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{7693, 7696, 6615, 5390, 6606, 6604, 4324, 6590, 7671, 
             6594, 5380, 6585, 6583, 4321, 6569, 7645, 6573, 7651, 7650, 4815,
              7633, 6568, 8616, 6552, 4811, 7624, 4808, 7607, 6547, 8611, 
             6530, 4804, 7598, 4801, 7583, 7585, 6538, 5350, 6126, 7582, 6123,
              7593, 4799, 6515, 5340, 6119, 7564, 6116, 7569, 5344, 6497, 
             6492, 7540, 4516, 8876, 8589, 9605, 9603, 5332, 7556, 5331, 7549,
              6698, 7789}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4330, 6631, 4329, 9172, 9177, 9164, 9168, 9166, 4326, 
             6610, 7695, 6614, 5389, 6605, 6603, 4323, 6589, 7670, 6593, 7676,
              7675, 4821, 7658, 6588, 8618, 6572, 4817, 7649, 4814, 7632, 
             6567, 8615, 6551, 4810, 7623, 4807, 7604, 7606, 6559, 5359, 6132,
              6130, 7615, 4806, 7584, 6537, 5349, 6125, 7581, 6122, 7592, 
             7595, 6519, 7589, 6514, 7561, 4518, 8602, 6121, 5343, 6496, 6491,
              7539, 4515, 4305, 8591, 6707, 5334, 6699, 7548, 6697, 7788}]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwN0L8rhHEAx/GP7PLjJEJdZgajDBa7/An+AGIwG29hdouJIiaiRLqd64jL
lUWKXCEXIguv4d273p/v93l6nuLcwux8W5IZHBWTY3z2Jy+dySu3MNibNHnf
9sTPtuuRpIFz1FDFo35l7xhO6lzgHtx1J+18qe15RoVvtd+h5IabfKLt2Hb5
UrvXqlzlGg7074I7fckPGtqF/ZA3bG+2D72FM62CVf2US1zm7a7k3d50dlnb
1Ba5xFu2svevY3ogeXBmkifw5bvGeM02znXbijt/3r/ku0a1Kf/oH5MgQMs=

             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkDtLQmEAhl+FdjsVmqJwCHFxaQyHGhydXJz1BygNzY0t4exgS4uQk7UI
Ro1hg4K3KBA0qCMkXihOHcjL4/DynO95v/PdzEwumXVJSpHjPSnql05D0tKQ
zoOSa0dKMz7E103pxyMd8R0jw10pDov4E/hHl4Al/rPozvalEZx6cdtSAX+B
q8FLOKez6W7o7nBXuC68hq/whfzSO8Rm7i2+gWtxtjlc4uWTVnRPm71wn6RN
78AefMSXOV8TurnHG86AfdjB/UdY70AaMH6G7zAfZm++V3QWd/pgXoU1RjDA
G83gmHzRfcMqnQ1NugV0yIRui7d4oLsna4etR1g=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVjzFLQnEUxY8ghg3i00JfYPSMkDYhcMzBURwK3BwefgDtE/gFoqm2WlyC
oCWppKA1EgQRJQqDaNFAKhGkzEx/bzj87j3n/t+718oXdwsuSTaKL0vRFWkL
mjCEBn5pEfrQJr4H3lmSG36Q/ZjSH1ojG8Eq2RBewUv0Rf0ekGKrUhf26f9j
0uO6dLAhveHVqF9hE07IWsy80Bu8eYaziOSi7uAvODuE+T/y4j2R98jvne8u
MRuSpmiAN0TX+J/wAtbhucG+5GNmy3htvBNYgWdkI+ct2T7eLd4NynHrL7fu
wCzqk2fgKVkafpMl4TH3puAR/iFyB6Vt+gf8OLTZV3glsil7F+j3UIKswcwc
3RBFRg==
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwNkE0oBGEch3+722h3o3Z9Llk1ZI2RlEgpKbn7yE0OvorSDi6OcnHh5Ooi
Bw4ixbrIhaR8FdJuDpRsamOVPexqKc/h1zPv83tn5v++5pgzGHVJWiKnpdJ0
WDqDcw3SPImSWeKQxWIpa0k5csj6iMTIeoXUYUsJnm94jsNr2Iub4J04+xNk
E79NtsgyfSO9TSzyEpG+A1K4ShqokUzYWiaFYDn5ovPBImLhu9mT4dtt0Is7
NqV8pZTGNeM+YBPM4g7o0vAdF8ElYYr1H3M81kmr9dIKCYakWvo3+lf6AP8p
xPlJNf4ZL/hEV0Bn4D3Ei/OTS7wBz2GSe9wLSm56F3tjuE/cPryCO3R57iDH
XW/gHnD3ZIaz/HLWUThJMvQj8IRuGP7Q9cMhkqLbxftKpD7Wd5yzBy4wg4Fb
o/PALtwFXQvsZJZxepu5pqCb3oHtdLfs+QehWlE5
             "]], 
            LineBox[{5781, 9874, 9876, 9875, 5300, 8553, 5301, 10601, 10600, 
             10814, 10813, 10815, 6048, 8554, 6047, 8570, 8491, 10821, 6096, 
             10811, 10812, 10203, 6095, 10201, 6094, 10202, 4719, 8490, 
             8413}]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkc0rg3EAx78rtRkxGzP2wuO1jZQ4UEu5yEnCkcyTNK3RDnMiF8VR8h/g
Rh5yctKS5aaUmiLiZBysKNTy2eHb5/f7fJ/fy/M8hrk8sWSTtE6+XVJ/o7QQ
kgZgtE5aZBz2SSbsgoO4UTq7R1rD9eDScIUM428MaQw66A+DkhNu0E3ibulm
YRUuQ1eoleaZx8gfZyfgHT5ZmtOlYYoU6VZhnu6dnDVwWe5h4+yjGukVd4kr
45xr6KRz0Fl0Rboczkf3CIPQT8rpK0g1zz7jX9ySgXfhttslD/TSPbRKb3RW
i7SD3yWh0tncpwlGWJOn74Yf8Je9znlPO30froAbgl+wEndB54cjuB/cFOxl
n2bcOOMA/OR9nzqkrJe7wYOwtE/2OqXNev5DBMd4i3GA/dwwBueISbLMLfpj
0sY4x9p7MsN8mpzybVN8lxMYh1es+Qd9Akt7
             "]], 
            LineBox[{5783, 8517, 8374, 8516, 8515, 8519, 10424, 10423, 9027, 
             6007, 8415, 8414, 9873, 9872, 9870, 5921, 10073, 10155, 10154, 
             8492, 8493, 6038, 8549, 6037, 8548, 8538, 8547, 4724, 10481, 
             10480, 6036, 10803, 5925, 8498, 5895, 8470, 9143}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4705, 8471, 9106, 9105, 9104, 6021, 8469, 8468, 5894, 
             10689, 10039, 10145, 10790, 10791, 10144, 9102, 9103, 8464, 8465,
              8366, 9871, 5779, 8574, 5780, 9869, 9868, 10207, 10206, 8364, 
             8577, 6006, 8520, 6004, 8373, 6005, 8518, 5784, 6422, 4654, 8368,
              7457, 8382}], LineBox[CompressedData["
1:eJwNj90rQ2Ecx79SRl7GOXZ2rMbmhCYiKUlSSu7HSk0T42bKFHkJF8jdSjr3
FO5X/oHF1ZQrpRRKmeTKSy5Ei8/Ft8/zfL7P8/zOCc+kowslktbJZKOUCkrz
ZMgvxdukVbJClgzpMySNh6UYcemP8Ifk0pKOI1KyXTqBp7jnVmnakfJ0T6wv
uNMUkH55Z4w533AEBnA5ukr4hRvEfcBu2EMMvOOTbFuySD/unT4CRRekc1uk
A5Jtll7p7pnrwxuc38d7ocN5G1dokB6Jxf6sTqqhM/EPOD/uFhb5/yydh66C
Lo8rhx76DDNFtw33SCl+C75xZwMWa6VFuEx+6qU7vGlKafY3/GcSurzjxZ3T
VcME7pouCnfpdkgvszOwin4CP8ycLtwarhNuwjK6Ubop1gmS47uueKeDfoDz
fXRz+FnywvoP/gNKtUVk
             "]]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4502, 8867, 6426, 5787, 7459, 8383, 7456, 8367, 4653, 
             6421, 8377, 8376, 9490, 9489, 10220, 10221, 6102, 10224, 6101, 
             10226, 5778, 10822, 10823, 10205, 10209, 10208, 6091, 8365, 6090,
              10197, 4704, 8312, 4703, 9101, 9099, 10033, 10032, 10686, 10685,
              10030, 10041, 10040, 6448}], LineBox[CompressedData["
1:eJwNjkEoQ3Ecx7922AXlzZ43i5dtmZXTS0kORLO0nHZxUutdzGUOJE5zkAM5
TBHhJDdtKTmq1ezAwUUplBqNkx2IcjCfw7fP//f9vP//90LufCrbJGmJ/NlS
LSjNwnc4Ykof8Dok3ZBLQ5rBJehWYBJO8I0TkEq4Rbox5mn65nZpk3kAtw4H
4SQugzNwB3TDdHm4TVz6O3ZkoQ//0C354TFuge4el4MBui+ch7fWmFdJo41d
0Mu3W7AFtwPzxMN/HcIgzqB/6uR92MruM5xJ/0z3Qix6P32RXee4jV7pMYIn
hbC0yzwXky5we5z3SYN7Md6o+6QhaHLfImHeMtjr0H3jpmAXvU36cVFcnG6c
/OBT8Bfa9CX2V6PSK0mzuwbL7B3Fv3GucL4iLi5nSUd90m2H9NkjndAtM0fo
Hd45Zf4HJNlHrA==
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0E0opWEYxvGbmR0Lx/c50/E1aDKKpk5S1CmnfMXCYpKNIo1S1EgpZUEW
FhMLUmRxlJWOjVGzVNZKFlMs7InVZDfJz+Lq/7z/632e537fxqmFsfmiiFiS
taqIh1REcX1EriJiri6il3vmrhojHjGRiHjBFV2fbtA6h521ERe6Rf47t4kT
OKT7Zf1Nv4EZ7Od+6Mrcsc91c7vYg6O6ZV217oTLcnk8kp/8X3OsYo3+Xzoi
iWe6de5Wt4VprpQrcdaO520pMtsBJvlDrNQdY14+6k6wICn+9/vaWadyptts
ibj7HHEvhSazep79EnGu27N+Tfou536wr9X+lJn/6Dq4Mm4Aq3AEh+WTPi1t
3m3h+7j/5RHj2MQ3S0b31Orfy6R7Z+TSnVnv3TToZJp7xutq/9ysX83RLp3W
HdIlb1jRQTo=
             "]], 
            LineBox[{8466, 8467, 8460, 10031, 5891, 8310, 5892, 8462, 5735, 
             10038, 8313, 9100, 10198, 5893, 10035, 8463, 8582, 8581, 10232, 
             6103, 10225, 10234, 10233, 6100, 10222, 10223, 10219, 10218, 
             5213, 8375, 6419, 6420, 5782, 7458, 8370, 5217, 8385, 8386, 6425,
              8866, 4655, 8378, 7468, 7470, 5792, 6431, 8869}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4483, 7375, 8309, 5732, 8461, 5734, 10036, 10037, 8841, 
             10687, 10688, 10034, 8859, 10329, 10825, 10827, 10826, 10231, 
             10216, 10824, 6099, 10217, 9487, 9488, 8325, 5212, 7444, 8861, 
             7450, 8372, 8369, 5216, 8384, 6423, 6424, 5785, 7469, 8380, 5222,
              8393, 5791, 6430, 8870, 4656, 8387, 7480, 7483, 5796, 6435, 
             8873}], LineBox[CompressedData["
1:eJwVkD1IAnEchl8TaWioLLPL0DutkAanwKAhNEocBKkhXBoiHAxqaAia+hh0
aqnBQahBF2nQCgJbolUc2gJnCaIPKguChp4bXp7/vc/v7v/jrPXt5S2HpB0S
c0vThrTvlT6npC75tmlKrRHpDT6QbEjaIGukaffMzHik0KhkkVW/lCHhMWmC
xDg3BiUTF2FumC5B1w8j8AZn4CZxPfY7MEp/y7kX98w9m2HugddB6Ql2iAtX
Y6ZmSVfQ4L0LWCVO3DksE5NvBUhwSDrjuc38Cbyj89P1wXF4TPeIO4SXdHWy
yF4N6MMX6Fe4I05XoZuHVejB7eJSuDm6U7pZWIJpuhyuyDkLD+A9u0XxSVyG
rkCXJ04f/wb3S/dHlvA/cA/XhQO4V/Z74fxu78a9ObgAHQHpiPkP3Bcz//hJ
RAg=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{5800, 8396, 7493, 9886, 4659, 10426, 9884, 9030, 9493, 
             9491, 9877, 4657, 8874, 6434, 5795, 7482, 7479, 8388, 5789, 6429,
              8391, 6427, 8392, 5221, 8379, 5786, 7464, 8864, 7453, 5215, 
             8334, 5214, 8371, 7449, 8860, 8862, 7443, 8849, 7445, 5741, 
             10214, 10215, 10211, 10213, 10212, 4499, 8858, 4482, 8840, 6392, 
             5733, 7376, 8308, 7374, 8843, 8842}], LineBox[CompressedData["
1:eJwNkbFLAmEchl9FimiyI4sL1OvIS6jVrSgICRGCg4ImoS2HIoKGGmwLmqIh
m1oKchCCdLlwEHUIi/6AwC2Co4zMoaKlZ3h5vu95f999H5y1se1uBSTtkN0x
yRmX+gkpAQ8s6SkifcYlD/bwj9CHbXidlNaiUi0sNZmd4kxqlG+Ykk0W6Dy6
GH4Wb+BmYAbfZj1EV4ct4uBrMEV3BwfofFvKT0tdWJmUXuELCeIC5Ja5pMG9
nHHgDfsO77iEDzgbF4UWvMA9053CHHc18BnedQ/j9Of4dXwaV8UtQQ+adEd0
Lt0i7go3D8twFbdPV2K9B09gk3fP0a/QbeKKuDMyMiFF6AbhMMnSh+AxXRAa
dD/M/5FDXIEsc3cffuPeefsb/GDfJTnu+IVpZhTjH9F9MfMPO0NFTw==
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkD1LglEYhu+gIqIhEz9IyN5SsSEEp8CmGkoSxFAQBAlxzrkltwaXxmgT
B3MSaymIiuhTJCPCyX6AQ2BlhLjY9Q43F+e6z3mfR41Mbnt3RFKOzFik7qz0
Nyf14AD2SdopfcEduG+ThnR5+IPbsOJgGA7wv4Y05pLG3VIEd0i3xd1J0xEb
MyzwGG+FMToXdBAnnQHLdCdkj+/F6deZe09XxB3gzmEBpug26R7pargk5yO8
m7lP5k50t+Z8mKar0HnpXnFR3AvM4kv4D/auQh+9B++Hp5zllzqL7OSVlnFn
C1IAfuJG6a65E+Qc4s0queN8QybYqQ7DuAYMMOcNNskU3TtskRV8Gz4wvzct
XdIleFNeYl/S8fHfky65sMN56Zs8O1iN33DF/TXe/gM+mUa0
             "]], 
            LineBox[{5737, 7371, 5738, 8315, 5166, 8311, 6389, 8304, 6391, 
             8300, 8299, 7384, 10210, 7386, 5740, 6396, 8846, 8848, 7442, 
             4500, 7446, 8331, 7448, 5747, 7455, 7452, 8865, 8863, 7463, 8381,
              5218, 8343, 5220, 8390, 5790, 6428, 5788, 7481, 5226, 8394, 
             6432, 6433, 5793, 9492, 9879, 5230, 9029, 9883, 10425, 4658, 
             9885, 7492, 8395, 7495, 5801, 6438, 4660, 9887, 9510, 9512, 9033,
              9895, 10427, 4661, 9897, 9514, 9517, 9036, 9902, 10429, 4663, 
             9904, 7505, 8399, 5805}]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVj71LgmEcRW9EQ0ZGiBoGpWZSFIk0RP4DQaJJSyA0mEg0VEOUQwQtCS2O
DQ0mSIRTNJRDiCAJBRUhSlCbOgg5VFRjeBwu5/nd83y8r2Nte3mrS9ImGRiU
dhzSLnmwSnG4R24tUsMmfbilGuxn3yu8w73BObNUgWXSh2vSv7CeN0lLI3j4
xFynL8J3ulk6H/TCPF33BPePSTPMV05pGmbGpXOSw2/wRpp1qjPjp/A19kfp
Q0PSI3cF4TN04S44s4orMN/zTQFchPmUvkR3Ai9hCbeAC+OO6W7orolnWLLh
3HCSrOCdMIuzQyvO0tlDzuhSJMS7ZuY//rMXGkd5ly6J88Me5gT3GHFHMMa7
UWKgX8R/se+fbzjAtVhXeeOTuyLsOaT7xv3S/5B97ljnXBsML0Q/
             "]], LineBox[CompressedData["
1:eJwVkc8rg3Ecx9/+BEvmt2Hbs2c4UORnTysWrcTMiZPngDTTc9hB4+LHQSu1
IhwUzVoKKW7bKD/KiqOSmz/CxcXL4d371+fz+fb0tMwnoisVkjbAS5W0HZR2
wBZI+aRBU0qTD8NDYI58FtShlw0pgw64pS+8AafxHwHJdkkx9Cgz03AYDoEy
c6/gyc9tZh6YfUTH2qQZ3ouCEn6A7p6uiJ6ii5CPgzt8P12J7hY9QRcit8AN
vo/OrJWuqnm3UXr3SJPwNV0vXYG9S3SEvQ52TJDHX4AcyIIxuiTffIo26HPc
8nHTC96459CFuXlOfszMERhhJ05+gD4jt+jzrVIPvER+wt4C3I3PkgfhZzKb
7BBeY8dPto/2/nOlVA83AYfODa/Cu/TfDdI63Mz37HHrt4b/hd8EXdxz4E9m
bOZ/6BL4OOiks+B2OAWXmVlk5g+0IUsQ
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0TsrBmAchvG/UpSInA+RwysZ9JbIgE8gcoiBQUJSvItBsiiL8gWELFIW
o2QgUUrKIjHIaVAUk1iUn+Huep7rfk71VI+l+mbTImJGJqsiFsojvisjFnGp
UPCjOuJTrvMi3nW/ZREZ1qbpVqzJMh4riRiXZfNsPp3rzo8owik+F1d1mbov
ZxVgj37Teb1Ypi/lfnR1OMDt6QbtaTBPSKn7m/CAT+KIrhWbpULXgae6M1nz
xlF9l7vPdUfcDrcrE3wv/+iuC916ImJDnmojGt27X+Nd5lsyZe2+PdvGSd2t
c/rs7Zdp3bmuhX/gh7h7TPEn/LPzL7FV38234ZX5K3+DL1w7N4ydeMe96d7l
6X9cbw0eFkXMcyfF/gWPcQ5zvP0PonhEVA==
             "]], LineBox[CompressedData["
1:eJwVkL9LglEUht/+giwiTRTU8EcWVFRriAiBEIQ6SVMUCYUSYZJDSUEO4RYo
IhRIfZEfCBYI0SBNNgQN/getTW225PMNL+85z3vuPdzr3cklsmOScqjokfou
6QNFp6UI/cKUlMU/YWWfNMCP6Y/QEtkFPnRIf+iAM9/k57A1soo1B/sn80xK
V/Q/5Dd4Ae53S6f4PD6HqhPSIt4gX8ZLZLfUGe5apTfYv47XAuyCNckO8Sgs
HZKcft5BH55lL+6m34b7cIO77jiXh2+QN6nv0ZO1n7wIj8NbMBO14AnuPYN/
sSc4I4WQaf0L85fwTeY7zD6jNjwO71KXybbIXqnfUIcsRXYNT8J7sHf0Ao8F
pXE7fwKvoTqy0e/C99AD/S9vyPN/K17pBH+EGShDvo9MNAJMXkSW
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkDFLQmEYRh/pFxSRCQppZTWpJIKig0ZFBQU2Rpi3EHRQwSiDTC0oCCHC
JWtrayuCQByivUWENsFdXduMzh0Oz33O+93v9eo0cvGsRVIOCuPSvV2qQ3RK
6k1LJy6pCN+4KvM2uTYjdchNcgM8k9IPvca5rnkOdwF+fI0ccc8fZLnzht43
d5BDsogbs0nOCekO94t7Ikt4r0MqkwFyGR7YHyYjcIVfIRvsjJKPzKzzkg2W
ZqU8u+087y1yN/ns5vtwHmbH5Bxun9kW757SX9h5Rm7TE3gf83O6n/MlM+lJ
fIis0IP4SzJCP8Kvkq/8pg/2XON3mDd5bsEbfpf5LT6O/8R9wTs+tsB3QB3f
AIP/YZ1+AElIwCEY4LZKaTIDKRiydwB53vkHc1xB8g==
             "]], LineBox[CompressedData["
1:eJwNjz9IQlEchU80BUKFiJKlPSVeORRFLqUhOEWThiGODknxsqW2CjcDl+a2
GiPHNwgaTkJUi4IIxTOUhkanEAr6hsN37zm/P/ca+dN0cULSCXrySJd+6Tgo
Xbil34D0h0p4I0O6gpFZqQynqClTL87X8NAndckm8V14bjgDvdCDCuTT8AhW
qF8gS7PDwLPw5uENvg//h11huE9eZX8GmtzH+OvQpDaLVydroCjeBvKzPwZb
eDswz7wkTKAA2S7cQwX8FHSY10fPZLdL0mdYGiI7JN1xt5alF7J7zvYc/2Nu
DVr0Z3jzG1kbr4Na+Ju8yeF8QPYBs7BI7YiZW2QN5j4w6xGd4Tv0nMMBtdvk
ORiHPfxv3vUFE9w7i9LairSKbHqbXunVlN7hP9u0Q1c=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwNjj1LgmEYhU9BDRFBIeZHlh9Ytkj4ghj6RkSWBIXULmG0JgmSEqSFgQpC
GFlmuyAEje1BPyCSlqC2fkFguHQNh+u+zznPhyed2T0aknSMstOS0yO9LkoT
zKkFqemTbpEDvxeQ3tEN+zj5Cz2TThQl/VLVIq2RVeAO+yHdTXjJbuKX4fO8
tI53QBaD53gRsiJcZt/HTyOD+QmGoUF+Sr7EnMLbdkl59q6bN63SFnuHOQEf
JiUfvUd6fhjkrBvOoTaZE3bJZmGAzAatqEW2yvkavPNKY3bpgrsHM9IfanG/
d0oaxT/D7+Pd4/3CK5jDGyZrMAs2YYQ/VmCG7IfeNfd+QwN/Dz8ES/ATr05W
5u0e8wdKcOYNbsA4nTZzGFr4wwndL5u0wm6iEe5pkBfw/wFw4z9P
             "]], LineBox[CompressedData["
1:eJwVj71LwlEUhl+3FhMVSbL84U/NomhycRKcJAhCQvGDhobIJJMaGiwaAqko
BKH+hqLNpUg3EcSCCIpAaBAaGoMg6APpaXh5732fc84917e8kShaJBWQw5T2
PVLekFZR2Sn9eKVdfI98GG5DFc5D8AP8yCUd44do1i7VcDvMgWycT+BrbukZ
ZiUbIzNwA6/BTM4FuAdfx6tk07Akb86Qlcg20Sl5hPwMnyBPwRvslsbD5N8+
KYqHYTmyLmwJj5H9wsZ5P855Dq0wYwHvk8//7wP78vNXdMP/LAGpOCkNuJuw
FDWPzHtC16PsS/8iO93BHsjaZB1UIk+TvzL3HnYelN6Z8YGazL3gfom2qHuh
vk9vlB3f8Ax9WbQN+6Q+Rt6ip079FapOSTuw25DUG5H+AOBDQbg=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVjzFIQlEUhv+WgmiJEjLJeKmQ4gOlxdUGJyFoiDDEtKEl38PIQIKCoMEC
QzQQotnJSITA2tpaQlpyaGhqFQJBkqDvDT/fOf9/7rn3Gjl705qQZKHwrHTu
kXaXpQu4B3OovCBdoq5LusZ/ghn80zlpBp7BA3hFNr8imeypOjVeDVaYb8Ab
FCG7g0tkXkfUVXKL/X0yN14ILwRN2CAzqW3yAqrTx/ADeCnujcEj/CK6JUuQ
reFF0Q75q1dKwzj+2JCSzv/oe/hZuM7cBt7kqjSFRj7pF3X5h/xSHu+P3uBt
W8x9cG4b5rkrDVPIR5aBWXSIvw+/uWsa/w01A9KAHT/omb0tepu9PbJ76s9F
5tn7BUvOXv7yTvZAdkw/5Fyct75wto33iDqoEpROyP8B/WdB1Q==
             "]], LineBox[CompressedData["
1:eJwVkMtKQmEYRbdl0IWCpCsUVN4qMEEokyOpCWVwRGzmNKgDBTVImzhwapOg
EJxkZkUQBEFEDxBFvUNgidArBI1aZ7BZ37/Xfzk6vXWwue+QVCBXg5I1K73N
Sf2j0jv8IHG/FCM9dFHYB1/oe+Er3OFMg7PmvJTxSs+sszDhltLQJJf4NfiE
S8EoLglXSR1nwEfcCgzjlm2SC1wIPuAWYQgXhAukZr85yZukPCJtwNsp6YZ0
Mhd8ks8l3XP2kDnA2bZHapE91h7cHW6X2Y/7pm8Si7UbV53hN4/zv3Bfg8SG
pG3c34RU5L0unJPUcAbulz5P76A7gqf0YfocXILH8Ic9Z9xbIV/MJdiCJvs/
YZY9GXLNnIDDfEd7TFrHp1h3c48Bz/FxuiYuYr9DnLgB2AFP8En8Pwk3QF8=

             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVj71LQmEYxU9KKdEHSmRBgVbX78VFykJCwgYbol2CcDDoA0IFwwStCAqh
pVpDbBKCiP6T5iJJoibJSYrod4fDOc/5vc973+vZ2t/Y65O0g7IOaXNKGnRL
Q6hGNsalUbJ1TJrHL+nyM9INvsQcQzbYKv42IbXQCjsJ5jpn1vEGnqL7gJXZ
zfOdF7pT/B1vm+fgX/gx/BO/xq9Qh7zA/WnzW3iXec0vPc9JJXYyXilOf2u+
Y1Kyowr9KzxB753lvzizjU7oW/S75CQsDDsgN7nPcEo5smVauuOufvyM88Pc
54MVYB12v1GEvSLzPXt+2CG5R/+DorAj5gdYAFYm/9L/oUVYhfkRFoRVyQMG
b0bLsHPmJ1gIdkEe4Q0xn+TA7S7JyVvizGF4kzf+A9phPdg=
             "]], LineBox[CompressedData["
1:eJwVzrsrBmAUx/GjvKUYXr0pl8LLS5QiJYMUg9Ugi3K/JeVeLmVAJmKhlCRl
sUkZFAP+A5kwWBhkVRbFx3D6nuf3Pc9znvTwTNd0VkRMqYuyiM+SiCG8LojY
1N/gdmFEsiLiIz+ij7uS7XL9+rVUxAzumJnGW26LS5nfx3W+UL6Bi3ggK+Lq
vXWkL5cd4557p3iiGrkzrOFqVZ3+gF+w44nLyJplTdiCx9wS98I1yA6dO/7f
0Q/Y24rL/Io64bq5EXmHfFXWhu2qU56oifipjBjlr/xzDH+dc+Q9/H1VxITs
uTRiEntl2eYSql8/qObsGMf3tD2Y8a/cTESeujWXwjnvJbGamzXz5r139Vrs
r+73+tcDd27fl/3f6s7dS+cFdx+5efwDKmFARg==
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0E0rBFAUh/EjNixoSNEUjZeQhWShsDPFmiWrqSExjDCJZoUdslJEIsWk
bCwl2SgfgVIWioX4CPwsTs+9z//cc283lVkYmy+LiFnVlYhoaotY6YxI4WNL
RBIbVYdsKRlRUGv1EYv40RSxgO2yGj1552rx3rl8XUS1dRWX1TPaHJHj3pyZ
wwxXrm8CZ+yf+Wl8aI8omV/p7CXe2d+qJ71T8gr+nC82RAybuY5pzMjGzRqy
HlSv3vSb8lb5qf4RWVr1yF5kBf6YH+COsJ+/se6TXeG1OuBL2C27wN7///GO
M+sit+XOVtzEE65Bto8r3LLac8cqbsgP+Xvzdrkct415fOD2ZDtq0v7THd0q
YdY3dyfP/t9vxo9/+OLeuT86xD8D
             "]], LineBox[CompressedData["
1:eJwVjr9LQmEUht8garhFXZBSUMi8SdDS0hJFSThEdi9o0BBEOGRBZDqUpFBE
mf0ACSRock36W5wCB3EUCYKiaBKUnju8PN/3nHO+8wWT6fjxgKQUOZiWDsmu
XzKmpD1oTUh1r7SPT5EyLmtKFeih5xl64SQZ8kgv3M/pq8Ios2t4Ax+Hbd6x
YQfG4Aap0fdGHHo/8VfMnvL+B64Iv+A32aL+5zrqv7BEbXNWerf4W1haYsdo
SFqGDZxNrQlXuZv4CGxxd/B95tPMHJEofo76CecMuWHPYEBax7+6f/dJI6SI
/2E+hp+n/4zeHLnHd9138Qv4PK5AHvA9fAK/iL/AXZJH/PCMdM15m9oKtVvO
d6RMbZzdO3hfUBpjr0me8P9XcjsL
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwNkD1LgmEUhm8blDdMCy0UEjVN9E+09EJqGPr6kTQWDS62OAiNYh9E0RKE
kT/ASfoZ0pIQKuEiFBJRNEST4DXcXOe+z3nOw/OED0+sqk1SBcXWJHtMiqII
mnikpZDU80kGfIYOaEfH65IHxjlzR52ALXiPaivS6YbUpjaZMbxSEC7CDEwz
+86uFOww4yIvk0/J9uEnLMIC6tJ/Qnlmf8ib7K2z/5fsHL5EpT5yRqQBfIhL
r/CS3hCO0DK9MXyk9wav6GWpZ+yo8s5t7j/iLhMqIOXofTC3g1/lbBJO8Rb5
F0zj/eS78BufJ/+DGXyAfA/+4wvkBvuy+Ar7LejEl8gXNqVr3tTg/hL5FufO
qC/QDbmbuQNyX5j/8fMGdEs+B6NVOxg=
             "]], LineBox[CompressedData["
1:eJwV0MsrhGEYhvFHSqRRk2iicVazspAsbOytNOUfkA3KRA7ZMAthJ1nJQtKg
iY0kJiGH2Mx/oOyVw8KW/Czurve97u95vm+mfTSXnaqIiAlJZSL6OiI+uiPe
5aA+Yqw14gjfmyN6dYPJiE/nL7lriPjGBr5R3nSTnt/mduRBv+i+kYpYwE28
5wq6VTvz3Ba3jE/8Hp+2p4hr+h5+HVfwhOvUdcmpcz93hrvmLvBc+rz/Ekuy
z9/gT3vEr7zoBsxkuREp6Je8u8K+1/85v7eyK6JKnrmS+5Uceq6au3We9C1l
3b3zgxR143ZN8cN25+0bwmN+jK/xfybM5vTX5qYx6V7Lz+jLdsxyby0R8zjH
JXR1kvJckzyaa8NZLo0Z3/oHcc1DOg==
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkMtKQmEUhdeBEuMkaqk5OILXKOgpSgyMgkTLNOgysKjIF8ihsy7j0jBL
nPcCvYADn0FQwsocFNFAqM/B4tt7rf3//z4ndFhMnRuSztC+W4pbUmVRqqLJ
eWkK2VFnFgaliE9q+aUwLDDbw/fi+1Ab35yRXNSnZBYMoHvqJebr8AGVwtIF
alJPe6QYMw64BTeY63PPOnwmd+Pv4n/g5eEnXGGfZXQbZVdkRqQE/d0Ce/D+
KvUjfgM5yZL0VbI5sjXqF+7d464DNKLO8ZYRkP6oL/kHXc71kIezfVjj7Cu8
InuD78hPNoR1sgG8JvuC38gi+4VPZD/whszG/Ue8Z4cn8Bht8m0mfYY5IyaV
2S2NF+J8Bk7gbZOZMDv+T/g70DHu8f8BcY087Q==
             "]], LineBox[CompressedData["
1:eJwVj79KgmEYxU+CBCGESJYaWqLhDTg0FW0OEtYdOAWRoqbYUkhRVOQQ4gVE
CqJQSxQoNuQ/qmuIrMmcQpBaot83HH7vOed9n+f7FqPxjdiEpBhac0jjJWng
l75Q0Ct9zkhDzqU5qYz6+LFL+oC3HqlikxIwiUbks7z5hqtW6Qf+ojZ3/6CT
zoWGdCnuX5OVUY8+h79k/j4swI4xn+6U+SdkRbJj+EJeI/cy5w6e0S+Tn8N7
fIC8Di/I8mQr8Io3TTLRNWCQ/U+wZeyn60ET3QL5G3rgf00+yYy65E18JiC9
0z1yniSfQq90bXyWrk/X4bzFrDA7t2EErqMDvj0Ec7DKvh26JN+2SXZIdoRu
yO3GTGY8oxT9wC2l4S73LeyYp8/iW+zdgx78NPk/+khKag==
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkM1KQlEUhVdIiBdTr0r+ZOVfJhT0EgkFinqpyCAQsQIR7yvkG2hDBxGK
JISzaCbSCxQ+Qw6aNPEF8ruDxdp7fefsfTiphm11NiS10JMpeQ+kSV7y4dmM
ZOAe1Ie58DFsE0/ChP9npR7M2JW2UH1bcuP3SamJPhNSLSftBKUhd6+dmrtz
7s3QJX0c9gK7oI7APsjfUZU+BnuGVahDsCn5GyrRR2GrKPPZOWdPnX0zvAi7
IjvHz5CPe5GwNHL2kRfITpFBHiYfOLvI/5hl4TfMCZAf4358yszHtNRFr9QT
dMK5MZ7mTArZ1DHcy5sWzDmC79H/hqQ27JD+izxIZqIl+Wpf+sEb8DtmP/CP
t9RV6goqI9P5T976zbkCzCJbA/doNfk=
             "]], LineBox[CompressedData["
1:eJwVkD1LgmEUhm9barXQggQrP9AGgyDDJXCpIae2VpckxHBS3poEq8EoBekH
NAiKWSFtDQ1hVphf9AMkN6cghCLoeoeb633u+5zznOddjB7sJCySkuhqWhp7
pY5dirmkhk/agyOPlPdLBXSB7PizaGyVqk7pGn3PSzVYnpHuYWlOqsOhTfoi
Cy5JP7BCbuAfoj/ODvxfGGaWxSFNoCY9k9BJtoBGZEfU16i7RW/kp5yL3JGF
l/AFz+WWcsz/oKfHzn30jv9ITxvmqD0j34Dn8AHfT+0TzHPexC/AImzgWXlj
kLs9zPWiV2qXYQrfB9fJAnAFtcnWoEG2CkNkHWZsMyuC9vmuskOGXQdkW3hx
vAS6wc/iTzHjk+yZvZvIZt4JU+zUJWuZ70F31KfpM/B3mXNM74n5v/H/AeaI
S8o=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkM8rg3Ecx9+ypnAY5kchPbON3Yiadlm5UXZYDis3hRs3WnLhojStbepR
+wMoVpt2ISXKaoU9axsXLmInrqYUL4dX7+/n/X4+7++3x1hcC682SVqHUIc0
PyjFnNKCIe2jyx5pBZZg1ifNQMQtXQ9LNzDhkoIwx27DK1V6pPyQ9N4tffVL
dfSoT/oma/BNjuwMfslOuqRLzsfk5+gF/OD76WsekE7Jt/F2wM5s4NvQaXpa
0Ta4o9+Besi88EFW5q0u3uiGKl6VeWtU+iSrcb5n54p79uiNc0cCNXnDIVhk
RbIkvomfxkuiKbjFd9AzQm+KvEj3Aepj7sQfQ1/oN/EeyCaZo/jj6BR3l9gP
0VNGM9xTQysQIHtEnyCL/4za2W+BV7ICnU46esHCKzFv0vtGZnHe4Pso5Nnd
5b3tfFMni/z/a7w/sR9Pjg==
             "]], LineBox[CompressedData["
1:eJwVjz1LQmEcxY/tDt2rl7TrS2qSd0joG6RDW4FChvbmSyAK5iJ+gVa/QjSE
LpJLOjSECNEmDn2GRCEwCBzr13A4///vnOd57t0p3WYaLkk19BWSDm2p40gp
fMm+QFNTcsWlDXQcoYj/7kpHdFbkpiUVmT14BS+jOr0aqjJ/cn5Nb477w9I2
mm1JDv0meZz7lmQx+D7sg8xtSGH2FnkCd1Cf+YB8gD+h9qZ0xxvPzIZHStIx
8RF7ak+6j0le9jUdC39gT8NfyHPcc0nfBy/hK978RmfwPj0bbkT5X77tBBXg
Q3gIbsEzsCw6h7/CI3A//BSWQxfwPD7mrRvun+BXsB/esPm3Atkb597/7+Tc
Nfsj3xYgKzJP4TMUJSuz98iCZF38DzypPDU=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkEkoxGEYxp8hZU2WsTRjGWEQJxfLxBjkqKaQ4iLlQMhZ7jNkO9CMOHCx
FAeHoZwmDhIHszQzcaDGWuZE4eLn8PR73+d5v/f7/n/LyJRz0iBpFQ3mSNOF
0lOZFEfJtVISMqBX9IISNdIHOs6Xxuir6qRKNGBhR65kxjOhXfbY8QMF0gX1
KPUt9RBzbvphOA9n8BegCy1bpXG4BCfgCoxXSO3F0ja7SzhTijro7ciB5+Od
JyjM7p9qKQT3uL+Xb/ksl77QGfmrkQ80S29wv0j6ZfabmVOyF7xUssM86Zz+
gNwP3/FT8Jt4QyY8Infhu1E2vRU/C3ayx1EJUQSvB87xj7phF5mRmSXOLCO/
if/AXi93JMgW8S7xrpCHeh1tkK3BTRhktp49a9wdY3ekSoqiMP41Z+6p79A6
+Q25BzYyn8f9AXIvvfN/JwzRNzAThTt4W3h9sB/d4aWRxWAr72pmRwsK4rXB
WfbZoI3sgZlH5OMNzzCdmQz0RDbArj/vlWF2
             "]], LineBox[CompressedData["
1:eJwVkb1LQlEYxp8+aAy0UKm8er3mLcNBUog+prRoaHEuo7tEQbVEoO2Rk/0B
RTiFTVFEiU0GrVFC/0ANNahE5dAQ/Rp+POd53ve8555zTWc7s9UhaQ8cj3QQ
lQrg/BORQpYU7ZcewtIq9RWyLBjkNvk9eZb80yctky9BmLyHuoXWqM+PSFXU
xHeSB9EKfo78AjXwvyHJj57j0+RldBD/Qz6AnuJT5LdDkg8fD0oTnFvB30De
JZ3Qc0hPCW2z7xg9ghy1K3quIcGeS3QcjTEjzzqC9rqlZ+4QJx/DN/qkXWox
fJ38CSzyd/Jh7mjDJmdMct4UrNO7AV7611AP+hWQFlg30RbcMaMGH6wfmdPF
jG5YZE6CGUmYpT+NT0HO5h2ZU+RfvLFnn7erjvKjvHwPvXV4wb/CN+s2uOh1
g5/MgABMm9IMnLFvh1oZ/QMZaEfz
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0klszlEUxuFjIYbE0KpSU1WpDqaFWSTGGhMi3WDFzlRhWzSsDAsxW6Dm
UDMJYijSkqCCNE1ptcawMIRIpaXK8y3e73fPec859373/jOWrl5Q2CYiUv1M
TIr40Dui04CIj3i1e8Ti9Ijj3SJO43u57tnqBkYckatSdxgniFPk6/gl4gK1
B/EIHqXX8rVmvR0U8YYa9B3gj9FXI1/SM+JQQmpL6Kn6A1iJdep/OFex+bXW
L/UO1ZeX6BV/5+XJ5VJmn4hq8/phX5rO64FpVCWfijvMTcHe5vWifHMuO0uN
/ks4TZwm31nNNz0P1Z9ztsd4kZ8kf8/6Lv02/19WxFn+V7UdeF+wnNfcP6KJ
5qspzYk4Qy1qa1Ij7vDLaHlmxDKamhZxIjmif4a7xkXOsJgW0n17Vup9Qq+c
q54aKF1tXeJO6CV16+GMaranROzBf86xC1txN76z3x91v+mTuBn/UgttsudY
8yLRJ26lSeZNoZW5EZPxNW8INuBQfIM//JcB/Ex6puc5zTNrVd+IfWpGyo+m
UZQjrteTh68wF8f539vUr7D3UXHZ4IhjeBNv0y3awh/P34oX3dUFmqHmPG6W
G8dLNi+JulI+rxGbnK3R99EO53rb9vhL/Mx95nun0c5aIJ8s39G7VMk3uqNf
VOE925r903qO2k78zrRSfZr6QrlVtFpcSGutP+sP7/0FB2M2VZszQn0R/7v8
MLkauReUY142FXnjddRozjDxdufqYu/h1sX6NtIYM+r0rEnsRTflinxXJ/Sd
pGa5Utyp91RiHu88XqC/vCu4m3cJ1/Ou4XVq4w5v4V7eDdzAu4v3qC2vAvfz
ynEWzqQKew/yjY3yX7LwgXi2/CM12eIO+nJwiTevlJvD+w8Kl7kz
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0nloz3Ecx/E3ScM/mDFXho2Nqbk2IZTFXDkWfyiUouRuCuW+Yv5wrFlI
ueZY7uNvpM3cRcowRJRzrmw25OGP5+/1vt+f7+fz6zp78ZRFjSKihZ91rSJu
p0bsTY+4SxO6R9yklVgrV94p4gaGtY24TvunRPTDZvbwHhGJrSNK9A5jN9Fb
oq8YQ/it5YrlBrNDbrf4TuTwW8kVyWWzf3eL2C5eiH78lnK75Pqy6+Q2iW9E
Fj/bOZ4kR1Qhyzl+JPoGZxko3kc+Ez/0fBXvxe6NFXqHmrdSXY14Y32f6XL+
ErXzfGcBexk6mLOU/uniXJjArqNNnancznr2LzzS38LsJPXTzMgxP0/tA/G6
tIjm4vnizWgtP7WnK0BtRsSYdhE/6VhaR/NoPR1Pf9FxdIp9c9mn2kTMoafp
NlqIrbjD36muoFfEDjqza8QsXGBfsecarmK1OQPF19Ayb3ASC8UXIKd9xAa5
jVjcOWIREtgDsEr9IPkK8zL46ci0qw+22H/L/hRapG4WLePPoCfpTJqr7wMd
Sd/TT/iIcB97aAlS3Vkaprv/qXZPcqYk9RNpWzqZtqH5NPn/ndB2dIR7rnDP
uc53zP5a7/lM/I/3+Iv5vrHS3Jso91YVqLI39D+mp+yebGe9vgbckq9J8n81
9ws9450bqW1Qc0OuEolyF+28zz4rfw5f1XYUvyT+25zzYg/kHyJZfIj370Iv
y+8T249u/EzxFDrK/Dz/zTF4JjaBrnPmcXS0XLqaA3oe23Ovo2+gB+34JvfC
fypb3SBU633FX6/3u9xr9nP1L1Gq/ygO6TuMp2aM0HPYmV7pe6P2LarF36k/
ofY4jshPp6X0jXiW2n9tVat7
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV01toz2Ecx/HvDBNuHDYbc9jMhgvHrYxtSMpxmzHEjNwQwg2zOYUidxTC
laKocePMJSLltCJixqRIuXHmz+b1u/j0fr6f7/d5vs/ze55f3upNNRvTIuIX
tWVGnMmOOE3NQyPeiD8NiviYaETE9z4R+0ZGfDBuz4+YXhAxld6Lv8mN5Y2h
4tyIVnPH4ziaLVetbq+5NfhWTRVW0iy5IfzR6m72izil7w0cJR7Mn6fmuviV
OddwjjiXnyf/TY9n6i/Z73O8Kl/A/8pvEf+zds+iiIvybVnmyQ2kR3J/5SZb
s5R6qPliTjfsTunUqr4r1qi7MCripbiL+BU+NP8BzewbsWE45kScM87PiziL
K+yxnuronj3VmjdoQMQifJPsXV2OuMW6A/ERPqHHtHhwxHI9i9QV0u7REYf6
R1TIHcZKrKK5NJ/m0Qw9m3A7NdJO2kFH+RV6HcEl1qnX6zxtMW7G/rgS+2EW
ZdIY8ThaYzwWG8wtxrXiEhxP76w9EdtxApY5/0l1m/W6JL7jnFfwFl7G23gi
+S7OVk8veHXJOWkhv1rcYa0F2JmcC/8l58QUVuJfHGGd397aH6p1b73cRcr4
afIu3Osk32spP5vfu9Cb4He4p0666w1k6JUyrlJbTbnq7vOXmbOctvHW+fZb
3VsDfeI14UHrNuJ6uXLjHeq+WDt9mLeGu8QVyV2p+S7+bN4P3JP8H/wDWKrX
RHv6yU8l/4hxCU3mH5b/xe/kT+KV0hT+MX4q6eONlfHKqYy/X78OfrH+rfb/
msr5x9WneSMZ6qepXeXOpuMBnCr/H8a2mDg=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0l1ozmEYx/Hr8S4Tm/cMw2yYFI4oL0OUHNiezabk2eaUZ17DgZmFMC+F
OHCuOCDFENtOjM2R0CK0TU6UQpiXNvN5Dr797ut3Xfd1X/f//s+sqS1NJyLi
C27MiOjNjliBRbMiludGdE+IWEaXYiO/PD/i2NyICvpRTRlNYoNcHn+JutZx
Edf0aqGLxTP4JWqaxV32PKJf50R8w0L53864PzniHt7a91C+iP+L38S7i5gZ
kUAhf3RhRAF9pfafc+/I96qdw/tJO/kDeXJIyt+cF3ELo+zrmRiRRbtov/wz
s9XOdk/xSP77SRHDMyreyU9jfU7Ecz3X0cfiNizQrwjXeVXu1mHmFG2nL/gv
0a13Dz5gttnzkav/Zv0rUZFhWsRWM85TMxf18yMujI9Yaf9FmqRl2IRSlGCt
M4/QetShAUdxhb/SGZdppT5VzqpB2rqaHvC9W/Rc4w1Woxi31e6ydzdq0Sx/
iLfD+iD9YabveMDfx9uPPWgV76XLp/hf0KR/u/t0oA1P8QRX9ah2xxq8UVNF
UyjjJ8VDzTYcw1AqHkyHIDAICRTo02f2flSYOcvb/LPu9K03Zv5N823hjy2I
GIPX/IS3feq/aMdU9Wlv84b/SV22mpP2jDBDjnW5HpsxXd02+RS2e5PDvB0Z
tbcOn/kN9HTmnehOueP0BL7InaKNcidpWu4MPYtvcucza7lztFZulfVF6z9m
+i7/l14SF/MbnNsnHuoO/fSYeG+mPx0Qv+OH75/ybRp5++T+A54Llek=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0k1Mz3EcwPFPucjmodKDHvRAytOclC2Mg8zFJhUZpqdNGT3hwMkcyOKE
deDo4iFsniIbcbIxBzZCM5FZWxIOceDV4b339/Pw/fy+3//3X1DfWnkgISK+
oT054lRORDcepkec5NYlESe4Te04NxZGNODVoogCPd3FEafRhWy9WchXm5ES
caYkIs96Qv+hhREHkStOUutWy7EeV+uU70CWOBvz8NK8TB5Tb1drQ4Y4zzfT
OQ2jau9TnXFqrvwu8Vz5VLyTH82LGOStzr1T7YWZAxkRz7l0ccTr/Ih++yrV
t6DOHTfzbq7Q/1vfL8zUU8wluGPfbUzK3eJq86a7c6p1eUFElXiGeBsncQ1X
u29Drt8OXXpOonduRJO4b0HEXT21ei/qa1e7wKvlauSOWZfKlYvXokVuH47I
rxEf5TJullvFpci0buQMbuD13Mv3fKvAOVvNuya+gcNq17ln6oxqjdiDetRh
At8xjjFs0PuDE9y/hxN5ibdcim1FEWfdq4ZrsR1N5g57h1zfmY8c7Dcjj0f8
xl9RMS9inVnn7N1hz3lu5hbsxSVxvTd+5i3ruBENuGx2kbtc4Y1mtLnfJus3
vtdp3YF2fHLGId+s8q6zveFn8Sz+wnN4mFM4Fcm46Sw3pt5Wf6L50zBo5mRa
xDL/jz/clxnxT/2t/HK5FRgx5758OMMH+SGslH/k3B+tH6j146/9ZfI/3W0C
j9WH/Q4DXONehX7LcvUn4qv2PeXV4rV6/gOVJon5
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0mlozwEcx/HvNHPPtc0ms8MtK/OAWSHP5kgSM6RYNuRajlybI6RcD9wi
7YH2yBFLjnKlUGjGUK4Rc+WRLQ8c5fV/8O7z/36/n+/x+/1/eeWrZqxMioif
uNwr4siQiKM4iMM4hNe5EbcHRNzCAXFln4iq4RF3xAOGRQzE08ERz9CARjxB
sr5aM2/y3cBevXuQmxHRXz0feXjfO+JHTkQzndcvojzfLL65djTRpxhrRzFe
mfmOby7fQr5GtbvuaaBj1IvwkuctzxyeBTyLeka8UW/ka03Mo9vyIupoGc/s
xE6emXQSfwl+8aW6cxj9Q6+Z+5teoVfRw23dkeZ3Omr4tmATqrEZTe4o9fxd
+bqhC8rsTKWn5fP1VYizxJfEu91UT6dmRVz0vs6o7Rcvl99Hi+W3DrIHK8Qb
9dX4Xct7IS2izX3T5KarVWVHXJfLd0erfL1dP+lacbG5a+hnuRbkip/THPqC
LtO/Wv9yWmjnA3M6yndCZ7ShFaexAzuRjPaJOPEciRztQFNwX3+BOSVypeI6
8Sxahtk4Lp5Ij9Ht7h8xlB/z/Sdl7piDbLd9lPuEFgz2TirNO+nZT6FQ/yiM
xC71EvvOqs/zfk6Yu5ZnHSbLLZOrHBixGBVYiiU4p1ag/zy9x/vQnCl+v/Ft
TqUb5NYj3btLQ7ObMugX73Wj/CP+x0h2W7V4Mzbhq/p73lLPk8n/TdyH9kUW
/qZHjPPN5SX28STZ1WznaN9jEb7z38iMaCf/QX68XLa+CbSDXSm4qX4L/8z6
D3dhlQQ=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0klsjWEUgOEjYmUeUm2U9qqxaCVITAspiajYSKRKTU20pl4xhkSr022L
KLZUxUIqEVHU1JaQSAyN2glLU0iMC6xIPHfx5v3P+c453/n/exPlu1cnB0TE
R6wdGZE3LeJ4fsSPjIgb0yN+cmJqxFfO5e88gb9xDpfoeTs24ou4IS+iESkM
SkS8NKsf9eJsteOwZGLEYnSOingiv3NSxA4kJ0eskquRq8aFMRHlctfkirMi
msyZY5++0RHzeC7Oq2u1aw2Wic9wu76l6TNeoW+g/s/u223HXOdJTvCHnIhK
Z5vdsQUb0aZnExe6qyC9t7qzckXmneN1fJlLuYOr1O7CQXts4DL8wiezU2YP
UTcYwzAUTXLD+ar6K/r3qG1Pvyv6xIXum40CtNrzOk5iofg8z+c2XsC1ZnX7
nu3iu3wH97DPzDXO93PSXVXoMfuP32er/G/e66xT7qJ7D6T3R694ke/Vam6V
3+4UXzL7ppobeOY8ZVat2uW+Z5fzp+nd+bD6x2oL9JeIK8b7L3GhuEM+Q99Y
ZCKp9rSzLr230IwWlMq9yjXfO9ThKEr11nOWvttqKuz/1/75csfEx/Fazxus
U1tt9sPMiEdYL25Qd0LPPz3dZswQz8JMjJAr9h4rscl/uCzb9+GUsyY0ogVH
9DdzNV+04zZz93jezpXoxSFxD7/HOxSJ7/Nkd07BVOy1Wz5PxzQ8cL5U3XOz
633T0577feM6zy/4hJoK+/wHqIWNvQ==
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkL8vQ2EUht9WDWWQIKQDSYMUU7Uh6WgoTZqinWh7O9AEpS2LVg1XtUln
YzspBmKnqgMJG5u/wc8/wIanw5P3O+/5znu+e52r2UjGIsmERK/U5ZS6wToo
tSYkC2rgrw9JcTQyKZXxSnALOeoGGnLQR9PUBvo7IP1BmDrGXBMvii5RH3Fe
YccytEakO2hCD/dr7PSOSx4ocfe8X5rHC0ByTCrgraEHaIa8C5d0CV72e8Ak
00d+Daqwz917MvLtmfY8HDOXIy8Pe/BAP4y3SGaRmR/eYSfnijfVqSv0Zql3
OdvoJbjXgW7zT66ZLdObZvcMPFIb9J/QBqTIv0G30AVysuzfgSLZh2DCCf0q
/U4y3Xz3FETJruO/4g+z9w3vHTbIcLFvE/2g/oQKhNhpwwvyhlPm/MydoXNo
Cv+bO3HOMXju4+2j0guaRr/o/QO2w0wZ
             "]]}, {}, {}}, {InsetBox[
            StyleBox[
             FrameBox["3.9`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.7560003855412551, 0.7732654897135212},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["4.16`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.5119987742863144, 0.7704081632653068},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["4.68`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.28745265577005696`, 0.7780837693611988},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["4.94`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.6342383900038797, 0.8680497462566579},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["5.46`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.8679167812458006, 0.6479875829061621},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["5.72`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.411345477768287, 0.8891552146681647},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["5.98`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.520335037440482, 0.6525404940192767},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["6.5`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.2208065639209411, 0.8979591836734704},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["6.5`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.3088102733331337, 0.6538552321994513},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["7.28`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.12087695059826542`, 0.6513605442176877},
            Background->GrayLevel[1]]}}], 
        {GrayLevel[1], Opacity[1], 
         RectangleBox[{0, 1.1102230246251565`*^-16}, \
{1, 0.4761904761904763}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
         GraphicsComplexBox[CompressedData["
1:eJx0nXl83lWV/4MbDCqi4wKOjFVRQQamIwioDN+qqLiDilRBKc6IiKKAjAKK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          "], {{
            {RGBColor[0.178927, 0.305394, 0.933501], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmH9s1VcZxs+9LVCWraVA77UtlxssyEpC6YCWrPe2YrYxW8BJhzDmQKNC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                "]], PolygonBox[CompressedData["
1:eJwllF1oznEUx797ZZr32Ww8e5rtUbtZbMvy7P/MNJRZhgvKPCMXbMiUiJFN
SF4mcuFWEkIxoSaspE0oTSlb9taSNJtSzFz5nM7FqfP7n3O+55zvOeeft7Np
0/5ESVuQZORhWBpLku5kS49CUm0gdWRJh9KkOO8x7BkEHOY9EZFelkslU6Rc
fDrRF+K/gfhm3iH07CJpL/5Xpko56PkFUibY85CbMWkAaUz0b4Po8TxypoM9
XzrF+y4YbSlSLFO6h36ZHKPot8HvopYhfGqJbaae89TXwLeNs6Sm2VJVqfQd
SZ0j9cyQhhdIL7BfJ99ogvQcvQP7Z3z7kE7e28ifSr730+iRfOtCzkcx5HzF
/gD/D/j2z5TCxdJvfPalekwdsRNl0npqfztXmkQfWSRVpvq3AXzXVkhZOd5T
fT78gdk722uwWlroL5lcScgJ9N3wtXmq92C9/C1zbOPIuKrDHtD/Jzg5hv+y
QumgHPMZ/qdjzuU1ZnQxKlVTw2O4e4oMkXscSSfXLzCWU1ucdyv9VsNnduAc
Gpdf6DeXfi+EfNbGuXFvnBl3VvOrsGMYlu2I7UofMz+W5jvQi74SzNw0z9mN
PR7zXbIdugYfx8u9l5/MZwe55lX4LtoMbBbbQ26zGTfju4f+t8BPhPnuQm+L
eq+W41LUv5nNOGxAP4As5r0c+UE9NYFzUUl9rWD/jviuG6fG7V6+TU/0nbtC
vjA1VyU5RxMl0ruIc3UDjPLAMQ3bev6H7QgxCfT6kfij6PUh1+2m7La+sZMt
8v7uk68i8N3eyjsg12TEd9tqttrbbWZJvoO2iyvwn0F942BWoo+Bdxm8Rnza
8f8b8duzGztn/MFnQ473kAtW91IpJdlvtgt99RK/FbuRVegbCv0WDNOwC4h/
CTeTxJxhXv0LmT3zeELN68i/ptRvw2pajT5U5L28BmMYfTjqt2w9nyR2MOyx
tpO2m/F8v027EbuVlpDPxnJa7gw4fDPXb8pu62q5924z2ofvgsD/PXYDjWHf
WdvdIuod4X075v8e6/lWzG/abts4rSE+HRmc6Tc9nVpGljqXlvMPt7em0Hsx
H/M9G3Js28FG+G6NOjfGsXEdBL4btgO2Cz0Rv23jzLj7D74y2bI=
                "]]}]}, 
            {RGBColor[0.2630497119999999, 0.3938123039999999, 0.938291664], 
             EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmXt01dWVx39JCHlAeLSS5N7kcpvcRBrEVEhqMPfe8CivVotWrR0UhIgV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                "]], PolygonBox[CompressedData["
1:eJwtl31w1cUVhtcQSAgEua3kcgmX23CTMGklQwCN5v5uLEgCHQQVFIsmfFSn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                "]]}]}, 
            {RGBColor[0.4452219679999995, 0.5600506239999996, 0.949590128], 
             EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmgmUFNSVhh9bdxFokK3prqLtNNVgULoEu+2Wrq4GFSQxUdmRRVAUY3Q0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                "]], PolygonBox[CompressedData["
1:eJwtmHuQjecdxx97dhcJK6xdl7WEsy4b9rCsXfacsy6zS5JO4pYgrkGIUikJ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                "]]}]}, 
            {RGBColor[
             0.6849889999999997, 0.7538378799999997, 0.9692369599999999], 
             EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmgd4llWWx19qAkJoqYQQki+CEfIRSIAkX76oiCgqRVzLLK6ODXZ1pFkR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                "]], PolygonBox[CompressedData["
1:eJwtmHl01cUVx0cSsiiLSQh5gYQs7wUIJCEkMdtLogJaVHaOgoWiomKrLQgo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                "]], 
               PolygonBox[{{12695, 12694, 13905, 4815, 13906}, {13281, 4371, 
                7866, 12694, 12695}}]}]}, 
            {RGBColor[0.8820072399999999, 0.9087526479999999, 0.988607832], 
             EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmgl01tWZxv+ghIASCJCVfAnhS0JiQkxITEjyJa5Q2UQRQW07bdEq6iiK
06Iom3WsjnMqIq1L3UDbKnTUVoOKPVW29rgBR4GxskhEds6ZGcXqSG3n+fm8
HuccvnNv7v8u733X530v5TNnT72ud5Ikp52QJPqXdDUkyacnJsmU8iQ5UpQk
x4uT5J1o+Xuwvm1Qf1J2kmS0sCYvScar/2VWkvyoIkku0pz9nf4+Oeb8RfNX
Dk6SaxN//7nWzNd4bl/P2dEnSfbWJ0mP/h6lPX6s3yyN924yHdBTUaM9sr2W
eX/I+IxOff92V5LcqvEJqSTp0N+Zk7VmjPYVTSv1+32vJDlHNHQMTZKn9XeB
1uVne5w2L/rr25JkhvY5Ved/rjOuUL9D87/IT5KjovtgbpJcpfZNMWqCflUn
JcnFmjNI9JXr3CqdW9iSJBu1Ty+te25EkuzWvb6rvXbV+0f/hbT2LDZP4Sc0
rgo6t2tsm34Tdc4S7ZWnM/eKDwsKk+Qz0fFbzftU9/jrUPN8c7H/pp/RuZ+o
/6b2n1Pk/nLx/Cyt2yL+P6v+MY19/P/WbtHv71meX53nb+069xHR2ab2DN3r
Qa0dqv4o/brVr1c7ocJ8u7xSdxiUJDO1x+viycniycR+7qM33DMlWU/Pc5/7
DpG8ntL8cyWvC7VPvfb5H+1zs74fDh3L1Rn366zBLV7LOHxGdnk5lhvyQCd/
3ds8Yx942am/d+j8FeLnBH0fX+Tz2Af5Qs/bo33vY23mH/2RvcyH1mLzYsco
y3mzaNup/hJ9HyWazxZ/z9Waf5WOvSMZV2ntgVbxWnweq7X3aN4b2Zb1XTpr
mfoT1L87sc4P7Gu7QJeYjz6N1R6bhiTJALWD8k0Dsnsz23tt0G/1AH2LtdhN
bvQrxf8houcx9e8cqHna51XZ1DrR9JD6S9ut++cEbYc0/pLGD6p9Tb8H1V+r
dq7kcmqBeNORJHt032Hab3bK8mQ+91xS5H2wo75dpvlYie8xLu7yvX62H+5c
Ncz2PyrX8sFO0fUtlZ77WJnXsR7+TZW8b9Ad7m+UH6lNklLZ1EvS/2tzvQ8+
BHk+qbm/0T6Timwz2MuTYdf4llVh59jU3DzrDH+jJ8xv7Gs6r8wzrdfp98/6
LdPal8SDIn2rk76V9XU7VuM31tsv4Z9K1b9J8kipXdbP/fbgD7yBtg9H2H8M
H+27b4tzs7vsW/qLtwu0/l2tXZ22Lh8N/c8MNd3QzN1Yi27fPMbf5qltb7Mf
eFtru8SnLM1frP2bxK9u0btW+9/Sab0ur5asUx7n+zGtP62/aKm2TtE/rm/T
tGeN+g+Uih/i+U0F5vkHae89Q98/z7cvKtX8JdKTyZpfXW0ZXV5gWWfJP/9S
68qqZHuioVB3WKW2W7q6Xr+dOebxor4+d3zKfBsq3gzutL/LV3tbie1mv/Ro
Gvqr/X+t+3Tq26ei4QHp6grx7/3w9Qs7veePpfNHxJt92ufgUN+vNM5ijyWx
D+tO1NitOmN5fPuNxl8Uj54X77vVZuk+Z/W3/2lN25fgwwr17SrtWaB2su7/
H9rjBNE7Rfp73kDzbYZono6vF60zRdvtGhui9uwC8wF+cI+LNOeY2lEZ0/GM
+LFftH+k3yyd8bju+Q99v7HLfveM/tbtodXuPyt5zdG3v2vOY5o7psB7o88l
fSyjIbK3t4il6h/T+K6R7u9U+/NSjz0qm1uq/sfqP6T+L2L8aK3tAJnBw2Ua
/0TtQY0f1Xmf6ay1TdYDzhqptqXAd4D+RcW25cFa/55k87Hmv6L5L5earil1
jiGfac7PdK+CavO8EL3V2rXF5m+x4ss23X+P1rwmWVypvb/TYDlsH+C/8Yd8
R46sQw9Yu1p8WK/vh9Xvjn6P7lRXYUwBBtmYth8YJtoOyEaWa+1BtXvwt3mO
i59ozsNqR1QZr7C2l+7UINs4pPmv6vtetR8NNf8vabNtXqx2RbNj00r5vZlt
3vMHaqeJhxWi+yb5ij+n7Y9GN1kvpoVuEAOJYfiH27u8/ytp2xZ6u1v7LgyM
Ae7g3gfj7rTQ9rjuvU/3eVz9o2Pso/F/+C584RXhD1fUW29uUPzv3W7clbQ7
LhGfiI8bZMOnqz0oetYXGxcSj/An66O/KProzLqQI/qwuN7yKmqyjq+LcX7I
Gzkyd13IryBsba3u+2mbcWf/CuMV+uAZ8MX0iO/E9M2BbYaGP8Gv3K47j9O3
29T+u87vk219I3ZeluU+eJa17Am+mx4Y75jOfpR4IF0t1O9M6WqR2o1xd+56
gfg1XuOHWz22MbByn7TPOyz7btDZxxU3G9UuLXJsJi4Tz8HC4JeuHPv0F7S2
scE8PqvcOnAg1/TUaXwh2DLtecy/IDEOJs4eFp/qUsYt4Je57bbfm+WjcjV+
rcZTzfaLYGZi3PQ298HR+EXiLL6R9lf53mtgi+0mozn7teeZGt+n9mXJ6E2N
z1b/+oEef0Zrp1Ta7xSXGzsQI7kv8Z4+sfLdAseXvSfaLrFVzthaYHlhr2sy
5s+DiqsnNNiX3Ki77Kt1f2Kl93oy6ARXrMg3zuAczuPcH7Wbb/APv4P/uV5r
57cb79WWGes8Jvx5zgn2t2A44tDK6IMxnpK9rsszNhsue3xZZ5R1Odf5a579
f6P23KjvD0tX+1XYbv5NPG7Q+Br1l2lsTrltDZsj/hEHx0imDeAw8bFcPuHG
TtvJv3Qa4zwZecvJiovbxKMFg33X5XH3kvC1r4uHB/Ps55EBvmdiYONlsc/8
wKgrA6ei1+BHdO517f+cdPGkBvuAlTG/coCxEXLCl3MG+y/MON+YW27+wcfT
e9knzc42Hm5sc3+e7t6dbV1/If5mfL74MED8WaE9F2pslHiyRbydIb2bSm6l
8Zv1fbHGTxJ9i9RuLvKcu3t7DL7AE1r+flpnjOhvfhDbllY4vn8o3Tmu88bq
+xdqx3dYz89Ve3a5eYD9kc/MDP9wqs7bprPquxxn6RNr68d4TpZkl5tr+lPi
z5F6475faHx7gXUa2sD2nPtG4NZZwVtw4DuR14Ab6OPTkPPJcZfuwCfcY4tk
MS7H++1vtf/BD5Ff3Bu2hp9GrtznI8X7TWqzGpxfnp3v3LC2zj4B3zC50rZc
pH3+c6T51lvz63O9JxiPcypCvuQtxEgw3/xiyxP6yOG6w5bLxNO54Ea1Wwe6
z1r8H36wPni2JvhWqLPf0Lorxee30s5dx7R5X/bH193Zaho2yyes0p6ztOfw
XtY76GP/IS3Ws/vINXWHBZLFTu13UL6vj+g70Ow7LQ1eodeM14Uvgw/vjbTf
xcZ/IFmfhF6KzntFT3fa+k3srcsYW56SsV1gE+AkMMXewAMTRXOz/P+EVuMd
+nf0sR8hF+Dug/s6RpMrfl/77MoyVj0iHXtC44fVLk573hkNzg0ZJ/buj/hO
nL8rbf/+ifqXjnD8n17t2gi4Gcx8dr393PAyxxfycO56fdrxk1wZn7R8gP0r
OcR1kSuVNbn/58BN3xpiG/xuq/vfHuGckrszjiyR6Q/VtgwyHeDY59PW41vq
ne9wV+IO9+duYIk7xhi7/UTtHyXrzUOcN1Mfgg/ETfwR8iOWFRZYjvwNfgJH
gfnBSvTBS+Qx4HNyGc7KjX2Oxzh4/W/5xvFfj82I+fjbcZG3Uuuh5jOyzryG
53fqTv81ypiRmgr2QR8bYe7D0d8a9lVQbn7Bt+Y2151ujpoJuINcPifLutoY
OTW4qjTuC34BY+Cjro45+ABqFcRQYiu2SB8+Lii2rSIP8C7yK23ymZyNDoAL
v8pheznPbY8+vN8U/IcmWnwHefas8GfUjfDt3RFXWEsMJW5uiFhwQ8S+U6pt
98RK9H9j1Dzooxf4NsaIt9gI37CZrdnGbuB98gJyJ+5O3QH+4BfH5nyz/s3Y
l7t3hx+5uMX1sQtbXA8D+42PeW8EnU/LD5SKJ0+1uw7B/sT5awYaD1OrebrC
NOzVtz4l9qmX6l5Dc70WLPR8yn79QvmHe9st10my3/cLHC/xV9Tt5vb1nr/s
cL79kNo/jnLsmlRpuS0IP0texd/4ReLnVVF3wuaQ6d2BvcEPYOkX+zh+YyvM
vTLmU4/8Iuq9YO/XApNzzsLgF2ctCp0Bb4LZ8MPEZOoG+NY9+fYt2DZYcmHo
5y1d5us/VRhTUC9l/j3iQ7Zo+Wmj6Gry3d/rsP7ha8G6+INdkasvjLtDQ16d
aaA+MajFZ4HvwN7rA5PPi/y9v3TkYMZ20lfz+0cs2KH+mrT9FDWwJwPjga++
ROaF9gGTM64NnZex/7gofAjYgBoZPpSYSmz9QDZ9etTSqanznZjEHOo31HVW
hQ/Gv3M/4gm4GR9NTCY2Uwu7ZYRlNrvGOdOskFm6xjiuNeV6Cn55WWB2amT4
z9ObXcc5q9n+nfNLxKcZBa5rwF/qy5y1qt21BPwyPrk85hMfiKvYP7Z/Z4fl
8MOUayHjA8OT0xDPwED3BbarbHctj3v06Jxn1Z6rs54ZaPmTQ4JJwA9jc+1D
sAfsgnzrBvF6t2idk7GOTNCcKzWnX8b7lDU7ZuAjRre77kIeDV+u6LKuXt5l
/hJXiHfQDf1TtO79kcaFr8q2yqt8vyMl1lF0dVunazH4lc2a39BgmrcP81nw
9uua5ITg+SHRdpd4lVPluix9fNSGZtesN6pd3eha7WadtbnJcnhRcXZqnWVL
bQPstKnAPntUmetr39ddstPWYXR5dpF9EL7it2XWx4xo3p227n9VD0sbFxxS
XOopdN0A34DdkHdhv0savc89au9otK1sIrZXWMbUvQ5o/DnN2d9ofAxOvqvD
MkWe1BmniaY12vP8jGuZR+Ld5JEO29KjHZ77XMwHt4Hf9rXal1PfwZcPr3J8
pNayWDT/pNBvH0Wd7ncENnk29uEe4GLuQn9b/L09+sS+UwKb1av9fcY2hW29
nHI9rqfD/qMn6r3Ee+6CvwYLEmsZB79vjz2hlXoT8l3XZN07on2qBnmcGtS2
mA/mnxe2zPnkSORKCzKOE8SLS1o8b2vBN7F6a5zFPu9Gf6f0Zqe+v5JxjQqM
BH7ZGDq2u8PfyffAM/jCQVH/vCBjXEM9cnC8RzCHWumhqBmB9cEkYBOwOjJ6
NeIGuOorjFVg/UP30B36OyPPIv9kPXVk4sKRWucSYOkdI227e0Jv5kdtEH9O
PQZ/CoYBz6MDYCVqUuAQMATncDZnlZTb35LTUF8Ab/eM9PvIpHhbxH9TO8WH
d3W6RjozbVvCps5oNn4ZEBiGmjj14vM194lm8xF+d0fdGh/LnUac7LMP17p/
qNbn7YwaTrvOuE1nF3a6bgsNl6Vdq8XP/qne2GlvjjEQtVRyhfMU33tqrctz
SvzGyV1mSW57Gs0H3haOZgKDStZ/CT+GP5sWeOY7LcZCYEDqGvSvKTJuARte
HXkcY1fHnE9LjK2/aLR9E0tOjPovdeDzK10DnBNy/7LVOJC3oIva7NN5C/3f
Ya47Uhd/XfTVSF73p4xtWEvdjrcCcj5oADcyB+y4PN52qGOA8bAt9AFfjE/+
XoXjALpDLECu/4j3iP+udK5Nzo3/AceCn69L+T2Ldy3k/3nMP7/euOKStLE9
+QC20Z5yrlCbsd9hnPU98W4EnuVcfAS5OViAOj7+lzdS6CNeEdPQK3D+I6HL
9IkNxIWBansaret/Ev/2NdqnrZWvTrUYEw5TO67cGPEa0dMvZRpW1/tdBEw9
qSbeaiIefRZ3hOaxkQeQ257Z7PpPXZlzFej5nXRpdcrxvVT0XN3oN4xrGp1z
oJ/o6bgG3+mewK05YS+8E4BL75Velzb7ziXNxshXh75RrwEjXqg77pIcJ2t8
doVzqb+FLPZFLr9F9GxoNJ3LtU/PQJ+LrBdKPy/gbaXRb38TI+YSh4nHrCFe
kO8hP2IqsbW0y/I5FjyhjtUTb5TsAz3oDbr/dU7zZfgM5AsN4EjiIu+Hk2I+
2IRaH3ckVhwP/enV4PizsMt1F2I9/rOgxe0i3bEt3p5v7XTdn9hBDOENCduZ
Wu2YSIzBBnbr22DR8IHaLfXONcg58JHoD9hladR8sCveZNgTvvyuxv9f4bka
6x34gT3faXPNnzdJMDJzwNtp0fMhfl/tvNGOZ7eo/YNordX+r3Q616SPz+YN
mfwWXS8JHeibsV6in0ekC1s7/Cb0RMr2ht01dRrTMg6uPXWM/z9Bbcq4+JFC
zzut0/3mzngHzv3mTXlVvP2N1reHNKeR97UK07Wm07kEOUVFk/UeHUG/8IH3
hn8E87J2R9QT8N9gyLdLjY35vxjH4v9foD9Pa98iravQOSs7bffgL3QtK+rz
yIo6IPVlatrEc/Ju7Ik3Mnw+bzfsA07YFBiBefO6nIve2uX9wOvo3qE21/b5
Py/EFnQdPb+w2nkDNR7qxcTW4c3GFmCMA+1+K8UGHuxwjRt/z/9xQO5Zodtz
I67j22+odP59Y7l5hh7Bk9o2Y0jeoE5stq7Vl1lmyO7y0dZZMDP3Ak+Ra4Kd
wD6rgw/kBOTG5MXEVc4lh/mwyeNvlbrm9FS8p/N9XMy5NGIcsY56TmHwcE9T
vDlofECTaw05and1GMeRf4MBWQN94ADiAW+n19WYLupMyHpxYE7O5Gx4Q44I
hgY/n1tjn5SjPS9rdOy+r9T+aWvUJ776v1P5Phsfhh+Bz2uaXB/kLRT/MSXe
i3kTBkvBD/SX/08DHiLGE+u/1eH/M8GbxpGM/6/H1vAtyIR6NPjkgRHGIryZ
8PYPRq6sMi7HT01Ve3nKufpPO2zrPRFPiR28l+HHiLF7Yhx9op+ttY/V+k2B
N2RyPu5KjP6ow/za22FfDm3UNCoir9+c9l0/C7+U12ket2n8/wArlLR5
                "]], PolygonBox[CompressedData["
1:eJwtmHlw1dUVx2+QsEMgC0kkeSF5SQiGPLKZ9SUgVESWIqCirY5VqNiirFoQ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                "]]}]}, 
            {RGBColor[
             0.9760451759999998, 0.9816551119999999, 0.9254334480000002], 
             EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmnt4ldWVxj9RUIGEBBJyJ+RGTkwIOZyQnJOTE+wMlwFBEanVXnwEAq11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                "]], PolygonBox[CompressedData["
1:eJw1mHlw1dUVxy8ghCUJJCQQyEaWlwQSICEx5CV5UauIbIKY0oLLCAStOtaC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                "]], 
               PolygonBox[{{13284, 13283, 15019, 5663, 15018}, {10318, 10317, 
                7171, 3836, 12436}, {12381, 3812, 7161, 10317, 10318}, {8610, 
                4841, 13968, 13283, 13284}}]}]}, 
            {RGBColor[0.994926288, 0.991556168, 0.6891359440000018], EdgeForm[
             None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXt4VdWZxhcgd5IIJBACJOScXA4mYMiFnJMLg8WqgEJVLJSLys1WQLGK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                "]], PolygonBox[CompressedData["
1:eJwtmHmcz3Uexz/EDHNgZJhhzGnMaH6YyzQniZSR7qJIjmFdURKF0rWPpQ01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                "]], 
               PolygonBox[{{13761, 4714, 13763, 12641, 12642}, {12642, 12641, 
                13227, 4330, 7791}, {7888, 7887, 11348, 3179, 11347}, {13970, 
                4842, 13972, 7887, 7888}}]}]}, 
            {RGBColor[0.97701004, 0.934111608, 0.365188776], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXd01tUZxy/KDAKBxLCSQPISeGPCyJv1hryhrLYGqGKjgNUqIEPrAAQX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                "]], PolygonBox[CompressedData["
1:eJwtmHlU1lUaxy9plmRKYLghCIiCMAQv2wuCuU2FOmabWllumC0alFuWlluT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                "]], PolygonBox[CompressedData["
1:eJwtkD9LQmEUxh8ERUgSs607eAdRMLDF0fAztOZFae3q9asoCFE2Jejk1icQ
pMG0KfMD6GpDQ1P5O7x3eDjve855/ryvfxfddBOSzkDSqi+dZ6RtRVqVpDV4
vJT69F6YTcrSFIw5D+g9MWtyD8ChIP2eSCO49aJ0XXS7xnm4kv5P0aJumOfh
flIjT+p5btc4i5oUEua74DRNewRHWbyobxfSDJ005x3Z9qDNTgvckiVCN6B2
0ArBPTmb9Or03qvSEvygHeGxxKtBP2Ae+m7feGt2hnis4n3jPccZUp7zMk/7
G/ujr/g9Od+9xd40J+cEjb+qy2hZP2LdV2ZHGPg/eA==
                "]]}]}, 
            {RGBColor[
             0.9187130800000002, 0.7154314800000008, 0.2534528400000002], 
             EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1mXl8ldWZxw/IvoYQiEISSS4pNyaGcEOSm+VCixZBFJUCAgoIotB2QEbQ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                "]], PolygonBox[CompressedData["
1:eJwtmHl01cUVxwdJAgoRSBDQhMQQUhITQ0jI9pIQxcq+KLIr+2pbQEErKAKy
r8q+LwJhswgCihWsekRUQI/UpVqstaAgq1pBtAuefr79vj9+5915M3PX771z
Z9IGj+k2+roQwoPVQojhd0lmCAf5LY4NYSn04fwQRtcNIbZhCNvLQvgsL4SG
dUJ4/IYQ1jL/FvOjmB9fP4SR6SHMSwnhWxi+BbP3mrE3I4Sm14dw6sYQ+rJ3
OesjrD+AvGXQrRqHcBvjEB/CjNtDmJITwisMM9nzFPRDLUK4D3n/uSmEaZEQ
dhaEcIH1JxnvTQqhN/vfb4AsvnHoN7k4hP6JIQzkm9AkhOdahlDK+lrVQ9gB
HVsRwthGISyOC6E69NLkELIkq3YI05H3aIZlT2E8jfG15ralDv/90tx7tHcc
PGpAr0+zr8bjj2WsXwG/XNZewV8zykMYXBJCAfKrsWYQ9DBs+BLdz/DfRmzZ
is4xDe1D+VI2ytbh+LOK9cuSHY9C9j+ObgvzbY98uBh6Dz74B+u/YbwJfs+w
p6KmffJomWOm2I1h/h3WZ6HvccZ3YV8y+o5F3ofYl43+46BHEb+zrG2Nz/vg
+xeSrG8s8yuI53l0GIF99dGvHbJO54aQSGznIXNW0xBmE8P062zTNmQvZ839
rL1eNoOPffA7BX0RGbvRd3jE+kvmVsbjMxyPqeg3A/2GsP8UsWvJ/FDZBoaO
Ia8fPmmSFcL8fM/tAU+twcKIiLEhjOyC3+YC+0YyJGsd49OMByeE8NWtITwN
v59vNOaeBM93NjYvxex++Y/156J4E+8Gyca/4r2c9Wfx0Sj028t/56BrFoXw
Rqx9PJz4f9vMvv2lFnKQ9yRrHmBtP75J0CsyzUs8lVuVjHveYPytIFYnkF+n
Xgh1+T6H/g57B+HrpeTL99B7wWCTm4lRDfBY5k/0QOJfE7ot+TAFfeLA6xb0
ifBtQLf22FQK/QQy0pnvisy++HsTPNsx9xoY3wj9LD4fTPyG8nUjftvZUwte
PRmXk1+bsW9vjGM6MuKaoNqwH/1PwLuKrzzWObEW/jvg2QX+X+Hjvvi6qty6
xfJthv4UfPwArw744wl8XYk/DxGrSvK5G/K2wn8S/G9m/gT+mgPelscac8Le
aHzarY5rxhjo6XzLa3jNNOjVOd6fScxWQd+F/3Yi+zL2voSt57BhHHsb4r/z
0A+BsStgoxSfPww9NdNYKRA/6DPJ9nUS8d3GfBo15vpYY6JjKvWHGNTE349g
83vYPpbxsQaOQXG5c0y5JoyNJvcalSIfOgN7GkI3Srat0nkL8laRH83g3R0Z
q6Gn4ZOG6H8rGP6YXLySTT2t7fy+G9/vwp9/x5818f9weJWi4xf4/hoxi2T5
P80pH/YXhlCGT4/CayvjbOi54CdS0zJeRN/D1MA/xJjn0IhrsHJD+m8Dn3P4
Lwb7qvPNhl4Pj4po/DdAV+Ube1+iQy/ifzbFsZA9Vdh3Kdm59C74qof9I9jT
NNYxWY2vFubZ96oRi6D3saYN8tvxpVB/thS4lijfVRt7RP2r/zTXhz0nb3RO
TcSehFJjqw0YqQLfkaj9qjHl0MP47zuwUcb+feAjM83+rca3C19vKHAtV41U
rXy4FXXtFmo5ezql+wzSWRRhfQJ465VlWcJHh1TnuHJdZ85jxPMwGD5aw5h7
C3o8+wck+kzT2fYAa76I8XgS48voX1bTMeqD/Qfxb1W8dT4Avb/UvvkIny2E
1wrwnhVvGbew/mSxa6lknIJeTD7vhP9I4v86eMjCB3tjLbOZfMN/S/HNWfD5
LnTrPGOpC/Gag3++TDLdlW8u4wfxwY/o8jz4+TWyJ6LTJJ2f6HQS3baVu5bI
Z/Ldz6y/EO+eQb3Da4XWZTjfQehy5luxvoLvCfgfSnG9PM38LGpFBfOVzE3R
GQP/lc18dik+Ons/aG7922LzS+g6B5sPxbpmP9XEOkt31SDVorXwvJRgDO8C
n8uKXM8u8t8qyWNPQaJromrjfGI8i3g+gMwjKT6zdXbrvwU57ikUb+ks3dVz
PBVd3y7TZ57Ovj6M32Z+ZZrnhfcJ8Hqo3Ll5GZ93Zu4U3+u1XR9UG8+kuD48
o/MDXneiX2Gia6Jq48Y0z6lGr2F992LjXzW2FfaszXA+iudV9r+KP34iXpPx
yWvQ8yKmVVPnRtyzqXfLIQcqyedniuwr+WwN9JUMnyWqOfcxv7LIvhuO/A/R
9Q14TqlvGZK1AH1+l+iYzIO+A/1nxdqGTsXGvLAvzI6nVhwudC+hM+h7ztcj
xPtQjHvQufDvwP6SRJ+5OnvbM14U6/+6wKuisbH4CN+pUn+iR+Pvcua+yDb+
1QMm4rul7K/A3lqcuSvB80dJ1kU1Q7XzLOOPoVPZPx39prI+O942zUfeamzs
X988xEtnhs4OnUGtK9wjqVcSptqzvk6e+7MZ+Owqtv5YaFr153l0u5rk3lr5
Mh95xfg3obprXAn0vwu9VjzS0X8J8vsgfwHy0pD3YqmxpBr6EvR85rsxvx0Z
XVg/Ote16jjxGgPdUT0AuvdizSLW9sjynGyW7VvBRGNqfy4+uxv8rIn4LN3E
uAfjxex5O846LC1xTVJtEs/O8H8u02eBMHiO+G1nvmu8e5w96Ptptntxxbhe
mnWQLp3UP1JbjhW6NinH34NeifzEBvbHQfx5njX/wh+3gd9zOotK3MuqJqk2
PZvvOeG1O/EvZv5aojFTBL0qxf3cTPzzE/xT8Udyfd9hJrP3KOf/pXo+w48y
7saepPrumdU77y722X6RNS9AL2O+PN4+6Qyv36a7VtagP9hR5hxRrnyCvH7E
8zI88qn1Zej4A/TzzVzLRjH/Dvr8cKtp2X+MWrc62o+pv1Tveja6/hqY24Iv
32ecpNrB+jeJ3wep1k13Pt39XkG/e+Jdw3+Dbi8jY0iC92ivemj1DuohitBn
HuvnNjKGFkDfkWNsCpOV0FXZli0dpPu+QvcT4vlH6FXsmd/IObJGtQEdpsfZ
h/cxbsm3pJpjUljinkXy1dOvLTCmhe0BrF/L/H+b2zbhRbVBPYV6C9U81b50
dOpY2z1vT+L9K/aPrG8ZGdC78MfRer5z6e41M8/YFsa3ga1VFa4FfyYegXh9
gg61WD8Sfy9o4RgqluoB1QtWZvs8+hoMtIKegA431XaNeRSsb2TNt3E+wzdB
70nx3VU95S3EcncL9xJav6uFc0q5pR5+Qpp7LvVeV/HBReJ1hZiuCs4B5cLF
DNc23dnacv6/Hb3fH8CHA9k/MsW6qQdY3sw2ybbe7L8O+vNk0734qjFOSLNv
hYcT2HMx33fBvnwXhJ9CY0Mx/hqs7IR/LPbcgz++KzMP8TqEz9aTO1NzfPap
x9ZbgHwoX8qGmcg+nupeWjmmXDuS7/mm6kegx6U4/3Ue6G7yDvG4F1nVWH8E
eliGa7Niqtg2z/HdJwH/DcGW07oj13CNOAM9Mc39p3KwH2sHRP2t/55kbnGa
8aDzfDr5OZZ6+PUN7vHV6+vOprubepr1uX7z0NvHQeYHM9872o8exP+D0nwH
0l3oVTDQBmzMLPdbgnoO9R7vFtiWPazPYtw+072DeoT/9wr5PouVM8qdx6Lv
GbrjLkBWea7vjqpZql2DyqyLeqqJ5Et7/nszzm8IeksYke67kWrAftV7cqRN
XeeMcmdhiXtd7enA2qF59qfwODjPMVasPyPmddF1RK6xIR8vZP02dOxc128E
XRlPrTB2lQNDGT9S5rcd1RTVlnUlzm3VCNWKtqx5I846peo9J9+9uvJ1ke7K
GX57EeYGQhcU2dcLyP/d5NuGlsaeMCKsqKdUb6keUr1kXoGx8aZ6QPb2L3It
Vvx1Nykv8pxszsa+vcTs6URjUtjUHUx3MfXch273m4vGukPoLqE3MvUWqgF/
y/aZXi06fxm6R7Hlqz/rCb0d/SbGuUbtgJ5d5N5XGFRtWlfku5Z6sC3w757u
t6RhfJtL3IPpbBvCeGOJ77S626aBj78QmzXR/l814EFyaVv0fq+c+j3jrSXm
JR22QP+p0L259pwhv7dm+61DZ6TOyo5Zzs1XWJOPbvemW7beFPS2cJY9/6zl
mqhevTjDsvXfEnj9XOizVv2LeqFPcq2rcqx/qu+8uvuqx1KvtanEbxXqGdU7
DkizbNU41brzOX6bUI/8TYp7HPU66t9091uY6X5db25PQ69J91mrN5eRyLpa
5rc01fifypyDykW9KcaAv3V5rhXK1zXQd6c7l3VHm41uHXN99xVmO0F/GPHd
WXfU4xH3MOpl1BP8Fbz0aey3EuXIY8hbUeJc0hvKSp21Oc5/6bwaW9oV++1E
bz56+7k30++Tsuce6OV5fm/Sf8ugDxS6dqs+nyYWk1v4bUp3eN3l74i+vwiD
ygWdETor1LO/jvzHo+9Hqom90eXlEr8F683uErG8VOq7mHqWC6XOOeWecmQP
+sVV+C1VPZ56vfXR/k/x0V3mf9vreiA=
                "]], 
               PolygonBox[{{8440, 3070, 11175, 10217, 10218}, {12507, 3865, 
                7192, 10412, 10413}, {12628, 12627, 7786, 4326, 13216}, {
                12379, 3810, 7158, 11331, 11332}, {11332, 11331, 7169, 5661, 
                15014}, {10218, 10217, 11173, 3069, 8439}, {13755, 4710, 
                13756, 12638, 12639}, {10413, 10412, 13978, 4845, 13980}, {
                12637, 12636, 7792, 4331, 13229}, {12639, 12638, 13214, 4325, 
                7783}, {13220, 4327, 7787, 12627, 12628}, {13232, 4332, 7793, 
                12636, 12637}}]}]}, 
            {RGBColor[
             0.8577476239999999, 0.4448791199999993, 0.2029324959999999], 
             EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNWgl4lNUVfSFA0qhJSAIJWWaSDOkEE4ZkEjIzmQlYiwJa2kqNllhAtEhw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                "]], PolygonBox[CompressedData["
1:eJwtmHmcz3Uexz/jDg07jhmMYQzNaGbHmDHHz4wjESptKUTpXFe1jtRWjqw0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                "]], PolygonBox[CompressedData["
1:eJwtkc0rhGEUxQ+ZLDBEbJS8WYwiM5JXpnz8ARRqEkv2o3ys7JCZYcp3BjVZ
2SNZkDWSr5U9IZE1Ir/bM4vTed57zz33vM/jjYwNxPMl1YAAGGqU4sXSMHxC
8RT0R6Q+EGuTuiukQXiR/jy6bY9zvZQGybA0HZQW4K0QPVDP3Bm1EFyAJgA+
qL+DB3QZesfV0iV4q5Qmoq5nmhS7k+C6QSpl1w28zt405w34kd6TafBOgFWy
PJZLs74U5LsEjEed72TU5bFcXfhcFUmHtdId9eYq6RZOtOIFInjH2DGKX5i8
kVxuy99GrZ1eGZo/5n/BNzMJ9n7BnWg6wAIZnqml4Bnf5ZrzXc80U+SeBD1k
uSdLLxygn0ZX6Dtf87f7t3cI5zI1wT+5fXWe+0f71wtqcWrnrc7X/O1N7G12
0CWZXWI20yJtglizhFQbnOfZ98Tsmufu0e7T7tXu95WZI2Zf4BUyfpJ1ucG9
i73PAf77IMtMXqm0C2fRrjGz57meaf4BDa1nYA==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1Wnd8lFUWfQktJJDEFBLSJm3MhCSTMZlkMgyJgrqCbQUWRRF7WYqNxd+K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                "]], PolygonBox[CompressedData["
1:eJw1mHd01tUZxy8JQkiAhBGGeeHNAJKQEGJ2SFIZtYKKZRSlUurADSJQPC1a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                "]], PolygonBox[CompressedData["
1:eJwtkksrxGEUxp9GsiCkLFySWWiUqRmmmU+gyEIuC5pZmSKXjI0voEFSxkKh
FGYGYcpKUaIsXRYWWCnKZTuElY3f6Z3F03n/532f55zznL83PtWX8EhqAMWg
r1XqBamQ9FIptXNx2yKVl0k3xMl6KQF2I9JXlbRDTDZJs2AxDJ/cEjGKRgxk
g5KnQiqBM9QsxcGhV/rkXQbuKlgDCT/a4Jx61UXSBOc09f5Kpe9GOD4p53N8
0xnlfpqexok1aNdS44la+5wPQCfcO7gdxCi8GJjxOs4YnDY0QuAZTh3cWjgn
fJ+CQfoeAOt48IoHHfR0D/cI7hPcOd7Mg31yeebYov9hdEbAHLP3kFsIOw3T
Mr/Mt8s6fCtnpoDzy3zbjDiNbeI2mlvgkxpn1MoT38Ex5w+/u7M3Np/N+Uvu
grsfv/PGPLpCe4Ua1wHXj/WVKewgHXTz2ZzpiNtBtuC/7WGvsNMcc83Qfzfn
ZNj9D/ZfmIfmZYpcP3fLYeeD+fGIdjU1HoJu77b/Dfx7w78u/PsHug9qZA==

                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFWWl0lEUWLSACZiEdYoCETppOCOmQTpOkvyTdHRoRBFRAHHBBEh0GERWR
XYHxsCTgwr4IEZwR2UcEHFEcPSOjCOp4DItAGFFZVVAGRJawyZK5l1vnzI9Q
RXXVq1dvve993kEj+g5vaIz5GP80wtgrZMy8JsZMixizymNMcpwxK3KNCaYZ
83ZTY9bit2gzY4rj9f922PdcrDELfMY8kG/MYsyvYB4fNmYl6L3sNmbbbcZ8
ir8ozi70GjMRZ78qwejXfGaBMbe1MKZVijHvNtHerfgbA57ScG81/tKwvjvP
mPW4c15bY+4rNSaSbEzvTGO64m/GLcZMxf1twW+/W41pHGNMKnj4GnTWZhnz
Is7WY/3FHNyBe867jNkAWnuLjTmAM4/j90rQ2Iu1pbh3qUtnh0MoQ/D+A3hX
QZEx/THfg/nDGFeVGfMk9n2C9YX4fwPQWYQxAecysF6Lswmd9P9gujEhyNZg
Hgt+Wrk034U9X+CvDm/5DONS8LYzAfeCj2/SNL4EfmIxX54mWp+3Ec/k/QHs
bY75NfAeD7pDGxsTxj0uvP0ZnB0cNWZ/mmgNSMVvrSTPUoxHQec0zs7N07vj
KHOcfxfrNViPYn0O6CdifSzWu4U0vxPjcugjFr8FGhhzR0hnO2N8Gjp9Fjod
jnFBvvY8lCn+yTtlUgK6X4J+KcZcyCEN6z6MrcH/FNxzD+g0g401AE+/QY+V
kOk5yLwK4xrsO2z1QnmQLnkrSTImqyXsEvu/zdb4M+x3dLL28N6hsLMToOsB
/U/w/pSWsqsjmFeAzwGYh3BPD/A/Ge96GnpNxX3DMDrgN4D93UD3NeiyCjr5
2tGdnWJ1H/fw9xD+6nHuBv5iGmnk/2kTX8LuR2L/ZPjIxCK9fxLG9/D/HTCJ
Or984L8JkvE32D8V+09m6Pw1a1ftcfc4jA96pNP6VL3lut3De5vHy87pM2ku
+UsmnR22Ugx5PYA9K3HfE6C/F/SdNPl5cQv53Wb8DXVJTputD/4rqBjggd+v
hg9WguYb0G/7FPFM3l/EW/rgjlr4+iTYwAXKE+NXkPvL0N1o6Lk8VXPGiBmw
0RLc+R1oxjviLQ7jMtCpwe/HwGN2J/HxIXzufdjnq9QDeLkXNCuh/3TQ3Ij1
hVifHZRNUPdLocelWYpBcfCJsclapwyrME5Jlg82BH+fg88YjD97NW+UL9rc
81YDjZV2vg6/j4HcvgR/B8Ky1c6ISxngtRt+82D8uAN4gb1t6aDYMBjx5x+4
y+uSn5G3r/BbPOisy5GvjbXr34OHfpDhCchgLvZMAp35GHfC50c2h60Uy8/p
73E2nnBejbPrW+veT7D/+wDkDJ0Pw/h7R/kv/bg/ZF0NWc2ArP6aIl0Mayr7
ox2uddu4a2NFOfg7A/7vgs8+FJGce2Dt3gytV+TIb+m/aeBnIM682UJ2dyag
nHEW48MR6e4V3HsPzpzE2V45sp1Ya/OMBaRDOTM2POLS2iOpimWMY4Mhl06Q
z1qv8tAGm5t+gGwGQv5+/DYPccAB/bnZin88y5j4Ouy1B+76MV/xtX8Txdhb
wVN38HbVo3jAdcqOfhOXIt+5I0M89wTPByGrYswXgP5J2Owwl/IBfW5Tinj6
iyN9PwsfP2h1egq8Z0a0xxtRLv3U7udZ5if67GbYxQeNFIsWJMgWKZPb2yo+
boE892Vrz0yPaLxr6fhCyintMC7CnhLwuRDjvlLxvAr6/RA8u1zKP7V5ihf7
MO7BXxLme/NEg79Pb6CcPKip8vJb+M1gzxHY2JO3yvboRzXYvz1ZeeFaqebH
IW8P4xje4APPjYtFZ1Rb5dUdyYplHGvsfENIOXwj5FYNO6pKkI+NwPs24UxD
zMMJGivAyq5S+WI7vKsLYsRI7DsMv+zulz1MwDwIubeD/Cu9yheM2YyBN/3a
8s9cwfhAPxxqY+MgnJtcIpuajbP5+AuA5nXIoDZfsXYd7OIpvG0reBqKcUJb
2Rrz8MJWwiW1oFnlFQ/DCxSn16QoFvFd5JlyToJuR6XobdVWd6vdevcIu4e/
j7B7+E6evaOtfJU+64WOXBHRr8J6A/A/A75hMJ7tKP+sw1iN8SDkW+6S7CjD
63jTDdB8BWdH4+wp6Ot5nD2JcUGK1onl9sfq/5w3tPSzvfItvrUefP7mVwxn
LCdd0j/sF964GQPBZwzueAs0pkclk3qbv9an6/cSyLNDuuzMRIU3N8Qrx3TH
Gy5Al3sd6ZB7qMfj8AcH+j0H+znhUU7uUaD8nNhc//8N61GM14rEC+MvY28/
5Jp8yDARMhiKv5Z442rIsiwk+uRlZCfF81+gn6vwgWaYD4f8LmG+Cvq70kH2
Spsnhnk4ETJNUe59KV/+Qry2pbX2X8b+2Dj5GnHgPq/eN9snLE5MPrZQuZDy
XMP4nCuse9gtv+JdVzMlL8ptXbpiZr6Ne4yTzO+UNXM9cy7ng/AGN+g8lq01
x2KAcW751h7wuAmyWoz8W9BRNBxLh2/m27fniUfGbdNQ57mPMZk0+X/SWo93
3Y53bca7WraTnY4Gn+dA92nofWuR8FRsc/nnkxaztYHsLzrS3QWMpx3t+dUR
9iEGesGld8RjfTruOu/IBmgL5IsxlPEzAfHhcfDzi1vYmXPiZ+Y85r5UjANc
smHGoDrYVy3+3JhPg4w60B9h753L5Iu56dLDgSTt3+xo/pEjf0y2+HxSWPUO
a6BB0NHr0PME8NYVdF4HD+3ThbeYS5hHepcph/bCuNej+3cXKadynbl+O2WB
/TUY14XE8wOwq/4B5bQ3QPNuxKbvMN/SXrKhjCiXv3mVQ5lLJ+LNvWGjTxUq
151IUr4Lxkkf3H87ch6uN+3zLB60mDDdJ3+in10PKyYcg5+OstiDGGQ88yLo
tI6RzMkz56OLhGvj4U/3haSjVuD/QdzBcmlIjvyC8qFvtI/TeZ7d2FK+/xTk
EH+b/Jd+zJxPfMZYQ3lRbu+UyR/oF69BVovd0uMb8KelEcXksdmKB+eShO+p
831J0tP7jubvWz+otfc2z1KuuNJR99Ta/VPc8vkJhVqrs/vJ7zk73xiRPbAO
7mHj2H9Av9YRLep8F95UbrEI8TF96XuMVdjraa54xtjN+pd+x3hHXW3Fe5fn
CVuOg/5X5Uiem+DLK7B/WpLODsbdo8HDY37R5PoK8N8Z+miEd64GnUklyqHM
pYsCimd3e1V7MFcH4MfbymQnSbCF58PaP9wrTEQ6tKX78a6poB9gHZ2k+3gX
85qrmXJZV8hhPfbv9Ehm1DFl9XlAefEzjK+WKkcvKhUGSLJnu+Od3+KePpB5
ZUvdRfqP2zdOBj/3WF8ox554v7BXEOv1tv664RdGZx1I3DXL2vwGyO0QZJ8C
m6/Am+7qpHkPjNNsb+EF7N3tSL+7MD6Gu47iLh9+/6BM9QvrmLBf+Og8bOQU
5hNw1zHsvZAl/BvB2kNe5YpOiPF/snReAJ04n3hbkyGMusvaBnHsTjtn7DrQ
Qvl3apnmVRgngKcV4G28o9zFOd+6qY1qgWrg3xkerY3Dnpig+iC3BIXB+X7a
GO3toKU/xNpVZ/A2ISAexmOcly6c6PYpnlGntIVtAel6K8ZRhbJb9m9Ye7O2
Z12/LF1xg/GD9khdUo+MZYxpH0Em49IVU74uUl6jHol7zzmKcWcwdoWM9mN/
T9xzp533xTzWr9x1GvR/LFLe+AnjZfD6KmTbCDK4ZOcXMXrShUHLIMO4oPiM
D6p3Qr1TN2exbxH2n/WL35t+hH2veZTPc0KKr8Q97DO9ki0cTjx+zp41HtXK
jHfcM836CP10KXhYBXqxQdn1TZng/238wqLEpK1Bcz72roM+I8g7IZsT6X/M
rfRB9kSYV086yjHD7HpNQHyS3y4x0jt1QdydaHsxS2zf4zzwy3xbW9UiPx8M
qx5hXZJmewbM62PSNTLPn7A5jXc1DYr3JrbeYu6grbBvyP5hWqF8mL7cLUM1
CmMEcy11ST12wfo/y/Q+6rBhsfpy7M996FPP5DB4K/YI4/+cr77OZuvXQ22t
Rv5SU4TxiO974i03kEt6hYX5uG7c8n/Ggbk5whKsR+kLrJOIf7bGKD+RV/J5
prV6G37wsqlI/tMgKj3nJwrDVcBn9kPXW9rIf+hHA3FXMeb/xvrbWD8EXDgR
tnoA4+Js1Y8HvKrVWCPy3heLVVPf7IuUCF+95RWOvmb7TvQf1lqM142wZyZ8
JKZEdEn/O8SePjmiwxqd+JQ9BWLpZbi3P2ge86qfy3fxfY+mCl+yb8CYx9zJ
WM06m+vEnOFk4RVilRaFentKoeo6YqW/Y5wfVPxhT4L9tlZ2PzEd8ROxE/sO
7DM8kiPsyDeugn4LHOWSQkf1ad9U1ZZOurD8eNjDglzp3Iu1Hbb/VukTriUm
LcpVrma8Zd1xqEDvfccnPMH6nbhhUq5w5VlH9Qf9lxid+I580paO+NUXmo6z
QwqEr970Csdz774C9fxoP8SiX+RIhy7WTTZ/9S9Ubk+0+Z29IeZx5vMtOL8a
+roBfSUXqAZnLf5TVLyRx8Y+0fy9g/pQ7EdVB5SHGKuYT9iPZj+2X5lqVtZy
rOMoL8qtGnGpS0i4qivG2Ih603EYT+OuCsg5IawYyljKGm5YWL5U1VHxg3GE
8WJZibAWsfPBAvn4VfC4xMZGxp619o398/R+yuEF2PWlLNEkbfpuTJz6Hevb
KNbNwTl3lmo/9gLZLxrRSv7GuDXV9g3W2f2l2N8wqj0ZOHciW7mQ9Rx7YOXW
nqdbOV/Psr0n6+/s5dJWaCftbI/lDshwh0cx7gtHPZjHU+WfxHPEdaxTibuJ
p4nPqmxP+7GA+l6bE4UJEn2yQ+b/DpDFNvad84S5GX8GuIU/WLczD7OmZL+U
Z7rbHjTj6eWoeLgUlf6ZI4jb2IeiPT9XpLdW2Pf2tXG1EjKfhbtOgc5hyOxC
a32bWQK998qUP/cp1blH7VnWZqzR2F8/b+s41nPEWMRaM4rle/TBUrz7vSJh
lLdxbm6x/Jr9xT2OMN8+jB/i7vth//OK1QNl3GP/jHmR+ZF2c87WE8Tbxy12
Z01/xmKAOke1PddvYJyDd/2Ks0fa6JsW/XYL+wMB4S7irwRHvaFmjvIJbZh5
cJ6jftl8R9+fqNsrAdVb7O0wlrGnwzqC9QR5a2/rFNbGzBF3gcdZHtkv+3ak
HbU+kmdrT+JQyo/9GcbNmWH11mdh7BPWdx9+/xljsRMx1G1+1dmN2iruDrB6
ieDer7A/jPEJ+w2L37IuF8reLhUKywywfc5lmeqJrynVt7g8+z1uSon6qpUY
vdnq/bLXvhP66Akeagp091r7feCZqGhuhDzri/TOix7lYObi/aBxNEN9nEPg
/XCGYubLPn0XYXxmnA5YjMMYyLfS3ok5+a2CfbmB2OPzCBs4uerTcX0l+Al6
FC+iuZIH+7/EjsSwFdaXtxUJ/3TpqBzCHMn8yNqWWJ0Y4eWg3suedzr4rodc
3RgPZIjPGvBQVaz8RRw936d38bvozBzFHMaqz4P6NvNFUFifmH8J9q6z/RDm
7cWt5NfkL8ajOMlvqsttHmE+YZ3MfD6qSHUy6+XeIdUDrAv+DPsM5crGaGvn
cUc11i9gbODRvM4n2+e3Q+bWGTbWMeYxPzFP8RvOH2BvBjZwH8Y5YdnDbIzJ
tk/Init5LbfyjLHfXnn38Ki+q42I/v9bJvFAhpVhuVt9AuYd5i1+lyWWZi1F
/EU7Jy6h3tlXIv1rsJVtiGNX/ao/2GekPbCv4LZxYG6masJvILeLkPso2O3X
0M9K+x2N2JA+yTPcz95PyGKMxT7p5aRffj3A2tv6kO7idwPWV6zHaUvrbQ+c
eXhXse7ajbEuX3s2ZQqHhy39HdZfdmD/HK/wJvvKxNOMAfyuyG8u3M++Cn2I
NR59k9//yP9qv+oAxnnGe/bQiXeOQs4Dc4WjWXux18PYe1eG4kmaxd4by/T2
qdi7ukB5mb2Q2Zn6NrYYOr2WJXsg1ngwS3YZAP3dJcJFx73ybfJ3MFv3d7cY
fmi2YiljKmVD+6Ee/5grXfeFDfaE3HaD/3vyJAvKZLtXcYTzd+A7TSL6LtU0
Iv1ErAx/jArj/RAVHiU/5Kt9VH32vKjkF7G1z1n7rbdvVN+NGdMZz/8Hc97W
hA==
                "]], PolygonBox[CompressedData["
1:eJwtmHl01cUVx4dFIBskmMiWvPCIgYSEEJOXQAhBFhVEKIpLEbCloEdFRAUr
ogcKoSj7TgQVBFkqCqgIaqs9CijlgIgLVlRAVLRaFmUTRZZ+vv2+P+a8+3sz
c+duc+/3TnToff1H1g4hTK0VQl1+65eG8GxqCEVNQliSFcLdFSE0yQihGeNM
TggToyG0viSEOxNDGF4YwoNXhDCnfgjT+G809ITiEAov8Z7h7P2kIITGySFs
gXm9vBAyGaM5sCPfWdCrykNonxDClex5Ad4jikKYwvwAeN4LfYo1NZzVvlEI
TeF/oSSEKvZ2Z1yE7sWeH6GLOKMl8oRMn92UcQ/nV7djHbrtuyyESZUhfIw8
aXF5trUJoZL/apir1YA1rH+tZQivMqaXhTCDMTNqfYawZzyy3o0MfZFlIv89
nR9CH3gcRv6dSSFsYN8HyPQw9msB/93Qz0et2yR0WMH+lcX+ls6roKvg8SZz
PeHfm7U/Z1u3j/ivNufPjYXwehqy1glhGPw2Mf8J33sYG5lrm2nbyEYnsVUG
8rXjeyHfJ/h+B3+eQ57zjHehj7InsXEIXZhfH0GeDvjsUuzEWNYKOYrtm0as
+Zm1Z+D3JvwSU0KYhy2/aIENG9gG4zj7OGumYvZk1p+AbtcaX9Tynl/Yexv2
+QldP8Q+b2Cf5vy3iLN3sacg0zGmWIsxvwVbpCrmatnH3+Xi/87Yvim+RP6T
0IeQ4XnmJyLvKmQ/jI47g3W+DN5HqkIY2CyExxVDxM9VHdElPYRZyJ9G/H5Z
bF8MwAcHoH+F54P1vOYs9BTFJ/Mv4I+P8EcvZGiI/I+iX0O+x2L/JXXsg03o
O6Tcd0F3opr5S7DxUmSt5vzF6HIUeQYhzwrZiPh6jzXXsfZ+9mxn79vI2LCh
Y1ix/FInz4/j/Jc7Oebl3ydY/wuy9SFen7vMNjmOvFv4jtW1P7dCP6w7wvkR
xijiZQDxnswcZgi3QJ+K2VfacxJ6HvqVod/LnPc19+c/xMAubLuPPXfij+Xo
uxt9A/bpCJO+jHnYcgI2a4E9p8btpf3/Rv4s5Yh6XnM9axfCoxa+fRUe86Fr
8NlS/DeKM56A/hT+L+P/U9jzI+RJjfpuriXGPkTeKDbYyF0+iT4riNcv+C5H
/8GINIb4WcUoR/5XOP8Q8p9t7/3y2W/QXS/33ZaN9ysf8L06w3dCdyMbGX9o
aP9EoBfkml83/juNb1Zm2j7r4P8F/BdzfjrnbyA/3cPaWfg4B/nLkT8F+R9h
dEy0vtPQ7Uv238j+y7HBevRPae3csZT4WMvez7HXOHjtY74f8r3PnrXwOwy/
7fCaxf2Ziz64MsyAns2ZMfitRZ7Pkec31l/D/FB0rEe+KIL/GM7eiX1/w777
sOeNnDcWmY6wfmEH2/5Bxkx8PRcbjW/o+FgJ/5uRZw/+64n/1srX+PehRNuj
Bts9hCDRVPswhvyf5lq/usi/CP2mwOMi38f4/or7/j3ztyc4BhYw3zLL39Xw
b4N9hzFOJPpODYX+HnvdgX0bs3456z+JOTYy0XEP9GfYv4z5NdgsHX1a8r2u
gWOkFfRweGyBdxXzf2L/IeSdjLwduS8fcjeS8fnqVNeYZciyOM+2UfzsxVYH
8MF98HqA0R19i7lji5o4Jyk3vQW/u9j/AzLtwvaJ8FuZah8kQHdn/YhU+7AH
9B0F9u393LnT2CO7k2WXzJJ9P/YZyPdI9N8H/VKldT2pOwW9mfOGwy8Dfq/x
fRT/JCFbJ/x3Pb7cjU1OIMtpRk/Ou5f1zVlfwXwf/PtX9uzHXjXoX0guqq50
LRzImldYO6mda7dqpGrlt4yaWs4xfVlbku+7Vht5S6EjyLyB8zcznsI+swvi
vsaeMeTPZFxk7Xb+K2duYp5zneL1Y9XSPN813bm7yb8nM10v3kPec+gzKNP7
t7G/lP1tiMF3sM0p5vOgE3Oci5oi/3DkX9/RutTDZuugV+OTPXV8x1ORdXWm
64PuwCJk6xnP58IAH8F/W8y+lE1l249jtqVyknJTf2z2FrZrjo/+jj2KS5wb
n+WM9tDjGfmprkmqTarRqtVLsF8P1h8vdC2WDD9CT+OOfo6tbiIe5kKPJSZv
beScrdzdNst7E9F/Sb5znnKfMNQe5D1cFq9FCdbldMy1OptxCXMd4vliK/vb
s/4+5D/Y1DF2b5V1kC4XqUmdu5Aj8lyPtyh/4p9dZY5VxeztBR6iL2Dz67gb
qwpdP4Vh1rK+W6V9I/zYtdIYRlhGOTAJ3kWKsTRjygbcj7e5A3uTXJPWIOsI
ZFje3DW4cY4xlfKjfL4Y+19a6PjTndfdn4oOz9d3DZgGfa6lCit4DZnrUE9P
x/HiP/nvILLczpp7iad2nHEjZ33XyrGm/HiWeGtU4bnbsMePVY5hxfIRZJyB
7tOQuQZ77uW/HviiKzGWlG4MJCzUt5Xvou6c7p5yrngrpoWFRkaNHb9GvgnI
92CuscKf+W8Eul0Jv9H1zLMbdCnry5ir4n78RC47yBkXMhwjE1RL8Hc19hzA
KIZeke1ceTM57yjx9007527ded39GDr8K8n148o2zqla35axCToJ/bemO18+
jf2/xgb9scUW/luS4xyoXJiGPO8WuYapli0gptqy9vVK5ybdkePI/xP//YH9
gxnHoH8tci2/g+9f+D5TZVo5RLmkc4GxszB0N+zbu8BYUZjxd3yvKDa+6oLN
lkO/2NK5RTkigi3HxFxrn8UeY6F7IENyum0q296IfCnpjjHFmu6s7q5i8ibW
H4Tf0STXLNWunowF+HsH/3VCltltbDvZsIzv89hkVX379FFsdyH+Lbw2nu9n
Co3tJe/f8OW6ls5lkjcr1zltW1zf3vC+FfuMaGDMKux6rsC9zNWMCLx6InMG
sh/An5PRJWQ7nyi+T6rfYc9dCcZcmcjyKf6vSPGd0d3pU+G7K4yRjP2GZLrW
q+bPofY3yzQWVw7Yz/zPecaawpzqLX4jvifBrxHrNyPrEsZ/+W6L/6ZXGBMI
Gwgz1aBfnWzvVz45W2gMpXlhiK/w5wZh8HTX4KRS12TVZtX8FPQ72N73WfIe
gN7I+YM4bzfjkSLHuGL9Umy4krPeyDfW15pTzJ3nzK3JxvfLkGcT+wenOAeO
xFZpecbKwmzCbtWd3duqx5sVdY1TrUtF5q2c14XvwNzNxEwZ520p8txGeOTx
/ftW7o1kE9lGNpKthG/OMvdOke+OfDKb7/no/ATx9RkyXxMxJlb8/oV8MQ96
mGpognuqb7n7O8tdP9UTvB+1DWQL6STd9hQbD26Xv/HX5ALnL8XzY9DfovO8
DPM7VGXMJdnU82aj/8N8v8/3UtYkch/bsWZwqmOuF7H3ZaF5C+MfhD5QaF/2
Q55Pou7R1auLx9gi6yz+wng/oEtSJ/MeiU0ToBswns5wzCv2Z1Q4loSnB5M7
x0RcG1QjBiH/xhaOV/23o70xkrDSB8RQswpjGmGbRYxbiK01OZ5TD1a31D2u
/F0Kv83CL8zfp3rOmhtgPLHcuVn+19vF5Dh+VU6Yyfm14H9bqvfUrrIO0kU1
Zezl7inVWyrndIfftfH3CN2ZbHinVDgXqgdUL5jA9+Z0v4EMQZ5u8Lg/w5hT
2PPhmHOZ7CesrBqtWi0M+w/ux5Mx9w7C4E9BHy40fhW++YKzHyhx76ecl9LF
GElYqRnjHmGTUr8F1MWGe7gv30V9V1TTP0XemiLnHumwsMhvDHprEAbemG2M
IayhGqRapJyk3CQbbYT/iyXGYvuYf5P5x+J4cjj56XHopBzTylmV2OtInmUX
PlIvn8SesjTXPNW+r6rc26gmfQPdK2L8pDvUD19NL3buVQ6eVuweTvhyCvrv
gB6Ffedn+A6cx74Jsfhd5oxk6IYx9276T3OKQcViAetnVbgmqjaKxwW+Z1Z4
Tu9LPyv3o3+dJsb8W9F9KCM11W82c+A3HZu9Vsc9Ug3+Hlvh2iF5z7E/lu9c
oj3a+0bMttN69VZbSvz2oTO6dnFPqN5QPYF6g725cX2UU3Kd45U7A/LdwFnX
V5hWThVWOhvHJ+rx1esXVLmWq+d7AXsVVfkuKQcoF4wiBqO13fOsRNdb8/02
pRyuXH5FzFhEPWdb6J2MY2nGGMImegPTW5j+e4+5D2J+G1HP8qHeouL3QRhk
KfwOx6yL3qiOQY8sNFYSZiolPooLjG2Fcafj/+Y5fovQG2Qf5P8LMXY62RhS
vfaeqHOVevj9hfaZfKc3Qr1tvl3iWiIdR2f5zVDz6vFPE3/Hi4zF1hODSezv
kO9cLZ92hH4u6lqvmr+M+7Mm/i3MsoL10wuMJZWTh0Wcc5R71DOMKzFGVS1X
TT+Ofs+08tuW3uT0Nreog3v1//c02POFiO+ualIj1q/u4Lc7vdHorUY9mXoz
Ychkzq+J41fVm57snZTv3lJvlGOy/Gai3lc5ZBH8WkeNpRUva5G9e8TYV5ho
Crzys4z1lbO6Ew8zSz2nNVdFbCPZShg9sdBvaHpLU42ak2tMKWwpn8v3ejPS
25H8Mz/XPbvum+aVK9WTSz7hi4W5fqPSetWjLyN+A1FvqRq5j+8RJc51yjnq
ZeeUuddSzrg24h50bVyeubl+09HbjmraXPR/Kc/5UBjiHHM7yp1fVH93Rf1G
qbdK9fxLscXATONDxWOLXGMeYR/hqbr4Y2KZbSMfVEN3Yn55ffcHFdCTy+wb
5bPHylyjVKuEAYbm+o1J+Uh7huca8yle1OPUgv+oHOc61dT61Kb+/Lc30W8g
dxO718Xfp4U5hUX7dfDbgOyj3KyeT/IKs53Jcw+kXkgYXlhePah6Ud2p8e3c
M6h30JvNxHxjFGELnflHvq+OWB/pO7fUb0J6G9IbdymyVRYYWytmorl6uKW+
odMmzn6V8WQcH8lfveH1P6PRzHU=
                "]], PolygonBox[CompressedData["
1:eJwtkssrRVEUxj8XA5GBYqJw86xzuQZcCQOmZjJj5FFEnilSFCP3ev4DTAzF
QB5FKInIqygzQynKxCvP32qfwa+1zl5rffvbe59gS29DT0BSDiTCb0g6J64X
SX/kKpbmw9JYqjRHzM2X8nws32HwOlmq96RKOCWvImZTy4FNdDYgAZ2jFOkh
KDUXSi9J6JVTZ34Lrsj706RL4nCWNAIz6DyjN0s8ZuYE8pmP0hcXkdJLpQz4
wNcy/t6JO7ALJexZDJ3UH6l1EON9DwHiIt6WoJszDrHWRRzgexCm8RCDBWhk
r238jbPvAH1tIadr+tZrM60hV2snVuD1BM9rzNTitw7e4Q0Ucd4DEbdu9VX6
jukv85wf8/WFziF6PyF3FjtTKvuPMvuEp1dm+sgvyG+o3YbdPdh9JKAdo1YQ
dPdl9/bp389BpjTJ9wTco/HEvjHPzZvOtf8Gb9R+WC/Bw7fnvNsZ9umZQWcv
7DRMKwpTcODXVjLd29kbNjF7xx7NpgWH5KWe67c5+z/sP6lh7YxaNfEf76Vt
8Q==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXmU1cWVx6vZd4FuNnvjdfN64XU3vTx6oZtojCKyCQYU0IkoyTnqQTJH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                "]], PolygonBox[CompressedData["
1:eJwtmHl01cUVxyeQsIQEAklE4IVsJHkhJCHJS0JYhLogyqpld63oOeJBbMGC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                "]], PolygonBox[CompressedData["
1:eJwtk0tIlHEUxU9GbpKMLKUmxplmoTYTjUiDIy0qyRaVRVAty6EHFCi4MjGL
KGchRIuxTVBWZvRYtgkKDFJ7uUhropdZUCRKLiUJp9/lfovD/bj3/u859/FF
M20HWoskbQTLwLfN0rUV0iT2C/gKeuvwr5Qaw9LuWmkP6E9IuRLpblQ6Vi0d
BwvgL1hHPFkqrcXuB/vATt5+p8YVar0OSY/gKEtK9+PSA3B5qzRfIf2k3tuU
NA4G4bgKx0N8T6j7FHSmpco10r+YNMT7Z0nXY7p2wDEJRxaOFt7nV0kXeNtK
ThvI4f9BvCnsmkxbH/EceEW+yqSXAbdp+IW/GF+e7/INaEPLwU3eo/WqGqmA
XUTnc2JLiNXQy9ByqRrbAk8GnIb7FKisl/5Qr0Ctw8Tz5B3CnqiSTlb5HGwe
U8EOHofcb/Ft+MfI344diUjDYGKL1E6P49ibaOhDw23sBJzvwGdypnnTw5se
amSBmNscGiL1rsm0mUbTeinu+Vns+5T3/gE7Q2w27Du2Xd+LOtctuEaJF9Dw
AnuO2HkQCvYfX+/zsTl1EZ8irxvbxLtdCddjui7C9xvejxHXbfqPBvs7kvKa
VnuM7yI0vUn5LdhNDKB/KVyD2C5uI8ptdKd9p7Zb4zG+M8HddGD3gsJqbiDt
c7R5Wn/W553g5gYSfjN2O9cbuOVy6UaD35vd3WLMuc6m/R+xf+VTzOs24/sP
sByYnw==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXl4ldW1xje0TNFAQsJk5onkkJPhnBySQwyt4gQiiKBSQHGkFWurthWs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                "]], PolygonBox[CompressedData["
1:eJwtmXd41dUZxw9UVmSFMIJZJCTcXJJ7k5txc8NwAQoiCLIkCE4q+FiV4noo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                "]], PolygonBox[CompressedData["
1:eJwlkb0vg1EUxp80GBDVio/QlvqqetGK+BoYSISEoCmNmrCYiF0MYjDYMBKa
KEaVEhGRGIwtkxWRYBL+APxu3uGXc997nuec857rn1+OLDkkeSAXTlqkY1ho
khbzpVPOqpfqSqX1XikTlrLw1SFVuiRHtXTYLiXg15JChejx7PmkfXhDu0Gd
K+pV0cQDY9yPQrZZOiiQHoiDeDOcByw7ZzSmpqld3C35SiQ3sSsgdYIX3TX6
oxppqkGKQpvf7v9HLq9Vuuf8wV1ukG8YwTcMafrt4l3BO4vuHV2cmKbGBcwx
I7+qZJW0E0ILcZiBCP61HCnGOYZnGspqqcXyLvEm8KwWSVvkJ9BOwjiaF3q4
0aXQnENFj/TJP5UTvezIB/38cx9YzH/HfK3EFLNucz5rtnNGk2TuG+78lr0L
sxNT09R20cNLXSe72mQWrjREPso8UyH77cwbPoLbye7D9juZ9/qhXpA5v4kB
jI1wS68nesUte4dml894PHhfif+Q2VKZ
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXuYFVS5xtcwOMBwmeYiDMxlM3c2M8PM3rMdmItThKB0UgETBArRNKyT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                "]], PolygonBox[CompressedData["
1:eJwtmHl01NUVxx/EsASIkoSwZGVCDGEySWYYIAmLIouiFSEIZXFBBFFboKIC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                "]], PolygonBox[CompressedData["
1:eJwtlFlIVHEUxr8mo1HLotIeZrJmJrVyxoqYKYOiiMyCFtQWX9qgRUgtqAyp
7KUwol4LgqBe1JaxxaCNrAx6CcoMbM/SfJCiRaKUon6H/334OPeee5bvO//z
v6HN1SVVPkkLwDBwb4rUChqj0skR0nns67i0Z4z0Cts2SXoIRkyV0sH7hJQ6
VvqAXZ0nlYHH06Qz6dJ+4s7lSGfB8Jj0iHqp2NvUvwV6ZkgTRknd2O/kfQNX
8iUfcb6Q1BdyOf6Yi7e85/TpAD0gjb5fiMkjp5V+jfSLUaMAlIOvqdJTuBzE
Xwc+ef2CQafRtK6bLlVkSGuxA5OlwclOn+ksLpT+jpOWYf25aAAFaL6cJkUm
SnPInw3+BaRAFlrnSmH8zXyPTnXxlue3ZzA+LPWiZx16Js6UThPnwx+FTyzo
eBv/BnrfRU8EXduovxVc4hxOkXsVvSuJXQHq6bsN7qVw/0fNLSOlIQXoQsN9
UEWdSnCVGfQyi0Jq7+O9BvyEVzu+Vr7twr8TrKBfB31XYps5syQYCee39C2m
/mv6vAJvvH0YpM4h3uvMz/N6fEm+LUVbMaidhX+0lJkt3STmGFxvePGWV0+f
PvodxT6gfxt4hr8dLGHmf5h9Z0TK5vsd4iZhs+A0HhR53xcXOu6mYS3n20WP
/oA7FzufKyG3x01RN0ebZwv1r4E0vtXCuQ/OA/DfzfOLuNNoWiuI3Q6qyd1L
jZ3Y6/RpAZ1xF/8SuzrudNagt5TnMtDt7efHhNt/uwdF8H+Cjlv02kiNTSAJ
h37qXCJuB/wrwTJm/Y5+GWF3BnYWTfhT2F1/0HEybi8jbj+XFrqZ2ews3+o0
evEN2B/4zzKX755u028ztFnmencnB1tG3x76ZobdvtrerkHLfPiVx92Z2tle
9u5oc76bhc1kFTW30qMEO4/3+bZPxC4Hh5nLW+YTYA9S0DvU9jjf3Xe797ar
trO/2d1F1PiFPQK3w+Biws0nmXDzsrkdp8cB4k5gL3r34kLUxVve55D7J3V5
/wr7Z9hu2Y71e7NoZUc2oGkhtTfFHU/j+x9WhNa6
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1mXl0VdUVxg8ICISIIUwZSEgIeSSPTI9HXhIQtRarVAgySKgKOOIIggpW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                "]], PolygonBox[CompressedData["
1:eJwtmHlw1dUZhg9EQQghQEhCQnZCbpKbkOTmhoQQUEvRQkFkKYtWRBRRqyyK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                "]], PolygonBox[CompressedData["
1:eJwtkktsjGEUht/WpelMtaLtppqZ+WcqZf7eReV3ia6w6GJa0UokLTZIywSh
HZIZ0hI2WEmENcG+pRJtiViSuCzYUCsLdhJSST0nZxZP3m/O93/nPZcJjuUH
T1dKysIaGAilD3Eph+YS/IZSq1SESWJL3L1Pedzuv/LwAbFvaCP3s5wb0OFm
6RA0paUfNdKRdmnVFmk1/Nos/YQBYkvc5dCFXml5g7SIFtvwhGebpKcw2u45
jqKP8LmJxxO0k5q6Wt3H/O5tlD41SkM7pDHy99HQwy7ewGMobZP68SiiI9Q+
CifJeT8mVSWl45xPwO1AugWvqOUf37/sdR/zm+qUJmp5g9f6bqkOqumxoV5a
4bsx+MybU+hOetgFBbwn4Xrgd+PcXYmkNLWuZKS15KiCA/Q6CH+YXxv9hnw/
Q197qqX91LUX9kFhK/ngIH3sJl8+5XO1+SbJ01MnJdCPxL8zq4uh78/2+IK5
3SU2jybpPwWLxBcgjl8M39d8P815Cro7qHsd/Xf4Tmw3l8u1l9DzkOA8EfnM
bHbTnFuIXUPf8vsdZCEk9+/Qe7RezdtqmKWWO9Q0k/U52DwqWjzH1cj3ZPsq
hN7PJfQwvffR+wg6BMNQuZ3/IHuIpX0vtp/nzH0OljNe54XId2K7Ocu5mdiZ
yGu0WivKOYTm2dMXPG4Evj/b4xu84/RRE/jMbHbnynn+ZtzLPP8Dh5h83w==

                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1mHlwldUZxg/7nhDDImSPSS7ZIPfmZiFEO23/cIZCRxZFsUiBoigqWisO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                "]], PolygonBox[CompressedData["
1:eJwtl3lw1dUZhk8IiSEQQkBCyJ6QBRIC5OaSSy5RO3aqFrAVQa0LoiCLKzII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                "]], PolygonBox[CompressedData["
1:eJwtk8tvzFEUx79Bk5mpajxSjxna0QedUZ3QKZr+C0JUSeOVYEhTj4VEYqNJ
Q4SIVm20EjZopa0ZKlIaEqQlhJ2mpfVY6HQMQ1C6wufm3sUn5/7uPefc7zn3
/IK7D286NE3SKsgC/1LpCIucUmlPmbQXRkPS1WzpLda3TMqG2rD0mr2HBdIB
vg/Cdc7PsncNu3aJtA4ulUtNs6R2bKhYCsNn1pfZS2GTMAFv8qWp2dJQhXS/
SOqHVIQzuF0lFeZJd7CJFVLbTKk3KA0slwZhIT5DM6RJNCxi7YcY6x9e6SNa
TqDxJOxibyeMuXqa2Mug8SvEXd6b2B1RaTtsgxc0Zx7nL4m5QswrbBHfxa4+
U2cevejjbAE2YHyJuYtfH9yDcyul9zlSC7aW8y3gpV4PjFfSz7nSJ6yPnnuh
np5/Qcti3iKE3lLocL2Nofk5tf+dQ/3EDFDrIKxG91Zi9nFWQU+i0B2QuqCl
mt7Ol5qxj8nzCGrY/+2RnoSsr4nZT2wdOdaQqxGNx+EGNf3j3k7sGeInydOD
Xwd3d0KCdRwaiK/3SbfYayd3G5x2/qew552GFL7D+IxA0tWeCdp3TrlaTE3P
IDdXeoptoOZq6t3Ie3wo4U1L7LyZuWtldhqZpQtYL3dmEdMdsfcbHWbezNwN
F9o3aOYNAvQ1bXpVZvtt+v6defsGCfrRSr3xkJ1BM4sPOC9nbyTfzpuZu66I
vasHO46uY+ibiNqemd6tR08MXRvK7fuZdxylXg/1vqu0M5dxs2BmYrP7n2rC
9n8w/8X0oM2bJO8UOv4YLei6iN/RAttD08t00OYdY/2Le35C2v1j/X7mKGD/
n94qOw9mLv4DJTKxtg==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1mHlw1dUVx6+iQNjCUtkS3ksCeYGEEHh5eSEJzTidaq1Qp4MD2BHBQcUN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                "]], PolygonBox[CompressedData["
1:eJwtl2lw1tUVxq8mLFnIQlooCVkJb+AlISF5k2hCUz/UBUGnTYdlqoJFqR1B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                "]], PolygonBox[CompressedData["
1:eJwtkjtMU2EUx/+pkgiSVgwmQqHtJUKLlqCQsjjopInEQWaBeGvQUqIR5FXa
hYGwObhBHGog0YGHEwFrItH4GhgwQIiPicGwkbBAMfD78t3hl3Nyv3P+53Ud
92nHE5+kGJRAV5P0r1yqqpP8jVIAItek5zyu1EsOfh3sNUi509JQRHp/WSrA
akj6CENt0t/z0gj2J3HrMMX75FnJJT4VlfZLpZfN0kxQmoVVGpgok+auSqU1
UhkMtkrb56QKNG9Q8yY8RHML7QlH6id2ADJoTqP9iRpHl6T/ECKnFsJ86+Yt
gv0KX6DI+xpDf8a/jeYtuEjsL2plqXlEf0WoQnvJL9V4dUy9abOLgPQKmyTG
hQfM0UfcC+Y4JP8AGsJStAIt/BVmWYZOb7f3sS30v83+fMx9Js7MsMBs+8z2
DrtBP5shu39zhyD32CXXJfcCd6iE4BW0ma0am4JdZhojpxc/DY/gD+892GNm
FbYLOsGln1PcoBt/nB5/M3t1yO7C7CRDPxnqjcbtTc1ts8TuoJfDFpj7AyzA
PDz2av3gFkX8JnLjjt2j2edbZnoDi46dcRE/Sex1/LsJ+4+Yf8VoGu3vaJSj
8Q3bwfs9SBM/zM6e0e9r+snDoVfrAJvjDoPcIYu9A+0exs+T206tLDpjCevn
EnaPZp/HaMa4VzRs72fuaPZv7pD0/jkXewJseoUb
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlnls1FUQxwcoBUuBIipCS9lty9LtArbdboullogmSuAPJV4RRS2IFhAw
KmcVkaBiQQxRVECNqPGKAaUQU1G5lKLx5AYBxRCFgnIoUA7x8828P9p5v7fz
5vjOd+a9aM3E4RNam1mPVmZtkEuLzOZ2MFuCfC7b7Er2mmNm6/nx1S5mT6P3
Wgl7ncweKfa9l8P+qXKzrK5m6Xlmq1mfuNTsA2QHvvdkml3fz2ximdli9Ccg
K/Dx8yVmp7FflzSr7mx2A7azK8yi2OmBvLnSbOvlZjchc8J+BHtzernvBdjJ
yDXbkWU2Hhv1nB+DnXnIucTfjfhnsP/J1WbFHc2+I4Zavh9JM7sOm9OJbz9x
TkM2Yns0vo62I4+42esZxIv+BtYpMNmIbC7wszURs39Dvv8gc8CiGP3zfTwH
5fIUfj7ltwjYPdPb7A7iH4z+LcTfXOH+jiD7kP9ScCggxnPkM4L1qRyzBzlb
TnFGonMQ2/F0s9nYqsBuE/mWIb8gpjp0FvXEN98xMDmLrLuC2Dt6Lm2qybM7
/qs9v/ROvj/0Kr5ZP47swfnp1PCGUrMGbPyHvxX4aiaGjsT5F3JtwnNsIcf1
5L8bTO5jbyGxrgTn8+B9b8L3a5DNlb6v39PAZD5nfy00aw0Wp9uji9/vyT2K
zny4cAgfmfj6Ezkv7vEorv0ps8nU6CI+01iXYn8f9d8X9vemvJaqy7fYO835
LthpQbbL8/UZ1gf5bQQ6edgZU+4YpsBqXD+vtWp+OMRwgqDeDxyurzKbVOyc
X44clXReRVPeF52yHKuFl3ls7cH2AjyZia/p+BoWcB6Gfj7nG1nnYXsqf7fg
dx38LQwcaCKG4ejtxGYW+xaw2l7kGAmrIeA5Kek6E8XluPPjUWQ+OJfBvd4l
zlFhsgXb23Odh8vxOSPisaVRx2PY/JCY/y7yWLWfyf7twld8ho/9c9xmATZX
BEyEjc5LfwT5tSKOJcRzEf21SefqoYFm98CDXdgficzo5TjXgHcPvrfA28vJ
bwn215FXRo5zVxy+iPy5yHMXBuoJzQ3hPDzMhFfg2+SYz6g4mB0PudSTx37W
77CezbqcWhyhJlFiXhB3br+AvJQYVqHzGjo/ZHtdCqjPAvrtOHl9TD8eYn8R
9seT18yk+9JcnEchEm2xDZ+b+potY759yd7QqJ+VjTbEdD3rs+T9fYFzL4Kv
qehPQ38KsjV/Z8DhDerTRDzXYP9zcB1cGTgDtoUpnyeDS3yeCv9G5MBC5494
1JJwO8uwc5ZYB+HrBH6XcXYFOS6M+LwWh0ejXxPmkngRi3mcLeg/hZ0/0N8Z
8TqpXp3jPmvUL0eJ62TUZ8KRcp9Z4q34OzjMvTHozghztR7dWcHmk8hLyDdJ
7qXsj+d7H/vfRbwPZX8s5+oCDlPBoWmg80r8ejPL+0ux1sadn+KpctVac/Dw
QO8F9cTQlHOsnBznl3mvLkJ/M77fJYatfT1n2VOtxBHdEarfhkq/Ux7C7xq4
9CM5HifHoaXOwSHIxdnej72Jc3K+2fP0/7YB3Av9fHZphmXB6a/Q+Ro+3MX+
XtaN7L3U0+PV/L7QxWeGZr1mieLUfXptV89dervw/Q0x7EGOC7jVIlOB26sF
WMJr/UDCv7Uv7nfM9bO7Y37/KcdnmIsvBm60SngNha+w+J34MvHfFixPBnzF
qULqdDf63cGjHYmng2FjwnNTjvmcWwAm/Gyj+jiPFZbqqTx0931MLpvB/S3O
fovsEO6O8XD56jAb1YvqUfW8sNZdpbtMM2XxFY6R8Lmtt3NePZQRZsg67DxU
5m+ScWU+F9Sz1+Y4R4Sp8MzN9ZqqtmujHs832HknxF9L7F36u9+s/j7jNOvO
g+HLvbxG4lRBd79PhfVGDi4Fn03Iz9hf091rmtbT7+N88MyvDvvw6vZqx1l4
n+njd6veEduJ4z3hE3Vu6F4RP/LotR2sP8r32ujsAc6OIL4G4ryzv/eH1tJX
TVVPYT6X2r3Pb4eK/L7R3JiOn2Mxx+FEzGeE+CBe1GG3Fhx2Z7stcVu57ERv
M/qZ2LgQ9/U29vZwIf7SzXvn4XA36R5Tg0xhDvzG+o+Y35t6l7UOXNV8+q/M
Y1wDTi0xfxNGsb+3l+e/t8z7VpgPo+/akcOtnE0v8nmquTqWcyXhPXmK9a8p
93tAM2CAx68eFTY7Ap7iqGqtmp8OfmUjjzmWZI5FSnz2aQaOpG9Wlvv81Ftg
XHh3qY/V/5oDb3C2W7D5E/8qcn3+6K7TW0G5DwLXn0I8iisvxH8Y/89WOYd1
Hz7J+jgHZlX5m1LcOJfweqgu55J+r+t+H4WNTYV+dhUxdkKvAXyykJEwu8R3
9Zh67X50HiOeIeAzBfl6xNeTU/4+0zttEPnmhp6S7SeKnTOVrJdE3H5n7N9Y
6u9tvbvVlw3hjn4zzD3NP/WH+kR9rHe0+lozZWKVc2ZClb+PdR99ovmf8rtP
79Pt4Q1wkTm2I3BPvJuT4/ey7mfdnZoDXyY8bsV/KtdnvNaKYxl26vH9NnJT
3PnWgM3REd9/q8jj1GxUL49N+vzXPaD3luo7K9vfK6rpjJS/35WT5tL/CwgY
kQ==
                "]], PolygonBox[CompressedData["
1:eJwtlmls1GUQxgeoFGw5igdCS49tu7S7gIXd/RcKghDPlGiCiES0UURCS6FR
FBGKqARRQGtMhFiRUNSoHwzl8igkcohtIUGLIiAWE4EYaEkEExQp4O9x9sMk
M/t/Z+Z5nznezZtZM2V+dzNrQFKQ/LFmtbeanU81C6GvyjO7MNBs6o1mY4v4
vcyspb/ZNs52oFcNN2tH38D3uej5WWb7sd/EThlplhvgT+BfiVEzzmz+ONdP
IPPQD4bNFvD9jTSz9RGzPM53prqPfIVBWAoGme24g3yB59+JHRpvFsTMdg1y
Ow97ea7Zx8T6u5dZ90KzrkzHOpg7NYB3cwm4+7q9EbsVGY5+G2eWEauz1Kzp
JrPinma7sZcMIUd3z5FP/P7csR+yFy72Ic34f4c8z9mFSHvc7GqG+8j3Or+F
sRfj3wP/vvj2ScZQrIPw+2m68/Ub8VqSeMb3MytKUIthzucmzrSgT8xyrDqj
s6/G/Kxs3eUj7vxhoedQrsqhZtBqn8FJB0obfP+AbERvQJ643bnSmTq4+jpq
1pNcJeD5B9/Fw7z20RvM1oC1i/udxJ5Aff7KMVtNDS8OMNuD/+voTYHbuT3M
vkLfXWw2itwN1Gw9fEwAP6W3GfgfKiBWjn9/52azn0fDcTZ1RRIACpAQMZr6
er9UEz8ociwvgnER2NbQY7O5/1pirsjyGqu2qvEHfNPFphD/QG84Ie7gXLdb
sY/CQ8BvP1KrHfw2gLtXhR3bw9ip+PYfQd/28ZlIGeI9o/jqqTTyVeBznLON
iKGfLvTekU8Gvpeyvbaq8RHwzgocm/iZib5ljPd6Cee3oveOeG5hOAOWQdiP
p3nNF2KvBUMteN+HzxZm45ew3+37W8zuAdtz8H2GfMuJXwGWC6o33+eQcxq1
bibeeuItI/5V+L8STdaamJfRz451/IpxDt1inmsiM/FQCHzcpxfyAL35IPIt
+RJp3g/V6KcKPbdiiIulJV4v9dBL6N2izpU420MtusKORZj2g+3JUfQt+erh
eAL53ybmNXy3M0Pv0iv3872R+PXYNXGfQc1iB7E7keq498I6vs+Le8/933tw
MJRcF3Mc6wzsK3yfH/dYsn8Hb8Vw32XaaY+hXx7q/GgmUun/avg4SrxD8H13
mWMSNmEW9qcD7w3tqNmBcy7uDxP/Mvm3Bl579cC2wGskvirxqaWfPs8nPrOw
nX6YMcJrqtoeI94z5P6JHvok3XeCdsNpYp5CXmN2VyKzk/tAM/YUekWp76K3
iNk22nemdqV+m0P+CLUsRlrgvhVpImdPsM0iZxv9uBT8s7C5utUTf3LCbc1M
ecJ3ruLpvqXkKyvyWuvNeJl5vRT2u4uD1fivyPT7qGePh33naT50p9Y83wHa
Bdqh7XD76AjnQjtCu+SVTMciDJPgZjKc7+3hPVE+yt8IvRV6QxL09wvw2SvV
OQ1xnyUJxy7/2oRzJu6eBfsC5Juoz4Jqvhs9Pdt3hXaGdsmR0c6lYiq2ekC9
oDPHws6ZuNMb0gH308f77k/vZvYI+pGwn5XP8kwX6eqpqiQGYdGborelkf7b
jBxgVg4i1wt8X+uNOwmejKjvLt2pFKzNw/ytUH800E9NWd7LMXoixD5M5Xss
3e84jd67Hvf53oJ9Le4zrlnXjq+E7yUx7yX1VC16FAwRpJN7nEdqYt6bqqlq
uynbYytHb3JtL/DYk4g5vdR7QL2gnfQn/hsi/vbrP0AHZxdxV0poqzjzJb23
I/C3RW/KF4H/Z9BboDdhDPNeB+b3MrwH1tEvV2I+S3pzu9Cnhjy37qhdph2l
+dcOnVvsb4riaQeX5/kbrrf8TriaiJxI7lfVX2/HypDvas2IZuVSlu8O7ag6
4t1LDy7u5m/SfehlxBgz0nemdueuIc7HXeQLE7sj7LtdOz4z4jtI8bRT9xFv
HjuoGtnJ77uQf3PcV/OQQv+2FPtuU8xm9Llx333iZAVnzyXfM9XwD/TNyf0j
PhvR2yL+9qunDqOcjfh/Bf02kFr8BxgRnPU=
                "]], PolygonBox[CompressedData["
1:eJwtk11MzWEcx79r1ErqVDObWs45vZ8TSs5pmhnjxo2XyMY0xGapZJpSMXJX
cW+LUNmYC114WbGRMaqxmJdiymtRectLueLzeP4Xn/3+/9/zPL/3n6eoPH9P
iKSlMB02JErr4atPujhD+o5cmyc9mSXlI6sWSAegCX09583IT8nSKFQGpFWx
0n7kFmwUwoRHiozjTlB6AS8hLkOKhY9BezaKnOLuJEzxHYNuEhmRLYVDqFdy
ofuFLoi/AHi4+zhcyuV7EM4RyxAyA70Ptvvxh26b3+Zj8urm/D5EpkmHp0m1
bqkfRrhXx71q9DVwlzsn0d1BenmXBG/IqYrcXiMP8n8IUohtUbQ0P8HmY/La
nCJtgoXknRMphWVKP4M2/t/Ifv4HoBN/oZx3IDvw2Zlm62XqdsRvYzqKjIbL
fEchC/CzEZ7y/jxvn2U6NYNGt+3XN2Leja0S+JwqjUM8ukLO0rkzniWNQVc6
0O9E7Lmpr4f44nOlYc5GsmyMJtaV8+gZvlYg65YwD7OlBnLbRy4VEIrtAmyH
I9/h6z1kkH86FDk9uI3fYWbmA7x16iiPnQUzE19gJv5/oBt3vseQrdhog2Ti
6YyiD1m2tqbGJj+T5xh+L+CjHh/L6ccycFGPfpe0N0cqg+d8R6BbzFketPGm
kTc7edNHvI9Sbd9N/68RYwO+riIn0PcxY27u+7jrd9vZNztQ5cx6M7ok3nnB
5fSqyW33wexFq+OrBdmLvgd2ca8dXQiynLo2RxDfXKmU7zKoJvchbNeaeSHu
gUTbd9P/E/F2F9exi13YGsDOVr+tt6n7DbgOc3JtTxOQZ/F9Bk77/pddD1Nt
70wPGz3WVw3fvfS7lV7fQncMG8fhFD6u4CPGb3M0uf5xdjTMa/fT7Olf7lVi
ZzBg+2z6bWbazPargD0bQj7g3iD2SrB3ibN2WIN+NezgrIK9LM6xM2hmMdnZ
saRsu3Nm94r91kap39bG1KjHib0708Zt4r9JHi3o7qH7B+sI0Ow=
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlnls1FUQxwcoZxU5ilSBdrvdbrvbSotlt1ABg5BIgrccBiinchQ5tJUz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                "]], PolygonBox[CompressedData["
1:eJwtlmtM1nUUxw+CgVFJQIqB8FzgkZtcoudJH9FSX+SmtWo6mqRmbakPiZaI
pluZ8kbLLK3WJqRptt5Ub6oXJrYuRl6Q0iCoaWtrraw2wgveqD7fzrNxtvN7
fud3Lt/zPedP8LFVDzWPMrPtSBqybpLZlTFmv2aaPVdh9k+Z2QjSGzHrQzZN
NzufZ3b0FrONcbOsKrOZKWaP8OZW9M4Ss0NIwV1mE5Gd5WZdBOjifhd6aqXZ
KGRPodleJAfbaxlmc7LN1kTNmuvMViLxWrNpSHO9x9rP/Sr0mcQ8cZvZ0yT7
W7FZK7bTx5pVjiMGd7ORbu77ssxWcHf9TrM83q5PNWso4hwzq0Iv5c0Ielu+
2RYkgW2T4paafQQOg8R8tsYsGDALIAlqb0Iu8KbX/P1F9L+QP5G3qeMAMo8a
4tme37xqs5ao17aN80bOUWKUjjbr57cneBfiPojcXWB2D/Il+X8RdwyERQzM
ltGL0+AXBq/wNPyMc8zTJoIJNpT7Pwar0R8F8zk5ZjtyzU5NMRtb4fhuJf5u
6mhI4qU389HXktPZMX7fgn6UeB3E66Fn5cRrDZulp7u/0/h7GS58Bn41xN+B
fijmeJ2hnk70HnpystgxE3bv836At/1IeCq1g+HsND8Xc04Q8yLx2/htOXoY
DErIr4MavqKW1qjzUfi9GfAeqBfp5JmB3A8fP8nzHL8jv/oCr60B+2PkcTDk
vuQzFT49I8xTPd8NMeeEuNFOT1aUeUzZZ2Kfha/jcLVujL85iv5jxH0rxgD6
CwHPXTX8TT7BmHP1cQxixB+JeO/Uw7qAz5BmSZwT92Qj25IJZh9Ty2vUu4D3
Hfh8o9pzUC7K4S30WQimtoT7U7xdy8wtoPbum5ld9CNxnwX1uAhft5PTBKSV
mOuQE8hxpF19FrdizkVxshnuXyrw3o7nt2vMzlCR6+OQq5znhxyrs3DqYbDa
hv1KYp25kf6B3wr8DWQ7BxeH/I3eagbP42so4rmrhkH0SKFzTZw7Rj6fxrw3
wvuw5qrcd4d2yL5ynyFx4V7NWNRrUm1l6OXI4RrHSz1U75+vd3/i6Cb0y9gO
I7X4ugPZjmzJ9Bgn+f2pqPsW57QLE8l6hI9mVzOqWRXHxfWOgM+OZiibWevn
fCDN32/m/DWYTMl0zov7Xcn+8Gdr8DcUNFuE7z3gd07zE/FclNMifP1MPlnc
HdRyxvbfgOs5/PYTd9eT/EqwrxqrfUY1q8L/W/RE3O3lowl9Ydy5Jb42ovdi
80quz49mfWmF38nmc2I9EHe8tUMeRF9W57tVO3Yz/E1h5xnSB47fI+1JPGS/
Ouo7VbtVO0277aq+L0g6tWQgf0x37jZhvx48XypxrquHnfRyScB3qfB9Hf/v
hZ3vyjk01XeIdkkb/JgEFiWcf8h1vC/Dt3ervfa9nN9B7w64rt+erPAdKby0
Q+4jl6F857Y4LW5/WOxn9bCLXqZUODaa0Vep78V8x149uEr8c+T4OzKeGvOQ
xcl9LA4tp79XYv7t0DdoGD1W6LXpmzEXf2lxx2I3+N6APhhzbogjF8Crpca5
OBefS/F9qdB99d8ELyf7jhUewuADsOqMezx9s4qpZ3TcfWsnazcHmZG1Sf4F
8DdjsvuSzyv4Xljl2ArzRvThIsdWmBwBj5Yq547utYtmFDi3xXHtopJa960Y
YfQlIc9deGhXbMBma7r/T6H/LfaDwT5kJ33ahfwSda6LwylB/6aKD/ofYBZv
eyp9V4gz31T6DtUu1TcySu/+A1V7YOA=
                "]], PolygonBox[CompressedData["
1:eJw1k0tsjGEUhl/jb2dGpaaEMUxr/naG6bSTqokptZCqDUsJXZRICCNoy4JE
bAgJFizKjkZdFyQIqtQ9JFVG3NsuWVhoOiIRisTl+fL9Fk/O6T/n8p5zvrrr
Ola0+yTNhSKYl5Lq4ftsKcLfdfjnEtJZKE1LAxOlMuyTpNQPPVliJ0u92IAr
+aGvRpoyQbo9R1raKD2fKjVjn1EzDxeJvQB9MEbuTXK2I2AbXIbiSdIl7AIY
KJUWYl/MlF7C0ZjUCcfmSyvJ7cQG0OiHYpiG5hw9DqL3AFylxzfirmN7XOtf
y9pepudjZngEo/iz6DuC7a6QTsJ95ggw70Ns0LX+A/yfzPULrnhaS6LSVmq0
QR5t3Y7kI+402s6Ar15KEOdg3xPzwYs1ORvQMoymHDZCzf3kHqLGJ2YZgXZ2
/Zm+bdg7zHM3YfNNncV8G+Y3p1Kqos+7kLQ+I7n4lXCE/H0l0mHsMjQuh/IG
KQoxcnZw8HvUm07fMLwi7hTxb1J212bncWYMB6Wd5Pa69tY3vPuZO4bR2oLm
IXb+u1r6A7vw1/ItyW8Ras2A8/RZQ7+v1BglrwBxNNZSL4ldwm6aYRE0QpD9
DzLPJub54tp3F0rbW5mbObVW1yrq+vDHwxB9BuFvHO086rf4GTTkmKkBfwxd
P6Dg3boiat+wecspNFRDU9RqqsEvY5YQdHg3iLOzW//fbNa+L/POzF7Nfvey
rzxvvYm3/pR+XfTdTX+H3RZBF99OwHHoR5+fGffE7M5f803UGpewezD72Jix
N/1YbvNNndY6aTP/E6uxVegpoGtL2uo0ev8BPFGX8g==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlmdslWUUx08HUGS3IsWue7tuuVDba70dty1BcCAJahQHWzCGUrQKllKG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                "]], PolygonBox[CompressedData["
1:eJwtlmtM1XUYxx8BBYUyUQrG7Zwj5xw4gB1yBxAOzgmrxoZr5Vw3MSinxUZl
hLhqy5axtbSLl2lr1Vq+KcsixVzClgZtKqOJSVkvelGtyAq6LDJrfb57zotn
e87/uX2f6+8EOx+8tTvNzHZCGdCTAbPtMBfnm03EzNY2mPVcbbYM2YFCsx0R
s6ehJcjyoJYas2bou2Kz76G8OmRQMGQWgoL4W5dtNpVlNl5mNlli9sACs74c
s0erzO7F52J8jxIv93q+QVuIh5kFo2bZ1WZJZHfPNfs1aDYWcd02fC5CaUHM
/R/m2zfEDxI7AGWXmuVAm5uImW92W6bZ20vNtmE/gG47NhXYp4G9E9/XzDNL
h79SCx4APQ/Gv8E6CMZ++GZ0jhO/nG9RqI24a6Ap/N9eQE7k9wN8IfjXgr+T
Gk6S70zQsctHHrn8hM4dBY6nl6L+G3Fd2RRjW7LC7PwSs9brzEbI5xUw3phr
1oG8BfkkMd/I9h7NCZutrHasyiGDek+n4qlmi5B1Ee8r8v8aOkT+TxR6beVv
Fb0tJt4X+R6zFP4o9quxr8H+SK33QPrPEHMfsdv58TCxp8n3RX6fafTcVWPV
ejBlrx5/QO1aGrxf6vFThZ6TcqvD32gF38nhXJrn+FDC7Dd0DqJbi3wE+Z/4
+wOaiSODdqPzErQX2gedQnZTqn8TxNu03GMlF4IHviDqs/wW/p4F+zg6B5m9
bvBdpI89CZ9vYXgEvgOde6BR+vIptCvs/mXzGbatCa+d9G+G3xXzWqgm67Eb
ouffZnl+s8xfBvm/nOc970O2gR69ib9L+Oio8xpIVzYnkF/h9y38ph12F/HH
I+57B992EytKzAhUBoWhv0q9VrJX7P6g75bq310ONmamBn4IH7/An0HnNJQP
1oKA74RmUTNwP/37Mub10nxtV68Tvvuq0Rb4/tS8biRmHN051CROvDvR6S3i
DpT7PGqHssh1Q53nuxD/7ySpLb9bF/u3duSHki7TjGpWC4kZYxYqoGLidS/3
XlZea/YJtSzgWz6UJFZTke+4dn2aWZ2p9ZyU23pwtkMri9yXfAYSriNdzZRm
a7jSLDPH6/MRs9JDsmevMttPz9KJl6z22dJ+pYN3VZHfskr8hRLuU751fzZF
/AbqFt4H7o1QYwq/ZrIefi4+12X6TMyD70vdo2p8LAV3c9ixCNOJSr8R6o8w
bV3mO6BdOIrtIFQKppKQ31zd3oEq313t4BHyey/us6Df78IXxfz2KeYUOLvJ
rxm+F3lZyGusWmv+usA7VuW7oh04ib+0kNdCPW7AtjTgtVBNxpirZuqzGjoH
PwENx71+sh+Cj9R4LMWMwu/BfnfAd1q7rZqr9i8A4Hw9MxT1WdTN+xzsjUWO
TRhPonss6LdZ9/UYfT1e6/nr24dBv5naV70pPfA/x11XN3Iq7jdEt2Q/sgPQ
azW+m5rPV+FviPmsa+Zn6VV93Gf9dzA+RvxYwnunem5F3hXxWdCbpLdPN0b1
u4zOMNjejzs2YRyIew7KRTOSi6/5Qe+/dvZj+h/nd02O/zZ2a7bC3z7d1Ex8
X4h4PXQz/kP2eonryia9KvUGh/xN1NsYXuH3RjN4mN3fyb19DrqMn3+gkaBj
FebHy/2N11uvnqq3ekP0llwgaABffQm/hboP2+DXNHnvtONt8JtT9dCOaLfP
lvmsqD56u/fG/G3RG3MK3R+b3LfeVL2te2J++3QDTyO/FPNbrhtVXeI3QLdA
N023LZy6jfpPov8m/wM7BUcM
                "]], PolygonBox[CompressedData["
1:eJwtkk1IlFEUht8R8wdFIjHND+cnaz7HUWYGycVgq9ZqiKCpaYVB/jAu/MG9
qSC1yAyMNpWa1dIwQRvbpG7aZLlxOxO4CHGZmtBzvbN4OJd7zj33ve+5gQdD
LYksSVVwATyutJcvdUWkJ470FCr9Uu0lKXxDCoILDoTY8xEbYtJN+ByXVuHd
dfbosca6nPyPi1JrnVTG+gos03uyiDriIixBjpf7YbaaXIE0R4wEpGghmmqk
Nnq2w05Q2oYeNE1R94K6KDxkHSE+JjcJaXqmoB8N6RJpkPjzmrQLIc52U+81
59DVC5XoCpv3kMvlnhyYYf2RukPTF20TkKZunLoU8Rv6jlkn66URGIUxtI6j
eZrcMKaOQN5VqbhYOiNfgE+FcIrGE6hAYyteJPD5VYN0C982udvLGR80cXcj
BL12Ls2s+ziT4MyjiNVp9M6zf5QnHfC+e+i+77d+Gd+y0RRDUxRNQ8w3Af2Z
Hs8cOzszw7Y6O6v9Cu6i31ve/ovocncVLFO7j5edcdvD9HpJn3noiNtcF3Hd
sZ4PsF6h5pNr32zenmTPvSx9iVu/jG9f4QQft9D3O+OvJ2DnZ+Zozps+7zP/
5oNjfT33Nyr9YW+UuBHGC965GbazMjM7DuEf7/gbsv/L/LPX3HGHOxaIz/Fp
zm//oPmL3/0294ZcN/O5C6Xs3abHP3r8BwXcfIk=
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlm1M1XUUx0+AgsggyQf0Xu7lXi9/Hrx3wOqC93JJS7fUF7GlWy5JK9Ny
mvTCW9Z60kzXi1ZOM0WWZCa17EUiUkm5KSSBtIghylrLyMrcJNvcavaiz+n8
Xtydw+9/ft9zzvc8/Ag91vzA5gwR6eGXya86JHIxS2RlqcgBn8jIDJEVSZF+
T6R3isjeSpGsAPbo29G/ny5yoUhk6R0iN7mbj7xRKzJRa/pfyEtFZqc2voTp
fuSPxSJf4TwLnOGIyLUckUV+kTVVYII/uUwkGCYo7h9MEdOdIqexv8y9xTWm
l8ZF8tDXTxLJwfZ0VGRTrsiz5SJ7+LaTXPaWiLxVYvq9CfOnfn8A5w1ynIOL
2/B1Hb9t+SJ/IneQ4zVsTs0TaXE4itGMHUfSzr2znvHwNnir+JYoJEdsZ/Mr
R5+DXIS/bWDuAzOIPkzuxchvyPcq+fYhx7n/N3oWnJdxpwlfczVmzndMFXkT
udvpqzkP1YmE4TJMvpPI/UKeyPyYyAx+/eg3qMN0pxcirzv8bPAnB6yO/1SI
TANrOb4GyeNLn+U+QZxL4pbLMpXYPIXf+8Doha8uOAkQfyN/N3N+P3KAeI7i
awju224Xic0SeRW78bhxqFwOR83mLLF1Rwzna2LI4P5ycIrx0+P4fImz31zM
mcR8grut3O1CpqtFNlLfLdT3HH5HOW8gx/n0Rj++65F3cbcTnAni7SPWI9h8
y92fXL/lat+6eDT2D7Te5N5eZf2t/ChPe+jFdIHIugarn9bxHvAuo7eiHyW/
gOuHn7VGnvWSh/4yfK7FZim2E+Tch6+pMesVzfEctoXcL4XnM8zXULHFnyD+
mxUWQx82J7jbwt3jxNvpcm8m9wJXu0ZsniS+KJwP1IMbsXP9/ppnPFRX2oyO
uDkdxdcxzps86znlWfnOjVmcecgjxAacpMmvc57V8RU4aUnZPLamzKf2s9Z6
mstlFvKTlPlZU2f5aF75OhMBm+sRfP1OzA/OFvkDuT9u/B+Gq0Cl7QHdBx/P
NR+a32Y3p7c867ER/K7IJmc3Rw1+w1LMqw22O9RXKZglCbM9Bl4iZvOic9MB
pwfRT8Jx0p1nhG336Q6sCtnu0NlvI8ZfXN2vxC1PzbcA+W+F8bnasx2ku+gK
NVrl2bl+/zxkPXwSn6+DH2LZnkJfWGrcKsdBN9eBOqur1jEf/w/D4UPoiaT1
lvKwmHxfwMcSfPWCPRgxmyD2edisZKbyK23mtb4biH2mm4udnvWcxl/vN16U
n43wdsD1+b64caccTimzemr/6Dw0e7aj6sF4z9VOZ6gMTuN895BjRbb3FVfr
rTg54HRHrYefLrcdpzhbwesos377gjqPF9tu131/y82U7mnNU/NN11qddc9o
LxTiu5EY1vosf+VhHXebkpaL5rQgYXOq8/qrw9c3JO38vkMez/NbBieHwHjO
6VuRXeBEZlK7pM2ScriLuHb7DFPfhMNuh7TGjcf/+405+DBuPaM7o4P5zYaf
PL/FHnV78rg7/7TaOFVOHiF+Kbc+1DdZ+VLedAfUx2zv6f7LdW/ZeeqfGbbz
FN8XgDPA2303cqHTXyTeDW5X6GxpjXSO9D3WXaw7WXe8vp86F9qj292+0t2c
jtrZaMBqoLXoCVlfKuePa185G+3xdLlh6ZvcnbS50Lf63Rrro0M1tlO0/9vh
6YkG67H1yIv4fZ8eHkN+5LMaaY+cCdk+HwTzfNR03fGbksazzugWx9UzUfs/
QGPoQX+Uuu4Cc3+l5T3m+vMzV9+g33p2zP2/MuT+J/kuYm+J1l1naFuJxXYJ
/T98gHHE
                "]], PolygonBox[CompressedData["
1:eJwtlEtsFFQUhn9KUYptteUhdR7O1HZoxxlqbSZkKANKTagbjYJKpKCoRYpo
VyUuMMaIuCYmYoAQTAhVgwvjgwTRJogBeZgAgaoQgjYYoLo0aoiP7+fM4k/O
vefec/7zzD43/PgrNZIGQS1IlqUzs6Rz4N92KcX5LHLhTmmoIjWUpHpQTkoL
Qet9Uhb8M4/34FROWo6hRxul5i7ptby0GSzjbT94oCj9WC+Ng6mt0onesF0E
J5G/yEo70W2cIW3qkC6mpK8huPw2qQY7uYy0CnlyunS6TRqFyyT6Xfj7APlg
QsLMzfPGhVIFn9d429EstaA/XZD2YX/sdulPdENw/Av9vfzZxt8L+PsJPNEj
PQmmENNd6F7G58P4/69Tegx5fx0x8O4hctQHDmHgK7CdN2+jP4K+Ni1dIYZ1
07CJz6XE3pcM7o5hNm+ntUY+zoMy+u/htxd5bQP20PXD73li+RZ7x8nt7/z5
DRSxPR+0ZIKPYzxBPo61hew7c/0mG/Ha3g3sH8uFLdt8nXg34e8lcp2dKo0g
j6dDdg0+LUQNXIsdnD/D1mz85chlO2gin41wWYmvAWo+jO0kdwlQ6ZYWgxe4
e7o2aniJfA32xHmM86+cb3RHLczxLP6S2E+AFDbSYE4maueYviO2/YukFbeS
s7nSBvqxNxlczGkm71PwSYLr2J4E13jzVIu05w7iKkcOnAvn+HA2/viv67kK
rmP0cj18+qnZZmLfV4peck/tRb6lJ2y9Cf+dqbDpszllkH9ORWyOcTVvP7qH
2s6NmUqgH4TPCPbPcfci8peFyLdrcAh5XSV0/uO/o9R/S9X/h9Srjn48D9dh
ct5LbnaVQr8VfzuQ/+6M+noGm9C/y90bVf07yA+W4+x+X4L8zAL6emZw2k0t
nu2JWjqGCWJZk4vcuJ/ca01dMdu2f5R6LMvHbHhGtvF2K/i8Lvrbs7qnFL7N
8X3kpeU4m0NfOWbAb/3nLf6OJoKb9QPM7yP5iNUxd6Sj5q69OX9ML9S0xux4
hrxbrlTr5Z0wgfxqLuJxjzZg6wc4j4NuuN0PmslnE1hNXGvAJ4Xodff8CPU/
UgjZNTqMvL0UtXA87yEn+ZPoCpu2vagYu8097d72jrHsu95izIRnwzvGu6ZS
fW/+3gXeud697in32i/5yId31ARympwdqImdfDdyeylq5RjnlWJnuL89T2fg
e7ItZs/9eAp5iHysz8WMeda8c717PSNXye1Atd6eCc96YyZq7Z76ozNmMlWd
cc/6lHzsZvu4TDxHc7H7vAPX8vd//LH13A==
                "]], PolygonBox[CompressedData["
1:eJwtlE1IlFEUht+0yHRmTMsh/JlxBk2ZmvwmHccZo6ysHDdCVgSRQW6KSFdB
WgZB4LKiRWGGQW0LtNLCRKEWoRa1SMxtUZCVPxG0UXpu91s8nDPn3vOec8+9
34ROdx7uyJBUB+ug1JFm1+JUSiH8MFzC74a326WHHmkauxiQFmAYv5/YU+w7
sweWQtIksc1R6WWxNAp3d6G5RerDfmHPZ9jH+hz79mK9QckDS7WSbxPa2NUK
aQUWq6T7PmmsiLjr/8LuL5caIT9q6xVEbU+mt0ZqFlKyg5wi9hZDIMF50A4l
bK3/Ncl5Q+5CyPZuztBE7iHoIXeqQNqTknanrN+APYDWQciNS+X51MfWxqQE
+PAnNzLParTxvXEbN+v11XbtQ4kURL/ML42g9wj/MQyUSs3odZHThX43ZHL+
DEhHpPM5UpI9x9A5CoXsq2S/v9T2Y/pqJpYkdoJYG79PQhb5MxukU/jL7nz/
cN5l7va3i/GHU7an59id5Megd6v0jNwa6vuZW4GZYdjOMZiwPZpej5Dzkfm0
YufY+4Ber5KfR+18GHHfyQvqTjHjaUiT185dNmHHqTMBce6uBi7G7Sy6sfXo
dKLXErGzMDMx8zJzy3HvLxvb776xYNj2afrdgVYUPrk9zWKryIvnShUx+zbN
G70H/TBEn33oDWLnuafv4CXnOLkerIc968kdcux+kze2DQ0YhXk+pgbeZNq9
h6a4PY85Vybxv1m8XXR+wE94X0YOsQB+MZRE7GzMjAYdW+uJY2djZtTGLK7R
yw321XHmGXpNRe33ZL6r6xG7fhP7Fe1vLsa/Q6yXtdumDjqt+Gvwz6B7Fq7g
v+auX+Ffxu+BVb6BFRhgVhfo5RbnTUES2om3cH953F8evz2sjzv2v8L8Z3TC
uWzyHKthtP4Be5isYw==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1lW1M1XUUx0+hlsjDQMCa916vcHm6gEB0QS6gUKyHtbVlC0zLNpw2c5O1
1htLttZCWy9qq81SU1sPVi/aWqx0iqIxFUeEhEWPL0Kny8olOWdt1ufb+fXi
v9/vnnsev+d7zm9xT++KTTea2SG+DL7muNm6WdzLzTYVmbXfYvbWfLPOUrOs
uWaXas0+ipiNo7uIM3uRWSOGsSZ+88XRLeIsTJmV55sVcD5TYTaMfh76R0pd
vxKdB9NmLxFrMz5zsbu2wGztbLO64L+g0izCf7/eTHxkl2Nm2zLNbq0xe7zN
bJLc1nHOaTDbQm7X8f0qegPYXl9oNlRm9jnye/ExWOX5q46JarP8OciKzUYq
3OeVOmqv8fizkce5v4j8S/7fgJ+V5BkFm/3kHM81m0G/mO9ADr85n0uCDXlO
J6gfvS70u8grinwIgMeRl4LnNXIuw74cnTXo9OE7Enf/ijOV8HpV93nux7F9
GR8Lm81W3GT2YYnZWXKapMal5PhK0mtUrUW17vMp7pm1Lj/KfQc96KYXuzjT
ob+vIf8YHI7h500wewz9jdSyhvOTOsdklDivY9OF7XbO9/lWc9+Xcm6IF/U3
gONis71ZxKt23sh/C3F+r3OsKuvNPgi2E8gvNToHxB31Sf3qrfA8lE9WxOtU
vevp745Ws5/EUeSzYo7JdupuD5xUb4WrOCRsxRvxJwY+59AbR78Ku2nu++aZ
/Zx0joqru/B9Nsj7yS0V5As4T4D/BXqRByZj/H4b+RDc+KLV6y9q8fmQXFhM
hVhLiHWs2jEZ5rwd+Xr834b/A+DeCz4Pc59p9Jy30tu9nLvnO//kSz7F0TNR
6sZna4P/vydgLt6o1+r5SJPLD5LbE8SaApMc+nAu4ZwUN++q9bjL4G8hsR/i
/kiZz9zeEFf8FH7i1vK0294D5vHQlwl69C35DJLP3eTzR6XjM5zwT/eryFLU
/6Pmjp7vjPpsakaPhnm8iE4y6TyfxO7RQnIp9HqnQ85b+f90wmssI9+xCp/H
LHp6pNjxVx8G2tx2BAyvRhyb02D+fchzGdzrCfO7lJp+qXT+ZMQc9//wx8fx
kL9qEga5AZNYym01oz8knNuaoYa0Y9iN70TYFTP4/Cb06x/8HA71ahaFnTA8
TG7Z+EwwCzmcb4T5OoHPbW3O4/42z1VxHwC3Q9jshksHOX8LHMuA+x2B//vh
/+aUYy7sZ8LcXYZfGyOuM4DOqrhzQBzMS3n+4sKf5Hof/JzhHPw/FjPdCT5/
F5h9zSx+Os/9a1+n0r7fOskts8ZnTW9CR41zR/tJ8ymctcN6i7xf6k058h58
LSHuk8x+NzunBHyWE+svYnVwXgn55MR9/wpbYaxeqqcRcn8h6fnE4fnawPls
7i01HkdcEEelPxX1N0M7Tftes6QefYV8tNrfJr1Ro+Et+Kza8RJuwjg/7PDz
6BeEXouP75DHKnr3Xsp3k3ZUbcTfM+G0h/wvRN1WPrQX1Dv1sCzs//4yf4fE
/THi1od5OAUO+eVe13dJ31+y3cB9ssSxam/2PaV9leY8E94OzdbTgW/a8atD
37UDtMvE8zR5noz7u7BT+Rf7HjjV5LtDcYXrnYEDd3BmBRwuUlNTk+9wvecj
CeeD3r0t6DxL7/qSvpN6Q9/1pmqe2sDv/gbXF4/0Zms/RPD/PDZ92K6M+/yo
RycTHk9x9ZZWNTm39baMxx3/d1P+3mg255J7R4NzWzP6L7SvW8Y=
                "]], PolygonBox[CompressedData["
1:eJw1lNtvFFQQxj9pq9ACC21oSdhdVuzFLi1QN8vSbeslIQFeVEikoNggUAia
UI0PGsLdKBgTL/hmjGj8E2gbDbdGCbZImhZKLBcheIkNmgAaH3xRf5+zPnzJ
nHPmzHzzzZzz4Ja+dbumSdoGysE3BemTGqntPqmjVZqTkRLgqUbpaXA4K92Z
LvXh/Cz7NfhUg7tp6R74lvufcb/6fulii1TRJjUmpK0VUjt+4y0R2z72TbZL
e2dI6x6QFmCfZ+9Tzv6qk452St+npOtgGnnLwMKkNAbPDDG/KErD9dJJClgP
nxHs88R4fl7kP71Iam4LX99Zxt1uangG36ZqaV5e+n15nC8voy7sFXCcUHA2
9/fIeY74X8PxfexME5ywB6uofbFUhEM72EbcXjBM/k3kP0uMC9S6Jh/+1us5
9Bou6esaT8JvJzHHiD+Jz4vYSfxPsd6Afxr7ZWL2gQ5ydIKeHPXlIqdzj6LR
4/OlXbXSGeIdIsa+quBcTj/qOrjP2THyjZD7z2XSkUrpK2uIHqMtoZU5m3s3
HPdURY9/Rs+3uugF8RuI8SX5ZqLP25WhZyV2bUfkdg7nupSKfljjJ+A5qylq
e2m29O4C7hO/Hu2niH+O+CPWDOzn7AAoJuPMPrOo/3hXaGl+/dhLuL8Ffr/h
c5n7JxZFbdbU2qZbg5s5ZrBX0MMCGIfXRfDKw2gKBtBhEKzMxeyY82XO1+ZC
e/fgCuvVydDCmuxF2x/Yu5WKHrgX7rl7f4O9m+DX5pgV638bezV3VoEP8DkK
6vIxe9ZnLvZG58tFTMc+TI2JmtD8CPbMZPTKPTsO3yH6dQa8Rg2vg0fQY3tJ
j0n0mKgP23s58q4v1ed6rhG/gr3ybLwpvy3PlGdrM34vgCH0/LwmZsqz5Tfk
+fDeKPr2wmmCs344fQi37V3xdr23A3sONSXyobm1X5kMPu5ZI3m7WuMvcL/8
10ymgps5Pkn+n1j/mApNrE0OnxueVfzz2D1LY5Y8U9VN8ef47+lHkwEwyJsc
AAfYO5iOnrv37cQq5qJH7pU1sBYbM/E2/UbfZL2p9D94Hr7DbwY5ell3k7OB
3GXp6K3f2Bv438XnDqjFrgMJMDsbb9Zv9+PO4O4aPsJ+aGnEcszr9OpVfHqw
h4g5RZyr2ajtvz8hGz1xb6yJtfkHPn+DU7yV0+DRYvD3jD6GPVYfsRxzHDtd
iL/NHBZiH6Ped0r17qZPxUKc2aeAXdGANuAXck+B5v/v8x8uLsSf7L/ZM/oH
/+VI6b/zn9tGvn8BZ6X5dQ==
                "]], PolygonBox[CompressedData["
1:eJwtk0tIlFEYhl90vFTTKDrkotQZc5zUYgL7F9MmM6HChdKiEYOEAdsMaC5M
F2HWQqpFZIh2Q8TKy97xgpfEC9kmJMK9puhOySRQ0J7DmcXDd/5zzvd+l/P9
/mjTncYkSSWQAmOXpTg0XZBG+T59Tmpj3QqLF6V+tzTjl7Zx2ILkgLSCwCbr
Wc7n8Wnh7lfWc9BxVnoCt0PSwgnuFElvoAuK8ImekoLYLp/0GirC0qFXqsR+
4/tulvTWkQbw/2Q0EjnMY18Q+yXUcq8dnWfoLKK7BI+C5AG9jtV4h83h/Ax0
cn7fRVz80riTCgG0Ix6pmVyvlklh8OBTiK+be934NOATZn0TjVtQTo4H5HoN
m4dGftDGNjm0c/6YnCLcr+G7Gjysq9j7Wyytnrd13sC3h9i98IPYk+RQQP+P
0DqGiVLi07dy6oyzHiu1d43P9UT8X2h5yTVIrjnYDMiEvTx6dJKzS1IWZEMZ
eT0ghyvYnVxpF7Zgjjd0s+eBDPOukAS55FxL3VHyXyfmGgyiXUesFZ/tv3mH
Kd6jz8wG9kvi/LNj38C8xV6xrX0fu4zWd+jEf4i938RxoZESsD00vVwvsWcb
2DiaozAOz6nnD3X9Q2c7nRkpJF90Mn12PsycfCRuhPjL7H1IrN87dr7MnP2E
e+wNO7YeU9creh+j9/UhOw9mLqb8tqZp4j5kppthlnszsBOy7xLj/3hKPh0w
5FjdEex/KwGIwg==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlX1o1WUUxw+tOaNNl2tauav37t67u91Zd2utn14bRSmV3d4GUU1TtzIo
a9k/Fkg5kDYpErIgQtBhxOoPK8jcxtoyo3Ji02xFUhINZVIG1VZmJvX5ch7Y
OM99nvPyPd/z8kt0PNXaeZGZ9fFfxH9/jdlC5PPzzTrKzPbPNjtdYnZb1mzg
ErPXeN+/yGxXqdkIcneF2Y1XmE2iszFj9jc6bzWb/cf5DvyM4ed2bFovNiuL
mw1icy06L6XNKq42W0TQqQVm5zivJd4/yLEbeJtBnGqzkzGz8XKz9iazHDa7
8fMVftKV6BK3j7h383YUnVbk8Zif7+X8YtpjfUrMFfw+wn2UN3sSPO9zX5nD
d63Z8mJySZBfg+vvrDLb2uL+e5C/4fMTSGqCg+1gO0/MQ5HZ+irPcYQc9+Qc
mzAeDz778bdsidl7l5q9Enc96YubPxZ47h+CbQg8B4h7Cz4uZF1/Q85tdN4B
n3cF/N+BpZQYm8DwTdJsONhO1pF33DFMYHsMvSEwL240KwRbcTBS7XU9tMTf
pFOO/++xnwO2qMp/6/5yZDv+9+C/Ap9rmrwWHci98JK80uwD5Bix3kHnJ3zs
qzcrpjcGkDMSfu7nvJCcf0DnJuIWqMEWcFZytwpfX+NzJXIU/Lu47yVWZ85z
VK7iXfyPp8xevsb9NIq/0JOvgvEMOZXO8trMxLbAuQT5NJzzZyXEej34/Bbe
ZuW8J9Wb/3K3CfvL6LnpOs/lHu7fzDmeL8C1sd57u424FcRtoy6puMeUveIW
pz2vbu675jufo/gZDj2vfjxf59wegbNu/HThZyvyM/Q6sX0A25/RuZX7X5Bt
cdfpQedk1nMXl9tCXmWcb8657d4ar4Hw38n5FPpvY3sa+XG1z5Rma+p6x6te
Hk86J+KmNvD8K9iS4XyG8xvNnrvmWzytDVxNhJ4/BsbPU85nKeexyHtMvTYd
8xqpVveFPSDuW7KOfzn99nuYBe2Dc/w+wM65QG8eDP2gOojnbXOda8WQn3yT
1127QHtg3lLfQ3ORG8KMzybO6tBjE2BZWek7S3qqjWo0BWfXLXX/c2JeY+W7
s9l5UkzlW07cAnyeRX80ch+KeSrl/N/P+wDzUMtcDCIzoT+3E2ddzntDva/8
xI/qoR0knE+gcxX5H2ZezjI3RVmfuxPgaQ9c9aKTIcYqMMzjrh5+M+SyGCwP
8/Yu+o8iD0aOd4j34YTvomdrfcfprP0kjKqlctNsyL96qifuOIU3GfZzX9pr
Lu6Uc2PKvwmjzHIUOYZ85PjkR7V9gf/N4HwQf0fDLlLvr+f+Ge6Xxb3P1GPq
tcfD/WNZ50u86ZszEmqkeYrTGwm4+7PB51+z8Eiz11gcTuKvi/Nz+Nmc9d0q
/Oov1UY10px9GXkPHEZuyfr+LNJc1/u3L57xfap77eaOsANVE/EwGfpBO1H3
a3j/Meb8r6vx76H8q76r877DtdfLwD8T/PvA/1G1+1CtesOeeQjd6QbP8S9k
AZtObFeojzI+a/rODOa937tbfM417yfq/LulPaNvrGZCs6H+/R86CT47
                "]], PolygonBox[CompressedData["
1:eJwtlVlslVUUhVeEirVIa7EDSi+305X7t+W23g720kZFiImSqEQjEUUpSuJU
cIgxMYo4gC/65IsxsQmJQUwcHppQU4GCmlLCUKXtizS+qFRDHJAYQEz8VvZ9
WMk55997n73XXmf/9QNb1w1eIWkrmA8meqW5BVLjEmm4X1qflgb5cLhUeiOR
jvZI//L92iulrxqkXdg3V8XZ393SnmapdZ50bKF0fZv0Hf678b+A/4stfMO/
BfzeLv0BOlnnQRfoBkeJN3BN5NDRRMysVElee/E/z/qeTKzXlkkVxH49Je0A
e7ukT8BMnTQN+vJSP5ghxjRIyL0F/JMNX8c4gd1Ly6U1JdIQ+Y61SjupeQ93
X6qV3mY9TM7z+XYXOTy1lJrrpVHwLH7PgZPEGIXAddR4P7mVktMdZcHXfvZV
N8Ib3z7m7Bfuv9whLYa73Yul49RbvVI6w323cN/xPimF/33Yfor/JvzT+C/j
7u2cvYX/Y9R4ujRi7sL2w67gdoj9BPst+HxWGjEcq5CP3Jzj9+RaT0/S4CS5
T4Iq+LgOpDhbBkqS8HWMH7EfT0ds3/E+d43Tnw30+1F6dBH7KWxOgdu4ZxV4
mvu/wHYCmydvkM4R+y/wDT34FlxqC9+X3WP0M93IekHU9M4KauoP7q0pa8s5
Otcm/JrBGPo6CLJwl4C5JLg1HyWcjzUEv9bQiaJNtqg5a+898hvhrkF8CtR2
pi7yfZB9JbGO9URvXKNrfQH758Ecdr+CnqWhx7WLpKty0tW5WPvsAHajDfE2
3NMJYs1mQ2v+/gPrRzLR23Hib4Gffe2hv5s4G2FdQ7zqXNzpu92TVLFn7p05
NbdTFcSC769bw9cx9teHhqwlc3CQXGqo6SFqO0T//yT/BP1lQTt1dID/WB8u
D3trsxy9LQKbrTXrtS24tM1F7D9AA5+XhSaOwN/OdHDv/v2E/QF6uBA+zuIz
xPrhQtjaZyPr2bqo3xqz1m4uBBc+G6DeJ6jvSFXobzP74UzMn1ewfy2JmeHZ
4Rpcy7xUvDW/ud/g91BrvGXzMYVubu2N3KyxKbS2LRe5eD/I+mxdcGOOaom/
AU5PVUQOzuWj4vvyDJuk1vXk84DfNefVoFAIW/tsxDeHzYp0zBzPni/R83Jm
6WXuy68Mzs2935zf3o4kanONP2PfSbx8Ie7wXZXk9251cGpuu4uzsgbUgttz
Ub/9V7HuxrcLrCaXNaCvEHqxxrcRbzt4NRMas9ZsY1vPTM/OO5N4G34j59lf
INex8tCAtdCUjrfieM8Q5158Jyuih+6lNe21z+4uzgTPBtfk2t5MYpZ5pu3L
xAzwLDBHI3C1KR/ads7O3TPcs9wzxrPm8eJ8M+fmvokaGsFpuJsFS9ri3+N/
0Dm0MVOcL+756t7ogXthTjtZ/w/GKBi7
                "]], PolygonBox[CompressedData["
1:eJwtkr9PU1EUx79BqoIWjCiUYE0ftrzaUmk0/Eg3jQaHF4dubVhEFyWBwOKk
FWPUxNE/wMRJnJtSf4CUIInGxIYyaKKLFAJhUoSufm7uGz7vnJx77rnfc85z
xqeyk02SYhCAYETKNkurUenPeekvZC9J1RPSj7A0in8dthLS62PSJjZ5VuqH
Av59YrPYDe7X4ciA5LVJrdhKn7QMwxnpG/VuUGcQfwjG8deJ1Xkjh5+Hd+S+
hRyaCtR9TN1n8BA/H7FnJucT76xAA60eZwfYgCM1H5eKSekyzV2JWT1G11O/
xhPsPOcB8krYWXp4BCPDktuBTuxH7i3BtTNSD/OZ5nOOXqIQ4v4YdVy0PEBH
Ad4MSnOwRuwVcyy70gvi5RbyyL9AfAA6yTkNp+A9C6jS9y+0/YQM55PU9cjf
Ib4NJ/HzxDqwDXr7iubulPQ5Ln2J27ma+e7S+yh5LRG7J7Ov72E7bw8/yf0E
rPNOhXfj+DHqRGHP7PEQ/aVsTVN7Py057dI/7G1yb0HQtbO4iX/gn0eYzxr5
NbjK2/fQcJfzNnLb4TkzvMgMFvrpF/0fHJtr7iwSe0k/FWyImXdBxt9Bstf+
W+Yfu5OwdScS9v8w/8lveqvR2xj+DLWmoYSmo2gqpu3ezf7L/p4P8+5/bipz
Fw==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlVts1FUQxr+qVKqC2IZC2i6wsN3e2y3bS0QazGp9MNp4iQZQQYox8VZQ
wQdjgiFGTcEnvD4o8UmCD2pEWwwSlbRGoaClkmDFaIJGE3kxppaLib8vcx5O
Znb+c74zl29ms4Nb7hq6TNJbnMs5TzVKN8+RDmWl25qlc3OlMznpLGcMxx3Y
XuB8WSF9lpeKN0ivVEsH+6SeXilfJXX1xn3j7KrnJP9R/C91ol8r/YecaQID
zDGwcx3xVn+dtGSZtO4K6WH8S9w/hD4HvHP4VF4lfdogNYK5+WqpBbkDv4/B
X4z+5lLpCIl0rpZ+A78fn7PICjDvAOcrfOcmvYQ+2RR5lS0BP8VzNCNdWCTd
XhNYY9Whv1QmfUt9NpDXv9nI33m9zLvl2YjT8T6J/SPs12FfSRzj3H+COv2Z
Cfs2vt/J2Y++gJy+w/4+enU3eK3SMDme5J1782G/QFwDNRGDY/ljuXRLOfY2
at8u/TxP+mFFfB9IMe+ujr4MlcX7A+mua99Fjiuxn2+LnL6+XtrbHr6HkSuw
n7hGqkfuTvjD7VE71+1KYv4xF/0qkeNjnNPE2UoN95DvRWr3BrKRHvfwXgty
wyppeqH0APKmojSxgByQj9bSG3j3ONgbk88+bK8lHONNNUZNXJtS4uRp3n+x
OXpnbh4oBN/M346OiKcannwAn/rQF5FLB33fRPx78lEb18h1PJWJePqL0QPX
fC0+9/N7Evt65O8px4VgPo/+BfoBfEYbgpP7u6O+xpssi5lxnOb1I+SDqvuK
kZO55R4VUjy7wOlKc+R5muiNPnlW/qb3t8Lhefbl3e3oDyE766K2zfg8l/j/
bD5mwPpfmeC06zOMrcTbx8hlCntpWeAMYh9YFXlVkcfxTPDfczmRdM9EK/Hk
mOtmZFvSG+Dg5nzk5fzuSXw+kYlauCY7ef8b3lpbKb2D7e7kY+4fTfi/gP92
d/js7Q4umpPHeGc5PTsOD2eZrUttwdlZ8q5Dn8Bei3x9ddTSc1+i1g/Oh1/I
fwoxp57XcmIoke9PvHUkFxz2DpgtBDfMkemm8DmD3JSP/eM9dDjNRWUm9o7z
+rAj+uM+epY8d9Ydt+fM8+aYsin+pW3x3XfsczLxeaYQ9osJp6Yt4nmPHXK+
LvJ13os7gic73ed8cK8M2yj3K8AcKcSu8W7ZzvdtLdKv5PJ0S3DLd41xKhe6
52BNmiPP8ScJc6opcK3btj7xf7AYO8hzsQ77Mwn/+2XBd8+ROX8wxTOf2EfS
bvR/xcZizLhnvQe+jTPjvcjP0z7xbjb/zEPP7mhf4HrPeafY7vmrT9w2380t
92KEWPbVR93cz6pUB+9aY3gmXXPX25wxJ25Ms7CmGL0aS/HPZOP7NP0ZIo6t
cGkr8tXa0Legj7GD3gVnHPk/qeYpjA==
                "]], PolygonBox[CompressedData["
1:eJwtlE1IlGEQx6cvcUtUFNtqNTLXzV1dVt0trbTAsnJ1222FSIrU9aNDaQSd
IjI6pBjd+rhVnoqiIAzUqFBiOyXGIl06FUSXjAgzTIJ+w7yHP8zzPvPMzH/m
P29p6nxycLWIxMBaENkjki4SeZ8v0hQWaQaz2O/4tou7Sz6RcZdIMlfkrEdk
rkTkMef4BpEVv8ibUpGxHJHR9SLzFcSpExleJTKTRxzs3/gvgqqASBCUbxPx
ggHiDoJ+0EEh2dTSg11fLFIHskMiLuAJEseJv7hVJEV9GeqjBOnELsQnkWsx
unk/RI40BKdxuIrtDlntymGI+1pi1IDenSJ9YNTxn+H+BvYItQ2DPt71g5oG
kbdr6MdG3mK3kPMIaAMx8MJnubrI0YT/pM9ipTgf5rw/bL3VHvfSv5Nh46oc
TmEnQBwkQTtYqjaup9fBF7uDeE+cfhdS13divoJrAT4L2G760+gy/yVmcYsa
I/BZcYvcxr7I++fO/LQXVzxWm9Y4wd0PZrMAyuDuBdf41k38HvL5AzZjza01
fCixGpNOD1qcHmgvoqAVNPE+wftm3nzlbRfnTp0zec+A+8z2HpiqEnkJLnus
d9rDcfw2o5lNoHI7mgETlcZVOWfBbzd39WC6HA7gL/wPZZnmlrHn/RZLZ5rB
fgbnpyCEbzX4VGG9Uk0V4/+n1M7awy1B05j2XzWdpr5/NablWo1P3QN7TQsZ
znH6kfbCg1xR+P4i30+/2fpttsQ4KBetWWu/22CzUU3dwc6jtlzQAvcoKODN
ILFvkiNCrhPO/FU/uqtjnB+ARmazD0w1mq/2YBK7lW/RgO2c7t4y/OZyjN8j
+H/z22x0Rq+J0+exXdedPxA2jWouzXmc+5GAaUX7eT1gGlQ96D+gnfsvxPsM
YthHQWXAtKMa+ui1mevs447WH5ZbLVpTWdB2UHdRd05375zPdvsYmigK2T9H
tasavuCzndTdbKMXMdDMm4Mgb4dIPvgPEWe8Jw==
                "]], PolygonBox[CompressedData["
1:eJwtkttLVFEUh39EF6ecC04jxVg544yOZ8ZmptATghbmBI0XLAiiKC8VBNEo
lD31F3R5qtfUeYugKHoop4giEIIuChWoFSlCL118rIeib7PPw8daZ5+112/t
tVZsZPRwaY2knbAOxhulBz4p7EiJeikJB3ZLb0LSx21SB34nNPP/1CYphf3B
+U9owc/ADXIMr5Vy3J1P8L9K6uW8CD1Q28Q5Gufwu4kpQIk75yGSlQ4FpM1Z
q2P03pP7Nfr78GcyUrlaehYjR0pagDKxU3CiXVqMSIPYIrkOgp/cRepcbZZC
6AbhNLrjnHXxL5eUsjCHv8TZxbR0IW39S9hj26XjEKiTfEHpcU6awJ+EPnR6
IeK9px9/lf+/wMlLbcSn8rZGU+ujnM0xjf1KPRUa/5a3LeEvQ4K6GuA7Zw/J
l8S/wmC++KXr2Dx17IK0lztPDRHu1cIL3vAcHJc8YWaB/cR5F+9YxLrE7oER
7+3D2Cn6U4azUWmAnofp4SDfQ+DEpUbytJFnC2x1rY7R29FC3cwgjv0ds34M
f5Y3zsEKMQU0vmGfkOspdKLXAYU6uw97HdtX09+JVulojXSr1caaO/upZYia
LlNbD3Mvgkt/Z5jvmajVMXpJdN+h/4c6/pHzL4xxd4y7N4mrsC/TcJXedLPg
FeL6yd8Hn73+rGf297lTs5H5Msu7+PfAB1WwAQbY55fs8u2o3bGT7VbLaPrJ
XQ0fGuysrjGrpridQ8a1+2D2YtSrq5S18ebepPf2V/V2h80uh+AO8z9CjQH8
IPwHPWWLag==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlF9M1mUUx09KApaGrkB6A+GN9+V9X/jx+saQREIWBBQLXG61ZY4iSIYL
3BqrNi8aXOTUCy9Q5wWhXtHc1GkXRXoRrbbGciv/bDln6drSjZLEP9Co/Hx3
fhe/nfM8v/Oc8z3f832e0u7B1waWmNkw31K+J9Nm27LMBuJm+6rMFnLMVsTM
Yimzdx4zK8P2RMweJXZTtVkv/jL8dvzOIrM5kry/kRgCcoi/wD8jZ9tK1jX8
4xvBH2OvKmPWnGt27hmzd9lvWm32HvZ51n9Q92rSrIG803lmLdhvy3w/l7Mz
/JvgbDs4D9SbLRaYjWKf4zuMn8FuB1s25d8m5vW4Yxb2l8l1npxbsKOsK9n/
j75qMo5TeLfX+P7H7F+nbh+cNJXQK18nfgf57hWbBfRbHXivqqv+m6qdE3Hz
alhLNX9NOv6pMu9BvnpdKDXrAtxPCTilXj+5GrBjYLjGcLZSJzfms5hn/w48
T7Ffhx8r8XkNgeerdWZ7l5tdIc9i6F/CPw6OT+nrJDUbiVsFth/A8lKJ95Vf
bvZGsdfaQc0/iRsnfgb7CDEvaI7E/5x0/yK2lX87Ofsl+XZFPOdZ/LshJ5HA
NSRswngi7RhOpR2fsH0PwQeZ07/wdgjbTD9fM9NjnLtJjRZq3cIGta6Tb+Cg
EP8juEpFzbLSPot64v+Cky+ISZJjd4lrqZde2lPO1S9ljk84f0+6bqSf2/iN
ocakNWlUGvgf7X8e814CeplLOf+ag7hTnvXMrqvO9XwULAn08yHYZuE+FnX/
2Vpfyy+P+vyUJ4c8R+Peb3fKdSa93cHeRw/Tj5sVUDc/cH9N4HdGtfrBuLna
tS2Nz4Z34RXyfVfpmDWHwqTr6gH188p91pr5i+HctSfuxGE2e+v4euA8SPmd
FOef1fv9Ua0+av0TalW51Zv6StDXXs4Mc3YPdrDCtSRN9YUznS/yOeue6G3Q
LJV/AzkqYx6vcyvXmh1BGwn6LU35TEd010LNa55PwEMHPOSl/c4Izzy4KqOu
DWlkkvUYvE3CRwczuvAUdxFbFbj2Lid8ZuJzvMbxCac0uCK8a4P8n4h5ft3R
1pAr6W5reF8+AHOm1jELezRwPz/p74JmIR3dYN1M779hfyzyeWluQ3D6JhiC
tL9B0sBExHnSW6L383Tc79pbzOdMqGHduVrWO4hr5Fxn2OP+iPemHvUGtIU6
13v5dNr5/CTu+ISzIuNr7YvvZMj5cNzfF3H+N3gfAte15xk=
                "]], PolygonBox[CompressedData["
1:eJwtk0tIFGAQx/+9fCRoUvTAtXZF13Xdh6uoVFLmiomRlUagENISFG5lRVH0
uOSt9db7UFonb0V1CLoZdTG6R1JU9LgkZAQqBf2m2cMf5vtm5j//mW++UGak
78RSSTvAcvCzUpri4nCJlIhKZQGpFIyDCZDh7nmxdJTgjqD0ttrjs8R34BsM
SwNgNb41IB302P85+LPN0nviR0ul49gzddK3ImkPMQXEVhNzCK6nxM+iZYzz
Fc4n8T+Gd45zDJ0L5PzCnqr2/C5ivsN1kZgLIFshHQPX2uhlhfRnnXQDe6FB
mgcP6eURmCXnB5im1mswGvbapiGOnm3UGC5x/ffxTVZ4fdM/tEWKVEnn4J9Y
KaVapd6w99JJzid4cwnpKmjcKDWB/ibpzSqpEI692A/Czm01Wqi3i7sCecxu
7O0Aek1zbsf+XOfcVmMnuftBP9gH+sA9euwsdk01aKtPuTY7R7CHm1279XAE
OxJ3/xD+xZB0Fo6DcA9Qo5zeU/DdYXZFnG9v4s22MvdlfteIb22tv+8gnMkk
M4Mvjj8HZwI7VSM1gDP1cIOZiPQOBPBVggzz7CV3Es3d1B5J+tuavuv5N7S3
PIXvNBgDObCeuA1gc6v3ex79Mfptj/ou2k7OVfoO2i7252dVGPTZ2c58YJZd
TT5bm3kaOx713bf83+TPh3w2NqMq9C6hZjd6y4l/Al9P2LVbD2X4noV9V21n
c1Gfmc3uL/O6ybxexXw2NqOX2LX5/bEe4vQynn8f+yN3sdPwdYAvaP0KYinv
1eIT2Ivc9Zb4jhwgrijof8H6e8HfuNXmte0P2F+IJ/2t7M0+4m8JeC/WUzN8
l+G4lP9D9pf+ATIhlCg=
                "]], PolygonBox[CompressedData["
1:eJwtkksrRHEYxp8hNS4xxt0MUa7DmEEoJUKyMWLHRsatKHLbsbEhY+ELiKVS
Zhbu+QbDxmWDpFzKYli5bvidzix+vf9z/u/zvJdzCv1TvZMxkgogDmZKpGlI
dUl9iZKNmO2WwknSZ6F0WybdgR2Bj/vfcvLI74fbIukGWtFMcNdAzjv32/HS
eZ4U4fwGf1VSZ7Jk8Uj76A7gyysN0MB2sfTN+Qfq0Y/j0+wyfQ3/IJpltLtE
L7nVkEd/TnCAO1b6yJcuqdOE9oJo4TkG5iukOZiFe4auRHvNLIEE6Zh6yU4p
BaqoN4zWS/0Ava1BeqmUBh7q9lN/3iG94P0MT5DK7lrIO2POMDzwrh2PR6Ib
n0HOxfgukLMIh3gdQCg6zw5+tfRYAyN1UptdGiJu0c8mnFRKG3yDI+IpuZto
Ih7Tw/Ay5jPmXKXGErXWXOZejf1eRXdhoY9ennvAhtaHhx+v0Wi9Fe5HeT8G
r2g60Fh510p+G4ToIwhZ0f8h023mGpquRnaeIXUTrez1x0oPfOdVCEAOOdmw
hM8e/0Mu53WHqfE1mrs1dvwPX8hjGQ==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlEtIlVEUhVdPMyVDpJeve0V/vervVezXNOnBFSsIApMGjcoeSpSBYIPC
UZOiCzWLZtGgBkWvgRUEQU2iF9mLoqJBEDUpelMU9u32Gfyec89Ze+21917H
9ODe/pHpkrbyzeAbSqTeUmkX68kK6RZnJaz5SJoolFoapSiWHhZLGdaFGWkS
TDuYH9xNQpatkpbVSOOzpD2d0mC5NBNMPxyVxOTnSq8apN2cs9UBzsf5tgCK
U+CzxM2TutGwCU6o1cefy2BuoCHPWSe47eBf1jqXcS6CO8v3CG1/0tK2xPW0
m56APwHHr1appkT6ybqK36fhfEcdm9kPgClNeQ0WuwKOkSb0g4nrpLfgzrC/
V+k6TM90sKms8x+FY4Sa0/SwIPHeWQ+fonEI/L4iaQfrHeKvwf88472zHr4g
bgk8G6l9MevtgLkPZjjE5tB2PvKeWG/GgrY2tPVFrq2Y2KvNntdm2BJ6ErOu
CRirozNxHuM7HOZbRWxznXMad9ImLadXHQC7inxvc53MeO2XiGsLM31NjULf
evrwLOP1WF2t3L/PeC03a31m1quOlOezvIfgWRu5T8wvA2EWZSmvxzT3cjYa
uWfMO3+rXdP+2Odnc8xxP7/RMYZ9EM5XR+5dy/W50mdm+h9zPxT8tjPxfJbX
vHA85W9hmPO7Ga/bfH2W3D3wX6l3TaZtNhwLYq/3YoX7zGo0XxxpcS/Noa8f
4VmH5k+s39Bzjn2ePN+rvIf2Psw35p9C1q7wjiz/WLnPq6ze34m9l4OR6zA9
17nf0O21WE3twcOW3+Zhc5mqdh/bfEebfAam8xQ808LsJthP8X6e4Jmlsf/+
HwvPG3hyaC5IueeM50LWNZm2Y2j4Gur60uj+trmbl3PhrX3g7Hfa/4c0wL8y
cc327nvCjMyP/wB8w6cn
                "]], PolygonBox[CompressedData["
1:eJwtkrtrk3EUhl/FgmmkAQcvNLVNbD/6VZO0SoxNo7Z4oYIg1IIODqLgUpM6
KwW7KXTwH7BuOjh4GQQHFdwUFYqik4pOCuKgCK0o8Xk5HZ6P8/s45z3XwtnZ
qdZaSXthHaz0SMtwaEg6DPur0hIOzS7pAPbWinQC+2FGWkikCXzG4Scxv6Bz
QMrAMv9W4OIOaRZObpNOwfVuKa/QO16Xsn3S0ax0G70j6N1sSIswUJQSmOff
FSigVYQy+UvwuV/6Ak20G66d+Bb2cIl6eS90SiPYGWoubJSOuTlyidi5Dmks
J1VHpGdoPKK/g9TwKZV2E/N2Q8T/pt5LvEezETNKPbtq6EJXr5SDj2nEWuMF
/b/h/TQT+daQ78NgaFmzXZC2lOLtGjdh361E7e7hDrO5n0T8PJrX6LefXNth
kNwpPE+jnlv4jOPbLkcu97i+GjP2rGewL0ALmnCDPIswkUSsNf5Rf7MWvTm+
hd3uDT3XsESuDtcHDeL2Qb0au/MOa9jf0tBz/1/TyDmzmtO5z6/6+4bOYb/s
iV175z/wv5rELfmmmt1xQ76lOr2PDUXP7t0z9+xL7GwnlKEC39GYzMbtTiYx
A/finrzrV2nU5hpfY08l4TvNZzoJDWs9pqEnsCcft+H5eNan+2IXnseDJHzs
6xv1rb5nv+/g7zDzhD9QzMV+NxN/mRjWrTPkm0vipn3b3ql3ey8fvo5ZIfY/
FfuAqg==
                "]], PolygonBox[CompressedData["
1:eJwtkU0rRGEYhu90BjOjmbIbRs6ZmOYwZ0YxEaNoxles+AMSzaQYKYoV2SpL
KxY2Imt/wB9APnaKtZKPMKJcp3PqXD3P+7zP+9z3+x5rrjK9XCMpBgHY7JA2
4A3OwtIHsQrfUN8uXdH8Sb7aKRlBKU2tQr4CA9T74bVFOmcvTz6VlCbhxZYm
mBc2pWirFIGUI102SEniYVY6gMWcVGyU9ukr+3kp53lyvS3AOnPKrid0qtDD
+RvmdBNP8HMKI+wX4QjteUPqY96vJV3Tl6HvLiXdw2hc4tNas+SgnwHb9/VD
fwzfTTDInDzUMaeA/gO1XdN7o3d0gmiGfG3Xg+N4Wllign0Ldjg/i5c052rR
OeaNxqgZ5AH468Ij3OLrAk9W3NN2PXxRT0TxRHxqkx6hYHpvUWL2nn/PXmpD
rIchRD7O/rPt/QP3Xyxxz5kIc9HbYr0N/8n1Sn4=
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtk8trU2EQxY+pFZuIj7qwaEpurvbCTcyrNCQ2MTVIs9GC1o2LLkRQEdJU
Xak7d7rwsRbqY+HC16Ir/wdBRUQEF634B7iwoCjY+hvmLsKZzDffnDNnvps/
vzQ/SEma4zfE71dBep2R/oA3StLPHdJ1cLgindgpbQP/lYm3Sv2GVOGsMyK9
mJAuhOCw9JzzY3VpalQ6FUj5rHRwF/eqUrUmNYlr4ExS0wF7kXSanhnqQzje
0PMuuXuB6/mNnuW2tGVMegJGocePia8UpW/UXAO/H5J+bJfK9PgYS23ymzm4
c665S89OxvO7mXcfNU/T0l+0vSdukX8HLh5AC+e3qf8QeP+r9D+Ojj5xD7wV
eY3VrmTdhyJ+rHL/GfFRzlOB86Xr7pdp2EDLpYLrNL13Cq5lJXK/z+x1H5uB
c81y3uD+JF5NgzU4PlFXBSeTeCMvDRp+dxE8mfiZpkeF/xPky+CA+7P06dd9
Zpt9P3rXEt8WCr4/478Y+g5sF03ybX6X0dMC18c93yVeSno+hOsRemaoGSL+
HPvsKXaxWXV/zCfbsWkzjUfgWEf/Te6Fo37XuN+Ou4fm5XTkvtm7Kybv7SXv
rRN5zdfY/TUu41xIvF1lprNJbPPZm7C4l/V5TP8DerSSPl9if8fWfwqeV0ls
2rtJ/X1qFbjWETgHvIk1eBeL/p3Y/pZtL4nnMfPtybnPY/SfC3yPzbr7bvm4
5NymwWY6TM05eoZwVvhOGnwvJfA/btiE1Q==
                "]], PolygonBox[CompressedData["
1:eJwlkssrxHEUxU+DxHjFgvKamfLD1DSGJjIeKVZ2FEuPIhbGnpUlUXYehSxs
KLLyH4iNR8pjwR/hsSCvz+3W79Tv+7vn3HvO/f6ik/ND2ZCkZpALVgJpGdQl
pXowHZMO86TesLSbkP7qpa6wn+8R7cHZBRsRaRPMpqUZsBCXFsEv/EEavxVx
Rr9O77MCeOjT8KvosV8odZRKLSnXmPYdfIC5dmm4QnpF34GXNTSroLBBCje4
B/MSK8c837fpvwUieIomvYf1Mo1pQ3zrgV8GfayafNSmwGet9AVivI9T59ES
fYrhF4F+3gcCz2hZLaNl7Qs8XwbBFV5yIu7HdnTD+brZa8bphNvCDu7IckSm
J7I9UX8EF8y+BJm478Z29MY5lfLdGP+c/AVpz2p3kp/2HlYzTluNNEGmwRLp
AH2GeQsJ373N/+EuugOvGScv6R7Nq+0khPcyOKUgQNcIfqLSN3howmeTe7B5
lqGV+mngu7Qet/TaSfhdmb8puCfUj8EIuUbj7tlqdqfZdvds3u0fqET/woxn
8MdMof8HlvNh/A==
                "]], PolygonBox[CompressedData["
1:eJwtkktPk1EQhl+IGGjRKmxMRHqxLVTSG+FLqzRKAu3GkIALLUshSEiaFt0R
/oC60DVNFFmwEmTpTraoXBYsrCYWfgELTDTlJs/J+RZPZr6ZOTPvme8EJyuP
ys2SQtACH3JS0w0pSiCckSLw74605pX+YpPdUgryUWkELielh1elpzelXzFp
pU36dkuq4f+EsYA00CE9cKRJaqdcjH+PWD+5UWqOOdOAPDNKzBrG7hDfxy/3
SfGIlICv1GzCNr0Hye1iE0ZnJ72wPr90zW81Gq33HTt/yLGX/B/kO04cnav0
+xixfpLYKbkzqIelw1ZpBg3T8AwWyP9pl+7S4zsztyDr6s9gP7GLdXDQPIuu
HGde8f0a+ruo8TEjLX3B34An5B9DocvOKuLXeqUfcJaSblN/gg2ypwC8pc9n
dIbwe9AShRgse6Trfrsbs6MX7OrA7AUdVcijr4y+95xbAi81Hmi4//QNNRPs
qQglx9ZXsF5qxy+hj7nt+Feg4P6bLGcWiVfBT7wbXuKTUoV38NzVMNdn+5r+
5s7m7kvu+3qXszs0u8yy0yN2O899ztn/Hn4a/ze7qPfaN2jeYixk/3MS/wIO
x2Qy
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtU8tqU1EUXSRWKSHaB5pSjb2JJmlSbm4SrJdaqxZRcdBJtWoF0SoWfGBo
C2rJWBDBx6TSBqqIDgT9gY4EX1ARdegD4sBvqAWLwbXcZ3A55+6z9tprv1Ln
q6PXIgDO8Yvy6/eAC+uAB1lgYqvZDumeBjrjQN0HztJ+dCMQCYD7xN8i/kYB
+JYHhmPAd57dOeBHKzBETCxjmLvEnqHvEfpeDoEFci1tADbtBNr4lTcDcwPA
cXIt0fch4x7oN57SduAU7dPkP8lzRwewnABGyPs3Rf0twIuMcejtJnkbjPGL
+t9uA17ybYIYMI8oNT0jZyh+apoh52lytvXQxoSLoXErX/HXqHMPMU2+TxL3
hgVrUO/zomFUmyp1rpJznDobvRarSV0f8ub7tAy8oo6flFDhWSFn13rgPX2v
u3trhVqpc5a+Pu0dTs++0HjFP9XHPAO7T7PGWxh/JW51HMhaXsrvYtreFsn9
mP+3mUfdMy5xvmacz3nDLyetH+pLkzntom+hk7WhrcZ8a9R/ifnNujp8pN9g
aLmked7J2sxodtZK1ouvvfbprv6ol+ppLrBeqqer5I54VuMv5JxyOtuljfYn
vBczll/C5RgnZoQ6YzznPcMrv+HQNEv7itMs7Wm+nSA+FVgMxYp6VnfVvFy2
GIr1ifYxz3zX6Dvu5m0/bS1F60uQtj7Jd7dvPVAvZsgf7zNfcdRdvocLNn+a
w3nf+ioe8b1zds3pPbdH2hXVSL5z5Fjca3XW7DzyrQ6T5BjM2m5qR68GVs9u
Nw+qk3irfBtj7j18z/nWd8246qu6LTDmQTfPf5K2G5pbzW+7m72c29GE2wXh
hNceaOel+UpgeyCcML8d5hjfS2XLtytvc6P5+b9PblY1g0NOf5L6/wGtlaH/

                "]], PolygonBox[CompressedData["
1:eJwtk81LVGEUxp/GTGyY6UNKwcI7o17w2vXOBDaOulCiooWR9rGIXNRUIEom
Qiitgwi0laADRVKLpEUfu7Z9LGxTm4gI2vg3mIto6nc4szjMee/7nHOe5znv
5K7PTtxOSRoidhP7uqR3TVJLRnrRJ9U6pMG0NNEizZSkcr80QLwKpddELpEu
Z6lplqqcV0LP7duddurpcSbr9ZW8tMz9EjEQ0YtI+LbYKLXtke7G0unI6z9A
6iT5CDMjaq+BqRUgWJT+8fvmiPSW2JX3O8OMgv1DzT343kfMowB40XvbjAL5
+26p1ODnj+QNYMbAtqL3CfM3j0rPmT9Kjx89UhqtnQfpc0jajzen4E65xtCU
Qfs49eeJCvkN4kLk3E3DRfJfXX6ep99VzrfyPmub2MCbEM7dREIUiKXAuZuG
bfDV2Hex2SpNDksnYtdjmk17FfwD8DvMm4XrDjU/m73HMncbcFqv378k/4am
hSbXtBf8OdMf+E5ttytl12qYr53Sd/Ajadc8hPYF5m/J38Ri7Du13dr5M9jp
xGcbhxnyx2AOZ7zGaqf6XZtxXg2cg3GxHaQCf2PWz97M3z731Lw1jsZ1PnEt
Vj9HfiVyb83j3+yulnNvzKPjzEuBOZt1PaZ9HQ+fDrvn5v1cr/czj74E7rF5
bZxs9209/lbszRzgv7Ba12//kbXY36C9xV7yY0QH8y4xr0K/h6Hv2HZtHtzE
q8bA35a9sTL3z4runfX8RJ+1+j7NowzcSqFjzY/JdvfEcvs2yN1/2yCE6g==

                "]], 
               PolygonBox[{{14128, 14127, 14126, 823, 7954}, {14114, 223, 
                15517, 15520, 15521}, {10809, 10808, 9872, 1123, 8244}, {9440,
                 9439, 10844, 2931, 8256}, {8196, 2880, 10711, 9790, 9791}, {
                12542, 1377, 9644, 12543, 12544}, {9904, 9903, 10839, 2930, 
                10841}, {7024, 3670, 12066, 9869, 9870}, {11564, 11563, 9643, 
                1376, 8699}, {10013, 2523, 13632, 8272, 8273}, {8255, 2930, 
                10840, 9439, 9440}, {9791, 9790, 10714, 2881, 8197}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtU89LVGEUPaXDEDraDxBEpfH5GJlXOhZOr1cOo/uash+LFrUowWIqs6JF
f4RCpGRBIBHZxgI3QtGuIFe1aFVRf0ILIciwzuF8i4/vvvvde+6959zXf3nm
zM2dAE7ztPDsjoE3eaCtCnwaAL4WgIUMWBoC9tJ+xHt7BIg7gfEUmOD50g7s
iIB7fPtFu0J7sgg0W4G+QWIdtv8O33NHHZ/Sbj8ArLXxnfe5BJilfZZ3IfiX
iLHMuG7WnSbmet49rOR47wcG9gEjrD9b4ekgPu+3eccr5nUJeLcLyDjLR+av
Mv4hZ6mlzh3kfYM5M8x90ANcD3aT9xxz2SZu0b9RBl4S70rkb/kX+H6N+ZPE
afKuVV3rXx8wesj8RL3kJdjy5ThPg5zUmTtBe5r2C9rnw+w1+saD/yd1WOzx
XLfZz3ti3SfOM+Icr5jbrOL5NUspdW31cCkxT5uBB9UQZpnxK8P2d8bW9nfB
ek8FTOmmOMU/ZR5C/9K8FGotj9FNLsq066nnFw/fU++B9D1C3e6GfZD+o8S9
yhmzxH2r1in6/vB7lf6/0j22xk+Y1xHsBnOzknkTf+pXGqvnzWPAyS7gQ6+1
kUbbnO/imN8fE+cHe3rF3jYiYwlTdYSjXGGd6DJfetOeaX8WuSeNsMPiRruj
OMXsiZ33nNx8S113KrI+qqXv6pB50L5LS/FZJ96FxBppN/WPqU/1u9UPfGb8
Qeblh82b+Jsvmp+txHsjHlqL1kBaRKkx1I+0/g8XLoqU
                "]], PolygonBox[CompressedData["
1:eJwtkk9LVAEUxQ+lxWDj6AhBjeE0TTPOwBuZYHw9QaWtlFG7EgOHIFEoMGjR
F3DnyibNlVjgP2wbKC7MCXTfKquv0GJoVoW/y32LA+++e+655573btZfPX55
QVIJdID/FWmrU3rUJ82FUlSTDhPSPM3JrDRVlp6CvzekNmjelo5BkJMq4Gfo
s6ZxZvNwZ7ukK2gvFaQPgbR/WdqkPwN/d0jaAQtF6TXYqEpvUz5/iqltelsx
x7gf4/4eO06Y/8ruo9iDeRljZ4neLZAekP71owP/OwZqgXs0r53ceQkMB94z
TuIOHqj/xLXNNiLpWlI6wHNvXnpH/SPpN/RQr8BPU9+/igf4xdB3m4cqe57n
/JbP1L/p3SWDEExnpGfgU9W1HzDfGuFd2fN+Qd73yHsN/S9xXnW0MmR0HYyS
xRj41u+zbTzscM+v0LOxjJp2e853W23ZmUfzahzjmqZp243r7LqI5kQ335r9
UcEzsSwskzf0U9zcSvrNq9TLkWuZx+68f1PTM85mxT2ZN8tskeeHWf+X7MZR
/q337GiAInsHwXjWb7f+E7I4B4GZaSQ=
                "]], PolygonBox[CompressedData["
1:eJwtkM0uA1EYhl//ixZBYmE0aYcq09JIyEhqqrZ2fmpBiNhIf7SZ6YK7kEhU
bHoJFnoHXIGF+7AiwcJzcmbx5P3mnPne7/1O5rJ90BqUNAsjcOtJN9AoSu0J
6RqNIKQO0amsNB1j6qe01E9Iybz0R98z9V3aehivRN7ej6NVzo/h3rHeTfzm
cpID/XnpBQqr0ntS8lAfPqh3fWnDlTbhnN4zqHO2PyPV0ADPkBlHzOsuSY+w
w/kK92X0lZxvWTvbZPiNc/6gF3jtkWWILD59W7BNTwlcWMAjQL9T0hccenZW
Fe3x79WwVMHzhO9TGF3jHaFI1k+yj1G77LU4yeOu2x3Nrh12jqATv22XHMvU
OXjAl1ZFjt3Z7F7xrccAHmX+CSBFf4P5Jep/mJg5pw==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtU01oE2EQfTXpxto01SYFoVmIqxbZsIndEJLURPHgUYpWRRCjFEE8VKXt
odri0Z+7eKlYBb001Yu3nhSxoB4KgnpQ8SJ4UfQgCkXRN7zvsMzs9828efNm
vm0TFw6f3wDgBL8Ev98+sNLD/xDYUwbaGWAv7eM88Jr3Ae1aPzDYB/ge8I/+
l6z8S0OKbzL+WwC843mqDnj83tL/yrM3WfnVLt3b/1w3Y4rAZBIYLwCZHcDu
QeBmA9hCP6Z/qyE7x3odxs+Q3+VeYCkShzLv5olZDYRX43l9GLDeTg+p5g9X
dyUlnM+8+5vX2TTjB3YC6xuBKfKfYs5x9rKL/i/2urVPeT9HlftghHmRcg0j
x/tkThyKZWm4MCx+xnOafJtVoDJAXWknAuUs8P5FIP3uEzPjOPQUNQPDuUOc
YwXp08vzI3nFJOkHdfWV2A5cqat+njNsuVpjzFsl5gHixMSfLIvPLLErTqvr
1NbLib9pe5J3M4w5Rbu/IL8dqp7VNY6JEvA9TZ0i5XW73lt1+RnyWQ/F2bjP
unn9CaWl52oddT3a3h2MNcsx2rSrZTO5GylnkbbCHkYZ85RzaNU4H/bepPV9
1TcNxp1Wy5H2wnSed3M3HKu7iTVeEScda9esrs3Aesm5mP5Ye36bOPcindvc
0i73Pes+zCom7+kdrDmcrhFpa/v4qaaYM4F2wvo9FGoeNpcnnGeKep41XUra
L+NqHMJI787e3yO3S7b7titW52UgLMNcJPYHx+kjLXzx2Uy+y5z7Ve7zEu25
mt5Fmzt+raR30KG9GGmmNttnbmf2MfZGQ5qb9pZjufa2Oi53ldyeu3jL+w9g
55aS
                "]], PolygonBox[CompressedData["
1:eJwtks9LVHEUxY8681RGZxIdEGYG9E1qKk+dZ8PooO1aWtCfIIFI+INspf4B
tk3RoKBaRNEP/wZdqJQLQaggFTdBmyIXERRBfa7XxYH7fffec+8593VOzt2a
rZU0BBJgZVRaSkrVjHSfuLFf+tMgzZAMiN+HUiGQss3SaUU6AW9bpTzf7hDn
C9JyjZRsk8ZHpNWc9ADkesiB26H3Ws8x9U8iqZ33L/BqQPpG/iO5DyBB/xVq
ekCJ7zGoRL6f5ZPkx0CCWQHIFKWX3dIL0Dso9YHHkc87QI/YLWDGFO8fTdJA
6D3Wazs8pfYeOy6AdXbeyF1oQpt5NE18M5b+ZVxjAb7dvPSF3BLfflalNTwb
yrpH7+BvviwNZr3nBr1XS+6taagh/gxnGa4z9IRoqSt6bB4EvBciz+/Tk6L/
eclnxXC2wD3FjNdwtbH/M2qPKl5rPcad6vfb2Q2biLfY93qj65+n/k3k+cWU
tBm55+btJ/Ad7r99njvnIE4X/bbmuXlvHhqXce50Sb95f211vRPsWz/iXKZ3
OPSbGb/tV2beo8h3N4/Mq0ux38o4jOtaB/8R2OCmD7vdQ+M2j9PUp2O/j904
Q7w+6t6YJ+bN3cj3s5vv8Q7Rfyi/gd1iu+qxfSuT+w9gXGrU
                "]], PolygonBox[CompressedData["
1:eJwtjsEuA2EUhb9ImtKmCMuWtJJORwVVaURppQtrSVOJjUpsrJDoWPAAHoBE
rVgS8QQegIU3suGbzCy+3D/n/OfcWzm97F9MALOSkfY6bMtBGTbnYLcF16sQ
Sb4JPzOQc+60Er/j/FswuOhfc8NpvbQj7qrLsjwH8DkFK74bSxDOm92CmoTy
rXZWgOxasiveWapBUbpp700RXtKew7p5b+xK0+yG7Nmzr/dVhZH+bR7Ozd6b
e5ATtUitZ+bVnrcguTu+f5h6x853/96578PsyP2RjNUe5UrtdxIGJXgyP5ZQ
7cj/gfMftjsrSQ==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtU79rU2EUPbYxobX5UY2CJM/qaxtL7HuVZ9PENBVxFEQpHRR06dChoIFW
Ed1c/DE7tIiQLkIJTlJXQRDt1E0F/Rfs4CgqeI7nDY/7ve+ee++5597v1HJ3
8c4AgOv8BvktDwG3s8Ab/tyqAx/kPAHci4DjvP8UAsOJz7r7OQLsF4HL/B+I
gZU8kKFFADQPAC+JyRNfoX+iBfSPAdUS8IK+vzmgyPNN+uYS5ykzrsjzHs+F
xFyEF59n54HaUeAp7cdJ4OFBICGfS2XzfkvsV/pWiflC255hDwWgQ7tE307W
nNZmne/xGLBLPo/yjq0Rt5IBNmvAxbLziOO1wLjuPPsquZ7wCxP2j7aZvwqw
VWxUgK3IvIvjwJXEtX+F7uPdqGtvzvr8ihw6LeMLxPdja9OLXEPcllINhJFP
NVTr7mkgZOzrI8C3JjDVtCZnWetc6Nnk6L+fzmmLuaOGNZljr0/GzEV6TPP/
Bu/XK86nmWhmfwLvQLfuHNJ/O+d45Uka9gnzm9ih2HGa+Zk0Z532cNt6aj7S
Rb2ob+ksDbU/Dyr/1wZV9pVp+e5HaO2kQSndEcXIN0nMKvXJx/503uNdJ+1R
89+OnHODdWca5qmeVEP3z1nzwknPvVfzfKW76slqr6SR9FB+9SatpdH3pvdP
mkv7hZbxVSbOthwzOO43o/eyFvlt6I0coh2Ofb8bmof4rFPLBnepzn1733Y/
qjtCbBCY39XEe7GT8lRvck03/J6EV23tsfpSf1OBfZ+J3Q+tnzTW25Ym84zt
pXlrsWeiHMJpz7RvfXL8B0sniMw=
                "]], PolygonBox[CompressedData["
1:eJwtkk1L1GEUxY8z+h9Gx5mxNAhnqEYdwvyPNDY502iIyyDMl6WiuGgh+F6E
LoI2Wd8gUtRNYDYVRG0jQcRVu9r0FXLRBwj8Xe8sDtzn5Z57znmeG/PLE0sR
SbdBI7jfJY20S2cp6W5RSoOpQBps4DArDfVLM8mLUhudUts96X9MWuiQLlH/
GZRql6VOehL0vrsmfW+TMmlphfVyVTq9In3jfP2O9KsipdLOMdwt7eSlbTDe
K02AYsnnHSOyn/oV9/PM+peQBnLS74rPNs2m/QgNvfAfwDeAqaOM9AOshNIq
aL4lxUEAYmAndG8/8ZtCX3vWvRv/s9A1m/ZDOMeqzmncpuE1s0/RcDVwv/GC
1ARnI0j2wAde4v9L1DN4g98W7jxu9Z5m6r6SZ2keQ+oi/BXmbzZJJ3UO4zLN
pn0t9F7jiNL/lIyegEP2P4D9gms3jRHynLouTYIaZx9Dz9yyN01baIuS2XTg
b5YrS3vceUsei+ztU38Gn0KfYbPGyENp/xMPi/7G5v3CD/Uu+Er9An171LGy
63nA3hlZJdC30OpvfhPj3WXvt70e6gx783FplPd8XnZYbTOznP3NOZdpDjhL
drlW6xlmnS/4bPtjj7hfLfnfsXyHSv7m9vaWiWUzh6dZcMCfe5/3jGp1z+b9
HBYgZNU=
                "]], 
               PolygonBox[{{7220, 3897, 12594, 7360, 7361}, {9897, 9896, 
                12074, 3673, 12076}, {11691, 11690, 10867, 29, 11688}, {11011,
                 45, 7252, 11012, 11013}, {7027, 3673, 12075, 9883, 9884}, {
                11633, 11632, 11779, 3430, 11778}, {7675, 708, 10845, 10847, 
                10848}, {10834, 10833, 9887, 1126, 8252}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtUj1oU2EUPTZq0tQQ8yOI+mzaF0Nr+l40JhrTVAdd1KEluArSqaHUJJTi
5OoP6CpCWhU11CCibTcplG4dLBSqzp10cnEtiOd43/Bxvu9+95577s/QdLN+
rw/AdZ4Qz92zwHo/sO8AzzPA6gAQyQOPBoGXCWC+BITzZo8SJ7JA4xjw/TLQ
x/vvGPDaB/6G6XMYaB8AOkVgjfdF4pOI3R/TvlMBnqWBBZd+Qd53OTu6ny+Y
r2LE1U/eGfJvDTMX73vU2/YAlzx3+H/QtbzdmPknqecCtXWorVDmSQJF4uQ4
sMtiW9Tz5TjwNG16hNIjrhTrfRMFHlQs59c4cIL2Ecd8j/j2r3i9T47aW3H3
Pas77VgO5erS/pn20+Sao/6lhNnp9r9GxYonSt4GfQaIN32rZYN4K2P6z1H/
K3JeO8p5EK+6Fq8eaw7qlXg8+vn0HyOeYQ1/UkCWWA7sNzLWO/Vw8xSwHTcf
1f6iZPoeBjNf5PlGzinHMOebTT7Sn6wCy8ydqBqXOEvEi0WbwxVqrDFfiztT
55x7wXy1az9rwG328FfN6lav1WfVrboUr3/pkzbtnzQ1OUM/qEU1aVfE+Zbc
h7iXK8wVIn4Kev6ROBb4KP97vh3aP3imT3l+cE9mh83evGT9XA56ulQ0TZqJ
/uTTY+w//VN3zQ==
                "]], PolygonBox[CompressedData["
1:eJwtkj1M01EUxX8tDZSWBlvbhFhKkZamUvkPxZoWKwwOroR0ZWGShSrWOLmK
JDhrYlFj0qiDCSmbiysDKolfK5NOLs58eG4uw0ne/Tr3nPfe5dX28noYKAsR
oX0DXibhewiWcvA6gL8JuKf44SycjcPnUWiNwe8mRFW/k/Cc1UqBz966AK+q
4izAyiA8TcNhHd6LI6f+uQykitDJwn2hW4Id4XYN6imYUM+ueluTHvfjMFSB
RNV32c5h7YoIl8R/JO1hnfenvLYmxBSfStPBeb9p7UjPR2l/E4PsFejl4duA
dsvz82vwp+neTHNBer8K22mfsdkRcTwJee6LakXh30XXZNoSgc9ablq1aMW1
mwfz9kn1nrScDsGC/D8o+N0Yn+36MOverd+8v2j4XQWKA813tWNv0Dl2dE7n
/G36yl1X/DjvXrrChvz80PxaxjWX1fuo7t6NY7HgHmy3aTbtyXl4m/GZm0Xn
MC77E5viPhHHsdCegbtCPPC7tjewt3h2rtfe+J28XK25dstZ7WfDtW5F4VfD
YWfbmdLu//7KX6A=
                "]], 
               PolygonBox[{{10870, 10869, 11691, 3357, 8811}, {9488, 9487, 
                11018, 2994, 8342}, {8341, 2993, 11013, 9487, 9488}, {8813, 
                3358, 11695, 10869, 10870}, {13616, 4655, 13615, 7676, 
                7677}, {12087, 12086, 13618, 4655, 8267}, {9885, 9884, 10834, 
                2928, 10832}, {10864, 10863, 7675, 2492, 10865}, {8265, 4654, 
                13613, 12086, 12087}, {9891, 2492, 12076, 7027, 7028}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkd8rg3EUxj+bYaVpNrSaMtsomy0/9tpWizYXbiX3yq1fo1GUa38BEStF
4kJcaHdyKVdE+RO41m6Fczrvxen9fp/3Oc/3Oc8ZWFqfX/MCY1ItUt9haEo5
AtaHICBYLQrHRRgNQc6BchA+uqAgDfcZuGmFlTg0coY3+sGfhUkP/PbBWwJ2
2+EsCS8FaJPzlmBOD/xE4EHuy3HT2U7BptROB8zGIFEwT18liA5bb016nwet
76hoWNr1PBK2s3pT3+r/XObYcDWrKfuvPcqp5mFB7leiExTNfR8cyLuhpOlf
y3y3JeMody5lmprNYskymZBMpsVTuRv2xG8+bj5m8jafzqm8Wcdy8KctR8VU
I+sY50Q83GWMo9ym61PnmhI/gU54lFxfC/bP576p+9BZLpLWq3nXx6Ei+Kl8
P0u2iz/ZxVOv8d89lrVmvip+60k76z6Vp3zd4WXRctC8D2OWj+akO1Bvuk/N
0xsxn6pdcfX/AZ/UUo0=
                "]], PolygonBox[CompressedData["
1:eJwtkTsvA2AUhh9Vl4XQIk1EWm1JpJQ2egsirUmZxC+wop0sErPBLiiJSAmD
MHUTo1Ui8ROYxYp4T06HNznfd27POWd8q75RCwAxKSi9TECxE94HoTUPKwWY
Dvuf+c6yUB6QPQK1Baim4a0DKvq7kK+i+FTYcwpxaJQgNwxPPRBKQiYHc9Lv
GPxJdzPu21R8XbmXitnX+75L9WS3os5iPa13MAHfiv2SEkVYF/hazGta7ars
VakwK2ap0eYtD8GycnPWP+RMadnnWWe3GIu9noSmlFFuVgpHffZuMY1OwV7C
bWN4Vf/elPMeannH6ntb8llsppuSz2Rvm2c77kzGZszGfpX0XKvRlH20BD8R
ZzxV/m7cc83/qF2dlLy2xVjss/bf1+83sFscFH1WYzb2z0XfVV7+D9k77XrG
9KB3Xu9AxG9mt/sH/RtK0Q==
                "]], 
               PolygonBox[{{8263, 2937, 10865, 9892, 9893}, {7678, 7677, 
                10864, 2937, 10866}, {12082, 12081, 9891, 13, 7030}, {13619, 
                4656, 13621, 8265, 8266}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkLtKQ1EQRRc+CgvFxgeIGINaCOFivEkMXhsFC7GyFUQsRROwsPIPfLUa
SCcqglh5O2vBv/AfbBX3Zk4xzJw5e2bWzPxRd68zAMzJBmX3bcgn4HIDPhdh
ewS2WnCj9+80XMm/LMGH8qfL8CB9ZRTea1DmoXfd32xoVhqhc/yqulvVf03B
YQGb6nsxDM0qHBSR938vMfTlH2WF4mf5yYWInxR31uFHwL16mONSS5zPwP4Y
1LPobZ5v7ZVnwWD23QocD8GacmUt+LtiOEucZu8nhmvx7CT9qnZ5E+e47nAi
fasaM7yHe1ljrW/n2rt2zDebGZqN1CeLeZ7r+/0DtTc7wA==
                "]], 
               PolygonBox[{{11701, 3360, 6160, 15534}, {15456, 6090, 1130, 
                13622}, {8812, 6160, 3360, 11700}, {8264, 8263, 9893, 9894}, {
                8118, 1012, 2374, 13494}, {15756, 6397, 6090, 15454}, {12083, 
                1130, 2493, 12084}, {15455, 6090, 6397, 13620}, {9379, 9378, 
                9380, 9381}, {13617, 2493, 1130, 8268}, {13619, 1130, 6090, 
                15455}, {9171, 9170, 9376, 9377}, {14147, 2374, 1404, 8759}, {
                9377, 9376, 9373, 9374}, {9381, 9380, 9170, 9171}, {15757, 
                5428, 6397, 15758}, {13620, 6397, 5428, 14745}}], 
               PolygonBox[{{9894, 9893, 12082, 3675, 12080}, {9901, 2493, 
                10866, 8263, 8264}, {9674, 9673, 14744, 5428, 14746}, {14193, 
                14192, 14760, 5436, 9238}, {15534, 6160, 15535, 14192, 
                14193}, {9374, 9373, 11700, 3360, 11702}, {14759, 5436, 14758,
                 9673, 9674}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkLFLQmEUxX+UkC0NiWGYYKBt+ox6xssnBIE0N4uEm0vR1NC/kEGNDYaJ
ClFuNQZt4lD/kXUu9w0f5/sO595zzrfbvTq/XAEKOqs6kz3opeCsCPdNWOag
L/yswE8aBiV41JtteBBeH8H3GsximO9obh3eqpCR7kv8IIJ61vfY2/ba/nf5
nATQ3oCbPLxIdyzdUPgU+Z5FGcJEY9pWCPub0JXXSJqG9GPhYaI5CHzO9lim
sTL8KvNIWE9mL2LvYF2Gwk7sue7U5TVy/ln8bd7vxv3lvK/pLJN5TMXXAu9i
f2b9zfOj4vnM61SeWyXn7Z/+AQ2DOV0=
                "]], PolygonBox[CompressedData["
1:eJwtkDFLgmEUhR8kyIYaDMWoRRKHIEXiU97ym4RobpaQ9mxo7BcIpSa0SAZG
Iphrq9DWpENzf8U6l+tw4b73nHvOuW/u+vaylQAyqg3VXRW+NuE0DW8Bnvdh
mYTfbWgX4UWzirC5OLt5+Dx2/plm78JOStDYgXJKvAhGwbUutuD7AD4KMFXd
HEFLNQ6+axrm3YvhL+v759p/iN1rpVlH/WPsvWUYanekDIt1vp9DeA3OZw/6
4j7F3pumac+KnsX27ZZmzb0M7wqvR/62G6KSzwwzzauae5iX/clY3pPgepY/
k/dMlfW9g+B/ZnzLeK+//AcBDjyH
                "]], 
               PolygonBox[{{7031, 3676, 12084, 9898, 9899}, {9375, 2254, 
                11702, 8815, 8816}, {10862, 10861, 9901, 1129, 8262}, {8816, 
                8815, 14756, 5435, 14755}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFUDFKA1EUnKyIhaQxpggRibKVsFqtyxd+Y0wOEMgFPECUqCB4AjsV0onB
BAUxeAVLvYhHEC2dYT5YPN7um3kz8/7W8clglAHIWUus0AQq1RpwVgHDBvAU
gM8N4Iv4I7/7HeByFRjtsLaBt2XgnNx7Yr91YLELzIJ3pdHIPReetejDel8B
yj1gnz7d0r6ay/si+Y4rz4SJ38zdnwvPs8SfRCCyv1D/NOWZknsXjT8oc+mb
bqL3pbNOzjWzbvKuSdt6tZazHpbOdsQ+D9aUtvSyxJkX/7mkK/3b6BzKs2B/
Tbt6p4/0hrPC+/LSfy3dIq1psE6Pvt8HxrU3Tm/yw9lV25mV/Q+gtkA6
                "]], PolygonBox[CompressedData["
1:eJwtUEsOAVEQLEKsbDARIUIyscNqyBOT+IQDSFzAAdgQEqfw2/pNbJi4gq2F
aziCsFSdnkUl1d2vqrpfcTQZjMMALCJCrFygniDYWJNviTz7LusduW+U36PA
jfxEvDkfJoEzec9R/SsNDArAtK5vZT4jb1eBFjHPAgviSI2xVHMg3zAjlAEe
McAr07Os/tKTWZf+tcB/1AT2Rnf9xYGkDXwbmiWaD/nFaC07eOQpW70lU7IP
ts7kpqvRncVbMjqOZkgt+/VZ+xXNEv9nTjWilT9aBjfJbbcS3xJ/stI2ew==

                "]], 
               PolygonBox[{{9900, 9899, 10862, 2936, 10860}, {13636, 4662, 
                12085, 12096, 12097}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkL9KA2EQxH/EQCot1Cga8E8Qi8AhKY7o4UUUbS1S2ApWCYSIoGCjL6HW
ihqCmELxDWzFx1FbZ9grPma/3dmdnV09Oe0MSsCS3oTeeB2mhJc1uN+CzSo8
CJ8SWJyEmxx2U0inoa18rw415b8V/2RwOAd/wus8OFfCd/Uui/PShJ0NOJZA
nkX9ax76ZbgTr7wAt3nUXXPeGo49by+NXGdFOxRz9tP4O3+geNQMLWue1WOf
t224aMHRDJy3YlfvPBTnVXFbHsfC58Jjt/Bk757bb8RNfBv7N+cxiT5rfVZC
w1q/WdzLvbNr4dmcjyS8eq5n/gMzbzN8
                "]], PolygonBox[CompressedData["
1:eJwtkE0rhFEYhq80ZcVixgzmnZK32Q5ZnPBmaMSWsrAVK0ojEyXlZ1grHzMJ
C/kHNhZ+j6+d++6ZxTmdp+f+PLMHJzvdEaCuU9J5a8HMGOxWoJfDZoJjLZaq
cLMMZ4uxM6abB8ZzeQpeV6DahD/t6jp30rrIYFy6e7o68/BbwHYt9vfaTzRD
O9Pc1/wyF3zPR9K+akMqB39N/GdlWBX+fRQe9W4XsbPHZRYa5lrDWYwxtjQN
19L6EX6rFnl76rKvzJ+T4dFJ0cnd7PEk7kcj8przVURHcz2fCnuYRxf7Ofv3
UN8cd+0vhL81B3o/DPPZ0963reAbb6+NFH385+spMtrPf3yu9z/dYzuN
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1jzEvg2EUhZ9oxNSKpE2akEibb+0nLRKVNiL+gT9ATRgIWxti9UMoA76I
gdHcpX6HAZOoybk5n+HNfe99n/ece2p7x9tHU8CiTkGn14H3GbhuwMUa1Irw
rHuvAjsVv0Xd1bmbhtM6ZKpPYuaq5qMft80sJ7CxBJ96O+/CSc4/djwbielL
86BuvfsUNlftE7t8Vc0FM1qQxix8SPtKfq+a/azDb9G+/33Ub9XBvPW7ur80
zESmmyacSWeoOinbI/RXEud8a3u/LM+3VbZv9A+p/bLUepE5/FqJd77U/DDP
UsqZ+B9/Y+/QuW06ZzD7Yv8A4wFBzQ==
                "]], PolygonBox[CompressedData["
1:eJwtjz1OQlEQhb8YCZUSEl5Cy8OWRwQsnuEixB24AX8qtZBQUkDtQjRiQoSE
AktrE0C3QSOVCVSeyVic5J47Z+abKd10Lx72gEjal5YpXMpcS40jGB3DIAfn
BWiXoa6/q8gzlr2NYZyBjyw8VWAulQ5gJ70l8Cy/znp+ofxj4n6reUF+pvok
44xXsVqp1yzTOYFpE/JFz/Ri38F2Mca7eg8T59tOK/VOEmfbPi+qDwL8qH8j
DYPL3sYw1lfqtxqvptt+T73XmMYO//v09fdd9plWN+Z97DfZbebv5IP6PyNn
nlXhD2SmPJA=
                "]], 
               PolygonBox[{{7369, 3964, 12711, 11697, 11698}, {11698, 11697, 
                12713, 3965, 7370}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtUDFOQlEQHCViBcYEChRI4P/2m4gk/h/zE2LkAhQcgEKFED2BiVh5E6kw
oQCvoBjF3pqGxiM4w1Bsdt/u7Mzsq/XuO3e7AAJGhhEVgHIOqGaBvTzwyzre
ASYnwAPzPAKuY+MGzLfbWr1HxhXr4xR4KgIjxow8jdBcywTox+Ze1IH1vvvi
13vTT8zRLni3WrHuDfe+ORvST55eRrExl4F1zkvACvY+3Prvhvbxx72XyLNX
7v4EvitlvxVYZ3zKe+rGCCsO+ROP8vLA9UfZOlNimqFnX4n39A/yepQ6y7s0
pPVM3bfIWtIUn3Z1+2HD79KFudQ/C60hrXdqfibGCPsPnUQ+SQ==
                "]], PolygonBox[CompressedData["
1:eJwtjztOQmEUhL9L5FIBBVjw0IRHe28imniJoZDgBkxkATQ8QnQFBLByKVbS
oWtQEl0AtY2J1yU4J4fiJDNz/n9mTmP0cHufAUqaI00hhnke6ppZE766kC3A
Tw4u2lC5klaEJIDgBGo9GJRhIV4VHieOI2kT4U3sXqa9CPdbcFP2Pyvtz9vu
bZmfyvrVrI/hW13e6/An/ii+DeFafz/ET0PvsOu6ZjvzXMtvmbi3aW8RPClz
n/cbOsp6PvOdZVjWnbTLivNU/DXyruZhXumhj3UY6u0s8dusw1T4H8EELsE=

                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{
               PolygonBox[{{14440, 5166, 14439}, {3494, 1719, 469}, {1719, 
                947, 469}, {2403, 5166, 1689}, {3435, 5470, 2025}, {947, 1689,
                 444}, {9302, 2099, 14831}, {14441, 5167, 14442}, {1719, 2403,
                 947}, {5167, 3435, 1689}, {2099, 3494, 469}, {6276, 2403, 
                1719}, {14465, 3494, 9025}, {7425, 5745, 15129}, {1689, 3435, 
                444}, {14464, 1719, 9026}, {947, 444, 15}, {3435, 2025, 
                444}, {14831, 2099, 9301}, {14796, 5470, 14795}, {469, 947, 
                15}, {2403, 1689, 947}, {9025, 3494, 14832}, {15642, 6276, 
                15643}}], 
               PolygonBox[{{14832, 3494, 2099, 9302}, {12817, 2025, 5470, 
                14796}, {14795, 5470, 3435, 8907}, {14442, 5167, 1689, 
                14438}, {14439, 5166, 2403, 7454}, {15129, 5745, 2025, 
                12817}, {7454, 2403, 6276, 15642}, {15643, 6276, 1719, 
                14464}, {14438, 1689, 5166, 14440}, {9026, 1719, 3494, 
                14465}, {8907, 3435, 5167, 14441}}]}]}}, {{}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7425, 15129, 12817, 14796, 14795, 8907, 14441, 14442, 
              14438, 14440, 14439, 7454, 15642, 15643, 14464, 9026, 14465, 
              9025, 14832, 9302, 14831, 9301}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7369, 11698, 7370, 14830, 12712, 9024, 11704, 14463, 
              11703, 11950, 11951, 11687, 8810, 11790, 14799, 9267, 14798, 
              9268, 14800, 9266, 11912, 14653, 9169}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7034, 14909, 12095, 15741, 15742, 14654, 13633, 15457, 
              11685, 14797, 8809, 11949, 8808, 11684, 15096, 15094, 15536, 
              8817, 15537, 8818, 11699, 12713, 11697, 12711, 12710}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{10860, 9900, 7032, 12097, 13636, 13634, 8274, 13637, 
              14751, 14752, 9236, 11686, 9237, 11683, 15763, 11682, 7367, 
              15093, 15095, 14194, 14197, 14196, 8814, 14763, 14764, 14761, 
              15765, 15764}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7061, 11913, 7035, 14762, 9375, 8816, 14755, 14757, 
              14195, 14754, 14753, 7368, 11948, 14748, 9235, 14750, 15762, 
              15761, 15760, 13638, 15458, 13635, 12085, 12096, 7031, 9899, 
              10862, 8262}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{9379, 9381, 9171, 9377, 9374, 11702, 8815, 14756, 11701,
               15534, 14193, 9238, 14759, 9674, 14746, 14749, 15757, 15758, 
              15756, 15454, 15759, 15456, 13622, 12083, 12084, 9898, 10861, 
              9901, 8264, 9894, 12080}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7030, 12082, 9893, 8263, 10866, 7678, 13617, 8268, 
              12088, 8266, 13619, 15455, 13620, 14745, 15755, 14744, 9673, 
              14758, 14760, 14192, 15535, 8812, 11700, 9373, 9376, 9170, 9380,
               9378}], 
             LineBox[{8758, 14146, 8759, 14147, 9671, 13494, 8118, 12954, 
              15214}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7422, 11784, 7423, 15590, 15591, 14371, 8964, 14544, 
              9077, 14543, 9076, 10523, 7955, 14461, 9023, 12955, 12956, 
              12957, 11850, 11967, 9278}], 
             LineBox[{8341, 9488, 8342, 11016, 13639, 11696, 8813, 10870, 
              8811, 14191, 11689, 9234, 14747, 13614, 13621, 8265, 12087, 
              8267, 13616, 7677, 10864, 10865, 9892, 12081, 9891, 7028, 9885, 
              10832}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7220, 7361, 11633, 11778, 11780, 11787, 11786, 8904, 
              11785, 12813, 14372, 14373, 11789, 14542, 11788, 7464, 14805, 
              9277, 14865, 14866, 14807, 14806, 9022, 12854, 7444, 11639, 
              11936, 9218}], 
             LineBox[{8252, 10834, 9884, 7027, 12076, 9897, 10848, 7675, 
              10863, 7676, 13615, 13618, 12086, 13613, 13612, 14743, 11688, 
              11691, 10869, 11695, 11693, 8276, 11015, 11018, 9487, 11013, 
              11011}], 
             LineBox[{12958, 12959, 11814, 7504, 15215, 13427, 8071, 13426, 
              8070, 13464, 8101, 12912, 15183}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7082, 10100, 7063, 7252, 11012, 9486, 11017, 11014, 
              8275, 11692, 11694, 10868, 11690, 10867, 7059, 10012, 7033, 
              12092, 12090, 13628, 13627, 7680, 10845, 10847, 9896, 12074, 
              12075, 9883, 10833, 9887, 8254, 9880, 12070}], 
             LineBox[{7221, 15041, 12595, 14729, 14728, 8755, 14343, 8941, 
              14340, 8940, 14342, 8963, 14370, 14298, 14299, 12812, 12810, 
              11637, 8903, 11634, 11779, 11632, 7360, 12594, 9670, 8754, 
              14120, 8752}], 
             LineBox[{11946, 11679, 11680, 8975, 14396, 8974, 14397, 7452, 
              14462, 7453, 12879, 12877, 8953, 12816, 7424, 11676, 12815, 
              12814}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7008, 9784, 7006, 14185, 14187, 14301, 14300, 8804, 
              14303, 8906, 12708, 8905, 14740, 9230, 12878, 9229, 11675, 8802,
               11681, 8807, 14742, 9233, 12709, 15092, 7366, 11947, 11911}], 
             LineBox[{7026, 12072, 9879, 8253, 10837, 7671, 10843, 9886, 
              12073, 9895, 8257, 10846, 7679, 13629, 8271, 12089, 12091, 
              12094, 10011, 7058, 12141, 10872, 11004, 11002, 8278, 11019, 
              11020, 9490, 12146, 7062, 10099, 12204, 12202}], 
             LineBox[{11562, 7347, 7202, 12596, 12545, 8757, 11575, 14341, 
              11573, 7421, 11635, 12811, 11636, 11783, 11782, 8750, 9669, 
              9667, 14143, 8753, 14119, 14141, 14140}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{8196, 9791, 8197, 9785, 12035, 9783, 7005, 14186, 12030,
               8803, 10698, 12707, 7365, 14302, 7364, 11672, 11673, 9231, 
              11944, 8801, 11674, 15453, 13579, 9232, 14741, 9168}], 
             LineBox[{8244, 10809, 9870, 7024, 9877, 12071, 9878, 10836, 
              10835, 7670, 10842, 8256, 9440, 8255, 10841, 9904, 13625, 8270, 
              12132, 8273, 10013, 12093, 10010, 12140, 12139, 10871, 8335, 
              11003, 8277, 11021, 8345, 9489, 12145, 12147, 10098, 12203, 
              12201}], 
             LineBox[{8699, 11564, 7346, 12544, 12542, 14144, 8756, 14145, 
              8705, 11574, 12809, 11638, 8751, 11781, 8749, 9668, 9666, 14142,
               7954, 14128, 14118, 15521, 14114, 14139}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7007, 12034, 10709, 13578, 8194, 10704, 8195, 11678, 
              8806, 11945, 8805, 11677, 11640, 11641, 10700, 11643, 8190, 
              14188, 12029, 9786, 10703, 7625, 10713, 10714, 9790, 10711, 
              9787, 7009, 9797, 12045, 12043}], 
             LineBox[{7023, 12063, 9866, 8245, 9872, 10808, 9869, 12066, 
              12065, 9882, 10822, 10819, 7674, 10854, 9438, 10844, 9439, 
              10840, 10839, 9903, 13624, 8269, 12131, 8272, 13632, 7728, 
              10999, 8334, 9483, 8333, 10997, 10875, 13673, 8344, 12191, 8346,
               13679, 7769, 11121, 8399, 9518, 8398}], 
             LineBox[{7218, 7359, 15517, 15520, 14117, 14127, 14126, 7952, 
              11559, 7953, 10520, 12592, 12593, 8902, 11570, 8702, 10462, 
              8704, 9644, 12543, 7345, 11563, 9643, 8701, 10456, 12539}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7201, 12541, 10455, 8700, 11567, 9642, 11572, 8703, 
              10461, 11569, 11568, 14297, 7219, 10519, 12538, 10522, 11561, 
              11558, 7951, 14130, 8745, 14116, 8742, 15519, 7358, 12591, 
              12589}], 
             LineBox[{8202, 9804, 8203, 9798, 12044, 9796, 12038, 12037, 9789,
               10718, 7626, 10712, 7624, 10701, 10702, 9793, 8189, 11642, 
              8761, 10699, 8760, 14189, 14190, 13575, 13577, 8192, 10710, 
              8191, 10705, 9905, 10889}], 
             LineBox[{8236, 10786, 9857, 7021, 9864, 12062, 9865, 10812, 
              10811, 7667, 10817, 9871, 12064, 9881, 8248, 10821, 7673, 10853,
               10855, 9442, 12078, 7238, 10838, 9902, 13623, 13626, 12130, 
              13631, 13630, 7727, 10998, 11001, 9482, 8332, 10996, 10874, 
              13672, 8343, 12190, 13678, 13676, 7768, 11120, 11122, 9517, 
              11118, 11117}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7100, 10167, 7083, 12207, 9521, 11125, 9516, 11119, 
              7767, 13675, 13677, 12189, 13674, 13671, 10873, 10994, 10995, 
              9481, 11000, 9480, 11915, 7731, 13667, 13670, 12135, 14927, 
              7056, 10004, 7029, 12077, 9441, 8259, 10856, 7672, 10820, 9890, 
              8246, 9435, 8247, 10816, 7666, 10810, 7665, 10798, 9868, 12057, 
              12058, 9856, 10785, 9859, 8237, 9853, 9851, 7020, 9842, 10768}],
              LineBox[{8210, 9818, 8212, 9812, 9810, 7010, 9800, 10732, 9803, 
              10735, 10734, 7628, 10723, 9799, 12036, 9788, 8199, 10719, 9410,
               10728, 10729, 9795, 10726, 9792, 10697, 7222, 12597, 12032, 
              13576, 12031, 9910, 8193, 10707, 7682, 10892, 9906, 8284}], 
             LineBox[{11448, 7328, 7183, 10453, 12540, 10454, 11566, 11565, 
              9641, 11571, 7925, 11549, 10460, 11544, 11542, 7344, 12537, 
              12535, 10521, 8698, 11560, 7950, 14129, 8744, 14115, 8741, 
              15518, 7357, 12590, 12588}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7016, 9824, 7015, 13136, 13139, 13129, 13133, 13131, 
              7013, 13123, 13126, 13118, 13120, 13119, 7012, 9814, 10746, 
              9817, 8211, 9811, 9809, 12048, 12047, 9802, 10736, 7629, 10733, 
              7627, 10720, 10722, 9806, 8198, 10716, 7224, 12041, 9411, 8200, 
              9794, 10725, 10724, 9916, 7036, 9907, 12033, 9909, 10708, 10706,
               7681, 10890, 10891, 9912, 12103}], 
             LineBox[{7503, 15213, 15410, 15409, 8088, 15510, 15511, 15507, 
              15509, 15508}], 
             LineBox[{8634, 11450, 7327, 7182, 12473, 10458, 11462, 11461, 
              7924, 11547, 11548, 10459, 8694, 11543, 7343, 12536, 9640, 8697,
               10449, 8696, 11554, 10518, 12587, 12584, 12528, 8743, 14125, 
              9665, 14137, 8748, 14105, 8746}], 
             LineBox[{12052, 9838, 8229, 9845, 10769, 9841, 7019, 9850, 9852, 
              10789, 10788, 7662, 10793, 9858, 12056, 9867, 8240, 10797, 7669,
               10827, 9433, 10818, 9434, 10815, 10814, 9889, 10850, 8258, 
              10000, 8261, 10006, 12079, 10003, 14926, 14925, 12134, 8328, 
              13669, 7730, 11914, 11916, 9485, 12143, 7060, 11006, 7080, 
              14943, 12193, 13727, 13725, 7771, 11123, 11124, 9520, 12206, 
              12208, 10166, 12269, 12268}]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwNkE0ow2Ecx78O3mo4rKGwrP29bvknLyu1C1asv9RKaV7WZlbshYMcTRIu
Tu7aWbmttshFObh4KXbRDkqkuEguUj6Hb5/n+X6/v+fpeVyxtVCmQlIWbbVI
hU5pt1c6gwdwD70Y5HAb5fFHTWkMnbN+65EuYG27dAmr8WuQr1V6IiujKfxn
eNMm/cArzvuCdcxMktXTn4G35L/4d7BxSJrFGxzhvgHpAc8PSzAAh/F9KMja
QhMohKZRgndEmLVzbhQ6uScBl9AK2RydeRRGMRRBq/gpcgczaWgwY+e979y3
wb4JPwub8T7w3PATdkMPKvEmk5kjOl7232RBaKEymcF8gD/xs8/RicI4auiS
xplLsvY6pVfowLN42zIz+2Rx/qKf7LBPenRLtg4pQ7aO/ugv0l1AOfbX9I/p
h+lveqR79ib9U7Ii556Q7ZAVyKpc/C1ZJfwHDA5OuA==
              "]], 
             LineBox[{7416, 11772, 7417, 12797, 12796, 14285, 14284, 14791, 
              11769, 11770, 8936, 15800, 15801, 15155, 15156, 7442, 11966, 
              11935}], 
             LineBox[{12468, 10354, 8636, 9611, 11449, 7326, 12472, 12471, 
              10457, 8638, 10452, 11457, 10451, 12534, 12532, 10442, 8695, 
              11546, 9639, 11555, 11557, 10448, 11553, 11551, 10517, 7217, 
              12586, 12527, 14124, 14122, 9664, 14136, 8747, 14104, 14134, 
              14132}]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwNkU8og3EYx79aS8mf5e/Bv2l4s9Wkt9W87WC14iRcZg7K5IAyWjlqS7it
JiU5ysFd4rJS/l4kNlGkxrK4EOXI5/D0+T3f7/M8Pe/ztkVjI3MlkhLEVaP0
Z0gZONsk7XukYId0CA+IZIu055NunFK+W7qGu+SL9GzBc/Id9Au4TZ6GoV7p
ziVtomdhH3kr9a9uaRXfzvwi7wLhYf40nCEqqZmEFTDFPqVwAbqY89guWfRu
dEoD1KxDA3rRcnhu3llows9mqQEaeEvU1dMfh0X0avQ3WAXn0QKWNGGyG1oE
5uE4tNCn8J/J7dQ+QRuMovnxhql5QOuH93AQ+tBDMEcegLcwCE30MH113KeW
cBD+Hm6Kb+GXs+cZu391SSfwFzrQhuj54f1NXPJOcIsMLON7juEH+jth44bL
7DZKzyl6GBaYk0R7gWtwDO0ILwJXyJ3ctob/+w86+VUt
              "]], 
             LineBox[{7181, 12470, 10353, 8635, 11453, 9610, 11459, 8637, 
              10360, 11456, 11454, 10450, 7200, 12533, 10441, 11545, 7922, 
              11445, 7921, 11539, 7923, 11556, 10447, 11552, 11550, 10516, 
              7216, 12585, 12526, 14123, 14121, 9663, 14135, 14138, 14103, 
              14133, 14131}], 
             LineBox[{15033, 15750, 15752, 15751, 14727, 14067, 15506, 14282, 
              8892, 14280, 8891, 14281, 15127, 15126, 15565, 8895, 15566, 
              8896, 14286, 8894, 14794, 9265, 14793, 15796, 15795}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7185, 10363, 11468, 14792, 11470, 8893, 11474, 14283, 
              11473, 7415, 11579, 14279, 11581, 8709, 11577, 12549, 11576, 
              10468, 11585}], 
             LineBox[{7215, 7356, 15514, 15516, 14102, 14111, 14110, 7949, 
              14063, 14066, 12531, 15032, 7199, 7342, 11530, 11532, 10446, 
              11540, 11538, 7920, 11444, 11447, 10444, 12467, 7180, 7325, 
              11441, 10357, 11455, 10359, 11460, 11458, 9609, 11451, 11452, 
              10352, 12469, 10351, 7166, 7315, 15717, 15719, 15718, 9130, 
              14619, 14620, 9726, 13062, 7579}], LineBox[CompressedData["
1:eJwVkb1LQlEYxp9SgqCuGGRD914s0qigb4mroH1I5RQURNCXREtLTi1CHxS0
ZktGBEFE9Q80Bg1BtuWUVATW4BDh1Fr9HB5+5zzP+77nnHtbVlLT61WS9pC/
V2pFv+3SbbNU7pHiAdZd0jC8gTu2dBWSrlGR/BJeoA16svAYneOfwhOU8Uuj
jjSGjvBHYAzZ1H90Sp/IzewSdMFv2M0ZBfiCGqhbom8Z1bAOwFoYYa4LOnCC
usOgFIRxUzKpKbRJ/WSDeGVL8sH9Sg1enuwJWXhfZHXQQCnySFhKDnAv/DlY
hIvQwV8lf2fvpvYNVkOLeWv4JrR5r4mifdIr+Sx9PvxHzsqhvw7pGX+B+kZ8
L7VNyIOG6MmTOfQY7OtRmLd4ecsDvR7qp+gz4A9zcqy3+UcJ8jvWGe5ygErU
ZivflG+4C+/JtuAmmmRejHdE0Th988xKcE6I2jQ8Y5/GnyH/B01sT1s=
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwNkk8og3Ecxp/XAWkOI4d5t/HGbEjb8icspUbGgRKlsDIpStt1Kw5qcnJY
RnbjoOXshlIcFHaSxElhB2m5CuVzeHp+v+fP9/v+1qxYYjJuSEqDnClN9Usp
P+iWkqDLLUXgMTCMPoi/Tm7EKa21SVct0i58DS80Svuci81SBo5yv0CP0LuB
s2jlzPtulex4BbQavEXm9THPxo7eTikEeoJ43C/ZF8Kr5TxL/pduFHbQv2XP
AJ4Drx5M03t2odE1ubuASW6ZvMHuF7wq+I5eATTgLdEpog/R8ZD3gib0JJ1q
sh94TtgN7umE2VfHeRM/AG/BQfKPeCZvifOWH7Rt2PBKo2TK4Al4HPh4/wNc
iTZP3g5v0H9C68D7hEugwiOt4GeYkyCTh+f4LXJoe3zjDsjSO4APwRF6HhyT
OyF/Cq+Sf0N7x38FaeaftUvnIMz8Et4X+CNvBfgD+HiTJc3g+eF/CiJRFg==

              "]], 
             LineBox[{8644, 13941, 8645, 10364, 12479, 10362, 11469, 8642, 
              11771, 8643, 11475, 12795, 11580, 8707, 11584, 8706, 11578, 
              10467, 11586, 10469, 8712, 12556, 15036}], 
             LineBox[{9404, 10694, 7621, 14622, 14623, 14621, 15721, 9131, 
              15720, 15307, 15308, 15848, 15850, 15849, 14625, 14624, 9132, 
              15723, 15532, 15722, 15533, 14175, 12702, 12703, 7165, 12405, 
              10356, 11382, 11381, 7895, 11443, 8630, 10358, 8628, 11442, 
              7324, 12466, 12465, 10443, 8633, 11446, 7919, 11541, 8689, 
              10445, 8687, 11531, 7341, 15031, 15030, 12530, 8693, 14065, 
              7948, 14113, 8738, 14101, 8735, 15515, 7355, 12583, 12582}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7204, 15037, 12555, 14077, 14076, 7929, 11582, 8708, 
              10465, 12546, 12547, 8890, 12478, 12477, 9614, 11472, 11471, 
              7898, 14014, 14015, 13940, 14013, 14012}], 
             LineBox[{8739, 10513, 8740, 11630, 9661, 14109, 9662, 8734, 
              14100, 8737, 14112, 7947, 14064, 8692, 12529, 15029, 9638, 
              14061, 9637, 11537, 8688, 10436, 12522, 12525, 10440, 14007, 
              8631, 13995, 8632, 14009, 9608, 14004, 8629, 12401, 12462, 
              12464, 10349, 13927, 10350, 8583, 10355, 12404, 14177, 8799, 
              13929, 8798, 14176, 14546, 15693, 15694, 14548, 14851, 11892, 
              11893, 11895, 11894, 15851, 9336, 14852, 14854, 14853, 9134, 
              14627, 9135, 14629, 8184, 9405, 8183, 10693, 7154, 7306, 
              10600}], LineBox[CompressedData["
1:eJwVks0rw3Ecx9+LMWfKPIyN2dqmhqXEyMNOykVqhUVSW1vNs4WDxU5aDlvk
QCmSs6tSCoe1IsQfgJK/YK3Ia4d3r8/3/fm8f9+HzTa3MB43SEqjbY+UcEpL
3dIy2vJKq3AFVbdJi/DYKgVKPlpDNuYP3dIM/oNDmoXfdmmoVxptlPbphfAe
6WWpM8jYJBVcUiU8YZ2nF2B+p0EK+6QI6uuU4vAOPwZT9N6Y+yNXy/dC1GaY
Yy8/+5g52wRzQeQn28z6nuwAPSt1mHkTe8WgrXQecoP0Wui1onlyXxZphKyd
tQN5kBslyNST3YAuss9kh8nW4KXwvLALFah99H+hhbcpwjTnnqY28k45Zhzc
eQw64St8RwbeNknuhdrM3A+sg3t4FfQi5KMojjfFnSbREesDzpZBWebOYB6e
41+gS3TFfIzZKPpgbbBJn8ztsvcNv/U1fRNeEVbBW7xTemXtUjkKsrcBrnPX
J+7R08F/gm8l+6VN+A8w/1YV
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwN0N9rzXEcx/HX1rJcDTfys3Oc+XE2YWlHhrS5kpUfaRfkAqWM7azUSeQC
SVpu5Mr8yPIHuLGL3fiV0DJNGVIkS1kpXJCieVy8er5/vF6fz+f7LR6q7umv
S3KNPi9PpmjummQONSxJSpuSZXRvS9LenIxgBYuVpEDVzUk/9dHGdcnLRUkz
7nNO4+qkB+vx1tLkfmvygP6stCsmo+pR9cf2ZKaQfFnrEeaf9Gf4j9u/ML/L
M4b1+mG7K+qrWKd/qC674xEe1O+V+9GSDOqPyV3Cr/r56gl8ReGfxBnf8QFb
ZJ7jad4Gvv3e8XdF8sSsZFfBDfTbrA1/4aDv/I4/qVXuG67CBfY1ddn7Ohcn
zzrM1V1tyZH1yWEq6rfajbu/INPL3yg3i6bUF519gu+pbA07ZQewShfs3vG8
p4Wyb/BfOXmN5+16eR7L9WGH3Gzv3+m+o/pt5mN8190zRNPuH8Y7NGF+G8fx
Mm73vrPO65Lp9j+6nbGDKs6b5z/fcHfJvxrCJn0P/27eXXSS/6Z5jf8A/zn7
t/pT/CN2/wFJ0GVx
              "]], 
             LineBox[{11587, 11481, 14068, 14069, 12554, 14073, 14071, 7928, 
              11477, 7926, 11583, 10464, 12548, 7203, 14278, 7184, 7329, 
              11463, 9613, 11467, 11465, 7897, 13945, 13946, 13939, 15489, 
              15488, 10298, 12414, 12413}], LineBox[CompressedData["
1:eJwVjztLwmEYR0+zIEKrWf7V0qGoNO0C9Q0aUigKggKju031ERpraXNoaAoi
6IaEQ9Bga0hTH0CIJgOHcug4HM7L77nwvPHNytJhH7Aou6OwJ5EMVPSB1FMQ
LcBQAK1xSExASvrt+cpDOw6f+kd/6yv7w70d8po2cyYWhYbvR+tPci3PUpNT
++/0vRzZeyuXsxByZt+ZsvmWTGW9TwfzsK3Xvel9GppynIAPfaKDGbjRa2Ow
Ki/eWR2AkWFIWkvrN7OGPCRhxT0l/4b7i3rHfHkQujn/pH91W//pjjedWT+X
C7ONSViYg39tZziC
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0k9oz3Ecx/EXUiY0Bxdba/sxbP7TrCG54LBymPwrzdqUxiJ/1rCf/Cvi
sqscEO0sLpooBzFKkYtW/mQtbb8Vbv5MPHZ49fy+36/36/Ovb0370ZYjU5L0
05fKZPqGZBh3b0r20DT6tzb5TRP0h4YqkqKZ1trkZF1ygsbkRukpf7wxKdHb
puTRiuRKIXm9PHmgvk99vOaapGtjUliXLFiV7LXWGr2yZcmdquTXUnvRxOKk
kv8TB9QD+KEh+UgjK50ZP1NRppN/mO6ZeVWdHPQdaqX9tMQe7dhGO8x/q0++
0yHzJezEfnfrwD5ss/5UmUvW+sSvkxnEWfwzen8XJi/Uz6jAa8CaybMvSnbJ
/sDHelV61VgvM65X4buE1+xxznu9XJ9cxG2r3QN76Srvq5kxKsiNYJncMF7m
HTfzXK4bN8uV26PFOxxTb9UfMjdbL5PnxffqLfpd/JnqJpkZuF2mw/rv+O1Y
cqebMqN4Fw/oveHd9n2Lat39hv3Pul8zFeV7aZ53mu9dG605FwvmynEO7fSv
XJdpsX+PTI/5btpn9jz/Ap02/5B3CovqJziI/wE3UHJR
              "]], 
             LineBox[{8715, 11588, 11480, 14070, 8710, 12553, 8711, 14072, 
              7927, 11478, 8651, 10463, 8649, 11476, 11388, 11464, 8639, 9612,
               8640, 11466, 7896, 13947, 8587, 13938, 8586, 10299, 13944, 
              7873, 11386, 8588, 10294, 11384, 11383}], 
             LineBox[CompressedData["
1:eJwNkL0vg1EYR0/D1ESaGFtfpRoG4qNaQawIk1k6vLH11Q5GcxNJiUSiBjGI
qVPNiMTH4C/oIKnBIJqGzUAEZzg5N09+z73Pc5NBab0YAfLyOQZ7oxDvhaUp
WJbKpDUp90ArAWEGtqQg5X440Md6X1f1mj2rsiIla0V5GYZ7732QUApy5Bs3
uqof5yEyDX9mf+XaWjoNX97XMQPfulM/68YsNHXT3I65oUXI2pvUOZ2R9zlo
y6Ez/zjzmedTd9iegM0sBNLog7q+kJpUFmBXTuyJyu2Id5i/0zH/pUvO3aNt
9kOepCVv0u0e4/akfOPVnkTOP5Qr86F9UecNdMxcXm/IpflB8wPyD9pPQ54=

              "]]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7205, 15040, 12561, 14086, 14085, 8657, 14074, 14075, 
              12552, 15034, 15035, 10466, 12489, 12487, 12486, 8650, 14022, 
              8593, 14011, 8641, 12476, 15020, 15021, 10361, 12412, 12411, 
              12410, 13943, 13942, 7872, 11385, 7870, 11319, 10293, 11315, 
              11314, 11766, 8887, 9398, 9397}], 
             LineBox[{8719, 11595, 11940, 11939, 11943, 7349, 15090, 12704, 
              14739, 14738, 8800, 12853, 14179, 14178}], 
             LineBox[CompressedData["
1:eJwV011M1mUYx/ErjzIVbHqgPpDReDFFS4xKJWod6JR0K6dzvi5K52jZ5hIP
BNQmFG1AraPUExWNqZiaiYjTDZ3azM1MYxng2nxtZqRmFKF9/ge/53tfL/d1
3ff1v5+s0g/eWvlYRBT6yXgm4olnIzLxSE5E1sSI1oyIxeMjRvKliaXwXfbA
0RHXXoy4Qbeejzg4xT65e6ihKOJz+lmsizrpzlMRe/Mj9tGpMRHN9gyUu4k+
lvspNcnblxWxHy/Jfwdr2KvkbnaWLXRHn9t0bWpEe6b+eBI7Xoi47Ext2fri
L+xO6iqI+EbOQVri/FfY3dSfxOX9g39iL/ZgmZz52PpSxCF3nSn3sHULVSf3
12tUbkS9/FRCvjpq1vfCpIgfqdieA87/g/V52qjeK3xFNJk2sJfa323GQ1/W
W5/X+F+n7AkRf7HT+f/GIfggmT1eTdlrBuvprLrNetxzrx66SwXF7oJTaJH6
hez1ei2wXocLMV0sjXLM+zO+3ORbYa1YMX8NNrA3Yj1WY7V5r9GznFbTLn13
8O+kRmqWN8/Z59IcqmNnq1slVkkPnTUvmTXmYj9WqLnU/d/wfbO8iSY115jj
V3hcfLA38r13dpYeyX1IrXofUreFPjGTb7EWz8g5TRPVGmDf4+ptVeffcRH5
fH153q83lKL71m3m+NtzETfpRmHEdVonv0n+WizDvfJW4HJ6NNZ/AEu91c32
jHPuBt+pnubJnyM2l9635wvxRvVLrd+2XobVT7srfoSdag2ybscT9J93cwr7
8BzmqBfiq+X28pVjG38m/2jMwFb8w9srMZMNZjWKb5rZjMAq9gz+W+KL3Ws4
3yD5w/A633SxD+U8yX7VnnR8U957+vwqXoZ39e2hr+1LE+/iX87/O99t2pPc
gX+WfRfENrG/pBLzme3Os2isOyyzZyf/ZLkjzCeXr0JsJm0Vq0zOZ5Ypse3s
bPFtOJJdYX1A3n4qp4v8u+UXyK8S72CvlfNTUod91Po7PIZDfPPj+MC+/wEt
Vtrb
              "]]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7207, 7348, 15089, 15087, 15088, 13362, 15381, 8026, 
              13363, 15158, 12852, 8939, 14339, 8716, 12010, 14093, 14092, 
              14091, 9361, 14884, 14088, 11942, 9228, 14892, 13291, 11597, 
              8720, 9648, 7350, 11591, 10478, 11600}], 
             LineBox[{7443, 15157, 12849, 8937, 14335, 8898, 14292, 14289, 
              14078, 14079, 12560, 14082, 14080, 8656, 14724, 14725, 12551, 
              14721, 14719, 11391, 14016, 7330, 12488, 12485, 14021, 12483, 
              14018, 8592, 14709, 14710, 12475, 14707, 14705, 11324, 13931, 
              13932, 12409, 13935, 13934, 7871, 11320, 8551, 10292, 8550, 
              11767, 11768, 11318, 12790, 9776, 7615, 13352, 8020, 15376, 
              15377, 13393, 13392, 15394, 10594, 10595, 9391, 9390}], 
             LineBox[CompressedData["
1:eJwV1Hloz3Ecx/G3HDmSKMYwx8zst2HObc4kJa3cTM4Z2xw5oqQ5yxlJ/iN/
+IPGHMPCJiYhJfzjaHP7h0kmuf5QeOyP516f9+v9/rw/1/e3PkvXzljTLCJ6
+fOwb0SHQRE1AyPuZkbcw+30iPt0T0rEA7qbnhsRcR5XBkcsGRVRiKIeEZvk
n/SO2G7OM1omXqx+u9qT4p3qZ6udgwL1neVP8LPUJxl3Qa76U4mIcmTwp5qT
To93j8imZ/gVeNo/osTcxn4R+Xqd5r3ivcFq/kXxV7lvWCF+x59mH530r5L7
zv+BtXKbh1mbP2VIxFw187EADeZMttet8knyk+S70R3iKfxG+Wq9rqI3v5b+
0vMm/U036v1PTT+5x7yt4r/8mfZ7W9zWeV7S11hkvEv+vfF09dPdxTLeEedf
TWvlZvFmyx32RnWpEYm0iGPyx1EkV+2O6o0vqf+j/gxvm/oGZ2neJ+Kj3Cd8
xnc1ydkRP2mm3Ey9EvSXOc0GRLTMimiFPb6JQzkR15y9Gu2c54n9Xzcu7OVe
huqD7mhvXupIH9NwPXBDTS1uYbjaMt4WzFA7C6k9xRnuh44d7e55V3EFS3mZ
zpmFAme9mCtPL9E0uYP69Kfz1BZgn3gvLtjrQroIOfxi2nac91WbY40ScSke
eMNHeIgKb5JmnUo1HZ1vonlJxgfsbbl+xZjAK6UlyHeWujx3jVz+KIxGXz3y
rJGL8eIf7q6bfl2xzprrkeBnIB1l+rx1743us8Za1/Fe/A63jKfK15vzAo/x
smndpnuVu9lUb9/PxTX0mPiOPX+w9lDrLbT2Bu+325tm29cuul680htVePdV
tJJX7r3O0/1jIo7axzm5s7gnX8WvNOeLb+iNus/iOvqJHlZ/Vn2V38FlNJjT
yP8g39o+i/wPaW9PKd6+BU22n0JejbOV0hVowy+my/Ef9afCjQ==
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkL0vQ2EYxc9VQZvQ5JIIUdKqj6rPe29pVbAQEUsruXQVKxKLLhqT6FJz
V4lRLCw2IYwS/R8MQiiD+Ejqd4eT83yc533O84Y3drLbhqQ8iHVJ7RPSRZ/U
GpHeB6XMiPQKL8JL4JzeMnwGr8B/3dKLLZWj0umo5J+SAuCL+JpaDY2IS8QN
ltQ5LXWABep1SebZ2UQ90S/leqS2GckhNmYlG96HC8AFJt4aefuHnU94spmz
wDNeDd7yET/Sf+CNClwPysQ+2I8myHzA03qasHSYIvZ8Ua/1SgfkhWF8T0p3
9G/HpXv4hvwY3qP/i+6K+je8S55Gv0X/iH6eehFO4e2EG5PwGjUX5NjpsjuB
3gEf3D3GfVX4k/1VMODw7/gNgji3mLCVljZj0ip/k6X/hi7E3GVIipJnqEfg
FrTNwKQ3h34erOOlgj6OvyHwD0lNSM0=
              "]], LineBox[CompressedData["
1:eJwV01tM1nUcx/Fv1CYqF80ZJgqPchCKEB4Phceboq02g/CEqwTdnLUJkmmR
JSq0pjddVa6JN7KE0NFJK3NOitY6jBuFknURyLyQ2QLMaWwyX8/Fh/fve3y+
v9//y8Ltu6sbHoiI5f4Mzo9IWxuRnR/xR0nEAB3IjvhmVcSJZRGdiYg27MDC
1RE1zltofGlEJt8YzsEJzFIza0lEX27E0FMRZ5IRXfSW85s0c2FET2FEBv5c
HFFREHFjecQonS3Vgy7Ni+iVc0T8ADZhM+7Ht2lrDlt+HXbjITXnqZmOq93s
PrPlFavJw8VYiAU0x+/lYIKK+FvUtFKp8+nHI5L46oKIZbiETuhXjiuogX8t
Vsl/kdb5nW41fy+KuEaN4re94XqxSrENZttITd7lEbM+5x02sbdSDe2R/57Y
PLEXxGpTd6I3+P/T71u9E2KXsIlvUu8avav1/p5vSs7v+K7YRnMdxC24mdrN
/YHcbc7PumulPkNyq7CKXZ16D29xUU2l8+upvBURf+ZFXFY3iM+zfxL/y0yT
KfL/j4Psc/K/UJfmO447P4Rfs9v0v4N3U7+h/23cZ94+82SWR1zFTvf4zY79
Sl32rOQx38n+pLtPLq60W6so0x7l26cCetR5Ll3wThepX88eHMAf8B09dqn9
BOuxRX0rHaTDdIhK10SU0efmuGaP79nREZzCLL6T2GVHP8U+PXfw1fu/2E0N
VOZNnsEKepr+lTesfgynyz2FGTiBM3AcZ+LD7pUnr8VcdebYTtuomf2xNzhG
R819hH50n3bsxV+83y098hbbH7kJ/qS3KPIO+9mVeqzD5BP2B18SvyLWTy87
v0ID/H3y+rHCDEf1HfcNjq20M2W++ZP89GEqz6y1ausoaeaPzLVH772U5u5J
c7T6zo3s14oiPlPfQfXUzd+tz/tmPiP+FXunnC+xi93jfF3eCF1wHuWfrv9J
+SPq/mH3400cxgyzl5g14Ts86Fwnt5a+k78Tp5m3BtPFNuD6VEx+tvz5dB+I
y8zT
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1Xusz3Ucx/H3sTjGaMvtmOPgOOg4t3RyCMd23E8bcZAcJY5bzHUpVro5
yKW20pLNZiuVYzqEwmwcE1FZbhVDI0RZbh2akNPjt/54ntfn8759Pp/35/P7
njZlM0qmJ0XEz/68nB8xoFPEyM4R33WLGJwaUWpczr4QA/nGmh/kG8JXZlzd
PuIW5rSO+CcjYkSeHAzpEPFxi4ih9GDHiGH0NTGHjQemRfTOinia7R2xY+gO
vr5sJXwjaSk6tIv4gH+stQaZzxTX9/GI/jjCXkwH4Gu5J+3lNE6yn6DH8aX4
jfI24brxZrpK/Rt0Nb1PazDcOmmPRKR0jWhF76VHrHWWjrkRmVjXMqLewxEV
NDczItl5s+kk/ciiL+Il5OG2PmW0QnZEO1rYI6IT++ZHraX+Xradj9kX26Gc
iB/wqvFita+KuYILYi6L6WoPTa1/yn4KaVWh87LtosV0N01vG9GrZ8RTahfR
NWL3WPMTuq6LO1CrSo86it9JMxP59KJ1F1irHPPxnPzRuKQXv1r7HM6yf9U9
Yp69LbXH8eqtYP8QM/gG8aWxN7bGMvXeRkvzJfqSShegFMP0dCiKCtRoE3HA
Ot9iP2bZ/xPOMdcaR9XM0Odt7marvMn20ltOH5zgmyC3l/EqvtPmp/ATXlBj
NO2gxkR9n4QktjKaq285mGH8vNp1vaUKe5mKSrU+x0LrrOevxEQx62gFqoxT
xV8QuyOR63zJ+Ej8OXkXcAxncQb17StbfC16Tk4dWkd8bdTRo5G0mXtJZm9C
t6kzgm0rHUVT2O5b5x4a6fU2tar91h5K3KOeXvO2rqCh+YPYIu9JeZtoCa3R
t2tyG6izga0hLWa/y/63HlyW+wdy1FzpHdxm202T6D6xLdhr62Myzjv/Xes/
YFzgve/X22n2/Q29pMbvqLGni/Q3hLu8Iz5JfC005FvpHe5SswrH1TuqJ4dx
CGHdcu9whTvdq3cH6B72DWI34hXxC8zLMR933Ods8VPEzRQ/C3PY14it8Z3p
4tzVdJk9LLd2pj0Pd6ZsmpX4RrHdxF/I835zkadGmrwc+81OvC/nm+eerou5
rk6qvGv0T/PLGMzXVt4XelAktsC8iZhDfM3Zi8yPGv+I8eYT0E/dybS+32Zz
eVOMU2hf9j6J35+ccWzT6VK6nJay7zKuwj7zZ82fwSi8n/itsWfp3xg9z9SX
xewj/RZL0dNdvmW+CAsT3xI9O48yeT3kjUt8k2gPsen2ccz7uOee/sVd1OA+
OvO9540tx7tYppfb2Q+LP4LG1u1n/Ua0P20ivrWetMFVsXXZzoo/gwbuspl7
+l4vK/VmPWaLmavuTd/rW5jK18+bred+t5jfQDX2+G4v8Y0+7Rv/hvEvdKl5
vtiNie+9+evitmMH3hSTwb+WPce4grY3byq+NU2hn7IV8H1G09m6+X1U+r/U
neazL1KnG83h68m2mW+a2EK2Er7udLW31pv2wSy+YjqcbzH7IGcZam9z8v//
n/ofLR08xQ==
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1WtM1mUYx/HLNm22ailUIlCiAs8DqKCipVjmOmigovOQmJqHlq6mW20u
nTbLklIzj2vaSumAS33hAS3b1Cke1sBjBqgrdct05Wm+rKQ+z3rx5fe/r/s6
3df9f/7kTJszenabiGjw50CXiJn5EeMLI16jz9C9bF1zI571PAQVj0WcLIgo
p+P4LOsVsRyVnifQ0XSemBF0OGoyI1b3iTg+IGItrSyJWEk/wSZ7H9EGe8to
hb1qugQb7T0vfoycQ+luNeswWN3nrKvZy+jT1jvYB9FC/RVhMPsWPXTWdwZK
2Mrs59BSe9k0CxOyIj6Q5/0U7N+KSbJP41tNL1hXs5+ji61n8J+u12nYJ2ZH
acR2VPM/ZL8eR/gfxinPt3pGnHaOvOKIXGzoHtFT7FtdI37oEdG+nz6ss3GV
7+/om6NPWkofLIroR0uT+no84oyYpWIbnalJL1+w9+bbB1lyl6bisZxP0RMR
PZBEIQpwf17E+r4RbbPV7C0GM+Rd09/d4JD516NZ7tv8W+hxtRbLPUXeyVgh
d5a9bGTiSlnEb7hXzo7WaeiAh5GOzfy3yr0NJ+RuN5C/vJ30cYWm6em653Sa
lpADW9XLZcvDn2Ju4Cb+0Gum/V3mvcTZ62ixGZZgqPmuNMdCMWP5JWkPFGG/
3laZ3T5aoM5ePR3QTxUmYq7YCjnKMcu8h9EX8S77QroAL7iLt5+MmI+DKTtd
gHX8f7TfyPae9Ql6Gl852zH2RfptpCfwgDOcpMvN6xQN8+9kHq3sB/V0Si/7
nf0A6q0vq3mYtuq9WZ1m+y1owulUDiTUSTh3Evmp86MAn8pxTe2rSJc/LTU/
z3fN7Ia8rXSEvB3l3+mOO9Cbfnf3mF0N34fU6IB09rvi2rJX8d/Ndxx9hP0v
9gy+mQj30Ya9Db2m17b0kjlcxhY9fqzXFTjj3E34Gdf18LVearFPrlq+e2km
//10M/t0uom+Sr+kNTgrbor4qZgjZqPz/u13tkrcVPvvqN/Lu7oo9VvyDka3
iNf5/avnButGNJl9wn3tNP/53ouk5+38zrOfQzNanLmbum8M8g2kc5+K+M65
vscuuerMZw92o7P4efKsV3cDFpr/RXpTzs9ohRzleIW9id5inyTmNp1Ml5rh
h6iUd5R8I+kRfR7FIRxGPUrUOOadTrirJGbrs47tItsl/Iph5jwU1fqsEpOr
xgSaRyfScrkn0YT1AJpPX6bF8oyn3axH0u70JZpBx9IcWk670DF0Hf2HrqZv
6n0NvWs9RP5wprXWrdYTnbcKU+Uv1lPCvY11N9v1Po6WsQ3EOXc4U57+7qof
StHO7/Ub930fnets7ekocZU4r8YFZKjxaOqbxH+M97OnnOE9+FzcHd/hfOs7
vsnp9hvU2Jr6v0Yv+ob/ghFyDMdR3/kzvudn8RP7LO/VHn7bxNbStWx5uf//
n/wPN1EsUg==
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1XlM13Ucx/G3qevQlpvLTEGxFAkTL8S80nRKeTZbis0t1GzVPJZUHn/I
ArVEbaBlpDNbgs08ynVusqRD5kzmAWh5lH9UzKGuUlErrcd3/fHi+Xkfn/fn
/Tl+X7rNWjBlfouI+MqfHWkRg3pG9OkVkUUlxjs7R+zrE1FsvJpvdpeIDJyJ
K3BlIrHluALX4gGsNu+aeVV0fmBEE+X2iDgmXkc1ctp1izhqXNo94nqW/OER
V6nLkIhNfG0fjBgg53exP6gN+w66aNxKfJXcEjop/xQtSlHfuv0fMI++lfcN
ZXSNyGbP6m+t7Igymm08emhEZmrEZrFlvSMK6c50e+bLMW8HbpS7iV6W/wpl
8y2Wv2FQxNv0Fq29L6Ict1mnnT6K9PbdgIj9VEP16u5wXndlREyzn4fNHyi3
kf8HZ/IjNbKbrHORLtBu+V8nPYvNpl/t62n2FHnP6+0Fmsm+fXBEPpbqK0X9
VDonJ7dvRLM6V6i1s38C+1I/yqSpcrLs9W9998Zr/Zw9rdPTNPvZrP5qtdfQ
DDlv4Fpqvt/6eBXnYtEwMXsqzBHHZTjWHS0R+0dOtT5u4jL2m+IHxWuxlv8Q
HmAX6rkWX8U6vjL7rRdv7z4PWzsdb+jrZ3XP0ip5x+Wtl9cgXiF+ir+MP935
r8MN7mCDeKXYL2LlfE14yrxzxmfwfOKjDvZ9N/1pHM7lkrwWeJndkf8atmT/
xd8Kn9TLdb5OYr3U/9f4pljwf27cqHZL4y3Wv8H/XnJ/yVu3x9/wBDa530qx
newqcyrst5LK1dvC/wH/M/zbcSu7Tn6+eUXs+fLetc+X1J0rVoBzsFAsy5zn
xNMe8kawK3ahg7TQPdxq3m003f2e99vJwy3ezl5v6LKeP3X3S/k+w/niC2ge
7TH3jHVO073ucju7lbfdmt4x/5K5G/GIt3WUDlOut3HceY3FOvYJ42PYQPVU
xz7qN/Wx3+EeKtbDoqQG32E6JOd72irvgvoV+L6carECefd4twuxwtx9fLXi
NcnvR2+PexcT7WEe/wSczF6pxmvUVnyw82iDQ7GPGmGPKexJ7NRkPnbEidgZ
x2EnnIDLk7N39wX0Io1Wv1jdIirWSxF9Yt3dcnfRHuOPqEpve5NzcIblyTdK
v8NxnHtr4962ueOl4iX8i3AJLaY0/fV0J11xqNqnnf9I7/sMjsBqsUfVSPMG
euMN39Srvq+3eC892B28g3Tcyd/e+EM867v8E52mk/Y1Wa39vv91vhVzxK8Y
N4g14xG+JXqbwV/N3q52nvFUetZ4JOZ7t6Xyu9vbePY4mpTMEf/CnDVqfIml
+Bh/daaecbL4dOe53jsam9jOcwyWsfP4S3A0ezz/KHydPY0/17wh1hhMadYc
ho8kefy7rJPKl0I5/INoFH82jsBMfEq/nXv8/z/vP3pVNgM=
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1XtM11UYx/HHyyy5mHb5o1UgmnlDpdC8l6JOM9pSq9lY/6izCUbpP8Ga
Tpw6LwhpaunUYIirNFODslwtsVbLstl0XbzgBSy3ShHRBai9fuuPN59zPs9z
nnO+5/t8f2TMenV6YYeIqPPno54R4/tG7KHDBkaUG3/4QEQpLcNu/hqaJbaK
fjUk4kssNa4XK+UP7WMdPWe+kn+Wlpl/a/yv3Bs4iG4ZEVPk/iBW+GBEG68V
XfpFnOAdR1VaRMaoiF7oiXR8kR3R6eGIezMjfjO/h/4yyJ69Ir4eHPENcsTP
jPQstJ7mjI7o/1DEODoej4yI6Ie+2JIeccSazXRr/4h5j0Yscp6Tnnuc+Hg8
iQnIQY/eERPpJLSO8Uy4mzf/iYgZamfbJ9V4wWMRKXQhLVKzGEvUPatu8lAx
dEU3pKLMuh6e/bAadbhq3UVnaha7hiu4iiYsds6GsRGNuOn5FnrOW3SrcyTT
7TSJbqPn5VzAOSyQ12WYu1a3q3tMwnb71qm3jd5hficG2/s5+wyhWZgr/jL+
cMetw52LttNmzzPS/Y9Ci70uucd877QAm72bFs9a4Bwhr9o833hJVkTJ4xSF
euAN3k1rV/FXYw0WqbdP/l4cMT8q74j8U/rhd7Fy9d/Ez/yV7qyef56/nnea
HuevSPSRtWsTan6Gf05eizNukLcRv/I3izfy/xI/Zf4Of6fzNppXiF2mTQmM
z4q30GYMkHOd3kADv42ett/9/PdxzZqPebdpLe2sRztiu/ptvHbs5Z+xph4H
jKs84wdqvU130Wq6TH4Ffc98rrxKVGGW/Hw1SvjZxoXGBVgofzadg0H8eXIz
6RXvYqVzpbjvv/VCKv2HXsFl3GU+Q7/OMe5uXKxXurr/ZCShyL0V4xXMx0ks
QIW+SdEzydjvPb6oT2aioz67rs9u659baMdl84vO192aLN9NjXmNPqultbSY
zlJzNpaqUYJaVOJPZ0/1XRzzHTWodQGfm49x5s/odOdu8k0eMO7D+5QekvOd
ukfVnWC/HBzmVYuNk1NnfJXXjGtoQq7YM2j0ruaLFyAfSZ5thPqVau3U+xW+
gR30XVpNG+QvlrcI0+Slye/oTB1Qw1uu5mR7TsEg3mC8ICeTLhO7YP02tXZb
+zx/Fx0oNgB7PH+9599E19j/hDsspSPMhyPDfa6nb2EjNiTuS85r9rpEW9U9
5E7baD+arp+e0jcbjTcl5nolLdGTfnOv+50O8Q64T+90pp3Q7nf8WX0xDSn8
XPo05ljzo3d9FMf9fh+jP6HIN5Un9jqtpLvU/V68Rh/uMF5nXI7ezndQ7Zd4
U+Tl0XLrP0n8r6HrsBp53vtUtbbos1qxFbzlmMmfzN/Er+Ev5ZVgOn8ify1/
Hz/DPqPVT6dj6X5err2mIjuxr/tN6/P//8D/ADDZQ88=
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1X9wz3UcwPGXJI47c1lx5Wc/TEhrKtMP/bhK/cGddRESqvlRhq6565TK
j60tNi3Tkt/zM11HNidtuhb/bKTrlp9JDDV1iFl+XfT4Xn88Pd/v1+v1fr8/
7x/76vry5IxJTSLiS/8U9okYfG/ErPsjdj8YMbJDxGztBeKfYqhcnv5Pci/J
5WsvFF+E4XIF+rVyo+QKtYenRAzoGfEsSrUru0QM1J7aKaJafrVY9T0R67lB
brncNLk9cnsTyO3DllsjTqmp4Wzzt06NuCJ/CVeNa/ZAxA1oJ94eu9R10h/Q
NWJEv4gTt0ec4xfuiCjuHTEftcjoGDHloYg30PGRiA54Uu30uyPeQV7niKK7
7JMfN+/U+6yPNP0S8Z/v9I3Yql9p/u7mr0+LSOEK/df5Mk/kS7z/toiDD9sT
v9Y/opt1U3C6b8QBsVN8kM9wlbql2qXaK1HjfHfiiLNdbu2jfL2xu8TWya/F
CvXnuREN6CnfAy3ssxd/5ds3+daNXMYnuI6P8VE+zmN816Pazaz/GLcTqzB2
hjlGO7Mx+CBxnukRufycMxskt943DeSJahc6g7LEWnjLHNfsPdsZXBH/F1PM
sdrYm8XXcFu+CckoNsdlNfP5Iv+DlWpayxXZa4Z7GGpvgzm1O3pF9EaldzOM
t3EWp8lN4LCf8TxGv7kzW+z9lBqbiWXeyFLMcoereA0+QSlWYIsxtxizgZer
38RLzbUEf1rnAl9EufhRb61Re536Q2qXmPOY2Bdyn+O03Fq5ReK/ia8Q+1ts
Gf/OB8RK5E5q/4Hj5i/mOl6gZp855/ER/ULxeZirP4c/5GRz71WTo31I7LC6
XP6VZ4vVyr3Lv+jPtbcC1IjN4Xz0l5uZOAvkiedyDrJ812RnPwXviU/iVc4w
i5N4hnttzwX8jPpp3s3bWOyOxxu7zV19i2/wtfc52rhz7nMUn+Uc76eztbtg
urfyvDczFMPc2xAeziftrZv6FOzzBvZiD55QP8RajYlxfJ6b+E0INHo3f+lf
MMcJ59rc2BZoED+Ped5Xvb/x78SqcEZdvfqzcju84Tb66fotuS8n8WS+jntw
Uw5rXlN7FW8a18e3ZnNLe2qF8eIT8LS1+jmPp7gksbZ9V4pvQ45YslwFbsRM
c7TlQc5zuzl2IFPdWIxL/L3LlaEcNahGZ7Wb+WPnu9+eDjqvrb5tt30XibV0
L+P0091HK+0e7nGkXKXf7RGcas0kb6UNmrmH7vJNucrvaJa5dvpd/gE7/QYn
meNH7XzvqIjr/P7WiFf5nf4emepfsdZh8U3uYTPK8ar6NPWZXKB+u9qPeKx+
uvhG9fP1i7DBusW8AGXin3Ge+ny8aP73zTe3z///X/0Hm185TA==
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1XtMlmUYx/HLsvSf1ubWYcs0U6fMiqzEAyCbadLBrRnYpKxlS6g2bFkr
B1YqgkK6FxCRg+gU8bA8H9LRamsrFC2d0TJptTQPIB1GJdph6/OuP7787vs6
3ddz3c/7MGzu/JmF/SJigz+zxkbUPhiRSzfTPXdEbKQnJkU00xz2DXQ9dvPV
joooT42oo1ljIiajYEjEGvvP2avoJ+MiPkYrnpefz79O/rm7ItJGRozDYb6f
7PfRQ/gQX8j91Bn/qHM0eY68hPrL6Ze0gh5n/866EwvHR7x5d0TK/RGj0H90
xPhhEc+q/w7f24MjvlIvnW8MRqRFvJYRMUPMSOv9EyMOYB+GjIg4SBPqzbgv
4vHhEZUTIloeiPj23ohq9hr7GexVdDWqMSwzopGuQx0aUJ/0i1/LV4dIj7gO
nfrpR5seMk+0mclRHEGKfvqLvQHXYwBuxFZ19tC9SZvcgbigzpaUiClsD+OA
8/L1dZBuE3+YvmJ/iL5Mp4p5lW6Tux3HPdOEyREnh0a066Pd/hhu9/y3YZfZ
7cZRvhNiPuPbKq+N/kmvoA8d+v4aK91xqZ66zfojeX/Qtd6fVuvZ5l5s5osw
3TOeEd+JJjO+qqdCd5Un5hlMvce85U2j1e6ojK2KlsjLdLflNIvWsr0lbyX/
KixiG+T8JXQp6pK5NMFXidV8JWpmJ2vQev4K6waaoKtwi5hquhpN7DXiznnf
LtFattPqNNIzfN1sF/l6aZ0+6vE9+3b+LvZr7I1sV+hZ9pZknvxO7LBu9Bw7
aQvfnuR57OtRq4dl5lSKGjF1WItTas6hzyFfXL15rzOnLnQjIS/XfTZY5zpz
obpj1S2iefat8lPpi/ap7E+qketuZiFLzZnemUHuvdl99Lnja3ja+/WYuy90
T/Mxyz4Xl9xtifNe8nw7+RNiq5Cq52q6BjWY6/1I09MLtNh7uMw6Q/0i60za
47yfcRk5fnu/q9eLU85q4C+gv6rzG9KtMzCU/V37yXeq5zeZRRfbv4en1J2J
bjWy6aMoZv9R/ZudnSn2rHUG7REz3Znn1Syjt5pbKe0Rfxn57Aln/a3GefsL
WOy8btqFi6jk30Bz1JtoLpOQY75TzHaFvCVq/mBW5dbf0CIzm+fess18Ojab
VzM24RH7jbRM7DR1l9O85Ez0O5uW8+/nX+qeOvS2hL7PthIVKLFfQRfTge5z
ntgUvQx256PpTt/KAez/+t7+5Ts7nO0mfb6uxwXo8U097Zv7C70qppv20WZ5
O6zb5PTaHxPTbn0Eb3innuBfQDeJKVBnn+fc5bfdYb2bzvG8O+gH2Mu3hZ7i
O4mycf//7/kPTCUzag==
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1OlvlFUUx/HDX6DFRA0oUBCXoIgMtKV2yuZWMFUWtShLqQVcQilI2WKl
FpQCg2iUtlAgdpsZDIJoVERQEygpUUN8oUYTX6ixKYkEExF94/J54ovv/O45
99xzzz33zlNYs2pu3ZCIaPBzMBWx+K6Ik5Mjvi6NWHFDxCnjgVERHbdEPD0i
onVcRPHYiNfpIH87/zKxndY+Y36e9c/SbvZy/ixdyV7AX0fz7BX8R2g9eyH/
atpnn9/kK5f7Es3Ju47/c/4v8OWdEefx/nD1mOung7RXHRdojmax15o/xf+F
qyZEXKF/4G1zv+My7i2MOH1HRFs6YthNapkSMZz28Z3BV85df5u68M14vcDi
kRFr2Gvudv6yiFJMQQm6J0b04LEbI2aLfRAPjIkYIf/9dCR9xNyY2yMepV1i
O3GfucvOO4+vsyRiDvtNOpd20Wmj5SqOmE7r9GkV6rFF/3rMzxfXTbPoxXXs
PD2EHG6271iMl38SezJSKEYRKuStlH8WbZT3BWzGdvlb8Kt8zdbX0uNJzc7e
hQrn+5h9Ah9hmfn35HvD+DW8NUkNeMddNOnZMTrsVj3U90L+2Xo5aJ8LuKjX
Bfo/Xx3lRc6MCd5Gmv5r7zI6ztpad1mDlNhN8lTp5UJ1L6GN7K1qep4uYleL
PyC2A4uMe/j38zfr9QH5etm7aQf24bCY69XRS/dZk09U/F4Mqr2H/R3/QTrA
buPvlKMjicO11rbSVjF70JjsY34O38PYJn6PmE38u4wzOCdPhbl2cRv5N+Al
/rP8M/ibjZvwItaZa8AW49Pmt6m5BS/bK+eehsg909wV/4mMcdp4pfhpdCqO
W1MsvgRV1iy1Z5FxCkf18Jje93vH79Jz7q8fa5O37O4milki/ixfNf3UPX+G
k/gEp7BTDTuwNXmbaEalvNv9l1qQ82ayOCPHU97Kh9ZcVN+TtDZZz5/BDHtO
dY/T6RPid/DVmF+KmUnd1lTjHjGHnemSmKv1ar24NjHtyBsfwuNyVIpbQNeL
y/E9ZO9WMQO0wlnTasw7dxnN0dXl/m/mRnl3WfarYmexX0n+K3Q3bZCrSs7n
6Frs5NuFDCr1p1SdZUhjtP79aJ+f0IQN9tlMN9Kh7uVn4wJ6VL+O4Affpmvk
aOT/27fuH9S7z2/5C/jP+84Npd+zM85/wnftF9/KPnG1yTfV/S8X/wH//tT/
3/P/AKLdAwM=
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1H1M1VUYwPGHZllpabrWzEpQ71XsxUQxICR8mSUWudzUyiWhmRV60QpK
aaOZK7Oo0CwDinJWE6HZ3GphbSFZa42hNcLeM1srAttyZVu6Pnf98b3fc57z
nPdzf1nlqVvWZETEvX5+zYxonBDx/OUR23BIuXN0xNtTI3oKIvZx2ZSIussi
9iqvFuucHDGQG9GPeYmIH/R7WvsR7tK/l3uQuiTigLFqromoGhuxnqs5I2ly
DJ4Ycbgw4nMc09albf+VEe0449KI0ddGjMyJOGHek8r/4E/lvdbzzrSId7FL
e5V4Mjvi4jERtfqO4oT6ejyMm2dEPDQu4ss8de7lUv6OH+FvuIa/5enmPU/+
+Virfj/WIUd7iitRgTVYjaXyMvKtF8OVh2Gq3Ae0TeLq9Jj8IOdyFRebY7N1
z7a2Amt90przeZZ6JV9vX2v5Bp7Nvfb7Fb5Gu/7v4Tdne2aRPYgN4u85d7r5
nOU0Lrk6Yj4SzjiJiiy4q/u46IqIbNwkL6W+SV4ll6p3uMdC+U+JFXOn+lbr
+4hnqj8jPoc/Vl9gjE94rnq9+I28WewJfJruxxvMWYPnlJ/FYjlL0Gy+WvEX
9BtkL01iF/FrvDON9jf4Re07sF3bRnt7DHXWuRX16DbPQuMe4gZeqk+j/LPk
L1O+PR1Dp7Mv4zuwzX4WpdeCA+LL5Xdwjjvc7n0f92Yf17/HWzvtPnt5Mo56
Z+3uboryhcrnWstQDEHSfSYwTPs891iCandX6g6rOEvOKOtpER+q7xB0u7M2
b/536+nD+/rvxz73u9J6Zpq7GB+I7ZRf5J6vw4CxjuMP9KNE23wcNcY9clfh
bpyT3pOxms3/qv9Xo7le4QZu5h/l75HXgt3yss01ERPQJvaoMVt5rjkXGmu8
eK3YQf02pcfSZ4H4yzxO21i02t9hZ3fKOebb+zJz53EZt3IbWvCW+h7OMl4m
vjDekfS3gG81Tp1xF/ESLMZG57ryKvfPSetZMd4blXOX2BZeweVif7vD5XyS
7+R68Z+0/6V+jG/jOd7WCHd+2vfrAh6OU8r/4iXvqN+3K1NOn2/ZYG1n42fl
bt+9LnyGE76bb4q9jgb5jZjhPR80RiE3qa8zVrP2Abkd4h+i3J2nxHd7Q33i
BXLzsUN+hXiT/F/E69VXOce8xP/f6P8AldT4LQ==
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1HtM12UUx/FTm242ctmiCDVBRSGxsjRDgtbFFBA1oq3WZV7A0DZdF7cm
TVetrbWZlinKCs1LS43lcLNyq5yAYCKVDQkv4G3pXIna1Wqj13f98f59znOe
c85znsvvmzlnUdnCqyKiys8vGRF1oyN+pmvHRBxmNw+O+IF24Dx/Df/KWyJ2
3RVxiG/hpIid7NTMiN4JEcVZEafFrBDznfkedjeeH2KROyL6bo8YeHfEDeJP
3BNxEj1YOiKieqJc9il8NDTiqdsittA+NSvGRVwrb5K8FJpHf7du2rCIHeYa
0GaNDePVz45Ivzei0lyh8TyanRMxGv3VO6L+Eut10Wp6lK4ezj82Yg1dp48a
Wku3yv0iLyJzZMRnNIN+TmfSMswsjHiETtbrMTk30TzjNHrc+GHaUhDRikEY
b71GvW0z10Tny9/ObmYPyI+4Bh/r86y9FOv9BesX0RfpjfaVilz7T+cbjC77
Po5jyHUePfLH0iJnPYbeiib9XrC3UbnOAQ/gfsxxhkW0GIuc8XJrTmUf0Esb
Gu2/GU14XI8r1FmJVdY6497fFl8iPkdPpXQ6HmS/pO4UOhlXJ/ugJVjMP4M+
rbfp9D26CuXs9829m6zt3ayhS/WzDOv5nzDfzr+W/1W+d+x/I/8Ze9umjyeT
WnzfiikX87K5Z/hmqT0b6/SbIu4V95IuZwiG4nV3c9h5dSDDeJ+7mWB/1eLy
abtxJv9wjMBr4iv4KzEXVXgW89Bpfpf1u+hub6zMHTaosxPl7EcxzX0tTu6R
FtA39FVIG43baCk9QOudd73zbnEHn9ASb6QU01Crp3+s9y/6ox9Oirkk5wS9
THPsJxvPie/mO6pOD71obg/7a3zjLe5Hlv52qzGKbtFjlZzNdL/eWlEnp1Zu
Pv8H7K/kfolx+kiRvw/N+D45S3GpdKJab6JATgffQb52zOC7nm+K8zlnzU+x
A6vtu86+K+90lpir9+vEVSR78N/8Scwg44fknWWXqtPrHVxAq7rLk/+yHo7g
R1Sa/1ven/gLf+AtMVfoguQ/h8fElaMzyVFjmT73+o/cLLfeGmm0z/esIvmO
oEHMSO/qom9Zr+/aZXPDjAd4X7+xf0WN+99ofhNOizmFFt/Pbtrqu9eC+/R8
yXf0Q771aJK3wH+k0/tsZM925tu9oa3YYzzfXH7W/9/m/wACkwKG
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1Gto13UUx/GjkUaSeZ+y7b+mm9b23306d0kDwbw2nUtQ60FzPslqbiII
XqY+8PIguiFIhEIPQgm8IG5qT2a4SaT9DaIEnaGb8/IfGjQfKBS9/vTgvc/v
nO/5nnO+5/v9L7+lremTURHxjj/NtRE3Z0W8XB4xDj9lRzwujvidlrOzCiJm
JCOmI5UT0VUR8evMiKmVEYn6iDzkWtvcELE4PyJ7Hhs5eC0vYlFpRD4teiOi
1Z7i3Iiy+RFj1CylFSjHQjmX1UQsx0dqfIxO9W7r4zt7B+gJvVyXL4WT8pSo
WYoiJFGMOv7pb1L5s2g9nUFr6VQ6DZMwBZPRgtX2NWEVmrEGZ+Xpd7bb6K2O
uIxvfG/hz1vgbEig25lSVREj1n6h+/V9AJ/VmYf5lZpDCZaawSD/EO6jcLa5
vB6xQ/2dmf7cwzU91tE2Op9epTX0Z9pAU7RAjRtqFdIBOohLeqpi99BKekVc
Hk0gG73savs3mPH75rtBP0m9v0ebsR7rMqqfF838e70P2Pc537VExBH9XqV3
+Y5bO4F3xR7mX0vXy7uGlqnRRF+QYyV95s62Z+qYQ48emryT1Rgvzysok6eL
f7f73OrttBeaOf8W2ijugppF8rRb+1ZMB13B/1zdp2r86ywjdKwa//h+xn+J
9qDbW/lAPy2odY46PCmJOKPXOXKcpr3W+nDHvgnmmHAnXWaYq1YCp+VIO8MK
72+I7lOrVW/L+Pusn9LfFP196g1UuMNK7JfnAFrlWSJmI63mn4sqrHPeVfyN
2GTtoNhDWIKlKOG7pc8kfZu9GMPeYxrHvKHr6qdwU0wxe5cZPpd3N+0Q045O
35ud6cPMPMxzWI40fvS9Xa/Nvmvkn+VcBWg01wXuaCHewl49DvtN3sMQBvEA
99Fp7RFN4yH2ZM6j/kvmMMI+yP6bHqJPab3ca824n52Ue5veJriLBv5X6SRM
xDT2X3Plc5d70YlR4jvM/I7/R3fxpbmfc4ZunMcQ33KzuEez7P9tTsRoe/6g
X7ibrzN76A12m7oX7PmKvdFcfsj8jvgu0j53e0tMP47ZcxSHxf3JHiPfIM2R
P81/JPH//8z/AOoV3Qc=
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1Els1GUYx/GnuFGNGALSokA7pQimnWGKBlBpC/QgEhZpY8CYiAEVL7ZI
wTotWmWL8VKWAsWFRS6KHtwTW4SAJsYDkQDGKKUtatvp4MEFYyIe/Ew8fOf3
Ps/zvs/zvMt/Emua6hsLImK1n5PJiB+nR/yAXyoimidFXJeOeLIm4mk8hXUo
TkSspdPuj9hTHjFudsR4zOf/IxVRS1fdF/EoVqJ/asTtlRE1/NvnRtSxt9Bt
2IodaLw7ogltZREfzYtopV/oZ8vkiOF7I7IYwjKxpcjorUX959FeHdEnZ0ZP
z4hVq3OcHpCjm3bRHtprzVE5jpVEvE2P4KuqiEr2AuOFqMU69nz6hHxJ4wJr
U/R6vhf0Olet8WIP6e1B+11Ex7Hn8Dc6j4v6eZb20iZ6ie4Tu2Lub9MifkcD
f87ZLLb2MWtHjLtm2bf8GQyyvzZ/v/g3D0SMusderWnm24AhOTexw/5HoQBJ
9s9ilfQzWmjteXlupqPVOGdcqsZPzmPAvq84j8RdEWX4U3+ltAQ32u9NmGS/
UzAZY+WocIeVuGruEu9il5q7cXpOxN93RkyfETEDO91bB/r13IdetOvpVnM7
aZq+SavoLLTp9WM5/6X/4Bo24xO+S7QP7fiU/SJtza+1l1PsIrmLMRGviB3V
5wXndR4bnVEzTpi3iZ6k6fy7tP9d9BZ5Op3DoB6GsNwbHpDnMvbz17Oz/B3O
aZi+5ExavK122iC2ChXOdSVN0iNqn1G3xbhbrfVq9tBt7Ar1vhdLGc/EgPFl
fG5NSr0O9XZirzqvmVuot9n5u6N/0dX0O/kep23Wb0Yrroqdcafr1TmVfzdy
lLivQj2ORqlxQjyt1hi1FvnGytlTUYaN3nWxOyvCB2IfIq3GaXln0i9pzl0e
tP4t1OphrVrNah9mPyfnIbqBvYa/Rvx19htoEhuwtpEeYHehWnwe3lf3GH0P
76BcrXdpv/lt+e8AGUyQ8zZvcgxG8u+Snc3vjeboDbTHuuPoRp08h+zhrDvL
epcjGMY5d56jK9zfED3LHqTf0lfpy7TIPS4Ur/K262gxO0EfcQa96qT4G4wz
7qieDvufHPE/mcMK3/TD+NV43xR3K3aHtcv5liHL38l/kX8i/1K+JTiR/P9/
9z/l++5D
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1FtM13UYx/HHiRk3JkcPnBKsRPmDAgJCMXPgRTXg7ypKCM1N3XTTbJ1s
5VTANjVaoWbLpmutraVicgG12KQr8YLC6g4PubayqZvTmZkXvf7r4s2H7/M8
3+f0+8K8dVtXbZkSEXV+dDdGtJZGPFQV0f54xAv4qSHi84KICXoe/fURB3At
L+JF/rv07ScixkoittNzdE95RC++cO9NtrfwBs7y5cqdg2y8yrYN5csi1iwW
My+irSbiu8KIQ0sikn5/Ds9j5/yIYdxTb6fcQ3ItdG+YzpRrXG8/YjNflnMm
MvAtf0LcCC2j39PTZpwoivhd7Hk66Dzg7nilXs20HQ1qtuipFTfUTIp5ulpe
ZCEDOSiws2yaJvdUdJlnDc7IN4r37eBZdfbTl9kPq7+WfkLz2fMwgmw77TFf
Fu2lObSZrsQMNRrcH3HvBE7iOE5hAF+b4edHzIKLiYglzk162kwfNssmWkiL
0KanOzRJV6FW7TrM1E9jne/J9zcq1Ssui/iY7zCa9HHZfFfFddI236rabqpQ
ibn2NQfF7Dk0FxXs1+V8Sv+v4zXsdj+p5256g69QfEJcAb25VI3HIv5YJDbf
27CDVzCNP49/T23Ee+hGL3rwq28zqN93i+V23kFH7eAM7rv7Lwa9pXfYd/F/
aY5T5vkGaY96Z3qZStMXRMySZzaW2l0NOvXbhZeQb4clcuXRUm/hoDy35dhB
r6TeI/tx9vVq/Wa2Fncu0w/5knY527ld7E27q07lFp+rVgddx/eP3PfQz3eE
7SP6GT2Q+o6+0yaUil+AZr834VP+r5wbzXbB3Yu4hEk7ecC96ZiGCnEP0tP2
vVpPc9TboKceO2pyt965mf7FV2Mftdgr/z5sFJc0Q1/qLWM/OsTVienz9/IB
lvM/iQT7LVpGV9BnzPtD6u/bOZ1W0CHawP6LPdTTCvnKkcAFs0ziih2W+CbD
ai/0BofoGPs5ZIjLRFaqH/334ai8f6q3wfvfiGOp/fsWzeaeZF9Z9P//tv8A
NkPIYw==
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1HeIz3Ecx/E3ZyZKGeXscbbscYcSZ6RL7mxn/4OMP8wQKVGIyMo+1J2M
srJKIWTvPcohZM/CKY9v/nje6/P+fN7z8/n+rs7YqdlTikVERX9Su0acrBWR
Wz/iBN3SJWIrNmIzNuFp84jhNSKuWF/FZVzHNbyuF/EGfxK/1Ij51SNKydVP
3tK0JJZhAHspXSzPF77tO0ccU68NbYe2uCr2Lr2HO3iA++hWJ6JQjV/i7qgx
h1/xtIgi9l/8zrDGH6TIX6l1RCv1dtXUm70n6frgn+/sZ5uIGuoebhVxBNfk
6tA24pT9NDREiZYRs8U8TGLxGI/wXN5CzJfnU8eIRXrK7BCRXjeiB82gVZtF
VMGnphHVaCrqmnuHPndiG/KwHc/UTpF3k9jN+Gj9Abv1fVYf2eZOax+RQxvS
gc46qZ3eImKI9WAMQmV9vGsQ0TE5k3cUuxMdTTNoL31lyd+bzjHzXMzDEjMu
xjt+C/mNoWvkW4t1yFFnspzrrc+4o0vu7TS9SG8nb4F9zvZjJr9B/Adjijw9
nU2mvWgf9MbhxhHl+ZX1Nq/08hK1+V9K3s28s9zTa34F4sbRHfScs/O4gGnO
/5qzCB/ElWHn0fHsH/yXs7/S7/iGCmbrr8ZI75lj/o3sbHoI9X0PL9iFWJF8
C+58uG8tF8NQZMbH8j5CplyT9LJHD3sxwwzNvetAtW86u4UbGKH+F7+Vz/iK
g2rni2ti3g1iavHvzOe93I3trba3wJ2soo3YeXyz9Jplrwef6Ukv3n4aHUob
qFmObwq7BIojg99PtVfKm5nEoTuffO9UgCrmPMA+zacvn1z9j8BIHNXPMbSw
f5y+1fNo+6NQhn9T/ay0nig+17q6HidYZyd3Tqt1/f//4x8GZ8Cm
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl0stvzGEUxvFjY8XOJdWZTqoVsZGi0dBRBOPWBN2204oFLYINcW+bEqlb
XBb+AZcoQu1ItYNoJVZWQqKd0YhIWrt2XCLxmVh887znvOec9zm/mco9h5sO
zYiIHBY3RIynIiqWR2yojWh3rpXrE5+sj2hLRnxYGrGbnhafQnN1xNSiiKzc
jnREKz0hfxxpcT3euS+jWfMS8kkUV0SkxH+dK2ibd7pWR3TjfFVEtbjTrKz3
umij/ry6bXSMbqefExHvzc6Jz5hzFp14Ka7T/4oO4ZldBulzunJJRIdzuf4k
EqgRv1kWMYwRvBbfXRNxD7dRZcc7dAyj6OXnp3d75RfwV4YBfMQn/HH3GxPO
R9T8cr6oJ6/3Eh3icRC37JmVm3ZfxKR3V/H9g75Fjt8Rup7HHrte9W2u4DLO
6etBtpKXOm+giFG14wsj5pg/oWemedPy4/baYlY/P5PlETt9h83iY+pbzDhK
m+kUnc3XLD4zpRoU7JFHWn2D+2F6zfzrOKBuo9xBelN8A+vEa0t12GSHDFL+
Q49pv975PDWq/1r6Helc8Tw8dX4i95DHbzze9/YX2m2Pgp3zeGBmHzJ2bOVz
q74sbdE7oPcFHpU81XgbBf3fvbvPzF1q2+le7EeTuINeSP7/7/8DWXCKvg==

              "]]}, {}, {}}, {InsetBox[
             StyleBox[
              FrameBox["2.7`",
               StripOnInput->False],
              StripOnInput->False,
              FontSize->10,
              FontWeight->Bold], {0.42281000925263434`, 0.25784557382527806`},
             Background->GrayLevel[1]], InsetBox[
             StyleBox[
              FrameBox["2.88`",
               StripOnInput->False],
              StripOnInput->False,
              FontSize->10,
              FontWeight->Bold], {0.7069764565806382, 0.26360544217687165`},
             Background->GrayLevel[1]], InsetBox[
             StyleBox[
              FrameBox["3.06`",
               StripOnInput->False],
              StripOnInput->False,
              FontSize->10,
              FontWeight->Bold], {0.27042036196566777`, 0.2648260227047401},
             Background->GrayLevel[1]], InsetBox[
             StyleBox[
              FrameBox["3.24`",
               StripOnInput->False],
              StripOnInput->False,
              FontSize->10,
              FontWeight->Bold], {0.5639978804322467, 0.3691846827873686},
             Background->GrayLevel[1]], InsetBox[
             StyleBox[
              FrameBox["3.96`",
               StripOnInput->False],
              StripOnInput->False,
              FontSize->10,
              FontWeight->Bold], {0.4085374484746156, 0.40069645310732804`},
             Background->GrayLevel[1]], InsetBox[
             StyleBox[
              FrameBox["4.32`",
               StripOnInput->False],
              StripOnInput->False,
              FontSize->10,
              FontWeight->Bold], {0.5875226643471771, 0.09437696255576755},
             Background->GrayLevel[1]], InsetBox[
             StyleBox[
              FrameBox["4.68`",
               StripOnInput->False],
              StripOnInput->False,
              FontSize->10,
              FontWeight->Bold], {0.3339006564812337, 0.09097310172575668},
             Background->GrayLevel[1]], InsetBox[
             StyleBox[
              FrameBox["5.4`",
               StripOnInput->False],
              StripOnInput->False,
              FontSize->10,
              FontWeight->Bold], {0.763717983075626, 0.0785016407122896},
             Background->GrayLevel[1]]}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0, 0.5238095238095238}, {1, 0.5238095238095238}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0.0032159172221151167`, 0.5294939938095239}, {
          0.0032159172221151167`, 0.5238095238095238}}], 
         LineBox[{{0.03230473808868739, 0.5294939938095239}, {
          0.03230473808868739, 0.5238095238095238}}], 
         LineBox[{{0.061393558955259664`, 0.5294939938095239}, {
          0.061393558955259664`, 0.5238095238095238}}], 
         LineBox[{{0.09048237982183194, 0.5294939938095239}, {
          0.09048237982183194, 0.5238095238095238}}], 
         LineBox[{{0.11957120068840421`, 0.5351784638095238}, {
          0.11957120068840421`, 0.5238095238095238}}], 
         LineBox[{{0.14866002155497604`, 0.5294939938095239}, {
          0.14866002155497604`, 0.5238095238095238}}], 
         LineBox[{{0.17774884242154831`, 0.5294939938095239}, {
          0.17774884242154831`, 0.5238095238095238}}], 
         LineBox[{{0.2068376632881206, 0.5294939938095239}, {
          0.2068376632881206, 0.5238095238095238}}], 
         LineBox[{{0.23592648415469242`, 0.5294939938095239}, {
          0.23592648415469242`, 0.5238095238095238}}], 
         LineBox[{{0.2650153050212647, 0.5351784638095238}, {
          0.2650153050212647, 0.5238095238095238}}], 
         LineBox[{{0.29410412588783696`, 0.5294939938095239}, {
          0.29410412588783696`, 0.5238095238095238}}], 
         LineBox[{{0.32319294675440924`, 0.5294939938095239}, {
          0.32319294675440924`, 0.5238095238095238}}], 
         LineBox[{{0.3522817676209815, 0.5294939938095239}, {
          0.3522817676209815, 0.5238095238095238}}], 
         LineBox[{{0.38137058848755334`, 0.5294939938095239}, {
          0.38137058848755334`, 0.5238095238095238}}], 
         LineBox[{{0.41045940935412517`, 0.5351784638095238}, {
          0.41045940935412517`, 0.5238095238095238}}], 
         LineBox[{{0.4395482302206979, 0.5294939938095239}, {
          0.4395482302206979, 0.5238095238095238}}], 
         LineBox[{{0.4686370510872697, 0.5294939938095239}, {
          0.4686370510872697, 0.5238095238095238}}], 
         LineBox[{{0.49772587195384244`, 0.5294939938095239}, {
          0.49772587195384244`, 0.5238095238095238}}], 
         LineBox[{{0.5268146928204143, 0.5294939938095239}, {
          0.5268146928204143, 0.5238095238095238}}], 
         LineBox[{{0.5559035136869861, 0.5351784638095238}, {
          0.5559035136869861, 0.5238095238095238}}], 
         LineBox[{{0.5849923345535588, 0.5294939938095239}, {
          0.5849923345535588, 0.5238095238095238}}], 
         LineBox[{{0.6140811554201306, 0.5294939938095239}, {
          0.6140811554201306, 0.5238095238095238}}], 
         LineBox[{{0.6431699762867034, 0.5294939938095239}, {
          0.6431699762867034, 0.5238095238095238}}], 
         LineBox[{{0.6722587971532752, 0.5294939938095239}, {
          0.6722587971532752, 0.5238095238095238}}], 
         LineBox[{{0.701347618019847, 0.5351784638095238}, {0.701347618019847,
           0.5238095238095238}}], 
         LineBox[{{0.7304364388864197, 0.5294939938095239}, {
          0.7304364388864197, 0.5238095238095238}}], 
         LineBox[{{0.7595252597529916, 0.5294939938095239}, {
          0.7595252597529916, 0.5238095238095238}}], 
         LineBox[{{0.7886140806195634, 0.5294939938095239}, {
          0.7886140806195634, 0.5238095238095238}}], 
         LineBox[{{0.8177029014861361, 0.5294939938095239}, {
          0.8177029014861361, 0.5238095238095238}}], 
         LineBox[{{0.8467917223527079, 0.5351784638095238}, {
          0.8467917223527079, 0.5238095238095238}}], 
         LineBox[{{0.8758805432192798, 0.5294939938095239}, {
          0.8758805432192798, 0.5238095238095238}}], 
         LineBox[{{0.9049693640858525, 0.5294939938095239}, {
          0.9049693640858525, 0.5238095238095238}}], 
         LineBox[{{0.9340581849524243, 0.5294939938095239}, {
          0.9340581849524243, 0.5238095238095238}}], 
         LineBox[{{0.963147005818997, 0.5294939938095239}, {0.963147005818997,
           0.5238095238095238}}], 
         LineBox[{{0.9922358266855689, 0.5351784638095238}, {
          0.9922358266855689, 0.5238095238095238}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0, 0.5238095238095238}, {0, 1}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0.0074814960000000015`, 0.538493811621565}, {0., 
          0.538493811621565}}], 
         LineBox[{{0.0074814960000000015`, 0.5594713656387666}, {0., 
          0.5594713656387666}}], 
         LineBox[{{0.0074814960000000015`, 0.5804489196559679}, {0., 
          0.5804489196559679}}], 
         LineBox[{{0.0074814960000000015`, 0.6014264736731696}, {0., 
          0.6014264736731696}}], 
         LineBox[{{0.014962992000000003`, 0.6224040276903713}, {0., 
          0.6224040276903713}}], 
         LineBox[{{0.0074814960000000015`, 0.643381581707573}, {0., 
          0.643381581707573}}], 
         LineBox[{{0.0074814960000000015`, 0.6643591357247742}, {0., 
          0.6643591357247742}}], 
         LineBox[{{0.0074814960000000015`, 0.6853366897419764}, {0., 
          0.6853366897419764}}], 
         LineBox[{{0.0074814960000000015`, 0.7063142437591776}, {0., 
          0.7063142437591776}}], 
         LineBox[{{0.014962992000000003`, 0.7272917977763793}, {0., 
          0.7272917977763793}}], 
         LineBox[{{0.0074814960000000015`, 0.748269351793581}, {0., 
          0.748269351793581}}], 
         LineBox[{{0.0074814960000000015`, 0.7692469058107827}, {0., 
          0.7692469058107827}}], 
         LineBox[{{0.0074814960000000015`, 0.7902244598279844}, {0., 
          0.7902244598279844}}], 
         LineBox[{{0.0074814960000000015`, 0.8112020138451861}, {0., 
          0.8112020138451861}}], 
         LineBox[{{0.014962992000000003`, 0.8321795678623873}, {0., 
          0.8321795678623873}}], 
         LineBox[{{0.0074814960000000015`, 0.853157121879589}, {0., 
          0.853157121879589}}], 
         LineBox[{{0.0074814960000000015`, 0.8741346758967907}, {0., 
          0.8741346758967907}}], 
         LineBox[{{0.0074814960000000015`, 0.8951122299139924}, {0., 
          0.8951122299139924}}], 
         LineBox[{{0.0074814960000000015`, 0.9160897839311941}, {0., 
          0.9160897839311941}}], 
         LineBox[{{0.014962992000000003`, 0.9370673379483958}, {0., 
          0.9370673379483958}}], 
         LineBox[{{0.0074814960000000015`, 0.9580448919655971}, {0., 
          0.9580448919655971}}], 
         LineBox[{{0.0074814960000000015`, 0.9790224459827988}, {0., 
          0.9790224459827988}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0, 1}, {1, 1}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0.0032159172221151167`, 0.99431553}, {
          0.0032159172221151167`, 1.}}], 
         LineBox[{{0.03230473808868739, 0.99431553}, {0.03230473808868739, 
          1.}}], LineBox[{{0.061393558955259664`, 0.99431553}, {
          0.061393558955259664`, 1.}}], 
         LineBox[{{0.09048237982183194, 0.99431553}, {0.09048237982183194, 
          1.}}], LineBox[{{0.11957120068840421`, 0.98863106}, {
          0.11957120068840421`, 1.}}], 
         LineBox[{{0.14866002155497604`, 0.99431553}, {0.14866002155497604`, 
          1.}}], LineBox[{{0.17774884242154831`, 0.99431553}, {
          0.17774884242154831`, 1.}}], 
         LineBox[{{0.2068376632881206, 0.99431553}, {0.2068376632881206, 
          1.}}], LineBox[{{0.23592648415469242`, 0.99431553}, {
          0.23592648415469242`, 1.}}], 
         LineBox[{{0.2650153050212647, 0.98863106}, {0.2650153050212647, 
          1.}}], LineBox[{{0.29410412588783696`, 0.99431553}, {
          0.29410412588783696`, 1.}}], 
         LineBox[{{0.32319294675440924`, 0.99431553}, {0.32319294675440924`, 
          1.}}], LineBox[{{0.3522817676209815, 0.99431553}, {
          0.3522817676209815, 1.}}], 
         LineBox[{{0.38137058848755334`, 0.99431553}, {0.38137058848755334`, 
          1.}}], LineBox[{{0.41045940935412517`, 0.98863106}, {
          0.41045940935412517`, 1.}}], 
         LineBox[{{0.4395482302206979, 0.99431553}, {0.4395482302206979, 
          1.}}], 
         LineBox[{{0.4686370510872697, 0.99431553}, {0.4686370510872697, 
          1.}}], LineBox[{{0.49772587195384244`, 0.99431553}, {
          0.49772587195384244`, 1.}}], 
         LineBox[{{0.5268146928204143, 0.99431553}, {0.5268146928204143, 
          1.}}], LineBox[{{0.5559035136869861, 0.98863106}, {
          0.5559035136869861, 1.}}], 
         LineBox[{{0.5849923345535588, 0.99431553}, {0.5849923345535588, 
          1.}}], LineBox[{{0.6140811554201306, 0.99431553}, {
          0.6140811554201306, 1.}}], 
         LineBox[{{0.6431699762867034, 0.99431553}, {0.6431699762867034, 
          1.}}], LineBox[{{0.6722587971532752, 0.99431553}, {
          0.6722587971532752, 1.}}], 
         LineBox[{{0.701347618019847, 0.98863106}, {0.701347618019847, 1.}}], 
         LineBox[{{0.7304364388864197, 0.99431553}, {0.7304364388864197, 
          1.}}], LineBox[{{0.7595252597529916, 0.99431553}, {
          0.7595252597529916, 1.}}], 
         LineBox[{{0.7886140806195634, 0.99431553}, {0.7886140806195634, 
          1.}}], LineBox[{{0.8177029014861361, 0.99431553}, {
          0.8177029014861361, 1.}}], 
         LineBox[{{0.8467917223527079, 0.98863106}, {0.8467917223527079, 
          1.}}], LineBox[{{0.8758805432192798, 0.99431553}, {
          0.8758805432192798, 1.}}], 
         LineBox[{{0.9049693640858525, 0.99431553}, {0.9049693640858525, 
          1.}}], LineBox[{{0.9340581849524243, 0.99431553}, {
          0.9340581849524243, 1.}}], 
         LineBox[{{0.963147005818997, 0.99431553}, {0.963147005818997, 1.}}], 
         LineBox[{{0.9922358266855689, 0.98863106}, {0.9922358266855689, 
          1.}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{1, 0.5238095238095238}, {1, 1}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0.992518504, 0.538493811621565}, {1., 0.538493811621565}}],
          LineBox[{{0.992518504, 0.5594713656387666}, {1., 
          0.5594713656387666}}], 
         LineBox[{{0.992518504, 0.5804489196559679}, {1., 
          0.5804489196559679}}], 
         LineBox[{{0.992518504, 0.6014264736731696}, {1., 
          0.6014264736731696}}], 
         LineBox[{{0.985037008, 0.6224040276903713}, {1., 
          0.6224040276903713}}], 
         LineBox[{{0.992518504, 0.643381581707573}, {1., 0.643381581707573}}],
          LineBox[{{0.992518504, 0.6643591357247742}, {1., 
          0.6643591357247742}}], 
         LineBox[{{0.992518504, 0.6853366897419764}, {1., 
          0.6853366897419764}}], 
         LineBox[{{0.992518504, 0.7063142437591776}, {1., 
          0.7063142437591776}}], 
         LineBox[{{0.985037008, 0.7272917977763793}, {1., 
          0.7272917977763793}}], 
         LineBox[{{0.992518504, 0.748269351793581}, {1., 0.748269351793581}}],
          LineBox[{{0.992518504, 0.7692469058107827}, {1., 
          0.7692469058107827}}], 
         LineBox[{{0.992518504, 0.7902244598279844}, {1., 
          0.7902244598279844}}], 
         LineBox[{{0.992518504, 0.8112020138451861}, {1., 
          0.8112020138451861}}], 
         LineBox[{{0.985037008, 0.8321795678623873}, {1., 
          0.8321795678623873}}], 
         LineBox[{{0.992518504, 0.853157121879589}, {1., 0.853157121879589}}],
          LineBox[{{0.992518504, 0.8741346758967907}, {1., 
          0.8741346758967907}}], 
         LineBox[{{0.992518504, 0.8951122299139924}, {1., 
          0.8951122299139924}}], 
         LineBox[{{0.992518504, 0.9160897839311941}, {1., 
          0.9160897839311941}}], 
         LineBox[{{0.985037008, 0.9370673379483958}, {1., 
          0.9370673379483958}}], 
         LineBox[{{0.992518504, 0.9580448919655971}, {1., 
          0.9580448919655971}}], 
         LineBox[{{0.992518504, 0.9790224459827988}, {1., 
          0.9790224459827988}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0, 1.1102230246251565`*^-16}, {
           1, 1.1102230246251565`*^-16}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0.0032159172221151167`, 0.005684470000000112}, {
          0.0032159172221151167`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.03230473808868739, 0.005684470000000112}, {
          0.03230473808868739, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.061393558955259664`, 0.005684470000000112}, {
          0.061393558955259664`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.09048237982183194, 0.005684470000000112}, {
          0.09048237982183194, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.11957120068840421`, 0.011368940000000114`}, {
          0.11957120068840421`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.14866002155497604`, 0.005684470000000112}, {
          0.14866002155497604`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.17774884242154831`, 0.005684470000000112}, {
          0.17774884242154831`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.2068376632881206, 0.005684470000000112}, {
          0.2068376632881206, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.23592648415469242`, 0.005684470000000112}, {
          0.23592648415469242`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.2650153050212647, 0.011368940000000114`}, {
          0.2650153050212647, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.29410412588783696`, 0.005684470000000112}, {
          0.29410412588783696`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.32319294675440924`, 0.005684470000000112}, {
          0.32319294675440924`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.3522817676209815, 0.005684470000000112}, {
          0.3522817676209815, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.38137058848755334`, 0.005684470000000112}, {
          0.38137058848755334`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.41045940935412517`, 0.011368940000000114`}, {
          0.41045940935412517`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.4395482302206979, 0.005684470000000112}, {
          0.4395482302206979, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.4686370510872697, 0.005684470000000112}, {
          0.4686370510872697, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.49772587195384244`, 0.005684470000000112}, {
          0.49772587195384244`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.5268146928204143, 0.005684470000000112}, {
          0.5268146928204143, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.5559035136869861, 0.011368940000000114`}, {
          0.5559035136869861, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.5849923345535588, 0.005684470000000112}, {
          0.5849923345535588, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.6140811554201306, 0.005684470000000112}, {
          0.6140811554201306, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.6431699762867034, 0.005684470000000112}, {
          0.6431699762867034, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.6722587971532752, 0.005684470000000112}, {
          0.6722587971532752, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.701347618019847, 0.011368940000000114`}, {
          0.701347618019847, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.7304364388864197, 0.005684470000000112}, {
          0.7304364388864197, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.7595252597529916, 0.005684470000000112}, {
          0.7595252597529916, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.7886140806195634, 0.005684470000000112}, {
          0.7886140806195634, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.8177029014861361, 0.005684470000000112}, {
          0.8177029014861361, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.8467917223527079, 0.011368940000000114`}, {
          0.8467917223527079, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.8758805432192798, 0.005684470000000112}, {
          0.8758805432192798, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.9049693640858525, 0.005684470000000112}, {
          0.9049693640858525, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.9340581849524243, 0.005684470000000112}, {
          0.9340581849524243, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.963147005818997, 0.005684470000000112}, {
          0.963147005818997, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.9922358266855689, 0.011368940000000114`}, {
          0.9922358266855689, 1.1102230246251565`*^-16}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0, 1.1102230246251565`*^-16}, {0, 0.4761904761904763}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0.0074814960000000015`, 0.01468428781204123}, {0., 
          0.01468428781204123}}], 
         LineBox[{{0.0074814960000000015`, 0.035661841829242924`}, {0., 
          0.035661841829242924`}}], 
         LineBox[{{0.0074814960000000015`, 0.056639395846444174`}, {0., 
          0.056639395846444174`}}], 
         LineBox[{{0.0074814960000000015`, 0.07761694986364587}, {0., 
          0.07761694986364587}}], 
         LineBox[{{0.014962992000000003`, 0.09859450388084756}, {0., 
          0.09859450388084756}}], 
         LineBox[{{0.0074814960000000015`, 0.11957205789804926`}, {0., 
          0.11957205789804926`}}], 
         LineBox[{{0.0074814960000000015`, 0.1405496119152505}, {0., 
          0.1405496119152505}}], 
         LineBox[{{0.0074814960000000015`, 0.16152716593245264`}, {0., 
          0.16152716593245264`}}], 
         LineBox[{{0.0074814960000000015`, 0.1825047199496539}, {0., 
          0.1825047199496539}}], 
         LineBox[{{0.014962992000000003`, 0.2034822739668556}, {0., 
          0.2034822739668556}}], 
         LineBox[{{0.0074814960000000015`, 0.22445982798405728`}, {0., 
          0.22445982798405728`}}], 
         LineBox[{{0.0074814960000000015`, 0.24543738200125897`}, {0., 
          0.24543738200125897`}}], 
         LineBox[{{0.0074814960000000015`, 0.26641493601846067`}, {0., 
          0.26641493601846067`}}], 
         LineBox[{{0.0074814960000000015`, 0.28739249003566236`}, {0., 
          0.28739249003566236`}}], 
         LineBox[{{0.014962992000000003`, 0.3083700440528636}, {0., 
          0.3083700440528636}}], 
         LineBox[{{0.0074814960000000015`, 0.3293475980700653}, {0., 
          0.3293475980700653}}], 
         LineBox[{{0.0074814960000000015`, 0.350325152087267}, {0., 
          0.350325152087267}}], 
         LineBox[{{0.0074814960000000015`, 0.3713027061044687}, {0., 
          0.3713027061044687}}], 
         LineBox[{{0.0074814960000000015`, 0.3922802601216704}, {0., 
          0.3922802601216704}}], 
         LineBox[{{0.014962992000000003`, 0.4132578141388721}, {0., 
          0.4132578141388721}}], 
         LineBox[{{0.0074814960000000015`, 0.43423536815607333`}, {0., 
          0.43423536815607333`}}], 
         LineBox[{{0.0074814960000000015`, 0.455212922173275}, {0., 
          0.455212922173275}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0, 0.4761904761904763}, {1, 0.4761904761904763}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0.0032159172221151167`, 0.4705060061904763}, {
          0.0032159172221151167`, 0.4761904761904763}}], 
         LineBox[{{0.03230473808868739, 0.4705060061904763}, {
          0.03230473808868739, 0.4761904761904763}}], 
         LineBox[{{0.061393558955259664`, 0.4705060061904763}, {
          0.061393558955259664`, 0.4761904761904763}}], 
         LineBox[{{0.09048237982183194, 0.4705060061904763}, {
          0.09048237982183194, 0.4761904761904763}}], 
         LineBox[{{0.11957120068840421`, 0.4648215361904763}, {
          0.11957120068840421`, 0.4761904761904763}}], 
         LineBox[{{0.14866002155497604`, 0.4705060061904763}, {
          0.14866002155497604`, 0.4761904761904763}}], 
         LineBox[{{0.17774884242154831`, 0.4705060061904763}, {
          0.17774884242154831`, 0.4761904761904763}}], 
         LineBox[{{0.2068376632881206, 0.4705060061904763}, {
          0.2068376632881206, 0.4761904761904763}}], 
         LineBox[{{0.23592648415469242`, 0.4705060061904763}, {
          0.23592648415469242`, 0.4761904761904763}}], 
         LineBox[{{0.2650153050212647, 0.4648215361904763}, {
          0.2650153050212647, 0.4761904761904763}}], 
         LineBox[{{0.29410412588783696`, 0.4705060061904763}, {
          0.29410412588783696`, 0.4761904761904763}}], 
         LineBox[{{0.32319294675440924`, 0.4705060061904763}, {
          0.32319294675440924`, 0.4761904761904763}}], 
         LineBox[{{0.3522817676209815, 0.4705060061904763}, {
          0.3522817676209815, 0.4761904761904763}}], 
         LineBox[{{0.38137058848755334`, 0.4705060061904763}, {
          0.38137058848755334`, 0.4761904761904763}}], 
         LineBox[{{0.41045940935412517`, 0.4648215361904763}, {
          0.41045940935412517`, 0.4761904761904763}}], 
         LineBox[{{0.4395482302206979, 0.4705060061904763}, {
          0.4395482302206979, 0.4761904761904763}}], 
         LineBox[{{0.4686370510872697, 0.4705060061904763}, {
          0.4686370510872697, 0.4761904761904763}}], 
         LineBox[{{0.49772587195384244`, 0.4705060061904763}, {
          0.49772587195384244`, 0.4761904761904763}}], 
         LineBox[{{0.5268146928204143, 0.4705060061904763}, {
          0.5268146928204143, 0.4761904761904763}}], 
         LineBox[{{0.5559035136869861, 0.4648215361904763}, {
          0.5559035136869861, 0.4761904761904763}}], 
         LineBox[{{0.5849923345535588, 0.4705060061904763}, {
          0.5849923345535588, 0.4761904761904763}}], 
         LineBox[{{0.6140811554201306, 0.4705060061904763}, {
          0.6140811554201306, 0.4761904761904763}}], 
         LineBox[{{0.6431699762867034, 0.4705060061904763}, {
          0.6431699762867034, 0.4761904761904763}}], 
         LineBox[{{0.6722587971532752, 0.4705060061904763}, {
          0.6722587971532752, 0.4761904761904763}}], 
         LineBox[{{0.701347618019847, 0.4648215361904763}, {0.701347618019847,
           0.4761904761904763}}], 
         LineBox[{{0.7304364388864197, 0.4705060061904763}, {
          0.7304364388864197, 0.4761904761904763}}], 
         LineBox[{{0.7595252597529916, 0.4705060061904763}, {
          0.7595252597529916, 0.4761904761904763}}], 
         LineBox[{{0.7886140806195634, 0.4705060061904763}, {
          0.7886140806195634, 0.4761904761904763}}], 
         LineBox[{{0.8177029014861361, 0.4705060061904763}, {
          0.8177029014861361, 0.4761904761904763}}], 
         LineBox[{{0.8467917223527079, 0.4648215361904763}, {
          0.8467917223527079, 0.4761904761904763}}], 
         LineBox[{{0.8758805432192798, 0.4705060061904763}, {
          0.8758805432192798, 0.4761904761904763}}], 
         LineBox[{{0.9049693640858525, 0.4705060061904763}, {
          0.9049693640858525, 0.4761904761904763}}], 
         LineBox[{{0.9340581849524243, 0.4705060061904763}, {
          0.9340581849524243, 0.4761904761904763}}], 
         LineBox[{{0.963147005818997, 0.4705060061904763}, {0.963147005818997,
           0.4761904761904763}}], 
         LineBox[{{0.9922358266855689, 0.4648215361904763}, {
          0.9922358266855689, 0.4761904761904763}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{1, 1.1102230246251565`*^-16}, {1, 0.4761904761904763}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], 
         Dashing[{}], {
          LineBox[{{0.992518504, 0.01468428781204123}, {1., 
           0.01468428781204123}}], 
          LineBox[{{0.992518504, 0.035661841829242924`}, {1., 
           0.035661841829242924`}}], 
          LineBox[{{0.992518504, 0.056639395846444174`}, {1., 
           0.056639395846444174`}}], 
          LineBox[{{0.992518504, 0.07761694986364587}, {1., 
           0.07761694986364587}}], 
          LineBox[{{0.985037008, 0.09859450388084756}, {1., 
           0.09859450388084756}}], 
          LineBox[{{0.992518504, 0.11957205789804926`}, {1., 
           0.11957205789804926`}}], 
          LineBox[{{0.992518504, 0.1405496119152505}, {1., 
           0.1405496119152505}}], 
          LineBox[{{0.992518504, 0.16152716593245264`}, {1., 
           0.16152716593245264`}}], 
          LineBox[{{0.992518504, 0.1825047199496539}, {1., 
           0.1825047199496539}}], 
          LineBox[{{0.985037008, 0.2034822739668556}, {1., 
           0.2034822739668556}}], 
          LineBox[{{0.992518504, 0.22445982798405728`}, {1., 
           0.22445982798405728`}}], 
          LineBox[{{0.992518504, 0.24543738200125897`}, {1., 
           0.24543738200125897`}}], 
          LineBox[{{0.992518504, 0.26641493601846067`}, {1., 
           0.26641493601846067`}}], 
          LineBox[{{0.992518504, 0.28739249003566236`}, {1., 
           0.28739249003566236`}}], 
          LineBox[{{0.985037008, 0.3083700440528636}, {1., 
           0.3083700440528636}}], 
          LineBox[{{0.992518504, 0.3293475980700653}, {1., 
           0.3293475980700653}}], 
          LineBox[{{0.992518504, 0.350325152087267}, {1., 
           0.350325152087267}}], 
          LineBox[{{0.992518504, 0.3713027061044687}, {1., 
           0.3713027061044687}}], 
          LineBox[{{0.992518504, 0.3922802601216704}, {1., 
           0.3922802601216704}}], 
          LineBox[{{0.985037008, 0.4132578141388721}, {1., 
           0.4132578141388721}}], 
          LineBox[{{0.992518504, 0.43423536815607333`}, {1., 
           0.43423536815607333`}}], 
          LineBox[{{0.992518504, 0.455212922173275}, {1., 
           0.455212922173275}}]}, InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"(a)\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            ShowContents->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.07728818181818184, 0.9412761363636364}, {0, 0}, 
          Automatic, {1, 0},
          Background->GrayLevel[1]], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"(b)\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            ShowContents->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.07728818181818184, 0.4174666125541126}, {0, 0}, 
          Automatic, {1, 0},
          Background->GrayLevel[1]], InsetBox[
          TagBox[
           StyleBox[
            
            TagBox["\<\"a=0.5(RMS \
\\!\\(\\*\\nStyleBox[\\\"B\\\",\\nFontWeight->\\\"Plain\\\"]\\)): \
\\!\\(\\*SuperscriptBox[SubscriptBox[\\(\[Chi]\\), \\(F\\)], \
\\(2\\)]\\)/\\!\\(\\*SubscriptBox[\\(dof\\), \\(F\\)]\\)(a) and total \
\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\\)]\\)/dof(b)\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.4744108800000001, 1.100124}, {0, 1}, Automatic, {
          1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"14.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.6224040276903713}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"14.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.7272917977763793}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"15.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.8321795678623873}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"15.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.9370673379483958}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"Tp/Te at 6M\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.19064418181818182`, 0.761904761904762}, {0, 0}, 
          Automatic, {0, 1}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"(a)\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.07728818181818184, 0.9412761363636364}, {0, 0}, 
          Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"65.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.11957120068840421`, -0.02348954545454535}, {0, 1},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"67.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.2650153050212647, -0.02348954545454535}, {0, 1}, 
          Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"70.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.41045940935412517`, -0.02348954545454535}, {0, 1},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"72.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.5559035136869861, -0.02348954545454535}, {0, 1}, 
          Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"75.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.701347618019847, -0.02348954545454535}, {0, 1}, 
          Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"77.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.8467917223527079, -0.02348954545454535}, {0, 1}, 
          Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"80.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.9922358266855689, -0.02348954545454535}, {0, 1}, 
          Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"Inclination angle \[Theta] [deg]\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.5, -0.09787310606060598}, {0, 0}, Automatic, {1, 
          0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"14.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.09859450388084756}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"14.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.2034822739668556}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"15.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.3083700440528636}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"15.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.4132578141388721}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"Tp/Te at 6M\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.19064418181818182`, 0.23809523809523825`}, {0, 0},
           Automatic, {0, 1}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"(b)\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.07728818181818184, 0.4174666125541126}, {0, 0}, 
          Automatic, {1, 0}]}}},
      AspectRatio->NCache[
        Rational[6, 5], 1.2],
      Axes->False,
      Background->None,
      BaseStyle->{
       FontFamily -> "Times", FontSize -> 12, FontSlant -> "Plain", 
        FontTracking -> "Plain", FontWeight -> "Plain", FontColor -> 
        GrayLevel[0], FontOpacity -> 1, ShowAutoStyles -> False, 
        SingleLetterItalics -> False},
      DisplayFunction->Identity,
      Frame->False,
      FrameLabel->{None, None, None, None},
      FrameStyle->Directive[{
         GrayLevel[0], 
         Opacity[1], 
         AbsoluteThickness[1], 
         AbsoluteDashing[{}]}],
      FrameTicks->None,
      ImageSize->NCache[{264, 
         Rational[1584, 5]}, {264, 316.8}],
      PlotRange->{{-0.26013600000000003`, 1.100136}, {-0.14012400000000003`, 
       1.100124}},
      Ticks->None], {140.8, -166.32}, ImageScaled[{0.5, 0.5}], 
     NCache[{264, Rational[1584, 5]}, {264, 316.8}]], InsetBox[
     GraphicsBox[{
       {GrayLevel[1], Opacity[1], 
        RectangleBox[{0, 0.5238095238095238}, {1, 1}]}, 
       {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
        GraphicsComplexBox[CompressedData["
1:eJxsfXmczdX//80S2ZMkkSWJEGXKEp8jpFEIEUohlCRUlK0IlSLJXlEqiVBj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         "], {{
           {RGBColor[0.178927, 0.305394, 0.933501], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmF2MnVUZhfecmWmNnfaczgynTgc7nb/OmfMdjHZKELTttA1lSopARYpC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               "]], PolygonBox[CompressedData["
1:eJwtlEtIlGEUhl9nLCNrRplxpmEIx2iccf4JogKt1NSITCItgi5KZZQFZYEp
XfBCtYhcmFbQJsc27mrRJqLotgiKoIIWtWnjugu1jaDncFocOOf7zuX93vP+
f93Rs3vOhCTtxMqxsQZpbrk0v0RalZA6sPawdAx7HEgn0lJbhTS1TPoek+Ip
aUWl1LtISuCHs1IrDT8Rl+NnqE9S+7RKmihKfSn3n2DjxE1YJuo5jfjVcWll
yHt+WS1dtJlR72m9q8hZS20HYCP4S8m/A5ZOMJ0D21cwNeL3k9NS9Bk2K0N9
L7NniI/Qr4d50/g1Kcf+l36vqc0UpLqIlKdmFC4+kNNN7iFqPuJXMi9Mrxxn
Q8xLErcR94A3C76reek8eEbKpCv401gEPncT37A73jMQ9TddwC8x73bEMRv2
GXLKwFOkfwB3n5m5vVqapX6A+DQ1B6jdj50ybjjrCnuO5T7i7AV3cfI3c/cm
5rvIL5YmeesvOC1xlyT+jT+cdu76wD/PfUPC37aOs3e1Uijr3NnMQXpPkPO+
yjkv5dg5798Yck6Hub9edOzriSfxhwLnznJq4s6xcW2aamfWt5hzVSBnR+A7
s93ZDmrh5m7etddmRv7Nou/eOLyFfzDtWPeBv5RyzZp2TSPRop/ZnWn2ZNo5
MC4EJ2+Z3UT+M3o1039Tws/szjjdRjwKpiH8QXLG8IOsc2UaMC2YRkwr9s2M
47+KOfeL2cdz5qfiXnuZnL3EzfR8GfUd2a4upf+/LeRaWoi5Vuyb2Mp9f853
VUm8hrgzcK4Ms2G3GTbLNDcJV3nO6sOu2QfkLmCtFf6GwwnHYFj+gPdHg2vI
tGQ7td3eK7iW65l5jTiZ8m/Fvkn7Nk2DpkXreRzs9wPnzmbmEv5PsH/DFuIW
4p8NPss0bdreFbg2NmDd+FMxf1sX/Ubo15rwWuPIuJotOBb7RubwC5w9jPo3
NUW/nsB7maZN2/8AhquQ9w==
               "]]}]}, 
           {RGBColor[
            0.8923132800000001, 0.6039015800000004, 0.2318559000000001], 
            EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmWl0lNUZx99kyICEMJkkDAwDhKQJWWao1lalEBRkFw2oWGXRIC60bpRF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               "]], PolygonBox[CompressedData["
1:eJwtlmlslGUQxx9poYWy3ZbdLl1W0oNtd9t3EaNSLgWFcgmUw6ACJdygsQU5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               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXlw1dUVx3/EvCSCIcsLj7w8QgQTkpf3pkUBlbG76ygyKpu2apVFVCSi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               "]], PolygonBox[CompressedData["
1:eJwtl3lw1dUVx29CApHk8YIPXt4jTSIYkry8X1sUEnS6TKfW1mlBBUSwFauA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               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXmYVdWVxS8gFGPVe/VqeA9SYBUlNV1FiZBEWxTU7g7jpzIJ+WIUmRKb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               "]], PolygonBox[CompressedData["
1:eJwtl3lwleUVxt+whCUswSzkkiYx4Wa5uV87goB27CCE2hYEnLIvjsgiBEQI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               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXmcllUVx59hGRiY5X1nYd4ZnckZhnfmnXnU+gCa6SeRNbbItWSQXQ03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               "]], PolygonBox[CompressedData["
1:eJwtl3t01nUdx78oCINtTLax5xk8g12fPduTJ0+Kp+QkOC7CRikCAjuMm4AE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               "]], 
              PolygonBox[{{10069, 10068, 5444, 3318, 10346}, {10588, 3460, 
               10590, 10074, 10075}, {10075, 10074, 10356, 3322, 5448}, {
               10349, 3319, 5445, 10068, 10069}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXuU1VUVx3/DzCAzzDCPO3dedIc1IzNzX2pZy0cPq+UAKpoIDD5gQDHD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               "]], PolygonBox[CompressedData["
1:eJwtl3twlOUVxl8gIAYSLpvNboIJTchlN7sFh3akOmq1CEGCI4JFbsESVCiE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               "]], 
              PolygonBox[{{10564, 3446, 10566, 10063, 10064}, {10064, 10063, 
               10331, 3311, 5425}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1mXl4ldW1xr+QBpIAGc7JgZx4kxAJOSPgUEGk1CFgiVZFoBgstBaHOt0w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               "]], PolygonBox[CompressedData["
1:eJw1l3l01NUVx1+gCXsSMpmEhENiFmAmMyBQtCqloBEqOwKytEIpiyJoIlBQ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               "]], 
              PolygonBox[{{10571, 3450, 10573, 10066, 10067}, {10329, 3310, 
               5423, 10057, 10058}, {10067, 10066, 10339, 3314, 5430}, {10058,
                10057, 5422, 3309, 10325}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXl0VdUVxi8QJgkhL/ERXjAJCYG8iVFlUBnaOk8oguCAIssqaIsDtoVi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               "]], PolygonBox[CompressedData["
1:eJwtmHt0zvcdx78uzaUSl8QjEn0SuUjyPE+oW5WirIeizNaMqg3FWtcORTcO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               "]], PolygonBox[CompressedData["
1:eJwlj0tKA0EARB8SEYOCmzEhYmCQxDQiAd2ahaLuImr8Llwki6CbiK79oQcR
IugF9CLiBYQcQPECvqYXj5npqqmqznuX+4MxYEbGZWMR1qXVgO8pmMjgpQpD
YQFqRX1l2NHTlhX1H31n+rf83pRt30eeFdWWA5xPQzMkLXpKczArJ+Y8mvdp
brcEN/p29V1V4FqC733PlkLaFLd96X3yn9NyyohZH/PwLgf67vQf+uy64dcN
q1naGfcey5H01f7U1rLUE/uec7iYhJ477utQUH+op3vH+7+pD9Rf89QVO/fs
ubWvE1JuzP8HhNoqmg==
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1mHuQ1lUZxw8ssLvA7sLuvrzw0rv47sK+l8WMawsIyHVzyAsIYgkaIAIL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               "]], PolygonBox[CompressedData["
1:eJwtl2twlNUZx4+5kBA2CSYsu6bdxE1INu+i0oiQEDVcKgTHgoogiqBCuQYh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               "]], 
              PolygonBox[{{5392, 5391, 10546, 3435, 10545}, {8975, 2607, 6158,
                7972, 7973}, {6154, 2603, 8969, 6872, 6873}, {6931, 6930, 
               6228, 2686, 9164}, {9924, 3106, 9925, 7982, 7983}, {6873, 6872,
                9861, 3079, 9860}, {8805, 2525, 8806, 7748, 7749}, {7973, 
               7972, 6159, 2609, 8979}, {7749, 7748, 8816, 2531, 8815}, {
               10548, 3436, 10550, 10055, 10056}, {7983, 7982, 9155, 2682, 
               6225}, {9166, 2687, 6229, 6930, 6931}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtl3uMlOUVxt9ld2Hvws7Ozuzszk5ndnfcGYjITZZdLgJRkVoVNaYVTRGQ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               "]], PolygonBox[CompressedData["
1:eJwtl2ls1FUUxV+htHRFWspMW/5TZ9oO7WjEgmBRKBQSEQwKkhANLrizCAiC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               "]], PolygonBox[CompressedData["
1:eJwtj88rw2Ecx18pMZuLxkopU9/YzWFOo61cVlaLMzsoN6Eof44fKb+K/AXu
uG/LcpgmF4XiiNfT4/Duefq8X5/n/X7y69srW33AiOpXJ3nYTMFGDq4m4Frt
TkHP2Z7n0Sgc/yvcv51NDsGXZ20GXjKQcV6ehoqaU0X1k4VHvVmZjwTe1YVv
NwfgM4ls2Em725Oryh3qH6gn/cs03FqyJrOk6vqvcmPyZ+Nwqu7s3LLnql0W
9Z/1U/ol+XnVkFlTdblluX3/WpTryP1mY8/Qt2XeuXnNJPJhr+GbbXfuczEr
ZJYKsDMMC4XYKXR7sOONu29J7B7+ELJDh0G7dM0qm/kHFXY6tA==
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlm2Q1WUZxu9deVF2OSxn9+w5+/I/p7PLnj3nsMrGyyiCCFEJpJI4rDYw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               "]], PolygonBox[CompressedData["
1:eJwtlmls1FUUxW/Z6TKWKWVK25nxPy1DW4ogYhRBBfcVpCJKNEZxBY0osa4o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               "]], PolygonBox[CompressedData["
1:eJwtkssuQ1EUhv820UbrEpdW2qSt9lCtVGKChMRlqBNRIhIhGEooA8xdRi5P
ICRGJCTERAeIqUSq1GWgEYknwAP4do7Bn7XP2Wv961vrnOhsNrPglBRGZagt
KqVQb0jq4LmV8yPaLZeeiJM+aQrtBKVtlIxLb14pQXTFpBPy3MQVclbRQ7OU
R2n8cm6pwLnaL1Wh2Sbp2iPNEBsb6EttOz36yO1H97XSBd7f1BzxfIyqk9J4
pVRD7GyRuv5lzoGEVKygR700AVvJBQN+y2jFqE4aZKYbfN/xLKFnGIsoZ5EH
yyVxm2VsoQJMnzDNM88d8zXjbeFxFpHOIzaP4frC5xTOW3zXyCsjz0Oejxw/
OsBrHznxjtPDYdk7NLvcYI5D5lknzsA8jTL0HaPvGsxz9P7gnG+wmQxbkLoA
WuJ+iLvFqM1juHroO0B/J/t4oc8m/V4te99m7z/4RXj3G7OZDJthNKwhasPU
XjGDh5oUeV7L3o/ZUzeMWVjTsAwzdwbtcT6GwRGz/wfzX5jvbr7/KO+K3I0Q
/wBhgVQz
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtl32Q1WUVxw+QhCzs3bt37164u/dedu/ufWMJLCbGphmtURM1wd3RfCEZ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               "]], PolygonBox[CompressedData["
1:eJw1lnlsVFUUxi8tWze6TKfTTufNZGbKMNMOUkyj0ZhAjBpKNEgbRFksYKsk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               "]], PolygonBox[CompressedData["
1:eJwlkjssg2EYhU80BrdFK0Xpr62WtoNZBavLpIlBIyrCSl0SAxaryWC3YBKX
uMx1iUUIf5MmDIpNTNhc4vnyDSfny/u97znne/8/NDGTni6T1AzKgT8ujdZI
DXBnm5QCXUEYjIelhwopC982Sjfgxy81Vkpv1IIx6b5KcuBPBL9AJCTFmGmF
XZ9U8Nm6uf+gtsndOhpDzLuc02HrZTy3HWkLpLxSb7X0h26SmQR9CfipSSo1
WU2j7SNzhuxe+AD9ffAWlfbIdF4rXTEfQSfktbpGP4/OKnpncIn+Z3ASkRZ4
0ymcoCfp2Lq5n0V7A48cvIjOADvLo/2Czytw2ck9WMHLg9cy3MMOu0FHO/uj
9kjWDFojwGVmh3yFqN212XkrfUX6ivQF8BnDLxi3GkbrmN4jMMj8tUc65Oyv
k3b5kDneMQfmQza3yX/JO5Z4zwVcVi+FOX+HbU6T1+zQ7NLBI4tXCzxFfRIM
820y7GcNvVPeuUXWO/z68O4H7+gE0Pv12//B/Bf/zCRdEg==
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlmtsVFUQx8cWKH1Survdsuy2vdt22e0SKy81IvjFV0OMQkS0BFsRIsQI
pE0EsYiCNlYjygeBigSJUUmQD2IUlBYtoH3I9gWt8hCKmCCCFhONCvHxm8z5
cDPnnjvzn5n/mZlzvcUr561IE5F+nnSe+6IiA2zsDIl0xEQ2jRXZXSLSXCGy
NUMkFRa5aZLI2+h85xcZXSYywrovwD42XwESCIpcBSeSJfIf62Jwpo5CLyJy
eLJIzniRL5Ef8T4Hn70FIkuxPTdG5AJ+0opEVqC/rVhkC08rOpfAO1lp+KVx
kQ3sTyG2x9jvw3YMsT2Dnw+JZyV+96gE/yL6p8Dsj5p+C3HmJ0V6ckQywXkA
nR50EsQ5yRN5B5xfyHEcvsblkRNx7nM5ZkwUmYWPH7NFbkf+6/h5H346/YY5
Fkw/z3HWfvzUhiyGueAPoPMWOEn4u4hfjxyfZT/lN/0Adr9HjCvlLLsQ/pTb
MotP43yI7yGfcZKJ3zLPMKvw05CAr1yR59Gdwv4t6CxH94Lf8tL8SrF5gpij
yByHX1suMoTOdtYfl5Jn3HJRnmrw14ZtA7Yt4M4gthjc+xLm9wR2C9E5hM4h
eO7Nthi6+BZ3MV+Dz3nwPoLON+CsT9j3GvYGwnamerZreA8Q23TwbyXuHuLf
RZyn+NaBzmDYuFbOtTYzCm39AXvniaEZ/Xbwh9Hbga8k6yMFVmNaa5+WGea7
YB8PWY1prVXiLx+cBLKb/eXs/03ss1wvNBBXssRsFWMtuA9mijQia9HZw/5M
bEMxy/8F8lvC/hl0UuBcCRv/vyLnOv3XieFe1j3o3IN8rdj81sesf5STsrjV
kNZGIWuv2PjXc1iH7/nYrvcsPo1Te/dsxHg+yn4Btn3YjsN2h4tfeb0StX5J
hYwj5eoHYmti3cl6Y8R6Rut2GetXPetN7dEUvurgaic8vAJ3++m1+dRPetQ4
VC41B82lifUmdD5HZyE6VZxj8gbmAvIMuFF0GsllWrGd+wzkhKCd9Y1x41S5
Us5+djH3EkOfz3Da6c1zfov/PPGPdz2rvZtWYj2ivRJxftWuC70tioPdhojl
+yJyiHx3c3YHqZfNQetB7cVE3OLRGhwI2BzQedDEGV/Htpa9YnQGtX8TFp/G
qRzf7OaJ9t8fntX8y3zf6vpIz1Pr5XKe1e5GN9N0Vk1wtVQPZlaJ1Wo6XO4j
zhb2P0EWJSw25UzniM6Ty8Sc4eaDcnDSb7NaZ/ZhdHqpmWrw7wT/Ejh3I+s4
m2H092JXFLBeXhSxftb1oxHLdWem8dJG/qs501ZkNTGtYr2X9VlwC1kPR40X
tfmNvP8K2yzSmdTB8xI4XyPXuph1FuqM01mURU8nXT/eEbVaVn3VaydWD56P
IOtdzadp73jW42uIfzr89lOry3w2C5TXZtZPxYxb5XhmyOaSzqernuU1glwX
tJrU2uz2W+/kcbZ3keOT5LWLGE9U2DzUufhP1HpBe6I6Yjnup37eAGsRmJuQ
S+H2C2yXIE+7s5jNWbyH3nb4PwBeDj568dWl9ynrFOtRyKrJdi56PmPcfoff
ek/95nK+NXz7DPxHym1mad9tJseDfHsTnTZktsPPQna6+u8I20zXXILE3xiz
GtO5GAtYX+g8CLvaDiELeAZYj0d2h+1/QP8LckosnufAOMATRmeiz+a71rzW
fp/f9I9h53M4x9j71t07t8HJafgMkMv3yEbX+6PB6Sbfdex3IfMLLa9WfD6M
3hA8L0BOc+c+FTkUsDvOUx13fy1A/unq+Jpn/xk601b77Mz07O7ne2nC5one
IWH4rOMu89g76u4OvQdy41YbOl/1Xtc5+TS2/W4+6D+R3qOa1yD5Xa+0Hr+G
/AlfQ5x7RcxyVp1gwu5RvU/1Pl+VsLrVO+1x91+0OGT3tPbIHP5DymM2Q7bh
PzNmfaKzf7b7N5sIxv9xAn0U
               "]], PolygonBox[CompressedData["
1:eJwtlllslFUUx4+00hUsnU6nztJhlo4zlBQEDCRqfFERfYBAQQgiKhjbGCnB
RFxYFJFYEzA8yE5QeCEhoIkxSAGVxRbQLtS0YMBAjIkCmmp80LQS/P1zvoeT
nPvds/7v/577pV5om7tilJltQ4qRdTmz50rNVrBYg954n9kuDAYqzeJ5sx31
vndCPujltWZ32D9abrYga9YdMbtaZnY/MTawPx6fb4s8Rn+NWVccvxK+jTXb
XW3WmTJ7D/shvs0Nm/3FegR9Cjm2EivCt5OsZ2Azk73F5Ogo95wV5C6lxnSx
+5ehbyVnK+tabK6lzeZnvTbZV2J/IGTWQ+0p+jmNfTvrdq3xWRc1S5AzT66L
o82mss6lfP0x8X+n9g+xP4T9jQqzx/BPFcBrjNke4v9If180mO1kbzo2sxJe
s2r/Cv86ekknzV4Cm9XUNLvO7PGcx1LMNdTeTP6F2F8j/zLyP0IPVdj3E/9h
9KaIxxMmC4l/G///kCPE/TTpPagXYdpF7mjez64TvPeA90Z8zuG7hP2FxDqB
z0fEP0Y9m6lnU4BfmPVV8j2b8NqVU7lPBvZfs78V+y0pj6WYOfpbEtgfpKcB
sBgAsy7Ofzf1D4LPz6z3st+IT5J4D5AvTLxBxWAdLni94ksIfYdsip0Tm1jH
wD9e6RytpJYPyN+OpMmdQeqRBDKbb3OQbvJtx3cE+yuc//Np56bwXor+boCH
MBf2vTXOT9l/Nt7sm4nkGWd2D/iNm8BZ0dNvSAs4tyI3E86fW+yPsB8G7x8q
nd+XWH+SMXsZrIbEf9WVcG70gMkc9KaUYyFMrpH7j7hzTZwTF8uJ10u8M8Tb
Ue2YNQb8nEb+KtbN8K8bm9HYFtX5/RQ+t+kvV+/4DXIeuZxjImxi1BJHHuLb
LxXOsUZsD4LpFvS11DyPWF3U34ns5/sBZDi4n4q5ndxvI9vI30uMe4k1eaJj
dZ0eJ6EX57021VjB+U2Jeu3qQb0X6j23avib/lLB/Wgj/xPkbwm5vfDQXRye
4FgrX5R83wfnK35fZm8c+frJd5b1LuJdrvG7KQ4W2BuV9ruknEXoZUmfZcKs
HP0UNTfe5Wd+Gj1WcH/d8Qx6SczPciX1HQGXQxmvVTWPx3+gxrmumddPbYvA
+Pwox+hV/CMF31c9degd1HgMmQcXmpExST87cfwo/Y2l5r6gn0H6Ww8G88Hi
V/zbsD9e7XdNd24x61LsewK+DGAf43yiSJxcCWRS1O+W6puMPhx3LoqT/6J3
8200sRLiLPgsSPj+bnJ0wPs15G8O8i/F9kba8ZPPTfTWkMfSDPwc+31Rx7sX
nyfZ7ws7froT+8FuJt96ynwGTIULh0POnUfFZ96eMzmf1ZrZe8HmTsRrU74+
Yh/O+Fko5kVib0z5Xdad3kDtmeD9EeaXOJvzGee2OF7CPJhBjOlIhrhZZFba
a1XNq8LOIWGvMxiT9zsobIVxSd4x1lp3tDLvZyR7cTCU9xmiWSKO9pH/jZzX
LsxKQj6TtK+Zcw78m/LODXHuCvarCs51zZiV6O8Ea3FqPfr7Udf1XrajN+T8
rut+ZtGvp/0t1EzfDL4/pX22a30B+xMZf4vE30H6/bLBz1pn/iD7q0P+FglT
YTuU8FzKKW7vDPs81Zu/jNivJZwb4ug67FuCtTjzVspnjmbPcr6/iNwdvKeK
8Qr1TgveA3HiFOdxK+HvmfrXrH067W+FbF4P+z+EZq1mbg3YDZFjX5nPqH+w
P5vyfwPFeJN4i7L+1ukNO570GS1/4X8e/Jdn/W3TflWtY6p+FfPPlL+hmjU6
zwvYfxfE1z/I2ojPIO3rDaunnqdi/u+hf5ZniP0/gSFjmQ==
               "]], PolygonBox[CompressedData["
1:eJwtk8tLlFEYxh8CL5OKMI42qKPOfON4+QOyTTsFr5RpKqIQXkARtJ2i2D4j
0WWJ98QWYVALc0DCC97QUSxnkySCC92k4FbF3+G0+PEe3nPO8z7ve77P39Lz
ovuBpEKIga1HUtQlNQSkT+nSHLgypHgo9Uo9D6UvjtRC/iRWeueX3sIQBPMk
B7Y90n6ilJAv+QqkTHDgVRJr9KvReg6xnC3mXAxxMlWagEvq+qhxRVwMcZ79
H8SUbMkDp5nSeJyUg146WhkwS34GavA3yN0dx541d2ZYd5ErYe8EzTTWfwO2
lqn5jHwvuWXOJeIpCcrZ32cGq2hP0ef0f8x6hVyEvVLOhPAVTZDO3fSeJeXC
NDUjzHEdvQ3YhAV4TY0yr52jmWe7T2qDo1zpMxpRYg5zyIZN5rdn5sL8Wqlz
TL024kf8jsEoOj/Raw/aOZp5OuQD8IZ3eMn5Qb/txfS0ik8/eivEvhSpAn9r
eD6n5gXU4qMGwqzH8DLntr2Ynq5Zn5F7yt1O+u+ABmbQTI0RaqTh8Rfae3jO
w3s+zDOD4Xjpjjs3cAsDnK3lTj/Rh88sqMJbJbynnyX6aaSf73j4QL1vxCJq
PYF6vC3z5r/JLeEnDMnUPaDujsd+c+bbC+LLgX98I1Ocf0ytJjTDaA97bS1T
08zQzPKYmaay9ydgfRv/u+gdoutG3wUR1lse+y7mfb7S2wLUobvI3SGv/UfM
v1JCnxd4LybeA1Cuekw=
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlnuIVVUUxlc5Ns6oPca5j87cO/feed07SgqKIaRZYCljapplihhoWUol
VH9kKiFl6mikRo9Rx2dWmCkpEZRWouCMZeiEk6U2RTT4SHKkzEyz39fafxz2
Puus9e21vvXYJzd9zoSnrzez73i68YytMKsrZp83uy1hdhjhDWmzXRmzVT3M
ptWYFfUx24ru3EqzUVVml24w2xiZtdeafYntY+hvZ9+K7YmU2YFqs1ex3QjG
xBrHEV4zzzL2++rMhuR4wJwN9qlys83gDEQ2DPyDJWbDWSP0BhSZXe5rdiff
BiEfyvoCfr7Mfj/7z8DsAGcy51xEfnMpMWBbHDf7l0Bb8aUxafYhODvQnVTj
8pHE3S3u/jQgKy6YZcF5u8zs0zL3bRJx7cD+UXQibHvFPZYH0a+Br9G9zG7C
rpIYDqG/Cp0s8gbkJcgL7O9jH2dflHZMxb0CHm8H5xx+ZjNu+wHnTMT/03D4
Ero7iT3C9iPW/iEv05B/wnsjsfTGbkzI3VT8eSfjnI9TfOg/ic41zumo8rNW
6kzOHgBvNQnPq2L5GLueBY9FMbWRi3b2WWTJjMcuDsozfq7OPxjyuxnZGrji
CDtA3o+Tpxb87IdtCb7F8W17tT/aFyP7irrpzv45cN6M4Q843wDQgv02bI/D
cWmw/RydEp79Pc16sG4LOMI+Tyxd1OFS8CoSfu7PYExFvoP8ZsGuw+ZG8OuI
vUeoB+Vf9aq6TcW85lR7f2O7gv1PYM4Cc0bQmc56T9JjFwen8l4np4mxi9ib
2GfBX079r0a/HZyZ2Oxlvw9ZLub+yK8xofbkyxl0/kTnLOuiyOt8GXE8nPZc
K+fnOAMzm0B9defcneiMJ/YX68029DZbWO85Vq4NH3dj08C+P7LOlPej+vIi
IJvI++t876xy/pWHw1Gok4THo7jGc9agyG3TyB+KuZ+/5Dxnsn0DnfKC5135
X0deZtN3G6qdO3F4mnPf51szudvNvh79Y9TVMeprF+9t4hmcxsjzmAX7Uspz
cZl1L++vqc6JNx9sa1nXx7yeVdfLE86b+FsV+mgwmD+kvB5Uj+dD/cvuLDEs
QacTjnvCHSZWVHDehdOFfC16P5KjX2UXuZ+DWdP1jqla6w9OMzoDkT+Fn1eI
sTvnViacN3G/NMS1JHIeJT+HfEjAFAdlBZ8PmhNDU87nhYJzJw6fB7M61E8j
Zz4euJ3JOizUdi25rox5vc1Dp3eomdVwPzHMHM2zfVn3+QT8L0JhMvWwOOc2
sn0i7dyJwyaIuYr8XXSuaN5yxjj4aSWONYGfGZqx6F+H/3PrvNaFMwucVmxe
wbaFdUHoR8XxRbXPW83d7+Pe78OJe2XSa3tPxuMXDw/08fmiOaP7JBV6XHko
qvB+HJH0eSGcQ+CMS3rNVGHXEO6p9XC1NvK+UH90hp6tIKZS9B4Bv0QzMOy/
xs+ukJda8vJtyvta/a0eU78UZXzmavaOxpdrt7oPikn3os7V+W3YNqFzFM6v
8l5Nj3QD4y382AI/l+FmS+TctiScU3HbhA9TAr5mvL5JZzA+/5V2/3/H9mKZ
38vPIL+Q97xrZmwJ95fy3xj4n845//T1XtbsmZf2u6aDuI4EPw9rhvO+lXre
A0a8n98FuYL3obgVxwv5tgSdxbU+uzXDF+DDwTDbTyLrV+mcD6U2NgVO7mZ/
stzrUPV4V+SzTv8dY7E5ojudfVvM752N5L293Pk/mvL7W/f4VXBGVfh+adJj
UCzPEtNv4S7Lwcepgt/FafarM+7//aqZwLNqeUbktrp7R9Q5z8rJoErndqTm
ZcDR3a6+Es+3IOsIsWgeqA//v2vAaA7/DLo/94SZrBqcE3OdO6rcJ2GezHs8
iuW9jP9/aA6XFrz+VId/sE4JPOvOVO2qBnT/5MJ/yJm814F81v+a/mnUa+vA
nF/ptvdyTqbgOVVuj+d9Bs4v83tFPahe/A9EMXur
               "]], PolygonBox[CompressedData["
1:eJwtlnmI1HUYxt9ydd1dz511Z5udnd2ZXWfHzMxMEVyzwFIy0+zUJEGjMiSj
/kktKgqvMjuIWHG9usCMyAgKj5IM1y1BDSXXq7LELsrI1NW0z8Mzf7zwvr/3
/b7H8x4z2Vnzpj56eUS8CZVAfQdHnOkTcUuviJOFiATyOeRbkU8hr66PeLFn
xBjkrnzErsaIizhYzrcO+MNVEW3I7d0iOtMRVzVHDIbSvK2Drs7gm0AdZRHX
5yKqiv5howp9f+SzyBPx/ztyv2I+DehLke+vi9iD77aKiG0DI+bjbwO6yfhc
AL9loHWyuSEVcSkZMRfdSPL7iyBTshEtxN5eGpEZEPFGIqI7fFU5+aKvLMbH
LHoT7x7ijQr7uxf+Per/oMQ1l1ZHjM25FtU0mPhPYPMLth+iz+L/12bXovxP
wj9f1E/jzSKC/NNsbBXvb/idaWOxEZt2+M+o51NoNLW0QH9i2Ir+VA/qgf8j
59pU40VqTZHfA8iPU8/EmohPkF9D3oK8AvmOhP0Lc/VWNrKtBoPy2oiP6GmK
fGbypoK316bcz13kMxy+68qIocQ6jf15+NsTrk090uy8zwzsDvvbCD814dqE
qXo7IuNeqWfD4csKnjW9V6+PNFsmdByC/4l5Og4146QA9S0YT/lTrzY1On/V
vA+8F4PVkgrjd+kK/OXc36PUcAh+NNSnp/u1Fbz2IPcrt34V758lxjPQPPr0
GHSqzvWu7Y1uEHUV3C/hp9ntBn6N5carnKTXgNFZerOX/k7Cdxe+3ilzz85o
dulpK/ns5P3qyogexXnWjJXAH88aW8V8ify6g98F6hmK/6fAa3+V3/+H/DHA
L0l5FtYT4zRvS+o9C5eR4wJ62YSPoej2YTMK297ol6F/hJzXgF1L3lgIkzHw
TxLve2xn8GY5/g6n3XvNwBFi35x3LurhOPit+NsEf4z8N8OPz7m3wmAC/I6k
sZC8nvg/54y1enICvrXe87ICHyvht+U9O/qWSXgntZua8Veov5OZawe776hv
EL14uM67vAGMOul9A98O9DK+B7FdV+/bpHs1KmHMpZNNfcE2koXpPmq9Me9c
VcO/2O7n28pSx1TsNZXm9e1bdDObvFvasV7V3jHJefS3sU/TmoyN5Omy5f1m
6D7yngFNbnJ+uieT4J8b5FlT/1Pkci7p+oVXB/g1ZDxLmqnz9OcEPpYgv4D8
lW4bNBz+LexP0q8LyO+Wub/zmO8VyC9DefhmaFbKt0o3aTb8iJRnRTMzArv+
Be+vZr4SPkd+WeggvjuhdY3ePc3UTdReXvA90I5W6H4mPUuaqYfwPb7WteqG
ToDv1mxshFFLwr8p6pUweZvedaVdi2oqJN1D6fUb1IZ+YMGzoJ6oN69mPCvC
TNi18W0V1IGfr6Ef0v5t0jwfI/9vBnh3tcMXmLWyesu6gSlirW30rqi+EvKd
kzA+Q8hnGMDUEj9VcAzFGpv27dGNbYFfnPWtF74L64yZsLuGuodBrQO8D7pB
e3nUjv2iMt+Au9HNz3uXtdN7wK+k4NuoG9kdfkqNd0d4fE6u54p4Kb8s9Y+r
ce7qURv6hrzvhWboBPnuSnqXtdPTiZ8m5hel/o3Ub2U+49nRDLViu7tYn27s
UvZtaY17qfm/k/mdWOt+age0G1/mnZty3A5fWuv91s3W7f6tzrWq5oX4z9Xb
VvvfAP9jtW+d9nNv2pgPKc73WeS7mhxbOSyr8U2UvfbzADi/nvRtVM3LUsZk
SPEejkQ+UNxvvVGspzPGQjd3LvnuyHq3tGNHyXVrpW+Nbs6DyNcljZUwm408
p3iP9E26o8X93MGbsrz/A6WLM6PZ+R/EUWKz
               "]], PolygonBox[CompressedData["
1:eJwlkc0rw3Ecx9+2WJ5KQ6vl6be1B00hkcL+Aw5uzGkHB2GK06RNRlxwk4OH
FMlFORHJRdlEzWEtLori4mgXW3n9+h1efX59Ht6f9+/zNaKx0VmbpCYoh2iz
dOeQcj7p2indwFS91E/tmO9L8lcQaJT8sGZIY5XSKvGb2S9YdJEnlyYXCkoP
dvTJGe2SB8IeKUN9iDiPxgL00ttJro/40SB9QqpFWoEsfXVVUgGNR4xmYAMP
69XSMp6SaB7WSgniOFoRuEcnhV7cZXkyvU37pSIzM35L19Rvo/ecAyzRn4Ak
GHjO1UgveAgFpA7ohi7Ik8tTC9DjYd6AXXacsKvEbBGvXryWiE9oP8OgWxqA
IH099IXpm8BPBG75jz08nTqtXnPmwMvN0dgn2lslG7h5Azd7L/D+x/wxOjsu
a7/pYxL99wppm9ombEEQAvDDvdK8QYvLuo15o1/yR2gUiHE0y9B21Fu7zJ1z
eIvBK/7O8Pfms97JfK9h/i3L7AjxHxiqVYA=
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtln1M1WUUx88ErTSnwb1dvNzfvfd34XIvYa5pVhiRMTKMsDLLVvaPLZm9
iE3a0tayJhWU0Uy2zKLmWrlsk2y1XGUvwuJOK8wtS20TSl58oUCBUrI+Z+f5
g51n537POd/zfc55fvjL6xavmiAie/jL4u/LkEjmEpHrEyIdvsjZi0R6PZHz
nKdeLBKPiizMF0nil5RIXVDkAAnG+X21O1cQW8xvNZeKjGHvwd+JvxPMGPGf
EzojV+RH/IP43y8QedX5DxMbhUMxHNLgDwdEfiVPopi8hSJNcJhwucj34KZN
Jgc2kxRph089PCfDbWO2SHWeyHbyBvFPxFdaJNIzReQ6bB21asB0UCcJhzY4
PEStMjhVUCsLzvPCIgcnEYed6Xrx0yK1xJ8jzwrso/zVkudp8mWcVv1w2J20
2IfJ90bMOG/B7gL/AOcszilXt5m4/fQwB/8L5JlOfCk6zMc/G34/cSm5+Jrg
MYdar4VMO9XqAvj2OPnQqh9NevjbCf7niMiOHJG34fkNXHrI9TqYbt/61LqF
1L/a5V/pmUaq1W44NjiMcjxC/F78q8FsiFq/2ncv+Q+SP855AfhryV+JfQrM
LHppIXZb2HRup84651+LjcI/hp57iL2P3g8RmwHTRS+t1D3GnWdT7z3qTsL6
/LYPnv9ETBfV5xFyzPUNP5c6bUnDDIBJOPww59MBy1MK9pjTpzpi86RzVcKd
LnXz2afzxm9bwR8NWM/a+3r88+DZCc9S7GjIdFA9vo4b/hBx4wmb5/3ku5Lf
cui3Gl990M7lnH9wM6/YYZ11ZngIez5tM6Z7kxU2nsr3ZWptoe7vcPgubHVH
8J1Dux2cW5mlGSXWy0xyDHg2h4Pg94ZMf5337oBppRo/y92xGrJPe3XzqbvV
4fD14BvANHK/Tej6oGdzovOyOWRz6IG5KmH7rntf4c5b4bjJYfKiprvqP5Ec
PW7OG/FXuTfkFmwv/jx0OI49RQ8LpopcVmJvgc55C3d9c9g46E40u/lcga8g
au/SbLBDxFYRm0tstpvnd2j0lG/3q/d8IGLa6q600iNtS1fE5l7x26j1ltMn
n3xr8P+HDk9g/6KHv8GcIZ/n7kvfhnLf9r0MPu/G7F70fprQvBPMGTCV+eZ/
nndprMg0V+3vD1rO9cxjOb+9CGY6/uGUxZ5N2T0pH+U132Ek3+ZV+9pA3XXu
bckmth9ulegwrcTuQO9C7+2KtM2Jzssfbh50hxaRqw1MM7lryXUSfZaCfyVm
b+lt+KsiptV42vZK90t3TmM09hOwIynjOQbmcc/eZH2bR33rUXstI3Yt5xux
23Nsl5d5FqOxS3KNt/K/k3MmaH1t5scj5P8W/r9h+1yPvdhf3M7qLpa5d1vf
YH1Pdd507t4M2rmLc8LNjH7TWgtsH3Uvd8aN20a06adGB7VOYI8nTZNn4Lko
YbusO613oHeh96a6qD53w3lKzPwfFZl2qmFLzL6XOvMf6oxRdyUzX8nvI25u
B7HPBazHo2CvCZvO+v6Vu7qz4P6v+xZrHzrrGnsXORsCxnkgZfuje7QY/xdO
5+Xw/4q6T1L3DurGHGfdA51Lnc8PYjaLel9Dnn2rVH+dr2Xu26T59E3UtzGO
DqvcO/kY9gJcI+Q/Dd8lJP+UcyO5F3Lexbka6wdtNtaAP+n2/QS2233HdXb+
dJqoNrc6DXUe7yX+M/K8hG8UHn3s5k1F9r1XTBhMDZiPwdxeaHepd3pDxL7N
+jbq/zX/A5X1XIY=
               "]], PolygonBox[CompressedData["
1:eJwtlW1M1WUYxu/ByeIQ5Ti8CeeFw/G8qNMFTJPCTR0mxqTSVWurPtgGsw/6
hbZKW2trE7A2p7FVGppr5aoF6WxtKq2wBctSozKVSssERlBoaqMX+13d58O9
Pc//uV+u+3ru6/nH121csyHHzJ7DAljxPLPpW8xW32z2V8ZsHnaa9SDfzs41
m6oyiwbNHrmJb8VmuWmz5Zz3EtxcYTYzZtbOepKkxzkvyeabTe4Yub4Nm/Xk
mnXkm72QNKuMmhWQ6yf2U4VmbxP/DvEHqNFM0GCp2ak8swX4PI3vtbRjS5Dv
CusFfCvkbACfw/h2Jj23auSWm9VV+Zl85uM7i/xlWA8JerG/42YncxzDP6z3
8K34RsffzboyZTZEvlowdZLvWLGfqcf8mHMibnYSc4be2qm/Bbs+C4D4D4Px
E/D24fMFvi186yV+HHytrBdi3ew/Z7+I9XkwvAzeP8n3ewTs7Ac4/4P9IOuO
MrMP4CbJvhG+Hw+Bb4ZZNTGLOT8Rdq7V/0nWE/Qfxv8Q37bRf0XGuROHEdYf
g3U3/X2F/wrqX4HDVnqrhY9jxDZQb33QOQlQL1XqtVTzDvwz5EhjSSyFTUUc
u3rYiu89s/0udadvwNc6zuvM6z3G+vly7+8V/C+A/9+oYxXmSeofjPlsHWL/
KLn2MCO7sSF6+xo7V+T8zSF+DvFN+OzP1msA70sJn1Xd11J6uRhxLl/Dfxz/
49S4Neg9fwaWpux8isNG1g343I7vm8RMUKud/RZsE3k2Y93ZeVXNuwnaVuq5
VWOM8yX41mOjxI5hmwt9FjQTZ5mNHvh/Dxum1vfYU1Gf9WnuJMDdjvDtYth9
5Ks7rs7iCZD/mahjVw9f0ssS5eBsVQFaKzF7P+W9i4P9Kccs7D+S65z0xzz3
47+MnA+TOxBzX2nc4GtxyrUpfSSodSc1BvNcMxuJfSvhetB87GO9N+Rrzcwu
9m3ErKb+CDmWk6uL/C+yj9H/R+wzcb873eGFIscgLEfJESf//SG/C70hepte
L3S96U2ay7wdLfX80ncz2O4F85PU7mT/KrV2ljtWYa7nfEepa1kzejXuGpVW
T8PVmRKfYc2yZkyz1hZxLMJUR+yljHMrjuvhepSY3DzX/3fsn424tqXxJPgn
8F+J/wB4L3Hf35T4/i5snLO19NdY4DmVOxJ1fHpz4vAzxrcVnH1K/Cjxa0Ie
qxzKvT7iWpKG+7nPrfT/YfZ9WMX834d/Q4HnUK5f4KAs6PreBb6f4649afAB
9jklzp047Ev4DAmbMP5GfB+cHMFaqNuK9aX8LnWnQepdjju36mE7fD3B+fV8
1/Q1equhh+q0vxl6O2ZEfJalsfn4T8ZdO8LzK+uxtPcu/ENgeTfkvekNXMtg
rKzwvXp+kP0RODiMLeVel2GhLD96c2ayvpz2uxB/ugtpUtqsoVYt1lXs+tM/
5yG4OlHlXEljV8HXFfJe1FOb7ifsb7fm9zx5WlKuXeXYFHVN/69tzn7Ahot8
VjQz/ZU+U5otaXAD+E6F/VwzrlnviHp93dk0vjdk+dIboLdYnIgb3fEIfDZV
uRakiX7lTrn2tN8LH/GMv/3Sk/7NO9DIdmwhfS3Caqpc69LMbaz/Ay7iOoc=

               "]], PolygonBox[CompressedData["
1:eJwtk01IlFEUhl+aqbQfgrFysvEbv5nxJ5gWGRUT9ktECbaooBRq0SKJqKBp
UcuCSTPbFFTCDG2DFkpFBPkDWTAy1WaC0LBSYgwJQYkiF9lzui0ezjf3nPve
95x7xz914fD5RZKSsBjG1kqjsCsiXVkq9dZIRxLSs2XSUeKTqPQU7q2R7sK7
mLSK3Ftigt99iGV8qQM64T06ReiulW4sJxeS9lRJu2FjpbStXNpP3d46aYr8
T/IXPSkNdfVSLfyA/AqpazUeKqQ4Pq9S14FmJ0w3oLFS+k70qY3BPNphfJXw
VeCsNzBD/gB1sw1O1/RLfO9j7Ruxmt8efMVPD7660ciw7zp84uxxGGYeAXKv
aty65W9Sd5+1Sd+dbR6m4TWeM+w5i+cUnh/iuR+/A1DOjMvgGDN9js/jxBm8
Rvj+g94C/Ys5p9AvLpF2ot0EO2CDwXkedSVmOwVbOWML9LCnq0z6xTy/cM5n
SFfjl7uc4DuC7nqYxcsk805Rd478MPmP5o31wZCbv91DEM156tqpa6futNVS
94C1R9QdsjeB55aE68f6yuE5C/34y+NzO331cWm9UIW/W0GpOSwNoRllRh5n
3Gb9DjRRO8KegUqnYVqb6bcRftNnIcCMyfnsLeKhFHL9WF/2Lu19nsTLCzyd
IGY58wzfOWKY3Lqom+u/+eLBIzcXc+/D3skldBfQTROD9BKAZnQeU3eQmOSd
jOJ5jHvdxB03/n8z9nbG4SW5a+Ra0fxAH20x9z+x/8sgHi6jMxR3uqb/F7ba
h2k=
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlmlslFUUhk+hbFYJbWcoDP06nWmZDhUagUQtCkGbaAFT9y3RGEkQo1Bi
yg+NGFFoHUhcAiXUoFXUBGuJu/hLIEEtmEFcEBIVwl5R21QW2YL1eXPujy/3
zL3nnvOe9yx3UvOX3NU8xMy28w3lGxOZdY0wK2U9kjIbGG7WljC7iW8v8lcT
zfrTZg+NNPuvwmzFOLMPrzCbXW1WmzXLYGNjidn4pFke+Y0qsyr0GgvNrufw
yzKXO7C3JchZzpfh71v85vD5HncexX4xNurR2QuwpZz/wdmGUWavsPcsdxZw
9zFsLuSbjH4LeyfRm8r+a+j8Vo5/bB5knQO+ywRaOBbc/N6NzS3E0sj+J+C/
lXUusTyF/HGV4xb+d0rNvkBuYf8z1o8qzS7i61fspGvMVmHzT+KuQM4hnxAH
yKuR+5EbwTwDO4uwc2fA0DDB7Bo4/JpYpmmtDDhjZt/FzfrQeR1fh8G3ucjs
EGuKGIvwGxHjdYGTdOTxyOZW9A1OvyFHOfRnJDzGDLrNkeuLy/PgeRe/51iL
sdXBtT7y9Thyl2oAnHeD8yDyZuRZIe8N6PfCWyc4JyFvA08OPOvI0bGwnyeO
HQnPywC+hgVsivsBvlfRH8XeWfjZdSUYWB8p95oZNclsbcz3/2V/Dfc3gvM0
vi7B421XmcWv5nfWuc2h2xpqbDo4X4g5//vY2w+nheDZCZZG7C9Dnsf6Phwt
Jo+bWM8Q7xPgvISfXYHzf7h3c6ilpZyvj/ndOdz9Gxyd4OlnvRDwDGY9Z8rd
gXKvXdVwNfZ6yUEP8nOR45b+veC8JeV8qp8Gg53zrEsyjrm91PkVn4diXgfC
NphwfrV/FF8Phxx9Trwn0HsLnYOcp4mnDpzTU14T4n8InJ8MOjPZn02dL4CH
ds6bUt7vp2KeY2GbqZzjgxDs7RL3IV+qi08rnRNxMz/E+zQxHguzYiV3k5HX
vGpf80I2nySuG+H3HPIGdBYGna3Yb2A/D+ZtYH8mzAHZXhvmwGj8D0Req4dT
Xt+q83tKvV5Vt83kqxceN1HnPxNvS8bzm8dXH/XUxf73tdRztddtOzYLsh5j
AbU3I2B7E/1z3L2BOry21PkSb/Xs/5V1O79gv071hLxX82S847nMuhs7B9Bf
Tw2sjPl8KML/YfbL4Pwoa0/Cc70n7fiE8yKx5/k9Gp2zyKtjXueaJafKvKfU
W+JCnGhGqpfUU03V3j/qo/vBvAP9H+BzXtq5ECcnsdNd4pyL+50Bg+ruTIlz
qBmg2BTjafRPIBdgZys5jzI+V/si7zf13ctgKQ+yevFUeBcMuS3UreZZUZiT
K4ipK+mYu1lHgLkJnqdwfrTE86uZNBj3HClXL4a+1nwVp+L2Qfy0lnjuVKfF
Yd62oTutxm1OJlebwTwOuZt1bdJtam61hrxofqv/xf8F/E6Me88+H/nc1Pwc
FnlfqQaOcy+bdfvys7vWa+B35IKkx54j7vowq8uxeaTG+c/Xeo7laxX7P2Jz
pObJWH8L9Q7qPdQbpvmjOaSeVG8WRz7XxMPymPMlDEPBMiXM7fq096o4yWR9
7iiW5ZG/x6qN/XBVE+LSG6h+UK6P1/i8Vo0tr/CeVJ0sjhy38E8t9zpT7j4A
S2fC+2VWxvOt2PW/YE3c8W9HfinhM2ECOj0T/Q2amwg9NtznQS7UuXLYEfK7
L+3/OXRXc+UOfv8EV7en/b7s6A0Uv+JZb+OiuMt1ae9n8XBfqb9tqquyCn/v
FftZYtkT9z4ak/R6kt917P0PfXtniQ==
               "]], PolygonBox[CompressedData["
1:eJwtlGto1XUYx59dnJYX1J153Dxnx/9/O8eT2WBq0hauIW5qWwVR9EaQgiVU
GnZDyRcrbc2VBrWRYCzSF7oSdfQi6kWtyMRSlBC1UtklXafYsl1cVl4+357z
4oHn+f2e6/e5BE89/+jGXDPbAuVDuXPMbvBw6E6zFeVm0VKz3bx/dIfZWGC2
vcTsaoHZHuRB5AloH/zUKWbPFZmtwqYb23eQuxJmfYHby6YffiP+upBPY9MY
mtXEzJZDZ4l7DhqKm1WSSCf/Q+i3l5k14W+InI7jfwCbKPIz6Izhaxb6XZPN
7kV/YdTsraRZG5RHnvnQp9i/iH4r+dzCfg2xtqL/0HSzC4qJnCKfHOx75pt1
oHORWE34fxX/u6Jeq/J/E3/Fd5v9O8NtFqapgXoboJXzzOqgZwvNzhR4PrWB
56BceonVBz3G/1H+G4g/gf21BdQ1zeXz/G+gnmp8n8kDK/gbxa7/D/kfIr9b
JY6FMOmgtrfnUjO0htgPQt3UfgTKUNfvUA5vBtWg8wC0k56c4GkT9t3Y74c2
wD+J/1PU/g22X0N1xKmHFpHjw9O8ZtX+RKHXLjmKXFvus6KZmUT+F4n5Afi+
P9XsMH7SYLgaLL8Fj0p6Nxx4b9XjDPUtB9865O+w2YIcL/VZ0ky187c57n8H
8dcz2+zL+d4r5bAu5hgKO2E4vsAxlCzMboJdeZHbK0YTsf9Le+81A6uxf5x6
Gqf7m/5eIN4m6Di5f5/0GdGfdK7z38zfsaw/5T7M/xT4Tt5+xd9whP5AVcSq
hvbOdiyEyS8xx0Sy9AeR94DxBLmewMcK8BkNfNf+3xliVfH/IdieZB6q4RtC
3x3t0D1g9RK0CLx+5O0o+WTI5zfoPL5/ivlOabf+JPerUEfCd0E70cg8NJf6
rGvmdxd5T9Vb9XzyXWaPhO5bMd7l/zIYd5HLDvS3U+cF5APIrcivI2eQ92f/
30C+if+12M7FXzFY/xX6/OptBP7plMeX//XwlTG3l7/XsL8v5fOjmaiCL2CW
J0Gfw38BvQK9DE0Q52+oKnRshGk1/I5SvxW6Gf3IFaH7ks/PwGscmsFfPv04
Br4txGzL9RqHqOVIme+KdqYY7L6Keq/kvxP9jxN+63TzWsCzPYvv/dR7jbxG
s3jJZxu+87L7lNTNge8JvXZhMKJ8Yt5r9fwK+otD3x3lW0YtP8/xW6D5thLf
ce16H7r90KnQa1E/T8L3RnzWNKOn2Z3LEfddgbw08JnQbIzrFkFLAv+TTgbd
UXyPxPym6LbUpLx2YTzGbKfSXotqSsMvK/TahcF7YDEv5bdT8zyA/i587oz4
zdftryPeysB3Rrujm6PbsxgslkR9Z7Vr2rlkkd9U3Vbd/Jlxv/mSdXNrsJuV
8Fumm1ZPP3qTfjt0A7aifyXts6UZG4T/JOWzqXnMwTaM++3VDU7At5b5n2a2
Bb454vaa+Qrd2LTPunr8B3x7oeOvmfoB/Adijr92XrdgW8T1Fb+f2TiI/iVi
1ZKDIZ8NvXfycQ7+NpooLnA=
               "]], PolygonBox[CompressedData["
1:eJwlkk1IlFEUhl/NMTOTSHNGRzM/Ta1FlLZR0cSfaGqIcJFuDdpEpfa3ClpE
Gv6M0ORKEcyNoUwouKjVVIaYCiYuciON4IyBumiyGYvI5/ItHu757r3nvO89
3ym42dZ0L1HSaXCA15KWDkmfnFLbCakdQlnSd7iaKz05KE2dlM6UkAMxmEuT
/JlSx3HuQx01FqhRz1rvlv4h4CkiH7xwhT0PiNxacv8XS5OF5Kdy5pJ8+VI/
hE9JG/A0T5pFN0IcQPtPivSWtQ9NH2Tj0QWv8DyKbrxAaqR+A3RSb5K6l9F9
j847eJ2BP+RzWS9yXgNH0Wulrh8fQ8SDUEdOgNxnnP8mrwqvsWL7zNxZRzsE
S3hJQfcr6x1qVlJ7/Jj0Ab8foRI/FeDgHYsHeDY+x80b0WtBo4f6vUajVNqF
HeimZ1HWNXo+xNtnqL3JP/iRZffG9MhLzgP8TeP5EvFd4jFiB+9OhgtonsWX
hd5P6kThC37m4CFeVvAySxzE68Rh3kLcwf592CZ3mNwt1mb+aQvc4G1c0XPu
dxP0wB59v52ED/ryCB7DKjrfIIjnBGqE8TyAr1v4q8Wn8JbgtmfLzNhn/C1z
77pl6xi9CLqD7G2yxrkTg2z0XfyDCTRe8N0F6+Q4qRtinYd04gXLPjN3zhPP
UOecZc+mmdFf1Bxh76XTnhszP3F67T0i/S2159rMd3UOPUqmt9xvMDMF5eSU
QQY9esN/ucbePr3sgw0=
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlW1MlWUYxy/QQVLWhIPA4XA4h7eDiuJbbsgwlYllrBc/tOoTObe2hpRt
uT4131I2UCpsteZKaq0ZxabFaq4lw0ab9UHnylxlKeMlxEJhRDO037/r/vDs
vp/r+V//639fL/eT3Pb81pZ0M/uIZw7PxYVmH7NZFzM7t9jsm3vMBlNmv/Oc
YX+ZdVOhWVmmWWOZ2TJwL7HfHTF7sMzt+r632KxtrtnmfLOrwXcfmNewH7zL
bA3YryrdtwqOFh5g9mXC7HVw7Yi6CXZ/xDUM8bGdfRv2MezPVJjN3G3WVOE6
FLeeuNfAHANzA56lQZvivJ/t/IPYHkqa1cwzq84jLv6z8LzAuhp7F/ghOD7h
/Wl0zsTNfg7axJEG1/fomcOavsj36exvF5h1k7efyN9V/N+DZwy/ds7fQx66
0fxdidkpeI7kmNWh+dMsswfK/Jw6b0fEdUv/GPvFKbfPwP8HvCfhvwzn3KjZ
QAa5KEc3+pagsxHuSwnX/xeYi7xnw/8ja0Oo1y3O1Bp3DdLyTqnZs2A2oPHP
kLdN5CCGviLOdQp8dZFZLfjHkx5DsVrgSA8a0li3coZeeFrhmQKXBSYPTG+p
17qD8/Wj9QfwzXDvyKW3iHU/fBmF3icN+C7lvZ+6VLGu5f0A9kx8G5Puu5FY
tcF+i/2r5Z7zGs5bH3WMsNG4a0jA0xxi/Z30XlSsVjg/QFszmj9knaj0nlfv
nySH/+J7hf0b+P6C76PwZC7xPhymJqd5Xw7mFeJ0BswAthU892GvxL6l0Ouu
+h+NhD5Z5HlUPnfk+AwoP7fhOIqm4+CnyfkjwpCHVfTnnQrnEV9DOKNyuZ0Y
D2PvAzMeapovzpif5TyzeyLk/1Cx94rq9QSYSc67ZT6xWNPgjdAbb4KdCbUr
gK8anl3Y68q9TsrhW8QfjXlvX2PtIPZyNOSAn0RnDWe8wVqLvR79TfDFg69q
fhwdv6JzM+c+FHzvjbtWaZ4gtxMx72H18ij+0+yfxPdKmB3172TAaF5Tcc/5
+hKfPfXDdMr7WP1ch+a9+Z7bY8Xei8qJcvMtZ+ti9s+y3kRPFv3QB89Ars/+
/lLPqeJOEufFMAt92X4vCLOL874b9VqczvP6KdYR4uyJeA5XxDynyq3mY17U
Z3lkoXOJ82W4R4ldgIYR1gPEbtJMlXqNxf8cHCn2K8ntWngOh/uwh1x9HTDq
C92PsrfxvQr7GvAbkj5j6v8FfP+8wuveleM1UC1Uzy94zoBfVuIzplnTLI6Q
ox5yNVzufa/+vwCmE33bdY/l+92te/IpONOK3bebOPVhLnaS17dz3Xc3HJ+V
+OxohgbCvp+Y10Pdr5OTfaF2mo/VcP2GhlVaiTUfnVPkcJAcnsNeiH19oeNV
8/TQ2zrrSLg/t1GLx8I9prvzfML7WXf2FDxD8KwDfynmeN27F8K87wE/XuTa
hpJee/XAP3GfH8W6E/V+/V9/0mujWszyf+gM/zXd67OVvte/bjhoU8yd4T7v
LfH/ru4c3T3jYDI479mE51H51H1zMOq1O0zdNsa8/3Uvam7Veyux/QdT4Ddo

               "]], PolygonBox[CompressedData["
1:eJwtlW1olWUYx6+zrb0cs9g5x515ds6z7exVp84cWGt4tnnAbCJWH3r70pAg
iLVVUJRQbBFu4UthgutLNaoPugzUNDDUchEhUgbll3RRbhnq5sw5NdP1+3Pt
wx/u+7ne/tfLfT2VG3se684xs16QB0obzOKgYJFZIXgyavZE1L9J9gLnFvSG
5pn9UGM2XGu2GcOnC80+57w9brac+0yB2d+VZufTZgvDLv9+gVkGnXFs16Hz
YcKsM2n2DCgiVhgcRp6622wL8vwy5yAuS+vMloFOfGaLnENjyqwZ2+Fc9Eli
awwd4o0gP8W9i3gF5c6vEw79VWYv4v828Q9jfykw+w4OI2AK3ldAa6nZs+jG
4B8i/kTKc/kZmxS2Y/g/B6axvQZOVMCTeFCz7qTnoFxUM9WuCZvfsQ2TfwL9
dvivRP9j+F2E7xXkzeTbj/w9uB6Le23u5Z4lzgPc7wdpeFSBsyVmZ8DNerN/
wSjnDfOpbb5ZDnmEFvn9JD5DyL/BR5h8zhBvB/WYguge6tWBzjTy08gjyJcT
bxB5GXxOzfMe9uOvPnAux+F8CB4D5d4b9ehrdD+jpl1h//YWsuMJj6WY3+J7
pt5jKeYU5yVp9yWfdfjelfBeqWeNyMapyRD1ns99lNq2pV1XNTlK/OkSl0ln
inqfS3rt1YOT6A9FvXfq4Q64xQOvvXowEfEaqpbloAKEEl67/9DZh/1V4v8D
ipFFwGXiTYIx4oyDx6Ourxqr1qN825/rHH7jnFPvtZdcvbmPb6/C58g9fF9s
tpMa7SaXvfDLVJvNJpzvc9w/gO8talrN/Sz+mok1g/018BeczoOHql0mnbWc
s2V+Poj9o9wvJ702g+T7Cfk+yLytmJu3SeyvV3q9VZMbnMcrfb7V723UdzV8
fiW/FmzWI2uK+1nf1iD7RbOH7SvYLCPWafLZX+g59uG/Ef3mOf0s+hdiHlsc
WvC3JOm28rGXem8r99nXG2gi3wz2q8Dr1H4TeC3lb11vfiP2PSUeTz6W4qs3
5md9E5dM0mdN+2A7smPEOFrhO0a7Zh2cOhL+pvS2NqR9Xhuwf4TzHyU+C+px
HnpdUc9FOa0lfnfgujeoby6yBnwsBhl0W8GJGt+N4vwy3Ifh9EWe92w351UJ
r4d2QBZ/g3DcBR6GWwdop4dt4C545IM38fEG6AV9KdeRrnaAdsFMne+/rfh8
Hz8R7sVgM+d+0F7qs6UZy2FWdkZ992kH9jBrXzJzB8Asb9/wt6/GZ0czdJU4
rdU+q5rZNuz7At8V2hnXyXsWnTvgEHZfgU0Rn3XNQ2PSZ1D+PtL/gHtF2mdP
Mxik/U1If4T+/wnvt6v8X6Gd3QL3zlqvtWr+UuA7T7tvFhjvb0vMe62er8T/
JD4mwI/4/QkMVPnul78Q9V8x9x41L5olvXG9dfVQvXwHfwMxr6FqeXuh+1eN
73AerXOu4qxclbNy1xvVW70ZOH/9827hLxr429JOTdZ6T9QbcRTXsYj/W/QG
L8HjqajvEu2UooT3XL3Xm9DbGCj1t643v4Z+FM/tY+3gT8n13ZjPgviuhs/B
tNdOM36A84Wk90I9Ua+fD3y36p/cCr//AZ+YK5U=
               "]], PolygonBox[CompressedData["
1:eJwtkstL1GEUhl8cL3lLmiY1GXXUSg0vkRLI4CXcmFKgf0EOQQmia4NEMDXB
lS68IKjkpkWC1yAhyRG8UrZql4qOClqWM5GQOj4fPxcP58z5vd8573e+SfM0
1jSESMqCMBh3SadXpAlir0PqA1eylAoVaVJRpPSIWHpH8kVLAbv0IkWqg9Ik
qQTK+f4AXU6CdH5D6qDfdIY0CVMwz5kxzu7dll7Rtxlm6ZccIzmvS22pUjs8
po+bPk+Ix/jwO6w5Zp4N3Qk9ajn3OV2KikLDPC/zF8CO5hr8ZNYGukJ0f/kd
gP/obqLf51wHfp6StxNX8LoKL/HTBB7mljPfnWDVzfd+dM/RDxC74Rl5D/Eq
fuPgwCkNRUjf2N+veOkIAiy3Mhb/xDfcoROG0b4LlVoTpbJb0kNQthREcwJd
PMpZlrUHs48C7lvEfvzcI5yeYVDNmWnm1xBjMqVoaKW3F90m+de70hfwkS9Q
WyffvcxfOyy9ObfEO4ywo0ViJburgjzquWDDwxr6QfQ+7rYDa9wtnL0c4sHD
7wkbfck/UZ8DJx7X6bdtt97AvMU/dmjH63d2vkT/ZfBT/8i1t6htw066tUOz
y1F2Wo/+LdHNO9xnXqb5PzEvCH/If0MLPe7x/5rjbD540X2g3kf//ktMPkNt
nm+5aPa4yy78wGsstQ2X5cf4asT7Gd4biOJOQd68hP2+x0sx8QLag4T7
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlWtM1mUYxm8xBEI7cHrd658X3hcCFJzzgE1A0ZZUtsrYOthmefgSbeHc
WjY/6OggtnRtZaNYW5LVsrIyZSstWEzAxprNmn0qv2gqoqgYMiDrd3U/H949
9/v8r+e6r/vw3E9yw6bG5jQz+4bfVH6LyswyM81yEmYHis3uYK8qMmsrMXua
/cwis5E8sw4OPZQ0mx8zq8kyW4X9FpgB8B25Zu+C2Q3mIBy3F/m+vm8qMHsZ
RwvgPIqv1+DcyfdYueP36Byc7XCehfMvvm3JMFsIfk/cbOUtZl/xPZ5weyEc
DbPMvsDeOdNsceT4N+A5jL9JOG/mmw1yZiOYLZxLL/JYFNP8XNfWwt4KeEo4
OwbnC3wb4mw/Z+dGrlnap6PhMPYl7AtwPQvnWMxxwu/mXF+wz6XMruWYfQr/
WrDFheiEv4T1RszPtrD/bYXzN8N5mnx9COYc+q+EPE+ytzXkUHqvR465ETlO
9ij2WJ7zJ+F/EJ2nppkdv8usZ47X8Qm0vKI63opf1jPoW0MeRtDQWGq2C3sa
GqzA86b8TQn2Sr5/UOSY1dgNpZ4r5WxfqLvq/EDSNSjWoZDzLrQcIYZ+9GRg
T1LrA8R7El3LQ87r4Wsu85z8BGa8wjF/4H8IfN90s4us3fC0gN9AvJ3BXo89
mvBYXkTLMc5PZf9H4uuCp3oGvcb6CLgv4fwVv++BGUXPPDCW6zXaCEc3/7PI
z1W0P06+mrPpl0qzd0I/q08/QWcBej5mraXnngH/Kn7T4s7/J5rbA38NmC64
Bujn5SnvFcV4GV9zU46Rlm1oQ6L1Frs/+a2jdq/jtx9f1/m4LvJ4lYMEZ7+H
s5j1TfptNrEfxB7I995uRc8/nHmY2G222Wf8b0bn/hLnFf8RvnfkOadyOVzu
vrIrvY/Vw+Noaw93X9z6JsxVsEPUuA36M+RpFzwvwbMEjdvJyX58VVPTuyPf
r4n8XqnWn5PvX6hB921mJ1ibEq6/nu870NaKtu1wboO/Dv4e7OMpr2kvemrp
sY+wB/G5jHyeIuctYLcWuq29urC/gL31Zc4vP9PIxaPkJJ11ZqXbT6JnRej/
vfTwcIHf8Yto/jv0le7KvFCvtrjPPt3Ne7CPovkE+DR81cfdrsT/ZOQ6L5Hb
k5y9k5z8xro26XE143dfjtd9GGwUZm8uPk8XeC+pZ/8NPIq7kd9S6l4N/44i
n5+ao7rnuu/PwzmR7/utfK8NeVBumso8h2+DGQoxno38nmi/B+1L+LaM+k6A
/TrmM1ZzV/dW9zedNSvYa3K9z9QbGfi6HO5pa573seJ6CkxmyLnyXZHynpmR
8FmjnCv3q+OuU3V7LOmx3Bf3e6v7e2yOz1xp3ozmBnh+Jg/3sv4efOkOLeZ/
H/vfxfydkP6ihM8RzZNVYO4Ps1F+zocZqDprRmsOaB4oL/KlXtAbprs/hXPZ
hV5f1VxzWT0wTLzl4WxVyvtY/fYce9fA5KJnHJ5F4W3Sm6YZpzmgd0DzSLW+
Sf6a8r0HInjOh5mgHtF7/P9+mfeWNOQUem+pNyYin7Oat3rrNifcXlfmc1ax
N4A5BG86fdjJOhLeX/VRb5iZ6hHNGt3xK+U+y6Qtjb2lpf4W6H04BG4WmE7W
qqBHvT9ITt8n3gtJf8/0rv3A2f8AYU9HXg==
               "]], PolygonBox[CompressedData["
1:eJwtlW1olXUYxm/Pmnp0izxnbuP47JztnNPO5kuTdFbD1TZthkXoPvUCtumX
CpoJoaFlbDUUMqZZGMOoRUbSioKJWmYWskEjJAqhPvSC5dSdci82ZBur39V9
Plzwf57n/l/3db8+FVu3t7SHzGwPuAWcX2pWW2h2G+dvOJ+83axnodn788z+
DcyOp8zaF5h1zTebXmy2o9LsWZCNm/0F5sTMXoPwkzyzEOfPq7DnfifPpzhb
tdnD8H/M8xTPB4vMukET3OvAPeB5fO3jThe+x0rMwvjL4915+Drw8SRCF/Hu
hyS6Iq7vPb7f4O4JtCwpMBvC1e6E2bvgAFr7sO8sNSvk/hG+9YTNLleYfUA8
x0Andi+DF4rNvsB+F3yr4bszcO2KoR49q+C/H//zsVnN+UyV50s2K7B9nVgO
gXG4JsB1zr3k4wLfF5aZHY56LIrpLPo/A9VwbYMzS6xtcHTwvQXOS2g5QsyT
c80G0FuL7WTgsSpm1aYdvrXEcxH+Tdgux+ZD8zsrOK9Ne+zKwTvouZbw+JTj
A2gLkh6LYvoU/2Pwj4Kfys1+Bom4fzuD/wS2oxmzQfJ77laz7+mPjYHXUjV/
C7558G+Bbws+68h3pMxjVw4m+J6PxkG0heD7Gv5pcngvfH34aF5i9kaRc4lz
Bl+nSzx2xdPD3SY4G0EI2zzZ04OHwQDaBsFVano07DE9tdhrrvhTxNuA/a64
5zqfd/3Yz2Izg7/jPK8hVyP4HEDPV8T3Ir31UsR7Ufm6K/CYFbv6Yw3Pb6P3
KAjR13ngFXrpCbiycA7AvSmd6z987kNLinz0SQsa7ya2jeitC3t+RuGp5V09
zxeJ9wHiPUZ+itHzKByTcb/TkPv+YMxzqFyqZ3q5P4z+y6AAFII96N8NatC6
EuwvdS3S1IK2ppj7loaH0HIi6blRjnbg7/EK9yfNN+HfmutP+RymP5v43ghG
+JYF04Hviv93Bn6/rPLZ0Iyc5dyGbSuoIQ8rQW/UZ1Uz26/ZSns9VK9mzh9F
/awaqpen8BkNu48ZfF1Y6rVSzf4m3vvSbi+Oes7LA99l8q9Z7SjzWdHM7OW8
M+W5Vb2e43ytyLnlY6zcY1Ss6tkwufqH5xvFPiOalb0R7wfNxHX8/5j03aQd
dZX8DcHxLWjHdjtYUO2zrRy2qibUswasg3s9eCbqtVUPbCZP5UmfPc1gDL4G
nofCPuMZnqdirl0914X+39HwG/gF/Aqejvt++Y475/CzLe53xdGo2V/GzC7z
nlHvbIi5f9VctZ+Ie37Ug6VoG6dGY+Agc34IjBBDP/nUar/CeTbju18z/Ca5
fCzq32RTAHdrpfeWNLVxHk66fvm4wrkj5btDOyQf/vVJ1y77buYpGvfZ1ox3
l3hOldtT5Ph0ue9M5XczmEuu9yf8X6V/1oZSn4mCXI6Uq0eibqs7qk1d7v+j
Hal/wZ8V/q/QPyNLv9SmfVeov+YU+47Xrtc/TP+yGjjvyPhO0G5YFfiuUI+o
V14t8mfxaxf/ge2ljNdAtair9F2nGo1HvIaqpWZYs9yc27f6h86S2P8AGHsn
/g==
               "]], PolygonBox[CompressedData["
1:eJwlks9L03EYx99srjRzkdNN0lzflZohbQbusLGDPygECeZB8GIpCV6c+Qfo
sLFGh0ir0+hUJBTRZTtUiEUHFUcoBYVdPBQeahkzpYMZvj58Dy+eD8/ned7P
83mejzUy0Z9wSGoGF2w3SmNlUgLHTZiEX/iKUOeRvMeleXzLAWkJ3p+SnEel
Fc6lFvzc36mRqjl7YBF/xTHpLXYajSSU+6Whcil7Vuqsk7pgskHKO6njlVbP
SAWYqibPLa1fkL6h9R1CxAUh1kSPldIAMTPoFej9CXpPYR5crVK8ilrYi+QF
wXFaWqNGm4+6FnUhRe4tuEIPCfp8Tq6THIfhvPSS+E16GqXvG/CO3A8V0mXe
kyb2GjlRcveZwz/YQjPL/V3i3MSfgEStNA4dZmbchbGdUOC86LN1jb7JNzoR
9IbQTaE/R2+zED4nPcOX5M5P7gK5jQFb1+ibWZuZZ5j9Ejsocv5P/1eZwQF2
Dv99yKCVZvZ/2GEJduA1s34Fg+x3+Yj0hnMPfXRDH++JUKudPp31zATy5NRT
I4ctovkTSuR4iNvBdrOfLkizoww7uo39in8DfuOnHX3hHGIfQYhTI0Zuv2X/
D/NPPvG2k7z3I9Yi5gV/rJf7IH2E4BK+z+wmyvk6/mHLnrWZ+T18j9D7gS9P
vgudHPYBc3oIf+nhMXqb9LDLbvfgEFlFdBU=
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlXtM1WUYx5+EREIucs4BBodzOIKcg+TCNFjNlorB2lpjtJXdVtZy5R8q
rbJlyRyUcyu7aE7dXK0lrMuMipngwk1oOau5/Mdqbc7p7CLqBCMnRH0ev+/G
j+c97+/73L7P5Zd6cl372hlmtp8ni6coYZYzy6x+rtm7ZWZNRWbRm81Wpsw+
zzFbWGnWUKnzKu4S4GeDXwT+jbhZHTZOVJkV8u5DDF+Jmk1FhXcbLeAy4J9G
79ViM/7sfNpsBbobwbTMM3u+2uzhm8xeRB7MmC3ONxtEnq+SfffTxbsI+Kly
HvSPzTbbgZ+xWrPebLMtSbNuf/C1oMZsE44i6C5C9zLPAZL9u8TsbFL371WY
jWKnFTuRtHLzmG8l14+K5XcSvTeJrw/dds67Oe8DkwWmGR9b8bULe6X8/gnM
Yd6vjYmfpPMZVY7T5PJOUnF6vLfgbxtc3YiTf8uV137us+vNxguwjzwCZg4x
fI1uYajROWKcU65cxsnlfWz+BmYJsVxEv4lcLiAfCbVoBbuH5x78DpSa3R/u
J4hrC7Xuh/M2dDcWy9cpfH6F/lbwWfCzsFR5rcDGMHk9SAzPUYdccC34GkFe
SOi+A70x4h4g/uH56qPGItXytVC7a+Wqt3PSCp/DcLQA3ZewcSmtunjdlpcp
hllJ5eY5fhpR7d2O22sOmFfAXAv9cBX5Q0Z2lvJvDFtn8szuqFXtnbd/8Hum
RDVdFRfvbvMD8M9wngS/plY5e+4NcHAYm43k0YHeSEY9fBf4ZvRfRvdt+Hwh
oVw8pw1JxeYxflYnDgbQ2xtV3b3++YHD39Pqles9g40dMdnp564g9OdRZBvx
nJxJf+H3vnC+F3nUdanjd8jVCc1aL+fOMvWb993jKeFdrz9wvgFsT61q5zW8
HZ4niW1JhWbDOXQudybV597vHQF/EXwLv/vwezfy9XniwfmoD3amYporj/9y
WjNwfd7B9MBDN+dDzLdVaqZ8th6rVfyexwOhJxvA1xDzcWxuJ/4m8uomrwnO
V6PqZ+/3b9Oqi9fnNPoDnEtJYn2JetJ7MxdfvfjK8X0WePC6vRX602fxdKiL
16ch9H8KfB/4bPL9ElkX4lkTUxweT2OZ5t/xBeAfSmjuBrExnJFNn5uJhPD7
yHW0VDa/wF572D++a5eFvlqKXBlXr/oemoyJ24+rZdftP4G9v1LaD74nPqnW
DuyibmcDJ753x6rE82hUnDq3Pvf93E+DP4Dcie5q4tmF3BN6tZD7PnwdyjWL
E+fisPe8L45lVF/v04MhHs97Wdj5TyXUi37eRuxXwvfC9+tJ7OZh81fkUJiv
b5An5qp2nQlx6lxNJVRLv/+D8yA6/2FzAPkL+Agx/4ycrlJ9vc7jYd434/PZ
mOr1Jzyd4r4NX1kEcmeFZmRTmXai95J/xxrDPPouPxe4zU9oJ/pc+37qDD02
BDYv9NWlqHrCfXnPVvAMkmM5sifUZTO8zaxTTX0PdYVvlr8fCrlvj4h35383
NpenVLsZ+FkX1+x8z/sbSlSL22r0fXWenfsj89XzI/NVb9d1Gz5vrrs+rm+2
1+LRiGz5fUdcc+s95vvgOPc5xP8j8n9UHjKt
               "]], PolygonBox[CompressedData["
1:eJwtlX1o1WUUx49u997NbaHeu90x74v3bu7eNf3D2kvYogxf0gJFyMReqARB
//ANzHDlnNyI/sjE3kyKSHCSCPpHM+dQU/MFIaIykghCFMXprLFls121z5fz
++ML53me8zvPOd/zPc8v8/raJWvGm1knKAWLG8y+mWD2B/aXabOzU83OgOVR
sxfBrnqzlZy/h/Mmzn9+2OzkQ2YXKs2KObNXU2YLOLtSYfZ4I0iYzQJv1Zi9
DeZjd0bMTpSZFVgPp93W3s6Y2Zt8P4N1JXcMx81us36BdZT1KOvvua+P+0IT
zfrzZkPNZiXYbVXEYb2O+AViPeCbq8R/NEusMs/pCN8PN/u3irGO87nUe0j1
4DOO9WN83x7krNzL8B/BdzJ8XKW+kiY44q7tkPYF+T5g7z74GPsTMAL2cPZT
iVk8aZZJuq290ZhzKC4r68yqwA72Ngd8iItm8o1g/4h/E/ZozrkVx9tI4nd6
UVFudpiYQ+TXF/faVGNb1n3kKz7ncB6dzj71toOdtdTDnREQAmHQik8LuMbd
18GutHMhTt7Bv434reAZfBeANTXOdwscHIHvjmkef1g9gaujeT/Tns56yOdz
tLCXfAwu5gX9V47SzmLWi8Av2BdBxxSzMWrfR01PTPE9nYljcd0/zePtI0YF
8d5Nu6++GauGFzTXCzaz35l2zUl7qlG1Hoa/+6oP/pax3otvodQ11oM9q9G1
K053U+8p/E+Cr9RXEA70MI+enKbWdMq5P0pPDsJTVcr79x3rPP04lndtijNx
t6He79Kd7bXOmbibBD1L4eqzmGtLGitFa0sSnqv2dnP2bMZsIfgbewg8DUez
wSh53wWRpHMjjsT9vwnXCqFsBHtLrfOlHreg/R+oLVLuM9MT85mUFqXJ2fjH
prt21NMDBFlf4/VohjRLFeAf8kfS9hf9WU0OY9zdx/oyXJzL+ixrpj+iPx/W
ubb7uTPJWTc9KnDWDp8zCTJG/P9AkbvvgRP4HwcDcHtT859z7sXXKewZDf69
+t+M/SsxL4Ib3D0AznPnOfA+vG8HZWl/u/SGfcr6RsbzUc8GsL+u91iKuR+7
b6q/JeJnreYt0Lf6qbfnPDnMr/T34Qx2d8C3ZvQS39ZlXRvSSIp8xid9FtQf
afkN7lg+wfVwh/NE1rlRTquqvcfqdZFY90Bv3LWlfCfifynrb6M0dbraZ1qz
Lc1Ku68F+pHme1k/GfVcpWFpWTOt2X6e2peC9cH7KU0M0odv8861NFqK/yPk
f1BvC+cd5LKVYF2T/c3U2znY6L0UfwW4Hgr4kUaklfJAL9q7kPcYivVbGM2T
x82c56fzW9h/5vx+9fwy9oqM+yuHIrxcD/SgevRWP1fnseQj36eirk3dqbv1
zwgF/4vj2CXB/Om90lvZpRlJ+D9P/75Qk8+eOAw3uSalzUHOboNX6MHLQJeM
A3PpxxzwAb3YIb1HfRY0E6sa/R+hf0WcvGvBNvrfDUJwFQYvRX1WpaFJ1FJM
uTakkY34tTb47GqGu5jl/wFKNiN/
               "]], PolygonBox[CompressedData["
1:eJwtkk9I02EYx7+26ZZuHly6kTqdaaXQQaJ26FJRC+zgmPQHYRMUoi7rUghT
KosED24erK4mRIcOW+UEFRQUTbqIUSwh6NCwck2hLrrp7LPW4cPz/J7nfZ/n
+zzvz9V92xc8IKkRiqG1VoqaJJ9LOmWXTkM5sVUDOfw24pdhs15KQ7ZGauZe
Cv/JYWkUopybPihVN0jJKmnfzDd5EzkzGKj3gh6/iWXIZ6Gkjv7w7Ih0o1R6
iu3ne8govT0qxWESwsSHIUMdGzUi+FfRcwUuERtnmA78MVsh/4j8ADwExzHJ
DqOHpPcWauD/QauFfstoXeT+EnxGVxn6E9h7zHcfzkKIeoNNfFdID+CxQ4px
18PyzlVL52Gc2s8hzt0cc09gN5zST9iml43za/TaI74LW5x9Sd0cfrhSOs4d
D/kLcBGKmEPQ4yzk/OzgB/4U4Q/kP8In2CG+Da84+4WcG3uG729l7Bmtfu4E
4A1njWj4hZZZZp2DWmIzzBuzF94v/4532Vcn5+5g36FrGQLs1Q9BaidKpC78
Pt4oBK3E3Ox0k55GfgivVfrKu7azNy8stKC5XJrHXkPPdUjRbwN60XWC2aIN
hf3n3+EWdbJov4n9Tv11OFnzbxVK4o+gJwKv/88Tw1q5Z4E0fU3Ms8JO/wIt
dnS3
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlW1M1XUUx09CZDwY4QXj3sv1ysMFvLVmZrBBaqzmWrW5Woaz1Ml6eJXo
1qKRpWRrWfNaLaI36HIags0ye6ApIqCgrYetZTRXL0pXk8Xm1LKI7HP2/b34
75x77nn4nsffvHXrH3x6hpnt58vi211ulppptiZhdrTG7NtsswtpsxNRsyfg
L84xS1ea7ck1uwV6usDscIH0fsR2BbbnsR2Cz0NnBDo+1+xj5Cdrzc5hf/V6
s73In0W+BXlXhVkB/sdyzFbNNmuKmfXi7+WbzGLoXUb+Nv/fge13gFxQZjaR
NLsRP5PQN4rNzpBEP7rfBwy/g2FHkN+DrKUanNeaPVxqtpz/3ifXqSKzWv47
hp809HP8H4dfCP9pyqwDP8+DcRv4VsFPYzdVgh4YssDQGRW2RehuRW8PmP+A
P59SXm3I6sinMd/sb2QtfDOuM3sTWVnI6y18fIC8FJ0D0LxQh1xoQ0q9WEvc
DjCcAvMubCcSyvFxZF/lKq+XskS9D85PBvztYJgm9y/xP4s+HqOndfRrFFpT
pnqOVIGJWh/CdvbNZvUx5fIcsjq+lcTYSKxu9HrAfwN2GX6vQ769Qv12PF77
ZmraCY7h+Wb3RuXf+zYc4uaA4QB6WdhOIB+MqiZemyP8v7BAODojwnwV7C/G
zV5BZ5xeX0KvHL6XOixIK2fv7Z0xyRuhQ95rbEeqNbtek37i/4R9Pv09A31o
ntli+BXQbOZyE7bvErOeWBDbTB67Y+J/oYYNlfK/GNmVMAM70G2MKNYwsQqp
wzJifUJeZ9H5CJ1WdM4F/sm46uv5ZYGrL6K8RsFziC/DrL6HLC8pPPejX0Wt
BsB5EJ87I9IpT0rP+aGkPudzotqz7EL1YCk6R8B2AmzHq8WPQdvB8yp4umLS
dRufGd9P538g358T2vdLxP0mqZn0Hc2Zqzn0efS6eH2a6EUi7FQUvMPs3QR4
xuHrwz3ZhmwkyNuxfSCuHD3XCxHN1X30opDfJ9HPlChPz6ub/y+mhXED8kfQ
W0JNVkK38vt15Mvwtx/8A8xPhBr/h+0cdKahyUrt41/E3xRyb0C/NeRyK/i/
KNcc+jx2BJ97qU9Nnmri9fT5835tiWs+PPel8I8xk3+idw1+WiqUo+fqt9Jr
2JZQHZ3/Ff6ZcE/+ha9LaWZK4Fvna5/72LlTpcLpveqt1W70QceKZes+/kmI
9/s0WaT6+20riWo+fU5XJ1R/vyVnybcf/jfoILvcDeZ9RcrP43p9/Vb6zdxO
nA8D73c0O63d/KxGffJ+zeIOPJVSXv4+ZKo054/GNevOu8zfh4HwRuxCP8Ic
7kzppvsN9FvYFt4C75XfHb8/ryH7ulS98J5MhRybE9pD30e/B2O1eoduSyvO
4XBD9tWK74G2B59+2/xmnA54bideD7m/wP8bqGMz/PoK3US/XfEy3U2/RUbu
M6PKy/c7A54MNXynSm+Vv1ldYG4tUS19Zn3uvf7+ruaXqW5+R0fDLG2O60b7
rfY3pz3Mz2XiLIprBnxm74qrDj7va4m7kbh342d52CO/YZ3hjfAdXUOPmpj/
1dCj4cYeBMOVYsWqJe/puObE37TRcJ8Ha3SjnV/CPP8P7glCBA==
               "]], PolygonBox[CompressedData["
1:eJwtlX1olXUUx89edC93btM7771ud/fe3bvuNmeEmWVl5ctKAq2wki1XgZZE
US4LCnpTEyLKrYyumpBBuM0trCyy6XToVNZKiYwyhKAgCs1BLzNdG/b5du4f
X/g9zznP+Z3zPd9znppVa5c/kWtm60E+6G0wOzjF7FMe1tSZbZpmdqTU7MsS
swmef4uZrSg0q+A5HDSbwbsIGAP/gtNJs3O57vMD5+JGsyIwXE8M8M90sw3Y
Hik225HiucLsAiirMSsHXZw7wYGEWT9ojZp9nGfWQcydvJ/gXbjIrLvA7A+e
jxJzHvkeJJ9j3H8Gewn2V7D3Yj+B/SuwgFwXgruJtxy8g20HWMr5hQKvUbW+
wfPn3DeVGL8nPGflXkrsMvBhmpq5axiu2uJmm/F/HXyD7ymwlXcZsLjWrAk8
nHIuxMlqzi3UeAuxT3FHfbXZ9gq//wt8yvi+gW82ct4F/89F8CXn66Z4jap1
W8r50/0ZztuqzF4lVh/vfuHep0Puq28O4z+HHhzjvi78Y/SukDsLQCe1doFv
Z3rtyuEu6mi6wmxdgJqIeXKG2SVqvgg24vsymF3tuauGZmrpJP5lzmeo7016
G83ab+bdPdgXR7zXyvkZ8tunnMitHw6PEPdK6t1V7PVuwv4Y/D4KfiLXn8FW
8ukIeE9ClWYPEXM1GJcWwFVB50Lxz/Ldn2gtv5xc8W+Di7Mgn1yGJpsF+P54
wp+lj5eo9/GQ5yPN9zS4BqXFv4k9CipmmR3KzsOWiGt8LMuJuGmk/sPEW4K9
nHxPEv9EwjUsLWfoz9tVrkFpsSPkvRbfy6I+A+JHPb8If6GYx1LMmcTuob4k
vt34zIGrt6hhlFoOYa/FfifPd4ClYBnIwf8CfKWJ9wCxuqmpn/y/A0Ocl0S9
t+rxbXC7M+2z/L9G8T9e57MkDUlL0rS03Urc+4POibgJ0+cIOEoOAXJbQ84/
8v04WEmsZt5dC18PxjwX5dSa9p0iLpXTbvKpTLo2VVMV5xU1rh1p6HbqKeaO
oqxmpd0W8m8Gm8m9HTwfd+7EobRWVu27QTsiJ4xGsvmswj4f+240/G7AfUrw
vReN90+iN9jbmIUboz5PlGjzOF/d6NzJZzbnzirnT/b3OW+Iupa0c/4KeQ/U
C2lUWu2NeOxPyOF03HeQdpF2onbjFs65fJ+Hz56kz6Rm08gtB+RVu/Y1A9up
d3Kl70LtxELOc9POnTgc4bu9SY+nefyI8z5691nCORN3fUm3yWc/5/ey86Od
todYT4Z8dr6mRwPodW3KeykOx+BysM5nVzOj2Xkx4tqURm+Cj9Is/+J4gHyb
Y56bdtA13Dda6buwhW+eIvbKoM+mZlKzKY1Ja1Pxmwb66j0XzeAH6OW1uO8K
7YxZta4BaUE7Xbt9UdB7ox4O09sJZmocXI/vDeBynf/LtPO0++4jvxawH60c
AOuz/VQ+2h2X4GQ+/j3cuYj6zqf9fmluhPPesM+iepAh30FiZib5DtIu+jXu
u1n5zCX293HXQj38nCefdSnnQpwMkudIwv896vkE/u0p1674H8J+LuxaUf8G
uO/ZmM+eZnAQfvMafb7Un3zO7dO939rRXdgXRJ0faXhh1He6dnsT51vBf6Be
NTo=
               "]], PolygonBox[CompressedData["
1:eJwlkktPU1EUhVetqH1gba22taCltLWIMwkINGqgMJQETQQCgXSApk1ANPIL
HGo6sqImhAnBmFhiYvBVsComEKL+AgYojGRG0k5a4Lu5gy/73nPOXnvtfU5D
arJ/4oikCNSA55zkhr2zktMmbYYkO/9rx6Q/fP+C3+C6KJ2ENVh2Sje80sNG
adAutfmlEjlluBSWvqHTREyfkTLQUycloTcqPXBIYx5p54L06YS0TXwWlHJB
86yREyF3BY0o0eKTfHzv48FWjze4e14ahwX2D9jb4UyShrphBr03R6XHeGph
/yf7H9kf5PwQ2PFvg1Uo0EeCPgpof4H7eHxnRY9Z3G6QrpF7i1jiTBmGY3zj
fyRm1jd8/DO8UO8ea2nIgAWPghf0m+V8ln7zeLEyq0XiI3Km4TJ+51lrJlbo
uwr7zLAKeXQC+HtLrFK7AgN4uY6nO0TFpQ32c6z76SUACXpOoZdtNDUMrQ60
2yHBfMPHpc6IWdvw8AMvDs5/J/7lfwt8pyUvunPU9dODD77Sxyx9FIkdzLIL
D6N4uIl+H8ziIcujes8Ml+BDyHwLxptoxdMANabwtMu6m9z/xCfM+im8Ivcl
uFhb5z2cMu6CGp9hDD8x1q7i7wq+X6PTQsxxx8+hyAzaaukjbt6pcbeHAu9r
BQ==
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1lVls1VUQxgc1QgtdbO+t7e1dut+W3oRaNGCtD2o1PmCMUkVxbalLUuua
FIm7oqaiAj6ABgMiVbANVSGRzcQGIrYlQUMibSQkRGiitBp5IKWaor8vc3y4
OefOf87MN998Z055+1N3PnmJme3jdym/ZeVm2zDMRMxOpMxeZL+Y/dYKs/lz
zDqTZlezr2Z/D/tZCeyc215gdiFq9jf+myrNRvm2F3u00Gw62BuqzJryzY7l
mB29zKyW/28Rp4c8AxXu/wH+m+Me81SZ2Tzw9M02iyQck7B1YLsQMyvAvqPG
7DTn9xJnVRF5gk9puefqvMLzrQ2Ye8ByuNqsn7MlxKwkx0/YP+LseMb9z2T8
zFecb5/nOZRrS6HbZRP+5UmPKT5G6szG+DZQbLYT/7f5fhGMnexb8TmN7+/s
r+Hsb6zj5LMss2/Jn5cHX5ydxJSb5/En2H8TOO/i7EuVjkF1Z4N7P82adaXZ
Sc4PX8437OPwsByfD0vNDoFnBXE60mbvwec72CfxfT7UtjLj/VBfFuE/n1xZ
5CoiVzLY1beF7E+ApY/a38TvNfI2wd9AoWMsoFF9dW7voqYXqL8326yOc835
zolq2w3WW+BkKfE7o55LOYdK4AD8h1kT4HsFnHeBdyr09znqHgk+N5KzhHpu
pS6rNVsfdX4+J04vfV8H5kZiRILPL6yL+fYDPB8gf17MuTqOz83k4Li9UeB9
zgm8f0eNas0Y8Zsirn/dg0fTzmc/td4bd5x7iHNf0ID0tSfg38y54oTr9jz7
aNhLy9sDzqP4TmW89wvr2Udck634TABgN3yujDtWYc4F+xehp8KyKNydd1N+
H6T52/D5OvC8BFwN9V7XAtZx7G3YH0s6p+L2fMxrlo96GUl6Xyoq/P4o5jS4
7g71qj/SnLSXl/De6o7pLvxb5Pat+J4N+F+Ne33SgTTwV5nrcFfE+yQetrHP
KnPOxX1H4PnxtN9/zYEH6ftQnWPcwZoJta+h9o0p16d02oD2XgfLuaT3Vf2d
Js7TBHkiF12hoxXU3oo+H6n0+6l72sy5uTHHLOyrCxzPEvA/E7iSHg+GGdVN
/B7sbcRZU+kcKr54OCLdUGs2nOeD/2XObqLGj6udnwRxri/2vM+mfAap75/x
/U/ynprLjGA+/Fjrd3kjnIylPHY/5+6v8T4+BIZ/gs51J8SpuH0/7lyPhRk7
E3WuxJm0pVxxclaH+6672BzwzCRdl+pLtuZM2vU/CJa1Bd4LzfvJ0Md15Fpf
7bx1sv+UmBe5a70VPvfF1cmk86W9ZvyGmOtzFzr6o8pn3mjK3w/Fn5PwN0b3
WvOvm0ZcSy3fg+FczPurPk8kfb8FPvbjN5te7GNt/F8DMb8/wiaMI3zLwWeY
9Qj/f8aeIdd1YOjH3lTlPRA/Cb01adeAtPBw0JJmRnfG58Uq1paI90i9Ur/V
9xuouznMDfGnWanZeBDdjqY9zjH8b485hiZ4uCPuOmmN+wyV/6G060b2pXF/
UzWTpwhwNrwjCwpdT9KV7t+GUsejd0BvqvquOaFZplpa8D9e65rRjFwNV19S
e0uVzwv1RXP6k/Bm/Zr0d0Xz5wHOtmOfRp8dNf5NPnrfNFOkSWlzMOr2tkqv
U/XexNkDMfc5Q/xlNT4zNTuHw30ZYh2s9jmp2bmz2GeHZuRV9f4uNrJ2pVyr
ukP/AVv/Rq4=
               "]], PolygonBox[CompressedData["
1:eJwtlW9M1WUUx8+0CQKXi4L3IsLPy7V74QKbZVOUnGUj1xs1U9tkuYbYcjMT
t0pQp9OWLTKlXoi9AR1Mk2ui9abUNlMQcMtarXTZ+mO6tdnKNitBcX6+O/fF
d/d5fs95zvme7znnueVrNj736jgz2wweAp1FZjuyzL7JNovHzGYnzX7NNVvE
4f4Ss7XsR9h/hu3lwGxvqVkb9hMnmt2KmGWXmVVxdmq8WQ7rpwrNzkzAHn/X
ppv9WGH2TJ7ZFN1nPZziN2R2Cf9XOD9DTMNXO6SOwOVAwqwDRIgdBe/OMGvM
MXsb+w3Yt3O2D7wAj9VgZanzb4Pj7slmrTVmJwrMviVGC+u5+NyG753we2ua
Wephsx78jfLtDqSO8O0w6AY9YB0cm+B7E1rHyeUY99NgEJ5DIJ3yc/nrZV2A
fRg8ic1CMFBpNi/kMevYx+Okl+16nozCDT37QDO5bAJL4L8Y5OI7L+Y5Kbcu
7h4EF6a6nqfw8Qf278A5wXoQzWrxvRzb7Zn896LLAXJoyHL7rdQnr9rsv3yv
wQ9we5NvuyKes3LPz5zzycbI4zIx/jSvkWoVRcM69LzC/iL7XjQ+CvKodQh8
UOi9oR5pIq/JVa5dKGz2CL5nVvtaNXkDX1+Tz6WpzkFclJO4inM9+bbzbV/E
NZE2KWJUgn5yG0h4TrKXJhfx81HK46kmR1lbpeeqnJRbfaHnpr20GKnwXpTN
Xda107wX1BNV9Mb5Cq+t6jcfPiuJ8Qp312DfxFkJOcwnlzA5fVyMNtxJc3c3
nMZwfC7l98XnfMp7Qr1xgbuDoDXisyH+Q/hexkw9C+6i6T0wDz5zQSu+t4C/
+fZbrvdQEXYfRnxW1fPPo8/xYq+NOInbdbB+ktdMtTtb6bmoJwdZL0SPOtaP
g6/Yr8fHp+N9/nrgubnGZ0c+brD+nB7LkjbEfJ/8GpnHFax30c+zit2HfKl+
++Fdjx592F9F4w5qe6jU3wa9EZ2sB/DRD7biZxv4J3BfK7izlv0w8UI5HuMs
dulifytUg2actEQ8nnIYJvbr7F8DX7I+B8YCfyv0ZrThrxlsBKPSGNTQS9/D
p5t8R8n3dNRnSTPVwPnywGdVb+CcpL9xeuuGqVeY9+ilGc5VnG8GPnOaPdVj
Ffn1wP8+9o2cn8Z+daHflY/vmO8n0GgBuI3vf5PeE+oN5aBcZtGj+WHv6aGU
39Fdvbnv4f+xau89zWgfvruSGf3gf1A+yakX2zLuFJTTR9SgBcSoSznYM917
VT27E207Mu+FNJW2OSXeC+qJXNa/B+5bNbkd9RnQLIjjo3B5mvzrEz7Tmu3F
Ja6tNF7KugEOq8p9hjXLGwLvJfXUX/j7JOp6q78TaFeGTTrDP5uzAb71g5+5
9wu4HnVt5eNQ3N8gvUWdcOgCP6HX1Zi/2Xq79R+i/5I75DYCIoHH0kzVJj2G
YkmzKfhZh8Yvl/p/jP5r9J+i+uqNXcb3w3GPLQ43uNtd5HrpP+yLmGsuf8rh
f85eDNxWPdHN3QezFBll
               "]], PolygonBox[CompressedData["
1:eJwlkkkohWEUht/MM5kzX3M2NmbFAjsLpAwLmYqVaSFzbMi1YMdCyLVxJcpG
SqF7XcPG3hgpQ8mCjMnzdxdP5/vvOed9z/eda2rurOpwkZQM7pDBYcVHGoyU
8qKlfGgI4Xdy08HSbIo0B0fpUoG/dEoMTJOC4Ctc+oSZGMnsKb0mSPtR0h60
pJL3lZqJY2iv4VGIVxH6xbBLrbyle/rb6G8HE/kE+AiTvhkyjvMBfvvggHz8
e6l/iZA80dtJdHoZnkfoOWAUnS1X6Zk6O3PbICYWf+Y75JxLjwPfPKIZnyko
4b4ENXLfUmrK4DpOuoI3vPzxOqG+O17qgkzqs/2kR+4WgPexh3SJ9zlcQCh+
Vvz20FlF0wqtSVI1Oi1EG2Z28KPWF8qZOdx4Ds6LaAfT201dJ3TBOz5vYCV3
Tl0W8YfZvsFMvgndSeIQDBr1UU6NYcMT7RHOQWhPG7uCAfbRD1PcZdxLSued
F5l1AQKZfYf3m+f8y9w/UItPCnU1zPCQ6rz7E7GP/n64JL/NXAe8kQ3skEP+
hv2/0F9BvhKWQvGBRGY5Qy+J+MW3hV3XmKQ6qIceNCfcpHU0NmATVvjPWOCW
3Da9d/HO3Rk7tOD3x06Xif/6/XTb
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlX1olXUUx08vq1xzzPvSvbv37m73Xu/u5haFSlL0QkT9EdhwWxSSq3SS
Qe+UzUisqGSl5CooKthqhU7mbP1ZDJq25paloVBJtaJt9ELOXLWkF/p8Ob8/
Hn7nOc/5nZfv+Z7z5Nbf33rf2WY2yHMOz7MRswTnzRmz4jKz1WeZfRs1SyNv
rzB7qWR2sNHs+GKzA5zdBbMJ7P/Omn0U9INJsx70G8rNdnFWc7eqzCzF2bLE
LIf8+blmD2PXz7mt1uzSJrNopVkEm9mk24/jr7PC9XqfT/rdT7F/5CKzZ0h4
nHy6kLcjv5I2W0muV3Dnj3qzLbXu/0fkn3i2XWD2ILo5npHzzD6pNtuNPoH9
AOcu/PTgp53ah6vM9vN8QLyZZn9/lHNziHugATnkv4K4G2sdh4uJ/yT6Peh3
oLu+6LGui/o32dyD/nXiRYj7GmcsZTaJzUwduRBjhpjTnKlmx2kIf4er3Y9y
n+LZStOuipn9V+v9ugHfVSXXHyK3Y9Vey07ybcFvD/o92M8jA7Xdjv1n2F1J
v45yfo++cpHZn9g/lzcrgFUrPU3Xuf8j1HiYWE/Dh5PCmPfc+eRD/ut5Oslz
lDp+4X4Zfg5xr4v83wO3LZyd8OBWfP6Gz6mo80r8ujbmOSv3Vmx+Rh6Ne97K
/yBx7g76Uynvh3goPlxd9F50Y3My4Tnci/9TxI6Qwxl8bKKXT5HnCLo1Ga9F
HP+CeKP4OcHZEnP5S+SNwX5Dxrk6zTOiWCFPYT8QczyF6yzfFpZ4z5YvdUyE
jXR/Bb24I1l86kg7h8VlvctOWAhf5aZ+/h53rmbwd5oayqnleJ1zV/p3wbsM
4zT68hwYxL1f6tsi7MaRKzh/wH4d+byN77ms498FlgW+PYG+jzrG4q5Xf/ZG
nBuxGrPL6t1nG/fWZF2WThwVV6P0Yijq87mp5PgKt3587sDnCfDZSz6lwCXl
qLqFqTi0LGC1itxeLbrPjqj3VrgIk8lGx08z8QY2PRea9Ra9J/Kj2RB+6oHs
hfFCwFmxZsOeuasU9gh8Wwte+4h7hjwX13i9qvuOwE/hpF2mOX0A3WDo9dfU
92HceThBTceyzre5hMdVj5Wr+D4c9kZ9jcdayjnGnTb8f8O9oYzH1Sxubnbb
S5qc9/Ivvv8a+Kw4t4D7PLX/Q57XpH23aMdoB4n/2oUTDb4DtQuPllweo94X
0m6jWREuwlfxPua9D59jnO1F50OH5iPsIvVkbcb1+r6ceG3s8zvJbSrrtaim
LH3sQ5/j3Mq325AfLzhHxdWH4OCNMefhO2nHUXhWppyX0u9Oez81Z+LGd8F/
O34mA26Kqf+B5l7/k/1Rt1/R5D0QVl9lfRf3h39LAzn1k89jSf+HqG7d7wq9
Pp11jswEnuSINcJMFfI+G6p9HRgcCbtXu3w44TZ5bKaQF5B35n33KQftIf0j
hfPLJfefC/x8PszFKuz3JT2mdnxN4KT4clPG957+RZof2b+f8juSu+O+czU7
A2DwVtDL9+VhJ2u2+tD/S269eeex+NyL/cowp9pz4od48iL33gz20+TfGHir
WfkfhchBig==
               "]], PolygonBox[CompressedData["
1:eJwtlVlsVXUQxj+XCpS21Hvubend2tvbDaix6IOlWImR+mDAhELAGMGwJSYg
JjwAJRqICg2btcSEQIIgUG0TaCIYfZA1prS3YFhDy6Y8gAFfaAEhIIn+JnMf
vmTOOf+Z/8w338xJLfikedmzkpaD50FrSNo0Wlo7Qno/LnWUS/vAr1HpMGip
lQ4W8pwjrcA+XSmdArUJ6SVwPSnNHCmF8qRIIK0plfYSeHeuVFohpSrctnct
fIviUwI6iPE9yJ8g5YFLNdIA2JwmH/AxZ5eBL4qko8Q/8oJ0pkTqBSfBbb7d
AX34fEZBrc9JGewNEekKz49GSW3UMVzq/nOp752w9E+V1ECuneQzJSaFyYXr
FeN8Xkp6zH0h7H7uK6b+twK/uzFfOk/8UyX+bDEt9r/EfAJi+MbB7SqvdQ3f
72DPSjs/f5NTM3YnZ9uxc7gjU8adoJfv7eT/LvzPAbNBgvfJMufYuLY77K6l
fFsC9mF3gFHF0kgQ4UwRKIh6/FziX8J/NfW0gD7yzoBgvLSI+gvp519jPYbF
eoWzr4IdnN1e5DlYLrvoUfto5yif+Ht49x341r6BpfR/CfgZrn8Bi6l5ERjg
3SDIlHvtxkE/9kY42wBeQxf14CF3FWT5DpP7IzR280XpHBweIL/BaulEnvO/
lrPDYAiM4WwhWE8P14EG8pwMZsWdSyjRDOxD1HYQfIXdBpL4JMB/xLBDC3n3
+QifAZuFvjLvjXG4H7/fYh7PepTLt+h4566VnGLYFXByAP/d+O8PuSZNm1Px
bQKrqWEv+k9xZhKxJvOuAVzlzDWQxD+R8B5aL5+g38egDm4mguWlrqWFxGgk
1rzAuTLObpBPEPVn0+xd6yGNOpLjHBqXW2M+GzYjb3DvUDTbD+ItQI/3eB4G
dcSeCLroXTG1ZaBnMXfPT/tZ8zlOXs30NE0+96l3dpXXYLXUE3tS2Dk2roey
vfoU/w/wfw+fHvznxn3XGN9f06/usd7rW+TcP453aa/Van7A+a2mv0rXvGm/
K3AujdNq+LlZ674/sqNuYf9OLimev3yGXYW9pdx3ge2EzcTLTfmsm567ibct
y8/r6OsM872y1mPZzluFHaLHQYHPTHfgGjQt2g44XeI7wZ5NowPVvsNsl4Wx
I+Bimc+i6akLfnp5ty7bjzd5jld4rbYzVsDFN9Wurenk/2fgHBlXptGPyPc4
+R4Dg9xxOQuzp3K2CXwYeG02szvxPVvjtVmNZ4l9kueeGtegaXE6/ZwGDqG9
n4p9R/Rld6zt2j8Cz8U4nRfzmbHZsR1gu+CHmO9W24e2q1+e4P8K46wO++3A
Z9Fm6ALxdlT5v8L2wY2k/wPsX2AzYLNgNVgt9k+wf4NpyrRlM26z/jTk2jMN
zsB/iOe7IIwdAfeSrjXTXD18riLHlXHXkGmpp9Jn1WZ2HPftClzrpvlOcmsM
e2+sR23c9z/KSBJS
               "]], PolygonBox[CompressedData["
1:eJwtkk1I03EYx7+oI7c0ZW26nJvOfzV30xUkZTe7KYGSCr4Qa1KQ01upEEjQ
YSXEjr6lpqKHdVAjwQpfSsWLXqJyl4q8RWR6sAWCnz/b4cPz/H/P7/k+L/+f
L9Rd35UhqRws0FUiReC6S7pjk2KG9LpQWoAGr2RkS/4yqcMvheGeaXOku9hp
t9R2SvpJfm+B1AfeUskDt4olJOTGv3ZBugprAelTrvQRW+wjBkmH9AoND/4Y
dY6t0gT2PrU7IUqNJ5nSA7TXaXoDttC0cO8XZw+p0wNxuzR+mjh1znmkIsgv
kvLgM/dt3D/gfsl57jGnF5t0Sv9hiTsJlvKSulMwDQXkOyHH7JNcC8P4yZkk
txwbZeanUIV/BQbwZ7OkfvbYib/F7FF2+QwGwEYPm+zSil1mphUIcd6AXpCc
v/RwADfYRw3sMGc1u9rGJjn/B7MX2Sm7n8GOMmeMeUewHmJeqESnwtRib83U
uo1+Jb1VmD1Sz8eeg/hfiX8B51nJjt4weovM/AYinIeZ4zfzvkPzLewVpv7L
OPHddDxEThg6oIqarczxyEj1afZ7iTmDMMksj6l7Gd8g/z06c+jVolNn9gAO
KEvHfFgnb8sBCVilv5to/CHfTnwfO8/3Aozx31/Ad87OEPuBbee7n3oG/iD/
ewga6fGQXTVhW6jVmsb0n1PviNxv9BR3pd7nh0DqrZtv/gRHz3Z4
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlX1olXUUx0+WS+cc5r13bc/z7N7tbu7lbglpxGTUH4YRQpK30iJZNRCL
NoWI7IV0MFe+JKs2C9bLxFiWaUFvg5pUaMqyjNJeFpEZZUVJbmb0AtHny/n9
8fA7z+85v+/5nnO+5/fUdq4rrp1mZvt4zuf5LmvWc4HZUINZaY1Z54VmB2Kz
+xKzPuxx9tbXmd1SanY/67X452eY1eXN1jSafcLZ1awPVJhtBnCEs82VjnkK
35Zg/xaZtU83awPzEvx+JN7CMrMfWHfMNRuYZfb8PLN/02avyKfaLJUyG4Xj
Z+C8Fzs3cdxc5lg1PDua8Jtt9iTrKs734tMN947YY30LxsPYK7AXgX1n4j7y
/RtOfXBrg+PuBre190zsuRwumN2Y9rjvs7cp4PSyTlSZDeLzFHmPk/8GiroY
35Pw247PMHHuBXeYuiX1Zl/C70p4zm7xeIo1RV7tc+A7y+u4lPMbwZnMmV0T
7F+xT6Q850HivEzdzwPzp4vNurJen2H29vPMYP8d1gFyexNuD8Khk55dBJ8z
5PUo9gZ61wVmeei18jvJ+03Y28krhuNcnsWc38r+1+A3wn9Xg+M8B5fJSq/9
5a3UFx4dcO+Ey4lgr8Jem/NYirku2BlwRsQfnLcj143y3gveSNr70gXncxn6
QO71+N8TdLgUvs/mXXub+H59i/dd/R+q8F50JN4P2cfIZQ++/WWey+05r/ki
YsVgHeVblrWduCvBP9Tk+SivKXyScrOb6U1U7jr6r9R1m4NTL2c3gjea9l7/
DM5doc5nI3/X/s7Ea6GarKB+U5H7qCeN5PLuTLM3qFllq+uginUB+LuJdWm9
81YvFHewye0B1iLnl+FzA+tQqMky4lyVdh1Kjx8GbWiGJnKe49bYeYhPMeva
ksau5lwc8nqIvaTg81VscS3K5wh6/yP05bE6r5cwt4BZXWtWSy4J6x3M8nr0
XESDl1GHL8BcyJol9yMl9JD98SqfL90Z08KMi2+h2md/Lz5vRc5T+tIsqZ67
WB8PGpa+GkNvxPWfjPNXf8Yi15i0djrw1zz9kvP6HCb+I7HzV23UW2lFdT5N
vBLeR/NeU9VWujsbeqc5ONrkOEvSno/yupU8Xuf9CfZ/r/GZ0ey8lPJ37aci
n3/dA0vY3x94doC5hRh/UsNteded9CctVlCTMXjNhNdq/JbDZwJeccF9ooLP
gWog/vnI/Uvw/yjneX2c8/Paz4J3rsY5R5HPg+ZiDT5jGce/rs6/yecvfA81
m31OjAOt/j/QPL6Y9hjCfI2+3MaZonQL3vygpZ6cz638704cS5iVYKfqXUua
9ekBR7k+HXL8KuuPbOX9fajhq2m/F3R2Qex3tLR0HM0fbPV5/TTleWt+VJOD
zX7Hts/znql30oLuVGlItZuq8DtzDtyWB866e9LlnrvuqZ3h7pK+9D/Tf03/
Os2M8lXeqpH8PyBmBv4voIEzzMRkwO8Hs4cze6hVG/6nKj1GquC6l/7nU4dv
wv/iGGtf4md1rys35diOjmrzjq844i0fxTkezgpDd7ru9m2x10417Ca/lYnf
k7o7u0Nt9/G9P/hfgf0/jj8pgA==
               "]], PolygonBox[CompressedData["
1:eJwtlV1s02UUxg9TscBYdG1H13/Xde26wgYmOE3QJuPCiImJMguKSDIjCgYz
XOJHxAtwBuZkMKYbMRE/MDNgaGBcIM4oRmeAxThlyDDOGOFC553DQTBigv6e
nF486Xn/73u+nvPRuvUdhWfLzGwruBFka8zqweFKsyOgP2u2e55Z181mWxJm
a/nWwXkN5+7AbAlvh5AH+TbG20SdWd0c//ZvxOwpdJ4E3ei9DhL1Zvvnmv2D
0ytRs4kc328w28b5Ht7/V2t2HawIm90H9jWYdRLYQyGzd5AHsdWL7Sp82AKz
8ylsgEPoFsHD+NhMLPlbzGKL+c36+RF0XiPelqzH/yjnPs4bsbehFKNiVYyK
9THkdaB6sds6Qwwji8zu5LyWc+oms79iZs9XmR0Puf0d2HtroVl4PryQUz9y
Jm2W5v4g4dYh7wfDyLN4/wHyZWxch49lnNvQ7wmcW9mU7Wspz1U5D5PfbSW+
xXEF+U/iYzn+1vPtK3T3is9yj28AeVfguSpn1W4q6Xw+iM9VGbOPsfHlHI/x
Ae6q0ImClfhqjTjH8v/tbLNk3Ox9anIr9groP45+vsksXuGciJvNcLad+x+x
N0j8PyQ939m8/5R8u6s83hYwQewzMY81DxKNZh9SnwFiPQF/afztrPT+k81N
2P6l1rkRR3nim0e/zQVD3B0F58QBut/zJgF3v4ad2xwxZrH/Wdy5n0U8ReK5
K+K1k03Z3h74WT2jXmpOeS7yf4C33/GmGPKaqXad0uH8EeetnMP4iFR4vzwN
j20Jj+cl7K0mt+XYaAEX0LsIctSzoTRzmr1X4acTjFXjCzyX8NkTB+KiAJ9t
2L5KTXqIf5x4zwQ+M5qdv9G9CiLkGQUjgfeGOBf3f8JHX7nnMMb7tgbnQzUq
4251xntDPXIRX6fJ5xTox84AeJn7ddx3cf8E+nuIoRfsZpZ7oz6DmsWV8NYK
jiD3M9vH4aCLXKLM/7aQz38YeRKOfsp5zsq90OS9oBla1eQ7QLvgHFxMgMmk
74IQMUzTm8Np7y3F387djqj3snq6gbuz2B7PeQ7KRT2iXrlMbFfA52m3JZsn
0D3FjJ+f7z19kn7+Y4H3ijj6Aj6X1nutVfNrvF9Bfq+U+Q57N/AdodrLxmnk
ZMp7UT2wBr9xYkhUuP3qRu9J9aZm9gJ53h44N9qRNfjalfZaq+afxF1HurI/
ushnXPMjmwF3O0v7Q/OuXZfnfDeYps6XwB3IzeAFevVFcDjm8arfT2Lv7bTv
KnG4D/k3dJrLvWYdtd4D6gX1sHo5FvfdoB2hXTVU6f8F2lGN9PNZZnx8oddA
tVhGTkVy+xkfPdgbrfbdL/6+KdVYte6lF/aAIv4PgQ283QiWxnz3aAfN4LuQ
9dkSv5PoDeCrEm4C8B7ygcBtq0b3E++9Yd89mgftTu1o7Wrp7EX+mpqOgE30
+TMZ34HahepR9epoqT8041PE0l7ad5pP/Ve2ZryXND9NMf8P1X9pHC6CGp9J
zebvcDUFZpI+S5qpLej2JXxWNDPHIr4DtAumyf0SeCPj/aF6vImcrPFdqZ15
EP/ttX6nmi0h1/8Bhe4i0g==
               "]], PolygonBox[CompressedData["
1:eJwlkrkvw2EYx7/uuppQdVVRRS0WNREGf4CjDEKi0kRdCYsrEToICVEDMROD
c5NIDEQwShxxJRZHwiZtHLX6/NLhk+f5ve9zfJ/n/Tl8w56hWEnFkACTBdJB
nPSVLd1xeA/hIikEF3lSgOBP/ALOL02SDXtlk66hvEQ6SZZc2FmrNAetTqkx
RfJgT/k+gyAswi5xMdztYTfo90C9aur1oMEPU7nSFvdVpVIN9WvhrlC6hVCO
ZOLumNxmcppgO4u+SVILvpl7B1rsDnTZ0QS3FVJ9uvSItbqkbFiibxDOqe0j
10yunX5r1B6jv5vzavjh/Bu8FvaQKP3iH9I7kbjPnKgmQ5uNPvmwWSatpEqr
mdIodUYgwN5mjJ1RvwGt0+zyEi3XcANhYy6YYFed1B3HesGD3+2M3hkxPuiK
l57pG0TDEnyg5x0s+dIydd/w99nhEW+ZQFwKe0iFcDl1YIc5nnjvKmwvumap
t2Wcwy50ktsBbcwxzhx9zOEnrgcqyXGn0Y+4F76foY552tnfK/46eUHDR0OE
3f7BAPr7IYy+DO4GndH/w/hPFtAf4a3msf8CoWac
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlG1olmUUx/+u91zPtvY8c9t97023Z8utPkhG4IcoPxSENRWjFpWNsihq
REhEFouGL8lCcjNKklkQpkQhiIJstSgxyHBu+2AfZJVtRQQrkn3oQ/3+nOvD
zTn3uc51Xv7nf662/oFNL1ZIGua7im9FldRXLWUFaaIo7btO+iKXPuySlnG+
H/nOSqnzeqm/Wdq8StqCPo/+Zp20lyAXO6Uzt0jTN0mTyCutUvEG6R/kX/WR
Y22PVMH/xLXS+QbpeeI8dKP0HPKzmyWO1dEkHaWGndQwi+9Gvkvk6kW+mod9
B3K0QzpJ3j3ondyZQC+skD7tCL2zMe7b/zV8LrVIj6CPZNLr1PPJ1dIgtsNl
qVQpfYz8kT4HAWYD+StqpaXl0uPl+Ld9Cf8nqPUsdR7ifHO3dAd9bUI+3BL2
Huw/gMWXxPweWW6XWsm7lrwZ+iH63U7+qa7wuYfY362WvkK/gP9PxDlJv3PI
WfDtRV9Pzmvo5WniTBGnN9VTh/8I/Q5T517we5eYNeB/ALmFf8/4LfynUj3O
eVcxcNiPfV8WurHpI8574DbHXM5nkStvjc/6dBZn9hlj5kP8D6G/XBdYG/NK
8D+WeDJckmYaYtb3gslRcNyB/RlyjaQ6Xa/97G9+/cnZOPoicnlb8PA4s9uW
+LYAHi+B3WFmdyv5d3L3Ik2WuTuQ7Nu5+2RzxDyC/deUdxv2Ar2cdS5qHi0H
tsbYvDQ/13XHHjQVYhd2c/8KHN6F/KMcczxCL4PU8xhzfGNVxHV897cbzClD
T1HzsSz24m5wPdcQunclawqem+/mhGM69rPp7qN53LH/GOeLpYhf3R7cMse2
kvPrUmDiXbw9xWlqjz5ce8+ykO7lNHq+OvS/68PP/mu4d7k54hjjVxK3F7EN
tASel8uBtXVjPJM4eQpM1lDPnfBqsRy7Zw7c1hTz8FyGqHF8Zfj7XmXymaTH
D7D/C7bvI/uKwTFzvJbaDoJtCflAmrtr9G54R2bN+RT/BLxb4E41cX5Hrsti
r73fE3ng/B/2QuKS37bfqKEfn3PEbEvcdn7vkndquivu+O7W2sDMO24MpxKf
/YadSn1dIE6pMd6iJeZb3xN75/07mOrcVYrPumv/qC726AVzOw/dtsn0fjYQ
Y30x+p2hrs/zqN87MZreSfPoTHP04p7GG0NfQJ/Lgkul1uCTdXPTc/V8/Ya5
Vtc8loeffe6j3wc52wD+G5HzCSvn6a4Pey/2byigqkb6lnoP5BHH77HfAr8J
b2fxZhmf06V4N43t/cV4O9zvL/jsSfh4j3+mhirmOO951UR8c/h/v+T2Yw==

               "]], PolygonBox[CompressedData["
1:eJwtlGtszmcYxi8m2jlW37fV9m311WpfWpkvIsQH3xyTkUoFw6LbCAky1iwM
kTgrInFMjDhFxKk+rctoBXPINokGHyqIxMaW2dIJ5rBkflfu98OVPP//89zX
fV/XfT/PwIYldYu7SvoMdAPFQ6XbvSX/K2K9uVRq+UDq+6H0OC2tqJSWg7nl
UgN4ko49nykokS5USOfBhQKpFXySL/3QR5qRI+1ISbeKpbbu0o1cqTexjfB/
BSayngQKBkn7e0iHKWYJ/GeT0hmwnjMbQGORdJD9NHzD4bs7WLoD7oMH4Gg1
HL3gp/7pxI8jdiz4lrMHQHtCGtqFmvtJP6IvRc0l4DW534CrQ2KvD7jC/jv+
vQUtcHwPJoE1mNOE3lPwrU2FV+v4Xse6YYCUQdtLPHnYX7pWE/ovUlN7hrhC
8uaGB+14cZmYS2Aj/zeBQ6ngbuXM39R/Ds070JqE7z/2N1YEt3PMJdfn7GOJ
9hIzj/XUKqkOdMB9D7TD90VO5HTuCdQ/HvwJ9zPwIh3cztFcGjGO3cvZfYXh
ib0pwqNisB2+ba4RbAU7U9Fba7RWe2bvPEPX8PJQdn7yyPF7OjRaq3vm3j2n
+DJiZ+ZJI4g9Ru1HQQW5KsEjamzJjRxjktFD9/I6uW6AcYnw0vr+5+wl8rWR
Dyq1sa4tk2rAaTjPgDzma2VuzNeX5F7NLM/uEf86mdeneFrPehr/hrNfV0td
faPGUvItrIw9n7lcEDW79v6c+acoPLW3njnPnmfas72UWpaB3Wg+3yU4p8Ld
WB61eOaT1LYr66c1f41PVWVZLWjKsP4LT56BIeSqAU+ZsYZuMQ+nmI2DiZh9
34Ej3IUTibgrvjMl8M8vD63WPIr4ndRDOepHv3ax3l4Yd9Oe3mEOOuEYCddx
coymtiloecj+BjhPJsNze+8Zu8X+N6Wxt60n3FXRQ/eyO3XmgE2eddBB3D1w
oiJqt4Yn7D9OxSx7ph+xvjkg9v6F79PqmDnP3gzelZlgZTafazpJ7X+kY9Y8
c3vY2zM4tNlze+8Z9iz7Tvtu/1od/tuT31ivpqZV4CO8GgZe0eOXYBDrKrAQ
zgVgFtpmg6b80Ooalmd77F5v5v8WsBV9TeA7craA0bUxK36D/Bb9kom3wffH
b+VialqUjjfPb9+c6tBuD1qJ/xk/fgIJYpNgMuuPwQH3HpwjpjkZHOZqhvNs
ftwB3wV7Zu/cA/eiszzeGr85N+n3NGLrk/Em+W2yBmuxZmvvyMRZv4FTOPce
yqP0uw==
               "]], PolygonBox[CompressedData["
1:eJwtkk9I02EYx7+oaVpptN9KtlLnn6UzFKSLV7usg9tU5kEc2iAIooIoRmGx
w4z8swhSlEZCGUJRFIEu0Fk3twkesg6KCTUoD62LTQ928CPb4cPz8P7e53m+
z/f92fw3Oq/nSaqDQxC1SHOweUrKFEsPqyWnSSrn25UTUicXuyB5VkpAmyF9
OiqtkBvcM8GXCslzWBq3SzGztACeGqm9RHITJ09KE7BqlS4XSbYqqZ+6c8wY
Z8Y0/V+CpVaaosZKvFcp3Yd1WINhakP50k36fERDFLbocxzNv4nN1DRBkLsz
BdIACzigAX6hz4s+F1peU79J3kHNrdPSbXjL7DfQdEZaZMYrcj99LkEr9T40
Ban9T63BvAy1Fjyzwj/YhhfsbsaX58QivCyED/R+zL6lNul7vbQBqxDkAdaJ
8+asbzE8n4cF6KN+94iUhz9JdC/DN7z+TO8LRvYNDt7iGBri1JYSvZx3QwB9
Uc5+oDuMX48gxfcyNP8kvuPOezDwKcJOJmIGDTswxexnECJfQ1+EfNaSzYfI
R2AUHrDTIDzBozA6x4g+6IVrnE/gXw95iv33mPuUGhc7uKEfXXHePICXd+Au
dOT+k0Z8/sO8NPzlXow90kQnei/Ceb53c+9qTdbvA9/r0F8LLexZhc928rhD
WoKvOc8S5PtQbXbt
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlEtIVWEQxweT7OXNx73Xm9fu+4gZEVFte9AihUjMELy3SG2Vi6SkAouw
ArMQN12hLCUjwhZWkKbQQwiCIqM2EklRESgtskUhRBb9pvkWh2/OnPn+M/P/
z5x4c+uewzki0sKziKcmKfIVx+OAyJ8ikQf4JiIiMyUYy0SGEiKD5SLnckV+
loq85NvuJSIH8M3xXpAncg273i9yBpz8GN/B3MXdypBIYVxkHVBNxSK9YP1a
KvIJ7OaoyElw2on9zZ1L3F0FXoxncrFILveEJ0R8DvFjAcu7hfhNIatnllo2
OnsveL5iq/8Z/tO8v8MuTVkOzdWILy9l9nfwRv2W9wL5f4TJT/wa7H7sDH3t
5HuC+A7ij3N37Wrr5S48Zei5kbz15LpKXwvUOcBZEzH/F2ru4l3AGaOni0WG
31YmMh8wTD/Ym139maj1pj1OglHOtxtw6KUsTuOPEeMRX4V/O7FzvO8D/zr1
LkSN/1pqbqWHGeLvB0kYM38d/g7Hg3IfxD+JnQ2arlrDf16prwvMQzHjQmuu
htfpCpFt+SIfKowv5W0ETJ+rrQ3MpNPupmdzoHnfADDueFadT5Cvk8HLUvNf
7AC8zeMfCFsvg5zVfrO1v3SRzWm3+sHt4eUedp/TaKtns6i8vYK3WVeb5jwK
/gj+aXB6wpZX82utWrNq2xU0zKdhmxWdmSH6fZSwvXiIVr3gF6xAB/yfsTdg
f+TsdFzdIdd4qWndUG77oHvRT3w6abbuym1q7V0uMsw5nLCada6/uT2qJbYp
YjN8PmE8Kp+N4Kyktj50L0yZlsqtaq57ojFRMLrdvI1i+/CXwW1eic2f+vV7
Gsx2atjPedDtoO7EKbS/Bf567LdoNgHmFGedZ3aVzoDzq2+HZxqpbi1lNic6
46qH6nIF/5OAcdiQtP+L2sprHI1ek/cy3L+ohGOfyHPOqQrTQjUZ4nlPTBWx
R0LWe0HK/k3Kj+667rzOre7QWNju6ozo7KouZ1WfsM2PzlHWM7/q9g8gs7ZN

               "]], PolygonBox[CompressedData["
1:eJwtlFlI1FEUhw9aWqkhOY7LmDM6uWBZ9FDPWQ8pbtiD5AZaUNCDBpGUlRVB
WYoUqS1UZEWUViilBYaS0EJaomGRbYoWWQZFYAlKfYczDx/c/73nnvs72z9u
S8Wmcj8RKYJ50B4j0gazTpE5aHCJHPUX6Vwg8tEtEhUtcpoL4QtFZjwiz1JE
uhZzP1DkIrbJnCdBcIRICBR4RSaxD+W8kHUHZ8J6hvsN8SK3uNMKaQki66GN
dT3vrQsReZcs8jlWZAK2cXc79PrOD+Mz38GbYeY7a5FINufnXKZFNZUsEamD
WthLTFVwBpqgkbea4C8x/YFMfGVBSqT5Up8/0LrRYf4eEv8UdqW81x8gEon+
f8SfzncP3/2ch/N9B/sa7L/wXc53V7jFn47PDeibYG8c2rBrh1XLRK5z9pa0
VLtNo2rdDwegL0nkObyEAbiN5sYgkVTsly8lh057WzW8iRI5yBvV8JN3f8EL
7vRDETkoBr8I064xeIivLMx8qc8WX040N8d5+wQco0adYjWrYe2Otrsx+AiJ
E9mFDc/KezRkEtdZ9Az49IxwMBxla91zcz5EfQahFrs6+JQosjpYZB/nWzW/
blvr3gq0pXvMt77xW2tLzgphPvsB0Mv7j6AbemACm3EYhTEYwd897tMyUqP7
EdZ7Gs+DaMux5roFLa1Oq7HWupjzDN7Jp/dKGYxZ7lwg/jSv1VJr2h1uM6Kz
4sJXDIwhdBQus9cMj2N9+ePOzXibCZ0N1azaCxJNi9rMUZ9rfF+FzegogGqn
6dEePO8yjap1N3crYSV7qVBB3+6Eu07rPe3BI5w3uywW9aG+Bny9pD2hvZFA
/11B2yHOp4knz2u9r/Hlei0GjUVzqrntJ54cbEOpTwM6PyTbrOpMDifbDOks
6UzrbNe5LPf6D6ln/Zo3h309rb3tCDNf6rMP30PkbhD8qK0/VLpNm2rcQ3zf
2Jv02AzrLJfQq1VB1h87+M5z2L9B9dznvbWwBr6jdQpyOM922Mzr7OtM6Gyc
xOYUPEXDE/hKjSahB9tuh/0T9d+oPau9qxpV6414q63Wr4x7l+KtV7RncmNt
hnSWdOZ19qc99u/Uf2gHfl+RgyFfTjQ3gRE2Wzpj3mjrce11nRmdnYwwi1Vj
LiL2/4HN6Ho=
               "]], PolygonBox[CompressedData["
1:eJwtkkkoxGEYxp8G2cc61mkYe0IkzpaLwhycrBcHboYDibIeKA5k5oKD7YBS
lFwUN1JERFkzZadwVMJvModfzzff9y7P+/7H2mivajFISgQfGDBLw76SI1Ua
CZdGoTNGmguQ0lKkgnipEIKtktlfMqJbkdI2tBJnh/YEqc+PN+Irk6UKcm3o
nUW6h6UkGnH3EC3t8HsXxqk5BjfkbpB7jZrjpHj4wpyJXj9RUgN+No3SXqZ0
nC6dwDJenYHURdOJz4AEcg6pY0Vr8VbnhpqD3tJsmjQPC/AGr7AYIZ1jKxcN
w/ck/tqYJRtPOdCM/yZ4tPzXyOfNi9oGOIqV+j1LXKfPBOdHzs/w4lbmfIID
cm14WmH+bfa8Bb+8xzCb2KMDH6FBzIKeEnsG7yapm5w+evdAL1xmSEXB0gVa
ST8buPB4Cybq7RMfhX6S+wGhnnlC0Bp2UA1ZzJlHLxe9OvDRDuXkXJG7yJ7X
qLkKLdw9cGdHp/H9jdcpdIi6wx7cZwd3X7w50Tq+Qxffoxa9ZTeu2P9Z3DOV
4r8ML6nsr4T3YpjBdz3/uVLOf5aAZXU=
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlElI1XEQxyfXFi3I7el7vKe999SoJAg8dapDlBrRZmoLdWgB0bpIBRVE
0KJQYgua3YSUEhIikKIkMIWKoKCLeTAU2iCKoi5Gny/zO/yZ35vlOzPfmXkV
h9q3t2WYWRtfJt9cqVkfj6Fis/wKs+sYE2VmxeVmR3PNZqJmKwvMJvDdkTAr
w6d8kVkE2RMz68TnAr7v42Zns4ivNHuGvgf9c2QTMacWmg2g/0eOUXLFwM/C
hrD1xL6sMnuaBwayC59r+Lwl75ugl/1c0uwvtX0vMvtR5G/pNqbNTiwx24BM
RbyGTwDXpx3nCTgNSa//Dn2UhL4+Rr1W+b+i9lXox3LMpuFjD/pfYDZXOi/i
5w/+w3wHiP1NT+mQS31vItd+9IPYDxY6vvLML3ecJnFS6NyKY/El3rrhoL/c
9aPYW8G8udgsO2X2OPjLPst3Gf8r+M+Uep0t5KxLez2q6xKcpOC5f4XZl4D/
EIy+tHN+m9idcffpxude6OsM+vFCn1cOtWUR+wKfXOTpMKMu+lgQdkN1KV44
jXHPp/fuuO+Kep9FTvC7Af0Q9r3EQ5W9Zo4dMc+r/LX4DWA4Sd9GvnH8M5FL
6b8XHo6jvxvz+tXHfNifEXRDUedc3N8P73pq21ronExVs0OlvgPaqfyAmYfc
Rz3ZpOyN+q5ojsmIz17c1lDDZKi/Oum7qx1uYe5W4Vxpx2+E3sV9e5jRCPmX
pXw/tadr2bladvgbGDMBRzdxMeb+x9I+S+XdXOD5lPcRsYNhRuJMd6JZbMGn
O+p8ildxJw47wFzHexc9Hkk678IZp4/OsA+6V/Eifh6AcSvcr/ZlMupc6W5q
wi1MlfqtinNxfzjUoNttIcc2cq2J+N6IkzH0GSnvsTnhd6JcI2B/LXK97M0h
tgk5F/fb1I3WJfyt/5t3VT4jzUqciivdwTB9ZRD7ucRnptl9AGM64ZyIG3Eq
/86Y765qPs/7aqVzotm2ka8RnFZkJMxrNbHF4b9OtfwM/zOy/wdSiMOb
               "]], PolygonBox[CompressedData["
1:eJwtk0tIlGEUht8cL93DcRy1GfIfRzNbVJtcdpEWKRWkZgsj0YIsoojaFFSL
irAoiszAbihBNzdSeYFQC8w2ERha0CKDXESR0NVFRc/pzOKB7/u/9z/3k2ja
X70vTdI6SIerMakdVpdIa6A2ItXA70LpD4QCaXimdCEkjRZIv7j/hEdoemBq
ofQFri2WrsOpqPQE/fYs6S52p3KlaRy2zZayiqWPeVIa541oRhZJfbz3wqok
McDJuHQCduNjD2TBs5T/59g7jv1jUY/ZYn9R6nkMzJVecm7KkRrhHrnch/f4
m4A+YuyHOnwWY+/HHKmeeNvQnOd8lniv4PcytlvhNbm+gRX4H0PfzHsj+Z4L
u76F+2n0d2Ke6wG+NfB2Me62TGPao9zbiR3XOsK5G/q5t1KTQezd5P8b0AGd
UE/ND+NvKzVame8xWCxjMA6HeD8IRdQyCTWcR7C9BX0z9avG5mboxVZfzHtk
vWohjzOB99R6axrTWo2sVksIsAz2Jt23xfCJvmyIeH7W02n+m6Bm72AH551Q
gX4tDKAdhIxi77X1/Guux2CxVOKjCp6S/yXsBbOkefSlKsdrYzWaJL8ElwDS
E9iCDzGvvfWgg748hAdRnxGblTD+smEZuuUx15h2KJPep2pmtSsk9wC+o/kG
ZZyXQsjmMc99/vcduLaevLdBRYn31mrQxX9DzM8gzCfuBVCJdn3gNs12NzSk
6mW70Jnqrc2szW5Prs++7UBXET2J+yzZvNgsPo75rNvOzcDuaOpuO5AZeA/M
tvnYRHyf6UU5s3+LJShHm5/w2lqNh3nvj/is2czdxtffsM++7UAtebwt8FpZ
zWzWx0t9lzLoySvOYexlJ3ynbLd2JX3WbOYm+f8fxHWoyA==
               "]], PolygonBox[CompressedData["
1:eJwtkjsvg2EUx/+9UNeKWwmiqiXuBrG6Lkok4pK6hQQRRIoQYjHYMBioxKUs
BgOJhAQLXcriI0iUD8AiWIhf8xp+Oec9zzn/c57zvK6RmU6/WZILYiBYLB1A
MF164NuBHXNKo2DzSDsJ0nS2NOGWevBr8Ls564F+6j4SpZ806S5fCoEPPHFS
oFCKZEkvcIpvpvYMe5UpXUMlOh3E+tF9y5HeoaFIqofdXGO2IXTLCqRS8DJX
KFYqx0/Bt0OYXu302mSOL2r2LNKJQ2qJ5sM6rMFlhrRhA/xX8ibwHfjb5AZg
kPMBiCV2j54VOwWTsJonMZrG8VuZzQvnaAyj0Yb/xAwrVqmI+zRylyao4Pyb
Jaewv1RIg310bpjvl36faH1BPbl18Piv4UFjg7w1tGc4vyD3EobZwxx7bqbf
IdpH0f3wgFZwMtw2vUz4d+z1Fvrcxm4H3MY7Rd+rFm0fMT+xauqrYJbYLrFk
5nNDISySe8wsS5yVol0CybxhQTx7oEeSx6ixY+fJXYj+B7DM3l54h2eIwA11
19D3/4/0Yk3cKUyesF3suxtC3HfLZvyQZvpY4A/uili1
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtk0tIVGEUx880U1kpwTysuXcY53npYY99RNFCKWMCKxWTLIkSCysRalUU
rTRoKAxhCqtVYBupBgeLbF+roKQHlARGRG2KiVb9DudbfHzfPfd//ud/XtmB
s53Dy0TkGCfMac6KvF4hUvBEkgWRu6tFRtaLnOFMRUROtIi8SIh0NojsyYsc
jYqcWyOyuyhyMiPyFfsQ96wP50pwcZHTzncI3yy8cwQKrxP5x/dxMM/BjuPz
E98x7gjnKqL68K2mDH8P/kNxw4f4fxjfi+AH0bCT04bOHdzTRdM/EDN9qvNj
mrz4jjWSTyDypJkbznG4K8Qe430Z2wx5dYDP4xdwvqGhhq2fHKGUh2C/oLuf
XLrhbHeYJXJ6n7ZYXdhayfcKmDY0RqlhC5pb8d3q7CXsP5KmYYa4Gz3TrNqH
85aX5hfCd4K8wtwd/Bulzvu4B7WmcP6Bc4Tv67zvkEs5J/J3lchN7gX4b8E/
Ab/neqpxqnHD16nhlG95aX6KU/witianeRvv377F2gt+FE0L4BsL1j/tyzxx
t/uGXwpsPrTXn3kXyLcd/bvyxqUYrUeX610d+xHXI52pX57VZwt+swmr7aOc
cSlnL37vfNN5gLw3+GbX+VJ9qrOO7UNg/BpnM/Y3vDdxh6hDkvosz1pvNJb2
5ALnPjrzaCuB+wR+f8Z6oz1qIMcbcDYxP2uZo6duth9zl4o2kzXftKrmasLm
UjUcJM61lPHo3M2nbcZ6A8tfMd/B98Rt5mPELbp50F3UPDXfV/D3BDZ7Nc92
QOM+wz6Zsp7qLOjsKv9L4lT4LjMz5aj1WzGVlPkrj87yef5dAnOqaDumPZ1O
2T7oXjzwLTeNpfsacX3XvexzmjNw33bzo/2ZzJkG3aeY2+XuuO2S1kf3JuPs
b5nTubTpWYT7P2T8pEs=
               "]], PolygonBox[CompressedData["
1:eJwtk0lIlHEYxh9cJ1MC1xlnGJdRUTGzc0WeMtQ6iJXYofRiexGeg0JbbMGl
QNJJ6lIWBRWFZUURhUKdgpDSDlEZFAWV1aXl9/LO4YH/973b87xLSefelj1J
kppBCsgokKKLpOdpUnmh1F4hNQWkLRjbeI9EpBPpUv9i6Wy5dCMsXQe9+dJh
cI33VbBQJP0E01FpClTGpCpQg62I+HiGFCyTGsnRTa6t/JvA9gwMJUuHINWW
K3XmOBfjlF1CXLE0Cu5guwuWBqWDcGuB42byvwlJc6AWn2VglvdrUMd7OVgF
VoJG8jaBNDikgm950ncQwJYOpuAxDVKpGaL2JJxK6MfGmNeymjXUziR2Rq4p
i3dLrmt5jM8f9J/Klk6CI/TtKFgg507sL7DH6VcX+g+gP07+z/A8jc8Q6IFD
LxjkPRDxHJYrRo3zGV6zm/z1xO8jvo/4EXK/DHnvrIczIddoWt/z/gBC6AmC
J/B8CnZQ413A6/dQ50rEtZrmJPz6s33WNvNhbPep0ZHQdwz+m6K+G7/xHyiV
9gd9ttaPOnyPRzy3adwO13Y4j+F/Bp+kMp+hzfIifpfAZWLGQQO+a8HNsPfT
dqQz22dis2nGtg50EtsBCtARLPaeGzfj2Mr/1cyrgVof6ckE830U9X3OyqSf
7HMgwc960EX8P2r8Ba34bQAXwt5bVlBjvOcLPZflrCd3M/WaQBU9rs7xG7Bb
MA2mJbnMtZrmyrDfhN2G3Yzdzq/EPsxRf5y4Pjh8CXi/b8M/FX4pEd9Z293Z
qO/fGnLGrNdoyMn0ffwKtxUxt5nPK3wHS302NqNJvkcT92s1HuT7TdhtWA+t
l28L3Nd6NFzqN2S3ZDdktzRf4bO1/atF75Ic76X5PyR/c7FrMU3byLcbPrvA
J3r/Oc93xuZjM72F9vVFzt00nCN3dbHfhsX/wH6PHJO5fvPxxE3YbdhN2G3Y
Dtsup7Gr6eA/2Huy6Q==
               "]], PolygonBox[CompressedData["
1:eJwlkL0vQ3EUht/Wvb31tSjtbYmqXo3yN0hMKkEHHzG3AyFUJB1MBguJhEox
kDKqgdHSRowMJqPUIEh9xMBi9DQdnpxzz/ndc97zRtIrkxm3pCCYMNEnjUO5
U0pZUpL82i99e6XtHinfJe3DPPkLtTmiwbcJHx3SGrVMVFqCZbDpB+CZefkG
6ZBZM93SNOz1Sn+NUo74HpKqELWlkSZpiH9/mfcDtiMVqAWJVkTywA37Sswz
AlK6Tco2S2NovWDPJbxx0Cucs6+CpiQaZtulDY41yC3wwk5Mam2Rdom3aLoD
Bx33HinEHhuCcELfxzu/jz1hPIIiGs7giL059h8TB+jHYSpc9+KR/0apJ6CI
LsYqhd5F+qcGPnGvyV0e2GLWJizwdp15q7yL40M/XOFDFe0xcndNE765iCVu
KsMX/U9wM+cAr1zEYd4myB277m3N4wJ+PKBrkNsr+PME/zgeRlw=
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkk1I1FEUxU8lahoEOY7OjPifaaYRQ4xA3BniSlEnCGxWFtlGkooQ3USb
hHCTlPgFhS1ECJdBG91ohGARtHAjtVJUEtv0geCi/F3uW1zefeedd++5H5mB
hzcenJbUhZ3B9hLSWqnUXSUtpaVpHldj0ka99LhEmshLffjv4f6/IDXAGYPT
D2c95vxERjpISufLpFn4VRnHP/A+D/9PufQp7nfDLc8M9y/gtfgvLnp8y9Oe
9Tj7xGuqla5XSDfB+rLuFzlj/PnM30liPMOeU8i7lHSLt1Hw3WrpEDsi132w
N3A2wZvSrs/iv6berpDLtF8NdX2nH20B/wF+DXyLv4tx74X1ZA2dj+gFKTVe
J5XmpCdw7kVwAj4J/rvacXu/Az5cKXVekgYjx2vAS2qk5FmpLON9tP7kyPsr
1NIbuQ7TY72xeqyuA2Ln8dvpSSNnR9rnuI3+nTBTw4pp19NDvQVyj6Chl/MV
NkHMt+jsiTzXfN7vhi8zq2/cr5yTLvO3GWvB3webZV7HaJ7h3CD4Xfjl5DmV
c23We4tlMQvEngv8bWptzfqsl+nhYsi1wLmT9N4mmPntmM/Cds3uhn+FH6/z
WqymQfCX1P6XeCLvFP4//IqgoQFiIfTEdvxn2Ad7T4R52XxsV0yn9Xsp5btk
O5UKeU3XeqjxY8pnZn+HIq/Z8CJ6B4Jm26PxoNN2YYVYh/Cfgp8AFu+A4g==

               "]], PolygonBox[CompressedData["
1:eJwtk0tIVGEYhl8c8zatnNNcHMmZjtqFyFpX1CqFHIo21SICC5wKCpTaRJui
RUGRplDQRC3clBRaGk5qBiFYCS2CyqIW7UJ3qVAQPR/fWTycc/7/u/3v/558
17lDZysk7YFK+LBeusjL3jppYyj9WietEtDH9yrfhRbpfFw6US3NZaV0Tpqv
ka4Q0xWwXs8TnrD3FK4npWswxvs43G2U7kAPdXqhslmKwSb2NsNzeJb1Glbr
Lbm/qX+TfkPkFejXCUV6nYJR9keghr1aOBz4bO/ISRA3xN4X3l9XST8zUomY
ezDN+isoEtMNa1irgjK9J+BPk/QXWhukFkjmpRTEU1Jdytdsb57Y93CEvkfh
NDmX6DeAXmfS0lZqf4z0OW7zEnsjJs2wtkLsC3qOwwO0eAhvsj6/aXyS8/fB
rXrXzLSzmWy2KeKmTbPQ78rubI67KweulWlWMp2o2Q2LnH0p43cwFmlsWrdT
ax9sY9a2tMdYrGlq2l6mxiK1CFWS/lsSxK2VLrDWSd6xwM9mHsgQu4t5dsIC
s3yFDrvnuJ/5EUX+ha6NaVQkv9DktazmQqv0LeP1TLM26vUyUw9sJ3cHlPHj
BLRTpwOGmekxVHA3MZhhnkHyG2rxBN/3OUMJvlP3R8Y1Nq0tZzjyjHnHPGBe
ME+Zt5bptQLLYeR9ai7Rt7/RtTBNruaimKz3sF52J3Y35nnz/v6Ee888uDvn
M9qsk/SYCtyD5sUB6g7CZ3I/wQFmPAj9SfeyeWKW9eq8n83OOEv+7Q3EwEu0
noRRZhyBkLmbQ69htcyj5lX75+zfs3/A/oX/lcWd/Q==
               "]], PolygonBox[CompressedData["
1:eJwtkU0ow3EYx7+YmZdSNpt5f5mNklFuTE5GzZSycXGQolaEuMjRVV42lLeD
O1FoG2VnuSlsRTlwcVxWTj6aw6fv7/97nuf7PM/v3zA5NzKbK6kG8mGgSfLC
Z6VUWiANco7VSpfENhqlLdgGe730YJJ2rNJTlfQMPrOEaL5Mmm6WZmCK81Kx
5OccJRiDA3PW24N3N/RAK/ctEKqQwkWYOCRTg1RZKBls0lW1dA0RCMMa/b/o
H6d/0im5S6QUGqiTgv/8nTN4b+I3g68b2sHP/TK1E8Rc0EfciUbLmQ/e7NIr
uOnxSN4xPYLEh8lro76fei+cMMc6e+yz2wZ7bkKKt0pC4D9/FH3HK2GkL34+
GIIQ9at429lzAc9F2OFdf9h3Dz1njgvo5E064JPdutjxAz3j+xS+8bjDI43e
WqQbOMQ7zd0RauP9rODgX0b4yWbO4+SMgZn4PXkW1MGMTZBg7hUD/5BZjOyW
Dx7iL+T1oi56ZvDJYeY8MMANNXF4t2Vn32X2Xyp4U7g=
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtk0FIVGEUhQ8pmtnGZtTJNzg64zjUomhVRCSBQUkRFiFCusgsI9IgatMq
aNVGSDIXadFGgiKoaGFjQYsWQVLbIgKDoqBV0brvcP/F4/3/feeee8699/We
njk+vUHSCZ4GnnJFOrZRWuuWXmTSLMGbHVKd+xDxubJ0tEe6QdL6VmkyH+c9
xBr7pO5mqUbeKvFZzg290h9w9+Gpw7Nc5Rvnl0Xpabv0g9x5OPu7It7aKZ1P
nK6zoxKYdb4vkT8P5h/8n/qlxUYwJWmkFGfHxsh500QONfeR+xZPd3PU6wgN
t6k7jIarrdLZLdIVnuucLxEbSL7sqZaL3INwrybveyvh05gJMNuy8Gvfd8qB
cZ9qqYcfOE+BnwbTQt2lnuiJe7M95X5D82Qh9I9Tayqd7cm9M/4RufeS96/4
OpcwZTgeoPsW+ufw8Zcc4HpCvI1aZ7isZeHZ3l/DMZj0NBMbTDo/onOXueC8
XIh880zAudIeGHvanWbxjNivLPSMVEOH9djHGJjhTdIp3idT/z/DP5rm8hP9
D4vh6xq5SjvjXo6n3J2F2D/XtUbvn/fwVRb9Mn6Z+eToT6lF6uR9oBS1PLeZ
fHi016lq1D1CfDQfPXmfhTd7fJ6FH/vyrlmf8d6jeWq1bZYWeOdTP82xP/Ww
qRge7OVxMf4N78AK2g/DNYSXQ5XAGe9daMXvAvGLeHyXBadnlXEfIN5XiRl4
Fhfw9DvpsQ/30R691/W0z13F2AnPwv/H9/7I9Tw9G8e/ZDF74xfB/weItoyd

               "]], PolygonBox[CompressedData["
1:eJwtkk1IlGEUhQ8lqVOb7HP0m5Fxxs9xInKr0CasIHFTtNGNJWWRSCoE7Sv3
okKaGKSl0M9KomLEyKkmUFq4s21pQqCLRDdB+VzuLA687/0999ybuT54ZeCQ
pFZQBp7XSc/AaJU0BjYS0k8Q1koJsJ+UHh2WhknqC6S1lHSpQuqISTn8NeTG
QWda6gIJEIJ18r6DjZB64By282CLd+GItEmNfv7zcWku7jEW+42c3nLp3lHp
cla6CadekMe+CCozUgV4R8/3YLJJOn5MKjJLWz0x2JbgW18pBcSN21zUGqHm
C3xdEVzBRWLbwRtq4tIIOW95r8JlxTgROw+Wmflj4D2t9ys4v0y7zXz91JhF
yGn0qGkEGe9tHJrQ8T+9/oHbxPWBH9i20PIs8VnsD6n1IO0ampa3qnx202AF
PnfQeJLYFP9T/HNJf5stRr8bge/GdvTbdtXg9TvQd4L3E2o+xXefmnfR8wsx
n5OuqWnbTO/T4Bp1esD0CdfSNJ1A28bIuVrNhWrXZK50M3Y7afhdiHm/pZTf
kN3SY3xToD3yW7GbyZP/us53YTuZgc+HpGtfwP8XffIpr2U1W8gdZxdjoEjc
V9s/+QPlfj8L2M9EHm/8WnkPZX1Wm3mXe/rETIXAd2a7OwlyoBvbVbBPzh7Y
httOtdvMF5Zu2TQxbXKl3F/EbII/5OxGfsPGxTgNBs7J/nbj26FzLpY0N+0P
AJBqh68=
               "]], PolygonBox[CompressedData["
1:eJwtkM0rw3Ecx995GpsL+5ntN22GzYX8B1YkDxFTGsUOUuYyB83dw11NzUOe
CydnsttPOVBy5ODi6UAciJLCa83h1fvz/Tx/voHRyf5EniQ3FMKzKT3BUkgq
K5XSaD3BLrvUWZuLZXPa/NIp+QP4ojAIF15pzCYZ1VLKJS1CBt8xfJNvFUtf
aCvxFrj1SPMMD2PbqqQEtc3Yu9TtwQ116XxpE7sBfyOskrcCU0FpxiEly6UD
3gvUbhA/I/ccjIDkL5GcqGVIJ/DOjm/Qww7rBdI4dwV5h7nNi33HXfew75R8
9FOd9EP8F4YhQl4MfaiQHiH23ydO7Qf+T5jAF4dKatfId6EmcQ9c+qRe/qAm
+1/sGoVuZllF0hC2yR1b3Jth/1nec3CE7xC2uTfFvTvoK7NfwE7vZWY40Gv+
6gr6iE+TF0E72KMdmty53UeY+weAlEo6
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtUk1IVGEUPVSgVrTwr/HNozfj+J4hBEGLwkUuTEjIRUKg4D+YuDFcCNGm
RZuWZhBkuxLd1KoWQasW4iIIBEUSDBR/EMEIQVQEPYfzwXwzZ77v3nPPPfcW
h551jl0A8IjnIk9tA7DC39EEaCkAq+VAK39TnpEy4G8e6CoBE7xvY8xn3h8R
L9YCd1Lg5SXgZg74xf+fSPglZmw1MM7cQcY+ZsxT4j/k+U+eF8ztSZyj3AfE
08zhB1OVwMPEtVRTmqTtjHiGXG/I85WBFQ3m6ef7MHMIMU/+7tSaV4mzwDnB
vIFq398iflWwtij2m2I6qlxDteaIt4kPadJODbBArin29Zb9LYQem5hUT/1t
l4F7jK3nuU8c8e4k5BbzzlHub+I54vfEp8SbEXCNGlLGzsbmlH8ndcaqcxi8
6kvsozTnGNse/Nnl+8fUnnzn/bfYWD5t11hDj+ZW6R7lsWagWUSMWcnox1Vg
ObNf8kczz8JcNNvnqfVI15Xg+T65lwPPk9RHeEkczJ2kDwes2xt2RvN8HfRr
L1Rb8X3Ed0v2sLnkHqS/oug9kOYZfl2Pnau5TWb27UOVvRPeiJyj3J/k/JH3
PmgvjhNj3b3L3Nde5B7UizzWLgprpwZTz+hf3nGKb8x5b+TPGu+3wuykZSf4
rJnfDnr0PhtmXUbtm3XGumsM3i7e4K6Sc117XvBOKEb1zwHCuYhm
               "]], PolygonBox[CompressedData["
1:eJwtkrtrk2EUxh9aQSlFMOklN5J8fqRKiil00kXUJoNrFzOYUrSJg9o0g5P+
Eb0Nlo6K8TI4NJuJILYICi0KQXAQpEVNOzhYxNHf8XT4fd97Oe9zznPeN7hR
n57vk1SAY7A2Jj2EyxnpCuRT0qN+iZ/G+PwOpcUB6Q+Hvg9Lh3HWoD0ideBr
Urp1XPp0Qlpn3oxKnzk7OSjtopuISRc5f5KYvYQ0MyTVjuLPZqV9tHpQYTwD
H9B7D6cYR+AO3IY65xagi+Y5tO9x/ir1Xg+9NptXGM8RcxP20TiAKc5+YW8N
T3vkaeFhAwrETkAjh27OPZm3IOl65vmQ/ZD5aajioxbzGqyWIrol2GIPeS2j
/856ESEu4h7Myxtil/D7l6AXxMfoaYP5N+Yv6dc8mnchT+w49EL38r/fjH9S
04+498B68SvpXszTpaOeWe8sxmKf4qUJr8jThvWo997uIEBvOJCG4C11bUI5
67VYTaPE11irwnnWL8DjlL8FexNPGDyHZ3CfHA9ynsNymaZpW8+t99fYK8PH
EfduPWil/M7t7u3NzJKnlHG/dqdnop7Tctsd2l3upKVtKFJ7CQJ6lYUOa6/T
/uZMz95Ul7yr9H4l4jVarf8ALkhzqQ==
               "]], PolygonBox[CompressedData["
1:eJwtkD0oBHAYh598dELK+chXx91xinxkIYOv7kYDCxZKuZscBiWU1egrsTIY
kIERC/NJKaUMzsSmDEbPxfD0//W+7//3foRnF8bTeUC1FMqN4lrqGmApAJtN
kJC4BIwd5sOJ+ckWmJDXekhZN6W+Dflf+qP+KYZIDYw0wrC0VkBHKTzHYN3a
NTnX71i/FXWXfzolWwdl+nWrL81vq4/M7wZhT+4r4U5OneenCM58Z/RfVZc0
w7w909L3P0NvzqcKriRpfE6m/+u/zLU7f5u8O1eP82V94+Y3CmBffSCHErRP
uWSs3XHmbW/w7f8te6T0jBiPyoXxN72nrP2ohU95Mp50jzH3SLpDSka9h+ux
rF40viRh/QZyd/PNeMcHSajj8hj6mylmryG9X+wx6DvnLZLyC9AtP7E=
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtUk0oRGEUPSG/G42hN80Y73kzL2VhZi0bf+V3IQtspiYRTYNSfmIhlIXS
YCMbNpTsrJSxMTYspJSFbEYMiahZWji3+xZf3333O/fcc899VnxqIFkAoIWn
kOfQBGp5r4SAXY/GZwFgJgxcFQN9VUCqBrgpBTzEVvL7mph7R2sEnzL1W/IO
3y+DwHIRYBlAzg9MlAAx8s2ZyvnjA/I2a5m3+P7pYka9wLOj+SPynFPHNuNV
1g7zLFQAQ7wd8naVAx3kOKa2J2rrIHfGq/hqC2gk5wE1JIkd4ds6h07wPeHG
79TwxvpN8nzwvguqfovxn6stRI4N4r/In2afvE/1izdxQ2tzxNp+xctMKdfP
furfcdSHDLkH3b6TXp1HdKYD6pf0jTD3SPwse7XWqUfSa5F1p6biZb5przsL
c82m+iYe97J3D/UsNQDj3GMZOR+YnyfvGn1bCuv8UitaxBfxJ8Zee27fdsb1
hmqWHQqXcHaTO8rTyrjWUI9E8z61/zLeYn7MUN3CI3y3ftUgWmT3ovOVuZOA
+iP/WjSse+y0dU6Z99unvouf8i9kHdUp+8xWK/+LrTsWTy4C+i35NvaPuDqb
eP8DmAlsQw==
               "]], PolygonBox[CompressedData["
1:eJwtkj9IlVEYxh8iTHNTu9zb1fzi9t2kBg0XdTJQQY2GoGhSvIGhgzaoIDim
qxaRgw0NGdFSiA5BTRFFDlKQQ4JB0B+SyqHJP9Dv4b3DD75z3nOe5/ne95wu
jV8ZOyKpGY5CKZGGIFsv5WAlJ92olvqPS5cK0v0a6R7ru8ekF9TPQhEmuTMF
11NpmvoI9Z289If7ryuk35XSHPXnGekZ/GJ/BwYbpYcYL6JfdUa6XCs1kOM2
GtNofUFjG5a48wA+wgdYxXMNNql9gqucvQabRdbQi24fvMqEtzP8K3vae4As
g9Caxv/14l/MSjfrpGFop9aRRA/cC2d29pk0sjnjU/bPw7lyD9yLKe5O1kUP
3csaeI9/FefX85HZ2R+xvwzv0HybCQ1rDZNhniwN9K/A+RJ+Q/CX713oLkTW
N+htnJJ+npB+wB77+zCK9ywD3cKzB/3HtaFlzV2f4d/3cuFp7+4kzvrOLe5e
ZN2ZRA/ci2/5mKVnOsrs29Fog1U816CLHk9UxvtoykZGZ7WGtb6fRAMWmMkd
6Cnnd8/9trY4+xlSzhaT0Ogv1z0bz9yz94w9675C1O35Ff+WNHphzQt8v6yP
t+k3+iQNTWv7DfktHcJBPnrq3v4HScJ1ZQ==
               "]], PolygonBox[CompressedData["
1:eJwtkbsvg2EUh5+IW1nELXUpqlixKRuJhMQiISEuSWOpgYXSwYYYJC6LwSQh
FhtGE/4A4pLoTGuQsBaJp6nhyTnv+c7v/Z3zfuHY4uhCAVAtRTLcDEPyHoHt
MogFYcDzUik8d8CjPMl8JSTLYaIdXhogJdP2TUmgDQ7Ulho/vWfH/CuS/5br
Sf/f/WZM10BGEi2wLCNVcF0MK+bffs9K2LtDJfBjftMEa4XQ6lw9nqOSdIZ1
Z1k1ZuvUSa/6qMy5WFxtn/mlPhfSqaZf/27juJoxedAj4P5x9zqx91jOG/W1
dmQ+KCnf4LTWOez9lU1rH9a2crPrk5ArNfv6nVm7s/deQsG8X5d+r/XuLXu+
4a4cuu+tHhXGWTUzknH+DX/KpPkflGhBsA==
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFUUsohGEUPR4hr2TQ/OY3M5oHZkaZjbw2k7LQbFhYKDFDaRAboYxSLMgK
WZkFCluPZikle2Ux2SmkxILSWKCc2/3L4nbv//33nnvuOfXxmf7pXABdjDzG
UhUwW8jsBloZE6w/HECbD5gsAY5DwDzfX4qAOeZ3D5Dh3JENaDB1NsgctwO7
+UCvCzht4n+C39QAyz6t5S0dAFYLgMVGYJ9YWWIeMo+yJ8ldU5XAGOsU+3NM
nZfZNS8QIo9AKdAcUq6yt5E9GXLdYU+KveNVyj/C/+lqIEr8dvJ9YGwUA0/M
Zabiy54ir94yRM5Rj3I7M4DPJt116yeOqRxuib9r7RXN6hx6b8yu84Ij2sQs
HfpcqoXUGeK8OZSbaByxdH7n2x45JNnjtGtIneX+BLVYoCYD5Gla79J7aagv
4s8v923zrgT/f3GmnJy3uOvV0BtPyPnH6vlmfq5VnDr2nxt6r3gyQj6P1GqU
+cqpugXZP8jvB9bDzJ2MO9YdbsUVfIParHvVxwO3ai2z18QIW7X4UGFTbpt+
1VH0vDB1RmZXvHpTvOTfA8k9HvVbvBBPxGPx+t6hmoq23dQ47NPZFuY/5GBv
kg==
               "]], PolygonBox[CompressedData["
1:eJwtkrtLlXEYx79dKMnuHsPT0TxxLlo6ZENDa2BQkRDV0qCcBuEcqyU0zYZK
rGjSqIbaovoDIqiWIBpqPAURdAM1NYzUxYZK+nx53uED7+997t/n2Vk6d+zs
Skn7YDWcSUl9cDwrnYADzdI9DDfXSZM5aTEjlddKH2ukB9ukdKN0fxU23iX8
L7VKw3AI38NwkX9D8CstzcO7orR7vdQG7/neWyCuVqrAS+zFurDZp4q9jRxH
yD1MD40N9LaV79ro4Se9tFL/PN8/8HlGP93UmqiJnubId5L8F/C/zfsD/g+x
L2F/xPspsQX+5eELtb7C6x1RbxP1b/G+kpcuwxhx43AQOuEfMcswS38zMFtP
D1ChvzJ8wvYZHrfHbCNrpCf0M07Ojcl87djGkrfnm94u9dBvN3wndtr5YSYT
/2wbgkH4Q66/sCLR3zOfoq/r+ZjNM97guz8b2lijFnz3JHpbY2u9SI6FdOzI
u3JN1/YMnqWa7Ms9bsa/wm2UU6GBtbiLzx14Tu4X8C0TWlepWcTe1BCzWdOO
XNyUb8s5nMs34luZQLtJ2FIX2tv/FbtY2hXxrv+b7/3ZuD3vv5f4heQefRMl
ZpvKxa36ZpsyoZG1esNtvIVrxI9CP7EDqdipd3uUul1wOhu3bE03JDN5tqvk
HinEDfuWncO5HOPYwWQ3vmlra41925252L3fHbz/A0ephz8=
               "]], 
              PolygonBox[{{9950, 9949, 5030, 214, 4907}, {7132, 7131, 8230, 
               2257, 8228}, {5603, 5602, 9187, 2699, 9186}, {8283, 2274, 8282,
                5228, 5229}, {5795, 2264, 8251, 7143, 7144}, {10363, 1668, 
               9036, 10364, 10365}, {8017, 1179, 6242, 9191, 9192}, {7166, 
               7165, 9570, 2940, 9571}, {5239, 5238, 8290, 2275, 8288}, {9347,
                2294, 8353, 9345, 9346}, {5609, 5608, 9211, 2707, 9213}, {
               5816, 2281, 8311, 6640, 6641}, {9604, 9603, 7357, 934, 9600}, {
               6249, 2707, 9212, 6948, 6949}, {5833, 5832, 7211, 1908, 
               8347}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtUk9I02EYfjCmoSmj2djY0Mm21n7uEIJ07iAdgqY7eI48LorwoBRCf2TZ
jnXYQfAgiy4TD1bEBP9QF2/i6CZpZSOFIRFqRbael+c7fLzf937P+3zP+7xf
3627uTstAIa4znAthYFvfuBVRrHSBbxsBQbjgM8HTKeUe+fy/yLA7TbgWgz4
TszEWWCkF9i/oL3l6n7hra52ESizbovx1OENu8C7Ra7mOeBKUtxr1LIaFn6A
uWyv8L9Z94jnQgf1poFqFOih9tJ54CZ1FNjQRDewR94j7hvEjyWl0/TOJYCr
7UCG+WoQOCDnZExny8/zfps4bpEnZ4HnH8S8D6p/82HRA746/utxaa84/XZn
mO2QerBelplb9+TDmqd+DWv1T53mQ2KLfOsjH34TEmfdzeCEdx/IUyL2oet9
mrGckD8rYfli/uToU38AuEz+T/T5S1zvmN5R1u8Ss8BeMpzxDfI/JyYRU7/W
d8PhoxHN1XzL0090CW+9jTvN95j/4/7AL8ZnTv8M40laNceMs8T/5LsbfHe8
W7XGMXVJPjxg3ExrjsMB+W566uT8TD1FHnbi+gfWr/0jz83L5nk/KX+yrH3M
c435J4xZ6m12SnM0Jd/s77yIaaY222hIPP3k++t8Nj7rNev6Nd8tf8T712HN
762nf1ZwM/wPMJmNRA==
               "]], PolygonBox[CompressedData["
1:eJwtks1LlGEUxU+SFZVSo7344jQzoU7jYLvK/oegqaBVLfqwRWm6cFEw5CLE
hUtbtSuaaJNEmWEFfdmmVVHboBYaFUWMOhgR2O9wXRx4nnvPvffcjz1nR44P
N0naDzaC8R5pYpuU4/00K93tkxZ3SHc2SYfwfe2UtuKrwjnNv9ErrbVINfy1
bqm/IB0EdXhLYKZD+khAfYt0HfsvbD87g2NuKzVawAC5zoNT2E6CS+3SMPjc
JU0Sf5n4Sh57RhrKRA7nOtoWWq05u1eaTdGI3vut0pOyNEaOqwY5x8DKut4K
nH30dpj8DQawth1OSbqI3gugh9xF0IS2DdnQZG3WaK222VctRew96s1Sb5F8
C2A3sTnQC6cE5hL0JKHJ2qbBI7Q+RM8D8A7fe/Ab2wR6ftBvlXofijFba7b2
QXoZ2ix9wX8C/7Ny7GaOfK94Py5Hbve0sCs0WZt3OJPGDs13zhf831JzmVxv
+P/jf6UQta1htD00W3sd3xK4xY5vghwzyoOX5ajtmXv2f9Ao/s3N0gHmcCwf
u/MOz8D/1BE+9+PbmU6iF/f0l3lV2kKL72VqfWfenWfoWT5PQ7t76KeXDPyd
4DVHMJ+LGMf65q51xw36Fm9Tp5bEzr37I6CP93wSfNdcTYNj7jdivoMB8p0r
xI36VqeKEeseV9HfSCPWM7wB7z9yA4zq
               "]], PolygonBox[CompressedData["
1:eJwtj08rw3Ecx18pTWhF0pb5zbKtcNlT2FNYcdTYLmSTk8MipRZ7BsvFeASs
XRx5AJR2k2xRuCHaRXmtObx6f76fP+/P55tY386Vh4AJGZabAK5laR6yo7Co
9mZgKwSFlDoJJYmZ+3awa/1ZXqQ+B18jcKLuTcG+3E3DrRwloa1fTT1LDrxj
ETg1bkig36ysmatZ6+j3GYUPqej3ru+VPnHrgfwseGzY29Sye0qybN+TfStq
KzLYd9zf5/v8n358aO7eWtOeN3e+St6/VcZgVU37TsljGjLj8KDu6F/1v3nn
C1KUXBx23ffrrRt6bUrTe6r6HOhzYXwpf3fFOiA=
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtUs9LVGEUPWiklLlwVEbfY0YZZ6b3lpH4BwRBu5iFK2vhIkJy3LQsBaEW
btu48neKEDI4/mgsJck/oE0Q4UbQhbkIBsJ2dQ7nW3x8933v3HvPPecOjk9V
qi0AHvK08mx1Ats8b24CL1Pg+w1gJwtsDgDX7cDzIeCsAMRtQC4CFvl9eQto
JsB9vj9gPFsGaszdYJ0PfcBBL3Es3mScix2/KAKN8J7w7WsOOGH/rgz/ld1X
/WPGjzqAxxnnCJ8hvp41ZpW8jomrsdcn3ochPuB9SX7zxK+xz36n3+eZ8zvw
z0eetRbm/ZuYf561q93AJDFjrP8xtS77vHf7jP3C+LQELLBeiXXWgz5V8v0X
ObfCt52Ab6TWRfXvsX89NZcn7LWVeMZ+/p+4ba7694zzvub3VBcwHLQVR9VS
TXGRB5rlomBvxEFccMechfvDnCvmnrJXWrDO0nv6rnEzvFeHjFkidi7U+dZr
faXzbtbzaK7W2H7L95983wg7oF24CNrG5PWj5Pg9vRsperYjcn5atC/y5xVr
XrHXzIC10NyfU2uked+W7Z/wzcgcVUe48x7z30vtpXqpp/yQLxNZ75x2Rru2
FmaUHts8x8ytJ8YJX8mTW+Agf5aJ/0X8Cu93QQftXRR2Ur6NBU1aqMloiLU7
/wHggYsa
               "]], PolygonBox[CompressedData["
1:eJwtkj1rk2EUhm9iUGk1gpXyhoYmkkjMi2MhP8DJyZAf0EHMUpoEPwYdTCcV
HEuhaYdqqSiCTUupUbQtBvMDsoiDAV016CBoPhz0OpwMFzyf59z3Oef8tWqx
EpF0CaJwEEp1Frsx6ZD1s4zU5vzbhPScdWda6p+UWqelvZx0+5x0y0ixhvdx
6TV/Fyal/AUpGUiX+fsdNvk/nJEGUD4rVaAwJV05JXWJ1yHeQ948gA/kacMr
/n+Mes5HnNfJsQq/yfMHmrBHvga8QW8xKW3wfpl8wzRaQr8T8WsX0cf+/nH3
12K9RKwesR8fk2YT0jr7NajhaQm65O+Zd97vhK7JtPXJO4CbvLkB1/lTgl94
qxPrEzHz7Kt4vEctyiekf9w1A/dqnmey0lc0foGr6C7A58BrZTWbS3sOy2We
zftK4LW3erxgn0u4dvNQG2swLTHOz8DLuGs3D1sZ75H1yjSb9gZetmGEtr9Q
yXpsq/li1s9G455Z757kPJbNyDxaNjI+GzYjIXrfhV5bmwGbhUjCvVsNSszD
XXLfSfnM2OwcxX1WLObTjM+EzcYPcv2Et+N41uPmuOfWe+uR9aoZem+tp/uc
/wfh2oBY
               "]], PolygonBox[CompressedData["
1:eJwtjz0vg2EUhq8oIT5K0pKmfRNEpTQ1Nn6AyUQMfoCETa0kaAi1YyaRSCcf
SU22/giRMCCxIGqtzfXkNVw5d+5zzn2eZ3xlY6nSAQxJl+xPwp40pqE5AKcZ
WByFBfmdgONeaFsTEax3w/IYXI3AtQzqJWXV/Z0+WLNmCzDfD1Ehzg35KWfO
E3Dvzqb7W3KZcsa8N7Nf5FXuvP3QCSf2a3k4kmoadgN6Xz2wbW3l4Ftm1Y96
ZWt1ys/4/vdhe2a1ZEZKcmHOp/94zsR+6Ee5+P6P+kn/w/5ZPp4PezXfP6dX
Vh+oD/8J+qYI9STcWv8A/F81aw==
               "]]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtks1LlGEUxQ+OlWgf0gwxNkJvzAzTvFQr/SuiELdBi7CiqDGkRR+WUKmt
3OSqNkFkRI2NYFNEUas2LftYZEH7yKhAKlH6He67eLjPc++5955z77P76Ohw
o0PSAU6OM7RL+oD9WpYGOJ0bpKWidGWP1Ob+NI2YMffy0t2KdHKj9KhPuliQ
pik2k0gjPdKNbmmK2J8M79o/uM/gX8b29ktnN3GS7HAv4LtPze9g5rDXatKl
zdTFPtkiPdwa/a5WeXdKO/Hn4LRG7GddWi1JtxEyv0Pav1dax7+KfzwJbhNw
vFyJ3JvoOlKMunfA/KuExkNoecz7Nf5WPXqbw1v0rlSC/0gxerhXDs4tOIyD
mQQ7DeY9mEUwA9WYxSD2XCE0XoDLwd7g7Pk2yZ1D1zy2RP5HuLXJbWyXSNVf
NL2h168uaTYJLutZ7udyzHmpHDM1twl2tVyKXNc4Tu9R+m6D54MktM9SfzGN
eS6g9yX3Be4vsO2+2NvzNGrb7/exJOqMoeNZGj5jT8P5BJwateBlbeZ2K5v5
Cpi1esS8E8/Is5qqBSfXdO3DcO4ir4PapzLO3cTH0qh/phaz8wzz/fHPXP98
Ifbqu3t6f97jN+YxXIp5vqN/oxq5/nc9WV/3Mc74IfJa+ejlnv731rGP+GS2
0+u21HqFlmY9YsZ8KsZ/sd/z/Z3ptW7v1nr9bweT2Iv34x0Y67/8pRzxJhz+
A7dtkm8=
               "]], PolygonBox[CompressedData["
1:eJwtks1LVGEUxh/USjSHKImZFL1hOc2tTWB/RhAG7WoRggrqSMyq8oOij1Wr
FkGLikDBGhtJLUKphe7aJZF97N24yECyT38P5y4OnHPveZ/nd97zHr1c7h2p
k3SaaCAGj0kDxFQiTRNPStJCizSTk2oFaZb6LfVHmtuK0jbf7iCw1Sg9oP9x
1j+4V3qKzv0k/rnnaqvU2S51EEPHpWEHGv37pRH0L6BVzfTfES/I/6BxG63F
PdIv8lop/i3gP0Y9x5lnufA0a7UQ3v42n0pv0jg/R71MfvKUdPaA9I/+H/SP
HpTKxP82hofrCozlfdIGzJUkZvbsd5ukr13SDXivwdsATw/1GWboaw4Ps/qM
z46iUUHrecZznTM1/L/j+bclGMwyn5fWmmL+ShoMZulF5zzxCM1GvDbpmSaf
pWcqF5rf8P/SFWxm6IHldylmM+NNWN8fCm+fqabhYS/f+VAx7ty1GW6hX5eG
nxnryXdgQVoP69Emv5gPP9/JS/4vHo55fWfNsL9KY1e+j9fkR4qxK+/Ub2cr
m98enu1cIfrvoblNPcnME0m8Eb+VVfRXiJ/07RTCcybb9yVYPpTiLVp/jfxz
PnZjD3u1tscuzGjWhBk6iU/d0joxcSK8zTBOvpTGW/GMnnUX8OaFmg==
               "]], 
              PolygonBox[{{8359, 8358, 10094, 3175, 5040}, {6291, 1205, 8361, 
               9320, 9321}, {7178, 1903, 9574, 4719, 4720}, {6649, 6648, 8344,
                2290, 5830}, {5067, 3195, 10114, 9010, 9011}, {8275, 8274, 
               7171, 923, 5804}, {9945, 9944, 5029, 213, 4904}, {9011, 9010, 
               10118, 3196, 5068}, {9348, 2772, 9351, 5828, 5829}, {6244, 
               2702, 9199, 6943, 6944}, {9581, 9580, 7187, 1904, 9582}, {5240,
                647, 8316, 8319, 8320}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtU89LVGEUPb5qimkcJCHmoQtlnjnvJVKU/0SrTKidAxGFi9HC8Ac1IliL
NrVo26ZCqGhMJSo30cY2tQhqUZS6iHaCRBFZWp7D+RYf3333x7nnnu++zrMj
p4YjACd4dvF0tAF3dgPnSsBGHji+F8jvARZbgQrtmwl9XcBz+j6XgcM9jn9P
WV8E+luAHL9/pPYrvnwQuEfwa6xdKTm+yfgFfr9ij6Fu4GoGXGb9NPMvHgAK
5JJvZx5zjuwH/vHe4jlKu4/9V9n7BmvvE6dO/zva87SbGPtI/kvs84v+Xuaf
jIGnxK/SbtDejM1HvIYCh9vMH2HtNHNG2X+syzllcniYWItHiWccL3q2W6Hv
Amv/BG7iKF7rPJUm4HfgrzkamX1vqeWLknmK7wznj4j5l/yHA4ca7/7YOv9k
7f/UmKusmypYq3rBtm7hRsEnfZU7FfzzxJnJAXdT95bvWNlaC+cKeV1nj5es
O83cB4kx9FazibHUfzsxH/F6Hd5UWkoP6SNNPjBvrRl4z/sScWuMjfJGu99U
bztWtI7qIU7ithB7v1QrXaSZ/Oo3GLumnhlLmJPSkrP0EvTTIeBJ6rpG6tk0
4xvGv5SNIw0mMs94JvbO6d3PJ/6W/1uFvJiTI37E+2vFM2oXtNdR4Cxuz5qN
+5g6rO0DBjqsnXBq3f5vcmFPVsKuzmXeV9nVkjGqYc4dwjaGTQ==
               "]], PolygonBox[CompressedData["
1:eJwlk99rzXEYx9/O4dB2rK2NzolytO+x8/3GosafQeZSOUIpmh9Lm5kj2oSb
7QJ3rpT8qMNOabiReynFBWG7kCtK8iPMlte75+Jdz/fzPJ/neb/fn+e78cDx
wWM5STvAcnC1JD1rk16CRiL9S6V8hzQC9pWlrvVSJzhRkU6Cv+QbRekU+bOZ
9Irv+dVSbaU0uE6q0+8Kvert0paqNM2dKXC6RxoDRXq1gyPkjlbjzLnz1FwA
h7h/A2L93P8Fn0t9MS/HvAniMWYOET9dwT3iy5ydI/+Fmbeo/wafNnIFavLk
62gY7QhN1tbIQluBmjvUX2fmNXAGDuPgB2ePyG1j/gLxeBZaPcOzcln0HkDv
XvQupMFtdyecN9OTXrfBTLfUAjNpePsGTQ/SqHGt+Szy3UwjZw9fp8HBXOyZ
vfuZhBf25CDePKdnbVl4Ym9edAeXr8y4S+0u9O4En3vxBLzrDT0TBek98dtN
9CtGvwr8P9XCy5t56SPx9mpo950B4v3MnIXbVs5+038PnOZX8Y7sjnjHpSRy
rl8kXsNZD5hdyxl4Ugp99mA6Cc3W7jf6TjyVxO645jG195LQ4jfz23knvBsb
6FkBk0lwNeeLxEN9EXsnhnmbVjm0ev8eZrGz3l1zMrc/aby9/fMuN8tR6539
gD/3s4jtcTMLDdbinfXutkqhxf/M4SR23Pftkb2aK8Uuuscc/f4DPIqFYQ==

               "]], 
              PolygonBox[{{7203, 930, 5830, 8340, 8341}, {4723, 2944, 9582, 
               7184, 7185}, {9196, 9195, 6480, 2862, 9461}, {9318, 2752, 9321,
                8359, 8360}, {9579, 9578, 7178, 12, 4722}, {5041, 5040, 10866,
                3693, 10865}, {9467, 2865, 9466, 6478, 6479}, {7200, 7199, 
               9581, 2944, 9583}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFU89LVGEUPVNO1sw4RZq9wVkYvmF8T0chgv6A/oDCVbXQMDLKakoa0iyi
KAhKc9umRRRMrRKimSCo1qKbkqKFLapFUNHCoN90DudBi8d93333O+fcc+/b
NlodOrEGwDCftXzqIfAlA5yPgWdp4DXfX7QA6RKwMwusYxzLAW/agEOMN0LX
PA6Ao2V/G2e8lDfOR2JMsuYp474CUGP+ySbgJc+5InCLpI1OoKvfmIsRMMS6
Jr+PEqdCvpvkHyF+N+snWoGL3eSNzTHDeLVsvGm+tzB3Je/zHvKk8tbwsB04
Qm0ny46vMu5vYjNwgX2Nl8y5kDHfVmI1qOd2ZDz1Lsxhaltm/B1Zt/Rvoa6R
JH+fvQ6y/iy5oxRwhjhVnmuMS6zfRczVPuBy3vqlbTuxB7Pmf8s+NzA+T+ag
HlSjd9XrWzOw/lnWPAg8nwXqATnSrEnF1ltLfJijX1/XE5P8xwrmnmNNf2yt
A4w7sp6jPJFntURbRzJ3zX+SdaeYn2J81+tePvQ6px414zq5PlPKGLX94lPh
3VXG/QVjXw+tXXw6yzNpkFfyvtlm/w+H7ms+sDe5jfZH+6W9E0e15H3QXsy3
Oyd+7Zm0TBNjKfJeab9+Ru7tB2Mltpfye3fBOqX3XOwa1WrG0qfZylftVivP
QezYyVhMdvI0tdwN7bf28U/ouf4N7aU8lJ+avXx7T99WeoyzEtgDcUmT/g/d
kY5q2T7Jv4E++3CHvX4P7dMB3j3IZ4befQutQ3q6ij4r/6nHdarX/7Sc7JO4
9C+pfqqDc4ztobzUHBrJLOqBZ3M8tqfydm/BOyqMWebvhZ7hIu9eS2an3ayF
viuMR+F///4BCd2sjA==
               "]], PolygonBox[CompressedData["
1:eJwtU0FvTGEUPcNUaadjtJN6L3mLyrzJeE+riUhs7PwAdMOKpAlSVTWlptUK
EVaMsSGxsaAS7CTCSCRYl24QItGdBVFpQoKFck7OLE7evd9373fvOfe+TcPj
Q8dXAdhJZIlaDCzx+7wNmKLdmwLttJ90ARtp/0mATB7YUwA+BcBWng3SX8eY
Ad0zp0n7Jh/7TXu0DJzrBG6tBnIRcI0xFxn/hTGjITBGXKKfJVb49iviUA74
yHoLtOt8430HMMKzRz3A68R3h+kfrfDb6lc5I/RvJ+61SczRnma9at58TtKe
59mbrONVa3/ou3HG1Hi/GJiv+vnH+xmevaX/jHzP9wMPA+d/YE+N2BzEZQc5
FsvOUa5y7vL+AfGOdpIB7tP+RQwydoD4QftUN/siNlCb7sgaKL+NAGvf6AOu
EzNFYJYYrljf3Hpqv4X1K9ZiqTW7l73A8lpgoh2IImsirur5CO9jnpUiv6m3
M+x5e6c1bpLbiYq1fiFNKu5RvdZ5/7VkDaWX6lVpnyW+d5jjAWpxJXau6l2m
nUnNRZo+pr83NP9txF/6+0JrrxlNMfZnq55iFFvn2YW8d+YY/c+bgV1dzlFu
jf2fLpuTuM31WBvlS+uDgXdRO3En8Qw1S+3wbOod0a7Mk8Mk49eUPUvtpHbz
W8nc1dNu+ldT77p6aqT+B/QvSIN7zJ8uWnvNoNHnmqot/ot8ayU2d81Q/8pY
6tryh0LvgHahytwJYjI1V3Fe4GwLjDlT8D/Xz7ungXdRM9Qs/wNJM5Cr
               "]], 
              PolygonBox[{{10468, 3395, 10467, 9590, 9591}, {7195, 1906, 9583,
                4723, 4724}, {5244, 5243, 8335, 2288, 8336}, {8306, 8305, 
               7189, 926, 5813}, {5043, 5042, 9358, 2775, 9357}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtVM9LVGEUvVaOg9ZjmHGmNziJ2jfNzBuToHVBbaJVNJva6iZ/ZIolUxBj
INgvLWvRHxD+BZXZJopaRTpQWRFBqyCYyo2FVlCdw/kWH/e9+90f55x73+se
GKuc2WJmQzhbcQa3mxUDszU874M93mx2DGfDma3Ct5Ayq0Zm47g7mTVbCs3e
bzN7jPsjvWYR/AXcvyrJz/uxguqOw9aQk4qhFuLTbWZHW9Tjww6zjzg9zXqn
n33PJc3gto6c2XJJcS9hF3B24f5uSfWYU8T5hvMVJ4dTzyAOpCaBZ08kbMTY
2C0u68DQAgwNn1v39dln3fMl70pCcexxqqx+5JHMCRsxssYhxJxoMmvP63kE
MaNZ4YnBdzAhjuxxsd3sLDje6UIt4HrXKu5XIr3PwA76Xuz51us1VFYOcx36
V1F3Gv7PRfHj7Kj1YfjibdLjQEI9e7w29BEna6c9rwpwDiN3FH0tUtxf6PDc
Scu1UPf9qP0Ccw3y8n8PpV3D1+yNNLcE6nXChoHmtDPScwZ2AxxiwPQT9o1T
/ibq/IYG2UB5VfjreB/BzvxplY91pjzfalKYiIFYqB95kuOM1/Aa7KRTHveF
O8qdvAz/PzzvRx1D7m3fY8lJC86amB46YWqKdMeYR05z5Xzn4V/Ejn2Jm010
KbbT796nonZvOaN5TATqTV0Zl/P68p07Qt6h5341Eo8foWYV93vFd/prwHDe
60OdZv0+5LEP8/6Z+5XOaw8yee0d928VGLpzimHeJeS/Rp0p2BX/vRD7ohOW
W9Bmzul/cB/f/gWnGMbeC1XvCXzPnHD+CvXf4DdDLTmXmue+6Xelv0N68I7+
vZFy+mCHC6q5Am1OZ7VXc/D3lbV7AwXNZzrQ3VOPnzxuRvLfgL3uVH/W68QY
1n2QEhdy+g+/q7c4
               "]], PolygonBox[CompressedData["
1:eJwtk7trVGEQxU+MNwlqJOSx7pKNGNl1d29iEOwEBe2shG1EO1PF+IjErKtN
UqTw/fwTJKCdIip2mmgj6opxVcTCJiD4qiKiFvo7jMVw5/vmzJzzzcwdHJ2o
Hl0haRu2EsukUnatlMOy+Pty0tbVUmOVdLIgHStJY2uk72Dv9kgLGWkey+el
AexWNrDO+Qv+Idak8CJ3j/Cvkr8+kf5wvoa/RI29LVIH+AXiR+Ach/spOTep
NUe8CdcBOEeG+PZL5SRynPsRTLVL2kLOZnIvUOMttSc570d7Z6+0u13qo/4b
YktlaRa/jZxl6v3KBvcurK8ofeOcT0LjPfBXqLmT2GfOh6m3WIn3v0Pfq0pw
mMt3E7ynBn6ulT5xV8evdwffcTQM0p8n1PyaBMdj/ClsIIn33oC7hZzf6P/C
nfAvpsE9S73L+NPgN3L+0Cm9hP9SGrF2OOaJnU5D2zR3Z/AL+eC2hjrvyxTj
rdZgLefSwLrmWfzbaNjeFT08T3y0FL33TKq52AnvhjXeJ94/LO0A/x49DfS0
gikTT7FNYE+k0Qv35BT4Q6XYD+/EeCk0W7tn6Fk+q0Qta7CWJvGetpj5a/yR
NGa9h/Mw/vVK9M87uy6NmXq25muwl6U0tHg+np13yr12To16zzOBdc5P5xaj
996vpBg77d2ewq9hDwqxu8737Iwx1jvSW4yZeDZ+3x24XlTCd4/cqx//9Xke
M+APDsVu+o1j+DOF+FfcI/9LkxukTx3sMevQjY5/Qd+Fdg==
               "]], 
              PolygonBox[{{7205, 1907, 8336, 5825, 5826}, {9340, 9339, 6488, 
               3696, 10870}, {9472, 2867, 6489, 9339, 9340}, {9589, 9588, 
               7195, 13, 4726}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFVE1LlFEYPY0zTjo57+TYNEOaBO/rx4zQKoiYCtu0aAzL+gG2KoTapBCY
E0IfVpuiNu1atTSCIFpUVCuzRLOloRG0ahlimzqnc6HFZZ65z3m+znPuu+/c
pdMXUwAmeFp4vheBQ1lgfA+wNAgstwMzMfCgCqRbgckKMJixvZ8BG7S3iDmx
DTiaA1I8P3j3sB+Y2wHcZdxLxp+kf52539NuI6aUAFP0LTF2OnbMn3bjUsyd
aXWdZfaw1gGs8Pd57Fo/y8DuPHA4Z+zxnPGy55jzGn23+bvAc52+q4l70SwJ
c0adwAhPnudZ2featY24g8Rn+dsImNGMcfqveZ8Qv0D8ZfYyz7OSBrYT/7EA
dOWM10zKI18vfRHtRWKvxPZp7rbQu2Y8XwPORsAF/vZ0A49Z523JNVTrRWxe
lecI8e8Ch+JygnUHOW9d/IV+5suuJ/yH2LmUM2HuL/yf58I7uoDNsvl4Gpvj
rx3OvxI47w99imv1Wug0d2Ps9Q1j0vS9js2X5p0d8pE9Tp30Vd1XC+3hrPtU
/qmK9SNN6W4t1O1JfC//Lfqa9N2senbZ0sjn2DyvxtbLctDMnapn0UyZivPt
TYxtDXt5FXS4UTRH4qrJu+Ga9SHNas/Ca9eFxJremVhTqqceVFOzq97vomdb
iP1utE/Fap9nInMdBa09Yr16znr9t/u8Y8XRfda+wR7u9dt/ILKm1YvyKqd4
j0KekbALzaW9pYI2hkrGdrPnZmL9/6oZ3wh9KGcjxE4HTULvkXez9E0m7r3Q
+b9mIeBX+1z/Uy91FWbWN+NUzT1v0Z4JdfX+NEM66FzzSq/a967Ed1vh/Yl/
7UbvWzzoe7IxABwj9tuA37p8+t6ot7HA7SbrZplzsWROhROmHjiWrd4VMxpi
9VZlrw+4T/Wrb5PqSyN/Af2gn1o=
               "]], PolygonBox[CompressedData["
1:eJwtks1LlGEUxU82o+nkO5OWzaCmxvs2OiO0KYiwwjYugqCoP6A2FUGtJG2h
EmhZtiho066/oAiiSKSonWFhH8siV61qldVsst/htrhw7nPPvc+5HwNnL5+8
1CRpH5bDqjXpc7t0sSSNDUs/y9JGmzSTSPPE1uvSbEFqIf4bPJVKq23BMfdm
Lbjf8tIc+A9vzfC3Yx/gXsXewT3KH2uD0plu6WBLcMxdIt4E/kL8Kf4L/Fwh
/niMv16O+BGslEnf8RvEDuEn+F1YK3iI/3eAt2XBtZ5Fap1D86midBo7D+4h
vnczfzRLveAFNM9vlTL4t8AX6sFNGNIn8mfSiFnTS/AzbJn/j21CL3gae58L
jrmNcmhxj6/wt2QRP0B+K/gNb8VC9OTePDNrnWaGN8DXa4Ed92yWsVFqHYaT
r8SOvKsR/D1wxyvRSx67h9/NH2PkjmDt4F/12J13+JX5P/rfjzU9BK90xW68
o0n8KeqtlGJmnt04Na6R+4CZ9fZwMFlwnb8B/2Mau3aOc/+iL+mIGQ9Tu9Ep
7S+GJmvblUUvnkFfFjty/8eZ5/M0enAvzjnB/2/7pPu5qOnavhHfim92dUj6
gb8ziRt4ncZOvJs5dnq3yr1VYvbW7FvcTQ8D2EK/dLs/bsi35BqutdYZWnwT
o/x/pxq1fHNPyJ9Ax5WOqOFa/wCaN3UH
               "]], 
              PolygonBox[{{8333, 8332, 7205, 929, 5824}, {9597, 2949, 9599, 
               4727, 4728}, {10463, 10462, 5836, 4103, 11254}, {10466, 3394, 
               5837, 10462, 10463}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNUr1PU3EUPbUWEOTZgjZtypfalzTv9R8goQluMOoGC+qoCU4khMTEwqSV
0VEgASaS8rEpjXGGhMVBBxNBB9xc1MSFcE7Ob3B4uffde+6959z7u/342YP5
KwCm+WX5RX30+XV1AZsRkKNfyAGVGHiXAf4NAsP0pxgfoj1InD8vAbtV4Hcv
sEc7VwHGu4GHtH9T4F4/8K3GGawbuQH8ZM0W+0/22d/pcc8s547G5jBC22Dt
F+YnaNfLwNc8sFEH6tdd84mcc2XzPuLcO0P0GVscYN+SuYljhvkG/bv8BmLP
HaSdKVijeLdTY3bFNzXPM+pthj2I5zXWjNPvoV1m3yXmmonz2pcw0qr455xj
WyHeon0ZWeMTanhLLU9pl6rGPqKOfGyOf0rmpFnSr7pXkW+gnDDHrHvPD8Qc
Vr1v6VRuL7XfYbw/3K4S7tYKHDbGrPdq2Ku4al9vEs9aKPsdCNPJ+H7S9r3m
eZpbYM+zmvlLx1re2oVbobYP/H/BfrMF7/pW5Ltpvm4nrDCq1w6FEQfh5GsH
H4vAL9asjpmr+OhWurFu/Tw2F+mX9ou6Z5yMusfsfz3VT/uMwhuXLvWTr9of
eeOEOQ169X73E8dv0rbLxm1zTivx+3hNWy96rubrfWXDm7mfep/aq26uHanv
JSRHc48=
               "]], PolygonBox[CompressedData["
1:eJwtkjtPlGEQhc8KC8h11xUCAUHk+5Ts8gc20UQ6KaG0AS0tpILCwrBrxa3T
UtlErSBcSgjwA5BYmUgBCWghHY3RYOVzMltMMvPOnJlzZt7h57NTL29IGsMa
sa9D0noLcbv07b50XpDKzSTapL1E2sZ+t0pZ4r+90upd6Yr6TkruDUjP+qTv
WekgJ1VpWib+gP8ee0G8UJQO8V8BqOK/TiM33sGsUekzNT+JT+jxqCStUFOh
9pL43QPpx2jUesYF/sNS1HpeBWyBfo/h9glMjdkzdT6e+Yb8GfY0L3WT36H3
TH/oawDzBz35NLSOgMnhb1DzkdpT8Gv0GuRtgnwnliVeQ/9+Bq7U1/DneFui
fhF7C3aA+idt9Z32SMfsr6kpegyRu10MLta82RcYY5exeeIvSXAxxlhrsjZz
MrdKMXbpHXvXv6whGxqt9YL7DXaFvkPwW6XgmiHexr8mv5sJzpOluNlBff/N
8KuNhXb3vKT3fhJY72y6PziaqzXeSeNP+G/4ZstwO0piV97Rv0Ls2Fx8o1tp
3MzzfCPfyhwb6v3998zBXMq83cRvScP3H9xK4k/4b1jjOPz/A1VmZ4E=
               "]], 
              PolygonBox[{{11371, 4253, 9598, 10954, 10955}, {10955, 10954, 
               9597, 14, 4729}}]}]}, 
           {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
            GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFUT1LQ0EQXJUnYpFItHhHGoWkufcULAX9Cxb5AwZLFW1ikc7oj7DMNQED
4keS0n/gb7DWXrRKojPMivDu7d3e7tzM7NbxRet80cx2sZawBviNqmb4zJbN
5plZI1OcYe3g/nPV7BJ3P5lqGNOCcncVsw7ioefZ+7VidrYm7IPCLAB8UJr1
sHLs9wvFLnq3gXMf1Z+CMIg7RRxWhM/zdy7sdl18hp7fQ88t8j1gnJTaMzd3
ruT5VgrnPf/XQCy+SSzmjurS+tLQeeoan8B1Aq6PhXwaV1XHOPH9zP1ifTtI
G7X++ciaWlNn6niO4kNeN+4J+/gmvaQnxOd79JD+sYb5h6CajSj9HfeqH6SH
XnZr0AH816j74L3Ja9abwiZvzv06ahZXUXMb+7u8H7lGYhHzFHzTpmbcR/zI
5WFC/hdODVrT
               "]], 
              PolygonBox[{{6375, 3752, 3753, 10930}, {9404, 814, 4020, 
               11184}, {7008, 1316, 814, 7007}, {10880, 3705, 3864, 11395}, {
               11068, 3864, 3865, 11069}, {11183, 4020, 4019, 11182}, {10881, 
               1431, 3705, 10882}, {11371, 3772, 1431, 11370}, {11424, 2803, 
               1614, 6559}, {10930, 3753, 2803, 6376}, {11182, 4019, 4204, 
               6404}, {11429, 3865, 1652, 6574}, {10772, 1652, 3752, 10929}, {
               9491, 1614, 1316, 9490}, {6404, 4204, 2293, 8352}}]}]}}, {{}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4729, 10955, 11371, 11370, 6457, 10881, 10882, 10880, 
             11395, 6496, 11393, 11068, 11069, 11429, 6574, 10772, 10929, 
             11485, 6375, 10930, 6376, 11424, 6559, 10924, 6560, 9491, 9490, 
             6390, 7008, 7007, 9404, 11184, 11183, 11182, 6404, 8352, 8351}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{5114, 9418, 6405, 9502, 9503, 9420, 9419, 6389, 9488, 
             9489, 9403, 9402, 5088, 9406, 5089, 11073, 10133, 10892, 10891, 
             6391, 9392, 9391, 9480, 9481, 9479, 11394, 6497, 9338, 10465, 
             10466, 10463, 11254, 10464, 9598, 10954, 9597, 4728, 7202, 8333, 
             5824}], LineBox[{9485, 9499, 5113, 11089, 10901, 6517, 10900, 
             6518, 9501, 9500, 5676, 11518, 8142, 9940}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4726, 9589, 7197, 5826, 7205, 8332, 7201, 4727, 9599, 
             11253, 11255, 5836, 10462, 5837, 9337, 10870, 9340, 9472, 9471, 
             6319, 9343, 9344, 9408, 9407, 6322, 10703, 9342, 6388, 10889, 
             10890, 10886, 10888, 10887, 9405, 6327, 10705, 10706, 10791, 
             11335, 10790, 6403}], 
            LineBox[{5133, 9429, 11113, 11112, 11111, 6526, 9428, 9427, 6392, 
             7009, 5092, 9410, 6393, 9493, 9494, 9412, 9411, 6382, 9486, 6381,
              9397, 10129, 10130, 9399, 9400, 9332, 6311}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{5043, 9357, 5044, 10096, 10095, 6490, 9356, 9355, 6320, 
             10699, 10700, 10702, 11291, 10701, 10090, 10091, 9335, 9336, 
             6489, 9339, 6488, 10871, 10869, 5838, 11252, 10468, 9591, 7204, 
             8342, 5244, 8336, 5825, 7196, 9588, 7195, 4724, 7186, 8306, 
             5813}], LineBox[{6416, 10796, 10798, 10797, 6367, 9409, 10894, 
             10895, 10893, 6508, 10896, 6507, 9492, 9477, 9478, 6509, 10750, 
             10752, 10753, 9398, 10776, 10774, 10775, 10658, 10660, 9333, 
             6312, 10861, 6482, 10082, 11054, 5028, 9463, 9459, 9194}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4722, 9579, 7180, 5815, 7189, 8305, 7185, 4723, 9583, 
             7200, 8321, 5241, 8335, 5243, 8341, 7203, 9590, 10467, 10469, 
             6487, 10872, 10873, 10867, 10865, 5041, 8360, 9318, 10089, 9319, 
             6321, 9359, 6329, 9473, 6328, 9358, 5042}], 
            LineBox[{5069, 9385, 9386, 6495, 10748, 6494, 10877, 9384, 6365, 
             10745, 10746, 10876, 11392, 10875, 10120, 9381, 10751, 6366, 
             9182, 10659, 6239, 9517, 6240, 9464, 9465, 9470, 9469, 6481, 
             9460, 9467, 6479, 9196, 9461, 6243}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4904, 9945, 6944, 6244, 9462, 6480, 9195, 6478, 9466, 
             9468, 9525, 9524, 9179, 9180, 6576, 10657, 6577, 10932, 6573, 
             9181, 10926, 10925, 5068, 9011, 5067, 10119, 10115, 10747, 11310,
              10749, 10739, 11307, 10737, 10755, 10754, 7003}], 
            LineBox[{5804, 8275, 7168, 4720, 7178, 9578, 7179, 5814, 7188, 
             8304, 7184, 9582, 9581, 7199, 8320, 5240, 8334, 5242, 8340, 5830,
              6649, 5829, 9348, 9349, 6486, 10093, 10866, 5040, 8359, 9321, 
             6291, 9341, 10672, 10671, 10669, 10708, 10707, 6994}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{6326, 10011, 10670, 10010, 9602, 6292, 8361, 9320, 8358, 
             10094, 10092, 10868, 6324, 9351, 5828, 6648, 8344, 6646, 8346, 
             5247, 8316, 8319, 7198, 9580, 7187, 8313, 5236, 8308, 5234, 8293,
              7183, 9574, 4719, 7167, 8274, 7171, 5806, 7163, 7161, 4718, 
             7150, 8245}], 
            LineBox[{9208, 8016, 9184, 5029, 9944, 6943, 9199, 9198, 10367, 
             10366, 10935, 10936, 6582, 10938, 10941, 10940, 6237, 10931, 
             6238, 10656, 9379, 6572, 10928, 10117, 10118, 9010, 10114, 9012, 
             6363, 9005, 6362, 10738, 9375, 9383, 9382}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4882, 7875, 9002, 9374, 9004, 9378, 9377, 6175, 10744, 
             9013, 10116, 10927, 6364, 10741, 9380, 6590, 9527, 6592, 10939, 
             10945, 10944, 6581, 10937, 6580, 10934, 5604, 9197, 6940, 9189, 
             6942, 9185, 9183, 8015, 9209, 8018, 6250, 6950, 9948}], 
            LineBox[{9566, 7145, 5796, 7154, 8247, 7149, 4717, 7160, 7162, 
             5805, 8278, 5230, 8284, 7170, 9573, 7182, 8292, 5233, 8307, 5235,
              8312, 5818, 6642, 5817, 7209, 8318, 5246, 8345, 6645, 8343, 
             6647, 5827, 9350, 8339, 6323, 8355, 6325, 9354, 5840, 10674, 
             10675, 9601, 10012, 4944, 10704}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4759, 7354, 9604, 9600, 10673, 5839, 9352, 9353, 8354, 
             9347, 9346, 8338, 4943, 9594, 6652, 5833, 8347, 5245, 8317, 7208,
              5816, 6641, 8315, 6639, 8327, 5239, 8288, 8291, 7181, 9572, 
             7169, 8283, 5229, 8277, 5227, 8263, 7166, 9571, 4716, 7148, 8246,
              7153, 5795, 7144, 9568, 7142, 4715, 7132, 8228}], 
            LineBox[{4907, 9950, 6949, 6249, 9213, 5609, 9192, 8017, 6241, 
             6941, 9188, 9186, 5603, 9035, 10365, 10363, 10933, 6579, 11431, 
             9528, 6591, 9522, 9939, 9938, 10740, 11309, 11308, 9874, 10743, 
             10742, 6174, 9376, 6172, 9003, 7874, 4881}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4713, 9558, 7126, 5788, 7135, 8230, 7131, 4714, 7141, 
             9567, 7143, 8251, 8250, 5223, 8257, 7152, 9570, 7165, 8262, 5226,
              8276, 5228, 8282, 8287, 6635, 5808, 7193, 8290, 5238, 8326, 
             6638, 8314, 6640, 8311, 8310, 7207, 7211, 5832, 6651, 9593, 4942,
              8337, 9345, 8353, 8357, 7349, 5842, 7357, 9603, 7353, 4758}], 
            LineBox[{9224, 8029, 9200, 5030, 9949, 6948, 9212, 9211, 5608, 
             9191, 6242, 8010, 9942, 8003, 9187, 5602, 9034, 10364, 9036, 
             6578, 9030, 9521, 9520, 4902, 9937, 4880, 9873, 6886, 6173, 9009,
              5557, 9017, 7876, 9875}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{5777, 8210, 7115, 4711, 7124, 9557, 7125, 5787, 7134, 
             8229, 7130, 9561, 9560, 7147, 5220, 8249, 5222, 8256, 7151, 9569,
              7164, 5799, 8261, 5232, 8300, 6632, 8286, 6634, 5807, 7192, 
             8289, 5237, 8328, 5821, 6644, 9585, 4941, 8309, 7206, 7210, 5831,
              6650, 9592, 9596, 7338, 4756, 7347, 8356, 7348, 5841, 8364, 
             5316, 8469, 7356, 9640}], 
            LineBox[{6177, 7870, 6178, 9016, 5556, 9007, 9008, 6885, 9872, 
             5019, 8993, 7887, 9029, 6182, 9523, 6184, 8004, 9881, 8002, 9943,
              9941, 8009, 9193, 9190, 5607, 9210, 6945, 9204, 6947, 6246, 
             9201, 8028, 9225, 8031, 6254, 6955, 9954}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{8185, 7099, 4709, 7109, 7111, 5779, 7118, 8209, 7114, 
             4710, 9553, 7129, 8218, 5214, 8232, 5216, 8237, 7133, 9559, 7146,
              5219, 8248, 5221, 8255, 8259, 6628, 5798, 7175, 8260, 5231, 
             8299, 6631, 8285, 6633, 8281, 8280, 7191, 8323, 7194, 5820, 6643,
              9584, 4725, 7322, 4754, 7332, 7334, 5835, 7341, 9595, 7337, 
             4755, 9634, 7352, 8457, 5313, 8363, 5315, 8468, 7355, 9639}], 
            LineBox[{9238, 8041, 9215, 5031, 9955, 6954, 6253, 9227, 5614, 
             9206, 8030, 6245, 6946, 6247, 9203, 5606, 9052, 9053, 8008, 9048,
              8005, 4903, 8001, 9880, 9878, 6891, 6183, 7889, 9028, 7886, 
             8994, 6170, 6884, 8997, 6882, 9006, 5555, 9015, 9018, 7869, 
             6176}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{5899, 6694, 8471, 8467, 5314, 8362, 5312, 8456, 7351, 
             9633, 7340, 8451, 5309, 8350, 5834, 7333, 7331, 4753, 7321, 9587,
              7325, 5823, 7317, 5819, 8322, 7190, 8279, 4940, 9576, 6637, 
             5810, 7177, 8296, 7174, 8254, 5797, 6627, 8258, 6626, 8269, 5225,
              7158, 5790, 6623, 5791, 8236, 5215, 8231, 5213, 8217, 7128, 
             9552, 7117, 5209, 8212, 5778, 7110, 7108, 4708, 7098, 8187, 7102,
              5770, 7094, 7092, 4707, 7087, 8180}], 
            LineBox[{9014, 7866, 8851, 7868, 8855, 8854, 5554, 8996, 6171, 
             6883, 6169, 7888, 8999, 5562, 9032, 9033, 6890, 9879, 5020, 9020,
              7899, 9045, 9047, 8007, 6191, 9054, 5605, 9202, 8013, 9946, 
             8023, 6248, 9205, 5613, 9226, 6951, 9220, 6953, 9216, 9214, 8040,
              9239, 8043, 6259, 6961, 9958}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4705, 9544, 7082, 5766, 7090, 8182, 7086, 4706, 7091, 
             7093, 5769, 7101, 8186, 7097, 9550, 9549, 7113, 8200, 5207, 8211,
              5208, 7116, 9551, 7127, 5782, 8216, 5218, 8241, 6620, 8239, 
             6622, 5789, 7157, 5224, 8268, 8270, 6630, 4939, 8253, 7173, 8295,
              7176, 5809, 6636, 9575, 4721, 7304, 4750, 7314, 8325, 7316, 
             5822, 7324, 9586, 7320, 4752, 9627, 7336, 5306, 8349, 5308, 8450,
              7339, 9632, 7350, 5892, 8455, 5318, 8473, 6692, 8470, 6693, 
             5898}], 
            LineBox[{4863, 7765, 8848, 8850, 7867, 6114, 8856, 5553, 8995, 
             7873, 9870, 7881, 9001, 8998, 5561, 9031, 6887, 9024, 6889, 9021,
              9019, 7898, 9046, 6188, 8006, 6190, 8014, 9886, 8012, 4906, 
             9947, 8022, 9207, 5610, 9069, 5612, 9217, 9219, 6952, 6251, 8042,
              9222, 5619, 9241, 6258, 6960, 9959, 4910}]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVjz9LAmEAh3+HmbuF2inoDQ0ZSB+gwS08nQ7HSHQQbMiP0HIiJA0iLZ0g
tOgRDUJEUkOL0CeQQFwEv4FyU+Bzw4/nfX/P+9dqtJ07Q5JDbuJS8VTy0tJ9
QnqBI1Kjn8ArnA87uCncZaU3WKa3ySdj51j6p69CIyd901VwvzDG/IBc43Jw
cSL9kSfOW+OTdHXcBVzSF+AKnsM82bKmBAPos2eDs4+ky/DcjNSEt8Rl/I7v
wRZ3d+Ejf+hDFz+APfhAPrgvgB7dM2vHcEY3pPsK/2BJUWKZUiQp/eAPmc9x
KWiSM9wrexu8Jc58D8MmMfg=
             "]], 
            LineBox[{6263, 9251, 8052, 9228, 9229, 6959, 9234, 6956, 9240, 
             5618, 9221, 6252, 8036, 9952, 8026, 9218, 5611, 9068, 9070, 8021,
              9064, 8019, 4905, 8011, 4886, 9885, 6895, 6189, 9051, 5567, 
             9026, 7900, 6179, 6888, 6180, 9023, 5560, 8876, 5558, 9000, 7880,
              9871, 4879, 7872, 9818, 9816, 6841, 6113, 7767, 8849, 7764, 
             4862}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4912, 9964, 6966, 6264, 8054, 9250, 8051, 9230, 6256, 
             6958, 9233, 9231, 5617, 9087, 5615, 9223, 8035, 9951, 9953, 8025,
              9892, 8027, 6197, 8020, 6195, 9063, 7909, 9037, 5021, 9884, 
             6894, 9050, 9049, 5566, 9025, 6181, 7894, 9876, 7884, 9022, 5559,
              8877, 6121, 7879, 8873, 7877, 4878, 7871, 4861, 9817, 6840, 
             6112, 8853, 5512, 8860, 7766, 9819}], LineBox[CompressedData["
1:eJwNjzFLQmEYRp8y3BxSUcwLXgdJf0WQi4IE6hJcG2xzyc0hyCEnxSUIRQfB
TdShS0mj0BohKNYQDoKTqxAOKp3h4Xzvcz7e+93wbTFzdyTpmixC0lNQyrml
r3NpQj7JN5mRG/oW/iIitWHZJ3Vhh8TpLsmQc8orbdl1BX+j0gtdEvcO03Q7
XBbKlBxkGpDq7JrincwWLgTn9D/kGedjXuJXpMu8pLfYmfRIMdyGPgF7uJIh
DeADvCd13v0IC/gKfMUVOdt8ZwVrdA12NeGa+Y2+CkfwDx64b5xJe2hzZ0zv
CvNGuhNowmM//8N5jP8gLuYofZ+9ed54ivsHrBc5+A==
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwNzr8rxHEcx/E3JQsGP/MrLunEX2FCslCGk8JoOEWSMus4yXBkUQYLwo0m
xYQkpyxXpG6QklWieAyvnt/v6/n6fr6fxMzcaLosIqblrDairz3ipDviUJIt
EVVNEZdtERfy1xkxVRdxwHVxlVxNgquPyPO/jRGt+m+7ZvzBc+4N32XHZtu3
a1jynufSeIqruhyXdYdlzyty5LxFHLZZwHVuFiftUvLaHLFvU2r1LA12g+43
xhW5XS6hSzm/Ags2WV2BK/f+gNU4zl9xGe6pJ+JZijKi/+rwfzzm+527j5+6
Id0HDuCe7ro34kYek86QW7mXO5lw7y2bF/scLvnPJm5IistgkZvX/wP2y0OH

             "]], 
            LineBox[{6115, 7759, 8862, 8859, 5511, 8852, 6837, 8844, 6839, 
             8840, 8839, 7777, 8872, 6118, 7878, 6120, 7885, 9823, 7883, 4884,
              9877, 7893, 9027, 5563, 8892, 5565, 9039, 9041, 6893, 6186, 
             9038, 7908, 9062, 7911, 6196, 6900, 9889, 9891, 8024, 4908, 8032,
              9082, 8034, 9088, 9086, 5616, 9232, 6257, 6957, 6255, 8053, 
             9236, 5622, 9253, 9254, 6965, 9963, 5032, 9242, 8062, 9263, 
             6268}]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4914, 9968, 6971, 6269, 8064, 9262, 8061, 9243, 6261, 
             6964, 9245, 6962, 9252, 5621, 9235, 9237, 8047, 9956, 9957, 8038,
              9898, 8039, 6201, 8033, 9081, 9079, 7920, 9055, 5022, 9890, 
             6899, 9067, 9066, 5570, 9043, 7910, 6185, 6892, 6187, 9040, 5564,
              8891, 8893, 7892, 8888, 7890, 4883, 7882, 4866, 9822, 6845, 
             6119, 8875, 5517, 8846, 7778, 6110, 6838, 8843, 8841, 5510, 8742,
              5508, 8861, 7758, 8858, 8857}], LineBox[CompressedData["
1:eJwVj08og2Ecx78uLmoHbN5tr2xqjZEbF4cVhZzm1Q7iJInDKNy4CI2JgxkX
StzkT7k4L9vkoKy9DisHHKSkEJELnx0+fZ7n931+v+d5/MOT1kSZpDnYbZCS
sAkbsAUp6G+SLDBD0ochtTVL77gVt1PPV0kZ1tlG6QLncBrcrA2IVkoLXmkR
pl1SAhfrpDgeIFvFa/BA7R7C1byDfY778kHgDR3Urlh3Yhtfku1wpov9Cz09
+BW/wbVbmueeIuci1F24wIw7sCFOlqY3SubwSevsbXq6+ccf/TdkJvUC3i7N
IbMC0hhvHTSlZTyCR2GfPIaHyMfxCtkU7qV/BvfhCBxy1y2epZbk7BI+phaj
doof8RM4PdI3M/fIn9mfk/1ig/oP9uAv/Fnq40yFXzrD5TVSPdkBs1O8wVvL
fBzAQXCQt+Aj8hA+IfsHFDNUIQ==
             "]]}, 
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{4848, 7701, 8737, 8739, 7757, 6068, 8743, 5509, 8842, 
             7762, 9814, 7772, 6111, 8845, 5516, 8874, 6842, 8869, 6844, 8864,
              8863, 7788, 8887, 6125, 7891, 6127, 7897, 9829, 7896, 9883, 
             9882, 7904, 9044, 9042, 5569, 9065, 6896, 9058, 6898, 6193, 9056,
              7919, 9080, 7922, 6200, 6905, 9895, 9897, 8037, 4909, 8044, 
             9100, 8046, 9105, 9104, 5620, 9244, 6262, 6963, 6260, 8063, 9247,
              5626, 9265, 9266, 6970, 9967, 5033, 9255, 8074, 9272, 6272}], 
            LineBox[CompressedData["
1:eJwVjr1LglEYxY9DQ0IQvmr5vloJ2SdOtYjoVkOLEEHgYFCIS9RYNDUVDSFY
UxBBYCRIS/9A0IdIbyUkVCBKQ4FLUkJLEP0aDr97zzn3uU9wcXV2xSFpDX0Y
kt0v3aF2r5SypDpeaExqwP1haQ9Z3E3kQ6VR6Z2uwTlDlkZF7lf40ZC0xYyI
W6oxMwpvRqQdvDhZFsbwGmRxmON+zZwKMyr07tEUfpO85JPKaMMr5enN4H/i
3+K1oA03yZ55myDzwCfed40zg91fOF/wzjkgXcJduo+8mSb75f0DnkXWh+b9
0gF5Cs6xZxJuu6QlmEaTdCZQnn+WueforMMy3ileAhZgFX4xp9tkV5ilc47f
wjfw3qAbfpO9cj4iP0bqYQ/8Q+YusF+b7AzfGZQ6yLwBqfO/A0/omLDIfoNw
CAXo+dEPf4W523T+ADA8TQs=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwNzb8uw2EYxfHjFtAQkkpLREyNiF8M4ga6YDCYNN3E340wGJtKXIIQg5FI
LBaGDtyASSwGFtJBQhh8hpPveZ/nnOetNDYXN3qS1Gm6L/kaT+aHk8PB5Ggk
KcaSFk7gntms3SRfYA1/SkkZK7Qr96b/Ttv8Je7gnN46tkfdot9ysoUn/ruQ
+R5KDrz3qeNeE7syNb2u3RSumt3ZPVSTR3qx7+Azltx5wqZbDbrX+Rjwp9mN
zBqe4qvZrd05f0Zt9wps4TGuyC3r//UmC/wMv4TXenW8wqpcP/8p8w9zIjNR

             "]], LineBox[CompressedData["
1:eJwVzj1IFWAUxvHTpuAXt6vXe+2iIuLXBUWXcJNsFRJ1EHSQBkHQyS8cpUbR
qQQxRSUQK2iXoPBqOQgOKuUQWCC4uIku+nN4+J/zPOe876kdmegdfxIRc/Tl
aURHS8RNLuJTZUQGP+OvpoiU+h/9p2maoVmaolY7bZRoNu+N0YaI1/TD3nfq
rI94UxXxPBnxp1qPe412K+Q4ifvmu/hleMD7STP8d/aO1N2yS7v5tJxmZRf6
TflHmtcf8V/664Ubju2ceus3JelEX+TGbtmZ+pudwhoe9TyLWLTfh6/obSKi
H7OyAVyW1anX3DD0OOuPUdzlbfDacRPHeEuyabyyc8Df4Z9jScYNWIrXsgUz
X2XXvFt9iv/e7rD7/vJW5et0L8vKVmQfqDgbse2+JBbVRpRjQcoMbsnTmMc9
alIPmrn1TxXeYY53KHsAU4ZPxw==
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkLtLQmEYxp+zxTEyLLyUUUah1pRjNFjUlghdEKEgSmrqMri1RLnWaSoh
sCHIrD+gxcEosgu5OBRES+AiNUaKCP0aHn7v9zzv937vOb7lzZkNQ1ISjbqk
aJcUQQmf1OyUYjCOAj3S3aDkhXOcf8na4Q904xXIcg6plTpDbYcG80zYgrJk
BrTgMbmTN2pO6dArffVJ+7AMFzskB9kH9Tu6Yn4R7pBX6beRmaiElyXLwwr+
GrnF3AV4it+Pn4HXMI53QDYLT/73xrO4E+Fso56GKfZq+qW2YX5EQPJQN1Ad
7ZFN0bMEJ5lT8ki73D/vls7QZ680wd5P+Nv4abwK3hF8YdY4mcncZ2o788Ls
cA+T9N7gFVEBmXhjZLdwnewyyPejVc45eIEeUIhZI2gFf543t4boc0tvvPlI
/gq/B6Q/lmBJcA==
             "]], LineBox[CompressedData["
1:eJwVjc9rAXAYxh//AhlRNj9rWu3AIrTT/gCctFZqkoPCUotcnexkBw47UMpB
jdoNFy1/xw6Wi5WTZZHl4/D0ed/v8zzv1/lYTBYMkhKobpXuPFL7XArAgUna
+KRbuxRlj6CDWbqCL2Sq5MN4NXjJ2x/em1vawgv2CpkV/WvulJhHzO/o3ybF
6BwcUoP8Dhbh06mLV4a/sAbn3MrALPoh16HfRQvmPPyGG4v0Becu6RM9Mw/h
K/9myMy4NWEfoyb3+nBJJ0fuAT8Ne7w18MJwinfPW5A5BfdGKQ7X8IZ8i3sf
ZLz4eTp+eIYfwjsCB004ig==
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVzT8rBXAYxfFjMSuJ3Fz5k9LNRG7CQt6AMhhIBslAKVFkEOulREabDSmS
xaDkDShGm4hFKXWVj+H0Pb/nec75tc0ujS/WJJmgcn3y05WMFJKdpuSoNRnt
TA6xDzfNhu2GaMC72pCUsIe23XzIftI6f4Ub/3mZVTzq0EO1/BYe++vUzW9z
sutdoQd9K1gtJv1y33ZlXDa7s3tqT57pzf4RX7FRzwsu6Jqne5mvxmTN7M7N
Cp7hu9mt3QV/Tnv6xrCCJzjnbkq+Rt80P8jP4I3cJF5jr7si34wFOtDXgvvY
iQu6urFEde4uZf4A9zw3Kg==
             "]], LineBox[CompressedData["
1:eJwVj88rg3Ecx9/aGs/BI9vaFhM7yM/LDqQcULJkSVN6iijujPuyyZGLoubo
sJOjSA6rx4+krZUc/AHKQanZ0sLweg6vXt/v+/3d8/kssrqRWG+QtAXLEWkF
ZtukOKxx/vFLFo52SMNBaZp8gfs8fNK14CoO0ue7JRPPkJXJ6l3SLxhkjZDz
MgRneefC3wHehKV33rzBHudHvOSTWplToc+QPZNt4zu8SNdMV+JchBxzrnCS
/oX3TXQesMlO6M7wOVj0+8xN4GNnb7IsdvdJc2RP/dJfj3REFsJfUIMddp6k
n+K3MbzLjAk8Dmm6ETwKKfIh/NrJHnDYLhV6ece+xoD0wNnke/dwCzfcx+g8
dNecDScDGy64u8ld4BuUDkKSH5+y6yVdmTyPN5lZ4ZzEH853+A8WO/0DWytJ
SA==
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkM8rg3Ecx9/oQY3LJisRz0GGg8dGau2EkAutbDXtsP0Bzzhju+28xNFB
+RfUTBTZaTcOymWJOJj2A008yWuHd69P79f3eT7f5zGTqbDdJmmLRN3S9YR0
Q8590iW5IHa/lIcFEhqVjEkpwllrUNqB5THpkfSSV9KNf4Z7uDdYIR5SJy5c
FaZxAZ5/GZZm4C47gnCOZHBZ9iww5/qkD87swz/2L9Hdcj+HdxzQeeFhy8E7
+jV8mXd1jEtH9FP0BnMneaJP4E9HpGPcFTQGpC5SYD4jKXwJbsN3zvfgYh6p
SJemu4cPpM78hW/CT3LCnX9bz+Ac+INrMFfYM29K7UP8U77JBat0Dq4GV3HT
XmmRPRY08d/0m/TLdBtwBc7iwswWPgH9MES3jrO5X5zuH5VsS4Q=
             "]], LineBox[CompressedData["
1:eJwVjTFLgmEUhY9E0CJBYopFH5aIq4MO4mKoczQGLUaDiyKIgYuIiJOIKAgt
TQrVUKEOLd8mX3P4GwRFHRxErMHH4fC89557zutNZW8zNkl3qOaWbnzSiyFF
4btD2vil2JmUZE4g26kUgiVum9yt8Gvwzym9XklvqMLcg2UYpKMIh9z10QFd
12SP2HW4OYTlfQb9e6Qq3MI6tOjMwwJaX0hd8j204J2DS7hxSVM4vpR+UYm3
CVv8m+ZmRNcPs4Xa9A3gEzczcibeHH6xa+DFYRI94sfgAxQ993B1IkXoeybz
TSaMnyFjQAP/g10b7xOes0vjTb38g47xJ9AOA3g7cx89Ng==
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkDssg2EUhp92cYmpBBGijYhLSxODkAZRk9vAxNZ0Fe3eQWIQERKxGWxm
g4lBIjGJBaNBSYRKibo0BonwdHjznPO+3/m+8/+RdHY+EwCW1FkIVtpgVY02
QU4mZCoCces5uVwP550w3QJDZh36YTVZOWM/oT9jnZSz8qsBQuZRszG9mBzX
f9H/CENRJuz/WuHIe79lQe/OrNwI7/Y31iW5737P8kWVzB7lq7wwz1gfy0X3
q/Gdgn5a71QvJWt7YMGsOQrV1v1dsOc7QetgN+Q9H3QuoA6d2TWbcu5W/8cc
z/3KHf3PdtiWSfM1dx6WW/ZF/U05aH/d6+6+UXZmo/IPrNflm7w0u1IP1lXu
8yTr1L3Kq5zfGfeOEe8ekFl36JMn3hWTB+73D+LrRas=
             "]], LineBox[CompressedData["
1:eJwNjUErA3AYxn8cuFFbWMMY4jI5MIW07WL3fYJZLpThCyhL7CJrDuJE8gls
J8VIKzn6CpMddllLDiv5HZ5+7/95n/f5R3N7mXwPkFWNALTG4SsKZyMwEIFz
GZRjsxCQS3JRhZ0npyCidocgLi/DsCCv5LyMqTlzSflkz5ZzTe7IhB3bclNm
1YFz1dyDurCvLl/teZFvsu3ds/OhuU95JH/13t3lvd9XLb1QEDqyYeZHNuW3
qtt5PA1rIeh6syr7J+BU78PdtUzp9Y5Cxa5be8p6g2bu5L0qOKfNFOWjmRPZ
kW1Vcl6egT+7KmYZhnXfCZW0s+DdjZmU7z53GVnU23DX9X7F//4BK7U9jw==

             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVj88rw3Ecxl+LkpyGLKKZ0pgoUUptFxEODg4c1W5KlBMHNZGUcnFw9wco
Do6Si5KUkh/RyjBRliyLg/Ha4en1eT/P+/l8P99Icm58NgBMq8s66GqEVC1c
hWFZdjufxSAThRXnKrkqn+W5/rtccw7KdZlvg4L6UNfel7C/qb/bDL/1UFQ3
+gX3t/Rj8tvdP/Wj7s1G7Gyb7dt5cC5vgI1WmKiBQLtyr0x12q1wDnXApFml
5ym7h/ay9m49v8q0vFM71fBY+h/zJ5kzu/Cc8Vtvznt+Iy97I/6fXrp0j/zS
OzArymgI+s1z+oMy7tsGZELGzIJN8Gk2ptfjPKR/bHfG9w3rhc1bVJ/ZqNmJ
2ama1zvyfQsy6d6ijLuTkkvqxZ2s+gekIEpJ
             "]], LineBox[CompressedData["
1:eJwVzjsoxQEcxfHfTYzqkuf1yCOZlOyXkke65TGZDTLIYzEreQwe5VGUTBZd
i4SyUBaxM8tiUdKNK8P1MZy+//85v3P+/6aJ2bGZRERMUn1bxHs9NUWMV0S8
4WZVxGptREr2WhaRbJBjFebkNZjHb5rW6WiOuNLZ17nEdnknb17Wize8I1na
Xs7OlLyoPGIGM/I5HMFh2ta5xU+dO50PXJTv85/4z3TPn7W1a+PR+5r8BV8p
5/lX5wcX3OTxFLOUaHTbErFCD/YOsGBrDxOpiO7qiB3Ppe6OMYn9vBLZtX6d
7y3zunADz9xs4QWe/2/ZTLf6L96X+0Nc0u/hFVdGjGKvrQz24SAO0Im7LK27
HeIXdP8AFEVEuA==
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVjL8rxAEYxj/EYFPCHY7OiUnJICdJ3yznZGDAYDEwKKeOyaqTlMRdhmOx
kAwGi4VBkqL7G1xKSpcf6cogH8PT532f93mf6FxqYqkCWFQ7jfAagVIU3tRU
PbzI9SZ4lhlZlE/q3dyX3PUn1ApZGZHRTmiRcdmvYs697dCjlu0LZN6eQXko
B2RcdZtLyht7Us63ckUGdqTlgpxXa845e2bM7stHWVB3dn378+C8YaYoN+XP
v+ct7e+qKuuF6+BXlszQBp/yQ93bl43BcEi/GYZkrfeC/rH+iarWv7TnyI4D
97D3czlqdtt5TObktZk92Weu7Jx3DjqgsgGuzFfJhHtSjdiZ8e/UzLh7jbdp
uaWX8EYXnNkzqXdhZlb+AdRgRE0=
             "]], LineBox[CompressedData["
1:eJwVjj1LgmEYhU+Ie2QaRYpKvn5ONikICRVCW+QfECIiMoLGIBAEEfoPNTvo
H1AMXByCoA8lVHQwfYsKEnGoocvhcD33Ofd5nseTOdvPLkg6RvchqeOXcsuS
C74FpBF6dEgmcx7fC9/xPtAz/oS5iG/AL7wp+kYvZIl16Zqs7JZembUmFXzS
gU2azXfpzFAQ/TLbw1Ka7I9ziu4e6tOz0CvSyy9JT3g30GAngKJ0I3CVbgje
krXYqfNmG47pNzj3+EeXucw9Ixj0cDfeA9kAmngVsh/oXZE2yU38BIzxfhwZ
+FYnM94n2TbcRUmyKt0T/r7FvMiODUXZ3yG7IyvxryO8GjyF2fk95BewSX4O
B7CPLjkXuGfDLh1CH7zCG5L9A3rgSA8=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkDFLQmEUht8gXMNMo/SWX3C5ljUY3mi4lH8hG1qcDAwbSnDUwYZwCfoF
1erkHtjk6FIEQmoIEXGVGpKWpnocHt5z3vec77vfNfnz7NmMpCJU56W+I72C
BX5CmktKByFpRO3jjcHAJ32QLEv2RT3B+wEbvulDZIdkE2ovJu3DS0T6W5Lq
tnTBXR28GzTKjAWb07PRCLur6C3ZIzNP8MZuF71i9xm9I7OZcSDFXm9BWluX
kvT9DXpmBnjtOO9BB/RNdj/QlUUpYaR3fBd1l6UdMPi/5Nt4PpmH7oFHds/u
Ke/ZpZ+1pABsMZ8ha5E1+J4cXgvNo8eQJi+ibfIC+jD9v9Ql6hrnxMPsoAYt
4w3JKmgd7xIc/Gu0wB0ncMR5/ynpQs4=
             "]], LineBox[CompressedData["
1:eJwVjjtIQnEYxY/cO0RtRSWKphZFS1tTEQRBYfhAosCgoTm6EC4JQUMNPaBI
EhSTkPbIaPOxFCSKNLdGlyAaWu7Q+9dw+P2/c8733RtctRLrLkkWmuyRjBEp
6pWO3NLNgLQyJF3DBbiHN0c2i5aYO/qkCIyhCzofw1IRhpkNsvqgFGcnj5dD
49w/gX5Yo9vJnXlyD94lXTc8gzN4Jtk57yJq90pfIakFu+hcsVtGBu80NKHY
+fVLP/3SG91j3o/wlG+l6DQ9ks38jArceYAO3R16a+RbsI2XJUvCBlkabxOZ
3NiATrc0TbfErVvyKL0U/Sk4Rl7BK5BV4QSe9f/fQekbhcg/YQC+c8cLbRjg
3j47GXYc8mV2tkfp+KQDvF2yQ/hEtkh2DxvohfwO2vAV/gGRzkmx
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwNjr9LAmEchz+BISmhXZeB3skdaZ4K0g+IwH8iREgIGoxAl1wDiQYhUDAa
I137C1wkwbUQXIQkbYhoamiXJp/hw/N+P8/73n3dcq1wtSKpQtqudL0p/Sal
alR6YL4nu1vSHWzYUnFbusCVSYtuB3cDb0kNP+dtBdaZ47gTaMFLuiluYEhn
nIecz2GO75XgKXnBFeEz7OPz/MPD/1vSguzzrSr79XDHuATuiO7HlFLwjzs2
3SHugOTovnDf9DF6O80u0IUz+r2U9AHTHntnpHfuTZl7Dmc4YZ7RO/gJc5b7
Fuco6bLjCN9klzH8jEhv8JV0cCZ3zKwUgR7vDLhBnnDr0MCFYAIXhAHyiPPD
MG4NOrhV6CNBdl4CUkw5ug==
             "]], LineBox[CompressedData["
1:eJwVj08og3EYx79ozavt5M80+fMOr9hRymFymT/REuVgrRRnHORglNYuuO2k
tbTepB3Iapcd5CAKK4WrcFQctotkWnx2+PR5fs/zfZ6311xam1utkbQB9ZZk
wGu7dG1KUY/0Tr2FP/EH/A5IZfCSi/VLOxBulr7I73qlPShRF+GbfBkfsG92
SElsYYvdXjyCA+CnHvXxhnVuhXCaO1PYxpN4AgbJDcEtd47pB9kdh216jkZp
hTpO/Ug2yZ1lnMLP+AUK7PywmyDzVv0GsxL+o/fAbJN9J3dqO/k/bOAGqGuV
KuTuyae7JTe9PNkmPMbMpvfELIedbdIZNvApPoEucj6YIeumf8nuFRzSG+Y7
Nr4hd4QL+K56p0XK8K6Qy+J9dud7JBf9RTzNnQgO4TBegHNyF5AgO0vf0Sf9
Aw+JSbU=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkL9LAmEcxp+WaIgI7Th/n3aoaZAOQtDgKk1WQkQggpQ41RAUSDSIi/TP
pCBRa0MpRg13XdAStjhEf0OfGx6e9/k87/v9Hpdqnh+cLUhqobeANIhLT/g8
LbUj0pEp9WBd1EtJV0Hph+6U7pbcR+uGdINfcmef+w26a3IHxemqeBQ/oXd5
W8dD5ArcxC/wY5hD98DuGudHzod4jnl7eBXd0+3iI7oh2maPTf8Xk35Rhjlt
vq8Et+Az2CbsG0/mpAgshtsoispZ6WtN2tqQwnQhmIl24B7chhvwIvMK/i5m
OfAgdwyUoP/MS1Pmv8PvkvxDfEz24Ab9KznLvKn/jvwBX8En/nz4GF8mu/Al
/IVswZ/xRfIq+/8B7+s5bw==
             "]], LineBox[CompressedData["
1:eJwVjk8og3EYx78mEit/lr9r08vQRs3BzVlZOTDlTw5Dc0XvLg6ztMPKYeSi
5SCN5MJRDlPeN20HLZNyWuKGlMRR8nH49nme7/N9nt/PWFwJL1dISqJ4q1T2
SOvwxpDCzVIeFlCiQ9p0SRb1M5lVv2Si9l5pg3yMepb8BzMv3jfcwf8kH8FP
Mc/Q+5j1oJcmaq/0Bf0wgCq7JAcyyYegTf6Ady04xHwNfxp/Bh3hj3Bnmz9N
0A8zj8AFlKQushOl3mOnDFN4Jvk0fKJ/RPv//4VFbr3DW/gGX9EuuQxytEn3
+HF2E8jZKbl584LaRZ3tlkrcqYJ38BSG2KlxS6PQIPOAn8O/RE58m91DbpzT
9zO/hnmUpZ5k5wQWyBzDX/iDzqinfFJtC++RrYNz9Fvkx7iZhjkyDfhR/CU0
jl/dx594a54+OCANovqA1IiuqG1koRIZD14Q/QFablOG
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVj0Erw3EYxz/utJnN7N9spi3855/koCmRkFIOqx0WF8IOCq1MjrwLL0FR
ityFk4y1k4OUo1fh4/Dt+/w+3+d5en6FnaPqYQ/QUJcJeMpCJYRnPcjAZxHC
AMoqlob4OLwmYWYMeiegT/XLX+xvy0cKMGlvpBLyIfs78ln7Y/bGVVL+bn/S
umtWdCYtm3ZmbwAG5aPOFVXFuYzvbBn2zQLrSD6l5s1yvnNmDbO89bd7Q/dF
anHYe9y7rC+pB/+3oq+qknxdvy/Bmt7RP1TVeu7/xhQsuCOl12Rds7relB2r
QN7SN715S22478A8Lz+XX6ht+ZdzLW87831ifqpq9u6a/Zg9etOV7E2/1m9U
3fxO/zW/1dtmfyULNGU=
             "]], LineBox[CompressedData["
1:eJwVj00ow3Ecxp9RU0Zmsnlp1kxexmHn5eBoSjLJRfJyk5cchMOSaQdsxQEX
clgOCsXFYnOg7bDkMHHgIuykHCwXrHwcnj7f3/N9vs9/c45O+6cMkiLIZ5US
rVIXvIQWmGyQyv/fDlgtedxStkLaapKO2WWrpA28NxjGW0Mr6JW3GX8d9tRK
Y2RHUBldDy6pFMboNJAtQCfM6UbpFA5wcwQPkZdv7UMnTLE30+Vn34aXpMcN
z2A3nondOXMM3VdKxfAO2snEuU0gK3MQ2mARNxZYSM6A9uqkXD3/jW8FyGRq
pB/e3yhKzzb7X5t0i5+H7/i7+BNwEoXZj8NVaKQjBH30dKIDbm64accbJuOF
fpjCi7LrZ+5Dc/QZ4Sz0kOng9svC/2V2MzejCPkd7vJ2fg8KtkibvF3sQszL
aIj7jFMahJ8wR87BPkvXB3MJswkt0bXI7QveDHfP8Ir8PF6A3QK85t1LzwWM
oycyjyjN/AeE51pI
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkc8rwwEYxp/NWDamMBsza8Y0Dmou4iR3SWuXoexkl60o5MLihOygHFkO
UhycaFw4oTCL/AjJX0DyoznIZ4enz/t9nud9+25fbzQxEDdISqHRWmmuVYrB
efjmlCqapXeYaZKseK/MDjwn2sHbRtkqqZzsEna1SWXMCy2SBZYiE/OBR4rS
tdVIdz4pwp19vD3Uzd4u9MEzv1TtksLkHXhBdET/GFXg29Ap871dOoR99PyF
DnsemMG7IbNCK1k9ngu5uW2HFpike1snlZCnGyQj3TX42SgZ8HJkP8xfaINb
4zANV+hMsjuFlplTKOeQFmEWxuj1MEfgINrizjDchFE4zY0wPKHbSa+XO0EY
wpsgM8N1sna8YmYTMjL/efk/ee8A/SVuGfCFRtjJk62y8+vGIv+G8wFpiOya
bI7sAy8Jr3h+4hs8onPmCzTLvRmUZQ6xE2c3gczcyvPtXiqlZ/aNPBuQ0Fjh
t9Lpp/9AVoT3D9xBVMk=
             "]], LineBox[CompressedData["
1:eJwVjz1OAlEUhY8bIGGIwDCMBBPiDwSJfwRnHCAWmgkWUlAaA1TGaEgkVCzC
HVgIMbFQQGs7K4KtBXRsQNyAH8XJ9+4999z3XrJ+V71dkdRCXUtytqW4KR1B
G7rQgiVYRh6aoSl6M6RhRhqhAcptSgcb0j6MpaVdOGBmz5bWklICfcWlUETK
xqRGSApsSRHmTHRINkhtkW3iGZwnzK+TC5PJsycKHVhAI3Z75IrIJXsCbbJl
+I53Cs9QCa8CE3g+/FjmyGfYW4Q5uIMCq+ygnqTIwiB1nr4Bfepv+hfQ5w0F
3hamX2G3w9lF5/Sv8FtkTLw27KBL/vpDts2f7qmvmblB1eU83hTvkzc90hvD
HuyjGv4LnOM/wwX8Ra+cn9hzzB0P0INDen94/zT/On0=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVkM9KAlEYxc+ghWKLyEoNWgyMVLYSnRBFx1wpUUJtiogoyIWBbvQtfAJR
JEzCoB7CbQ8gbfq7LfAJyt9dHM49v/N99w5jXzePG5akmlFEam9ILTS2JW9N
GuI38OdNaRaXHvEcvAPP4g/kH/gvGnB+w+/wE3b6eA+9rEhd/JVuii64v0p/
BbtEhR3eDEvOrpTnfLBFvy0doQy5wuwZO6eowbth3j1krwx36dOozM4yPMk5
hfbpvxPcxR1LcI8+hFfIX/ASHiTn4AG8SP6EZ9lbJMd5ZwHPkD/ge/R+k5n3
GSe76J3OZcaC2ewIT5v/AE/R/6+S2fnDk+Q83DPi22vM3zpSHZVgUWZGzN6j
83XpiflJTJoDYIY2nw==
             "]], LineBox[CompressedData["
1:eJwVkU8ow3EYhz8yo2VkS4Zszcz/rF2QclFzFW6iJENWlpqDZEq42EHKxYoc
Zkqu5OAiJ/NnarPkYEkpd2wXPA5Pz+/9fN/3/a7vnBPBobkCSRHor5bWW6VZ
HGuRDiEOJw1SmHwFyuDVJu2TW9qlEuosdREuBiP0WqVzh3TbKN2ArVYaoaeH
rBsSLnKwkt/hCnyPnyulSzxIr4e+K2abcYbc8t8Pbupy7MIO7rHjDfrW4KlG
MjEbt/Pb4adeMlCnyVNgYC7Grhx5HqL0LDG3g7+oDzgL4VSVtE02z3cQfHz7
8Rb3HbMnyXmAepn+Ps6uqePkCTxGvkheis3QxXknfFskL/7AHu7sgD36I7zj
JP2FnO1Sb7Inin+d0jh5CqchX8cb8rY5/M6OT5zFZvZ4+b9GOVtl7oHeoybe
FYepfeQmel7oH2ZfgPsWyI1kITxLneSN3rAfpuDXLc3gaRhg5pRdZ5BhR65N
esQX1H+3SlqA
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0btL1WEcx/FPUGmLlhfMpNQ8JXbXgjqLNIQ2NURNpdQJKhqqoaBQqKCo
tobIDAwiu0m0dYMugzSWXUmTGmoK+gOUIHs5vHk/3+/zeb7n9zynuXRs59E5
Se6hszopa03K8X5lcrMtGeOGhmTv4mRrYzJ3lRx/aEk+os7eZ67lL/yjNina
3yVfpbeb3+p/06/nCR7ldTJvzG7ym63WbaiULXAFV8g8XJbM5wGZC7LjS5IF
6nLcN2dmeTJP9rbcGftDPKx/Sv80bqgHUe78VZ6uSnbIPTLnU13SpXdcbhsf
5Hd6I/YOWx9Cv1k13MedMt3OTplRtO6wbscV+VvOlc1+Ky56syH1WnuXrS/h
gPOTzUlp9puXuq+93+b8ta62rsIinHduj/fdUJ/0rknWc4+6FyN4gMf+myf4
U0ie8zM8RYfsNWcGcHZ1cg7d8k36XdzM27mR7/BdDGNQ/jpGvftG9SZ0oB09
5g5539e+/RVeeMc+vX78W+EtZL67x7h7TPCUXsl992Ha7+/nk7IvzT/Bv9Q/
UVCPmbtZZguKmFG3mBffV+Ajegtrkq/uWcn/ASPCZSk=
             "]], LineBox[CompressedData["
1:eJwNj81KQlEUhVdOhCAEpaJQQvFWWjoQ9FYYlXRrUEneUiH8QSkskASDiJok
vUENCgpn0RNYjapBkxr2AhXkqJfwG3ysc9bea+9z/NWGfdgnqQkdj/Q7JRWH
pB+0hL6NSa/gnZZ88I1fwD9Fz6A1KXm433E+59wNS3/w7pYWQpIB4xCExWEp
Myo12FPzS/uQ8EmOQekyKNnUtmCJvhdmPI1IJjNnYQ4O6N+mnoUUPUk8J9nU
hBRifhiW8S38fnwLP4IXBQt/nl0D+HXm5JiRhxX8Dfpj9LiorZJJcA7wnyPe
aXJeJ5eGNXp3yHwZ0jP/u8L7QAvki5AmW0ENsmX0k9o1PTewSfaEvXF23HL/
Z0YbNblf4M+gbbRKX5MdFXSPGUn8PHMzvMOGXfws2iH7QP8jWsM7JtPivfd4
PVvDPWo=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV01tsznccx/Gvm9FMpE6lZKV16snZJENTslLHzaFGb0SWTTpLio6YkHDh
kLGtrXNtiSqpOq/WLTI2BG1lsYvRjuHCBZYYu5glMtV6PRfv5/M9/76/////
pH+4Yn5pp4go9HO7R8T1tyJ+RUmfiCZalx5RiwZ2UVbEpp4RWTkRC9gfDItY
lhnxEd7nz8WqfhEH1a+k1fSd3hGH9S41b7b8LCzQN158BnsmquSfZasxZ6z4
HPkxdAn/qfhu+VH8FebNNqeSX4Fm+y5SM8g+xXSmvoW0CE1yX6jZgUI92+in
+pdjUmKec8vcJV3vSHaB3mn6CpCbuIfcQLkc9hS5PPEfciMm0mFiK+XPOuMv
+90YEpEp9q/8f3iOd515jB5HHU7iBM6lRuyxw2406n+s/xFeyP3cNyKN/kJb
zTtPdw2OGGePz+xwgd8iPtGMT/TsNGMXOvMz+dnIQg4uD4j40Y5l+lbhJ72V
ZlWgWy/vSOyovotmX8Jl1PGPuN9h1KCQPx3rzLlm1wa7TeC/gd/YL8VvmNeW
eBb6R6RE1NPhdLP8FhTwp+KRmka1j+lX4mvN+JJ+Tv8Rf4ZJ7DzM0d+s5z16
PfEO7FtOs2kFvYe7aDermC5GExpR1D9itLljkM+fjBZ15zynUu/kf34bXiLV
/A4aal8lnrF8O+1rhxrP5xCqsUhdreex0OzTdCn/mHg9u0PvWfqxWAu7FbcS
59t1j1lj6d/0KZ6gRN1V869gpO/mG7EDqMIZsVq9652zAVX8J/wDdC+2qNmK
dDNLvOMM+r09GpA8NGKNb2M1Hvq+77jv1sR92NtopzT3xCt9bchVv0Ptdizz
33ozI+Jr/9lyJLG7oKv6ZNodeewj5kym+egwox2zzNlnxl5sNKdM7UkzTuF3
9aX86epnoJVfLz5Pz3x8K5bk3Wxi1yT2G+T+ZmzUc5R25if5bv/Q04WeUnNC
PFm8O+6K79fflf2dXArtoW64b78nHU1HIUNNszPeZt/Tn6buPr1Ji9WleNaL
ab78A/E/xVPF+uEO+zZeA0jzz/Q=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV01toz3EYx/EHuZlTzcZsOR9mB0OJEDcOYQ4zNpON2ihh/4Wc5hRuRCaL
zZYLhNouMIniYmJKSOawocSlU9yQIuX1v3j/P8/z+T7P8/3+vr/ff2RlTXGi
R0QM8PN7bMTjoRGL0iNaR0YspI/kP3MjfmHr+IjcvIhttCw7ooYm0J0a0aHu
h/7v2J4ZUTU44hLvIpbmRBwcGJGtd4m4WG+VvkoskFeordGTwDn7TrFvg75y
/jzrc1GkZzJ/jngNv976N2cqM2Mif6H1Aloq/8o/Zn2CvNq8fHpU/oW/wnqe
fL76XFos/8xfTnOS8/njaZG8ll+bH7EXjebsow10y5iINtz2TCuyItozIk7L
0wZF3B8eUeI5V+IhOpCubwH+qV8lL8ViteV6X/A69ZTKq4a4E6S4w9S0iEPi
On116nPkJ+gD3Eeh+k96Z1j/Y//p9C9NOEc1zojfJM9LZ5tzS/zce3qid5ne
x7SIPqUTzD5F82k9vYs7+GH+E301+hNoch/NaMBZNKIruRd+q212d03oobbC
s3XxXni2bvrQnPX8z85zQ32mvTp5w3idvLHi1/bswlqsQy81X2hPWkHL8Qov
kensBe4pi3bYo92+2erueT+J5Jmxyfm2YDMK7LOa9uaX0QHjInb5lnaixPt+
p++w7+8IusVdmKNut/U9yFN/1HdXK96gvvewiEm8FHqenzIqYiM/lQ5EvTnH
PXd/8TJzTuirwyI9V9SfFB9Ifm/6I/m/4DfxzuIQf5e+a2Zcx07xDhSq3U/f
6L8gfksv00voY68jZrSIW/QfVtdK+42G+31nTl/aZv0qfzA/A+/5TXrTxDet
ZdF0dVPc6SA6jU7FmOS3YP5M8Qf9I9R9pLPkz/j/AdL3pFY=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0mloz3EcB/DP5IEr5/5z5GjOOcIjjzxAs7nKUUrGrkJsjkfUhuTakzmm
FHNlrtkcsS1GMqR44BorDCMiUUjJE+X1W733/nzen/P3+f4zi9cvWpcW/vwb
1S9i6rCIPaMjKuHDoIgBAyKah0Zch0EjIqrlvKMPYQ+Gy6mIJrHe8t7Q++AU
/SJ95/CIC/iSeIV+PdT+mxBRxy/E9bi9f0Qtfo23yX8/MqIDytjl0KDnVdjK
3qFX9diINrkL9EsbH5Grdhv9AL2WPo9exd4PBeMiiqHS3O/mFbHzx0Qct+M1
8TPyU/rW0+pgofgCqKFXmXkK9xJfpX9Hpt2gq3ld9eqCv/WN6Iw/4Axzbwx0
Gzlv4Zx+Z+Ele5c+2fqmy0nBxyERn2ATvSd/Iy61zwt7zdV7HhT6tiIohm76
lsMXehnOHBXRmtybf5L/nF2R5f0yvJ2Z59i1sIS/UvyzvBW4u7oesIN9xD7b
8VH8130euPlD6ETLlp8DM+Gr2HG9TsAdvSemR7TgSfip3Z7BI3gCjxPfLbar
ma3PBvVz8Cl8Otk1eXt+DZ5kt0b5DXCe9kdNLi2XnwOT2U24xbe1y7+DR9Jq
aXVJDWTwj+EU/iXnh2/5Ca12qHf3C9Cs923aNPedDlN8/1L3XuN9y8w8lLyP
t9gN98wooZfTD9MraXvgPr2U/kr9ZrFqsb30dv4+/FB8rfh7/hbxGXipe12z
Ux6e7145tNF23Zp8J/uguiP65NulmV2Ab+Gb8ML+q9WtgcVq1+IstaW4Texu
sivUqD8JOX6f9/m/fecGOXnJfJhFz1O/jL0cSsx4JG8uvUFdI5Tbu8JOV9j/
Aa5EqNM=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV00dsz3EYx/HHzYhL0ZqlA6W9iHG0RdSKqtJKlNqxQou2VjgIMS6tEZsD
MSt1qSoRkRIrwsFI1RaxiQsSvP6Hz//9rO/zPL/v7/dPK1mWt7RFRHTw05QU
8aBbxENakhJxHxdjbVrEHXZxn4jN7SKysyNmsIt6R5RlRdTlRJTiNLFCquwc
UUEHMiNGd4hodHahPj97RkyVL6BR4vnOj8RFzv7oG9GgbgT/oHnDsZ7/XXyB
/DD+JPVDcT7/uR6/zP1Dv+lux4gMvIcv5W5hM97BJryNz/ChZ0xXd4P/lH8T
99pzDw3yXAOp0pxG8cfyQzpFPMLr/HLxCrrkDnarr8dcvVqqGYOtsB01s5Pw
n/zCLs6wi/SdTi3aR/RwD4H79TpAq2g1XVR/JHGf2EOPNOpO18wejEMSMffx
l5+OJzFZ7BRetWO/5IiV/HzzSnEyliXeDVapL8Nt/I/q++MHHICPzTtl7hNs
5J9k77TPVtxC68SG0wga5xnG0w+1N9zBdxzLz6Vh8kOpqz2qcRetF99AXTzv
U/Vdcbp4VuJOsA9W0wd2FabKv1X3ji7x3+BravJN1NjpHJ2l3nKFzhR4rvX8
1uw2tMY9pPSK6EivvOs2qRGfcIy69/K5OI7GUgF/Ck1gZ+o3HjPwBG7HfXLb
8Di9YKdjlne3B/dSpl1nJ87gV/lv9IWu2KeBZspdxuR0PX3/dXY77M6LxXLc
yQ53t8H38Vm8iqppor1Pq93F3uRbz7X/ZLE8vR6Jr9XrjPPdzNzIXu5ujia+
dTyGJebPplk0wI7znXvF7s8uxjn8eTSXmvS7bE6+/lOoxqy2dqrFfPkLWKrv
Cqr0HVRQOR3W5xCdVrPVufbmHtTnvH27Z/hv+u+/oBTx/+fUspU=
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV02loz3EcwPHPpvDYtUO2yOZ8gGxTJMfTTZnEygM3m2OzcjxitmEbI5HR
5H6g5CgbduRIE6WcbUweMOdcKyGivPbg3fv3/Xy/n+P7+/3/w5cW569PiIhf
KEmK+JMRsXxMxDLMGRzRODwijx8Nc2ZsxObREbnWi0ZFbPLcND5iIzfziwER
P53567kjOSKTR+GzWp/QLvaRu/EOH/AenfJ+69vem88/UGSWW3rexCUz7BgY
sSU1oj4l4obYdVwUrxTfLH5K/JrYVVwQb9W3Bc9Rp+9Pnj4u4qnzxzl5SMQx
TuKtQyMqxAvcaaY6a52dwev4vFpP7O3yXIWdKLGXasYU9Ng7qM7EQREHeAI/
5rnqLlN3Kf7qP8n6nty76JZTPDLisHin9RGepWaX59mc72yHGvP4GU9W8xAf
Rh1a8V2N+86XOr8Bp733aj7JVXyK33q3e3ybWuxztzSxL3I65f7Tc6rnaUhA
HyQiTc/+XOP99+Vq7scpapboW4z1KHCuwN1uq/XGeol1F7/DW6SbucQdS+Xm
9s7IefwwPeIB2vDVuUJ5jeYr4iu8R2w31lr3cA2qscb6G7e4RzManL2MNjUb
9MnSr8w82+yVIWmEb4wT7rnYOsvdszEFObij/1Ez1co/a72XX6vzCpX6VKAc
C51ZgHq8tJepT5X4LmTLWSWeLbZd7xzr1dZTuJCzeDmvxApkOFdhpmbfpQVN
OG2+Vs6xV65Ghpx55snk+Xym9z+jbzfO9d7Vb32/d77AXo+8eiSa5ShXZZrR
97qaFjFavyu8W6wG/wHZiKqu
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0klIllEUgOETZANZUTZZiNmgObRqonUGQdBgI1EbbYAG/1xkBbYIVNo1
QOQImUM0aiMUpQWBJTQrZJnQSsMWEbVpgJ5/8fKee+85597vfjerOFFUOioi
BjA4NWJ0dkQK/i0UF0T85T8omxnRlxHRi4dZEafSIipmRzSmR7w29woPzCfk
3c+NaJgVcZfr+R5/4+l5EU/UbZ8T8Uhdh/6P+Qa34ybGT9NrgZ44Ye0tv0Gf
+lznyEOdcS269KrnTt6m5wT5JfkRuzFOn436jeXD1srQYj3BpejOtLe6reIG
80e5HGPkH+RDaDZ/gPejSc+MGREXuRmX8Et9obmf/NJeq8RLUOesa9WuRiG+
O2OKvhXixhz3Ki43V+o+EqhbFLFc3QVrNVgh7tFvRN9aa8uSa7yUa3gNN/Ex
5zqOSn3nuZc0favEzXr0+L5seSvNPzX3wvg5nuk5yXi9/pN5A6fyO+fZ65v2
YKLxOvOZ6veJu8Wf1N2RM8CtctrQgiw5E61f9d9T+QoX8SYcsV6O6866Q941
HjT+jG593jvPLnl59tjJ+TxsjyHM9S0f5W1R18+buVX9D3nzxZfNVRpXowqL
5KfP85bsPyX5lpLvVf9e/PauO+QUq2vnEh5W/xVDyfdi3KjmnP2/8lk+jy/i
xZzjDs9wAZ/mbB5xxir73XbXt9CBAmsnk3fv26qtdXn3rd5CJ7dxnn79yXfM
H/g/9ViRFQ==
             "]]}, 
           {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0c1LVWEQgPHpY2Wihdcr4kItxY+r677VkqIWlUgrK8LQDEojNSrxqhQU
KujVluUtglbqto9NUVAULZRa2CYC21qRf0G/s3h4zjszZ2bOe6ovXe8c2BIR
z9CYjpipj8hhFr9KIhZqIta5PRNxFPuaIvaiSu04ny+PGONzvLU2ol/NNVzF
uFi+LqIgFTFUETGM52IZdTvEBp0b9PlSGfHRjC7nvPwV7sNvscPy3/Rv4UN4
oe9Bfi83bcd3/EZ+ynPWrHt8F/0NEafEN+RPeudEsrv3DuCr+H5eEqvjRa7n
ZZ6VW8EqbjgPotSue+yc4hpO87D4EObU5XDZvmV23yX33Z2lPKfxU66UP9jj
iBkvk3vkV1yo9rFd25wfcSuPJH3Ea825772njREPeIGfII8fyb3oW+m5CqO+
dQxZ7NajWG4nirBUFjHPD3HLzNu4g236b8cFvd/KfdJzyvNnPqbHazXHuQ9r
yfdxr916sC530XmUsyi371k1f8z/iznfkpHP+R/z9ptM/g9Oqz2DDvxzR5uY
MLNbXbPYjNk39f8PciFfYA==
             "]]}, {}, {}}, {InsetBox[
            StyleBox[
             FrameBox["4.`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.7410714285714293, 0.7897049707706296},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["4.5`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.413228547225986, 0.7545986279307413},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["4.75`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.5803571428571428, 0.8490646664559902},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["5.`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.21211071888030109`, 0.7321428571428568},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["5.75`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.4838474735273324, 0.6505488221298417},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["6.`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.6904121827592098, 0.6542254912030976},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["6.`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.33027995534986143`, 0.8597306335068682},
            Background->GrayLevel[1]], InsetBox[
            StyleBox[
             FrameBox["7.`",
              StripOnInput->False],
             StripOnInput->False,
             FontSize->10,
             FontWeight->Bold], {0.15329815605789765`, 0.5968086457418562},
            Background->GrayLevel[1]]}}], 
        {GrayLevel[1], Opacity[1], 
         RectangleBox[{0, 1.1102230246251565`*^-16}, \
{1, 0.4761904761904763}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Opacity[1], Dashing[{}], 
         GraphicsComplexBox[CompressedData["
1:eJxsnXmc1lXZ/8fKpTLDXFKzon5mVFqkPkpKfqm01FxwKU3JLU3LTFwqS81R
UXHJjDQRfQzNLTQbccMtZxCQAUZmYAYHBnFg7lnvmXvITE2tfvdyvT/H6/o+
8w+vD+fc53vW61znWj916jlHnf6eurq6xRPq6ir/+r/GifW7HDxjl4PnZuAb
q3i+cPfjZ3c9fvZS4ZnV8hXC8yrFXatC/S7h91X/7Ra+qfr7DcLjKnBGQfiZ
6s/7hCdXincZDO0XhS+oVH98RLj278aA6+rqp73zP/v9+M6M8YIZL5jxghkv
mPH6+l3CjBfMeMGMF8x4wYzXt18UZrxgxutxXd3JVfywxgtmvGDGC2a8YMbr
63cJM14w4wUzXjDjBTNe335RmPGCGa/HdXWzF73Vetwnn9J4wYwXzHjBjBfM
eH39LmHGC2a8YMYLZrxgxuvbLwozXjDj9Zj1bQrr2xTWtymsb1NY36awvk1h
fZvC+jaF9W0K69sU1rcprG9TWN+msL5NYX2bNN6p91z03iULFmq8YMYLZrxg
xgtmvL5+lzDjBTNeMOMFM14w4/XtF4UZL5jxelymV9X1XpLolWHRK8OiV4ZF
rwyLXrn6XcKiV4ZFrwyLXhkWvTIseuXaLwqLXhkWvXK4ru7G/l/e0f/LFzVe
MOMFM14w4wUzXl+/S5jxghkvmPGCGS+Y8fr2i8KMF8x4Pa6rO666v9s0XjDj
BTNeMOMFM15fv0uY8YIZL5jxghkvmPH69ovCjBfMeD0u92DbZ26//JaVGi+Y
8YIZL5jxghmvr98lzHjBjBfMeMGMF8x4fftFYcYLZrwe19WdWT3PHRovmPGC
GS+Y8YIZr6/fJcx4wYwXzHjBjBfMeH37RWHGC2a8Hpf/p7zaW7/6ksYLZrxg
xgtmvGDG6+t3CTNeMOMFM14w4wUzXt9+UZjxghmvx3V1F1bp1xqNF8x4wYwX
zHjBjNfX7xJmvGDGC2a8YMYLZry+/aIw4wUzXo/r6rY49ql9Zh+6VuMFM14w
4wUzXjDj9fW7hBkvmPGCGS+Y8YIZr2+/KMx4wYzX47q6+6v0ep3GC2a8YMYL
ZrxgxuvrdwkzXjDjBTNeMOMFM17fflGY8YIZr8ettr9fyBqr7S/KxlTnY5l9
r5TNPnTK4Lr6Fdlu1f4MZ2Nf/tjkXR9qV3mDjRM8/j+zPv7YFquFF99wfPlG
6BI+7pM7Fb/xg5ezxup478rqrqzcF7/T/IOp78s3CvP7+up4/ia8sUqPn0/8
lJWLXlk5481hm4/aegypXJj54nsBM3+ePpbLq+vzdBYx9Wvr3a5yMOUXVtfz
ZZWDKT+0uh/WqxxMeW1/9KgcTPnUanu9KgfH8XjcmkW8RWW6jm7NDqp+f7XK
wZTTfzD9BfN98BbV9gfUHphy9kv8HvuX74EZf/x+LAfTHzDfB7M/aA9MOf3z
5RtUzvc5X3wfzPfBfD+eRzDnJeJ4Xv19WRI9ZD9zXll/MP3z5RuFaQ96o/Ne
/UPeUxKmnPcf59G/x4aEdf7tPcF58u+XdmHWH8x8+/dLjzDz7d8rreLn2V9g
2gfTPpj2wKxffC/E/Qs/TfuRn4/71/PrPcJ8H8z3fXtDOX4+tu/54x5h2gfT
vue3S8Ksn7+/enL7xb+PW3Pr5d9rpRyO44nnEX5nbbW90Wxydf+2CM8bv+Xz
47dcKVxf7s3NpZeFLzzzwQ//5p+852Zo34InVe/DZp2fWA69rfEL5ffKX1cf
ed2Ny9V+3b/O+nn7p9P55ftg+kt7dVdVxntZ+r1hysdU17NR/aF/rD/7j/n3
9Hh9Nr46gQkzfr5H/3VfW//5fpy/cVXys1Y48leRP4nyDspr/FBbFscT5Sf+
PlwqDL8G5nz5+3G95hv+jPIaP1dQueSFtt+oDz2GP4v0m/fV2Gr9BVlrlX9a
qvmEv2K+dqh87pJOlcNvUT57TuUv8fNxP9T6N1+41p8FaX8a/+Pfc8x3s9aF
/jL/8M/MD+vl53uD5qs2vy0aL+sJFv/v6FGv9iP8cFwP9qPks+G+jvKduN85
//Q3YvY/+4X1rI23lE1qWvq5C7/SofWIuLXcu+d++FI6r3YfMv9e3jtD88H4
wfSX8YIZD/1lvsCU1+anW+Oh3N8fg/o9/Y2Y9uivf0/NyOtrbD+yPaFPXp7w
Qlb3RKX9BxI9NazzYTjKK/3+61N96FuUF9L/Wv01Gp/0AbZ/KGe+wFH+Rnu1
c7JO7YH5PdjP9/rQXkG/B/N7MPVr77WB3Pnw77kB/R4c78t4H914zRfKO3yV
yj0uv7fC/QR9h16wfrwn/XukKFxbvyHVh7/TfBpm/aBDfr4XBflue9jv7Tl5
MuXwG8wXOPJjnHdw5I/gt8HQd8ZPOTjK2yK98OWt4b3bKn4Jeso80D7jkb7J
7edS2A/DQZ46FN4nReHa/hvWfU/7jI/22S9g6B/f4/0g+bJh6rOf2G/cX9w/
cbzx/Y48ABz1U9Rn/9E+/Ky//wbDe3lQ+3V29fePi97U2l8Z8NJw37QE+rwq
7MfOwF91qj79g/5xnvmef++9IOzrD4teMv+efpbUnu6vcB+xf5gP+kv7jEfy
Ofd+H1J9yescPS6pHBz5UfYz91fEnCfOF/tP/GnQf3l5Sq/WF0x95sPLc9aq
f2DmB+z1Md2hfndOP+Pnr1/1pW928ov+3HpEHOm97ife03ZepI9Enmb3Lfe1
5Ft2fnR/Q5+sPufJy+df0P3M/LI/vDxyKOznoXA/F8P7bkjjBUMfjA8R/8n9
FLHnpzoCv9qhcvjVeL/DL3I/s/9q9UdyGPoIfzK7Ss8fS9jZO5T59er8PKP9
Bz3mvPFe4DyBOT+8H7gP/XlZFe6/Ts0n9AbM+tIfvu/168PpXrb3hKdvjeF8
r9D3mV/P73RrvMw39w/f9/rf4bCe5ffn8n9MXP6Pdp0X1gvM99nf3BfQd/Yz
8g/uO+gHmPVnfekf5wns7S+G1T7f134A236gP8w//YFfgF7xfdnLWHu6T8G2
nvF+pL96DyI/t/5EewzKWb9obxDPv+ffh3L2BNTX/AX7Ar0XbD/5911zkMd1
hP1RyMnj4n0X7RXYv4zP0/P2QL+HAn8+LEz7UR4X9c05eYvTfxdy+l3OB/Ql
8p/If2kPTLnkcba+0r9AR51+plWY8YORZ4Lhl8HIF8Hwy2DoDZj5AdPfnH6o
uj/mBPnwnCBPmhPki3OC/HiO+g/28uQ5QZ48J8iT5wT+bE6QT80J+3lO4M/m
6DzW7V1ZnyfUf39+W4VFzw1LH2JY+hDD0n8Yln7DsPQZhvWeMCx9IfSJ+XX6
t1Zhza9hza9hza9hza9hyecNa34Nc97gTzSfgX9B3gW9AEMvwNLPGT2jv2Dp
5wxLn2ZY74fwvqB98efuPdcofkjfc/RvQOXiJwxL3hTkJZ6/aROG/oJpH0x/
/e9HAj80mp1cff8n/gh+iPa9PGIk8O+jNs62dL9x/7LfDUPvuK9pH0z/wfQf
zPfBfM/zE4uC/qxVmP3g9XNl+v3In7b/1KUdao/7n/bAtOf5hXZh9hOY/Q9m
P4E5n2DGx/uG/nWWub0zH3xJ/YMfpH9g+gdm/4HpH5j+gaF/YM4DmP6D6X+U
bx+34ZA3NrtptfqLfJv+gukPmP6A6Q+Y/oDpD5j+gKF3Ub7efd4HTjy8qUv9
k32D9Q8sfZ5h6fMMS39nWPo6w9LXGZa+zjDrjfyN9Z75zzsf3n+vdZIveHrR
LP4G+YmnB6XceYG/hj/l/UJ91gtMf/S+NvrL96B/vEfFVxi9ivoy+ge/G99z
ohNW7vVvjRov5fE9R7nkBfZ76E2Ud0T9RcTxfQjm9/690yfM+8PLi/rVPtjL
VwZy8pFI3+Ef+T7rW+Ov+7MbK5/bb4XWI75fWX9+799bA8J8H8x5ifLAaH/A
e1TnP8j/vD1U2l/sJ94frG/U57OerI/X1/cGfUB/eA90ij+nvte39+fKvT1r
KejLW4I+M6+/jucxvhe8/choNr46nct0/sGUcz+DzyyXDt+f6AWYck8/yr8v
r2bhr23Cfr+MZm9udlP5hblSeExlOc9M92OkT5F/qOmDzs3qquO9PGus7ufn
tB+9vmtQv4dexPd9Y4U8bZpwXeXzH0r8hvTr9r043km7f728Y9J8ePu75iD/
bRFmP/r9Nxjev0M5+oS8i9+D+Z7XR7cE3JHTf3r7sN5ceXwfRv1lxLwfpf9z
9/9otsW4bcpfSPpo7kfqc38y3jhfUd9HfznPfj7acuOJ+mEw9MnPV15f7M9T
b7D/Svb/tOfl91F/XN5/J1UYwsR/2bgngnd46IJzJt3aqv3n7TPLNW3/Mx/M
D/Ph5fl9OXrv7R36hel/HB/49urvB3LnPZ6vC285euN5H1glfH9le9ycMPIm
9hf3s/iHIO8Fw68zPup7+8jy+656Xyy29ovClE+t8iNJH0P/wawn+49ysJcf
tQX5e4/4H9ELw/SX+5bxe/nlcI6/ivo4/95J+jjJO4x+sX5g5i/ya/48D4te
I1/jvUB/4n3t3x8lvSfA7Hf5/xi91/1l97nvz4KgT1yQ1t/ew1p/w+xnz88O
hvt9MOiXB7Ufau2l/QE99ee3I6dvgX7Dj/M92XsE7P2thoN9y4gw5fF9HfVv
nn6V6cn5Ffqa2mP/0p7XDyX7VMq9/DKvb4v0jP0BfYnz4/V5fbn3udc/94u+
cF/w/hf/Yv2XfBt5DfTQ9oPoodsvfVpfyYMcvR/O6ZfiefP97ZG+APki8nbm
D/5V+km7H2v0qKT7kf0FPWA+In2An+W8Qz85v7Or9DXRU38/pf1Uu8/6s4b9
91p19aI0PuRj4OhfmpOnmr+x5MF2n8l/nPpWrvr+nZb8y4M8OfpfR/my96du
V3vyR3fy4668vNnqyz/dyZM35OTR3h+7J9zfvTl5NfVVbvXl3271vX1xkg9T
X/7vQf7t/cuH8v7xQT5Ofd0XVl/+80F+7ue/JPssvbes3PunztH+iP7ZlHv/
1TlBn5b80aN8PvqnR3l99Ff38vcuYe/vOkfr7eX9hZz83su3+1QufwAr9/6w
aT2jf3uU/0d/96gPiP7vUT+gcvTr0f/d+if/9yCfz/nDR31C9I+P+oXoL2/l
sn91+oMN4feF0L+eIL/vU7nmO/rTR31F9K+P+ovobx/1GdH/Puo3wvx6/UZj
sK9ulP5W+xt/Jbe/k39+1JdEf33Ktb+D/iT673t7pw05fQr3pfa/a78n6Cv6
cvqX6O8f9TE+PsBQzv+f+uJ33PxtDPuhlOID2H73/vfNOX9/P772nP9/1OfE
eADefmyDMPMX4wN4/rQnFy8g6odi/ICoL/K/H8rFE/D69ZGgv8rHG/DrWQrl
jcG/vzngNu1b7NnA3n/3BfE3nh/vCPxwISdf9fKwvvC9/mDfl+zd5J+BPYDt
j+h/H/Vf3v6zL/e+9/K4ZC+u91Lg52WPavdhtB9Bfif9gPPvT/73ss/g9/Cb
Th+F/WNqP/rTR/2ZtydoDf7x7Tl7Av/eHAj+8skfnv5Kf2b99fquujrKoZ+q
b/2P/vFRHxf95aN+jnLOc9TXxfKoT/P+9EPCko8G/37p92y8Xn9WV0c541V9
G2/0j4/6wugvH/WH0X8+6hO9Pq5L5V6fnPzrvT5xQ85+OfrXU+79R5O/fZxf
778/JMx8Sh9p8+nlhXV1lDOfqm/zGf3vo34z+uNHfSffYz79+6096BO7cvpR
ypnPqC+N/vy+/UJOfxr9+6M+Nfr7R/1q9P+P+lbK4X+iP1yMdyD9q61P9J+n
nPVRfVufGC8g6nNj/AC//q2SH7E+lMveyvmndqlc/sch3oDX924I7RVy+uMY
fyDqk2M8gqhfjvEJor45xiuI+mfK5W8T4jPIHxd/GOePUVeHfkPxZtBX2/pE
/7uoz47xDrz/b2su/gHlrE+MhxD14zE+QtSXx3gJUX8e4yd4eWNB86F4N0Hf
HuMrRP17jLcQ9fH+9yPyV2A9wZKXI+93/kuzAj8zS/wZ9l/g+H6I9pZentoX
/G+SfAz5OZj94fmlJukPmV/Ka+MvqBz+0duzJ/8l6iPvE/1y8soBlYt+Ofuh
YpAXdkjeCL8LZr4Xf7rw19VHpvg/Xh7eJ/m97KsMyx/JMOsJrvVvRPY/shcI
8tIoX8degvX3+7+Qi9fh7YhetPaSP4f3LyhJP4t+Doz8EP2s/KdNX8Pv0edI
/2mY+oyH+uMq0/18p+qDpc8wf1S9pw1LP276Qso5L7Qf9bFg2UcGeVXOH9rJ
98q4uXK+rg3y+llB3jIrydutvvC91Qmx79+WnVw9D89KfyT7bVs3xTWo/n6h
1s/r3+aH+BHzVc55ptzr05I+jPtZ/o5G32XvUx3/k9If4D/j2ysIow/18ue+
8N7rzdWnvDb/veof9b1/c2sOe/vA3py/E/VlT+boRyn4D5c0Xq2/G39vsK/u
1XlBHwrme9AX2Ws7/cuQ7A3QR4Jl7+bo4VCQ/w/pe/werHgKzr+5pPY1PsOK
zxPsMdEP8r6O2NO/UtAvlnL6z2gv4PmldL45r5xv6ReCvRjlYM//bVA5mN8r
3oidf82H2ZdwnmJ8Ea+P7An2GRtz9jVenzSk+wgc9Vvo+/l91J/F+BmyT/lp
5Qf3yj4FegOW/DToW/37oZS7D9EHMT/cj7IXsv6D0ReLnkZ6+H/Gnzg3zP9l
mm9/3uvq5L9r6+ftqfL2PDU6u1blYPgfH8+pEOyherV/wVE+Qf9aq+N5XvRC
62n6Pq2n0++l+4/63HeUT5+34tlNTk94XmX4G9doPJTDj3v/qSXS/4G5T+g/
+5f+w9+Boce0z3jHV+dxmcZboy+t1v8loo/sd8VXNHrEfLNeYOgR9gLwS2D0
q9AzysVPWLnihximPNbHHgGMvUKNnJT34/TK/jpF/ff+hQWNH/sBz48OhvOc
yvke5eBYzn7XebH5Yf+L/tj5Z/3ArAc4xj9gPPD71AczPvTllENv43oyHsUf
dPEvCqIX4Hh/8nv4ezDl8T3g/TeTPRI4th/pRbRP0n1j54j5HVOTXmh+4Y85
T9gXcH/C33n+pCX417YEetsS4rduEL8NjvE4vf/gsPht6fvt97LndPLKFvGP
0EPPT7YE++uWXLwlynlvQG8UPzK8N1gfznO0J/bvpWLufRXjC3j7pqLeK4q3
G94rrDff571COeef+fPxKVK8AeQtlFOf+5X3Hu8PMPazfJ/7iO+DKef3vAeY
X28P9i7+3+xNNF/O33NQ+jOw1wcOZVOr69UkfhLs/afnJ3mAlYNbq/s52V9F
f6Son5F9p703oC/IB6B/7K94/j09HtDvwdAvzj/l8D/0B/oqOaPNP/VZHzDl
/n0wqnLOW7wP2f+KJxzeA9yH3B/Qe8XbcPb7wypnfbw/QVHtgeN7g3LFLw7v
Bco1Xvu9/MXde6uk9QH7+6AU7rce3cfcF1Hf5+1XC+JHwN5+q5Cbf2+/lfzL
sHfy/elXf7G3olzxc51/RPKHYL1YX9YzxlOgnPrx99B/2TPbeZW/AvYB9l5X
fBM7P5w/rx8kb0eDziuY+tz3zC/jA1Me7XG9frMYzm8x8IdD4TwNab6p7/fL
UE6+5+1li+E8FXPvYT/fRZ1v9dfR06Luc/XXlTfpfaB2TL4Jf4B8E36Z8wT/
zXkCx/Md5YWyJ6x+b1jnhXLuMzD3meIbOH/+GVnddpUN9Ug6H3Zf6n0U4vXw
fgEjj5R/ZogfQX3x6/a+wR7A8zsdOXtyxYswfrXut5UFfVr3O+sBZr1q+7lR
51v6P8OUc5/An4EVb97Rz6ZAP5u0XvBL3n51RbDXbgv284keQ7/9ezXRZ96D
rH+N/yvzp+XX+FutCU9aXHnAdOi9Qjn0i/c6mPc8mP6dXMXPij7I3sHxj72B
vywE/9N8fAt+D7/PfgWzX2XvHexlY7wQz78k/sPHr5qv+aVc+8XoHfSU8yBs
+hPF7zB7LtmzWjnj9fx0b5B3pXga3P+MX/mNor1ntK+s7duJyG+w5/P2VQ9L
vkN/0Xf5+Bw9wR5rJKcfgq5x30V/S50nw/F95+NZpPcW71Xv79aXi/ca8xtA
j9D/efuOlK/Ax9tG39AuTLmPX98a4uW3C/O9WN/Hm2/P6Ve9fVpDNqk6X43J
X8vKFW/UMPSF+rLnt3LF2zKs90Woz3vMxw9dkOpX9+dC0WPvj7BCuKZPbRN/
RX0vH14hTP0o7+E8aH/Y/SV+xslz5wZ9dIPkl4qnZeWyRzRM+9QX/xrkO8jP
fDyvWel+xJ7c5KfIL/G/ivogH8+klJd3uvIh0R9h7i/uO/ee6MjZ08X4795u
vl3tIa+JOMrrwLyv4L+gV1H+Qn3uD8rhdyO/HzH3GfPLe7jO/nhPSx5s9E/z
a/Jir787V9+P9MbvnyTP1nrbenF/1vR1V9r5rMjbKuW/SvoZG7/omfELtBfP
A/wz+5Px814BI2+FP0a+CqZ/3Pfqn8knJR80TPvefyjpk2r0dTCbcGtFgJz0
D/KvBdv8wG8wP8I2P8LEa7X9zPiZH+wf4Ze9fHlleH+2B36sQ/wR/IK3hxvW
/QqO/AX3Bfyp918sSn9BeWwvynO8/ctw4J+Gdd4Vn97K0d9wfjlPnFfeg/H9
DYb++fu6EPT9+fezj2/fH/xZk78V+2Nq+fTOW9Em/hl+TPFQDPP+9PrtR+Wf
zfuR/oF9/MQ0frD370zvU/mvuv1Tft9Xp3ux9hfvNfaXj8/dHuxXOoJ9Sofm
m/MMPWO9Ob/y3wz7Bf6P9UP/Q398fOAVwnyP9QDzvuX+hH9j/tlfirdmmPmj
f9B3zof0/fbekn+Ik/c1qb3a/lih+ffxr4i31il+gvsD+qv4NIah79HeBKz7
1+gT9MTrR3qDfC/RA9kvBix5CPZVxB+x+Yjx+/g95yH6J0Ts7f1XhnjbK5J/
t31f9nJuvJeJ/4n3QY7+Gv339Phc9Zf3Ae891ht+i/NKf719fHuQb6wM+ooV
2q+cf+aX/erlxU36nuK9QE8MM5/cj75/I8Lif+33stdx/ial3O/HVPUHC4I/
9Xxh729RUn32t+e/GsTPMF74GTDry/xQn/e01ycUgv1gIcTf6M08v5TiAUHv
qc96+ffAyqDPaQ/ylbS/GK/3l+4SJr55jEcGlj2/rQ/ryX2h94qV634O5T7e
cikn72Q+mF/ua+5Lypkf2YfZ+sV4lvSH8xP9h7w+I+a/zOe79PLHfP5LX94U
8lEWQnzKfLxJxX+Gnkx7dzzythA/viPkcywGPBLqj+biVfp4NaMhHngh6CtH
QvzJlE+P3/t8eg3BnreQs5/19o+Nes95/6RZksd5e731wj6e6KywPrNSvKnq
9x5K8aQMK9+Fw23C0n8ZVrxhV39EWPqo0D7yJ9oHs55gxVsyrHgP7vcjwno/
uPLmIJ9oE+a8e9wnrHgqhhX/2snvOkSPaM/jPmHa8/5rRckzfHzjJO9AHsF9
OLnCXn6rTePz8QD7JC9lfX385eYc9vHpB4QVj9ow/UG/TPtent4c4qOtEdZ9
4Mr7hJWfwbDiyYb2sa+T/5ZhyeMMy5/L2dsOCcu/y7DO72mVD6Z8Dt7ebE2I
77Q+lPcJy3/P2eMP5fTrUd4DPwn/Df8IPxjth6L8QfIeo8fY7/J+5n0i/inI
Q7x8paT3B/w3/HsNj2Y7VLbbdSn+lZefl3L0kfsdftfn2+0P8YVLOfrt41ck
eQb85MbKdK5ant6rJv/TfDn/t0KwT0zxjcSf1vb5RM6r5xfS+5z7PL7nud95
PzD/jNe/B4eDfm446GtSPgG9x1x8kw79XvEtoj4gxMNGfwC/4OPJpnwSsg8J
/uDwl4pvFeKVeH/jxF8gj/L8xkiY31IuPlL0h/X5Kjpy/IWPZ5j4Dfrn86UM
5fgDrw8fztlfxfxBMZ9IzG8W48l5ffxoLl9z9Nfw8VgHg/9okg/5eFIp3jX0
nO95/8gUD1vxMoxeSb9k7znWO2LPn7QIw69TX/e9YfJFgBXv3pV3qz3syShX
/EbDspd23+9XufgLwz7+0SzNr/e3GAr9H1R95YexcvEnrn/DOXl9Y3W97kn8
mWHF/zSs/C+GmV+w+DXDzJevv16Y+QHLHyKWR/7PyuWvbuXMB+XiD933B1Vf
+RJc/0dCf4ZVX/ZOVi7+0rDKrb72p9E3YcdvtmSe/vULa3/Ecvf7QZVrfxhW
udXX/rBy7Q/DKrf60s9YufhbwyoP4+G9p/eyYfZD5HcpV/xEp5/rD/rrgdB+
f+Cvi5JPiJ91789OvX99/MH56k8s9/xwv8p9fL/5qb8unvmQ5B2Kn2eY8sh/
0x73tbfXSphy+Av473h/R4z8ifvQ65/6gr3QiMrh/9F3QB+4P8DefqNZ5fSX
94HoubufGoUVXzi8FyhXPkRnL9Cicr3vnH1rS7APWhnKO4J/zkrVVzxDl4+t
UVj5qJz/YbPKlW/SxQtvCfEb24Qp9++flaG8Q5hyX78/5EMZCPX7Q38GVa54
HO57g6rPfkI/LHmiYcrjew37Jsnz7H3F/FDO/IEppz7z4+u3BX+Rltx70Ofz
7FS58kUZ5v6hPvTAx5/rE2Y+wcx3LPf9H1Q58+37P6j64p9dvtFGYcXfdO/L
ZpUr/ibx1I2/oVz5vAwrXmso5/denr4m0U/DopeGRS9DuX//Dgb/1aHgzzMY
3t/DKpc9t+v/cOhvmR+v3+Pcey5K722w+FF7fzO/Mb+il48uyL3Pff68zmBv
sTa8v/tVn/kBix907/3BIH8dCv7ug8k/D37c3udg3vuSH9t9AOa+4L0Kveb3
Pv50UfYoYOQDvCej/xHfB9M/vkc572vk6ehz6C/yA2+vnvzjwYwHewD0kfK/
cvbY/cH+uT+0N6Dfyz7e2YOXcvcr7zfuP+aP+mDZV5xde78zPzF+O/agsg9x
9Gk0h728I/lzy3/D3lvU9/s1xX9nPvz7tJSLf+71wym+uvzRwvvVy1PwL1wm
XOtvi/gPymW/GcpnVtSLJ64Qrj9lh6tO2cHyETeX+deqwORnkrew3tpvhuU/
4PwRG7T+yGe2qCzH+Nas7tOV/zgvm1360Lhtjk3ny+dTH8zJH7y9/rvysdp5
8/GVUrxwnZ8QLzz6Q0LPpF8I9NDH0xnKxaON+tAxj21R5pASPzjuvu7ebZ9J
9k0+P+KIzi8Y+RPji/bIPl5wMdgnFHPxNHz8s4SZ35jv1tuHDGVTK8dzdbP0
XT5+fTFn3+L9DUaCffxIsJ9P8aXlb2L8peRrLn70kOgB44sYeSzjo5z2vX9X
ijctfV/g32I+m+jPRTn6N+8PneJP036kHzG/hM+HkPQPWu/wXvL+c8Xc+8rH
C+zPxZ/29jHl81UhD4cne4q4fzj/sid3/qkjgT6MqJz59/FbSiE+/EjwTxpJ
/qjw08Ge3cdfyft3xPyu8T7y9hKjufedt6cZycUTAet8hnyTnF/Z41e/s0jj
8fHyh0M+iqLsb2Xf7+wRhnPlMX8j9hCyRyUechXfJXkXGHmNj5eLfG5pqm/j
8PFKWnPYy7va8/LDGh85UfGRnX9+kg/6/HYJR/kY7WGPTnuKNxHsXfz4eoK8
qi+01y97W8WHtPqKTxLkcfxe8RSCfJL2tD+tvuTTTv5ZzOmT+b3kU87efzAX
r5nfK35LkO/xfcVrtu/7+MBJfx2/H+M9U1/xw4M8kPo+3+AsYclf7S/KP318
5YLkb5I/O3ldX/BP6g366MHc+vl4yym+MvsB/wjZW9rvtd5BfxP1877/w7nv
0b7Wy36v/WHty/4j6Ptpz8cXSt+jfa2PG3+Sh8IvRfuB2D7taf3ceEs5eS/6
LmGzH1N+GJNPsp5R/hnjX0f7BB+/eTDEe+7X97Re9nuwl6cWc/YOPt70cP57
1r7Wy36veC/WvuKhB/sJ2pP9WPyeta/1cuMfDvLdjTl7jFz71p7Wy423FPyn
mqQ/Zf24f9BnIK9Fvg1/4vPdzNf6RvsMHw+6P8SP7g3f6w3y7sGcvYiPHz2Y
a5/2WP+ob/X21aUQT3tY97Psue1+Zv6jvQq/9+enSfNNfZ/vcUGKb2X8neJh
hfwknv9L8Z6ZL2/vMpizh/Hxogdz7dOezkvgP315KRcvWvILmx9+L/2xG18p
xKNO/kiiN8aXYI/Gewb7Uf+e6sjF5+E9Rb4N+GXJP+z38Mf+/ToS4oGl+F+y
13b2dDOkD5C8F/+SantPy58CeUn031Z+dOLP2XuJ9qN8Xv5w1r7XBzQHf9KW
HI7xm32+8pUqZ37APn9Ke4qPHfyHeX/Zba/6/F7+eNZ/L69fmtOHeH18S3j/
rcyV037t+505fYj3D1wT9B2dOf2C998czMV3jvoRxVe2+UFepfhjJu9WvKSg
T/HxkFuEfX6zl3ROvPx9Ze733j6oI1c/2ov5eM39Of9d315v6P9gzt7N92cw
1z7tKR5f0NfI3pP8FCb/Vnwhk/coHi3xMG3/4X+ueDuGpd8z/03FS3Dy9uYQ
L7klFw/a28+1BXl+S5D/dwT9wEqVYy8d9TleH9IZ7O36cuvn4z/3CysebbAH
9OMbzP2e+VH+WPu98mUEfQa/V/6o0L6PX53sDxWvMug3YnzpqA9Cvid/D/O3
5T0c7etVbuvt9RFLc/qlGF/al7cF/URL0Gd0hPZXqhz+KcaH9vuhR79nfX39
fmHFiwn2mT6+9GDu98wH6+n7W8zZd3p56nCufdpjPWN8JOrDD8T2+L3imwX/
6eg/EeNNM7+yl3X+FAtUX/IPt14tob2VuXjT3v+4U+Xyb3L+ximeJPwI/Vc+
lKAv8/GoUzxp+f8H+1cff3owxC/v1++V/8l9r5izn4359WL73t5+KCcfzfnn
mn2s4im6fCqtkoci3/T+YEXJM3mvIF9D/xDjR/t88/n40jE+NBj9RYwP7eOz
RTyay0/n+ZN+Yfg/7987EPwDk37R++Mn/aLPD9knewT8aVkf/LXZ54pvFuwh
c/GeQzy4iGO8ZnCN3y/z8xVx62zkqQnjjwyWPsww7RGv0sfHWqNy9D3yFw/7
Dcz3Dtq1IlB+Ob2HzX7b+4u/K76rycNkD2b7V/7U0f97sDLfN2g8lPv35R0p
Ppa1J/2jlcsfz9qrXWcJS99Xlb/8XuVgxed08UwWhvUfCvZcg9JPSD8XcPy9
/Nlsv8V40GD012DOX/Q/9vkH+3L+vD7+corvzP6O7ysw9u9g+U/b72UvHnCs
7+PPl3L2zmDFb3Hxl/ty9mExX7rPjz4U/NsTrtUfkv095b5/Q7nz7PPFj4Z4
U8meH4y+V/nAw/gj9vncR3MYeqX46y5ebtLX1u7ThhCP/bZ03xom/iH2EtTX
+TN9rnCIz4C8gfOEfh9/9uMuqUxg8gdCHzWp+vu7pf+u9Xd2Vv3c1sm+gPVk
vGBPT65M59vokehJjDdh9Enl5q/ry88N5e+iZzZ++ae485Sw8g+F84N9C/TF
508fzcUvhl4rnpnRC37P/Y59SqQPcX8Sr4rxuni9d5fHd2NlvEfW1qO+jBdU
xvtj448G5c8leZTtd82f6RNTPA+Lr2X0Lea7iP2N8WXB0Fcw8QZifmqfHznZ
E0LffDyeFC9V8SfC93z8t0HNl9dHd4jfiPFRvX3oSC4+AVj6eDuPij9n/CL8
ftSHo18HU057lNfwSHZyxbzlquTP5eONjkh+LX8l81dX/D/zD9Z9Z/Jc7CNm
V+0ZUrxS78+fMPSa+wl67u0v0n3C96I8kftO9hOGvf3CCzpP/r4c0Pmg/Rjv
E8x6xHifPv96wrXvF0X/mV9fXgrfz8f3jPEzI2a/cj49vR0M8e4bcvFkPf3J
x5f08TSL4bwU9T3Z0xt9kn7eMPW7q+fxBZ1f3hPQN+YDehbnn/Mmfb/D5f1c
4f76Uznni/tri8rxODCdxxg/EYx83OenKb/vqvEokr+4j6fZpP4ib8c/UvZP
Ll56r+iT/M2d/XRR50/2QCE+oz+PI8Lyx3T6mmI2tbofUrwcnw8l4UK1vWGd
Z8WXMTkB/GmN/j6Z8nOE+M+1fdc4Uf4EIR6e4oHY/YC9Ce9/5Fm674zeKF6+
jU/vOSsXf+To00iufu73dj94/irdF/A7iidtmPWO8dx8fPJHU74IO4/wY5SD
mc+YX4L3De/BHP/j7B3Sewd+t/a+JR/BqpCfIPmPqn3j/4SN/xF28cBC/JMK
/7BPhZ5fXau/dxkPV/rz69p5OCHxG3qvGb8m+0urj7+kP1/DOu/g6RX2ZHfu
15GsoXI8561K9W3/Uw6mnP3O/RTjPcV4EYq/ZOfB+yf1ZXVVe6nF6j/0jv0B
Pa3J454K92dToNcD2f0HVgKSrRBu2KdS413Y6A3rA71jfbAH5HwzX4yfeDua
Lzufyrdh9Efvb8M676Hc8xcvab+x3+F3NH+Ga/UfyS6smsuleCz+fVII/uTt
Oq/aP7ZfsSdgvXR+Xfx27BOfFZ5Ufc8kewQfbz0fHwXM77ur98fzGq/Pn5XG
I/9ne2/I38nOo/0b3i/zU/w3K/f2S83Bv7M553+JvZH8m9z5X69y2Q9ZueyF
gj+r9y8t6Peqb79HXhvt0fi9sOtff/BvH8z5x3r7qgH9XvZl9nvZrwR/WerL
fszqyx4l+MtSX+fB6J/sGayc9Y3+s9j/yL82xDvx9lJL8+vr/DPbhJGX5+zx
ov+s828thPi2/Tn7P+/f2qf6shez+sy/b6+Y87elXPZawf6O8tp8bMz50/ry
BvEjOh9ufppz9lM5+zfn31oI/rCFYA/UF/xb+3L2ddTXfg3+upRrPwb/XMq1
/4I/LuXMT/S/9d9vysWbA7O/vD1Tc7h/2kK8rxWhfluwP+oI9dfk7Ztcvoz1
IV5Niqcs/1qrz3pQ3+/fJq2P/35f4D8Hc/7CvjzZG+v96+JVpXjOfj82aX79
/bc0+A+vCfnaN4T38vpgz74+2FMXcvZjMb999FemnPH6fPfJXlvygZCvnvYY
r4/PtSEXn4v3uOJfGub97fNJJPuhOvvDPl7xyFy+g2bZ/0BPlW/UcMy/7vMZ
NIf4FW0hvlZHsu+x9nhvgrFfkb9+8E/28beaA24L8qO2YB/TEfyVO1TO+oGh
F7LXsf7Jfsiwj/dVV0c5/Y/+ytH+yOcTbw64LdivtIXvdeb8kb19Sofqcz58
vtY1uXznXn7WF+KHDIT6Kb85/JX8e4nfFvK/+njkdXXRHibmN4/+yD4feFvO
vsW33xnyPxSE4Rdjuc+f3hfsO/L5xqP/sO/fSC6/uOxlOE8hX2TMN0657JeD
/7HXTzTq97KvC/ZCPj/3ylDelrMf8e115OyFfD7zNSEe15qQj7yQyy8e/Zej
P27MJx7teWI+8eiP7Puf7DWYT+8v3Jizt4j+x9H+wpe35ewvvP1NR/APXpfL
1x3taWK+7jg/lDMfvn8jev8pPqVh7H3hp2UfYhh/Gc/vj0pewu/hF/k9mN+D
fT6HVB9+ivox/wPYf68ptJ/iXcJfYJ8Bn6Z81k6eNaJyxfd09spNQV61VOXI
VymnP9zfPn/2Qn3v5Kr+I8Xf9PFFVwV74JGQr2gk5Uc0/sH7z40G/8zBYG8y
EOLfFkP86GIW+QPKxZ9ZOd8HI2+6sSpfe1Hz5fPZLMnlP/P5ZJM+jP5RrvW0
ch/feYXOr9dvFkL+4oLkz3yfcuaHcr7v46kUQz6akWCfPBLiL24UZn46K9vn
gpSf3cf36pN+TPlHDPN9MN/3+cfK61Nhx+7s0Pcp5/uUs1+5vzlvkR/w9rJ9
IZ7IRmHaH5hYEcin9rj/1F9nXzxi/r+rU39dfI5RldNfb3+3Pmd/h3x3UrX8
4aAP36hy+ku59MAuH1/M71iSfzvyP7Dy+wR5IPERaQ//XtpDnkp7YPkbmP0U
2MdLKSkfiPIfG5Y9iMXXUD5rl4+xJPsjvh8x8m7JI80+SPJlk48zf/69tVDy
Pcr9+2ool18g6kuxv1O5yTvBMR+8/F+r8/90+m51PzyZ/N+tPMbTZ/15f3n/
5Z5cfnewcf9Bf9krjP7B53/oC/mCU34SsI/fMBDsbfr1e+U3CfE0fLzImJ82
5n8sZWNOr2ywFP8BzHigd7TH+ZD/Wcj/zvfkjxDqe/pbCv7/Jel7pW80TH2f
n7hX70XF17TzSH/9+6+UO58xvmrM7674NNhfuPjbdXXC1fFdnuTphmN+dzDf
8/xcjMeS9EmaL6dPWhj8+RcG+Ubyl2I/wi+AfT7N/sAP9Ksceko8EDDxKagf
463w/pc9p/krgaH3sge1+wP5CPZQ6NeIP1KFMxKW/Mj6D0afw+/R9/B7MPW5
v8GsJ79Hn0I566Xvm70AmP3P94iPQnvkK6F+zEfPfub36KO8vjHl18P+S/d/
tf9pPlz+hROSflDn2egDGHqE/tTnWxoN+SFHs9ZnNylTkOUq5/2h9aosx1vJ
Hpb7GH2et7dM8WKlr3b5UQvC8A81++zV+j7xFvh+tP8d86lLW244PtmLYf/P
77H/pf7MirnW1WvEr/l8LYM5TP/gR9mPjM/HLxrS+aB96Dn+CfB3ihfh7LVL
yreE/fNBlc9PSfmXfHke077W1/gRfr+4SsBSvnkw9R2/WJ/009jXEM9Q8dhs
P1FOfBvao1z2d1bO92N93g9aX6NPyhdr66F4cdZ+jX8bUHuU+3y6ST/M+kbM
+0TycKMHtM95B/O+AWMPxHh8/ptR8ZOMf2aF/TtvlcaLPlrxqF3+ouFc/JUY
r8f7qw4pPxH2R2D5L9t9An8Fv6L8PHa/g5lv5V+y/Q+Gnsi/yfFXC0P8lkXB
/2Gh2pO9ubu/WiW/xp4R+gxmPcE+3lBP8D/o0frgT+PtHRNm/lk/xW+x8wX2
+SRHc+eX95zuD7PfYHzw4/Tf6yuGQ/6mYY1f/sSGqR/fuz4fUimHffylUsh3
XAr3XcLU5/v0j/tY9oTGT9A/7ku9H0K8JjD3mfe/Leb8Xbz/bjH4y6TvYQ/G
/Vv7/bAw9fm+9LMhfqe3t03525gvzjPzBaa+30/p/cjvoc+UQ59pr7VyfK9J
+w9+VvvR+B/Fkwvxpbjf+d64ys8fW6v2wYpH7vJ3D+feh9iXKB+2Yb3/nL5y
SPI9/d7pO4dkn8R6x3hXPh5BMeRPKsqeSPHMrP+U1/b/fL03vH1sv+w1xQ+4
9+Sg6Cf2pviXIT+DXmLPGTH8Afy3j088IH2f4ge591/5fVmVF6T8Dz6fXbT3
LYV4b6VcvgX4Na23va9lf0k+SqM3Md4X/JPsdwPm/lZ8EafPLO//qjxkifYf
WPGz7XvS79vvxR+H/BLMD/SW9lg/7hf4F/hf1hMs+5mQPz3i6N8X443599qQ
2ld8scAv+nzgpcCfJ6z5sf6A4X/A3l63FPivkvg77i/oC/wv/Ib4M5M3yB/P
9rXip9j9wfxyXzCf/r4aTPpse5/G/jC/8CsxPw/7Tf6VAfv3R4pfKftQ2x+K
L+zmqxjsC/OY+5P2GK++Z/p/yhuq9D/l5+I+wz4T/h77bjD1/XtiJNwvI+Iv
kbdhH8N6IU/R+tl9yX728ZuHFd9O+SgNUz/Ki3nPyb44YPz52Z+895QfO/A7
yEvAkT9ifrnPmV/uc+gh+iLOG+/XGH+S9xzt+/dejD+Y/Iv0nrX1wh6zoVo/
+dty//MejvxltGcHi/8M8f+4P/VecPY7yb5X8V6IvwU/X13/R1M+ypC/Efsy
fh/t36O9B/cx/g6enjXn+HvkZehzvb1hW4h/t1L2jugn+X3t385gX7km2It2
6veKNx3iCdIe8ap8vL71uf74/BkdIf/GymDf2BnsC9eE+Hadqk//KEcf7eMp
rg31u4Vl3+ryXXSEeG6dwZ5vTb7c7PuU/8XKFb/RsMpd/e7w/fWhfrfqSw/g
7OMWBn+PleIn6V+0t/P5NNamfMLW31ju42t15+zzfP0hnT/FJw7+F54fTvlA
ocfcX5JPG32DPsHvwk/6fBhrc/GufHy1Usj/nvKJ+vPbrPMNP8h50jpUf9+Z
i0fs4w2PJP2OldMe/KjnnxOmXPIImx/JL21+vD67NeiDWoP8oFflii9u5fLP
Nv4A+RD1Fc/Gyqnv49UOqRz+wOvvh0J8+KGgzx8J+vzEP8O/Iv+VPNiNL5VT
H30+96ePP9EhfpD1ifmlKac9+C8w8i6ji7qfsc+JOOrzvX96X5Cn9gV/s4GQ
LzHmbx4SZv69fmooVz/G5/fyv5FgPzCSy+/H75kP5Dusj4/vn8q1nib/4fz6
+BfdwtSH/5Y9gr3/5c9p5dRHn0/78G/QO29P1y1+Tf71xp/RPuWSN1u5zqvT
/6yVPRnt+/hV60P8je6UX8PoUcz/gP0U/ff+I93BXmt9wClfMfwJ8hHFv3fx
uZfm/MmhR2DoFfwM7wf4WS/vysvXfLyGkZx/NPIp0VOnD036NslzXLyuVC5/
BKPf8h82+g09hV8Wv2cYe53o7+X56ya1hz0H86d83DZ/YOYPeuTjgy8VPWS+
oXdgT09bxT+yvsibFc/GxQ+P+Sn6cvp5H98ir6+nPeWLtvaY/yjvYDz0z9sr
9Yf49/2yT2G9fP3BXHwPyrGfYj9Jv2b7R/4XrnwgyEMHcvuNcslvrFznKZwX
3kuUMz+Kz+pwf8gPUgj0vxDyfaT5k/+4yZP5PvIrxRew/vC+jfk3kFdAP8Hw
U/69l+5XMPcv7VPO76P+mfgD/B59dO0+3aj6uu+tPpj6/B59Mb9H3qL7KMQf
QR7BeCkHs/9oj/mXvVhF3ftUwrV6Sb9NOb+P+m/kDfwefbj4i3fH12pO8TfY
/55/Ggzx8Qdz9o7sL9mPVdnvF5N8y+RnfJ9yfs/5p34u3kcYf8wfGu8b9Ofc
H9BPsM+P2qxy+HP2L/wXmN8j/wQj74LeUg6mXPF5TB7D/kUew/5984sVgWGK
t4X+XfGZQn+9vVWjyhX/JdxHjIf7KGL6C/2nHHqDPEf5AK0+9NLnRx5SOb/n
vgb7/CyDoie0z/e030x/w3rP++G3yjtglXDUv1MORt+teFhhftgfmg+bXzDl
+HdQjv483n9gyuN7iflS/KqA4/xG+wjmD/049En8bTh/3L/MJ/o00S/Tl8pe
xuSd/N7rUzfm9O3Ya4r/M/ko5bG9GJ8GfgYc80Ez/8h38X+X/srloyyqHBz1
9ZRLnkz+HVvvqF+X/t7eX/692hrsDXukT2W8Mb4I6yX5Y8jvw30M9vzJcO69
5eNHF4N/2mDgfwdz9rnQW+SZ3Dfw07yP8D/nPQTmvQTm/KEPAdP/KG9GfqL1
DvHPWd/ae7df66l4Qc5+YzDww4Nhfw1qvcHoF9FPUY681OsrOoTlf+j47f6g
/0jxMvXesP6I/3P7PV8O/6X4Kta+1j/kC4ry9KivgR5J3uTus5Fgfzsi/o31
BCuepGHd70FfiD4L+oD+kPF4fVqSn4C5D+hvzE/P+x76Sjnrw3kBR3kJ54f3
QuTfFG/F6AP7l/uD/av7I2CvT+8N+u1e7TfZZzh97nC4n4dy+hTuBx9/J8lX
vP4n6YsUL9DFfy6JH5E9tPEjrDflnAfoF/MHPwzGvlP5G+z9C/3x8Y8SZr/C
Hyifiu1v7mP0C4pvYfb48Ef270TpZ0J8C+qrPfI3IT8hH5PhXLwE2rdxxfgY
0T/A6ydWhHw/bSHeTkfI974qxLNYE/IrdYX8UetC/IzuoJ/p1vewz/L533tD
PIt8PA1+D72N8TJ8+/0hvkWKr6H8PjY/in9h8Xukj7d4GD4+xmXan9jzqr79
XvnkTX/j98+clL/LsPLNh3zqPn9QS8gH1Jwrj+3h/6f9YL/X/nH6ohVBv9Wa
0zdRzv7w8TTWBH1VV/jeuhCvozvks18f8iFtCPqwfLwPxuvzf83R/onxPmK+
JzDn0+f7acnle/flC0N8wbbc7318i1a1x/yBpd8LOPpj+vgca0L9rqB/Wxfi
f3SH8awP+Ys2hP5t0Hgkn4rxRKxc+ZENK75IjCcS69v4dP5d/1K8DOgh+j3p
s51+vDnkA1qo+BXsb59PqC3UbwnxO1qkj2f9fHlHyF/VJSx/Wxefbl2wn+sW
Vv4z6w/zHeODxHxJvv5QLr4H5fBb6C/hJ3z+oI7gT9YR+OMu6Sulf3X2g90h
nu6GkK9ofcgnlI//4b/Xo3LGQ7n4SWdPOJL0o1YO/yR9po2X/QO/i7wFjH9w
fH9DN8XPmTxd8UiCvtTnv20N/EVfTh7h/XOSP4LynRi/pfzw5Beyfvl4bHNT
PJHqX4P4N+4fX39Grn3lF+K+CPlcKZf+IMQXwR6J9mM+I8r5XsTKD2Tf9+/5
Fbn4I8pHZOfVx5tuz72XaZ/+x3gj2AfT35jfiHL0LTHeSMzXA4YfUP4eo2/K
V2vY22+tyMUnUX4hG6//fqfKoUc+H+668J7pDvFM1gtzniOm/5xXypnPGI8k
5tsBM58xP1LM16P8PLYffDyLFbn4JP690aFy7l/v/9yh+syfz++zTvWZLzDl
1Ef/Sf8UbyHoU3287PVBn9sbvldQ+5SD5d/oxrchxE/pybVPOfdt1CfHeCox
fory4VTL71K56EnIz0R9zkuMp0I566327Tz4eCgtufrK52P7w8f3WJGLt+Lz
36wUZn/E+Cu+flcu/grlnDfpx21/gNk/vv31wvBjPn95bw7zPbCPv5LqIw+P
8bkVP9/uB/wLlC/YxVdpzOXPETb5g4/n3RL8FVaEfDxtIT/NSmHoGfX1Hg35
lHz9zuDf2676iq/i7BO6hZWP2OXrKYT+94X+juTyGXl/jJHgzzEi/ZHsb509
xIj8Nbif8M/EnkPxFYi/iPzB+DniBXBeff7mBpUrvoyV8736Kv99S+JfLP4M
/BLxk8Hwm4rPZvxPbX76JG9CHo78E0w59nE+f0fyV8QeKMYnoZz2sG9iPI0V
9eGXkr4TTDnxQeDvvD/6UA5He23sg1g/sOLVm70Q8nr0S+InDYtfNXkZ+8vf
Z8keW/ys2Ysgj0D+hTwNTDn6YfSB0R86xtugHHkZ+l7kaWDK0Q/re6afUTwP
w5Sjz9H3gz9ljNcRy8dt+qX7untT/HP8hWWvE+JzcB+hb4A+Kp+pxRtQ/H2L
54F8J8bz4DzL3zfE86Bc57VGRyfqvP6f8acvk3w75gPifEp/X6X3t6d42RZP
W+c71rfzD/329vSDev95/V/KD4Q9Kv5d2KOD8cdCv4H+hHKw5DvuPbVB7yno
Lxh6gj5N9kH2e+437z+VcG39e/V91gv9AOsJpjz6x1Aue9hQjj6C9aQ+8a05
T8wP9ghgn28h5fdh/vD3oX5sj/MLvcQ+Cf0j9cHeXmkoRy/4PvMDpjzGC6Fc
8h9770Hv0A/KH9z0g6yntxfqz2Hqg6HHYOg1+jDKofe8Dznf8EuKlxHyD3Gf
w79i38P+5f6uFW8I9iIbFF8Ef2XFw+f8m7zY04N35euxeCPyb3fnI8Xr4bwi
L2G8Pv5Buj/ZT9E+GH2W7HtsfRXPz+3PtD6y17D1UXwcl/8p5TsEx3yBPp7k
xlz+CeLHg2M8Ecqxf0Efx/7kvgfDD3B+fbyw5D9NOfo6fu/9w5K9HfXRb/t4
Min+TYzfgf0S9bGvYD7Yj4x/TKW75yQc+UfKlV/bfk/71Kd99He0h/5N3zP9
HO17/d1oeD9vlH8Zv/f5ANP7UvxnxXzj62n9ub+1/pXj3JLib8X4IPxe/ILF
C4G/RP6H/RL2HrIPdv6FiX8Dw9+hn6bc59NI/uYxPgj+ZYrPb/5lijfm4n+k
9hU/zL6v9bP2xG9Ye+KP7Puyd7T2FH/M2oPexHLsKWjP21ckeyj6j/0G5dhv
aD+b/YbOh5XjP+rjhcR4hcm+Sv6Pzj4ilWt+7L6kf7E93gtg6CHtx3LvD9wX
7C/6shur+zFh76/cq/ro4ymvsz/ZT1W/f3mI71XI2WMxXvg35oP3k5+PFN+F
+tA3yj19Gwz0bUDf5/fwF9SHf2C+sf9S/CbDsn8N9lqRfvn39bDyv8i/3fg7
3iOUUx//f97DMZ8N+wHM/EEfKEefBCa+B/Jz2U/bfGAPj/ydcu4jsL/fNoR8
6MUgjy0G/5FiiGdRzOVfwn5O95XZ18k/wvRj6Cd8vtCS9gM4xg+hHHrH+KFv
nh8dCe/JGN9xKBd/08vvh0I+3WKIN1LU+xPM+5R4IZRrPDYf4Bjvg3LG5/19
R0L8yOSvzfgop33oHe2DKYc+Kj6K84cp5uKDUK74tUHexHsU+QTvUerDjyme
qdmrg7FXZ3zwE4wPLPudgGM8Es+PjIR8vKl/2IPxvpT9uPljsj98/p6hkF8s
5vcb1P5WfBK331O57DVD/BLKkT9RDvb9LebilZBPh/q8l0VfQ34B6Bv8NOXQ
H/R/xBPh/pE/iPEz2Lv4eB0D4X4aDfkORkN/RtQ+6++/NxLiL5SCvWCqD47x
Qvz9mewDtf/sva38RO59nd7r8I/++0kfK3mgfZ/7hu/LX8Sw/ENCOb/n/Q3/
Dv/i38cp3gj3Fe9lydfc+6oY/O2LQV9cDPFHisHfqaj2ef/F+CX0l/e/j5dS
UrnoU4hfQrnWy77P+vj4oSNhvEl+wO99vLcR8V9g+DN+Tzm/j/FR4H/4PfwP
4/H5YBOmnO/p/Wr64hp97RG/DH/m4/EkrPxfZp9b629B8m/xt86fIx9P1s9P
f4ivMpjLpxnjt3Dfwg9Bz4jfDD1TPGejZ9hDe3v4vpw839OHFK9F+9POM/uT
88v+jPFcaI/9yXkDs75g1lf5Imw/8D3qg6lP/2N7Pj56kpfQPvNLe/BDuh+M
X2I+vD9KUfwS9eGPmA8f/y7Fo1F+BqPP+r3Zs+p+sfgpnp98QeXwy5r/EN+G
9vg+7WEv4/3zlmi/Kh+C8WviP0I8HN6v3PdeXzKi9wK/hx8Dw6+B4bfA8GPk
A4wYfln5zo1f5P6L8XW8vHI0F68O+YnsyQ1TjjyE9fD2B0Xpc8Tvmb5H/itW
jv4HeQvzN6HCPn5hdZI/2PdE/0xfAkYeI/mElWNv7f1b0/4Csx/gr3lv1e7f
RvEn+Bv7+KDzQ36Cplw8SR9veqH2F+8V7z9b1H0E5r7ivcj9p/ywVh9MfcXb
Ce1xX4G9/D753+Bvz/6uTkd9mZ+qkLMN7ZKf+vwG/cGfpj/EP+iXvBOMvLP2
fn1G9Bv5un//9YX8tgW9L/HX9f43Bb0v0V/SHpj3KvYplKN/AUMP4M8Vfy7k
B/bxWxJ/rfW1+4j1iuXw19qfxl+jr8a+FH1RzGfM+iGf8fQlnx8S/bvy7wXs
87n05uzdfT7AFF8ceYDPP9gT7Kt7cvn/qK/2nX11yg8o+16Xv68n2BP3hHyw
64O9a4+w/MGr7S6SPRD8CDj6w8i+0Mpjfg7oP/oX2ctZfdmzGcaeCnsSHy+j
PcTraM/Zm8m+zNqTfZdhb7/VEvQVrZnPr9Wq+vSH+nzf55fqFJb9cPiez1fV
GvRVrZIH8D2v32oP8T3aVR/5F+9lxXtw9tL5fD5jq/S5Ufc5dBx9ubfPLWVj
q/dnsteN+XrGV8/jgmQ/Yfl7oEc+X0tB+wV+FX96ytG3gX1+6lKIn538B+H/
Y3xt9BHwA+gjFJ/y5oqBTpf4A8oVv8/0fcrvYfRC59/yfwibPl/Yfi9+zOib
+GPj5+Qv5vy7+oJ+vE/1wdzf3K/8vnY+Xgzy4xS/lPdIjEcZMfy15EOhPMZP
9/H4Unl99Xt/kHxK82n0U/Nl9hXIe+DPkU/E/ATcp8oPY/dtXbW967Qe1fbu
TvnBhav09YoU3796Af5M+njeP/DXzB8Y+QXr6ee3EPjpQtB3FzQ/8BvEK6zO
394pHjzlzFeNf0z6CMVvsPEIY59Sna/LxU/JP9DxAym+Nvysj9c9kotP7ddn
JPfeifGf0a9y39foYNKv8V5Q/GvDlMd861H+iHwSeoT9n+JRmnwPfoTzKP2D
8SN6vzl54UDIz94f9BuDOflKjCdLufyjjX9F3kD7yt9s/h+1/jxi8prGkH8K
/r0/8POpf7z/8Y9Qvjjzl6x9t13xVMDEW2F+Od/Mb9wfvJ8k/zP9M/ak7J9a
eyu0f8Dsn9p89KZ4qtX+Py3+U/nrq/ftU8K181our/anSfyn7jcXT6eU0y9Q
Tv4O5GPyhwjyQPYn+4v5oDxi5DeyxzT5uOw18fex91iMRxr9g2I5/jbcJ8qv
Q/7Yd+evr0/0ztOLc9P+dfEWR7LZ1f2cMPuR/UC54tmHeIz0X/GWrX32C7/X
eTFMOd+jfz4+Y7l88wq9eT7xO8a/0D9fXgr+Zvn4jcyn7M+MPtA/sPpn7VMO
1vvd+gP/g/4Ge2zWR/7kph/C/wLMew77kNp9WVB7un+sXPFirX0w9JH3iNsf
dZ3B3rBJ7wvJi1w+7pLxa8+meFE2P7X2GsS/0j+vDysk+0vb/7zH0M9G/2nK
oS+Uy1/TxYvtEpZ/pWH5UxqW/6Rh+RPX+jWR8+TzwZdLnD9uY8hX3yws/13n
L96mcvnruni2XcLyx3XxaAsh332fMPcJ68V6QE/BPn97s7Dm171HVwlrfl0+
+xR/VvPr4s8WQn75Ztmn077fb125eLPUlz+jlfM9Hz+2IEz7MT869kb8Puaj
p1zxq03+yvxETDx/1Td5ORj9luxT7PfKF2rydNZP8VltvXz8rYZcPqSof/L6
o5Hg3xjjwTeG/CHp/U/7Xv41Ioy8EHtC+deQ39zoC+XaTy4+Y5f4Z9bHx8tZ
E/KT5/Nzc/9SHvPFgOkvv6c/YPxRqI+/GOX01+e7WR/yq69XOfvL+yfOlXyD
73v5SFfO/wx5Mu1RrvyvTp6xNOd/B+b8gLX/Q/5p5BO0H/ND+/zKS3P+XDEf
NPUZb8wH7dvrUjn9jfFKqa/4GO5+WJPid1h9L+/rCPR5TYjHsC7I61K+Zslj
LD67j8/5pO77+qq86Um1D32lfe9fn/I7qz2T59Ae97Lvf5POF/I75heMv3SM
Z+nzMRWk36F/yPPYH9H/NJZ7fcn64A+6Lvi/rQ/yr0KIF1sI/lV5+Y/Xl6R4
NtL/m7yH+shvuL91P9p7Gf4VHOMVwH/q/R/ej7zHkGegj+U9Q/wl+evafSH/
XMPwez4fS6/sYfGXoH3lU3X5a3qDv0PK74b8HHkG8iIw+mwfv7s/yId6Q3zo
gZy/AvoY5iPqb6mPftPn+0jyKObL3xc9Ib9pT85fweeXSv4H2j/2vuV+iPEz
uY+wL4j+A9znlHv/up5cPlHuX/oDlv12iI8V4//xfmY+0X9Lfmb3ufwDTB+n
+Kghnmq0r0c+W3v+5vNv1k5Nmh/v/znq+ZX6lD9T9gA2Ptbbx5ccDfmBUrxP
yf+M3vN+YP3knxnst718cqH4MfyrwLVxLQj2Vgt1fqgPpj7yP9n3Gz1i/qI9
Pvbuim/t4j03C9e+3yz9LRj5juKnuPjPC4TpH/Yfol/Es7T6Pn7oAvlfYb/m
7bNagn1ai+aL+p7+tIR4qC3BHqwt2Fu3Bvu0QvCH6RVGXhTtjbCXZ/8trogP
xiV7+5gvEHtO7W+Tv0pf6OLf9ebyXUV7dM4b8iP5E1Xbv073Gfbh/B5+HHqo
fJfhPPv82ck+W+8Hx88m+2zlt3DxEJuFa/bGi7X+8sew/UR9H699sfYX9hrs
T+Rf3IfKBx/yZ/J75B/QQ/ar4qsY3UEep3hLhrGH8PEB23X/KL6AzR/vMX4P
9vEEN0g+Dvb686RvZ/zRX9a/H1olb8K+25/3FmH0OZx/5i/mU/D2/smfmPuC
+w55vPcHTv6+8o8O9sjIi7C3Vzx76KejXwvVX62/8Uda/+APF/O7eHveZP/L
fUE5/g3sJ96n8EfYE0f/Ie8v0CLMfHt/9RQvCPtd6JPyvcT8LC5+ZvJXhf5H
+oZ8XPYBhqFv3L/oG7BnkX+37W/lEwv2ldGeM5d/zvh52U+5+JL9OXtF9hfv
H/hlMPyy4lXbflf8HMPI79kfkleRr8fkG+wXMPJZ5Cf+/kr2j2C/H/pk3yl7
Q8fvFrU+YPSf1Ic+1/ZTo/KrKz6Cy1fTLCx6Geojz5E8zOVjWCx+jfsf/kjx
yB39axamPusP/fH7o024Nj9twd4y+dNJH2L2J4ofY/Hi0J+Q30zlxNdDv4J9
UbX8rpx9UYyvgLxD+mnjp3jfsj9532IPB4ZeQv+4n6R/cfnRGoVZX2+/vVL0
tvb9FSHe6orwHhr2+r7mZF/G+cKfFQw/DuZ70Av0t8j/od+UI/9S/CDD0BP4
BdYbeSP3G/J/9h/6QbDi95s8XOfT9E+cX5/PrlnlMZ8UGHmTjx/fF/IPDOj8
KF6JYcVvMcx8T66yby3iD7z94oDsB5Sv1jDtgWmvdg+mfIOTK+KIWSne/OTy
au1x7mrxM9yflPO+wt8BTHu1+VyX/JNcf5J8Q/b19j3uI59PqGTrkOJ3Qa+5
z7Hvgd9i/bjffb60hbL/wR/Hx39I+XB0P4T85awn+i3lm/hv5e8J0Tve87wP
ZO9o55P9DWZ/c954X/v91q/2sd/07aX8NDp/zr60P9iflrTfKIf+MD/QA+5P
1pPxeXuJQoi/N1fyIOaT+WD+wPTf6wMKkr9jXzK26u+1TPKxmC+F94nivdj7
Rf5G75bHVdqr8pNpP0f5ifTrn660d570u8wP5535YT7hD1k//CdivraYPwT+
tUbPW0V/eJ/CL4DhDxRf1MqVX8P5R/SoP6yfp1eFkL+hJ+RHT/74tM/3JU/A
nqM6/5drvrH/Ir664ivYe4P9wX5WfGPyM9n5Yv9y/ilXfGNnv7Iw7Pf0XsL+
Id6vnl4Nh3xvw7rfKPf5hYdFX9jPPj5nyq8tezR7P/L9eB/4ePUJ+/zsy7R/
o/zN59/uD/xSf3iP9gf78yQvVXnwT0ceP6n6/b/IfgB+Cfk0+iw/3wnD72If
B2Y92B/EF5J+28XrTvGyhc2eTvZJpu/WfYI+nHxnVX5lrvoPln2uYeU/C/G3
aY/zQX3lT6M9e0+A0T9JH088J+MvZU9g/Kv4Z2fvvijoxxv1PhU9MHtbfs/7
lN97f9WOYP+S7Fmm2r3s9cfJXkTxUG2/w794eUyHzgffoxz64/NF9OXiNfFe
l30D+mXygdp7FMz9xn6A/+Z9RjkY/rXO/qgPPfX5+nqCv0WP7i/oK+W05/NB
1dV5/4m14pfRN/l4rHV13v58rfRVxLvCPwfs8yUUgj15XZ3Pv1gI8ST7ZJ+j
+NmGeb+DoQfKX2b3geI92n3q85PV1QlbOfc3+xfM+QETbxH5uvy/zD9c9oCG
JW938ZVGg/42xRuU/ZuzX2gM791GvTdYf5+/pBDy2xVUn/Po37fNwT+pOedP
6OW3SV8qe3njr5Ef8T6CX/D5GV/U/a37ydk3NcjeTvoT8zeRPZ7ZK4Prq+fu
D7KnnlSd72d0P3t7zxQfTvlrTF4m/+cQD476uh/svlP+DO4/4x+8vKRX31f+
B5O/wI8zH/CLY35S6VCyl4ZewM+DZQ9q8hbFp7P3G+9V9u+kKr7bx9fbO5/f
Dnse6fOMvtI+8kDkf/Cv0Cvs5eDnYrypGE8qxosivgL8XuQ3Yjym6K9A/CT2
M/5+tIe/Mpj1QP/i9W+90h/CD+T0Z0Ffin2A4m29Ox9veb4Hqvdlh/YH36P8
xqr+q1X8QcxHDWY9GQ8Yfk/8BfmP4C8MUx/5Bhj5Htjrb/tDPIO+4A/QF/R9
vWof+sz7EX0484s+x8dHTeVV/uGEAXvvJX2QPx+jwf44xethfmvyvrQeGyvb
+18dkt8wn8r/6vKNtQhDz5A/c164Xzl/Pn/chhA/qCfED9oQ9FNJn4L/gb+v
U7wc3gfeX2BY7TMf3v6qRfJivf+cPLlVmHLeI4w/5h+K9zX2AOh/uB/B0H+V
O/+v/yP+i7UHfef7yqfo8lEMyr9L8VecfeSQ97/8yFB2cnU9030Q46V4efyL
Id7CQM5ehP2v/J8hngfl0BvoJeuHfFr+7vb+BMd4m9GfgveV4m/Z9+G/fLyC
QohfUhA94H3l4zckXNsv/SE/e4rvwO/hN/g9mPrKP2nYxz9L7cu+0cVr6gv8
dX/IJ5vya+k9ZfI+9C34v4DRxyhfonvvpvgOlPv4WUO5eArc94pXavtX+gzj
37i//Hs53TeK341/ttFX9AvQt5lVfjP5p+Bfz3sfzPuI/pMPBAx9Zv7AvFeg
15TDz7I/4F/Zn8hXkA/IPhb/kurvm4J/+grxn/B/91fbaxfGnqG63PWpHPmC
z2/Xl/OPhj5jXwc9BVOf94m//5O/OPcf+gfdh87etTfn34U/m/JxGUb/rne4
vTf9+7JT8jTsi7EP1nvDjWel7BP5vc+38EjOPzZi5FGKv+be323B3qst5O9r
DfET2oSp7+PjFKRvg3/i/Ue53nfo0+w94fFlei/AD9fGP1tY62H2kFoPw/LX
NFy9T+rL+PhKB69P7xnsoZC3GK6vtv9n8Utgz+8mexrZYzh7oYSxD/L8V2uI
N1UI8SZ7hdmP0Fuwty9M8Rd5D/h4jSl+Dfdp7X5pTfNj7w3Ka/1N8hPe7/Cf
rCf8K5hy3jfyVzb5nvSxtp6yh7PzCv/v4/20CLO/0C9Iv0K8S9tPyMPpH5j+
YS8EfUb/AL2X/Wu1/XbRO+QJMd4L9AX/Nsqr9Ld5OBtbUf9OS/wh/B78APcR
/qa8x+A3XDy3ExI/JH80589Z0PtA+Z2NP1Z+Z+Rjdv/yfbDnn1N8IPFn77av
HBnMBqryooTrqu/lNr2/ef9Dv9Cn6P1i8838+3ys7eKvkC+CWR/GD/b677Zc
vC4ff3iF7lP04WD8PWP8cuyR2G/IxxVPJ/D73F/KD2byVc4X+lbuEZ8PbqHk
uWB+L/2HlUu/5+QtJe0f6KX45Wp7j4nfZ728f/KKkH9thfSrYOQT3F9e/5r8
Fav78SPl71f1Kc9Lvu3jDy4J8aFWSt6j+BbO36lD7fM+oz+832i/tp82hvy1
o7r/FH/L+D3xjyavgx/ifsevwcfTivxLt/xd8Lfx/jLrJT9R/yweE/27sEI+
3knxr4lPLXmci0+9IcTz3iB/BebD5+fp1H6Tf4fLL7go3Je3SX7o46Wk+A6c
B9nXGv/I+xWMfbnXl6V8wpR7e+te6TO5D9GvQq9cPt/yfdZZTXeR5GPwm2Cv
z+4X/VW8axdvdDTIk1uDfWpbsK9bGvSrI5LPQY/QP7O+yOtZX94D0n+yLnZf
Is/0+eJesPmfr/cN9oeeXxkM+uBB0V/kh8iHlG/G6C/ybR//sSfoWwtB35jk
p9y/+AuB2Y/oA9A/0R/kqXzP8zuFoO/s0XmVfN7Fp072jJT7+NOpv8wX+kvm
C/5G8cBsPVgn/55O/DXn0et3Nvp4G2UMf127X0ezxur9ZvK0+sQPSF9o8w3m
+9BXL3/oD/EwEpb+kPyX1fKnE7bzD73gPoMeoz/y8uo+8V+ynzIM/WU/Qn/9
fixq/in3+uP2EF+uPcgjUzw0xo89G+MHy7+d+EWGkVchj/DxwlqDfnO9xo+/
GZj19/SjKdiHNuTsM/z+KwizXsj7WS8w8jniH3Hfc78xH97/tj/Ir/oDP9Qr
+ok+Bv5c9jZVercuyS+dPX1PsJdbmOxLyO9o4+c95u0h+oK/w0CI/zIQ5D0D
Ib74u+Rbtn+Rv3J/Rn8qL+/pyeWHYX5q8Xv6szer+Z9WpPeu+ZOzn8Dcx96e
uFP8TG3cncHefkbyh8ae1cbP+RS/b/Pp8/f0hPwFyX8F+yb2t+JZG+a9ynry
Ho350vAvon+Of6/oDyrisuOSvBb5YO3+TvoB9Alg7GdifBOw8p+5+DvJv1zx
Uw0rXmuwr6Y/sv81ewz2C/6zsicx+2HOC/SE/QHmfPv3WEOQl7eKH1K8X5Mf
gX0+xfKVQH4+u0+xnxE2+xn4o4ZqPLEkT2A/8X7domJud8oq+TOgj0VeC31B
PwP/z/0D5v6B/kAvvT9GilcA/xz91cHS/7r4guVzVd2P82RvHfnbGI8BeqN8
8nZvgzl/nEcfb/el4N+yUvZ33EfQJ/n/OH+8ZaJn2Nd7efbSXH2vDy2EfAWF
4D9aCPkLRkI8oYW6r7gffHzy+cH+cH7Qzy4UVjw92z/Ia3y+k0H1X/Yyxl8i
z/X5HQohXmkhzHch3f9VfF2SNxpGHiX7x8A/env8JcG+slnjk7zX6BeY/tf4
8+UaL/vbn++Eqe/vo54g706Y+ODQN/hB5OucL/QTnEcfL7clp6/x8dX7wnst
2Qd6+zbsL56RfIH6kq8ZZv/In8/OB/PL/scehvcj8iC+L/rl4mvNCPka2oP9
ZkeIx7cq5N9K/hjQW+nHq3+N6j/yEPgV1t/7z7QFf/lV2m98z9v3dOTyw3h6
s0D0EnqHvBL5Dfwb9zH8mOSvZt/EfQo/xvnlfcj4WQ/4dc7rQLV/HTn7UCdf
npHsTeHXfHyp9L7gPnTyxjK/hPxQ9sRmL+nzyc/Vfcn6sX+9PWGKJ89+B7Of
mc8avf9bzp7Ll/eonPVjf3HeoB/yH7b5RV4R6SX3CfQy5q/x+uw8PwX9rs3H
bPELvHfgxzmP0m/YfHr76eS/Wx3/3ok/w1+R/iH/Rl4o+wEX/yu975h/cHW8
9eX1qI4n4fFVeUez+DOvv38XP2b3tPwxqvvzhZx9HZjzBb3mPkO+L3tSJx/o
k70QGPk95wN6TLwT9HHQf+8P3Rri/yf9mfSZdn8p36nRD+Tr8Gtg9DWcf94j
7CdvH5XiD7B/5O9k+4f1Qd9Qe8/Ml7yX81ajE0k+znwjjxYfRXxI/GVc/Lfk
PwZGPof8kPMMZr9j7xHtI+AHavS2Nek3kF/i32n8vM8/m+iDsJufBt1f2LtC
L+k/81O9L5rT+4/z5fM3pPeq8sPb/uS+8P6RHSHe49z0nrT7Afoof5tg3x7l
b95+aoYw7XGfKX4z8Xvt/uF86v1v88n3wbzXvT96n/RlnC+w3svh/UL+YmF7
76Cfi/FXeS9U7SNG0nsGfkTvbTv/8g+19SY/OVjvP+PvmR8w88P94eN/9QT9
UIf2Oxj+hfHL/tzOj7d3mqH5gf9D/6/8kyavA3v5wjLVZ7/5/KFpP8o/zuxZ
9P6y/cd7m/lnvsf8pkKAV+l9rPm0+QZrf1l/wchj2G8+ftHSYB+3TP4IOh8T
vvNK36/PyGbv+ol/H/8+1rVx4tQJX//669OaUrytll1efnu3/yNe49jT/9+y
K/fJZq764knPPbhCv1f8wHk/3f/ej0zJtpz8pW9fNnGDfr/bG9PPX9+0QfUV
T3DWGZ/42uqLsgdPm3z9j3bqVflPPjX1P4//pU+/X/vD7ieeGuxTueT3ex13
0W9P+mV25if3+8TSxQOqf9wOn3ry5dMGVR95ad3rR291yoGXZjvPuv6LW+9c
VP33rdq5MKW+qPpv/vJPj+/1UsLKv7TVHotfv/r87MIvzJ559Ykj+n3noa/N
/9xdCU/81HOHXPDSiH6/yx2HLT797lGVT//WxYM/7EpY63PX7Xf9Y/u7s8af
fvyKXy56MMWjvOGQpmMfXJKPNznxtz+883N3K95a/ZWHnLVl6U8pnuOn/5xN
OeBuyVvr9zn5shnT7sz2em3FKa/sW1B78IuTdn5k68seuEvy/frns/MmnnhP
duFvfvTCZpsNqv5p537nnLauIeEL/vTJbx+9fzFh5uvfl+94yhV/yt7pO2OH
Q/YdUfku9+933q/rR0I8zo1Z/WGtH1l86D3ZgoHij1tvH1X5xK+8/88TlyU8
75pd++9/O2He591/+8uGt/47N8UnnPnpWzunz03z07PHGVttOlfz0/3nD15X
N2Zuijf5g4nnnt5QXofHpx1+1icKIb5mmb844Myx/3vA3Gzx7A//8vlNBkN+
h/J+OnKTk/7zRrn91/f752kDQyqfsMOeV3+0Es/RcGGfo+bs+MWRFC/ujX8O
3P7zhJmPxrsW3rpg5cPZOxNX/LY4e1Tliy/b98nnViXc/cbBRw5/5mHJc5iP
sW+2XP/dKSkeaP1e31l8f3+5/ln/enTHO9tUf+yvFl/742f/j/icF+90RN/z
T6f5WTFj4zNbPpMN3/Cbed+4v0/1mZ+xHx064bQ9ns7mnXLG1LonBlTO/HSv
2nyLeVs9kx3wpZZxx3++mL63uv28y+8YER7/h92eOGjGqPA74z72TGlRwouf
fn/TTW8nXHfg1T/Z9+pGvRcHvjr3I/XT8/FBJx9w00VbHzY/2+Xfz52w8fn1
Kmf/148eMWve9+Znx/z+jyf+8tk+ld999WHrt1szkPTp7xz/r89/uSj8vm+N
OXfSIyPhvboxm/2hlZuO3tGUjdv1/N7xF40m+fUuO85Z9WjC2376uZ9eXEpY
8Ui3e8+PHjp8kfo/tufacWN+vUj9nXzvkU+Nn7go6VN/sftZDe9ZlHXfP2bi
5WeMiD8ce+4PfjenIeHu7221y4Kh0fBeqqubOn3aDecc8GK2wzcb/nl4KcUj
7X506oV/+1oxxD8bybqfGbmj7XdLsjMPXN0//ncpPmnh6aOOP2LdqPDYvS96
bly2JMnnOz8zeeeVbcJrTzrm6heOLAo/s/kbJ2763RHhgc13OftjdyQ8ZpvP
NHz7H6PC3Xe+8/FZDzZJn7XDYbcf8YEK/2h42lfPuuEHi1I81AmNs85+obz/
wJ2XTNn/it+meKgXfOfDv/vmktFcfNQtbrnkwclvrMzGHnHuZrO7m0J80lXZ
5MZLr1lUrj/vX3t99uJNV6m8e8/Ote9cleKfPri07plVFxSET+sa2HK0TF/B
Z+5x+On39AwJT9933batRyZ7qev3GfPatteOCNc9vW1P248flL2k7DN23fpj
m79aLp92wblPDjSrnP5O+snDP76mzNecucfRO++y1SqVQy/H7Pf5cdd9ssyf
btX5x7d/0afyyf99Zsz+nxoUnrLriwv22qwoPGbrnZ65dv8R4UnHF9eeeWvC
Y1ftdOHfW0eF5Y/4jS8d89sfdGo/1u+7etoRr6zOuqd99IkbtmuS/WfrvEnr
bj5uqfC8l6//ac9BbQnb+Fob7z/wL1NSPNYJQwuuuvOoTtGzzs9s85e/junM
xi7/7qOvXl5Iv//rgxcccGif8GnbLbrrl/8cCPanxWzxlC1u/VNdZ/aTm797
6G/fGUr51h989NlNpoyE/DV1ddP3PvaYTT+S4rHWnfnvx3//u/J4Zt8zZ/p+
jbJPgZ/rvPuor/SMK9PlI7b9+rPfXqJy6EHnQ/d+ZOfz12SF8+a+vcmCgfD7
Mn165Tvfa9hvTdZ47v+e/JnCkMovWPOdb799XDFhO8/z7hx36N/3Kff/1Obf
vnzqiMoXn/zF5jWvjwqfPGGvqYd+cm4ufuyZI9tvc9RTa7OGT8/ccVaxORcv
dmrdxB90L1ur9Wj9xPRl/1mwNpu34OJdt1r2iurLXr6w+W7fu2htNv68T357
7OF9Kue+2fjQFQOl8u+7dz71HzfuWEzf27j2PZ+aPCJc9+Jm9+z+UMKTeme0
btjQlE2as2fbBffNzrpb/9RfuKv8jr5w58tbl/8x6zzjp4+eNqf8DrztuWP/
vtMd2ew79x1/8KtDWV226tP3XnRbNvlrUya+8vuRrLHjy7/5y0mzs5OXf+3g
meX93Hjp9nduuUkZj2k8fsbtDVn3wb8+btc7yu+mcc8evP0WjVndx6dsdsQ1
D5Xp7vb/3XqbpVn92leP7d/m4WzMP469+9q7y3Rx19cufnR8Qza5Z8En32hb
X+ZDTrzk3IP+mh0w7e23l/YMZJPOePWaC89vyHbe9odvz9ylks9w500fProh
e+bu0x+/dGqZ39r3sF33PLEh26XzreJ+F4xmdauPPeymBx7Kdtj68U98+InR
bOzUzX865ZiGbMtDzj1yw7/K9O0fpz5WOurhrPXFPx90VX1zNnarN35298Hz
sjGb/6H1nuc6spNP+/HLy98zL6s/vrP/Z8+szxp/X9z+x5vPy3Y+6v8de8HK
gWz2nu+54Jihedm8J/dYftqEMj3d4wd3TTjmyeyAsV8+cu3p5fl5/1lDzeXy
M/fe+39/eG2ZXzm0+c7vnTQva3x7x9++Vebnul8c++pbU54svxuu2vGtS8p8
7m19z3d9pSlr3aHr8av+0ZbN/uiDH354h6Zswr3bb3rREV3Z7GdfHT3nsPL9
v+yUu6Yf+0o2dr9fX93c3JhN/ut159x6Sfn+/v2dh17+RJkPWPed1itnlefj
hW+0fH2vpuzuS8d+7Z6fl8d/0i9+M+u0xqx7i4em3TCvvF57HrPTrhsasx1m
7Lf4F2+V798tvnzfwyc1ZcfNOvSyF3fryiaPuXXozasWZu3nfjs76sEy/Tv2
3ls/fNbCbOdHJ3z9iobye+PGRTc92b8gG3fAvFfWfan8Xti2d82/D1+YPTj9
tRP+OHcka11y2yeefKbMP0y7/u6P3VOmd8cd8p0/f7Tc3n1/H7OifP9O+vu3
rjzv9oXZxb84fv3N5ft58ksfuvOH2yzJprxyxnfvLZePf8/qzR96vTl733u3
/mLn8EDWcOvvtpv/4RezY97Z81fjbijft/uf+d9Tdivfz5cfvk3vy+Xx3HLc
wX+f8GLWuv/zQ89OLt+nnz/+Z386vC173++f/tFfyvR33J4fGpxaxjf9dJ+b
s9fK/bn0qx/6wEnlff61V5884cQy3/jho0ZvO2lldv/Psn8/tWZVNuGrh122
e/k++8nC//5n45Ly+Xtr6voXr16ZNUxZ+LvT9iqW+3vnjsWTy/fnS4fOPbLc
n0mbtm3VP7V8P3bu+uFbrmjKZj5w6SONN5fvx03vf+LoSwrZ9Kfu3669oSP7
yYeeP72wVfl90bb+jF3KeML3/+d95x1dzBreOvCMhQ90ZLudO/aSGfeW5/ek
Z2/b+lcvZRd+ZMwur5fvm7qGz25/8+hL2V4jjxxy4LbFbNwWT//Phttfysad
fue+K28v819tgzd8c/VL2ezvnPLcpQeW38Mfv/bWhdutySadfuLeuxXXZDeu
/eDuX1q/Orvxhl99/T3XlN8/77y06RXbr8na335i56y+L5v+9DcXXLZ4ddbw
s4fHvzRjIHtzhyXZDTetzjbO+eHhj/xnIJsw9b76b729Ottlzoe+Ub9l+fy9
90OHPj9/dTbzsFPnz7r5lWzSVj/Y6fUd12bv+/y07+80tD4baG66ZedXu7K9
Gv9w/i4TCtlxm8768aLXu7Jdth3d/TPH92UTdj36sUvburJJrccd9/lXBrLF
8/9w4lUfWJsdMKfl7/94ayh78+r3H3bMK13Zm9us2vusKeX7/+N7//izE9dm
s4dX3/qzs8v36XXLd3lys7XZ9d/8/h+H3hgt80lLThk5YG1Wd/49V73+vw9n
Wzx64WNXnb4uW7CkeeWO223IzuyfccixB5XpZ8OCg26fVqav01+/dsJn12V3
/23z5z9xX/n71xXOOPs967I3P7Bq4IG1Q9m4bdqWLxh9OdvrC+9t+MgXy/z6
779/wLe/WqanR1xy+9i/lvfTa//a/Lrz1mUH3fHNQw5pKWWdvzropTPOX5Ft
3PG5lsZlpWzeF/9e7LxhRXZ/6x9njr98OJv+8z+83XZHe/aTj42f98cy7jzy
8eVjnm3P6n59+fhtXy1lBxVOPqFr4ars/qbC/vuuKGVvvm9k+d//25m980bz
sofL7U99re625u1WZ9Mfm7vdutvL9b933DVnvFVe35NLN5zYV8rG/rvvg7/7
Qlc2cN9rm919UynbYfrXDzjjl+X5/+lpjxx1bym7sbn7+pduTvYBdd99/cwH
vndDdvcbqy64fKSU1W1z+n8f++6N2bZ7rf3ZM+X26+bsfuB1n7k523jepKu2
WFjK6lf+aadfPzdD/H1dV887838xI+t8YN0+vyzTD8Xj6NukeMevFmVTb1nz
rR/96Pls0u/fPmzKawuz8Ydu1X/tpguy2eee8vYfPzaUTT7qs3stn/R8NjDw
5IJpXxzKGrbcfoevLHk+m7jl5+5/q+J/sOqLu/Zd+0JWv9PtP3yt+d5s7Gs7
7NR+5gvZDt9Y8rc3/9aeNSx57IStP70se/SD/71v0rierHWPnb558s8XZxeu
P+xnH2wrZa0Lz3mlc8KybN5VDz5WKs/H5I+N/rx/xbJs2gcO2+zClaWs8bLN
pjefsCxbttfnpow9ovy9OU+M2e2i8jvxkG3OvvO18nxmHZvesl9r1t3xkQ3D
i3rL+2HeM53l9Tvm6VMbFr3dn01qHP/rsXPas4FTxmz9sTKe0DH+5uVz27MJ
l/104pvPl8p09KjlL97Snl2w6a5/HG4qZdMXbX3p1EXtWeue679+dseo7P0u
PqNu3/tuK4kfXFB30Y/ntJbEb9Rv03PzwLN/ymafM/qXbQ57Obvp79vXvbdz
VPbie520+9Zd5f3i+YdS1nDNn6556+h12aEvff9/Ln27FORBPVn93C8/edfj
zfKPqj//gZ0/tKw5m/bQv4+59q0UT3HjCc+9sc1T/Xpv7PC1yUsffiPFiz3u
3++MaS6Pl/fC3e90nXVMZb/Z+2eHo9tHJz5Z0u8nzn/Pq5tV4skRj+6Y9y/4
5gOlFL+iZd8PXXFC+f205Z47zpzUkl14zO/2/MKU8nyteev8v05ryZ752OBB
c48azeZ94KXrf/bqimzBH/7wzY2/Kd9fM/fdrX5kRdZ9xeVt48rljf99pfDT
XVdmW6z71V5Ty+0dd+2qgd1ffjkr3LlPw38mj2aTX/xtx+j712UX7/Hh7yye
NpotfmzmspteKfPRd/dMX3JNub1/Fn9xyJgV2YWTrvjbnjeU6cvcXe/oeW97
Nu/Wqzvu+m35/f2Dx4Y+/Y327MZbhuaedUT5Pjno7ZlvbVrel6cuOLPl5PJ5
WHdb/flNl2adzz64/PopZf7psyf23//ZZdnkf73z0b3PLPev8fV/fviq5dmh
hx574Z8vHs0Omv7Mg481r81e+9Sqd97zq3L/hm4/+P6eMj/57Vtuft+pbdmk
N9/p/tKLi7MFXxv8c+cmhWzyuQfe9txJLdn4P++y800dKX/bltstbO+Yk/Ij
T2k9pe4Prya87X6/+eCshlJ6P719+YEHH7ogG7v00f3v23ZpNmnDV3/yhUnl
c/qVT63d/vtLs9afL7n49edGFc9wy4mPXvToFaPZ9N1/8cS5Z3ZmnR27H3tq
GY+fstfNm83ozBoO+8Lkm45qzsY/95VPXblwUdZwwwXzLjy0Oevu3fHps0uL
stZNep7Y96Pl7/3+A69/rDyehiumZcdNbCnzhYc/cM/bS7KN5xy151vbt2Wt
XWfv+oHPLc0avn/e5EvGFrKNnf9tvf+o5dkWL//18Jm7FbIxu7ww5+LeMt7r
r7cW3hlI8W+/On3O+75UPg//u2zm947qyMZfueeiz+1RPl/XLr/05v/XkW15
yW2ff/yq8vt/z/+8vfHwd8VPrn/qrFm//ER2/ddfP+zU3w9mEw5ZueXcurZs
20n3X35zGXc/vv/UI59tzd659tkf3Vxf8dd+vn3jstasfvG3/njZfTcmftv+
Jv3jrAPrj2jMpn/vksP2fC7Fr+/+xWub77ZfIRv3i63m3HBva3bBwUdO/deX
y++vk37R8drCtmz46AtP33XXQnbjJp88bcOOK7JC33Fvv9Y1kOIpzr50+cIz
BpP90QPP7tbzSoqvfOZO96z+7HWj2cz1Fy/aeq9V2YKFS+49s8x/zjy8peuc
s8r3y9Bw/9MbUrzlxf854vtPbUjxlsdO6xp6byWe96T9jjp3i+as9dcnFSp4
8oSth9+s4GULNz390eFszJdO+saOD7+QbXv3Rza2nTOc1b++3ZVP7Lk4u2nM
bY/8zylF6b9nj2wy7YTLnsrmffB7X7tgn9bs5KUHvnX+yqeyk/+y+4uvnd6a
bVxx9sVbPbWwPI//OOuSma3Z+O4nZ53R2J513/3UqXd+tTUb27HllU9cuTwb
6G78edMPVmSTP/6JzmmP/3+yrjwuxu/7TxRFGCkVySCKVgmldAZJWpREoRRC
iAZJlAwVyZZU0sKUpKhM2vdp0b5M+7QarVMzzSShEL/r9/r0PN/X5/PXvN6v
e+c+97n33HPe57n3nlMHRqoyRXaBaHwkbA73bsD3Vwyynr0xPM1D/oDFOvvU
FpBMTtfzs+VBaGHmgRfzW8HTRed9yR0e/r2hziBOah8PyFN0dqJBAzBPO7Uf
SuDBhKjunzlODWCTufvrbjMecPgzfgcVNYCo0trtQxF4/GKVBSc2zxzB8cSt
ofytuogPOEimmnPqgX7/2MB3PSSPh7r2rhZqALndN6NaVIaBpVd1Zv2TJvh1
5KuRxuphCFWuMXVkNmH+K2F/7paN3CYI3RevEXaFi61fDSHbz1mI/0zbD9E/
7HPhhThWsu3hwzE+cAaUH2tqt0DQ2E63Oms+kONosRmurWCqFVZneZYHcdJT
D5T0u8B024fXFgfQ+8/4sP9oBNKP1eE94UN4/GTe7Ns9vWeQvnjiu6Y2A+kj
5VV9Dv0lYNF1wbwzpRScu+dlHM/igcXLeR2zzIpBw3Dt62gKDxjHF68Lby1G
vLda+sMRZF+fFC71UcwHiyNxtGyxYaAWfdvkcbYAysuLWnR3DmPfM7H89D52
wda++PdT8rNlc7ZLlECcRfXuXAcuth9UnptEONKF9Ou55Geq14vAr3sFy6h7
GEZ/7/A3v10Eo/Ycq56/+8sT+s8NE8uAcE/3wZveQaBVVdwUUyoHh2Rls+1z
8HjL407MHy55iG93tJZvlULroOIevXpXBlAjv8xVl0P60HwNO6K6BlgTh85K
9zGx88YWpw2uj7ypQPbOy9EuBPG1BSERPufLIOLUnjfMLsRHzAbe+46UAb3u
8mrrJUj/CFWf1LtWBpnxbEZfFLLPnTJBcfbl4FhalcxP4WPfJ1NnJ5VPefCA
Elk5fy3iO1amCk2BtTzQaL2XWdlWBazfWc2619H8VY8HZLlWg9Ls4KV3M/B4
zk5P31f3/sax0bZZkqrayD7P36/5Vgr5CXcCD+ttQfb7e7vXUcsqyFxFPuJ0
FekHUdun6curkN60Ia9D9omg7vLz1t4q8Lsm4bRtWz9MIO9Dtx3ZyxtLV1q+
44FMVon7KFrfBP9duQ2HecCO3vv78h0mOPfe7v+zg4vHj2M87f30EsedG2d0
T9Qi+SAZ7at3rwMV1bQEK78RrJz9o22xfTOOyQUDEh6n0fjYOOaPIXugktcd
naiM5Fsxf+nkD9Re55v6K4qIf0sUybfmM4HRph5jaYXzGUbGOqrryAAeb93g
jNOqjwPY+qWs1nss+uTf+aVGYYKedGblEHq/d0ZdTupZQKvRbwNSCTB+0LYE
EpOAKlL5Y2N9EcSsPUXPODUAGrLje92RfZP79uSSsQoXe35QpWn7iA+O6QrC
hafyhoFpmvq0+lcleBp55toPDQPp2OiBqHpkH049dJ2J/Ovp/ilsped+D8Qx
C1yrGqqHwX3wmnrMINI3PqGGau1oPeTf3z6vrRRGZbgRalIMID8oylQ9iPiC
6I+l7RHlMPr1nsTLlTVg8dx2nVQMWgdMafNLNITny6k5aSA972rizfGvA0bR
64e+mhVA1+rgqT+tA2LGSbEG5Ddn7tV58b6ICdp+TMcMI+Tvz+YmzpVG/u3F
tsf5Ckh/eO+hfzZvAeLVkO40hGnfmxhb/+aParDf1mKK5yfR2mERs/oSD5Re
5m2cx2UBWVC7P62eB6NtRov2VLMgZrJo6SxnpI/FjTJXq7YBJcUz38EPj6/s
7P+a68XGsdWKT35/diP/yexpdqAnCwI+9wd2Dzdj4+UY4jbO8edh+w3T93Uo
8W+4s5aUQswpU7WR2TygbXkRblVdCoSyc/aJXoX/ut/ZAKSAK4bGvg1QvnC0
1dSwAWs/xoBf+G0vD+O/vyL0/d6KoPfZJXsjH9kxhfN3C6/6DQI92+Vc4upG
7H4GyTrfJCe/EOjhTy78oCH7FfWqnb8tH3i0b4vX/V1PsyRn9pkUYP3VECw1
u368EOSS7G7BLFQ+rr5lwrUIGPLvF4/p5+D5mv5pn7FmR/LUcBbYrlOcrXCx
H7N/WHzEQ/IL4+npwC7yCbLjpvzr/AOBQN296pLm8zTQyymdHNnMxe6fir4w
TF0fieOIIIbOnT84pj4Jkl/tUIjpaxpnt0yhYSY2/pSUypR28SqsHDv/Xe74
pzOiEmKQXUpPGcb0oZX38EaNbSOYvpaZ+zXvly+Ona5fPqdUjeO4ydCNyVJ8
XL8fc99Qt4aH69fh/gtCHjimrv1zwzRAgNUnz098+6Ecx8Q31qwVTeX4ecC3
H3ft4guw83Xl9931A4/i+z8MUWc60fH9v+JnDoNfyGy3b/H14BfIo92Q4GH6
ptpbc8YaFxznfqk5I7wF3+8x9WRm6NUO/ev+0jAEWJ6V5oc1YvrKKCKiSH1G
AyjdsbwnXizAzo/Yakhumf8HxxHNDi2V5vh+D33y0cZvMRxsffbV5aVU6w5h
mDbKaZrswfkTc8sx8x/reZj/2hn14JbdXRxPyyv12IK0p8WtwGiAgj3a+P6H
eMpJoZhbPIw/T9cP+JNn4GHWDbSTp5sXZWQCYaWxwhYvP2CS+qOLckqAELDu
5JbYW0C4YxPoFoHwmwf2TyaeAUPkj+K59hoglE+p6V29BRoLbdobNGqBkLeE
kr4nFEQLojPnNKFxCjpqdOvmHWDT/OW6TyI/iFznI696G4irZ8szvRqBumnn
DonIZ+BuOzuA5MgCwv1VMT/s70A5YVz9OasNCEcSovvl/EC0YsXnZjkWUB+K
XHq14xk4VdSKBIp1AcGGKDPo7QeUnub2L8eRX8A0uFR/G+GMZ6GZsZ1AWPZn
eaz3M8hcIrVsGekTUMvEqUpJj4E+lHhF/UQvEA59uWXACQDXvcV3yC4Ir3h9
tNryMVDNC9fd6Ua4lB1qddIX/FavFbMa6QGCssj3kPmov9JdDdfjB4Ewy2//
TD8/IJar7Gg15aD+rjN6lXQXZI5/OHj2KSo/oODY+vIpKHyySC6aGATq4Xyp
+6zHUB5QekWdifjPRpnZCud9IE5IdnmjO7InjmK7zBQfgKvWWVV9BsLBDUcL
Yn3ASqAUUcEZAuqewQzqmqdgtPLCsaXrUXmb6AIvViAY/TIXi1FB+qzytE56
NhrfcPFDgS8Q5osZlL0IAOKFc1qmTQivUXZ8O+EP4rtq588SGwGCy3ZyebIP
VJ+ntyioIfmxJ8RtcHgKepOsovOnEFbL4W/5/gSormcLuyVpQMgdM3olEY9+
1yRuS3oN5LVzPRIeoN8FJlKjxtnI/x7LPzMnHtl3lse34hIg717te3pVLGgs
OJ23fLwOCFV6rCzRN+DeE5AwRwr5dYe1FDXq4sFB+iO5MgbJw77l0dJxiaC9
+/PeQzksYByoFFajvwWWd5aQ7a4uYKhYxsuWvwWGWvjky3toPuU3/Z4//zXI
bPF2ly1iA/XQoR/h8xJhIlVj7b7MXmDc2JncM/AalLg6qTLKvUCtjNQeWpIA
psYzRrfqc4Dqrnl8+c44YMPMdy6ug0DmHX5EN0wCUR2hDY+70fyJLs6WkH8L
1b84Uh9PDANjSNvZzSAeJNdu75iVgPSlRLrEmOprcKqp9pnxAc1Ptc3yRfOT
oPMqbeFimWEg1+m9kgt+CwFXYhuHF6LxTOraYWYWC6mR344fDkZ8clPa4bHZ
b2B8j3T+uRpUvre8K8c2DrQI2jJUkRGgOnfY+ybHApPSsaBkHuL7lwJeiCxM
gpLHHL0+ZP8YYw+kJ8QSgLBcJODNHsTXSh7s+sh/BfRbmx8khyK+dtKjpHdl
HDgesFfK/ohwmrFn6O940P6qTLabi/hmLOXE8vdxIBo0YU3YjPhySMie2BOv
ga35weXlMVR+J3ezqmwsUBOTzlvY8JH92mxqMSsJlO47ZFB90fOCy6aEkxKA
dUaCkPwetc+0fpe1/y1Y6P/OENUpBdou3XekdWlAMk8SYxBrgWQodmz5SApY
OJ0JFDmC1nOmZ8QP/QwItZAbPX+oC2gLTkQ2u6bDeOr2vO3pn5B/uWJ3+bMU
8LHdE0wuZQPD/1iMrEoGsMsuHPvyAK2n4tY6C4lUkPEzHnU15oDD+t9DCvGp
wKzc+8sXzR95+Me7vQbpQNpz/s6pbqTPK1Qj16mlQsKPeQEbLqH1o3N6MEAh
DRLSZm65Uoywac3i6rEUcDW2T/hcNgRkqaW0SXoGyCz8sebacsSfL9dMeR9P
h4Qc6RmnN6P581qcF3omFbTaWgRt4YjPJO80PEhLgwmW2sHiVsQXKk3mLMtN
hVzW7aKERSNA6ttby25NAVZr6csOeR6QxMPve3tmQDWvTDPIDuFLE6lPHqSD
05VTihUnkL/A99lOE04FTpWd6Go68l+2xvf1L0+DmKIL7TICPuKvS/w6r6YB
VbXQbq28AMh2Zi6PS1PBNpT4SccMzacN9YDholQgtn+N5dih+XldmPg1OgP6
dM/p+D5E85fAL/8wlA65kX1VKwrQ/CYv7QvWSAfqhe8PZLI+APV7AuPEiTyg
X+xxOu2P/IIDP512XMwDo9diGVc7kH7/yD22rKUAiE3R4fvPofm8m1L4SS4P
OLRL/SsXtAPNTcViWU4uaBDOLz5zDc1n1e5dPZp50HQr5ezCwX6gtQbe1C/K
A9uPAXs/m/WDxVq9ZZXCDHCq3JxwW5cDZDELv1VP8yBg9HVtRuEgkGpiTiqf
KoCE+THfDSbRerQxf8BYwgBOS9itqSjkz3ZE+vxhMKBJ3C12TgwaLyniKk5s
Hrh6/2TfGuAD7YOv/TvzfKAv1vOpk0byPcxisJ+g/sZ7KsrtFgBtvspKCRbq
b3lNTVDK3/Hq3pK6sACouyKZxCdxQFlvOrLOugSovxMntkgjvZf7NeqgJhon
2ZayskWIV2bGH2lcVwK2mzvGdpCQfzJRcDuntgi0DDSi593oB5LXjdgaIaQX
9yqonGwdBObEeZaKcTGQTgh5XD+F3vfxjNZjDUXASRq8+mEE8ddtUVt0s4tB
6dzuU8/fDwNR9nDCGYcSoGRvK9krzQXCjIOnJPSQvy53w/FIIdI3K18/rfhY
AvcPWM/7U4/m98CVbfd8i8F93Fe3RVQAGnu3JAhvK4Zfqu7HJ/UE4CCZ7pPW
VQTlN2pNRl8geWpfNrtRtAScNjk10ZqQfy28KdgtphjIG/qHdG8WIP6fcO72
cDlQH/l8Lr5WAJTxTsnzShXgHNnDLHuM9GmgTVn+7ApIEKMVDiNMZ+0YcBKr
APK+NfqB4iN/9aHq7/ZyCMpzHbO0GAHKgQ++R9LKIS7M8OAFIuKTEk264urI
v9fzqalZh/r7kGKz/W45lE+9Pn3MBck3wzbrtkgFCDc3KIvQEP/zcPjdE1cO
Bl2/0/brIn/HvXjpWyf0PPrttFOkt0DpMGtacKgGqL1iVZa6b4E5b+jljtM1
IJoc6HOpkQk0Pcu5MxbXAEut6SK7E/mpSSeL772uAU/vS05PpAaAHN485fmh
BoS3Gom8q0fy9virfKoFaq/Qx0ehcRgo634Zi19C/3fv1/6sjNb3q0GGzv4a
cDcYnZ3Sh/S56sF1I501ELBXIeZiGOp/OKnVPRPhMHXjb5ECsFj4WlJIvhZE
u5YIyy0bAEaF4OlkKhPcdTakxSwZgNFLz+0159ZDwk8KlfIb+WfRjs6h2Uww
kKk5PExG/qDgBXO4mAmeHoN3rGei8TVaLfroNxNipv4sWJeD1v+J60rupHrk
f79v0BXkA6HWa1RkMfKjXFprXgpnAct3x5RVJcK8I6LxdWVAm9JzykR+loX1
c4uQ6BLI3Gm4xly0ESISCYKuuX0gMzlwvZfQCFr3dcezxFH/xp1jYxsaQGW0
TlyuahjilmSKxv5qgPGbM5TLK4fBpinSYa5cI8TcP3dsyxekD811jmp2NUCQ
SNSXOTCC/Cabqh9jiD9/O+uiPYr47PGmc+L6jcC2zF4mfjIfSAL57dH7moB0
3ai0tDITSImZrBu/m4AoNdjnr1EGmQEZp3ueNSE+1yyoe1ICouETy5bqNIN2
Q4ln6yL03gP83qp1TUB5r/xguLYWtMMO9Vd8awK/gfGfWR5NYJNdouf0sgnY
CzsvadxvgtHgdzfmJaP2CwNVzpYKoHzF3bnmlGYgR0r8mFWN/DDvjSkfXFuA
7Udoc/yeBZnSTwKnZrfCqAY7/oZpGYhusGq4yUD+96sWE+EZH4AsrW+82rQV
nD59FqgPMpG+keg9cA7567NmaV6dWwcBhXPWx0q1Amm/8MyhqEaI236p6psT
+r9lj1f1wSZwEETk7vvWApRze+7GxnZBAPmJw+reFvBZS88KbmZDgPU8x9dr
WpE+ivZviB6EibZbK+m3WkDcYk6gkhYHKEdm/GTEt0DQuru7nT8NgfYpmcZX
7i3guMHSUn4X4i9DYQrUthYY93ERK2oZBqVP6WEPrVpg4m7sxryCIZgollxg
fKQVZIR+zXQzHIYJ1YwnP7tQ/TZn1ibhEWDd5QTyd7UC60t+pv/RESDqbzye
pNIKEZs4s1eg+Xb/zZRuCW4Fdm/YRIJ4LsQ5iwWVf0V24sIPzRVxGTAxmOoa
59GG1v2ki9aMcnC4/LXat4gFTJGaIkHbB7BQr+uaadgGFs3usnCiDjhv1vt2
9rKApJtV6tpQB0y7ecsfLGoDdn1a/8tiFpQfzLjetakNyg8QXwtv7IK4WD/S
p0oWZLbtnPDjdQE7zfj2agELnEmfNzYSPwFjVPSq99I2yF32I8WktwccnB8e
/OTDQn6jsdiHXf0QMJnF5zxngZY3RatfbQBYbp7xx0JYEDAysfFj2CBaN/qk
E3EscEiJTo5Q4oCSz3Pq7B4WNMlxh+K+ofFesPb7mmz0vkWEBIHTMBjNOvn0
3DALUhWHXZbtFYAM21690r0N5D5sIhiYCMBP5BK7ORW9z/wUUb2LGYhHa8c9
z20HwmyvzviMfGDGh8sV1rcjPdexXfd0NmiH7Jvzx6oDNH65ii4glwEh/WX3
LPkOIOpYRO7ZhOSPVfKRHNYBtAjfHmUW8o9mXMzenIDs8olRz/CXneCgBKXz
szrAOa6qmvaSDaRNh4fUctqBuUdxfYJCPzBFuw8Uv2kH52iPkqzyfuB4jBMm
FDrAtGBX6ru7gxAqOOq75wNqb02VWRryb0isBelz1DsgIDY9zvDzINjoBNnN
MOgAkvSRsVNtQzB687xwYFU7OHW4GtrpI75VHBeZqdwBVlc191xC+tWvs8tF
ObUdRM9enz+lhez5Ny1rtd0d0Pl5U+RuZR6an+zgvsZ2KGmtnSJdR/x35fxd
LStQ/5eynV9+QuXXG4NOD6P+mD0Xlkb+vcO20JCb1h0gl3Nfmq4pAE5K8Frp
u+h5p+7f3fca2T/BISGKfwfEcObk1SF7o5SczBERQuPiILg93ywflO5t88ia
i3jp5ib3BdLZQP5YmTL/fhdoTF4+21ZbDgR3fbHDPORnuhArScOlQFbOHCu2
7wJi7Z57dzglSO/HC81r7wIWp4x4d04bMLpUm+NdEAaDW9yZyJ/Z9PDF/PkI
85ZX35VDfrju+pssTSSnjPLo2zKfwA8Gl1ZZo/Zu7dF7seET2OzTvcC36gJt
wjEfkav9wGKP1NkrdYFF7c9aQQ0ab9EAkZANXeBgHfFW5AoHRA2N1Ic+d0JA
mfxLXeTfOChYujpwuuCXzXxXdWmkn1vNa9+h+jJiD30OIX7h98vNn/inE5pM
ml5fGB0CjVkXHuRldIH4in4KG9lvAn1RqTCrCyYSf3WaofU/KuvWYjGvG8Qv
bti/pUgANhddT51Z2w0ajevnNAfUACFr7C5zSQXyOxtKrz6pAbZq6ljHd8Qf
wr8/c6aj37exzxN/VwLbhpkldrMELK663bh2FtlX51oF8Ysl4FC0iTu0D9nX
sctmMVp80BiYlMtY3gijSatFL2zig/tnkw1HfzQA4YK2n+INPnCsCkyioBEY
VCahfMcIOHzeuHGpSBNqbzil1mwE2PcurF9i3AQytdFjGmNIPuaFG7WNNYIp
VyR6VQEXWPeiWFuvNIPPsO7ryAoukGYsrEgQaQZPjZs7D67jgWirmHrN0Wbw
233xIV+aD6JuVov6i9pAnMIzUDiL+FNM2gYntH5jRJ9/iFnHB4eR+JKouWh8
Ls+JdN6Iyi0eatR2/N0fX7Zz0W2EjecnRCp1Y/eLyBfvttq+zwOF9b/qOgKH
gPi0X6kzpBSU3l/OrUaYfcjk11JSGZDuvrK1+Z4BhMPnLZueliI7aZAcrc4A
UlVpRn5JKdC/vt96QZ4B1EXi5byhUnCoC5n1NjwdLP7sd++VrgDayfGszuh0
GJUc3r71J9K7BQoxynzEc0Xqi/PWV4HC5XNX6dL9QJ/HcKvxqIHq9XQr4uJ+
IJp/yYjaVQMOXj2XPBfVANNa5MWCZDTPbDf7+cPVQB99kJInVANki5u510g1
QNNgPBIYITvHknj4U7UGRg+bTmbW14FMopFVILLPDhWnnx2i1iF7aGljsaUf
KActzVacqgPRkN8DKxD/ItYHzb2mWge/hEJ4oRSkXzqYCV4aVeAkXxyx34QD
bLdT8ifF6oB3LNWVL8uHgLht0uvzakDjkcyk2WE+WCj2cDt8a4BBpqmclBmA
UFbkR1JZPYwetZccWNuP9OzPiB0LG0Huir6kCdLnzOSFLCFSAyRYadTdCxqE
8sf+B3oPN0DMHXWliqYhsMk9+SpZqRFSF19JzWf3ArvLQ42I5Ev4J2/p6K8+
YPWMuEhNNUJC/6XAOUN9EDqQf/X24SbITVx2OCmZAwF8q8kRYWTXF3z5OpXI
QTxk4vbmrU3QdyGbvEeND5nle812iiH8VOW9jjuSrxudJlNfG8FmYL7EH00+
MBtyfnE3N0G58aIjHF38fIstx2aGbhgfi3fHSRlrfsjBsV7rRcbDc/h5lun9
+NC5dsFxR7tA1FhEM5mIn28R5QqHcT7zsXgn7L1V8QNPcEyWGZ/6/SEd+547
ff8wYLXQGdXtleBuNSCa+rQfz681J/PjCpUa7Hvt9P1ZtsjObcKutaCxb32h
sGQ/9n30V1mwTI8Kft6F9ni3k9mpGux5QRO7MpRX8v+VzwxhH7p/s3gNZDI4
Ln/3A7H4dcONi02X4/nHm0Kmyq0i8PLOe26rV2ji52eamtgXv+zFz8/Q12Zf
OY38azadE7apuhoSyh8uKkOY4n9ny8+eaojp5xiYliN/ZKl0RFZ6NbB8Iucx
qhHfD1lx7xVaD+y9tGQZEpqv6A1tS7/XgKOkqWU16s8ov2CzV38NxGxetKJF
WABxHzc9SPFH9oDywfVlE7JHhme6HiF7w3g88qOsDvEDO81H8YwusHm/RpmQ
i3CkpOzvN/VQbR765DvCdG9CTVpaPaRaffwyhvrD/K3xjWLaAAZrO6cKy5A/
tU3v0jLlBtDI1T3WUCkAo91i3xQrEd++Gtnhgvo7umr+QObnRrCgb6f7NKL+
OMtvq/BG/FtBXIjORO/v5PC+17wJJmIvbZsMwcdTfPDKGk/kbxAWm4cpWlDA
s++zPycfYaL07EmrS0CIE0mnmF4FqrnYyOstBUCIORgk1TUEDhNFW1RG0Hyq
VXzS9Ub6Lc/meCjytyLSBswdo9D4pqYFHeisBdKTOL3lScheU4KNyYsRj3YQ
mW3A8AJKV2GjFXSD44mNS6vaEV+fNH3aBF0wurivym5exb/iA1SAhbtyTXgw
8nNE7Kj5hTX/ye9GWiweFbWuHOj20Y3mi0owectd+DWkRHcYk2fq2eG7P70L
sP1F5oFAveGn5fh+sCyfu6CnF8OZPc68d7087Pu+Sgbh/novPoYd14lLMFbh
54XoGbElWWcF/8pvKgDGIf9Fq4XawK/L6E7WZjRfwtXBnqvR+g52+3lBB73/
/++PdAD7QMTu/MMF2Pth+ZgbL3xYdLMMyO9qlXrj4rH+0X6PR394koFhG1nN
Otm/8ZP/we7M17Nld/dj+ytyPkVt64eHsHKrrIGNrzb14/u7tCvMLp8hbH1G
vJ5HMLXHzw8Rq2fZn2lA/vqLG69aZ7WCggx/U3K9AFjK48avtrSC9rUJlsJf
PpH2NJz6kAkJ1K9dxcVInhJFfO+9QvM/P03lrc1F7L47Id0mUWFDBva+0+f7
R/cHvK1tqQGi2cY/tEY8XygvtdiF7z2I9V9vxLz3cCd+3kePTb5wfQ8HCLLz
LlWj9cU2bFuwIQY//2MR4/XBqxXNT7iiux23GYLqi9TDWKj/IZ6qnLQW8IyL
s7izEfGNw9sWr8gpBcq2IyFfNyG+dKKO4Pq7FEbLDXc29iF5UN7GFjpWCjHf
NcfiEd+gHme5alEqgBFdsH1uFRcISnsLW16Wg9YDv61ZK3hArhU/9tmoAlK9
tHo8TnMxeRR/YmZQqMDD3p86WjRJChkGxtW9pgvdysHIplp+CX0YLHw9J+qr
K4Ctn/ssUv4D0NUcXTLN6oBwgxDy6movFu/KNf3j4q7fiA9N9RDcx+vB5lHn
YjeE2QfbNwl/rwetZR46WvtHQPu18A9dZE9LIPFi5d/7VJlXZh1d3QCZYff3
7pgzAkaOd2u9OuuBfvmQXeVnLjh9VlfNkm0EmZxe2S9f0PtWWhanExohgq54
uvoXDz9/9YF85TXiR9P4V7WLSnQffp/KItrskMFjHpYPkxxxec14KfJXT+h9
v7Hor30MUA7NHgaNlHS1RzORvU0dj0pSwtefI9v3luhWHmg0zJF9Wd8I4i90
0mcnjWD5rtmNsqyfUvh5H+omu3rWMT6GR/XX37wwMQKU2NKusJRWmNjR0On5
YwQ0nF/dV3rdChT7tDcUZE/Jy14dO7+wFYIUvx/3LxvB7Gd1xqorHeZ8zB5j
+QZjNl9JRvp/ojv5SXIzFyhJdHrO7xIYlRPdcwHJR0AsVUrXsAQIG158DlDi
YvfLrV7Y3PnhgeOJywFh3mj+p/d7DX6nkrYs4WHYlfzNTnob4lMXJxRS7ZCe
HOTsbFcbwuTJlVyxcI0Vnl9R2CjjYMnYIFau5/y0KleBD4z3kwvn7UH1iQ9n
jMshe+q27ujd1HJgDnrf5hxH43VwwJWui+RZbuJylwp+3oYn39n3uZULxFef
e+hDlWAT4rukWJUHFEqyaEN3JSjtWVe99m++yJjU2jWeVeB6bKtJyWo0H9Z8
xLCroLOFyc1AmHgjpEFZuwpM27t+/B7nggM9962OO7LvZ0S3iyJ5I5LptoWG
NZA6mwKRS/HzOXErX38MvM/H8PT4O7yV33CeWg0+S409XJA9JU/2X+FXVQHl
ytLrVGTfiAcSrl/OrAK/sfaUckM0nxsnnjuY14FchtVWzZ0IL3lZ8662DjTs
5qmRviL/4qvJJ+VNdUAX3Rkc+/d8gqHoApM+fH969MnXyRtbmeC8S7MoT4iH
6ccI2Bo//gPHqVPbB7e48PFyVujYD5mB/+SL5MiRuK1mjZCpGZlxe2gAi29g
lXdB4+Ii/PyNn3f76SvvBoGT6re5Pa4emELPcqYmBVg8QoeZc62/3MkEi9WO
BaqSH7D4ASTavWZmeDHkqqc3ksqGsfFzZH3t+6nCw3DJRHbOosJh/LzeEwWn
x5G9QBCppGZ1NIHo5t5nVTd6gbaS3wx/81X06V1qVnyB5bNkDyQp0beMgMWP
PUL7nFggrJd8Y5UOWl+HZhZOBrAgJrnY7mIXkpdnBcdjdViQIPn7kcCXj9lL
hx1F/NnhfFCSqlE6qc6CXzvHBW2IH1tkQEYP8r4nRCPtUs41Q6gcTZDeUA8E
+8t6uVF4PBGHmW7ez4fw+7fUKwfeuR7gYXFWxHlGNj+icWyhcnErzQjhTR01
y81LwWpbi9qJdh5mb/x889Zn3sOxsOJ53m8m0t9mva+XJzIgVUuFsf5v/tP3
Kx75hTKgxC/T3maY+6/4p++BYKRcendDENDOSNhl3krF7gNg8RIvnqkYkoyE
gAenrE+IF+Ll/5xPIeTIxBq3hONxjd+7NYQFXgHazm1m970q8Pr/lJP9iSFL
Nr3E4qkxZlWf6daKxu+7a2i+eEF+ht0XJLwyGqK8D8biBxKu98y8nfQciMw/
i4SHev9zPp5w/tJslqE7eJ7S+/xy1gAQpFrEJ63ugsaHPQ03FfuBujeiNWLs
GWh1WW+zDkPY7cZYsdwTLF4bNX0w9vj752AwbvJ+3hge32H6vD0h0HmO0F0q
Hm9N+PvgJsFT0OOc0E84MYC9r6gvYUvA1kE8XiPD/Nrdj+j/E18STw3FgXO7
W/a+0whffXV83vkEkFyqY6e9jYM9b/p8IoHYX33h/jU8/vPXYYVZzx+DUfC+
8KK/94v+aV9ueeGkUjyOJ7omuJGeg1i8hun2qIe/h0dYvcAwY1cV6ZP3Kyjv
Uw7xtxzGnp+r/CtbmjH833gUwWdTlT4FglZcs9tWES72PG3HU+fYx3BM/ra2
hpiOY88rVj9FWENYf6bPvxC2hR3g7IkC4lHiAtUyHva8zr7tjJr5eDyK6fMl
hJI42wd3nEBjjhR1y4YRrH1iidDei1dx7ChYmPe5AMfUjbNqryjysOfzMp3e
rfPBMXbepTmz3ic4GjxTK20e7uUDYeY+66bTVHD12HRWCNnr6fq5LQ5qYU9x
TNC891mz5n/K//EfGQuJlyskXuL5Z3Mf0eeQ3wB7+ITm1OGif+zXGzy/7N0Z
qszHyUDfvSz5Un4FVj69XkiP7fLYZ/B4EeTvSiJrR95i64cB3EeauW+xeAiM
Px3scwsTQOWg/+qClh6sPSyeSU9em/DbRGAL6cf/lujDyselfxvMkunHME8j
9HR+Vy+Q6AEBM5akQkJVmwqD3Avsa8K6kpR0YKxYIQI/B7D6Fjb9G3jCA8Ce
ddr/RHgqOBuy7E1vofa+9trOfJCOyTMj/PfLNp8EYC4iaJz9xsH+33dsqKn4
xhCGYxY7FmeWDGLxM7B4wXkFJQ05aDwOVSVnqXOx+qJZ2nJb/XFcrp8THdCD
Y4N3lLL78/F4INPySG01MJgzlgTjuzOaxtVG8PFI5dp7uOLY5ui2qrQsHIfO
qNqfMIFj9ksrdvRmPobF1ZYIz9zLw56HxRs/Zxp67h4djx8uT2vtupcALO2M
T8+9Bfj759Qed8jCMUV/oH+FAMcOl+GcO/L/ptunJKceE2bw/xUv5W9/zm9e
//IdZn/JrPxusaPZ2H1o6omZ/m0X0oH5peiMiHw1dp7Qqejs6pu76jHswJhV
Gldcg51XxOKXmBzMe/smA8/38etdeGF0Jiaf5LuDkUdepGPySeY57B6IS8fz
1z4LjD39FT2fXSHWY9KHPY9scH55YzbyJyLOhq+xykN81NHu46y/8bQnT7cS
GGB1f49HuuwgVr/8uZa4EfT/Jx4Kqa1yOa0vHQKO9aZ/+BsP5Z/6phE/Wul3
cUwIllpUVzqI/X9a3sgz7JQt3+Vg59sZjuGjZdoZ4NnatOr52DD2f6XjPjPf
WnIx7N5rMHf/WxxTdOZUphPweCsRRmomIZojeH8em7acuIpjcaKK7pMCHBP3
230OEeJjWCbs4euwHTj2jNjuuBrxh+n2p+WNdmDr6KHSLGDvW3fxaagAq8/7
9kDOvBbHMSGjjZOIv07/P2Crzcfzvjj26SsY7mXw/xUvGenLeb6/giUygbp9
2PuzTj7Sf86232sLQCPuenqqVyV2vhTLp+Wxc5djViGkUk0UYy17sHLWsj41
wxl9eL6Ur79WOc/qxzBNdr5BhyHSPzY5p25/KgYfr7OLrwwMYOWYvV52JFdE
DY/3Qjhye8pChgE2GVreX8Y4WP24k/2ymdeG8POx/8w36duSQM1vqP6T6o/E
bPy+gzjZXTEYzc90fZ+rViatWTi2uF25c/IbjmOkfc5ITiD7Euo6J3mqAITN
36ZcB1Q+t42wl4TkN4hza6kIml/mjFHfRwxMHzhYzVGx1ymAvmVzdPQeCrD2
yAELDhsW4Th0htR1i284VhmNsIo+zMf6a5o3Nmj4AsfT80VTaLyRu6oQmw/i
j0dLS91KsfVJv7eppyOwBONfDjY8x929Jdh6deDaZwxJloB4skxd8fE+zB+U
OX8npH3VIIan54MiXTn7nMoHbD4oRusel+YVQ3nmKaY3aQirf//WAEctDse8
/ogL1/0HMf7ss1GiKKxqGMMWs9Mk9G+MYPVtPb1oZR9wrML5VCw/ZwQYO9JU
SzxKgLT15eSqv/zilLw4m1UCGlGOyr0r8Xg40/n8CMXVhbUteHwcUryeSchU
MYQqVomLI/083b5c5vnNMTk4jjCSOKY3jmPRFzc/7ffkY+07mb46u7wAx6Sc
lUfGiwvw88zOk401gnI83s3JfStWvGvB4103OlllHvxvPnaaUdL5N2kVQNkn
JJWZhPzr5EiFCPtSYK25aqe+FY+fQxRTJzJHmNj3NGGBgZDF0gEMTzhf9Xi6
G4+nw1L/udS1dRjDqR9klC3cRvDz00deZa7OwXGE8UF13R84Hq+/tcOAj5+v
J2Sr/LS9FQys0ZNHor40AGm76223G6XY9/Jpf8GPdv3MjvB6kGEnXghF/il2
v6N7yZmJwngIOCdxxVivCajktIget1DQvjCjynFOM3b+nR4qdseN1ACEuu6+
MYdbmP9I8vKPLzPMwb7/TPMv7ePcaxEvG4GSUbv53LUq/Hv98VmCTZYfsPqd
5T91ur7+N1883eemddq+Rqj2+v2t+TMPb3/M6d2zpkTsexH1kPSq53lRQP9W
VJfTi+xm26Lci1oPsXLikJr/GXEGhtkxdG6yVzGGyc29Jivtc7Dvu9P9n3gf
vaGxvBmz59pZFePb5ZqBFHMha2ZrJfb/gCnLqLywD9j/WXLq7+7F12Pl03yT
/O2N/7OwZhh1fblqaRULRruzAxmsJqDMedfKOMUC5l3be9YbW4ETlcT60TqI
tWfFOf1Mf8bwf+4rOAQ5z9dntwDJYKw3a/17/HvYvI8FRgmx4D5ZFdT+gQXU
kKgss4ZQIHElFuke+5s/qTrBTIuBfy+LDWW2iJZg2OHj7JtDlIx/xQNC8+eW
eNNTohUslhxqk/9ZidUPyG1IufewFKs/LW+j7x8d2L2MBfQNghnvnOv/ld+F
CU5Lji9+4NoKzGUHup+9bcXzB181fW6X1gTMWvZ7wgQL06dOB1hJ+/xb8fh2
ic57n6u2gtEqe7fyoU/Y/5vmGzGfnez9V/97QUY/3CCc0wqjcRPO61oHsPqm
2mJbX8f0Y/Wn9WtA5XHXjPxWsPq4Svd+CQerb3Fk/rDRniEMd2r+nL2rexD7
P+YfHlMSNvNphZJj/cYhysN4PCTavZPBz9Ow7yHUZw3iHa4x4Jem6M2RRH67
+P5+yRlPgX616NS+yA5s/WmIGOhbUVlAyHU56uz4APs/Fp9qhnqhuU4bsG/2
E8kNhVg5Wfmhda5GDna/fFq+Ha6vOnhZuR3o4zE6tuuqsfrT88dyvceOedeG
3fcxypOd6WPSBqMP2PFSX+qx+jbhVmONN5gQqu3ybtlkO2iY7ngzt6AWjBQ1
XU/d6gDWeZFZQ3Zo3Sy4miHS3A6ipFnb1D41giix1s3SvwNsNL/pFz5oA87T
RMWBmR14/LkHfef3rGj7J55yF8h8o4/J+rUDLT3cLHJOH/Z8dkvatvaF/Rj2
c3foEBft/Ve8pl5w0L938EZpG/a9YcJOcejuPDR+jU2nUzoHsP/HHZr97sa5
fuz/mH/11Sydao7GJ9IgXDuFg9WX/CTt8ACGMJy7QmtZc/0gPt6hY+/TtLn4
+H7qKbCPw3FfReGcNXPx+FFxlgeWbNvJwzB2H6RnU/Sa4+1AuD2vWWKPACsn
U2LE/eRSsP2l6e9NbMUFWk6Snfh9bC+V9R4EJE82NYf2LrqJ1ScbrjU9dZCB
YYJUpLoSlGDY4XbZvX3uWVg8hmn5saDE8Iui8HhVmQ3q97/c6wCLrwul6m9V
Yv+nfRhQv/C+Bu/fP/LFjqVZb9/UCQ5GKpRvuxvx/rzQfm+phPSDmdFBokUX
UK0Wik7urkX87Wzmw6ouzD9yv2afLH8NyU/ZHaqdXgu+v1ZP0NepbYLQDfu0
sgy7wGFJzc5Av0bIzOkvqvrUhX8fG6FVJFzvwPQLQTwpXl6nE+NjE2rCotZ3
OqApMr33elUf3v4/8qRNsrgR8L4T3IdbJ1fEDGDl2kcvveHZDGJ4Wn4cHK/e
jt3XAT7wwDFRbQgrv59My40MHsTGd1p/cNKUn/4qQ+N79cRwpzwXq1/yIjkw
LQzHpO3xU+TuoX/FB0N8zr9iaSKaHwuTMZssrRGsPvOB7ODFABzHHNfxa+f9
D+4fmLyvycPjb/xjb8o5ZUbtx7uAoG+S/Wbne2x/hDrzzJn7WgmgNPf3UEFP
F9DcRd/P0WBg5Q5Gr3YNXC/GMDnXwTrVPPM/8cMomWvVtg6g/1O8Ou4tqcTq
E2WIplHaNf/JD0mxDXbu3tcNflfCjT0cGrDyafsSZ0ViBp/txvznUbnB7ZHG
3UBgPbz69jELe/60fvEj0Ykv93bj/PzrbKHm893Qt27mic9FvUAi7bvmktqF
6Q+WP8PgZmIXlP9YPuuT6CD2fB81rYZHZ/qx9qftifb2nz8DiOj5bZu1Z/dx
sPq/WCLOVjeHMEzLz5Q61jeIn/f4Rx7cd5SMHtXuxvxlmeSFsvffdEFJhH+p
4wIu9v+mcfdu7zs4LrFPTmqf+J/yqeAKnw3DWPvT8qLkXnzBUQO9P0ueZrAL
ycN3CmVqohOcFxyPDaOPYPERmnRs2velC/71fgLwS7pxJditG8gHn8rtKHoD
hMCzigs8nyHe3xZ6Kz8RCDnG/mXDT8EvU0SpfKcACHT+vvb8p1AyLnv2LBXh
L4k7LGY8g+rynvHLiohf74u6wDZ7DsIqif1EK1QeqeivGhsOpChbl9ua+UBN
uXF+7+IMMJiZGbv2+gAwfh79WXm2AvyqVY+t8R0A9v4abfHEClCabP79Yx4X
2A9qVP44VYDr1JbNiyW4QIvLP6+XUQEk8k7F56sYQO4826/jWgOE5b29O5G/
TOO17Ao9VQNsp5KF5n4VkGllTVpXxgSN+3cObdfrQ3ZNl2QmUw8+hzbyPbb2
ATFuVk2Cej04jrdJCM3A49VXdxRNlvxGfOBdPGtoRj24X98ChqZcrJw076Gy
exyOZbRlNX+qtoDG2vrvbo0NMEoSDzCuEGD7RZwf/KqnCFPfJWUIkRtBT98q
2yVoAOObTbQS57XGgxjurL2xwMUb2bdXTQbjQs0QUaOeo0njAPvSSxVtlWaw
qcqyMgoaBubXa1LpX5vAYLtYsrAQF4ilxs5vpZpBr/ZtvdizEWz/mdPhWfG6
H8fU3KLTBQ29IHpJ8CJWtxWIFbzBEtkRyOw/sjPvbhvYCi+ZUys5Au69j2fM
fYn07JLUkE3Sr3H5CfNfKbm2FpgLtTrrF5ZBXKZw8dYyPrbfo6c40CMyF7+v
yZl1OXKFH/K3HXv0/dcjf0TMJJ6CsFM570KIQQNwWuOCDywUANndpKBPqQFU
XlxaGqz+N16Hg89qiybgfC5MDlzHA5ultLAw3yZI3Rt5MP01H4sHQh6zV5Qf
wbH2GY7TrHg++LkmZ8lRW4D2R7GxfrMAmE7i/S7eLZC5MO+Avo4AlPS/tbjG
twDTfpG65ygf26+WaTwa+OIVjoVvTC0pDuJDuVTsGTqDBZwjkfIy6wVAvMaf
uTyDBXKSZ/ZeVhGAg8tCyUeVLOCddSLxZv49D3VpXr5TOxDX9Yt7WfJB9EHq
2uKodpAZivN9F8X/J591O1B1Bx4Lj+KYoT78aIE2HxySbVY9qe8A0xdZ/uv0
+EBXCLszltoBKnv3HIy5ywdqfFR3zu8OoB9WqjPN52PrXUO6xVlDGo+PYpQw
rLZIQgAW4er2U3ORPk96MiTekgCE/Dw248p1oB6+rbthzlsguClvSkqg4t+z
ilVMXhTfBVHTqsmTxXws37nKsuwD9pM4LknM9J+rhMfT4ugVX062xTEWr0Yj
/t2F8iCQe5z6pV0f4ZBXKRa/b0OfESVngxjCaRGFul23wfXtwSM64qj9qUJC
dEEkjF+6df71doSPz3XWuRUGPv6/clfpImxpX/Ft9zMg9a+dewbJEzU9huLR
G4nHp7aIUfuK9JFPYYOeC/a9OAxUqnY2rE9GzysBS26VP+Sm7FILaUTljgee
CS0IgpguVg2fhsovxu5JdQsCqv+BJwqhoeCgMtegVzwPfD6zon/dRfwgQNHn
QEsRJGhvy/alDOP5fqWquXl1Q0ChPQu+31UCERSfyq+iw5gdtJXdHlJ3Gcfk
BR3nZllmAHFg43YdyyqIGb9YLLSgD0ipdQtZ+aVgNP5s+1y5PqAs6fRiEcug
3HN2GVmmH9m3daLfi0vh15f3S0bk+4F6hkVRGyiF8j2GOno7BrDvJdP5C2jv
W6vuLCoHRz/C2bdH+vHvKTcUFjv59oPDjl1SPm/KgTLUtii9F89X7q6m/3bd
Kg6GRT09MrdlD2L6z6nOOn9/Hh8rl1ydonCJgN8vt9AP/a52E61PVbVf2bQq
8ON6G7T4oPq3n+jw2quA84ERI2woANLF7cue3ayC0R2V6x/MRvMR9Dpjtn8V
CI8yb4F+P/K3nhkKzW+AktvfJ5bt5IDFHbqbw+YGiCjqoGzV5GD6Vs/w4K4D
x4ex80UT+XDGdmIIyKF3lsfNQvo9Q9JpcHII4vzMu3IXMcHzUlvYFc9h7H3G
BbffcQ4NY/qLZbetcHPvEDhZakRUL2+AIP3O4qiuIXDP+7nt8+EGcGI1lyx6
y8eeZ3rSizPAxXE53U/vRCLSB3qpn3U4dUDX/BbTeh6VX5ebSVdnAvnlQ8tR
DWSfE9vMFWcwgW7FfBazQQDslDzl3XJMYIxIXpX+xcf6FxNd8uJzJo6VrH8X
yB4fhIlV9XmZMsgeXJ7ZvO7IIJBfuXyLXt8E5dklvbd00Xw5ta8wOt0Mpuyj
2y4bDIK2caqXqkQzKLHOWwcW8bHzP9UF179u/nuf9R9s1LTskeEUH7Mf9+Wl
X6Rm49hgMmLJ3VV4/DfXtWI2413o/f4/vzryH3aFLrjlkQBx2hW8HsSPqdGB
xw/VR2Dnd6hNzeM1j0LAXXqowi6jEzu/zd7V4mYV1QVy/MvXd0b1gEyNgdX+
BYgP2UaojwT2wKjTYbfoDYgPeU0aUmf3Iiy98JFMN75/r3nVNrfVG3jHg8k2
8/7qn/dRwh9OAWHR4oMPZRGOmb/ilZgrNF3p9U64OvSv+ONIfgLviV55VQK2
V+/EyhoPY+eB5IROtl427MXO79gOdRK70Pp2UJxpNlO1HqrlsiWtxRBmNRET
lyK+IWK6cfWPv/EI5DIs3uD5kOL0TJ43mEznux0EqkbJZrWWRhBn+DROiXGw
8Sdk1nkJNcZAaDX3s/a+bsyfCZCjfiIOIf+q+2BU/LFebDy1e5PLJufi8elE
K+aSfSVwPsJ0uFxWX8nHcPl+77YliJ9M5JG71qQ1gK21yuSav3wlTuTweGsD
BNy79dJjgQACtl3cJjjRCE7qK2RGiGj8upb9XAWov1rNEo8A/b/4wQGNkHog
u/3s4ogIQHRu6wfpmnqI8wmRPyKO7CV16zn50kZwth+cl4PkS3R50VjjeCME
dF8v3eiB2qv4219/kDPlSD4ME2D2xXWsel2X6TS+ALbmrdHVPjgOlSDONlbH
60/n2yT0XblGpnrAqFgl6+LBYUwfTcuH0kPRN6/X1ENTqUfLs7/89bDaFtc/
tYjnlLaq/b3/u1c0aMP9TqA4XFWrlEP2Pd7/2PtnnTBqPWhqzxRg58F5M58F
5yPMPOBQLLGcBSUHbVoCEZ64U0/WtmBB58Qhe3c0nu7ZV3RLm1gQo9ArF1Er
AHrwLOK5BBYYvG6uVk0RgNPb1i/Uo+1QQn7/am3G3/tyE1LPR9vBlrnxrDzC
DqpxlYsQdri6a//WiWIYzfzZMdVcAQEdLhenvlUDJeFTyvbPSN+uiLlzVBbZ
j+HKLnhTC3rPyyYPavSBw2ryN//VTBC/nLry8acRCF2cvHn1sWYgShZ5EvmI
7yW7HMnuQX7XoW2f9IdHQCPSfe0d0WbIjG3JepPCB+K4ah73eTMEHFRpm3cB
4UmiYRnCEeWOY5vQfJNtdiuONTdB0PjxlSJI/9t8DKx7/jcfNH9+g7O/AMvv
ZKrmVrRkKxqvywf1ssRawWml4vODiI/RP2v5ajJawSBkQtr1Rx+MjnqlnfxV
BVoDcStfPRpCfEW6UuDOhIQ3y2QMngxh56sI7hsv3dQVAMWX2316Sz3GN0iB
bu8mJ+uA7DFqWeIiwPMPuXgcvjrvFbZ+yS8efPMdjgHai7F8tTqE90RUVWbE
gIbhVplmywqgZoVdMN8XC6MfFpu5hVUC4QQhc8V1hPNKrvalIWw9uNHB7hW2
v0AOrtkU8XYAk7eAaJc37yMHgFJ8sXMkCPnJzIDRqugBoN6xTFtWWQlGF69Z
WOUgfyhCaLbnAjSPuTnhPPoAkBeyz4/drgIn4rzNO7uQfb9X5FXPQ8/zpnZ2
x/qDhmu8/vLOOhC9oUrYrdMHMjkXVdf4MyHT9eNPysY+sHmzJpMUWQ82xWcH
Dsn3gfa1oXnfjjeA6UyC1JsTHHAai4pc7IXqE+2SLG04oHQp2Xr2hnrIHVJe
UzLAwfPTvRNZbSXgAMdc03Q0AvF50sX7FlwO+N36YC5SgOzjj9k7K9gcQM7W
FgtyA1S31g63fUL6q15NUmZjAzg2qfkWbRQALWrrVskfSF7UbUpq7HlA3i/7
Nli3DMh3xr6P01OBdMjpHpdUD0YRr0Z+8ntAw857jufWFggoqpIPK+sBcqtl
8dQxxPfjdRdt1eZi33Pvk/YQjsTi2OrjTEM+jwt+Nl8bOe6t4Bi3x3LxFy7y
L16ZXjrUCiqqxzf+1OchHmVNyIluhdFupYyOfC5welXpCyWQP7Be2eoYiQcy
T+dbGKxvAXr0IdkHjdXAJMjoRkkWAfEulyb+E+ntHZnn9h0sAgvh52Xq9nV4
fiKzpSO1Mcg/epPhKLupFGhTT6L8X47g+Trz3ucKBDjum3F8k44n4vcQrvgp
rB5CT+TWff2M1p/5kEiwUQP4RC5ayRkbgTi3izl5ag3gbvKx/2MM4p/GTtdC
jZvB4WOSanQ84iPHnyxjI/9QeNRhtYk9F7PPjkpXHVa+Gsb8S7lHR0mb13Ex
+yLpPrLX+CaOaXXX2A8aEOYt1uy+1QQUzp3+pZ54PirhpMct26pwbHSKcXY4
AfEB2Zkmiz83Q2gHMVsO+V8aYwXbNEgtyO8O9pSX4gPH8kvDJ+RvdbZXD3Y8
5wND+siPo5mtcN/4HKGZhvydSYWvD56j+akVMbsjjeTD0vTp3cJObD9Su6FF
sNy5C4SN6aNPb/Mw/4Z9oESL2saF0PMOptyKLohYuu3HhbU8YByyuzV/MbKX
VXvEFQLQeOYo3HLU74LOBeYdIedHgDKSdUs6rgskxVWJOxDmZHjbX4zvgnG1
yMi+pXwYve72MPNKJ/gU5wU/d+NDXJ5XmwDhOMKXS82TI+AQttD+2qouEH2y
r9rmF9Kn8xX2kZZ0QVz226FSdfQ8mXWdt88WgZOslD7j9AgQQSZedqoQyASp
roT1qPyUS3DTsyKgnUq+bpaP+ClRfPYOjVyI68hf7D6Li+RmyeX4uBwo2bjm
x5llXGDna9+caZQHNmK5u8UyhoCo/bCTv48BFhq+67/v5GL+xy8Vb3/LeBz7
LKiMPr2JCw77s20eNxZC34HeC4v1uRAwc9BAcU0RmNLcP9bt5wBRUBS01akU
hLWO0nzcOZh/4Bx8YuiA3RC+vzlV0ilVxQHaXF64C7sK+naoJbsZofEKmPJe
2Y78mcrfr+b6Ir5vrD3X6nQpjG/Urn2G+AiJW1kZa1EGma/XaAaj+vQYrzqv
TuSvpAR/I99F9u0Ua3QithS0RUNVn9wTAKPKdt8eyTIIqlr82NTir31pMjv5
shTYxhJFUeMjMHp618GZwZVAv5g779K3EWCMS6R15FZCboK6fmEa8qef8vSW
nqoEVxsfE2UKHygbF5ckna4Ex4mp1vNovtgtLumy5VVgq5t37xTCTLuFyy9n
I3/j9GymCfIPSQlOwotolSAeclONiOzVqNekkLBnJWgVtmqmI/03ze/1ngqn
z/+O5iNHn6sxXgt9X47lOt9B/kLI9Tln1zDBIp+XnGDNw+oTjh1wVIzHsYGP
R8ovGx5QPlzc+G6qDhSMNj3S1OFi5dVWFxqdYnCsYqP0ZCZwgXKlLbijoRZ8
fjfrrtdD5c80r2zWRP8/92BwJpkLcSr+sQuVmKAiffbymC6ab6+G/AOCOsi8
nkSdGTSCtedj+vpPXuf/4JlHrn16jex7/qs90p21oBS6+9oNtJ6JsswNlPV1
4ODLLqruGAH6nxO7h1rQ8/4s3SfnP4L5IxSKzxcRFo5VVn01PdGL9JfibyMm
1IOD+Ir5Fuh5MgqVx4Jn1EPMOnWJF1eQPihz2/N9K9L/2atNw3f1AitVXugG
rRk/HxXVniS8sQLxoIDMB3f6MPvtvmjS1qmkD2i6p/XqvSoh5nxtg2hNH9Db
nt+UKq0EagRPwVUGj6dIPPfBqJc/gPWP7VH2xBr5s6H3r3/pVayHElnO3SsI
04RM1FauwPOzaivwXOXkGoCzIXe2FHsA09+eh8X2FtxD+niOVtXuJ/VA/Rrg
q84dwsp9PsZ3Z7sg/iIwP7diawNQ9w54hARnY+uTvfLPOOUcHdk1l8NeHYXg
cL7TiaxFB40VdO6UUBFQDW3f8O++Bcb1J9FrgopB1J3+ckoV+XMNvI0Xz5aD
lcT2ISIFz/fIiy45EXKDi61XvZ+16ZFySB/kPPDwDq+EoOM+Z8SUkDyUpK7i
lFWBeNnVSroiF6gmyafscqog6Nii0sr0YaDLzLmy4kQlWFnstT1zFfFnNfPm
gJtMYJ2AsSrkL3M6At9mJDIhd9bu1aK7uFBO+xV/HvGzgJYXAaxrwxA6V2N5
P+JjvDxTyPEYBiUXpwPSC+pBpdTU2HojFxsfJ43YMGI4jm1W1lOrkH4iv1FP
7CpHfK5n89At1F/Gzomgb/oN8CvhblQzwg5EhYg1yP83XdHdaHdhGCaS5Zb7
ByA+OPCGF7WNi31fMV26rMUrAcfuirQxoQ1ofP58uxmhVQpGt8UVbTej8Vjb
5t1/qRRU1uxUTqIMA7l6kYd8QClIjpwPlg7kYfZUoaZrQZ/ZCDj1pRyj/uW7
4Weoy3g80E5adFnkUTOQz3inxd0egfKN9SrJY83Ani3S7XwLra+UXncV+RZQ
aG+uSHYdAdHHbNqZiBaQofnfN3YbAfLc86+fPWiB8feSKmauPMy+Wm2OyMid
g/y3NUaMHvMm4Nnyep+I4vEoVUIKtodUofHQNb3ibsICqkhm1ZgiD/wK0i5b
W7PA586YnXEOF2z4300a81ngN0/1tCaBB0bvBZObgtqgM0rHtPXZCObPVJvs
vxY0huMApuapuCG0nlXHnfexWOCqOibNFPyNzzIQEZXCAuan3SoqXxEvUXpq
/3RnI3Yeh5MW864U8RfRHPeAgt04n4z4f/8L4Q7LiTO/kb8o9aaDURQLhN0j
VDmNHGAcb96/xvo1OFgln7kjkwNNFqdspIK5QOw1Xlm2oBT8DhZ1Z7xAfO+V
VLOaZ+n/cfXl8VBF7/9TKRJFIVmilYpMUlTyTJGQSqWSdWxFWqYSCjWFolRD
RCVGiGQZ+87Yd8Y+GBr7YCwVoYXf8f18mvm9Pn95vZ079557zrO8n3PPeR7A
Bqr3HC9B9vDqR6UzxHLO9/VJ4fD2ho0o3o4O3vx0ZRFH32npXjYeQaWc8x6E
kpd/VFKpgK1WTcuorwNcxux5qwOFMNstuatvLQ1wFeUf5rAIU+pe/OKnQcx7
wR0jKY2c+FlA+kXFfDR6fnrakxFWHXhLhZyLQnyUvGLimsTWeiB8uK+5yZAN
tG990ycm6yBk1tf80nk2UAa2Ot+TQu3bxi5uQfadTi+8VySDnif2w+FpBJrP
r7K2AjP10K/a23+jAfnHI9W1d8ubQWU/333XKsSnzXlMyrej+GrObEnIC9Se
gIl6UtMMGFeDFzTfxXxEo1+wrc1QUW0Y7bMfxRtv7lCtNVpB/m1c7eEfKB5o
1CWUqKJ46/4BnZSFPg5//refB1PyMaimo5Vzvpi+9V54elorCOwe9CZYo/ji
2IvnVxDfw4o/MGgxRHi//65AUcT3ynh3r85G+hZY4LfraA5MLrl+zl8a+btK
757ZzhxwU585vbcL+SuC7jrlhlyYXO57uwfpE1Fga9+RxBzwtt44t4J/DMin
eQweDeUAj/+j+Kg0Ngj933xRYfYu7/1r9lw8Kb/RthvJB03hlk5GOpqnG3My
V8lIPoIVH+rLFgFhP++7OFM2x95eq5sP0ovn4rjltFeVp9mANbYSGWAVgmn5
C+Lns2yYvOfZksBbBGq3Xi03Tkf2Yd0JnJxgMeAELU9sQZgmms/byF8MzGUd
E2sO5HHqqxp0X2zRXDyv/W997PT5+/NWA8By99I4jGnl+DNi/66M6XuvwTvX
xcPavp+zXv7v+yOubdfT71VkYFndObbiPLceguETwQfVL7iYb72Mx4UVfZz9
zv/Wh8gjr+ffuSdD7mben5kmA9z90f+9P1liUgAnmAJYEdwmq+ne/6mP2Ae4
R9eTVdbmcr6vytLDX2aeKeS0M6vUL9zNowKGf7nGAwabs7+SYSNwJUh67H/q
DSL7FsGiXcgsBL4L2/Pjhbl1sDFiS0v3zg5yccb+pFPZ0UBxfmAln4fiTe1D
e8oO93P3x/13/YbPJY6AfdnEweQZQZnFOu//1rupge9v/JlsAeIPg4HIT2+4
+53+e72dR/1ulbt0Diby+fPoF7eDQbtcXXRp3f/UA6NBxZkDUSPhHcBqO2v2
nt3Eaf/3vXo2yfyy923u9Wrr0p7FfOvktMuba0ls6e3kfJ9nWj3NdWBQ0Twl
h9ocSuHIM3Xn8oyPs8Ugq5CILQqhAj7jl36rNYorXxmq3DtMBbbwLudyoXFg
JhC9fuRT4c+hst88eohPf9n38+h5KpBirHdlIP/z7346P/gPhFRwcYzs5+Z1
eoi/KbTu5HtPhZKbmh0XXyJ9k/vQX0SmQqp7Ym/+eYRZP9gkgUJo3jZzea0S
4s9F23jqv5aAwabES4VbER+U7eZrsysBBk8CWeMOit9Wh327OF8C/T079izW
L/oXD0euNF5n0svFQnZfCrtMxsDA8aT0vfXIDlesSbtlifj78MlTbQalMLts
RfQRnQag/VnmnLSzEohzrrECbxtAvrTtDV6sAfjuMo+WRDcAViCir3BXA0ef
jJTSJ8dcWyBGMbW3Oqafo3/k30XxAUvTgX7ko9Nlvm4gzvwQ7NhLAbsRnjtr
d3dzfi8k9+KYFcJxFro2zyv7OeuppsXYz88R/50sZ70/jOzllCvN4dqRCTCq
MlJsb+4AbHIGzUd9AsRzVk9t513cryN7sbX7DWCurxBbWeG1uN/zUJYmETCO
Z5JyRZ8DprChniLqAZi2Q7uoxGcgf2vHWeXT4xz9Z1dFGyp4c/G/85SYI5FP
Uy+RgN3626pqMf86rc+qQdsbrl11Zts8HAG8m/OICqsIxCsViPmInxEKfrlm
HC5HduTEy4H0GKDO/mSleFeDVNv5kTPigzD5JTT+mlo5EJK2bB4dHgDZgCAM
BKH4Rwonc/TMAEy+0ThunIr8o10qiddgAJhLMpf9dqOBuNPHo73bWYDv0l4m
SET8UrKupitrCOzWGMtsDKFBf0fGloxVI6C2Q73ILpIGfJoxbr8dx2E2JaRb
Pg21Y0vbUm+PA0tIRkLRlQapZumD+++PQ0X5dv5c/hbwvRazbt51HOzO9k+8
7m4GInmNIZ95EKgZ3TnYXd4F1/48W/9deYJ7PsrnvjTjIxoP2YX+hYmrYNAR
FdeI4j+Mup3DaeY9ECpat0rz6zhnvZhjL6q2NC/d2Q0YrRcUhbGPELxY7lkF
yQOtep/wugmwu35yGyOtEYJ36S4MrZ0A2vS+cuO2Rm79as9VDyPxTwGjTB2f
W+3FWb9mX/9ZXbX4/ZAv5m8ivyfICqy9vO88wrJWhGFwBtlNfb4Wj5H8GtCx
V05UgLrgt6wfpf0QXCG7xuRrM6S2Zn0z80b+O9Lv6h5BZL+any4tOoh+T79J
P7rpPOBVlO4p3UPYe/F9LIG+6YyZKqOfw/f/E68gf3KkZs4di7BPanZhH3d9
3UZppsaXjvAhx6Q1171AfRYCFhCfwFw4VFrH9wCIPR/u7qRx19Nxc0mqn8ej
AKPJdt9rWQFEP70XXRFRgE1o8Lr/sQLoIH5QLLqZEz8aFqYb3+Vn/w+fYEOM
wZqCRqk2yIVbdXZtiJ8OVK4IW9EKKpTyI34tbKgA6e+8Qq2gNbVvy6YCbv1M
7/olLhEjKD5Xal3q+x7Fi+sGg+vYY2B0Yr/frqIGCH44WucrMw44yvO8y2zE
RwZ7Vht0sSFzmXpovWQXkG91iXgg/0TdyisXsbELtI4L+75isQHzaNLPh1EI
AfejMn9aI36i+dZSor0IHJ2WOJw0Rvrzf3y1ECIHVddpUIc4/km9r17frXYI
MMS1T6IOIb7ZmxJ12mMYiGkVBDEULzN+aoSnbx4HWsmulxLFdeArd3LFARTv
Unx5tljo1oNdaLlqQ2Y/N9/LrDnv2BcqMPPOWJtN5gI++ao4xSQViL4qgc+d
CgAz48ES35EK5EdM3Y9FBZBamXVeTHQIaLqu3w97liM/tPeh0MohmLTY/dFY
ufy//noISAFiK1dOlUNk0pXkBeNBEPo/Po/m69D92hNWg0A6m+6sH18B1Jm0
rcfimjnnaTNJHTbPh1F84HMjwmywGUhZ65NGFcfAZbG8PX8rELfY7viA4gNi
xtHEXzvpkJtpaxGF8KTDb4XbWnTAbL5E68E0cuO5bD8im9kAFdddljDQ/E2G
6s59YDfA7C1ytntlA6it8OCZ0moEnZJvu5gPGoE8ueZsoEwOZ/zJNb/wNfgs
IHeedY49i/jkScdQT8TLOPytTDHj+kEWeB/sMvbMbASe4tiZBFVkn2rU3skj
ffV21J/7tWhPROI2wTnkhz981f7pjvznS9+HdNdmEOrc39pYjPzZ/9VfR/zZ
+2988+pATnzwT9+FuntLF7A0oLyviBF3Z3PGw7dsWMnnE5vTX2rOw76M2wWc
8yj/tVOAYfFKOszlgbfl/k15Y2zu+ZkCfZm8BW4+Ab47F8sYL5H+DZ4Up5y6
B9iTO6pWKpVyz78wJFIwDxG/eh89k3CqAK5951XCofhS9gvmUHl3AZDtecW0
xMZB9v3VTfXPUPxElH/QbTIO1Oy5GN3liG+n0QQ0/MfROLuUbd+fAxRlShkN
+XPmY6ulPG25gFPWdkohjHPPB40LxDUvoPh1ofbo4KsCoBR4a3QtLPLz6cw1
fgWg1mQTZYf4BrEza7rqB+LDd+f/dPkhvoeL1Em6UgL0cmXbJmVkfy0YX0wv
oHk75tPghO5PoflKzu0rAln9Ng/Dg+h5T08yRT8UgcHV0zySRuOc8RBZiz2g
twHxC63y9zHfi4EiOHrCLLsNKPiJJwXS5SA7rFelEZgGJFVbDekkBjD3non2
8kkHb+YKreQehPNnegRkUwFPfXPySXoXJ76R/X227p1rF/Bp39q49Gs/kF0K
WEmBDAjx+WR8VXOAs//uX/wTs5vXX9irC2bjqIW4qCagCDnvWtVXAuwT+j9j
yha/Ly3q832gsD8s4wkb45y/x8/Mfcv5ysUGV4uUMZNovJ7Nzu4n56H5mZAh
oviavPu8zwvBPG59aLNXvJpDRaB+wmnHgZtjHHlvXrHj8VsKF2c+/3kh6wcX
Y7tEe1YvRfL89vJFKaFiDr+hnn0usmScAalJA6qSiB/9Wz8ntV1YJSI4yukf
zWwwa8dtLlZx8WPK0biYc97x4T6cZGo5+J41rb7mN8ixZ//Z/4zsTV0i2V2u
Cowe+7wOFxvl5r/YKlPRsW+MY09rJDY2lLpxscruz9nfirhYzZoanrt8nIuD
27yf6nCxjdEdSl0Ntx7C7PTr2CRpbv3sf/EHMXL3e3GBas7+oMnTP75i88oh
IMvgF/HZBPfcTU48LqSIi93y+J9m/OJi0q238h+DqZzzPFN7tCSHRPo52MV2
LeZbGLeewj++TzbLUwnRpAG5WSeMIZnE8Ze4lDuiI3qRnPjmP/tbkZ085p+o
fBT93X3j9GnEY/+10x0WIveNjHDza10uO6NWyK2/oCCkurVZgFt/W+qVtNyC
M7ceg8iZcIeoNC7+tx+BWOT3kHSJi4WkL+s9cmqAqWBhusfifoj/nudh0fEU
vmIu/nOmRwj/gluPQcXqTY6HKrfeNd9Pr4TiPm59Bf3N179ke3LrKegM1Xpe
0+z/n/2tiI+zJSHLsRtIlpad+WPcegvMsfAfbieQXT2ddmLgK4rrzF8GVieV
A+arQXHXuwAg8NdfP6NLA4yJhhU9+DXQnzxrvLmrBzATS7LojX6Qa2W0Wku4
FzA2ZuWUvACI/Fuzw8gYtauu/yIUHgZuZa+X0gdGgCgk4RtBfAsu9kMrhbaP
AsbMoEkoIRAcBQ4J61xGOPaJxINOP1BTnfTfqzcCOJuZ6zutwiFzyljswFv0
+6i493uEQiHTzT1aOhHxjYjH23w3vQaB6I0vnm4aA0zWsNX85FtgBxat9L+A
8Pz5WcdtQZCZNGYz4YPkFQPNhWIBgF/mUnA9D8k3paTVaxMZYo7Z0s5OIuzK
9/TRoQ8w+fRsj+oWdH3gU/zM3ncw2WrB+NOKxkPUvfPR/Bdkt7Qpx2NYQNWU
OWDYGA/En/QayxWIr/T99TBd/gX0tetdbI6ygPh5fcGp6xRw3B2nTfFB73Pn
TprMqjiI/KWitPrPCFAHLalnHsVDzd9GvmZA+vxj5OqU2xeQcpqk774+AuTy
HQ8mmBSYpD9rKE9DvxdPVCkITgSDwuTkzmDEv97U6lw7Ewu4MuH8diHU36Nr
nn7qiwdTkb3PLA0QfmwotFEhHuIuKL2o81zU3/DchJAvwLb8TuIJYyM7r2Ca
fSAJTKWKzmQhPkfkT8XFnKJATavf2hsSaPyMnPQUyhMQX+A3D+9dzL9unax6
IRaoiaLSebuQfKt2dh7yiAO3sA+sgVsTgEvGHOQ1TgDP/Veyy0MQjr+ffGpd
PHjXYn0/ly/uf5na+abmC5Bsfpk9/470P+JGRJdXLMg+u72i8wfyr/VzaxUF
k0DEbaNSmzRqF/qbegiNH9+NqotNx5E/iMIkBLxLBJdr+hsPB9OAanLhSclg
OlAPXmdcD28B5sbb0r0SmYB/FxCXHIn4yo1pibEvGRBQan7z8KphwKwbUtHb
lg6+f3+uWHsEtX85EntXLgsIjUqGA+FoPlzijw+IZQD9azVzF7LfZPpLA3+V
DMCURQYSjRbzWSmVBIumA37r7gNlV9B8HNHtjI7NAoHSxAyJ/BHANNx5WG6Z
ifxNgu+txfwr+gzqRRQnE5wlhiJ5Eb/ARN/o9sgA5gv/JXwnkT8PodyYuJgB
kTYi1olei/O15a4UMR2kBlwkGt+wAb9rhdTa1dlgmBp5smWxPobYOfmWTVng
60Ej0tcuyjNZJXhfJthYhzH3/EL842vTrfkD6aBjzhtB00T2o4AUdudsBkh9
rOF5SJwA2bqu956xGeBCj9khFofGM/1Z4F2eDGhe7XUqvg1d/0H11WXzdBDY
XaFvNo34g7eM/PPcLMRPer32bUXzWW30UIw/CwzP/M0XPIfwav/W8IuZIHRV
YrPQ0koQ+m5cKq9JBfw9tvTJ2gqgPbi/Y7s7FVhNN/4a86D52tBkt/dxPsTd
C3jeb4r82/R90TlFKsSVG3V2Fg2AQdHtGfNzheC5dIJf2J0FQkFS0Qq7qIBl
/LQ5+JcFzMLA7Io1BSDQERATLoQwPcjqhV4h8N36k0V7ygLsz3ghnytUcPnU
vn3XKOr/5OXOrrR8JH/zdkp70PvGYgqCqQWgTvr9OuEO8icPq0kHdBCPXLNq
LBP5F9zHFerxrAKgvpDQLq5G8nrM6cIQDvFOgZ1htTMTQGYNEDa9RXbywZrE
r0ykD+69vAyLQsD2zr7lX4xn8zf8UFlaCDbavZ770PgLYc50v4ikgt2hluXr
UBxKVhO5EskshsmY8tUCtwfBYGwsTB1fApkugU+qKgeAHPvmdha5FMgbL8xa
hrOAcLAg18avBMRt+nvnZJF98VteaBJaDOzdt3t9drCANNI4H3u3FAjJ1wfj
FJH9LGwckJUvBbrnM+Eq8QnEc511rQVKoH8FSUPDAvVfzYwV6F+C5OpD/vUA
NN+DITfsbEpAZ2vE0+2lSN8EfuS/4y0BrPRng6/TE4jH6q6pjS0G0nnP2ew5
xC+/OumufV4KhmobNM7uRvH0B8r0wPZSkJJM8Bi2QvJlMhKeVVQCdlZrXoTo
IH+149Nx9SUovrx5u7boFYp3dn2y2sbTAG7RNwaJp8cAu9dr+uIRFLfzu8c9
zJ5AfuHKFn555G/N9++/NYfGry1lU8POBhRHLH1+2KkCZqtHuxN6G9H/N8/w
xlVAxe+tv/vkm2AyMki04AkVxGW1Baw3tADh0cvTCiHlQKik+/IzmmHyw8M/
/vNV4JKP9wupQPFJkP9B6t0KwGnL9K+3bgEDPQn5EnMUt5Ut7f6k2gZkhfLc
i5uqYfaTXH7IWCvgeG/ZGrMrIFj6nspmxzagOq+TGtmGxv9NC9lnAcXXs/FN
tAQW6NxvjHt9AvnjuwF7cpNHgNVYKz0PbUDYN7g2dfcoUBmOZoT1bSBi/UZp
yZcRoFQerOgKaAO12vIfkaeQPieQLza8bANST+hx8bgx0Ole47lAaIO4q/ol
TkeR/ah0uvC2pQ2IqXlrYtPyQJZ/BeXAqXagbBw9dRNTBJjO03QeiXbAyQWT
pa8XAOmiGcEjqh0INY67eOsrgbbD4NAth3aYpGkJX/YtB6OTlUL7p9vBxbe6
ukeuAzKvTIV2RbSDJ/n7sW9lfSA+vacm0awdUvVJI4Z9AyCuOHlTaG87YDqq
JtatZ8GkWGtm4sZ2ELjj07T3NQvURg/elXvdDkLv/at3mY5AJsMY34z64x2X
/ZOQOAKTp9bd2nwV3f8Xo9hh6yhgW7dmP0b9t6O9+ZUbMAI687k/LrWh/gY+
WW5vWwE6JtoRVa87gZJmYhnKqIKKP9EEb6NOILzw7VH9gdo1xV6tru0E0qkz
+5UXygB31nKDlBYD+Hjs9x3y6AMjcxbpvl4nVDQE6eHzBoCyCjO8R70Tau4M
3Kh2GgScZNvy5sBOCHgp+0uKwALc8aHyInInGL3F7TI+geLf7Y1kBg8DfNWv
x1uGjADB1GjoqFcn9BezV1wRGAU+xUrhWH/Uv2C5O17IH2RmpMUmKTHAc/b3
rv5qNmCFnU61X+sEA9fylwEbEH+8a0puTe+EkOvrdw2i+A47em7bZ+tOUPn6
RNo7lA202wFPf+IYYMgyNppeNwbyincrZRs6gbE37kVKENJHiVdqJ4Y7YZKn
4ZYYCdmb88SYvl2MRR5l6b4dyXt34rotd7tgckwseCgc8faHIW+rXncBdvmV
Ke0apC/14R7vl3WD7OuEu80y5TA50m4Tat8NBvisxkTbdqhoXV997HEX8kvk
4J2fOkBooqRQt6gLvNtficUq94D4XO8H12vdyJ9ZZOzBDIJODW6P1Ocu2Pp7
evaTGgsMlrKPqb3tAmJwU5FlPhpPvZ2pb0q6wPB0t0vt/RGQXWVx65V/FwSs
983S7B4BvK6HYe9oF1BerdmgaToGlC/4xLAt3RA8GV52APE3bJ8EYfG8Gm3U
M2GP5zgQTr3x+NHUCEYfDs2c9RqHzGMrvihlN0LwJU/cserF/dbbtWv/IPtg
/VaubpANhCWvPkabNYOn9PLnO4bYIH/4nGLsnWaweYzttpBng7ds0X2edS2g
9kss12Ynmq+CPbgnrc1gWvR6m6g/G9TexERqoziB8q6sSOA0er6zzoZ+OxS/
OiWd+0pG8X1H4L4GFP/2Bx6Yf8JYrFe0yM8DYarD+Pv6xXxALUt1h06UA7P5
o4TLWAEY2EnyXD5YDfgrOwvtnyO/Yr1ktgtbA1KJhB/+t4YA65v29sLhahQf
YNd2PBoC8reDxVrba0BAtVzz+0Xkb2TvOAofrwVPa+If08BxwIYOZtZ11YDv
d+f6fRvQfGxcS9y7pRHkVcSagtYPAmWn1t6EM43Q/3W3gxf/BNgRXlH0HzWD
FFvQsGrlBMg3XGmODGgG9o+F1/be3HzNmCv765ae4NYjl9fadPY0boAT3/wn
nh4C+WF/VwFiAxj5P7tx35mbn1j8cd7x4hfc/MQie6x/x/QOAyXsTayDTzVE
TrMnPgwNAxlTuJQ6UQ10qRufHL5MgNrjhwf4l9GAdnYdPLmJ/Evias19AjSw
26mRRI1C/iqDr1QmqZ6zn3zSfOynunclkKNPOW9E8QKhV29mRUAlTBY/cD1x
jZuvVoB09dktlX5ufteWbZopz4c5WK1hZcDjaO7699bn52cp30c4+7V4/PVH
lSUQnzMbv7LGvhUiTb49ukZA/LlwSZoJoRV0MM+WMFaxQeh8/PHNtFYwspR1
iF3Hzcep9riiTGQGyZfFvRbPtiJwq6vrKPnDBoNMcYXkE8Vg1FW2XDEJtc9t
epaWUwRa74UPFtkh/TmxROTpznK4Zjkse/MO0q/45QEnM8oBNyn0U+TbEFAe
PCvUQ36J8vd6HEYV9Q9/783DX0ieQtbtlt7DBtLp8k2KsTVg+CnuwuVniD92
xb/WMKwFKTs5m7ZfqL8ZiRReZj3QSvTSPOaQPvAcagjcSYOY1QfxerFswM08
eaKVXw+EaCzYIn39N14Up06en1u5+R7JZfMLfMXNwNxCrRZ0rYFM7Fbr95Rm
wPX8OWmtXQvU9+dvX9lH4XzP/ZePm5g7oXtjcyrnPCdRwfNVy0MqaO2MkvFb
PH/33+9rnisnCvOucLH35eoGRvH/195DHL5vO8LN7/O77mpiPRf/y2fJ3LIp
6uhcPmgt35DNe5a7XvhvPZ24vFvw7aN8IPFW6xcZlnHWywxv81NvFA5w1j+u
mazrTz3NrUfJQ3LjIWVw89vqGHQKWP7h4q3n2pa+NuXWn9T/uIat/WH8f84T
IfsyGG+Z3FcGJSbi+7/f4a7vUGXuSnyv42L9fh5E5bm/j8xapyQiwa1PiXm1
WcP4Ahf/279Naiil8H6vAL6jloKi75o56ymOHtKn3O9zzxcFB83rWaVy8b/1
C4K0RvJfq2rIPJX+s6ifm9+8hEx6tGfLxP/kT0f6mnMkzjmiDvkDIYeNGdkc
eamwuLtS+D53vQVvZm7E04HspVPz5v5ExBcH53Jjk0c57f/mB5fnE9rEbgDS
Xvzqjb+49gYvaLphxwluPUws/9Hnz0uHOftv2bG7bLsOjnBwql+A/u90LlZH
xpy9mB998XUPNcJUF4nB/5R73hJ7SaSyS5C7HvPvPHtMOAzznG+BScGeiV+h
LM73UQG5t7f7dw5zcGrnMSeZT/8fxt/fW5vDraeZypJegJ3c/cT/Ge9hwGpM
sCi05v+ukyF5CqxLXTbZApijtfdoN0e5+TTW7sOVN3Ox737CoxuRbM55S5G5
Z0ZX/3Kxd8VeVc0TXOzCX9cAI1x777hfLdrBa5SzPkQz1lBc952L/80H1kG1
/6hZNxjO7OZPjmZzvu+ytD+uoPBy8wkb5aibfVPjtmPGFHITcCmAkb+iKOxi
BlQ95/si/CWAsWw98NfZC8h/Dx+LeVkCxAI48kT4HRjM+wVffVULGJs9SeI+
b8GIj/3c91wjYHCPlh9u3AuT35vCcjoR9vzwIU3iGbp/yx6mAPJjhuN5f72f
gEH5zdHx7YgnzXz7tq7uKfBdW7leqPYrYKiisq5HjADLZ+Edao3wHpuPnl4+
MKl18+N6AhMwEyoh1vIhQLnk6VBcg3Co8rmb7z7AVJM7b9HuPsCopwkl/LoO
1262nj2U0QsY7ayHFlleUFO2/mfouX7kTzLPbm67DoSUYmf/RNROUZpZ7REE
+okbj6rdHgLMevnJUSYRdFgru/oqEd66YHekxB5UXu05+FMA4dXTFOa4Lyg0
Hi1LJrMAs1k76JftQyDt09zRPYswSSsmvt4G6Q3MjYqi+NBS6u3CMxLoqAPr
/p4hIBLNXPemfQCasonK35zF9Q+lc821RCAd+RyZvRzJ/85cGq8gAWxKPu1N
WNxPyYetutbnA4x9tIuSyP5ihBytejvvgY3EBs1vhxGe2vb1Q8FlkLdeYZNw
AeFszRO4VSQwwvpaCdig+/EteDeGXQKt9T69X7VRf0Q7Kr/akEH9pv1NqxB0
/ypb3bzk9zD1JHX9Dj/0e28ND6EePLCfWHS/WIv80wqL0Gf2D4B2J9aCD8kn
xjDgNP8MASj4aeZjD4SxJ1cYbNUHX1WzjnNk9Psse9+ftb6gcy2uhtSOcJDC
K9JfL8Azxry2qI8B5tcq9V+q7sCeuFLlfn1xPTDJt8H5Fjgu611ND0WYD383
ovsCkFXabqobIeyRPVxKegq4uzx3phBfxPRvNsqzdYRUC7k1L+6i++d8Ynjt
DoeA11MBEanIHou5eKW+DwVCeaFE9g/UnvHxjFnHO6i5ubo1dABhQXsnixfB
QJ5vLFnuiu43UzL+J5MMmMkSVt6Vs0BlS6caUcKBKjofxxsfB8TRTRvppp+A
2KcfOIxJBaJHp9oawQjA/6jr+GSE5D8nLeGScBQQBUIzvi7UAc7LX3H92Qgg
zYdmvvdqANzzREHH/dHgYngqjLiVBsRGcqnudDiI2+7Y++QmE3DbeJ9P5kTC
7FTaL/tohJemNddviYK4XyXKN7R7ARemEjfwIByEKIHTsyt6gXiHKbFHLgaC
pba6rzqF5LeD6BbwKhzsLNUuhgv3AS7hyVSjXCSo1ZHinl1D7bc8DkQKfwae
dKEZzKF+oO5OIakvi4SQ3HvKSh7ofk0b2RtfUKBEOKKbHozkV/KMeI1/FEjJ
7p5Rn2QBsfsP78/Zj6Cu+Ogsb8LieRfjzh3Bn0Ak57dk+rIhkHV6NFBKo0C/
lc/9mx5IP8aNjl6WSUT8Z30lPn4YqNj5k35uaHxC15s4LSD8yd7w/fsIoGGj
qsvMEf55U6bHOgYiQ3XJ91KRPX4RITvZGgUVjMhT85MjgMsiGLvJRkEzzJe5
7l3cb3fkZ/+2CJgSiaiv40fzvWFBsUwxGkquf/z458QIUNepmg0+DAfchv44
3uvo/u9I3coXKMASPizY2onk/YvnsU+vE0HhkObwCiK634rSjEI0H0xXvpnb
fMgenqg9ftUzCnTOiD1x10H+bfNeE9eQCKBs3yrq7b2YPz74hm9qODQ/Y8Rq
e6DnO9zaKOz6GWbrolv4y5B8+RiJWjyIBjx92VJtJO/E1N6CvULofnN7i2/c
GkPx7a8FRdcIwErYeAZ9GgPqI2Gc/GA4GOw/obX1HGrXSJALkYsGqU1OX/NH
FuvrakjuF4gE9WKBpPsv0f11dV/aj1FA/2mKfWgtwpSVP4rmEoEx0xvICEL9
UTp0zAX/BRjtCh8TpVH/V395I2qaCLh9mD7fadSf0F/V/ceR/NL1N9nrjwPx
J/VQ/5cooIsYr9/nguKZRGLJXvNIMDxzRXDJYj1Me9xJD6EIqHnhuKy2Hl2/
GdPaWBQOwb8lIsWyUP8DYjONVsdCsIgozXAE4V0FyTuCkHwqrvnjL4muL2qK
+yUTDcR7N5vTXiyu9+m+W9oQCd4hSZigzAnAHZ5cOPUM6UvBDwWXxf0bDW9s
32t+hJqSiPWpH1G7fJGSp1E0qFVvDckYngBi9q9q/7ufodnoQo2z8ARQPTQL
p5dHgPe7l2f5TVD7Iaf+x/ujwO6LqPPxIjSe1zasyNRIgshy5VWDU8ieXAhd
2utOAUbf6TBPOdS/h9rz6+8nAvOu6rLcbNQudt20Tz0WjEbfPDgphMaj1PRY
a0UcXCtft2Sb7TjgPFCfTidCzbeel76Z40BeQsWbDFDA4HeI7phYMcia6Z9V
3Z0MROXL8k6RRUh+y27jK7KAwm8i+Gs98p+/NhoGumeAuCp/sqTTEFDV8l55
O6eAQttR36OdQ4D7tPvRnp9JwAqwJq9fivSr3C7h4Z40II7x1R1NQnzm9kn8
400pELLPXfPx2mHAi9335k9MAu/ApGtx/UhfZeSMzRtSwbCPxTJeGASq77Me
1zdZYLhT8KrvNXS/HPGLj39mQPAJ3bMy9gjXLVd6zcwAnXce/fvLkL7s2f9+
iVkKGOhqCp+QHgEyj8zK48LJwBfT9eDmVcTn3rv3RGSnAt8PobhbSP/IU7JG
V/qTIVPM/bzLyVF0P5dlwgNJgHtXWl6vidofvZiW35YGnneihB9Eovu1rGg8
WJYMCp/u1V+5hp53Y8g1STAL+nNvSrbSUfzp+Vvd404myJJsf2/KQvqZErfj
mU8y0FYP9hNl2YB/XTmTKJkCudmRdpMWKL46eW87785kYJ3EPDf+gK4/InT0
1Jo09H7rjGO/ov5MP3tMWZsKAj/M7dJPofldsXfJ3M9kcPSalrfzGQOy4vZV
+PXJoF90Qrvm8hgwz7xUr32dClJlRfWkT0jfi8QW3DKSIEagYGcHH5Lv9VfL
hxVToMbq2XPbYKRv41EXCtyyQKvXWWPD4n7fYxEBK5wzwaXXofIKioeIpb+0
Dq3KACJd+16W8mL/h3pPpmSCzY8dDVUV6H6jE/tfJiSBylzUF21xJI/WFfRL
XcmQmt6qrmGG9E9v6bpJvRTwxs7mXPND7aEHSNs9k8E0dsOh96XjwPxOEDTL
S4L+oE09fXmo/2YH5RY+p4H4Hxf9bT/GAL/D5MzGr6mgg6dlXJZH8jrl6npY
BPmxp2aDfK5Ilok754ptUhC/W2a+6tMEkA3Gzo9SkyH3TmyLYAPi17KU5LXS
yUAfNjgp9GcCZL/dXnPwXhIoWJXQ/zxC+mdzGpPfnwKRxWddbhcj/UsZIkl1
p8I1xSUb+zDo+oMrjo3PJkFN9OPzx44gnFEUu3c8GYTq1ucLof5i1t7STebN
Bn3+e0mPUX+pd78b6qplgad2R+TUjnHAt9/BM+0ygbg7/hgW6TNGJo4+NZEG
jtp/pebXj4Ps/bjDzfuRPrHnzz68it6Prraw6VYmeDP4vr9G+okp2iQb+A7p
H6+6xan6GsDcrWZuIOQARXv63PhTxE8nmh98e5MNTM+luKcnmUDb1sR+2UoF
vJoq3+XFeo/UFz51moXw592U5Nz9QSBPy/ZWv8wBHo9lnfwJ/YBt3+pluq8Q
9H/vVFtjPATMHvZa6pJccFx6ow3bjvTbZCn/npRsEG+9HtLUi/SxfG9Zplk+
CJmHXJy5jPxlncjB85dzgb1/4UNGLAvIFpKfXkzkgP5jkZ7Tq1E8YruOb5tj
NoR8618vREPtK4ejZlTzwPBUomOYxhAYrJxQ1IunwlZ6LzN0YhBkl52MayrL
B2LvuPKkNpJH2+S7YYIF0Lx6roFgOwok67tyLZpUUNPQXqqA4kvZ43eFd0nn
gunT8ne+scj+6o5Ef7XJASJNZ+9YB5pfPQuNgLhsqFktDJvckXxoNYkYP82F
4NvLnOaR/SZTp9qvOOQBvnU6rnMKyYu6WNjd0/kQqbE8LGUezZ+pglNmVDYQ
3Kd32Wug608oil4LzoGKrLFHq962ATbG1b1hYxGQPhaR18TQgdAqxUtjFoLp
5Q9HQlYPAME4V4f/YhHE3GpyIMgMgCwz63HUsyJoljewO5g2CMT8o07zyYUQ
tzcU/4Y+AHh7z5z7sYXInnjq/mrpB0Jk+MYOzVIQSpum7gwcAoqj7bKsfUXA
LLwwcBbxebJqgCn+YDFIBbBPYtpYMKk5NvH7L3r+iQOVFhuHYXLdsbTU58XQ
f/VHxwd51L5W+1NwRiGwNjT/PX0J3W+im7y0pQTUly3YUY8OgZBeZ5+BaQlk
KmJm8yNQ/Dyp8Nh/SQnYdEuWDOoiXCLlkBpXAtf214qTrJF9XJkXTo8tBhHo
ZNUKIH+em6PwaroYaHyjPhL4EcDWxfQKvi0Fxv7EFm29xXrVS5VPU0pASNXw
W37lCEwOXQ+SjCgF6jK5nDzCBGCz1/2UcC0CjAm7bE/YBOAVvt0K24z8UHJS
Y1Qt0s/QurEtVYXgvdK5ewPSZ4pQnH3MrUJo1o6yZN1C8fZKXGandxGknudv
1UxG8/W62OfWsmIItrmpF7b4fVj6uAnvg2IUP9OVL/Uh/QqbET1zrxAMxw67
MHai+zsLingvKYKauSvuda5IXndHxvRKVYBLOHZD7qI8M1bZfJasANmYDUoF
K1nIHuSJVghUgVvM1W2ZRYNAqzs0SnGtAZHzpPzdjUie+x9ciT5TC4ahYkoH
69hgkLuquya/BgimFe75NDaQVA/w6LNrYFatdfXKDygejzzCvG5bB1glpXP+
KF4gbXw5nr68DrT83ahTkoPgUrvblfyABjUTyTg5iUHA0r0y7h9uADenklVG
HogvfBVlf/KkAX3XWNEIwpk7HONtE2hA2hS04azGGBAepV6XvkYDt6choY6/
JoDmGP9AT6YB8EEGWo8L0Pg5zGRvH6IB7uX+5+zH6SAufaN82WgDMBM3H3+c
lA6yR+dCnv1CWLZ5u8yjFMAbhSWa325CcUvdV5pKDngnC/nlkppAdkWeBnhX
oXldWtlFbgCBKFzxqk3I/4fwJK90aUJyYLhUfhfi4xJ9cXr7mgBXvKSmZDoV
2ePoy8uGUbvz5rLTZ3JAjfRJtf9dEzBFtj97xpsOwR75vwXVmwE70yA231EI
+BfmPrlJ6PfeRTf3pqWgOER6+PbbFvTc/BRZQ2QnZ9IO5Re2AMWj5OfDzEqI
OWb+9f1CE2A+z6z6frUKiJ7YPB9CMzA9tqSOBZag+Prt3gsHW0AoZWZenVAL
8rLDa3nWNqP3O6gQGYjwjKRA3s5mMBDWXP32Nw2M2OeDzqxpRvFN+rOj8jUQ
XF0dYhHcAuSitaQbKWgcLKVfhi9pBvFHb2/s7WyFYK9Qs9CgJghOcJYE70Zg
3vyIz/vUArJGF0WltNKBYEU9LK7RCrgvnrq11jng0vBdYra0BYiBAUylL+nA
LJcT7TjfCkSQ4j2zvAjs7tdjJ5tbAOOnapvmkAYxQuNaT/zbgHxI2c0iuhLx
eh/lGWwr0ARVmyc8qkBcccGhJKIVZB03lj6JLwLxz23VOzvaADNmfMliRxng
DJ+5xJWj3xcrTQUZ1oIQab1zuhrqz3uS2U2/Wpjc2NTMc6kV8YzRqzuMkVzR
VXZmTaD+5x7V3f4BvX+CiEHj5zYgHVH1Nb/fBEaHnORE9VohZmwIG2aOfke0
91XDtIIR43bi3ahGIMlJvpAsawPTUPUTRuuQ/5E6+53/VwsovFpl2VM1BMTZ
UhHLGTSfq4wbWmeQvuldV7BBz+Nb1brcsI4FQrliNXo+rSDffNC+/gILsF0F
O53Xt0LA3lIVbdMhqFj1O8TEuQ1SH0sLL1gje6cVcPiBWRsoWGyP6hhYrNdA
qtrZ3gbeJSaWbJdhwK690iAj2gqe/PU9F78PA61X4bUjuh9+bclolNEwqJ1X
HW3+3AokKfxb89OjkPmi1JjSg+TLYcWSlsOjQNDw8muKbwWKv0St8q0RwLiZ
fJ8YQf23v6MoQR8Blx+XmZP6rWDIzrVcrjeMrlPSEV9A/T/i0XI0fxjEX95O
r7neBhTsk2uk3SNAe6OlXUhvA+IPl/oPmWzE62OlJtD1DEadaOq6MaDfPKb7
YBS97x6pg0c/s4Gcp+bdbdAGkZJSRHziGMibNzWGWbTBVt6fC0K2Y6CjvE+l
Q7wNWMYn3E+Fs0FH73ON4N02MMyZX5BgswFrP3hPL7cNDAiWR9L0qFDRIfTx
rQMd6Vf8VemthSBkccZssogO5G24tG/WKUDbtFoq4W87ijvXjrmnZoOB+ctv
J1Z2IB7VF3Q7rxhIbvPa6Xp0oMy2t0x+LgPxfhKt/W8bMHes5c8yQn7Aw4Ox
/jkdJhckveROL+Y/fsg+sR/hZZXXu+OKgeWyzeVTVTvgK7yDP2rUQUzP8LE1
ZsjPprtsHR2uBp1Dp/03j9JBPjDt9WuVBqjofKtQcpcOLm8eb7G1awDKMku9
xA90wCPuTHtSC7JCTy86h7UDpvi0xjKBWuDTiHtzyaEdxB/mU85OdcDsrsk3
X3eh6z0ONFZ8Q/OSO/8kRaQDMk0Ozkf7dIK8Z9Qr/rXouvezG6OgD1wqrz//
Jk0HnrasHf4FvWC0fpXaaBAd6OduS1q/6wcj/QehFXPofT3OTpH9BsCg7N3q
J6J08H0/ZYvBDYJ3s/3TBEc68JE6tzGkhoCg57LPCosw75nY6OohEN/iGDG6
hQ5YZ9GmHV2DkHnhhNxq3nbQH0neW4v8u7jM2R2kmTbA9+xZxqpigV2x4tDp
FDrYLL/MmjNmAX036Xi6Dh30qfanFuubkQakv1rEofE8vEbuDgP5k21UiYSV
7RAiEZMjYTUE2FlZi1nvdjCd7tt4u2sIxf2XdhHm28FxjZKBoi/iE10ThDxD
OmhdoSi9kxkB3Mj7y+Eb6MCM72+4fRbFcwVn6Mu66MA4kmTZ8g21m77NErBb
HP/HR2RGR2BWoenBeV86sq9hlbkovnJxfFSczaRDjJTcmM8rxA927w2R2ofk
7eWdq5b+wyCfn3O6JL0dGGonzzWpovjN4hphlWQ7UPRDig3Jw0CQfj3k/6Ad
MtvG6D9ERoAquf9M5Fg7MGt0n2vr5ICBlWFd7ZYOoDot1fiyAsWN7LAuz6hF
HHNithrFBTlYO/vtnUCJf3j5mxfiRXYt6Y0nO4B8dclmhw/pQBWuV6ZUdALR
w8SiowTx/vBWzOBhBlBF6n556KWBAataKMCvE0g+FVZn8NUwq+Fg4rO5A4RM
xMli2EpgHTZKYEd3AJ7UuOyGXiXQDSPUElI6gGnU1Ty4rRhcSnhuCYkzgG57
sesTsxtwBTFX5OI7QHb1nHPOy16gb3xjFWbZAYxnjnxuxv0QM12b4G7YAX8Y
tMP5gv3gEnjLojCjA0ri1nh4N/QCsad/MruqE2qab/5ewuwFtR5pWmxpJxi9
bHnZtXUAcLYBv6xiOyBudYI3FvFPPtvvbn7CnTA5IiOpLDUI4r41soyHHSCg
6ntBfQ3i9/dnexMNUP/V+Z9SkpE8yDi3ztl1gFFhTFdYFwsy346YjFih93k8
Fb8zF/nzPPvoF43o93kRy4VOsYCP8VU1yb4DWNj9KwcxyJ6nXYyblGcA39DV
07QDiL9KmHkwXy3mV94V8ZKC5B3Dd3IGwwD2g1At1evDIJRqddDbpgNIP4ds
js4g+Uq7WW14vQMw8i+/5ioj+ThcGvZAvhNK7vWMSCqPAqXj+R61v+j9nlS2
Nrsi+/nh7c6w02i8SLbJr1qQPL7yUBBB8886E5ogSUD3Czj7KZGHASqnMnPG
diH7z6zTnlfvhNzj0e8OBwxDBX+b9wVyJ2itGRV2mEX2v+dzZf4Cmu/qP2KL
39P4/PpFdbYheTF983570yhMevcvmULjR/cSuy2zH8XfMmuWyDh3AG3y6wZa
HPIX5Mh7/XMdQGhx0PQ/OQYu740fhnqg+b46ul9WE2F+O5mS8g4weGUonBIw
Bnav+l84inZCzDPftrR3bJh9VkIzl0P2J/SZw5MJNvAJiDttc0Hvl7IrADcw
CgYPnmeWdyB5vbriJPnVKNiZ87zSudAJUnsOH/UeR+NjM0H6QukE/UGP2Zxj
bFAT9tbIXMaAkvDunlMD4+D96h3YQidgcmKwP/ZNAF/QN2txh04IyWRaC3WP
A6E3oqE6vxMqVHltb6B4i2ne3Ft/sxPUo4mXWrtQ+4f3EW+LO4GQvSUsascE
zD4wKaxZxQCDpCabBflCICSOGx/yY4DQQ0mt53mIfxGUVP2dGIDvKsN+9ygH
mrtLUYEjA5h/LBIkh4qQ3XM8esIQ6QXzne7SEjTOLZGShA8MIEduXo5/2Aa4
+YtFLbu6genPXlilyQA75nnTMyLdgPmmNGtxqAvxNtHnEtAN/c8bCBrsQcBo
rpiOMGWAC1ivuGW1uN7LH7OvlgFG67YNaB4bgsyq8gnneQb8+c0zkTiL+L+D
iI/LgS4IfjWjJiqD+Mes6ZODV9FzbleMNHmxQO11XZpIDQO8M5qsds4NQozt
L5E3D7vAaNWPISfCEMyeC9VT+dYFbpkhUQVjQ2AnrV/kZdcNqYdWZzzTHQbc
7bzplpsMiPQKr+1NQvb16eFV+5sYwDj4KsElbhhIt3fva+1B/X2UPqZ2DsW/
Ko+UO20ZIFXfljWzDcnT8yD7iY1dYGoZYLPUdARiCpUFgs0Z4Agxa+zKkLxL
bkpkFzPg2vD9H2t2DIOBm2QK+W43hJykrH19FfGbgIzzE1Fd4Plou+mx1mHQ
8cFRiQLd4OnYrqGuNgKEbpsrtfbd4Db4/ObWfDZQ23kD+F50AXn58FhyPBso
v97vuN/cBSLFN75+jmJDhcffY/xLuoH1PmF/zRwbCPT3v3ae6Qbq+Ek/QdkS
YCbXZS/3qIE/l1gmW0vHUTxfManzuAn4rhRdfuQ2Djhi0UjQ5SbAhvuollcu
7kfJWY+RbgIXpsL8VxQfCe1aoeT7EfF3xbtuJt8QH0p+KqZb0QRa0oy29vxR
oG3mWZ3/BPGxn3qvipxGQT7OMb84vRk8b23a1Fw1Cjhc9UIlsxkck6ynwryR
/ryPDH6T0wI1SyvNjuxgA822wu/hhxbwDvwWv5hPImaecCz6QAtENg8zgkrG
kF7+osb+7gIB9dAzmyTGwa5d696mk91go70EO/wV8TGl6/vNnnUB/mUrv2TN
GARnb1O61NEFsqF8jBvN6P2cV6zSuNMNsvuWRgw8GAfysaS2NO1uiPQkNBkv
GQHZVnWNpyfLgFpfq9CKMOG9083358oAk/mnfauvETB/GmY+saoD6k0Bww+V
BUCkzeSeUKgCNUOX9+dXDQAmLeBYslsNyCoPXlbeVQsGj+K67XLrgDyutnqz
VS2KgxItHIAGOj3kmvzeQWAOPm2dcagD3zvbTR+MIT7d3hZK662Dfrxgqicb
8emrchVl2+qBkcaoo/xkAVNC/+KAHA34GtdIqX1DWDgz2uR7PUhd2NxDjkDx
9BuWXeiaOmDEQoSI7TiKj3M/UrTQ/dV+ifF9RO+vdLIsiFYLMXNUQfUNiM+s
3pfaGdQA+lGYPbriLGC93V8QkdAEnscUzDasQnxGvPnyUfFmmNLepN9UNA6Z
KUUS31B7jOtFqfjCcYjZ2Ft1kr8ZQhqraQ+cxyF4Zl1NdDGKuzKieUR/cPfL
uChsPZyweP7tv9+j/+XPlcVvG//SQYeA/m8PTQLGQX4xXUQxHRQWlspZ9XAx
n+1mvxldbn158jIe7YD93PyC4u9WRgus5Nabn+2u97F1nACc4tH5d9JdMLk3
POXPxQnO9+r/nPdB/S/vbfeZ7gIVY9cXd6a59WMoWmqZbzdOAPb/ulsDIb8t
n+5Z3J/1XywvWxs20M7FpCMyQmEm3Prk13LefHC8xK33Tj9yQS5ziHvexDSg
kSGxjrufym3p3WWCEhNAaX15NBZfA24v2dsLkD0nVTx/1W5eC5H9SwK3yKD+
5D6eHjGqBVZJmNzCrwkQYuLYchdqYGuKwFezEoRdjmWbXK4BoanDTvvqJ4B6
LMOvRwXJnXjyMKZyAjDEVZFvbjYC5Wuu6KYF9PywB6aWPxFvV2T8VkC/N/LP
OKK+tBFiukujTBbrXz8Ibrfe5gz4XqtzKqeHgVpT5vSCUAXyRhmBty4g++mw
seNvaxUwip1Yj1uQ/37kaJt7qQqufU6x/2GP7KlJ3cN7FdXQrPfg7Vs7xB9b
pJ+TMqoBpzFwsF+RAhSK3zH9X0ifRC+JJl+iAFOvITxAoh585XImjjlPgKyC
xbSbHg1EPhx+LkpA/c0rt8QK0YDCPNLFqzfM2T9TYVJwWSqCWy+db3rqQ3UO
t77wny0d+xyKufXPQ/RJSlVt3PM3bpPTh7XcJzjyZtcJPiG7ufjfeShv7x3O
2HWIr9SG/dkdOsHN3xq5/kYa8t//6g04PlbvE13K3V/1n/0VI0BiS8vqa9I4
+28wmIKRU912IOtjFmaazD2vzGO+Qu77LJqPDbfNTqM4Xy0kc/P1zAlwuRIq
JnaeBo7HH/NvKUT9U5QWkmmhgWzYwSv8wOLIE5/yhz+898YAuy3A68XBMkg9
EBTakDIGOP4lL19XlYLRRM+pj65jgC8psA67WgYhkt471z8eA8qpXTavXpRD
7ruRy2qArnfFs04VlINLfMYTIeIYMIdDwqo1y8HNJ+lGaC/yL+rTOfZHy4Dp
7ESU3oLud4BHhFReCrPf3mz+TmaD7Ccj+UcFZVCRWHX+CeJrk0JWT46LIHnp
JctJVY8CteDlx3fZlWDqWZVhXTsKZEU5AZezFdz6eRbnPYPeVILshXOPghH+
tx+w5vZdwlVebj3y3AG3JL9KLta5OI377sPd7/cffUf2fGXhOgX9Cm495DAp
LxyrDIID+l+dHhz57/6ZcpjEb1s4cHoEsPMlekXrqkDcerBk8fwSxdbJexXq
DzX62sbvlslAfRQcEmGA5FNM0bzh8yiwjNp470U0QKrSTZklkaOAHd4aSi9s
QLwHlsz4jYL4kZ9xRuaNQDwb0ncoEGFRB0OsZCOIB63YYz+F+CNtj2XL3UYQ
qZv4ohM6BqTvBLuPj5C9OPhFeEPEGIj7E17n9DaAW85hEcsLyJ4+aWuMfdsA
5OszGiOL5ymvPrqy3KERgjdOb2WdRf7yEm4oz7AR5JccyM5Ev581jXUv420E
X0ylvHAtt945dUupvbkKt7651MY2v7VjXIz5Gee1TB3Jr/Y7p3NizbA1c1aj
qAbpX5EqwTyuCfGM7uSA3aMQHNa7NaKpCaT82y7dVETzlaT3ImSgCVh1r6Wu
bEf8Sdy979DVZgiOOHz4M8IU/CPWw8vNQA6PIrjrIv/bkg9tQU1gI2WSsaUQ
6TPDeLMvpQnwI+u6/z7i1lM3NIjKML7ArZ/urXP+gikPNx/9f+pLIP+hcOfL
eY82CPlCcujK4563/3fe0ajK+vWzM60gsMxk6UnpMeTXFh1EK8gfe/Ox6AvX
f/07b2p04UCxG+ILcU/9f+/NHuPkQ4iJz+AXsuHuj/qP/CI+ovWtlz++C+g1
UxLYPeOcdrekUyqW8dx67NdsThgoaCI+g7wJO6YLsOtjCtJ8RhE/jq1yelUK
zN0Jcz4PRgGvNGukXFcCVEXDAupiffoztxr6SKXgmzVfp1mOMJ9s3utlJSCQ
aDUXdB+N90mB9aGBJf99X8TPtrThX78sgSmJtAidem799n/6QbU1vPPZqRi8
JXq8NU8NAc2i6iehrxK01pZiGeJcfSK4nuJ/o4HmK+F4NU0K2dseRnWnH4uj
fyHjbl+THdHzY/1efUL8CNe6NjQDxWcGMbxjSXeqwGjvPpwXeh+SJM51TrQa
TG8QRW57jgLxTvnvc5tqQF3nKsw/RPqz3DCy1qgaRMq8923oRNdveGl4YUUN
CJx6p/v6zhhgjA+nEsOqwFDLNuB9EsKrTj412lGFxptmc9sR6UfiXJB7RhXw
Ga+Lf39rDMgfJoWzkD+i3H+R0Yow0eKzyp2saqiou7UvTR/x289bZPHTtcC4
MSTeuRzxbXsxZeqNOpDakvd7+gSSv7ygT6rDtcDUeTgY44v0w75E/ff1WpCd
tNZ82sit7/6PX2DZOHv1GNRfkfJT6/2RPZXocZ4oqIMKaVF7+ddjQDj4Iva5
fj3wvJR9fv7oGFBVEt2Dk+sgkpBz8JbvGOi8BnPlXcj+f+vfbIniU/HD5w7g
9tOARHW7ZOyH9P1Th9jvtnqoCNTR3ROG5Lso94C7fx2knmI7uH9nAz5qpYF+
ex0YwrjtzWg2GGBb7hy1qwc6fTZCKQHZ14AQ82aFBlBYfzpEJ34U6Gp4BUfJ
BjBKs4wXiRgFo1GXkqtPaEDz4T1biuyZS9/ImvuxiH9qeAgfvMP1bwTBMnJP
8wgnf7CBldmN6BTufmJCUX1qbTa33jvV/Tjt/dsxYP1Ze58tSIdUmebePwjj
xzSj+y3pEPLkr06mBorHW1ZGz/LTwUbpgVvvS+R/chodI3rpQMuQuJqkMAaZ
n/fPz2LaQV75cTM9COmbVHPL6Ds6Z/8tc9LHY9qbDjwPViZ90eLyScJN7FW+
V9x66//2P+L5tnjYPC6DZvuYocA55I/+L79cGajP1m/KWqyX+l8sJWCi7bqS
W4/9P89D7XNy9ScNyzj7O4Xkg3csJ9SCulb55n04bj32f9cb2Jjnb6ishdS7
TMskr1EQ2ra74qV6IQhJxS0Y9SF9744qj95bCDUKdwJzk5F+hPB10YkFUMOv
NhWxgPS37+gxbdd8xH+PqSamIuwZfqAxuAAUIq5p7FZG/ROqUfjEXwjiKl95
Sm4heT1L6vP2owI55wzf0HNuvfd/70/lwef3yBcBO+qdqfXvUU6+BszLNvvN
g7c59av/5Xsgfu5dbqtHRvxnarf81s+c+hH/8sfg3PiKn5JjuPWtsVGHE1aT
gazy8+YanxLO9Zz6wsKm05+PhwLTVX/nEd1a7v3+O85ErGDLSEsgJ38URqzn
rM6TAA4mtrGkXeY+c/JJYXLsnZPcnwDu1IzDhvFuznmAf/WRMIo36jxVfLj1
46Wu8QVl+XEwcbX9lgLlT+B78NGdI9NMoP6fvERx87/Jvin5EXmCk+8L47px
mHzED2IO/PxIp/Rx8sOYNvnxmd8ZBEzJ1rnyMhfAXIh4PZTeDzjPqR8Hz5Fh
NkqnqER4AIhpCq1NmLfc/GKTOspRAp8g882bgxaWfZzn/8vfhckeENeyvw2M
p4oVf75z68lz8uWfXrtqBI1PBfaUWKvBIOA6FxQVnkVBSavJm2+lg0BdHTnJ
FvwIIubHR84O9wOzjKYVs5EC7OE63XtdrP+pr47w/+PqzONifv4HvinkTkJI
toukdIiK8lpKhShKQihCEYokREtRUXShklqpJNFK6a7tvmvTfVraaru2RShF
v+nztfP+Pex/z8fMzj2veb3mPa8Z212/XQauAOclOfaycw+un2ZwmNaRZRzM
ek6V5Gipvn/ua0P6wrLtLrmeAaD4871sn3Q/8Z78X32MRI0xMxOwId5/1wOu
0bbbUDIrqoqX3YvTp+4LtF68rg+zQ9emiLh4gvn6IyXB5KH5eRoYrVqx7GBf
Hx5PQoVbZY7o92MOU446vfQpwRJOQh3sIYIdbkl3rAgh6oPL62t4pfasN8GL
TrYprQwGiWIn1ejpA8T781kzjL6bE8yfbyRTMf1Te/2AbXg44MCBXjy/cHt9
VXuWEhFOvD9O/TmwfMZDoLx8WHHjOlEfSkGoqe0MgnH7rVp//LfWC6RnpUr5
Kvfh8SN29sWiNcEE8ySYUVqmg7g/bCVrVeERwfi926BXgwaLz+D3+0jii01r
pH3B6cj1xUJLB3D788YWG6y3I9jHUmC9fTLBmYuEIs7+IZivX1HX1hwPDn4C
rmXS0T2nBnF9fIIOMRe8JtjMh8ey/EEw+WqJiSmFi7nJR9zTNIpob6ONoRX9
/QTj+mTMaSpq9QUedUeenUs/bn/Kn2sZd6sIxv4kJz7kn28JIzixquH+cBRu
D2q9hmtXdAhY3nKbu+/hAC6PvANbWrCNYN7h7RpvpYnyq3Min7ZuJcL56VHK
Hl7m5bwE4SUzXXVmDeD+0p5/tf28FcEmnu9lJN4SnEr5o3lqjOCKI57vrdmD
uD6zC4V+jcpxMfPXS2r2gsxFPU+I+9R6sq5FaEcT78PvyIn+/ukxiJ+pEg3t
ItrbZlR84tJS4v0guufx/j3GBKuc11gjeoWIT+O9dnJNIBinPy81JPvqS6DH
bErftouLy8/pjdcJ9yCYrCSZ+yODYKuezE1DXwlOVTq/1m71EGZxJympzqME
89+PZMy49iC78tnf+1o+A9Vz2oJtinGQSd47knQcyefgJ8/ilyWCbajCJWWv
z8C4t8NCWTkNSOf+3K+40w3UGWtlnsUnQmzZjG7WMBuoZ14fzn2RCgxee6tL
MgcY//lXvAGyp3XkG4NezNrzFDh7T3D+1j8OsHydfnnZ6Yfx4BE0vvzbRC8O
58sDytGIb71qrwmWu1r8/Uc0sHIHupOX9vxzv2UP0GzEd9nqvsPv7TEC70mn
M+JBwufe7pkriPIFeV9LuuPSg5n6R//WHFck3xdOKnDvIIqt0/FKjoMZy1cX
V7Em8wRgq8s9UEL2OP//I1s9p8w9RjDV91XConSCzfJsZKwd+3D9jKRMVJ7X
EozlqfJhsx+ZcUCyiS26qT2Aw/H829/OUa2PB5GiVwqfgnr/ub8TtR9zgktK
QP33RdXwzIs+nL99vWyNRDnRHz4lQ/MEtxLhfPlJSclKPBH7DjT7b+W4InuX
X3+JHmcHaYM+zOo/6+oOpxHMl2eMzNltBmfoIBYh6Pb2yCBOP1bwlChEEdxk
/7bqQSfBYTkL1oSQuUT83KY31x8R9Ve58KJRt5NgLM/01Pzeqb0Esa0BJicd
uThc7Al52eqXBOP5vftrFIjHg+aL5mXqEf24/eSDgnYH/CEYr1e6hdvmXX0L
dUnXBDNKBnD5BsaOhT1ZTJSfWbD/oO8CIlzzkbmeiRPBfPnGeiNSe2FaMjDO
fZm+dvUAbj8fc30HnysE21opBgQWEmxh6+cXP28QM6184ee0C0M4fZvxdwfE
YwhWVNpb49z8/7gkOaSERbRH0O95YnKLhzCPqJ2+f3MXwfh9NuM7Yb4OLzBT
D7m/39P2GmwGfmTeLRjE7RU2fO6migAXc9N497YGHYL57U+xrT49uiIROIWR
BdunEeWLav+t80Kb4OAorY32lsR40JtOM29+SDDPbtpF/WqCsTw9EcBlFKD2
W9erZWvFxe2lNzR+szKMYPFXImVqzQTbPnO3ujP5ftFf9uo+tT7WgGCyjk5b
0MtCoP0nT5OB/F9/FoDVpZTVST/eo3WFWZ57Ng/flysRtWNb1H42kL+2JDP+
pAP5+5jCucoe/H+/Q4++j73mYH9S8TucuVrbejELyXlF8Rw4OD5fXjJWvgvf
wnuP7MxDN2fN7sPh/PlP7jrcdkouBWYXFcsML+755/7eHmAJTG34M56C5SNt
4qXBjGMp4NojlaEpQpTHZPuH4dWLOPh+L5bxjZLRpf043OlK9c3VV/8fT+yo
6f1AML3WIpDjQZSPL98YBTGqtPIkYEeougkKDOBwy0ixe9+MCebPP9ord5vr
71H4sTlXJO/24vrg9eCMb9qxlgxCfl2h2omnovZUtzLg7e7D5RHZrRRblUKw
kdMnA0410d78/5NVDTvmrMkCcsK0oTm5vbj+NDuXOy/U+4j7225umLB7TjBf
/pGKNwzXe6aBa5Kdxq5Jf6y/6bvuSn+SSSM4Nda/5FUnwQ4Xqc3KslzMVOfE
uarhRHt4Vev15nEI5ss/q3v7Do90JEG8XOO+0snve3/DrSYM6vanEcyff4wV
Rhb65PdgkfOnPyCynxivBRe3xv4kmN/+rCET8+Wu6WBrXlMfkTtA9PfgnEOB
c4nyi9ia8yxWEuHB5/9473AiGOvP/fHFabeyQGiJyrVI+QHifrl34vEnrhGs
XjQQsryEYKMy3Vl3RIn78vjfJ6yG9uataUgFQyUB1Wl3hnB+rO2HixyzCXY9
mXao/QfBJraiOflfifbRNj00EKowRMy3zVFLLhwjGMvD7fvc7jq/B9dXbm0V
2YO4veqekqIuCXExY3kXK/Z+pmg6BE1JypBfQOTPCNOM6DAimDlSm+R5jOh/
FZ03ad+fEux10yv7eDPBfHnHyI30bp6XBZnjp7wCD3OJ+/iux4pygglO+sMJ
064jWGzE6IHL7CFifF+pUjLQI9iq8ZfQG/9c8BM++UiOkg+srP2W8v25QLse
vor2Og8o5wKfWgzm4f0Ude/niotHPgH1u8bHp0J5EH9wXKrCiwWUg+8mNBkF
UBISs/v1MxawcnYfv1xeAGLrvOcmT5+0v3ckq1zIgyamY+OLFWwg5X2sUMjK
A9sP+6cqTO/G/u18+9/qruYv6scc8AtolzjxogeH8+Wb1XZOe0hoJvDK5UWf
5rBx+UjSjf5e9l3Y317CRSQ/R6UX87C3XszL/RycXur+Gf3Rw72Y+fLGL9as
LGcvAypUzCu8T/bg9LF8PVvlP+6ZCzYcAYnP7hycvpG01NDajh7M+HtMsZec
pz2qv6z7Ko1K4n5ZciCFskyduG9T28914cpoNB9phQ/zc7OhZGmpP/Mr0i9O
hFCcNHJg+InL9SJkDzFHpf3CFjOAztz2SjgQcYziySrbXBDXWTYwu3IAHKQe
2Rj9YgDFrlrkVt4A0A8uj3FMYMC41zqJC8sGUXm2H2y2QP3crGTY5DSEy6si
/+L55ZcEM5zJE4s6CI4Pj6hbwPl/5S08K2xBHsJc0b9JO8yCYPweW7aua9QM
Boglbx0xayfuh7eafya4cBkXM31ppcTGKf8vv8M3jrM2ESxf47uKjeYb7k8V
puJ5L4IZfqJqv4oI5u+XsR5smraYXAC0Z7vSf3Br8fcBr92mNadsu/D9Cfz7
Ph3UGJ5PQvOQvSVcVzT5nurfcP749DPsnGJBz4eB9x2r2JweHK7Z+XPMtJ+N
9181717LXRfZhfMbXjfXLj6Kg9nn+5zAZzq9xPtho4KFu/04OD2+PsDbsi90
09t8KKGWn9aT78Ph/PHKYLxy0J9XgMenw0hy+lvVQrz+O1yVuzLXvgDadhSU
zphG5B+btd/a41gfLi89u2nbZhHi/lWfh7fMBzuJ/WHK5btX5VUGMUf1jipd
fDqE0/M4/uDonWaCY/2aL7rPHcLpWSy2X7tmO8HaAsq+Dj8Gcf5Uq9uFrlpc
zHz557c09l3gb9TeGQm+LA4Xp2+y1n2FhByRH51m/na/NcEMR++fOWeJ+AOe
M8SuvSIYv3d8/1exS0oxkKe8u8bxIe4XNXsmorarhuDUEzc+vhch7gNN8lf/
stWYYF72oWBFZg3QLr5Z2najGJjnlj0pHKwByo9ptRfUiqFku2PjTY8PQBJ9
E2r6uxBUlsnPaznABpWxk68eHC4B+rpPVzddR/b2p32Ln7BKQGjaqI+mWydQ
ZjVvIf0phab0izepUUi+OLR5ySkVwUiO37PTs/j2dhmIL1K6XiU3SLzfu2FO
jIkW8T4vx854lzzSN/j3XzB2zA8Rckgm3lf4b/xkgN/5C6a0Z0yg7fDcsnUi
g3j/3E1HqWh+Kv6+yr8fxWXWn6UpMz6g9m4c/Xb/OZiYJJv3xNWi9WQwdUfv
O3wfBeNr0Zmd17Pw91feUuf4IyIlOD2mYcF2jahq4vvtldV5FXkV+P/8/XD5
ANLlKuYHsPj9LuqdNBO/xyIcaenF1a3F8f83H2pB5IZP+a68WtBMHDesXsbB
4dTsmtvNsSn4+yu/PqzOXsEUpzpgjMx1rfSKh9TyJumt0ABkXx9KzYe3YKjb
GLq/sgFIUl1cw6PeMKL/w8XOvxHf9+wwi92i+qIOKPb9YhbmSfg8BuOdkOVW
VhZ+34f+2DBQ62E5vm+DHnbPX39fMXG/htqCmPqDVf/ct1EJsVYTPWS9OjCs
9z/X5VWHw+lBF5jjLhU4P9sSN3WxxA+Y+e2RuqHi/dqtDaCSPiwXRmoFi6nd
B7JH6sFqxE2PJt2D45M0Est+evdi5uvPqcffpV1nNgBl3V11r75eXJ/YBxtv
ytr0Ee8FHkm//baRYKpaXO3G1Wn4+zO/vb18rBSfHUXpabTMp52lg0mTjPVr
hSYgjVPuLil0AM34vGunJpqRXaHYFLaoAn8PF/m6o8LyXjFOj6LIe5yG2ovP
/PYa4ertV7qK+it1+SYXTh4+r8Xqkpj+/UIxPm9lZX9n0U2lOvx/nl23lptF
JY7PT0+cellEmtwEDqslfesvonwCbUROyjSBVx5vxXqJWrASODe9Mb0Zwrwe
Bc2f6MLpyd+UvPPduwczX17bhhScWba5ESylew4GRbBxfuKGQLla24Xry7/P
xUHsmk3g50YQ0r80eiGOQ7xfv1gl8ffGXsy808tlI5U4OD8VRtAc3apezMGL
Xwdl6/cR59nmz/XasL4H56/dd1nnuzCRPinys/j7173/tAeyr84avWXENwJF
cs4fqbjXYCt1ZEmwVwuQqq7mbkh0AJ5MROsHxTagCXhPfBNH68B/512agRqV
cI53LBNU/vu+3gwO2eAre7gQM9/+RukL0qKagMWIb66VT8Lvr/DHT+yrq2Nm
T1uA+tMys2lFCtDiJn8tYGVrMoMyloWZPrzwom5yCU7/f+1ZCl7tt+o+Kzej
cir/eZ1aTeRv/XGJ0JMiXF4v0/Prv6Yj+b7bXH/ecVS/28yA54kVQDcX2q47
0Qq8cLLFGiS3Yh/N3GSv1va3f1tBeFP9toWzWsBlquzqS/WN4AUbrvnVtwI9
/D7JJ7UJxGNYt5SXtAGJvmc0N6ob58cUdA1QOtpD8LGm5nUjXbh89LcL3LNv
9mDmjyf5qzUnxw+h+DVZg/1If+D/32pmg6nn3F7M6opXR52CCaYP3JiVIsHB
6ekxzrep1PYS/fO3vw2vnbFbvh21V+qRgKiVPcR703/1DbJFw6D2NTRfT8q1
Vo8S5eeHx+64mMlb0QqpfTvpPo96cP8EVRsdMVfnYKYel4lYZt2H8xf/cO3K
WCnBeL+h96jQxsImEMpxXZ26YACHU7Snf/p6nmBxNevnB2704vLy5ZlK7kUq
9VQzRF3IOTErug+XV2K0b6e3BsH8+IyRZ4qmM1uBdnOdzzR2Ly6vfIT/wavH
+zBL0G7NnV9HMOvs53rzS/04f/VDNxvqewnm2+MjbFJR2cNmsNyu7WqpPID/
PxBu/KDHi+DU5mmVpzgEs942C8WlpeHzeqSw5rGvX6j4fXb+923m4c8OKx+2
4e/ZsdIvmqlq7UCtmNZnJBiK74e3Ut5RriDxDv+fP9/IX/aVytW2glU+Z2/a
aCaO78D6VRk6vQKfHyT1PXUev1yMy6Py5UfQx7oSHE7b4Fnx6EkhZs2P7Avx
/9177nA5rLQNVA6LP/faUwEi7uRrL3U7IPbXWFXxpgYQDm1dEBPcBvKseGaq
yQfwO+z5dqdzB2ibl5bUPu7E+fG/Z6c2qMy/V9qCvz/zhIuD11i1gsnKaX1v
uz/j/H1OzxGOk+7E9VH5mPrsHKMLp0fNPJ9b9r0HM3++8aS2SvVPb4Uks6jk
65P3//5NL0liWNgbrZ98Nmq+6JF5n4P/z9fvRcRWOTGVWqGA6vSLnNWLw2kl
U8YiN/Vh5s+/4Bv2i8QNUf5GukfnfevG/YPXE6Gph9IS22DkEGvqEJp//PpI
PJr2k32TQ7yf+/d7B6+KPNH/DaXf17xddko/Lu/s9NDFOlcINjmUaj2nn2De
l0WfbeKI8vlIjNe9RvOPzwVd/d4GLgP/9McACL9w8im43gqurwIEPu/rxeXn
16/JZp7U9MI2YMqINDzR6sPlbZKoDCxiEKz+oJwb2Eikz98vG5GzCdNxbwVm
tOb3mO3E+VWfN9TeiscE8/dvDF+uoZRvagVL8qbTH4v6cXn0jOo77WSGMPPv
i/MLTtpP2dwGFNEKkT+57/D5Nv78IH3aTGpT6wCR8ESfpe7l+HycSuWcQ+Pf
ivD5OP76Izwj+EjZzHagVNglV9rn4/vLyEWzO1bfLSHuI/vhWZanUUikt9iM
o1VdgeMzKlVffrX4QNyX/3f9MVxxRikHxQ+OKSj8bt9KpPffrwliA++tC9/X
8fccUzMYHrvGeOTc/lfefQaLmcl6TdABdfe7Ho25doLI1GcKs1jt4LoktvJ3
fDdOz+mCg0Z/Ug+un6VCSb1MVRdR3qr164O2c3C4a/mi+Q4z+jCTfbcsl5Ds
+af8aH7FOpOMf7TD+DuZbz8Wc3B6ek9OrLjk2IPZSsYtRqe9D3OQ0v0Fg6b9
mJuqn66PLiJYpZu+PNaXyF8k8toC8+MDmPnjtelagvd87XZwSNVRfr6qF5fP
tkHnjsx7gvnjl7VANDjncgfQaE3GY5ZEeTjbXv4U+9hLlG9mXcPiWVw8nvnn
O8Wjvi9dhsaD2Geyh8hvZJ8u554tPh0IrjK6WeMaQ0Ca+75gMCwIrN77+Tyy
GgKq0/seUAuAVIWlX553coHK8fy4ITIEgp3mt+xG9jdV6pXnTPHHYBsnYhu9
j4ntbxEli18UdWTnrTvwWL8U6WXxrRLLNvbg847xYx5pFXb9QG+7ylstUgp+
PCfmw8n7L1f8nFYSWArMeR1n7i9l4PNflDARy5prBZjrzKRiZ0xhE/4CxxXY
A4u6MPtkUrZxN7Gxfek0YjehG9iL2dDk0oYxTh9m2o2KA198h7C9R9VKfrKg
oAvbPwXHowW3jvVgZoqWhh7O7QJhyRfH5FPrQIzkvzDpOZK/q10HMrPrwO+o
cZjUsX4gcRwlHdbWQ6pz2W79ef0gklvFuvOxDkh64iW6+oPYPitYKvaRrsLF
zF7u6dw72AXiP16Hts1rhFixEzb7P3aBbYf7ClUK0pfPTQ6IGCjRUvOvvdSB
1qnAwBU7qvB+gaETvJ7mzsX3N3pd2RzvsYO4z5FdKrZqszUX20/qkqItj9cP
YSbdcf56YtMQ1s+tsm6/r7EgzgtbegYEjCH5JqysM13lRhNouxxXXhnKBVpS
2QWWRxOY5UrandkwBCKmi5jH7jfBcK0D8ySHCyzz9xrZ3k3guvqKVe1nND53
lb8jZTYBM+zVVNEXXLAqK9LesKcFShbZ8CKjUHus21Z/zRnpwzKctEeH0Pid
u31Zn0oLzLY5MH7GYAjrJ5Yxgb0iH7jA8wn1SdZF8ryIuyv9zuR4/7hpdH4b
VASqsdRPEPNBXj/qrf/ZITDRP3iHjOZjVNcb/54YLn7PrEDZOeRiG8HsKzrP
JuYT750FNyQNHzXj4vM4Ykd9Tyn5Esw/z0oKeZCvL+IOpNbn8wS+Ee/v8eU9
1erdmqWpfiDLObGwRYe4P7nEY8Is9QLBFr5hLyNeEMxQcZxCPoU4cl/3rHW3
YCR4VUeo+uR7cI7aH/e6A/UHO586+T7c+2mqwV8fgP0S/QFYhfJrrTh1Zos/
eNW7Xa0wRuHjr6fOS/CFzKZNQTFCiJU13s3RuA3CM792r5usf+L2Ksb0u0CL
ZMmfap48Pzz91LTjNCBtkl0RvBCFPyh6+T0vAujzT4Y/KUThbGF5gZ0BoM7U
VD20FIWfTH2xZl0QBJ/5tHtd1yBQPYs7Vx9+DOrPBT9uKEPhkUd1F/TQIEh3
x6DZES4wNuSXlpXQQP3mHN0pPkjePL1i79scDnqfin/NS0VsWu26dWMYxKpd
3PjnJ6rPs23Bmjw/4Pzx/mWWh8qv9+WuVYYfVAxqDdv2Td5/dnqF2VsfcNj9
bskUb8R5j9ujgx6A3kMJgbk3Ebux+wvsfYC1ac6L4jGUHud7tHcc6p/9USK0
ChSubxk4lBwAwe8+l80KRcz+07JFKhCC2r++9XFEnL4n3uLuQ/Dbn/TG6W0e
kL4aOPU8yQXWRjhPqS0g3vdpNBz3te4FBm+34zOTQoiyv3+tYw+yty3Cdp8T
KgSKZaj5wa5e8Js/VqllXwj2go1Rh1v6iPdLc59cjKl7gffb+PPfZNx5alZN
GTCUZrXdN0khwj2OktK4OcR+3Q2e9nFVNpBuec+dCCwGesXCeIufbGDUHQzj
Li2CEp3TunSxGhyfEr7UsaikEsvHJrcjjZISxPvmlsU5irt2dmEW2TFdYhVa
L/n/T7ovy3A6xsHh6md2xj65SuwXenGKNpYCcb9uxW+Ng8s3d2H5JFG7rGrK
EuI99Pim/FVzfHqwfFYJnusr9q0Xv3ekUiootb6qD/MI7bV3K2LGatLa67HV
wPPNVOip7QPeVaXi/GlM8FmpJBqG7D38Xri7581tdlz8/4qGLnN5xSHMHFFH
g0u2BNOPy7h0IqY9d3PIDKkGVtaaO90ovopFT5otrRq0BdjFP5H8E97Yoi+6
lQmK8wx/2W8ewu1hFc0aOOfEJd6LN15U0X6Fi/cvg5S1HiXvHsJsf+z72HXK
EF4fhCMWbz10mVgvUt17jHcpE/5VVlk8btymRLRO68NLa6Q/Ll7wW/sgHahn
pVhtokg/S5kcWE9A/F1ouBUb8Uqj6U8lncG28du4lBbSJ4pO2FlOQ/k72MsE
F1oCc0Wr8JYOVD6f18sFsx1g+MzCrz5fEEtHjYv6XQfWTAG/Sf9DUuLe/Tvq
L0CqjR/bOKsP74cb0oWatpUR/oF+1xzDtQqGQPyN03lKCBMoFPfZUZY0sI2p
eNA9qwN8EprMxvYQ67HPpaPlV25xMePvqbfMO5nFHqA9vPCltgNfPt4GWfUQ
xrUEQl6bbVLZN6BP8P/OVyNesrTQeMo9+J/5ivjcWQUnYVci3OO1fkbyWUh6
r5b0xYZ4v3LEzjzdW5p4n60u0mvzalYvHs82nhdzJHP6iPmoUv7rQWsE7m89
Y/FqcOsCyqUmg7oH9aDH+soMuYfmk+Twpbhj9WA1az6rxKAA/19Wt0z8njvh
vylyZZbDlGRi/eP7x1EynouU9rQAdYb6mTvGpVh+0Pam77wsWID1L4fja00F
lCuJ+67JuRvTVrHx+PZyqzSpRPW3HV04/yCzDlSWiSomIfaTzvV2r0H6zeZ5
YUteofqrUOf+ttGHAQvdGRfpiEe8pJXTLUG7X2HTDrdJeVm7u+fSaZAv+lwb
fAMxU5Bk4mQHYt+bo1cifYze/DhJy7AGLK+rPVFAnPrRcaqfPpJDlwf2Pjoz
BLxJd6EGNN/65Tq+Tb7X89dfwn7Iy1lejWD5oM8smTVsQl70Vc1jXO3FzNv5
tEcQ2UP8+te5yC4/X0DsTxot6j1z/+4AiCiQ+5P6GkFFegNp4aYB4DmPxVSk
Ia7IMNk7vRrI0aMDR3YXAi1mmsVbmWrwy25lzl1cCCXrxzKNzQdxflEHx7xX
axP6l7bXartrCr1gErFEewnUQx01SPXcQ2SPjy7XG46qhzazi0J9m5D8/3jS
1bqgDrz2rN+tpNQLnE2PZ+ur1oNJ783Ckvx+PN/tE//8kp687/evfCgoHYtI
Q/YpX39zCmJNE1tM6HeZNOldwV4DwDwcbplS1QbjIku6AhQGgHRomaTipTYo
OJe+wq6UsE/4/hh+PeHtGdLtMGzwyHSR2CC2R+uOqC9vf9gPVl/vVcaZdkCJ
lWi81st+ULEsWa67CtkrmWLfJH/0A23888QNhw4I2j9n+2Z3xJ5lXQWXkf22
ya514c9+GFE2PJ57ph28wjvF8z1Re2veaPt0vgP0uNBwdeUgkN291ReeQPIr
3UrC49kgWMkWen4KyAVXe4v+mXSkP185M4N9MQ8GZDIF3W1RuB5LI6o/F9rE
6+50OA8Cq+gbm7Y8H5pCruazNw0Cs35i26Iz+cDM6Jn2zAnpK0a3p0ydyAMx
6wkb0bcofKRwsPNeHtJHpOveifYB5abzmixuOmhvDY6Okkfry4V9ejXMDIiV
uCzlRO4HstD6nG8XsoA+3tfxZAfqv9fC54qlcmHY8AjttgYa37dz5emXGcD+
rrsh9hSy11Y8D87RzwOOsUTQwmN9IJJR8GuuXB7YkO/mJSD7kv/eYpCHg+FD
Vg/2H1MvexjpkcPB81UvNKzmyh9UXqFjL9V3If3i889l8zdxwUHZgBHysRCc
HvldYeUOAv3Btx0ORUUgYXrGphDFp6p3Lb+4twiGxXV+JOYifVnffn3F90Lw
SRZxK6xG69/OA9e1CotAPejaKmEkb0kprWtWqhZB21pWHblsEBwSRpwsK4uB
zJMK1yhA6b3WsmQNI/1BWvFV5Dykn30XTPT0KIbZc+WmzipC+n+MJjXeHcW/
vMQi+/4QkJenpK16VwwDr35fzETyn8WU6DY2KgbOWSPL7l8ovPJOtGwXsl9W
vN0+5kas78PTF3RlTx3A7DO070nPCMEVM2fTJTv6kH1gbjF9DxPi2ealLwwG
cXjB0XBzbVlifZcwkmn7pTuI5fF4/tXG96uJ9bgu4VG5jy+af/Nuz/X1qkHr
exl37mgvvp+fEWHSvXr0De6v/+130IHn5pG0fmUeGH4wTFkh04/7i+9PKLJE
WY19GOlHOtKHrVuIcOqy875v/vRjeUG+l0Rr7EH26f775XOc+e8n9gODo1Di
L1cMNjrvawa4feAQZ+fDrUDj4+ym/XuRPUuOYbnsdisGPxcDA39aCbaHSTGb
zJ6qluL6+4mx5LxWVGIW+/Dtp9bQAJYvsnJW2/UUCBY5qv78+uT7mlm7JHrq
6sFm/XRfbWU0/27FJ+wgNUCJ5LUvassHsLwxepm9SGLWEGjademJbaqDJrt2
Ef+Ng3j9clg1zX6qZC2w5J5HPXCsBc0E1m03bj/wVp7bQu5G43Fq+cmYESQv
1Prbl20tAqqw1peCF7lAkS0ME7yK9CfeisP00VzgRWxw+lOO9M/8BNrhIQau
z//aOxdo1m51zmPVYCs9lvxb/wOYjHzW6rr5AYLNE+s2VA2BfPU37epvdUBv
i4t7GNcFfqJ5W627G6GudPrGcB02rg///cjYgP0lC9che9l76WKrVCT/5r/p
XqeSAfZmq6NDR5E8mFV+6L1GOoz8Pmcg7ojk8zfTozmQCamFrYPfDgyA1fqx
wq/f08FmYaZBytkBoL6P/GWcmwEc34wOoSAUP4xsPdaTBXpmNk/rnFD6Iush
81QmuC7XUbae6Aeqa+CTu5ezocK68vjuC6g/Jqxl8pyywGr/ccPHaogHasFN
Lxsol6fP+uOA5KeCwNRi8ywQP74z1yEKybuNX1klAZkQfJL+UPP3AD7PIhsY
knN+qB/8DE5/KvbOBZuw4ROPf6H8991Ig0l5KuR1ZOP0ATzeqYsURuW+Ehz/
ciJY8CCS31s5qplWKFxlXcZ9mXdATflQWa74HmgnH988uzMDyDVLyVPnpYPw
vKiCsu1duH0tnNsfphVwsf8Mtp/pT3o3b9UHy6TVjpsCB/B5Hv76xEgQdnxi
nQt0peeq5/uI95KFd/WE96wexGxjv2a2lR3BJGcFr+3pzyG48MCqrWY1eH9S
fu3Qes7hZqDNqpTV627G32cclM7nFgbkAznpBPc+jwEiZUn7pfcVEOfBEshR
X5uQvK3o/bpzdS74icdc31+O2r8V1oVdZYBJuPilBchepv5ZYj93ei6kPrby
OhaI7KGEQ/sFPjHAtaM1WvAAYnd3IZJRLqg8Fo2ZhsJJ1s9OUNsZkJpGO/Co
FOn7n60pgZcYYPiLZ3976yDO3+ne8zO6M4jzSfz9PqqqxRnJhzkgHr7YUoiH
1sfjd/J796P1YQ/rgfPk+8BcXu7duYUgNiPP4aYGF+gd4fmqzwvBdsfQoimZ
XDA51/GB54Xi5478SEH2hkpEeakosk9tKZGSQm9Rfh1zLwz9KQCxOqqxxN5B
rO8X9M2bbbeGOA9DevqYFWhSg/Uvkd1PxfQu1mB5S/F8QC/+FP/P/jEdmM5T
a2grO4DRW7hb0j4Zh//v+20S+EmcHt9S2g5MTy1dQPqzy0VXsaMmHUB65qUd
KhkGpJrZ0jJV4UDqYc+UYYUAdcddtY0aEaC+pF+tELUn6TrV6LiHO/DufMgz
8h/C+zN8e4C6ZHt5yhN/4v6Jy5Ss5AkfiC3+VP8iHXHv5P7sfSioqs+lInud
ufblPNV2ZK8/i75AYzQA7SCZdbepGEYq1yyacZZ4X6nOPZP8YXL/gzHNY2uk
MZi0zve3eo9YwvduiPZV8EuL/cSO5e8nOYJP2Q31ZwuHMCsuWZC8yAVxKDNc
sdMLTHSl+o0m9yMuB0xbqHYHxrW4mv7IHiXNnG7t40wF1/IpGzb8l/9szR3P
/mz+n/8OYtXbzKjYO9BWG+yiM7nfEfs8i77BDVx+rlnlUYnmV3VYd+vWBhD7
+EndYDFaT68wEgqqkLz/ER16S2IQRpbBugtPGyDWKOtiB5qf9PVuG+EsktNl
t7u7ItH6cXBOAKc+F4yKZ5k2S6Lxtmb6U6lLuZDpLDhR1jYAJt5XbtXZIzkt
cDg7/zXiwZnxnkZ54CN5xu9AHJInf86qHZfJw+9tUX5w7v8OLAJZsc61ryS6
iP0RnanM5HMp+Pwp+b/5nAaUvSuVfM5nQGryhawCvW7g5Rw4e/JXMRoXX5Tb
UtNBJEztTPW+PKCY2QloCGaAg6SFE2duHszm6oRIbOaAxds6W6t7HyDocI+s
qzoHqCUSCh4jH4DRnq2uqMUBOrJOPIs+AGVc4+2SfC7Eet/sndCqgxGhwlUm
iK3mVFbd3lMHsdfvKT6bOYTfg2doVa+Fy6h9Ak/cPrShAem1d/M2Xh0A8Y+Z
IpZSDaDZndcb20C8B08JfDy8bFKu+pdv1FyfDn6nO1t4DDSfA059yNuWjupd
/th18v78QdP5a3+mg61MZsutZtRfiXrGYSUZUFDoLtGE5CttofWI9aV0KJjj
wnWvRfIkaN23q2szge69atGqHWi+dudHqsqkQ9QxfYeNSP5StJSoBeszoE5i
dVxh5+T9GdywkhzUfyJVis5SaHyG+3szk5E+Pr4jZH4fmv/xz+VNV+SBcEqc
42XzRnB4t9/3iQnS/0YOTk+uTAKKo476hnttYEW333BbKx28hI+Wmzi2gYr1
gsrqfWzgsLxKXq1uB9ldwaFK1Z3Y3vhv/Z28j+f+7aOulq6Ev9DnDY8Xi2aD
cPyciWJH1B7/6TtoPbwjtCPsLcEVRyMsvg4SrCLJ+3FyBXGe2Ymc8Nw3DY3P
g483R57PBqOfzzZ2fUft1/eZYmeaDXr+i+XMulD4ExnxTYmZYDnnpLvzJaR/
/7cfkQ+Zae+HD6QRrJmyYOELFeL9dP79FipD5DtJh/NA03Ght7AGF4fz5TVT
YvWgyG9kj7SzxkzzUXyFr765bvlQN60lqhmlb/V7qyZ7fj6QZldxWy3f4/1s
rzRZ7enH2Pj+JoeLUWc3M9E6l0qvMt30AEifHcfOH8oG0txEWSUTZ+xfTuoe
tlvZ7QOkI8ovPXgo/FuSgnZeFDDsL8vOKC8Dkui0LIHfvsCyoB4TbEfzxv4n
Ry3uHIh0Dwtb5pYBQ9HZYk5jLPAsWkln7xcDJeZ+nFJOJLhUbo5RcmBif0mT
v/cYUKOcaosnIv7K009ALYx+O3GAhv0JSWQpVcXozUA7c0zj0ukuIE1ZF5qi
cgHs6YbKjqNsIGne40T73AGra8775sxHXHPP8eayEGizI7FV3RCfU6XJ+AaA
fZCHuWJAJ1Aes0YvmNFAj97HOVDY+Y9/KmqvpZ8zDBMi8flckhU1yDpR++/5
j24gaUSt+tF4B8ysCwvVo7vx/o/Zkm1G4ZHdQF0eo9hbHgSKJdbDIZPvo5nZ
fzgi/gyC54a23VqHwi/X/RixfQI2rnF36su6/vEfReE2yqv8OGGYKYP51arm
0eDV6qUdG9KD1wv+90qSjUTEJ30qsAJ+1E3eX88vj/p8Sb0qbcLfW+Li4S8t
lShc+1JveOAjsEg3ezFVpheofvXkxpv+IJ96ZShGHMkz/Rj2qTc0YFcKKis5
o/glip6vy5+A1U21tS4KHFxe7G+pUfTFRCKc8CfSd3dyMYkG0mrdV4Mfe3F5
8fktzZ3NlWfdgNHteSJ6UT8un4fWJ2+ZSwQzp3TJa5T8v/Ca7eG0HX04f80b
J787phHMP59DLftq3eP5HGRdO5R2rBnA+UfN6mcPuhKM/fE82LN+3XAi/G0C
xLet7noA5P6KGPa2QZy/0Pe0tfH3CHaV/OlswySYUycQGMgcwOXxO7dlw7yl
g/+Md8Sj+2rtj4USPMNe7adLJPhdS1O4jOQRKbXvlZDAaRgZX/GsuATxSf1Y
Yb8bQHG7Iln1c1Jf75idfvgi1Nm8PPp8yhDRHyeStaZqEux1InfBqbME8/dH
KbnHVT9feAaMaCMDY9obwp/3l4KCnPN11D7y2YasV8AqTKoJ70P2U6+o0Xfn
JHy/BKlec8+i+bFAmTlf6MqnCvx/kcqGt6fpJcASvEDqlH8HtsNHp+5jIf1O
7rTRyt9Izs88sNJvOxNoW4dGDvx4i7/3UzKtZ0tlxoJKuMGWV7vQ+n3eBuLu
RYHlw5nVUbVsYCQKXbJWigXL/rvly/ZN+nP0Hrn05RWIPA0pYH/oBMbRcM+A
mgQ8f2kGc97su0EHF8c9PofTe4Bx+0t5setzaDuyf9eBfjS/VnxPmR3zEuw/
ezOGLVB4cf25r8diwJIs1GV4pRsYQ4GCErNeg7COiq+mIJrfzx9Y7jWgg5hz
jv1W3e5//A9R/JNnLy/1eguGD8d+Sjzl4PZgk7Ok0hV7MZcY6KxY8Y7gilxj
ZuNxDk6PP39YSbMf5TonEvd3XT/7rD/kBQzLS2m3jRL3DQT3HKHS9/cT/Rd/
q5eSSLBf1eUllVf6cPr8+UEZ5jwWPPmWGO9Ssotbml5CMFkmffJ+HP7/Fevj
Cq55ESwhSz64roJg4e1z3y+eQ/iLl/ivuqEWOUD4u1Zu4RoPEcwf7wzZAOOQ
8QSoqDFtin1E+JPbr96/z6uSYJqY28Pd44S/p21lt1ON+hBm9Tu7zczOEswf
31YGlF5N57fAeL/t+4+vb4BSklIYU5IKlC3kpdK18WAVImcIZWlgsv0y6yTS
U7A/pp42pbWjDLVPoEfzlyxwMC6UHdiGxtd+kawagUQgVZjsFH2E1iP1it3p
EUkQv7nRZfsdtD7YL4jbKpMI5D1PQjQm2GC1Q4JdLZcEmTVS58rt0Xi0v54e
ZvoeUj12kdXKUXr+2Qs2ZqTi8Wr1OEC3OzwNry804aEL07clQeqJfdVKqd24
fGZKpPovt9B4axzr6liYAmJTz9Lj/nQB5fqQRemcNDCcGjrzi3b3P/5iKL5T
9e5sG6TfOTqX3coh/M9FamNsbuwg/LEzH61QkjrJwf/H41GRYeS0IwO8VGq0
L67oJ+LnuArdukHw8LVcgfv1BAvN07378mIfTg/L55zCxxE30/D4o7kZvH+8
Lhlop0VF8swJf2T1RfbusWEEs79KvU34SLD9XusFf8iEv6290vyg8scDOD+/
BcVy0p0EY//uO8X6DefTsL8fS9Psa7RnMij+9InXuU7455bsNU46mkCwzZv5
mTc/EUy5cm+a76//559nPmiRrzaEmbfO+NXoaYKx/H3xy1PIBZVvcVmb+P1c
IC+9kOAaiuwM0Yk3lqVoPD6Y3P/LIOSthHDiPs0sYBqJ2CavrMD6KfWjbIid
QjmQJaarO19G+qX8N6dfWjWT7/+UN8tkgkVlqyGJXAOsR91R/bqZWN8iL3yw
NnJZHjB50W49AQ3AmCp2Mn8IpX+/ekGSXTOwnOQoovG54NAwhXpAoRNoJ1VO
j67IACPG/J1fd34GslCtgxbSh5vIj4+sVPqE5lOSKvtALgTpXJ53adsnvB/D
1+d4FrM9RUtQPbPPbHdxQOP14lWF62syIN7cfuR4I5LvRzx+R1/IggGpvPFK
HTQfjM6VZGbkgP21IJsZgZ2ovofFZWVyQRiUO3e87vznviU2UBU/xHXtz8Pz
hzzw7bmWTDZISL49u/BxN24vn2OJs1KO92AuEfR+9bG0i/AHa5937Eky4Z88
29gpZWQL4a/rFFTskbKIg+Pz5wdF60zkzHAGBBef8j63oB/8Mvdm62YzwMvn
rL+yXT/Q8me+0bBkgJ6L6X7Xpf2gsiruwIqvDLz/S7Zk6URvRPnnLPCjHyH8
1eI/NoD0Z8Jfzdayu/S15BBm+ebvplqHCOaPL95S166PxnlYn2cqTMlIXYLs
WWFhM0VkL/L3u/jjy2rzTb2yTflAfW2zvGNLBbY/xDS27F+X/BlMmi9FJJTm
AbtFr+WrzSdgFspdUthRiPuXMdPgZF1iIVAfpvuzL7HBTz/e/XFlPjjdOFfY
ko7065GzvBbVQtBTvNsp0tH5z31hbGAJzXX+ajd5Pkl8pSS7G+c/Eh83ew2z
C8cvsBV2X6LJwWy5/UXzlbOEPxffnqL9mblDpLgQmObG9dqOQzg9I1WvO8Yv
CC6ZlatxrJ1gnw0TVnYThD9Y0yf1T206Q5j57euwjut2WQXVV+19/dZ0tB5c
P1MTurQYDI+FDG4oQvL20dYjaoOFEHRs4rbal25gOo80/HhbBBY9N57rveAA
3cnkhPXPUpDvbmw3iiP8qZj1fZ3SToN/v9+WgaHpqM7vFIK9luYlhn8nmGHs
n6J/LxLoCn7tAYG1QLrR2/s6O/Iff6RyoDSEp7Zd+gCUXeyrdZ/K8PcEampK
6YvFpf+831sKtluOC2RG1ILhU5sjv32ZhD9URus5Q2c6WIkl26d31QH16Gk/
ybYo4Fifuuz3tB4ov6z75xbGEP48/50neAXU7rVbtWUbwMRx32a1nEIwibkD
yq21QHsjf/+mLJJbo5tC+6/UAbn521fLiRL8f355ePbNedrt9SCsP6UgsqMG
tcur6R2sOmBka636JcmEWOZMxoz39VAi8KaWocjE//eKX7tl5oV64Cmq7tQ5
WP93vNYD7XuFxGrfenB52DvzIrJv+PH585n81qep/FQ90LtPZjo59eFw/vo1
kvG7elyuAazGlrzfrTX5jtr8PSbtSI7W3oJza19CE+VR2W+vRlz/4EhqyNqm
RnxfjsiClezHqoj9pP9MM3Yl/F1GHGqTxgrBYpPN6bm/6oFh7dw/G9n5dHfP
ZVH+DcDbOP+V7W8GOHCH6XYKjcDaytD8dDILgq9qdA0mI951fsT2Vjb2l+H7
h/m9rzrotLMJtyddzIYe7tcIJl0/zROya0Al6vgJy+WNwJh/dd7LY6g9tXZs
XpTfCIbXrtxJCmbi9PjrB/PZhruWdk3g4hA3vGpvIwibLdZjRzZAsJP90xtH
UHuXO1rX+jXi9mYqPnh8BKVn8qXo0bGnzai+pTHeqY0gfoaWr7eyBaf/P32l
BZi0qUbv/jRieR584pNpbXkDWKj0SIr96sbfB/j6DVNp/cyGo03QJPbulbo7
B6fH70/xwWln1RiNYBSTEWn2pI/wx8rwN/symgpNj6ypldpNYEUefbrfPgk4
M6f5+RU3AalJ9MfYxzfgstKg5dbRZmBcizryXTMayKlzgoK/NgPJa077au1Y
7E/B729a7Q5BxwMtuP0ZKYpdH7Oa8XwUd19gnJvdBH6lP369KirD379MpPVT
LD4V4/T4/UViP76p+LwFrGbrD6SKfQDN2Fj7V1LNoPL95ILt+Uyg3vr16GBe
M+4fK55FepBwCzR1eajGB6J27VXtHKE3AWf6kfOLN7NBZcbhotupTTAi0G81
asXG+fPb06F6SyBZrgXY29ti9p7h4PLw29Mrpy807VEzcJLGn9/j9uH/Z8ZH
llw/2I+5KaZz6lgewTYRZuky3n04Pf58Er6SH1f+oAW8njVHs58M4PBgyYS0
p+ME/8+fJBEsDL5sXDmvFcm/Oz5xNgn4vAtD+UYQVz8eySXdY1ZJrUBSGZq+
s/s5GC6wCBZWbwOKjfNK363R+Hw9v78o2j0XmlPbwK+h/LjN2UKg/wh74uaM
2v/yHtA+mg/yAuqSRd9Q/h1j7JlonWZdrUrzckb5CybuPKycDfQtl+jhI624
v0W2mjOSN6L8OKeOblGtBpYW1ybAZDI9RUn2cAW45IlZNjehce4x1mm2qBiX
h9/fVke+6mh9bAXN3wvBdHMdWFnsFjAzQO0zL9h/8AOS4xpCLUeHUf9unHls
4GYN+B1V3tsS1Ap0S/WA7XuYYOXT19Un1wYM1tCJnd7Mf9KvgZGKK8MCKW1A
b8wJEUL6H+3tqfAvFq3gMFPz19WpSC6GXHYoXIjC+81TZ9+s/8dfAsmlsvur
Ro+3gcoXKZuN01ohdvnyX7qnWoG3xdEnbzOaJ8vk36+itAGz6fzVJw7N+P/8
+U2/uy7I5VYbjAcKmu/q7cThfH1AuO68xYBGG57/JjdWLlctaQGRwxmh53q6
cX8zDdbOu3mpG1jRJoWqU9qBzjiwIEKJg9Pjj1fqxwf97xNRfz89EbBpdz/+
v/jaV6nbigkW4r57HGfVh//PH59WF0yrmBfaoM13f0C7wSCOH5u/sXZxDMEs
zVDt5b8J5rWYO74PG8DpDfcb708kDRLtcf6IR8A9wt+D9Fo969uUQuB4UEsk
s1D7ZU6f8mlKPliUJbTN1Jj8nsUQYAvmgtfYA2YSvR3ID3RnSNVkgSYrY5qk
agcwUve6MVyqgBHcmVL8sg14Tw4+iLtVAbbMUzNMpdrB4biGS/G2Yuw/wB9v
TaJtFW6rO4DDGJ56LqQWVBRGeeR8VL5TLQv0zT4gezVzys/D7cBz4M3Zr1AD
wZ+j7zX0twOr+ssf2TlMcHFx0om+2AHCvbq9h2mNwNOKUHed2g4mqqfyJdG6
r5nXufB+ejswMoZuu5TXAe/ULtf4Ix3ArHER7Rpvh+At9976WnRAUOihohdI
X+fvXwutPzTVz5LwJzK8kzG1elkv4V9k1qFTl0CwpriMweBtDq4fv/8NhRpb
bYw6gNXS5PTzZR8O5/evSs1DQ8dv7aBYfarC9/Agmpe6i7rQ+OTbp3Sdnl2a
r1H/vdgbxEof/PudsY24H7XF6pKMbQhm6qbK9MXHovD3Y6qRnAbVLITgLemV
B5qfA//+VKqy6Bcls1DMpFhm2XqLKODJqFUO3R0CamKbfFTbE5AX/VGaV4Ts
z0txjQ88n4LI9g2szaEoXGFk4MsiGs6fIXD00l1mPGbKmLbAx3nviPz3e3jf
o7/CTLptdZFrm0iUh3LTOvblK8w0JfY108tv8X2ulJT7UeeKXhNMzfUsFibS
ZwlQTmfuSCHSp9SGUScyifTcRS4U33iPmbxyvfiV6AycHu3N2k2xiSmYyR/U
d52tzSTa29cn11A+B/+f8tBp57nPyL6qb/SsvNIPlP8UegawvJUu66zuB0av
92tz61ygtLU875y8P/pvuNGiOc/kawmOZVMu2wWj/r4/TuoRR/bYheaWoFoG
cf/D9FOO8clI/6orUnkphOyL+8rXFR8zgJf3cH2layEwDrVpjZiV4fgqg/sm
soTLQEWrz65yaSFQ1kUtm9JZCiJv1NqWni7E5Xe4obBPjlUAw7MFD9TF8P0/
CsFW+mzdoUGCfRw6Ax69HASWD9sye28hGF7YpvpNvAF/P/dTts0MG0H6LUu3
wcwA6Q3iV2q6zQdxOEVg1syZ4QR7DAz7M1kEC/mqlFCkuJh9XpbmNthMvtf8
a9UK91Jw+brI2DlyEKgW40vvK5dC1Nn8zbEnkb1a/U7K5VkpxIZ/5saeH8L/
57Q47NoTS7D84olXoyyCZ+85pzmE4ouoHH0/NLsUXHcfsHtEHwIT7qmyhV4o
/zh64XE2srfSltga6ZRC0OuxV42XUfy9q1fMnV0GqQ/Tj25/OwR+bm+3Pg8v
BWGD4XRrNgefb6If3vr1Zx/SB6VElceZleAa+ULVQqsfh3tZ3xETCiGYJ3Mk
LEEH2e8+tudzsitBT8nhRPGNQRxOnV0Yxi39f8zePdVFGcmL9TPeTXWpBI7w
spv7PVF7Dm41KsyqBMMbreH7ANmn15ZfGtSvAssaX5NXyN6khKxe8Uu5CqzO
JEfJ1pSC4cAxIZIw0sPvPQrfLVAGVq1uTfHra4B2+ohS5BgH3/ctzJCJmTKK
uCQ7NJtSA6wjYj5zf3KQXvhTqd8Y6X021KofaH3jx1e/ZrMv7zXBdU7RPUIm
/UAqvKnTgv7PaDZ1WdqZg++/8LtJLd8hW4BZZU7TnuNJDDB58iBB59MHYP2O
CDk1A63PHp/eyy2shYIMzyULLHrx+WsO61rVsTIOaOY6eIdvqQVGcmiqYwEH
5Jddvp51qha0p5Pik1D78+MPi4+KOj0mOElI48aXDf0Q3L3K8SClFqguHndc
fAaJ890PFo0uYv0/XhYl16kzCBZP8qbskkX579i4MdN3EIK9eXEH102+z3pl
bhdqf5rs7wHX6yi9RPepxaVDUCLNTmjeUwtieqarfiJmWc+6MtumFsJq/ngt
LBsCTok+W+12LRjpJZjzLncT92X0nNe+RukhztvvkhU8f74bRr5t/DB0uB7p
AzJumfu7kb5r/rsT6UlhfY8TLZ4i+0Oy5hNJrx5GjKV69nztA5Jt0M5txvVA
5kxhiFii/pltvsJgB7KXO10rVNhoPaqTzHbMrAfD9/d+Cvqj+r17vkjKDdlV
YYsDIzoI9pnLufVr8j73Um3t6vB6sJWKddZB7LfKt7c6uh5SK2nBS8tRfXy3
OdgF1IPKjxCqQhXSN0TnL3r8ph7Ln5IKJ9U7PQ2YGY3lwz+6mrD81bxi4KO1
tBFK/hSrD8d2Y3tVUaA2wtG6B7O2DeVGoD/S18qdr2e8agRKoWEU268byC9z
BTNfI/urvP7iqho0nx25vIuFjeCzjWE+DbFI+xKqXHMjzs9LM/Og8pJmzBZe
N39cymoBm+4NbqWOg8T5q2lJ84+VEJxalHF01elB8Opsqd7Z0AxRt7lqj22R
PF/Wtci/oxkMYxbfVYwfAs3ry7Xdq5vBImLa9FbE1AKTIxs6m3H9/VQ1DIV7
WjHHDvweqlnZjsvDWbxYzUW0DXOJ2BSG8z60DsX7CRZZ0vF7FqT6shLW+rdg
4r8vRXBfB4gLC9wrzRkC8cNLvuZod4DfyomI6PgSfN6zYGh4849KLvhN4qYP
SL50ntRcMISZNEq9l4PCxVfkHdMx/AA2W98dk0XhLqHbTlfvRPz080xlxCOe
rGfGDshOWB/HmOU5gM+XpLZuz7h8ewAsFj28m+hUBxJG7MLkl1z8Xsfs104J
83gEU3fm95yP40Jw/zHpwvgG8IoYDBN4hcr3zC/kc34DqA82ygt84QLvXMCG
PXENECa1dkfLNy4wjk4O0EZIyg38JPuKYInwym2jE1zcXz4fNO5QjYcwu5qY
T5xIJsILpvTf8NiDyiPR6BaV2AISX2bpnArnAjNnrkYpuwUc3MYvJG7nQmrD
+hOX1reC5TMq+/5TxJPH3XgtQDtxt8q/j+CC4pFjz1B8l8xrxy9uaAVhgSqx
k0FcIGtLR8RebwVFysGJHyh//nkJhkbqNi0R4v2rIEuhT9sSucDxkiib9M+1
yBfwG6Wj9FtXP52h3w6GI34Hf8xB41lfxVhmXTtYtdOmPJqF5MvqTRtddqL0
vpkKWS5C+ptp6vErzHtgxGR79kz60xmmaJka3YUgdkXfRwfECR6fOLmPQbyY
GrNn76R/7bp3c3/4A836UaJIFAp3+DAjpfYR2IRY/P5cSJxPw/dCVbaYvR3J
A9bGFSQ57WK8v5kq52sVObcPGEtUqkx4eSCkZ/gtZEEfPp8yTK9peepBsJUZ
hzS7qBeY6z5TNfwLQD7vs7+kyP9732fXNp6/G8ES8TLnzin0gch/9n4JUKPn
teibxeByWXnr9NYzUwieucR0VmoKmMi9zh+eVwys158Y4ZQUILme9hltRqxU
47Q2vQ7PD9v0Z8l9szrx+Xf++RDyxukBS7ZN7r/uS5RV6gRSo4t4im8JUOb2
XQl37cLlkZfKW3NjcQ0+DyyflLd9xoJu4rxzEufSA50uoLxTOC3LqEbtmvJC
UL8LSIfW12atY4J2tFHCQrFuoMpLuD75Xg0OpMuuQQu7QSV7OclVGtndA9O+
KCpwgHRx0t+qHPwMbm/+sZnQR0pWqRr9MeLg/OyXLXRpeNUDqb9Gh88LMoH+
6NLjea97gL7YiKS7mAnjQSb15aYcUFlrqVqKwj2iRON270fpRecK2C9jIvv1
S39SWg/2l7I8aJuUWszF+fMKfiVvmD2E2StUykG2jAt01szLmz6Xg3zbgT0P
5w0Bz8/nsWEval/xGTfF0PhUEbjzc6pqBSgeaFu/XLgbr7d+LzwXLlLowqyZ
da2bocfB8sk2bZEU2454v4Td63Q62LUPl09MepWj7q4+HD/VaE9W194+nJ7V
La/51eUEe9WrF/g1EPqFuGnCyaUJXJy+xwmS09QvBM9+ovB7xlskrybCvTTX
MEE+s3V2DGKXe57c1PWovQ7Muc76ygX5uO3uurJMMPuV3uQyzsXlk5VaV3Yg
lWCX4wNv7jV2EfeHeS2R+jxMrP8MrsRUkwIuqDi4bb95ow7Ir4MTmFOI8+Nm
OsJ9o9lczD6VS/YpX+f+s7+A5FtL2WqLrlYg2fXtmd6M5KnNpABsI+5Xn//a
InTSP09Tqqxp+wEsj0j3/L+dmfABeWmF+ZJUxEd+thol3cb+OqT/9ltugfhm
/b4MtD7x54tIxme773/awFZ/m+abC1xsD/vUcW94fubi9et/+zFo/DDO+Yw3
GxD31/G+p1bln4WRCBvy7A9c/N4aLdW+9bgGsoN2ZguscS4E2t0Ku7zVhfj7
ie18cQMrXu8/33+QvrOtYMb1rUUgFEvPOR3RBSYvD48dXF8K8RfVxKfKdQGt
8PyuvKtVYFa/PM87uAfI80R79slXweydenWGET3A8/T5s7epCn/PJb87Fb8+
qQJU0m7pPP099Nder8DhpD8vnZnXmBDFenGr/Q+S18nCqIeZYHNC7+gJZzT/
IufuLI5A+mFDZ4fZFS7+/uGwNNLl6kkuvs/OIu52pzUaj5R806ET35F+sYc7
oniUC7QZtwQOz2wB8mFq6Ec0/njSgtTQjGao809/sPgwF+9n1tm4/Xp1gPB/
9Jm5tXfEn2D1joM7hA6i9aNxbNj5dwXYa56coh2EynvXsZC9pBKCbs+2oiFm
FRw6LiKN7JVfTt9uhA2B1X/noSuB1H6zT/sIwRUnl7Lm7R3C51OFJcejPvsS
HBywRi8RhVNkB0V0WUj/OGqvx0PhTYI/Tmt2fQCvdYtCXvoS+rNHfVF4twnB
KqP1mRInh/D5TBcZ9V2dx5E+8vJAmGFiOzT50h4d2DqE/WWsVPbspLkRbOFJ
bnnuS+g7FbTbMxr3EEy/d/ue/j1UXnfZuLkrULiYwvlgfdQehn/cdzJrQCjf
766UAdIv995a+ryuBma7NqWwdqP8pwV5r2mvhaZx1bvOvgTPjimhn/Ujzt/W
nTiWVbub4KirnwPiHyB9rfpgrJxhHRhZyMM+pK/QZy0oXfoLjQ+h1arqJUh/
zNwwf9lEOwTH548X1KPyrlp6WC4c2Zfnb39ffYDwB01t51zqfUBw1LljZyf7
h9SUd6Ck6jqIjCdl6R7qw/K67nHVw8GTfXj9GBcxErjygWCS6LLWoMJQoJq5
X9gSzgRqYJLb2FgwiJtYDNPuMCEoPU43d9UQMCbF1dRqGMn22rbgxP+R9e1x
MUXd3yMhhOiKShEVRRIlsYaK6CIpUmGkFEUjoQhDpSQMXVEahFS6Kd1ruk81
1UzXqaaadK/pIqEIv93z6Jz387x/fj97n332Ze211nefdfbCcXbE6HHZVzi2
sW8P+I7qq125bZKwsBr01jmtC0T11V45uWSKVQNlqf1k3QY0P6u+fPt0B7V3
4HjqXK8R7DxMI9zmotBlxDfEtWmvJFqBZ6sXqaQ9An76cy9a2rcBTSZjZzeN
jdnv//rXSA7G5Jjn0pG93/02/E4Nno9S5M0KImFZEZYPzPTjZJ3CvG4Md63T
2rzsI9K3vxy+FRxoAu+VAstdNRG/URJFNTig1rrFfo03jnXiD+6UoIyAwcNj
pQFJHJgael99ANVPDz3/9uF+Dmj9YK+o34bmY+DO4r9OHFB4tMtkZ+rI/9yH
hMZ37djAql/NMP6R5OpkjMaXXpMzy74ZBAPWH9/6EcdCK5ct/2qA5CN6tcQ7
32aYmuvE7JnGO5bNX+rXDN7eoavHW/qAOEicN9bABGr+Pq4YF/H5v6IX1ZqY
oHCA5nbZox/U8unbAvOZ4Givn//8Uj82/v9+T0LlZoIvr49VgF1qRZb5ii4w
uOQQPfYU7W//+e97fvaDnPwBeaMJ5H8Ih5oYITyjvzRW+vX/QPp/hk/yCv9c
3r8Bx1Grn96u1MDtl+DJl370azjOFn7ScHnLMBj8CX57WagepDNz9kpdQf6q
blPHPrt6EIu9d0zm6jA4wplMy8OIz+r52H3XRfxL0iYuZWk9aHTmNEwhfUAp
m7KnSCM+/PXWw2BfpH8Y04ShHuxe289Juz2C9WeqR71m0c4RjE9ERSkcsPDF
cd+br5d8dNB6W73ndGs2glA/O6Fxx8h0/G1TsGkj6HnVhyxG9cmrqRe2b2+E
OusNvLs+SL9Nb/e4RuRnq4ukbscxMb3vypkr0/dniJTkPLQC5+0LLx8PRPO/
u/xnkQAb/LLdXNlP+jF/wfOM4bwgVE6qqypqymSBkf2mNPk7+P/s7uXfjmYB
2j95m+xlPyJ/6Evtt+sIk+TnFe0rZoFG7CKvRDReVsjm4L1xyJ/xmhsfcR3P
92YnavVASQfHxIvvR+XR+AjuiqvFzrLA8obatq9n+7D3kc9pLSI79AEnz+75
ik8sSLlnm7DvTB+MChy7qFzIgrCQmuMCjX0wcaPBxqwA6feT+1TiSP1AMNZY
I51ZAwZbc22FT6DxGFlYXKqvweTNscNsSOhQDTAKEvVFTVB7dw+mhqSwIWX8
qW3J/j6IzvzydWycDVRGzlExsz5wfOa0INcV6fc7EdDkN4L9v5BYw3TKvDeC
8U3LPsqCQS0cR31ruX/TH+nb71pfrK81wJTwu9k+W5F87I9dErqiAfoUT3gV
aKD1FF30K5HYAGTqyo9dX/lAJYYuXadVCkaTqo91J/hA1A3RiYsohSKfFkVO
Ph87fyw6Gp2gvRg//8xeuKF1nTxersIoGtx/CcckM49AXtUgpr+Kamc/KQjB
+Y6jW0P46d849pa5eut1KMIia68G+zJAmih0v4Q2AHI/7EJXDjFgtGFL1S6B
QaC7vjcrzmWAmqrSinaETWODbb0ZDDDV63ZYK4Lna432YTQ9+zCAYcqXTfvz
0jIwPkH5rqeZOisTSIsfkrb1VgP9wPmQct90oJ9d19kvWgWkMJmaHToZMJr0
Uz30bxVQvqrnkA0ygJT7sKhwUTWIDBgFOVkVQ6I+LZYzUg1Eurla5PViiObu
l50vzQIe7VxI61Qx9n8WXfPhA9+6IiAK+W2ysaoC6t/048rjRUAtclD0iq4C
uW9WkQfQe2biTYhp8gTpXdXg1ztHKW0N8i8ma+cdujidxzHeihbCBv7DzAEH
ccTvdjVcnDVVj3i1esrhK51gKu8iGLe7HrtPj3phfMsHc6Q/3kc0ZBzrxPRD
USvP+YYzH5MfwVVWh2Tn80HrfmG7dFcDdO0xOtJ6hA/uW87LK21sBJ0a2uKn
a/lYfEf6HcrSL6XInxqr88vZXw8U6+0RRkgfEL2XnRBOqge3CfYbZ2QvOAfv
BOQ2IP9fNbhWa4CF8WuqBOOnbH0Vfr/1f/zlKlCbXTqrP7UYPDUeTzJs+Nh8
iCnerHNNxfHUm34nwXn4fQGe31z/2ljwgexr4/dkUw3oPfkd/nvOEJg+DRqN
W1YDE7Wqq/UJQxDNtzxgdKIGpE6euWySwgeDzIo3X8VroOhdVWjYCz7Gn6KX
XX+9cRjHbtp34jP345j/sUlc4OkQCL0OP2UUgd43sDb8CXUISDS5t5m9NWC0
SV5FzWAIWAE/wstf1YBz8Mg+of4hsOz+tCI6sQa8EyKXS+gMA+l+iqbJgxpQ
u/v7knvnEPTl3gr72IGevzQHVu3E8+VOnPRNk9Acxvw/86wjQQo3cCx09m+j
uhbyv9vXmcyjs4Hzi3Rt3S3kT2//4StTgPRh8dGPRncQnxrUvXW4hw2OWy5l
kP3w8zP3XkfPp0QcO4ptW3VSnw+EdR+UL1rUQlfh2w773XzMv5/JJ2G6g35J
UboObMZzy52f8zF/cfy6wlaDon7gPeYFR2yqA8dCCvPU9gEwKHRY0bi5Dlhu
Es+NsvuBnq597Ud0HehVJLhcT0bl6S+Da/fXAT/v/uHe2AFw3MDd20lBz5c+
PW55dwDjk2LF2x+ZSOCY79KyYIfzIGZvWWbxdaMyg9h9YzPxg34nyB6mnsge
u8vzK6vxchH5RnJ/6yDWf2pDn+n3Hfh4GI8M2vyaB9G8rl+07m8t6Kidunwe
YdrvsEXjhDpwXh63nKqN9KlJqP7iwVoI22DQLLeNDywDbf90kTpws+IPGKni
54vm9x4DpW4QwzPfT4ViK/ZGb2mE6IpVdyYzhjB7PROvRz6208+7pQHElAI3
20gPY/bBfWNpiKc9jr11H4zmL0f8XDWi4+dqtL+fbH8vIoX8jR1HHqttR/Yi
NO5gyGkkLxM2B1+taQBKi9aTebb4eWZU8Vl1sjiOTbd1WOYtxs8neRu/BkSS
cKxisd35rzDybwIWR1xVbQTB5ctMF80ZhokrTxpGTjUCZ3dYa5jpMO4v3F8U
VnFoGBLLmF/WRzWCaeEOY1iC9EuR/62rPVyIc60p2eqF9vO8d++MERaK4nD2
HULyaGU7EJfYCm67h62UJYcxf5qs88hT6yKOzbtedVWKInnurghf+4YL/BSX
7acWIbxd6uuWCi7QhBZxMp3Q/mDeY2z/yAW1edl0NUc+dp6XIvnCpvwTjqfO
rUpZkc/Hv2/m+/69ugD/X3c0/4CEuxteXvfwi96GUuQfWCZvLPLPhvSNW0N3
ag8Az+fgNXufbFA4lp16rBuVPzcKK2PkQJfkbnV64gBQPJbt3DqSDaOyiYsc
ypF8b3VQX7g9F9wU3/d7PhnA/k+288o94yWPY65itvhaPWQvlackP5Hywf2R
ZO7TMrT/hJKpvnvzIe5UVghBCbX3XuFa2hM6kLVzmpMq+7F42IlF/K1zpu+b
3n2vUpWcD1zeFdOjLkg+/3OeUwTOx+3DN/7B8xvwHjIz79EH/yffAdoP+erU
CNFCCHc/6+fDx89HOcH69DkDiI+dsKLYjRZAykBXxzJ2L3YeatrWfS2npRfI
55c9ZMWWov2V9VItAvWP3a/5bTVj+ruRz3kVxHeewubcSeQfXLxlf6SiH7Pv
nNm2LgcZ/UB7ufUawxXZ+4gnqSLmyA/45XGy5wQLiK2L17ZcqQSOf7pvnS0L
CLMMRr+cr8TyBVsedHlxdLwXRkPj3/bLloH3+9yoQ6l9WPwotcZq87wy/LyS
eYR3aG8J8udSHpjPfloBPNWMtqcFfSDyUbxzr30F9Bn94GUGI3mbdWipGqkU
7EzKrpJrhoH83mnBA34JsJJHyFVWw6D2wcncmVUKDM3ehUlmiA9TpW71LC4F
t+tusy4dQf6aS8QIvbgUzH12K1yRQv7dcR3f+IOlQJUTUHQcwb8/x32YO/Z+
E/69OFHCJ35eDF7On1IIE0hC+z13Z2lAVRl0jXXYdyD551UfX76xtQzCLJ44
an9A/TmrfiiVVAZG9L6AjReGMX45DvPn6m3iY+fLIob6dndu41hre6JubC2O
5Rij0bIb0X6QirSrf1AB5nXR38Sm86m3/HHJP1IBnkSDjaKoXC2wV6N1vAIU
CMLv10oPAaFWxiZIB/G7T1lX6NVIX0o8figSWwEpvbJ1+y4iez6gIKrIZsLo
uz6TC9P3N1g/nhziMUGF6aYQkTYEox8N1JeaMIFANyv9hPQPcUdKzZJKJsi9
/vzLoBT5r64aRyZ1KyFKkXVj1148f/bM/6NqVQeOLjvFBEaHvyIR8bWZ9Sek
/0j8dgnHzrqmD2ZtHQbC98P0OexysNPZHR9+Gb3PovGWQUc5qMiRNLYhPke5
2JB5TqAC0qlSyw554efN3h6FPFvAsdwDieYtOiNY+9GvXRy2XsVx375ZFXpJ
OA46N/+zsRd+Xm1Trfwu/gCOTQ817l+J+JGcfanJifAKYL3kiEalIP406rtp
qzZar2KGmCF6H9XnbHdTYzloKSUFXts5nX/OZMv9uRXg9vN8lv2dfuy8o+vU
kMPb7zjOrjL4zbqN9t8cfZrXhmqwuRXjVUpB+2+5a522czVotSzYroHqi8iK
q32WrAaD1vMrX39F/Ppu9dc/7tUQ8IisrDXZj51H67w5c47ljWNvHUOu9zE+
jskPqAs/4FhEeUnnEPIHZ/xrps6i1Zv/4FjlaP8OpTk4JtS9162xxTE3clKu
umYAGw8/pFt6F8IUo8rUdIlqxCv89SOJQ5h+MN0/f53GmmGsPtd+3tIWBxxP
3F+gmorKSU9jd+zcXw3kmE8GWQhTrg4OXjdC/OKtnPvxs6g8lvvu6Z5qiLas
6BZwxs/j3XhPkGrGMalA9dRvJE8z/JXLvVMkuxHHXdYnp4zW4ufvevTsg5Gu
OOb8vSG+Q3EYwlwY3gEZLKC0U5c8uDIMfXnexkoLEN/sMFhqjfCEYeH4nUk0
X+tC2pzZI2A5HC63iNIIjK8vz5USuzD+NnN/i9zNVhsbCQbI1fkYuZlO54vh
enaJMWH8jEVZs8kI2j+/ZCWmKoDW4PxE7CjCcP9r9lUmZLMfuJkeQ/I1XvFK
IokJiU0W67fF92L+K2cZ9e4yL2Sv9l0n7yhig/O5QKrLjX4Q+kybFYT8VWbP
aceKtn78++4m28A2Fxz/1x9FfJssNXz+Ahvi8msar/0eAa2n0wdMiC9UycUQ
6fj9gYTg0wk/ktIxey2o9bw2VG0Q+aut4sL5SP+osnrkNQZB7ZtDX/A3JigU
Wqb1+SL7ds3CwOcmE8Jdot/atSO+OSU5nOXPBMeIa8EvHg8CNWdRW7tsJVBH
L2s2tQxi+kV6Vrg4L2MA279CC1UubZAZxP9fmAyneWYj+7rO69Kz7nJQyNyX
FNiLfw8it7z8tgX1x3Hp3PSoNOSfv3/8bs429L6qvR7rGmsgrPR+6twgxI8d
JTOs3yB+I7bl+uxvyJ9t1KRY3K8BbjjbHUJRf+8aXnnVVQM6PEfX9PFBjF8k
pievi2hC/va+3MAXSWwINx0mJFcPYPmEbK4rdS5jDwC1v2Nx/ekS4Bw7kaAw
wMf97VizIx6GQxg2cPK6WIHKOczANxcFEN+sV52gID7FE4q/aKxYD34fh8oz
ET/ye3rn2y6JeqCtP3LEn4jHa2i83tz5ENWfwfQLd392qSD+phWwgbSsAfxS
nMrPIXljPJ5VcpRaB8T07x9DER5NP6wof7cOJnKebgIFPhZP7R6huFLPE8fh
hvOUpZtxbPQmQ1dGHvnv1+hN/HAO2O1NX/vDgw/Em4OMgCAOaPW7CP4UR/rj
7V9C6VcOpCyvDZCunc6vt/ucXBYH/OpLRjVy+Pj3+V4dfXUpPN6CnkBP30HA
y0d5YjHMkzjW+2xdYXUL1X/1Ze3jnU3I324LP3AN2bNcPw9LqyYweD7XVrp5
CNQWnD9osL4JjFY52Mkg++RotLUwQaYJyLqxRe8qEN/kPVmvRWmCuK+p6SsQ
X5zJrzDe/zfb88Awdr5LTTDiiPjUY/w5es6G03vuIft8TSow7GMxuD8467NR
HWFZsUsa9sXAWL7d55g7H0bDPLc9aC+CCRmDQmvEj2b4O+uMCK82BM9HJbXc
o6HcAK33OKGsZBp/fyY1S4qP+XsBpR5ZP3IHMeyn9Pio0Vw8/xGW3/rc3iCZ
tErQ8X+mUYPan/k+Q0u8knjSCMdRZlmnhNDzM/qYJrcyK5s1AkoNvsiDqQOx
Qb3E2Ar8vFSr9JN0CnMETOs8nkUI1cPEp/4crcrpeBf3OUdn1YNOZTVPelkP
EP2WtQq+a4Dxw3v/DCzvBk7grwMG7AZQWxnk0UZE6/8s6Weubg6kKA6YRyL/
hjJv39CKgGxQY4lKsPTQfCyUSC+4lAMqS2xTBD+j/h3g7lc+kAMcy9irQZJD
QAk8TZC9mQ16e0/5nOtG8215frXpPVT+J8dwoSSaL5ug/GRFOoy/Ffu26RRq
Tz3RUYGfB9m07CPNgN/n9N94cdSfh2Nlxan5YEc/dkK9jI/Fa04YhnALbuCY
d9X8/dlDaUApSr+YVP0RiC7soPywbCC+fbfQnZIONMFct71K2f/8x4x//3N1
Az3XVza5Af/fiHROZe2t09VAKLA3FZhXhs3/f78fIj0bPyA+pusBiRDh/sew
EggTYirnw7xB6aF2vNY2pMdNH6Vrz9kDpKBvv999ZQNBrkWmOucBiLgmcXWe
oefP3FYNsnEFupLSoo2naoGgW1TMycPjgwm3JXWsO32BbruI6x7WCIQ3n0KY
gb5gkBY+l5feDAQTv5NsET8wKJpbLtfVCBSF1Sa/DzwF6sDd5d7XuUBYLLuk
9eJTLD6JsDF1ePFTVwjik+yY63hAGBXoTvWwBeFz/rb1nxHWalAoNHYBd3Ny
6uRmhM+VD5zpCICoDJcUSSZ6fjyNLF1yA1KeBfVyHyK8zlAg3cQD1GRp31V3
1wLlD3X+6pVvQOSGg6B0PMLPbB08qqOAdjv15qHlDUAUMu1NNkY440rH60NI
77X0WW3RjQKKpaVVsmEt0C/ZHzed+ACUsl8xT+82Al1X4oTp99dgSnA4cNub
A/ShCGEB5mvoO3sthVOBxq/2qKGtBpU/Clz0vKAJiD4J2npFr4EaKPis8DB6
PpYXWNQfC6QzhxakS3OBeMXbdkAwChJ9PatuTnGBUhhxdKNaFIg4PxkQ3N8O
9COfFhmviQK53Bar4y5tQNG3/CmjjLBdgogLpwXoryOZ3amx4NnFtlEw5AGx
SDWoxToOqN/0Pt8/i9YvaafBk0cfYXTHpoapy2g8EUHH6b4fgfXlsf+UagMQ
lnxoD0tJhugNgjt+G6LxK+oWfK1A2MfG99uVRpBL9m659iQZWJtXTCWHofH2
/Ah955YMliJ2u6ylW4CSKtCiPicZGEv2P6CHIvlYNsc3Uh8935o7VzyuEdlv
savbzdLAMdB/0b30FiDZf7DLm0gCvx7OHMmEViCl33w71yMJ0te7riEktwPx
e/iOyj9JYCAeH/4tpxWIEe3nCq4mARE+Rns3tQDR2WK3/JNPIE3+G8DZiuTh
8dwya81kUAsS182u5gG9TdD/3IdkULFb0lGdhuRBdlfz2ucfQYirIBC+G5Vn
Jldl5n5CPDCmYodNCfb/LNWDtrg3txiIbQtOPLPOgbCuW+X+B9H87czc3bKN
Dox7e2yGjzYCUWsNOz8gB+QqiCLel5qBHuex8khENrJHqVdfOaL1ZG20OfA7
C0yPW/R8LueCXOHeeBYvCyxFWbls1XYgaEQOJiZkAa/rW9/HO21A9JKpi3yd
BQyPo5yb4Wh+kpfe+bAzH+iFFwast7eC2l3boNQxOmQ7GDV8pqDxvlvqcnRB
NoSnqJ+4HcEDkuNpx8/y2dB3t/6+457PICfvjJy8XDCd/MzSdx0AwkHu3FCJ
PEgp/vvSHfnbcrqd6+eF54Iav3GdEmUASEOb9z+vzwOdXauVUz6g+onig6tF
8yHxU6GY/PR50/xc+81R2RC2rfD4w0jEt/hOMp/UcoB11P/teB3ytxXONhrY
Z4NYeFevNuK3tJEssvBEDoTrbqxi7B+GxCRCwgkzOlj679hy5hbyt4+orbvJ
yQONFQFeme6oPbMqwU2b8oBgoavUVYD4+oai180KdKCLiJaGSbwDwvlgWy9i
MaitXdquswLNiwsrp0+mCFgpztoRbeVAZ95Xf9dSCITf2jGM0HIQibihss+g
CLSYxld9kbzImaukrzxRDFL2+8XH/3JBrXb4WJhEMYQ/WLtKxQO/z8jgp935
jkwcF3lCdeIkjrl/HH6824r/jxtNXn37hC+y98WyUfY/UH2b7QZD9GGgPk59
fexjAbgJnuY23Ufl4jIXXaUKIS69Zyoa8RG1/WIG28hFQNx83Gj6PIKk/9lZ
MaMQqBq+G4Kn8wd8OOAUr18EpIHapRPZeUD6c1z29BLkvxpKZVtu52DxaUrq
C40lxDjAS61UeDRcAhprBF8dzEb27GBnicweBvgd+xpxmTAE5Mwyk+ZtDHBe
wD5fnIvs/VmSwuRHBkhdKjhcHoD4v9nm35tR/fHeoc43T1H9L/c2LWMzgC9O
uZu6dwjJwbdgyS0M0ONRr1Qh+0Z9trc2NLUMhF9sdEsv5YPpdfUxzwtlEM13
XGosg/i+TMnrW0vLwfP6q4NX29D6u+k8aP5RCuGdJapzlUeAfsZ8QZ8bAxSe
dH29a4X8x1n2zhGI32hJ9tUuGkbjd333R7ubAfQY9pYg5E+wthc12BkxIOBh
9RCnGfFnX/Xy0XwGRJH69smEoudJdzv5RNRf4Qa/lF/DwMtylW7rKANpJ7Mt
F74Ng8jQkjU62mXgbJF4uAfxbVKfgY9+URmIXI1vedQ/fd/To/spu6sg6hKj
yX9FD7DsnY8qyFcBn9qoV7GtD2iPdGr/pDCBdW+/94ntfUAmVDz9jfhJyqEk
ksrePqCQM/N3jldC4qbqWLp+H4hcW0aT66sE8vFx5RsnEN9tkfphcBnxkcc5
t80YA5AoGlMpeBHxs992V5Lt0H48fnWkdGMlcAlZqjbMASy+xlyYIK3jjJ4X
3yMrolkFoz0XrALOIn7QbOH4m1YJ3h7+N+80onIn4wyyaxWorSsUNlfF4/9n
7pOQW5f1w2puJYSRH5/WlxvC2ldRv5Ao+BTNb8xQ9/LwSsj+fOhWbjMejzNz
3x6VW9r2+XclKCD+GIPqk/4TP1MJUm9FxEwbcGx5+IGFbCTy7+QpWxKNqoCy
I0dfjlCP8T/3C88Ed8jUg9DSOpWlSmwQ8cifd0myHkbV+l+bybJh3Oxrd1gS
4jcZMtSzF1kQ7hylZzyF/C//fZFfPFjgmMu7rfyJD2Ffiyxzs1kQVbYu6zod
lX9ZW7FjFxvxxcwLV5H8KwmtdxWfxwbpxR1vLgoPgXsZL5l4mA1kikisy03E
X/ZVmzUMsyDMj91x3XMECGfh4G0JNmgdrvGLcB9B67HPuekkG3SimHqcayPg
qGnyUnQzwjoNSz+ljkCismHNmrNsIJ5a2LJpdy5Et3zssaazga6szJuXXgAi
CkWSr7yRX0VUDrcJLAHH5+zm09fZQHlP3GMcXgiJz0aPy6rVAMv025UXsUgP
0Jo/ay2rhT7FBzuYC7qw713O7uIXAhb3gJJ4ckFceg1k1zk2Co13Q1+x7K9d
x2tBq17z2OUf3ZAYdUE5bX8tcNoYy2TZfdjzKnl55qUN+H1/0c4ba0sPDsDE
n/uw2bcG/A5cPv2wYAD5bXOFHoXVgIadsvwtM6T/Yye1DWaj9o822q4uHcCe
NzL7Ju+/fwB4BxQ65UNrQdh742tzVJ8VuqZ2VKwW7Nwz69yKBoCSc7L45e1a
0Ml1MLj3DvnTykZ/Vwaj/jNemjydQP7zzi+NeTGIT+ubPfkbyQcRe6lb8n9r
QK52b+G6nfj/E8ScBebW3/jY+wNk1F0F9Ybw8XR8WlsTwYc+s1XadwNqwTMh
TVcKtUd6sSb7tFQteB9d8lL+CyqP5Aj5nEHjOdDkLOqF5PVmkRnLuB7MvzUv
vDcdz5Dy5y7RuR7slhAM9zHweA5n9mEnn5IRMJh2D2zqwbvzoc5j9Dw5kiL0
M6EeBM8uXjl5B+HLMRtJgfUQN7i4y/MYD3g3aSnv1BqBHCisuuEu0k/vu4vn
32yEsEvfllT4jMDEXje2R3AjjN7po2mx8XiOqf2tt6wRZk3T03uNQP2t3T3o
jeSvx8vgR0sj8Jt3bNdDzxOsLHMbChoh8dz9y2dsuEBqClAWDuWAyrvHOwel
ecBIXVsD0/+5yequrhVG9krs8Em6ZhNI7aUYc88hPiaW2eG8EPHXUMuLSgKI
f70SOaHg0gQ6iyT/zH2Px7s7+hbkGFqi+qPTCRqaQPjeXPX5yTjWsKz8dnNi
GPmJxwfez24GjaTynAmkf1kbF+yb87EJGC4O7hXGaH5UF90fIzTD6MhJU0tn
Lih5jG3dmdACjnfaR9/f4oGaZm/LmexmoDbs8E8s6wDKzXL5rLBm0JvMO6IV
h7D9FbhHawZvhcXbPm/kAfXeUf/JVVwQbAt6coTPg/TCwtnLJLlYvl5GhTLj
MqMVKHQ9uRK9bOz+1YmC5qi3x7ggdd1dZmCMC+4/luie4LaDox1zh5FZKxh8
abspuZgHYVOHtnIsWiFM5O7Zv6KfgRGTGvlWrRU4UTe7HFO6sf85Ey/emb8k
AfGzI9F2J9u5QCVcOc+gj2DxqbTirO6/Tyrx+Iw1exJGLyAeHfmiYvnvMjCV
+eHVPMCARIms7jrtcuCdSFI+1z4EStt2GH4m10L6cs+T1W1D0Lfa5P1OdcRb
+IsjklSRP3bRXf/EDaQfKvJpp7cPY/shJdhfsNobx+4MVwejrXj+ib6d+9+9
mb4v7l+8cJxb7jnbZzi2DNWQCejFccCdTQE8NTy/h3fmYO6px8h+XPxxaUtW
LZAPi399EjYEWtFb1v2eUwdRiyfHVfeg/Xum0DL1Yy1Erw5rKzNBWIJI+uJT
B1TijScSkUMglXSMenV7HXCtPjvYZg4BXcOvYWplMzCfHK30LRkCEUnVveOv
msB7u8N5jWXDENaTajd3cDo/au+7PBn8/wuuYur16e+v5OnjzKYmsJwXYP9B
DMfp0m4J7wn9eH7qzYltp0L6geIcLbItpRTo98ePZj96C7y0TKHl+0qAIPD0
fNCdt6AmyHmVYFUCNJU5j8+opAP1R4TuHPESoIiI3pVfR8faEzlwhmPtTgfa
nnVmK/4UA03vieiq4E/YevPKCr6NFX8C0yOskB0rysEg2iZN/HcdULYrX17i
Uw7kZVzjgyV1QFaoeEAWrAC1l49eCc2qxP/3S7j+0U+xEnjBYpx3W6uA/Hd1
4JY2JiRujwys+MgEIffy4qQvLCCnVQ9Yx1RB+j1NPZ0d3Vi8DaFpw+hWqR5I
pLu1r2ysAiH6ykNCIb2YfXcrrdmVNIz/X8BNu7Px4dte/L56iQcvplA5sXuV
ATO1GpyF3SMtDPtgdE8RU3gWav/X0M83HORfBGaR/LdXgV5O48LQSuR/eN/r
pT5E/owRa1/UqmEYbeO2N6+vAo1Dc+Ii5g5j/odz7HrXSwdxHM7bHW+B1ntm
/F33jr5SC+oFA/NvGc0nkf0wI4gWmvaDVJ6ir/P5WtBQmVQ9b9EPiS2fJdK1
0X5IY6QWVPeD0PCpgfJbtRB3ds5Sj84uoP79EreOjOR9jtuL6wl9mDxraVdu
VNTtx7D58hq/nIw+mHh8RkgipxbCyozLPd/2AclXa6TvWR2Q5DfM1UH7Max1
SHU2Kid3WxzsVhkGuUZl37PJtaDWlL/tQCeS3+TzFl4TaP+2Cr6ij6L9EXO0
Q+BqHYgE9El+5KP9FaxauPJIHXgmZj7gaaLnA+OKUyLqgLfBkjSq0A2UF5Jn
NDyqgPYi2sZiRTe2XuTJypd6XT1A7d43muNfBUXzuY9+83vQ+ncxJV2qQcPN
7e9eiW6kt+4Edt+rhaK0iCPBIt3g7qXTfT+mFrsvVChp4O/rrbVQZ04RZqzq
xuKjyRXa9zXR+GbiTeLmb1+T2jyEnQ9yVsQlbpfF49UNRC4EmTwaAcoB46jw
ACbYyC4wzEPYVCj+q2woE/gLQJ/UMYz1P845Y+/wKty/VHtfpFvzCi/3jnQP
N+hC6//BKn3+2SoY/7CH9Qw9z5rdZXvsZyVIl849JbMG2TM7ETP5q1XAUlub
97kV6afl+qJjDkjeBoj7XFH7RPmun3PPV8JEC2mlJnqeknZnKbUT4YUWmg2k
ERBp9zUmnaoCTwlHq+wTqL/Gk8EyC6tgarn8DcIsPD48bsvBvUOvhzFMXmls
fG/6/qrGTmOX08hejDZ3V5xB7fls1TzyqhW8nyQE5v9A+tn1xY7nta0QdVr2
RORPxAe1Dmi/KmmFvt33du+pwdsX2qn58lP9CPSdDvrxltIKU5uHYvcxRyDd
Wjp+YzNqP8HFSQTxIfJrdSMLQhu4Lz0caY/mh1RKkknZ0AaMe6oHLmbj8eka
nfP375nEsdwjRTvT8RFQ0k+2sbnMhqnZDlK0iRFQu5Yo3xaN/NmQidYff5B/
/yPg9uNxNohtj/gqVTAC7pbrqJwBNlDvvsgsR+2Zeu7MrExlQ1To0dPrPJD/
7NprsQq1Z1c1zM5H/rCac63jPic2pNPjX89C/rVpgf33kzTkT9uNpqc+GIHo
UXuJM7Y1IPT99bmk6Xj+2tjUmGPIRVFOO0mqwOPd7Y5rPHAvR/K1yfKVGpLX
9NxNl69WovGIMRYZLaoDKZtTQvum23twS/BJai0wXWWKNBEWap6IXZ9XC0p7
xT+rPkb+S8GKyJMByH71GblqIsxJ791k7F8HBAs9s/Zq1L8qd8d32nXAzOv7
XOyN9Mfbva9ur6gCpnPW6fBb/Zj+SR+YfWjwZz8mnxoTxyRavHEspHWhXqYd
j08XzDOdldaG5mMFT9wkowos96XeT2+bjg+YGqkvrgLvOSn+d6brL6n2jzar
hvR3Cz5QECYdnF+5Shc9LyjtnEpD83PZ76VkVBUo2FifXTOA5wuy+eau2PMZ
zU/RY8pkaTXo3G7PiexG4wkpzojsr4aJyJxhhYcjILXx9d7FU8j/lmm17X2I
5+MiyQ+Kklvx/wU923uLL/CQv7L1tofAdy7UkWK6qlB/OC9HD4394QI5SbXg
1tIyoGgNnJnqKwXTDXePHtxUhn0/kLOqJT95kAd0//72Ngcmdr8My7hAcI5K
JRCq93mcSc7D9DtRzMZEI44B5JEtjcYuFUB4s854XygDCKSbo0fnMyGMbb5X
Kw3Zw6wHDsrHKoA2XO+3q6gO+57HbFo5Z/OKEez7CpZ/Nia2X6uLA2R168TR
Z/j3FhrfjH2mH8eMo0bWylpoflIN4jIEOUBR28FN6xuGvjEzuSwyB8RWyC/X
QfWl9t514ulxgPA9rJR3MQ/x+8O52qxS4EW8dHtkkQejGh9l3q5g4PfpnDWc
NbW2FGgyi86sLsnD50c5r1tgPA3kqo5nXZarBLqp646hqDSgvvk+65kn0p/P
JCI3VLKA5zDh1BrJBJEUxYnTm/uw8YapRvzyHUXy9k79m+M3JvAeLH00PITk
1WJbim8qE/oGLYddN3QD69PY+Os5tSA1b6HG2q1In28VLXtHrQG7YrhZwMbj
z/mV6Trza9H666wQ0PveAJQCifOPUDlNRUfykHEj0OY2ChX6ovUvFrDRGW8A
y2orp1SEST6Lv5sLNULdEzEra8SHWauaP788yQLhT3soD2+NAC+eZLTHjwWU
SR/yraK3QOIOpwvaIf/KT9zzfdVb7Hs2RWvlrIB1aUATVF88PpuB5QdmjRcn
fqGi+TwZN1bf/QmLT07UFyqOr0P2zkn9iAy5EtxHs7N+cHvw84ljVBPlv2j8
Ej/kjjUwgfZhiaslwqMVilqbm5gQ5+UU6vWwF+Qabq0pV0B+VIyX6YRPL6gR
z+XXXkPlkYduWzX2Ayt5rG7nUA1wayhvGlv6Qe2yiK5UVA1I6SSq7zXpw/Sp
mt+JVcxXaLwPt8xy2YDsLbn8xaPXCI/sUC53qgbatgbRfi4ePx7u9inr5vT5
SM7y14Of64HlVty2vhPpr4Tzmm81GmDKg57c04Hkd2yvmYxiA1BfD317jPgi
62669BVuPagt7gsVmf5/4HONjskY4qvkC/VvW/D4c7LOtmKpe+j9c3c/P5bf
AN7BAcGE6Xj1gApufkIDiM2eMH6G9nNY4YrI7xcaQGmM5x6D9JHfePSLOVca
QCfYM6bHH9mH1dfGdq1rAMJ57ffb7+P5VMM0njoreiD+naYlc22kDPy0DC+s
VeCD6bamHbeay4BGWK9VdYkPct8/1RbuQXrBMvqIujwfyOd5lR5lDFA60f0m
FdWnzTqX/FuTAbwrAy/ML03nZ08sy61kgAEphsN14WPyQb3cmP/BfhBbf2nH
LjFD20Hk77bfqZnHANOTBlL9doNAcLhl+8KZAe7lgwzp6fsrnWU2fPnLALv7
RXlmZwZB7m/jvqv3GZC+zMpE+/sA0IMub5VZywDPm3bRvIkBoBx0P2mozwDO
J8+9skmofJfOvhddiI+dkiVqby/G/N//+jlFQLiXGLoZ8TjyTY/24IwiTP4Y
Vuse+EmyYfSjvsz38GoYFY07nu6N5zscVYy3EjjHB/c9bgKhVGSfW84+6bfl
g4jFqT8XGGwgSy7OdRDhg9adjT+aPdjgeE/Hjk3nA6cpZmtACBui1WzWRwoP
Adnh5skFt9ng/nHwvX0maq/muvexajaIaEzt5j0YBPfHxH0d7rUQHqBKpQYO
Il4ds2inWi2Ibd2SsqIXzeeYaxUT+cPRvVKyGl/x+yyY1zWlc/X5mP8nbTGp
2z84iOG6qjUtye/5WLwCq8DiYo7/IOYfSl8PCzxg1A9y5h3JR5A/nDjuc3m1
QT/wpqDmGwHxxfCHPc57UPnu6pdpj+tAwWnbop69/eBXSi700a0DufWXPp96
jNrvddWckK8Du6z31zKICEfki/lG1oIgtSk9/uUQdj6i560wnzaJY7dza65t
+joEo3dur2ztbkT+dQB1Xv4QOF4V4sh0I/kNcDY4j/il1LWDxokyjeA8q9DX
RhT5iy6KWm1DDWBz2ZR8Q5WP3V8zWrZr4WTzIIaLRB3PRsrxgTIewxUgF4HQ
W/Mf11bygZerFdBcUQhcuuC4BJLn0ZR+n0xXJCcDBqXLp+X5X3wmZ2ybpM2m
XkyexQaeWG3e3Iv0sW78+WAGRB1aftdeE+mnXpOIpi4Gli9b7fOBPyc7GaCw
VXZ4z/t+7HmROzljL4h4/KXclUH9Sn00v1c65i3ilYFj3vquIj00/zZF663Z
ZdCnmkydUu8HInuj1nqFMtB4uHw0dTpfn8B79leHMoh79PL1AhZ6vn/fORLa
356NOS+plcj/8RjI2pdX9q8/lUBdwDZeV8gCkX3Zw2ciKrH4GHr1ptYldXWg
lNc71u+KeKiDuuO7kTqgGVwzv5TMgq45DTdVpu8vJ5XYkAzK8fzl33cN/1pW
Ae4qu1p9Tvdi8ThxH6jKWQNDQGLUi/tnl4H7QLHL7m7ER1YEdomfKgPu8Ziv
yusRX7Rkth9B+5U79294TRXim1vWXU9bxQBmxYltjSuQf6zRsVP3AAOos6XE
pVpRe08DlvDyGMjOPPs413EYm7+Ai4pPPdbhWGmbvMTukSEs/tLSybzrqScf
qI8/0N6i/icyPTxHKUgfvny6akysAmxER3S7lJE8GC38vcalHKYcrCwn2Kg+
94vf27ByIHmuSdoqO4T8LbOeKxtQewYTCZk1fFDzdojUySqHlNS3py++Q/pK
IF1oDPEPo5MPNHdEDcKoxKwrKysQX5KM3vancxDzn5SWq60P2sLHMClWa83w
GH4/0MSqutaacj7+P+K/83+1wyvjrY9WQLjmXHqc3BAWr6gx3rVNbSXiq+7k
0FsnmJCd+zzjzCq0n8QFCcurmJDOL0y+tBfxp3xba/ohJhhRl5zb/mAYeArv
9PWOMEHllOUNpgma74RBOZVK5P+9ZBwNGMfjIbN/Wntk+yF+SBmvVFzOhLrD
Z/OWTJ+HNqv7x49UgOXPHtGKEWQfH7RvbzGvAKVZQs/svyL7Z1PEMXpfAUGK
vw9wnJA++C48+UKfDYyHglyhpXwgTQ0KCFixgSi9/OCrM2i+R7Yv8RRCfGWw
fUWJILJPJ65eOt7MAmcbBrFwFh/xCIe9+hYsCDv/+vyHE3xQsrhcUvAByeuz
5gklaz4Wb+j462fauUQcRy3M/+xyF88nnt5/OGpvbw8QPiboekjWAt3qcOvF
W/9PflwHNy/y+XRIfOZyY5l9MRCjrspPbMiA0S4GKVShCCivNjXsfZ6B6Qfh
RzVWPxK6Mfmjb2HTdfO6gXbp1jqLJeXAGbZ9q3h8AP+fskj2zZXr+PrGLWwt
tj04gOlnufrJ5kwjJJ+kQLuxshqYCLRuPGiK628F5vWkF618oKcKi0Zt5YDw
s5SL45eGISxr9DfRqQmiwznio9eHweDlmnPi25ug60lgnF4m4uPr3da7ujVB
+OH55YYsPL5pJt8ZY5+6xLxKDhjNmrj78DmSB6cvpd0/G8Fy1gEDU+SPi3iZ
/865zAHz4/5twoZovy3ovfz5ayOyu0Fy/gfQ+z88rLbfxoFEZcUkz4P1kLg3
xMvtORuk1pbzLsb1gl+Bc35VBhsmPGuEXCJ6oY+k4Fe4qAbcl0dsdB7iY+dx
OtuGKYQApK/LnksUsIrBUkVfLnAn8kdK33Frmosh7sSaUc2YQew8Yya/xuiX
Fd9DG5F/qEtv3SyAxzeRCJKTGXszgGA5tud75gvMXyVcin0eqvYAeNZrdrdH
5GP5Omb4AMHmhmjFezJ2Hk04kPRQLPw2kHwDmzbezsLycWD19635K7MzCCh7
OKSrxz9h+TCw912EmCbJl0AyuiLo7JL9Tz89w9onHj0lxN8cDQTHwVSjgRw8
30LYyfEq23Ksf9h9rXKhoskTJ4BkmzlI3lCM9Qcrr5XxKxF7gnjmoqiBv0V4
Pof/xDtNxw9t2fHXLRx4p/I/hGvXYv3h3L5v0f6Hhd33MnOfJ+H80+Vbf1Eh
fb6hpHB0PRDsDF3uxD+F9Mpfb58X1QOFekkk6NPTf98bkR/qpJrbveYZSF0a
rl1c3YC1z1pqu9K6A8d9lmds7m5uBsqpk5fOOD0FLZe5juMkhJ+ttOGfRTj2
x43sujagjLKTrPmo/T20D44dbUD4oGvO+PL03/rz0HxH3Z8n8By0tErmflnc
jrVP/L4/QmlxBzae/8r7dHzSldItlo9AuGjLbTOhTqx+1OsyeR20f2fmU1hY
95HN7x6sfOb+WoLkF0LT6KN/89MPBJF1C42ORoDjHGvP/L99WH3n9fFyKQH9
GGYaRsWW+fZh/cHy2wwONMptf4LZV8r6MgsZLu1ffD0qX/O6fP/xJ0D+mFjK
O4W3L5i2Z4NYZi+G/Wb1HWqdi+cHsbn4KdYpB9mLcvDRnPsYgg6W++d9QVgl
uj+BfR+igkMXeHcgTJnbaXzz7r/xTeeDe7iN3HId5LRfL2jYiueDcxbxMbQT
HcbmZyb+n/AqRjnl21Xg3Ax/s+r6dD5ulZWCw1cggHH4xjN/hO/vkV5JoYCK
XPB+e/VhLB82UX2PIn1FKtCPEaJDq+KAoKweWVOW/m88Mdj+oYSsenotJBYI
txW7M/sDsfL/3tf7BOnzV1My+1H9tWJkglkBEBk1j7TUYoD19vPaKKdiIL2q
WfttYSLGB4gqalUEj7fA4118t+t2JRBTBTaXicZj+4f4aIl2GT8G6dkAbmVX
Nfa+GX+Kvv+Aqm7KBzDVfy14prwQyw+Cta+zSfQhLRHTa/SMa+c7t3wAwrlq
Yrccwv/RX/FYOU/gz6ZyagpQdXVpUosZWP6Hmf1K8ak+ecQqAZR+lK/djHju
zPOEJ3LJSrer8Ppvo1l7V6P9GPVzx2fdOJDS3P1hwA7txwT5FTWfYyExwox+
5G4TEFIXWlUExgKrr9TBS6AFiFMhRllpsRDtuuxwpVIbEDUztJ3ZqDyPMsfD
px0IrseWyo6h5w0LYnSi0X7akd9t2B+P5dchecgF0bclwjhzBT87oQvr38x9
u/SNkXlSL97j+a7+3ElpuBqD57v6InuMN54AAQXiRwbie7DnDQz934gv7sHm
H8s3IvvKcXZGLLglnbzeVNyLlWP7Jyk44dyseBwniBAtZr0DGjVLujo7D2j/
2R+puP6mGLwOeZ4Kag9NaA2MCuDdzBt5svITEEvm13syq0AuZfDEtZ/p+Pp7
yn1P3JkCZNue29R7JUBbuWIy+k8Wpi+JX2TSH/xIxerTxrREN6tnYvGdtLWt
2xalpAGZSLeYnVcNhG3TDmEaSF0x2Cb4px7D7ufo6m8F64Ak+0WJujQD8bRJ
+bO8Gizfx3/HVws82bJzu6wygLbgi0k+pwlIrkcE/q5MA62yI38O1zcD79A7
J+HeT0Caf/vhJpk2IHHunPno+wlof44J+vu3A405vuFu1CdQ2OM6t/pjB9AG
LU/F/07D1lduBbNNKzcdBP3N5hqLdmLzh+VPK1G5kCyYCpwbB2etrujC+o+t
f6F5mkBECuh8GR0OtOrGnp+RB1r1DV+f/BQ8v8aPuNRneemgdPJGRhWSB2x+
OpmHq5x6McyVEf4as6sHaw/Tz+Nd5Jc/8fYpsoqi9x9n/FsPJH+fbf8a300D
nYVqPxsrurH2Zsp5+eZzFOKzYWqqw1n+TTcWX0hLuT3367Mc7P9BwlqRbQvV
s8H0Ss5lzx35QFl7IPncghxQm1ec2pxKx/QJ3fPF5FdlOrafWbYK70gsOkxs
LVU4JFeLtWew1PBN/zwWUP4j/7lAPX1HmqpeBUTxpvpbD+kgsiyYe/Zu5f/k
P6kENZ/mXQqq+Xj88En1m6kPcoF2IWWtl28V1r5WtVHbyvI6IHq4COt05f6T
nxbgcb4uP7U/H0y3a49sMGwDtZ+vM39y6Zh9pQlLjV2ooGPrTTRdOlFnmffP
nnaB2qJVi1U76CB18LOBvX0X9j4s/1CC9YWfF3Kx9eCRSv/MUsgDS1k/CS2N
IWy8fVZVUoLfpvPrTp/f5IHOojf9v7WHMEz5lWhxtO4tFj9PuDDdH4QDv961
TCsGJcazwo16DUDU5jtdnYf4+/vW8w169f/zv2U9sPbnqnnoFWLjl2v2vePl
VgwTDOV50rltaD+bLNBGepx6tzO2ldAOIopi2Tf9i8A09MK3DYd42P8vRmfT
NxIUOrH2Z+aHtH7717PDBaAiHRByjd6F1Z+5X4C0yiDPT6cIvI8ptbSGdWLl
TMld197tGsLa8+7yXjU7D/GhFo3lKfxCCOpPKTeYNQSszc56Gc2F4NnWzLpJ
5wNrr84z+SNF4N4WarVrzhD2/2mUz+b4mn04tgmJjHSrQvzCoU94o1kxCBff
/6CH+KZcQLAHQ6oY+mgvRAJXI77r7blnil4MYuXzBdQ5+P8KM/mPRX5/lO8c
KAbH/R7eudcbwNSIoqJuzIBRs723VxxF/t3zcYEEfwaQvuVbfmxC++esu4XS
vBIIGi7RauJ3g0jathshbiW4/8NNJh1eVAYTHTGJf170YXxK2E/NeNUv/H/K
8P/snz7gybx1sXKsAmZ0kWGW0wDGB9TG4tdYhRSA5X/2BxtYcda8na6leD6S
f/f7952+vXXnKsT/fGolbn5Ows7TKLUKE7cuJMJE4XstUgbyk9cJJUpdSALS
wawlMmMIc1pO1TVfhrDmNsldR2sw/8P06eYDCg01mD0X+vbBK5hcB4ntW3Zo
bC3Bvt/QdJYo/onA7wPA+kNduVxbvx7kNt1IDl6YjJ0/zuQPsMzP1y8+W4d4
yY8FBqO3wS/8cF81wjPvV/p0aDyosg7zP9wf/8hz1arH+tMXnlFecq8BaD3u
FazzJf+T36IGpJhbFMzOofpf+9hhkjXY+2fsGdX7TtqpHaj/77lXr+pVY+XY
feTMD1GjqXXgV5Wynwz1eD73CKfZk9PxT//uv6ArfXDVi0rB85FkR+t09lER
Dwv8FGrVAPTxU0Ypai//3WvRgM+viu6uBOTHzOQbIv754GqT3Ai0o8TDfL98
vL1/9tyd+W70WEEDNh+sRz9EdCQbMX8yfTLXraG2EeNf6Su2uJaYoueD1h/e
2pqFtTdTzrt9bfEhFgfxwN0gvyTzf/JZ1IBf7bhn1cNGUMpZZRMiXoM9PzN/
6fWizJe0BiC1Lt4iwq3+n/5ygPpCv1NjXiOM1oWq0tkcrFxI/sJ69dZWkJJf
fCZhqAGiZdsJ58+3Azmlpmq7fCPi4Td9l1p0AL3UIz9ifiP0dcdGfzzbCYmR
d+RhuBEYFrmDNSmdWHsz8ha2ScYwgNkEcu1Eq4VxiVg8DjFfKOse8qNnzgdm
5M99cbt5qmwTNn8Tb8NnyRo1AeXK8fR+v3BQm2S8MtqE5kd4THFT+S2IfjJZ
rcjkYOtHCTw/WqOI2rsnHrn0YhF2P93M+shl/REW2NCMx0UTCW6fJpuBsIek
sGGyGMt3QN45+npnSQ3WX4JDfroLkis19echjx40YfyTscM5OG8B8nu81xXn
s+ux+rSjG8x0a+uw8c3Yg8RlzZJ2yC+eMLwec9WUg4//3/pEH3+eYtjLAS39
GuPg+naguljze6VR/YASvxRGG1b/v/1vA62Aw/OzFqD5TRvnfZVshVE59jxB
p2YQ0k5v5Ja3YePR2fPSdqt6B3A2DE0kiaP+Owi+uNjfBX0CxyXTrJsg8cTh
Z/FeSF9u6G54PtyE56+wu3Vms1QTZk/pIfrVWp0cmLgmIzO0qxPon5dcLBtr
wuxRX8khtpJuM9jN3rnjF7I32P3G//wdv0uP7sX6NkHQ3TfxTxO7sXKx4F2U
jxPD/19+FBGe8Oxlylyg2C61+aj9AXjT4YT5LUAxPnz4ycVPGCbaVCwLZLzB
7jebkSetK2c1it4ifNP4idzi51h9glKtuu3VUODlJU9u9kLrrxCqVlN4ASb2
qWQnSLVg8qR27MYcl8stmD4gs469vMpuAZrrV5eTYgV4e//0genJB7QE8RZM
3shebPnj5i3Y/jZwWrDiyj1U39PlnGRONvb8jH9lUMB+f0cTPc/gVwenF2L3
a860Z1ldHaISwsX53NxIXp5VK1p/TmOlSTEWb0izOao1P5CB4Rn9IdS8YWWJ
KGpPZe2e4GI29n65leELHTpZ2PzN6BOlXXZSlSdaMP+f2itsNN+wBUQWdb30
fdr4P/2vhwnhilKBv81o3t5T21c0Y+3N5EtJ7/x99++eFhDSX/E8/FgbcGK2
Rq/624L7f/eaO5tXof7/vddRRe4A4jz+L0FBLsYP+phU9/6OFoizEd2mkNoF
o8UOHzYebQGbe0KL+k2Rv1eR/MJvsAWTV4NNUaLDSP7d+eNLV4l2Y/M5Uy4S
wtW4soWLyWf61b99kvtaQOXIjedMp25sfErmvcoOqci/L0n0fdTABer6jt7P
z/lANMv+UmTBBYXGNtdDv/kQfaLrnoArF5MXpavXjmbLIR5UI2rATMnH4ktn
5EXrgZN2+6FWbH1F9q9jS+a1Aqmwd+umHMSrFvPI80624Xww2/pMYVArtp4M
Jx2TDZfawHHwj8n4JjbWvvvrCx5r9rGw+1Ox87UW5jN2XyvO52QOHrza0Ao0
24QDvjFV2PMz+i0xUBIOjLWCUl//49Tp87V/5aR13bfiJOux9mfWn6f46iIl
ohX55VOBj1o5+P2tM/bHMCU5bW0rsrsq3xjvarH2sle2Fe5c3gGUd0OaMi5t
oCM0lle7vAt7fub/dtKxvmz5ba1gPlJlsXhLD1Y+w8eUJPw2jeu2AlXyuzT/
0BAm/0YOnmLVk3zs/hnaI1vHDms8/wmVqW/RsmMIi3fh3IXOSi4fw7xyaSG6
/hBwaqQ+zfrDBVOCssPyUT7WPuG9hen1pCHQeux7vbaGC1L2FbPPfhoBJS/T
d9c82kDMpC8kPWsEaMOLlESPtmH6iSB5Yfz2gadAonO9zhknAuX4CBUsQ4BX
58Jy9R7Bzttm7muk/Oi71GX4FBRu2E0NxIwA4WARKf1aCBjFur6huSEc9Ep7
9cYQCK8kU58hf5bgYbxH4jIN/NoOnO3vRbi9ad3j1mfgtj1x018lVP/Um9Yj
OS/Apm1zvul0fuXP9/ZvdniJeMO9Hx5n84De/vzBVWHE51M8A6L7szA+qMCW
t1N73AMsa6lFe2TKYWpRmIr2wkEwpRx3/qVVBs5yR+RCxBGWDeFUCpRDombR
bP9XZdj3D2LVZv25f/uAdnznVDUB6Zm2us6w/gE8v8Mbgwd2xoMwsTTjbdJv
FqgsCnlehzCRMytNYy4buK/XhAUMDICWSmB0nTUbbNzXllkinP5F/lapOhs4
TRcucR6MAOnd2vfl62tB6v317AKEaRHz3M231IJl49UB97IRSOzcaTYoUwtF
D931Pabjw3aY2uh61II7fetLKsJ+psabNpFrgdm49HbgvR7gsaqKvQbrgGuo
OJAdPAByGycCfEbrIDvG3DvGfQAcj6w84xtaD2GzHyhX3xgA3suWDJpTPYj4
rtKR00P8siDT1edoPZA16QkPdIdg4lHwychT9ZC9XICkGTIE0V+1Dz60rAcN
k/qKC8FDwDi7ccDwZD14f/JaLon4KWu76l3DxHrQa6HterlzCKTupz/5E4L0
blDbbde/nRBdu8p9HO3buN7H1qb1PRCW/dGX2NEA6eu5sgapPUCbZPw9t6cR
pqxHcgoYiP9merwO0UH2ftz4pE8R4neGHXKb7Jqw+6yIK3YPtKU1gaWN/4WD
03ztXzx/9tclbiYv+ED1ObGwRxT5G3I7y5+nIv4oWCYQm9oEUd5yXYazUX8X
E5dE/20C0hqvnVe8h0FOs/ZimkANjLtZXfjNGAaSxYfH0vOQHjPp3NHAROWE
eltT1RoQbJcxPew7DOlfTZIuXKkB990ez26bjECYak27vmgNqFHWvHpxcAR4
u2xfBsjWAJVW8vji9H2/w0MiPWdqYHTL9SbH6ft6zn5ZrWmB2t/l0vRx0Qio
Fc1OM19YA2TlwxSiOur/ziPXX2qh9ez+sUX2MdrvULX+y5o6kG7+c3KfHx/C
RLnPv52og/Qgvz9sZT5QnF8+OUStg7gSHXtNW7SfYp7O++3QAEV9inRThLXC
8z0qbjSA4JGjHieih0FESeH3GvsGmIp08zI+PQycV0/jvBBfmDJoLtqKMOvv
Ks2weMRHqgKfJW9F8tbywcGJ1AB+O5k1fdojIHK2x1OxBPFeic0BA0PDYLBt
9uG0Uw2QPexlrD4yDEKsIxu/3GkABad5HQrOIyD16c6+bfOaQGkg+GZ8xhCQ
TCwuzV+N/LEvbNWXgsOgptHzN4zUDNlf8ttjvyJ9tlD0/NIptH6ZJJ+674i/
W5V0h/Yie1lbbv7z0DCej26M6mFxdQi3hwFLNc04OK4z2TbrovYwhsO8zBqh
ZAjpfdrFHzu50LVR01K7bggSJUk797Uif8OC3/9OaRhGx06FJqhyYTTzU0V1
zxCEnQ41jD6N/A9eLOlSK9ovwie6AsJbgKOp8J1lheczsDx4SPlRJpIPCBiC
H0i/Vwh/bcwYBvoLozcvfnNhamMLcxPqP4VzJ++ZdStIHx60nLBE77vIqv2g
guxbXvDjDPERMFByZor34PnzCGe0ndvcKPh94ZYKdT1vvGAi5eHpS+Uj/86P
XkDYipGgOwMIa16K72gMg7pYlZrjGQg/yvy5cvIpdCk4kU91oefdMrrenQ0F
ypKbp3zGUPka4fgc/jPgTA74tmQiHH9nk4nNM+De+v0tP+r/yPryuBi/6P+h
orQoQiimJFGRFNk6I6QIbRJCCCGpFElqkhIqI6VUKJIiGS3aa9qnfaammtIy
7dMyTUib8Lt9vnqe7+v784/Xu3ufZ+56zvvc555zUP2YafvVG1xEu3X3NeI4
KMK6l/0Z1f/v/DAE87cjqwrL/g4IBo69z+Cf8ELsPqFTkdP9pzwuni82wOmx
+UQfhmfilVv5fbjV+CYfCJOOi23f9AG5nVZ0x7EA9HuDBKoz+oByxsBg/axS
GP+4fEpbux/Iys63XLl0sF8i9KZXHcm/0e3qAR/oIH3m7O8rjzowXkrOpeRo
SHUAWVDx07ENxUA/67/1l3kPkKRijs89RwcOuXvZQ4EerP7/tKcH1NNPmayv
KAbJR9udcg8i/nW4+O/rNyUYX1M/uNdX6E8xcDs/7ri4oxvP33CqQvyiXzeQ
ymyHSFV0sJbetjLXDe2/M6OXBE6XA0vlmev4tL/t19H+MzblYFu80vVu4RBQ
59t8jAkuB9/7JkaMR2g/Lzl43JBUAWJ2qY2De5C+2PmJFXG9HIZd72ftXYD2
4/lpg6XiH7/jg9HAaovXH8pBnXoz7KQQmq+zQhJXHcqBO/GXGfcDjbegbc+8
2GpIfpK4v8i6H2hCgioqRdVQ0VcYsOFCP6jXvtj/qKsa7CUtax/39MF4VJV8
iXgNxMbc8gls6YPh+fuJi6xqQNvAWd86E883oCh8auuzQvS+dbeWHkLybNCR
sXgqtx8Ieer9C+RrYDxuGAZy0PsDN/1JPV8DTs8KBoOy0fxF5fJeH0XyUjQj
s/poP0iq9l70FkDyVvjuT+lD/UCSpld5bq4B1bpX2kZXhsC+2v1uFLMarK07
yu0RZlx7NuTbVA2MyiVOV+ORPAmaemqeXw2+cm4OE9PxyAIL945uZID1/N7x
FUheUU8au+okVoO2qFX9NSSvrLKzc2g/qyG+NfB02rse7LxK1qD5V4BVL4aT
Z3v+CMlF/MI1WlwosRa0j10Y3/mxByixwnkNo9P+fml5ayJ60LiVfep0QPXv
RvilRPaA9rfL1bTjLLD0HnhPaO+G0KuTC2Nya8HX3nTFKjbi7yKdLgoCLBim
vhbedbgXbKQ9GKueoOffp99P0ewFkvPZcI+AOhi5GWuxXL8XhJcOnxpjsuDe
eTtzoXZUvuAmweBdHex4Qj7Z8KMXxjeXPxXbWwfKyj5NIhQ+Fq9yePURek0B
nh8xPs0z/dJjXD7O3IcQvnq7WjMc2ZvzJubdWfMUu+8/Y+9IfnwZZ6rUAtI2
1FRTtL8YTyvOTy7G8x/Q67YcyVduBdqma2uc3sbh9wX+nVcTdFc5lNTeBUY4
ofqFMB/Lb0ApSXm1goRjF3OdGs0HaL0NVG3JWV4Mg5c1Ygy29mPnudo0xTj3
0j7s/NisvPRBxiM+dr8kMgsZhrdx/ubr9Trdbh5abxxvLpvLANsFzj+eu/Cx
+zKFJYs7e34i+evq7DFhwACXpwclRlKRfifMAj8TBkQH6NWZ8RB/1lVV/bKS
AZye2dscE9Hz09EK1Rlgk2t3+LltL+YP0NXRIrhYhAvKR2en3VZhAVlMs3HR
5U5g67/6SxyYyXfUCXSb4+t8RVuhIp0pNIX048x5Q7Muu5dYiucPGJ8w+i02
jWMWftIIRHxi6NeTLQj7bs65ljxZA/cgp42B+CGxVyHU4VUNBB2nSdQhTHt9
ReXbO8Q3qrMat0ni+QR8XRffP1EyhGGbp0Pv30nwIU0kat2bu7UQoSeg0iqF
fm9DThthRS0EQfuLYSPUf7l1q5e7IX5Ku6CxxBjx2aWkS7LIbnP7uM10CQ2P
L2s70SVpPRv35xjM3qD9eweanwyV226eTODKSqlHzUXvC5lbMtXIBLcI+j5S
3hA2fqFVS2c3iOL+FZLdup/+TPMr7rs7jCTEn31COvsQTutybyql1YK+uWyE
Kao/fNfNt3QeCxiX7i6Mi8XjrcWeHbDcw8WxetOL0G1n+WBPzZKjP66CNLXf
zAhrPjAsKg92/qgC9TGvj3MHkDz5sa6o1rEa6eesTQJ9iA86Oe9aurIaCjUq
E9UG8fj8keYpxsfQ+mEfuy1RZN4MVKnormdDSB5/urkv2bMZmnmNWvndfOCu
NVEdyUH8QkU88Q93+v6zzCyNWMQXHjvWWPhOr7e7936fbwbbldQ53d5I3l+5
krPrdjOSVzvfJJTg8Upluhx++8vhv++UZ9h4SQbtn47YhpMVzXBvVWRULAOP
zz+4MNT9K8K0Kx4+rHlskDmcL+U8Xa7BSZp1ng07ZnsMPUb2nUvCgdHauWwQ
LOaWHZzGDDP6ZgU2bu9pctiWWxpBNc6dajAd34B5zys8mA3NX2I/KlH52Pp1
Gc1cf3U63yDz2geX1U2gaFj0fBXaTzP5ouhtmo6jb4eweP6qeuz2uJ84lqXU
FycfRPy4rTaJtbMJks9sZxQiTM9qIwbrof2hFn6s4hsaj8AjGZbBTaCpMX49
8Qd6ft3n1yvcmsBIYyL/UnwpHm9qzalPRy8V4ve1Lbe73m6twOTF4Ov6sHVf
eaD/9dcNrdd1ILv3ToAWwjR9fSlaVB348nnsnA5kT0fep5odqQM/pw/WW9ag
31tvetk1ug5YQVnyTQi76Ick1r2sA7eG4ei32kOY/A192x7W9gaPdzb+9Oq5
0Ol4W1lywc05LJDRuWzwWwvxya9ODk/aWSAokGI4jzv9vWv7oxiFOrRPNzVv
H8fzB/ieMq1a8wXHwpv1Njy0H4LYjZuuxaD22B9o0s1LQ3hBBO/O8TqI9fZ5
640w3WmbX8fJOmD0hizXmoP250S/uVQ5C2zuLTQTRPySbPKp5t1iZN8FOVNf
6+H5dmb4hW+HLofewAKxtrqsw2i+XG50eK2KrwNVJ+OsmFHUHvtLJInndeD0
seZG/+QQhHafkXJG9mVs4chuTYS5KaxkJrIvrc+4D61B9oTV9OcpNL73mKY3
1EZQe0Ue5f/9Xg/Swn9e7kOYu2hnwhWRBqAdk6+5g+SHy0qRd1qofOqEu8E5
NP/UVwGf6owbIPqi6sL+72i8L7gmOm1B9YlPPvYP4vGDfdd8+Vv0CscsN98z
/v1IXi0XlHvf2QCcU0JSWqh+7Ke1B89lNYD6sewb7xA/IKZtzJvtit6nvN+Z
iviDsOLh44LhDSCtUrE7Vns6Pyxt/3BrA3CP7fi88nEf+CoZSF26zgDVIMc2
4QnEP0Ji8kqvMdC4jfhOTkzn8+kQVnZjAO3b0Y4xwPMXaCftNLLYgefLmdLr
XBwyhepD+U6zXAZYrs36GjQ1HZ9lll1tGgOMLP2OS//C4zsaZjwPWpyOY98D
VjoBaLx9/V4rPDNkgmblx1cvESZR5Ub1dJlATSpKDUfPj6vMlX78G71/9XWq
P8I2MWm8CSEmpC3dE9U5PT8CpKEJMyZYBI2KxKL5ndGX9xIiLeiverD7z5LV
zn/cY3vAKHmeaYJoOZBeJ28XYXVj5fYHc7ibWhHfWS9hEfGzDAqfhPRpyHZh
9zutbxi4y57jQmjyvhYTWwbEVksRDObg+R+czE0f28/qA+GfkaNizgi3vP7d
gPBwIcdNzYUBglFjwh8F+8Bi7PKQL40BXI2Vy+cI9YF9119hw1Q0vrbfH8nw
cH8Yq6e/VuR84wLHZM3z2x5MkCxavmUxlwtGi+Jb3fuY/+5jcIG7bmhIxLcG
CqsUVyZ2I/tFw/aQ2V8m3DN/OdHyHo+fHbGok76Bj2O/Ghv5QS3cn4Zd1Dp/
ej0qh4zFO0E9VPjNTpUaQutvnnfSJtl6IAYNOhdO508Zy3O1i24GFwuKvtRt
Pnaex179dUO56CCoP+l/1PWtGBRr9epXSA/CcMBBR1tSCUjHKSxln8Pj5elP
3FO7moDj0GpV0wvHBkHy1MoW68liiDywyKNh5SDQnh/Ou5yCynXGC7LlBsFq
RdTE+VclYHVWtOVDTBJ2Pka8mn+vqy4ZlDOFqC9VmUgP3B9TtUsEG8sfRIIF
A0g7XwsUHU0CwiEz6uccBuJ7XF9J33zQP7TnF5xggv19uQsK1sVAkSR8rz3I
hEhTwhxZ5WIghTkZhIswsXj+kbUXP+R9ZQKNsiKSd7McJO1mHbN3rwFG0dZH
xVIVeHyNhx/5RlcrgOHElHp3vBasqrOWuxpXgHZ7nf0V3VqIdLXKqLxTDpzV
x0KT7tUA4afS2KpvyC769kyoZxDZF7NWrn28cgD7Pug7Vn4+8yGOKTyR2FXD
OBbrP+Z9zH4A2QMlnAA+kjcPBLz8fQZAefayqxfd0f5vIJxe2DwARGXvtKbq
BhAOJrbIvRwASq1+vA+SX11SqZNGT9HzzntZfN0GsNFz3ae7fwD7Hm0tLcbW
pA4AacrScFlEPag72urFfB4AapzHimpKPUS67+60RfKNMc+BTW1C+mWdDsVx
GPF3vriJ3SiS5yfFTzacqgT7RYKFikF5MLIrWGlJFtrf/edyF/oyQXvRTuX9
2Uj+V/hMbXjKBErg046VRUjeSQ0RD3PQ/j4Xu/py/hBoT7oXfSlhgtmSuhhR
12l/wrpNxoivEff3C0W+5WH23rhn0WL9HziOfCHFThziAVvlx3tr+xqIVtJ/
mD+M9Oec7CxJwRro8k9QYu5E8mzLgseLbtQAOVU2dT4JySf9ZwrNu2vAaO/7
QFPRfqDul3/W/6AOjJTLFA5J9ENa9tyjng51QGzcMdY3isfvL7Se3+6nhMfD
J7j9aT12B8eUiGCJVy4DEMnUWFjwhgWDHvJfH7oNgL0i/1XEDRbQvOLF9cgD
MO5ocslTEz2v+ZBHch+A0BXuw1kWLGCfL4w2YA4A54694WQQC4ISNPpvJiB9
5BG2NaoN6bNDyc+K3yH9tljfOnp7PZj5/RVfexntZ+MLf7d3IX29Jo45Hb+X
vEzLK38A9eeymLi0Mw/PB9q39/XLYhxTVKq0duXzQKairy2QUQ+2StKfKot4
ENlLbiBE14PwWHbzjjJU//hPkSdn60H7wLqO+yU8oDrOD+30rgf67C/syYVI
v4U/trtAr4fYHPcRbjgab4HjvB5uAxDlT9utOoD0c25h+7rhBtAO9iNLG6H2
lWg1CSQ1APn3rlqLaIS3HV3w42YDjKdIC73cMoDJn5GTm0UPxOBY/UXvTrGA
AWBPdnx22YPsw7WfFq94MQDaEVfslgi1QMQpPWWJyQGQUTz5KOxkC4gNnDP9
sAD/PhGdtHi3fDj+fUN/gcWJS79wHOG4T0pEmQd0Md2TY6dRefgo/e5mHlgc
N62krm+BPftynfo+8sCI7vPnBqcZSBIfFZqieJDW+Sv/uUgLqF5penfOjofZ
r6QA0Y2sOhxbUFVY793R+7jeWy9dbwG61uk/O9H4h0pc/3PzaDPI7hF45pHJ
g3E9V0qLP+rvsvQTW1ZMx+/O3XrxUjNU3JTdPK8ajVft0URbi2awFONoi5Uh
/XpB0DcT8X03M6Gaz8ie0bdV7LiW2wz2qg41gYVo/3Jrrogjvj/+NreZcQvp
06YpjaFzzUAPcCq5hPYPYVHx4nsmLeB778BupcFBIMUnul1YlA/jAqJJksOD
QL6isYhyLB+t4w47b+s+ILizjxr4ZEP8GQ8HLYs+iDRr6DOXygYx83knp0zQ
+vXzdFbxzgDS5WWpAsPI/i36OLvoagaEbmO5f/Xth0gluw9SCzJh0GAJt9sf
lfMUvJL0MoEeyViQkNeHxf/kFjcuSD/eB5Lidt5WzDzEn0syos71AZUY6Z4n
nA9kDTNVtTz0/P3GnTsi8sC+8Y3Nbjqy16WiU0VRfUP1mmtNW9H+++8+Uh4o
hsxlP4jAcRd1g4uyKmqvPz08wQWV9x6er74LyV+Z0xIn96P+G+2R3Ib6M5Mf
QEZ40c3dX3Bsubh4tQeSD/buiz7/OFcA9tpHRpJQf0l7Xf2/aBYgHsPXijmA
5IHyp/d5eflgQZ64kWCIntedd2xvJXo/q+JTCx/xAZ28TevXFoP68/JDwb+4
MEz4ufiEfzEIQ/jIzbmo/0KHDr/OKAFhsVlXswX6gKz+dnx0aQlYtn969MWI
CwyTOW7UXcUgefzKXjm1Kuw+FkXjiOPdBC5Q1VINlx8pgy6fO5J5VC7iRRbx
UfZl4Mv1dGLV4P7TM/yD4HbhnXx1BdwbG8j9KIPnF7AKGLj0YSXiKxd/1cRN
lIG2WeG+73JcIEpMLUvpLAOymnnf5RxkP3o0bEtB7bFNtWhMHUY4riaju70I
4teXj1Nzkf07lkvhWxXDjrmZW25OIvyTKd3JQP2lbpvtcQfVv3j0YWNHEajr
Jfm0iiF+GjJv26gC6p+HTMtSfcQPx+RG7MSQHn8V/TZuAR9IAkZ3tR2LgXpt
798QJP+Ht3Vt+ryjDELf60n1pKL9repET4gtA1W5rjsKG4YgUsqxrcOoDLhu
T72VNyJ76IrnkV9uZXCPcbF1Ptp/6vTwNZNq5RB9t6lKJg3pk6dDGnM/loE1
0yxYdhKV6+6FonXlQDXS6zyeisfbJ0VvWhv8C8eFMRPuoSkIx+VGhZ1Fv/dG
9+AuxJftmaVtXSNlEEEX39uH7COrb+a/Lw2WASuyi9B8DfHtjrDcASs0vgl1
pmkOuP9ZhbLIo+vpOFY17tG6MoVjhpCglS/qLyc6vdz8QAXsuaSicQPVZwz5
XNhTXA6xu9aGdPxB+lMrPIi8vwIs79R/XYv6y3h/8Ky6TjnYFPCTSah/jHM/
JodI6H2PWFx79Lz9n6MXz2Yhfu0jzZmjh9p/gVtO1asAC53g01MwBMO73nvm
1pSD8mDgerMBPP5/hfDURfZNPnaf0GyjkN6hzzgmiXl/rx5E9ff0b7WXKofk
96krHKafd9DcVMtE61PrfmU5ep6WurvXT6MMBhenGO5Dz6sHNs6fWFsGYitT
HHfdnPY3q5R1Dy0DtqTXlp1o/IeHh2H4RBloChkddJn+/isYS319tQymVohe
uroTvX95jvjnQ+h92j6gi+wbdcXH7dfH0Pjf2qiZOB2Pa1/WEJFbBuPVkzVC
k33A2Xx6537vKmD1ZXxRf9AH4xdOP7fdyoAI1sWNAoJ4vP/It4dJBy0GgWqz
fcmVj9XA3bAjMH/WIPhKS5zvN0b2S/hwxbjAIFCmbMe+SDFAZmWgx7F3A3i+
xh0w7rANyYfTe3e1X6iGcV70B+bOAez92gGysfVvcGx4hTcvf1q+yc436Emr
But7Nyq9LuL5AiSr1jepT8c7XPJVaNKzCoTtZM8crkXyku2Ulf+zCrgHVTqG
rPtB/UwpRJyohnt6KtFfzyP55cP2HNheDZrh4gulEN9g/LavcYuqAuoWM6YG
sj+IEs+n/pythuEUczsJG7S+hZXelCZXgZtCzCtNhEkj85IlyqpA9tinaLHH
PDx/go2aQFkjjiMkXwTqNyB91x8Rm6KJ7KfwL5k/EA6tN3e8rob6+0twHuMr
Ws/XXv10qUPtuW7+iqGI9stbl8t/1Bkwwqa6VEznIzg8EvUI4axl9toyQTzM
HiVuqP6qw8Gxpb/er9YuHhCXWHCtjZA9cZ68UKUZ7YfZd1xFZjHBLzhF+K06
4p9T14x7TJgw6Bb8JBPJC+LtAp+iHcieSAg75OLJw+xDG53ZPScZOBbWOLVk
+WrU/0++CX3IXhS2K3BfjTC7d6nqOLKvaYfkpYNZPLDSUFwYls8AK7VLP3Jq
UP/5E5PVSQyw2LZWazWSD+TGRa+DDJC9UrRaTRXhYfPZ2zT2MoGdsrSv4SZa
r7sSTMSMmUC4QEybi8plKvKE4v+i8UoUbSEgLDyuJlMqwMTOe4X12Na/OHVg
1mkxfGhPJ5AsPgAlpg7uacndqnrYBSR9seUji0vBsHptr1FsF3Yf2DBINiDu
cxcMh+b/CuosRfaguUd6QhcQzNmHNMpKgbD54DeVjF5sfC2mGvaeR9j3bp6U
fgea7w+/Vn706cPsX9LLBxUde6mY/iUc4x2SqaSCkf+zHZLheWAVWze6/2YP
qL88arlyB/o9sfN5o0sGYJix2d1yC7Lnjy5/Z3R3AJN3U8+5Jy2O4PkKbNO7
q0u+IH2s4GzVbF0G+uJzbWst+pH9R1svJ1MOVgdMuNbm/UB4elyXW1AG6lHR
Ijk3+kF/SKux5irav3/dItvcEP9392y9V8aA4e5NVS4GA9j8Zk341w28wXF0
fuUBfz2EP27UH7mOylmdmguRvg/Nip4cyEb7PYIQ2IPsLZdnzaY2GWh+ubIb
v7Uie6O3as2wOQOsv/xkvuzpB/bbEwUhAej38m/EPXJF+7V2t8Kr6fib/IIo
UdQeUos7bckIA0IjRGwadw/g8TVmj9vYv8NxoZ30hz3TfIN3yU3kEROcjGzh
Jfp9avmdkzcDmGBzPzTPEckLrmPz4g/tqL4kc3bk4wHMnpoqq+AFa6D6V0kt
3bNrgG55R+Do5X78PP3U/o0fTqP2vveZt5QzHc/o/SAZyQ/Kj+rv30uZ4HbD
upOgOYDF129+p6R0PwzHO0b8fATR+yn7NsddaC0CmVn5EoE7kLw7+WZ/6sdi
SPYdED5mjMfbD33ZfPMQGn+j9cL1xcQS8L3d+uciwtQQglSIfAmkOTyMfTYL
z/8gy4vfYmOLY8O+itVpFf3A6Hf3ruIUQbJglkdZFZJ3GwL8RLSLgXzCv+K5
A2r/vqh+lRfFQCPfrdxoXIqdN9Hvnlu8xISHnaemdR/wnHzBA3LMM+9i+Tpk
l3e4zEH8PzYsWzxMuA4EZ1uN3T6M7IHW85+Gy1gga+8va9w1CEafRsdMsurA
OrF76yIvHnY+w20OqF7MxLGYe3oj05cHXPPVQWGtdeBiosxPR/ZC7P1eFS7U
Q2GE5rmMq6g+YcXxy1/rwegD/X34bdS+C8YHj56sh/jVYb3M8kHMvtdM3K86
cYgP1MeWF5aTkH25N79f4jAffIXSlQ8cYCH7iJJgMY8PMtOfYx4h/H2hwNtr
SJ+kdotwfzRARNA69QgGGv/TZO9NK9mg/6GM4ew7CFYmE6O2vxrA4u2CVQru
g5B2Xpm38TIbbNWN1AvUBsEmnZEVI8cG0q/MpK0ZaH/U7bq4q5gNzYZvDnot
GMDuu+6Y3Bs3zxfH0cTkUwdvIn145uyGLYuboEvhQo6OzwDQrzpVn/vQCGkT
CfJhvAHQT960rVa8CcbjlDlLItH7/zz4/Um7EQYzDbSLKWh9/7QivHFsBKO3
jodUjAbBIrp53IrTCJEW5CxLs0EgOk66E6obwSLc/FxXxSB2n9g3ZZb8XQUk
z6PLhS8aIjyuZbYwmAfK/9F9NowvH+75yMMxW/lpz75upK98IEuXz4Y9VjKU
0O/IPnQeN1zzkA0yrVs+9GxF8jjzmeDGSTZQzJcxY3cPAY3ruXQvnQ0WyYYZ
ogF1ELpUWXlKuAZYIuxTykFo/WdUreyYUwxmJoE7pOOQfTLZStqQVwwu/uJe
nEqEOx64axeXACm42uPxwWyM7xPkvl4vXZgP6glyvi8GGECIfctROJyPyWdK
jPaXsYwikCx+NbktjPHv+0oRcErVSpYHMoDqNeQ1do4BvkOr1bgXa8FlSdSW
jk1IbjUFR3Yr1oJYPb0pBrWHtj69SuJpFVg2Xord8HYASDqLX3TYIb7TYrcu
xQzPb6Ea3uP78g2Oo+XLiNdMBmG4fZZm2CP0fE581YA54k+HHIoNb1TDYOET
d6s5CCez5cV9qsC37UvNiBCyP2mnRdsnEL+4NFoQguQvNXQ9VWcX0qcayxN0
o1F7FrldGkuqBurcszuXl+LxZIRjjDJyDfD8GmadKdt0/HFMGTTx/PuQD4Sb
qfatgyzgfr7vM+bZi32fDIoS/H3nZi/mP+J23GBf2eNe7PvonoBHwQYBqPzn
LzkVXg0EKTDEPBCOzM6/QOuuAUFJpSSNJ71AfPBF/f3rGiiMPj+hjnDa7ieb
cqJrgPY4J9amJBMkb9859MwjD6itnc4r2dPxm4j5+9j1IJ09aduzoQfbz9rd
X4fN27qw88FI3oOXpe+7QHthdmRmUwPILPKK0ypFmDj/gUR4AzgJCrvfE+8G
+sgBl7Pf6oESMOBR8bcTbDRC3u9A8sPKf8I/bWUXdh6kvLZEXU29G8OaPVN+
Mt6Ir/3gt/U1Z6B1xb85D+0H2lVXk8ryTJAOqZUT0EDyZz0px88ElX929PIL
Q/NtMnWqVicDpgiJR+/8GASOsdYe06YMGPEEbclMNL9CBw7pf86c9pMZ4C4b
xPzXQj1uCDyaXv9Bi+xCPiB+sPVF3a0YNN8pk7IfzuSD8jHGBtMPAyDZ8Hlb
/bN8sPpv/WaD1SvL8F1eqRB0vcpi78tuIL/LrhBXqMP85QjEnoMHFV4BbZdJ
3N/VXdh9UtbwJot9Dp2Yf/jMfX9CZvR6K1tfDJNVdysJaYdCl96Y/D6Xbqw+
5l+7VDNubeVzHO82IUUdeAiUbHXtgZ4uLD7BTDnpU76J6do32H1r8h25jSuC
g8DqnVHmG1nc/52Svv5h97ru/3P/FT3flq9W++EdWv9ZhSY3ujH/8+js2wrl
JxEfZpjdqnlvCsrtEusUHiNMcL1tI6gM45K/OrsuTH8POtAUHWeN3Z+IPPxa
P3HuZ8xfjsZPcHp78SNMeRnz1J93Yv7BbJ2Xj22yOjH/55n+EG9It/p8pOLt
M6s/WuicANqOMS+cUrux5y0CyKSfzG7s+Znf53iM7b/9OR37/chjQ4uPqqeC
sngJzTq8E/MXJa5OTzvu1on5hzZz6nRMtTtx/1BJw6W5QSHYeb0FkbKioLcb
27+Exp9qOtdeYvIB82e3prh3FDYA7T/8GjiHuhga/Hogn7Y+Hpv4DvdPcv7r
pZH3GvNHst9pdulGDHpvU+uZk2fZmH8WNUTHcc2yBnC5NZd+RKoOex7z3/K/
c96gG+mHTaOLddi12PsId32Hak94/h//j0AgntFhpJxqAkLHtjq34y/xfE0z
7b1uqUTmofL5G2f3nonA/Xf+3Ze3GrM/2ZvYiPmrpolUH+etaQSrtHv+jHsM
3F/n15GVfmIM7PmZ+/FpSr8T97Y3gvDZFNCZU4eX1xiU5muwgUgzj3cPbMLy
3SjbyIpf7WkCF6mmbR9vsLH61IvbdmS4V2L3gbB4SWmv7g2ebQbii6TTa1yq
/48/CQPG56yu3LulBRjBv/Of8auw81ybdqGz1z7VYO+baS93H2f7qU/NQLIy
cz90iPV/7huh8ddcP9azoQXS2t/fVC+sxd4XW9u+VcKYh50/JucoXh4UxzG1
wtYu3I8HjGThG9cCaGCYvu656vT9+fnFqf16SF593Lx3TG4Iuy8kw4qsOHsO
x2LnxSSSkL1qX3J+XMemEGhvGBqqp3lY/KzQ7gK68mIcu0hck9/+EtmLQe0e
Ei2FMMgS8DnyZvp8a5GFvnQREF5sf30F8UHiFtnMbYVF/87vusBmb0ijdmML
EPYKUCxO/Jf/0fXSkQaQ9lGL3HoateeECnnFZqQfHkUk7rJG9uUZv8Okn/Uw
4s8qd0Dt5VqeFp0njNavbu9emXfT8aNuLh8yaQD6nCs+T0n4fQpG2NnSubv5
QCyP/Rpf0gSRKwdGY7fygaYqOtAj/xXsPzzSJg8h+9lUL56V1QSWs5qsmwaG
wFeZovCJ0wTNfgKu/Oyh/xMvBOFBkvySDU+h67reyt6DCG97ykyUfwIVl24u
uHAP2cfC55JfPqMg++NFjPq0vCuttd9Y6QWCnxYwswIQfrjV92S9JyiSzc4H
Tsu760F+N176wL3w3gcnHPB4GP+TLwrhuOLNyxp8wVBP/v4Kl37g7I1S+5KY
D4q3bnRL3EL2RHSbwm3REiC+tdiqqdiD2SeyR6YCm4V6wD7jwo+QnmKIWHF4
2FOnB6xWxDpWt5Qg+8Hkz+j6HiCKvbwVEVoCkfKndBYXV8Kw2s4FBl+RvXc9
pOS6EhesXgcdlnQph8iBAPH7yH6mUwZdL6Ny34e63pudh0B7/lKlrQUMEKw+
I6DmOASR+Z6aqo5oX4QqXfyaNgQuh5e5T03bm+0iK5oQpnxccn89sjeNLr7U
WXQLjf+aAI+byF7RrBLLcrgzBKGXb7z7m8eC5OOZktezhsAiU2Ld2PI6sF3J
MdNB80G85hwTIIn0ZzTdwXX6e86/+3GSn3em+Tji8Umw8YtIYJHibEFR+Dt1
agF+fyxZOlNlTQUeX91vnWWovwkfOOlNktlhNRB6+8q1Z9P300/MWpYYXwNG
N7y1StDzNNpkiM6vGvQ7C1+2qVKAkFZCqJL1BcLjy8zd8YivyVbuetDsC07r
NaULYhHeVFlw3PE+sInVVXkvEF5OCawruQuM9/GK2cj+IfSPtRnnOsJ48Wcd
0YJ+7PxAWzcw/hatH8h1p6+bXioHrs5DenoeshdfnVt3jFIOZss65s4uRvZv
oeby2lUVIGwUF7x9+r7piOqSO7xyCFVsKP5xDNnze7WXzjIvh+hysXUZx9Hz
Y1G91a/Ksf1IY/wtEw1igeKU+kZOYhdYuAxcsFtWB7GbFq4pSkZ8TZbREiNd
B271EWvzHvBB/4uSNv8Xqu864pekjdpvFJO+3vgwFAr2tM5rRvyvuUuFqTmd
j1X+hmsNKve40PrX9S5a92Mq64McgCxZsbYtqwoIzec37bHzAEq9CadKBvHj
7L7rdtaDmL9v1u6MS/B3AIt3avhM50pXLuJX80hL2LOQPSnEXh8UycPsf5nq
K2MlAzgW3nT/y/1NQ4i3UJ4z3JkwVet9v0YLyY/M+Jd3XjAhlLGcKshH8krh
WYFVNxN8KTQKVw3PX676PM5D1xvHg8mtAwGcAQi1KbjglILkshLhWUzbAFh9
/nnLMqcWbM2fjNjeRfbG1bPsZfMRX98zvFL43gBExrzOsf1eC+ox1vt/s5A9
9umun1t7HfjtWXInt5YH+h8dFvCH6oB6z1vbnojWu/7z8oTOOqD7FVz7UMED
m0P1+Ue2I3t8tdam9ipkX1urtZjK14MiTzosbGAQfG9C0bHeZqAuC9spvIaH
+VspJ5asiV+A59/Wf/u8zNQK8V/3+CXCH/OhYjxqa68Mspcp900X2hSAzaLZ
l34vQuP/OsFx4eYCkD173PbWGS52/9s+YPN7uUJkP/xdxUsYKQanOe8Oad3r
A8baqzK06Cpgy2hPvgjkYfaUk70UNf0rjqmXuUvjFJC8Nn5dMJhZBX4qQxU6
zTyQDLZ7Z29YDfek+4/4L+zCfi/yvPSSZO1kLN4DsSlhgRsjCYh3OG2Oq2lg
M0ExXTofz39tRnb2sFRE9s/C3aPvv5VAhISkxlKhXqDYuPlbLSkBzrbjLJFw
FhYPzNciszvvOdK/JsnfSx1R+88/vesexgLGReKCi6OVMN71TXF/HAvUTXLu
qN5C9c+obToYgfSzu261aHclkN9aty7rGkR2zpfES19Y4Ocvp1rxnIfdL+wq
/LM36juO9bdfPENBmN41cC3Eng3q633F7fqZ2HqlJYwox9ehdazRl9vrwgTJ
VclDPt+YYOEV1R/RyASbyG3vjXd1g4vWQLnblXqwcCWT12l3Q5pimv1yr3og
dPIfMAPTkRyaPjDLBBpR0l9/dSYQDli71e/KAFL+37laj9D/THFtYlkGEEue
f8tbnA8c/60pHJt8ICjsCiQg+TtzX8C23Ovnss04Di0zUT7gPgSk+Q/nyaJx
JC8ufXpMOAgko3u26Oshe751p9KN8QDs/Fz6Kszf7DMI2l5zew0YdWDf9f35
cQ+0/nYf33BlvA5IB8VzjqD9PHO+VHh/77LdCoM4nu1htNZ4EDuP5dy9MLT2
VS5Y6YjVlh3Igci1FdvjpBB2F9t7YQBhjtdwEOLZVv+t/2zg8hy4Usi+n4kn
MhM/kVBMecBYlA2UDi1jTRUeVt+i7e8iFTSfM5jWxe+iZeHxP8k3in1rvr4D
QgOrM+55C+6PsnftMmZdC5Abgja9fBOLfU/nzio7JeiL5J9SmrJ883Ugxbcv
y8riY/pJVjt9c7YHHs/Ej0/uaaTh2LqWaNf493/FO1m2dsLuNuJf14aWqyTk
gIve64WzkP1r31vWs20NDbqUfXaWaaFyblatR2YOBFnbkeW3ov5NyU9o6+ZC
V6jySPz5Iax/1Am20fhaHPtV3mnrjB/Cxmsm/hfZOwEW76cBKZX2k60zhLWH
Psu8N8INxzK9hbc0pvN/+I8PR/rkAAN+DDeMIf736gdxMjQHZF2NsptzUfmV
yvU77XJB7PlviSi0vojav3rtaDkw+JxXsG4n+r3mUYnBs2heG6Mgo5gHnBsa
VZZaNLANC9VblI/6s1/u8OHMXHD5mue5zQ+PZ2J//UfVZhaOzSRNz9E90e8n
RZ3NykbyzZWw6vcT9D6ng2slLhWCqnzr3au6iC8fkVp1hoHKa+Ykvd/NA/VH
K4qe9xZA17ojlizEL+3HLnV4VeSBesjQllef0X747ae5c2M+GJEKGw4hvkqL
rLK4HpSHjRen0Ww2zC0AC+1m+xKEZ+TvPZXg66IPcez2IGW1QcgQHt/FxeLF
m1ocz/BNqx+pW1lWBcDY3RqSZo7Kk/e/fHunACx7XhLm7kftI8nN54gXgO+H
hJOfxNHvpxT6OqBy9Vsxb66WovGWtSV1ZBSA4Ej/8WvVaPyM1BoERgogK7vR
a2Ih6s8nqegAND60eU6p5kheU9VObYxD/N9sTsvxAwgzGL+HtyPMuSt1U25f
IpBV3VI9kX4hXmwftYA0oPufbenSbsHiQbhYtIPX92a0zmO6NiamYvdX0opi
UvOpnWCjaUJz9WsGmbzhX+1iXaAfJvrV91oL+G79QE3mdQGXkDzBITeD4TuX
4jla3UABNQbfsQXLn2p0O8xZZDP6fQ5lQdbsbmy/Yf7Lr7YlrZwoBtKHhRXV
MnmYPf4/+z8PSGu9bo9tywJD0sY1ItP20b/yGX9KJEHoZ1TR/v/A/kNXR+vT
Yp+onFwOELr2yUzn67EymdzVUJ4NbNLgKT0RNN7/ncch+bAsvlL39kfc3/i/
f1TgeJ/aPinUgvOtUm62QFgz0Ne941i/6ILYzYLnfDqaMX9z2pOo/Emh6H/t
KQdCS4f+juhHePyokqOXSNej8PiNGZopFo2P8HiLi4WUdy67j8UzIrxX9Cy7
eR/z3yeEjp9P1X6E+a8QDK5Vx+d7gszZ76Xu2zsw/5RI+5tzAzO6MLznWZPO
t8VDeHzMf/KPI+Ohtynh87+/EwjkRPue3ys/Aset6VlwWSYWD2+mfyTyszH3
l/8rvp7c1wUteYl4f1blSfC/vQWXag3v0y412PlRZP5ipYtZDOx9M/7y5KyD
DsW1VOw8jRYb8EvUMgZsv1W7zXLrwp6fiSdGjq2huWnFgXbdunksix6sXLmS
uPeZbi+GaUGiXNc2JN9PEuWubUN6szJqlrBKPB5vzfRTgWdlCYZn+sMxltqo
/jEN78/sFL7B+WQIVRInbLKsxc6XZsaf9qrCy21DMhgOa6W8berCyhnOby9Z
KNMxf25sfp+EPWymZmPzG3lWLDoBrd9Qds28jun4Vf/W80w8B6L5yTqPu3nY
70V29/YuuZwD9PdCx3e96sLqz7yfPIfv6BeRD8oZxqGuhAbMH3HmfZImRCNC
SxFwTow85Lp0YOXCxj81HsjXACn6kEpKSjEIM8eCjPVrsO9d6usELYyn78n+
u19R6Ezvam/rwco5LY3P2/uRfVW/Ii1wXxlYDp/v3TzAB4Zfk85CrzIgyXS/
B+ePQC11UJfYUQUkla6fa/QTsHhPM/tNPao+Wr6rCoJeMG9okgaAMfxS52FC
FRgelFnouwvPf0N3rW5yHOFi3ydk01W8VuRwsfM4Iv+PcRIJz59D/PZz+eqA
fMz/LW3dQW3dkgZwYa8nN+5EfD+zuNTgZQNWzu6p9RepaQTfYIHEDY512PiR
KnaYfI2pAyPig9+juj0Y34kmt23PMO3B4iPFKv89lsTE4yWpfzGL3Yj0xsx5
u5X9xHBbdz2Gx3P2ya3bg+RI0oTWYed6kLHoH5MY/IqVu/Vef/RqbQdwDhzk
2WTXY+uBbJByIiUevc9FNeBuXyJ23iejt/WoGbK7ZrDRMifV87OaMSzY6Fwn
dKn9/8TPaQffPwMpSj/ZeDyQ3wq0OwVsoG0/z9v/OB87byOt0DZv0yrFMDnv
YeUm3woMz+wfmwcnk1KSmsD+cY74yq01WPmMPGNEzj84mtYErKAiA6poD3be
hsX/+3nQvHQAjw+jnpz1ZepbMxgp5t/9Oisfk9fkswW+D2JzIfa/9dEKjBPb
V1Wnl/9/8VkI51jbGixawCW8jap+nImV08i8pzQZBva85J7GMwl/6rFySf/5
JJ2ldVh5WobBSbPyr1g5Jp8lHrM4Zi1Y/KDYD1rKSxxbsfgdhHSTWev2RWPr
iczS+X6v6w1Wnybikpfy7Q1WPzL7vKxgTiJe3+5F3lGlRKx+ZMad2VdqPmPz
R46NWbZl7iesnBRTIFqWmImVE22Sal8T0sCqdInE2d2J2Pmj1SyZDT07EyHy
Siv1WTsNXM5fDMk7Uo+ddxvRMzZ6uNQDXcph9sHttWBxY+NW8SddmL+OJvPE
iROULqB+OGk5Rq7Dfo/bofXE7GUT1h7f1W8kF4g3Y+Wk4wHS/r++gtlN8qbD
fl1Yvj7Ni19S4q50Af28guDKI62gvI8psgPxW5tArwVWwmifbtR7/xhherMY
7/oI2j/JpB1TTxGfOu5MeV/IBssj4heezsXzI45vuyRNoQ1hWNp5ltCtPqT/
B1U/J/1GclZkbrAtFenHtdcFmlL8weXvyQ7fJIRH9o8rtyG76PTnMfe9/kBy
iat5Pw/xifAH89qqfTC+Tfhvfu4C8eHKjwvKc4CkV6Fxt7IIGG+l6S/UCmFH
54rcR/f7wf6JWMpbIuKX1Y91sj37wWiR6bfdPsjelTe/RPHtB6vlFyf82kqg
cH3XrV8K/SC5T3VL3jY6EOb5sAbl+4Hxl/39kwYd8W7WWdGMTmD8F/+nHKTV
c7vLKztheJnll4jgchgf8rmr2dIJZF7bk2PzKnD+5ZBsE7KRDm5jA1HBLt0Q
afA2O8GGDn7mi+UqB7vx+373+UEDI93Y/U3bRS7GgvxuIInffv+uvRzYG+DH
iR/doJ6oYeSnWQH2r1c5dapyQZ0mnLVyrBxkOMXBteu5EBnS1OyxrAKEPxn3
6WpzsXj5kl1BSx6l90Jsve+9z88YwNrD/H18Dxe4f4I0i6AG9E+MnasFLgwf
9j3892YN2D8ydXO26wdludUe4urIPo3lfP2IMGleoEHCRgY0tw0/HRPpB2L3
Dcv8xwwI+u7ofHV2P8SWrLfqPcKAPWs5qQ4H+yFSLyzxEHq/mWlR9FtjPJ+q
0cMdX+Z+GYLIoOBwrZsMxGtO+Q6lIL748vGJh84MUHQ4459T04npB+kUobxr
JQgrH1JNsmCB+kHJx19onUD0dTrFcWCBG59DcKvvhtD3t91+kFggK5gYQfnZ
C5Hnfv26v6EOpsoOBnmj9ThsLSq7oQm9b4WD7ZtaPthX5apmB7KAcSf++s5a
3N9Z+oVwcNlIB9h/tqctHW4GIinJTtCkE2haeZ9u7CyFeM8SqtL5Tux+FfvF
k8FxxW5MX0ayXmg/Cu/FsHT+vCOzJvlA8bg1T2tXBajvtGsi5vNh+HSiivKW
CvC1+vTM8ycfyJIXjx6oK4fhrHPXFApwf+SZ+AbaonKrJQKYENoqnaaJsMWd
aYOfCYySNerJc/thHHL4XWcRb4j9JkJGeEZfF8adbVudhvsri+msOPvtJNqv
xyOPPmJUAn1ljN9vYz4or463cNxSC7E3fpy2PsQH9b69opcXt8LU0uvEME8+
cEIaR1n5TFBvKzhvdZj/j0cgfT4SbK0agGPf0oD+OdPxJf7FQ1K8Sa9eWsPH
8jXI6FoIuFBQfeK74CUBrhDZx+6sO4HWx+yHun1d5WAUklW+7gyeDzrWWpBe
dwHxm+xZ5zv2V0My2Y0fXoXn96IYM0c0N/MxfSEo8UxfoBbx2foGpXVfWOBE
e0wQ/sAD7fnuTy+ls4B4r6xIMoYHbI3P+5idLIjWcLug9Y0Hw/Eqz3dksWB4
xP3s4u2F2H00dROS7Du9QiDzIxMSqsqA3PBMW2t9IbZ/1Wfvt3Peguzqzpcr
JZ6Vg01A/saQPD6MKyhouP1hQyjZOHrCiw/aHyTzeIZs0BxSz1+bhPqTqHbG
x6YJxo8ueCucgsrlj8oOxTbBMGfjp5KrpRjfi+zZ2yl0sRTsLV0iadeKgcp+
kKGuXgqMKvraLWdKkPzbWA7cAmw9cuyUmHu6CoBaEhcWeAK950qLynFUTnrC
3b18dymQTZa8CdhciOVX4ZizzBXkC4FqufXXniQ6RN4ok+QeqsT6z1juyUze
VQlW0c3c6x1lQJutInxrTiXWf1KB/psDiysRD1ejOdxF6/eH5ux3SyuBUxt+
wvFGObhA1+/MVUzsfaEyst+pCBOyE/U8P5SB5Amtufl7u7H7LSMnTvmqH0D7
2eVmHVWACYOfCJ+9ECZOLXpx+y8DlL8se5qN7Et18YhVwueR/mue0//eB623
F+8Mk+XrgFJF353qzQdq8K17Hmp1QPUayHLegeZj/apGKxskDwQtJDfroPVy
8/KZTuM6cAtIGVm/Dc1HRPK+2pAGyGpVqx5BmMsv1JRya0B2rrzQ+utovVGm
95MxkhNSgVu+dWH9l96vvG/LYBeyMxR8zaLKoUu1x+phcxdIeopnLdMuB1nz
3BvEnXxIkxa9vkGcCVMn5xLfI6y92udg9SgDjLxGWPXa+P4krLm7XW7+AyCm
PxVYZoV4BzHh5xlLLpBeP7WHBUwYrr18wfs0FygK+ue2jjCAm/10+axmLvhW
X3tgQq6Bezl8tq0JztcJTgG3Fz7igy8l98I+tXqkbzJEcpaUYvNvtUqtKBth
o4t/jT280PwvtR6UkC/F1lPkib93DBAmeQQ8uxFYCureZ5zZMYNA4NQuDJld
AraXb63z/zAIxElD71ebS8Dqxa35ry+hcs+XF15Hl0D85kOray8PAqW+4Ebf
5xLgKMYkh2QPYr+v2qkkTXbAcfKXd1vevu8HCv1xRuT5UoityjtyNKYfhsNu
3+euR+t7z7lNp2rSMPlK/G/dpINVl8XV951VYL941ZACpxArV94g5z+SzMLO
W2VYZyX0S1jYeBM/dkw6ZiC5sCIhUUIe6aPSi19/bmGCr2FU74n9aH7qxrze
aDPxfClzWbkJXh1gc0TqcvP9evCbJXGmvLUDjEx3exiZ1oPhvcz5KfmD4JvJ
Xmj0sR5C332ziaMNgsWcihR+Xj1EWp/Mn57vGXuFUrjullIG+l2t/Re29uSD
jXG86dkoBupnaueTZQVgJHzQ1/h5FSYP7CUtlL09q8DqibD8oGsxklsnbK7a
VAFN18D7fXQxRJzKLch6g+cPV07Pax8z/F94/FpNgyEP858NKr37XGPany7h
2fzPGjVA82sibMzsQ3yLIL4vEclHne3D22SRPv9jKZIoUYd+R2Tn97oBGF8W
+aR9PwumXqml368fALJe39s/SP+K3bFzKVyE+J9jTLyIZz0kx+ruyl08BAyp
9TVF5+vBJTXlpkYAD/TJC/ab7WmBaPlVUb+98O8x9gfunAmSKML6S57I/H5i
ohCGf56bvdGzGFSX3tmcfBWtL4vbMSxjJNesW1OmMen3h+IWhG2z5qgX5w7i
55tDZ/xrHXBMVgyXnPjSB1bV5+afNqVB1pK2/fOl+oGzrf6VLzMXWPDFfPVh
xB//+96Qh+WroLV/jv2eQwfb5hOvq5fj+amkfXadC3jWh8UHsOLff7l9vBKT
Z4wTKS9+8xAOrS5wWMKEZkLzjbDfvdj+sjb0oqhncMF+VC1wsq8MKsxae3Zl
ItxtuitlvAyyzq5xEjg7BOSf3mlHGulQscFgYs8pNL4HtiscXkYHy8+8yeMx
qJyz+9WLN3Sg93S+/mTLw/Pn/DuvY5zv7KZr4JhCG51ysakA6dM/c5J0EP/q
uLz3ysdyZAfZpOz8jPhRzIH1J1PKwMUuLVc+GfGRYeewcvVyIKfcdlt7E/Gl
KweC4rLKoFDmd6kudGPfZ0JdlYgVu7rB5t7bxPRyJqgu+MkeuNsHBKtrO1x+
VENsauP+XnIfqKuwzWVSqsHQtchq8fFBIAebsqRWoP2mEpXrhzDnnrqvwG4k
D282mSUmDeL5t3xr0kcscSw7KlnvrYjsi06jnwfqq8HJcbauz7Q/wbOPR+QQ
Jr0YpBqoIpx1au0SESZIb9y01J2J5zeyv5TwZJd9H1hE03TLtGvA6VsE/HLp
A8asvKX6hBqwWlmzOts6BUg7YpRvl2QDWaFNJGwoGbNH/ieORjKQ7tMCz63I
BSLfa9PPznQgUiq35G8tAI5Zl3l0UjpQbQNWOjqj9Qohyy66f8DOr8dPmWVf
U+wFK6GQLaZo/VCFi6wuIzyznv5nvnrAKsHG+OA4HTS36aX3qaD9tmrkSLRO
BeyhXc1olxtAdotRgk1qGcgYL1EVWzUAjOhnDos2lUOQopr5Uy5azzY7yore
MsDizcmvu9YPAMV7/+W3iO9biQm7OoXSMb41XGI8VyECYS/9wH6ZSqDJFebz
Y+nY90Cjdk/hi2/pQH7otmduYiUQk499q0e8Yka+WsnpLF+rWwq005ckOucw
UDsyA87pMbH5Ir1ZKRpvygTtLw+3JnxigOo9vtSO4UFIqzp9yuhKHVjsz70w
C+Fx1wWzpQ7+r/tdMdyPEbuSgaBtqjg5EQzknujHv+cmA01C6czTX5Fg9c7S
U/N3JnafipZ8VGZ2dSaQF908JRoWg33v05+1Y3gPAclD3euHi542gmCxGblD
ahC0j9WGZC9F9qrodRbt/HS88cs+Ly41gupC54IDKjzs/MZ2fPyV134kz5JJ
H4W3soGutmNDY3MdxI6cf15iVwP03FL6NpF6sHFzuCsTWwOFFzY8Uc4ZAHvR
X4YNFiVAO9LRvryYhvv3RMfKs2ppQKm2vhCvUg3DNt5zp3poYL+eGLTlejWw
oxpSlobWALV5rXNITw1oX3bcs9qtBpPnTk9OX5Odg/bPIXeLFslqSPNaMsGv
5gM9Vura4FfEf3mUyoUIE1+2dIlyWeCio7lA6hZaX2eXlCX6Ib6f8+DJQw+E
QzZIs87WgswIJ1HZG2Gf3Lfe22vBLPXR35TAXkxf/M/5cS8QE7k3Tz2sQfaB
hrno4m7sPkLE1gvzplS6QPnb4S9/b9UDd0p2f5pWF1h8+noq/Gw9ZHWk8l+c
7sbO8xRFH7RGn+gGC8rW6Njl9WBh7/Ei07Qbht+JHju5pR7Is0xTalUQjwk8
ULZLCfFRKo1yGsnhyKP71+80QPrfovvkN8RbiSu5GVsUq4CRl+yv00EHI6VP
mneQ3jT6e9Ws9y9ar18e3Cn4UQWkD7rrJk7FYfqA1MOz2P3mHRYPymrlqqXZ
t3OxfPa0JrvCFPUPmP1i1SWj5cxmYDhIJHLxSbEeDGPx3w5+MnnZVgFBXgvC
GPXI3rvVGvTlcyXsWFJ7K7ZpOr5e8MIVSC+EymYmxNYj+33z6fQF5TUQGb9t
VLuGC7SU4ztsBWohmRMuGkvigW/wwm372msgvgAythXzQf9R8P3hy3Wgyvlr
exjJs2GlibHNTxtA8X5MxR6EtW0Cr2a+bgAx4+YTj6iI74ZGrzlj1ggsrlzH
6zhkj/3qe3btfiOy0wybtiinY/oX41ObV62JOdsCtgP1ow+LEH+cppNSrUC/
mWs+NG2f3mIUtMi1gh9XQ9REewho397v969H6/Jbd2D8Wvz8595y+3dWLjhW
F540gVUIl1Ql8K81grZR/ud8BaS/xpoEBx0bQWzLrNFTV4ew+4zCvxy2nr+M
sPTeMMEM1N4g8Q+ZTsHY99hIWy2m+NUibP5m7sMbWVNlKg8UgrroiQ3yukXY
fTwrsaBkzQNFSC5ojWrOKYLh9ed9+BaIb9y7XtbWhOpv7blVRenD+IfgAonZ
F572YfctrNINfwjLpWHzTQj+oSRin4bJR8IhuvFpkzSgmum9fpCF5OePKEPd
nWkQqXpj1DwM2VWDtntvPe8Ehur13ERHtJ6b/U1/vO8Eit7xpxZ5yN7U3Ope
rd6Nx5tSrrXfoIn2A0N66ZhCNRBfOwW/o/Riv0/1N/jg8LQXaOKl7+Q/VAKZ
cSvxIMLqY4l+UzGVwNVZa7I0qhfP191EWu31AuEiDmn9dJzkQDeVd68RH7k/
xzoFyZ+gW08Ktd6i9/ddJQ3ZVcMegY0tTXOHwP6hoAG3pwLcwl8tb54/BJHz
15yR2FsJ9qalfIVnvZj/Effi966Uxj5MPk3tGppk/OgE/bc3l8u9qQVZ1TmZ
kyNdeH6HmnUGRWVfgOwgpmy0qgwiR0eoNQtTMXvxXlrKfcfOHvz7xa+dy78J
ofUueSDlGrkF9vy4cuxQ+xDo109+bNjaCtIfH5gr7eNj55sz8YcoU8cGIlRa
oXBRjBpHB49frF+8LM6UhNb37M+pHw+1wrBebImB3vR5DeXT6OZWCJ3n2c6o
xf1r9vSsj55bw8fue8Ruelhu49qH6c+Ito51Z/k4Hs9w/uF5uw+IpaKjW75X
gBFFi+Tl3gecoe2f9+yuhOSKXm3iTzz/enSCyFb3ScSXjJ66ynRVguIbg2O9
qJyRukfS40Yl3JOveJCA5Efoq833V+9qAQJLd3UWDenhc22UolGkX5x75wbF
VmL81OZNOOPMQCdI8s16u69XYPfhI9/SV9P3V6J+LlPr/NmJtbfwbxbvanwn
dh7m9N9+6gQL2eeniilovrK/nF7Qj/Sfs+ITAQIbQstsIwL7hkDSbrRl1zo2
WC1JWJZ0De2jE/maz9tLsPNaemLDczWDVrRfeKcCrX2w8Reseay3m80H2pTM
0heZ9UBwrKx4hPYldh9qjmzdXjmEzWPf2eyrxr5nUq85MEX+VAPH7k7+U2Um
xj9Ir5fAg5EBbP3t6LnFEP45AOpHKywmGDX/zveRfr+iWshYXAvaDPriqb2I
b4yqJjccqgWq0tBnSYVBTJ7YTBlSipSQfVEvoEQYLwTCgs2F6xEmrr7zOHu4
EPwqR/s/nRvC9EVaqbhAizXim98y+VtPlwLlN8NuoA+1Z7S6mTC7EjTDZXqj
ED834k3mfjpUAerxlqd6ls7E766A6I3wTGn/EIYV76suC8zF43VWCPXJ8jLx
fKN+6eSfF+J7cf51/ZxxWCLS3xaSux8eZoCwbej42iS0n6+t+b78KAPGn5/b
2YvKsXhMzFshBk09mL8MIW6RkMKtD8DY8jy8NbTg3/2dcOBUHbiz4ksW2KQL
KW7u6cHG12rCw3mkrQdcfI+7rvdGfGfAYI82KqeQwupIWTXIHr6oITfYAwRD
boLhVA0Mi38xDe/rAcnyYxHCrBrgrLtSM0s1Cf1u4KPjy56CZeJ9e2th/D4x
li+PJX0rWo4CbomvGBHbEb7sfZn/2gkq0v/o3BZHWCIiL+ulB2R13pyXjvQL
obC7KqbVGwS36MbdRfqFICUwd9LbG8vHQArPvJ188BNY7ThlGbU8CfNvID0m
Ldo1PwY4PXV/dxmherfzNu9eGAeE1eLS8ROfgebaXdGtFAmch9T31xclYXyT
qN75PKsS1d/0d9WrwOh/fCkRKA4xbN35NOz95NhQ2bjQTOAEjz9JcP8MZMfn
Ru9M0xEvmXV9f0gikGl9S30907HnsfsNhG7nwDoqDNuufNWD5C6Wz27fuHhc
XSmej6s9p3TbxRKIVBaMuROdgefT62JvtbuG+DGDmin9txjjw2QBLUkhpxzs
ftKMP84wJzr6BYkG1Fb33i+lyK41vH8+6WseUO5JrDvqXQIUrYUNPzfkA+Vt
XptGcgnuD/xssOmyTR1mH818XyPV0vWCDXIgaOHhVO2daL2b9olfH8oFi0nu
nIthjcAJo5rP1kL69b3jVK10E3CWmn2NGC2CeFfBaAPD6fvyyoMeZwshvvbD
Xf+DyL4Nu5rbaV8InP0K4W4+dRCp3huz71vpP/lQB4w5r1fKmZcBSXlDqjSz
DrO3yb+02Bk+ndj39Zn7GbSt/6+saw+HeuvCUyEKEaFSjUSOVEoyidbkEpUK
lVTUyCWlpKhQapRQFIpSJEThoMklE2Lc78y433IGg3EZJgmV+LZTfvM83/Hf
evaYy/6tvd733WuvtdcJlwWieS1fOIZblYjhOflgHCGF7y2UPv+8/1ISijMT
vszU1ARQFdD0foX0IU0nLjEk+gN2XxLO4PJ6k6EkILX417adQONUZU/dle8w
/jyXf6cOm06FvUTxaJ6giMxEN/iedty5MKAOxs6lnTNA8Rlbj3/+XPuLL7tK
1wMucNGqWMXDGH7OjRNJN+ff6GoAnLJ2Q/qDR1g+m5gdKiL56DPGz5X+9H10
fbz7WN7DRl4+s8XkFnWkEZrFjizaltmG1a/MvT6QwNkxY9oKgT57hV9Id4Gr
Rdg975ZmMAp1nnxY2wlcx68aR4absfMlpDSaeLVQK9gc8fG4Xs3C+Jzhyig5
HWsWVs9B+XBhdPdADxCIDfLBHrz7K5rVXdbJ17cDuUFu5emOHqxf5e/7r4bA
1WDDCsNn7WC+SXzTiie8+xBwNs8fXdhqD9RvIrvUED+dmx8xmQ/eOvzInrTI
XBpsjvFZnHBsMuu9K8YXcGtn3+gKCHL2TnspdQDzgMuNGZ8cKH3reWfdgQ5Y
F2O3a9CYieUb5u5HNQbvZxGuHdBce2B363EOTFZ+j1CLbQcjQ6frX45ygDCw
8+rBvHagGvkd5owPgQy/0H23xHbw2iBTIzE2BHGPtVxcae1gePeT7K47vZi/
cjXM/PpP0zB/pDeljdeQaYgvuJUEalUDJUbkIu06DYhvl4uHr68Gp/DAUbYw
C3u95NhZtWdLWcBde9ftlhnieyplP1NFWUC72abzbBGy05RTfp4qw/Q5l9W5
1NKxDPDSE9q1CXSQNO/Q+dQ/AEwmx/nBEB30ZN+1f0N24AHK3iwpxh9+1Qjc
PtkYtR9IvxQl5f+Dq8bOG4tl3LLMKKwC40Xtg9cHkf339Zqlo4gnL7IyGb1T
AubqAx5SZ4aBtCK6J3UEzccB+c2DlsPA5NTFMoQ+A/NpjQbxIAVwD3SiL+Y4
g+r+KIEvH3n3SUgeWdScPdtf3GuUaDp5D+HI0IdXJYWAF9rAqhsrBrrr39rk
CITbo3auw6QS2NZwpsrDndc//Hd87QcxPumAW5r5MKXRk8upRXzLY8Yp9VUe
pL1nL29u6Adyu626T2YeNHtKPk7vQ/zM1pDCkM8HaqRm1UvEz8jvdiRJX8wH
2rVTBF2XDAyfcYIjJIp/BhhvlS52WFsJxGuVdUI3MoAWqzFxsK8CLky83HHl
EMLHf88/l4KLsIug1tEewLU4hDkVlABlp0mXs1YPxq8tXrtfj9yJ1kerQ1n/
eYSvul6JRdo94BRiq7z9MOLfy+r80xcNYP33Eksfx5cEdQFbQcyqQA3593J1
/IkrrwGn9lDCPPIukP+yfbR5JhZwcmqVn0TuQuSdwWvOOmg+CY7LZ57bYPND
MtfP4XgWQf3VJBcZIV5/5Ln7dom/clLEbyG+aBJQLTKfjfHjcCvJy/OmkT5M
v3TxLz8GqBIlo0nIjltZoxP2iAFDDmI/+UQQv2F9qOYm1cHQU/VN+3uGgfuO
vTDFvxpkT1wK0JUfAebbCVXbm9XgVXxB/3nf7PlOfYnFw9VAlRFp3IfGCW9E
JJoPoHjRppB8W7YQAquEL96XrASmocC3A7P5rROyxisnKkCMYsGSrRzB6r8J
H/RFN08i/blYPiJLsxXstzjcMJoYBtdA94/X9rVCZOt7b2pQGcL7N00Fk0g3
3soOtvNE9t5zvn3yxYhnNR21/VEAxh+eiZ1sLwOxdvyJRCuES+c8PDWESgG/
1szKSB99fmOvfKZ5KVAubHwm3F8JlLc3zQ7JIz0ld/ZVl14PTP50rnDZzwB/
67QPHvro+aub2w/pMkDyRRf57ggHq3fG22g/Mhvi9YPFLROXkEodBnuVkBH/
WIS72rn8NjtHsPMiWuJZXjaaiF+XWx/qf4JwsG67lz+y43AXtBY+bADaz+ol
o1MscNLqSCkVrgRzazLLXxvNN8nu6DVPOjDzY82lYQQETeJykgLoQM580S30
PoaHp0cdrdxXxwIz1MqBNFAGRHWb19W5McDNO0AdNUTj6eNj/BfeYHqOzDh5
MsE/Fmgeg6vVDMpBJnJ8uUh6L7ZeIm8qcWze9YJxwKi1I+I9gpfjH60oQvHf
5GzmDc1yaC/sOddX1QMk3UfPC2/N4nfute5iL2D+y19qML1BSWeWhB+tAV+L
nCszx9mYvxp/U3+y0owNxrPhyYABekYhnxOOsUFVbLFX0A4Giu8zY1qdbGy9
EYSqTB01RsBp9raEvgbIzrkf44zs5k5Hg9cNDSA8ds2IqY7mU0/n/vLJBhCT
U9la/K0U6Ken54sJlSOdTbLywJchfqT5YDIE+U3+EvPLYdXYfjm3/WlReWI1
yNhXfprOZIDS6GU9nc4uDL/XGeJJeiLd2H6ZjRM3MXyqC/D4MpKIMhr/F3+6
gCgQsnjkdiPvflkZyfyaYwjfl6dE1WTx+kX+xtdBiDM55WZ+uRGyqUXpHfJD
6PnEOn/tbYCpmth57cimKh6RMGI3QMx6w4NV+CEgfHI+TfmrEVRv7LIq/TqM
5a/I44rWIkFo3jed1jFxK8TqPVUfbfb5gtYhfduJj4OTNdh+G3d6Ytv1umrg
GmhnBZcWgeuN9sd16YPA3K7VeiAI4feM4mU9ZLuOF+VWPmkHdsCvCmUX3v1F
RI9IJTGE92RHn2QBNI6TNytwDeCAoeIsgH3+g8ccEKzXk/+igfRxgPJRe6Qf
nSYyIoUWIt5rt5p7dWURBCa+Ci4TRXaOa/K8jH6s/pgqVy4hRusH7i4PT1IV
DSQ59/5WOtSPnS8d8tkvJflPP8Z3f883ev1C3WZCRx5MPU9tibIYBFrwcYnv
1wqAZNL9Qs9sEJy8PF+1EAqAdj5TKHk5ilsFnlmppgg/T1BH1y6sBsPVWzzf
aTBg7JQ+8R6Djfjjlzbajkow/qml2yeC4uuGXZb1O8rhpnUTfkqSDeTbTxel
3EH+ddHu0d73IxD4b//rctA6uqpEXqcHxAp3EW28GZCYf18gfjdaP1qfcKrB
DGA7s6xz+IeAu3qN2M2wGqgPflstwjcEpHvuW5cuokOpmy3nnjavn9WFNoUr
VbsHgfCWRaFp0CF466qahnMDCD8UBTZSq+HI00YgIZuoVTdVV1INaVZ7bBLr
OIDLd1cVukSHOP7QSolaDqjKHGUdvk0H19dLH2aUsXj91qj3X2rnsgAnubtQ
6Gg5VBKaVFVHe7H1uu6MenDQt17wbX4zz8yEAXiX8GSfMaQ3V+/b7a7FAEJo
6lVHbi9QD4ouHRilg0X4Coe6LyievHN/qb2EAYaH8K0Lkf6c4zc3KxbohnB6
gcb9mtNpQwf/x3k7EmfHDz6Ur/elQ/uUZte24V6INAxfsbAKfd/ob2b5aJx4
4md5XjwdKs8ljdtk9oG5HKei3Y6BnZcmGPffcLKsBePJX3pVTb1Y/DAflGYN
dKDxmNN6/h61IMz3bfQ60svc+98W231nYPUAJL/jl8Yjs4HJ+jVWHp+O7W/i
qxZc22iUCVyHkfbqonwgFX98Ob0vEyjEk2mTxfmAS4p9EiCcidVL/Na3mUA0
OSLNLc2HoTFWWet6Xr8l83zI1jMeADE3kfODKuVgf1pX0vkIep5SQSZyISge
d6dablHi9ROyqJYePueM+J7ffcloHxSfqKGrhE4h/3hov2VbfQn483mHXpr1
7zXd96WeIH7Fun3G2W4AnJZulHo5VQQx9p7/ONkPAOXqHrNbkmi9FTeR8w6W
QeDrp3r+e+kQ+C3d+Jh+GZQqy3zPWobmt7w95vFBHt7hmkcb7ezPQmTTYsZL
h3TAuehUrnt2D+HqnjxPZhq4vlr1/qIyB5xcV6zZK9qC1S8xnQq8NLRagH4j
8VGKIuLfE7MFimi8sidkaUIDL77HvzT6uJcNgh+4aSvGER+ROi1zxACtLysZ
byuZWiCdiL2+ajQb4uSKdk7vZADxx7PU1+rZQNa8ZvJhHOGh3wE+yUQa0oUP
TAxTEZ+mxJ+V25aH7cf8jg+IF0tGnx3dVAeSLm4QVTsCrimtXj4f6mHbo9LC
Q+UjQC/52Kn8VwMQ+L9taAkYAcNsjceulHoY0m9fVr27F8SqZL9fEm+EGD1N
H63jLAwPbgq7eSw9xwKxa+kpW7sbMP1kaCq8uaWpHmI6YptCknowvkAYsh1J
UZjtp2fjWsIkgWtTpeGl9chmTWoZlJyB0AodP1VFXr2wSsri+8o2PJtIItzq
00jA9C5Tziq/6n4ztl84V18S5zpulGRdj/UTIOxh3OtY0QBE1lnn4+YtWP+G
bd9yRV+YoN8X/9qqubIB4owssp8P1v7JfzZh/QDEhhyl3HWaoTSuwuvKoiZM
n859XqhQ7lb+O61oXT+p+bgqFZhZmaPbvGmgckCipGwvByit+Xn8oTQwErjy
uRvpscDURiefNsTTfrR8IagzMD6jZKds3KnCAJLcJYlL0uVAzUr8qbANjX9h
FbVHIxxPK/+7LZqBxSetBVr7b7xmAWX3Okrz3gbg8zpwNucLC+hbf93emPMZ
ArvNZKooLJDJkv8Yu7gD20/DUU+L2nR4Ac5bQOFk/VPA5YVZelfcA7KEo83W
nkjASajq7RBD47c23xN+HAG4hp43uvZegN/V5DfOj57HYM5DyyVBIMNUOFlM
QPZG04hNS/1B5WDXgMFuZPfP6tNHULrdk+6WwrPJ88sObPDg2WnXxiPPuSE7
1sf6zLKHYOO3oVPaGdlCjO0GBQ+Qrolw6+6O4533mlCMjT4UB2QN0fH9ZyoQ
bxYdMT0aDyTVW8uKEH8k08PV/Y3iwVifObFtfiXY7Nqjqzjbv6P6maypbQWw
g5+ohX+n896v3/NYhRhaV9X7TtUaVoBrtlq6wDxkv927wuVVBQQWOsy/xKZD
5JY84RMSlUCvWLZm/zAdPc+LbTNjFeCk/ySBdqgHi+8yVzQ2Wxn3QGTz433f
8+kw2eUwMH6wB4gRfaFMJzp4JUbLHlw8wOv/tuzLjA+yld4yeySzkf4dtPxU
g2z8ZTOFBgod7J9MHtac7TdgwzRZGuwE5JN2apoCSP/UmNz+y4kBlEARaR0c
im9aAll0fwaQQycavr6MBqa7ycmtmzuAdlSzu/NDJLbfQPyXn8RA6FjRXZlD
HaByYcNdAQmE3+bu5cFBtRBz8cH3EwgP59br7/13FjC/LNq6UbQBVJPDcPaI
R+H5bFxeHSlH+HDiyhKVQiAek2JPuSFb9kaxpmUViNFcmwT2IX4se1fm4tEq
CGy4Z6l/sxzC/UDetBbp/3/7PyD8zQq4+qohFssX4PyTk6IMkG1CG4xuRnZa
2I8+jzNY/iXQ0e64pUgZGK9Ndlz9qwRUF5kcnD1Pptqy7rrB9VKkH+b92hlf
DyTO6nN2b2qA9OvFtxIUx+jexitrp2vAMIp74usqDtAX1AZdC2iENMXzn74X
DmH9iizUyzvPlA5B6OzXu9IIk1+eWXUVz+brvXvV7jSCfWPU/ovIJv1I/8j1
boRIUcIpLpsDobnJGVvIaN1OXtS+7ov441pK5xSlDoj539sX+wyCecWxY4uL
6oDK3a//WHD2/js/t61B+cDtLLFbJ4b4Zeqpe5c5+TBWNpSlaIb0c9gwWvB5
4FtTUe9rMgDG4juXMHOR/SwleXsbB4hDmdT1udWQffj2JsJsf8v09jvjyJ57
XsSoGavvouWgWq194OpAL8b3K2eIX+iI37CTCEc90fet/+IdtxXxDV/1jJkF
EUgfmzpuXdTZC6WCd35u4zLAfLWWbAq7F+I671V6Z6P//7U+QGQU8U/kvdRa
FJcSdg1emOgHczsyRZTKAJVzPSO6Y/2AG1rx1K+EATY2x72vDvcDO0vEoZmF
9KS/8VE6ssm+fXlS3Wi+HP0fuf+VAUxqcF/55WwQTr8S1/9XH7YfQe/aSAkL
LkVxOF5gUxDSrarzxB8jW0zhQdLpJ5VA4i+LCIusx/giaXlu6qUX9aC6gMxI
8ER4uAU8FqDxSI3FboqT1WBug9+o+aYeiLbLzjz0qAHqdKfd7qh6YHqd074h
UQNxEWsMNTUZUOqKv9NniXQEacnbnXooHpi/zlZ5QIcx8Y0nUkY50Gz1tDt7
ugnMN2gFZSCcnsNzw0HLgx04xLviBuMnpGvB/qm8st68WhDsPdD9E70Oz6J2
C94YBsrE9T3fCfVAXiGyU2cghne/65/7puKKemM1fD4Dxa90n/JwKaYPnBLf
dfdOFQKpuTb+8j85WL4Z//BDVOe5T7z7kpd5q+suoAFTaL+bQ04htr/e3mwj
2LluGIitAaKrW7IhzXl7zP55w0A+clLso1AB8NXayY2Z8uolCVoZBobCdYDb
G79x5mwR0NZKOHZk1GL308zxCxJVcl3qyyIML52e6Zh/XTKrc26LVhPrsPz3
EHKqF/N49bVKfq8VghcOg2r/rg3ndQtQfGo9/YSMcHrQeg/dugBU7kiLF9p0
gbG6kBr9TTHIsNtatw+MYHjJvrybfmS2Hu2UtNCBT2WgZxxWHIX0wtz+o5jx
lLXSW56tMhboGKI7CKqNlK9v/0J6IbBc7zqyyVEZ3aKA4svlu5erjAowfiFj
/muxaFwnUGJhU/iPZkzf4gMUNhNL24AW5avaUPIG2280Snb+qfa+B4yvpsyr
jCgDWcEPLRtQfMblB1za8RDpf6HlOXWKbGx/fSgrJqNCnI31ryBVnhHtujV7
X9dsQq8dxZ1h1ZmrDCw+ar0c6hB/w8H2twp76HeWj/BsZlDl/thZ/zx5/6wj
8mu+6eiUgpwRwDVSf2mJtSAevXSYdK4fwz++2g7xBe28eg3CRfHNO1axsPWk
VyW+JHkTC+OTONnaS29S7RC+XOcK9OWC3qFpI2tNFoZn/gbh1c1qLCzeTCXy
ebnLs3h8t/Y43u00Lz8f/jU+baCNDQTTa1+PetYC34xOyYv4oT/9REqAHGjS
LZdZhL0/bpqIt9z4EdPzcfOe/mqx7YXf7lQK63RXP/i6ZZCXDze9f97On2dT
V0aZ56kg+6pczXaLSrCoM2yxUuflawPzdQuknvJssfCa5J7NKH5vmdGO86sF
anHui5KbfdA8Szdd0Lrgew0Wm7MgkJ3olNabB06Op3okJFnY/xMJ8ivcBrNA
9Ufz6pf/oPXNfrHwZ3EmVg+NL57K1VcvAuNmKYFlPmh92Zg7CeVRET9SpW07
g/zRyyO3hYD4+up59tbnO4Cc13nRyj4B+z3k+MiES4x4pNtWdqV5IDtSZ81S
0QTEa8yNlyVXQuEZh3wbYzZWr/EbH/qAlr1KrMydDuGF/G1nkT13f4+w0HIH
1eBuDP/Z8WZBs/Ukc3pEMO4U/61XSH+u+/YFP78WcMaiUbq0F1g97By/pA1P
RPV5pwJ5yU7lyIQMbHzufA9RRCkx5n0KqNImS4jtzUCxX1P98Gkxlg9T5Vbx
1y1B778y4Vi9YBIvvvq+u9CnxcL4b/gLpt3e+n7svGxlHUEmzB2tn2KpPYdr
miFwQeZBz8NsaLaLr7AgMYCesqu25Qiajx8R+g9NGeBfueJ2TO4g4MUTfq6v
agDB1k2nPssPYfttFlGrbA71InyefZw/2gHf88IjFgYh8t9wWo3Fa/wPCcmo
jVnY/h+uLVxhPOEBZKe1fJxYhPTulomj1+vpwFLwCNNF/E4sl6FaU0wH45aD
YVvKhyAwT+Cfe6RGuLAnIn8+srnG+LTjZxpBRvFJa4rtAET++/vzefWArzkG
4rVI9/1wi9HOqsfWs5hLyej7RhZMNgoSYxAPKjV/ph2RyIHJ0btfbGPqweL7
RxI7ngOk/G3BtS71ILk7YixhUze4qr14cbYa/V6Pet0GxAewfuTlyU3tyBab
P7lv2W7EV8/7Ut6N9AI5eiRshxzip+tFFxTP1lNIFq9mx5cj/7zQanI+F4tX
NNJ+STs6HfNXducq/giBHt79eOfZePMXhaBaY8oNOV8C1AJZyzU19Nl8Uk2g
N/Ln4VUiCtPxEDlTcGzpRAE0r02W/Pa2D+MfpK78W1UxfTCpsI9wEvGLyC20
8R5k+9oNr61D/KLeZtfVFLfeP+e/yoAkuCLkjnwjtj7bceIdC216AHehzugu
XynCT4mMA4ID2P6sVwF+WKsY+RP/ZsTQm6E+W/1+YAcbQmfl76laGJMQuppX
NYTiq+SxXWafQdWpfnfIJTRfQW+YCvxlUGp4MLHLqRcCU+465oqiz7/NeCqj
PIidp2CZC0TFbxjE3o827d+9XO4tFj/XORNP7dLrBfPYyKul/I1APBOWpK+f
Atzkacdfn2kQp/Dcxj4I8XU3t0X7byH9V9HZfziABYRkzr2LWzrAIt1N+U45
C9vPiBk30J85NQDEnxHnQ8TzQSm67fWUdC/Gf7OVo411FHsBfzqn48jlRigc
2xN3TaEXIq8U1pY5NyJ/C7e9l/QQaPa2bPnQyD/5t3Lg3oSvI7lIz64hpEn9
ogBppZrj6OEMLN+Mq8/2Et5MBbG7G5y2m5YDxYE6fj0FvT70zcyCq+mAu/yq
cNWKdFDRCYnToA9h9SKBASuVNlHKsXj///yOT5a4RsekB7hPdxmcSKP/J79B
Dpt4foFSCuS/30QkTZf/p56WNFAnPpmdC6Rpy9XWS8oh0m7sY3v0B+BKDuho
/0T+67vsZnz1G+w8tBIzkU41Rjhh6fN+/7UOILQt2rFtvB/EVi9T7ZKuAXPB
IT//wyhuET35tWvVAKdDWrfhexHv/uf/6x96kxoem8vpA/tVRvn37Dv+k18n
nckcdNpQhPV3IEb62YVEpGPngQV3zFML6kB8WVAqc+nqvwHHLWR/OmsKtKFV
aeaUKMBxVLKTiSguK53dKO5qCUSprw4+rxEf+gdvKzxR859665sVUuJOQgM8
Ppp9yeqCzUPs82zuqHacVkLPB5/vzifR8J/+IUSba4oPdWKx+u52t0hxKRnk
bzVasbIh6PtVu+dtT3ECrvyrtlqVdlDd89fbaCeE99ZSymFNBSiuPLY+wQjH
6vfY2nvfxupzsPkwz9Ky/EIYwsb/P98euDs+JpMf8S3lbPpCEaf/9M8nPDXT
M3YZ4p1fOeQRjn/HAaWx7wv9rnSAUXyOlOziESCc69GT3FkPlK2U4tn7Aph3
zszna0L6xOb4lIPBCPY8/79+jvJP9jK5GTT+6paF1TjSDVf5nMf6UHxgrTX/
ZOsCtCDOj5KaEfC13BoQT/sMwptKjSy/If7tu0bJL/vjf+4z+Y3X6PeLbi0d
93EG396z6nHo8+fwdK6fDU720Xanthtw0+7jyc/jI9h5HMkuvJfYLzS+avhi
yfknQL2v2Bf3cwTrzzF5zizz/lr0+vJZf3SHwNyvKq7dyGY8tQ3TjUb+MH/7
9ouz9ZXChH1R07uYO0XelqD/J7O/xd5PCIL/AUF+cRg=
          "], {{
            {RGBColor[0.178927, 0.305394, 0.933501], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmFtwV1cVxvcJtIChkBvkTkioQBIoEJJ/0kpLHQs61oLCYB98KFABoTOE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                "]], PolygonBox[CompressedData["
1:eJwllEtslVUUhdellEf6vLe1Ta9tbytIaZvLoy3/RXBCAg7AB0LQMQUkgLE+
EouxEIFohIRYRREoEkLBCOqAhGgitDgwUYESHoaXMtAoiQmJ3KKJxoF+K3vw
J/v855y111p779Pa27fihQmS1vFN5HtjnrSgVtpVJ7UXpMwM6Rk2VrKXJt7D
v0HWec68T1x4SGqdIi2ul8YLccZnt1dL92dLKb7rVdLLD0hH8tKqBmkF+4vK
WfdEDue6VSr156SpTdLeEukueI/Nl4rc3wbW95zf2hH/vNeYkqZwtsj9rsnS
Ev79Rfw6/MtYF+G3hXhbNuJ7fAOsxbfFMd9/5G+Cfxr+X5dJYy3SpnzkMseN
xG3kOwT2IPnWZAPDWNYkuL2aC+5vo2Em+Ye5c6NSOgyHtlbpuy7uZtibJF3L
hWZr/xc/9iZ4PUf6iQIM4+lC4mP8Kwerkq+IvuXk/4f8I+Qfapa+6AnvPyL9
Vrw80Y735VGj48QfJIF9Gg4j3F/A/R+4/wqeDndKVdwfromauXauiWtjzkeJ
R5uidvZ8HH116H2HfEOcWdVIP+DRFbgtZ/0ze7WzwMKLGvCrwZ9BvoPOh6al
6G3txp+SuDOAPw8n4X03eqYTV8Jn7uTgVE08xL8x9GxAz024PJlErQe58xTx
KGceqY0ePUs83hneumeKxNvpkQvlgbGD+EZTYJnjAe4/ise34ZaBz+es71DT
xayfRs8v6OmA/yfwP0vOjfC/Q47V5NqN37/j9+Ukzvrfbz3hgb0whrHuF2IW
3JPuza+oyVr216Wl5rlSjvP7uLuS/C3gDzQEdgf/ToG3KRe1OgFGJ1w+xPMJ
qejZlP1uDu72wF6MzZQu0bvr0VhNv9XPC69cM9fuKhw66mMmPBsZ16giOJnb
82D8WhMYf1Pbvmz02jHutJN/4pzAtqelxDk0PJeOnnsW7r3ZmA3X3LV/kfVo
Kjy0l8vQ01cSM+RZsiZr85mXOHuwObx2j7vX36KfXquKmWykP3sbwjvndG5z
MjdjbgD7JJxPlYXGK2h9nPr0g/cl+p4g3tkQs5Lgxwha79EPFXUxY5619wrh
vd+0d4n/wJ8fS2Nmv+2KN8Fvw1E8SnO/O4lZMIaxzifR67NYXyDezAydqQxP
7e25JPbMaT9ap6F5c1VotNaPk5j1i2Acp1+XzI63wzOTBv+zJLj7jfg0iRnz
rBnjTe63FeLtMWdznw5+W0XUOM26kI1Zc8+1UP9vHoxcfhP8NlzOx9vjmbjN
3p+FeEvtqb3N9IR2z6hntT8fb4s1Wqt72L3snDXkW5aE9+5Z9+7/Zafv7w==

                "]]}]}, 
            {RGBColor[0.992825364, 0.9870625040000001, 0.46046333200000056`], 
             EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmXt01dWVx094hTcXcpPchECCaGKIJFHuIz5qVwntUnGqvOlMu6o8VRSZ
ytJSrULplKGlKup0xvFVBGkR7IBaa0t9oeB7OqJWQVlFnVE7o8SACNgZne+H
72bZP373nHt+57H3Pnt/9+M3atblkxf2SCnt0k9PtSe0pzR7YEqvNKc0oH9K
twxL6ZJeKS3PpPROv5Smqf+W2qlqx+t5sSGl9vKURhyX0mH1F6t/aT6lpWr/
OCClSZpzn/bZ3julfnrqT9ZanTOrJqWdmn+q5n1aSunXg1OarLm/ER13at0n
fVJ6Qk93dUrna/whjb+geQ9UpbS7PqWvi8a5ejdT77ZUefyB3h6bV+0zbtHe
u7XHpOQ5m/XMUX9BL/crxfD9VX7H+Obosw+8zo19No1MKT9U/Eg2hWqvYf73
xcPtapeMTmllo96Lxp3DU9qg9b/Q89MyzSmk1JVN6Wq1vfr6HeP39rGcWbNR
/VbJ6KZeHj+pv/f9ruSzXf8bR6W0RrzvUP97GvvPcSl9pv696jd2pPRL7Tmr
VvLVum9WW/acz/gV2meC2jGaX6Zzn1b/HvV/oPE1aufpzIVlpmHRQJ/br8P7
9FVbnfW+zN0pHTise3pYaz7KpfR3mr9c/XUNvq96zd+a8T7wcn2l6YCGU1ul
L0NSOkPtc6ekdLP06jXd40Kdc7me9ySHzzT///RcpLXLxMObQR960a49O9HP
QSkdEb3teu6XTOs0f0vB+oAuwOOrGe95cKDl95Se72vtQPGxuLf1+YqM90Sv
fqT7XKnnWe1dVuG7fr3MPHbrGaI1Y9V+oKet3PpO/3+1Z6vaD3N+f2LJ+1wp
vj6R3H6ifpX43NHbckfmyOyj2PMrag/rrGe4nw7PWaR7nBfnztWzRbLtr/M+
LpmXuwaYn31V1hP0ZfqJKZ0rPv5Ha2dq7gw9T/YxTdC7UrwMlTwyehb1tFyQ
+32i5ztjUnpc/6eP1TrJcrqe+Vo7XmsXa+5xPX3fC+OOKjT+tN6fqv4E7f2G
+o/rKRftG0VPn97GjJsCN7b1sT1jy9AG7S+Lnk9lC5uOzdf4hgG21RdCN9CR
/r2NHeDGwaxl+XjG9sv+2CDtzdEfKpl0Sz/X6P27I633v2r2/ytCJ/8k2ylJ
D8dID9e2pLRKd36aZD9LNPTTs1D77MtahvwH7zoHGuv66A7+Xe+mFcwzuooe
/q3kv0L/T9ZdzcuaVuiE3kNZ69LxRdm95p9QtN1zb9hac8m6slR79h0h3ZW8
v9ZhzIAO7v4uzTks3u5Ue1BPp+6iW21t1uPIGMx6UM+VOmuH3v9JZ3f2MMY9
EOMzaoxnYHDTAOMD9glegnXYUEFyGac1F9cJf8Yaz69S+4homyIZ/FPRPD4m
/tbp//ktnj9K9J8p3fiSnheztqXJ6j8zyM8k9b8heo709XwwoUtj+3J+d6me
hT2tq5tz1jPw7h3RtFd3+rbaKe3WxZN1t9vkYw5p/HXRNm2ssWFvm/fk3F3a
54Do2J+1vm2u9r1A8zWi9SWNLav1HTOHe7+v2RiySe3HWa9n7bhy/6fP3lP+
av9zc14/Med+TU+3vKOPDWPv4OQFBd/RhWqvKfmORkkfFw+0fm5KtqHVvW0X
YDzzub8bpFsV4mGr1vUQRqUKyxPZ0kfHptd7PuecJ52s117fk1+aI1rWl9tu
keuhPpbtUw32Z29rz9srbRdFPY/mLaes5NxQb8ys157frvTZnHtxvX16c4fv
boGebT1M9+rQtxqdm9Ozqsz+DTvEBhkDw7nrvNbNkpxO6Gk+yoKX4ZXGTTBz
VsGy2CB6W7Pea2PEB/gd/NfUBvuo2eL3rmpjKuvByK4qz7+l5P7NJdsluI/8
sEswBVvBrrHpbyfjzvbw138Uv6t1X8+c4rv6fca8ZFrsk7KtlgXzL681T4cC
Jz/ReV8TTYfULtecf9PZpxUcs3wWtnuxxp/X+BSN/0T6d6fGf6x2bqPjsIdO
EhZozre0z4AO+1p4n6yzllT4rCVl5ndjYAu62hX2tS/66O2x/9f1MB6j3+h2
p8a254z9t2msrcq43tJheS6QDN4SfRdpzTDJOyM9uVtnD1abEZ17FTOtavbY
7PCT+Bv8DjJ8oeg9n1f7jyVjZrv2WSf7fU22fPdY+7dx4Sewc+x9l8ZPGWD/
yJ3ObLcvejLvGPNgP8eZ8MOe6OeWiA0m6pyJVdYJ1hJ/gX3g3vhq4ysYAL34
APzlR8K6H2q/caLzhxnHu+D/hPDXq8uM09wx94teco/EZb9ssr7/Wuf+PHw2
cRy2jtzA5G0Z+wf0vKvFWNlUsu/dXu05B9p87tBG2+zm8LvVml+rc2tarUcN
1b7/98Lf9c2bD3g7im3ad6fOKR3nsc7gmZb/vFsUMRhx02rtv0z0DCqZxif0
/Co57gQz9o4zHcga3neWvB9xytuhG+/Wem/oYP8vZ703+8AffHbo3fIxjvV+
MOYLf4lMBmnOwGr7g9XgapVjkQURz4DV6CM6wZ3iH/Dj+Ah0jVjn+jL7VXAf
LCNea4/7Pb3ROnNGo20BXtAZfD1xPz6SPYbFPgdjH+gj3iHuAXMq4ix0HKzI
xHziHjCTWPS8BttyZrTx5tnwhw0af1P/l4d+wkd5D+sp/9GxJtG2pNrx2Y1h
m4zjb/qFzf5F68/WnCNqv1G037lW9zAvcAP8OL/DsdTtIx1j9df4X8Tj6pLj
yJtKxk7ifOLtpg7bycR66x96OEztqw2OMz+oNYZzR+g67aDoI6dPIlbj3uAF
vi7oaXzFL3CvrAH/yUugE5kRD8M/PP6uFPLXmRuk33PLnSvSzim3/oDZA2Pt
b0red22dfQn2u5qcrsnnb6313c8K/dmqs36f854bxjjOWF903DczZEsesC3s
FBkz/6xq5w2TIycFR7BH8I24Bz1ABx4sWSYPq50f+k/cTcyIj0H+T0VMTKw+
oc4xcdvx5nFr0JaqnBdhJ6z9LGJO6GAOcmjLOQ/BD51T77iOvPBfxc/nmv/6
CK/7PNY+XTJu7ChZv6ZG3v1Q0Azt6BzvGN8WvhafuK/Z8UpXs/OzPZGjnaM1
Rcnh01HWMd6BycSo22LtnhiH9+cG2Qfhjz6IHIp86p/rrCsTi7a1PX8lqycj
j+O8N8Lvg1uLIjfBLp+I8SciL+Fc+IOXCckxOj4C/3NMpuxPrnYo9JaYidjp
6kbv8UbQgI+CBmJH+Ngd40+fYrsGy8F54u/Zg22jM0KX9kbtBD/SHTEhseG8
yBXAxvkRV9Ofq/4jGedoTZLFDaKzsej4dEJgC/q4NXTy1HbHJMNk46e3e+1p
au8res8z2n3e/PBBvH809odW9Oi7PWxb6B9ybg+/eMxuZgeec+bcsMGOsEfW
Ips5sZY9wXre0+4Iv3ZJvf04+W635PW85LZf7f7hokf6v144eWikbRbbfb/g
vPS9gnF0b/hi8kVwbHfkCGA/9t4Z8Qv/8TuVVba9LUX3NxdtK+TGx+oIRyLe
AzPeiX121bvOM016MrTF8j6+1jIHC7DNqe2uiUxTe0df53TUc/BvZwXvzKUP
bnZHXHFP0bJCN9Al4hTiXeyH/PXjyAXQgcPxnxi1rMqYt3+wsYS7+3PROPte
0TEgsQJ+ubXBsfrZ4+zDkS16hfyyWevihbXGbGIWcAv8It7uHm57+sMY57uM
g2noC2dz7h+yfsc4eR996CfGhwfoX5v3WdNrnB99p5exFz7AbXg5u855UmWL
fQJ+Bb+waqznvznCNTXkeny78yhkzf/NIY9jdQD6+AJ8yiVRC0JHsHPslNic
GhxYTd5I/tilve8WnRXIpMbx5uHgcX+bsePREcbW1tAZHvQHOvdXu0Y5JTAU
v0Auek+D4zPifda1Bb79rOizOPPDwG3Gy4Y7/icPoJ5I/L6ixnk5MQl2/2HU
oDgbnTgUcv553jXSD0Xvs+XeH3peCrlRm9wTOAZ24uepEdKfXvBdzijYruAX
nKTmgY4QC1ELpmbxarPjrM6wL+oUxMH9RjgexQ+eU+cY+SsRq6Q26zg5dyHn
fI8cEz/PHOK4/2i1DsyUbG4d6ZzjOfX/LP5nibZ3xd9jkZOSm+I7fjvEej6p
zjWq5hbXIKgtUMPojFwWW36m3PKhDgzd4ANr0MFbs47VyKvIJZbG3Kv72r83
jXa/UW0xZx7IkxsKXluqdVx2Y+AO+Rv3OFXtj1p9t6M157aRjsGIxf6+1nyT
V4HD2Dn3SV5bytqG9tU4b38/b/zGT2C/YNn86BOXzouaxtKM7x792x2+F34f
i/ngxVDdU1/9/2qb81FqGuRa2Dd1G2x/dm3kSKJty3Dn9Klo/PhynLuuzjFv
TjJfX+fY/P2iMeDM3Bf70QcTlkTuQA37kbx5XCn+8lW+X2qh4N+XYj61OWQ8
Q3uvyzs2Jb+/Kuqq1Mwyo1w3fPFE5+X4EWIJYnn0A90gF8JXUgsk3kcPkMvd
kW+WSQ6XjPW3hwW0Jxk71jd5v+diz/Fxv/CJXZATYivQTj0X+qdE3Yk4gNy5
POre5VHLod9b+HWD1vZSuyrnOu9FEY8zDk5tLLqOualofekXNRByi35Ri+Ce
p0T8SZwG7oA5145xv7vNdkD9nXPxvdsjJuH+afHX2O5vK53HbqxwnI1fu173
ei11kRaP3Vthn06dFPt/arjrTOSJxPPUIZhP3PU3ovth7Xlu0fzB55CoCTFO
bDfyZNcafxcx5LK4F+glzgFHiKuvj/55RdP59aJzcPAHOohBNgRtrzSYhxrd
edVIx+1ntjsW5j6Qw+xKx6PUpbbHPqujFt0nalaHJbsVWnuozf4H/cdnoSPY
GPaFHl2XMU5A+9Kgf9cIx+u3ic5pkYdUCQf+K29df6loHZkUdVHiTVryC+pz
KyKvJi5G964L24OG+4fb7+AfiVVywQf956O/KmputTEOfxOCR+Jf8kmwne8/
/UOv6o4zRoFV4PaEkC11X+wLDOG7zZpKYyn53I2xJ3wvCz8yJ/IY9Ip75X6H
tURdqsL2PzjqRcPyjiXpE0/i45F1TjS81Wad5rsEfo+7wPeB59QowXT45S7h
9cdRKyPPvjq+tb1cMl6D22vy9sPQQH3sKO1hy8RN9OGpO+rqB8gj8cEav0X0
DO7wXe9rs69fHDLJjPS3rg7p2GU5zyf/HJp33Mx3UXzUq1EjIqYA54kryJ+J
B/lu83ab7+Rl4eEron+C+HpD71eWrBPX1bjecrTfw/Ux5oDb2C3+FL6oJcyI
bzfEn/Q546yot9BHX4lVoJ+8iW86+IUrG5yj3VFyzEfsR42taZTvc+3YL/Yl
ht8z3HHgSxq/qsE1Lmpd4AG2hB1NibPAKHwz/vZfWm0/4Bfj3CU2gl5NCruC
NmyR7wTY7PQ63/2luofP864hpKgzgS/Qg37i1zljZ42x8Cy1xVbv01nnb01H
ws672nyn3C14A86Mi7o9cSr1lY/b/M37YJtjU+IT4hTkQB5FHDovcjho6A48
P4p14S/Qq1tbrWv4SXJK1rN2a97fSf+72fVkfD6xHLW0fVHf2R819wMF5wqM
E0utHe25P6txrQ1ZUJf9xWj7aXKpDc32Vfc220cRM3MueLoo6hXs1xV7Yruv
hV8gPyFPoQ66Ob6HI3e+66P/fBc69s1jYXx3QebInhrdpREbg1sLYs5lMc4Y
dsn3V3QAfEQHqgt+f1nYEXjA/sid/HNB7Mk3AjCTeh3Ygg2g//iXC6K+hK6g
M6dJ9tfW+JvBQyFvauM3xfdMYn3ssazgtdQeLqzxN+978q4hUFOgBoAu7w/b
AQs7I7Y8vdV6RxxK7YP4pXfJcw8EXhyNOWP+P7Q6l+C7wY6Ie8h1K1och/K9
JZe3z325wXVbMHJI3vaCvZ8Qdl8I26ctRp+4qRAx9oNa0yJerhFPQ0YbZ8Ab
dIFx8lViLmjAF9DWBT135F3nWtFsPvZHjgPWjo8c4f8BuwruLg==
                "]], PolygonBox[CompressedData["
1:eJwtl3lw1dUVx28gJCEB87KR5BGTIJBAgLyUvLzH1nam0I4sLiMJaJepJFRB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                "]]}]}, 
            {RGBColor[
             0.8923132800000001, 0.6039015800000004, 0.2318559000000001], 
             EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXl0lfWZx98AIciWVLLckJsQGky4hCyQe3MRlVYEEWwAkUX0HBVwqtRO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                "]], PolygonBox[CompressedData["
1:eJwtmHlw1dUZhg+ExMiWFLMTSSiQkOVmIbm5EVDLTrCUiCGATpGtMGgLxUoL
OoURZJFFRaSLGygG2VwQWQQ7lYpgkZnKjmgHRFZFGBRBttrnndc/ztzv/L5z
vn07t+3ICQPHNw4hdGgUQhN+R0RDOJASwn7WcOBH80J4ITGE+eAeAW7Lt+fA
DWoRQm1RCBfYD0sN4aGWISREQsiIhXDxZyFUQi8duKx9CJ3i+M7qkw2N3BBq
bgnheloIL4Of0BGeCDASGpeg9ST4YwkhnG0awmbwp/g2if0Q8KeBo21C+Cw5
hMOsX5eF8Ck8r8B7N/tycH/JDOF25NuCzMvahfAdd6Y3C2EONL4F3sW3fwTT
GMb9v5WEMDcphBj6FKBPK2i8giFK4X8b+OWcb2B/Ghm/bR1CHfxWwm8N+/GF
IRwqBc++GzQPAjdGxx/ZX20ewifgZxUgD/evIP+iqhD+B78D8BuODd6v4Az7
TewL4J8K/99g4xRoFyDvGOA0vhWCy+fMXdn2iXwzDvvV54SwkG/roP02qwb6
9ci36if5HoL/SujvYN8Ef6wA/hh9dmGbHtD4uBIbcf9+ZElKD2Ej9t7ZKYRi
eC9uxTngvtn23TpWOb6cA/8T8SG8h32eAB5ZbJx0+rHEOkiXDuxrsm1T2baM
/d3sT8NzFLyXYq9z+GoIMm9PtQ1ki5MR224cZ85UWkbJKpseB9eVMz05Ww3P
24D/U+jzioEL+KdPpn3xBTLOxPYzo4YbkHcW8HFsPhV926HvylzHkGLpc1YV
vu/4k7xfQO9D6L2FfJvx3x3IsBb4YI59IxvJVuc5cxJbb+DMoYh1lK6SsQvy
jWP/C+A7WVH2g7Bxzk0hRLj/KbR2su+MLtvlD+BZ0Fvd2DEzAHqjiIFEZD+L
v+uQNx96jeJ857uIfS7fv8N6JtsxqliVzK/h6wR0ngHtx1hNgJexUjjbDP6v
AI9Bh6H4egc6n0P3+KhjRXduAj6HTfphv+/J6YPlIdyAxwV0KeZ8FufDreQ7
+8vo9H3bED6otK0OYM8h2HYqNBbH2cdDkXV5PvGDPl2x73piJ487S7h7Df0m
57qGqJbE4aNS9pexSY9U07gE3B4ZHkSWPpw/g2xHoZdLfrfkfHfO90C+tDjb
vAp7L2c/L8k5/nf2Y3Osi2rUAWh1gsa7TZwTg5H3BeRfAf87+PY88Ax4PtrM
NSgX+rXo82/0Gwn/GtGKunaNYF2MOgYUC6pB/+L+M8TgsZvRkfsLgRdgs6fj
7dMngSfjo4Wc/wyfHcZ3b3CmN/E8FvlOIlsmMuchexH2Ti8yD/E6A/8eyHM3
+50plkmybcnCJeC/g/5b2GYw+udhj0XwLFTuEP838PePrGLuB3zyIOdnwmMt
/OfCvxP8K1jzCpyDykXVzBPodgqa8xqZ58CoY0qx1Yx8WgC9vCr3hqehmQ9c
gQ6HiIUZ0IsnV69gzy74ux/nr8UcI4oV5bByuS8+6cb9PvDoA/w58fUs+O34
ZD7847kzCt2vQ+MqsVNDvieluCbfA75flXNBOdIR3f/L/cXc/wj8AvDtoFmT
5hjqUO4YUiy9h4/X0YvGVbMyWPijEfaYjQ3uxD8t4fEithiEvsvjLUMCslzF
HkeQdS8yX8c/x+gBk+D3B+IpCd/2Z81PdM4od87Cr2+8ZTiJrJnQ3Arvzuiz
D/s1qD9xPgX8G+A3RFyLlGPKtSngV4Afjb3+jO7F7AeBmgnPS/Deg8wvgS9U
faZ2PNDO+wj7eey3QmNWsmMyhf0q5P+6qWXczN2l0gneMfT/E/KsAH8G/C70
H0FsrWT/VVPXkNXse6FTepx7fBrx9SUyfAjtbtisAV4ZJe4F8qF8mVXiXiaf
yDdrsG+v5o751wvcU9W7lIMD0b1ziWv9JHzyW3xzvsC9XT36HPBpbNQ/zTmu
XD/Fvi7e384Ab0GnBYnWUbreg/8a4n/yMfRyWAvSnZOvavaIufepRm9jf3+Z
e4Nq6rvE2+h89742nH8LX77I+cvwmkAM/JHze/DJNu4+xJ2j2KIX+fZmcM71
Bv49+r0OrdXoNyTiGqxa3ACNXtBqEnNtGYbOS4nP/QX2tWrEPuD5efal9qod
ZfD8kvPHWHO4e6XctXwb6yzxeAfyZ8R7hklr4x6iXpKGP1+tdA1RLZmKPGnI
k1DoXJXMf0WXwznuVe2x0a6Ye6Z6p2bEkchezv54mmese8mfaZnu7ZLpCc73
jFk39Rj1mlW5pqUerF68HnzLdMeYYu0d9kcT/G0D8Fl0nog8q6E5B9qZRe49
mok0G22MuFaoZ28Cbok/R4s+9j9f6p6i3qKYVmy/WeXcUs2vxzYbit2LNHNp
9hoc9eypHK8HviQb4M/BfPsA/F7uV6d55tLs9f6tzj3F8GpkbQz+d6meuTR7
qSepN7Vg1aPv4Ih9r5ql2vV2a9c21WDVYs3Emo01I01RPFU51sRzH/BZcu6B
lq6h+8EXqt43cs3MRN6B6DQdWU6gz93AL8VcyxSjS4C/KXJs7OPOdO5ezrLv
1UOP5Lumqrau4nw/zfJt3dsvov9a8P2yXdvVk9SbJnc0L9loCnBnZsTG5H8q
509hm8v4oGcT2+eHUvc09bbnsUci8Zde4lhXDekN7V/me1ZbzuoP/BE2vZe7
z5HDY4j36jLP5kugmQytUviNiHPP75ltnuKtnP8V57vis2nIth4ZuwC35/6a
ZNdE1crqLL9VHiNmsqqdY8otnelQZp/L96rJqs0V2GQRtjmOT8qBW8Q8i0uG
hdh2EjSeynCNV63Xm0Rvk09Y95RZZ+muGegUuAN8ezzBObqG/eJMx7p8uJWz
8wvci3vxLRlZ1rV2L1OMNSIevsem3ZvbxhdL3ePV6yfD4wjxNjDLtUk1TrXu
rph9mw7PtcTLoDLLphm2DngAMZV7i2cAzQKtKz2L6Y2WBTwg6llVM8DwLNdE
1Ub1+Pu4v5s7TyLLSvZt2ddF3TtUc1V7c8uMk/3VmySDZNHM8nbUPUu9S2/O
3ej6dZbfftOIz3riq0+FZxe9OfX2nBdzbikH5sbcI9QrNPPUEw9TKzxbqYZM
A56c59h/GJ5TgJ+p8ttsIjIdwX5bNIMn+Q36FLbYm+verBk1o9I1VrVWNU+1
77Ms90rNqPuiftPpbaceqV55NeZZRz1+D+ePgn/kFr+B9RZWj1Cv0JttUMQ1
RLmiHq1ePTTiXqqeMQd71EY8m+qNMJv9XuLl4WTPHJo9NMNoljkJ/9Nt/AZU
P9WZL8BnFHmWlI6vYp9nSzz76Q04vtpvFL1V9MbXW/+1fNPSjNEde3WOOrY2
YuMZnK/N9Wyrnj8J3Roq3Vtq9V8CstVnOnYVo8vAfVPq2txKb0D2ye08Kynm
FHsvVxrXnTt54L4qcK5X6k0PbnamYc1AmoUmot8/m/sNPlO1FHv/kGAb74g5
ZhQ7qpmqnYXIeKaVa4pqS99Mz3bq2erdqjmqPcrxTtxvjL418c5p5fammN/K
6lHqVQOwZx32vB2bjc12DVEt0bdKdD1X6tqjnqTelFht29zH/uZq21C2lMwN
uf6PRf+16M0xoKNjVLEqmYuQvTLmWVNv8On05mv5rkWaQTWLymaynWbWfOCa
Cv/3oRpTkusYV6zLZrKdarpqu2p2LfI3q7ZsqplNq/2G0FtCM9Vl4mldzLO+
3oR6G/68zLVZOX+DeM0rty1ks2/A/x+jNtY0
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1mnl8ldWZx19iEhi2LEK2m9wkBG9IwiX3Jrm5mdE6U5VNR6U6DaDIJi51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                "]], PolygonBox[CompressedData["
1:eJwtmHl4lcUVxofIVg2EmBBIAmFJuHCTXHIvIfemdWlVSKgLIG1NEAShVFBB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                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw9mgt0ldWVxz8IbyEBTMj7JiEauAk3916S3BtQBIoiFcURUYEBFVushYKD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                "]], PolygonBox[CompressedData["
1:eJwtmHd01FUWxx+E3kIRQipgJJKMycyQZCaodAWUFVdAJQhIXwQEkeIuqISi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                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXl81dWZxg87hISENTtJjN5wE+69iVmIgoLUBdlq2RSpMyAqi9hWprUj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                "]], PolygonBox[CompressedData["
1:eJwtmHmcz3Uexz+MI8yYcTeXmZ9hzO83Zn7D8DMhpESucp+7kZJ0t10K0Uai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                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1mnl0ldW5xjdjwpCEKZRwcpKTBAkn4eSckJOTuNpiq1exoh0UW1Ruu5Yo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                "]], PolygonBox[CompressedData["
1:eJwtmHuUz2Uexx+GcZtbRMz1NzP8zP03d/ZUdms3ttBFtBXVOZExRLU5FTFi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                "]], 
               PolygonBox[{{9927, 2650, 7735, 9138, 9139}, {9139, 9138, 7736, 
                2652, 9930}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXl4ltWZxg9BSJCwJpEsZA/ZSL7vC/mS4AKVDrZ1wI1Wnaksyr5jWzqj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                "]], PolygonBox[CompressedData["
1:eJwtmHlw1dUZhg+CECCJLFGa7Wa5IeQmubkJ2UDFqgULFRVR0SKgAmGJBveO
2gpOZxRFx1rWRFkEBFHQgAKKbKJ1AMUNBBewSgCtVZSpSpUK9nnz5o8z9zv3
nPPt6y9v7M3Dp5wWQpjYLoQO/N6WE8JpPUK496wQIrUhLGGdBB7aM4TllSE0
VIUQ7RRCUXIIU4DLykI4+4wQ7gNJemYIT5SH8BF4VnI+v9z/6Wx9lxBG9Qnh
OPt/s38GYqujIdQlQjiT+5FuIUwAXsabXzhfwPvlwLdnhLAN3vp1DGFnSQgF
2eDrHMKwpBBm5YdQD0+N3O/M/RuBP8wNoRlet3QNYV0RckQ4h/ZS9rPZT4TG
Q6mmKdo7Wf1En/dvAr9eHcIJ5BkAvdeAnywO4QBnn7IWAx9EP9Wc9dcC3+bS
EKq6+r9NwPnpIfwM/XXoaCvwUvR3Cv3dlAYv8DaUlcV5BvhGxkJIRqbk9sgC
zcXoMj/D8GzWEvbvwtNZHczfe8Dz+4ZwOrJniD94OVgRwq/dQ9h1OvZg/2gB
vKOfAu6kouuns0J4BFzjWTeB73V4fBt6P7PvC77JtW2ywmM98Hb4K4T338Jj
F+z7Av8l9eItb9bUmmfxnsH5xdydBI5cbLeO/0ahn2ug1x/c/Vgl0Iuj3FW8
X5ESQgu8pmCP+cizHv4WFIbQqbfteTn7IfD7HvItwP8Wsb5Anmx4GIN9n4Ne
pMoySlb56CHwvYqNzulonrdVW2fSXUf2zfDXPWr71sLfbHjPhebX0BsMD3HO
5kDzBfBfyn5CPIQXq63bkdh0LfDH3HmH9/s4/wS4EJt2AtcV8NuI/x3Dp0u5
+yU2uAbejrAW9rAMkkU6kC4UI39ENy/VgB9dd2K/Hnh1rnktB8c7irdi+1oU
f2lG3hbuDOL+T8TAEXQ3hf0BnHciqwOxkIjbl6X/cuBiFk/DWvYlwNlZjqcW
9FcPvpvh7xS8nmR9hv7qsV8+9lvP/THQ3kjMXcr+JPLOgt5o7m9G31tZ3eHv
Yfjt3Ms+0cx+Hjr4Ad94AJ2mYMvuyBtBtlzWBdC+pNi5YChM7YP+AP5L5X6G
/JO7LWXOD9LRIeCB6Pe8YB2+j/5mZNl361gNnNexH8V5Dvse7J/NsG4WoYQa
dHOwTd+zuPM58Fxywgro72A/B/hY3LqXTqQb8She57Ge4v7YbMebYvQW7v/E
fxN4u5vzn4EXllued7mzAHgJ9n++nXWyGn1sQQevoYuxyDcR35qQZd4Wsqrh
76/43xzOZvD+OLRWKKeAbxf8LAfeiz5zOxjHVnAl97Zu5W+XgO/8LMsuHUvX
e/HJ3ZxdT44bgL3akZPKkqzTUOScp9zXxPlUzquQH3dqtXc18K3w81iS6d8C
fD3+cH+qfeg64KH5xvct9zfB3zJiIoX4uAKcy4Gfjji3647uVvYxLel3fx53
4TH9DOc45bqR2HcIuN7C5/cD74Hm60muCbuBb8DmI3r4ju6uwL7d0N3V/DeO
s8fRwYbTHL8VyF5KcK/s5RqxHfwX4J/J2O4vkgH5ukC/U0fjHNvXMkiWOtaH
5INz0M8kZDmfO7ug1T3f95NYPYBP5Tp2DrIm478b0q2br3jzLW/XFrnWnAcP
R7H/j8RUKrT2Ei//Af4n6wSx1pX9p8B35visJzr6nn0SPrQFeS6Hn87AE2ud
i4ejn8PcHYE+m7m7kPxZD3/LyuyrU9HnUuAS1ZAOrjnT4W8L++HSHTxMRN7L
il1LlcPWwHsLOlrH+y3g+wK4knpxJ2e/Qd4q4O/SrR/Z82LkP1pkWZWf57Af
39e2kI6k28HFjq+OyHhHxDlFuUU16Rb4fzXTvnW36j32KIs5f14Jvvngm1Rq
X0oF30Tgu6vN20zkuwv4O+h/3dU5ZkCec7ZsLx9oUi+R6VoyDB1twn8uLvSZ
/Gso8AX9XLtasM+FwLe19ROqSapNU3Pd26hGq1bvLLQvyiffBH4iavwN8PwA
urmReFze2T3HMGgfJYandXBM38H9NVG/VTy+z/4Pee4FziWnziWeouwXdHKN
Vq0eGLWvyQeWg+8DdIIbtOYA5YJfqp3rVaNmcz6dnFQBvy9zZzFvx4LjxmCc
44BX4QM5af6v9Yz9oZ7u4dTLqScRP8fAOZ18NBl9zE+xj8nXyiC+Fl4/ht6H
0KvH3tdi7yb0tRB/Ob3GtfwQ8dUROJv7jW357L/o4jB3PuLuw+DP47yx1LU0
A5rzgKP4yxx0OZdVUOyYUmyJx1+xRVO+c518RL7yTZV7pwbWUeAz445t9QTH
4f3P5cb3IvTvAd7W5m+yydXo567yttzPnbuBs6A5M9k6HAO9X9MdG4PA/3aV
fU6+JxnOwz9m59v3T3D/Qc5vA8dX3Uwvjr9Pg4dNKe63zuPuPnAOQNZdvO+v
3IQPDES3e/lvJbbPiHi/kvtT4W9V1L2wfO7HTOtMunuElQ98P/w1wV89PL8C
/WfQ8RF85y7eZ/I2js1mdnHPfYr989mOD53nQ3sH9jic7BypXLmryrKqB1kH
/tnoY3eyc0ALtHZzPiTNMa3Yzm7Tl2S+FN4n9XVuUQ2oK7VNZJuVyFeDfKMj
7pVUk9rB2zsx+0YRd17g7mxi4Jxuro970Nd63qzuYH/+Efql3NnU0zPGG+hy
FfSPQL+Q96s5K4659+/KmxhwQ6V7UdJEyCQ2m8A/oJtzonLjcvZDujleL8t0
j6ZeTT6/ocQxJNriYQnw9zHbQ/b6AXhEtmkpZv4OrpMx31VOOAX8vzL3Bs34
zAngiphnEdEczdtHE+ZFMs8BfixhfGeznwV8HTJW9rSOW30z4TPJODjTOVK5
Ujnn2mz3ZOrNVOOuQvaimHOFerbVvN2eZ/3Lp+XbH/DfVcg+ifO9CffU6q1V
885Fab8vdK5UzrwIuK6va6/y+3PcHUMOSe7oHmg0cFO5c736nxHwcgc0CtLc
w/wr3TaSrTQDxNHHPem2vfLjGPR7vNDxKB/bU+UeV72uetLPK1xjFG+aCTTr
zcozf+JpDbLWt/WbuHOYDPx5zLGhnJUEPxXF9j3poBx4XsK5VzaQLRbg89uQ
NQLNhTXu+dX738udbxL2IfnSYPbL2D9b5bvKqSuBP2uj9zTnv8BfacS5QDac
gT02x1zLVYNVi0dlG5d8Qr6xudqzrGbGLcDP5nkeUr5dkeear9r/GucvwciX
Oe5NysgH/+D+AXgYnmb5a+K2gWzRFf0txjY9aj1LqGcfw9uxMc+OOaxxwJ9l
Ove05iBscX4/10bppJmzp/Icr8o5R7HdkZhrn3gUr59Af1iaZ45S6N8bNT71
U/dxf1WeY0f4lev+FDFv6pk1C6imSFbhu523g1jTk9zjqdery/Xs+T356fFa
z9iatS8k579KvtmZYVgz13fkl/3wc3mae9oK+NlY4l5pPfK/Atw37tlId3Q3
HvdsJBkkS2VbvMrmfeD/enz8b/QH89BJAbqpjbtXls6l+8a2+qSeJIX70Rrn
6h74ZC7w+Jh1rZlTs+dk2SzNPYd6j8ZK20v5tQl4XMLfPsTTSPTTp8yzi3J2
UZl1IF2MBsd4dPNWhmd3faOo5G1arWezLazrsHdNgXu5WdCrBu6Xbtk0szfC
/9I+vquZRbPLGSXuJTWTpQIvYT2cYh1IF73x37xunvEnQ29Hwrg0I21POEcN
a4tXzfLyUfmqZlTNqm8n7H+6vwv4poR9VzNnA3DvYvcCygnKDZqRNCtpxtOs
p28Yrd8yyFk/kB8G1ngWnAGPvwMegb57JTsHKhfur7Ds6rkPVLgm6/1G7k9F
dyXoYCP+dRlMtKDPRzJdK1VTe0F/c6F7ydYcjy8Xc/+Vnq5Jh7i/Lde9jL6p
tOdsT8K5VTgfhZ+sKn+r0DcofYuSD8mXlENvKHAPpV6qkdW7n3sI5Y/+qgGV
zinKLeqpxuE/i6pdWxQjTwJfnWPf1jegN5BvbK7fqr9RbyWcwq2avqjEM6F6
UfWka8H3YI17P9Ug1aLF6a5/qj874P3lIuce9TDqZRTTim3NBJoN5ubbfsrB
mv33xXyuHDAN/JFyx7dyZA5wlPiZkWofki+pJxY/ytEfcP9QiW2jmUSzyYa4
e0vV/JXI01zofKKanB3xN0l9m1RM3YouKhL+lqBvWu3BP4HzbWf5m9DWas9k
ms30Xx3wnJi/BSk+e0bdg6gXkQ9VIV9DoWczzcRXRt3DqZdTDT2W4Zle99Vj
NCYcs4pdzcwxzg6h34b2/mZzWN96ovYvfXPKAffhKseyvnG8B70FEc+GffDX
behrYcSwvjnq2+NDVe49NXPq245qqGqpaq5q77SYv8VqZhiU7m9wynf6xlma
6W86yl+yQYL9kyWOHcX44hLHgGJBPi5fnwKPaV3c06q3XZ3j2UwzwEXo7/G2
fkT9ub6FzSxz7pPMs4C/TriWts787KfVevYTzvuA03q7FxOOM4H/D1enULw=

                "]], 
               PolygonBox[{{9752, 2533, 7593, 8981, 8982}, {8982, 8981, 10643,
                 3127, 10645}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmnmUVdWVxk8xFYXMBTW9modXI/Wq4FW9EnGpSYxZEWVplEkZRYI0sxFb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                "]], PolygonBox[CompressedData["
1:eJwtmHl01cUVx6cEDGGRLCSYfeUlIcsLyQuBgMcN9bSiVAU8rZCwiUhNQFCo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                "]], PolygonBox[CompressedData["
1:eJwlkDEvRFEQRs/bxCa7FIptXkLkLd6i0ajQyEpUK+InrJ5SoqCgICpUdDoK
Ev+B2KWl4x9oiI6IM7nFyUy+mflm7i26W+ubFWBYBqQ3Do9ymcNSw3wOTgs4
kZUSfmvwMAprM3AzBHf2ZRNQkXv1H+vLZeqPudUmdCSbgsVBOBqDp0mxr298
s/Yu6Len31me9scdF9Mwr3Zu3NfrQI6tb6t9q32af+VJj/qt+z/0LcrkGd79
Wdjwcc/GQ3cveMNfK90Ut8V8+Fw7067DlbE64l/Iq3lX7aVM74t31pzdVasb
kR3zrJX6Y+4fkXI0NQ==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFWXl01NUVfhCWLMOSPZNkMoTJTDIkkwmZycxkcTm1smlRqyKCAgpWT2Wx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                "]], PolygonBox[CompressedData["
1:eJwtmGlw1dUZxg+b2VjCGsLNTcxOSG5uLkluWLUzLVVRsCrKpgRZClORUKdK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                "]], 
               PolygonBox[{{11290, 3554, 11289, 8773, 8774}, {6554, 3207, 
                10761, 6649, 6650}, {9932, 9931, 8636, 1215, 7738}, {8784, 
                8783, 11291, 3554, 6799}, {8774, 8773, 7374, 2373, 9373}, {
                6800, 5377, 13710, 8783, 8784}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1mHtw1NUVx6+8hPBOCLC7ySYh2UAgMbubzQZsS7Wj8kYFW14iWuvAjA8q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                "]], PolygonBox[CompressedData["
1:eJwtl3mMleUVxo/sA9MBGUDuzNw7+9wZhvHeuTPMQDEWGyvD2qJtFYWqXUIT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                "]], PolygonBox[CompressedData["
1:eJwtkc0rhGEUxU+KjCZGFkZvXgbjYzRG8yoNltQslLLykcTGrMhuFoqxUiyI
mg02rEWxHB8Rq6lZsWWh7M0f4Hd7LE73vuc5z3nuPW9sdWN2vUZSFNSCuh4q
CBLSeVgaofq+lG2Qbnql/W7pAKQGpSFQSkrfjdKrJxX43gEncGW4W7h7tCUw
gccyHhU8vuA/wRF9Gu6QOt0mZXivOCC1oo+Car/0CxYDqblFmuqUJkGEfi5w
Z6aZwXsTnyo+zzHpBVyyQzYkXVBTfA+DO96sMFcx6ea0eT+6pHeQj0tX6Nfa
pRy4pt+KuzPT2H3zeeDuDx5P1DfP9Y9Jl4VlUmCWU2YZ7ZPqeTsEwvTbcCu+
y9YyLjPrEtyY7/KxnExrdzLozzjb9V0OlkeOXGLkM05OC/95zFPTzBB4bmfb
vYP/dYzOTzjezpvYY499ItQ/ekdGkA==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmHts1tUZxw+IUCgWWij2+r6lhd4o68vbllZdmAStmoEM5i5eBoNlug2B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                "]], PolygonBox[CompressedData["
1:eJwtl31s1eUVxx9awJaOtryu7eXe29L3UtZr33UTISpKVoZUNnVOWUx0Lwq4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                "]], PolygonBox[CompressedData["
1:eJwtkMsug1EUhb8QCWpAXZJqNRpK/5BU0vIIZiY1dUkrOmQkIo050dDwGi4P
0QSPwEiCmaGp23dyDNZZJ2vvvfY6p9DYr+31AGnRJ0oZjzG4qEKmCJPitwSf
KfiRv8S3OJuChwHoWt8tQFMceb9Ta8m1LKxnox7q92qP1trOvc/Am9jOw/Eg
9M/HPWEfSdw1Yo5e9Zb1rXzsD3P1ivFGYUde0GtRHCzBxzAcyuM5mMjFjCHr
6nTsb1Rib5jZ9J5W25BfzfjiB3Tm4FJcidsyrOlXt3fZPCtJ9AzeRTO1zTQr
n5rnRDxZbw7BcxLfHN5+8+9xXY7zwee8Gv+2I/8BGcM10w==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1l32Q1VUZx49vvOzysiywy13Ye+++cne57F3uLuwOlWJaUzGxy0tMKdDk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                "]], PolygonBox[CompressedData["
1:eJwtl3lwleUVxg+ggbCGQEyzL/cmuQmBXJKQMLZjbbWdjkxJoJbOINCp02qh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                "]], PolygonBox[CompressedData["
1:eJwlkL0uBGEUhp9IMHYIDcnsCsbPDhtXoNmKZElI9hIk6ChcARKluxAdxVYk
LIVbMEh2wxVQbiWeL1/x5kzec96f+fL9k/bxEDAlhsXpHFxVoCjgLYdS3Ndh
V67u7nkJXsTYLCTi292Ruy/nRgYL43CwBh+L8Cm21+FvAlrO3gr0RboMFTFt
xoXaGeelnreJOrVn+pxnUR98mnKT+jbkUjNL7xI1I2JU9M0+1KfnfLTvUx5z
Qt71POykUF2NvUP/wv/Y8/7B+3YD7vTuZLFT6BayQ4euux93v1l8h/AeW3I3
cpvOd/WlGNTgNXT3+x9JUDU1
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFl3+Q1WUVxl9C2JaF/Zm77g+4u3svd+8uy97de4GLaKFb5iQQYiC1CDT5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                "]], PolygonBox[CompressedData["
1:eJwtln2Q1WUVx4+6u+wuuMCiu+zu3d179/72xeW6L/e63CITIStfQKQJVFao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                "]], 
               PolygonBox[{{9688, 2513, 9691, 7027, 7028}, {7524, 2475, 9584, 
                8523, 8524}, {9185, 9184, 10765, 3209, 10766}, {7742, 2659, 
                9945, 9145, 9146}, {7178, 756, 9952, 9954, 9955}, {10763, 
                10762, 9144, 178, 6555}, {8524, 8523, 9587, 2476, 7525}, {
                7028, 7027, 9672, 2505, 9671}, {9409, 2397, 9408, 8753, 
                8754}, {10049, 10048, 9233, 2281, 10050}, {11611, 3757, 11610,
                 8740, 8741}, {8741, 8740, 6814, 3583, 11341}, {8754, 8753, 
                9345, 2357, 9346}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtln1s1eUVxw9vRWgpUGgp7aUv997evl1uy7221akDi9uClggom8qWvQDO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                "]], PolygonBox[CompressedData["
1:eJwtllls1VUQxqctFLpQaEtbWi5d7r2lC5e23EspWwIWowEhQAHZoyKghi1E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                "]], PolygonBox[CompressedData["
1:eJwtkcEuQ2EQhY/StL1XtGiiRTVttXWrcRtdtImdeAI8AWki0WKrLCW6UC9A
gibewM6WFxALbHgAwo6l789/Fyfz5585c87M5Lb21/dCkqZBGEQ9KQJWMlI1
IR350llRuqXoYEbq8z4HXloaG6WO2qu8dA1Cy9IQiID0BNys1ITTACk4/Zg0
VbS1huPC/XWlJL0eC9ID+ClJHUf6Jn5Q8w56cO7gtvF0abyhe0HMkcuD5Lw0
CdbK0gBub07q+tb/sW/1jY8U+RPyLfJx6hPglPcNf6tl28P0GlT5Ax7cr7i0
SNxEZwMMM1uK2cLEpyXpnvwzMUH/cdDBVwF/beJujgi2a8yCl1bNzmhmXaDn
J9y/WatlNJ1gH7HgBuYWxqPx2qiwN/o2K1bH6JWDHiXf7sHso8//YVTKoNHN
Wq8jwV3Mfd7Y5St4CW66gz+3zizUOXU7o5n1H/xHQ6I=
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtV2lslFUUvZaCXWgLXel0un2dlnaYdqZMWyqaoKIxuCAgAUxAsSyyulEs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                "]], PolygonBox[CompressedData["
1:eJwtlllslWUQhocClRbaAl2AQ9fTAz3A6YKnLWowblGDEoKogAlxAxTUuAEB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                "]], PolygonBox[CompressedData["
1:eJwtkLkvRHEYRY8JsQ8REcuMxB5GSEYyURi9hkRBr1DZlxEqNRLxF2gwjWlV
YomWSSjQaWxRilY4L2+Kk3vz3rfc79c2szi5EAEapEQizVAk0R7YroBqdaUF
lmWvC87KYV9NxeFA36pfbIcleeuGV6kbgsc6qFfnrWsuhpz/d6zdlWlnTcm6
PueMNTVT8LPWn1ibldEmSMt8L1yWwq0+OggvNVCrljqjTH77YS4Kf+pdJ+Q7
wzxBroi9P5XepD64I++O+67wnuCuDXsy8hUL59Y4t9r+zzIY7jOLO7OS0h9W
wbH+vQM+5GoATu05t/cpAc+JcHeQ4VtW3dUYD78H/6+tz1l/o6bNMyK9zjMG
R2bdMkfMOzYLmYJs40kY8y0nkuFbBG8S3BzcflnYf6H+A9RGRWw=
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtV1lslFUY/Upl6crS0mWmHdrpzHRaphuddlADL4JiJahEJURFJGLYFMQW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                "]], PolygonBox[CompressedData["
1:eJwtlm1M1XUUxw9cxS7gRQG5cPGiXC54Qy4oz9nW1rKl1Kz5xjnTmmVTYD1i
WdhyutrIZakvslYuW7b5ojeJvepB0x5mam0l4uOcDhVRUCNhY2Cf78598dvO
//7O75zv+f6+5/xu6eqXlr6YbmYfsyaxJprMngqbLZ9iVltvdilmtu4+s+nZ
ZnOLzBZVmf0xw+xYjtmtarMe/I/lmkUKzVY1m/07l++pZmfSzN6NmL0XcbuO
GP+x1z3b7ECW2Xy+lxJ7CTEXkHcLv61MmPWXmfWytznT7LkSswQ+lwJm64Nm
d+Nm9+rMduaZHSf/xZlmo/x2OeA+kSh5ys124bucGF9xdhz/gil+xqinGozf
UN95/F9uMGssNluIb+U0szdqzA5SUzf4RcqP2F8nzU6HzIbIN0a+A+D/DqxH
WYfAu/B+50Yc9ZFvFz4V5B8k55VSaoav5zm/hjWC/Tj1bRWf1NdeQa3wVxV2
Dk9ht1HzBFimEP+XOWbZ5Otlby3+V/DPoJ7juY5hH/mvwe8LxM7mzGLwr2z2
u5CPfJvh49N05+MB7IOceRJsqzLMfsIuijp34nAYLjfFnRvFHAVvKz5d5KoF
4znwdZGvB34OwscF+AnVOFfF+OfUuGaknUPwXY/9GfEWwscQ+efPdM7EnTQg
LbzGHfTn8xsaOUK81Zw5k+cciIu6eo8VLYAvvn+Y7fcpTBPUdwf8e/C9Qf6j
3NXemNcqDTzCXif+X+D7JWsHuTfy3UK8NGo4W2mWFXMupFlp93yT16oc0s5I
3LUnjsrwXV/vd9M62awD+2rE71Z3PAxfY8T/m/0u7quU+yuodN9faa4Z2OP4
XAy4BiawuzkfSPffCoi/P/UtPt9mfz38XM93TR6Gn3OVjv0f5DwZ347Uvvh7
k/rD85wP8R0Fex/+Qfz78A+pF4nZAb566juN/UmD95Lq3YV9Ao0cD3pPHqM3
N/PbaL5r9CTctJQ5VmFcjP0K+8Fc7yn11t2U3jUjNCu2w/meLOdc3F9L9bf0
/DD32QbeFuzf4Ocxvo/MMnsa/xA+RfCxNuHa3ACmddjPNnps5XgGe5iaNoRc
D9JqYZXXvpszYezvIx5L/ZtEn/viPo9U0xawb4w4d+JQXAuTsKnnwtz/spjP
ribibwTbYTjuD7n+j6LnE7OdS/V8HnrYX+H1tLEGsBvR4FjAZ8wsuL1R4XtB
4s0gXl6N37V6aDp2XcLrX0O8EeIPgfdCwHsyn1g3Od/O+UXcaS3Yb853/tVD
r4L/TszvTnf4J/lK4s6HNKFeuT7PuZEmBrDH4s6tOBSXo3O8VtVcwmzsTLr2
xI+09mGZ74nDD8q8BtUiTINge6vK65E+viXevVqf9SvosTS4Wlbs8+gAObeC
LxOfIGsBeR9kTWPlsG4R+zarr9RnqWaIZklz1Ge1+Oyg1kdLvLfE+Vrq2Znw
XlcPqhd3o+Ft2b6vu+mrSN0v568Sv5X461jbibuDNZUcf8FfE5zWgn1Fwt8m
cToA3t+TPmvEp3qtN+53pXl+mfOnU9+6Q2lZM0uzSz3wUcLfEGlRmiyMuSb1
rTdmb9LvVHerN3icfqsHw91JjqcBO3eOv43Cnz3TZ75mv2aQZlFXuXMrjpdQ
1+vlPg/13YFdjkbPpvkbUIE9jZzbMrzHcrBvxX02qcfD1BMtd66l4Yao16ha
5fME/LXUeG5ptCDqnAmrMIeI9U7StS0NbUr6m6fz4ugU+3HW8gzHFMNubPLz
uoMG7HDMuRKf6o3Bav/voRmwqtF7UL2oNym9yt8kfatHf076fwTNN50ZqvYe
Ui9lkmOI3onB5/uZ/kborWgt8dmtN0hv0ckG165mZg92TsRnqTD3w29nan6o
BweJ93nEcynnbfK1p95PcfwQ8TtmeW75q3f/BysdeSQ=
                "]], PolygonBox[CompressedData["
1:eJwtkk1IlFEUhh9NRccZx6Igfya0Px2dcaBxMGpbOze5aFWgtiqoNhluapG0
aGet3NlObRfUTlwFqZBEkaX9SwllkC6ShKyey3XxcL57zznffc97b+vg1b4r
5UCLVMq9DNyVF0fgYjV8OQjdJm/XwkA71LVCWjJN0CxbbdBj7rdx1L5nNbAQ
eq25JH1yRi6be2zujrmT1p6Qj+5vVsDIAVhphN598L4Ey0fhrWwehiF7fhn/
mN+WbvvH3Csab6jtpiSL8HKP2opRU9C22AXTaXhlzHpOh3zNwbk6ZzJ+lhWp
lAp5kodv5mbtnZcffs/lYy7U3JdxmXBvydy0Nf864a+83jnraTM8aoCHSTjb
ATXqTcjGIViXC855KwF7nf2n6+f6nfI7LfVtUU/QlWiJ86Scp8z1Ygp25eJZ
4cyqrJpkuOBc9XA8E70JHvW3x7saNPa4nzU/VIj1oS/4FXy7Voi564XodfB8
dcefT/5nxvmW/Z7Kx7nD/PvV80ZdSfV9d72Wi74Gfyfzsf6B8bTn7NaDU9l4
9+ENhNrQ864U7/lDKb6j8J7Oq3VEzcf873+coGoU
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtlmtw1dUVxTeRkIZHEgya5N7cmCe5hHuTcJNwY2Ha4oPBx4hNpx8cpzqj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                "]], PolygonBox[CompressedData["
1:eJwtlllslGUUhk+n0NJl2qYDFGam2zAwU2npQFeoCwYwFbmQKlcoF3CF4hpF
LiRRSDRqMIoJgQKakGBCqxFBQzCixkKrvdAq+yqy1hSxoiAqi8/r+S++5Jz/
O8t71u+vXvxUx5MhM+vkjOC015sVlJg15pntjpt9ETPrR2BLrllXndmbE8y2
jzKbx/1+7rMzLtuOTAj60kSzIc6VhNkfnDHlbm9wtNnTTWa/oX8M/VfzzSpS
ZmFsPl9klhMxm9+AXtT5MmRS6A9G3bZ8XK8121RlFi8zi3G+bgHDZLOdYfch
7EPoZAgkUWj2WI3ZCfRnoN+BzePor+B8lm1WDr8SugV8N+Db8bcc/UNTPNYN
fOsjvveqnVcONkN/cofZK9j/EX4H9IqE618tIH/4e594erJd/nNy10nM+WPM
hrPM/sH+ETBPAXsRNg9C7wnyK5355GZT1GVvENMc8N2u9/hvwhv53RjYEz8M
1g3weYH93+ELyeEq5BcSXxh6BrXozPPidqsm2F/I/XK+lYK1kXy+luP5Xpw2
G4+/c8Vmr8PfD569YCwH78qR1KPS7AD8ZPg2bHQlqQP4X4YOE08H9q8n3fZy
/Bdj/0DG7xfAH4Tu5FtvyO1vhE4n3Ldqrl5QTVVb+dwMtk3k+IURrtMJ/esk
sySxLgPPZeidUa+lMAv7MP6fzXP5XTE/omVjHvGEyNEScj2Sk6G+9XGnVdMs
7nrAsBF+CJu90NvJyRry8yDxfQz9HZi2RryfDlOf9XG3p2+RRrMfMh6rem4A
ejb9mU9vPAHeWdB70F8b8frORr+tyu3r2y3qdb7WazcT/dNR9yFfD3GOQp+M
eu6bwHMK/lit38lfO/gawHCaWL7CXiP0qibvNc3raugavu3m7g0w3Y3vhmnM
HNhaS7EJ3UYOQyXeQw30ewE2f6J93mVeC6FfSvosat40240TfXbUX7Pg/w7q
r3luxX52jc+GZuQ5an1pktduLypD0Ieod12Zz8Rh6GPkbFEQ/9GM50i5Uo+v
B/+4Br/vwV8Z9G0w95Z6j6kXb8HvK/Wa/DvNMQiL+quIem4O5kszpFm6Ue+z
JF6zGqv3ftKOiEJvTXhsmqHpxPpplff6zXHswlZ6Gp05Y7zmJ8E6ttJrPUhN
O6aCu877WzOWW+cykhXmrCqfccWnHihJeA1VS9k8hO0H0l5rxTcX+kjQD4rR
0H+myXerduBl/PXHfDepn/vrfKcqftUkSn1ml3s8qlnLRI9BsTTjYxv278Jm
XsR7RL2yJOWzH+N8VGG2tMZ3q3bsOfB2o7OrwHusm9q3pbxX1DP55PparedX
O+xP6CLk7ytwmdXYm8lM/JLjM3Iv9Nvc9+d4D7+V9jdEb8n3YB3gPMK3hWl/
Y/TWaEY1q4r5G2I/kvRZ/5L6/cVsxqnhhWLfD8Pwcyf47tGOKCv3HSReMuXI
/hz13tMMXtS8ZbzX1HOnoM8G86kZCaN/Ne6+5HM/vssSzmufj0u4T/lWT72I
7pnA/v/2qN1ZZM5wJo83q+X0pbx3Hiffoys9p8qtdq52bxh7hZyLzM4g59ug
3spBbjNvatJrr502FbmBlNvSm9mD/qOtXmvN3CLo6mB+NZ/TiSdCDk4Xe//r
rVzN/SrOw/hZwNkX97dRb+I6fGXVOq+dGYJuxse6sb5TtFtOsLNDYa/pcehY
tduWj1J8HUx6rpSza9hunua7SPr3gD3CKU15zIq9pM7fFvWoerWbnHXluo+R
5HZ90rEIUy/yH6Z9d+vN+wB6aYX/e+gf5MoE/wcRL8xNYF+W9t2oedRuXovM
jlG+Dyu0X1p8t+oNutni/0DarZqBLnTPV3vutX8uQG9L+r3+mdZga12lxyaf
ucjfGcyLZmJDpe9c+ZLPd5DvC/pbMeWR3/8AJ7NxAA==
                "]], PolygonBox[CompressedData["
1:eJwtkD0vg2EUhq/4FrShXVoqWvGVtqk0Io2YJIwGUQuTzULChMG3xESMfoGY
hMUihv4ABgwmIaKLjd315u1w5Zznuc/95NxPenltbrUOiEujPA3Ao5ylYLQB
fjMQHYaZNohYj3rhuEbQjxWh1AXj1h99J01Q7INFZ5fk0Lu7ZphNw779gXx3
w00LnPdD2fcXZCsP9xHYtOY852UyAZl2WBmBD8+fUh3UL1W9Ffeb6g1nA892
Em474DkLMb1/7lyvd11to0bQp4J8rdBjLbvLvJTsL7ybsL7qf5Ht2k6X6lfy
YL+bD7VgJmmmhOzkQ23P2lWA9yh0FkItmIn2wJt540PqEhsKMwfZT81xrfbl
+zl3zsr0SPhnFft/8ZE8RQ==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtVmlslFUUvd0oUDqFTqlMW6btMNOWYYYprcyAVC1IjZaobGKCLEbQpDEu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                "]], PolygonBox[CompressedData["
1:eJwtllls1FUUxk9LobSl01IoSmeGTkvLlDKFdqAthIoUl0SIAVk0QVkCxQRw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                "]], PolygonBox[CompressedData["
1:eJwtkT1LAlAUhl+M0JLya6pUtDLUPhQiIzAo6WMs2nIJ2iwo0qFNG1qihqgI
mvoBUUN/obGyqSWotlD6WGzLoedyHR7O4dz3vPfcc6Pr2ytbDkk90A7TfVIW
ojHppEOKEJNDUgIavdJut+QblR5C0qGXhrS0MCItwmZC2oAsZsMc1folF9oS
PU5iA69fqNLr6JSW8CwPShXwJiUPvOI35ZPeiXU8a/BCnqF2HZaWo/TBPj63
zFcI2X7j04buiJkeqZVjdoY7ZqmQ78EZmhl6zok71IuQZ8ZVcMelebfURczh
Pwtz+Fygz7TmNvOPR7gb3Rq6EhyTF+N2P2ZPxtN4X9JfdUof5Ddh+6a3tH1P
vbUvs7dmSjpg5nvuqtNfYC859N8D0g802dsfpIKS38ODxqSJmJ1rMmb/yvxZ
G/UA5+mg1Zu+Z86f0J3i/ckbvyDA/+Rd0hW5j9wP/1G3S5s=
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFVntM1WUYfhUQVLwAggLiOQdPCMcDHM6RixWstTW3SmVq/VFNW1ktsVqp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                "]], PolygonBox[CompressedData["
1:eJwtlltsVFUUhhe0hUIHKIUWqLSdaacwLdMWZmyniWAiCSFBgQIGH0zAqMCD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                "]], PolygonBox[CompressedData["
1:eJwtkE8rhFEUxp8Y+TekMNN4KaN3hhE1mZWimG9g8gkUmxELoZiZUhTK+wWG
vbEgNowFO1bDgmm2koUlRUkpv9t9F7/Ouec8z73n3OjccmapTlIIGsCNSR6F
cUeKkcchNyrdtEsFYj31AOwMS9tQcmwvT2+P82NQ2vV7RuNFpAO4iEq1RumL
fAHmYd/Xv5CfDknlVumMONMvZSDvSqlm6apX6sLfDc/M8wRVyDZJq47VGs8K
3g/0I3Gp2Ic3IH0PUEP7CQ/4KxAZZLYWqYc4leCM7gTdNHkajvy736kVyQ/h
lVkWufvNtfuYvdbpr0Ebnh9mDybs35g/yvmzbxJLaI6hk/4vujDeLMyy+y21
OzT3rt3P7HnJvmN4N6h5SemvgzeJE/zXJFxzVxkKzHWObov4DxbXRdM=
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1lmlslFUUhq/QQlu2Umih0DLTdqYMMO10FqasCWAiiZVFiGIMMYqIEAWN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                "]], PolygonBox[CompressedData["
1:eJwtlmlslVUQhkewFFoopZe2dKO3hZb2crtdbstaFAiSiKDBGP1hDCqgAUFF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                "]], PolygonBox[CompressedData["
1:eJwtkssrRGEYxp+UuxAi4zIuZxrEYEi5xJSlQuw0JMm1yGXcFxbutmIhJSRr
E7mHf8DSiiIblB078juds/j1vuf7zvs873lmsruGW4ZCJGVCKFQVSJXwkSvd
83yUKvnTpZo4qcwj/RZJf7Dnkg4ZDKRJ+/QHsAQdEdJljjSQIQ1CO70fkg00
uTPQmqafgmC+1BDDPR7PedJTNFD3nGjCHfe3MOmVOhOkM86uoI9+mbMFWAQX
mp9opxiWl+kZhGPwMR+PRz311CGdwJLX0lihvrLjC8zQd3E2Z2ua2uvQz9k1
nnl8Gza6YNd8+gJYs+9XvZaGqeUpl24SpRJqFDlF23mZuZWSXzU5tiF07rT8
Zr3WN5rf6kFzM1IqolaRazV047cVzn52ZmZ2o9nSCGzj98j7Xy7rXXPGoN/g
zE2dIMsAtGZJu2FSEn0dc7VQbHv50Ggq47dn50bqGHuMw0Kh5IyV5gutzMzs
PsjzHXaYvWB2jNkf+m9otjUq8HpA/42dHW6phz9WL/wDRkVeQA==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtl3tw1NUVx08FgoAJ5IUSAtmEjXltNpvdzcMkSEU7rVrA6YwjtOqA8uiA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                "]], PolygonBox[CompressedData["
1:eJwtlmlsFWQWhs9QWlQsl65gvfTeW2+xlkt7e28XoKCI/lARNf6RUTSi4GRG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                "]], PolygonBox[CompressedData["
1:eJwtkE1LAlEUhl9EpxkTRAQ/cIaYhhGbEf0Fpq5EihZtIhg30brAj1rYNoNa
uy+hbRu3/pPEXf6OHplZPJxzz3nPee+97t3j9UNKUgEyYLjS9lj6bUhlqMCf
zTlPry0tAukNjBp6COjfoG8SZ2eSn5OmxDF7JjBCE8HCl9aW9Eq8gsiUfk6l
C/JLeEbzBCvyDbpvooXfFl+zHXsdPOv4+HBflW65r0c+dSQ7zRz7Ppn7Ag8G
eLxQ69A/hw/yd2jQW+IREvvUe9BK9HP665P4TSG7S7yhDF0nngnQdTn33Pgf
Dv+RTe65559M6kewY3bIjiLxH+PbKw8=
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtl39s1WcVxk+BthRoS28pSkt7721vey9t1977vbfQUdrSUkgYoxB12czG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                "]], PolygonBox[CompressedData["
1:eJwtlnts1eUZx59CS6lQLi3MrZRzTvF0p7Rn9PR3elrsTa4mIKNkZhsGnZuJ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                "]], PolygonBox[CompressedData["
1:eJwtkD0vg2EUhq+0FaSJRCQ+o9JWGw3DK+w1q1YiVGfCiIH4+AEiwWQj4Scg
PhaLicmkfoCFxR8w+LjevO9w5T7Puc9znnOe7NL63FoC6JIWqUxAykNVLffB
lDxloNapOQ4/AfwGUT70t0rw2AovxmMFGJXyIPwl4TgHwyOwkIZ8qEWox4Tx
vrlTvQN1z9pdyXv/pB1yarc9v/U7SpEX1lzJpdT0L6yr+Na88ZlLNAbsa1wv
RDOGsyadedbZn92hGt+ZUQ/tcSSvvj2dgmW1KW/yqd+07kPdtueOBNZm2txR
/2YIbmXVeEU2Jq31zxJZ6JUeKcZ7X1vX8Lwom876YN9z+9672528m//y/9L9
8A/aOzk2
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtl21sluUVx48UKLV9oC+WSil92vKUPn2h9H5aWp0UymsERgDH0IiTjETi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                "]], PolygonBox[CompressedData["
1:eJw1lmmMleUVx890GGZgFuaOCPHKzMvAHe4scLnvnWGGVodVjCzKUlP3MZJo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                "]], PolygonBox[CompressedData["
1:eJwtkD0vg2EUhq8QCfEZVULbRJtqaYREKiFMgkH7GkR8jV1J/QFhYLap2WaR
lJ9BhBETFmOF2F1v3g5Xzp3znOc893OnK4cb1RZgQNokmIBYF5StO2nYlT51
rwwOQ7czJxm4S8GtvIzDWye8Wh/kSX1vLeZgVlaK9mOwXIzmw3vJPCTkp+Bu
F8ZGoC5DcbiehSn3T8tewvdlcwyuOmDbGqQivaWuO3MrZXslCeyV2uHcXjUJ
i63wq/8gC+sy4/mld5ecPXXmTOK+26+Hv0LkKfT2PQqPel7T85zMNwn1avM/
DWfe3bdgHo/m8qH+lJq7L+RLfaCXRibKIczjyFxq5nNszftuTp71VdHTUzb6
c/j3/Umz7oEbz/8BWiw6dg==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtl31s1eUVxx8phQK2pQU6Vkpvb2npbW/ffn0BjIE6GQUJOCgwU5TFIZuw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                "]], PolygonBox[CompressedData["
1:eJwtllls1FUUxi/LtBSEMgUq1kpb7NChw9T5l9LKA4sgQowaKBAEVFBRgcTS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                "]], PolygonBox[CompressedData["
1:eJwtkTsvBFEYhl/XJRIKybCsuDObMNiIhih24xoTCWtZ65LoKHZ2iYRKjZ5C
4w9oVKO2rWrpJX6AjpLn5Ezx5Dtnvst55pz+o2CjWCupAxrg1pUeWqRyn1QY
kfZgaliahBSsNEnz3dJ7j1SFm6j+mjgKOdZJ1+ZMze+MlHekH+LsgDQHpYQU
QHZIcpqlLeLpuPTRzpnT7CEHO5y3DT5z6uqlkN579iE9d8RdPArgJK3XFfnO
uBSHdfKP1G0S09RkoEhdijnf1AWsS3DI/x3Ac691d13raFwXPGmtTVryrI/x
ykI5Ri++E5zjgc+cF75VWGeoTcMq+PRe8p+xQakRPnGp4vRl7jHKL3v2Lsyd
7ONRw2M8dUnHY9IJXCSsw2I018yv4PiG6yvxj1mK3sm81xleYat0TvwHcYk/
5A==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtl3uMVdUVxjctL9ErDiApt1NmBoYZ4My9c888OpIUCKIMIJUIirxFUBAI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                "]], PolygonBox[CompressedData["
1:eJwtl2dslWUUxw8ChaIFWysfLrUtUO14e6+9HRY/QFWUggNkORBRoQqKpZah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                "]], PolygonBox[CompressedData["
1:eJwtkTsvg3EUxh8S1DURIqFuLVW3DuIdGBTpB6A1YOhSk4S2BotFi8ZlcVk6
ShgltSmtQcRktLL4AEwWLeL35v8Ov5x/3nPO85xzXk8sEYlXSuqAKugekqIu
6dYruXl3wuKAVF0nbQakC7d0CRu8801SkrgG6xD2SfMwB8eIhjxSelDK1kur
vdIEOpPwOSx9wBs9JTS+0Uvjl4I2/MrUtxJLfP8l/x4w9XbfksU8sGwZ/3Nq
rhk+B1G0a5gzPmrmsef6wvelRYpQH3TmCtIzzXsGEl3UQ9Zn9s4zQ478I9pH
9CfQSkLBL93B4Yi01ciO+J3QQ0pP7dIp7zM4cPL7xD3IQBH9AqScW2wTd9F+
wGOHOI6n5TU+tl/GyV0xR9gy8y9YRsPWyjjaUz3STTO3G5NW6InBLHXP1IeI
P2iWIc4t+xv4Z8QiO/xxo3tnH3uvCu72Wssi9v36JBf8A41cVZs=
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1V2lwVeUZflm0EAxXkBC9ueGGJASSc8+BA9xLnE4DhCVpqYXEQSVWMCEI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                "]], PolygonBox[CompressedData["
1:eJwtl39012UVx+8YKYNgziA622Q/GAz23fcDUzbESmCAQGayeVCBym3IbxxQ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                "]], PolygonBox[CompressedData["
1:eJwtkMEqhGEUhh+iZkxRLMRvaGgmMmYhFAvGxrCwscGGQXYMNaw1wwUoKUpc
gPRb0CgWLoA7cAXuQXn+/lk8vd93zvnOec+X2T1aq7QCPdIu6TH4S8GAupyB
Ffkehi+5zEIjCVfqZg42ZF3ebXBt3UEeejuhopaN78ivtccJ6BiBmzTcSt7a
cXmagB/rQ/XD+GobnI1CTepSMnbnvKI9as6vy5K+AusankuRR3n1/CKDTe9B
H2zbM7T3lprQR1LKBX13mSvE8yMfkcfI6+mk8W77DsGc91nZ8+2zPfbVk2a+
qjac8yYzzvx098cAzq25kAc930tLLt475d5F8wsyn433WVSnfTslYX/8Z4f+
2T+uYjZ3
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtV3tMlmUUP4iC5AVhIAIfIvhxkY/v1Q/70NDyBiVuLa9p4Q3NwkEWiFCC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                "]], PolygonBox[CompressedData["
1:eJwtlntM1mUUx08CKmoiTTTkVXzh9ZIv70+xJJdLEdHUreWNTNIZppmJiIqY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                "]], PolygonBox[CompressedData["
1:eJwtkMsuQ2EUhRchVYSkiUpPT6MVtyZqINHUTA1QiYmJ+yUe4HiCCjPiUkFH
BA/g0jYhihiQEBMz7yBiKDH1/fk7+LL2yd7/WWvv2MrqpFctKQi1sBOTtuEx
Iv36pWSXNNshOdRzaDAstcJMnzQNWVeaaqZHfTXAXItUQHd7pT0YbJdSUHZs
75rea4/00SC9o2f4nMNRv+QFpEM0B/tQjksTjdIdekymE1g0vvitudbf5DB5
TK6FSm8eveT7ApJ4R+ukzYQ03imdskcGHaKXBh/7FTlAjnqJmWVIhKQAvmP4
3vD+Fl7gGUbitpdBXebCEKEu+aSHkN3Z7J6v7PPUJtXj4YefqN37jb1LZPDI
9cc/C9RFOOBdd5N079ibmdttkGsdvul/kv0LHYY0jHK3qhppi7l/Q25B2A==

                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtVEtIVVEUXeorM80fmpovw/fRZ+ozRcWSiLJBOMvU1EqyAoPyk5qan1l+
+mAmUhAWSoMyKC1SiqgQoqIoMho0MQiCBg2bNWot9hlczr3n7rP32muts7NP
dNS0RwIY5hPF52iY79xIywT6twDvI4Ah7q1tBzybgMUdgL8MmEkBglwfZABf
eW6kGNgXBKo3AHt59qUP2Mr9Ru4tbwMaYoFwCOhkrtYEoIfrRZ55lgSMc+0q
AZqTgSXG/mDOT9HAwRzgN9/HmKeba6eLaS8xLFF8fvKfpxz4Fg/cLiRm5j3D
/L1cTxFHC/HcIoZxn2FLzwO8xH5/M5C6Hohh7FAq6zNXYrm953iBGj/wkYRE
solK8rCfPPQEeDbD+lr2WZ555jmbbHmVf4T7w6zdwbyDXP96jatW5p4lvm7h
LjeOFF9NbF2OE3GTHgOcX8c+I+w9Pta+2wLGs4dYrlGL1Thgiutx5lxjXDS5
agqYdqnMfY81a5nzGPPUMu8h4SGWwpBpURSy/zUupoN5RohnLtM0U4+Xc8lT
iuEQnqd5FlPpt/4VU5hhWohH6VGbT+8wvp5YDgfsvZd1g0XAH8YEuLYUG5/i
tZHY6rnfzPWLz/SaDlqf6lf+qvJbXWGUxtL6DtcFevGfB7iSRR8w7nQakFQB
XHJay4/qT73nst5kiWk1zXWc51eY5yH7vc7vNu5PcV1MNe0Uv+rwLDHPqPOq
PPs9znQUJ6+2mY8mCkxjaR3gvZglOWXE9jZkuFRXmiVW2DpJ7d6FTLuNOdaz
an1mzRfOY/KafCktpZFqSg/VDfgt/wA1OeI4FJeD+RYnr1U63u4yppv/3sjD
5PVGtt2vphzzV5rz3Af+qyInKwV29xRzk7FjjqvRQjuj/RnutxFfP3GeY+4F
9uxjrZ3E/5i9vGbOJ0G7D9Jid9D8pL6qgsaXeHvEcxNe4/0A+buQbX3NMbDP
a95rCBhH4kp+l1aqpfOaU/K8vN/tZkVT2HzhcfNhrNjmmOZZnONN+uju6g4r
jzwl3qStvNzl5st8qZsXpca1zgrjktNLM0YzQrNijvtXs6y2vDlVYDh3+Wwe
aS6dJJZ6atTI3HX5pod06Qsbp+L2OesMee1+1nH/l+NZfAuTsMkPe5y+upea
Z+JFvUgD1VX9gXyLTyC3/wF+YMqy
                "]], PolygonBox[CompressedData["
1:eJwtk0tI1GEUxU/5KNN8hGbmWIzz0LLGVzNWmxZpOC3V7ElgLRR6iGZpzbgo
UFuYqERtMrBNuumxqxZFJBVEkVHQxkUQVLSKWlSrfpfb4sD5f/97v3vuufcL
HuttO71cUhJkgv4KqQ88q5QWwOV66UGR9HKZNAZPx5z3FkjD8HbQBu8A6YA0
wHc3fIGYM/DpzdJinnRyjTTZIN3cKr3Plz5yNsO/jARxq/0sEz5NzCli59ZK
E/BIXLpRLH0okYK10mDM7z5BjSF4+P//GRCFt9dIZ7Ok0hw0wVMx13qP/An0
zW2TAsWup7tM2hdz7bc5ayD/elB6vQItq6S3+LATDypXSt+J+UX+IeLH8KmT
78PwozHnw5h4BH683rU1o7EL3sfZkNyTfviBsLQObXPUa4y7x+Z1cpO0F4yQ
807u+Sg8r9zrmydT+NERdW2m8VrQPTFvTF8E/i0ifQUp8tJglphXGa75S5nX
tNrmeQp/3lC7i/ufoOl+xHu2+0c42xWSirZLPaU+w0L4LTTOgnHuvRJ0z8y7
fu67UOMztdlaz5/LXINpecjdj8C5gM8mP5faVcyljnrk/mX5xjdI5ytci2la
RFtBwu9O02MhvJ7+68Akd06B59VSnNwlcl5Uew2r9ZvcP+Bqg896nn1KNjGr
sNe3fdmxnl7KvVfr2bztSbiftlM/0XqJ/xfL3VPz1nbSdtN2aJ5daiInAUbw
YhQ83SLtznfP20LukXllMRYbDXgvOczrB28hN+rarYdwyHfS9Jrnn+DZ/M+K
ugbTEq71WdtO2G7YTtq3aTbt9gasN+txf9hrWC3zeInZtCb8LVSxn430nyK/
vcDfsL1l88Tyrf9Q3GMs1mI6Yt6j9WozsFmYp+ZtSbb0eKN0J+7c9N2F7yG2
BbQy1yQYCPvbOIiezhrfAdsFexODaGnB4+aI51juPwfZql0=
                "]], PolygonBox[CompressedData["
1:eJwtkMEuQ1EURVdEVbWRMBOpppU2SB6JpEOjqqihkRHhA4rOfAAqIWpqVsYm
EhIRER8g0Q+o72DWdXPfYOXse8++Z5/3ykfHu+0xYEYycjcPPcnWYJiDvLW9
Dvuz0Al1Dg5kbQn28vBagmIZFlKCfilF/4n+x2U4n4TGIvTVD3KzAtfyZM7X
NFwm9opQH4eCvoyZE7WYE/LefPOdhV91S9+27FTFud0KXCRxTteac+aUbKT9
K/tN/VvSM3NQgNs0P+zxb/9PnvV/+r1n+u7Vh7798f7UcyfkuUNLEnfwyEcl
5oS81fRfJNZGNfbf9W2qmzICba8vfw==
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkc0rhFEUxn8+8jGRj83EG/XinfHRpJgJiY0os0SyECU1SZnSLLGwmFGY
sCQLLPAfsGClbC1kZWPpb7DxnM4sbue89z73Ob/nveFGfmGnGhjSqtGKhuG3
BULVQgj3OvyLYK4LrhphSn15BLbb4UJ1SRdXmmFRNRZAXvpiCr464L0eUgnY
C9znV3dbxyEXhzbVlx5Yb4DsAJzLqyBNU+DL+j4xpPrd07znxVBdK5bQvczz
MHA+6/fVjyV87qk0m5H7v2pOTjxbyveQhl35PCvLZeRnplmNnMP6N+2VlOGj
ST6D8Jj2vJa7GLq/zenNwGQVTHTCSdLZsl3OYTxP8vypzLX5Rz2usRzZSpYD
ZayT17d4brS3FjiDsacqWUqaOavva2lmVI816zOmf9wNt2KeFufdgOtMP5pw
JmNb7vO3tDeNMp7Hcp2pzlU8y0nnMJ64fP4BANtJqg==
                "]], PolygonBox[CompressedData["
1:eJwtkssrhGEUxh+T3OWy4WtCw3yuaZhGKUKJPUlWSCQpt2yMnTJKCBs2NjbY
o7BVtkhWIkt/Aiu/05nFr873vu95zuX5YjPLo0sRSc2QCwdN0lmhFOFjjzho
kaphu17KwGpSWoElWIb9mPSUL/WVSOe8e+TNVIF0h8ZajbTJWRo2eJeGP+5/
YYO7NIw2SiNwwt0pvHD2DP0N0kAWi6/RuIEkbzvhKCodRz3Hci3HcuMJaZ2B
fsqkkPgrkD4Dr2G1Ohg0AbXk1EGEsw96vSBnne/B0Od/K5J2mf+W7xuYpdYc
TKM1ldU07a2o55pGHlolUAxxeg5hJPDd2I7eA+/Zei/Ovn1lFy/1XsNqjcel
nhxpolQaa5MquqX5KmkBb74D1zRt26nt1mawWcwT8ybTji/080zNHeLDVo9N
oxyt91qfzWYcpt4xOYuVvrMj4rDLd2c9NBCfhu6leToZdc/Ne9uB7cI8MW96
6KkXLlPeq2lepdxj89pmtFkf0LsP/R+wf2E45v+a9TPE+T/2AmG/
                "]], 
               PolygonBox[{{7013, 7012, 9626, 2489, 9624}, {9564, 2143, 8893, 
                9561, 9562}, {9656, 679, 7036, 9658, 9659}, {9562, 9561, 
                10122, 2772, 10123}, {8838, 8837, 9533, 2459, 9531}, {10519, 
                1026, 8840, 10520, 10521}, {8476, 623, 10285, 10287, 10288}, {
                8570, 8569, 7585, 2524, 9730}, {9020, 9019, 10659, 3134, 
                6481}, {9779, 1991, 8582, 9777, 9778}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkM1KwlEQxX+U0OdWxLJ/XuWvtVIU9DGKluZCeoCkTYERuPeDaNfWlY8g
uOoVBMGdi96gpbjoDHMXw5x75pwzww1P/YfnA6CgOlTN2/CbhbcW5G9hfwY5
9WLEF3kYXEGSgV0JXluuN99LA76P4DpIF/XmW6bwcwIL9VXJvZZhOtPXbyBT
dv5e+jvNZtJ/VqEXnH8X10md76Y+M/wo3NNNHd3e1/5R5E3bqMCfcFM9Uf7g
GD6UHyI2bhu9lmG7bZft3CSwPoWJ8sZVx1P1NHrPK3633V8I/jb+6xKGtfhX
yvsHXS8wRA==
                "]], PolygonBox[CompressedData["
1:eJwtkTEvQ2EYhU+qCbobpNrkau6VDgwdLCph0cTWjgYSUaNGgqHFqAYWU/tD
1ECIn0BCR4N/YMTgOXkNT3Lznfc75/3OTXY7rYOcpDnIwzCVBrBdlHZgVJVu
oV6RVuEX7QfO0M5hPCu9w2ImLWUx49kmZy3oJVIXcmgTcL0gvRWkzxnpZFk6
RjtKwtPe69xdq0Sms+1p7z4zl/Bakl5KMePZ73mpzOLP09J9GhnOsqe999mx
XYw3+W2nePaqsZN3G8IgCU97P6ThZc88/uMy74MNzhtwx8wXendKSirRkbva
Q2tbh1Eamc52B83/jtxVn30vYIWZOmyWogt3ckU3nZq05f8wKR3y3XJvhTj7
4P5NMbK9Qy2LTGc/4vkEfyDfR28=
                "]], 
               PolygonBox[{{8895, 8894, 9564, 2466, 7503}, {6426, 3068, 10521,
                 8838, 8839}, {8584, 8583, 9779, 2546, 7607}, {12159, 12158, 
                10519, 3068, 12160}, {10621, 2170, 8997, 10619, 10620}, {
                13943, 5603, 7498, 12158, 12159}, {7038, 7037, 9656, 2497, 
                9660}, {7631, 2563, 9810, 8600, 8601}, {9543, 9542, 10126, 
                2773, 7896}, {9563, 2466, 10123, 7894, 7895}, {7547, 1054, 
                8914, 9654, 9655}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkLtKg1EQhD+MFwQRu5BI1KMcQxQSIfCnsbGyt9TCG1hqZSQmoqDyVz5A
wBfQ1sJWX8CABIxvYqXOsqdYzjJnZnZ2w9HZzukYsKwqqL4WoDkBexF6NajO
wJXe7ei4/d8vwXASXppwmPC/NbhtwMYcdDJoZ855qMLWinjj8FmBg3l41MBj
6frR+xNhHyV4n4IfYc8tZSnCU8s1pu0H4YlvHjbb/HNlKay6thucZ/yBdN9p
F8vYzTybZcxVdfWXwvZTHsuS6wizukFZWUZJa3t3kvZOusWacyrivOrvbVre
mrUb3Mcy3iT/64aX9RfyYN0z2/3Og2e27JvRPW1+O+G/0W9hvWH/5CM+uw==

                "]], PolygonBox[CompressedData["
1:eJwtkDEvw1EUxU9QIjHYpEr5t2mbkqikCRMJs0TVZlKJjmwkKtjKIGH3AbBK
1EDUFzBJ9MMQfie3wy9577777j3nJHuH9YMBSVMwBM2CtA/vOakLqTx1qJWl
LWgl0seIVBqTTrmfLEkL49IitDjfL0uDE9LXsHTE/ZdZP3CWkc5hOy3V4Rt6
8DcnVVPRr3npZVrqQMLOHFyx7zKJmt+swVp2qTWgRm0TbkrSLTyxqzsq3WFq
h/c37q+F8GAv7dnYZY2PaG1motd/OvQd9/343V5W+bOSD83W/szuDbw3CGuN
eqVIfzE0WutkObLwjItKZOgsrdFa7cnesjCTj0ycjTVa63o6snXGn5wf+nl6
Xpt516XQ78x62cjQWVqDtfwDiwBBjA==
                "]], 
               PolygonBox[{{6493, 3148, 10678, 9021, 9022}, {10529, 10528, 
                6426, 14, 10527}, {8991, 8990, 10621, 3111, 6466}, {9726, 
                1985, 8565, 9724, 9725}, {10129, 10128, 9563, 1331, 7897}, {
                8545, 8544, 7547, 2496, 9651}, {9571, 668, 7007, 9573, 
                9574}, {12164, 4144, 10522, 10528, 10529}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtjztLA1EUhL/EDfhAEIKGVXwkEkK0CBjIdv6BgEUCwcbGgHamFLQQQUjj
A/0NNoqxEANa5G+I2tvYW7o6h3OLu3Pv2Zk5M8XdXusgC5R0xnQ2V6Ep3In1
WYfCNPytQVbz3jgcVuGqAm+TcCN8j53fjv00g0cmaON5uEzgew7OhRfhbrNc
8ByV4aUO23l4FR7LN4pgaxHSknPaVX/b/LTmvub/JH5HuqgAGzPSNuBrFo4a
/ra7aWyH+ZwswH3i/P4K7Gl+OwFdYVE70ik4k3+/5vo7cT+WvO91xfubj+X6
leZT2lT4kHiOgXA/eLaU9znks/8/ee9uOx4T72u9h3XPaL1tZnzbvRzyWK5/
6vM+vg==
                "]], PolygonBox[CompressedData["
1:eJwtkL9KA2EQxIdgodgIohJCTO6OCKkCnuT6WNqYFCLaaB7AdP4txCiIom/g
CxiJTRSTTl9AW7HWxs5C0ELxt+4VAx/fzM7MbtBsNTYykqbBEOgm0tK4tAyu
eVdmpI8RaQHuOSsdVtAhfJuQ9qrSQyjdg8W8VAdH8L+j0iv8DvxxEf2Ue/Zi
abfqs7NjcGgHzPRBGElR5DM2axmWdZDm2d82XDOQ1kGvJN2AMzq+T0qf+Lfn
pFO4k8A9zbud9jHNOdpVuBXQYfYq9TAv+zPuiR0fwRd/3+Ay8a62QyfxDtbF
PM17EPutTHPHO5/1LsYXytIFHV64X2tYyrBfERRADd08aKCpl30n280yLXuT
91bgnv/53OA29s7WfS3HDNjPubdl/JTcs5buYLvYTcM007L/ACuAT9Y=
                "]], 
               PolygonBox[{{7505, 7504, 10129, 2774, 10127}, {10130, 2774, 
                7897, 9569, 9570}, {7606, 2545, 9775, 8585, 8586}, {7506, 
                2468, 9574, 8896, 8897}, {8567, 8566, 9726, 2522, 7580}, {
                13234, 3351, 11008, 8325, 8326}, {8326, 8325, 13235, 4950, 
                13236}, {9570, 9569, 11007, 3351, 11009}, {10579, 2159, 8965, 
                10577, 10578}, {7009, 7008, 9571, 2468, 9575}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtUT1LA1EQHL8igkVAJKQ4yCWEKBan3GEauxSC2BgRC6NFChtB2zQWBgwi
imCZ1sLKgBKNsRELG1Gs/CfaO8Ncscy829nZee/C5lH9cBTAHGuM9Z0HVog1
Yq8KZHLAHXEnBF4mgX4Z6BSArRngIQZe2Tsg/yLfZ3UzwCr797E1fwnwGVsj
7Rl7P9QcV4BLnqMs0I6A27L9G6F3iDfJHzm7zdkBcSLnPJr/TYwt+jSpv5kC
rsn76V5lbKSZe+x/FDk/DhTn7SXPYex5+SjXOfXr1DwFwHves8qlfMrZWvY9
lrI+dyLzU2KdvrPTwCZxI/CuN+7cS7Otcc8wsL/2PC/6u/rqie+Sl0rWSNtO
/J4XVXvJsx74DuIDelxVzLVzZME+eo9a+h8LJedW3hPm/Afc5EkK
                "]], PolygonBox[CompressedData["
1:eJwtkDEvQ3EUxX8pKhKD5IUGkaiXpjE9TSVv8RHE0ETM3oBEwtguBoMNTYzC
ZGyZhLLbGH0KKwMDzsntcJLz/99zzz33VovD1kEJmBNGhWIetoXdGuwJb03Y
TyCb0lv8OAveEDYW4Eeab6FdhY7Qy2GsAu9l+FyFkyy09nhV/7V6roRSCiNp
9LjXf6511f8xA5fq35H+cUV+CnYzAQPx82HdGc7EC/U+j8P0JLSW4UszN5PI
4CxP8thKIs9AvCNNW/hdgj/hNI9Z9rS3d7S3387SmA1vz3gR72vXXi1u5Ft5
B+9iT3sviq/pjuvKnKYx07PLynMnv/7wPs54r9pRPerO+KD3bR5aa6y9qMfu
vkFX/B89k0GQ
                "]], 
               PolygonBox[{{13238, 4951, 13237, 10107, 10108}, {9565, 2467, 
                11009, 6681, 6682}, {9719, 60, 6607, 9721, 9722}, {9576, 9575,
                 7506, 1029, 8906}, {10108, 10107, 7502, 4145, 12166}, {9646, 
                1978, 8539, 9643, 9644}, {8959, 8958, 10579, 3093, 6449}, {
                6682, 6681, 13234, 4949, 13233}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFj7tKQ2EQhD9MELQLioaAxwQJJ9gYOIE8gr29jYVICoMpxIDaKViJpYKg
tRew8dL4AppY+wxaKoJFcJY5YPGzy+7M/N/W1rorm2NAolfQ603DYBI+1Vcq
rqt1eMmgMwVbDSjPuv8Yh7vsXztatLefwmvm/cGSteGZUd1PrS9LX1iAVhHO
5+BQuqG8u9p/tcxx1Ybjtn0byjtKnT9MrAv9veZvifsLsa1n1ofvqQnzJTjR
flt/PE/AjW5ZzhmC5bru+a3qZcPMp1XnRuaeNI95zkPTTMH2LcZfed7l/VE9
q9obGf2cM3jjtrhxp+Ybgm2g+gfXLkBs
                "]], PolygonBox[CompressedData["
1:eJwtkD9LwmEUhR8ihGo0Sg0iFVFbxPxB36G25v6ADqVDYpMNjUXfIGpqiVr9
BE45ZNncZ6ixlobyHK7DA+9773vPe87NN7t7p3PAqpgXk3V4W4SHJbipwLgA
L6JQhaLol6N/tgzfCVzoPpm9v95QrwErachIcLgtwSL8a76ehS2RycEXofG3
GX941hrv+vupBI9iPw8HYqSZ52zU3GutQVOc6NwWR+JQ7MjHbjk8WM/69tqT
ficdno7l7Vb9z1TUxrqfO1M1PNprX38mWsTHAvxK974S3jxzp9nLWpxdu6pF
Rmd17VV6P0nsxhkHjfBor96hd+kd1GeZnG0KEXJBSA==
                "]], 
               PolygonBox[{{10531, 10530, 12471, 4383, 12473}, {9645, 2494, 
                9644, 7010, 7011}, {8541, 8540, 9646, 2494, 7542}, {13159, 
                4886, 13158, 8263, 8264}, {7825, 4383, 12472, 9566, 9567}, {
                10059, 10058, 9565, 236, 10055}, {10614, 1076, 8963, 10616, 
                10617}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtj7FKA2EQhD+UiHjaiij+nMLpJWmUPIRRIUWeQLQIaSI2gpVWku5KSSy0
sIt5DEG84CniW/gMkln2L5bdf/7Zmdmd88vuYAHYVi2q3nfhbBk6dTjah5cV
OFX/CnBQg1LzW+Rk4nzo/bcEx0242HJ8msG98Eq7t+rtFIoEei240c7eKlyr
F8H178T5Ds63vbH4r+I/5/DfgPU12Nh0bJq43yz6PqaOTSL+kHvOT+kNxfmR
ZnLoPPu3vP3Mc1peu9Nmu6mKN5qGZbXMV5rLeK/tlS33GqWe2/K31X+De5nn
SdM5T7lnNl/TnQN7GztH
                "]], PolygonBox[CompressedData["
1:eJwtkD1OQlEQhT+NUkgsMWLCC+RJ3kMalEUolPT8hAUgNtJhbUW000ZIKCDo
AmQBWkD4idtgCyaeyVh8yblz5szce3Pt21pnH0iJA3ETwfgI1mIbwEPk+uQY
fi/gJQuzJHyIUQwL+aVD2CVgGXnNvHfxqt632PsHois9L8GneNLsZ3FegLDg
NfNOz3yX7exrXiMHdXGfgV7GM5Zt5qElKkXfbTuq0lPVJnnPWPYu9t3mL8pQ
TsOV+BLf/5i2jGX3Qn1C6D3WO4z9LfbGdeB3srvZH11LrwL3fnR+1Dl56dpq
G3l/qDw32Q==
                "]], 
               PolygonBox[{{7543, 7542, 9645, 2144, 8904}, {6465, 3110, 10617,
                 8960, 8961}, {11005, 3350, 11006, 10105, 10106}, {9568, 9567,
                 10059, 2724, 7823}, {10106, 10105, 10121, 2771, 7893}, {
                10533, 2144, 8907, 10531, 10532}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkL0uRFEUhb/x07gUygk5M8LkjiuSO1Sj0w2VKEQ5mQdArREJERXRKlSe
QKLwAiIU4rfwKoS1rVucrH3WXvuctfbMYHdzZwho6gzrfOSwNApvCU5Uv4zB
p/C+DovqLwuPdD+VptuA67brFdVZBhsTUNRgaxLGM/fWF8yvCe9K+BU/Nw+1
Wb+5qjfP9N/3CPRbkOrWDAq41F/P8vCaPBN8S9gvrL8pPRP1hTTvyf73c/eC
Pxf3U5g/EP+Q22tPfr5y+5xuOFv4CV9PFf8o3O5YH3OROTJF7qkqc/T32s59
JTyu9hb7O6z8/+dI3kvWsb/wE75uS2tC+wd9dDmw
                "]], PolygonBox[CompressedData["
1:eJwtkL0uRFEUhT9iCi6FjsEdI5HD3EhQKDwBCkShROYBKOkoRKiIdgqJTqNU
SJT+FWPip/AqEtbKnuJL1jl7n7XXPtX6ztp2JzAgukRjFK4z6BVvCS4moNYB
q32wVMBiETpT/UX1fTFbglYPHEkfi5NS3H3m6td5QbxLt8TzGDyJ5UlYEWe6
+9Xgpt7fTMN3Ci+//5LerMKG2B2BPXHe7v/T/Fv1D1ciqzNfKmu9FjX3bEl/
5OHlTIfOUkR27zRXlp6B9f6oO/t8JbQ9f1LsmLX9/TfO4CzewbscpMjuead5
7OTd7lV7EK8pvDyjmUdGe9lzSLOuxuGuG6b094+D8A94Ezz0
                "]], 
               PolygonBox[{{7891, 2768, 10112, 10056, 10057}, {8902, 8901, 
                10533, 3071, 6430}, {7890, 7889, 10118, 2770, 10117}, {7541, 
                2493, 9641, 8542, 8543}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtUbtKA1EUHHwVbgwEX6y72WtsdtEmF0kEv0ALEf0BNR+gWAQsgpVaWxlN
aQRbCx+NP2CpEeMDbOws/QJnOFtc7j1z5syZc26lsbe5OwBgnmeQ5ygFnkeB
1wSozwDrY8DKAvBFPA6AZQe0xoF2CfgdIY/4JPEe74MyUB4CtirAMWM/DLxQ
p78IhOQsOdMW/4S561nT+mF+Nef3EqvRW9jGlNXuM35jPM13n3fNmUY3A64y
05QX9RD/IzUf8tOkr29qfrJ3h3iL8/zRe5f93+vkcJaiB24Cm1G5bS7koQA0
eK9xD03u4ZB1UWA8caQlzQv2b6fmR76Ui3PP91Ugof5pYt41v3jSi3KdkjcP
8hLmmGonvNXeUeNpzmbRji8zy8fO/kE7Ulzw5nmHns8z2+EZfT2GhitfzHvd
UjNyVie9fz3uSUU=
                "]], PolygonBox[CompressedData["
1:eJwtUL0uw1EcPRHtoO3QKFLlFsutdtFIJPoEFhEm3fAAxGBrLL5Wk1aMJVYJ
iTcgHaWiUaPNYPAEzsn5Dyf53XvP1/3N7x1s7Y8AmCVGiUYZmMkAD8RdBVjl
ucT5bQw4jcDGIlDIkk9ybwF4D36bIueD78No/lEOWJ8GHpfIzQPP1OxU6U2/
w5Qzvsg9idZLI22P+EkDbWq260Cf54kkX9xXZr4QoQiUiS47nqfMueX8vQy0
xu3RmbOHvJRZYvZu1V3UKc+33xVgc9KcJs9rNf4xZ726XET714kzzp9EMWON
tM3EX5n3zOsHc4fsexO9Q+1S/9Muu+T8pe0xYNfjmneluxbnq2i9Mtucn5L9
BaLArMvgWXfa7SB69+Kr63XF2fLocP4HlgRGbA==
                "]], 
               PolygonBox[{{12469, 4382, 12470, 10113, 10114}, {6448, 3092, 
                10575, 8902, 8903}, {6431, 6430, 10850, 3255, 6588}, {10114, 
                10113, 10139, 2778, 7902}}]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1kT8vQ1EYxh8VBtJItZq2g3trOQ1L62pj8REsJo0m/kwmIoxi0MUHEFo2
Ff8WkZAYTBYfQFUZLBITTewknifvNZw857znPb/7PO/NLq3OrEQAjHN1c22O
ARtRYIs6XwSaCWA5A1z12/63F5j0gJ0e4MsBtRxwwrs6tRkAa3HgiXqXBobJ
86iHvDtlz4HUB37IKBeATsn2L+S8sblE5jb3da4W6xF6iLJvNgYMUOeoU0k7
f2aBCnWI9RqZF+S/B+Z9PW7+kqxdcn2T9RxYvcHeFvcp1kuevVM2+Wj3mc//
b0t3nTHPmX2hCxgsGO+InI6zeZz5llN5H0ZsHmLp/XHOPDSo0xljvDrLoTzK
rLPqVWf5VbvJmy/x5S0V5lCfzqoroziag2YiH6rf0nsinNd13matN5q3MovV
dvavkiG3Gnp4dJZBWfJpy61+3cXIKZO5OArcx20u8lAJ/4t87zvLvkf98K2v
OAH8AWzBYi8=
                "]], PolygonBox[CompressedData["
1:eJwtUj0vQ2EYPQQDilINHW7bxb3RpTf9IPEbLBYVEh+TiQgjZj9AVK/EoNKG
RSQkBpO/oK36XCQmJHYS5+Tp8CbPe5/zPOfjvcmV9Zm1dgBjPB08uSxwNwTs
dQKTceA6DeRZz4eBiA/cu8BSG/DTBdRYL48Dc+zN8vSy/54BznuAX/arCaDk
ARXeG7wHxF+lbVeBp4/4L9e4/tj/Zj3g276pKPDsAE1+G+H8WQTI5oAnx7iE
EXbftd1VYo480yRtF7yf8p6jhyjrZjdQZO/AtVqaDtlv5o1L+8LcV3cNv8EM
avRykzJtNfIvkn81ZvUlMRXOD3NmIWwZvTqWgfSxxO0osMv5rZBlNh0zT+KT
/5BvnuRNmB1iJ+KWxyb5H8j/4pheaZI2cYpbGR+zLnvmVX15DTzLQjOaDVr5
SN8b7/2+cUvzZ9LeoNDKW1mUE8YtPdsp86RZ7Shx10nC8tWbNDKmWVj9Mx/s
1TOWnTCD3P3o2r8gT/L2D+QyY0o=
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtUrtKA1EUnCgaMQQfQYsgugFhF9MYkhUL/8DOUgKClZVC+mCw0A9QCw1Y
WKgQbWLjd4jxbamN0cIvcIa5xeHeO+ecOXNmt7S5s7Y9AGCRMchoFYBdxsEQ
sD8DrBJszAPNMlDPArWUuYAv1YD3WSBl7WkCrE8AK9N+K6cacfRLwB97xyrA
YQw8jQLHPDPE94jXyd9OjB/FniNcGoo5oMzohrtO8bbzwPCI33ny1ni+UcsJ
+1/I88F7L7YWabyJgFv23ydhZtY8G6m57rjfeOB5ZX03Zz1p4BWufCdy7jKx
T9pZOuWLOJ8584K5dgbYKlrjQtC9POcdUnrzUDW3NH5F7pXH/dj138EH1Uun
PGgWzHMW+DVnsmINPfI9MhqsOY/8HaRTM7SvdpfOq8R3+fEbm/eH53XkfT6r
zrfCPyAf5edUxbvIK83WzEaokS7h0vYPpGlWBw==
                "]], PolygonBox[CompressedData["
1:eJwtkbtKg1EQhL/ES0JCEA2KxECMCPkxVcgFC9/AzlIEwcpKQWtRbPIAKqjp
bAwoFrHxOcTrA2hjtPAJnGEtDmf3zOzs7pzq1u7aThoo64z6LsFsAV5zcFKD
N52NDHTHoFOBu3k4KsJ9HvoJtFtQygfnU9jeIqyOwED8fcUPdehJ70A1feHP
TVifVJ3wJ8Xf0q/nQ2O5Ehxz/fYjrNgI/qHeboVNKP9Vr5bqC4o/moF5Js92
5RmKUTMl/Fwa77nYybud1mI352nNdq0dBuq1MiNeB6YbwXePYTU45vrtQrVz
pcCcW/vsX88aN+r9pXxJ8XgWsguwLX4vFR5stuWTPDnOhEfdcvR0b8/rXS+T
8MaavSQ8tJfWHNbiD/wX3vFFuz8m8RfWTGnePxdbQ78=
                "]]}]}, 
            {RGBColor[0.817319, 0.134127, 0.164218], EdgeForm[None], 
             GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtUEEOwVAQfdUKYtFFd1TSSpN2JRGJg1jTBXsSVk7gACJxA4K4hBvYiANY
4Q7eM3/xMu/PvJl5f9LpYjSvAOgQPjGpAb0GsPaNK4bMb3Pgyxi3gHrX8m/m
yprpPGLvNG1qbhEwC60uiEu3iVnn/HEGBK6m3msCVBlfA3tLq73PIX2RHwrg
khiP+jZPPv+7U+DRBO7UnKmpMLfLTauZJw84Fsa155Nb7yoziC8zmyFv8hU4
X+rVPs2Sl6qrKS+t/qk/iJeupv2+0+heuolu8wPnnycE
                "]], 
               PolygonBox[{{10450, 3031, 1796, 8365}, {7302, 3939, 5059, 
                13366}, {9330, 2350, 3939, 7302}, {13285, 1797, 1795, 8364}, {
                9308, 2331, 3031, 8449}, {13366, 5059, 2331, 7303}, {10133, 
                1794, 237, 10131}, {10219, 889, 2350, 10220}, {8365, 1796, 
                1797, 10408}, {10407, 1795, 1794, 8363}}]}]}}, {{}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{6683, 10136, 6684, 10131, 10133, 8363, 10407, 14041, 
              12563, 8364, 13285, 8366, 10408, 8365, 10450, 8449, 9308, 7303, 
              13366, 7302, 9330, 9331, 10220, 10219, 8712}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7898, 12560, 7899, 12557, 12559, 8684, 12565, 7901, 
              10137, 11010, 10132, 10395, 10394, 7900, 10197, 13268, 13269, 
              12562, 8354, 13270, 7990, 10200, 13620, 11133, 8422, 13365, 
              7992, 10221, 10222, 8360, 11192, 13663, 6760, 10406, 10398}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{6448, 8903, 6431, 6588, 12556, 10849, 12561, 14040, 
              12558, 12468, 12564, 12469, 10114, 7902, 10138, 10393, 10392, 
              10134, 10135, 7989, 10403, 10404, 10196, 10195, 10115, 10202, 
              6733, 11134, 11132, 8355, 13271, 7991, 10201, 14062, 12633, 
              8359, 13283, 8344}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{6710, 11080, 10185, 12632, 7963, 10402, 7964, 10203, 
              7994, 10405, 7993, 10116, 7892, 10198, 10199, 10119, 10117, 
              7890, 10057, 7891, 10139, 10113, 12470, 7824, 12467, 10848, 
              10850, 6430, 8902, 10575, 8905, 7544, 8543, 7541}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{6465, 8961, 6451, 6599, 9641, 8542, 7543, 8904, 10574, 
              8901, 10533, 10532, 12474, 7826, 9568, 7823, 10112, 10056, 7889,
               10118, 10111, 11005, 10106, 7893, 10120, 12555, 7888, 10187, 
              10188, 8347, 10186, 11081, 11082, 10399, 10352}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{10614, 10617, 8960, 6450, 6598, 9640, 8541, 7542, 9645, 
              7011, 9577, 8907, 10531, 12473, 7825, 9567, 10059, 10055, 10110,
               6680, 11006, 10105, 10121, 7886, 10391, 7887, 10400, 8346, 
              10401, 8345, 13259, 10353, 13159, 8264}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{8263, 13158, 14223, 13160, 13261, 14271, 13260, 12165, 
              12166, 10108, 13238, 10109, 8328, 10104, 13556, 14251, 13557, 
              13233, 6682, 9565, 10058, 9566, 12472, 12471, 10530, 8906, 9576,
               7010, 9644, 9646, 8540, 9639, 6597, 6449, 8959, 10616, 8963, 
              7581, 8568, 9722, 9719}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7606, 8586, 7609, 8995, 8992, 6467, 6607, 9721, 8567, 
              7580, 8962, 10615, 8958, 10579, 10578, 8546, 9652, 8539, 9643, 
              7009, 9575, 7506, 8897, 7505, 10127, 10130, 9570, 11009, 6681, 
              13234, 8326, 13236, 14252, 14253, 14254, 13240, 13241, 13239, 
              13237, 10107, 7502, 12161, 13944, 12162, 14221, 14222, 14220, 
              13442}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{6429, 10527, 10529, 12164, 13945, 12163, 13947, 13946, 
              12167, 14249, 14250, 8327, 13235, 8325, 11008, 11007, 9569, 
              7897, 10129, 7504, 8896, 9574, 9571, 7008, 9642, 8538, 9651, 
              8545, 10577, 8965, 9661, 7039, 9725, 9726, 8566, 9720, 6606, 
              6466, 8991, 8994, 7608, 8585, 9775, 6616, 6483, 9022, 6493}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7631, 8601, 7634, 9025, 10678, 9021, 6482, 6615, 9774, 
              8584, 7607, 8993, 8990, 10621, 10620, 8571, 9731, 8565, 9724, 
              7038, 9660, 8964, 10576, 8544, 7547, 9655, 7014, 9625, 7007, 
              9573, 8895, 7503, 10128, 9563, 7895, 9543, 7896, 10125, 13942, 
              14248, 13943, 12159, 12160, 10522, 10528, 6426, 8839, 9532}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{8476, 10288, 8479, 12913, 12911, 6496, 6623, 9810, 8600,
               7633, 9024, 10677, 9020, 6481, 6614, 9773, 8583, 9779, 9778, 
              7058, 9740, 8997, 10619, 8570, 9730, 8564, 9723, 7037, 9656, 
              9659, 8954, 7546, 8914, 9654, 7013, 9624, 7006, 9572, 8894, 
              9564, 9562, 10123, 7894, 9542, 10126, 10124, 7498, 12158, 10519,
               10521, 8838, 9531}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{11091, 11092, 9302, 6713, 13603, 13605, 12065, 12069, 
              12068, 6924, 12945, 12946, 12942, 13481, 13480, 6503, 6625, 
              14353, 14352, 10896, 10893, 11655, 11654, 6922, 10285, 10287, 
              8478, 12912, 12910, 6495, 6622, 9809, 8599, 7632, 9023, 10676, 
              9019, 10659, 10658, 8589, 9783, 8582, 9777, 7057, 9739, 8996, 
              10618, 8569, 7585, 9734, 7042, 9705, 7036, 9658, 8953, 7545, 
              8913, 9653, 7012, 9626, 7538, 8900, 10570, 8893, 9561, 10122, 
              9539, 9541, 8518, 7497, 8840, 10520, 8837, 9533, 7494}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{6858, 11457, 9042, 7426, 8609, 6631, 6515, 11866, 11867,
               11865, 11870, 11868, 6935, 9306, 6933}], 
             LineBox[CompressedData["
1:eJwVj0srxGEUhx8hkS/gMmncbzO5hLBymTKWcstCLgssGMM0lJWFosSkycrI
fABEmZqUjWI3+RAW9iwsPRZPz/s/7+895/yDK7GprSJgQyIBOKmH0SYYqYFJ
PWEtEoRxz89VUCs5MyEdbYNXz3EzHzptpqAf9KP8es7rA3t96UNd2gyVDXDj
m7dWeJcKa0shKNMpM136yJn9+lRnnTPmm5iZrPfT1i+tL+grnfd+0X12euCp
DgLWcjps73Lzx7671aftcC4XkjKblugAvJg964S7PriXQfe+8HtI/9TCej98
6zXd6H2zzDVC0lqhBfb0vN+91g86/DfnFZstkYzna8k489MdNyUedlfZloTs
/rvaPnpfkrLaDcsybD1h71n7zsgfcZ5CfQ==
              "]], 
             LineBox[{7819, 12463, 7820, 12464, 10973, 11761, 7206, 13840, 
              13839, 11130, 13618, 11861, 7292, 11859, 7291, 11860, 6707, 
              13896, 7310, 11899, 11901, 11900, 6776, 12679, 12680, 12676, 
              12678, 12677, 6570, 6660, 9325}]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV00lszVEUx/FTLIwLCxKqhpqKtuaq+bWq1ZWhEVOkWsNCq0TQWJhLQvFQ
NSeKlSFRtKVIJMLCoiSonYiwUVYWuiHxeYvf+94z3HPO/977RlVuX1GTFhED
/MyeGbEwP+LkpIh5eRHzaQHNobmUK14yNKJ0TEQxVsuromW5EUtpw7CI2vER
FbhETr3YcnldU+XgcLV/WJ/gP4HHacHEiA+jIt5TjT0D7f0zOuKSnMtUPCLi
orwS/K72N1psjiK6Kr6Y/4J4I31Sq5M+50T0N28/+mJ9Tl6D+Gj915qj0N5a
60X2/pVThOfFE3gGC/E0FmASk0Mi3qrbQR/V62tPH+q0bsmOeK7eNd9/x+xX
8DZexcl6rZTXxn7MfkZPqZb/EbbQA2oVf4jtMyJe6/Eq1UvtD+kRve1/a93t
G/KmRxydFZE1MqIHX0/qRauyIn6aoYvS2OPF6+RlsIel7lSNI3oksA6r9Mrn
34KH2ZvwEG7Gvb71sf5t1Eq3hke8mRJxE6udRa4z2Yo5WIULfcsa93YgdeeZ
EQdxHXuw2dert5+9GvdhrjveYJ2N982Zg030Vf4L+WXu/aXz3MO+J/+du76L
u9mTzFup3xh9N+FJ/t/ioWcPamE3q32fjjmr+tQ+60z1b+jVrv5G/id4nX2N
jsqp5KugciqQn6D16mdO9l4oaZ6z9NR35uvTjs1mOcXXOM27oiSddVanqZ7u
6ZEnt06PmbhNbjVVjHO25t8l/8kEb8Rsa/gasQyb7Kuxp9A5NInX8z/PcEfu
d474ZrEGOQnvJInl7D78v9z3GznX5faztxffQfGusf5DfP/MsFO9bmzm68AG
fIc7xF9isfgSarVO9wYyrEv1XyGvCEsxoWYBlqRmkjdIzn/+uKsS
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV00lI1kEcxvGfl7AgiOjUprar5VKvqRdbDNI20SAto7QsLUmTSKpLSRRB
BbZBVFoQdGkxorKVOkRJtgd1CDpItyAIKrQF+ryHr887zzzzm9/M/M3Y0FrV
khIRw/xJjI3InBJRQIvnRizOjqjOiViFjeMjKmkVlmOPcVEyI/83K+IPBtE/
MWJ4fsRzepTOS4s4QkvokHza9Ih0DE6OGK3GE79H0R/G3fTanIiO9IgrdB+9
SnfIdOnlHM7grHpnUGqPgVkRv8dFfLP3EP1s/Aln1fqVZw2tKopo1ucpa9c6
24B6tbS0IOIk77hax5DIiPhg7Ufc5r+n75CTG9Eof4t3A93O34VB+Tv0Ll7x
36Bd7qHxTtqs/gO/X/Jv01uYpqfXar7Bdf4L2o+35tbIr0YP/5KzDzj7SvdW
TLOMi2gmPVgYsUK/W6zZinb5XVhqzz3GS2i+OruTffCbaCPy9fvc/v3Ywu+j
z1DjPhZZ08TbjBa1t+Gf/Ibk26OV34ZyufJJEWU01x4tvHrz65Etf9VZruEx
/wq9jDz31yz/iPcAF2TPo84eDd5lE2qdM0XdNfS7fu7jHiqsK7TPIesOoMOa
fRjprZeqsQwN/JkyC2Ur1FpA63jrcG+m98FTXi+9g07MUuOn7yeb9tjnJO8E
juCRHk7P9h1NiDicPI+9tvMv0/3GCX32qNfCq5vmjmV3oDfTd+kOanjVuChf
k3BW2mbdNlQZV+K+2ntnOA+KZTeaK+U30G/euJ6WGK+jqea/8vpku61LMU71
//JlasQIepr3V09t9v+V7I3/gnbS41ilp1aZXt5imZt0Ih2PMnOVMqW0jM7T
awmdjw65MTL/Aem2rzk=
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV02toz3EUx/GjzBhRksx9bK4z5q7MYmxICMOyUXPXbGNbI5I0ueyR1BbZ
E8/dlctGJsoeYSmFQm4his098tqD9//zPef7Oed7+X3/KcVly0o7RUSSn9yx
EWNSI2YMjFhIN9CPKRGLMyL69o+4KPd7TMQv/ECXzIgEtAxWOzEiD7XieXQu
MtVUjozI1ncWfgyP6D0k4httQ5l+fXjaJke063d+UsQ53NXvlD4NOIF/UyP+
onhCxItxES/xif8Z/aL2CT1kj4fRrLZE31t0u7VzjeutXYfjaHCmWr4hAyLu
6J1vP1fki6ZErMVWNZfFl3ABK8w38hWpa7N+k7735RvpV/EW/lbxQ7zlq+BP
maY/fskNpTX6/jS+ar67uAeSsEa+ELf1OGv+DC7yXMIHuWnu4j197o6epzs7
qnm6yiei2dwicxP02C1fib1q96Cf81XQSmyTH8czj/ehmhy6WW5jx771eYAK
53vrPO9QLv+GvsYm/grxTmxHpvNV69lb/1ZaIG6WX6//Btzkvym+gXvmezln
T7QY3+5Yk+cGTxd1bTSBNtFrOGL+EGqQJZ81zJvx3WfSPN9slz3m0N10AS2n
+b5vFV1EK2m2/HLjp+pH6pNu3RE0Fd99swzxV3rC+zyJfahHHZKc94i3dBRl
7vogPYBJ1j/rzopGuEv5dXTUKP3xaJAaWotC+Sr+0+5mlXdZgJ3ilbSclqB9
qP2Jr6vbr2areLq6YnOz5edgPvKQJr+jowey0Xm6d8//WN0HeocGT6L/0qu0
iG60Xt8/9ls62pr4bDw+mRfHePL9n0t56o3X2OdqepVnAG+euaXiJcgxl0ln
0Wy6n6cvT7I+/wFea7Df
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV01toz2EYwPHHaYgYUg5zmNlmxjabOSS2NpNksiHHKFfc7GSWFHO8ES6X
XNi1pAyjyYQ5hRyjuCHSRJrZgdzw+V98+/7e533e533e9/3/U3dWV1YNiIi/
mDAxonFGRHJWxDHOT4/IQ8nkiHV8Wmz1lIgWLueNYlvMNfH61Ihm3szl1ueo
9UNete8ubpJfY+6TnI9ISov4xx2zIu5jkLn3PITf8mB+x5etK5uvxvSIxfyT
j4sfwy7fB7kwI+IJ9xh/4D5eL3cDtiJpkT65X7x+rj4LIvbwVutqxU5Y89o+
WYn9pkVsF989J+LipIhcvV/i84VyxepRhxaxxvyIG/IP8GEcQvfUiFnz1EJa
dkR6ArnPZ0Zk8hquStEfV/PKnIhVKMEKlGGJPfsXRPxBozpHcQQD7VXExchX
txBZar42foCHWCD2hB9jqPwX/BJP8RzPUKp+j9q9aEjUkrePL+v9a15EK3+c
7a3wGZV6vb8w4py7eubumvkVZ1tXZ10eV3Mu1/Iq9fvULjDebzw/cUc8isvd
8VDrb3G/Nx6uzm8eJnZJToWcJc5QyS3Go/kaX8cFtOJqYk/9jHDfI/HF+Cs6
0ab3XmfoQ6fevyHZHRU7Q5v5G/gu1s430S7/LnfgFu7gNjY5w1pnqMAJb3IK
J7HDm1VlOi+Wq1mCMeoX5UaM5V9+Z8t8d9ljm3NsQbF4jfwz6tbyPXt2m+/B
OHMpYuO537hCzlo8krNXfKn1K52x2T0U+92V4qzcBnNv9PYWg+UPS7w33unv
W+K/xFf0tohbeCFn8E7+D/gqp2c=
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV01toz3EYx/FnpDCzyXnDmB0chs3GRtvMsJoNhRxyyi6UyDFCDkUJcUFc
cLG4Qc1pJclpRZssQ0m5EZMcSswpScnrf/Hp/X2+z/N5vs/3+/v/R9RvnL8h
KSL+0I3BEcnpEZezI65QDr0cEjEKp02MyMPT8jXWZzMjpuA5rM6LmEVV+RHT
aRo12J8h3weTCiNah0X8K4h4iEPV/hoTkYHfsZP+yj2Q22JvxdiIZdR9fMTA
yRGTzTAAyyZE9MVy7D00ohI7i51jrmbe9bwr1VbZT5M/zJ+K08UF5h5vnpPm
aTbPKSwU3+NrLIrYNzziszm+6PeVLun5SfyR3tMtdV/NeBOz+U7wv9PnOI4U
L9a/R0nEPPEl+1fpCqWJH+nfRmXulDHJHGrX6j8Op9p75ey7oyLuUIr6Crmd
vOVYpiYdN4mHYH7i3BERT/VLkTtjrxd2mPE1vTVjBzWZMy3x/rSNNxV7U4Xa
+/iA2hPfBVuou74terZSiZn6mbM/vdG/WFxEhdRVXTlfUuKefE9xr/gJNorL
9S/hmentp+Bm3+OHeedY58o9w0zf45v9MXw/zXnE7+UH5iXezDc8LD5EB+m2
vvsTd7DeSsm89X4DH/hX4wUzXky8aVbEOvkCvM4zyJlNmO1NF+Xqhxu98zHc
hGfds4F+W6/yveeqWY5bKaU0oid/L+xGb3h6iB9jGxWr3Y3bvfceXKdHDd9s
KqVqmklNfnsv5Z/TC1pDXfSpc24tVfq/tVNHjtnsn1L/wXpHRsR5/OYudaMj
lsg1iBckanCp/EJcRNfU1PLNsT5qnY/HsMreAUzlH+CMXdZZcv8B8nOZ8g==

              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV01tMz2EYwPHHKWzGhDl3Qk5JKFGpnK5EzWYyYw4Lq5ENi7mxGW3iStlM
LlyQ01/NYdwxtTHuTFdcoLFcONRVWcbnf/Hd932e93mf3/P+fv9/5r76rUeG
RcQAnkyP+JwZ8QntcyM6cD09onR5RCuXc0tBRDNWF0ZckyviVfJrUIILaREP
8iKqF0XswDq5tahcFvFPPvgvj+DhOKR+UPwHxepfigesF+mdkhsxFgWzIkbz
lJURk5GKXzkRfUhfEZGB72btRd38iI38dYZ7mLNfzYalEesx6F5LzZKHIvli
XFFX60ybHrdRKHeX7+C95/42Sx/y5X/yDxxU3+LcCrk8ZOs3D6OyIhLuVGX2
W4sj7uE+OtW/0q8lQ1/xFX4tvqp/Vn7ER3EGf+Ah7/OF+p32ytyjWv1MzhW/
k//iDoNLInr4rVyPeR57Z5PM8Yg/iWvUpYonYgLOmSfVfEPOdHG3OCH/MHkG
z9V3muey53eIm7lLPKR/qfuMVH9PvsS6GM+S9e5/V64ND/RMYIdZV5m10rkq
7ve8ub5bhnd/wDfrl0+zPuvMRfWX0GSd8J2e6VeXHfGUG5Mz45T9k+hNfn/n
xuGrdaPfyTceK06ZGZGzwD3MONXzsq3nYJte5/mM2kY+5k57vOO9qMBu7MKb
2X7z9r/gI1L0mMZjeBKnosr/ohsNep3AYb1avZ9aLtbjOxdyLxdxh577nXuP
GhyVq0eB/c3Olel1YqGZPOPXvIgj/I0b3OUm//Y72mR/u/xxvW7I7bJ3jqt5
G7er2cIVaLJezGVqy51Zy6flxutxiufYK5X7D7AqomI=
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0ltozmEcwPGfeJFlpuzgbOwNs5PDXmOEXC6UG9KU5JAwNVqpleQQiguU
mkQ25l1rkhHbkNOFK4fChbgQWWMLF7aEfHbx7fs8v+d5fof/++Zv3rO2ZkhE
9GLp5Ij66REzkxGVEyNKeLnYsvyIQutZOOG8itt45eyIm7zTnaNi1d5c4i6x
vWI93GR/GXXOPvNuufq4lvd5v2Z+RGpaxC+xjGI1F0SUYsusiO7SiCXWS9Fj
fTYV0S7vIWfnF0bs8q7B+xq+wBflG+esDo1TIz7wCHVy+R2y8cz7VfL98KaK
f/JqruVGOZpwoDDiIN6PNxP2F+iHk97nyDeHC5Ew00h9jcJR94dzAqNRNy/i
jh4e6uku19t/VPsE37M/wl18jG9PiDhcpCZmlJjfnGVIWq+eFDGdd/NwfT7S
51X3riGNlD46ytVAq/0t+dox0be/zw9wXfwGnqpT4f4T7nS/TazTeQdq5e81
ex8yxbNw0r2/MyNO8Un3x4nluZuL0dYZGPCbjdVrsfe/rYu4n3dymb438D/7
as7X/wKxq3P1j/Sg50S0YJsam9TayuvVaha74rwJDd4O6Ouu2UvVnIt5SJjl
jLunUW5/xvcsHuzN7F/VeetdSrwCi9Dsd7yGN+JfnL/mbl4hNuD/9EL+bD2+
5BzO5CnqZvEkHsOT+ZMe++T7jld+94Qcw7BDr/1lavivLBb/NiNi+5SI5/4z
f8SHepd2ts5Z2v6R7/YYzdbH3WvlFlSaYTH+qDXWjOfMNYoL9LvRbEnO0/NC
ef8DuZaYJQ==
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwVk11Ik1Ech39CkcmCLnSiZm7m1+bW/MisYBJd+zlBb7zqwkChiBrWTFAx
QxLxQqhQL9SCUoy2IepE8KPoqkjdjYTgMpOZEUEaJorPe/HwnPec//mf33n3
znrzjud2jKQIWFKkszmSFSdmSHXpkhknQCzzD69Ip/GMRRrLk0K4lrmDQmmc
5w+XpffwmnEPuO3SklX6DMnZUv156ecF6Srz23gwSQozXoGv1C/hXw5pBzaS
pU3OTaH3Fj7DWRs4/pL0Dfew9y/8uCj56b98Tuqlp4O9TthmPgp99LEVSHbI
AQfkQm+atE/v/xAD/2APGug9lC8Nwzx5SqkbYTxG9lFcznNssVSGT2F3kVTD
Gem8hwLOs+JCfOiU8rEL3LDL8x746WkiXxx0sy+BLJ30isdPsBl34N9kmeLO
O3gSr3JWFdmmWF9hfRKH8TRexnN4HmahmloPLNDfz3MA3sEX6oL4k5Gd97hI
35M4Qu06lJDTYtwBXpCznYytMEGfTiOfkQ2eQhdEUiUfboY5m9SEG/lNPpKz
Hq9DF30eQwt3fwQn+LaaWW8xvit+Nx9+AEH2B+AV9/WSawjfxwPk6uabe853
9QyOXFIlmStgn7GZtZfcZw0PYy+uZt9b7MGOLKmfXhNkvcVcEEfZl838d9ZN
ZMqjVxzezaQ3teVwjyx3yddP/R/mfeQOYy8ewVH+G4N4AEKM2/AMbqA+gK+z
/wa8YZzIewiBjZoSerqwE67RKwNnQRN1JuqPAZSSmvI=
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0ltoz3EYx/Fn+2+s2BzGxea0YQdjc9xBNsWNohjlhppyuNBEIRna1FyI
loQ2Vi5cOMxhi2Ir5VRiRuZ0paawLEuIKxOvXXx6/57vc/5+f7mbd63bmRQR
3TQxKyJ9VsS+6RF5eRGLJ0XkYBWWYhktz40YLyaTLotbhm24fUpENd9hMfXU
5awVv2CtmEF8y35Ndep9x9/OzsmrKYzYRL+cpRVH/MQf2RHFiyLy8yMKqTwn
YjaO4y/CPeLXOmvHu7gXVy6IWEW1vjPUHkOf+f7MjfhLz/RaMSeiBy8sjEia
F/Hcd8PMiBfD86t7Z3LEBHt04iHnCbPW63kFjxRFHKVjtM1dPea/Z7cn+EF+
Nzbq/xSvlroX2loWcQ3r9W2gFrmt9FH+DuoVm2LPV9gzLeIdtqvxBh+4gzUz
7Meuxl7+82a7ze6Xu5tOi/tqlzPDvfnPYiZ/Mx6XP1LPNOrQ8xYNytlP/+wU
JRFDmMCcCrPSFlovb4mZK+nSfHen3hC1TTWnO3tN99V6SI+oUb1kMyS768AE
JvCEeVIxlV0gPwVT2KfULzHTSTv1u9eLZu2w101qUusTe5T7XO0dR2M/u88s
deURB+kAZavz3hzXzTSg1g3sY481zzd1B7xlhjfMKvDG6r6kSr4mMV3epEKN
ThyhR4s5q9Qod9ZstqVyWobprGb4H+XfiOliN+B/m2qFEQ==
              "]], 
             LineBox[{6764, 13670, 13908, 13907, 7309, 14013, 14014, 14010, 
              14012, 14011}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7855, 10083, 7975, 14276, 8349, 14274, 8348, 14275, 
              10192, 7956, 10183, 8343, 12626, 7958, 11074, 11075, 11076, 
              10184, 11073, 11072}], LineBox[CompressedData["
1:eJwV0l1oDXAYBvB3szot5rBd7QvzNWOz2bHNxykREheLopRSyoVdEEqSSORK
blbLhlwpnYNMUi6U0siVaWfysa3W0pSttKHYwu9cPD3v+7yf/7d/zZET+44X
RMQLqFoRcXppRFl5RFFdxFn2xuqIGnq6MqINb+dvrYlYKJ4V30TbL3YZX4F2
sYv4pR71MCYnjTvkf2N3qv+B++VM4wl8aFXEJE4toeFEQ0Qx1IpPVUTMZ28Q
+708opQ9TatbGXFK3X14AKPivfgRpNkL1O6oj7gld936iD+NET0tEbN4Jz2a
Iv6xC/EcuKB3u57PqiJ20QfWROSgQZ9zZt7zxvf8DL7Er/DOUnmVeEJNh9pJ
XJHX4LwZ3/lV7KOtEdX4proeeKpHd95ebT94aL8B83/Kb7H/LzzIv6vH3mUR
z/O3p9826w6cdM8u8T55s7URr/AN/jXvK1bzWu+EmW/U9bEfm/EEes0pWBvR
KH+G3oQL+TPNEX/hTJu7uN0HPT7DkNsd1r/ffd7BEG0Q56DZHrvttAfeqhkR
G5ZfxB/BGfvk9MviLC0DA+Zd954v9jrgruO4k5/Sa7P7lPgbY/qMw6ge5amI
j2Z9gq+0ETwMSW+ZVLdtEd3dS/Qts2cST9GP0RPmdS12N+9Kq90i3sq+KpYU
6xZL0+ax58JB+/wH/9uA7g==
              "]]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{6558, 9907, 9963, 9964, 7957, 9966, 9965, 6706, 14333, 
              14334, 13362, 13364, 13363, 7788, 10384, 10385, 8316, 10971, 
              10972, 6661, 6571}], LineBox[CompressedData["
1:eJwV0ktIlHEUBfBrkYvQtCzG0Ryyp6YZOmMaUhAVaETQUKuohbsieiFRSCVG
ixY9cGVU0KbAthltKoqgokWtRi0pwh4KQmmEDUTZr8Xh3HMf597vz1fdeTR7
pCAinsBgMmJ+RUTbmojzqYgFNREXcKYpohnSsKFFDCk931dElOJpvBgvgqKl
EeOrIybktphNpCPKYbI+4kNzxBj/UfWP+IvcGBSrF0FVZUSeRwr3md+7POIK
vgQDK91kvhdy9o/AMAzBgdaI/VDIY8DNl8X3l0U8FQ/iLJ9KnrPuL6Df25nj
MwTtet7Rb2EYXquXZSL6fcfXajfCDbsb6RT+URXxah3wm6f/JX5OP/uf0zNH
rgBm6yJe0EMNEWt53FV/rPeW2kN8h/6tXu62BKTd8YseseOTHTt98wN9U3SC
3kF3QHJ9xD1vd4bPKSijF0LSjnM8eyBndzfu8n2ncT3/bjPfGiOOyzV4n2N4
Cd8e/nk+E+odfMbxT3oG2mHK/df13pSfFl8T98M2tUfe6q83b8OH3b8Z13q7
TbjU3hLI86+wZ7e+YrrGLTNyf/h1msnoLXF7E95HT67yxnre4KvmDqn14c9y
B2v9L7jOf7pdnFW7qG8X7sV7vFcr3gi39W01lxGfFZ/0bS10oblW3CU3V3wC
V+lplvsH34V+lw==
              "]]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{7750, 12394, 7751, 12395, 7713, 12392, 7749, 10772, 
              10773, 10774, 7955, 13428, 13429, 10182, 10181, 7787, 13410, 
              7786, 10017, 8443, 10387, 10386, 8315, 10018, 12435, 7791}], 
             LineBox[CompressedData["
1:eJwV0slL1WEUxvFjE03euxH1pmaOZWWW1hWCWrUqCArKVTZtMpowzQjbNVAt
on+gNsmtbQRtmigXBeUiCCu0DNTShhukhJTa5y6+PO85z3nPe97396s4dHL3
ibyIeIS8uohTlRHpsojyGloS0dUQcRbzeZ20A+fVNPFv0y3yGXpG3IEWe67R
43rsqojYxh/hX5dr572hN3htvD7rV6mIrdjZCLpvVUSCd5AewL9lEZPVEX9Q
pU/K3gnrEnqE35arEf/FhNqj4oHmiEFMN7nUxohZOlQakV0X8ROtab2xH9/F
k2v1x3Z3K9T3h15T4iwtEGc3uFu5PG3fFHEavfZ1O6/T+rn1uzURT+ljLHTP
hF5JdOlzDvfUNovv00L3KNa3T/9p3gx2VEUcq43ol2sw73va68yU2pv8h/bV
299TH/HAmRl6S/4uvYM6b/bW2f2YMctc3hV7Poqf8a/mZqbz5F/SFyhaH1Hm
nGK5Igyrfe2dxuW/YXi1b4eEPj3qknTMObPmqhZX4rJcjTeuxdAKb+D9n2CB
9RKz/zbLRTVf3elS7luKW+S79ZhaGVGaeyveYvWfczNgFB+8xaCZBzAuXsof
lStQO0K/eK+02cbo4eURv2hSv3zMcU7Gv5Rvvkb/VYJeUPPJ7Jv5i/h77d2D
/244g6Q=
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0ttrz3Ecx/H3VoZt2HnYwc5+O9iBjW1ZU67UCrNwMTe7kIuxJMpWbq2R
f8AhKVPKDTkkh5BcLGVcKBYunMYmQy4m8fhdvHp+3p/36/35vN+f77d8YKj3
QEpEPKGcFRGptRFDFRGl1RFtRRGF2I7DTREjtEg+nfJ4z/PV4kbxuPXekojD
/Dv5x/CKvUF77/CU+CQdlJvEfeURr3AQ96vvcs7Wtc5ZFbHE3iUsSkT8WRlR
XBlRQhXOOcNbhofqIn5WRcxT77qIjrKI3eo7cYf4svo+3CTut9+dzDdE7KKb
aqaKI27ja5xtjLhhnavXbe7cTjPirzTt/m/JdYs9mlc/h9/pntqHah/Qy/qI
O+L71gvNmOWtvoiP8B+lEUpzfr7eC+XycM65P+gp/ZOfwFn3Neu7Ur+NWIUt
+Mg858zxGM/yXm/TMzU4666aW9b11hfkElhD2fp4rp8X9Fd/ITfK2yk3hifU
dFin2e9fH7GHpnjzxQX0wXrSDNXJM6mWTiffpNndpRF1ybfEGfEzvs++2yfa
4v1axZW8v927ZoN/ot08mGiNaMJj5ujhS/cOmXTVnL94r+G0eUfkU807jAuw
jyfD/mL5TN8+A5eJu92fjwWUTbmUQ+9rIj76Zy76r9r431oP8E7ob+nqiBTz
j8u1y2Xpc7m9Cj134RuezTjKnyd3HP8DcPV6IQ==
              "]], 
             LineBox[{6545, 9879, 13186, 13187, 12393, 13190, 13189, 7712, 
              12390, 12391, 10771, 12388, 12387, 9157, 9967, 10446, 8441, 
              10467, 8442, 13412, 13413, 13411, 13838, 13837, 7188, 14396, 
              11753, 14395, 11754, 10818, 14015, 13520}]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0ktIVVEUxvFlRqJCKYGPXnbvVW8+MjimBkKPW8MrvZBIB0XlqKgEJ0FN
amCTomhoZtYoclgRNojIMONOogZZlIQjCwxqUtagn4M/315rr2/tdfY+qRPn
Dp0tiogptG2MqGqIqMTSlog/GExHJPI1cl3rIy5ui+gWlzRFlKIcY2q66Tgd
sJdPRZyigzwTcsP0Kuasr9Hz+kzTIfqBzuI0zxk9DiQRBzEnl2+N6EEDX//W
iMZlP0+KjqgdxR0MNUfsr404yvewLuIInaB99AE9Ro+jH3u7InK4vy6iMxNx
j/Y642l9xJcNEY/pI3xDuj2ienPED74amhH/1S/nXuY7rPlq5evlZ1sirvA8
02OYTtLLNDHrC7og3sX3nb4Sz/BOo8p9nux0hnyN9SLN0x4U1P1Tk+jfjnAH
C85dNHOiV9539GDUfHcxhiX+Zt4mjPP+FmetK9zb+zazm+el3G7+KXrLGe/U
vUWfOfoxI/9J7Wv6mX5EwfqnGX6hXm0jsijW56aZbqBFfN39pM2RsU7p3c63
Qk1C68RP3FfvDverT3Z7xCX1Lb6hFWV8pbggt4qWoAgrUYzDZi/jG/HW5d58
0vvt3BTx3L9Tsfw28rex2t5Xe/ON6p1bmY14o6aALntrzDHAVy2fst9BM3Qf
XWsvR/fgP9ord6w=
              "]], 
             LineBox[{7714, 12357, 7715, 12358, 7686, 13188, 8285, 10745, 
              10746, 10747, 9906, 10770, 10769, 9154, 7748, 9158, 12389, 9156,
               9968, 7754, 10447, 7755, 9969, 7187, 12433, 7789, 10817, 12432,
               12431, 9212, 10022}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{6407, 8799, 6406, 14039, 7884, 12554, 7885, 12630, 
              12631, 14061, 14060, 7962, 14246, 14247, 14244, 8322, 14245, 
              8352, 13267, 8353, 8324, 14426, 8323, 6679}], 
             LineBox[CompressedData["
1:eJwV0UtIlFEUwPHTqjf0Bi11Rkcr0cy0DGlR24QeQkHmtIhoWVkEtRAqekBk
pUS7omDa2jYXmdlDWxXVQsfRLJCoRTipED2g3yz+/L9z7jnn3vvd5NGTrSfm
RcRzLCuK+LUhIo+6koiOuohqPsP1/Ed+M58Wny2POM/N4saNETu4U7x/rfVK
PWhJRpziQXOrkdXTzMfVf/bdpWe4UKtnjL/K3ZErsk8xJuR210Tk+H5xRMp6
W21EO/bI39SX9v1Yz4EtEQeRqoqoQEZ9woxH3Kb2EI5YTxfqfDdVRNzT35eK
GF9nX2fNOdthTKv5Wxbxg/9xnn/zDM/iJzqa3A2d5r/eFDGEV3iDYTw1c+/6
iH24Yo/LuIh6dxjgQXw38yV/NO8Fvy3McraG7Wbw3eqI1f7pSvEqbkFNQ0Qy
EfFQTznXiofM2cpV4ox8JTeKn5mXMzcnN84PSv1nzpib5V3OcounrN/mOXN6
+Ju4mz/of+cc2+z/nnv1jbrbCD4h6/5jyNtrDrPoMiOhP4kSlKEUPYX3MLO7
YLPS/st1tf1mTvvnl3DVmyxQe43PWev1JiGesXYDT+QXqe/jUW88gn41EzzA
S61NWvsinsRCbzDfPot5Sv6Y+68pxM7RqnYJX5Bbwcux09p/1RqFFQ==
              "]], 
             LineBox[{10717, 10718, 9857, 13177, 8283, 12356, 8284, 13180, 
              7685, 12353, 12354, 10744, 12352, 12351, 9110, 9912, 9913, 9153,
               9914, 7163, 9962, 7165, 12400, 12401, 10778, 10779, 6560, 9209,
               13519, 13518, 10816, 7790, 12434, 7191, 10024, 7795, 8663, 
              10821}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{6573, 10822, 8662, 10023, 8660, 10020, 7190, 12405, 
              12406, 10815, 12404, 12403, 9162, 12396, 12397, 10777, 7752, 
              12398, 7164, 9915, 7719, 9152, 7718, 9111, 7145, 12355, 7711, 
              10743, 13504, 6544, 9878, 6532, 10716, 10715, 13179, 13178, 
              7668, 12329, 12330, 12328, 13994, 13993}], 
             LineBox[CompressedData["
1:eJwV0l1Mz2EUwPFjjLhgXrrQq/IWGpaS2cTGjRlRLlxYpo0LJu6MMWszW+rC
ZriJSuvCJl2406oLsV68bKjWWqWWmNgw1GzG53/x3ff3nPOc85zn9/tllZ8t
qZgVEe+Qkx6xcHXEmeyIRcsjKvMjfuRElG2JOIpc+eNcjr/i/7DYvhQ1OXzD
/q3rIh5tiniI0tSIC3IXsT8rokhuJwb1P8FDXKPnSblq7rRvUqyfB9CUGTHM
e3Mj9iF9TURdSsTdgohi6xIcRL3YYW7ge3KjhREjaF8RcXVbRKY5j3EGj2VE
PDF/ldy8DRF/zNy6Sk1aRP7KiFozv1yrD2+37jLXdF7EDPqc0Y8+5zTYU6vf
dbXV2ON5N+abv2djRC+G9B/BKK7Z07454rbz31vf4Q7rpe7+Vu8pd+3Vu9v8
PdihVxG+ip92ly98yR265F45P99zp/15/IxvrdcTS6yXIRmnfJNm9zuSqFN/
QJ9uvu+859zEvdzIPVyceGd6D1t/tx7iUYygzrxPzduJRuc04YP+5zAp/xET
+K3uE//kz4n3xhX6TvNlc7ww/xtnFHp+Ze4Cfs3N+rVgSr/zqPO+vvlO9VyT
mJnT9GvgbPuzUOYbPDBXqnib2g5Uqh30b1X5djf9L+O+47R9zd5zC37JtcrN
iA/It4kN8yg6xHfpN8xj1kn+iblqkzAhNpvHOZkXmOOxsw45c47nK4k6vZIS
/6JYKf4DgaieuA==
              "]], 
             LineBox[{9578, 8847, 9469, 14472, 9470, 10390, 10389, 7454, 9471,
               7821, 12465, 7822, 12466, 7452, 13941, 7453, 12111, 6946, 
              12114, 12115, 10470, 12113, 12112}]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV0ktIlVEUhuGVYFFEBU3U9BztqllpeTsRhUK3QQ6yQVBUVIRBYFBQg2hg
I7tQUQQOminkxJnaIDErNEjtGEiZHS+HHEeDKCSRngYv395rrf3t9a/9l1y4
2tSyLCLGsCY/4mdpxJWNEWVFEeu2RFRtiDhVFXGoOOKX3EG6XvyMWLmai/Sw
2KLcEqIsIl/+UXXEQ9TYn1fXXRHRxOuWXAf/ZrEv9DK9LdYiN0SHcakk4h0d
0c8+5G2KOEbbeTXusUa3c4mtEc9rIvbXRXQlIw7QJrnjOyJOYKbWOhUxSxvk
6jFnnUXebn0itzxiOZIFEUf5FdPT4gl+Ne5N0r00hUb5azyu47d7luQW6Hwi
4pU53DOHVbz++u5FtG2OuIvXhRFT4hlMo1nspr5vIGs/KD+6KyLHDD7z+8H3
g/5HMa6f6W0RX/lPYRIZfEOuGTzdGfEMPc628uql7fazci94daGDTycGefXw
6kUfZvWx4O5q71bgLebUZjGmdkRvn9SfVJc2r3G8rfQ+GEKpN2pwbq376p2d
cGZC/Uv1NeZXi2qkUIcV+unX1wCGnanQ63v6xr6SV6de0no5wquQVxHum8OY
u7rMN2Gftv6ISf9Bm/d44j0eI8unm87TB+IJ9X30j31afBwD9mO0n2Zohs7g
nNrv9CzN0Xv4hk7/WvV2/4WeVosl/8+IZvSZonfUrpRrpf8AL5GNqA==
              "]], 
             LineBox[{10025, 9975, 10019, 7792, 8661, 7793, 10021, 7189, 
              12407, 9211, 10782, 8644, 7759, 9973, 7167, 12399, 7753, 10776, 
              13510, 6559, 9155, 6546, 10748, 8629, 8627, 9909, 7144, 12338, 
              12339, 10742, 7689, 12335, 9071, 12327, 7683, 10714, 7684, 9856,
               9855, 10700, 10699, 10698, 8281, 13176, 7657, 12316, 7669, 
              12315, 13992, 13991}], 
             LineBox[{12122, 12123, 10474, 7457, 12124, 6947, 8800, 10471, 
              10469, 7455, 12116, 8504, 12119, 7456, 12110, 12118, 12117, 
              8849, 6432, 10534, 8848, 6981, 9472, 6980, 12171, 12172, 10535, 
              13444}]}, 
            {GrayLevel[0], Opacity[0.4], 
             LineBox[{6411, 8803, 6410, 11547, 11549, 11545, 6949, 11546, 
              13433, 10473, 7458, 12125, 8505, 9477, 6948, 8801, 9474, 9473, 
              6583, 6408, 13432, 10472, 12121, 12120, 6982, 12169, 12170, 
              12168, 13949, 13948, 6589, 6433, 13443, 13951, 13950, 13954, 
              13953, 13952, 14410, 14409, 13784, 13783, 14200, 14199, 6906}], 
             LineBox[{7658, 12307, 7659, 12308, 7652, 13174, 8280, 10690, 
              10691, 9842, 7656, 12314, 7667, 10697, 12313, 12312, 9055, 9859,
               9067, 9069, 9877, 9876, 7125, 12336, 12337, 10722, 10723, 
              10724, 9108, 9109, 7717, 8628, 7716, 9908, 9116, 12359, 12360, 
              10775, 12362, 12361, 7166, 9971, 8641, 9972, 8643, 10783, 6562, 
              9210, 6572, 13521, 10820, 7794, 12436, 7762, 12442, 7797, 10826,
               13524}], LineBox[CompressedData["
1:eJwV0ktIlGEUxvFTGShKggXh6GhTatpo6phjWuAuaFHYBTKKbhS10GZZi8CI
dhVWSEIQREHkZVGLaBFWRESR27SiRHRZUiQtEpR+Lv4877mf732/1Knc/vMr
IuItCqojzm6MKCqNqG6IqEEV6lCLy9si+tAjp7ksolh+hh5uiTiC+dqIbnoI
JWLH6Qk01kWcoafRkowYbowYQRv/EH2MB3peUHMRE86XaK/eb2iOfqTjy/ul
oO4c1m+KGKSldFTfK2IjtKwmImmXcnS2RRzIRBzE92zEN0xXRCSaI97J3S03
Px1xlD3Df39zxB72XqSrIv6qq6ezYnP6F/CnEhFjfEvuYhGFfEn15Rgoj3gp
tso35OGG83WknXvs0otPen7GJHZU2su9TKFPn9ZWs/XPupPb7jzLHli+e7FB
egdFTRFd+uzDIz2GMYQFOzbZoRlp+WvUFmPK/C/iv8yq5/9Nv7IX5c/SefYx
NX/oDLvTrjm9/7F/sOfwE0vy2+V1oEGfEr1r7brdri/stZY9RreKvaav0OjO
Hpq/zhveo7v0TtRH9Kvrcr5J+9VV8iXMKMVKc65601veZlrdKJ2l1/ieOj/B
M+fn2Cl3jHbQcf4F/+5dTPBNYrX3zMN7e3xAyxY+e5yUX8hf4b0ydANtp/li
bTSL/98Revc=
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwNkL1LgmEUR09To9Wm0YdofiYERTm4NQV9UIFLCNHkEAU5OOVQ/QFGpS8S
FNnfkGPUUkHQ0qy01NDWlFOd4XDufe7v8rzvE93Z39gbADalHIZcHN4W4HMW
viRiHZbyBMTnoDcJMd3Vx1k4km4SCs6rKZiKwtU81PJQNFN399p+1X5Nbqzb
civDMzAiQxKSYgwqCdjSJalZH8rrKGzb/47Bru7rE8/fPc+5NzgOH2mYts7K
gZlL54FuScf6Tr7N3+u0+Y7f+ecOGXg28+Q/vegVZ4/OlvWP2Qep+w6nsmj2
XJ/JuvOmdwWy5HlDX0jffMb3+AflFTlv
              "]], LineBox[CompressedData["
1:eJwV0klsjVEYxvHXkKI2pObb6Ro6Ua0qqqwkZWGmFsZWg9ho2VhQEqGCqkYX
BEEkGkOUpDYWNJqwIaxEzBIrU0IkrYqhfnfx/57zzud85yTrGlbVD4iIkT6d
4yOGTIiYkR+xN9t6ckQjHURXFEUMpOlitXyvJ4lnKmSn0Wd5Ec/xgn+o3GH4
pd9jvrvJiHlqbondRDP/D1wVu45jfAnxJnoQrXz9+h7JiVg2MeIoXUlPzIpY
ThPTIsajyvqp2RfsKyMRUTg9oppdOjXihnXZ7IgO2sk3c4a96tOlrt+sMvYH
9pc5EV/xEZ/xCZUFEZPE8s1LVEQU0G7++yiyLsRu/qSc72ZMpDX6fbZez78B
9+R2oS3X+ekINSOx01534Y89nLOX37RE7W3nPcs+g1Po1vNcWUS7s1xGvXMs
1H8RqnCKvYCepu3O1+8f/8MbfY6ya8xoVfdH/C9q9KzFNfe7XSxhZg9/Lzby
X7K34dbz1eboO49m03Xysuzlm/UFvS+iyv08yHI28x7SUnc2Vl4JXepezxZG
HBJLyjtAM2mz+3kyxZ7kj5J3gj5iv3WHj0si3qXume8FrVFfi3rxSjoXFWiY
yYdyeVfUbErN5j9eHtGC82p/urte9KBYfKe8crPrxfLY81NvEcP1Lk35xRuQ
XxyxX4/t8qbzp4sX023sffxJ8ansHFpEc2kj/1bxAvZQ+fl0C3svf6Z4nb6b
UWlemnieeJ34YOtBuONfDcMe+V9Tb87+NslfJK+VVrNb6Gp60P/vkntYbhMO
sdfwH6ZNWOLNLUaGuTlmtFj/ctc79O2jx9jZ/M202j9bgzZ9TqJRnzHe6Vqx
0fS1t/AKL5Eu1qD/e+90HK30LnrV/EQfjrA7UKB2hzn/AZucp9Y=
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV1GtM13UUx/HDqpUOWiVWolByETDUULut3KLssszcWmJjgNykIAFL60nT
OVtPqrkpkEpaQmllLrCoTZGUViGlZrJyZQ9MumwpWSl0v7z+D958/ufyPed8
Lz8mVzXd35gUEWv8WZkR0ZIXsYrOyo04Pjli27UR2zFzasQC7JoQkZQdMUb8
y6yIr1AmP4l9waSIz6eAbw5fNx1kH0WPWofp6MSILv6z+RHn8It6r/PvFE+z
ZpXYSqzmP4N5mRH/qj2fJpktkKbGyekRQyjANziBuXJyaR52mPXANeI3RvTT
5WkRA3Toqoh9BRG910W8hxG1e9l78elMtcRv0mM/e8CaM+I/40H+3dbX8RWz
62kPew8WiX1YGHGh/pvVeJ+92fq31e9GoXob2RvQir6rI86bHfGq81pq1iY8
43dDYg/XR9yOImxVux0dqHDm2fZSSTvVL6dlqMXv1v2B3/AX/sRJ9cr1ekn/
rbjDmb5m5mrz1WCsnCpaiRLnfBxz3cM693AXvRNtzrnQuk3u6Sn+N9MjMvmf
47+CXonLxVvFx9GBnIivncHAjIiPUcl/iB5ElbXLZkXca+8l/PNoA3uiNdvE
S8UL+cvodvYCPVLFxuMFNdswxYwbaUribTjTOWbKlV/PV4el1jXgEdSj3BuY
oU7WtIgceXV8Dyd68RfwZ/I/xF6CWtSgGiXi+eIZ4hXsxdit5096DqNVr2z1
mul6TDV3Pk6JFfOvk3+P2Z6nG7AWrWjBoPzZahXLz0MXXyd6fGPN3v9CZ1Lk
bFL1Ho9Rd9ao7ghN92YyMAnH5LzD352Y6QZ7QC32uev96MNHcsbI7adj6RLa
JqeGrvaWhvi+xZHE3eMzb+E7b+sI/Z7eovbNOKj3D+wP1Gz0Ls+3xybr/2a3
OKd/aCutNe9pezmFZO8rBcmJN0wnyM9Up8PvTv0PmaOLHqalal9Gy+kltIxe
SitpKl1Mx9EK+rJvrwNd7Get76RvYRfavfkifW7Dreg0039m66JbzP0idtjv
G9iJKt9OdeK7cldZWOv3xXLP+ZZH8Cse1/MsbfDWH/DG29VYSB9lL0Of/EXs
086klA7TFfyf8K9J/L9jv6L2sPN9Eo1ynqZ79D/h/i9y59Pd/TH5y8WS2Zto
Ct1i/Y/8e2kv3lVnxNpm9CdmoQfUSfde75P/mDrT6HpvqMrZZPFnIwej1g/K
PYq72SsSfeQX03b6BJ3P/4X4/wXTBDY=
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV02tM1XUcx/Gva922tOHWA5U7kgYc5K49yMXWddHW2txqmG4iwoGCcm1p
LWg+CGvVmoeMM5TyqGhiirWymgnhiq52U9q0ori0HtTySetJSS8evM/n9/ve
ft/f9/z+BZs67+9YEBHzP0/kRiRWRFwuiuiviNiDhpKIAboX6/j7qiPSuJN9
N30FYzdGbOPfjkL2p+iTKBP/PP/G/Ihs9g20x36f+hms5B+g/93kTPRbP7sk
Ytb6SEHEYaTVnlgWkateHib5/s2JaBJ7lj2H7R/7s+xv1ThX/ga+x+nvOOzc
QYyKHU5EFDu/e3XEM+hUuwPdSyPWFkZ00enSiCn8hllsr3U3rF0TMWNfUOeO
KEI+dpVHpJDJlms/gynMutsBszyiZp39Fv5a2kwXi7+VZtF6eoAexH4cs7/e
OYuwELfYL2KfU6dyVcQV7nqmLKLKukJPX7BXW5/R4xiS7tWGVrRgJi/i5MqI
9zBh/jfLuSSn3hxOmd05uefxPV7SX0b9F2mpWU6JL6HTtIx+TB+hHegy727c
bsZjao8Wq2WG5zFifRotZt6nbhqlYnvkFYofQY8zduJlvhR24S7xV8u7m/aq
s1P8cyjxv5Wi0f+YoBfYymiROqtoBR7iq6IX+Srpcr4aWouNfKvpj3x182+A
b7f6r2Kh867Dvc5M25frcw9tNId29vvY28yqHVV81Vgh/2G+NbRPzUa2T/U/
jiZ5X9NvsIm9CZuR5U320hRusH5D3DK6FHneYD4S1mnn1Vv303toA1K+gxPy
mqsi3vR/LnBmlh4X45j9bfIGxY8sjzhEr/G/XosP5ZxGi7xWNHs3B72RQRT6
z1rtW7AFw+rc4b0kxbVhwNsr9lZeoynz68WU+yZR7ZwajMqpo7XY7E1drDRj
XMDP+Al7fQcf6WWAvq7GPmRw3B1+4e9UY5I+Sn+lHXSabqW5+nmMbtNHUs9b
nZGwnuL/RF8f+C+v9IauwvvWQ+oexbDaCd/MA76dUvogLadLzGa9b/KQXhrM
7pTYH8xnYv4tm+Ek/5B5D5n3cZojbgd7Nj1K/+b/jP1zvG0/Tk/Qb+k5Wqle
Bb6zXi9nXJ058/pKP1/iHX2exLt4wUz+0vMl5Oivjf+y7ytJ52g7zbj/oHfX
Zb/f+mm6w/3/4Ptz/i2rX4v/AcfP9JI=
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwV1F9M11UYx/EHbf0RyTaLKfAT6A/yR8G0Elerrbb+gLhSXEhtbVmChlk3
kqQmtZhAKS4tKw3SH1ErKcWbaiupRKMsrWzCheuCausfq4tGW2mv78Wbz3k+
5znPec75nh+FD65b+mhGRDT7897MiJHrIpaURjwxi3l1xPmrIspmR8zBSGHE
GZQbz8iL6J4X0YNq+aet67d+oiiiRFyM2VhZEPHSgogK9TbKvZsW8j+XP4wj
8ndaN5k3Ce1yt+L33IiPzP1G9+qhx7gbzca76RR13tJLJn2c9xhOlkR8jT5+
L9rknbD+Cvtm44S58VTE4bkRn/L77DdgnF0ZcZBmyfn7Wn3bP0ffRTSXLiuO
WIpfciJmiZ9eGJFPl/Nq8dP1ET9iDCl+q/kC+x+/wTlxDLv1eY97+16N1nI1
sAW73OO43D+Sns3fKi5376f1uV5Pvfo8p26artHndmu65WyjO9CFW8TT6M30
MlrrPlucbUPyHfGitQ1qnbN3lju5FGf0me/+0+6kF3vsPY3f4jyrzD1JG+gk
e05G4GdxBn1GvRr1FuNwRUSn8z2HDryg5k4c10O7eJNzHJSzmQ7QRmv30HvF
c+3bIbczeQfyX+G/inJ1q+St1Pte8Wuok7+AX81/mN/N68EKfmXSS3JG/uu8
fajnL+Iv4a/m7+f9YJ9B+6STmlfyfd+7nKlOH1W0SfyAdUPm2+j9/GfpUfG6
ayK+oh3i5/nfGJ9Ce/K+3Fs2nvINv1O/GqXeYx19V2658SdJ/3Q+quQeEzfS
UXrIXX+c3HVyD/S+OfbGG75Xobk+Ol2/Y77vQ/y09/AO73a1Vqtxh/d2Jx6Z
H7EWTRj33gadp0u93LKIi625BLu8j23uZYrxdppnbgftQqb3f1Y/+XJq7JUy
V4BCvCke8dtoyvfbEX+Gozjg3TSq1YBcPaw1n6J5qPVWlmGNuS/l3mY8oE6/
+sPiLzBdf5vkXk430wl9l/KnWpOFZr+F993BiPkP6Sj9gP4jr97589RcQTe6
hxvlpsQ30SJ9rNLvX97gnyhzX/XJ/zGao+4ie9SYX4yM5H+TGmd9y7Q6vWgV
D3s3W2i/+G16AJVyD9GFdIg/4Ru/jIvkfsu/wPnO84e8hQ732Yk2tGMrGn3j
/5xhPZ0qp5lm0jFnOom0nP1o4P8r7xSvxV7z9F7sTA36LaGNdCZdTmfQX52x
Qs6Fzjeq3gZr9qkzyD+C/wFIdfB3
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1FtM13UYx/EH8abQ2rrQcVQxSfhzyEox5KSJcsotsBBbBVpWaifLm8oO
F66NnOZasHRNpys3bGuxznqjqUGlrZtEnDbXSkwlNLdMlvX6rYv3//N9Dt/n
+3wPv/+0Fc+0PJ0WEWv9fFEW0YfXciM+oxOnR7xeyEYbdvP/xP/ytIh/yyM2
0HfvitgyJ2Ir3sL4VEQ6crMiCvMj8ujfcrLEMpGLHGSjSV7V3IhmOk+9SnTP
jujBdvPeuy1iSN5JTJoV8ZTcnTkRLewd7HHy09Es/148Ys5v5jQZN6IB9VMi
0uS8bV4/HUA1fw2WyT8jv53OZ9diTO1ryV70lHlrRCpZT04RPVYa8QN+F3tR
7nn6gNw2HBA/KnaWbxg5U+3/Tmendpm+Zxqf47+q77/wq7PsK9Evven2iIPZ
EesLInY509044ry/Qac7WIExeR/wX6Mb5T3O10VfoOux3XgbTqhTrt7NeXox
fxjnsEPOTqT404rshzbJ22XOm3rr0O9U/k66iV0q/or4UlrA30o3sA/JP4xl
7BR/MUrwj9ofZUYcd9fn7SvTeQzyZ9EL7EH+izSbPcSfQ0fYrc5iKSa7pzrn
k+dcr6v/oPqrzCmVW4bran/inNv5N+pjOX2Dpqvzo7XvZi9nd6IDXzmrfnWu
OI9e8cvOoEuN79X6DgMYlHcck81dYM+jci7hJfmbzW3UV4a+vpQ7gTax35fb
QG9kL6A30MfoDNqWvGN1LtjDXHd+kVawR+gf3kGfd1TFrkYlalGTrJvEUeD9
tNrPLPtsoYvVWOx7q6e3uPfn6Do8i0X8+4rdJf+YvVao3+Ftn9LH0TsiTtNj
dFS/B62x1b3m6y/DOgvNr8Ma66zFakwRe5LmJd+uPkqNS5BKeuErpvnm3mec
LV7ILsJM9LL34mM9X9LLKD6012Z2uj7HYxx+Ye/3TZ2hS8SvmPMnLmNYvyP6
/1afh61zBBPcfz87gw7QifR+ut8d7TFe6T73GbfTIWyxbq17q0GPe0+5x+7k
/4u/1zll8Xfxn9XLHvbm5LtQp9HcAzO8Ifow30N43pmtS74LeV/LP4R2/p4k
37tdo85q76LBuB7l5tbRn8UX0SfEFtJ7MEeslp4Wm09XidXQaswWq6SnxKro
o2LzaAW6+d5BsXVf1cenelhpL5+X/f9f/R9Jvuqt
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1ElsllUUxvHDQlwYSSBBqCJSCkJRmacNJFBoSRAkLrTMaSmjtAWpGMpQ
OmgxQcsCEF3gAtPGFQQSQKBMijjQUsqMiAZo0ZIoCUS0pYXfGxb/77nn3HPP
Pffc+36puYVvF3SKiGw/ZS9HHBoScQSH0SUtIjMlojw9oiLhpYir/BtSI36j
N3AN1/Ernh8eUfJKRI3YapQhrFnyRkTV2IildO2giM3Gn2Cd8XrsHBbxeLTY
MfYbFZGFuS9GNA2ImEensEsGR2zpZW9aRRvEnsNyc/lYI+5f8cW0kF2ANPN9
ccm5Htg73bob9iuXowLb2f+Yv4c68fW4bP3kgRFXaAP7LP7Hf3jOWVppG3rK
1wNXxWWKv0Yb+c/hA/mK0KofOa/L7Wz1+LJ3xPGhzquGr1Cgt9l6fEqfvker
Pvyt1o6kH2hDOx7hw1cj8sQuxCbjSjSoJ02+DmsarT+P1eav8I/m72K/Zr5R
xiNRbG67uj7H+hERpdiIruLeMj8Db2I6puFr8TvEfoFPxVXhMwwVX2J+IwY5
x7vsW3rRST8vs0v5W0aq2/nKjO+Y+zPpVdJ79l1z7eYqjM/ao6e30EDbnekR
TnlfrbQN9fx1SR3iH2KvPu7DzORM9p1D7zvvN0kedra7SKE11uZ6DznYZfyM
/T+yTyU+RoZzvNaH7WwH1FPCN4u9jX2QfVith3AQ1fKdSfpBJ7uLTEzAJGRg
tbpakK+uDj0Y4lt4TFexi7AC72MlfvROFtgjB7n43feSR/+gzfQObqEJtzG1
n/7SbLyDWZiJ6+Ln0fmYjbmYg9PyL3aWJViE3t55L4zFmAQ1DJezxni3Gqvp
HjpF/7JQYP1CubvLtYi+kNRJLzpnHr1AF9Bu7qgravVlm778IO9Wusqejd79
WvqXuGJ62jdRJ+8w4zN6/Av6yNNkzV1r9ruzFnrUnRzDEWwWU0tTxfXFs/bp
jD3e8xb7fufNZ7jXHe5+HB2PdPUPRIpxN3rbPTShKvk/Et9sXEmL5J0u/yb+
aXQlO79/xEnzP7vHm+7/hHGhu18u/1Rvp8K643zHkM+/jD+Lv5z/KF8t3uNf
yj+Rv5T/W76f5MtLffrf+gQ4tflF
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1O1r11UYx/Frc64/QNP8LXWba865uXsdPdTmz612m7jGyGKFSog3D6zt
ibdMZybkQgQNqYb3oIZgq55MIogW1FJSDNHIvME50HTSdOnrhw/e+5xzXZ9z
nXOu8/0tp2Nty5q0iMj1pzsrYn1hxNWSiN75EZ9h+5yI/ZURjcXG8qvld9Am
8wPin6PZuAVr5JbSv8TepLXTIlrpW1gn12Ndm/FB+Z3qHpoe8be9euiGCjWz
Iz4V34NeTMqPmIxz8ifMB+gof9GsiIXiR2ZH3JoRcaYg4jbNK4t4BbNww9mH
xTZUR6RXRUzA5LkRd8Xy5Ve+7E7mleoleKoTEVXGhbkRUxdEvIQ/Ur6ZERfp
SGofsd3OmKFWJl7ARBydF3EM6fZMwxn33O2eV5w3If66vabYaxoSGDevd4fv
+I67w/e0wfwm/6t5+iD/tfiDnIiHCPGz6v3IV2B9v/E3+EjPks62BNWp+s5S
6B5t1rbjY+fdhWV8C537mthVPOKZYv0isQfWPMQo1upjwttkoc6aEvlMvnty
SfMi89foYtTgsDc46tz7vHOm952ICn1qL4341rnfofPN36ZVdDn9hb+P/x91
b9vnBv3NunR3vm48KDbIE+at/OXWLaOn9PUkDsn9YN9RNfrt0eXMnRjRm2a+
FmSod06dvTxf8vbQYd/PHWxy7o34k/+g3GXaqeYnxrvwgXG2GjkY4h/X+1zj
X/lWyP0kVmj9XHTxd2Kbfn5It9K73mEY/6W+Rb3Pw4j5inK9M67BV/rZhxP8
x7zHgFr/+06eoqMo4j2U+Q6W6EHS3ZK01HxV6jviqaEv0sV0Kv3CXhnq1vpW
m9RtRgtuqv2uPRqNGzDI8zNWW/evXs+m92kBrdPbXlpL99Dz9AJ+x2lv8L5a
O9XowQ5stVelWo/d7QnG5B9ji3iZeAXKUS/2BrZb040x3s083fqY9C5DuOh3
dwkNxc//Bz0D3zu9zw==
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1ElM1lcUxuHjwlbbWNHEAloVIoITg/OEbnQhdmGLH6hdAdrGoZHEhVNT
jXHhjDExRhdOASlqNWrqyM6hpNWkFbCV1kQxRmhVcKbVjc8XFz/ee8957zn/
O3xkVlQWL+8WEVn+lOZGrBgR0ZofUTYpoik94r5x7yERKZiTEbF1eMQ2bEdK
tjU81eMi6sxf8b5E3cCILvoffhQ/gZN4OCiiB28brc2JODsq4hy+Vucb3B4c
8cuYiD/pr/QGruP+xIirepfQFrkE/YveoMfEH4yNOEorxkeUowyl8r3kd42M
yM+KmPmZdXrOoBPyIpbQ8TST9wue7AkROZgtni6eKpaGGvN6dXaqf5FW0Uv0
uFrzkn1Qgg/EuuNNphr0c5wWP4P6/hGn+Lvsu02Pf9COWrX36bUXw/X60nyq
cSEmY6n5FPqtuyg1HmfNPDpC7K49V4gn1J6ix0bjI77tZ30b0Cp/D2vFDpuv
oRt42px/Ozrc23pskSuQ20xH06+GRSzACzWfo0iNPPFZNJf+UeBO7WM6/ZRO
o/2S9+l9PB8Q8QO9pv4p33oaV41T9b1C5/P+5n0942vx1kZbN1esBAk8FW+Q
76S35S9bsyf5vtTs9H468AR9rZvMH3QSTaH/itfzb+Jfw/89vSXWjKE8WWhU
d4t3dpMu5vnOeC3m2G8fe9voDDJom32345GzLZV7TG+J/y//NnnHaDRP16+Z
ptImmkYr9c32BlabH+JbRXeq8bcazWo2oUv8NdYbr8MC5zQfv7vXft5BkTtO
M77jd7TdOZzxvZE8T7rMWe6WW06r+c6rcwE/4RzOos5bK9cvofZcLOHtZm2X
ca1vPMBzEPux0vdV+b5i/sF8NeY7fEMVKpzNQiTEaqw7gnL7WyTWg7cnPsTH
+Ahh34VyU1Fl3OH3/4l4J32CQ9YfRrazz0GN/W1yP/vFZqnbiHt8Jbnv/xe9
Azfry4E=
              "]]}, 
            {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl01tMiHEYx/GnDeNGxzl2FB3lFLK45ULCtNa1zEyZ2JBNmpw2Fy6cl3Kh
sOVwYeTCVJsZhi5iqI0LNo0rnWzu8mkuvvu9z+H/PM//ed83p7Zhx/6EiPiI
+pKI5qKI0eURY+jNiBinyXkRKehjdxVG3EXN/IislRG1NHFdRKbnp/wpxfKx
eEFEKs3OkreGooxvjzrta8WxBJOrNRZLwLX0iAq+SmxBlfyq/IjWzIg37Hd4
i5yciM3q5ulbK+ennF00n13BP2NRxF5ayG7grxZvU2M7u53WZEfUiRexD4hP
iB+kxex6/kF36TR7OfvFwohue+mylzt6j9rBbTpCS2m1meeYfS7mYRvfVswU
3+T8LPpczoh6oxjDJz1er4o4reduOa88/+bPL4sowJGpu9EW9Ypo49Rd6Al2
n331Is09HuizYYVaZvtqzgFzpvKv5yvHS/4v/Pfk3ccz53pwzjs77z000yfs
blxW/xImzXuBXsQj/sdokrc3N+Iw/YVhvh8YUPOmfofc4bvZht3nG02x3ybn
c0p9P0t9D2pu9B3le2+dZryFDiTwBZqcaXH2OD2GD86+x0N1JugfjGIcYyjz
fhP1T8JspCAZ/fIzxNJxdllErpo7zXbGc5L9ptFUXDf3oJla6RBto6fs6iSm
29s0fOa/UeCcmfvpX7X36XHU3I2oVLdHzhVnr6JDrNpuhjDiTnUl//+nf/FO
jR4=
              "]]}, {}, {}}, {InsetBox[
             StyleBox[
              FrameBox["3.63`",
               StripOnInput->False],
              StripOnInput->False,
              FontSize->10,
              FontWeight->Bold], {0.3219260459267357, 0.23833213071341097`},
             Background->GrayLevel[1]], InsetBox[
             StyleBox[
              FrameBox["3.96`",
               StripOnInput->False],
              StripOnInput->False,
              FontSize->10,
              FontWeight->Bold], {0.6661692247733986, 0.2610078521487216},
             Background->GrayLevel[1]], InsetBox[
             StyleBox[
              FrameBox["4.95`",
               StripOnInput->False],
              StripOnInput->False,
              FontSize->10,
              FontWeight->Bold], {0.48214285714285765`, 0.06961697398012712},
             Background->GrayLevel[1]], InsetBox[
             StyleBox[
              FrameBox["8.25`",
               StripOnInput->False],
              StripOnInput->False,
              FontSize->10,
              FontWeight->Bold], {0.8799285258902043, 0.3292857359706507},
             Background->GrayLevel[1]]}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0, 0.5238095238095238}, {1, 0.5238095238095238}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0.006929545158944617, 0.5294939938095239}, {
          0.006929545158944617, 0.5238095238095238}}], 
         LineBox[{{0.03601836602551689, 0.5351784638095238}, {
          0.03601836602551689, 0.5238095238095238}}], 
         LineBox[{{0.06510718689208872, 0.5294939938095239}, {
          0.06510718689208872, 0.5238095238095238}}], 
         LineBox[{{0.094196007758661, 0.5294939938095239}, {0.094196007758661,
           0.5238095238095238}}], 
         LineBox[{{0.12328482862523327`, 0.5294939938095239}, {
          0.12328482862523327`, 0.5238095238095238}}], 
         LineBox[{{0.15237364949180554`, 0.5294939938095239}, {
          0.15237364949180554`, 0.5238095238095238}}], 
         LineBox[{{0.18146247035837781`, 0.5351784638095238}, {
          0.18146247035837781`, 0.5238095238095238}}], 
         LineBox[{{0.2105512912249501, 0.5294939938095239}, {
          0.2105512912249501, 0.5238095238095238}}], 
         LineBox[{{0.23964011209152192`, 0.5294939938095239}, {
          0.23964011209152192`, 0.5238095238095238}}], 
         LineBox[{{0.2687289329580942, 0.5294939938095239}, {
          0.2687289329580942, 0.5238095238095238}}], 
         LineBox[{{0.29781775382466646`, 0.5294939938095239}, {
          0.29781775382466646`, 0.5238095238095238}}], 
         LineBox[{{0.32690657469123874`, 0.5351784638095238}, {
          0.32690657469123874`, 0.5238095238095238}}], 
         LineBox[{{0.355995395557811, 0.5294939938095239}, {0.355995395557811,
           0.5238095238095238}}], 
         LineBox[{{0.38508421642438284`, 0.5294939938095239}, {
          0.38508421642438284`, 0.5238095238095238}}], 
         LineBox[{{0.4141730372909551, 0.5294939938095239}, {
          0.4141730372909551, 0.5238095238095238}}], 
         LineBox[{{0.4432618581575274, 0.5294939938095239}, {
          0.4432618581575274, 0.5238095238095238}}], 
         LineBox[{{0.47235067902409966`, 0.5351784638095238}, {
          0.47235067902409966`, 0.5238095238095238}}], 
         LineBox[{{0.5014394998906719, 0.5294939938095239}, {
          0.5014394998906719, 0.5238095238095238}}], 
         LineBox[{{0.5305283207572442, 0.5294939938095239}, {
          0.5305283207572442, 0.5238095238095238}}], 
         LineBox[{{0.559617141623816, 0.5294939938095239}, {0.559617141623816,
           0.5238095238095238}}], 
         LineBox[{{0.5887059624903883, 0.5294939938095239}, {
          0.5887059624903883, 0.5238095238095238}}], 
         LineBox[{{0.6177947833569606, 0.5351784638095238}, {
          0.6177947833569606, 0.5238095238095238}}], 
         LineBox[{{0.6468836042235329, 0.5294939938095239}, {
          0.6468836042235329, 0.5238095238095238}}], 
         LineBox[{{0.6759724250901051, 0.5294939938095239}, {
          0.6759724250901051, 0.5238095238095238}}], 
         LineBox[{{0.7050612459566774, 0.5294939938095239}, {
          0.7050612459566774, 0.5238095238095238}}], 
         LineBox[{{0.7341500668232492, 0.5294939938095239}, {
          0.7341500668232492, 0.5238095238095238}}], 
         LineBox[{{0.7632388876898215, 0.5351784638095238}, {
          0.7632388876898215, 0.5238095238095238}}], 
         LineBox[{{0.7923277085563938, 0.5294939938095239}, {
          0.7923277085563938, 0.5238095238095238}}], 
         LineBox[{{0.8214165294229661, 0.5294939938095239}, {
          0.8214165294229661, 0.5238095238095238}}], 
         LineBox[{{0.8505053502895383, 0.5294939938095239}, {
          0.8505053502895383, 0.5238095238095238}}], 
         LineBox[{{0.8795941711561106, 0.5294939938095239}, {
          0.8795941711561106, 0.5238095238095238}}], 
         LineBox[{{0.9086829920226824, 0.5351784638095238}, {
          0.9086829920226824, 0.5238095238095238}}], 
         LineBox[{{0.9377718128892547, 0.5294939938095239}, {
          0.9377718128892547, 0.5238095238095238}}], 
         LineBox[{{0.966860633755827, 0.5294939938095239}, {0.966860633755827,
           0.5238095238095238}}], 
         LineBox[{{0.9959494546223993, 0.5294939938095239}, {
          0.9959494546223993, 0.5238095238095238}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0, 0.5238095238095238}, {0, 1}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0.0074814960000000015`, 0.5255102040816313}, {0., 
          0.5255102040816313}}], 
         LineBox[{{0.0074814960000000015`, 0.5425170068027203}, {0., 
          0.5425170068027203}}], 
         LineBox[{{0.0074814960000000015`, 0.5595238095238089}, {0., 
          0.5595238095238089}}], 
         LineBox[{{0.014962992000000003`, 0.5765306122448974}, {0., 
          0.5765306122448974}}], 
         LineBox[{{0.0074814960000000015`, 0.593537414965986}, {0., 
          0.593537414965986}}], 
         LineBox[{{0.0074814960000000015`, 0.6105442176870741}, {0., 
          0.6105442176870741}}], 
         LineBox[{{0.0074814960000000015`, 0.6275510204081631}, {0., 
          0.6275510204081631}}], 
         LineBox[{{0.0074814960000000015`, 0.6445578231292513}, {0., 
          0.6445578231292513}}], 
         LineBox[{{0.014962992000000003`, 0.6615646258503398}, {0., 
          0.6615646258503398}}], 
         LineBox[{{0.0074814960000000015`, 0.6785714285714284}, {0., 
          0.6785714285714284}}], 
         LineBox[{{0.0074814960000000015`, 0.6955782312925165}, {0., 
          0.6955782312925165}}], 
         LineBox[{{0.0074814960000000015`, 0.7125850340136051}, {0., 
          0.7125850340136051}}], 
         LineBox[{{0.0074814960000000015`, 0.7295918367346932}, {0., 
          0.7295918367346932}}], 
         LineBox[{{0.014962992000000003`, 0.7465986394557822}, {0., 
          0.7465986394557822}}], 
         LineBox[{{0.0074814960000000015`, 0.7636054421768708}, {0., 
          0.7636054421768708}}], 
         LineBox[{{0.0074814960000000015`, 0.7806122448979589}, {0., 
          0.7806122448979589}}], 
         LineBox[{{0.0074814960000000015`, 0.7976190476190474}, {0., 
          0.7976190476190474}}], 
         LineBox[{{0.0074814960000000015`, 0.8146258503401356}, {0., 
          0.8146258503401356}}], 
         LineBox[{{0.014962992000000003`, 0.8316326530612241}, {0., 
          0.8316326530612241}}], 
         LineBox[{{0.0074814960000000015`, 0.8486394557823131}, {0., 
          0.8486394557823131}}], 
         LineBox[{{0.0074814960000000015`, 0.8656462585034013}, {0., 
          0.8656462585034013}}], 
         LineBox[{{0.0074814960000000015`, 0.8826530612244898}, {0., 
          0.8826530612244898}}], 
         LineBox[{{0.0074814960000000015`, 0.899659863945578}, {0., 
          0.899659863945578}}], 
         LineBox[{{0.014962992000000003`, 0.9166666666666665}, {0., 
          0.9166666666666665}}], 
         LineBox[{{0.0074814960000000015`, 0.9336734693877551}, {0., 
          0.9336734693877551}}], 
         LineBox[{{0.0074814960000000015`, 0.9506802721088432}, {0., 
          0.9506802721088432}}], 
         LineBox[{{0.0074814960000000015`, 0.9676870748299322}, {0., 
          0.9676870748299322}}], 
         LineBox[{{0.0074814960000000015`, 0.9846938775510199}, {0., 
          0.9846938775510199}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0, 1}, {1, 1}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0.006929545158944617, 0.99431553}, {0.006929545158944617, 
          1.}}], LineBox[{{0.03601836602551689, 0.98863106}, {
          0.03601836602551689, 1.}}], 
         LineBox[{{0.06510718689208872, 0.99431553}, {0.06510718689208872, 
          1.}}], LineBox[{{0.094196007758661, 0.99431553}, {0.094196007758661,
           1.}}], LineBox[{{0.12328482862523327`, 0.99431553}, {
          0.12328482862523327`, 1.}}], 
         LineBox[{{0.15237364949180554`, 0.99431553}, {0.15237364949180554`, 
          1.}}], LineBox[{{0.18146247035837781`, 0.98863106}, {
          0.18146247035837781`, 1.}}], 
         LineBox[{{0.2105512912249501, 0.99431553}, {0.2105512912249501, 
          1.}}], LineBox[{{0.23964011209152192`, 0.99431553}, {
          0.23964011209152192`, 1.}}], 
         LineBox[{{0.2687289329580942, 0.99431553}, {0.2687289329580942, 
          1.}}], LineBox[{{0.29781775382466646`, 0.99431553}, {
          0.29781775382466646`, 1.}}], 
         LineBox[{{0.32690657469123874`, 0.98863106}, {0.32690657469123874`, 
          1.}}], LineBox[{{0.355995395557811, 0.99431553}, {0.355995395557811,
           1.}}], LineBox[{{0.38508421642438284`, 0.99431553}, {
          0.38508421642438284`, 1.}}], 
         LineBox[{{0.4141730372909551, 0.99431553}, {0.4141730372909551, 
          1.}}], LineBox[{{0.4432618581575274, 0.99431553}, {
          0.4432618581575274, 1.}}], 
         LineBox[{{0.47235067902409966`, 0.98863106}, {0.47235067902409966`, 
          1.}}], LineBox[{{0.5014394998906719, 0.99431553}, {
          0.5014394998906719, 1.}}], 
         LineBox[{{0.5305283207572442, 0.99431553}, {0.5305283207572442, 
          1.}}], 
         LineBox[{{0.559617141623816, 0.99431553}, {0.559617141623816, 1.}}], 
         LineBox[{{0.5887059624903883, 0.99431553}, {0.5887059624903883, 
          1.}}], LineBox[{{0.6177947833569606, 0.98863106}, {
          0.6177947833569606, 1.}}], 
         LineBox[{{0.6468836042235329, 0.99431553}, {0.6468836042235329, 
          1.}}], LineBox[{{0.6759724250901051, 0.99431553}, {
          0.6759724250901051, 1.}}], 
         LineBox[{{0.7050612459566774, 0.99431553}, {0.7050612459566774, 
          1.}}], LineBox[{{0.7341500668232492, 0.99431553}, {
          0.7341500668232492, 1.}}], 
         LineBox[{{0.7632388876898215, 0.98863106}, {0.7632388876898215, 
          1.}}], LineBox[{{0.7923277085563938, 0.99431553}, {
          0.7923277085563938, 1.}}], 
         LineBox[{{0.8214165294229661, 0.99431553}, {0.8214165294229661, 
          1.}}], LineBox[{{0.8505053502895383, 0.99431553}, {
          0.8505053502895383, 1.}}], 
         LineBox[{{0.8795941711561106, 0.99431553}, {0.8795941711561106, 
          1.}}], LineBox[{{0.9086829920226824, 0.98863106}, {
          0.9086829920226824, 1.}}], 
         LineBox[{{0.9377718128892547, 0.99431553}, {0.9377718128892547, 
          1.}}], LineBox[{{0.966860633755827, 0.99431553}, {0.966860633755827,
           1.}}], LineBox[{{0.9959494546223993, 0.99431553}, {
          0.9959494546223993, 1.}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{1, 0.5238095238095238}, {1, 1}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0.992518504, 0.5255102040816313}, {1., 
          0.5255102040816313}}], 
         LineBox[{{0.992518504, 0.5425170068027203}, {1., 
          0.5425170068027203}}], 
         LineBox[{{0.992518504, 0.5595238095238089}, {1., 
          0.5595238095238089}}], 
         LineBox[{{0.985037008, 0.5765306122448974}, {1., 
          0.5765306122448974}}], 
         LineBox[{{0.992518504, 0.593537414965986}, {1., 0.593537414965986}}],
          LineBox[{{0.992518504, 0.6105442176870741}, {1., 
          0.6105442176870741}}], 
         LineBox[{{0.992518504, 0.6275510204081631}, {1., 
          0.6275510204081631}}], 
         LineBox[{{0.992518504, 0.6445578231292513}, {1., 
          0.6445578231292513}}], 
         LineBox[{{0.985037008, 0.6615646258503398}, {1., 
          0.6615646258503398}}], 
         LineBox[{{0.992518504, 0.6785714285714284}, {1., 
          0.6785714285714284}}], 
         LineBox[{{0.992518504, 0.6955782312925165}, {1., 
          0.6955782312925165}}], 
         LineBox[{{0.992518504, 0.7125850340136051}, {1., 
          0.7125850340136051}}], 
         LineBox[{{0.992518504, 0.7295918367346932}, {1., 
          0.7295918367346932}}], 
         LineBox[{{0.985037008, 0.7465986394557822}, {1., 
          0.7465986394557822}}], 
         LineBox[{{0.992518504, 0.7636054421768708}, {1., 
          0.7636054421768708}}], 
         LineBox[{{0.992518504, 0.7806122448979589}, {1., 
          0.7806122448979589}}], 
         LineBox[{{0.992518504, 0.7976190476190474}, {1., 
          0.7976190476190474}}], 
         LineBox[{{0.992518504, 0.8146258503401356}, {1., 
          0.8146258503401356}}], 
         LineBox[{{0.985037008, 0.8316326530612241}, {1., 
          0.8316326530612241}}], 
         LineBox[{{0.992518504, 0.8486394557823131}, {1., 
          0.8486394557823131}}], 
         LineBox[{{0.992518504, 0.8656462585034013}, {1., 
          0.8656462585034013}}], 
         LineBox[{{0.992518504, 0.8826530612244898}, {1., 
          0.8826530612244898}}], 
         LineBox[{{0.992518504, 0.899659863945578}, {1., 0.899659863945578}}],
          LineBox[{{0.985037008, 0.9166666666666665}, {1., 
          0.9166666666666665}}], 
         LineBox[{{0.992518504, 0.9336734693877551}, {1., 
          0.9336734693877551}}], 
         LineBox[{{0.992518504, 0.9506802721088432}, {1., 
          0.9506802721088432}}], 
         LineBox[{{0.992518504, 0.9676870748299322}, {1., 
          0.9676870748299322}}], 
         LineBox[{{0.992518504, 0.9846938775510199}, {1., 
          0.9846938775510199}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0, 1.1102230246251565`*^-16}, {
           1, 1.1102230246251565`*^-16}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0.006929545158944617, 0.005684470000000112}, {
          0.006929545158944617, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.03601836602551689, 0.011368940000000114`}, {
          0.03601836602551689, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.06510718689208872, 0.005684470000000112}, {
          0.06510718689208872, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.094196007758661, 0.005684470000000112}, {
          0.094196007758661, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.12328482862523327`, 0.005684470000000112}, {
          0.12328482862523327`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.15237364949180554`, 0.005684470000000112}, {
          0.15237364949180554`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.18146247035837781`, 0.011368940000000114`}, {
          0.18146247035837781`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.2105512912249501, 0.005684470000000112}, {
          0.2105512912249501, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.23964011209152192`, 0.005684470000000112}, {
          0.23964011209152192`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.2687289329580942, 0.005684470000000112}, {
          0.2687289329580942, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.29781775382466646`, 0.005684470000000112}, {
          0.29781775382466646`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.32690657469123874`, 0.011368940000000114`}, {
          0.32690657469123874`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.355995395557811, 0.005684470000000112}, {
          0.355995395557811, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.38508421642438284`, 0.005684470000000112}, {
          0.38508421642438284`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.4141730372909551, 0.005684470000000112}, {
          0.4141730372909551, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.4432618581575274, 0.005684470000000112}, {
          0.4432618581575274, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.47235067902409966`, 0.011368940000000114`}, {
          0.47235067902409966`, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.5014394998906719, 0.005684470000000112}, {
          0.5014394998906719, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.5305283207572442, 0.005684470000000112}, {
          0.5305283207572442, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.559617141623816, 0.005684470000000112}, {
          0.559617141623816, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.5887059624903883, 0.005684470000000112}, {
          0.5887059624903883, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.6177947833569606, 0.011368940000000114`}, {
          0.6177947833569606, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.6468836042235329, 0.005684470000000112}, {
          0.6468836042235329, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.6759724250901051, 0.005684470000000112}, {
          0.6759724250901051, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.7050612459566774, 0.005684470000000112}, {
          0.7050612459566774, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.7341500668232492, 0.005684470000000112}, {
          0.7341500668232492, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.7632388876898215, 0.011368940000000114`}, {
          0.7632388876898215, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.7923277085563938, 0.005684470000000112}, {
          0.7923277085563938, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.8214165294229661, 0.005684470000000112}, {
          0.8214165294229661, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.8505053502895383, 0.005684470000000112}, {
          0.8505053502895383, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.8795941711561106, 0.005684470000000112}, {
          0.8795941711561106, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.9086829920226824, 0.011368940000000114`}, {
          0.9086829920226824, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.9377718128892547, 0.005684470000000112}, {
          0.9377718128892547, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.966860633755827, 0.005684470000000112}, {
          0.966860633755827, 1.1102230246251565`*^-16}}], 
         LineBox[{{0.9959494546223993, 0.005684470000000112}, {
          0.9959494546223993, 1.1102230246251565`*^-16}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0, 1.1102230246251565`*^-16}, {0, 0.4761904761904763}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0.0074814960000000015`, 0.0017006802721075687`}, {0., 
          0.0017006802721075687`}}], 
         LineBox[{{0.0074814960000000015`, 0.018707482993196578`}, {0., 
          0.018707482993196578`}}], 
         LineBox[{{0.0074814960000000015`, 0.03571428571428514}, {0., 
          0.03571428571428514}}], 
         LineBox[{{0.014962992000000003`, 0.05272108843537371}, {0., 
          0.05272108843537371}}], 
         LineBox[{{0.0074814960000000015`, 0.06972789115646227}, {0., 
          0.06972789115646227}}], 
         LineBox[{{0.0074814960000000015`, 0.0867346938775504}, {0., 
          0.0867346938775504}}], 
         LineBox[{{0.0074814960000000015`, 0.1037414965986394}, {0., 
          0.1037414965986394}}], 
         LineBox[{{0.0074814960000000015`, 0.12074829931972753`}, {0., 
          0.12074829931972753`}}], 
         LineBox[{{0.014962992000000003`, 0.1377551020408161}, {0., 
          0.1377551020408161}}], 
         LineBox[{{0.0074814960000000015`, 0.15476190476190466`}, {0., 
          0.15476190476190466`}}], 
         LineBox[{{0.0074814960000000015`, 0.17176870748299278`}, {0., 
          0.17176870748299278`}}], 
         LineBox[{{0.0074814960000000015`, 0.18877551020408134`}, {0., 
          0.18877551020408134`}}], 
         LineBox[{{0.0074814960000000015`, 0.20578231292516946`}, {0., 
          0.20578231292516946`}}], 
         LineBox[{{0.014962992000000003`, 0.22278911564625847`}, {0., 
          0.22278911564625847`}}], 
         LineBox[{{0.0074814960000000015`, 0.23979591836734704`}, {0., 
          0.23979591836734704`}}], 
         LineBox[{{0.0074814960000000015`, 0.25680272108843516`}, {0., 
          0.25680272108843516`}}], 
         LineBox[{{0.0074814960000000015`, 0.2738095238095237}, {0., 
          0.2738095238095237}}], 
         LineBox[{{0.0074814960000000015`, 0.29081632653061185`}, {0., 
          0.29081632653061185`}}], 
         LineBox[{{0.014962992000000003`, 0.3078231292517004}, {0., 
          0.3078231292517004}}], 
         LineBox[{{0.0074814960000000015`, 0.3248299319727894}, {0., 
          0.3248299319727894}}], 
         LineBox[{{0.0074814960000000015`, 0.34183673469387754`}, {0., 
          0.34183673469387754`}}], 
         LineBox[{{0.0074814960000000015`, 0.3588435374149661}, {0., 
          0.3588435374149661}}], 
         LineBox[{{0.0074814960000000015`, 0.37585034013605423`}, {0., 
          0.37585034013605423`}}], 
         LineBox[{{0.014962992000000003`, 0.3928571428571428}, {0., 
          0.3928571428571428}}], 
         LineBox[{{0.0074814960000000015`, 0.40986394557823136`}, {0., 
          0.40986394557823136`}}], 
         LineBox[{{0.0074814960000000015`, 0.4268707482993195}, {0., 
          0.4268707482993195}}], 
         LineBox[{{0.0074814960000000015`, 0.4438775510204085}, {0., 
          0.4438775510204085}}], 
         LineBox[{{0.0074814960000000015`, 0.46088435374149617`}, {0., 
          0.46088435374149617`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0, 0.4761904761904763}, {1, 0.4761904761904763}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{0.006929545158944617, 0.4705060061904763}, {
          0.006929545158944617, 0.4761904761904763}}], 
         LineBox[{{0.03601836602551689, 0.4648215361904763}, {
          0.03601836602551689, 0.4761904761904763}}], 
         LineBox[{{0.06510718689208872, 0.4705060061904763}, {
          0.06510718689208872, 0.4761904761904763}}], 
         LineBox[{{0.094196007758661, 0.4705060061904763}, {0.094196007758661,
           0.4761904761904763}}], 
         LineBox[{{0.12328482862523327`, 0.4705060061904763}, {
          0.12328482862523327`, 0.4761904761904763}}], 
         LineBox[{{0.15237364949180554`, 0.4705060061904763}, {
          0.15237364949180554`, 0.4761904761904763}}], 
         LineBox[{{0.18146247035837781`, 0.4648215361904763}, {
          0.18146247035837781`, 0.4761904761904763}}], 
         LineBox[{{0.2105512912249501, 0.4705060061904763}, {
          0.2105512912249501, 0.4761904761904763}}], 
         LineBox[{{0.23964011209152192`, 0.4705060061904763}, {
          0.23964011209152192`, 0.4761904761904763}}], 
         LineBox[{{0.2687289329580942, 0.4705060061904763}, {
          0.2687289329580942, 0.4761904761904763}}], 
         LineBox[{{0.29781775382466646`, 0.4705060061904763}, {
          0.29781775382466646`, 0.4761904761904763}}], 
         LineBox[{{0.32690657469123874`, 0.4648215361904763}, {
          0.32690657469123874`, 0.4761904761904763}}], 
         LineBox[{{0.355995395557811, 0.4705060061904763}, {0.355995395557811,
           0.4761904761904763}}], 
         LineBox[{{0.38508421642438284`, 0.4705060061904763}, {
          0.38508421642438284`, 0.4761904761904763}}], 
         LineBox[{{0.4141730372909551, 0.4705060061904763}, {
          0.4141730372909551, 0.4761904761904763}}], 
         LineBox[{{0.4432618581575274, 0.4705060061904763}, {
          0.4432618581575274, 0.4761904761904763}}], 
         LineBox[{{0.47235067902409966`, 0.4648215361904763}, {
          0.47235067902409966`, 0.4761904761904763}}], 
         LineBox[{{0.5014394998906719, 0.4705060061904763}, {
          0.5014394998906719, 0.4761904761904763}}], 
         LineBox[{{0.5305283207572442, 0.4705060061904763}, {
          0.5305283207572442, 0.4761904761904763}}], 
         LineBox[{{0.559617141623816, 0.4705060061904763}, {0.559617141623816,
           0.4761904761904763}}], 
         LineBox[{{0.5887059624903883, 0.4705060061904763}, {
          0.5887059624903883, 0.4761904761904763}}], 
         LineBox[{{0.6177947833569606, 0.4648215361904763}, {
          0.6177947833569606, 0.4761904761904763}}], 
         LineBox[{{0.6468836042235329, 0.4705060061904763}, {
          0.6468836042235329, 0.4761904761904763}}], 
         LineBox[{{0.6759724250901051, 0.4705060061904763}, {
          0.6759724250901051, 0.4761904761904763}}], 
         LineBox[{{0.7050612459566774, 0.4705060061904763}, {
          0.7050612459566774, 0.4761904761904763}}], 
         LineBox[{{0.7341500668232492, 0.4705060061904763}, {
          0.7341500668232492, 0.4761904761904763}}], 
         LineBox[{{0.7632388876898215, 0.4648215361904763}, {
          0.7632388876898215, 0.4761904761904763}}], 
         LineBox[{{0.7923277085563938, 0.4705060061904763}, {
          0.7923277085563938, 0.4761904761904763}}], 
         LineBox[{{0.8214165294229661, 0.4705060061904763}, {
          0.8214165294229661, 0.4761904761904763}}], 
         LineBox[{{0.8505053502895383, 0.4705060061904763}, {
          0.8505053502895383, 0.4761904761904763}}], 
         LineBox[{{0.8795941711561106, 0.4705060061904763}, {
          0.8795941711561106, 0.4761904761904763}}], 
         LineBox[{{0.9086829920226824, 0.4648215361904763}, {
          0.9086829920226824, 0.4761904761904763}}], 
         LineBox[{{0.9377718128892547, 0.4705060061904763}, {
          0.9377718128892547, 0.4761904761904763}}], 
         LineBox[{{0.966860633755827, 0.4705060061904763}, {0.966860633755827,
           0.4761904761904763}}], 
         LineBox[{{0.9959494546223993, 0.4705060061904763}, {
          0.9959494546223993, 0.4761904761904763}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], Dashing[{}], 
         LineBox[{{1, 1.1102230246251565`*^-16}, {1, 0.4761904761904763}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Opacity[1], 
         Dashing[{}], {
          LineBox[{{0.992518504, 0.0017006802721075687`}, {1., 
           0.0017006802721075687`}}], 
          LineBox[{{0.992518504, 0.018707482993196578`}, {1., 
           0.018707482993196578`}}], 
          LineBox[{{0.992518504, 0.03571428571428514}, {1., 
           0.03571428571428514}}], 
          LineBox[{{0.985037008, 0.05272108843537371}, {1., 
           0.05272108843537371}}], 
          LineBox[{{0.992518504, 0.06972789115646227}, {1., 
           0.06972789115646227}}], 
          LineBox[{{0.992518504, 0.0867346938775504}, {1., 
           0.0867346938775504}}], 
          LineBox[{{0.992518504, 0.1037414965986394}, {1., 
           0.1037414965986394}}], 
          LineBox[{{0.992518504, 0.12074829931972753`}, {1., 
           0.12074829931972753`}}], 
          LineBox[{{0.985037008, 0.1377551020408161}, {1., 
           0.1377551020408161}}], 
          LineBox[{{0.992518504, 0.15476190476190466`}, {1., 
           0.15476190476190466`}}], 
          LineBox[{{0.992518504, 0.17176870748299278`}, {1., 
           0.17176870748299278`}}], 
          LineBox[{{0.992518504, 0.18877551020408134`}, {1., 
           0.18877551020408134`}}], 
          LineBox[{{0.992518504, 0.20578231292516946`}, {1., 
           0.20578231292516946`}}], 
          LineBox[{{0.985037008, 0.22278911564625847`}, {1., 
           0.22278911564625847`}}], 
          LineBox[{{0.992518504, 0.23979591836734704`}, {1., 
           0.23979591836734704`}}], 
          LineBox[{{0.992518504, 0.25680272108843516`}, {1., 
           0.25680272108843516`}}], 
          LineBox[{{0.992518504, 0.2738095238095237}, {1., 
           0.2738095238095237}}], 
          LineBox[{{0.992518504, 0.29081632653061185`}, {1., 
           0.29081632653061185`}}], 
          LineBox[{{0.985037008, 0.3078231292517004}, {1., 
           0.3078231292517004}}], 
          LineBox[{{0.992518504, 0.3248299319727894}, {1., 
           0.3248299319727894}}], 
          LineBox[{{0.992518504, 0.34183673469387754`}, {1., 
           0.34183673469387754`}}], 
          LineBox[{{0.992518504, 0.3588435374149661}, {1., 
           0.3588435374149661}}], 
          LineBox[{{0.992518504, 0.37585034013605423`}, {1., 
           0.37585034013605423`}}], 
          LineBox[{{0.985037008, 0.3928571428571428}, {1., 
           0.3928571428571428}}], 
          LineBox[{{0.992518504, 0.40986394557823136`}, {1., 
           0.40986394557823136`}}], 
          LineBox[{{0.992518504, 0.4268707482993195}, {1., 
           0.4268707482993195}}], 
          LineBox[{{0.992518504, 0.4438775510204085}, {1., 
           0.4438775510204085}}], 
          LineBox[{{0.992518504, 0.46088435374149617`}, {1., 
           0.46088435374149617`}}]}, InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"(c)\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            ShowContents->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.07728818181818184, 0.9412761363636364}, {0, 0}, 
          Automatic, {1, 0},
          Background->GrayLevel[1]], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"(d)\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            ShowContents->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.07728818181818184, 0.4174666125541126}, {0, 0}, 
          Automatic, {1, 0},
          Background->GrayLevel[1]], InsetBox[
          TagBox[
           StyleBox[
            
            TagBox["\<\"a=0.5(lin \
\\!\\(\\*\\nStyleBox[\\\"B\\\",\\nFontWeight->\\\"Plain\\\"]\\)): \
\\!\\(\\*SuperscriptBox[SubscriptBox[\\(\[Chi]\\), \\(F\\)], \
\\(2\\)]\\)/\\!\\(\\*SubscriptBox[\\(dof\\), \\(F\\)]\\)(c) and total \
\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\\)]\\)/dof(d)\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.4744108800000001, 1.100124}, {0, 1}, Automatic, {
          1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"17.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.5765306122448974}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"18.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.6615646258503398}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"18.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.7465986394557822}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"19.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.8316326530612241}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"19.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.9166666666666665}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"Tp/Te at 6M\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.19064418181818182`, 0.761904761904762}, {0, 0}, 
          Automatic, {0, 1}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"(c)\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.07728818181818184, 0.9412761363636364}, {0, 0}, 
          Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"45.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.03601836602551689, -0.02348954545454535}, {0, 1}, 
          Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"47.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.18146247035837781`, -0.02348954545454535}, {0, 1},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"50.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.32690657469123874`, -0.02348954545454535}, {0, 1},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"52.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.47235067902409966`, -0.02348954545454535}, {0, 1},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"55.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.6177947833569606, -0.02348954545454535}, {0, 1}, 
          Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"57.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.7632388876898215, -0.02348954545454535}, {0, 1}, 
          Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"60.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.9086829920226824, -0.02348954545454535}, {0, 1}, 
          Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"Inclination angle \[Theta] [deg]\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.5, -0.09787310606060598}, {0, 0}, Automatic, {1, 
          0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"17.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.05272108843537371}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"18.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.1377551020408161}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"18.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.22278911564625847`}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"19.0\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.3078231292517004}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"19.5\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.030915272727272732`, 0.3928571428571428}, {1, 0},
           Automatic, {1, 0}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"Tp/Te at 6M\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {-0.19064418181818182`, 0.23809523809523825`}, {0, 0},
           Automatic, {0, 1}], InsetBox[
          TagBox[
           StyleBox[
            TagBox["\<\"(d)\"\>",
             DisplayForm],
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Bold,
            FontSlant->"Plain",
            FontTracking->"Plain",
            FontColor->GrayLevel[0],
            FontOpacity->1],
           DisplayForm], {0.07728818181818184, 0.4174666125541126}, {0, 0}, 
          Automatic, {1, 0}]}}},
      AspectRatio->NCache[
        Rational[6, 5], 1.2],
      Axes->False,
      Background->None,
      BaseStyle->{
       FontFamily -> "Times", FontSize -> 12, FontSlant -> "Plain", 
        FontTracking -> "Plain", FontWeight -> "Plain", FontColor -> 
        GrayLevel[0], FontOpacity -> 1, ShowAutoStyles -> False, 
        SingleLetterItalics -> False},
      DisplayFunction->Identity,
      Frame->False,
      FrameLabel->{None, None, None, None},
      FrameStyle->Directive[{
         GrayLevel[0], 
         Opacity[1], 
         AbsoluteThickness[1], 
         AbsoluteDashing[{}]}],
      FrameTicks->None,
      ImageSize->NCache[{264, 
         Rational[1584, 5]}, {264, 316.8}],
      PlotRange->{{-0.26013600000000003`, 1.100136}, {-0.14012400000000003`, 
       1.100124}},
      Ticks->None], {422.4000000000001, -166.32}, ImageScaled[{0.5, 0.5}], 
     NCache[{264, Rational[1584, 5]}, {264, 316.8}]]}, {}},
  ContentSelectable->True,
  ImageSize->{575.2, 344.64},
  PlotRangePadding->{6, 5}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.5025640657166*^9, 3.5025642544454*^9, 3.502564313351*^9, {
   3.50262625675*^9, 3.502626301836*^9}, 3.5026265683050003`*^9, 
   3.502649304053*^9, 3.502649390321*^9, 3.504287513651*^9, 3.504367241769*^9,
    3.508262989086*^9}],

Cell[BoxData["\<\"C:\\\\study\\\\accretion\\\\! 2009 fall cfa\\\\GR Polarized \
modeling\\\\fitthFFLPCP.eps\"\>"], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.5025640657166*^9, 3.5025642544454*^9, 3.502564313351*^9, {
   3.50262625675*^9, 3.502626301836*^9}, 3.5026265683050003`*^9, 
   3.502649304053*^9, 3.502649390321*^9, 3.504287513651*^9, 3.504367246032*^9,
    3.508262989086*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["the rest", "Subsubsection",
 CellChangeTimes->{{3.4864423604994*^9, 3.4864423615894003`*^9}, 
   3.508262989086*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{
     "Import", "[", 
      "\"\<E:\\\\mathematica\\\\analysis\\\\poliresa90th223fn-1cr_th.dat\>\"",
       "]"}], ",", "7"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"len", "=", 
   RowBox[{"Length", "[", "imp", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"len", "\[Equal]", 
     SuperscriptBox[
      RowBox[{"Round", "[", 
       RowBox[{"par", "=", 
        RowBox[{"Sqrt", "[", "len", "]"}]}], "]"}], "2"]}], ",", 
    RowBox[{"impx", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{"imp", ",", "par"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}]}], 
   "]"}], ";", 
  RowBox[{"mmord", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"thmin", "=", 
    RowBox[{"impx", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1", ",", "1", ",", "13"}], "]"}], "]"}]}], ";", 
   RowBox[{"thmax", "=", 
    RowBox[{"impx", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", "1", ",", "13"}], "]"}], "]"}]}], ";", 
   RowBox[{"rhomin", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", "12"}], "]"}], "]"}], "]"}]}], 
   ";", 
   RowBox[{"rhomax", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", 
        RowBox[{"-", "1"}], ",", "12"}], "]"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabb", "=", 
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           RowBox[{"tofit", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{
               RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
              "2"}], "]"}], "]"}], "-", 
           RowBox[{"impx", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], "]"}]}], 
          "dFnu"], ")"}], "2"], "]"}], "7"], "&"}], "/@", 
    RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnu3", "=", 
    RowBox[{"ListInterpolation", "[", 
     RowBox[{"tabb", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"thmin", ",", "thmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"rhomin", ",", "rhomax"}], "}"}]}], "}"}], ",", 
      RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"for", " ", "heat"}], ";", " ", 
    RowBox[{"for", " ", "th", " ", "in", " ", 
     RowBox[{"C", "++"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabb", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      FractionBox["1", "12"], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                "2"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], 
              "]"}]}], "dFnu"], ")"}], "2"], "]"}], "+", 
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "4"}], ";;", 
                 RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "6"}], 
               "]"}], "]"}]}], "dCP"], ")"}], "2"], "]"}], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"Log", "[", 
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
            RowBox[{"Log", "[", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"-", "7"}], ",", "#", ",", "All", ",", "4"}], "]"}], 
              "]"}], "]"}]}], "dlogLP"], ")"}], "2"], "+", 
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"Log", "[", 
              RowBox[{"tofit", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}], 
             "-", 
             RowBox[{"Log", "[", 
              RowBox[{"impx", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "4"}], ";;", 
                  RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "4"}], 
                "]"}], "]"}], "]"}]}], "dlogLP"], ")"}], "2"], "]"}]}], 
       ")"}]}], "&"}], "/@", 
    RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lipFnuCPLP3", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{"tabb", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"thmin", ",", "thmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"rhomin", ",", "rhomax"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lcp", "=", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"lipFnu3", "[", 
      RowBox[{"th", ",", 
       RowBox[{"Log", "[", 
        RowBox[{
         SuperscriptBox["10", 
          RowBox[{"-", "9"}]], "rhonor"}], "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"th", ",", "thmin", ",", "thmax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"rhonor", ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomin", "]"}]}], ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomax", "]"}]}]}], "}"}], ",", 
     RowBox[{"Contours", "\[Rule]", "40"}], ",", 
     RowBox[{"ContourLabels", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Framed", "[", "#3", "]"}], ",", "15"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], ")"}]}],
      ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Inclination angle \[Theta]\>\"", ",", 
        "\"\<Accretion rate in \!\(\*SuperscriptBox[\(10\), \
\(-9\)]\)Msun/year\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Times\>\"", ",", "16"}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
         RowBox[{
          RowBox[{"2", "#"}], "+", "0.3"}], "]"}], "&"}], ")"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xcp", "=", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"lipFnuCPLP3", "[", 
      RowBox[{"th", ",", 
       RowBox[{"Log", "[", 
        RowBox[{
         SuperscriptBox["10", 
          RowBox[{"-", "9"}]], "rhonor"}], "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"th", ",", "thmin", ",", "thmax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"rhonor", ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomin", "]"}]}], ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomax", "]"}]}]}], "}"}], ",", 
     RowBox[{"Contours", "\[Rule]", "40"}], ",", 
     RowBox[{"ContourLabels", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Framed", "[", 
             RowBox[{
              RowBox[{"Round", "[", 
               RowBox[{"10", "#3"}], "]"}], "/", "10."}], "]"}], ",", "15"}], 
           "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], ")"}]}],
      ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Inclination angle \[Theta]\>\"", ",", 
        "\"\<Accretion rate in \!\(\*SuperscriptBox[\(10\), \
\(-9\)]\)Msun/year\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Times\>\"", ",", "16"}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
          RowBox[{"#", "-", "1."}], "]"}], ")"}], "&"}], ")"}]}], ",", 
     RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"frac", "=", "0.06"}], ";", 
  RowBox[{"sizy", "=", 
   RowBox[{
    SuperscriptBox["10", "9"], "frac", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Exp", "[", "rhomax", "]"}], "-", 
      RowBox[{"Exp", "[", "rhomin", "]"}]}], ")"}]}]}], ";", 
  RowBox[{"sizx", "=", 
   RowBox[{"frac", 
    RowBox[{"(", 
     RowBox[{"thmax", "-", "thmin"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coords", "=", 
   RowBox[{"xcp", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "All", ",", "2"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"posit", "=", 
   RowBox[{"Position", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ar", "=", 
         RowBox[{"Delete", "[", 
          RowBox[{
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{
              FractionBox[
               RowBox[{
                RowBox[{"coords", "[", 
                 RowBox[{"[", "#", "]"}], "]"}], "-", 
                RowBox[{"coords", "[", 
                 RowBox[{"[", "nn", "]"}], "]"}]}], 
               RowBox[{"{", 
                RowBox[{"sizx", ",", "sizy"}], "}"}]], "&"}], "/@", 
             RowBox[{"Range", "[", 
              RowBox[{"Length", "[", "coords", "]"}], "]"}]}], "]"}], ",", 
           "nn"}], "]"}]}], ";", 
        RowBox[{"obst", "=", "False"}], ";", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"kk", "=", "1"}], ",", 
          RowBox[{"kk", "<", "nn"}], ",", 
          RowBox[{"kk", "++"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"ar", "[", 
                RowBox[{"[", 
                 RowBox[{"kk", ",", "1"}], "]"}], "]"}], "<", "1"}], ")"}], "&&", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"ar", "[", 
                RowBox[{"[", 
                 RowBox[{"kk", ",", "2"}], "]"}], "]"}], "<", "1"}], ")"}]}], 
            ",", 
            RowBox[{"obst", "=", "True"}]}], "]"}]}], "]"}], ";", "obst"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"nn", ",", 
         RowBox[{
          RowBox[{"Length", "[", "coords", "]"}], "-", "1"}]}], "}"}]}], 
      "]"}], ",", "True"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xcp", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "2", ",", "3"}], "]"}], "]"}], "=", 
   RowBox[{"Delete", "[", 
    RowBox[{
     RowBox[{"xcp", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "2", ",", "3"}], "]"}], "]"}], ",", "posit"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"lcp", ";"}], "\[IndentingNewLine]", "xcp"}], "Input",
 CellChangeTimes->{{3.4858838610502157`*^9, 3.4858838966182156`*^9}, 
   3.485883995756215*^9, {3.4858840536322155`*^9, 3.485884084598215*^9}, {
   3.4858841598838153`*^9, 3.4858841872150154`*^9}, {3.4858843623874154`*^9, 
   3.4858843851166153`*^9}, {3.4858845935170155`*^9, 
   3.4858846994254155`*^9}, {3.4858847905918155`*^9, 
   3.4858848142414155`*^9}, {3.4858848652066154`*^9, 
   3.4858848721330156`*^9}, {3.4858849239094152`*^9, 3.4858849278874154`*^9}, 
   3.4858849638142157`*^9, {3.4858850330158157`*^9, 3.4858850587558155`*^9}, {
   3.485900494498*^9, 3.485900542778*^9}, {3.485900584935*^9, 
   3.485900598166*^9}, {3.48590094242*^9, 3.4859009738380003`*^9}, {
   3.485901015506*^9, 3.485901063616*^9}, {3.486168544462*^9, 
   3.4861685445880003`*^9}, 3.4864423770294*^9, 3.5082629890959997`*^9, {
   3.5093765656940002`*^9, 3.5093765807790003`*^9}, {3.509376671554*^9, 
   3.509376671678*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{
     "Import", "[", 
      "\"\<C:\\\\study\\\\mathematica\\\\3DMHD\\\\poliresa50th191fn-1cr_th.\
dat\>\"", "]"}], ",", "7"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"len", "=", 
   RowBox[{"Length", "[", "imp", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"len", "\[Equal]", 
     SuperscriptBox[
      RowBox[{"Round", "[", 
       RowBox[{"par", "=", 
        RowBox[{"Sqrt", "[", "len", "]"}]}], "]"}], "2"]}], ",", 
    RowBox[{"impx", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{"imp", ",", "par"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}]}], 
   "]"}], ";", 
  RowBox[{"mmord", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"thmin", "=", 
    RowBox[{"impx", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1", ",", "1", ",", "13"}], "]"}], "]"}]}], ";", 
   RowBox[{"thmax", "=", 
    RowBox[{"impx", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}], ",", "1", ",", "13"}], "]"}], "]"}]}], ";", 
   RowBox[{"rhomin", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", "12"}], "]"}], "]"}], "]"}]}], 
   ";", 
   RowBox[{"rhomax", "=", 
    RowBox[{"Log", "[", 
     RowBox[{"impx", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", 
        RowBox[{"-", "1"}], ",", "12"}], "]"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabb", "=", 
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           RowBox[{"tofit", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{
               RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
              "2"}], "]"}], "]"}], "-", 
           RowBox[{"impx", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], "]"}]}], 
          "dFnu"], ")"}], "2"], "]"}], "7"], "&"}], "/@", 
    RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnu3", "=", 
    RowBox[{"ListInterpolation", "[", 
     RowBox[{"tabb", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"thmin", ",", "thmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"rhomin", ",", "rhomax"}], "}"}]}], "}"}], ",", 
      RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"for", " ", "heat"}], ";", " ", 
    RowBox[{"for", " ", "th", " ", "in", " ", 
     RowBox[{"C", "++"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabb", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      FractionBox["1", "12"], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                "2"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "#", ",", "All", ",", "3"}], "]"}], 
              "]"}]}], "dFnu"], ")"}], "2"], "]"}], "+", 
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "4"}], ";;", 
                 RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "6"}], 
               "]"}], "]"}]}], "dCP"], ")"}], "2"], "]"}], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"Log", "[", 
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
            RowBox[{"Log", "[", 
             RowBox[{"impx", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"-", "7"}], ",", "#", ",", "All", ",", "4"}], "]"}], 
              "]"}], "]"}]}], "dlogLP"], ")"}], "2"], "+", 
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"Log", "[", 
              RowBox[{"tofit", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}], 
             "-", 
             RowBox[{"Log", "[", 
              RowBox[{"impx", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "4"}], ";;", 
                  RowBox[{"-", "3"}]}], ",", "#", ",", "All", ",", "4"}], 
                "]"}], "]"}], "]"}]}], "dlogLP"], ")"}], "2"], "]"}]}], 
       ")"}]}], "&"}], "/@", 
    RowBox[{"Range", "[", "par", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lipFnuCPLP3", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{"tabb", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"thmin", ",", "thmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"rhomin", ",", "rhomax"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "mmord"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lcp", "=", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"lipFnu3", "[", 
      RowBox[{"th", ",", 
       RowBox[{"Log", "[", 
        RowBox[{
         SuperscriptBox["10", 
          RowBox[{"-", "9"}]], "rhonor"}], "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"th", ",", "thmin", ",", "thmax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"rhonor", ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomin", "]"}]}], ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomax", "]"}]}]}], "}"}], ",", 
     RowBox[{"Contours", "\[Rule]", "40"}], ",", 
     RowBox[{"ContourLabels", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Framed", "[", "#3", "]"}], ",", "15"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], ")"}]}],
      ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Inclination angle \[Theta]\>\"", ",", 
        "\"\<Accretion rate in \!\(\*SuperscriptBox[\(10\), \
\(-9\)]\)Msun/year\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Times\>\"", ",", "16"}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
         RowBox[{
          RowBox[{"2", "#"}], "+", "0.3"}], "]"}], "&"}], ")"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xcp", "=", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"lipFnuCPLP3", "[", 
      RowBox[{"th", ",", 
       RowBox[{"Log", "[", 
        RowBox[{
         SuperscriptBox["10", 
          RowBox[{"-", "9"}]], "rhonor"}], "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"th", ",", "thmin", ",", "thmax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"rhonor", ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomin", "]"}]}], ",", 
       RowBox[{
        SuperscriptBox["10", "9"], 
        RowBox[{"Exp", "[", "rhomax", "]"}]}]}], "}"}], ",", 
     RowBox[{"Contours", "\[Rule]", "40"}], ",", 
     RowBox[{"ContourLabels", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Framed", "[", 
             RowBox[{
              RowBox[{"Round", "[", 
               RowBox[{"10", "#3"}], "]"}], "/", "10."}], "]"}], ",", "15"}], 
           "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "White"}]}], "]"}], "&"}], ")"}]}],
      ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<Inclination angle \[Theta]\>\"", ",", 
        "\"\<Accretion rate in \!\(\*SuperscriptBox[\(10\), \
\(-9\)]\)Msun/year\>\""}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Times\>\"", ",", "16"}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "550"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"ColorData", "[", "\"\<TemperatureMap\>\"", "]"}], "[", 
          RowBox[{"#", "-", "1."}], "]"}], ")"}], "&"}], ")"}]}], ",", 
     RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"frac", "=", "0.06"}], ";", 
  RowBox[{"sizy", "=", 
   RowBox[{
    SuperscriptBox["10", "9"], "frac", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Exp", "[", "rhomax", "]"}], "-", 
      RowBox[{"Exp", "[", "rhomin", "]"}]}], ")"}]}]}], ";", 
  RowBox[{"sizx", "=", 
   RowBox[{"frac", 
    RowBox[{"(", 
     RowBox[{"thmax", "-", "thmin"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coords", "=", 
   RowBox[{"xcp", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "2", ",", "3", ",", "All", ",", "2"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"posit", "=", 
   RowBox[{"Position", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ar", "=", 
         RowBox[{"Delete", "[", 
          RowBox[{
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{
              FractionBox[
               RowBox[{
                RowBox[{"coords", "[", 
                 RowBox[{"[", "#", "]"}], "]"}], "-", 
                RowBox[{"coords", "[", 
                 RowBox[{"[", "nn", "]"}], "]"}]}], 
               RowBox[{"{", 
                RowBox[{"sizx", ",", "sizy"}], "}"}]], "&"}], "/@", 
             RowBox[{"Range", "[", 
              RowBox[{"Length", "[", "coords", "]"}], "]"}]}], "]"}], ",", 
           "nn"}], "]"}]}], ";", 
        RowBox[{"obst", "=", "False"}], ";", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"kk", "=", "1"}], ",", 
          RowBox[{"kk", "<", "nn"}], ",", 
          RowBox[{"kk", "++"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"ar", "[", 
                RowBox[{"[", 
                 RowBox[{"kk", ",", "1"}], "]"}], "]"}], "<", "1"}], ")"}], "&&", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"ar", "[", 
                RowBox[{"[", 
                 RowBox[{"kk", ",", "2"}], "]"}], "]"}], "<", "1"}], ")"}]}], 
            ",", 
            RowBox[{"obst", "=", "True"}]}], "]"}]}], "]"}], ";", "obst"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"nn", ",", 
         RowBox[{
          RowBox[{"Length", "[", "coords", "]"}], "-", "1"}]}], "}"}]}], 
      "]"}], ",", "True"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xcp", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "2", ",", "3"}], "]"}], "]"}], "=", 
   RowBox[{"Delete", "[", 
    RowBox[{
     RowBox[{"xcp", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "2", ",", "3"}], "]"}], "]"}], ",", "posit"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"lcp", ";"}], "\[IndentingNewLine]", "xcp"}], "Input",
 CellChangeTimes->{{3.4858838610502157`*^9, 3.4858838966182156`*^9}, 
   3.485883995756215*^9, {3.4858840536322155`*^9, 3.485884084598215*^9}, {
   3.4858841598838153`*^9, 3.4858841872150154`*^9}, {3.4858843623874154`*^9, 
   3.4858843851166153`*^9}, {3.4858845935170155`*^9, 
   3.4858846994254155`*^9}, {3.4858847905918155`*^9, 
   3.4858848142414155`*^9}, {3.4858848652066154`*^9, 
   3.4858848721330156`*^9}, {3.4858849239094152`*^9, 3.4858849278874154`*^9}, 
   3.4858849638142157`*^9, {3.4858850330158157`*^9, 3.4858850587558155`*^9}, {
   3.485900494498*^9, 3.485900542778*^9}, {3.485900584935*^9, 
   3.485900598166*^9}, {3.48590094242*^9, 3.4859009738380003`*^9}, {
   3.485901015506*^9, 3.485901063616*^9}, {3.4860923405465403`*^9, 
   3.4860923432505403`*^9}, {3.486168598524*^9, 3.486168598597*^9}, 
   3.4864423820594*^9, 3.508262989105*^9}],

Cell[BoxData["1600"], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.485900498234*^9, 3.485900543551*^9}, 
   3.4859005996289997`*^9, {3.4859009438780003`*^9, 3.485900974349*^9}, {
   3.485901023418*^9, 3.485901064051*^9}, 3.48609214833354*^9, 
   3.4860923439735403`*^9, 3.486168599368*^9, 3.508262989105*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\mathematica\\\\3DMHD\\\\plot09_ch_cr.pdf\>\"", ",", 
   "xcp"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\mathematica\\\\3DMHD\\\\plot09_ch_cr.eps\>\"", ",", 
   "xcp"}], "]"}]}], "Input",
 CellChangeTimes->{{3.4858981025664153`*^9, 3.4858981219260154`*^9}, {
   3.485898156729615*^9, 3.4858981662768154`*^9}, {3.485898220356615*^9, 
   3.4858982208558154`*^9}, {3.485899892605*^9, 3.485899903396*^9}, {
   3.485900169987*^9, 3.485900201913*^9}, 3.508262989105*^9}],

Cell[BoxData["\<\"C:\\\\study\\\\mathematica\\\\3DMHD\\\\plot09_ch_cr.pdf\"\>\
"], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.4858981707228155`*^9, 3.4858982225094156`*^9, 3.485899904749*^9, {
   3.485900174046*^9, 3.485900202994*^9}, 3.508262989106*^9}],

Cell[BoxData["\<\"C:\\\\study\\\\mathematica\\\\3DMHD\\\\plot09_ch_cr.eps\"\>\
"], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.4858981707228155`*^9, 3.4858982225094156`*^9, 3.485899904749*^9, {
   3.485900174046*^9, 3.485900204153*^9}, 3.508262989106*^9}]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["\[Chi]^2 analysis",
 FontColor->RGBColor[0, 0, 1]]], "Subsection",
 CellChangeTimes->{{3.486484672613*^9, 3.4864846824519997`*^9}, {
   3.489155313108533*^9, 3.4891553155577326`*^9}, {3.503080950505*^9, 
   3.50308095152*^9}, 3.509206154698*^9, {3.529164747301758*^9, 
   3.529164747380762*^9}, {3.529321616887007*^9, 3.529321619839176*^9}, {
   3.529321670367066*^9, 3.5293216844468713`*^9}}],

Cell[CellGroupData[{

Cell["\<\
linear analysis - all linear LP87, LP231, LP345, CP231, CP345\
\>", "Subsubsection",
 CellChangeTimes->{{3.526761702744647*^9, 3.5267617061288404`*^9}, {
  3.526762839608672*^9, 3.5267628483441715`*^9}, {3.52849259877991*^9, 
  3.528492605307511*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"new", " ", "data"}], "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{"tofit", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"8.450", ",", "0.6898", ",", "0", ",", "0", ",", 
         RowBox[{"-", "0.2500"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"14.90", ",", "0.9044", ",", "0", ",", "0", ",", 
         RowBox[{"-", "0.6200"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "22.50", ",", "1.070", ",", "0.1900", ",", "131.0", ",", "0"}], "}"}],
        ",", 
       RowBox[{"{", 
        RowBox[{
        "43.00", ",", "1.159", ",", "0.5041", ",", "94.25", ",", "0"}], "}"}],
        ",", 
       RowBox[{"{", 
        RowBox[{"87.73", ",", "1.841", ",", "1.42", ",", 
         RowBox[{"-", "4."}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"102.0", ",", "1.908", ",", "0", ",", "0", ",", "0"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"145.0", ",", "2.275", ",", "0", ",", "0", ",", "0"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"230.9", ",", "2.637", ",", "7.40", ",", "111.5", ",", 
         RowBox[{"-", "1.200"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"349.0", ",", "3.181", ",", "6.50", ",", "146.9", ",", 
         RowBox[{"-", "1.500"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"674.0", ",", "3.286", ",", "0", ",", "0", ",", "0"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"857.0", ",", "2.867", ",", "0", ",", "0", ",", "0"}], 
        "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", " ", 
   RowBox[{
    RowBox[{"dFnu", "=", 
     RowBox[{"{", 
      RowBox[{
      "1.", ",", "1.", ",", "1.", ",", "1.", ",", "0.080", ",", "0.1517", ",",
        "0.2644", ",", "0.1414", ",", "0.1205", ",", "0.3508", ",", 
       "0.2404"}], "}"}]}], ";", 
    RowBox[{"dCP", "=", "0.30"}], ";", 
    RowBox[{"dLP", "=", 
     RowBox[{"{", 
      RowBox[{"0.5", ",", "0.66", ",", "0.61"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Clear", "[", 
     RowBox[{"nh", ",", "co"}], "]"}], ";", 
    RowBox[{"ext", "=", "1."}], ";", 
    RowBox[{"acc", "=", "16"}], ";", 
    RowBox[{"inord", "=", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], ";", 
    RowBox[{"poi3", "=", "50000"}], ";", 
    RowBox[{"Off", "[", 
     RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], "]"}], ";", 
    RowBox[{"t", "=", 
     RowBox[{"TimeUsed", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"SetOptions", "[", 
      RowBox[{"NIntegrate", ",", 
       RowBox[{"Method", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
          RowBox[{"Method", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
             RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}],
        ",", 
       RowBox[{"MaxPoints", "\[Rule]", "poi3"}], ",", 
       RowBox[{"AccuracyGoal", "\[Rule]", "acc"}]}], "]"}], ";"}], "*)"}], 
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"NIntegrate", ",", 
      RowBox[{"Method", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
         RowBox[{"Method", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
            RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
      ",", 
      RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"co", "=", "0"}], ";", 
    RowBox[{"thlen", "=", "50"}], ";", 
    RowBox[{"sptab", "=", 
     RowBox[{"{", 
      RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], 
      "}"}]}], ";", 
    RowBox[{"narr", "=", "1.1"}], ";", 
    RowBox[{"nF", "=", "7"}], ";", 
    RowBox[{"nP", "=", "12"}], ";", 
    RowBox[{"avg", "=", "False"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fmin", "=", "6950"}], ";", 
    RowBox[{"fmax", "=", "9950"}], ";", 
    RowBox[{"ind", "=", "11"}], ";", 
    RowBox[{"sep", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"ind", "-", "1"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Do", "[", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"gat", "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"th", "=", 
              RowBox[{
               FractionBox["\[Pi]", "thlen"], 
               RowBox[{"(", 
                RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
             RowBox[{"Import", "[", 
              RowBox[{
              "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\\
ava\>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Round", "[", 
                 RowBox[{"100", 
                  RowBox[{"sptab", "[", 
                   RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
               "\"\<th\>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Floor", "[", 
                 RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<in11\>\"", 
               "<>", "\"\<.dat\>\""}], "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"flen", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"gat", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", ";;", "11"}], ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"gat", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
       RowBox[{"Off", "[", 
        RowBox[{
         RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
         RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"gat", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{"gat", ",", "flen"}], "]"}]}], ";", 
       RowBox[{"rholen", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"Position", "[", 
          RowBox[{
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "6"}], 
             "]"}], "]"}], ",", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1", ",", "1", ",", "6"}], "]"}], "]"}]}], 
          "]"}], "]"}]}], ";", 
       RowBox[{"gat", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", 
       RowBox[{"dim", "=", 
        RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", 
       RowBox[{"hlen", "=", 
        RowBox[{"dim", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", 
       RowBox[{"hmin", "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "6"}], 
           "]"}], "]"}], "]"}]}], ";", 
       RowBox[{"hmax", "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "6"}], "]"}], 
          "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"thmin", "=", 
        RowBox[{
         FractionBox["\[Pi]", "thlen"], 
         RowBox[{"(", 
          RowBox[{"1", "-", ".5"}], ")"}]}]}], ";", 
       RowBox[{"thmax", "=", 
        RowBox[{"\[Pi]", "-", "thmin"}]}], ";", 
       RowBox[{"rhomax", "=", 
        RowBox[{"Log", "[", 
         FractionBox[
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "7"}], "]"}], "]"}], 
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"flen", "+", "1"}], ")"}], "/", "2"}], ",", "1", ",", 
             "1", ",", "7"}], "]"}], "]"}]], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"rateint", "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], 
             "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"raterho", "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "7"}], "]"}],
             "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"flux", "[", "i", "]"}], "=", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "All", ",", "i", ",", "All", ",", "2"}], 
             "]"}], "]"}]}], ";", 
          RowBox[{
           RowBox[{
            RowBox[{"iflux", "[", "i", "]"}], "[", "sp", "]"}], "=", 
           RowBox[{"ListInterpolation", "[", 
            RowBox[{
             RowBox[{"flux", "[", "i", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
             RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "flen"}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"LP", "[", "1", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "7"}], ",", "All", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{
        RowBox[{"LP", "[", "2", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "4"}], ",", "All", ",", "3"}], "]"}], "]"}]}], ";", 
       RowBox[{
        RowBox[{"LP", "[", "3", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "3"}], ",", "All", ",", "3"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"CP", "[", "1", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "4"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{
        RowBox[{"CP", "[", "2", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "3"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";"}], 
      "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"gaxx", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"th", "=", 
            RowBox[{
             FractionBox["\[Pi]", "thlen"], 
             RowBox[{"(", 
              RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
           RowBox[{"Import", "[", 
            RowBox[{
            "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\\
poliresa\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", 
               RowBox[{"100", 
                RowBox[{"sptab", "[", 
                 RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
             "\"\<th\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Floor", "[", 
               RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<fn\>\"", "<>", 
             RowBox[{"ToString", "[", "fnum", "]"}], "<>", 
             "\"\<boo.dat\>\""}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}]}], ";", 
       RowBox[{"gat", "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          FractionBox[
           RowBox[{"Total", "[", 
            RowBox[{"gaxx", ",", 
             RowBox[{"{", "1", "}"}]}], "]"}], "ind"], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"flen", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"gat", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", ";;", "11"}], ",", "2"}], "]"}], "]"}], ",", 
            RowBox[{"gat", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
       RowBox[{"Off", "[", 
        RowBox[{
         RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
         RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"gat", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{"gat", ",", "flen"}], "]"}]}], ";", 
       RowBox[{"rholen", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"Position", "[", 
          RowBox[{
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "6"}], 
             "]"}], "]"}], ",", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1", ",", "1", ",", "6"}], "]"}], "]"}]}], 
          "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"rholen", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"Position", "[", 
          RowBox[{
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "8"}], 
             "]"}], "]"}], ",", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}]}], 
          "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"gat", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", 
       RowBox[{"dim", "=", 
        RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", 
       RowBox[{"hlen", "=", 
        RowBox[{"dim", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", 
       RowBox[{"hmin", "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "8"}], 
           "]"}], "]"}], "]"}]}], ";", 
       RowBox[{"hmax", "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], 
          "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"thmin", "=", 
        RowBox[{
         FractionBox["\[Pi]", "thlen"], 
         RowBox[{"(", 
          RowBox[{"1", "-", ".5"}], ")"}]}]}], ";", 
       RowBox[{"thmax", "=", 
        RowBox[{"\[Pi]", "-", "thmin"}]}], ";", 
       RowBox[{"rhomax", "=", 
        RowBox[{"Log", "[", 
         FractionBox[
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "9"}], "]"}], "]"}], 
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", 
             FractionBox[
              RowBox[{"flen", "+", "1"}], "2"], ",", "1", ",", "1", ",", 
             "9"}], "]"}], "]"}]], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"rateint", "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], 
             "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"raterho", "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "9"}], "]"}],
             "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
       "\n", "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"flux", "[", "i", "]"}], "=", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "All", ",", "i", ",", "All", ",", "3"}], 
             "]"}], "]"}]}], ";", 
          RowBox[{
           RowBox[{
            RowBox[{"iflux", "[", "i", "]"}], "[", "sp", "]"}], "=", 
           RowBox[{"ListInterpolation", "[", 
            RowBox[{
             RowBox[{"flux", "[", "i", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
             RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "flen"}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"LP", "[", "1", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "7"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{
        RowBox[{"LP", "[", "2", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "4"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
       RowBox[{
        RowBox[{"LP", "[", "3", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "3"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"CP", "[", "1", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "4"}], ",", "All", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{
        RowBox[{"CP", "[", "2", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "3"}], ",", "All", ",", "6"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"iCPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
          RowBox[{"ListInterpolation", "[", 
           RowBox[{
            RowBox[{"CP", "[", "i", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
            RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"iLPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
          RowBox[{"ListInterpolation", "[", 
           RowBox[{
            RowBox[{"LP", "[", "i", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
            RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"lipFnux", "[", "sp", "]"}], "=", 
        RowBox[{"Total", "[", 
         FractionBox[
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox[
             RowBox[{
              RowBox[{"tofit", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                 "2"}], "]"}], "]"}], "-", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                  RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                 "&"}], "/@", 
                RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], 
             RowBox[{"dFnu", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
              "]"}]], ")"}], "2"], 
          RowBox[{"nF", "-", "3"}]], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "=", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"nP", "-", "3"}]], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Total", "[", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"tofit", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                    "2"}], "]"}], "]"}], "-", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                    "&"}], "/@", 
                   RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], ")"}], "/", 
               RowBox[{"dFnu", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
                "]"}]}], ")"}], "2"], "]"}], "+", 
           RowBox[{"Total", "[", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               FractionBox["1", "dCP"], 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"tofit", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"iCPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                    "&"}], "/@", 
                   RowBox[{"Range", "[", "2", "]"}]}], ")"}]}], ")"}]}], 
              ")"}], "2"], "]"}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"tofit", "[", 
                 RowBox[{"[", 
                  RowBox[{"5", ",", "3"}], "]"}], "]"}], "-", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"iLPx", "[", "1", "]"}], "[", "sp", "]"}], "[", 
                  RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                 ")"}]}], ")"}], 
              RowBox[{"dLP", "[", 
               RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
           RowBox[{"Total", "[", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"tofit", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "-", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"iLPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                    "&"}], "/@", 
                   RowBox[{"{", 
                    RowBox[{"2", ",", "3"}], "}"}]}], ")"}]}], ")"}], "/", 
               RowBox[{"dLP", "[", 
                RowBox[{"[", 
                 RowBox[{"2", ";;", "3"}], "]"}], "]"}]}], ")"}], "2"], 
            "]"}]}], ")"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Fdistx", "=", 
        RowBox[{
         RowBox[{"PDF", "[", 
          RowBox[{
           RowBox[{"ChiSquareDistribution", "[", 
            RowBox[{"nF", "-", "3"}], "]"}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"nF", "-", "3"}], ")"}], " ", 
            RowBox[{"lipFnux", "[", "sp", "]"}]}]}], "]"}], 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Ldistx", "=", 
        RowBox[{
         RowBox[{"PDF", "[", 
          RowBox[{
           RowBox[{"ChiSquareDistribution", "[", 
            RowBox[{"nP", "-", "3"}], "]"}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"nP", "-", "3"}], ")"}], " ", 
            RowBox[{"lipFnuCPLPx", "[", "sp", "]"}]}]}], "]"}], 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"PFnux", "=", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{"Fdistx", ",", 
          RowBox[{"{", 
           RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"rhonor", ",", 
            RowBox[{
             RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
            RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"PCPLPx", "=", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{"Ldistx", ",", 
          RowBox[{"{", 
           RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"rhonor", ",", 
            RowBox[{
             RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
            RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}],
        ";", 
       RowBox[{"(*", 
        RowBox[{
        "uncomment", " ", "for", " ", "computation", " ", "of", " ", 
         "probability"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prob", "[", "sp", "]"}], "=", 
        RowBox[{"{", 
         RowBox[{"PFnux", ",", "PCPLPx"}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\< sp=\>\"", ",", 
         RowBox[{"sptab", "[", 
          RowBox[{"[", "sp", "]"}], "]"}], ",", 
         "\"\<; Probabilities: P(Fnu)=\>\"", ",", "PFnux", ",", 
         "\"\<; PCPLP=\>\"", ",", "PCPLPx"}], "]"}], ";", 
       RowBox[{"(*", 
        RowBox[{
        "uncomment", " ", "for", " ", "computation", " ", "of", " ", 
         "probability"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"resFLC", "[", "sp", "]"}], "=", 
        RowBox[{"NMinimize", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], ",", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"hmin", "<", "heat", "<", "hmax"}], ")"}], "&&", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "rhomax"}], "<", "rhonor", "<", "rhomax"}], ")"}],
              "&&", 
             RowBox[{"(", 
              RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}], ")"}]}]}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "}"}], ",", 
          RowBox[{"Method", "\[Rule]", "\"\<DifferentialEvolution\>\""}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<sp=\>\"", ",", 
         RowBox[{"sptab", "[", 
          RowBox[{"[", "sp", "]"}], "]"}], ",", 
         "\"\<; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=\>\"", ",", 
         RowBox[{
          RowBox[{"resFLC", "[", "sp", "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         "\"\< for \!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\),LP,CP at  rhonor=\>\
\"", ",", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"raterho", "[", 
             RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], "]"}],
           "/.", 
          RowBox[{
           RowBox[{"resFLC", "[", "sp", "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<; heat=\>\"", ",", 
         RowBox[{
          RowBox[{"Exp", "[", "heat", "]"}], "/.", 
          RowBox[{
           RowBox[{"resFLC", "[", "sp", "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<;  \[Theta]=\>\"", ",", 
         RowBox[{"\[Theta]", "/.", 
          RowBox[{
           RowBox[{"resFLC", "[", "sp", "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"resF", "[", "sp", "]"}], "=", 
        RowBox[{"NMinimize", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"lipFnux", "[", "sp", "]"}], ",", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"hmin", "<", "heat", "<", "hmax"}], ")"}], "&&", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "rhomax"}], "<", "rhonor", "<", "rhomax"}], ")"}],
              "&&", 
             RowBox[{"(", 
              RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}], ")"}]}]}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "}"}], ",", 
          RowBox[{"Method", "\[Rule]", "\"\<DifferentialEvolution\>\""}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<sp=\>\"", ",", 
         RowBox[{"sptab", "[", 
          RowBox[{"[", "sp", "]"}], "]"}], ",", 
         "\"\<; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=\>\"", ",", 
         RowBox[{
          RowBox[{"resF", "[", "sp", "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         "\"\< for \!\(\*SubscriptBox[\(F\), \(\(\[Nu]\)\(\\\ \\\ \\\ \\\ \\\ \
\\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \)\)]\)at  \
rhonor=\>\"", ",", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"raterho", "[", 
             RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], "]"}],
           "/.", 
          RowBox[{
           RowBox[{"resF", "[", "sp", "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<; heat=\>\"", ",", 
         RowBox[{
          RowBox[{"Exp", "[", "heat", "]"}], "/.", 
          RowBox[{
           RowBox[{"resF", "[", "sp", "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<;  \[Theta]=\>\"", ",", 
         RowBox[{"\[Theta]", "/.", 
          RowBox[{
           RowBox[{"resF", "[", "sp", "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";", "\n", 
       RowBox[{"If", "[", 
        RowBox[{"avg", ",", 
         RowBox[{
          RowBox[{"hmean", "=", 
           RowBox[{"Exp", "[", 
            RowBox[{
             FractionBox["1", "PFnux"], 
             RowBox[{"NIntegrate", "[", 
              RowBox[{
               RowBox[{"heat", " ", "Fdistx"}], ",", 
               RowBox[{"{", 
                RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"rhonor", ",", 
                 RowBox[{
                  RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                 RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
              "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"rhomean", "=", 
           RowBox[{"Re", "[", 
            RowBox[{"Exp", "[", 
             RowBox[{
              FractionBox["1", "PFnux"], 
              RowBox[{"NIntegrate", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"rateint", "[", 
                    RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}],
                   ")"}], "Fdistx"}], ",", 
                RowBox[{"{", 
                 RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"rhonor", ",", 
                  RowBox[{
                   RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                  RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
               "]"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"\[Theta]mean", "=", 
           RowBox[{"Re", "[", 
            RowBox[{
             FractionBox["1", "PFnux"], 
             RowBox[{"NIntegrate", "[", 
              RowBox[{
               RowBox[{"\[Theta]", " ", "Fdistx"}], ",", 
               RowBox[{"{", 
                RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"rhonor", ",", 
                 RowBox[{
                  RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                 RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
              "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<Over Fnu fits:  <h> = \>\"", ",", "hmean", ",", 
            "\"\<;  <Mdot> = \>\"", ",", "rhomean", ",", 
            "\"\<;  <\[Theta]>=\>\"", ",", "\[Theta]mean"}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"hmean", "=", 
           RowBox[{"Re", "[", 
            RowBox[{"Exp", "[", 
             RowBox[{
              FractionBox["1", "PCPLPx"], 
              RowBox[{"NIntegrate", "[", 
               RowBox[{
                RowBox[{"heat", " ", "Ldistx"}], ",", 
                RowBox[{"{", 
                 RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"rhonor", ",", 
                  RowBox[{
                   RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                  RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
               "]"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"\[Theta]mean", "=", 
           RowBox[{"Re", "[", 
            RowBox[{
             FractionBox["1", "PCPLPx"], 
             RowBox[{"NIntegrate", "[", 
              RowBox[{
               RowBox[{"\[Theta]", " ", "Ldistx"}], ",", 
               RowBox[{"{", 
                RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"rhonor", ",", 
                 RowBox[{
                  RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                 RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
              "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"rhomean", "=", 
           RowBox[{"Re", "[", 
            RowBox[{"Exp", "[", 
             RowBox[{
              FractionBox["1", "PCPLPx"], 
              RowBox[{"NIntegrate", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"rateint", "[", 
                    RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}],
                   ")"}], "Ldistx"}], ",", 
                RowBox[{"{", 
                 RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"rhonor", ",", 
                  RowBox[{
                   RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                  RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
               "]"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<Over FnuCPLP fits:  <h> = \>\"", ",", "hmean", ",", 
            "\"\<;  <Mdot> = \>\"", ",", "rhomean", ",", 
            "\"\<;  <\[Theta]>=\>\"", ",", "\[Theta]mean"}], "]"}]}]}], 
        "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"sp", ",", "1", ",", "5"}], "}"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{"\"\<Computed in \>\"", ",", 
     RowBox[{"Round", "[", 
      RowBox[{
       RowBox[{"TimeUsed", "[", "]"}], "-", "t"}], "]"}], ",", 
     "\"\< seconds\>\""}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5211267716318865`*^9, 3.521126872999685*^9}, {
   3.521126987946833*^9, 3.5211269889608345`*^9}, {3.5267610949398823`*^9, 
   3.5267611247465878`*^9}, {3.526761256764138*^9, 3.5267612577971973`*^9}, {
   3.526761360000043*^9, 3.5267613744558697`*^9}, {3.5267614898954725`*^9, 
   3.526761492769637*^9}, {3.5267617132852497`*^9, 3.5267617749997797`*^9}, {
   3.5267623789133215`*^9, 3.526762384294629*^9}, {3.5267624230078435`*^9, 
   3.526762500271263*^9}, 3.526762633906906*^9, {3.528239599207718*^9, 
   3.5282396002707787`*^9}, {3.5284728205771313`*^9, 3.528472851772916*^9}, {
   3.5284732714469194`*^9, 3.52847330065559*^9}, {3.528473991615111*^9, 
   3.528473991685115*^9}, {3.5284740383097816`*^9, 3.5284740407509212`*^9}, {
   3.5284751168594713`*^9, 3.5284751204676776`*^9}, {3.528492303302278*^9, 
   3.5284923042372923`*^9}, {3.52849261176511*^9, 3.52849261435765*^9}, {
   3.5284926468646727`*^9, 3.5284926493842134`*^9}, 3.5284932869111166`*^9, {
   3.5285077208948345`*^9, 3.528507726508156*^9}, {3.5285079597424965`*^9, 
   3.5285080098893642`*^9}, {3.528508055423969*^9, 3.528508092733103*^9}, {
   3.528508482548399*^9, 3.5285084848105288`*^9}, {3.528762570364758*^9, 
   3.5287626136427536`*^9}, {3.5287626828890467`*^9, 
   3.5287626834696207`*^9}, {3.528762719035637*^9, 3.5287627518783073`*^9}, {
   3.529201501725095*^9, 3.529201503333187*^9}, {3.5293355621892023`*^9, 
   3.5293355657164044`*^9}, {3.5293650577787447`*^9, 3.529365058377779*^9}, {
   3.5294107590855923`*^9, 3.5294107604846725`*^9}, {3.529410885070798*^9, 
   3.52941091866772*^9}, {3.52941095607786*^9, 3.5294109665964613`*^9}, {
   3.529411027227929*^9, 3.529411041707757*^9}, {3.5296831483887043`*^9, 
   3.52968315163589*^9}}],

Cell["\<\
{4.48, 2.09, 3.31, 3.91, 3.71} - random exploration
0.00 4.4831 0.7358 0.41680 1051247.91196 7.608e-08
0.50 2.0956 2.0304 0.38473 924988.66162 2.713e-08
0.70 3.3066 2.1546 0.31866 1097040.00000 3.713e-08
0.90 3.9064 2.1426 0.40969 647457.34623 1.015e-08
0.98 3.7110 2.1139 0.40783 414295.83116 1.733e-08\
\>", "Text",
 CellChangeTimes->{{3.529683570631566*^9, 3.5296835958568106`*^9}, {
   3.5296849724841785`*^9, 3.529684998567425*^9}, 3.529685036444291*^9, 
   3.530362967371216*^9, {3.5303630788195906`*^9, 3.53036308091471*^9}, {
   3.530363121884053*^9, 3.530363185131671*^9}}],

Cell[BoxData[{
 RowBox[{
  FractionBox["180", "\[Pi]"], 
  RowBox[{"(", 
   RowBox[{"\[Pi]", "-", 
    RowBox[{"{", 
     RowBox[{"2.0304", ",", "2.1546", ",", "2.1426", ",", "2.1139"}], "}"}]}],
    ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox["180", "\[Pi]"], "0.7358", 
  RowBox[{"(*", 
   RowBox[{"spin", " ", "0"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.530362942955819*^9, 3.5303629582126923`*^9}, {
  3.530363038996312*^9, 3.5303630570923476`*^9}, {3.53036337655462*^9, 
  3.530363398962901*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"resFLC", "[", "2", "]"}], "[", 
  RowBox[{"[", "2", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.529410703724426*^9, 3.5294107183042593`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"determine", " ", "flow", " ", "parameters"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"sp", "=", "2"}], ";", 
    RowBox[{"rhonor", "=", 
     RowBox[{"(", 
      RowBox[{"rhonor", "/.", 
       RowBox[{
        RowBox[{"resFLC", "[", "sp", "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], ";", 
    RowBox[{"heat", "=", 
     RowBox[{"(", 
      RowBox[{"Exp", "[", 
       RowBox[{"heat", "/.", 
        RowBox[{
         RowBox[{"resFLC", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ")"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"atab", "=", 
     RowBox[{"{", 
      RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], 
      "}"}]}], ";", 
    RowBox[{"sptab", "=", 
     RowBox[{"{", 
      RowBox[{
      "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
       ",", "\"\<098\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nmtab", "=", 
     RowBox[{"{", 
      RowBox[{"8", ",", "8", ",", "8", ",", "9", ",", "9"}], "}"}]}], ";", 
    RowBox[{"ncuttab", "=", 
     RowBox[{"{", 
      RowBox[{"145", ",", "147", ",", "149", ",", "153", ",", "162"}], 
      "}"}]}], ";", 
    RowBox[{"a", "=", 
     RowBox[{"atab", "[", 
      RowBox[{"[", "sp", "]"}], "]"}]}], ";", 
    RowBox[{"nm", "=", 
     RowBox[{"nmtab", "[", 
      RowBox[{"[", "sp", "]"}], "]"}]}], ";", 
    RowBox[{"ncut", "=", 
     RowBox[{"ncuttab", "[", 
      RowBox[{"[", "sp", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xx", "=", 
     RowBox[{"Import", "[", 
      RowBox[{"\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\a\>\"", "<>", 
       RowBox[{"sptab", "[", 
        RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<\\\\Tsmap\>\"", "<>", 
       RowBox[{"sptab", "[", 
        RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<.dat\>\""}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rhoout", "=", "130"}], ";", 
    RowBox[{"rmax", "=", 
     RowBox[{"3.4", " ", 
      SuperscriptBox["10", "5"]}]}], ";", 
    RowBox[{"rcut", "=", 
     RowBox[{"xx", "[", 
      RowBox[{"[", 
       RowBox[{"ncut", ",", "1"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rhopo", "=", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Log", "[", 
        RowBox[{
         RowBox[{"rhoout", "/", "rhonor"}], "/", 
         RowBox[{
          RowBox[{"xx", "[", 
           RowBox[{"[", "ncut", "]"}], "]"}], "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}], "/", 
      RowBox[{"Log", "[", 
       RowBox[{"rmax", "/", "rcut"}], "]"}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"rhocon", "=", 
     RowBox[{"rhonor", "*", 
      RowBox[{"xx", "[", 
       RowBox[{"[", 
        RowBox[{"ncut", ",", "3"}], "]"}], "]"}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Ucon", "=", 
     RowBox[{"xx", "[", 
      RowBox[{"[", 
       RowBox[{"ncut", ",", "2"}], "]"}], "]"}]}], ";", 
    RowBox[{"ruru", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"rg", "\[Rule]", 
        FractionBox[
         RowBox[{"2", " ", "6.67", " ", 
          SuperscriptBox["10", 
           RowBox[{"-", "8"}]], "4.5", " ", 
          SuperscriptBox["10", "6"], "2", " ", 
          SuperscriptBox["10", "33"]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"3", " ", 
            SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
       RowBox[{"arcsec", "\[Rule]", 
        FractionBox[
         RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
          SuperscriptBox["10", "3"], "3.08", " ", 
          SuperscriptBox["10", "18"]}], 
         RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
       RowBox[{"pc", "\[Rule]", 
        RowBox[{"3.08", " ", 
         SuperscriptBox["10", "18"]}]}], ",", 
       RowBox[{"year", "\[Rule]", 
        RowBox[{"365.35", " ", "86400"}]}], ",", 
       RowBox[{"cc", "\[Rule]", 
        RowBox[{"3.", " ", 
         SuperscriptBox["10", "10"]}]}], ",", 
       RowBox[{"Msun", "\[Rule]", 
        RowBox[{"2.", " ", 
         SuperscriptBox["10", "33"]}]}], ",", 
       RowBox[{"mp", "\[Rule]", 
        RowBox[{"1.67", " ", 
         SuperscriptBox["10", 
          RowBox[{"-", "24"}]]}]}], ",", 
       RowBox[{"me", "\[Rule]", 
        RowBox[{"9.1", " ", 
         SuperscriptBox["10", 
          RowBox[{"-", "28"}]]}]}], ",", 
       RowBox[{"kb", "\[Rule]", 
        RowBox[{"1.38", " ", 
         SuperscriptBox["10", 
          RowBox[{"-", "16"}]]}]}], ",", 
       RowBox[{"h", "\[Rule]", 
        RowBox[{"6.626", " ", 
         SuperscriptBox["10", 
          RowBox[{"-", "27"}]]}]}], ",", 
       RowBox[{"ee", "\[Rule]", 
        RowBox[{"4.8", " ", 
         SuperscriptBox["10", 
          RowBox[{"-", "10"}]]}]}], ",", 
       RowBox[{"keV", "->", 
        RowBox[{"1000", " ", "1.602", " ", 
         SuperscriptBox["10", 
          RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rategs", "=", 
     RowBox[{
      RowBox[{"4.5", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "8"}]], " ", 
       RowBox[{"Msun", "/", "year"}]}], "/.", "ruru"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rtab", "=", 
     RowBox[{"xx", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
    RowBox[{"rntab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"rcut", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["rcut", "rmax"], ")"}], 
         RowBox[{"-", 
          FractionBox["i", "100"]}]]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "100"}], "}"}]}], "]"}]}], ";", 
    RowBox[{"\[Rho]fun", "=", 
     RowBox[{"rhocon", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["r", "rcut"], ")"}], 
       RowBox[{"-", "rhopo"}]]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vrvr", "=", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["rategs", 
        RowBox[{"2", " ", "cc", " ", "mp", " ", 
         SuperscriptBox["rg", "2"], 
         SuperscriptBox["r", "2"], "\[Rho]inter", " "}]]}], "/.", "ruru"}]}], 
    ";", 
    RowBox[{"dcap", "=", 
     RowBox[{"(", 
      RowBox[{"2.", "-", 
       FractionBox["0.49", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"0.7", "+", " ", 
           SuperscriptBox["cser", "2"]}], ")"}], "2"]]}], ")"}]}], ";", 
    RowBox[{"Tsfun", "=", 
     RowBox[{"Ucon", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["r", "rcut"], ")"}], 
       RowBox[{"-", "0.98"}]]}]}], ";", 
    RowBox[{"Tstab", "=", 
     RowBox[{"xx", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"1", ";;", "ncut"}], ",", 
        RowBox[{"1", ";;", "2"}]}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Tsinter", "=", 
     RowBox[{
      RowBox[{"Interpolation", "[", 
       RowBox[{"Join", "[", 
        RowBox[{"Tstab", ",", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"rntab", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Tsfun", "/.", 
               RowBox[{"r", "\[Rule]", "#"}]}], "&"}], "/@", "rntab"}]}], 
           "}"}], "]"}]}], "]"}], "]"}], "[", "r", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sysm", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"tail", "=", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Dts", "=", 
                RowBox[{"D", "[", 
                 RowBox[{"Tsinter", ",", "r"}], "]"}]}], ";", 
               RowBox[{"\[Nu]c", "=", 
                RowBox[{"8.9", " ", 
                 SuperscriptBox["10", 
                  RowBox[{"-", "11"}]], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox[
                    RowBox[{"Te", "[", "r", "]"}], 
                    RowBox[{"3", " ", 
                    SuperscriptBox["10", "10"]}]], ")"}], 
                  RowBox[{"-", 
                   FractionBox["3", "2"]}]], 
                 FractionBox["\[Rho]fun", 
                  SuperscriptBox["10", "7"]]}]}]}], ")"}], 
             FractionBox[
              RowBox[{"2", " ", "mp", " ", 
               SuperscriptBox["rg", "3"], 
               SuperscriptBox["r", "2"], "\[Rho]fun", " "}], "rategs"], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Tp", "[", "r", "]"}], "-", 
               RowBox[{"Te", "[", "r", "]"}]}], ")"}]}], "+", 
            RowBox[{"2", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                FractionBox[
                 SqrtBox[
                  RowBox[{"Tp", "[", "r", "]"}]], 
                 RowBox[{
                  SqrtBox[
                   RowBox[{"Tp", "[", "r", "]"}]], "+", 
                  RowBox[{"heat", 
                   SqrtBox[
                    RowBox[{"Te", "[", "r", "]"}]]}]}]], ")"}], "-", 
               RowBox[{
                FractionBox["1", "dcap"], 
                RowBox[{"(", 
                 RowBox[{"1", 
                  FractionBox[
                   RowBox[{"heat", 
                    SqrtBox[
                    RowBox[{"Te", "[", "r", "]"}]]}], 
                   RowBox[{
                    SqrtBox[
                    RowBox[{"Tp", "[", "r", "]"}]], "+", 
                    RowBox[{"heat", 
                    SqrtBox[
                    RowBox[{"Te", "[", "r", "]"}]]}]}]]}], ")"}]}]}], ")"}], 
             "Dts"}]}]}], ";", 
          RowBox[{
           RowBox[{
            RowBox[{"Te", "'"}], "[", "r", "]"}], "==", 
           FractionBox[
            RowBox[{
             RowBox[{"2", "Dts"}], "-", "tail"}], 
            RowBox[{"dcap", "+", "1"}]]}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"Tp", "'"}], "[", "r", "]"}], "\[Equal]", 
          RowBox[{"tail", "+", 
           FractionBox[
            RowBox[{
             RowBox[{"2", "Dts"}], "-", "tail"}], 
            RowBox[{"dcap", "+", "1"}]]}]}]}], "}"}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Theta]e", "\[Rule]", 
          FractionBox[
           RowBox[{"kb", " ", 
            RowBox[{"Te", "[", "r", "]"}]}], 
           RowBox[{"me", " ", 
            SuperscriptBox["cc", "2"]}]]}], ",", 
         RowBox[{"cser", "\[Rule]", 
          SqrtBox[
           FractionBox[
            RowBox[{"kb", " ", 
             RowBox[{"Te", "[", "r", "]"}]}], 
            RowBox[{"me", " ", 
             SuperscriptBox["cc", "2"]}]]]}], ",", 
         RowBox[{"cspr", "\[Rule]", 
          SqrtBox[
           FractionBox[
            RowBox[{"kb", " ", 
             RowBox[{"Tp", "[", "r", "]"}]}], 
            RowBox[{"mp", " ", 
             SuperscriptBox["cc", "2"]}]]]}]}], "}"}]}], "/.", "ruru"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Off", "[", 
     RowBox[{"FindRoot", "::", "\"\<lstol\>\""}], "]"}], ";", 
    RowBox[{"tosol", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", 
       RowBox[{"sysm", ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"Tp", "[", "r", "]"}], "==", "Tsinter"}], ",", 
           RowBox[{
            RowBox[{"Te", "[", "r", "]"}], "\[Equal]", "Tsinter"}]}], "}"}], "/.", 
         RowBox[{"r", "\[Rule]", "rmax"}]}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"solnew", "=", 
     RowBox[{
      RowBox[{"NDSolve", "[", 
       RowBox[{"tosol", ",", 
        RowBox[{"{", 
         RowBox[{"Tp", ",", "Te"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"r", ",", 
          RowBox[{"rtab", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", "rmax"}], "}"}]}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{"\"\<\!\(\*OverscriptBox[\(M\), \(.\)]\)=\>\"", ",", 
     RowBox[{"N", "[", 
      RowBox[{"Floor", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"rateint", "[", 
            RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], "]"}], 
         "/.", 
         RowBox[{
          RowBox[{"resFLC", "[", "sp", "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ",", 
        SuperscriptBox["10", 
         RowBox[{"-", "10"}]]}], "]"}], "]"}], ",", 
     "\"\< Msun/yr;  \[Theta]=\>\"", ",", 
     RowBox[{"Floor", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox["180", "\[Pi]"], 
         RowBox[{"(", 
          RowBox[{"\[Pi]", "-", "\[Theta]"}], ")"}]}], "/.", 
        RowBox[{
         RowBox[{"resFLC", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", "0.1"}], "]"}], ",", 
     "\"\<\[Degree];  \!\(\*FractionBox[\(Tp\), \(Te\)]\)=\>\"", ",", " ", 
     RowBox[{"Floor", "[", 
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{"Tp", "[", "6", "]"}], 
         RowBox[{"Te", "[", "6", "]"}]], "/.", "solnew"}], ",", "0.1"}], 
      "]"}], ",", "\"\< at 6M; Te[6M]=\>\"", ",", 
     RowBox[{"N", "[", 
      RowBox[{"Floor", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Te", "[", "6", "]"}], "/.", "solnew"}], ",", 
        SuperscriptBox["10", "8"]}], "]"}], "]"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Clear", "[", 
     RowBox[{"sp", ",", "co", ",", "rhonor", ",", "heat"}], "]"}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{
  3.504281307174*^9, {3.504353694981*^9, 3.504353840008*^9}, {
   3.504354006301*^9, 3.504354102815*^9}, {3.504354136771*^9, 
   3.504354153587*^9}, {3.5043544822019997`*^9, 3.504354536822*^9}, {
   3.504354671208*^9, 3.5043547002530003`*^9}, {3.5043548315699997`*^9, 
   3.5043549369849997`*^9}, {3.529410546518434*^9, 3.529410581821453*^9}, 
   3.529410662781084*^9, {3.5294107294498973`*^9, 3.5294107306939683`*^9}, {
   3.529411243985327*^9, 3.5294112513927507`*^9}}],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Ftab", "=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
         RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "&"}], "/@", 
       RowBox[{"Range", "[", "7", "]"}]}], "/.", 
      RowBox[{
       RowBox[{"resFLC", "[", "sp", "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"CPtab", "=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"iCPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
         RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "&"}], "/@", 
       RowBox[{"Range", "[", "2", "]"}]}], "/.", 
      RowBox[{
       RowBox[{"resFLC", "[", "sp", "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"LPtab", "=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"iLPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
         RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "&"}], "/@", 
       RowBox[{"Range", "[", "3", "]"}]}], "/.", 
      RowBox[{
       RowBox[{"resFLC", "[", "sp", "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"sp", ",", "\"\< \[Implies] \>\"", ",", 
      RowBox[{"{", 
       RowBox[{"Ftab", ",", "CPtab", ",", "LPtab"}], "}"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"sp", ",", "1", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5282403826715293`*^9, 3.528240382742533*^9}, {
   3.5282405515181866`*^9, 3.528240582974986*^9}, {3.528240958008436*^9, 
   3.5282409580714397`*^9}, {3.5284733140993595`*^9, 3.528473318121589*^9}, 
   3.5284736559009094`*^9, {3.5285084246910896`*^9, 3.5285084275392523`*^9}}],

Cell[BoxData[
 RowBox[{"inord", "\[Rule]", 
  RowBox[{"{", 
   RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5285089506971755`*^9, 3.5285089543193827`*^9}}],

Cell[BoxData[
 RowBox[{"inord", "\[Rule]", 
  RowBox[{"{", 
   RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5285084751699767`*^9, 3.5285084895998025`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "dir", "=", 
   "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fmin", "=", "6950"}], ";", 
  RowBox[{"fmax", "=", "9950"}], ";", 
  RowBox[{"ind", "=", "11"}], ";", 
  RowBox[{"sep", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"ind", "-", "1"}], ")"}]}]}], ";", 
  RowBox[{"sp", "=", "2"}], ";", 
  RowBox[{"thlen", "=", "50"}], ";", 
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{
  "dir", "=", 
   "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\\>\""}], ";", 
  RowBox[{"th", "=", 
   RowBox[{
    RowBox[{
     FractionBox["\[Pi]", "thlen"], 
     RowBox[{"(", 
      RowBox[{"thn", "-", ".5"}], ")"}]}], "/.", 
    RowBox[{"thn", "\[Rule]", "33"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"tata", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"gat", "=", 
      RowBox[{"Import", "[", 
       RowBox[{"dir", "<>", "\"\<poliresa\>\"", "<>", 
        RowBox[{"ToString", "[", 
         RowBox[{"Round", "[", 
          RowBox[{"100", 
           RowBox[{"sptab", "[", 
            RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
        "\"\<th\>\"", "<>", 
        RowBox[{"ToString", "[", 
         RowBox[{"Floor", "[", 
          RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<fn\>\"", "<>", 
        RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Partition", "[", 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{"gat", ",", "7"}], "]"}], ",", "7"}], "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"17", ",", "4"}], "]"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.52853885773276*^9, 3.5285390026060467`*^9}, {
  3.5285393934234*^9, 3.528539399965774*^9}, {3.5285394547139053`*^9, 
  3.528539465349514*^9}}],

Cell[BoxData[{
 RowBox[{"tata", "[", 
  RowBox[{"[", 
   RowBox[{"All", ",", "All", ",", "3"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tata", "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", "1", ",", "4"}], "]"}], "]"}], 
  RowBox[{"(*", "LP88", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tata", "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", "4", ",", "4"}], "]"}], "]"}], 
  RowBox[{"(*", "LP230", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tata", "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", "5", ",", "4"}], "]"}], "]"}], 
  RowBox[{"(*", "LP345", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tata", "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", "4", ",", "6"}], "]"}], "]"}], 
  RowBox[{"(*", "CP230", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tata", "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", "5", ",", "6"}], "]"}], "]"}], 
  RowBox[{"(*", "CP345", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.528539483136531*^9, 3.5285395073049135`*^9}, {
  3.5285395766258783`*^9, 3.5285396999299307`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"averaging", ":"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"fmin", "=", "6950"}], ";", 
    RowBox[{"fmax", "=", "9950"}], ";", 
    RowBox[{"ind", "=", "11"}], ";", 
    RowBox[{"sep", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"ind", "-", "1"}], ")"}]}]}], ";", 
    RowBox[{"thlen", "=", "50"}], ";", 
    RowBox[{"sptab", "=", 
     RowBox[{"{", 
      RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], 
      "}"}]}], ";", 
    RowBox[{
    "dir", "=", 
     "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Dynamic", "[", "sp", "]"}], ",", 
     RowBox[{"Dynamic", "[", "thn", "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"gat", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"th", "=", 
           RowBox[{
            FractionBox["\[Pi]", "thlen"], 
            RowBox[{"(", 
             RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
          RowBox[{"Import", "[", 
           RowBox[{"dir", "<>", "\"\<poliresa\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"Round", "[", 
              RowBox[{"100", 
               RowBox[{"sptab", "[", 
                RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
            "\"\<th\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"Floor", "[", 
              RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<fn\>\"", "<>", 
            RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}],
            "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"roro", "=", 
       RowBox[{"Round", "[", 
        RowBox[{
         RowBox[{"Delete", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            FractionBox[
             RowBox[{"Total", "[", "gat", "]"}], "ind"], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", "1", "}"}], ",", 
             RowBox[{"{", "7", "}"}], ",", 
             RowBox[{"{", "10", "}"}], ",", 
             RowBox[{"{", "11", "}"}], ",", 
             RowBox[{"{", "12", "}"}], ",", 
             RowBox[{"{", "13", "}"}]}], "}"}]}], "]"}], ",", "0.001"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"tot", "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{"ToString", "[", 
           RowBox[{"roro", "[", 
            RowBox[{"[", 
             RowBox[{"1", ";;", "6"}], "]"}], "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"roro", "[", 
           RowBox[{"[", "7", "]"}], "]"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{"dir", "<>", "\"\<ava\>\"", "<>", 
         RowBox[{"ToString", "[", 
          RowBox[{"Round", "[", 
           RowBox[{"100", 
            RowBox[{"sptab", "[", 
             RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
         "\"\<th\>\"", "<>", 
         RowBox[{"ToString", "[", 
          RowBox[{"Floor", "[", 
           RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<in\>\"", "<>", 
         RowBox[{"ToString", "[", "ind", "]"}], "<>", "\"\<.dat\>\""}], ",", 
        RowBox[{"Transpose", "[", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"tot", "[", 
            RowBox[{"[", 
             RowBox[{"1", ";;", "3"}], "]"}], "]"}], ",", 
           RowBox[{"Reverse", "[", 
            RowBox[{"tot", "[", 
             RowBox[{"[", 
              RowBox[{"4", ";;", "5"}], "]"}], "]"}], "]"}], ",", 
           RowBox[{"tot", "[", 
            RowBox[{"[", 
             RowBox[{"6", ";;", "7"}], "]"}], "]"}]}], "]"}], "]"}]}], 
       "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"sp", ",", "1", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5285033071203814`*^9, 3.5285033458075943`*^9}, {
  3.528503403463892*^9, 3.528503411520353*^9}, {3.5285034522496824`*^9, 
  3.528503463083302*^9}, {3.528503520254572*^9, 3.528503603740347*^9}, {
  3.5285036611566315`*^9, 3.5285037084043336`*^9}, {3.5285049062038436`*^9, 
  3.5285049601179276`*^9}, {3.5285051388131485`*^9, 3.5285051482206864`*^9}, {
  3.5285057656520014`*^9, 3.5285059404399986`*^9}, {3.528506001808509*^9, 
  3.528506022264679*^9}, {3.5285060717545094`*^9, 3.5285060768888035`*^9}, {
  3.528506121904378*^9, 3.528506152840147*^9}, {3.528506519498119*^9, 
  3.528506520983204*^9}, {3.5285066574500093`*^9, 3.528506658033043*^9}, {
  3.5285071744505796`*^9, 3.528507231953869*^9}, {3.5285073042820063`*^9, 
  3.5285073060421066`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["\[Pi]", "thlen"], 
   RowBox[{"(", 
    RowBox[{"thn", "-", ".5"}], ")"}]}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"thn", "\[Rule]", "33"}], ",", 
    RowBox[{"thlen", "\[Rule]", "50"}]}], "}"}], 
  RowBox[{"(*", 
   RowBox[{"9", ",", 
    RowBox[{"37", " ", "-", " ", 
     RowBox[{"spin", " ", "0"}]}]}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.5276973637869062`*^9, 3.527697372700416*^9}, {
  3.527833217955329*^9, 3.5278332182593465`*^9}, {3.5278333077974677`*^9, 
  3.527833314846871*^9}, {3.527833394193409*^9, 3.5278333944434233`*^9}, {
  3.528001983556769*^9, 3.5280019955274534`*^9}, {3.528491442575807*^9, 
  3.528491448263132*^9}, {3.528538900899229*^9, 3.5285389039624043`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["x analysis - no LP87, only LP231, LP345, CP231, CP345", "Subsubsection",
 CellChangeTimes->{{3.5211267243091803`*^9, 3.521126744425331*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tofit", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"8.450", ",", "0.6898", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.2500"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14.90", ",", "0.9044", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.6200"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22.50", ",", "1.070", ",", "0.1900", ",", "131.0", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"43.00", ",", "1.159", ",", "0.5041", ",", "94.25", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"87.73", ",", "1.841", ",", "1.42", ",", 
       RowBox[{"-", "4."}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"102.0", ",", "1.908", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"145.0", ",", "2.275", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"230.9", ",", "2.637", ",", "7.40", ",", "111.5", ",", 
       RowBox[{"-", "1.200"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"349.0", ",", "3.181", ",", "6.50", ",", "146.9", ",", 
       RowBox[{"-", "1.500"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"674.0", ",", "3.286", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"857.0", ",", "2.867", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"dFnu", "=", 
    RowBox[{"{", 
     RowBox[{
     "1.", ",", "1.", ",", "1.", ",", "1.", ",", "0.080", ",", "0.1517", ",", 
      "0.2644", ",", "0.1414", ",", "0.1205", ",", "0.3508", ",", "0.2404"}], 
     "}"}]}], ";", 
   RowBox[{"dCP", "=", "0.30"}], ";", 
   RowBox[{"dLP", "=", 
    RowBox[{"{", 
     RowBox[{"0.5", ",", "0.66", ",", "0.61"}], "}"}]}], 
   ";"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"nh", ",", "co"}], "]"}], ";", 
  RowBox[{"ext", "=", "1."}], ";", 
  RowBox[{"acc", "=", "16"}], ";", 
  RowBox[{"inord", "=", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], ";", 
  RowBox[{"poi3", "=", "50000"}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], "]"}], ";", 
  RowBox[{"t", "=", 
   RowBox[{"TimeUsed", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"NIntegrate", ",", 
      RowBox[{"Method", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
         RowBox[{"Method", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
            RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
      ",", 
      RowBox[{"MaxPoints", "\[Rule]", "poi3"}], ",", 
      RowBox[{"AccuracyGoal", "\[Rule]", "acc"}]}], "]"}], ";"}], "*)"}], 
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{"NIntegrate", ",", 
     RowBox[{"Method", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
        RowBox[{"Method", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
           RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
     ",", 
     RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], 
   ";"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"co", "=", "0"}], ";", 
  RowBox[{"thlen", "=", "50"}], ";", 
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"narr", "=", "1.1"}], ";", 
  RowBox[{"nF", "=", "7"}], ";", 
  RowBox[{"nP", "=", "11"}], ";", 
  RowBox[{"avg", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fmin", "=", "6950"}], ";", 
  RowBox[{"fmax", "=", "9950"}], ";", 
  RowBox[{"ind", "=", "11"}], ";", 
  RowBox[{"sep", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"ind", "-", "1"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"gat", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"th", "=", 
            RowBox[{
             FractionBox["\[Pi]", "thlen"], 
             RowBox[{"(", 
              RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
           RowBox[{"Import", "[", 
            RowBox[{
            "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\ava\
\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", 
               RowBox[{"100", 
                RowBox[{"sptab", "[", 
                 RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
             "\"\<th\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Floor", "[", 
               RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<in11\>\"", 
             "<>", "\"\<.dat\>\""}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"flen", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"1", ";;", "11"}], ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}]}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
     RowBox[{"Off", "[", 
      RowBox[{
       RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
       RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gat", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{"gat", ",", "flen"}], "]"}]}], ";", 
     RowBox[{"rholen", "=", 
      RowBox[{"Length", "[", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "6"}], "]"}], 
          "]"}], ",", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1", ",", "1", ",", "6"}], "]"}], "]"}]}], "]"}],
        "]"}]}], ";", 
     RowBox[{"gat", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", 
     RowBox[{"dim", "=", 
      RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", 
     RowBox[{"hlen", "=", 
      RowBox[{"dim", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"hmin", "=", 
      RowBox[{"Log", "[", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "6"}], "]"}],
         "]"}], "]"}]}], ";", 
     RowBox[{"hmax", "=", 
      RowBox[{"Log", "[", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "6"}], "]"}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"thmin", "=", 
      RowBox[{
       FractionBox["\[Pi]", "thlen"], 
       RowBox[{"(", 
        RowBox[{"1", "-", ".5"}], ")"}]}]}], ";", 
     RowBox[{"thmax", "=", 
      RowBox[{"\[Pi]", "-", "thmin"}]}], ";", 
     RowBox[{"rhomax", "=", 
      RowBox[{"Log", "[", 
       FractionBox[
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "7"}], "]"}], "]"}], 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"flen", "+", "1"}], ")"}], "/", "2"}], ",", "1", ",", 
           "1", ",", "7"}], "]"}], "]"}]], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"rateint", "=", 
      RowBox[{"ListInterpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], "]"}], 
          "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"raterho", "=", 
      RowBox[{"ListInterpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "7"}], "]"}], 
          "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"flux", "[", "i", "]"}], "=", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", "i", ",", "All", ",", "2"}], "]"}],
           "]"}]}], ";", 
        RowBox[{
         RowBox[{
          RowBox[{"iflux", "[", "i", "]"}], "[", "sp", "]"}], "=", 
         RowBox[{"ListInterpolation", "[", 
          RowBox[{
           RowBox[{"flux", "[", "i", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
           RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}]}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "flen"}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"LP", "[", "1", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", 
         RowBox[{"-", "7"}], ",", "All", ",", "3"}], "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"LP", "[", "2", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", 
         RowBox[{"-", "4"}], ",", "All", ",", "3"}], "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"LP", "[", "3", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", 
         RowBox[{"-", "3"}], ",", "All", ",", "3"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CP", "[", "1", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", 
         RowBox[{"-", "4"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"CP", "[", "2", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", 
         RowBox[{"-", "3"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";"}], 
    "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"gaxx", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"th", "=", 
          RowBox[{
           FractionBox["\[Pi]", "thlen"], 
           RowBox[{"(", 
            RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
         RowBox[{"Import", "[", 
          RowBox[{
          "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\\
poliresa\>\"", "<>", 
           RowBox[{"ToString", "[", 
            RowBox[{"Round", "[", 
             RowBox[{"100", 
              RowBox[{"sptab", "[", 
               RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
           "\"\<th\>\"", "<>", 
           RowBox[{"ToString", "[", 
            RowBox[{"Floor", "[", 
             RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<fn\>\"", "<>", 
           RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
          "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}]}], ";", 
     RowBox[{"gat", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"Total", "[", 
          RowBox[{"gaxx", ",", 
           RowBox[{"{", "1", "}"}]}], "]"}], "ind"], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"flen", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"1", ";;", "11"}], ",", "2"}], "]"}], "]"}], ",", 
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}]}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
     RowBox[{"Off", "[", 
      RowBox[{
       RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
       RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gat", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{"gat", ",", "flen"}], "]"}]}], ";", 
     RowBox[{"rholen", "=", 
      RowBox[{"Length", "[", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "6"}], "]"}], 
          "]"}], ",", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1", ",", "1", ",", "6"}], "]"}], "]"}]}], "]"}],
        "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"rholen", "=", 
      RowBox[{"Length", "[", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "8"}], "]"}], 
          "]"}], ",", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}]}], "]"}],
        "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"gat", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", 
     RowBox[{"dim", "=", 
      RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", 
     RowBox[{"hlen", "=", 
      RowBox[{"dim", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"hmin", "=", 
      RowBox[{"Log", "[", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}],
         "]"}], "]"}]}], ";", 
     RowBox[{"hmax", "=", 
      RowBox[{"Log", "[", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"thmin", "=", 
      RowBox[{
       FractionBox["\[Pi]", "thlen"], 
       RowBox[{"(", 
        RowBox[{"1", "-", ".5"}], ")"}]}]}], ";", 
     RowBox[{"thmax", "=", 
      RowBox[{"\[Pi]", "-", "thmin"}]}], ";", 
     RowBox[{"rhomax", "=", 
      RowBox[{"Log", "[", 
       FractionBox[
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "9"}], "]"}], "]"}], 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", 
           FractionBox[
            RowBox[{"flen", "+", "1"}], "2"], ",", "1", ",", "1", ",", "9"}], 
          "]"}], "]"}]], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"rateint", "=", 
      RowBox[{"ListInterpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], "]"}], 
          "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"raterho", "=", 
      RowBox[{"ListInterpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "9"}], "]"}], 
          "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
     "\n", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"flux", "[", "i", "]"}], "=", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", "i", ",", "All", ",", "3"}], "]"}],
           "]"}]}], ";", 
        RowBox[{
         RowBox[{
          RowBox[{"iflux", "[", "i", "]"}], "[", "sp", "]"}], "=", 
         RowBox[{"ListInterpolation", "[", 
          RowBox[{
           RowBox[{"flux", "[", "i", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
           RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}]}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "flen"}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"LP", "[", "1", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", 
         RowBox[{"-", "7"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"LP", "[", "2", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", 
         RowBox[{"-", "4"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"LP", "[", "3", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", 
         RowBox[{"-", "3"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CP", "[", "1", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", 
         RowBox[{"-", "4"}], ",", "All", ",", "6"}], "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"CP", "[", "2", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", 
         RowBox[{"-", "3"}], ",", "All", ",", "6"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"iCPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"CP", "[", "i", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"iLPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"LP", "[", "i", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"lipFnux", "[", "sp", "]"}], "=", 
      RowBox[{"Total", "[", 
       FractionBox[
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{
                RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
               "2"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], 
           RowBox[{"dFnu", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
            "]"}]], ")"}], "2"], 
        RowBox[{"nF", "-", "3"}]], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "=", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"nP", "-", "3"}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Total", "[", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                  "2"}], "]"}], "]"}], "-", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                   RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                  "&"}], "/@", 
                 RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], ")"}], "/", 
             RowBox[{"dFnu", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
              "]"}]}], ")"}], "2"], "]"}], "+", 
         RowBox[{"Total", "[", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             FractionBox["1", "dCP"], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"iCPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                   RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                  "&"}], "/@", 
                 RowBox[{"Range", "[", "2", "]"}]}], ")"}]}], ")"}]}], ")"}], 
           "2"], "]"}], "+", 
         RowBox[{"Total", "[", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "-", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"iLPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                   RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                  "&"}], "/@", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", "3"}], "}"}]}], ")"}]}], ")"}], "/", 
             RowBox[{"dLP", "[", 
              RowBox[{"[", 
               RowBox[{"2", ";;", "3"}], "]"}], "]"}]}], ")"}], "2"], "]"}]}],
         ")"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Fdistx", "=", 
      RowBox[{
       RowBox[{"PDF", "[", 
        RowBox[{
         RowBox[{"ChiSquareDistribution", "[", 
          RowBox[{"nF", "-", "3"}], "]"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"nF", "-", "3"}], ")"}], " ", 
          RowBox[{"lipFnux", "[", "sp", "]"}]}]}], "]"}], 
       RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Ldistx", "=", 
      RowBox[{
       RowBox[{"PDF", "[", 
        RowBox[{
         RowBox[{"ChiSquareDistribution", "[", 
          RowBox[{"nP", "-", "3"}], "]"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"nP", "-", "3"}], ")"}], " ", 
          RowBox[{"lipFnuCPLPx", "[", "sp", "]"}]}]}], "]"}], 
       RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"hmin", "=", 
        RowBox[{"Log", "[", "0.25", "]"}]}], ";"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"PFnux", "=", 
      RowBox[{"NIntegrate", "[", 
       RowBox[{"Fdistx", ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"rhonor", ",", 
          RowBox[{
           RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
          RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"PCPLPx", "=", 
      RowBox[{"NIntegrate", "[", 
       RowBox[{"Ldistx", ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"rhonor", ",", 
          RowBox[{
           RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
          RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"prob", "[", "sp", "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"PFnux", ",", "PCPLPx"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"PCPLPz", "=", 
         RowBox[{"NIntegrate", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Exp", "[", 
             RowBox[{"-", 
              FractionBox[
               SuperscriptBox[
                RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "2"], "2"]}], "]"}], 
            RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"rhonor", ",", 
             RowBox[{
              RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
             RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
          "]"}]}], "]"}], ";"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\< sp=\>\"", ",", 
       RowBox[{"sptab", "[", 
        RowBox[{"[", "sp", "]"}], "]"}], ",", 
       "\"\<; Probabilities: P(Fnu)=\>\"", ",", "PFnux", ",", 
       "\"\<; PCPLP=\>\"", ",", "PCPLPx"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"resFLC", "[", "sp", "]"}], "=", 
      RowBox[{"NMinimize", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"hmin", "<", "heat", "<", "hmax"}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "rhomax"}], "<", "rhonor", "<", "rhomax"}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}], ")"}]}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "}"}], ",", 
        RowBox[{"Method", "\[Rule]", "\"\<DifferentialEvolution\>\""}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<sp=\>\"", ",", 
       RowBox[{"sptab", "[", 
        RowBox[{"[", "sp", "]"}], "]"}], ",", 
       "\"\<; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=\>\"", ",", 
       RowBox[{
        RowBox[{"resFLC", "[", "sp", "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       "\"\< for \!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\),LP,CP at  \
rhonor=\>\"", ",", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"raterho", "[", 
           RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], "]"}], "/.", 
        RowBox[{
         RowBox[{"resFLC", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<; heat=\>\"", ",", 
       RowBox[{
        RowBox[{"Exp", "[", "heat", "]"}], "/.", 
        RowBox[{
         RowBox[{"resFLC", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<;  \[Theta]=\>\"", ",", 
       RowBox[{"\[Theta]", "/.", 
        RowBox[{
         RowBox[{"resFLC", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"resF", "[", "sp", "]"}], "=", 
      RowBox[{"NMinimize", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"lipFnux", "[", "sp", "]"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"hmin", "<", "heat", "<", "hmax"}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "rhomax"}], "<", "rhonor", "<", "rhomax"}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}], ")"}]}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "}"}], ",", 
        RowBox[{"Method", "\[Rule]", "\"\<DifferentialEvolution\>\""}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<sp=\>\"", ",", 
       RowBox[{"sptab", "[", 
        RowBox[{"[", "sp", "]"}], "]"}], ",", 
       "\"\<; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=\>\"", ",", 
       RowBox[{
        RowBox[{"resF", "[", "sp", "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       "\"\< for \!\(\*SubscriptBox[\(F\), \(\(\[Nu]\)\(\\\ \\\ \\\ \\\ \\\ \
\\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \)\)]\)at  \
rhonor=\>\"", ",", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"raterho", "[", 
           RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], "]"}], "/.", 
        RowBox[{
         RowBox[{"resF", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<; heat=\>\"", ",", 
       RowBox[{
        RowBox[{"Exp", "[", "heat", "]"}], "/.", 
        RowBox[{
         RowBox[{"resF", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<;  \[Theta]=\>\"", ",", 
       RowBox[{"\[Theta]", "/.", 
        RowBox[{
         RowBox[{"resF", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";", "\n", 
     RowBox[{"If", "[", 
      RowBox[{"avg", ",", 
       RowBox[{
        RowBox[{"hmean", "=", 
         RowBox[{"Exp", "[", 
          RowBox[{
           FractionBox["1", "PFnux"], 
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"heat", " ", "Fdistx"}], ",", 
             RowBox[{"{", 
              RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"rhonor", ",", 
               RowBox[{
                RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
               RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
            "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rhomean", "=", 
         RowBox[{"Re", "[", 
          RowBox[{"Exp", "[", 
           RowBox[{
            FractionBox["1", "PFnux"], 
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"rateint", "[", 
                  RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], 
                ")"}], "Fdistx"}], ",", 
              RowBox[{"{", 
               RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"rhonor", ",", 
                RowBox[{
                 RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
             "]"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Theta]mean", "=", 
         RowBox[{"Re", "[", 
          RowBox[{
           FractionBox["1", "PFnux"], 
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"\[Theta]", " ", "Fdistx"}], ",", 
             RowBox[{"{", 
              RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"rhonor", ",", 
               RowBox[{
                RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
               RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
            "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<Over Fnu fits:  <h> = \>\"", ",", "hmean", ",", 
          "\"\<;  <Mdot> = \>\"", ",", "rhomean", ",", 
          "\"\<;  <\[Theta]>=\>\"", ",", "\[Theta]mean"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"hmean", "=", 
         RowBox[{"Re", "[", 
          RowBox[{"Exp", "[", 
           RowBox[{
            FractionBox["1", "PCPLPx"], 
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{"heat", " ", "Ldistx"}], ",", 
              RowBox[{"{", 
               RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"rhonor", ",", 
                RowBox[{
                 RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
             "]"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Theta]mean", "=", 
         RowBox[{"Re", "[", 
          RowBox[{
           FractionBox["1", "PCPLPx"], 
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"\[Theta]", " ", "Ldistx"}], ",", 
             RowBox[{"{", 
              RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"rhonor", ",", 
               RowBox[{
                RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
               RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
            "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rhomean", "=", 
         RowBox[{"Re", "[", 
          RowBox[{"Exp", "[", 
           RowBox[{
            FractionBox["1", "PCPLPx"], 
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"rateint", "[", 
                  RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], 
                ")"}], "Ldistx"}], ",", 
              RowBox[{"{", 
               RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"rhonor", ",", 
                RowBox[{
                 RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
             "]"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<Over FnuCPLP fits:  <h> = \>\"", ",", "hmean", ",", 
          "\"\<;  <Mdot> = \>\"", ",", "rhomean", ",", 
          "\"\<;  <\[Theta]>=\>\"", ",", "\[Theta]mean"}], "]"}]}]}], "]"}]}],
     ",", 
    RowBox[{"{", 
     RowBox[{"sp", ",", "1", ",", "5"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Computed in \>\"", ",", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"TimeUsed", "[", "]"}], "-", "t"}], "]"}], ",", 
   "\"\< seconds\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.5211267716318865`*^9, 3.521126872999685*^9}, {
  3.521126987946833*^9, 3.5211269889608345`*^9}, {3.5267610949398823`*^9, 
  3.5267611247465878`*^9}, {3.526761256764138*^9, 3.5267612577971973`*^9}, {
  3.526761360000043*^9, 3.5267613744558697`*^9}, {3.5267614898954725`*^9, 
  3.526761492769637*^9}, {3.52676191312568*^9, 3.526761916340864*^9}, {
  3.5282400400349317`*^9, 3.528240041105993*^9}, {3.5313588705095725`*^9, 
  3.5313588929818583`*^9}, {3.5313589622938223`*^9, 3.5313589952787085`*^9}}],

Cell[BoxData[
 RowBox[{"resF", "[", "4", "]"}]], "Input",
 CellChangeTimes->{{3.5211280573665853`*^9, 3.5211280880123377`*^9}, 
   3.5282400993723254`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "5"}], ";", 
  RowBox[{"Ftab", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
       RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "&"}], "/@", 
     RowBox[{"Range", "[", "7", "]"}]}], "/.", 
    RowBox[{
     RowBox[{"resFLC", "[", "sp", "]"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CPtab", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"iCPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
       RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "&"}], "/@", 
     RowBox[{"Range", "[", "2", "]"}]}], "/.", 
    RowBox[{
     RowBox[{"resFLC", "[", "sp", "]"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LPtab", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"iLPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
        RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "]"}], "&"}],
      "/@", 
     RowBox[{"Range", "[", "2", "]"}]}], "/.", 
    RowBox[{
     RowBox[{"resFLC", "[", "sp", "]"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{"Ftab", ",", "CPtab", ",", "LPtab"}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.5282403826715293`*^9, 3.528240382742533*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "4"}], ";", 
  RowBox[{"Ftab", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
       RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "&"}], "/@", 
     RowBox[{"Range", "[", "7", "]"}]}], "/.", 
    RowBox[{
     RowBox[{"resFLC", "[", "sp", "]"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CPtab", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"iCPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
       RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "&"}], "/@", 
     RowBox[{"Range", "[", "2", "]"}]}], "/.", 
    RowBox[{
     RowBox[{"resFLC", "[", "sp", "]"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LPtab", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"iLPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
        RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "]"}], "&"}],
      "/@", 
     RowBox[{"Range", "[", "2", "]"}]}], "/.", 
    RowBox[{
     RowBox[{"resFLC", "[", "sp", "]"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{"Ftab", ",", "CPtab", ",", "LPtab"}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.5211280426877456`*^9, 3.521128045263893*^9}, {
  3.521128090024453*^9, 3.5211282665795517`*^9}}],

Cell[BoxData[
 RowBox[{"inverse", " ", "B"}]], "Input",
 CellChangeTimes->{{3.521127058334157*^9, 3.52112706009696*^9}}],

Cell[BoxData[
 RowBox[{"direct", " ", "B"}]], "Input",
 CellChangeTimes->{{3.521126977713215*^9, 3.5211269834696255`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"el", "=", 
   RowBox[{"{", 
    RowBox[{"ListLogLogPlot", ",", "ListLogLinearPlot"}], "}"}]}], ";", 
  RowBox[{"Clear", "[", "totI", "]"}], ";", 
  RowBox[{"xcol", "=", "Cyan"}], ";", 
  RowBox[{"myf", "=", "14"}], ";", 
  RowBox[{"siz", "=", "580"}], ";", 
  RowBox[{"ord", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"#", ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ","}], "*)"}], 
        RowBox[{
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "myf"}]}], "}"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"FrameTicks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"(*", 
           RowBox[{"{", 
            RowBox[{
            "10", ",", "20", ",", "50", ",", "100", ",", "200", ",", "500"}], 
            "}"}], "*)"}], 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "43", ",", "88", ",", "145", ",", "231", ",", "349", ",", "690"}],
             "}"}], ",", "None"}], "}"}]}], "}"}]}]}], "]"}], "&"}], "/@", 
   "el"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ax", "=", "30"}], ";", 
  RowBox[{"Fran", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"40", ",", "900"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.8", ",", "3.7"}], "}"}]}], "}"}]}], ";", 
  RowBox[{"LPran", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"40", ",", "860"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.4", ",", "24."}], "}"}]}], "}"}]}], ";", 
  RowBox[{"CPran", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"40", ",", "860"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2."}], ",", "2.2"}], "}"}]}], "}"}]}], ";", 
  RowBox[{"angran", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"80", ",", "860"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"80", ",", "170"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{
   "Import", "[", "\"\<E:\\\\mathematica\\\\3DMHD\\\\quicka90in11x.dat\>\"", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{"imp", ",", "7"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"plo", "[", 
    RowBox[{
     RowBox[{"nn_", "?", "IntegerQ"}], ",", 
     RowBox[{"style_", "?", "ListQ"}], ",", 
     RowBox[{"ax_", "?", "NumberQ"}]}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fff", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"imp", "[", 
        RowBox[{"[", "nn", "]"}], "]"}], "]"}]}], ";", 
     RowBox[{"ftab", "=", 
      RowBox[{"fff", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"Fnusim", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"ftab", ",", 
         RowBox[{"fff", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
     RowBox[{"LPnusim", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"ftab", ",", 
         RowBox[{"fff", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
     RowBox[{"CPnusim", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"ftab", ",", 
         RowBox[{"fff", "[", 
          RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
     RowBox[{"angsim", "=", 
      RowBox[{"Delete", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"ftab", ",", 
           RowBox[{"ax", "+", 
            RowBox[{"fff", "[", 
             RowBox[{"[", "5", "]"}], "]"}]}]}], "}"}], "]"}], ",", "1"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{"Fnusim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "Fran"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "Null", ",", 
              "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\""}], 
             "}"}]}], "}"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", "\[IndentingNewLine]", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}], ",", 
       RowBox[{"ListLogLogPlot", "[", 
        RowBox[{"LPnusim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "ord"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "LPran"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Null", ",", "\"\<LP [%]\>\""}], "}"}]}], "}"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}], ",", 
       RowBox[{"ListLogLinearPlot", "[", 
        RowBox[{"CPnusim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "ord"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Null", ",", "\"\<CP [%]\>\""}], "}"}]}], "}"}]}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "CPran"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}], ",", 
       RowBox[{"ListLogLinearPlot", "[", 
        RowBox[{"angsim", ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "siz"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "angran"}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Null", ",", "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "Null", ",", "\"\<Electric vector position angle [deg]\>\""}], 
             "}"}]}], "}"}]}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "style"}]}], "]"}]}], "}"}]}], 
    ")"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5211689178972607`*^9, 3.5211689445247836`*^9}, 
   3.52116901807199*^9, {3.521169078979474*^9, 3.5211691017387753`*^9}, {
   3.5211691999693937`*^9, 3.521169227220953*^9}, {3.521169267680267*^9, 
   3.5211692858553066`*^9}, {3.5211695798981247`*^9, 3.521169589884696*^9}, 
   3.5211698607641897`*^9}],

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"RGBColor", "[", 
     RowBox[{"0", ",", "1", ",", "0"}], "]"}], ",", 
    RowBox[{"Disk", "[", "]"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.521169671744378*^9, 3.521169694963706*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"plo", "[", 
      RowBox[{"i", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
         RowBox[{"RGBColor", "[", 
          RowBox[{"0", ",", 
           FractionBox["i", "15"], ",", 
           RowBox[{"1", "-", 
            FractionBox["i", "15"]}]}], "]"}]}], "}"}], ",", "30"}], "]"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "15"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", "tab", "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", "tab", "]"}], "[", 
   RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", "tab", "]"}], "[", 
   RowBox[{"[", "3", "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", "tab", "]"}], "[", 
   RowBox[{"[", "4", "]"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.521169287960427*^9, 3.5211693507800198`*^9}, {
  3.521169442831285*^9, 3.521169532016386*^9}, {3.5211695647182565`*^9, 
  3.521169571610651*^9}, {3.521169619771405*^9, 3.5211696253377237`*^9}}],

Cell[BoxData[
 RowBox[{"inverse", " ", "B"}]], "Input",
 CellChangeTimes->{{3.5211750783696194`*^9, 3.521175080066716*^9}}],

Cell[BoxData[
 RowBox[{"direct", " ", "B"}]], "Input",
 CellChangeTimes->{{3.521169855197871*^9, 3.521169856787962*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["best analysis - interpolating all the quantities", "Subsubsection",
 CellChangeTimes->{{3.501952273153*^9, 3.5019522815039997`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"tofit", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"8.450", ",", "0.6898", ",", "0", ",", "0", ",", 
        RowBox[{"-", "0.2500"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"14.90", ",", "0.9044", ",", "0", ",", "0", ",", 
        RowBox[{"-", "0.6200"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"22.50", ",", "1.070", ",", "0.1900", ",", "131.0", ",", "0"}],
        "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"43.00", ",", "1.159", ",", "0.5041", ",", "94.25", ",", "0"}],
        "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"87.73", ",", "1.841", ",", "1.026", ",", 
        RowBox[{"-", "4."}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"102.0", ",", "1.908", ",", "0", ",", "0", ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"145.0", ",", "2.275", ",", "0", ",", "0", ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"230.9", ",", "2.637", ",", "7.015", ",", "111.5", ",", 
        RowBox[{"-", "1.200"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"349.0", ",", "3.181", ",", "6.143", ",", "146.9", ",", 
        RowBox[{"-", "1.500"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"674.0", ",", "3.286", ",", "0", ",", "0", ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"857.0", ",", "2.867", ",", "0", ",", "0", ",", "0"}], "}"}]}],
      "}"}]}], ";", 
   RowBox[{
    RowBox[{"tofit", "[", 
     RowBox[{"[", 
      RowBox[{"5", ",", "3"}], "]"}], "]"}], "=", "2."}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"8.45", " ", "-", " ", 
    RowBox[{"43", "GHz"}], " ", "-", " ", 
    RowBox[{"still", " ", "old", " ", "data"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"dFnu", "=", 
    RowBox[{"{", 
     RowBox[{
     "1.", ",", "1.", ",", "1.", ",", "1.", ",", "0.080", ",", "0.1517", ",", 
      "0.2644", ",", "0.1414", ",", "0.1205", ",", "0.3508", ",", "0.2404"}], 
     "}"}]}], ";", 
   RowBox[{"dCP", "=", "0.30"}], ";", 
   RowBox[{"dlogLP", "=", 
    RowBox[{"{", 
     RowBox[{"0.19", ",", "0.086", ",", "0.115"}], "}"}]}], ";", 
   RowBox[{"t", "=", 
    RowBox[{"TimeUsed", "[", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"nh", ",", "co"}], "]"}], ";", 
  RowBox[{"ext", "=", "1."}], ";", 
  RowBox[{"acc", "=", "16"}], ";", 
  RowBox[{"inord", "=", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], ";", 
  RowBox[{"poi3", "=", "50000"}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"NIntegrate", ",", 
      RowBox[{"Method", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
         RowBox[{"Method", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
            RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
      ",", 
      RowBox[{"MaxPoints", "\[Rule]", "poi3"}], ",", 
      RowBox[{"AccuracyGoal", "\[Rule]", "acc"}]}], "]"}], ";"}], "*)"}], 
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{"NIntegrate", ",", 
     RowBox[{"Method", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
        RowBox[{"Method", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
           RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
     ",", 
     RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], 
   ";"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"co", "=", "0"}], ";", 
  RowBox[{"thlen", "=", "50"}], ";", 
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"narr", "=", "1.1"}], ";", 
  RowBox[{"nF", "=", "7"}], ";", 
  RowBox[{"nP", "=", "12"}], ";", 
  RowBox[{"avg", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"gat", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"th", "=", 
            RowBox[{
             FractionBox["\[Pi]", "thlen"], 
             RowBox[{"(", 
              RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
           RowBox[{"Import", "[", 
            RowBox[{"\"\<E:\\\\mathematica\\\\3DMHD\\\\ava\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", 
               RowBox[{"100", 
                RowBox[{"sptab", "[", 
                 RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
             "\"\<th\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Floor", "[", 
               RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<in11\>\"", 
             "<>", "\"\<.dat\>\""}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"flen", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"1", ";;", "11"}], ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}]}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
     RowBox[{"Off", "[", 
      RowBox[{
       RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
       RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gat", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{"gat", ",", "flen"}], "]"}]}], ";", 
     RowBox[{"rholen", "=", 
      RowBox[{"Length", "[", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "6"}], "]"}], 
          "]"}], ",", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1", ",", "1", ",", "6"}], "]"}], "]"}]}], "]"}],
        "]"}]}], ";", 
     RowBox[{"gat", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", 
     RowBox[{"dim", "=", 
      RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", 
     RowBox[{"hlen", "=", 
      RowBox[{"dim", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", 
     RowBox[{"hmin", "=", 
      RowBox[{"Log", "[", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "6"}], "]"}],
         "]"}], "]"}]}], ";", 
     RowBox[{"hmax", "=", 
      RowBox[{"Log", "[", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "6"}], "]"}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"thmin", "=", 
      RowBox[{
       FractionBox["\[Pi]", "thlen"], 
       RowBox[{"(", 
        RowBox[{"1", "-", ".5"}], ")"}]}]}], ";", 
     RowBox[{"thmax", "=", 
      RowBox[{"\[Pi]", "-", "thmin"}]}], ";", 
     RowBox[{"rhomax", "=", 
      RowBox[{"Log", "[", 
       FractionBox[
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", 
           RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "7"}], "]"}], "]"}], 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"flen", "+", "1"}], ")"}], "/", "2"}], ",", "1", ",", 
           "1", ",", "7"}], "]"}], "]"}]], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"rateint", "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], 
             "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], 
       ";"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"raterho", "=", 
      RowBox[{"ListInterpolation", "[", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "7"}], "]"}], 
          "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"flux", "[", "i", "]"}], "=", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", "i", ",", "All", ",", "2"}], "]"}],
           "]"}]}], ";", 
        RowBox[{
         RowBox[{
          RowBox[{"iflux", "[", "i", "]"}], "[", "sp", "]"}], "=", 
         RowBox[{"ListInterpolation", "[", 
          RowBox[{
           RowBox[{"flux", "[", "i", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
           RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}]}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "flen"}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"LP", "[", "1", "]"}], "=", 
      RowBox[{"Log", "[", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", 
          RowBox[{"-", "7"}], ",", "All", ",", "3"}], "]"}], "]"}], "]"}]}], 
     ";", 
     RowBox[{
      RowBox[{"LP", "[", "2", "]"}], "=", 
      RowBox[{"Log", "[", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", 
          RowBox[{"-", "4"}], ",", "All", ",", "3"}], "]"}], "]"}], "]"}]}], 
     ";", 
     RowBox[{
      RowBox[{"LP", "[", "3", "]"}], "=", 
      RowBox[{"Log", "[", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", 
          RowBox[{"-", "3"}], ",", "All", ",", "3"}], "]"}], "]"}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CP", "[", "1", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", 
         RowBox[{"-", "4"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"CP", "[", "2", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", 
         RowBox[{"-", "3"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"iCPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"CP", "[", "i", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"iLPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"LP", "[", "i", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"lipFnux", "[", "sp", "]"}], "=", 
      RowBox[{"Total", "[", 
       FractionBox[
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{
                RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
               "2"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], 
           RowBox[{"dFnu", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
            "]"}]], ")"}], "2"], 
        RowBox[{"nF", "-", "3"}]], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "=", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"nP", "-", "3"}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Total", "[", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                  "2"}], "]"}], "]"}], "-", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                   RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                  "&"}], "/@", 
                 RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], ")"}], "/", 
             RowBox[{"dFnu", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
              "]"}]}], ")"}], "2"], "]"}], "+", 
         RowBox[{"Total", "[", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             FractionBox["1", "dCP"], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"iCPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                   RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                  "&"}], "/@", 
                 RowBox[{"Range", "[", "2", "]"}]}], ")"}]}], ")"}]}], ")"}], 
           "2"], "]"}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"Log", "[", 
              RowBox[{"tofit", "[", 
               RowBox[{"[", 
                RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"iLPx", "[", "1", "]"}], "[", "sp", "]"}], "[", 
               RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
              ")"}]}], 
            RowBox[{"dlogLP", "[", 
             RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
         RowBox[{"Total", "[", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{"tofit", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}], 
               "-", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"iLPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                   RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                  "&"}], "/@", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", "3"}], "}"}]}], ")"}]}], ")"}], "/", 
             RowBox[{"dlogLP", "[", 
              RowBox[{"[", 
               RowBox[{"2", ";;", "3"}], "]"}], "]"}]}], ")"}], "2"], "]"}]}],
         ")"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Fdistx", "=", 
      RowBox[{
       RowBox[{"PDF", "[", 
        RowBox[{
         RowBox[{"ChiSquareDistribution", "[", 
          RowBox[{"nF", "-", "3"}], "]"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"nF", "-", "3"}], ")"}], " ", 
          RowBox[{"lipFnux", "[", "sp", "]"}]}]}], "]"}], 
       RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Ldistx", "=", 
      RowBox[{
       RowBox[{"PDF", "[", 
        RowBox[{
         RowBox[{"ChiSquareDistribution", "[", 
          RowBox[{"nP", "-", "3"}], "]"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"nP", "-", "3"}], ")"}], " ", 
          RowBox[{"lipFnuCPLPx", "[", "sp", "]"}]}]}], "]"}], 
       RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"hmin", "=", 
        RowBox[{"Log", "[", "0.25", "]"}]}], ";"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"PFnux", "=", 
      RowBox[{"NIntegrate", "[", 
       RowBox[{"Fdistx", ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"rhonor", ",", 
          RowBox[{
           RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
          RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"PCPLPx", "=", 
      RowBox[{"NIntegrate", "[", 
       RowBox[{"Ldistx", ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"rhonor", ",", 
          RowBox[{
           RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
          RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"prob", "[", "sp", "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"PFnux", ",", "PCPLPx"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"PCPLPz", "=", 
         RowBox[{"NIntegrate", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Exp", "[", 
             RowBox[{"-", 
              FractionBox[
               SuperscriptBox[
                RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "2"], "2"]}], "]"}], 
            RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"rhonor", ",", 
             RowBox[{
              RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
             RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
          "]"}]}], "]"}], ";"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\< sp=\>\"", ",", 
       RowBox[{"sptab", "[", 
        RowBox[{"[", "sp", "]"}], "]"}], ",", 
       "\"\<; Probabilities: P(Fnu)=\>\"", ",", "PFnux", ",", 
       "\"\<; PCPLP=\>\"", ",", "PCPLPx"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"resFLC", "[", "sp", "]"}], "=", 
      RowBox[{"NMinimize", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"hmin", "<", "heat", "<", "hmax"}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "rhomax"}], "<", "rhonor", "<", "rhomax"}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}], ")"}]}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "}"}], ",", 
        RowBox[{"Method", "\[Rule]", "\"\<DifferentialEvolution\>\""}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<sp=\>\"", ",", 
       RowBox[{"sptab", "[", 
        RowBox[{"[", "sp", "]"}], "]"}], ",", 
       "\"\<; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=\>\"", ",", 
       RowBox[{
        RowBox[{"resFLC", "[", "sp", "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       "\"\< for \!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\),LP,CP at  \
rhonor=\>\"", ",", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"raterho", "[", 
           RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], "]"}], "/.", 
        RowBox[{
         RowBox[{"resFLC", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<; heat=\>\"", ",", 
       RowBox[{
        RowBox[{"Exp", "[", "heat", "]"}], "/.", 
        RowBox[{
         RowBox[{"resFLC", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<;  \[Theta]=\>\"", ",", 
       RowBox[{"\[Theta]", "/.", 
        RowBox[{
         RowBox[{"resFLC", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"resF", "[", "sp", "]"}], "=", 
      RowBox[{"NMinimize", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"lipFnux", "[", "sp", "]"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"hmin", "<", "heat", "<", "hmax"}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "rhomax"}], "<", "rhonor", "<", "rhomax"}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}], ")"}]}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "}"}], ",", 
        RowBox[{"Method", "\[Rule]", "\"\<DifferentialEvolution\>\""}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<sp=\>\"", ",", 
       RowBox[{"sptab", "[", 
        RowBox[{"[", "sp", "]"}], "]"}], ",", 
       "\"\<; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=\>\"", ",", 
       RowBox[{
        RowBox[{"resF", "[", "sp", "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       "\"\< for \!\(\*SubscriptBox[\(F\), \(\(\[Nu]\)\(\\\ \\\ \\\ \\\ \\\ \
\\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \\\ \)\)]\)at  \
rhonor=\>\"", ",", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"raterho", "[", 
           RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], "]"}], "/.", 
        RowBox[{
         RowBox[{"resF", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<; heat=\>\"", ",", 
       RowBox[{
        RowBox[{"Exp", "[", "heat", "]"}], "/.", 
        RowBox[{
         RowBox[{"resF", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<;  \[Theta]=\>\"", ",", 
       RowBox[{"\[Theta]", "/.", 
        RowBox[{
         RowBox[{"resF", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";", "\n", 
     RowBox[{"If", "[", 
      RowBox[{"avg", ",", 
       RowBox[{
        RowBox[{"hmean", "=", 
         RowBox[{"Exp", "[", 
          RowBox[{
           FractionBox["1", "PFnux"], 
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"heat", " ", "Fdistx"}], ",", 
             RowBox[{"{", 
              RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"rhonor", ",", 
               RowBox[{
                RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
               RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
            "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rhomean", "=", 
         RowBox[{"Re", "[", 
          RowBox[{"Exp", "[", 
           RowBox[{
            FractionBox["1", "PFnux"], 
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"rateint", "[", 
                  RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], 
                ")"}], "Fdistx"}], ",", 
              RowBox[{"{", 
               RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"rhonor", ",", 
                RowBox[{
                 RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
             "]"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Theta]mean", "=", 
         RowBox[{"Re", "[", 
          RowBox[{
           FractionBox["1", "PFnux"], 
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"\[Theta]", " ", "Fdistx"}], ",", 
             RowBox[{"{", 
              RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"rhonor", ",", 
               RowBox[{
                RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
               RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
            "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<Over Fnu fits:  <h> = \>\"", ",", "hmean", ",", 
          "\"\<;  <Mdot> = \>\"", ",", "rhomean", ",", 
          "\"\<;  <\[Theta]>=\>\"", ",", "\[Theta]mean"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"hmean", "=", 
         RowBox[{"Re", "[", 
          RowBox[{"Exp", "[", 
           RowBox[{
            FractionBox["1", "PCPLPx"], 
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{"heat", " ", "Ldistx"}], ",", 
              RowBox[{"{", 
               RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"rhonor", ",", 
                RowBox[{
                 RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
             "]"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Theta]mean", "=", 
         RowBox[{"Re", "[", 
          RowBox[{
           FractionBox["1", "PCPLPx"], 
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"\[Theta]", " ", "Ldistx"}], ",", 
             RowBox[{"{", 
              RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"rhonor", ",", 
               RowBox[{
                RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
               RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
            "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rhomean", "=", 
         RowBox[{"Re", "[", 
          RowBox[{"Exp", "[", 
           RowBox[{
            FractionBox["1", "PCPLPx"], 
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"rateint", "[", 
                  RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], 
                ")"}], "Ldistx"}], ",", 
              RowBox[{"{", 
               RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"rhonor", ",", 
                RowBox[{
                 RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
             "]"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<Over FnuCPLP fits:  <h> = \>\"", ",", "hmean", ",", 
          "\"\<;  <Mdot> = \>\"", ",", "rhomean", ",", 
          "\"\<;  <\[Theta]>=\>\"", ",", "\[Theta]mean"}], "]"}]}]}], "]"}]}],
     ",", 
    RowBox[{"{", 
     RowBox[{"sp", ",", "4", ",", "4"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Computed in \>\"", ",", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"TimeUsed", "[", "]"}], "-", "t"}], "]"}], ",", 
   "\"\< seconds\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.4828815248972*^9, 3.4828815249284*^9}, {
   3.4828820445176*^9, 3.4828820446424*^9}, {3.4828822936652*^9, 
   3.4828823011532*^9}, {3.4843074276977997`*^9, 3.4843074281502*^9}, 
   3.4843075464762*^9, {3.4843079516862*^9, 3.4843079517642*^9}, {
   3.4843080370962*^9, 3.4843080371898003`*^9}, {3.4843084549578*^9, 
   3.4843084557222*^9}, {3.4843087334178*^9, 3.4843087344474*^9}, {
   3.4843089825654*^9, 3.4843089836418*^9}, {3.4843093097441998`*^9, 
   3.484309310883*^9}, {3.4843093847178*^9, 3.484309384983*^9}, {
   3.4843096946429996`*^9, 3.4843096951734*^9}, {3.4843934028486*^9, 
   3.4843934593206*^9}, {3.4843948275916*^9, 3.4843951134772*^9}, {
   3.4843952257816*^9, 3.4843952289172*^9}, {3.4843953598168*^9, 
   3.484395370612*^9}, {3.4843955238664*^9, 3.4843955375944*^9}, {
   3.4843959418684*^9, 3.4843959419308*^9}, {3.4843960801272*^9, 
   3.4843960802052*^9}, {3.4843966115880003`*^9, 3.4843966516488*^9}, {
   3.4843970255652*^9, 3.48439702569*^9}, {3.4843973343048*^9, 
   3.4843973343672*^9}, {3.4844158645804*^9, 3.4844158648143997`*^9}, {
   3.4844902285268*^9, 3.4844902288543997`*^9}, {3.4844937845008*^9, 
   3.4844938187896*^9}, {3.4844939961127996`*^9, 3.4844940010892*^9}, {
   3.4845153205952*^9, 3.4845153241988*^9}, {3.4845215022214003`*^9, 
   3.4845215127046003`*^9}, {3.4856083978822365`*^9, 3.485608412546237*^9}, {
   3.485608763265437*^9, 3.4856087649034367`*^9}, {3.485610046335437*^9, 
   3.485610049720637*^9}, {3.4857050917882156`*^9, 3.4857050930362153`*^9}, {
   3.4857106035334153`*^9, 3.485710609445815*^9}, {3.4857952778846154`*^9, 
   3.4857952779470153`*^9}, {3.4857958875482154`*^9, 
   3.4857958980782156`*^9}, {3.4858613839618154`*^9, 
   3.4858613959270153`*^9}, {3.4858628533570156`*^9, 3.485862857038615*^9}, {
   3.4864803743073997`*^9, 3.4864803840262003`*^9}, {3.4864818376966*^9, 
   3.4864818385078*^9}, {3.500641134174*^9, 3.5006411451870003`*^9}, {
   3.5006413240629997`*^9, 3.500641362574*^9}, {3.500641447243*^9, 
   3.500641453318*^9}, {3.500641550433*^9, 3.500641551883*^9}, {
   3.500642724248*^9, 3.500642805061*^9}, {3.5006444124890003`*^9, 
   3.500644447483*^9}, {3.50064448788*^9, 3.5006445069449997`*^9}, {
   3.5006448652980003`*^9, 3.500644933047*^9}, {3.500645043782*^9, 
   3.50064510413*^9}, {3.500660372426*^9, 3.500660478392*^9}, {
   3.5006605240480003`*^9, 3.500660592927*^9}, {3.500660624099*^9, 
   3.5006606242650003`*^9}, {3.500660755769*^9, 3.500660756601*^9}, {
   3.500660899642*^9, 3.500661052255*^9}, {3.500661177458*^9, 
   3.500661185532*^9}, {3.5006612513*^9, 3.50066126141*^9}, {3.50066130346*^9,
    3.5006614140769997`*^9}, {3.500661488117*^9, 3.5006615018570004`*^9}, {
   3.500909307273*^9, 3.500909308942*^9}, {3.5009098999969997`*^9, 
   3.5009099008599997`*^9}, {3.5019341601400003`*^9, 
   3.5019341611689997`*^9}, {3.501934645459*^9, 3.501934745742*^9}, {
   3.5019352290039997`*^9, 3.50193523581*^9}, {3.501935291024*^9, 
   3.501935327283*^9}, {3.501935438476*^9, 3.501935438796*^9}, {
   3.501935477783*^9, 3.5019355290369997`*^9}, {3.501935677514*^9, 
   3.501935684367*^9}, {3.501935775887*^9, 3.501935812484*^9}, {
   3.501936829882*^9, 3.5019368304119997`*^9}, {3.501937009797*^9, 
   3.501937010924*^9}, {3.501937194637*^9, 3.5019371953190002`*^9}, {
   3.501937379127*^9, 3.501937379751*^9}, {3.50193843276*^9, 
   3.501938453074*^9}, {3.501939161678*^9, 3.501939162334*^9}, {
   3.501939204697*^9, 3.501939204769*^9}, {3.501939713619*^9, 
   3.5019397142060003`*^9}, {3.5019398162349997`*^9, 3.50193981696*^9}, {
   3.50194019784*^9, 3.501940198416*^9}, {3.501940287359*^9, 
   3.501940304225*^9}, {3.5019410154*^9, 3.501941017276*^9}, {3.5019522991*^9,
    3.50195230071*^9}, {3.5019524358929996`*^9, 3.501952437307*^9}, {
   3.5019525102790003`*^9, 3.501952533523*^9}, {3.501957147219*^9, 
   3.501957147631*^9}, {3.5019590341400003`*^9, 3.50195903534*^9}, {
   3.5019591071219997`*^9, 3.5019591628970003`*^9}, {3.5019592159849997`*^9, 
   3.501959241863*^9}, {3.501959294234*^9, 3.501959295762*^9}, {
   3.5019593842139997`*^9, 3.5019593964820004`*^9}, {3.501959533231*^9, 
   3.5019595900150003`*^9}, {3.5019609894519997`*^9, 3.501960989999*^9}, {
   3.5020208230629997`*^9, 3.5020208342539997`*^9}, {3.5020215268450003`*^9, 
   3.502021526955*^9}, {3.502022046198*^9, 3.5020220486619997`*^9}, {
   3.502022450421*^9, 3.502022451149*^9}, {3.502022893616*^9, 
   3.502022894961*^9}, 3.502024229578*^9, {3.502024624727*^9, 
   3.502024626109*^9}, {3.502025938782*^9, 3.502025939521*^9}, {
   3.502027048665*^9, 3.502027056177*^9}, {3.502027086602*^9, 
   3.502027086667*^9}, {3.5020271417139997`*^9, 3.5020271468059998`*^9}, {
   3.5020273027790003`*^9, 3.502027303032*^9}, {3.502027532743*^9, 
   3.502027532791*^9}, {3.502027833525*^9, 3.502027833613*^9}, {
   3.5020282448789997`*^9, 3.502028263401*^9}, {3.502031249172*^9, 
   3.502031292384*^9}, {3.502463167876*^9, 3.502463177861*^9}, {
   3.5024633203050003`*^9, 3.502463339356*^9}, {3.502464319766*^9, 
   3.50246432087*^9}, {3.5024683505629997`*^9, 3.502468351106*^9}, {
   3.502472039225*^9, 3.502472039698*^9}, {3.502472357888*^9, 
   3.5024723584040003`*^9}, {3.5026313870109997`*^9, 
   3.5026313881429996`*^9}, {3.502631468626*^9, 3.502631477634*^9}, 
   3.5026319139700003`*^9, {3.502631944942*^9, 3.502631945021*^9}, {
   3.5026322362530003`*^9, 3.502632236363*^9}, {3.502642375962*^9, 
   3.502642376257*^9}, {3.5026425371619997`*^9, 3.5026425375690002`*^9}, {
   3.502642574684*^9, 3.502642590407*^9}, {3.502642620508*^9, 
   3.502642659926*^9}, {3.50264269008*^9, 3.5026426904040003`*^9}, {
   3.502642720749*^9, 3.502642720824*^9}, {3.502642757752*^9, 
   3.5026427921429996`*^9}, {3.50264288349*^9, 3.5026428906800003`*^9}, 
   3.50264295625*^9, {3.5026435987609997`*^9, 3.502643600641*^9}, {
   3.502643647165*^9, 3.5026436481289997`*^9}, {3.502643832342*^9, 
   3.50264383299*^9}, {3.502643867284*^9, 3.5026438939040003`*^9}, {
   3.502644029209*^9, 3.50264403396*^9}, {3.5026442377799997`*^9, 
   3.5026442888780003`*^9}, {3.502644343796*^9, 3.502644343922*^9}, {
   3.5026443931280003`*^9, 3.502644394168*^9}, {3.502644541131*^9, 
   3.502644544203*^9}, {3.502644830957*^9, 3.50264484176*^9}, {
   3.5026450140889997`*^9, 3.502645082804*^9}, {3.502645877967*^9, 
   3.502645881749*^9}, {3.5026462638269997`*^9, 3.50264628265*^9}, {
   3.502646341763*^9, 3.502646457138*^9}, {3.5026465931289997`*^9, 
   3.50264660481*^9}, {3.502646896925*^9, 3.502646919049*^9}, {
   3.5026472243929996`*^9, 3.502647228401*^9}, {3.502647703741*^9, 
   3.5026477203*^9}, {3.503149271975*^9, 3.503149272432*^9}, {
   3.5042815796140003`*^9, 3.5042816375039997`*^9}, {3.504281772573*^9, 
   3.504281810483*^9}, {3.504353553818*^9, 3.504353575125*^9}, {
   3.505568526583*^9, 3.5055685334820004`*^9}, {3.5082487659849997`*^9, 
   3.50824876652*^9}, {3.508248908259*^9, 3.5082489087390003`*^9}, {
   3.508249594968*^9, 3.508249595449*^9}, {3.508250493664*^9, 
   3.508250494675*^9}, {3.5091266336*^9, 3.509126634316*^9}, {
   3.509126755153*^9, 3.5091267558570004`*^9}, {3.509208610231*^9, 
   3.509208610814*^9}, {3.5092086779820004`*^9, 3.509208678717*^9}, {
   3.5092087604379997`*^9, 3.509208761091*^9}, {3.509210661514*^9, 
   3.5092106623059998`*^9}, {3.50921086359*^9, 3.5092108704040003`*^9}, {
   3.5092110254379997`*^9, 3.509211026066*^9}, {3.5092114014779997`*^9, 
   3.509211402578*^9}, {3.5092115488719997`*^9, 3.509211549335*^9}, {
   3.509211844979*^9, 3.509211845784*^9}, {3.5092125894309998`*^9, 
   3.509212590962*^9}, {3.509212848966*^9, 3.509212860076*^9}, {
   3.509213063885*^9, 3.509213064627*^9}, {3.509213900715*^9, 
   3.5092139179560003`*^9}, {3.509213958707*^9, 3.50921396733*^9}, {
   3.5093873595761037`*^9, 3.5093873697561035`*^9}, {3.5093878394351034`*^9, 
   3.5093878398571033`*^9}, {3.50940382265*^9, 3.509403865882*^9}, {
   3.509403934941*^9, 3.509403936685*^9}, {3.509404360508*^9, 
   3.509404361778*^9}, {3.509405134925*^9, 3.5094051370039997`*^9}, {
   3.509408087572*^9, 3.509408088399*^9}, {3.5094478379449997`*^9, 
   3.50944784474*^9}, {3.5097286222980003`*^9, 3.509728622852*^9}, {
   3.509796839059*^9, 3.509796842752*^9}, {3.5208384723673253`*^9, 
   3.520838558517253*^9}, {3.520838658078947*^9, 3.5208387159222555`*^9}, {
   3.520838750430229*^9, 3.520838828209678*^9}, {3.5208393880897017`*^9, 
   3.5208393882127085`*^9}, {3.5208396772532406`*^9, 3.520839691491055*^9}, {
   3.5208397491403522`*^9, 3.520839750777446*^9}, {3.52083987253441*^9, 
   3.520839882079956*^9}, {3.5208400250691347`*^9, 3.520840039443957*^9}, {
   3.5208400729738746`*^9, 3.5208401166473722`*^9}, {3.520840252032116*^9, 
   3.5208402521081204`*^9}, {3.5208403255723224`*^9, 
   3.5208403256423264`*^9}, {3.5208403966433873`*^9, 
   3.5208403973174257`*^9}, {3.520840515650194*^9, 3.5208405170172725`*^9}, {
   3.5208405780047607`*^9, 3.520840578794806*^9}, {3.5211123075455885`*^9, 
   3.5211123231224794`*^9}, {3.521112687649329*^9, 3.52111271948315*^9}, {
   3.5211129041067095`*^9, 3.5211129055147905`*^9}, {3.5211144849611297`*^9, 
   3.5211144855741644`*^9}, {3.5211266704180975`*^9, 3.521126702119911*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"LP87", "=", 
   RowBox[{"2", "%"}]}], " ", ";"}]], "Input",
 CellChangeTimes->{{3.521112918482532*^9, 3.521112931722289*^9}}],

Cell[BoxData["inv"], "Input",
 CellChangeTimes->{{3.521112679759878*^9, 3.5211126798298817`*^9}}],

Cell[BoxData[
 RowBox[{"50000", ",", 
  RowBox[{"{", 
   RowBox[{"2", ",", "2", ",", "2"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5208406655327673`*^9, 3.5208406679449053`*^9}}],

Cell[BoxData[
 RowBox[{"50000", ",", 
  RowBox[{"{", 
   RowBox[{"1", ",", "1", ",", "2"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.520840569213258*^9, 3.5208405726284533`*^9}}],

Cell[BoxData[
 RowBox[{"50000", ",", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2", ",", "1"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5208405026784525`*^9, 3.5208405064076653`*^9}}],

Cell[BoxData[
 RowBox[{"50000", ",", 
  RowBox[{"{", 
   RowBox[{"2", ",", "1", ",", "1"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5208403868088245`*^9, 3.520840390007008*^9}}],

Cell[BoxData[
 RowBox[{"50000", ",", 
  RowBox[{"{", 
   RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5208402580924625`*^9, 3.5208402597485576`*^9}, {
  3.520840333145756*^9, 3.5208403362719345`*^9}}],

Cell[BoxData[
 RowBox[{"all", " ", "boosted"}]], "Input",
 CellChangeTimes->{{3.5094479883780003`*^9, 3.509447990308*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"all", " ", "non"}], "-", "boosted"}]], "Input",
 CellChangeTimes->{{3.5094080932539997`*^9, 3.5094080975769997`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "4"}], ";", 
  RowBox[{
   RowBox[{"resFLC", "[", 
    RowBox[{"sp", ",", "co"}], "]"}], "=", 
   RowBox[{"NMinimize", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"lipFnuCPLPx", "[", "4", "]"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"0.1", "+", "hmin"}], "<", "heat", "<", "hmax"}], ")"}], "&&", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "rhomax"}], "<", "rhonor", "<", "rhomax"}], ")"}], "&&", 
        RowBox[{"(", 
         RowBox[{"2.0", "<", "\[Theta]", "<", "2.6"}], ")"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "}"}], ",", 
     RowBox[{"Method", "\[Rule]", "\"\<DifferentialEvolution\>\""}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<sp=\>\"", ",", 
    RowBox[{"sptab", "[", 
     RowBox[{"[", "sp", "]"}], "]"}], ",", 
    "\"\<; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=\>\"", ",", 
    RowBox[{
     RowBox[{"resFLC", "[", 
      RowBox[{"sp", ",", "co"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", 
    "\"\< for \!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\),LP,CP at  rhonor=\>\"", 
    ",", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"raterho", "[", 
        RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], "]"}], "/.", 
     RowBox[{
      RowBox[{"resFLC", "[", 
       RowBox[{"sp", ",", "co"}], "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<; heat=\>\"", ",", 
    RowBox[{
     RowBox[{"Exp", "[", "heat", "]"}], "/.", 
     RowBox[{
      RowBox[{"resFLC", "[", 
       RowBox[{"sp", ",", "co"}], "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<;  \[Theta]=\>\"", ",", 
    RowBox[{"\[Theta]", "/.", 
     RowBox[{
      RowBox[{"resFLC", "[", 
       RowBox[{"sp", ",", "co"}], "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=."}], ";"}]}], "Input",
 CellChangeTimes->{
  3.5093873946491036`*^9, {3.5093874309751034`*^9, 3.509387452462104*^9}, {
   3.5093875357931037`*^9, 3.509387601422104*^9}, {3.509387796962104*^9, 
   3.5093878544581037`*^9}}],

Cell[BoxData[
 RowBox[{"0.9", ",", " ", "boosted", ",", " ", 
  RowBox[{"0", "-", "7"}]}]], "Input",
 CellChangeTimes->{{3.509212842138*^9, 3.509212846053*^9}, {3.509292787506*^9,
   3.509292787586*^9}}],

Cell[BoxData[
 RowBox[{"0.5", ",", " ", 
  RowBox[{"non", "-", "boosted"}]}]], "Input",
 CellChangeTimes->{{3.509211011138*^9, 3.509211015965*^9}}],

Cell[BoxData[
 RowBox[{"0.9", ",", " ", "boosted"}]], "Input",
 CellChangeTimes->{{3.509208749084*^9, 3.509208751414*^9}}],

Cell[BoxData[
 RowBox[{"0.5", ",", " ", "boosted"}]], "Input",
 CellChangeTimes->{{3.509208672137*^9, 3.5092086755950003`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "4"}], ";", 
  RowBox[{"co", "=", "0"}], ";", 
  RowBox[{
   RowBox[{"resFLC", "[", 
    RowBox[{"sp", ",", "co"}], "]"}], "=", 
   RowBox[{"NMinimize", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"hmin", "<", "heat", "<", "hmax"}], ")"}], "&&", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "rhomax"}], "<", "rhonor", "<", "rhomax"}], ")"}], "&&", 
        RowBox[{"(", 
         RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}], ")"}]}]}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "}"}], ",", 
     RowBox[{"Method", "\[Rule]", "\"\<RandomSearch\>\""}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<sp=\>\"", ",", 
    RowBox[{"sptab", "[", 
     RowBox[{"[", "sp", "]"}], "]"}], ",", 
    "\"\<; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=\>\"", ",", 
    RowBox[{
     RowBox[{"resFLC", "[", 
      RowBox[{"sp", ",", "co"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", 
    "\"\< for \!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\),LP,CP at  rhonor=\>\"", 
    ",", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"raterho", "[", 
        RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], "]"}], "/.", 
     RowBox[{
      RowBox[{"resFLC", "[", 
       RowBox[{"sp", ",", "co"}], "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<; heat=\>\"", ",", 
    RowBox[{
     RowBox[{"Exp", "[", "heat", "]"}], "/.", 
     RowBox[{
      RowBox[{"resFLC", "[", 
       RowBox[{"sp", ",", "co"}], "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<;  \[Theta]=\>\"", ",", 
    RowBox[{"\[Theta]", "/.", 
     RowBox[{
      RowBox[{"resFLC", "[", 
       RowBox[{"sp", ",", "co"}], "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.508248989519*^9, 3.508249007245*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "4"}], ";", 
  RowBox[{"heat", "=", 
   RowBox[{"Log", "[", "0.2", "]"}]}], ";", 
  RowBox[{"co", "=", "0"}], ";", 
  RowBox[{
   RowBox[{"resFLC", "[", 
    RowBox[{"sp", ",", "co"}], "]"}], "=", 
   RowBox[{"NMinimize", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "rhomax"}], "<", "rhonor", "<", "rhomax"}], ")"}], "&&", 
        RowBox[{"(", 
         RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}], ")"}]}]}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"rhonor", ",", "\[Theta]"}], "}"}], ",", 
     RowBox[{"Method", "\[Rule]", "\"\<RandomSearch\>\""}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<sp=\>\"", ",", 
    RowBox[{"sptab", "[", 
     RowBox[{"[", "sp", "]"}], "]"}], ",", 
    "\"\<; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=\>\"", ",", 
    RowBox[{
     RowBox[{"resFLC", "[", 
      RowBox[{"sp", ",", "co"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", 
    "\"\< for \!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\),LP,CP at  rhonor=\>\"", 
    ",", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"raterho", "[", 
        RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], "]"}], "/.", 
     RowBox[{
      RowBox[{"resFLC", "[", 
       RowBox[{"sp", ",", "co"}], "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<; heat=\>\"", ",", 
    RowBox[{
     RowBox[{"Exp", "[", "heat", "]"}], "/.", 
     RowBox[{
      RowBox[{"resFLC", "[", 
       RowBox[{"sp", ",", "co"}], "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<;  \[Theta]=\>\"", ",", 
    RowBox[{"\[Theta]", "/.", 
     RowBox[{
      RowBox[{"resFLC", "[", 
       RowBox[{"sp", ",", "co"}], "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=."}], ";", 
  RowBox[{"heat", "=."}], ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.508249752966*^9, 3.508249797401*^9}, {3.508249832326*^9,
   3.5082498755559998`*^9}, {3.508249931858*^9, 3.508249946723*^9}, {
  3.508249996493*^9, 3.508249996821*^9}, {3.508250897442*^9, 
  3.508250910745*^9}, {3.508250988204*^9, 3.508250988276*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"determine", " ", "flow", " ", "parameters"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"sp", "=", "4"}], ";", 
    RowBox[{"co", "=", "0"}], ";", 
    RowBox[{"rhonor", "=", 
     RowBox[{"(", 
      RowBox[{"rhonor", "/.", 
       RowBox[{
        RowBox[{"resFLC", "[", 
         RowBox[{"sp", ",", "co"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], ";", 
    RowBox[{"heat", "=", 
     RowBox[{"(", 
      RowBox[{"Exp", "[", 
       RowBox[{"heat", "/.", 
        RowBox[{
         RowBox[{"resFLC", "[", 
          RowBox[{"sp", ",", "co"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ")"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"atab", "=", 
     RowBox[{"{", 
      RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], 
      "}"}]}], ";", 
    RowBox[{"sptab", "=", 
     RowBox[{"{", 
      RowBox[{
      "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
       ",", "\"\<098\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nmtab", "=", 
     RowBox[{"{", 
      RowBox[{"8", ",", "8", ",", "8", ",", "9", ",", "9"}], "}"}]}], ";", 
    RowBox[{"ncuttab", "=", 
     RowBox[{"{", 
      RowBox[{"145", ",", "147", ",", "149", ",", "153", ",", "162"}], 
      "}"}]}], ";", 
    RowBox[{"a", "=", 
     RowBox[{"atab", "[", 
      RowBox[{"[", "sp", "]"}], "]"}]}], ";", 
    RowBox[{"nm", "=", 
     RowBox[{"nmtab", "[", 
      RowBox[{"[", "sp", "]"}], "]"}]}], ";", 
    RowBox[{"ncut", "=", 
     RowBox[{"ncuttab", "[", 
      RowBox[{"[", "sp", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xx", "=", 
     RowBox[{"Import", "[", 
      RowBox[{"\"\<C:\\\\study\\\\mathematica\\\\3DMHD\\\\Tsmap\>\"", "<>", 
       RowBox[{"sptab", "[", 
        RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<.dat\>\""}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rhoout", "=", "130"}], ";", 
    RowBox[{"rmax", "=", 
     RowBox[{"3.4", " ", 
      SuperscriptBox["10", "5"]}]}], ";", 
    RowBox[{"rcut", "=", 
     RowBox[{"xx", "[", 
      RowBox[{"[", 
       RowBox[{"ncut", ",", "1"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rhopo", "=", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Log", "[", 
        RowBox[{
         RowBox[{"rhoout", "/", "rhonor"}], "/", 
         RowBox[{
          RowBox[{"xx", "[", 
           RowBox[{"[", "ncut", "]"}], "]"}], "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}], "/", 
      RowBox[{"Log", "[", 
       RowBox[{"rmax", "/", "rcut"}], "]"}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"rhocon", "=", 
     RowBox[{"rhonor", "*", 
      RowBox[{"xx", "[", 
       RowBox[{"[", 
        RowBox[{"ncut", ",", "3"}], "]"}], "]"}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Ucon", "=", 
     RowBox[{"xx", "[", 
      RowBox[{"[", 
       RowBox[{"ncut", ",", "2"}], "]"}], "]"}]}], ";", 
    RowBox[{"ruru", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"rg", "\[Rule]", 
        FractionBox[
         RowBox[{"2", " ", "6.67", " ", 
          SuperscriptBox["10", 
           RowBox[{"-", "8"}]], "4.5", " ", 
          SuperscriptBox["10", "6"], "2", " ", 
          SuperscriptBox["10", "33"]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"3", " ", 
            SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
       RowBox[{"arcsec", "\[Rule]", 
        FractionBox[
         RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
          SuperscriptBox["10", "3"], "3.08", " ", 
          SuperscriptBox["10", "18"]}], 
         RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
       RowBox[{"pc", "\[Rule]", 
        RowBox[{"3.08", " ", 
         SuperscriptBox["10", "18"]}]}], ",", 
       RowBox[{"year", "\[Rule]", 
        RowBox[{"365.35", " ", "86400"}]}], ",", 
       RowBox[{"cc", "\[Rule]", 
        RowBox[{"3.", " ", 
         SuperscriptBox["10", "10"]}]}], ",", 
       RowBox[{"Msun", "\[Rule]", 
        RowBox[{"2.", " ", 
         SuperscriptBox["10", "33"]}]}], ",", 
       RowBox[{"mp", "\[Rule]", 
        RowBox[{"1.67", " ", 
         SuperscriptBox["10", 
          RowBox[{"-", "24"}]]}]}], ",", 
       RowBox[{"me", "\[Rule]", 
        RowBox[{"9.1", " ", 
         SuperscriptBox["10", 
          RowBox[{"-", "28"}]]}]}], ",", 
       RowBox[{"kb", "\[Rule]", 
        RowBox[{"1.38", " ", 
         SuperscriptBox["10", 
          RowBox[{"-", "16"}]]}]}], ",", 
       RowBox[{"h", "\[Rule]", 
        RowBox[{"6.626", " ", 
         SuperscriptBox["10", 
          RowBox[{"-", "27"}]]}]}], ",", 
       RowBox[{"ee", "\[Rule]", 
        RowBox[{"4.8", " ", 
         SuperscriptBox["10", 
          RowBox[{"-", "10"}]]}]}], ",", 
       RowBox[{"keV", "->", 
        RowBox[{"1000", " ", "1.602", " ", 
         SuperscriptBox["10", 
          RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rategs", "=", 
     RowBox[{
      RowBox[{"1.5", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "8"}]], " ", 
       RowBox[{"Msun", "/", "year"}]}], "/.", "ruru"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rtab", "=", 
     RowBox[{"xx", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
    RowBox[{"rntab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"rcut", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["rcut", "rmax"], ")"}], 
         RowBox[{"-", 
          FractionBox["i", "100"]}]]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "100"}], "}"}]}], "]"}]}], ";", 
    RowBox[{"\[Rho]fun", "=", 
     RowBox[{"rhocon", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["r", "rcut"], ")"}], 
       RowBox[{"-", "rhopo"}]]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vrvr", "=", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["rategs", 
        RowBox[{"2", " ", "cc", " ", "mp", " ", 
         SuperscriptBox["rg", "2"], 
         SuperscriptBox["r", "2"], "\[Rho]inter", " "}]]}], "/.", "ruru"}]}], 
    ";", 
    RowBox[{"dcap", "=", 
     RowBox[{"(", 
      RowBox[{"2.", "-", 
       FractionBox["0.49", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"0.7", "+", " ", 
           SuperscriptBox["cser", "2"]}], ")"}], "2"]]}], ")"}]}], ";", 
    RowBox[{"Tsfun", "=", 
     RowBox[{"Ucon", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["r", "rcut"], ")"}], 
       RowBox[{"-", "0.98"}]]}]}], ";", 
    RowBox[{"Tstab", "=", 
     RowBox[{"xx", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"1", ";;", "ncut"}], ",", 
        RowBox[{"1", ";;", "2"}]}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Tsinter", "=", 
     RowBox[{
      RowBox[{"Interpolation", "[", 
       RowBox[{"Join", "[", 
        RowBox[{"Tstab", ",", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"rntab", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Tsfun", "/.", 
               RowBox[{"r", "\[Rule]", "#"}]}], "&"}], "/@", "rntab"}]}], 
           "}"}], "]"}]}], "]"}], "]"}], "[", "r", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sysm", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"tail", "=", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Dts", "=", 
                RowBox[{"D", "[", 
                 RowBox[{"Tsinter", ",", "r"}], "]"}]}], ";", 
               RowBox[{"\[Nu]c", "=", 
                RowBox[{"8.9", " ", 
                 SuperscriptBox["10", 
                  RowBox[{"-", "11"}]], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox[
                    RowBox[{"Te", "[", "r", "]"}], 
                    RowBox[{"3", " ", 
                    SuperscriptBox["10", "10"]}]], ")"}], 
                  RowBox[{"-", 
                   FractionBox["3", "2"]}]], 
                 FractionBox["\[Rho]fun", 
                  SuperscriptBox["10", "7"]]}]}]}], ")"}], 
             FractionBox[
              RowBox[{"2", " ", "mp", " ", 
               SuperscriptBox["rg", "3"], 
               SuperscriptBox["r", "2"], "\[Rho]fun", " "}], "rategs"], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Tp", "[", "r", "]"}], "-", 
               RowBox[{"Te", "[", "r", "]"}]}], ")"}]}], "+", 
            RowBox[{"2", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                FractionBox[
                 SqrtBox[
                  RowBox[{"Tp", "[", "r", "]"}]], 
                 RowBox[{
                  SqrtBox[
                   RowBox[{"Tp", "[", "r", "]"}]], "+", 
                  RowBox[{"heat", 
                   SqrtBox[
                    RowBox[{"Te", "[", "r", "]"}]]}]}]], ")"}], "-", 
               RowBox[{
                FractionBox["1", "dcap"], 
                RowBox[{"(", 
                 RowBox[{"1", 
                  FractionBox[
                   RowBox[{"heat", 
                    SqrtBox[
                    RowBox[{"Te", "[", "r", "]"}]]}], 
                   RowBox[{
                    SqrtBox[
                    RowBox[{"Tp", "[", "r", "]"}]], "+", 
                    RowBox[{"heat", 
                    SqrtBox[
                    RowBox[{"Te", "[", "r", "]"}]]}]}]]}], ")"}]}]}], ")"}], 
             "Dts"}]}]}], ";", 
          RowBox[{
           RowBox[{
            RowBox[{"Te", "'"}], "[", "r", "]"}], "==", 
           FractionBox[
            RowBox[{
             RowBox[{"2", "Dts"}], "-", "tail"}], 
            RowBox[{"dcap", "+", "1"}]]}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"Tp", "'"}], "[", "r", "]"}], "\[Equal]", 
          RowBox[{"tail", "+", 
           FractionBox[
            RowBox[{
             RowBox[{"2", "Dts"}], "-", "tail"}], 
            RowBox[{"dcap", "+", "1"}]]}]}]}], "}"}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Theta]e", "\[Rule]", 
          FractionBox[
           RowBox[{"kb", " ", 
            RowBox[{"Te", "[", "r", "]"}]}], 
           RowBox[{"me", " ", 
            SuperscriptBox["cc", "2"]}]]}], ",", 
         RowBox[{"cser", "\[Rule]", 
          SqrtBox[
           FractionBox[
            RowBox[{"kb", " ", 
             RowBox[{"Te", "[", "r", "]"}]}], 
            RowBox[{"me", " ", 
             SuperscriptBox["cc", "2"]}]]]}], ",", 
         RowBox[{"cspr", "\[Rule]", 
          SqrtBox[
           FractionBox[
            RowBox[{"kb", " ", 
             RowBox[{"Tp", "[", "r", "]"}]}], 
            RowBox[{"mp", " ", 
             SuperscriptBox["cc", "2"]}]]]}]}], "}"}]}], "/.", "ruru"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Off", "[", 
     RowBox[{"FindRoot", "::", "\"\<lstol\>\""}], "]"}], ";", 
    RowBox[{"tosol", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", 
       RowBox[{"sysm", ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"Tp", "[", "r", "]"}], "==", "Tsinter"}], ",", 
           RowBox[{
            RowBox[{"Te", "[", "r", "]"}], "\[Equal]", "Tsinter"}]}], "}"}], "/.", 
         RowBox[{"r", "\[Rule]", "rmax"}]}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"solnew", "=", 
     RowBox[{
      RowBox[{"NDSolve", "[", 
       RowBox[{"tosol", ",", 
        RowBox[{"{", 
         RowBox[{"Tp", ",", "Te"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"r", ",", 
          RowBox[{"rtab", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", "rmax"}], "}"}]}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{"\"\<\!\(\*OverscriptBox[\(M\), \(.\)]\)=\>\"", ",", 
     RowBox[{"N", "[", 
      RowBox[{"Floor", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"rateint", "[", 
            RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], "]"}], 
         "/.", 
         RowBox[{
          RowBox[{"resFLC", "[", 
           RowBox[{"sp", ",", "co"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ",", 
        SuperscriptBox["10", 
         RowBox[{"-", "10"}]]}], "]"}], "]"}], ",", 
     "\"\< Msun/yr;  \[Theta]=\>\"", ",", 
     RowBox[{"Floor", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox["180", "\[Pi]"], 
         RowBox[{"(", 
          RowBox[{"\[Pi]", "-", "\[Theta]"}], ")"}]}], "/.", 
        RowBox[{
         RowBox[{"resFLC", "[", 
          RowBox[{"sp", ",", "co"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", "0.1"}], "]"}], ",", 
     "\"\<\[Degree];  \!\(\*FractionBox[\(Tp\), \(Te\)]\)=\>\"", ",", " ", 
     RowBox[{"Floor", "[", 
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{"Tp", "[", "6", "]"}], 
         RowBox[{"Te", "[", "6", "]"}]], "/.", "solnew"}], ",", "0.1"}], 
      "]"}], ",", "\"\< at 6M; Te[6M]=\>\"", ",", 
     RowBox[{"N", "[", 
      RowBox[{"Floor", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Te", "[", "6", "]"}], "/.", "solnew"}], ",", 
        SuperscriptBox["10", "8"]}], "]"}], "]"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Clear", "[", 
     RowBox[{"sp", ",", "co", ",", "rhonor", ",", "heat"}], "]"}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{
  3.504281307174*^9, {3.504353694981*^9, 3.504353840008*^9}, {
   3.504354006301*^9, 3.504354102815*^9}, {3.504354136771*^9, 
   3.504354153587*^9}, {3.5043544822019997`*^9, 3.504354536822*^9}, {
   3.504354671208*^9, 3.5043547002530003`*^9}, {3.5043548315699997`*^9, 
   3.5043549369849997`*^9}}],

Cell[BoxData[{
 RowBox[{"chisqF", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"resF", "[", 
      RowBox[{"i", ",", "0"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "5"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"chisqFLC", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"resFLC", "[", 
      RowBox[{"i", ",", "0"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "5"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"chisq05F", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"resF", "[", 
       RowBox[{"2", ",", "i"}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "7"}], "}"}]}], "]"}]}], 
  RowBox[{"(*", "boosted", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"chisq05FLC", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"resFLC", "[", 
      RowBox[{"2", ",", "i"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "7"}], "}"}]}], "]"}], 
  RowBox[{"(*", "boosted", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.502646286296*^9, 3.5026463291140003`*^9}, {
  3.502646511479*^9, 3.5026465743*^9}, {3.5026466409119997`*^9, 
  3.5026467254700003`*^9}, {3.502646804672*^9, 3.50264681596*^9}, {
  3.502647650425*^9, 3.502647650585*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "\"\<NelderMead\>\"", ",", " ", "\"\<DifferentialEvolution\>\"", ",", " ", 
   RowBox[{"\"\<SimulatedAnnealing\>\"", " ", "and", " ", 
    RowBox[{"\"\<RandomSearch\>\"", "."}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.502648096042*^9, 3.502648096043*^9}, {3.502648374972*^9,
   3.502648376476*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"chisqFboo", "=", 
   RowBox[{"{", 
    RowBox[{
    "3.6116494688826073`", ",", "1.7118581693296315`", ",", 
     "0.10203485802123645`", ",", "0.040861451912052954`", ",", 
     "0.03130335960552725`"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"chisqFnob", "=", 
   RowBox[{"{", 
    RowBox[{
    "4.749449410553588`", ",", "1.6719417953699511`", ",", 
     "0.2038945607375132`", ",", "0.0581573074416609`", ",", 
     "0.06058174038749031`"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"chisqFLCboo", "=", 
   RowBox[{"{", 
    RowBox[{
    "6.77409384860362`", ",", "1.923488888795368`", ",", "4.026577188368991`",
      ",", "3.03696414000554`", ",", "3.6365119314749563`"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"chisqFLCnob", "=", 
   RowBox[{"{", 
    RowBox[{
    "4.908819933436118`", ",", "2.219704563759286`", ",", 
     "5.090257542045821`", ",", "3.0241934681053935`", ",", 
     "10.105163241573656`"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"chisq05F", "=", 
   RowBox[{"{", 
    RowBox[{
    "1.7306671186587128`", ",", "0.9479766404071468`", ",", 
     "2.7880501281067986`", ",", "2.217177805817168`", ",", 
     "2.076373378889102`", ",", "0.543301748308009`", ",", 
     "1.2680030887729172`"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"chisq05FLC", "=", 
   RowBox[{"{", 
    RowBox[{
    "2.202065090891869`", ",", "4.312903912784133`", ",", 
     "4.368991649788537`", ",", "2.9197686580331124`", ",", 
     "2.2803997926233883`", ",", "1.5108312899428729`", ",", 
     "2.875748393748631`"}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.502647247509*^9, 3.5026472803719997`*^9}, {
  3.502647658047*^9, 3.502647663574*^9}, {3.502647945199*^9, 
  3.502647957991*^9}, {3.502648320157*^9, 3.5026483309049997`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"various", " ", "co", "  ", "sp"}], "\[Rule]", "0.5"}], ";", " ", 
  RowBox[{"boosted", "\[Rule]", "True"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"boosted", "\[Rule]", "True"}]], "Input",
 CellChangeTimes->{{3.5026458499630003`*^9, 3.502645856501*^9}}],

Cell[BoxData[{
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\" sp=\"\>", "\[InvisibleSpace]", "0.`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "1.6905420310744644`*^-6", 
   "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", "\[InvisibleSpace]", "0.`"}],
  SequenceForm[
  "co=", 0, " sp=", 0., "; Probabilities: P(Fnu)=", 1.6905420310744644`*^-6, 
   "; PCPLP=", 0.],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "6.77409384860362`", 
   "\[InvisibleSpace]", "\<\" for \\!\\(\\*SubscriptBox[\\(F\\), \\(\[Nu]\\)]\
\\),LP,CP at  rhonor=\"\>", "\[InvisibleSpace]", "792832.8814743025`", 
   "\[InvisibleSpace]", "\<\"; heat=\"\>", "\[InvisibleSpace]", 
   "0.4395586939120195`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "2.1048775510182796`"}],
  SequenceForm[
  "sp=", 0., "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   6.77409384860362, 
   " for \!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\),LP,CP at  rhonor=", 
   792832.8814743025, "; heat=", 0.4395586939120195, ";  \[Theta]=", 
   2.1048775510182796`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "3.6116494688826073`", 
   "\[InvisibleSpace]", "\<\" for \\!\\(\\*SubscriptBox[\\(F\\), \
\\(\\(\[Nu]\\)\\(\\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \
\\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\)\\)]\\)at  rhonor=\"\>", 
   "\[InvisibleSpace]", "477455.9190401364`", 
   "\[InvisibleSpace]", "\<\"; heat=\"\>", "\[InvisibleSpace]", 
   "0.5747396285589937`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "1.5054038160507532`"}],
  SequenceForm[
  "sp=", 0., "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   3.6116494688826073`, 
   " for \!\(\*SubscriptBox[\(F\), \(\(\[Nu]\)\(\\ \\ \\ \\ \\ \\ \\ \\ \\ \\ \
\\ \\ \\ \\ \\ \\ \\ \\ \\ \\ \)\)]\)at  rhonor=", 477455.9190401364, 
   "; heat=", 0.5747396285589937, ";  \[Theta]=", 1.5054038160507532`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\" sp=\"\>", "\[InvisibleSpace]", "0.5`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.0011248352648110475`", 
   "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", "\[InvisibleSpace]", 
   "0.000023795537692635264`"}],
  SequenceForm[
  "co=", 0, " sp=", 0.5, "; Probabilities: P(Fnu)=", 0.0011248352648110475`, 
   "; PCPLP=", 0.000023795537692635264`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.5`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "1.923488888795368`", 
   "\[InvisibleSpace]", "\<\" for \\!\\(\\*SubscriptBox[\\(F\\), \\(\[Nu]\\)]\
\\),LP,CP at  rhonor=\"\>", "\[InvisibleSpace]", "300089.52109151334`", 
   "\[InvisibleSpace]", "\<\"; heat=\"\>", "\[InvisibleSpace]", 
   "0.4437819537026777`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "1.8610878963501176`"}],
  SequenceForm[
  "sp=", 0.5, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   1.923488888795368, 
   " for \!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\),LP,CP at  rhonor=", 
   300089.52109151334`, "; heat=", 0.4437819537026777, ";  \[Theta]=", 
   1.8610878963501176`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.5`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "1.7118581693296315`", 
   "\[InvisibleSpace]", "\<\" for \\!\\(\\*SubscriptBox[\\(F\\), \
\\(\\(\[Nu]\\)\\(\\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \
\\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\)\\)]\\)at  rhonor=\"\>", 
   "\[InvisibleSpace]", "249195.81465590224`", 
   "\[InvisibleSpace]", "\<\"; heat=\"\>", "\[InvisibleSpace]", 
   "0.4847015413805526`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "1.5496466247643208`"}],
  SequenceForm[
  "sp=", 0.5, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   1.7118581693296315`, 
   " for \!\(\*SubscriptBox[\(F\), \(\(\[Nu]\)\(\\ \\ \\ \\ \\ \\ \\ \\ \\ \\ \
\\ \\ \\ \\ \\ \\ \\ \\ \\ \\ \)\)]\)at  rhonor=", 249195.81465590224`, 
   "; heat=", 0.4847015413805526, ";  \[Theta]=", 1.5496466247643208`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\" sp=\"\>", "\[InvisibleSpace]", "0.7`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.017598235308911143`", 
   "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", "\[InvisibleSpace]", 
   "2.5982271458854927`*^-9"}],
  SequenceForm[
  "co=", 0, " sp=", 0.7, "; Probabilities: P(Fnu)=", 0.017598235308911143`, 
   "; PCPLP=", 2.5982271458854927`*^-9],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.7`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "4.026577188368991`", 
   "\[InvisibleSpace]", "\<\" for \\!\\(\\*SubscriptBox[\\(F\\), \\(\[Nu]\\)]\
\\),LP,CP at  rhonor=\"\>", "\[InvisibleSpace]", "462221.0104519148`", 
   "\[InvisibleSpace]", "\<\"; heat=\"\>", "\[InvisibleSpace]", 
   "0.47075643717703947`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "2.0497505682894634`"}],
  SequenceForm[
  "sp=", 0.7, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   4.026577188368991, 
   " for \!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\),LP,CP at  rhonor=", 
   462221.0104519148, "; heat=", 0.47075643717703947`, ";  \[Theta]=", 
   2.0497505682894634`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.7`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "0.10203485802123645`", 
   "\[InvisibleSpace]", "\<\" for \\!\\(\\*SubscriptBox[\\(F\\), \
\\(\\(\[Nu]\\)\\(\\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \
\\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\)\\)]\\)at  rhonor=\"\>", 
   "\[InvisibleSpace]", "1.3050105211547036`*^6", 
   "\[InvisibleSpace]", "\<\"; heat=\"\>", "\[InvisibleSpace]", 
   "0.27629740963690863`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "2.391520263654418`"}],
  SequenceForm[
  "sp=", 0.7, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   0.10203485802123645`, 
   " for \!\(\*SubscriptBox[\(F\), \(\(\[Nu]\)\(\\ \\ \\ \\ \\ \\ \\ \\ \\ \\ \
\\ \\ \\ \\ \\ \\ \\ \\ \\ \\ \)\)]\)at  rhonor=", 1.3050105211547036`*^6, 
   "; heat=", 0.27629740963690863`, ";  \[Theta]=", 2.391520263654418],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\" sp=\"\>", "\[InvisibleSpace]", "0.9`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.007166323562321694`", 
   "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", "\[InvisibleSpace]", 
   "1.2942096775880684`*^-6"}],
  SequenceForm[
  "co=", 0, " sp=", 0.9, "; Probabilities: P(Fnu)=", 0.007166323562321694, 
   "; PCPLP=", 1.2942096775880684`*^-6],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.9`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "3.03696414000554`", 
   "\[InvisibleSpace]", "\<\" for \\!\\(\\*SubscriptBox[\\(F\\), \\(\[Nu]\\)]\
\\),LP,CP at  rhonor=\"\>", "\[InvisibleSpace]", "527561.150316622`", 
   "\[InvisibleSpace]", "\<\"; heat=\"\>", "\[InvisibleSpace]", 
   "0.41356113768190955`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "2.2305428553468793`"}],
  SequenceForm[
  "sp=", 0.9, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   3.03696414000554, 
   " for \!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\),LP,CP at  rhonor=", 
   527561.150316622, "; heat=", 0.41356113768190955`, ";  \[Theta]=", 
   2.2305428553468793`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.9`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "0.040861451912052954`", 
   "\[InvisibleSpace]", "\<\" for \\!\\(\\*SubscriptBox[\\(F\\), \
\\(\\(\[Nu]\\)\\(\\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \
\\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\)\\)]\\)at  rhonor=\"\>", 
   "\[InvisibleSpace]", "1.55621905954556`*^6", 
   "\[InvisibleSpace]", "\<\"; heat=\"\>", "\[InvisibleSpace]", 
   "0.23578911091319246`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "2.856247576287296`"}],
  SequenceForm[
  "sp=", 0.9, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   0.040861451912052954`, 
   " for \!\(\*SubscriptBox[\(F\), \(\(\[Nu]\)\(\\ \\ \\ \\ \\ \\ \\ \\ \\ \\ \
\\ \\ \\ \\ \\ \\ \\ \\ \\ \\ \)\)]\)at  rhonor=", 1.55621905954556*^6, 
   "; heat=", 0.23578911091319246`, ";  \[Theta]=", 2.856247576287296],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\" sp=\"\>", "\[InvisibleSpace]", "0.98`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.008769426712708486`", 
   "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", "\[InvisibleSpace]", 
   "4.0413781439029534`*^-7"}],
  SequenceForm[
  "co=", 0, " sp=", 0.98, "; Probabilities: P(Fnu)=", 0.008769426712708486, 
   "; PCPLP=", 4.0413781439029534`*^-7],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.98`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "3.6365119314749563`", 
   "\[InvisibleSpace]", "\<\" for \\!\\(\\*SubscriptBox[\\(F\\), \\(\[Nu]\\)]\
\\),LP,CP at  rhonor=\"\>", "\[InvisibleSpace]", "304072.9503906153`", 
   "\[InvisibleSpace]", "\<\"; heat=\"\>", "\[InvisibleSpace]", 
   "0.42350517759745937`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "2.2084483251538427`"}],
  SequenceForm[
  "sp=", 0.98, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   3.6365119314749563`, 
   " for \!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\),LP,CP at  rhonor=", 
   304072.9503906153, "; heat=", 0.42350517759745937`, ";  \[Theta]=", 
   2.2084483251538427`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.98`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "0.03130335960552725`", 
   "\[InvisibleSpace]", "\<\" for \\!\\(\\*SubscriptBox[\\(F\\), \
\\(\\(\[Nu]\\)\\(\\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \
\\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\\\ \\)\\)]\\)at  rhonor=\"\>", 
   "\[InvisibleSpace]", "837925.0761184829`", 
   "\[InvisibleSpace]", "\<\"; heat=\"\>", "\[InvisibleSpace]", 
   "0.25241125166538325`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "0.350239"}],
  SequenceForm[
  "sp=", 0.98, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   0.03130335960552725, 
   " for \!\(\*SubscriptBox[\(F\), \(\(\[Nu]\)\(\\ \\ \\ \\ \\ \\ \\ \\ \\ \\ \
\\ \\ \\ \\ \\ \\ \\ \\ \\ \\ \)\)]\)at  rhonor=", 837925.0761184829, 
   "; heat=", 0.25241125166538325`, ";  \[Theta]=", 0.350239333180533],
  Editable->False], "\[IndentingNewLine]", 
 InterpretationBox[
  RowBox[{"\<\"Computed in \"\>", "\[InvisibleSpace]", "262", 
   "\[InvisibleSpace]", "\<\" seconds\"\>"}],
  SequenceForm["Computed in ", 262, " seconds"],
  Editable->False]}], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.502645285977*^9, 3.50264530596*^9}, 3.502645895152*^9, {
   3.502646160965*^9, 3.50264616721*^9}}]
}, Closed]],

Cell[BoxData[
 RowBox[{"boosted", "\[Rule]", "False"}]], "Input",
 CellChangeTimes->{{3.50264769709*^9, 3.502647699427*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"chisq", "[", 
      RowBox[{"fi_", "?", "ListQ"}], "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"flen", "+", "5"}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Total", "[", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                  "2"}], "]"}], "]"}], "-", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"fi", "[", 
                   RowBox[{"[", 
                    RowBox[{"#", ",", "3"}], "]"}], "]"}], "&"}], "/@", 
                 RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], ")"}], 
             RowBox[{"dFnu", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
              "]"}]], ")"}], "2"], "]"}], "+", 
         RowBox[{"Total", "[", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox[
             RowBox[{
              RowBox[{"tofit", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"fi", "[", 
                  RowBox[{"[", 
                   RowBox[{"#", ",", "6"}], "]"}], "]"}], "&"}], "/@", 
                RowBox[{"{", 
                 RowBox[{"4", ",", "5"}], "}"}]}], ")"}]}], "dCP"], ")"}], 
           "2"], "]"}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"Log", "[", 
              RowBox[{"tofit", "[", 
               RowBox[{"[", 
                RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
             RowBox[{"(", 
              RowBox[{"Log", "[", 
               RowBox[{"fi", "[", 
                RowBox[{"[", 
                 RowBox[{"1", ",", "4"}], "]"}], "]"}], "]"}], ")"}]}], 
            RowBox[{"dlogLP", "[", 
             RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
         RowBox[{"Total", "[", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox[
             RowBox[{
              RowBox[{"Log", "[", 
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}], 
              "-", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"Log", "[", 
                  RowBox[{"fi", "[", 
                   RowBox[{"[", 
                    RowBox[{"#", ",", "4"}], "]"}], "]"}], "]"}], "&"}], "/@", 
                RowBox[{"{", 
                 RowBox[{"4", ",", "5"}], "}"}]}], ")"}]}], 
             RowBox[{"dlogLP", "[", 
              RowBox[{"[", 
               RowBox[{"2", ";;", "3"}], "]"}], "]"}]], ")"}], "2"], "]"}]}], 
        ")"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"chisq", "[", 
    RowBox[{
    "Import", "[", 
     "\"\<E:\\\\mathematica\\\\analysis\\\\poliresa50th186fn-1boo.dat\>\"", 
     "]"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"chisq", "[", 
    RowBox[{
    "Import", "[", 
     "\"\<E:\\\\mathematica\\\\analysis\\\\poliresa50th186fn-1boox.dat\>\"", 
     "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.502465022383*^9, 3.502465093667*^9}, {
   3.5024651810220003`*^9, 3.502465187342*^9}, {3.502465858546*^9, 
   3.502465958336*^9}, 3.502466416053*^9, {3.50264769334*^9, 
   3.502647694071*^9}, {3.5042826734309998`*^9, 3.504282674229*^9}}],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"res", "[", "sp", "]"}], "=", 
     RowBox[{"NMinimize", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"hmin", "<", "heat", "<", "hmax"}], ")"}], "&&", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "rhomax"}], "<", "rhonor", "<", "rhomax"}], ")"}], "&&", 
          RowBox[{"(", 
           RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}], ")"}]}]}], "}"}],
        ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "}"}], ",", 
       RowBox[{"Method", "\[Rule]", "\"\<RandomSearch\>\""}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<sp=\>\"", ",", 
      RowBox[{"sptab", "[", 
       RowBox[{"[", "sp", "]"}], "]"}], ",", 
      "\"\<; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=\>\"", ",", 
      RowBox[{
       RowBox[{"res", "[", "sp", "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<  at  rhonor=\>\"", ",", 
      RowBox[{
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"raterho", "[", 
          RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], "]"}], "/.", 
       RowBox[{
        RowBox[{"res", "[", "sp", "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<; heat=\>\"", ",", 
      RowBox[{
       RowBox[{"Exp", "[", "heat", "]"}], "/.", 
       RowBox[{
        RowBox[{"res", "[", "sp", "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<;  \[Theta]=\>\"", ",", 
      RowBox[{"\[Theta]", "/.", 
       RowBox[{
        RowBox[{"res", "[", "sp", "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"sp", ",", "2", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.501959536928*^9, 3.50195953796*^9}, {3.501963291901*^9, 
   3.501963292061*^9}, {3.502020953814*^9, 3.502020953974*^9}, {
   3.502021069992*^9, 3.5020211217650003`*^9}, {3.502022054528*^9, 
   3.502022055328*^9}, 3.5020223950620003`*^9, {3.502022464737*^9, 
   3.502022466304*^9}, {3.502024358414*^9, 3.502024393292*^9}, {
   3.502024758566*^9, 3.50202475955*^9}, 3.5020253834189997`*^9, 
   3.5020254482720003`*^9, 3.502025478512*^9, {3.5020270245880003`*^9, 
   3.502027031347*^9}, {3.502028304586*^9, 3.5020283051940002`*^9}, {
   3.502631364185*^9, 3.502631375957*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "2"}], ";", 
  RowBox[{
   RowBox[{"Fnures", "[", "sp", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"iflux", "[", "i", "]"}], "[", "sp", "]"}], "[", 
       RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "/.", 
      RowBox[{
       RowBox[{"res", "[", "sp", "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "7"}], "}"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CPres", "[", "sp", "]"}], "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"iCPx", "[", "i", "]"}], "[", "sp", "]"}], "[", 
      RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "/.", 
     RowBox[{
      RowBox[{"res", "[", "sp", "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LPres", "[", "sp", "]"}], "=", 
  RowBox[{"Exp", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"iLPx", "[", "i", "]"}], "[", "sp", "]"}], "[", 
       RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "/.", 
      RowBox[{
       RowBox[{"res", "[", "sp", "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "3"}], "}"}]}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.502028415939*^9, 3.5020284214709997`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["etc + convergence", "Subsubsection",
 CellChangeTimes->{{3.501959470358*^9, 3.5019594732609997`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"acc", "=", "7"}], ";", 
  RowBox[{"inord", "=", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], ";", 
  RowBox[{"poi3", "=", "20000"}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], "]"}], ";", 
  RowBox[{"sp", "=", "3"}], ";", 
  RowBox[{"SetOptions", "[", 
   RowBox[{"NIntegrate", ",", 
    RowBox[{"Method", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
       RowBox[{"Method", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
          RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
    ",", 
    RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"Total", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                "2"}], "]"}], "]"}], "-", 
             RowBox[{"gat", "[", 
              RowBox[{"[", 
               RowBox[{"nh", ",", "#", ",", "All", ",", "All", ",", "3"}], 
               "]"}], "]"}]}], 
            RowBox[{"dFnu", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
             "]"}]], ")"}], "2"], "]"}], "flen"], "&"}], "/@", 
      RowBox[{"Range", "[", "7", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"nh", ",", "hlen"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnu3", "[", "sp", "]"}], "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{"tabb", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{"rhomax", "=", 
            RowBox[{"Log", "[", 
             FractionBox[
              RowBox[{"gat", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", 
                 RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "9"}], "]"}], 
               "]"}], 
              RowBox[{"gat", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"flen", "+", "1"}], ")"}], "/", "2"}], ",", "1", 
                 ",", "1", ",", "9"}], "]"}], "]"}]], "]"}]}], ")"}]}], ",", 
         "rhomax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        FractionBox["1", 
         RowBox[{"flen", "+", "5"}]], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Total", "[", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                  "2"}], "]"}], "]"}], "-", 
               RowBox[{"gat", "[", 
                RowBox[{"[", 
                 RowBox[{"nh", ",", "#", ",", "All", ",", "All", ",", "3"}], 
                 "]"}], "]"}]}], 
              RowBox[{"dFnu", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
               "]"}]], ")"}], "2"], "]"}], "+", 
          RowBox[{"Total", "[", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
               RowBox[{"gat", "[", 
                RowBox[{"[", 
                 RowBox[{"nh", ",", "#", ",", 
                  RowBox[{
                   RowBox[{"-", "4"}], ";;", 
                   RowBox[{"-", "3"}]}], ",", "All", ",", "6"}], "]"}], 
                "]"}]}], "dCP"], ")"}], "2"], "]"}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox[
             RowBox[{
              RowBox[{"Log", "[", 
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
              RowBox[{"Log", "[", 
               RowBox[{"gat", "[", 
                RowBox[{"[", 
                 RowBox[{"nh", ",", "#", ",", 
                  RowBox[{"-", "7"}], ",", "All", ",", "4"}], "]"}], "]"}], 
               "]"}]}], 
             RowBox[{"dlogLP", "[", 
              RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
          RowBox[{"Total", "[", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{"tofit", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}], 
               "-", 
               RowBox[{"Log", "[", 
                RowBox[{"gat", "[", 
                 RowBox[{"[", 
                  RowBox[{"nh", ",", "#", ",", 
                   RowBox[{
                    RowBox[{"-", "4"}], ";;", 
                    RowBox[{"-", "3"}]}], ",", "All", ",", "4"}], "]"}], 
                 "]"}], "]"}]}], 
              RowBox[{"dlogLP", "[", 
               RowBox[{"[", 
                RowBox[{"2", ";;", "3"}], "]"}], "]"}]], ")"}], "2"], "]"}]}],
          ")"}]}], "&"}], "/@", 
      RowBox[{"Range", "[", "7", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"nh", ",", "hlen"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"lipFnuCPLP3", "[", "sp", "]"}], "=", 
    RowBox[{"ListInterpolation", "[", 
     RowBox[{"tabb", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
      RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"flux", "[", "i", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "i", ",", "All", ",", "All", ",", "3"}], "]"}], 
       "]"}]}], ";", 
     RowBox[{
      RowBox[{
       RowBox[{"iflux", "[", "i", "]"}], "[", "sp", "]"}], "=", 
      RowBox[{"ListInterpolation", "[", 
       RowBox[{
        RowBox[{"flux", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "flen"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LP", "[", "1", "]"}], "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "All", ",", 
       RowBox[{"-", "7"}], ",", "All", ",", "4"}], "]"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"LP", "[", "2", "]"}], "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "All", ",", 
       RowBox[{"-", "4"}], ",", "All", ",", "4"}], "]"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"LP", "[", "3", "]"}], "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "All", ",", 
       RowBox[{"-", "3"}], ",", "All", ",", "4"}], "]"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CP", "[", "1", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "4"}], ",", "All", ",", "6"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"CP", "[", "2", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "3"}], ",", "All", ",", "6"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"iCPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"CP", "[", "i", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"iLPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"LP", "[", "i", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnux", "[", "sp", "]"}], "=", 
   RowBox[{"Total", "[", 
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         RowBox[{"tofit", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{
             RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", "2"}], 
           "]"}], "]"}], "-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
             RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "&"}], "/@", 
           RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], 
        RowBox[{"dFnu", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], "]"}]],
        ")"}], "2"], "flen"], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "=", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"flen", "+", "5"}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Total", "[", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{
                RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
               "2"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], 
           RowBox[{"dFnu", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
            "]"}]], ")"}], "2"], "]"}], "+", 
       RowBox[{"Total", "[", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iCPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"Range", "[", "2", "]"}]}], ")"}]}], "dCP"], ")"}], 
         "2"], "]"}], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           RowBox[{"Log", "[", 
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"iLPx", "[", "1", "]"}], "[", "sp", "]"}], "[", 
             RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], ")"}]}], 
          RowBox[{"dlogLP", "[", 
           RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
       RowBox[{"Total", "[", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"Log", "[", 
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}], 
            "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iLPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"{", 
               RowBox[{"2", ",", "3"}], "}"}]}], ")"}]}], 
           RowBox[{"dlogLP", "[", 
            RowBox[{"[", 
             RowBox[{"2", ";;", "3"}], "]"}], "]"}]], ")"}], "2"], "]"}]}], 
      ")"}]}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PFnu", "=", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{"Fdist", ",", 
     RowBox[{"{", 
      RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"rhonor", ",", 
       RowBox[{
        RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
       RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PCPLP", "=", 
   RowBox[{"Re", "[", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{"Ldist", ",", 
      RowBox[{"{", 
       RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"rhonor", ",", 
        RowBox[{
         RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
        RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fdist", "=", 
   RowBox[{"nF", " ", 
    RowBox[{"PDF", "[", 
     RowBox[{
      RowBox[{"ChiSquareDistribution", "[", "nF", "]"}], ",", 
      RowBox[{"nF", " ", 
       RowBox[{
        RowBox[{"lipFnu3", "[", "sp", "]"}], "[", 
        RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}]}]}], "]"}], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Ldist", "=", 
    RowBox[{"nP", " ", 
     RowBox[{"PDF", "[", 
      RowBox[{
       RowBox[{"ChiSquareDistribution", "[", "nP", "]"}], ",", 
       RowBox[{"nP", " ", 
        RowBox[{
         RowBox[{"lipFnuCPLP3", "[", "sp", "]"}], "[", 
         RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}]}]}], "]"}], 
     RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fdistx", "=", 
   RowBox[{"nF", " ", 
    RowBox[{"PDF", "[", 
     RowBox[{
      RowBox[{"ChiSquareDistribution", "[", "nF", "]"}], ",", 
      RowBox[{"nF", " ", 
       RowBox[{"lipFnux", "[", "sp", "]"}]}]}], "]"}], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ldistx", "=", 
   RowBox[{"nF", " ", 
    RowBox[{"PDF", "[", 
     RowBox[{
      RowBox[{"ChiSquareDistribution", "[", "nF", "]"}], ",", 
      RowBox[{"nF", " ", 
       RowBox[{"lipFnuCPLPx", "[", "sp", "]"}]}]}], "]"}], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Timing", "[", 
    RowBox[{"PFnu", "=", 
     RowBox[{"NIntegrate", "[", 
      RowBox[{"Fdist", ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"rhonor", ",", 
         RowBox[{
          RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
         RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
    "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Timing", "[", 
    RowBox[{"PFnux", "=", 
     RowBox[{"NIntegrate", "[", 
      RowBox[{"Fdistx", ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"rhonor", ",", 
         RowBox[{
          RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
         RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
    "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Timing", "[", 
    RowBox[{"PCPLP", "=", 
     RowBox[{"NIntegrate", "[", 
      RowBox[{"Ldist", ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"rhonor", ",", 
         RowBox[{
          RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
         RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
    "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Timing", "[", 
    RowBox[{"PCPLPx", "=", 
     RowBox[{"NIntegrate", "[", 
      RowBox[{"Ldistx", ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"rhonor", ",", 
         RowBox[{
          RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
         RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
    "]"}]}], "}"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJwl0FkohGEUBuBJopBsxYUsNUnJjZSYUlxYmxtpTGOJaUj2/F+WIdT4s0TW
4rfVRISsMVmKSdFkbmQsmYxdWRJGuTCT5T0uTs/FOd/pe0+wsjwt30EkEon/
CrbF3UVV+j7FhbXsJMMUt/YMaNSeZcHl0c086DP/Q/a+2MvgV0MCgzPvver/
OY6HD7alPjgkTI9A6+H6LNToFTrYUbKwAQt7BCOMWbk6gHupNtJRVnQMKwtL
yRv1mxkaqqxk2tr+BeSfLeTpuMGXo31zQRzNnYihQ9glGcA3RsL0WyEWTlR0
ZsLP0Hol1H10FkAPOV8Pc+/lTRz9N6SZo5yyVugeLuuDk8ORAxzlGxVg9Zaz
FnppahahSZqzCv0V9i2O7pa4C5Ouv0mFynYOVZJAC5RHd7uwP3M2PF3hYJnZ
C75NOXkzerfszyifNIDRvSMksPbRSrqH6+SM9m1nQ4s4XgX1+8mkfXpODfv9
FkmTVMHDsddi8nR8rQvW+RySGr1SyygnIx1lFyZGeQXzf7/oEn4flZC/urEZ
Tw==
  "]],

Cell[TextData[{
 "{2,2,2} 50000 ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3.8220000000000027`", ",", "0.02118665953229199`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"24.960000000000036`", ",", "0.005862288438091984`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"3.197999999999979`", ",", "0.000012898129728912421`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"40.32600000000002`", ",", "5.095704602698712`*^-8"}], "}"}]}], 
   "}"}]], "Output",
  CellChangeTimes->{3.501958165573*^9, 3.501958250108*^9, 3.501958328883*^9, 
   3.501958490852*^9}],
 "\n{2.2,2} 20000 ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1.6059999999999945`", ",", "0.02063070575716054`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"9.983999999999924`", ",", "0.0056653223334607325`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"1.4200000000000728`", ",", "0.00001226341155173992`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"16.473999999999933`", ",", "5.095063273448898`*^-8"}], "}"}]}], 
   "}"}]], "Output",
  CellChangeTimes->{
   3.501958165573*^9, 3.501958250108*^9, 3.501958328883*^9, 
    3.501958490852*^9, {3.501958821451*^9, 3.501958849408*^9}, 
    3.501958886915*^9, 3.501958941027*^9}],
 "\n{2,2,2} 10000 ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0.7649999999999864`", ",", "0.018726312194555943`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"5.444000000000074`", ",", "0.005591892900751026`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.7019999999999982`", ",", "9.444870047421319`*^-6"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"8.798999999999978`", ",", "5.072568244785175`*^-8"}], "}"}]}], 
   "}"}]], "Output",
  CellChangeTimes->{
   3.501958165573*^9, 3.501958250108*^9, 3.501958328883*^9, 
    3.501958490852*^9, {3.501958821451*^9, 3.501958849408*^9}, 
    3.501958886915*^9}],
 "\n{2,2,2}  5000 ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0.4049999999999727`", ",", "0.01318072433622577`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2.7620000000000573`", ",", "0.005214034275728289`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"0.4519999999999982`", ",", "0.000041104857261290754`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"4.866999999999962`", ",", "4.890619408022685`*^-8"}], "}"}]}], 
   "}"}]], "Output",
  CellChangeTimes->{
   3.501958165573*^9, 3.501958250108*^9, 3.501958328883*^9, 
    3.501958490852*^9, {3.501958821451*^9, 3.501958849408*^9}}],
 "\n{2,2,2}  2000 ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0.18700000000001182`", ",", "0.011769336716714266`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"1.26400000000001`", ",", "0.0054005613565029035`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.18700000000001182`", ",", "1.002147094612499`*^-13"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"2.2619999999999436`", ",", "1.6897131917847895`*^-11"}], 
     "}"}]}], "}"}]], "Output",
  CellChangeTimes->{3.501958165573*^9, 3.501958250108*^9, 3.501958328883*^9, 
   3.501958490852*^9, 3.501958821451*^9}],
 "\n\n{2,2,2} 50000 ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3.8220000000000027`", ",", "0.02118665953229199`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"24.960000000000036`", ",", "0.005862288438091984`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"3.197999999999979`", ",", "0.000012898129728912421`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"40.32600000000002`", ",", "5.095704602698712`*^-8"}], "}"}]}], 
   "}"}]], "Output",
  CellChangeTimes->{3.501958165573*^9, 3.501958250108*^9, 3.501958328883*^9, 
   3.501958490852*^9}],
 "\n{1,1,2} 50000 ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2.636000000000081`", ",", "0.007955595703245801`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"16.691999999999894`", ",", "0.006027308655318735`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"2.52800000000002`", ",", "2.092271125672958`*^-14"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"28.53200000000004`", ",", "1.2271846679925863`*^-8"}], "}"}]}], 
   "}"}]], "Output",
  CellChangeTimes->{3.501958165573*^9, 3.501958250108*^9, 3.501958328883*^9}],
 "\n{1,2,1} 50000 ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2.9010000000000673`", ",", "0.020713256088032223`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"18.783000000000015`", ",", "0.005859927560114322`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"2.52699999999993`", ",", "1.582715656157868`*^-12"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"30.451999999999998`", ",", "1.5009380689549625`*^-8"}], "}"}]}],
    "}"}]],
  CellChangeTimes->{3.501958165573*^9, 3.501958250108*^9}],
 "\n{2,1,1} 50000 ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2.9320000000000164`", ",", "0.007883381021523778`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"19.048000000000002`", ",", "0.005985028265779254`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"2.699000000000069`", ",", "1.84078741584808`*^-6"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"31.932999999999993`", ",", "3.337318833473692`*^-8"}], "}"}]}], 
   "}"}]], "Output",
  CellChangeTimes->{3.501958165573*^9}],
 "\n{1,1,1} 50000 ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2.464999999999975`", ",", "0.007784097632644025`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"16.19300000000004`", ",", "0.005986085978412685`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2.2309999999999945`", ",", "1.0090971510623578`*^-14"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"26.769000000000005`", ",", "1.0131560240092018`*^-8"}], "}"}]}],
    "}"}]], "Text",
  CellChangeTimes->{{3.50195797692*^9, 3.501957984363*^9}}]
}], "Text",
 CellChangeTimes->{{3.5019581243059998`*^9, 3.501958202967*^9}, {
   3.5019582596949997`*^9, 3.501958285396*^9}, {3.5019584048310003`*^9, 
   3.501958434534*^9}, 3.501958516817*^9, {3.5019588286289997`*^9, 
   3.501958901533*^9}, {3.501958952624*^9, 3.50195896665*^9}}],

Cell[TextData[{
 "50000 ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2.464999999999975`", ",", "0.007784097632644025`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"16.19300000000004`", ",", "0.005986085978412685`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2.2309999999999945`", ",", "1.0090971510623578`*^-14"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"26.769000000000005`", ",", "1.0131560240092018`*^-8"}], "}"}]}],
    "}"}]], "Text",
  CellChangeTimes->{{3.50195797692*^9, 3.501957984363*^9}}],
 "\n",
 "20000 ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1.0919999999999845`", ",", "0.007832668488359763`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"6.583000000000027`", ",", "0.005917727636181847`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.8429999999999609`", ",", "1.004709808247602`*^-14"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"11.16900000000004`", ",", "1.0138667741373184`*^-8"}], "}"}]}], 
   "}"}]], "Text",
  CellChangeTimes->{3.501957892994*^9, 3.501957963804*^9}],
 "\n",
 "10000 ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0.5149999999999864`", ",", "0.005942344401514704`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"3.415999999999997`", ",", "0.006023847148968275`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.5460000000000491`", ",", "1.0077434547251971`*^-14"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"5.959000000000003`", ",", "9.983696275915878`*^-9"}], "}"}]}], 
   "}"}]], "Text",
  CellChangeTimes->{3.501957860657*^9, 3.501957955541*^9}],
 "\n",
 "5000 ",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0.3120000000000118`", ",", "0.006012183033511605`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"1.7620000000000005`", ",", "0.005694362571548019`"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"0.3120000000000118`", ",", "1.0658622549431912`*^-14"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"3.1829999999999927`", ",", "1.0018332224096467`*^-8"}], "}"}]}],
    "}"}]], "Text",
  CellChangeTimes->{3.50195783729*^9, 3.501957946054*^9}]
}], "Text",
 CellChangeTimes->{{3.501957980799*^9, 3.501957990707*^9}, 3.501958088109*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "imprecise", "*)"}], 
  RowBox[{"(*", 
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"res", "[", "sp", "]"}], "=", 
       RowBox[{"NMinimize", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"lipFnuCPLP3", "[", "sp", "]"}], "[", 
            RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"hmin", "<", "heat", "<", "hmax"}], ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "rhomax"}], "<", "rhonor", "<", "rhomax"}], ")"}], 
            "&&", 
            RowBox[{"(", 
             RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}], ")"}]}]}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "}"}], ",", 
         RowBox[{"Method", "\[Rule]", "\"\<RandomSearch\>\""}]}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<sp=\>\"", ",", 
        RowBox[{"sptab", "[", 
         RowBox[{"[", "sp", "]"}], "]"}], ",", 
        "\"\<; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=\>\"", ",", 
        RowBox[{
         RowBox[{"res", "[", "sp", "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<  at  heat=\>\"", ",", 
        RowBox[{
         RowBox[{"Exp", "[", "heat", "]"}], "/.", 
         RowBox[{
          RowBox[{"res", "[", "sp", "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<;  \[Theta]=\>\"", ",", 
        RowBox[{"\[Theta]", "/.", 
         RowBox[{
          RowBox[{"res", "[", "sp", "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"sp", ",", "3", ",", "3"}], "}"}]}], "]"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", "precise", "*)"}], 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"res", "[", "sp", "]"}], "=", 
      RowBox[{"NMinimize", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"hmin", "<", "heat", "<", "hmax"}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "rhomax"}], "<", "rhonor", "<", "rhomax"}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}], ")"}]}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "}"}], ",", 
        RowBox[{"Method", "\[Rule]", "\"\<RandomSearch\>\""}]}], "]"}]}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<sp=\>\"", ",", 
       RowBox[{"sptab", "[", 
        RowBox[{"[", "sp", "]"}], "]"}], ",", 
       "\"\<; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=\>\"", ",", 
       RowBox[{
        RowBox[{"res", "[", "sp", "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<  at  heat=\>\"", ",", 
       RowBox[{
        RowBox[{"Exp", "[", "heat", "]"}], "/.", 
        RowBox[{
         RowBox[{"res", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<;  \[Theta]=\>\"", ",", 
       RowBox[{"\[Theta]", "/.", 
        RowBox[{
         RowBox[{"res", "[", "sp", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"sp", ",", "3", ",", "3"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.501952420231*^9, 3.5019524212469997`*^9}, {
  3.5019524911949997`*^9, 3.501952491627*^9}, {3.5019577792200003`*^9, 
  3.50195779227*^9}, {3.501958721217*^9, 3.501958723186*^9}}],

Cell[BoxData["1"], "Input",
 CellChangeTimes->{3.501958731295*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"LP", "[", "1", "]"}], "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "All", ",", 
       RowBox[{"-", "7"}], ",", "All", ",", "6"}], "]"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"LP", "[", "2", "]"}], "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "All", ",", 
       RowBox[{"-", "4"}], ",", "All", ",", "6"}], "]"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"LP", "[", "3", "]"}], "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "All", ",", 
       RowBox[{"-", "3"}], ",", "All", ",", "6"}], "]"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CP", "[", "1", "]"}], "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "All", ",", 
       RowBox[{"-", "4"}], ",", "All", ",", "6"}], "]"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"CP", "[", "2", "]"}], "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "All", ",", 
       RowBox[{"-", "3"}], ",", "All", ",", "6"}], "]"}], "]"}], "]"}]}], 
  ";"}]}], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
good analysis - interpolating \[Chi]^2; integrating simultaneously over heat, \
rhonor, \[Theta]\
\>", "Subsubsection",
 CellChangeTimes->{{3.4792194274284*^9, 3.4792194827616*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"nh", ",", "co"}], "]"}], ";", 
  RowBox[{"ext", "=", "1."}], ";", 
  RowBox[{"acc", "=", "7"}], ";", 
  RowBox[{"inord", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"co", "=", "0"}], ";", 
  RowBox[{"thlen", "=", "50"}], ";", 
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"poi3", "=", "200000"}], ";", 
  RowBox[{"tann", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"fnum", "=", 
       RowBox[{
        RowBox[{"-", "1"}], "-", "co"}]}], ";", 
      RowBox[{"th", "=", 
       RowBox[{
        FractionBox["\[Pi]", "thlen"], 
        RowBox[{"(", 
         RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
      RowBox[{"ToExpression", "[", 
       RowBox[{"Import", "[", 
        RowBox[{"\"\<E:\\\\mathematica\\\\analysis\\\\poliresa50th\>\"", "<>", 
         RowBox[{"ToString", "[", 
          RowBox[{"Floor", "[", 
           RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<fn\>\"", "<>", 
         RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
        "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.4792638701176*^9, 3.4792639307860003`*^9}, {
  3.4792639608316*^9, 3.4792639895824003`*^9}, {3.4792640248852*^9, 
  3.479264029144*^9}, {3.500640226451*^9, 3.500640226733*^9}, {
  3.500640439045*^9, 3.500640494146*^9}, {3.500641006942*^9, 
  3.500641036243*^9}, {3.500660838594*^9, 3.50066084633*^9}, {
  3.500660918641*^9, 3.5006609264519997`*^9}, {3.501934052283*^9, 
  3.501934052377*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"nh", ",", "co"}], "]"}], ";", 
  RowBox[{"ext", "=", "1."}], ";", 
  RowBox[{"acc", "=", "7"}], ";", 
  RowBox[{"inord", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ";", 
  RowBox[{"poi3", "=", "50000"}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], "]"}], ";", 
  RowBox[{"SetOptions", "[", 
   RowBox[{"NIntegrate", ",", 
    RowBox[{"Method", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
       RowBox[{"Method", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
          RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
    ",", 
    RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"co", "=", "0"}], ";", 
  RowBox[{"thlen", "=", "50"}], ";", 
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"narr", "=", "1.1"}], ";", 
  RowBox[{"nF", "=", "7"}], ";", 
  RowBox[{"nP", "=", "12"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"boosted", "=", "True"}], ";", 
  RowBox[{"test", "=", "\"\<Normal_narrow\>\""}], ";", 
  RowBox[{"test", "=", "\"\<Normal\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"bline", "=", 
        RowBox[{"If", "[", 
         RowBox[{"boosted", ",", "\"\<boo\>\"", ",", "\"\<nob\>\""}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"gat", "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"fnum", "=", 
              RowBox[{
               RowBox[{"-", "1"}], "-", "co"}]}], ";", 
             RowBox[{"th", "=", 
              RowBox[{
               FractionBox["\[Pi]", "thlen"], 
               RowBox[{"(", 
                RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
             RowBox[{"Import", "[", 
              RowBox[{"\"\<E:\\\\mathematica\\\\analysis\\\\poliresa\>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Round", "[", 
                 RowBox[{"100", 
                  RowBox[{"sptab", "[", 
                   RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
               "\"\<th\>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Floor", "[", 
                 RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<fn\>\"", "<>", 
               RowBox[{"ToString", "[", "fnum", "]"}], "<>", "bline", "<>", 
               "\"\<.dat\>\""}], "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", "\n", 
       RowBox[{"flen", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"gat", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", ";;", "11"}], ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"gat", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
       RowBox[{"Off", "[", 
        RowBox[{
         RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
         RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"gat", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{"gat", ",", "flen"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"rholen", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"Position", "[", 
          RowBox[{
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "8"}], 
             "]"}], "]"}], ",", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}]}], 
          "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"gat", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"dim", "=", 
        RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"hlen", "=", 
        RowBox[{"dim", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"tofit", "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"8.450", ",", "0.6898", ",", "0", ",", "0", ",", 
            RowBox[{"-", "0.2500"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"14.90", ",", "0.9044", ",", "0", ",", "0", ",", 
            RowBox[{"-", "0.6200"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "22.50", ",", "1.070", ",", "0.1900", ",", "131.0", ",", "0"}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "43.00", ",", "1.159", ",", "0.5041", ",", "94.25", ",", "0"}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"87.73", ",", "1.841", ",", "1.026", ",", 
            RowBox[{"-", "4."}], ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"102.0", ",", "1.908", ",", "0", ",", "0", ",", "0"}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"145.0", ",", "2.275", ",", "0", ",", "0", ",", "0"}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"230.9", ",", "2.637", ",", "7.015", ",", "111.5", ",", 
            RowBox[{"-", "1.200"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"349.0", ",", "3.181", ",", "6.143", ",", "146.9", ",", 
            RowBox[{"-", "1.500"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"674.0", ",", "3.286", ",", "0", ",", "0", ",", "0"}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"857.0", ",", "2.867", ",", "0", ",", "0", ",", "0"}], 
           "}"}]}], "}"}]}], ";", 
       RowBox[{"(*", 
        RowBox[{"8.45", " ", "-", " ", 
         RowBox[{"43", "GHz"}], " ", "-", " ", 
         RowBox[{"still", " ", "old", " ", "data"}]}], "*)"}], 
       "\[IndentingNewLine]", " ", 
       RowBox[{"dFnu", "=", 
        RowBox[{"{", 
         RowBox[{
         "1.", ",", "1.", ",", "1.", ",", "1.", ",", "0.080", ",", "0.1517", 
          ",", "0.2644", ",", "0.1414", ",", "0.1205", ",", "0.3508", ",", 
          "0.2404"}], "}"}]}], ";", 
       RowBox[{"dCP", "=", "0.30"}], ";", 
       RowBox[{"dlogLP", "=", 
        RowBox[{"{", 
         RowBox[{"0.19", ",", "0.086", ",", "0.115"}], "}"}]}], ";", "\n", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"dFnu", "=", "0.33"}], ";", 
         RowBox[{"dCP", "=", "0.27"}], ";", 
         RowBox[{"dlogLP", "=", "0.26"}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"test", "\[Equal]", "\"\<Normal_narrow\>\""}], ",", 
           RowBox[{
            RowBox[{"dFnu", "*=", "narr"}], ";", 
            RowBox[{"dCP", "*=", "narr"}], ";", 
            RowBox[{"dlogLP", "*=", "narr"}]}]}], "]"}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"hmin", "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "8"}], 
           "]"}], "]"}], "]"}]}], ";", 
       RowBox[{"hmax", "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], 
          "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"thmin", "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", 
       RowBox[{"thmax", "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "1", ",", 
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"rateint", "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], 
             "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"raterho", "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "9"}], "]"}],
             "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tabb", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            FractionBox[
             RowBox[{"Total", "[", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox[
                 RowBox[{
                  RowBox[{"tofit", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                    "2"}], "]"}], "]"}], "-", 
                  RowBox[{"gat", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    "nh", ",", "#", ",", "All", ",", "All", ",", "3"}], "]"}],
                    "]"}]}], 
                 RowBox[{"dFnu", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], 
                   "]"}], "]"}]], ")"}], "2"], "]"}], "flen"], "&"}], "/@", 
           RowBox[{"Range", "[", "7", "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"nh", ",", "hlen"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"lipFnu3", "[", "sp", "]"}], "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{"tabb", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", 
               RowBox[{"(", 
                RowBox[{"rhomax", "=", 
                 RowBox[{"Log", "[", 
                  FractionBox[
                   RowBox[{"gat", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", 
                    RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "9"}], "]"}],
                     "]"}], 
                   RowBox[{"gat", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"flen", "+", "1"}], ")"}], "/", "2"}], ",", "1", 
                    ",", "1", ",", "9"}], "]"}], "]"}]], "]"}]}], ")"}]}], 
              ",", "rhomax"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tabb", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             FractionBox["1", 
              RowBox[{"flen", "+", "5"}]], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Total", "[", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox[
                   RowBox[{
                    RowBox[{"tofit", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                    "2"}], "]"}], "]"}], "-", 
                    RowBox[{"gat", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    "nh", ",", "#", ",", "All", ",", "All", ",", "3"}], "]"}],
                     "]"}]}], 
                   RowBox[{"dFnu", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], 
                    "]"}], "]"}]], ")"}], "2"], "]"}], "+", 
               RowBox[{"Total", "[", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox[
                   RowBox[{
                    RowBox[{"tofit", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
                    RowBox[{"gat", "[", 
                    RowBox[{"[", 
                    RowBox[{"nh", ",", "#", ",", 
                    RowBox[{
                    RowBox[{"-", "4"}], ";;", 
                    RowBox[{"-", "3"}]}], ",", "All", ",", "6"}], "]"}], 
                    "]"}]}], "dCP"], ")"}], "2"], "]"}], "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox[
                  RowBox[{
                   RowBox[{"Log", "[", 
                    RowBox[{"tofit", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
                   RowBox[{"Log", "[", 
                    RowBox[{"gat", "[", 
                    RowBox[{"[", 
                    RowBox[{"nh", ",", "#", ",", 
                    RowBox[{"-", "7"}], ",", "All", ",", "4"}], "]"}], "]"}], 
                    "]"}]}], 
                  RowBox[{"dlogLP", "[", 
                   RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
               RowBox[{"Total", "[", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox[
                   RowBox[{
                    RowBox[{"Log", "[", 
                    RowBox[{"tofit", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}],
                     "-", 
                    RowBox[{"Log", "[", 
                    RowBox[{"gat", "[", 
                    RowBox[{"[", 
                    RowBox[{"nh", ",", "#", ",", 
                    RowBox[{
                    RowBox[{"-", "4"}], ";;", 
                    RowBox[{"-", "3"}]}], ",", "All", ",", "4"}], "]"}], 
                    "]"}], "]"}]}], 
                   RowBox[{"dlogLP", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ";;", "3"}], "]"}], "]"}]], ")"}], "2"], 
                "]"}]}], ")"}]}], "&"}], "/@", 
           RowBox[{"Range", "[", "7", "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"nh", ",", "hlen"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"lipFnuCPLP3", "[", "sp", "]"}], "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{"tabb", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
          RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Fdist", "=", 
        RowBox[{"nF", " ", 
         RowBox[{"PDF", "[", 
          RowBox[{
           RowBox[{"ChiSquareDistribution", "[", "nF", "]"}], ",", 
           RowBox[{"nF", " ", 
            RowBox[{
             RowBox[{"lipFnu3", "[", "sp", "]"}], "[", 
             RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}]}]}], 
          "]"}], 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Ldist", "=", 
        RowBox[{"nP", " ", 
         RowBox[{"PDF", "[", 
          RowBox[{
           RowBox[{"ChiSquareDistribution", "[", "nP", "]"}], ",", 
           RowBox[{"nP", " ", 
            RowBox[{
             RowBox[{"lipFnuCPLP3", "[", "sp", "]"}], "[", 
             RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}]}]}], 
          "]"}], 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"PFnu", "=", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{"Fdist", ",", 
          RowBox[{"{", 
           RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"rhonor", ",", 
            RowBox[{
             RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
            RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"PCPLP", "=", 
        RowBox[{"Re", "[", 
         RowBox[{"NIntegrate", "[", 
          RowBox[{"Ldist", ",", 
           RowBox[{"{", 
            RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"rhonor", ",", 
             RowBox[{
              RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
             RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<co=\>\"", ",", "co", ",", "\"\< sp=\>\"", ",", 
         RowBox[{"sptab", "[", 
          RowBox[{"[", "sp", "]"}], "]"}], ",", 
         "\"\<; Probabilities: P(Fnu)=\>\"", ",", "PFnu", ",", 
         "\"\<; PCPLP=\>\"", ",", "PCPLP"}], "]"}], ";", "\n", 
       RowBox[{"hmean", "=", 
        RowBox[{"Exp", "[", 
         RowBox[{
          FractionBox["1", "PFnu"], 
          RowBox[{"NIntegrate", "[", 
           RowBox[{
            RowBox[{"heat", " ", "Fdist"}], ",", 
            RowBox[{"{", 
             RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"rhonor", ",", 
              RowBox[{
               RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
              RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
           "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"rhomean", "=", 
        RowBox[{"Re", "[", 
         RowBox[{"Exp", "[", 
          RowBox[{
           FractionBox["1", "PFnu"], 
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"rateint", "[", 
                 RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], 
               ")"}], "Fdist"}], ",", 
             RowBox[{"{", 
              RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"rhonor", ",", 
               RowBox[{
                RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
               RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
            "]"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Theta]mean", "=", 
        RowBox[{"Re", "[", 
         RowBox[{
          FractionBox["1", "PFnu"], 
          RowBox[{"NIntegrate", "[", 
           RowBox[{
            RowBox[{"\[Theta]", " ", "Fdist"}], ",", 
            RowBox[{"{", 
             RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"rhonor", ",", 
              RowBox[{
               RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
              RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
           "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{
        "\"\<Over Fnu fits:  <h> = \>\"", ",", "hmean", ",", 
         "\"\<;  <Mdot> = \>\"", ",", "rhomean", ",", 
         "\"\<;  <\[Theta]>=\>\"", ",", "\[Theta]mean"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"hmean", "=", 
        RowBox[{"Re", "[", 
         RowBox[{"Exp", "[", 
          RowBox[{
           FractionBox["1", "PCPLP"], 
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"heat", " ", "Ldist"}], ",", 
             RowBox[{"{", 
              RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"rhonor", ",", 
               RowBox[{
                RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
               RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
            "]"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Theta]mean", "=", 
        RowBox[{"Re", "[", 
         RowBox[{
          FractionBox["1", "PCPLP"], 
          RowBox[{"NIntegrate", "[", 
           RowBox[{
            RowBox[{"\[Theta]", " ", "Ldist"}], ",", 
            RowBox[{"{", 
             RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"rhonor", ",", 
              RowBox[{
               RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
              RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
           "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"rhomean", "=", 
        RowBox[{"Re", "[", 
         RowBox[{"Exp", "[", 
          RowBox[{
           FractionBox["1", "PCPLP"], 
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"rateint", "[", 
                 RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], 
               ")"}], "Ldist"}], ",", 
             RowBox[{"{", 
              RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"rhonor", ",", 
               RowBox[{
                RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
               RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
            "]"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{
        "\"\<Over FnuCPLP fits:  <h> = \>\"", ",", "hmean", ",", 
         "\"\<;  <Mdot> = \>\"", ",", "rhomean", ",", 
         "\"\<;  <\[Theta]>=\>\"", ",", "\[Theta]mean"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"sp", ",", "1", ",", "5"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"co", ",", "0", ",", "0"}], "}"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.4828815248972*^9, 3.4828815249284*^9}, {
   3.4828820445176*^9, 3.4828820446424*^9}, {3.4828822936652*^9, 
   3.4828823011532*^9}, {3.4843074276977997`*^9, 3.4843074281502*^9}, 
   3.4843075464762*^9, {3.4843079516862*^9, 3.4843079517642*^9}, {
   3.4843080370962*^9, 3.4843080371898003`*^9}, {3.4843084549578*^9, 
   3.4843084557222*^9}, {3.4843087334178*^9, 3.4843087344474*^9}, {
   3.4843089825654*^9, 3.4843089836418*^9}, {3.4843093097441998`*^9, 
   3.484309310883*^9}, {3.4843093847178*^9, 3.484309384983*^9}, {
   3.4843096946429996`*^9, 3.4843096951734*^9}, {3.4843934028486*^9, 
   3.4843934593206*^9}, {3.4843948275916*^9, 3.4843951134772*^9}, {
   3.4843952257816*^9, 3.4843952289172*^9}, {3.4843953598168*^9, 
   3.484395370612*^9}, {3.4843955238664*^9, 3.4843955375944*^9}, {
   3.4843959418684*^9, 3.4843959419308*^9}, {3.4843960801272*^9, 
   3.4843960802052*^9}, {3.4843966115880003`*^9, 3.4843966516488*^9}, {
   3.4843970255652*^9, 3.48439702569*^9}, {3.4843973343048*^9, 
   3.4843973343672*^9}, {3.4844158645804*^9, 3.4844158648143997`*^9}, {
   3.4844902285268*^9, 3.4844902288543997`*^9}, {3.4844937845008*^9, 
   3.4844938187896*^9}, {3.4844939961127996`*^9, 3.4844940010892*^9}, {
   3.4845153205952*^9, 3.4845153241988*^9}, {3.4845215022214003`*^9, 
   3.4845215127046003`*^9}, {3.4856083978822365`*^9, 3.485608412546237*^9}, {
   3.485608763265437*^9, 3.4856087649034367`*^9}, {3.485610046335437*^9, 
   3.485610049720637*^9}, {3.4857050917882156`*^9, 3.4857050930362153`*^9}, {
   3.4857106035334153`*^9, 3.485710609445815*^9}, {3.4857952778846154`*^9, 
   3.4857952779470153`*^9}, {3.4857958875482154`*^9, 
   3.4857958980782156`*^9}, {3.4858613839618154`*^9, 
   3.4858613959270153`*^9}, {3.4858628533570156`*^9, 3.485862857038615*^9}, {
   3.4864803743073997`*^9, 3.4864803840262003`*^9}, {3.4864818376966*^9, 
   3.4864818385078*^9}, {3.500641134174*^9, 3.5006411451870003`*^9}, {
   3.5006413240629997`*^9, 3.500641362574*^9}, {3.500641447243*^9, 
   3.500641453318*^9}, {3.500641550433*^9, 3.500641551883*^9}, {
   3.500642724248*^9, 3.500642805061*^9}, {3.5006444124890003`*^9, 
   3.500644447483*^9}, {3.50064448788*^9, 3.5006445069449997`*^9}, {
   3.5006448652980003`*^9, 3.500644933047*^9}, {3.500645043782*^9, 
   3.50064510413*^9}, {3.500660372426*^9, 3.500660478392*^9}, {
   3.5006605240480003`*^9, 3.500660592927*^9}, {3.500660624099*^9, 
   3.5006606242650003`*^9}, {3.500660755769*^9, 3.500660756601*^9}, {
   3.500660899642*^9, 3.500661052255*^9}, {3.500661177458*^9, 
   3.500661185532*^9}, {3.5006612513*^9, 3.50066126141*^9}, {3.50066130346*^9,
    3.5006614140769997`*^9}, {3.500661488117*^9, 3.5006615018570004`*^9}, {
   3.500909307273*^9, 3.500909308942*^9}, {3.5009098999969997`*^9, 
   3.5009099008599997`*^9}, {3.5019341601400003`*^9, 
   3.5019341611689997`*^9}, {3.501934645459*^9, 3.501934745742*^9}, {
   3.5019352290039997`*^9, 3.50193523581*^9}, {3.501935291024*^9, 
   3.501935327283*^9}, {3.501935438476*^9, 3.501935438796*^9}, {
   3.501935477783*^9, 3.5019355290369997`*^9}, {3.501935677514*^9, 
   3.501935684367*^9}, {3.501935775887*^9, 3.501935812484*^9}, {
   3.501936829882*^9, 3.5019368304119997`*^9}, {3.501937009797*^9, 
   3.501937010924*^9}, {3.501937194637*^9, 3.5019371953190002`*^9}, {
   3.501937379127*^9, 3.501937379751*^9}, {3.50193843276*^9, 
   3.501938453074*^9}, {3.501939161678*^9, 3.501939162334*^9}, {
   3.501939204697*^9, 3.501939204769*^9}, {3.501939713619*^9, 
   3.5019397142060003`*^9}, {3.5019398162349997`*^9, 3.50193981696*^9}, {
   3.50194019784*^9, 3.501940198416*^9}, {3.501940287359*^9, 
   3.501940304225*^9}, {3.5019410154*^9, 3.501941017276*^9}, {
   3.501952406855*^9, 3.5019524070629997`*^9}}],

Cell[BoxData[{
 RowBox[{"gat", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "1", ",", "1", ",", "All", ",", 
    RowBox[{"-", "1"}]}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"Union", "[", 
    RowBox[{"Flatten", "[", 
     RowBox[{"Im", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"nn", ",", "All", ",", "All", ",", "All", ",", "3"}], "]"}], 
        "]"}], "]"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"nn", ",", "40"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"Union", "[", 
    RowBox[{"Flatten", "[", 
     RowBox[{"Im", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", "All", ",", "nn", ",", "3"}], "]"}], 
        "]"}], "]"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"nn", ",", "50"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5019398319110003`*^9, 3.5019399285629997`*^9}, {
  3.501939990113*^9, 3.501940082836*^9}, {3.501940215821*^9, 
  3.501940225124*^9}, {3.501940314984*^9, 3.5019403153900003`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"boosted", "\[Rule]", "False"}]], "Input",
 CellChangeTimes->{{3.501940437141*^9, 3.50194044063*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.`", 
    "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \
\\(2\\)]\\))=\"\>", "\[InvisibleSpace]", "4.809417967925678`", 
    "\[InvisibleSpace]", "\<\"  at  heat=\"\>", "\[InvisibleSpace]", 
    "0.42350282336474293`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
    "\[InvisibleSpace]", "0.06543528625338155`"}],
   SequenceForm[
   "sp=", 0., "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
    4.809417967925678, "  at  heat=", 0.42350282336474293`, ";  \[Theta]=", 
    0.06543528625338155],
   Editable->False], 
  RowBox[{"(*", 
   RowBox[{"only", " ", 
    SubscriptBox["F", "\[Nu]"]}], "*)"}]}]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.50194092038*^9, {3.501940999926*^9, 3.50194100799*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.5`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "1.6736981215261155`", 
   "\[InvisibleSpace]", "\<\"  at  heat=\"\>", "\[InvisibleSpace]", 
   "0.44115121081717606`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "1.6021564705088536`"}],
  SequenceForm[
  "sp=", 0.5, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   1.6736981215261155`, "  at  heat=", 0.44115121081717606`, ";  \[Theta]=", 
   1.6021564705088536`],
  Editable->False]], "Print",
 CellChangeTimes->{3.501940921568*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.7`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "0.21193355632866925`", 
   "\[InvisibleSpace]", "\<\"  at  heat=\"\>", "\[InvisibleSpace]", 
   "0.29329181531376536`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "0.9738897984061798`"}],
  SequenceForm[
  "sp=", 0.7, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   0.21193355632866925`, "  at  heat=", 0.29329181531376536`, ";  \[Theta]=", 
   0.9738897984061798],
  Editable->False]], "Print",
 CellChangeTimes->{3.501940922229*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.9`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "0.0801883021176997`", 
   "\[InvisibleSpace]", "\<\"  at  heat=\"\>", "\[InvisibleSpace]", 
   "0.25948585437925836`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "2.67037172388582`"}],
  SequenceForm[
  "sp=", 0.9, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   0.0801883021176997, "  at  heat=", 0.25948585437925836`, ";  \[Theta]=", 
   2.67037172388582],
  Editable->False]], "Print",
 CellChangeTimes->{3.50194092288*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.98`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "0.08048115044270543`", 
   "\[InvisibleSpace]", "\<\"  at  heat=\"\>", "\[InvisibleSpace]", 
   "0.318241968999736`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "0.5340612146357524`"}],
  SequenceForm[
  "sp=", 0.98, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   0.08048115044270543, "  at  heat=", 0.318241968999736, ";  \[Theta]=", 
   0.5340612146357524],
  Editable->False]], "Print",
 CellChangeTimes->{3.501940924014*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"boosted", "\[Rule]", "True"}]], "Input",
 CellChangeTimes->{{3.501939721038*^9, 3.5019397293190002`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.`", 
    "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \
\\(2\\)]\\))=\"\>", "\[InvisibleSpace]", "3.686772804310676`", 
    "\[InvisibleSpace]", "\<\"  at  heat=\"\>", "\[InvisibleSpace]", 
    "0.563585734662483`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
    "\[InvisibleSpace]", "1.4766495378152886`"}],
   SequenceForm[
   "sp=", 0., "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
    3.686772804310676, "  at  heat=", 0.563585734662483, ";  \[Theta]=", 
    1.4766495378152886`],
   Editable->False], 
  RowBox[{"(*", 
   RowBox[{"fitting", " ", 
    SubscriptBox["F", "\[Nu]"]}], "*)"}]}]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.501941150697*^9, 3.501941203579*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.5`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "1.720721203750868`", 
   "\[InvisibleSpace]", "\<\"  at  heat=\"\>", "\[InvisibleSpace]", 
   "0.47867966696146774`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "1.5393834842359366`"}],
  SequenceForm[
  "sp=", 0.5, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   1.720721203750868, "  at  heat=", 0.47867966696146774`, ";  \[Theta]=", 
   1.5393834842359366`],
  Editable->False]], "Print",
 CellChangeTimes->{3.501941151415*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.7`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "0.12847198943136912`", 
   "\[InvisibleSpace]", "\<\"  at  heat=\"\>", "\[InvisibleSpace]", 
   "0.27031385174857453`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "0.7225591792767144`"}],
  SequenceForm[
  "sp=", 0.7, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   0.12847198943136912`, "  at  heat=", 0.27031385174857453`, ";  \[Theta]=", 
   0.7225591792767144],
  Editable->False]], "Print",
 CellChangeTimes->{3.501941151966*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.9`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "0.05187480645858162`", 
   "\[InvisibleSpace]", "\<\"  at  heat=\"\>", "\[InvisibleSpace]", 
   "0.23914217979565158`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "2.8588693744363725`"}],
  SequenceForm[
  "sp=", 0.9, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   0.05187480645858162, "  at  heat=", 0.23914217979565158`, ";  \[Theta]=", 
   2.8588693744363725`],
  Editable->False]], "Print",
 CellChangeTimes->{3.50194115258*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"sp=\"\>", "\[InvisibleSpace]", "0.98`", 
   "\[InvisibleSpace]", "\<\"; min(\\!\\(\\*SuperscriptBox[\\(\[Chi]\\), \\(2\
\\)]\\))=\"\>", "\[InvisibleSpace]", "0.0380303225692083`", 
   "\[InvisibleSpace]", "\<\"  at  heat=\"\>", "\[InvisibleSpace]", 
   "0.2594858530522124`", "\[InvisibleSpace]", "\<\";  \[Theta]=\"\>", 
   "\[InvisibleSpace]", "2.7332040747768174`"}],
  SequenceForm[
  "sp=", 0.98, "; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=", 
   0.0380303225692083, "  at  heat=", 0.2594858530522124, ";  \[Theta]=", 
   2.7332040747768174`],
  Editable->False]], "Print",
 CellChangeTimes->{3.50194115371*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"res", "[", "sp", "]"}], "=", 
     RowBox[{"NMinimize", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"lipFnuCPLP3", "[", "sp", "]"}], "[", 
          RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"hmin", "<", "heat", "<", "hmax"}], ")"}], "&&", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "rhomax"}], "<", "rhonor", "<", "rhomax"}], ")"}], "&&", 
          RowBox[{"(", 
           RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}], ")"}]}]}], "}"}],
        ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "}"}], ",", 
       RowBox[{"Method", "\[Rule]", "\"\<RandomSearch\>\""}]}], "]"}]}], ";", 
    "\n", 
    RowBox[{"(*", 
     RowBox[{"res", "=", 
      RowBox[{"NMinimize", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"lipFnuCPLP3", "[", 
           RowBox[{"heat", ",", "0", ",", "\[Theta]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"hmin", "<", "heat", "<", "hmax"}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}], ")"}]}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "\[Theta]"}], "}"}], ",", 
        RowBox[{"Method", "\[Rule]", "\"\<RandomSearch\>\""}]}], "]"}]}], 
     "*)"}], "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<sp=\>\"", ",", 
      RowBox[{"sptab", "[", 
       RowBox[{"[", "sp", "]"}], "]"}], ",", 
      "\"\<; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=\>\"", ",", 
      RowBox[{
       RowBox[{"res", "[", "sp", "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<  at  heat=\>\"", ",", 
      RowBox[{
       RowBox[{"Exp", "[", "heat", "]"}], "/.", 
       RowBox[{
        RowBox[{"res", "[", "sp", "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<;  \[Theta]=\>\"", ",", 
      RowBox[{"\[Theta]", "/.", 
       RowBox[{
        RowBox[{"res", "[", "sp", "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"sp", ",", "1", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.500642066392*^9, 3.500642098749*^9}, {3.50064212958*^9, 
  3.5006421569700003`*^9}, {3.5006423077209997`*^9, 3.500642310635*^9}, {
  3.5006425230810003`*^9, 3.500642564285*^9}, {3.500642818506*^9, 
  3.50064281908*^9}, {3.500644184868*^9, 3.5006441885769997`*^9}, {
  3.500909328486*^9, 3.500909366211*^9}, {3.500909397571*^9, 
  3.500909399059*^9}, {3.5009098243710003`*^9, 3.500909840594*^9}, {
  3.501937061078*^9, 3.501937061868*^9}, {3.501937300575*^9, 
  3.5019373012139997`*^9}, {3.5019395666219997`*^9, 3.50193956695*^9}}],

Cell[BoxData[
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"res", "[", "sp", "]"}], "=", 
     RowBox[{"NMinimize", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"lipFnu3", "[", "sp", "]"}], "[", 
          RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"hmin", "<", "heat", "<", "hmax"}], ")"}], "&&", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "rhomax"}], "<", "rhonor", "<", "rhomax"}], ")"}], "&&", 
          RowBox[{"(", 
           RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}], ")"}]}]}], "}"}],
        ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "}"}], ",", 
       RowBox[{"Method", "\[Rule]", "\"\<RandomSearch\>\""}]}], "]"}]}], ";", 
    "\n", 
    RowBox[{"(*", 
     RowBox[{"res", "=", 
      RowBox[{"NMinimize", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"lipFnuCPLP3", "[", 
           RowBox[{"heat", ",", "0", ",", "\[Theta]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"hmin", "<", "heat", "<", "hmax"}], ")"}], "&&", 
           RowBox[{"(", 
            RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}], ")"}]}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "\[Theta]"}], "}"}], ",", 
        RowBox[{"Method", "\[Rule]", "\"\<RandomSearch\>\""}]}], "]"}]}], 
     "*)"}], "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<sp=\>\"", ",", 
      RowBox[{"sptab", "[", 
       RowBox[{"[", "sp", "]"}], "]"}], ",", 
      "\"\<; min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=\>\"", ",", 
      RowBox[{
       RowBox[{"res", "[", "sp", "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<  at  heat=\>\"", ",", 
      RowBox[{
       RowBox[{"Exp", "[", "heat", "]"}], "/.", 
       RowBox[{
        RowBox[{"res", "[", "sp", "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ",", "\"\<;  \[Theta]=\>\"", ",", 
      RowBox[{"\[Theta]", "/.", 
       RowBox[{
        RowBox[{"res", "[", "sp", "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"sp", ",", "1", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.501939582269*^9, 3.501939583197*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"poi3", "=", "100000"}], ";", 
  RowBox[{"Timing", "[", 
   RowBox[{"PFnu", "=", 
    RowBox[{"Re", "[", 
     RowBox[{"NIntegrate", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          FractionBox[
           SuperscriptBox[
            RowBox[{
             RowBox[{"lipFnu3", "[", "2", "]"}], "[", 
             RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "2"], 
           "2"]}], "]"}], 
        RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"rhonor", ",", 
         RowBox[{
          RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
         RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Method", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
          RowBox[{"Method", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
             RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}],
        ",", 
       RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"deg", "=", "12"}], ";", 
  RowBox[{"Timing", "[", 
   RowBox[{"PFnux", "=", 
    RowBox[{"Re", "[", 
     RowBox[{"NIntegrate", "[", 
      RowBox[{
       RowBox[{"deg", " ", 
        RowBox[{"PDF", "[", 
         RowBox[{
          RowBox[{"ChiSquareDistribution", "[", "deg", "]"}], ",", 
          RowBox[{"deg", " ", 
           RowBox[{
            RowBox[{"lipFnu3", "[", "2", "]"}], "[", 
            RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}]}]}], 
         "]"}], 
        RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"rhonor", ",", 
         RowBox[{
          RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
         RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}], ",", 
       RowBox[{"Method", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
          RowBox[{"Method", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
             RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}],
        ",", 
       RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], "]"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.5006599847860003`*^9, 3.500660042361*^9}, {
  3.500660120078*^9, 3.500660135125*^9}, {3.500660176507*^9, 
  3.5006602456949997`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dat1", "=", 
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"4", ",", "0.4"}], "]"}], ",", "10"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dat2", "=", 
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"3.9", ",", "0.4"}], "]"}], ",", "10"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
   RowBox[{"TTest", "[", 
    RowBox[{"{", 
     RowBox[{"dat1", ",", "dat2"}], "}"}], "]"}], ",", 
   "\"\< = T-test for equal means of two unknown distributions\>\""}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.500695893523*^9, 3.500695898277*^9}, {
  3.5170977193484*^9, 3.5170977461963997`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"dat", "=", 
    RowBox[{"RandomVariate", "[", 
     RowBox[{
      RowBox[{"NormalDistribution", "[", 
       RowBox[{"4", ",", "0.01"}], "]"}], ",", "10"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"dat", "=", 
     RowBox[{"{", 
      RowBox[{
      "3", ",", "4", ",", "6", ",", "3.5", ",", "4.1", ",", "2.7", ",", "2.4",
        ",", "5", ",", "4.7", ",", "9", ",", "10"}], "}"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ldat", "=", 
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"4", ",", "0.4"}], "]"}], ",", "100000"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{"ZTest", "[", 
     RowBox[{"dat", ",", "0.4", ",", "4"}], "]"}], ",", 
    "\"\< = Z-test to known mean\>\""}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
     "tests", " ", "that", " ", "the", " ", "means", " ", "are", " ", "equal",
       " ", "for", " ", "known"}], " ", "&"}], " ", "unknown", " ", 
    "distributions"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{"ZTest", "[", 
     RowBox[{"dat", ",", "Automatic", ",", "4"}], "]"}], ",", 
    "\"\< = Z-test to known mean w/ inferred variance\>\""}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"=", 
    RowBox[{"LocationTest", "[", 
     RowBox[{"dat", ",", "4", ",", "\"\<Z\>\""}], "]"}]}], "*)"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
      "tests", " ", "that", " ", "the", " ", "means", " ", "are", " ", 
       "equal", " ", "for", " ", "dist", " ", 
       RowBox[{"w", "/", " ", "known"}], " ", "mean"}], " ", "+", " ", 
      RowBox[{"unknown", " ", "variance"}]}], " ", "&"}], " ", "unknown", " ",
     "distribution"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{"TTest", "[", 
     RowBox[{"{", 
      RowBox[{"dat", ",", "ldat"}], "}"}], "]"}], ",", 
    "\"\< = T-test for equal means of two unknown distributions\>\""}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
   "tests", " ", "that", " ", "the", " ", "means", " ", "are", " ", "equal", 
    " ", "for", " ", "unknown", " ", "normal", " ", "distributions"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{"DistributionFitTest", "[", 
     RowBox[{"dat", ",", 
      RowBox[{"NormalDistribution", "[", 
       RowBox[{"4", ",", "0.4"}], "]"}], ",", "\"\<Kuiper\>\""}], "]"}], ",", 
    "\"\< = data was drawn from known distribution - no normality \
assumption\>\""}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "tests", " ", "that", " ", "unknown", " ", "data", " ", "was", " ", 
     "drawn", " ", "from", " ", "known", " ", "distribution"}], " ", "-", " ", 
    RowBox[{"tests", " ", "shape"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
   RowBox[{"LocationTest", "[", 
    RowBox[{"dat", ",", "4", ",", "\"\<SignedRank\>\""}], "]"}], ",", 
   "\"\< = smart test of equality of means\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[ScriptCapitalH]", "=", 
   RowBox[{"LocationTest", "[", 
    RowBox[{"dat", ",", "4", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<TestDataTable\>\"", ",", "All"}], "}"}]}], "]"}]}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"\[ScriptCapitalH]", "=", 
    RowBox[{
     RowBox[{"DistributionFitTest", "[", 
      RowBox[{"dat", ",", 
       RowBox[{"NormalDistribution", "[", 
        RowBox[{"4", ",", "0.4"}], "]"}], ",", "\"\<HypothesisTestData\>\""}],
       "]"}], "\[IndentingNewLine]", 
     RowBox[{"\[ScriptCapitalH]", "[", 
      RowBox[{"\"\<TestDataTable\>\"", ",", "All"}], "]"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5006933981610003`*^9, 3.50069342101*^9}, {
  3.500693464909*^9, 3.500693489881*^9}, {3.500693551613*^9, 
  3.500693564862*^9}, {3.500695084644*^9, 3.5006951318190002`*^9}, {
  3.5006951749300003`*^9, 3.500695178448*^9}, {3.500695401889*^9, 
  3.50069540746*^9}, {3.500695460593*^9, 3.500695580314*^9}, {
  3.5006956260629997`*^9, 3.500695774725*^9}, {3.5006958599890003`*^9, 
  3.500695869012*^9}, {3.5006958991470003`*^9, 3.500695901477*^9}, {
  3.5006959486610003`*^9, 3.500696009201*^9}, {3.50069610677*^9, 
  3.500696112208*^9}, {3.500696176557*^9, 3.5006961838599997`*^9}, {
  3.500696281215*^9, 3.500696349075*^9}, {3.500696677769*^9, 
  3.500696766725*^9}, {3.500696866133*^9, 3.500696873139*^9}}],

Cell[BoxData[{
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    FractionBox["1", 
     RowBox[{
      SqrtBox[
       RowBox[{"2", "\[Pi]"}]], "\[Sigma]"}]], 
    RowBox[{"Exp", "[", 
     RowBox[{"-", 
      FractionBox[
       SuperscriptBox["x", "2"], 
       RowBox[{"2", 
        SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ",", "x"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     FractionBox["1", 
      RowBox[{
       SqrtBox[
        RowBox[{"2", "\[Pi]"}]], "0.01"}]], 
     RowBox[{"Exp", "[", 
      RowBox[{"-", 
       FractionBox[
        SuperscriptBox["x", "2"], 
        RowBox[{"2", " ", 
         SuperscriptBox["0.01", "2"]}]]}], "]"}]}], ",", 
    RowBox[{"1", "-", 
     RowBox[{"Erf", "[", 
      FractionBox["x", 
       RowBox[{
        SqrtBox["2"], " ", "0.01"}]], "]"}]}]}], "}"}], "/.", 
  RowBox[{"x", "\[Rule]", 
   RowBox[{"0.01", 
    SqrtBox[
     FractionBox["chisq", 
      RowBox[{"Length", "[", "dat", "]"}]]]}]}]}]}], "Input",
 CellChangeTimes->{{3.500702620641*^9, 3.500702669984*^9}, {
  3.5007027785150003`*^9, 3.500702808573*^9}, {3.500703445966*^9, 
  3.500703448112*^9}}],

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    FractionBox["1", 
     SqrtBox[
      RowBox[{"2", "\[Pi]"}]]], 
    RowBox[{"Exp", "[", 
     RowBox[{"-", 
      FractionBox[
       SuperscriptBox["x", "2"], "2"]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "\[Infinity]"}], ",", 
     RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.500704515546*^9, 3.500704559535*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"PearsonChiSquareTest", "[", 
    RowBox[{"data", ",", 
     RowBox[{"NormalDistribution", "[", "]"}], ",", "\"\<TestStatistic\>\""}],
     "]"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"SurvivalFunction", "[", 
    RowBox[{
     RowBox[{"ChiSquareDistribution", "[", 
      RowBox[{"Length", "[", "dat", "]"}], "]"}], ",", "chisq"}], "]"}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"ZTest", "[", 
    RowBox[{"dat", ",", "Automatic", ",", "4"}], "]"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"data", "=", 
     RowBox[{"RandomVariate", "[", 
      RowBox[{
       RowBox[{"NormalDistribution", "[", "]"}], ",", 
       SuperscriptBox["10", "4"]}], "]"}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"PearsonChiSquareTest", "[", 
    RowBox[{"dat", ",", 
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"\[Mu]", ",", "0.01"}], "]"}]}], "]"}], "*)"}], 
  "\[IndentingNewLine]"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"nh", ",", "co"}], "]"}], ";", 
  RowBox[{"ext", "=", "1."}], ";", 
  RowBox[{"acc", "=", "7"}], ";", 
  RowBox[{"inord", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"co", "=", "0"}], ";", 
  RowBox[{"thlen", "=", "30"}], ";", 
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"poi3", "=", "200000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tofit", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"8.45", ",", "0.68982", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.25"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14.9", ",", "0.904432", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.62"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22.5", ",", "1.070321", ",", "0.19", ",", "131.", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "43.", ",", "1.159432", ",", "0.504083", ",", "94.25", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "87.73", ",", "1.584437", ",", "1.11", ",", "102.777778", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"102.", ",", "1.415119", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"145.", ",", "2.245702", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"230.86", ",", "2.181906", ",", "7.61271", ",", "124.25", ",", 
       RowBox[{"-", "1.2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"349.", ",", "3.06505", ",", "7.03", ",", "148.142857", ",", 
       RowBox[{"-", "1.5"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"674.", ",", "3.203363", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"857.", ",", "2.786328", ",", "0", ",", "0", ",", "0"}], 
      "}"}]}], "}"}]}], ";", 
  RowBox[{"dFnu", "=", "0.33"}], ";", 
  RowBox[{"dCP", "=", "0.27"}], ";", 
  RowBox[{"dlogLP", "=", "0.26"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EVPA", "=", "28.5"}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"349", " ", "minus", " ", "230", " ", "difference"}], " ", "-", 
     " ", 
     RowBox[{
     "should", " ", "be", " ", "taken", " ", "with", " ", "the", " ", "other",
       " ", "sign", " ", "from", " ", "the", " ", "code"}]}], ",", " ", 
    RowBox[{"because", " ", "of", " ", "switching"}]}], "*)"}], 
  RowBox[{"dEVPA", "=", "20"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"gat", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"fnum", "=", 
           RowBox[{
            RowBox[{"-", "1"}], "-", "co"}]}], ";", 
          RowBox[{"th", "=", 
           RowBox[{
            FractionBox["\[Pi]", "thlen"], 
            RowBox[{"(", 
             RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
          RowBox[{"Import", "[", 
           RowBox[{
           "\"\<G:\\\\mathematica\\\\3DMHD\\\\odyssey_nnn\\\\poliresa\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"Round", "[", 
              RowBox[{"100", 
               RowBox[{"sptab", "[", 
                RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
            "\"\<th\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"Floor", "[", 
              RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<fn\>\"", "<>", 
            RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<.dat\>\""}], 
           "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", "\n", 
    RowBox[{"flen", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"1", ";;", "11"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}]}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
    RowBox[{"Off", "[", 
     RowBox[{
      RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
      RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], ";", 
    RowBox[{"gat", "=", 
     RowBox[{"Partition", "[", 
      RowBox[{"gat", ",", "flen"}], "]"}]}], ";", 
    RowBox[{"rholen", "=", 
     RowBox[{"Length", "[", 
      RowBox[{"Position", "[", 
       RowBox[{
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "8"}], "]"}], 
         "]"}], ",", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}]}], "]"}], 
      "]"}]}], ";", 
    RowBox[{"gat", "=", 
     RowBox[{"Partition", "[", 
      RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", 
    RowBox[{"dim", "=", 
     RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", 
    RowBox[{"hlen", "=", 
     RowBox[{"dim", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], ";", 
    RowBox[{"hmin", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], 
       "]"}], "]"}]}], ";", 
    RowBox[{"hmax", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}], 
      "]"}]}], ";", 
    RowBox[{"thmin", "=", 
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", 
    RowBox[{"thmax", "=", 
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "1", ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"rateint", "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], "]"}], 
         "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"raterho", "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "9"}], "]"}], 
         "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"tabb", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox[
          RowBox[{"Total", "[", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                  "2"}], "]"}], "]"}], "-", 
               RowBox[{"gat", "[", 
                RowBox[{"[", 
                 RowBox[{"nh", ",", "#", ",", "All", ",", "All", ",", "3"}], 
                 "]"}], "]"}]}], "dFnu"], ")"}], "2"], "]"}], "flen"], "&"}], 
        "/@", 
        RowBox[{"Range", "[", "7", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"nh", ",", "hlen"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"lipFnu3", "[", "sp", "]"}], "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{"tabb", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{"rhomax", "=", 
              RowBox[{"Log", "[", 
               FractionBox[
                RowBox[{"gat", "[", 
                 RowBox[{"[", 
                  RowBox[{"1", ",", 
                   RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "9"}], "]"}], 
                 "]"}], 
                RowBox[{"gat", "[", 
                 RowBox[{"[", 
                  RowBox[{"1", ",", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"flen", "+", "1"}], ")"}], "/", "2"}], ",", "1", 
                   ",", "1", ",", "9"}], "]"}], "]"}]], "]"}]}], ")"}]}], ",",
            "rhomax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"tabb", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox["1", 
           RowBox[{"flen", "+", "5"}]], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Total", "[", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox[
                RowBox[{
                 RowBox[{"tofit", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                    "2"}], "]"}], "]"}], "-", 
                 RowBox[{"gat", "[", 
                  RowBox[{"[", 
                   RowBox[{"nh", ",", "#", ",", "All", ",", "All", ",", "3"}],
                    "]"}], "]"}]}], "dFnu"], ")"}], "2"], "]"}], "+", 
            RowBox[{"Total", "[", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox[
                RowBox[{
                 RowBox[{"tofit", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
                 RowBox[{"gat", "[", 
                  RowBox[{"[", 
                   RowBox[{"nh", ",", "#", ",", 
                    RowBox[{
                    RowBox[{"-", "4"}], ";;", 
                    RowBox[{"-", "3"}]}], ",", "All", ",", "6"}], "]"}], 
                  "]"}]}], "dCP"], ")"}], "2"], "]"}], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox[
               RowBox[{
                RowBox[{"Log", "[", 
                 RowBox[{"tofit", "[", 
                  RowBox[{"[", 
                   RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
                RowBox[{"Log", "[", 
                 RowBox[{"gat", "[", 
                  RowBox[{"[", 
                   RowBox[{"nh", ",", "#", ",", 
                    RowBox[{"-", "7"}], ",", "All", ",", "4"}], "]"}], "]"}], 
                 "]"}]}], "dlogLP"], ")"}], "2"], "+", 
            RowBox[{"Total", "[", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox[
                RowBox[{
                 RowBox[{"Log", "[", 
                  RowBox[{"tofit", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}],
                  "-", 
                 RowBox[{"Log", "[", 
                  RowBox[{"gat", "[", 
                   RowBox[{"[", 
                    RowBox[{"nh", ",", "#", ",", 
                    RowBox[{
                    RowBox[{"-", "4"}], ";;", 
                    RowBox[{"-", "3"}]}], ",", "All", ",", "4"}], "]"}], 
                   "]"}], "]"}]}], "dlogLP"], ")"}], "2"], "]"}]}], ")"}]}], 
         "&"}], "/@", 
        RowBox[{"Range", "[", "7", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"nh", ",", "hlen"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"lipFnuCPLP3", "[", "sp", "]"}], "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{"tabb", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"sp", ",", "1", ",", "5"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.486482483677*^9, 3.4864825978534*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"poi2", "=", "10000"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{"Dynamic", "[", "sp", "]"}], ",", "\"\< \>\"", ",", 
    RowBox[{"Dynamic", "[", "thn", "]"}]}], "]"}], ";", 
  RowBox[{"xxlen", "=", "20"}], ";", 
  RowBox[{"\[Theta]min", "=", 
   RowBox[{"0.5", 
    FractionBox["\[Pi]", "xxlen"]}]}], ";", 
  RowBox[{"\[Theta]max", "=", 
   RowBox[{"\[Pi]", "-", "thmin"}]}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "\"\<ncvb\>\""}], "]"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Theta]FCPLP", "[", "sp", "]"}], "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"th", "=", 
          RowBox[{
           FractionBox["\[Pi]", "xxlen"], 
           RowBox[{"(", 
            RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
         RowBox[{"{", 
          RowBox[{"th", ",", 
           RowBox[{"Re", "[", 
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{"Exp", "[", 
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{
                   RowBox[{"lipFnuCPLP3", "[", "sp", "]"}], "[", 
                   RowBox[{"heat", ",", "rhonor", ",", "th"}], "]"}], "2"], 
                 "2"]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"rhonor", ",", 
                RowBox[{
                 RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
              RowBox[{"Method", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
                 RowBox[{"Method", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
                    RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], 
                "}"}]}], ",", 
              RowBox[{"MaxPoints", "\[Rule]", "poi2"}]}], "]"}], "]"}]}], 
          "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"thn", ",", "xxlen"}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"inFCPLP", "[", "sp", "]"}], "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{"\[Theta]FCPLP", "[", "sp", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FCPLPnorm", "[", "sp", "]"}], "=", 
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"inFCPLP", "[", "sp", "]"}], "[", "\[Theta]", "]"}], 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "\[Theta]min", ",", "\[Theta]max"}], 
         "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"\[Theta]F", "[", "sp", "]"}], "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"th", "=", 
          RowBox[{
           FractionBox["\[Pi]", "xxlen"], 
           RowBox[{"(", 
            RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
         RowBox[{"{", 
          RowBox[{"th", ",", 
           RowBox[{"Re", "[", 
            RowBox[{"NIntegrate", "[", 
             RowBox[{
              RowBox[{"Exp", "[", 
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{
                   RowBox[{"lipFnu3", "[", "sp", "]"}], "[", 
                   RowBox[{"heat", ",", "rhonor", ",", "th"}], "]"}], "2"], 
                 "2"]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"rhonor", ",", 
                RowBox[{
                 RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
              RowBox[{"Method", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
                 RowBox[{"Method", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
                    RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], 
                "}"}]}], ",", 
              RowBox[{"MaxPoints", "\[Rule]", "poi2"}]}], "]"}], "]"}]}], 
          "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"thn", ",", "xxlen"}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"inF", "[", "sp", "]"}], "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{"\[Theta]F", "[", "sp", "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"Fnorm", "[", "sp", "]"}], "=", 
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"inF", "[", "sp", "]"}], "[", "\[Theta]", "]"}], 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "\[Theta]min", ",", "\[Theta]max"}], 
         "}"}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"sp", ",", "1", ",", "5"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.4864805415550003`*^9, 3.4864806861514*^9}, {
   3.4864807478494*^9, 3.4864808731642*^9}, {3.4864809448774*^9, 
   3.4864809701338*^9}, {3.4864812881242*^9, 3.4864813188873997`*^9}, {
   3.4864814235165997`*^9, 3.4864814286334*^9}, {3.4864824314014*^9, 
   3.4864824422278*^9}, {3.4864825846714*^9, 3.4864825896166*^9}, {
   3.4864826420014*^9, 3.4864827413733997`*^9}, {3.4864828780294*^9, 
   3.4864828791214*^9}, {3.4864830349997997`*^9, 3.4864830437202*^9}, 
   3.500644793054*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"thic", "=", "3"}], ";", 
  RowBox[{"mysize", "=", "20"}], ";", 
  RowBox[{"SetOptions", "[", 
   RowBox[{"LogPlot", ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "thic", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"mysize", ",", 
       RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", "\"\<Arial\>\""}], 
      "}"}]}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Inclination angle \[Theta]\>\"", ",", 
       "\"\<Normalized probability\>\""}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], ";", 
  RowBox[{"col", "=", 
   RowBox[{"{", 
    RowBox[{"Black", ",", "Green", ",", "Brown", ",", "Blue", ",", "Cyan"}], 
    "}"}]}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"FCPLPplot", "[", "sp", "]"}], "=", 
      RowBox[{"LogPlot", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"inFCPLP", "[", "sp", "]"}], "[", 
          RowBox[{
           FractionBox["\[Pi]", "180"], "\[Theta]"}], "]"}], 
         RowBox[{"FCPLPnorm", "[", "3", "]"}]], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", 
          RowBox[{
           FractionBox["180", "\[Pi]"], "\[Theta]min"}], ",", 
          RowBox[{
           FractionBox["180", "\[Pi]"], "\[Theta]max"}]}], "}"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"90", ",", "145"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0.001", ",", "50"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.", ",", 
             FractionBox[
              RowBox[{"sp", "-", "1"}], "5"], ",", 
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"sp", "-", "1"}], "5"]}]}], "]"}], ",", 
           RowBox[{"AbsoluteThickness", "[", "thic", "]"}]}], "}"}]}]}], 
       "]"}]}], ";", "\n", 
     RowBox[{
      RowBox[{"Fplot", "[", "sp", "]"}], "=", 
      RowBox[{"LogPlot", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"inF", "[", "sp", "]"}], "[", 
          RowBox[{
           FractionBox["\[Pi]", "180"], "\[Theta]"}], "]"}], 
         RowBox[{"Fnorm", "[", "3", "]"}]], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", 
          RowBox[{
           FractionBox["180", "\[Pi]"], "\[Theta]min"}], ",", 
          RowBox[{
           FractionBox["180", "\[Pi]"], "\[Theta]max"}]}], "}"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           SuperscriptBox["10", 
            RowBox[{"-", "3"}]], ",", "10"}], "}"}]}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"RGBColor", "[", 
            RowBox[{"0.", ",", 
             FractionBox[
              RowBox[{"sp", "-", "1"}], "5"], ",", 
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"sp", "-", "1"}], "5"]}]}], "]"}], ",", 
           RowBox[{"AbsoluteThickness", "[", "thic", "]"}]}], "}"}]}]}], 
       "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"sp", ",", "2", ",", "5"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.4864813313206*^9, 3.486481525447*^9}, {
   3.4864816985134*^9, 3.486481818571*^9}, {3.4864820074245996`*^9, 
   3.4864820155366*^9}, {3.4864828134454*^9, 3.4864828478278*^9}, {
   3.4864828875453997`*^9, 3.4864829342518*^9}, {3.4864830928602*^9, 
   3.4864831015182*^9}, {3.486483211545*^9, 3.486483242901*^9}, {
   3.4864832866122*^9, 3.4864833305886*^9}, {3.486483384939*^9, 
   3.486483385407*^9}, {3.4864834463406*^9, 3.4864835035146*^9}, 
   3.4864835378970003`*^9}],

Cell[BoxData[{
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"Fplot", "[", "2", "]"}], ",", 
   RowBox[{"Fplot", "[", "3", "]"}], ",", 
   RowBox[{"Fplot", "[", "4", "]"}], ",", 
   RowBox[{"Fplot", "[", "5", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"FCPLPplot", "[", "2", "]"}], ",", 
   RowBox[{"FCPLPplot", "[", "3", "]"}], ",", 
   RowBox[{"FCPLPplot", "[", "4", "]"}], ",", 
   RowBox[{"FCPLPplot", "[", "5", "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.4864831082418003`*^9, 3.4864832009526*^9}}],

Cell[BoxData["x"], "Input",
 CellChangeTimes->{3.4856100436990366`*^9}],

Cell[BoxData["500000"], "Input",
 CellChangeTimes->{{3.4844937713032*^9, 3.4844937732688*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"180", "-", 
  RowBox[{"2.1", " ", 
   FractionBox["180", "\[Pi]"]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"inum", "=", "100"}], ";", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"0.4", " ", 
     SuperscriptBox["1.05", "i"]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", "inum"}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.4845798565986*^9, 3.484579872573*^9}, {
  3.4846533299336*^9, 3.4846533540668*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\"sp=\"\>", "\[InvisibleSpace]", "0.9`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.10669424545163775`", 
   "\[InvisibleSpace]", "\<\"; PCP=\"\>", "\[InvisibleSpace]", 
   "0.005990849991399063`", "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", 
   "\[InvisibleSpace]", "0.0033799404833830186`"}],
  SequenceForm[
  "co=", 0, "sp=", 0.9, "; Probabilities: P(Fnu)=", 0.10669424545163775`, 
   "; PCP=", 0.005990849991399063, "; PCPLP=", 0.0033799404833830186`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"sp=\"\>", "\[InvisibleSpace]", "0.9`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.1130826483402193`", 
   "\[InvisibleSpace]", "\<\"; PCP=\"\>", "\[InvisibleSpace]", 
   "0.013280319296889357`", "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", 
   "\[InvisibleSpace]", "0.0011681287867020846`"}],
  SequenceForm[
  "co=", 1, "sp=", 0.9, "; Probabilities: P(Fnu)=", 0.1130826483402193, 
   "; PCP=", 0.013280319296889357`, "; PCPLP=", 0.0011681287867020846`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"sp=\"\>", "\[InvisibleSpace]", "0.9`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.11219527570585637`", 
   "\[InvisibleSpace]", "\<\"; PCP=\"\>", "\[InvisibleSpace]", 
   "0.011909493302349835`", "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", 
   "\[InvisibleSpace]", "0.007784869490778616`"}],
  SequenceForm[
  "co=", 2, "sp=", 0.9, "; Probabilities: P(Fnu)=", 0.11219527570585637`, 
   "; PCP=", 0.011909493302349835`, "; PCPLP=", 0.007784869490778616],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"sp=\"\>", "\[InvisibleSpace]", "0.9`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.10449747463717049`", 
   "\[InvisibleSpace]", "\<\"; PCP=\"\>", "\[InvisibleSpace]", 
   "0.0015796047174800444`", "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", 
   "\[InvisibleSpace]", "0.001032741791482769`"}],
  SequenceForm[
  "co=", 3, "sp=", 0.9, "; Probabilities: P(Fnu)=", 0.10449747463717049`, 
   "; PCP=", 0.0015796047174800444`, "; PCPLP=", 0.001032741791482769],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"sp=\"\>", "\[InvisibleSpace]", "0.9`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.11134642628525881`", 
   "\[InvisibleSpace]", "\<\"; PCP=\"\>", "\[InvisibleSpace]", 
   "0.006636272591774596`", "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", 
   "\[InvisibleSpace]", "0.0018460835586507891`"}],
  SequenceForm[
  "co=", 4, "sp=", 0.9, "; Probabilities: P(Fnu)=", 0.11134642628525881`, 
   "; PCP=", 0.006636272591774596, "; PCPLP=", 0.0018460835586507891`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"sp=\"\>", "\[InvisibleSpace]", "0.9`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.10427193400248641`", 
   "\[InvisibleSpace]", "\<\"; PCP=\"\>", "\[InvisibleSpace]", 
   "0.005412353179173153`", "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", 
   "\[InvisibleSpace]", "0.0023471441775633093`"}],
  SequenceForm[
  "co=", 5, "sp=", 0.9, "; Probabilities: P(Fnu)=", 0.10427193400248641`, 
   "; PCP=", 0.005412353179173153, "; PCPLP=", 0.0023471441775633093`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"sp=\"\>", "\[InvisibleSpace]", "0.9`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.10250334637071327`", 
   "\[InvisibleSpace]", "\<\"; PCP=\"\>", "\[InvisibleSpace]", 
   "0.0031879178080101035`", "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", 
   "\[InvisibleSpace]", "0.0017972240971333468`"}],
  SequenceForm[
  "co=", 6, "sp=", 0.9, "; Probabilities: P(Fnu)=", 0.10250334637071327`, 
   "; PCP=", 0.0031879178080101035`, "; PCPLP=", 0.0017972240971333468`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"sp=\"\>", "\[InvisibleSpace]", "0.9`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.10245272031065529`", 
   "\[InvisibleSpace]", "\<\"; PCP=\"\>", "\[InvisibleSpace]", 
   "0.004236465737762282`", "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", 
   "\[InvisibleSpace]", "0.0017060286754168978`"}],
  SequenceForm[
  "co=", 7, "sp=", 0.9, "; Probabilities: P(Fnu)=", 0.10245272031065529`, 
   "; PCP=", 0.004236465737762282, "; PCPLP=", 0.0017060286754168978`],
  Editable->False]}], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.4856100846646366`*^9, 3.485795375041415*^9, 
  3.4857959331314154`*^9, 3.4858614415102153`*^9, 3.4858636236538153`*^9}],

Cell[BoxData[{
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\"sp=\"\>", "\[InvisibleSpace]", "0.`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.029888473117124725`", 
   "\[InvisibleSpace]", "\<\"; PCP=\"\>", "\[InvisibleSpace]", 
   "0.00007558974082604428`", "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", 
   "\[InvisibleSpace]", "0.000018322201118716728`"}],
  SequenceForm[
  "co=", 0, "sp=", 0., "; Probabilities: P(Fnu)=", 0.029888473117124725`, 
   "; PCP=", 0.00007558974082604428, "; PCPLP=", 0.000018322201118716728`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\"sp=\"\>", "\[InvisibleSpace]", "0.5`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.11576225835126357`", 
   "\[InvisibleSpace]", "\<\"; PCP=\"\>", "\[InvisibleSpace]", 
   "0.007303091753408392`", "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", 
   "\[InvisibleSpace]", "0.00031355696494507446`"}],
  SequenceForm[
  "co=", 0, "sp=", 0.5, "; Probabilities: P(Fnu)=", 0.11576225835126357`, 
   "; PCP=", 0.007303091753408392, "; PCPLP=", 0.00031355696494507446`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\"sp=\"\>", "\[InvisibleSpace]", "0.7`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.1021416716052561`", 
   "\[InvisibleSpace]", "\<\"; PCP=\"\>", "\[InvisibleSpace]", 
   "0.011241603649941841`", "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", 
   "\[InvisibleSpace]", "0.00046725928487918126`"}],
  SequenceForm[
  "co=", 0, "sp=", 0.7, "; Probabilities: P(Fnu)=", 0.1021416716052561, 
   "; PCP=", 0.011241603649941841`, "; PCPLP=", 0.00046725928487918126`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\"sp=\"\>", "\[InvisibleSpace]", "0.9`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.10669424545163775`", 
   "\[InvisibleSpace]", "\<\"; PCP=\"\>", "\[InvisibleSpace]", 
   "0.005990849991399063`", "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", 
   "\[InvisibleSpace]", "0.0033799404833830186`"}],
  SequenceForm[
  "co=", 0, "sp=", 0.9, "; Probabilities: P(Fnu)=", 0.10669424545163775`, 
   "; PCP=", 0.005990849991399063, "; PCPLP=", 0.0033799404833830186`],
  Editable->False], "\n", 
 InterpretationBox[
  RowBox[{"\<\"co=\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\"sp=\"\>", "\[InvisibleSpace]", "0.98`", 
   "\[InvisibleSpace]", "\<\"; Probabilities: P(Fnu)=\"\>", 
   "\[InvisibleSpace]", "0.1090809767278269`", 
   "\[InvisibleSpace]", "\<\"; PCP=\"\>", "\[InvisibleSpace]", 
   "0.007163872460606839`", "\[InvisibleSpace]", "\<\"; PCPLP=\"\>", 
   "\[InvisibleSpace]", "0.0006268172324242625`"}],
  SequenceForm[
  "co=", 0, "sp=", 0.98, "; Probabilities: P(Fnu)=", 0.1090809767278269, 
   "; PCP=", 0.007163872460606839, "; PCPLP=", 0.0006268172324242625],
  Editable->False]}], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.4856100846646366`*^9, 3.485795375041415*^9, 
  3.4857959331314154`*^9, 3.4858614415102153`*^9, 3.4858628928874154`*^9, 
  3.4858636760074153`*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dx", "=", "430"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"6950", "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"n", "-", "1"}], ")"}], " ", "dx"}]}], ",", 
     RowBox[{"6950", "+", 
      RowBox[{"n", " ", "dx"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "7"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.4843100809146*^9, 3.4843100907426*^9}, {
  3.4843101250313997`*^9, 3.4843101670266*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["tables", "Subsubsection",
 CellChangeTimes->{{3.503077308564*^9, 3.503077309275*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Theta]FCPLP", "[", "5", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.03141`", ",", 
       RowBox[{"-", "231.268`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.09424`", ",", 
       RowBox[{"-", "216.681`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.15707`", ",", 
       RowBox[{"-", "197.4`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.21991`", ",", 
       RowBox[{"-", "161.096`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.28274`", ",", 
       RowBox[{"-", "126.703`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.34557`", ",", 
       RowBox[{"-", "104.25`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.4084`", ",", 
       RowBox[{"-", "93.5125`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.47123`", ",", 
       RowBox[{"-", "86.8252`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.53407`", ",", 
       RowBox[{"-", "82.6085`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.5969`", ",", 
       RowBox[{"-", "80.1627`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.65973`", ",", 
       RowBox[{"-", "80.8202`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.72256`", ",", 
       RowBox[{"-", "73.2402`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.78539`", ",", 
       RowBox[{"-", "66.9791`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.84823`", ",", 
       RowBox[{"-", "39.4874`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.91106`", ",", 
       RowBox[{"-", "38.5316`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.97389`", ",", 
       RowBox[{"-", "39.7818`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.03672`", ",", 
       RowBox[{"-", "45.0407`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.09955`", ",", 
       RowBox[{"-", "48.864`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.16238`", ",", 
       RowBox[{"-", "59.0883`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.22522`", ",", 
       RowBox[{"-", "72.8118`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.28805`", ",", 
       RowBox[{"-", "89.9272`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.35088`", ",", 
       RowBox[{"-", "97.2574`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.41371`", ",", 
       RowBox[{"-", "97.8079`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.47654`", ",", 
       RowBox[{"-", "85.3478`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.53938`", ",", 
       RowBox[{"-", "75.7693`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.60221`", ",", 
       RowBox[{"-", "70.168`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.66504`", ",", 
       RowBox[{"-", "64.8249`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.72787`", ",", 
       RowBox[{"-", "62.4977`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.7907`", ",", 
       RowBox[{"-", "66.2353`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.85353`", ",", 
       RowBox[{"-", "61.8016`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.91637`", ",", 
       RowBox[{"-", "51.2608`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.9792`", ",", 
       RowBox[{"-", "36.3658`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.04203`", ",", 
       RowBox[{"-", "25.5318`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.10486`", ",", 
       RowBox[{"-", "17.16`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.16769`", ",", 
       RowBox[{"-", "12.2074`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.23053`", ",", 
       RowBox[{"-", "11.949`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.29336`", ",", 
       RowBox[{"-", "15.2586`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.35619`", ",", 
       RowBox[{"-", "21.6635`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.41902`", ",", 
       RowBox[{"-", "32.4496`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.48185`", ",", 
       RowBox[{"-", "44.8285`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.54469`", ",", 
       RowBox[{"-", "55.2633`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.60752`", ",", 
       RowBox[{"-", "54.4715`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.67035`", ",", 
       RowBox[{"-", "46.4255`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.73318`", ",", 
       RowBox[{"-", "52.4624`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.79601`", ",", 
       RowBox[{"-", "74.5247`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.85884`", ",", 
       RowBox[{"-", "95.6883`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.92168`", ",", 
       RowBox[{"-", "134.561`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.98451`", ",", 
       RowBox[{"-", "140.156`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.04734`", ",", 
       RowBox[{"-", "173.`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.11017`", ",", 
       RowBox[{"-", "186.924`"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Theta]FCPLP", "[", "4", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.03141`", ",", 
       RowBox[{"-", "230.848`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.09424`", ",", 
       RowBox[{"-", "122.236`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.15707`", ",", 
       RowBox[{"-", "180.567`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.21991`", ",", 
       RowBox[{"-", "146.313`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.28274`", ",", 
       RowBox[{"-", "152.461`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.34557`", ",", 
       RowBox[{"-", "164.181`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.4084`", ",", 
       RowBox[{"-", "119.93`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.47123`", ",", 
       RowBox[{"-", "146.929`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.53407`", ",", 
       RowBox[{"-", "149.781`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.5969`", ",", 
       RowBox[{"-", "121.592`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.65973`", ",", 
       RowBox[{"-", "94.5023`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.72256`", ",", 
       RowBox[{"-", "75.0945`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.78539`", ",", 
       RowBox[{"-", "58.3431`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.84823`", ",", 
       RowBox[{"-", "43.8553`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.91106`", ",", 
       RowBox[{"-", "34.5317`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.97389`", ",", 
       RowBox[{"-", "31.9139`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.03672`", ",", 
       RowBox[{"-", "33.3664`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.09955`", ",", 
       RowBox[{"-", "41.0646`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.16238`", ",", 
       RowBox[{"-", "49.8572`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.22522`", ",", 
       RowBox[{"-", "51.4018`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.28805`", ",", 
       RowBox[{"-", "58.3552`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.35088`", ",", 
       RowBox[{"-", "66.6306`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.41371`", ",", 
       RowBox[{"-", "71.9067`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.47654`", ",", 
       RowBox[{"-", "75.6421`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.53938`", ",", 
       RowBox[{"-", "73.2605`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.60221`", ",", 
       RowBox[{"-", "77.0598`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.66504`", ",", 
       RowBox[{"-", "66.2061`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.72787`", ",", 
       RowBox[{"-", "55.9779`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.7907`", ",", 
       RowBox[{"-", "49.0163`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.85353`", ",", 
       RowBox[{"-", "49.2274`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.91637`", ",", 
       RowBox[{"-", "48.1785`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.9792`", ",", 
       RowBox[{"-", "27.9366`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.04203`", ",", 
       RowBox[{"-", "23.5499`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.10486`", ",", 
       RowBox[{"-", "21.8688`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.16769`", ",", 
       RowBox[{"-", "15.2214`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.23053`", ",", 
       RowBox[{"-", "9.83949`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.29336`", ",", 
       RowBox[{"-", "16.304`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.35619`", ",", 
       RowBox[{"-", "31.4762`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.41902`", ",", 
       RowBox[{"-", "34.7808`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.48185`", ",", 
       RowBox[{"-", "24.9733`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.54469`", ",", 
       RowBox[{"-", "31.8609`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.60752`", ",", 
       RowBox[{"-", "23.4592`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.67035`", ",", 
       RowBox[{"-", "26.2337`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.73318`", ",", 
       RowBox[{"-", "38.2695`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.79601`", ",", 
       RowBox[{"-", "68.8672`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.85884`", ",", 
       RowBox[{"-", "63.353`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.92168`", ",", 
       RowBox[{"-", "135.219`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.98451`", ",", 
       RowBox[{"-", "220.889`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.04734`", ",", 
       RowBox[{"-", "244.62`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.11017`", ",", 
       RowBox[{"-", "155.703`"}]}], "}"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Theta]FCPLP", "[", "3", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.03141`", ",", 
       RowBox[{"-", "293.322`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.09424`", ",", 
       RowBox[{"-", "277.144`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.15707`", ",", 
       RowBox[{"-", "206.942`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.21991`", ",", 
       RowBox[{"-", "168.08`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.28274`", ",", 
       RowBox[{"-", "110.349`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.34557`", ",", 
       RowBox[{"-", "69.6067`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.4084`", ",", 
       RowBox[{"-", "48.8803`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.47123`", ",", 
       RowBox[{"-", "35.5828`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.53407`", ",", 
       RowBox[{"-", "36.1569`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.5969`", ",", 
       RowBox[{"-", "34.9829`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.65973`", ",", 
       RowBox[{"-", "43.1974`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.72256`", ",", 
       RowBox[{"-", "64.7259`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.78539`", ",", 
       RowBox[{"-", "76.2682`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.84823`", ",", 
       RowBox[{"-", "59.078`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.91106`", ",", 
       RowBox[{"-", "51.8187`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.97389`", ",", 
       RowBox[{"-", "49.5989`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.03672`", ",", 
       RowBox[{"-", "45.7939`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.09955`", ",", 
       RowBox[{"-", "51.0512`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.16238`", ",", 
       RowBox[{"-", "47.263`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.22522`", ",", 
       RowBox[{"-", "44.1011`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.28805`", ",", 
       RowBox[{"-", "41.6054`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.35088`", ",", 
       RowBox[{"-", "42.028`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.41371`", ",", 
       RowBox[{"-", "44.9779`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.47654`", ",", 
       RowBox[{"-", "38.453`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.53938`", ",", 
       RowBox[{"-", "37.6322`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.60221`", ",", 
       RowBox[{"-", "38.2901`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.66504`", ",", 
       RowBox[{"-", "35.7971`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.72787`", ",", 
       RowBox[{"-", "32.5439`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.7907`", ",", 
       RowBox[{"-", "22.526`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.85353`", ",", 
       RowBox[{"-", "15.4618`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.91637`", ",", 
       RowBox[{"-", "17.8901`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.9792`", ",", 
       RowBox[{"-", "18.0065`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.04203`", ",", 
       RowBox[{"-", "13.38`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.10486`", ",", 
       RowBox[{"-", "14.1481`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.16769`", ",", 
       RowBox[{"-", "17.2384`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.23053`", ",", 
       RowBox[{"-", "27.0893`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.29336`", ",", 
       RowBox[{"-", "28.5657`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.35619`", ",", 
       RowBox[{"-", "27.7161`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.41902`", ",", 
       RowBox[{"-", "28.8812`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.48185`", ",", 
       RowBox[{"-", "28.9967`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.54469`", ",", 
       RowBox[{"-", "41.3038`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.60752`", ",", 
       RowBox[{"-", "63.8472`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.67035`", ",", 
       RowBox[{"-", "69.0105`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.73318`", ",", 
       RowBox[{"-", "117.024`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.79601`", ",", 
       RowBox[{"-", "142.404`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.85884`", ",", 
       RowBox[{"-", "111.557`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.92168`", ",", 
       RowBox[{"-", "168.512`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.98451`", ",", 
       RowBox[{"-", "249.818`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.04734`", ",", 
       RowBox[{"-", "222.537`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.11017`", ",", 
       RowBox[{"-", "186.595`"}]}], "}"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Theta]FCPLP", "[", "2", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.03141`", ",", 
       RowBox[{"-", "237.545`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.09424`", ",", 
       RowBox[{"-", "279.064`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.15707`", ",", 
       RowBox[{"-", "293.425`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.21991`", ",", 
       RowBox[{"-", "212.865`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.28274`", ",", 
       RowBox[{"-", "155.826`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.34557`", ",", 
       RowBox[{"-", "133.468`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.4084`", ",", 
       RowBox[{"-", "120.814`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.47123`", ",", 
       RowBox[{"-", "112.787`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.53407`", ",", 
       RowBox[{"-", "88.1708`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.5969`", ",", 
       RowBox[{"-", "75.1039`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.65973`", ",", 
       RowBox[{"-", "85.523`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.72256`", ",", 
       RowBox[{"-", "91.6716`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.78539`", ",", 
       RowBox[{"-", "104.965`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.84823`", ",", 
       RowBox[{"-", "130.611`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.91106`", ",", 
       RowBox[{"-", "121.364`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.97389`", ",", 
       RowBox[{"-", "110.063`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.03672`", ",", 
       RowBox[{"-", "104.141`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.09955`", ",", 
       RowBox[{"-", "88.7654`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.16238`", ",", 
       RowBox[{"-", "75.3986`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.22522`", ",", 
       RowBox[{"-", "63.7417`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.28805`", ",", 
       RowBox[{"-", "54.2698`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.35088`", ",", 
       RowBox[{"-", "53.149`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.41371`", ",", 
       RowBox[{"-", "43.5009`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.47654`", ",", 
       RowBox[{"-", "39.5477`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.53938`", ",", 
       RowBox[{"-", "38.9243`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.60221`", ",", 
       RowBox[{"-", "27.0997`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.66504`", ",", 
       RowBox[{"-", "22.5565`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.72787`", ",", 
       RowBox[{"-", "16.5132`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.7907`", ",", 
       RowBox[{"-", "10.8913`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.85353`", ",", 
       RowBox[{"-", "8.18165`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.91637`", ",", 
       RowBox[{"-", "8.52503`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.9792`", ",", 
       RowBox[{"-", "8.42317`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.04203`", ",", 
       RowBox[{"-", "10.597`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.10486`", ",", 
       RowBox[{"-", "13.4865`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.16769`", ",", 
       RowBox[{"-", "16.4167`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.23053`", ",", 
       RowBox[{"-", "19.9111`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.29336`", ",", 
       RowBox[{"-", "21.874`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.35619`", ",", 
       RowBox[{"-", "24.2432`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.41902`", ",", 
       RowBox[{"-", "27.3033`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.48185`", ",", 
       RowBox[{"-", "31.0821`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.54469`", ",", 
       RowBox[{"-", "32.0746`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.60752`", ",", 
       RowBox[{"-", "28.7046`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.67035`", ",", 
       RowBox[{"-", "26.062`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.73318`", ",", 
       RowBox[{"-", "26.1559`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.79601`", ",", 
       RowBox[{"-", "24.6129`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.85884`", ",", 
       RowBox[{"-", "36.2213`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.92168`", ",", 
       RowBox[{"-", "54.3425`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.98451`", ",", 
       RowBox[{"-", "113.175`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.04734`", ",", 
       RowBox[{"-", "249.637`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.11017`", ",", 
       RowBox[{"-", "329.922`"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Theta]F", "[", "5", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.03141`", ",", 
       RowBox[{"-", "10.1274`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.09424`", ",", 
       RowBox[{"-", "8.66142`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.15707`", ",", 
       RowBox[{"-", "7.31815`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.21991`", ",", 
       RowBox[{"-", "5.73137`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.28274`", ",", 
       RowBox[{"-", "4.90913`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.34557`", ",", 
       RowBox[{"-", "4.55504`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.4084`", ",", 
       RowBox[{"-", "4.26493`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.47123`", ",", 
       RowBox[{"-", "4.54198`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.53407`", ",", 
       RowBox[{"-", "5.08614`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.5969`", ",", 
       RowBox[{"-", "5.36846`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.65973`", ",", 
       RowBox[{"-", "5.49347`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.72256`", ",", 
       RowBox[{"-", "5.55855`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.78539`", ",", 
       RowBox[{"-", "5.57119`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.84823`", ",", 
       RowBox[{"-", "5.59407`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.91106`", ",", 
       RowBox[{"-", "5.61285`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.97389`", ",", 
       RowBox[{"-", "5.76458`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.03672`", ",", 
       RowBox[{"-", "5.82094`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.09955`", ",", 
       RowBox[{"-", "5.83716`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.16238`", ",", 
       RowBox[{"-", "5.82269`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.22522`", ",", 
       RowBox[{"-", "5.71297`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.28805`", ",", 
       RowBox[{"-", "5.51495`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.35088`", ",", 
       RowBox[{"-", "5.3363`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.41371`", ",", 
       RowBox[{"-", "5.14189`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.47654`", ",", 
       RowBox[{"-", "5.01011`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.53938`", ",", 
       RowBox[{"-", "4.94712`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.60221`", ",", 
       RowBox[{"-", "4.96442`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.66504`", ",", 
       RowBox[{"-", "5.00775`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.72787`", ",", 
       RowBox[{"-", "5.12916`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.7907`", ",", 
       RowBox[{"-", "5.21428`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.85353`", ",", 
       RowBox[{"-", "5.3417`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.91637`", ",", 
       RowBox[{"-", "5.45217`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.9792`", ",", 
       RowBox[{"-", "5.56384`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.04203`", ",", 
       RowBox[{"-", "5.57522`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.10486`", ",", 
       RowBox[{"-", "5.55486`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.16769`", ",", 
       RowBox[{"-", "5.50274`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.23053`", ",", 
       RowBox[{"-", "5.45231`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.29336`", ",", 
       RowBox[{"-", "5.47689`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.35619`", ",", 
       RowBox[{"-", "5.47259`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.41902`", ",", 
       RowBox[{"-", "5.45277`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.48185`", ",", 
       RowBox[{"-", "5.39236`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.54469`", ",", 
       RowBox[{"-", "5.22288`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.60752`", ",", 
       RowBox[{"-", "4.71038`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.67035`", ",", 
       RowBox[{"-", "4.05177`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.73318`", ",", 
       RowBox[{"-", "4.33662`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.79601`", ",", 
       RowBox[{"-", "4.69509`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.85884`", ",", 
       RowBox[{"-", "6.02389`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.92168`", ",", 
       RowBox[{"-", "8.30245`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.98451`", ",", 
       RowBox[{"-", "11.1829`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.04734`", ",", 
       RowBox[{"-", "13.0399`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.11017`", ",", 
       RowBox[{"-", "14.7033`"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Theta]F", "[", "4", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.03141`", ",", 
       RowBox[{"-", "7.1023`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.09424`", ",", 
       RowBox[{"-", "5.99631`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.15707`", ",", 
       RowBox[{"-", "5.46573`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.21991`", ",", 
       RowBox[{"-", "5.10973`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.28274`", ",", 
       RowBox[{"-", "4.89903`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.34557`", ",", 
       RowBox[{"-", "4.95161`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.4084`", ",", 
       RowBox[{"-", "5.52516`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.47123`", ",", 
       RowBox[{"-", "6.69027`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.53407`", ",", 
       RowBox[{"-", "7.5422`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.5969`", ",", 
       RowBox[{"-", "7.8097`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.65973`", ",", 
       RowBox[{"-", "7.88928`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.72256`", ",", 
       RowBox[{"-", "7.80295`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.78539`", ",", 
       RowBox[{"-", "7.72446`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.84823`", ",", 
       RowBox[{"-", "7.66482`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.91106`", ",", 
       RowBox[{"-", "7.75188`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.97389`", ",", 
       RowBox[{"-", "7.87837`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.03672`", ",", 
       RowBox[{"-", "7.9033`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.09955`", ",", 
       RowBox[{"-", "7.85697`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.16238`", ",", 
       RowBox[{"-", "7.79378`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.22522`", ",", 
       RowBox[{"-", "7.62993`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.28805`", ",", 
       RowBox[{"-", "7.25838`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.35088`", ",", 
       RowBox[{"-", "6.85551`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.41371`", ",", 
       RowBox[{"-", "6.29644`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.47654`", ",", 
       RowBox[{"-", "5.88617`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.53938`", ",", 
       RowBox[{"-", "5.67163`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.60221`", ",", 
       RowBox[{"-", "5.65116`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.66504`", ",", 
       RowBox[{"-", "5.90625`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.72787`", ",", 
       RowBox[{"-", "6.38115`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.7907`", ",", 
       RowBox[{"-", "6.95445`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.85353`", ",", 
       RowBox[{"-", "7.25976`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.91637`", ",", 
       RowBox[{"-", "7.53644`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.9792`", ",", 
       RowBox[{"-", "7.60029`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.04203`", ",", 
       RowBox[{"-", "7.52477`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.10486`", ",", 
       RowBox[{"-", "7.46765`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.16769`", ",", 
       RowBox[{"-", "7.32265`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.23053`", ",", 
       RowBox[{"-", "7.12928`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.29336`", ",", 
       RowBox[{"-", "7.02155`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.35619`", ",", 
       RowBox[{"-", "7.05581`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.41902`", ",", 
       RowBox[{"-", "7.04665`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.48185`", ",", 
       RowBox[{"-", "6.97558`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.54469`", ",", 
       RowBox[{"-", "6.67279`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.60752`", ",", 
       RowBox[{"-", "5.97076`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.67035`", ",", 
       RowBox[{"-", "4.80831`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.73318`", ",", 
       RowBox[{"-", "4.42033`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.79601`", ",", 
       RowBox[{"-", "4.58412`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.85884`", ",", 
       RowBox[{"-", "4.86167`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.92168`", ",", 
       RowBox[{"-", "5.16902`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.98451`", ",", 
       RowBox[{"-", "5.57227`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.04734`", ",", 
       RowBox[{"-", "6.13501`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.11017`", ",", 
       RowBox[{"-", "7.26261`"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Theta]F", "[", "3", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.03141`", ",", 
       RowBox[{"-", "25.9411`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.09424`", ",", 
       RowBox[{"-", "24.3479`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.15707`", ",", 
       RowBox[{"-", "22.8514`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.21991`", ",", 
       RowBox[{"-", "20.1507`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.28274`", ",", 
       RowBox[{"-", "17.5288`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.34557`", ",", 
       RowBox[{"-", "14.6566`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.4084`", ",", 
       RowBox[{"-", "11.508`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.47123`", ",", 
       RowBox[{"-", "8.18362`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.53407`", ",", 
       RowBox[{"-", "5.94253`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.5969`", ",", 
       RowBox[{"-", "4.70541`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.65973`", ",", 
       RowBox[{"-", "4.19864`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.72256`", ",", 
       RowBox[{"-", "3.99487`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.78539`", ",", 
       RowBox[{"-", "3.84484`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.84823`", ",", 
       RowBox[{"-", "3.76577`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.91106`", ",", 
       RowBox[{"-", "4.01883`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.97389`", ",", 
       RowBox[{"-", "4.68237`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.03672`", ",", 
       RowBox[{"-", "5.51177`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.09955`", ",", 
       RowBox[{"-", "6.1957`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.16238`", ",", 
       RowBox[{"-", "6.60544`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.22522`", ",", 
       RowBox[{"-", "6.74732`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.28805`", ",", 
       RowBox[{"-", "6.61073`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.35088`", ",", 
       RowBox[{"-", "6.1444`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.41371`", ",", 
       RowBox[{"-", "5.53985`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.47654`", ",", 
       RowBox[{"-", "5.08788`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.53938`", ",", 
       RowBox[{"-", "4.92193`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.60221`", ",", 
       RowBox[{"-", "5.01962`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.66504`", ",", 
       RowBox[{"-", "5.35985`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.72787`", ",", 
       RowBox[{"-", "5.99211`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.7907`", ",", 
       RowBox[{"-", "6.53415`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.85353`", ",", 
       RowBox[{"-", "6.78321`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.91637`", ",", 
       RowBox[{"-", "6.79696`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.9792`", ",", 
       RowBox[{"-", "6.53735`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.04203`", ",", 
       RowBox[{"-", "6.00307`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.10486`", ",", 
       RowBox[{"-", "5.2469`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.16769`", ",", 
       RowBox[{"-", "4.42599`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.23053`", ",", 
       RowBox[{"-", "3.88238`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.29336`", ",", 
       RowBox[{"-", "3.73752`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.35619`", ",", 
       RowBox[{"-", "3.84583`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.41902`", ",", 
       RowBox[{"-", "3.99627`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.48185`", ",", 
       RowBox[{"-", "4.22238`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.54469`", ",", 
       RowBox[{"-", "4.88868`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.60752`", ",", 
       RowBox[{"-", "6.69161`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.67035`", ",", 
       RowBox[{"-", "9.81625`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.73318`", ",", 
       RowBox[{"-", "13.8728`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.79601`", ",", 
       RowBox[{"-", "17.871`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.85884`", ",", 
       RowBox[{"-", "23.1403`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.92168`", ",", 
       RowBox[{"-", "27.0853`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.98451`", ",", 
       RowBox[{"-", "30.5008`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.04734`", ",", 
       RowBox[{"-", "32.4419`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.11017`", ",", 
       RowBox[{"-", "34.1919`"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Theta]F", "[", "2", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.03141`", ",", 
       RowBox[{"-", "22.9031`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.09424`", ",", 
       RowBox[{"-", "21.5987`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.15707`", ",", 
       RowBox[{"-", "20.719`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.21991`", ",", 
       RowBox[{"-", "19.5779`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.28274`", ",", 
       RowBox[{"-", "18.1726`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.34557`", ",", 
       RowBox[{"-", "16.6044`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.4084`", ",", 
       RowBox[{"-", "14.9579`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.47123`", ",", 
       RowBox[{"-", "13.442`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.53407`", ",", 
       RowBox[{"-", "12.2078`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.5969`", ",", 
       RowBox[{"-", "11.109`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.65973`", ",", 
       RowBox[{"-", "10.2453`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.72256`", ",", 
       RowBox[{"-", "9.5181`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.78539`", ",", 
       RowBox[{"-", "8.85615`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.84823`", ",", 
       RowBox[{"-", "8.32679`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.91106`", ",", 
       RowBox[{"-", "7.98195`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.97389`", ",", 
       RowBox[{"-", "7.84721`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.03672`", ",", 
       RowBox[{"-", "7.79457`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.09955`", ",", 
       RowBox[{"-", "7.79339`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.16238`", ",", 
       RowBox[{"-", "7.85015`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.22522`", ",", 
       RowBox[{"-", "7.82517`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.28805`", ",", 
       RowBox[{"-", "7.65273`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.35088`", ",", 
       RowBox[{"-", "7.26969`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.41371`", ",", 
       RowBox[{"-", "6.66926`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.47654`", ",", 
       RowBox[{"-", "6.30813`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.53938`", ",", 
       RowBox[{"-", "6.169`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.60221`", ",", 
       RowBox[{"-", "6.22235`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.66504`", ",", 
       RowBox[{"-", "6.38079`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.72787`", ",", 
       RowBox[{"-", "6.77046`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.7907`", ",", 
       RowBox[{"-", "7.17518`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.85353`", ",", 
       RowBox[{"-", "7.45321`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.91637`", ",", 
       RowBox[{"-", "7.57302`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.9792`", ",", 
       RowBox[{"-", "7.56035`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.04203`", ",", 
       RowBox[{"-", "7.55319`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.10486`", ",", 
       RowBox[{"-", "7.54587`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.16769`", ",", 
       RowBox[{"-", "7.63766`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.23053`", ",", 
       RowBox[{"-", "7.82025`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.29336`", ",", 
       RowBox[{"-", "8.15116`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.35619`", ",", 
       RowBox[{"-", "8.67404`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.41902`", ",", 
       RowBox[{"-", "9.32692`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.48185`", ",", 
       RowBox[{"-", "10.1418`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.54469`", ",", 
       RowBox[{"-", "11.1365`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.60752`", ",", 
       RowBox[{"-", "12.4007`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.67035`", ",", 
       RowBox[{"-", "13.915`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.73318`", ",", 
       RowBox[{"-", "15.7106`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.79601`", ",", 
       RowBox[{"-", "17.6566`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.85884`", ",", 
       RowBox[{"-", "19.6197`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.92168`", ",", 
       RowBox[{"-", "21.3516`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.98451`", ",", 
       RowBox[{"-", "22.7937`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.04734`", ",", 
       RowBox[{"-", "23.8701`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.11017`", ",", 
       RowBox[{"-", "25.2646`"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Fnorm", "[", "2", "]"}], "=", "0.0011212337773897662"}], ";", 
  RowBox[{
   RowBox[{"Fnorm", "[", "3", "]"}], "=", "0.013895637218861846`"}], ";", 
  RowBox[{
   RowBox[{"Fnorm", "[", "4", "]"}], "=", "0.003489375537699251`"}], ";", 
  RowBox[{
   RowBox[{"Fnorm", "[", "5", "]"}], "=", "0.010320719804867508`"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FCPLPnorm", "[", "2", "]"}], "=", "0.000043904150829407224"}], 
  ";", 
  RowBox[{
   RowBox[{"FCPLPnorm", "[", "3", "]"}], "=", "1.2854899530533667`*^-7"}], 
  ";", 
  RowBox[{
   RowBox[{"FCPLPnorm", "[", "4", "]"}], "=", "1.561961249945853`*^-6"}], ";", 
  RowBox[{
   RowBox[{"FCPLPnorm", "[", "5", "]"}], "=", "6.017011851705533`*^-7"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ord", "=", "2"}], ";"}]}], "Input",
 CellChangeTimes->{{3.503075194524*^9, 3.5030752822790003`*^9}, {
  3.503075314323*^9, 3.503075358052*^9}, {3.50307545634*^9, 3.50307562371*^9}}
  ]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "\[Chi]^2 for all configurations (Figure 11) - ",
 StyleBox["deleted",
  FontColor->RGBColor[1, 0, 0]]
}], "Subsection",
 CellChangeTimes->{{3.485182082626*^9, 3.4851821147200003`*^9}, {
   3.4891544925379324`*^9, 3.4891544954239326`*^9}, {3.500917286084*^9, 
   3.500917288601*^9}, {3.50264711974*^9, 3.5026471383459997`*^9}, {
   3.5030809579440002`*^9, 3.503080958664*^9}, 3.509206149627*^9, {
   3.509293166731*^9, 3.509293167755*^9}, {3.528550435862842*^9, 
   3.528550436042845*^9}, {3.52916001297497*^9, 3.529160014654066*^9}, {
   3.5291647217972994`*^9, 3.529164724557457*^9}, {3.529321838197665*^9, 
   3.5293218382856703`*^9}, {3.539993780449953*^9, 3.539993791395579*^9}}],

Cell[CellGroupData[{

Cell["new - averaging over snapshots", "Subsubsection",
 CellChangeTimes->{{3.529149578720165*^9, 3.5291495905518417`*^9}, 
   3.5291501760603304`*^9}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.52915077399553*^9, 3.529150798938957*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"gat1", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Import", "[", 
         RowBox[{
         "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\xisqa\>\
\"", "<>", 
          RowBox[{"ToString", "[", 
           RowBox[{"Round", "[", 
            RowBox[{"100", 
             RowBox[{"sptab", "[", 
              RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
          "\"\<in11N\>\"", "<>", 
          RowBox[{"ToString", "[", "testN", "]"}], "<>", "\"\<.dat\>\""}], 
         "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"testN", ",", "7"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gat2", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Import", "[", 
         RowBox[{
         "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\\
deepthought\\\\xisqa\>\"", "<>", 
          RowBox[{"ToString", "[", 
           RowBox[{"Round", "[", 
            RowBox[{"100", 
             RowBox[{"sptab", "[", 
              RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
          "\"\<in11N\>\"", "<>", 
          RowBox[{"ToString", "[", "testN", "]"}], "<>", "\"\<.dat\>\""}], 
         "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"testN", ",", "7"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gat1", "=", 
      RowBox[{"Delete", "[", 
       RowBox[{"gat1", ",", 
        RowBox[{"Position", "[", 
         RowBox[{"gat1", ",", "$Failed"}], "]"}]}], "]"}]}], ";", 
     RowBox[{"ssx1", "=", 
      RowBox[{"Sort", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{"gat1", ",", "1"}], "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"#1", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "<", 
          RowBox[{"#2", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "&"}]}], "]"}]}], ";", 
     RowBox[{"ss1", "=", 
      RowBox[{"ssx1", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
     RowBox[{"ssx2", "=", 
      RowBox[{"Sort", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{"gat2", ",", "1"}], "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"#1", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "<", 
          RowBox[{"#2", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "&"}]}], "]"}]}], ";", 
     RowBox[{"ss2", "=", 
      RowBox[{"ssx2", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{
       RowBox[{"ListLogPlot", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ss1", "[", 
            RowBox[{"[", 
             RowBox[{"1", ";;", 
              RowBox[{"-", "10"}]}], "]"}], "]"}], ",", 
           RowBox[{"ss2", "[", 
            RowBox[{"[", 
             RowBox[{"1", ";;", 
              RowBox[{"-", "10"}]}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"0.9", 
             RowBox[{"ss1", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], ",", 
            RowBox[{"1.1", 
             RowBox[{"ss1", "[", 
              RowBox[{"[", 
               RowBox[{"-", "10"}], "]"}], "]"}]}]}], "}"}]}], ",", 
         RowBox[{"PlotLabel", "\[Rule]", 
          RowBox[{"\"\<spin = \>\"", "<>", 
           RowBox[{"ToString", "[", 
            RowBox[{"sptab", "[", 
             RowBox[{"[", "sp", "]"}], "]"}], "]"}]}]}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Red", ",", "Blue"}], "}"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}], ",", 
       "\"\<  icc gives: min(\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))=\>\"",
        ",", 
       RowBox[{"ss1", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       "\"\<;  gcc gives: min(\!\(\*SuperscriptBox[\(\[Chi]\), \
\(2\)]\))=\>\"", ",", 
       RowBox[{"ss2", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ";", 
     RowBox[{"Print", "[", 
      RowBox[{"ssx2", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "]"}], ";"}], ",", 
    RowBox[{"{", 
     RowBox[{"sp", ",", "5"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"{", 
    RowBox[{"4.48", ",", "2.09", ",", "3.31", ",", "3.91", ",", "3.71"}], 
    "}"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.529149645653993*^9, 3.529149775000391*^9}, {
  3.529149948679325*^9, 3.529149969584521*^9}, {3.5291500042005005`*^9, 
  3.529150018224303*^9}, {3.5291500926475596`*^9, 3.5291501116716475`*^9}, {
  3.529150151535928*^9, 3.5291502644323854`*^9}, {3.5291503318002386`*^9, 
  3.5291503940728*^9}, {3.52915068201427*^9, 3.529150700718339*^9}, {
  3.529150750017159*^9, 3.529150761870837*^9}, {3.529150805783349*^9, 
  3.529150820822209*^9}, {3.5291575032314205`*^9, 3.5291575050075226`*^9}, {
  3.529683440771368*^9, 3.529683477499402*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"gat2", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Import", "[", 
         RowBox[{
         "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\\
deepthought\\\\xisqa50in\>\"", "<>", 
          RowBox[{"ToString", "[", "co", "]"}], "<>", "\"\<N\>\"", "<>", 
          RowBox[{"ToString", "[", "testN", "]"}], "<>", "\"\<.dat\>\""}], 
         "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"testN", ",", "7"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ssx2", "=", 
      RowBox[{"Sort", "[", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{"gat2", ",", "1"}], "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"#1", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "<", 
          RowBox[{"#2", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "&"}]}], "]"}]}], ";", 
     RowBox[{"ss2", "=", 
      RowBox[{"ssx2", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{
       RowBox[{"ListLogPlot", "[", 
        RowBox[{
         RowBox[{"ss2", "[", 
          RowBox[{"[", 
           RowBox[{"1", ";;", 
            RowBox[{"-", "10"}]}], "]"}], "]"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"0.9", 
             RowBox[{"ss2", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], ",", 
            RowBox[{"1.1", 
             RowBox[{"ss2", "[", 
              RowBox[{"[", 
               RowBox[{"-", "10"}], "]"}], "]"}]}]}], "}"}]}], ",", 
         RowBox[{"PlotLabel", "\[Rule]", 
          RowBox[{"\"\<window = \>\"", "<>", 
           RowBox[{"ToString", "[", "co", "]"}]}]}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "Blue"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}], ",", 
       "\"\<;  gcc gives: min(\!\(\*SuperscriptBox[\(\[Chi]\), \
\(2\)]\))=\>\"", ",", 
       RowBox[{"ss2", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ";", 
     RowBox[{"Print", "[", 
      RowBox[{"ssx2", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "]"}], ";"}], ",", 
    RowBox[{"{", 
     RowBox[{"co", ",", "6"}], "}"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.5291577663334694`*^9, 3.5291578307121515`*^9}, {
  3.529157865220125*^9, 3.5291579735053186`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"chisqF", "=", 
    RowBox[{"{", 
     RowBox[{
     "6.695329", ",", "0.21319", ",", "\[InvisibleSpace]", "0.29149", ",", 
      "0.11951", ",", "\[InvisibleSpace]", "0.12347"}], "}"}]}], ";"}], 
  "\[InvisibleSpace]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"chisqFLC", "=", 
   RowBox[{"{", 
    RowBox[{
    "4.478", ",", "2.095", ",", "\[InvisibleSpace]", "3.306", ",", "3.906", 
     ",", "3.71"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"chisq05FLC", "=", 
   RowBox[{"{", 
    RowBox[{
    "3.839", ",", "\[InvisibleSpace]", "5.523", ",", "3.235", ",", "2.491", 
     ",", "2.546", ",", "2.348"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmin", "=", "6950"}], ";", 
  RowBox[{"jum", "=", "500"}], ";", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"tmin", "+", 
       RowBox[{"jum", " ", "i"}]}], ",", 
      RowBox[{"tmin", "+", 
       RowBox[{"jum", " ", 
        RowBox[{"(", 
         RowBox[{"i", "+", "1"}], ")"}]}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", "5"}], "}"}]}], "]"}], ";", 
  RowBox[{"tim", "=", 
   RowBox[{"2", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"tmin", "+", 
       RowBox[{"jum", " ", 
        RowBox[{"(", 
         RowBox[{"i", "+", 
          FractionBox["1", "2"]}], ")"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "0", ",", "5"}], "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"sxx", "=", 
   RowBox[{
    FractionBox["sptab", 
     SqrtBox[
      RowBox[{"1.2", "-", "sptab"}]]], "+", "0.25"}]}], ";", 
  RowBox[{"txx", "=", 
   RowBox[{"risco", "/.", 
    RowBox[{"a", "\[Rule]", "sptab"}]}]}], ";", 
  RowBox[{"stick", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"sxx", ",", "sptab"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lle", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"sxx", ",", "chisqF"}], "}"}], "]"}], ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"sxx", ",", "chisqFLC"}], "}"}], "]"}]}], "}"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Red"}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Blue"}], 
         "}"}]}], "}"}]}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameTicks", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"stick", ",", "None"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "14"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"All", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.2"}], ",", "7"}], "}"}]}], "}"}]}], ",", 
     RowBox[{
     "PlotLabel", "\[Rule]", 
      "\"\<(a) reduced \!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\) for various \
spins \!\(\*SubscriptBox[\(a\), \(*\)]\)\>\""}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lri", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"tim", ",", "chisq05FLC"}], "}"}], "]"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Blue"}], "}"}]}], 
     ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"All", ",", 
        RowBox[{"{", 
         RowBox[{"1.5", ",", "7"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "14"}]}], "}"}]}], ",", 
     RowBox[{
     "PlotLabel", "\[Rule]", 
      "\"\<(b) for \!\(\*SubscriptBox[\(a\), \(*\)]\)=0.5 for different \
averaging periods\>\""}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"lgr", "=", 
  RowBox[{"GraphicsRow", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"lle", ",", "lri"}], "}"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "700"}], ",", 
    RowBox[{"Epilog", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Black", ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<spin \!\(\*SubscriptBox[\(a\), \(*\)]\) \>\"", ",", "16", ",", 
           "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.4", ",", "0.037"}], "}"}], "]"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"\"\<time [M]\>\"", ",", "16", ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.94", ",", "0.034"}], "}"}], "]"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<\!\(\*SuperscriptBox[\(\[CapitalDelta]\[Chi]\), \(2\)]\)/dof~1\
\>\"", ",", "16", ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.8", ",", "0.6"}], "}"}], "]"}]}], "]"}]}], "}"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", "13"}]}], "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "\"\<C:\\\\study\\\\accretion\\\\! 2009 3fall cfa\\\\GR Polarized modeling\
\\\\!svn\\\\\>\"", "<>", "\"\<probabilities.eps\>\""}], ",", "lgr"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.479606352525*^9, 3.4796064460769997`*^9}, {
   3.479606557164*^9, 3.479606601584*^9}, {3.479607013258*^9, 
   3.479607058775*^9}, {3.479607102362*^9, 3.479607118264*^9}, {
   3.479608302086*^9, 3.479608336144*^9}, {3.485178199491*^9, 
   3.485178254006*^9}, 3.48517829467*^9, {3.485178770841*^9, 
   3.485178831933*^9}, {3.4851796558710003`*^9, 3.485179691068*^9}, 
   3.485179723841*^9, {3.48517989952*^9, 3.485179912455*^9}, {
   3.485180227934*^9, 3.4851802420769997`*^9}, {3.4851802812019997`*^9, 
   3.48518046506*^9}, {3.4851805772869997`*^9, 3.485180895659*^9}, {
   3.485180991566*^9, 3.485181028493*^9}, {3.485796649216*^9, 
   3.4857967277799997`*^9}, {3.485796982341*^9, 3.485797111209*^9}, {
   3.48579719787*^9, 3.4857972000769997`*^9}, {3.485864038157638*^9, 
   3.485864182817638*^9}, {3.4858643618866377`*^9, 3.485864401730638*^9}, {
   3.485864585284638*^9, 3.485864600550638*^9}, {3.4885988590388002`*^9, 
   3.4885988593328*^9}, {3.4891545044095325`*^9, 3.4891546057627325`*^9}, {
   3.4891546702375326`*^9, 3.4891546726399326`*^9}, {3.4891582057605324`*^9, 
   3.4891582655241327`*^9}, {3.4891583048673325`*^9, 
   3.4891583668773327`*^9}, {3.4891584292773323`*^9, 
   3.4891584419289327`*^9}, {3.4891585042197323`*^9, 
   3.4891586196753325`*^9}, {3.4891587167853327`*^9, 3.489158716941333*^9}, {
   3.4891587750669327`*^9, 3.4891588139889326`*^9}, {3.502645775098*^9, 
   3.502645776658*^9}, {3.502645935135*^9, 3.502645994257*^9}, {
   3.50264605712*^9, 3.5026460577060003`*^9}, {3.502648393171*^9, 
   3.502648393526*^9}, {3.502648444882*^9, 3.5026485053450003`*^9}, {
   3.502648539651*^9, 3.502648550826*^9}, {3.502648615476*^9, 
   3.502648726527*^9}, {3.502648760491*^9, 3.502648797726*^9}, {
   3.5026488685369997`*^9, 3.5026488948450003`*^9}, {3.502648930506*^9, 
   3.502648973781*^9}, {3.502649007402*^9, 3.5026491054700003`*^9}, {
   3.503063347134*^9, 3.503063361141*^9}, {3.503063405591*^9, 
   3.5030634119960003`*^9}, {3.503063457586*^9, 3.503063476962*^9}, {
   3.5032369348380003`*^9, 3.503236938013*^9}, {3.503414130764*^9, 
   3.503414134222*^9}, {3.503418602907*^9, 3.503418639204*^9}, {
   3.5042827316949997`*^9, 3.504282738288*^9}, {3.50428279369*^9, 
   3.504282901492*^9}, {3.504282952377*^9, 3.504282954791*^9}, {
   3.504287225382*^9, 3.504287230145*^9}, {3.50428726871*^9, 
   3.504287343172*^9}, {3.5043673430439997`*^9, 3.504367386057*^9}, {
   3.509210560817*^9, 3.50921056215*^9}, 3.509211077572*^9, {
   3.5092111481289997`*^9, 3.509211169954*^9}, 3.509211218076*^9, 
   3.509211255828*^9, {3.5092114475039997`*^9, 3.5092114617200003`*^9}, {
   3.509213201409*^9, 3.5092132036800003`*^9}, {3.50921331879*^9, 
   3.5092133212200003`*^9}, {3.509213355611*^9, 3.509213400076*^9}, {
   3.509213456057*^9, 3.509213484634*^9}, {3.509213552866*^9, 
   3.509213574797*^9}, {3.509292911119*^9, 3.509292922605*^9}, {
   3.509292964868*^9, 3.509293056192*^9}, 3.509405301823*^9, {
   3.509900971881*^9, 3.509900971984*^9}, {3.5101048128396*^9, 
   3.5101048128926*^9}, {3.5101483964976*^9, 3.5101484402446003`*^9}, 
   3.529150176084332*^9, {3.5291580647945404`*^9, 3.529158197681141*^9}, {
   3.5291583833667617`*^9, 3.5291584583020477`*^9}, {3.5291585457180476`*^9, 
   3.5291585928707447`*^9}, {3.5291589547764444`*^9, 
   3.5291591058310843`*^9}, {3.529159136912862*^9, 3.5291592725916224`*^9}, {
   3.5291593119278727`*^9, 3.5291593164291296`*^9}, {3.5291594542930155`*^9, 
   3.529159466252699*^9}, {3.529159578086096*^9, 3.529159597606212*^9}, {
   3.5291597073004866`*^9, 3.5291597726352234`*^9}, {3.529159931361302*^9, 
   3.5291599506334043`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["computation", "Subsubsection",
 CellChangeTimes->{{3.5006400974379997`*^9, 3.500640098933*^9}, {
  3.502649119929*^9, 3.502649121144*^9}}],

Cell[BoxData[
 RowBox[{"0.9", ",", " ", "boosted", ",", " ", 
  RowBox[{"4", "-", "7"}]}]], "Input",
 CellChangeTimes->{{3.5092130562860003`*^9, 3.509213060777*^9}}],

Cell[BoxData[
 RowBox[{"0.9", ",", " ", "boosted", ",", " ", 
  RowBox[{"0", "-", "2"}]}]], "Input",
 CellChangeTimes->{{3.509212842138*^9, 3.509212846053*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"PFnu", "=", 
     RowBox[{"{", 
      RowBox[{
      "0.029888473117124725`", ",", "0.11576225835126357`", ",", 
       "0.1021416716052561`", ",", "0.10669424545163775`", ",", 
       "0.1090809767278269`"}], "}"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"PCPLP", "=", 
     RowBox[{"{", 
      RowBox[{
      "0.000018322201118716728`", ",", "0.00031355696494507446`", ",", 
       "0.00046725928487918126`", ",", "0.0033799404833830186`", ",", 
       "0.0006268172324242625`"}], "}"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"PCPLP09", "=", 
     RowBox[{"{", 
      RowBox[{
      "0.0011681287867020846`", ",", "0.007784869490778616`", ",", 
       "0.001032741791482769`", ",", "0.0018460835586507891`", ",", 
       "0.0023471441775633093`", ",", "0.0017972240971333468`", ",", 
       "0.0017060286754168978`"}], "}"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"PFnu09", "=", 
     RowBox[{"{", 
      RowBox[{
      "0.1130826", ",", "0.11219527570585637`", ",", "0.10449747463717049`", 
       ",", "0.11134642628525881`", ",", "0.10427193400248641`", ",", 
       "0.10250334637071327`", ",", "0.10245272031065529`"}], "}"}]}], ";"}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"chisqFboo", "=", 
     RowBox[{"{", 
      RowBox[{
      "6.320386570544563", ",", "3.580219047092071", ",", 
       "0.17856100153716378", ",", "0.07150754084609268", ",", 
       "0.05478087930967269"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"chisqFnob", "=", 
     RowBox[{"{", 
      RowBox[{
      "8.311536468468779", ",", "3.67499754035438", ",", "0.3568154812906481",
        ",", "0.10177528802290657", ",", "0.10601804567810805"}], "}"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"chisqFLCboo", "=", 
     RowBox[{"{", 
      RowBox[{
      "9.032125131471492", ",", "5.771637280989387", ",", "5.368769584491988",
        ",", "4.049285520007386", ",", "4.848682575299941"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"chisqFLCnob", "=", 
     RowBox[{"{", 
      RowBox[{
      "6.545093244581491", ",", "3.67499754035438", ",", "6.787010056061094", 
       ",", "5.529408960518567`", ",", "13.473550988764874"}], "}"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"chisq09F", "=", 
     RowBox[{"{", 
      RowBox[{
      "0.060963726605707945", ",", "0.04197525908598914", ",", 
       "0.12232301335016174", ",", "0.07094357826100815", ",", 
       "0.7506279264932736", ",", "1.062497572531079", ",", 
       "0.3126819882460815"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"chisq09FLC", "=", 
     RowBox[{"{", 
      RowBox[{
      "4.623880759440321", ",", "2.906247371048607", ",", "5.486386247336712",
        ",", "4.511348689100931", ",", "5.988666292107806", ",", 
       "4.250554961170413", ",", "5.166923812921367"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"tmin", ",", "tmax"}], "}"}], "=", 
      RowBox[{"{", 
       RowBox[{"6950", ",", "7380"}], "}"}]}], "]"}], ";", 
    RowBox[{"jum", "=", "430"}], ";", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"tmin", "+", 
         RowBox[{"jum", " ", "i"}]}], ",", 
        RowBox[{"tmax", "+", 
         RowBox[{"jum", " ", "i"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "0", ",", "6"}], "}"}]}], "]"}], ";", 
    RowBox[{"tim", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"tmin", "+", "tmax", "+", 
        RowBox[{"2", "jum", " ", "i"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "6"}], "}"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sptab", "=", 
     RowBox[{"{", 
      RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], 
      "}"}]}], ";", 
    RowBox[{"sptab", "=", 
     RowBox[{"{", 
      RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], 
      "}"}]}], ";", 
    RowBox[{"sxx", "=", 
     RowBox[{
      FractionBox["sptab", 
       SqrtBox[
        RowBox[{"1.2", "-", "sptab"}]]], "+", "0.25"}]}], ";", 
    RowBox[{"txx", "=", 
     RowBox[{"risco", "/.", 
      RowBox[{"a", "\[Rule]", "sptab"}]}]}], ";", 
    RowBox[{"stick", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"sxx", ",", "sptab"}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lle", "=", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"sxx", ",", "chisqFboo"}], "}"}], "]"}], ",", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"sxx", ",", "chisqFnob"}], "}"}], "]"}], ",", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"sxx", ",", "chisqFLCboo"}], "}"}], "]"}], ",", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"sxx", ",", "chisqFLCnob"}], "}"}], "]"}]}], "}"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Red"}], "}"}],
           ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", 
             RowBox[{"{", 
              RowBox[{"10", ",", "7"}], "}"}], "]"}], ",", "Red"}], "}"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "0", "]"}], ",", "Blue"}], "}"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", 
             RowBox[{"{", 
              RowBox[{"10", ",", "7"}], "}"}], "]"}], ",", "Blue"}], "}"}]}], 
         "}"}]}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameTicks", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"stick", ",", "None"}], "}"}]}], "}"}]}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "14"}]}], "}"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"All", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.2"}], ",", "9"}], "}"}]}], "}"}]}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<(a) reduced \!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\) for \
various spins \!\(\*SubscriptBox[\(a\), \(*\)]\)\>\""}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lri", "=", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"tim", ",", "chisq09F"}], "}"}], "]"}], ",", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"tim", ",", "chisq09FLC"}], "}"}], "]"}]}], "}"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", "0", "]"}], ",", "Red"}], "}"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Blue"}], 
           "}"}]}], "}"}]}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"All", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.2"}], ",", "9"}], "}"}]}], "}"}]}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "14"}]}], "}"}]}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<(b) for \!\(\*SubscriptBox[\(a\), \(*\)]\)=0.9 for different \
averaging periods\>\""}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"lgr", "=", 
    RowBox[{"GraphicsRow", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"lle", ",", "lri"}], "}"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "700"}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Black", ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<(a) \>\"", ",", "16", ",", "Bold"}], "]"}], ",", 
             RowBox[{"ImageScaled", "[", 
              RowBox[{"{", 
               RowBox[{"0.03", ",", "0.05"}], "}"}], "]"}]}], "]"}], ",", 
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<(b)\>\"", ",", "16", ",", "Bold"}], "]"}], ",", 
             RowBox[{"ImageScaled", "[", 
              RowBox[{"{", 
               RowBox[{"0.535", ",", "0.03"}], "}"}], "]"}]}], "]"}], ","}], 
          "*)"}], 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<spin \!\(\*SubscriptBox[\(a\), \(*\)]\) \>\"", ",", "16", 
             ",", "Bold"}], "]"}], ",", 
           RowBox[{"ImageScaled", "[", 
            RowBox[{"{", 
             RowBox[{"0.4", ",", "0.037"}], "}"}], "]"}]}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"\"\<time [M]\>\"", ",", "16", ",", "Bold"}], "]"}], ",", 
           RowBox[{"ImageScaled", "[", 
            RowBox[{"{", 
             RowBox[{"0.94", ",", "0.034"}], "}"}], "]"}]}], "]"}], ",", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<\!\(\*SuperscriptBox[\(\[CapitalDelta]\[Chi]\), \
\(2\)]\)/dof~1\>\"", ",", "16", ",", "Bold"}], "]"}], ",", 
           RowBox[{"ImageScaled", "[", 
            RowBox[{"{", 
             RowBox[{"0.7", ",", "0.7"}], "}"}], "]"}]}], "]"}]}], "}"}]}], 
      ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "13"}]}], "}"}]}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{
     "\"\<C:\\\\study\\\\accretion\\\\! 2009 fall cfa\\\\GR Polarized \
modeling\\\\\>\"", "<>", "\"\<probabilities.eps\>\""}], ",", "lgr"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.479606352525*^9, 3.4796064460769997`*^9}, {
   3.479606557164*^9, 3.479606601584*^9}, {3.479607013258*^9, 
   3.479607058775*^9}, {3.479607102362*^9, 3.479607118264*^9}, {
   3.479608302086*^9, 3.479608336144*^9}, {3.485178199491*^9, 
   3.485178254006*^9}, 3.48517829467*^9, {3.485178770841*^9, 
   3.485178831933*^9}, {3.4851796558710003`*^9, 3.485179691068*^9}, 
   3.485179723841*^9, {3.48517989952*^9, 3.485179912455*^9}, {
   3.485180227934*^9, 3.4851802420769997`*^9}, {3.4851802812019997`*^9, 
   3.48518046506*^9}, {3.4851805772869997`*^9, 3.485180895659*^9}, {
   3.485180991566*^9, 3.485181028493*^9}, {3.485796649216*^9, 
   3.4857967277799997`*^9}, {3.485796982341*^9, 3.485797111209*^9}, {
   3.48579719787*^9, 3.4857972000769997`*^9}, {3.485864038157638*^9, 
   3.485864182817638*^9}, {3.4858643618866377`*^9, 3.485864401730638*^9}, {
   3.485864585284638*^9, 3.485864600550638*^9}, {3.4885988590388002`*^9, 
   3.4885988593328*^9}, {3.4891545044095325`*^9, 3.4891546057627325`*^9}, {
   3.4891546702375326`*^9, 3.4891546726399326`*^9}, {3.4891582057605324`*^9, 
   3.4891582655241327`*^9}, {3.4891583048673325`*^9, 
   3.4891583668773327`*^9}, {3.4891584292773323`*^9, 
   3.4891584419289327`*^9}, {3.4891585042197323`*^9, 
   3.4891586196753325`*^9}, {3.4891587167853327`*^9, 3.489158716941333*^9}, {
   3.4891587750669327`*^9, 3.4891588139889326`*^9}, {3.502645775098*^9, 
   3.502645776658*^9}, {3.502645935135*^9, 3.502645994257*^9}, {
   3.50264605712*^9, 3.5026460577060003`*^9}, {3.502648393171*^9, 
   3.502648393526*^9}, {3.502648444882*^9, 3.5026485053450003`*^9}, {
   3.502648539651*^9, 3.502648550826*^9}, {3.502648615476*^9, 
   3.502648726527*^9}, {3.502648760491*^9, 3.502648797726*^9}, {
   3.5026488685369997`*^9, 3.5026488948450003`*^9}, {3.502648930506*^9, 
   3.502648973781*^9}, {3.502649007402*^9, 3.5026491054700003`*^9}, {
   3.503063347134*^9, 3.503063361141*^9}, {3.503063405591*^9, 
   3.5030634119960003`*^9}, {3.503063457586*^9, 3.503063476962*^9}, {
   3.5032369348380003`*^9, 3.503236938013*^9}, {3.503414130764*^9, 
   3.503414134222*^9}, {3.503418602907*^9, 3.503418639204*^9}, {
   3.5042827316949997`*^9, 3.504282738288*^9}, {3.50428279369*^9, 
   3.504282901492*^9}, {3.504282952377*^9, 3.504282954791*^9}, {
   3.504287225382*^9, 3.504287230145*^9}, {3.50428726871*^9, 
   3.504287343172*^9}, {3.5043673430439997`*^9, 3.504367386057*^9}, {
   3.509210560817*^9, 3.50921056215*^9}, 3.509211077572*^9, {
   3.5092111481289997`*^9, 3.509211169954*^9}, 3.509211218076*^9, 
   3.509211255828*^9, {3.5092114475039997`*^9, 3.5092114617200003`*^9}, {
   3.509213201409*^9, 3.5092132036800003`*^9}, {3.50921331879*^9, 
   3.5092133212200003`*^9}, {3.509213355611*^9, 3.509213400076*^9}, {
   3.509213456057*^9, 3.509213484634*^9}, {3.509213552866*^9, 
   3.509213574797*^9}, {3.509292911119*^9, 3.509292922605*^9}, {
   3.509292964868*^9, 3.509293056192*^9}, 3.509405301823*^9, {
   3.509900971881*^9, 3.509900971984*^9}, {3.5101048128396*^9, 
   3.5101048128926*^9}, {3.5101483964976*^9, 3.5101484402446003`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["for thesis defense", "Subsubsection",
 CellChangeTimes->{{3.5127540512194*^9, 3.5127540547144003`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"PFnu", "=", 
     RowBox[{"{", 
      RowBox[{
      "0.029888473117124725`", ",", "0.11576225835126357`", ",", 
       "0.1021416716052561`", ",", "0.10669424545163775`", ",", 
       "0.1090809767278269`"}], "}"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"PCPLP", "=", 
     RowBox[{"{", 
      RowBox[{
      "0.000018322201118716728`", ",", "0.00031355696494507446`", ",", 
       "0.00046725928487918126`", ",", "0.0033799404833830186`", ",", 
       "0.0006268172324242625`"}], "}"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"PCPLP09", "=", 
     RowBox[{"{", 
      RowBox[{
      "0.0011681287867020846`", ",", "0.007784869490778616`", ",", 
       "0.001032741791482769`", ",", "0.0018460835586507891`", ",", 
       "0.0023471441775633093`", ",", "0.0017972240971333468`", ",", 
       "0.0017060286754168978`"}], "}"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"PFnu09", "=", 
     RowBox[{"{", 
      RowBox[{
      "0.1130826", ",", "0.11219527570585637`", ",", "0.10449747463717049`", 
       ",", "0.11134642628525881`", ",", "0.10427193400248641`", ",", 
       "0.10250334637071327`", ",", "0.10245272031065529`"}], "}"}]}], ";"}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"chisqFboo", "=", 
     RowBox[{"{", 
      RowBox[{
      "6.320386570544563", ",", "3.580219047092071", ",", 
       "0.17856100153716378", ",", "0.07150754084609268", ",", 
       "0.05478087930967269"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"chisqFnob", "=", 
     RowBox[{"{", 
      RowBox[{
      "8.311536468468779", ",", "3.67499754035438", ",", "0.3568154812906481",
        ",", "0.10177528802290657", ",", "0.10601804567810805"}], "}"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"chisqFLCboo", "=", 
     RowBox[{"{", 
      RowBox[{
      "9.032125131471492", ",", "5.771637280989387", ",", "5.368769584491988",
        ",", "4.049285520007386", ",", "4.848682575299941"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"chisqFLCnob", "=", 
     RowBox[{"{", 
      RowBox[{
      "6.545093244581491", ",", "3.67499754035438", ",", "6.787010056061094", 
       ",", "5.529408960518567`", ",", "13.473550988764874"}], "}"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"chisq09F", "=", 
     RowBox[{"{", 
      RowBox[{
      "0.060963726605707945", ",", "0.04197525908598914", ",", 
       "0.12232301335016174", ",", "0.07094357826100815", ",", 
       "0.7506279264932736", ",", "1.062497572531079", ",", 
       "0.3126819882460815"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"chisq09FLC", "=", 
     RowBox[{"{", 
      RowBox[{
      "4.623880759440321", ",", "2.906247371048607", ",", "5.486386247336712",
        ",", "4.511348689100931", ",", "5.988666292107806", ",", 
       "4.250554961170413", ",", "5.166923812921367"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"tmin", ",", "tmax"}], "}"}], "=", 
      RowBox[{"{", 
       RowBox[{"6950", ",", "7380"}], "}"}]}], "]"}], ";", 
    RowBox[{"jum", "=", "430"}], ";", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"tmin", "+", 
         RowBox[{"jum", " ", "i"}]}], ",", 
        RowBox[{"tmax", "+", 
         RowBox[{"jum", " ", "i"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "0", ",", "6"}], "}"}]}], "]"}], ";", 
    RowBox[{"tim", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"tmin", "+", "tmax", "+", 
        RowBox[{"2", "jum", " ", "i"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "6"}], "}"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sptab", "=", 
     RowBox[{"{", 
      RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], 
      "}"}]}], ";", 
    RowBox[{"sptab", "=", 
     RowBox[{"{", 
      RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], 
      "}"}]}], ";", 
    RowBox[{"sxx", "=", 
     RowBox[{
      FractionBox["sptab", 
       SqrtBox[
        RowBox[{"1.2", "-", "sptab"}]]], "+", "0.25"}]}], ";", 
    RowBox[{"txx", "=", 
     RowBox[{"risco", "/.", 
      RowBox[{"a", "\[Rule]", "sptab"}]}]}], ";", 
    RowBox[{"stick", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"sxx", ",", "sptab"}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"lle", "=", 
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"sxx", ",", "chisqFboo"}], "}"}], "]"}], 
        RowBox[{"(*", 
         RowBox[{",", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"sxx", ",", "chisqFnob"}], "}"}], "]"}]}], "*)"}], ",", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"sxx", ",", "chisqFLCboo"}], "}"}], "]"}]}], 
       RowBox[{"(*", 
        RowBox[{",", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"sxx", ",", "chisqFLCnob"}], "}"}], "]"}]}], "*)"}], "}"}],
       ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Red"}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
           RowBox[{"AbsoluteDashing", "[", "0", "]"}], ",", "Blue"}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
           RowBox[{"AbsoluteDashing", "[", 
            RowBox[{"{", 
             RowBox[{"10", ",", "7"}], "}"}], "]"}], ",", "Blue"}], "}"}]}], 
        "}"}]}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameTicks", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"stick", ",", "None"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "14"}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"All", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.2"}], ",", "9"}], "}"}]}], "}"}]}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lgr", "=", 
     RowBox[{"GraphicsRow", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"lle", ",", "lri"}], "}"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "700"}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Black", ",", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"Text", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<(a) \>\"", ",", "16", ",", "Bold"}], "]"}], ",", 
              RowBox[{"ImageScaled", "[", 
               RowBox[{"{", 
                RowBox[{"0.03", ",", "0.05"}], "}"}], "]"}]}], "]"}], ",", 
            RowBox[{"Text", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"\"\<(b)\>\"", ",", "16", ",", "Bold"}], "]"}], ",", 
              RowBox[{"ImageScaled", "[", 
               RowBox[{"{", 
                RowBox[{"0.535", ",", "0.03"}], "}"}], "]"}]}], "]"}], ","}], 
           "*)"}], 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
             "\"\<spin \!\(\*SubscriptBox[\(a\), \(*\)]\) \>\"", ",", "16", 
              ",", "Bold"}], "]"}], ",", 
            RowBox[{"ImageScaled", "[", 
             RowBox[{"{", 
              RowBox[{"0.4", ",", "0.037"}], "}"}], "]"}]}], "]"}], ",", 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"\"\<time [M]\>\"", ",", "16", ",", "Bold"}], "]"}], ",", 
            RowBox[{"ImageScaled", "[", 
             RowBox[{"{", 
              RowBox[{"0.94", ",", "0.034"}], "}"}], "]"}]}], "]"}], ",", 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
             "\"\<\!\(\*SuperscriptBox[\(\[CapitalDelta]\[Chi]\), \
\(2\)]\)/dof~1\>\"", ",", "16", ",", "Bold"}], "]"}], ",", 
            RowBox[{"ImageScaled", "[", 
             RowBox[{"{", 
              RowBox[{"0.7", ",", "0.7"}], "}"}], "]"}]}], "]"}]}], "}"}]}], 
       ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "13"}]}], "}"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{
     "\"\<C:\\\\study\\\\accretion\\\\thesis\\\\! defense\\\\\>\"", "<>", 
      "\"\<probabilities.eps\>\""}], ",", "lle", ",", 
     RowBox[{"\"\<CompressionLevel\>\"", "\[Rule]", "0"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.479606352525*^9, 3.4796064460769997`*^9}, {
   3.479606557164*^9, 3.479606601584*^9}, {3.479607013258*^9, 
   3.479607058775*^9}, {3.479607102362*^9, 3.479607118264*^9}, {
   3.479608302086*^9, 3.479608336144*^9}, {3.485178199491*^9, 
   3.485178254006*^9}, 3.48517829467*^9, {3.485178770841*^9, 
   3.485178831933*^9}, {3.4851796558710003`*^9, 3.485179691068*^9}, 
   3.485179723841*^9, {3.48517989952*^9, 3.485179912455*^9}, {
   3.485180227934*^9, 3.4851802420769997`*^9}, {3.4851802812019997`*^9, 
   3.48518046506*^9}, {3.4851805772869997`*^9, 3.485180895659*^9}, {
   3.485180991566*^9, 3.485181028493*^9}, {3.485796649216*^9, 
   3.4857967277799997`*^9}, {3.485796982341*^9, 3.485797111209*^9}, {
   3.48579719787*^9, 3.4857972000769997`*^9}, {3.485864038157638*^9, 
   3.485864182817638*^9}, {3.4858643618866377`*^9, 3.485864401730638*^9}, {
   3.485864585284638*^9, 3.485864600550638*^9}, {3.4885988590388002`*^9, 
   3.4885988593328*^9}, {3.4891545044095325`*^9, 3.4891546057627325`*^9}, {
   3.4891546702375326`*^9, 3.4891546726399326`*^9}, {3.4891582057605324`*^9, 
   3.4891582655241327`*^9}, {3.4891583048673325`*^9, 
   3.4891583668773327`*^9}, {3.4891584292773323`*^9, 
   3.4891584419289327`*^9}, {3.4891585042197323`*^9, 
   3.4891586196753325`*^9}, {3.4891587167853327`*^9, 3.489158716941333*^9}, {
   3.4891587750669327`*^9, 3.4891588139889326`*^9}, {3.502645775098*^9, 
   3.502645776658*^9}, {3.502645935135*^9, 3.502645994257*^9}, {
   3.50264605712*^9, 3.5026460577060003`*^9}, {3.502648393171*^9, 
   3.502648393526*^9}, {3.502648444882*^9, 3.5026485053450003`*^9}, {
   3.502648539651*^9, 3.502648550826*^9}, {3.502648615476*^9, 
   3.502648726527*^9}, {3.502648760491*^9, 3.502648797726*^9}, {
   3.5026488685369997`*^9, 3.5026488948450003`*^9}, {3.502648930506*^9, 
   3.502648973781*^9}, {3.502649007402*^9, 3.5026491054700003`*^9}, {
   3.503063347134*^9, 3.503063361141*^9}, {3.503063405591*^9, 
   3.5030634119960003`*^9}, {3.503063457586*^9, 3.503063476962*^9}, {
   3.5032369348380003`*^9, 3.503236938013*^9}, {3.503414130764*^9, 
   3.503414134222*^9}, {3.503418602907*^9, 3.503418639204*^9}, {
   3.5042827316949997`*^9, 3.504282738288*^9}, {3.50428279369*^9, 
   3.504282901492*^9}, {3.504282952377*^9, 3.504282954791*^9}, {
   3.504287225382*^9, 3.504287230145*^9}, {3.50428726871*^9, 
   3.504287343172*^9}, {3.5043673430439997`*^9, 3.504367386057*^9}, {
   3.509210560817*^9, 3.50921056215*^9}, 3.509211077572*^9, {
   3.5092111481289997`*^9, 3.509211169954*^9}, 3.509211218076*^9, 
   3.509211255828*^9, {3.5092114475039997`*^9, 3.5092114617200003`*^9}, {
   3.509213201409*^9, 3.5092132036800003`*^9}, {3.50921331879*^9, 
   3.5092133212200003`*^9}, {3.509213355611*^9, 3.509213400076*^9}, {
   3.509213456057*^9, 3.509213484634*^9}, {3.509213552866*^9, 
   3.509213574797*^9}, {3.509292911119*^9, 3.509292922605*^9}, {
   3.509292964868*^9, 3.509293056192*^9}, 3.509405301823*^9, {
   3.509900971881*^9, 3.509900971984*^9}, {3.5101048128396*^9, 
   3.5101048128926*^9}, {3.5101483964976*^9, 3.5101484402446003`*^9}, {
   3.5127540891823997`*^9, 3.5127541321724*^9}, {3.5127541855924*^9, 
   3.5127543035984*^9}}],

Cell[BoxData["lle"], "Input",
 CellChangeTimes->{{3.5127541657564*^9, 3.5127541706364*^9}}],

Cell[BoxData[{"tim", "\[IndentingNewLine]", 
 RowBox[{"2", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"tmin", "+", 
       RowBox[{"jum", " ", "i"}]}], ",", 
      RowBox[{"tmax", "+", 
       RowBox[{"jum", " ", "i"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", "6"}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.504372743403*^9, 3.504372795451*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["the rest", "Subsubsection",
 CellChangeTimes->{{3.5026491319119997`*^9, 3.502649132696*^9}}],

Cell[BoxData[{
 RowBox[{"lx", "=", 
  RowBox[{"ListLogPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"sxx", ",", "PFnu"}], "}"}], "]"}], ",", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"sxx", ",", "PCPLP"}], "}"}], "]"}]}], "}"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Red"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Blue"}], "}"}]}],
       "}"}]}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"stick", ",", "None"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", "14"}]}], "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"All", ",", 
       RowBox[{"{", 
        RowBox[{
         SuperscriptBox["10", 
          RowBox[{"-", "3.5"}]], ",", "0.15"}], "}"}]}], "}"}]}], ",", 
    RowBox[{
    "PlotLabel", "\[Rule]", "\"\<Total probability to have such spin\>\""}], 
    ",", 
    RowBox[{"ImageSize", "\[Rule]", "350"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", "\"\<spin a\>\"", "}"}]}], ",", 
    RowBox[{"Epilog", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Black", ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<fitting \!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\),LP,CP \>\"", 
           ",", "16", ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.7", ",", "0.45"}], "}"}], "]"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<fitting only \!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\)\>\"", ",", 
           "16", ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.7", ",", "0.82"}], "}"}], "]"}]}], "]"}]}], "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\Users\\\\roman\\\\Desktop\\\\pdocs\\\\probabilities.eps\>\"", 
   ",", "lx"}], "]"}]}], "Input",
 CellChangeTimes->{{3.497639065415015*^9, 3.497639065620015*^9}, {
  3.4976390976280155`*^9, 3.4976394894440155`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "3"}], ";", 
  RowBox[{"co", "=", "0"}], ";", 
  RowBox[{"splen", "=", "5"}], ";", 
  RowBox[{"ext", "=", "1."}], ";", 
  RowBox[{"acc", "=", "7"}], ";", 
  RowBox[{"inord", "=", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], ";", 
  RowBox[{"mmm", "=", "\"\<LocalAdaptive\>\""}], ";", 
  RowBox[{"fl", "=", 
   RowBox[{"1.", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "20"}]]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"z1", "=", 
   RowBox[{"1", "+", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        SuperscriptBox["a", "2"]}], ")"}], 
      RowBox[{"1", "/", "3"}]], 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "+", "a"}], ")"}], 
        RowBox[{"1", "/", "3"}]], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "-", "a"}], ")"}], 
        RowBox[{"1", "/", "3"}]]}], ")"}]}]}]}], ";", 
  RowBox[{"z2", "=", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", 
       SuperscriptBox["a", "2"]}], "+", 
      SuperscriptBox["z1", "2"]}], ")"}], 
    RowBox[{"1", "/", "2"}]]}], ";", 
  RowBox[{"risco", "=", 
   RowBox[{"3", "+", "z2", "-", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"3", "-", "z1"}], ")"}], 
       RowBox[{"(", 
        RowBox[{"3", "+", "z1", "+", 
         RowBox[{"2", "z2"}]}], ")"}]}], ")"}], 
     RowBox[{"1", "/", "2"}]]}]}], ";", 
  RowBox[{"rimax", "=", 
   RowBox[{
    RowBox[{"Log", "[", 
     RowBox[{"1.", "risco"}], "]"}], "/.", 
    RowBox[{"a", "\[Rule]", "0"}]}]}], ";", 
  RowBox[{"rimin", "=", 
   RowBox[{
    RowBox[{"Log", "[", "risco", "]"}], "/.", 
    RowBox[{"a", "\[Rule]", "0.98"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"thlen", "=", "30"}], ";", 
    RowBox[{"ttick", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"txx", ",", "sptab"}], "}"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ListLogPlot", "[", 
      RowBox[{"sxx", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameTicks", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"stick", ",", "None"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "None"}], "}"}]}], "}"}]}]}], "]"}], 
     "\[IndentingNewLine]", 
     RowBox[{"ListLogPlot", "[", 
      RowBox[{"txx", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameTicks", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"ttick", ",", "None"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "None"}], "}"}]}], "}"}]}]}], "]"}]}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.479606477366*^9, 3.479606482678*^9}, {3.479606520461*^9,
    3.479606554885*^9}, {3.4796066319849997`*^9, 3.4796068344630003`*^9}, {
   3.4796068968050003`*^9, 3.479606904176*^9}, {3.4796069456549997`*^9, 
   3.4796069791400003`*^9}, {3.4851784592320004`*^9, 3.485178531703*^9}, {
   3.485178575685*^9, 3.485178632906*^9}, {3.4891545357655325`*^9, 
   3.489154563876733*^9}, 3.502648576802*^9, {3.517239309442151*^9, 
   3.517239313339151*^9}}],

Cell[BoxData[
 RowBox[{"risco", "/.", 
  RowBox[{"a", "\[Rule]", "0.6"}]}]], "Input",
 CellChangeTimes->{{3.517239318173151*^9, 3.5172393250251513`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dist", "=", 
   RowBox[{
    FractionBox["1", 
     RowBox[{
      SqrtBox[
       RowBox[{"2", "\[Pi]"}]], "\[Sigma]"}]], 
    RowBox[{"Exp", "[", 
     RowBox[{"-", 
      FractionBox[
       SuperscriptBox["x", "2"], 
       RowBox[{"2", 
        SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Integrate", "[", 
  RowBox[{"dist", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "\[Infinity]"}], ",", 
     RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
   RowBox[{"Assumptions", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\[Sigma]", ">", "0"}], "}"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   SqrtBox[
    RowBox[{"Integrate", "[", 
     RowBox[{
      RowBox[{
       SuperscriptBox["x", "2"], "dist"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"-", "\[Infinity]"}], ",", 
        RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
      RowBox[{"Assumptions", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\[Sigma]", ">", "0"}], "}"}]}]}], "]"}]], ",", 
   RowBox[{"\[Sigma]", ">", "0"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"td", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"dist", "/.", 
      RowBox[{"\[Sigma]", "\[Rule]", "1."}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "10"}], ",", "10", ",", "0.01"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", "Distribution"}], "Input",
 CellChangeTimes->{{3.486120416348*^9, 3.486120538677*^9}, {3.486120596896*^9,
   3.486120657843*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Correlated flux (*warning: requires a lot of free memory*) (new Figure 10)\
\>", "Subsection",
 CellChangeTimes->{{3.486475801967*^9, 3.486475805366*^9}, {
   3.4864801041062*^9, 3.4864801129358*^9}, {3.4891551402449327`*^9, 
   3.4891551425225325`*^9}, {3.502627703656*^9, 3.502627704448*^9}, 
   3.509206152498*^9, {3.509298566408*^9, 3.509298567167*^9}, {
   3.5093820265361032`*^9, 3.509382028568104*^9}, {3.52855043766537*^9, 
   3.5285504378153725`*^9}, {3.529164742597489*^9, 3.529164742909507*^9}, {
   3.529321517608329*^9, 3.5293215184953794`*^9}, {3.529321840333788*^9, 
   3.52932184038179*^9}, {3.539993809013586*^9, 3.539993809630622*^9}, {
   3.54030058839335*^9, 3.5403005896964245`*^9}}],

Cell[CellGroupData[{

Cell["From Jon\[CloseCurlyQuote]s simulations", "Subsubsection",
 CellChangeTimes->{{3.568516431510478*^9, 3.5685164345524836`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fmin", "=", "6000"}], ";", 
  RowBox[{"fmax", "=", "6001"}], ";", 
  RowBox[{"ind", "=", "2"}], ";", 
  RowBox[{"sep", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"ind", "-", "1"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"plo", "[", 
     RowBox[{
      RowBox[{"sp_", "?", "IntegerQ"}], ",", 
      RowBox[{"style_", "?", "ListQ"}]}], "]"}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SetSharedVariable", "[", "sp", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"furtab", "=", 
       RowBox[{"ParallelTable", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ruru", "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"rg", "\[Rule]", 
              FractionBox[
               RowBox[{"2", " ", "6.67", " ", 
                SuperscriptBox["10", 
                 RowBox[{"-", "8"}]], "4.5", " ", 
                SuperscriptBox["10", "6"], "2", " ", 
                SuperscriptBox["10", "33"]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"3", " ", 
                  SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
             RowBox[{"arcsec", "\[Rule]", 
              FractionBox[
               RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
                SuperscriptBox["10", "3"], "3.08", " ", 
                SuperscriptBox["10", "18"]}], 
               RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
             RowBox[{"pc", "\[Rule]", 
              RowBox[{"3.08", " ", 
               SuperscriptBox["10", "18"]}]}], ",", 
             RowBox[{"year", "\[Rule]", 
              RowBox[{"365.35", " ", "86400"}]}], ",", 
             RowBox[{"cc", "\[Rule]", 
              RowBox[{"3.", " ", 
               SuperscriptBox["10", "10"]}]}], ",", 
             RowBox[{"Msun", "\[Rule]", 
              RowBox[{"2.", " ", 
               SuperscriptBox["10", "33"]}]}], ",", 
             RowBox[{"mp", "\[Rule]", 
              RowBox[{"1.67", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "24"}]]}]}], ",", 
             RowBox[{"me", "\[Rule]", 
              RowBox[{"9.1", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "28"}]]}]}], ",", 
             RowBox[{"kb", "\[Rule]", 
              RowBox[{"1.38", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "16"}]]}]}], ",", 
             RowBox[{"h", "\[Rule]", 
              RowBox[{"6.626", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "27"}]]}]}], ",", 
             RowBox[{"ee", "\[Rule]", 
              RowBox[{"4.8", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "10"}]]}]}], ",", 
             RowBox[{"keV", "->", 
              RowBox[{"1000", " ", "1.602", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
          "dir", "=", 
           "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\images\\\\th238\\\\f230\\\\\>\""}\
], ";", "\[IndentingNewLine]", 
          RowBox[{"fname", "=", 
           RowBox[{"Switch", "[", 
            RowBox[{
            "sp", ",", "0", ",", "\"\<shotimag93.75th238f230fn\>\"", ",", "1",
              ",", "\"\<shotimag0th73fn\>\""}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"namefile", "=", 
           RowBox[{"dir", "<>", "fname", "<>", 
            RowBox[{"ToString", "[", "fnum", "]"}], "<>", 
            "\"\<_201.dat\>\""}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"fi11", "=", 
           RowBox[{"OpenRead", "[", 
            RowBox[{"namefile", ",", 
             RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
          RowBox[{"params", "=", 
           RowBox[{"BinaryReadList", "[", 
            RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"a", "=", 
           RowBox[{"params", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], ";", 
          RowBox[{"th", "=", 
           RowBox[{
            RowBox[{"Round", "[", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"\[Pi]", "-", 
                RowBox[{"params", "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "1000"}], 
             "]"}], "/", "1000."}]}], ";", 
          RowBox[{"nxy", "=", 
           RowBox[{"Round", "[", 
            RowBox[{"params", "[", 
             RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
          RowBox[{"nu", "=", 
           RowBox[{"Round", "[", 
            RowBox[{"params", "[", 
             RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
          RowBox[{"maxy", "=", 
           RowBox[{"params", "[", 
            RowBox[{"[", "5", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"heat", "=", 
           RowBox[{"params", "[", 
            RowBox[{"[", "6", "]"}], "]"}]}], ";", 
          RowBox[{"rnohor", "=", 
           RowBox[{"params", "[", 
            RowBox[{"[", "7", "]"}], "]"}]}], ";", 
          RowBox[{"inten", "=", 
           RowBox[{"BinaryReadList", "[", 
            RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
          RowBox[{"partres", "=", 
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{"inten", ",", "5"}], "]"}], ",", 
             RowBox[{"nxy", "+", "1"}]}], "]"}]}], ";", 
          RowBox[{"Close", "[", "fi11", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"partres", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}], "=", "0."}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"dat", "=", 
           RowBox[{"Reverse", "[", 
            RowBox[{
             RowBox[{"partres", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], ",", 
             "2"}], "]"}]}], ";", 
          RowBox[{"nn", "=", 
           RowBox[{"nxy", "+", "1"}]}], ";", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"dat", "=", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Exp", "[", 
                 RowBox[{
                  RowBox[{"-", "5"}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    FractionBox[
                    RowBox[{"2", "x"}], "nn"], "-", "1"}], ")"}], "2"]}], 
                 "]"}], 
                RowBox[{"Exp", "[", 
                 RowBox[{
                  RowBox[{"-", "7"}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    FractionBox[
                    RowBox[{"2", "y"}], "nn"], "-", "1"}], ")"}], "2"]}], 
                 "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"y", ",", "nn"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"x", ",", "nn"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"pixel", "=", 
           RowBox[{
            RowBox[{
             FractionBox[
              RowBox[{"2", "maxy"}], "nxy"], 
             SuperscriptBox["10", "6"], 
             FractionBox["rg", 
              RowBox[{"2", "arcsec"}]]}], "/.", "ruru"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"side", "=", 
           RowBox[{"pixel", " ", 
            FractionBox["nxy", "2"]}]}], 
          RowBox[{"(*", 
           RowBox[{"\[Mu]as", " ", "-", " ", 
            RowBox[{"from", " ", "center", " ", "to", " ", "edge"}]}], "*)"}],
           ";", 
          RowBox[{"a", "=", 
           RowBox[{"side", 
            FractionBox[
             RowBox[{"2.", "\[Pi]"}], 
             RowBox[{"360", " ", "60", " ", "60"}]], " ", 
            SuperscriptBox["10", 
             RowBox[{"-", "6"}]]}]}], ";", 
          RowBox[{"(*", 
           RowBox[{"a", " ", "of", " ", "mabase", " ", "G\[Lambda]"}], "*)"}],
           "\[IndentingNewLine]", 
          RowBox[{"mabase", "=", "7"}], ";", 
          RowBox[{"bb", "=", 
           RowBox[{"mabase", " ", 
            SuperscriptBox["10", "9."]}]}], ";", 
          RowBox[{"step", "=", 
           RowBox[{"2", 
            FractionBox["bb", "nxy"]}]}], ";", 
          RowBox[{"ran", "=", 
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"-", "bb"}], ",", "bb", ",", "step"}], "]"}]}], ";", 
          RowBox[{"Dimensions", "[", "dat", "]"}], ";", 
          RowBox[{"Dimensions", "[", "ran", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"DFT2D", "[", 
            RowBox[{"m_", ",", "n_"}], "]"}], ":=", 
           RowBox[{"Sum", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"dat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"k", "+", 
                  FractionBox["nn", "2"]}], ",", 
                 RowBox[{"l", "+", 
                  FractionBox["nn", "2"]}]}], "]"}], "]"}], " ", 
              RowBox[{"Exp", "[", 
               RowBox[{
                RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]", " ", "m", 
                " ", 
                FractionBox[
                 RowBox[{"2", "a", " ", "k"}], "nn"]}], "]"}], 
              RowBox[{"Exp", "[", 
               RowBox[{
                RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]", " ", "n", 
                FractionBox[
                 RowBox[{"2", "a", " ", "l"}], "nn"]}], "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"k", ",", 
               RowBox[{
                FractionBox[
                 RowBox[{"-", "nn"}], "2"], "+", "1"}], ",", 
               FractionBox["nn", "2"]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{
                FractionBox[
                 RowBox[{"-", "nn"}], "2"], "+", "1"}], ",", 
               FractionBox["nn", "2"]}], "}"}]}], "]"}]}], ";", 
          RowBox[{"Print", "[", "fnum", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"res2D", "=", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"DFT2D", "[", 
              RowBox[{"ran", ",", "n"}], "]"}], "/.", 
             RowBox[{"n", "\[Rule]", "ran"}]}], "]"}]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ruru", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"rg", "\[Rule]", 
          FractionBox[
           RowBox[{"2", " ", "6.67", " ", 
            SuperscriptBox["10", 
             RowBox[{"-", "8"}]], "4.5", " ", 
            SuperscriptBox["10", "6"], "2", " ", 
            SuperscriptBox["10", "33"]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"3", " ", 
              SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
         RowBox[{"arcsec", "\[Rule]", 
          FractionBox[
           RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
            SuperscriptBox["10", "3"], "3.08", " ", 
            SuperscriptBox["10", "18"]}], 
           RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
         RowBox[{"pc", "\[Rule]", 
          RowBox[{"3.08", " ", 
           SuperscriptBox["10", "18"]}]}], ",", 
         RowBox[{"year", "\[Rule]", 
          RowBox[{"365.35", " ", "86400"}]}], ",", 
         RowBox[{"cc", "\[Rule]", 
          RowBox[{"3.", " ", 
           SuperscriptBox["10", "10"]}]}], ",", 
         RowBox[{"Msun", "\[Rule]", 
          RowBox[{"2.", " ", 
           SuperscriptBox["10", "33"]}]}], ",", 
         RowBox[{"mp", "\[Rule]", 
          RowBox[{"1.67", " ", 
           SuperscriptBox["10", 
            RowBox[{"-", "24"}]]}]}], ",", 
         RowBox[{"me", "\[Rule]", 
          RowBox[{"9.1", " ", 
           SuperscriptBox["10", 
            RowBox[{"-", "28"}]]}]}], ",", 
         RowBox[{"kb", "\[Rule]", 
          RowBox[{"1.38", " ", 
           SuperscriptBox["10", 
            RowBox[{"-", "16"}]]}]}], ",", 
         RowBox[{"h", "\[Rule]", 
          RowBox[{"6.626", " ", 
           SuperscriptBox["10", 
            RowBox[{"-", "27"}]]}]}], ",", 
         RowBox[{"ee", "\[Rule]", 
          RowBox[{"4.8", " ", 
           SuperscriptBox["10", 
            RowBox[{"-", "10"}]]}]}], ",", 
         RowBox[{"keV", "->", 
          RowBox[{"1000", " ", "1.602", " ", 
           SuperscriptBox["10", 
            RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
      "dir", "=", 
       "\"\<E:\\\\GRMHD\\\\thickdisk7\\\\images\\\\th238\\\\f230\\\\\>\""}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"fname", "=", 
       RowBox[{"Switch", "[", 
        RowBox[{
        "sp", ",", "0", ",", "\"\<shotimag93.75th238f230fn\>\"", ",", "1", 
         ",", "\"\<shotimag0th73fn\>\""}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"namefile", "=", 
       RowBox[{"dir", "<>", "fname", "<>", "\"\<6000_201.dat\>\""}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"fi11", "=", 
       RowBox[{"OpenRead", "[", 
        RowBox[{"namefile", ",", 
         RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
      RowBox[{"params", "=", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"a", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", 
      RowBox[{"th", "=", 
       RowBox[{
        RowBox[{"Round", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Pi]", "-", 
            RowBox[{"params", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "1000"}], "]"}], 
        "/", "1000."}]}], ";", 
      RowBox[{"nxy", "=", 
       RowBox[{"Round", "[", 
        RowBox[{"params", "[", 
         RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
      RowBox[{"nu", "=", 
       RowBox[{"Round", "[", 
        RowBox[{"params", "[", 
         RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
      RowBox[{"maxy", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "5", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"heat", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "6", "]"}], "]"}]}], ";", 
      RowBox[{"rnohor", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "7", "]"}], "]"}]}], ";", 
      RowBox[{"inten", "=", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
      RowBox[{"partres", "=", 
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"inten", ",", "5"}], "]"}], ",", 
         RowBox[{"nxy", "+", "1"}]}], "]"}]}], ";", 
      RowBox[{"Close", "[", "fi11", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"partres", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}], "=", "0."}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"dat", "=", 
       RowBox[{"Reverse", "[", 
        RowBox[{
         RowBox[{"partres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], ",", "2"}], 
        "]"}]}], ";", 
      RowBox[{"nn", "=", 
       RowBox[{"nxy", "+", "1"}]}], ";", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"dat", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Exp", "[", 
             RowBox[{
              RowBox[{"-", "5"}], 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  RowBox[{"2", "x"}], "nn"], "-", "1"}], ")"}], "2"]}], "]"}], 
            RowBox[{"Exp", "[", 
             RowBox[{
              RowBox[{"-", "7"}], 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  RowBox[{"2", "y"}], "nn"], "-", "1"}], ")"}], "2"]}], 
             "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"y", ",", "nn"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"x", ",", "nn"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<1 pixel = \>\"", ",", 
        RowBox[{"pixel", "=", 
         RowBox[{
          RowBox[{
           FractionBox[
            RowBox[{"2", "maxy"}], "nxy"], 
           SuperscriptBox["10", "6"], 
           FractionBox["rg", 
            RowBox[{"2", "arcsec"}]]}], "/.", "ruru"}]}], ",", 
        "\"\< \[Mu]as\>\""}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"side", "=", 
       RowBox[{"pixel", " ", 
        FractionBox["nxy", "2"]}]}], 
      RowBox[{"(*", 
       RowBox[{"\[Mu]as", " ", "-", " ", 
        RowBox[{"from", " ", "center", " ", "to", " ", "edge"}]}], "*)"}], 
      ";", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Center-edge angle in rad = \>\"", ",", 
        RowBox[{"a", "=", 
         RowBox[{"side", 
          FractionBox[
           RowBox[{"2.", "\[Pi]"}], 
           RowBox[{"360", " ", "60", " ", "60"}]], " ", 
          SuperscriptBox["10", 
           RowBox[{"-", "6"}]]}]}]}], "]"}], ";", 
      RowBox[{"(*", 
       RowBox[{"a", " ", "of", " ", "mabase", " ", "G\[Lambda]"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"mabase", "=", "7"}], ";", 
      RowBox[{"bb", "=", 
       RowBox[{"mabase", " ", 
        SuperscriptBox["10", "9."]}]}], ";", 
      RowBox[{"step", "=", 
       RowBox[{"2", 
        FractionBox["bb", "nxy"]}]}], ";", 
      RowBox[{"ran", "=", 
       RowBox[{"Range", "[", 
        RowBox[{
         RowBox[{"-", "bb"}], ",", "bb", ",", "step"}], "]"}]}], ";", 
      RowBox[{"res2D", "=", 
       FractionBox[
        RowBox[{"Total", "[", "furtab", "]"}], "ind"]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"inter", "=", 
       RowBox[{"ListInterpolation", "[", 
        RowBox[{"res2D", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "mabase"}], ",", "mabase"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "mabase"}], ",", "mabase"}], "}"}]}], "}"}]}], 
        "]"}]}], ";", 
      RowBox[{"Nin", "=", 
       RowBox[{"inter", "[", 
        RowBox[{"0", ",", "0"}], "]"}]}], ";", 
      RowBox[{"flux0", "=", "2.637"}], ";", "\[IndentingNewLine]", 
      RowBox[{"flux0", "=", 
       RowBox[{"Switch", "[", 
        RowBox[{"sp", ",", "0", ",", "2.4"}], "]"}]}], ";", "\n", 
      RowBox[{"\[Theta]sc", "=", 
       RowBox[{"170", "\[Degree]"}]}], ";", 
      RowBox[{"dir", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"90", "-", 
          RowBox[{
           FractionBox["180", "\[Pi]"], 
           RowBox[{"ArcTan", "[", 
            FractionBox["1.33", "3.5"], "]"}]}]}], ")"}], "\[Degree]"}]}], 
      ";", 
      RowBox[{"mysize", "=", "20"}], ";", 
      RowBox[{"expr", "=", 
       RowBox[{
        RowBox[{
         FractionBox["flux0", "Nin"], 
         RowBox[{"inter", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"y", " ", 
             RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "-", 
            RowBox[{"x", " ", 
             RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}], ",", 
           RowBox[{
            RowBox[{"x", " ", 
             RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "+", 
            RowBox[{"y", " ", 
             RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}]}], "]"}], 
         SuperscriptBox["2", 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox[
               RowBox[{
                RowBox[{"y", " ", 
                 RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "-", 
                RowBox[{"x", " ", 
                 RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "7"], ")"}], 
             "2"]}], "-", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"x", " ", 
                RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "+", 
               RowBox[{"y", " ", 
                RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "3.8"], ")"}], 
            "2"]}]]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x", "\[Rule]", 
           RowBox[{
            RowBox[{"-", "t"}], " ", 
            RowBox[{"Sin", "[", "dir", "]"}]}]}], ",", 
          RowBox[{"y", "\[Rule]", 
           RowBox[{"t", " ", 
            RowBox[{"Cos", "[", "dir", "]"}]}]}]}], "}"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"minsp", "=", 
         RowBox[{"Minimize", "[", 
          RowBox[{
           RowBox[{"expr", "/.", 
            RowBox[{"t", "\[Rule]", "3.5"}]}], ",", "\[Xi]"}], "]"}]}], ",", 
        RowBox[{"maxsp", "=", 
         RowBox[{"Maximize", "[", 
          RowBox[{
           RowBox[{"expr", "/.", 
            RowBox[{"t", "\[Rule]", "3.5"}]}], ",", "\[Xi]"}], "]"}]}]}], 
       "}"}], ";", 
      RowBox[{"totf", "=", 
       RowBox[{
        RowBox[{
         FractionBox["flux0", "Nin"], 
         RowBox[{"inter", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"y", " ", 
             RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "-", 
            RowBox[{"x", " ", 
             RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}], ",", 
           RowBox[{
            RowBox[{"x", " ", 
             RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "+", 
            RowBox[{"y", " ", 
             RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}]}], "]"}], 
         SuperscriptBox["2", 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox[
               RowBox[{
                RowBox[{"y", " ", 
                 RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "-", 
                RowBox[{"x", " ", 
                 RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "7"], ")"}], 
             "2"]}], "-", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"x", " ", 
                RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "+", 
               RowBox[{"y", " ", 
                RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "3.8"], ")"}], 
            "2"]}]]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x", "\[Rule]", 
           RowBox[{
            RowBox[{"-", "t"}], " ", 
            RowBox[{"Sin", "[", "dir", "]"}]}]}], ",", 
          RowBox[{"y", "\[Rule]", 
           RowBox[{"t", " ", 
            RowBox[{"Cos", "[", "dir", "]"}]}]}]}], "}"}]}]}], ";", 
      RowBox[{"sizepl", "=", 
       RowBox[{"LogPlot", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"totf", "/.", 
            RowBox[{"minsp", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ",", 
           RowBox[{"totf", "/.", 
            RowBox[{"maxsp", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}], 
         RowBox[{"(*", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"totf", "/.", 
             RowBox[{"\[Xi]", "\[Rule]", "1."}]}], ",", 
            RowBox[{"totf", "/.", 
             RowBox[{"\[Xi]", "\[Rule]", "2.5"}]}]}], "}"}], "*)"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "0", ",", "4"}], "}"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0.1", ",", "3.2"}], "}"}]}], ",", 
         RowBox[{"Epilog", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AbsoluteThickness", "[", "3", "]"}], ",", 
            RowBox[{"Line", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"3.5", ",", 
                 RowBox[{"Log", "[", "0.25", "]"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"3.5", ",", 
                 RowBox[{"Log", "[", "0.47", "]"}]}], "}"}]}], "}"}], "]"}]}],
            "}"}]}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{"style", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
                RowBox[{"AbsoluteDashing", "[", 
                 RowBox[{"{", 
                  RowBox[{"3", ",", "5"}], "}"}], "]"}]}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"Join", "[", 
             RowBox[{"style", ",", 
              RowBox[{"{", 
               RowBox[{"AbsoluteThickness", "[", "2", "]"}], "}"}]}], "]"}]}],
            "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\"", ",", 
              "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "\"\<baseline [G\[Lambda]]\>\"", ",", 
              "\"\<Correlated flux vs. baseline\>\""}], "}"}]}], "}"}]}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"FrameStyle", "\[Rule]", 
          RowBox[{"AbsoluteThickness", "[", "3", "]"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
         RowBox[{"BaseStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", "\"\<Arial\>\"", 
            ",", 
            RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "}"}]}]}], "]"}]}]}],
      ")"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\"\<quicka0in21.dat\>\"", ",", "Brown"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<quicka50in21.dat\>\"", ",", "Red"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<quicka70in21.dat\>\"", ",", "Green"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<quicka90in21.dat\>\"", ",", "Cyan"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<quicka98in21.dat\>\"", ",", "Orange"}], "}"}]}], "}"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl0", "=", 
   RowBox[{"plo", "[", 
    RowBox[{"0", ",", 
     RowBox[{"{", "Brown", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"pl0", "=", 
     RowBox[{"plo", "[", 
      RowBox[{
       RowBox[{"dir", "<>", "\"\<quicka0in21.dat\>\""}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", 
         RowBox[{"AbsoluteDashing", "[", 
          RowBox[{"{", 
           RowBox[{"3", ",", "5"}], "}"}], "]"}], ",", "Brown"}], "}"}], ",", 
       "22"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"pl50", "=", 
     RowBox[{"plo", "[", 
      RowBox[{
       RowBox[{"dir", "<>", "\"\<quicka50in21.dat\>\""}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Red"}], "}"}], 
       ",", "62"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"pl70", "=", 
     RowBox[{"plo", "[", 
      RowBox[{
       RowBox[{"dir", "<>", "\"\<quicka70in21.dat\>\""}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", 
         RowBox[{"AbsoluteDashing", "[", 
          RowBox[{"{", 
           RowBox[{"10", ",", "7"}], "}"}], "]"}], ",", "Green"}], "}"}], ",",
        "62"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"pl90", "=", 
     RowBox[{"plo", "[", 
      RowBox[{
       RowBox[{"dir", "<>", "\"\<quicka90in21.dat\>\""}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Cyan"}], "}"}],
        ",", "46"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"pl98", "=", 
     RowBox[{"plo", "[", 
      RowBox[{
       RowBox[{"dir", "<>", "\"\<quicka98in21.dat\>\""}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "DotDashed", 
         ",", "Orange"}], "}"}], ",", "50"}], "]"}]}], ";"}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.48647582549*^9, 3.486475840718*^9}, {3.486475908071*^9, 
   3.486475909387*^9}, {3.486476123024*^9, 3.486476126365*^9}, {
   3.486477995409*^9, 3.486478030433*^9}, {3.486478078071*^9, 
   3.486478117726*^9}, {3.48647848499*^9, 3.486478490237*^9}, {
   3.486478738394*^9, 3.486478753651*^9}, {3.48647965588*^9, 
   3.486479661719*^9}, {3.4873883094118*^9, 3.4873883172118*^9}, {
   3.502540782178*^9, 3.5025408012724*^9}, {3.5025408632511997`*^9, 
   3.5025408633292*^9}, {3.502546266383*^9, 3.502546274387*^9}, 
   3.5025464697626*^9, {3.509379847657*^9, 3.509379868892*^9}, {
   3.5093803045369997`*^9, 3.509380307383*^9}, {3.5093808278517036`*^9, 
   3.509380830846904*^9}, {3.5093809354917035`*^9, 3.5093809380657034`*^9}, 
   3.5094523773380003`*^9, {3.509452703691*^9, 3.509452706882*^9}, {
   3.510000010913*^9, 3.5100000110360003`*^9}, {3.5292493060312395`*^9, 
   3.5292494138124046`*^9}, {3.5292496801386375`*^9, 3.529249701571863*^9}, {
   3.529250343124558*^9, 3.529250343944605*^9}, {3.5292504490626173`*^9, 
   3.529250449325632*^9}, 3.5292508786001854`*^9, {3.5292555536485825`*^9, 
   3.529255600735276*^9}, {3.529256068034004*^9, 3.529256075637439*^9}, {
   3.529256458317327*^9, 3.5292564586763477`*^9}, {3.5292565386329207`*^9, 
   3.5292566276130104`*^9}, {3.5292576475573473`*^9, 
   3.5292577899594927`*^9}, {3.5292578591234484`*^9, 3.529257895222513*^9}, {
   3.529257978708288*^9, 3.5292579796373415`*^9}, {3.529258067065342*^9, 
   3.5292580849113626`*^9}, {3.529258423898752*^9, 3.5292585066724863`*^9}, 
   3.5292588612037644`*^9, {3.5293209592533927`*^9, 3.529320984475835*^9}, {
   3.52932103491572*^9, 3.529321036873832*^9}, {3.529321185218317*^9, 
   3.5293212162670927`*^9}, {3.540226794658067*^9, 3.540226794689267*^9}, {
   3.5402284983380594`*^9, 3.54022849854086*^9}, {3.5403008537815294`*^9, 
   3.540300906166526*^9}, {3.540300951509119*^9, 3.5403009807487917`*^9}, {
   3.540301110183195*^9, 3.5403011105572166`*^9}, {3.5403053482535987`*^9, 
   3.5403053492086535`*^9}, {3.540305408017017*^9, 3.5403054152784324`*^9}, {
   3.540305462762148*^9, 3.540305607676437*^9}, {3.5403056551981544`*^9, 
   3.5403056997197013`*^9}, {3.540305735166729*^9, 3.540305833415348*^9}, {
   3.540305899315118*^9, 3.540305931340949*^9}, {3.540306007634313*^9, 
   3.5403060660606546`*^9}, {3.5403061150564575`*^9, 
   3.5403061306853514`*^9}, {3.540306180576205*^9, 3.5403062568715687`*^9}, {
   3.5403063325868993`*^9, 3.5403064033459463`*^9}, 3.5403065214787035`*^9, {
   3.540306665549944*^9, 3.5403066845620313`*^9}, {3.5403068187807083`*^9, 
   3.5403068304333744`*^9}, {3.5403071310545692`*^9, 
   3.5403072051518073`*^9}, {3.5403072850233755`*^9, 3.540307310744847*^9}, {
   3.540307619887529*^9, 3.5403076199365315`*^9}, 3.5403076583787303`*^9, {
   3.5685165107254176`*^9, 3.5685166584264765`*^9}, {3.5685167721194763`*^9, 
   3.568516826298372*^9}, {3.568516959039005*^9, 3.5685169924386635`*^9}, {
   3.568517267092746*^9, 3.5685172757351613`*^9}}],

Cell[BoxData["pl0"], "Input",
 CellChangeTimes->{{3.5685170657587924`*^9, 3.568517066008393*^9}}],

Cell[BoxData["238"], "Input",
 CellChangeTimes->{{3.568517354716897*^9, 3.568517355013298*^9}}],

Cell[BoxData["237"], "Input",
 CellChangeTimes->{{3.568517260805935*^9, 3.5685172611335354`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["New calculations", "Subsubsection",
 CellChangeTimes->{{3.5403054359026117`*^9, 3.5403054378537235`*^9}, {
  3.5403071628353868`*^9, 3.5403071630904016`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fmin", "=", "6850"}], ";", 
  RowBox[{"fmax", "=", "9850"}], ";", 
  RowBox[{"ind", "=", "21"}], ";", 
  RowBox[{"sep", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"ind", "-", "1"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"plo", "[", 
     RowBox[{
      RowBox[{"sp_", "?", "IntegerQ"}], ",", 
      RowBox[{"style_", "?", "ListQ"}]}], "]"}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SetSharedVariable", "[", "sp", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"furtab", "=", 
       RowBox[{"ParallelTable", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ruru", "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"rg", "\[Rule]", 
              FractionBox[
               RowBox[{"2", " ", "6.67", " ", 
                SuperscriptBox["10", 
                 RowBox[{"-", "8"}]], "4.5", " ", 
                SuperscriptBox["10", "6"], "2", " ", 
                SuperscriptBox["10", "33"]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"3", " ", 
                  SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
             RowBox[{"arcsec", "\[Rule]", 
              FractionBox[
               RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
                SuperscriptBox["10", "3"], "3.08", " ", 
                SuperscriptBox["10", "18"]}], 
               RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
             RowBox[{"pc", "\[Rule]", 
              RowBox[{"3.08", " ", 
               SuperscriptBox["10", "18"]}]}], ",", 
             RowBox[{"year", "\[Rule]", 
              RowBox[{"365.35", " ", "86400"}]}], ",", 
             RowBox[{"cc", "\[Rule]", 
              RowBox[{"3.", " ", 
               SuperscriptBox["10", "10"]}]}], ",", 
             RowBox[{"Msun", "\[Rule]", 
              RowBox[{"2.", " ", 
               SuperscriptBox["10", "33"]}]}], ",", 
             RowBox[{"mp", "\[Rule]", 
              RowBox[{"1.67", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "24"}]]}]}], ",", 
             RowBox[{"me", "\[Rule]", 
              RowBox[{"9.1", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "28"}]]}]}], ",", 
             RowBox[{"kb", "\[Rule]", 
              RowBox[{"1.38", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "16"}]]}]}], ",", 
             RowBox[{"h", "\[Rule]", 
              RowBox[{"6.626", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "27"}]]}]}], ",", 
             RowBox[{"ee", "\[Rule]", 
              RowBox[{"4.8", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "10"}]]}]}], ",", 
             RowBox[{"keV", "->", 
              RowBox[{"1000", " ", "1.602", " ", 
               SuperscriptBox["10", 
                RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
          "dir", "=", 
           "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2012Feb_full\\\\\>\"\
"}], ";", "\[IndentingNewLine]", 
          RowBox[{"fname", "=", 
           RowBox[{"Switch", "[", 
            RowBox[{
            "sp", ",", "1", ",", "\"\<shotimag0th73fn\>\"", ",", "2", ",", 
             "\"\<shotimag50th184fn\>\"", ",", "3", ",", 
             "\"\<shotimag70th201fn\>\"", ",", "4", ",", 
             "\"\<shotimag90th220fn\>\"", ",", "5", ",", 
             "\"\<shotimag98th214fn\>\""}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"namefile", "=", 
           RowBox[{"dir", "<>", "fname", "<>", 
            RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<.dat\>\""}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"fi11", "=", 
           RowBox[{"OpenRead", "[", 
            RowBox[{"namefile", ",", 
             RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
          RowBox[{"params", "=", 
           RowBox[{"BinaryReadList", "[", 
            RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"a", "=", 
           RowBox[{"params", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], ";", 
          RowBox[{"th", "=", 
           RowBox[{
            RowBox[{"Round", "[", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"\[Pi]", "-", 
                RowBox[{"params", "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "1000"}], 
             "]"}], "/", "1000."}]}], ";", 
          RowBox[{"nxy", "=", 
           RowBox[{"Round", "[", 
            RowBox[{"params", "[", 
             RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
          RowBox[{"nu", "=", 
           RowBox[{"Round", "[", 
            RowBox[{"params", "[", 
             RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
          RowBox[{"maxy", "=", 
           RowBox[{"params", "[", 
            RowBox[{"[", "5", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"heat", "=", 
           RowBox[{"params", "[", 
            RowBox[{"[", "6", "]"}], "]"}]}], ";", 
          RowBox[{"rnohor", "=", 
           RowBox[{"params", "[", 
            RowBox[{"[", "7", "]"}], "]"}]}], ";", 
          RowBox[{"inten", "=", 
           RowBox[{"BinaryReadList", "[", 
            RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
          RowBox[{"partres", "=", 
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{"inten", ",", "5"}], "]"}], ",", 
             RowBox[{"nxy", "+", "1"}]}], "]"}]}], ";", 
          RowBox[{"Close", "[", "fi11", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"partres", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}], "=", "0."}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"dat", "=", 
           RowBox[{"Reverse", "[", 
            RowBox[{
             RowBox[{"partres", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], ",", 
             "2"}], "]"}]}], ";", 
          RowBox[{"nn", "=", 
           RowBox[{"nxy", "+", "1"}]}], ";", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"dat", "=", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Exp", "[", 
                 RowBox[{
                  RowBox[{"-", "5"}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    FractionBox[
                    RowBox[{"2", "x"}], "nn"], "-", "1"}], ")"}], "2"]}], 
                 "]"}], 
                RowBox[{"Exp", "[", 
                 RowBox[{
                  RowBox[{"-", "7"}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    FractionBox[
                    RowBox[{"2", "y"}], "nn"], "-", "1"}], ")"}], "2"]}], 
                 "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"y", ",", "nn"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"x", ",", "nn"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"pixel", "=", 
           RowBox[{
            RowBox[{
             FractionBox[
              RowBox[{"2", "maxy"}], "nxy"], 
             SuperscriptBox["10", "6"], 
             FractionBox["rg", 
              RowBox[{"2", "arcsec"}]]}], "/.", "ruru"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"side", "=", 
           RowBox[{"pixel", " ", 
            FractionBox["nxy", "2"]}]}], 
          RowBox[{"(*", 
           RowBox[{"\[Mu]as", " ", "-", " ", 
            RowBox[{"from", " ", "center", " ", "to", " ", "edge"}]}], "*)"}],
           ";", 
          RowBox[{"a", "=", 
           RowBox[{"side", 
            FractionBox[
             RowBox[{"2.", "\[Pi]"}], 
             RowBox[{"360", " ", "60", " ", "60"}]], " ", 
            SuperscriptBox["10", 
             RowBox[{"-", "6"}]]}]}], ";", 
          RowBox[{"(*", 
           RowBox[{"a", " ", "of", " ", "mabase", " ", "G\[Lambda]"}], "*)"}],
           "\[IndentingNewLine]", 
          RowBox[{"mabase", "=", "7"}], ";", 
          RowBox[{"bb", "=", 
           RowBox[{"mabase", " ", 
            SuperscriptBox["10", "9."]}]}], ";", 
          RowBox[{"step", "=", 
           RowBox[{"2", 
            FractionBox["bb", "nxy"]}]}], ";", 
          RowBox[{"ran", "=", 
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"-", "bb"}], ",", "bb", ",", "step"}], "]"}]}], ";", 
          RowBox[{"Dimensions", "[", "dat", "]"}], ";", 
          RowBox[{"Dimensions", "[", "ran", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"DFT2D", "[", 
            RowBox[{"m_", ",", "n_"}], "]"}], ":=", 
           RowBox[{"Sum", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"dat", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"k", "+", 
                  FractionBox["nn", "2"]}], ",", 
                 RowBox[{"l", "+", 
                  FractionBox["nn", "2"]}]}], "]"}], "]"}], " ", 
              RowBox[{"Exp", "[", 
               RowBox[{
                RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]", " ", "m", 
                " ", 
                FractionBox[
                 RowBox[{"2", "a", " ", "k"}], "nn"]}], "]"}], 
              RowBox[{"Exp", "[", 
               RowBox[{
                RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]", " ", "n", 
                FractionBox[
                 RowBox[{"2", "a", " ", "l"}], "nn"]}], "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"k", ",", 
               RowBox[{
                FractionBox[
                 RowBox[{"-", "nn"}], "2"], "+", "1"}], ",", 
               FractionBox["nn", "2"]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{
                FractionBox[
                 RowBox[{"-", "nn"}], "2"], "+", "1"}], ",", 
               FractionBox["nn", "2"]}], "}"}]}], "]"}]}], ";", 
          RowBox[{"Print", "[", "fnum", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"res2D", "=", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"DFT2D", "[", 
              RowBox[{"ran", ",", "n"}], "]"}], "/.", 
             RowBox[{"n", "\[Rule]", "ran"}]}], "]"}]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ruru", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"rg", "\[Rule]", 
          FractionBox[
           RowBox[{"2", " ", "6.67", " ", 
            SuperscriptBox["10", 
             RowBox[{"-", "8"}]], "4.5", " ", 
            SuperscriptBox["10", "6"], "2", " ", 
            SuperscriptBox["10", "33"]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"3", " ", 
              SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
         RowBox[{"arcsec", "\[Rule]", 
          FractionBox[
           RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
            SuperscriptBox["10", "3"], "3.08", " ", 
            SuperscriptBox["10", "18"]}], 
           RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
         RowBox[{"pc", "\[Rule]", 
          RowBox[{"3.08", " ", 
           SuperscriptBox["10", "18"]}]}], ",", 
         RowBox[{"year", "\[Rule]", 
          RowBox[{"365.35", " ", "86400"}]}], ",", 
         RowBox[{"cc", "\[Rule]", 
          RowBox[{"3.", " ", 
           SuperscriptBox["10", "10"]}]}], ",", 
         RowBox[{"Msun", "\[Rule]", 
          RowBox[{"2.", " ", 
           SuperscriptBox["10", "33"]}]}], ",", 
         RowBox[{"mp", "\[Rule]", 
          RowBox[{"1.67", " ", 
           SuperscriptBox["10", 
            RowBox[{"-", "24"}]]}]}], ",", 
         RowBox[{"me", "\[Rule]", 
          RowBox[{"9.1", " ", 
           SuperscriptBox["10", 
            RowBox[{"-", "28"}]]}]}], ",", 
         RowBox[{"kb", "\[Rule]", 
          RowBox[{"1.38", " ", 
           SuperscriptBox["10", 
            RowBox[{"-", "16"}]]}]}], ",", 
         RowBox[{"h", "\[Rule]", 
          RowBox[{"6.626", " ", 
           SuperscriptBox["10", 
            RowBox[{"-", "27"}]]}]}], ",", 
         RowBox[{"ee", "\[Rule]", 
          RowBox[{"4.8", " ", 
           SuperscriptBox["10", 
            RowBox[{"-", "10"}]]}]}], ",", 
         RowBox[{"keV", "->", 
          RowBox[{"1000", " ", "1.602", " ", 
           SuperscriptBox["10", 
            RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";", 
      RowBox[{
      "dir", "=", 
       "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2012Feb_full\\\\\>\""}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"fname", "=", 
       RowBox[{"Switch", "[", 
        RowBox[{
        "sp", ",", "1", ",", "\"\<shotimag0th73fn\>\"", ",", "2", ",", 
         "\"\<shotimag50th184fn\>\"", ",", "3", ",", 
         "\"\<shotimag70th201fn\>\"", ",", "4", ",", 
         "\"\<shotimag90th220fn\>\"", ",", "5", ",", 
         "\"\<shotimag98th214fn\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"namefile", "=", 
       RowBox[{"dir", "<>", "fname", "<>", "\"\<6850.dat\>\""}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"fi11", "=", 
       RowBox[{"OpenRead", "[", 
        RowBox[{"namefile", ",", 
         RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
      RowBox[{"params", "=", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"a", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", 
      RowBox[{"th", "=", 
       RowBox[{
        RowBox[{"Round", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Pi]", "-", 
            RowBox[{"params", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "1000"}], "]"}], 
        "/", "1000."}]}], ";", 
      RowBox[{"nxy", "=", 
       RowBox[{"Round", "[", 
        RowBox[{"params", "[", 
         RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
      RowBox[{"nu", "=", 
       RowBox[{"Round", "[", 
        RowBox[{"params", "[", 
         RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
      RowBox[{"maxy", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "5", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"heat", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "6", "]"}], "]"}]}], ";", 
      RowBox[{"rnohor", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "7", "]"}], "]"}]}], ";", 
      RowBox[{"inten", "=", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
      RowBox[{"partres", "=", 
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"inten", ",", "5"}], "]"}], ",", 
         RowBox[{"nxy", "+", "1"}]}], "]"}]}], ";", 
      RowBox[{"Close", "[", "fi11", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"partres", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}], "=", "0."}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"dat", "=", 
       RowBox[{"Reverse", "[", 
        RowBox[{
         RowBox[{"partres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], ",", "2"}], 
        "]"}]}], ";", 
      RowBox[{"nn", "=", 
       RowBox[{"nxy", "+", "1"}]}], ";", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"dat", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Exp", "[", 
             RowBox[{
              RowBox[{"-", "5"}], 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  RowBox[{"2", "x"}], "nn"], "-", "1"}], ")"}], "2"]}], "]"}], 
            RowBox[{"Exp", "[", 
             RowBox[{
              RowBox[{"-", "7"}], 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  RowBox[{"2", "y"}], "nn"], "-", "1"}], ")"}], "2"]}], 
             "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"y", ",", "nn"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"x", ",", "nn"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<1 pixel = \>\"", ",", 
        RowBox[{"pixel", "=", 
         RowBox[{
          RowBox[{
           FractionBox[
            RowBox[{"2", "maxy"}], "nxy"], 
           SuperscriptBox["10", "6"], 
           FractionBox["rg", 
            RowBox[{"2", "arcsec"}]]}], "/.", "ruru"}]}], ",", 
        "\"\< \[Mu]as\>\""}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"side", "=", 
       RowBox[{"pixel", " ", 
        FractionBox["nxy", "2"]}]}], 
      RowBox[{"(*", 
       RowBox[{"\[Mu]as", " ", "-", " ", 
        RowBox[{"from", " ", "center", " ", "to", " ", "edge"}]}], "*)"}], 
      ";", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Center-edge angle in rad = \>\"", ",", 
        RowBox[{"a", "=", 
         RowBox[{"side", 
          FractionBox[
           RowBox[{"2.", "\[Pi]"}], 
           RowBox[{"360", " ", "60", " ", "60"}]], " ", 
          SuperscriptBox["10", 
           RowBox[{"-", "6"}]]}]}]}], "]"}], ";", 
      RowBox[{"(*", 
       RowBox[{"a", " ", "of", " ", "mabase", " ", "G\[Lambda]"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"mabase", "=", "7"}], ";", 
      RowBox[{"bb", "=", 
       RowBox[{"mabase", " ", 
        SuperscriptBox["10", "9."]}]}], ";", 
      RowBox[{"step", "=", 
       RowBox[{"2", 
        FractionBox["bb", "nxy"]}]}], ";", 
      RowBox[{"ran", "=", 
       RowBox[{"Range", "[", 
        RowBox[{
         RowBox[{"-", "bb"}], ",", "bb", ",", "step"}], "]"}]}], ";", 
      RowBox[{"res2D", "=", 
       FractionBox[
        RowBox[{"Total", "[", "furtab", "]"}], "ind"]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"inter", "=", 
       RowBox[{"ListInterpolation", "[", 
        RowBox[{"res2D", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "mabase"}], ",", "mabase"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "mabase"}], ",", "mabase"}], "}"}]}], "}"}]}], 
        "]"}]}], ";", 
      RowBox[{"Nin", "=", 
       RowBox[{"inter", "[", 
        RowBox[{"0", ",", "0"}], "]"}]}], ";", 
      RowBox[{"flux0", "=", "2.637"}], ";", "\[IndentingNewLine]", 
      RowBox[{"flux0", "=", 
       RowBox[{"Switch", "[", 
        RowBox[{
        "sp", ",", "1", ",", "3.131", ",", "2", ",", "2.859", ",", "3", ",", 
         "2.858", ",", "4", ",", "2.915", ",", "5", ",", "2.862"}], "]"}]}], 
      ";", "\n", 
      RowBox[{"\[Theta]sc", "=", 
       RowBox[{"170", "\[Degree]"}]}], ";", 
      RowBox[{"dir", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"90", "-", 
          RowBox[{
           FractionBox["180", "\[Pi]"], 
           RowBox[{"ArcTan", "[", 
            FractionBox["1.33", "3.5"], "]"}]}]}], ")"}], "\[Degree]"}]}], 
      ";", 
      RowBox[{"mysize", "=", "20"}], ";", 
      RowBox[{"expr", "=", 
       RowBox[{
        RowBox[{
         FractionBox["flux0", "Nin"], 
         RowBox[{"inter", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"y", " ", 
             RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "-", 
            RowBox[{"x", " ", 
             RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}], ",", 
           RowBox[{
            RowBox[{"x", " ", 
             RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "+", 
            RowBox[{"y", " ", 
             RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}]}], "]"}], 
         SuperscriptBox["2", 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox[
               RowBox[{
                RowBox[{"y", " ", 
                 RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "-", 
                RowBox[{"x", " ", 
                 RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "7"], ")"}], 
             "2"]}], "-", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"x", " ", 
                RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "+", 
               RowBox[{"y", " ", 
                RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "3.8"], ")"}], 
            "2"]}]]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x", "\[Rule]", 
           RowBox[{
            RowBox[{"-", "t"}], " ", 
            RowBox[{"Sin", "[", "dir", "]"}]}]}], ",", 
          RowBox[{"y", "\[Rule]", 
           RowBox[{"t", " ", 
            RowBox[{"Cos", "[", "dir", "]"}]}]}]}], "}"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"minsp", "=", 
         RowBox[{"Minimize", "[", 
          RowBox[{
           RowBox[{"expr", "/.", 
            RowBox[{"t", "\[Rule]", "3.5"}]}], ",", "\[Xi]"}], "]"}]}], ",", 
        RowBox[{"maxsp", "=", 
         RowBox[{"Maximize", "[", 
          RowBox[{
           RowBox[{"expr", "/.", 
            RowBox[{"t", "\[Rule]", "3.5"}]}], ",", "\[Xi]"}], "]"}]}]}], 
       "}"}], ";", 
      RowBox[{"totf", "=", 
       RowBox[{
        RowBox[{
         FractionBox["flux0", "Nin"], 
         RowBox[{"inter", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"y", " ", 
             RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "-", 
            RowBox[{"x", " ", 
             RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}], ",", 
           RowBox[{
            RowBox[{"x", " ", 
             RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "+", 
            RowBox[{"y", " ", 
             RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}]}], "]"}], 
         SuperscriptBox["2", 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox[
               RowBox[{
                RowBox[{"y", " ", 
                 RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "-", 
                RowBox[{"x", " ", 
                 RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "7"], ")"}], 
             "2"]}], "-", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"x", " ", 
                RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "+", 
               RowBox[{"y", " ", 
                RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "3.8"], ")"}], 
            "2"]}]]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x", "\[Rule]", 
           RowBox[{
            RowBox[{"-", "t"}], " ", 
            RowBox[{"Sin", "[", "dir", "]"}]}]}], ",", 
          RowBox[{"y", "\[Rule]", 
           RowBox[{"t", " ", 
            RowBox[{"Cos", "[", "dir", "]"}]}]}]}], "}"}]}]}], ";", 
      RowBox[{"sizepl", "=", 
       RowBox[{"LogPlot", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"totf", "/.", 
            RowBox[{"minsp", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ",", 
           RowBox[{"totf", "/.", 
            RowBox[{"maxsp", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}], 
         RowBox[{"(*", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"totf", "/.", 
             RowBox[{"\[Xi]", "\[Rule]", "1."}]}], ",", 
            RowBox[{"totf", "/.", 
             RowBox[{"\[Xi]", "\[Rule]", "2.5"}]}]}], "}"}], "*)"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "0", ",", "4"}], "}"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0.1", ",", "3.2"}], "}"}]}], ",", 
         RowBox[{"Epilog", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AbsoluteThickness", "[", "3", "]"}], ",", 
            RowBox[{"Line", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"3.5", ",", 
                 RowBox[{"Log", "[", "0.25", "]"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"3.5", ",", 
                 RowBox[{"Log", "[", "0.47", "]"}]}], "}"}]}], "}"}], "]"}]}],
            "}"}]}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{"style", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", 
                RowBox[{"AbsoluteDashing", "[", 
                 RowBox[{"{", 
                  RowBox[{"3", ",", "5"}], "}"}], "]"}]}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"Join", "[", 
             RowBox[{"style", ",", 
              RowBox[{"{", 
               RowBox[{"AbsoluteThickness", "[", "2", "]"}], "}"}]}], "]"}]}],
            "}"}]}], ",", 
         RowBox[{"FrameLabel", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\"", ",", 
              "Null"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "\"\<baseline [G\[Lambda]]\>\"", ",", 
              "\"\<Correlated flux vs. baseline\>\""}], "}"}]}], "}"}]}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"FrameStyle", "\[Rule]", 
          RowBox[{"AbsoluteThickness", "[", "3", "]"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
         RowBox[{"BaseStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", "\"\<Arial\>\"", 
            ",", 
            RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "}"}]}]}], "]"}]}]}],
      ")"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\"\<quicka0in21.dat\>\"", ",", "Brown"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<quicka50in21.dat\>\"", ",", "Red"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<quicka70in21.dat\>\"", ",", "Green"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<quicka90in21.dat\>\"", ",", "Cyan"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<quicka98in21.dat\>\"", ",", "Orange"}], "}"}]}], "}"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl0", "=", 
   RowBox[{"plo", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", "Brown", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl50", "=", 
   RowBox[{"plo", "[", 
    RowBox[{"2", ",", 
     RowBox[{"{", "Red", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl70", "=", 
   RowBox[{"plo", "[", 
    RowBox[{"3", ",", 
     RowBox[{"{", "Green", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl90", "=", 
   RowBox[{"plo", "[", 
    RowBox[{"4", ",", 
     RowBox[{"{", "Cyan", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl98", "=", 
   RowBox[{"plo", "[", 
    RowBox[{"5", ",", 
     RowBox[{"{", "Orange", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"finsize", "=", 
  RowBox[{"Show", "[", 
   RowBox[{"{", 
    RowBox[{"pl0", ",", "pl50", ",", "pl70", ",", "pl90", ",", "pl98"}], 
    "}"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"pl0", "=", 
     RowBox[{"plo", "[", 
      RowBox[{
       RowBox[{"dir", "<>", "\"\<quicka0in21.dat\>\""}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", 
         RowBox[{"AbsoluteDashing", "[", 
          RowBox[{"{", 
           RowBox[{"3", ",", "5"}], "}"}], "]"}], ",", "Brown"}], "}"}], ",", 
       "22"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"pl50", "=", 
     RowBox[{"plo", "[", 
      RowBox[{
       RowBox[{"dir", "<>", "\"\<quicka50in21.dat\>\""}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Red"}], "}"}], 
       ",", "62"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"pl70", "=", 
     RowBox[{"plo", "[", 
      RowBox[{
       RowBox[{"dir", "<>", "\"\<quicka70in21.dat\>\""}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", 
         RowBox[{"AbsoluteDashing", "[", 
          RowBox[{"{", 
           RowBox[{"10", ",", "7"}], "}"}], "]"}], ",", "Green"}], "}"}], ",",
        "62"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"pl90", "=", 
     RowBox[{"plo", "[", 
      RowBox[{
       RowBox[{"dir", "<>", "\"\<quicka90in21.dat\>\""}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "Cyan"}], "}"}],
        ",", "46"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"pl98", "=", 
     RowBox[{"plo", "[", 
      RowBox[{
       RowBox[{"dir", "<>", "\"\<quicka98in21.dat\>\""}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2.5", "]"}], ",", "DotDashed", 
         ",", "Orange"}], "}"}], ",", "50"}], "]"}]}], ";"}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.48647582549*^9, 3.486475840718*^9}, {3.486475908071*^9, 
   3.486475909387*^9}, {3.486476123024*^9, 3.486476126365*^9}, {
   3.486477995409*^9, 3.486478030433*^9}, {3.486478078071*^9, 
   3.486478117726*^9}, {3.48647848499*^9, 3.486478490237*^9}, {
   3.486478738394*^9, 3.486478753651*^9}, {3.48647965588*^9, 
   3.486479661719*^9}, {3.4873883094118*^9, 3.4873883172118*^9}, {
   3.502540782178*^9, 3.5025408012724*^9}, {3.5025408632511997`*^9, 
   3.5025408633292*^9}, {3.502546266383*^9, 3.502546274387*^9}, 
   3.5025464697626*^9, {3.509379847657*^9, 3.509379868892*^9}, {
   3.5093803045369997`*^9, 3.509380307383*^9}, {3.5093808278517036`*^9, 
   3.509380830846904*^9}, {3.5093809354917035`*^9, 3.5093809380657034`*^9}, 
   3.5094523773380003`*^9, {3.509452703691*^9, 3.509452706882*^9}, {
   3.510000010913*^9, 3.5100000110360003`*^9}, {3.5292493060312395`*^9, 
   3.5292494138124046`*^9}, {3.5292496801386375`*^9, 3.529249701571863*^9}, {
   3.529250343124558*^9, 3.529250343944605*^9}, {3.5292504490626173`*^9, 
   3.529250449325632*^9}, 3.5292508786001854`*^9, {3.5292555536485825`*^9, 
   3.529255600735276*^9}, {3.529256068034004*^9, 3.529256075637439*^9}, {
   3.529256458317327*^9, 3.5292564586763477`*^9}, {3.5292565386329207`*^9, 
   3.5292566276130104`*^9}, {3.5292576475573473`*^9, 
   3.5292577899594927`*^9}, {3.5292578591234484`*^9, 3.529257895222513*^9}, {
   3.529257978708288*^9, 3.5292579796373415`*^9}, {3.529258067065342*^9, 
   3.5292580849113626`*^9}, {3.529258423898752*^9, 3.5292585066724863`*^9}, 
   3.5292588612037644`*^9, {3.5293209592533927`*^9, 3.529320984475835*^9}, {
   3.52932103491572*^9, 3.529321036873832*^9}, {3.529321185218317*^9, 
   3.5293212162670927`*^9}, {3.540226794658067*^9, 3.540226794689267*^9}, {
   3.5402284983380594`*^9, 3.54022849854086*^9}, {3.5403008537815294`*^9, 
   3.540300906166526*^9}, {3.540300951509119*^9, 3.5403009807487917`*^9}, {
   3.540301110183195*^9, 3.5403011105572166`*^9}, {3.5403053482535987`*^9, 
   3.5403053492086535`*^9}, {3.540305408017017*^9, 3.5403054152784324`*^9}, {
   3.540305462762148*^9, 3.540305607676437*^9}, {3.5403056551981544`*^9, 
   3.5403056997197013`*^9}, {3.540305735166729*^9, 3.540305833415348*^9}, {
   3.540305899315118*^9, 3.540305931340949*^9}, {3.540306007634313*^9, 
   3.5403060660606546`*^9}, {3.5403061150564575`*^9, 
   3.5403061306853514`*^9}, {3.540306180576205*^9, 3.5403062568715687`*^9}, {
   3.5403063325868993`*^9, 3.5403064033459463`*^9}, 3.5403065214787035`*^9, {
   3.540306665549944*^9, 3.5403066845620313`*^9}, {3.5403068187807083`*^9, 
   3.5403068304333744`*^9}, {3.5403071310545692`*^9, 
   3.5403072051518073`*^9}, {3.5403072850233755`*^9, 3.540307310744847*^9}, {
   3.540307619887529*^9, 3.5403076199365315`*^9}, 3.5403076583787303`*^9}],

Cell[BoxData[
 RowBox[{"finsize", "=", 
  RowBox[{"Show", "[", 
   RowBox[{"{", 
    RowBox[{"pl50", ",", "pl98"}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5403098490140276`*^9, 3.5403098694481964`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "\"\<C:\\\\study\\\\accretion\\\\! 2009 3fall cfa\\\\GR Polarized modeling\
\\\\!svn\\\\\>\"", "<>", "\"\<sizepl.eps\>\""}], ",", "finsize"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.540307719199209*^9, 3.540307723694466*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ruru", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rg", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "6.67", " ", 
        SuperscriptBox["10", 
         RowBox[{"-", "8"}]], "4.5", " ", 
        SuperscriptBox["10", "6"], "2", " ", 
        SuperscriptBox["10", "33"]}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"3", " ", 
          SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
     RowBox[{"arcsec", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
        SuperscriptBox["10", "3"], "3.08", " ", 
        SuperscriptBox["10", "18"]}], 
       RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
     RowBox[{"pc", "\[Rule]", 
      RowBox[{"3.08", " ", 
       SuperscriptBox["10", "18"]}]}], ",", 
     RowBox[{"year", "\[Rule]", 
      RowBox[{"365.35", " ", "86400"}]}], ",", 
     RowBox[{"cc", "\[Rule]", 
      RowBox[{"3.", " ", 
       SuperscriptBox["10", "10"]}]}], ",", 
     RowBox[{"Msun", "\[Rule]", 
      RowBox[{"2.", " ", 
       SuperscriptBox["10", "33"]}]}], ",", 
     RowBox[{"mp", "\[Rule]", 
      RowBox[{"1.67", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "24"}]]}]}], ",", 
     RowBox[{"me", "\[Rule]", 
      RowBox[{"9.1", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "28"}]]}]}], ",", 
     RowBox[{"kb", "\[Rule]", 
      RowBox[{"1.38", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "16"}]]}]}], ",", 
     RowBox[{"h", "\[Rule]", 
      RowBox[{"6.626", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "27"}]]}]}], ",", 
     RowBox[{"ee", "\[Rule]", 
      RowBox[{"4.8", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "10"}]]}]}], ",", 
     RowBox[{"keV", "->", 
      RowBox[{"1000", " ", "1.602", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";", 
  RowBox[{
  "dir", "=", 
   "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\deepthought\\\
\\2\\\\\>\""}], ";", 
  RowBox[{"namefile", "=", 
   RowBox[{"dir", "<>", "\"\<shotimag50th203fn6950.dat\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fi11", "=", 
   RowBox[{"OpenRead", "[", 
    RowBox[{"namefile", ",", 
     RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
  RowBox[{"params", "=", 
   RowBox[{"BinaryReadList", "[", 
    RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"th", "=", 
   RowBox[{
    RowBox[{"Round", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[Pi]", "-", 
        RowBox[{"params", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "1000"}], "]"}], "/", 
    "1000."}]}], ";", 
  RowBox[{"nxy", "=", 
   RowBox[{"Round", "[", 
    RowBox[{"params", "[", 
     RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"nu", "=", 
   RowBox[{"Round", "[", 
    RowBox[{"params", "[", 
     RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"maxy", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "5", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"heat", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "6", "]"}], "]"}]}], ";", 
  RowBox[{"rnohor", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "7", "]"}], "]"}]}], ";", 
  RowBox[{"inten", "=", 
   RowBox[{"BinaryReadList", "[", 
    RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
  RowBox[{"partres", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"Partition", "[", 
      RowBox[{"inten", ",", "5"}], "]"}], ",", 
     RowBox[{"nxy", "+", "1"}]}], "]"}]}], ";", 
  RowBox[{"Close", "[", "fi11", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"partres", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}], "=", "0."}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dat", "=", 
    RowBox[{"Reverse", "[", 
     RowBox[{
      RowBox[{"partres", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], ",", "2"}], 
     "]"}]}], ";", 
   RowBox[{"nn", "=", 
    RowBox[{"nxy", "+", "1"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"dat", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"-", "5"}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"2", "x"}], "nn"], "-", "1"}], ")"}], "2"]}], "]"}], 
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"-", "7"}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"2", "y"}], "nn"], "-", "1"}], ")"}], "2"]}], "]"}]}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", "nn"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "nn"}], "}"}]}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<1 pixel = \>\"", ",", 
    RowBox[{"pixel", "=", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"2", "maxy"}], "nxy"], 
       SuperscriptBox["10", "6"], 
       FractionBox["rg", 
        RowBox[{"2", "arcsec"}]]}], "/.", "ruru"}]}], ",", 
    "\"\< \[Mu]as\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"side", "=", 
    RowBox[{"pixel", " ", 
     FractionBox["nxy", "2"]}]}], 
   RowBox[{"(*", 
    RowBox[{"\[Mu]as", " ", "-", " ", 
     RowBox[{"from", " ", "center", " ", "to", " ", "edge"}]}], "*)"}], ";", 
   RowBox[{"Print", "[", 
    RowBox[{"\"\<Center-edge angle in rad = \>\"", ",", 
     RowBox[{"a", "=", 
      RowBox[{"side", 
       FractionBox[
        RowBox[{"2.", "\[Pi]"}], 
        RowBox[{"360", " ", "60", " ", "60"}]], " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "6"}]]}]}]}], "]"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"a", " ", "of", " ", "mabase", " ", "G\[Lambda]"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mabase", "=", "7"}], ";", 
  RowBox[{"bb", "=", 
   RowBox[{"mabase", " ", 
    SuperscriptBox["10", "9."]}]}], ";", 
  RowBox[{"step", "=", 
   RowBox[{"2", 
    FractionBox["bb", "nxy"]}]}], ";", 
  RowBox[{"ran", "=", 
   RowBox[{"Range", "[", 
    RowBox[{
     RowBox[{"-", "bb"}], ",", "bb", ",", "step"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res2D", "=", 
   FractionBox[
    RowBox[{"Total", "[", "furtab05", "]"}], "ind"]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"inter05", "=", 
    RowBox[{"ListInterpolation", "[", 
     RowBox[{"res2D", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "mabase"}], ",", "mabase"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "mabase"}], ",", "mabase"}], "}"}]}], "}"}]}], "]"}]}],
    ";", 
   RowBox[{"Nin05", "=", 
    RowBox[{"inter05", "[", 
     RowBox[{"0", ",", "0"}], "]"}]}], ";", 
   RowBox[{"flux0", "=", "2.637"}], ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Theta]sc", "=", 
   RowBox[{"170", "\[Degree]"}]}], ";", 
  RowBox[{"dir", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"90", "-", 
      RowBox[{
       FractionBox["180", "\[Pi]"], 
       RowBox[{"ArcTan", "[", 
        FractionBox["1.33", "3.5"], "]"}]}]}], ")"}], "\[Degree]"}]}], ";", 
  RowBox[{"mysize", "=", "20"}], ";", 
  RowBox[{"expr", "=", 
   RowBox[{
    RowBox[{
     FractionBox["flux0", "Nin05"], 
     RowBox[{"inter05", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"y", " ", 
         RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "-", 
        RowBox[{"x", " ", 
         RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}], ",", 
       RowBox[{
        RowBox[{"x", " ", 
         RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "+", 
        RowBox[{"y", " ", 
         RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}]}], "]"}], 
     SuperscriptBox["2", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"y", " ", 
             RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "-", 
            RowBox[{"x", " ", 
             RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "7"], ")"}], "2"]}],
        "-", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           RowBox[{"x", " ", 
            RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "+", 
           RowBox[{"y", " ", 
            RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "3.8"], ")"}], 
        "2"]}]]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", "\[Rule]", 
       RowBox[{
        RowBox[{"-", "t"}], " ", 
        RowBox[{"Sin", "[", "dir", "]"}]}]}], ",", 
      RowBox[{"y", "\[Rule]", 
       RowBox[{"t", " ", 
        RowBox[{"Cos", "[", "dir", "]"}]}]}]}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"min05", "=", 
    RowBox[{"Minimize", "[", 
     RowBox[{
      RowBox[{"expr", "/.", 
       RowBox[{"t", "\[Rule]", "3.5"}]}], ",", "\[Xi]"}], "]"}]}], ",", 
   RowBox[{"max05", "=", 
    RowBox[{"Maximize", "[", 
     RowBox[{
      RowBox[{"expr", "/.", 
       RowBox[{"t", "\[Rule]", "3.5"}]}], ",", "\[Xi]"}], "]"}]}]}], 
  "}"}], "\n", 
 RowBox[{
  RowBox[{"totf", "=", 
   RowBox[{
    RowBox[{
     FractionBox["flux0", "Nin05"], 
     RowBox[{"inter05", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"y", " ", 
         RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "-", 
        RowBox[{"x", " ", 
         RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}], ",", 
       RowBox[{
        RowBox[{"x", " ", 
         RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "+", 
        RowBox[{"y", " ", 
         RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}]}], "]"}], 
     SuperscriptBox["2", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"y", " ", 
             RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "-", 
            RowBox[{"x", " ", 
             RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "7"], ")"}], "2"]}],
        "-", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           RowBox[{"x", " ", 
            RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "+", 
           RowBox[{"y", " ", 
            RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "3.8"], ")"}], 
        "2"]}]]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", "\[Rule]", 
       RowBox[{
        RowBox[{"-", "t"}], " ", 
        RowBox[{"Sin", "[", "dir", "]"}]}]}], ",", 
      RowBox[{"y", "\[Rule]", 
       RowBox[{"t", " ", 
        RowBox[{"Cos", "[", "dir", "]"}]}]}]}], "}"}]}]}], ";", 
  RowBox[{"sizepl05", "=", 
   RowBox[{"LogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"totf", "/.", 
        RowBox[{"min05", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", 
       RowBox[{"totf", "/.", 
        RowBox[{"max05", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}], 
     RowBox[{"(*", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"totf", "/.", 
         RowBox[{"\[Xi]", "\[Rule]", "1."}]}], ",", 
        RowBox[{"totf", "/.", 
         RowBox[{"\[Xi]", "\[Rule]", "2.5"}]}]}], "}"}], "*)"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "4"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0.1", ",", "3.0"}], "}"}]}], ",", 
     RowBox[{"Epilog", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "3", "]"}], ",", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3.5", ",", 
             RowBox[{"Log", "[", "0.25", "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3.5", ",", 
             RowBox[{"Log", "[", "0.47", "]"}]}], "}"}]}], "}"}], "]"}]}], 
       "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"AbsoluteThickness", "[", "3", "]"}], ",", "Red"}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"AbsoluteThickness", "[", "3", "]"}], ",", "Blue"}], 
         "}"}]}], "}"}]}], ",", 
     RowBox[{"FrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\"", ",", "Null"}],
          "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "\"\<baseline [G\[Lambda]]\>\"", ",", 
          "\"\<Correlated flux vs. baseline\>\""}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "3", "]"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", "\"\<Arial\>\"", ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sizepl", "=", 
   RowBox[{"Show", "[", "sizepl05", "]"}]}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"\[Theta]sc", "=", 
     RowBox[{"170", "\[Degree]"}]}], ";", 
    RowBox[{"dir", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"90", "-", 
        RowBox[{
         FractionBox["180", "\[Pi]"], 
         RowBox[{"ArcTan", "[", 
          FractionBox["1.33", "3.5"], "]"}]}]}], ")"}], "\[Degree]"}]}], ";", 
    RowBox[{"expr", "=", 
     RowBox[{
      RowBox[{
       FractionBox["flux0", "Nin09"], 
       RowBox[{"inter09", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"y", " ", 
           RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "-", 
          RowBox[{"x", " ", 
           RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}], ",", 
         RowBox[{
          RowBox[{"x", " ", 
           RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "+", 
          RowBox[{"y", " ", 
           RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}]}], "]"}], 
       SuperscriptBox["2", 
        RowBox[{
         RowBox[{"-", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox[
             RowBox[{
              RowBox[{"y", " ", 
               RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "-", 
              RowBox[{"x", " ", 
               RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "7"], ")"}], 
           "2"]}], "-", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"x", " ", 
              RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "+", 
             RowBox[{"y", " ", 
              RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "3.8"], ")"}], 
          "2"]}]]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x", "\[Rule]", 
         RowBox[{
          RowBox[{"-", "t"}], " ", 
          RowBox[{"Sin", "[", "dir", "]"}]}]}], ",", 
        RowBox[{"y", "\[Rule]", 
         RowBox[{"t", " ", 
          RowBox[{"Cos", "[", "dir", "]"}]}]}]}], "}"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"min09", "=", 
        RowBox[{"Minimize", "[", 
         RowBox[{
          RowBox[{"expr", "/.", 
           RowBox[{"t", "\[Rule]", "3.5"}]}], ",", "\[Xi]"}], "]"}]}], ",", 
       RowBox[{"max09", "=", 
        RowBox[{"Maximize", "[", 
         RowBox[{
          RowBox[{"expr", "/.", 
           RowBox[{"t", "\[Rule]", "3.5"}]}], ",", "\[Xi]"}], "]"}]}]}], 
      "}"}], "\n", 
     RowBox[{"totf", "=", 
      RowBox[{
       RowBox[{
        FractionBox["flux0", "Nin09"], 
        RowBox[{"inter09", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"y", " ", 
            RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "-", 
           RowBox[{"x", " ", 
            RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}], ",", 
          RowBox[{
           RowBox[{"x", " ", 
            RowBox[{"Cos", "[", "\[Xi]", "]"}]}], "+", 
           RowBox[{"y", " ", 
            RowBox[{"Sin", "[", "\[Xi]", "]"}]}]}]}], "]"}], 
        SuperscriptBox["2", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"y", " ", 
                RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "-", 
               RowBox[{"x", " ", 
                RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "7"], ")"}], 
            "2"]}], "-", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox[
             RowBox[{
              RowBox[{"x", " ", 
               RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "+", 
              RowBox[{"y", " ", 
               RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "3.8"], ")"}], 
           "2"]}]]}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"x", "\[Rule]", 
          RowBox[{
           RowBox[{"-", "t"}], " ", 
           RowBox[{"Sin", "[", "dir", "]"}]}]}], ",", 
         RowBox[{"y", "\[Rule]", 
          RowBox[{"t", " ", 
           RowBox[{"Cos", "[", "dir", "]"}]}]}]}], "}"}]}]}]}], ";", 
    RowBox[{"sizepl09", "=", 
     RowBox[{"LogPlot", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"totf", "/.", 
          RowBox[{"min09", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", 
         RowBox[{"totf", "/.", 
          RowBox[{"max09", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}], 
       RowBox[{"(*", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"totf", "/.", 
           RowBox[{"\[Xi]", "\[Rule]", "1."}]}], ",", 
          RowBox[{"totf", "/.", 
           RowBox[{"\[Xi]", "\[Rule]", "2.5"}]}]}], "}"}], "*)"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "0", ",", "4"}], "}"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0.1", ",", "2.5"}], "}"}]}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Thick", ",", 
          RowBox[{"Line", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"3.5", ",", 
               RowBox[{"Log", "[", "0.25", "]"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"3.5", ",", 
               RowBox[{"Log", "[", "0.47", "]"}]}], "}"}]}], "}"}], "]"}]}], 
         "}"}]}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AbsoluteThickness", "[", "3", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", 
             RowBox[{"{", 
              RowBox[{"5", ",", "4"}], "}"}], "]"}], ",", "Red"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AbsoluteThickness", "[", "3", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", 
             RowBox[{"{", 
              RowBox[{"5", ",", "4"}], "}"}], "]"}], ",", "Blue"}], "}"}]}], 
         "}"}]}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) [Jy]\>\"", ",", 
            "Null"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
           "\"\<baseline [G\[Lambda]]\>\"", ",", 
            "\"\<Correlated flux vs. baseline\>\""}], "}"}]}], "}"}]}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "3", "]"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"18", ",", "\"\<Arial\>\"", ",", 
          RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "}"}]}]}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"sizepl", "=", 
     RowBox[{"Show", "[", 
      RowBox[{"{", 
       RowBox[{"sizepl05", ",", "sizepl09"}], "}"}], "]"}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{
     "\"\<C:\\\\study\\\\accretion\\\\! 2009 3fall cfa\\\\GR Polarized \
modeling\\\\!svn\\\\\>\"", "<>", "\"\<sizepl.eps\>\""}], ",", "sizepl"}], 
    "]"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Suppression due to scattering = \>\"", ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox["2", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"y", " ", 
             RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "-", 
            RowBox[{"x", " ", 
             RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "7"], ")"}], "2"]}],
        "-", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           RowBox[{"x", " ", 
            RowBox[{"Cos", "[", "\[Theta]sc", "]"}]}], "+", 
           RowBox[{"y", " ", 
            RowBox[{"Sin", "[", "\[Theta]sc", "]"}]}]}], "3.8"], ")"}], 
        "2"]}]], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x", "\[Rule]", 
        RowBox[{
         RowBox[{"-", "t"}], " ", 
         RowBox[{"Sin", "[", "dir", "]"}]}]}], ",", 
       RowBox[{"y", "\[Rule]", 
        RowBox[{"t", " ", 
         RowBox[{"Cos", "[", "dir", "]"}]}]}]}], "}"}]}], "/.", 
    RowBox[{"t", "\[Rule]", "3.5"}]}], ",", 
   "\"\< at 3.5G\[Lambda] in Fourier\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.5292588713003416`*^9, 3.529258875676592*^9}, {
   3.5292589076084185`*^9, 3.5292590304144425`*^9}, {3.5293210806553364`*^9, 
   3.52932108614265*^9}, 3.529321193296779*^9, {3.5293214012826753`*^9, 
   3.5293214986862464`*^9}, {3.5403011444271536`*^9, 3.540301148494386*^9}, {
   3.5403036543837147`*^9, 3.54030365465073*^9}}],

Cell[BoxData["1"], "Input",
 CellChangeTimes->{{3.509452743145*^9, 3.509452746868*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["tests for fast DFT (Discrete Fourier Transform)", "Subsubsection",
 CellChangeTimes->{{3.502541219697*^9, 3.5025412402578*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "namefile", "=", 
   "\"\<E:\\\\mathematica\\\\analysis\\\\size\\\\1\\\\shotimag50th188fn-1boo.\
dat\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fi11", "=", 
   RowBox[{"OpenRead", "[", 
    RowBox[{"namefile", ",", 
     RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
  RowBox[{"params", "=", 
   RowBox[{"BinaryReadList", "[", 
    RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"th", "=", 
   RowBox[{
    RowBox[{"Round", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[Pi]", "-", 
        RowBox[{"params", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "1000"}], "]"}], "/", 
    "1000."}]}], ";", 
  RowBox[{"nxy", "=", 
   RowBox[{"Round", "[", 
    RowBox[{"params", "[", 
     RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"nu", "=", 
   RowBox[{"Round", "[", 
    RowBox[{"params", "[", 
     RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"maxy", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "5", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"heat", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "6", "]"}], "]"}]}], ";", 
  RowBox[{"rnohor", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "7", "]"}], "]"}]}], ";", 
  RowBox[{"inten", "=", 
   RowBox[{"BinaryReadList", "[", 
    RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
  RowBox[{"partres", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"Partition", "[", 
      RowBox[{"inten", ",", "5"}], "]"}], ",", 
     RowBox[{"nxy", "+", "1"}]}], "]"}]}], ";", 
  RowBox[{"Close", "[", "fi11", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dat", "=", 
    RowBox[{"Reverse", "[", 
     RowBox[{
      RowBox[{"partres", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], ",", "2"}], 
     "]"}]}], ";", 
   RowBox[{"nn", "=", 
    RowBox[{"nxy", "+", "1"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"dat", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"-", "5"}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"2", "x"}], "nn"], "-", "1"}], ")"}], "2"]}], "]"}], 
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"-", "7"}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"2", "y"}], "nn"], "-", "1"}], ")"}], "2"]}], "]"}]}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", "nn"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "nn"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ruru", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rg", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "6.67", " ", 
        SuperscriptBox["10", 
         RowBox[{"-", "8"}]], "4.5", " ", 
        SuperscriptBox["10", "6"], "2", " ", 
        SuperscriptBox["10", "33"]}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"3", " ", 
          SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
     RowBox[{"arcsec", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
        SuperscriptBox["10", "3"], "3.08", " ", 
        SuperscriptBox["10", "18"]}], 
       RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
     RowBox[{"pc", "\[Rule]", 
      RowBox[{"3.08", " ", 
       SuperscriptBox["10", "18"]}]}], ",", 
     RowBox[{"year", "\[Rule]", 
      RowBox[{"365.35", " ", "86400"}]}], ",", 
     RowBox[{"cc", "\[Rule]", 
      RowBox[{"3.", " ", 
       SuperscriptBox["10", "10"]}]}], ",", 
     RowBox[{"Msun", "\[Rule]", 
      RowBox[{"2.", " ", 
       SuperscriptBox["10", "33"]}]}], ",", 
     RowBox[{"mp", "\[Rule]", 
      RowBox[{"1.26", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "24"}]]}]}], ",", 
     RowBox[{"me", "\[Rule]", 
      RowBox[{"9.1", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "28"}]]}]}], ",", 
     RowBox[{"kb", "\[Rule]", 
      RowBox[{"1.38", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "16"}]]}]}], ",", 
     RowBox[{"h", "\[Rule]", 
      RowBox[{"6.626", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "27"}]]}]}], ",", 
     RowBox[{"ee", "\[Rule]", 
      RowBox[{"4.8", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "10"}]]}]}], ",", 
     RowBox[{"keV", "->", 
      RowBox[{"1000", " ", "1.602", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<1 pixel = \>\"", ",", 
    RowBox[{"pixel", "=", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"2", "maxy"}], "nxy"], 
       SuperscriptBox["10", "6"], 
       FractionBox["rg", 
        RowBox[{"2", "arcsec"}]]}], "/.", "ruru"}]}], ",", 
    "\"\< \[Mu]as\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"side", "=", 
    RowBox[{"pixel", " ", 
     FractionBox["nxy", "2"]}]}], 
   RowBox[{"(*", 
    RowBox[{"\[Mu]as", " ", "-", " ", 
     RowBox[{"from", " ", "center", " ", "to", " ", "edge"}]}], "*)"}], ";", 
   RowBox[{"Print", "[", 
    RowBox[{"\"\<Center-edge angle in rad = \>\"", ",", 
     RowBox[{"a", "=", 
      RowBox[{"side", 
       FractionBox[
        RowBox[{"2.", "\[Pi]"}], 
        RowBox[{"360", " ", "60", " ", "60"}]], " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "6"}]]}]}]}], "]"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"a", " ", "of", " ", "mabase", " ", "G\[Lambda]"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mabase", "=", "7"}], ";", 
  RowBox[{"bb", "=", 
   RowBox[{"mabase", " ", 
    SuperscriptBox["10", "9."]}]}], ";", 
  RowBox[{"step", "=", 
   RowBox[{"2", 
    FractionBox["bb", "nxy"]}]}], ";", 
  RowBox[{"ran", "=", 
   RowBox[{"Range", "[", 
    RowBox[{
     RowBox[{"-", "bb"}], ",", "bb", ",", "step"}], "]"}]}], ";", 
  RowBox[{"Dimensions", "[", "dat", "]"}], ";", 
  RowBox[{"Dimensions", "[", "ran", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DFT2D", "[", 
   RowBox[{"m_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"dat", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"k", "+", 
         FractionBox["nn", "2"]}], ",", 
        RowBox[{"l", "+", 
         FractionBox["nn", "2"]}]}], "]"}], "]"}], " ", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]", " ", "m", " ", 
       FractionBox[
        RowBox[{"2", "a", " ", "k"}], "nn"]}], "]"}], 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]", " ", "n", 
       FractionBox[
        RowBox[{"2", "a", " ", "l"}], "nn"]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{
       FractionBox[
        RowBox[{"-", "nn"}], "2"], "+", "1"}], ",", 
      FractionBox["nn", "2"]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"l", ",", 
      RowBox[{
       FractionBox[
        RowBox[{"-", "nn"}], "2"], "+", "1"}], ",", 
      FractionBox["nn", "2"]}], "}"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"res2D", "=", 
   RowBox[{"Abs", "[", 
    RowBox[{
     RowBox[{"DFT2D", "[", 
      RowBox[{"ran", ",", "n"}], "]"}], "/.", 
     RowBox[{"n", "\[Rule]", "ran"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListDensityPlot", "[", "res2D", "]"}], ",", 
     RowBox[{"ListDensityPlot", "[", "dat", "]"}]}], "}"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"wide", " ", "in", " ", "y", " ", "direction"}], ",", " ", 
    RowBox[{"narrow", " ", "in", " ", "x", " ", "direction"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5025412617234*^9, 3.5025412620042*^9}, {
  3.5025450675338*^9, 3.5025450768782*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DFT1D", "[", "m_", "]"}], ":=", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"dat", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"k", "+", 
           FractionBox["nn", "2"]}], ",", 
          FractionBox["nn", "2"]}], "]"}], "]"}], " ", 
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]", " ", "m", " ", 
         FractionBox[
          RowBox[{"2", "bb"}], "nn"], " ", 
         FractionBox[
          RowBox[{"2", "a", " ", "k"}], "nn"]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{
         FractionBox[
          RowBox[{"-", "nn"}], "2"], "+", "1"}], ",", 
        FractionBox["nn", "2"]}], "}"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    FractionBox["1", 
     SqrtBox[
      StyleBox["n", "TI"]]], " ", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{"Exp", "[", 
         FractionBox[
          RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", 
           RowBox[{"(", 
            RowBox[{
             StyleBox["r", "TI"], "-", "1"}], ")"}], 
           RowBox[{"(", 
            RowBox[{
             StyleBox["s", "TI"], "-", "1"}], ")"}]}], "n"], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"r", ",", "1", ",", "n"}], "}"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"s", ",", "1", ",", "n"}], "}"}]}], "]"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DFT1Dx", ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"dat", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"k", "+", 
            FractionBox["nn", "2"]}], ",", 
           FractionBox["nn", "2"]}], "]"}], "]"}], " ", 
        RowBox[{"Exp", "[", 
         RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", " ", "m", " ", 
          FractionBox[
           RowBox[{"2", "bb"}], "nn"], " ", 
          FractionBox[
           RowBox[{"2", "a", " ", "k"}], "nn"]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", 
         RowBox[{
          FractionBox[
           RowBox[{"-", "nn"}], "2"], "+", "1"}], ",", 
         FractionBox["nn", "2"]}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"m", ",", 
       RowBox[{"-", 
        FractionBox["nn", "2"]}], ",", 
       FractionBox["nn", "2"]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DFT1Z", ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"dat", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"r", "+", 
            FractionBox["nn", "2"]}], ",", 
           FractionBox["nn", "2"]}], "]"}], "]"}], 
        RowBox[{"Exp", "[", 
         RowBox[{
          FractionBox[
           RowBox[{"4", "bb", " ", "a"}], "nn"], 
          FractionBox[
           RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", " ", 
            StyleBox["r", "TI"], 
            StyleBox[" ", "TI"], 
            StyleBox["s", "TI"]}], "nn"]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ",", 
         RowBox[{
          FractionBox[
           RowBox[{"-", "nn"}], "2"], "+", "1"}], ",", 
         FractionBox["nn", "2"]}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"s", ",", "1", ",", "nn"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res1D", "=", 
   RowBox[{"Abs", "[", 
    RowBox[{"DFT1D", "[", 
     RowBox[{"Range", "[", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["nn", "2"]}], ",", 
       FractionBox["nn", "2"]}], "]"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res1Dx", "=", 
   RowBox[{"Abs", "[", "DFT1Dx", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fur", "=", 
   RowBox[{
    RowBox[{"Fourier", "[", 
     RowBox[{
      RowBox[{"dat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", 
         FractionBox["nn", "2"]}], "]"}], "]"}], ",", 
      RowBox[{"FourierParameters", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         FractionBox[
          RowBox[{"4", "bb", " ", "a"}], "nn"]}], "}"}]}]}], "]"}], "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", 
      FractionBox["nn", "2"]}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res1Z", "=", 
   RowBox[{"Abs", "[", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"Reverse", "[", "fur", "]"}], ",", "fur"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res1Zx", "=", 
   RowBox[{"Abs", "[", "DFT1Z", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ListPlot", "[", "res1D", "]"}], ",", 
    RowBox[{"ListPlot", "[", "res1Dx", "]"}], ",", 
    RowBox[{"ListPlot", "[", "res1Z", "]"}], ",", 
    RowBox[{"ListPlot", "[", "res1Zx", "]"}]}], "}"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{"{", 
   RowBox[{"res1D", ",", "res1Z"}], "}"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5025424387536*^9, 3.5025424589712*^9}, {
   3.5025425383596*^9, 3.5025426058608*^9}, {3.502542652458*^9, 
   3.5025428613732*^9}, {3.5025429246*^9, 3.5025430045656*^9}, {
   3.5025431014658003`*^9, 3.502543242365*^9}, {3.5025432731906*^9, 
   3.5025434245262003`*^9}, {3.5025434632454*^9, 3.502543535957*^9}, 
   3.502543567547*^9, {3.502543635953*^9, 3.5025437712206*^9}, {
   3.5025438069758*^9, 3.5025438142922*^9}, {3.5025438721214*^9, 
   3.5025440047058*^9}, {3.5025441742622004`*^9, 3.5025442270682*^9}, {
   3.5025443154890003`*^9, 3.502544317361*^9}, {3.5025445646678*^9, 
   3.5025445648705997`*^9}, {3.5025446099234*^9, 3.502544635679*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"res1Z", "=", 
   RowBox[{"Abs", "[", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"Reverse", "[", "fur", "]"}], ",", "fur"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rere", "=", 
   RowBox[{"Abs", "[", "DFT2D", "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5025443214326*^9, 3.5025444030518*^9}, {
  3.5025446524178*^9, 3.502544674289*^9}, {3.5025447315566*^9, 
  3.5025447338498*^9}, {3.5025447750962*^9, 3.5025447801038*^9}, {
  3.502545127469*^9, 3.502545128639*^9}}],

Cell[BoxData[{
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"fur", "=", 
    RowBox[{"Abs", "[", 
     RowBox[{"Fourier", "[", 
      RowBox[{"dat", ",", 
       RowBox[{"FourierParameters", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", 
          FractionBox[
           RowBox[{"4", "bb", " ", "a"}], "nn"]}], "}"}]}]}], "]"}], "]"}]}], 
   ";"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ListDensityPlot", "[", "fur", "]"}]}], "Input",
 CellChangeTimes->{
  3.5025452432054*^9, {3.5025454117321997`*^9, 3.502545420749*^9}, {
   3.5025455595422*^9, 3.5025455679505997`*^9}, {3.5025457038733997`*^9, 
   3.5025457139821997`*^9}, {3.5025458108426*^9, 3.5025458936162*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Estimating best \[Theta] (Figure 13) - ",
 StyleBox["deleted",
  FontColor->RGBColor[1, 0, 0]]
}], "Subsection",
 CellChangeTimes->{{3.529321674767318*^9, 3.5293216761423965`*^9}, {
  3.529321842109889*^9, 3.529321842245897*^9}, {3.52932783337214*^9, 
  3.52932783425919*^9}, {3.5399937967258835`*^9, 3.539993798153965*^9}}],

Cell[CellGroupData[{

Cell["new confidence intervals", "Subsubsection",
 CellChangeTimes->{{3.529322342825528*^9, 3.5293223469617653`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"new", " ", "data"}], "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{"tofit", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"8.450", ",", "0.6898", ",", "0", ",", "0", ",", 
         RowBox[{"-", "0.2500"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"14.90", ",", "0.9044", ",", "0", ",", "0", ",", 
         RowBox[{"-", "0.6200"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "22.50", ",", "1.070", ",", "0.1900", ",", "131.0", ",", "0"}], "}"}],
        ",", 
       RowBox[{"{", 
        RowBox[{
        "43.00", ",", "1.159", ",", "0.5041", ",", "94.25", ",", "0"}], "}"}],
        ",", 
       RowBox[{"{", 
        RowBox[{"87.73", ",", "1.841", ",", "1.42", ",", 
         RowBox[{"-", "4."}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"102.0", ",", "1.908", ",", "0", ",", "0", ",", "0"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"145.0", ",", "2.275", ",", "0", ",", "0", ",", "0"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"230.9", ",", "2.637", ",", "7.40", ",", "111.5", ",", 
         RowBox[{"-", "1.200"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"349.0", ",", "3.181", ",", "6.50", ",", "146.9", ",", 
         RowBox[{"-", "1.500"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"674.0", ",", "3.286", ",", "0", ",", "0", ",", "0"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"857.0", ",", "2.867", ",", "0", ",", "0", ",", "0"}], 
        "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", " ", 
   RowBox[{
    RowBox[{"dFnu", "=", 
     RowBox[{"{", 
      RowBox[{
      "1.", ",", "1.", ",", "1.", ",", "1.", ",", "0.080", ",", "0.1517", ",",
        "0.2644", ",", "0.1414", ",", "0.1205", ",", "0.3508", ",", 
       "0.2404"}], "}"}]}], ";", 
    RowBox[{"dCP", "=", "0.30"}], ";", 
    RowBox[{"dLP", "=", 
     RowBox[{"{", 
      RowBox[{"0.5", ",", "0.66", ",", "0.61"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Clear", "[", 
     RowBox[{"nh", ",", "co"}], "]"}], ";", 
    RowBox[{"ext", "=", "1."}], ";", 
    RowBox[{"acc", "=", "16"}], ";", 
    RowBox[{"inord", "=", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], ";", 
    RowBox[{"poi3", "=", "50000"}], ";", 
    RowBox[{"Off", "[", 
     RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], "]"}], ";", 
    RowBox[{"t", "=", 
     RowBox[{"TimeUsed", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"SetOptions", "[", 
      RowBox[{"NIntegrate", ",", 
       RowBox[{"Method", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
          RowBox[{"Method", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
             RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}],
        ",", 
       RowBox[{"MaxPoints", "\[Rule]", "poi3"}], ",", 
       RowBox[{"AccuracyGoal", "\[Rule]", "acc"}]}], "]"}], ";"}], "*)"}], 
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"NIntegrate", ",", 
      RowBox[{"Method", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
         RowBox[{"Method", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
            RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
      ",", 
      RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"co", "=", "0"}], ";", 
    RowBox[{"thlen", "=", "50"}], ";", 
    RowBox[{"sptab", "=", 
     RowBox[{"{", 
      RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], 
      "}"}]}], ";", 
    RowBox[{"narr", "=", "1.1"}], ";", 
    RowBox[{"nF", "=", "7"}], ";", 
    RowBox[{"nP", "=", "12"}], ";", 
    RowBox[{"avg", "=", "False"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Do", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"gat", "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"th", "=", 
             RowBox[{
              FractionBox["\[Pi]", "thlen"], 
              RowBox[{"(", 
               RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
            RowBox[{"Import", "[", 
             RowBox[{
             "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\\
ava\>\"", "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"Round", "[", 
                RowBox[{"100", 
                 RowBox[{"sptab", "[", 
                  RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
              "\"\<th\>\"", "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"Floor", "[", 
                RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<in11\>\"", 
              "<>", "\"\<.dat\>\""}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"flen", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Position", "[", 
          RowBox[{
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"1", ";;", "11"}], ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}]}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
      RowBox[{"Off", "[", 
       RowBox[{
        RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
        RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"gat", "=", 
       RowBox[{"Partition", "[", 
        RowBox[{"gat", ",", "flen"}], "]"}]}], ";", 
      RowBox[{"rholen", "=", 
       RowBox[{"Length", "[", 
        RowBox[{"Position", "[", 
         RowBox[{
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "6"}], "]"}],
            "]"}], ",", 
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1", ",", "1", ",", "6"}], "]"}], "]"}]}], 
         "]"}], "]"}]}], ";", 
      RowBox[{"gat", "=", 
       RowBox[{"Partition", "[", 
        RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", 
      RowBox[{"dim", "=", 
       RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", 
      RowBox[{"hlen", "=", 
       RowBox[{"dim", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", 
      RowBox[{"hmin", "=", 
       RowBox[{"Log", "[", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "6"}], 
          "]"}], "]"}], "]"}]}], ";", 
      RowBox[{"hmax", "=", 
       RowBox[{"Log", "[", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "6"}], "]"}], "]"}],
         "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"thmin", "=", 
       RowBox[{
        FractionBox["\[Pi]", "thlen"], 
        RowBox[{"(", 
         RowBox[{"1", "-", ".5"}], ")"}]}]}], ";", 
      RowBox[{"thmax", "=", 
       RowBox[{"\[Pi]", "-", "thmin"}]}], ";", 
      RowBox[{"rhomax", "=", 
       RowBox[{"Log", "[", 
        FractionBox[
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "7"}], "]"}], "]"}], 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"flen", "+", "1"}], ")"}], "/", "2"}], ",", "1", ",", 
            "1", ",", "7"}], "]"}], "]"}]], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"rateint", "=", 
         RowBox[{"ListInterpolation", "[", 
          RowBox[{
           RowBox[{"Log", "[", 
            RowBox[{"gat", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], 
              "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], 
        ";"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"raterho", "=", 
       RowBox[{"ListInterpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "7"}], "]"}], 
           "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"flux", "[", "i", "]"}], "=", 
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "All", ",", "i", ",", "All", ",", "2"}], 
            "]"}], "]"}]}], ";", 
         RowBox[{
          RowBox[{
           RowBox[{"iflux", "[", "i", "]"}], "[", "sp", "]"}], "=", 
          RowBox[{"ListInterpolation", "[", 
           RowBox[{
            RowBox[{"flux", "[", "i", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
            RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}]}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "flen"}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"LP", "[", "1", "]"}], "=", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", 
          RowBox[{"-", "7"}], ",", "All", ",", "3"}], "]"}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"LP", "[", "2", "]"}], "=", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", 
          RowBox[{"-", "4"}], ",", "All", ",", "3"}], "]"}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"LP", "[", "3", "]"}], "=", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", 
          RowBox[{"-", "3"}], ",", "All", ",", "3"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"CP", "[", "1", "]"}], "=", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", 
          RowBox[{"-", "4"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"CP", "[", "2", "]"}], "=", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", 
          RowBox[{"-", "3"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"iCPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
         RowBox[{"ListInterpolation", "[", 
          RowBox[{
           RowBox[{"CP", "[", "i", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
           RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"iLPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
         RowBox[{"ListInterpolation", "[", 
          RowBox[{
           RowBox[{"LP", "[", "i", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
           RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"lipFnux", "[", "sp", "]"}], "=", 
       RowBox[{"Total", "[", 
        FractionBox[
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             RowBox[{"tofit", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                "2"}], "]"}], "]"}], "-", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                 RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                "&"}], "/@", 
               RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], 
            RowBox[{"dFnu", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
             "]"}]], ")"}], "2"], 
         RowBox[{"nF", "-", "3"}]], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "=", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"nP", "-", "3"}]], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Total", "[", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"tofit", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                   "2"}], "]"}], "]"}], "-", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                   "&"}], "/@", 
                  RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], ")"}], "/", 
              RowBox[{"dFnu", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
               "]"}]}], ")"}], "2"], "]"}], "+", 
          RowBox[{"Total", "[", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              FractionBox["1", "dCP"], 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"tofit", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"iCPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                   "&"}], "/@", 
                  RowBox[{"Range", "[", "2", "]"}]}], ")"}]}], ")"}]}], ")"}],
             "2"], "]"}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"tofit", "[", 
                RowBox[{"[", 
                 RowBox[{"5", ",", "3"}], "]"}], "]"}], "-", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"iLPx", "[", "1", "]"}], "[", "sp", "]"}], "[", 
                 RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                ")"}]}], ")"}], 
             RowBox[{"dLP", "[", 
              RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
          RowBox[{"Total", "[", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"tofit", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "-", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"iLPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                   "&"}], "/@", 
                  RowBox[{"{", 
                   RowBox[{"2", ",", "3"}], "}"}]}], ")"}]}], ")"}], "/", 
              RowBox[{"dLP", "[", 
               RowBox[{"[", 
                RowBox[{"2", ";;", "3"}], "]"}], "]"}]}], ")"}], "2"], 
           "]"}]}], ")"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Fdistx", "=", 
       RowBox[{
        RowBox[{"PDF", "[", 
         RowBox[{
          RowBox[{"ChiSquareDistribution", "[", 
           RowBox[{"nF", "-", "3"}], "]"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"nF", "-", "3"}], ")"}], " ", 
           RowBox[{"lipFnux", "[", "sp", "]"}]}]}], "]"}], 
        RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Ldistx", "=", 
       RowBox[{
        RowBox[{"PDF", "[", 
         RowBox[{
          RowBox[{"ChiSquareDistribution", "[", 
           RowBox[{"nP", "-", "3"}], "]"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"nP", "-", "3"}], ")"}], " ", 
           RowBox[{"lipFnuCPLPx", "[", "sp", "]"}]}]}], "]"}], 
        RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"sp", ",", "2", ",", "2"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.529322414239613*^9, 3.5293224199839416`*^9}, {
  3.5293227545270767`*^9, 3.5293227680478497`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"poi2", "=", "5000"}], 
  RowBox[{"(*", 
   RowBox[{"enough", " ", "resolution", " ", "for", " ", "2", "D"}], "*)"}], 
  ";", 
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{"Dynamic", "[", "sp", "]"}], ",", "\"\< \>\"", ",", 
    RowBox[{"Dynamic", "[", "thn", "]"}]}], "]"}], ";", 
  RowBox[{"xxlen", "=", "100"}], ";", 
  RowBox[{"\[Theta]min", "=", 
   RowBox[{"0.5", 
    FractionBox["\[Pi]", "xxlen"]}]}], ";", 
  RowBox[{"\[Theta]max", "=", 
   RowBox[{"\[Pi]", "-", "thmin"}]}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "\"\<ncvb\>\""}], "]"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Theta]FCPLP", "[", "sp", "]"}], "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"th", "=", 
          RowBox[{
           FractionBox["\[Pi]", "xxlen"], 
           RowBox[{"(", 
            RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
         RowBox[{"{", 
          RowBox[{"th", ",", 
           RowBox[{
            RowBox[{"ni", "=", 
             RowBox[{"Log", "[", 
              RowBox[{"NIntegrate", "[", 
               RowBox[{
                RowBox[{"Fdistx", 
                 RowBox[{"(*", "Ldistx", "*)"}], "/.", 
                 RowBox[{"\[Theta]", "\[Rule]", "th"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"rhonor", ",", 
                  RowBox[{
                   RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                  RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
                RowBox[{"Method", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
                   RowBox[{"Method", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
                    RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], 
                  "}"}]}], ",", 
                RowBox[{"MaxPoints", "\[Rule]", "poi2"}]}], "]"}], "]"}]}], 
            ";", "ni"}]}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"thn", ",", "xxlen"}], "}"}]}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"inFCPLP", "[", "sp", "]"}], "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{"\[Theta]FCPLP", "[", "sp", "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"FCPLPnorm", "[", "sp", "]"}], "=", 
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"inFCPLP", "[", "sp", "]"}], "[", "\[Theta]", "]"}], "]"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "\[Theta]min", ",", "\[Theta]max"}], 
         "}"}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"sp", ",", "2", ",", "2"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.4864805415550003`*^9, 3.4864806861514*^9}, {
   3.4864807478494*^9, 3.4864808731642*^9}, {3.4864809448774*^9, 
   3.4864809701338*^9}, {3.4864812881242*^9, 3.4864813188873997`*^9}, {
   3.4864814235165997`*^9, 3.4864814286334*^9}, {3.4864824314014*^9, 
   3.4864824422278*^9}, {3.4864825846714*^9, 3.4864825896166*^9}, {
   3.4864826420014*^9, 3.4864827413733997`*^9}, {3.4864828780294*^9, 
   3.4864828791214*^9}, {3.4864830349997997`*^9, 3.4864830437202*^9}, 
   3.486484779027*^9, {3.486485808914*^9, 3.486485809*^9}, {3.50306406459*^9, 
   3.503064145413*^9}, {3.503064234778*^9, 3.50306425959*^9}, {
   3.503064405784*^9, 3.503064406451*^9}, {3.503064508274*^9, 
   3.503064508376*^9}, {3.503064571874*^9, 3.503064580869*^9}, {
   3.503069387369*^9, 3.503069391283*^9}, {3.5030694476070004`*^9, 
   3.503069452894*^9}, {3.50306968624*^9, 3.50306970431*^9}, {
   3.5030699119519997`*^9, 3.5030699139700003`*^9}, {3.5030700585299997`*^9, 
   3.503070059907*^9}, 3.503070932929*^9, {3.503071712278*^9, 
   3.5030718142390003`*^9}, {3.503071963775*^9, 3.503071964927*^9}, {
   3.503076976273*^9, 3.503076976822*^9}, {3.503077023894*^9, 
   3.503077024225*^9}, {3.503077149414*^9, 3.5030771671949997`*^9}, {
   3.5093845390101037`*^9, 3.5093845403351035`*^9}, {3.5093855798351035`*^9, 
   3.5093855833451033`*^9}, 3.5093864710561037`*^9, {3.50945072558*^9, 
   3.509450725946*^9}, {3.5293225316813307`*^9, 3.5293225360565805`*^9}, {
   3.5293225898726587`*^9, 3.529322597192077*^9}, 3.529322771743061*^9, {
   3.529322832304525*^9, 3.529322832951562*^9}, {3.529323241276487*^9, 
   3.529323259067504*^9}, {3.5293233696348286`*^9, 3.529323392530138*^9}, 
   3.529323671625101*^9, {3.529324255429493*^9, 3.529324257373604*^9}, 
   3.529373841982173*^9, {3.5293745276073885`*^9, 3.529374529806514*^9}, {
   3.531741876222433*^9, 3.5317418934754195`*^9}}],

Cell[BoxData[{
 RowBox[{"ToExpression", "[", 
  RowBox[{"ToString", "[", 
   RowBox[{"Floor", "[", 
    RowBox[{
     RowBox[{"\[Theta]FCPLP", "[", "2", "]"}], ",", 
     SuperscriptBox["10", 
      RowBox[{"-", "5."}]]}], "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FCPLPnorm", "[", "2", "]"}]}], "Input",
 CellChangeTimes->{{3.50307507916*^9, 3.503075217892*^9}, {
   3.5030752855439997`*^9, 3.503075341165*^9}, {3.503075417076*^9, 
   3.503075518875*^9}, 3.503078509127*^9, {3.5093846904491034`*^9, 
   3.509384693745104*^9}, {3.5093863711071033`*^9, 3.5093863730591035`*^9}, {
   3.5293229912631865`*^9, 3.5293230010707474`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Theta]F", "[", "2", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.0157`", ",", 
       RowBox[{"-", "9.69771`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.04712`", ",", 
       RowBox[{"-", "8.59289`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.07853`", ",", 
       RowBox[{"-", "8.07653`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.10995`", ",", 
       RowBox[{"-", "7.73419`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.14137`", ",", 
       RowBox[{"-", "7.47816`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.17278`", ",", 
       RowBox[{"-", "7.27607`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.2042`", ",", 
       RowBox[{"-", "7.10974`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.23561`", ",", 
       RowBox[{"-", "6.96804`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.26703`", ",", 
       RowBox[{"-", "6.84687`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.29845`", ",", 
       RowBox[{"-", "6.74`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.32986`", ",", 
       RowBox[{"-", "6.64415`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.36128`", ",", 
       RowBox[{"-", "6.55633`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.39269`", ",", 
       RowBox[{"-", "6.47782`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.42411`", ",", 
       RowBox[{"-", "6.40985`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.45553`", ",", 
       RowBox[{"-", "6.35166`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.48694`", ",", 
       RowBox[{"-", "6.30368`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.51836`", ",", 
       RowBox[{"-", "6.26514`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.54977`", ",", 
       RowBox[{"-", "6.23501`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.58119`", ",", 
       RowBox[{"-", "6.21381`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.61261`", ",", 
       RowBox[{"-", "6.20044`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.64402`", ",", 
       RowBox[{"-", "6.19736`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.67544`", ",", 
       RowBox[{"-", "6.20876`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.70685`", ",", 
       RowBox[{"-", "6.2352`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.73827`", ",", 
       RowBox[{"-", "6.27574`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.76969`", ",", 
       RowBox[{"-", "6.33061`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.8011`", ",", 
       RowBox[{"-", "6.39683`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.83252`", ",", 
       RowBox[{"-", "6.48155`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.86393`", ",", 
       RowBox[{"-", "6.59084`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.89535`", ",", 
       RowBox[{"-", "6.72904`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.92676`", ",", 
       RowBox[{"-", "6.90034`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.95818`", ",", 
       RowBox[{"-", "7.10012`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.9896`", ",", 
       RowBox[{"-", "7.31995`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.02101`", ",", 
       RowBox[{"-", "7.55886`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.05243`", ",", 
       RowBox[{"-", "7.81949`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.08384`", ",", 
       RowBox[{"-", "8.0856`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.11526`", ",", 
       RowBox[{"-", "8.34064`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.14668`", ",", 
       RowBox[{"-", "8.56877`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.17809`", ",", 
       RowBox[{"-", "8.74714`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.20951`", ",", 
       RowBox[{"-", "8.87217`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.24092`", ",", 
       RowBox[{"-", "8.95141`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.27234`", ",", 
       RowBox[{"-", "8.97792`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.30376`", ",", 
       RowBox[{"-", "8.93708`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.33517`", ",", 
       RowBox[{"-", "8.85908`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.36659`", ",", 
       RowBox[{"-", "8.7502`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.398`", ",", 
       RowBox[{"-", "8.6487`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.42942`", ",", 
       RowBox[{"-", "8.59874`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.46084`", ",", 
       RowBox[{"-", "8.57841`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.49225`", ",", 
       RowBox[{"-", "8.54537`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.52367`", ",", 
       RowBox[{"-", "8.54152`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.55508`", ",", 
       RowBox[{"-", "8.61891`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.5865`", ",", 
       RowBox[{"-", "8.74983`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.61792`", ",", 
       RowBox[{"-", "8.92269`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.64933`", ",", 
       RowBox[{"-", "9.11432`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.68075`", ",", 
       RowBox[{"-", "9.31073`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.71216`", ",", 
       RowBox[{"-", "9.4834`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.74358`", ",", 
       RowBox[{"-", "9.62093`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.77499`", ",", 
       RowBox[{"-", "9.70106`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.80641`", ",", 
       RowBox[{"-", "9.69507`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.83783`", ",", 
       RowBox[{"-", "9.61213`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.86924`", ",", 
       RowBox[{"-", "9.45456`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.90066`", ",", 
       RowBox[{"-", "9.22805`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.93207`", ",", 
       RowBox[{"-", "8.93264`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.96349`", ",", 
       RowBox[{"-", "8.59227`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.99491`", ",", 
       RowBox[{"-", "8.23195`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.02632`", ",", 
       RowBox[{"-", "7.87187`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.05774`", ",", 
       RowBox[{"-", "7.52263`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.08915`", ",", 
       RowBox[{"-", "7.19115`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.12057`", ",", 
       RowBox[{"-", "6.88411`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.15199`", ",", 
       RowBox[{"-", "6.61339`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.1834`", ",", 
       RowBox[{"-", "6.38524`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.21482`", ",", 
       RowBox[{"-", "6.19763`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.24623`", ",", 
       RowBox[{"-", "6.05091`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.27765`", ",", 
       RowBox[{"-", "5.94043`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.30907`", ",", 
       RowBox[{"-", "5.86174`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.34048`", ",", 
       RowBox[{"-", "5.81374`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.3719`", ",", 
       RowBox[{"-", "5.79336`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.40331`", ",", 
       RowBox[{"-", "5.7954`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.43473`", ",", 
       RowBox[{"-", "5.8155`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.46615`", ",", 
       RowBox[{"-", "5.84938`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.49756`", ",", 
       RowBox[{"-", "5.89581`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.52898`", ",", 
       RowBox[{"-", "5.95118`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.56039`", ",", 
       RowBox[{"-", "6.0157`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.59181`", ",", 
       RowBox[{"-", "6.08843`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.62322`", ",", 
       RowBox[{"-", "6.16587`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.65464`", ",", 
       RowBox[{"-", "6.24921`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.68606`", ",", 
       RowBox[{"-", "6.34071`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.71747`", ",", 
       RowBox[{"-", "6.43855`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.74889`", ",", 
       RowBox[{"-", "6.54253`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.7803`", ",", 
       RowBox[{"-", "6.65378`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.81172`", ",", 
       RowBox[{"-", "6.77487`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.84314`", ",", 
       RowBox[{"-", "6.90944`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.87455`", ",", 
       RowBox[{"-", "7.05382`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.90597`", ",", 
       RowBox[{"-", "7.21803`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.93738`", ",", 
       RowBox[{"-", "7.41675`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.9688`", ",", 
       RowBox[{"-", "7.65346`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.00022`", ",", 
       RowBox[{"-", "7.93888`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.03163`", ",", 
       RowBox[{"-", "8.27856`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.06305`", ",", 
       RowBox[{"-", "8.69407`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.09446`", ",", 
       RowBox[{"-", "9.27076`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.12588`", ",", 
       RowBox[{"-", "10.419`"}]}], "}"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Theta]FCPLP", "[", "2", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.00523`", ",", 
       RowBox[{"-", "85.8886`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.0157`", ",", 
       RowBox[{"-", "85.0174`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.02617`", ",", 
       RowBox[{"-", "84.6823`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.03665`", ",", 
       RowBox[{"-", "84.4724`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.04712`", ",", 
       RowBox[{"-", "84.2955`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.05759`", ",", 
       RowBox[{"-", "84.1102`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.06806`", ",", 
       RowBox[{"-", "83.8901`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.07853`", ",", 
       RowBox[{"-", "83.6154`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.08901`", ",", 
       RowBox[{"-", "83.2706`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.09948`", ",", 
       RowBox[{"-", "82.7677`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.10995`", ",", 
       RowBox[{"-", "82.1361`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.12042`", ",", 
       RowBox[{"-", "81.4602`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.13089`", ",", 
       RowBox[{"-", "80.7369`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.14137`", ",", 
       RowBox[{"-", "79.9787`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.15184`", ",", 
       RowBox[{"-", "79.1566`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.16231`", ",", 
       RowBox[{"-", "78.3261`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.17278`", ",", 
       RowBox[{"-", "77.4616`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.18325`", ",", 
       RowBox[{"-", "76.5043`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.19373`", ",", 
       RowBox[{"-", "75.4502`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.2042`", ",", 
       RowBox[{"-", "74.2959`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.21467`", ",", 
       RowBox[{"-", "73.039`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.22514`", ",", 
       RowBox[{"-", "71.7021`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.23561`", ",", 
       RowBox[{"-", "70.272`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.24609`", ",", 
       RowBox[{"-", "68.7267`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.25656`", ",", 
       RowBox[{"-", "67.0726`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.26703`", ",", 
       RowBox[{"-", "65.3162`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.2775`", ",", 
       RowBox[{"-", "63.4751`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.28797`", ",", 
       RowBox[{"-", "61.623`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.29845`", ",", 
       RowBox[{"-", "59.7218`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.30892`", ",", 
       RowBox[{"-", "57.6768`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.31939`", ",", 
       RowBox[{"-", "55.5049`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.32986`", ",", 
       RowBox[{"-", "53.2247`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.34033`", ",", 
       RowBox[{"-", "50.8565`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.35081`", ",", 
       RowBox[{"-", "48.2234`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.36128`", ",", 
       RowBox[{"-", "45.4639`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.37175`", ",", 
       RowBox[{"-", "42.8381`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.38222`", ",", 
       RowBox[{"-", "40.3643`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.39269`", ",", 
       RowBox[{"-", "38.0576`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.40317`", ",", 
       RowBox[{"-", "35.9306`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.41364`", ",", 
       RowBox[{"-", "33.9663`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.42411`", ",", 
       RowBox[{"-", "32.2338`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.43458`", ",", 
       RowBox[{"-", "30.7629`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.44505`", ",", 
       RowBox[{"-", "29.5275`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.45553`", ",", 
       RowBox[{"-", "28.5038`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.466`", ",", 
       RowBox[{"-", "27.6693`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.47647`", ",", 
       RowBox[{"-", "27.0407`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.48694`", ",", 
       RowBox[{"-", "26.6017`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.49741`", ",", 
       RowBox[{"-", "26.2647`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.50789`", ",", 
       RowBox[{"-", "25.9865`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.51836`", ",", 
       RowBox[{"-", "25.6847`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.52883`", ",", 
       RowBox[{"-", "25.348`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.5393`", ",", 
       RowBox[{"-", "24.5406`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.54977`", ",", 
       RowBox[{"-", "23.4281`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.56025`", ",", 
       RowBox[{"-", "22.5273`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.57072`", ",", 
       RowBox[{"-", "21.8339`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.58119`", ",", 
       RowBox[{"-", "21.35`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.59166`", ",", 
       RowBox[{"-", "21.0773`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.60213`", ",", 
       RowBox[{"-", "21.3515`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.61261`", ",", 
       RowBox[{"-", "22.0238`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.62308`", ",", 
       RowBox[{"-", "22.724`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.63355`", ",", 
       RowBox[{"-", "23.4627`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.64402`", ",", 
       RowBox[{"-", "24.2481`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.65449`", ",", 
       RowBox[{"-", "25.0855`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.66497`", ",", 
       RowBox[{"-", "26.106`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.67544`", ",", 
       RowBox[{"-", "27.2491`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.68591`", ",", 
       RowBox[{"-", "28.2964`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.69638`", ",", 
       RowBox[{"-", "29.3034`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.70685`", ",", 
       RowBox[{"-", "30.2605`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.71733`", ",", 
       RowBox[{"-", "31.1881`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.7278`", ",", 
       RowBox[{"-", "32.4024`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.73827`", ",", 
       RowBox[{"-", "33.9276`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.74874`", ",", 
       RowBox[{"-", "35.4567`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.75921`", ",", 
       RowBox[{"-", "36.9536`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.76969`", ",", 
       RowBox[{"-", "38.4024`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.78016`", ",", 
       RowBox[{"-", "39.7535`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.79063`", ",", 
       RowBox[{"-", "40.8452`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.8011`", ",", 
       RowBox[{"-", "41.4266`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.81157`", ",", 
       RowBox[{"-", "41.7292`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.82205`", ",", 
       RowBox[{"-", "41.9469`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.83252`", ",", 
       RowBox[{"-", "42.1078`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.84299`", ",", 
       RowBox[{"-", "42.1363`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.85346`", ",", 
       RowBox[{"-", "41.2355`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.86393`", ",", 
       RowBox[{"-", "39.2598`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.8744`", ",", 
       RowBox[{"-", "37.4715`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.88488`", ",", 
       RowBox[{"-", "36.0172`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.89535`", ",", 
       RowBox[{"-", "34.8954`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.90582`", ",", 
       RowBox[{"-", "34.0768`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.91629`", ",", 
       RowBox[{"-", "33.7502`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.92676`", ",", 
       RowBox[{"-", "33.7683`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.93724`", ",", 
       RowBox[{"-", "33.8697`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.94771`", ",", 
       RowBox[{"-", "34.0391`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.95818`", ",", 
       RowBox[{"-", "34.3166`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.96865`", ",", 
       RowBox[{"-", "34.6835`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.97912`", ",", 
       RowBox[{"-", "35.4505`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.9896`", ",", 
       RowBox[{"-", "36.4417`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.00007`", ",", 
       RowBox[{"-", "37.2645`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.01054`", ",", 
       RowBox[{"-", "37.9448`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.02101`", ",", 
       RowBox[{"-", "38.5039`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.03148`", ",", 
       RowBox[{"-", "38.9506`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.04196`", ",", 
       RowBox[{"-", "39.3756`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.05243`", ",", 
       RowBox[{"-", "39.0649`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.0629`", ",", 
       RowBox[{"-", "38.1663`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.07337`", ",", 
       RowBox[{"-", "37.1799`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.08384`", ",", 
       RowBox[{"-", "36.2567`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.09432`", ",", 
       RowBox[{"-", "35.4346`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.10479`", ",", 
       RowBox[{"-", "34.5412`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.11526`", ",", 
       RowBox[{"-", "33.5644`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.12573`", ",", 
       RowBox[{"-", "32.693`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.1362`", ",", 
       RowBox[{"-", "31.9473`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.14668`", ",", 
       RowBox[{"-", "31.3835`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.15715`", ",", 
       RowBox[{"-", "31.0397`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.16762`", ",", 
       RowBox[{"-", "31.5201`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.17809`", ",", 
       RowBox[{"-", "32.5718`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.18856`", ",", 
       RowBox[{"-", "33.5691`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.19904`", ",", 
       RowBox[{"-", "34.5085`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.20951`", ",", 
       RowBox[{"-", "35.3834`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.21998`", ",", 
       RowBox[{"-", "36.1823`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.23045`", ",", 
       RowBox[{"-", "36.6207`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.24092`", ",", 
       RowBox[{"-", "36.5588`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.2514`", ",", 
       RowBox[{"-", "36.2914`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.26187`", ",", 
       RowBox[{"-", "36.0043`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.27234`", ",", 
       RowBox[{"-", "35.865`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.28281`", ",", 
       RowBox[{"-", "35.9458`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.29328`", ",", 
       RowBox[{"-", "37.0792`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.30376`", ",", 
       RowBox[{"-", "38.9058`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.31423`", ",", 
       RowBox[{"-", "40.4515`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.3247`", ",", 
       RowBox[{"-", "41.6648`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.33517`", ",", 
       RowBox[{"-", "42.5067`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.34564`", ",", 
       RowBox[{"-", "42.9537`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.35612`", ",", 
       RowBox[{"-", "42.4609`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.36659`", ",", 
       RowBox[{"-", "41.3236`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.37706`", ",", 
       RowBox[{"-", "40.2674`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.38753`", ",", 
       RowBox[{"-", "39.3404`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.398`", ",", 
       RowBox[{"-", "38.552`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.40848`", ",", 
       RowBox[{"-", "37.8918`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.41895`", ",", 
       RowBox[{"-", "36.7386`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.42942`", ",", 
       RowBox[{"-", "35.3122`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.43989`", ",", 
       RowBox[{"-", "34.1691`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.45036`", ",", 
       RowBox[{"-", "33.2338`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.46084`", ",", 
       RowBox[{"-", "32.5387`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.47131`", ",", 
       RowBox[{"-", "32.1107`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.48178`", ",", 
       RowBox[{"-", "32.7388`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.49225`", ",", 
       RowBox[{"-", "34.2076`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.50272`", ",", 
       RowBox[{"-", "35.6021`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.5132`", ",", 
       RowBox[{"-", "36.8346`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.52367`", ",", 
       RowBox[{"-", "37.8276`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.53414`", ",", 
       RowBox[{"-", "38.5138`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.54461`", ",", 
       RowBox[{"-", "38.4181`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.55508`", ",", 
       RowBox[{"-", "37.6582`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.56556`", ",", 
       RowBox[{"-", "36.8273`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.57603`", ",", 
       RowBox[{"-", "35.991`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.5865`", ",", 
       RowBox[{"-", "35.1736`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.59697`", ",", 
       RowBox[{"-", "34.3835`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.60744`", ",", 
       RowBox[{"-", "33.8107`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.61792`", ",", 
       RowBox[{"-", "33.3624`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.62839`", ",", 
       RowBox[{"-", "32.8132`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.63886`", ",", 
       RowBox[{"-", "32.1782`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.64933`", ",", 
       RowBox[{"-", "31.4198`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.6598`", ",", 
       RowBox[{"-", "30.5529`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.67028`", ",", 
       RowBox[{"-", "29.2529`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.68075`", ",", 
       RowBox[{"-", "27.6748`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.69122`", ",", 
       RowBox[{"-", "26.1659`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.70169`", ",", 
       RowBox[{"-", "24.7556`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.71216`", ",", 
       RowBox[{"-", "23.4814`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.72263`", ",", 
       RowBox[{"-", "22.3517`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.73311`", ",", 
       RowBox[{"-", "21.5369`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.74358`", ",", 
       RowBox[{"-", "20.9664`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.75405`", ",", 
       RowBox[{"-", "20.4163`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.76452`", ",", 
       RowBox[{"-", "19.8667`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.77499`", ",", 
       RowBox[{"-", "19.3107`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.78547`", ",", 
       RowBox[{"-", "18.7501`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.79594`", ",", 
       RowBox[{"-", "18.064`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.80641`", ",", 
       RowBox[{"-", "17.3097`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.81688`", ",", 
       RowBox[{"-", "16.6343`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.82735`", ",", 
       RowBox[{"-", "16.0519`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.83783`", ",", 
       RowBox[{"-", "15.5839`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.8483`", ",", 
       RowBox[{"-", "15.2476`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.85877`", ",", 
       RowBox[{"-", "15.3189`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.86924`", ",", 
       RowBox[{"-", "15.4593`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.87971`", ",", 
       RowBox[{"-", "15.272`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.89019`", ",", 
       RowBox[{"-", "14.874`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.90066`", ",", 
       RowBox[{"-", "14.4166`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.91113`", ",", 
       RowBox[{"-", "13.9967`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.9216`", ",", 
       RowBox[{"-", "13.9823`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.93207`", ",", 
       RowBox[{"-", "14.2421`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.94255`", ",", 
       RowBox[{"-", "14.4155`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.95302`", ",", 
       RowBox[{"-", "14.5023`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.96349`", ",", 
       RowBox[{"-", "14.492`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.97396`", ",", 
       RowBox[{"-", "14.3652`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.98443`", ",", 
       RowBox[{"-", "13.6158`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.99491`", ",", 
       RowBox[{"-", "12.5038`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.00538`", ",", 
       RowBox[{"-", "11.7229`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.01585`", ",", 
       RowBox[{"-", "11.2653`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.02632`", ",", 
       RowBox[{"-", "11.0708`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.03679`", ",", 
       RowBox[{"-", "11.073`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.04727`", ",", 
       RowBox[{"-", "11.3159`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.05774`", ",", 
       RowBox[{"-", "11.697`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.06821`", ",", 
       RowBox[{"-", "12.1009`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.07868`", ",", 
       RowBox[{"-", "12.5327`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.08915`", ",", 
       RowBox[{"-", "13.0019`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.09963`", ",", 
       RowBox[{"-", "13.5173`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.1101`", ",", 
       RowBox[{"-", "14.1235`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.12057`", ",", 
       RowBox[{"-", "14.849`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.13104`", ",", 
       RowBox[{"-", "15.6094`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.14151`", ",", 
       RowBox[{"-", "16.3477`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.15199`", ",", 
       RowBox[{"-", "17.0256`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.16246`", ",", 
       RowBox[{"-", "17.6154`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.17293`", ",", 
       RowBox[{"-", "17.8729`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.1834`", ",", 
       RowBox[{"-", "17.9114`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.19387`", ",", 
       RowBox[{"-", "18.07`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.20435`", ",", 
       RowBox[{"-", "18.3766`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.21482`", ",", 
       RowBox[{"-", "18.8397`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.22529`", ",", 
       RowBox[{"-", "19.4646`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.23576`", ",", 
       RowBox[{"-", "20.5647`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.24623`", ",", 
       RowBox[{"-", "22.0169`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.25671`", ",", 
       RowBox[{"-", "23.4614`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.26718`", ",", 
       RowBox[{"-", "24.8793`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.27765`", ",", 
       RowBox[{"-", "26.2513`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.28812`", ",", 
       RowBox[{"-", "27.5328`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.29859`", ",", 
       RowBox[{"-", "28.7562`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.30907`", ",", 
       RowBox[{"-", "29.7579`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.31954`", ",", 
       RowBox[{"-", "30.542`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.33001`", ",", 
       RowBox[{"-", "31.2023`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.34048`", ",", 
       RowBox[{"-", "31.8091`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.35095`", ",", 
       RowBox[{"-", "32.406`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.36143`", ",", 
       RowBox[{"-", "32.8953`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.3719`", ",", 
       RowBox[{"-", "33.1632`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.38237`", ",", 
       RowBox[{"-", "33.5358`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.39284`", ",", 
       RowBox[{"-", "34.1284`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.40331`", ",", 
       RowBox[{"-", "34.954`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.41379`", ",", 
       RowBox[{"-", "36.0094`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.42426`", ",", 
       RowBox[{"-", "37.612`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.43473`", ",", 
       RowBox[{"-", "38.6761`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.4452`", ",", 
       RowBox[{"-", "39.0901`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.45567`", ",", 
       RowBox[{"-", "39.2827`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.46615`", ",", 
       RowBox[{"-", "39.5589`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.47662`", ",", 
       RowBox[{"-", "40.057`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.48709`", ",", 
       RowBox[{"-", "41.17`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.49756`", ",", 
       RowBox[{"-", "42.2095`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.50803`", ",", 
       RowBox[{"-", "42.7716`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.51851`", ",", 
       RowBox[{"-", "43.1892`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.52898`", ",", 
       RowBox[{"-", "43.601`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.53945`", ",", 
       RowBox[{"-", "44.0259`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.54992`", ",", 
       RowBox[{"-", "44.86`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.56039`", ",", 
       RowBox[{"-", "45.6917`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.57086`", ",", 
       RowBox[{"-", "46.2637`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.58134`", ",", 
       RowBox[{"-", "46.8017`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.59181`", ",", 
       RowBox[{"-", "47.4144`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.60228`", ",", 
       RowBox[{"-", "48.1398`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.61275`", ",", 
       RowBox[{"-", "49.3311`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.62322`", ",", 
       RowBox[{"-", "50.805`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.6337`", ",", 
       RowBox[{"-", "52.1943`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.64417`", ",", 
       RowBox[{"-", "53.4478`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.65464`", ",", 
       RowBox[{"-", "54.6231`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.66511`", ",", 
       RowBox[{"-", "55.7468`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.67558`", ",", 
       RowBox[{"-", "57.0688`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.68606`", ",", 
       RowBox[{"-", "58.5003`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.69653`", ",", 
       RowBox[{"-", "59.8068`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.707`", ",", 
       RowBox[{"-", "60.9956`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.71747`", ",", 
       RowBox[{"-", "62.0612`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.72794`", ",", 
       RowBox[{"-", "62.9912`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.73842`", ",", 
       RowBox[{"-", "63.6423`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.74889`", ",", 
       RowBox[{"-", "64.0603`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.75936`", ",", 
       RowBox[{"-", "64.3858`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.76983`", ",", 
       RowBox[{"-", "64.6144`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.7803`", ",", 
       RowBox[{"-", "64.744`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.79078`", ",", 
       RowBox[{"-", "64.7738`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.80125`", ",", 
       RowBox[{"-", "64.3842`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.81172`", ",", 
       RowBox[{"-", "63.733`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.82219`", ",", 
       RowBox[{"-", "63.1782`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.83266`", ",", 
       RowBox[{"-", "62.7889`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.84314`", ",", 
       RowBox[{"-", "62.5925`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.85361`", ",", 
       RowBox[{"-", "62.6067`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.86408`", ",", 
       RowBox[{"-", "63.2334`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.87455`", ",", 
       RowBox[{"-", "64.2819`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.88502`", ",", 
       RowBox[{"-", "65.2943`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.8955`", ",", 
       RowBox[{"-", "66.2662`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.90597`", ",", 
       RowBox[{"-", "67.1913`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.91644`", ",", 
       RowBox[{"-", "68.0611`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.92691`", ",", 
       RowBox[{"-", "68.9827`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.93738`", ",", 
       RowBox[{"-", "69.8333`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.94786`", ",", 
       RowBox[{"-", "70.4844`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.95833`", ",", 
       RowBox[{"-", "70.8957`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.9688`", ",", 
       RowBox[{"-", "71.0566`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.97927`", ",", 
       RowBox[{"-", "70.971`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.98974`", ",", 
       RowBox[{"-", "70.3307`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.00022`", ",", 
       RowBox[{"-", "69.3453`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.01069`", ",", 
       RowBox[{"-", "68.4372`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.02116`", ",", 
       RowBox[{"-", "67.625`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.03163`", ",", 
       RowBox[{"-", "66.9185`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.0421`", ",", 
       RowBox[{"-", "66.3255`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.05258`", ",", 
       RowBox[{"-", "65.8556`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.06305`", ",", 
       RowBox[{"-", "65.5003`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.07352`", ",", 
       RowBox[{"-", "65.324`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.08399`", ",", 
       RowBox[{"-", "65.3297`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.09446`", ",", 
       RowBox[{"-", "65.551`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.10494`", ",", 
       RowBox[{"-", "66.0333`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.11541`", ",", 
       RowBox[{"-", "66.843`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.12588`", ",", 
       RowBox[{"-", "68.1034`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.13635`", ",", 
       RowBox[{"-", "70.2611`"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ord", "=", "1"}], ";", 
  RowBox[{
   RowBox[{"FCPLPnorm", "[", "2", "]"}], "=", "1.0156786300798763`*^-6"}], 
  ";", 
  RowBox[{
   RowBox[{"Fnorm", "[", "2", "]"}], "=", "0.003244898444768984`"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"inFCPLP", "[", "2", "]"}], "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{
     RowBox[{"\[Theta]FCPLP", "[", "2", "]"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"inF", "[", "2", "]"}], "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{
     RowBox[{"\[Theta]F", "[", "2", "]"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5030783968389997`*^9, 3.5030784001879997`*^9}, {
   3.503078515342*^9, 3.503078539546*^9}, {3.50307859513*^9, 
   3.50307860573*^9}, {3.503079770328*^9, 3.503079820771*^9}, {
   3.503080094848*^9, 3.503080100949*^9}, {3.5093846186181035`*^9, 
   3.5093846191231036`*^9}, 3.509385531094104*^9, {3.5093855669461036`*^9, 
   3.5093855712651033`*^9}, {3.5093865026631036`*^9, 
   3.5093865233721037`*^9}, {3.509386573257104*^9, 3.5093865733591037`*^9}, {
   3.5093866222581034`*^9, 3.5093866318171034`*^9}, {3.509448415774*^9, 
   3.50944844565*^9}, {3.5293231382445936`*^9, 3.5293231635750427`*^9}, {
   3.52932353750343*^9, 3.5293235449918585`*^9}, {3.5293240848097343`*^9, 
   3.5293240916041226`*^9}, {3.5293277681094065`*^9, 3.529327790095664*^9}, {
   3.5293738717518754`*^9, 3.529373919143586*^9}, {3.529374499531782*^9, 
   3.529374501506895*^9}, {3.529377797985443*^9, 3.5293778262920623`*^9}, {
   3.531741949002596*^9, 3.5317419524247913`*^9}, {3.531742237629104*^9, 
   3.531742317924697*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"thic", "=", "3"}], ";", 
  RowBox[{"mysize", "=", "20"}], ";", 
  RowBox[{"SetOptions", "[", 
   RowBox[{"LogPlot", ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "thic", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"mysize", ",", 
       RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "}"}]}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Inclination angle \[Theta] [deg]\>\"", ",", 
       "\"\<Probability density\>\""}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}], ";", 
  RowBox[{"col", "=", 
   RowBox[{"{", 
    RowBox[{"Black", ",", "Green", ",", "Brown", ",", "Blue", ",", "Cyan"}], 
    "}"}]}], ";", 
  RowBox[{"xxlen", "=", "100"}], ";", 
  RowBox[{"\[Theta]min", "=", 
   RowBox[{"0.5", 
    FractionBox["\[Pi]", "xxlen"]}]}], ";", 
  RowBox[{"\[Theta]max", "=", 
   RowBox[{"\[Pi]", "-", "\[Theta]min"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"FCPLPplot", "[", "sp", "]"}], "=", 
     RowBox[{"LogPlot", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"inFCPLP", "[", "sp", "]"}], "[", 
            RowBox[{"\[Pi]", "-", 
             RowBox[{
              FractionBox["\[Pi]", "180"], "\[Theta]"}]}], "]"}], "]"}], 
          RowBox[{"FCPLPnorm", "[", "2", "]"}]], ",", 
         FractionBox[
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"inF", "[", "sp", "]"}], "[", 
            RowBox[{"\[Pi]", "-", 
             RowBox[{
              FractionBox["\[Pi]", "180"], "\[Theta]"}]}], "]"}], "]"}], 
          RowBox[{"Fnorm", "[", "2", "]"}]]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", 
         RowBox[{
          FractionBox["180", "\[Pi]"], "\[Theta]min"}], ",", 
         RowBox[{
          FractionBox["180", "\[Pi]"], "\[Theta]max"}]}], "}"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"50", ",", "80"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"1.5", " ", 
             SuperscriptBox["10", 
              RowBox[{"-", "2."}]]}], ",", "30"}], "}"}]}], "}"}]}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"RGBColor", "[", 
             RowBox[{"0.", ",", 
              FractionBox[
               RowBox[{"sp", "-", "1"}], "5"], ",", 
              RowBox[{"1", "-", 
               FractionBox[
                RowBox[{"sp", "-", "1"}], "5"]}]}], "]"}], ",", 
            RowBox[{"AbsoluteThickness", "[", "thic", "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"AbsoluteThickness", "[", "thic", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", 
             RowBox[{"{", 
              RowBox[{"10", ",", "7"}], "}"}], "]"}]}], "}"}]}], "}"}]}]}], 
      "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"sp", ",", "2", ",", "2"}], "}"}]}], "]"}], "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Fplot", "[", "sp", "]"}], "=", 
    RowBox[{
     RowBox[{"LogPlot", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"inF", "[", "sp", "]"}], "[", 
          RowBox[{"\[Pi]", "-", 
           RowBox[{
            FractionBox["\[Pi]", "180"], "\[Theta]"}]}], "]"}], "]"}], 
        RowBox[{"Fnorm", "[", "4", "]"}]], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", 
         RowBox[{
          FractionBox["180", "\[Pi]"], "\[Theta]min"}], ",", 
         RowBox[{
          FractionBox["180", "\[Pi]"], "\[Theta]max"}]}], "}"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          SuperscriptBox["10", 
           RowBox[{"-", "2"}]], ",", "10"}], "}"}]}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.", ",", 
            FractionBox[
             RowBox[{"sp", "-", "1"}], "5"], ",", 
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"sp", "-", "1"}], "5"]}]}], "]"}], ",", 
          RowBox[{"AbsoluteThickness", "[", "thic", "]"}]}], "}"}]}]}], "]"}],
      "\n", 
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"Fplot", "[", "2", "]"}], ",", 
       RowBox[{"Fplot", "[", "3", "]"}], ",", 
       RowBox[{"Fplot", "[", "4", "]"}], ",", 
       RowBox[{"Fplot", "[", "5", "]"}]}], "]"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"thpl", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"FCPLPplot", "[", "2", "]"}], ",", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"FCPLPplot", "[", "3", "]"}], ",", 
      RowBox[{"FCPLPplot", "[", "4", "]"}], ",", 
      RowBox[{"FCPLPplot", "[", "5", "]"}], ","}], "*)"}], 
    RowBox[{
    "PlotLabel", "\[Rule]", 
     "\"\<\[Rho](\[Theta],\!\(\*SubscriptBox[\(a\), \
\(*\)]\)=0.5|\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\))\>\""}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\study\\\\accretion\\\\! 2009 3fall cfa\\\\GR Polarized \
modeling\\\\!svn\\\\thpl.eps\>\"", ",", "thpl", ",", 
   RowBox[{"\"\<EmbeddedFonts\>\"", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.4864813313206*^9, 3.486481525447*^9}, {
   3.4864816985134*^9, 3.486481818571*^9}, {3.4864820074245996`*^9, 
   3.4864820155366*^9}, {3.4864828134454*^9, 3.4864828478278*^9}, {
   3.4864828875453997`*^9, 3.4864829342518*^9}, {3.4864830928602*^9, 
   3.4864831015182*^9}, {3.486483211545*^9, 3.486483242901*^9}, {
   3.4864832866122*^9, 3.4864833305886*^9}, {3.486483384939*^9, 
   3.486483385407*^9}, {3.4864834463406*^9, 3.4864835035146*^9}, 
   3.4864835378970003`*^9, {3.486484912469*^9, 3.486484935627*^9}, {
   3.486485676634*^9, 3.486485685153*^9}, {3.486485769541*^9, 
   3.486485777212*^9}, {3.4864859200369997`*^9, 3.48648592798*^9}, 
   3.4864864015512*^9, {3.486726432856*^9, 3.486726437475*^9}, {
   3.4867264794*^9, 3.4867264828640003`*^9}, 3.486726676383*^9, {
   3.486728389196*^9, 3.486728392884*^9}, {3.489155180976533*^9, 
   3.4891552188221326`*^9}, {3.4891552510205326`*^9, 
   3.4891552645613327`*^9}, {3.489155295137333*^9, 3.4891552959797325`*^9}, {
   3.489155705821933*^9, 3.489155748097933*^9}, {3.503069205799*^9, 
   3.503069222317*^9}, {3.503071055508*^9, 3.503071058627*^9}, {
   3.503071478781*^9, 3.5030715013310003`*^9}, {3.5030716370690002`*^9, 
   3.503071639075*^9}, {3.503075790782*^9, 3.503075794072*^9}, {
   3.50307582459*^9, 3.50307582474*^9}, {3.503075891666*^9, 
   3.5030759190290003`*^9}, {3.5030760109370003`*^9, 3.503076036336*^9}, {
   3.50307647492*^9, 3.503076506575*^9}, {3.503076749908*^9, 
   3.5030767950620003`*^9}, {3.503076831076*^9, 3.503076848475*^9}, {
   3.5030784614110003`*^9, 3.503078472333*^9}, 3.5030786042860003`*^9, {
   3.503079834041*^9, 3.503079913317*^9}, {3.503079973203*^9, 
   3.503079973442*^9}, {3.503080030619*^9, 3.503080078742*^9}, {
   3.503155828074*^9, 3.50315582942*^9}, 3.503155872384*^9, {
   3.504289280023*^9, 3.504289295514*^9}, {3.504376759743*^9, 
   3.504376760174*^9}, {3.509386703035104*^9, 3.5093867140431037`*^9}, {
   3.509448387532*^9, 3.509448393273*^9}, {3.509448461174*^9, 
   3.509448504842*^9}, {3.509472308591*^9, 3.509472309466*^9}, {
   3.5101491335856*^9, 3.5101491345116*^9}, {3.5102333783986*^9, 
   3.5102333816496*^9}, {3.529323173251596*^9, 3.5293232245615306`*^9}, {
   3.529323769250685*^9, 3.5293237989133816`*^9}, {3.5293242221785913`*^9, 
   3.5293242303380575`*^9}, {3.529408449079468*^9, 3.5294084581019835`*^9}, {
   3.53174228388575*^9, 3.531742285512843*^9}, {3.531742327233229*^9, 
   3.5317424173163815`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "2"}], ";", 
  RowBox[{"\[Theta]fun", "=", 
   FractionBox[
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"inFCPLP", "[", "sp", "]"}], "[", 
      RowBox[{"\[Pi]", "-", "\[Theta]"}], "]"}], "]"}], 
    RowBox[{"FCPLPnorm", "[", "sp", "]"}]]}], ";", 
  RowBox[{"\[Theta]min", "=", "0.8"}], ";", 
  RowBox[{"\[Theta]max", "=", "1.7"}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "nlim"}], "]"}], ";", 
  RowBox[{"Off", "[", 
   StyleBox[
    RowBox[{"NIntegrate", "::", "izero"}], "MessageName"], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"nno", "=", 
  RowBox[{"NIntegrate", "[", 
   RowBox[{"\[Theta]fun", ",", 
    RowBox[{"{", 
     RowBox[{"\[Theta]", ",", "\[Theta]min", ",", "\[Theta]max"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Theta]cent", "=", 
   RowBox[{"\[Theta]x", "/.", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       FractionBox["nno", "2"], "==", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"\[Theta]fun", ",", 
         RowBox[{"{", 
          RowBox[{"\[Theta]", ",", "\[Theta]min", ",", "\[Theta]x"}], "}"}]}],
         "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Theta]x", ",", 
        FractionBox[
         RowBox[{"\[Theta]min", "+", "\[Theta]max"}], "2"]}], "}"}]}], 
     "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Theta]intmin", "=", 
   RowBox[{"\[Theta]x", "/.", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"0.05", "nno"}], "==", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"\[Theta]fun", ",", 
         RowBox[{"{", 
          RowBox[{"\[Theta]", ",", "\[Theta]min", ",", "\[Theta]x"}], "}"}]}],
         "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Theta]x", ",", "\[Theta]cent"}], "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Theta]intmax", "=", 
   RowBox[{"\[Theta]x", "/.", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"0.05", "nno"}], "==", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"\[Theta]fun", ",", 
         RowBox[{"{", 
          RowBox[{"\[Theta]", ",", "\[Theta]x", ",", "\[Theta]max"}], "}"}]}],
         "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Theta]x", ",", "\[Theta]cent"}], "}"}]}], "]"}]}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Central value for the inclination angle = \>\"", ",", 
    RowBox[{
     FractionBox["180", "\[Pi]"], "\[Theta]cent"}], ",", 
    "\"\<\[Degree]\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<90% confidence interval for inclination angle: \>\"", ",", 
   RowBox[{
    FractionBox["180", "\[Pi]"], 
    RowBox[{"{", 
     RowBox[{"\[Theta]intmin", ",", "\[Theta]intmax"}], "}"}]}], ",", 
   "\"\<\[Degree]\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.5293777791643667`*^9, 3.5293778146673975`*^9}, {
  3.5293778488193507`*^9, 3.5293780323088455`*^9}, {3.529378068817934*^9, 
  3.529378073258188*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["confidence intervals", "Subsubsection",
 CellChangeTimes->{{3.500640175512*^9, 3.500640177432*^9}, {
   3.5019594568380003`*^9, 3.501959461942*^9}, 3.5293223182821245`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"tofit", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"8.450", ",", "0.6898", ",", "0", ",", "0", ",", 
        RowBox[{"-", "0.2500"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"14.90", ",", "0.9044", ",", "0", ",", "0", ",", 
        RowBox[{"-", "0.6200"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"22.50", ",", "1.070", ",", "0.1900", ",", "131.0", ",", "0"}],
        "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"43.00", ",", "1.159", ",", "0.5041", ",", "94.25", ",", "0"}],
        "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"87.73", ",", "1.841", ",", "1.026", ",", 
        RowBox[{"-", "4."}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"102.0", ",", "1.908", ",", "0", ",", "0", ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"145.0", ",", "2.275", ",", "0", ",", "0", ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"230.9", ",", "2.637", ",", "7.015", ",", "111.5", ",", 
        RowBox[{"-", "1.200"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"349.0", ",", "3.181", ",", "6.143", ",", "146.9", ",", 
        RowBox[{"-", "1.500"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"674.0", ",", "3.286", ",", "0", ",", "0", ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"857.0", ",", "2.867", ",", "0", ",", "0", ",", "0"}], "}"}]}],
      "}"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"8.45", " ", "-", " ", 
    RowBox[{"43", "GHz"}], " ", "-", " ", 
    RowBox[{"still", " ", "old", " ", "data"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"dFnu", "=", 
    RowBox[{"{", 
     RowBox[{
     "1.", ",", "1.", ",", "1.", ",", "1.", ",", "0.080", ",", "0.1517", ",", 
      "0.2644", ",", "0.1414", ",", "0.1205", ",", "0.3508", ",", "0.2404"}], 
     "}"}]}], ";", 
   RowBox[{"dCP", "=", "0.30"}], ";", 
   RowBox[{"dlogLP", "=", 
    RowBox[{"{", 
     RowBox[{"0.19", ",", "0.086", ",", "0.115"}], "}"}]}], ";", 
   RowBox[{"t", "=", 
    RowBox[{"TimeUsed", "[", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"nh", ",", "co"}], "]"}], ";", 
  RowBox[{"ext", "=", "1."}], ";", 
  RowBox[{"acc", "=", "16"}], ";", 
  RowBox[{"inord", "=", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], ";", 
  RowBox[{"poi3", "=", "20000"}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"NIntegrate", ",", 
      RowBox[{"Method", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
         RowBox[{"Method", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
            RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
      ",", 
      RowBox[{"MaxPoints", "\[Rule]", "poi3"}], ",", 
      RowBox[{"AccuracyGoal", "\[Rule]", "acc"}]}], "]"}], ";"}], "*)"}], 
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{"NIntegrate", ",", 
     RowBox[{"Method", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
        RowBox[{"Method", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
           RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
     ",", 
     RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], 
   ";"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"co", "=", "0"}], ";", 
  RowBox[{"thlen", "=", "50"}], ";", 
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"narr", "=", "1.1"}], ";", 
  RowBox[{"nF", "=", "7"}], ";", 
  RowBox[{"nP", "=", "12"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"boosted", "=", "False"}], ";", 
  RowBox[{"avg", "=", "False"}], ";", 
  RowBox[{"test", "=", "\"\<Normal_narrow\>\""}], ";", 
  RowBox[{"test", "=", "\"\<Normal\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"bline", "=", 
        RowBox[{"If", "[", 
         RowBox[{"boosted", ",", "\"\<boo\>\"", ",", "\"\<nob\>\""}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"gat", "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"fnum", "=", 
              RowBox[{
               RowBox[{"-", "1"}], "-", "co"}]}], ";", 
             RowBox[{"th", "=", 
              RowBox[{
               FractionBox["\[Pi]", "thlen"], 
               RowBox[{"(", 
                RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
             RowBox[{"Import", "[", 
              RowBox[{"\"\<E:\\\\mathematica\\\\analysis\\\\poliresa\>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Round", "[", 
                 RowBox[{"100", 
                  RowBox[{"sptab", "[", 
                   RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
               "\"\<th\>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Floor", "[", 
                 RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<fn\>\"", "<>", 
               RowBox[{"ToString", "[", "fnum", "]"}], "<>", "bline", "<>", 
               "\"\<.dat\>\""}], "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", "\n", 
       RowBox[{"flen", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"gat", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", ";;", "11"}], ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"gat", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
       RowBox[{"Off", "[", 
        RowBox[{
         RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
         RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"gat", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{"gat", ",", "flen"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"rholen", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"Position", "[", 
          RowBox[{
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "8"}], 
             "]"}], "]"}], ",", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}]}], 
          "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"gat", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"dim", "=", 
        RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"hlen", "=", 
        RowBox[{"dim", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"dFnu", "=", "0.33"}], ";", 
         RowBox[{"dCP", "=", "0.27"}], ";", 
         RowBox[{"dlogLP", "=", "0.26"}], ";"}], "*)"}], 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"test", "\[Equal]", "\"\<Normal_narrow\>\""}], ",", 
           RowBox[{
            RowBox[{"dFnu", "*=", "narr"}], ";", 
            RowBox[{"dCP", "*=", "narr"}], ";", 
            RowBox[{"dlogLP", "*=", "narr"}]}]}], "]"}], ";"}], "*)"}], "\n", 
       RowBox[{"hmin", "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "8"}], 
           "]"}], "]"}], "]"}]}], ";", 
       RowBox[{"hmax", "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], 
          "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"thmin", "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", 
       RowBox[{"thmax", "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "1", ",", 
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", 
       RowBox[{"rhomax", "=", 
        RowBox[{"Log", "[", 
         FractionBox[
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "9"}], "]"}], "]"}], 
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"flen", "+", "1"}], ")"}], "/", "2"}], ",", "1", ",", 
             "1", ",", "9"}], "]"}], "]"}]], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"rateint", "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], 
             "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"raterho", "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "9"}], "]"}],
             "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"flux", "[", "i", "]"}], "=", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "All", ",", "i", ",", "All", ",", "3"}], 
             "]"}], "]"}]}], ";", 
          RowBox[{
           RowBox[{
            RowBox[{"iflux", "[", "i", "]"}], "[", "sp", "]"}], "=", 
           RowBox[{"ListInterpolation", "[", 
            RowBox[{
             RowBox[{"flux", "[", "i", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
             RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "flen"}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"LP", "[", "1", "]"}], "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", 
            RowBox[{"-", "7"}], ",", "All", ",", "4"}], "]"}], "]"}], "]"}]}],
        ";", 
       RowBox[{
        RowBox[{"LP", "[", "2", "]"}], "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", 
            RowBox[{"-", "4"}], ",", "All", ",", "4"}], "]"}], "]"}], "]"}]}],
        ";", 
       RowBox[{
        RowBox[{"LP", "[", "3", "]"}], "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", 
            RowBox[{"-", "3"}], ",", "All", ",", "4"}], "]"}], "]"}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"CP", "[", "1", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "4"}], ",", "All", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{
        RowBox[{"CP", "[", "2", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "3"}], ",", "All", ",", "6"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"iCPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
          RowBox[{"ListInterpolation", "[", 
           RowBox[{
            RowBox[{"CP", "[", "i", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
            RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"iLPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
          RowBox[{"ListInterpolation", "[", 
           RowBox[{
            RowBox[{"LP", "[", "i", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
            RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"lipFnux", "[", "sp", "]"}], "=", 
        RowBox[{"Total", "[", 
         FractionBox[
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox[
             RowBox[{
              RowBox[{"tofit", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                 "2"}], "]"}], "]"}], "-", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                  RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                 "&"}], "/@", 
                RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], 
             RowBox[{"dFnu", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
              "]"}]], ")"}], "2"], "flen"], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "=", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"flen", "+", "5"}]], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Total", "[", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"tofit", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                    "2"}], "]"}], "]"}], "-", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                    "&"}], "/@", 
                   RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], ")"}], "/", 
               RowBox[{"dFnu", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
                "]"}]}], ")"}], "2"], "]"}], "+", 
           RowBox[{"Total", "[", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox[
               RowBox[{
                RowBox[{"tofit", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"iCPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                   "&"}], "/@", 
                  RowBox[{"Range", "[", "2", "]"}]}], ")"}]}], "dCP"], ")"}], 
             "2"], "]"}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{"tofit", "[", 
                 RowBox[{"[", 
                  RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"iLPx", "[", "1", "]"}], "[", "sp", "]"}], "[", 
                 RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                ")"}]}], 
              RowBox[{"dlogLP", "[", 
               RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
           RowBox[{"Total", "[", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox[
               RowBox[{
                RowBox[{"Log", "[", 
                 RowBox[{"tofit", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}],
                 "-", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"iLPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                   "&"}], "/@", 
                  RowBox[{"{", 
                   RowBox[{"2", ",", "3"}], "}"}]}], ")"}]}], 
               RowBox[{"dlogLP", "[", 
                RowBox[{"[", 
                 RowBox[{"2", ";;", "3"}], "]"}], "]"}]], ")"}], "2"], 
            "]"}]}], ")"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Fdistx", "[", "sp", "]"}], "=", 
        RowBox[{"nF", " ", 
         RowBox[{"PDF", "[", 
          RowBox[{
           RowBox[{"ChiSquareDistribution", "[", "nF", "]"}], ",", 
           RowBox[{"nF", " ", 
            RowBox[{"lipFnux", "[", "sp", "]"}]}]}], "]"}], 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Ldistx", "[", "sp", "]"}], "=", 
        RowBox[{"nF", " ", 
         RowBox[{"PDF", "[", 
          RowBox[{
           RowBox[{"ChiSquareDistribution", "[", "nF", "]"}], ",", 
           RowBox[{"nF", " ", 
            RowBox[{"lipFnuCPLPx", "[", "sp", "]"}]}]}], "]"}], 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"sp", ",", "2", ",", "2"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"co", ",", "0", ",", "0"}], "}"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.486482483677*^9, 3.4864825978534*^9}, 
   3.4864847026400003`*^9, {3.503063828865*^9, 3.50306385301*^9}, {
   3.5030694191940002`*^9, 3.50306942219*^9}, {3.503078544058*^9, 
   3.503078544553*^9}, {3.504289364125*^9, 3.504289364749*^9}, {
   3.5093844806701035`*^9, 3.5093845068481035`*^9}, {3.5093855875531034`*^9, 
   3.5093855881371036`*^9}, {3.509450733843*^9, 3.5094507343780003`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"poi2", "=", "10000"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{"Dynamic", "[", "sp", "]"}], ",", "\"\< \>\"", ",", 
    RowBox[{"Dynamic", "[", "thn", "]"}]}], "]"}], ";", 
  RowBox[{"xxlen", "=", "100"}], ";", 
  RowBox[{"\[Theta]min", "=", 
   RowBox[{"0.5", 
    FractionBox["\[Pi]", "xxlen"]}]}], ";", 
  RowBox[{"\[Theta]max", "=", 
   RowBox[{"\[Pi]", "-", "thmin"}]}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "\"\<ncvb\>\""}], "]"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Theta]FCPLPx", "[", "sp", "]"}], "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"th", "=", 
          RowBox[{
           FractionBox["\[Pi]", "xxlen"], 
           RowBox[{"(", 
            RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
         RowBox[{"{", 
          RowBox[{"th", ",", 
           RowBox[{
            RowBox[{"ni", "=", 
             RowBox[{"Log", "[", 
              RowBox[{"NIntegrate", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Ldistx", "[", "sp", "]"}], "/.", 
                 RowBox[{"\[Theta]", "\[Rule]", "th"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"rhonor", ",", 
                  RowBox[{
                   RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                  RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
                RowBox[{"Method", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
                   RowBox[{"Method", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
                    RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], 
                  "}"}]}], ",", 
                RowBox[{"MaxPoints", "\[Rule]", "poi2"}]}], "]"}], "]"}]}], 
            ";", "ni"}]}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"thn", ",", "xxlen"}], "}"}]}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"inFCPLP", "[", "sp", "]"}], "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{"\[Theta]FCPLP", "[", "sp", "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"FCPLPnormx", "[", "sp", "]"}], "=", 
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"inFCPLPx", "[", "sp", "]"}], "[", "\[Theta]", "]"}], 
          "]"}], 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "\[Theta]min", ",", "\[Theta]max"}], 
         "}"}]}], "]"}]}], ";"}], "\n", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Theta]F", "[", "sp", "]"}], "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"th", "=", 
           RowBox[{
            FractionBox["\[Pi]", "xxlen"], 
            RowBox[{"(", 
             RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
          RowBox[{"{", 
           RowBox[{"th", ",", 
            RowBox[{"Log", "[", 
             RowBox[{"NIntegrate", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Fdistx", "[", "sp", "]"}], "/.", 
                RowBox[{"\[Theta]", "\[Rule]", "th"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"rhonor", ",", 
                 RowBox[{
                  RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                 RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
               RowBox[{"Method", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
                  RowBox[{"Method", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
                    RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], 
                 "}"}]}], ",", 
               RowBox[{"MaxPoints", "\[Rule]", "poi2"}]}], "]"}], "]"}]}], 
           "}"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"thn", ",", "xxlen"}], "}"}]}], "]"}]}], ";", "\n", 
      RowBox[{
       RowBox[{"inF", "[", "sp", "]"}], "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{"\[Theta]F", "[", "sp", "]"}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"Fnorm", "[", "sp", "]"}], "=", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"inF", "[", "sp", "]"}], "[", "\[Theta]", "]"}], "]"}], 
          RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Theta]", ",", "\[Theta]min", ",", "\[Theta]max"}], 
          "}"}]}], "]"}]}]}], "*)"}], ",", 
    RowBox[{"{", 
     RowBox[{"sp", ",", "2", ",", "2"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.4864805415550003`*^9, 3.4864806861514*^9}, {
   3.4864807478494*^9, 3.4864808731642*^9}, {3.4864809448774*^9, 
   3.4864809701338*^9}, {3.4864812881242*^9, 3.4864813188873997`*^9}, {
   3.4864814235165997`*^9, 3.4864814286334*^9}, {3.4864824314014*^9, 
   3.4864824422278*^9}, {3.4864825846714*^9, 3.4864825896166*^9}, {
   3.4864826420014*^9, 3.4864827413733997`*^9}, {3.4864828780294*^9, 
   3.4864828791214*^9}, {3.4864830349997997`*^9, 3.4864830437202*^9}, 
   3.486484779027*^9, {3.486485808914*^9, 3.486485809*^9}, {3.50306406459*^9, 
   3.503064145413*^9}, {3.503064234778*^9, 3.50306425959*^9}, {
   3.503064405784*^9, 3.503064406451*^9}, {3.503064508274*^9, 
   3.503064508376*^9}, {3.503064571874*^9, 3.503064580869*^9}, {
   3.503069387369*^9, 3.503069391283*^9}, {3.5030694476070004`*^9, 
   3.503069452894*^9}, {3.50306968624*^9, 3.50306970431*^9}, {
   3.5030699119519997`*^9, 3.5030699139700003`*^9}, {3.5030700585299997`*^9, 
   3.503070059907*^9}, 3.503070932929*^9, {3.503071712278*^9, 
   3.5030718142390003`*^9}, {3.503071963775*^9, 3.503071964927*^9}, {
   3.503076976273*^9, 3.503076976822*^9}, {3.503077023894*^9, 
   3.503077024225*^9}, {3.503077149414*^9, 3.5030771671949997`*^9}, {
   3.5093845390101037`*^9, 3.5093845403351035`*^9}, {3.5093855798351035`*^9, 
   3.5093855833451033`*^9}, 3.5093864710561037`*^9, {3.50945072558*^9, 
   3.509450725946*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "4"}], ";", 
  RowBox[{
   RowBox[{"inFCPLP", "[", "sp", "]"}], "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{"\[Theta]FCPLPx", "[", "sp", "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"FCPLPnormx", "[", "sp", "]"}], "=", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"inFCPLP", "[", "sp", "]"}], "[", "\[Theta]", "]"}], "]"}], 
      RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Theta]", ",", "\[Theta]min", ",", "\[Theta]max"}], "}"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.5093864792531033`*^9, 3.5093864948121033`*^9}}],

Cell[BoxData[{
 RowBox[{"ToExpression", "[", 
  RowBox[{"ToString", "[", 
   RowBox[{"Floor", "[", 
    RowBox[{
     RowBox[{"\[Theta]FCPLPx", "[", "4", "]"}], ",", 
     SuperscriptBox["10", 
      RowBox[{"-", "5."}]]}], "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FCPLPnormx", "[", "4", "]"}]}], "Input",
 CellChangeTimes->{{3.50307507916*^9, 3.503075217892*^9}, {
   3.5030752855439997`*^9, 3.503075341165*^9}, {3.503075417076*^9, 
   3.503075518875*^9}, 3.503078509127*^9, {3.5093846904491034`*^9, 
   3.509384693745104*^9}, {3.5093863711071033`*^9, 3.5093863730591035`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Theta]FCPLP", "[", "4", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.0157`", ",", 
       RowBox[{"-", "269.371`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.04712`", ",", 
       RowBox[{"-", "202.627`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.07853`", ",", 
       RowBox[{"-", "134.796`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.10995`", ",", 
       RowBox[{"-", "147.52`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.14137`", ",", 
       RowBox[{"-", "164.382`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.17278`", ",", 
       RowBox[{"-", "170.703`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.2042`", ",", 
       RowBox[{"-", "130.388`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.23561`", ",", 
       RowBox[{"-", "166.167`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.26703`", ",", 
       RowBox[{"-", "151.201`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.29845`", ",", 
       RowBox[{"-", "161.818`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.32986`", ",", 
       RowBox[{"-", "164.441`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.36128`", ",", 
       RowBox[{"-", "158.011`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.39269`", ",", 
       RowBox[{"-", "117.793`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.42411`", ",", 
       RowBox[{"-", "154.697`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.45553`", ",", 
       RowBox[{"-", "149.417`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.48694`", ",", 
       RowBox[{"-", "164.707`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.51836`", ",", 
       RowBox[{"-", "156.865`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.54977`", ",", 
       RowBox[{"-", "145.052`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.58119`", ",", 
       RowBox[{"-", "129.098`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.61261`", ",", 
       RowBox[{"-", "114.061`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.64402`", ",", 
       RowBox[{"-", "100.524`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.67544`", ",", 
       RowBox[{"-", "89.1962`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.70685`", ",", 
       RowBox[{"-", "79.492`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.73827`", ",", 
       RowBox[{"-", "70.8764`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.76969`", ",", 
       RowBox[{"-", "62.8647`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.8011`", ",", 
       RowBox[{"-", "54.6202`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.83252`", ",", 
       RowBox[{"-", "47.2263`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.86393`", ",", 
       RowBox[{"-", "40.8429`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.89535`", ",", 
       RowBox[{"-", "36.2166`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.92676`", ",", 
       RowBox[{"-", "33.3141`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.95818`", ",", 
       RowBox[{"-", "32.0638`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.9896`", ",", 
       RowBox[{"-", "31.6424`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.02101`", ",", 
       RowBox[{"-", "32.4211`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.05243`", ",", 
       RowBox[{"-", "34.8943`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.08384`", ",", 
       RowBox[{"-", "38.8086`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.11526`", ",", 
       RowBox[{"-", "44.4144`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.14668`", ",", 
       RowBox[{"-", "48.4919`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.17809`", ",", 
       RowBox[{"-", "49.2953`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.20951`", ",", 
       RowBox[{"-", "50.2486`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.24092`", ",", 
       RowBox[{"-", "52.9009`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.27234`", ",", 
       RowBox[{"-", "56.4343`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.30376`", ",", 
       RowBox[{"-", "60.6078`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.33517`", ",", 
       RowBox[{"-", "64.8887`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.36659`", ",", 
       RowBox[{"-", "67.6031`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.398`", ",", 
       RowBox[{"-", "70.3478`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.42942`", ",", 
       RowBox[{"-", "73.6323`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.46084`", ",", 
       RowBox[{"-", "75.7928`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.49225`", ",", 
       RowBox[{"-", "74.1931`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.52367`", ",", 
       RowBox[{"-", "73.1237`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.55508`", ",", 
       RowBox[{"-", "75.4679`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.5865`", ",", 
       RowBox[{"-", "77.5033`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.61792`", ",", 
       RowBox[{"-", "74.1846`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.64933`", ",", 
       RowBox[{"-", "68.7115`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.68075`", ",", 
       RowBox[{"-", "63.267`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.71216`", ",", 
       RowBox[{"-", "58.0986`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.74358`", ",", 
       RowBox[{"-", "54.4375`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.77499`", ",", 
       RowBox[{"-", "50.6072`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.80641`", ",", 
       RowBox[{"-", "49.004`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.83783`", ",", 
       RowBox[{"-", "49.9936`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.86924`", ",", 
       RowBox[{"-", "47.7866`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.90066`", ",", 
       RowBox[{"-", "49.0823`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.93207`", ",", 
       RowBox[{"-", "37.458`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.96349`", ",", 
       RowBox[{"-", "29.7078`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.99491`", ",", 
       RowBox[{"-", "25.9748`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.02632`", ",", 
       RowBox[{"-", "24.7645`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.05774`", ",", 
       RowBox[{"-", "22.1446`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.08915`", ",", 
       RowBox[{"-", "22.5362`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.12057`", ",", 
       RowBox[{"-", "20.1841`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.15199`", ",", 
       RowBox[{"-", "16.8008`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.1834`", ",", 
       RowBox[{"-", "13.4068`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.21482`", ",", 
       RowBox[{"-", "10.2875`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.24623`", ",", 
       RowBox[{"-", "10.487`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.27765`", ",", 
       RowBox[{"-", "13.7969`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.30907`", ",", 
       RowBox[{"-", "19.5913`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.34048`", ",", 
       RowBox[{"-", "27.3015`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.3719`", ",", 
       RowBox[{"-", "35.4131`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.40331`", ",", 
       RowBox[{"-", "39.1995`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.43473`", ",", 
       RowBox[{"-", "31.6439`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.46615`", ",", 
       RowBox[{"-", "26.5349`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.49756`", ",", 
       RowBox[{"-", "26.8363`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.52898`", ",", 
       RowBox[{"-", "30.9926`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.56039`", ",", 
       RowBox[{"-", "28.5973`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.59181`", ",", 
       RowBox[{"-", "24.2206`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.62322`", ",", 
       RowBox[{"-", "22.7526`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.65464`", ",", 
       RowBox[{"-", "24.4379`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.68606`", ",", 
       RowBox[{"-", "29.1126`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.71747`", ",", 
       RowBox[{"-", "34.7137`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.74889`", ",", 
       RowBox[{"-", "43.8553`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.7803`", ",", 
       RowBox[{"-", "59.2755`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.81172`", ",", 
       RowBox[{"-", "64.9347`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.84314`", ",", 
       RowBox[{"-", "59.5511`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.87455`", ",", 
       RowBox[{"-", "74.6704`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.90597`", ",", 
       RowBox[{"-", "109.853`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.93738`", ",", 
       RowBox[{"-", "180.543`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.9688`", ",", 
       RowBox[{"-", "213.025`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.00022`", ",", 
       RowBox[{"-", "235.759`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.03163`", ",", 
       RowBox[{"-", "249.521`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.06305`", ",", 
       RowBox[{"-", "229.21`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.09446`", ",", 
       RowBox[{"-", "181.434`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.12588`", ",", 
       RowBox[{"-", "133.267`"}]}], "}"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Theta]FCPLPx", "[", "4", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.0157`", ",", 
       RowBox[{"-", "338.351`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.04712`", ",", 
       RowBox[{"-", "187.509`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.07853`", ",", 
       RowBox[{"-", "98.1804`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.10995`", ",", 
       RowBox[{"-", "67.8677`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.14137`", ",", 
       RowBox[{"-", "64.6542`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.17278`", ",", 
       RowBox[{"-", "73.9027`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.2042`", ",", 
       RowBox[{"-", "58.165`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.23561`", ",", 
       RowBox[{"-", "31.9573`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.26703`", ",", 
       RowBox[{"-", "33.6843`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.29845`", ",", 
       RowBox[{"-", "52.3862`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.32986`", ",", 
       RowBox[{"-", "59.298`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.36128`", ",", 
       RowBox[{"-", "80.6994`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.39269`", ",", 
       RowBox[{"-", "90.7804`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.42411`", ",", 
       RowBox[{"-", "130.854`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.45553`", ",", 
       RowBox[{"-", "161.311`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.48694`", ",", 
       RowBox[{"-", "152.325`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.51836`", ",", 
       RowBox[{"-", "142.956`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.54977`", ",", 
       RowBox[{"-", "131.732`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.58119`", ",", 
       RowBox[{"-", "119.338`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.61261`", ",", 
       RowBox[{"-", "101.718`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.64402`", ",", 
       RowBox[{"-", "85.5237`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.67544`", ",", 
       RowBox[{"-", "72.0685`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.70685`", ",", 
       RowBox[{"-", "60.1125`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.73827`", ",", 
       RowBox[{"-", "48.7365`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.76969`", ",", 
       RowBox[{"-", "38.8526`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.8011`", ",", 
       RowBox[{"-", "31.2151`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.83252`", ",", 
       RowBox[{"-", "25.2337`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.86393`", ",", 
       RowBox[{"-", "20.714`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.89535`", ",", 
       RowBox[{"-", "17.4679`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.92676`", ",", 
       RowBox[{"-", "15.964`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.95818`", ",", 
       RowBox[{"-", "15.4409`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.9896`", ",", 
       RowBox[{"-", "16.1336`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.02101`", ",", 
       RowBox[{"-", "17.7928`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.05243`", ",", 
       RowBox[{"-", "20.5505`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.08384`", ",", 
       RowBox[{"-", "24.3925`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.11526`", ",", 
       RowBox[{"-", "28.8156`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.14668`", ",", 
       RowBox[{"-", "34.2944`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.17809`", ",", 
       RowBox[{"-", "39.823`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.20951`", ",", 
       RowBox[{"-", "42.4941`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.24092`", ",", 
       RowBox[{"-", "46.3876`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.27234`", ",", 
       RowBox[{"-", "50.1579`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.30376`", ",", 
       RowBox[{"-", "53.4066`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.33517`", ",", 
       RowBox[{"-", "55.829`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.36659`", ",", 
       RowBox[{"-", "57.7371`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.398`", ",", 
       RowBox[{"-", "59.6306`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.42942`", ",", 
       RowBox[{"-", "62.8006`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.46084`", ",", 
       RowBox[{"-", "64.7735`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.49225`", ",", 
       RowBox[{"-", "64.9064`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.52367`", ",", 
       RowBox[{"-", "64.2697`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.55508`", ",", 
       RowBox[{"-", "60.6874`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.5865`", ",", 
       RowBox[{"-", "58.1164`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.61792`", ",", 
       RowBox[{"-", "58.8894`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.64933`", ",", 
       RowBox[{"-", "60.8006`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.68075`", ",", 
       RowBox[{"-", "61.9772`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.71216`", ",", 
       RowBox[{"-", "61.1208`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.74358`", ",", 
       RowBox[{"-", "57.5326`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.77499`", ",", 
       RowBox[{"-", "53.5234`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.80641`", ",", 
       RowBox[{"-", "50.7972`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.83783`", ",", 
       RowBox[{"-", "49.3368`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.86924`", ",", 
       RowBox[{"-", "47.0292`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.90066`", ",", 
       RowBox[{"-", "43.017`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.93207`", ",", 
       RowBox[{"-", "38.0751`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.96349`", ",", 
       RowBox[{"-", "33.3356`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.99491`", ",", 
       RowBox[{"-", "29.1944`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.02632`", ",", 
       RowBox[{"-", "25.4267`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.05774`", ",", 
       RowBox[{"-", "21.9425`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.08915`", ",", 
       RowBox[{"-", "18.8146`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.12057`", ",", 
       RowBox[{"-", "16.2572`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.15199`", ",", 
       RowBox[{"-", "14.4217`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.1834`", ",", 
       RowBox[{"-", "13.4324`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.21482`", ",", 
       RowBox[{"-", "13.494`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.24623`", ",", 
       RowBox[{"-", "15.1559`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.27765`", ",", 
       RowBox[{"-", "19.1569`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.30907`", ",", 
       RowBox[{"-", "25.5276`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.34048`", ",", 
       RowBox[{"-", "34.0445`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.3719`", ",", 
       RowBox[{"-", "45.1134`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.40331`", ",", 
       RowBox[{"-", "57.5196`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.43473`", ",", 
       RowBox[{"-", "63.3901`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.46615`", ",", 
       RowBox[{"-", "40.2897`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.49756`", ",", 
       RowBox[{"-", "26.9414`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.52898`", ",", 
       RowBox[{"-", "19.7796`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.56039`", ",", 
       RowBox[{"-", "15.6535`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.59181`", ",", 
       RowBox[{"-", "13.2141`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.62322`", ",", 
       RowBox[{"-", "11.8165`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.65464`", ",", 
       RowBox[{"-", "12.0823`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.68606`", ",", 
       RowBox[{"-", "13.2059`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.71747`", ",", 
       RowBox[{"-", "15.8172`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.74889`", ",", 
       RowBox[{"-", "23.4324`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.7803`", ",", 
       RowBox[{"-", "34.8519`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.81172`", ",", 
       RowBox[{"-", "47.6506`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.84314`", ",", 
       RowBox[{"-", "65.9541`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.87455`", ",", 
       RowBox[{"-", "100.634`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.90597`", ",", 
       RowBox[{"-", "138.064`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.93738`", ",", 
       RowBox[{"-", "172.894`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2.9688`", ",", 
       RowBox[{"-", "204.603`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.00022`", ",", 
       RowBox[{"-", "300.025`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.03163`", ",", 
       RowBox[{"-", "339.35`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.06305`", ",", 
       RowBox[{"-", "353.654`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.09446`", ",", 
       RowBox[{"-", "377.304`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.12588`", ",", 
       RowBox[{"-", "345.611`"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FCPLPnorm", "[", "4", "]"}], "=", "1.573270040406384`*^-6"}], ";", 
  RowBox[{
   RowBox[{"FCPLPnormx", "[", "4", "]"}], "=", "3.6631833694467267`*^-7"}], 
  ";", 
  RowBox[{"ord", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"inFCPLP", "[", "4", "]"}], "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{
     RowBox[{"\[Theta]FCPLP", "[", "4", "]"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"inFCPLPx", "[", "4", "]"}], "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{
     RowBox[{"\[Theta]FCPLPx", "[", "4", "]"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5030783968389997`*^9, 3.5030784001879997`*^9}, {
   3.503078515342*^9, 3.503078539546*^9}, {3.50307859513*^9, 
   3.50307860573*^9}, {3.503079770328*^9, 3.503079820771*^9}, {
   3.503080094848*^9, 3.503080100949*^9}, {3.5093846186181035`*^9, 
   3.5093846191231036`*^9}, 3.509385531094104*^9, {3.5093855669461036`*^9, 
   3.5093855712651033`*^9}, {3.5093865026631036`*^9, 
   3.5093865233721037`*^9}, {3.509386573257104*^9, 3.5093865733591037`*^9}, {
   3.5093866222581034`*^9, 3.5093866318171034`*^9}, {3.509448415774*^9, 
   3.50944844565*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"thic", "=", "3"}], ";", 
  RowBox[{"mysize", "=", "20"}], ";", 
  RowBox[{"SetOptions", "[", 
   RowBox[{"LogPlot", ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "thic", "]"}]}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"mysize", ",", 
       RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "}"}]}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Inclination angle \[Theta] [deg]\>\"", ",", 
       "\"\<Probability density\>\""}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}], ";", 
  RowBox[{"col", "=", 
   RowBox[{"{", 
    RowBox[{"Black", ",", "Green", ",", "Brown", ",", "Blue", ",", "Cyan"}], 
    "}"}]}], ";", 
  RowBox[{"xxlen", "=", "100"}], ";", 
  RowBox[{"\[Theta]min", "=", 
   RowBox[{"0.5", 
    FractionBox["\[Pi]", "xxlen"]}]}], ";", 
  RowBox[{"\[Theta]max", "=", 
   RowBox[{"\[Pi]", "-", "\[Theta]min"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"FCPLPplot", "[", "sp", "]"}], "=", 
     RowBox[{"LogPlot", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"inFCPLP", "[", "sp", "]"}], "[", 
            RowBox[{"\[Pi]", "-", 
             RowBox[{
              FractionBox["\[Pi]", "180"], "\[Theta]"}]}], "]"}], "]"}], 
          RowBox[{"FCPLPnorm", "[", "4", "]"}]], ",", 
         FractionBox[
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"inFCPLPx", "[", "sp", "]"}], "[", 
            RowBox[{"\[Pi]", "-", 
             RowBox[{
              FractionBox["\[Pi]", "180"], "\[Theta]"}]}], "]"}], "]"}], 
          RowBox[{"FCPLPnormx", "[", "4", "]"}]]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", 
         RowBox[{
          FractionBox["180", "\[Pi]"], "\[Theta]min"}], ",", 
         RowBox[{
          FractionBox["180", "\[Pi]"], "\[Theta]max"}]}], "}"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"40", ",", "67"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"1.5", " ", 
             SuperscriptBox["10", 
              RowBox[{"-", "2."}]]}], ",", "30"}], "}"}]}], "}"}]}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"RGBColor", "[", 
             RowBox[{"0.", ",", 
              FractionBox[
               RowBox[{"sp", "-", "1"}], "5"], ",", 
              RowBox[{"1", "-", 
               FractionBox[
                RowBox[{"sp", "-", "1"}], "5"]}]}], "]"}], ",", 
            RowBox[{"AbsoluteThickness", "[", "thic", "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"RGBColor", "[", 
             RowBox[{"0.", ",", 
              FractionBox[
               RowBox[{"sp", "-", "1"}], "5"], ",", 
              RowBox[{"1", "-", 
               FractionBox[
                RowBox[{"sp", "-", "1"}], "5"]}]}], "]"}], ",", 
            RowBox[{"AbsoluteThickness", "[", "thic", "]"}], ",", 
            RowBox[{"AbsoluteDashing", "[", 
             RowBox[{"{", 
              RowBox[{"10", ",", "7"}], "}"}], "]"}]}], "}"}]}], "}"}]}]}], 
      "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"sp", ",", "4", ",", "4"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Fplot", "[", "sp", "]"}], "=", 
    RowBox[{
     RowBox[{"LogPlot", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"inF", "[", "sp", "]"}], "[", 
          RowBox[{"\[Pi]", "-", 
           RowBox[{
            FractionBox["\[Pi]", "180"], "\[Theta]"}]}], "]"}], "]"}], 
        RowBox[{"Fnorm", "[", "4", "]"}]], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", 
         RowBox[{
          FractionBox["180", "\[Pi]"], "\[Theta]min"}], ",", 
         RowBox[{
          FractionBox["180", "\[Pi]"], "\[Theta]max"}]}], "}"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          SuperscriptBox["10", 
           RowBox[{"-", "2"}]], ",", "10"}], "}"}]}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"RGBColor", "[", 
           RowBox[{"0.", ",", 
            FractionBox[
             RowBox[{"sp", "-", "1"}], "5"], ",", 
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"sp", "-", "1"}], "5"]}]}], "]"}], ",", 
          RowBox[{"AbsoluteThickness", "[", "thic", "]"}]}], "}"}]}]}], "]"}],
      "\n", 
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"Fplot", "[", "2", "]"}], ",", 
       RowBox[{"Fplot", "[", "3", "]"}], ",", 
       RowBox[{"Fplot", "[", "4", "]"}], ",", 
       RowBox[{"Fplot", "[", "5", "]"}]}], "]"}]}]}], "*)"}]}], "\n", 
 RowBox[{"thpl", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"FCPLPplot", "[", "4", "]"}], ",", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"FCPLPplot", "[", "3", "]"}], ",", 
      RowBox[{"FCPLPplot", "[", "4", "]"}], ",", 
      RowBox[{"FCPLPplot", "[", "5", "]"}], ","}], "*)"}], 
    RowBox[{
    "PlotLabel", "\[Rule]", 
     "\"\<\[Rho](\[Theta],\!\(\*SubscriptBox[\(a\), \
\(*\)]\)=0.9|\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\)); RMS b and linear b \
models\>\""}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "\"\<C:\\\\study\\\\accretion\\\\! 2009 fall cfa\\\\GR Polarized \
modeling\\\\\>\"", "<>", "\"\<thpl.eps\>\""}], ",", "thpl", ",", 
   RowBox[{"\"\<EmbeddedFonts\>\"", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.4864813313206*^9, 3.486481525447*^9}, {
   3.4864816985134*^9, 3.486481818571*^9}, {3.4864820074245996`*^9, 
   3.4864820155366*^9}, {3.4864828134454*^9, 3.4864828478278*^9}, {
   3.4864828875453997`*^9, 3.4864829342518*^9}, {3.4864830928602*^9, 
   3.4864831015182*^9}, {3.486483211545*^9, 3.486483242901*^9}, {
   3.4864832866122*^9, 3.4864833305886*^9}, {3.486483384939*^9, 
   3.486483385407*^9}, {3.4864834463406*^9, 3.4864835035146*^9}, 
   3.4864835378970003`*^9, {3.486484912469*^9, 3.486484935627*^9}, {
   3.486485676634*^9, 3.486485685153*^9}, {3.486485769541*^9, 
   3.486485777212*^9}, {3.4864859200369997`*^9, 3.48648592798*^9}, 
   3.4864864015512*^9, {3.486726432856*^9, 3.486726437475*^9}, {
   3.4867264794*^9, 3.4867264828640003`*^9}, 3.486726676383*^9, {
   3.486728389196*^9, 3.486728392884*^9}, {3.489155180976533*^9, 
   3.4891552188221326`*^9}, {3.4891552510205326`*^9, 
   3.4891552645613327`*^9}, {3.489155295137333*^9, 3.4891552959797325`*^9}, {
   3.489155705821933*^9, 3.489155748097933*^9}, {3.503069205799*^9, 
   3.503069222317*^9}, {3.503071055508*^9, 3.503071058627*^9}, {
   3.503071478781*^9, 3.5030715013310003`*^9}, {3.5030716370690002`*^9, 
   3.503071639075*^9}, {3.503075790782*^9, 3.503075794072*^9}, {
   3.50307582459*^9, 3.50307582474*^9}, {3.503075891666*^9, 
   3.5030759190290003`*^9}, {3.5030760109370003`*^9, 3.503076036336*^9}, {
   3.50307647492*^9, 3.503076506575*^9}, {3.503076749908*^9, 
   3.5030767950620003`*^9}, {3.503076831076*^9, 3.503076848475*^9}, {
   3.5030784614110003`*^9, 3.503078472333*^9}, 3.5030786042860003`*^9, {
   3.503079834041*^9, 3.503079913317*^9}, {3.503079973203*^9, 
   3.503079973442*^9}, {3.503080030619*^9, 3.503080078742*^9}, {
   3.503155828074*^9, 3.50315582942*^9}, 3.503155872384*^9, {
   3.504289280023*^9, 3.504289295514*^9}, {3.504376759743*^9, 
   3.504376760174*^9}, {3.509386703035104*^9, 3.5093867140431037`*^9}, {
   3.509448387532*^9, 3.509448393273*^9}, {3.509448461174*^9, 
   3.509448504842*^9}, {3.509472308591*^9, 3.509472309466*^9}, {
   3.5101491335856*^9, 3.5101491345116*^9}, {3.5102333783986*^9, 
   3.5102333816496*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"PCPLP", "=", 
   RowBox[{"{", 
    RowBox[{
    "0.", ",", "0.000043904150829407224", ",", "1.2854899530533667`*^-7", ",",
      "1.561961249945853`*^-6", ",", "6.017011851705533`*^-7"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Theta]fun", "=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"inFCPLPx", "[", "sp", "]"}], "[", 
        RowBox[{"\[Pi]", "-", 
         RowBox[{
          FractionBox["\[Pi]", "180"], "\[Theta]"}]}], "]"}], "]"}], 
      RowBox[{"PCPLP", "[", 
       RowBox[{"[", "sp", "]"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"sp", ",", "4", ",", "4"}], "}"}]}], "]"}]}], ";", 
  RowBox[{"\[Theta]min", "=", "0.6"}], ";", 
  RowBox[{"\[Theta]max", "=", "1.3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"LogPlot", "[", 
  RowBox[{"\[Theta]fun", ",", 
   RowBox[{"{", 
    RowBox[{"\[Theta]", ",", "35", ",", "85"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Theta]mean", "=", 
   FractionBox[
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{"\[Theta]", " ", 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"inFCPLPx", "[", "sp", "]"}], "[", 
            RowBox[{"\[Pi]", "-", "\[Theta]"}], "]"}], "]"}], 
          RowBox[{"PCPLP", "[", 
           RowBox[{"[", "sp", "]"}], "]"}], 
          RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"sp", ",", "4", ",", "4"}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Theta]", ",", "\[Theta]min", ",", "\[Theta]max"}], "}"}]}], 
     "]"}], 
    RowBox[{"nno", "=", 
     RowBox[{"NIntegrate", "[", 
      RowBox[{
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"inFCPLPx", "[", "sp", "]"}], "[", 
            RowBox[{"\[Pi]", "-", "\[Theta]"}], "]"}], "]"}], 
          RowBox[{"PCPLP", "[", 
           RowBox[{"[", "sp", "]"}], "]"}], 
          RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"sp", ",", "4", ",", "4"}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", "\[Theta]min", ",", "\[Theta]max"}], "}"}]}],
       "]"}]}]]}], ";"}], "\n", 
 RowBox[{"Off", "[", 
  RowBox[{"NIntegrate", "::", "\"\<nlim\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"\[Delta]max", "=", 
  RowBox[{"FindRoot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"0.05", "nno"}], "==", 
     RowBox[{"NIntegrate", "[", 
      RowBox[{
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"inFCPLPx", "[", "sp", "]"}], "[", 
            RowBox[{"\[Pi]", "-", "\[Theta]"}], "]"}], "]"}], 
          RowBox[{"PCPLP", "[", 
           RowBox[{"[", "sp", "]"}], "]"}], 
          RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"sp", ",", "4", ",", "4"}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", 
         RowBox[{"\[Theta]mean", "+", "\[Delta]"}], ",", "\[Theta]max"}], 
        "}"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Delta]", ",", "0.01"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Delta]min", "=", 
  RowBox[{"FindRoot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"0.05", "nno"}], "==", 
     RowBox[{"NIntegrate", "[", 
      RowBox[{
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"inFCPLPx", "[", "sp", "]"}], "[", 
            RowBox[{"\[Pi]", "-", "\[Theta]"}], "]"}], "]"}], 
          RowBox[{"PCPLP", "[", 
           RowBox[{"[", "sp", "]"}], "]"}], 
          RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"sp", ",", "4", ",", "4"}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", "\[Theta]min", ",", 
         RowBox[{"\[Theta]mean", "-", "\[Delta]"}]}], "}"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Delta]", ",", "0.01"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Expectation value for the inclination angle = \>\"", ",", 
   RowBox[{
    FractionBox["180", "\[Pi]"], "\[Theta]mean"}], ",", "\"\<\[Degree]\>\""}],
   "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<90% confidence interval for inclination angle: \>\"", ",", 
   RowBox[{
    FractionBox["180", "\[Pi]"], 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Theta]mean", "-", "\[Delta]"}], "/.", "\[Delta]min"}], ",", 
      RowBox[{
       RowBox[{"\[Theta]mean", "+", "\[Delta]"}], "/.", "\[Delta]max"}]}], 
     "}"}]}], ",", "\"\<\[Degree]\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.486485033185*^9, 3.486485234974*^9}, {3.486485270459*^9,
    3.4864852969119997`*^9}, {3.486485513601*^9, 3.486485513865*^9}, 
   3.4864855668459997`*^9, {3.503076093609*^9, 3.503076108513*^9}, {
   3.5030761516289997`*^9, 3.5030762247060003`*^9}, {3.5030762631400003`*^9, 
   3.503076272672*^9}, {3.503080170016*^9, 3.503080177407*^9}, {
   3.503080210781*^9, 3.503080232676*^9}, {3.503155902742*^9, 
   3.503155948484*^9}, {3.509472328451*^9, 3.509472424318*^9}, {
   3.509472500889*^9, 3.5094725024960003`*^9}, {3.50947265335*^9, 
   3.5094726545109997`*^9}, {3.509472716557*^9, 3.5094727169709997`*^9}, {
   3.509472750075*^9, 3.509472753809*^9}, {3.5094728102539997`*^9, 
   3.509472859974*^9}}],

Cell[BoxData[
 RowBox[{"not", " ", "boosted"}]], "Input",
 CellChangeTimes->{{3.50947286895*^9, 3.509472870808*^9}}],

Cell[BoxData["boosted"], "Input",
 CellChangeTimes->{{3.509472843856*^9, 3.509472845521*^9}}],

Cell[BoxData["20"], "Input",
 CellChangeTimes->{
  3.4864857956879997`*^9, {3.4864860350880003`*^9, 3.48648603524*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "inclined images (new Figure 11) - ",
 StyleBox["done",
  FontColor->RGBColor[0, 0, 1]]
}], "Subsection",
 CellChangeTimes->{{3.486466498406*^9, 3.486466503158*^9}, {3.486471838413*^9,
    3.4864718415299997`*^9}, {3.487437875091*^9, 3.487437878281*^9}, 
   3.487437974116*^9, {3.4891560838963327`*^9, 3.4891560871567326`*^9}, {
   3.502627719071*^9, 3.5026277251029997`*^9}, {3.5291647600854893`*^9, 
   3.5291647664048505`*^9}, {3.529321844438022*^9, 3.5293218445090265`*^9}, {
   3.52932790156304*^9, 3.5293279047632227`*^9}, {3.5293345698524437`*^9, 
   3.529334570500481*^9}, {3.539993803029244*^9, 3.5399938068234615`*^9}, 
   3.5403002837729273`*^9, {3.5403006087045116`*^9, 3.5403006109376397`*^9}}],

Cell[CellGroupData[{

Cell["cloud - changing density - for talks", "Subsubsection",
 CellChangeTimes->{{3.5379867458723617`*^9, 3.5379867556649218`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "0.5", "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{"Clear", "[", "totI", "]"}], ";", 
    RowBox[{
    "dir", "=", "\"\<E:\\\\GRMHD\\\\movies\\\\cloud\\\\dens1000\\\\\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Off", "[", 
     StyleBox[
      RowBox[{"InterpolatingFunction", "::", "dmval"}], "MessageName"], "]"}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fmin", "=", "6950"}], ";", 
    RowBox[{"fmax", "=", "9950"}], ";", 
    RowBox[{"ind", "=", "11"}], ";", 
    RowBox[{"sep", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"ind", "-", "1"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sss", "=", "1.0"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ph05", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"180", "-", "\[InvisibleSpace]", "89.0"}], ")"}], 
      "\[Degree]"}]}], ";"}], 
   RowBox[{"(*", 
    RowBox[{
    "from", " ", "actual", " ", "mean", " ", "position", " ", "angles"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"taxx", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"namefile", "=", 
         RowBox[{"dir", "<>", "\"\<shotimag50th203fn\>\"", "<>", 
          RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<.dat\>\""}]}], 
        ";", 
        RowBox[{"fi11", "=", 
         RowBox[{"OpenRead", "[", 
          RowBox[{"namefile", ",", 
           RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
        RowBox[{"params", "=", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"a", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", 
        RowBox[{"th", "=", 
         RowBox[{"Round", "[", 
          RowBox[{
           RowBox[{"Round", "[", 
            RowBox[{
             FractionBox["180", "\[Pi]"], 
             RowBox[{"(", 
              RowBox[{"\[Pi]", "-", 
               RowBox[{"params", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "10"}], "]"}], 
           "/", "10."}], "]"}]}], ";", 
        RowBox[{"nxy", "=", 
         RowBox[{"Round", "[", 
          RowBox[{"params", "[", 
           RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
        RowBox[{"nu", "=", 
         RowBox[{"Round", "[", 
          RowBox[{"params", "[", 
           RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
        RowBox[{"maxy", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "5", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"heat", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "6", "]"}], "]"}]}], ";", 
        RowBox[{"rnohor", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "7", "]"}], "]"}]}], ";", 
        RowBox[{"inten", "=", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
        RowBox[{"Close", "[", "fi11", "]"}], ";", 
        RowBox[{"partres", "=", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{"inten", ",", "5"}], "]"}], ",", 
           RowBox[{"nxy", "+", "1"}]}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"partres", "=", 
     FractionBox[
      RowBox[{"Total", "[", 
       RowBox[{"taxx", ",", 
        RowBox[{"{", "1", "}"}]}], "]"}], "ind"]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"de", "=", 
     SuperscriptBox["10", 
      RowBox[{"-", "20."}]]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"li05", "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{
         RowBox[{"partres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "+", "de"}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"scale05", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"Mean", "[", 
       RowBox[{
        RowBox[{"Sort", "[", 
         RowBox[{"Flatten", "[", 
          RowBox[{"partres", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], "]"}],
         "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"-", "10"}], ";;", 
          RowBox[{"-", "5"}]}], "]"}], "]"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"scale05", "=", 
      RowBox[{"Log", "[", 
       RowBox[{"Max", "[", 
        RowBox[{"partres", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}],
      ";"}], "*)"}], 
   RowBox[{
    RowBox[{"csc", "=", "1"}], ";", 
    RowBox[{"mysize", "=", "20"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"con", "=", "10"}], ";", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
       RowBox[{"contrast", " ", "con"}], "\[Implies]", 
       RowBox[{
       "luminosity", " ", "con", " ", "times", " ", "lower", " ", "is", " ", 
        "black"}]}], ",", 
      RowBox[{"max", " ", "luminosity", " ", "is", " ", "white"}]}], "*)"}], 
    RowBox[{"totI05", "=", 
     RowBox[{"DensityPlot", "[", 
      RowBox[{
       RowBox[{"rr", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"li05", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"y", " ", 
                RowBox[{"Cos", "[", "ph05", "]"}]}], "+", 
               RowBox[{"x", " ", 
                RowBox[{"Sin", "[", "ph05", "]"}]}]}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "y"}], " ", 
                RowBox[{"Sin", "[", "ph05", "]"}]}], "+", 
               RowBox[{"x", " ", 
                RowBox[{"Cos", "[", "ph05", "]"}]}]}]}], "]"}], "-", 
            "scale05"}], ")"}], "/", 
          RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{
          RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
         RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", 
         RowBox[{
          RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
         RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
       RowBox[{"Axes", "\[Rule]", "False"}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
       RowBox[{"PlotPoints", "\[Rule]", "150"}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"RGBColor", "[", 
           RowBox[{
            RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
            RowBox[{"#1", " ", "csc"}], ",", 
            RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
       RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"I09line", "=", "\"\<For 10x accretion rate\>\""}], ",", 
             RowBox[{"mysize", "+", "10"}], ",", "Bold", ",", "Pink"}], "]"}],
            ",", 
           RowBox[{"Scaled", "[", 
            RowBox[{"{", 
             RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", 
           RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
      "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"dir", "<>", "\"\<totI.jpg\>\""}], ",", "totI05", ",", 
     RowBox[{"\"\<CompressionLevel\>\"", "\[Rule]", "0"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "450"}]}], "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1"}], "]"}], "]"}], "=", 
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "2"}], "]"}], "]"}]}], ";", 
    RowBox[{"hei", "=", 
     RowBox[{"2.", "/", "nxy"}]}], ";", 
    RowBox[{"mult", "=", 
     RowBox[{"66.4648", "*", "maxy", "*", "maxy", "*", "hei", "*", "hei"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{"\"\<Total flux is \>\"", ",", 
     RowBox[{"mult", " ", 
      RowBox[{"Total", "[", 
       RowBox[{"Flatten", "[", 
        RowBox[{"partres", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}],
      ",", "\"\<Jy\>\""}], "]"}]}]}]], "Input",
 CellChangeTimes->{
  3.5292487335294943`*^9, {3.529248764291254*^9, 3.5292487745868425`*^9}, {
   3.5292488317851143`*^9, 3.529248867663166*^9}, {3.5292500265794525`*^9, 
   3.5292500268214664`*^9}, {3.529330232786378*^9, 3.5293302575687957`*^9}, {
   3.529330361519741*^9, 3.529330365310958*^9}, {3.5293304270884914`*^9, 
   3.52933045486208*^9}, {3.5293305276562433`*^9, 3.5293305403679705`*^9}, {
   3.529330594311056*^9, 3.52933062550284*^9}, {3.5293306781258497`*^9, 
   3.5293307005561333`*^9}, 3.5293307936444573`*^9, {3.5293311441915073`*^9, 
   3.529331146109617*^9}, {3.53798595996041*^9, 3.5379859618825197`*^9}, {
   3.537986769290701*^9, 3.5379867733399324`*^9}, {3.5379868252299004`*^9, 
   3.5379868916607*^9}, {3.537986922634472*^9, 3.5379869313519707`*^9}, {
   3.5379871570868816`*^9, 3.5379871688335533`*^9}, {3.537987984089184*^9, 
   3.537987995953862*^9}, {3.537988030207821*^9, 3.537988047783827*^9}, {
   3.5379881244002085`*^9, 3.537988124549217*^9}, {3.537988523407031*^9, 
   3.5379885461623325`*^9}, {3.537989017689302*^9, 3.5379890453208823`*^9}, {
   3.537989514850738*^9, 3.5379895185689507`*^9}, {3.5379895582892227`*^9, 
   3.5379895588542547`*^9}, {3.53799001037508*^9, 3.537990060353939*^9}, {
   3.537990205051215*^9, 3.5379902272464848`*^9}, {3.5379902579722424`*^9, 
   3.5379902582392573`*^9}, {3.5379904179353914`*^9, 3.53799051371887*^9}, {
   3.5379907075249553`*^9, 3.537990710911149*^9}, {3.5379910960651784`*^9, 
   3.5379910993553667`*^9}, {3.537991992879473*^9, 3.537991996898703*^9}, {
   3.5379929638850117`*^9, 3.537992969906356*^9}, {3.5379955048713474`*^9, 
   3.5379955290167284`*^9}, {3.5379967050429935`*^9, 3.537996705156*^9}, {
   3.537999615952488*^9, 3.537999621088782*^9}, {3.5380013768962083`*^9, 
   3.538001380743428*^9}, {3.5380462384238467`*^9, 3.5380462523906455`*^9}, {
   3.538046777917704*^9, 3.538046778115715*^9}, {3.5380468344399366`*^9, 
   3.5380469153995676`*^9}, {3.538047109634677*^9, 3.5380471133258886`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.", ",", "3.079418479144744`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.5", ",", "4.632430584217032`"}], 
    "\[InvisibleSpace]\[InvisibleSpace]", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2.", ",", "6.027383075037517`"}], "\[InvisibleSpace]", "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"3.", ",", "8.568277326565086`"}], "\[InvisibleSpace]", "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"4.5", ",", "12.102163230180082`"}], 
    "\[InvisibleSpace]\[InvisibleSpace]", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7.0", ",", "17.63300821494997`"}], 
    "\[InvisibleSpace]\[InvisibleSpace]", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10.0", ",", "23.51507062480937`"}], "\[InvisibleSpace]", "}"}]}],
   "}"}]], "Input",
 CellChangeTimes->{{3.5379877769243345`*^9, 3.5379877813405867`*^9}, {
   3.5379880121797905`*^9, 3.5379880248435144`*^9}, {3.537988064961809*^9, 
   3.5379880956915665`*^9}, {3.5379890320931263`*^9, 
   3.5379890596957045`*^9}, {3.5379895437213893`*^9, 3.53798955509904*^9}, {
   3.5379900212377014`*^9, 3.53799005197246*^9}, 3.5379911389446306`*^9, {
   3.5379918547795744`*^9, 3.537991861483958*^9}, 3.5379920142666965`*^9, 
   3.5379921259140825`*^9, 3.537992991993619*^9, 3.53799552519451*^9, {
   3.53799682386579*^9, 3.537996828191037*^9}, 3.537999645791195*^9, 
   3.538001400759573*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["new averaged image", "Subsubsection",
 CellChangeTimes->{{3.5293303465378847`*^9, 3.5293303539143066`*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Clear", "[", "totI", "]"}], ";", 
    RowBox[{
    "dir", "=", 
     "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2012Feb_full\\\\\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Off", "[", 
     StyleBox[
      RowBox[{"InterpolatingFunction", "::", "dmval"}], "MessageName"], "]"}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fmin", "=", "6850"}], ";", 
    RowBox[{"fmax", "=", "9850"}], ";", 
    RowBox[{"ind", "=", "21"}], ";", 
    RowBox[{"sep", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"ind", "-", "1"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fmin", "=", 
     RowBox[{"fmax", "=", "8650"}]}], ";", 
    RowBox[{"ind", "=", "1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"taxx", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
        "namefile", "=", 
         "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\shotimag0th73fn8650_301.\
dat\>\""}], ";", 
        RowBox[{"fi11", "=", 
         RowBox[{"OpenRead", "[", 
          RowBox[{"namefile", ",", 
           RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
        RowBox[{"params", "=", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"a", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", 
        RowBox[{"th", "=", 
         RowBox[{"Round", "[", 
          RowBox[{
           RowBox[{"Round", "[", 
            RowBox[{
             FractionBox["180", "\[Pi]"], 
             RowBox[{"(", 
              RowBox[{"\[Pi]", "-", 
               RowBox[{"params", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "10"}], "]"}], 
           "/", "10."}], "]"}]}], ";", 
        RowBox[{"nxy", "=", 
         RowBox[{"Round", "[", 
          RowBox[{"params", "[", 
           RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
        RowBox[{"nu", "=", 
         RowBox[{"Round", "[", 
          RowBox[{"params", "[", 
           RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
        RowBox[{"maxy", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "5", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"heat", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "6", "]"}], "]"}]}], ";", 
        RowBox[{"rnohor", "=", 
         RowBox[{"params", "[", 
          RowBox[{"[", "7", "]"}], "]"}]}], ";", 
        RowBox[{"inten", "=", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
        RowBox[{"Close", "[", "fi11", "]"}], ";", 
        RowBox[{"partres", "=", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{"inten", ",", "5"}], "]"}], ",", 
           RowBox[{"nxy", "+", "1"}]}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"partres", "=", 
     FractionBox[
      RowBox[{"Total", "[", 
       RowBox[{"taxx", ",", 
        RowBox[{"{", "1", "}"}]}], "]"}], "ind"]}], ";", 
    RowBox[{"de", "=", 
     SuperscriptBox["10", 
      RowBox[{"-", "20."}]]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"li09", "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{
         RowBox[{"partres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "+", "de"}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"scale09", "=", 
     RowBox[{"Log", "[", 
      RowBox[{"Mean", "[", 
       RowBox[{
        RowBox[{"Sort", "[", 
         RowBox[{"Flatten", "[", 
          RowBox[{"partres", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], "]"}],
         "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"-", "10"}], ";;", 
          RowBox[{"-", "5"}]}], "]"}], "]"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"csc", "=", "1"}], ";", 
    RowBox[{"mysize", "=", "20"}], ";", 
    RowBox[{"sss", "=", "0.83"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ph05", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"180", "-", "115.30"}], ")"}], "\[Degree]"}]}], ";", 
    RowBox[{"ph09", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"180", "-", "\[InvisibleSpace]", "120.29"}], ")"}], 
      "\[Degree]"}]}], ";"}], 
   RowBox[{"(*", 
    RowBox[{
    "from", " ", "actual", " ", "mean", " ", "position", " ", "angles"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"con", "=", "20"}], ";", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
       RowBox[{"contrast", " ", "con"}], "\[Implies]", 
       RowBox[{
       "luminosity", " ", "con", " ", "times", " ", "lower", " ", "is", " ", 
        "black"}]}], ",", 
      RowBox[{"max", " ", "luminosity", " ", "is", " ", "white"}]}], "*)"}], 
    RowBox[{"totI09", "=", 
     RowBox[{"DensityPlot", "[", 
      RowBox[{
       RowBox[{"rr", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"li09", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"y", " ", 
                RowBox[{"Cos", "[", "ph09", "]"}]}], "+", 
               RowBox[{"x", " ", 
                RowBox[{"Sin", "[", "ph09", "]"}]}]}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "y"}], " ", 
                RowBox[{"Sin", "[", "ph09", "]"}]}], "+", 
               RowBox[{"x", " ", 
                RowBox[{"Cos", "[", "ph09", "]"}]}]}]}], "]"}], "-", 
            "scale09"}], ")"}], "/", 
          RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{
          RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
         RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", 
         RowBox[{
          RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
         RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
       RowBox[{"Axes", "\[Rule]", "False"}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
       RowBox[{"PlotPoints", "\[Rule]", "150"}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"RGBColor", "[", 
           RowBox[{
            RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
            RowBox[{"#1", " ", "csc"}], ",", 
            RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
       RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"I05line", "=", 
              RowBox[{
              "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): \
\!\(\*SubscriptBox[\(a\), \(*\)]\)=\>\"", "<>", 
               RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
               "\"\<GHz,   \[Theta]=\>\"", "<>", 
               RowBox[{"ToString", "[", "th", "]"}], "<>", 
               "\"\<\[Degree]\>\""}]}], ",", 
             RowBox[{"mysize", "-", "2"}], ",", "Bold", ",", "Pink"}], "]"}], 
           ",", 
           RowBox[{"Scaled", "[", 
            RowBox[{"{", 
             RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0"}], "}"}], ",", 
           RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
      "]"}]}]}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.545492914912758*^9, 3.5454930315594296`*^9}, 
   3.5454931047416153`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "incorrect", " ", "lookup", " ", "for", " ", "transformation", " ", 
   "matrix"}], ",", " ", 
  RowBox[{
  "but", " ", "correct", " ", "lookup", " ", "for", " ", 
   "quantities"}]}]], "Input",
 CellChangeTimes->{{3.5454932804536657`*^9, 3.545493300416807*^9}}],

Cell[BoxData[
 RowBox[{"Fully", " ", "cut", " ", "polar", " ", "region"}]], "Input",
 CellChangeTimes->{{3.5454931351453543`*^9, 3.5454931368664527`*^9}, {
  3.5454933335687037`*^9, 3.5454933390650177`*^9}}],

Cell[BoxData["nxy"], "Input",
 CellChangeTimes->{{3.5540498812559643`*^9, 3.554049882293023*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.5540501063428383`*^9, 3.5540501084849606`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dd", "=", "20"}], ";", 
  RowBox[{"ListDensityPlot", "[", 
   RowBox[{"partres", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{"nxy", "-", "1"}], "2"], "-", "dd"}], ";;", 
       RowBox[{
        FractionBox[
         RowBox[{"nxy", "-", "1"}], "2"], "+", "dd"}]}], " ", ",", 
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{"nxy", "-", "1"}], "2"], "+", 
        RowBox[{"2", "dd"}]}], ";;", 
       RowBox[{
        FractionBox[
         RowBox[{"nxy", "-", "1"}], "2"], "+", 
        RowBox[{"3", "dd"}]}]}], " ", ",", "1"}], "]"}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Histogram", "[", "papa", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Histogram", "[", 
   RowBox[{
    RowBox[{"Flatten", "[", 
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"2", ";;", 
         RowBox[{"-", "1"}]}], ",", 
        RowBox[{"2", ";;", 
         RowBox[{"-", "1"}]}], ",", "1"}], "]"}], "]"}], "]"}], ",", 
    "\"\<Log\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Histogram", "[", 
  RowBox[{
   RowBox[{"Flatten", "[", 
    FractionBox[
     SqrtBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"partres", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", 
            RowBox[{"-", "1"}]}], ",", 
           RowBox[{"2", ";;", 
            RowBox[{"-", "1"}]}], ",", "2"}], "]"}], "]"}], "2"], "+", 
       SuperscriptBox[
        RowBox[{"partres", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", 
            RowBox[{"-", "1"}]}], ",", 
           RowBox[{"2", ";;", 
            RowBox[{"-", "1"}]}], ",", "3"}], "]"}], "]"}], "2"]}]], 
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"2", ";;", 
         RowBox[{"-", "1"}]}], ",", 
        RowBox[{"2", ";;", 
         RowBox[{"-", "1"}]}], ",", "1"}], "]"}], "]"}]], "]"}], ",", 
   "\"\<Log\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Histogram", "[", 
  RowBox[{
   RowBox[{"Flatten", "[", 
    RowBox[{"Abs", "[", 
     FractionBox[
      RowBox[{"partres", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"2", ";;", 
          RowBox[{"-", "1"}]}], ",", 
         RowBox[{"2", ";;", 
          RowBox[{"-", "1"}]}], ",", "3"}], "]"}], "]"}], 
      RowBox[{"partres", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"2", ";;", 
          RowBox[{"-", "1"}]}], ",", 
         RowBox[{"2", ";;", 
          RowBox[{"-", "1"}]}], ",", "1"}], "]"}], "]"}]], "]"}], "]"}], ",", 
   "\"\<Log\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.5540498955347805`*^9, 3.554050002239884*^9}, {
  3.5540500326516232`*^9, 3.5540501664622765`*^9}, {3.5540502095777426`*^9, 
  3.5540502116498613`*^9}, {3.5540505549764986`*^9, 3.554050571235429*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "totI", "]"}], ";", 
  RowBox[{
  "dir", "=", 
   "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2012Feb_full\\\\\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Off", "[", 
   StyleBox[
    RowBox[{"InterpolatingFunction", "::", "dmval"}], "MessageName"], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fmin", "=", "6850"}], ";", 
  RowBox[{"fmax", "=", "9850"}], ";", 
  RowBox[{"ind", "=", "21"}], ";", 
  RowBox[{"sep", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"ind", "-", "1"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"taxx", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"namefile", "=", 
       RowBox[{"dir", "<>", "\"\<shotimag98th214fn\>\"", "<>", 
        RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<_401.dat\>\""}]}], 
      ";", 
      RowBox[{"fi11", "=", 
       RowBox[{"OpenRead", "[", 
        RowBox[{"namefile", ",", 
         RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
      RowBox[{"params", "=", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"a", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", 
      RowBox[{"th", "=", 
       RowBox[{"Round", "[", 
        RowBox[{
         RowBox[{"Round", "[", 
          RowBox[{
           FractionBox["180", "\[Pi]"], 
           RowBox[{"(", 
            RowBox[{"\[Pi]", "-", 
             RowBox[{"params", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "10"}], "]"}], 
         "/", "10."}], "]"}]}], ";", 
      RowBox[{"nxy", "=", 
       RowBox[{"Round", "[", 
        RowBox[{"params", "[", 
         RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
      RowBox[{"nu", "=", 
       RowBox[{"Round", "[", 
        RowBox[{"params", "[", 
         RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
      RowBox[{"maxy", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "5", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"heat", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "6", "]"}], "]"}]}], ";", 
      RowBox[{"rnohor", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "7", "]"}], "]"}]}], ";", 
      RowBox[{"inten", "=", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
      RowBox[{"Close", "[", "fi11", "]"}], ";", 
      RowBox[{"partres", "=", 
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"inten", ",", "5"}], "]"}], ",", 
         RowBox[{"nxy", "+", "1"}]}], "]"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"partres", "=", 
   FractionBox[
    RowBox[{"Total", "[", 
     RowBox[{"taxx", ",", 
      RowBox[{"{", "1", "}"}]}], "]"}], "ind"]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"de", "=", 
   SuperscriptBox["10", 
    RowBox[{"-", "20."}]]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"li09", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{
       RowBox[{"partres", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "+", "de"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scale09", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"Mean", "[", 
     RowBox[{
      RowBox[{"Sort", "[", 
       RowBox[{"Flatten", "[", 
        RowBox[{"partres", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], "]"}], 
      "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"-", "10"}], ";;", 
        RowBox[{"-", "5"}]}], "]"}], "]"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"csc", "=", "1"}], ";", 
  RowBox[{"mysize", "=", "20"}], ";", 
  RowBox[{"sss", "=", "0.83"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ph05", "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"180", "-", "115.30"}], ")"}], "\[Degree]"}]}], ";", 
   RowBox[{"ph09", "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"180", "-", "\[InvisibleSpace]", "120.29"}], ")"}], 
     "\[Degree]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
   "from", " ", "actual", " ", "mean", " ", "position", " ", "angles"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"con", "=", "20"}], ";", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"contrast", " ", "con"}], "\[Implies]", 
      RowBox[{
      "luminosity", " ", "con", " ", "times", " ", "lower", " ", "is", " ", 
       "black"}]}], ",", 
     RowBox[{"max", " ", "luminosity", " ", "is", " ", "white"}]}], "*)"}], 
   RowBox[{"totI09", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"rr", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"li09", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"y", " ", 
               RowBox[{"Cos", "[", "ph09", "]"}]}], "+", 
              RowBox[{"x", " ", 
               RowBox[{"Sin", "[", "ph09", "]"}]}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "y"}], " ", 
               RowBox[{"Sin", "[", "ph09", "]"}]}], "+", 
              RowBox[{"x", " ", 
               RowBox[{"Cos", "[", "ph09", "]"}]}]}]}], "]"}], "-", 
           "scale09"}], ")"}], "/", 
         RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "150"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{
           RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"I05line", "=", 
             RowBox[{
             "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): \
\!\(\*SubscriptBox[\(a\), \(*\)]\)=\>\"", "<>", 
              RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \>\"", "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
              "\"\<GHz,   \[Theta]=\>\"", "<>", 
              RowBox[{"ToString", "[", "th", "]"}], "<>", 
              "\"\<\[Degree]\>\""}]}], ",", 
            RowBox[{"mysize", "-", "2"}], ",", "Bold", ",", "Pink"}], "]"}], 
          ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
     "]"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"(*", "0.5", "*)"}], 
  RowBox[{
   RowBox[{"Clear", "[", "totI", "]"}], ";", 
   RowBox[{
   "dir", "=", 
    "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2012Feb_full\\\\\>\""}], 
   ";"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Off", "[", 
   StyleBox[
    RowBox[{"InterpolatingFunction", "::", "dmval"}], "MessageName"], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fmin", "=", "6850"}], ";", 
  RowBox[{"fmax", "=", "9850"}], ";", 
  RowBox[{"ind", "=", "21"}], ";", 
  RowBox[{"sep", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"ind", "-", "1"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"taxx", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"namefile", "=", 
       RowBox[{"dir", "<>", "\"\<shotimag50th184fn\>\"", "<>", 
        RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<_401.dat\>\""}]}], 
      ";", 
      RowBox[{"fi11", "=", 
       RowBox[{"OpenRead", "[", 
        RowBox[{"namefile", ",", 
         RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
      RowBox[{"params", "=", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"a", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", 
      RowBox[{"th", "=", 
       RowBox[{"Round", "[", 
        RowBox[{
         RowBox[{"Round", "[", 
          RowBox[{
           FractionBox["180", "\[Pi]"], 
           RowBox[{"(", 
            RowBox[{"\[Pi]", "-", 
             RowBox[{"params", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "10"}], "]"}], 
         "/", "10."}], "]"}]}], ";", 
      RowBox[{"nxy", "=", 
       RowBox[{"Round", "[", 
        RowBox[{"params", "[", 
         RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
      RowBox[{"nu", "=", 
       RowBox[{"Round", "[", 
        RowBox[{"params", "[", 
         RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
      RowBox[{"maxy", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "5", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"heat", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "6", "]"}], "]"}]}], ";", 
      RowBox[{"rnohor", "=", 
       RowBox[{"params", "[", 
        RowBox[{"[", "7", "]"}], "]"}]}], ";", 
      RowBox[{"inten", "=", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
      RowBox[{"Close", "[", "fi11", "]"}], ";", 
      RowBox[{"partres", "=", 
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{"inten", ",", "5"}], "]"}], ",", 
         RowBox[{"nxy", "+", "1"}]}], "]"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"partres", "=", 
   FractionBox[
    RowBox[{"Total", "[", 
     RowBox[{"taxx", ",", 
      RowBox[{"{", "1", "}"}]}], "]"}], "ind"]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"de", "=", 
   SuperscriptBox["10", 
    RowBox[{"-", "20."}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"li05", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{
       RowBox[{"partres", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "+", "de"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scale05", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"Mean", "[", 
     RowBox[{
      RowBox[{"Sort", "[", 
       RowBox[{"Flatten", "[", 
        RowBox[{"partres", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], "]"}], 
      "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"-", "10"}], ";;", 
        RowBox[{"-", "5"}]}], "]"}], "]"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"linQ", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"linU", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "3"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"linV", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "4"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scale05", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"Max", "[", 
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
  ";", 
  RowBox[{"csc", "=", "1"}], ";", 
  RowBox[{"mysize", "=", "20"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"con", "=", "20"}], ";", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"contrast", " ", "con"}], "\[Implies]", 
      RowBox[{
      "luminosity", " ", "con", " ", "times", " ", "lower", " ", "is", " ", 
       "black"}]}], ",", 
     RowBox[{"max", " ", "luminosity", " ", "is", " ", "white"}]}], "*)"}], 
   RowBox[{"totI05", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"rr", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"li05", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"y", " ", 
               RowBox[{"Cos", "[", "ph05", "]"}]}], "+", 
              RowBox[{"x", " ", 
               RowBox[{"Sin", "[", "ph05", "]"}]}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "y"}], " ", 
               RowBox[{"Sin", "[", "ph05", "]"}]}], "+", 
              RowBox[{"x", " ", 
               RowBox[{"Cos", "[", "ph05", "]"}]}]}]}], "]"}], "-", 
           "scale05"}], ")"}], "/", 
         RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "150"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{
           RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"I09line", "=", 
             RowBox[{
             "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): \
\!\(\*SubscriptBox[\(a\), \(*\)]\)=\>\"", "<>", 
              RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \>\"", "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
              "\"\<GHz,   \[Theta]=\>\"", "<>", 
              RowBox[{"ToString", "[", "th", "]"}], "<>", 
              "\"\<\[Degree]\>\""}]}], ",", 
            RowBox[{"mysize", "-", "2"}], ",", "Bold", ",", "Pink"}], "]"}], 
          ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"scV", "=", 
   RowBox[{"8.", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "6"}]]}]}], ";", 
  RowBox[{"scL", "=", 
   RowBox[{"Log", "[", "0.00007", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"totV05", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"res", "=", 
       RowBox[{"linV", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"y", " ", 
           RowBox[{"Cos", "[", "ph05", "]"}]}], "+", 
          RowBox[{"x", " ", 
           RowBox[{"Sin", "[", "ph05", "]"}]}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "y"}], " ", 
           RowBox[{"Sin", "[", "ph05", "]"}]}], "+", 
          RowBox[{"x", " ", 
           RowBox[{"Cos", "[", "ph05", "]"}]}]}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"Function", "[", 
        RowBox[{
         RowBox[{"{", "n", "}"}], ",", 
         RowBox[{
          RowBox[{"r", "=", 
           RowBox[{"n", "/", "scV"}]}], ";", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"r", ">", "0"}], ",", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"2", "r"}], ",", "r", ",", "r"}], "]"}], ",", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"-", "r"}], ",", 
              RowBox[{"-", "r"}], ",", 
              RowBox[{
               RowBox[{"-", "2"}], "r"}]}], "]"}]}], "]"}]}]}], "]"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Vline", "=", 
             RowBox[{"\"\<V: \!\(\*SubscriptBox[\(a\), \(*\)]\)=\>\"", "<>", 
              RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \[Nu]=\>\"", 
              "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
              "\"\<GHz,  \[Theta]=\>\"", "<>", 
              RowBox[{"ToString", "[", "th", "]"}], "<>", 
              "\"\<\[Degree]\>\""}]}], ",", "mysize", ",", "Bold", ",", 
            "Pink"}], "]"}], ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Red", " ", "-", " ", "positive"}], ",", " ", 
    RowBox[{"Blue", " ", "-", " ", "negative"}]}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"totQU05", "=", 
   RowBox[{"VectorDensityPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"A", "=", 
         RowBox[{"linQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"y", " ", 
             RowBox[{"Cos", "[", "ph05", "]"}]}], "+", 
            RowBox[{"x", " ", 
             RowBox[{"Sin", "[", "ph05", "]"}]}]}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "y"}], " ", 
             RowBox[{"Sin", "[", "ph05", "]"}]}], "+", 
            RowBox[{"x", " ", 
             RowBox[{"Cos", "[", "ph05", "]"}]}]}]}], "]"}]}], ";", 
        RowBox[{"B", "=", 
         RowBox[{"linU", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"y", " ", 
             RowBox[{"Cos", "[", "ph05", "]"}]}], "+", 
            RowBox[{"x", " ", 
             RowBox[{"Sin", "[", "ph05", "]"}]}]}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "y"}], " ", 
             RowBox[{"Sin", "[", "ph05", "]"}]}], "+", 
            RowBox[{"x", " ", 
             RowBox[{"Cos", "[", "ph05", "]"}]}]}]}], "]"}]}], ";", 
        RowBox[{"ann", "=", 
         FractionBox[
          RowBox[{"ArcTan", "[", 
           RowBox[{"A", ",", "B"}], "]"}], "2"]}], ";", 
        RowBox[{"Cos", "[", "ann", "]"}]}], ",", 
       RowBox[{"-", 
        RowBox[{"Sin", "[", "ann", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{
        RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
       RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", 
       RowBox[{
        RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
       RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
     RowBox[{"VectorPoints", "\[Rule]", "40"}], ",", 
     RowBox[{"VectorStyle", "\[Rule]", 
      RowBox[{"Arrowheads", "[", "0", "]"}]}], ",", 
     RowBox[{"StreamStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Arrowheads", "[", "0", "]"}], ",", 
        RowBox[{"RGBColor", "[", 
         RowBox[{"1", ",", "0.5", ",", "0.5"}], "]"}]}], "}"}]}], ",", 
     RowBox[{"StreamPoints", "\[Rule]", "50"}], ",", 
     RowBox[{"StreamScale", "\[Rule]", "Full"}], ",", 
     RowBox[{"MaxRecursion", "\[Rule]", "2"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "y", ",", "vx", ",", "vy", ",", "n"}], "}"}], ",", 
        RowBox[{
         RowBox[{"w", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               FractionBox["1", "2"], 
               RowBox[{"Log", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"linQ", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"y", " ", 
                    RowBox[{"Cos", "[", "ph05", "]"}]}], "+", 
                    RowBox[{"x", " ", 
                    RowBox[{"Sin", "[", "ph05", "]"}]}]}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "y"}], " ", 
                    RowBox[{"Sin", "[", "ph05", "]"}]}], "+", 
                    RowBox[{"x", " ", 
                    RowBox[{"Cos", "[", "ph05", "]"}]}]}]}], "]"}], "^", 
                  "2"}], "+", 
                 RowBox[{
                  RowBox[{"linU", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"y", " ", 
                    RowBox[{"Cos", "[", "ph05", "]"}]}], "+", 
                    RowBox[{"x", " ", 
                    RowBox[{"Sin", "[", "ph05", "]"}]}]}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "y"}], " ", 
                    RowBox[{"Sin", "[", "ph05", "]"}]}], "+", 
                    RowBox[{"x", " ", 
                    RowBox[{"Cos", "[", "ph05", "]"}]}]}]}], "]"}], "^", 
                  "2"}]}], "]"}]}], "-", "scL"}], ")"}], "/", 
            RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ";", 
         RowBox[{"RGBColor", "[", 
          RowBox[{
           RowBox[{"2", " ", "w", " ", "csc"}], ",", 
           RowBox[{"w", " ", "csc"}], ",", 
           RowBox[{"w", " ", "csc"}]}], "]"}]}]}], "]"}]}], ",", 
     RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
     RowBox[{"Epilog", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"QUline", "=", 
            RowBox[{
            "\"\<\!\(\*SqrtBox[\(\*SuperscriptBox[\(Q\), \(2\)] + \
\*SuperscriptBox[\(U\), \(2\)]\)]\) & field: \!\(\*SubscriptBox[\(a\), \(*\)]\
\)=\>\"", "<>", 
             RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \[Nu]=\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
             "\"\<GHz,  \[Theta]=\>\"", "<>", 
             RowBox[{"ToString", "[", "th", "]"}], "<>", 
             "\"\<\[Degree]\>\""}]}], ",", 
           RowBox[{"mysize", "-", "3"}], ",", "Bold", ",", "Pink"}], "]"}], 
         ",", 
         RowBox[{"Scaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{
  3.5292487335294943`*^9, {3.529248764291254*^9, 3.5292487745868425`*^9}, {
   3.5292488317851143`*^9, 3.529248867663166*^9}, {3.5292500265794525`*^9, 
   3.5292500268214664`*^9}, {3.529330232786378*^9, 3.5293302575687957`*^9}, {
   3.529330361519741*^9, 3.529330365310958*^9}, {3.5293304270884914`*^9, 
   3.52933045486208*^9}, {3.5293305276562433`*^9, 3.5293305403679705`*^9}, {
   3.529330594311056*^9, 3.52933062550284*^9}, {3.5293306781258497`*^9, 
   3.5293307005561333`*^9}, 3.5293307936444573`*^9, {3.5293311441915073`*^9, 
   3.529331146109617*^9}, {3.53798595996041*^9, 3.5379859618825197`*^9}, {
   3.5402298632156568`*^9, 3.540229902574526*^9}, {3.540299302090347*^9, 
   3.5402993380484095`*^9}, {3.540299374084473*^9, 3.540299494126684*^9}, {
   3.5402996171640997`*^9, 3.5402996514373603`*^9}, {3.540299691576231*^9, 
   3.540299707113858*^9}, {3.5540497903247633`*^9, 3.554049790413768*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"AppendTo", "[", 
   RowBox[{
   "$Path", ",", 
    "\"\<C:\\\\Program Files\\\\Wolfram \
Research\\\\Mathematica\\\\LevelScheme-3.52\>\""}], "]"}], ";", 
  RowBox[{"Get", "[", "\"\<LevelScheme`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ratio", "=", "0.25"}], ";", 
  RowBox[{"ysc", "=", "10"}], ";", 
  RowBox[{"num", "=", "15"}], ";", 
  RowBox[{"xsc", "=", 
   RowBox[{"ratio", " ", "ysc"}]}], ";", 
  RowBox[{
   RowBox[{"fcol", "[", "a_", "]"}], ":=", 
   SuperscriptBox["a", "2."]}], ";", 
  RowBox[{
   RowBox[{"fnI", "[", "i_", "]"}], ":=", 
   RowBox[{"0.05", " ", 
    SuperscriptBox["20", "i"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nf", "[", "scV_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"z", "=", 
      RowBox[{"Floor", "[", 
       RowBox[{"Log", "[", 
        RowBox[{"10", ",", "scV"}], "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"ToString", "[", 
       RowBox[{"Floor", "[", 
        RowBox[{
         RowBox[{
          SuperscriptBox["10", 
           RowBox[{"-", "z"}]], "scV"}], ",", "0.01"}], "]"}], "]"}], "<>", 
      "\"\<e\>\"", "<>", 
      RowBox[{"ToString", "[", "z", "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gr", "=", 
   RowBox[{"Graphics", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"RGBColor", "[", 
         RowBox[{"0.8", ",", "1", ",", "1.0"}], "]"}], ",", 
        RowBox[{"Rectangle", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{
             RowBox[{"-", "0.05"}], "ysc"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"xsc", ",", 
            RowBox[{"1.05", "ysc"}]}], "}"}]}], "]"}]}], "}"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"GrayLevel", "[", "i", "]"}], ",", 
          RowBox[{"Rectangle", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"0.05", "xsc"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 FractionBox["0.1", "num"]}], "ysc"}], "+", 
               RowBox[{
                FractionBox[
                 RowBox[{"ysc", " ", "i"}], 
                 RowBox[{"num", "+", "1"}]], "num"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"0.4", "xsc"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 FractionBox["0.1", "num"]}], "ysc"}], "+", 
               FractionBox[
                RowBox[{"ysc", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"i", " ", "num"}], "+", "1"}], ")"}]}], 
                RowBox[{"num", "+", "1"}]]}]}], "}"}]}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "1", ",", 
          FractionBox["1", "num"]}], "}"}]}], "]"}], ",", "Black", ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"ToString", "[", 
             RowBox[{"Floor", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"fcol", "[", "i", "]"}], "+", 
                SuperscriptBox["10", 
                 RowBox[{"-", "6."}]]}], ",", "0.01"}], "]"}], "]"}], ",", 
            "16"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"0.7", "xsc"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               FractionBox["0.1", "num"]}], "ysc"}], "+", 
             FractionBox[
              RowBox[{"ysc", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"i", " ", "num"}], "+", "0.5"}], ")"}]}], 
              RowBox[{"num", "+", "1"}]]}]}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "1", ",", 
          FractionBox["1", "num"]}], "}"}]}], "]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Show", "[", 
   RowBox[{"gr", ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "xsc"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "0.05"}], "ysc"}], ",", "ysc"}], "}"}]}], "}"}]}]}], 
   "]"}], ";", 
  RowBox[{"dr", "=", "0.95"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"grI09", "=", 
    RowBox[{"Graphics", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.8", ",", "1", ",", "1.0"}], "]"}], ",", 
         RowBox[{"Rectangle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{
              RowBox[{"-", "0.05"}], "ysc"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"xsc", ",", 
             RowBox[{"1.05", "ysc"}]}], "}"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"rr", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{"fnI", "[", "i", "]"}], "]"}], "/", 
               RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ";", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"2", "rr", " ", "csc"}], ",", 
              RowBox[{"rr", " ", "csc"}], ",", 
              RowBox[{"rr", " ", "csc"}]}], "]"}]}], ",", 
           RowBox[{"Rectangle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.05", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", "i"}], 
                  RowBox[{"num", "+", "1"}]], "num"}]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.4", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "num"}], "+", "1"}], ")"}]}], 
                  RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", "Black", ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{"NumberForm", "[", 
               RowBox[{
                RowBox[{"fnI", "[", "i", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}]}], "]"}], "]"}], ",", "16"}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"0.7", "xsc"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                FractionBox["0.1", "num"]}], "ysc"}], "+", 
              RowBox[{"dr", 
               FractionBox[
                RowBox[{"ysc", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"i", " ", "num"}], "+", "0.5"}], ")"}]}], 
                RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"\"\<x\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"NumberForm", "[", 
              RowBox[{
               RowBox[{"Exp", "[", "scale09", "]"}], ",", "3"}], "]"}], 
             "]"}]}], ",", "16"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"0.5", "xsc"}], ",", 
           RowBox[{"0.98", "ysc"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"grI05", "=", 
    RowBox[{"Graphics", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.8", ",", "1", ",", "1.0"}], "]"}], ",", 
         RowBox[{"Rectangle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{
              RowBox[{"-", "0.05"}], "ysc"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"xsc", ",", 
             RowBox[{"1.05", "ysc"}]}], "}"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"rr", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{"fnI", "[", "i", "]"}], "]"}], "/", 
               RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ";", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"2", "rr", " ", "csc"}], ",", 
              RowBox[{"rr", " ", "csc"}], ",", 
              RowBox[{"rr", " ", "csc"}]}], "]"}]}], ",", 
           RowBox[{"Rectangle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.05", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", "i"}], 
                  RowBox[{"num", "+", "1"}]], "num"}]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.4", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "num"}], "+", "1"}], ")"}]}], 
                  RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", "Black", ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{"NumberForm", "[", 
               RowBox[{
                RowBox[{"fnI", "[", "i", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}]}], "]"}], "]"}], ",", "16"}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"0.7", "xsc"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                FractionBox["0.1", "num"]}], "ysc"}], "+", 
              RowBox[{"dr", 
               FractionBox[
                RowBox[{"ysc", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"i", " ", "num"}], "+", "0.5"}], ")"}]}], 
                RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"\"\<x\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"NumberForm", "[", 
              RowBox[{
               RowBox[{"Exp", "[", "scale05", "]"}], ",", "3"}], "]"}], 
             "]"}]}], ",", "16"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"0.5", "xsc"}], ",", 
           RowBox[{"0.98", "ysc"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}], ",", 
   RowBox[{"grQU", "=", 
    RowBox[{"Graphics", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.8", ",", "1", ",", "1.0"}], "]"}], ",", 
         RowBox[{"Rectangle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{
              RowBox[{"-", "0.05"}], "ysc"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"xsc", ",", 
             RowBox[{"1.05", "ysc"}]}], "}"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"rr", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{"fnI", "[", "i", "]"}], "]"}], "/", 
               RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ";", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"2", "rr", " ", "csc"}], ",", 
              RowBox[{"rr", " ", "csc"}], ",", 
              RowBox[{"rr", " ", "csc"}]}], "]"}]}], ",", 
           RowBox[{"Rectangle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.05", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", "i"}], 
                  RowBox[{"num", "+", "1"}]], "num"}]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.4", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "num"}], "+", "1"}], ")"}]}], 
                  RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", "Black", ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{"NumberForm", "[", 
               RowBox[{
                RowBox[{"fnI", "[", "i", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}]}], "]"}], "]"}], ",", "16"}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"0.7", "xsc"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                FractionBox["0.1", "num"]}], "ysc"}], "+", 
              RowBox[{"dr", 
               FractionBox[
                RowBox[{"ysc", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"i", " ", "num"}], "+", "0.5"}], ")"}]}], 
                RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"\"\<x\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"NumberForm", "[", 
              RowBox[{
               RowBox[{"Exp", "[", "scL", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"5", ",", "5"}], "}"}]}], "]"}], "]"}]}], ",", "16"}],
           "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"0.5", "xsc"}], ",", 
           RowBox[{"0.98", "ysc"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}], ",", 
   RowBox[{"grV", "=", 
    RowBox[{"Graphics", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.8", ",", "1", ",", "1.0"}], "]"}], ",", 
         RowBox[{"Rectangle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{
              RowBox[{"-", "0.05"}], "ysc"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"xsc", ",", 
             RowBox[{"1.05", "ysc"}]}], "}"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"r", "=", 
             RowBox[{
              RowBox[{"2", "i"}], "-", "1"}]}], ";", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"r", ">", "0"}], ",", 
              RowBox[{"RGBColor", "[", 
               RowBox[{
                RowBox[{"2", "r"}], ",", "r", ",", "r"}], "]"}], ",", 
              RowBox[{"RGBColor", "[", 
               RowBox[{
                RowBox[{"-", "r"}], ",", 
                RowBox[{"-", "r"}], ",", 
                RowBox[{
                 RowBox[{"-", "2"}], "r"}]}], "]"}]}], "]"}]}], ",", 
           RowBox[{"Rectangle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.05", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", "i"}], 
                  RowBox[{"num", "+", "1"}]], "num"}]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.4", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "num"}], "+", "1"}], ")"}]}], 
                  RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", "Black", ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{"NumberForm", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"2", "i"}], "-", "1."}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}]}], "]"}], "]"}], ",", "16"}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"0.7", "xsc"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                FractionBox["0.1", "num"]}], "ysc"}], "+", 
              RowBox[{"dr", 
               FractionBox[
                RowBox[{"ysc", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"i", " ", "num"}], "+", "0.5"}], ")"}]}], 
                RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"\"\<x\>\"", "<>", 
            RowBox[{"nf", "[", "scV", "]"}]}], ",", "16"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"0.5", "xsc"}], ",", 
           RowBox[{"0.98", "ysc"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}]}], 
  "}"}]}], "Input",
 CellChangeTimes->{{3.502129646547*^9, 3.502129653307*^9}, {3.5021297056*^9, 
   3.5021299671800003`*^9}, {3.502130171939*^9, 3.502130177856*^9}, {
   3.5021302665550003`*^9, 3.502130354127*^9}, {3.502198434785*^9, 
   3.50219843788*^9}, {3.502452148104*^9, 3.502452202293*^9}, {
   3.502455133999*^9, 3.502455400816*^9}, {3.502455441406*^9, 
   3.502455714793*^9}, {3.50245574988*^9, 3.502455769021*^9}, {
   3.502455816708*^9, 3.502455816795*^9}, {3.502455980579*^9, 
   3.5024560181280003`*^9}, {3.5024560566870003`*^9, 3.502456057013*^9}, {
   3.5024561147790003`*^9, 3.502456115547*^9}, {3.502456145977*^9, 
   3.502456146041*^9}, {3.502456340414*^9, 3.5024563450299997`*^9}, {
   3.502456437481*^9, 3.502456454575*^9}, {3.502456549299*^9, 
   3.5024565493859997`*^9}, {3.5024567835810003`*^9, 
   3.5024568541800003`*^9}, {3.502457008764*^9, 3.502457093533*^9}, {
   3.502457129922*^9, 3.502457169335*^9}, {3.5024572012139997`*^9, 
   3.502457221542*^9}, {3.502457282362*^9, 3.502457296112*^9}, {
   3.502457334216*^9, 3.5024573634379997`*^9}, {3.502457430657*^9, 
   3.5024574602060003`*^9}, {3.50245755513*^9, 3.502457561506*^9}, {
   3.502457760488*^9, 3.502457760566*^9}, 3.502458213052*^9, {
   3.5025545221734*^9, 3.5025545222544003`*^9}, {3.5025546537553997`*^9, 
   3.5025547479664*^9}, {3.5025555314764*^9, 3.5025556280204*^9}, {
   3.5025556896164*^9, 3.5025557169784*^9}, {3.5025558473524*^9, 
   3.5025558739514*^9}, {3.5025560246174*^9, 3.5025561177854*^9}, {
   3.5025561504734*^9, 3.5025561722384*^9}, {3.5025563131544*^9, 
   3.5025563985554*^9}, {3.5025564806934*^9, 3.5025565437754*^9}, {
   3.5025567242924*^9, 3.5025567647614*^9}, {3.5025569471984*^9, 
   3.5025569594694*^9}, {3.5025570044814*^9, 3.5025570155774*^9}, {
   3.5025570536244*^9, 3.5025570605973997`*^9}, {3.5025583089544*^9, 
   3.5025583204824*^9}, {3.5025583524504004`*^9, 3.5025583564194*^9}, {
   3.5025587587004004`*^9, 3.5025588212924*^9}, {3.5025594994274*^9, 
   3.5025595020624*^9}, {3.5025595893844*^9, 3.5025595974234*^9}, {
   3.5025596610984*^9, 3.5025596894524*^9}, {3.5025597327704*^9, 
   3.5025597666324*^9}, {3.5025602512644*^9, 3.5025602513434*^9}, {
   3.5025613735034*^9, 3.5025613741584*^9}, {3.5101485586675997`*^9, 
   3.5101485590536003`*^9}, 3.52933131225212*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"siz", "=", 
   RowBox[{"1.2", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "9"}], ",", "9"}], "}"}]}]}], ";", 
  RowBox[{"lt", "=", 
   RowBox[{"LinTicks", "[", 
    RowBox[{
     RowBox[{"-", "8"}], ",", "8", ",", "4", ",", "4"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"figv", "=", 
  RowBox[{"Figure", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.50", ",", "0.98"}], "}"}], ",", 
        "\"\<images of total and polarized intensities for best-fitting \
models\>\"", ",", 
        RowBox[{"FontSize", "\[Rule]", 
         RowBox[{"mysize", "+", "1"}]}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.68", ",", "0.45"}], "}"}], ",", "Vline", ",", 
        RowBox[{"Color", "\[Rule]", "Pink"}], ",", 
        RowBox[{"Background", "\[Rule]", "Black"}], ",", 
        RowBox[{"FontSize", "\[Rule]", 
         RowBox[{"mysize", "-", "2"}]}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.36", ",", "0.45"}], "}"}], ",", "I05line", ",", 
        RowBox[{"Color", "\[Rule]", "Pink"}], ",", 
        RowBox[{"Background", "\[Rule]", "Black"}], ",", 
        RowBox[{"FontSize", "\[Rule]", 
         RowBox[{"mysize", "-", "2"}]}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.36", ",", "0.88"}], "}"}], ",", "I09line", ",", 
        RowBox[{"Color", "\[Rule]", "Pink"}], ",", 
        RowBox[{"Background", "\[Rule]", "Black"}], ",", 
        RowBox[{"FontSize", "\[Rule]", 
         RowBox[{"mysize", "-", "2"}]}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.68", ",", "0.90"}], "}"}], ",", "QUline", ",", 
        RowBox[{"Color", "\[Rule]", "Pink"}], ",", 
        RowBox[{"Background", "\[Rule]", "Black"}], ",", 
        RowBox[{"FontSize", "\[Rule]", 
         RowBox[{"mysize", "-", "2"}]}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Multipanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "4"}], "}"}], ",", 
        RowBox[{"XPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "xsc"}], "}"}], ",", "siz", ",", "siz", ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "xsc"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"YPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}], ",", 
               RowBox[{"1.02", "ysc"}]}], "}"}], ",", "siz", ",", "siz", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}], ",", 
               RowBox[{"1.02", "ysc"}]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}], ",", 
               RowBox[{"1.02", "ysc"}]}], "}"}], ",", "siz", ",", "siz", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}], ",", 
               RowBox[{"1.02", "ysc"}]}], "}"}]}], "}"}]}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"XFrameLabels", "\[Rule]", "None"}], ",", 
        RowBox[{"BufferB", "\[Rule]", "2"}], ",", 
        RowBox[{"YFrameLabels", "\[Rule]", "None"}], ",", 
        RowBox[{"BufferL", "\[Rule]", "2"}], ",", 
        RowBox[{"TickFontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", "\[IndentingNewLine]", 
        RowBox[{"XFrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"None", ",", "lt", ",", "lt", ",", "None"}], "}"}]}], ",", 
        RowBox[{"YFrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"None", ",", "lt", ",", "lt", ",", "None"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"None", ",", "lt", ",", "lt", ",", "None"}], "}"}]}], 
          "}"}]}], ",", 
        RowBox[{"XPanelSizes", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0.3", ",", "1", ",", "1", ",", "0.3"}], "}"}]}], ",", 
        RowBox[{"YPanelSizes", "\[Rule]", "1"}], ",", 
        RowBox[{"XGapSizes", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0.15", ",", "0.0", ",", "0.05"}], "}"}]}], ",", 
        RowBox[{"YGapSizes", "\[Rule]", 
         RowBox[{"{", "0.0", "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"Background", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PanelLetterCorner", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "1"}]}], "}"}]}], ",", 
        RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
        RowBox[{"TickNudge", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "5"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5"}], ",", "0"}], "}"}], ",", "0", ",", "0"}], 
          "}"}]}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"grI05", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(a)\>\""}], ",", 
        RowBox[{"ShowTickLabelsInterior", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "False"}], 
          "}"}]}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"totI05", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "3"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(b)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"totQU05", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "4"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"grQU", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"grI09", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "2"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(c)\>\""}], ",", 
        RowBox[{"ShowTickLabelsInterior", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "False"}], 
          "}"}]}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"totI09", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "3"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(d)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"totV05", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "4"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"grV", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.05"}], ",", "1.05"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.05"}], ",", "1.10"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1155", ",", "850"}], "}"}]}]}], 
   RowBox[{"(*", 
    RowBox[{"{", 
     RowBox[{"1100", ",", "800"}], "}"}], "*)"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5025533764804*^9, 3.5025533820794*^9}, {
   3.5025534158213997`*^9, 3.5025534158764*^9}, {3.5025535127114*^9, 
   3.5025535838604*^9}, {3.5025536190434*^9, 3.5025536889624*^9}, {
   3.5025537551984*^9, 3.5025537767414*^9}, {3.5025538383954*^9, 
   3.5025538664974003`*^9}, {3.5025538969424*^9, 3.5025539019684*^9}, {
   3.5025539400674*^9, 3.5025539402424*^9}, {3.5025541513304*^9, 
   3.5025541516244*^9}, {3.5025541959924*^9, 3.5025542169094*^9}, {
   3.5025542610674*^9, 3.5025542748514*^9}, {3.5025543105694*^9, 
   3.5025543130424*^9}, {3.5025543543984003`*^9, 3.5025543592784*^9}, {
   3.5025561249244003`*^9, 3.5025561252654*^9}, {3.5025583432854*^9, 
   3.5025583439024*^9}, {3.5025588601043997`*^9, 3.5025588602324*^9}, 
   3.5025597999344*^9, {3.5025601535664*^9, 3.5025601578864*^9}, {
   3.5025602124124002`*^9, 3.5025602160424*^9}, {3.5025603535174*^9, 
   3.5025603693283997`*^9}, {3.5025604020734*^9, 3.5025604318073997`*^9}, {
   3.5025604682704*^9, 3.5025604949944*^9}, {3.5025605291944*^9, 
   3.5025605292074003`*^9}, {3.502561799251*^9, 3.5025619258761997`*^9}, {
   3.5025619825198*^9, 3.5025620749342003`*^9}, {3.5025621948514*^9, 
   3.5025621954754*^9}, {3.5101486679996*^9, 3.5101486920446*^9}, {
   3.5101487307576*^9, 3.5101487403185997`*^9}, {3.5293313411447725`*^9, 
   3.5293313961279173`*^9}, {3.529331446495798*^9, 3.5293314543522477`*^9}, {
   3.5293315030480328`*^9, 3.529331507759302*^9}, {3.529331580990491*^9, 
   3.52933161996572*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"siz", "=", 
   RowBox[{"1.2", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "9"}], ",", "9"}], "}"}]}]}], ";", 
  RowBox[{"lt", "=", 
   RowBox[{"LinTicks", "[", 
    RowBox[{
     RowBox[{"-", "8"}], ",", "8", ",", "4", ",", "4"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"figX", "=", 
  RowBox[{"Figure", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.36", ",", "0.88"}], "}"}], ",", "I09line", ",", 
        RowBox[{"Color", "\[Rule]", "Pink"}], ",", 
        RowBox[{"Background", "\[Rule]", "Black"}], ",", 
        RowBox[{"FontSize", "\[Rule]", 
         RowBox[{"mysize", "-", "2"}]}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.68", ",", "0.88"}], "}"}], ",", "I05line", ",", 
        RowBox[{"Color", "\[Rule]", "Pink"}], ",", 
        RowBox[{"Background", "\[Rule]", "Black"}], ",", 
        RowBox[{"FontSize", "\[Rule]", 
         RowBox[{"mysize", "-", "2"}]}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      RowBox[{"Multipanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "4"}], "}"}], ",", 
        RowBox[{"XPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "xsc"}], "}"}], ",", "siz", ",", "siz", ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "xsc"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"YPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "0.05"}], "ysc"}], ",", 
              RowBox[{"1.05", "ysc"}]}], "}"}], ",", "siz", ",", "siz", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "0.05"}], "ysc"}], ",", 
              RowBox[{"1.05", "ysc"}]}], "}"}]}], "}"}], 
          RowBox[{"(*", 
           RowBox[{",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "0.05"}], "ysc"}], ",", 
                RowBox[{"1.02", "ysc"}]}], "}"}], ",", "siz", ",", "siz", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "0.05"}], "ysc"}], ",", 
                RowBox[{"1.02", "ysc"}]}], "}"}]}], "}"}]}], "*)"}], "}"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"XFrameLabels", "\[Rule]", "None"}], ",", 
        RowBox[{"BufferB", "\[Rule]", "2"}], ",", 
        RowBox[{"YFrameLabels", "\[Rule]", "None"}], ",", 
        RowBox[{"BufferL", "\[Rule]", "2"}], ",", 
        RowBox[{"TickFontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", "\[IndentingNewLine]", 
        RowBox[{"XFrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"None", ",", "lt", ",", "lt", ",", "None"}], "}"}]}], ",", 
        RowBox[{"YFrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"None", ",", "lt", ",", "lt", ",", "None"}], "}"}], 
          RowBox[{"(*", 
           RowBox[{",", 
            RowBox[{"{", 
             RowBox[{"None", ",", "lt", ",", "lt", ",", "None"}], "}"}]}], 
           "*)"}], "}"}]}], ",", 
        RowBox[{"XPanelSizes", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0.3", ",", "1", ",", "1", ",", "0.3"}], "}"}]}], ",", 
        RowBox[{"YPanelSizes", "\[Rule]", "1"}], ",", 
        RowBox[{"XGapSizes", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0.15", ",", "0.0", ",", "0.05"}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Background", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PanelLetterCorner", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "1"}]}], "}"}]}], ",", 
        RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
        RowBox[{"TickNudge", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "5"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5"}], ",", "0"}], "}"}], ",", "0", ",", "0"}], 
          "}"}]}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"grI05", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(a)\>\""}], ",", 
        RowBox[{"ShowTickLabelsInterior", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "False"}], 
          "}"}]}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"totI05", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "3"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(b)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"totI09", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "4"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"grI09", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.05"}], ",", "1.05"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.1"}], ",", "1.05"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1155", ",", "430"}], "}"}]}]}], 
   RowBox[{"(*", 
    RowBox[{"{", 
     RowBox[{"1100", ",", "800"}], "}"}], "*)"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.563853938082849*^9, 3.5638539520976505`*^9}, {
  3.563853996304179*^9, 3.5638540003074083`*^9}, {3.5638540345813684`*^9, 
  3.5638540659561625`*^9}, {3.563854134987111*^9, 3.5638541688290467`*^9}, {
  3.5638542043710794`*^9, 3.563854307504979*^9}, {3.5638543386817617`*^9, 
  3.5638543854674377`*^9}, {3.563854423669623*^9, 3.5638545244113855`*^9}, {
  3.563854567282837*^9, 3.563854571773094*^9}, {3.5638546218009553`*^9, 
  3.563854622895018*^9}, {3.563854669015656*^9, 3.5638546719218225`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"myf", "=", "15"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"imagepl", "=", 
    RowBox[{
     RowBox[{"GraphicsGrid", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"totI09", ",", "totV09"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"totI05", ",", "totQU09"}], "}"}]}], "}"}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "16"}]}], "}"}]}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<images of total and polarized intensities for best-fitting \
models\>\""}]}], "]"}], "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{
       "\"\<C:\\\\study\\\\accretion\\\\! 2009 fall cfa\\\\GR Polarized \
modeling\\\\\>\"", "<>", "\"\<images.pdf\>\""}], ",", "imagepl", ",", 
       RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", " ", 
       RowBox[{"ImageResolution", "\[Rule]", "150"}]}], "]"}]}]}], 
   "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{
     "\"\<C:\\\\study\\\\accretion\\\\! 2009 3fall cfa\\\\GR Polarized \
modeling\\\\!svn\\\\\>\"", "<>", "\"\<images.eps\>\""}], ",", "figv", ",", 
     RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", " ", 
     RowBox[{"ImageResolution", "\[Rule]", "150"}]}], "]"}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{
  3.4875180686218*^9, {3.4885991589258003`*^9, 3.4885991592248*^9}, {
   3.489156234295933*^9, 3.4891562452315326`*^9}, {3.4891589360121326`*^9, 
   3.4891589426265326`*^9}, {3.4891589846685324`*^9, 3.489158984996133*^9}, {
   3.4891590499857326`*^9, 3.4891590973629327`*^9}, {3.4891592083569326`*^9, 
   3.4891592121477327`*^9}, {3.502475801034*^9, 3.5024758024709997`*^9}, {
   3.5025598734754*^9, 3.5025598947854*^9}, {3.5025599291524*^9, 
   3.5025599320234003`*^9}, {3.5025612126324*^9, 3.5025612129904003`*^9}, {
   3.529331701179365*^9, 3.5293317093948355`*^9}, {3.563853272715792*^9, 
   3.563853273852857*^9}}],

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\Users\\\\roman\\\\Desktop\\\\faculty\\\\totI05.eps\>\"", ",", 
   "totI05", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", " ", 
   RowBox[{"ImageResolution", "\[Rule]", "150"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\Users\\\\roman\\\\Desktop\\\\faculty\\\\totI09.eps\>\"", ",", 
   "totI09", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", " ", 
   RowBox[{"ImageResolution", "\[Rule]", "150"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<C:\\\\Users\\\\roman\\\\Desktop\\\\faculty\\\\totIX.eps\>\"", ",", 
   "figX", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", " ", 
   RowBox[{"ImageResolution", "\[Rule]", "150"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5638534563492956`*^9, 3.563853541305155*^9}, {
  3.5638546391289463`*^9, 3.563854647474424*^9}}],

Cell[BoxData[
 RowBox[{"Print", "[", 
  RowBox[{
   RowBox[{"10", 
    RowBox[{"(*", 
     RowBox[{
     "number", " ", "of", " ", "variables", " ", "to", " ", "describe", " ", 
      "geodesics"}], "*)"}], " ", "4", 
    RowBox[{"(*", 
     RowBox[{"number", " ", "of", " ", "bytes"}], "*)"}], " ", "256", 
    RowBox[{"(*", "r", "*)"}], " ", "64", 
    RowBox[{"(*", 
     RowBox[{"position", " ", "\[Theta]"}], "*)"}], " ", "64", 
    RowBox[{"(*", 
     RowBox[{"angle", " ", 
      RowBox[{"\[Theta]", "'"}]}], "*)"}], "64"}], 
   RowBox[{"(*", 
    RowBox[{"angle", " ", 
     RowBox[{"\[Phi]", "'"}]}], "*)"}], ",", 
   "\"\< bytes - lookup table\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.540172885976462*^9, 3.540172896937089*^9}, {
  3.5401729275058374`*^9, 3.540173007378406*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["old single snapshots", "Subsubsection",
 CellChangeTimes->{{3.5292430504614415`*^9, 3.5292430538926377`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "totI", "]"}], ";", 
  RowBox[{
  "dir", "=", "\"\<E:\\\\mathematica\\\\analysis\\\\size\\\\3\\\\\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"namefile", "=", 
    RowBox[{"dir", "<>", "\"\<shotimag90th218fn-1nob.dat\>\""}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "namefile", "=", 
     "\"\<E:\\\\mathematica\\\\analysis\\\\size\\\\2\\\\shotimag90th265fn-\
1nob.dat\>\""}], ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Off", "[", 
   StyleBox[
    RowBox[{"InterpolatingFunction", "::", "dmval"}], "MessageName"], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fi11", "=", 
   RowBox[{"OpenRead", "[", 
    RowBox[{"namefile", ",", 
     RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
  RowBox[{"params", "=", 
   RowBox[{"BinaryReadList", "[", 
    RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"th", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"Round", "[", 
      RowBox[{
       FractionBox["180", "\[Pi]"], 
       RowBox[{"(", 
        RowBox[{"\[Pi]", "-", 
         RowBox[{"params", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "10"}], "]"}], "/", 
     "10."}], "]"}]}], ";", 
  RowBox[{"nxy", "=", 
   RowBox[{"Round", "[", 
    RowBox[{"params", "[", 
     RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"nu", "=", 
   RowBox[{"Round", "[", 
    RowBox[{"params", "[", 
     RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"maxy", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "5", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"heat", "=", 
    RowBox[{"params", "[", 
     RowBox[{"[", "6", "]"}], "]"}]}], ";", 
   RowBox[{"rnohor", "=", 
    RowBox[{"params", "[", 
     RowBox[{"[", "7", "]"}], "]"}]}], ";", 
   RowBox[{"inten", "=", 
    RowBox[{"BinaryReadList", "[", 
     RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
   RowBox[{"partres", "=", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"Partition", "[", 
       RowBox[{"inten", ",", "5"}], "]"}], ",", 
      RowBox[{"nxy", "+", "1"}]}], "]"}]}], ";", 
   RowBox[{"Close", "[", "fi11", "]"}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"li05", "=", 
    RowBox[{"ListInterpolation", "[", 
     RowBox[{
      RowBox[{"Log", "[", 
       RowBox[{"partres", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
      RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"linQ", "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"partres", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"linU", "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"partres", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", "3"}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"linV", "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"partres", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", "4"}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scale05", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"Max", "[", 
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
  ";", 
  RowBox[{"csc", "=", "1"}], ";", 
  RowBox[{"ph05", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"180", "-", "123.6"}], ")"}], "\[Degree]"}]}], ";", 
  RowBox[{"ph09", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"180", "-", "121.2"}], ")"}], "\[Degree]"}]}], ";", 
  RowBox[{"mysize", "=", "20"}], ";", 
  RowBox[{"sss", "=", "0.9"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"con", "=", "20"}], ";", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"contrast", " ", "con"}], "\[Implies]", 
      RowBox[{
      "luminosity", " ", "con", " ", "times", " ", "lower", " ", "is", " ", 
       "black"}]}], ",", 
     RowBox[{"max", " ", "luminosity", " ", "is", " ", "white"}]}], "*)"}], 
   RowBox[{"totI05", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"rr", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"li05", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"y", " ", 
               RowBox[{"Cos", "[", "ph05", "]"}]}], "+", 
              RowBox[{"x", " ", 
               RowBox[{"Sin", "[", "ph05", "]"}]}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "y"}], " ", 
               RowBox[{"Sin", "[", "ph05", "]"}]}], "+", 
              RowBox[{"x", " ", 
               RowBox[{"Cos", "[", "ph05", "]"}]}]}]}], "]"}], "-", 
           "scale05"}], ")"}], "/", 
         RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "150"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{
           RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"I05line", "=", 
             RowBox[{
             "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): \
\!\(\*SubscriptBox[\(a\), \(*\)]\)=\>\"", "<>", 
              RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<(lin b),  \>\"",
               "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
              "\"\<GHz,   \[Theta]=\>\"", "<>", 
              RowBox[{"ToString", "[", "th", "]"}], "<>", 
              "\"\<\[Degree]\>\""}]}], ",", 
            RowBox[{"mysize", "-", "2"}], ",", "Bold", ",", "Pink"}], "]"}], 
          ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"namefile", "=", 
   RowBox[{"dir", "<>", "\"\<shotimag90th223fn-1boo.dat\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fi11", "=", 
   RowBox[{"OpenRead", "[", 
    RowBox[{"namefile", ",", 
     RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
  RowBox[{"params", "=", 
   RowBox[{"BinaryReadList", "[", 
    RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"th", "=", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{"Round", "[", 
      RowBox[{
       FractionBox["180", "\[Pi]"], 
       RowBox[{"(", 
        RowBox[{"\[Pi]", "-", 
         RowBox[{"params", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "10"}], "]"}], "/", 
     "10."}], "]"}]}], ";", 
  RowBox[{"nxy", "=", 
   RowBox[{"Round", "[", 
    RowBox[{"params", "[", 
     RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"nu", "=", 
   RowBox[{"Round", "[", 
    RowBox[{"params", "[", 
     RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"maxy", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "5", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"heat", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "6", "]"}], "]"}]}], ";", 
  RowBox[{"rnohor", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "7", "]"}], "]"}]}], ";", 
  RowBox[{"inten", "=", 
   RowBox[{"BinaryReadList", "[", 
    RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
  RowBox[{"partres", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"Partition", "[", 
      RowBox[{"inten", ",", "5"}], "]"}], ",", 
     RowBox[{"nxy", "+", "1"}]}], "]"}]}], ";", 
  RowBox[{"Close", "[", "fi11", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"li09", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"partres", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"linQ", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"linU", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "3"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"linV", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "4"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scale09", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"Max", "[", 
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
  ";", 
  RowBox[{"csc", "=", "1"}], ";", 
  RowBox[{"mysize", "=", "20"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"con", "=", "20"}], ";", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"contrast", " ", "con"}], "\[Implies]", 
      RowBox[{
      "luminosity", " ", "con", " ", "times", " ", "lower", " ", "is", " ", 
       "black"}]}], ",", 
     RowBox[{"max", " ", "luminosity", " ", "is", " ", "white"}]}], "*)"}], 
   RowBox[{"totI09", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"rr", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"li09", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"y", " ", 
               RowBox[{"Cos", "[", "ph09", "]"}]}], "+", 
              RowBox[{"x", " ", 
               RowBox[{"Sin", "[", "ph09", "]"}]}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "y"}], " ", 
               RowBox[{"Sin", "[", "ph09", "]"}]}], "+", 
              RowBox[{"x", " ", 
               RowBox[{"Cos", "[", "ph09", "]"}]}]}]}], "]"}], "-", 
           "scale09"}], ")"}], "/", 
         RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "150"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{
           RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"I09line", "=", 
             RowBox[{
             "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): \
\!\(\*SubscriptBox[\(a\), \(*\)]\)=\>\"", "<>", 
              RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<(RMS b),  \>\"",
               "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
              "\"\<GHz,   \[Theta]=\>\"", "<>", 
              RowBox[{"ToString", "[", "th", "]"}], "<>", 
              "\"\<\[Degree]\>\""}]}], ",", 
            RowBox[{"mysize", "-", "2"}], ",", "Bold", ",", "Pink"}], "]"}], 
          ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
     "]"}]}], ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scV", "=", 
   RowBox[{"5.", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "6"}]]}]}], ";", 
  RowBox[{"scL", "=", 
   RowBox[{"Log", "[", "0.0003", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"totV09", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"res", "=", 
       RowBox[{"linV", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"y", " ", 
           RowBox[{"Cos", "[", "ph09", "]"}]}], "+", 
          RowBox[{"x", " ", 
           RowBox[{"Sin", "[", "ph09", "]"}]}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "y"}], " ", 
           RowBox[{"Sin", "[", "ph09", "]"}]}], "+", 
          RowBox[{"x", " ", 
           RowBox[{"Cos", "[", "ph09", "]"}]}]}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"Function", "[", 
        RowBox[{
         RowBox[{"{", "n", "}"}], ",", 
         RowBox[{
          RowBox[{"r", "=", 
           RowBox[{"n", "/", "scV"}]}], ";", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"r", ">", "0"}], ",", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"2", "r"}], ",", "r", ",", "r"}], "]"}], ",", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"-", "r"}], ",", 
              RowBox[{"-", "r"}], ",", 
              RowBox[{
               RowBox[{"-", "2"}], "r"}]}], "]"}]}], "]"}]}]}], "]"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Vline", "=", 
             RowBox[{"\"\<V: \!\(\*SubscriptBox[\(a\), \(*\)]\)=\>\"", "<>", 
              RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \[Nu]=\>\"", 
              "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
              "\"\<GHz,  \[Theta]=\>\"", "<>", 
              RowBox[{"ToString", "[", "th", "]"}], "<>", 
              "\"\<\[Degree]\>\""}]}], ",", "mysize", ",", "Bold", ",", 
            "Pink"}], "]"}], ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Red", " ", "-", " ", "positive"}], ",", " ", 
    RowBox[{"Blue", " ", "-", " ", "negative"}]}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"totQU09", "=", 
   RowBox[{"VectorDensityPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"A", "=", 
         RowBox[{"linQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"y", " ", 
             RowBox[{"Cos", "[", "ph09", "]"}]}], "+", 
            RowBox[{"x", " ", 
             RowBox[{"Sin", "[", "ph09", "]"}]}]}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "y"}], " ", 
             RowBox[{"Sin", "[", "ph09", "]"}]}], "+", 
            RowBox[{"x", " ", 
             RowBox[{"Cos", "[", "ph09", "]"}]}]}]}], "]"}]}], ";", 
        RowBox[{"B", "=", 
         RowBox[{"linU", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"y", " ", 
             RowBox[{"Cos", "[", "ph09", "]"}]}], "+", 
            RowBox[{"x", " ", 
             RowBox[{"Sin", "[", "ph09", "]"}]}]}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "y"}], " ", 
             RowBox[{"Sin", "[", "ph09", "]"}]}], "+", 
            RowBox[{"x", " ", 
             RowBox[{"Cos", "[", "ph09", "]"}]}]}]}], "]"}]}], ";", 
        RowBox[{"ann", "=", 
         FractionBox[
          RowBox[{"ArcTan", "[", 
           RowBox[{"A", ",", "B"}], "]"}], "2"]}], ";", 
        RowBox[{"Cos", "[", "ann", "]"}]}], ",", 
       RowBox[{"-", 
        RowBox[{"Sin", "[", "ann", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{
        RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
       RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", 
       RowBox[{
        RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
       RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
     RowBox[{"VectorPoints", "\[Rule]", "40"}], ",", 
     RowBox[{"VectorStyle", "\[Rule]", 
      RowBox[{"Arrowheads", "[", "0", "]"}]}], ",", 
     RowBox[{"StreamStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Arrowheads", "[", "0", "]"}], ",", 
        RowBox[{"RGBColor", "[", 
         RowBox[{"1", ",", "0.5", ",", "0.5"}], "]"}]}], "}"}]}], ",", 
     RowBox[{"StreamPoints", "\[Rule]", "50"}], ",", 
     RowBox[{"StreamScale", "\[Rule]", "Full"}], ",", 
     RowBox[{"MaxRecursion", "\[Rule]", "2"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "y", ",", "vx", ",", "vy", ",", "n"}], "}"}], ",", 
        RowBox[{
         RowBox[{"w", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               FractionBox["1", "2"], 
               RowBox[{"Log", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"linQ", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"y", " ", 
                    RowBox[{"Cos", "[", "ph09", "]"}]}], "+", 
                    RowBox[{"x", " ", 
                    RowBox[{"Sin", "[", "ph09", "]"}]}]}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "y"}], " ", 
                    RowBox[{"Sin", "[", "ph09", "]"}]}], "+", 
                    RowBox[{"x", " ", 
                    RowBox[{"Cos", "[", "ph09", "]"}]}]}]}], "]"}], "^", 
                  "2"}], "+", 
                 RowBox[{
                  RowBox[{"linU", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"y", " ", 
                    RowBox[{"Cos", "[", "ph09", "]"}]}], "+", 
                    RowBox[{"x", " ", 
                    RowBox[{"Sin", "[", "ph09", "]"}]}]}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "y"}], " ", 
                    RowBox[{"Sin", "[", "ph09", "]"}]}], "+", 
                    RowBox[{"x", " ", 
                    RowBox[{"Cos", "[", "ph09", "]"}]}]}]}], "]"}], "^", 
                  "2"}]}], "]"}]}], "-", "scL"}], ")"}], "/", 
            RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ";", 
         RowBox[{"RGBColor", "[", 
          RowBox[{
           RowBox[{"2", " ", "w", " ", "csc"}], ",", 
           RowBox[{"w", " ", "csc"}], ",", 
           RowBox[{"w", " ", "csc"}]}], "]"}]}]}], "]"}]}], ",", 
     RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
     RowBox[{"Epilog", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"QUline", "=", 
            RowBox[{
            "\"\<\!\(\*SqrtBox[\(\*SuperscriptBox[\(Q\), \(2\)] + \
\*SuperscriptBox[\(U\), \(2\)]\)]\) & field: \!\(\*SubscriptBox[\(a\), \(*\)]\
\)=\>\"", "<>", 
             RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \[Nu]=\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
             "\"\<GHz,  \[Theta]=\>\"", "<>", 
             RowBox[{"ToString", "[", "th", "]"}], "<>", 
             "\"\<\[Degree]\>\""}]}], ",", 
           RowBox[{"mysize", "-", "3"}], ",", "Bold", ",", "Pink"}], "]"}], 
         ",", 
         RowBox[{"Scaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.486466504365*^9, 3.486466504535*^9}, {3.486466888175*^9,
    3.4864669138190002`*^9}, {3.486466946699*^9, 3.48646696973*^9}, {
   3.486469104926*^9, 3.486469333568*^9}, {3.4864693788269997`*^9, 
   3.486469382115*^9}, {3.486469442733*^9, 3.48646944301*^9}, {
   3.486469817558*^9, 3.486469832678*^9}, {3.486470376785*^9, 
   3.486470387541*^9}, {3.486470422441*^9, 3.4864704816140003`*^9}, 
   3.4864705136070004`*^9, {3.486471330034*^9, 3.4864713477460003`*^9}, {
   3.486474745896*^9, 3.48647475674*^9}, {3.487437960727*^9, 
   3.487437964684*^9}, {3.487437998273*^9, 3.487438087355*^9}, {
   3.487438120276*^9, 3.487438128234*^9}, 3.487438168425*^9, 
   3.487438206017*^9, {3.487439374508*^9, 3.487439379585*^9}, {
   3.4874394374820004`*^9, 3.4874394793310003`*^9}, {3.487439559781*^9, 
   3.487439593867*^9}, {3.487439646443*^9, 3.487439651396*^9}, 
   3.487439729449*^9, {3.4874399640973997`*^9, 3.4874399692454*^9}, {
   3.4874593360559998`*^9, 3.487459363166*^9}, {3.4874594277469997`*^9, 
   3.4874594282860003`*^9}, {3.487517871558*^9, 3.487517899601*^9}, {
   3.487517941801*^9, 3.487517959034*^9}, {3.4876892649812*^9, 
   3.4876892778392*^9}, {3.4891561032871323`*^9, 3.4891562072143326`*^9}, {
   3.497801360825*^9, 3.497801487205*^9}, {3.502475567818*^9, 
   3.502475571092*^9}, {3.502475730039*^9, 3.502475763918*^9}, {
   3.502475931771*^9, 3.502475952546*^9}, 3.502476117457*^9, {
   3.502540423955*^9, 3.502540426042*^9}, {3.5025520755824003`*^9, 
   3.5025520756373997`*^9}, 3.5025521097914*^9, {3.5025521421874*^9, 
   3.5025521809983997`*^9}, {3.5025531623204*^9, 3.5025531749983997`*^9}, {
   3.5025548195654*^9, 3.5025548460494003`*^9}, {3.5025582655064*^9, 
   3.5025582824824*^9}, {3.5025601031384*^9, 3.5025601349244003`*^9}, {
   3.5025612836654*^9, 3.5025612837604*^9}, 3.5025613801274*^9, {
   3.5025614609844*^9, 3.5025614614054003`*^9}, {3.5025615025554*^9, 
   3.5025615027944*^9}, {3.5025615357134*^9, 3.5025615360664*^9}, {
   3.5025616542794*^9, 3.5025616543254004`*^9}, {3.5025621283798*^9, 
   3.5025621588466*^9}, {3.5030821488120003`*^9, 3.503082167792*^9}, {
   3.505570654051*^9, 3.5055706825179996`*^9}, {3.5093821227911034`*^9, 
   3.5093821286611032`*^9}, {3.5093822022271037`*^9, 
   3.5093822241871033`*^9}, {3.5093828806511035`*^9, 
   3.5093828937231035`*^9}, {3.5093830692181034`*^9, 3.509383095443104*^9}, 
   3.5093832226691036`*^9, {3.5093839781381035`*^9, 3.5093839782071037`*^9}, {
   3.509453146995*^9, 3.509453151762*^9}, {3.5094531883710003`*^9, 
   3.5094532010550003`*^9}, {3.509453469204*^9, 3.509453469508*^9}, {
   3.5101485180416*^9, 3.5101485471106*^9}, {3.5102334635326*^9, 
   3.5102334720316*^9}, 3.5292430325214157`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "Get", "[", 
   "\"\<C:\\\\Program Files\\\\Wolfram \
Research\\\\Mathematica\\\\LevelScheme-3.45\\\\LevelScheme.m\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ratio", "=", "0.25"}], ";", 
  RowBox[{"ysc", "=", "10"}], ";", 
  RowBox[{"num", "=", "15"}], ";", 
  RowBox[{"xsc", "=", 
   RowBox[{"ratio", " ", "ysc"}]}], ";", 
  RowBox[{
   RowBox[{"fcol", "[", "a_", "]"}], ":=", 
   SuperscriptBox["a", "2."]}], ";", 
  RowBox[{
   RowBox[{"fnI", "[", "i_", "]"}], ":=", 
   RowBox[{"0.05", " ", 
    SuperscriptBox["20", "i"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nf", "[", "scV_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"z", "=", 
      RowBox[{"Floor", "[", 
       RowBox[{"Log", "[", 
        RowBox[{"10", ",", "scV"}], "]"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"ToString", "[", 
       RowBox[{"Floor", "[", 
        RowBox[{
         RowBox[{
          SuperscriptBox["10", 
           RowBox[{"-", "z"}]], "scV"}], ",", "0.01"}], "]"}], "]"}], "<>", 
      "\"\<e\>\"", "<>", 
      RowBox[{"ToString", "[", "z", "]"}]}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gr", "=", 
   RowBox[{"Graphics", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"RGBColor", "[", 
         RowBox[{"0.8", ",", "1", ",", "1.0"}], "]"}], ",", 
        RowBox[{"Rectangle", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{
             RowBox[{"-", "0.05"}], "ysc"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"xsc", ",", 
            RowBox[{"1.05", "ysc"}]}], "}"}]}], "]"}]}], "}"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"GrayLevel", "[", "i", "]"}], ",", 
          RowBox[{"Rectangle", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"0.05", "xsc"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 FractionBox["0.1", "num"]}], "ysc"}], "+", 
               RowBox[{
                FractionBox[
                 RowBox[{"ysc", " ", "i"}], 
                 RowBox[{"num", "+", "1"}]], "num"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"0.4", "xsc"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 FractionBox["0.1", "num"]}], "ysc"}], "+", 
               FractionBox[
                RowBox[{"ysc", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"i", " ", "num"}], "+", "1"}], ")"}]}], 
                RowBox[{"num", "+", "1"}]]}]}], "}"}]}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "1", ",", 
          FractionBox["1", "num"]}], "}"}]}], "]"}], ",", "Black", ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"ToString", "[", 
             RowBox[{"Floor", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"fcol", "[", "i", "]"}], "+", 
                SuperscriptBox["10", 
                 RowBox[{"-", "6."}]]}], ",", "0.01"}], "]"}], "]"}], ",", 
            "16"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"0.7", "xsc"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               FractionBox["0.1", "num"]}], "ysc"}], "+", 
             FractionBox[
              RowBox[{"ysc", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"i", " ", "num"}], "+", "0.5"}], ")"}]}], 
              RowBox[{"num", "+", "1"}]]}]}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "1", ",", 
          FractionBox["1", "num"]}], "}"}]}], "]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Show", "[", 
   RowBox[{"gr", ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "xsc"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "0.05"}], "ysc"}], ",", "ysc"}], "}"}]}], "}"}]}]}], 
   "]"}], ";", 
  RowBox[{"dr", "=", "0.95"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"grI09", "=", 
    RowBox[{"Graphics", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.8", ",", "1", ",", "1.0"}], "]"}], ",", 
         RowBox[{"Rectangle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{
              RowBox[{"-", "0.05"}], "ysc"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"xsc", ",", 
             RowBox[{"1.05", "ysc"}]}], "}"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"rr", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{"fnI", "[", "i", "]"}], "]"}], "/", 
               RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ";", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"2", "rr", " ", "csc"}], ",", 
              RowBox[{"rr", " ", "csc"}], ",", 
              RowBox[{"rr", " ", "csc"}]}], "]"}]}], ",", 
           RowBox[{"Rectangle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.05", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", "i"}], 
                  RowBox[{"num", "+", "1"}]], "num"}]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.4", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "num"}], "+", "1"}], ")"}]}], 
                  RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", "Black", ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{"NumberForm", "[", 
               RowBox[{
                RowBox[{"fnI", "[", "i", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}]}], "]"}], "]"}], ",", "16"}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"0.7", "xsc"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                FractionBox["0.1", "num"]}], "ysc"}], "+", 
              RowBox[{"dr", 
               FractionBox[
                RowBox[{"ysc", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"i", " ", "num"}], "+", "0.5"}], ")"}]}], 
                RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"\"\<x\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"NumberForm", "[", 
              RowBox[{
               RowBox[{"Exp", "[", "scale09", "]"}], ",", "3"}], "]"}], 
             "]"}]}], ",", "16"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"0.5", "xsc"}], ",", 
           RowBox[{"0.98", "ysc"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"grI05", "=", 
    RowBox[{"Graphics", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.8", ",", "1", ",", "1.0"}], "]"}], ",", 
         RowBox[{"Rectangle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{
              RowBox[{"-", "0.05"}], "ysc"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"xsc", ",", 
             RowBox[{"1.05", "ysc"}]}], "}"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"rr", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{"fnI", "[", "i", "]"}], "]"}], "/", 
               RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ";", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"2", "rr", " ", "csc"}], ",", 
              RowBox[{"rr", " ", "csc"}], ",", 
              RowBox[{"rr", " ", "csc"}]}], "]"}]}], ",", 
           RowBox[{"Rectangle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.05", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", "i"}], 
                  RowBox[{"num", "+", "1"}]], "num"}]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.4", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "num"}], "+", "1"}], ")"}]}], 
                  RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", "Black", ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{"NumberForm", "[", 
               RowBox[{
                RowBox[{"fnI", "[", "i", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}]}], "]"}], "]"}], ",", "16"}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"0.7", "xsc"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                FractionBox["0.1", "num"]}], "ysc"}], "+", 
              RowBox[{"dr", 
               FractionBox[
                RowBox[{"ysc", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"i", " ", "num"}], "+", "0.5"}], ")"}]}], 
                RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"\"\<x\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"NumberForm", "[", 
              RowBox[{
               RowBox[{"Exp", "[", "scale05", "]"}], ",", "3"}], "]"}], 
             "]"}]}], ",", "16"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"0.5", "xsc"}], ",", 
           RowBox[{"0.98", "ysc"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}], ",", 
   RowBox[{"grQU", "=", 
    RowBox[{"Graphics", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.8", ",", "1", ",", "1.0"}], "]"}], ",", 
         RowBox[{"Rectangle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{
              RowBox[{"-", "0.05"}], "ysc"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"xsc", ",", 
             RowBox[{"1.05", "ysc"}]}], "}"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"rr", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{"fnI", "[", "i", "]"}], "]"}], "/", 
               RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ";", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"2", "rr", " ", "csc"}], ",", 
              RowBox[{"rr", " ", "csc"}], ",", 
              RowBox[{"rr", " ", "csc"}]}], "]"}]}], ",", 
           RowBox[{"Rectangle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.05", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", "i"}], 
                  RowBox[{"num", "+", "1"}]], "num"}]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.4", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "num"}], "+", "1"}], ")"}]}], 
                  RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", "Black", ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{"NumberForm", "[", 
               RowBox[{
                RowBox[{"fnI", "[", "i", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}]}], "]"}], "]"}], ",", "16"}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"0.7", "xsc"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                FractionBox["0.1", "num"]}], "ysc"}], "+", 
              RowBox[{"dr", 
               FractionBox[
                RowBox[{"ysc", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"i", " ", "num"}], "+", "0.5"}], ")"}]}], 
                RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"\"\<x\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"NumberForm", "[", 
              RowBox[{
               RowBox[{"Exp", "[", "scL", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"5", ",", "5"}], "}"}]}], "]"}], "]"}]}], ",", "16"}],
           "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"0.5", "xsc"}], ",", 
           RowBox[{"0.98", "ysc"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}], ",", 
   RowBox[{"grV", "=", 
    RowBox[{"Graphics", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{"0.8", ",", "1", ",", "1.0"}], "]"}], ",", 
         RowBox[{"Rectangle", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{
              RowBox[{"-", "0.05"}], "ysc"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"xsc", ",", 
             RowBox[{"1.05", "ysc"}]}], "}"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"r", "=", 
             RowBox[{
              RowBox[{"2", "i"}], "-", "1"}]}], ";", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"r", ">", "0"}], ",", 
              RowBox[{"RGBColor", "[", 
               RowBox[{
                RowBox[{"2", "r"}], ",", "r", ",", "r"}], "]"}], ",", 
              RowBox[{"RGBColor", "[", 
               RowBox[{
                RowBox[{"-", "r"}], ",", 
                RowBox[{"-", "r"}], ",", 
                RowBox[{
                 RowBox[{"-", "2"}], "r"}]}], "]"}]}], "]"}]}], ",", 
           RowBox[{"Rectangle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.05", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", "i"}], 
                  RowBox[{"num", "+", "1"}]], "num"}]}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0.4", "xsc"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["0.1", "num"]}], "ysc"}], "+", 
                RowBox[{"dr", 
                 FractionBox[
                  RowBox[{"ysc", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"i", " ", "num"}], "+", "1"}], ")"}]}], 
                  RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", "Black", ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Text", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"ToString", "[", 
              RowBox[{"NumberForm", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"2", "i"}], "-", "1."}], ",", 
                RowBox[{"{", 
                 RowBox[{"2", ",", "2"}], "}"}]}], "]"}], "]"}], ",", "16"}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"0.7", "xsc"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                FractionBox["0.1", "num"]}], "ysc"}], "+", 
              RowBox[{"dr", 
               FractionBox[
                RowBox[{"ysc", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"i", " ", "num"}], "+", "0.5"}], ")"}]}], 
                RowBox[{"num", "+", "1"}]]}]}]}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "1", ",", 
           FractionBox["1", "num"]}], "}"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"\"\<x\>\"", "<>", 
            RowBox[{"nf", "[", "scV", "]"}]}], ",", "16"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"0.5", "xsc"}], ",", 
           RowBox[{"0.98", "ysc"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}]}], 
  "}"}]}], "Input",
 CellChangeTimes->{{3.502129646547*^9, 3.502129653307*^9}, {3.5021297056*^9, 
   3.5021299671800003`*^9}, {3.502130171939*^9, 3.502130177856*^9}, {
   3.5021302665550003`*^9, 3.502130354127*^9}, {3.502198434785*^9, 
   3.50219843788*^9}, {3.502452148104*^9, 3.502452202293*^9}, {
   3.502455133999*^9, 3.502455400816*^9}, {3.502455441406*^9, 
   3.502455714793*^9}, {3.50245574988*^9, 3.502455769021*^9}, {
   3.502455816708*^9, 3.502455816795*^9}, {3.502455980579*^9, 
   3.5024560181280003`*^9}, {3.5024560566870003`*^9, 3.502456057013*^9}, {
   3.5024561147790003`*^9, 3.502456115547*^9}, {3.502456145977*^9, 
   3.502456146041*^9}, {3.502456340414*^9, 3.5024563450299997`*^9}, {
   3.502456437481*^9, 3.502456454575*^9}, {3.502456549299*^9, 
   3.5024565493859997`*^9}, {3.5024567835810003`*^9, 
   3.5024568541800003`*^9}, {3.502457008764*^9, 3.502457093533*^9}, {
   3.502457129922*^9, 3.502457169335*^9}, {3.5024572012139997`*^9, 
   3.502457221542*^9}, {3.502457282362*^9, 3.502457296112*^9}, {
   3.502457334216*^9, 3.5024573634379997`*^9}, {3.502457430657*^9, 
   3.5024574602060003`*^9}, {3.50245755513*^9, 3.502457561506*^9}, {
   3.502457760488*^9, 3.502457760566*^9}, 3.502458213052*^9, {
   3.5025545221734*^9, 3.5025545222544003`*^9}, {3.5025546537553997`*^9, 
   3.5025547479664*^9}, {3.5025555314764*^9, 3.5025556280204*^9}, {
   3.5025556896164*^9, 3.5025557169784*^9}, {3.5025558473524*^9, 
   3.5025558739514*^9}, {3.5025560246174*^9, 3.5025561177854*^9}, {
   3.5025561504734*^9, 3.5025561722384*^9}, {3.5025563131544*^9, 
   3.5025563985554*^9}, {3.5025564806934*^9, 3.5025565437754*^9}, {
   3.5025567242924*^9, 3.5025567647614*^9}, {3.5025569471984*^9, 
   3.5025569594694*^9}, {3.5025570044814*^9, 3.5025570155774*^9}, {
   3.5025570536244*^9, 3.5025570605973997`*^9}, {3.5025583089544*^9, 
   3.5025583204824*^9}, {3.5025583524504004`*^9, 3.5025583564194*^9}, {
   3.5025587587004004`*^9, 3.5025588212924*^9}, {3.5025594994274*^9, 
   3.5025595020624*^9}, {3.5025595893844*^9, 3.5025595974234*^9}, {
   3.5025596610984*^9, 3.5025596894524*^9}, {3.5025597327704*^9, 
   3.5025597666324*^9}, {3.5025602512644*^9, 3.5025602513434*^9}, {
   3.5025613735034*^9, 3.5025613741584*^9}, {3.5101485586675997`*^9, 
   3.5101485590536003`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"siz", "=", 
   RowBox[{"1.05", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "9"}], ",", "9"}], "}"}]}]}], ";", 
  RowBox[{"lt", "=", 
   RowBox[{"LinTicks", "[", 
    RowBox[{
     RowBox[{"-", "8"}], ",", "8", ",", "4", ",", "4"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"figv", "=", 
  RowBox[{"Figure", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.50", ",", "0.98"}], "}"}], ",", 
        "\"\<images of total and polarized intensities for best-fitting \
models\>\"", ",", 
        RowBox[{"FontSize", "\[Rule]", 
         RowBox[{"mysize", "+", "1"}]}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.68", ",", "0.45"}], "}"}], ",", "Vline", ",", 
        RowBox[{"Color", "\[Rule]", "Pink"}], ",", 
        RowBox[{"Background", "\[Rule]", "Black"}], ",", 
        RowBox[{"FontSize", "\[Rule]", 
         RowBox[{"mysize", "-", "2"}]}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.36", ",", "0.45"}], "}"}], ",", "I05line", ",", 
        RowBox[{"Color", "\[Rule]", "Pink"}], ",", 
        RowBox[{"Background", "\[Rule]", "Black"}], ",", 
        RowBox[{"FontSize", "\[Rule]", 
         RowBox[{"mysize", "-", "2"}]}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.36", ",", "0.88"}], "}"}], ",", "I09line", ",", 
        RowBox[{"Color", "\[Rule]", "Pink"}], ",", 
        RowBox[{"Background", "\[Rule]", "Black"}], ",", 
        RowBox[{"FontSize", "\[Rule]", 
         RowBox[{"mysize", "-", "2"}]}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ScaledLabel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0.68", ",", "0.90"}], "}"}], ",", "QUline", ",", 
        RowBox[{"Color", "\[Rule]", "Pink"}], ",", 
        RowBox[{"Background", "\[Rule]", "Black"}], ",", 
        RowBox[{"FontSize", "\[Rule]", 
         RowBox[{"mysize", "-", "2"}]}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
        RowBox[{"Offset", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Multipanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "4"}], "}"}], ",", 
        RowBox[{"XPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "xsc"}], "}"}], ",", "siz", ",", "siz", ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "xsc"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"YPlotRanges", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}], ",", 
               RowBox[{"1.02", "ysc"}]}], "}"}], ",", "siz", ",", "siz", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}], ",", 
               RowBox[{"1.02", "ysc"}]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}], ",", 
               RowBox[{"1.02", "ysc"}]}], "}"}], ",", "siz", ",", "siz", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "0.05"}], "ysc"}], ",", 
               RowBox[{"1.02", "ysc"}]}], "}"}]}], "}"}]}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"XFrameLabels", "\[Rule]", "None"}], ",", 
        RowBox[{"BufferB", "\[Rule]", "2"}], ",", 
        RowBox[{"YFrameLabels", "\[Rule]", "None"}], ",", 
        RowBox[{"BufferL", "\[Rule]", "2"}], ",", 
        RowBox[{"TickFontSize", "\[Rule]", "mysize"}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}], ",", "\[IndentingNewLine]", 
        RowBox[{"XFrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"None", ",", "lt", ",", "lt", ",", "None"}], "}"}]}], ",", 
        RowBox[{"YFrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"None", ",", "lt", ",", "lt", ",", "None"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"None", ",", "lt", ",", "lt", ",", "None"}], "}"}]}], 
          "}"}]}], ",", 
        RowBox[{"XPanelSizes", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0.3", ",", "1", ",", "1", ",", "0.3"}], "}"}]}], ",", 
        RowBox[{"YPanelSizes", "\[Rule]", "1"}], ",", 
        RowBox[{"XGapSizes", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0.15", ",", "0.0", ",", "0.05"}], "}"}]}], ",", 
        RowBox[{"YGapSizes", "\[Rule]", 
         RowBox[{"{", "0.0", "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"Background", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterBackground", "\[Rule]", "White"}], ",", 
        RowBox[{"PanelLetterFontColor", "\[Rule]", "Black"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PanelLetterCorner", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "1"}]}], "}"}]}], ",", 
        RowBox[{"Thickness", "\[Rule]", "2"}], ",", 
        RowBox[{"TickNudge", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "5"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "5"}], ",", "0"}], "}"}], ",", "0", ",", "0"}], 
          "}"}]}], ",", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"grI09", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(a)\>\""}], ",", 
        RowBox[{"ShowTickLabelsInterior", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "False"}], 
          "}"}]}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"totI09", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "3"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(b)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"totQU09", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "4"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"grQU", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"grI05", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "2"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(c)\>\""}], ",", 
        RowBox[{"ShowTickLabelsInterior", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "False"}], 
          "}"}]}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"totI05", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "3"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "\"\<(d)\>\""}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"totV09", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "4"}], "}"}], ",", 
        RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "]"}], ",", 
      RowBox[{"RawGraphics", "[", 
       RowBox[{"grV", ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.05"}], ",", "1.05"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.05"}], ",", "1.10"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1155", ",", "850"}], "}"}]}]}], 
   RowBox[{"(*", 
    RowBox[{"{", 
     RowBox[{"1100", ",", "800"}], "}"}], "*)"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5025533764804*^9, 3.5025533820794*^9}, {
   3.5025534158213997`*^9, 3.5025534158764*^9}, {3.5025535127114*^9, 
   3.5025535838604*^9}, {3.5025536190434*^9, 3.5025536889624*^9}, {
   3.5025537551984*^9, 3.5025537767414*^9}, {3.5025538383954*^9, 
   3.5025538664974003`*^9}, {3.5025538969424*^9, 3.5025539019684*^9}, {
   3.5025539400674*^9, 3.5025539402424*^9}, {3.5025541513304*^9, 
   3.5025541516244*^9}, {3.5025541959924*^9, 3.5025542169094*^9}, {
   3.5025542610674*^9, 3.5025542748514*^9}, {3.5025543105694*^9, 
   3.5025543130424*^9}, {3.5025543543984003`*^9, 3.5025543592784*^9}, {
   3.5025561249244003`*^9, 3.5025561252654*^9}, {3.5025583432854*^9, 
   3.5025583439024*^9}, {3.5025588601043997`*^9, 3.5025588602324*^9}, 
   3.5025597999344*^9, {3.5025601535664*^9, 3.5025601578864*^9}, {
   3.5025602124124002`*^9, 3.5025602160424*^9}, {3.5025603535174*^9, 
   3.5025603693283997`*^9}, {3.5025604020734*^9, 3.5025604318073997`*^9}, {
   3.5025604682704*^9, 3.5025604949944*^9}, {3.5025605291944*^9, 
   3.5025605292074003`*^9}, {3.502561799251*^9, 3.5025619258761997`*^9}, {
   3.5025619825198*^9, 3.5025620749342003`*^9}, {3.5025621948514*^9, 
   3.5025621954754*^9}, {3.5101486679996*^9, 3.5101486920446*^9}, {
   3.5101487307576*^9, 3.5101487403185997`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"myf", "=", "15"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"imagepl", "=", 
    RowBox[{
     RowBox[{"GraphicsGrid", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"totI09", ",", "totV09"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"totI05", ",", "totQU09"}], "}"}]}], "}"}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "16"}]}], "}"}]}], ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<images of total and polarized intensities for best-fitting \
models\>\""}]}], "]"}], "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{
       "\"\<C:\\\\study\\\\accretion\\\\! 2009 fall cfa\\\\GR Polarized \
modeling\\\\\>\"", "<>", "\"\<images.pdf\>\""}], ",", "imagepl", ",", 
       RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", " ", 
       RowBox[{"ImageResolution", "\[Rule]", "150"}]}], "]"}]}]}], 
   "*)"}]}], "\n", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "\"\<C:\\\\study\\\\accretion\\\\! 2009 fall cfa\\\\GR Polarized \
modeling\\\\\>\"", "<>", "\"\<images.eps\>\""}], ",", "figv", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", " ", 
   RowBox[{"ImageResolution", "\[Rule]", "150"}]}], "]"}]}], "Input",
 CellChangeTimes->{
  3.4875180686218*^9, {3.4885991589258003`*^9, 3.4885991592248*^9}, {
   3.489156234295933*^9, 3.4891562452315326`*^9}, {3.4891589360121326`*^9, 
   3.4891589426265326`*^9}, {3.4891589846685324`*^9, 3.489158984996133*^9}, {
   3.4891590499857326`*^9, 3.4891590973629327`*^9}, {3.4891592083569326`*^9, 
   3.4891592121477327`*^9}, {3.502475801034*^9, 3.5024758024709997`*^9}, {
   3.5025598734754*^9, 3.5025598947854*^9}, {3.5025599291524*^9, 
   3.5025599320234003`*^9}, {3.5025612126324*^9, 3.5025612129904003`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["for Einstein Fellowship", "Subsubsection",
 CellChangeTimes->{{3.5025611136493998`*^9, 3.5025611196804*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"con", "=", "20"}], ";", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"contrast", " ", "con"}], "\[Implies]", 
      RowBox[{
      "luminosity", " ", "con", " ", "times", " ", "lower", " ", "is", " ", 
       "black"}]}], ",", 
     RowBox[{"max", " ", "luminosity", " ", "is", " ", "white"}]}], "*)"}], 
   RowBox[{"totI09", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"rr", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"li", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"y", " ", 
               RowBox[{"Cos", "[", "ph09", "]"}]}], "+", 
              RowBox[{"x", " ", 
               RowBox[{"Sin", "[", "ph09", "]"}]}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "y"}], " ", 
               RowBox[{"Sin", "[", "ph09", "]"}]}], "+", 
              RowBox[{"x", " ", 
               RowBox[{"Cos", "[", "ph09", "]"}]}]}]}], "]"}], "-", "scale"}],
           ")"}], "/", 
         RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{
         RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
        RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "150"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{
           RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{
            "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): a=\>\"", "<>", 
             RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,   \[Nu]=\>\"", 
             "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
             "\"\<GHz,   \[Theta]=\>\"", "<>", 
             RowBox[{"ToString", "[", "th", "]"}], "<>", 
             "\"\<\[Degree]\>\""}], ",", 
            RowBox[{"mysize", "-", "2"}], ",", "Bold", ",", "Pink"}], "]"}], 
          ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"scV", "=", 
   RowBox[{"3.5", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "6"}]]}]}], ";", 
  RowBox[{"scL", "=", 
   RowBox[{"Log", "[", "0.0003", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"totV09", "=", 
   RowBox[{"DensityPlot", "[", 
    RowBox[{
     RowBox[{"res", "=", 
      RowBox[{"linV", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"y", " ", 
          RowBox[{"Cos", "[", "ph09", "]"}]}], "+", 
         RowBox[{"x", " ", 
          RowBox[{"Sin", "[", "ph09", "]"}]}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "y"}], " ", 
          RowBox[{"Sin", "[", "ph09", "]"}]}], "+", 
         RowBox[{"x", " ", 
          RowBox[{"Cos", "[", "ph09", "]"}]}]}]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{
        RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
       RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", 
       RowBox[{
        RowBox[{"-", "sss"}], " ", "maxy"}], ",", 
       RowBox[{"sss", " ", "maxy"}]}], "}"}], ",", 
     RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", "n", "}"}], ",", 
        RowBox[{
         RowBox[{"r", "=", 
          RowBox[{"n", "/", "scV"}]}], ";", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"r", ">", "0"}], ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{
             RowBox[{"2", "r"}], ",", "r", ",", "r"}], "]"}], ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{
             RowBox[{"-", "r"}], ",", 
             RowBox[{"-", "r"}], ",", 
             RowBox[{
              RowBox[{"-", "2"}], "r"}]}], "]"}]}], "]"}]}]}], "]"}]}], ",", 
     RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
     RowBox[{"Epilog", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"\"\<V: a=\>\"", "<>", 
            RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \[Nu]=\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
            "\"\<GHz,  \[Theta]=\>\"", "<>", 
            RowBox[{"ToString", "[", "th", "]"}], "<>", "\"\<\[Degree]\>\""}],
            ",", "mysize", ",", "Bold", ",", "Pink"}], "]"}], ",", 
         RowBox[{"Scaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}], ",", 
     RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Red", " ", "-", " ", "positive"}], ",", " ", 
    RowBox[{"Blue", " ", "-", " ", "negative"}]}], "*)"}], 
  RowBox[{"myf", "=", "15"}], ";", 
  RowBox[{"imagepl", "=", 
   RowBox[{"GraphicsRow", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"totI09", ",", "totV09"}], "}"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "16"}]}], "}"}]}]}], 
    RowBox[{"(*", 
     RowBox[{",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<images of total and circular polarized intensities for \
best-fitting models\>\""}]}], "*)"}], "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
  "dirx", "=", 
   "\"\<C:\\\\Users\\\\roman\\\\Desktop\\\\pdocs\\\\Einstein\\\\\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"dirx", "<>", "\"\<images.eps\>\""}], ",", "imagepl", ",", 
   RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", " ", 
   RowBox[{"ImageResolution", "\[Rule]", "150"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.4978015652460003`*^9, 3.4978016441549997`*^9}, {
   3.4978017061*^9, 3.49780170749*^9}, {3.4978020660439997`*^9, 
   3.4978020670810003`*^9}, 3.497802429849*^9, {3.49780363715*^9, 
   3.4978036397460003`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"d", "=", 
   RowBox[{"8.3", " ", 
    SuperscriptBox["10", "3"], "3.08", " ", 
    SuperscriptBox["10", "18"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rg", "=", 
   RowBox[{"2", " ", "4.3", " ", 
    SuperscriptBox["10", "6"], "2", " ", 
    SuperscriptBox["10", "33"], "6.67", " ", 
    RowBox[{
     SuperscriptBox["10", 
      RowBox[{"-", "8"}]], "/", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"3", " ", 
        SuperscriptBox["10", "10"]}], ")"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
   RowBox[{
    FractionBox["rg", 
     RowBox[{"2", "\[Pi]", " ", "d"}]], "360", " ", "60", " ", "60", " ", 
    SuperscriptBox["10", "6"]}], ",", 
   "\"\<\[Mu]as in 1\!\(\*SubscriptBox[\(r\), \
\(g\)]\)(=2GM/\!\(\*SuperscriptBox[\(c\), \(2\)]\))\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.49780217125*^9, 3.4978023430769997`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Estimating best Position Angle \[Xi] - ",
 StyleBox["done",
  FontColor->RGBColor[0, 0, 1]]
}], "Subsection",
 CellChangeTimes->{{3.4874421297116003`*^9, 3.4874421443346*^9}, {
  3.5293299395886083`*^9, 3.529329940428656*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ss", "=", "1.644"}], ";", 
   RowBox[{"EV231", "=", 
    RowBox[{"3", " ", "5.3"}]}], ";", 
   RowBox[{"EV349", "=", 
    RowBox[{"3", " ", "2.2"}]}], ";"}], 
  RowBox[{"(*", "uncertainties", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"rel00", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"180", "-", 
      RowBox[{"(", 
       RowBox[{"x231", "-", 
        RowBox[{"(", 
         RowBox[{"ang230", "+", 
          FractionBox["RM", 
           SuperscriptBox["231", "2"]]}], ")"}]}], ")"}]}], "/.", 
     RowBox[{
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ang230", "+", 
          FractionBox["RM", 
           SuperscriptBox["231", "2"]], "+", "x349", "-", "x231", "-", 
          "ang349", "-", 
          FractionBox["RM", 
           SuperscriptBox["349", "2"]]}], "\[Equal]", "0"}], ",", "RM"}], 
       "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x231", "\[Rule]", "111.5"}], ",", 
      RowBox[{"x349", "\[Rule]", "146.9"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"rel11", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"180", "-", 
      RowBox[{"(", 
       RowBox[{"x231", "-", 
        RowBox[{"(", 
         RowBox[{"ang230", "+", 
          FractionBox["RM", 
           SuperscriptBox["231", "2"]]}], ")"}]}], ")"}]}], "/.", 
     RowBox[{
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ang230", "+", 
          FractionBox["RM", 
           SuperscriptBox["231", "2"]], "+", "x349", "-", "x231", "-", 
          "ang349", "-", 
          FractionBox["RM", 
           SuperscriptBox["349", "2"]]}], "\[Equal]", "0"}], ",", "RM"}], 
       "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x231", "\[Rule]", 
       RowBox[{"111.5", "+", 
        RowBox[{"ss", " ", "EV231"}]}]}], ",", 
      RowBox[{"x349", "\[Rule]", 
       RowBox[{"146.9", "-", 
        RowBox[{"ss", " ", "EV349"}]}]}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin    0.: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "102.15"}], ",", 
        RowBox[{"ang349", "\[Rule]", "126.62"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka0in21_", "60.", "dat"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin   0.5: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "80.97"}], ",", 
        RowBox[{"ang349", "\[Rule]", "86.02"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka50in21_", "60.", "dat"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin   0.7: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "121.31"}], ",", 
        RowBox[{"ang349", "\[Rule]", "86.51"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka70in21_", "60.", "dat"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin   0.9: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "109.35"}], ",", 
        RowBox[{"ang349", "\[Rule]", "102.99"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka90in21_", "60.", "dat"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin  0.98: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "103.85"}], ",", 
        RowBox[{"ang349", "\[Rule]", "98.85"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka98in21_", "60.", "dat"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin 0.5 N1: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "94.11"}], ",", 
        RowBox[{"ang349", "\[Rule]", "71.53"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka50in21_various", ".", "dat"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin 0.5 N2: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "77.87"}], ",", 
        RowBox[{"ang349", "\[Rule]", "83.46"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka50in21_various", ".", "dat"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin 0.5 N3: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "93.01"}], ",", 
        RowBox[{"ang349", "\[Rule]", "58.77"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka50in21_various", ".", "dat"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin 0.5 N4: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "79.06"}], ",", 
        RowBox[{"ang349", "\[Rule]", "85.29"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka50in21_various", ".", "dat"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin 0.5 N5: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "87.15"}], ",", 
        RowBox[{"ang349", "\[Rule]", "77.70"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka50in21_various", ".", "dat"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin 0.5 N6: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "86.49"}], ",", 
        RowBox[{"ang349", "\[Rule]", "89.25"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka50in21_various", ".", "dat"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin    0. fast light: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "97.74"}], ",", 
        RowBox[{"ang349", "\[Rule]", "133.96"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka0in21_", "0.", "dat"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin   0.5 fast light: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "89.58"}], ",", 
        RowBox[{"ang349", "\[Rule]", "84.51"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka50in21_", "0.", "dat"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin   0.7 fast light: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "94.78"}], ",", 
        RowBox[{"ang349", "\[Rule]", "101.34"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka70in21_", "0.", "dat"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin   0.9 fast light: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "108.12"}], ",", 
        RowBox[{"ang349", "\[Rule]", "102.43"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka90in21_", "0.", "dat"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Spin  0.98 fast light: \!\(\*SubscriptBox[\(\[Xi]\), \
\(min\)]\),\!\(\*SubscriptBox[\(\[Xi]\), \(max\)]\)= \>\"", ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a1", ",", "a2"}], "}"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rel00", ",", "rel11"}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ang230", "\[Rule]", "107.56"}], ",", 
        RowBox[{"ang349", "\[Rule]", "100.08"}]}], "}"}]}]}], ",", 
    "\"\< mean=\>\"", ",", 
    FractionBox[
     RowBox[{"a1", "+", "a2"}], "2"]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"quicka98in21_", "0.", "dat"}], 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->CompressedData["
1:eJwdxVFIE3EAB+DTCh86WKUEyw3xRpCI3stACold2BR1GItiEXOntE3mYBW1
HKyNQYrWXGObMislkawNDRoMtpowxsZGRBD20oOzBj54taC4hmRU/989fHyt
ow69uZ6iKIbAkdr97/n9XU7TOPsD6+c//MJnQldruNT2Xlkgyw5vSTOBSwyu
K3vUODqYNOF/icc8pij3iXdki8XTjDd1OQb77e0qnLm1MoS9tr0L+Hyv1tj9
Z5cLx87xmN1S5KNygeve/lrEoere+AZ59IjGjnseTNzA/XTnTWw4Tc9g39xA
GPd9EaomhcAd//RTup92HuPJw6+T0uXL+qXFkwL30mV8hl3NDXEssuuvcGXt
aR5P922UcGLR0ZIlB3MLDD5QS1tiAwJ3RTRZ8YTVcBeL6XkP1nn8Qaysvg3h
jH1yAWvb1MuYmk1ncSudl/540fjiNi9w7o570mPsqnOOXAr47uCzB5fcuKv3
jRer2v9O4cj+k4fYUFcJ42DKF8WPzI5V7JezcVxskonXRgSukHr+G4vZwiEz
OdtzqhFf39Tt2Mh0qvINf57elo2TnTNHFfg/2UwfMw==
  "]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Inclination", " ", "angles"}], "*)"}], 
  RowBox[{
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{
      FractionBox["180", "\[Pi]"], 
      RowBox[{"(", 
       RowBox[{"\[Pi]", "-", 
        RowBox[{"{", 
         RowBox[{
         "1.9202", ",", "1.8716", ",", "1.8609", ",", "1.8431", ",", "1.8871",
           ",", "1.8080"}], "}"}]}], ")"}]}], ",", "0.1"}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Round", "[", 
    RowBox[{
     RowBox[{
      FractionBox["180", "\[Pi]"], 
      RowBox[{"(", 
       RowBox[{"\[Pi]", "-", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"\[Pi]", "-", "0.7231"}], ",", "1.8726", ",", "2.1054", ",",
           "2.2109", ",", "2.1351"}], "}"}]}], ")"}]}], ",", "0.1"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5407232794060073`*^9, 3.5407233244455833`*^9}, {
  3.5407236048606224`*^9, 3.540723608387824*^9}, {3.5407359126362815`*^9, 
  3.540735929546711*^9}, {3.5407359686451797`*^9, 3.540735996709629*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"nh", ",", "#", ",", 
      RowBox[{
       RowBox[{"-", "4"}], ";;", 
       RowBox[{"-", "3"}]}], ",", "All", ",", "4"}], "]"}], "]"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
      "fitting", " ", "124.25", "\[Degree]", " ", "at", " ", "230", "GHz", 
       " ", "and", " ", "slope", " ", "of"}], " ", "+", 
      RowBox[{"24", "\[Degree]", " ", "between", " ", "230"}]}], " ", "&"}], 
    " ", "345", " ", "GHz"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"thmin", ",", "thmax"}], "}"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"12.55", "-", 
    RowBox[{"0.8", " ", "ang230"}], "+", 
    RowBox[{"1.8", " ", "ang345"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Clear", "[", 
     RowBox[{"nh", ",", "co"}], "]"}], ";", 
    RowBox[{"ext", "=", "1."}], ";", 
    RowBox[{"acc", "=", "7"}], ";", 
    RowBox[{"inord", "=", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ";", 
    RowBox[{"Off", "[", 
     RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"co", "=", "0"}], ";", 
    RowBox[{"thlen", "=", "30"}], ";", 
    RowBox[{"sptab", "=", 
     RowBox[{"{", 
      RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], 
      "}"}]}], ";", 
    RowBox[{"poi3", "=", "200000"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tofit", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"8.45", ",", "0.68982", ",", "0", ",", "0", ",", 
         RowBox[{"-", "0.25"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"14.9", ",", "0.904432", ",", "0", ",", "0", ",", 
         RowBox[{"-", "0.62"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"22.5", ",", "1.070321", ",", "0.19", ",", "131.", ",", "0"}],
         "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "43.", ",", "1.159432", ",", "0.504083", ",", "94.25", ",", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "87.73", ",", "1.584437", ",", "1.11", ",", "102.777778", ",", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"102.", ",", "1.415119", ",", "0", ",", "0", ",", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"145.", ",", "2.245702", ",", "0", ",", "0", ",", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"230.86", ",", "2.181906", ",", "7.61271", ",", "124.25", ",", 
         RowBox[{"-", "1.2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"349.", ",", "3.06505", ",", "7.03", ",", "148.142857", ",", 
         RowBox[{"-", "1.5"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"674.", ",", "3.203363", ",", "0", ",", "0", ",", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"857.", ",", "2.786328", ",", "0", ",", "0", ",", "0"}], 
        "}"}]}], "}"}]}], ";", 
    RowBox[{"dFnu", "=", "0.33"}], ";", 
    RowBox[{"dCP", "=", "0.27"}], ";", 
    RowBox[{"dlogLP", "=", "0.26"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"EVPA", "=", "28.5"}], ";", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
       RowBox[{"349", " ", "minus", " ", "230", " ", "difference"}], " ", "-",
        " ", 
       RowBox[{
       "should", " ", "be", " ", "taken", " ", "with", " ", "the", " ", 
        "other", " ", "sign", " ", "from", " ", "the", " ", "code"}]}], ",", 
      " ", 
      RowBox[{"because", " ", "of", " ", "switching"}]}], "*)"}], 
    RowBox[{"dEVPA", "=", "20"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"gat", "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"fnum", "=", 
             RowBox[{
              RowBox[{"-", "1"}], "-", "co"}]}], ";", 
            RowBox[{"th", "=", 
             RowBox[{
              FractionBox["\[Pi]", "thlen"], 
              RowBox[{"(", 
               RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
            RowBox[{"Import", "[", 
             RowBox[{
             "\"\<C:\\\\study\\\\mathematica\\\\3DMHD\\\\poliresa\\\\poliresa\
\>\"", "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"Round", "[", 
                RowBox[{"100", 
                 RowBox[{"sptab", "[", 
                  RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
              "\"\<th\>\"", "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"Floor", "[", 
                RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<fn\>\"", "<>", 
              RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<.dat\>\""}], 
             "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", "\n", 
      RowBox[{"flen", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Position", "[", 
          RowBox[{
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"1", ";;", "11"}], ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}]}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
      RowBox[{"Off", "[", 
       RowBox[{
        RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
        RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], ";", 
      RowBox[{"gat", "=", 
       RowBox[{"Partition", "[", 
        RowBox[{"gat", ",", "flen"}], "]"}]}], ";", 
      RowBox[{"rholen", "=", 
       RowBox[{"Length", "[", 
        RowBox[{"Position", "[", 
         RowBox[{
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "8"}], "]"}],
            "]"}], ",", 
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}]}], 
         "]"}], "]"}]}], ";", 
      RowBox[{"gat", "=", 
       RowBox[{"Partition", "[", 
        RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", 
      RowBox[{"dim", "=", 
       RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", 
      RowBox[{"hlen", "=", 
       RowBox[{"dim", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", 
      RowBox[{"hmin", "=", 
       RowBox[{"Log", "[", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "8"}], 
          "]"}], "]"}], "]"}]}], ";", 
      RowBox[{"hmax", "=", 
       RowBox[{"Log", "[", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}],
         "]"}]}], ";", 
      RowBox[{"thmin", "=", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", 
          RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", 
      RowBox[{"thmax", "=", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1", ",", "1", ",", 
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"rateint", "=", 
       RowBox[{"ListInterpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], "]"}],
            "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"raterho", "=", 
       RowBox[{"ListInterpolation", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "9"}], "]"}], 
           "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tabb", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox[
            RowBox[{"Total", "[", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox[
                RowBox[{
                 RowBox[{"tofit", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                    "2"}], "]"}], "]"}], "-", 
                 RowBox[{"gat", "[", 
                  RowBox[{"[", 
                   RowBox[{"nh", ",", "#", ",", "All", ",", "All", ",", "3"}],
                    "]"}], "]"}]}], "dFnu"], ")"}], "2"], "]"}], "flen"], 
           "&"}], "/@", 
          RowBox[{"Range", "[", "7", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"nh", ",", "hlen"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"lipFnu3", "[", "sp", "]"}], "=", 
       RowBox[{"ListInterpolation", "[", 
        RowBox[{"tabb", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"(", 
               RowBox[{"rhomax", "=", 
                RowBox[{"Log", "[", 
                 FractionBox[
                  RowBox[{"gat", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", 
                    RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "9"}], "]"}],
                    "]"}], 
                  RowBox[{"gat", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"flen", "+", "1"}], ")"}], "/", "2"}], ",", "1", 
                    ",", "1", ",", "9"}], "]"}], "]"}]], "]"}]}], ")"}]}], 
             ",", "rhomax"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tabb", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            FractionBox["1", 
             RowBox[{"flen", "+", "5"}]], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Total", "[", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox[
                  RowBox[{
                   RowBox[{"tofit", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                    "2"}], "]"}], "]"}], "-", 
                   RowBox[{"gat", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    "nh", ",", "#", ",", "All", ",", "All", ",", "3"}], "]"}],
                     "]"}]}], "dFnu"], ")"}], "2"], "]"}], "+", 
              RowBox[{"Total", "[", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox[
                  RowBox[{
                   RowBox[{"tofit", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
                   RowBox[{"gat", "[", 
                    RowBox[{"[", 
                    RowBox[{"nh", ",", "#", ",", 
                    RowBox[{
                    RowBox[{"-", "4"}], ";;", 
                    RowBox[{"-", "3"}]}], ",", "All", ",", "6"}], "]"}], 
                    "]"}]}], "dCP"], ")"}], "2"], "]"}], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox[
                 RowBox[{
                  RowBox[{"Log", "[", 
                   RowBox[{"tofit", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
                  RowBox[{"Log", "[", 
                   RowBox[{"gat", "[", 
                    RowBox[{"[", 
                    RowBox[{"nh", ",", "#", ",", 
                    RowBox[{"-", "7"}], ",", "All", ",", "4"}], "]"}], "]"}], 
                   "]"}]}], "dlogLP"], ")"}], "2"], "+", 
              RowBox[{"Total", "[", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox[
                  RowBox[{
                   RowBox[{"Log", "[", 
                    RowBox[{"tofit", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}],
                    "-", 
                   RowBox[{"Log", "[", 
                    RowBox[{"gat", "[", 
                    RowBox[{"[", 
                    RowBox[{"nh", ",", "#", ",", 
                    RowBox[{
                    RowBox[{"-", "4"}], ";;", 
                    RowBox[{"-", "3"}]}], ",", "All", ",", "4"}], "]"}], 
                    "]"}], "]"}]}], "dlogLP"], ")"}], "2"], "]"}]}], ")"}]}], 
           "&"}], "/@", 
          RowBox[{"Range", "[", "7", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"nh", ",", "hlen"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"lipFnuCPLP3", "[", "sp", "]"}], "=", 
       RowBox[{"ListInterpolation", "[", 
        RowBox[{"tabb", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"PA", "[", "sp", "]"}], "=", 
       RowBox[{"ListInterpolation", "[", 
        RowBox[{"(*", 
         RowBox[{"Mod", "[", 
          RowBox[{"2.063061075394515`", "\[InvisibleSpace]", "-", 
           RowBox[{"0.7796756282875511", " ", 
            RowBox[{"gat", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "All", ",", 
               RowBox[{"-", "4"}], ",", "All", ",", "5"}], "]"}], "]"}]}], 
           "+", 
           RowBox[{"1.7796756282875512", 
            RowBox[{"gat", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "All", ",", 
               RowBox[{"-", "3"}], ",", "All", ",", "5"}], "]"}], "]"}]}]}]}],
          "*)"}], 
        RowBox[{
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"5.5", "\[VeryThinSpace]", "-", 
            RowBox[{"0.7797", 
             RowBox[{"gat", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "All", ",", 
                RowBox[{"-", "4"}], ",", "All", ",", "5"}], "]"}], "]"}]}], 
            "+", 
            RowBox[{"1.7797", " ", 
             RowBox[{"gat", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "All", ",", 
                RowBox[{"-", "3"}], ",", "All", ",", "5"}], "]"}], "]"}]}]}], 
           RowBox[{"(*", 
            RowBox[{"12.55", "-", 
             RowBox[{"0.8", 
              RowBox[{"gat", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "All", ",", 
                 RowBox[{"-", "4"}], ",", "All", ",", "5"}], "]"}], "]"}]}], 
             "+", 
             RowBox[{"1.8", 
              RowBox[{"gat", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "All", ",", 
                 RowBox[{"-", "3"}], ",", "All", ",", "5"}], "]"}], "]"}]}]}],
             "*)"}], ",", "180"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ";", 
      RowBox[{
       RowBox[{"PFnu", "[", "sp", "]"}], "=", 
       RowBox[{"Re", "[", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Exp", "[", 
            RowBox[{"-", 
             FractionBox[
              SuperscriptBox[
               RowBox[{
                RowBox[{"lipFnu3", "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "2"],
               "2"]}], "]"}], 
           RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"rhonor", ",", 
            RowBox[{
             RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
            RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}], ",", 
          RowBox[{"Method", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
             RowBox[{"Method", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
                RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], 
            "}"}]}], ",", 
          RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"PCPLP", "[", "sp", "]"}], "=", 
       RowBox[{"Re", "[", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Exp", "[", 
            RowBox[{"-", 
             FractionBox[
              SuperscriptBox[
               RowBox[{
                RowBox[{"lipFnuCPLP3", "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "2"],
               "2"]}], "]"}], 
           RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"rhonor", ",", 
            RowBox[{
             RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
            RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}], ",", 
          RowBox[{"Method", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
             RowBox[{"Method", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
                RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], 
            "}"}]}], ",", 
          RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Xi]F", "[", "sp", "]"}], "=", 
       RowBox[{"Re", "[", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"PFnu", "[", "sp", "]"}]], 
         RowBox[{"NIntegrate", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"PA", "[", "sp", "]"}], "[", 
             RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], " ", 
            RowBox[{"Exp", "[", 
             RowBox[{"-", 
              FractionBox[
               SuperscriptBox[
                RowBox[{
                 RowBox[{"lipFnu3", "[", "sp", "]"}], "[", 
                 RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                "2"], "2"]}], "]"}], 
            RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"rhonor", ",", 
             RowBox[{
              RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
             RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}], ",", 
           RowBox[{"Method", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
              RowBox[{"Method", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
                 RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], 
             "}"}]}], ",", 
           RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Xi]FCPLP", "[", "sp", "]"}], "=", 
       RowBox[{"Re", "[", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"PCPLP", "[", "sp", "]"}]], 
         RowBox[{"NIntegrate", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"PA", "[", "sp", "]"}], "[", 
             RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
            RowBox[{"Exp", "[", 
             RowBox[{"-", 
              FractionBox[
               SuperscriptBox[
                RowBox[{
                 RowBox[{"lipFnuCPLP3", "[", "sp", "]"}], "[", 
                 RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                "2"], "2"]}], "]"}], 
            RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"rhonor", ",", 
             RowBox[{
              RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
             RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}], ",", 
           RowBox[{"Method", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
              RowBox[{"Method", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
                 RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], 
             "}"}]}], ",", 
           RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"d\[Xi]", "[", "sp", "]"}], "=", 
       RowBox[{"Re", "[", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"PCPLP", "[", "sp", "]"}]], 
         RowBox[{"NIntegrate", "[", 
          RowBox[{
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"PA", "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "-", 
               RowBox[{"\[Xi]FCPLP", "[", "sp", "]"}]}], ")"}], "2"], 
            RowBox[{"Exp", "[", 
             RowBox[{"-", 
              FractionBox[
               SuperscriptBox[
                RowBox[{
                 RowBox[{"lipFnuCPLP3", "[", "sp", "]"}], "[", 
                 RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                "2"], "2"]}], "]"}], 
            RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"rhonor", ",", 
             RowBox[{
              RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
             RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}], ",", 
           RowBox[{"Method", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
              RowBox[{"Method", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
                 RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], 
             "}"}]}], ",", 
           RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}]}], "]"}]}], ";", 
      RowBox[{"Print", "[", 
       RowBox[{"sp", ",", "\"\< \>\"", ",", 
        RowBox[{"\[Xi]F", "[", "sp", "]"}], ",", "\"\< \>\"", ",", 
        RowBox[{"\[Xi]FCPLP", "[", "sp", "]"}], ",", "\"\< \>\"", ",", 
        SqrtBox[
         RowBox[{"d\[Xi]", "[", "sp", "]"}]]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"sp", ",", "1", ",", "5"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.4874406356462*^9, 3.4874406676261997`*^9}, {
   3.4874410253286*^9, 3.4874410861956*^9}, {3.4874411447706003`*^9, 
   3.4874411472566*^9}, {3.4874411859426003`*^9, 3.4874412382296*^9}, {
   3.4874418811526003`*^9, 3.4874419274536*^9}, {3.4874419824516*^9, 
   3.4874420146646*^9}, {3.4874420611286*^9, 3.4874421122665997`*^9}, {
   3.4874421600716*^9, 3.4874421772005997`*^9}, {3.4874429583616*^9, 
   3.4874429820095997`*^9}, {3.4874430383696003`*^9, 3.4874430449056*^9}, {
   3.4874433806956*^9, 3.4874434247656*^9}, {3.4874435530116*^9, 
   3.4874435563386*^9}, {3.4874437752836*^9, 3.4874438047206*^9}, 
   3.4874438868526*^9, {3.4874481883900003`*^9, 3.487448191868*^9}, {
   3.48745759196*^9, 3.487457653601*^9}, {3.487457892198*^9, 
   3.487457900299*^9}, {3.4876874931331997`*^9, 3.4876875224032*^9}, {
   3.4876875548292*^9, 3.4876875572932*^9}, {3.503081163807*^9, 
   3.503081197315*^9}}],

Cell[BoxData[{
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"PA", "[", "2", "]"}], "[", 
    RowBox[{
     RowBox[{"Log", "[", "heat", "]"}], ",", "0", ",", "1.93731"}], "]"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"heat", ",", 
     RowBox[{"Exp", "[", "hmin", "]"}], ",", 
     RowBox[{"Exp", "[", "hmax", "]"}]}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"PA", "[", "4", "]"}], "[", 
    RowBox[{
     RowBox[{"Log", "[", "heat", "]"}], ",", "0", ",", "2.14674"}], "]"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"heat", ",", 
     RowBox[{"Exp", "[", "hmin", "]"}], ",", 
     RowBox[{"Exp", "[", "hmax", "]"}]}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"lipFnuCPLP3", "[", "2", "]"}], "[", 
    RowBox[{
     RowBox[{"Log", "[", "0.359703", "]"}], ",", "0", ",", "1.93731"}], "]"}],
    ",", 
   RowBox[{
    RowBox[{"PA", "[", "2", "]"}], "[", 
    RowBox[{
     RowBox[{"Log", "[", "0.359703", "]"}], ",", "0", ",", "1.93731"}], 
    "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"lipFnuCPLP3", "[", "4", "]"}], "[", 
    RowBox[{
     RowBox[{"Log", "[", "0.345315", "]"}], ",", "0", ",", "2.14674"}], "]"}],
    ",", 
   RowBox[{
    RowBox[{"PA", "[", "4", "]"}], "[", 
    RowBox[{
     RowBox[{"Log", "[", "0.345315", "]"}], ",", "0", ",", "2.14674"}], 
    "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"lipFnuCPLP3", "[", "2", "]"}], "[", 
    RowBox[{
     RowBox[{"Log", "[", "0.345315", "]"}], ",", "0", ",", "2.14674"}], "]"}],
    "*)"}]}]}], "Input",
 CellChangeTimes->{{3.487454056972*^9, 3.4874541162200003`*^9}, {
  3.48745468498*^9, 3.487454907749*^9}, {3.487455452729*^9, 
  3.4874555275030003`*^9}, {3.487457044951*^9, 3.487457104776*^9}}],

Cell[BoxData[{
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      FractionBox["1", 
       RowBox[{
        SqrtBox[
         RowBox[{"2", "\[Pi]", " "}]], "\[Sigma]"}]], 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        FractionBox[
         SuperscriptBox["x", "2"], 
         RowBox[{"2", 
          SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "\[Infinity]"}], ",", 
       RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
     RowBox[{"GenerateConditions", "\[Rule]", "False"}]}], "]"}], ",", 
   RowBox[{"\[Sigma]", ">", "0"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["x", "2"], 
      FractionBox["1", 
       RowBox[{
        SqrtBox[
         RowBox[{"2", "\[Pi]", " "}]], "\[Sigma]"}]], 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        FractionBox[
         SuperscriptBox["x", "2"], 
         RowBox[{"2", 
          SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "\[Infinity]"}], ",", 
       RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
     RowBox[{"GenerateConditions", "\[Rule]", "False"}]}], "]"}], ",", 
   RowBox[{"\[Sigma]", ">", "0"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.487456252976*^9, 3.4874563228710003`*^9}, {
  3.487456365296*^9, 3.487456370323*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Xi]prob", "=", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       FractionBox["1", 
        SqrtBox[
         RowBox[{"2", "\[Pi]", " ", 
          RowBox[{"d\[Xi]", "[", "sp", "]"}]}]]], 
       RowBox[{"Exp", "[", 
        RowBox[{"-", 
         FractionBox[
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[Xi]", "-", 
             RowBox[{"\[Xi]FCPLP", "[", "sp", "]"}]}], ")"}], "2"], 
          RowBox[{"2", 
           RowBox[{"d\[Xi]", "[", "sp", "]"}]}]]}], "]"}], 
       RowBox[{"PCPLP", "[", "sp", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"sp", ",", "1", ",", "5"}], "}"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Plot", "[", 
     RowBox[{"\[Xi]prob", ",", 
      RowBox[{"{", 
       RowBox[{"\[Xi]", ",", "80", ",", "120"}], "}"}]}], "]"}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Xi]tot", "=", 
  RowBox[{"NIntegrate", "[", 
   RowBox[{"\[Xi]prob", ",", 
    RowBox[{"{", 
     RowBox[{"\[Xi]", ",", "0", ",", "180"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Xi]00", "=", 
  RowBox[{"\[Xi]0", "/.", 
   RowBox[{"Quiet", "[", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       FractionBox["\[Xi]tot", "2"], "\[Equal]", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"\[Xi]prob", ",", 
         RowBox[{"{", 
          RowBox[{"\[Xi]", ",", "\[Xi]0", ",", "180"}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Xi]0", ",", "100"}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Xi]min", "=", 
  RowBox[{"\[Xi]m", "/.", 
   RowBox[{"Quiet", "[", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       FractionBox["\[Xi]tot", "20"], "\[Equal]", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"\[Xi]prob", ",", 
         RowBox[{"{", 
          RowBox[{"\[Xi]", ",", "50", ",", "\[Xi]m"}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Xi]m", ",", "60"}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Xi]max", "=", 
  RowBox[{"\[Xi]m", "/.", 
   RowBox[{"Quiet", "[", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       FractionBox["\[Xi]tot", "20"], "\[Equal]", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"\[Xi]prob", ",", 
         RowBox[{"{", 
          RowBox[{"\[Xi]", ",", "\[Xi]m", ",", "180"}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Xi]m", ",", "100"}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<90% confidence interval: (\>\"", ",", "\[Xi]min", ",", "\"\<,\>\"", 
   ",", "\[Xi]max", ",", "\"\<) ;  \[Xi]0=\>\"", ",", "\[Xi]00"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.487456148632*^9, 3.487456249111*^9}, {
  3.4874563351809998`*^9, 3.48745642158*^9}, {3.487456552157*^9, 
  3.487456553824*^9}, {3.4874565963719997`*^9, 3.487456718865*^9}, {
  3.4874568150439997`*^9, 3.4874568733*^9}, {3.487456917116*^9, 
  3.487457006281*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{"2.6", "*", "20"}], 
  SqrtBox["10"]]], "Input",
 CellChangeTimes->{{3.4874591344379997`*^9, 3.4874591394779997`*^9}}],

Cell[BoxData[{
 RowBox[{"Mean", "[", 
  RowBox[{"{", 
   RowBox[{
   "149.8", ",", "90.8", ",", "122.3", ",", "137.3", ",", "116.4", ",", 
    "86.6"}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Mean", "[", 
  RowBox[{"{", 
   RowBox[{"152.7", ",", "142.5", ",", "151.5", ",", "158.7"}], "}"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.487457424573*^9, 3.487457475164*^9}, {3.487457519131*^9,
   3.487457548809*^9}}],

Cell[BoxData["final"], "Input",
 CellChangeTimes->{{3.4874481858929996`*^9, 3.4874481862679996`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Estimating best Te at 6M - now done by the code", "Subsection",
 CellChangeTimes->{{3.4874421297116003`*^9, 3.4874421443346*^9}, {
  3.487459718863*^9, 3.4874597210039997`*^9}, {3.5293382374672194`*^9, 
  3.529338238378272*^9}, {3.529377645163702*^9, 3.529377646618786*^9}, {
  3.529380241049178*^9, 3.5293802414882035`*^9}, {3.540299276787102*^9, 
  3.5402992895635247`*^9}}],

Cell[CellGroupData[{

Cell["best computations", "Subsubsection",
 CellChangeTimes->{{3.5293660068850307`*^9, 3.529366010421233*^9}, {
  3.5293776304188585`*^9, 3.529377632899001*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tofit", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"8.450", ",", "0.6898", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.2500"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14.90", ",", "0.9044", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.6200"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22.50", ",", "1.070", ",", "0.1900", ",", "131.0", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"43.00", ",", "1.159", ",", "0.5041", ",", "94.25", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"87.73", ",", "1.841", ",", "1.42", ",", 
       RowBox[{"-", "4."}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"102.0", ",", "1.908", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"145.0", ",", "2.275", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"230.9", ",", "2.637", ",", "7.40", ",", "111.5", ",", 
       RowBox[{"-", "1.200"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"349.0", ",", "3.181", ",", "6.50", ",", "146.9", ",", 
       RowBox[{"-", "1.500"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"674.0", ",", "3.286", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"857.0", ",", "2.867", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"dFnu", "=", 
    RowBox[{"{", 
     RowBox[{
     "1.", ",", "1.", ",", "1.", ",", "1.", ",", "0.080", ",", "0.1517", ",", 
      "0.2644", ",", "0.1414", ",", "0.1205", ",", "0.3508", ",", "0.2404"}], 
     "}"}]}], ";", 
   RowBox[{"dCP", "=", "0.30"}], ";", 
   RowBox[{"dLP", "=", 
    RowBox[{"{", 
     RowBox[{"0.5", ",", "0.66", ",", "0.61"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=", "2"}], ";", 
  RowBox[{"fmin", "=", "6950"}], ";", 
  RowBox[{"fmax", "=", "9950"}], ";", 
  RowBox[{"ind", "=", "11"}], ";", 
  RowBox[{"sep", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"ind", "-", "1"}], ")"}]}]}], ";", 
  RowBox[{"thlen", "=", "50"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"nh", ",", "co"}], "]"}], ";", 
  RowBox[{"ext", "=", "1."}], ";", 
  RowBox[{"acc", "=", "16"}], ";", 
  RowBox[{"inord", "=", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], ";", 
  RowBox[{"poi3", "=", "20000"}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], "]"}], ";", 
  RowBox[{"t", "=", 
   RowBox[{"TimeUsed", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"NIntegrate", ",", 
    RowBox[{"Method", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
       RowBox[{"Method", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
          RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
    ",", 
    RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"co", "=", "0"}], ";", 
  RowBox[{"thlen", "=", "50"}], ";", 
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"xptab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
     ",", "\"\<098\>\""}], "}"}]}], ";", 
  RowBox[{"nF", "=", "7"}], ";", 
  RowBox[{"nP", "=", "12"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gaxx", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"th", "=", 
       RowBox[{
        FractionBox["\[Pi]", "thlen"], 
        RowBox[{"(", 
         RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
      RowBox[{"Import", "[", 
       RowBox[{
       "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\poliresa\
\>\"", "<>", 
        RowBox[{"ToString", "[", 
         RowBox[{"Round", "[", 
          RowBox[{"100", 
           RowBox[{"sptab", "[", 
            RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
        "\"\<th\>\"", "<>", 
        RowBox[{"ToString", "[", 
         RowBox[{"Floor", "[", 
          RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<fn\>\"", "<>", 
        RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
       "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}]}], ";", 
  RowBox[{"gat", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"Total", "[", 
       RowBox[{"gaxx", ",", 
        RowBox[{"{", "1", "}"}]}], "]"}], "ind"], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"flen", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Position", "[", 
      RowBox[{
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"1", ";;", "11"}], ",", "2"}], "]"}], "]"}], ",", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}]}], "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{
    RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
    RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gat", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{"gat", ",", "flen"}], "]"}]}], ";", 
  RowBox[{"rholen", "=", 
   RowBox[{"Length", "[", 
    RowBox[{"Position", "[", 
     RowBox[{
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "6"}], "]"}], 
       "]"}], ",", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", "1", ",", "6"}], "]"}], "]"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rholen", "=", 
   RowBox[{"Length", "[", 
    RowBox[{"Position", "[", 
     RowBox[{
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "8"}], "]"}], 
       "]"}], ",", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gat", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", 
  RowBox[{"dim", "=", 
   RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", 
  RowBox[{"hlen", "=", 
   RowBox[{"dim", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"hmin", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], 
     "]"}], "]"}]}], ";", 
  RowBox[{"hmax", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"thmin", "=", 
   RowBox[{
    FractionBox["\[Pi]", "thlen"], 
    RowBox[{"(", 
     RowBox[{"1", "-", ".5"}], ")"}]}]}], ";", 
  RowBox[{"thmax", "=", 
   RowBox[{"\[Pi]", "-", "thmin"}]}], ";", 
  RowBox[{"rhomax", "=", 
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "9"}], "]"}], "]"}], 
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", 
        FractionBox[
         RowBox[{"flen", "+", "1"}], "2"], ",", "1", ",", "1", ",", "9"}], 
       "]"}], "]"}]], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rateint", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], "]"}], 
       "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"raterho", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "9"}], "]"}], 
       "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"flux", "[", "i", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", "i", ",", "All", ",", "3"}], "]"}], 
       "]"}]}], ";", 
     RowBox[{
      RowBox[{
       RowBox[{"iflux", "[", "i", "]"}], "[", "sp", "]"}], "=", 
      RowBox[{"ListInterpolation", "[", 
       RowBox[{
        RowBox[{"flux", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "flen"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LP", "[", "1", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "7"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"LP", "[", "2", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "4"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"LP", "[", "3", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "3"}], ",", "All", ",", "4"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CP", "[", "1", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "4"}], ",", "All", ",", "6"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"CP", "[", "2", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "3"}], ",", "All", ",", "6"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"iCPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"CP", "[", "i", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"iLPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"LP", "[", "i", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnux", "[", "sp", "]"}], "=", 
   RowBox[{"Total", "[", 
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         RowBox[{"tofit", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{
             RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", "2"}], 
           "]"}], "]"}], "-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
             RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "&"}], "/@", 
           RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], 
        RowBox[{"dFnu", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], "]"}]],
        ")"}], "2"], 
     RowBox[{"nF", "-", "3"}]], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "=", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"nP", "-", "3"}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{
                RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
               "2"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], ")"}], "/", 
          RowBox[{"dFnu", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
           "]"}]}], ")"}], "2"], "]"}], "+", 
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", "dCP"], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iCPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"Range", "[", "2", "]"}]}], ")"}]}], ")"}]}], ")"}], 
        "2"], "]"}], "+", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"tofit", "[", 
            RowBox[{"[", 
             RowBox[{"5", ",", "3"}], "]"}], "]"}], "-", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"iLPx", "[", "1", "]"}], "[", "sp", "]"}], "[", 
             RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], ")"}]}],
           ")"}], 
         RowBox[{"dLP", "[", 
          RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iLPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"{", 
               RowBox[{"2", ",", "3"}], "}"}]}], ")"}]}], ")"}], "/", 
          RowBox[{"dLP", "[", 
           RowBox[{"[", 
            RowBox[{"2", ";;", "3"}], "]"}], "]"}]}], ")"}], "2"], "]"}]}], 
     ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fdistx", "=", 
   RowBox[{
    RowBox[{"PDF", "[", 
     RowBox[{
      RowBox[{"ChiSquareDistribution", "[", 
       RowBox[{"nF", "-", "3"}], "]"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"nF", "-", "3"}], ")"}], " ", 
       RowBox[{"lipFnux", "[", "sp", "]"}]}]}], "]"}], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ldistx", "=", 
   RowBox[{
    RowBox[{"PDF", "[", 
     RowBox[{
      RowBox[{"ChiSquareDistribution", "[", 
       RowBox[{"nP", "-", "3"}], "]"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"nP", "-", "3"}], ")"}], " ", 
       RowBox[{"lipFnuCPLPx", "[", "sp", "]"}]}]}], "]"}], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Ts06", "[", "sp", "]"}], "=", 
   RowBox[{
    RowBox[{"Interpolation", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"Import", "[", 
         RowBox[{"\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\a\>\"", "<>", 
          RowBox[{"xptab", "[", 
           RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<\\\\Tsmap\>\"", "<>", 
          RowBox[{"xptab", "[", 
           RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<.dat\>\""}], "]"}], 
        "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"1", ";;", "2"}], "]"}], "]"}], "]"}], "]"}], "[", "6", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TpTein", "[", "sp", "]"}], "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "4", ",", "1", ",", "16", ",", "8"}], "]"}], 
         "]"}], "]"}], ",", 
       RowBox[{"2", 
        RowBox[{
         RowBox[{"Ts06", "[", "sp", "]"}], "/", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "4", ",", "1", ",", "16", ",", "11"}], "]"}], 
          "]"}]}]}]}], "}"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5293660148974895`*^9, 3.529366034248596*^9}, 
   3.52937375749034*^9, {3.5293740483279753`*^9, 3.5293740619677553`*^9}, 
   3.5293740957336864`*^9, 3.5293784566441164`*^9, {3.529378808669251*^9, 
   3.5293788156136484`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "2"}], ";", 
  RowBox[{"Exp", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Temin", "=", 
      RowBox[{"Log", "[", 
       RowBox[{
        RowBox[{"TpTein", "[", "sp", "]"}], "[", "hmin", "]"}], "]"}]}], ",", 
     RowBox[{"Temax", "=", 
      RowBox[{"Log", "[", 
       RowBox[{
        RowBox[{"TpTein", "[", "sp", "]"}], "[", "hmax", "]"}], "]"}]}]}], 
    "}"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Tenum", "=", "100"}], ";", 
  RowBox[{"Tevar", "=", 
   RowBox[{"Range", "[", 
    RowBox[{"Temin", ",", "Temax", ",", 
     FractionBox[
      RowBox[{"Temax", "-", "Temin"}], "Tenum"]}], "]"}]}], ";", 
  RowBox[{"\[Theta]tab", "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1", ",", "1", ",", "All", ",", 
      RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"htab", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"TT", "/.", 
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{
            RowBox[{"TpTein", "[", "sp", "]"}], "[", "TT", "]"}], "]"}], 
          "\[Equal]", 
          RowBox[{"Tevar", "[", 
           RowBox[{"[", "i", "]"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"TT", ",", 
           FractionBox[
            RowBox[{"hmin", "+", "hmax"}], "2"]}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"Length", "[", "Tevar", "]"}]}], "}"}]}], "]"}]}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"poi2", "=", "3000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"NIntegrate", ",", 
    RowBox[{"Method", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
       RowBox[{"Method", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
          RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
    ",", 
    RowBox[{"MaxPoints", "\[Rule]", "poi2"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Dynamic", "[", "i", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Tetab", "[", "sp", "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Tevar", "[", 
        RowBox[{"[", "i", "]"}], "]"}], ",", 
       RowBox[{"Log", "[", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{"Ldistx", "/.", 
           RowBox[{"heat", "\[Rule]", 
            RowBox[{"htab", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"rhonor", ",", 
            RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}]}], "]"}], "]"}]}],
       "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"Length", "[", "Tevar", "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ord", "=", "2"}], ";", 
  RowBox[{
   RowBox[{"inFCPLP", "[", "sp", "]"}], "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{
     RowBox[{"Tetab", "[", "sp", "]"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FCPLPnorm", "[", "sp", "]"}], "=", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"inFCPLP", "[", "sp", "]"}], "[", "TT", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"TT", ",", "Temin", ",", "Temax"}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5293789381236553`*^9, 3.5293789400287647`*^9}, {
  3.5293791796184683`*^9, 3.529379181492575*^9}, {3.5293792835504127`*^9, 
  3.5293792906858206`*^9}, {3.529379486981048*^9, 3.529379501420874*^9}, {
  3.5293796577198143`*^9, 3.529379661002002*^9}}],

Cell[BoxData[{
 RowBox[{"ToExpression", "[", 
  RowBox[{"ToString", "[", 
   RowBox[{"Floor", "[", 
    RowBox[{
     RowBox[{"Tetab", "[", "2", "]"}], ",", 
     SuperscriptBox["10", 
      RowBox[{"-", "5."}]]}], "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FCPLPnorm", "[", "2", "]"}]}], "Input",
 CellChangeTimes->{{3.529374671144598*^9, 3.5293746725846806`*^9}, {
  3.5293750710224695`*^9, 3.5293750715895023`*^9}, {3.529379204985919*^9, 
  3.5293792056569576`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "2"}], ";", 
  RowBox[{"rate", "=."}], ";", 
  RowBox[{
   RowBox[{"Tetab", "[", "2", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"22.8782`", ",", 
       RowBox[{"-", "94.3671`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22.9042`", ",", 
       RowBox[{"-", "91.6191`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22.9301`", ",", 
       RowBox[{"-", "89.2194`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22.9561`", ",", 
       RowBox[{"-", "87.9609`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22.9821`", ",", 
       RowBox[{"-", "86.7285`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.0081`", ",", 
       RowBox[{"-", "84.9474`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.034`", ",", 
       RowBox[{"-", "83.645`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.06`", ",", 
       RowBox[{"-", "83.5394`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.086`", ",", 
       RowBox[{"-", "83.9829`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.112`", ",", 
       RowBox[{"-", "84.4143`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.1379`", ",", 
       RowBox[{"-", "85.0653`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.1639`", ",", 
       RowBox[{"-", "85.6281`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.1899`", ",", 
       RowBox[{"-", "86.2697`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.2159`", ",", 
       RowBox[{"-", "86.6435`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.2418`", ",", 
       RowBox[{"-", "87.4778`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.2678`", ",", 
       RowBox[{"-", "88.2071`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.2938`", ",", 
       RowBox[{"-", "87.8082`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.3198`", ",", 
       RowBox[{"-", "86.253`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.3457`", ",", 
       RowBox[{"-", "83.9744`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.3717`", ",", 
       RowBox[{"-", "80.4318`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.3977`", ",", 
       RowBox[{"-", "76.1726`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.4237`", ",", 
       RowBox[{"-", "73.5983`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.4496`", ",", 
       RowBox[{"-", "71.6091`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.4756`", ",", 
       RowBox[{"-", "68.0372`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.5016`", ",", 
       RowBox[{"-", "63.2897`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.5276`", ",", 
       RowBox[{"-", "58.0705`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.5535`", ",", 
       RowBox[{"-", "52.9418`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.5795`", ",", 
       RowBox[{"-", "46.874`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.6055`", ",", 
       RowBox[{"-", "40.9531`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.6315`", ",", 
       RowBox[{"-", "35.2896`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.6574`", ",", 
       RowBox[{"-", "30.1311`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.6834`", ",", 
       RowBox[{"-", "25.8028`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.7094`", ",", 
       RowBox[{"-", "22.8996`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.7354`", ",", 
       RowBox[{"-", "21.3606`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.7613`", ",", 
       RowBox[{"-", "21.0007`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.7873`", ",", 
       RowBox[{"-", "21.6891`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.8133`", ",", 
       RowBox[{"-", "23.502`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.8393`", ",", 
       RowBox[{"-", "25.4134`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.8652`", ",", 
       RowBox[{"-", "27.2639`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.8912`", ",", 
       RowBox[{"-", "29.308`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.9172`", ",", 
       RowBox[{"-", "31.1458`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.9432`", ",", 
       RowBox[{"-", "29.8605`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.9691`", ",", 
       RowBox[{"-", "26.1224`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"23.9951`", ",", 
       RowBox[{"-", "23.8393`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.0211`", ",", 
       RowBox[{"-", "22.6553`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.047`", ",", 
       RowBox[{"-", "20.992`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.073`", ",", 
       RowBox[{"-", "18.8664`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.099`", ",", 
       RowBox[{"-", "17.0233`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.125`", ",", 
       RowBox[{"-", "15.9238`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.1509`", ",", 
       RowBox[{"-", "15.8132`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.1769`", ",", 
       RowBox[{"-", "15.4612`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.2029`", ",", 
       RowBox[{"-", "14.6269`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.2289`", ",", 
       RowBox[{"-", "13.6228`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.2548`", ",", 
       RowBox[{"-", "12.6696`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.2808`", ",", 
       RowBox[{"-", "12.0475`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.3068`", ",", 
       RowBox[{"-", "11.5877`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.3328`", ",", 
       RowBox[{"-", "11.3931`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.3587`", ",", 
       RowBox[{"-", "11.4713`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.3847`", ",", 
       RowBox[{"-", "11.619`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.4107`", ",", 
       RowBox[{"-", "11.8969`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.4367`", ",", 
       RowBox[{"-", "12.3436`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.4626`", ",", 
       RowBox[{"-", "12.8979`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.4886`", ",", 
       RowBox[{"-", "13.5851`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.5146`", ",", 
       RowBox[{"-", "14.2819`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.5406`", ",", 
       RowBox[{"-", "15.0322`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.5665`", ",", 
       RowBox[{"-", "15.999`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.5925`", ",", 
       RowBox[{"-", "17.3353`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.6185`", ",", 
       RowBox[{"-", "19.0886`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.6445`", ",", 
       RowBox[{"-", "21.2468`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.6704`", ",", 
       RowBox[{"-", "23.6918`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.6964`", ",", 
       RowBox[{"-", "26.3741`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.7224`", ",", 
       RowBox[{"-", "29.4129`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.7484`", ",", 
       RowBox[{"-", "32.7799`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.7743`", ",", 
       RowBox[{"-", "36.6794`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.8003`", ",", 
       RowBox[{"-", "40.6961`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.8263`", ",", 
       RowBox[{"-", "44.5064`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.8523`", ",", 
       RowBox[{"-", "47.9587`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.8782`", ",", 
       RowBox[{"-", "51.9046`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.9042`", ",", 
       RowBox[{"-", "56.8016`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.9302`", ",", 
       RowBox[{"-", "62.1887`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.9562`", ",", 
       RowBox[{"-", "68.0498`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"24.9821`", ",", 
       RowBox[{"-", "74.3351`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.0081`", ",", 
       RowBox[{"-", "80.0345`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.0341`", ",", 
       RowBox[{"-", "85.5328`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.06`", ",", 
       RowBox[{"-", "90.9537`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.086`", ",", 
       RowBox[{"-", "97.2591`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.112`", ",", 
       RowBox[{"-", "104.659`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.138`", ",", 
       RowBox[{"-", "113.351`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.1639`", ",", 
       RowBox[{"-", "122.396`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.1899`", ",", 
       RowBox[{"-", "132.232`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.2159`", ",", 
       RowBox[{"-", "142.363`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.2419`", ",", 
       RowBox[{"-", "151.329`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.2678`", ",", 
       RowBox[{"-", "158.026`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.2938`", ",", 
       RowBox[{"-", "163.012`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.3198`", ",", 
       RowBox[{"-", "167.421`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.3458`", ",", 
       RowBox[{"-", "171.153`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.3717`", ",", 
       RowBox[{"-", "174.694`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.3977`", ",", 
       RowBox[{"-", "178.534`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.4237`", ",", 
       RowBox[{"-", "182.727`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.4497`", ",", 
       RowBox[{"-", "187.199`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"25.4756`", ",", 
       RowBox[{"-", "191.803`"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FCPLPnorm", "[", "2", "]"}], "=", "1.7457361398265796`*^-6"}], 
  ";", 
  RowBox[{"rate", "=."}], ";", 
  RowBox[{
   RowBox[{"inFCPLP", "[", "sp", "]"}], "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{
     RowBox[{"Tetab", "[", "sp", "]"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"func", "=", 
   FractionBox[
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"inFCPLP", "[", "sp", "]"}], "[", "TT", "]"}], "]"}], 
    RowBox[{"FCPLPnorm", "[", "sp", "]"}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nno", "=", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{"func", ",", 
     RowBox[{"{", 
      RowBox[{"TT", ",", "Temin", ",", "Temax"}], "}"}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "nlim"}], "]"}], ";", 
  RowBox[{"Off", "[", 
   StyleBox[
    RowBox[{"NIntegrate", "::", "izero"}], "MessageName"], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Te0", "=", 
   RowBox[{
    RowBox[{"Exp", "[", "Tex", "]"}], "/.", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       FractionBox["nno", "2"], "==", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"func", ",", 
         RowBox[{"{", 
          RowBox[{"TT", ",", "Temin", ",", "Tex"}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"Tex", ",", 
        RowBox[{"Log", "[", 
         RowBox[{"4", " ", 
          SuperscriptBox["10", "10"]}], "]"}]}], "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Telmin", "=", 
   RowBox[{
    RowBox[{"Exp", "[", "Tex", "]"}], "/.", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"0.05", "nno"}], "==", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"func", ",", 
         RowBox[{"{", 
          RowBox[{"TT", ",", "Temin", ",", "Tex"}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"Tex", ",", 
        RowBox[{"Log", "[", "Te0", "]"}]}], "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Telmax", "=", 
   RowBox[{
    RowBox[{"Exp", "[", "Tex", "]"}], "/.", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"0.05", "nno"}], "==", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"func", ",", 
         RowBox[{"{", 
          RowBox[{"TT", ",", "Tex", ",", "Temax"}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"Tex", ",", 
        RowBox[{"Log", "[", "Te0", "]"}]}], "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Central value is = \>\"", ",", "Te0", ",", "\"\<K\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<90% confidence interval for Te at 6M: \>\"", ",", 
    RowBox[{"{", 
     RowBox[{"Telmin", ",", "Telmax"}], "}"}], ",", "\"\< K\>\""}], "]"}], 
  ";", 
  RowBox[{"sp", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.5293752419922485`*^9, 3.529375278942362*^9}, 
   3.529375331614375*^9, {3.529375528851656*^9, 3.5293755299397182`*^9}, {
   3.5293756320035563`*^9, 3.5293756375318727`*^9}, {3.52937570689884*^9, 
   3.52937573383438*^9}, {3.529375780969076*^9, 3.5293757843952723`*^9}, {
   3.5293758498760176`*^9, 3.529375870516198*^9}, {3.5293759185479455`*^9, 
   3.529376009960174*^9}, {3.529376058577955*^9, 3.5293760644092884`*^9}, 
   3.5293761139381213`*^9, {3.5293763736059732`*^9, 3.5293763788372726`*^9}, {
   3.5293765940285807`*^9, 3.5293766014120035`*^9}, {3.5293775373955383`*^9, 
   3.5293775541854987`*^9}, {3.5293791860248346`*^9, 
   3.5293792743028836`*^9}, {3.529379306116703*^9, 3.5293794514210143`*^9}, {
   3.5293796217327557`*^9, 3.52937962915018*^9}, {3.5293801898742514`*^9, 
   3.5293802028879957`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["new computations", "Subsubsection",
 CellChangeTimes->{{3.5293347881629305`*^9, 3.5293347904510612`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tofit", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"8.450", ",", "0.6898", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.2500"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14.90", ",", "0.9044", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.6200"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22.50", ",", "1.070", ",", "0.1900", ",", "131.0", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"43.00", ",", "1.159", ",", "0.5041", ",", "94.25", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"87.73", ",", "1.841", ",", "1.42", ",", 
       RowBox[{"-", "4."}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"102.0", ",", "1.908", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"145.0", ",", "2.275", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"230.9", ",", "2.637", ",", "7.40", ",", "111.5", ",", 
       RowBox[{"-", "1.200"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"349.0", ",", "3.181", ",", "6.50", ",", "146.9", ",", 
       RowBox[{"-", "1.500"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"674.0", ",", "3.286", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"857.0", ",", "2.867", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"dFnu", "=", 
    RowBox[{"{", 
     RowBox[{
     "1.", ",", "1.", ",", "1.", ",", "1.", ",", "0.080", ",", "0.1517", ",", 
      "0.2644", ",", "0.1414", ",", "0.1205", ",", "0.3508", ",", "0.2404"}], 
     "}"}]}], ";", 
   RowBox[{"dCP", "=", "0.30"}], ";", 
   RowBox[{"dLP", "=", 
    RowBox[{"{", 
     RowBox[{"0.5", ",", "0.66", ",", "0.61"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=", "2"}], ";", 
  RowBox[{"fmin", "=", "6950"}], ";", 
  RowBox[{"fmax", "=", "9950"}], ";", 
  RowBox[{"ind", "=", "11"}], ";", 
  RowBox[{"sep", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"ind", "-", "1"}], ")"}]}]}], ";", 
  RowBox[{"thlen", "=", "50"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"nh", ",", "co"}], "]"}], ";", 
  RowBox[{"ext", "=", "1."}], ";", 
  RowBox[{"acc", "=", "16"}], ";", 
  RowBox[{"inord", "=", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], ";", 
  RowBox[{"poi3", "=", "20000"}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], "]"}], ";", 
  RowBox[{"t", "=", 
   RowBox[{"TimeUsed", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"NIntegrate", ",", 
    RowBox[{"Method", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
       RowBox[{"Method", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
          RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
    ",", 
    RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"co", "=", "0"}], ";", 
  RowBox[{"thlen", "=", "50"}], ";", 
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"xptab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
     ",", "\"\<098\>\""}], "}"}]}], ";", 
  RowBox[{"nF", "=", "7"}], ";", 
  RowBox[{"nP", "=", "12"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gaxx", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"th", "=", 
       RowBox[{
        FractionBox["\[Pi]", "thlen"], 
        RowBox[{"(", 
         RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
      RowBox[{"Import", "[", 
       RowBox[{
       "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\poliresa\
\>\"", "<>", 
        RowBox[{"ToString", "[", 
         RowBox[{"Round", "[", 
          RowBox[{"100", 
           RowBox[{"sptab", "[", 
            RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
        "\"\<th\>\"", "<>", 
        RowBox[{"ToString", "[", 
         RowBox[{"Floor", "[", 
          RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<fn\>\"", "<>", 
        RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
       "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}]}], ";", 
  RowBox[{"gat", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"Total", "[", 
       RowBox[{"gaxx", ",", 
        RowBox[{"{", "1", "}"}]}], "]"}], "ind"], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"flen", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Position", "[", 
      RowBox[{
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"1", ";;", "11"}], ",", "2"}], "]"}], "]"}], ",", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}]}], "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{
    RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
    RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gat", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{"gat", ",", "flen"}], "]"}]}], ";", 
  RowBox[{"rholen", "=", 
   RowBox[{"Length", "[", 
    RowBox[{"Position", "[", 
     RowBox[{
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "6"}], "]"}], 
       "]"}], ",", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", "1", ",", "6"}], "]"}], "]"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rholen", "=", 
   RowBox[{"Length", "[", 
    RowBox[{"Position", "[", 
     RowBox[{
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "8"}], "]"}], 
       "]"}], ",", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gat", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", 
  RowBox[{"dim", "=", 
   RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", 
  RowBox[{"hlen", "=", 
   RowBox[{"dim", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"hmin", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], 
     "]"}], "]"}]}], ";", 
  RowBox[{"hmax", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"thmin", "=", 
   RowBox[{
    FractionBox["\[Pi]", "thlen"], 
    RowBox[{"(", 
     RowBox[{"1", "-", ".5"}], ")"}]}]}], ";", 
  RowBox[{"thmax", "=", 
   RowBox[{"\[Pi]", "-", "thmin"}]}], ";", 
  RowBox[{"rhomax", "=", 
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "9"}], "]"}], "]"}], 
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", 
        FractionBox[
         RowBox[{"flen", "+", "1"}], "2"], ",", "1", ",", "1", ",", "9"}], 
       "]"}], "]"}]], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rateint", "[", "sp", "]"}], "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], "]"}], 
       "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"raterho", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "9"}], "]"}], 
       "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"flux", "[", "i", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", "i", ",", "All", ",", "3"}], "]"}], 
       "]"}]}], ";", 
     RowBox[{
      RowBox[{
       RowBox[{"iflux", "[", "i", "]"}], "[", "sp", "]"}], "=", 
      RowBox[{"ListInterpolation", "[", 
       RowBox[{
        RowBox[{"flux", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "flen"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LP", "[", "1", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "7"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"LP", "[", "2", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "4"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"LP", "[", "3", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "3"}], ",", "All", ",", "4"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CP", "[", "1", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "4"}], ",", "All", ",", "6"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"CP", "[", "2", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "3"}], ",", "All", ",", "6"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"iCPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"CP", "[", "i", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"iLPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"LP", "[", "i", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnux", "[", "sp", "]"}], "=", 
   RowBox[{"Total", "[", 
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         RowBox[{"tofit", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{
             RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", "2"}], 
           "]"}], "]"}], "-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
             RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "&"}], "/@", 
           RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], 
        RowBox[{"dFnu", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], "]"}]],
        ")"}], "2"], 
     RowBox[{"nF", "-", "3"}]], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "=", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"nP", "-", "3"}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{
                RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
               "2"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], ")"}], "/", 
          RowBox[{"dFnu", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
           "]"}]}], ")"}], "2"], "]"}], "+", 
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", "dCP"], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iCPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"Range", "[", "2", "]"}]}], ")"}]}], ")"}]}], ")"}], 
        "2"], "]"}], "+", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"tofit", "[", 
            RowBox[{"[", 
             RowBox[{"5", ",", "3"}], "]"}], "]"}], "-", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"iLPx", "[", "1", "]"}], "[", "sp", "]"}], "[", 
             RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], ")"}]}],
           ")"}], 
         RowBox[{"dLP", "[", 
          RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iLPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"{", 
               RowBox[{"2", ",", "3"}], "}"}]}], ")"}]}], ")"}], "/", 
          RowBox[{"dLP", "[", 
           RowBox[{"[", 
            RowBox[{"2", ";;", "3"}], "]"}], "]"}]}], ")"}], "2"], "]"}]}], 
     ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fdistx", "=", 
   RowBox[{
    RowBox[{"PDF", "[", 
     RowBox[{
      RowBox[{"ChiSquareDistribution", "[", 
       RowBox[{"nF", "-", "3"}], "]"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"nF", "-", "3"}], ")"}], " ", 
       RowBox[{"lipFnux", "[", "sp", "]"}]}]}], "]"}], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ldistx", "=", 
   RowBox[{
    RowBox[{"PDF", "[", 
     RowBox[{
      RowBox[{"ChiSquareDistribution", "[", 
       RowBox[{"nP", "-", "3"}], "]"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"nP", "-", "3"}], ")"}], " ", 
       RowBox[{"lipFnuCPLPx", "[", "sp", "]"}]}]}], "]"}], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PFnux", "=", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{"Fdistx", ",", 
     RowBox[{"{", 
      RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"rhonor", ",", 
       RowBox[{
        RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
       RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PCPLPx", "=", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{"Ldistx", ",", 
      RowBox[{"{", 
       RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"rhonor", ",", 
        RowBox[{
         RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
        RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
   ";"}], 
  RowBox[{"(*", 
   RowBox[{
   "uncomment", " ", "for", " ", "computation", " ", "of", " ", 
    "probability"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"prob", "[", "sp", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"PFnux", ",", "PCPLPx"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\< sp=\>\"", ",", 
     RowBox[{"sptab", "[", 
      RowBox[{"[", "sp", "]"}], "]"}], ",", 
     "\"\<; Probabilities: P(Fnu)=\>\"", ",", "PFnux", ",", 
     "\"\<; PCPLP=\>\"", ",", "PCPLPx"}], "]"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
   "uncomment", " ", "for", " ", "computation", " ", "of", " ", 
    "probability"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Ts06", "[", "sp", "]"}], "=", 
   RowBox[{
    RowBox[{"Interpolation", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"Import", "[", 
         RowBox[{"\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\a\>\"", "<>", 
          RowBox[{"xptab", "[", 
           RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<\\\\Tsmap\>\"", "<>", 
          RowBox[{"xptab", "[", 
           RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<.dat\>\""}], "]"}], 
        "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"1", ";;", "2"}], "]"}], "]"}], "]"}], "]"}], "[", "6", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TpTein", "[", "sp", "]"}], "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "4", ",", "1", ",", "16", ",", "8"}], "]"}], 
         "]"}], "]"}], ",", 
       RowBox[{"2", 
        RowBox[{
         RowBox[{"Ts06", "[", "sp", "]"}], "/", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "4", ",", "1", ",", "16", ",", "11"}], "]"}], 
          "]"}]}]}]}], "}"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TeF", "[", "sp", "]"}], "=", 
   RowBox[{"Re", "[", 
    RowBox[{
     FractionBox["1", "PFnux"], 
     RowBox[{"NIntegrate", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"TpTein", "[", "sp", "]"}], "[", "heat", "]"}], " ", 
        "Fdistx"}], ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"rhonor", ",", 
         RowBox[{
          RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
         RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TeFCPLP", "[", "sp", "]"}], "=", 
   RowBox[{"Re", "[", 
    RowBox[{
     FractionBox["1", "PCPLPx"], 
     RowBox[{"NIntegrate", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"TpTein", "[", "sp", "]"}], "[", "heat", "]"}], "Ldistx"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"rhonor", ",", 
         RowBox[{
          RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
         RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dTe", "[", "sp", "]"}], "=", 
   SuperscriptBox[
    RowBox[{"Re", "[", 
     RowBox[{
      FractionBox["1", "PCPLPx"], 
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"TpTein", "[", "sp", "]"}], "[", "heat", "]"}], "-", 
            RowBox[{"TeFCPLP", "[", "sp", "]"}]}], ")"}], "2"], "Ldistx"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"rhonor", ",", 
          RowBox[{
           RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
          RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
     "]"}], 
    RowBox[{"1", "/", "2"}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "sp", ",", "\"\< \!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) fit gives \>\"", 
   ",", 
   RowBox[{"TeF", "[", "sp", "]"}], ",", "\"\<K;  FCPLP fit gives \>\"", ",", 
   RowBox[{"TeFCPLP", "[", "sp", "]"}], ",", "\"\<K;  dTe=\>\"", ",", 
   RowBox[{"dTe", "[", "sp", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.529336226995227*^9, 3.5293363355874386`*^9}, {
  3.5293363964429193`*^9, 3.529336402946291*^9}, {3.529336655304725*^9, 
  3.529336657288839*^9}, {3.5293367590176573`*^9, 3.529336782426996*^9}, {
  3.529337518708109*^9, 3.5293375270955887`*^9}, {3.5293376609562454`*^9, 
  3.529337670494791*^9}, {3.5293379149447727`*^9, 3.5293379158408237`*^9}, {
  3.5293379489187155`*^9, 3.529337949274736*^9}, {3.5293380565668726`*^9, 
  3.5293380799662113`*^9}, {3.5293385557084217`*^9, 3.52933856878517*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Teprob", "=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      FractionBox["1", 
       RowBox[{
        SqrtBox[
         RowBox[{"2", "\[Pi]", " "}]], 
        RowBox[{"dTe", "[", "sp", "]"}]}]], 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        FractionBox[
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"Te", "-", 
            RowBox[{"TeFCPLP", "[", "sp", "]"}]}], ")"}], "2"], 
         RowBox[{"2", 
          SuperscriptBox[
           RowBox[{"dTe", "[", "sp", "]"}], "2"]}]]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"sp", ",", "2", ",", "2"}], "}"}]}], "]"}]}], ";", 
  RowBox[{"Plot", "[", 
   RowBox[{"Teprob", ",", 
    RowBox[{"{", 
     RowBox[{"Te", ",", 
      RowBox[{"2.5", " ", 
       SuperscriptBox["10", "10"]}], ",", 
      RowBox[{"5", " ", 
       SuperscriptBox["10", "10"]}]}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Tetot", "=", 
  RowBox[{"Quiet", "[", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{"Teprob", ",", 
     RowBox[{"{", 
      RowBox[{"Te", ",", "0", ",", 
       SuperscriptBox["10", "11"]}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"T00", "=", 
  RowBox[{"T0", "/.", 
   RowBox[{"Quiet", "[", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       FractionBox["Tetot", "2"], "\[Equal]", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"Teprob", ",", 
         RowBox[{"{", 
          RowBox[{"Te", ",", "T0", ",", 
           SuperscriptBox["10", "11"]}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"T0", ",", 
        RowBox[{"3.8", " ", 
         SuperscriptBox["10", "10"]}]}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Temin", "=", 
   RowBox[{"Tm", "/.", 
    RowBox[{"Quiet", "[", 
     RowBox[{"FindRoot", "[", 
      RowBox[{
       RowBox[{
        FractionBox["Tetot", "20"], "\[Equal]", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{"Teprob", ",", 
          RowBox[{"{", 
           RowBox[{"Te", ",", "0", ",", "Tm"}], "}"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"Tm", ",", 
         RowBox[{"0.9", "T00"}]}], "}"}]}], "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Temax", "=", 
   RowBox[{"Tm", "/.", 
    RowBox[{"Quiet", "[", 
     RowBox[{"FindRoot", "[", 
      RowBox[{
       RowBox[{
        FractionBox["Tetot", "20"], "\[Equal]", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{"Teprob", ",", 
          RowBox[{"{", 
           RowBox[{"Te", ",", "Tm", ",", 
            SuperscriptBox["10", "11"]}], "}"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"Tm", ",", 
         RowBox[{"1.1", "T00"}]}], "}"}]}], "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<90% confidence interval: (\>\"", ",", "Temin", ",", "\"\<,\>\"", ",", 
   "Temax", ",", "\"\<) ;  Te0=\>\"", ",", "T00", ",", " ", "\"\<  dTe=\>\"", 
   ",", 
   RowBox[{"Temax", "-", "T00"}]}], "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQBWIQHWE5pej075eOAb3K9SD6wKmnnSA6pn/TFBCtysa6
FESbxlmB6Zzn3atAtMi62ztBdFHGw6MgetZMzbMg2m3b4ksg+svfE3ch/Pum
54C0IccC83Ng81OtQXTjVGtbEL1pbrs7RN4mHkSfKAtKOwe2TywdIp5zGUTf
/lkGpg99PdC4S/KVY33WmlYQLRCxtRNEX/ZNmwKi9e/GLAHR897Hg+lPl1zv
gOgwvolguiiD99AJ1VeO3zQ+HAHRO+RST0LowtMgesKhnfdBdFTK6ocgOrPH
Y+pa71eOy8yiwLTRvgmLQPSrBwsXg+gVX56uANHtn2avBtEAogfF6Q==
  "]]
}, Closed]],

Cell[CellGroupData[{

Cell["old computations", "Subsubsection",
 CellChangeTimes->{{3.5293347834346604`*^9, 3.5293347855627823`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
     ",", "\"\<098\>\""}], "}"}]}], ";", 
  RowBox[{"sp", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ts06", "[", "sp", "]"}], "=", 
  RowBox[{
   RowBox[{"Interpolation", "[", 
    RowBox[{"Transpose", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"Import", "[", 
        RowBox[{"\"\<C:\\\\study\\\\mathematica\\\\3DMHD\\\\Tsmap\>\"", "<>", 
         RowBox[{"sptab", "[", 
          RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<.dat\>\""}], "]"}], 
       "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"1", ";;", "2"}], "]"}], "]"}], "]"}], "]"}], "[", "6", 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.487460849093*^9, 3.487460850943*^9}, {3.487460891415*^9,
   3.4874610175810003`*^9}, {3.503149236903*^9, 3.50314923696*^9}, {
  3.509470462414*^9, 3.5094704624440002`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"tofit", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"8.450", ",", "0.6898", ",", "0", ",", "0", ",", 
        RowBox[{"-", "0.2500"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"14.90", ",", "0.9044", ",", "0", ",", "0", ",", 
        RowBox[{"-", "0.6200"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"22.50", ",", "1.070", ",", "0.1900", ",", "131.0", ",", "0"}],
        "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"43.00", ",", "1.159", ",", "0.5041", ",", "94.25", ",", "0"}],
        "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"87.73", ",", "1.841", ",", "1.026", ",", 
        RowBox[{"-", "4."}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"102.0", ",", "1.908", ",", "0", ",", "0", ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"145.0", ",", "2.275", ",", "0", ",", "0", ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"230.9", ",", "2.637", ",", "7.015", ",", "111.5", ",", 
        RowBox[{"-", "1.200"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"349.0", ",", "3.181", ",", "6.143", ",", "146.9", ",", 
        RowBox[{"-", "1.500"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"674.0", ",", "3.286", ",", "0", ",", "0", ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"857.0", ",", "2.867", ",", "0", ",", "0", ",", "0"}], "}"}]}],
      "}"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"8.45", " ", "-", " ", 
    RowBox[{"43", "GHz"}], " ", "-", " ", 
    RowBox[{"still", " ", "old", " ", "data"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"dFnu", "=", 
    RowBox[{"{", 
     RowBox[{
     "1.", ",", "1.", ",", "1.", ",", "1.", ",", "0.080", ",", "0.1517", ",", 
      "0.2644", ",", "0.1414", ",", "0.1205", ",", "0.3508", ",", "0.2404"}], 
     "}"}]}], ";", 
   RowBox[{"dCP", "=", "0.30"}], ";", 
   RowBox[{"dlogLP", "=", 
    RowBox[{"{", 
     RowBox[{"0.19", ",", "0.086", ",", "0.115"}], "}"}]}], ";", 
   RowBox[{"t", "=", 
    RowBox[{"TimeUsed", "[", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"nh", ",", "co"}], "]"}], ";", 
  RowBox[{"ext", "=", "1."}], ";", 
  RowBox[{"acc", "=", "16"}], ";", 
  RowBox[{"inord", "=", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], ";", 
  RowBox[{"poi3", "=", "20000"}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{
    RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], ",", 
    RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
    RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"NIntegrate", ",", 
      RowBox[{"Method", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
         RowBox[{"Method", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
            RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
      ",", 
      RowBox[{"MaxPoints", "\[Rule]", "poi3"}], ",", 
      RowBox[{"AccuracyGoal", "\[Rule]", "acc"}]}], "]"}], ";"}], "*)"}], 
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{"NIntegrate", ",", 
     RowBox[{"Method", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
        RowBox[{"Method", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
           RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
     ",", 
     RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], 
   ";"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"co", "=", "0"}], ";", 
  RowBox[{"thlen", "=", "50"}], ";", 
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"xptab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
     ",", "\"\<098\>\""}], "}"}]}], ";", 
  RowBox[{"narr", "=", "1.1"}], ";", 
  RowBox[{"nF", "=", "7"}], ";", 
  RowBox[{"nP", "=", "12"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"boosted", "=", "True"}], ";", 
  RowBox[{"avg", "=", "True"}], ";", 
  RowBox[{"test", "=", "\"\<Normal_narrow\>\""}], ";", 
  RowBox[{"test", "=", "\"\<Normal\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"bline", "=", 
        RowBox[{"If", "[", 
         RowBox[{"boosted", ",", "\"\<boo\>\"", ",", "\"\<nob\>\""}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"gat", "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"fnum", "=", 
              RowBox[{
               RowBox[{"-", "1"}], "-", "co"}]}], ";", 
             RowBox[{"th", "=", 
              RowBox[{
               FractionBox["\[Pi]", "thlen"], 
               RowBox[{"(", 
                RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
             RowBox[{"Import", "[", 
              RowBox[{"\"\<E:\\\\mathematica\\\\analysis\\\\poliresa\>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Round", "[", 
                 RowBox[{"100", 
                  RowBox[{"sptab", "[", 
                   RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
               "\"\<th\>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Floor", "[", 
                 RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<fn\>\"", "<>", 
               RowBox[{"ToString", "[", "fnum", "]"}], "<>", "bline", "<>", 
               "\"\<.dat\>\""}], "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", "\n", 
       RowBox[{"flen", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"gat", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", ";;", "11"}], ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"gat", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"gat", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{"gat", ",", "flen"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"rholen", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"Position", "[", 
          RowBox[{
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "8"}], 
             "]"}], "]"}], ",", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}]}], 
          "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"gat", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"dim", "=", 
        RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"hlen", "=", 
        RowBox[{"dim", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", 
       RowBox[{"hmin", "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "8"}], 
           "]"}], "]"}], "]"}]}], ";", 
       RowBox[{"hmax", "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], 
          "]"}], "]"}]}], ";", 
       RowBox[{"hmin", "=", 
        RowBox[{"Log", "[", "0.25", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"thmin", "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", 
       RowBox[{"thmax", "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "1", ",", 
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", 
       RowBox[{"rhomax", "=", 
        RowBox[{"Log", "[", 
         FractionBox[
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "9"}], "]"}], "]"}], 
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"flen", "+", "1"}], ")"}], "/", "2"}], ",", "1", ",", 
             "1", ",", "9"}], "]"}], "]"}]], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"rateint", "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], 
             "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"raterho", "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "9"}], "]"}],
             "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"flux", "[", "i", "]"}], "=", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "All", ",", "i", ",", "All", ",", "3"}], 
             "]"}], "]"}]}], ";", 
          RowBox[{
           RowBox[{
            RowBox[{"iflux", "[", "i", "]"}], "[", "sp", "]"}], "=", 
           RowBox[{"ListInterpolation", "[", 
            RowBox[{
             RowBox[{"flux", "[", "i", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
             RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "flen"}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"LP", "[", "1", "]"}], "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", 
            RowBox[{"-", "7"}], ",", "All", ",", "4"}], "]"}], "]"}], "]"}]}],
        ";", 
       RowBox[{
        RowBox[{"LP", "[", "2", "]"}], "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", 
            RowBox[{"-", "4"}], ",", "All", ",", "4"}], "]"}], "]"}], "]"}]}],
        ";", 
       RowBox[{
        RowBox[{"LP", "[", "3", "]"}], "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", 
            RowBox[{"-", "3"}], ",", "All", ",", "4"}], "]"}], "]"}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"CP", "[", "1", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "4"}], ",", "All", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{
        RowBox[{"CP", "[", "2", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "3"}], ",", "All", ",", "6"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"iCPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
          RowBox[{"ListInterpolation", "[", 
           RowBox[{
            RowBox[{"CP", "[", "i", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
            RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"iLPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
          RowBox[{"ListInterpolation", "[", 
           RowBox[{
            RowBox[{"LP", "[", "i", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
            RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"lipFnux", "[", "sp", "]"}], "=", 
        RowBox[{"Total", "[", 
         FractionBox[
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox[
             RowBox[{
              RowBox[{"tofit", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                 "2"}], "]"}], "]"}], "-", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                  RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                 "&"}], "/@", 
                RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], 
             RowBox[{"dFnu", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
              "]"}]], ")"}], "2"], "flen"], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "=", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"flen", "+", "5"}]], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Total", "[", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"tofit", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                    "2"}], "]"}], "]"}], "-", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                    "&"}], "/@", 
                   RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], ")"}], "/", 
               RowBox[{"dFnu", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
                "]"}]}], ")"}], "2"], "]"}], "+", 
           RowBox[{"Total", "[", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox[
               RowBox[{
                RowBox[{"tofit", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"iCPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                   "&"}], "/@", 
                  RowBox[{"Range", "[", "2", "]"}]}], ")"}]}], "dCP"], ")"}], 
             "2"], "]"}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{"tofit", "[", 
                 RowBox[{"[", 
                  RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"iLPx", "[", "1", "]"}], "[", "sp", "]"}], "[", 
                 RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                ")"}]}], 
              RowBox[{"dlogLP", "[", 
               RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
           RowBox[{"Total", "[", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox[
               RowBox[{
                RowBox[{"Log", "[", 
                 RowBox[{"tofit", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}],
                 "-", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"iLPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                   "&"}], "/@", 
                  RowBox[{"{", 
                   RowBox[{"2", ",", "3"}], "}"}]}], ")"}]}], 
               RowBox[{"dlogLP", "[", 
                RowBox[{"[", 
                 RowBox[{"2", ";;", "3"}], "]"}], "]"}]], ")"}], "2"], 
            "]"}]}], ")"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Fdistx", "=", 
        RowBox[{"nF", " ", 
         RowBox[{"PDF", "[", 
          RowBox[{
           RowBox[{"ChiSquareDistribution", "[", "nF", "]"}], ",", 
           RowBox[{"nF", " ", 
            RowBox[{"lipFnux", "[", "sp", "]"}]}]}], "]"}], 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Ldistx", "=", 
        RowBox[{"nF", " ", 
         RowBox[{"PDF", "[", 
          RowBox[{
           RowBox[{"ChiSquareDistribution", "[", "nF", "]"}], ",", 
           RowBox[{"nF", " ", 
            RowBox[{"lipFnuCPLPx", "[", "sp", "]"}]}]}], "]"}], 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"PFnux", "[", "sp", "]"}], "=", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{"Fdistx", ",", 
          RowBox[{"{", 
           RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"rhonor", ",", 
            RowBox[{
             RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
            RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"PCPLPx", "[", "sp", "]"}], "=", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{"Ldistx", ",", 
          RowBox[{"{", 
           RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"rhonor", ",", 
            RowBox[{
             RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
            RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prob", "[", 
         RowBox[{"sp", ",", "co"}], "]"}], "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"PFnux", "[", "sp", "]"}], ",", 
          RowBox[{"PCPLPx", "[", "sp", "]"}]}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{"PCPLPz", "=", 
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Exp", "[", 
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "2"], "2"]}], 
               "]"}], 
              RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"rhonor", ",", 
               RowBox[{
                RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
               RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
            "]"}]}], "]"}], ";"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<co=\>\"", ",", "co", ",", "\"\< sp=\>\"", ",", 
         RowBox[{"sptab", "[", 
          RowBox[{"[", "sp", "]"}], "]"}], ",", 
         "\"\<; Probabilities: P(Fnu)=\>\"", ",", 
         RowBox[{"PFnux", "[", "sp", "]"}], ",", "\"\<; PCPLP=\>\"", ",", 
         RowBox[{"PCPLPx", "[", "sp", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"avg", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"Ts06", "[", "sp", "]"}], "=", 
           RowBox[{
            RowBox[{"Interpolation", "[", 
             RowBox[{"Transpose", "[", 
              RowBox[{
               RowBox[{"Transpose", "[", 
                RowBox[{"Import", "[", 
                 RowBox[{
                 "\"\<C:\\\\study\\\\mathematica\\\\3DMHD\\\\Tsmap\>\"", "<>", 
                  RowBox[{"xptab", "[", 
                   RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<.dat\>\""}], 
                 "]"}], "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"1", ";;", "2"}], "]"}], "]"}], "]"}], "]"}], "[", 
            "6", "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TpTein", "[", "sp", "]"}], "=", 
           RowBox[{"Interpolation", "[", 
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{"gat", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "4", ",", "1", ",", "16", ",", "8"}], 
                  "]"}], "]"}], "]"}], ",", 
               RowBox[{"2", 
                RowBox[{
                 RowBox[{"Ts06", "[", "sp", "]"}], "/", 
                 RowBox[{"gat", "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "4", ",", "1", ",", "16", ",", "11"}], 
                   "]"}], "]"}]}]}]}], "}"}], "]"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TeF", "[", "sp", "]"}], "=", 
           RowBox[{"Re", "[", 
            RowBox[{
             FractionBox["1", 
              RowBox[{"PFnux", "[", "sp", "]"}]], 
             RowBox[{"NIntegrate", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"TpTein", "[", "sp", "]"}], "[", "heat", "]"}], " ", 
                "Fdistx"}], ",", 
               RowBox[{"{", 
                RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"rhonor", ",", 
                 RowBox[{
                  RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                 RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
              "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TeFCPLP", "[", "sp", "]"}], "=", 
           RowBox[{"Re", "[", 
            RowBox[{
             FractionBox["1", 
              RowBox[{"PCPLPx", "[", "sp", "]"}]], 
             RowBox[{"NIntegrate", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"TpTein", "[", "sp", "]"}], "[", "heat", "]"}], 
                "Ldistx"}], ",", 
               RowBox[{"{", 
                RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"rhonor", ",", 
                 RowBox[{
                  RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                 RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
              "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dTe", "[", "sp", "]"}], "=", 
           SuperscriptBox[
            RowBox[{"Re", "[", 
             RowBox[{
              FractionBox["1", 
               RowBox[{"PCPLPx", "[", "sp", "]"}]], 
              RowBox[{"NIntegrate", "[", 
               RowBox[{
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"TpTein", "[", "sp", "]"}], "[", "heat", "]"}], 
                    "-", 
                    RowBox[{"TeFCPLP", "[", "sp", "]"}]}], ")"}], "2"], 
                 "Ldistx"}], ",", 
                RowBox[{"{", 
                 RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"rhonor", ",", 
                  RowBox[{
                   RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                  RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
               "]"}]}], "]"}], 
            RowBox[{"1", "/", "2"}]]}], ";", "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{"sp", ",", "\"\< \>\"", ",", 
            RowBox[{"TeF", "[", "sp", "]"}], ",", "\"\< \>\"", ",", 
            RowBox[{"TeFCPLP", "[", "sp", "]"}], ",", "\"\< \>\"", ",", 
            RowBox[{"dTe", "[", "sp", "]"}]}], "]"}]}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"sp", ",", "4", ",", "4"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"co", ",", "0", ",", "0"}], "}"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.503149360269*^9, 3.503149416342*^9}, {3.503149451156*^9,
   3.503149453567*^9}, {3.5031496047460003`*^9, 3.5031496515880003`*^9}, {
  3.503149728034*^9, 3.503149765428*^9}, {3.503149802875*^9, 
  3.503149841817*^9}, {3.503149997198*^9, 3.503150002685*^9}, {
  3.503150279458*^9, 3.50315028004*^9}, {3.50947060671*^9, 
  3.5094706372869997`*^9}, {3.509470867301*^9, 3.50947088283*^9}, {
  3.509728740274*^9, 3.509728740863*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"TpTein", "[", "2", "]"}], "[", 
  RowBox[{"Log", "[", "0.359703", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TpTein", "[", "4", "]"}], "[", 
  RowBox[{"Log", "[", "0.345315", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.4874618860150003`*^9, 3.487461921203*^9}}],

Cell[BoxData[{
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      FractionBox["1", 
       RowBox[{
        SqrtBox[
         RowBox[{"2", "\[Pi]", " "}]], "\[Sigma]"}]], 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        FractionBox[
         SuperscriptBox["x", "2"], 
         RowBox[{"2", 
          SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "\[Infinity]"}], ",", 
       RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
     RowBox[{"GenerateConditions", "\[Rule]", "False"}]}], "]"}], ",", 
   RowBox[{"\[Sigma]", ">", "0"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["x", "2"], 
      FractionBox["1", 
       RowBox[{
        SqrtBox[
         RowBox[{"2", "\[Pi]", " "}]], "\[Sigma]"}]], 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        FractionBox[
         SuperscriptBox["x", "2"], 
         RowBox[{"2", 
          SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "\[Infinity]"}], ",", 
       RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
     RowBox[{"GenerateConditions", "\[Rule]", "False"}]}], "]"}], ",", 
   RowBox[{"\[Sigma]", ">", "0"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      FractionBox["1", 
       RowBox[{
        SqrtBox[
         RowBox[{"2", "\[Pi]", " "}]], "\[Sigma]"}]], 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        FractionBox[
         SuperscriptBox["x", "2"], 
         RowBox[{"2", 
          SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "s"}], ",", "s"}], "}"}], ",", 
     RowBox[{"GenerateConditions", "\[Rule]", "False"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[Sigma]", ">", "0"}], ",", 
     RowBox[{"s", ">", "0"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.487456252976*^9, 3.4874563228710003`*^9}, {
  3.487456365296*^9, 3.487456370323*^9}, {3.503154977072*^9, 
  3.503154990749*^9}}],

Cell[BoxData[{
 RowBox[{"ss", "=", 
  RowBox[{"s", "/.", 
   RowBox[{"FindRoot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Erf", "[", 
       FractionBox["s", 
        SqrtBox["2"]], "]"}], "\[Equal]", "0.9"}], ",", 
     RowBox[{"{", 
      RowBox[{"s", ",", "1."}], "}"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"\[InvisibleSpace]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"3.3808", "-", 
     RowBox[{"ss", " ", "0.2768"}]}], ",", 
    RowBox[{"3.3808", "+", 
     RowBox[{"ss", " ", "0.2768"}]}]}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.5031550040690002`*^9, 3.503155145796*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Teprob", "=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      FractionBox["1", 
       RowBox[{
        SqrtBox[
         RowBox[{"2", "\[Pi]", " "}]], 
        RowBox[{"dTe", "[", "sp", "]"}]}]], 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        FractionBox[
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"Te", "-", 
            RowBox[{"TeFCPLP", "[", "sp", "]"}]}], ")"}], "2"], 
         RowBox[{"2", 
          SuperscriptBox[
           RowBox[{"dTe", "[", "sp", "]"}], "2"]}]]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"sp", ",", "4", ",", "4"}], "}"}]}], "]"}]}], ";", 
  RowBox[{"Plot", "[", 
   RowBox[{"Teprob", ",", 
    RowBox[{"{", 
     RowBox[{"Te", ",", 
      RowBox[{"2", " ", 
       SuperscriptBox["10", "10"]}], ",", 
      RowBox[{"4", " ", 
       SuperscriptBox["10", "10"]}]}], "}"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Tetot", "=", 
  RowBox[{"NIntegrate", "[", 
   RowBox[{"Teprob", ",", 
    RowBox[{"{", 
     RowBox[{"Te", ",", "0", ",", 
      SuperscriptBox["10", "11"]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"T00", "=", 
  RowBox[{"T0", "/.", 
   RowBox[{"Quiet", "[", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       FractionBox["Tetot", "2"], "\[Equal]", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"Teprob", ",", 
         RowBox[{"{", 
          RowBox[{"Te", ",", "T0", ",", 
           SuperscriptBox["10", "11"]}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"T0", ",", 
        RowBox[{"3", " ", 
         SuperscriptBox["10", "10"]}]}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Temin", "=", 
   RowBox[{"Tm", "/.", 
    RowBox[{"Quiet", "[", 
     RowBox[{"FindRoot", "[", 
      RowBox[{
       RowBox[{
        FractionBox["Tetot", "20"], "\[Equal]", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{"Teprob", ",", 
          RowBox[{"{", 
           RowBox[{"Te", ",", "0", ",", "Tm"}], "}"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"Tm", ",", 
         RowBox[{"0.9", "T00"}]}], "}"}]}], "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Temax", "=", 
   RowBox[{"Tm", "/.", 
    RowBox[{"Quiet", "[", 
     RowBox[{"FindRoot", "[", 
      RowBox[{
       RowBox[{
        FractionBox["Tetot", "20"], "\[Equal]", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{"Teprob", ",", 
          RowBox[{"{", 
           RowBox[{"Te", ",", "Tm", ",", 
            SuperscriptBox["10", "11"]}], "}"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"Tm", ",", 
         RowBox[{"1.1", "T00"}]}], "}"}]}], "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<90% confidence interval: (\>\"", ",", "Temin", ",", "\"\<,\>\"", ",", 
   "Temax", ",", "\"\<) ;  Te0=\>\"", ",", "T00", ",", " ", "\"\<  dTe=\>\"", 
   ",", 
   RowBox[{"Temax", "-", "T00"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.487456148632*^9, 3.487456249111*^9}, {
  3.4874563351809998`*^9, 3.48745642158*^9}, {3.487456552157*^9, 
  3.487456553824*^9}, {3.4874565963719997`*^9, 3.487456718865*^9}, {
  3.4874568150439997`*^9, 3.4874568733*^9}, {3.487456917116*^9, 
  3.487457006281*^9}, {3.487461806991*^9, 3.487461821001*^9}, {
  3.4874618511809998`*^9, 3.487461865862*^9}, {3.487461948238*^9, 
  3.487462137876*^9}, {3.4874621945769997`*^9, 3.487462200699*^9}, {
  3.487463067376*^9, 3.487463067718*^9}, {3.5031500940299997`*^9, 
  3.503150125388*^9}, {3.503150157667*^9, 3.503150243197*^9}, {
  3.503150370902*^9, 3.503150370998*^9}, {3.503150818182*^9, 
  3.503150820533*^9}, {3.5094707364189997`*^9, 3.509470759505*^9}, {
  3.50947079516*^9, 3.509470811535*^9}, {3.5094709738050003`*^9, 
  3.509470989356*^9}}],

Cell[BoxData[
 RowBox[{"boosted", "\[Rule]", "False"}]], "Input",
 CellChangeTimes->{{3.509471001365*^9, 3.509471004578*^9}}],

Cell[BoxData[
 RowBox[{"boosted", "\[Rule]", "True"}]], "Input",
 CellChangeTimes->{{3.509470854726*^9, 3.509470857859*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Estimating best Mdot - now done by the code", "Subsection",
 CellChangeTimes->{{3.4874421297116003`*^9, 3.4874421443346*^9}, {
  3.487459718863*^9, 3.4874597210039997`*^9}, {3.487463658073*^9, 
  3.4874636624700003`*^9}, {3.5293384216407537`*^9, 3.5293384234328566`*^9}, {
  3.529377635731163*^9, 3.529377636427202*^9}, {3.5402992804843087`*^9, 
  3.5402992854139175`*^9}}],

Cell[CellGroupData[{

Cell["best computations", "Subsubsection",
 CellChangeTimes->{{3.5293660068850307`*^9, 3.529366010421233*^9}, {
  3.5293776304188585`*^9, 3.529377632899001*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tofit", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"8.450", ",", "0.6898", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.2500"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14.90", ",", "0.9044", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.6200"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22.50", ",", "1.070", ",", "0.1900", ",", "131.0", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"43.00", ",", "1.159", ",", "0.5041", ",", "94.25", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"87.73", ",", "1.841", ",", "1.42", ",", 
       RowBox[{"-", "4."}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"102.0", ",", "1.908", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"145.0", ",", "2.275", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"230.9", ",", "2.637", ",", "7.40", ",", "111.5", ",", 
       RowBox[{"-", "1.200"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"349.0", ",", "3.181", ",", "6.50", ",", "146.9", ",", 
       RowBox[{"-", "1.500"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"674.0", ",", "3.286", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"857.0", ",", "2.867", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"dFnu", "=", 
    RowBox[{"{", 
     RowBox[{
     "1.", ",", "1.", ",", "1.", ",", "1.", ",", "0.080", ",", "0.1517", ",", 
      "0.2644", ",", "0.1414", ",", "0.1205", ",", "0.3508", ",", "0.2404"}], 
     "}"}]}], ";", 
   RowBox[{"dCP", "=", "0.30"}], ";", 
   RowBox[{"dLP", "=", 
    RowBox[{"{", 
     RowBox[{"0.5", ",", "0.66", ",", "0.61"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=", "2"}], ";", 
  RowBox[{"fmin", "=", "6950"}], ";", 
  RowBox[{"fmax", "=", "9950"}], ";", 
  RowBox[{"ind", "=", "11"}], ";", 
  RowBox[{"sep", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"ind", "-", "1"}], ")"}]}]}], ";", 
  RowBox[{"thlen", "=", "50"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"nh", ",", "co"}], "]"}], ";", 
  RowBox[{"ext", "=", "1."}], ";", 
  RowBox[{"acc", "=", "16"}], ";", 
  RowBox[{"inord", "=", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], ";", 
  RowBox[{"poi3", "=", "20000"}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], "]"}], ";", 
  RowBox[{"t", "=", 
   RowBox[{"TimeUsed", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"NIntegrate", ",", 
    RowBox[{"Method", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
       RowBox[{"Method", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
          RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
    ",", 
    RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"co", "=", "0"}], ";", 
  RowBox[{"thlen", "=", "50"}], ";", 
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"xptab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
     ",", "\"\<098\>\""}], "}"}]}], ";", 
  RowBox[{"nF", "=", "7"}], ";", 
  RowBox[{"nP", "=", "12"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gaxx", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"th", "=", 
       RowBox[{
        FractionBox["\[Pi]", "thlen"], 
        RowBox[{"(", 
         RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
      RowBox[{"Import", "[", 
       RowBox[{
       "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\poliresa\
\>\"", "<>", 
        RowBox[{"ToString", "[", 
         RowBox[{"Round", "[", 
          RowBox[{"100", 
           RowBox[{"sptab", "[", 
            RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
        "\"\<th\>\"", "<>", 
        RowBox[{"ToString", "[", 
         RowBox[{"Floor", "[", 
          RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<fn\>\"", "<>", 
        RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
       "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}]}], ";", 
  RowBox[{"gat", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"Total", "[", 
       RowBox[{"gaxx", ",", 
        RowBox[{"{", "1", "}"}]}], "]"}], "ind"], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"flen", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Position", "[", 
      RowBox[{
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"1", ";;", "11"}], ",", "2"}], "]"}], "]"}], ",", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}]}], "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{
    RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
    RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gat", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{"gat", ",", "flen"}], "]"}]}], ";", 
  RowBox[{"rholen", "=", 
   RowBox[{"Length", "[", 
    RowBox[{"Position", "[", 
     RowBox[{
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "6"}], "]"}], 
       "]"}], ",", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", "1", ",", "6"}], "]"}], "]"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rholen", "=", 
   RowBox[{"Length", "[", 
    RowBox[{"Position", "[", 
     RowBox[{
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "8"}], "]"}], 
       "]"}], ",", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gat", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", 
  RowBox[{"dim", "=", 
   RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", 
  RowBox[{"hlen", "=", 
   RowBox[{"dim", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"hmin", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], 
     "]"}], "]"}]}], ";", 
  RowBox[{"hmax", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"thmin", "=", 
   RowBox[{
    FractionBox["\[Pi]", "thlen"], 
    RowBox[{"(", 
     RowBox[{"1", "-", ".5"}], ")"}]}]}], ";", 
  RowBox[{"thmax", "=", 
   RowBox[{"\[Pi]", "-", "thmin"}]}], ";", 
  RowBox[{"rhomax", "=", 
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "9"}], "]"}], "]"}], 
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", 
        FractionBox[
         RowBox[{"flen", "+", "1"}], "2"], ",", "1", ",", "1", ",", "9"}], 
       "]"}], "]"}]], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rateint", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], "]"}], 
       "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"raterho", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "9"}], "]"}], 
       "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"flux", "[", "i", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", "i", ",", "All", ",", "3"}], "]"}], 
       "]"}]}], ";", 
     RowBox[{
      RowBox[{
       RowBox[{"iflux", "[", "i", "]"}], "[", "sp", "]"}], "=", 
      RowBox[{"ListInterpolation", "[", 
       RowBox[{
        RowBox[{"flux", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "flen"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LP", "[", "1", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "7"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"LP", "[", "2", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "4"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"LP", "[", "3", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "3"}], ",", "All", ",", "4"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CP", "[", "1", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "4"}], ",", "All", ",", "6"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"CP", "[", "2", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "3"}], ",", "All", ",", "6"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"iCPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"CP", "[", "i", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"iLPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"LP", "[", "i", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnux", "[", "sp", "]"}], "=", 
   RowBox[{"Total", "[", 
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         RowBox[{"tofit", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{
             RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", "2"}], 
           "]"}], "]"}], "-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
             RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "&"}], "/@", 
           RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], 
        RowBox[{"dFnu", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], "]"}]],
        ")"}], "2"], 
     RowBox[{"nF", "-", "3"}]], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "=", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"nP", "-", "3"}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{
                RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
               "2"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], ")"}], "/", 
          RowBox[{"dFnu", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
           "]"}]}], ")"}], "2"], "]"}], "+", 
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", "dCP"], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iCPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"Range", "[", "2", "]"}]}], ")"}]}], ")"}]}], ")"}], 
        "2"], "]"}], "+", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"tofit", "[", 
            RowBox[{"[", 
             RowBox[{"5", ",", "3"}], "]"}], "]"}], "-", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"iLPx", "[", "1", "]"}], "[", "sp", "]"}], "[", 
             RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], ")"}]}],
           ")"}], 
         RowBox[{"dLP", "[", 
          RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iLPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"{", 
               RowBox[{"2", ",", "3"}], "}"}]}], ")"}]}], ")"}], "/", 
          RowBox[{"dLP", "[", 
           RowBox[{"[", 
            RowBox[{"2", ";;", "3"}], "]"}], "]"}]}], ")"}], "2"], "]"}]}], 
     ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fdistx", "=", 
   RowBox[{
    RowBox[{"PDF", "[", 
     RowBox[{
      RowBox[{"ChiSquareDistribution", "[", 
       RowBox[{"nF", "-", "3"}], "]"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"nF", "-", "3"}], ")"}], " ", 
       RowBox[{"lipFnux", "[", "sp", "]"}]}]}], "]"}], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ldistx", "=", 
   RowBox[{
    RowBox[{"PDF", "[", 
     RowBox[{
      RowBox[{"ChiSquareDistribution", "[", 
       RowBox[{"nP", "-", "3"}], "]"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"nP", "-", "3"}], ")"}], " ", 
       RowBox[{"lipFnuCPLPx", "[", "sp", "]"}]}]}], "]"}], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5293660148974895`*^9, 3.529366034248596*^9}, 
   3.52937375749034*^9, {3.5293740483279753`*^9, 3.5293740619677553`*^9}, 
   3.5293740957336864`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ratenum", "=", "100"}], ";", 
  RowBox[{"ratemax", "=", 
   RowBox[{
    RowBox[{"-", "0.1"}], "+", 
    RowBox[{
     RowBox[{"Minimize", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"rateint", "[", 
          RowBox[{"hmin", ",", "\[Theta]"}], "]"}], ",", 
         RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}]}], "}"}], ",", 
       "\[Theta]"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}]}], ";", 
  RowBox[{"ratemin", "=", 
   RowBox[{"0.1", "+", 
    RowBox[{
     RowBox[{"Maximize", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"rateint", "[", 
          RowBox[{"hmax", ",", "\[Theta]"}], "]"}], ",", 
         RowBox[{"thmin", "<", "\[Theta]", "<", "thmax"}]}], "}"}], ",", 
       "\[Theta]"}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}]}], ";", 
  RowBox[{"ratetab", "=", 
   RowBox[{"Range", "[", 
    RowBox[{"ratemin", ",", "ratemax", ",", 
     FractionBox[
      RowBox[{"ratemax", "-", "ratemin"}], "ratenum"]}], "]"}]}], ";", 
  RowBox[{"\[Theta]tab", "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1", ",", "1", ",", "All", ",", 
      RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", 
  RowBox[{"heattab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"heat", "/.", 
        RowBox[{"FindRoot", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"ratetab", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", 
            RowBox[{"rateint", "[", 
             RowBox[{"heat", ",", "\[Theta]"}], "]"}]}], "/.", 
           RowBox[{"\[Theta]", "\[Rule]", "#"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"heat", ",", 
            FractionBox[
             RowBox[{"hmin", "+", "hmax"}], "2"], ",", "hmin", ",", "hmax"}], 
           "}"}]}], "]"}]}], "&"}], "/@", "\[Theta]tab"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"Length", "[", "ratetab", "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"heatint", "=", 
    RowBox[{"ListInterpolation", "[", 
     RowBox[{"heattab", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ratemin", ",", "ratemax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";"}], 
  "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"sub", "=", 
     RowBox[{"{", 
      RowBox[{"rate", "\[Rule]", 
       RowBox[{"Log", "[", 
        RowBox[{"5.", " ", 
         SuperscriptBox["10", 
          RowBox[{"-", "8"}]]}], "]"}]}], "}"}]}], ";", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"heatmin", "=", 
        RowBox[{
         RowBox[{"heatint", "[", 
          RowBox[{
           RowBox[{"rate", "+", "rhomax"}], ",", "\[Theta]"}], "]"}], "/.", 
         "sub"}]}], ",", 
       RowBox[{"heatmax", "=", 
        RowBox[{
         RowBox[{"heatint", "[", 
          RowBox[{
           RowBox[{"rate", "-", "rhomax"}], ",", "\[Theta]"}], "]"}], "/.", 
         "sub"}]}]}], "}"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"rhonor", "\[Rule]", 
       RowBox[{
        RowBox[{"rateint", "[", 
         RowBox[{"heat", ",", "\[Theta]"}], "]"}], "-", "rate"}]}], "/.", 
      "sub"}]}], ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"poi2", "=", "3000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{"NIntegrate", ",", 
     RowBox[{"Method", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
        RowBox[{"Method", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
           RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
     ",", 
     RowBox[{"MaxPoints", "\[Rule]", "poi2"}]}], "]"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Ldistx", "/.", 
       RowBox[{"rhonor", "\[Rule]", 
        RowBox[{
         RowBox[{"rateint", "[", 
          RowBox[{"heat", ",", "\[Theta]"}], "]"}], "-", "rate"}]}]}], "/.", 
      "sub"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"heat", ",", 
       RowBox[{
        RowBox[{"heatint", "[", 
         RowBox[{
          RowBox[{"rate", "+", "rhomax"}], ",", "\[Theta]"}], "]"}], "/.", 
        "sub"}], ",", 
       RowBox[{
        RowBox[{"heatint", "[", 
         RowBox[{
          RowBox[{"rate", "-", "rhomax"}], ",", "\[Theta]"}], "]"}], "/.", 
        "sub"}]}], "}"}]}], "]"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"Dynamic", "[", "i", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mdottab", "[", "sp", "]"}], "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"rate", "=", 
       RowBox[{"ratetab", "[", 
        RowBox[{"[", "i", "]"}], "]"}]}], ",", 
      RowBox[{"Log", "[", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{
         RowBox[{"Ldistx", "/.", 
          RowBox[{"rhonor", "\[Rule]", 
           RowBox[{
            RowBox[{"rateint", "[", 
             RowBox[{"heat", ",", "\[Theta]"}], "]"}], "-", "rate"}]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"heat", ",", 
           RowBox[{"heatint", "[", 
            RowBox[{
             RowBox[{"rate", "+", "rhomax"}], ",", "\[Theta]"}], "]"}], ",", 
           RowBox[{"heatint", "[", 
            RowBox[{
             RowBox[{"rate", "-", "rhomax"}], ",", "\[Theta]"}], "]"}]}], 
          "}"}]}], "]"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{"Length", "[", "ratetab", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ord", "=", "2"}], ";", 
  RowBox[{
   RowBox[{"inFCPLP", "[", "sp", "]"}], "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{
     RowBox[{"Mdottab", "[", "sp", "]"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FCPLPnorm", "[", "sp", "]"}], "=", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"inFCPLP", "[", "sp", "]"}], "[", "rate", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"rate", ",", "ratemin", ",", "ratemax"}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQBWIQnVausWyv9yvHR/xfwPQtzivbQHTBoZg9IFqjRvog
WPzumsMgmoEl8wqI1qk5Dqb/9229AaKvBGXfBdG97iVJ+4A0972uNBDdde7l
exD9lyn8I4hebpL+B0Q7sCn/BdH2aqlM+4H0vp5sMH1ovrExiM5+MsUERE/p
FysC0bdW7CkH0U+U8mpA9B0ro3YQ/V//7gQQvdaIYyKI1jt2ej6IbhR5B6bz
N11eCaLNaq+Cab9ja9aD6B7/dWD63K6tm0G0wIxdYDp8W9xfEM3nIf4fRHcc
UdQ6AKQDLzqDaTH7pEAQzX69BkxHcbHlg+jPV+3BNAC6b7Qn
  "]],

Cell[BoxData[{
 RowBox[{"ToExpression", "[", 
  RowBox[{"ToString", "[", 
   RowBox[{"Floor", "[", 
    RowBox[{
     RowBox[{"Mdottab", "[", "2", "]"}], ",", 
     SuperscriptBox["10", 
      RowBox[{"-", "5."}]]}], "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FCPLPnorm", "[", "2", "]"}]}], "Input",
 CellChangeTimes->{{3.529374671144598*^9, 3.5293746725846806`*^9}, {
  3.5293750710224695`*^9, 3.5293750715895023`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "2"}], ";", 
  RowBox[{"rate", "=."}], ";", 
  RowBox[{
   RowBox[{"Mdottab", "[", "2", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.8659`"}], ",", 
       RowBox[{"-", "156.677`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.8347`"}], ",", 
       RowBox[{"-", "151.125`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.8035`"}], ",", 
       RowBox[{"-", "145.86`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.7722`"}], ",", 
       RowBox[{"-", "123.725`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.741`"}], ",", 
       RowBox[{"-", "101.897`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.7098`"}], ",", 
       RowBox[{"-", "88.3888`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.6786`"}], ",", 
       RowBox[{"-", "79.5601`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.6473`"}], ",", 
       RowBox[{"-", "72.0528`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.6161`"}], ",", 
       RowBox[{"-", "65.8212`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.5849`"}], ",", 
       RowBox[{"-", "61.942`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.5537`"}], ",", 
       RowBox[{"-", "57.0538`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.5225`"}], ",", 
       RowBox[{"-", "49.7864`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.4912`"}], ",", 
       RowBox[{"-", "44.9687`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.46`"}], ",", 
       RowBox[{"-", "40.4496`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.4288`"}], ",", 
       RowBox[{"-", "36.2329`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.3976`"}], ",", 
       RowBox[{"-", "32.361`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.3663`"}], ",", 
       RowBox[{"-", "28.487`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.3351`"}], ",", 
       RowBox[{"-", "25.4009`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.3039`"}], ",", 
       RowBox[{"-", "22.7194`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.2727`"}], ",", 
       RowBox[{"-", "20.4446`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.2414`"}], ",", 
       RowBox[{"-", "18.6166`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.2102`"}], ",", 
       RowBox[{"-", "17.1888`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.179`"}], ",", 
       RowBox[{"-", "16.0678`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.1478`"}], ",", 
       RowBox[{"-", "15.1703`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.1166`"}], ",", 
       RowBox[{"-", "14.4114`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.0853`"}], ",", 
       RowBox[{"-", "13.686`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.0541`"}], ",", 
       RowBox[{"-", "13.1183`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "17.0229`"}], ",", 
       RowBox[{"-", "12.6688`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.9917`"}], ",", 
       RowBox[{"-", "12.3655`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.9604`"}], ",", 
       RowBox[{"-", "12.1961`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.9292`"}], ",", 
       RowBox[{"-", "12.1533`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.898`"}], ",", 
       RowBox[{"-", "12.301`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.8668`"}], ",", 
       RowBox[{"-", "12.6318`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.8356`"}], ",", 
       RowBox[{"-", "13.1027`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.8043`"}], ",", 
       RowBox[{"-", "13.7792`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.7731`"}], ",", 
       RowBox[{"-", "14.6731`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.7419`"}], ",", 
       RowBox[{"-", "15.7065`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.7107`"}], ",", 
       RowBox[{"-", "16.4187`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.6794`"}], ",", 
       RowBox[{"-", "16.8223`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.6482`"}], ",", 
       RowBox[{"-", "17.4491`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.617`"}], ",", 
       RowBox[{"-", "18.5333`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.5858`"}], ",", 
       RowBox[{"-", "19.941`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.5546`"}], ",", 
       RowBox[{"-", "21.4362`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.5233`"}], ",", 
       RowBox[{"-", "22.8709`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.4921`"}], ",", 
       RowBox[{"-", "24.2784`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.4609`"}], ",", 
       RowBox[{"-", "25.2735`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.4297`"}], ",", 
       RowBox[{"-", "26.5971`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.3984`"}], ",", 
       RowBox[{"-", "28.4833`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.3672`"}], ",", 
       RowBox[{"-", "28.7979`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.336`"}], ",", 
       RowBox[{"-", "27.1601`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.3048`"}], ",", 
       RowBox[{"-", "25.6206`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.2736`"}], ",", 
       RowBox[{"-", "24.1681`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.2423`"}], ",", 
       RowBox[{"-", "22.9978`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.2111`"}], ",", 
       RowBox[{"-", "22.3097`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.1799`"}], ",", 
       RowBox[{"-", "22.0684`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.1487`"}], ",", 
       RowBox[{"-", "22.2515`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.1174`"}], ",", 
       RowBox[{"-", "22.8501`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.0862`"}], ",", 
       RowBox[{"-", "23.8559`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.055`"}], ",", 
       RowBox[{"-", "25.3071`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "16.0238`"}], ",", 
       RowBox[{"-", "27.2244`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.9926`"}], ",", 
       RowBox[{"-", "29.6198`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.9613`"}], ",", 
       RowBox[{"-", "32.4787`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.9301`"}], ",", 
       RowBox[{"-", "35.8911`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.8989`"}], ",", 
       RowBox[{"-", "39.4073`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.8677`"}], ",", 
       RowBox[{"-", "43.1891`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.8364`"}], ",", 
       RowBox[{"-", "47.2134`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.8052`"}], ",", 
       RowBox[{"-", "52.0421`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.774`"}], ",", 
       RowBox[{"-", "56.4211`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.7428`"}], ",", 
       RowBox[{"-", "61.4152`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.7116`"}], ",", 
       RowBox[{"-", "65.9394`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.6803`"}], ",", 
       RowBox[{"-", "69.739`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.6491`"}], ",", 
       RowBox[{"-", "72.7956`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.6179`"}], ",", 
       RowBox[{"-", "74.6305`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.5867`"}], ",", 
       RowBox[{"-", "75.9687`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.5554`"}], ",", 
       RowBox[{"-", "77.9036`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.5242`"}], ",", 
       RowBox[{"-", "80.5242`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.493`"}], ",", 
       RowBox[{"-", "83.4901`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.4618`"}], ",", 
       RowBox[{"-", "86.2645`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.4306`"}], ",", 
       RowBox[{"-", "88.132`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.3993`"}], ",", 
       RowBox[{"-", "88.9772`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.3681`"}], ",", 
       RowBox[{"-", "88.7247`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.3369`"}], ",", 
       RowBox[{"-", "88.1189`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.3057`"}], ",", 
       RowBox[{"-", "87.6728`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.2744`"}], ",", 
       RowBox[{"-", "87.3126`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.2432`"}], ",", 
       RowBox[{"-", "86.8806`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.212`"}], ",", 
       RowBox[{"-", "86.4494`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.1808`"}], ",", 
       RowBox[{"-", "86.0477`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.1496`"}], ",", 
       RowBox[{"-", "85.6514`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.1183`"}], ",", 
       RowBox[{"-", "85.3563`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.0871`"}], ",", 
       RowBox[{"-", "85.1894`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.0559`"}], ",", 
       RowBox[{"-", "85.0394`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "15.0247`"}], ",", 
       RowBox[{"-", "84.8591`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "14.9934`"}], ",", 
       RowBox[{"-", "84.633`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "14.9622`"}], ",", 
       RowBox[{"-", "84.7016`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "14.931`"}], ",", 
       RowBox[{"-", "85.1922`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "14.8998`"}], ",", 
       RowBox[{"-", "86.0549`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "14.8686`"}], ",", 
       RowBox[{"-", "87.2126`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "14.8373`"}], ",", 
       RowBox[{"-", "88.197`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "14.8061`"}], ",", 
       RowBox[{"-", "88.9029`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "14.7749`"}], ",", 
       RowBox[{"-", "89.507`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "14.7437`"}], ",", 
       RowBox[{"-", "90.0693`"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FCPLPnorm", "[", "2", "]"}], "=", "1.04520695179839`*^-6"}], ";", 
  RowBox[{"rate", "=."}], ";", 
  RowBox[{
   RowBox[{"inFCPLP", "[", "sp", "]"}], "=", 
   RowBox[{"Interpolation", "[", 
    RowBox[{
     RowBox[{"Mdottab", "[", "sp", "]"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "ord"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"func", "=", 
   FractionBox[
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"inFCPLP", "[", "sp", "]"}], "[", "rate", "]"}], "]"}], 
    RowBox[{"FCPLPnorm", "[", "sp", "]"}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nno", "=", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{"func", ",", 
     RowBox[{"{", 
      RowBox[{"rate", ",", "ratemin", ",", "ratemax"}], "}"}]}], "]"}]}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "nlim"}], "]"}], ";", 
  RowBox[{"Off", "[", 
   StyleBox[
    RowBox[{"NIntegrate", "::", "izero"}], "MessageName"], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mdot0", "=", 
   RowBox[{
    RowBox[{"Exp", "[", "ratex", "]"}], "/.", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       FractionBox["nno", "2"], "==", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"func", ",", 
         RowBox[{"{", 
          RowBox[{"rate", ",", "ratemin", ",", "ratex"}], "}"}]}], "]"}]}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"ratex", ",", 
        RowBox[{"Log", "[", 
         RowBox[{"5", " ", 
          SuperscriptBox["10", 
           RowBox[{"-", "8"}]]}], "]"}]}], "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mdotmin", "=", 
   RowBox[{
    RowBox[{"Exp", "[", "ratex", "]"}], "/.", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"0.05", "nno"}], "==", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"func", ",", 
         RowBox[{"{", 
          RowBox[{"rate", ",", "ratemin", ",", "ratex"}], "}"}]}], "]"}]}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"ratex", ",", 
        RowBox[{"Log", "[", "Mdot0", "]"}]}], "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mdotmax", "=", 
   RowBox[{
    RowBox[{"Exp", "[", "ratex", "]"}], "/.", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"0.05", "nno"}], "==", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"func", ",", 
         RowBox[{"{", 
          RowBox[{"rate", ",", "ratex", ",", "ratemax"}], "}"}]}], "]"}]}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"ratex", ",", 
        RowBox[{"Log", "[", "Mdot0", "]"}]}], "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Central value is = \>\"", ",", "Mdot0", ",", "\"\<Msun/yr\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<90% confidence interval for log(accretion rate): \>\"", ",", 
    RowBox[{"{", 
     RowBox[{"Mdotmin", ",", "Mdotmax"}], "}"}], ",", "\"\< Msun/yr\>\""}], 
   "]"}], ";", 
  RowBox[{"sp", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.5293752419922485`*^9, 3.529375278942362*^9}, 
   3.529375331614375*^9, {3.529375528851656*^9, 3.5293755299397182`*^9}, {
   3.5293756320035563`*^9, 3.5293756375318727`*^9}, {3.52937570689884*^9, 
   3.52937573383438*^9}, {3.529375780969076*^9, 3.5293757843952723`*^9}, {
   3.5293758498760176`*^9, 3.529375870516198*^9}, {3.5293759185479455`*^9, 
   3.529376009960174*^9}, {3.529376058577955*^9, 3.5293760644092884`*^9}, 
   3.5293761139381213`*^9, {3.5293763736059732`*^9, 3.5293763788372726`*^9}, {
   3.5293765940285807`*^9, 3.5293766014120035`*^9}, {3.5293775373955383`*^9, 
   3.5293775541854987`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["new computations", "Subsubsection",
 CellChangeTimes->{{3.5293385928395457`*^9, 3.529338594559644*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tofit", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"8.450", ",", "0.6898", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.2500"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14.90", ",", "0.9044", ",", "0", ",", "0", ",", 
       RowBox[{"-", "0.6200"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"22.50", ",", "1.070", ",", "0.1900", ",", "131.0", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"43.00", ",", "1.159", ",", "0.5041", ",", "94.25", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"87.73", ",", "1.841", ",", "1.42", ",", 
       RowBox[{"-", "4."}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"102.0", ",", "1.908", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"145.0", ",", "2.275", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"230.9", ",", "2.637", ",", "7.40", ",", "111.5", ",", 
       RowBox[{"-", "1.200"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"349.0", ",", "3.181", ",", "6.50", ",", "146.9", ",", 
       RowBox[{"-", "1.500"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"674.0", ",", "3.286", ",", "0", ",", "0", ",", "0"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"857.0", ",", "2.867", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"dFnu", "=", 
    RowBox[{"{", 
     RowBox[{
     "1.", ",", "1.", ",", "1.", ",", "1.", ",", "0.080", ",", "0.1517", ",", 
      "0.2644", ",", "0.1414", ",", "0.1205", ",", "0.3508", ",", "0.2404"}], 
     "}"}]}], ";", 
   RowBox[{"dCP", "=", "0.30"}], ";", 
   RowBox[{"dLP", "=", 
    RowBox[{"{", 
     RowBox[{"0.5", ",", "0.66", ",", "0.61"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=", "2"}], ";", 
  RowBox[{"fmin", "=", "6950"}], ";", 
  RowBox[{"fmax", "=", "9950"}], ";", 
  RowBox[{"ind", "=", "11"}], ";", 
  RowBox[{"sep", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"fmax", "-", "fmin"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"ind", "-", "1"}], ")"}]}]}], ";", 
  RowBox[{"thlen", "=", "50"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"nh", ",", "co"}], "]"}], ";", 
  RowBox[{"ext", "=", "1."}], ";", 
  RowBox[{"acc", "=", "16"}], ";", 
  RowBox[{"inord", "=", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], ";", 
  RowBox[{"poi3", "=", "20000"}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], "]"}], ";", 
  RowBox[{"t", "=", 
   RowBox[{"TimeUsed", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"NIntegrate", ",", 
    RowBox[{"Method", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
       RowBox[{"Method", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
          RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
    ",", 
    RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"co", "=", "0"}], ";", 
  RowBox[{"thlen", "=", "50"}], ";", 
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"xptab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
     ",", "\"\<098\>\""}], "}"}]}], ";", 
  RowBox[{"nF", "=", "7"}], ";", 
  RowBox[{"nP", "=", "12"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gaxx", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"th", "=", 
       RowBox[{
        FractionBox["\[Pi]", "thlen"], 
        RowBox[{"(", 
         RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
      RowBox[{"Import", "[", 
       RowBox[{
       "\"\<C:\\\\study\\\\mathematica\\\\!GRMHD\\\\!2011Oct_full\\\\poliresa\
\>\"", "<>", 
        RowBox[{"ToString", "[", 
         RowBox[{"Round", "[", 
          RowBox[{"100", 
           RowBox[{"sptab", "[", 
            RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
        "\"\<th\>\"", "<>", 
        RowBox[{"ToString", "[", 
         RowBox[{"Floor", "[", 
          RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<fn\>\"", "<>", 
        RowBox[{"ToString", "[", "fnum", "]"}], "<>", "\"\<boo.dat\>\""}], 
       "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"fnum", ",", "fmin", ",", "fmax", ",", "sep"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}]}], ";", 
  RowBox[{"gat", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"Total", "[", 
       RowBox[{"gaxx", ",", 
        RowBox[{"{", "1", "}"}]}], "]"}], "ind"], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"flen", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Position", "[", 
      RowBox[{
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"1", ";;", "11"}], ",", "2"}], "]"}], "]"}], ",", 
       RowBox[{"gat", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}]}], "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{
    RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
    RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gat", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{"gat", ",", "flen"}], "]"}]}], ";", 
  RowBox[{"rholen", "=", 
   RowBox[{"Length", "[", 
    RowBox[{"Position", "[", 
     RowBox[{
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "6"}], "]"}], 
       "]"}], ",", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", "1", ",", "6"}], "]"}], "]"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rholen", "=", 
   RowBox[{"Length", "[", 
    RowBox[{"Position", "[", 
     RowBox[{
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "8"}], "]"}], 
       "]"}], ",", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gat", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", 
  RowBox[{"dim", "=", 
   RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", 
  RowBox[{"hlen", "=", 
   RowBox[{"dim", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"hmin", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], 
     "]"}], "]"}]}], ";", 
  RowBox[{"hmax", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"gat", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"thmin", "=", 
   RowBox[{
    FractionBox["\[Pi]", "thlen"], 
    RowBox[{"(", 
     RowBox[{"1", "-", ".5"}], ")"}]}]}], ";", 
  RowBox[{"thmax", "=", 
   RowBox[{"\[Pi]", "-", "thmin"}]}], ";", 
  RowBox[{"rhomax", "=", 
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "9"}], "]"}], "]"}], 
     RowBox[{"gat", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", 
        FractionBox[
         RowBox[{"flen", "+", "1"}], "2"], ",", "1", ",", "1", ",", "9"}], 
       "]"}], "]"}]], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rateint", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], "]"}], 
       "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"raterho", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "9"}], "]"}], 
       "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"flux", "[", "i", "]"}], "=", 
      RowBox[{"gat", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", "i", ",", "All", ",", "3"}], "]"}], 
       "]"}]}], ";", 
     RowBox[{
      RowBox[{
       RowBox[{"iflux", "[", "i", "]"}], "[", "sp", "]"}], "=", 
      RowBox[{"ListInterpolation", "[", 
       RowBox[{
        RowBox[{"flux", "[", "i", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "flen"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LP", "[", "1", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "7"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"LP", "[", "2", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "4"}], ",", "All", ",", "4"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"LP", "[", "3", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "3"}], ",", "All", ",", "4"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CP", "[", "1", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "4"}], ",", "All", ",", "6"}], "]"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"CP", "[", "2", "]"}], "=", 
   RowBox[{"gat", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"-", "3"}], ",", "All", ",", "6"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"iCPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"CP", "[", "i", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"iLPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
     RowBox[{"ListInterpolation", "[", 
      RowBox[{
       RowBox[{"LP", "[", "i", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnux", "[", "sp", "]"}], "=", 
   RowBox[{"Total", "[", 
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         RowBox[{"tofit", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{
             RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", "2"}], 
           "]"}], "]"}], "-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
             RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], "&"}], "/@", 
           RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], 
        RowBox[{"dFnu", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], "]"}]],
        ")"}], "2"], 
     RowBox[{"nF", "-", "3"}]], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "=", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"nP", "-", "3"}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{
                RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
               "2"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], ")"}], "/", 
          RowBox[{"dFnu", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
           "]"}]}], ")"}], "2"], "]"}], "+", 
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", "dCP"], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iCPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"Range", "[", "2", "]"}]}], ")"}]}], ")"}]}], ")"}], 
        "2"], "]"}], "+", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"tofit", "[", 
            RowBox[{"[", 
             RowBox[{"5", ",", "3"}], "]"}], "]"}], "-", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"iLPx", "[", "1", "]"}], "[", "sp", "]"}], "[", 
             RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], ")"}]}],
           ")"}], 
         RowBox[{"dLP", "[", 
          RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
      RowBox[{"Total", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"tofit", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"iLPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"{", 
               RowBox[{"2", ",", "3"}], "}"}]}], ")"}]}], ")"}], "/", 
          RowBox[{"dLP", "[", 
           RowBox[{"[", 
            RowBox[{"2", ";;", "3"}], "]"}], "]"}]}], ")"}], "2"], "]"}]}], 
     ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fdistx", "=", 
   RowBox[{
    RowBox[{"PDF", "[", 
     RowBox[{
      RowBox[{"ChiSquareDistribution", "[", 
       RowBox[{"nF", "-", "3"}], "]"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"nF", "-", "3"}], ")"}], " ", 
       RowBox[{"lipFnux", "[", "sp", "]"}]}]}], "]"}], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ldistx", "=", 
   RowBox[{
    RowBox[{"PDF", "[", 
     RowBox[{
      RowBox[{"ChiSquareDistribution", "[", 
       RowBox[{"nP", "-", "3"}], "]"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"nP", "-", "3"}], ")"}], " ", 
       RowBox[{"lipFnuCPLPx", "[", "sp", "]"}]}]}], "]"}], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PFnux", "=", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{"Fdistx", ",", 
     RowBox[{"{", 
      RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"rhonor", ",", 
       RowBox[{
        RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
       RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PCPLPx", "=", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{"Ldistx", ",", 
      RowBox[{"{", 
       RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"rhonor", ",", 
        RowBox[{
         RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
        RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
   ";"}], 
  RowBox[{"(*", 
   RowBox[{
   "uncomment", " ", "for", " ", "computation", " ", "of", " ", 
    "probability"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"prob", "[", "sp", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"PFnux", ",", "PCPLPx"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"\"\< sp=\>\"", ",", 
     RowBox[{"sptab", "[", 
      RowBox[{"[", "sp", "]"}], "]"}], ",", 
     "\"\<; Probabilities: P(Fnu)=\>\"", ",", "PFnux", ",", 
     "\"\<; PCPLP=\>\"", ",", "PCPLPx"}], "]"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
   "uncomment", " ", "for", " ", "computation", " ", "of", " ", 
    "probability"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MdotF", "[", "sp", "]"}], "=", 
   RowBox[{"Exp", "[", 
    RowBox[{"Re", "[", 
     RowBox[{
      FractionBox["1", "PFnux"], 
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"rateint", "[", 
            RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], ")"}], 
         "Fdistx"}], ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"rhonor", ",", 
          RowBox[{
           RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
          RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
     "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MdotFCPLP", "[", "sp", "]"}], "=", 
   RowBox[{"Exp", "[", 
    RowBox[{"Re", "[", 
     RowBox[{
      FractionBox["1", "PCPLPx"], 
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"rateint", "[", 
            RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], ")"}], 
         "Ldistx"}], ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"rhonor", ",", 
          RowBox[{
           RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
          RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
     "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dMdot", "[", "sp", "]"}], "=", 
   SuperscriptBox[
    RowBox[{"Re", "[", 
     RowBox[{
      FractionBox["1", "PCPLPx"], 
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"rateint", "[", 
             RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor", "-", 
            RowBox[{"Log", "[", 
             RowBox[{"MdotFCPLP", "[", "sp", "]"}], "]"}]}], ")"}], "2"], 
         "Ldistx"}], ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"rhonor", ",", 
          RowBox[{
           RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
          RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
     "]"}], 
    RowBox[{"1", "/", "2"}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"sp", ",", "\"\< \>\"", ",", 
     RowBox[{"MdotF", "[", "sp", "]"}], ",", "\"\< \>\"", ",", 
     RowBox[{"MdotFCPLP", "[", "sp", "]"}], ",", "\"\< \>\"", ",", 
     RowBox[{
      RowBox[{"dMdot", "[", "sp", "]"}], 
      RowBox[{"MdotFCPLP", "[", "sp", "]"}]}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MdotF", "[", "sp", "]"}], "=", 
   RowBox[{"Re", "[", 
    RowBox[{
     FractionBox["1", "PFnux"], 
     RowBox[{"NIntegrate", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"rateint", "[", 
           RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], "]"}], 
        "Fdistx"}], ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"rhonor", ",", 
         RowBox[{
          RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
         RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MdotFCPLP", "[", "sp", "]"}], "=", 
   RowBox[{"Re", "[", 
    RowBox[{
     FractionBox["1", "PCPLPx"], 
     RowBox[{"NIntegrate", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"rateint", "[", 
            RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], ")"}], 
         "]"}], "Ldistx"}], ",", 
       RowBox[{"{", 
        RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"rhonor", ",", 
         RowBox[{
          RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
         RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dMdot", "[", "sp", "]"}], "=", 
   SuperscriptBox[
    RowBox[{"Re", "[", 
     RowBox[{
      FractionBox["1", "PCPLPx"], 
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Exp", "[", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"rateint", "[", 
                RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], 
              ")"}], "]"}], "-", 
            RowBox[{"MdotFCPLP", "[", "sp", "]"}]}], ")"}], "2"], "Ldistx"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"rhonor", ",", 
          RowBox[{
           RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
          RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}], 
     "]"}], 
    RowBox[{"1", "/", "2"}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"sp", ",", "\"\< \>\"", ",", 
    RowBox[{"MdotF", "[", "sp", "]"}], ",", "\"\< \>\"", ",", 
    RowBox[{"MdotFCPLP", "[", "sp", "]"}], ",", "\"\< \>\"", ",", 
    RowBox[{
     RowBox[{"dMdot", "[", "sp", "]"}], 
     RowBox[{"MdotFCPLP", "[", "sp", "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.529336226995227*^9, 3.5293363355874386`*^9}, {
  3.5293363964429193`*^9, 3.529336402946291*^9}, {3.529336655304725*^9, 
  3.529336657288839*^9}, {3.5293367590176573`*^9, 3.529336782426996*^9}, {
  3.529337518708109*^9, 3.5293375270955887`*^9}, {3.5293376609562454`*^9, 
  3.529337670494791*^9}, {3.5293379149447727`*^9, 3.5293379158408237`*^9}, {
  3.5293379489187155`*^9, 3.529337949274736*^9}, {3.5293380565668726`*^9, 
  3.5293380799662113`*^9}, {3.5293385557084217`*^9, 3.52933856878517*^9}, {
  3.5293387620982265`*^9, 3.529338766363471*^9}, {3.529338800004395*^9, 
  3.5293388269209347`*^9}, {3.52936366651917*^9, 3.5293636668311872`*^9}, {
  3.5293641164199023`*^9, 3.529364116936932*^9}, {3.52936438825045*^9, 
  3.529364437711279*^9}, {3.5293644828198595`*^9, 3.529364551524789*^9}, {
  3.5293647928215904`*^9, 3.5293647940686617`*^9}, {3.5293658964947166`*^9, 
  3.5293659000559206`*^9}}],

Cell[BoxData[{
 RowBox[{"lipFnuCPLPx", "[", "2", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Exp", "[", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"rateint", "[", 
      RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}], ")"}], "]"}],
   "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"\[Theta]", "\[Rule]"}], ",", 
    RowBox[{"rhonor", "\[Rule]", "0."}], ","}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.5293647199984255`*^9, 3.529364720230438*^9}, {
  3.5293649727328806`*^9, 3.529364982477438*^9}}],

Cell[BoxData[
 RowBox[{"LogPlot", "[", 
  RowBox[{
   RowBox[{"Exp", "[", 
    RowBox[{"rateint", "[", 
     RowBox[{
      RowBox[{"Log", "[", "heat", "]"}], ",", "2.04"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"heat", ",", "0.2", ",", "0.7"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5293645745761075`*^9, 3.529364619575681*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Mdotprob", "=", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       FractionBox["1", 
        RowBox[{
         SqrtBox[
          RowBox[{"2", "\[Pi]"}]], 
         RowBox[{"dMdot", "[", "sp", "]"}]}]], 
       RowBox[{"Exp", "[", 
        RowBox[{"-", 
         FractionBox[
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"logMdot", "-", 
             RowBox[{"Log", "[", 
              RowBox[{"MdotFCPLP", "[", "sp", "]"}], "]"}]}], ")"}], "2"], 
          RowBox[{"2", 
           SuperscriptBox[
            RowBox[{"dMdot", "[", "sp", "]"}], "2"]}]]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"sp", ",", "2", ",", "2"}], "}"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Plot", "[", 
     RowBox[{"Mdotprob", ",", 
      RowBox[{"{", 
       RowBox[{"logMdot", ",", 
        RowBox[{"Log", "[", 
         RowBox[{"5", " ", 
          SuperscriptBox["10", 
           RowBox[{"-", "9"}]]}], "]"}], ",", 
        RowBox[{"Log", "[", 
         RowBox[{"2", " ", 
          SuperscriptBox["10", 
           RowBox[{"-", "8"}]]}], "]"}]}], "}"}]}], "]"}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"Mdottot", "=", 
  RowBox[{"NIntegrate", "[", 
   RowBox[{"Mdotprob", ",", 
    RowBox[{"{", 
     RowBox[{"logMdot", ",", 
      RowBox[{"Log", "[", 
       SuperscriptBox["10", 
        RowBox[{"-", "9"}]], "]"}], ",", 
      RowBox[{"Log", "[", 
       RowBox[{"6", " ", 
        SuperscriptBox["10", 
         RowBox[{"-", "7"}]]}], "]"}]}], "}"}], ",", 
    RowBox[{"MaxRecursion", "\[Rule]", "20"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Mdot00", "=", 
  RowBox[{
   RowBox[{"Exp", "[", "Mdot0", "]"}], "/.", 
   RowBox[{"Quiet", "[", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       FractionBox["Mdottot", "2"], "\[Equal]", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"Mdotprob", ",", 
         RowBox[{"{", 
          RowBox[{"logMdot", ",", "Mdot0", ",", 
           RowBox[{"Log", "[", 
            RowBox[{"3", " ", 
             SuperscriptBox["10", 
              RowBox[{"-", "7"}]]}], "]"}]}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"Mdot0", ",", 
        RowBox[{"Log", "[", 
         RowBox[{"4", " ", 
          SuperscriptBox["10", 
           RowBox[{"-", "8"}]]}], "]"}]}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Mdotmin", "=", 
  RowBox[{
   RowBox[{"Exp", "[", "Mdot", "]"}], "/.", 
   RowBox[{"Quiet", "[", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       FractionBox["Mdottot", "20"], "\[Equal]", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"Mdotprob", ",", 
         RowBox[{"{", 
          RowBox[{"logMdot", ",", 
           RowBox[{"Log", "[", 
            SuperscriptBox["10", 
             RowBox[{"-", "9"}]], "]"}], ",", "Mdot"}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"Mdot", ",", 
        RowBox[{
         RowBox[{"Log", "[", "Mdot00", "]"}], "-", "0.1"}]}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Mdotmax", "=", 
  RowBox[{
   RowBox[{"Exp", "[", "Mdot", "]"}], "/.", 
   RowBox[{"Quiet", "[", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       FractionBox["Mdottot", "20"], "\[Equal]", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"Mdotprob", ",", 
         RowBox[{"{", 
          RowBox[{"logMdot", ",", "Mdot", ",", 
           RowBox[{"Log", "[", 
            RowBox[{"6", " ", 
             SuperscriptBox["10", 
              RowBox[{"-", "7"}]]}], "]"}]}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"Mdot", ",", 
        RowBox[{
         RowBox[{"Log", "[", "Mdot00", "]"}], "+", "0.1"}]}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<90% confidence interval: (\>\"", ",", "Mdotmin", ",", "\"\<,\>\"", ",",
    "Mdotmax", ",", "\"\<) ;  Mdot0=\>\"", ",", "Mdot00", ",", " ", 
   "\"\<   dMdot=\>\"", ",", 
   RowBox[{"Mdotmax", "-", "Mdot00"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.487456148632*^9, 3.487456249111*^9}, {
   3.4874563351809998`*^9, 3.48745642158*^9}, {3.487456552157*^9, 
   3.487456553824*^9}, {3.4874565963719997`*^9, 3.487456718865*^9}, {
   3.4874568150439997`*^9, 3.4874568733*^9}, {3.487456917116*^9, 
   3.487457006281*^9}, {3.487461806991*^9, 3.487461821001*^9}, {
   3.4874618511809998`*^9, 3.487461865862*^9}, {3.487461948238*^9, 
   3.487462137876*^9}, {3.4874621945769997`*^9, 3.487462200699*^9}, {
   3.487463067376*^9, 3.487463067718*^9}, {3.487464676791*^9, 
   3.4874648036610003`*^9}, {3.4874648593719997`*^9, 
   3.4874648900299997`*^9}, {3.487464968685*^9, 3.487465030953*^9}, {
   3.487465066159*^9, 3.487465083035*^9}, {3.487465177171*^9, 
   3.487465469219*^9}, 3.487465796023*^9, {3.5031513166610003`*^9, 
   3.5031513696949997`*^9}, {3.503151401775*^9, 3.503151406741*^9}, {
   3.503151474586*^9, 3.503151476465*^9}, {3.503151598773*^9, 
   3.503151600209*^9}, {3.503151635072*^9, 3.503151659295*^9}, {
   3.50315176477*^9, 3.503151766584*^9}, {3.509471172516*^9, 
   3.5094711850030003`*^9}, {3.509471313177*^9, 3.509471313915*^9}, {
   3.5293635017197437`*^9, 3.52936350235878*^9}, {3.5293635573349247`*^9, 
   3.5293635622152033`*^9}, {3.5293636069667635`*^9, 3.529363607174775*^9}, {
   3.5293638369249163`*^9, 3.5293638370529237`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"90", "%"}], " ", "-", " ", "poi"}], "=", "20000"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.52936412826958*^9, 3.52936413089073*^9}, {
  3.5293643134901743`*^9, 3.529364317409398*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["old computations", "Subsubsection",
 CellChangeTimes->{{3.529338589104332*^9, 3.529338590759427*^9}}],

Cell[BoxData[{
 RowBox[{"Exp", "[", 
  RowBox[{
   RowBox[{"rateint", "[", "1", "]"}], "[", 
   RowBox[{
    RowBox[{"Log", "[", "0.3", "]"}], ",", "2.15"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Exp", "[", 
  RowBox[{
   RowBox[{"raterho", "[", "1", "]"}], "[", 
   RowBox[{
    RowBox[{"Log", "[", "0.3", "]"}], ",", "2.15"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.487464121293*^9, 3.487464133049*^9}, {3.487464171227*^9,
   3.4874641915030003`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"tofit", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"8.450", ",", "0.6898", ",", "0", ",", "0", ",", 
        RowBox[{"-", "0.2500"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"14.90", ",", "0.9044", ",", "0", ",", "0", ",", 
        RowBox[{"-", "0.6200"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"22.50", ",", "1.070", ",", "0.1900", ",", "131.0", ",", "0"}],
        "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"43.00", ",", "1.159", ",", "0.5041", ",", "94.25", ",", "0"}],
        "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"87.73", ",", "1.841", ",", "1.026", ",", 
        RowBox[{"-", "4."}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"102.0", ",", "1.908", ",", "0", ",", "0", ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"145.0", ",", "2.275", ",", "0", ",", "0", ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"230.9", ",", "2.637", ",", "7.015", ",", "111.5", ",", 
        RowBox[{"-", "1.200"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"349.0", ",", "3.181", ",", "6.143", ",", "146.9", ",", 
        RowBox[{"-", "1.500"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"674.0", ",", "3.286", ",", "0", ",", "0", ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"857.0", ",", "2.867", ",", "0", ",", "0", ",", "0"}], "}"}]}],
      "}"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"8.45", " ", "-", " ", 
    RowBox[{"43", "GHz"}], " ", "-", " ", 
    RowBox[{"still", " ", "old", " ", "data"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{"dFnu", "=", 
    RowBox[{"{", 
     RowBox[{
     "1.", ",", "1.", ",", "1.", ",", "1.", ",", "0.080", ",", "0.1517", ",", 
      "0.2644", ",", "0.1414", ",", "0.1205", ",", "0.3508", ",", "0.2404"}], 
     "}"}]}], ";", 
   RowBox[{"dCP", "=", "0.30"}], ";", 
   RowBox[{"dlogLP", "=", 
    RowBox[{"{", 
     RowBox[{"0.19", ",", "0.086", ",", "0.115"}], "}"}]}], ";", 
   RowBox[{"t", "=", 
    RowBox[{"TimeUsed", "[", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"nh", ",", "co"}], "]"}], ";", 
  RowBox[{"ext", "=", "1."}], ";", 
  RowBox[{"acc", "=", "16"}], ";", 
  RowBox[{"inord", "=", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], ";", 
  RowBox[{"poi3", "=", "20000"}], ";", 
  RowBox[{"Off", "[", 
   RowBox[{
    RowBox[{"NIntegrate", "::", "\"\<maxp\>\""}], ",", 
    RowBox[{"InterpolatingFunction", "::", "\"\<dmval\>\""}], ",", 
    RowBox[{"NIntegrate", "::", "\"\<slwcon\>\""}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"NIntegrate", ",", 
      RowBox[{"Method", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
         RowBox[{"Method", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
            RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
      ",", 
      RowBox[{"MaxPoints", "\[Rule]", "poi3"}], ",", 
      RowBox[{"AccuracyGoal", "\[Rule]", "acc"}]}], "]"}], ";"}], "*)"}], 
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{"NIntegrate", ",", 
     RowBox[{"Method", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<GlobalAdaptive\>\"", ",", 
        RowBox[{"Method", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<NewtonCotesRule\>\"", ",", 
           RowBox[{"\"\<Points\>\"", "\[Rule]", "3"}]}], "}"}]}]}], "}"}]}], 
     ",", 
     RowBox[{"MaxPoints", "\[Rule]", "poi3"}]}], "]"}], 
   ";"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"co", "=", "0"}], ";", 
  RowBox[{"thlen", "=", "50"}], ";", 
  RowBox[{"sptab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"xptab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
     ",", "\"\<098\>\""}], "}"}]}], ";", 
  RowBox[{"narr", "=", "1.1"}], ";", 
  RowBox[{"nF", "=", "7"}], ";", 
  RowBox[{"nP", "=", "12"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"boosted", "=", "False"}], ";", 
  RowBox[{"avg", "=", "True"}], ";", 
  RowBox[{"test", "=", "\"\<Normal_narrow\>\""}], ";", 
  RowBox[{"test", "=", "\"\<Normal\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"bline", "=", 
        RowBox[{"If", "[", 
         RowBox[{"boosted", ",", "\"\<boo\>\"", ",", "\"\<nob\>\""}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"gat", "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"fnum", "=", 
              RowBox[{
               RowBox[{"-", "1"}], "-", "co"}]}], ";", 
             RowBox[{"th", "=", 
              RowBox[{
               FractionBox["\[Pi]", "thlen"], 
               RowBox[{"(", 
                RowBox[{"thn", "-", ".5"}], ")"}]}]}], ";", 
             RowBox[{"Import", "[", 
              RowBox[{"\"\<E:\\\\mathematica\\\\analysis\\\\poliresa\>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Round", "[", 
                 RowBox[{"100", 
                  RowBox[{"sptab", "[", 
                   RowBox[{"[", "sp", "]"}], "]"}]}], "]"}], "]"}], "<>", 
               "\"\<th\>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Floor", "[", 
                 RowBox[{"100", "th"}], "]"}], "]"}], "<>", "\"\<fn\>\"", "<>", 
               RowBox[{"ToString", "[", "fnum", "]"}], "<>", "bline", "<>", 
               "\"\<.dat\>\""}], "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"thn", ",", "thlen"}], "}"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", "\n", 
       RowBox[{"flen", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"gat", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", ";;", "11"}], ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"gat", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}]}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "1"}], "]"}], "]"}], "-", "1"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"gat", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{"gat", ",", "flen"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"rholen", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"Position", "[", 
          RowBox[{
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"1", ";;", "30"}], ",", "1", ",", "1", ",", "8"}], 
             "]"}], "]"}], ",", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "1", ",", "1", ",", "8"}], "]"}], "]"}]}], 
          "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"gat", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{"gat", ",", "rholen"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"dim", "=", 
        RowBox[{"Dimensions", "[", "gat", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"hlen", "=", 
        RowBox[{"dim", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", "\n", 
       RowBox[{"hmin", "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1", ",", "8"}], 
           "]"}], "]"}], "]"}]}], ";", 
       RowBox[{"hmax", "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "8"}], "]"}], 
          "]"}], "]"}]}], ";", 
       RowBox[{"hmin", "=", 
        RowBox[{"Log", "[", "0.40", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"thmin", "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", 
           RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", 
       RowBox[{"thmax", "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1", ",", "1", ",", 
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", 
       RowBox[{"rhomax", "=", 
        RowBox[{"Log", "[", 
         FractionBox[
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "9"}], "]"}], "]"}], 
          RowBox[{"gat", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"flen", "+", "1"}], ")"}], "/", "2"}], ",", "1", ",", 
             "1", ",", "9"}], "]"}], "]"}]], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"rateint", "[", "sp", "]"}], "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "12"}], 
             "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"raterho", "[", "sp", "]"}], "=", 
        RowBox[{"ListInterpolation", "[", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "4", ",", "1", ",", "All", ",", "9"}], "]"}],
             "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"flux", "[", "i", "]"}], "=", 
           RowBox[{"gat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "All", ",", "i", ",", "All", ",", "3"}], 
             "]"}], "]"}]}], ";", 
          RowBox[{
           RowBox[{
            RowBox[{"iflux", "[", "i", "]"}], "[", "sp", "]"}], "=", 
           RowBox[{"ListInterpolation", "[", 
            RowBox[{
             RowBox[{"flux", "[", "i", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
             RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "flen"}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"LP", "[", "1", "]"}], "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", 
            RowBox[{"-", "7"}], ",", "All", ",", "4"}], "]"}], "]"}], "]"}]}],
        ";", 
       RowBox[{
        RowBox[{"LP", "[", "2", "]"}], "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", 
            RowBox[{"-", "4"}], ",", "All", ",", "4"}], "]"}], "]"}], "]"}]}],
        ";", 
       RowBox[{
        RowBox[{"LP", "[", "3", "]"}], "=", 
        RowBox[{"Log", "[", 
         RowBox[{"gat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", 
            RowBox[{"-", "3"}], ",", "All", ",", "4"}], "]"}], "]"}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"CP", "[", "1", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "4"}], ",", "All", ",", "6"}], "]"}], "]"}]}], ";", 
       RowBox[{
        RowBox[{"CP", "[", "2", "]"}], "=", 
        RowBox[{"gat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", 
           RowBox[{"-", "3"}], ",", "All", ",", "6"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"iCPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
          RowBox[{"ListInterpolation", "[", 
           RowBox[{
            RowBox[{"CP", "[", "i", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
            RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"iLPx", "[", "i", "]"}], "[", "sp", "]"}], "=", 
          RowBox[{"ListInterpolation", "[", 
           RowBox[{
            RowBox[{"LP", "[", "i", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"hmax", ",", "hmin"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "rhomax"}], ",", "rhomax"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"thmin", ",", "thmax"}], "}"}]}], "}"}], ",", 
            RowBox[{"InterpolationOrder", "\[Rule]", "inord"}]}], "]"}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"lipFnux", "[", "sp", "]"}], "=", 
        RowBox[{"Total", "[", 
         FractionBox[
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox[
             RowBox[{
              RowBox[{"tofit", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                 "2"}], "]"}], "]"}], "-", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                  RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                 "&"}], "/@", 
                RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], 
             RowBox[{"dFnu", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
              "]"}]], ")"}], "2"], "flen"], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "=", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"flen", "+", "5"}]], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Total", "[", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"tofit", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], ",", 
                    "2"}], "]"}], "]"}], "-", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"iflux", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                    "&"}], "/@", 
                   RowBox[{"Range", "[", "7", "]"}]}], ")"}]}], ")"}], "/", 
               RowBox[{"dFnu", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"11", "-", "flen", "+", "1"}], ";;", "11"}], "]"}], 
                "]"}]}], ")"}], "2"], "]"}], "+", 
           RowBox[{"Total", "[", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox[
               RowBox[{
                RowBox[{"tofit", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"8", ";;", "9"}], ",", "5"}], "]"}], "]"}], "-", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"iCPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                   "&"}], "/@", 
                  RowBox[{"Range", "[", "2", "]"}]}], ")"}]}], "dCP"], ")"}], 
             "2"], "]"}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{"tofit", "[", 
                 RowBox[{"[", 
                  RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}], "-", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"iLPx", "[", "1", "]"}], "[", "sp", "]"}], "[", 
                 RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                ")"}]}], 
              RowBox[{"dlogLP", "[", 
               RowBox[{"[", "1", "]"}], "]"}]], ")"}], "2"], "+", 
           RowBox[{"Total", "[", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox[
               RowBox[{
                RowBox[{"Log", "[", 
                 RowBox[{"tofit", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"8", ";;", "9"}], ",", "3"}], "]"}], "]"}], "]"}],
                 "-", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"iLPx", "[", "#", "]"}], "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "rhonor", ",", "\[Theta]"}], "]"}], 
                   "&"}], "/@", 
                  RowBox[{"{", 
                   RowBox[{"2", ",", "3"}], "}"}]}], ")"}]}], 
               RowBox[{"dlogLP", "[", 
                RowBox[{"[", 
                 RowBox[{"2", ";;", "3"}], "]"}], "]"}]], ")"}], "2"], 
            "]"}]}], ")"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Fdistx", "=", 
        RowBox[{"nF", " ", 
         RowBox[{"PDF", "[", 
          RowBox[{
           RowBox[{"ChiSquareDistribution", "[", "nF", "]"}], ",", 
           RowBox[{"nF", " ", 
            RowBox[{"lipFnux", "[", "sp", "]"}]}]}], "]"}], 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Ldistx", "=", 
        RowBox[{"nF", " ", 
         RowBox[{"PDF", "[", 
          RowBox[{
           RowBox[{"ChiSquareDistribution", "[", "nF", "]"}], ",", 
           RowBox[{"nF", " ", 
            RowBox[{"lipFnuCPLPx", "[", "sp", "]"}]}]}], "]"}], 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"PFnux", "[", "sp", "]"}], "=", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{"Fdistx", ",", 
          RowBox[{"{", 
           RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"rhonor", ",", 
            RowBox[{
             RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
            RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"PCPLPx", "[", "sp", "]"}], "=", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{"Ldistx", ",", 
          RowBox[{"{", 
           RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"rhonor", ",", 
            RowBox[{
             RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
            RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prob", "[", 
         RowBox[{"sp", ",", "co"}], "]"}], "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"PFnux", "[", "sp", "]"}], ",", 
          RowBox[{"PCPLPx", "[", "sp", "]"}]}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{"PCPLPz", "=", 
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Exp", "[", 
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"lipFnuCPLPx", "[", "sp", "]"}], "2"], "2"]}], 
               "]"}], 
              RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"rhonor", ",", 
               RowBox[{
                RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
               RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
            "]"}]}], "]"}], ";"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<co=\>\"", ",", "co", ",", "\"\< sp=\>\"", ",", 
         RowBox[{"sptab", "[", 
          RowBox[{"[", "sp", "]"}], "]"}], ",", 
         "\"\<; Probabilities: P(Fnu)=\>\"", ",", 
         RowBox[{"PFnux", "[", "sp", "]"}], ",", "\"\<; PCPLP=\>\"", ",", 
         RowBox[{"PCPLPx", "[", "sp", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"avg", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"MdotF", "[", "sp", "]"}], "=", 
           RowBox[{"Exp", "[", 
            RowBox[{"Re", "[", 
             RowBox[{
              FractionBox["1", 
               RowBox[{"PFnux", "[", "sp", "]"}]], 
              RowBox[{"NIntegrate", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"rateint", "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}],
                   ")"}], "Fdistx"}], ",", 
                RowBox[{"{", 
                 RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"rhonor", ",", 
                  RowBox[{
                   RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                  RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
               "]"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"MdotFCPLP", "[", "sp", "]"}], "=", 
           RowBox[{"Exp", "[", 
            RowBox[{"Re", "[", 
             RowBox[{
              FractionBox["1", 
               RowBox[{"PCPLPx", "[", "sp", "]"}]], 
              RowBox[{"NIntegrate", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"rateint", "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor"}],
                   ")"}], "Ldistx"}], ",", 
                RowBox[{"{", 
                 RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"rhonor", ",", 
                  RowBox[{
                   RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                  RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
               "]"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dMdot", "[", "sp", "]"}], "=", 
           SuperscriptBox[
            RowBox[{"Re", "[", 
             RowBox[{
              FractionBox["1", 
               RowBox[{"PCPLPx", "[", "sp", "]"}]], 
              RowBox[{"NIntegrate", "[", 
               RowBox[{
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rateint", "[", "sp", "]"}], "[", 
                    RowBox[{"heat", ",", "\[Theta]"}], "]"}], "+", "rhonor", 
                    "-", 
                    RowBox[{"Log", "[", 
                    RowBox[{"MdotFCPLP", "[", "sp", "]"}], "]"}]}], ")"}], 
                  "2"], "Ldistx"}], ",", 
                RowBox[{"{", 
                 RowBox[{"heat", ",", "hmin", ",", "hmax"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"rhonor", ",", 
                  RowBox[{
                   RowBox[{"-", "ext"}], " ", "rhomax"}], ",", 
                  RowBox[{"ext", " ", "rhomax"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]", ",", "thmin", ",", "thmax"}], "}"}]}], 
               "]"}]}], "]"}], 
            RowBox[{"1", "/", "2"}]]}], ";", "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{"sp", ",", "\"\< \>\"", ",", 
            RowBox[{"MdotF", "[", "sp", "]"}], ",", "\"\< \>\"", ",", 
            RowBox[{"MdotFCPLP", "[", "sp", "]"}], ",", "\"\< \>\"", ",", 
            RowBox[{
             RowBox[{"dMdot", "[", "sp", "]"}], 
             RowBox[{"MdotFCPLP", "[", "sp", "]"}]}]}], "]"}]}]}], "]"}]}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"sp", ",", "4", ",", "4"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"co", ",", "0", ",", "0"}], "}"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQAWIQvWw2h9ouyVeOqz5y6YLoL39TDEH0XZVNYNrm/nQX
EP3sQpEXiG4XYwwB0bqb1kaAaAaGmFiIeqskEM0StqwURLe+Di0D0R+Wv5sB
ote5M84E0UsKbj4C0fPeGz8B0U4Joi9A9KS3Kh9A9JYTdX9BtF/SHTD9ZCm7
4W4gLdcqDqbzhPa7gegFUufB9LLZH76eUAWZq/sNRAf0Sv8G0Y1TZ4PpVR9/
KZwE0iuOcSuC6LNnOCxBtLqhDJg+UbYvCESHPD4Ipu/7C6aCaJF14mD63xWO
QhA94ZAtmNaMcS6HmJMDpgEYoqI0
  "]],

Cell[BoxData["0.35"], "Input",
 CellChangeTimes->{{3.5094720512349997`*^9, 3.509472051606*^9}}],

Cell[BoxData["0.3"], "Input",
 CellChangeTimes->{{3.509471889558*^9, 3.509471889847*^9}}],

Cell[BoxData[{
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      FractionBox["1", 
       RowBox[{
        SqrtBox[
         RowBox[{"2", "\[Pi]", " "}]], "\[Sigma]"}]], 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        FractionBox[
         SuperscriptBox["x", "2"], 
         RowBox[{"2", 
          SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "\[Infinity]"}], ",", 
       RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
     RowBox[{"GenerateConditions", "\[Rule]", "False"}]}], "]"}], ",", 
   RowBox[{"\[Sigma]", ">", "0"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["x", "2"], 
      FractionBox["1", 
       RowBox[{
        SqrtBox[
         RowBox[{"2", "\[Pi]", " "}]], "\[Sigma]"}]], 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        FractionBox[
         SuperscriptBox["x", "2"], 
         RowBox[{"2", 
          SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "\[Infinity]"}], ",", 
       RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
     RowBox[{"GenerateConditions", "\[Rule]", "False"}]}], "]"}], ",", 
   RowBox[{"\[Sigma]", ">", "0"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.487456252976*^9, 3.4874563228710003`*^9}, {
  3.487456365296*^9, 3.487456370323*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Mdotprob", "=", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       FractionBox["1", 
        RowBox[{
         SqrtBox[
          RowBox[{"2", "\[Pi]"}]], 
         RowBox[{"dMdot", "[", "sp", "]"}]}]], 
       RowBox[{"Exp", "[", 
        RowBox[{"-", 
         FractionBox[
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"logMdot", "-", 
             RowBox[{"Log", "[", 
              RowBox[{"MdotFCPLP", "[", "sp", "]"}], "]"}]}], ")"}], "2"], 
          RowBox[{"2", 
           SuperscriptBox[
            RowBox[{"dMdot", "[", "sp", "]"}], "2"]}]]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"sp", ",", "4", ",", "4"}], "}"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Plot", "[", 
     RowBox[{"Mdotprob", ",", 
      RowBox[{"{", 
       RowBox[{"logMdot", ",", 
        RowBox[{"Log", "[", 
         RowBox[{"5", " ", 
          SuperscriptBox["10", 
           RowBox[{"-", "9"}]]}], "]"}], ",", 
        RowBox[{"Log", "[", 
         RowBox[{"2", " ", 
          SuperscriptBox["10", 
           RowBox[{"-", "8"}]]}], "]"}]}], "}"}]}], "]"}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"Mdottot", "=", 
  RowBox[{"NIntegrate", "[", 
   RowBox[{"Mdotprob", ",", 
    RowBox[{"{", 
     RowBox[{"logMdot", ",", 
      RowBox[{"Log", "[", 
       SuperscriptBox["10", 
        RowBox[{"-", "9"}]], "]"}], ",", 
      RowBox[{"Log", "[", 
       RowBox[{"6", " ", 
        SuperscriptBox["10", 
         RowBox[{"-", "7"}]]}], "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Mdot00", "=", 
  RowBox[{
   RowBox[{"Exp", "[", "Mdot0", "]"}], "/.", 
   RowBox[{"Quiet", "[", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       FractionBox["Mdottot", "2"], "\[Equal]", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"Mdotprob", ",", 
         RowBox[{"{", 
          RowBox[{"logMdot", ",", "Mdot0", ",", 
           RowBox[{"Log", "[", 
            RowBox[{"6", " ", 
             SuperscriptBox["10", 
              RowBox[{"-", "7"}]]}], "]"}]}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"Mdot0", ",", 
        RowBox[{"Log", "[", 
         RowBox[{"5", " ", 
          SuperscriptBox["10", 
           RowBox[{"-", "8"}]]}], "]"}]}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Mdotmin", "=", 
  RowBox[{
   RowBox[{"Exp", "[", "Mdot", "]"}], "/.", 
   RowBox[{"Quiet", "[", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       FractionBox["Mdottot", "20"], "\[Equal]", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"Mdotprob", ",", 
         RowBox[{"{", 
          RowBox[{"logMdot", ",", 
           RowBox[{"Log", "[", 
            SuperscriptBox["10", 
             RowBox[{"-", "9"}]], "]"}], ",", "Mdot"}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"Mdot", ",", 
        RowBox[{
         RowBox[{"Log", "[", "Mdot00", "]"}], "-", "0.1"}]}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Mdotmax", "=", 
  RowBox[{
   RowBox[{"Exp", "[", "Mdot", "]"}], "/.", 
   RowBox[{"Quiet", "[", 
    RowBox[{"FindRoot", "[", 
     RowBox[{
      RowBox[{
       FractionBox["Mdottot", "20"], "\[Equal]", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{"Mdotprob", ",", 
         RowBox[{"{", 
          RowBox[{"logMdot", ",", "Mdot", ",", 
           RowBox[{"Log", "[", 
            RowBox[{"6", " ", 
             SuperscriptBox["10", 
              RowBox[{"-", "7"}]]}], "]"}]}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"Mdot", ",", 
        RowBox[{
         RowBox[{"Log", "[", "Mdot00", "]"}], "+", "0.1"}]}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<90% confidence interval: (\>\"", ",", "Mdotmin", ",", "\"\<,\>\"", ",",
    "Mdotmax", ",", "\"\<) ;  Mdot0=\>\"", ",", "Mdot00", ",", " ", 
   "\"\<   dMdot=\>\"", ",", 
   RowBox[{"Mdotmax", "-", "Mdot00"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.487456148632*^9, 3.487456249111*^9}, {
   3.4874563351809998`*^9, 3.48745642158*^9}, {3.487456552157*^9, 
   3.487456553824*^9}, {3.4874565963719997`*^9, 3.487456718865*^9}, {
   3.4874568150439997`*^9, 3.4874568733*^9}, {3.487456917116*^9, 
   3.487457006281*^9}, {3.487461806991*^9, 3.487461821001*^9}, {
   3.4874618511809998`*^9, 3.487461865862*^9}, {3.487461948238*^9, 
   3.487462137876*^9}, {3.4874621945769997`*^9, 3.487462200699*^9}, {
   3.487463067376*^9, 3.487463067718*^9}, {3.487464676791*^9, 
   3.4874648036610003`*^9}, {3.4874648593719997`*^9, 
   3.4874648900299997`*^9}, {3.487464968685*^9, 3.487465030953*^9}, {
   3.487465066159*^9, 3.487465083035*^9}, {3.487465177171*^9, 
   3.487465469219*^9}, 3.487465796023*^9, {3.5031513166610003`*^9, 
   3.5031513696949997`*^9}, {3.503151401775*^9, 3.503151406741*^9}, {
   3.503151474586*^9, 3.503151476465*^9}, {3.503151598773*^9, 
   3.503151600209*^9}, {3.503151635072*^9, 3.503151659295*^9}, {
   3.50315176477*^9, 3.503151766584*^9}, {3.509471172516*^9, 
   3.5094711850030003`*^9}, {3.509471313177*^9, 3.509471313915*^9}}],

Cell[BoxData[
 RowBox[{"boosted", "\[Rule]", "True"}]], "Input",
 CellChangeTimes->{{3.5094713290480003`*^9, 3.509471332535*^9}}],

Cell[BoxData[
 RowBox[{"boosted", "\[Rule]", "False"}]], "Input",
 CellChangeTimes->{{3.503151663249*^9, 3.503151666401*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Much", " ", "largee"}], " ", "\[Rule]", " ", 
  RowBox[{"4", " ", 
   SuperscriptBox["10", 
    RowBox[{"-", "8"}]], 
   RowBox[{"Mdot", "/", "yr"}]}]}]], "Input",
 CellChangeTimes->{{3.509471824216*^9, 3.509471834955*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Variability with time", "Subsection",
 CellChangeTimes->{{3.485181988256*^9, 3.485181994447*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "dir", "=", "\"\<C:\\\\study\\\\mathematica\\\\3DMHD\\\\vary\\\\\>\""}], 
  ";", 
  RowBox[{"sep", "=", "1"}], ";", 
  RowBox[{"\[Nu]tab", "=", 
   RowBox[{"{", 
    RowBox[{
    "43", ",", "87", ",", "102", ",", "145", ",", "230", ",", "349", ",", 
     "674", ",", "857"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"el", "=", 
   RowBox[{"{", 
    RowBox[{"ListLogPlot", ",", "ListPlot"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SetOptions", "[", 
      RowBox[{"#", ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "13"}]}], "}"}]}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}]}], "]"}], "&"}], "/@",
     "el"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{",", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "43", ",", "87", ",", "145", ",", "230", ",", "345", ",", "690"}], 
          "}"}], ",", "None"}], "}"}]}], "}"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"tr", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Import", "[", 
        RowBox[{"dir", "<>", "\"\<poliresa90th214nu\>\"", "<>", 
         RowBox[{"ToString", "[", 
          RowBox[{"\[Nu]tab", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "]"}], "<>", "\"\<fn0.dat\>\""}], 
        "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tr", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "=", 
      FractionBox[
       RowBox[{"2", 
        RowBox[{"tr", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], 
       SuperscriptBox["10", "3"]]}], ";", 
     RowBox[{"tmin", "=", 
      RowBox[{"tr", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"tmax", "=", 
      RowBox[{"tr", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"GraphicsRow", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Fpl", "[", "i", "]"}], "=", 
           RowBox[{"ListLogPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tr", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"tr", "[", 
                 RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"None", ",", "None"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"None", ",", 
                  RowBox[{
                  "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) at \[Nu]=\>\"", 
                   "<>", 
                   RowBox[{"ToString", "[", 
                    RowBox[{"tr", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
                   "\"\<GHz\>\""}]}], "}"}]}], "}"}]}], ",", 
             RowBox[{"Frame", "\[Rule]", "True"}], ",", 
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"tmin", ",", "tmax"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"0.9", 
                   RowBox[{"Min", "[", 
                    RowBox[{"tr", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ",", 
                  RowBox[{"1.1", 
                   RowBox[{"Max", "[", 
                    RowBox[{"tr", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "]"}]}]}], "}"}]}], 
               "}"}]}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], ",", 
          RowBox[{
           RowBox[{"LPpl", "[", "i", "]"}], "=", 
           RowBox[{"ListLogPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tr", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"tr", "[", 
                 RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"None", ",", "None"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"None", ",", 
                  RowBox[{"\"\<LP at \[Nu]=\>\"", "<>", 
                   RowBox[{"ToString", "[", 
                    RowBox[{"tr", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
                   "\"\<GHz\>\""}]}], "}"}]}], "}"}]}], ",", 
             RowBox[{"Frame", "\[Rule]", "True"}], ",", 
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"tmin", ",", "tmax"}], "}"}], ",", "Automatic"}], 
               "}"}]}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"EVPApl", "[", "i", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tr", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"Mod", "[", 
                 RowBox[{
                  RowBox[{"180", "+", 
                   RowBox[{"tr", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}], ",", "180"}], "]"}]}], 
               "}"}], "]"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"None", ",", "None"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"None", ",", 
                  RowBox[{"\"\<EVPA in deg at \[Nu]=\>\"", "<>", 
                   RowBox[{"ToString", "[", 
                    RowBox[{"tr", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
                   "\"\<GHz\>\""}]}], "}"}]}], "}"}]}], ",", 
             RowBox[{"Frame", "\[Rule]", "True"}], ",", 
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"tmin", ",", "tmax"}], "}"}], ",", "Automatic"}], 
               "}"}]}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"CPpl", "[", "i", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tr", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"tr", "[", 
                 RowBox[{"[", "6", "]"}], "]"}]}], "}"}], "]"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"None", ",", "None"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"None", ",", 
                  RowBox[{"\"\<CP in % at \[Nu]=\>\"", "<>", 
                   RowBox[{"ToString", "[", 
                    RowBox[{"tr", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
                   "\"\<GHz\>\""}]}], "}"}]}], "}"}]}], ",", 
             RowBox[{"Frame", "\[Rule]", "True"}], ",", 
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"tmin", ",", "tmax"}], "}"}], ",", "Automatic"}], 
               "}"}]}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}]}], "}"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "1200"}]}], "]"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{"Length", "[", "\[Nu]tab", "]"}]}], "}"}]}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.4819877127506*^9, 3.4819877316577997`*^9}, {
  3.4819877782394*^9, 3.4819878385802*^9}, {3.4819878727286*^9, 
  3.4819878736177998`*^9}, {3.4820234987612*^9, 3.48202354904*^9}, {
  3.4820236181636*^9, 3.4820236523744*^9}, {3.4821629769922*^9, 
  3.4821630120142*^9}, {3.4821669409365997`*^9, 3.4821669450861998`*^9}, {
  3.482166997705*^9, 3.4821669988438*^9}, {3.4821874021306*^9, 
  3.4821874047358*^9}, {3.4847075649898*^9, 3.4847076190906*^9}, {
  3.4847077202878*^9, 3.4847077446394*^9}, {3.4847077766661997`*^9, 
  3.4847078052766*^9}, {3.4847078724502*^9, 3.4847079750046*^9}, {
  3.485182210955*^9, 3.485182248198*^9}, {3.48518228334*^9, 
  3.485182314842*^9}, {3.485182350538*^9, 3.485182356481*^9}, {
  3.4851824366280003`*^9, 3.485182506658*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SetOptions", "[", 
      RowBox[{"#", ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "14"}]}], "}"}]}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}]}], "]"}], "&"}], "/@",
     "el"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{",", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "43", ",", "87", ",", "145", ",", "230", ",", "345", ",", "690"}], 
          "}"}], ",", "None"}], "}"}]}], "}"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tr", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"Import", "[", 
     RowBox[{"dir", "<>", "\"\<poliresa90th214nu\>\"", "<>", 
      RowBox[{"ToString", "[", 
       RowBox[{"\[Nu]tab", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "]"}], "<>", "\"\<fn0.dat\>\""}], 
     "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tr", "[", 
    RowBox[{"[", "1", "]"}], "]"}], "=", 
   FractionBox[
    RowBox[{"2", 
     RowBox[{"tr", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], 
    SuperscriptBox["10", "3"]]}], ";", 
  RowBox[{"tmin", "=", 
   RowBox[{"tr", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", 
  RowBox[{"tmax", "=", 
   RowBox[{"tr", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", 
      RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"GraphicsRow", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Fpl1", "=", 
       RowBox[{"ListLogPlot", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"tr", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"tr", "[", 
             RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"tmin", ",", "tmax"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"0.9", 
               RowBox[{"Min", "[", 
                RowBox[{"tr", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ",", 
              RowBox[{"1.1", 
               RowBox[{"Max", "[", 
                RowBox[{"tr", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "]"}]}]}], "}"}]}], "}"}]}], 
         ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Red"}], 
           "}"}]}]}], "]"}]}], ",", 
      RowBox[{"LPpl1", "=", 
       RowBox[{"ListLogPlot", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"tr", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"tr", "[", 
             RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"tmin", ",", "tmax"}], "}"}], ",", "Automatic"}], 
           "}"}]}], ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Red"}], 
           "}"}]}]}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"EVPApl1", "=", 
       RowBox[{"ListPlot", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"tr", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"Mod", "[", 
             RowBox[{
              RowBox[{"180", "+", 
               RowBox[{"tr", "[", 
                RowBox[{"[", "5", "]"}], "]"}]}], ",", "180"}], "]"}]}], 
           "}"}], "]"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"tmin", ",", "tmax"}], "}"}], ",", "Automatic"}], 
           "}"}]}], ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Red"}], 
           "}"}]}]}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"CPpl1", "=", 
       RowBox[{"ListPlot", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"tr", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"tr", "[", 
             RowBox[{"[", "6", "]"}], "]"}]}], "}"}], "]"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"tmin", ",", "tmax"}], "}"}], ",", "Automatic"}], 
           "}"}]}], ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Red"}], 
           "}"}]}]}], "]"}]}]}], "}"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1200"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tr", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"Import", "[", 
     RowBox[{"dir", "<>", "\"\<poliresa90th214nu\>\"", "<>", 
      RowBox[{"ToString", "[", 
       RowBox[{"\[Nu]tab", "[", 
        RowBox[{"[", "5", "]"}], "]"}], "]"}], "<>", "\"\<fn0.dat\>\""}], 
     "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tr", "[", 
    RowBox[{"[", "1", "]"}], "]"}], "=", 
   FractionBox[
    RowBox[{"2", 
     RowBox[{"tr", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], 
    SuperscriptBox["10", "3"]]}], ";", 
  RowBox[{"tmin", "=", 
   RowBox[{"tr", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", 
  RowBox[{"tmax", "=", 
   RowBox[{"tr", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", 
      RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Fpl5", "=", 
      RowBox[{"ListLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tr", "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"tr", "[", 
            RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"tmin", ",", "tmax"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"0.9", 
              RowBox[{"Min", "[", 
               RowBox[{"tr", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ",", 
             RowBox[{"1.1", 
              RowBox[{"Max", "[", 
               RowBox[{"tr", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}]}]}], "}"}]}], "}"}]}], 
        ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Blue"}], 
          "}"}]}]}], "]"}]}], ",", 
     RowBox[{"LPpl5", "=", 
      RowBox[{"ListLogPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tr", "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"tr", "[", 
            RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"tmin", ",", "tmax"}], "}"}], ",", "Automatic"}], "}"}]}],
         ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Blue"}], 
          "}"}]}]}], "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"EVPApl5", "=", 
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tr", "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"Mod", "[", 
            RowBox[{
             RowBox[{"180", "+", 
              RowBox[{"tr", "[", 
               RowBox[{"[", "5", "]"}], "]"}]}], ",", "180"}], "]"}]}], "}"}],
          "]"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"tmin", ",", "tmax"}], "}"}], ",", "Automatic"}], "}"}]}],
         ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Blue"}], 
          "}"}]}]}], "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"CPpl5", "=", 
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"tr", "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"tr", "[", 
            RowBox[{"[", "6", "]"}], "]"}]}], "}"}], "]"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"tmin", ",", "tmax"}], "}"}], ",", "Automatic"}], "}"}]}],
         ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"AbsoluteThickness", "[", "1.5", "]"}], ",", "Blue"}], 
          "}"}]}]}], "]"}]}]}], "}"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "1200"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.485182568684*^9, 3.485182710434*^9}, {3.485182751432*^9,
   3.485182798439*^9}, {3.485183375334*^9, 3.485183406145*^9}}],

Cell[BoxData[{
 RowBox[{"variab", "=", 
  RowBox[{"GraphicsGrid", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Show", "[", 
         RowBox[{"Fpl1", ",", "Fpl5", ",", 
          RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
          RowBox[{"FrameLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"None", ",", "None"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "None", ",", 
               "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\), Jy at \
\[Nu]=43GHz(red) and 230GHz(blue)\>\""}], "}"}]}], "}"}]}]}], "]"}], ",", 
        RowBox[{"Show", "[", 
         RowBox[{"CPpl1", ",", "CPpl5", ",", 
          RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
          RowBox[{"FrameLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"None", ",", "None"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "None", ",", 
               "\"\<CP% at \[Nu]=43GHz(red) and 230GHz(blue)\>\""}], "}"}]}], 
            "}"}]}]}], "]"}]}], "}"}], "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Show", "[", 
         RowBox[{"LPpl1", ",", "LPpl5", ",", 
          RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
          RowBox[{"FrameLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"None", ",", "None"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "None", ",", 
               "\"\<LP% at \[Nu]=43GHz(red) and 230GHz(blue)\>\""}], "}"}]}], 
            "}"}]}]}], "]"}], ",", 
        RowBox[{"Show", "[", 
         RowBox[{"EVPApl1", ",", "EVPApl5", ",", 
          RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
          RowBox[{"FrameLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"None", ",", "None"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
              "None", ",", 
               "\"\<EVPA at \[Nu]=43GHz(red) and 230GHz(blue)\>\""}], "}"}]}],
             "}"}]}]}], "]"}]}], "\[IndentingNewLine]", "}"}]}], "}"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "950"}], ",", 
    RowBox[{"Epilog", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Black", ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<time, \!\(\*SuperscriptBox[\(x10\), \(3\)]\)M\>\"", ",", "20", 
           ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.44", ",", "0.52"}], "}"}], "]"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<time, \!\(\*SuperscriptBox[\(x10\), \(3\)]\)M\>\"", ",", "20", 
           ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.44", ",", "0.05"}], "}"}], "]"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<time, \!\(\*SuperscriptBox[\(x10\), \(3\)]\)M\>\"", ",", "20", 
           ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.94", ",", "0.50"}], "}"}], "]"}]}], "]"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<time, \!\(\*SuperscriptBox[\(x10\), \(3\)]\)M\>\"", ",", "20", 
           ",", "Bold"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.94", ",", "0.03"}], "}"}], "]"}]}], "]"}]}], "}"}]}], 
    ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", "16", "}"}]}], ",", 
    RowBox[{
    "PlotLabel", "\[Rule]", 
     "\"\<Intrinsic variability of simulated quantities\>\""}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "\"\<C:\\\\study\\\\accretion\\\\! 2009 fall cfa\\\\GR Polarized \
modeling\\\\\>\"", "<>", "\"\<variability.eps\>\""}], ",", "variab"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.485182321416*^9, 3.4851823252209997`*^9}, {
  3.485182367979*^9, 3.4851823857460003`*^9}, {3.485182484381*^9, 
  3.485182550793*^9}, {3.485182714817*^9, 3.4851827420550003`*^9}, {
  3.485182789109*^9, 3.485182803811*^9}, {3.4851828379449997`*^9, 
  3.485183014234*^9}, {3.485183081071*^9, 3.485183143059*^9}, {
  3.4851831740889997`*^9, 3.485183335163*^9}, {3.485183424207*^9, 
  3.4851834898190002`*^9}, {3.485183533664*^9, 3.48518354988*^9}}],

Cell[BoxData[{"ZTest", "\[IndentingNewLine]", "TTest", "\[IndentingNewLine]", \
"LocationTest"}], "Input",
 CellChangeTimes->{{3.501521260884*^9, 3.5015212632*^9}, {3.501523300242*^9, 
  3.501523303424*^9}, {3.501524600814*^9, 3.501524602038*^9}}],

Cell[BoxData[{
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    FractionBox["1", 
     SqrtBox[
      RowBox[{"2", "\[Pi]"}]]], 
    RowBox[{"Exp", "[", 
     RowBox[{"-", 
      FractionBox[
       SuperscriptBox["x", "2"], "2"]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "\[Infinity]"}], ",", 
     RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"2", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     FractionBox["1", 
      SqrtBox[
       RowBox[{"2", "\[Pi]"}]]], 
     RowBox[{"Exp", "[", 
      RowBox[{"-", 
       FractionBox[
        SuperscriptBox["x", "2"], "2"]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y", ",", 
      RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.50152193291*^9, 3.501521936601*^9}, {3.501521982079*^9, 
  3.5015220272320004`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Erfc", "[", 
   FractionBox["y", 
    SqrtBox["2"]], "]"}], "/.", 
  RowBox[{"y", "\[Rule]", "2.47"}]}]], "Input",
 CellChangeTimes->{{3.501522029974*^9, 3.501522032573*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["non-inclined images", "Subsection",
 CellChangeTimes->{{3.486466498406*^9, 3.486466503158*^9}, {3.486471838413*^9,
   3.4864718415299997`*^9}, {3.487437875091*^9, 3.487437878281*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "totI", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"namefile", "=", 
   RowBox[{
   "\"\<C:\\\\study\\\\mathematica\\\\3DMHD\\\\4\\\\\>\"", "<>", 
    "\"\<shotimag50th193fn-1.dat\>\""}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fi11", "=", 
   RowBox[{"OpenRead", "[", 
    RowBox[{"namefile", ",", 
     RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
  RowBox[{"params", "=", 
   RowBox[{"BinaryReadList", "[", 
    RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"th", "=", 
   RowBox[{
    RowBox[{"Round", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[Pi]", "-", 
        RowBox[{"params", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "1000"}], "]"}], "/", 
    "1000."}]}], ";", 
  RowBox[{"nxy", "=", 
   RowBox[{"Round", "[", 
    RowBox[{"params", "[", 
     RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"nu", "=", 
   RowBox[{"Round", "[", 
    RowBox[{"params", "[", 
     RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"maxy", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "5", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"heat", "=", 
    RowBox[{"params", "[", 
     RowBox[{"[", "6", "]"}], "]"}]}], ";", 
   RowBox[{"rnohor", "=", 
    RowBox[{"params", "[", 
     RowBox[{"[", "7", "]"}], "]"}]}], ";", 
   RowBox[{"inten", "=", 
    RowBox[{"BinaryReadList", "[", 
     RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
   RowBox[{"partres", "=", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"Partition", "[", 
       RowBox[{"inten", ",", "5"}], "]"}], ",", 
      RowBox[{"nxy", "+", "1"}]}], "]"}]}], ";", 
   RowBox[{"Close", "[", "fi11", "]"}], ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"li", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"partres", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"linQ", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"linU", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "3"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"linV", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "4"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scale", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"Max", "[", 
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
  ";", 
  RowBox[{"csc", "=", "1"}], ";", 
  RowBox[{"mysize", "=", "20"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"con", "=", "20"}], ";", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"contrast", " ", "con"}], "\[Implies]", 
      RowBox[{
      "luminosity", " ", "con", " ", "times", " ", "lower", " ", "is", " ", 
       "black"}]}], ",", 
     RowBox[{"max", " ", "luminosity", " ", "is", " ", "white"}]}], "*)"}], 
   RowBox[{"totI05", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"rr", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"li", "[", 
            RowBox[{"y", ",", 
             RowBox[{"-", "x"}]}], "]"}], "-", "scale"}], ")"}], "/", 
         RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "150"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{
           RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{
            "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): a=\>\"", "<>", 
             RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,   \[Nu]=\>\"", 
             "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
             "\"\<GHz,   \[Theta]=\>\"", "<>", 
             RowBox[{"ToString", "[", "th", "]"}]}], ",", 
            RowBox[{"mysize", "-", "2"}], ",", "Bold", ",", "Pink"}], "]"}], 
          ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"scV", "=", 
     RowBox[{"3.5", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "6"}]]}]}], ";", 
    RowBox[{"scL", "=", 
     RowBox[{"Log", "[", "0.0003", "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"totV05", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"DensityPlot", "[", 
        RowBox[{
         RowBox[{"res", "=", 
          RowBox[{"linV", "[", 
           RowBox[{"y", ",", 
            RowBox[{"-", "x"}]}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", 
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"y", ",", 
           RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
         RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
         RowBox[{"ColorFunction", "\[Rule]", 
          RowBox[{"Function", "[", 
           RowBox[{
            RowBox[{"{", "n", "}"}], ",", 
            RowBox[{
             RowBox[{"r", "=", 
              RowBox[{"n", "/", "scV"}]}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"r", ">", "0"}], ",", 
               RowBox[{"RGBColor", "[", 
                RowBox[{
                 RowBox[{"2", "r"}], ",", "r", ",", "r"}], "]"}], ",", 
               RowBox[{"RGBColor", "[", 
                RowBox[{
                 RowBox[{"-", "r"}], ",", 
                 RowBox[{"-", "r"}], ",", 
                 RowBox[{
                  RowBox[{"-", "2"}], "r"}]}], "]"}]}], "]"}]}]}], "]"}]}], 
         ",", 
         RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
         RowBox[{"Frame", "\[Rule]", "True"}], ",", 
         RowBox[{"FrameStyle", "\[Rule]", 
          RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
         RowBox[{"Axes", "\[Rule]", "False"}], ",", 
         RowBox[{"BaseStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
            RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
            RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
         RowBox[{"Epilog", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Text", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{
               RowBox[{"\"\<V: a=\>\"", "<>", 
                RowBox[{"ToString", "[", "a", "]"}], "<>", 
                "\"\<,  \[Nu]=\>\"", "<>", 
                RowBox[{"ToString", "[", 
                 RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
                "\"\<GHz,  \[Theta]=\>\"", "<>", 
                RowBox[{"ToString", "[", "th", "]"}]}], ",", "mysize", ",", 
               "Bold", ",", "Pink"}], "]"}], ",", 
             RowBox[{"Scaled", "[", 
              RowBox[{"{", 
               RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0"}], "}"}], ",", 
             RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}], 
         ",", 
         RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}], 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"Red", " ", "-", " ", "positive"}], ",", " ", 
         RowBox[{"Blue", " ", "-", " ", "negative"}]}], "*)"}], "\n", 
       "totQU05"}], "=", 
      RowBox[{"VectorDensityPlot", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"A", "=", 
            RowBox[{"linQ", "[", 
             RowBox[{"y", ",", 
              RowBox[{"-", "x"}]}], "]"}]}], ";", 
           RowBox[{"B", "=", 
            RowBox[{"linU", "[", 
             RowBox[{"y", ",", 
              RowBox[{"-", "x"}]}], "]"}]}], ";", 
           RowBox[{"ann", "=", 
            FractionBox[
             RowBox[{"ArcTan", "[", 
              RowBox[{"A", ",", "B"}], "]"}], "2"]}], ";", 
           RowBox[{"Cos", "[", "ann", "]"}]}], ",", 
          RowBox[{"Sin", "[", "ann", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", 
          RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"y", ",", 
          RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
        RowBox[{"VectorPoints", "\[Rule]", "100"}], ",", 
        RowBox[{"VectorStyle", "\[Rule]", 
         RowBox[{"Arrowheads", "[", "0", "]"}]}], ",", 
        RowBox[{"StreamStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Arrowheads", "[", "0", "]"}], ",", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"1", ",", "0.5", ",", "0.5"}], "]"}]}], "}"}]}], ",", 
        RowBox[{"StreamPoints", "\[Rule]", "100"}], ",", 
        RowBox[{"StreamScale", "\[Rule]", "Full"}], ",", 
        RowBox[{"MaxRecursion", "\[Rule]", "2"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
        RowBox[{"ColorFunction", "\[Rule]", 
         RowBox[{"Function", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x", ",", "y", ",", "vx", ",", "vy", ",", "n"}], "}"}], 
           ",", 
           RowBox[{
            RowBox[{"w", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  FractionBox["1", "2"], 
                  RowBox[{"Log", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"linQ", "[", 
                    RowBox[{
                    RowBox[{"-", "y"}], ",", 
                    RowBox[{"-", "x"}]}], "]"}], "^", "2"}], "+", 
                    RowBox[{
                    RowBox[{"linU", "[", 
                    RowBox[{
                    RowBox[{"-", "y"}], ",", 
                    RowBox[{"-", "x"}]}], "]"}], "^", "2"}]}], "]"}]}], "-", 
                 "scL"}], ")"}], "/", 
               RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ";", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"2", " ", "w", " ", "csc"}], ",", 
              RowBox[{"w", " ", "csc"}], ",", 
              RowBox[{"w", " ", "csc"}]}], "]"}]}]}], "]"}]}], ",", 
        RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
        RowBox[{"Axes", "\[Rule]", "False"}], ",", 
        RowBox[{"BaseStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
           RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
           RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
        RowBox[{"Epilog", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{
              "\"\<\!\(\*SqrtBox[\(\*SuperscriptBox[\(Q\), \(2\)] + \
\*SuperscriptBox[\(U\), \(2\)]\)]\) & field: a=\>\"", "<>", 
               RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \[Nu]=\>\"",
                "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
               "\"\<GHz,  \[Theta]=\>\"", "<>", 
               RowBox[{"ToString", "[", "th", "]"}]}], ",", 
              RowBox[{"mysize", "-", "3"}], ",", "Bold", ",", "Pink"}], "]"}],
             ",", 
            RowBox[{"Scaled", "[", 
             RowBox[{"{", 
              RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0"}], "}"}], ",", 
            RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
       "]"}]}]}]}], "*)"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"namefile", "=", 
   RowBox[{
   "\"\<C:\\\\study\\\\mathematica\\\\3DMHD\\\\4\\\\\>\"", "<>", 
    "\"\<shotimag90th214fn-1.dat\>\""}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fi11", "=", 
   RowBox[{"OpenRead", "[", 
    RowBox[{"namefile", ",", 
     RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
  RowBox[{"params", "=", 
   RowBox[{"BinaryReadList", "[", 
    RowBox[{"fi11", ",", "\"\<Real64\>\"", ",", "10"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"th", "=", 
   RowBox[{
    RowBox[{"Round", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[Pi]", "-", 
        RowBox[{"params", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ")"}], " ", "1000"}], "]"}], "/", 
    "1000."}]}], ";", 
  RowBox[{"nxy", "=", 
   RowBox[{"Round", "[", 
    RowBox[{"params", "[", 
     RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"nu", "=", 
   RowBox[{"Round", "[", 
    RowBox[{"params", "[", 
     RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"maxy", "=", 
   RowBox[{"params", "[", 
    RowBox[{"[", "5", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"heat", "=", 
    RowBox[{"params", "[", 
     RowBox[{"[", "6", "]"}], "]"}]}], ";", 
   RowBox[{"rnohor", "=", 
    RowBox[{"params", "[", 
     RowBox[{"[", "7", "]"}], "]"}]}], ";", 
   RowBox[{"inten", "=", 
    RowBox[{"BinaryReadList", "[", 
     RowBox[{"fi11", ",", "\"\<Real64\>\""}], "]"}]}], ";", 
   RowBox[{"partres", "=", 
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"Partition", "[", 
       RowBox[{"inten", ",", "5"}], "]"}], ",", 
      RowBox[{"nxy", "+", "1"}]}], "]"}]}], ";", 
   RowBox[{"Close", "[", "fi11", "]"}], ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"li", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"partres", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"linQ", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"linU", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "3"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"linV", "=", 
   RowBox[{"ListInterpolation", "[", 
    RowBox[{
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "4"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "}"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scale", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"Max", "[", 
     RowBox[{"partres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
  ";", 
  RowBox[{"csc", "=", "1"}], ";", 
  RowBox[{"mysize", "=", "20"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"con", "=", "20"}], ";", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"contrast", " ", "con"}], "\[Implies]", 
      RowBox[{
      "luminosity", " ", "con", " ", "times", " ", "lower", " ", "is", " ", 
       "black"}]}], ",", 
     RowBox[{"max", " ", "luminosity", " ", "is", " ", "white"}]}], "*)"}], 
   RowBox[{"totI09", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"rr", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"li", "[", 
            RowBox[{"y", ",", 
             RowBox[{"-", "x"}]}], "]"}], "-", "scale"}], ")"}], "/", 
         RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "150"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"RGBColor", "[", 
          RowBox[{
           RowBox[{"2", " ", "#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}], ",", 
           RowBox[{"#1", " ", "csc"}]}], "]"}], "&"}], ")"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{
            "\"\<total  \!\(\*SubscriptBox[\(I\), \(\[Nu]\)]\): a=\>\"", "<>", 
             RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,   \[Nu]=\>\"", 
             "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
             "\"\<GHz,   \[Theta]=\>\"", "<>", 
             RowBox[{"ToString", "[", "th", "]"}]}], ",", 
            RowBox[{"mysize", "-", "2"}], ",", "Bold", ",", "Pink"}], "]"}], 
          ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
     "]"}]}], ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scV", "=", 
   RowBox[{"3.5", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "6"}]]}]}], ";", 
  RowBox[{"scL", "=", 
   RowBox[{"Log", "[", "0.0003", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"totV09", "=", 
    RowBox[{"DensityPlot", "[", 
     RowBox[{
      RowBox[{"res", "=", 
       RowBox[{"linV", "[", 
        RowBox[{"y", ",", 
         RowBox[{"-", "x"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", 
        RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
      RowBox[{"PlotPoints", "\[Rule]", "200"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", 
       RowBox[{"Function", "[", 
        RowBox[{
         RowBox[{"{", "n", "}"}], ",", 
         RowBox[{
          RowBox[{"r", "=", 
           RowBox[{"n", "/", "scV"}]}], ";", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"r", ">", "0"}], ",", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"2", "r"}], ",", "r", ",", "r"}], "]"}], ",", 
            RowBox[{"RGBColor", "[", 
             RowBox[{
              RowBox[{"-", "r"}], ",", 
              RowBox[{"-", "r"}], ",", 
              RowBox[{
               RowBox[{"-", "2"}], "r"}]}], "]"}]}], "]"}]}]}], "]"}]}], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
      RowBox[{"Frame", "\[Rule]", "True"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", 
       RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
      RowBox[{"Axes", "\[Rule]", "False"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
      RowBox[{"Epilog", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Text", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"\"\<V: a=\>\"", "<>", 
             RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \[Nu]=\>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
             "\"\<GHz,  \[Theta]=\>\"", "<>", 
             RowBox[{"ToString", "[", "th", "]"}]}], ",", "mysize", ",", 
            "Bold", ",", "Pink"}], "]"}], ",", 
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", 
          RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}], ",", 
      RowBox[{"ClippingStyle", "\[Rule]", "Automatic"}]}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Red", " ", "-", " ", "positive"}], ",", " ", 
    RowBox[{"Blue", " ", "-", " ", "negative"}]}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"totQU09", "=", 
   RowBox[{"VectorDensityPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"A", "=", 
         RowBox[{"linQ", "[", 
          RowBox[{"y", ",", 
           RowBox[{"-", "x"}]}], "]"}]}], ";", 
        RowBox[{"B", "=", 
         RowBox[{"linU", "[", 
          RowBox[{"y", ",", 
           RowBox[{"-", "x"}]}], "]"}]}], ";", 
        RowBox[{"ann", "=", 
         FractionBox[
          RowBox[{"ArcTan", "[", 
           RowBox[{"A", ",", "B"}], "]"}], "2"]}], ";", 
        RowBox[{"Cos", "[", "ann", "]"}]}], ",", 
       RowBox[{"Sin", "[", "ann", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", 
       RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
     RowBox[{"VectorPoints", "\[Rule]", "100"}], ",", 
     RowBox[{"VectorStyle", "\[Rule]", 
      RowBox[{"Arrowheads", "[", "0", "]"}]}], ",", 
     RowBox[{"StreamStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Arrowheads", "[", "0", "]"}], ",", 
        RowBox[{"RGBColor", "[", 
         RowBox[{"1", ",", "0.5", ",", "0.5"}], "]"}]}], "}"}]}], ",", 
     RowBox[{"StreamPoints", "\[Rule]", "100"}], ",", 
     RowBox[{"StreamScale", "\[Rule]", "Full"}], ",", 
     RowBox[{"MaxRecursion", "\[Rule]", "2"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "y", ",", "vx", ",", "vy", ",", "n"}], "}"}], ",", 
        RowBox[{
         RowBox[{"w", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               FractionBox["1", "2"], 
               RowBox[{"Log", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"linQ", "[", 
                   RowBox[{
                    RowBox[{"-", "y"}], ",", 
                    RowBox[{"-", "x"}]}], "]"}], "^", "2"}], "+", 
                 RowBox[{
                  RowBox[{"linU", "[", 
                   RowBox[{
                    RowBox[{"-", "y"}], ",", 
                    RowBox[{"-", "x"}]}], "]"}], "^", "2"}]}], "]"}]}], "-", 
              "scL"}], ")"}], "/", 
            RowBox[{"Log", "[", "con", "]"}]}], "+", "1"}]}], ";", 
         RowBox[{"RGBColor", "[", 
          RowBox[{
           RowBox[{"2", " ", "w", " ", "csc"}], ",", 
           RowBox[{"w", " ", "csc"}], ",", 
           RowBox[{"w", " ", "csc"}]}], "]"}]}]}], "]"}]}], ",", 
     RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}], ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", 
      RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"BaseStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
        RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
        RowBox[{"FontSize", "\[Rule]", "mysize"}]}], "}"}]}], ",", 
     RowBox[{"Epilog", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{
           "\"\<\!\(\*SqrtBox[\(\*SuperscriptBox[\(Q\), \(2\)] + \
\*SuperscriptBox[\(U\), \(2\)]\)]\) & field: a=\>\"", "<>", 
            RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<,  \[Nu]=\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"Round", "[", "nu", "]"}], "]"}], "<>", 
            "\"\<GHz,  \[Theta]=\>\"", "<>", 
            RowBox[{"ToString", "[", "th", "]"}]}], ",", 
           RowBox[{"mysize", "-", "3"}], ",", "Bold", ",", "Pink"}], "]"}], 
         ",", 
         RowBox[{"Scaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.5", ",", "0.925"}], "}"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"Background", "\[Rule]", "Black"}]}], "]"}], "}"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.486466504365*^9, 3.486466504535*^9}, {3.486466888175*^9,
    3.4864669138190002`*^9}, {3.486466946699*^9, 3.48646696973*^9}, {
   3.486469104926*^9, 3.486469333568*^9}, {3.4864693788269997`*^9, 
   3.486469382115*^9}, {3.486469442733*^9, 3.48646944301*^9}, {
   3.486469817558*^9, 3.486469832678*^9}, {3.486470376785*^9, 
   3.486470387541*^9}, {3.486470422441*^9, 3.4864704816140003`*^9}, 
   3.4864705136070004`*^9, {3.486471330034*^9, 3.4864713477460003`*^9}, {
   3.486474745896*^9, 3.48647475674*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"totI", "=", 
    RowBox[{"GraphicsColumn", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"totI09", ",", "totI05"}], "}"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "16"}]}], "}"}]}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<images of intensity for best-fitting models\>\""}]}], "]"}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"imagepl", "=", 
    RowBox[{"GraphicsGrid", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"totI09", ",", "totV09"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"totI05", ",", "totQU09"}], "}"}]}], "}"}], ",", 
      RowBox[{"BaseStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
         RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
         RowBox[{"FontSize", "\[Rule]", "16"}]}], "}"}]}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<images of total and polarized intensities for best-fitting models\
\>\""}]}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{
     "\"\<C:\\\\study\\\\accretion\\\\! 2009 fall cfa\\\\GR Polarized \
modeling\\\\\>\"", "<>", "\"\<images.eps\>\""}], ",", "imagepl", ",", 
     RowBox[{"\"\<AllowRasterization\>\"", "\[Rule]", "True"}], ",", " ", 
     RowBox[{"ImageResolution", "\[Rule]", "150"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.4864694479820004`*^9, 3.486469478133*^9}, {
  3.486470249033*^9, 3.48647027212*^9}, {3.486470303263*^9, 
  3.48647031827*^9}, {3.486470498125*^9, 3.486470551209*^9}, {
  3.4864715937460003`*^9, 3.486471595292*^9}, {3.486475686441*^9, 
  3.486475687551*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["auxillary stuff", "Subsection",
 CellChangeTimes->{{3.485214458423046*^9, 3.485214488325046*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ruru", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rg", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "6.67", " ", 
        SuperscriptBox["10", 
         RowBox[{"-", "8"}]], "4.5", " ", 
        SuperscriptBox["10", "6"], "2", " ", 
        SuperscriptBox["10", "33"]}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"3", " ", 
          SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
     RowBox[{"arcsec", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
        SuperscriptBox["10", "3"], "3.08", " ", 
        SuperscriptBox["10", "18"]}], 
       RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
     RowBox[{"pc", "\[Rule]", 
      RowBox[{"3.08", " ", 
       SuperscriptBox["10", "18"]}]}], ",", 
     RowBox[{"year", "\[Rule]", 
      RowBox[{"365.35", " ", "86400"}]}], ",", 
     RowBox[{"cc", "\[Rule]", 
      RowBox[{"3.", " ", 
       SuperscriptBox["10", "10"]}]}], ",", 
     RowBox[{"Msun", "\[Rule]", 
      RowBox[{"2.", " ", 
       SuperscriptBox["10", "33"]}]}], ",", 
     RowBox[{"mp", "\[Rule]", 
      RowBox[{"1.26", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "24"}]]}]}], ",", 
     RowBox[{"me", "\[Rule]", 
      RowBox[{"9.1", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "28"}]]}]}], ",", 
     RowBox[{"kb", "\[Rule]", 
      RowBox[{"1.38", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "16"}]]}]}], ",", 
     RowBox[{"h", "\[Rule]", 
      RowBox[{"6.626", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "27"}]]}]}], ",", 
     RowBox[{"ee", "\[Rule]", 
      RowBox[{"4.8", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "10"}]]}]}], ",", 
     RowBox[{"keV", "->", 
      RowBox[{"1000", " ", "1.602", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "12"}]]}]}], ",", 
     RowBox[{"dd", "\[Rule]", 
      RowBox[{"8.4", " ", 
       SuperscriptBox["10", "3"], "3.08", " ", 
       SuperscriptBox["10", "18"]}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Lambda]", "=", 
   RowBox[{
    FractionBox["cc", 
     RowBox[{"43", " ", 
      SuperscriptBox["10", "9"]}]], "/.", "ruru"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox["dd", 
   RowBox[{"100", " ", 
    SuperscriptBox["10", "3"], "rg"}]], "/.", "ruru"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   FractionBox["\[Pi]", "180"], 
   FractionBox[
    RowBox[{"0.7", " ", 
     SuperscriptBox["10", 
      RowBox[{"-", "3"}]]}], 
    RowBox[{"60.", " ", "60"}]], 
   FractionBox["dd", "rg"]}], "/.", "ruru"}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox[
   RowBox[{"30", " ", "60", " ", "cc"}], "rg"], "/.", 
  "ruru"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"400", 
   FractionBox["rg", "cc"], 
   FractionBox["1", "3600"]}], "/.", "ruru"}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox[
   RowBox[{"1.7", " ", 
    SuperscriptBox["10", "5"], "rg"}], "arcsec"], "/.", "ruru"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJwl0Fsog3EYBvCvhVJMOcwpcyobIpqJG1nZZEItZurL+bAtxUja0moXzotC
kbhQElZqpEyYY5SS2IVzQrTPOUo5xP/5XLz9Lp6396k3vLxOUcWhKCqCDFwV
zPlm7TslO5W5YdCVogVQrrHEQeFpjho6ql91ME163wRvDUfNMMhcvAIFP8wu
u/fR/gJb8hjWYUdBspwo86lKhfkKL88Oh1OSLlay7me88GD9npAPGZelSMiN
m46B3T9iFaQodRHUXgQ2wMsRG6v4eWEQGs1TQ9DOXSrrJBq2xyrgBadMC3nm
YR28UtXo4aaVZ4Ii0VsrfGppboPZRfweOHMUynoSTPdB2lrSz9752kjqIqbp
d1iNIe+e+mOnZN2fw4W01ccPxv9u8eB1cq4AikSFrEyjRgZlA4pMmGS79GfO
yL/cHxNhlNaUAZkujRTKLJ9ZsJQfJIex7QeW5QfS07tog7V392ErRFXqdzg8
zOGOQXGxcRy6maST//nNNBwIoL3txNnRWF/oojQEOIhyj4lgeD6fYE//dkqe
U6LX4B9DSik6
  "]],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"heat", ",", "rhonor", ",", 
     RowBox[{"outp", "[", "0", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"heat", 
      RowBox[{"(", 
       RowBox[{"1", "+", "dheat"}], ")"}]}], ",", "rhonor", ",", 
     RowBox[{"outp", "[", "1", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"heat", ",", 
     RowBox[{"rhonor", 
      RowBox[{"(", 
       RowBox[{"1", "+", "drho"}], ")"}]}], ",", 
     RowBox[{"outp", "[", "2", "]"}]}], "}"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   FractionBox["dxi", "dheat"], "\[Equal]", 
   FractionBox[
    RowBox[{
     RowBox[{"outp", "[", "1", "]"}], "-", 
     RowBox[{"outp", "[", "0", "]"}]}], "dheat"]}], ";", 
  RowBox[{
   FractionBox["dxi", "drho"], "\[Equal]", 
   FractionBox[
    RowBox[{
     RowBox[{"outp", "[", "2", "]"}], "-", 
     RowBox[{"outp", "[", "0", "]"}]}], "dheat"]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"xi00", "\[Equal]", "0", "\[Equal]", 
  RowBox[{
   RowBox[{
    FractionBox["dxi", "drho"], "ddr"}], "+", 
   RowBox[{
    FractionBox["dxi", "dheat"], "ddh"}], "+", 
   RowBox[{"outp", "[", "0", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Conjugate", " "}]}], "Input",
 CellChangeTimes->{{3.4771563111603374`*^9, 3.477156319069537*^9}, {
  3.4771563641400003`*^9, 3.47715646325*^9}, {3.4771565090889997`*^9, 
  3.47715651467*^9}, {3.4771565543190002`*^9, 3.477156608361*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"fun", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"1.001", 
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "1.2"}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"x", "-", "0.3"}], ")"}], "2"]}], "-", 
         RowBox[{"0.1", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             FractionBox["y", 
              RowBox[{"4", " ", 
               SuperscriptBox["10", "5"]}]], "-", "1"}], ")"}], "2"]}]}], 
        "]"}]}], "-", "1"}], ",", 
     RowBox[{
      RowBox[{"0.999", 
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", "1.2"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            FractionBox["y", 
             RowBox[{"4", " ", 
              SuperscriptBox["10", "5"]}]], "-", "1"}], ")"}], "4"]}], 
        "]"}]}], "-", "1"}], ",", 
     RowBox[{
      RowBox[{"1.002", 
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"x", "-", "0.35"}], ")"}], "2"]}], "-", 
         RowBox[{"2", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             FractionBox["y", 
              RowBox[{"5", " ", 
               SuperscriptBox["10", "5"]}]], "-", "1"}], ")"}], "4"]}]}], 
        "]"}]}], "-", "1"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"heat", "=", "0.4"}], ";", 
  RowBox[{"rhonor", "=", 
   RowBox[{"5", " ", 
    SuperscriptBox["10", "5"]}]}], ";", 
  RowBox[{"dheat", "=", "0.01"}], ";", 
  RowBox[{"drho", "=", "0.01"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"outp", "[", "0", "]"}], "=", 
   RowBox[{"fun", "[", 
    RowBox[{"heat", ",", "rhonor"}], "]"}]}], ";", 
  RowBox[{"resid", "=", 
   RowBox[{"outp", "[", "0", "]"}]}], ";", 
  RowBox[{"Norm", "[", 
   RowBox[{"outp", "[", "0", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outp", "[", "1", "]"}], "=", 
  RowBox[{"fun", "[", 
   RowBox[{
    RowBox[{"heat", 
     RowBox[{"(", 
      RowBox[{"1", "+", "dheat"}], ")"}]}], ",", "rhonor"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"outp", "[", "2", "]"}], "=", 
  RowBox[{"fun", "[", 
   RowBox[{"heat", ",", 
    RowBox[{"rhonor", 
     RowBox[{"(", 
      RowBox[{"1", "+", "drho"}], ")"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Jac", "=", 
  RowBox[{"{", 
   RowBox[{
    FractionBox[
     RowBox[{
      RowBox[{"outp", "[", "1", "]"}], "-", 
      RowBox[{"outp", "[", "0", "]"}]}], "dheat"], ",", 
    FractionBox[
     RowBox[{
      RowBox[{"outp", "[", "2", "]"}], "-", 
      RowBox[{"outp", "[", "0", "]"}]}], "drho"]}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"matr", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Jac", "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "k"}], "]"}], "]"}], "*", 
       RowBox[{"Jac", "[", 
        RowBox[{"[", 
         RowBox[{"j", ",", "k"}], "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "3"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"bb", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Jac", "[", 
        RowBox[{"[", 
         RowBox[{"k", ",", "j"}], "]"}], "]"}], "*", 
       RowBox[{"resid", "[", 
        RowBox[{"[", "j", "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "3"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "2"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"sol", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"matr", ".", 
       RowBox[{"{", 
        RowBox[{"ddh", ",", "ddr"}], "}"}]}], "\[Equal]", 
      RowBox[{"-", 
       RowBox[{"Jac", ".", "resid"}]}]}], "]"}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"ddh", "\[Rule]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"bb", "[", 
         RowBox[{"[", "2", "]"}], "]"}], " ", 
        RowBox[{"matr", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "-", 
       RowBox[{
        RowBox[{"bb", "[", 
         RowBox[{"[", "1", "]"}], "]"}], 
        RowBox[{"matr", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "2"}], "]"}], "]"}]}]}], 
      RowBox[{
       SuperscriptBox[
        RowBox[{"matr", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "2"}], "]"}], "]"}], "2"], "-", 
       RowBox[{
        RowBox[{"matr", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}], " ", 
        RowBox[{"matr", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "2"}], "]"}], "]"}]}]}]]}]}], ",", 
   RowBox[{"ddr", "\[Rule]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"bb", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], " ", 
        RowBox[{"matr", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"bb", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", 
        RowBox[{"matr", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], 
      RowBox[{
       SuperscriptBox[
        RowBox[{"matr", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "2"}], "]"}], "]"}], "2"], "-", 
       RowBox[{
        RowBox[{"matr", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}], " ", 
        RowBox[{"matr", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "2"}], "]"}], "]"}]}]}]]}]}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"heat", "*=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "ddh"}], ")"}], "/.", "sol"}]}], ",", 
    RowBox[{"rhonor", "*=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "ddr"}], ")"}], "/.", "sol"}]}]}], "}"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Norm", "[", 
  RowBox[{"fun", "[", 
   RowBox[{"heat", ",", "rhonor"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.477157040601*^9, 3.47715736096*^9}, {
   3.4771574203599997`*^9, 3.477157525072*^9}, {3.477157566895*^9, 
   3.477157674849*^9}, {3.4771577101099997`*^9, 3.4771578438310003`*^9}, {
   3.477158521373*^9, 3.477158695281*^9}, {3.477159131832*^9, 
   3.477159151749*^9}, 3.477159228172*^9, {3.477159282174*^9, 
   3.477159338783*^9}, {3.477159498578*^9, 3.47715956281*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mm", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"ma", "[", "0", "]"}], "[", "0", "]"}], ",", 
       RowBox[{
        RowBox[{"ma", "[", "0", "]"}], "[", "1", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"ma", "[", "0", "]"}], "[", "1", "]"}], ",", 
       RowBox[{
        RowBox[{"ma", "[", "1", "]"}], "[", "1", "]"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"mm", ".", 
       RowBox[{"{", 
        RowBox[{"ddh", ",", "ddr"}], "}"}]}], "\[Equal]", 
      RowBox[{"-", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"b", "[", "0", "]"}], ",", 
         RowBox[{"b", "[", "1", "]"}]}], "}"}]}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"ddh", ",", "ddr"}], "}"}]}], "]"}], "[", 
  RowBox[{"[", "1", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.477159153479*^9, 3.477159267134*^9}, {3.47715967912*^9, 
  3.477159719359*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Distribution function of intensity etc.", "Subsection",
 CellChangeTimes->{{3.5003910344324994`*^9, 3.500391064206499*^9}, {
  3.503149214158*^9, 3.5031492146689997`*^9}}],

Cell[CellGroupData[{

Cell["Zhao 2003 +", "Subsubsection",
 CellChangeTimes->{{3.5004019267404995`*^9, 3.500401949074499*^9}, {
  3.501002113289*^9, 3.501002113824*^9}}],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzs3c9vHWee33sHF/dPCJDFwIphJY58LQsaW77pnsyw1TKMwICbLSdm1Jo2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    "], {{0, 494}, {1316, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->{1138.8, Automatic},
  ImageSizeRaw->{1316, 494},
  PlotRange->{{0, 1316}, {0, 494}}]], "Input",
 CellChangeTimes->{{3.501003079465*^9, 3.501003091317*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"daxx", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"267", ",", "3.6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"268", ",", "4.05"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"269", ",", "3.3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"271", ",", "3.8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"325", ",", "1.9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"361", ",", "1.2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"380", ",", "2.0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"381", ",", "2.4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"382", ",", "2.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"385", ",", "3.3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"387", ",", "2.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"390", ",", "3.0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"395", ",", "2.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"408", ",", "2.4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"422", ",", "2.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"462", ",", "1.9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"497", ",", "2.15"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"599", ",", "3.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"630", ",", "2.4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"657", ",", "2.3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"702", ",", "2.7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"703", ",", "2.3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"709", ",", "2.8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"710", ",", "2.6"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dates", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "daxx", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cur", "=", "1"}], ";", 
  RowBox[{"diff", "=", "15"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"res", "=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"{", 
    RowBox[{"True", ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"dates", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "-", 
           RowBox[{"dates", "[", 
            RowBox[{"[", "cur", "]"}], "]"}]}], ">", "diff"}], ",", 
         RowBox[{
          RowBox[{"cur", "=", "i"}], ";", "True"}], ",", "False"}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "2", ",", 
         RowBox[{"Length", "[", "dates", "]"}]}], "}"}]}], "]"}]}], "}"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Count", "[", 
  RowBox[{"res", ",", "True"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ans", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"res", "[", 
      RowBox[{"[", "i", "]"}], "]"}], ",", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"ans", ",", 
       RowBox[{"daxx", "[", 
        RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", 
     RowBox[{"Length", "[", "res", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "ans", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], "\[IndentingNewLine]", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"data", "=", 
     RowBox[{"{", 
      RowBox[{
      "3.5", ",", "1.8", ",", "1.1", ",", "1.9", ",", "2.4", ",", "3.0", ",", 
       "2.5", ",", "2.0", ",", "2.0", ",", "2.2", ",", "2.9", ",", "2.4", ",",
        "2.3", ",", "2.4", ",", "2.7"}], "}"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xmin", "=", 
    RowBox[{"Min", "[", "data", "]"}]}], ";", 
   RowBox[{"xmax", "=", 
    RowBox[{"Max", "[", "data", "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"dist", "=", 
     RowBox[{"EmpiricalDistribution", "[", "data", "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"DistributionFitTest", "[", "data", "]"}], "\[IndentingNewLine]", 
 RowBox[{"dist", "=", 
  RowBox[{"EstimatedDistribution", "[", 
   RowBox[{"data", ",", 
    RowBox[{"NormalDistribution", "[", 
     RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hist", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"data", ",", 
     RowBox[{"{", "0.3", "}"}], ",", "\"\<ProbabilityDensity\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"hist", ",", "pl"}], "}"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<Flux, Jy\>\"", ",", "\"\<Probability\>\""}], "}"}]}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "finds", " ", "11", " ", "points", " ", "with", " ", "relative", " ", 
     "spacing"}], " ", ">", 
    RowBox[{"15", " ", "days"}]}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.50100411477*^9, 3.501004122039*^9}, {3.501004261034*^9, 
  3.501004361377*^9}, {3.501004718245*^9, 3.5010047620220003`*^9}, {
  3.501004851635*^9, 3.501004860236*^9}, {3.501004915679*^9, 
  3.501004922926*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{
    RowBox[{
    "Import", "[", "\"\<E:\\\\mathematica\\\\location_sgra_230.xlsx\>\"", 
     "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"dates", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "imp", "]"}], "[", 
    RowBox[{"[", "8", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"str", "=", 
   RowBox[{"ToExpression", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\"\<20\>\"", "<>", 
         RowBox[{"StringTake", "[", 
          RowBox[{"#", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2"}], "}"}]}], "]"}]}], ",", 
        RowBox[{"StringTake", "[", 
         RowBox[{"#", ",", 
          RowBox[{"{", 
           RowBox[{"3", ",", "4"}], "}"}]}], "]"}], ",", 
        RowBox[{"StringTake", "[", 
         RowBox[{"#", ",", 
          RowBox[{"{", 
           RowBox[{"5", ",", "6"}], "}"}]}], "]"}]}], "}"}], "&"}], "/@", 
     "dates"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"cur", "=", "1"}], ";", 
  RowBox[{"diff", "=", "15"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{"True", ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"DateDifference", "[", 
            RowBox[{
             RowBox[{"str", "[", 
              RowBox[{"[", "cur", "]"}], "]"}], ",", 
             RowBox[{"str", "[", 
              RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ">", "diff"}], ",", 
          RowBox[{
           RowBox[{"cur", "=", "i"}], ";", "True"}], ",", "False"}], "]"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "2", ",", 
          RowBox[{"Length", "[", "str", "]"}]}], "}"}]}], "]"}]}], "}"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Count", "[", 
  RowBox[{"res", ",", "True"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ans", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"res", "[", 
      RowBox[{"[", "i", "]"}], "]"}], ",", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"ans", ",", 
       RowBox[{"imp", "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "8"}], "]"}], "]"}]}], "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", 
     RowBox[{"Length", "[", "res", "]"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "finds", " ", "44", " ", "points", " ", "with", " ", "relative", " ", 
     "spacing"}], " ", ">", 
    RowBox[{"15", " ", "days"}]}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.5010021196619997`*^9, 3.50100215371*^9}, {
  3.501002224443*^9, 3.501002225874*^9}, {3.5010048136879997`*^9, 
  3.501004840949*^9}, {3.501006925738*^9, 3.501006926074*^9}}],

Cell[BoxData[
 RowBox[{"imp", "[", 
  RowBox[{"[", 
   RowBox[{"10", ",", "8"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5010069013570004`*^9, 3.501006919891*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\mathematica\\\\location_sgra_good230.dat\>\"", ",", "ans"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5010050213710003`*^9, 3.501005062977*^9}, {
  3.501006898701*^9, 3.501006899052*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Herrstein 2004", "Subsubsection",
 CellChangeTimes->{3.5004019406354995`*^9, 3.501002347258*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"her2cm", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\<Herrstein_2cm.xlsx\>\""}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"her13mm", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\<Herrstein_13mm.xlsx\>\""}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"her7mm", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\<Herrstein_7mm.xlsx\>\""}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dat2cm", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "her2cm", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"dat13mm", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "her13mm", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"dat7mm", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "her7mm", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5003970947264996`*^9, 3.5003971236084995`*^9}, {
   3.5003971612944994`*^9, 3.5003971908844995`*^9}, {3.5003973265894995`*^9, 
   3.5003973819054995`*^9}, 3.50100234726*^9, {3.501607540918*^9, 
   3.50160757331*^9}}],

Cell[BoxData[{
 RowBox[{"Mean", "[", 
  RowBox[{"xx", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{"dat7mm", ",", 
      RowBox[{"{", 
       RowBox[{
       "1.03", ",", "1.1", " ", ",", "2.02", ",", " ", "1.9", ",", " ", 
        "1.92", ",", " ", "1.78", ",", "2.02", ",", " ", "1.59", ",", " ", 
        "1.99", ",", " ", "1.61", ",", " ", "1.86", " ", ",", "1.66", ",", 
        "1.45", ",", "1.07", ",", "2.3", ",", "1.4", ",", "1.6"}], "}"}]}], 
     "}"}], "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"StandardDeviation", "[", "dat7mm", "]"}], "/", 
  SqrtBox[
   RowBox[{"Length", "[", "dat7mm", "]"}]]}], "\[IndentingNewLine]", 
 RowBox[{"Length", "[", "xx", "]"}]}], "Input",
 CellChangeTimes->{{3.501606951133*^9, 3.501607009572*^9}, {3.501607478523*^9,
   3.5016075227130003`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"dat2cm", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "her2cm", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"xmin", "=", 
   RowBox[{"Min", "[", "dat2cm", "]"}]}], ";", 
  RowBox[{"xmax", "=", 
   RowBox[{"Max", "[", "dat2cm", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist", "=", 
   RowBox[{"EstimatedDistribution", "[", 
    RowBox[{"dat2cm", ",", 
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hist", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"dat2cm", ",", 
     RowBox[{"{", "0.03", "}"}], ",", "\"\<ProbabilityDensity\>\""}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plo", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hist", ",", "pl"}], "}"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Flux, Jy\>\"", ",", "\"\<Probability\>\""}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"test", "=", 
   RowBox[{"DistributionFitTest", "[", "dat2cm", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{"\"\<2cm\>\"", ",", "plo", ",", "dist", ",", "test"}], "}"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dat13mm", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "her13mm", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"xmin", "=", 
   RowBox[{"Min", "[", "dat13mm", "]"}]}], ";", 
  RowBox[{"xmax", "=", 
   RowBox[{"Max", "[", "dat13mm", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist", "=", 
   RowBox[{"EstimatedDistribution", "[", 
    RowBox[{"dat13mm", ",", 
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hist", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"dat13mm", ",", 
     RowBox[{"{", "0.03", "}"}], ",", "\"\<ProbabilityDensity\>\""}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plo", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hist", ",", "pl"}], "}"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Flux, Jy\>\"", ",", "\"\<Probability\>\""}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"test", "=", 
   RowBox[{"DistributionFitTest", "[", "dat13mm", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{"\"\<13mm\>\"", ",", "plo", ",", "dist", ",", "test"}], "}"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dat7mm", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "her7mm", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"xmin", "=", 
   RowBox[{"Min", "[", "dat7mm", "]"}]}], ";", 
  RowBox[{"xmax", "=", 
   RowBox[{"Max", "[", "dat7mm", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist", "=", 
   RowBox[{"EstimatedDistribution", "[", 
    RowBox[{"dat7mm", ",", 
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hist", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"dat7mm", ",", 
     RowBox[{"{", "0.03", "}"}], ",", "\"\<ProbabilityDensity\>\""}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plo", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hist", ",", "pl"}], "}"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Flux, Jy\>\"", ",", "\"\<Probability\>\""}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"test", "=", 
   RowBox[{"DistributionFitTest", "[", "dat7mm", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{"\"\<7mm\>\"", ",", "plo", ",", "dist", ",", "test"}], 
  "}"}]}], "Input",
 CellChangeTimes->{{3.5003977740594997`*^9, 3.5003978363544993`*^9}, {
   3.5003979007194996`*^9, 3.500397927173499*^9}, {3.5003980015914993`*^9, 
   3.5003980375724993`*^9}, {3.5003980898784995`*^9, 3.5003982091224995`*^9}, 
   3.501002347266*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"7mm\"\>", ",", 
   GraphicsBox[{
     {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
      EdgeForm[Opacity[0.7]], {}, 
      {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
       EdgeForm[Opacity[0.7]], {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.63, 0.}, {0.6599999999999999, 
             0.27548209366391263`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{40.7907570004746, 54.45651400094917}, {
            142.43750338168715`, 166.9535238686926}}],
          StatusArea[#, 0.27548209366391263`]& ,
          TagBoxNote->"0.27548209366391263"],
         StyleBox["0.27548209366391263`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.27548209366391263`, {
           GrayLevel[0]}], "Tooltip"]& ], {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.69, 0.}, {0.72, 0.27548209366391163`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{65.6222710014238, 79.28802800189837}, {
            142.43750338168724`, 166.9535238686926}}],
          StatusArea[#, 0.27548209366391163`]& ,
          TagBoxNote->"0.27548209366391163"],
         StyleBox["0.27548209366391163`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.27548209366391163`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.72, 0.}, {0.75, 0.27548209366391163`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{78.03802800189837, 91.703785002373}, {
            142.43750338168724`, 166.9535238686926}}],
          StatusArea[#, 0.27548209366391163`]& ,
          TagBoxNote->"0.27548209366391163"],
         StyleBox["0.27548209366391163`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.27548209366391163`, {
           GrayLevel[0]}], "Tooltip"]& ], {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.78, 0.}, {0.8099999999999999, 0.5509641873278253},
              "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{102.86954200284762`, 116.5352990033222}, {
            119.17148289468169`, 166.9535238686926}}],
          StatusArea[#, 0.5509641873278253]& ,
          TagBoxNote->"0.5509641873278253"],
         StyleBox["0.5509641873278253`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.5509641873278253, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.8099999999999999, 0.}, {0.84, 
             1.1019283746556465`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{115.2852990033222, 128.95105600379682`}, {
            72.6394419206711, 166.9535238686926}}],
          StatusArea[#, 1.1019283746556465`]& ,
          TagBoxNote->"1.1019283746556465"],
         StyleBox["1.1019283746556465`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.1019283746556465`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.84, 0.}, {0.87, 1.1019283746556465`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{127.70105600379682`, 141.36681300427145`}, {
            72.6394419206711, 166.9535238686926}}],
          StatusArea[#, 1.1019283746556465`]& ,
          TagBoxNote->"1.1019283746556465"],
         StyleBox["1.1019283746556465`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.1019283746556465`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.87, 0.}, {0.8999999999999999, 
             3.5812672176308644`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{140.11681300427145`, 
            153.78257000474602`}, {-136.75474246237835`, 166.9535238686926}}],
          StatusArea[#, 3.5812672176308644`]& ,
          TagBoxNote->"3.5812672176308644"],
         StyleBox["3.5812672176308644`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[3.5812672176308644`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.8999999999999999, 0.}, {0.9299999999999999, 
             1.6528925619834698`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{152.53257000474602`, 166.19832700522065`}, {
            26.107400946660363`, 166.9535238686926}}],
          StatusArea[#, 1.6528925619834698`]& ,
          TagBoxNote->"1.6528925619834698"],
         StyleBox["1.6528925619834698`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.6528925619834698`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.9299999999999999, 0.}, {0.96, 3.581267217630851}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{164.94832700522065`, 
            178.61408400569528`}, {-136.7547424623772, 166.9535238686926}}],
          StatusArea[#, 3.581267217630851]& ,
          TagBoxNote->"3.581267217630851"],
         StyleBox["3.581267217630851`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[3.581267217630851, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.96, 0.}, {0.99, 2.4793388429752046`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{177.36408400569528`, 
            191.02984100616985`}, {-43.69066051435573, 166.9535238686926}}],
          StatusArea[#, 2.4793388429752046`]& ,
          TagBoxNote->"2.4793388429752046"],
         StyleBox["2.4793388429752046`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.4793388429752046`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.99, 0.}, {1.02, 0.8264462809917349}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{189.77984100616985`, 203.44559800664447`}, {
            95.90546240767648, 166.9535238686926}}],
          StatusArea[#, 0.8264462809917349]& ,
          TagBoxNote->"0.8264462809917349"],
         StyleBox["0.8264462809917349`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8264462809917349, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.02, 0.}, {1.0499999999999998`, 
             1.6528925619834818`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{202.19559800664447`, 215.861355007119}, {
            26.10740094665934, 166.9535238686926}}],
          StatusArea[#, 1.6528925619834818`]& ,
          TagBoxNote->"1.6528925619834818"],
         StyleBox["1.6528925619834818`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.6528925619834818`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.0499999999999998`, 0.}, {1.08, 
             2.7548209366390957`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{214.611355007119, 
            228.27711200759373`}, {-66.95668100135939, 166.9535238686926}}],
          StatusArea[#, 2.7548209366390957`]& ,
          TagBoxNote->"2.7548209366390957"],
         StyleBox["2.7548209366390957`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.7548209366390957`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.08, 0.}, {1.1099999999999999`, 
             1.9283746556473955`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{227.02711200759373`, 240.69286900806824`}, {
            2.8413804596538057`, 166.9535238686926}}],
          StatusArea[#, 1.9283746556473955`]& ,
          TagBoxNote->"1.9283746556473955"],
         StyleBox["1.9283746556473955`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.9283746556473955`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.1099999999999999`, 0.}, {1.1400000000000001`, 
             1.3774104683195478`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{239.44286900806824`, 253.10862600854298`}, {
            49.37342143366661, 166.9535238686926}}],
          StatusArea[#, 1.3774104683195478`]& ,
          TagBoxNote->"1.3774104683195478"],
         StyleBox["1.3774104683195478`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.3774104683195478`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.1400000000000001`, 0.}, {1.17, 
             0.8264462809917409}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{251.85862600854298`, 265.52438300901747`}, {
            95.90546240767597, 166.9535238686926}}],
          StatusArea[#, 0.8264462809917409]& ,
          TagBoxNote->"0.8264462809917409"],
         StyleBox["0.8264462809917409`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8264462809917409, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.17, 0.}, {1.2, 1.6528925619834698`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{264.27438300901747`, 277.9401400094921}, {
            26.107400946660363`, 166.9535238686926}}],
          StatusArea[#, 1.6528925619834698`]& ,
          TagBoxNote->"1.6528925619834698"],
         StyleBox["1.6528925619834698`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.6528925619834698`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.2, 0.}, {1.23, 0.8264462809917349}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{276.6901400094921, 290.3558970099667}, {
            95.90546240767648, 166.9535238686926}}],
          StatusArea[#, 0.8264462809917349]& ,
          TagBoxNote->"0.8264462809917349"],
         StyleBox["0.8264462809917349`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8264462809917349, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.23, 0.}, {1.2599999999999998`, 
             1.9283746556473955`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{289.1058970099667, 302.77165401044124`}, {
            2.8413804596538057`, 166.9535238686926}}],
          StatusArea[#, 1.9283746556473955`]& ,
          TagBoxNote->"1.9283746556473955"],
         StyleBox["1.9283746556473955`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.9283746556473955`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.2599999999999998`, 0.}, {1.29, 
             1.1019283746556383`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{301.52165401044124`, 315.187411010916}, {
            72.6394419206718, 166.9535238686926}}],
          StatusArea[#, 1.1019283746556383`]& ,
          TagBoxNote->"1.1019283746556383"],
         StyleBox["1.1019283746556383`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.1019283746556383`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.29, 0.}, {1.3199999999999998`, 
             0.8264462809917409}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{313.937411010916, 327.6031680113905}, {
            95.90546240767597, 166.9535238686926}}],
          StatusArea[#, 0.8264462809917409]& ,
          TagBoxNote->"0.8264462809917409"],
         StyleBox["0.8264462809917409`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8264462809917409, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.3199999999999998`, 0.}, {1.35, 
             1.1019283746556383`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{326.3531680113905, 340.0189250118651}, {
            72.6394419206718, 166.9535238686926}}],
          StatusArea[#, 1.1019283746556383`]& ,
          TagBoxNote->"1.1019283746556383"],
         StyleBox["1.1019283746556383`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.1019283746556383`, {
           GrayLevel[0]}], "Tooltip"]& ], {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.38, 0.}, {1.41, 0.27548209366391163`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{351.18468201233975`, 364.85043901281426`}, {
            142.43750338168724`, 166.9535238686926}}],
          StatusArea[#, 0.27548209366391163`]& ,
          TagBoxNote->"0.27548209366391163"],
         StyleBox["0.27548209366391163`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.27548209366391163`, {
           GrayLevel[0]}], "Tooltip"]& ], {}, {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.47, 0.}, {1.5, 0.27548209366391163`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{388.4319530137635, 402.09771001423815`}, {
            142.43750338168724`, 166.9535238686926}}],
          StatusArea[#, 0.27548209366391163`]& ,
          TagBoxNote->"0.27548209366391163"],
         StyleBox["0.27548209366391163`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.27548209366391163`, {
           GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, {}, {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.6800000000000002`, 0.}, {1.71, 
             0.27548209366391363`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{475.3422520170859, 489.0080090175604}, {
            142.43750338168707`, 166.9535238686926}}],
          StatusArea[#, 0.27548209366391363`]& ,
          TagBoxNote->"0.27548209366391363"],
         StyleBox["0.27548209366391363`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.27548209366391363`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.71, 0.}, {1.7399999999999998`, 
             0.27548209366391363`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{487.7580090175604, 501.42376601803494`}, {
            142.43750338168707`, 166.9535238686926}}],
          StatusArea[#, 0.27548209366391363`]& ,
          TagBoxNote->"0.27548209366391363"],
         StyleBox["0.27548209366391363`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.27548209366391363`, {
           GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.8599999999999999`, 0.}, {1.89, 
             0.5509641873278233}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{549.8367940199334, 563.5025510204081}, {
            119.17148289468184`, 166.9535238686926}}],
          StatusArea[#, 0.5509641873278233]& ,
          TagBoxNote->"0.5509641873278233"],
         StyleBox["0.5509641873278233`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.5509641873278233, {
           GrayLevel[0]}], "Tooltip"]& ]}, {}, {}}, {{}, {}, 
      {RGBColor[1, 0, 0], AbsoluteThickness[2], LineBox[CompressedData["
1:eJwV13c8Vf8fB3B8VSqlFClFywhlJPRNXiJlZ1WSXSmjyJ4ZKUIoGkoiskKI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        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{
      FormBox["\"Flux, Jy\"", TraditionalForm], 
      FormBox["\"Probability\"", TraditionalForm]},
    AxesOrigin->{0.6, 0},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    ImageSize->500,
    PlotRange->{{0.6, 1.89}, {All, All}},
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.02], 
       Scaled[0.1]}},
    Ticks->{Automatic, Automatic}], ",", 
   RowBox[{"NormalDistribution", "[", 
    RowBox[{"1.0609090909090915`", ",", "0.20979328669072292`"}], "]"}], ",", 
   "0.0000721327621716985`"}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.5003978218924994`*^9, 3.5003978373454995`*^9}, {
   3.5003979038334994`*^9, 3.5003979274534993`*^9}, {3.500398027961499*^9, 
   3.5003980380784993`*^9}, {3.5003981236204996`*^9, 3.5003981686814995`*^9}, 
   3.500398209975499*^9, 3.501002347291*^9, 3.5016069469230003`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"13mm\"\>", ",", 
   GraphicsBox[{
     {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
      EdgeForm[Opacity[0.7]], {}, 
      {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
       EdgeForm[Opacity[0.7]], {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.6, 0.}, {0.6299999999999999, 
             0.26881720430107603`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{43.204931972789126`, 59.28486394557817}, {
            145.53963944662127`, 166.95352386869266`}}],
          StatusArea[#, 0.26881720430107603`]& ,
          TagBoxNote->"0.26881720430107603"],
         StyleBox["0.26881720430107603`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.26881720430107603`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.6299999999999999, 0.}, {0.6599999999999999, 
             0.26881720430107503`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{58.03486394557817, 74.11479591836732}, {
            145.53963944662132`, 166.95352386869266`}}],
          StatusArea[#, 0.26881720430107503`]& ,
          TagBoxNote->"0.26881720430107503"],
         StyleBox["0.26881720430107503`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.26881720430107503`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.6599999999999999, 0.}, {0.69, 0.5376344086021501},
              "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{72.86479591836732, 88.94472789115642}, {
            125.37575502455002`, 166.95352386869266`}}],
          StatusArea[#, 0.5376344086021501]& ,
          TagBoxNote->"0.5376344086021501"],
         StyleBox["0.5376344086021501`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.5376344086021501, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.69, 0.}, {0.72, 0.26881720430107503`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{87.69472789115642, 103.77465986394557`}, {
            145.53963944662132`, 166.95352386869266`}}],
          StatusArea[#, 0.26881720430107503`]& ,
          TagBoxNote->"0.26881720430107503"],
         StyleBox["0.26881720430107503`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.26881720430107503`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.72, 0.}, {0.75, 0.8064516129032252}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{102.52465986394557`, 118.60459183673473`}, {
            105.21187060247868`, 166.95352386869266`}}],
          StatusArea[#, 0.8064516129032252]& ,
          TagBoxNote->"0.8064516129032252"],
         StyleBox["0.8064516129032252`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8064516129032252, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.75, 0.}, {0.7799999999999999, 0.5376344086021521},
              "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{117.35459183673473`, 133.43452380952377`}, {
            125.37575502454987`, 166.95352386869266`}}],
          StatusArea[#, 0.5376344086021521]& ,
          TagBoxNote->"0.5376344086021521"],
         StyleBox["0.5376344086021521`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.5376344086021521, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.7799999999999999, 0.}, {0.8099999999999999, 
             1.6129032258064504`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{132.18452380952377`, 148.26445578231292`}, {
            44.720217336264724`, 166.95352386869266`}}],
          StatusArea[#, 1.6129032258064504`]& ,
          TagBoxNote->"1.6129032258064504"],
         StyleBox["1.6129032258064504`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.6129032258064504`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.8099999999999999, 0.}, {0.84, 
             1.6129032258064504`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{147.01445578231292`, 163.09438775510202`}, {
            44.720217336264724`, 166.95352386869266`}}],
          StatusArea[#, 1.6129032258064504`]& ,
          TagBoxNote->"1.6129032258064504"],
         StyleBox["1.6129032258064504`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.6129032258064504`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.84, 0.}, {0.8699999999999999, 
             4.0322580645161405`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{161.84438775510202`, 
            177.92431972789112`}, {-136.7547424623783, 166.95352386869266`}}],
          StatusArea[#, 4.0322580645161405`]& ,
          TagBoxNote->"4.0322580645161405"],
         StyleBox["4.0322580645161405`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[4.0322580645161405`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.8699999999999999, 0.}, {0.8999999999999999, 
             2.1505376344086002`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{176.67431972789112`, 192.75425170068021`}, {
            4.392448492122099, 166.95352386869266`}}],
          StatusArea[#, 2.1505376344086002`]& ,
          TagBoxNote->"2.1505376344086002"],
         StyleBox["2.1505376344086002`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.1505376344086002`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.8999999999999999, 0.}, {0.9299999999999999, 
             1.8817204301075254`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{191.50425170068021`, 207.58418367346937`}, {
            24.556332914193405`, 166.95352386869266`}}],
          StatusArea[#, 1.8817204301075254`]& ,
          TagBoxNote->"1.8817204301075254"],
         StyleBox["1.8817204301075254`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.8817204301075254`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.9299999999999999, 0.}, {0.96, 3.225806451612901}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{206.33418367346937`, 
            222.41411564625852`}, {-76.26308919616321, 166.95352386869266`}}],
          StatusArea[#, 3.225806451612901]& ,
          TagBoxNote->"3.225806451612901"],
         StyleBox["3.225806451612901`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[3.225806451612901, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.96, 0.}, {0.99, 1.6129032258064504`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{221.16411564625852`, 237.24404761904762`}, {
            44.720217336264724`, 166.95352386869266`}}],
          StatusArea[#, 1.6129032258064504`]& ,
          TagBoxNote->"1.6129032258064504"],
         StyleBox["1.6129032258064504`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.6129032258064504`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.99, 0.}, {1.02, 2.9569892473118258`}, 
             "RoundingRadius" -> 0]},
           ImageSizeCache->{{235.99404761904762`, 
            252.07397959183677`}, {-56.0992047740919, 166.95352386869266`}}],
          StatusArea[#, 2.9569892473118258`]& ,
          TagBoxNote->"2.9569892473118258"],
         StyleBox["2.9569892473118258`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.9569892473118258`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.02, 0.}, {1.0499999999999998`, 2.419354838709693},
              "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{250.82397959183677`, 
            266.9039115646258}, {-15.77143592995057, 166.95352386869266`}}],
          StatusArea[#, 2.419354838709693]& ,
          TagBoxNote->"2.419354838709693"],
         StyleBox["2.419354838709693`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.419354838709693, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.0499999999999998`, 0.}, {1.08, 
             1.8817204301075112`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{265.6539115646258, 281.73384353741494`}, {
            24.556332914194456`, 166.95352386869266`}}],
          StatusArea[#, 1.8817204301075112`]& ,
          TagBoxNote->"1.8817204301075112"],
         StyleBox["1.8817204301075112`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.8817204301075112`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.08, 0.}, {1.1099999999999999`, 1.344086021505385},
              "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{280.48384353741494`, 296.563775510204}, {
            64.88410175833532, 166.95352386869266`}}],
          StatusArea[#, 1.344086021505385]& ,
          TagBoxNote->"1.344086021505385"],
         StyleBox["1.344086021505385`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.344086021505385, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.1099999999999999`, 0.}, {1.14, 
             1.6129032258064504`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{295.313775510204, 311.39370748299314`}, {
            44.720217336264724`, 166.95352386869266`}}],
          StatusArea[#, 1.6129032258064504`]& ,
          TagBoxNote->"1.6129032258064504"],
         StyleBox["1.6129032258064504`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.6129032258064504`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.14, 0.}, {1.17, 0.5376344086021501}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{310.14370748299314`, 326.2236394557823}, {
            125.37575502455002`, 166.95352386869266`}}],
          StatusArea[#, 0.5376344086021501]& ,
          TagBoxNote->"0.5376344086021501"],
         StyleBox["0.5376344086021501`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.5376344086021501, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.17, 0.}, {1.2, 1.0752688172043001`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{324.9736394557823, 341.05357142857144`}, {
            85.04798618040738, 166.95352386869266`}}],
          StatusArea[#, 1.0752688172043001`]& ,
          TagBoxNote->"1.0752688172043001"],
         StyleBox["1.0752688172043001`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.0752688172043001`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.2, 0.}, {1.23, 0.8064516129032252}, 
             "RoundingRadius" -> 0]},
           ImageSizeCache->{{339.80357142857144`, 355.8835034013605}, {
            105.21187060247868`, 166.95352386869266`}}],
          StatusArea[#, 0.8064516129032252]& ,
          TagBoxNote->"0.8064516129032252"],
         StyleBox["0.8064516129032252`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8064516129032252, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.23, 0.}, {1.2599999999999998`, 0.806451612903231},
              "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{354.6335034013605, 370.7134353741495}, {
            105.21187060247826`, 166.95352386869266`}}],
          StatusArea[#, 0.806451612903231]& ,
          TagBoxNote->"0.806451612903231"],
         StyleBox["0.806451612903231`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.806451612903231, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.2599999999999998`, 0.}, {1.29, 
             0.26881720430107303`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{369.4634353741495, 385.5433673469388}, {
            145.5396394466215, 166.95352386869266`}}],
          StatusArea[#, 0.26881720430107303`]& ,
          TagBoxNote->"0.26881720430107303"],
         StyleBox["0.26881720430107303`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.26881720430107303`, {
           GrayLevel[0]}], "Tooltip"]& ], {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.3199999999999998`, 0.}, {1.35, 
             0.26881720430107303`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{399.12329931972783`, 415.2032312925171}, {
            145.5396394466215, 166.95352386869266`}}],
          StatusArea[#, 0.26881720430107303`]& ,
          TagBoxNote->"0.26881720430107303"],
         StyleBox["0.26881720430107303`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.26881720430107303`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.35, 0.}, {1.38, 0.268817204301077}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{413.9532312925171, 430.03316326530603`}, {
            145.53963944662118`, 166.95352386869266`}}],
          StatusArea[#, 0.268817204301077]& ,
          TagBoxNote->"0.268817204301077"],
         StyleBox["0.268817204301077`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.268817204301077, {
           GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, {}, {}, {}, {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.62, 0.}, {1.65, 0.268817204301077}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{547.4226190476192, 563.5025510204081}, {
            145.53963944662118`, 166.95352386869266`}}],
          StatusArea[#, 0.268817204301077]& ,
          TagBoxNote->"0.268817204301077"],
         StyleBox["0.268817204301077`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.268817204301077, {
           GrayLevel[0]}], "Tooltip"]& ]}, {}, {}}, {{}, {}, 
      {RGBColor[1, 0, 0], AbsoluteThickness[2], LineBox[CompressedData["
1:eJwVlnc8V/8Xx30+V1Lkm1GEBskqEmVUvG6KImRlVoqGEWkovg2iosyQhMoq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        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{
      FormBox["\"Flux, Jy\"", TraditionalForm], 
      FormBox["\"Probability\"", TraditionalForm]},
    AxesOrigin->{0.57, 0},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    ImageSize->500,
    PlotRange->{{0.57, 1.65}, {All, All}},
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.02], 
       Scaled[0.1]}},
    Ticks->{Automatic, Automatic}], ",", 
   RowBox[{"NormalDistribution", "[", 
    RowBox[{"0.9654032258064515`", ",", "0.16094679141571458`"}], "]"}], ",", 
   "0.1353931808575767`"}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.5003978218924994`*^9, 3.5003978373454995`*^9}, {
   3.5003979038334994`*^9, 3.5003979274534993`*^9}, {3.500398027961499*^9, 
   3.5003980380784993`*^9}, {3.5003981236204996`*^9, 3.5003981686814995`*^9}, 
   3.500398209975499*^9, 3.501002347291*^9, 3.501606946703*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"2cm\"\>", ",", 
   GraphicsBox[{
     {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
      EdgeForm[Opacity[0.7]], {}, 
      {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
       EdgeForm[Opacity[0.7]], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.6, 0.}, {0.63, 0.2898550724637679}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{28.375000000000114`, 50.980102040816405`}, {
            144.09936198790191`, 166.95352386869263`}}],
          StatusArea[#, 0.2898550724637679]& ,
          TagBoxNote->"0.2898550724637679"],
         StyleBox["0.2898550724637679`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.2898550724637679, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.63, 0.}, {0.6599999999999999, 0.5797101449275379},
              "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{49.730102040816405`, 72.3352040816327}, {
            122.49520010711106`, 166.95352386869263`}}],
          StatusArea[#, 0.5797101449275379]& ,
          TagBoxNote->"0.5797101449275379"],
         StyleBox["0.5797101449275379`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.5797101449275379, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.6599999999999999, 0.}, {0.69, 
             1.1594202898550716`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{71.0852040816327, 93.69030612244904}, {
            79.2868763455298, 166.95352386869263`}}],
          StatusArea[#, 1.1594202898550716`]& ,
          TagBoxNote->"1.1594202898550716"],
         StyleBox["1.1594202898550716`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.1594202898550716`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.69, 0.}, {0.72, 1.7391304347826073`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{92.44030612244904, 115.04540816326545`}, {
            36.07855258394841, 166.95352386869263`}}],
          StatusArea[#, 1.7391304347826073`]& ,
          TagBoxNote->"1.7391304347826073"],
         StyleBox["1.7391304347826073`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.7391304347826073`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.72, 0.}, {0.75, 2.3188405797101432`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{113.79540816326545`, 
            136.40051020408174`}, {-7.1297711776330175`, 
            166.95352386869263`}}],
          StatusArea[#, 2.3188405797101432`]& ,
          TagBoxNote->"2.3188405797101432"],
         StyleBox["2.3188405797101432`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.3188405797101432`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.75, 0.}, {0.78, 3.188405797101447}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{135.15051020408174`, 
            157.75561224489803`}, {-71.94225682000513, 166.95352386869263`}}],
          StatusArea[#, 3.188405797101447]& ,
          TagBoxNote->"3.188405797101447"],
         StyleBox["3.188405797101447`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[3.188405797101447, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.78, 0.}, {0.8099999999999999, 
             2.3188405797101517`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{156.50561224489803`, 
            179.11071428571432`}, {-7.129771177633643, 166.95352386869263`}}],
          StatusArea[#, 2.3188405797101517`]& ,
          TagBoxNote->"2.3188405797101517"],
         StyleBox["2.3188405797101517`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.3188405797101517`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.8099999999999999, 0.}, {0.84, 
             2.3188405797101432`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{177.86071428571432`, 
            200.46581632653073`}, {-7.1297711776330175`, 
            166.95352386869263`}}],
          StatusArea[#, 2.3188405797101432`]& ,
          TagBoxNote->"2.3188405797101432"],
         StyleBox["2.3188405797101432`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.3188405797101432`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.84, 0.}, {0.87, 2.898550724637679}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{199.21581632653073`, 
            221.82091836734702`}, {-50.338094939214415`, 
            166.95352386869263`}}],
          StatusArea[#, 2.898550724637679]& ,
          TagBoxNote->"2.898550724637679"],
         StyleBox["2.898550724637679`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.898550724637679, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.87, 0.}, {0.8999999999999999, 4.057971014492765}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{220.57091836734702`, 
            243.1760204081633}, {-136.75474246237837`, 166.95352386869263`}}],
          StatusArea[#, 4.057971014492765]& ,
          TagBoxNote->"4.057971014492765"],
         StyleBox["4.057971014492765`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[4.057971014492765, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.8999999999999999, 0.}, {0.9299999999999999, 
             3.7681159420289827`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{241.9260204081633, 
            264.5311224489797}, {-115.15058058158655`, 166.95352386869263`}}],
          StatusArea[#, 3.7681159420289827`]& ,
          TagBoxNote->"3.7681159420289827"],
         StyleBox["3.7681159420289827`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[3.7681159420289827`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.9299999999999999, 0.}, {0.96, 
             2.3188405797101432`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{263.2811224489797, 
            285.886224489796}, {-7.1297711776330175`, 166.95352386869263`}}],
          StatusArea[#, 2.3188405797101432`]& ,
          TagBoxNote->"2.3188405797101432"],
         StyleBox["2.3188405797101432`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.3188405797101432`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.96, 0.}, {0.99, 1.4492753623188395`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{284.636224489796, 307.2413265306124}, {
            57.68271446473911, 166.95352386869263`}}],
          StatusArea[#, 1.4492753623188395`]& ,
          TagBoxNote->"1.4492753623188395"],
         StyleBox["1.4492753623188395`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.4492753623188395`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.99, 0.}, {1.02, 0.8695652173913037}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{305.9913265306124, 328.5964285714287}, {
            100.89103822632052`, 166.95352386869263`}}],
          StatusArea[#, 0.8695652173913037]& ,
          TagBoxNote->"0.8695652173913037"],
         StyleBox["0.8695652173913037`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8695652173913037, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.02, 0.}, {1.0499999999999998`, 0.57971014492754}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{327.3464285714287, 349.9515306122449}, {
            122.4952001071109, 166.95352386869263`}}],
          StatusArea[#, 0.57971014492754]& ,
          TagBoxNote->"0.57971014492754"],
         StyleBox["0.57971014492754`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.57971014492754, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.0499999999999998`, 0.}, {1.08, 
             0.8695652173912971}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{348.7015306122449, 371.3066326530614}, {
            100.891038226321, 166.95352386869263`}}],
          StatusArea[#, 0.8695652173912971]& ,
          TagBoxNote->"0.8695652173912971"],
         StyleBox["0.8695652173912971`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8695652173912971, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.08, 0.}, {1.1099999999999999`, 
             0.8695652173913099}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{370.0566326530614, 392.6617346938776}, {
            100.89103822632005`, 166.95352386869263`}}],
          StatusArea[#, 0.8695652173913099]& ,
          TagBoxNote->"0.8695652173913099"],
         StyleBox["0.8695652173913099`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8695652173913099, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.1099999999999999`, 0.}, {1.1400000000000001`, 
             0.28985507246376574`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{391.4117346938776, 414.0168367346941}, {
            144.09936198790209`, 166.95352386869263`}}],
          StatusArea[#, 0.28985507246376574`]& ,
          TagBoxNote->"0.28985507246376574"],
         StyleBox["0.28985507246376574`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.28985507246376574`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.1400000000000001`, 0.}, {1.17, 0.28985507246377}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{412.7668367346941, 435.3719387755103}, {
            144.09936198790177`, 166.95352386869263`}}],
          StatusArea[#, 0.28985507246377]& ,
          TagBoxNote->"0.28985507246377"],
         StyleBox["0.28985507246377`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.28985507246377, {
           GrayLevel[0]}], "Tooltip"]& ], {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.2, 0.}, {1.23, 0.2898550724637679}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{455.4770408163267, 478.08214285714297`}, {
            144.09936198790191`, 166.95352386869263`}}],
          StatusArea[#, 0.2898550724637679]& ,
          TagBoxNote->"0.2898550724637679"],
         StyleBox["0.2898550724637679`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.2898550724637679, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.23, 0.}, {1.2599999999999998`, 0.57971014492754}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{476.83214285714297`, 499.43724489795915`}, {
            122.4952001071109, 166.95352386869263`}}],
          StatusArea[#, 0.57971014492754]& ,
          TagBoxNote->"0.57971014492754"],
         StyleBox["0.57971014492754`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.57971014492754, {
           GrayLevel[0]}], "Tooltip"]& ], {}, {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.3199999999999998`, 0.}, {1.3499999999999999`, 
             0.2898550724637679}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{540.8974489795919, 563.5025510204082}, {
            144.09936198790191`, 166.95352386869263`}}],
          StatusArea[#, 0.2898550724637679]& ,
          TagBoxNote->"0.2898550724637679"],
         StyleBox["0.2898550724637679`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.2898550724637679, {
           GrayLevel[0]}], "Tooltip"]& ]}, {}, {}}, {{}, {}, 
      {RGBColor[1, 0, 0], AbsoluteThickness[2], LineBox[CompressedData["
1:eJwV1nc8le8bB3DCeYxEZCRJVkLLqqzrRimSRKISJQ3KaBCqb8kImVFZyV7Z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        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{
      FormBox["\"Flux, Jy\"", TraditionalForm], 
      FormBox["\"Probability\"", TraditionalForm]},
    AxesOrigin->{0.6, 0},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    ImageSize->500,
    PlotRange->{{0.6, 1.3499999999999999`}, {All, All}},
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.02], 
       Scaled[0.1]}},
    Ticks->{Automatic, Automatic}], ",", 
   RowBox[{"NormalDistribution", "[", 
    RowBox[{"0.8671304347826084`", ",", "0.13417551916534265`"}], "]"}], ",", 
   "0.01843162287730411`"}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.5003978218924994`*^9, 3.5003978373454995`*^9}, {
   3.5003979038334994`*^9, 3.5003979274534993`*^9}, {3.500398027961499*^9, 
   3.5003980380784993`*^9}, {3.5003981236204996`*^9, 3.5003981686814995`*^9}, 
   3.500398209975499*^9, 3.501002347291*^9, 3.501606946494*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"2cm\"\>", ",", 
   GraphicsBox[{
     {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
      EdgeForm[Opacity[0.7]], {}, 
      {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
       EdgeForm[Opacity[0.7]], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.6, 0.}, {0.63, 0.2898550724637679}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{28.375000000000114`, 50.980102040816405`}, {
            144.09936198790191`, 166.95352386869263`}}],
          StatusArea[#, 0.2898550724637679]& ,
          TagBoxNote->"0.2898550724637679"],
         StyleBox["0.2898550724637679`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.2898550724637679, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.63, 0.}, {0.6599999999999999, 0.5797101449275379},
              "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{49.730102040816405`, 72.3352040816327}, {
            122.49520010711106`, 166.95352386869263`}}],
          StatusArea[#, 0.5797101449275379]& ,
          TagBoxNote->"0.5797101449275379"],
         StyleBox["0.5797101449275379`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.5797101449275379, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.6599999999999999, 0.}, {0.69, 
             1.1594202898550716`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{71.0852040816327, 93.69030612244904}, {
            79.2868763455298, 166.95352386869263`}}],
          StatusArea[#, 1.1594202898550716`]& ,
          TagBoxNote->"1.1594202898550716"],
         StyleBox["1.1594202898550716`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.1594202898550716`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.69, 0.}, {0.72, 1.7391304347826073`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{92.44030612244904, 115.04540816326545`}, {
            36.07855258394841, 166.95352386869263`}}],
          StatusArea[#, 1.7391304347826073`]& ,
          TagBoxNote->"1.7391304347826073"],
         StyleBox["1.7391304347826073`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.7391304347826073`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.72, 0.}, {0.75, 2.3188405797101432`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{113.79540816326545`, 
            136.40051020408174`}, {-7.1297711776330175`, 
            166.95352386869263`}}],
          StatusArea[#, 2.3188405797101432`]& ,
          TagBoxNote->"2.3188405797101432"],
         StyleBox["2.3188405797101432`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.3188405797101432`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.75, 0.}, {0.78, 3.188405797101447}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{135.15051020408174`, 
            157.75561224489803`}, {-71.94225682000513, 166.95352386869263`}}],
          StatusArea[#, 3.188405797101447]& ,
          TagBoxNote->"3.188405797101447"],
         StyleBox["3.188405797101447`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[3.188405797101447, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.78, 0.}, {0.8099999999999999, 
             2.3188405797101517`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{156.50561224489803`, 
            179.11071428571432`}, {-7.129771177633643, 166.95352386869263`}}],
          StatusArea[#, 2.3188405797101517`]& ,
          TagBoxNote->"2.3188405797101517"],
         StyleBox["2.3188405797101517`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.3188405797101517`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.8099999999999999, 0.}, {0.84, 
             2.3188405797101432`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{177.86071428571432`, 
            200.46581632653073`}, {-7.1297711776330175`, 
            166.95352386869263`}}],
          StatusArea[#, 2.3188405797101432`]& ,
          TagBoxNote->"2.3188405797101432"],
         StyleBox["2.3188405797101432`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.3188405797101432`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.84, 0.}, {0.87, 2.898550724637679}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{199.21581632653073`, 
            221.82091836734702`}, {-50.338094939214415`, 
            166.95352386869263`}}],
          StatusArea[#, 2.898550724637679]& ,
          TagBoxNote->"2.898550724637679"],
         StyleBox["2.898550724637679`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.898550724637679, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.87, 0.}, {0.8999999999999999, 4.057971014492765}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{220.57091836734702`, 
            243.1760204081633}, {-136.75474246237837`, 166.95352386869263`}}],
          StatusArea[#, 4.057971014492765]& ,
          TagBoxNote->"4.057971014492765"],
         StyleBox["4.057971014492765`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[4.057971014492765, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.8999999999999999, 0.}, {0.9299999999999999, 
             3.7681159420289827`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{241.9260204081633, 
            264.5311224489797}, {-115.15058058158655`, 166.95352386869263`}}],
          StatusArea[#, 3.7681159420289827`]& ,
          TagBoxNote->"3.7681159420289827"],
         StyleBox["3.7681159420289827`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[3.7681159420289827`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.9299999999999999, 0.}, {0.96, 
             2.3188405797101432`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{263.2811224489797, 
            285.886224489796}, {-7.1297711776330175`, 166.95352386869263`}}],
          StatusArea[#, 2.3188405797101432`]& ,
          TagBoxNote->"2.3188405797101432"],
         StyleBox["2.3188405797101432`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.3188405797101432`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.96, 0.}, {0.99, 1.4492753623188395`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{284.636224489796, 307.2413265306124}, {
            57.68271446473911, 166.95352386869263`}}],
          StatusArea[#, 1.4492753623188395`]& ,
          TagBoxNote->"1.4492753623188395"],
         StyleBox["1.4492753623188395`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.4492753623188395`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.99, 0.}, {1.02, 0.8695652173913037}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{305.9913265306124, 328.5964285714287}, {
            100.89103822632052`, 166.95352386869263`}}],
          StatusArea[#, 0.8695652173913037]& ,
          TagBoxNote->"0.8695652173913037"],
         StyleBox["0.8695652173913037`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8695652173913037, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.02, 0.}, {1.0499999999999998`, 0.57971014492754}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{327.3464285714287, 349.9515306122449}, {
            122.4952001071109, 166.95352386869263`}}],
          StatusArea[#, 0.57971014492754]& ,
          TagBoxNote->"0.57971014492754"],
         StyleBox["0.57971014492754`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.57971014492754, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.0499999999999998`, 0.}, {1.08, 
             0.8695652173912971}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{348.7015306122449, 371.3066326530614}, {
            100.891038226321, 166.95352386869263`}}],
          StatusArea[#, 0.8695652173912971]& ,
          TagBoxNote->"0.8695652173912971"],
         StyleBox["0.8695652173912971`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8695652173912971, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.08, 0.}, {1.1099999999999999`, 
             0.8695652173913099}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{370.0566326530614, 392.6617346938776}, {
            100.89103822632005`, 166.95352386869263`}}],
          StatusArea[#, 0.8695652173913099]& ,
          TagBoxNote->"0.8695652173913099"],
         StyleBox["0.8695652173913099`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8695652173913099, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.1099999999999999`, 0.}, {1.1400000000000001`, 
             0.28985507246376574`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{391.4117346938776, 414.0168367346941}, {
            144.09936198790209`, 166.95352386869263`}}],
          StatusArea[#, 0.28985507246376574`]& ,
          TagBoxNote->"0.28985507246376574"],
         StyleBox["0.28985507246376574`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.28985507246376574`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.1400000000000001`, 0.}, {1.17, 0.28985507246377}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{412.7668367346941, 435.3719387755103}, {
            144.09936198790177`, 166.95352386869263`}}],
          StatusArea[#, 0.28985507246377]& ,
          TagBoxNote->"0.28985507246377"],
         StyleBox["0.28985507246377`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.28985507246377, {
           GrayLevel[0]}], "Tooltip"]& ], {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.2, 0.}, {1.23, 0.2898550724637679}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{455.4770408163267, 478.08214285714297`}, {
            144.09936198790191`, 166.95352386869263`}}],
          StatusArea[#, 0.2898550724637679]& ,
          TagBoxNote->"0.2898550724637679"],
         StyleBox["0.2898550724637679`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.2898550724637679, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.23, 0.}, {1.2599999999999998`, 0.57971014492754}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{476.83214285714297`, 499.43724489795915`}, {
            122.4952001071109, 166.95352386869263`}}],
          StatusArea[#, 0.57971014492754]& ,
          TagBoxNote->"0.57971014492754"],
         StyleBox["0.57971014492754`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.57971014492754, {
           GrayLevel[0]}], "Tooltip"]& ], {}, {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.3199999999999998`, 0.}, {1.3499999999999999`, 
             0.2898550724637679}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{540.8974489795919, 563.5025510204082}, {
            144.09936198790191`, 166.95352386869263`}}],
          StatusArea[#, 0.2898550724637679]& ,
          TagBoxNote->"0.2898550724637679"],
         StyleBox["0.2898550724637679`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.2898550724637679, {
           GrayLevel[0]}], "Tooltip"]& ]}, {}, {}}, {{}, {}, 
      {RGBColor[1, 0, 0], AbsoluteThickness[2], LineBox[CompressedData["
1:eJwV1nc8le8bB3DCeYxEZCRJVkLLqqzrRimSRKISJQ3KaBCqb8kImVFZyV7Z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        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{
      FormBox["\"Flux, Jy\"", TraditionalForm], 
      FormBox["\"Probability\"", TraditionalForm]},
    AxesOrigin->{0.6, 0},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    ImageSize->500,
    PlotRange->{{0.6, 1.3499999999999999`}, {All, All}},
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.02], 
       Scaled[0.1]}},
    Ticks->{Automatic, Automatic}], ",", 
   RowBox[{"NormalDistribution", "[", 
    RowBox[{"0.8671304347826084`", ",", "0.13417551916534265`"}], "]"}], ",", 
   "0.01843162287730411`"}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.5003978218924994`*^9, 3.5003978373454995`*^9}, {
   3.5003979038334994`*^9, 3.5003979274534993`*^9}, {3.500398027961499*^9, 
   3.5003980380784993`*^9}, {3.5003981236204996`*^9, 3.5003981686814995`*^9}, 
   3.500398209975499*^9, 3.501002347291*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"13mm\"\>", ",", 
   GraphicsBox[{
     {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
      EdgeForm[Opacity[0.7]], {}, 
      {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
       EdgeForm[Opacity[0.7]], {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.6, 0.}, {0.6299999999999999, 
             0.26881720430107603`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{43.204931972789126`, 59.28486394557817}, {
            145.53963944662127`, 166.95352386869266`}}],
          StatusArea[#, 0.26881720430107603`]& ,
          TagBoxNote->"0.26881720430107603"],
         StyleBox["0.26881720430107603`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.26881720430107603`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.6299999999999999, 0.}, {0.6599999999999999, 
             0.26881720430107503`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{58.03486394557817, 74.11479591836732}, {
            145.53963944662132`, 166.95352386869266`}}],
          StatusArea[#, 0.26881720430107503`]& ,
          TagBoxNote->"0.26881720430107503"],
         StyleBox["0.26881720430107503`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.26881720430107503`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.6599999999999999, 0.}, {0.69, 0.5376344086021501},
              "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{72.86479591836732, 88.94472789115642}, {
            125.37575502455002`, 166.95352386869266`}}],
          StatusArea[#, 0.5376344086021501]& ,
          TagBoxNote->"0.5376344086021501"],
         StyleBox["0.5376344086021501`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.5376344086021501, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.69, 0.}, {0.72, 0.26881720430107503`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{87.69472789115642, 103.77465986394557`}, {
            145.53963944662132`, 166.95352386869266`}}],
          StatusArea[#, 0.26881720430107503`]& ,
          TagBoxNote->"0.26881720430107503"],
         StyleBox["0.26881720430107503`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.26881720430107503`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.72, 0.}, {0.75, 0.8064516129032252}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{102.52465986394557`, 118.60459183673473`}, {
            105.21187060247868`, 166.95352386869266`}}],
          StatusArea[#, 0.8064516129032252]& ,
          TagBoxNote->"0.8064516129032252"],
         StyleBox["0.8064516129032252`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8064516129032252, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.75, 0.}, {0.7799999999999999, 0.5376344086021521},
              "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{117.35459183673473`, 133.43452380952377`}, {
            125.37575502454987`, 166.95352386869266`}}],
          StatusArea[#, 0.5376344086021521]& ,
          TagBoxNote->"0.5376344086021521"],
         StyleBox["0.5376344086021521`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.5376344086021521, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.7799999999999999, 0.}, {0.8099999999999999, 
             1.6129032258064504`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{132.18452380952377`, 148.26445578231292`}, {
            44.720217336264724`, 166.95352386869266`}}],
          StatusArea[#, 1.6129032258064504`]& ,
          TagBoxNote->"1.6129032258064504"],
         StyleBox["1.6129032258064504`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.6129032258064504`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.8099999999999999, 0.}, {0.84, 
             1.6129032258064504`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{147.01445578231292`, 163.09438775510202`}, {
            44.720217336264724`, 166.95352386869266`}}],
          StatusArea[#, 1.6129032258064504`]& ,
          TagBoxNote->"1.6129032258064504"],
         StyleBox["1.6129032258064504`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.6129032258064504`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.84, 0.}, {0.8699999999999999, 
             4.0322580645161405`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{161.84438775510202`, 
            177.92431972789112`}, {-136.7547424623783, 166.95352386869266`}}],
          StatusArea[#, 4.0322580645161405`]& ,
          TagBoxNote->"4.0322580645161405"],
         StyleBox["4.0322580645161405`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[4.0322580645161405`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.8699999999999999, 0.}, {0.8999999999999999, 
             2.1505376344086002`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{176.67431972789112`, 192.75425170068021`}, {
            4.392448492122099, 166.95352386869266`}}],
          StatusArea[#, 2.1505376344086002`]& ,
          TagBoxNote->"2.1505376344086002"],
         StyleBox["2.1505376344086002`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.1505376344086002`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.8999999999999999, 0.}, {0.9299999999999999, 
             1.8817204301075254`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{191.50425170068021`, 207.58418367346937`}, {
            24.556332914193405`, 166.95352386869266`}}],
          StatusArea[#, 1.8817204301075254`]& ,
          TagBoxNote->"1.8817204301075254"],
         StyleBox["1.8817204301075254`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.8817204301075254`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.9299999999999999, 0.}, {0.96, 3.225806451612901}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{206.33418367346937`, 
            222.41411564625852`}, {-76.26308919616321, 166.95352386869266`}}],
          StatusArea[#, 3.225806451612901]& ,
          TagBoxNote->"3.225806451612901"],
         StyleBox["3.225806451612901`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[3.225806451612901, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.96, 0.}, {0.99, 1.6129032258064504`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{221.16411564625852`, 237.24404761904762`}, {
            44.720217336264724`, 166.95352386869266`}}],
          StatusArea[#, 1.6129032258064504`]& ,
          TagBoxNote->"1.6129032258064504"],
         StyleBox["1.6129032258064504`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.6129032258064504`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.99, 0.}, {1.02, 2.9569892473118258`}, 
             "RoundingRadius" -> 0]},
           ImageSizeCache->{{235.99404761904762`, 
            252.07397959183677`}, {-56.0992047740919, 166.95352386869266`}}],
          StatusArea[#, 2.9569892473118258`]& ,
          TagBoxNote->"2.9569892473118258"],
         StyleBox["2.9569892473118258`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.9569892473118258`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.02, 0.}, {1.0499999999999998`, 2.419354838709693},
              "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{250.82397959183677`, 
            266.9039115646258}, {-15.77143592995057, 166.95352386869266`}}],
          StatusArea[#, 2.419354838709693]& ,
          TagBoxNote->"2.419354838709693"],
         StyleBox["2.419354838709693`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.419354838709693, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.0499999999999998`, 0.}, {1.08, 
             1.8817204301075112`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{265.6539115646258, 281.73384353741494`}, {
            24.556332914194456`, 166.95352386869266`}}],
          StatusArea[#, 1.8817204301075112`]& ,
          TagBoxNote->"1.8817204301075112"],
         StyleBox["1.8817204301075112`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.8817204301075112`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.08, 0.}, {1.1099999999999999`, 1.344086021505385},
              "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{280.48384353741494`, 296.563775510204}, {
            64.88410175833532, 166.95352386869266`}}],
          StatusArea[#, 1.344086021505385]& ,
          TagBoxNote->"1.344086021505385"],
         StyleBox["1.344086021505385`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.344086021505385, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.1099999999999999`, 0.}, {1.14, 
             1.6129032258064504`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{295.313775510204, 311.39370748299314`}, {
            44.720217336264724`, 166.95352386869266`}}],
          StatusArea[#, 1.6129032258064504`]& ,
          TagBoxNote->"1.6129032258064504"],
         StyleBox["1.6129032258064504`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.6129032258064504`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.14, 0.}, {1.17, 0.5376344086021501}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{310.14370748299314`, 326.2236394557823}, {
            125.37575502455002`, 166.95352386869266`}}],
          StatusArea[#, 0.5376344086021501]& ,
          TagBoxNote->"0.5376344086021501"],
         StyleBox["0.5376344086021501`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.5376344086021501, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.17, 0.}, {1.2, 1.0752688172043001`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{324.9736394557823, 341.05357142857144`}, {
            85.04798618040738, 166.95352386869266`}}],
          StatusArea[#, 1.0752688172043001`]& ,
          TagBoxNote->"1.0752688172043001"],
         StyleBox["1.0752688172043001`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.0752688172043001`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.2, 0.}, {1.23, 0.8064516129032252}, 
             "RoundingRadius" -> 0]},
           ImageSizeCache->{{339.80357142857144`, 355.8835034013605}, {
            105.21187060247868`, 166.95352386869266`}}],
          StatusArea[#, 0.8064516129032252]& ,
          TagBoxNote->"0.8064516129032252"],
         StyleBox["0.8064516129032252`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8064516129032252, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.23, 0.}, {1.2599999999999998`, 0.806451612903231},
              "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{354.6335034013605, 370.7134353741495}, {
            105.21187060247826`, 166.95352386869266`}}],
          StatusArea[#, 0.806451612903231]& ,
          TagBoxNote->"0.806451612903231"],
         StyleBox["0.806451612903231`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.806451612903231, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.2599999999999998`, 0.}, {1.29, 
             0.26881720430107303`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{369.4634353741495, 385.5433673469388}, {
            145.5396394466215, 166.95352386869266`}}],
          StatusArea[#, 0.26881720430107303`]& ,
          TagBoxNote->"0.26881720430107303"],
         StyleBox["0.26881720430107303`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.26881720430107303`, {
           GrayLevel[0]}], "Tooltip"]& ], {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.3199999999999998`, 0.}, {1.35, 
             0.26881720430107303`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{399.12329931972783`, 415.2032312925171}, {
            145.5396394466215, 166.95352386869266`}}],
          StatusArea[#, 0.26881720430107303`]& ,
          TagBoxNote->"0.26881720430107303"],
         StyleBox["0.26881720430107303`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.26881720430107303`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.35, 0.}, {1.38, 0.268817204301077}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{413.9532312925171, 430.03316326530603`}, {
            145.53963944662118`, 166.95352386869266`}}],
          StatusArea[#, 0.268817204301077]& ,
          TagBoxNote->"0.268817204301077"],
         StyleBox["0.268817204301077`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.268817204301077, {
           GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, {}, {}, {}, {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.62, 0.}, {1.65, 0.268817204301077}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{547.4226190476192, 563.5025510204081}, {
            145.53963944662118`, 166.95352386869266`}}],
          StatusArea[#, 0.268817204301077]& ,
          TagBoxNote->"0.268817204301077"],
         StyleBox["0.268817204301077`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.268817204301077, {
           GrayLevel[0]}], "Tooltip"]& ]}, {}, {}}, {{}, {}, 
      {RGBColor[1, 0, 0], AbsoluteThickness[2], LineBox[CompressedData["
1:eJwVlnc8V/8Xx30+V1Lkm1GEBskqEmVUvG6KImRlVoqGEWkovg2iosyQhMoq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        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{
      FormBox["\"Flux, Jy\"", TraditionalForm], 
      FormBox["\"Probability\"", TraditionalForm]},
    AxesOrigin->{0.57, 0},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    ImageSize->500,
    PlotRange->{{0.57, 1.65}, {All, All}},
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.02], 
       Scaled[0.1]}},
    Ticks->{Automatic, Automatic}], ",", 
   RowBox[{"NormalDistribution", "[", 
    RowBox[{"0.9654032258064515`", ",", "0.16094679141571458`"}], "]"}], ",", 
   "0.1353931808575767`"}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.5003978218924994`*^9, 3.5003978373454995`*^9}, {
   3.5003979038334994`*^9, 3.5003979274534993`*^9}, {3.500398027961499*^9, 
   3.5003980380784993`*^9}, {3.5003981236204996`*^9, 3.5003981686814995`*^9}, 
   3.5003982102034993`*^9, 3.501002347315*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"7mm\"\>", ",", 
   GraphicsBox[{
     {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
      EdgeForm[Opacity[0.7]], {}, 
      {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
       EdgeForm[Opacity[0.7]], {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.63, 0.}, {0.6599999999999999, 
             0.27548209366391263`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{40.7907570004746, 54.45651400094917}, {
            142.43750338168715`, 166.9535238686926}}],
          StatusArea[#, 0.27548209366391263`]& ,
          TagBoxNote->"0.27548209366391263"],
         StyleBox["0.27548209366391263`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.27548209366391263`, {
           GrayLevel[0]}], "Tooltip"]& ], {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.69, 0.}, {0.72, 0.27548209366391163`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{65.6222710014238, 79.28802800189837}, {
            142.43750338168724`, 166.9535238686926}}],
          StatusArea[#, 0.27548209366391163`]& ,
          TagBoxNote->"0.27548209366391163"],
         StyleBox["0.27548209366391163`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.27548209366391163`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.72, 0.}, {0.75, 0.27548209366391163`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{78.03802800189837, 91.703785002373}, {
            142.43750338168724`, 166.9535238686926}}],
          StatusArea[#, 0.27548209366391163`]& ,
          TagBoxNote->"0.27548209366391163"],
         StyleBox["0.27548209366391163`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.27548209366391163`, {
           GrayLevel[0]}], "Tooltip"]& ], {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.78, 0.}, {0.8099999999999999, 0.5509641873278253},
              "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{102.86954200284762`, 116.5352990033222}, {
            119.17148289468169`, 166.9535238686926}}],
          StatusArea[#, 0.5509641873278253]& ,
          TagBoxNote->"0.5509641873278253"],
         StyleBox["0.5509641873278253`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.5509641873278253, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.8099999999999999, 0.}, {0.84, 
             1.1019283746556465`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{115.2852990033222, 128.95105600379682`}, {
            72.6394419206711, 166.9535238686926}}],
          StatusArea[#, 1.1019283746556465`]& ,
          TagBoxNote->"1.1019283746556465"],
         StyleBox["1.1019283746556465`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.1019283746556465`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.84, 0.}, {0.87, 1.1019283746556465`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{127.70105600379682`, 141.36681300427145`}, {
            72.6394419206711, 166.9535238686926}}],
          StatusArea[#, 1.1019283746556465`]& ,
          TagBoxNote->"1.1019283746556465"],
         StyleBox["1.1019283746556465`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.1019283746556465`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.87, 0.}, {0.8999999999999999, 
             3.5812672176308644`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{140.11681300427145`, 
            153.78257000474602`}, {-136.75474246237835`, 166.9535238686926}}],
          StatusArea[#, 3.5812672176308644`]& ,
          TagBoxNote->"3.5812672176308644"],
         StyleBox["3.5812672176308644`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[3.5812672176308644`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.8999999999999999, 0.}, {0.9299999999999999, 
             1.6528925619834698`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{152.53257000474602`, 166.19832700522065`}, {
            26.107400946660363`, 166.9535238686926}}],
          StatusArea[#, 1.6528925619834698`]& ,
          TagBoxNote->"1.6528925619834698"],
         StyleBox["1.6528925619834698`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.6528925619834698`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.9299999999999999, 0.}, {0.96, 3.581267217630851}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{164.94832700522065`, 
            178.61408400569528`}, {-136.7547424623772, 166.9535238686926}}],
          StatusArea[#, 3.581267217630851]& ,
          TagBoxNote->"3.581267217630851"],
         StyleBox["3.581267217630851`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[3.581267217630851, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.96, 0.}, {0.99, 2.4793388429752046`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{177.36408400569528`, 
            191.02984100616985`}, {-43.69066051435573, 166.9535238686926}}],
          StatusArea[#, 2.4793388429752046`]& ,
          TagBoxNote->"2.4793388429752046"],
         StyleBox["2.4793388429752046`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.4793388429752046`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.99, 0.}, {1.02, 0.8264462809917349}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{189.77984100616985`, 203.44559800664447`}, {
            95.90546240767648, 166.9535238686926}}],
          StatusArea[#, 0.8264462809917349]& ,
          TagBoxNote->"0.8264462809917349"],
         StyleBox["0.8264462809917349`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8264462809917349, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.02, 0.}, {1.0499999999999998`, 
             1.6528925619834818`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{202.19559800664447`, 215.861355007119}, {
            26.10740094665934, 166.9535238686926}}],
          StatusArea[#, 1.6528925619834818`]& ,
          TagBoxNote->"1.6528925619834818"],
         StyleBox["1.6528925619834818`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.6528925619834818`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.0499999999999998`, 0.}, {1.08, 
             2.7548209366390957`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{214.611355007119, 
            228.27711200759373`}, {-66.95668100135939, 166.9535238686926}}],
          StatusArea[#, 2.7548209366390957`]& ,
          TagBoxNote->"2.7548209366390957"],
         StyleBox["2.7548209366390957`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.7548209366390957`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.08, 0.}, {1.1099999999999999`, 
             1.9283746556473955`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{227.02711200759373`, 240.69286900806824`}, {
            2.8413804596538057`, 166.9535238686926}}],
          StatusArea[#, 1.9283746556473955`]& ,
          TagBoxNote->"1.9283746556473955"],
         StyleBox["1.9283746556473955`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.9283746556473955`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.1099999999999999`, 0.}, {1.1400000000000001`, 
             1.3774104683195478`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{239.44286900806824`, 253.10862600854298`}, {
            49.37342143366661, 166.9535238686926}}],
          StatusArea[#, 1.3774104683195478`]& ,
          TagBoxNote->"1.3774104683195478"],
         StyleBox["1.3774104683195478`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.3774104683195478`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.1400000000000001`, 0.}, {1.17, 
             0.8264462809917409}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{251.85862600854298`, 265.52438300901747`}, {
            95.90546240767597, 166.9535238686926}}],
          StatusArea[#, 0.8264462809917409]& ,
          TagBoxNote->"0.8264462809917409"],
         StyleBox["0.8264462809917409`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8264462809917409, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.17, 0.}, {1.2, 1.6528925619834698`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{264.27438300901747`, 277.9401400094921}, {
            26.107400946660363`, 166.9535238686926}}],
          StatusArea[#, 1.6528925619834698`]& ,
          TagBoxNote->"1.6528925619834698"],
         StyleBox["1.6528925619834698`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.6528925619834698`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.2, 0.}, {1.23, 0.8264462809917349}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{276.6901400094921, 290.3558970099667}, {
            95.90546240767648, 166.9535238686926}}],
          StatusArea[#, 0.8264462809917349]& ,
          TagBoxNote->"0.8264462809917349"],
         StyleBox["0.8264462809917349`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8264462809917349, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.23, 0.}, {1.2599999999999998`, 
             1.9283746556473955`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{289.1058970099667, 302.77165401044124`}, {
            2.8413804596538057`, 166.9535238686926}}],
          StatusArea[#, 1.9283746556473955`]& ,
          TagBoxNote->"1.9283746556473955"],
         StyleBox["1.9283746556473955`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.9283746556473955`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.2599999999999998`, 0.}, {1.29, 
             1.1019283746556383`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{301.52165401044124`, 315.187411010916}, {
            72.6394419206718, 166.9535238686926}}],
          StatusArea[#, 1.1019283746556383`]& ,
          TagBoxNote->"1.1019283746556383"],
         StyleBox["1.1019283746556383`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.1019283746556383`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.29, 0.}, {1.3199999999999998`, 
             0.8264462809917409}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{313.937411010916, 327.6031680113905}, {
            95.90546240767597, 166.9535238686926}}],
          StatusArea[#, 0.8264462809917409]& ,
          TagBoxNote->"0.8264462809917409"],
         StyleBox["0.8264462809917409`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.8264462809917409, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.3199999999999998`, 0.}, {1.35, 
             1.1019283746556383`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{326.3531680113905, 340.0189250118651}, {
            72.6394419206718, 166.9535238686926}}],
          StatusArea[#, 1.1019283746556383`]& ,
          TagBoxNote->"1.1019283746556383"],
         StyleBox["1.1019283746556383`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.1019283746556383`, {
           GrayLevel[0]}], "Tooltip"]& ], {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.38, 0.}, {1.41, 0.27548209366391163`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{351.18468201233975`, 364.85043901281426`}, {
            142.43750338168724`, 166.9535238686926}}],
          StatusArea[#, 0.27548209366391163`]& ,
          TagBoxNote->"0.27548209366391163"],
         StyleBox["0.27548209366391163`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.27548209366391163`, {
           GrayLevel[0]}], "Tooltip"]& ], {}, {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.47, 0.}, {1.5, 0.27548209366391163`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{388.4319530137635, 402.09771001423815`}, {
            142.43750338168724`, 166.9535238686926}}],
          StatusArea[#, 0.27548209366391163`]& ,
          TagBoxNote->"0.27548209366391163"],
         StyleBox["0.27548209366391163`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.27548209366391163`, {
           GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, {}, {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.6800000000000002`, 0.}, {1.71, 
             0.27548209366391363`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{475.3422520170859, 489.0080090175604}, {
            142.43750338168707`, 166.9535238686926}}],
          StatusArea[#, 0.27548209366391363`]& ,
          TagBoxNote->"0.27548209366391363"],
         StyleBox["0.27548209366391363`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.27548209366391363`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.71, 0.}, {1.7399999999999998`, 
             0.27548209366391363`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{487.7580090175604, 501.42376601803494`}, {
            142.43750338168707`, 166.9535238686926}}],
          StatusArea[#, 0.27548209366391363`]& ,
          TagBoxNote->"0.27548209366391363"],
         StyleBox["0.27548209366391363`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.27548209366391363`, {
           GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.8599999999999999`, 0.}, {1.89, 
             0.5509641873278233}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{549.8367940199334, 563.5025510204081}, {
            119.17148289468184`, 166.9535238686926}}],
          StatusArea[#, 0.5509641873278233]& ,
          TagBoxNote->"0.5509641873278233"],
         StyleBox["0.5509641873278233`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.5509641873278233, {
           GrayLevel[0]}], "Tooltip"]& ]}, {}, {}}, {{}, {}, 
      {RGBColor[1, 0, 0], AbsoluteThickness[2], LineBox[CompressedData["
1:eJwV13c8Vf8fB3B8VSqlFClFywhlJPRNXiJlZ1WSXSmjyJ4ZKUIoGkoiskKI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        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{
      FormBox["\"Flux, Jy\"", TraditionalForm], 
      FormBox["\"Probability\"", TraditionalForm]},
    AxesOrigin->{0.6, 0},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    ImageSize->500,
    PlotRange->{{0.6, 1.89}, {All, All}},
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.02], 
       Scaled[0.1]}},
    Ticks->{Automatic, Automatic}], ",", 
   RowBox[{"NormalDistribution", "[", 
    RowBox[{"1.0609090909090915`", ",", "0.20979328669072292`"}], "]"}], ",", 
   "0.0000721327621716985`"}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.5003978218924994`*^9, 3.5003978373454995`*^9}, {
   3.5003979038334994`*^9, 3.5003979274534993`*^9}, {3.500398027961499*^9, 
   3.5003980380784993`*^9}, {3.5003981236204996`*^9, 3.5003981686814995`*^9}, 
   3.5003982104204993`*^9, 3.5010023473389997`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"test", "=", 
  RowBox[{"DistributionFitTest", "[", 
   RowBox[{"dat7mm", ",", "Automatic", ",", "\"\<HypothesisTestData\>\""}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"test", "[", 
  RowBox[{"\"\<TestDataTable\>\"", ",", "All"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"test", "=", 
  RowBox[{"DistributionFitTest", "[", 
   RowBox[{"dat13mm", ",", "Automatic", ",", "\"\<HypothesisTestData\>\""}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"test", "[", 
  RowBox[{"\"\<TestDataTable\>\"", ",", "All"}], "]"}]}], "Input",
 CellChangeTimes->{
  3.500398243383499*^9, {3.5003983101244993`*^9, 3.5003983865194993`*^9}, {
   3.500398428501499*^9, 3.5003984304544992`*^9}, 3.5010023473389997`*^9}],

Cell[BoxData[
 RowBox[{"HypothesisTestData", "[", 
  TemplateBox[{
   "\"\[LeftSkeleton]\"","\"DistributionFitTest\"","\"\[RightSkeleton]\""},
   "Row",
   DisplayFunction->(
    RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
   InterpretationFunction->(RowBox[{"Row", "[", 
      RowBox[{"{", 
        RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )], "]"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.5003983553584995`*^9, 3.5003983876164994`*^9, 
  3.5003984307244997`*^9, 3.501002347341*^9}],

Cell[BoxData[
 StyleBox[
  TagBox[GridBox[{
     {"\<\"\"\>", "\<\"Statistic\"\>", "\<\"P\[Hyphen]Value\"\>"},
     {"\<\"Anderson\[Hyphen]Darling\"\>", "2.3814684431933557`", 
      "1.4433129687459555`*^-6"},
     {"\<\"Cram\[EAcute]r\[Hyphen]von Mises\"\>", "0.34093413075696344`", 
      "0.0000721327621716985`"},
     {"\<\"Jarque\[Hyphen]Bera ALM\"\>", "92.82181795738789`", "0.`"},
     {"\<\"Pearson \\!\\(\\*SuperscriptBox[\\(\[Chi]\\),\\(2\\)]\\)\"\>", 
      "25.363636363636363`", "0.008062039036127516`"},
     {"\<\"Shapiro\[Hyphen]Wilk\"\>", "0.9040788155700069`", 
      "2.9081534543803807`*^-7"}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Automatic}}},
    GridBoxDividers->{
     "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
      "RowsIndexed" -> {2 -> GrayLevel[0.7]}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
    GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"], "DialogStyle",
  StripOnInput->False]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.5003983553584995`*^9, 3.5003983876164994`*^9, 
  3.500398430739499*^9, 3.501002347343*^9}],

Cell[BoxData[
 RowBox[{"HypothesisTestData", "[", 
  TemplateBox[{
   "\"\[LeftSkeleton]\"","\"DistributionFitTest\"","\"\[RightSkeleton]\""},
   "Row",
   DisplayFunction->(
    RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3}]& ),
   InterpretationFunction->(RowBox[{"Row", "[", 
      RowBox[{"{", 
        RowBox[{#, ",", #2, ",", #3}], "}"}], "]"}]& )], "]"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.5003983553584995`*^9, 3.5003983876164994`*^9, 
  3.5003984307414994`*^9, 3.501002347343*^9}],

Cell[BoxData[
 StyleBox[
  TagBox[GridBox[{
     {"\<\"\"\>", "\<\"Statistic\"\>", "\<\"P\[Hyphen]Value\"\>"},
     {"\<\"Anderson\[Hyphen]Darling\"\>", "0.5787755945451778`", 
      "0.1339556295317306`"},
     {"\<\"Cram\[EAcute]r\[Hyphen]von Mises\"\>", "0.09375592274389513`", 
      "0.1353931808575767`"},
     {"\<\"Jarque\[Hyphen]Bera ALM\"\>", "24.484831850478656`", 
      "0.0036599097401222823`"},
     {"\<\"Pearson \\!\\(\\*SuperscriptBox[\\(\[Chi]\\),\\(2\\)]\\)\"\>", 
      "16.`", "0.1411308802670582`"},
     {"\<\"Shapiro\[Hyphen]Wilk\"\>", "0.97239880905449`", 
      "0.012079787421599058`"}
    },
    AutoDelete->False,
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Automatic}}},
    GridBoxDividers->{
     "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
      "RowsIndexed" -> {2 -> GrayLevel[0.7]}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
    GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"], "DialogStyle",
  StripOnInput->False]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.5003983553584995`*^9, 3.5003983876164994`*^9, 
  3.5003984307434998`*^9, 3.501002347344*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"dat7mm", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "her7mm", "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";", 
  RowBox[{"xmin", "=", 
   RowBox[{"Min", "[", "dat7mm", "]"}]}], ";", 
  RowBox[{"xmax", "=", 
   RowBox[{"Max", "[", "dat7mm", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist", "=", 
   RowBox[{"EstimatedDistribution", "[", 
    RowBox[{"dat7mm", ",", 
     RowBox[{"NormalDistribution", "[", 
      RowBox[{
       RowBox[{"Median", "[", "dat7mm", "]"}], ",", "\[Sigma]"}], "]"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hist", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"dat7mm", ",", 
     RowBox[{"{", "0.1", "}"}], ",", "\"\<ProbabilityDensity\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plo", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hist", ",", "pl"}], "}"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Flux, Jy\>\"", ",", "\"\<Probability\>\""}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"test", "=", 
   RowBox[{"DistributionFitTest", "[", "dat7mm", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{"\"\<7mm\>\"", ",", "plo", ",", "dist", ",", "test"}], 
  "}"}]}], "Input",
 CellChangeTimes->{{3.5003985913684998`*^9, 3.500398653053499*^9}, {
   3.5003986879484997`*^9, 3.500398691987499*^9}, 3.5010023473450003`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"7mm\"\>", ",", 
   GraphicsBox[{
     {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
      EdgeForm[Opacity[0.7]], {}, 
      {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
       EdgeForm[Opacity[0.7]], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.6000000000000001, 0.}, {0.7000000000000001, 
             0.08264462809917357}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{28.37499999999997, 70.69250392464673}, {
            155.2739284779662, 166.95352386869277`}}],
          StatusArea[#, 0.08264462809917357]& ,
          TagBoxNote->"0.08264462809917357"],
         StyleBox["0.08264462809917357`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.08264462809917357, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.7000000000000001, 0.}, {0.8, 
             0.16528925619834714`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{69.44250392464673, 111.76000784929354`}, {
            144.84433308723962`, 166.95352386869277`}}],
          StatusArea[#, 0.16528925619834714`]& ,
          TagBoxNote->"0.16528925619834714"],
         StyleBox["0.16528925619834714`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.16528925619834714`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.8, 0.}, {0.9000000000000001, 1.90082644628099}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{110.51000784929354`, 
            152.82751177394036`}, {-74.17717011801815, 166.95352386869277`}}],
          StatusArea[#, 1.90082644628099]& ,
          TagBoxNote->"1.90082644628099"],
         StyleBox["1.90082644628099`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.90082644628099, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{0.9000000000000001, 0.}, {1., 2.3966942148760366`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{151.57751177394036`, 
            193.89501569858706`}, {-136.75474246237823`, 
            166.95352386869277`}}],
          StatusArea[#, 2.3966942148760366`]& ,
          TagBoxNote->"2.3966942148760366"],
         StyleBox["2.3966942148760366`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[2.3966942148760366`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1., 0.}, {1.1, 1.9834710743801636`}, 
             "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{192.64501569858706`, 
            234.96251962323387`}, {-84.6067655087447, 166.95352386869277`}}],
          StatusArea[#, 1.9834710743801636`]& ,
          TagBoxNote->"1.9834710743801636"],
         StyleBox["1.9834710743801636`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.9834710743801636`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.1, 0.}, {1.2000000000000002`, 
             1.2396694214876023`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{233.71251962323387`, 276.03002354788066`}, {
            9.259593007794336, 166.95352386869277`}}],
          StatusArea[#, 1.2396694214876023`]& ,
          TagBoxNote->"1.2396694214876023"],
         StyleBox["1.2396694214876023`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.2396694214876023`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.2000000000000002`, 0.}, {1.3000000000000003`, 
             1.3223140495867758`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{274.78002354788066`, 
            317.09752747252753`}, {-1.1700023829322106`, 
            166.95352386869277`}}],
          StatusArea[#, 1.3223140495867758`]& ,
          TagBoxNote->"1.3223140495867758"],
         StyleBox["1.3223140495867758`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[1.3223140495867758`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.3000000000000003`, 0.}, {1.4000000000000001`, 
             0.4132231404958684}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{315.84752747252753`, 358.1650313971742}, {
            113.55554691505984`, 166.95352386869277`}}],
          StatusArea[#, 0.4132231404958684]& ,
          TagBoxNote->"0.4132231404958684"],
         StyleBox["0.4132231404958684`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.4132231404958684, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.4000000000000001`, 0.}, {1.5, 
             0.16528925619834733`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{356.9150313971742, 399.23253532182093`}, {
            144.8443330872396, 166.95352386869277`}}],
          StatusArea[#, 0.16528925619834733`]& ,
          TagBoxNote->"0.16528925619834733"],
         StyleBox["0.16528925619834733`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.16528925619834733`, {
           GrayLevel[0]}], "Tooltip"]& ], {}, {}, 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.7000000000000002`, 0.}, {1.8000000000000003`, 
             0.16528925619834697`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{480.11754317111456`, 522.4350470957614}, {
            144.84433308723965`, 166.95352386869277`}}],
          StatusArea[#, 0.16528925619834697`]& ,
          TagBoxNote->"0.16528925619834697"],
         StyleBox["0.16528925619834697`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.16528925619834697`, {
           GrayLevel[0]}], "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         TagBox[
          DynamicBox[{
            FEPrivate`If[
             CurrentValue["MouseOver"], 
             EdgeForm[{
               GrayLevel[0.5], 
               AbsoluteThickness[1.5], 
               Opacity[0.66]}], {}, {}], 
            
            RectangleBox[{1.8000000000000003`, 0.}, {1.9000000000000001`, 
             0.16528925619834733`}, "RoundingRadius" -> 0]},
           
           ImageSizeCache->{{521.1850470957614, 563.5025510204081}, {
            144.8443330872396, 166.95352386869277`}}],
          StatusArea[#, 0.16528925619834733`]& ,
          TagBoxNote->"0.16528925619834733"],
         StyleBox["0.16528925619834733`", {
           GrayLevel[0]}, StripOnInput -> False]],
        Annotation[#, 
         Style[0.16528925619834733`, {
           GrayLevel[0]}], "Tooltip"]& ]}, {}, {}}, {{}, {}, 
      {RGBColor[1, 0, 0], AbsoluteThickness[2], LineBox[CompressedData["
1:eJwVl3c8Vu//x1GRKCMz3yg7Lasi8RIqKxFJhYyi7AgRmWlQKRoasrKSMooU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        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{
      FormBox["\"Flux, Jy\"", TraditionalForm], 
      FormBox["\"Probability\"", TraditionalForm]},
    AxesOrigin->{0.6000000000000001, 0},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    ImageSize->500,
    PlotRange->{{0.6000000000000001, 1.9000000000000001`}, {All, All}},
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.02], 
       Scaled[0.1]}},
    Ticks->{Automatic, Automatic}], ",", 
   RowBox[{"NormalDistribution", "[", 
    RowBox[{"1.03`", ",", "0.2120579992391759`"}], "]"}], ",", 
   "0.0000721327621716985`"}], "}"}]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{{3.5003985922994995`*^9, 3.500398654041499*^9}, {
   3.5003986890724993`*^9, 3.5003986928374996`*^9}, 3.501002347365*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pl2", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{"her2cm", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl13", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{"her13mm", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Green"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl7", "=", 
   RowBox[{"ListPlot", "[", 
    RowBox[{"her7mm", ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Blue"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"{", 
   RowBox[{"pl2", ",", "pl13", ",", "pl7"}], "}"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5003973852484994`*^9, 3.5003974443114996`*^9}, 
   3.501002347366*^9}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.5003975140494995`*^9, 3.5003975140734997`*^9}, 
   3.501002347366*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["My simulations", "Subsubsection",
 CellChangeTimes->{{3.500401954562499*^9, 3.500401956746499*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "dir", "=", "\"\<C:\\\\study\\\\mathematica\\\\3DMHD\\\\vary\\\\\>\""}], 
  ";", 
  RowBox[{"sep", "=", "1"}], ";", 
  RowBox[{"\[Nu]tab", "=", 
   RowBox[{"{", 
    RowBox[{
    "43", ",", "87", ",", "102", ",", "145", ",", "230", ",", "349", ",", 
     "674", ",", "857"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"el", "=", 
   RowBox[{"{", 
    RowBox[{"ListLogPlot", ",", "ListPlot"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SetOptions", "[", 
      RowBox[{"#", ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "13"}]}], "}"}]}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}]}], "]"}], "&"}], "/@",
     "el"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{",", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "43", ",", "87", ",", "145", ",", "230", ",", "345", ",", "690"}], 
          "}"}], ",", "None"}], "}"}]}], "}"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"tr", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Import", "[", 
        RowBox[{"dir", "<>", "\"\<poliresa90th214nu\>\"", "<>", 
         RowBox[{"ToString", "[", 
          RowBox[{"\[Nu]tab", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "]"}], "<>", "\"\<fn0.dat\>\""}], 
        "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tr", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "=", 
      FractionBox[
       RowBox[{"2", 
        RowBox[{"tr", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], 
       SuperscriptBox["10", "3"]]}], ";", 
     RowBox[{"tmin", "=", 
      RowBox[{"tr", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"tmax", "=", 
      RowBox[{"tr", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"GraphicsRow", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Fpl", "[", "i", "]"}], "=", 
           RowBox[{"ListLogPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tr", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"tr", "[", 
                 RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"None", ",", "None"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"None", ",", 
                  RowBox[{
                  "\"\<\!\(\*SubscriptBox[\(F\), \(\[Nu]\)]\) at \[Nu]=\>\"", 
                   "<>", 
                   RowBox[{"ToString", "[", 
                    RowBox[{"tr", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
                   "\"\<GHz\>\""}]}], "}"}]}], "}"}]}], ",", 
             RowBox[{"Frame", "\[Rule]", "True"}], ",", 
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"tmin", ",", "tmax"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"0.9", 
                   RowBox[{"Min", "[", 
                    RowBox[{"tr", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "]"}]}], ",", 
                  RowBox[{"1.1", 
                   RowBox[{"Max", "[", 
                    RowBox[{"tr", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "]"}]}]}], "}"}]}], 
               "}"}]}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], ",", 
          RowBox[{
           RowBox[{"LPpl", "[", "i", "]"}], "=", 
           RowBox[{"ListLogPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tr", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"tr", "[", 
                 RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"None", ",", "None"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"None", ",", 
                  RowBox[{"\"\<LP at \[Nu]=\>\"", "<>", 
                   RowBox[{"ToString", "[", 
                    RowBox[{"tr", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
                   "\"\<GHz\>\""}]}], "}"}]}], "}"}]}], ",", 
             RowBox[{"Frame", "\[Rule]", "True"}], ",", 
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"tmin", ",", "tmax"}], "}"}], ",", "Automatic"}], 
               "}"}]}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"EVPApl", "[", "i", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tr", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"Mod", "[", 
                 RowBox[{
                  RowBox[{"180", "+", 
                   RowBox[{"tr", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}], ",", "180"}], "]"}]}], 
               "}"}], "]"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"None", ",", "None"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"None", ",", 
                  RowBox[{"\"\<EVPA in deg at \[Nu]=\>\"", "<>", 
                   RowBox[{"ToString", "[", 
                    RowBox[{"tr", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
                   "\"\<GHz\>\""}]}], "}"}]}], "}"}]}], ",", 
             RowBox[{"Frame", "\[Rule]", "True"}], ",", 
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"tmin", ",", "tmax"}], "}"}], ",", "Automatic"}], 
               "}"}]}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"CPpl", "[", "i", "]"}], "=", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"tr", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"tr", "[", 
                 RowBox[{"[", "6", "]"}], "]"}]}], "}"}], "]"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"None", ",", "None"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"None", ",", 
                  RowBox[{"\"\<CP in % at \[Nu]=\>\"", "<>", 
                   RowBox[{"ToString", "[", 
                    RowBox[{"tr", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
                   "\"\<GHz\>\""}]}], "}"}]}], "}"}]}], ",", 
             RowBox[{"Frame", "\[Rule]", "True"}], ",", 
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"tmin", ",", "tmax"}], "}"}], ",", "Automatic"}], 
               "}"}]}], ",", 
             RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}]}], "}"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "1200"}]}], "]"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "5", ",", "5"}], "}"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5004021099864993`*^9, 3.5004021102244997`*^9}, {
  3.500402188508499*^9, 3.5004021890844994`*^9}, {3.500402267192499*^9, 
  3.500402267758499*^9}, {3.500403358987499*^9, 3.5004033836894994`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"tr", "[", 
    RowBox[{"[", "6", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xmin", "=", 
    RowBox[{"Min", "[", "data", "]"}]}], ";", 
   RowBox[{"xmax", "=", 
    RowBox[{"Max", "[", "data", "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"dist", "=", 
     RowBox[{"EmpiricalDistribution", "[", "data", "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"test", "=", 
   RowBox[{"DistributionFitTest", "[", "data", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist", "=", 
   RowBox[{"EstimatedDistribution", "[", 
    RowBox[{"data", ",", 
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist2", "=", 
   RowBox[{"EstimatedDistribution", "[", 
    RowBox[{"data", ",", 
     RowBox[{"CauchyDistribution", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hist", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"data", ",", 
     RowBox[{"{", "0.05", "}"}], ",", "\"\<ProbabilityDensity\>\""}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl2", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist2", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Green", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plo", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hist", ",", "pl", ",", "pl2"}], "}"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Flux, Jy\>\"", ",", "\"\<Probability\>\""}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"ToString", "[", 
     RowBox[{"tr", "[", 
      RowBox[{"[", 
       RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
    "\"\< GHz: CP  \>\""}], ",", "test", ",", "plo", ",", "dist"}], 
  "}"}]}], "Input",
 CellChangeTimes->{{3.500651541094*^9, 3.500651612363*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"\[ScriptCapitalH]", "=", 
     RowBox[{"DistributionFitTest", "[", 
      RowBox[{"data", ",", "Automatic", ",", "\"\<HypothesisTestData\>\""}], 
      "]"}]}], ";", "\n", 
    RowBox[{"\[ScriptCapitalH]", "[", 
     RowBox[{"\"\<TestDataTable\>\"", ",", "All"}], "]"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"DistributionFitTest", "[", 
   RowBox[{"data", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.500987350185*^9, 3.500987403526*^9}, {3.500987469291*^9,
   3.500987484098*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"n", "=", "40"}], ";", 
  RowBox[{"Off", "[", 
   StyleBox[
    RowBox[{"HypothesisTestData", "::", "ties"}], "MessageName"], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tabprob", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"rand", "=", 
       RowBox[{"RandomSample", "[", 
        RowBox[{
         RowBox[{"tr", "[", 
          RowBox[{"[", "3", "]"}], "]"}], ",", "n"}], "]"}]}], ";", 
      RowBox[{"DistributionFitTest", "[", 
       RowBox[{"rand", ",", "Automatic", ",", "\"\<KolmogorovSmirnov\>\""}], 
       "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1000"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Median", "[", "tabprob", "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"p", "=", 
        RowBox[{
        "0.05", " ", "at", " ", "300", " ", "points", " ", "drawn", " ", "of",
          " ", "CP"}]}], ";", 
       RowBox[{"25", " ", "points", " ", "drawn", " ", "of", " ", "log", 
        RowBox[{"(", "LP", ")"}]}], ";"}], " ", "~", "1000"}], " ", "points", 
     " ", "drawn", " ", "of", " ", "LP"}], ";", " ", 
    RowBox[{"40", " ", "points", " ", "of", " ", "flux"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.500987496727*^9, 3.500987518126*^9}, {3.500987550333*^9,
   3.500987669799*^9}, {3.5009877582279997`*^9, 3.50098777205*^9}, {
  3.500987811769*^9, 3.500987847869*^9}, {3.50098816031*^9, 
  3.500988363311*^9}, {3.5009886331210003`*^9, 3.50098863324*^9}, {
  3.500988672073*^9, 3.500988711802*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"tr", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";", 
  RowBox[{"SetOptions", "[", 
   RowBox[{"Histogram", ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", "16", "}"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xmin", "=", 
    RowBox[{"Min", "[", "data", "]"}]}], ";", 
   RowBox[{"xmax", "=", 
    RowBox[{"Max", "[", "data", "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"dist", "=", 
     RowBox[{"EmpiricalDistribution", "[", "data", "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"test", "=", 
   RowBox[{"DistributionFitTest", "[", "data", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist", "=", 
   RowBox[{"EstimatedDistribution", "[", 
    RowBox[{"data", ",", 
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist2", "=", 
   RowBox[{"EstimatedDistribution", "[", 
    RowBox[{"data", ",", 
     RowBox[{"CauchyDistribution", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hist", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"data", ",", 
     RowBox[{"{", "0.05", "}"}], ",", "\"\<ProbabilityDensity\>\""}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl2", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist2", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Green", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plo", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hist", ",", "pl", ",", "pl2"}], "}"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Flux, Jy\>\"", ",", "\"\<Probability\>\""}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"ToString", "[", 
      RowBox[{"tr", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
     "\"\< GHz: total I  \>\""}], ",", "test", ",", "plo", ",", "dist"}], 
   "}"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"tr", "[", 
     RowBox[{"[", "4", "]"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xmin", "=", 
    RowBox[{"Min", "[", "data", "]"}]}], ";", 
   RowBox[{"xmax", "=", 
    RowBox[{"Max", "[", "data", "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"dist", "=", 
     RowBox[{"EmpiricalDistribution", "[", "data", "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"test", "=", 
   RowBox[{"DistributionFitTest", "[", "data", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist", "=", 
   RowBox[{"EstimatedDistribution", "[", 
    RowBox[{"data", ",", 
     RowBox[{"NormalDistribution", "[", 
      RowBox[{
       RowBox[{"Median", "[", "data", "]"}], ",", "\[Sigma]"}], "]"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist2", "=", 
   RowBox[{"EstimatedDistribution", "[", 
    RowBox[{"data", ",", 
     RowBox[{"CauchyDistribution", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hist", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"data", ",", 
     RowBox[{"{", "0.2", "}"}], ",", "\"\<ProbabilityDensity\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl2", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist2", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Green", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plo", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hist", ",", "pl", ",", "pl2"}], "}"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Log[LP,%], \>\"", ",", "\"\<Probability\>\""}], "}"}]}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"ToString", "[", 
      RowBox[{"tr", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
     "\"\< GHz: LP  \>\""}], ",", "test", ",", "plo", ",", "dist"}], "}"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"tr", "[", 
    RowBox[{"[", "6", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xmin", "=", 
    RowBox[{"Min", "[", "data", "]"}]}], ";", 
   RowBox[{"xmax", "=", 
    RowBox[{"Max", "[", "data", "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"dist", "=", 
     RowBox[{"EmpiricalDistribution", "[", "data", "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"test", "=", 
   RowBox[{"DistributionFitTest", "[", "data", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist", "=", 
   RowBox[{"EstimatedDistribution", "[", 
    RowBox[{"data", ",", 
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist2", "=", 
   RowBox[{"EstimatedDistribution", "[", 
    RowBox[{"data", ",", 
     RowBox[{"CauchyDistribution", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hist", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"data", ",", 
     RowBox[{"{", "0.05", "}"}], ",", "\"\<ProbabilityDensity\>\""}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl2", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist2", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Green", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plo", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hist", ",", "pl", ",", "pl2"}], "}"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<CP, %\>\"", ",", "\"\<Probability\>\""}], "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"ToString", "[", 
      RowBox[{"tr", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
     "\"\< GHz: CP  \>\""}], ",", "test", ",", "plo", ",", "dist"}], "}"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"180", "+", 
      RowBox[{"tr", "[", 
       RowBox[{"[", "5", "]"}], "]"}]}], ",", "180"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xmin", "=", 
    RowBox[{"Min", "[", "data", "]"}]}], ";", 
   RowBox[{"xmax", "=", 
    RowBox[{"Max", "[", "data", "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"dist", "=", 
     RowBox[{"EmpiricalDistribution", "[", "data", "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"test", "=", 
   RowBox[{"DistributionFitTest", "[", "data", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist", "=", 
   RowBox[{"EstimatedDistribution", "[", 
    RowBox[{"data", ",", 
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist2", "=", 
   RowBox[{"EstimatedDistribution", "[", 
    RowBox[{"data", ",", 
     RowBox[{"CauchyDistribution", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hist", "=", 
   RowBox[{"Histogram", "[", 
    RowBox[{"data", ",", 
     RowBox[{"{", "2", "}"}], ",", "\"\<ProbabilityDensity\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl2", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist2", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "xmin", ",", "xmax"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Green", ",", 
        RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plo", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hist", ",", "pl", ",", "pl2"}], "}"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<EVPA, deg\>\"", ",", "\"\<Probability\>\""}], "}"}]}], 
     ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"ToString", "[", 
      RowBox[{"tr", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], "<>", 
     "\"\< GHz: EVPA  \>\""}], ",", "test", ",", "plo", ",", "dist"}], "}"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5004021223534994`*^9, 3.5004021247294993`*^9}, {
  3.5004021599124994`*^9, 3.5004021698114996`*^9}, {3.5004023031724997`*^9, 
  3.5004024109864993`*^9}, {3.5004025549994993`*^9, 3.5004025555354996`*^9}, {
  3.5004028032734995`*^9, 3.5004028082234993`*^9}, {3.500403013553499*^9, 
  3.5004030163604994`*^9}, {3.5004036880004997`*^9, 3.5004036910264997`*^9}, {
  3.500658495073*^9, 3.5006584954*^9}, {3.5006585458120003`*^9, 
  3.500658551861*^9}, {3.500658795002*^9, 3.500658802177*^9}, {
  3.5006588433570004`*^9, 3.500658847035*^9}, {3.5009950469630003`*^9, 
  3.500995049201*^9}, {3.504975950167*^9, 3.504975966356*^9}, {
  3.5049762321140003`*^9, 3.504976278211*^9}, {3.5049763279040003`*^9, 
  3.5049763313129997`*^9}, {3.504976389416*^9, 3.504976414131*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Kurtosis", "[", "data", "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     ButtonBox["CentralMoment",
      BaseStyle->"Link",
      ButtonData->"paclet:ref/CentralMoment"], "[", 
     RowBox[{
      StyleBox["list", "TI"], ",", "4"}], "]"}], "/", 
    RowBox[{
     SuperscriptBox[
      RowBox[{
       ButtonBox["CentralMoment",
        BaseStyle->"Link",
        ButtonData->"paclet:ref/CentralMoment"], "[", 
       RowBox[{
        StyleBox["list", "TI"], ",", "2"}], "]"}], "2"], "."}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Skewness", "[", "data", "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     ButtonBox["CentralMoment",
      BaseStyle->"Link",
      ButtonData->"paclet:ref/CentralMoment"], "[", 
     RowBox[{
      StyleBox["list", "TI"], ",", "3"}], "]"}], "/", 
    RowBox[{
     SuperscriptBox[
      RowBox[{
       ButtonBox["CentralMoment",
        BaseStyle->"Link",
        ButtonData->"paclet:ref/CentralMoment"], "[", 
       RowBox[{
        StyleBox["list", "TI"], ",", "2"}], "]"}], 
      RowBox[{"3", "/", "2"}]], "."}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"tutorial", "/", "ContinuousDistributions"}]}], "Input",
 CellChangeTimes->{{3.500403701515499*^9, 3.500403735949499*^9}, {
  3.5004037897304993`*^9, 3.500403798435499*^9}, {3.5004038582474995`*^9, 
  3.5004038596634994`*^9}, {3.500645669354*^9, 3.500645669785*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "dir", "=", "\"\<C:\\\\study\\\\mathematica\\\\3DMHD\\\\vary\\\\\>\""}], 
  ";", 
  RowBox[{"sep", "=", "1"}], ";", 
  RowBox[{"\[Nu]tab", "=", 
   RowBox[{"{", 
    RowBox[{
    "43", ",", "87", ",", "102", ",", "145", ",", "230", ",", "349", ",", 
     "674", ",", "857"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"el", "=", 
   RowBox[{"{", 
    RowBox[{"ListLogPlot", ",", "ListPlot"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SetOptions", "[", 
      RowBox[{"#", ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"BaseStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
          RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
          RowBox[{"FontSize", "\[Rule]", "13"}]}], "}"}]}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "1.5", "]"}]}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", 
        RowBox[{"AbsoluteThickness", "[", "2.5", "]"}]}]}], "]"}], "&"}], "/@",
     "el"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{",", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "None"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "43", ",", "87", ",", "145", ",", "230", ",", "345", ",", "690"}], 
          "}"}], ",", "None"}], "}"}]}], "}"}]}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"tr", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Import", "[", 
        RowBox[{"dir", "<>", "\"\<poliresa90th214nu\>\"", "<>", 
         RowBox[{"ToString", "[", 
          RowBox[{"\[Nu]tab", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "]"}], "<>", "\"\<fn0.dat\>\""}], 
        "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tr", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "=", 
      FractionBox[
       RowBox[{"2", 
        RowBox[{"tr", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], 
       SuperscriptBox["10", "3"]]}], ";", 
     RowBox[{"tmin", "=", 
      RowBox[{"tr", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", 
     RowBox[{"tmax", "=", 
      RowBox[{"tr", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";", 
     RowBox[{"Print", "[", 
      RowBox[{
       RowBox[{"\[Nu]tab", "[", 
        RowBox[{"[", "i", "]"}], "]"}], ",", "\"\<  I: \>\"", ",", 
       RowBox[{
        RowBox[{"dist", "=", 
         RowBox[{"EstimatedDistribution", "[", 
          RowBox[{
           RowBox[{"tr", "[", 
            RowBox[{"[", "3", "]"}], "]"}], ",", 
           RowBox[{"NormalDistribution", "[", 
            RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}]}], ";", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dist", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"dist", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], ",", "\"\<,  LP: \>\"", 
       ",", 
       RowBox[{
        RowBox[{"dist", "=", 
         RowBox[{"EstimatedDistribution", "[", 
          RowBox[{
           RowBox[{"tr", "[", 
            RowBox[{"[", "4", "]"}], "]"}], ",", 
           RowBox[{"NormalDistribution", "[", 
            RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}]}], ";", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dist", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"dist", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], ",", "\"\<,  CP: \>\"", 
       ",", 
       RowBox[{
        RowBox[{"dist", "=", 
         RowBox[{"EstimatedDistribution", "[", 
          RowBox[{
           RowBox[{"tr", "[", 
            RowBox[{"[", "6", "]"}], "]"}], ",", 
           RowBox[{"NormalDistribution", "[", 
            RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}]}], ";", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dist", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"dist", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2", ",", "8"}], "}"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5004029522404995`*^9, 3.5004029948594995`*^9}, {
  3.5004030474394994`*^9, 3.500403215640499*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Other distributions", "Subsubsection",
 CellChangeTimes->{{3.500645881939*^9, 3.500645885138*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Mu]", "=", "3.9"}], ";", 
  RowBox[{"\[Sigma]", "=", "0.1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"dat", "=", 
  RowBox[{"RandomVariate", "[", 
   RowBox[{
    RowBox[{"NormalDistribution", "[", 
     RowBox[{"4", ",", "\[Sigma]"}], "]"}], ",", "30"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\)=\>\"", ",", 
   RowBox[{"chisq", "=", 
    RowBox[{"Total", "[", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{"dat", "-", "\[Mu]"}], "\[Sigma]"], ")"}], "2"], "]"}]}], ",",
    " ", "\"\<; dof=\>\"", ",", 
   RowBox[{"Length", "[", "dat", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
   RowBox[{"SurvivalFunction", "[", 
    RowBox[{
     RowBox[{"ChiSquareDistribution", "[", 
      RowBox[{"Length", "[", "dat", "]"}], "]"}], ",", "chisq"}], "]"}], ",", 
   "\"\< = p-value assuming normal distribution \[Implies] \
\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\) distribution\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
   RowBox[{"TTest", "[", 
    RowBox[{"dat", ",", "\[Mu]"}], "]"}], ",", 
   "\"\< = t-test for assumed mean & computed standard deviation\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{"ZTest", "[", 
     RowBox[{"dat", ",", 
      FractionBox["\[Sigma]", 
       SqrtBox[
        RowBox[{"Length", "[", "dat", "]"}]]], ",", "\[Mu]"}], "]"}], ",", 
    "\"\< = z-test for assumed mean & standard deviation\>\""}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{"DistributionFitTest", "[", 
     RowBox[{"dat", ",", 
      RowBox[{"NormalDistribution", "[", 
       RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}]}], "]"}], ",", " ", 
    "\"\< = can fit by normal distribution?\>\""}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[ScriptCapitalH]", "=", 
   RowBox[{"DistributionFitTest", "[", 
    RowBox[{"dat", ",", 
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}], ",", 
     "\"\<HypothesisTestData\>\""}], "]"}]}], ";"}], "\n", 
 RowBox[{"\[ScriptCapitalH]", "[", 
  RowBox[{"\"\<TestDataTable\>\"", ",", "All"}], "]"}]}], "Input",
 CellChangeTimes->{{3.500697399408*^9, 3.500697423441*^9}, {3.500697497465*^9,
    3.500697499885*^9}, {3.500697566885*^9, 3.500697615767*^9}, {
   3.500697803947*^9, 3.500697852145*^9}, {3.500698113579*^9, 
   3.500698142882*^9}, {3.500698467538*^9, 3.500698491618*^9}, {
   3.5006986329449997`*^9, 3.5006986727320004`*^9}, {3.500699076207*^9, 
   3.500699076967*^9}, {3.500699150212*^9, 3.500699150867*^9}, {
   3.500699401414*^9, 3.50069945991*^9}, {3.5006995121870003`*^9, 
   3.500699523052*^9}, {3.500699654774*^9, 3.500699656477*^9}, {
   3.500699970189*^9, 3.5006999757530003`*^9}, {3.5007000416689997`*^9, 
   3.500700108439*^9}, {3.5007003781140003`*^9, 3.500700380835*^9}, {
   3.500702112236*^9, 3.500702143916*^9}, {3.500702194986*^9, 
   3.500702281818*^9}, 3.5007023469820004`*^9, {3.500702398908*^9, 
   3.5007024397320004`*^9}, {3.500702563731*^9, 3.500702612835*^9}, {
   3.500702687493*^9, 3.500702741198*^9}, {3.5007028157539997`*^9, 
   3.5007028250290003`*^9}, {3.5007029979630003`*^9, 3.500703005789*^9}, {
   3.500703038374*^9, 3.5007030652790003`*^9}, {3.50070329966*^9, 
   3.5007033021359997`*^9}, {3.500703333568*^9, 3.500703340704*^9}, {
   3.500703399656*^9, 3.5007034066809998`*^9}, {3.500703527832*^9, 
   3.5007035432720003`*^9}, {3.500703588028*^9, 3.500703590457*^9}, {
   3.500703707363*^9, 3.500703708245*^9}, {3.500703740565*^9, 
   3.500703765825*^9}, {3.500703801255*^9, 3.500703859778*^9}, {
   3.5007039851280003`*^9, 3.500704010861*^9}, {3.500704113322*^9, 
   3.5007041884040003`*^9}, {3.5007042537980003`*^9, 
   3.5007043449189997`*^9}, {3.500704377229*^9, 3.50070443281*^9}, {
   3.500704463396*^9, 3.500704493837*^9}, {3.5007045692679996`*^9, 
   3.5007046472460003`*^9}, {3.5007046844960003`*^9, 3.500704755716*^9}, {
   3.500704794674*^9, 3.500704829866*^9}, {3.5007051618380003`*^9, 
   3.500705235245*^9}, {3.500705266903*^9, 3.500705304367*^9}, {
   3.500705401222*^9, 3.500705432565*^9}, {3.500705504991*^9, 
   3.5007055401619997`*^9}, {3.500705728391*^9, 3.500705729322*^9}, 
   3.500705791752*^9, {3.500705861264*^9, 3.500705893809*^9}, {
   3.5007059953310003`*^9, 3.500706025204*^9}, 3.5007064740550003`*^9}],

Cell[BoxData[{
 RowBox[{"dat", "=", 
  RowBox[{"RandomVariate", "[", 
   RowBox[{
    RowBox[{"NormalDistribution", "[", 
     RowBox[{"\[Mu]", ",", "\[Sigma]"}], "]"}], ",", "30"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"dat2", "=", 
  RowBox[{"RandomVariate", "[", 
   RowBox[{
    RowBox[{"NormalDistribution", "[", 
     RowBox[{
      RowBox[{"\[Mu]", "-", "\[Sigma]"}], ",", "\[Sigma]"}], "]"}], ",", 
    "20"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"TTest", "[", 
  RowBox[{"{", 
   RowBox[{"dat", ",", "dat2"}], "}"}], "]"}]}], "Input",
 CellChangeTimes->{{3.500721327101*^9, 3.500721389899*^9}, {3.500721422649*^9,
   3.500721437019*^9}, {3.500721514942*^9, 3.500721515336*^9}, {
  3.500729507222*^9, 3.500729508898*^9}, {3.500729552082*^9, 
  3.500729558427*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"deg", "=."}], ";", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     FractionBox[
      SqrtBox["deg"], 
      RowBox[{"2", " ", 
       SqrtBox["\[Pi]"]}]], 
     RowBox[{"Exp", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"deg", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"x", "-", "1"}], ")"}], "2"]}], "4"]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"-", "\[Infinity]"}], ",", 
      RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"deg", ">", "0"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.500646082144*^9, 3.500646083568*^9}, {3.500646227976*^9,
   3.500646342717*^9}, {3.500646389634*^9, 3.5006463997060003`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"12", " ", "degrees", " ", "of", " ", "freedom"}], "*)"}], 
  RowBox[{
   RowBox[{"deg", "=", "12"}], ";", 
   RowBox[{"LogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        FractionBox[
         SqrtBox["deg"], 
         RowBox[{"2", " ", 
          SqrtBox["\[Pi]"]}]], 
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"deg", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"x", "-", "1"}], ")"}], "2"]}], "4"]}], "]"}]}], ",", 
       RowBox[{"deg", " ", 
        RowBox[{"PDF", "[", 
         RowBox[{
          RowBox[{"ChiSquareDistribution", "[", "deg", "]"}], ",", 
          RowBox[{"deg", " ", "x"}]}], "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"1", "-", 
        FractionBox["5", 
         SqrtBox["deg"]]}], ",", 
       RowBox[{"1", "+", 
        FractionBox["10", 
         SqrtBox["deg"]]}]}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", "Blue"}], "}"}]}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5006458895*^9, 3.5006458944110003`*^9}, {
  3.500645974391*^9, 3.5006460307799997`*^9}, {3.5006460609309998`*^9, 
  3.500646080506*^9}, {3.5006463558529997`*^9, 3.500646474078*^9}, {
  3.50064657565*^9, 3.5006466242390003`*^9}, {3.500658966528*^9, 
  3.5006590071730003`*^9}, {3.500659290119*^9, 3.5006593025629997`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ndist", "=", 
   RowBox[{
    FractionBox["1", 
     RowBox[{
      SqrtBox[
       RowBox[{"2", "\[Pi]"}]], "\[Sigma]"}]], 
    RowBox[{"Exp", "[", 
     RowBox[{"-", 
      FractionBox[
       SuperscriptBox["x", "2"], 
       RowBox[{"2", 
        SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}]}], ";", 
  RowBox[{"deg", "=."}], ";", 
  RowBox[{"Integrate", "[", 
   RowBox[{"ndist", ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"-", "\[Infinity]"}], ",", 
      RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"\[Sigma]", ">", "0"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Y", "=", 
    SuperscriptBox["X", "2"]}], "*)"}], 
  RowBox[{"Ydist", "=", 
   RowBox[{
    FractionBox[
     RowBox[{"(", 
      RowBox[{"ndist", "+", 
       RowBox[{"(", 
        RowBox[{"ndist", "/.", 
         RowBox[{"x", "\[Rule]", 
          RowBox[{"-", "x"}]}]}], ")"}]}], ")"}], 
     RowBox[{"D", "[", 
      RowBox[{
       SuperscriptBox["x", "2"], ",", "x"}], "]"}]], " ", "/.", 
    RowBox[{"x", "\[Rule]", 
     SqrtBox["y"]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Integrate", "[", 
  RowBox[{"Ydist", ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "0", ",", 
     RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
   RowBox[{"Assumptions", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\[Sigma]", ">", "0"}], "}"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Yexp", "=", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{"Ydist", " ", 
      RowBox[{"Exp", "[", 
       RowBox[{"\[ImaginaryI]", " ", "\[Omega]", " ", "y"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", "0", ",", 
       RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\[Sigma]", ">", "0"}], "}"}]}], ",", 
     RowBox[{"GenerateConditions", "\[Rule]", "False"}]}], "]"}]}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"N", " ", "distributions"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Yexptot", "=", 
   SuperscriptBox["Yexp", "n"]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Ytot", "=", 
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{"Yexptot", " ", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]", " ", "y"}], "]"}]}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"\[Omega]", ",", 
      RowBox[{"-", "\[Infinity]"}], ",", 
      RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Sigma]", ">", "0"}], ",", 
       RowBox[{"n", "\[Element]", "Integers"}], ",", 
       RowBox[{"n", ">", "0"}], ",", 
       RowBox[{"y", ">", "0"}]}], "}"}]}], ",", 
    RowBox[{"GenerateConditions", "\[Rule]", "False"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cc", "=", 
   RowBox[{"1", "/", 
    RowBox[{
     RowBox[{"Integrate", "[", 
      RowBox[{"Ytot", ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", "0", ",", 
         RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
       RowBox[{"Assumptions", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\[Sigma]", ">", "0"}], "}"}]}]}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Ychisq", "=", 
  RowBox[{"cc", " ", "Ytot", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"Derived", " ", 
      SuperscriptBox["\[Chi]", "2"]}], "-", "distribution"}], 
    "*)"}]}]}]}], "Input",
 CellChangeTimes->{{3.500647779111*^9, 3.500647853957*^9}, {
  3.5006487559630003`*^9, 3.500648861486*^9}, {3.500648934281*^9, 
  3.50064900792*^9}, {3.50064942616*^9, 3.5006494280360003`*^9}, {
  3.500649460006*^9, 3.5006494650290003`*^9}, {3.500649990519*^9, 
  3.500650006416*^9}, {3.5006501297860003`*^9, 3.500650167935*^9}, {
  3.5006501982139997`*^9, 3.5006503087209997`*^9}, {3.500650357631*^9, 
  3.500650360303*^9}, {3.500650392197*^9, 3.500650394428*^9}, {
  3.500650527334*^9, 3.5006505392279997`*^9}, {3.5006506976099997`*^9, 
  3.5006506978459997`*^9}, {3.50065074396*^9, 3.500650758142*^9}}],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnV1IHFkWxwv2tV987AchSyPkQRgG8UEJS/uQJoOgYZcgyUqjYmiHYdF5
SIkwOmGj85CCXowhzgwUq02EXpwigpO1E9IIHUnjWLsxOOLWTOJGbWs3cVtt
Okbbtip766s/q/ojVtnVen5giFrePlX1r3PPPffcW7/t6P59x28wDHOhr3n0
Jfz/AwAAAAAAAAAAAAAAAAAAAAAAQGnhWHpqgnDWO6n1UpsCnA5iLP1wknBa
MQkbSAvQB3YKx7+nKOSvqkFagBHEacIG0gKMgKWcIC3ACEBagEGAtACDAGkB
BgHSAgwCpAUYBEgLMAiQFmAQIC3AIEBagEGAtACDAGkBBgHSAgwCpAUYA8eQ
DpAWoDscO++WC02tzrGVKFdqg4BTwDrltGHZ2Ag6XmrTAAAAAAAAAAAAAAAA
AAAAAAAAAAAAyh+VCVkA0KDUagUAAAAAAAAAQJOhoSGKokptBXDaeP78eW1t
7fv370ttCFAWRBj/1CThtOH+SM7jwuEw0hXDMCdkF1De7DNkxzXnZSuGWfNJ
68aNG+Pj4ydkF3A64FZIhzW3tFB81dnZCV0hUBz5pLWxsYFhGPr3RK0CTgE5
pYU8VXNz86NHj07aKuAUkFNaKL5CUdZJmwScDrSlBdkG4FhoSAspCukKqas0
VgGnAA1poX5wZGSkNCYBpwM1aaG4HUXv0BWeAbgo41NeyOjAx+ZZHTdhypIW
ZBvODlzoodvtY4RNvWLs/F2n1Won5qN6NBzx91mTtaJXSGYf/bSzsxPmoM8G
+y9ng6Gkm9pnyCuYtc8fMWT7uPHxcSQtI1oGTI/oaoyRFsMwaFQYDod1bxko
BwRp2TqokN7KkrINc3NzOrcLlA1bftxJ0Du6tzskkvKDCPNY2b/Vjo/Reg4d
tImxNEW47qZu5smxtFD3Y3VRrOm3+BRs/R63KwGs1UlMzjLlsfMtF6WHnVox
fPyfZD/pZ3JXx6iDnFV6tiEWmrrrfswIHyRvEdxohJ7TED/I5kQfG5G+pacm
lHExwvTSii6RSWtTsDrduo7pDSE678Y92vs/c1GGwu01TvdcUWeiUubHrc7O
rifbKKDw5rgI96XG3vdYsTzOUjdxcpIS/JWppMVFV8YEk6wd5ErK9eBeUx3V
yEtRinvnBP+r2J5xsNngXk+5vfn3FRefnaJ2IEdDwnxlfqgXrjFQWpLN6gFk
lCbsppeWGACrXPPICtkh7wlv6IN5HLiQ3z3qZ2Pyt9GlMXJO09ToPGG3Fqgu
qcwv31FIWo4O6rUxXn2HJhox6xdUKKb2W+S+XGaSlipb/r4+dfvFeyGYb87d
4KMrFO7I6L8d5Ir2jUYhmduO5c+sStmG/In3CFKWmzYkHJXStjlMLQdpxWl3
v5ZTUrxuznwRvx+if/wrgXe1NjW14GTwbeJM41uB241VtY2tXTgx8XT9Ha9t
Bb//lgn+/f7oN7jLecVepbGJgn0wqMTMYieedYCcOddG6MKwnLF3wWV+yKt0
GxXDyw91jtMpB2nlQpGWg2TUlXXAPvvOVYsuwictxMPlrf0s8fDx7Rfent8J
jVR97n21l9UCH99h/GRvo82iIadUn3T8jKgyiaN5Rh9GRkbSsw3q7UTpUZxc
0mNeSaVx2chcnYV5pCWsfkLxA0Xi9iJukCQtjV6G3/2ZvC74F8tnA082kqcX
31598etWPKkyPuzrEfvVinZqk09rgXlws0kRlaWm6Tp+iyC+dtkrMVtT9+Bt
IgPvog63EvVigjE1uH8r+5cFlvkJ05djBulKHnjmC3HNIS35vXLKo194TC6d
o2okmdAVVtNFraboam2mt8GCfdLt+2/K0ZvTrvOZHVZ848nAZ6KqLLamr/+2
sBaV1cgfvrx/tcJS1Tb2c/ToI085F/LbhbKvg5RtyFvmx7F+t9uvZAPQyGiS
nFVR6ccj36/ccaM5pCXbQhM2zadVFfGFdKqR5NH2s9sNgiws57+ceZN0REdh
/1eihjLeYZcYKSuS48MLRLOkq/NdE//KlNAuTVzKalwvNAPIAhYVSimylLKI
ggK8okjUXeS+UyaSlvLiwsItESNeu9oIaO8noq5C7OE+pzYPUz7jF8/lc+L5
XhpefJfyB7vBwQtYUnLxN75eyYtZLv5lIaLimhRrLxH0bpEnmpfETbETdPKh
QXF73kWFXIjqyJBVzrBNR/O0Dyu5tMSakyKugzROVx1Jxda8HaLDqagjfkqN
yxU9ZDuExBvuxMuVUCbmGAqG1d2SHBEZkVJLuIU014pEZY7ahoSH10VaidYK
xkmxxRks3dzc3XeqRWjwW6OeDIw9H66vUOsIjt5O/0nq46oHn6UNBd8F+isl
J9VFsQeJQjvLVe+aVn93EByU/J8BKTU5NDBpuk5fae2v+kYzR0O58RSZT5Gd
QGFRgZAysjvVR9b8XvCbavWOQLkmFe2el6nK4mOLd+qTf5LoHCubPb9qKYtf
97ZgIC3zd4hKF1BQ2mGHJi5rJ4H3lkebxTOquDC6lB4kSdek8uLwP9KzV1JM
jjh32fMLx//b2yL5owuDQa04KllCbGmjWL0jeXNLq7xiLSkFXUjcEgtR3Y7k
PHs2iTRC9vhFlFbtrcB2muL48JPe82I/WfXlNHuYvK/YHz2rBxqf8r9Av+TZ
qrumQ7qPERUTzPkqdvVQMAtzSEtOweVNO8RY/01HnkLN9IA8BT7ybKiuoqLb
lx4K7zHkNVFY55rJZWEwmfRa7d71ww9q8JtUuxjNWS7eWdzTX1mFuYXSIUcv
ZZDXKiztIOpKsyogxtJBsSww4bXSfQ6/s3jnCpJQZX8gJenAxzenewSXZalq
u8/Is0DhQH+d2EJdf0BtRMa/DQw0iMJqJhY0xo/HQhksG7ZG49gU0ssoZ1FK
aRWSdsipK46lx3DFmx288rSKXujTHt9/5PvOv1vz3WpuJ5/+cMNaf2cxpvw4
+oJs+1TQSMOtJ2xCh1wkcFNUZ2buQuSA9X1VK/5N78yaMZes8PCgVOSPjTl2
zi2XblZrDLhOgLxpB0FX0phEm2Rnym8/HWoQUwlV7cMzTwMzE8M911oGHjDR
ow/7y562env3velAMDB9r9uODqu093iXM5Lth4znqjhHVNH67dJuylwjkuif
hSS/7Q9D/g2jHsXiZyVKgFz5oJZXTJ+2S1CCIUmetEPGck4N0h4fPs4GPYOu
BptFmFDu/+7HxTeJk+KjK9NEd1ONFbM1OHuHvYFXUZUuDbXweEDW57WhH2YX
6HlRok02zFrruudfjRjQDyonLIUHqrMMJkJKWZeDazXdMJuPby/7vh243lgj
hGI1ja2uXoJ8EFh+k12Xoyti6eYJrJXQAZObmrMq5uwhTgLqtX7feKS1MOZ0
sHLaQd+p+bJFXl1SxMqL0lP8apETodBS8DMBF/L3Ocx3jwpAWvBo76M+aiml
TsRC1BfJRZdS9bg53emJIu2VZC92HaKZQKfgJ/vHShcwi3kGqShUXO1idd6d
Z1WXGp0l4rTbpSw9Bj4SZZmhMLjGyakT2o8AAAAAAAAAAAAAAAAAAAAAAI7J
/wHSsZV+
    "], {{0, 103}, {201, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->{117.00000000000003`, Automatic},
  ImageSizeRaw->{201, 103},
  PlotRange->{{0, 201}, {0, 103}}]], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["size of emitting region", "Subsection",
 CellChangeTimes->{{3.499533274483*^9, 3.499533279641*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"87.73", ",", "33."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"102.00", ",", "24."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"145.00", ",", "15."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"230.86", ",", "13."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"349.00", ",", "11."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"674.00", ",", "8."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"857.00", ",", "7."}], "}"}]}], "}"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Blue"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl2", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{
     RowBox[{"8", "+", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["600", "\[Nu]"], ")"}], "1.5"]}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Nu]", ",", "87", ",", "857"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"{", 
   RowBox[{"pl1", ",", "pl2"}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"#", ",", 
     RowBox[{"0.1", 
      RowBox[{"Round", "[", 
       RowBox[{"10", 
        RowBox[{"(", 
         RowBox[{"8", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["600", "#"], ")"}], "1.5"]}], ")"}]}], "]"}]}]}], 
    "}"}], "&"}], "/@", 
  RowBox[{"{", 
   RowBox[{
   "87.73", ",", "102.00", ",", "145.00", ",", "230.86", ",", "349.00", ",", 
    "674.00", ",", "857.00"}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.499533217674783*^9, 3.499533248110383*^9}, {
  3.49953331566*^9, 3.4995335364890003`*^9}, {3.499533713612*^9, 
  3.499533723467*^9}, {3.499533786615*^9, 3.49953387059*^9}}],

Cell[BoxData[
 RowBox[{"2.", 
  SqrtBox["27"]}]], "Input",
 CellChangeTimes->{{3.504278779307*^9, 3.504278781606*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Correlations of quantities", "Subsection",
 CellChangeTimes->{{3.530457361633316*^9, 3.5304573698247848`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"num", "=", "1000"}], ";", 
  RowBox[{"xx", "=", "1.5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fir", "=", 
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", "]"}], ",", "num"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sec", "=", 
   RowBox[{"xx", " ", "fir"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"secx", "=", 
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", 
      RowBox[{"0", ",", "xx"}], "]"}], ",", "num"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Histogram", "[", 
    RowBox[{"sec", ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}], ",", 
   RowBox[{"Histogram", "[", 
    RowBox[{"secx", ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], "}"}]}], "Input",
 CellChangeTimes->{{3.5304574636531515`*^9, 3.53045747254466*^9}, {
   3.5304575913204536`*^9, 3.5304576209281473`*^9}, {3.530457656224166*^9, 
   3.5304577348636637`*^9}, {3.530457892526682*^9, 3.530457918158148*^9}, {
   3.530458082101525*^9, 3.5304581313183393`*^9}, {3.530458168480465*^9, 
   3.5304581827722826`*^9}, {3.5304582205244417`*^9, 3.5304582510761895`*^9}, 
   3.531487133675911*^9}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Mean", "[", "sec", "]"}], ",", 
   RowBox[{"Mean", "[", "secx", "]"}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"StandardDeviation", "[", "sec", "]"}], ",", 
   RowBox[{"StandardDeviation", "[", "secx", "]"}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{"StandardDeviation", "[", "sec", "]"}], 
    SqrtBox[
     RowBox[{"Length", "[", "sec", "]"}]]], ",", 
   FractionBox[
    RowBox[{"StandardDeviation", "[", "secx", "]"}], 
    SqrtBox[
     RowBox[{"Length", "[", "secx", "]"}]]]}], "}"}]}], "Input",
 CellChangeTimes->{{3.530458139135787*^9, 3.5304581635001802`*^9}, {
  3.5304582552154264`*^9, 3.5304582595076714`*^9}, {3.530458486609661*^9, 
  3.5304585049557104`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"num", "=", "10000"}], ";", 
  RowBox[{"nn", "=", "100"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"taxx", "=", 
        RowBox[{"RandomVariate", "[", 
         RowBox[{
          RowBox[{"NormalDistribution", "[", "]"}], ",", "num"}], "]"}]}], 
       ";", 
       RowBox[{"mm", "=", 
        RowBox[{"Mean", "[", "taxx", "]"}]}], ";", 
       RowBox[{"err", "=", 
        FractionBox[
         RowBox[{"StandardDeviation", "[", "taxx", "]"}], 
         SqrtBox[
          RowBox[{"Length", "[", "taxx", "]"}]]]}], ";", 
       RowBox[{"{", 
        RowBox[{"mm", ",", "err"}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "nn"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Sort", "[", 
   RowBox[{"res", "[", 
    RowBox[{"[", "2", "]"}], "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 FractionBox[
  RowBox[{"Total", "[", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      RowBox[{"res", "[", 
       RowBox[{"[", "1", "]"}], "]"}], 
      RowBox[{"res", "[", 
       RowBox[{"[", "2", "]"}], "]"}]], ")"}], "2"], "]"}], "nn"]}], "Input",
 CellChangeTimes->{{3.530466000001403*^9, 3.530466010027976*^9}, {
  3.5314871535390472`*^9, 3.5314873008224716`*^9}, {3.53148737666881*^9, 
  3.5314873915636616`*^9}, {3.531487569570843*^9, 3.5314875714739523`*^9}, {
  3.5314876225538735`*^9, 3.531487628506214*^9}, {3.5314877550724535`*^9, 
  3.531487769386272*^9}}],

Cell[BoxData[
 RowBox[{"ListPlot", "[", "res", "]"}]], "Input",
 CellChangeTimes->{{3.5314873033376155`*^9, 3.5314873141062317`*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Something else", "Section",
 CellChangeTimes->{{3.476803567863*^9, 3.476803569951*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{
     FractionBox["180", "\[Pi]"], 
     RowBox[{
      RowBox[{"ArcTan", "[", 
       RowBox[{"Q", ",", "U"}], "]"}], "/", "2"}]}], ",", "180"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"U", "\[Rule]", 
     RowBox[{"-", "7."}]}], ",", 
    RowBox[{"Q", "\[Rule]", 
     RowBox[{"-", "244"}]}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{
     FractionBox["180", "\[Pi]"], 
     RowBox[{
      RowBox[{"ArcTan", "[", 
       RowBox[{"Q", ",", "U"}], "]"}], "/", "2"}]}], ",", "180"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"U", "\[Rule]", "28"}], ",", 
    RowBox[{"Q", "\[Rule]", 
     RowBox[{"-", "224."}]}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{
     FractionBox["180", "\[Pi]"], 
     RowBox[{
      RowBox[{"ArcTan", "[", 
       RowBox[{"Q", ",", "U"}], "]"}], "/", "2"}]}], ",", "180"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"U", "\[Rule]", 
     RowBox[{"-", "176"}]}], ",", 
    RowBox[{"Q", "\[Rule]", "100."}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{
     FractionBox["180", "\[Pi]"], 
     RowBox[{
      RowBox[{"ArcTan", "[", 
       RowBox[{"Q", ",", "U"}], "]"}], "/", "2"}]}], ",", "180"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"U", "\[Rule]", 
     RowBox[{"-", "14"}]}], ",", 
    RowBox[{"Q", "\[Rule]", 
     RowBox[{"-", "12."}]}]}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.475880542967*^9, 3.475880628495*^9}, {
  3.4758806603789997`*^9, 3.4758808960690002`*^9}, {3.47588095138*^9, 
  3.475880959453*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dat", "=", 
   RowBox[{"{", 
    RowBox[{"0.730", ",", ".590", ",", ".720", ",", ".69"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Mean", "[", "dat", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Median", "[", "dat", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Exp", "[", 
  RowBox[{"Mean", "[", 
   RowBox[{"Log", "[", "dat", "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dat", "=", 
   RowBox[{"{", 
    RowBox[{"0.95", ",", "0.8"}], "}"}]}], ";", 
  RowBox[{"exx", "=", 
   RowBox[{"{", 
    RowBox[{"8", ",", "2"}], "}"}]}], ";", 
  RowBox[{"Exp", "[", 
   RowBox[{"Total", "[", 
    FractionBox[
     RowBox[{
      RowBox[{"Log", "[", "dat", "]"}], "*", "exx"}], 
     RowBox[{"Total", "[", "exx", "]"}]], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dada", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"11", ",", " ", "88", " ", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", " ", "110", ",", " ", "8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4.96", ",", " ", "117", ",", " ", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7.2", ",", " ", "139", ",", " ", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5.9", " ", ",", "114", " ", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Exp", "[", 
  RowBox[{"Total", "[", 
   FractionBox[
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", "dada", "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], "]"}], "*", 
     RowBox[{
      RowBox[{"Transpose", "[", "dada", "]"}], "[", 
      RowBox[{"[", "3", "]"}], "]"}]}], 
    RowBox[{"Total", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", "dada", "]"}], "[", 
      RowBox[{"[", "3", "]"}], "]"}], "]"}]], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dada", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"6.86", ",", " ", "149", ",", " ", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5.87", ",", " ", "143", ",", " ", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"13", ",", "161", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Exp", "[", 
  RowBox[{"Total", "[", 
   FractionBox[
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", "dada", "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], "]"}], "*", 
     RowBox[{
      RowBox[{"Transpose", "[", "dada", "]"}], "[", 
      RowBox[{"[", "3", "]"}], "]"}]}], 
    RowBox[{"Total", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", "dada", "]"}], "[", 
      RowBox[{"[", "3", "]"}], "]"}], "]"}]], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.475937920068*^9, 3.475937956533*^9}, {3.475939431833*^9,
   3.47593944712*^9}, {3.47593949151*^9, 3.475939539508*^9}, {
  3.475939599368*^9, 3.475939741723*^9}, {3.4759398574189997`*^9, 
  3.4759399067460003`*^9}, {3.4857880477390003`*^9, 3.485788048329*^9}}],

Cell[BoxData[{
 RowBox[{"\[CapitalDelta]\[Chi]2", "=", 
  RowBox[{
   FractionBox[
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{"Log", "[", 
        FractionBox["0.9", "1.1"], "]"}], "0.26"], ")"}], "2"], "12"], "+", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["0.03", "0.33"], ")"}], "2"], "+", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["0.05", "0.27"], ")"}], "2"]}]}], "\[IndentingNewLine]", 
 RowBox[{"Exp", "[", 
  RowBox[{"-", 
   FractionBox["\[CapitalDelta]\[Chi]2", "2"]}], "]"}]}], "Input",
 CellChangeTimes->{{3.4991896499024*^9, 3.4991896675324*^9}, {
  3.4991898846014*^9, 3.4991899179284*^9}, {3.4991899546714*^9, 
  3.4991899654784*^9}, {3.4991900351544*^9, 3.4991901441944*^9}}],

Cell[BoxData[{
 FractionBox[
  RowBox[{"360.", " ", "60", " ", "60"}], 
  RowBox[{"2", "\[Pi]", " ", "100", " ", 
   SuperscriptBox["10", "3"]}]], "\[IndentingNewLine]", 
 FractionBox[
  RowBox[{"360", " ", "60", " ", "60."}], 
  RowBox[{"3", " ", 
   SuperscriptBox["10", "9"]}]]}], "Input",
 CellChangeTimes->{{3.500653798336*^9, 3.5006539188970003`*^9}, {
  3.500653952615*^9, 3.500654007677*^9}, {3.500655741001*^9, 
  3.500655741877*^9}}],

Cell[BoxData[{
 SuperscriptBox[
  RowBox[{"(", 
   FractionBox[
    RowBox[{"3.4", " ", 
     SuperscriptBox["10", "5"]}], "25"], ")"}], "0.2"], "\[IndentingNewLine]", 
 SuperscriptBox[
  RowBox[{"(", 
   FractionBox[
    RowBox[{"3.4", " ", 
     SuperscriptBox["10", "5"]}], "25"], ")"}], "0.1"]}], "Input",
 CellChangeTimes->{{3.504623813873*^9, 3.5046238402200003`*^9}}]
}, Closed]]
},
WindowSize->{1904, 955},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 97, 1, 106, "Section"],
Cell[CellGroupData[{
Cell[667, 25, 91, 1, 68, "Section"],
Cell[761, 28, 8036, 206, 327, "Input"],
Cell[8800, 236, 2962, 64, 221, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[11799, 305, 173, 4, 68, "Section"],
Cell[11975, 311, 100, 1, 38, "Text"],
Cell[12078, 314, 44904, 740, 368, "Input"],
Cell[56985, 1056, 6791, 188, 251, "Input"],
Cell[63779, 1246, 3333, 105, 140, "Input"],
Cell[67115, 1353, 640, 16, 36, "Input"],
Cell[67758, 1371, 1794, 52, 119, "Input"],
Cell[69555, 1425, 822, 22, 83, "Input"],
Cell[70380, 1449, 8360, 232, 401, "Text"],
Cell[78743, 1683, 1661, 50, 83, "Input"],
Cell[80407, 1735, 179, 6, 36, "Input"],
Cell[80589, 1743, 654, 19, 60, "Input"],
Cell[81246, 1764, 3018, 88, 175, "Input"],
Cell[84267, 1854, 970, 27, 146, "Input"],
Cell[85240, 1883, 316, 10, 50, "Input"],
Cell[85559, 1895, 706, 22, 48, InheritFromParent],
Cell[86268, 1919, 1485, 41, 83, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[87790, 1965, 107, 1, 68, "Section"],
Cell[CellGroupData[{
Cell[87922, 1970, 112, 1, 59, "Subsection"],
Cell[88037, 1973, 3570, 94, 152, "Input"],
Cell[91610, 2069, 3411, 102, 106, "Input"],
Cell[95024, 2173, 1351, 41, 83, "Input"],
Cell[96378, 2216, 3395, 98, 106, "Input"],
Cell[99776, 2316, 877, 26, 36, "Input"],
Cell[100656, 2344, 1330, 36, 36, "Input"],
Cell[101989, 2382, 591, 16, 36, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[102617, 2403, 118, 1, 48, "Subsection"],
Cell[102738, 2406, 3486, 93, 129, "Input"],
Cell[106227, 2501, 3411, 102, 106, "Input"],
Cell[109641, 2605, 2004, 60, 83, "Input"],
Cell[111648, 2667, 3527, 99, 106, "Input"],
Cell[115178, 2768, 1130, 30, 57, "Input"],
Cell[116311, 2800, 2008, 52, 78, "Input"],
Cell[118322, 2854, 339, 10, 57, "Input"],
Cell[118664, 2866, 1124, 30, 57, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[119837, 2902, 322, 4, 68, "Section"],
Cell[CellGroupData[{
Cell[120184, 2910, 111, 1, 59, "Subsection"],
Cell[120298, 2913, 1003, 26, 146, "Input"],
Cell[121304, 2941, 846, 21, 58, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[122187, 2967, 328, 7, 48, "Subsection"],
Cell[CellGroupData[{
Cell[122540, 2978, 158, 2, 49, "Subsubsection"],
Cell[122701, 2982, 1476, 41, 124, "Input"],
Cell[124180, 3025, 21652, 550, 1325, "Input"],
Cell[145835, 3577, 4205, 121, 261, "Input"],
Cell[150043, 3700, 601, 14, 124, "Input"],
Cell[150647, 3716, 22236, 617, 1127, "Input"],
Cell[172886, 4335, 493, 12, 80, "Input"],
Cell[173382, 4349, 315, 6, 55, "Text"],
Cell[173700, 4357, 383, 11, 76, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[174120, 4373, 97, 1, 40, "Subsubsection"],
Cell[174220, 4376, 3776, 107, 190, "Input"],
Cell[177999, 4485, 15857, 407, 623, "Input"],
Cell[193859, 4894, 427, 11, 35, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[194323, 4910, 142, 2, 40, "Subsubsection"],
Cell[194468, 4914, 1476, 41, 124, "Input"],
Cell[195947, 4957, 379, 7, 82, "Input"],
Cell[196329, 4966, 2621, 70, 168, "Input"],
Cell[198953, 5038, 21838, 557, 1417, "Input"],
Cell[220794, 5597, 4205, 122, 261, "Input"],
Cell[225002, 5721, 322, 10, 50, "Input"],
Cell[225327, 5733, 86, 1, 35, "Input"],
Cell[225416, 5736, 22559, 633, 1149, "Input"],
Cell[247978, 6371, 315, 6, 55, "Text"],
Cell[248296, 6379, 383, 11, 76, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[248728, 6396, 422, 10, 48, "Subsection"],
Cell[CellGroupData[{
Cell[249175, 6410, 122, 1, 49, "Subsubsection"],
Cell[249300, 6413, 7342, 187, 396, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[256679, 6605, 156, 2, 40, "Subsubsection"],
Cell[256838, 6609, 16074, 436, 1134, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[272949, 7050, 208, 3, 40, "Subsubsection"],
Cell[273160, 7055, 16636, 452, 1338, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[289833, 7512, 166, 2, 40, "Subsubsection"],
Cell[290002, 7516, 4743, 122, 171, "Input"],
Cell[294748, 7640, 16010, 408, 726, "Input"],
Cell[310761, 8050, 879, 17, 58, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[311689, 8073, 573, 11, 48, "Subsection"],
Cell[312265, 8086, 17897, 491, 887, "Input"],
Cell[330165, 8579, 111, 2, 35, "Input"],
Cell[330279, 8583, 154, 3, 35, "Input"],
Cell[330436, 8588, 615, 16, 58, "Input"],
Cell[331054, 8606, 505, 13, 102, "Input"],
Cell[CellGroupData[{
Cell[331584, 8623, 92, 1, 32, "Subsubsection"],
Cell[331679, 8626, 1806, 51, 85, "Input"],
Cell[333488, 8679, 1878, 52, 107, "Input"],
Cell[335369, 8733, 296, 8, 58, "Input"],
Cell[335668, 8743, 822, 25, 104, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[336539, 8774, 843, 14, 48, "Subsection"],
Cell[337385, 8790, 20842, 545, 1072, "Input"],
Cell[358230, 9337, 330, 9, 96, "Input"],
Cell[358563, 9348, 1834, 54, 129, "Input"],
Cell[360400, 9404, 4304, 77, 78, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[364741, 9486, 1190, 19, 48, "Subsection"],
Cell[365934, 9507, 19486, 519, 1026, "Input"],
Cell[CellGroupData[{
Cell[385445, 10030, 95, 1, 49, "Subsubsection"],
Cell[385543, 10033, 8758, 235, 542, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[394350, 10274, 803, 13, 48, "Subsection"],
Cell[CellGroupData[{
Cell[395178, 10291, 118, 1, 32, "Subsubsection"],
Cell[395299, 10294, 44263, 1220, 2333, "Input"],
Cell[439565, 11516, 2221, 49, 532, "Text"],
Cell[441789, 11567, 354, 8, 58, "Input"],
Cell[442146, 11577, 482, 12, 77, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[442665, 11594, 216, 3, 23, "Subsubsection"],
Cell[442884, 11599, 49905, 1315, 2401, "Input"],
Cell[492792, 12916, 26383, 692, 1206, "Input"],
Cell[519178, 13610, 11743, 259, 552, "Input"],
Cell[CellGroupData[{
Cell[530946, 13873, 744, 22, 158, "Input"],
Cell[531693, 13897, 1680995, 28408, 449, "Output"],
Cell[2212691, 42307, 426, 8, 35, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2213166, 42321, 122, 2, 23, "Subsubsection"],
Cell[2213291, 42325, 13661, 385, 708, "Input"],
Cell[CellGroupData[{
Cell[2226977, 42714, 13608, 384, 708, "Input"],
Cell[2240588, 43100, 345, 6, 35, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2240970, 43111, 586, 12, 58, "Input"],
Cell[2241559, 43125, 295, 6, 35, "Output"],
Cell[2241857, 43133, 295, 6, 35, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2242213, 43146, 417, 6, 48, "Subsection"],
Cell[CellGroupData[{
Cell[2242655, 43156, 261, 5, 49, "Subsubsection"],
Cell[2242919, 43163, 41397, 1037, 1930, "Input"],
Cell[2284319, 44202, 592, 11, 162, "Text"],
Cell[2284914, 44215, 520, 14, 96, "Input"],
Cell[2285437, 44231, 178, 4, 36, "Input"],
Cell[2285618, 44237, 14161, 406, 780, "Input"],
Cell[2299782, 44645, 1936, 49, 102, "Input"],
Cell[2301721, 44696, 186, 4, 35, "Input"],
Cell[2301910, 44702, 186, 4, 27, "Input"],
Cell[2302099, 44708, 2235, 64, 151, "Input"],
Cell[2304337, 44774, 1070, 30, 146, "Input"],
Cell[2305410, 44806, 5044, 126, 230, "Input"],
Cell[2310457, 44934, 752, 18, 50, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[2311246, 44957, 146, 1, 40, "Subsubsection"],
Cell[2311395, 44960, 38190, 1010, 1764, "Input"],
Cell[2349588, 45972, 155, 3, 35, "Input"],
Cell[2349746, 45977, 1590, 47, 124, "Input"],
Cell[2351339, 46026, 1641, 48, 124, "Input"],
Cell[2352983, 46076, 120, 2, 35, "Input"],
Cell[2353106, 46080, 122, 2, 35, "Input"],
Cell[2353231, 46084, 7519, 200, 300, "Input"],
Cell[2360753, 46286, 275, 7, 35, "Input"],
Cell[2361031, 46295, 1341, 36, 134, "Input"],
Cell[2362375, 46333, 123, 2, 35, "Input"],
Cell[2362501, 46337, 120, 2, 35, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[2362658, 46344, 138, 1, 40, "Subsubsection"],
Cell[2362799, 46347, 39711, 941, 1391, "Input"],
Cell[2402513, 47290, 160, 4, 35, "Input"],
Cell[2402676, 47296, 97, 1, 35, "Input"],
Cell[2402776, 47299, 180, 4, 35, "Input"],
Cell[2402959, 47305, 178, 4, 35, "Input"],
Cell[2403140, 47311, 180, 4, 35, "Input"],
Cell[2403323, 47317, 178, 4, 35, "Input"],
Cell[2403504, 47323, 231, 5, 35, "Input"],
Cell[2403738, 47330, 122, 2, 35, "Input"],
Cell[2403863, 47334, 152, 3, 27, "Input"],
Cell[2404018, 47339, 2269, 61, 98, "Input"],
Cell[2406290, 47402, 203, 4, 35, "Input"],
Cell[2406496, 47408, 147, 3, 27, "Input"],
Cell[2406646, 47413, 122, 2, 27, "Input"],
Cell[2406771, 47417, 127, 2, 27, "Input"],
Cell[2406901, 47421, 2131, 59, 98, "Input"],
Cell[2409035, 47482, 2367, 63, 128, "Input"],
Cell[2411405, 47547, 14049, 407, 714, "Input"],
Cell[2425457, 47956, 1463, 43, 102, "Input"],
Cell[2426923, 48001, 350, 7, 35, "Input"],
Cell[2427276, 48010, 1882, 47, 146, "Input"],
Cell[2429161, 48059, 166, 4, 35, "Input"],
Cell[CellGroupData[{
Cell[2429352, 48067, 129, 2, 27, "Input"],
Cell[2429484, 48071, 12309, 233, 358, "Print"]
}, Closed]],
Cell[2441808, 48307, 124, 2, 27, "Input"],
Cell[2441935, 48311, 3987, 107, 239, "Input"],
Cell[2445925, 48420, 2504, 59, 87, "Input"],
Cell[2448432, 48481, 1618, 48, 102, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[2450087, 48534, 107, 1, 40, "Subsubsection"],
Cell[2450197, 48537, 19786, 561, 1026, "Input"],
Cell[2469986, 49100, 6257, 176, 242, "Text"],
Cell[2476246, 49278, 2281, 69, 97, "Text"],
Cell[2478530, 49349, 3740, 95, 218, "Input"],
Cell[2482273, 49446, 66, 1, 35, "Input"],
Cell[2482342, 49449, 1267, 39, 80, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[2483646, 49493, 191, 4, 40, "Subsubsection"],
Cell[2483840, 49499, 1856, 48, 131, "Input"],
Cell[2485699, 49549, 27669, 654, 1347, "Input"],
Cell[2513371, 50205, 1174, 31, 83, "Input"],
Cell[CellGroupData[{
Cell[2514570, 50240, 124, 2, 36, "Input"],
Cell[CellGroupData[{
Cell[2514719, 50246, 867, 19, 27, "Print"],
Cell[2515589, 50267, 675, 13, 27, "Print"],
Cell[2516267, 50282, 676, 13, 27, "Print"],
Cell[2516946, 50297, 668, 13, 27, "Print"],
Cell[2517617, 50312, 672, 13, 27, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2518338, 50331, 129, 2, 36, "Input"],
Cell[CellGroupData[{
Cell[2518492, 50337, 847, 19, 27, "Print"],
Cell[2519342, 50358, 672, 13, 27, "Print"],
Cell[2520017, 50373, 676, 13, 27, "Print"],
Cell[2520696, 50388, 675, 13, 27, "Print"],
Cell[2521374, 50403, 672, 13, 27, "Print"]
}, Open  ]]
}, Open  ]],
Cell[2522073, 50420, 2890, 70, 91, "Input"],
Cell[2524966, 50492, 2393, 63, 91, "Input"],
Cell[2527362, 50557, 2845, 76, 187, "Input"],
Cell[2530210, 50635, 788, 23, 83, "Input"],
Cell[2531001, 50660, 4601, 118, 336, "Input"],
Cell[2535605, 50780, 1171, 41, 118, "Input"],
Cell[2536779, 50823, 456, 15, 62, "Input"],
Cell[2537238, 50840, 1056, 30, 146, "Input"],
Cell[2538297, 50872, 13135, 359, 742, "Input"],
Cell[2551435, 51233, 5649, 142, 452, "Input"],
Cell[2557087, 51377, 3952, 104, 209, "Input"],
Cell[2561042, 51483, 549, 13, 60, "Input"],
Cell[2561594, 51498, 71, 1, 36, "Input"],
Cell[2561668, 51501, 94, 1, 36, "Input"],
Cell[CellGroupData[{
Cell[2561787, 51506, 467, 13, 84, "Input"],
Cell[CellGroupData[{
Cell[2562279, 51523, 5224, 100, 182, "Print"],
Cell[2567506, 51625, 3379, 65, 116, "Print"]
}, Open  ]]
}, Open  ]],
Cell[2570912, 51694, 534, 16, 60, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[2571483, 51715, 91, 1, 40, "Subsubsection"],
Cell[2571577, 51718, 42006, 1273, 1598, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2613632, 52997, 701, 12, 48, "Subsection"],
Cell[CellGroupData[{
Cell[2614358, 53013, 151, 2, 32, "Subsubsection"],
Cell[2614512, 53017, 91, 1, 35, "Input"],
Cell[2614606, 53020, 5254, 139, 174, "Input"],
Cell[2619863, 53161, 2465, 66, 109, "Input"],
Cell[2622331, 53229, 10385, 249, 391, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[2632753, 53483, 144, 2, 23, "Subsubsection"],
Cell[2632900, 53487, 165, 3, 35, "Input"],
Cell[2633068, 53492, 160, 3, 27, "Input"],
Cell[2633231, 53497, 14493, 347, 570, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[2647761, 53849, 109, 1, 23, "Subsubsection"],
Cell[2647873, 53852, 12659, 301, 661, "Input"],
Cell[2660535, 54155, 91, 1, 35, "Input"],
Cell[2660629, 54158, 424, 12, 58, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[2661090, 54175, 98, 1, 23, "Subsubsection"],
Cell[2661191, 54178, 2875, 79, 175, "Input"],
Cell[2664069, 54259, 3476, 102, 151, "Input"],
Cell[2667548, 54363, 153, 3, 35, "Input"],
Cell[2667704, 54368, 1614, 50, 166, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2669367, 54424, 714, 11, 48, "Subsection"],
Cell[CellGroupData[{
Cell[2670106, 54439, 132, 1, 49, "Subsubsection"],
Cell[2670241, 54442, 31557, 796, 1563, "Input"],
Cell[2701801, 55240, 97, 1, 36, "Input"],
Cell[2701901, 55243, 95, 1, 36, "Input"],
Cell[2701999, 55246, 97, 1, 36, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[2702133, 55252, 164, 2, 40, "Subsubsection"],
Cell[2702300, 55256, 32571, 826, 1655, "Input"],
Cell[2734874, 56084, 211, 5, 36, "Input"],
Cell[2735088, 56091, 293, 7, 36, "Input"],
Cell[2735384, 56100, 22101, 661, 1061, "Input"],
Cell[2757488, 56763, 87, 1, 36, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[2757612, 56769, 133, 1, 40, "Subsubsection"],
Cell[2757748, 56772, 8279, 253, 489, "Input"],
Cell[2766030, 57027, 5784, 172, 317, "Input"],
Cell[2771817, 57201, 550, 14, 58, "Input"],
Cell[2772370, 57217, 689, 17, 76, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2773108, 57240, 342, 7, 48, "Subsection"],
Cell[CellGroupData[{
Cell[2773475, 57251, 117, 1, 32, "Subsubsection"],
Cell[2773595, 57254, 18774, 499, 814, "Input"],
Cell[2792372, 57755, 4760, 103, 192, "Input"],
Cell[2797135, 57860, 644, 13, 61, "Input"],
Cell[2797782, 57875, 41967, 1250, 1334, "Input"],
Cell[2839752, 59127, 8034, 191, 274, "Input"],
Cell[2847789, 59320, 3115, 88, 264, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[2850941, 59413, 178, 2, 23, "Subsubsection"],
Cell[2851122, 59417, 20785, 539, 995, "Input"],
Cell[2871910, 59958, 6433, 151, 297, "Input"],
Cell[2878346, 60111, 761, 21, 58, "Input"],
Cell[2879110, 60134, 592, 12, 61, "Input"],
Cell[2879705, 60148, 21548, 641, 732, "Input"],
Cell[2901256, 60791, 8054, 195, 274, "Input"],
Cell[2909313, 60988, 5634, 148, 280, "Input"],
Cell[2914950, 61138, 116, 2, 35, "Input"],
Cell[2915069, 61142, 93, 1, 35, "Input"],
Cell[2915165, 61145, 119, 2, 35, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2915333, 61153, 724, 12, 48, "Subsection"],
Cell[CellGroupData[{
Cell[2916082, 61169, 131, 1, 49, "Subsubsection"],
Cell[2916216, 61172, 11702, 291, 584, "Input"],
Cell[2927921, 61465, 1396, 31, 60, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[2929354, 61501, 113, 1, 40, "Subsubsection"],
Cell[2929470, 61504, 9112, 245, 536, "Input"],
Cell[2938585, 61751, 299, 8, 36, "Input"],
Cell[2938887, 61761, 207, 3, 36, "Input"],
Cell[2939097, 61766, 97, 1, 36, "Input"],
Cell[2939197, 61769, 96, 1, 36, "Input"],
Cell[2939296, 61772, 2909, 89, 210, "Input"],
Cell[2942208, 61863, 29262, 789, 1557, "Input"],
Cell[2971473, 62654, 22628, 610, 968, "Input"],
Cell[2994104, 63266, 11955, 290, 543, "Input"],
Cell[3006062, 63558, 7793, 196, 359, "Input"],
Cell[3013858, 63756, 2244, 52, 129, "Input"],
Cell[3016105, 63810, 984, 22, 83, "Input"],
Cell[3017092, 63834, 795, 21, 60, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3017924, 63860, 115, 1, 40, "Subsubsection"],
Cell[3018042, 63863, 29620, 777, 1246, "Input"],
Cell[3047665, 64642, 22530, 608, 841, "Input"],
Cell[3070198, 65252, 11753, 287, 498, "Input"],
Cell[3081954, 65541, 2080, 47, 124, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3084071, 65593, 114, 1, 40, "Subsubsection"],
Cell[3084188, 65596, 8412, 217, 389, "Input"],
Cell[3092603, 65815, 940, 27, 100, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3093592, 65848, 244, 6, 48, "Subsection"],
Cell[3093839, 65856, 13832, 407, 761, "Input"],
Cell[3107674, 66265, 1030, 29, 92, "Input"],
Cell[3108707, 66296, 26112, 661, 1275, "Input"],
Cell[3134822, 66959, 1973, 58, 124, "Input"],
Cell[3136798, 67019, 1496, 45, 114, "Input"],
Cell[3138297, 67066, 3026, 87, 227, "Input"],
Cell[3141326, 67155, 156, 4, 59, "Input"],
Cell[3141485, 67161, 424, 11, 58, "Input"],
Cell[3141912, 67174, 101, 1, 35, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3142050, 67180, 382, 5, 48, "Subsection"],
Cell[CellGroupData[{
Cell[3142457, 67189, 161, 2, 49, "Subsubsection"],
Cell[3142621, 67193, 19035, 561, 923, "Input"],
Cell[3161659, 67756, 3954, 115, 269, "Input"],
Cell[3165616, 67873, 481, 11, 61, "Input"],
Cell[3166100, 67886, 14124, 416, 620, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3180261, 68307, 111, 1, 40, "Subsubsection"],
Cell[3180375, 68310, 23747, 695, 1154, "Input"],
Cell[3204125, 69007, 3491, 103, 225, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3207653, 69115, 111, 1, 40, "Subsubsection"],
Cell[3207767, 69118, 977, 25, 58, "Input"],
Cell[3208747, 69145, 28070, 715, 1294, "Input"],
Cell[3236820, 69862, 316, 7, 58, "Input"],
Cell[3237139, 69871, 2250, 69, 166, "Input"],
Cell[3239392, 69942, 601, 18, 80, "Input"],
Cell[3239996, 69962, 3853, 106, 225, "Input"],
Cell[3243852, 70070, 125, 2, 35, "Input"],
Cell[3243980, 70074, 124, 2, 35, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3244153, 70082, 379, 5, 48, "Subsection"],
Cell[CellGroupData[{
Cell[3244557, 70091, 161, 2, 32, "Subsubsection"],
Cell[3244721, 70095, 17633, 523, 879, "Input"],
Cell[3262357, 70620, 7044, 206, 379, "Input"],
Cell[3269404, 70828, 432, 10, 61, "Input"],
Cell[3269839, 70840, 16361, 518, 634, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3286237, 71363, 109, 1, 23, "Subsubsection"],
Cell[3286349, 71366, 26182, 763, 1275, "Input"],
Cell[3312534, 72131, 519, 14, 58, "Input"],
Cell[3313056, 72147, 350, 9, 35, "Input"],
Cell[3313409, 72158, 5405, 143, 229, "Input"],
Cell[3318817, 72303, 246, 7, 35, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3319100, 72315, 107, 1, 23, "Subsubsection"],
Cell[3319210, 72318, 474, 13, 58, "Input"],
Cell[3319687, 72333, 27174, 696, 1248, "Input"],
Cell[3346864, 73031, 95, 1, 35, "Input"],
Cell[3346962, 73034, 89, 1, 35, "Input"],
Cell[3347054, 73037, 1496, 45, 114, "Input"],
Cell[3348553, 73084, 5145, 139, 229, "Input"],
Cell[3353701, 73225, 129, 2, 35, "Input"],
Cell[3353833, 73229, 125, 2, 35, "Input"],
Cell[3353961, 73233, 258, 7, 37, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3354268, 73246, 103, 1, 48, "Subsection"],
Cell[3354374, 73249, 9806, 244, 382, "Input"],
Cell[3364183, 73495, 11210, 312, 426, "Input"],
Cell[3375396, 73809, 4957, 125, 242, "Input"],
Cell[3380356, 73936, 247, 3, 80, "Input"],
Cell[3380606, 73941, 901, 30, 114, "Input"],
Cell[3381510, 73973, 209, 6, 56, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3381756, 73984, 189, 2, 48, "Subsection"],
Cell[3381948, 73988, 30771, 813, 1357, "Input"],
Cell[3412722, 74803, 1984, 49, 102, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3414743, 74857, 103, 1, 48, "Subsection"],
Cell[3414849, 74860, 3619, 105, 347, "Input"],
Cell[3418471, 74967, 1458, 42, 137, "Input"],
Cell[3419932, 75011, 6867, 219, 337, "Input"],
Cell[3426802, 75232, 1097, 35, 58, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3427936, 75272, 177, 2, 48, "Subsection"],
Cell[CellGroupData[{
Cell[3428138, 75278, 147, 2, 32, "Subsubsection"],
Cell[3428288, 75282, 39467, 651, 552, "Input"],
Cell[3467758, 75935, 5722, 171, 410, "Input"],
Cell[3473483, 76108, 2951, 89, 212, "Input"],
Cell[3476437, 76199, 169, 4, 35, "Input"],
Cell[3476609, 76205, 251, 6, 35, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3476897, 76216, 102, 1, 23, "Subsubsection"],
Cell[3477002, 76219, 1476, 41, 124, "Input"],
Cell[3478481, 76262, 830, 19, 84, "Input"],
Cell[CellGroupData[{
Cell[3479336, 76285, 5681, 165, 520, "Input"],
Cell[3485020, 76452, 32074, 785, 399, "Output"],
Cell[3517097, 77239, 32197, 776, 399, "Output"],
Cell[3549297, 78017, 26938, 659, 399, "Output"],
Cell[3576238, 78678, 26919, 659, 399, "Output"],
Cell[3603160, 79339, 32180, 776, 399, "Output"],
Cell[3635343, 80117, 32057, 785, 399, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3667437, 80907, 729, 15, 102, "Input"],
Cell[3668169, 80924, 552, 13, 35, "Output"],
Cell[3668724, 80939, 1212, 26, 151, "Output"],
Cell[3669939, 80967, 552, 13, 35, "Output"],
Cell[3670494, 80982, 1213, 27, 149, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3671744, 81014, 1968, 56, 168, "Input"],
Cell[3673715, 81072, 19005, 423, 399, "Output"]
}, Open  ]],
Cell[3692735, 81498, 914, 26, 102, "Input"],
Cell[3693652, 81526, 119, 2, 35, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3693808, 81533, 105, 1, 23, "Subsubsection"],
Cell[3693916, 81536, 9207, 233, 382, "Input"],
Cell[3703126, 81771, 2810, 86, 234, "Input"],
Cell[3705939, 81859, 611, 15, 80, "Input"],
Cell[3706553, 81876, 1609, 43, 102, "Input"],
Cell[3708165, 81921, 12290, 367, 1004, "Input"],
Cell[3720458, 82290, 1431, 42, 85, "Input"],
Cell[3721892, 82334, 4551, 128, 250, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3726480, 82467, 104, 1, 23, "Subsubsection"],
Cell[3726587, 82470, 4529, 94, 300, "Input"],
Cell[3731119, 82566, 787, 20, 80, "Input"],
Cell[3731909, 82588, 793, 24, 65, "Input"],
Cell[3732705, 82614, 1494, 42, 114, "Input"],
Cell[3734202, 82658, 4163, 118, 264, "Input"],
Cell[3738368, 82778, 3989, 70, 93, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3742406, 82854, 105, 1, 48, "Subsection"],
Cell[3742514, 82857, 1965, 58, 141, "Input"],
Cell[3744482, 82917, 118, 3, 39, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3744637, 82925, 116, 1, 48, "Subsection"],
Cell[3744756, 82928, 1294, 33, 124, "Input"],
Cell[3746053, 82963, 805, 22, 103, "Input"],
Cell[3746861, 82987, 1582, 44, 160, "Input"],
Cell[3748446, 83033, 133, 2, 35, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3748628, 83041, 93, 1, 106, "Section"],
Cell[3748724, 83044, 1725, 57, 180, "Input"],
Cell[3750452, 83103, 2995, 85, 288, "Input"],
Cell[3753450, 83190, 746, 20, 127, "Input"],
Cell[3754199, 83212, 443, 11, 101, "Input"],
Cell[3754645, 83225, 374, 11, 108, "Input"]
}, Closed]]
}
]
*)

(* End of internal cache information *)
