(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[   1292738,      32287]
NotebookOptionsPosition[   1272026,      31720]
NotebookOutlinePosition[   1272391,      31736]
CellTagsIndexPosition[   1272348,      31733]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Init functions", "Section",
 CellChangeTimes->{{3.4834528321758003`*^9, 3.483452835483*^9}}],

Cell["\<\
Creating equatorial Ts and \[Rho] profiles ()\
\>", "Subsection",
 CellChangeTimes->{{3.541259745582222*^9, 3.541259764853324*^9}}],

Cell[CellGroupData[{

Cell["loading Ts and extending by a power-law", "Subsection",
 CellChangeTimes->{{3.4834528490081997`*^9, 3.483452861145*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{
   "Import", "[", 
    "\"\<G:\\\\mathematica\\\\3DMHD\\\\a098\\\\Tsmap098.dat\>\"", "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.4834525633098*^9, 3.4834525851966*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"lpl", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", "imp", "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"1", ";;", "2"}], "]"}], "]"}], "]"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{
     RowBox[{
      SuperscriptBox["10", "12.22"], 
      SuperscriptBox["r", 
       RowBox[{"-", "0.8"}]]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"imp", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
       RowBox[{"imp", "[", 
        RowBox[{"[", 
         RowBox[{"200", ",", "1"}], "]"}], "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"pl", ",", "lpl", ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.4834525875522003`*^9, 3.4834527382482*^9}, 
   3.4834528099458*^9}],

Cell[BoxData[
 RowBox[{"imp", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "1"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.4834526625257998`*^9, 3.4834526850366*^9}, 
   3.4834527516954*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Creating x2 grid", "Subsection",
 CellChangeTimes->{{3.4834567534884*^9, 3.4834567565928*^9}}],

Cell[CellGroupData[{

Cell["old simulations till 200M radial grid", "Subsubsection",
 CellChangeTimes->{{3.5412046276648855`*^9, 3.5412046367441015`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"np", "=", "64"}], ";", 
  RowBox[{"\[Theta]xx", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "x2"}], "-", "1"}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", "h"}], ")"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "x2"}], "-", "1"}], ")"}], "7"]}], "+", "1"}], ")"}], 
      FractionBox["\[Pi]", "2"]}], "/.", 
     RowBox[{"h", "\[Rule]", "0.65"}]}], "/.", 
    RowBox[{"x2", "\[Rule]", 
     RowBox[{"(", 
      RowBox[{"x2tab", "=", 
       RowBox[{"N", "[", 
        RowBox[{"Range", "[", 
         RowBox[{
          FractionBox["1", 
           RowBox[{"2", "np"}]], ",", 
          RowBox[{"1", "-", 
           FractionBox["1", 
            RowBox[{"2", "np"}]]}], ",", 
          FractionBox["1", "np"]}], "]"}], "]"}]}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Cos", "[", "\[Theta]xx", 
  "]"}], "\[IndentingNewLine]", "x2tab", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"x2tab", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"1", "/", 
            RowBox[{"(", 
             RowBox[{
              FractionBox["\[Pi]", "2"], 
              RowBox[{"(", 
               RowBox[{"h", "-", 
                RowBox[{"7", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "h"}], ")"}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{"x2", "-", "1"}], ")"}], "6"]}]}], ")"}]}], 
             ")"}]}], "/.", 
           RowBox[{"h", "\[Rule]", "0.65"}]}], "/.", 
          RowBox[{"x2", "\[Rule]", "x2tab"}]}]}], "}"}], "]"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "\[IndentingNewLine]", 
    RowBox[{"ListPlot", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"x2tab", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "/", 
           RowBox[{"(", 
            RowBox[{"\[Pi]", "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"1", "-", "h"}], ")"}], " ", "\[Pi]", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"2", " ", "\[Pi]", " ", "x2"}], "]"}]}]}], ")"}]}], "/.", 
          RowBox[{"h", "\[Rule]", "0.65"}]}], "/.", 
         RowBox[{"x2", "\[Rule]", "x2tab"}]}]}], "}"}], "]"}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.474038462528*^9, 3.474038532538*^9}, {3.47403863959*^9, 
   3.4740386858199997`*^9}, {3.474038725953*^9, 3.474038739874*^9}, {
   3.474038771481*^9, 3.4740388137650003`*^9}, 3.474038845924*^9, {
   3.47403895655*^9, 3.474039045752*^9}, 3.474121703814*^9, {
   3.4834567714908*^9, 3.4834567957176*^9}, {3.4834569155256*^9, 
   3.483456918552*^9}, {3.5412579720037794`*^9, 3.541257987872687*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["new simulations till 10^5M radial grid", "Subsubsection",
 CellChangeTimes->{{3.5412046276648855`*^9, 3.5412046548401337`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"np", "=", "128"}], ";", 
  RowBox[{"\[Theta]xx", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "x2"}], "-", "1"}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", "h"}], ")"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "x2"}], "-", "1"}], ")"}], "7"]}], "+", "1"}], ")"}], 
      FractionBox["\[Pi]", "2"]}], "/.", 
     RowBox[{"h", "\[Rule]", "1.00"}]}], "/.", 
    RowBox[{"x2", "\[Rule]", 
     RowBox[{"(", 
      RowBox[{"x2tab", "=", 
       RowBox[{"N", "[", 
        RowBox[{"Range", "[", 
         RowBox[{
          FractionBox["1", 
           RowBox[{"2", "np"}]], ",", 
          RowBox[{"1", "-", 
           FractionBox["1", 
            RowBox[{"2", "np"}]]}], ",", 
          FractionBox["1", "np"]}], "]"}], "]"}]}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Cos", "[", "\[Theta]xx", 
  "]"}], "\[IndentingNewLine]", "x2tab"}], "Input",
 CellChangeTimes->{{3.541204667179755*^9, 3.5412046879121914`*^9}, {
  3.541204758673916*^9, 3.5412047589235163`*^9}, {3.5412048070496006`*^9, 
  3.5412048141320133`*^9}, {3.541206002733876*^9, 3.541206016275651*^9}, {
  3.541257994804083*^9, 3.541258004328628*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Creating r grid", "Subsection",
 CellChangeTimes->{{3.4834570884203997`*^9, 3.4834570912752*^9}}],

Cell[CellGroupData[{

Cell["old simulations till 200M radial grid", "Subsubsection",
 CellChangeTimes->{{3.541203848926118*^9, 3.5412038577089334`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", " ", "=", " ", 
   RowBox[{"NotebookDirectory", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", "fnum_", "]"}], " ", ":=", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", " ", "=", 
      RowBox[{
      "\"\<E:\\\\GRMHD\\\\a0\\\\fieldlines\\\\fieldline\>\"", " ", "<>", " ", 
       RowBox[{"StringJoin", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", "#", "]"}], " ", "&"}], " ", "/@", " ", 
         RowBox[{"PadLeft", "[", 
          RowBox[{
           RowBox[{"IntegerDigits", "[", "fnum", "]"}], ",", " ", "4"}], 
          "]"}]}], "]"}], " ", "<>", " ", "\"\<.bin\>\""}]}], ";", "\n", 
     "   ", 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "256", "*", "64", "*", "32", "*", "4"}]}], ";", "\n",
      "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\n", "   ", 
     RowBox[{"res2m", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"llist", " ", "=", " ", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"BinaryReadList", "[", 
                RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                 RowBox[{"11", "*", "32", "*", "64", "*", "256"}]}], "]"}], 
               ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], ",", " ", 
           "64"}], "]"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], "}"}]}], 
       "]"}]}], ";", "\n", "   ", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.48199863871*^9, 3.4819986488344*^9}, {
   3.4821459308244*^9, 3.4821459311208*^9}, 3.4834575605388002`*^9, {
   3.4834576012392*^9, 3.4834576140312*^9}, {3.4834576807524*^9, 
   3.4834576815011997`*^9}, {3.4834577493612003`*^9, 3.4834577829636*^9}, {
   3.4834578209184*^9, 3.4834578352236*^9}, {3.5057603089278*^9, 
   3.5057603097546*^9}, {3.541203794809623*^9, 3.541203794981223*^9}, 
   3.541279953595425*^9}],

Cell[BoxData[
 RowBox[{"read11", "[", "6950", "]"}]], "Input",
 CellChangeTimes->{{3.4834576716108*^9, 3.4834576995972*^9}, {
  3.4834577744772*^9, 3.4834577752728*^9}, {3.4834578390612*^9, 
  3.4834578400128*^9}, {3.5057603134362*^9, 3.505760313795*^9}, {
  3.5060828910062*^9, 3.5060828911778*^9}, {3.541203811454852*^9, 
  3.541203812624854*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"stt", "=", 
   RowBox[{"StringToStream", "[", "strrr", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"x1min", "=", 
    RowBox[{"Read", "[", 
     RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "5"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"dx1", "=", 
    RowBox[{"Read", "[", 
     RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"off", "=", 
    RowBox[{"Read", "[", 
     RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "6"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Close", "[", "stt", "]"}], ";"}], "\n", 
 RowBox[{"rtab", "=", 
  RowBox[{"off", "+", 
   RowBox[{"Exp", "[", 
    RowBox[{"x1min", "+", 
     RowBox[{"dx1", " ", 
      RowBox[{"Range", "[", 
       RowBox[{"0", ",", "255"}], "]"}]}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.4834577893908*^9, 3.4834577902799997`*^9}, {
   3.4834578852528*^9, 3.4834579287455997`*^9}, {3.483457985436*^9, 
   3.4834580282892*^9}, {3.4834580820156*^9, 3.4834581050411997`*^9}, {
   3.4834581675348*^9, 3.483458214756*^9}, {3.4834583189484*^9, 
   3.4834583413812*^9}, 3.4840505656378*^9}],

Cell[BoxData[
 RowBox[{"rtab", "[", 
  RowBox[{"[", "60", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.541279965707118*^9, 3.54127996871729*^9}}],

Cell[BoxData["strrr"], "Input",
 CellChangeTimes->{{3.4834580687244*^9, 3.4834580700192003`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x1min", ",", "dx1", ",", "off"}], "}"}]], "Input",
 CellChangeTimes->{{3.541203824714875*^9, 3.541203830767686*^9}, {
  3.541203927051055*^9, 3.5412039322926645`*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Dealing with normalizations", "Subsection",
 CellChangeTimes->{{3.4834598058264*^9, 3.4834598106468*^9}}],

Cell[BoxData[{
 RowBox[{
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJztnY9zk9eZ7zOz9/+QFwEDDFwglFkPm8I046bgSXypJ2WTYTY/1gGbdgk0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     "], {{0, 91}, {1162, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{487.7599999999992, Automatic},
   ImageSizeRaw->{1162, 91},
   PlotRange->{{0, 1162}, {0, 91}}], " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"n", " ", "rhonor", " ", "mp", " ", 
    SuperscriptBox["cc", "2"]}], "\[Rule]", 
   FractionBox[
    SuperscriptBox["B", "2"], 
    RowBox[{"4", "\[Pi]"}]]}], ";", "  ", 
  RowBox[{"B", "=", 
   RowBox[{"b", "*", "Bnor"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "  ", "rhonor"}], " ", "\[Rule]", 
  RowBox[{"number", " ", "density"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "  ", "rhonor", " ", "mp", " ", 
    SuperscriptBox["cc", "2"]}], "\[Rule]", 
   RowBox[{
    RowBox[{"energy", " ", "density"}], " ", "\[Rule]", 
    RowBox[{
     SuperscriptBox["b", "2"], "\[Rule]", 
     RowBox[{
      RowBox[{
       SuperscriptBox["B", "2"], "/", 
       RowBox[{"(", 
        RowBox[{"4", "\[Pi]"}], ")"}]}], " ", "\[Implies]", " ", 
      "Bnor"}]}]}]}], "=", 
  RowBox[{
   SqrtBox[
    RowBox[{"4", "\[Pi]", " ", "rhonor", " ", "mp"}]], "cc"}]}]}], "Text",
 CellChangeTimes->{{3.4834598198508*^9, 3.4834599156972*^9}, {
  3.4834603058375998`*^9, 3.4834603563972*^9}, {3.4834603893444*^9, 
  3.4834603896876*^9}, {3.4834607880492*^9, 3.4834608602460003`*^9}, {
  3.4834609771212*^9, 3.48346098255*^9}, {3.4834610293968*^9, 
  3.4834610357928*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Separating Tp and Te", "Subsection",
 CellChangeTimes->{{3.4834630829652*^9, 3.4834630870212*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"atab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"nmtab", "=", 
   RowBox[{"{", 
    RowBox[{"8", ",", "8", ",", "8", ",", "9", ",", "9"}], "}"}]}], ";", 
  RowBox[{"ncuttab", "=", 
   RowBox[{"{", 
    RowBox[{"145", ",", "147", ",", "149", ",", "153", ",", "162"}], "}"}]}], 
  ";", 
  RowBox[{"a", "=", 
   RowBox[{"atab", "[", 
    RowBox[{"[", "sp", "]"}], "]"}]}], ";", 
  RowBox[{"nm", "=", 
   RowBox[{"nmtab", "[", 
    RowBox[{"[", "sp", "]"}], "]"}]}], ";", 
  RowBox[{"ncut", "=", 
   RowBox[{"ncuttab", "[", 
    RowBox[{"[", "sp", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xx", "=", 
   RowBox[{"Import", "[", "\"\<E:\\\\GRMHD\\\\a0\\\\Tsmap0.dat\>\"", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhonor", "=", "1042075.25"}], ";", 
  RowBox[{"heat", "=", "0.41929"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoout", "=", "130"}], ";", 
  RowBox[{"rmax", "=", 
   RowBox[{"3.4", " ", 
    SuperscriptBox["10", "5"]}]}], ";", 
  RowBox[{"rcut", "=", 
   RowBox[{"xx", "[", 
    RowBox[{"[", 
     RowBox[{"ncut", ",", "1"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhopo", "=", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"Log", "[", 
      RowBox[{
       RowBox[{"rhoout", "/", "rhonor"}], "/", 
       RowBox[{
        RowBox[{"xx", "[", 
         RowBox[{"[", "ncut", "]"}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}], "/", 
    RowBox[{"Log", "[", 
     RowBox[{"rmax", "/", "rcut"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"rhocon", "=", 
   RowBox[{"rhonor", "*", 
    RowBox[{"xx", "[", 
     RowBox[{"[", 
      RowBox[{"ncut", ",", "3"}], "]"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Ucon", "=", 
   RowBox[{"xx", "[", 
    RowBox[{"[", 
     RowBox[{"ncut", ",", "2"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ruru", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rg", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "6.67", " ", 
        SuperscriptBox["10", 
         RowBox[{"-", "8"}]], "4.5", " ", 
        SuperscriptBox["10", "6"], "2", " ", 
        SuperscriptBox["10", "33"]}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"3", " ", 
          SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
     RowBox[{"arcsec", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
        SuperscriptBox["10", "3"], "3.08", " ", 
        SuperscriptBox["10", "18"]}], 
       RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
     RowBox[{"pc", "\[Rule]", 
      RowBox[{"3.08", " ", 
       SuperscriptBox["10", "18"]}]}], ",", 
     RowBox[{"year", "\[Rule]", 
      RowBox[{"365.35", " ", "86400"}]}], ",", 
     RowBox[{"cc", "\[Rule]", 
      RowBox[{"3.", " ", 
       SuperscriptBox["10", "10"]}]}], ",", 
     RowBox[{"Msun", "\[Rule]", 
      RowBox[{"2.", " ", 
       SuperscriptBox["10", "33"]}]}], ",", 
     RowBox[{"mp", "\[Rule]", 
      RowBox[{"1.67", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "24"}]]}]}], ",", 
     RowBox[{"me", "\[Rule]", 
      RowBox[{"9.1", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "28"}]]}]}], ",", 
     RowBox[{"kb", "\[Rule]", 
      RowBox[{"1.38", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "16"}]]}]}], ",", 
     RowBox[{"h", "\[Rule]", 
      RowBox[{"6.626", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "27"}]]}]}], ",", 
     RowBox[{"ee", "\[Rule]", 
      RowBox[{"4.8", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "10"}]]}]}], ",", 
     RowBox[{"keV", "->", 
      RowBox[{"1000", " ", "1.602", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rategs", "=", 
    RowBox[{"7.722", " ", 
     SuperscriptBox["10", "17"]}]}], ";", 
   RowBox[{"(*", 
    RowBox[{"g", "/", "s"}], "*)"}], 
   RowBox[{"rategs", "=", 
    RowBox[{"ratexx", "/.", 
     RowBox[{
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"0.5", "\[Equal]", 
          FractionBox["ratexx", 
           RowBox[{"2", " ", "cc", " ", "mp", " ", 
            SuperscriptBox["rg", "2"], 
            SuperscriptBox["r", "2"], "\[Rho]fun"}]]}], "/.", "ruru"}], "/.", 
        RowBox[{"r", "\[Rule]", "3"}]}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"this", " ", "is", " ", "a", " ", "self"}], "-", 
    RowBox[{
    "consistency", " ", "check", " ", "for", " ", "the", " ", "radial", " ", 
     "velocity"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rtab", "=", 
    RowBox[{"xx", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";"}], "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"rategs", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"\[Rho]\[Rho]", " ", "U1", " ", "sqdet"}], "/.", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"lr", "\[Rule]", 
               RowBox[{"Log", "[", 
                RowBox[{"rr", "-", "off"}], "]"}]}], ",", 
              RowBox[{"x2", "\[Rule]", 
               RowBox[{"\[Theta]2x2", "[", "\[Theta]", "]"}]}]}], "}"}]}], "/.", 
           RowBox[{"r", "\[Rule]", "rr"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Theta]", ",", "\[Theta]min", ",", "\[Theta]max"}], 
           "}"}]}], "]"}]}], "\[Rho]nor", " ", 
       SuperscriptBox["rg", "2"], "cc", " ", "mp"}], "/.", 
      RowBox[{"ruru", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<Accretion rate = \>\"", ",", 
         RowBox[{"rate", "=", 
          RowBox[{
           RowBox[{"rategs", 
            FractionBox["year", "Msun"]}], "/.", "ruru"}]}], ",", 
         "\"\<  Msun/year\>\""}], "]"}]}]}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"rategs", "=", 
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["rcut", "2"]}], 
      FractionBox[
       RowBox[{
        RowBox[{"dat070", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "32", ",", "3"}], "]"}], "]"}], "+", 
        RowBox[{"dat070", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "33", ",", "3"}], "]"}], "]"}]}], "2"]}]}], 
    ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rntab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"rcut", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["rcut", "rmax"], ")"}], 
       RowBox[{"-", 
        FractionBox["i", "100"]}]]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "100"}], "}"}]}], "]"}]}], ";", 
  RowBox[{"\[Rho]fun", "=", 
   RowBox[{"rhocon", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["r", "rcut"], ")"}], 
     RowBox[{"-", "rhopo"}]]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vrvr", "=", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["rategs", 
      RowBox[{"2", " ", "cc", " ", "mp", " ", 
       SuperscriptBox["rg", "2"], 
       SuperscriptBox["r", "2"], "\[Rho]fun", " "}]]}], "/.", "ruru"}]}], ";", 
  RowBox[{"dcap", "=", 
   RowBox[{"(", 
    RowBox[{"2.", "-", 
     FractionBox["0.49", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"0.7", "+", " ", 
         SuperscriptBox["cser", "2"]}], ")"}], "2"]]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rhofun", "=", 
    RowBox[{"rhocon", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["r", "rcut"], ")"}], 
      RowBox[{"-", "rhopo"}]]}]}], ";", 
   RowBox[{"Tsfun", "=", 
    RowBox[{"Ucon", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["r", "rcut"], ")"}], 
      RowBox[{"-", "0.98"}]]}]}], ";", 
   RowBox[{"Tstab", "=", 
    RowBox[{"xx", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"1", ";;", "ncut"}], ",", 
       RowBox[{"1", ";;", "2"}]}], "]"}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Tsinter", "=", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"Interpolation", "[", 
        RowBox[{"Log", "[", 
         RowBox[{"Join", "[", 
          RowBox[{"Tstab", ",", 
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"rntab", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"Tsfun", "/.", 
                 RowBox[{"r", "\[Rule]", "#"}]}], "&"}], "/@", "rntab"}]}], 
             "}"}], "]"}]}], "]"}], "]"}], "]"}], "[", 
       RowBox[{"Log", "[", "r", "]"}], "]"}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Tsinter", "=", 
   RowBox[{
    RowBox[{"Interpolation", "[", 
     RowBox[{"Join", "[", 
      RowBox[{"Tstab", ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"rntab", ",", 
          RowBox[{
           RowBox[{
            RowBox[{"Tsfun", "/.", 
             RowBox[{"r", "\[Rule]", "#"}]}], "&"}], "/@", "rntab"}]}], "}"}],
         "]"}]}], "]"}], "]"}], "[", "r", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sysm", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"tail", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Dts", "=", 
               RowBox[{"D", "[", 
                RowBox[{"Tsinter", ",", "r"}], "]"}]}], ";", 
              RowBox[{"\[Nu]c", "=", 
               RowBox[{"8.9", " ", 
                SuperscriptBox["10", 
                 RowBox[{"-", "11"}]], 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox[
                   RowBox[{"Te", "[", "r", "]"}], 
                   RowBox[{"3", " ", 
                    SuperscriptBox["10", "10"]}]], ")"}], 
                 RowBox[{"-", 
                  FractionBox["3", "2"]}]], 
                FractionBox["\[Rho]fun", 
                 SuperscriptBox["10", "7"]]}]}]}], ")"}], 
            FractionBox[
             RowBox[{"2", " ", "mp", " ", 
              SuperscriptBox["rg", "3"], 
              SuperscriptBox["r", "2"], "\[Rho]fun", " "}], "rategs"], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Tp", "[", "r", "]"}], "-", 
              RowBox[{"Te", "[", "r", "]"}]}], ")"}]}], "+", 
           RowBox[{"2", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               FractionBox[
                SqrtBox[
                 RowBox[{"Tp", "[", "r", "]"}]], 
                RowBox[{
                 SqrtBox[
                  RowBox[{"Tp", "[", "r", "]"}]], "+", 
                 RowBox[{"heat", 
                  SqrtBox[
                   RowBox[{"Te", "[", "r", "]"}]]}]}]], ")"}], "-", 
              RowBox[{
               FractionBox["1", "dcap"], 
               RowBox[{"(", 
                RowBox[{"1", 
                 FractionBox[
                  RowBox[{"heat", 
                   SqrtBox[
                    RowBox[{"Te", "[", "r", "]"}]]}], 
                  RowBox[{
                   SqrtBox[
                    RowBox[{"Tp", "[", "r", "]"}]], "+", 
                   RowBox[{"heat", 
                    SqrtBox[
                    RowBox[{"Te", "[", "r", "]"}]]}]}]]}], ")"}]}]}], ")"}], 
            "Dts"}]}]}], ";", 
         RowBox[{
          RowBox[{
           RowBox[{"Te", "'"}], "[", "r", "]"}], "==", 
          FractionBox[
           RowBox[{
            RowBox[{"2", "Dts"}], "-", "tail"}], 
           RowBox[{"dcap", "+", "1"}]]}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Tp", "'"}], "[", "r", "]"}], "\[Equal]", 
         RowBox[{"tail", "+", 
          FractionBox[
           RowBox[{
            RowBox[{"2", "Dts"}], "-", "tail"}], 
           RowBox[{"dcap", "+", "1"}]]}]}]}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\[Theta]e", "\[Rule]", 
         FractionBox[
          RowBox[{"kb", " ", 
           RowBox[{"Te", "[", "r", "]"}]}], 
          RowBox[{"me", " ", 
           SuperscriptBox["cc", "2"]}]]}], ",", 
        RowBox[{"cser", "\[Rule]", 
         SqrtBox[
          FractionBox[
           RowBox[{"kb", " ", 
            RowBox[{"Te", "[", "r", "]"}]}], 
           RowBox[{"me", " ", 
            SuperscriptBox["cc", "2"]}]]]}], ",", 
        RowBox[{"cspr", "\[Rule]", 
         SqrtBox[
          FractionBox[
           RowBox[{"kb", " ", 
            RowBox[{"Tp", "[", "r", "]"}]}], 
           RowBox[{"mp", " ", 
            SuperscriptBox["cc", "2"]}]]]}]}], "}"}]}], "/.", "ruru"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{"FindRoot", "::", "\"\<lstol\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tosol", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{"sysm", ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"Tp", "[", "r", "]"}], "==", "Tsinter"}], ",", 
         RowBox[{
          RowBox[{"Te", "[", "r", "]"}], "\[Equal]", "Tsinter"}]}], "}"}], "/.", 
       RowBox[{"r", "\[Rule]", "rmax"}]}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"solnew", "=", 
   RowBox[{
    RowBox[{"NDSolve", "[", 
     RowBox[{"tosol", ",", 
      RowBox[{"{", 
       RowBox[{"Tp", ",", "Te"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"r", ",", 
        RowBox[{"rtab", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", "rmax"}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"lpl00", "=", 
  RowBox[{"LogLogPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Tp", "[", "r", "]"}], "/.", "solnew"}], ",", 
      RowBox[{
       RowBox[{"Te", "[", "r", "]"}], "/.", "solnew"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", 
      RowBox[{"rtab", "[", 
       RowBox[{"[", "nm", "]"}], "]"}], ",", "rmax"}], "}"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<T, K\>\"", ",", "None"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "\"\<r  measured in \!\(\*SubscriptBox[\(r\), \(g\)]\)\>\"", ",", 
         "\"\<Red - \!\(\*SubscriptBox[\(T\), \(p\)]\), blue - \
\!\(\*SubscriptBox[\(T\), \(e\)]\); dashed - old model; solid - new \
model\>\""}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Red"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Blue"}], "}"}]}],
       "}"}]}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "650"}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
       RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", "16"}]}], "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox[
   RowBox[{"Tp", "[", "6.", "]"}], 
   RowBox[{"Te", "[", "6.", "]"}]], "/.", "solnew"}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox[
   RowBox[{"Tp", "[", "3", "]"}], 
   RowBox[{"Te", "[", "3", "]"}]], "/.", "solnew"}]}], "Input",
 CellChangeTimes->{{3.4834636103388*^9, 3.4834636696968*^9}, {
   3.4834637181972*^9, 3.483463909968*^9}, {3.483464244042*^9, 
   3.4834642699692*^9}, 3.4834643070192003`*^9, {3.4834643425248003`*^9, 
   3.483464342712*^9}, {3.4834645751052*^9, 3.483464580222*^9}, {
   3.4834648283087997`*^9, 3.4834648597584*^9}, {3.4834652891484003`*^9, 
   3.483465387678*^9}, {3.4837022693568*^9, 3.4837022740992002`*^9}, {
   3.4837023050028*^9, 3.4837023305712*^9}, {3.4837026416782*^9, 
   3.4837026653901997`*^9}, {3.4837026982438*^9, 3.4837026983218*^9}, {
   3.4837027290694*^9, 3.4837027606126003`*^9}, {3.4840698681808*^9, 
   3.4840699216264*^9}, 3.485208462080637*^9, {3.5412586476474237`*^9, 
   3.5412586779961596`*^9}, {3.5517162745392466`*^9, 
   3.5517162852088566`*^9}, {3.5517165038173604`*^9, 3.551716530966913*^9}, {
   3.551716752546587*^9, 3.5517167630651884`*^9}, {3.5517168975668817`*^9, 
   3.55171690348822*^9}, {3.551716983533798*^9, 3.55171701293248*^9}, {
   3.5517171162643905`*^9, 3.551717116765419*^9}, 3.551717313892694*^9, {
   3.551720141751438*^9, 3.5517201563032703`*^9}, {3.55180259907298*^9, 
   3.551802600163042*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"rtab11", "=", 
   RowBox[{"xx", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"1", ";;", "ncut"}], ",", "1"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]tab11", "=", 
   RowBox[{"rhonor", " ", 
    RowBox[{"xx", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"1", ";;", "ncut"}], ",", "3"}], "]"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rtab22", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"rcut", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["rmax", "rcut"], ")"}], 
       FractionBox["i", "500"]]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "500"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]tab22", "=", 
   RowBox[{"\[Rho]fun", "/.", 
    RowBox[{"r", "\[Rule]", "rtab22"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rtab", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"rtab11", ",", "rtab22"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]tab", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"\[Rho]tab11", ",", "\[Rho]tab22"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListLogLogPlot", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"rtab", ",", "\[Rho]tab"}], "}"}], "]"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Tetab", "=", 
   RowBox[{
    RowBox[{"Te", "[", "rtab", "]"}], "/.", "solnew"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Tptab", "=", 
   RowBox[{
    RowBox[{"Tp", "[", "rtab", "]"}], "/.", "solnew"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"solful", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Te", "\[Rule]", 
     RowBox[{"Interpolation", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"rtab", "/", "2"}], ",", "Tetab"}], "}"}], "]"}], "]"}]}], 
    ",", 
    RowBox[{"Tp", "\[Rule]", 
     RowBox[{"Interpolation", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"rtab", "/", "2"}], ",", "Tptab"}], "}"}], "]"}], "]"}]}], 
    ",", 
    RowBox[{"\[Rho]", "\[Rule]", 
     RowBox[{"Interpolation", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"rtab", "/", "2"}], "]"}], ",", "\[Rho]tab"}], "}"}], "]"}],
       "]"}]}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"solful", ">>", 
  "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring \
umd\\\\NGC3115\\\\spin0solution.dat\>\""}]}], "Input",
 CellChangeTimes->{{3.551717211407832*^9, 3.5517172820638733`*^9}, {
  3.5517173209851*^9, 3.551717385474788*^9}, {3.5517174297273192`*^9, 
  3.5517176072244716`*^9}, {3.551717892736802*^9, 3.5517179205923953`*^9}, {
  3.551718551463479*^9, 3.551718613119005*^9}, {3.551718648239014*^9, 
  3.551718747784708*^9}, {3.5517199553527765`*^9, 3.55171995680486*^9}, {
  3.551720322416772*^9, 3.551720340883828*^9}, {3.5517544865658493`*^9, 
  3.551754514469445*^9}}],

Cell[CellGroupData[{

Cell["With cooling", "Subsubsection",
 CellChangeTimes->{{3.5518027279413505`*^9, 3.5518027292884274`*^9}}],

Cell[BoxData[{
 RowBox[{
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJztnW9ME9n6xye5b+dNX/KChF+aJrwwMabhBYRsygvImiZlo2kIaggQDZhd
UrhGqoY/5lowMsbdNr/d6q7NrgTX6rVhr3XXylJd6oai7S5DpHHLSr3tSpUi
f5pCwE4Z75yZaTsznUILWGQ5n8REy3h6aL9z5jnP85zn+b96zYH6fyAIcoT6
M0f9AX9/B4FAIBAIBAKBQCAQCAQCgUAgEAgEAoFAIBAIBAKBbCnkcmjC/cBq
obhrd/85s7y6TROJzvvcdms/mEi/7ZEnuExu00QgO49YxGNuVuQjSVCp6my/
dyG3IiKJ0GNT8365svWydcjldjkHv++pLZWpuu5OhqGcIetBRifNdYWlNee+
NlPLoPlKu3ovK+eic465WO7mER7Bygtktd+NRzhvSgRsWgUi01j8yzmbCWRH
EvX21mtM45zllwgOdalQIGVptdmXq8VwZbL3CIoo9XhE8INVr6kCQQvbh8I5
mglkJ0K+He+/5p4TynVpWLcHaFmKuYkcTeSFuaoAQerMgajwR0FLDTWVfXo8
d88HyN+GgKVGmtM1OYbr91H3zp5G60vBO5IBcxWl5AqTd7v2oJAdDK1kWYs1
mLJCvi9e2zS0fV7UZguucF6PTlmOSxDZIfMkFDIkW8hZW3NecbPVnyPTAhCb
c5wrot0msqrPh1gxk0TwnrYoT1bb5xV3xpFE5E1wLabn+e5Ecnk+6POMBSLs
cMScD3/sHPEEeZcRkYBnxOnyznDvqawhl2dfeH53OZ0j7rGJGehNzDnkPG44
Vmcai+T4oydnhruUKOMELGrqHZ+PBgc6ygrLtBZvJNVEXgm5r2uVhci6SE/a
ZqIRj9VkPN+klNPjM/tK6jZ5iFUxjhq0UDs4y/y+xMsh7LCMefWT3o09CcjI
8wemtipVQ8+NASeO4yN3sCp159ArKOacQUb+tFHfI1pSi90Zn8uZaRGH+Guw
Yz/KurT3yIuqdPf+FLuhVoKD58okclVTew9GcaamuFJzAaPpblWXq1u7sTj6
PmeQYIaILdjPAKf5nm7n0ioRHOis67gx9KtVp0QSO0pqAp2faq/dGzDW54FX
GyzBbJ9LjHO+sKzjnj+xzhMvLI17kVKjB25a3z+rwcfX9a1qeV4yOlJ2bjC4
qcfrRiBePzEclrBT2FdjeBTXYQJyefzr6upLdv8i+4PYU2PD9fjWdMZ++rw9
LLqSEtNWDTVyXqt9IeI2tHyNg6WeCFoaqHeSaGyz4GF0snPwL0q7hBuTbsR3
E5tzfq6SFpR1DHCmzTgY4aY1hxCRkG/0vkmrlMbXxUqTN5rLRyL1xH9kqD10
skerYueQr2g2e7jWRdRjqtfZQ0mFrXq/rTU+Za+gVF37bRrBMJvKvZp7Y47z
mHWKuUlnHe3F1LtU9j6bHb7cfZfZGlDybkQZeWczeRBjkqFo+eeuMHfxJaYH
O4plB7sd0LrIMcCA7FIW0EJS6JzzOXxfyjBW0DvNWGS8r7GIeUCgvB3f8quJ
ANfiWPaajrc7WMWRvt7KGktQdPiwvZUaDz127faVS44QO8KKC9tLaVZ99Ynd
cMkxl1jYW+UIIqu1+LPQHum31FF2e4nWPg0V+8FARr2mSrAoSkoTy937fsvQ
w86yfEmdZYrVASNsJhukQGUcEw9Xvx3Vf9Rqm2XmuBq2n94jbhGQS87uPeDW
rNde/jURCop5jKXUiyXtV7+59igRml90tIO3VZu8mYfIySX3RWpxR4ovupeg
kD8kyJfWxj05DPMtuLGPKR0kVldmEkkxSzTW6dSJ0Pqp7I0bydT6rE4z4SWP
sRKs78XnhmYTtya4Hoz9cY3uxwCZGJPRfHYbNGYZRwp0zpxvLSBrw3zLlAH5
Zy6WGHYZTPUVUPu7K3QWSKnOuZDy3+adunLOUyPixhTiSl59ZqqgbIuCSpMn
6ZGh7IFaWcp2IILrldRrezGXuCbJSIBJf+2/P+KP2zlsjFJaYwlk94tD3jsr
vt7DubOTmeQKUa8X+3QobLBOCX8ybW2UcJdxEJpEG6yhlOFJv7maEhpab/a/
Tb46awO+DGRfs42zF2M1L3g6MMQinlta1QHN1Z+cboe5VZEMgzJGuPjtBtlW
yFe25n25812wOUuHe32pCyFYaRGk0uhZEvwfr+kQKjlhS1oLdJBdJNeI9b+h
1WbOFg4Y1Xkpli3YM1Iv5p0Grjwy/Op14me0EzvvyOWnTN4gc6fHZ8Uqea/G
9lrktyNejoz8N+fe+d0FuRz0jD1POSESC7s+L5eoDfh8rnYvYVz/CSp4+rNT
9JmrpZLqvueCe2rpCVYs4YuTSXxK3akxRqwgIYqyTKgbRFKiH+Us07FZ2wmg
+VpLkFwYv/7VTS+TZcp42KTx6cXD6I0WP+M3ZldytLDlnsBzQS6/uH/xCyvM
r36/MN8mghbV99z4xcPkBhCz3kFDTfERbOhlDvMuKPNzzFS7D5Ed4yVLk4v+
/hN7RGI0TGaRQJyLuJ7aNuZVmJ7x7kzGCBeYFm9H9SUSRJgRzaz/SF7DlR8v
n+2moyT0NGgPW95JsP6TYd+DbzQKuaqjnxNGjwatLTImmqMfoD9JkogEvcPm
rha9PfcBpl0HEXJg8RgE7bqVSgukFY1YPx7ahg8fxMq/OFokKant+e42taW6
fU3fcrRBd9MtMhk6zCHM1mPcDvkVxjGOZMkVN7ZXaFowCfwIUmLA33LXUOZe
oNbvg132vxI38upkL/XAQOQ1be2fVirVTbpr9z0h4W1OLnhunlFyP0x5dZvp
UWDbTkTuNqilY9rn+d0NGPMGZiLC6PD2zcfzIhRJ91ggiZk/xwIpSRnkUnDC
P7+JXwGYW795Arz3ZU2ODBySicn/7vFNb/cnCYEIiIWsTdRSm9/uWEy+SJnK
rgH8zY4S6+ryQhhml+5mWOtCctjw5DVYlolp3IK1dPaLpZt+uJDT9052PoDH
IXc3Ee8NTVHcBKY2yJj1Wa7ztzcJ4bM0VqQeLoPsPijLfILeTKRa5x88TOK3
wHsDgewkovPen79qKAXPkxLM8TIYDL6BW1HIDoOcGrrYUltzUAF8g6hUcbCG
4jOzdydZ9xBInNhTY6kkt6nmfMjl+VdrnhtOz6t56GuBsLAxICaTZFsmwHh+
NsSGDwVD/na89ZvrUfr04lb634hpvN/QrFTr8cX1L4ZANg+bEytS3GnjQwYH
u4+p6IILCswtrOMHgbwX2NOLW+5/Y9IOt1/JG7Ra+C3sNzwIZPNk9j2Ti45O
cBZn6wsUfChKhuwOwm6sXCTNdQvIRslEOMCmqGXL754gPN8LSfjf+DnYZMTv
tBiaKz/Su+c9t7TKkrLm66D6OkgmudRcpZAieXLlsXbTsLBmDjHl7O1uogxk
aVlNe6dGkZehkld9Nw5JN+a8yJMf/yEApbzrYf1voHoYpYbY4pvZ5dWX9u4G
JV1pKv9Iw3HVfjpo8rEeD4IzO5IGs3/5HRn+w1QvQfLL9b8lz5tFJ8x1crbj
APHadfkofawAWheQHMBWUqL9b2R08vYZw2O6XwtbQAwpvuAMx4jQ2MBDb4Qp
H5bIwGYOCCfLLyw9762TcLeN7IkbqGRIDmBOcuWVG93T3jtdp29PsgchWSXz
Dg6AAy9Y182ndHJULIJ/qeReER5qL0Q5wn4Hd3x/F1ZmPL8IS158cIPHKysi
+fzKvWJKZgBHFE1tVZVVxw7KOVeAYh7UP3llyqCSP3jARnvEbv2PzTEqXr57
+Y/bzeWcDcy+GsPIzFapeWsHB3XORz2BMF+xokomieBgl6pU1XELHOFkrAv2
irg1siOVTEYDI/2WH+ze3XTCgFzwWv+/o+sbq2PUG/B7XT9g1ZWNvYKK6GFc
f0DGdAx0DtzoqafT7+WNFp/oEb+0uTPimTHZDb5RRJRMzj3qKsuX1N5kix7w
lBx3SvNO7+4QJS+PGVUFu6o2FBmZsHadveJ6zV2mop7L5UhZR6Kw5zsQMtMe
+BJPPqnprRCSrogctdC571q+/0qTWGaZ1Eo6zRItUrfqzY7J5J2S3eAbJlXJ
5Iqzq4Bb1I6nZKbWE4ivdDln45PdCUoGBbHVTD++3aJkImDrbOPV2WBfBzt6
bu4NGbBfd/Kf9iFrA7reuWu2QhGnSgwR9rtuaEHxxvxE2fANDp41rJK5xRhZ
S7joVP/kfMT38Cpz6+Vrrt03XbwbIMlZFwZKt6Jlp834NKgJ7L3VXESJe2/j
jRHPxEwu66JkDKg+VPGR4iPJ7lHy0vO+zvPDYtYoU/IlXUFmBkala4aD2Qpd
wgzhWNh5ARSqRQrr0hVqzmDw7CBDeP/XbBtcWVX7VSvOyDDZFwOVqrruPnN8
VcG7y6gL7F0HpfGARVFj28n91AWFymZDPy5SRHXbAfZSuRob/qlHukuUTEaf
X//s/LBoY2wmsrB2PiR9TXopAtiqdEh+p2ORfxVboRThO7iyGnwLWZnxjsZP
KYJDi795BYttLBIYc9gfjoDXF32PHm5LeZ+MIEOODqXK4I7E22z8/ZVMTttP
nxWrzEyx6DEeWC8fElyDlhvwtbID2NLKIncE+zmns4QzGRySCjFt0+6t+vYP
alO9a5RMTt890T28JPqj2UFtIYqqroynP39DBu8cL/wEc82uJTV24RW5I9ho
cpqu3BkNDhFCElPW5r31vc/pb3VLlExEZsTcTzNpC2RlMuacD3c5nY/xidBW
nO+invu6bp7tSixGVuiIbsCmVaDFbfem0j9AQQWJ/XXmiTXLycYr5KdmCIMn
YBkt5EMmb8rNlNHgkBTA56ZM+i03oWRy+aXbcknDHCkQBW3MvsndO1C+ePhK
Q1GiyRq16egbF5YAik5ZLlwRlllegxn7mYtx23XObTzVqtOber9sU5crFPsk
yp6hNWpskgtPL39Wv37/TaZCfoolnEjCQfd3DP6VWiwxs8EhApYmzZ+WNFun
Ell8G1RyLDL5o05VSO2KFTUnddj59oYK2gxEZeqTPSKtHjOHrsIN/FEKNTjo
fojO5kJlx+8EuSMtPbl4on8q87FXXBfP3I9Xrl8Jum4bwQQvGXv/8/Ptc+US
MY0xkAvjpk8reU330sDWVZaUYL+AUhNBn8c9PGj+ollZCPzJbaYHvpS9ZuaD
Q3hQm/e+6pIOboe7DSmZXPb21cpQtKzzjnc2PlZ0bvRKlWSTJ2TpViOyAx03
Xcnu0sSs19qlkpZx/FrUgqy76M6iOcKq91pTui4qzPG3wjb7bMpOjFzw3jxV
zVcaGRnrM/wcTBkrbgnLFOojbECEQVZvdIntM7MZHMIDhPOUvDDWu40omQl3
IkX8OwLAtG7ktV0gI4GxdQ4LjCa7n0c9pgNH4z0RuKwEbW0ljVa2hvzSE+zo
d9n0kiCClvOX05oiTCJZSrcFsGAek6FlDecSD5keXetRpVwu5uJgzzVz4rxE
JIDb9HW0XVEqDIVnNziEA4jdqCuwEeETLmslMz3IRJsqRgPmOkFYM+F8Sk/y
rWOeqw2pLRvY+fvMR87SZRxis7buM9m1dOQayamwxe354bUVv+Uzmeh8RZus
seea0T06vnskGUWVH7cmjkRkOTgkCbmEG8olH7devWUR8G+sBmyt8hStX9P/
fuiNrGUcsHH58ssekSWRkQRXySADXNZwPZ5nKNQMGfH2tyrjSiaJVxMTc+m+
R2rR6zDgi0DSnxmya+nIM5JTYVoDoyLtdzKH7S0l0kaK7UWFpBbVh2yAeLbe
+og1F+ON04imPfY4ZW0o5FsX1PU6zskykdWP9PXVZiahmMd0wuKnDJCm3oms
LPG1jOR3iV5UIq3TMn8HtreUaPGf5GNp7c8Wkgmxeff3mCgXNEqwmEjkNWfo
f3/vnl9DVowUPxYvR8NkDvBiWCTx5vWb5I5G7DlOvHnxV2YuqJBVgw04L+os
U1l5Xqm7qSN9Hhf5FjeUIJssE8F2I5IkLHkuiTj19hW52hVkZyczq67o2kKZ
ryfzRHuTJRG1SLOY6qWjx479866IWhLNTK2/eGYEnuEZe6s6vZIZsx8t1A5u
PMDG9nYXdKdiZ8beKZTOk326Ie+B7JRMS5HX4TEO9dSvLEDLP3eF113SN65k
TCpvtc/wX10Jua9rVcoGfb9jFMfv6srLLrm4pj6Q2T7xLpB0F4OWQhSRaSwb
b6KX0KpYr0wQh5LTQi4Teo0gW0t2Sl4NO84WinxlkT9MNRJBfz0RNq3k4rMO
3gOaDqMk2mKyQeE6cyD5WABG8pcm7J//9qdGH8ig/ZQCQfd3Dr3ahMbiob2U
hEyQ0t++nz1e1/VoDur4vZKtFw4UQygp53rzyEW/7V/lxU2968j43WaVHLQc
5bVkoru7olx7Zh43nW4x/MpZ+xhPcjg0pD/1Ld+jywSRZXWG4anNbMPYVZ2y
gjWW5/GMk4DXPXjjQi0TcJdWavtcIRjFe99k7U8miTncrK2p1V0fdD5x2m8b
25uasTvjc5nswjaj5NWwvfOw+UVSELQ9Ix6bSxL3JFO3m/0r7akv+u45XO7H
DuvV9ipVbeZdNRN2ePIQNDGDW01fnKlJ5odwyZMrDze0YibryOQ8zAz6kCEi
wQkcdIT871wWjUE3o+R5p+6wzpmMUMc8xlJh47wUBJ7kRNWyLKYdi3huaVUH
NFd/crod5lZFSrdWyC5kE0oGdc+OcgxgxkNeUMVdpVNYx5O8PrQdnnckHkBf
8fUeRpBKYxY5eJC/JRtXMsjP4QXhGCXnV/KESq2f9ge+Jc41a6RbrAsZnTTX
yaRxO5wkgve0RXmyRovI5hGyu2BSjNYzCUQAscV83pEi1veFquJn7cmwj7KE
u3/mpJatnW6xHqTfUleI5J0ELkdQsecbjUKu6thhzVIhWw21P7KZja1KJtdR
qmrW997FM/evzthby2oFpzWZdDIQnpMrjxxUyD/RsrXO4sRwQ9sa6RbrwDZ/
kde0tX9aqVQ36a7d9wiT/yCQ7KCM5I+OiUWT481M3RMzqU/80M+G/rWs6LXf
ctZ2QrLl9ScguxwyNPbrRG7PB8VC1iZUaAhRprJrAH8DrWTIDoK1LiSHDU/o
ulugDjzW0gntZMiOI+K9oSlKVHkrqsesz+C5UcjOJG6Hs+V6IBAIBAKBQCAQ
CAQCgUAgEAgEAvlw+R9ERMMV
     "], {{0, 92}, {238, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{170.8000000000002, Automatic},
   ImageSizeRaw->{238, 92},
   PlotRange->{{0, 238}, {0, 92}}], ";", " ", 
  RowBox[{
   FractionBox[
    SuperscriptBox["B", "2"], 
    RowBox[{"8", "\[Pi]"}]], "\[Equal]", 
   RowBox[{"\[Rho]fun", " ", "kB", " ", "Tp"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   FractionBox["dTe", "dr"], "=", 
   RowBox[{
    FractionBox[
     RowBox[{"dTe", " "}], 
     RowBox[{"vr", " ", "dt", " "}]], "=", 
    RowBox[{
     FractionBox["Te", 
      RowBox[{"vr", " ", "trad"}]], "=", 
     RowBox[{
      RowBox[{
       FractionBox["Te", 
        RowBox[{"cc", " ", "vrvr"}]], 
       FractionBox[
        RowBox[{"4", "\[Sigma]T", " ", "\[Gamma]", " ", 
         SuperscriptBox["B", "2"]}], 
        RowBox[{"3", " ", "8", "\[Pi]", " ", "me", " ", "cc"}]]}], "=", 
      RowBox[{
       RowBox[{
        FractionBox["Te", 
         RowBox[{"cc", " ", "vrvr"}]], 
        FractionBox[
         RowBox[{
         "4", "\[Sigma]T", " ", "\[Gamma]", " ", "\[Rho]fun", " ", "kB", " ", 
          "Tp"}], 
         RowBox[{"3", " ", "me", " ", "cc"}]]}], "=", 
       RowBox[{
        FractionBox["Te", 
         RowBox[{"cc", " ", "vrvr"}]], 
        FractionBox[
         RowBox[{"4", "\[Sigma]T", " ", "kB", " ", "\[Rho]fun", " ", "Tp"}], 
         RowBox[{"3", " ", "me", " ", "cc"}]], 
        RowBox[{"(", 
         FractionBox[
          RowBox[{"kB", " ", "Te", " "}], 
          RowBox[{"me", " ", 
           SuperscriptBox["cc", "2"]}]], ")"}]}]}]}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"3", "\[Rho]fun", " ", "kb", " ", 
     FractionBox["dTe", "dt"]}], "\[Equal]", 
    RowBox[{
     RowBox[{"-", "\[CapitalLambda]"}], " ", 
     SuperscriptBox["\[Rho]fun", "2"]}]}], " ", "\[Implies]", " ", 
   FractionBox["dTe", "dr"]}], "=", 
  RowBox[{
   FractionBox["dTe", 
    RowBox[{"vr", " ", "dt"}]], "=", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["1", 
      RowBox[{"cc", " ", "vrvr"}]]}], 
    FractionBox[
     RowBox[{"\[CapitalLambda]", " ", "\[Rho]fun"}], 
     RowBox[{"3", "kb"}]]}]}]}]}], "Text",
 CellChangeTimes->{{3.551802793649109*^9, 3.5518028010605326`*^9}, {
  3.551802994975624*^9, 3.551803020049058*^9}, {3.551803132294478*^9, 
  3.5518031595780387`*^9}, {3.5518035359755673`*^9, 3.5518035406768365`*^9}, {
  3.551803621069434*^9, 3.551803675672558*^9}, {3.5518037616974783`*^9, 
  3.5518037874619513`*^9}, {3.5518044264034967`*^9, 3.551804442664427*^9}, {
  3.5518046608499064`*^9, 3.5518046815570908`*^9}, {3.5518047567093897`*^9, 
  3.551804828189478*^9}, {3.552074611683524*^9, 3.5520746666466675`*^9}, {
  3.5520747206107545`*^9, 3.552074726859112*^9}, {3.5520747628051677`*^9, 
  3.552074780886202*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"cc", " ", "vrvr"}], "/.", 
   RowBox[{"r", "\[Rule]", "10"}]}], "/.", "ruru"}]], "Input",
 CellChangeTimes->{{3.5518027620253*^9, 3.5518027791512794`*^9}, {
  3.5518051392512693`*^9, 3.551805144264556*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"imp", "=", 
    RowBox[{
     RowBox[{
     "Import", "[", 
      "\"\<C:\\\\study\\\\accretion\\\\! 2012 1spring \
umd\\\\NGC3115\\\\Sutherland_cooling.xls\>\"", "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"for", " ", "nH"}], "=", "1"}], ";", " ", 
    RowBox[{"ne", "=", "1.2"}], ";", " ", 
    RowBox[{
     SubscriptBox["log", "10"], 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["\[CapitalLambda]", "net"], "[", 
       RowBox[{"erg", " ", 
        SuperscriptBox["cm", "3"], 
        SuperscriptBox["s", 
         RowBox[{"-", "1"}]]}], "]"}], ")"}]}], ";"}], " ", "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"Tex", "=", 
   RowBox[{
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}], "+", "0.05"}]}], ";", 
  RowBox[{"\[CapitalLambda]ex", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", 
      RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Tran", "=", 
   RowBox[{"Range", "[", 
    RowBox[{"Tex", ",", 
     RowBox[{"Tex", "+", "6"}], ",", "0.1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalLambda]ran", "=", 
   RowBox[{"\[CapitalLambda]ex", " ", "+", 
    RowBox[{"0.5", 
     RowBox[{"(", 
      RowBox[{"Tran", "-", "Tex"}], ")"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalLambda]tot", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"imp", ",", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"Tran", ",", "\[CapitalLambda]ran"}], "}"}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{"\[CapitalLambda]tot", ",", 
   RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Xcool", "=", 
  RowBox[{"Interpolation", "[", "\[CapitalLambda]tot", "]"}]}]}], "Input",
 CellChangeTimes->{{3.5520709428757257`*^9, 3.5520710101425734`*^9}, {
   3.552071063363618*^9, 3.552071087099975*^9}, {3.55207424619862*^9, 
   3.5520742707620244`*^9}, {3.5520743924499846`*^9, 
   3.5520743987743464`*^9}, {3.552074555454308*^9, 3.55207456562389*^9}, 
   3.552074609774415*^9, {3.5520747937989407`*^9, 3.552074825104731*^9}, {
   3.5520753685648155`*^9, 3.552075380970525*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sp", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"atab", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"nmtab", "=", 
   RowBox[{"{", 
    RowBox[{"8", ",", "8", ",", "8", ",", "9", ",", "9"}], "}"}]}], ";", 
  RowBox[{"ncuttab", "=", 
   RowBox[{"{", 
    RowBox[{"145", ",", "147", ",", "149", ",", "153", ",", "162"}], "}"}]}], 
  ";", 
  RowBox[{"a", "=", 
   RowBox[{"atab", "[", 
    RowBox[{"[", "sp", "]"}], "]"}]}], ";", 
  RowBox[{"nm", "=", 
   RowBox[{"nmtab", "[", 
    RowBox[{"[", "sp", "]"}], "]"}]}], ";", 
  RowBox[{"ncut", "=", 
   RowBox[{"ncuttab", "[", 
    RowBox[{"[", "sp", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xx", "=", 
   RowBox[{"Import", "[", "\"\<E:\\\\GRMHD\\\\a0\\\\Tsmap0.dat\>\"", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhonor", "=", "1042075.25"}], ";", 
  RowBox[{"heat", "=", "0.41929"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoout", "=", "130"}], ";", 
  RowBox[{"rmax", "=", 
   RowBox[{"3.4", " ", 
    SuperscriptBox["10", "5"]}]}], ";", 
  RowBox[{"rcut", "=", 
   RowBox[{"xx", "[", 
    RowBox[{"[", 
     RowBox[{"ncut", ",", "1"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhopo", "=", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"Log", "[", 
      RowBox[{
       RowBox[{"rhoout", "/", "rhonor"}], "/", 
       RowBox[{
        RowBox[{"xx", "[", 
         RowBox[{"[", "ncut", "]"}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}], "/", 
    RowBox[{"Log", "[", 
     RowBox[{"rmax", "/", "rcut"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"rhocon", "=", 
   RowBox[{"rhonor", "*", 
    RowBox[{"xx", "[", 
     RowBox[{"[", 
      RowBox[{"ncut", ",", "3"}], "]"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Ucon", "=", 
   RowBox[{"xx", "[", 
    RowBox[{"[", 
     RowBox[{"ncut", ",", "2"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ruru", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rg", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "6.67", " ", 
        SuperscriptBox["10", 
         RowBox[{"-", "8"}]], "4.5", " ", 
        SuperscriptBox["10", "6"], "2", " ", 
        SuperscriptBox["10", "33"]}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"3", " ", 
          SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
     RowBox[{"rs", "\[Rule]", "rg"}], ",", 
     RowBox[{"arcsec", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
        SuperscriptBox["10", "3"], "3.08", " ", 
        SuperscriptBox["10", "18"]}], 
       RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
     RowBox[{"pc", "\[Rule]", 
      RowBox[{"3.08", " ", 
       SuperscriptBox["10", "18"]}]}], ",", 
     RowBox[{"year", "\[Rule]", 
      RowBox[{"365.35", " ", "86400"}]}], ",", 
     RowBox[{"cc", "\[Rule]", 
      RowBox[{"3.", " ", 
       SuperscriptBox["10", "10"]}]}], ",", 
     RowBox[{"Msun", "\[Rule]", 
      RowBox[{"2.", " ", 
       SuperscriptBox["10", "33"]}]}], ",", 
     RowBox[{"mp", "\[Rule]", 
      RowBox[{"1.67", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "24"}]]}]}], ",", 
     RowBox[{"me", "\[Rule]", 
      RowBox[{"9.1", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "28"}]]}]}], ",", 
     RowBox[{"kb", "\[Rule]", 
      RowBox[{"1.38", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "16"}]]}]}], ",", 
     RowBox[{"h", "\[Rule]", 
      RowBox[{"6.626", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "27"}]]}]}], ",", 
     RowBox[{"ee", "\[Rule]", 
      RowBox[{"4.8", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "10"}]]}]}], ",", 
     RowBox[{"keV", "->", 
      RowBox[{"1000", " ", "1.602", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "12"}]]}]}], ",", 
     RowBox[{"\[Sigma]T", "\[Rule]", 
      RowBox[{
       FractionBox[
        RowBox[{"8", "\[Pi]"}], "3"], 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          SuperscriptBox["ee", "2"], 
          RowBox[{"me", " ", 
           SuperscriptBox["cc", "2"]}]], ")"}], "2"]}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ruru", "=", 
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"ruru", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1"}], "]"}], "]"}], "\[Rule]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"ruru", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}], "//.", "ruru"}], ")"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rategs", "=", 
    RowBox[{"7.722", " ", 
     SuperscriptBox["10", "17"]}]}], ";", 
   RowBox[{"(*", 
    RowBox[{"g", "/", "s"}], "*)"}], 
   RowBox[{"rategs", "=", 
    RowBox[{"ratexx", "/.", 
     RowBox[{
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"0.5", "\[Equal]", 
          FractionBox["ratexx", 
           RowBox[{"2", " ", "cc", " ", "mp", " ", 
            SuperscriptBox["rg", "2"], 
            SuperscriptBox["r", "2"], "\[Rho]fun"}]]}], "/.", "ruru"}], "/.", 
        RowBox[{"r", "\[Rule]", "3"}]}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"this", " ", "is", " ", "a", " ", "self"}], "-", 
    RowBox[{
    "consistency", " ", "check", " ", "for", " ", "the", " ", "radial", " ", 
     "velocity"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rtab", "=", 
    RowBox[{"xx", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"rategs", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"\[Rho]\[Rho]", " ", "U1", " ", "sqdet"}], "/.", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"lr", "\[Rule]", 
               RowBox[{"Log", "[", 
                RowBox[{"rr", "-", "off"}], "]"}]}], ",", 
              RowBox[{"x2", "\[Rule]", 
               RowBox[{"\[Theta]2x2", "[", "\[Theta]", "]"}]}]}], "}"}]}], "/.", 
           RowBox[{"r", "\[Rule]", "rr"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Theta]", ",", "\[Theta]min", ",", "\[Theta]max"}], 
           "}"}]}], "]"}]}], "\[Rho]nor", " ", 
       SuperscriptBox["rg", "2"], "cc", " ", "mp"}], "/.", 
      RowBox[{"ruru", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<Accretion rate = \>\"", ",", 
         RowBox[{"rate", "=", 
          RowBox[{
           RowBox[{"rategs", 
            FractionBox["year", "Msun"]}], "/.", "ruru"}]}], ",", 
         "\"\<  Msun/year\>\""}], "]"}]}]}]}], ";"}], "*)"}], "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"rategs", "=", 
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["rcut", "2"]}], 
      FractionBox[
       RowBox[{
        RowBox[{"dat070", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "32", ",", "3"}], "]"}], "]"}], "+", 
        RowBox[{"dat070", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "33", ",", "3"}], "]"}], "]"}]}], "2"]}]}], 
    ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rntab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"rcut", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["rcut", "rmax"], ")"}], 
       RowBox[{"-", 
        FractionBox["i", "100"]}]]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "100"}], "}"}]}], "]"}]}], ";", 
  RowBox[{"\[Rho]fun", "=", 
   RowBox[{"rhocon", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["r", "rcut"], ")"}], 
     RowBox[{"-", "rhopo"}]]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vrvr", "=", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["rategs", 
      RowBox[{"2", " ", "cc", " ", "mp", " ", 
       SuperscriptBox["rg", "2"], 
       SuperscriptBox["r", "2"], "\[Rho]fun", " "}]]}], "/.", "ruru"}]}], ";", 
  RowBox[{"dcap", "=", 
   RowBox[{"(", 
    RowBox[{"2.", "-", 
     FractionBox["0.49", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"0.7", "+", " ", 
         SuperscriptBox["cser", "2"]}], ")"}], "2"]]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rhofun", "=", 
    RowBox[{"rhocon", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["r", "rcut"], ")"}], 
      RowBox[{"-", "rhopo"}]]}]}], ";", 
   RowBox[{"Tsfun", "=", 
    RowBox[{"Ucon", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["r", "rcut"], ")"}], 
      RowBox[{"-", "0.98"}]]}]}], ";", 
   RowBox[{"Tstab", "=", 
    RowBox[{"xx", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"1", ";;", "ncut"}], ",", 
       RowBox[{"1", ";;", "2"}]}], "]"}], "]"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Tsinter", "=", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"Interpolation", "[", 
        RowBox[{"Log", "[", 
         RowBox[{"Join", "[", 
          RowBox[{"Tstab", ",", 
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"rntab", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"Tsfun", "/.", 
                 RowBox[{"r", "\[Rule]", "#"}]}], "&"}], "/@", "rntab"}]}], 
             "}"}], "]"}]}], "]"}], "]"}], "]"}], "[", 
       RowBox[{"Log", "[", "r", "]"}], "]"}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Tsinter", "=", 
   RowBox[{
    RowBox[{"Interpolation", "[", 
     RowBox[{"Join", "[", 
      RowBox[{"Tstab", ",", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"rntab", ",", 
          RowBox[{
           RowBox[{
            RowBox[{"Tsfun", "/.", 
             RowBox[{"r", "\[Rule]", "#"}]}], "&"}], "/@", "rntab"}]}], "}"}],
         "]"}]}], "]"}], "]"}], "[", "r", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sysm", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"tail", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Dts", "=", 
               RowBox[{"D", "[", 
                RowBox[{"Tsinter", ",", "r"}], "]"}]}], ";", 
              RowBox[{"\[Nu]c", "=", 
               RowBox[{"8.9", " ", 
                SuperscriptBox["10", 
                 RowBox[{"-", "11"}]], 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox[
                   RowBox[{"Te", "[", "r", "]"}], 
                   RowBox[{"3", " ", 
                    SuperscriptBox["10", "10"]}]], ")"}], 
                 RowBox[{"-", 
                  FractionBox["3", "2"]}]], 
                FractionBox["\[Rho]fun", 
                 SuperscriptBox["10", "7"]]}]}]}], ")"}], 
            FractionBox[
             RowBox[{"2", " ", "mp", " ", 
              SuperscriptBox["rg", "3"], 
              SuperscriptBox["r", "2"], "\[Rho]fun", " "}], "rategs"], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Tp", "[", "r", "]"}], "-", 
              RowBox[{"Te", "[", "r", "]"}]}], ")"}]}], "+", 
           RowBox[{"2", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               FractionBox[
                SqrtBox[
                 RowBox[{"Tp", "[", "r", "]"}]], 
                RowBox[{
                 SqrtBox[
                  RowBox[{"Tp", "[", "r", "]"}]], "+", 
                 RowBox[{"heat", 
                  SqrtBox[
                   RowBox[{"Te", "[", "r", "]"}]]}]}]], ")"}], "-", 
              RowBox[{
               FractionBox["1", "dcap"], 
               RowBox[{"(", 
                RowBox[{"1", 
                 FractionBox[
                  RowBox[{"heat", 
                   SqrtBox[
                    RowBox[{"Te", "[", "r", "]"}]]}], 
                  RowBox[{
                   SqrtBox[
                    RowBox[{"Tp", "[", "r", "]"}]], "+", 
                   RowBox[{"heat", 
                    SqrtBox[
                    RowBox[{"Te", "[", "r", "]"}]]}]}]]}], ")"}]}]}], ")"}], 
            "Dts"}]}]}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Te", "'"}], "[", "r", "]"}], "==", 
           RowBox[{
            FractionBox[
             RowBox[{
              RowBox[{"2", "Dts"}], "-", "tail"}], 
             RowBox[{"dcap", "+", "1"}]], "-", 
            RowBox[{"2", "rg", 
             FractionBox[
              RowBox[{"Te", "[", "r", "]"}], 
              RowBox[{"cc", " ", "vrvr"}]], 
             FractionBox[
              RowBox[{"4", "\[Sigma]T", " ", "kb", " ", "\[Rho]fun", " ", 
               RowBox[{"Tp", "[", "r", "]"}]}], 
              RowBox[{"3", " ", "me", " ", "cc"}]], 
             RowBox[{"(", 
              FractionBox[
               RowBox[{"kb", " ", 
                RowBox[{"Te", "[", "r", "]"}], " "}], 
               RowBox[{"me", " ", 
                SuperscriptBox["cc", "2"]}]], ")"}]}], "-", 
            RowBox[{"0.195", 
             FractionBox[
              RowBox[{"2", "rg"}], 
              RowBox[{"cc", " ", "vrvr"}]], 
             FractionBox[
              RowBox[{
               RowBox[{"10", "^", 
                RowBox[{"Xcool", "[", 
                 RowBox[{"Log10", "[", 
                  RowBox[{"Te", "[", "r", "]"}], "]"}], "]"}]}], 
               "\[Rho]fun"}], 
              RowBox[{"3", " ", "kb"}]]}]}]}], "/.", "ruru"}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Tp", "'"}], "[", "r", "]"}], "\[Equal]", 
         RowBox[{"tail", "+", 
          FractionBox[
           RowBox[{
            RowBox[{"2", "Dts"}], "-", "tail"}], 
           RowBox[{"dcap", "+", "1"}]]}]}]}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\[Theta]e", "\[Rule]", 
         FractionBox[
          RowBox[{"kb", " ", 
           RowBox[{"Te", "[", "r", "]"}]}], 
          RowBox[{"me", " ", 
           SuperscriptBox["cc", "2"]}]]}], ",", 
        RowBox[{"cser", "\[Rule]", 
         SqrtBox[
          FractionBox[
           RowBox[{"kb", " ", 
            RowBox[{"Te", "[", "r", "]"}]}], 
           RowBox[{"me", " ", 
            SuperscriptBox["cc", "2"]}]]]}], ",", 
        RowBox[{"cspr", "\[Rule]", 
         SqrtBox[
          FractionBox[
           RowBox[{"kb", " ", 
            RowBox[{"Tp", "[", "r", "]"}]}], 
           RowBox[{"mp", " ", 
            SuperscriptBox["cc", "2"]}]]]}]}], "}"}]}], "/.", "ruru"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{"FindRoot", "::", "\"\<lstol\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tosol", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{"sysm", ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"Tp", "[", "r", "]"}], "==", "Tsinter"}], ",", 
         RowBox[{
          RowBox[{"Te", "[", "r", "]"}], "\[Equal]", "Tsinter"}]}], "}"}], "/.", 
       RowBox[{"r", "\[Rule]", "rmax"}]}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"solnew", "=", 
   RowBox[{
    RowBox[{"NDSolve", "[", 
     RowBox[{"tosol", ",", 
      RowBox[{"{", 
       RowBox[{"Tp", ",", "Te"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"r", ",", 
        RowBox[{"rtab", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", "rmax"}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"lpl00", "=", 
  RowBox[{"LogLogPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Tp", "[", "r", "]"}], "/.", "solnew"}], ",", 
      RowBox[{
       RowBox[{"Te", "[", "r", "]"}], "/.", "solnew"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"r", ",", 
      RowBox[{"rtab", "[", 
       RowBox[{"[", "nm", "]"}], "]"}], ",", "rmax"}], "}"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<T, K\>\"", ",", "None"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "\"\<r  measured in \!\(\*SubscriptBox[\(r\), \(g\)]\)\>\"", ",", 
         "\"\<Red - \!\(\*SubscriptBox[\(T\), \(p\)]\), blue - \
\!\(\*SubscriptBox[\(T\), \(e\)]\); dashed - old model; solid - new \
model\>\""}], "}"}]}], "}"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Red"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"AbsoluteThickness", "[", "2", "]"}], ",", "Blue"}], "}"}]}],
       "}"}]}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"AbsoluteThickness", "[", "2", "]"}]}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "650"}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontFamily", "\[Rule]", "\"\<Arial\>\""}], ",", 
       RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}], ",", 
       RowBox[{"FontSize", "\[Rule]", "16"}]}], "}"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"Tp", "[", "6.", "]"}], 
     RowBox[{"Te", "[", "6.", "]"}]], "/.", "solnew"}], ",", 
   RowBox[{
    RowBox[{"Te", "[", "6.", "]"}], "/.", "solnew"}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox[
   RowBox[{"Tp", "[", "3", "]"}], 
   RowBox[{"Te", "[", "3", "]"}]], "/.", "solnew"}]}], "Input",
 CellChangeTimes->{{3.4834636103388*^9, 3.4834636696968*^9}, {
   3.4834637181972*^9, 3.483463909968*^9}, {3.483464244042*^9, 
   3.4834642699692*^9}, 3.4834643070192003`*^9, {3.4834643425248003`*^9, 
   3.483464342712*^9}, {3.4834645751052*^9, 3.483464580222*^9}, {
   3.4834648283087997`*^9, 3.4834648597584*^9}, {3.4834652891484003`*^9, 
   3.483465387678*^9}, {3.4837022693568*^9, 3.4837022740992002`*^9}, {
   3.4837023050028*^9, 3.4837023305712*^9}, {3.4837026416782*^9, 
   3.4837026653901997`*^9}, {3.4837026982438*^9, 3.4837026983218*^9}, {
   3.4837027290694*^9, 3.4837027606126003`*^9}, {3.4840698681808*^9, 
   3.4840699216264*^9}, 3.485208462080637*^9, {3.5412586476474237`*^9, 
   3.5412586779961596`*^9}, {3.5517162745392466`*^9, 
   3.5517162852088566`*^9}, {3.5517165038173604`*^9, 3.551716530966913*^9}, {
   3.551716752546587*^9, 3.5517167630651884`*^9}, {3.5517168975668817`*^9, 
   3.55171690348822*^9}, {3.551716983533798*^9, 3.55171701293248*^9}, {
   3.5517171162643905`*^9, 3.551717116765419*^9}, 3.551717313892694*^9, {
   3.551720141751438*^9, 3.5517201563032703`*^9}, {3.55180259907298*^9, 
   3.551802600163042*^9}, 3.5518027512996864`*^9, {3.551804589822844*^9, 
   3.5518046428258753`*^9}, {3.5518048595692725`*^9, 
   3.5518048714409513`*^9}, {3.551804916661538*^9, 3.5518049857454896`*^9}, {
   3.551805035244321*^9, 3.5518050353303256`*^9}, {3.5518051622455845`*^9, 
   3.5518051623235893`*^9}, {3.551805200523774*^9, 3.5518052259802303`*^9}, {
   3.5518053268119974`*^9, 3.551805354116559*^9}, {3.5518064667381973`*^9, 
   3.5518064770407867`*^9}, {3.5518065334460125`*^9, 3.551806540995445*^9}, {
   3.5518066024749613`*^9, 3.5518066049711037`*^9}, {3.5518067284881687`*^9, 
   3.5518067571658087`*^9}, {3.5520748906794815`*^9, 3.552074959555421*^9}, {
   3.5520750239421043`*^9, 3.55207506164826*^9}, {3.552075442140023*^9, 
   3.5520754422160277`*^9}, {3.552075549303153*^9, 3.5520755620618825`*^9}, {
   3.5520760887550077`*^9, 3.5520761138754444`*^9}}],

Cell[BoxData["0.15"], "Input",
 CellChangeTimes->{{3.552075539884614*^9, 3.552075540477648*^9}}],

Cell[BoxData["0.1"], "Input",
 CellChangeTimes->{{3.5520750390569687`*^9, 3.552075039368986*^9}}],

Cell[BoxData["NGC3115"], "Input",
 CellChangeTimes->{{3.5518067678054175`*^9, 3.5518067693525057`*^9}}],

Cell[BoxData[
 RowBox[{"with", " ", "cooling"}]], "Input",
 CellChangeTimes->{{3.551805218723815*^9, 3.5518052202369013`*^9}}],

Cell[BoxData[
 RowBox[{"0.001", " ", "cooling"}]], "Input",
 CellChangeTimes->{{3.5518052327036147`*^9, 3.5518052367908487`*^9}}],

Cell[BoxData[
 RowBox[{"LogLogPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", "rg"}], 
      FractionBox["r", 
       RowBox[{"cc", " ", "vrvr"}]], 
      FractionBox[
       RowBox[{"4", "\[Sigma]T", " ", "kb", " ", "\[Rho]fun", " ", 
        RowBox[{"Tp", "[", "r", "]"}]}], 
       RowBox[{"3", " ", "me", " ", "cc"}]], 
      RowBox[{"(", 
       FractionBox[
        RowBox[{"kb", " ", 
         RowBox[{"Te", "[", "r", "]"}], " "}], 
        RowBox[{"me", " ", 
         SuperscriptBox["cc", "2"]}]], ")"}]}], "/.", "ruru"}], "/.", 
    "solnew"}], ",", 
   RowBox[{"{", 
    RowBox[{"r", ",", "2", ",", 
     SuperscriptBox["10", "4"]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5518054757895184`*^9, 3.5518055059732447`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[Rho]fun", ",", "rg", ",", 
      RowBox[{"\[Rho]fun", " ", "rg"}]}], "}"}], "/.", "ruru"}], "/.", 
   RowBox[{"r", "\[Rule]", "3"}]}], 
  RowBox[{"(*", 
   RowBox[{"for", " ", "Sgr", " ", "A"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{"10586.346475568054`", ",", "5.928888888888888`*^14", ",", 
   RowBox[{"5.928888888888888`*^14", " ", "10586.346475568054`"}]}], 
  "}"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5518056720357428`*^9, 3.551805709104863*^9}, 
   3.551806496736913*^9, {3.5518066628514147`*^9, 3.5518066963533306`*^9}, {
   3.5518067410378866`*^9, 3.5518067413919067`*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Checking accretion rate", "Subsection",
 CellChangeTimes->{{3.4837054203658*^9, 3.4837054236574*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[CapitalDelta]", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "-", 
    RowBox[{"2", "r"}], "+", 
    SuperscriptBox["a", "2"]}]}], ";", 
  RowBox[{"\[Rho]sq", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "+", 
    RowBox[{
     SuperscriptBox["a", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}]}], ";", 
  RowBox[{"\[CapitalSigma]sq", "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["r", "2"], "+", 
       SuperscriptBox["a", "2"]}], ")"}], "2"], "-", 
    RowBox[{
     SuperscriptBox["a", "2"], "\[CapitalDelta]", " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"gmn", "=", 
    RowBox[{"-", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         FractionBox["\[CapitalSigma]sq", 
          RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
         ",", 
         FractionBox[
          RowBox[{"2", "a", " ", "r"}], 
          RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", 
          FractionBox["\[CapitalDelta]", "\[Rho]sq"]}], ",", "0", ",", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[Rho]sq", 
           RowBox[{"-", "1"}]]}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{"2", "a", " ", "r"}], 
          RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
         ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"(", 
            RowBox[{"\[CapitalDelta]", "-", 
             RowBox[{
              SuperscriptBox["a", "2"], 
              SuperscriptBox[
               RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]]}]}], "}"}]}], 
      "}"}]}]}], ")"}], "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"invgmn", "=", 
    RowBox[{"FullSimplify", "[", 
     RowBox[{
      RowBox[{"Inverse", "[", "gmn", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"r", ">", "0"}], "}"}]}], "]"}]}], ")"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"x", "[", "1", "]"}], "=", "t"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "2", "]"}], "=", "r"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "3", "]"}], "=", "\[Theta]"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "4", "]"}], "=", "\[Phi]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"G", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], "=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"gmn", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "m"}], "]"}], "]"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"invgmn", "[", 
           RowBox[{"[", 
            RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"x", "[", "1", "]"}]}], "]"}], "+", 
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"invgmn", "[", 
           RowBox[{"[", 
            RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"x", "[", "1", "]"}]}], "]"}], "-", 
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"invgmn", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"G", "[", 
      RowBox[{"i", ",", "k", ",", "l"}], "]"}], "=", 
     RowBox[{"Simplify", "[", 
      RowBox[{
       FractionBox["1", "2"], 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"gmn", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "m"}], "]"}], "]"}], "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"invgmn", "[", 
               RowBox[{"[", 
                RowBox[{"m", ",", "k"}], "]"}], "]"}], ",", 
              RowBox[{"x", "[", "l", "]"}]}], "]"}], "+", 
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"invgmn", "[", 
               RowBox[{"[", 
                RowBox[{"m", ",", "l"}], "]"}], "]"}], ",", 
              RowBox[{"x", "[", "k", "]"}]}], "]"}], "-", 
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"invgmn", "[", 
               RowBox[{"[", 
                RowBox[{"k", ",", "l"}], "]"}], "]"}], ",", 
              RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "1", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"l", ",", "1", ",", "4"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gmn", "=", 
   RowBox[{"Simplify", "[", "gmn", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"invgmn", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"invgmn", "/.", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"2", "\[Theta]"}], "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"2", 
        SuperscriptBox[
         RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "-", "1"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"invgmnKS", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", 
        FractionBox[
         RowBox[{"2", "r"}], "\[Rho]sq"], ",", "0", ",", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "a", " ", "r", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}]}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        FractionBox[
         RowBox[{"2", "r"}], "\[Rho]sq"], ",", 
        RowBox[{"1", "+", 
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", "0", ",", 
        RowBox[{
         RowBox[{"-", "a"}], 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "\[Rho]sq", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "a", " ", "r", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}], ",", 
        RowBox[{
         RowBox[{"-", "a"}], 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], ",", "0", ",", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
         RowBox[{"(", 
          RowBox[{"\[Rho]sq", "+", 
           RowBox[{
            SuperscriptBox["a", "2"], 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              FractionBox[
               RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}]}]}], 
       "}"}]}], "}"}]}], ")"}], "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Anumu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{"2", "r"}], "\[CapitalDelta]"], ",", "1", ",", "0", ",", 
       FractionBox["a", "\[CapitalDelta]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AMKS", "=", 
   RowBox[{"DiagonalMatrix", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      FractionBox["1", 
       RowBox[{"r", "-", "R0"}]], ",", 
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{"h", "+", 
           RowBox[{"7", 
            RowBox[{"(", 
             RowBox[{"1", "-", "h"}], ")"}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", "x2"}], "-", "1"}], ")"}], "6"]}]}], ")"}]}], 
        ")"}]}], ",", 
      RowBox[{"1", "/", "\[Pi]"}]}], "}"}], "]"}]}], 
  RowBox[{"(*", 
   RowBox[{"/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"R0", "\[Rule]", "0.3"}], ",", 
      RowBox[{"h", "\[Rule]", "0.65"}]}], "}"}]}], "*)"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AMKS", "=", 
   RowBox[{"Inverse", "[", "AMKS", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"invnew", "=", 
  RowBox[{"AMKS", ".", "invgmnKS", ".", "AMKS"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"g", "[", 
        RowBox[{
         RowBox[{"i", "-", "1"}], ",", 
         RowBox[{"j", "-", "1"}]}], "]"}], "=", 
       RowBox[{"gmn", "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "j"}], "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "4"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"invg", "[", 
        RowBox[{
         RowBox[{"i", "-", "1"}], ",", 
         RowBox[{"j", "-", "1"}]}], "]"}], "=", 
       RowBox[{"invgmn", "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "j"}], "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "4"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"gmn", " ", "=", " ", 
       SuperscriptBox["g", "\[Mu]\[Nu]"]}], ";", " ", 
      RowBox[{"invgmn", " ", "=", " ", 
       SubscriptBox["g", "\[Mu]\[Nu]"]}]}], "*)"}], 
    RowBox[{
     RowBox[{"ee", "[", "0", "]"}], "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], ",", 
       RowBox[{"u", "[", "1", "]"}], ",", 
       RowBox[{"u", "[", "2", "]"}], ",", 
       RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ee", "[", "1", "]"}], "=", 
     RowBox[{
      FractionBox["s", "N2"], 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           RowBox[{"g", "[", 
            RowBox[{"0", ",", "0"}], "]"}]}], "C1"}], "-", 
         RowBox[{
          RowBox[{"g", "[", 
           RowBox[{"0", ",", "3"}], "]"}], "C2"}]}], ",", 
        RowBox[{
         RowBox[{"g", "[", 
          RowBox[{"1", ",", "1"}], "]"}], "C0"}], ",", "0", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           RowBox[{"g", "[", 
            RowBox[{"3", ",", "3"}], "]"}]}], "C2"}], "-", 
         RowBox[{
          RowBox[{"g", "[", 
           RowBox[{"0", ",", "3"}], "]"}], "C1"}]}]}], "}"}]}]}], ";", 
    RowBox[{
     RowBox[{"ee", "[", "3", "]"}], "=", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", "N1"]}], 
      RowBox[{"{", 
       RowBox[{"l", ",", "0", ",", "0", ",", "1"}], "}"}]}]}], ";", 
    RowBox[{
     RowBox[{"ee", "[", "2", "]"}], "=", 
     RowBox[{
      FractionBox["1", "N3"], 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{
         FractionBox["C1", "C0"], 
         FractionBox[
          RowBox[{
           RowBox[{"g", "[", 
            RowBox[{"0", ",", "0"}], "]"}], "-", 
           SuperscriptBox["l", "2"]}], 
          RowBox[{"g", "[", 
           RowBox[{"1", ",", "1"}], "]"}]]}], ",", 
        RowBox[{
         FractionBox["Cmin", "C3"], "-", 
         RowBox[{
          FractionBox[
           RowBox[{"u", "[", "1", "]"}], 
           RowBox[{"u", "[", "2", "]"}]], 
          FractionBox["C1", "C0"], 
          FractionBox[
           RowBox[{
            RowBox[{"g", "[", 
             RowBox[{"0", ",", "0"}], "]"}], "-", 
            SuperscriptBox["l", "2"]}], 
           RowBox[{"g", "[", 
            RowBox[{"1", ",", "1"}], "]"}]]}]}], ",", 
        RowBox[{"-", "l"}]}], "}"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"ulo", "=", 
     RowBox[{"invgmn", ".", 
      RowBox[{"ee", "[", "0", "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"uco", "[", 
        RowBox[{"i", "-", "1"}], "]"}], "=", 
       RowBox[{"ulo", "[", 
        RowBox[{"[", "i", "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "4"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"l", "=", 
     RowBox[{
      RowBox[{"uco", "[", "3", "]"}], "/", 
      RowBox[{"uco", "[", "1", "]"}]}]}], ";", 
    RowBox[{"C0", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], 
       RowBox[{"uco", "[", "0", "]"}]}], "+", 
      RowBox[{
       RowBox[{"u", "[", "3", "]"}], 
       RowBox[{"uco", "[", "3", "]"}]}]}]}], ";", 
    RowBox[{"C1", "=", 
     RowBox[{
      RowBox[{"u", "[", "1", "]"}], 
      RowBox[{"uco", "[", "0", "]"}]}]}], ";", 
    RowBox[{"C2", "=", 
     RowBox[{
      RowBox[{"u", "[", "1", "]"}], 
      RowBox[{"uco", "[", "3", "]"}]}]}], ";", 
    RowBox[{"C3", "=", 
     RowBox[{
      RowBox[{"u", "[", "2", "]"}], 
      RowBox[{"uco", "[", "1", "]"}]}]}], ";", 
    RowBox[{"Cmin", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"u", "[", "3", "]"}], 
       RowBox[{"uco", "[", "3", "]"}]}], "-", 
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], 
       RowBox[{"uco", "[", "0", "]"}]}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"s", "=", 
     RowBox[{"Sign", "[", "C0", "]"}]}], ";", 
    RowBox[{"j", "=", 
     RowBox[{"FullSimplify", "[", 
      RowBox[{
       SqrtBox[
        RowBox[{"-", 
         RowBox[{"Det", "[", "invgmn", "]"}]}]], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"r", ">", "2"}], ",", 
         RowBox[{"a", ">", "0"}], ",", 
         RowBox[{"\[Pi]", ">", "\[Theta]", ">", "0"}]}], "}"}]}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"gmn", " ", "=", " ", 
       SuperscriptBox["g", "\[Mu]\[Nu]"]}], ";", " ", 
      RowBox[{"invgmn", " ", "=", " ", 
       SubscriptBox["g", "\[Mu]\[Nu]"]}]}], "*)"}], 
    RowBox[{"N1", "=", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"invg", "[", 
          RowBox[{"0", ",", "0"}], "]"}], 
         SuperscriptBox["l", "2"]}], "-", 
        RowBox[{"2", 
         RowBox[{"invg", "[", 
          RowBox[{"0", ",", "3"}], "]"}], "l"}], "+", 
        RowBox[{"invg", "[", 
         RowBox[{"3", ",", "3"}], "]"}]}], ")"}], 
      RowBox[{"1", "/", "2"}]]}], ";", 
    RowBox[{"N2", "=", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"g", "[", 
          RowBox[{"0", ",", "0"}], "]"}], 
         SuperscriptBox["C1", "2"]}], "+", 
        RowBox[{
         RowBox[{"g", "[", 
          RowBox[{"1", ",", "1"}], "]"}], 
         SuperscriptBox["C0", "2"]}], "+", 
        RowBox[{
         RowBox[{"g", "[", 
          RowBox[{"3", ",", "3"}], "]"}], 
         SuperscriptBox["C2", "2"]}], "+", 
        RowBox[{"2", 
         RowBox[{"g", "[", 
          RowBox[{"0", ",", "3"}], "]"}], "C1", " ", "C2"}]}], ")"}], 
      RowBox[{"1", "/", "2"}]]}], ";", 
    RowBox[{"N3", "=", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g", "[", 
         RowBox[{"0", ",", "0"}], "]"}], "-", 
        RowBox[{"2", 
         RowBox[{"g", "[", 
          RowBox[{"0", ",", "3"}], "]"}], "l"}], "+", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["C1", "C0"], ")"}], "2"], 
         FractionBox[
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g", "[", 
              RowBox[{"0", ",", "0"}], "]"}], "-", 
             SuperscriptBox["l", "2"]}], ")"}], "2"], 
          RowBox[{"g", "[", 
           RowBox[{"1", ",", "1"}], "]"}]]}], "+", 
        RowBox[{
         RowBox[{"g", "[", 
          RowBox[{"3", ",", "3"}], "]"}], 
         SuperscriptBox["l", "2"]}], "+", 
        RowBox[{
         RowBox[{"g", "[", 
          RowBox[{"2", ",", "2"}], "]"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            FractionBox["Cmin", "C3"], "-", 
            RowBox[{
             FractionBox[
              RowBox[{"u", "[", "1", "]"}], 
              RowBox[{"u", "[", "2", "]"}]], 
             FractionBox["C1", "C0"], 
             FractionBox[
              RowBox[{
               RowBox[{"g", "[", 
                RowBox[{"0", ",", "0"}], "]"}], "-", 
               SuperscriptBox["l", "2"]}], 
              RowBox[{"g", "[", 
               RowBox[{"1", ",", "1"}], "]"}]]}]}], ")"}], "2"]}]}], ")"}], 
      RowBox[{"1", "/", "2"}]]}], ";"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.4626330585179996`*^9, 3.462633106061*^9}, {
   3.462633200225*^9, 3.4626332373120003`*^9}, {3.462633273317*^9, 
   3.462633278652*^9}, {3.4626334330220003`*^9, 3.462633536664*^9}, {
   3.462633586236*^9, 3.462633660715*^9}, {3.462635287076*^9, 
   3.462635305646*^9}, {3.4626355485889997`*^9, 3.462635576118*^9}, {
   3.4626356357019997`*^9, 3.462635639954*^9}, {3.462635761001*^9, 
   3.462635913634*^9}, {3.462635986321*^9, 3.462636006325*^9}, {
   3.462636051492*^9, 3.4626360721210003`*^9}, {3.462636278928*^9, 
   3.462636293153*^9}, {3.462636395936*^9, 3.462636409736*^9}, {
   3.462636547731*^9, 3.4626365525769997`*^9}, 3.462636780659*^9, 
   3.462637584486*^9, {3.4626376989709997`*^9, 3.462637700028*^9}, 
   3.462637849402*^9, {3.46263823645*^9, 3.462638236615*^9}, {
   3.4626383039519997`*^9, 3.462638305049*^9}, {3.462638359123*^9, 
   3.4626383635480003`*^9}, {3.4626385617869997`*^9, 3.462638578455*^9}, {
   3.462638881075*^9, 3.4626389075369997`*^9}, {3.4626390873310003`*^9, 
   3.462639096484*^9}, {3.462644193078*^9, 3.462644217727*^9}, 
   3.4626443531809998`*^9, {3.462704235408*^9, 3.462704264086*^9}, {
   3.4740342972869997`*^9, 3.474034311618*^9}, {3.474036129392*^9, 
   3.474036141512*^9}, {3.474036184262*^9, 3.474036185574*^9}, {
   3.474036255237*^9, 3.474036314354*^9}, {3.474036347196*^9, 
   3.474036401833*^9}, {3.474036443409*^9, 3.4740365891470003`*^9}, {
   3.474055368087*^9, 3.474055472965*^9}, {3.474055541039*^9, 
   3.474055562652*^9}, {3.474055719885*^9, 3.4740557261940002`*^9}, {
   3.474055823498*^9, 3.474055840946*^9}, {3.474056932632*^9, 
   3.4740569785030003`*^9}, {3.4740570994*^9, 3.474057144969*^9}, {
   3.474057341248*^9, 3.4740573636210003`*^9}, {3.474059438028*^9, 
   3.474059442311*^9}, 3.483705093658*^9, {3.4837051349379997`*^9, 
   3.4837051368050003`*^9}}],

Cell[BoxData[{
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"-", 
     RowBox[{"Det", "[", "invnew", "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"0", "<", "h", "<", "1"}], ",", 
     RowBox[{"a", ">", "0"}], ",", 
     RowBox[{"\[Pi]", ">", "\[Theta]", ">", "0"}], ",", 
     RowBox[{"r", ">", "R0", ">", "0"}], ",", 
     RowBox[{"0", "<", "x2", "<", "1"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"-", 
     RowBox[{"Det", "[", "invnew", "]"}]}], "]"}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"h", "+", 
      RowBox[{"7", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", "h"}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"2", " ", "x2"}]}], ")"}], "6"]}]}], ")"}], ">", "0"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.483705124591*^9, 3.483705297017*^9}}],

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{
     SuperscriptBox["\[Pi]", "2"], "(", 
     RowBox[{"r", "-", "R0"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"h", " ", "+", " ", 
      RowBox[{"7", " ", 
       RowBox[{"(", 
        RowBox[{"1", " ", "-", " ", "h"}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], " ", "+", " ", 
          RowBox[{"2", " ", "x2"}]}], ")"}], "6"]}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["r", "2"], "+", 
      RowBox[{
       SuperscriptBox["a", "2"], 
       SuperscriptBox[
        RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}], "dx2", " ", "dx3"}], "\[Equal]", 
   RowBox[{
    RowBox[{"\[Pi]", "(", 
     RowBox[{"r", "-", "R0"}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["r", "2"], "+", 
      RowBox[{
       SuperscriptBox["a", "2"], 
       SuperscriptBox[
        RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}], "d\[Theta]", " ", "dx3"}], 
   "\[Equal]", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"\[Pi]", "(", 
      RowBox[{"r", "-", "R0"}], ")"}]}], 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["r", "2"], "+", 
      RowBox[{
       SuperscriptBox["a", "2"], 
       SuperscriptBox[
        RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
    RowBox[{"dCos", "[", "\[Theta]", "]"}], " ", "dx3"}], "\[Equal]", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{"r", "-", "R0"}], ")"}]}], 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["r", "2"], "+", 
      RowBox[{
       SuperscriptBox["a", "2"], 
       SuperscriptBox[
        RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
    RowBox[{"dCos", "[", "\[Theta]", "]"}], " ", "d\[Phi]"}], "\[Equal]", 
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{"2", "\[Pi]"}], "phlen"]}], 
    RowBox[{"(", 
     RowBox[{"r", "-", "R0"}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["r", "2"], "+", 
      RowBox[{
       SuperscriptBox["a", "2"], 
       SuperscriptBox[
        RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
    RowBox[{"dCos", "[", "\[Theta]", "]"}], " ", 
    UnderscriptBox["\[CapitalSigma]", "\[Phi]"]}]}], 
  TraditionalForm]]]], "Text",
 CellChangeTimes->{{3.4837054755741997`*^9, 3.4837055648696003`*^9}, {
  3.483705672104*^9, 3.4837056855824003`*^9}, {3.4837058110688*^9, 
  3.4837058232212*^9}, {3.4837059577556*^9, 3.4837059590816*^9}, {
  3.4837059991892*^9, 3.4837059995792*^9}, {3.4837061146604*^9, 
  3.4837061772768*^9}}],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", 
    RowBox[{"-", 
     RowBox[{"Det", "[", "invgmnKS", "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[Pi]", ">", "\[Theta]", ">", "0"}], ",", 
     RowBox[{"r", ">", "0"}], ",", 
     RowBox[{"a", ">", "0"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.547249887422329*^9, 3.547249903081225*^9}, {
  3.5472499391362867`*^9, 3.547249941520423*^9}, {3.547255353082947*^9, 
  3.5472553727860737`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"d\[Theta]", "/", "dx2"}], "\[Equal]", 
  RowBox[{"D", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"h", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "x2"}], "-", "1"}], ")"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", "h"}], ")"}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "x2"}], "-", "1"}], ")"}], "7"]}], "+", "1"}], ")"}], 
     FractionBox["\[Pi]", "2"]}], ",", "x2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.483705623042*^9, 3.4837056608096*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Intensity functions", "Section",
 CellChangeTimes->{{3.4837064993292*^9, 3.4837065025271997`*^9}}],

Cell[CellGroupData[{

Cell["Defining points on the picture plane", "Subsection",
 CellChangeTimes->{{3.4837073834592*^9, 3.4837073884512*^9}}],

Cell["beta = atan2 (yg, xg)", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Polarized spherical coordinates \[Rule] Stokes\
\>", "Subsection",
 CellChangeTimes->{{3.483707641842*^9, 3.4837076434488*^9}, {
  3.486825853430395*^9, 3.486825854444395*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"(", 
   RowBox[{"R", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"Cos", "[", 
         RowBox[{"2", 
          RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}], ",", 
        RowBox[{"Sin", "[", 
         RowBox[{"2", 
          RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", 
         RowBox[{"Sin", "[", 
          RowBox[{"2", 
           RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", 
        RowBox[{"Cos", "[", 
         RowBox[{"2", 
          RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ")"}], "//",
   "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"mat", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"aIc", ",", "aQc", ",", "0", ",", "aVc"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"aQc", ",", "aIc", ",", "rVc", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", "rVc"}], ",", "aIc", ",", "rQc"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"aVc", ",", "0", ",", 
        RowBox[{"-", "rQc"}], ",", "aIc"}], "}"}]}], "}"}]}], ")"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"fs", "=", 
    RowBox[{"FullSimplify", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", "R", "]"}], ".", "mat", ".", "R"}], "]"}]}], 
   ")"}], "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"eqq", "=", 
  RowBox[{
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"f", "[", "0", "]"}], ",", 
       RowBox[{"f", "[", "1", "]"}], ",", 
       RowBox[{"f", "[", "2", "]"}], ",", 
       RowBox[{"f", "[", "3", "]"}]}], "}"}], "\[Equal]", 
     RowBox[{"det", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"jIc", ",", "jQc", ",", "0", ",", "jVc"}], "}"}], ".", 
          "R"}], "/", "frsq"}], "-", 
        RowBox[{
         RowBox[{"frcu", "/", "frsq"}], " ", 
         RowBox[{"fs", ".", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"y", "[", "0", "]"}], ",", 
            RowBox[{"y", "[", "1", "]"}], ",", 
            RowBox[{"y", "[", "2", "]"}], ",", 
            RowBox[{"y", "[", "3", "]"}]}], "}"}]}]}]}], ")"}]}]}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Sin", "[", 
       RowBox[{"2", " ", 
        RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}], "\[Rule]", "sin2k"}], ",", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"2", 
        RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}], "\[Rule]", "cos2k"}]}], 
    "}"}]}]}]}], "Input",
 CellChangeTimes->{{3.4804209238673987`*^9, 3.4804209643961987`*^9}, {
  3.4819603122981997`*^9, 3.4819603299574003`*^9}, {3.4819612380178003`*^9, 
  3.4819613436610003`*^9}, {3.4819613782306004`*^9, 3.481961384299*^9}, {
  3.4819614353422003`*^9, 3.4819615463050003`*^9}, {3.481961580157*^9, 
  3.481961580703*^9}, {3.481961964229*^9, 3.4819619683318*^9}, {
  3.481962007675*^9, 3.4819620099214*^9}, {3.4819620427438*^9, 
  3.4819620461758003`*^9}, {3.481963014343*^9, 3.4819630171666*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"doub", " ", "cosqs"}], "=", 
   RowBox[{"cos", 
    RowBox[{"(", 
     RowBox[{"yyy", "[", "2", "]"}], ")"}]}]}], ",", 
  RowBox[{"sinqs", "=", 
   RowBox[{"sin", 
    RowBox[{"(", 
     RowBox[{"yyy", "[", "2", "]"}], ")"}]}]}], ",", 
  RowBox[{"frsq", "=", 
   RowBox[{"fr", "*", "fr"}]}], ",", 
  RowBox[{"sinths", "=", 
   RowBox[{"sin", 
    RowBox[{"(", 
     RowBox[{"yyy", "[", "3", "]"}], ")"}]}]}], ",", 
  RowBox[{
   RowBox[{"cosths", "=", 
    RowBox[{"cos", 
     RowBox[{"(", 
      RowBox[{"yyy", "[", "3", "]"}], ")"}]}]}], ";"}]}]], "Input",
 EmphasizeSyntaxErrors->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"rull", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"y", "[", "0", "]"}], "\[Rule]", 
      RowBox[{"yyy", "[", "0", "]"}]}], ",", 
     RowBox[{
      RowBox[{"y", "[", "1", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"yyy", "[", "1", "]"}], 
       RowBox[{"Sin", "[", 
        RowBox[{"yyy", "[", "3", "]"}], "]"}], 
       RowBox[{"Cos", "[", 
        RowBox[{"yyy", "[", "2", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"y", "[", "2", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"yyy", "[", "1", "]"}], 
       RowBox[{"Sin", "[", 
        RowBox[{"yyy", "[", "3", "]"}], "]"}], 
       RowBox[{"Sin", "[", 
        RowBox[{"yyy", "[", "2", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"y", "[", "3", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"yyy", "[", "1", "]"}], 
       RowBox[{"Cos", "[", 
        RowBox[{"yyy", "[", "3", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"f", "[", "1", "]"}], "\[Rule]", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"yyy", "[", "1", "]"}], "[", "s", "]"}], 
         RowBox[{"Sin", "[", 
          RowBox[{
           RowBox[{"yyy", "[", "3", "]"}], "[", "s", "]"}], "]"}], 
         RowBox[{"Cos", "[", 
          RowBox[{
           RowBox[{"yyy", "[", "2", "]"}], "[", "s", "]"}], "]"}]}], ",", 
        "s"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"f", "[", "2", "]"}], "\[Rule]", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"yyy", "[", "1", "]"}], "[", "s", "]"}], 
         RowBox[{"Sin", "[", 
          RowBox[{
           RowBox[{"yyy", "[", "3", "]"}], "[", "s", "]"}], "]"}], 
         RowBox[{"Sin", "[", 
          RowBox[{
           RowBox[{"yyy", "[", "2", "]"}], "[", "s", "]"}], "]"}]}], ",", 
        "s"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"f", "[", "3", "]"}], "\[Rule]", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"yyy", "[", "1", "]"}], "[", "s", "]"}], 
         RowBox[{"Cos", "[", 
          RowBox[{
           RowBox[{"yyy", "[", "3", "]"}], "[", "s", "]"}], "]"}]}], ",", 
        "s"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"f", "[", "0", "]"}], "\[Rule]", 
      RowBox[{"ff", "[", "0", "]"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"finex", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{"Simplify", "[", 
     RowBox[{
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"eqq", "/.", "rull"}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"yyy", "[", "1", "]"}], "\[Prime]",
              MultilineFunction->None], "[", "s", "]"}], "\[Rule]", 
            RowBox[{"ff", "[", "1", "]"}]}], ",", 
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"yyy", "[", "2", "]"}], "\[Prime]",
              MultilineFunction->None], "[", "s", "]"}], "\[Rule]", 
            RowBox[{"ff", "[", "2", "]"}]}], ",", 
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"yyy", "[", "3", "]"}], "\[Prime]",
              MultilineFunction->None], "[", "s", "]"}], "\[Rule]", 
            RowBox[{"ff", "[", "3", "]"}]}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"yyy", "[", "1", "]"}], "[", "s", "]"}], "\[Rule]", 
            RowBox[{"yyy", "[", "1", "]"}]}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"yyy", "[", "2", "]"}], "[", "s", "]"}], "\[Rule]", 
            RowBox[{"yyy", "[", "2", "]"}]}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"yyy", "[", "3", "]"}], "[", "s", "]"}], "\[Rule]", 
            RowBox[{"yyy", "[", "3", "]"}]}]}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ff", "[", "0", "]"}], ",", 
          RowBox[{"ff", "[", "1", "]"}], ",", 
          RowBox[{"ff", "[", "2", "]"}], ",", 
          RowBox[{"ff", "[", "3", "]"}]}], "}"}]}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        RowBox[{"yyy", "[", "2", "]"}], "]"}], "\[Rule]", "cosqs"}], ",", 
      RowBox[{
       RowBox[{"Sin", "[", 
        RowBox[{"yyy", "[", "2", "]"}], "]"}], "\[Rule]", "sinqs"}], ",", 
      RowBox[{
       RowBox[{"Cos", "[", 
        RowBox[{"yyy", "[", "3", "]"}], "]"}], "\[Rule]", "cosths"}], ",", 
      RowBox[{
       RowBox[{"Sin", "[", 
        RowBox[{"yyy", "[", "3", "]"}], "]"}], "\[Rule]", "sinths"}], ",", 
      RowBox[{
       RowBox[{"Csc", "[", 
        RowBox[{"yyy", "[", "3", "]"}], "]"}], "\[Rule]", 
       FractionBox["1", "sinths"]}], ",", 
      RowBox[{
       RowBox[{"Cot", "[", 
        RowBox[{"yyy", "[", "3", "]"}], "]"}], "\[Rule]", 
       FractionBox["cosths", "sinths"]}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.4819620126202*^9, 3.4819620263482*^9}, {
   3.4819620659566*^9, 3.4819620775474*^9}, 3.4819621284502*^9, {
   3.4819621742362003`*^9, 3.4819625064849997`*^9}, {3.4819625839702*^9, 
   3.4819627261486*^9}, {3.4819628088129997`*^9, 3.481962855067*^9}, {
   3.4819629406174*^9, 3.4819629419122*^9}, {3.4819631825422*^9, 
   3.4819631843674*^9}, {3.4819633376062*^9, 3.481963366591*^9}}],

Cell[BoxData[
 RowBox[{"ToString", "[", 
  RowBox[{"InputForm", "[", "finex", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.4819631908726*^9, 3.4819632141478*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"finex", "[", 
    RowBox[{"[", 
     RowBox[{"3", ",", "1"}], "]"}], "]"}], "\[Rule]", 
   RowBox[{"rVc", " ", 
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"finex", "[", 
       RowBox[{"[", 
        RowBox[{"3", ",", "2"}], "]"}], "]"}], ",", "rVc"}], "]"}]}]}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"frcu", "\[Rule]", 
     SuperscriptBox["fr", "3"]}], ",", 
    RowBox[{"frsq", "\[Rule]", 
     SuperscriptBox["fr", "2"]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5211765498037806`*^9, 3.5211765536650014`*^9}, {
  3.5211768379502616`*^9, 3.5211768996137886`*^9}}],

Cell["\<\
det<0, but integration along negative time \[Implies] effectively det >0;
dyy[2]/dl \[Rule] rVc<0 \[Implies] yy[2]<0
in[kk][1]\[Rule] cos[yy[2]]
in[kk][2]\[Rule] sin[yy[2]]

\[Chi]=ang[kk]=atan2(in[kk][2],in[kk][1])/2.==ArcTan[in[kk][1],in[kk][2]]/2\
\>", "Text",
 CellChangeTimes->{{3.521176662127205*^9, 3.5211766657364116`*^9}, {
  3.5211768165160356`*^9, 3.5211768293917723`*^9}, {3.5211769112204523`*^9, 
  3.5211769459794407`*^9}, {3.5211770038947535`*^9, 3.521177163516883*^9}}],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"ArcTan", "[", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"yy", "[", "2", "]"}], "]"}], ",", 
      RowBox[{"Sin", "[", 
       RowBox[{"yy", "[", "2", "]"}], "]"}]}], "]"}], "/", "2"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", "<", 
     RowBox[{"yy", "[", "2", "]"}], "<", 
     FractionBox["\[Pi]", "2"]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.521177168448165*^9, 3.5211772286276073`*^9}}],

Cell["\<\
\[Chi] \[Proportional] rVc \[Proportional] RM/\[Nu]^2<0 (RM<0)
\[Implies] higher \[Nu] \[Implies] larger \[Chi]\
\>", "Text",
 CellChangeTimes->{{3.521177262435541*^9, 3.5211772957314453`*^9}, 
   3.521177337582839*^9, {3.521177383007437*^9, 3.521177428845059*^9}, {
   3.521177495406866*^9, 3.521177502733285*^9}, {3.5211776058481827`*^9, 
   3.5211776079633036`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Check the integration routine for Stokes", "Subsection",
 CellChangeTimes->{{3.4837084870032*^9, 3.4837084882356*^9}}],

Cell[BoxData[
 RowBox[{
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzt3Vu25ThyGNCz7JF4Sh6CJmBP1uNJW67uq5OXJBh4kgD2/tBq5QEDjwAC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     "], {{0, 880}, {725, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{273.79999999999876`, Automatic},
   ImageSizeRaw->{725, 880},
   PlotRange->{{0, 725}, {0, 880}}], 
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzt2QuKLbuRheGCHomn1BMweAIeR4+6fJsLh/JOKbTioVfW/0HD5ZQyFBGK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     "], {{0, 137}, {863, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{534.0000000000014, Automatic},
   ImageSizeRaw->{863, 137},
   PlotRange->{{0, 863}, {0, 137}}]}]], "Input",
 CellChangeTimes->{3.4743287469309998`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"maxy", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"susu", "[", "nn_", "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"F", "[", 
        RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"a", " ", "b"}], "]"}], 
        RowBox[{"Exp", "[", 
         RowBox[{
          SuperscriptBox["a", "2"], "+", 
          RowBox[{"0.1", 
           SuperscriptBox["b", "2"]}], "+", 
          FractionBox["1", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", "0.25"}]]}], "]"}]}]}], ";", 
      RowBox[{"snxy", "=", "nn"}], ";", "\[IndentingNewLine]", 
      RowBox[{"xtab", "=", 
       RowBox[{"maxy", " ", 
        RowBox[{"Range", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1", ",", 
          FractionBox["2.", "snxy"]}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ftab", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"F", "[", 
          RowBox[{"xtab", ",", "#"}], "]"}], "&"}], "/@", "xtab"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Dimensions", "[", "ftab", "]"}], ";", "\n", 
      RowBox[{"ss", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"ftab", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"gx", "+", "0"}], ",", 
                 RowBox[{"gy", "+", "0"}]}], "]"}], "]"}], "+", 
              RowBox[{"3", 
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"gx", "+", "1"}], ",", 
                  RowBox[{"gy", "+", "0"}]}], "]"}], "]"}]}], "+", 
              RowBox[{"3", 
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"gx", "+", "2"}], ",", 
                  RowBox[{"gy", "+", "0"}]}], "]"}], "]"}]}], "+", 
              RowBox[{"ftab", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"gx", "+", "3"}], ",", 
                 RowBox[{"gy", "+", "0"}]}], "]"}], "]"}]}], ")"}], "+", 
            RowBox[{"3", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"gx", "+", "0"}], ",", 
                  RowBox[{"gy", "+", "1"}]}], "]"}], "]"}], "+", 
               RowBox[{"3", 
                RowBox[{"ftab", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"gx", "+", "1"}], ",", 
                   RowBox[{"gy", "+", "1"}]}], "]"}], "]"}]}], "+", 
               RowBox[{"3", 
                RowBox[{"ftab", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"gx", "+", "2"}], ",", 
                   RowBox[{"gy", "+", "1"}]}], "]"}], "]"}]}], "+", 
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"gx", "+", "3"}], ",", 
                  RowBox[{"gy", "+", "1"}]}], "]"}], "]"}]}], ")"}]}], "+", 
            RowBox[{"3", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"gx", "+", "0"}], ",", 
                  RowBox[{"gy", "+", "2"}]}], "]"}], "]"}], "+", 
               RowBox[{"3", 
                RowBox[{"ftab", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"gx", "+", "1"}], ",", 
                   RowBox[{"gy", "+", "2"}]}], "]"}], "]"}]}], "+", 
               RowBox[{"3", 
                RowBox[{"ftab", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"gx", "+", "2"}], ",", 
                   RowBox[{"gy", "+", "2"}]}], "]"}], "]"}]}], "+", 
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"gx", "+", "3"}], ",", 
                  RowBox[{"gy", "+", "2"}]}], "]"}], "]"}]}], ")"}]}], "+", 
            "\[IndentingNewLine]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"ftab", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"gx", "+", "0"}], ",", 
                 RowBox[{"gy", "+", "3"}]}], "]"}], "]"}], "+", 
              RowBox[{"3", 
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"gx", "+", "1"}], ",", 
                  RowBox[{"gy", "+", "3"}]}], "]"}], "]"}]}], "+", 
              RowBox[{"3", 
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"gx", "+", "2"}], ",", 
                  RowBox[{"gy", "+", "3"}]}], "]"}], "]"}]}], "+", 
              RowBox[{"ftab", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"gx", "+", "3"}], ",", 
                 RowBox[{"gy", "+", "3"}]}], "]"}], "]"}]}], ")"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"gx", ",", "1", ",", 
             RowBox[{"snxy", "-", "2"}], ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"gy", ",", "1", ",", 
             RowBox[{"snxy", "-", "2"}], ",", "3"}], "}"}]}], "]"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            FractionBox["3", "8"], "h"}], ")"}], "2"], 
         SuperscriptBox["maxy", "2"]}], "/.", 
        RowBox[{"h", "\[Rule]", 
         FractionBox["2", "snxy"]}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"tt", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"ftab", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"gx", "+", "0"}], ",", 
                    RowBox[{"gy", "+", "0"}]}], "]"}], "]"}], "+", 
                 RowBox[{"4", 
                  RowBox[{"ftab", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"gx", "+", "1"}], ",", 
                    RowBox[{"gy", "+", "0"}]}], "]"}], "]"}]}], "+", 
                 RowBox[{"ftab", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"gx", "+", "2"}], ",", 
                    RowBox[{"gy", "+", "0"}]}], "]"}], "]"}]}], ")"}], "+", 
               RowBox[{"4", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"ftab", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"gx", "+", "0"}], ",", 
                    RowBox[{"gy", "+", "1"}]}], "]"}], "]"}], "+", 
                  RowBox[{"4", 
                   RowBox[{"ftab", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"gx", "+", "1"}], ",", 
                    RowBox[{"gy", "+", "1"}]}], "]"}], "]"}]}], "+", 
                  RowBox[{"ftab", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"gx", "+", "2"}], ",", 
                    RowBox[{"gy", "+", "1"}]}], "]"}], "]"}]}], ")"}]}], "+", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"ftab", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"gx", "+", "0"}], ",", 
                    RowBox[{"gy", "+", "2"}]}], "]"}], "]"}], "+", 
                 RowBox[{"4", 
                  RowBox[{"ftab", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"gx", "+", "1"}], ",", 
                    RowBox[{"gy", "+", "2"}]}], "]"}], "]"}]}], "+", 
                 RowBox[{"ftab", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"gx", "+", "2"}], ",", 
                    RowBox[{"gy", "+", "2"}]}], "]"}], "]"}]}], ")"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"gx", ",", "1", ",", 
                RowBox[{"snxy", "-", "2"}], ",", "2"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"gy", ",", "1", ",", 
                RowBox[{"snxy", "-", "2"}], ",", "2"}], "}"}]}], "]"}], 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["h", "3"], ")"}], "2"]}], "+", 
           RowBox[{
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"gx", "+", "0"}], ",", 
                  RowBox[{"snxy", "+", "0"}]}], "]"}], "]"}], "+", 
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"gx", "+", "1"}], ",", 
                  RowBox[{"snxy", "+", "0"}]}], "]"}], "]"}], "+", 
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"gx", "+", "0"}], ",", 
                  RowBox[{"snxy", "+", "1"}]}], "]"}], "]"}], "+", 
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"gx", "+", "1"}], ",", 
                  RowBox[{"snxy", "+", "1"}]}], "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"gx", ",", "1", ",", "snxy"}], "}"}]}], "]"}], 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["h", "2"], ")"}], "2"]}], "+", 
           RowBox[{
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"snxy", "+", "0"}], ",", 
                  RowBox[{"gy", "+", "0"}]}], "]"}], "]"}], "+", 
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"snxy", "+", "1"}], ",", 
                  RowBox[{"gy", "+", "0"}]}], "]"}], "]"}], "+", 
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"snxy", "+", "0"}], ",", 
                  RowBox[{"gy", "+", "1"}]}], "]"}], "]"}], "+", 
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"snxy", "+", "1"}], ",", 
                  RowBox[{"gy", "+", "1"}]}], "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"gy", ",", "1", ",", 
                RowBox[{"snxy", "-", "1"}]}], "}"}]}], "]"}], 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["h", "2"], ")"}], "2"]}]}], ")"}], 
         SuperscriptBox["maxy", "2"]}], "/.", 
        RowBox[{"h", "\[Rule]", 
         FractionBox["2", "snxy"]}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"vv", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ftab", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"gx", "+", "0"}], ",", 
               RowBox[{"gy", "+", "0"}]}], "]"}], "]"}], "+", 
            RowBox[{"ftab", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"gx", "+", "1"}], ",", 
               RowBox[{"gy", "+", "0"}]}], "]"}], "]"}], "+", 
            RowBox[{"ftab", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"gx", "+", "0"}], ",", 
               RowBox[{"gy", "+", "1"}]}], "]"}], "]"}], "+", 
            RowBox[{"ftab", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"gx", "+", "1"}], ",", 
               RowBox[{"gy", "+", "1"}]}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"gx", ",", "1", ",", "snxy"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"gy", ",", "1", ",", "snxy"}], "}"}]}], "]"}], 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["h", "2"], ")"}], "2"], 
         SuperscriptBox["maxy", "2"]}], "/.", 
        RowBox[{"h", "\[Rule]", 
         FractionBox["2", "snxy"]}]}]}], ";"}], ")"}], "//", "Quiet"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"susu", "[", "45", "]"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{
    RowBox[{"InputForm", "[", "ss", "]"}], ",", "\"\< \>\"", ",", 
    RowBox[{"InputForm", "[", "tt", "]"}], ",", "\"\< \>\"", ",", 
    RowBox[{"InputForm", "[", "vv", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   RowBox[{"F", "[", 
    RowBox[{"a", ",", "b"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", 
     RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", 
     RowBox[{"-", "maxy"}], ",", "maxy"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.474328855212*^9, 3.474328912689*^9}, {3.474328994981*^9,
    3.474329059533*^9}, {3.474329187368*^9, 3.474329372217*^9}, 
   3.474330171017*^9, {3.474330228369*^9, 3.474330346276*^9}, 
   3.4743307625039997`*^9, {3.474330831315*^9, 3.474330886433*^9}, {
   3.4743309366619997`*^9, 3.474331039821*^9}, {3.474331323031*^9, 
   3.474331331899*^9}, {3.474331363001*^9, 3.474331363859*^9}, {
   3.474331404889*^9, 3.474331587708*^9}, {3.47433162965*^9, 
   3.474331724031*^9}, {3.474331757527*^9, 3.4743317586140003`*^9}, {
   3.474331799324*^9, 3.474331815087*^9}, 3.474331930866*^9, {
   3.4743322037130003`*^9, 3.474332205144*^9}, {3.474375438644*^9, 
   3.474375439983*^9}, {3.483708847151*^9, 3.483708847414*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "snxy", "]"}], ";", 
  RowBox[{"StringReplace", "[", 
   RowBox[{
    RowBox[{"ToString", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"InputForm", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"ftab", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"gx", "+", "0"}], ",", 
                RowBox[{"gy", "+", "0"}]}], "]"}], "]"}], "+", 
             RowBox[{"4", 
              RowBox[{"ftab", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"gx", "+", "1"}], ",", 
                 RowBox[{"gy", "+", "0"}]}], "]"}], "]"}]}], "+", 
             RowBox[{"ftab", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"gx", "+", "2"}], ",", 
                RowBox[{"gy", "+", "0"}]}], "]"}], "]"}]}], ")"}], "+", 
           RowBox[{"4", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"ftab", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"gx", "+", "0"}], ",", 
                 RowBox[{"gy", "+", "1"}]}], "]"}], "]"}], "+", 
              RowBox[{"4", 
               RowBox[{"ftab", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{"gx", "+", "1"}], ",", 
                  RowBox[{"gy", "+", "1"}]}], "]"}], "]"}]}], "+", 
              RowBox[{"ftab", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"gx", "+", "2"}], ",", 
                 RowBox[{"gy", "+", "1"}]}], "]"}], "]"}]}], ")"}]}], "+", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"ftab", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"gx", "+", "0"}], ",", 
                RowBox[{"gy", "+", "2"}]}], "]"}], "]"}], "+", 
             RowBox[{"4", 
              RowBox[{"ftab", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"gx", "+", "1"}], ",", 
                 RowBox[{"gy", "+", "2"}]}], "]"}], "]"}]}], "+", 
             RowBox[{"ftab", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"gx", "+", "2"}], ",", 
                RowBox[{"gy", "+", "2"}]}], "]"}], "]"}]}], ")"}]}], ",", 
          RowBox[{
           RowBox[{"ftab", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"gx", "+", "0"}], ",", 
              RowBox[{"snxy", "+", "0"}]}], "]"}], "]"}], "+", 
           RowBox[{"ftab", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"gx", "+", "1"}], ",", 
              RowBox[{"snxy", "+", "0"}]}], "]"}], "]"}], "+", 
           RowBox[{"ftab", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"gx", "+", "0"}], ",", 
              RowBox[{"snxy", "+", "1"}]}], "]"}], "]"}], "+", 
           RowBox[{"ftab", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"gx", "+", "1"}], ",", 
              RowBox[{"snxy", "+", "1"}]}], "]"}], "]"}]}], ",", 
          RowBox[{
           RowBox[{"ftab", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"snxy", "+", "0"}], ",", 
              RowBox[{"gy", "+", "0"}]}], "]"}], "]"}], "+", 
           RowBox[{"ftab", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"snxy", "+", "1"}], ",", 
              RowBox[{"gy", "+", "0"}]}], "]"}], "]"}], "+", 
           RowBox[{"ftab", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"snxy", "+", "0"}], ",", 
              RowBox[{"gy", "+", "1"}]}], "]"}], "]"}], "+", 
           RowBox[{"ftab", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"snxy", "+", "1"}], ",", 
              RowBox[{"gy", "+", "1"}]}], "]"}], "]"}]}]}], "}"}], "]"}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"A_", "[", 
          RowBox[{"[", 
           RowBox[{"n_", ",", "m_"}], "]"}], "]"}], "\[Rule]", 
         RowBox[{
          RowBox[{
           RowBox[{"ausin", "[", "n", "]"}], "[", "m", "]"}], "[", "il", 
          "]"}]}], "}"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"gx", "\[Rule]", "ix"}], ",", 
        RowBox[{"gy", "\[Rule]", "iy"}]}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<ausin\>\"", "\[Rule]", "\"\<(*ausin)\>\""}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.474375457977*^9, 3.4743755198*^9}, {3.474375629104*^9, 
  3.4743757765559998`*^9}, {3.474375806841*^9, 3.474375893376*^9}, {
  3.474376052642*^9, 3.4743760772679996`*^9}, {3.4837089278436003`*^9, 
  3.4837089315252*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Check definitions of distance to Sgr A*, percentages, position angles\
\>", "Subsection",
 CellChangeTimes->{{3.4837146171324*^9, 3.4837146181308002`*^9}, {
  3.4874324680888*^9, 3.4874324744068003`*^9}}],

Cell["percentages OK", "Text",
 CellChangeTimes->{{3.4837149118476*^9, 3.4837149159035997`*^9}}],

Cell[BoxData[{
 RowBox[{"ruru", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"rg", "\[Rule]", 
     FractionBox[
      RowBox[{" ", 
       RowBox[{"6.67", " ", 
        SuperscriptBox["10", 
         RowBox[{"-", "8"}]], "4.5", " ", 
        SuperscriptBox["10", "6"], "2", " ", 
        SuperscriptBox["10", "33"]}]}], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"3", " ", 
         SuperscriptBox["10", "10"]}], ")"}], "2"]]}], 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"=", 
       RowBox[{"1", "M"}]}], ",", " ", 
      RowBox[{"not", " ", "2", "M"}]}], "*)"}], ",", 
    RowBox[{"arcsec", "\[Rule]", 
     FractionBox[
      RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
       SuperscriptBox["10", "3"], "3.08", " ", 
       SuperscriptBox["10", "18"]}], 
      RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
    RowBox[{"pc", "\[Rule]", 
     RowBox[{"3.08", " ", 
      SuperscriptBox["10", "18"]}]}], ",", 
    RowBox[{"year", "\[Rule]", 
     RowBox[{"365.35", " ", "86400"}]}], ",", 
    RowBox[{"cc", "\[Rule]", 
     RowBox[{"3.", " ", 
      SuperscriptBox["10", "10"]}]}], ",", 
    RowBox[{"Msun", "\[Rule]", 
     RowBox[{"2.", " ", 
      SuperscriptBox["10", "33"]}]}], ",", 
    RowBox[{"mp", "\[Rule]", 
     RowBox[{"1.26", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "24"}]]}]}], ",", 
    RowBox[{"me", "\[Rule]", 
     RowBox[{"9.1", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "28"}]]}]}], ",", 
    RowBox[{"kb", "\[Rule]", 
     RowBox[{"1.38", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "16"}]]}]}], ",", 
    RowBox[{"h", "\[Rule]", 
     RowBox[{"6.626", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "27"}]]}]}], ",", 
    RowBox[{"ee", "\[Rule]", 
     RowBox[{"4.8", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "10"}]]}]}], ",", 
    RowBox[{"keV", "->", 
     RowBox[{"1000", " ", "1.602", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "12"}]]}]}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"unit", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     SuperscriptBox["10", "23"], 
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", "rg", ")"}], "2"], 
      SuperscriptBox["DD", "2"]]}], "/.", 
    RowBox[{"DD", "\[Rule]", 
     RowBox[{"8.4", " ", 
      SuperscriptBox["10", "3"], "pc"}]}]}], "/.", "ruru"}]}]}], "Input",
 CellChangeTimes->{{3.4837151175024*^9, 3.4837151290620003`*^9}, 
   3.4923033912066*^9, {3.5025610221418*^9, 3.502561043467*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["rg", 
   RowBox[{"cc", " ", "60"}]], "/.", "ruru", 
  RowBox[{"(*", 
   RowBox[{"min", " ", "in", " ", "rg"}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.4923033934062*^9, 3.4923034400502*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox["180", "\[Pi]"], 
       RowBox[{
        RowBox[{"ArcTan", "[", 
         RowBox[{"Q", ",", "U"}], "]"}], "/", "2"}]}], "+", "180"}], ",", 
     "180"}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"U", "\[Rule]", 
      RowBox[{"-", "7."}]}], ",", 
     RowBox[{"Q", "\[Rule]", 
      RowBox[{"-", "244"}]}]}], "}"}]}], 
  RowBox[{"(*", 
   RowBox[{"compare", " ", "with", " ", "Marrone", " ", "2007"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox["180", "\[Pi]"], 
       RowBox[{
        RowBox[{"ArcTan", "[", 
         RowBox[{"Q", ",", "U"}], "]"}], "/", "2"}]}], "+", "180"}], ",", 
     "180"}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"U", "\[Rule]", "28"}], ",", 
     RowBox[{"Q", "\[Rule]", 
      RowBox[{"-", "224."}]}]}], "}"}]}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Note", " ", "that", " ", 
     RowBox[{"ArcTan", "[", 
      RowBox[{"Q", ",", "U"}], "]"}], " ", "is", " ", "the", " ", "same", " ",
      "as", " ", "atan2", 
     RowBox[{"(", 
      RowBox[{"U", ",", "Q"}], ")"}], " ", "in", " ", 
     RowBox[{
      RowBox[{"C", "++"}], " ", "--"}]}], "-", " ", 
    RowBox[{"the", " ", "arguments", " ", "exchange"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      FractionBox["180", "\[Pi]"], 
      RowBox[{
       RowBox[{"ArcTan", "[", 
        RowBox[{"Q", ",", "U"}], "]"}], "/", "2"}]}], "+", "180"}], ",", 
    "180"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"U", "\[Rule]", 
     RowBox[{"-", "176"}]}], ",", 
    RowBox[{"Q", "\[Rule]", "100."}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      FractionBox["180", "\[Pi]"], 
      RowBox[{
       RowBox[{"ArcTan", "[", 
        RowBox[{"Q", ",", "U"}], "]"}], "/", "2"}]}], "+", "180"}], ",", 
    "180"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"U", "\[Rule]", 
     RowBox[{"-", "14"}]}], ",", 
    RowBox[{"Q", "\[Rule]", 
     RowBox[{"-", "12."}]}]}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.475880542967*^9, 3.475880628495*^9}, {
  3.4758806603789997`*^9, 3.4758808960690002`*^9}, {3.47588095138*^9, 
  3.475880959453*^9}, {3.4857770846036153`*^9, 3.4857770941040154`*^9}, {
  3.485777128283615*^9, 3.485777170996415*^9}, {3.4857773369798155`*^9, 
  3.4857773473694153`*^9}}],

Cell[TextData[{
 "atan2 calculates the arctangent of y/x\natan2( y, x)\n",
 Cell[BoxData[Cell[TextData[{
   Cell[BoxData[
    RowBox[{
     ButtonBox["ArcTan",
      BaseStyle->"Link",
      ButtonData->"paclet:ref/ArcTan"], "[", 
     RowBox[{
      StyleBox["x", "TI"], ",", 
      StyleBox["y", "TI"]}], "]"}]], "InlineFormula"],
   "\[LineSeparator]gives the arc tangent of ",
   Cell[BoxData[
    FormBox[
     FractionBox["y", "x"], TraditionalForm]], "InlineMath"],
   ", taking into account which quadrant the point ",
   Cell[BoxData[
    FormBox[
     RowBox[{"(", 
      RowBox[{"x", ",", "y"}], ")"}], TraditionalForm]], "InlineMath"],
   " is in. "
  }]]],
  GridBoxOptions->{
  GridBoxBackground->{
   "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
    "RowsIndexed" -> {}}}]
}], "Text",
 CellChangeTimes->{{3.4857772416794157`*^9, 3.4857772775906153`*^9}}]
}, Closed]],

Cell["Check xisq definition & residual calculations", "Subsection",
 CellChangeTimes->{{3.4837158124824*^9, 3.4837158126228*^9}}],

Cell["Check that file output is correct for poliresa", "Subsection",
 CellChangeTimes->{{3.483716867803*^9, 3.4837168690042*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Geoint functions", "Section",
 CellChangeTimes->{{3.4837171421602*^9, 3.4837171453582*^9}}],

Cell["Initializing the equations and defining quantities", "Subsection",
 CellChangeTimes->{{3.4837171486342*^9, 3.483717150475*^9}}],

Cell[CellGroupData[{

Cell["Defining initial vector to certain accuracy", "Subsection",
 CellChangeTimes->{{3.4837206618166*^9, 3.483720663283*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"b", "\[Rule]", 
   SqrtBox[
    RowBox[{
     SuperscriptBox["xpl", "2"], "+", 
     SuperscriptBox["ypl", "2"]}]]}], ";", 
  RowBox[{"rA", "=", 
   SqrtBox[
    RowBox[{
     SuperscriptBox["r0", "2"], "+", 
     SuperscriptBox["b", "2"]}]]}], ";", 
  RowBox[{"\[Theta]A", "=", 
   RowBox[{"ArcCos", "[", 
    FractionBox[
     RowBox[{
      RowBox[{"r0", " ", 
       RowBox[{"Cos", "[", "\[Theta]0", "]"}]}], "-", 
      RowBox[{"b", " ", 
       RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Theta]0", "]"}]}]}], "rA"], "]"}]}], ";", 
  RowBox[{"\[Phi]A", "=", 
   RowBox[{"ArcTan", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"r0", " ", 
       RowBox[{"Sin", "[", "\[Theta]0", "]"}]}], "+", 
      RowBox[{"b", " ", 
       RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
       RowBox[{"Cos", "[", "\[Theta]0", "]"}]}]}], ",", 
     RowBox[{"b", " ", 
      RowBox[{"Sin", "[", "\[Beta]", "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"initss", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"FullSimplify", "[", 
      RowBox[{
       RowBox[{"Normal", "[", 
        RowBox[{"Series", "[", 
         RowBox[{
          RowBox[{"init", "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"t", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
             RowBox[{
              RowBox[{"\[Phi]", "[", "0", "]"}], "\[Equal]", "\[Phi]A"}], ",", 
             RowBox[{
              RowBox[{"r", "[", "0", "]"}], "\[Equal]", "rA"}], ",", 
             RowBox[{
              RowBox[{"\[Mu]", "[", "0", "]"}], "==", 
              FractionBox[
               RowBox[{
                RowBox[{"r0", " ", 
                 RowBox[{"Cos", "[", "\[Theta]0", "]"}]}], "-", 
                RowBox[{"b", " ", 
                 RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
                 RowBox[{"Sin", "[", "\[Theta]0", "]"}]}]}], "rA"]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"r", "'"}], "[", "0", "]"}], "\[Equal]", 
              RowBox[{"-", "r0"}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Mu]", "'"}], "[", "0", "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"-", 
                RowBox[{"Sin", "[", "\[Theta]A", "]"}]}], 
               FractionBox[
                RowBox[{"r0", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Sin", "[", "\[Theta]A", "]"}], "-", 
                   RowBox[{
                    RowBox[{"Cos", "[", "\[Theta]A", "]"}], " ", 
                    RowBox[{"Cos", "[", "\[Phi]A", "]"}], " ", 
                    RowBox[{"Tan", "[", "\[Theta]0", "]"}]}]}], ")"}]}], 
                RowBox[{"rA", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Cos", "[", "\[Theta]A", "]"}], "+", 
                   RowBox[{
                    RowBox[{"Cos", "[", "\[Phi]A", "]"}], " ", 
                    RowBox[{"Sin", "[", "\[Theta]A", "]"}], " ", 
                    RowBox[{"Tan", "[", "\[Theta]0", "]"}]}]}], 
                  ")"}]}]]}]}]}], "}"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"b", ",", "0", ",", "2"}], "}"}]}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"r0", ">", "0"}], ",", 
         RowBox[{"\[Pi]", ">", "\[Beta]", ">", "0"}], ",", 
         RowBox[{"\[Pi]", ">", "\[Theta]0", ">", "0"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"t", "[", "0", "]"}], ",", 
       RowBox[{"\[Phi]", "[", "0", "]"}], ",", 
       RowBox[{"r", "[", "0", "]"}], ",", 
       RowBox[{"\[Mu]", "[", "0", "]"}], ",", 
       RowBox[{
        RowBox[{"r", "'"}], "[", "0", "]"}], ",", 
       RowBox[{
        RowBox[{"\[Mu]", "'"}], "[", "0", "]"}]}], "}"}]}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.4616294195238266`*^9, 3.4616294916368265`*^9}, {
  3.461629537234827*^9, 3.461629557491827*^9}, {3.461629593591827*^9, 
  3.4616296487548265`*^9}, {3.461629722085827*^9, 3.4616297304438267`*^9}, {
  3.4838025900488*^9, 3.4838026018736*^9}, {3.4838966159934*^9, 
  3.483896629035*^9}, {3.4839013603746*^9, 3.4839013617162*^9}}],

Cell[BoxData[
 RowBox[{"StringReplace", "[", 
  RowBox[{
   RowBox[{"ToString", "[", 
    RowBox[{"InputForm", "[", "initss", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\"\<Cos[\[Beta]]\>\"", "\[Rule]", "\"\<cosbeta\>\""}], ",", 
     RowBox[{"\"\<Sin[\[Beta]]\>\"", "\[Rule]", "\"\<sinbeta\>\""}], ",", 
     RowBox[{"\"\<Sin[\[Theta]0]\>\"", "\[Rule]", "\"\<sinth\>\""}], ",", 
     RowBox[{"\"\<r0^2\>\"", "\[Rule]", "\"\<r0sq\>\""}], ",", 
     RowBox[{"\"\<b^2\>\"", "\[Rule]", "\"\<bsq\>\""}], ",", 
     RowBox[{"\"\<Cos[\[Theta]0]\>\"", "\[Rule]", "\"\<costh\>\""}], ",", 
     RowBox[{"\"\<*Csc[\[Theta]0]\>\"", "\[Rule]", "\"\</sinth\>\""}], ",", 
     RowBox[{"\"\<Cot[\[Theta]0]\>\"", "\[Rule]", "\"\<costh/sinth\>\""}]}], 
    "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4838966630586*^9, 3.4838968414914*^9}}],

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"ArcTan", "[", 
     FractionBox["b", "a"], "]"}], "==", 
    RowBox[{"ArcTan", "[", 
     RowBox[{"a", ",", "b"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      FractionBox["\[Pi]", "2"], ">", "a", ">", "0"}], ",", 
     RowBox[{
      FractionBox["\[Pi]", "2"], ">", "b", ">", "0"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.4838044019586*^9, 3.483804409899*^9}, {
  3.4838049470694*^9, 3.483804998409*^9}}],

Cell[TextData[{
 "beta = atan2 (yg, xg) - corresponds to the picture\nxpl=b Cos[\[Beta]]; \
ypl=b Sin[\[Beta]];rA Cos[\[Theta]A] == r Cos[\[Theta]0] + ypl Sin[\[Theta]0] \
\[Implies] \[Theta]A=ArcCos",
 Cell[BoxData[
  FormBox[
   RowBox[{"[", 
    FractionBox[
     RowBox[{
      RowBox[{"r0", " ", 
       RowBox[{"Cos", "[", "\[Theta]0", "]"}]}], "+", 
      RowBox[{"ypl", " ", 
       RowBox[{"Sin", "[", "\[Theta]0", "]"}]}]}], "rA"], "]"}], 
   TraditionalForm]]],
 ";\n Tan[\[Phi]A]==xpl/(r Sin[\[Theta]0]-ypl Cos[\[Theta]0]) \[Implies] ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Phi]A", "=", 
    RowBox[{"ArcTan", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"r0", " ", 
        RowBox[{"Sin", "[", "\[Theta]0", "]"}]}], "-", 
       RowBox[{"ypl", " ", 
        RowBox[{"Cos", "[", "\[Theta]0", "]"}]}]}], ",", " ", "xpl"}], 
     "]"}]}], TraditionalForm]]],
 "; \n \nk={0, Sin[\[Theta]A] Cos[\[Phi]A] Sin[\[Theta]0] + Cos[\[Theta]A] \
Cos[\[Theta]0], Cos[\[Theta]A] Cos[\[Phi]A] Sin[\[Theta]0] - Sin[\[Theta]A] \
Cos[\[Theta]0], Sin[\[Phi]A] Sin[\[Theta]0]};\n",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["k", "\[Mu]"], TraditionalForm]]],
 "={kt,1,0,0}; a0={0,0,-1,0}; b={0,0,0,-1}; \nz=r Cos[\[Theta]];\nx=r Sin[\
\[Theta]]Sin[\[Phi]];\ny=r Sin[\[Theta]]Cos[\[Phi]];\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"r", "=", 
      RowBox[{
       SqrtBox[
        RowBox[{
         SuperscriptBox["x", "2"], "+", 
         SuperscriptBox["y", "2"], "+", 
         SuperscriptBox["z", "2"]}]], "\[Implies]", " ", 
       RowBox[{"dr", "\[Equal]", " ", 
        FractionBox[
         RowBox[{"dx", "+", "dy", "+", "dz"}], "r"]}]}]}], ";"}], " "}], 
   TraditionalForm]]],
 "\n",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Theta]", "=", 
    RowBox[{
     RowBox[{"ArcTan", "[", 
      RowBox[{
       SqrtBox[
        RowBox[{
         SuperscriptBox["x", "2"], "+", 
         SuperscriptBox["y", "2"]}]], "/", "z"}], "]"}], " ", "\[Implies]", 
     " ", 
     RowBox[{"d\[Theta]", " ", "\[Equal]"}]}]}], TraditionalForm]]],
 "\nk={kt,0,Sin[\[Theta]],Cos[\[Theta]]}={kt,kx,ky,kz} at a point {x,y,z}=rA{ \
Sin[\[Theta]A]Sin[\[Phi]A], Sin[\[Theta]A]Cos[\[Phi]A],Cos[\[Phi]A]}; line: ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    FractionBox[
     RowBox[{"x", "-", "xA"}], "kx"], "\[Equal]", 
    FractionBox[
     RowBox[{"y", "-", "yA"}], "ky"], "\[Equal]", 
    FractionBox[
     RowBox[{"z", "-", "zA"}], "kz"], "\[Equal]", "t"}], TraditionalForm]]],
 ";\n"
}], "Text",
 CellChangeTimes->CompressedData["
1:eJwl0VsoQwEABuCDBzG5pcmD25oSShLmgSzG9qBYyGU6RbYpRabF2x7IGkUt
mWgJjVJyja0Vy4M9rCUbW45bCEdiy4aymvMfD3/f09//8Gd39Ut7IgmCyGQC
NWLS7ArQwkGlxAKdaX4KBqjvG2j8KCt0Mzo6n4tgxhgphOaQilU25ZRAU0Fh
PTRqXpug4nxZBgliaB3mJii24ELxxiFcurDbYDTpOPnvbdvhCG15gNNF1Y9w
Nvzmg1dKvh8mlYqDULfZzPoh6I07Zxwg9SnQNJ/4Ah3vOW/wqGP0BzZJOb+w
4EsfhsMcA3HBGJnPiYXcyRbW+9Ydq4dxJWLxGKrvDCdQO6a2w0ud/xT2Pe+7
oI/L98KDKjkFQ+OGW7hWMvIEK19mwh527yjZy9gSP5cK3THWdHhP0zwoqlPz
ocojz4NfsxH5kLPHE8Css88KeL3XUAM14olGeFWb2g613TQJy0VUN9xts/V6
2d+m9qOCzG+rASv8A8aCOKo=
  "]],

Cell[BoxData[
 RowBox[{
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzs3Q14XVWdL/7de+stajGP0wf+E8SbYTqMGR6c8BQdQIXECwZnGIgv6Qh/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     "], {{0, 679}, {777, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{426.00000000000006`, Automatic},
   ImageSizeRaw->{777, 679},
   PlotRange->{{0, 777}, {0, 679}}], 
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzt3c1rY2meL3jBLPMv8LJIaEgykqEr8cC9MGCY7lhMDQgGclEX0iSBoRZF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     "], {{0, 934}, {825, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{320.4000000000014, Automatic},
   ImageSizeRaw->{825, 934},
   PlotRange->{{0, 825}, {0, 934}}]}]], "Input",
 CellChangeTimes->{{3.4838024153278*^9, 3.483802420976*^9}, {
   3.4838110987578*^9, 3.4838111066514*^9}, 3.4838186708059998`*^9, {
   3.4839250861182003`*^9, 3.4839250909542*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"b", ",", "rA", ",", "\[Beta]", ",", "xpl", ",", "ypl"}], "]"}], 
  ";", 
  RowBox[{"rsub", "=", 
   SqrtBox[
    RowBox[{
     SuperscriptBox["x", "2"], "+", 
     SuperscriptBox["y", "2"], "+", 
     SuperscriptBox["z", "2"]}]]}], ";", 
  RowBox[{"\[Theta]sub", "=", 
   RowBox[{"ArcTan", "[", 
    RowBox[{"z", ",", 
     SqrtBox[
      RowBox[{
       SuperscriptBox["x", "2"], "+", 
       SuperscriptBox["y", "2"]}]]}], "]"}]}], ";", 
  RowBox[{"\[Phi]sub", "=", 
   RowBox[{"ArcTan", "[", 
    RowBox[{"x", ",", "y"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"zsub", "=", 
   RowBox[{"r0", " ", 
    RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ";", 
  RowBox[{"xsub", "=", 
   RowBox[{"r0", " ", 
    RowBox[{"Sin", "[", "\[Theta]", "]"}], 
    RowBox[{"Cos", "[", "\[Phi]", "]"}]}]}], ";", 
  RowBox[{"ysub", "=", 
   RowBox[{"r0", " ", 
    RowBox[{"Sin", "[", "\[Theta]", "]"}], 
    RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], ";", 
  RowBox[{"kxyz", "=", 
   RowBox[{"-", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Sin", "[", "\[Theta]0", "]"}], ",", "0", ",", 
      RowBox[{"Cos", "[", "\[Theta]0", "]"}]}], "}"}]}]}], ";", 
  RowBox[{"axyz", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"Cos", "[", "\[Theta]0", "]"}]}], ",", "0", ",", 
     RowBox[{"Sin", "[", "\[Theta]0", "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Checking substitutions: \>\"", ",", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"z", "\[Equal]", "zsub"}], ",", 
       RowBox[{"x", "\[Equal]", "xsub"}], ",", 
       RowBox[{"y", "\[Equal]", "ysub"}]}], "}"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"r0", "\[Rule]", "rsub"}], ",", 
       RowBox[{"\[Theta]", "\[Rule]", "\[Theta]sub"}], ",", 
       RowBox[{"\[Phi]", "\[Rule]", "\[Phi]sub"}]}], "}"}]}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"krr", "=", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Dt", "[", "rsub", "]"}], ",", 
            RowBox[{"Dt", "[", "\[Theta]sub", "]"}], ",", 
            RowBox[{"Dt", "[", "\[Phi]sub", "]"}]}], "}"}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"Dt", "[", "x", "]"}], "\[Rule]", "kx"}], ",", 
            RowBox[{
             RowBox[{"Dt", "[", "y", "]"}], "\[Rule]", "ky"}], ",", 
            RowBox[{
             RowBox[{"Dt", "[", "z", "]"}], "\[Rule]", "kz"}]}], "}"}]}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"z", "\[Rule]", "zsub"}], ",", 
           RowBox[{"x", "\[Rule]", "xsub"}], ",", 
           RowBox[{"y", "\[Rule]", "ysub"}]}], "}"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"r0", "\[Rule]", "rA"}], ",", 
          RowBox[{"\[Theta]", "\[Rule]", "\[Theta]A"}], ",", 
          RowBox[{"\[Phi]", "\[Rule]", "\[Phi]A"}]}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"rA", ">", "0"}], ",", 
         RowBox[{"\[Pi]", ">", "\[Theta]A", ">", "0"}]}], "}"}]}], "]"}], 
     "]"}], "/.", 
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"kx", ",", "ky", ",", "kz"}], "}"}], "\[Rule]", "kxyz"}], 
     "]"}]}]}], ";", 
  RowBox[{"dkrr", "=", 
   RowBox[{"r0", " ", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{"1", ",", "krr"}], "}"}], "]"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"arr", "=", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Dt", "[", "rsub", "]"}], ",", 
            RowBox[{"Dt", "[", "\[Theta]sub", "]"}], ",", 
            RowBox[{"Dt", "[", "\[Phi]sub", "]"}]}], "}"}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"Dt", "[", "x", "]"}], "\[Rule]", "kx"}], ",", 
            RowBox[{
             RowBox[{"Dt", "[", "y", "]"}], "\[Rule]", "ky"}], ",", 
            RowBox[{
             RowBox[{"Dt", "[", "z", "]"}], "\[Rule]", "kz"}]}], "}"}]}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"z", "\[Rule]", "zsub"}], ",", 
           RowBox[{"x", "\[Rule]", "xsub"}], ",", 
           RowBox[{"y", "\[Rule]", "ysub"}]}], "}"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"r0", "\[Rule]", "rA"}], ",", 
          RowBox[{"\[Theta]", "\[Rule]", "\[Theta]A"}], ",", 
          RowBox[{"\[Phi]", "\[Rule]", "\[Phi]A"}]}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"rA", ">", "0"}], ",", 
         RowBox[{"\[Pi]", ">", "\[Theta]A", ">", "0"}]}], "}"}]}], "]"}], 
     "]"}], "/.", 
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"kx", ",", "ky", ",", "kz"}], "}"}], "\[Rule]", "axyz"}], 
     "]"}]}]}], ";", 
  RowBox[{"darr", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "arr"}], "}"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"r", "\[Equal]", "rsub"}], ",", 
        RowBox[{"\[Theta]", "\[Equal]", "\[Theta]sub"}], ",", 
        RowBox[{"\[Phi]", "\[Equal]", "\[Phi]sub"}]}], "}"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"z", "\[Rule]", 
         RowBox[{"r", " ", 
          RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ",", 
        RowBox[{"x", "\[Rule]", 
         RowBox[{"r", " ", 
          RowBox[{"Sin", "[", "\[Theta]", "]"}], 
          RowBox[{"Cos", "[", "\[Phi]", "]"}]}]}], ",", 
        RowBox[{"y", "\[Rule]", 
         RowBox[{"r", " ", 
          RowBox[{"Sin", "[", "\[Theta]", "]"}], 
          RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}]}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"0", "<", "\[Theta]", "<", "\[Pi]"}], ",", 
       RowBox[{"r", ">", "0"}], ",", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["\[Pi]", "2"]}], "<", "\[Phi]", "<", 
        FractionBox["\[Pi]", "2"]}]}], "}"}]}], "]"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.4838127472098*^9, 3.4838127573966*^9}, {
   3.4838128350846*^9, 3.483812958231*^9}, {3.4838130080106*^9, 
   3.4838131529552*^9}, {3.4838131935776*^9, 3.4838132133428*^9}, {
   3.4838132473352003`*^9, 3.483813274448*^9}, {3.4838134116656*^9, 
   3.4838134949852*^9}, {3.4838250102872*^9, 3.483825043484*^9}, {
   3.4838251598132*^9, 3.4838251631204*^9}, {3.4838252285624*^9, 
   3.483825248858*^9}, {3.4838252952368*^9, 3.483825299324*^9}, {
   3.4838253324272003`*^9, 3.48382533575*^9}, {3.4838254209572*^9, 
   3.4838255016716003`*^9}, {3.4838255486588*^9, 3.4838256349892*^9}, {
   3.4838256715088*^9, 3.4838256897139997`*^9}, {3.4838257426448*^9, 
   3.4838257766528*^9}, {3.4838258402696*^9, 3.4838259305467997`*^9}, {
   3.4838260446296*^9, 3.4838260459868*^9}, {3.4838260977476*^9, 
   3.4838260987771997`*^9}, {3.4838875298202*^9, 3.4838875656222*^9}, {
   3.4838877061782*^9, 3.4838877398274*^9}, {3.4838880575838003`*^9, 
   3.4838880997038*^9}, {3.4838883236106*^9, 3.483888326559*^9}, {
   3.4838883792402*^9, 3.4838883874614*^9}, {3.4838907298482*^9, 
   3.4838907772566*^9}, {3.483891826887*^9, 3.4838918441874*^9}, {
   3.4838945850917997`*^9, 3.4838946161358*^9}, {3.4838947174890003`*^9, 
   3.4838947250550003`*^9}, {3.4838948390285997`*^9, 3.4838948415402*^9}, {
   3.4838949919554*^9, 3.4838950152462*^9}, 3.483961702017*^9, {
   3.483961832745*^9, 3.4839618527441998`*^9}, {3.4839620859018*^9, 
   3.4839620893494*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"rA", "=", 
   SqrtBox[
    RowBox[{
     SuperscriptBox["r0", "2"], "+", 
     SuperscriptBox["b", "2"]}]]}], ";", 
  RowBox[{"\[Theta]A", "=", 
   RowBox[{"ArcCos", "[", 
    FractionBox[
     RowBox[{
      RowBox[{"r0", " ", 
       RowBox[{"Cos", "[", "\[Theta]0", "]"}]}], "-", 
      RowBox[{"b", " ", 
       RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
       RowBox[{"Sin", "[", "\[Theta]0", "]"}]}]}], "rA"], "]"}]}], ";", 
  RowBox[{"\[Phi]A", "=", 
   RowBox[{"ArcTan", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"r0", " ", 
       RowBox[{"Sin", "[", "\[Theta]0", "]"}]}], "+", 
      RowBox[{"b", " ", 
       RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
       RowBox[{"Cos", "[", "\[Theta]0", "]"}]}]}], ",", 
     RowBox[{"b", " ", 
      RowBox[{"Sin", "[", "\[Beta]", "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xkrr", "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{
     RowBox[{"Normal", "[", 
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"dkrr", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"dkrr", "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Sin", "[", "\[Theta]A", "]"}]}], 
           RowBox[{"dkrr", "[", 
            RowBox[{"[", "3", "]"}], "]"}]}], ",", 
          RowBox[{"dkrr", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"b", ",", "0", ",", "2"}], "}"}]}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"r0", ">", "0"}], ",", 
       RowBox[{"0", "<", "\[Theta]0", "<", "\[Pi]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xarr", "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{
     RowBox[{"Normal", "[", 
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"darr", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"darr", "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Sin", "[", "\[Theta]A", "]"}]}], 
           RowBox[{"darr", "[", 
            RowBox[{"[", "3", "]"}], "]"}]}], ",", 
          RowBox[{"darr", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"b", ",", "0", ",", "2"}], "}"}]}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"r0", ">", "0"}], ",", 
       RowBox[{"0", "<", "\[Theta]0", "<", "\[Pi]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"StringReplace", "[", 
  RowBox[{
   RowBox[{"ToString", "[", 
    RowBox[{"InputForm", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"tprin", "==", 
        RowBox[{"xkrr", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ",", 
       RowBox[{"rprin", "==", 
        RowBox[{"xkrr", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", 
       RowBox[{"muprin", "==", 
        RowBox[{"xkrr", "[", 
         RowBox[{"[", "3", "]"}], "]"}]}], ",", 
       RowBox[{"phprin", "==", 
        RowBox[{"xkrr", "[", 
         RowBox[{"[", "4", "]"}], "]"}]}]}], "}"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\"\<Cos[\[Beta]]\>\"", "\[Rule]", "\"\<cosbeta\>\""}], ",", 
     RowBox[{"\"\<Sin[\[Beta]]\>\"", "\[Rule]", "\"\<sinbeta\>\""}], ",", 
     RowBox[{"\"\<Sin[\[Theta]0]\>\"", "\[Rule]", "\"\<sinth\>\""}], ",", 
     RowBox[{"\"\<r0^2\>\"", "\[Rule]", "\"\<r0sq\>\""}], ",", 
     RowBox[{"\"\<b^2\>\"", "\[Rule]", "\"\<bsq\>\""}], ",", 
     RowBox[{"\"\<Cos[\[Theta]0]\>\"", "\[Rule]", "\"\<costh\>\""}], ",", 
     RowBox[{"\"\<*Csc[\[Theta]0]\>\"", "\[Rule]", "\"\</sinth\>\""}], ",", 
     RowBox[{"\"\<Cot[\[Theta]0]\>\"", "\[Rule]", "\"\<costh/sinth\>\""}]}], 
    "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"StringReplace", "[", 
  RowBox[{
   RowBox[{"StringReplace", "[", 
    RowBox[{
     RowBox[{"ToString", "[", 
      RowBox[{"InputForm", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tain", "==", 
          RowBox[{"xarr", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], ",", 
         RowBox[{"rain", "==", 
          RowBox[{"xarr", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", 
         RowBox[{"muain", "==", 
          RowBox[{"xarr", "[", 
           RowBox[{"[", "3", "]"}], "]"}]}], ",", 
         RowBox[{"pain", "==", 
          RowBox[{"xarr", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}]}], "}"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<Cos[\[Beta]]\>\"", "\[Rule]", "\"\<cosbeta\>\""}], ",", 
       RowBox[{"\"\<Sin[\[Beta]]\>\"", "\[Rule]", "\"\<sinbeta\>\""}], ",", 
       RowBox[{"\"\<Sin[\[Theta]0]\>\"", "\[Rule]", "\"\<sinth\>\""}], ",", 
       RowBox[{"\"\<r0^2\>\"", "\[Rule]", "\"\<r0sq\>\""}], ",", 
       RowBox[{"\"\<r0^3\>\"", "\[Rule]", "\"\<(r0sq*r0)\>\""}], ",", 
       RowBox[{"\"\<b^2\>\"", "\[Rule]", "\"\<bsq\>\""}], ",", 
       RowBox[{"\"\<Cos[\[Theta]0]\>\"", "\[Rule]", "\"\<costh\>\""}], ",", 
       RowBox[{"\"\<*Csc[\[Theta]0]\>\"", "\[Rule]", "\"\</sinth\>\""}], ",", 
       RowBox[{"\"\<Cot[\[Theta]0]\>\"", "\[Rule]", "\"\<costh/sinth\>\""}]}],
       "}"}]}], "]"}], ",", 
   RowBox[{
   "\"\<(2*(b - r0)*(b + r0) + bsq*Cos[2*\[Beta]])*sinth)\>\"", "\[Rule]", 
    "\"\<(bsq-2*r0sq+2*bsq*cosbetasq)*sinth)\>\""}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"t", "'"}], "[", "0", "]"}], "\[Rule]", 
      RowBox[{"dkrr", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"r", "'"}], "[", "0", "]"}], "\[Rule]", 
      RowBox[{"dkrr", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Mu]", "'"}], "[", "0", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Sin", "[", "\[Theta]A", "]"}]}], 
       RowBox[{"dkrr", "[", 
        RowBox[{"[", "3", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]", "'"}], "[", "0", "]"}], "\[Rule]", 
      RowBox[{"dkrr", "[", 
       RowBox[{"[", "4", "]"}], "]"}]}]}], "}"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.4839618941622*^9, 3.4839619469370003`*^9}, {
   3.4839619932377996`*^9, 3.4839620432046003`*^9}, {3.4839620986158*^9, 
   3.4839622916345997`*^9}, {3.4839623574042*^9, 3.4839624656526003`*^9}, {
   3.4839625340586*^9, 3.4839625468038*^9}, {3.4839632399586*^9, 
   3.483963263733*^9}, {3.4839637326534*^9, 3.483963754197*^9}, {
   3.4839637849914*^9, 3.483963792807*^9}, {3.4839639697422*^9, 
   3.4839640277586*^9}, {3.4839647286354*^9, 3.4839647308662*^9}, {
   3.4839653699202003`*^9, 3.4839653873454*^9}, 3.4839657871266003`*^9}],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", "*", 
      RowBox[{"(", 
       RowBox[{"bsq", " ", "-", " ", "r0sq"}], ")"}]}], " ", "+", " ", 
     RowBox[{"bsq", "*", 
      RowBox[{"Cos", "[", 
       RowBox[{"2", "*", "\[Beta]"}], "]"}]}]}], ")"}], "/.", 
   RowBox[{
    RowBox[{"Cos", "[", 
     RowBox[{"2", "\[Beta]"}], "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"2", 
      SuperscriptBox[
       RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"]}], "-", "1"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.4839639148302*^9, 3.483963940071*^9}}],

Cell[BoxData[{
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"b", "*", 
      RowBox[{"costh", "/", "sinth"}], "*", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r0", "-", 
         RowBox[{"2", "*", "b", "*", "cosbeta", "*", 
          RowBox[{"costh", "/", "sinth"}]}]}], ")"}], "/", "sinth"}], "*", 
      "sinbeta"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"r0sq", "*", "r0"}], ")"}]}], "==", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"b", "*", "costh", "*", "sinbeta", "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], "*", "b", "*", "cosbeta", "*", "costh"}], "+", 
         RowBox[{"r0", "*", "sinth"}]}], ")"}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"r0sq", "*", "r0", "*", 
       SuperscriptBox["sinth", "2"], "*", "sinth"}], ")"}]}], ")"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", "*", 
        RowBox[{"(", 
         RowBox[{"b", " ", "-", " ", "r0"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"b", " ", "+", " ", "r0"}], ")"}]}], " ", "+", " ", 
       RowBox[{"bsq", "*", 
        RowBox[{"Cos", "[", 
         RowBox[{"2", "*", "\[Beta]"}], "]"}]}]}], ")"}], "*", "sinth"}], 
    "\[Equal]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"bsq", "-", 
       RowBox[{"2", "*", "r0sq"}], "+", 
       RowBox[{"2", "*", "bsq", "*", "cosbetasq"}]}], ")"}], "*", "sinth"}]}],
    "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"r0sq", "\[Rule]", 
      SuperscriptBox["r0", "2"]}], ",", 
     RowBox[{"bsq", "\[Rule]", 
      SuperscriptBox["b", "2"]}], ",", 
     RowBox[{"cosbetasq", "\[Rule]", 
      SuperscriptBox[
       RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"]}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"bsq", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"cosbetasq", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", "*", "costhsq"}]}], ")"}]}]}], ")"}]}], "-", 
        RowBox[{"2", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "costhsq"}], ")"}], "*", "r0sq"}]}], 
       ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"2", "*", "r0sq", "*", "r0", "*", "sinthsq"}], ")"}]}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "*", "b", "*", "r0", "*", "cosbeta", "*", "costh"}], 
         " ", "-", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"bsq", "-", 
            RowBox[{"2", "*", "r0sq"}], "+", 
            RowBox[{"2", "*", "bsq", "*", "cosbetasq"}]}], ")"}], "*", 
          "sinth"}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"2", "*", "r0sq", "*", "r0"}], ")"}]}], ")"}]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"cosbetasq", "\[Rule]", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "\[Beta]", "]"}], "2"]}], ",", 
      RowBox[{"costhsq", "\[Rule]", 
       SuperscriptBox[
        RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], ",", 
      RowBox[{"costh", "\[Rule]", 
       RowBox[{"Cos", "[", "\[Theta]", "]"}]}], ",", 
      RowBox[{"cosbeta", "\[Rule]", 
       RowBox[{"Cos", "[", "\[Beta]", "]"}]}], ",", 
      RowBox[{"sinthsq", "\[Rule]", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], "}"}]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
   "comparison", " ", "to", " ", "the", " ", "incorrect", " ", "previous", 
    " ", "result", " ", "for", " ", "muprin"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.4839638657838*^9, 3.4839639136758003`*^9}, {
  3.4839646232418003`*^9, 3.4839646838166*^9}, {3.4839647367318*^9, 
  3.4839647429406*^9}, {3.4839651927042*^9, 3.4839653217005997`*^9}, {
  3.4839654075162*^9, 3.483965501163*^9}, {3.4839658448310003`*^9, 
  3.483965862459*^9}, {3.4839706153578*^9, 3.483970630131*^9}}],

Cell["-Sin[\[Theta]] \[Theta]'[0] == \[Mu]'[0]", "Text",
 CellChangeTimes->{{3.4839619534734*^9, 3.4839619707114*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"diag", "=", 
   RowBox[{"DiagonalMatrix", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "rA", ",", 
      RowBox[{"rA", " ", 
       RowBox[{"Sin", "[", "\[Theta]A", "]"}]}]}], "}"}], "]"}]}], ";", 
  RowBox[{"ddiag", "=", 
   RowBox[{"DiagonalMatrix", "[", 
    RowBox[{"{", 
     RowBox[{"\[ImaginaryI]", ",", "1", ",", "rA", ",", 
      RowBox[{"rA", " ", 
       RowBox[{"Sin", "[", "\[Theta]A", "]"}]}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{"dkrr", ".", "ddiag", ".", "ddiag", ".", "dkrr"}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     SuperscriptBox["k", "\[Mu]"], 
     SubscriptBox["k", "\[Mu]"]}], "\[Equal]", "0"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{"krr", ".", "diag", ".", "diag", ".", "krr"}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     SubscriptBox["k", "i"], 
     SubscriptBox["k", "i"]}], "\[Equal]", 
    RowBox[{"1", " ", "-", " ", "spatial"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{"arr", ".", "diag", ".", "diag", ".", "arr"}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     SubscriptBox["a", "i"], 
     SubscriptBox["a", "i"]}], "\[Equal]", 
    RowBox[{"1", " ", "-", " ", "spatial"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{"arr", ".", "diag", ".", "diag", ".", "krr"}], "]"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     SubscriptBox["a", "i"], 
     SubscriptBox["k", "i"]}], "\[Equal]", 
    RowBox[{"0", " ", "-", " ", "orthogonality"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"krr", "/.", 
     RowBox[{"\[Theta]A", "\[Rule]", "\[Theta]0"}]}], "/.", 
    RowBox[{"\[Phi]A", "\[Rule]", "0"}]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"radial", " ", "vector"}], 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.483888513447*^9, 3.4838885243514*^9}, {
   3.4838889190782003`*^9, 3.483888920061*^9}, {3.4838907960546*^9, 
   3.4838908045878*^9}, 3.4838946361038*^9, {3.4838947003602*^9, 
   3.4838947006878*^9}, {3.4838947542426*^9, 3.4838947673154*^9}, {
   3.4839610435878*^9, 3.4839610569102*^9}, {3.4839611403858*^9, 
   3.4839611415246*^9}, {3.483961191117*^9, 3.4839612296177998`*^9}, {
   3.4839612671358*^9, 3.4839614202654*^9}, 3.4839617502209997`*^9, {
   3.483961830717*^9, 3.4839618310758*^9}, {3.505828889823*^9, 
   3.5058288903378*^9}, {3.5058289235814*^9, 3.5058289241586*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"subs", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[Theta]0", "\[Rule]", "1.1"}], ",", 
     RowBox[{"r0", "\[Rule]", "10"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", "=", 
   SqrtBox[
    RowBox[{
     SuperscriptBox["xpl", "2"], "+", 
     SuperscriptBox["ypl", "2"]}]]}], ";", 
  RowBox[{"\[Beta]", "=", 
   RowBox[{"ArcTan", "[", 
    RowBox[{"xpl", ",", "ypl"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rA", "=", 
   SqrtBox[
    RowBox[{
     SuperscriptBox["r0", "2"], "+", 
     SuperscriptBox["b", "2"]}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Theta]A", "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{"ArcCos", "[", 
     FractionBox[
      RowBox[{
       RowBox[{"r0", " ", 
        RowBox[{"Cos", "[", "\[Theta]0", "]"}]}], "-", 
       RowBox[{"b", " ", 
        RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
        RowBox[{"Sin", "[", "\[Theta]0", "]"}]}]}], "rA"], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Phi]A", "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{"ArcTan", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"r0", " ", 
        RowBox[{"Sin", "[", "\[Theta]0", "]"}]}], "+", 
       RowBox[{"b", " ", 
        RowBox[{"Cos", "[", "\[Beta]", "]"}], " ", 
        RowBox[{"Cos", "[", "\[Theta]0", "]"}]}]}], ",", 
      RowBox[{"b", " ", 
       RowBox[{"Sin", "[", "\[Beta]", "]"}]}]}], "]"}], "]"}]}], ";", 
  RowBox[{"nn", "=", "5"}], ";", 
  RowBox[{"xmax", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xtab", "=", 
   RowBox[{"Range", "[", 
    RowBox[{
     RowBox[{"-", "xmax"}], ",", "xmax", ",", 
     RowBox[{"2", 
      FractionBox["xmax", "nn"]}]}], "]"}]}], ";", 
  RowBox[{"ytab", "=", 
   RowBox[{"Range", "[", 
    RowBox[{
     RowBox[{"-", "xmax"}], ",", "xmax", ",", 
     RowBox[{"2", 
      FractionBox["xmax", "nn"]}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"lpoints", "=", 
    RowBox[{"ListPointPlot3D", "[", 
     RowBox[{
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], "}"}], ",", 
        RowBox[{"coords", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"xsub", ",", "ysub", ",", "zsub"}], "}"}], "/.", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"r0", "\[Rule]", "rA"}], ",", 
                    RowBox[{"\[Theta]", "\[Rule]", "\[Theta]A"}], ",", 
                    RowBox[{"\[Phi]", "\[Rule]", "\[Phi]A"}]}], "}"}]}], "/.",
                  "subs"}], "/.", 
                RowBox[{"xpl", "\[Rule]", "xtab"}]}], ")"}], "/.", 
              RowBox[{"ypl", "\[Rule]", "ytab"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"3", ",", "2", ",", "1"}], "}"}]}], "]"}], ",", "1"}], 
          "]"}]}]}], "]"}], ",", 
      RowBox[{"BoxRatios", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
      RowBox[{"ViewPoint", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"1000", ",", "1000", ",", "1000"}], "}"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", "Black"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"PointSize", "[", "Large", "]"}]}]}], "]"}]}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"vect", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"krr", "/.", "subs"}], "/.", 
          RowBox[{"xpl", "\[Rule]", 
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"-", "xmax"}], ",", "xmax", ",", 
             RowBox[{"2", 
              FractionBox["xmax", "nn"]}]}], "]"}]}]}], ")"}], "/.", 
        RowBox[{"ypl", "\[Rule]", 
         RowBox[{"Range", "[", 
          RowBox[{
           RowBox[{"-", "xmax"}], ",", "xmax", ",", 
           RowBox[{"2", 
            FractionBox["xmax", "nn"]}]}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "2", ",", "1"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
  RowBox[{
   RowBox[{"len", "=", "0.7"}], ";"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lkvect", "=", 
   RowBox[{"Graphics3D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Blue", ",", 
       RowBox[{"Line", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"xsub", ",", "ysub", ",", "zsub"}], "}"}], "/.", 
                 RowBox[{"Thread", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"r0", ",", "\[Theta]", ",", "\[Phi]"}], "}"}], 
                   "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"rA", ",", "\[Theta]A", ",", "\[Phi]A"}], "}"}]}],
                   "]"}]}], "\[IndentingNewLine]", ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"xsub", ",", "ysub", ",", "zsub"}], "}"}], "/.", 
                 RowBox[{"Thread", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"r0", ",", "\[Theta]", ",", "\[Phi]"}], "}"}], 
                   "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"rA", ",", "\[Theta]A", ",", "\[Phi]A"}], "}"}], 
                    "+", 
                    RowBox[{"len", " ", "krr"}]}], "/.", "subs"}], "/.", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"xpl", "\[Rule]", 
                    RowBox[{"xtab", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], ",", 
                    RowBox[{"ypl", "\[Rule]", 
                    RowBox[{"ytab", "[", 
                    RowBox[{"[", "k", "]"}], "]"}]}]}], "}"}]}], ")"}]}], 
                  "]"}]}]}], "}"}], "/.", "subs"}], "/.", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"xpl", "\[Rule]", 
                RowBox[{"xtab", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}], ",", 
               RowBox[{"ypl", "\[Rule]", 
                RowBox[{"ytab", "[", 
                 RowBox[{"[", "k", "]"}], "]"}]}]}], "}"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"Length", "[", "xtab", "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", 
              RowBox[{"Length", "[", "ytab", "]"}]}], "}"}]}], "]"}], ",", 
          "1"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"BoxRatios", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
     RowBox[{"Axes", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"lavect", "=", 
   RowBox[{"Graphics3D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Blue", ",", 
       RowBox[{"Line", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"xsub", ",", "ysub", ",", "zsub"}], "}"}], "/.", 
                 RowBox[{"Thread", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"r0", ",", "\[Theta]", ",", "\[Phi]"}], "}"}], 
                   "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"rA", ",", "\[Theta]A", ",", "\[Phi]A"}], "}"}]}],
                   "]"}]}], "\[IndentingNewLine]", ",", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"xsub", ",", "ysub", ",", "zsub"}], "}"}], "/.", 
                 RowBox[{"Thread", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"r0", ",", "\[Theta]", ",", "\[Phi]"}], "}"}], 
                   "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"rA", ",", "\[Theta]A", ",", "\[Phi]A"}], "}"}], 
                    "+", 
                    RowBox[{"len", " ", "arr"}]}], "/.", "subs"}], "/.", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"xpl", "\[Rule]", 
                    RowBox[{"xtab", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], ",", 
                    RowBox[{"ypl", "\[Rule]", 
                    RowBox[{"ytab", "[", 
                    RowBox[{"[", "k", "]"}], "]"}]}]}], "}"}]}], ")"}]}], 
                  "]"}]}]}], "}"}], "/.", "subs"}], "/.", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"xpl", "\[Rule]", 
                RowBox[{"xtab", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}], ",", 
               RowBox[{"ypl", "\[Rule]", 
                RowBox[{"ytab", "[", 
                 RowBox[{"[", "k", "]"}], "]"}]}]}], "}"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"Length", "[", "xtab", "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", 
              RowBox[{"Length", "[", "ytab", "]"}]}], "}"}]}], "]"}], ",", 
          "1"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"BoxRatios", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
     RowBox[{"Axes", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"gkvect", "=", 
   RowBox[{"Graphics3D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Red", ",", 
       RowBox[{"Line", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"xsub", ",", "ysub", ",", "zsub"}], "}"}], ",", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"xsub", ",", "ysub", ",", "zsub"}], "}"}], "+", 
                  RowBox[{"len", " ", "kxyz"}]}]}], "}"}], "/.", 
               RowBox[{"Thread", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"r0", ",", "\[Theta]", ",", "\[Phi]"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"rA", ",", "\[Theta]A", ",", "\[Phi]A"}], "}"}]}], 
                "]"}]}], "/.", "subs"}], "/.", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"xpl", "\[Rule]", 
                RowBox[{"xtab", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}], ",", 
               RowBox[{"ypl", "\[Rule]", 
                RowBox[{"ytab", "[", 
                 RowBox[{"[", "k", "]"}], "]"}]}]}], "}"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"Length", "[", "xtab", "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", 
              RowBox[{"Length", "[", "ytab", "]"}]}], "}"}]}], "]"}], ",", 
          "1"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"BoxRatios", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
     RowBox[{"Axes", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gavect", "=", 
   RowBox[{"Graphics3D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Red", ",", 
       RowBox[{"Line", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"xsub", ",", "ysub", ",", "zsub"}], "}"}], ",", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"xsub", ",", "ysub", ",", "zsub"}], "}"}], "+", 
                  RowBox[{"len", " ", "axyz"}]}]}], "}"}], "/.", 
               RowBox[{"Thread", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"r0", ",", "\[Theta]", ",", "\[Phi]"}], "}"}], 
                 "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"rA", ",", "\[Theta]A", ",", "\[Phi]A"}], "}"}]}], 
                "]"}]}], "/.", "subs"}], "/.", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"xpl", "\[Rule]", 
                RowBox[{"xtab", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}], ",", 
               RowBox[{"ypl", "\[Rule]", 
                RowBox[{"ytab", "[", 
                 RowBox[{"[", "k", "]"}], "]"}]}]}], "}"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", 
              RowBox[{"Length", "[", "xtab", "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", 
              RowBox[{"Length", "[", "ytab", "]"}]}], "}"}]}], "]"}], ",", 
          "1"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"BoxRatios", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", 
     RowBox[{"Axes", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{
  "lpoints", ",", "lkvect", ",", "gkvect", ",", "lavect", ",", "gavect"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.4838889511674*^9, 3.4838891994258003`*^9}, {
   3.4838908534002*^9, 3.4838908786254*^9}, {3.4838909104962*^9, 
   3.4838912014986*^9}, {3.4838912456466*^9, 3.483891281979*^9}, {
   3.483891316533*^9, 3.4838913191070004`*^9}, {3.4838914431893997`*^9, 
   3.4838914578845997`*^9}, {3.4838915062914*^9, 3.4838916352566*^9}, {
   3.483891944043*^9, 3.483891945369*^9}, {3.4838924220114*^9, 
   3.4838924417922*^9}, {3.4838927575986*^9, 3.4838927595486*^9}, {
   3.483892793073*^9, 3.4838927934006*^9}, {3.4838928237738*^9, 
   3.4838928253806*^9}, {3.4838929122102003`*^9, 3.4838929149714003`*^9}, {
   3.4838929564518003`*^9, 3.4838929685418*^9}, {3.4838936174706*^9, 
   3.4838936176266003`*^9}, {3.483894192705*^9, 3.4838942258082*^9}, {
   3.483894364149*^9, 3.4838944152390003`*^9}, {3.4838946692226*^9, 
   3.4838946698778*^9}, {3.483894883785*^9, 3.483894968571*^9}, {
   3.483895046025*^9, 3.4838950817178*^9}, {3.4838951128710003`*^9, 
   3.4838952832698*^9}, {3.4838953480722*^9, 3.4838953695066*^9}, {
   3.4838954507514*^9, 3.4838955170982*^9}, 3.4838956006986*^9, {
   3.483895910811*^9, 3.4838959108578*^9}, {3.4838962978626003`*^9, 
   3.4838963150694*^9}, {3.4838963591549997`*^9, 3.4838963602314*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.5624140784486914`*^9, 3.562414078473692*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.4839702136734*^9, 3.4839702137046003`*^9}}],

Cell[BoxData[
 RowBox[{"Total", "[", 
  RowBox[{
   RowBox[{"Abs", "[", 
    RowBox[{
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"kxyz", "/.", 
            RowBox[{"Thread", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"r0", ",", "\[Theta]", ",", "\[Phi]"}], "}"}], 
              "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"rA", ",", "\[Theta]A", ",", "\[Phi]A"}], "}"}]}], 
             "]"}]}], "/.", "subs"}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"xpl", "\[Rule]", 
             RowBox[{"xtab", "[", 
              RowBox[{"[", "i", "]"}], "]"}]}], ",", 
            RowBox[{"ypl", "\[Rule]", 
             RowBox[{"ytab", "[", 
              RowBox[{"[", "k", "]"}], "]"}]}]}], "}"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"Length", "[", "xtab", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", 
           RowBox[{"Length", "[", "ytab", "]"}]}], "}"}]}], "]"}], ",", "1"}],
       "]"}], ".", "\[IndentingNewLine]", 
     RowBox[{"Transpose", "[", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"axyz", "/.", 
             RowBox[{"Thread", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"r0", ",", "\[Theta]", ",", "\[Phi]"}], "}"}], 
               "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"rA", ",", "\[Theta]A", ",", "\[Phi]A"}], "}"}]}], 
              "]"}]}], "/.", "subs"}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xpl", "\[Rule]", 
              RowBox[{"xtab", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}], ",", 
             RowBox[{"ypl", "\[Rule]", 
              RowBox[{"ytab", "[", 
               RowBox[{"[", "k", "]"}], "]"}]}]}], "}"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", 
            RowBox[{"Length", "[", "xtab", "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", 
            RowBox[{"Length", "[", "ytab", "]"}]}], "}"}]}], "]"}], ",", 
        "1"}], "]"}], "]"}]}], "]"}], ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.4838887251078*^9, 3.4838887845594*^9}, 
   3.4838946968658*^9, {3.4838955674706*^9, 3.4838956817094*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Correct Dsolve, definition of lmin, lmax, interpolation", "Subsection",
 CellChangeTimes->{{3.4839702412386*^9, 3.4839702420341997`*^9}}],

Cell[BoxData[{
 RowBox[{"lsol", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"TrigToExp", "[", 
     RowBox[{
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"1", "+", 
          RowBox[{"3", "*", 
           RowBox[{
            RowBox[{"Sinh", "[", "llog", "]"}], "/", "r0"}]}]}], "\[Equal]", 
         "t"}], ",", "llog"}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
    RowBox[{"t", ">", "0"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"lsol", "/.", 
  RowBox[{"t", "\[Rule]", "0"}]}], "\[IndentingNewLine]", 
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"llog", "/.", "lsol"}], "/.", 
      RowBox[{"t", "\[Rule]", "0"}]}], ")"}], "\[Equal]", 
    RowBox[{"-", 
     RowBox[{"Log", "[", 
      RowBox[{
       FractionBox["r0", "3"], "+", 
       SqrtBox[
        RowBox[{"1", "+", 
         FractionBox[
          SuperscriptBox["r0", "2"], "9"]}]]}], "]"}]}]}], ",", 
   RowBox[{"r0", ">", "0"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.483970245903*^9, 3.4839703427634*^9}, {
  3.4839704084862003`*^9, 3.4839704647866*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Geodes functions", "Section",
 CellChangeTimes->{{3.4839706445298*^9, 3.4839706480866003`*^9}}],

Cell[CellGroupData[{

Cell["Definitions of auxilliary and Christoffel symbols", "Subsection",
 CellChangeTimes->{{3.4839707191914*^9, 3.4839707201118*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.4839707206422*^9, 3.4839707209074*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["polarization basis propagation", "Subsection",
 CellChangeTimes->{{3.463219868683*^9, 3.4632198790290003`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[CapitalDelta]", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "-", 
    RowBox[{"2", "r"}], "+", 
    SuperscriptBox["a", "2"]}]}], ";", 
  RowBox[{"\[Rho]sq", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "+", 
    RowBox[{
     SuperscriptBox["a", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}]}], ";", 
  RowBox[{"\[Rho]min", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "-", 
    RowBox[{
     SuperscriptBox["a", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}]}], ";", 
  RowBox[{"\[CapitalSigma]sq", "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["r", "2"], "+", 
       SuperscriptBox["a", "2"]}], ")"}], "2"], "-", 
    RowBox[{
     SuperscriptBox["a", "2"], "\[CapitalDelta]", " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}]}], ";", 
  RowBox[{"gmn", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       FractionBox["\[CapitalSigma]sq", 
        RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
       ",", 
       FractionBox[
        RowBox[{"2", "a", " ", "r"}], 
        RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", 
        FractionBox["\[CapitalDelta]", "\[Rho]sq"]}], ",", "0", ",", "0"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       RowBox[{"-", 
        SuperscriptBox["\[Rho]sq", 
         RowBox[{"-", "1"}]]}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{"2", "a", " ", "r"}], 
        RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
       ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"(", 
          RowBox[{"\[CapitalDelta]", "-", 
           RowBox[{
            SuperscriptBox["a", "2"], 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
         RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]", " ", 
          SuperscriptBox[
           RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]]}]}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"invgmn", "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{"Inverse", "[", "gmn", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Upper index \!\(\*SuperscriptBox[\(g\), \(\[Mu]\[Nu]\)]\)=\>\"", ",", 
   RowBox[{"gmn", "//", "MatrixForm"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Lower index \!\(\*SubscriptBox[\(g\), \(\[Mu]\[Upsilon]\)]\)=\>\"", 
    ",", 
    RowBox[{"invgmn", "//", "MatrixForm"}]}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"lower", " ", "indices"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"x", "[", "1", "]"}], "=", "t"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "2", "]"}], "=", "r"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "3", "]"}], "=", "\[Theta]"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "4", "]"}], "=", "\[Phi]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Gtab", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"G", "[", 
      RowBox[{"i", ",", "k", ",", "l"}], "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"FullSimplify", "[", 
        RowBox[{
         RowBox[{"TrigExpand", "[", 
          RowBox[{
           RowBox[{"FullSimplify", "[", 
            RowBox[{
             FractionBox["1", "2"], 
             RowBox[{"Sum", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"gmn", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "m"}], "]"}], "]"}], "*", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"D", "[", 
                   RowBox[{
                    RowBox[{"invgmn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "k"}], "]"}], "]"}], ",", 
                    RowBox[{"x", "[", "l", "]"}]}], "]"}], "+", 
                  RowBox[{"D", "[", 
                   RowBox[{
                    RowBox[{"invgmn", "[", 
                    RowBox[{"[", 
                    RowBox[{"m", ",", "l"}], "]"}], "]"}], ",", 
                    RowBox[{"x", "[", "k", "]"}]}], "]"}], "-", 
                  RowBox[{"D", "[", 
                   RowBox[{
                    RowBox[{"invgmn", "[", 
                    RowBox[{"[", 
                    RowBox[{"k", ",", "l"}], "]"}], "]"}], ",", 
                    RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], "]"}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{
               SuperscriptBox["r", "2"], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox[
                 RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}], "\[Rule]", 
              "\[Rho]xsq"}], ",", 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["r", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"2", " ", "\[Theta]"}], "]"}]}]}], "\[Rule]", 
              RowBox[{"2", "\[Rho]xsq"}]}], ",", 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "2"}], "+", "r"}], ")"}], " ", "r"}]}], 
              "\[Rule]", "\[CapitalDelta]x"}], ",", 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["r", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                RowBox[{"Cos", "[", 
                 RowBox[{"2", " ", "\[Theta]"}], "]"}]}]}], "\[Rule]", 
              RowBox[{
               RowBox[{"-", "2"}], "\[Rho]xmin"}]}], ",", 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], "+", 
               SuperscriptBox["r", "2"]}], "\[Rule]", "rasq"}]}], "}"}]}], 
          "]"}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"Cos", "[", "\[Theta]", "]"}], "\[Rule]", "\[Mu]"}], ",", 
           RowBox[{
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "\[Rule]", 
            SqrtBox[
             RowBox[{"1", "-", 
              SuperscriptBox["\[Mu]", "2"]}]]}], ",", 
           RowBox[{
            RowBox[{"Cot", "[", "\[Theta]", "]"}], "\[Rule]", 
            FractionBox["\[Mu]", 
             SqrtBox[
              RowBox[{"1", "-", 
               SuperscriptBox["\[Mu]", "2"]}]]]}]}], "}"}]}], "]"}], "/.", 
       RowBox[{
        RowBox[{
         RowBox[{"a", " ", 
          SuperscriptBox["r", "2"]}], "-", 
         RowBox[{
          SuperscriptBox["a", "3"], " ", 
          SuperscriptBox["\[Mu]", "2"]}]}], "\[Rule]", 
        RowBox[{"a", " ", "\[Rho]xmin"}]}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"1", "/", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["\[Mu]", "2"]}]]}], "\[Rule]", 
         SuperscriptBox["sinmu", 
          RowBox[{"-", "1"}]]}], ",", 
        RowBox[{
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["\[Mu]", "2"]}]], "\[Rule]", "sinmu"}], ",", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", 
            SuperscriptBox["\[Mu]", "2"]}], ")"}], 
          RowBox[{"3", "/", "2"}]], "\[Rule]", 
         RowBox[{"sinmu", " ", "sinmusq"}]}], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox["\[Mu]", "2"]}], ")"}], "\[Rule]", 
         RowBox[{"-", "sinmusq"}]}]}], "}"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "1", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"l", ",", "1", ",", "4"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"extab", "=", 
  RowBox[{"{", 
   RowBox[{
   "\[CapitalDelta]", ",", "\[Rho]sq", ",", "\[Rho]min", ",", 
    "\[CapitalSigma]sq"}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.463220923127*^9, 3.463220972642*^9}, {3.463221008804*^9,
   3.463221075686*^9}, {3.463221107111*^9, 3.463221117205*^9}, {
  3.4632212161219997`*^9, 3.463221301648*^9}, {3.463221922961*^9, 
  3.463221944119*^9}, {3.463222058803*^9, 3.463222078215*^9}, {
  3.463222113042*^9, 3.463222118174*^9}, {3.463222438793*^9, 
  3.4632224682539997`*^9}, {3.4632225117869997`*^9, 3.463222525447*^9}, {
  3.463222564815*^9, 3.4632225723929996`*^9}, {3.4632282444430065`*^9, 
  3.4632282566422067`*^9}, {3.4632285589858065`*^9, 3.4632286268926067`*^9}, {
  3.463228662476207*^9, 3.4632287474494066`*^9}, {3.4632291920962067`*^9, 
  3.4632291971506066`*^9}, {3.4633168995550065`*^9, 3.463316902097807*^9}, {
  3.4839717364362*^9, 3.483971737731*^9}}],

Cell[BoxData[{
 RowBox[{"litt", "=", 
  RowBox[{"Complement", "[", 
   RowBox[{
    RowBox[{"Tuples", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], ",", 
    RowBox[{"pos0", "=", 
     RowBox[{"Position", "[", 
      RowBox[{"Gtab", ",", "0"}], "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"zerrul", "=", 
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"gg", "@@@", "pos0"}], "\[Rule]", "0"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"uniq", "=", 
  RowBox[{"Select", "[", 
   RowBox[{"litt", ",", 
    RowBox[{
     RowBox[{
      RowBox[{"#", "[", 
       RowBox[{"[", "2", "]"}], "]"}], "\[LessEqual]", 
      RowBox[{"#", "[", 
       RowBox[{"[", "3", "]"}], "]"}]}], "&"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"compl", "=", 
  RowBox[{"Complement", "[", 
   RowBox[{"litt", ",", "uniq"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"StringReplace", "[", 
  RowBox[{
   RowBox[{"ToString", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"sublg", "=", 
       RowBox[{"Thread", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"gg", "@@@", "compl"}], ")"}], "\[Rule]", 
         RowBox[{"gg", "@@@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", "3", "]"}], "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "&"}], "/@", 
            "compl"}], ")"}]}]}], "]"}]}], ")"}], "/.", 
     RowBox[{
      RowBox[{"gg", "[", 
       RowBox[{"i_", ",", "j_", ",", "k_"}], "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{
        RowBox[{"gg", "[", 
         RowBox[{"i", "-", "1"}], "]"}], "[", 
        RowBox[{"j", "-", "1"}], "]"}], "[", 
       RowBox[{"k", "-", "1"}], "]"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\"\<[\>\"", "\[Rule]", "\"\<\>\""}], ",", 
     RowBox[{"\"\<]\>\"", "\[Rule]", "\"\<\>\""}], ",", 
     RowBox[{"\"\<,\>\"", "\[Rule]", "\"\<,\>\""}], ",", 
     RowBox[{"\"\< \>\"", "\[Rule]", "\"\<\>\""}], ",", 
     RowBox[{"\"\<->\>\"", "\[Rule]", "\"\<=\>\""}]}], "}"}]}], "]"}], "\n", 
 RowBox[{"StringReplace", "[", 
  RowBox[{
   RowBox[{"StringReplace", "[", 
    RowBox[{
     RowBox[{"StringReplace", "[", 
      RowBox[{
       RowBox[{"ToString", "[", 
        RowBox[{"InputForm", "[", 
         RowBox[{
          RowBox[{"Thread", "[", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"gg", "@@@", "uniq"}], ")"}], "\[Rule]", 
            RowBox[{"(", 
             RowBox[{"G", "@@@", "uniq"}], ")"}]}], "]"}], "/.", 
          RowBox[{
           RowBox[{"gg", "[", 
            RowBox[{"i_", ",", "j_", ",", "k_"}], "]"}], "\[Rule]", 
           RowBox[{
            RowBox[{
             RowBox[{"gg", "[", 
              RowBox[{"i", "-", "1"}], "]"}], "[", 
             RowBox[{"j", "-", "1"}], "]"}], "[", 
            RowBox[{"k", "-", "1"}], "]"}]}]}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\"\<[\>\"", "\[Rule]", "\"\<\>\""}], ",", 
         RowBox[{"\"\<]\>\"", "\[Rule]", "\"\<\>\""}], ",", 
         RowBox[{"\"\<,\>\"", "\[Rule]", "\"\<,\>\""}], ",", 
         RowBox[{"\"\< \>\"", "\[Rule]", "\"\<\>\""}], ",", 
         RowBox[{"\"\<->\>\"", "\[Rule]", "\"\<=\>\""}]}], "}"}]}], "]"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<\[Rho]xsq\>\"", "\[Rule]", "\"\<rhosq\>\""}], ",", 
       RowBox[{"\"\<\[CapitalDelta]x\>\"", "\[Rule]", "\"\<dx\>\""}], ",", 
       RowBox[{"\"\<\[Rho]xmin\>\"", "\[Rule]", "\"\<rhomin\>\""}]}], "}"}]}],
     "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\"\<\[Mu]^4\>\"", "\[Rule]", "\"\<musq*musq\>\""}], ",", 
     RowBox[{"\"\<\[Mu]^2\>\"", "\[Rule]", "\"\<musq\>\""}], ",", 
     RowBox[{"\"\<\[Mu]\>\"", "\[Rule]", "\"\<y[5]\>\""}], ",", 
     RowBox[{"\"\<r^2\>\"", "\[Rule]", "\"\<rsq\>\""}], ",", 
     RowBox[{"\"\<r^4\>\"", "\[Rule]", "\"\<rsq*rsq\>\""}], ",", 
     RowBox[{"\"\<r^5\>\"", "\[Rule]", "\"\<rsq*rsq*r\>\""}], ",", 
     RowBox[{"\"\<a^2\>\"", "\[Rule]", "\"\<asq\>\""}], ",", 
     RowBox[{"\"\<a^3\>\"", "\[Rule]", "\"\<asq*a\>\""}], ",", 
     RowBox[{"\"\<a^4\>\"", "\[Rule]", "\"\<asq*asq\>\""}], ",", 
     RowBox[{"\"\<rhosq^2\>\"", "\[Rule]", "\"\<rhosqsq\>\""}], ",", 
     RowBox[{"\"\<rhosq^3\>\"", "\[Rule]", "\"\<(rhosqsq*rhosq)\>\""}], ",", 
     RowBox[{"\"\<rasq^2\>\"", "\[Rule]", "\"\<rasq*rasq\>\""}], ",", 
     RowBox[{"\"\<r*\>\"", "\[Rule]", "\"\<y[4]*\>\""}], ",", 
     RowBox[{"\"\<r/\>\"", "\[Rule]", "\"\<y[4]/\>\""}], ",", 
     RowBox[{"\"\<r)\>\"", "\[Rule]", "\"\<y[4])\>\""}]}], "}"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.463230021439007*^9, 3.4632300483490067`*^9}, {
   3.4632300802198067`*^9, 3.463230108689807*^9}, {3.4632301397182064`*^9, 
   3.4632301816354065`*^9}, {3.4632302382322063`*^9, 
   3.4632303051562066`*^9}, {3.4632303435010066`*^9, 3.463230351129407*^9}, {
   3.4632304318594065`*^9, 3.4632305573926067`*^9}, {3.463230591665807*^9, 
   3.4632307600522065`*^9}, {3.4632317684518065`*^9, 
   3.4632317689354067`*^9}, {3.4632319746214066`*^9, 3.463231992405407*^9}, 
   3.463233206849807*^9, {3.463233279109007*^9, 3.4632333007306066`*^9}, {
   3.4632339760546064`*^9, 3.463233977755007*^9}, {3.463234008611807*^9, 
   3.4632340096726065`*^9}, {3.4632414445702066`*^9, 3.4632414468166065`*^9}}],

Cell[BoxData[{
 RowBox[{"eqs", "=", 
  RowBox[{"StringReplace", "[", 
   RowBox[{
    RowBox[{"StringReplace", "[", 
     RowBox[{
      RowBox[{"ToString", "[", 
       RowBox[{"InputForm", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Expand", "[", 
             RowBox[{"Solve", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"0", "==", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox["\[PartialD]", 
                    RowBox[{"{", 
                    RowBox[{"\[Lambda]", ",", "2"}], "}"}]], 
                    RowBox[{
                    RowBox[{"x", "[", "k", "]"}], "[", "\[Lambda]", "]"}]}], 
                    "+", 
                    RowBox[{"Sum", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"gg", "[", 
                    RowBox[{"k", ",", "\[Sigma]", ",", "\[Nu]"}], "]"}], "/.", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mu]", "\[Rule]", 
                    RowBox[{"\[Mu]", "[", "\[Lambda]", "]"}]}], ",", 
                    RowBox[{"\[Theta]", "\[Rule]", 
                    RowBox[{"\[Theta]", "[", "\[Lambda]", "]"}]}], ",", 
                    RowBox[{"\[Phi]", "\[Rule]", 
                    RowBox[{"\[Phi]", "[", "\[Lambda]", "]"}]}], ",", 
                    RowBox[{"t", "\[Rule]", 
                    RowBox[{"t", "[", "\[Lambda]", "]"}]}], ",", 
                    RowBox[{"r", "\[Rule]", 
                    RowBox[{"r", "[", "\[Lambda]", "]"}]}]}], "}"}]}], ")"}], 
                    RowBox[{
                    SubscriptBox["\[PartialD]", "\[Lambda]"], 
                    RowBox[{
                    RowBox[{"x", "[", "\[Sigma]", "]"}], "[", "\[Lambda]", 
                    "]"}]}], 
                    RowBox[{
                    SubscriptBox["\[PartialD]", "\[Lambda]"], 
                    RowBox[{
                    RowBox[{"x", "[", "\[Nu]", "]"}], "[", "\[Lambda]", 
                    "]"}]}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"\[Sigma]", ",", "1", ",", "4"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"\[Nu]", ",", "1", ",", "4"}], "}"}]}], "]"}]}]}],
                     ",", 
                    RowBox[{"{", 
                    RowBox[{"k", ",", "1", ",", "4"}], "}"}]}], "]"}], "/.", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"\[Theta]", "''"}], "[", "\[Lambda]", "]"}], "->", 
                    RowBox[{
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"\[Mu]", "[", "\[Lambda]", "]"}], " ", 
                    SuperscriptBox[
                    RowBox[{
                    SuperscriptBox["\[Mu]", "\[Prime]",
                    MultilineFunction->None], "[", "\[Lambda]", "]"}], "2"]}], 
                    SuperscriptBox["sinmu", "3"]]}], "-", 
                    FractionBox[
                    RowBox[{
                    SuperscriptBox["\[Mu]", "\[Prime]\[Prime]",
                    MultilineFunction->None], "[", "\[Lambda]", "]"}], 
                    "sinmu"]}]}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"\[Theta]", "'"}], "[", "\[Lambda]", "]"}], 
                    "\[Rule]", 
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"\[Mu]", "'"}], "[", "\[Lambda]", "]"}], 
                    "sinmu"]}]}]}], "}"}]}], "/.", "sublg"}], "/.", 
                "zerrul"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  SuperscriptBox["t", "\[Prime]\[Prime]",
                   MultilineFunction->None], "[", "\[Lambda]", "]"}], ",", 
                 RowBox[{
                  RowBox[{"r", "''"}], "[", "\[Lambda]", "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[Mu]", "''"}], "[", "\[Lambda]", "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[Phi]", "''"}], "[", "\[Lambda]", "]"}]}], 
                "}"}]}], "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "/.", 
           RowBox[{"{", 
            RowBox[{
             SuperscriptBox["sinmu", 
              RowBox[{"-", "2"}]], "\[Rule]", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"1", "-", "musq"}], ")"}], 
              RowBox[{"-", "1"}]]}], "}"}]}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"r", "'"}], "[", "\[Lambda]", "]"}], "\[Rule]", 
             RowBox[{"y", "[", "2", "]"}]}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Mu]", "'"}], "[", "\[Lambda]", "]"}], "\[Rule]", 
             RowBox[{"y", "[", "3", "]"}]}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"t", "'"}], "[", "\[Lambda]", "]"}], "\[Rule]", 
             RowBox[{"y", "[", "6", "]"}]}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Phi]", "'"}], "[", "\[Lambda]", "]"}], "\[Rule]", 
             RowBox[{"y", "[", "7", "]"}]}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"t", "''"}], "[", "\[Lambda]", "]"}], "\[Rule]", 
             RowBox[{"f", "[", "6", "]"}]}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Phi]", "''"}], "[", "\[Lambda]", "]"}], "\[Rule]", 
             RowBox[{"f", "[", "7", "]"}]}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"r", "''"}], "[", "\[Lambda]", "]"}], "\[Rule]", 
             RowBox[{"f", "[", "2", "]"}]}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Mu]", "''"}], "[", "\[Lambda]", "]"}], "\[Rule]", 
             RowBox[{"f", "[", "3", "]"}]}], ",", 
            RowBox[{
             RowBox[{"\[Mu]", "[", "\[Lambda]", "]"}], "\[Rule]", 
             RowBox[{"y", "[", "5", "]"}]}]}], "}"}]}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"gg", "[", 
            RowBox[{"o_", ",", "p_", ",", "s_"}], "]"}], "\[Rule]", 
           RowBox[{
            RowBox[{
             RowBox[{"gg", "[", 
              RowBox[{"o", "-", "1"}], "]"}], "[", 
             RowBox[{"p", "-", "1"}], "]"}], "[", 
            RowBox[{"s", "-", "1"}], "]"}]}], "}"}]}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\"\<y[2]^2\>\"", "\[Rule]", "\"\<y[2]*y[2]\>\""}], ",", 
        RowBox[{"\"\<y[6]^2\>\"", "\[Rule]", "\"\<y[6]*y[6]\>\""}], ",", 
        RowBox[{"\"\<y[7]^2\>\"", "\[Rule]", "\"\<y[7]*y[7]\>\""}], ",", 
        RowBox[{"\"\<y[3]^2\>\"", "\[Rule]", "\"\<y[3]*y[3]\>\""}], ",", 
        RowBox[{"\"\< \>\"", "\[Rule]", "\"\<\>\""}], ",", 
        RowBox[{"\"\<->\>\"", "\[Rule]", "\"\<=\>\""}], ",", 
        RowBox[{"\"\<][\>\"", "\[Rule]", "\"\<\>\""}], ",", 
        RowBox[{"\"\<gg[\>\"", "\[Rule]", "\"\<gg\>\""}]}], "}"}]}], "]"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\"\<23]\>\"", "\[Rule]", "\"\<23\>\""}], ",", 
      RowBox[{"\"\<13]\>\"", "\[Rule]", "\"\<13\>\""}], ",", 
      RowBox[{"\"\<02]\>\"", "\[Rule]", "\"\<02\>\""}], ",", 
      RowBox[{"\"\<01]\>\"", "\[Rule]", "\"\<01\>\""}], ",", 
      RowBox[{"\"\<11]\>\"", "\[Rule]", "\"\<11\>\""}], ",", 
      RowBox[{"\"\<03]\>\"", "\[Rule]", "\"\<03\>\""}], ",", 
      RowBox[{"\"\<12]\>\"", "\[Rule]", "\"\<12\>\""}], ",", 
      RowBox[{"\"\<22]\>\"", "\[Rule]", "\"\<22\>\""}], ",", 
      RowBox[{"\"\<33]\>\"", "\[Rule]", "\"\<33\>\""}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"//", 
     RowBox[{"y", ":", "t"}]}], ",", " ", "phi", ",", "  ", "rp", ",", "mup", 
    ",", "  ", "r", ",", "mu", ",", " ", "tpr", ",", 
    RowBox[{"\[Phi]pr", "\n", "  ", "//", 
     RowBox[{"f", ":", 
      RowBox[{"t", "'"}]}]}], ",", 
    RowBox[{"phi", "'"}], ",", 
    RowBox[{"r", "''"}], ",", 
    RowBox[{"mu", "''"}], ",", 
    RowBox[{"r", "'"}], ",", 
    RowBox[{"mu", "'"}], ",", 
    RowBox[{"t", "''"}], ",", 
    RowBox[{"\[Phi]", "''"}]}], "\n", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.4633610142646065`*^9, 3.463361030738207*^9}, {
  3.4633635804490066`*^9, 3.463363649635007*^9}, {3.4633637247802067`*^9, 
  3.463363771065407*^9}, {3.4633638059626064`*^9, 3.4633639868290067`*^9}, {
  3.4633640243158064`*^9, 3.4633642756318064`*^9}, {3.4633643165818067`*^9, 
  3.4633643426182065`*^9}, {3.4633643897302065`*^9, 3.4633643993710065`*^9}, {
  3.4633644355474067`*^9, 3.463364573404607*^9}, {3.4633646084890065`*^9, 
  3.463364655632207*^9}, {3.4633647513538065`*^9, 3.463364753709407*^9}, {
  3.463364792787407*^9, 3.463365133600607*^9}}],

Cell[BoxData["uniq"], "Input",
 CellChangeTimes->{{3.4633636949842067`*^9, 3.463363695327407*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"D", "[", 
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       RowBox[{"\[Mu]", "'"}], "[", "\[Lambda]", "]"}], 
      RowBox[{"Sin", "[", 
       RowBox[{"\[Theta]", "[", "\[Lambda]", "]"}], "]"}]]}], ",", 
    "\[Lambda]"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"Csc", "[", 
      RowBox[{"\[Theta]", "[", "\[Lambda]", "]"}], "]"}], "\[Rule]", 
     FractionBox["1", "sinmu"]}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Theta]", "'"}], "[", "\[Lambda]", "]"}], "\[Rule]", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        RowBox[{"\[Mu]", "'"}], "[", "\[Lambda]", "]"}], "sinmu"]}]}], ",", 
    RowBox[{
     RowBox[{"Cot", "[", 
      RowBox[{"\[Theta]", "[", "\[Lambda]", "]"}], "]"}], "\[Rule]", 
     FractionBox[
      RowBox[{"\[Mu]", "[", "\[Lambda]", "]"}], "sinmu"]}]}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.4839743138126*^9, 3.4839743861498003`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "gg", "]"}], ";", 
  RowBox[{"eq11", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Thread", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"eph11", "[", "i", "]"}], "'"}], "[", "\[Lambda]", "]"}],
            ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "4"}], "}"}]}], "]"}], "\[Rule]", 
         RowBox[{"-", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Sum", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"gg", "[", 
                    RowBox[{"i", ",", "j", ",", "k"}], "]"}], 
                   RowBox[{
                    RowBox[{"eph11", "[", "j", "]"}], "[", "\[Lambda]", 
                    "]"}]}], "/.", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"\[Theta]", "\[Rule]", 
                    RowBox[{"\[Theta]", "[", "\[Lambda]", "]"}]}], ",", 
                    RowBox[{"r", "\[Rule]", 
                    RowBox[{"r", "[", "\[Lambda]", "]"}]}]}], "}"}]}], ")"}], 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", "k", "]"}], "'"}], "[", "\[Lambda]", 
                 "]"}]}], "/.", 
               RowBox[{
                RowBox[{
                 SuperscriptBox["\[Theta]", "\[Prime]",
                  MultilineFunction->None], "[", "\[Lambda]", "]"}], 
                "\[Rule]", 
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{
                   RowBox[{"\[Mu]", "'"}], "[", "\[Lambda]", "]"}], 
                  SqrtBox[
                   RowBox[{"1", "-", 
                    SuperscriptBox["\[Mu]", "2"]}]]]}]}]}], ",", 
              RowBox[{"{", 
               RowBox[{"j", ",", "1", ",", "4"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"k", ",", "1", ",", "4"}], "}"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", "4"}], "}"}]}], "]"}]}]}], "]"}], "/.",
        "sublg"}], "/.", "zerrul"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"eph11", "[", "i_", "]"}], "\[Prime]",
          MultilineFunction->None], "[", "\[Lambda]", "]"}], "\[Rule]", 
        RowBox[{"f", "[", 
         RowBox[{"i", "+", "7"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"eph11", "[", "i_", "]"}], "[", "\[Lambda]", "]"}], 
        "\[Rule]", 
        RowBox[{"y", "[", 
         RowBox[{"i", "+", "7"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"t", "'"}], "[", "\[Lambda]", "]"}], "\[Rule]", 
        RowBox[{"y", "[", "6", "]"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"\[Phi]", "'"}], "[", "\[Lambda]", "]"}], "\[Rule]", 
        RowBox[{"y", "[", "7", "]"}]}], ",", " ", 
       RowBox[{
        RowBox[{
         SuperscriptBox["\[Mu]", "\[Prime]",
          MultilineFunction->None], "[", "\[Lambda]", "]"}], "\[Rule]", 
        RowBox[{"y", "[", "3", "]"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"r", "'"}], "[", "\[Lambda]", "]"}], "\[Rule]", 
        RowBox[{"y", "[", "2", "]"}]}], ",", 
       RowBox[{
        RowBox[{"1", "/", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["\[Mu]", "2"]}]]}], "\[Rule]", 
        SuperscriptBox["sinmu", 
         RowBox[{"-", "1"}]]}]}], "}"}]}], "/.", 
    RowBox[{
     RowBox[{"gg", "[", 
      RowBox[{"i_", ",", "j_", ",", "k_"}], "]"}], "\[Rule]", 
     RowBox[{
      RowBox[{
       RowBox[{"gg", "[", 
        RowBox[{"i", "-", "1"}], "]"}], "[", 
       RowBox[{"j", "-", "1"}], "]"}], "[", 
      RowBox[{"k", "-", "1"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"StringReplace", "[", 
   RowBox[{
    RowBox[{"StringReplace", "[", 
     RowBox[{
      RowBox[{"ToString", "[", 
       RowBox[{"InputForm", "[", "eq11", "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\"\< \>\"", "\[Rule]", "\"\<\>\""}], ",", 
        RowBox[{"\"\<->\>\"", "\[Rule]", "\"\<=\>\""}], ",", 
        RowBox[{"\"\<][\>\"", "\[Rule]", "\"\<\>\""}], ",", 
        RowBox[{"\"\<gg[\>\"", "\[Rule]", "\"\<gg\>\""}]}], "}"}]}], "]"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\"\<]+\>\"", "\[Rule]", "\"\<+\>\""}], ",", 
      RowBox[{"\"\<])\>\"", "\[Rule]", "\"\<)\>\""}], ",", 
      RowBox[{"\"\<]-\>\"", "\[Rule]", "\"\<-\>\""}], ",", 
      RowBox[{"\"\<,\>\"", "\[Rule]", "\"\<;\>\""}]}], "}"}]}], "]"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"eph11", "[", "i_", "]"}], "[", "\[Lambda]", "]"}], "\[Rule]", 
     RowBox[{"y", "[", 
      RowBox[{"i", "+", "7"}], "]"}]}], ",", "...", ",", 
    RowBox[{
     RowBox[{
      RowBox[{"eph11", "[", "4", "]"}], "[", "\[Lambda]", "]"}], "\[Rule]", 
     RowBox[{"y", "[", "7", "]"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"//", 
     RowBox[{"y", ":", "t"}]}], ",", " ", "phi", ",", "  ", "rp", ",", "mup", 
    ",", "  ", "r", ",", "mu", ",", " ", "tpr", ",", 
    RowBox[{"\[Phi]pr", "\n", "  ", "//", 
     RowBox[{"f", ":", 
      RowBox[{"t", "'"}]}]}], ",", 
    RowBox[{"phi", "'"}], ",", 
    RowBox[{"r", "''"}], ",", 
    RowBox[{"mu", "''"}], ",", 
    RowBox[{"r", "'"}], ",", 
    RowBox[{"mu", "'"}], ",", 
    RowBox[{"t", "''"}], ",", 
    RowBox[{"\[Phi]", "''"}]}], "\n", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.463223063045*^9, 3.463223177215*^9}, {3.463223859926*^9,
    3.463223861014*^9}, 3.463224146551*^9, {3.4632291770266066`*^9, 
   3.4632291784150066`*^9}, {3.4632333082498064`*^9, 
   3.4632333087646065`*^9}, {3.4632333514618063`*^9, 
   3.4632334162018065`*^9}, {3.463233532967807*^9, 3.463233566289407*^9}, {
   3.4632336251014066`*^9, 3.4632336368638067`*^9}, {3.463233702571007*^9, 
   3.463233747764207*^9}, {3.4632337934410067`*^9, 3.4632339029374065`*^9}, {
   3.4632340172074065`*^9, 3.4632340615582066`*^9}, {3.463234095847007*^9, 
   3.4632340963774066`*^9}, {3.4632341432086067`*^9, 
   3.4632342693502064`*^9}, {3.4632345158614063`*^9, 
   3.4632345943606067`*^9}, {3.4632401376334066`*^9, 
   3.4632401401138067`*^9}, {3.4633653633886065`*^9, 
   3.4633653652294064`*^9}, {3.4633678217302065`*^9, 
   3.4633678282978067`*^9}, {3.4633678775782065`*^9, 
   3.4633679651566067`*^9}, {3.463369015255007*^9, 3.4633690196074066`*^9}, {
   3.4845676105954*^9, 3.4845676192534*^9}}],

Cell[BoxData[{
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnQWUVWXXxylFaRGEF0GkESlpCSlppEtiBBGku7uGIaSGThm6u7u7c+iS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    "], {{0, 135}, {727, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->{526.9999999999994, Automatic},
  ImageSizeRaw->{727, 135},
  PlotRange->{{0, 727}, {0, 135}}], "\[IndentingNewLine]", 
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnQl4TVfb/qmpqKmKpGhRiiY11lwzITGLt1LzLIYmiCE1xlBESlTMRCSp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    "], {{0, 72}, {633, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->{501.99999999999994`, Automatic},
  ImageSizeRaw->{633, 72},
  PlotRange->{{0, 633}, {0, 72}}], "\[IndentingNewLine]", 
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnQd0FVXX/lFUQEUEUap0qSKRLk0QQgdpQVBKqKJ06VWQEnpJKCGUSIdA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    "], {{0, 73}, {628, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->{502., Automatic},
  ImageSizeRaw->{628, 73},
  PlotRange->{{0, 628}, {0, 73}}]}], "Input",
 CellChangeTimes->{{3.4845757887862*^9, 3.4845758036998*^9}}],

Cell[BoxData[{
 RowBox[{"ComplexExpand", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"A", "-", 
     RowBox[{"\[ImaginaryI]", " ", "B"}]}], ")"}], 
   RowBox[{"(", 
    RowBox[{"r", "-", 
     RowBox[{"\[ImaginaryI]", " ", "a", " ", 
      RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ")"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"K2", "\[Rule]", 
  RowBox[{
   RowBox[{"A", " ", "r"}], "-", 
   RowBox[{"a", " ", "B", " ", 
    RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"K1", "\[Rule]", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"B", " ", "r"}], "+", 
    RowBox[{"a", " ", "A", " ", 
     RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], 
   ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A", "\[Rule]", 
   RowBox[{
    RowBox[{
     RowBox[{"kBL", "[", "0", "]"}], "*", 
     RowBox[{"e1BL", "[", "1", "]"}]}], "-", 
    RowBox[{
     RowBox[{"kBL", "[", "1", "]"}], "*", 
     RowBox[{"e1BL", "[", "0", "]"}]}], "+", 
    RowBox[{"a", "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"kBL", "[", "1", "]"}], "*", 
        RowBox[{"e1BL", "[", "3", "]"}]}], "-", 
       RowBox[{
        RowBox[{"kBL", "[", "3", "]"}], "*", 
        RowBox[{"e1BL", "[", "1", "]"}]}]}], ")"}], "*", "sinsq"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"B", "\[Rule]", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"rr", "*", "rr"}], "+", "asq"}], ")"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"kBL", "[", "3", "]"}], 
         RowBox[{"e1BL", "[", "2", "]"}]}], "-", 
        RowBox[{
         RowBox[{"kBL", "[", "2", "]"}], 
         RowBox[{"e1BL", "[", "3", "]"}]}]}], ")"}]}], "-", 
     RowBox[{"a", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"kBL", "[", "0", "]"}], 
         RowBox[{"e1BL", "[", "2", "]"}]}], "-", 
        RowBox[{
         RowBox[{"kBL", "[", "2", "]"}], 
         RowBox[{"e1BL", "[", "0", "]"}]}]}], ")"}]}]}], ")"}], "*", "sqrt", 
   RowBox[{"(", "sinsq", ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.4845758401258*^9, 3.484575878767*^9}, {
  3.484575909967*^9, 3.4845759605266*^9}, {3.4845759918046*^9, 
  3.4845760634398003`*^9}, {3.4845864576306*^9, 3.484586534523*^9}, {
  3.4845865721345997`*^9, 3.4845865965797997`*^9}, {3.4845868041222*^9, 
  3.4845869067078*^9}, {3.485267302753437*^9, 3.485267302956237*^9}, {
  3.485267700522237*^9, 3.485267708025837*^9}}],

Cell[BoxData[{
 RowBox[{"t", "\[Rule]", "0.9999"}], "\[IndentingNewLine]", 
 RowBox[{"r", "\[Rule]", "9."}], "\[IndentingNewLine]", 
 RowBox[{"K2", "\[Rule]", 
  RowBox[{"-", "704470.42291774042"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"K1", "\[Rule]", "636218.82084316690"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"r", "\[Rule]", "19"}], "\[IndentingNewLine]", 
 RowBox[{"K2", "\[Rule]", 
  RowBox[{"-", "705233.30073512404"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"K1", "\[Rule]", "636206.49786268233"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"r", "\[Rule]", "9."}], "\[IndentingNewLine]", 
 RowBox[{"K2", "\[Rule]", 
  RowBox[{"-", "704470.42291774042"}]}], "\[IndentingNewLine]", 
 RowBox[{"K1", "\[Rule]", "636218.82084316690"}]}], "Input",
 CellChangeTimes->{{3.485269054111037*^9, 3.485269099351037*^9}, {
  3.485269144535637*^9, 3.485269172288037*^9}}],

Cell[BoxData[{
 RowBox[{"r", "\[Rule]", "62"}], "\[IndentingNewLine]", 
 RowBox[{"K1", "\[Rule]", "26187649.977335777"}], "\[IndentingNewLine]", 
 RowBox[{"K2", "\[Rule]", 
  RowBox[{"-", "27847388.231093597"}]}], "\[IndentingNewLine]", 
 RowBox[{"r", "\[Rule]", "207."}], "\[IndentingNewLine]", 
 RowBox[{"K1", "\[Rule]", "26187863.498674039"}], "\[IndentingNewLine]", 
 RowBox[{"K2", "\[Rule]", 
  RowBox[{"-", "28122333.039226286"}]}]}], "Input",
 CellChangeTimes->{{3.4845870559638*^9, 3.4845870646686*^9}, {
  3.4845872007952003`*^9, 3.484587289804*^9}, {3.4845873962644*^9, 
  3.4845874206628*^9}, {3.485267935505037*^9, 3.4852679815094366`*^9}, {
  3.4852680753576365`*^9, 3.485268100504837*^9}, {3.485269049446637*^9, 
  3.485269051037837*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Solvetrans functions", "Section",
 CellChangeTimes->{{3.4839765742058*^9, 3.4839765763118*^9}, {
  3.4839792450818*^9, 3.4839792467042*^9}}],

Cell["Correct initialization ", "Subsection",
 CellChangeTimes->{{3.4839765788702*^9, 3.4839765795566*^9}}],

Cell["Correct initial II and convergent solutions", "Subsection",
 CellChangeTimes->{{3.4839792373754*^9, 3.4839792380618*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Transnew functions", "Section",
 CellChangeTimes->{{3.4839792482953997`*^9, 3.483979252913*^9}}],

Cell[CellGroupData[{

Cell["Correct auxilliary definitions and equation", "Subsection",
 CellChangeTimes->{{3.4839792197785997`*^9, 3.4839792228674*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"(", 
   RowBox[{"R", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"Cos", "[", 
         RowBox[{"2", 
          RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}], ",", 
        RowBox[{"-", 
         RowBox[{"Sin", "[", 
          RowBox[{"2", 
           RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}]}], ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"Sin", "[", 
         RowBox[{"2", 
          RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}], ",", 
        RowBox[{"Cos", "[", 
         RowBox[{"2", 
          RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ")"}], "//",
   "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"mat", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"aIc", ",", "aQc", ",", "0", ",", "aVc"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"aQc", ",", "aIc", ",", "rVc", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", "rVc"}], ",", "aIc", ",", "rQc"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"aVc", ",", "0", ",", 
        RowBox[{"-", "rQc"}], ",", "aIc"}], "}"}]}], "}"}]}], ")"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"fs", "=", 
    RowBox[{"FullSimplify", "[", 
     RowBox[{"R", ".", "mat", ".", 
      RowBox[{"Transpose", "[", "R", "]"}]}], "]"}]}], ")"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"eqq", "=", 
  RowBox[{
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"f", "[", "0", "]"}], ",", 
       RowBox[{"f", "[", "1", "]"}], ",", 
       RowBox[{"f", "[", "2", "]"}], ",", 
       RowBox[{"f", "[", "3", "]"}]}], "}"}], "\[Equal]", 
     RowBox[{"det", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"R", ".", 
          RowBox[{"{", 
           RowBox[{"jIc", ",", "jQc", ",", "0", ",", "jVc"}], "}"}]}], "/", 
         "frsq"}], "-", 
        RowBox[{
         RowBox[{"frcu", "/", "frsq"}], " ", 
         RowBox[{"fs", ".", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"y", "[", "0", "]"}], ",", 
            RowBox[{"y", "[", "1", "]"}], ",", 
            RowBox[{"y", "[", "2", "]"}], ",", 
            RowBox[{"y", "[", "3", "]"}]}], "}"}]}]}]}], ")"}]}]}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Sin", "[", 
       RowBox[{"2", " ", 
        RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}], "\[Rule]", "sin2k"}], ",", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"2", 
        RowBox[{"\[Chi]", "[", "s", "]"}]}], "]"}], "\[Rule]", "cos2k"}]}], 
    "}"}]}]}]}], "Input",
 CellChangeTimes->{{3.4804209238673987`*^9, 3.4804209643961987`*^9}, {
  3.4819603122981997`*^9, 3.4819603299574003`*^9}, {3.4819612380178003`*^9, 
  3.4819613436610003`*^9}, {3.4819613782306004`*^9, 3.481961384299*^9}, {
  3.4819614353422003`*^9, 3.4819615463050003`*^9}, {3.481961580157*^9, 
  3.481961580703*^9}, {3.481961964229*^9, 3.4819619683318*^9}, {
  3.481962007675*^9, 3.4819620099214*^9}, {3.4819620427438*^9, 
  3.4819620461758003`*^9}, {3.481963014343*^9, 3.4819630171666*^9}, {
  3.483979782689*^9, 3.4839798000518*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"doub", " ", "cosqs"}], "=", 
   RowBox[{"cos", 
    RowBox[{"(", 
     RowBox[{"yyy", "[", "2", "]"}], ")"}]}]}], ",", 
  RowBox[{"sinqs", "=", 
   RowBox[{"sin", 
    RowBox[{"(", 
     RowBox[{"yyy", "[", "2", "]"}], ")"}]}]}], ",", 
  RowBox[{"frsq", "=", 
   RowBox[{"fr", "*", "fr"}]}], ",", 
  RowBox[{"sinths", "=", 
   RowBox[{"sin", 
    RowBox[{"(", 
     RowBox[{"yyy", "[", "3", "]"}], ")"}]}]}], ",", 
  RowBox[{
   RowBox[{"cosths", "=", 
    RowBox[{"cos", 
     RowBox[{"(", 
      RowBox[{"yyy", "[", "3", "]"}], ")"}]}]}], ";"}]}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"rull", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"y", "[", "0", "]"}], "\[Rule]", 
      RowBox[{"yyy", "[", "0", "]"}]}], ",", 
     RowBox[{
      RowBox[{"y", "[", "1", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"yyy", "[", "1", "]"}], 
       RowBox[{"Sin", "[", 
        RowBox[{"yyy", "[", "3", "]"}], "]"}], 
       RowBox[{"Cos", "[", 
        RowBox[{"yyy", "[", "2", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"y", "[", "2", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"yyy", "[", "1", "]"}], 
       RowBox[{"Sin", "[", 
        RowBox[{"yyy", "[", "3", "]"}], "]"}], 
       RowBox[{"Sin", "[", 
        RowBox[{"yyy", "[", "2", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"y", "[", "3", "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"yyy", "[", "1", "]"}], 
       RowBox[{"Cos", "[", 
        RowBox[{"yyy", "[", "3", "]"}], "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"f", "[", "1", "]"}], "\[Rule]", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"yyy", "[", "1", "]"}], "[", "s", "]"}], 
         RowBox[{"Sin", "[", 
          RowBox[{
           RowBox[{"yyy", "[", "3", "]"}], "[", "s", "]"}], "]"}], 
         RowBox[{"Cos", "[", 
          RowBox[{
           RowBox[{"yyy", "[", "2", "]"}], "[", "s", "]"}], "]"}]}], ",", 
        "s"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"f", "[", "2", "]"}], "\[Rule]", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"yyy", "[", "1", "]"}], "[", "s", "]"}], 
         RowBox[{"Sin", "[", 
          RowBox[{
           RowBox[{"yyy", "[", "3", "]"}], "[", "s", "]"}], "]"}], 
         RowBox[{"Sin", "[", 
          RowBox[{
           RowBox[{"yyy", "[", "2", "]"}], "[", "s", "]"}], "]"}]}], ",", 
        "s"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"f", "[", "3", "]"}], "\[Rule]", 
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"yyy", "[", "1", "]"}], "[", "s", "]"}], 
         RowBox[{"Cos", "[", 
          RowBox[{
           RowBox[{"yyy", "[", "3", "]"}], "[", "s", "]"}], "]"}]}], ",", 
        "s"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"f", "[", "0", "]"}], "\[Rule]", 
      RowBox[{"ff", "[", "0", "]"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"finex", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{"Simplify", "[", 
     RowBox[{
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"eqq", "/.", "rull"}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"yyy", "[", "1", "]"}], "\[Prime]",
              MultilineFunction->None], "[", "s", "]"}], "\[Rule]", 
            RowBox[{"ff", "[", "1", "]"}]}], ",", 
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"yyy", "[", "2", "]"}], "\[Prime]",
              MultilineFunction->None], "[", "s", "]"}], "\[Rule]", 
            RowBox[{"ff", "[", "2", "]"}]}], ",", 
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"yyy", "[", "3", "]"}], "\[Prime]",
              MultilineFunction->None], "[", "s", "]"}], "\[Rule]", 
            RowBox[{"ff", "[", "3", "]"}]}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"yyy", "[", "1", "]"}], "[", "s", "]"}], "\[Rule]", 
            RowBox[{"yyy", "[", "1", "]"}]}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"yyy", "[", "2", "]"}], "[", "s", "]"}], "\[Rule]", 
            RowBox[{"yyy", "[", "2", "]"}]}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"yyy", "[", "3", "]"}], "[", "s", "]"}], "\[Rule]", 
            RowBox[{"yyy", "[", "3", "]"}]}]}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ff", "[", "0", "]"}], ",", 
          RowBox[{"ff", "[", "1", "]"}], ",", 
          RowBox[{"ff", "[", "2", "]"}], ",", 
          RowBox[{"ff", "[", "3", "]"}]}], "}"}]}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Cos", "[", 
        RowBox[{"yyy", "[", "2", "]"}], "]"}], "\[Rule]", "cosqs"}], ",", 
      RowBox[{
       RowBox[{"Sin", "[", 
        RowBox[{"yyy", "[", "2", "]"}], "]"}], "\[Rule]", "sinqs"}], ",", 
      RowBox[{
       RowBox[{"Cos", "[", 
        RowBox[{"yyy", "[", "3", "]"}], "]"}], "\[Rule]", "cosths"}], ",", 
      RowBox[{
       RowBox[{"Sin", "[", 
        RowBox[{"yyy", "[", "3", "]"}], "]"}], "\[Rule]", "sinths"}], ",", 
      RowBox[{
       RowBox[{"Csc", "[", 
        RowBox[{"yyy", "[", "3", "]"}], "]"}], "\[Rule]", 
       FractionBox["1", "sinths"]}], ",", 
      RowBox[{
       RowBox[{"Cot", "[", 
        RowBox[{"yyy", "[", "3", "]"}], "]"}], "\[Rule]", 
       FractionBox["cosths", "sinths"]}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.4819620126202*^9, 3.4819620263482*^9}, {
   3.4819620659566*^9, 3.4819620775474*^9}, 3.4819621284502*^9, {
   3.4819621742362003`*^9, 3.4819625064849997`*^9}, {3.4819625839702*^9, 
   3.4819627261486*^9}, {3.4819628088129997`*^9, 3.481962855067*^9}, {
   3.4819629406174*^9, 3.4819629419122*^9}, {3.4819631825422*^9, 
   3.4819631843674*^9}, {3.4819633376062*^9, 3.481963366591*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"D", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"ff", "[", "2", "]"}], "/.", "finex"}], ",", "rVc"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"frcu", "\[Rule]", 
     SuperscriptBox["fr", "3"]}], ",", 
    RowBox[{"frsq", "\[Rule]", 
     SuperscriptBox["fr", "2"]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.526053009866521*^9, 3.526053040729286*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3.200", ",", "0.1665", ",", "0.060722", ",", "0.53051"}], "}"}],
     " ", "at", " ", "coeff"}], "=", "20"}], ";", 
  RowBox[{"EVPA", "=", 
   RowBox[{"24.0", "deg"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2.6999", ",", 
      RowBox[{"-", "0.29622"}], ",", 
      RowBox[{"-", "0.127"}], ",", "0.3655"}], "}"}], "at", " ", "coeff"}], 
   "=", "10"}], " ", ";", 
  RowBox[{"EVPA", "=", 
   RowBox[{"19.7", "deg"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"magnetic", " ", "field", " ", "is", " ", "in", " ", "the", " ", 
  "opposite", " ", "direction", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"kbpar", "<", "0"}], ",", " ", 
    RowBox[{"rVc", "<", "0"}], ","}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "3.58"}], ",", 
   RowBox[{"1.3375", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "5"}]]}], ",", "0.23816"}], "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "3.67"}], ",", 
   RowBox[{"1.3684", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "5"}]]}], ",", "0.22091"}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", "3.76"}], ",", 
    RowBox[{"1.3920", " ", 
     SuperscriptBox["10", 
      RowBox[{"-", "5"}]]}], ",", "0.210575"}], "}"}], " ", "=", 
  RowBox[{">", 
   RowBox[{
    RowBox[{"II", "[", "2", "]"}], " ", "decrease", " ", "along", " ", "the", 
    " ", "ray"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1.433665", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "5"}]]}], ",", "0.166509"}], "}"}], " ", "at", " ", 
    "coeff"}], "=", "20"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1.3937", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "5"}]]}], ",", " ", "0.20823"}], "}"}], " ", "at", " ", 
    "coeff"}], "=", "21"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1.34405", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "5"}]]}], ",", "0.26189"}], "}"}], " ", "at", " ", 
    "coeff"}], "=", "22"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stronger", " ", "B", " ", "field", " ", 
   RowBox[{"extension", ":", " ", "Bpo"}]}], "=", 
  RowBox[{"2", " ", "\[Implies]", " ", 
   RowBox[{"24", "deg"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stronger", " ", "B", " ", "field", " ", 
   RowBox[{"extension", ":", " ", "Bpo"}]}], "=", 
  RowBox[{"1.9", " ", "\[Implies]", " ", 
   RowBox[{"26.2", "deg"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stronger", " ", "B", " ", "field", " ", 
   RowBox[{"extension", ":", " ", "Bpo"}]}], "=", 
  RowBox[{"1.8", " ", "\[Implies]", " ", 
   RowBox[{"20.9", "deg"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stronger", " ", "B", " ", "field", " ", 
   RowBox[{"extension", ":", " ", "Bpo"}]}], "=", 
  RowBox[{"1.7", " ", "\[Implies]", " ", 
   RowBox[{"19.9", "deg"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stronger", " ", "B", " ", "field", " ", 
   RowBox[{"extension", ":", " ", "Bpo"}]}], "=", 
  RowBox[{"1.6", " ", "\[Implies]", " ", 
   RowBox[{"17.0", "deg"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stronger", " ", "B", " ", "field", " ", 
   RowBox[{"extension", ":", " ", "Bpo"}]}], "=", 
  RowBox[{
   RowBox[{"1.5", " ", "\[Implies]", " ", 
    RowBox[{
     RowBox[{"10.5", "deg"}], " ", "-", " ", 
     RowBox[{"correct", " ", 
      RowBox[{"behavior", "!"}]}]}]}], " ", "=", 
   RowBox[{">", " ", 
    RowBox[{
    "magnetic", " ", "field", " ", "reversal", " ", "is", " ", 
     "present"}]}]}]}], "\[IndentingNewLine]"}], "Text",
 CellChangeTimes->{{3.5260568569385605`*^9, 3.5260569663688197`*^9}, {
  3.526056996985571*^9, 3.5260570100253167`*^9}, {3.5260570741289835`*^9, 
  3.5260571467451367`*^9}, {3.5260572235255284`*^9, 3.5260572792327147`*^9}, {
  3.5260573408572397`*^9, 3.5260573823696136`*^9}, {3.526057498233241*^9, 
  3.5260575155702324`*^9}, {3.526057938553426*^9, 3.526058017712953*^9}, {
  3.5260580944013395`*^9, 3.526058179609213*^9}, {3.526058217161361*^9, 
  3.526058249298199*^9}, {3.5260582852662563`*^9, 3.52605830053813*^9}, {
  3.5260583584464417`*^9, 3.5260584079812756`*^9}, {3.5260584502736945`*^9, 
  3.526058513158291*^9}, {3.5260585490093417`*^9, 3.5260585707295837`*^9}, {
  3.526058639665527*^9, 3.5260586594336576`*^9}}],

Cell["\<\
Larger ff[2] from larger kbpar, larger coeff at rVc
coeff=1:   {{4.73058, 1.0154}, {4.260062, 0.89517}, {1.801617, 1.11190}, \
{5.46000, 1.59975}} \[Implies] 
coeff=1.1:{{4.3664,   1.0138}, {5.090768, 1.01840}, {1.905887, 1.10751}, \
{5.506377, 1.5992}}
ausin[1]\[Equal]Cos[ff[2]]
ausin[2]\[Equal] Sin[ff[2]]
ang\[Equal]atan2[in[2],in[1]]/2\[Equal]atan[Sin[ff[2]]/Cos[ff[2]]]/2=ff[2]/2.

coef=1.05: {{4.91083,1.01699},{4.3144,0.960277},   {1.85309,1.10971},    \
{5.49337, 1.600488}}\
\>", "Text",
 CellChangeTimes->{{3.526053210375989*^9, 3.5260532259198785`*^9}, {
  3.5260532705354304`*^9, 3.526053276767787*^9}, {3.5260533370492344`*^9, 
  3.526053425192276*^9}, {3.5260534633844604`*^9, 3.5260536085917664`*^9}, {
  3.526053727386561*^9, 3.526053816399652*^9}, {3.526053884060522*^9, 
  3.526053891591953*^9}, {3.526053923343769*^9, 3.5260539483441987`*^9}, {
  3.5260540036903644`*^9, 3.526054022703452*^9}, {3.5260541576081676`*^9, 
  3.526054227856186*^9}}],

Cell[BoxData[
 RowBox[{"ToString", "[", 
  RowBox[{"InputForm", "[", "finex", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.4819631908726*^9, 3.4819632141478*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Symmetries", "Subsection",
 CellChangeTimes->{{3.5208467615304384`*^9, 3.52084676714876*^9}}],

Cell[BoxData[{
 RowBox[{
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJztnb2uHcdyhQX7MY4D+wUYMHFIEHwAEgZzEhfMCQLMCQJ8AAbKKUDKbBCG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     "], {{0, 220}, {567, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{274.1999999999989, Automatic},
   ImageSizeRaw->{567, 220},
   PlotRange->{{0, 567}, {0, 220}}], 
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzt3d2LXdeZ53EP82dULOul/Nq2SJuEGEej8czY2B5ZtCbdjUOUIWmbQSPk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     "], {{0, 508}, {505, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{236.40000000000057`, Automatic},
   ImageSizeRaw->{505, 508},
   PlotRange->{{0, 505}, {0, 508}}], 
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJztnb+uHTUQxi/iMS4FvMAt8gIo4gFAiIomUZQGIRFFSh9FygOkSJ+CPgU1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     "], {{0, 90}, {321, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{253.84999999999934`, Automatic},
   ImageSizeRaw->{321, 90},
   PlotRange->{{0, 321}, {0, 90}}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"For", "  ", "B"}], "\[Rule]", 
   RowBox[{"-", 
    RowBox[{"B", ":"}]}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Theta]", "\[Rule]", 
   RowBox[{"\[Pi]", "-", "\[Theta]"}]}], " ", ";", " ", 
  RowBox[{
   SubscriptBox["\[Epsilon]", "I"], "\[Rule]", 
   SubscriptBox["\[Epsilon]", "I"]}], ";", " ", 
  RowBox[{
   SubscriptBox["\[Epsilon]", "Q"], "\[Rule]", 
   SubscriptBox["\[Epsilon]", "Q"]}], ";", " ", 
  RowBox[{
   SubscriptBox["\[Epsilon]", "V"], "\[Rule]", 
   RowBox[{"-", 
    SubscriptBox["\[Epsilon]", "V"]}]}], ";", " ", 
  RowBox[{
   SubscriptBox["\[Alpha]", "V"], "\[Rule]", 
   RowBox[{"-", 
    SubscriptBox["\[Alpha]", "V"]}]}], ";", " ", 
  RowBox[{
   SubscriptBox["\[Rho]", "V"], "\[Rule]", 
   RowBox[{"-", 
    SubscriptBox["\[Rho]", "V"]}]}], ";", 
  StyleBox[
   RowBox[{
    SubscriptBox["\[Rho]", "Q"], "\[Rule]", 
    SubscriptBox["\[Rho]", "Q"]}],
   FontWeight->"Bold"]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SuperscriptBox[
    StyleBox["e",
     FontWeight->"Bold"], "2"], "\[Rule]", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["e", "2"]}], " ", "\[Implies]", "\[Chi]"}], "\[Rule]", 
    "\[Chi]"}]}], ",", " ", 
  RowBox[{
  "but", " ", "transformation", "  ", "is", "  ", "different"}]}]}], "Text",
 CellChangeTimes->{
  3.5208468047529106`*^9, {3.5208469054246683`*^9, 3.520847073570286*^9}, {
   3.520847218151555*^9, 3.5208472301132393`*^9}, {3.520847293725878*^9, 
   3.5208473237185936`*^9}, {3.5208473680271277`*^9, 3.52084738938935*^9}, {
   3.5208491507464733`*^9, 3.520849161323292*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"matrot", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cos", "[", "\[Chi]", "]"}], ",", 
       RowBox[{"Sin", "[", "\[Chi]", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Sin", "[", "\[Chi]", "]"}]}], ",", 
       RowBox[{"Cos", "[", "\[Chi]", "]"}]}], "}"}]}], "}"}]}], ";", 
  RowBox[{"inv", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Thread", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b"}], "}"}], "\[Equal]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"e1", ",", "e2"}], "}"}], ".", "matrot"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Thread", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "b"}], "}"}], "\[Equal]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"e1", ",", 
      RowBox[{"-", "e2"}]}], "}"}], ".", "inv", ".", "matrot"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{"Inverse", "[", 
    RowBox[{"matrot", ".", "matrot"}], "]"}], "]"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Inverse", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"inv", ".", "matrot"}], ")"}], ".", 
    RowBox[{"(", 
     RowBox[{"inv", ".", "matrot"}], ")"}]}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.520847395649708*^9, 3.5208475254081297`*^9}, {
  3.520847557706977*^9, 3.520847678803903*^9}, {3.5208477207393017`*^9, 
  3.5208478014629188`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RRx", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"Cos", "[", 
        RowBox[{"2", "\[Chi]"}], "]"}], ",", 
       RowBox[{"Sin", "[", 
        RowBox[{"2", "\[Chi]"}], "]"}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"Sin", "[", 
        RowBox[{"2", "\[Chi]"}], "]"}], ",", 
       RowBox[{"-", 
        RowBox[{"Cos", "[", 
         RowBox[{"2", "\[Chi]"}], "]"}]}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"RRx", "\[Equal]", 
   RowBox[{"Inverse", "[", "RRx", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RR", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"Cos", "[", 
        RowBox[{"2", "\[Chi]"}], "]"}], ",", 
       RowBox[{"-", 
        RowBox[{"Sin", "[", 
         RowBox[{"2", "\[Chi]"}], "]"}]}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"Sin", "[", 
        RowBox[{"2", "\[Chi]"}], "]"}], ",", 
       RowBox[{"Cos", "[", 
        RowBox[{"2", "\[Chi]"}], "]"}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"InvRR", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"Inverse", "[", "RR", "]"}], "]"}]}], ";", 
  RowBox[{"Simplify", "[", 
   RowBox[{"InvRR", "\[Equal]", 
    RowBox[{"(", 
     RowBox[{"RR", "/.", 
      RowBox[{"\[Chi]", "\[Rule]", 
       RowBox[{"-", "\[Chi]"}]}]}], ")"}]}], 
   "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5208485317831864`*^9, 3.5208485336395893`*^9}, {
  3.520848770230605*^9, 3.520848781025824*^9}, {3.5208490252910533`*^9, 
  3.5208490341830688`*^9}, {3.520849261038667*^9, 3.5208493434536123`*^9}}],

Cell[BoxData[{
 RowBox[{"Print", "[", 
  "\"\<regular 0<\[Theta]<\!\(\*FractionBox[\(\[Pi]\), \(2\)]\)\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RR", ".", 
   RowBox[{"{", 
    RowBox[{"\[Epsilon]I", ",", "\[Epsilon]Q", ",", "0", ",", "\[Epsilon]V"}],
     "}"}]}], "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Simplify", "[", 
    RowBox[{"RR", ".", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Alpha]I", ",", "\[Alpha]Q", ",", "0", ",", "\[Alpha]V"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Alpha]Q", ",", "\[Alpha]I", ",", "\[Rho]V", ",", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", "\[Rho]V"}], ",", "\[Alpha]I", ",", "\[Rho]Q"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"\[Alpha]V", ",", "0", ",", 
         RowBox[{"-", "\[Rho]Q"}], ",", "\[Alpha]I"}], "}"}]}], "}"}], ".", 
     "InvRR"}], "]"}], "//", "MatrixForm"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", "\"\<Inverted magnetic field \!\(\*
StyleBox[\"B\",
FontWeight->\"Plain\"]\)\[Rule] -B\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RRx", ".", 
   RowBox[{"{", 
    RowBox[{"\[Epsilon]I", ",", "\[Epsilon]Q", ",", "0", ",", "\[Epsilon]V"}],
     "}"}]}], "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{"RRx", ".", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Alpha]I", ",", "\[Alpha]Q", ",", "0", ",", "\[Alpha]V"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Alpha]Q", ",", "\[Alpha]I", ",", "\[Rho]V", ",", "0"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", "\[Rho]V"}], ",", "\[Alpha]I", ",", "\[Rho]Q"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"\[Alpha]V", ",", "0", ",", 
        RowBox[{"-", "\[Rho]Q"}], ",", "\[Alpha]I"}], "}"}]}], "}"}], ".", 
    "RRx"}], "]"}], "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.52084911455441*^9, 3.520849128844035*^9}, {
  3.520849166674102*^9, 3.520849183678131*^9}, {3.520849263066671*^9, 
  3.5208492638622723`*^9}, {3.5208493552628326`*^9, 3.520849398116108*^9}, {
  3.5208494414841843`*^9, 3.5208495590303907`*^9}}],

Cell["\<\
Thus, \[Epsilon]V \[Rule] -\[Epsilon]V; \[Alpha]V\[Rule] -\[Alpha]V; \[Rho]V \
\[Rule] -\[Rho]V - everything else is identical!!! \[Implies] eqs. of \
radiative transfer are not symmetric w/ respect to change of B direction
(\[Chi] - same angle)\
\>", "Text",
 CellChangeTimes->{{3.5208497827347836`*^9, 3.5208499160058174`*^9}, {
  3.52085005963527*^9, 3.5208501056553507`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Emis functions", "Section",
 CellChangeTimes->{{3.483980940833*^9, 3.4839809426426*^9}}],

Cell[CellGroupData[{

Cell["Computing emissivities/rotativities", "Subsection",
 CellChangeTimes->{{3.56241448462243*^9, 3.5624144964451113`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ttx", "=", 
   RowBox[{"SessionTime", "[", "]"}]}], ";", 
  RowBox[{"Clear", "[", 
   RowBox[{
   "inum", ",", "jnum", ",", "\[Theta]etab", ",", "\[Nu]\[CapitalOmega]tab", 
    ",", "\[Theta]e", ",", "\[Nu]\[CapitalOmega]", ",", "partab"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"inum", "=", "100"}], ";", 
  RowBox[{"jnum", "=", "60"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Theta]etab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"0.4", " ", 
      SuperscriptBox["1.05", "i"]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "0", ",", "inum"}], "}"}]}], "]"}]}], ";", 
  RowBox[{"\[Nu]\[CapitalOmega]tab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"12000", " ", 
      SuperscriptBox["1.1", "j"]}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", 
       RowBox[{"-", "jnum"}], ",", "jnum"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetSharedVariable", "[", 
   RowBox[{
   "inum", ",", "jnum", ",", "\[Theta]etab", ",", "\[Nu]\[CapitalOmega]tab"}],
    "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lookuprV", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"BesselK", "[", 
         RowBox[{"0", ",", 
          SuperscriptBox["\[Theta]e", 
           RowBox[{"-", "1"}]]}], "]"}], 
        RowBox[{"BesselK", "[", 
         RowBox[{"2", ",", 
          SuperscriptBox["\[Theta]e", 
           RowBox[{"-", "1"}]]}], "]"}]], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Theta]e", "\[Rule]", 
          RowBox[{"\[Theta]etab", "[", 
           RowBox[{"[", "i", "]"}], "]"}]}], ",", 
         RowBox[{"\[Nu]\[CapitalOmega]", "\[Rule]", 
          RowBox[{"\[Nu]\[CapitalOmega]tab", "[", 
           RowBox[{"[", "j", "]"}], "]"}]}]}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"Length", "[", "\[Theta]etab", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", 
        RowBox[{"Length", "[", "\[Nu]\[CapitalOmega]tab", "]"}]}], "}"}]}], 
     "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lookuprQ", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{"BesselK", "[", 
          RowBox[{"1", ",", 
           SuperscriptBox["\[Theta]e", 
            RowBox[{"-", "1"}]]}], "]"}], 
         RowBox[{"BesselK", "[", 
          RowBox[{"2", ",", 
           SuperscriptBox["\[Theta]e", 
            RowBox[{"-", "1"}]]}], "]"}]], "+", 
        RowBox[{"6", "\[Theta]e"}]}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Theta]e", "\[Rule]", 
          RowBox[{"\[Theta]etab", "[", 
           RowBox[{"[", "i", "]"}], "]"}]}], ",", 
         RowBox[{"\[Nu]\[CapitalOmega]", "\[Rule]", 
          RowBox[{"\[Nu]\[CapitalOmega]tab", "[", 
           RowBox[{"[", "j", "]"}], "]"}]}]}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"Length", "[", "\[Theta]etab", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", 
        RowBox[{"Length", "[", "\[Nu]\[CapitalOmega]tab", "]"}]}], "}"}]}], 
     "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lookupjI", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"ParallelTable", "[", 
     RowBox[{
      RowBox[{"Quiet", "[", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox["\[Nu]\[CapitalOmega]", 
            SuperscriptBox["\[Gamma]", "2"]], 
           RowBox[{"BesselK", "[", 
            RowBox[{
             FractionBox["5", "3"], ",", "t"}], "]"}], 
           FractionBox[
            RowBox[{"Exp", "[", 
             RowBox[{"-", 
              FractionBox["\[Gamma]", "\[Theta]e"]}], "]"}], 
            RowBox[{"\[Theta]e", " ", 
             RowBox[{"BesselK", "[", 
              RowBox[{"2", ",", 
               SuperscriptBox["\[Theta]e", 
                RowBox[{"-", "1"}]]}], "]"}]}]], "\[Gamma]", 
           SqrtBox[
            RowBox[{
             SuperscriptBox["\[Gamma]", "2"], "-", "1"}]]}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"\[Theta]e", "\[Rule]", 
             RowBox[{"\[Theta]etab", "[", 
              RowBox[{"[", "i", "]"}], "]"}]}], ",", 
            RowBox[{"\[Nu]\[CapitalOmega]", "\[Rule]", 
             RowBox[{"\[Nu]\[CapitalOmega]tab", "[", 
              RowBox[{"[", "j", "]"}], "]"}]}]}], "}"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Gamma]", ",", "1", ",", "3000"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", 
           RowBox[{
            FractionBox["\[Nu]\[CapitalOmega]", 
             SuperscriptBox["\[Gamma]", "2"]], "/.", 
            RowBox[{"{", 
             RowBox[{"\[Nu]\[CapitalOmega]", "\[Rule]", 
              RowBox[{"\[Nu]\[CapitalOmega]tab", "[", 
               RowBox[{"[", "j", "]"}], "]"}]}], "}"}]}], ",", 
           RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"Length", "[", "\[Theta]etab", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", 
        RowBox[{"Length", "[", "\[Nu]\[CapitalOmega]tab", "]"}]}], "}"}]}], 
     "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lookupjQ", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"ParallelTable", "[", 
     RowBox[{
      RowBox[{"Quiet", "[", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox["\[Nu]\[CapitalOmega]", 
            SuperscriptBox["\[Gamma]", "2"]], 
           RowBox[{"BesselK", "[", 
            RowBox[{
             FractionBox["2", "3"], ",", 
             FractionBox["\[Nu]\[CapitalOmega]", 
              SuperscriptBox["\[Gamma]", "2"]]}], "]"}], 
           FractionBox[
            RowBox[{"Exp", "[", 
             RowBox[{"-", 
              FractionBox["\[Gamma]", "\[Theta]e"]}], "]"}], 
            RowBox[{"\[Theta]e", " ", 
             RowBox[{"BesselK", "[", 
              RowBox[{"2", ",", 
               SuperscriptBox["\[Theta]e", 
                RowBox[{"-", "1"}]]}], "]"}]}]], "\[Gamma]", 
           SqrtBox[
            RowBox[{
             SuperscriptBox["\[Gamma]", "2"], "-", "1"}]]}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"\[Theta]e", "\[Rule]", 
             RowBox[{"\[Theta]etab", "[", 
              RowBox[{"[", "i", "]"}], "]"}]}], ",", 
            RowBox[{"\[Nu]\[CapitalOmega]", "\[Rule]", 
             RowBox[{"\[Nu]\[CapitalOmega]tab", "[", 
              RowBox[{"[", "j", "]"}], "]"}]}]}], "}"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Gamma]", ",", "1", ",", "3000"}], "}"}]}], "]"}], "]"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"Length", "[", "\[Theta]etab", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", 
        RowBox[{"Length", "[", "\[Nu]\[CapitalOmega]tab", "]"}]}], "}"}]}], 
     "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lookupjV", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"ParallelTable", "[", 
     RowBox[{
      RowBox[{"Quiet", "[", 
       RowBox[{
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            FractionBox["\[Nu]\[CapitalOmega]", 
             SuperscriptBox["\[Gamma]", "3"]], 
            RowBox[{"BesselK", "[", 
             RowBox[{
              FractionBox["1", "3"], ",", 
              FractionBox["\[Nu]\[CapitalOmega]", 
               SuperscriptBox["\[Gamma]", "2"]]}], "]"}], 
            FractionBox[
             RowBox[{"Exp", "[", 
              RowBox[{"-", 
               FractionBox["\[Gamma]", "\[Theta]e"]}], "]"}], 
             RowBox[{"\[Theta]e", " ", 
              RowBox[{"BesselK", "[", 
               RowBox[{"2", ",", 
                SuperscriptBox["\[Theta]e", 
                 RowBox[{"-", "1"}]]}], "]"}]}]], "\[Gamma]", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["\[Gamma]", "2"], "-", "1"}]]}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\[Theta]e", "\[Rule]", 
              RowBox[{"\[Theta]etab", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}], ",", 
             RowBox[{"\[Nu]\[CapitalOmega]", "\[Rule]", 
              RowBox[{"\[Nu]\[CapitalOmega]tab", "[", 
               RowBox[{"[", "j", "]"}], "]"}]}]}], "}"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Gamma]", ",", "1", ",", "3000"}], "}"}]}], "]"}], "+", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            FractionBox["\[Nu]\[CapitalOmega]", 
             SuperscriptBox["\[Gamma]", "3"]], 
            RowBox[{"BesselK", "[", 
             RowBox[{
              FractionBox["1", "3"], ",", "t"}], "]"}], 
            FractionBox[
             RowBox[{"Exp", "[", 
              RowBox[{"-", 
               FractionBox["\[Gamma]", "\[Theta]e"]}], "]"}], 
             RowBox[{"\[Theta]e", " ", 
              RowBox[{"BesselK", "[", 
               RowBox[{"2", ",", 
                SuperscriptBox["\[Theta]e", 
                 RowBox[{"-", "1"}]]}], "]"}]}]], "\[Gamma]", 
            SqrtBox[
             RowBox[{
              SuperscriptBox["\[Gamma]", "2"], "-", "1"}]]}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\[Theta]e", "\[Rule]", 
              RowBox[{"\[Theta]etab", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}], ",", 
             RowBox[{"\[Nu]\[CapitalOmega]", "\[Rule]", 
              RowBox[{"\[Nu]\[CapitalOmega]tab", "[", 
               RowBox[{"[", "j", "]"}], "]"}]}]}], "}"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Gamma]", ",", "1", ",", "3000"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"t", ",", 
            RowBox[{
             FractionBox["\[Nu]\[CapitalOmega]", 
              SuperscriptBox["\[Gamma]", "2"]], "/.", 
             RowBox[{"{", 
              RowBox[{"\[Nu]\[CapitalOmega]", "\[Rule]", 
               RowBox[{"\[Nu]\[CapitalOmega]tab", "[", 
                RowBox[{"[", "j", "]"}], "]"}]}], "}"}]}], ",", 
            RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"Length", "[", "\[Theta]etab", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", 
        RowBox[{"Length", "[", "\[Nu]\[CapitalOmega]tab", "]"}]}], "}"}]}], 
     "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
   RowBox[{"SessionTime", "[", "]"}], "-", "ttx"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"149", "s", " ", "for", " ", "10", "x12", " ", "table"}], " ", 
    "\[Implies]", " ", 
    RowBox[{"7450", "s", " ", "for", " ", "100", "x60", " ", "table"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.4810473239908*^9, 3.4810474558264*^9}, {
  3.4810477207924*^9, 3.4810477309636*^9}, {3.4810479831376*^9, 
  3.481048051528*^9}, {3.4810480899976*^9, 3.4810480936168003`*^9}, {
  3.4810481448784*^9, 3.4810481490436*^9}, {3.4810483771312*^9, 
  3.481048377958*^9}, {3.4810484304676*^9, 3.4810484974695997`*^9}, {
  3.4810486207262*^9, 3.4810486336429996`*^9}, {3.5624144422692795`*^9, 
  3.562414448329373*^9}, {3.5624147575127087`*^9, 3.562414802375898*^9}}],

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<lookupjIy.dat\>\""}], 
   ",", "lookupjI", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<lookupjQy.dat\>\""}], 
   ",", "lookupjQ", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<lookupjVy.dat\>\""}], 
   ",", "lookupjV", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<lookuprVa.dat\>\""}], 
   ",", "lookuprQ", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<lookuprQa.dat\>\""}], 
   ",", "lookuprV", ",", "\"\<Table\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.562414374930745*^9, 3.5624144343466578`*^9}, {
  3.562414630825763*^9, 3.5624146444059715`*^9}, {3.5624147448950152`*^9, 
  3.5624147511576114`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Correct lookup of emissivities/rotativities", "Subsection",
 CellChangeTimes->{{3.4839819443498*^9, 3.4839819456446*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"dx", ",", "dy"}], "]"}], ";", 
  RowBox[{"ta", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"f", "[", 
        RowBox[{"0", ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"f", "[", 
        RowBox[{"1", ",", "1"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"f", "[", 
        RowBox[{"1", ",", "0"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"f", "[", 
        RowBox[{"0", ",", "1"}], "]"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fuss", "=", 
   RowBox[{"InterpolatingPolynomial", "[", 
    RowBox[{"ta", ",", 
     RowBox[{"{", 
      RowBox[{"lTeman", ",", "lnWman"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"InputForm", "[", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{"fuss", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"f", "[", 
        RowBox[{"0", ",", "0"}], "]"}], "\[Rule]", 
       RowBox[{
        RowBox[{"jI", "[", "j", "]"}], "[", "k", "]"}]}], ",", 
      RowBox[{
       RowBox[{"f", "[", 
        RowBox[{"1", ",", "0"}], "]"}], "\[Rule]", 
       RowBox[{
        RowBox[{"jI", "[", 
         RowBox[{"j", "+", "1"}], "]"}], "[", "k", "]"}]}], ",", 
      RowBox[{
       RowBox[{"f", "[", 
        RowBox[{"0", ",", "1"}], "]"}], "\[Rule]", 
       RowBox[{
        RowBox[{"jI", "[", "j", "]"}], "[", 
        RowBox[{"k", "+", "1"}], "]"}]}], ",", 
      RowBox[{
       RowBox[{"f", "[", 
        RowBox[{"1", ",", "1"}], "]"}], "\[Rule]", 
       RowBox[{
        RowBox[{"jI", "[", 
         RowBox[{"j", "+", "1"}], "]"}], "[", 
        RowBox[{"k", "+", "1"}], "]"}]}]}], "}"}]}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"ToString", "[", 
     RowBox[{"InputForm", "[", 
      RowBox[{
       RowBox[{"FullSimplify", "[", "fuss", "]"}], "/.", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{"o_", ",", "m_"}], "]"}], "\[RuleDelayed]", 
        RowBox[{
         RowBox[{
          RowBox[{"xx", "[", 
           RowBox[{"k", "+", "o"}], "]"}], "[", 
          RowBox[{"j", "+", "m"}], "]"}], "[", "i", "]"}]}]}], "]"}], "]"}], 
    "\[IndentingNewLine]", 
    RowBox[{"ToString", "[", 
     RowBox[{"InputForm", "[", 
      RowBox[{
       RowBox[{"FullSimplify", "[", 
        RowBox[{"Collect", "[", 
         RowBox[{"fuss", ",", 
          RowBox[{"f", "[", "___", "]"}]}], "]"}], "]"}], "/.", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{"o_", ",", "m_"}], "]"}], "\[RuleDelayed]", 
        RowBox[{
         RowBox[{
          RowBox[{"xx", "[", 
           RowBox[{"k", "+", "o"}], "]"}], "[", 
          RowBox[{"j", "+", "m"}], "]"}], "[", "i", "]"}]}]}], "]"}], "]"}]}],
    "*)"}]}]}], "Input",
 CellChangeTimes->{{3.461505272984*^9, 3.461505276105*^9}, {3.461505309462*^9,
   3.461505351112*^9}, {3.461505388033*^9, 3.461505388215*^9}, {
  3.461505421237*^9, 3.461505427486*^9}, {3.46150546359*^9, 
  3.461505471466*^9}, {3.461505503947*^9, 3.461505516961*^9}, {
  3.461505592348*^9, 3.461505628642*^9}, {3.4748527014497137`*^9, 
  3.4748527819997134`*^9}, {3.4748528210457134`*^9, 3.474852823254713*^9}, {
  3.4748528642277136`*^9, 3.4748528688387136`*^9}, {3.4839823834440002`*^9, 
  3.4839824198232*^9}, {3.483982465422*^9, 3.4839825343584003`*^9}, {
  3.48398263944*^9, 3.4839826516703997`*^9}, {3.4839826962396*^9, 
  3.4839827075808*^9}, {3.4839827807916*^9, 3.483982782336*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"temp", "=", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"lnWman", "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "lTeman"}], ")"}]}], "-", "lTeman"}], 
    ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"InputForm", "[", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{
     RowBox[{"temp", "*", 
      RowBox[{
       RowBox[{"jI", "[", "j", "]"}], "[", "k", "]"}]}], "+", 
     RowBox[{"lTeman", "*", 
      RowBox[{
       RowBox[{"jI", "[", 
        RowBox[{"1", "+", "j"}], "]"}], "[", "k", "]"}]}], "+", 
     RowBox[{"lnWman", "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"jI", "[", "j", "]"}], "[", 
         RowBox[{"1", "+", "k"}], "]"}], "+", 
        RowBox[{"lTeman", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{
             RowBox[{"jI", "[", 
              RowBox[{"1", "+", "j"}], "]"}], "[", "k", "]"}]}], "-", 
           RowBox[{
            RowBox[{"jI", "[", "j", "]"}], "[", 
            RowBox[{"1", "+", "k"}], "]"}], "+", 
           RowBox[{
            RowBox[{"jI", "[", 
             RowBox[{"1", "+", "j"}], "]"}], "[", 
            RowBox[{"1", "+", "k"}], "]"}]}], ")"}]}]}], ")"}]}]}], "]"}], 
   "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"temp", "=", 
   RowBox[{"lnWman", "*", "lTeman"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"InputForm", "[", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "lnWman"}], "-", "lTeman", "+", "1", "+", "temp"}], ")"}],
      "*", 
     RowBox[{
      RowBox[{"jI", "[", "j", "]"}], "[", "k", "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"lnWman", "-", "temp"}], ")"}], "*", 
     RowBox[{
      RowBox[{"jI", "[", "j", "]"}], "[", 
      RowBox[{"1", "+", "k"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"lTeman", "-", "temp"}], ")"}], "*", 
     RowBox[{
      RowBox[{"jI", "[", 
       RowBox[{"1", "+", "j"}], "]"}], "[", "k", "]"}]}], "+", 
    RowBox[{"temp", "*", 
     RowBox[{
      RowBox[{"jI", "[", 
       RowBox[{"1", "+", "j"}], "]"}], "[", 
      RowBox[{"1", "+", "k"}], "]"}]}]}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.4839827559876003`*^9, 3.48398279115*^9}, {
  3.4839828218508*^9, 3.4839828950772*^9}, {3.4839830482956*^9, 
  3.4839830522111998`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Evalpointnew (obsolete) functions", "Section",
 CellChangeTimes->{{3.4839835127242002`*^9, 3.4839835182622004`*^9}, {
  3.562414925075283*^9, 3.5624149295778522`*^9}}],

Cell["Lookup of coordinate, k, e1 vectors in BL metric", "Subsection",
 CellChangeTimes->{{3.484046250901*^9, 3.4840462519306*^9}}],

Cell[CellGroupData[{

Cell["Definition of MKS metric (see GRMHD analysis shots.nb)", "Subsection",
 CellChangeTimes->{{3.4840475044702*^9, 3.4840475054997997`*^9}, {
  3.4840476726070004`*^9, 3.4840476809997997`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[CapitalDelta]", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "-", 
    RowBox[{"2", "r"}], "+", 
    SuperscriptBox["a", "2"]}]}], ";", 
  RowBox[{"\[Rho]sq", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "+", 
    RowBox[{
     SuperscriptBox["a", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}]}], ";", 
  RowBox[{"\[CapitalSigma]sq", "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["r", "2"], "+", 
       SuperscriptBox["a", "2"]}], ")"}], "2"], "-", 
    RowBox[{
     SuperscriptBox["a", "2"], "\[CapitalDelta]", " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"gmn", "=", 
    RowBox[{"-", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         FractionBox["\[CapitalSigma]sq", 
          RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
         ",", 
         FractionBox[
          RowBox[{"2", "a", " ", "r"}], 
          RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", 
          FractionBox["\[CapitalDelta]", "\[Rho]sq"]}], ",", "0", ",", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[Rho]sq", 
           RowBox[{"-", "1"}]]}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{"2", "a", " ", "r"}], 
          RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
         ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"(", 
            RowBox[{"\[CapitalDelta]", "-", 
             RowBox[{
              SuperscriptBox["a", "2"], 
              SuperscriptBox[
               RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]]}]}], "}"}]}], 
      "}"}]}]}], ")"}], "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"invgmn", "=", 
    RowBox[{"FullSimplify", "[", 
     RowBox[{
      RowBox[{"Inverse", "[", "gmn", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"r", ">", "0"}], "}"}]}], "]"}]}], ")"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"x", "[", "1", "]"}], "=", "t"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "2", "]"}], "=", "r"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "3", "]"}], "=", "\[Theta]"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "4", "]"}], "=", "\[Phi]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"G", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], "=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"gmn", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "m"}], "]"}], "]"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"invgmn", "[", 
           RowBox[{"[", 
            RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"x", "[", "1", "]"}]}], "]"}], "+", 
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"invgmn", "[", 
           RowBox[{"[", 
            RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"x", "[", "1", "]"}]}], "]"}], "-", 
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"invgmn", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"G", "[", 
      RowBox[{"i", ",", "k", ",", "l"}], "]"}], "=", 
     RowBox[{"Simplify", "[", 
      RowBox[{
       FractionBox["1", "2"], 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"gmn", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "m"}], "]"}], "]"}], "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"invgmn", "[", 
               RowBox[{"[", 
                RowBox[{"m", ",", "k"}], "]"}], "]"}], ",", 
              RowBox[{"x", "[", "l", "]"}]}], "]"}], "+", 
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"invgmn", "[", 
               RowBox[{"[", 
                RowBox[{"m", ",", "l"}], "]"}], "]"}], ",", 
              RowBox[{"x", "[", "k", "]"}]}], "]"}], "-", 
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"invgmn", "[", 
               RowBox[{"[", 
                RowBox[{"k", ",", "l"}], "]"}], "]"}], ",", 
              RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "1", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"l", ",", "1", ",", "4"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gmn", "=", 
   RowBox[{"Simplify", "[", "gmn", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"invgmn", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"invgmn", "/.", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"2", "\[Theta]"}], "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"2", 
        SuperscriptBox[
         RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "-", "1"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"invgmnKS", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", 
        FractionBox[
         RowBox[{"2", "r"}], "\[Rho]sq"], ",", "0", ",", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "a", " ", "r", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}]}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        FractionBox[
         RowBox[{"2", "r"}], "\[Rho]sq"], ",", 
        RowBox[{"1", "+", 
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", "0", ",", 
        RowBox[{
         RowBox[{"-", "a"}], 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "\[Rho]sq", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "a", " ", "r", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}], ",", 
        RowBox[{
         RowBox[{"-", "a"}], 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], ",", "0", ",", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
         RowBox[{"(", 
          RowBox[{"\[Rho]sq", "+", 
           RowBox[{
            SuperscriptBox["a", "2"], 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              FractionBox[
               RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}]}]}], 
       "}"}]}], "}"}]}], ")"}], "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Anumu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{"2", "r"}], "\[CapitalDelta]"], ",", "1", ",", "0", ",", 
       FractionBox["a", "\[CapitalDelta]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AMKS", "=", 
    RowBox[{"DiagonalMatrix", "[", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       FractionBox["1", 
        RowBox[{"r", "-", "R0"}]], ",", 
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{"\[Pi]", 
          RowBox[{"(", 
           RowBox[{"h", "+", 
            RowBox[{"7", 
             RowBox[{"(", 
              RowBox[{"1", "-", "h"}], ")"}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", "x2"}], "-", "1"}], ")"}], "6"]}]}], ")"}]}], 
         ")"}]}], ",", 
       RowBox[{"1", "/", "\[Pi]"}]}], "}"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"AMKS", "=", 
     RowBox[{"Inverse", "[", "AMKS", "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"invnewxx", "=", 
  RowBox[{
   RowBox[{"Inverse", "[", "AMKS", "]"}], ".", "invgmnKS", ".", 
   RowBox[{"Inverse", "[", "AMKS", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"invnew", "=", 
   RowBox[{"invnewxx", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"R0", "\[Rule]", "0.3"}], ",", 
      RowBox[{"h", "\[Rule]", "0.65"}]}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"g", "[", 
        RowBox[{
         RowBox[{"i", "-", "1"}], ",", 
         RowBox[{"j", "-", "1"}]}], "]"}], "=", 
       RowBox[{"gmn", "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "j"}], "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "4"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"invg", "[", 
        RowBox[{
         RowBox[{"i", "-", "1"}], ",", 
         RowBox[{"j", "-", "1"}]}], "]"}], "=", 
       RowBox[{"invgmn", "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "j"}], "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "4"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"gmn", " ", "=", " ", 
       SuperscriptBox["g", "\[Mu]\[Nu]"]}], ";", " ", 
      RowBox[{"invgmn", " ", "=", " ", 
       SubscriptBox["g", "\[Mu]\[Nu]"]}]}], "*)"}], 
    RowBox[{
     RowBox[{"ee", "[", "0", "]"}], "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], ",", 
       RowBox[{"u", "[", "1", "]"}], ",", 
       RowBox[{"u", "[", "2", "]"}], ",", 
       RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ee", "[", "1", "]"}], "=", 
     RowBox[{
      FractionBox["s", "N2"], 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           RowBox[{"g", "[", 
            RowBox[{"0", ",", "0"}], "]"}]}], "C1"}], "-", 
         RowBox[{
          RowBox[{"g", "[", 
           RowBox[{"0", ",", "3"}], "]"}], "C2"}]}], ",", 
        RowBox[{
         RowBox[{"g", "[", 
          RowBox[{"1", ",", "1"}], "]"}], "C0"}], ",", "0", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           RowBox[{"g", "[", 
            RowBox[{"3", ",", "3"}], "]"}]}], "C2"}], "-", 
         RowBox[{
          RowBox[{"g", "[", 
           RowBox[{"0", ",", "3"}], "]"}], "C1"}]}]}], "}"}]}]}], ";", 
    RowBox[{
     RowBox[{"ee", "[", "3", "]"}], "=", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", "N1"]}], 
      RowBox[{"{", 
       RowBox[{"l", ",", "0", ",", "0", ",", "1"}], "}"}]}]}], ";", 
    RowBox[{
     RowBox[{"ee", "[", "2", "]"}], "=", 
     RowBox[{
      FractionBox["1", "N3"], 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{
         FractionBox["C1", "C0"], 
         FractionBox[
          RowBox[{
           RowBox[{"g", "[", 
            RowBox[{"0", ",", "0"}], "]"}], "-", 
           SuperscriptBox["l", "2"]}], 
          RowBox[{"g", "[", 
           RowBox[{"1", ",", "1"}], "]"}]]}], ",", 
        RowBox[{
         FractionBox["Cmin", "C3"], "-", 
         RowBox[{
          FractionBox[
           RowBox[{"u", "[", "1", "]"}], 
           RowBox[{"u", "[", "2", "]"}]], 
          FractionBox["C1", "C0"], 
          FractionBox[
           RowBox[{
            RowBox[{"g", "[", 
             RowBox[{"0", ",", "0"}], "]"}], "-", 
            SuperscriptBox["l", "2"]}], 
           RowBox[{"g", "[", 
            RowBox[{"1", ",", "1"}], "]"}]]}]}], ",", 
        RowBox[{"-", "l"}]}], "}"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"ulo", "=", 
     RowBox[{"invgmn", ".", 
      RowBox[{"ee", "[", "0", "]"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"uco", "[", 
        RowBox[{"i", "-", "1"}], "]"}], "=", 
       RowBox[{"ulo", "[", 
        RowBox[{"[", "i", "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "4"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"l", "=", 
     RowBox[{
      RowBox[{"uco", "[", "3", "]"}], "/", 
      RowBox[{"uco", "[", "1", "]"}]}]}], ";", 
    RowBox[{"C0", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], 
       RowBox[{"uco", "[", "0", "]"}]}], "+", 
      RowBox[{
       RowBox[{"u", "[", "3", "]"}], 
       RowBox[{"uco", "[", "3", "]"}]}]}]}], ";", 
    RowBox[{"C1", "=", 
     RowBox[{
      RowBox[{"u", "[", "1", "]"}], 
      RowBox[{"uco", "[", "0", "]"}]}]}], ";", 
    RowBox[{"C2", "=", 
     RowBox[{
      RowBox[{"u", "[", "1", "]"}], 
      RowBox[{"uco", "[", "3", "]"}]}]}], ";", 
    RowBox[{"C3", "=", 
     RowBox[{
      RowBox[{"u", "[", "2", "]"}], 
      RowBox[{"uco", "[", "1", "]"}]}]}], ";", 
    RowBox[{"Cmin", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"u", "[", "3", "]"}], 
       RowBox[{"uco", "[", "3", "]"}]}], "-", 
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], 
       RowBox[{"uco", "[", "0", "]"}]}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"s", "=", 
     RowBox[{"Sign", "[", "C0", "]"}]}], ";", 
    RowBox[{"j", "=", 
     RowBox[{"FullSimplify", "[", 
      RowBox[{
       SqrtBox[
        RowBox[{"-", 
         RowBox[{"Det", "[", "invgmn", "]"}]}]], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"r", ">", "2"}], ",", 
         RowBox[{"a", ">", "0"}], ",", 
         RowBox[{"\[Pi]", ">", "\[Theta]", ">", "0"}]}], "}"}]}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"gmn", " ", "=", " ", 
       SuperscriptBox["g", "\[Mu]\[Nu]"]}], ";", " ", 
      RowBox[{"invgmn", " ", "=", " ", 
       SubscriptBox["g", "\[Mu]\[Nu]"]}]}], "*)"}], 
    RowBox[{"N1", "=", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"invg", "[", 
          RowBox[{"0", ",", "0"}], "]"}], 
         SuperscriptBox["l", "2"]}], "-", 
        RowBox[{"2", 
         RowBox[{"invg", "[", 
          RowBox[{"0", ",", "3"}], "]"}], "l"}], "+", 
        RowBox[{"invg", "[", 
         RowBox[{"3", ",", "3"}], "]"}]}], ")"}], 
      RowBox[{"1", "/", "2"}]]}], ";", 
    RowBox[{"N2", "=", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"g", "[", 
          RowBox[{"0", ",", "0"}], "]"}], 
         SuperscriptBox["C1", "2"]}], "+", 
        RowBox[{
         RowBox[{"g", "[", 
          RowBox[{"1", ",", "1"}], "]"}], 
         SuperscriptBox["C0", "2"]}], "+", 
        RowBox[{
         RowBox[{"g", "[", 
          RowBox[{"3", ",", "3"}], "]"}], 
         SuperscriptBox["C2", "2"]}], "+", 
        RowBox[{"2", 
         RowBox[{"g", "[", 
          RowBox[{"0", ",", "3"}], "]"}], "C1", " ", "C2"}]}], ")"}], 
      RowBox[{"1", "/", "2"}]]}], ";", 
    RowBox[{"N3", "=", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"g", "[", 
         RowBox[{"0", ",", "0"}], "]"}], "-", 
        RowBox[{"2", 
         RowBox[{"g", "[", 
          RowBox[{"0", ",", "3"}], "]"}], "l"}], "+", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["C1", "C0"], ")"}], "2"], 
         FractionBox[
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"g", "[", 
              RowBox[{"0", ",", "0"}], "]"}], "-", 
             SuperscriptBox["l", "2"]}], ")"}], "2"], 
          RowBox[{"g", "[", 
           RowBox[{"1", ",", "1"}], "]"}]]}], "+", 
        RowBox[{
         RowBox[{"g", "[", 
          RowBox[{"3", ",", "3"}], "]"}], 
         SuperscriptBox["l", "2"]}], "+", 
        RowBox[{
         RowBox[{"g", "[", 
          RowBox[{"2", ",", "2"}], "]"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            FractionBox["Cmin", "C3"], "-", 
            RowBox[{
             FractionBox[
              RowBox[{"u", "[", "1", "]"}], 
              RowBox[{"u", "[", "2", "]"}]], 
             FractionBox["C1", "C0"], 
             FractionBox[
              RowBox[{
               RowBox[{"g", "[", 
                RowBox[{"0", ",", "0"}], "]"}], "-", 
               SuperscriptBox["l", "2"]}], 
              RowBox[{"g", "[", 
               RowBox[{"1", ",", "1"}], "]"}]]}]}], ")"}], "2"]}]}], ")"}], 
      RowBox[{"1", "/", "2"}]]}], ";"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.4626330585179996`*^9, 3.462633106061*^9}, {
   3.462633200225*^9, 3.4626332373120003`*^9}, {3.462633273317*^9, 
   3.462633278652*^9}, {3.4626334330220003`*^9, 3.462633536664*^9}, {
   3.462633586236*^9, 3.462633660715*^9}, {3.462635287076*^9, 
   3.462635305646*^9}, {3.4626355485889997`*^9, 3.462635576118*^9}, {
   3.4626356357019997`*^9, 3.462635639954*^9}, {3.462635761001*^9, 
   3.462635913634*^9}, {3.462635986321*^9, 3.462636006325*^9}, {
   3.462636051492*^9, 3.4626360721210003`*^9}, {3.462636278928*^9, 
   3.462636293153*^9}, {3.462636395936*^9, 3.462636409736*^9}, {
   3.462636547731*^9, 3.4626365525769997`*^9}, 3.462636780659*^9, 
   3.462637584486*^9, {3.4626376989709997`*^9, 3.462637700028*^9}, 
   3.462637849402*^9, {3.46263823645*^9, 3.462638236615*^9}, {
   3.4626383039519997`*^9, 3.462638305049*^9}, {3.462638359123*^9, 
   3.4626383635480003`*^9}, {3.4626385617869997`*^9, 3.462638578455*^9}, {
   3.462638881075*^9, 3.4626389075369997`*^9}, {3.4626390873310003`*^9, 
   3.462639096484*^9}, {3.462644193078*^9, 3.462644217727*^9}, 
   3.4626443531809998`*^9, {3.462704235408*^9, 3.462704264086*^9}, {
   3.4740342972869997`*^9, 3.474034311618*^9}, {3.474036129392*^9, 
   3.474036141512*^9}, {3.474036184262*^9, 3.474036185574*^9}, {
   3.474036255237*^9, 3.474036314354*^9}, {3.474036347196*^9, 
   3.474036401833*^9}, {3.474036443409*^9, 3.4740365891470003`*^9}, {
   3.474055368087*^9, 3.474055472965*^9}, {3.474055541039*^9, 
   3.474055562652*^9}, {3.474055719885*^9, 3.4740557261940002`*^9}, {
   3.474055823498*^9, 3.474055840946*^9}, {3.474056932632*^9, 
   3.4740569785030003`*^9}, {3.4740570994*^9, 3.474057144969*^9}, {
   3.474057341248*^9, 3.4740573636210003`*^9}, {3.474059438028*^9, 
   3.474059442311*^9}, {3.4747543964820004`*^9, 3.474754403494*^9}, {
   3.474898024192319*^9, 3.4748980469371195`*^9}, {3.474904322239919*^9, 
   3.474904332598319*^9}, {3.474908775447119*^9, 3.474908780782319*^9}, {
   3.4782661786446*^9, 3.4782662016546*^9}, 3.4840475259826*^9}],

Cell[BoxData[{
 RowBox[{"invnewxx", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"matr", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"ig", "[", "0", "]"}], "[", "0", "]"}], ",", 
        RowBox[{
         RowBox[{"ig", "[", "0", "]"}], "[", "1", "]"}], ",", "0", ",", 
        RowBox[{
         RowBox[{"ig", "[", "0", "]"}], "[", "3", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"ig", "[", "0", "]"}], "[", "1", "]"}], ",", 
        RowBox[{
         RowBox[{"ig", "[", "1", "]"}], "[", "1", "]"}], ",", "0", ",", 
        RowBox[{
         RowBox[{"ig", "[", "1", "]"}], "[", "3", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        RowBox[{
         RowBox[{"ig", "[", "2", "]"}], "[", "2", "]"}], ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"ig", "[", "0", "]"}], "[", "3", "]"}], ",", 
        RowBox[{
         RowBox[{"ig", "[", "1", "]"}], "[", "3", "]"}], ",", "0", ",", 
        RowBox[{
         RowBox[{"ig", "[", "3", "]"}], "[", "3", "]"}]}], "}"}]}], "}"}]}], 
   ")"}], "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.4748977341259193`*^9, 3.4748977401787195`*^9}, {
  3.474897789833519*^9, 3.4748978683639193`*^9}, {3.4748979385951195`*^9, 
  3.4748980110883193`*^9}, {3.4748980555171194`*^9, 3.474898056141119*^9}, {
  3.4748997099907193`*^9, 3.474899714951519*^9}, {3.4840510209238*^9, 
  3.4840510210797997`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "off", "]"}], ";", 
  RowBox[{"InputForm", "[", 
   RowBox[{"Delete", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Union", "[", 
          RowBox[{"Thread", "[", 
           RowBox[{
            RowBox[{"Flatten", "[", "matr", "]"}], "\[Rule]", 
            RowBox[{"Flatten", "[", "invnewxx", "]"}]}], "]"}], "]"}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"R0", "\[Rule]", "off"}], ",", 
           RowBox[{
            SuperscriptBox["r", "2"], "\[Rule]", "rsq"}], ",", 
           RowBox[{
            SuperscriptBox["a", "2"], "\[Rule]", "asq"}], ",", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], "\[Rule]", 
            "cossq"}], ",", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], "\[Rule]", 
            "sinsq"}], ",", 
           RowBox[{"h", "\[Rule]", "h1"}]}], "}"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"asq", " ", "cossq"}], "+", "rsq"}], "\[Rule]", "rhosq"}], 
         "}"}]}], "/.", 
       RowBox[{
        FractionBox["A_", 
         RowBox[{
          RowBox[{"asq", " ", "cossq"}], "+", "rsq"}]], "\[Rule]", 
        RowBox[{"A", "/", "rhosq"}]}]}], "/.", 
      RowBox[{"r", "\[Rule]", "rr"}]}], ",", "1"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.4748997163711195`*^9, 3.474899757492719*^9}, {
  3.474899822700719*^9, 3.474899915271119*^9}, {3.4749000309139194`*^9, 
  3.474900063845519*^9}, {3.474900117150719*^9, 3.4749002548051195`*^9}, {
  3.4840510222497997`*^9, 3.4840510418746*^9}}]
}, Closed]],

Cell["Definition and lookup of quantities on the grid", "Subsection",
 CellChangeTimes->{{3.4840484231386003`*^9, 3.4840484244802*^9}}],

Cell[CellGroupData[{

Cell["Correct power-law extension of B etc.", "Subsection",
 CellChangeTimes->{{3.4840495383358*^9, 3.4840495397866*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", "=", "\"\<G:\\\\mathematica\\\\3DMHD\\\\a\>\""}], ";", 
  RowBox[{"atab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
     ",", "\"\<098\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", "n_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", "=", 
      RowBox[{"dir", "<>", 
       RowBox[{"atab", "[", 
        RowBox[{"[", "n", "]"}], "]"}], "<>", 
       "\"\<\\\\fieldline00-1.bin\>\""}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"fi11", "=", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", 
        RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Character8\>\"", ",", "374"}], "]"}], 
         "]"}], "]"}], ";"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"res2m", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"BinaryReadList", "[", 
               RowBox[{"fi11", ",", "\"\<Real32\>\"", ",", 
                RowBox[{"11", "*", "32", "*", "64", "*", "256"}]}], "]"}], 
              ",", "11"}], "]"}], ",", "256"}], "]"}], ",", "64"}], "]"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Close", "[", "namefile", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"namefile", " ", "=", 
      RowBox[{"dir", "<>", 
       RowBox[{"atab", "[", 
        RowBox[{"[", "n", "]"}], "]"}], "<>", 
       "\"\<\\\\fieldline0000.bin\>\""}]}], ";", "\n", "   ", 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "256", "*", "64", "*", "32", "*", "4"}]}], ";", "\n",
      "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\n", "   ", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"res2m", " ", "=", " ", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"llist", " ", "=", " ", 
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"Partition", "[", 
                RowBox[{
                 RowBox[{"BinaryReadList", "[", 
                  RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                   RowBox[{"11", "*", "32", "*", "64", "*", "256"}]}], "]"}], 
                 ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], ",", " ", 
             "64"}], "]"}]}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], 
           "}"}]}], "]"}]}], ";"}], "*)"}], "\n", "   ", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], "\n", 
 RowBox[{"read11", "[", "5", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stt", "=", 
   RowBox[{"StringToStream", "[", "strrr", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"x1min", "=", 
    RowBox[{"Read", "[", 
     RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "5"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"dx1", "=", 
    RowBox[{"Read", "[", 
     RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"off", "=", 
    RowBox[{"Read", "[", 
     RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "6"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Close", "[", "stt", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"rtab", "=", 
   RowBox[{"off", "+", 
    RowBox[{"Exp", "[", 
     RowBox[{"x1min", "+", 
      RowBox[{"dx1", " ", 
       RowBox[{"Range", "[", 
        RowBox[{"0", ",", "255"}], "]"}]}]}], "]"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x1min", ",", "x2min", ",", "x3min"}], "}"}], "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}], ",", 
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}], ",", 
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"dx1", ",", "dx2", ",", "dx3"}], "}"}], "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}], ",", 
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}], ",", 
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"BinaryRead", "[", 
       RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "8"}], "}"}]}], "]"}], ";", 
    RowBox[{"BinaryRead", "[", 
     RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"ress", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"BinaryReadList", "[", 
              RowBox[{"fi11", ",", "\"\<Real32\>\"", ",", 
               RowBox[{"30", "*", "32", "*", "64", "*", "256"}]}], "]"}], ",",
              "30"}], "]"}], ",", "256"}], "]"}], ",", "64"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Close", "[", "namefile", "]"}], ";"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.474395330177*^9, 3.4743954013129997`*^9}, {
   3.4743954785486*^9, 3.474395507549*^9}, {3.4743955492321997`*^9, 
   3.4743956059538*^9}, {3.4743956815358*^9, 3.474395682347*^9}, {
   3.4743957318458*^9, 3.4743958939454*^9}, 3.4743961811882*^9, {
   3.474396341837*^9, 3.4743963751274*^9}, {3.4743965493014*^9, 
   3.4743965682242002`*^9}, {3.4743967252538*^9, 3.4743967672958*^9}, {
   3.4743968341261997`*^9, 3.474396836123*^9}, {3.4744626708473997`*^9, 
   3.474462676869*^9}, {3.4744629273738003`*^9, 3.4744629351893997`*^9}, {
   3.474464462878333*^9, 3.474464485005333*^9}, {3.474849252384719*^9, 
   3.4748492674855194`*^9}, {3.474851530561719*^9, 3.474851533993719*^9}, {
   3.474851599981719*^9, 3.4748516129141192`*^9}, {3.474851968999719*^9, 
   3.4748519790305195`*^9}, {3.4748932293839192`*^9, 3.474893229758319*^9}, {
   3.474894184072719*^9, 3.474894191311119*^9}, {3.4748951725747194`*^9, 
   3.4748951818879194`*^9}, {3.474895252805519*^9, 3.4748952572671194`*^9}, {
   3.474895323879119*^9, 3.474895324440719*^9}, {3.474896254980719*^9, 
   3.474896259364319*^9}, {3.4748967491575193`*^9, 3.474896751606719*^9}, {
   3.474911094340319*^9, 3.4749110979127192`*^9}, {3.4766324628285313`*^9, 
   3.4766324638581314`*^9}, {3.4840501346722*^9, 3.4840501482441998`*^9}, {
   3.484050200941*^9, 3.484050207883*^9}, {3.4840502848534*^9, 
   3.4840503104217997`*^9}, {3.4840503488445997`*^9, 
   3.4840504036006002`*^9}, {3.4840505983978*^9, 3.4840507457866*^9}, {
   3.484051655797*^9, 3.4840516572634*^9}, {3.4840518824494*^9, 
   3.4840519349902*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Dimensions", "[", 
   RowBox[{"avgres", "=", 
    FractionBox[
     RowBox[{"Total", "[", 
      RowBox[{
       RowBox[{"res2m", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", "All", ",", "All"}], "]"}], "]"}], 
       ",", 
       RowBox[{"{", "3", "}"}]}], "]"}], "32"]}], "]"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"uup", "=", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"fie", "[", 
        RowBox[{"[", "5", "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{"fie", "[", 
         RowBox[{"[", "5", "]"}], "]"}], 
        RowBox[{"fie", "[", 
         RowBox[{"[", 
          RowBox[{"6", ";;", "8"}], "]"}], "]"}]}]}], "}"}], "]"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl3", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "5"}], "]"}], "]"}], "*", 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "6"}], "]"}], "]"}]}]}], "}"}], 
      "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl3", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"0.7", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "2.5"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "5"}], "]"}], "]"}], "*", 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "8"}], "]"}], "]"}]}]}], "}"}], 
      "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"0.3", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "1.5"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "5"}], "]"}], "]"}], "*", 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "7"}], "]"}], "]"}]}]}], "}"}], 
      "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"0.03", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "1.5"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{"lpl3", ",", "pl3", ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(u\), \(r\)]\)-upper index\>\""}]}], "]"}],
      ",", 
     RowBox[{"Show", "[", 
      RowBox[{"lpl1", ",", "pl1", ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(u\), \(\[Phi]\)]\)-upper index\>\""}]}], 
      "]"}], ",", 
     RowBox[{"Show", "[", 
      RowBox[{"lpl2", ",", "pl2", ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(u\), \(\[Theta]\)]\)-upper index\>\""}]}],
       "]"}]}], "}"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "1200"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"Abs", "[", 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "9"}], "]"}], "]"}], "]"}]}], "}"}],
       "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"0.8", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "2.5"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"Abs", "[", 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "10"}], "]"}], "]"}], "]"}]}], 
       "}"}], "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"0.01", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "1.5"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl3", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"Abs", "[", 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "11"}], "]"}], "]"}], "]"}]}], 
       "}"}], "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl3", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"0.8", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "2.5"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{"lpl1", ",", "pl1", ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(B\), \(r\)]\)-upper index\>\""}]}], "]"}],
      ",", 
     RowBox[{"Show", "[", 
      RowBox[{"lpl2", ",", "pl2", ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(B\), \(\[Theta]\)]\)-upper index\>\""}]}],
       "]"}], ",", 
     RowBox[{"Show", "[", 
      RowBox[{"lpl3", ",", "pl3", ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(B\), \(\[Phi]\)]\)-upper index\>\""}]}], 
      "]"}]}], "}"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "1200"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"Abs", "[", 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "1"}], "]"}], "]"}], "]"}]}], "}"}],
       "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"6", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "0.8"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        FractionBox[
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "2"}], "]"}], "]"}], 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "1"}], "]"}], "]"}]]}], "}"}], 
      "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"0.25", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "0.8"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{"lpl1", ",", "pl1", ",", 
       RowBox[{"PlotLabel", "\[Rule]", "\"\<\[Rho]\>\""}]}], "]"}], ",", 
     RowBox[{"Show", "[", 
      RowBox[{"lpl2", ",", "pl2", ",", 
       RowBox[{"PlotLabel", "\[Rule]", "\"\<U\>\""}]}], "]"}]}], "}"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "800"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.4770740564309373`*^9, 3.4770741419657373`*^9}, {
   3.4770741761921372`*^9, 3.4770741848969374`*^9}, {3.4840507559578*^9, 
   3.4840507562074003`*^9}, 3.4840516442218*^9, {3.484051709851*^9, 
   3.4840518415306*^9}, {3.484070100304*^9, 3.4840701156076*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Lookup of Te, u[0]", "Subsection",
 CellChangeTimes->{{3.484054262869*^9, 3.4840542637426*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"matr", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"ig", "[", "0", "]"}], "[", "0", "]"}], ",", 
        RowBox[{
         RowBox[{"ig", "[", "0", "]"}], "[", "1", "]"}], ",", "0", ",", 
        RowBox[{
         RowBox[{"ig", "[", "0", "]"}], "[", "3", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"ig", "[", "0", "]"}], "[", "1", "]"}], ",", 
        RowBox[{
         RowBox[{"ig", "[", "1", "]"}], "[", "1", "]"}], ",", "0", ",", 
        RowBox[{
         RowBox[{"ig", "[", "1", "]"}], "[", "3", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        RowBox[{
         RowBox[{"ig", "[", "2", "]"}], "[", "2", "]"}], ",", "0"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"ig", "[", "0", "]"}], "[", "3", "]"}], ",", 
        RowBox[{
         RowBox[{"ig", "[", "1", "]"}], "[", "3", "]"}], ",", "0", ",", 
        RowBox[{
         RowBox[{"ig", "[", "3", "]"}], "[", "3", "]"}]}], "}"}]}], "}"}]}], 
   ")"}], "//", "MatrixForm"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "ulo", "]"}], ";", 
  RowBox[{"StringReplace", "[", 
   RowBox[{
    RowBox[{"ToString", "[", 
     RowBox[{"InputForm", "[", 
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ulo", "[", "0", "]"}], ",", 
          RowBox[{"ulo", "[", "1", "]"}], ",", 
          RowBox[{"ulo", "[", "2", "]"}], ",", 
          RowBox[{"ulo", "[", "3", "]"}]}], "}"}], "\[Equal]", 
        RowBox[{"matr", ".", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"u", "[", "0", "]"}], ",", 
           RowBox[{"u", "[", "1", "]"}], ",", 
           RowBox[{"u", "[", "2", "]"}], ",", 
           RowBox[{"u", "[", "3", "]"}]}], "}"}]}]}], "]"}], "]"}], "]"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\"\<==\>\"", "\[Rule]", "\"\<=\>\""}], ",", 
      RowBox[{"\"\<,\>\"", "\[Rule]", "\"\<;\>\""}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.474902289388319*^9, 3.4749024748879194`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "u", "]"}], ";", 
  RowBox[{"InputForm", "[", 
   RowBox[{
    RowBox[{"FullSimplify", "[", 
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "1"}], "==", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"u", "[", "0", "]"}], ",", 
           RowBox[{"u", "[", "1", "]"}], ",", 
           RowBox[{"u", "[", "2", "]"}], ",", 
           RowBox[{"u", "[", "3", "]"}]}], "}"}], ".", "matr", ".", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"u", "[", "0", "]"}], ",", 
           RowBox[{"u", "[", "1", "]"}], ",", 
           RowBox[{"u", "[", "2", "]"}], ",", 
           RowBox[{"u", "[", "3", "]"}]}], "}"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"u", "[", "0", "]"}], "}"}]}], "]"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.474901422589919*^9, 3.474901471558319*^9}, {
  3.474901514770319*^9, 3.474901545564719*^9}, {3.474901632035519*^9, 
  3.4749017502679195`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["BL to MKS transformation", "Subsection",
 CellChangeTimes->{3.4840568118154*^9}],

Cell[CellGroupData[{

Cell["Old simulations ", "Subsubsection",
 CellChangeTimes->{{3.541280403898181*^9, 3.5412804069053535`*^9}}],

Cell[BoxData["strrr"], "Input",
 CellChangeTimes->{{3.5412805858375874`*^9, 3.5412806033765907`*^9}, {
  3.5412807505250072`*^9, 3.5412807577434196`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", "=", "\"\<E:\\\\GRMHD\\\\a09\\\\fieldlines\\\\\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", "=", 
      RowBox[{"dir", "<>", "\"\<fieldline6950.bin\>\""}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"fi11", "=", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", 
        RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Character8\>\"", ",", "374"}], "]"}], 
         "]"}], "]"}], ";"}], "*)"}], 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "256", "*", "64", "*", "32", "*", "4"}]}], ";", "\n",
      "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"res2m", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"BinaryReadList", "[", 
               RowBox[{"fi11", ",", "\"\<Real32\>\"", ",", 
                RowBox[{"11", "*", "32", "*", "64", "*", "256"}]}], "]"}], 
              ",", "11"}], "]"}], ",", "256"}], "]"}], ",", "64"}], "]"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], "\n", 
 RowBox[{"read11", "[", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stt", "=", 
   RowBox[{"StringToStream", "[", "strrr", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"nx1", "=", 
     RowBox[{"Read", "[", 
      RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"nx2", "=", 
     RowBox[{"Read", "[", 
      RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1"}], "}"}]}], "]"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"nx3", "=", 
     RowBox[{"Read", "[", 
      RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1"}], "}"}]}], "]"}], ";", 
  RowBox[{"{", 
   RowBox[{"nx1", ",", "nx2", ",", "nx3"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"x1min", "=", 
     RowBox[{"Read", "[", 
      RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"dx1", "=", 
     RowBox[{"Read", "[", 
      RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"off", "=", 
     RowBox[{"Read", "[", 
      RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "6"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"h1", "=", 
     RowBox[{"Read", "[", 
      RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Close", "[", "stt", "]"}], ";", 
  RowBox[{"{", 
   RowBox[{"x1min", ",", "dx1", ",", "off", ",", "h1"}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"rtab", "=", 
   RowBox[{"off", "+", 
    RowBox[{"Exp", "[", 
     RowBox[{"x1tab", "=", 
      RowBox[{"x1min", "+", 
       RowBox[{"dx1", " ", 
        RowBox[{"Range", "[", 
         RowBox[{"0", ",", "255"}], "]"}]}]}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"np", "=", "nx2"}], ";", 
  RowBox[{"h", "=", "h1"}], ";", 
  RowBox[{"\[Theta]tab", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"h", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "x2"}], "-", "1"}], ")"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", "h"}], ")"}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "x2"}], "-", "1"}], ")"}], "7"]}], "+", "1"}], ")"}], 
     FractionBox["\[Pi]", "2"]}], "/.", 
    RowBox[{"x2", "\[Rule]", 
     RowBox[{"(", 
      RowBox[{"x2tab", "=", 
       RowBox[{"N", "[", 
        RowBox[{"Range", "[", 
         RowBox[{
          FractionBox["1", 
           RowBox[{"2", "np"}]], ",", 
          RowBox[{"1", "-", 
           FractionBox["1", 
            RowBox[{"2", "np"}]]}], ",", 
          FractionBox["1", "np"]}], "]"}], "]"}]}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"read22", "[", "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"namefilexx", "=", 
        RowBox[{"dir", "<>", "\"\<usdump0000\>\""}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"fi22", "=", 
        RowBox[{"OpenRead", "[", 
         RowBox[{"namefilexx", ",", 
          RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi22", ",", "\"\<Integer32\>\""}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tt", "=", 
        RowBox[{"BinaryRead", "[", 
         RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Integer32\>\""}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x1min", ",", "x2min", ",", "x3min"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], ",", 
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], ",", 
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}]}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"dx1", ",", "dx2", ",", "dx3"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], ",", 
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], ",", 
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}]}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "8"}], "}"}]}], "]"}], ";", 
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ress", "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"Partition", "[", 
               RowBox[{
                RowBox[{"BinaryReadList", "[", 
                 RowBox[{"fi22", ",", "\"\<Real32\>\"", ",", 
                  RowBox[{"30", "*", "32", "*", "64", "*", "256"}]}], "]"}], 
                ",", "30"}], "]"}], ",", "256"}], "]"}], ",", "64"}], "]"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}], 
       ";"}], ")"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"read22", "[", "]"}]}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.484057957027*^9, 3.4840579635478*^9}, {
   3.4840580299258003`*^9, 3.4840580302066*^9}, {3.4840580629354*^9, 
   3.4840580673658*^9}, {3.4840581043222*^9, 3.484058118565*^9}, 
   3.4840581562390003`*^9, {3.5412054141272097`*^9, 3.5412054143672237`*^9}, {
   3.5412804537450323`*^9, 3.5412804770503654`*^9}, {3.5412805166566305`*^9, 
   3.5412805402109776`*^9}, {3.5412806081628647`*^9, 3.54128062049957*^9}, {
   3.541280780759736*^9, 3.541280814546669*^9}, {3.541280852925864*^9, 
   3.5412808570030975`*^9}, {3.54128088817288*^9, 3.5412808932901726`*^9}, {
   3.5412809397648306`*^9, 3.5412809616520824`*^9}, {3.541281150334875*^9, 
   3.541281175971341*^9}, {3.541281484919012*^9, 3.5412814897492886`*^9}, {
   3.541282644849356*^9, 3.54128264490936*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[CapitalDelta]", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "-", 
    RowBox[{"2", "r"}], "+", 
    SuperscriptBox["a", "2"]}]}], ";", 
  RowBox[{"\[Rho]sq", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "+", 
    RowBox[{
     SuperscriptBox["a", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}]}], ";", 
  RowBox[{"\[CapitalSigma]sq", "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["r", "2"], "+", 
       SuperscriptBox["a", "2"]}], ")"}], "2"], "-", 
    RowBox[{
     SuperscriptBox["a", "2"], "\[CapitalDelta]", " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"gmn", "=", 
    RowBox[{"-", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         FractionBox["\[CapitalSigma]sq", 
          RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
         ",", 
         FractionBox[
          RowBox[{"2", "a", " ", "r"}], 
          RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", 
          FractionBox["\[CapitalDelta]", "\[Rho]sq"]}], ",", "0", ",", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[Rho]sq", 
           RowBox[{"-", "1"}]]}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{"2", "a", " ", "r"}], 
          RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
         ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"(", 
            RowBox[{"\[CapitalDelta]", "-", 
             RowBox[{
              SuperscriptBox["a", "2"], 
              SuperscriptBox[
               RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]]}]}], "}"}]}], 
      "}"}]}]}], ")"}], "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"invgmn", "=", 
    RowBox[{"FullSimplify", "[", 
     RowBox[{
      RowBox[{"Inverse", "[", "gmn", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"r", ">", "0"}], "}"}]}], "]"}]}], ")"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"x", "[", "1", "]"}], "=", "t"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "2", "]"}], "=", "r"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "3", "]"}], "=", "\[Theta]"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "4", "]"}], "=", "\[Phi]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"G", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], "=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"gmn", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "m"}], "]"}], "]"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"invgmn", "[", 
           RowBox[{"[", 
            RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"x", "[", "1", "]"}]}], "]"}], "+", 
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"invgmn", "[", 
           RowBox[{"[", 
            RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"x", "[", "1", "]"}]}], "]"}], "-", 
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"invgmn", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"G", "[", 
      RowBox[{"i", ",", "k", ",", "l"}], "]"}], "=", 
     RowBox[{"Simplify", "[", 
      RowBox[{
       FractionBox["1", "2"], 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"gmn", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "m"}], "]"}], "]"}], "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"invgmn", "[", 
               RowBox[{"[", 
                RowBox[{"m", ",", "k"}], "]"}], "]"}], ",", 
              RowBox[{"x", "[", "l", "]"}]}], "]"}], "+", 
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"invgmn", "[", 
               RowBox[{"[", 
                RowBox[{"m", ",", "l"}], "]"}], "]"}], ",", 
              RowBox[{"x", "[", "k", "]"}]}], "]"}], "-", 
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"invgmn", "[", 
               RowBox[{"[", 
                RowBox[{"k", ",", "l"}], "]"}], "]"}], ",", 
              RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "1", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"l", ",", "1", ",", "4"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gmn", "=", 
   RowBox[{"Simplify", "[", "gmn", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"invgmn", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"invgmn", "/.", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"2", "\[Theta]"}], "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"2", 
        SuperscriptBox[
         RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "-", "1"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"invgmnKS", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", 
        FractionBox[
         RowBox[{"2", "r"}], "\[Rho]sq"], ",", "0", ",", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "a", " ", "r", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}]}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        FractionBox[
         RowBox[{"2", "r"}], "\[Rho]sq"], ",", 
        RowBox[{"1", "+", 
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", "0", ",", 
        RowBox[{
         RowBox[{"-", "a"}], 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "\[Rho]sq", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "a", " ", "r", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}], ",", 
        RowBox[{
         RowBox[{"-", "a"}], 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], ",", "0", ",", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
         RowBox[{"(", 
          RowBox[{"\[Rho]sq", "+", 
           RowBox[{
            SuperscriptBox["a", "2"], 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              FractionBox[
               RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}]}]}], 
       "}"}]}], "}"}]}], ")"}], "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Anumu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{"2", "r"}], "\[CapitalDelta]"], ",", "1", ",", "0", ",", 
       FractionBox["a", "\[CapitalDelta]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AMKS", "=", 
   RowBox[{"DiagonalMatrix", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      FractionBox["1", 
       RowBox[{"r", "-", "R0"}]], ",", 
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{"h", "+", 
           RowBox[{"7", 
            RowBox[{"(", 
             RowBox[{"1", "-", "h"}], ")"}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", "x2"}], "-", "1"}], ")"}], "6"]}]}], ")"}]}], 
        ")"}]}], ",", 
      RowBox[{"1", "/", "\[Pi]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"invnew", "=", 
   RowBox[{
    RowBox[{"Inverse", "[", "AMKS", "]"}], ".", "invgmnKS", ".", 
    RowBox[{"Inverse", "[", "AMKS", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invAnumu", "=", 
     RowBox[{"FullSimplify", "[", 
      RowBox[{"gmn", ".", "Anumu", ".", "invgmnKS"}], "]"}]}], ")"}], "//", 
   "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"iMBL", "=", 
    RowBox[{
     RowBox[{"AMKS", ".", 
      RowBox[{"Inverse", "[", "invAnumu", "]"}]}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         SuperscriptBox["a", "2"], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "2"}], "+", "r"}], ")"}], " ", "r"}]}], "\[Rule]", 
        "Del"}], ",", 
       RowBox[{
        RowBox[{"1", "/", 
         RowBox[{"(", 
          RowBox[{"\[Pi]", " ", 
           RowBox[{"(", 
            RowBox[{"h", "+", 
             RowBox[{"7", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", "h"}], ")"}], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "1"}], "+", 
                 RowBox[{"2", " ", "x2"}]}], ")"}], "6"]}]}], ")"}]}], 
          ")"}]}], "\[Rule]", 
        RowBox[{"1", "/", "x2temp"}]}]}], "}"}]}]}], ")"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Anumu", "//", 
       RowBox[{"MatrixForm", "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{"invAnumu", "=", 
          RowBox[{"FullSimplify", "[", 
           RowBox[{"gmn", ".", "Anumu", ".", "invgmnKS"}], "]"}]}], ")"}]}]}],
       "//", 
      RowBox[{"MatrixForm", "\[IndentingNewLine]", 
       RowBox[{"Inverse", "[", "invAnumu", "]"}]}]}], "//", 
     RowBox[{"MatrixForm", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Inverse", "[", "invAnumu", "]"}], ".", "invAnumu"}]}]}], "//",
     "MatrixForm"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.4626330585179996`*^9, 3.462633106061*^9}, {
   3.462633200225*^9, 3.4626332373120003`*^9}, {3.462633273317*^9, 
   3.462633278652*^9}, {3.4626334330220003`*^9, 3.462633536664*^9}, {
   3.462633586236*^9, 3.462633660715*^9}, {3.462635287076*^9, 
   3.462635305646*^9}, {3.4626355485889997`*^9, 3.462635576118*^9}, {
   3.4626356357019997`*^9, 3.462635639954*^9}, {3.462635761001*^9, 
   3.462635913634*^9}, {3.462635986321*^9, 3.462636006325*^9}, {
   3.462636051492*^9, 3.4626360721210003`*^9}, {3.462636278928*^9, 
   3.462636293153*^9}, {3.462636395936*^9, 3.462636409736*^9}, {
   3.462636547731*^9, 3.4626365525769997`*^9}, 3.462636780659*^9, 
   3.462637584486*^9, {3.4626376989709997`*^9, 3.462637700028*^9}, 
   3.462637849402*^9, {3.46263823645*^9, 3.462638236615*^9}, {
   3.4626383039519997`*^9, 3.462638305049*^9}, {3.462638359123*^9, 
   3.4626383635480003`*^9}, {3.4626385617869997`*^9, 3.462638578455*^9}, {
   3.462638881075*^9, 3.4626389075369997`*^9}, {3.4626390873310003`*^9, 
   3.462639096484*^9}, {3.462644193078*^9, 3.462644217727*^9}, 
   3.4626443531809998`*^9, {3.462704235408*^9, 3.462704264086*^9}, {
   3.4740342972869997`*^9, 3.474034311618*^9}, {3.474036129392*^9, 
   3.474036141512*^9}, {3.474036184262*^9, 3.474036185574*^9}, {
   3.474036255237*^9, 3.474036314354*^9}, {3.474036347196*^9, 
   3.474036401833*^9}, {3.474036443409*^9, 3.4740365891470003`*^9}, {
   3.474055368087*^9, 3.474055472965*^9}, {3.474055541039*^9, 
   3.474055562652*^9}, {3.474055719885*^9, 3.4740557261940002`*^9}, {
   3.474055823498*^9, 3.474055840946*^9}, {3.474056932632*^9, 
   3.4740569785030003`*^9}, {3.4740570994*^9, 3.474057144969*^9}, {
   3.474057341248*^9, 3.4740573636210003`*^9}, {3.474059438028*^9, 
   3.474059442311*^9}, {3.4747543964820004`*^9, 3.474754403494*^9}, {
   3.474898024192319*^9, 3.4748980469371195`*^9}, {3.474904322239919*^9, 
   3.474904332598319*^9}, {3.474908775447119*^9, 3.474908780782319*^9}, {
   3.484059672796*^9, 3.4840596747148*^9}, 3.4840598974516*^9, {
   3.4840602350824003`*^9, 3.484060312084*^9}, {3.541281935403778*^9, 
   3.541281957946068*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"R0", "=", "off"}], ";", 
  RowBox[{"h", "=", "h1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tadd", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"i1", ",", "i2", ",", "i3"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{"cv", ",", "45", ",", "21"}], "}"}]}], "]"}], ";", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"ext", "=", 
         RowBox[{"ress", "[", 
          RowBox[{"[", 
           RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}], "]"}]}], ";"}], 
       "*)"}], 
      RowBox[{"fie", "=", 
       RowBox[{"res2m", "[", 
        RowBox[{"[", 
         RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}], "]"}]}], ";", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Coord (x1,x2): \>\"", " ", ",", 
        RowBox[{"xxx", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x1tab", "[", 
            RowBox[{"[", "i1", "]"}], "]"}], ",", 
           RowBox[{"x2tab", "[", 
            RowBox[{"[", "i2", "]"}], "]"}]}], "}"}]}], ",", 
        "\"\<; (r,\[Theta]): \>\"", ",", " ", 
        RowBox[{"rtp", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"rtab", "[", 
            RowBox[{"[", "i1", "]"}], "]"}], ",", 
           RowBox[{"\[Theta]tab", "[", 
            RowBox[{"[", "i2", "]"}], "]"}]}], "}"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"sub", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"r", "\[Rule]", 
          RowBox[{"rtp", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], ",", 
         RowBox[{"x1", "\[Rule]", 
          RowBox[{"xxx", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], ",", 
         RowBox[{"\[Theta]", "\[Rule]", 
          RowBox[{"rtp", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", 
         RowBox[{"x2", "\[Rule]", 
          RowBox[{"xxx", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", 
         RowBox[{"a", "\[Rule]", "0.9"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\[Rho]=\>\"", ",", " ", 
        RowBox[{"\[Rho]", "=", 
         RowBox[{"fie", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ",", "\"\<; U=\>\"", ",", 
        RowBox[{"U", "=", 
         RowBox[{"fie", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\!\(\*SuperscriptBox[\(u\), \(\[Mu]\)]\)=\>\"", ",", 
        RowBox[{"uup", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"fie", "[", 
             RowBox[{"[", "5", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"fie", "[", 
              RowBox[{"[", "5", "]"}], "]"}], 
             RowBox[{"fie", "[", 
              RowBox[{"[", 
               RowBox[{"6", ";;", "8"}], "]"}], "]"}]}]}], "}"}], "]"}]}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"ulo", "=", 
       RowBox[{
        RowBox[{"invnew", ".", "uup"}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Lab \!\(\*SuperscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
        RowBox[{"bi", "=", 
         RowBox[{"fie", "[", 
          RowBox[{"[", 
           RowBox[{"9", ";;", "11"}], "]"}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\!\(\*SuperscriptBox[\(b\), \(\[Mu]\)]\)=\>\"", ",", 
        RowBox[{"bup", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"bi", ".", 
             RowBox[{"ulo", "[", 
              RowBox[{"[", 
               RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], ",", 
            FractionBox[
             RowBox[{"bi", "+", 
              RowBox[{
               RowBox[{"bi", ".", 
                RowBox[{"ulo", "[", 
                 RowBox[{"[", 
                  RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], 
               RowBox[{"uup", "[", 
                RowBox[{"[", 
                 RowBox[{"2", ";;", "4"}], "]"}], "]"}]}]}], 
             RowBox[{"uup", "[", 
              RowBox[{"[", "1", "]"}], "]"}]]}], "}"}], "]"}]}]}], "]"}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"MKS", "\[Rule]", "FFFF"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"u", "[", "0", "]"}], ",", 
          RowBox[{"u", "[", "1", "]"}], ",", 
          RowBox[{"u", "[", "2", "]"}], ",", 
          RowBox[{"u", "[", "3", "]"}]}], "}"}], "=", "uup"}], "]"}], ";", 
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"uco", "[", "0", "]"}], ",", 
          RowBox[{"uco", "[", "1", "]"}], ",", 
          RowBox[{"uco", "[", "2", "]"}], ",", 
          RowBox[{"uco", "[", "3", "]"}]}], "}"}], "=", "ulo"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xx", "[", "0", "]"}], "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"u", "[", "0", "]"}], ",", 
         RowBox[{"u", "[", "1", "]"}], ",", 
         RowBox[{"u", "[", "2", "]"}], ",", 
         RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "0", "]"}], "=", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"invnew", ".", 
          RowBox[{"xx", "[", "0", "]"}]}]}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xx", "[", "2", "]"}], "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"uco", "[", "2", "]"}], 
          RowBox[{"u", "[", "0", "]"}]}], ",", 
         RowBox[{
          RowBox[{"uco", "[", "2", "]"}], 
          RowBox[{"u", "[", "1", "]"}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"uco", "[", "2", "]"}], 
           RowBox[{"u", "[", "2", "]"}]}], "+", "1"}], ",", 
         RowBox[{
          RowBox[{"uco", "[", "2", "]"}], 
          RowBox[{"u", "[", "3", "]"}]}]}], "}"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "2", "]"}], "=", 
       RowBox[{
        RowBox[{"invnew", ".", 
         RowBox[{"xx", "[", "2", "]"}]}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xx", "[", "3", "]"}], "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"uco", "[", "3", "]"}], 
           RowBox[{"uco", "[", "0", "]"}]]}], ",", "0", ",", "0", ",", "1"}], 
        "}"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "3", "]"}], "=", 
       RowBox[{
        RowBox[{"invnew", ".", 
         RowBox[{"xx", "[", "3", "]"}]}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"sc", "[", "0", "]"}], "=", 
       RowBox[{
        SqrtBox[
         RowBox[{
          RowBox[{"xx", "[", "0", "]"}], ".", 
          RowBox[{"xxlo", "[", "0", "]"}]}]], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"sc", "[", "3", "]"}], "=", 
       RowBox[{
        SqrtBox[
         RowBox[{
          RowBox[{"xx", "[", "3", "]"}], ".", 
          RowBox[{"xxlo", "[", "3", "]"}]}]], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"sc", "[", "2", "]"}], "=", 
       RowBox[{
        SqrtBox[
         RowBox[{
          RowBox[{"xx", "[", "2", "]"}], ".", 
          RowBox[{"xxlo", "[", "2", "]"}]}]], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xx", "[", "0", "]"}], "/=", 
       RowBox[{"sc", "[", "0", "]"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "0", "]"}], "/=", 
       RowBox[{
        RowBox[{"sc", "[", "0", "]"}], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"xx", "[", "2", "]"}], "/=", 
       RowBox[{"sc", "[", "2", "]"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "2", "]"}], "/=", 
       RowBox[{
        RowBox[{"sc", "[", "2", "]"}], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"xx", "[", "3", "]"}], "/=", 
       RowBox[{"sc", "[", "3", "]"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "3", "]"}], "/=", 
       RowBox[{
        RowBox[{"sc", "[", "3", "]"}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xpr", "[", "1", "]"}], "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"u", "[", "0", "]"}], 
           RowBox[{"uco", "[", "1", "]"}]}], " ", ",", 
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"u", "[", "0", "]"}], 
              RowBox[{"uco", "[", "0", "]"}]}], "+", 
             RowBox[{
              RowBox[{"u", "[", "3", "]"}], 
              RowBox[{"uco", "[", "3", "]"}]}]}], ")"}]}], ",", "0", ",", 
          RowBox[{
           RowBox[{"u", "[", "3", "]"}], 
           RowBox[{"uco", "[", "1", "]"}]}]}], "}"}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xlopr", "[", "1", "]"}], "=", 
       RowBox[{
        RowBox[{"invnew", ".", 
         RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"xx", "[", "1", "]"}], "=", 
       RowBox[{
        RowBox[{"xpr", "[", "1", "]"}], "-", 
        RowBox[{
         RowBox[{
          RowBox[{"xlopr", "[", "1", "]"}], ".", 
          RowBox[{"xx", "[", "3", "]"}]}], "*", 
         RowBox[{"xx", "[", "3", "]"}]}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xxlo", "[", "1", "]"}], "=", 
       RowBox[{
        RowBox[{"invnew", ".", 
         RowBox[{"xx", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"sc", "[", "1", "]"}], "=", 
       RowBox[{
        SqrtBox[
         RowBox[{
          RowBox[{"xx", "[", "1", "]"}], ".", 
          RowBox[{"xxlo", "[", "1", "]"}]}]], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xlopr", "[", "1", "]"}], "=", 
       RowBox[{
        RowBox[{"invnew", ".", 
         RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"xx", "[", "1", "]"}], "/=", 
       RowBox[{"sc", "[", "1", "]"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "1", "]"}], "/=", 
       RowBox[{
        RowBox[{"sc", "[", "1", "]"}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"trxx", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"xxlo", "[", "0", "]"}], ",", 
         RowBox[{"xxlo", "[", "1", "]"}], ",", 
         RowBox[{"xxlo", "[", "2", "]"}], ",", 
         RowBox[{"xxlo", "[", "3", "]"}]}], "}"}]}], ";", 
      RowBox[{"trcoxx", "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"xx", "[", "0", "]"}], ",", 
          RowBox[{"xx", "[", "1", "]"}], ",", 
          RowBox[{"xx", "[", "2", "]"}], ",", 
          RowBox[{"xx", "[", "3", "]"}]}], "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", "tests", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{
       "\"\<Norm \!\(\*SuperscriptBox[\(u\), \
\(\[Mu]\)]\)\!\(\*SubscriptBox[\(u\), \(\[Mu]\)]\)=\>\"", ",", 
        RowBox[{"ulo", ".", "uup"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\!\(\*SubscriptBox[\(u\), \(i\)]\)=\>\"", ",", 
        RowBox[{"trxx", ".", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"u", "[", "0", "]"}], ",", 
           RowBox[{"u", "[", "1", "]"}], ",", 
           RowBox[{"u", "[", "2", "]"}], ",", 
           RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ",", 
        "\"\<;  should be {1,0,0,0}\>\""}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Co-moving \!\(\*SubscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
        RowBox[{"coB", "=", 
         RowBox[{
          RowBox[{"trxx", ".", "bup"}], "/.", "sub"}]}], ",", 
        "\"\<;  0-th component should be 0\>\""}], "]"}], ";", "\n", 
      RowBox[{"Print", "[", 
       RowBox[{
       "\"\<Back to lab frame: \!\(\*SuperscriptBox[\(b\), \(\[Mu]\)]\)=\>\"",
         ",", 
        RowBox[{"trcoxx", ".", "coB"}]}], "]"}], ";", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"rtp", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{"Norm", "[", "coB", "]"}], ",", "\[Rho]"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"cv", ",", "66", ",", "66", ",", "10"}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJwdy00ow3EAh/GZZM17JjmsJtnW2hnbQUYim9rLYWuWssaBjGm2taTWlMhh
lJfDctg0cliTuAzFiiWUsZ2Yt7wMecks0n/Z93d4+pyeSv2AsptOo9HYmaDC
3nrHfUxIXj91xIkbTjMvo1JTSxSHBBbIujKOQntsfRI2RE9cUP2nmIU9/KkF
GPeIlqHlnbsKD7RZfnimG9uEFaWMX1iubqSg574mm0++00LICD6UQd3iCBv+
fDmFMKEOE6t90x2wMc7pgk1S1TiV0bvLnIPpoVs31JoeiNuOmAfaxFtL8GKe
EYCGXivRtXfZLv9OSMwbFNFybdZDgThCZPmtfbAo75iY4hsGoSonSPQx01YY
p5fYoHgmNA7b8iPEBVlUo8i4nz7UQiZVzx7WP0toPCcx92mlCrqlLTz4Vpys
gwyjqBk6+oMyuPNRIIcB4ZobujpNXnhuCr/AVPKI+A8VEP1r
  "]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vec", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0.2", ",", 
     RowBox[{"-", "0.01"}], ",", "F"}], "}"}]}], ";", 
  RowBox[{"BFsol", "=", 
   RowBox[{
    RowBox[{"FindInstance", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"0", "\[Equal]", 
        RowBox[{"vec", ".", "invgmn", ".", "vec"}]}], "/.", "sub"}], ",", 
      RowBox[{"{", 
       RowBox[{"B", ",", "F"}], "}"}], ",", "Reals"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Vector in BL: \>\"", ",", 
   RowBox[{"kBL", "=", 
    RowBox[{"vec", "/.", "BFsol"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Vector in MKS: \>\"", ",", 
    RowBox[{"lll", "=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"iMBL", ".", "kBL"}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Del", "\[Rule]", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "2"}], "+", "r"}], ")"}], " ", "r"}]}]}], ",", 
          RowBox[{
           RowBox[{"1", "/", "x2temp"}], "\[Rule]", 
           RowBox[{"1", "/", 
            RowBox[{"(", 
             RowBox[{"\[Pi]", " ", 
              RowBox[{"(", 
               RowBox[{"h", "+", 
                RowBox[{"7", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "h"}], ")"}], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    RowBox[{"2", " ", "x2"}]}], ")"}], "6"]}]}], ")"}]}], 
             ")"}]}]}]}], "}"}]}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"R0", "\[Rule]", "0.3"}], ",", 
         RowBox[{"h", "\[Rule]", "0.65"}]}], "}"}]}], "/.", "sub"}]}]}], 
   "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Orthogonality in MKS to  \>\"", ",", 
   RowBox[{
    RowBox[{
     RowBox[{"lll", ".", "invnew", ".", "lll"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"R0", "\[Rule]", "0.3"}], ",", 
       RowBox[{"h", "\[Rule]", "0.65"}]}], "}"}]}], "/.", "sub"}]}], 
  RowBox[{"(*", 
   RowBox[{"orthogonal", " ", "to", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "5"}]]}], "*)"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Orthogonality in BL to   \>\"", ",", 
    RowBox[{
     RowBox[{"kBL", ".", "invgmn", ".", "kBL"}], "/.", "sub"}]}], 
   RowBox[{"(*", 
    RowBox[{"orthogonal", " ", "to", " ", 
     SuperscriptBox["10", 
      RowBox[{"-", "5"}]]}], "*)"}], "]"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Del", ",", "kBL", ",", "R0"}], "]"}], ";", 
  RowBox[{"expr", "=", 
   RowBox[{"iMBL", ".", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"kBL", "[", "0", "]"}], ",", 
      RowBox[{"kBL", "[", "1", "]"}], ",", 
      RowBox[{"kBL", "[", "2", "]"}], ",", 
      RowBox[{"kBL", "[", "3", "]"}]}], "}"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"expr", "==", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"iMBL", "[", 
        RowBox[{"[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], 
       RowBox[{"kBL", "[", 
        RowBox[{"j", "-", "1"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "4"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", "4"}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.4840588736236*^9, 3.4840589841808*^9}, 
   3.4840590259108*^9, {3.4840590673912*^9, 3.4840590819147997`*^9}, {
   3.484059251986*^9, 3.4840594341004*^9}, {3.4840594678900003`*^9, 
   3.4840595324896*^9}, {3.4840595656864*^9, 3.4840595911612*^9}, 
   3.4840598384368*^9, {3.4840599201496*^9, 3.4840600415332003`*^9}, {
   3.4840601290648003`*^9, 3.48406019719*^9}, {3.4840603846084003`*^9, 
   3.4840605025755997`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["New simulations ", "Subsubsection",
 CellChangeTimes->{{3.541280403898181*^9, 3.5412804069053535`*^9}, {
  3.541282119220292*^9, 3.541282120659374*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{
     "Import", "[", "\"\<E:\\\\GRMHD\\\\new\\\\a0\\\\checkmri.dat\>\"", "]"}],
      ",", "128"}], "]"}]}], ";"}], "\n", 
 RowBox[{"Dimensions", "[", "imp", "]"}], "\n", 
 RowBox[{"rtab", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", "7", ",", "1"}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Theta]tab", "=", 
  RowBox[{"imp", "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5412848839684267`*^9, 3.541284915052204*^9}, {
  3.541285013907859*^9, 3.5412850434755497`*^9}, {3.5412864423515606`*^9, 
  3.5412864468398175`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nn", "=", "180"}], ";", 
  RowBox[{"rtab", "[", 
   RowBox[{"[", "nn", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"ytab", "=", 
  RowBox[{
   RowBox[{"\[Theta]tab", "[", 
    RowBox[{"[", "nn", "]"}], "]"}], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"\[Theta]tab", "[", 
       RowBox[{"[", 
        RowBox[{"nn", ",", 
         RowBox[{"-", "1"}]}], "]"}], "]"}], "-", 
      RowBox[{"\[Theta]tab", "[", 
       RowBox[{"[", 
        RowBox[{"nn", ",", "1"}], "]"}], "]"}]}], ")"}], 
    FractionBox[
     RowBox[{"Range", "[", 
      RowBox[{"1", ",", "128"}], "]"}], "127.5"]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{"ytab", ",", 
   RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5412906572086368`*^9, 3.541290670810415*^9}, {
  3.541290705114377*^9, 3.5412907087855873`*^9}, {3.5412914701731358`*^9, 
  3.541291748352047*^9}, {3.5412917959687705`*^9, 3.5412918352930193`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", "=", "\"\<E:\\\\GRMHD\\\\new\\\\a0\\\\fieldlines\\\\\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", "=", 
      RowBox[{"dir", "<>", "\"\<fieldline9900.bin\>\""}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"fi11", "=", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", 
        RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Character8\>\"", ",", "374"}], "]"}], 
         "]"}], "]"}], ";"}], "*)"}], 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "256", "*", "128", "*", "64", "*", "4"}]}], ";", 
     "\n", "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"res2m", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"BinaryReadList", "[", 
               RowBox[{"fi11", ",", "\"\<Real32\>\"", ",", 
                RowBox[{"11", "*", "64", "*", "128", "*", "256"}]}], "]"}], 
              ",", "11"}], "]"}], ",", "256"}], "]"}], ",", "128"}], "]"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], "\n", 
 RowBox[{"read11", "[", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stt", "=", 
   RowBox[{"StringToStream", "[", "strrr", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"nx1", "=", 
     RowBox[{"Read", "[", 
      RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2"}], "}"}]}], "]"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"nx2", "=", 
     RowBox[{"Read", "[", 
      RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1"}], "}"}]}], "]"}], ";", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"nx3", "=", 
     RowBox[{"Read", "[", 
      RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1"}], "}"}]}], "]"}], ";", 
  RowBox[{"{", 
   RowBox[{"nx1", ",", "nx2", ",", "nx3"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"x1min", "=", 
     RowBox[{"Read", "[", 
      RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"dx1", "=", 
     RowBox[{"Read", "[", 
      RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"off", "=", 
     RowBox[{"Read", "[", 
      RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "6"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"h1", "=", 
     RowBox[{"Read", "[", 
      RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Close", "[", "stt", "]"}], ";", 
  RowBox[{"{", 
   RowBox[{"x1min", ",", "dx1", ",", "off", ",", "h1"}], "}"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"x1min", "=", 
   InterpretationBox[
    StyleBox["0.4220076586361168",
     ShowStringCharacters->True,
     NumberMarks->True],
    InputForm[0.4220076586361168],
    AutoDelete->True,
    Editable->True]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rtabx", "=", 
    RowBox[{"off", "+", 
     RowBox[{"Exp", "[", 
      RowBox[{"x1tab", "=", 
       RowBox[{"x1min", "+", 
        RowBox[{"dx1", " ", 
         RowBox[{"Range", "[", 
          RowBox[{"0", ",", 
           RowBox[{"nx1", "-", "1"}]}], "]"}]}]}]}], "]"}]}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"np", "=", "nx2"}], ";", 
    RowBox[{"\[Theta]tab", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"h", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "x2"}], "-", "1"}], ")"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", "h"}], ")"}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", "x2"}], "-", "1"}], ")"}], "7"]}], "+", "1"}], 
        ")"}], 
       FractionBox["\[Pi]", "2"]}], "/.", 
      RowBox[{"x2", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{"x2tab", "=", 
         RowBox[{"N", "[", 
          RowBox[{"Range", "[", 
           RowBox[{
            FractionBox["1", 
             RowBox[{"2", "np"}]], ",", 
            RowBox[{"1", "-", 
             FractionBox["1", 
              RowBox[{"2", "np"}]]}], ",", 
            FractionBox["1", "np"]}], "]"}], "]"}]}], ")"}]}]}]}], ";"}], 
   "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"read22", "[", "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"namefilexx", "=", 
        RowBox[{"dir", "<>", "\"\<usdump0000\>\""}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"fi22", "=", 
        RowBox[{"OpenRead", "[", 
         RowBox[{"namefilexx", ",", 
          RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi22", ",", "\"\<Integer32\>\""}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tt", "=", 
        RowBox[{"BinaryRead", "[", 
         RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Integer32\>\""}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x1min", ",", "x2min", ",", "x3min"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], ",", 
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], ",", 
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}]}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"dx1", ",", "dx2", ",", "dx3"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], ",", 
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], ",", 
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}]}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{"BinaryRead", "[", 
           RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "8"}], "}"}]}], "]"}], ";", 
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ress", "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"Partition", "[", 
               RowBox[{
                RowBox[{"BinaryReadList", "[", 
                 RowBox[{"fi22", ",", "\"\<Real32\>\"", ",", 
                  RowBox[{"30", "*", "32", "*", "64", "*", "256"}]}], "]"}], 
                ",", "30"}], "]"}], ",", "256"}], "]"}], ",", "64"}], "]"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}], 
       ";"}], ")"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"read22", "[", "]"}]}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.484057957027*^9, 3.4840579635478*^9}, {
   3.4840580299258003`*^9, 3.4840580302066*^9}, {3.4840580629354*^9, 
   3.4840580673658*^9}, {3.4840581043222*^9, 3.484058118565*^9}, 
   3.4840581562390003`*^9, {3.5412054141272097`*^9, 3.5412054143672237`*^9}, {
   3.5412804537450323`*^9, 3.5412804770503654`*^9}, {3.5412805166566305`*^9, 
   3.5412805402109776`*^9}, {3.5412806081628647`*^9, 3.54128062049957*^9}, {
   3.541280780759736*^9, 3.541280814546669*^9}, {3.541280852925864*^9, 
   3.5412808570030975`*^9}, {3.54128088817288*^9, 3.5412808932901726`*^9}, {
   3.5412809397648306`*^9, 3.5412809616520824`*^9}, {3.541281150334875*^9, 
   3.541281175971341*^9}, {3.541281484919012*^9, 3.5412814897492886`*^9}, {
   3.5412822380120864`*^9, 3.541282241767301*^9}, {3.541282337813795*^9, 
   3.5412823873586283`*^9}, {3.5412824786348495`*^9, 
   3.5412824795269003`*^9}, {3.54128254823783*^9, 3.54128255085198*^9}, {
   3.541282693753153*^9, 3.5412826954362497`*^9}, {3.541282730423251*^9, 
   3.541282730778271*^9}, 3.5412829200050945`*^9, {3.541285210466101*^9, 
   3.5412852128692384`*^9}, {3.541286323992791*^9, 3.541286325093854*^9}, {
   3.5412863773148413`*^9, 3.5412863790899425`*^9}, {3.541286424837559*^9, 
   3.541286426091631*^9}, {3.5412866677724543`*^9, 3.541286669399547*^9}, {
   3.5412896268827057`*^9, 3.5412896409165087`*^9}, {3.5412899090918474`*^9, 
   3.5412899123330326`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[CapitalDelta]", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "-", 
    RowBox[{"2", "r"}], "+", 
    SuperscriptBox["a", "2"]}]}], ";", 
  RowBox[{"\[Rho]sq", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "+", 
    RowBox[{
     SuperscriptBox["a", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}]}], ";", 
  RowBox[{"\[CapitalSigma]sq", "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["r", "2"], "+", 
       SuperscriptBox["a", "2"]}], ")"}], "2"], "-", 
    RowBox[{
     SuperscriptBox["a", "2"], "\[CapitalDelta]", " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"gmn", "=", 
    RowBox[{"-", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         FractionBox["\[CapitalSigma]sq", 
          RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
         ",", 
         FractionBox[
          RowBox[{"2", "a", " ", "r"}], 
          RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", 
          FractionBox["\[CapitalDelta]", "\[Rho]sq"]}], ",", "0", ",", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[Rho]sq", 
           RowBox[{"-", "1"}]]}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{"2", "a", " ", "r"}], 
          RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
         ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"(", 
            RowBox[{"\[CapitalDelta]", "-", 
             RowBox[{
              SuperscriptBox["a", "2"], 
              SuperscriptBox[
               RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]]}]}], "}"}]}], 
      "}"}]}]}], ")"}], "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"invgmn", "=", 
    RowBox[{"FullSimplify", "[", 
     RowBox[{
      RowBox[{"Inverse", "[", "gmn", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"r", ">", "0"}], "}"}]}], "]"}]}], ")"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"x", "[", "1", "]"}], "=", "t"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "2", "]"}], "=", "r"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "3", "]"}], "=", "\[Theta]"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "4", "]"}], "=", "\[Phi]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"G", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], "=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"gmn", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "m"}], "]"}], "]"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"invgmn", "[", 
           RowBox[{"[", 
            RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"x", "[", "1", "]"}]}], "]"}], "+", 
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"invgmn", "[", 
           RowBox[{"[", 
            RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"x", "[", "1", "]"}]}], "]"}], "-", 
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"invgmn", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"G", "[", 
      RowBox[{"i", ",", "k", ",", "l"}], "]"}], "=", 
     RowBox[{"Simplify", "[", 
      RowBox[{
       FractionBox["1", "2"], 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"gmn", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "m"}], "]"}], "]"}], "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"invgmn", "[", 
               RowBox[{"[", 
                RowBox[{"m", ",", "k"}], "]"}], "]"}], ",", 
              RowBox[{"x", "[", "l", "]"}]}], "]"}], "+", 
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"invgmn", "[", 
               RowBox[{"[", 
                RowBox[{"m", ",", "l"}], "]"}], "]"}], ",", 
              RowBox[{"x", "[", "k", "]"}]}], "]"}], "-", 
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"invgmn", "[", 
               RowBox[{"[", 
                RowBox[{"k", ",", "l"}], "]"}], "]"}], ",", 
              RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "1", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"l", ",", "1", ",", "4"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gmn", "=", 
   RowBox[{"Simplify", "[", "gmn", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"invgmn", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"invgmn", "/.", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"2", "\[Theta]"}], "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"2", 
        SuperscriptBox[
         RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "-", "1"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"invgmnKS", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", 
        FractionBox[
         RowBox[{"2", "r"}], "\[Rho]sq"], ",", "0", ",", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "a", " ", "r", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}]}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        FractionBox[
         RowBox[{"2", "r"}], "\[Rho]sq"], ",", 
        RowBox[{"1", "+", 
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", "0", ",", 
        RowBox[{
         RowBox[{"-", "a"}], 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "\[Rho]sq", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "a", " ", "r", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}], ",", 
        RowBox[{
         RowBox[{"-", "a"}], 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], ",", "0", ",", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
         RowBox[{"(", 
          RowBox[{"\[Rho]sq", "+", 
           RowBox[{
            SuperscriptBox["a", "2"], 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              FractionBox[
               RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}]}]}], 
       "}"}]}], "}"}]}], ")"}], "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Anumu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{"2", "r"}], "\[CapitalDelta]"], ",", "1", ",", "0", ",", 
       FractionBox["a", "\[CapitalDelta]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AMKS", "=", 
   RowBox[{"DiagonalMatrix", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      FractionBox["1", 
       RowBox[{"r", "-", "R0"}]], ",", 
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{"h", "+", 
           RowBox[{"7", 
            RowBox[{"(", 
             RowBox[{"1", "-", "h"}], ")"}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", "x2"}], "-", "1"}], ")"}], "6"]}]}], ")"}]}], 
        ")"}]}], ",", 
      RowBox[{"1", "/", "\[Pi]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"invnew", "=", 
   RowBox[{
    RowBox[{"Inverse", "[", "AMKS", "]"}], ".", "invgmnKS", ".", 
    RowBox[{"Inverse", "[", "AMKS", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"invAnumu", "=", 
    RowBox[{"FullSimplify", "[", 
     RowBox[{"gmn", ".", "Anumu", ".", "invgmnKS"}], "]"}]}], ")"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"iMBL", "=", 
    RowBox[{
     RowBox[{"AMKS", ".", 
      RowBox[{"Inverse", "[", "invAnumu", "]"}]}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         SuperscriptBox["a", "2"], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "2"}], "+", "r"}], ")"}], " ", "r"}]}], "\[Rule]", 
        "Del"}], ",", 
       RowBox[{
        RowBox[{"1", "/", 
         RowBox[{"(", 
          RowBox[{"\[Pi]", " ", 
           RowBox[{"(", 
            RowBox[{"h", "+", 
             RowBox[{"7", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", "h"}], ")"}], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "1"}], "+", 
                 RowBox[{"2", " ", "x2"}]}], ")"}], "6"]}]}], ")"}]}], 
          ")"}]}], "\[Rule]", 
        RowBox[{"1", "/", "x2temp"}]}]}], "}"}]}]}], ")"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Anumu", "//", 
       RowBox[{"MatrixForm", "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{"invAnumu", "=", 
          RowBox[{"FullSimplify", "[", 
           RowBox[{"gmn", ".", "Anumu", ".", "invgmnKS"}], "]"}]}], ")"}]}]}],
       "//", 
      RowBox[{"MatrixForm", "\[IndentingNewLine]", 
       RowBox[{"Inverse", "[", "invAnumu", "]"}]}]}], "//", 
     RowBox[{"MatrixForm", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Inverse", "[", "invAnumu", "]"}], ".", "invAnumu"}]}]}], "//",
     "MatrixForm"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.4626330585179996`*^9, 3.462633106061*^9}, {
   3.462633200225*^9, 3.4626332373120003`*^9}, {3.462633273317*^9, 
   3.462633278652*^9}, {3.4626334330220003`*^9, 3.462633536664*^9}, {
   3.462633586236*^9, 3.462633660715*^9}, {3.462635287076*^9, 
   3.462635305646*^9}, {3.4626355485889997`*^9, 3.462635576118*^9}, {
   3.4626356357019997`*^9, 3.462635639954*^9}, {3.462635761001*^9, 
   3.462635913634*^9}, {3.462635986321*^9, 3.462636006325*^9}, {
   3.462636051492*^9, 3.4626360721210003`*^9}, {3.462636278928*^9, 
   3.462636293153*^9}, {3.462636395936*^9, 3.462636409736*^9}, {
   3.462636547731*^9, 3.4626365525769997`*^9}, 3.462636780659*^9, 
   3.462637584486*^9, {3.4626376989709997`*^9, 3.462637700028*^9}, 
   3.462637849402*^9, {3.46263823645*^9, 3.462638236615*^9}, {
   3.4626383039519997`*^9, 3.462638305049*^9}, {3.462638359123*^9, 
   3.4626383635480003`*^9}, {3.4626385617869997`*^9, 3.462638578455*^9}, {
   3.462638881075*^9, 3.4626389075369997`*^9}, {3.4626390873310003`*^9, 
   3.462639096484*^9}, {3.462644193078*^9, 3.462644217727*^9}, 
   3.4626443531809998`*^9, {3.462704235408*^9, 3.462704264086*^9}, {
   3.4740342972869997`*^9, 3.474034311618*^9}, {3.474036129392*^9, 
   3.474036141512*^9}, {3.474036184262*^9, 3.474036185574*^9}, {
   3.474036255237*^9, 3.474036314354*^9}, {3.474036347196*^9, 
   3.474036401833*^9}, {3.474036443409*^9, 3.4740365891470003`*^9}, {
   3.474055368087*^9, 3.474055472965*^9}, {3.474055541039*^9, 
   3.474055562652*^9}, {3.474055719885*^9, 3.4740557261940002`*^9}, {
   3.474055823498*^9, 3.474055840946*^9}, {3.474056932632*^9, 
   3.4740569785030003`*^9}, {3.4740570994*^9, 3.474057144969*^9}, {
   3.474057341248*^9, 3.4740573636210003`*^9}, {3.474059438028*^9, 
   3.474059442311*^9}, {3.4747543964820004`*^9, 3.474754403494*^9}, {
   3.474898024192319*^9, 3.4748980469371195`*^9}, {3.474904322239919*^9, 
   3.474904332598319*^9}, {3.474908775447119*^9, 3.474908780782319*^9}, {
   3.484059672796*^9, 3.4840596747148*^9}, 3.4840598974516*^9, {
   3.4840602350824003`*^9, 3.484060312084*^9}, {3.541281935403778*^9, 
   3.541281957946068*^9}, 3.545402263349027*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"i1", ",", "i2", ",", "i3"}], "}"}], "=", 
    RowBox[{"{", 
     RowBox[{"25", ",", "23", ",", "21"}], "}"}]}], "]"}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"ext", "=", 
     RowBox[{"ress", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}], "]"}]}], ";"}], "*)"}], 
  RowBox[{"fie", "=", 
   RowBox[{"res2m", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"uup", "=", 
  RowBox[{"Flatten", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"fie", "[", 
      RowBox[{"[", "5", "]"}], "]"}], ",", 
     RowBox[{
      RowBox[{"fie", "[", 
       RowBox[{"[", "5", "]"}], "]"}], 
      RowBox[{"fie", "[", 
       RowBox[{"[", 
        RowBox[{"6", ";;", "8"}], "]"}], "]"}]}]}], "}"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"sub", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"r", "\[Rule]", 
     RowBox[{"rtab", "[", 
      RowBox[{"[", "i1", "]"}], "]"}]}], ",", 
    RowBox[{"\[Theta]", "\[Rule]", 
     RowBox[{"\[Theta]tab", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2"}], "]"}], "]"}]}], ",", 
    RowBox[{"a", "\[Rule]", "0."}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"ulo", "=", 
  RowBox[{
   RowBox[{"invgmnKS", ".", "uup"}], "/.", "sub"}]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Norm \!\(\*SuperscriptBox[\(u\), \(\[Mu]\)]\)\!\(\*SubscriptBox[\(u\), \
\(\[Mu]\)]\)=\>\"", ",", 
   RowBox[{"ulo", ".", "uup"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.541286514135667*^9, 3.5412866395988426`*^9}, {
  3.541286785035161*^9, 3.541286802834179*^9}, {3.5412869200128813`*^9, 
  3.5412869246061444`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"R0", "=", "off"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tadd", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"i1", ",", "i2", ",", "i3"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{"cv", ",", "45", ",", "21"}], "}"}]}], "]"}], ";", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"ext", "=", 
         RowBox[{"ress", "[", 
          RowBox[{"[", 
           RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}], "]"}]}], ";"}], 
       "*)"}], 
      RowBox[{"fie", "=", 
       RowBox[{"res2m", "[", 
        RowBox[{"[", 
         RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}], "]"}]}], ";", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Coord (x1,x2): \>\"", " ", ",", 
        RowBox[{"xxx", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x1tab", "[", 
            RowBox[{"[", "i1", "]"}], "]"}], ",", 
           RowBox[{"x2tab", "[", 
            RowBox[{"[", "i2", "]"}], "]"}]}], "}"}]}], ",", 
        "\"\<; (r,\[Theta]): \>\"", ",", " ", 
        RowBox[{"rtp", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"rtab", "[", 
            RowBox[{"[", "i1", "]"}], "]"}], ",", 
           RowBox[{"\[Theta]tab", "[", 
            RowBox[{"[", "i2", "]"}], "]"}]}], "}"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"sub", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"r", "\[Rule]", 
          RowBox[{"rtp", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], ",", 
         RowBox[{"x1", "\[Rule]", 
          RowBox[{"xxx", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], ",", 
         RowBox[{"\[Theta]", "\[Rule]", 
          RowBox[{"rtp", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", 
         RowBox[{"x2", "\[Rule]", 
          RowBox[{"xxx", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", 
         RowBox[{"a", "\[Rule]", "0.9"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\[Rho]=\>\"", ",", " ", 
        RowBox[{"\[Rho]", "=", 
         RowBox[{"fie", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ",", "\"\<; U=\>\"", ",", 
        RowBox[{"U", "=", 
         RowBox[{"fie", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\!\(\*SuperscriptBox[\(u\), \(\[Mu]\)]\)=\>\"", ",", 
        RowBox[{"uup", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"fie", "[", 
             RowBox[{"[", "5", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"fie", "[", 
              RowBox[{"[", "5", "]"}], "]"}], 
             RowBox[{"fie", "[", 
              RowBox[{"[", 
               RowBox[{"6", ";;", "8"}], "]"}], "]"}]}]}], "}"}], "]"}]}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"ulo", "=", 
       RowBox[{
        RowBox[{"invnew", ".", "uup"}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Lab \!\(\*SuperscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
        RowBox[{"bi", "=", 
         RowBox[{"fie", "[", 
          RowBox[{"[", 
           RowBox[{"9", ";;", "11"}], "]"}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\!\(\*SuperscriptBox[\(b\), \(\[Mu]\)]\)=\>\"", ",", 
        RowBox[{"bup", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"bi", ".", 
             RowBox[{"ulo", "[", 
              RowBox[{"[", 
               RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], ",", 
            FractionBox[
             RowBox[{"bi", "+", 
              RowBox[{
               RowBox[{"bi", ".", 
                RowBox[{"ulo", "[", 
                 RowBox[{"[", 
                  RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], 
               RowBox[{"uup", "[", 
                RowBox[{"[", 
                 RowBox[{"2", ";;", "4"}], "]"}], "]"}]}]}], 
             RowBox[{"uup", "[", 
              RowBox[{"[", "1", "]"}], "]"}]]}], "}"}], "]"}]}]}], "]"}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"MKS", "\[Rule]", "FFFF"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"u", "[", "0", "]"}], ",", 
          RowBox[{"u", "[", "1", "]"}], ",", 
          RowBox[{"u", "[", "2", "]"}], ",", 
          RowBox[{"u", "[", "3", "]"}]}], "}"}], "=", "uup"}], "]"}], ";", 
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"uco", "[", "0", "]"}], ",", 
          RowBox[{"uco", "[", "1", "]"}], ",", 
          RowBox[{"uco", "[", "2", "]"}], ",", 
          RowBox[{"uco", "[", "3", "]"}]}], "}"}], "=", "ulo"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xx", "[", "0", "]"}], "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"u", "[", "0", "]"}], ",", 
         RowBox[{"u", "[", "1", "]"}], ",", 
         RowBox[{"u", "[", "2", "]"}], ",", 
         RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "0", "]"}], "=", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"invnew", ".", 
          RowBox[{"xx", "[", "0", "]"}]}]}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xx", "[", "2", "]"}], "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"uco", "[", "2", "]"}], 
          RowBox[{"u", "[", "0", "]"}]}], ",", 
         RowBox[{
          RowBox[{"uco", "[", "2", "]"}], 
          RowBox[{"u", "[", "1", "]"}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"uco", "[", "2", "]"}], 
           RowBox[{"u", "[", "2", "]"}]}], "+", "1"}], ",", 
         RowBox[{
          RowBox[{"uco", "[", "2", "]"}], 
          RowBox[{"u", "[", "3", "]"}]}]}], "}"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "2", "]"}], "=", 
       RowBox[{
        RowBox[{"invnew", ".", 
         RowBox[{"xx", "[", "2", "]"}]}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xx", "[", "3", "]"}], "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"uco", "[", "3", "]"}], 
           RowBox[{"uco", "[", "0", "]"}]]}], ",", "0", ",", "0", ",", "1"}], 
        "}"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "3", "]"}], "=", 
       RowBox[{
        RowBox[{"invnew", ".", 
         RowBox[{"xx", "[", "3", "]"}]}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"sc", "[", "0", "]"}], "=", 
       RowBox[{
        SqrtBox[
         RowBox[{
          RowBox[{"xx", "[", "0", "]"}], ".", 
          RowBox[{"xxlo", "[", "0", "]"}]}]], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"sc", "[", "3", "]"}], "=", 
       RowBox[{
        SqrtBox[
         RowBox[{
          RowBox[{"xx", "[", "3", "]"}], ".", 
          RowBox[{"xxlo", "[", "3", "]"}]}]], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"sc", "[", "2", "]"}], "=", 
       RowBox[{
        SqrtBox[
         RowBox[{
          RowBox[{"xx", "[", "2", "]"}], ".", 
          RowBox[{"xxlo", "[", "2", "]"}]}]], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xx", "[", "0", "]"}], "/=", 
       RowBox[{"sc", "[", "0", "]"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "0", "]"}], "/=", 
       RowBox[{
        RowBox[{"sc", "[", "0", "]"}], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"xx", "[", "2", "]"}], "/=", 
       RowBox[{"sc", "[", "2", "]"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "2", "]"}], "/=", 
       RowBox[{
        RowBox[{"sc", "[", "2", "]"}], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"xx", "[", "3", "]"}], "/=", 
       RowBox[{"sc", "[", "3", "]"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "3", "]"}], "/=", 
       RowBox[{
        RowBox[{"sc", "[", "3", "]"}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xpr", "[", "1", "]"}], "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"u", "[", "0", "]"}], 
           RowBox[{"uco", "[", "1", "]"}]}], " ", ",", 
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"u", "[", "0", "]"}], 
              RowBox[{"uco", "[", "0", "]"}]}], "+", 
             RowBox[{
              RowBox[{"u", "[", "3", "]"}], 
              RowBox[{"uco", "[", "3", "]"}]}]}], ")"}]}], ",", "0", ",", 
          RowBox[{
           RowBox[{"u", "[", "3", "]"}], 
           RowBox[{"uco", "[", "1", "]"}]}]}], "}"}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xlopr", "[", "1", "]"}], "=", 
       RowBox[{
        RowBox[{"invnew", ".", 
         RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"xx", "[", "1", "]"}], "=", 
       RowBox[{
        RowBox[{"xpr", "[", "1", "]"}], "-", 
        RowBox[{
         RowBox[{
          RowBox[{"xlopr", "[", "1", "]"}], ".", 
          RowBox[{"xx", "[", "3", "]"}]}], "*", 
         RowBox[{"xx", "[", "3", "]"}]}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xxlo", "[", "1", "]"}], "=", 
       RowBox[{
        RowBox[{"invnew", ".", 
         RowBox[{"xx", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"sc", "[", "1", "]"}], "=", 
       RowBox[{
        SqrtBox[
         RowBox[{
          RowBox[{"xx", "[", "1", "]"}], ".", 
          RowBox[{"xxlo", "[", "1", "]"}]}]], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xlopr", "[", "1", "]"}], "=", 
       RowBox[{
        RowBox[{"invnew", ".", 
         RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"xx", "[", "1", "]"}], "/=", 
       RowBox[{"sc", "[", "1", "]"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "1", "]"}], "/=", 
       RowBox[{
        RowBox[{"sc", "[", "1", "]"}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"trxx", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"xxlo", "[", "0", "]"}], ",", 
         RowBox[{"xxlo", "[", "1", "]"}], ",", 
         RowBox[{"xxlo", "[", "2", "]"}], ",", 
         RowBox[{"xxlo", "[", "3", "]"}]}], "}"}]}], ";", 
      RowBox[{"trcoxx", "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"xx", "[", "0", "]"}], ",", 
          RowBox[{"xx", "[", "1", "]"}], ",", 
          RowBox[{"xx", "[", "2", "]"}], ",", 
          RowBox[{"xx", "[", "3", "]"}]}], "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", "tests", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{
       "\"\<Norm \!\(\*SuperscriptBox[\(u\), \
\(\[Mu]\)]\)\!\(\*SubscriptBox[\(u\), \(\[Mu]\)]\)=\>\"", ",", 
        RowBox[{"ulo", ".", "uup"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\!\(\*SubscriptBox[\(u\), \(i\)]\)=\>\"", ",", 
        RowBox[{"trxx", ".", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"u", "[", "0", "]"}], ",", 
           RowBox[{"u", "[", "1", "]"}], ",", 
           RowBox[{"u", "[", "2", "]"}], ",", 
           RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ",", 
        "\"\<;  should be {1,0,0,0}\>\""}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Co-moving \!\(\*SubscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
        RowBox[{"coB", "=", 
         RowBox[{
          RowBox[{"trxx", ".", "bup"}], "/.", "sub"}]}], ",", 
        "\"\<;  0-th component should be 0\>\""}], "]"}], ";", "\n", 
      RowBox[{"Print", "[", 
       RowBox[{
       "\"\<Back to lab frame: \!\(\*SuperscriptBox[\(b\), \(\[Mu]\)]\)=\>\"",
         ",", 
        RowBox[{"trcoxx", ".", "coB"}]}], "]"}], ";", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"rtp", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{"Norm", "[", "coB", "]"}], ",", "\[Rho]"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"cv", ",", "45", ",", "45", ",", "10"}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.476633370264931*^9, 3.4766333709045315`*^9}, {
   3.476634153027531*^9, 3.4766341537295313`*^9}, {3.4766345453363314`*^9, 
   3.476634611464731*^9}, {3.476634709619931*^9, 3.4766347584635315`*^9}, {
   3.476634794561931*^9, 3.4766348203799314`*^9}, {3.4766349378011312`*^9, 
   3.476634961216731*^9}, {3.476634992042331*^9, 3.476635060136331*^9}, {
   3.4766355922523313`*^9, 3.476635626073131*^9}, {3.4766356737155313`*^9, 
   3.4766357665511312`*^9}, {3.476635823210331*^9, 3.476635883894331*^9}, {
   3.4766360041235313`*^9, 3.476636006260731*^9}, {3.4766363805515313`*^9, 
   3.476636425027131*^9}, {3.477072954602937*^9, 3.4770730723361373`*^9}, {
   3.477073127076537*^9, 3.477073127201337*^9}, {3.477073174703337*^9, 
   3.4770731898821373`*^9}, {3.4770732802685375`*^9, 3.477073283731737*^9}, {
   3.4840582229300003`*^9, 3.4840582239284*^9}, {3.4840583876524*^9, 
   3.4840583905696*^9}, {3.48405845974*^9, 3.4840584624076*^9}, {
   3.48405849913*^9, 3.4840585018444*^9}, {3.4840585599388*^9, 
   3.4840585605316*^9}, {3.4840586861116*^9, 3.484058686564*^9}, {
   3.4840603586656*^9, 3.4840603743436003`*^9}, {3.5412810019683886`*^9, 
   3.5412810040985107`*^9}, {3.5412810532783237`*^9, 
   3.5412810822279797`*^9}, {3.5412812236270666`*^9, 
   3.5412813217946815`*^9}, {3.541281381857117*^9, 3.5412814084356375`*^9}, {
   3.541282021536705*^9, 3.5412820755427933`*^9}, {3.5412822484196815`*^9, 
   3.5412822490987206`*^9}, {3.5412824513802905`*^9, 3.541282474188595*^9}, {
   3.5412825710261335`*^9, 3.5412826127305193`*^9}, 3.541282706773898*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vec", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0.2", ",", 
     RowBox[{"-", "0.01"}], ",", "F"}], "}"}]}], ";", 
  RowBox[{"BFsol", "=", 
   RowBox[{
    RowBox[{"FindInstance", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"0", "\[Equal]", 
        RowBox[{"vec", ".", "invgmn", ".", "vec"}]}], "/.", "sub"}], ",", 
      RowBox[{"{", 
       RowBox[{"B", ",", "F"}], "}"}], ",", "Reals"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Vector in BL: \>\"", ",", 
   RowBox[{"kBL", "=", 
    RowBox[{"vec", "/.", "BFsol"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Vector in MKS: \>\"", ",", 
    RowBox[{"lll", "=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"iMBL", ".", "kBL"}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Del", "\[Rule]", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "2"}], "+", "r"}], ")"}], " ", "r"}]}]}], ",", 
          RowBox[{
           RowBox[{"1", "/", "x2temp"}], "\[Rule]", 
           RowBox[{"1", "/", 
            RowBox[{"(", 
             RowBox[{"\[Pi]", " ", 
              RowBox[{"(", 
               RowBox[{"h", "+", 
                RowBox[{"7", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "h"}], ")"}], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    RowBox[{"2", " ", "x2"}]}], ")"}], "6"]}]}], ")"}]}], 
             ")"}]}]}]}], "}"}]}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"R0", "\[Rule]", "0.3"}], ",", 
         RowBox[{"h", "\[Rule]", "0.65"}]}], "}"}]}], "/.", "sub"}]}]}], 
   "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Orthogonality in MKS to  \>\"", ",", 
   RowBox[{
    RowBox[{
     RowBox[{"lll", ".", "invnew", ".", "lll"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"R0", "\[Rule]", "0.3"}], ",", 
       RowBox[{"h", "\[Rule]", "0.65"}]}], "}"}]}], "/.", "sub"}]}], 
  RowBox[{"(*", 
   RowBox[{"orthogonal", " ", "to", " ", 
    SuperscriptBox["10", 
     RowBox[{"-", "5"}]]}], "*)"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Orthogonality in BL to   \>\"", ",", 
    RowBox[{
     RowBox[{"kBL", ".", "invgmn", ".", "kBL"}], "/.", "sub"}]}], 
   RowBox[{"(*", 
    RowBox[{"orthogonal", " ", "to", " ", 
     SuperscriptBox["10", 
      RowBox[{"-", "5"}]]}], "*)"}], "]"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Del", ",", "kBL", ",", "R0"}], "]"}], ";", 
  RowBox[{"expr", "=", 
   RowBox[{"iMBL", ".", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"kBL", "[", "0", "]"}], ",", 
      RowBox[{"kBL", "[", "1", "]"}], ",", 
      RowBox[{"kBL", "[", "2", "]"}], ",", 
      RowBox[{"kBL", "[", "3", "]"}]}], "}"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"expr", "==", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"iMBL", "[", 
        RowBox[{"[", 
         RowBox[{"m", ",", "j"}], "]"}], "]"}], 
       RowBox[{"kBL", "[", 
        RowBox[{"j", "-", "1"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "4"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", "4"}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.4840588736236*^9, 3.4840589841808*^9}, 
   3.4840590259108*^9, {3.4840590673912*^9, 3.4840590819147997`*^9}, {
   3.484059251986*^9, 3.4840594341004*^9}, {3.4840594678900003`*^9, 
   3.4840595324896*^9}, {3.4840595656864*^9, 3.4840595911612*^9}, 
   3.4840598384368*^9, {3.4840599201496*^9, 3.4840600415332003`*^9}, {
   3.4840601290648003`*^9, 3.48406019719*^9}, {3.4840603846084003`*^9, 
   3.4840605025755997`*^9}}]
}, Open  ]]
}, Closed]],

Cell["Shift of e1 by k due to Lorenz gauge", "Subsection",
 CellChangeTimes->{{3.4840612076956*^9, 3.48406120885*^9}}],

Cell[CellGroupData[{

Cell["\<\
Transformation matrix to locally-flat co-moving frame from MKS\
\>", "Subsection",
 CellChangeTimes->{{3.4840616366800003`*^9, 3.4840616377720003`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", "=", "\"\<G:\\\\GRMHD\\\\a07\\\\fieldlines\\\\\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", "=", 
      RowBox[{"dir", "<>", "\"\<fieldline0000.bin\>\""}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"fi11", "=", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", 
        RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Character8\>\"", ",", "374"}], "]"}], 
         "]"}], "]"}], ";"}], "*)"}], 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "256", "*", "64", "*", "32", "*", "4"}]}], ";", "\n",
      "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"res2m", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"BinaryReadList", "[", 
               RowBox[{"fi11", ",", "\"\<Real32\>\"", ",", 
                RowBox[{"11", "*", "32", "*", "64", "*", "256"}]}], "]"}], 
              ",", "11"}], "]"}], ",", "256"}], "]"}], ",", "64"}], "]"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read22", "[", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefilexx", "=", 
      RowBox[{"dir", "<>", "\"\<usdump0000\>\""}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"fi22", "=", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefilexx", ",", 
        RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", "\n", 
     RowBox[{"BinaryRead", "[", 
      RowBox[{"fi22", ",", "\"\<Integer32\>\""}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"tt", "=", 
      RowBox[{"BinaryRead", "[", 
       RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"BinaryRead", "[", 
         RowBox[{"fi22", ",", "\"\<Integer32\>\""}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "3"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x1min", ",", "x2min", ",", "x3min"}], "}"}], "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"BinaryRead", "[", 
         RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], ",", 
        RowBox[{"BinaryRead", "[", 
         RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], ",", 
        RowBox[{"BinaryRead", "[", 
         RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"dx1", ",", "dx2", ",", "dx3"}], "}"}], "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"BinaryRead", "[", 
         RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], ",", 
        RowBox[{"BinaryRead", "[", 
         RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], ",", 
        RowBox[{"BinaryRead", "[", 
         RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"BinaryRead", "[", 
         RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "8"}], "}"}]}], "]"}], ";", 
     RowBox[{"BinaryRead", "[", 
      RowBox[{"fi22", ",", "\"\<Real32\>\""}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ress", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"BinaryReadList", "[", 
               RowBox[{"fi22", ",", "\"\<Real32\>\"", ",", 
                RowBox[{"30", "*", "32", "*", "64", "*", "256"}]}], "]"}], 
              ",", "30"}], "]"}], ",", "256"}], "]"}], ",", "64"}], "]"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";"}],
     ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"read11", "[", "]"}], "\[IndentingNewLine]", 
 RowBox[{"read22", "[", "]"}]}], "Input",
 CellChangeTimes->{{3.484057957027*^9, 3.4840579635478*^9}, {
   3.4840580299258003`*^9, 3.4840580302066*^9}, {3.4840580629354*^9, 
   3.4840580673658*^9}, {3.4840581043222*^9, 3.484058118565*^9}, 
   3.4840581562390003`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[CapitalDelta]", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "-", 
    RowBox[{"2", "r"}], "+", 
    SuperscriptBox["a", "2"]}]}], ";", 
  RowBox[{"\[Rho]sq", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "+", 
    RowBox[{
     SuperscriptBox["a", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}]}], ";", 
  RowBox[{"\[CapitalSigma]sq", "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["r", "2"], "+", 
       SuperscriptBox["a", "2"]}], ")"}], "2"], "-", 
    RowBox[{
     SuperscriptBox["a", "2"], "\[CapitalDelta]", " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"gmn", "=", 
    RowBox[{"-", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         FractionBox["\[CapitalSigma]sq", 
          RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
         ",", 
         FractionBox[
          RowBox[{"2", "a", " ", "r"}], 
          RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", 
          FractionBox["\[CapitalDelta]", "\[Rho]sq"]}], ",", "0", ",", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", 
         RowBox[{"-", 
          SuperscriptBox["\[Rho]sq", 
           RowBox[{"-", "1"}]]}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{"2", "a", " ", "r"}], 
          RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
         ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"(", 
            RowBox[{"\[CapitalDelta]", "-", 
             RowBox[{
              SuperscriptBox["a", "2"], 
              SuperscriptBox[
               RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]]}]}], "}"}]}], 
      "}"}]}]}], ")"}], "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"invgmn", "=", 
    RowBox[{"FullSimplify", "[", 
     RowBox[{
      RowBox[{"Inverse", "[", "gmn", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"r", ">", "0"}], "}"}]}], "]"}]}], ")"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"x", "[", "1", "]"}], "=", "t"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "2", "]"}], "=", "r"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "3", "]"}], "=", "\[Theta]"}], ";", 
  RowBox[{
   RowBox[{"x", "[", "4", "]"}], "=", "\[Phi]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"G", "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], "=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"gmn", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "m"}], "]"}], "]"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"invgmn", "[", 
           RowBox[{"[", 
            RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"x", "[", "1", "]"}]}], "]"}], "+", 
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"invgmn", "[", 
           RowBox[{"[", 
            RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"x", "[", "1", "]"}]}], "]"}], "-", 
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"invgmn", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
          RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"G", "[", 
      RowBox[{"i", ",", "k", ",", "l"}], "]"}], "=", 
     RowBox[{"Simplify", "[", 
      RowBox[{
       FractionBox["1", "2"], 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"gmn", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "m"}], "]"}], "]"}], "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"invgmn", "[", 
               RowBox[{"[", 
                RowBox[{"m", ",", "k"}], "]"}], "]"}], ",", 
              RowBox[{"x", "[", "l", "]"}]}], "]"}], "+", 
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"invgmn", "[", 
               RowBox[{"[", 
                RowBox[{"m", ",", "l"}], "]"}], "]"}], ",", 
              RowBox[{"x", "[", "k", "]"}]}], "]"}], "-", 
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"invgmn", "[", 
               RowBox[{"[", 
                RowBox[{"k", ",", "l"}], "]"}], "]"}], ",", 
              RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "1", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"l", ",", "1", ",", "4"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gmn", "=", 
   RowBox[{"Simplify", "[", "gmn", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"invgmn", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"invgmn", "/.", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"2", "\[Theta]"}], "]"}], "\[Rule]", 
      RowBox[{
       RowBox[{"2", 
        SuperscriptBox[
         RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "-", "1"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"invgmnKS", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", 
        FractionBox[
         RowBox[{"2", "r"}], "\[Rho]sq"], ",", "0", ",", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "a", " ", "r", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}]}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        FractionBox[
         RowBox[{"2", "r"}], "\[Rho]sq"], ",", 
        RowBox[{"1", "+", 
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", "0", ",", 
        RowBox[{
         RowBox[{"-", "a"}], 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "\[Rho]sq", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "a", " ", "r", " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}], ",", 
        RowBox[{
         RowBox[{"-", "a"}], 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], ",", "0", ",", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
         RowBox[{"(", 
          RowBox[{"\[Rho]sq", "+", 
           RowBox[{
            SuperscriptBox["a", "2"], 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              FractionBox[
               RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}]}]}], 
       "}"}]}], "}"}]}], ")"}], "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Anumu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        RowBox[{"2", "r"}], "\[CapitalDelta]"], ",", "1", ",", "0", ",", 
       FractionBox["a", "\[CapitalDelta]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AMKS", "=", 
   RowBox[{"DiagonalMatrix", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      FractionBox["1", 
       RowBox[{"r", "-", "R0"}]], ",", 
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{"h", "+", 
           RowBox[{"7", 
            RowBox[{"(", 
             RowBox[{"1", "-", "h"}], ")"}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", "x2"}], "-", "1"}], ")"}], "6"]}]}], ")"}]}], 
        ")"}]}], ",", 
      RowBox[{"1", "/", "\[Pi]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"invnew", "=", 
   RowBox[{
    RowBox[{"Inverse", "[", "AMKS", "]"}], ".", "invgmnKS", ".", 
    RowBox[{"Inverse", "[", "AMKS", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invAnumu", "=", 
     RowBox[{"FullSimplify", "[", 
      RowBox[{"gmn", ".", "Anumu", ".", "invgmnKS"}], "]"}]}], ")"}], "//", 
   "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"iMBL", "=", 
    RowBox[{
     RowBox[{"AMKS", ".", 
      RowBox[{"Inverse", "[", "invAnumu", "]"}]}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         SuperscriptBox["a", "2"], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "2"}], "+", "r"}], ")"}], " ", "r"}]}], "\[Rule]", 
        "Del"}], ",", 
       RowBox[{
        RowBox[{"1", "/", 
         RowBox[{"(", 
          RowBox[{"\[Pi]", " ", 
           RowBox[{"(", 
            RowBox[{"h", "+", 
             RowBox[{"7", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", "h"}], ")"}], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "1"}], "+", 
                 RowBox[{"2", " ", "x2"}]}], ")"}], "6"]}]}], ")"}]}], 
          ")"}]}], "\[Rule]", 
        RowBox[{"1", "/", "x2temp"}]}]}], "}"}]}]}], ")"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Anumu", "//", 
       RowBox[{"MatrixForm", "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{"invAnumu", "=", 
          RowBox[{"FullSimplify", "[", 
           RowBox[{"gmn", ".", "Anumu", ".", "invgmnKS"}], "]"}]}], ")"}]}]}],
       "//", 
      RowBox[{"MatrixForm", "\[IndentingNewLine]", 
       RowBox[{"Inverse", "[", "invAnumu", "]"}]}]}], "//", 
     RowBox[{"MatrixForm", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Inverse", "[", "invAnumu", "]"}], ".", "invAnumu"}]}]}], "//",
     "MatrixForm"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.4626330585179996`*^9, 3.462633106061*^9}, {
   3.462633200225*^9, 3.4626332373120003`*^9}, {3.462633273317*^9, 
   3.462633278652*^9}, {3.4626334330220003`*^9, 3.462633536664*^9}, {
   3.462633586236*^9, 3.462633660715*^9}, {3.462635287076*^9, 
   3.462635305646*^9}, {3.4626355485889997`*^9, 3.462635576118*^9}, {
   3.4626356357019997`*^9, 3.462635639954*^9}, {3.462635761001*^9, 
   3.462635913634*^9}, {3.462635986321*^9, 3.462636006325*^9}, {
   3.462636051492*^9, 3.4626360721210003`*^9}, {3.462636278928*^9, 
   3.462636293153*^9}, {3.462636395936*^9, 3.462636409736*^9}, {
   3.462636547731*^9, 3.4626365525769997`*^9}, 3.462636780659*^9, 
   3.462637584486*^9, {3.4626376989709997`*^9, 3.462637700028*^9}, 
   3.462637849402*^9, {3.46263823645*^9, 3.462638236615*^9}, {
   3.4626383039519997`*^9, 3.462638305049*^9}, {3.462638359123*^9, 
   3.4626383635480003`*^9}, {3.4626385617869997`*^9, 3.462638578455*^9}, {
   3.462638881075*^9, 3.4626389075369997`*^9}, {3.4626390873310003`*^9, 
   3.462639096484*^9}, {3.462644193078*^9, 3.462644217727*^9}, 
   3.4626443531809998`*^9, {3.462704235408*^9, 3.462704264086*^9}, {
   3.4740342972869997`*^9, 3.474034311618*^9}, {3.474036129392*^9, 
   3.474036141512*^9}, {3.474036184262*^9, 3.474036185574*^9}, {
   3.474036255237*^9, 3.474036314354*^9}, {3.474036347196*^9, 
   3.474036401833*^9}, {3.474036443409*^9, 3.4740365891470003`*^9}, {
   3.474055368087*^9, 3.474055472965*^9}, {3.474055541039*^9, 
   3.474055562652*^9}, {3.474055719885*^9, 3.4740557261940002`*^9}, {
   3.474055823498*^9, 3.474055840946*^9}, {3.474056932632*^9, 
   3.4740569785030003`*^9}, {3.4740570994*^9, 3.474057144969*^9}, {
   3.474057341248*^9, 3.4740573636210003`*^9}, {3.474059438028*^9, 
   3.474059442311*^9}, {3.4747543964820004`*^9, 3.474754403494*^9}, {
   3.474898024192319*^9, 3.4748980469371195`*^9}, {3.474904322239919*^9, 
   3.474904332598319*^9}, {3.474908775447119*^9, 3.474908780782319*^9}, {
   3.484059672796*^9, 3.4840596747148*^9}, 3.4840598974516*^9, {
   3.4840602350824003`*^9, 3.484060312084*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"R0", "=", "0.3"}], ";", 
  RowBox[{"h", "=", "0.65"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tadd", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"i1", ",", "i2", ",", "i3"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{"cv", ",", "34", ",", "21"}], "}"}]}], "]"}], ";", 
      RowBox[{"ext", "=", 
       RowBox[{"ress", "[", 
        RowBox[{"[", 
         RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}], "]"}]}], ";", 
      RowBox[{"fie", "=", 
       RowBox[{"res2m", "[", 
        RowBox[{"[", 
         RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}], "]"}]}], ";", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Coord (x1,x2,x3): \>\"", " ", ",", 
        RowBox[{"xxx", "=", 
         RowBox[{"ext", "[", 
          RowBox[{"[", 
           RowBox[{"6", ";;", "8"}], "]"}], "]"}]}], ",", 
        "\"\<; (r,\[Theta],\[Phi]): \>\"", ",", " ", 
        RowBox[{"rtp", "=", 
         RowBox[{"ext", "[", 
          RowBox[{"[", 
           RowBox[{"9", ";;", "11"}], "]"}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"sub", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"r", "\[Rule]", 
          RowBox[{"rtp", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], ",", 
         RowBox[{"\[Theta]", "\[Rule]", 
          RowBox[{"rtp", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", 
         RowBox[{"\[Phi]", "\[Rule]", 
          RowBox[{"rtp", "[", 
           RowBox[{"[", "3", "]"}], "]"}]}], ",", 
         RowBox[{"x2", "\[Rule]", 
          RowBox[{"xxx", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", 
         RowBox[{"a", "\[Rule]", "0.7"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\[Rho]=\>\"", ",", " ", 
        RowBox[{"\[Rho]", "=", 
         RowBox[{"fie", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ",", "\"\<; U=\>\"", ",", 
        RowBox[{"U", "=", 
         RowBox[{"fie", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\!\(\*SuperscriptBox[\(u\), \(\[Mu]\)]\)=\>\"", ",", 
        RowBox[{"uup", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"fie", "[", 
             RowBox[{"[", "5", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"fie", "[", 
              RowBox[{"[", "5", "]"}], "]"}], 
             RowBox[{"fie", "[", 
              RowBox[{"[", 
               RowBox[{"6", ";;", "8"}], "]"}], "]"}]}]}], "}"}], "]"}]}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"ulo", "=", 
       RowBox[{
        RowBox[{"invnew", ".", "uup"}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Lab \!\(\*SuperscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
        RowBox[{"bi", "=", 
         RowBox[{"fie", "[", 
          RowBox[{"[", 
           RowBox[{"9", ";;", "11"}], "]"}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\!\(\*SuperscriptBox[\(b\), \(\[Mu]\)]\)=\>\"", ",", 
        RowBox[{"bup", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"bi", ".", 
             RowBox[{"ulo", "[", 
              RowBox[{"[", 
               RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], ",", 
            FractionBox[
             RowBox[{"bi", "+", 
              RowBox[{
               RowBox[{"bi", ".", 
                RowBox[{"ulo", "[", 
                 RowBox[{"[", 
                  RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], 
               RowBox[{"uup", "[", 
                RowBox[{"[", 
                 RowBox[{"2", ";;", "4"}], "]"}], "]"}]}]}], 
             RowBox[{"uup", "[", 
              RowBox[{"[", "1", "]"}], "]"}]]}], "}"}], "]"}]}]}], "]"}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"MKS", "\[Rule]", "FFFF"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"u", "[", "0", "]"}], ",", 
          RowBox[{"u", "[", "1", "]"}], ",", 
          RowBox[{"u", "[", "2", "]"}], ",", 
          RowBox[{"u", "[", "3", "]"}]}], "}"}], "=", "uup"}], "]"}], ";", 
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"uco", "[", "0", "]"}], ",", 
          RowBox[{"uco", "[", "1", "]"}], ",", 
          RowBox[{"uco", "[", "2", "]"}], ",", 
          RowBox[{"uco", "[", "3", "]"}]}], "}"}], "=", "ulo"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xx", "[", "0", "]"}], "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"u", "[", "0", "]"}], ",", 
         RowBox[{"u", "[", "1", "]"}], ",", 
         RowBox[{"u", "[", "2", "]"}], ",", 
         RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "0", "]"}], "=", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"invnew", ".", 
          RowBox[{"xx", "[", "0", "]"}]}]}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xx", "[", "2", "]"}], "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"uco", "[", "2", "]"}], 
          RowBox[{"u", "[", "0", "]"}]}], ",", 
         RowBox[{
          RowBox[{"uco", "[", "2", "]"}], 
          RowBox[{"u", "[", "1", "]"}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"uco", "[", "2", "]"}], 
           RowBox[{"u", "[", "2", "]"}]}], "+", "1"}], ",", 
         RowBox[{
          RowBox[{"uco", "[", "2", "]"}], 
          RowBox[{"u", "[", "3", "]"}]}]}], "}"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "2", "]"}], "=", 
       RowBox[{
        RowBox[{"invnew", ".", 
         RowBox[{"xx", "[", "2", "]"}]}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xx", "[", "3", "]"}], "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"uco", "[", "3", "]"}], 
           RowBox[{"uco", "[", "0", "]"}]]}], ",", "0", ",", "0", ",", "1"}], 
        "}"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "3", "]"}], "=", 
       RowBox[{
        RowBox[{"invnew", ".", 
         RowBox[{"xx", "[", "3", "]"}]}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"sc", "[", "0", "]"}], "=", 
       RowBox[{
        SqrtBox[
         RowBox[{
          RowBox[{"xx", "[", "0", "]"}], ".", 
          RowBox[{"xxlo", "[", "0", "]"}]}]], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"sc", "[", "3", "]"}], "=", 
       RowBox[{
        SqrtBox[
         RowBox[{
          RowBox[{"xx", "[", "3", "]"}], ".", 
          RowBox[{"xxlo", "[", "3", "]"}]}]], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"sc", "[", "2", "]"}], "=", 
       RowBox[{
        SqrtBox[
         RowBox[{
          RowBox[{"xx", "[", "2", "]"}], ".", 
          RowBox[{"xxlo", "[", "2", "]"}]}]], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xx", "[", "0", "]"}], "/=", 
       RowBox[{"sc", "[", "0", "]"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "0", "]"}], "/=", 
       RowBox[{
        RowBox[{"sc", "[", "0", "]"}], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"xx", "[", "2", "]"}], "/=", 
       RowBox[{"sc", "[", "2", "]"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "2", "]"}], "/=", 
       RowBox[{
        RowBox[{"sc", "[", "2", "]"}], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"xx", "[", "3", "]"}], "/=", 
       RowBox[{"sc", "[", "3", "]"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "3", "]"}], "/=", 
       RowBox[{
        RowBox[{"sc", "[", "3", "]"}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xpr", "[", "1", "]"}], "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"u", "[", "0", "]"}], 
           RowBox[{"uco", "[", "1", "]"}]}], " ", ",", 
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"u", "[", "0", "]"}], 
              RowBox[{"uco", "[", "0", "]"}]}], "+", 
             RowBox[{
              RowBox[{"u", "[", "3", "]"}], 
              RowBox[{"uco", "[", "3", "]"}]}]}], ")"}]}], ",", "0", ",", 
          RowBox[{
           RowBox[{"u", "[", "3", "]"}], 
           RowBox[{"uco", "[", "1", "]"}]}]}], "}"}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xlopr", "[", "1", "]"}], "=", 
       RowBox[{
        RowBox[{"invnew", ".", 
         RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"xx", "[", "1", "]"}], "=", 
       RowBox[{
        RowBox[{"xpr", "[", "1", "]"}], "-", 
        RowBox[{
         RowBox[{
          RowBox[{"xlopr", "[", "1", "]"}], ".", 
          RowBox[{"xx", "[", "3", "]"}]}], "*", 
         RowBox[{"xx", "[", "3", "]"}]}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"xxlo", "[", "1", "]"}], "=", 
         RowBox[{
          RowBox[{"invnew", ".", 
           RowBox[{"xx", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
        RowBox[{
         RowBox[{"sc", "[", "1", "]"}], "=", 
         RowBox[{
          SqrtBox[
           RowBox[{
            RowBox[{"xx", "[", "1", "]"}], ".", 
            RowBox[{"xxlo", "[", "1", "]"}]}]], "/.", "sub"}]}], ";"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"xlopr", "[", "1", "]"}], "=", 
       RowBox[{
        RowBox[{"invnew", ".", 
         RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
      RowBox[{
       RowBox[{"xx", "[", "1", "]"}], "/=", 
       RowBox[{"sc", "[", "1", "]"}]}], ";", 
      RowBox[{
       RowBox[{"xxlo", "[", "1", "]"}], "/=", 
       RowBox[{
        RowBox[{"sc", "[", "1", "]"}], "/.", "sub"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"trxx", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"xxlo", "[", "0", "]"}], ",", 
         RowBox[{"xxlo", "[", "1", "]"}], ",", 
         RowBox[{"xxlo", "[", "2", "]"}], ",", 
         RowBox[{"xxlo", "[", "3", "]"}]}], "}"}]}], ";", 
      RowBox[{"trcoxx", "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"xx", "[", "0", "]"}], ",", 
          RowBox[{"xx", "[", "1", "]"}], ",", 
          RowBox[{"xx", "[", "2", "]"}], ",", 
          RowBox[{"xx", "[", "3", "]"}]}], "}"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", "tests", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{
       "\"\<Norm \!\(\*SuperscriptBox[\(u\), \
\(\[Mu]\)]\)\!\(\*SubscriptBox[\(u\), \(\[Mu]\)]\)=\>\"", ",", 
        RowBox[{"InputForm", "[", 
         RowBox[{"ulo", ".", "uup"}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<\!\(\*SubscriptBox[\(u\), \(i\)]\)=\>\"", ",", 
        RowBox[{"trxx", ".", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"u", "[", "0", "]"}], ",", 
           RowBox[{"u", "[", "1", "]"}], ",", 
           RowBox[{"u", "[", "2", "]"}], ",", 
           RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ",", 
        "\"\<;  should be {1,0,0,0}\>\""}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<Co-moving \!\(\*SubscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
        RowBox[{"coB", "=", 
         RowBox[{
          RowBox[{"trxx", ".", "bup"}], "/.", "sub"}]}], ",", 
        "\"\<;  0-th component should be 0\>\""}], "]"}], ";", "\n", 
      RowBox[{"Print", "[", 
       RowBox[{
       "\"\<Back to lab frame: \!\(\*SuperscriptBox[\(b\), \(\[Mu]\)]\)=\>\"",
         ",", 
        RowBox[{"trcoxx", ".", "coB"}]}], "]"}], ";", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"rtp", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{"Norm", "[", "coB", "]"}], ",", "\[Rho]"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"cv", ",", "175", ",", "175", ",", "10"}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGCQBGIQHVjl8Vjt+UvHNx9jwHTnQwVXdSAdFGEOpq0Oa5WB
aJH7eXUguura5i4Q7XD13AQQHf47cCqITtPomQGi7y2yXA6iy96rrQLRx6MY
14HoyzEt20C0pDDHTxAtHu70F0QvemrGrAHWd5EPRHPsfiYKomPm1ciC6B+f
m3VA9MvwE2BaddnEaBDtdE8hEUQ7ewe3/wXSiw9yTQPR/4oezQHRUYXPwPTe
xmuLQHSF1Z4lIPrOdI4NIDolqxxMTzh01zfg60vHkq1/wXTZg5IkEK1ldQlM
i6wrzwbR/NxnwfQ3jZQCEB3MuhtML+P6Vw6i7zEJVoBoq0mH20G0F88lMD3D
52pEIJA+9u9UFIje+1jHIQhIG8zscgHRdeuuhYPotijvGBANAHY133w=
  "]],

Cell[BoxData[{"sub", "\[IndentingNewLine]", "uup"}], "Input",
 CellChangeTimes->{{3.484062528766*^9, 3.484062529*^9}, {3.4840625918836*^9, 
  3.4840625925388002`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], ",", 
       RowBox[{"u", "[", "1", "]"}], ",", 
       RowBox[{"u", "[", "2", "]"}], ",", 
       RowBox[{"u", "[", "3", "]"}]}], "}"}], "=", "uup"}], "]"}], ";", 
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"uco", "[", "0", "]"}], ",", 
       RowBox[{"uco", "[", "1", "]"}], ",", 
       RowBox[{"uco", "[", "2", "]"}], ",", 
       RowBox[{"uco", "[", "3", "]"}]}], "}"}], "=", "ulo"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "[", "0", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"u", "[", "0", "]"}], ",", 
     RowBox[{"u", "[", "1", "]"}], ",", 
     RowBox[{"u", "[", "2", "]"}], ",", 
     RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "0", "]"}], "=", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"invnew", ".", 
      RowBox[{"xx", "[", "0", "]"}]}]}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "[", "2", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"uco", "[", "2", "]"}], 
      RowBox[{"u", "[", "0", "]"}]}], ",", 
     RowBox[{
      RowBox[{"uco", "[", "2", "]"}], 
      RowBox[{"u", "[", "1", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"uco", "[", "2", "]"}], 
       RowBox[{"u", "[", "2", "]"}]}], "+", "1"}], ",", 
     RowBox[{
      RowBox[{"uco", "[", "2", "]"}], 
      RowBox[{"u", "[", "3", "]"}]}]}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "2", "]"}], "=", 
   RowBox[{
    RowBox[{"invnew", ".", 
     RowBox[{"xx", "[", "2", "]"}]}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "[", "3", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"uco", "[", "3", "]"}], 
       RowBox[{"uco", "[", "0", "]"}]]}], ",", "0", ",", "0", ",", "1"}], 
    "}"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "3", "]"}], "=", 
   RowBox[{
    RowBox[{"invnew", ".", 
     RowBox[{"xx", "[", "3", "]"}]}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sc", "[", "0", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "0", "]"}], ".", 
      RowBox[{"xxlo", "[", "0", "]"}]}]], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"sc", "[", "3", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "3", "]"}], ".", 
      RowBox[{"xxlo", "[", "3", "]"}]}]], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"sc", "[", "2", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "2", "]"}], ".", 
      RowBox[{"xxlo", "[", "2", "]"}]}]], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"xx", "[", "0", "]"}], "/=", 
    RowBox[{"sc", "[", "0", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "0", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "0", "]"}], "/.", "sub"}]}], ";", 
   RowBox[{
    RowBox[{"xx", "[", "2", "]"}], "/=", 
    RowBox[{"sc", "[", "2", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "2", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "2", "]"}], "/.", "sub"}]}], ";", 
   RowBox[{
    RowBox[{"xx", "[", "3", "]"}], "/=", 
    RowBox[{"sc", "[", "3", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "3", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "3", "]"}], "/.", "sub"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xpr", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], 
       RowBox[{"uco", "[", "1", "]"}]}], " ", ",", 
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"u", "[", "0", "]"}], 
          RowBox[{"uco", "[", "0", "]"}]}], "+", 
         RowBox[{
          RowBox[{"u", "[", "3", "]"}], 
          RowBox[{"uco", "[", "3", "]"}]}]}], ")"}]}], ",", "0", ",", 
      RowBox[{
       RowBox[{"u", "[", "3", "]"}], 
       RowBox[{"uco", "[", "1", "]"}]}]}], "}"}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xlopr", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"invnew", ".", 
     RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"xx", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"xpr", "[", "1", "]"}], "-", 
    RowBox[{
     RowBox[{
      RowBox[{"xlopr", "[", "1", "]"}], ".", 
      RowBox[{"xx", "[", "3", "]"}]}], "*", 
     RowBox[{"xx", "[", "3", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xxlo", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"invnew", ".", 
     RowBox[{"xx", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"sc", "[", "1", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "1", "]"}], ".", 
      RowBox[{"xxlo", "[", "1", "]"}]}]], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"xlopr", "[", "1", "]"}], "=", 
    RowBox[{
     RowBox[{"invnew", ".", 
      RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
   RowBox[{
    RowBox[{"xx", "[", "1", "]"}], "/=", 
    RowBox[{"sc", "[", "1", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "1", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "1", "]"}], "/.", "sub"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"trxx", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"xxlo", "[", "0", "]"}], ",", 
      RowBox[{"xxlo", "[", "1", "]"}], ",", 
      RowBox[{"xxlo", "[", "2", "]"}], ",", 
      RowBox[{"xxlo", "[", "3", "]"}]}], "}"}]}], ";", 
   RowBox[{"trcoxx", "=", 
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"xx", "[", "0", "]"}], ",", 
       RowBox[{"xx", "[", "1", "]"}], ",", 
       RowBox[{"xx", "[", "2", "]"}], ",", 
       RowBox[{"xx", "[", "3", "]"}]}], "}"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Metrics in FLAT frame \>\"", ",", 
   RowBox[{
    RowBox[{"Chop", "[", 
     RowBox[{
      RowBox[{"trxx", ".", 
       RowBox[{"Inverse", "[", "invnew", "]"}], ".", 
       RowBox[{"Transpose", "[", "trxx", "]"}]}], "/.", "sub"}], "]"}], "//", 
    "MatrixForm"}], ",", "\"\<; should be diag(-1,1,1,1)\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Orthonormal condition \>\"", ",", 
   RowBox[{
    RowBox[{"Chop", "[", 
     RowBox[{
      RowBox[{"trcoxx", ".", "trxx"}], "/.", "sub"}], "]"}], "//", 
    "MatrixForm"}], ",", "\"\<; should be diag(1,1,1,1)\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Transformation from FLAT to LAB frame \>\"", ",", 
   RowBox[{
    RowBox[{"trcoxx", "/.", "sub"}], "//", "MatrixForm"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Transformation from LAB to FLAT frame \>\"", ",", 
   RowBox[{
    RowBox[{"trxx", "/.", "sub"}], "//", "MatrixForm"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Inverse of transform from LAB to FLAT = transform from FLAT to LAB=\>\
\"", ",", 
    RowBox[{
     RowBox[{"Inverse", "[", "trxx", "]"}], "//", "MatrixForm"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Switching from \!\(\*SuperscriptBox[\(X\), \(\[Mu]\)]\) to physical \
vector \!\(\*SubscriptBox[\(x\), \(0\)]\)=\!\(\*SqrtBox[\(-\*SubscriptBox[\(g\
\), \(\[Mu]0\[Nu]\)]\)]\)\!\(\*SuperscriptBox[\(X\), \(0\)]\); \
\!\(\*SubscriptBox[\(x\), \(i\)]\)=\!\(\*SqrtBox[SubscriptBox[\(g\), \(\[Mu]\
\[Nu]\)]]\)\!\(\*SuperscriptBox[\(X\), \(i\)]\):  {\!\(\*SubscriptBox[\(x\), \
\(\(0\)\(,\)\)]\)\!\(\*SubscriptBox[\(x\), \(i\)]\)}=\>\"", ",", 
   RowBox[{"Xinv", "=", 
    RowBox[{"Simplify", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"Flatten", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             SqrtBox[
              RowBox[{
               RowBox[{"-", "invnew"}], "/.", 
               RowBox[{"a", "\[Rule]", "0"}]}]], "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{
             SqrtBox[
              RowBox[{"invnew", "/.", 
               RowBox[{"a", "\[Rule]", "0"}]}]], "[", 
             RowBox[{"[", 
              RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], "}"}], "]"}], ",", 
         "4"}], "]"}], "/.", "sub"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"r", ">", "0"}], ",", 
        RowBox[{
         RowBox[{"Sin", "[", "\[Theta]", "]"}], ">", "0"}]}], "}"}]}], 
     "]"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Transforming the physical vector to physical vector:\>\"", ",", 
    RowBox[{"Re", "[", 
     RowBox[{"Diagonal", "[", 
      RowBox[{
       RowBox[{"trcoxx", ".", "Xinv"}], "/.", "sub"}], "]"}], "]"}], ",", 
    "\"\<; should be (1,1,1,1)\>\""}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Velocity from FLAT to LAB frame \>\"", ",", 
   RowBox[{"trcoxx", ".", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], ",", 
   "\"\<;  actual \!\(\*SuperscriptBox[\(u\), \(\[Mu]\)]\)=\>\"", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"u", "[", "0", "]"}], ",", 
     RowBox[{"u", "[", "1", "]"}], ",", 
     RowBox[{"u", "[", "2", "]"}], ",", 
     RowBox[{"u", "[", "3", "]"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Velocity from LAB to FLAT frame \>\"", ",", 
   RowBox[{"trxx", ".", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"u", "[", "0", "]"}], ",", 
      RowBox[{"u", "[", "1", "]"}], ",", 
      RowBox[{"u", "[", "2", "]"}], ",", 
      RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ",", 
   "\"\<; should be {1,0,0,0}\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.462794275929*^9, 3.462794285986*^9}, {3.474052565123*^9,
    3.4740525681359997`*^9}, {3.474300472631*^9, 3.474300473479*^9}, {
   3.474300614631*^9, 3.474300625958*^9}, 3.474301157365*^9, {
   3.474301265365*^9, 3.474301416368*^9}, {3.4743015085290003`*^9, 
   3.4743015170439997`*^9}, {3.474301960594*^9, 3.474301975835*^9}, {
   3.474302383356*^9, 3.474302385054*^9}, {3.474302419315*^9, 
   3.474302466375*^9}, {3.4743025073570004`*^9, 3.4743025089779997`*^9}, {
   3.4743025466029997`*^9, 3.474302583834*^9}, {3.474302623046*^9, 
   3.474302644558*^9}, {3.474303378959*^9, 3.474303381472*^9}, 
   3.47430504405*^9, {3.474305216053*^9, 3.47430524841*^9}, {3.47430531252*^9,
    3.474305351744*^9}, {3.4743055055950003`*^9, 3.4743056055030003`*^9}, {
   3.474305638631*^9, 3.474305754756*^9}, {3.474305874498*^9, 
   3.474306086751*^9}, {3.474306194901*^9, 3.474306305917*^9}, {
   3.474306728212*^9, 3.4743067883599997`*^9}, {3.474307120579*^9, 
   3.474307171415*^9}, {3.474307209502*^9, 3.474307216705*^9}, {
   3.474307415205*^9, 3.474307452283*^9}, {3.474307523975*^9, 
   3.474307525726*^9}, {3.474307898139*^9, 3.4743079236359997`*^9}, {
   3.4743079820150003`*^9, 3.474307989916*^9}, {3.474308062708*^9, 
   3.474308099533*^9}, {3.4743081350559998`*^9, 3.474308147686*^9}, {
   3.474308401329*^9, 3.4743084029630003`*^9}, {3.474308451902*^9, 
   3.474308468117*^9}, {3.474308556637*^9, 3.474308568948*^9}, {
   3.4743086524630003`*^9, 3.474308684876*^9}, 3.474308725841*^9, {
   3.474308773033*^9, 3.474308813158*^9}, {3.474308888778*^9, 
   3.474308892158*^9}, 3.474310194201*^9, {3.474310233545*^9, 
   3.47431024921*^9}, {3.474310346593*^9, 3.474310448916*^9}, {
   3.474310499833*^9, 3.474310544203*^9}, {3.47431076033*^9, 
   3.474310775014*^9}, {3.474315321821*^9, 3.474315401474*^9}, {
   3.474315436784*^9, 3.474315486615*^9}, {3.474315572326*^9, 
   3.474315579336*^9}, {3.474315672815*^9, 3.474315716552*^9}, {
   3.474315750715*^9, 3.4743157550550003`*^9}, {3.4743157939049997`*^9, 
   3.4743158242609997`*^9}, {3.4743159295109997`*^9, 3.474315933599*^9}, {
   3.474315963718*^9, 3.474315965026*^9}, {3.474315997451*^9, 
   3.474316006317*^9}, {3.4743160637*^9, 3.474316232139*^9}, {
   3.4743162672200003`*^9, 3.474316284962*^9}, {3.47431642815*^9, 
   3.474316478492*^9}, {3.47431653842*^9, 3.474316538829*^9}, {
   3.4743168783789997`*^9, 3.474316923992*^9}, 3.474316961406*^9, {
   3.474317013734*^9, 3.474317013891*^9}, {3.4743176591029997`*^9, 
   3.4743177055690002`*^9}, {3.474318460744*^9, 3.4743185817720003`*^9}, {
   3.474320383012*^9, 3.474320445801*^9}, {3.474320542084*^9, 
   3.474320545676*^9}, {3.474320610021*^9, 3.47432066815*^9}, {
   3.474321588102*^9, 3.474321606324*^9}, {3.474374228576*^9, 
   3.474374320301*^9}, {3.474374543245*^9, 3.474374585189*^9}, {
   3.474374615356*^9, 3.474374717481*^9}, 3.474463442032333*^9, {
   3.474753847646*^9, 3.4747538952939997`*^9}, {3.4747539757530003`*^9, 
   3.474753982908*^9}, {3.4747540136359997`*^9, 3.4747540519440002`*^9}, {
   3.474754108921*^9, 3.474754110017*^9}, {3.474754161884*^9, 
   3.4747541935769997`*^9}, {3.474754227177*^9, 3.474754230711*^9}, {
   3.474754268323*^9, 3.474754282856*^9}, {3.474756568822*^9, 
   3.4747565714309998`*^9}, {3.474756657071*^9, 3.474756670233*^9}, {
   3.47475675819*^9, 3.4747567596940002`*^9}, {3.474756795042*^9, 
   3.474756818231*^9}, {3.474756958888*^9, 3.47475698405*^9}, {
   3.474890294236*^9, 3.474890327311*^9}, {3.474894553362*^9, 
   3.474894599462*^9}, {3.475851641059*^9, 3.475851641343*^9}, {
   3.4758516840950003`*^9, 3.4758517019379997`*^9}, {3.47585181296*^9, 
   3.475851822031*^9}, {3.476137033738*^9, 3.4761370554110003`*^9}, {
   3.476137100326*^9, 3.476137101466*^9}, {3.476137414418*^9, 
   3.4761374287200003`*^9}, {3.476137572887*^9, 3.476137599416*^9}, {
   3.4761382512349997`*^9, 3.476138251999*^9}, {3.476138408024*^9, 
   3.47613841108*^9}, {3.4761384657209997`*^9, 3.476138471546*^9}, {
   3.476138675535*^9, 3.4761386766*^9}, {3.476139026466*^9, 
   3.476139029039*^9}, {3.4761390615810003`*^9, 3.4761391003059998`*^9}, {
   3.476143793428*^9, 3.476143842472*^9}, {3.476143921948*^9, 
   3.4761439490629997`*^9}, {3.4761439810699997`*^9, 
   3.4761439811219997`*^9}, {3.4761441163050003`*^9, 3.476144153406*^9}, {
   3.476144212398*^9, 3.4761442301140003`*^9}, {3.4761454384709997`*^9, 
   3.476145439752*^9}, {3.476146050906*^9, 3.476146184099*^9}, {
   3.4766339075771313`*^9, 3.476633912506731*^9}, {3.476635244122731*^9, 
   3.4766352707051315`*^9}, {3.4766353304219313`*^9, 3.476635398484731*^9}, {
   3.476635494705531*^9, 3.476635525624731*^9}, {3.476635562721531*^9, 
   3.4766355694451313`*^9}}]
}, Closed]],

Cell["Vector product for e2 reconstruction", "Subsection",
 CellChangeTimes->{{3.4840628407096*^9, 3.4840628417236*^9}}],

Cell[CellGroupData[{

Cell["Definitions of frequency, magnetic fields, emissivities", "Subsection",
 CellChangeTimes->{{3.4840639915996*^9, 3.48406399408*^9}, {
  3.4840642638976*^9, 3.4840642646932*^9}, {3.484064447182*^9, 
  3.4840644499276*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ruru", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rg", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "6.67", " ", 
        SuperscriptBox["10", 
         RowBox[{"-", "8"}]], "4.5", " ", 
        SuperscriptBox["10", "6"], "2", " ", 
        SuperscriptBox["10", "33"]}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"3", " ", 
          SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
     RowBox[{"arcsec", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
        SuperscriptBox["10", "3"], "3.08", " ", 
        SuperscriptBox["10", "18"]}], 
       RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
     RowBox[{"pc", "\[Rule]", 
      RowBox[{"3.08", " ", 
       SuperscriptBox["10", "18"]}]}], ",", 
     RowBox[{"year", "\[Rule]", 
      RowBox[{"365.35", " ", "86400"}]}], ",", 
     RowBox[{"cc", "\[Rule]", 
      RowBox[{"3.", " ", 
       SuperscriptBox["10", "10"]}]}], ",", 
     RowBox[{"Msun", "\[Rule]", 
      RowBox[{"2.", " ", 
       SuperscriptBox["10", "33"]}]}], ",", 
     RowBox[{"mp", "\[Rule]", 
      RowBox[{"1.26", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "24"}]]}]}], ",", 
     RowBox[{"me", "\[Rule]", 
      RowBox[{"9.1", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "28"}]]}]}], ",", 
     RowBox[{"kb", "\[Rule]", 
      RowBox[{"1.38", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "16"}]]}]}], ",", 
     RowBox[{"h", "\[Rule]", 
      RowBox[{"6.626", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "27"}]]}]}], ",", 
     RowBox[{"ee", "\[Rule]", 
      RowBox[{"4.8", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "10"}]]}]}], ",", 
     RowBox[{"keV", "->", 
      RowBox[{"1000", " ", "1.602", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Nu]H", "=", 
   FractionBox[
    RowBox[{"ee", " ", "B"}], 
    RowBox[{"2", "\[Pi]", " ", "me", " ", "cc", " "}]]}], ";", 
  RowBox[{"\[Nu]c", "=", 
   RowBox[{
    FractionBox["3", "2"], 
    RowBox[{"Sin", "[", "\[Theta]", "]"}], "\[Nu]H", " ", 
    SuperscriptBox["\[Gamma]", "2"]}]}], ";", 
  RowBox[{
   RowBox[{"IjcSs", "[", 
    RowBox[{
     RowBox[{"\[Theta]e_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Nu]\[CapitalOmega]_", "?", "NumberQ"}]}], "]"}], ":=", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      FractionBox["\[Nu]\[CapitalOmega]", 
       SuperscriptBox["\[Gamma]", "2"]], 
      RowBox[{"BesselK", "[", 
       RowBox[{
        FractionBox["5", "3"], ",", "t"}], "]"}], 
      FractionBox[
       RowBox[{"Exp", "[", 
        RowBox[{"-", 
         FractionBox["\[Gamma]", "\[Theta]e"]}], "]"}], 
       RowBox[{"\[Theta]e", " ", 
        RowBox[{"BesselK", "[", 
         RowBox[{"2", ",", 
          SuperscriptBox["\[Theta]e", 
           RowBox[{"-", "1"}]]}], "]"}]}]], "\[Gamma]", 
      SqrtBox[
       RowBox[{
        SuperscriptBox["\[Gamma]", "2"], "-", "1"}]]}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Gamma]", ",", "1", ",", "3000"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", 
       FractionBox["\[Nu]\[CapitalOmega]", 
        SuperscriptBox["\[Gamma]", "2"]], ",", 
       RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"QjcSs", "[", 
    RowBox[{
     RowBox[{"\[Theta]e_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Nu]\[CapitalOmega]_", "?", "NumberQ"}]}], "]"}], ":=", 
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{
      FractionBox["\[Nu]\[CapitalOmega]", 
       SuperscriptBox["\[Gamma]", "2"]], 
      RowBox[{"BesselK", "[", 
       RowBox[{
        FractionBox["2", "3"], ",", 
        FractionBox["\[Nu]\[CapitalOmega]", 
         SuperscriptBox["\[Gamma]", "2"]]}], "]"}], 
      FractionBox[
       RowBox[{"Exp", "[", 
        RowBox[{"-", 
         FractionBox["\[Gamma]", "\[Theta]e"]}], "]"}], 
       RowBox[{"\[Theta]e", " ", 
        RowBox[{"BesselK", "[", 
         RowBox[{"2", ",", 
          SuperscriptBox["\[Theta]e", 
           RowBox[{"-", "1"}]]}], "]"}]}]], "\[Gamma]", 
      SqrtBox[
       RowBox[{
        SuperscriptBox["\[Gamma]", "2"], "-", "1"}]]}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Gamma]", ",", "1", ",", "3000"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VjcSs", "[", 
    RowBox[{
     RowBox[{"\[Theta]e_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Nu]\[CapitalOmega]_", "?", "NumberQ"}]}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"NIntegrate", "[", 
      RowBox[{
       RowBox[{
        FractionBox["\[Nu]\[CapitalOmega]", 
         SuperscriptBox["\[Gamma]", "3"]], 
        RowBox[{"BesselK", "[", 
         RowBox[{
          FractionBox["1", "3"], ",", "t"}], "]"}], 
        FractionBox[
         RowBox[{"Exp", "[", 
          RowBox[{"-", 
           FractionBox["\[Gamma]", "\[Theta]e"]}], "]"}], 
         RowBox[{"\[Theta]e", " ", 
          RowBox[{"BesselK", "[", 
           RowBox[{"2", ",", 
            SuperscriptBox["\[Theta]e", 
             RowBox[{"-", "1"}]]}], "]"}]}]], "\[Gamma]", 
        SqrtBox[
         RowBox[{
          SuperscriptBox["\[Gamma]", "2"], "-", "1"}]]}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Gamma]", ",", "1", ",", "3000"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", 
         FractionBox["\[Nu]\[CapitalOmega]", 
          SuperscriptBox["\[Gamma]", "2"]], ",", 
         RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}], "+", 
     RowBox[{"NIntegrate", "[", 
      RowBox[{
       RowBox[{
        FractionBox["\[Nu]\[CapitalOmega]", 
         SuperscriptBox["\[Gamma]", "3"]], 
        RowBox[{"BesselK", "[", 
         RowBox[{
          FractionBox["1", "3"], ",", 
          FractionBox["\[Nu]\[CapitalOmega]", 
           SuperscriptBox["\[Gamma]", "2"]]}], "]"}], 
        FractionBox[
         RowBox[{"Exp", "[", 
          RowBox[{"-", 
           FractionBox["\[Gamma]", "\[Theta]e"]}], "]"}], 
         RowBox[{"\[Theta]e", " ", 
          RowBox[{"BesselK", "[", 
           RowBox[{"2", ",", 
            SuperscriptBox["\[Theta]e", 
             RowBox[{"-", "1"}]]}], "]"}]}]], "\[Gamma]", 
        SqrtBox[
         RowBox[{
          SuperscriptBox["\[Gamma]", "2"], "-", "1"}]]}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Gamma]", ",", "1", ",", "3000"}], "}"}]}], "]"}]}], 
    ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Iexpr", "=", 
    RowBox[{"\[Nu]H", " ", 
     RowBox[{"Sin", "[", "\[Theta]", "]"}], 
     FractionBox[
      RowBox[{
       SqrtBox["3"], " ", 
       SuperscriptBox["ee", "2"]}], 
      RowBox[{"2", " ", "cc"}]], " ", 
     RowBox[{"IjcSs", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"kb", " ", "Te"}], 
        RowBox[{"me", " ", 
         SuperscriptBox["cc", "2"]}]], ",", 
       FractionBox[
        RowBox[{"2", "me", " ", "cc", " ", "2", "\[Pi]", " ", "\[Nu]"}], 
        RowBox[{"3", "ee", " ", "B", " ", 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}]]}], "]"}]}]}], ";", 
   RowBox[{"Qexpr", "=", 
    RowBox[{"\[Nu]H", " ", 
     RowBox[{"Sin", "[", "\[Theta]", "]"}], 
     FractionBox[
      RowBox[{
       SqrtBox["3"], " ", 
       SuperscriptBox["ee", "2"]}], 
      RowBox[{"2", " ", "cc"}]], " ", 
     RowBox[{"QjcSs", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"kb", " ", "Te"}], 
        RowBox[{"me", " ", 
         SuperscriptBox["cc", "2"]}]], ",", 
       FractionBox[
        RowBox[{"2", "me", " ", "cc", " ", "2", "\[Pi]", " ", "\[Nu]"}], 
        RowBox[{"3", "ee", " ", "B", " ", 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}]]}], "]"}]}]}], ";", 
   RowBox[{"Vexpr", "=", 
    RowBox[{"\[Nu]H", " ", 
     RowBox[{"Cos", "[", "\[Theta]", "]"}], 
     FractionBox[
      RowBox[{"2", 
       SqrtBox["3"], " ", 
       SuperscriptBox["ee", "2"]}], 
      RowBox[{"3", " ", "cc"}]], " ", 
     RowBox[{"VjcSs", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"kb", " ", "Te"}], 
        RowBox[{"me", " ", 
         SuperscriptBox["cc", "2"]}]], ",", 
       FractionBox[
        RowBox[{"2", "me", " ", "cc", " ", "2", "\[Pi]", " ", "\[Nu]"}], 
        RowBox[{"3", "ee", " ", "B", " ", 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}]]}], "]"}]}]}], ";"}], 
  "\[IndentingNewLine]", "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"quant", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[Theta]", "\[Rule]", "1."}], ",", 
     RowBox[{"B", "\[Rule]", "20"}], ",", 
     RowBox[{"Te", "\[Rule]", 
      RowBox[{"3.8", " ", 
       SuperscriptBox["10", "10"]}]}], ",", 
     RowBox[{"\[Nu]", "\[Rule]", 
      RowBox[{"1.", " ", 
       SuperscriptBox["10", "11"]}]}], ",", 
     RowBox[{"ne", "\[Rule]", "1"}]}], "}"}]}], ";", 
  RowBox[{"AppendTo", "[", 
   RowBox[{"quant", ",", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Beta]", "\[Rule]", 
       FractionBox[
        RowBox[{"ee", " ", "B"}], 
        RowBox[{"me", " ", "cc", " ", "2", "\[Pi]", " ", "\[Nu]"}]]}], "/.", 
      "quant"}], "/.", "ruru"}]}], "]"}], ";", 
  RowBox[{"S\[Nu]", "=", 
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"2", "kb", " ", "Te", " ", 
       SuperscriptBox["\[Nu]", "2"]}], 
      SuperscriptBox["cc", "2"]], "/.", "ruru"}], "/.", "quant"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{"IjS", ",", "QjS", ",", "VjS"}], "}"}], "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Iexpr", ",", "Qexpr", ",", "Vexpr"}], "}"}], "/.", 
     RowBox[{"\[Theta]e", "\[Rule]", 
      FractionBox[
       RowBox[{"kb", " ", "Te"}], 
       RowBox[{"me", " ", 
        SuperscriptBox["cc", "2"]}]]}]}], "/.", "ruru"}], "/.", 
   "quant"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[Alpha]IS", ",", "\[Alpha]QS", ",", "\[Alpha]VS"}], "}"}], "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"IjS", ",", "QjS", ",", "VjS"}], "}"}], "/", "S\[Nu]"}]}], 
  RowBox[{"(*", 
   RowBox[{"absorptivities", " ", "from", " ", "emissivities"}], " ", 
   "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"XX", "=", 
   RowBox[{"\[Theta]e", 
    SqrtBox[
     RowBox[{
      SqrtBox["2"], 
      RowBox[{"Sin", "[", "\[Theta]", "]"}], 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["10", "3"], 
        FractionBox[
         RowBox[{"ee", " ", "B"}], 
         RowBox[{"me", " ", "cc", " ", "2", "\[Pi]", " ", "\[Nu]"}]]}], 
       ")"}]}]]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]QSs", "=", 
   RowBox[{
    FractionBox["\[Omega]", 
     RowBox[{"2", "cc"}]], 
    FractionBox[
     RowBox[{"4", "\[Pi]", " ", "ne", " ", 
      SuperscriptBox["ee", "2"]}], 
     RowBox[{"me", " ", 
      SuperscriptBox["\[Omega]", "4"]}]], 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{"ee", " ", "B"}], 
       RowBox[{"me", " ", "cc"}]], ")"}], "2"], 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"BesselK", "[", 
        RowBox[{"1", ",", 
         SuperscriptBox["\[Theta]e", 
          RowBox[{"-", "1"}]]}], "]"}], 
       RowBox[{"BesselK", "[", 
        RowBox[{"2", ",", 
         SuperscriptBox["\[Theta]e", 
          RowBox[{"-", "1"}]]}], "]"}]], "+", 
      RowBox[{"6", "\[Theta]e"}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{"fx", "=", 
      RowBox[{
       RowBox[{"2.011", " ", 
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          FractionBox[
           SuperscriptBox["XX", "1.035"], "4.7"]}], "]"}]}], "-", 
       RowBox[{
        RowBox[{"Cos", "[", 
         FractionBox["XX", "2"], "]"}], 
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          FractionBox[
           SuperscriptBox["XX", "1.2"], "2.73"]}], "]"}]}], "-", 
       RowBox[{"0.011", 
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          FractionBox["XX", "47.2"]}], "]"}]}]}]}], ")"}], 
    SuperscriptBox[
     RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]VSs", "=", 
   RowBox[{"(*", "-", "*)"}], 
   RowBox[{
    FractionBox["\[Omega]", "cc"], "\[ImaginaryI]", " ", 
    RowBox[{"(", 
     RowBox[{"-", "\[ImaginaryI]"}], ")"}], 
    FractionBox[
     RowBox[{"4", "\[Pi]", " ", "ne", " ", 
      SuperscriptBox["ee", "2"]}], 
     RowBox[{"me", " ", 
      SuperscriptBox["\[Omega]", "3"]}]], 
    FractionBox[
     RowBox[{"ee", " ", "B"}], 
     RowBox[{"me", " ", "cc"}]], 
    FractionBox[
     RowBox[{"BesselK", "[", 
      RowBox[{"0", ",", 
       SuperscriptBox["\[Theta]e", 
        RowBox[{"-", "1"}]]}], "]"}], 
     RowBox[{"BesselK", "[", 
      RowBox[{"2", ",", 
       SuperscriptBox["\[Theta]e", 
        RowBox[{"-", "1"}]]}], "]"}]], 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"0.11", " ", 
       RowBox[{"Log", "[", 
        RowBox[{"1", "+", 
         RowBox[{"0.035", " ", "XX"}]}], "]"}]}]}], ")"}], 
    RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[Rho]QS", ",", "\[Rho]VS"}], "}"}], "=", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Rho]QSs", ",", "\[Rho]VSs"}], "}"}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Omega]", "\[Rule]", 
          RowBox[{"2", "\[Pi]", " ", "\[Nu]"}]}], ",", 
         RowBox[{"\[Theta]e", "\[Rule]", 
          FractionBox[
           RowBox[{"kb", " ", "Te"}], 
           RowBox[{"me", " ", 
            SuperscriptBox["cc", "2"]}]]}]}], "}"}]}], "/.", "ruru"}], "/.", 
     "quant"}]}], "]"}], 
  RowBox[{"(*", "rotativities", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fx", "/.", 
    RowBox[{"\[Theta]e", "\[Rule]", 
     FractionBox[
      RowBox[{"kb", " ", "Te"}], 
      RowBox[{"me", " ", 
       SuperscriptBox["cc", "2"]}]]}]}], "/.", "ruru"}], "/.", 
  "quant"}]}], "Input",
 CellChangeTimes->{{3.4804396407981987`*^9, 3.480439703525799*^9}, {
   3.4804594427693987`*^9, 3.4804594449377985`*^9}, {3.480460295169999*^9, 
   3.480460316978799*^9}, {3.480460534458399*^9, 3.4804605427419987`*^9}, {
   3.4804612138227987`*^9, 3.4804612447419987`*^9}, 3.4808663388864*^9, {
   3.4808672230008*^9, 3.480867225918*^9}, 3.4808724305928*^9, {
   3.4808727158856*^9, 3.480872716182*^9}, {3.4810364647066*^9, 
   3.4810364656426*^9}, {3.4810448332486*^9, 3.481044833467*^9}, {
   3.4819642306126003`*^9, 3.481964241907*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   FractionBox["\[Omega]", 
    RowBox[{"2", "cc"}]], 
   FractionBox[
    RowBox[{"4", "\[Pi]", " ", "ne", " ", 
     SuperscriptBox["ee", "2"]}], 
    RowBox[{"me", " ", 
     SuperscriptBox["\[Omega]", "4"]}]], 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      RowBox[{"ee", " ", "B"}], 
      RowBox[{"me", " ", "cc"}]], ")"}], "2"]}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"\[Omega]", "\[Rule]", 
     RowBox[{"2", "\[Pi]", " ", "nufr"}]}], ",", 
    RowBox[{"ne", "\[Rule]", "rho"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   FractionBox["\[Omega]", "cc"], "\[ImaginaryI]", " ", 
   RowBox[{"(", 
    RowBox[{"-", "\[ImaginaryI]"}], ")"}], 
   FractionBox[
    RowBox[{"4", "\[Pi]", " ", "ne", " ", 
     SuperscriptBox["ee", "2"]}], 
    RowBox[{"me", " ", 
     SuperscriptBox["\[Omega]", "3"]}]], 
   FractionBox[
    RowBox[{"ee", " ", "B"}], 
    RowBox[{"me", " ", "cc"}]]}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"\[Omega]", "\[Rule]", 
     RowBox[{"2", "\[Pi]", " ", "nufr"}]}], ",", 
    RowBox[{"ne", "\[Rule]", "rho"}]}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.482245382167*^9, 3.4822453890934*^9}, {
  3.4822454278906*^9, 3.4822454345674*^9}, {3.4840670918199997`*^9, 
  3.4840671116164*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"kkk", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"Sin", "[", "\[Theta]", "]"}], ",", 
     RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "}"}]}], ";", 
  RowBox[{"\[Eta]", "=."}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xmat", "=", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{"Cos", "[", "\[Theta]", "]"}], "0", 
       RowBox[{"Sin", "[", "\[Theta]", "]"}]},
      {"0", "1", "0"},
      {
       RowBox[{"-", 
        RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "0", 
       RowBox[{"Cos", "[", "\[Theta]", "]"}]}
     }], ")"}]}], ";", 
  RowBox[{"mat", "=", 
   RowBox[{"(", GridBox[{
      {"1", "0", "0"},
      {"0", 
       RowBox[{"Cos", "[", "\[Theta]", "]"}], 
       RowBox[{"Sin", "[", "\[Theta]", "]"}]},
      {"0", 
       RowBox[{"-", 
        RowBox[{"Sin", "[", "\[Theta]", "]"}]}], 
       RowBox[{"Cos", "[", "\[Theta]", "]"}]}
     }], ")"}]}], ";", 
  RowBox[{"m90", "=", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{"Cos", "[", 
        FractionBox["\[Pi]", "2"], "]"}], 
       RowBox[{"Sin", "[", 
        FractionBox["\[Pi]", "2"], "]"}], "0"},
      {
       RowBox[{"-", 
        RowBox[{"Sin", "[", 
         FractionBox["\[Pi]", "2"], "]"}]}], 
       RowBox[{"Cos", "[", 
        FractionBox["\[Pi]", "2"], "]"}], "0"},
      {"0", "0", "1"}
     }], ")"}]}], ";", 
  RowBox[{"kx", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Sin", "[", "\[Theta]", "]"}], ",", "0", ",", 
     RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invmat", "=", 
     RowBox[{"Simplify", "[", 
      RowBox[{"Inverse", "[", "mat", "]"}], "]"}]}], ")"}], "//", 
   "MatrixForm"}], ";", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invm90", "=", 
     RowBox[{"Simplify", "[", 
      RowBox[{"Inverse", "[", "m90", "]"}], "]"}]}], ")"}], "//", 
   "MatrixForm"}], ";", 
  RowBox[{"Simplify", "[", 
   RowBox[{"invmat", ".", "kkk"}], "]"}], ";", 
  RowBox[{"invm90", ".", "kx"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"T11", "=", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{"Cos", "[", 
        RowBox[{"\[Alpha]", " ", "\[Beta]"}], "]"}], 
       RowBox[{"\[Eta]", " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"\[Alpha]", " ", "\[Beta]"}], "]"}]}], "0"},
      {
       RowBox[{
        RowBox[{"-", "\[Eta]"}], " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"\[Alpha]", " ", "\[Beta]"}], "]"}]}], 
       RowBox[{"Cos", "[", 
        RowBox[{"\[Alpha]", " ", "\[Beta]"}], "]"}], "0"},
      {"0", "0", "1"}
     }], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"T22", "=", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox[
          RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"Cos", "[", 
            RowBox[{"\[Alpha]", " ", "\[Beta]"}], "]"}]}], ")"}], "2"]}], 
       RowBox[{"\[Eta]", " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
        RowBox[{"Sin", "[", 
         RowBox[{"\[Alpha]", " ", "\[Beta]"}], "]"}], 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Alpha]", " ", "\[Beta]"}], "]"}]}], ")"}]}], 
       RowBox[{"\[Eta]", " ", 
        RowBox[{"Sin", "[", "\[Theta]", "]"}], 
        RowBox[{"Cos", "[", "\[Theta]", "]"}], "\[Alpha]", " ", "\[Beta]", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Alpha]", " ", "\[Beta]"}], "]"}]}], ")"}]}]},
      {
       RowBox[{
        RowBox[{"-", "\[Eta]"}], " ", 
        SuperscriptBox[
         RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
        RowBox[{"Sin", "[", 
         RowBox[{"\[Alpha]", " ", "\[Beta]"}], "]"}], 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Alpha]", " ", "\[Beta]"}], "]"}]}], ")"}]}], 
       RowBox[{
        SuperscriptBox[
         RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
        SuperscriptBox[
         RowBox[{"Sin", "[", 
          RowBox[{"\[Alpha]", " ", "\[Beta]"}], "]"}], "2"]}], 
       RowBox[{
        RowBox[{"Sin", "[", "\[Theta]", "]"}], 
        RowBox[{"Cos", "[", "\[Theta]", "]"}], "\[Alpha]", " ", "\[Beta]", 
        " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"\[Alpha]", " ", "\[Beta]"}], "]"}]}]},
      {
       RowBox[{
        RowBox[{"-", "\[Eta]"}], " ", 
        RowBox[{"Sin", "[", "\[Theta]", "]"}], 
        RowBox[{"Cos", "[", "\[Theta]", "]"}], "\[Alpha]", " ", "\[Beta]", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Alpha]", " ", "\[Beta]"}], "]"}]}], ")"}]}], 
       RowBox[{
        RowBox[{"Sin", "[", "\[Theta]", "]"}], 
        RowBox[{"Cos", "[", "\[Theta]", "]"}], "\[Alpha]", " ", "\[Beta]", 
        " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"\[Alpha]", " ", "\[Beta]"}], "]"}]}], 
       RowBox[{
        SuperscriptBox[
         RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"], 
        SuperscriptBox["\[Alpha]", "2"], 
        SuperscriptBox["\[Beta]", "2"]}]}
     }], ")"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"rot11", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"FullSimplify", "[", 
       RowBox[{"invmat", ".", "T11", ".", "mat"}], "]"}], "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"1", ";;", "2"}], ",", 
        RowBox[{"1", ";;", "2"}]}], "]"}], "]"}], "/.", 
     RowBox[{"\[Alpha]", "\[Rule]", "\[Xi]"}]}]}], " ", ")"}], "//", 
  "MatrixForm"}], "\n", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"rot22", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"FullSimplify", "[", 
       RowBox[{"invmat", ".", "T22", ".", "mat"}], "]"}], "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"1", ";;", "2"}], ",", 
        RowBox[{"1", ";;", "2"}]}], "]"}], "]"}], "/.", 
     RowBox[{"\[Alpha]", "\[Rule]", "\[Xi]"}]}]}], ")"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Eta]", "=", 
    RowBox[{"-", "1"}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"total", "=", 
     RowBox[{
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", 
        SuperscriptBox["ee", "2"], "ne", " ", "\[Omega]", " ", 
        SuperscriptBox["\[Rho]", "2"]}], 
       RowBox[{
        SuperscriptBox["cc", "2"], "me", " ", 
        RowBox[{"BesselK", "[", 
         RowBox[{"2", ",", "\[Rho]"}], "]"}]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"rot11", " ", 
         FractionBox[
          RowBox[{"BesselK", "[", 
           RowBox[{"2", ",", "Rex"}], "]"}], 
          SuperscriptBox["Rex", "2"]]}], "-", 
        RowBox[{"rot22", " ", 
         FractionBox[
          RowBox[{"BesselK", "[", 
           RowBox[{"3", ",", "Rex"}], "]"}], 
          RowBox[{
           SuperscriptBox["\[Beta]", "2"], " ", 
           SuperscriptBox["Rex", "3"]}]]}]}], ")"}]}]}], ";"}], "*)"}], 
  RowBox[{"(*", 
   RowBox[{"final", " ", "expression", " ", "to", " ", "integrate"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rex", "=", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["\[Rho]", "2"], "-", 
      RowBox[{"2", "\[ImaginaryI]", " ", "\[Rho]", " ", "\[Xi]"}], "-", 
      RowBox[{
       SuperscriptBox["\[Xi]", "2"], 
       SuperscriptBox[
        RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "+", 
      RowBox[{"2", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Cos", "[", 
           RowBox[{"\[Beta]", " ", "\[Xi]"}], "]"}]}], ")"}], "/", 
        SuperscriptBox["\[Beta]", "2"]}]}]}], ")"}], 
    RowBox[{"1", "/", "2"}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"total", "=", 
   RowBox[{
    FractionBox[
     RowBox[{"\[ImaginaryI]", " ", 
      SuperscriptBox["ee", "2"], "ne", " ", 
      SuperscriptBox["\[Rho]", "2"]}], 
     RowBox[{
      SuperscriptBox["cc", "2"], "me", " ", 
      RowBox[{"BesselK", "[", 
       RowBox[{"2", ",", "\[Rho]"}], "]"}]}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"rot11", " ", 
       FractionBox[
        RowBox[{"BesselK", "[", 
         RowBox[{"2", ",", "Rex"}], "]"}], 
        SuperscriptBox["Rex", "2"]]}], "-", 
      RowBox[{"rot22", " ", 
       FractionBox[
        RowBox[{"BesselK", "[", 
         RowBox[{"3", ",", "Rex"}], "]"}], 
        RowBox[{
         SuperscriptBox["\[Beta]", "2"], " ", 
         SuperscriptBox["Rex", "3"]}]]}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"nonmagn", "=", 
    RowBox[{"Normal", "[", 
     RowBox[{"Series", "[", 
      RowBox[{"total", ",", 
       RowBox[{"{", 
        RowBox[{"\[Beta]", ",", "0", ",", "0"}], "}"}]}], "]"}], "]"}]}], 
   ";"}], 
  RowBox[{"(*", 
   RowBox[{"non", "-", 
    RowBox[{
    "magnetic", " ", "part", " ", "of", " ", "the", " ", "response"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"magn", "=", 
   RowBox[{"total", "-", "nonmagn"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.4133037135*^9, 3.413303800265625*^9}, {
   3.413304948984375*^9, 3.413304995890625*^9}, {3.4191773145625*^9, 
   3.4191773438125*^9}, {3.4808634128568*^9, 3.4808634131219997`*^9}, 
   3.4808634578627996`*^9, {3.4808637079308*^9, 3.4808637773196*^9}, {
   3.4808640027708*^9, 3.4808640044088*^9}, {3.4808641684428*^9, 
   3.4808641693164*^9}, {3.4808647527876*^9, 3.4808647816632*^9}, 
   3.4808649217824*^9, {3.4808653407984*^9, 3.4808654042592*^9}, {
   3.4808654771424*^9, 3.4808655103548*^9}, {3.48086704254*^9, 
   3.4808670537564*^9}, {3.4808671118664*^9, 3.4808671174356003`*^9}, {
   3.4808733879336*^9, 3.4808734398036003`*^9}, {3.4808735042004004`*^9, 
   3.4808735554776*^9}, {3.4810446948922*^9, 3.4810447424254*^9}, 
   3.4810448045601997`*^9, {3.4810449132298*^9, 3.4810449189238*^9}, {
   3.4810451325814*^9, 3.4810451950282*^9}, {3.4814679420948*^9, 
   3.4814680287372*^9}, {3.4814682053136*^9, 3.4814682355464*^9}, 
   3.4814691678336*^9, {3.4814691991428003`*^9, 3.4814692049616003`*^9}, 
   3.4814729906916*^9, {3.481473123666*^9, 3.4814731237908*^9}, {
   3.481473206034*^9, 3.4814732070168*^9}, 3.481473239184*^9, {
   3.4814734381932*^9, 3.481473474042*^9}, 3.4814737075584*^9, {
   3.4814743928664*^9, 3.4814744111184*^9}, {3.4814744451264*^9, 
   3.4814744452668*^9}, {3.4814744842980003`*^9, 3.4814744888375998`*^9}, {
   3.4814746037316*^9, 3.4814746974096003`*^9}, {3.4814747355984*^9, 
   3.4814748028968*^9}, {3.4814748713652*^9, 3.4814748818016*^9}, 
   3.4814749152636003`*^9, 3.4814974433016*^9, {3.481541211113*^9, 
   3.4815412116434*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"acc", "=", "7"}], ";", 
  RowBox[{"roro", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Omega]", "\[Rule]", "1"}], ",", 
       RowBox[{"q", "\[Rule]", "ee"}], ",", 
       RowBox[{"ne", "\[Rule]", "1"}], ",", 
       RowBox[{"m", "\[Rule]", "1"}], ",", 
       RowBox[{"\[Rho]", "\[Rule]", 
        FractionBox[
         RowBox[{"me", " ", 
          SuperscriptBox["cc", "2"]}], 
         RowBox[{"kb", " ", "Te"}]]}]}], "}"}], "/.", "ruru"}], "/.", 
    "quant"}]}], ";", 
  RowBox[{"resx", "=", 
   RowBox[{"Quiet", "[", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Cos", "[", "\[Alpha]", "]"}], "+", 
              RowBox[{"\[ImaginaryI]", " ", 
               RowBox[{"Sin", "[", "\[Alpha]", "]"}]}]}], ")"}], "magn"}], "/.",
            "roro"}], "/.", "ruru"}], "/.", "quant"}], "/.", 
        RowBox[{"\[Xi]", "\[Rule]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Cos", "[", "\[Alpha]", "]"}], "+", 
            RowBox[{"\[ImaginaryI]", " ", 
             RowBox[{"Sin", "[", "\[Alpha]", "]"}]}]}], ")"}], "x"}]}]}], "/.", 
       RowBox[{"\[Alpha]", "\[Rule]", 
        FractionBox["\[Pi]", "4."]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", 
        RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
      RowBox[{"MaxRecursion", "\[Rule]", "40"}], ",", 
      RowBox[{"PrecisionGoal", "\[Rule]", "acc"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      FractionBox["cc", "\[Nu]"], "resx"}], "/.", "ruru"}], "/.", "quant"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Alpha]IT", "=", 
    RowBox[{"Im", "[", 
     RowBox[{
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1"}], "]"}], "]"}], "+", 
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "]"}]}], ";", 
   RowBox[{"\[Alpha]QT", "=", 
    RowBox[{"Im", "[", 
     RowBox[{
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1"}], "]"}], "]"}], "-", 
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "]"}]}], ";", 
   RowBox[{"\[Alpha]VT", "=", 
    RowBox[{
     RowBox[{"-", "2"}], 
     RowBox[{"Re", "[", 
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}]}]}], ";", 
   RowBox[{"\[Rho]QT", "=", 
    RowBox[{"Re", "[", 
     RowBox[{
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1"}], "]"}], "]"}], "-", 
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "]"}]}], ";", 
   RowBox[{"\[Rho]VT", "=", 
    RowBox[{"2", 
     RowBox[{"Im", "[", 
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}]}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"old", " ", "definitions"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Alpha]IT", "=", 
    RowBox[{"Im", "[", 
     RowBox[{
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1"}], "]"}], "]"}], "+", 
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "]"}]}], ";", 
   RowBox[{"\[Alpha]QT", "=", 
    RowBox[{"Im", "[", 
     RowBox[{
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1"}], "]"}], "]"}], "-", 
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "]"}]}], ";", 
   RowBox[{"\[Alpha]VT", "=", 
    RowBox[{"2", 
     RowBox[{"Re", "[", 
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}]}]}], ";", 
   RowBox[{"\[Rho]QT", "=", 
    RowBox[{"Re", "[", 
     RowBox[{
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "2"}], "]"}], "]"}], "-", 
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "]"}]}], ";", 
   RowBox[{"\[Rho]VT", "=", 
    RowBox[{"2", 
     RowBox[{"Im", "[", 
      RowBox[{"res", "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}]}]}], ";"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"new", " ", "definitions"}], " ", "-", " ", 
    RowBox[{"all", " ", "quantities", " ", "are", " ", "positive"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
  "\[Alpha]IT", ",", "\[Alpha]QT", ",", "\[Alpha]VT", ",", "\[Rho]QT", ",", 
   "\[Rho]VT"}], "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   FractionBox["\[Alpha]IS", "\[Alpha]IT"], ",", 
   FractionBox["\[Alpha]QS", "\[Alpha]QT"], ",", 
   FractionBox["\[Alpha]VS", "\[Alpha]VT"], ",", 
   FractionBox["\[Rho]QS", "\[Rho]QT"], ",", 
   FractionBox["\[Rho]VS", "\[Rho]VT"]}], "}"}]}], "Input",
 CellChangeTimes->{{3.4804599722811985`*^9, 3.480460126346799*^9}, {
   3.480460167031599*^9, 3.480460282159599*^9}, {3.480460338303999*^9, 
   3.4804603489743986`*^9}, {3.4804604017335987`*^9, 
   3.4804604426835985`*^9}, {3.480460612473999*^9, 3.4804606245639987`*^9}, 
   3.4804607803767986`*^9, {3.4804609788399987`*^9, 3.4804609908051987`*^9}, {
   3.48086278335*^9, 3.4808627883732*^9}, {3.4808632842036*^9, 
   3.4808632934700003`*^9}, {3.480865740408*^9, 3.480865755774*^9}, {
   3.4808658876563997`*^9, 3.48086589009*^9}, 3.4808662379231997`*^9, {
   3.4819604773618*^9, 3.4819604993266*^9}, {3.4819605293722*^9, 
   3.4819605454245996`*^9}, {3.4819606026610003`*^9, 3.4819606476514*^9}, {
   3.4819641858718*^9, 3.4819642124698*^9}, {3.4819642878802*^9, 
   3.4819642958518*^9}, 3.4840667306644*^9}],

Cell[CellGroupData[{

Cell["correct inclusion of low-temperature regime", "Subsubsection",
 CellChangeTimes->{{3.52603706255857*^9, 3.5260370743742456`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"inum", "=", "100"}], ";", 
  RowBox[{"\[Theta]etab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"0.4", " ", 
      SuperscriptBox["1.05", "i"]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"-", "inum"}], ",", "inum"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lookuprV", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"BesselK", "[", 
         RowBox[{"0", ",", 
          SuperscriptBox["\[Theta]e", 
           RowBox[{"-", "1"}]]}], "]"}], 
        RowBox[{"BesselK", "[", 
         RowBox[{"2", ",", 
          SuperscriptBox["\[Theta]e", 
           RowBox[{"-", "1"}]]}], "]"}]], "/.", 
       RowBox[{"\[Theta]e", "\[Rule]", 
        RowBox[{"\[Theta]etab", "[", 
         RowBox[{"[", "i", "]"}], "]"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"Length", "[", "\[Theta]etab", "]"}]}], "}"}]}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lookuprQ", "=", 
   RowBox[{"Log", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{"BesselK", "[", 
          RowBox[{"1", ",", 
           SuperscriptBox["\[Theta]e", 
            RowBox[{"-", "1"}]]}], "]"}], 
         RowBox[{"BesselK", "[", 
          RowBox[{"2", ",", 
           SuperscriptBox["\[Theta]e", 
            RowBox[{"-", "1"}]]}], "]"}]], "+", 
        RowBox[{"6", "\[Theta]e"}]}], "/.", 
       RowBox[{"\[Theta]e", "\[Rule]", 
        RowBox[{"\[Theta]etab", "[", 
         RowBox[{"[", "i", "]"}], "]"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"Length", "[", "\[Theta]etab", "]"}]}], "}"}]}], "]"}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.526037255439602*^9, 3.5260372561816444`*^9}, 
   3.526038067182031*^9, {3.5260381160538263`*^9, 3.5260381338128424`*^9}, {
   3.5260393219728575`*^9, 3.526039349436428*^9}}],

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\mathematica\\\\3DMHD\\\\lookuprQa.dat\>\"", ",", "lookuprQ"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
  "\"\<E:\\\\mathematica\\\\3DMHD\\\\lookuprVa.dat\>\"", ",", "lookuprV"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.526039365994375*^9, 3.5260394189274025`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"inum", "=", "100"}], ";", 
  RowBox[{"\[Theta]etab", "=", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"0.4", " ", 
       SuperscriptBox["1.05", "i"]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"-", "inum"}], ",", "inum"}], "}"}]}], "]"}], "6", " ", 
    SuperscriptBox["10", "9"]}]}]}]], "Input",
 CellChangeTimes->{{3.526038138128089*^9, 3.52603816244748*^9}, {
  3.5260389525344996`*^9, 3.526038965854704*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Length", "[", "\[Theta]etab", "]"}], "-", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"2", "inum"}], "+", "1"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.526039264741584*^9, 3.526039275231184*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    FractionBox[
     RowBox[{"BesselK", "[", 
      RowBox[{"0", ",", 
       SuperscriptBox["\[Theta]e", 
        RowBox[{"-", "1"}]]}], "]"}], 
     RowBox[{"BesselK", "[", 
      RowBox[{"2", ",", 
       SuperscriptBox["\[Theta]e", 
        RowBox[{"-", "1"}]]}], "]"}]], ",", 
    RowBox[{
     FractionBox[
      RowBox[{"BesselK", "[", 
       RowBox[{"1", ",", 
        SuperscriptBox["\[Theta]e", 
         RowBox[{"-", "1"}]]}], "]"}], 
      RowBox[{"BesselK", "[", 
       RowBox[{"2", ",", 
        SuperscriptBox["\[Theta]e", 
         RowBox[{"-", "1"}]]}], "]"}]], "+", 
     RowBox[{"6", "\[Theta]e"}]}]}], "}"}], "/.", 
  RowBox[{"\[Theta]e", "\[Rule]", 
   RowBox[{"Exp", "[", "0.12575", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.526047542600377*^9, 3.5260475685302763`*^9}, {
  3.5260476220181513`*^9, 3.526047622545659*^9}, {3.526047661993266*^9, 
  3.526047668720869*^9}, {3.5260477210436735`*^9, 3.5260477252812386`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"r1", "=", "20030"}], ";", 
  RowBox[{"B1", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "7.64733"}], "*", 
      SuperscriptBox["10", 
       RowBox[{"-", "5"}]]}], ",", "0.000137425", ",", "0.0050052867"}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"r2", "=", "2891.2"}], ";", 
  RowBox[{"B2", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.0004173620"}], ",", "0.0009503498", ",", "0.034529621"}],
     "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox["r1", "r2"], 
  FractionBox["B1", "B2"], 
  RowBox[{"(*", 
   RowBox[{"for", " ", "2.0", " ", "extension"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.526048971255883*^9, 3.526049051520474*^9}, {
  3.5260490920407915`*^9, 3.5260491709213033`*^9}, {3.526049204716236*^9, 
  3.5260492104895663`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Definitions of cos2k, sin2k", "Subsection",
 CellChangeTimes->{{3.4840676592076*^9, 3.4840676602060003`*^9}}],

Cell["see Lei, Roman 2010 paper", "Text",
 CellChangeTimes->{{3.484069809946*^9, 3.4840698184948*^9}}],

Cell[BoxData[
 RowBox[{
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzs3Q14XVWdL/7de+stajGP0wf+E8SbYTqMGR6c8BQdQIXECwZnGIgv6Qh/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     "], {{0, 679}, {777, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{426.00000000000006`, Automatic},
   ImageSizeRaw->{777, 679},
   PlotRange->{{0, 777}, {0, 679}}], 
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzt3c1rY2meL3jBLPMv8LJIaEgykqEr8cC9MGCY7lhMDQgGclEX0iSBoRZF
MeSADQHdkButDAGDe9WDoTTQl4ZCdDIwUC4wtfEmC3M90AyBYBZFKTBcElEE
wShJEhPz+DwRDlnnRZIt6Tk65/Ph3Et1pCw/kl/O18/L7/ezZ//L//zsv+l0
Ov85/H//Ify/2//9FgAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAABY0nA4TD0EAACKnZyc
jEaj1KMAAKCAqAYAUFu7u7v9fj/1KAAAuGeY6XQ6BwcHqccCAMA9/UwnM86k
HhEAAO+IagAAtdXNxKh2lkk9IgAAbo3H486UXib1oAAAuHV2dtbJmUwmqccF
AICoBgBQX71eLx/VLi4uUo8LAKDtJpNJPqcFJycnqYcGANB2V1dXhVFtd3c3
9dAAANpOVAMAqK2Tk5PCqBYMh8PUowMAaLXd3d2yqKZ1OwBAKqNMWU4Lut1u
6jECALSUqAYAUFvTLdrLaN0OAJDEQaY6qmndDgCweTMt2sscZlIPFgCgXUQ1
AIDaKmzRXkbrdgCATSps0V5G63YAgE1aPKd1tG4HANgsUQ0AoJ7KWrSX0bod
AGBjKlq0lwnpLvWoAQBaodvtLhvVtG4HANgMUQ0AoIbmtmgvo3U7AMC6DTIP
iGpBjHmpXwEAQGMt0qK9jNbtAABrJaoBANTTgi3ay8SYl/pFAAA008XFxWOi
WqR1OwDAOizVor2M1u0AAOsgqgGwRm/+78Hpt+G6vP4x9VBgKz0+pwUh76V+
HQDU0w/D0y/C1ek82T8ehMAms8Hilm3RXkbrdgDK3LwahOvZTrxjPMky2++H
b25Sjwu2wANatJfRuh2AQqIaPJioBsB8P10ef9wJ10o9PTo9D1d7Mpv+PjzA
A1q0l9G6HaCx1hXVfheuby+v25DVwl1yN5N6IGyNB7doL6N1OwDFXp+H66jF
C6DTa1ipx8LWiA2hVhjVOlq3A1BIVBPVWJ6oBsBGtLdYx2QyyXfZTj0otsZj
WrSXGWRSvzIA6qStJXDH43HhfVYrRhYRvk9WG9IirdsBIK4x7e7uFt4rh8Nh
6gGyBVbSor1M+Dsi9esDgGRENR5PVAOAdbi6uopFOcrukqIai1hJi/YyWrcD
0E6LzISIaiyiIu0/ntbtALRNP7PIXdL5O+ZaVYv2CkuNZzweD9fMcRsA1kpU
Y4VENQBYlXCLWaqhtqjGXAvG/sdYqnV7+KZd93iGNgYAsGqTzLJFSkU15lph
i/Yy4e+LxccjqgFsg9fhGp5/O5jyu+P9nU7ntmHU09Nhi/pE3RqNRg8rJr/U
LZK2WXmL9jJLtW4X1QC2gah2j6jGOohqACzjNp69PH22s7N//K/H4drfyf+K
vQ1rT09ftiqpVVS4nevw8DD18KmvdbRoL7N463ZRDWB73Ly5fLHX6ex9+BX7
RbhOhz+kHtiGXGQeU/NKVKPCOlq0l1m8dfu6o9pXX3217jcWoEWuB/udzv7d
L9mPj8N1+VPqUW1KnPR4zK5vzbKpMFhGiP35b7CTk5MFPzz+3bHIqB5TrOPq
6upv//ZvC38WPvroo19mVOoAWCVRTVRjbUQ1AB7n5vX583dHCTI7R+fhep16
WJsX7kEnmQektdRjpyEGReuSddv09fXXX5f9IHz22WeL75cDYDHfnx99PvW7
9vOj8+/DlXpUKU0mk3DH/A8ZUY1NqnlUm/u3jJAGsHqvz4+mD4HuPD9/fROu
1MNKr5sR1dikOke1uedYF1x7BWA5oloJUY3NE9UAmHEzPH06/dt2f3D99u11
6lElV9hc+2c/+9nnn3+e//eOdR9WpLZRLcSwipAWDzWkHiNA8/wQruHpF1O/
cd9VvjWn1uv18vej2JUgHrKbOalXh5spDVDDqDa328KLFy8SDg+gyW5ehuv0
6fTyZ4sq31YYj8eFt6SZqbPwsLjLend3V1RjJeoW1cL3/KeZspym1C3AGolq
JUQ1UhHVALhzMzyd3ajWvhbthfK3y9gbqOzxk8wmR0hT1Sqqhe/qp0+ffpSZ
GZJStwDr99P14Ffhmv7126YeBVXyBz8XLwIPj1GTqBb/+vjqq6/KJtOUugVY
v9vKt1PFbz+PxW9TjyqxGMlm7kq7u7vmzdiMmkS1bzJlOa3jyDPAJohqBUQ1
0hLVAHgnq3z7ofjtzvNY/Db1sBI7zMzclfr9fupx0RZ1iGpz2+DaDACwflq0
Fyg7+Bn+PfXQaIvkUa26JYFStwCbMtOi/bbybSx++7bwZGilj48vm3Eeod/v
51/d4eHhej/r64vTF78fvrkJ13o/EdsgYVQrXP2fptQtwAaJagVENZIT1QC4
VVT5tqj47Y/X3/1TuPZ3Zn5nPz06/V24vr28bky8mEwmu7u7+dvT+rfl/PXy
+BfhLc3e1XOBreVSRbXq1lEdpW4BNquw8m1x8dufLsN1/HF83JNw7R//vpFx
Ij+f0M1s4FPHL8f7r8jTo99+F67mhGCWkSSqhZz22WefFSY0pW4BNm6pFu0/
vhr8OlzZpNrT5+evwtXUBHFwcDBzk1piB/WHNLs6O/vHg9tZS5mtVTYc1WIV
mpDE8v0IIqVuATZOVCsmqlEHohpA2xW0aC+rfHvz5uVv93c6txvV9p4Pho2t
5BHvRPmb1Diz0FOsKar97tvz4evz5r7z5G0yqsXWURXdozpK3QJs3uvzWPx2
KhLkK9/e3OW0nf3fhutlEzen3TnJzNyher3exgZwb69aNpkW59NooU1GtRcv
XlT/uaDULcDG3Va+jcVvPyS12cq3tyEty2k7e8//0PgFuHjwM3/28+rqalND
cAKUDzYW1apbEih1C5CIqDZLVKNWRDWAdpvboj2uez65vU7//U2ycW5OYRud
zdToeOf1fxn89lwJXKINRLW5pW6DLzLVj1nECocN0AozLdo7X8Tit9l/+/G2
4O35N3ud25DWkpwWhFSWv7+E/JZ6XLTUBqLaYebxMWwRKxw2QBvEc4ofjio+
PY3Fb0OGe3n6LFxZiLvXZKrZwh2w8P6i2iepiGoAbSaqzRDVqBtRDaDFCirf
3kaym1fnz++1mdo5Os+dNWim/M7qWLgj9bhoL1ENoL3yLdov/0u4BkdPOzv/
ce8/7oTr3X/ZeV5UbK1RYnnb/J1lmEk9OtpLVANordkW7Z3P9/Y+Dldn75vz
61f3T4ZOHzdopliLYOa2cnBwkHpctN0Golo/c7gRKxw2QOOJatNENepJVANo
pZ/CdT341czv/539fwrXd9c/xv869YCdux7uTdXNzLwh2uiQ3IbbtQNQD9/H
4rfTMW3vaDBddvVmeDoz7dbgkwVXV1f5u+Hu7u5aDn7eXF9++7twnR5Nvbt7
WV+Ct2+niteFN/v18PzbweBfjvefhavZs5qUEdUA2ijfor3zq8H1T3Me09yT
Bb1eL383XPXBzyx6/eHF/u1b+iRc+8f/Mnjvd8fhn6dKDc+UJv74OFyXP839
FDSQqAbQRqLafaIatSWqAbRPQYv295Vvp/0lXIP9j6ce1MyTBYU1OoLRaLSy
z/Hm5eDo6W0VlNuF5v/j8vrHy9sNgdNir9UvwnU6/P/iV+fuC9SeunbkiWoA
7TPTor3syMAPhTVyw8MaNrPW7/dn7oOrO6p2+269GQ6O9nbezaRVtVIN7/Z/
CtfT0z/+4d42ws+Pzr8P1yrGw/YR1QBaJ6t8O1X8tqoQR+w89SGrZXM7+emd
m1ffPv/HP4Tregtj3O7u7sx98CLz6Ce+nSjL5spu37m94+/CNafl/fUgXPt7
/2l/b3rK83ZtenZ5mtYQ1QBaR1S7T1SjzkQ1gLaJJTg+1Imo3rJedLJg9nDB
m++O937x/PxVuLYrqcVINnMTDMltFc8d95519mPD+2eD8NbMf3d+upwNx513
2whzOwlpC1ENoGVmtp/N3bI+c7Lg/r6pN/8ertP9vbgFa86UUf3EPWkzN8F+
v7+Cp76Nr3cdVH89ePXj/A95WxjVmrk/kMWJagDtMtuife6W9Vy0ezaIc0Q3
1xcv9j8P197zrVz3HI1G+TtgMB6PH/W8N38O1+DZk+zJbo8SPBv8edG3Jy6A
3hvO3vHl1kVgVklUA2gXUe09UY2tIKoBtMsie8/um93bNvXBIaRtaU4LTk5O
8i+p1+s97ll/fDX4dbjevcd7L8J1+WbRNyjfzKvBZYdZkKgG0Bo3sfjtvcq3
+4Prt2+v53zczInRDzkthLQtzWmTySR/8DO4urp61PPe6zJwO5+2xJRaUWli
lW8R1QBao6BF+2Jb1u/NFO3sH4drcLmlGe2d/MHPbuZxz/rXy+NffHjGbD5t
8Sm1t2/fXB7vhev9x38crv3BXx43JLaeqAbQGqLaB6Ia20JUA6CFDg4OZu59
sW36Y57z5tXg2YfFy+WLbCxTmpj2ENUAaJVhJn/vG2ce+qy5fqmL11J75+bN
5Yu9TuduTq3z9DQWv6XlRDUAWuUkM3PjC//yqCd9fT5ztHb54wAza9O3HSQq
mkjQHqIaAK0iqrFdRDUA2mMymeTveo++8c0U2di526i2xFPMlFObX5qYthDV
AGiPs7Oz/F3v0Qc/b3epTW1UW/I4wL3uBnezcvNLE9MSohrAlorb4MNv7Mlk
knosWyOksvxdL+S3Rz3pzMnNnefLtBi4PU0QDxTckx0ocKaAt6IawNYS1R5A
VGPriGoAWypGtenf3oeHh71eL9YHC/Ej/DJ/XAGKprm6upq53+1mHpt17zWT
uj0P0Fn8PMCb7473dsJ1f1zL12SjuUQ1gK1W+Gs87+Dg4DDT7/fDh8TaYqPR
KPXwNyrk2Jm3JZ4GfezzXg/2O539uyddPKplW9R2nv1v4frn/3X6+KfKt3wg
qgFstbK244uLM0shxYXQMsmkfk2rl5+BjEaZxz77Q6LaX991odp7cfnX78J1
/PHUsJZZP71dQh2enx7dnR/d2Tv6528vr7/d8s5f3BHVALaaqLYIUY3tJaoB
bLvCAhQP0O/3U7+UdYn792Ze78HBwWqefSaqzS3WcXP93Yv9cO1kzaduhqcz
RdXelc+9+a/hGv6/FZV0f7w+/yZce50n+y8uQjLLwtnr4eB5+Jfbfzz99zer
eYWkJKoBNEA385icFj68kfNpUeH7c3FxsZpn/+ny+OPO1LTYbQncvePvimPS
m5eDo6ednWfhOn35OleTLTzLx/uDv9ydDH36bPCqeHbsxyyk3fYM3Zl9zO18
3e2UXefJs8GfHU/YdqIaQANcZR4T1Rr8mz9EsvzrXcHBzw9ue0LNtIUKMWn/
+PfDNzfhun3Im+H5747DtX+b425DWpbT8h/7fkbu5s+DXx3dXmU939/1sSqe
wfswU5dN3C3ZOJ56EdUAGkBUqyCqiWpbTVQDaIzDw8MHhLR+JvXY16jwbVnt
S87vNyuzs/9P311PB6e/DPY/Dtf9qPZfX57+4z+evwpX0drlD3HZ9PbhT09j
sdzcgF7GwrxxKbZ0NZZtIKoBNEb47b1sTjs4OGjqqc+o8OBnsOrKwD/ebR4r
8fTot9+FK3cscyaqvX/w4GUIV8X56vX5+ym12wMI784gzLr96MvjbDjLdU+g
dkQ1gCY5OTlZKqodHR01O6r1+/2ZlxxLAa/ns72rm/GhdMbeUbhOB//X5XXZ
EuTNm5e/Ddftwujtmum/hut8WHHq8/YQQ3aOoRObGsS+BvlHhet68KtsEJ+H
6+j8+xW8PlIQ1QCaRFSbIaqJattOVANokrL1vgqxBO7V1VXqsa9YjKD5+sAX
mdSje7Dp4h63ZT2yyh7F7hLdXVNRtpGoBtAwheVeF9Hr9Zo0wxYj2cxr7Ha7
qcf1SNMnRveOL9+Eq+yh76NaFteKt7SxBUQ1gIYpm01aRCwV24y7wEFm5gWG
u17qcT3S9DGEJaJaZ39wvclhsjqiGkDDiGqRqCaqNYOoBtBIFY1BT09P5zai
6vf7W70YOhqNCl/Xqmt0bJ6o1jqiGkBTFYaxePgxxrD86chpWz3DVngSttfr
pR7X44lqrSOqATTVTKupeNJzZlop/MKP/16R2bZu0bBs/bcRp1xFtdYR1QCa
SlQT1US1BhDVABoslnuNv9vPMvnHxMXQXq9XkdbiFv3RaLT5l/AA+X16cTE3
9bhWQrGO1hHVABpsmOm836JW7erqqhkzbPlNemUxdQtNl8C97UFQ0oZguluB
ErjbTVQDaLzwq37Bs5yLz7DV8yjlXTSdsdWnWe+7eX3+PFxZt/aKbgU/xFCX
vfq9OP+26ZGyIoVRbSv+aAJgQaKaqCaqbS9RDYC8s7Oz6sXQ8J9quKR4kpkZ
aviX1ONaqdfn4TrKstrO0XnJJrTv46627EHPw3X+2vrnthLVACg0ztydSigU
jy3UZIatrFV943b1/DVcl8e/uH1tT0/DNcynsJuX4Tp9ertLbe/4u3CZU9te
ohoA1RaZYbu4uEg9zOI72sHBQepxrcXNq8Gz24m1L8J1Ovxh9r8OT8P19HZK
7deDVz+GK8kgWQlRDYBqoloNiWrtIaoBMNcok+9+Pq2XSbh7v7CRVh0y5Hr8
+Grw653Ozk62xHl/ffN2eTRbIX3ybPDnm5DcEg2RlRDVAFhc4V1jZoYtSVOA
mdYMnffdGZpy8LPQ65enz8K103myf/rvIa3dBrab6+9e7O90nobraPDSFrUG
ENUAWEo9Z9jyBUbiadCNDSCRH8N1fTk43n/y/nU/2T/+1/Ph63ClHhurIaoB
sBRRrU5EteYT1QB4mH6/X5HWOlnnzQ0UyohFRfKfPUbKdX92WDdRDYAHi90B
Cvfz3+ln1jfDFp9/5pMu0vMUtoKoBsAjhRiWcIatsJBIcw9+0jqiGgCPJKrB
+ohqAKxEXAytqJQb7y+rvcWESJb/LGEMK/wUkJaoBsAKTSaT/GHMGQcHB6va
8F/YorTf76/kyaEORDUAVu4qs+4ZtpD3Cp+5Ju3jYSVENQBWTlSDVRHVAFiT
BRdDH5ysTk5OZp4tlt5d7auAtEQ1ANbqLFMxwxb+U3zM4s85yeSfM87mre+1
wOaJagBswHg8LjwCMC08YMEZtovMzId3u911vwrYPFENgA0Q1eBhRDUANmaR
xdAYw6qf5yDj5kUbiGoAbNhoNMoHrRm9Xq+sbehwOCz8EAc/aSRRDYAkYrGO
irS2u7tbeEwgf/AzCP+Y5FXAuolqACQhqsEiRDUAElp2MTT8j8LHrKkXPCQn
qgGQXD9Tkda63W5sB392dpb/T85+0mCiGgA1EZJYCF3VM2w///nPZ/5l2fK5
sF1ENQBqQlSDPFENgPqYTCZzF0On7e7uxiZTqQcO6yKqAVBDw+GwolLuHQc/
aTxRDYB6mkwmvUxFVBuNRqmHCeslqgFQT6IavBXVAKi9q6ur6cXQP/3pTyeZ
g4OD1EODtRPVAKi/uxk2dyjaRlQDAKgtUQ0AoLZENQCA2hLVAABqS1QDAKgt
UQ0AoLZENQCA2hLVAABqS1QDAKgtUQ0AoLZENQCA2hLVAABqS1QDAKgtUQ0A
oLZENQCA2hLVAABqS1QDAKgtUQ0AoLZENQCA2hLVAABqS1QDAKgtUQ0AoLZE
NQCA2hLVAABqS1QDAKgtUQ0AoLZENQCA2hLVAABqS1QDAKgtUQ0AoLZENQCA
2hLVAABqS1QDAKgtUQ0AoLZENQCA2rq6uhLVAADqaTgcimoAAPUkqgEA1Jao
BgBQW6IaAEBtiWoAALUlqgEA1JaoBgBQW6IaAEBtiWoAALUlqgEA1JaoBgBQ
W6IaAEBtiWoAALUlqgEA1JaoBgBQW6IaAEBtiWoAALUlqgEA1JaoBgBQW6Ia
AEBtiWoAALUlqgEA1JaoBgBQW6IaAEBtiWoAALUlqgEA1JaoBgBQW6IaAEBt
iWoAALUlqgEA1JaoBgBQW6IaAEBtiWoAALUlqgEA1JaoBgBQW6IaAEBtiWoA
ALUlqgEA1JaoBgBQW6IaAEBtiWoAALUlqgEA1JaoBgBQW6IaAEBtiWoAALUl
qgEA1JaoBgBQW6IaAEBtiWoAALUlqgEA1JaoBgBQW6IaAEBtiWoAALUlqgEA
1JaoBgBQW6IaAEBtiWoAALUlqgEA1JaoBgBQW6IaAEBtiWoAALUlqgEA1Jao
BgBQW6IaAEBtiWoAALUlqgEA1JaoBgBQW6IaAEBtiWoAALUlqgEA1JaoBgBQ
W6IaAEBtiWoAALUlqgEA1JaoBgBQW6IaAEBtiWoAALUlqgEA1JaoBgBQW6Ia
AEBtiWoAALUlqgEA1JaoBgBQW6IaAEBtiWoAALUlqgEA1JaoBgBQW6IaAEBt
iWoAALUlqgEA1JaoBgBQN8P3zs7ORDUAgMcbj8d3+Wrw3mg0mn7MgrNk+ceI
agAAZULiuri4iOmr3+8fHh6OMtOPCf9pbqwqjGrh2WY+nagGALA4UQ0AIJXJ
ZDK9dpl/QK/Xm8lL8fHTjwlZTlQDAFitkJRmstA4M/2Y/IzZRWb6MYvsQwuZ
UFQDAIhCfArBppc5ODjY3d3NP+ZhM2ZxMXTmc+VjVXjymU8X/z0M5vC9fr8/
85i7UwknJyeiGgDQVKIaAEAdzCxZRt1udybnLLK4eZaZfkw+hvUz04+ZTCZ3
ESt8eMx7M0cPlqUELgCwpUIKCokozpjtZvKPyc+YXWWmHxP+z7kzZiHdxQB2
l8HW+9reE9UAgC0VstkDZszyMSxEvrvlyPCfLi4u8oU4UhHVAIAtJaoBAKQy
mUziYuXJyUm+nEWQ33I/t4BGSHf5qFZnohoAUEP5GJaf6cqfyjzJzDxVCDYx
8hWeO6g5UQ0ASKtwqTF/HCB/KjNEr+kHdLvd7ZoxW4SoBgCkJapVENUAgM2L
tS+CWPcsfxwgv7gZi3LMPM9WL24uQlQDADbmLpLNbEXLz5jle2WWVU5rNlEN
AFirGM/6/X63272bGZupOnuQmfnAg/dCMqlJ6YzNE9UAgLUS1R5DVAMA1uTi
4uLw8DCfNOIaaFzQzP8700Q1AGCF4gRaPoZNi9vSYg20TrYJLf5vUS1PVAMA
Hi8kiri4WRbPpsW1zljSdqa5ADNENQDg8US1NRHVAIAHiz03Q/RaJKF13hfc
yPd+ooyoBgAsZZIJCS1Wr13Q4eGhCbQHENUA1u3ivfArt7UFB2iGkNBCSKg+
MjAzh9bv9/OdCFicqAawbqIajSGqbZ6oBrBuZ2dnhbeww/diJ8TYxzD8Wg53
w9RDhntiQoshbZGEdnBwEP88ST3wJhDVADagm1nkHjctfEgIcvFUXfjNHCLf
MGNqjk0K33gLJrRYGy18i6YecqOIagAbECPWslGtjN/SbEA8NbDgnxiq166P
qAawAaIaW0dUqwlRDWBjFqwOWqGwpTWsUPyzYpE6abu7uyEwxMIdqUfdZKIa
wMaMx+NHRrVY3T3166CZwvfnIn9NxIQWQ1rqIbeCqAawSeEX7INzml/OrMPd
6c4FvwkltA0T1QA2SVSjbkS1mhPVADYp3OYeVrjDFjXW4erqapHvxnhqwMGB
JEQ1gA2LpUGXjWp/+tOfUg+c5gihK5Zfrv6ui4+R0NIS1QCSmHuXnLG7u3t2
dpZ61DTBIk0HDg4OVLKtCVENIAlRjVREte0iqgEkMRqNlopqkQUpHix8y8W6
fHP/IvBHQa2IagCpnJycPCCtdcywsbxFDniGb0inO2tIVANIJdwWdzNlt86f
//znFTfWOMOmIi4VFplJi2udljtrS1QDSEVUY91EtQYQ1QASivuC8r+HY+21
WJu04ibrlzYVwrdWxR8C8c8E3zz1J6oBJJef9Jie5Yh9P+dOjARm2HibzdbO
rZkWD6c4n7IVRDWA5GZ+Ffd6vcKHmWFjrvC9NHcmzZmU7VIY1ULYTj0ugBYR
1VgVUa15RDWAOgjx7O5mWlEwYfHFULvE26afqfjGsOi5pUQ1gDoIN9A443F1
dbXI4+OO8eqa8+HGPcmse/CkFTenVXwndEy3bjNRDaAmli2YEGdIqu/R8SSp
Gbamit8zFYk9fPXjTGzqkabyOlzD828Hp0d7nc7e3fuysx+u49/9cfjmJvUI
5xPVAGpCVGNZoto8ohoA6VkMbafCinzT2t0o6vXwDy/2dzrhqrLz7PTl63Cl
Hm0VUQ2gARafYVtwLxy1FSN3RQPZENovMqlHmsbN9UW4Xuw/yd6M8P8/2T/+
1/PhXRi7eTP8/fH+k+N3Dwhp7dfhGrz6MeWgK4lqAE0SktjcGbZer2eGbUuF
r1p1o6h2V0K+efPytx9m0vaeD4avB8OiGbM334XreO/DjNvO0XltZ9ZENYAm
EdWaTVSrJKoBsAViDLsr1FZoqcIg1ETIYBUhvJdpawL/MVzX59/s3b0de9+c
X1esad4+/tXg11Mb2b44Hf6wufEuQ1QDaCozbI0R955VfCnb3YDg5s3li3C9
y2kL7z27GZ4+/fAW7jw9fXkT/nED412SqAbQYIvPsLV2F3r9hS9N9deu3bOj
9xc9O0+eDf4croUS1/Vgf+rNjGugNVwGFdUAGkxUawBRrZKoBkAThN/2sVhH
RWbTI7KGKopyxBMELT5EkJk5HfBs8Orm7asFVzF/ujz+eOoN/fj48qe34aob
UQ2gJeIMW3VH7zhL0+6NT3VxkqnI1W3fYXjz53ANnj2ZeleWPBpwf1ats/P8
/PVNuNY24gcS1QDaxgxbzVW3X48RLvUYk7s9v3n/COfyBTdmolrnV4Prn8K1
phE/mKgG0DaiWs2JagsQ1UQ1gCZbfDF0MBikHmyLxK9LRYVbX47o5tXg2U7n
2Yeg9sUDCqPNbFUT1QCoodFoVF39vmP7+qbM7UTglO57f708/sX0O7PzbBAP
FCzstoLa6/Pn93q526sGQI0NBoOKtBaZ0lmfism0WI6j3RU57tzEgrd7996h
z4/Ovw/XMs/zJlyXx/efxglQAGpMVEtLVFuMqCaqAbSXxdAkqvenhZzm3f6g
oEBHp7P34vLNTbiWeaK/hGuwf3+r2tPT4c3bYe3WP0U1AGYtOMPW9rpeqxA7
sBc294z/LqdNuxme3m/c2Xlg787X5+E62rn/RLoVALA9xuPxYaYirXW73WEm
9WC3Vci6ZSVTYkiT0+77/vzo83Ddf6uWPvj5Njv7mTv+qV07ANtEVNsAUW1J
opqoBsCss7OzwuW5af1+32LoUqr3p8UNganHWDu5WmpZwFq27O2tH4anX4Tr
/ru+d3z5Zg2jXgFRDYBqZthWq6J+Wvx3ubfID7lw9Xk8+7n0M928PH26E677
me95DSuqRaIaAAtaZIbt5ORE0qhQPZkWZ9tSj7GWsnw1E64elq/iwYT7ZxMe
Nju3IaIaAAsS1R5PVHsgUU1UA2ABIUj0MhVpTcnWQtX707rdrpBWorDs7Qrt
3J0pqCdRDYAHCEls7gxbSHTix52y/X7qp83zfTz7uZpcVuAhrd43SVQD4GEW
mWH74osvzLAFJycnhe+Pohzz/XT5NldZ40Gt1YtatHdumxTEPgW1JaoB8DCi
2uJEtYcT1UQ1AB6nbDH0b/7mb+7+d0h04/E49UjTqM5pqUdXd0XNpDqd/cH1
27fXyz1T4ULq7S61Om9UeyuqAbAKk8mkn5m+m3z66aczyeQsk3qwm3ORKQxp
ctpiCsvVrqzv54Nm5zZNVANghcJtpdvt/veZ/P3l7i7Thhm2q6ursncgRrjU
A9wKq2omdbv0mV/9rG2L9mmiGgArJKrdEdVWQVQT1QBYsclk8r9nyoJKpwWL
oaPRqKyYiZC2hOxAQeGZguWe5+bPg2dPwvXoyJeAqAbAmsQZtorA1mniDFss
dVuW0waDQeoBbpXrwX6nsz/zJmZnCpZS3KHg2eBVrTepvSOqAbA+IbQMMtWB
LT4m9WBXoKIV+0km9QC3TKzSMTWp9rDOAn+9PP7F/a9G+D9/cXz51/WMesVE
NQDWR1QT1R5DVHsrqgGwEaPRqKz95Z3wgG2vX1FWQi28tNRD20q5qPZ5uI7O
v1/uWXI1OnaOzuvcn32GqAbAxjR7hu3s7Kwsp+mF+iA/XQ9+df+9XLZf5w+x
Mtv9oPbrwasfw7XGga+UqAbAhjVvhm2Yyb8KpW4fJxfVdp4vd/yzoOztk2eD
Py9dPjcpUQ2ADRPVWIyodktUAyCJuNBZVtQiis2qar56GEtzFL4Qreof5113
9Q9R6+PjcF3+tOCHFzSl2pYCHdNENQASGo/H4aZTkdaCbrcb7lapR1qqbIZw
S3fc1crssYJlotrNq8Gznc6zu5y39yJcl2+2LaiJagDUQOxcsI0zbDMd6u/0
er3UQ2uEbPnywwrm4lEta0/w4eux8+z05etwrX3AayCqAZCcqEYxUU1UA6A2
tmsxNO5Dy48wlsCtW6TcVjcvT5/uhOt94lrkWMFtA/aXpx9WPmNO29CA10BU
A6BWFplhi5X/E8ahkCoLjxLE856OfK7OzNGAuXXVfrw+/yZce+9D2rbntLei
GgC1FGJYr9erSGsxF6U6X1l2lODi4iLJeJosV3Cj/BTnu8m0d4/dez4Yvg7X
hse7cqIaADUkqvGOqCaqAVBXcT9Y9WJoL7PJxdCy3li6sa/Hj+F6Nfj1dFjb
Ozo9H74+fxfDXg/P/zVcx/vxHMFO9oDBcAvrchQS1QCoufrMsJV1JXCUYP1e
DwfP9zqdvervg72j315eh6shKS0jqgFQc6IaopqoBkDNxcXQbrdbcaOOi6Hj
8XgdAwhJrJvJp0SnPjfi5s3wj+EanB7dC2w7+8e/G4Tr22YltDuiGgBbJOSl
sqqz09np7Oxs5Z/65OSk8NOt43PBHVENgK0TFyKrZ9gOM6uaYSusdtvRlYD1
E9UA2DqiGu0hqgGwpTazGDrJFDYmCBwlYN1ENQC22rpn2OJRhfxzxmMOK385
MENUA6AZyirTTguPWeo5y9Y9+/3+ml4FzBDVAGgGUY1GEtUAaIxY36ysQWcU
y9UuUgatcIta0O12bVFjY0Q1AJpnJTNsZWcWwq1zM68C3opqADTUY2bYyhpI
9TNJXg6tJaoB0EiiGs0gqgHQbGdnZ7EGWkVmCwEs1k+LH1LW63P6MbAZohoA
jTfOhLtbRVqL8SzcFsv2uamiRhLhrwNRDYCWWGSG7Wc/+1n+HzWQIiFRDYCW
ENXYRqIaAO2xyGLotBjtVtX2HR5AVAOghS4uLubOsAX/Zyb1YGk1UQ2Adoon
Ogu7sc/MqjlTQEKiGgDtJKqxFUQ1AFouJLG5i6Eh0amrRhKiGgCYYaO2RDUA
uBOSWGG3gpkZtniSNPVgaQVRDQDuiGrUjagGANPiYmi/35+7GHp2dpZ6sDSf
qAYAhYbD4dwZtnDTNMPGWolqAFDGDBvJiWoAUEZUIzlRDQDmshhKKqIaACxu
MBhUpLUoPCb1MGkOUQ0AljIajQ4yFWkt/NdRJvVg2XqiGgAsRVRjk0Q1AHgY
i6FsgKgGAA9mho11E9UA4PHOzs52d3erZ9j6/f5kMkk9UraMqAYAjyeqsSai
GgCsxHg8PsxUpLVutzvMpB4sW0NUA4DVMsPGColqALByZthYFVENAFZOVGNV
RDUAWJ+Li4u5i6EnJycWQykjqgHAWoUY1stUpLUQ564yqQdL7YhqALAZIYnN
nWELic4MG9NENQDYDFGNBxDVAGBjLIayLFENADYvJLFut1s9wxbuyOPxOPVI
SUxUA4AkJpNJP1M9w3aWST1YkhHVACAJUY1FiGoAkNZwOLQYShlRDQCSM8NG
GVENAOpjwRm20WiUeqRsiKgGAPUhqjFDVAOAuhlkqgNbfEzqkbJ2ohoA1NNo
NDo4OKgObOEBZtiaTVQDgDozw9ZyohoA1Jmo1nKiGgDU34KLocPhMPVIWTFR
DQC2Rayrtru7WxHYYn22yWSSerCshqgGANtlPB6Hm3X1DFu32zXD1gyiGgBs
F1GtVUQ1ANhGFkNbQlQDgO1lhq3xRDUA2HYXmeoZtl7GDNvWEdUAYNuJag0m
qgFAM4QYFsJY9WJoiHNXV1epR8oSRDUAaJKrjBm2xhDVAKB5zLA1hqgGAM0j
qjWGqAYATRUXQ7vdbkVgO8yMx+PUg6WYqAYAzTaZTPr9/twZtrOzs9QjpYCo
BgBtMMyYYds6ohoAtIGotqVENQBoD4uhW0dUA4C2WXyGbTQapR5s24lqANBa
g8GgeoYtCI9JPcxWE9UAoLVEtfoT1QCgzUaZg4ODirR2kLEYmoSoBgC8NcNW
V6IaABAtPsM2HA5TD7YtRDUAIBLVakhUAwBmnJ2d7WYqMlu/359kUg+24UQ1
ACBvnAmpoCKtdTNm2NZKVAMAKphhS0tUAwAqiGppiWoAQDWLoQmJagDAgi4u
LubOsPV6PTNsKySqAQCLizEs5LGKtBbj3NXVVerBNoGoBgAsTlTbMFENAHiA
kMQshm6AqAYAPIwZtg0Q1QCARwpJLJ4ArchsIWDEk6SpB7tlRDUA4JFEtfUR
1QCAx4uLof1+f+5i6NnZWerBbhNRDQBYoeFwaIZthUQ1AGC1zLCtkKgGAKyW
qLZCohoAsCYLLoaOMqkHW1OiGgCwboPBoCKtReExqYdZR6IaALABo9HoIFOR
1sJ/NcM2Q1QDADZAVHsYUQ0A2CSLoUsR1QCADRuNRoeZ6hm2YSb1YBMT1QCA
VM7OznZ3d6tn2Pr9/mQyST3SZEQ1ACAVUW0uUQ0ASGg8Hs9dDO12u61dDBXV
AIA6MMNWSFQDAGrCDFueqAYA1ISolieqAQB1c3V1NXcxtNfrtWExVFQDAGoo
xLBepiKthTh3lUk92DUS1QCAOmv5DJuoBgDUmagmqgEAddbmxVBRDQDYFsPh
sNvtVs+whSQzHo9Tj3RlRDUAYItMJpN+pnqG7SyTerArIKoBAFtEVBPVAID6
a8liqKgGAGypNsywiWoAwLYbDocHBwdzZ9hGo1HqkS5NVAMAtp2oBgBQc4NM
dWCLj0k90iWIagBAk4xGo7kzbOEB2zLDJqoBAM3TmBk2UQ0AaB5RDQCg5kaj
UQg21YHt4OBgOBymHmkpUQ0AaLZYV213d7cisMX6bJPJJPVgZ4lqAEAbjMfj
uTNs3W63bjNsohoA0AaiGgBAzW3dYqioBgC0zRbNsIlqAEA7XWWqZ9h6mYQz
bKIaANBOohoAQM2FGBbCWPViaIhzIdQlGZ6oBgBQ2xk2UQ0AIKrhDJuoBgAQ
iWoAADU3zHS73YrAdpgZj8frHoyoBgCQN5lM+v3+3Bm2WFN3fcMQ1QAAyiwy
wxbj05pm2EQ1AIAyohoAQM0lXAwV1QAAFhFn2A4ODubOsI1Go1V9UlENAGAp
g8GgOq0Fg8zjP5eoBgCwFFENAKDORpm5i6HhAY9cDBXVAAAeLM6erW+GTVQD
AHik0WgUEtTcGbbhcLjsM4tqAACPJKoBANRcrKu2u7tbEdj6mclksuBzimoA
ACs0Ho/nzrB1u90FZ9hENQCAlVvVDJuoxra7yKyp8xoAPIyoBpGoBkBtLbgY
enV1VfYMhR+yyZcAj3SYCd+3Jycn40zqEQHAPVeZ6hm2XiY/wyaqse3uotqd
mNlSjwsA7gkxLISx6hm2EOdmZthENbZdPqrdBTaZDYD6ENVoJ1ENgC2y7GKo
qMa2K4tq05nNHjYAamXBGbaLiwtRjW03N6rNZLbU4wWAd4aZbre7yF1MVGNL
LR7V7gKbzAZAHYhqtIGoBsBWm0wm/X5/qag25L24929AkV6vd1gD/11myT9H
3mU2e9gAqIkYPB4wwwaNZ5INgJp4wAwbtERs1pb6ZxSAVhPVoIyoBkBNxMXQ
X/7yl6nvjVAL3W734uIi9c8lALxzkUl9e4TEYkIT0gColUUWQP/u7/5u5cf0
Up9WrKl4wjTdCdf6Go1GC35Lx2+wpRKaaTQAaktUqxVRrYyoBkCrTDIL3tHC
jTL1eGFRi0c1CQ2AehqNRgeZBW9nqccLS5gb1exJA6DOrq6udnd3FwlpUb/f
Tz1kWEJZVLPQCcBWENVoNlENgC0VN66XRbLPP/+88N912GG75KOahAZAzU0m
k5OTk7KQtpv5t3/7t5l/j/vZUo8dlnMX1cJ3dfzzJHz/px4UABQbZypOEIT/
VHYaVGMdtlEvI6EBsBVENdpGVANgW4xGo7i4WZbTTk5O3r6Pc/n/Gv899YsA
AGig6rae0zNm8X/PPKDX66UdP2zAZDKp6I+weIuEGfHPnLJnXu1LAGDrnGTK
Qtru7u7MzaKwHK4Tc7TE32byPyn/beZhz/lNJv+c/1NmteMHYOuIarA4UQ2A
jZlMJtUnCIKZNZ3wfxY+2JZsWqKfKfupubq6WvYJw89O2bPFz7WOVwFAzcV9
Nd1ut+we0ev14knPmQ8svEnF4wbQBvFnp+wH5wE/CxXbRB3VAWincGuoPuk5
GAzKPrYw3T1gJgG22pdffln4s/PJJ58sO8Nc9lTh39c0eABqTlSDRxLVAFiT
iraeIbxdZMo+NkSy/IcEmxw/1EG+Xs2dpY7YFJYofMDzALDtwl/6sSp72X2h
2+3OrQqVPygaT49u5iVAfVScBfjmm28Wf56KP50c1QFoj7m9omK7qLnPk18z
fUzZT9hqIZJ9lMn/TC1+HODp06eFP5UvXrxY9/gBqA9RDVZOVAPg8WJjmrlt
PeeKe9hmPrbb7a57/FBb+a2bd6YbsZWpLvrhqA5AG1TsfI4W37dcuM9NcU5a
7n/I5H+yvsxUf2xZl5D4nJsZPwCpzO0VtdTCZdkOasU5abnqzgXVPyCfZvIf
pUMBQBuIarABohoAy6pu69nJDhEsG7EKG9+E51nTS4BtEY8PlP2sVSSuin1u
mkkBNFWcKKs+QRA8oFhTYfabu2saWqKs3cDTp0/LPuSbb74p/BAdCgCa6jG9
oqqVTRqozwlRRb/14XCYf3xF+VwdCgCaSlSDVEQ1AKpVbGyO+e0xNZryFT9i
4Y4Vjh+2WkX0KqxbWBHt/AUE0CQLtvV8ZDeB8CT5P/z97Q/Tyg5cf/rpp/kH
l+1t004XoElCAKs46XmYeeRf6IXV1Hd3dyeZVb0QaICKE51Xmfiw6hOjOhQA
NImoBvUhqgFwJ/7mrzhBsKr6mYXlPa3RQKGnmfzP4zeZ+JhBJv+Y+LFpxw/A
Sqywredc3Yw//GERZTEsihPRZXFOhwKAbRfXHFfYK2quwgWd8FlW9fzQMNWL
m+FvqPx2gjs6FABsO1ENak5UA2it2Naz4hBB+E8r3+dfGAut0UC13/zmN4U/
pP/wD/9QVv9QMymArbamtp7VwhMWftIVztpBI1WUty3cpdbRoQBga8VKs2W/
9jvrbJie/7zxiMGaPh00Rvgz55NPPqn4sZ0RHqz0DcCWEtVg64hqAC1RfYLg
kW0958o3q4qFCNb3GaExKn548xQqBNgu8aTn4eFh2S/2g4OD1Z70LBxA/vM6
oQYLGg6Hi0e18ODU4wVgUSGAFVadvdPr9da9VnKWyefDtX5SaJiyUrfTdCgA
2DqiGjSDqAbQPHPbem6mpllhAbf1nV+ARir8k2eG/Z8A26K6dWDIbxsru1RW
a90JNVhKdeeCyP5PgPqb2ysqtova2HgKE2Ov19vYAKBJvvnmm7Kf7t/85jep
RwfAfKIaNJioBrC94trH3LaeG155LDzRoOsNPExFCWs/VgB1NhwO44xZ2a/x
JFUxR6PRzDDiIG1Ug4e5uroq/AHXoQCgzqp7RcVmUkkG1u/384lRKXV4sPz2
ho8yL168SD00AEqJatASohrAdonJpyyk7e7upm0xk1+QvcokHBJsqbIGbXc/
WakHCMA94Zd29QmCIGGFpRjJZkbV7XZTjQe2XVmxxM8yqUcHwAextfrcXlFp
9xgXTvdtpjkCNE/4cY6RLP/zrkMBQN2IatA2ohrAtri4uKguylGHX9rhtlI4
yE2W3oVtFH5+h5npP7XG4/FXX31V9iOvmRRAfeQPVN6JbT1rUgOz8ESqjWow
1y9/+cuyn/FCzlMD1EH4+7qXKft1HVJQrSasCod6dnaWelxQd19//fXiOe3T
Tz81nwZQB6IatISoBrB1QgarKMpxmKlVQ5lw7ygcqnsKzFVRJtGfPwB1E3cX
162t51zh9jEzzljkLfW4YAsUVk7L+zqTerAArZYPPDNqcoIgLz8HWJ/zDlBz
i0S1ENKSV+MBQFSDFhLVALZCdVvPWAI39RgLxPpO+TG7rcCCwo/200z+5+h/
zPirByCh2NazurNnnTfn9zMzY+71eqnHBdsn/DYYTqnzDz5AS4S/pqtPEAQ1
n5vqZmZGbhIAAGgAUQ0AoIbirvuykNbZkupJIWrmRx7CZ+pxAQA8XHVbz+Dq
6ir1GBdSeBSinpXfAACqxUORh4eHZTnt4OCgtic9CxWu3m5LzgQAmCaqAQDU
U2zrWd3Zs+YnCGaESDbzEuIRg9TjAgBYTkg1FSc9Y2my1GNcWn6j2pa+EACg
tc4yZSGts511LeJKbv61bNfqLQCAqAYAUEMhzFS39YydPVMP8yEKi8IdHByk
HhcAwHyxg3l1W8+t7mbey8y8qK2o2QsAtFzsFVXdLir1GB8lpNDC16W1NABQ
f6IaAEA9zW3r2YBVwsJTEoeHh6nHBQBQ6iRTFtJ2d3eHw2HqMa5G4R68bTzH
CgC0wdxeUbFdVOphrkZ4IYUvc3uPSAAAzSaqiWoAQA3Fiq/dbrcsp/V6va0u
ypHX7/fzrzFIPS4AgHsuLi6qT3o2shtmPpdeZVKPCwDgg8FgUJbQQniLxfxT
j3HFhpn8i009LgCAWaKaqAYA1M1kMinsqXSn2+025gTBjMJqJNtezhcAaIy5
bT1jZ8/Uw1yXwo15jSkWBwBsr7j21+BeUXNdXV0VTiGmHhcAgKgmqgEANVXd
1rPTjp5KhdvzGlmNBADYInPbejZ+s1Ys4Vv4DjT1AAUAUHMhnMRjAmU5Lfyn
8XicepibEAuP5F9+kHpoAEBLiWp3RDUAoFZGo1H1CYKgwUU5ZhxmZt6Es0zq
oQEA7RJnkCpy2mAwSD3GjRqPx4XvwziTenQAQIv0+/2yhBarv7awKfnZ2Vn+
3ej1eqnHBQC0jqiWJ6oBAGnFYhRz23q2szBF4cGKNtSRAwDqIASw6pOeh4eH
7TlBMCO8OYXvSWvfEABgk66uruae9Ew9xpQKV4Rb/p4AABsjqlUT1QCAJGJZ
sLKQ1rEdK9PtdvPvTAvPVgAAGzOZTKrbegbtPEEw7SpT+OakHhoA0EzxpGd1
r6j4mNQjTS8u/loRBgA2RlRbnKgGAGxSbOtZfYhASLtT+F61trgcALBWFxcX
ZQmto/N4TuHb1e12U48LAGiafqYspLWzV9RchY0bwtuYelwAQNOIag8gqgEA
6zaZTA4PD8tCWmwmZedVXnjfCt+x8XicemgAQBPE3e+F5VujXq/npGeZ/Ea1
GGtTjwsAaILYK6ripKeFvGr5YiaOXQAAqyKqPZKoBgCsyWAwKEtoIbxdZFKP
sb7GmfxbF/899egAgG0V23pWd/Z0gmCuwhb2vV4v9bgAgC02Ho+re0XFdlGp
h7kFupmZN9A8JADwGKLaqohqAMAKxaIc1W09U49xa4R3snDhWMoFAB6guq1n
Jzu3mHqM26Swp4OsC0ADTCaTXq93WKKXWerZYpn9MoPBYH2vZVtUnyAYZlKP
ccsUVgzWdQuABhDVNk9UWzlRDYAGy5c4ePBi3NeZsuf57LPP2rx3KLz2eEyg
7P0J/0kFsAcIkSyfeIPU4wKAlamOWJ9++ukiEWJu5GvzZNHctp6xs2fqYW6l
/CxlP5N6XACwMnHh8rPPPivLEiHIVT9DiCIh0ZV9+CCzmddSN7HLQMVJz9a+
M48Xv2/z7208XZt6dACwMqLa+ohq6yOqAdAq+T0/064yZR/75ZdffvTRR4Uf
+NVXX23yVdRKdVvP2Nkz9Ri3WIzBM29st9tNPS4AWJfC+lTRZ5n8fqo4Y1b2
UQvuc2uYONvT6/XK3pYQJ8z8PF7c4zfz3pqlBKDBQsB4mimbIpvZrV1YJX5a
CwsmhPdk7klPJwgeL7yHhW9vC/80AKA9RLXHE9U2Q1QDoJ3iwlxF+rqruRFz
XdnD2lkwIbw51W09dTtalcLiMCEGpx4XAGxC2fazjz766Msvv4yPKdvYFh8T
92ulfRWbdJapiLhOEKxW4byl3qkAtEdFUdzC7dx3Pv3007ZtmK/uFRW07Q1Z
t/F4XPhut+qvAwBaTlRbnKi2YaIaAIS74aeZshBSpj0rfXGRd25bTxvdVy6/
QB//fEg9LgDYqMISoxW+yaQe9YaMRqM4Y1b2bpycnJjkWZN8Q9X4vZp6XACQ
QEhfc0PaRx999PTp0/YcJZjbK0oh1jUpPKEcvhbt+d4DgBmiWp6oloqoBgAz
quun3WnJzvlYL67sTQiZoYVVfzep8P1XrQ6AlhsOh9U5rQ2TSCGyHh4elr0D
sUNB6rz6OlzD828Hg38+2tsJV6fz+dH59/cecnMdrstv/+V4/8nU8J/sH/9L
uL69vL5JNPQFFe4PFI8BaLnq4q5BXP1MPcx1iYtuFSc9Q4RLvAAX0tfgeH+n
E65be0en316ezgavmzfDwfsIV2Zn7/kfwkfVM7GFSJYfcbfbTT0uAEhMVBPV
6kBUA4C8WGCtOqp1mrtfKMSD6qIcSVud3qavGMCysTy5Xcp8cZELWje3j3z5
2/2KjDad1o6/C9ebJC+oUmGp4Ra2mgWAaV9++eUiN/hOtmWoYbuG5rb1TFrL
6/Vw8Hyv09l7N5ynz89fhatgPuzNd+E6fhfnnobraPAyS2LZ3rY/vMhFuF+E
6/jyr5t+QZUmk0lhYE69PxAAkolFJxbMacFnmQashIaXcJIpe6Wpe0XdRqyX
p8+mEtaTZ4M/32TTZzl/vTz+RbjK49zNm8sXU5Hvvaenwzotg+arMXczqccF
AMmIaqJafYhqADAtX2h0QV9//XXqsT/K3LaeQdI4+uOrwa/D9T6n7cTdZWVb
y26Gp0+zVc/bhz4bhJRWsER68/L06U647r/WL06HP6z3pSyj1+vNfC3OMqnH
BQAJVJe9jXvSfvOb33z00UeFD9jSG2g86Tm3rWfSnJabAdt7Ea7LN2XzXz8M
T794/9CK7We3D5t6ZJSryZZIfM/zX45xJvXoACCBirW/u4bsFdNun3zySYw9
aV/FUuY2pq9D/rx5NXh2b+rrdt0zLn0We31+dPf4ygXNny6Pw/XxvVf88f7g
L2t5GUuKs2czX46Dg4PU4wKAZEQ1UU1UA4AaioubZXFl5tRA2aGDjz766MtM
wheylOoTBMNM4iHe/Dlcg2dP7g0uS18lAez2kMHr8+dZUrvdz/b09GXFKYE6
R7W4P3Dm65K0TAoApBFiWDzFWZZbZu6PcUtbxa62mvcGjW09qzt71mNu8DZ0
vc9ddypOfQbfh+v86PPskV/MPSNQ26g2Ho8LvzQNOGgMAMv6+uuvy0LL15n8
h8QZp7KPCtLPR5UIGazb7ZYNu5epSx4oPKG58/z8dfk82evzD6ufT0/nVd4o
jIK1OAHa7/cLvzqpxwUACYhqopqoBgD1VNFE6dNPP60ujPDixYuyj42d3OuS
eTJxP15d23rmvdtyNlP1bOfo/HXFxwxPY0W1uEuteqNacbGO6ii4KYVx2kY1
AFolntb85JNPyqLL3MOPcZNb2Yd/k9nMa5mrov9CbMtevxhwt+Xszufzip5N
R6/bybF582O3n2Lms1RHwc3InzKOX6PU4wKAjYqnNfP1bD/KLHiQc26xi7Sd
3OPMXr7i/Z1ut1vTAiPTBTfepajnc6a8phdMq06J3vsUU59lbhTckPzJ3Njw
K/W4AGCjRDVRTVQDgHqa25B98fQSjx6UPc9nn32Wqg1Q+LyFtbnupG7rWeX9
lrOppHZ0Pnej2vu+n+/KqVUmtdxeuLlRcFPy+wnjPsPU4wKADak+vDnILP5s
8ehBxRMm6eQeXmN1W88az9L8FK7rwa9mktq8YwLTfT8XOcU5sxdukWMIa1dY
irnb7SYdFABsWkgphyUeXA/h7Oys7DmDTVb+v8hURMf6nSCY8cP93BXdLk1W
rU5mq5/vHjunRkf28JlmVVnz9/L+7xsSI/TM16tmJ3MBYO1Etc2M5KFENVEN
AJqpuq1n7OyZeoxzvQnX5fHe/eHPKb5xV05tbt/Poij4i+PLv67+dSxpMpkU
fuHqeOgDAFhGPOlZfYKgupxvnRTOqv1qcP1TuOY9fn7fz5tXg6kptdtot3f8
3Zs1vZRlFM6F2qgGANsu9oqqbhdV25OeRQqPFZRHtZuXH1Y/5zaTuvnz4NmT
cL171r0Xcelzba9lCYU1VebWYQYAak5UE9UAgHq6uLioKMqxbOGR+sjVVds7
vnwTrsJH3j14Xu21H18Nfv2hltreN+fXP4ZrjS9jYWX1XrZkzRoAmNXPlIW0
kN+2u2jqbLeCj/cHfwlX7nHTfT8rToneFsR9c/li7+75dp6dvkze7fODs7Oz
ma9gPDucelwAwNLm9oqK7aJSD/ORZk8WFM+YTTeTynoNFLUb+PH6u38K1/7O
u8m0OJ+2mZexoPyRkFh0JfW4AICliWofiGoAQG3E1uoVRTkODw9j4Y7UI12F
N98d7+2E6/2LKyjEMdX3sxODXG5R8/Vw8HwvBLTsIXtHg+Gbm2E9zhFEZY3J
mvN1BIB2iG09qzt7ph7jit1c/yFcz/emdq3dmxCbnnn7/P4utZs3w9+H63g/
O+y5sx+u4z8M61A/bUbhnsMHd80AAJLIbztv0WLZm+Efjvc/nNwMoet3fwzX
8PX/86GZ1O3q509vhn8M12DwL+8SWnzst5fXN2+vazSRdk9hoZXtPhICAO0j
qolqAEDdTCaTwhbed3Z3d7f/BMFi3gzDdT4YDE6P9t7tPZsVgtltNrstJvfH
uu1JKzQcDgu/pqnHBQDMN7etZ+zsmXqYSUz3/fw8t1FtaxSG8ObtOQSAhokn
PatPELT6hOB0M6md57FMR+oxlep2u4PBIJ70nPlPhV/i4XCYZJwAwIJEtTlE
NQAgkYuLi7KEFmnhvUzfz/Smv3YHBwfhyxdj9tXV1cxXNh4xSD1eAKDU3Lae
zgYu3PezLg4PDwu/oH//938/8y+xxlrq8QIAsyaTSWzPXZbTDg4O2nLSc66F
mknVSMWXdUZc+E49XgBglqi2BFENANiguW09Y2fP1MOsiwX6ftZLxaL2jLhX
LTxeYAOAOoh7zypOetq5lFPR97OmBoPBglEtH9vOzs7aWjoPABKruIPHtuxN
7hX1cN+fH33+7m2qd42OO/mTnssaZlK/DgBoF1HtQUQ1AGCNYk2tuW097VYq
9vr86K5De73Lqd0pbPS5OIkdADZmPB7H3p1l9+Xwn5wgKHETrtfnz7Oktk19
P8MXVE4DgPqb2ytKn+5K339Y/ax9M6kZyyY0M6sAsHmi2uOIagDAWlxkKm7N
2no2W7fbXTanpR4yALRF9QmCwOG+xluwYUH8fpDTAGAD4knPub2i3JfboCKu
z0ym+X4AgM0Q1bgjqgFArYQbbmwMVHZf7vV6inK0x9zeUtY9AeCRYj20RfLV
xcVFxUnPQWYDA6Y+Kg6VxO8rOQ0AHuOu4Hy4q1Y8LMawipkTFU3bqaxhQQz/
5lcB4JFENR5DVAOAtZo+HVBYqDbcbXu9XllIi/vWLHK1VvjSl+W01EMDgK03
Ho9nbrKxpO3df42dPctympkT3t5vWLD4vkcAYK6ySgvDTCxbWpbT9Ioiuvs+
Ed0BYLVENR5PVAOAlYuLm2Ux7G/+5m/K/lPn/iIpHGasewLAClWf6CyjnCl5
V5nUowCA5phMJtWLm3lxu/h4PE49dgCAhhPVAABqq6IZUKGTkxPbxQEANqOi
2XohhwgAADZj2Sm1zvvTBA4UAACsm6gGAFBb000/Fxd7fdquBgCwJrEHwQNy
2p0Q81K/CACAZjrJPCaqdfSTAgBYD1ENAKCeKjp+Lq7b7fZ6PTXWAABW6wHz
abFDQb/fv7i4iO3dU78IAIAGip2kqoNZeECv14tt3IfDYeohAwC0hagGAFBb
IX1Z3AQAqKeQyg4PD82YAQAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAABs0v8PpBFlpg==
     "], {{0, 934}, {825, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{320.4000000000014, Automatic},
   ImageSizeRaw->{825, 934},
   PlotRange->{{0, 825}, {0, 934}}], 
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzs3QuYG+V97/F5ThLwDccYG3t9xffbmvXaXhvbEC83x2DwLgZzMWSBRcXB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     "], {{0, 707}, {751, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSize->{357.9999999999999, Automatic},
   ImageSizeRaw->{751, 707},
   PlotRange->{{0, 751}, {0, 707}}]}]], "Input",
 CellChangeTimes->{{3.4838024153278*^9, 3.483802420976*^9}, {
   3.4838110987578*^9, 3.4838111066514*^9}, 3.4838186708059998`*^9, {
   3.4839250861182003`*^9, 3.4839250909542*^9}, 3.4857754412362156`*^9}],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnV9MG2e6xkc6t3PDJRdIHCFLXCChCHFBhHrMBSgrJIhaWYi2siBqBdG2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    "], {{0, 53}, {831, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->{416.60000000000014`, Automatic},
  ImageSizeRaw->{831, 53},
  PlotRange->{{0, 831}, {0, 53}}]], "Input",
 CellChangeTimes->{{3.4857756963908157`*^9, 3.485775697436015*^9}}],

Cell["a - North, b - East", "Text",
 CellChangeTimes->{{3.4857756999632154`*^9, 3.4857757099628153`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Evalpointzero functions", "Section",
 CellChangeTimes->{{3.545407779690544*^9, 3.5454077917592344`*^9}, {
  3.545407861122202*^9, 3.545407868416619*^9}, {3.5589110067729473`*^9, 
  3.558911013937357*^9}, {3.5624160841220894`*^9, 3.5624161140175486`*^9}}],

Cell[CellGroupData[{

Cell["Checking gdump/fieldline, making dxdxp", "Subsection",
 CellChangeTimes->{{3.541381299235394*^9, 3.541381326722642*^9}, {
  3.5414588620738506`*^9, 3.541458866415099*^9}, {3.562416091737206*^9, 
  3.5624161074899483`*^9}}],

Cell[CellGroupData[{

Cell["for old computation", "Subsubsection",
 CellChangeTimes->{{3.541458869783292*^9, 3.541458873102482*^9}}],

Cell[BoxData[
 RowBox[{"(", 
  RowBox[{
  "9", "+", "16", "+", "16", "+", "1", "+", "4", "+", "16", "+", "8"}], 
  ")"}]], "Input"],

Cell[BoxData[{
 RowBox[{"nsize", "=", 
  RowBox[{"256", " ", "64", " ", 
   RowBox[{"(", 
    RowBox[{"9", "+", "16", "+", "16", "+", "1", "+", "4", "+", "16"}], ")"}],
    "8"}]}], "\[IndentingNewLine]", 
 RowBox[{"issize", "=", 
  RowBox[{"256", " ", "64", " ", 
   RowBox[{"(", 
    RowBox[{
    "9", "+", "16", "+", "16", "+", "1", "+", "4", "+", "16", "+", "7"}], 
    ")"}], "8"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"actsize", "=", "9175208"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"actsize", "-", "issize"}]}], "Input",
 CellChangeTimes->{{3.541381317659026*^9, 3.5413813360670586`*^9}, {
   3.5413814503344593`*^9, 3.541381495574539*^9}, {3.5413815527061157`*^9, 
   3.5413815652278323`*^9}, {3.5414588589466715`*^9, 3.541458859227688*^9}, {
   3.541458893253634*^9, 3.541458937748179*^9}, 3.541459329601592*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", " ", "=", " ", 
   RowBox[{"NotebookDirectory", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ndd", "=", "650"}], ";", 
  RowBox[{"ncuttab", "=", 
   RowBox[{"{", 
    RowBox[{"145", ",", "147", ",", "149", ",", "153", ",", "162"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dirin", "=", "\"\<E:\\\\GRMHD\\\\a\>\""}], ";", 
  RowBox[{"anum", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"atab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
     ",", "\"\<098\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"readgd", "[", "sp_", "]"}], " ", ":=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"namefile", " ", "=", 
       RowBox[{"\"\<E:\\\\GRMHD\\\\a\>\"", "<>", 
        RowBox[{"atab", "[", 
         RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<\\\\usgdump2d\>\""}]}], 
      ";", "\n", "   ", 
      RowBox[{"siz", " ", "=", " ", 
       RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
      RowBox[{"xs", " ", "=", " ", 
       RowBox[{"256", "*", "64", "*", "70", "*", "8"}]}], ";", "\n", "   ", 
      RowBox[{"fi11", " ", "=", " ", 
       RowBox[{"OpenRead", "[", 
        RowBox[{"namefile", ",", " ", 
         RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
      "\n", "   ", 
      RowBox[{"strrr", " ", "=", " ", 
       RowBox[{"StringJoin", "[", 
        RowBox[{"BinaryReadList", "[", 
         RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", "168"}], 
         "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"resgd", " ", "=", " ", 
       RowBox[{"Transpose", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"BinaryReadList", "[", 
              RowBox[{"fi11", ",", " ", "\"\<Real64\>\"", ",", 
               RowBox[{"xs", "/", "8"}]}], "]"}], ",", "70"}], "]"}], ",", 
           "256"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", "\n", 
      "   ", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"resgd", " ", "=", " ", 
         RowBox[{"Transpose", "[", 
          RowBox[{
           RowBox[{"llist", " ", "=", " ", 
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"Partition", "[", 
               RowBox[{
                RowBox[{"Partition", "[", 
                 RowBox[{
                  RowBox[{"BinaryReadList", "[", 
                   RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                    RowBox[{"11", "*", "64", "*", "128", "*", "256"}]}], 
                   "]"}], ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], 
              ",", " ", "128"}], "]"}]}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], 
            "}"}]}], "]"}]}], ";"}], "*)"}], "\n", "   ", 
      RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dir", " ", "=", " ", 
   RowBox[{"NotebookDirectory", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", 
    RowBox[{"sp_", ",", "fnum_"}], "]"}], " ", ":=", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", " ", "=", 
      RowBox[{"\"\<E:\\\\GRMHD\\\\a\>\"", "<>", 
       RowBox[{"atab", "[", 
        RowBox[{"[", "sp", "]"}], "]"}], "<>", 
       "\"\<\\\\fieldlines\\\\fieldline\>\"", " ", "<>", " ", 
       RowBox[{"StringJoin", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", "#", "]"}], " ", "&"}], " ", "/@", " ", 
         RowBox[{"PadLeft", "[", 
          RowBox[{
           RowBox[{"IntegerDigits", "[", "fnum", "]"}], ",", " ", "4"}], 
          "]"}]}], "]"}], " ", "<>", " ", "\"\<.bin\>\""}]}], ";", "\n", 
     "   ", 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "256", "*", "64", "*", "32", "*", "4"}]}], ";", "\n",
      "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\n", "   ", 
     RowBox[{"res2m", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"llist", " ", "=", " ", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"BinaryReadList", "[", 
                RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                 RowBox[{"11", "*", "32", "*", "64", "*", "256"}]}], "]"}], 
               ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], ",", " ", 
           "64"}], "]"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], "}"}]}], 
       "]"}]}], ";", "\n", "   ", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], "\n", 
 RowBox[{"readgd", "[", "sp", "]"}], "\n", 
 RowBox[{"read11", "[", 
  RowBox[{"sp", ",", "9950"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "resgd", "]"}]}], "Input",
 CellChangeTimes->{{3.48199863871*^9, 3.4819986488344*^9}, {
   3.4821459308244*^9, 3.4821459311208*^9}, 3.4834575605388002`*^9, {
   3.4834576012392*^9, 3.4834576140312*^9}, {3.4834576807524*^9, 
   3.4834576815011997`*^9}, {3.4834577493612003`*^9, 3.4834577829636*^9}, {
   3.4834578209184*^9, 3.4834578352236*^9}, {3.5057603089278*^9, 
   3.5057603097546*^9}, {3.541203794809623*^9, 3.541203794981223*^9}, {
   3.5412043045883183`*^9, 3.5412043088003254`*^9}, {3.541204501242264*^9, 
   3.541204515750289*^9}, {3.5414588063706646`*^9, 3.541458813749087*^9}, {
   3.541458983765811*^9, 3.541459124153841*^9}, {3.5414592320200105`*^9, 
   3.5414592345781565`*^9}, {3.5414593414802713`*^9, 
   3.5414593601943417`*^9}, {3.541459447008307*^9, 3.54145948395142*^9}, {
   3.5414595323981915`*^9, 3.5414595580486584`*^9}, {3.541459622176326*^9, 
   3.541459622384338*^9}, {3.5414622654635134`*^9, 3.5414622660455465`*^9}, {
   3.5414623043457375`*^9, 3.541462304989774*^9}, {3.546870219183066*^9, 
   3.546870310255275*^9}, 3.546871107848895*^9, 3.546871246422821*^9, {
   3.5469690017541056`*^9, 3.546969029490692*^9}, {3.546969070834057*^9, 
   3.546969106395091*^9}, {3.5469691501305923`*^9, 3.5469691910899353`*^9}, {
   3.5472450407481155`*^9, 3.5472450412661448`*^9}, {3.547245086433728*^9, 
   3.547245088841866*^9}, {3.5472455092479115`*^9, 3.547245509318916*^9}, {
   3.5472456077835474`*^9, 3.547245635134112*^9}, {3.5472898174951315`*^9, 
   3.547289817582136*^9}}],

Cell[BoxData[
 RowBox[{"resgd", "[", 
  RowBox[{"[", 
   RowBox[{"All", ",", "1", ",", "8"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5472898212723475`*^9, 3.5472898719822474`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[CapitalDelta]", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "-", 
    RowBox[{"2", "r"}], "+", 
    SuperscriptBox["a", "2"]}]}], ";", 
  RowBox[{"\[Rho]sq", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "+", 
    RowBox[{
     SuperscriptBox["a", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}]}], ";", 
  RowBox[{"\[CapitalSigma]sq", "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["r", "2"], "+", 
       SuperscriptBox["a", "2"]}], ")"}], "2"], "-", 
    RowBox[{
     SuperscriptBox["a", "2"], "\[CapitalDelta]", " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"gmn", "=", 
     RowBox[{"-", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          FractionBox["\[CapitalSigma]sq", 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
          ",", 
          FractionBox[
           RowBox[{"2", "a", " ", "r"}], 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", 
           FractionBox["\[CapitalDelta]", "\[Rho]sq"]}], ",", "0", ",", "0"}],
          "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"-", 
           SuperscriptBox["\[Rho]sq", 
            RowBox[{"-", "1"}]]}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          FractionBox[
           RowBox[{"2", "a", " ", "r"}], 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
          ",", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"(", 
             RowBox[{"\[CapitalDelta]", "-", 
              RowBox[{
               SuperscriptBox["a", "2"], 
               SuperscriptBox[
                RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
            RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]]}]}], "}"}]}], 
       "}"}]}]}], ")"}], "//", "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invgmn", "=", 
     RowBox[{"FullSimplify", "[", 
      RowBox[{
       RowBox[{"Inverse", "[", "gmn", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ">", "0"}], "}"}]}], "]"}]}], ")"}], "//", 
   "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"x", "[", "1", "]"}], "=", "t"}], ";", 
   RowBox[{
    RowBox[{"x", "[", "2", "]"}], "=", "r"}], ";", 
   RowBox[{
    RowBox[{"x", "[", "3", "]"}], "=", "\[Theta]"}], ";", 
   RowBox[{
    RowBox[{"x", "[", "4", "]"}], "=", "\[Phi]"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "1", ",", "1"}], "]"}], "=", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"gmn", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "m"}], "]"}], "]"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"invgmn", "[", 
             RowBox[{"[", 
              RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"x", "[", "1", "]"}]}], "]"}], "+", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"invgmn", "[", 
             RowBox[{"[", 
              RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"x", "[", "1", "]"}]}], "]"}], "-", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"invgmn", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"G", "[", 
        RowBox[{"i", ",", "k", ",", "l"}], "]"}], "=", 
       RowBox[{"Simplify", "[", 
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"gmn", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "m"}], "]"}], "]"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"D", "[", 
               RowBox[{
                RowBox[{"invgmn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "k"}], "]"}], "]"}], ",", 
                RowBox[{"x", "[", "l", "]"}]}], "]"}], "+", 
              RowBox[{"D", "[", 
               RowBox[{
                RowBox[{"invgmn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "l"}], "]"}], "]"}], ",", 
                RowBox[{"x", "[", "k", "]"}]}], "]"}], "-", 
              RowBox[{"D", "[", 
               RowBox[{
                RowBox[{"invgmn", "[", 
                 RowBox[{"[", 
                  RowBox[{"k", ",", "l"}], "]"}], "]"}], ",", 
                RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "1", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"l", ",", "1", ",", "4"}], "}"}]}], "]"}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gmn", "=", 
   RowBox[{"Simplify", "[", "gmn", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invgmn", "=", 
     RowBox[{"Simplify", "[", 
      RowBox[{"invgmn", "/.", 
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"2", "\[Theta]"}], "]"}], "\[Rule]", 
        RowBox[{
         RowBox[{"2", 
          SuperscriptBox[
           RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "-", "1"}]}]}], 
      "]"}]}], ")"}], "//", "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invgmnKS", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          FractionBox[
           RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", 
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"], ",", "0", ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"2", "a", " ", "r", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"], ",", 
         RowBox[{"1", "+", 
          FractionBox[
           RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", "0", ",", 
         RowBox[{
          RowBox[{"-", "a"}], 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            FractionBox[
             RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
          SuperscriptBox[
           RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "\[Rho]sq", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"2", "a", " ", "r", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}], 
         ",", 
         RowBox[{
          RowBox[{"-", "a"}], 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            FractionBox[
             RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
          SuperscriptBox[
           RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], ",", "0", ",", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
          RowBox[{"(", 
           RowBox[{"\[Rho]sq", "+", 
            RowBox[{
             SuperscriptBox["a", "2"], 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               FractionBox[
                RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
             SuperscriptBox[
              RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}]}]}], 
        "}"}]}], "}"}]}], ")"}], "//", "MatrixForm"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"Anumu", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        FractionBox[
         RowBox[{"2", "r"}], "\[CapitalDelta]"], ",", "1", ",", "0", ",", 
        FractionBox["a", "\[CapitalDelta]"]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ")"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"invAnumu", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Inverse", "[", "Anumu", "]"}], "]"}]}], ")"}], "//", 
    "MatrixForm"}], ";"}], "\[IndentingNewLine]", "\n", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"i1", "=", "4"}], ";", 
  RowBox[{"i2", "=", "2"}], ";", 
  RowBox[{"i3", "=", "21"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rtp", "=", 
   RowBox[{"resgd", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", 
      RowBox[{"8", ";;", "10"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xxx", "=", 
   RowBox[{"resgd", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", 
      RowBox[{"5", ";;", "7"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Coord (x1,x2): \>\"", " ", ",", 
    RowBox[{"xxx", "[", 
     RowBox[{"[", 
      RowBox[{"1", ";;", "2"}], "]"}], "]"}], ",", "\"\<; (r,\[Theta]): \>\"",
     ",", " ", 
    RowBox[{"rtp", "[", 
     RowBox[{"[", 
      RowBox[{"1", ";;", "2"}], "]"}], "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sub", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"r", "\[Rule]", 
       RowBox[{"rtp", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ",", 
      RowBox[{"x1", "\[Rule]", 
       RowBox[{"xxx", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ",", 
      RowBox[{"\[Theta]", "\[Rule]", 
       RowBox[{"rtp", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ",", 
      RowBox[{"x2", "\[Rule]", 
       RowBox[{"xxx", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ",", 
      RowBox[{"a", "\[Rule]", 
       RowBox[{"anum", "[", 
        RowBox[{"[", "sp", "]"}], "]"}]}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gcon", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", 
        RowBox[{"11", ";;", "26"}]}], "]"}], "]"}], ",", "4"}], "]"}]}], ";", 
  RowBox[{"gcov", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", 
        RowBox[{"27", ";;", "42"}]}], "]"}], "]"}], ",", "4"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gdet", "=", 
   RowBox[{"resgd", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", "43"}], "]"}], "]"}]}], ";", 
  RowBox[{"dxdxp", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", 
        RowBox[{"48", ";;", "63"}]}], "]"}], "]"}], ",", "4"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fie", "=", 
   RowBox[{"res2m", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}], "]"}]}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\[Rho]=\>\"", ",", " ", 
    RowBox[{"\[Rho]", "=", 
     RowBox[{"fie", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], ",", "\"\<; U=\>\"", ",", 
    RowBox[{"U", "=", 
     RowBox[{"fie", "[", 
      RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SuperscriptBox[\(u\), \(\[Mu]\)]\)=\>\"", ",", 
    RowBox[{"uup", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"fie", "[", 
         RowBox[{"[", "5", "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{"fie", "[", 
          RowBox[{"[", "5", "]"}], "]"}], 
         RowBox[{"fie", "[", 
          RowBox[{"[", 
           RowBox[{"6", ";;", "8"}], "]"}], "]"}]}]}], "}"}], "]"}]}]}], 
   "]"}], ";", 
  RowBox[{"ulo", "=", 
   RowBox[{"gcov", ".", "uup"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<MKS \!\(\*SuperscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
    RowBox[{"bi", "=", 
     RowBox[{"fie", "[", 
      RowBox[{"[", 
       RowBox[{"9", ";;", "11"}], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SuperscriptBox[\(b\), \(\[Mu]\)]\)=\>\"", ",", 
    RowBox[{"bup", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"bi", ".", 
         RowBox[{"ulo", "[", 
          RowBox[{"[", 
           RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], ",", 
        FractionBox[
         RowBox[{"bi", "+", 
          RowBox[{
           RowBox[{"bi", ".", 
            RowBox[{"ulo", "[", 
             RowBox[{"[", 
              RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], 
           RowBox[{"uup", "[", 
            RowBox[{"[", 
             RowBox[{"2", ";;", "4"}], "]"}], "]"}]}]}], 
         RowBox[{"uup", "[", 
          RowBox[{"[", "1", "]"}], "]"}]]}], "}"}], "]"}]}], ",", 
    "\"\<; \!\(\*SubscriptBox[SuperscriptBox[\(b\), \(\[Mu]\)], \
\(KS\)]\)=\>\"", ",", 
    RowBox[{"bupKS", "=", 
     RowBox[{"dxdxp", ".", "bup"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<In KS coordinates: \!\(\*SubscriptBox[SuperscriptBox[\(u\), \
\(\[Mu]\)], \(KS\)]\)=\>\"", ",", " ", 
    RowBox[{"uupKS", "=", 
     RowBox[{"dxdxp", ".", "uup"}]}], ",", 
    "\"\<;  \!\(\*SubscriptBox[\(u\), \(\[Mu]KS\)]\)=\>\"", ",", 
    RowBox[{"uloKS", "=", 
     RowBox[{
      RowBox[{"invgmnKS", ".", "uupKS"}], "/.", "sub"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<In BL coordinates: \!\(\*SubscriptBox[SuperscriptBox[\(u\), \
\(\[Mu]\)], \(BL\)]\)=\>\"", ",", " ", 
    RowBox[{"uupBL", "=", 
     RowBox[{
      RowBox[{"invAnumu", ".", "uupKS"}], "/.", "sub"}]}], ",", 
    "\"\<;  \!\(\*SubscriptBox[\(u\), \(\[Mu]BL\)]\)=\>\"", ",", 
    RowBox[{"uloBL", "=", 
     RowBox[{
      RowBox[{"invgmn", ".", "uupBL"}], "/.", "sub"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 1: \!\(\*SuperscriptBox[\(g\), \
\(\[Mu]\[Nu]\)]\)\!\(\*SubscriptBox[\(g\), \
\(\[Nu]\[Sigma]\)]\)==\!\(\*SubscriptBox[SuperscriptBox[\(\[Delta]\), \(\[Mu]\
\)], \(\[Sigma]\)]\); should be identity matrix:   \>\"", ",", 
   RowBox[{"Chop", "[", 
    RowBox[{
     RowBox[{"gcov", ".", "gcon"}], "//", "MatrixForm"}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 2: gdet==\!\(\*SqrtBox[\(-Det[gcov]\)]\);  should be unity:      \
\>\"", ",", 
   FractionBox[
    SqrtBox[
     RowBox[{"-", 
      RowBox[{"Det", "[", "gcov", "]"}]}]], "gdet"]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 3: normalization of velocity in MKS: \!\(\*SuperscriptBox[\(u\), \
\(\[Mu]\)]\)\!\(\*SubscriptBox[\(u\), \(\[Mu]\)]\)=-1:  \>\"", ",", 
   RowBox[{"ulo", ".", "uup"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 4: normalization of velocity in KS: \
\!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\[Mu]\)], \
\(KS\)]\)\!\(\*SubscriptBox[\(u\), SubscriptBox[\(\[Mu]\), \(KS\)]]\)=-1:  \>\
\"", ",", 
   RowBox[{"uupKS", ".", "uloKS"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Test 5: normalization of velocity in BL: \
\!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\[Mu]\)], \
\(BL\)]\)\!\(\*SubscriptBox[\(u\), SubscriptBox[\(\[Mu]\), \(BL\)]]\)=-1:  \>\
\"", ",", 
    RowBox[{"uupBL", ".", "uloBL"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"u", "[", "0", "]"}], ",", 
      RowBox[{"u", "[", "1", "]"}], ",", 
      RowBox[{"u", "[", "2", "]"}], ",", 
      RowBox[{"u", "[", "3", "]"}]}], "}"}], "=", "uupKS"}], "]"}], ";", 
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"uco", "[", "0", "]"}], ",", 
      RowBox[{"uco", "[", "1", "]"}], ",", 
      RowBox[{"uco", "[", "2", "]"}], ",", 
      RowBox[{"uco", "[", "3", "]"}]}], "}"}], "=", "uloKS"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "[", "0", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"u", "[", "0", "]"}], ",", 
     RowBox[{"u", "[", "1", "]"}], ",", 
     RowBox[{"u", "[", "2", "]"}], ",", 
     RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "0", "]"}], "=", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"invgmnKS", ".", 
      RowBox[{"xx", "[", "0", "]"}]}]}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "[", "2", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"uco", "[", "2", "]"}], 
      RowBox[{"u", "[", "0", "]"}]}], ",", 
     RowBox[{
      RowBox[{"uco", "[", "2", "]"}], 
      RowBox[{"u", "[", "1", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"uco", "[", "2", "]"}], 
       RowBox[{"u", "[", "2", "]"}]}], "+", "1"}], ",", 
     RowBox[{
      RowBox[{"uco", "[", "2", "]"}], 
      RowBox[{"u", "[", "3", "]"}]}]}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "2", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xx", "[", "2", "]"}]}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "[", "3", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"uco", "[", "3", "]"}], 
       RowBox[{"uco", "[", "0", "]"}]]}], ",", "0", ",", "0", ",", "1"}], 
    "}"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "3", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xx", "[", "3", "]"}]}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sc", "[", "0", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "0", "]"}], ".", 
      RowBox[{"xxlo", "[", "0", "]"}]}]], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"sc", "[", "3", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "3", "]"}], ".", 
      RowBox[{"xxlo", "[", "3", "]"}]}]], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"sc", "[", "2", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "2", "]"}], ".", 
      RowBox[{"xxlo", "[", "2", "]"}]}]], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"xx", "[", "0", "]"}], "/=", 
    RowBox[{"sc", "[", "0", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "0", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "0", "]"}], "/.", "sub"}]}], ";", 
   RowBox[{
    RowBox[{"xx", "[", "2", "]"}], "/=", 
    RowBox[{"sc", "[", "2", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "2", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "2", "]"}], "/.", "sub"}]}], ";", 
   RowBox[{
    RowBox[{"xx", "[", "3", "]"}], "/=", 
    RowBox[{"sc", "[", "3", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "3", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "3", "]"}], "/.", "sub"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xpr", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], 
       RowBox[{"uco", "[", "1", "]"}]}], " ", ",", 
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"u", "[", "0", "]"}], 
          RowBox[{"uco", "[", "0", "]"}]}], "+", 
         RowBox[{
          RowBox[{"u", "[", "3", "]"}], 
          RowBox[{"uco", "[", "3", "]"}]}]}], ")"}]}], ",", "0", ",", 
      RowBox[{
       RowBox[{"u", "[", "3", "]"}], 
       RowBox[{"uco", "[", "1", "]"}]}]}], "}"}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xlopr", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"xx", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"xpr", "[", "1", "]"}], "-", 
    RowBox[{
     RowBox[{
      RowBox[{"xlopr", "[", "1", "]"}], ".", 
      RowBox[{"xx", "[", "3", "]"}]}], "*", 
     RowBox[{"xx", "[", "3", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xxlo", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xx", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"sc", "[", "1", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "1", "]"}], ".", 
      RowBox[{"xxlo", "[", "1", "]"}]}]], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xlopr", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"xx", "[", "1", "]"}], "/=", 
   RowBox[{"sc", "[", "1", "]"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "1", "]"}], "/=", 
   RowBox[{
    RowBox[{"sc", "[", "1", "]"}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"trxx", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"xxlo", "[", "0", "]"}], ",", 
      RowBox[{"xxlo", "[", "1", "]"}], ",", 
      RowBox[{"xxlo", "[", "2", "]"}], ",", 
      RowBox[{"xxlo", "[", "3", "]"}]}], "}"}]}], ";", 
   RowBox[{"trcoxx", "=", 
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"xx", "[", "0", "]"}], ",", 
       RowBox[{"xx", "[", "1", "]"}], ",", 
       RowBox[{"xx", "[", "2", "]"}], ",", 
       RowBox[{"xx", "[", "3", "]"}]}], "}"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", "tests", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Test 6: \!\(\*SubscriptBox[\(u\), \(i\)]\)=\>\"", ",", 
    RowBox[{"trxx", ".", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], ",", 
       RowBox[{"u", "[", "1", "]"}], ",", 
       RowBox[{"u", "[", "2", "]"}], ",", 
       RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ",", 
    "\"\<;  should be {1,0,0,0}\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Test 7: co-moving \!\(\*SubscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
    RowBox[{"coB", "=", 
     RowBox[{
      RowBox[{"trxx", ".", "bupKS"}], "/.", "sub"}]}], ",", 
    "\"\<;  0-th component should be 0\>\""}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Back to KS frame: \!\(\*SubscriptBox[SuperscriptBox[\(b\), \
\(\[Mu]\)], \(KS\)]\)=\>\"", ",", 
    RowBox[{"trcoxx", ".", "coB"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5454000162374997`*^9, 3.545400016674525*^9}, {
   3.5454021726668406`*^9, 3.5454021745119457`*^9}, {3.5454023760944757`*^9, 
   3.545402376496499*^9}, {3.545402495858326*^9, 3.5454025074229875`*^9}, 
   3.5454025825032816`*^9, {3.5454028874277225`*^9, 3.5454029476221657`*^9}, {
   3.545403011124798*^9, 3.545403016154085*^9}, {3.5454030531872034`*^9, 
   3.545403069655145*^9}, {3.5454031640715456`*^9, 3.545403172064003*^9}, {
   3.545403514974616*^9, 3.5454035544588747`*^9}, {3.5454036313522725`*^9, 
   3.5454036387846975`*^9}, {3.5454052181910343`*^9, 
   3.5454052978475904`*^9}, {3.54540581744831*^9, 3.54540581779533*^9}, {
   3.545408091542381*^9, 3.5454080920914125`*^9}, {3.5469691388739486`*^9, 
   3.546969143712225*^9}, 3.54696919816434*^9, {3.546987446201068*^9, 
   3.5469874727925887`*^9}, {3.54699027471585*^9, 3.5469902767999687`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"i1", "=", "34"}], ";", 
  RowBox[{"i2", "=", "44"}], ";", 
  RowBox[{"i3", "=", "21"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rtp", "=", 
   RowBox[{"resgd", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", 
      RowBox[{"8", ";;", "10"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xxx", "=", 
   RowBox[{"resgd", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", 
      RowBox[{"5", ";;", "7"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Coord (x1,x2): \>\"", " ", ",", 
    RowBox[{"xxx", "[", 
     RowBox[{"[", 
      RowBox[{"1", ";;", "2"}], "]"}], "]"}], ",", "\"\<; (r,\[Theta]): \>\"",
     ",", " ", 
    RowBox[{"rtp", "[", 
     RowBox[{"[", 
      RowBox[{"1", ";;", "2"}], "]"}], "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sub", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"r", "\[Rule]", 
      RowBox[{"rtp", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ",", 
     RowBox[{"x1", "\[Rule]", 
      RowBox[{"xxx", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ",", 
     RowBox[{"\[Theta]", "\[Rule]", 
      RowBox[{"rtp", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], ",", 
     RowBox[{"x2", "\[Rule]", 
      RowBox[{"xxx", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], ",", 
     RowBox[{"a", "\[Rule]", "0.0"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DiagonalMatrix", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"r", "-", "R0"}], ",", 
      RowBox[{"(", 
       RowBox[{"\[Pi]", 
        RowBox[{"(", 
         RowBox[{"h", "+", 
          RowBox[{"7", 
           RowBox[{"(", 
            RowBox[{"1", "-", "h"}], ")"}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "x2"}], "-", "1"}], ")"}], "6"]}]}], ")"}]}], 
       ")"}], ",", "\[Pi]"}], "}"}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"r", "\[Rule]", 
      RowBox[{"resgd", "[", 
       RowBox[{"[", 
        RowBox[{"i1", ",", "i2", ",", "8"}], "]"}], "]"}]}], ",", 
     RowBox[{"x2", "\[Rule]", 
      RowBox[{"resgd", "[", 
       RowBox[{"[", 
        RowBox[{"i1", ",", "i2", ",", "6"}], "]"}], "]"}]}]}], "}"}]}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"R0", "\[Rule]", "0.3"}], ",", 
    RowBox[{"h", "\[Rule]", "0.65"}]}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.5468735470564094`*^9, 3.54687360511073*^9}, {
   3.5468736420138407`*^9, 3.546873655060587*^9}, {3.5468737194842715`*^9, 
   3.5468737618446946`*^9}, {3.54687379987887*^9, 3.5468738171568584`*^9}, {
   3.546873849821727*^9, 3.546873849893731*^9}, {3.546873883531655*^9, 
   3.546873988052633*^9}, {3.5468740315641212`*^9, 3.5468740317881346`*^9}, {
   3.5468749726219473`*^9, 3.546874976940194*^9}, 3.5469692516593995`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"np", "=", "64"}], ";", 
  RowBox[{"h", "=."}], ";", 
  RowBox[{"\[Theta]tab", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "x2"}], "-", "1"}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", "h"}], ")"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "x2"}], "-", "1"}], ")"}], "7"]}], "+", "1"}], ")"}], 
      FractionBox["\[Pi]", "2"]}], "/.", 
     RowBox[{"x2", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{"x2tab", "=", 
        RowBox[{"N", "[", 
         RowBox[{"Range", "[", 
          RowBox[{
           FractionBox["1", 
            RowBox[{"2", "np"}]], ",", 
           RowBox[{"1", "-", 
            FractionBox["1", 
             RowBox[{"2", "np"}]]}], ",", 
           FractionBox["1", "np"]}], "]"}], "]"}]}], ")"}]}]}], "/.", 
    RowBox[{"{", 
     RowBox[{"h", "\[Rule]", "0.65"}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ncut", "=", 
    RowBox[{"ncuttab", "[", 
     RowBox[{"[", "sp", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"rtab11", "=", 
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"1", ";;", "ncut"}], ",", "1", ",", "8"}], "]"}], "]"}]}], 
    ";", 
    RowBox[{"rcut", "=", 
     RowBox[{"rtab11", "[", 
      RowBox[{"[", 
       RowBox[{"-", "1"}], "]"}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rtab11", "=", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{
      "Import", "[", "\"\<E:\\\\GRMHD\\\\a05\\\\Tsmap05.dat\>\"", "]"}], 
      "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", 
       RowBox[{"1", ";;", "ncut"}]}], "]"}], "]"}]}], ";", 
   RowBox[{"rcut", "=", 
    RowBox[{"rtab11", "[", 
     RowBox[{"[", 
      RowBox[{"-", "1"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rrmax", "=", "340000."}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rtab22", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"rcut", "*", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"rrmax", "/", "rcut"}], ")"}], 
       FractionBox[
        RowBox[{"k", "-", "ncut", "+", "1"}], 
        RowBox[{"ndd", "-", "ncut"}]]]}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "ncut", ",", 
       RowBox[{"ndd", "-", "1"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rtab", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"rtab11", ",", "rtab22"}], "]"}]}], ";", 
  RowBox[{"rn", "=", 
   RowBox[{"Length", "[", "rtab", "]"}]}], ";", 
  RowBox[{"tn", "=", 
   RowBox[{"Total", "[", "x2tab", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListLogPlot", "[", "rtab", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"i1", "=."}], ";", 
  RowBox[{"i2", "=."}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dxdxptab", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"DiagonalMatrix", "[", 
        RowBox[{"{", 
         RowBox[{"1.", ",", 
          RowBox[{"r", "-", "R0"}], ",", 
          RowBox[{"(", 
           RowBox[{"\[Pi]", 
            RowBox[{"(", 
             RowBox[{"h", "+", 
              RowBox[{"7", 
               RowBox[{"(", 
                RowBox[{"1", "-", "h"}], ")"}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"2", "x2"}], "-", "1"}], ")"}], "6"]}]}], ")"}]}], 
           ")"}], ",", 
          RowBox[{"1.", "\[Pi]"}]}], "}"}], "]"}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"r", "\[Rule]", 
          RowBox[{"rtab", "[", 
           RowBox[{"[", "i1", "]"}], "]"}]}], ",", 
         RowBox[{"x2", "\[Rule]", 
          RowBox[{"x2tab", "[", 
           RowBox[{"[", "i2", "]"}], "]"}]}]}], "}"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"R0", "\[Rule]", "0.3"}], ",", 
        RowBox[{"h", "\[Rule]", "0.65"}]}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i1", ",", 
       RowBox[{"Length", "[", "rtab", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i2", ",", 
       RowBox[{"Length", "[", "x2tab", "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coord", "=", 
   RowBox[{"Outer", "[", 
    RowBox[{"List", ",", 
     RowBox[{"Log", "[", "rtab", "]"}], ",", 
     RowBox[{"-", 
      RowBox[{"Cos", "[", "\[Theta]tab", "]"}]}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"fif", "=", 
   RowBox[{"OpenWrite", "[", 
    RowBox[{
     RowBox[{"\"\<E:\\\\GRMHD\\\\a\>\"", "<>", 
      RowBox[{"atab", "[", 
       RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<\\\\dxdxp.dat\>\""}], ",", 
     RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"BinaryWrite", "[", 
  RowBox[{"fif", ",", 
   RowBox[{"Flatten", "[", "coord", "]"}], ",", "\"\<Real32\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"BinaryWrite", "[", 
  RowBox[{"fif", ",", 
   RowBox[{"Flatten", "[", "dxdxptab", "]"}], ",", "\"\<Real32\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Close", "[", "fif", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5468741343640013`*^9, 3.5468741584193773`*^9}, {
  3.546874210291344*^9, 3.546874258763117*^9}, {3.5468743731216574`*^9, 
  3.5468745507988205`*^9}, {3.546874587897942*^9, 3.546874716121276*^9}, {
  3.546874872540223*^9, 3.546874916880759*^9}, {3.5468761525764365`*^9, 
  3.546876160987918*^9}, {3.5468761980160356`*^9, 3.546876208364628*^9}, {
  3.5468770498497577`*^9, 3.5468770512378373`*^9}, {3.5469071186315937`*^9, 
  3.546907153732601*^9}, {3.546968631899951*^9, 3.546968648117879*^9}, {
  3.5469687978754444`*^9, 3.546968801242637*^9}, {3.5469689124269967`*^9, 
  3.546968963909941*^9}, {3.546968995971775*^9, 3.5469689966488137`*^9}, {
  3.5469692624960194`*^9, 3.5469693183792157`*^9}, {3.5472455330972757`*^9, 
  3.5472455354924126`*^9}, {3.54724561883518*^9, 3.5472456195682216`*^9}, {
  3.547245686556053*^9, 3.5472457396040874`*^9}}],

Cell[BoxData[
 RowBox[{"Dimensions", "[", "grids", "]"}]], "Input",
 CellChangeTimes->{{3.546876462459161*^9, 3.5468764650403085`*^9}, {
  3.5468769891242847`*^9, 3.546877029028567*^9}, {3.546877107164036*^9, 
  3.546877111574288*^9}}],

Cell[BoxData[
 RowBox[{"grids", "[", 
  RowBox[{"[", 
   RowBox[{
    RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5468770829846525`*^9, 3.546877094724324*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "dxdxptab", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Total", "[", 
  RowBox[{"Flatten", "[", "dxdxptab", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.546875094240903*^9, 3.5468751191453276`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["for new computations", "Subsubsection",
 CellChangeTimes->{{3.541458869783292*^9, 3.541458887678315*^9}}],

Cell[BoxData[
 RowBox[{"(", 
  RowBox[{
  "9", "+", "16", "+", "16", "+", "1", "+", "4", "+", "16", "+", "7"}], 
  ")"}]], "Input",
 CellChangeTimes->{3.541462447305914*^9}],

Cell[BoxData[{
 RowBox[{"nsize", "=", 
  RowBox[{"256", " ", "128", " ", 
   RowBox[{"(", 
    RowBox[{"9", "+", "16", "+", "16", "+", "1", "+", "4", "+", "16"}], ")"}],
    "8"}]}], "\[IndentingNewLine]", 
 RowBox[{"issize", "=", 
  RowBox[{"256", " ", "128", " ", 
   RowBox[{"(", 
    RowBox[{
    "9", "+", "16", "+", "16", "+", "1", "+", "4", "+", "16", "+", "7"}], 
    ")"}], "8"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"actsize", "=", "18088096"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"actsize", "-", "issize"}]}], "Input",
 CellChangeTimes->{{3.541381317659026*^9, 3.5413813360670586`*^9}, {
   3.5413814503344593`*^9, 3.541381495574539*^9}, {3.5413815527061157`*^9, 
   3.5413815652278323`*^9}, {3.5414588589466715`*^9, 3.541458859227688*^9}, {
   3.541458893253634*^9, 3.541458937748179*^9}, 3.541459329601592*^9, {
   3.54146239268379*^9, 3.541462426042698*^9}}],

Cell[BoxData[
 RowBox[{"xs", " ", "=", " ", 
  RowBox[{"256", "*", "128", "*", "69", "*", "8"}]}]], "Input",
 CellChangeTimes->{{3.5414624556483917`*^9, 3.5414624629928117`*^9}}],

Cell[BoxData[
 RowBox[{"256", " ", "128", " ", "69", " ", "8"}]], "Input",
 CellChangeTimes->{{3.547304242323184*^9, 3.54730425169672*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", " ", "=", " ", 
   RowBox[{"NotebookDirectory", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=", "5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ndd", "=", "650"}], ";", 
  RowBox[{"ncuttab", "=", 
   RowBox[{"{", 
    RowBox[{"100", ",", "110", ",", "116", ",", "128", ",", "138"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dirin", "=", "\"\<E:\\\\GRMHD\\\\a\>\""}], ";", 
  RowBox[{"anum", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"atab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
     ",", "\"\<098\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"readgd", "[", "sp_", "]"}], " ", ":=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"namefile", " ", "=", 
       RowBox[{"\"\<E:\\\\GRMHD\\\\new\\\\a\>\"", "<>", 
        RowBox[{"atab", "[", 
         RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<\\\\usgdump2d\>\""}]}], 
      ";", "\n", "   ", 
      RowBox[{"siz", " ", "=", " ", 
       RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
      RowBox[{"xs", " ", "=", " ", 
       RowBox[{"256", "*", "128", "*", "69", "*", "8"}]}], ";", "\n", "   ", 
      RowBox[{"fi11", " ", "=", " ", 
       RowBox[{"OpenRead", "[", 
        RowBox[{"namefile", ",", " ", 
         RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
      "\n", "   ", 
      RowBox[{"strrr", " ", "=", " ", 
       RowBox[{"StringJoin", "[", 
        RowBox[{"BinaryReadList", "[", 
         RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", "156"}], 
         "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"resgd", " ", "=", " ", 
       RowBox[{"Transpose", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"BinaryReadList", "[", 
              RowBox[{"fi11", ",", " ", "\"\<Real64\>\"", ",", 
               RowBox[{"xs", "/", "8"}]}], "]"}], ",", "69"}], "]"}], ",", 
           "256"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", "\n", 
      "   ", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"resgd", " ", "=", " ", 
         RowBox[{"Transpose", "[", 
          RowBox[{
           RowBox[{"llist", " ", "=", " ", 
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"Partition", "[", 
               RowBox[{
                RowBox[{"Partition", "[", 
                 RowBox[{
                  RowBox[{"BinaryReadList", "[", 
                   RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                    RowBox[{"11", "*", "64", "*", "128", "*", "256"}]}], 
                   "]"}], ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], 
              ",", " ", "128"}], "]"}]}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], 
            "}"}]}], "]"}]}], ";"}], "*)"}], "\n", "   ", 
      RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", 
    RowBox[{"sp_", ",", "fnum_"}], "]"}], " ", ":=", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", " ", "=", 
      RowBox[{"\"\<E:\\\\GRMHD\\\\new\\\\a\>\"", "<>", 
       RowBox[{"atab", "[", 
        RowBox[{"[", "sp", "]"}], "]"}], "<>", 
       "\"\<\\\\fieldlines\\\\fieldline\>\"", " ", "<>", " ", 
       RowBox[{"StringJoin", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", "#", "]"}], " ", "&"}], " ", "/@", " ", 
         RowBox[{"PadLeft", "[", 
          RowBox[{
           RowBox[{"IntegerDigits", "[", "fnum", "]"}], ",", " ", "4"}], 
          "]"}]}], "]"}], " ", "<>", " ", "\"\<.bin\>\""}]}], ";", "\n", 
     "   ", 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "256", "*", "128", "*", "64", "*", "4"}]}], ";", 
     "\n", "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\n", "   ", 
     RowBox[{"res2m", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"llist", " ", "=", " ", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"BinaryReadList", "[", 
                RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                 RowBox[{"11", "*", "64", "*", "128", "*", "256"}]}], "]"}], 
               ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], ",", " ", 
           "128"}], "]"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], "}"}]}], 
       "]"}]}], ";", "\n", "   ", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], "\n", 
 RowBox[{"readgd", "[", "sp", "]"}], "\n", 
 RowBox[{"read11", "[", 
  RowBox[{"sp", ",", "2571"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "resgd", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"extension", " ", "to", " ", "large", " ", 
     RowBox[{"radius", ":", " ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"quantities", " ", "extended", " ", "as", " ", "power"}], "-", 
       "laws"}]}]}], ";", " ", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
     "elements", " ", "of", " ", "dxdxp", " ", "matrices", " ", "are", " ", 
      "extended", " ", "as", " ", "power"}], "-", "laws"}], ";", " ", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"grids", " ", "are", " ", "extended", " ", "as", " ", "power"}], 
     "-", "laws"}], ";", " ", 
    RowBox[{
    "theta", " ", "grid", " ", "is", " ", "fixed", " ", "at", " ", "40", "M", 
     " ", "boundary"}], ";"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.48199863871*^9, 3.4819986488344*^9}, {
   3.4821459308244*^9, 3.4821459311208*^9}, 3.4834575605388002`*^9, {
   3.4834576012392*^9, 3.4834576140312*^9}, {3.4834576807524*^9, 
   3.4834576815011997`*^9}, {3.4834577493612003`*^9, 3.4834577829636*^9}, {
   3.4834578209184*^9, 3.4834578352236*^9}, {3.5057603089278*^9, 
   3.5057603097546*^9}, {3.541203794809623*^9, 3.541203794981223*^9}, {
   3.5412043045883183`*^9, 3.5412043088003254`*^9}, {3.541204501242264*^9, 
   3.541204515750289*^9}, {3.5414588063706646`*^9, 3.541458813749087*^9}, {
   3.541458983765811*^9, 3.541459124153841*^9}, {3.5414592320200105`*^9, 
   3.5414592345781565`*^9}, {3.5414593414802713`*^9, 
   3.5414593601943417`*^9}, {3.541459447008307*^9, 3.54145948395142*^9}, {
   3.5414595323981915`*^9, 3.5414595580486584`*^9}, {3.541459622176326*^9, 
   3.541459622384338*^9}, {3.5414622654635134`*^9, 3.5414622660455465`*^9}, {
   3.5414623043457375`*^9, 3.541462304989774*^9}, {3.541462385373372*^9, 
   3.541462386052411*^9}, {3.5414624305879583`*^9, 3.5414624889242945`*^9}, {
   3.541462537932098*^9, 3.541462545298519*^9}, 3.545409232910663*^9, {
   3.5454092720989046`*^9, 3.5454092728439474`*^9}, {3.5472560730601273`*^9, 
   3.5472560743392005`*^9}, {3.547294353431572*^9, 3.5472945377361135`*^9}, {
   3.547294775668722*^9, 3.547294776171751*^9}, {3.5473042542098637`*^9, 
   3.547304254696892*^9}, {3.547306391910824*^9, 3.547306489613412*^9}, {
   3.5474815714911537`*^9, 3.547481571546157*^9}, {3.547481738490706*^9, 
   3.5474817391217422`*^9}, {3.5474831480233264`*^9, 3.547483148102331*^9}, {
   3.547483180727197*^9, 3.5474831966611085`*^9}, {3.547483265239031*^9, 
   3.547483270429328*^9}, {3.5474833051833153`*^9, 3.5474833174870195`*^9}, {
   3.547483360174461*^9, 3.547483367973907*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"avtab", "=", 
   RowBox[{
   "Import", "[", "\"\<E:\\\\GRMHD\\\\new\\\\a07\\\\Tsmap07.dat\>\"", "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"Delete", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", "avtab", "]"}], ",", "2"}], "]"}], "]"}], 
      "[", 
      RowBox[{"[", 
       RowBox[{"1", ";;", "160"}], "]"}], "]"}], ",", 
     RowBox[{"Frame", "->", "True"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"avtab", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"1", ";;", "160"}], ",", 
        RowBox[{"1", ";;", "2"}]}], "]"}], "]"}], ",", 
     RowBox[{"Frame", "->", "True"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl1", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{
     RowBox[{"0.047", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["r", "10"], ")"}], 
       RowBox[{"-", "0.3"}]]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"avtab", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
       RowBox[{"avtab", "[", 
        RowBox[{"[", 
         RowBox[{"160", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"pl1", ",", "lpl1"}], "]"}]}], "Input",
 CellChangeTimes->{{3.547293145011454*^9, 3.547293169086831*^9}, {
  3.547293233702527*^9, 3.54729355475089*^9}, {3.547481801419305*^9, 
  3.54748183000294*^9}, {3.547481868763157*^9, 3.5474819006979837`*^9}}],

Cell[BoxData[{
 RowBox[{"avtab", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "1"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"avtab", "[", 
  RowBox[{"[", 
   RowBox[{"100", ",", "1"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"avtab", "[", 
  RowBox[{"[", 
   RowBox[{"160", ",", "1"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"newpar", "=", 
  RowBox[{"{", 
   RowBox[{"2.02245567", ",", " ", 
    RowBox[{"4.23384276", " ", 
     SuperscriptBox["10", "11"]}], ",", "0.0402070586"}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"oldpar", "=", 
   RowBox[{"{", 
    RowBox[{"1.99835404", ",", " ", 
     RowBox[{"1.18096645", " ", 
      SuperscriptBox["10", "12"]}], ",", " ", "5.41663751"}], "}"}]}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"thus", ",", " ", 
    RowBox[{
    "need", " ", "to", " ", "increase", " ", "rhonor", " ", "by", " ", 
     "x100"}], ",", " ", 
    RowBox[{"increase", " ", "heat", " ", "to", " ", "0.55"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.547293436681137*^9, 3.5472934461016755`*^9}, {
  3.5472936855393705`*^9, 3.5472937004752245`*^9}, {3.547293875954262*^9, 
  3.5472939698336315`*^9}, {3.547306568846944*^9, 3.5473065696059875`*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "res2m", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res2m", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"res2m", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "2", ",", "1"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5473041595964527`*^9, 3.547304195361498*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[CapitalDelta]", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "-", 
    RowBox[{"2", "r"}], "+", 
    SuperscriptBox["a", "2"]}]}], ";", 
  RowBox[{"\[Rho]sq", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "+", 
    RowBox[{
     SuperscriptBox["a", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}]}], ";", 
  RowBox[{"\[CapitalSigma]sq", "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["r", "2"], "+", 
       SuperscriptBox["a", "2"]}], ")"}], "2"], "-", 
    RowBox[{
     SuperscriptBox["a", "2"], "\[CapitalDelta]", " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"gmn", "=", 
     RowBox[{"-", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          FractionBox["\[CapitalSigma]sq", 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
          ",", 
          FractionBox[
           RowBox[{"2", "a", " ", "r"}], 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", 
           FractionBox["\[CapitalDelta]", "\[Rho]sq"]}], ",", "0", ",", "0"}],
          "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"-", 
           SuperscriptBox["\[Rho]sq", 
            RowBox[{"-", "1"}]]}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          FractionBox[
           RowBox[{"2", "a", " ", "r"}], 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
          ",", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"(", 
             RowBox[{"\[CapitalDelta]", "-", 
              RowBox[{
               SuperscriptBox["a", "2"], 
               SuperscriptBox[
                RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
            RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]]}]}], "}"}]}], 
       "}"}]}]}], ")"}], "//", "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invgmn", "=", 
     RowBox[{"FullSimplify", "[", 
      RowBox[{
       RowBox[{"Inverse", "[", "gmn", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ">", "0"}], "}"}]}], "]"}]}], ")"}], "//", 
   "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"x", "[", "1", "]"}], "=", "t"}], ";", 
   RowBox[{
    RowBox[{"x", "[", "2", "]"}], "=", "r"}], ";", 
   RowBox[{
    RowBox[{"x", "[", "3", "]"}], "=", "\[Theta]"}], ";", 
   RowBox[{
    RowBox[{"x", "[", "4", "]"}], "=", "\[Phi]"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "1", ",", "1"}], "]"}], "=", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"gmn", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "m"}], "]"}], "]"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"invgmn", "[", 
             RowBox[{"[", 
              RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"x", "[", "1", "]"}]}], "]"}], "+", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"invgmn", "[", 
             RowBox[{"[", 
              RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"x", "[", "1", "]"}]}], "]"}], "-", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"invgmn", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"G", "[", 
        RowBox[{"i", ",", "k", ",", "l"}], "]"}], "=", 
       RowBox[{"Simplify", "[", 
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"gmn", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "m"}], "]"}], "]"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"D", "[", 
               RowBox[{
                RowBox[{"invgmn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "k"}], "]"}], "]"}], ",", 
                RowBox[{"x", "[", "l", "]"}]}], "]"}], "+", 
              RowBox[{"D", "[", 
               RowBox[{
                RowBox[{"invgmn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "l"}], "]"}], "]"}], ",", 
                RowBox[{"x", "[", "k", "]"}]}], "]"}], "-", 
              RowBox[{"D", "[", 
               RowBox[{
                RowBox[{"invgmn", "[", 
                 RowBox[{"[", 
                  RowBox[{"k", ",", "l"}], "]"}], "]"}], ",", 
                RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "1", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"l", ",", "1", ",", "4"}], "}"}]}], "]"}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gmn", "=", 
   RowBox[{"Simplify", "[", "gmn", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invgmn", "=", 
     RowBox[{"Simplify", "[", 
      RowBox[{"invgmn", "/.", 
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"2", "\[Theta]"}], "]"}], "\[Rule]", 
        RowBox[{
         RowBox[{"2", 
          SuperscriptBox[
           RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "-", "1"}]}]}], 
      "]"}]}], ")"}], "//", "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invgmnKS", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          FractionBox[
           RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", 
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"], ",", "0", ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"2", "a", " ", "r", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"], ",", 
         RowBox[{"1", "+", 
          FractionBox[
           RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", "0", ",", 
         RowBox[{
          RowBox[{"-", "a"}], 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            FractionBox[
             RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
          SuperscriptBox[
           RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "\[Rho]sq", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"2", "a", " ", "r", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}], 
         ",", 
         RowBox[{
          RowBox[{"-", "a"}], 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            FractionBox[
             RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
          SuperscriptBox[
           RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], ",", "0", ",", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
          RowBox[{"(", 
           RowBox[{"\[Rho]sq", "+", 
            RowBox[{
             SuperscriptBox["a", "2"], 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               FractionBox[
                RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
             SuperscriptBox[
              RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}]}]}], 
        "}"}]}], "}"}]}], ")"}], "//", "MatrixForm"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"Anumu", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        FractionBox[
         RowBox[{"2", "r"}], "\[CapitalDelta]"], ",", "1", ",", "0", ",", 
        FractionBox["a", "\[CapitalDelta]"]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ")"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"invAnumu", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Inverse", "[", "Anumu", "]"}], "]"}]}], ")"}], "//", 
    "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"i1", "=", "54"}], ";", 
  RowBox[{"i2", "=", "87"}], ";", 
  RowBox[{"i3", "=", "21"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rtp", "=", 
   RowBox[{"resgd", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", 
      RowBox[{"8", ";;", "10"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xxx", "=", 
   RowBox[{"resgd", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", 
      RowBox[{"5", ";;", "7"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Coord (x1,x2): \>\"", " ", ",", 
    RowBox[{"xxx", "[", 
     RowBox[{"[", 
      RowBox[{"1", ";;", "2"}], "]"}], "]"}], ",", "\"\<; (r,\[Theta]): \>\"",
     ",", " ", 
    RowBox[{"rtp", "[", 
     RowBox[{"[", 
      RowBox[{"1", ";;", "2"}], "]"}], "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sub", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"r", "\[Rule]", 
       RowBox[{"rtp", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ",", 
      RowBox[{"x1", "\[Rule]", 
       RowBox[{"xxx", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ",", 
      RowBox[{"\[Theta]", "\[Rule]", 
       RowBox[{"rtp", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ",", 
      RowBox[{"x2", "\[Rule]", 
       RowBox[{"xxx", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ",", 
      RowBox[{"a", "\[Rule]", "0.98"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gcon", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", 
        RowBox[{"11", ";;", "26"}]}], "]"}], "]"}], ",", "4"}], "]"}]}], ";", 
  RowBox[{"gcov", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", 
        RowBox[{"27", ";;", "42"}]}], "]"}], "]"}], ",", "4"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gdet", "=", 
   RowBox[{"resgd", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", "43"}], "]"}], "]"}]}], ";", 
  RowBox[{"dxdxp", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", 
        RowBox[{"48", ";;", "63"}]}], "]"}], "]"}], ",", "4"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fie", "=", 
   RowBox[{"res2m", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}], "]"}]}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\[Rho]=\>\"", ",", " ", 
    RowBox[{"\[Rho]", "=", 
     RowBox[{"fie", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], ",", "\"\<; U=\>\"", ",", 
    RowBox[{"U", "=", 
     RowBox[{"fie", "[", 
      RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SuperscriptBox[\(u\), \(\[Mu]\)]\)=\>\"", ",", 
    RowBox[{"uup", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"fie", "[", 
         RowBox[{"[", "5", "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{"fie", "[", 
          RowBox[{"[", "5", "]"}], "]"}], 
         RowBox[{"fie", "[", 
          RowBox[{"[", 
           RowBox[{"6", ";;", "8"}], "]"}], "]"}]}]}], "}"}], "]"}]}]}], 
   "]"}], ";", 
  RowBox[{"ulo", "=", 
   RowBox[{"gcov", ".", "uup"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<MKS \!\(\*SuperscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
    RowBox[{"bi", "=", 
     RowBox[{"fie", "[", 
      RowBox[{"[", 
       RowBox[{"9", ";;", "11"}], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SuperscriptBox[\(b\), \(\[Mu]\)]\)=\>\"", ",", 
    RowBox[{"bup", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"bi", ".", 
         RowBox[{"ulo", "[", 
          RowBox[{"[", 
           RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], ",", 
        FractionBox[
         RowBox[{"bi", "+", 
          RowBox[{
           RowBox[{"bi", ".", 
            RowBox[{"ulo", "[", 
             RowBox[{"[", 
              RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], 
           RowBox[{"uup", "[", 
            RowBox[{"[", 
             RowBox[{"2", ";;", "4"}], "]"}], "]"}]}]}], 
         RowBox[{"uup", "[", 
          RowBox[{"[", "1", "]"}], "]"}]]}], "}"}], "]"}]}], ",", 
    "\"\<; \!\(\*SubscriptBox[SuperscriptBox[\(b\), \(\[Mu]\)], \
\(KS\)]\)=\>\"", ",", 
    RowBox[{"bupKS", "=", 
     RowBox[{"dxdxp", ".", "bup"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<In KS coordinates: \!\(\*SubscriptBox[SuperscriptBox[\(u\), \
\(\[Mu]\)], \(KS\)]\)=\>\"", ",", " ", 
    RowBox[{"uupKS", "=", 
     RowBox[{"dxdxp", ".", "uup"}]}], ",", 
    "\"\<;  \!\(\*SubscriptBox[\(u\), \(\[Mu]KS\)]\)=\>\"", ",", 
    RowBox[{"uloKS", "=", 
     RowBox[{
      RowBox[{"invgmnKS", ".", "uupKS"}], "/.", "sub"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<In BL coordinates: \!\(\*SubscriptBox[SuperscriptBox[\(u\), \
\(\[Mu]\)], \(BL\)]\)=\>\"", ",", " ", 
    RowBox[{"uupBL", "=", 
     RowBox[{
      RowBox[{"invAnumu", ".", "uupKS"}], "/.", "sub"}]}], ",", 
    "\"\<;  \!\(\*SubscriptBox[\(u\), \(\[Mu]BL\)]\)=\>\"", ",", 
    RowBox[{"uloBL", "=", 
     RowBox[{
      RowBox[{"invgmn", ".", "uupBL"}], "/.", "sub"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Back to KS coordinates: \!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\
\[Mu]\)], \(KS\)]\)=\>\"", ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"Transpose", "[", "Anumu", "]"}], ".", "uupBL"}], "/.", 
     "sub"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 1: \!\(\*SuperscriptBox[\(g\), \
\(\[Mu]\[Nu]\)]\)\!\(\*SubscriptBox[\(g\), \
\(\[Nu]\[Sigma]\)]\)==\!\(\*SubscriptBox[SuperscriptBox[\(\[Delta]\), \(\[Mu]\
\)], \(\[Sigma]\)]\); should be identity matrix:   \>\"", ",", 
   RowBox[{"Chop", "[", 
    RowBox[{
     RowBox[{"gcov", ".", "gcon"}], "//", "MatrixForm"}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 2: gdet==\!\(\*SqrtBox[\(-Det[gcov]\)]\);  should be unity:      \
\>\"", ",", 
   FractionBox[
    SqrtBox[
     RowBox[{"-", 
      RowBox[{"Det", "[", "gcov", "]"}]}]], "gdet"]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 3: normalization of velocity in MKS: \!\(\*SuperscriptBox[\(u\), \
\(\[Mu]\)]\)\!\(\*SubscriptBox[\(u\), \(\[Mu]\)]\)=-1:  \>\"", ",", 
   RowBox[{"ulo", ".", "uup"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 4: normalization of velocity in KS: \
\!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\[Mu]\)], \
\(KS\)]\)\!\(\*SubscriptBox[\(u\), SubscriptBox[\(\[Mu]\), \(KS\)]]\)=-1:  \>\
\"", ",", 
   RowBox[{"uupKS", ".", "uloKS"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Test 5: normalization of velocity in BL: \
\!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\[Mu]\)], \
\(BL\)]\)\!\(\*SubscriptBox[\(u\), SubscriptBox[\(\[Mu]\), \(BL\)]]\)=-1:  \>\
\"", ",", 
    RowBox[{"uupBL", ".", "uloBL"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"u", "[", "0", "]"}], ",", 
      RowBox[{"u", "[", "1", "]"}], ",", 
      RowBox[{"u", "[", "2", "]"}], ",", 
      RowBox[{"u", "[", "3", "]"}]}], "}"}], "=", "uupKS"}], "]"}], ";", 
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"uco", "[", "0", "]"}], ",", 
      RowBox[{"uco", "[", "1", "]"}], ",", 
      RowBox[{"uco", "[", "2", "]"}], ",", 
      RowBox[{"uco", "[", "3", "]"}]}], "}"}], "=", "uloKS"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "[", "0", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"u", "[", "0", "]"}], ",", 
     RowBox[{"u", "[", "1", "]"}], ",", 
     RowBox[{"u", "[", "2", "]"}], ",", 
     RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "0", "]"}], "=", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"invgmnKS", ".", 
      RowBox[{"xx", "[", "0", "]"}]}]}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "[", "2", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"uco", "[", "2", "]"}], 
      RowBox[{"u", "[", "0", "]"}]}], ",", 
     RowBox[{
      RowBox[{"uco", "[", "2", "]"}], 
      RowBox[{"u", "[", "1", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"uco", "[", "2", "]"}], 
       RowBox[{"u", "[", "2", "]"}]}], "+", "1"}], ",", 
     RowBox[{
      RowBox[{"uco", "[", "2", "]"}], 
      RowBox[{"u", "[", "3", "]"}]}]}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "2", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xx", "[", "2", "]"}]}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "[", "3", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"uco", "[", "3", "]"}], 
       RowBox[{"uco", "[", "0", "]"}]]}], ",", "0", ",", "0", ",", "1"}], 
    "}"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "3", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xx", "[", "3", "]"}]}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sc", "[", "0", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "0", "]"}], ".", 
      RowBox[{"xxlo", "[", "0", "]"}]}]], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"sc", "[", "3", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "3", "]"}], ".", 
      RowBox[{"xxlo", "[", "3", "]"}]}]], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"sc", "[", "2", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "2", "]"}], ".", 
      RowBox[{"xxlo", "[", "2", "]"}]}]], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"xx", "[", "0", "]"}], "/=", 
    RowBox[{"sc", "[", "0", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "0", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "0", "]"}], "/.", "sub"}]}], ";", 
   RowBox[{
    RowBox[{"xx", "[", "2", "]"}], "/=", 
    RowBox[{"sc", "[", "2", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "2", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "2", "]"}], "/.", "sub"}]}], ";", 
   RowBox[{
    RowBox[{"xx", "[", "3", "]"}], "/=", 
    RowBox[{"sc", "[", "3", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "3", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "3", "]"}], "/.", "sub"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xpr", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], 
       RowBox[{"uco", "[", "1", "]"}]}], " ", ",", 
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"u", "[", "0", "]"}], 
          RowBox[{"uco", "[", "0", "]"}]}], "+", 
         RowBox[{
          RowBox[{"u", "[", "3", "]"}], 
          RowBox[{"uco", "[", "3", "]"}]}]}], ")"}]}], ",", "0", ",", 
      RowBox[{
       RowBox[{"u", "[", "3", "]"}], 
       RowBox[{"uco", "[", "1", "]"}]}]}], "}"}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xlopr", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"xx", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"xpr", "[", "1", "]"}], "-", 
    RowBox[{
     RowBox[{
      RowBox[{"xlopr", "[", "1", "]"}], ".", 
      RowBox[{"xx", "[", "3", "]"}]}], "*", 
     RowBox[{"xx", "[", "3", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xxlo", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xx", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"sc", "[", "1", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "1", "]"}], ".", 
      RowBox[{"xxlo", "[", "1", "]"}]}]], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xlopr", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"xx", "[", "1", "]"}], "/=", 
   RowBox[{"sc", "[", "1", "]"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "1", "]"}], "/=", 
   RowBox[{
    RowBox[{"sc", "[", "1", "]"}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"trxx", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"xxlo", "[", "0", "]"}], ",", 
      RowBox[{"xxlo", "[", "1", "]"}], ",", 
      RowBox[{"xxlo", "[", "2", "]"}], ",", 
      RowBox[{"xxlo", "[", "3", "]"}]}], "}"}]}], ";", 
   RowBox[{"trcoxx", "=", 
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"xx", "[", "0", "]"}], ",", 
       RowBox[{"xx", "[", "1", "]"}], ",", 
       RowBox[{"xx", "[", "2", "]"}], ",", 
       RowBox[{"xx", "[", "3", "]"}]}], "}"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", "tests", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Test 6: \!\(\*SubscriptBox[\(u\), \(i\)]\)=\>\"", ",", 
    RowBox[{"trxx", ".", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], ",", 
       RowBox[{"u", "[", "1", "]"}], ",", 
       RowBox[{"u", "[", "2", "]"}], ",", 
       RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ",", 
    "\"\<;  should be {1,0,0,0}\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Test 7: co-moving \!\(\*SubscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
    RowBox[{"coB", "=", 
     RowBox[{
      RowBox[{"trxx", ".", "bupKS"}], "/.", "sub"}]}], ",", 
    "\"\<;  0-th component should be 0\>\""}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Back to KS frame: \!\(\*SubscriptBox[SuperscriptBox[\(b\), \
\(\[Mu]\)], \(KS\)]\)=\>\"", ",", 
    RowBox[{"trcoxx", ".", "coB"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5454000162374997`*^9, 3.545400016674525*^9}, {
   3.5454021726668406`*^9, 3.5454021745119457`*^9}, {3.5454023760944757`*^9, 
   3.545402376496499*^9}, {3.545402495858326*^9, 3.5454025074229875`*^9}, 
   3.5454025825032816`*^9, {3.5454028874277225`*^9, 3.5454029476221657`*^9}, {
   3.545403011124798*^9, 3.545403016154085*^9}, {3.5454030531872034`*^9, 
   3.545403069655145*^9}, {3.5454031640715456`*^9, 3.545403172064003*^9}, {
   3.545403514974616*^9, 3.5454035544588747`*^9}, {3.5454036313522725`*^9, 
   3.5454036387846975`*^9}, {3.5454052181910343`*^9, 
   3.5454052978475904`*^9}, {3.54540581744831*^9, 3.54540581779533*^9}, {
   3.545408091542381*^9, 3.5454080920914125`*^9}, {3.546871327069433*^9, 
   3.5468713272944465`*^9}, {3.5468726464658985`*^9, 
   3.5468726465539036`*^9}, {3.5473040581236486`*^9, 
   3.5473040807089405`*^9}, {3.5473043892395873`*^9, 3.547304389324592*^9}, {
   3.547481920088093*^9, 3.5474819328308215`*^9}, {3.5474832134720697`*^9, 
   3.547483213591077*^9}, 3.547483332494878*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"np", "=", "64"}], ";", 
    RowBox[{"h", "=."}], ";", 
    RowBox[{"\[Theta]tab", "=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"h", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", "x2"}], "-", "1"}], ")"}]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "-", "h"}], ")"}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "x2"}], "-", "1"}], ")"}], "7"]}], "+", "1"}], 
         ")"}], 
        FractionBox["\[Pi]", "2"]}], "/.", 
       RowBox[{"x2", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"x2tab", "=", 
          RowBox[{"N", "[", 
           RowBox[{"Range", "[", 
            RowBox[{
             FractionBox["1", 
              RowBox[{"2", "np"}]], ",", 
             RowBox[{"1", "-", 
              FractionBox["1", 
               RowBox[{"2", "np"}]]}], ",", 
             FractionBox["1", "np"]}], "]"}], "]"}]}], ")"}]}]}], "/.", 
      RowBox[{"{", 
       RowBox[{"h", "\[Rule]", "0.65"}], "}"}]}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ncut", "=", 
     RowBox[{"ncuttab", "[", 
      RowBox[{"[", "sp", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rtab11", "=", 
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"1", ";;", "ncut"}], ",", "1", ",", "8"}], "]"}], "]"}]}], 
    ";", 
    RowBox[{"rcut", "=", 
     RowBox[{"rtab11", "[", 
      RowBox[{"[", 
       RowBox[{"-", "1"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"rtab11", "=", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{
        "Import", "[", "\"\<E:\\\\GRMHD\\\\a05\\\\Tsmap05.dat\>\"", "]"}], 
        "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", 
         RowBox[{"1", ";;", "ncut"}]}], "]"}], "]"}]}], ";", 
     RowBox[{"rcut", "=", 
      RowBox[{"rtab11", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rrmax", "=", "340000."}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rtab22", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"rcut", "*", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"rrmax", "/", "rcut"}], ")"}], 
         FractionBox[
          RowBox[{"k", "-", "ncut", "+", "1"}], 
          RowBox[{"ndd", "-", "ncut"}]]]}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "ncut", ",", 
         RowBox[{"ndd", "-", "1"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rtab", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"rtab11", ",", "rtab22"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"rn", "=", 
      RowBox[{"Length", "[", "rtab", "]"}]}], ";", 
     RowBox[{"tn", "=", 
      RowBox[{"Total", "[", "x2tab", "]"}]}], ";", 
     RowBox[{"ListLogPlot", "[", "rtab", "]"}], ";", 
     RowBox[{"i1", "=."}], ";", 
     RowBox[{"i2", "=."}], ";"}], "*)"}], "\n", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"dxdxptab", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"DiagonalMatrix", "[", 
           RowBox[{"{", 
            RowBox[{"1.", ",", 
             RowBox[{"r", "-", "R0"}], ",", 
             RowBox[{"(", 
              RowBox[{"\[Pi]", 
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"7", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", "h"}], ")"}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", "x2"}], "-", "1"}], ")"}], "6"]}]}], ")"}]}],
               ")"}], ",", 
             RowBox[{"1.", "\[Pi]"}]}], "}"}], "]"}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"r", "\[Rule]", 
             RowBox[{"rtab", "[", 
              RowBox[{"[", "i1", "]"}], "]"}]}], ",", 
            RowBox[{"x2", "\[Rule]", 
             RowBox[{"x2tab", "[", 
              RowBox[{"[", "i2", "]"}], "]"}]}]}], "}"}]}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"R0", "\[Rule]", "0.3"}], ",", 
           RowBox[{"h", "\[Rule]", "0.65"}]}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i1", ",", 
          RowBox[{"Length", "[", "rtab", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i2", ",", 
          RowBox[{"Length", "[", "x2tab", "]"}]}], "}"}]}], "]"}]}], ";"}], 
    "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"coord", "=", 
      RowBox[{"Outer", "[", 
       RowBox[{"List", ",", 
        RowBox[{"Log", "[", "rtab", "]"}], ",", 
        RowBox[{"-", 
         RowBox[{"Cos", "[", "\[Theta]tab", "]"}]}]}], "]"}]}], ";"}], "*)"}],
    "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{"rcmax", "=", 
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"256", ",", "1", ",", "8"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"coordx11", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"resgd", "[", 
            RowBox[{"[", 
             RowBox[{"num", ",", "All", ",", "8"}], "]"}], "]"}], "]"}], ",", 
          RowBox[{"-", 
           RowBox[{"Cos", "[", 
            RowBox[{"resgd", "[", 
             RowBox[{"[", 
              RowBox[{"num", ",", "All", ",", "9"}], "]"}], "]"}], "]"}]}]}], 
         "}"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"num", ",", "ncut"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"dxdxptab11", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"resgd", "[", 
          RowBox[{"[", 
           RowBox[{"i1", ",", "i2", ",", 
            RowBox[{"48", ";;", "63"}]}], "]"}], "]"}], ",", "4"}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i1", ",", "ncut"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i2", ",", "128"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"dxdxptab22", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.", ",", "0.", ",", "0.", ",", "0."}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.", ",", 
           RowBox[{"rtab", "[", 
            RowBox[{"[", 
             RowBox[{"i1", "+", "1"}], "]"}], "]"}], ",", "0.", ",", "0."}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.", ",", "0.", ",", 
           FractionBox["\[Pi]", "2."], ",", "0."}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.", ",", "0.", ",", "0.", ",", 
           RowBox[{"2.", "\[Pi]"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i1", ",", "ncut", ",", 
         RowBox[{"ndd", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i2", ",", "128"}], "}"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"thtab22", "=", 
     RowBox[{"-", 
      RowBox[{"Cos", "[", 
       RowBox[{"resgd", "[", 
        RowBox[{"[", 
         RowBox[{"ncut", ",", "All", ",", "9"}], "]"}], "]"}], "]"}]}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{"coordx22", "=", 
     RowBox[{"Outer", "[", 
      RowBox[{"List", ",", 
       RowBox[{"Log", "[", "rtab22", "]"}], ",", "thtab22"}], "]"}]}], ";"}], 
   "\n", 
   RowBox[{"Dimensions", "[", 
    RowBox[{"coordfin", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"coordx11", ",", "coordx22"}], "]"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Dimensions", "[", 
    RowBox[{"dxdxpfin", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"dxdxptab11", ",", "dxdxptab22"}], "]"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fif", "=", 
     RowBox[{"OpenWrite", "[", 
      RowBox[{
       RowBox[{"\"\<E:\\\\GRMHD\\\\new\\\\a\>\"", "<>", 
        RowBox[{"atab", "[", 
         RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<\\\\dxdxp.dat\>\""}], 
       ",", 
       RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"BinaryWrite", "[", 
    RowBox[{"fif", ",", 
     RowBox[{"Flatten", "[", "coordfin", "]"}], ",", "\"\<Real32\>\""}], 
    "]"}], "\[IndentingNewLine]", 
   RowBox[{"BinaryWrite", "[", 
    RowBox[{"fif", ",", 
     RowBox[{"Flatten", "[", "dxdxpfin", "]"}], ",", "\"\<Real32\>\""}], 
    "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Close", "[", "fif", "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"fullcoord", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Log", "[", 
            RowBox[{"resgd", "[", 
             RowBox[{"[", 
              RowBox[{"num", ",", "All", ",", "8"}], "]"}], "]"}], "]"}], ",", 
           RowBox[{"-", 
            RowBox[{"Cos", "[", 
             RowBox[{"resgd", "[", 
              RowBox[{"[", 
               RowBox[{"num", ",", "All", ",", "9"}], "]"}], "]"}], "]"}]}]}],
           "}"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"num", ",", "256"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"fullcoord", "=", 
      RowBox[{"Join", "[", 
       RowBox[{"fullcoord", ",", 
        RowBox[{"Abs", "[", 
         RowBox[{"Reverse", "[", 
          RowBox[{"fullcoord", ",", "2"}], "]"}], "]"}], ",", "2"}], "]"}]}], 
     ";"}], "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.5472945808155775`*^9, 3.5472946145585074`*^9}, {
   3.547294768023285*^9, 3.5472948032623005`*^9}, 3.5473953904776516`*^9, {
   3.5473957199844985`*^9, 3.5473957607268286`*^9}, 3.5473958009761305`*^9, {
   3.547395890562255*^9, 3.547395900555826*^9}, {3.5473959984834275`*^9, 
   3.547396012973256*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tn", "=", "23"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"dxdxpfin", "[", 
  RowBox[{"[", 
   RowBox[{
    RowBox[{"ncut", "-", "1"}], ",", "tn"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"dxdxpfin", "[", 
  RowBox[{"[", 
   RowBox[{"ncut", ",", "tn"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"dxdxpfin", "[", 
  RowBox[{"[", 
   RowBox[{
    RowBox[{"ncut", "+", "1"}], ",", "tn"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"coordfin", "[", 
  RowBox[{"[", 
   RowBox[{
    RowBox[{"ncut", "-", "1"}], ",", "tn"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"coordfin", "[", 
  RowBox[{"[", 
   RowBox[{"ncut", ",", "tn"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"coordfin", "[", 
  RowBox[{"[", 
   RowBox[{
    RowBox[{"ncut", "+", "1"}], ",", "tn"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5473955662577057`*^9, 3.54739561389443*^9}, {
  3.5473956585349836`*^9, 3.5473956716787357`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tn", "=", "64"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"lpl22", "=", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab11", ",", 
        RowBox[{"dxdxptab11", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "tn", ",", "2", ",", "2"}], "]"}], "]"}]}], 
       "}"}], "]"}], "]"}]}], ",", 
   RowBox[{"ListLogPlot", "[", 
    RowBox[{"dxdxptab11", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "9", ",", "3", ",", "3"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"ListLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"dxdxptab11", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "tn", ",", "3", ",", "2"}], "]"}], "]"}], "]"}], 
    "]"}], ",", 
   RowBox[{"ListLogPlot", "[", 
    RowBox[{"dxdxptab11", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "tn", ",", "4", ",", "4"}], "]"}], "]"}], "]"}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl22", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{"r", ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"rtab11", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{"rtab11", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"lpl22", ",", "pl22"}], "]"}]}], "Input",
 CellChangeTimes->{{3.547306806114515*^9, 3.547306951926855*^9}, {
  3.547307018612669*^9, 3.5473070240999827`*^9}, {3.5473070998133135`*^9, 
  3.547307219210142*^9}}],

Cell[BoxData[
 RowBox[{"dxdxp", "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.5473070749838934`*^9, 3.547307077488036*^9}}],

Cell[BoxData[{
 RowBox[{"ListPlot", "[", 
  RowBox[{"dxdxptab11", "[", 
   RowBox[{"[", 
    RowBox[{"100", ",", "All", ",", "3", ",", "3"}], "]"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{"dxdxptab11", "[", 
   RowBox[{"[", 
    RowBox[{"100", ",", "All", ",", "3", ",", "2"}], "]"}], "]"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.547307317726777*^9, 3.5473073258712435`*^9}, {
  3.547307363135374*^9, 3.5473073719098763`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"0", ",", "0"}], ")"}], " ", "\[Rule]", " ", "1"}], ";", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", ",", "1"}], ")"}], " ", "\[Rule]", " ", "r"}], ";", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"2", ",", "2"}], ")"}], " ", "\[Rule]", " ", 
     RowBox[{"\[Pi]", "/", "2"}]}], ";", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"3", ",", "3"}], ")"}], " ", "\[Rule]", " ", 
     RowBox[{"2", "\[Pi]"}]}], ";", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"3", ",", "2"}], ")"}], " ", "\[Rule]", " ", "0"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1.", ",", "0.", ",", "0.", ",", "0."}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.", ",", "r", ",", "0.", ",", "0."}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.", ",", "0.", ",", 
      FractionBox["\[Pi]", "2."], ",", "0."}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.", ",", "0.", ",", "0.", ",", 
      RowBox[{"2.", "\[Pi]"}]}], "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.547307048512379*^9, 3.54730708804064*^9}, {
  3.547307127464895*^9, 3.547307128463952*^9}, {3.5473072327269154`*^9, 
  3.547307292712346*^9}, {3.5473073390079947`*^9, 3.5473074308502474`*^9}}],

Cell[BoxData[{"gcov", "\[IndentingNewLine]", 
 RowBox[{"invgmnKS", "/.", "sub"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Transpose", "[", "dxdxp", "]"}], ".", "invgmnKS", ".", "dxdxp"}], 
  "/.", "sub"}]}], "Input",
 CellChangeTimes->{{3.5468726348802357`*^9, 3.546872746954646*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"given", " ", "u"}], ",", " ", "iKS", ",", " ", 
   RowBox[{"dxdxp", ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"1.", " ", "Find", " ", "iMKS"}], "=", 
     RowBox[{
      RowBox[{"Transpose", "[", "dxdxp", "]"}], ".", "iKS", ".", "dxdxp"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"2.", " ", "Find", " ", "ulo"}], "=", 
     RowBox[{"iMKS", ".", "u"}]}], ";"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.546872523859886*^9, 3.546872603859462*^9}, {
  3.546873333406189*^9, 3.546873351798241*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["for ADAF computations", "Subsubsection",
 CellChangeTimes->{{3.541458869783292*^9, 3.541458887678315*^9}, {
  3.5509827948811984`*^9, 3.5509827972680025`*^9}}],

Cell[BoxData[
 RowBox[{"(", 
  RowBox[{
  "9", "+", "16", "+", "16", "+", "1", "+", "4", "+", "16", "+", "7"}], 
  ")"}]], "Input",
 CellChangeTimes->{3.541462447305914*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"256", "*", "128", "*", "69", "*", "8"}], "+", 
  "156"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"264", " ", "126", " ", "69", " ", "8"}], "+", 
  "160"}], "\[IndentingNewLine]", 
 RowBox[{"87817358", "-", 
  RowBox[{"11", "*", "264", "*", "126", "*", "60", "*", "4"}]}]}], "Input",
 CellChangeTimes->{{3.55098298928874*^9, 3.5509829999279585`*^9}, {
  3.55098304059723*^9, 3.5509830692076807`*^9}, {3.550983148034619*^9, 
  3.550983182261079*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", " ", "=", " ", 
   RowBox[{"NotebookDirectory", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sp", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ndd", "=", "650"}], ";", 
  RowBox[{"ncuttab", "=", 
   RowBox[{"{", 
    RowBox[{"110", ",", "110", ",", "126", ",", "134", ",", "138"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dirin", "=", "\"\<E:\\\\GRMHD\\\\a\>\""}], ";", 
  RowBox[{"anum", "=", 
   RowBox[{"{", 
    RowBox[{"0.", ",", "0.5", ",", "0.7", ",", "0.9", ",", "0.98"}], "}"}]}], 
  ";", 
  RowBox[{"atab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
     ",", "\"\<098\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"readgd", "[", "sp_", "]"}], " ", ":=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"namefile", " ", "=", 
       RowBox[{"\"\<E:\\\\GRMHD\\\\ADAFs\\\\a\>\"", "<>", 
        RowBox[{"atab", "[", 
         RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<\\\\usgdump2d\>\""}]}], 
      ";", "\n", "   ", 
      RowBox[{"siz", " ", "=", " ", 
       RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
      RowBox[{"xs", " ", "=", " ", 
       RowBox[{"264", "*", "126", "*", "69", "*", "8"}]}], ";", "\n", "   ", 
      RowBox[{"fi11", " ", "=", " ", 
       RowBox[{"OpenRead", "[", 
        RowBox[{"namefile", ",", " ", 
         RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
      "\n", "   ", 
      RowBox[{"strrr", " ", "=", " ", 
       RowBox[{"StringJoin", "[", 
        RowBox[{"BinaryReadList", "[", 
         RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", "156"}], 
         "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"resgd", " ", "=", " ", 
       RowBox[{"Transpose", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"BinaryReadList", "[", 
              RowBox[{"fi11", ",", " ", "\"\<Real64\>\"", ",", 
               RowBox[{"xs", "/", "8"}]}], "]"}], ",", "69"}], "]"}], ",", 
           "264"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", "\n", 
      "   ", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"resgd", " ", "=", " ", 
         RowBox[{"Transpose", "[", 
          RowBox[{
           RowBox[{"llist", " ", "=", " ", 
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"Partition", "[", 
               RowBox[{
                RowBox[{"Partition", "[", 
                 RowBox[{
                  RowBox[{"BinaryReadList", "[", 
                   RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                    RowBox[{"11", "*", "64", "*", "128", "*", "256"}]}], 
                   "]"}], ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], 
              ",", " ", "128"}], "]"}]}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], 
            "}"}]}], "]"}]}], ";"}], "*)"}], "\n", "   ", 
      RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", 
    RowBox[{"sp_", ",", "fnum_"}], "]"}], " ", ":=", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", " ", "=", 
      RowBox[{"\"\<E:\\\\GRMHD\\\\ADAFs\\\\a\>\"", "<>", 
       RowBox[{"atab", "[", 
        RowBox[{"[", "sp", "]"}], "]"}], "<>", 
       "\"\<\\\\fieldlines\\\\fieldline\>\"", " ", "<>", " ", 
       RowBox[{"StringJoin", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", "#", "]"}], " ", "&"}], " ", "/@", " ", 
         RowBox[{"PadLeft", "[", 
          RowBox[{
           RowBox[{"IntegerDigits", "[", "fnum", "]"}], ",", " ", "4"}], 
          "]"}]}], "]"}], " ", "<>", " ", "\"\<.bin\>\""}]}], ";", "\n", 
     "   ", 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "264", "*", "126", "*", "60", "*", "4"}]}], ";", 
     "\n", "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\n", "   ", 
     RowBox[{"res2m", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"llist", " ", "=", " ", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"BinaryReadList", "[", 
                RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                 RowBox[{"11", "*", "60", "*", "126", "*", "264"}]}], "]"}], 
               ",", " ", "11"}], "]"}], ",", " ", "264"}], "]"}], ",", " ", 
           "126"}], "]"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], "}"}]}], 
       "]"}]}], ";", "\n", "   ", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], "\n", 
 RowBox[{"readgd", "[", "sp", "]"}], "\n", 
 RowBox[{"read11", "[", 
  RowBox[{"sp", ",", "3149"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "resgd", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"extension", " ", "to", " ", "large", " ", 
     RowBox[{"radius", ":", " ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"quantities", " ", "extended", " ", "as", " ", "power"}], "-", 
       "laws"}]}]}], ";", " ", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
     "elements", " ", "of", " ", "dxdxp", " ", "matrices", " ", "are", " ", 
      "extended", " ", "as", " ", "power"}], "-", "laws"}], ";", " ", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"grids", " ", "are", " ", "extended", " ", "as", " ", "power"}], 
     "-", "laws"}], ";", " ", 
    RowBox[{
    "theta", " ", "grid", " ", "is", " ", "fixed", " ", "at", " ", "40", "M", 
     " ", "boundary"}], ";"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.48199863871*^9, 3.4819986488344*^9}, {
   3.4821459308244*^9, 3.4821459311208*^9}, 3.4834575605388002`*^9, {
   3.4834576012392*^9, 3.4834576140312*^9}, {3.4834576807524*^9, 
   3.4834576815011997`*^9}, {3.4834577493612003`*^9, 3.4834577829636*^9}, {
   3.4834578209184*^9, 3.4834578352236*^9}, {3.5057603089278*^9, 
   3.5057603097546*^9}, {3.541203794809623*^9, 3.541203794981223*^9}, {
   3.5412043045883183`*^9, 3.5412043088003254`*^9}, {3.541204501242264*^9, 
   3.541204515750289*^9}, {3.5414588063706646`*^9, 3.541458813749087*^9}, {
   3.541458983765811*^9, 3.541459124153841*^9}, {3.5414592320200105`*^9, 
   3.5414592345781565`*^9}, {3.5414593414802713`*^9, 
   3.5414593601943417`*^9}, {3.541459447008307*^9, 3.54145948395142*^9}, {
   3.5414595323981915`*^9, 3.5414595580486584`*^9}, {3.541459622176326*^9, 
   3.541459622384338*^9}, {3.5414622654635134`*^9, 3.5414622660455465`*^9}, {
   3.5414623043457375`*^9, 3.541462304989774*^9}, {3.541462385373372*^9, 
   3.541462386052411*^9}, {3.5414624305879583`*^9, 3.5414624889242945`*^9}, {
   3.541462537932098*^9, 3.541462545298519*^9}, 3.545409232910663*^9, {
   3.5454092720989046`*^9, 3.5454092728439474`*^9}, {3.5472560730601273`*^9, 
   3.5472560743392005`*^9}, {3.547294353431572*^9, 3.5472945377361135`*^9}, {
   3.547294775668722*^9, 3.547294776171751*^9}, {3.5473042542098637`*^9, 
   3.547304254696892*^9}, {3.547306391910824*^9, 3.547306489613412*^9}, {
   3.5474815714911537`*^9, 3.547481571546157*^9}, {3.547481738490706*^9, 
   3.5474817391217422`*^9}, {3.5474831480233264`*^9, 3.547483148102331*^9}, {
   3.547483180727197*^9, 3.5474831966611085`*^9}, {3.547483265239031*^9, 
   3.547483270429328*^9}, {3.5474833051833153`*^9, 3.5474833174870195`*^9}, {
   3.547483360174461*^9, 3.547483367973907*^9}, {3.5509830780684958`*^9, 
   3.550983139501404*^9}, {3.550983213024333*^9, 3.5509832275791583`*^9}, {
   3.550983262164419*^9, 3.5509832622112193`*^9}, {3.550983454840358*^9, 
   3.550983520407273*^9}, {3.550983558159339*^9, 3.550983584180185*^9}, {
   3.5509892690699368`*^9, 3.5509892702867393`*^9}, {3.551984022106784*^9, 
   3.551984034410487*^9}, {3.5519848768126698`*^9, 3.551984877178691*^9}, {
   3.551984946135635*^9, 3.5519849468806777`*^9}, {3.5520152453262315`*^9, 
   3.552015245423237*^9}, {3.552015752103217*^9, 3.552015764120905*^9}, {
   3.552015816751915*^9, 3.552015817034931*^9}, {3.552015919532794*^9, 
   3.5520159394539332`*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "resgd", "]"}], "\[IndentingNewLine]", 
 RowBox[{"resgd", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5509834149042873`*^9, 3.5509834343731213`*^9}, {
  3.550983531358492*^9, 3.550983567831356*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"avtab", "=", 
   RowBox[{
   "Import", "[", "\"\<E:\\\\GRMHD\\\\ADAFs\\\\a0\\\\Tsmap0.dat\>\"", "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"Delete", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", "avtab", "]"}], ",", "2"}], "]"}], "]"}], 
      "[", 
      RowBox[{"[", 
       RowBox[{"1", ";;", "160"}], "]"}], "]"}], ",", 
     RowBox[{"Frame", "->", "True"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"avtab", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"1", ";;", "160"}], ",", 
        RowBox[{"1", ";;", "2"}]}], "]"}], "]"}], ",", 
     RowBox[{"Frame", "->", "True"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl1", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{
     RowBox[{"0.047", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["r", "10"], ")"}], 
       RowBox[{"-", "1.1"}]]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"avtab", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
       RowBox[{"avtab", "[", 
        RowBox[{"[", 
         RowBox[{"160", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"pl1", ",", "lpl1"}], "]"}]}], "Input",
 CellChangeTimes->{{3.547293145011454*^9, 3.547293169086831*^9}, {
  3.547293233702527*^9, 3.54729355475089*^9}, {3.547481801419305*^9, 
  3.54748183000294*^9}, {3.547481868763157*^9, 3.5474819006979837`*^9}, {
  3.5509866945687933`*^9, 3.5509867227504396`*^9}}],

Cell[BoxData[{
 RowBox[{"avtab", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "1"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"avtab", "[", 
  RowBox[{"[", 
   RowBox[{"100", ",", "1"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"avtab", "[", 
  RowBox[{"[", 
   RowBox[{"160", ",", "1"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"newpar", "=", 
  RowBox[{"{", 
   RowBox[{"2.02245567", ",", " ", 
    RowBox[{"4.23384276", " ", 
     SuperscriptBox["10", "11"]}], ",", "0.0402070586"}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"oldpar", "=", 
   RowBox[{"{", 
    RowBox[{"1.99835404", ",", " ", 
     RowBox[{"1.18096645", " ", 
      SuperscriptBox["10", "12"]}], ",", " ", "5.41663751"}], "}"}]}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"thus", ",", " ", 
    RowBox[{
    "need", " ", "to", " ", "increase", " ", "rhonor", " ", "by", " ", 
     "x100"}], ",", " ", 
    RowBox[{"increase", " ", "heat", " ", "to", " ", "0.55"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.547293436681137*^9, 3.5472934461016755`*^9}, {
  3.5472936855393705`*^9, 3.5472937004752245`*^9}, {3.547293875954262*^9, 
  3.5472939698336315`*^9}, {3.547306568846944*^9, 3.5473065696059875`*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "res2m", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res2m", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"res2m", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", "2", ",", "1"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5473041595964527`*^9, 3.547304195361498*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[CapitalDelta]", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "-", 
    RowBox[{"2", "r"}], "+", 
    SuperscriptBox["a", "2"]}]}], ";", 
  RowBox[{"\[Rho]sq", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "+", 
    RowBox[{
     SuperscriptBox["a", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}]}], ";", 
  RowBox[{"\[CapitalSigma]sq", "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["r", "2"], "+", 
       SuperscriptBox["a", "2"]}], ")"}], "2"], "-", 
    RowBox[{
     SuperscriptBox["a", "2"], "\[CapitalDelta]", " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"gmn", "=", 
     RowBox[{"-", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          FractionBox["\[CapitalSigma]sq", 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
          ",", 
          FractionBox[
           RowBox[{"2", "a", " ", "r"}], 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", 
           FractionBox["\[CapitalDelta]", "\[Rho]sq"]}], ",", "0", ",", "0"}],
          "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"-", 
           SuperscriptBox["\[Rho]sq", 
            RowBox[{"-", "1"}]]}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          FractionBox[
           RowBox[{"2", "a", " ", "r"}], 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
          ",", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"(", 
             RowBox[{"\[CapitalDelta]", "-", 
              RowBox[{
               SuperscriptBox["a", "2"], 
               SuperscriptBox[
                RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
            RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]]}]}], "}"}]}], 
       "}"}]}]}], ")"}], "//", "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invgmn", "=", 
     RowBox[{"FullSimplify", "[", 
      RowBox[{
       RowBox[{"Inverse", "[", "gmn", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ">", "0"}], "}"}]}], "]"}]}], ")"}], "//", 
   "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"x", "[", "1", "]"}], "=", "t"}], ";", 
   RowBox[{
    RowBox[{"x", "[", "2", "]"}], "=", "r"}], ";", 
   RowBox[{
    RowBox[{"x", "[", "3", "]"}], "=", "\[Theta]"}], ";", 
   RowBox[{
    RowBox[{"x", "[", "4", "]"}], "=", "\[Phi]"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "1", ",", "1"}], "]"}], "=", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"gmn", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "m"}], "]"}], "]"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"invgmn", "[", 
             RowBox[{"[", 
              RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"x", "[", "1", "]"}]}], "]"}], "+", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"invgmn", "[", 
             RowBox[{"[", 
              RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"x", "[", "1", "]"}]}], "]"}], "-", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"invgmn", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"G", "[", 
        RowBox[{"i", ",", "k", ",", "l"}], "]"}], "=", 
       RowBox[{"Simplify", "[", 
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"gmn", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "m"}], "]"}], "]"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"D", "[", 
               RowBox[{
                RowBox[{"invgmn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "k"}], "]"}], "]"}], ",", 
                RowBox[{"x", "[", "l", "]"}]}], "]"}], "+", 
              RowBox[{"D", "[", 
               RowBox[{
                RowBox[{"invgmn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "l"}], "]"}], "]"}], ",", 
                RowBox[{"x", "[", "k", "]"}]}], "]"}], "-", 
              RowBox[{"D", "[", 
               RowBox[{
                RowBox[{"invgmn", "[", 
                 RowBox[{"[", 
                  RowBox[{"k", ",", "l"}], "]"}], "]"}], ",", 
                RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "1", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"l", ",", "1", ",", "4"}], "}"}]}], "]"}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gmn", "=", 
   RowBox[{"Simplify", "[", "gmn", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invgmn", "=", 
     RowBox[{"Simplify", "[", 
      RowBox[{"invgmn", "/.", 
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"2", "\[Theta]"}], "]"}], "\[Rule]", 
        RowBox[{
         RowBox[{"2", 
          SuperscriptBox[
           RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "-", "1"}]}]}], 
      "]"}]}], ")"}], "//", "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invgmnKS", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          FractionBox[
           RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", 
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"], ",", "0", ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"2", "a", " ", "r", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"], ",", 
         RowBox[{"1", "+", 
          FractionBox[
           RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", "0", ",", 
         RowBox[{
          RowBox[{"-", "a"}], 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            FractionBox[
             RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
          SuperscriptBox[
           RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "\[Rho]sq", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"2", "a", " ", "r", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}], 
         ",", 
         RowBox[{
          RowBox[{"-", "a"}], 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            FractionBox[
             RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
          SuperscriptBox[
           RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], ",", "0", ",", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
          RowBox[{"(", 
           RowBox[{"\[Rho]sq", "+", 
            RowBox[{
             SuperscriptBox["a", "2"], 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               FractionBox[
                RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
             SuperscriptBox[
              RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}]}]}], 
        "}"}]}], "}"}]}], ")"}], "//", "MatrixForm"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"Anumu", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        FractionBox[
         RowBox[{"2", "r"}], "\[CapitalDelta]"], ",", "1", ",", "0", ",", 
        FractionBox["a", "\[CapitalDelta]"]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ")"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"invAnumu", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Inverse", "[", "Anumu", "]"}], "]"}]}], ")"}], "//", 
    "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"i1", "=", "24"}], ";", 
  RowBox[{"i2", "=", "47"}], ";", 
  RowBox[{"i3", "=", "21"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rtp", "=", 
   RowBox[{"resgd", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", 
      RowBox[{"8", ";;", "10"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xxx", "=", 
   RowBox[{"resgd", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", 
      RowBox[{"5", ";;", "7"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Coord (x1,x2): \>\"", " ", ",", 
    RowBox[{"xxx", "[", 
     RowBox[{"[", 
      RowBox[{"1", ";;", "2"}], "]"}], "]"}], ",", "\"\<; (r,\[Theta]): \>\"",
     ",", " ", 
    RowBox[{"rtp", "[", 
     RowBox[{"[", 
      RowBox[{"1", ";;", "2"}], "]"}], "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sub", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"r", "\[Rule]", 
       RowBox[{"rtp", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ",", 
      RowBox[{"x1", "\[Rule]", 
       RowBox[{"xxx", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ",", 
      RowBox[{"\[Theta]", "\[Rule]", 
       RowBox[{"rtp", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ",", 
      RowBox[{"x2", "\[Rule]", 
       RowBox[{"xxx", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ",", 
      RowBox[{"a", "\[Rule]", "0.9"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gcon", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", 
        RowBox[{"11", ";;", "26"}]}], "]"}], "]"}], ",", "4"}], "]"}]}], ";", 
  RowBox[{"gcov", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", 
        RowBox[{"27", ";;", "42"}]}], "]"}], "]"}], ",", "4"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gdet", "=", 
   RowBox[{"resgd", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", "43"}], "]"}], "]"}]}], ";", 
  RowBox[{"dxdxp", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", 
        RowBox[{"48", ";;", "63"}]}], "]"}], "]"}], ",", "4"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fie", "=", 
   RowBox[{"res2m", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}], "]"}]}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\[Rho]=\>\"", ",", " ", 
    RowBox[{"\[Rho]", "=", 
     RowBox[{"fie", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], ",", "\"\<; U=\>\"", ",", 
    RowBox[{"U", "=", 
     RowBox[{"fie", "[", 
      RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SuperscriptBox[\(u\), \(\[Mu]\)]\)=\>\"", ",", 
    RowBox[{"uup", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"fie", "[", 
         RowBox[{"[", "5", "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{"fie", "[", 
          RowBox[{"[", "5", "]"}], "]"}], 
         RowBox[{"fie", "[", 
          RowBox[{"[", 
           RowBox[{"6", ";;", "8"}], "]"}], "]"}]}]}], "}"}], "]"}]}]}], 
   "]"}], ";", 
  RowBox[{"ulo", "=", 
   RowBox[{"gcov", ".", "uup"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<MKS \!\(\*SuperscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
    RowBox[{"bi", "=", 
     RowBox[{"fie", "[", 
      RowBox[{"[", 
       RowBox[{"9", ";;", "11"}], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SuperscriptBox[\(b\), \(\[Mu]\)]\)=\>\"", ",", 
    RowBox[{"bup", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"bi", ".", 
         RowBox[{"ulo", "[", 
          RowBox[{"[", 
           RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], ",", 
        FractionBox[
         RowBox[{"bi", "+", 
          RowBox[{
           RowBox[{"bi", ".", 
            RowBox[{"ulo", "[", 
             RowBox[{"[", 
              RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], 
           RowBox[{"uup", "[", 
            RowBox[{"[", 
             RowBox[{"2", ";;", "4"}], "]"}], "]"}]}]}], 
         RowBox[{"uup", "[", 
          RowBox[{"[", "1", "]"}], "]"}]]}], "}"}], "]"}]}], ",", 
    "\"\<; \!\(\*SubscriptBox[SuperscriptBox[\(b\), \(\[Mu]\)], \
\(KS\)]\)=\>\"", ",", 
    RowBox[{"bupKS", "=", 
     RowBox[{"dxdxp", ".", "bup"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<In KS coordinates: \!\(\*SubscriptBox[SuperscriptBox[\(u\), \
\(\[Mu]\)], \(KS\)]\)=\>\"", ",", " ", 
    RowBox[{"uupKS", "=", 
     RowBox[{"dxdxp", ".", "uup"}]}], ",", 
    "\"\<;  \!\(\*SubscriptBox[\(u\), \(\[Mu]KS\)]\)=\>\"", ",", 
    RowBox[{"uloKS", "=", 
     RowBox[{
      RowBox[{"invgmnKS", ".", "uupKS"}], "/.", "sub"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<In BL coordinates: \!\(\*SubscriptBox[SuperscriptBox[\(u\), \
\(\[Mu]\)], \(BL\)]\)=\>\"", ",", " ", 
    RowBox[{"uupBL", "=", 
     RowBox[{
      RowBox[{"invAnumu", ".", "uupKS"}], "/.", "sub"}]}], ",", 
    "\"\<;  \!\(\*SubscriptBox[\(u\), \(\[Mu]BL\)]\)=\>\"", ",", 
    RowBox[{"uloBL", "=", 
     RowBox[{
      RowBox[{"invgmn", ".", "uupBL"}], "/.", "sub"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Back to KS coordinates: \!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\
\[Mu]\)], \(KS\)]\)=\>\"", ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"Transpose", "[", "Anumu", "]"}], ".", "uupBL"}], "/.", 
     "sub"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 1: \!\(\*SuperscriptBox[\(g\), \
\(\[Mu]\[Nu]\)]\)\!\(\*SubscriptBox[\(g\), \
\(\[Nu]\[Sigma]\)]\)==\!\(\*SubscriptBox[SuperscriptBox[\(\[Delta]\), \(\[Mu]\
\)], \(\[Sigma]\)]\); should be identity matrix:   \>\"", ",", 
   RowBox[{"Chop", "[", 
    RowBox[{
     RowBox[{"gcov", ".", "gcon"}], "//", "MatrixForm"}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 2: gdet==\!\(\*SqrtBox[\(-Det[gcov]\)]\);  should be unity:      \
\>\"", ",", 
   FractionBox[
    SqrtBox[
     RowBox[{"-", 
      RowBox[{"Det", "[", "gcov", "]"}]}]], "gdet"]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 3: normalization of velocity in MKS: \!\(\*SuperscriptBox[\(u\), \
\(\[Mu]\)]\)\!\(\*SubscriptBox[\(u\), \(\[Mu]\)]\)=-1:  \>\"", ",", 
   RowBox[{"ulo", ".", "uup"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 4: normalization of velocity in KS: \
\!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\[Mu]\)], \
\(KS\)]\)\!\(\*SubscriptBox[\(u\), SubscriptBox[\(\[Mu]\), \(KS\)]]\)=-1:  \>\
\"", ",", 
   RowBox[{"uupKS", ".", "uloKS"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Test 5: normalization of velocity in BL: \
\!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\[Mu]\)], \
\(BL\)]\)\!\(\*SubscriptBox[\(u\), SubscriptBox[\(\[Mu]\), \(BL\)]]\)=-1:  \>\
\"", ",", 
    RowBox[{"uupBL", ".", "uloBL"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"u", "[", "0", "]"}], ",", 
      RowBox[{"u", "[", "1", "]"}], ",", 
      RowBox[{"u", "[", "2", "]"}], ",", 
      RowBox[{"u", "[", "3", "]"}]}], "}"}], "=", "uupKS"}], "]"}], ";", 
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"uco", "[", "0", "]"}], ",", 
      RowBox[{"uco", "[", "1", "]"}], ",", 
      RowBox[{"uco", "[", "2", "]"}], ",", 
      RowBox[{"uco", "[", "3", "]"}]}], "}"}], "=", "uloKS"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "[", "0", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"u", "[", "0", "]"}], ",", 
     RowBox[{"u", "[", "1", "]"}], ",", 
     RowBox[{"u", "[", "2", "]"}], ",", 
     RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "0", "]"}], "=", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"invgmnKS", ".", 
      RowBox[{"xx", "[", "0", "]"}]}]}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "[", "2", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"uco", "[", "2", "]"}], 
      RowBox[{"u", "[", "0", "]"}]}], ",", 
     RowBox[{
      RowBox[{"uco", "[", "2", "]"}], 
      RowBox[{"u", "[", "1", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"uco", "[", "2", "]"}], 
       RowBox[{"u", "[", "2", "]"}]}], "+", "1"}], ",", 
     RowBox[{
      RowBox[{"uco", "[", "2", "]"}], 
      RowBox[{"u", "[", "3", "]"}]}]}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "2", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xx", "[", "2", "]"}]}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "[", "3", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"uco", "[", "3", "]"}], 
       RowBox[{"uco", "[", "0", "]"}]]}], ",", "0", ",", "0", ",", "1"}], 
    "}"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "3", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xx", "[", "3", "]"}]}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sc", "[", "0", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "0", "]"}], ".", 
      RowBox[{"xxlo", "[", "0", "]"}]}]], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"sc", "[", "3", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "3", "]"}], ".", 
      RowBox[{"xxlo", "[", "3", "]"}]}]], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"sc", "[", "2", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "2", "]"}], ".", 
      RowBox[{"xxlo", "[", "2", "]"}]}]], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"xx", "[", "0", "]"}], "/=", 
    RowBox[{"sc", "[", "0", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "0", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "0", "]"}], "/.", "sub"}]}], ";", 
   RowBox[{
    RowBox[{"xx", "[", "2", "]"}], "/=", 
    RowBox[{"sc", "[", "2", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "2", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "2", "]"}], "/.", "sub"}]}], ";", 
   RowBox[{
    RowBox[{"xx", "[", "3", "]"}], "/=", 
    RowBox[{"sc", "[", "3", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "3", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "3", "]"}], "/.", "sub"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xpr", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], 
       RowBox[{"uco", "[", "1", "]"}]}], " ", ",", 
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"u", "[", "0", "]"}], 
          RowBox[{"uco", "[", "0", "]"}]}], "+", 
         RowBox[{
          RowBox[{"u", "[", "3", "]"}], 
          RowBox[{"uco", "[", "3", "]"}]}]}], ")"}]}], ",", "0", ",", 
      RowBox[{
       RowBox[{"u", "[", "3", "]"}], 
       RowBox[{"uco", "[", "1", "]"}]}]}], "}"}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xlopr", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"xx", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"xpr", "[", "1", "]"}], "-", 
    RowBox[{
     RowBox[{
      RowBox[{"xlopr", "[", "1", "]"}], ".", 
      RowBox[{"xx", "[", "3", "]"}]}], "*", 
     RowBox[{"xx", "[", "3", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xxlo", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xx", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"sc", "[", "1", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "1", "]"}], ".", 
      RowBox[{"xxlo", "[", "1", "]"}]}]], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xlopr", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"xx", "[", "1", "]"}], "/=", 
   RowBox[{"sc", "[", "1", "]"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "1", "]"}], "/=", 
   RowBox[{
    RowBox[{"sc", "[", "1", "]"}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"trxx", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"xxlo", "[", "0", "]"}], ",", 
      RowBox[{"xxlo", "[", "1", "]"}], ",", 
      RowBox[{"xxlo", "[", "2", "]"}], ",", 
      RowBox[{"xxlo", "[", "3", "]"}]}], "}"}]}], ";", 
   RowBox[{"trcoxx", "=", 
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"xx", "[", "0", "]"}], ",", 
       RowBox[{"xx", "[", "1", "]"}], ",", 
       RowBox[{"xx", "[", "2", "]"}], ",", 
       RowBox[{"xx", "[", "3", "]"}]}], "}"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", "tests", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Test 6: \!\(\*SubscriptBox[\(u\), \(i\)]\)=\>\"", ",", 
    RowBox[{"trxx", ".", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], ",", 
       RowBox[{"u", "[", "1", "]"}], ",", 
       RowBox[{"u", "[", "2", "]"}], ",", 
       RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ",", 
    "\"\<;  should be {1,0,0,0}\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Test 7: co-moving \!\(\*SubscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
    RowBox[{"coB", "=", 
     RowBox[{
      RowBox[{"trxx", ".", "bupKS"}], "/.", "sub"}]}], ",", 
    "\"\<;  0-th component should be 0\>\""}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Back to KS frame: \!\(\*SubscriptBox[SuperscriptBox[\(b\), \
\(\[Mu]\)], \(KS\)]\)=\>\"", ",", 
    RowBox[{"trcoxx", ".", "coB"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5454000162374997`*^9, 3.545400016674525*^9}, {
   3.5454021726668406`*^9, 3.5454021745119457`*^9}, {3.5454023760944757`*^9, 
   3.545402376496499*^9}, {3.545402495858326*^9, 3.5454025074229875`*^9}, 
   3.5454025825032816`*^9, {3.5454028874277225`*^9, 3.5454029476221657`*^9}, {
   3.545403011124798*^9, 3.545403016154085*^9}, {3.5454030531872034`*^9, 
   3.545403069655145*^9}, {3.5454031640715456`*^9, 3.545403172064003*^9}, {
   3.545403514974616*^9, 3.5454035544588747`*^9}, {3.5454036313522725`*^9, 
   3.5454036387846975`*^9}, {3.5454052181910343`*^9, 
   3.5454052978475904`*^9}, {3.54540581744831*^9, 3.54540581779533*^9}, {
   3.545408091542381*^9, 3.5454080920914125`*^9}, {3.546871327069433*^9, 
   3.5468713272944465`*^9}, {3.5468726464658985`*^9, 
   3.5468726465539036`*^9}, {3.5473040581236486`*^9, 
   3.5473040807089405`*^9}, {3.5473043892395873`*^9, 3.547304389324592*^9}, {
   3.547481920088093*^9, 3.5474819328308215`*^9}, {3.5474832134720697`*^9, 
   3.547483213591077*^9}, 3.547483332494878*^9, 3.550983343034961*^9, {
   3.5509842956194344`*^9, 3.5509842961810355`*^9}, {3.5519849897691307`*^9, 
   3.551985020398883*^9}, {3.5520158429974165`*^9, 3.552015863940614*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"np", "=", "64"}], ";", 
    RowBox[{"h", "=."}], ";", 
    RowBox[{"\[Theta]tab", "=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"h", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", "x2"}], "-", "1"}], ")"}]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "-", "h"}], ")"}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "x2"}], "-", "1"}], ")"}], "7"]}], "+", "1"}], 
         ")"}], 
        FractionBox["\[Pi]", "2"]}], "/.", 
       RowBox[{"x2", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"x2tab", "=", 
          RowBox[{"N", "[", 
           RowBox[{"Range", "[", 
            RowBox[{
             FractionBox["1", 
              RowBox[{"2", "np"}]], ",", 
             RowBox[{"1", "-", 
              FractionBox["1", 
               RowBox[{"2", "np"}]]}], ",", 
             FractionBox["1", "np"]}], "]"}], "]"}]}], ")"}]}]}], "/.", 
      RowBox[{"{", 
       RowBox[{"h", "\[Rule]", "0.65"}], "}"}]}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ncut", "=", 
     RowBox[{"ncuttab", "[", 
      RowBox[{"[", "sp", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rtab11", "=", 
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"1", ";;", "ncut"}], ",", "1", ",", "8"}], "]"}], "]"}]}], 
    ";", 
    RowBox[{"rcut", "=", 
     RowBox[{"rtab11", "[", 
      RowBox[{"[", 
       RowBox[{"-", "1"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"rtab11", "=", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{
        "Import", "[", "\"\<E:\\\\GRMHD\\\\a05\\\\Tsmap05.dat\>\"", "]"}], 
        "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", 
         RowBox[{"1", ";;", "ncut"}]}], "]"}], "]"}]}], ";", 
     RowBox[{"rcut", "=", 
      RowBox[{"rtab11", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ";"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rrmax", "=", "340000."}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rtab22", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"rcut", "*", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"rrmax", "/", "rcut"}], ")"}], 
         FractionBox[
          RowBox[{"k", "-", "ncut", "+", "1"}], 
          RowBox[{"ndd", "-", "ncut"}]]]}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "ncut", ",", 
         RowBox[{"ndd", "-", "1"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rtab", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"rtab11", ",", "rtab22"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"rn", "=", 
      RowBox[{"Length", "[", "rtab", "]"}]}], ";", 
     RowBox[{"tn", "=", 
      RowBox[{"Total", "[", "x2tab", "]"}]}], ";", 
     RowBox[{"ListLogPlot", "[", "rtab", "]"}], ";", 
     RowBox[{"i1", "=."}], ";", 
     RowBox[{"i2", "=."}], ";"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"dxdxptab", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"DiagonalMatrix", "[", 
           RowBox[{"{", 
            RowBox[{"1.", ",", 
             RowBox[{"r", "-", "R0"}], ",", 
             RowBox[{"(", 
              RowBox[{"\[Pi]", 
               RowBox[{"(", 
                RowBox[{"h", "+", 
                 RowBox[{"7", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", "h"}], ")"}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", "x2"}], "-", "1"}], ")"}], "6"]}]}], ")"}]}],
               ")"}], ",", 
             RowBox[{"1.", "\[Pi]"}]}], "}"}], "]"}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"r", "\[Rule]", 
             RowBox[{"rtab", "[", 
              RowBox[{"[", "i1", "]"}], "]"}]}], ",", 
            RowBox[{"x2", "\[Rule]", 
             RowBox[{"x2tab", "[", 
              RowBox[{"[", "i2", "]"}], "]"}]}]}], "}"}]}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"R0", "\[Rule]", "0.3"}], ",", 
           RowBox[{"h", "\[Rule]", "0.65"}]}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i1", ",", 
          RowBox[{"Length", "[", "rtab", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i2", ",", 
          RowBox[{"Length", "[", "x2tab", "]"}]}], "}"}]}], "]"}]}], ";"}], 
    "*)"}], "\n", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"coord", "=", 
      RowBox[{"Outer", "[", 
       RowBox[{"List", ",", 
        RowBox[{"Log", "[", "rtab", "]"}], ",", 
        RowBox[{"-", 
         RowBox[{"Cos", "[", "\[Theta]tab", "]"}]}]}], "]"}]}], ";"}], "*)"}],
    "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rcmax", "=", 
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"264", ",", "1", ",", "8"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"coordx11", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"resgd", "[", 
            RowBox[{"[", 
             RowBox[{"num", ",", "All", ",", "8"}], "]"}], "]"}], "]"}], ",", 
          RowBox[{"-", 
           RowBox[{"Cos", "[", 
            RowBox[{"resgd", "[", 
             RowBox[{"[", 
              RowBox[{"num", ",", "All", ",", "9"}], "]"}], "]"}], "]"}]}]}], 
         "}"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"num", ",", "ncut"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"dxdxptab11", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"resgd", "[", 
          RowBox[{"[", 
           RowBox[{"i1", ",", "i2", ",", 
            RowBox[{"48", ";;", "63"}]}], "]"}], "]"}], ",", "4"}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i1", ",", "ncut"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i2", ",", "126"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"dxdxptab22", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.", ",", "0.", ",", "0.", ",", "0."}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.", ",", 
           RowBox[{"rtab", "[", 
            RowBox[{"[", 
             RowBox[{"i1", "+", "1"}], "]"}], "]"}], ",", "0.", ",", "0."}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.", ",", "0.", ",", 
           FractionBox["\[Pi]", "2."], ",", "0."}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.", ",", "0.", ",", "0.", ",", 
           RowBox[{"2.", "\[Pi]"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i1", ",", "ncut", ",", 
         RowBox[{"ndd", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i2", ",", "126"}], "}"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"thtab22", "=", 
     RowBox[{"-", 
      RowBox[{"Cos", "[", 
       RowBox[{"resgd", "[", 
        RowBox[{"[", 
         RowBox[{"ncut", ",", "All", ",", "9"}], "]"}], "]"}], "]"}]}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{"coordx22", "=", 
     RowBox[{"Outer", "[", 
      RowBox[{"List", ",", 
       RowBox[{"Log", "[", "rtab22", "]"}], ",", "thtab22"}], "]"}]}], ";"}], 
   "\n", 
   RowBox[{"Dimensions", "[", 
    RowBox[{"coordfin", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"coordx11", ",", "coordx22"}], "]"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Dimensions", "[", 
    RowBox[{"dxdxpfin", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"dxdxptab11", ",", "dxdxptab22"}], "]"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fif", "=", 
     RowBox[{"OpenWrite", "[", 
      RowBox[{
       RowBox[{"\"\<E:\\\\GRMHD\\\\ADAFs\\\\a\>\"", "<>", 
        RowBox[{"atab", "[", 
         RowBox[{"[", "sp", "]"}], "]"}], "<>", "\"\<\\\\dxdxp.dat\>\""}], 
       ",", 
       RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"BinaryWrite", "[", 
    RowBox[{"fif", ",", 
     RowBox[{"Flatten", "[", "coordfin", "]"}], ",", "\"\<Real32\>\""}], 
    "]"}], "\[IndentingNewLine]", 
   RowBox[{"BinaryWrite", "[", 
    RowBox[{"fif", ",", 
     RowBox[{"Flatten", "[", "dxdxpfin", "]"}], ",", "\"\<Real32\>\""}], 
    "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Close", "[", "fif", "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"fullcoord", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Log", "[", 
            RowBox[{"resgd", "[", 
             RowBox[{"[", 
              RowBox[{"num", ",", "All", ",", "8"}], "]"}], "]"}], "]"}], ",", 
           RowBox[{"-", 
            RowBox[{"Cos", "[", 
             RowBox[{"resgd", "[", 
              RowBox[{"[", 
               RowBox[{"num", ",", "All", ",", "9"}], "]"}], "]"}], "]"}]}]}],
           "}"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"num", ",", "256"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"fullcoord", "=", 
      RowBox[{"Join", "[", 
       RowBox[{"fullcoord", ",", 
        RowBox[{"Abs", "[", 
         RowBox[{"Reverse", "[", 
          RowBox[{"fullcoord", ",", "2"}], "]"}], "]"}], ",", "2"}], "]"}]}], 
     ";"}], "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.5472945808155775`*^9, 3.5472946145585074`*^9}, {
   3.547294768023285*^9, 3.5472948032623005`*^9}, 3.5473953904776516`*^9, {
   3.5473957199844985`*^9, 3.5473957607268286`*^9}, 3.5473958009761305`*^9, {
   3.547395890562255*^9, 3.547395900555826*^9}, {3.5473959984834275`*^9, 
   3.547396012973256*^9}, {3.550989334627646*^9, 3.5509893802973127`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tn", "=", "23"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"dxdxpfin", "[", 
  RowBox[{"[", 
   RowBox[{
    RowBox[{"ncut", "-", "1"}], ",", "tn"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"dxdxpfin", "[", 
  RowBox[{"[", 
   RowBox[{"ncut", ",", "tn"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"dxdxpfin", "[", 
  RowBox[{"[", 
   RowBox[{
    RowBox[{"ncut", "+", "1"}], ",", "tn"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"coordfin", "[", 
  RowBox[{"[", 
   RowBox[{
    RowBox[{"ncut", "-", "1"}], ",", "tn"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"coordfin", "[", 
  RowBox[{"[", 
   RowBox[{"ncut", ",", "tn"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"coordfin", "[", 
  RowBox[{"[", 
   RowBox[{
    RowBox[{"ncut", "+", "1"}], ",", "tn"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5473955662577057`*^9, 3.54739561389443*^9}, {
  3.5473956585349836`*^9, 3.5473956716787357`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tn", "=", "64"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"lpl22", "=", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab11", ",", 
        RowBox[{"dxdxptab11", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "tn", ",", "2", ",", "2"}], "]"}], "]"}]}], 
       "}"}], "]"}], "]"}]}], ",", 
   RowBox[{"ListLogPlot", "[", 
    RowBox[{"dxdxptab11", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "9", ",", "3", ",", "3"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"ListLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"dxdxptab11", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "tn", ",", "3", ",", "2"}], "]"}], "]"}], "]"}], 
    "]"}], ",", 
   RowBox[{"ListLogPlot", "[", 
    RowBox[{"dxdxptab11", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "tn", ",", "4", ",", "4"}], "]"}], "]"}], "]"}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl22", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{"r", ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"rtab11", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{"rtab11", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"lpl22", ",", "pl22"}], "]"}]}], "Input",
 CellChangeTimes->{{3.547306806114515*^9, 3.547306951926855*^9}, {
  3.547307018612669*^9, 3.5473070240999827`*^9}, {3.5473070998133135`*^9, 
  3.547307219210142*^9}}],

Cell[BoxData[
 RowBox[{"dxdxp", "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.5473070749838934`*^9, 3.547307077488036*^9}}],

Cell[BoxData[{
 RowBox[{"ListPlot", "[", 
  RowBox[{"dxdxptab11", "[", 
   RowBox[{"[", 
    RowBox[{"100", ",", "All", ",", "3", ",", "3"}], "]"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{"dxdxptab11", "[", 
   RowBox[{"[", 
    RowBox[{"100", ",", "All", ",", "3", ",", "2"}], "]"}], "]"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.547307317726777*^9, 3.5473073258712435`*^9}, {
  3.547307363135374*^9, 3.5473073719098763`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"0", ",", "0"}], ")"}], " ", "\[Rule]", " ", "1"}], ";", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", ",", "1"}], ")"}], " ", "\[Rule]", " ", "r"}], ";", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"2", ",", "2"}], ")"}], " ", "\[Rule]", " ", 
     RowBox[{"\[Pi]", "/", "2"}]}], ";", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"3", ",", "3"}], ")"}], " ", "\[Rule]", " ", 
     RowBox[{"2", "\[Pi]"}]}], ";", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"3", ",", "2"}], ")"}], " ", "\[Rule]", " ", "0"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1.", ",", "0.", ",", "0.", ",", "0."}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.", ",", "r", ",", "0.", ",", "0."}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.", ",", "0.", ",", 
      FractionBox["\[Pi]", "2."], ",", "0."}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.", ",", "0.", ",", "0.", ",", 
      RowBox[{"2.", "\[Pi]"}]}], "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.547307048512379*^9, 3.54730708804064*^9}, {
  3.547307127464895*^9, 3.547307128463952*^9}, {3.5473072327269154`*^9, 
  3.547307292712346*^9}, {3.5473073390079947`*^9, 3.5473074308502474`*^9}}],

Cell[BoxData[{"gcov", "\[IndentingNewLine]", 
 RowBox[{"invgmnKS", "/.", "sub"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Transpose", "[", "dxdxp", "]"}], ".", "invgmnKS", ".", "dxdxp"}], 
  "/.", "sub"}]}], "Input",
 CellChangeTimes->{{3.5468726348802357`*^9, 3.546872746954646*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"given", " ", "u"}], ",", " ", "iKS", ",", " ", 
   RowBox[{"dxdxp", ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"1.", " ", "Find", " ", "iMKS"}], "=", 
     RowBox[{
      RowBox[{"Transpose", "[", "dxdxp", "]"}], ".", "iKS", ".", "dxdxp"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"2.", " ", "Find", " ", "ulo"}], "=", 
     RowBox[{"iMKS", ".", "u"}]}], ";"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.546872523859886*^9, 3.546872603859462*^9}, {
  3.546873333406189*^9, 3.546873351798241*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
for Jon\[CloseCurlyQuote]s jet simulations with QPOs (i.e. thickdisk7)\
\>", "Subsubsection",
 CellChangeTimes->{{3.5553303735213623`*^9, 3.5553303963886704`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", " ", "=", " ", 
   RowBox[{"NotebookDirectory", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ndd", "=", "650"}], ";", 
  RowBox[{"ncut", "=", "120"}], ";", 
  RowBox[{"NDIM", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dirin", "=", "\"\<E:\\\\GRMHD\\\\Jon\\\\\>\""}], ";", 
  RowBox[{"anum", "=", "0.9375"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"readgd", "[", "spstr_", "]"}], " ", ":=", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", " ", "=", 
      RowBox[{"dirin", "<>", "atab", "<>", "\"\<\\\\gdump.bin\>\""}]}], ";", 
     "\n", "   ", 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"272", "*", "128", "*", "256", "*", "8", "*", "126"}]}], ";", 
     "\n", "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", "156"}], 
        "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetStreamPosition", "[", 
      RowBox[{"fi11", ",", 
       RowBox[{"siz", "-", "xs"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"resgd", " ", "=", " ", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"BinaryReadList", "[", 
               RowBox[{"fi11", ",", " ", "\"\<Real64\>\"", ",", 
                RowBox[{"xs", "/", "8"}]}], "]"}], ",", 
              SuperscriptBox["NDIM", "2"]}], "]"}], ",", "272"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";"}], "*)"}],
      "\[IndentingNewLine]", 
     RowBox[{"resgd", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"BinaryReadList", "[", 
               RowBox[{"fi11", ",", " ", "\"\<Real64\>\"", ",", 
                RowBox[{"xs", "/", "8"}]}], "]"}], ",", "126"}], "]"}], ",", 
            "272"}], "]"}], ",", "128"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"resgd", " ", "=", " ", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"llist", " ", "=", " ", 
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"Partition", "[", 
                RowBox[{
                 RowBox[{"BinaryReadList", "[", 
                  RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                   RowBox[{"11", "*", "64", "*", "128", "*", "256"}]}], "]"}],
                  ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], ",", " ",
              "128"}], "]"}]}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], 
           "}"}]}], "]"}]}], ";"}], "*)"}], "\n", "   ", 
     RowBox[{"Close", "[", "fi11", "]"}], ";"}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"readgd2d", "[", "spstr_", "]"}], " ", ":=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"namefile", " ", "=", 
       RowBox[{"dirin", "<>", "atab", "<>", "\"\<\\\\gdump.bin\>\""}]}], ";", 
      "\n", "   ", 
      RowBox[{"siz", " ", "=", " ", 
       RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
      RowBox[{"phlen", "=", "256"}], ";", 
      RowBox[{"xs", " ", "=", " ", 
       RowBox[{"272", "*", "128", "*", "phlen", "*", "8", "*", "126"}]}], ";",
       "\n", "   ", 
      RowBox[{"fi11", " ", "=", " ", 
       RowBox[{"OpenRead", "[", 
        RowBox[{"namefile", ",", " ", 
         RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
      RowBox[{"strrr", " ", "=", " ", 
       RowBox[{"StringJoin", "[", 
        RowBox[{"BinaryReadList", "[", 
         RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", "156"}], 
         "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"SetStreamPosition", "[", 
       RowBox[{"fi11", ",", 
        RowBox[{"siz", "-", "xs"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"resgd", " ", "=", " ", 
         RowBox[{"Transpose", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"BinaryReadList", "[", 
                RowBox[{"fi11", ",", " ", "\"\<Real64\>\"", ",", 
                 RowBox[{"xs", "/", "8"}]}], "]"}], ",", 
               SuperscriptBox["NDIM", "2"]}], "]"}], ",", "272"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"resgd2d", " ", "=", " ", 
       RowBox[{"Transpose", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"BinaryReadList", "[", 
              RowBox[{"fi11", ",", " ", "\"\<Real64\>\"", ",", 
               RowBox[{
                RowBox[{"xs", "/", "8"}], "/", "phlen"}]}], "]"}], ",", 
             "126"}], "]"}], ",", "272"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", "\n", 
      "   ", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"resgd", " ", "=", " ", 
         RowBox[{"Transpose", "[", 
          RowBox[{
           RowBox[{"llist", " ", "=", " ", 
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"Partition", "[", 
               RowBox[{
                RowBox[{"Partition", "[", 
                 RowBox[{
                  RowBox[{"BinaryReadList", "[", 
                   RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                    RowBox[{"11", "*", "64", "*", "128", "*", "256"}]}], 
                   "]"}], ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], 
              ",", " ", "128"}], "]"}]}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], 
            "}"}]}], "]"}]}], ";"}], "*)"}], "\n", "   ", 
      RowBox[{"Close", "[", "fi11", "]"}], ";"}], ")"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", 
    RowBox[{"spstr_", ",", "fnum_"}], "]"}], " ", ":=", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", " ", "=", 
      RowBox[{
      "dirin", "<>", "spstr", "<>", "\"\<\\\\fieldlines\\\\fieldline\>\"", 
       " ", "<>", " ", 
       RowBox[{"StringJoin", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", "#", "]"}], " ", "&"}], " ", "/@", " ", 
         RowBox[{"PadLeft", "[", 
          RowBox[{
           RowBox[{"IntegerDigits", "[", "fnum", "]"}], ",", " ", "4"}], 
          "]"}]}], "]"}], " ", "<>", " ", "\"\<.bin\>\""}]}], ";", "\n", 
     "   ", 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "272", " ", "128", " ", "256", "*", "4"}]}], ";", 
     "\n", "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"str", "=", 
      RowBox[{"StringToStream", "[", "strrr", "]"}]}], ";", 
     RowBox[{"param", "=", 
      RowBox[{"ReadList", "[", 
       RowBox[{"str", ",", "Number"}], "]"}]}], ";", 
     RowBox[{"Close", "[", "str", "]"}], ";", "\n", "   ", 
     RowBox[{"res2m", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"llist", " ", "=", " ", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"BinaryReadList", "[", 
                RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                 RowBox[{"xs", "/", "4"}]}], "]"}], ",", " ", "11"}], "]"}], 
             ",", " ", "272"}], "]"}], ",", " ", "128"}], "]"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], "}"}]}], 
       "]"}]}], ";", "\n", "   ", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"atab", "=", "\"\<thickdisk7\>\""}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"readgd", "[", "atab", "]"}], "*)"}]}], "\n", 
 RowBox[{"readgd2d", "[", "atab", "]"}], "\[IndentingNewLine]", 
 RowBox[{"read11", "[", 
  RowBox[{"atab", ",", "7034"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "res2m", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "resgd", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Dimensions", "[", "resgd2d", "]"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"extension", " ", "to", " ", "large", " ", 
     RowBox[{"radius", ":", " ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"quantities", " ", "extended", " ", "as", " ", "power"}], "-", 
       "laws"}]}]}], ";", " ", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
     "elements", " ", "of", " ", "dxdxp", " ", "matrices", " ", "are", " ", 
      "extended", " ", "as", " ", "power"}], "-", "laws"}], ";", " ", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"grids", " ", "are", " ", "extended", " ", "as", " ", "power"}], 
     "-", "laws"}], ";", " ", 
    RowBox[{
    "theta", " ", "grid", " ", "is", " ", "fixed", " ", "at", " ", "40", "M", 
     " ", "boundary"}], ";"}], "*)"}]}], "\n"}], "Input",
 CellChangeTimes->{{3.48199863871*^9, 3.4819986488344*^9}, {
   3.4821459308244*^9, 3.4821459311208*^9}, 3.4834575605388002`*^9, {
   3.4834576012392*^9, 3.4834576140312*^9}, {3.4834576807524*^9, 
   3.4834576815011997`*^9}, {3.4834577493612003`*^9, 3.4834577829636*^9}, {
   3.4834578209184*^9, 3.4834578352236*^9}, {3.5057603089278*^9, 
   3.5057603097546*^9}, {3.541203794809623*^9, 3.541203794981223*^9}, {
   3.5412043045883183`*^9, 3.5412043088003254`*^9}, {3.541204501242264*^9, 
   3.541204515750289*^9}, {3.5414588063706646`*^9, 3.541458813749087*^9}, {
   3.541458983765811*^9, 3.541459124153841*^9}, {3.5414592320200105`*^9, 
   3.5414592345781565`*^9}, {3.5414593414802713`*^9, 
   3.5414593601943417`*^9}, {3.541459447008307*^9, 3.54145948395142*^9}, {
   3.5414595323981915`*^9, 3.5414595580486584`*^9}, {3.541459622176326*^9, 
   3.541459622384338*^9}, {3.5414622654635134`*^9, 3.5414622660455465`*^9}, {
   3.5414623043457375`*^9, 3.541462304989774*^9}, {3.541462385373372*^9, 
   3.541462386052411*^9}, {3.5414624305879583`*^9, 3.5414624889242945`*^9}, {
   3.541462537932098*^9, 3.541462545298519*^9}, 3.545409232910663*^9, {
   3.5454092720989046`*^9, 3.5454092728439474`*^9}, {3.5472560730601273`*^9, 
   3.5472560743392005`*^9}, {3.547294353431572*^9, 3.5472945377361135`*^9}, {
   3.547294775668722*^9, 3.547294776171751*^9}, {3.5473042542098637`*^9, 
   3.547304254696892*^9}, {3.547306391910824*^9, 3.547306489613412*^9}, {
   3.5474815714911537`*^9, 3.547481571546157*^9}, {3.547481738490706*^9, 
   3.5474817391217422`*^9}, {3.5474831480233264`*^9, 3.547483148102331*^9}, {
   3.547483180727197*^9, 3.5474831966611085`*^9}, {3.547483265239031*^9, 
   3.547483270429328*^9}, {3.5474833051833153`*^9, 3.5474833174870195`*^9}, {
   3.547483360174461*^9, 3.547483367973907*^9}, {3.5509830780684958`*^9, 
   3.550983139501404*^9}, {3.550983213024333*^9, 3.5509832275791583`*^9}, {
   3.550983262164419*^9, 3.5509832622112193`*^9}, {3.550983454840358*^9, 
   3.550983520407273*^9}, {3.550983558159339*^9, 3.550983584180185*^9}, {
   3.5509892690699368`*^9, 3.5509892702867393`*^9}, {3.551984022106784*^9, 
   3.551984034410487*^9}, {3.5519848768126698`*^9, 3.551984877178691*^9}, {
   3.551984946135635*^9, 3.5519849468806777`*^9}, {3.5520152453262315`*^9, 
   3.552015245423237*^9}, {3.552015752103217*^9, 3.552015764120905*^9}, {
   3.552015816751915*^9, 3.552015817034931*^9}, {3.552015919532794*^9, 
   3.5520159394539332`*^9}, {3.555330639087552*^9, 3.5553306893434267`*^9}, {
   3.555331083042945*^9, 3.5553312104602327`*^9}, {3.555331279890204*^9, 
   3.555331310157935*^9}, {3.5553313474530687`*^9, 3.555331360302803*^9}, {
   3.5553315883518467`*^9, 3.5553316129072514`*^9}, {3.5553318323728037`*^9, 
   3.5553318328688326`*^9}, {3.5553320868213577`*^9, 
   3.5553320935707436`*^9}, {3.5553338103389373`*^9, 
   3.5553338177593617`*^9}, {3.55533395812339*^9, 3.555333966842889*^9}, {
   3.5553342131089745`*^9, 3.5553342298939342`*^9}, {3.5553342896843543`*^9, 
   3.555334303208128*^9}, {3.5553343658997135`*^9, 3.555334410294253*^9}, {
   3.555334517746399*^9, 3.5553345518263483`*^9}, {3.5553347214450493`*^9, 
   3.555334723306156*^9}, {3.5553347975003996`*^9, 3.555334798799474*^9}, {
   3.555334883553322*^9, 3.555334884325366*^9}, {3.555335011605646*^9, 
   3.555335042397407*^9}, 3.5553352514763656`*^9, {3.555336466198844*^9, 
   3.5553364663468523`*^9}, 3.5560223428512583`*^9, 3.5560292045947275`*^9, {
   3.558953002857064*^9, 3.5589530326087656`*^9}, {3.558953140646945*^9, 
   3.558953181559285*^9}, {3.5589532335192566`*^9, 3.558953292772646*^9}, {
   3.5589533325199194`*^9, 3.5589533745173216`*^9}, {3.5669593879819045`*^9, 
   3.56695940261473*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"rtab", "=", 
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1", ",", "1", ",", "7"}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"thtab", "=", 
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "All", ",", "1", ",", "8"}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"phtab", "=", 
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "1", ",", "All", ",", "9"}], "]"}], "]"}]}], ";"}], 
   "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"rtab", "=", 
     RowBox[{"resgd2d", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1", ",", "7"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"thtab", "=", 
     RowBox[{"resgd2d", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "All", ",", "8"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rdim", "=", 
      RowBox[{"param", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], ",", 
     RowBox[{"thdim", "=", 
      RowBox[{"param", "[", 
       RowBox[{"[", "3", "]"}], "]"}]}], ",", 
     RowBox[{"phdim", "=", 
      RowBox[{"param", "[", 
       RowBox[{"[", "4", "]"}], "]"}]}], ",", 
     RowBox[{"anum", "=", 
      RowBox[{"param", "[", 
       RowBox[{"[", "13", "]"}], "]"}]}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ncut", "=", "143"}], ";", 
    RowBox[{"ncut", "=", "rdim"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"rtab", "[", 
    RowBox[{"[", "ncut", "]"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"dxdxptab11", "=", 
      RowBox[{"Partition", "[", 
       RowBox[{
        RowBox[{"resgd", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", "1", ",", 
           RowBox[{
            RowBox[{"-", 
             SuperscriptBox["NDIM", "2"]}], ";;", 
            RowBox[{"-", "1"}]}]}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"272", ",", "128", ",", "4"}], "}"}]}], "]"}]}], ";"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"dxdxptab11", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"resgd", "[", 
           RowBox[{"[", 
            RowBox[{"i1", ",", "i2", ",", "1", ",", 
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["NDIM", "2"]}], ";;", 
              RowBox[{"-", "1"}]}]}], "]"}], "]"}], ",", "4"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i1", ",", "ncut"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i2", ",", "128"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"dxdxptab11", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"resgd2d", "[", 
          RowBox[{"[", 
           RowBox[{"i1", ",", "i2", ",", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["NDIM", "2"]}], ";;", 
             RowBox[{"-", "1"}]}]}], "]"}], "]"}], ",", "4"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i1", ",", "ncut"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i2", ",", "128"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rtab11", "=", 
     RowBox[{"rtab", "[", 
      RowBox[{"[", 
       RowBox[{"1", ";;", "ncut"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Dimensions", "[", "dxdxptab11", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5560292176924767`*^9, 3.556029227452035*^9}, {
  3.5589534623673463`*^9, 3.5589534711538486`*^9}, {3.55895351733749*^9, 
  3.558953554137595*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[CapitalDelta]", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "-", 
    RowBox[{"2", "r"}], "+", 
    SuperscriptBox["a", "2"]}]}], ";", 
  RowBox[{"\[Rho]sq", "=", 
   RowBox[{
    SuperscriptBox["r", "2"], "+", 
    RowBox[{
     SuperscriptBox["a", "2"], 
     SuperscriptBox[
      RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}]}], ";", 
  RowBox[{"\[CapitalSigma]sq", "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["r", "2"], "+", 
       SuperscriptBox["a", "2"]}], ")"}], "2"], "-", 
    RowBox[{
     SuperscriptBox["a", "2"], "\[CapitalDelta]", " ", 
     SuperscriptBox[
      RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"gmn", "=", 
     RowBox[{"-", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          FractionBox["\[CapitalSigma]sq", 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
          ",", 
          FractionBox[
           RowBox[{"2", "a", " ", "r"}], 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", 
           FractionBox["\[CapitalDelta]", "\[Rho]sq"]}], ",", "0", ",", "0"}],
          "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"-", 
           SuperscriptBox["\[Rho]sq", 
            RowBox[{"-", "1"}]]}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          FractionBox[
           RowBox[{"2", "a", " ", "r"}], 
           RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", "0", 
          ",", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"(", 
             RowBox[{"\[CapitalDelta]", "-", 
              RowBox[{
               SuperscriptBox["a", "2"], 
               SuperscriptBox[
                RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
            RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]]}]}], "}"}]}], 
       "}"}]}]}], ")"}], "//", "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invgmn", "=", 
     RowBox[{"FullSimplify", "[", 
      RowBox[{
       RowBox[{"Inverse", "[", "gmn", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ">", "0"}], "}"}]}], "]"}]}], ")"}], "//", 
   "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"x", "[", "1", "]"}], "=", "t"}], ";", 
   RowBox[{
    RowBox[{"x", "[", "2", "]"}], "=", "r"}], ";", 
   RowBox[{
    RowBox[{"x", "[", "3", "]"}], "=", "\[Theta]"}], ";", 
   RowBox[{
    RowBox[{"x", "[", "4", "]"}], "=", "\[Phi]"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"G", "[", 
      RowBox[{"1", ",", "1", ",", "1"}], "]"}], "=", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"gmn", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "m"}], "]"}], "]"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"invgmn", "[", 
             RowBox[{"[", 
              RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"x", "[", "1", "]"}]}], "]"}], "+", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"invgmn", "[", 
             RowBox[{"[", 
              RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"x", "[", "1", "]"}]}], "]"}], "-", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"invgmn", "[", 
             RowBox[{"[", 
              RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
            RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"G", "[", 
        RowBox[{"i", ",", "k", ",", "l"}], "]"}], "=", 
       RowBox[{"Simplify", "[", 
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"gmn", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "m"}], "]"}], "]"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"D", "[", 
               RowBox[{
                RowBox[{"invgmn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "k"}], "]"}], "]"}], ",", 
                RowBox[{"x", "[", "l", "]"}]}], "]"}], "+", 
              RowBox[{"D", "[", 
               RowBox[{
                RowBox[{"invgmn", "[", 
                 RowBox[{"[", 
                  RowBox[{"m", ",", "l"}], "]"}], "]"}], ",", 
                RowBox[{"x", "[", "k", "]"}]}], "]"}], "-", 
              RowBox[{"D", "[", 
               RowBox[{
                RowBox[{"invgmn", "[", 
                 RowBox[{"[", 
                  RowBox[{"k", ",", "l"}], "]"}], "]"}], ",", 
                RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "1", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"l", ",", "1", ",", "4"}], "}"}]}], "]"}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gmn", "=", 
   RowBox[{"Simplify", "[", "gmn", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invgmn", "=", 
     RowBox[{"Simplify", "[", 
      RowBox[{"invgmn", "/.", 
       RowBox[{
        RowBox[{"Cos", "[", 
         RowBox[{"2", "\[Theta]"}], "]"}], "\[Rule]", 
        RowBox[{
         RowBox[{"2", 
          SuperscriptBox[
           RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "-", "1"}]}]}], 
      "]"}]}], ")"}], "//", "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"invgmnKS", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          FractionBox[
           RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", 
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"], ",", "0", ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"2", "a", " ", "r", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         FractionBox[
          RowBox[{"2", "r"}], "\[Rho]sq"], ",", 
         RowBox[{"1", "+", 
          FractionBox[
           RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", "0", ",", 
         RowBox[{
          RowBox[{"-", "a"}], 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            FractionBox[
             RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
          SuperscriptBox[
           RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "\[Rho]sq", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"2", "a", " ", "r", " ", 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}], 
         ",", 
         RowBox[{
          RowBox[{"-", "a"}], 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            FractionBox[
             RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
          SuperscriptBox[
           RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], ",", "0", ",", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
          RowBox[{"(", 
           RowBox[{"\[Rho]sq", "+", 
            RowBox[{
             SuperscriptBox["a", "2"], 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               FractionBox[
                RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
             SuperscriptBox[
              RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}]}]}], 
        "}"}]}], "}"}]}], ")"}], "//", "MatrixForm"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"Anumu", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        FractionBox[
         RowBox[{"2", "r"}], "\[CapitalDelta]"], ",", "1", ",", "0", ",", 
        FractionBox["a", "\[CapitalDelta]"]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ")"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"invAnumu", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Inverse", "[", "Anumu", "]"}], "]"}]}], ")"}], "//", 
    "MatrixForm"}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"i1", "=", "24"}], ";", 
   RowBox[{"i2", "=", "47"}], ";", 
   RowBox[{"i3", "=", "21"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"rtp", "=", 
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", "i3", ",", 
        RowBox[{"7", ";;", "9"}]}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"xxx", "=", 
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", "i3", ",", 
        RowBox[{"4", ";;", "6"}]}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Coord (x1,x2): \>\"", " ", ",", 
      RowBox[{"xxx", "[", 
       RowBox[{"[", 
        RowBox[{"1", ";;", "2"}], "]"}], "]"}], ",", 
      "\"\<; (r,\[Theta]): \>\"", ",", " ", 
      RowBox[{"rtp", "[", 
       RowBox[{"[", 
        RowBox[{"1", ";;", "2"}], "]"}], "]"}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"sub", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"r", "\[Rule]", 
        RowBox[{"rtp", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ",", 
       RowBox[{"x1", "\[Rule]", 
        RowBox[{"xxx", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ",", 
       RowBox[{"\[Theta]", "\[Rule]", 
        RowBox[{"rtp", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", 
       RowBox[{"x2", "\[Rule]", 
        RowBox[{"xxx", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", 
       RowBox[{"a", "\[Rule]", "0.9375"}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"gcon", "=", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"resgd", "[", 
        RowBox[{"[", 
         RowBox[{"i1", ",", "i2", ",", "i3", ",", 
          RowBox[{"74", ";;", "89"}]}], "]"}], "]"}], ",", "4"}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"gcov", "=", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"resgd", "[", 
        RowBox[{"[", 
         RowBox[{"i1", ",", "i2", ",", "i3", ",", 
          RowBox[{"90", ";;", "105"}]}], "]"}], "]"}], ",", "4"}], "]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"gdet", "=", 
     RowBox[{"resgd", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", "i3", ",", "106"}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"dxdxp", "=", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"resgd", "[", 
        RowBox[{"[", 
         RowBox[{"i1", ",", "i2", ",", "i3", ",", 
          RowBox[{"111", ";;", "126"}]}], "]"}], "]"}], ",", "4"}], "]"}]}], 
    ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rtp", "=", 
   RowBox[{"resgd2d", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", 
      RowBox[{"7", ";;", "9"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xxx", "=", 
   RowBox[{"resgd2d", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", 
      RowBox[{"4", ";;", "6"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Coord (x1,x2): \>\"", " ", ",", 
    RowBox[{"xxx", "[", 
     RowBox[{"[", 
      RowBox[{"1", ";;", "2"}], "]"}], "]"}], ",", "\"\<; (r,\[Theta]): \>\"",
     ",", " ", 
    RowBox[{"rtp", "[", 
     RowBox[{"[", 
      RowBox[{"1", ";;", "2"}], "]"}], "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sub", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"r", "\[Rule]", 
       RowBox[{"rtp", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ",", 
      RowBox[{"x1", "\[Rule]", 
       RowBox[{"xxx", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ",", 
      RowBox[{"\[Theta]", "\[Rule]", 
       RowBox[{"rtp", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ",", 
      RowBox[{"x2", "\[Rule]", 
       RowBox[{"xxx", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ",", 
      RowBox[{"a", "\[Rule]", "0.9375"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gcon", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"resgd2d", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", 
        RowBox[{"74", ";;", "89"}]}], "]"}], "]"}], ",", "4"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gcov", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"resgd2d", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", 
        RowBox[{"90", ";;", "105"}]}], "]"}], "]"}], ",", "4"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gdet", "=", 
   RowBox[{"resgd2d", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", "106"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dxdxp", "=", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"resgd2d", "[", 
      RowBox[{"[", 
       RowBox[{"i1", ",", "i2", ",", 
        RowBox[{"111", ";;", "126"}]}], "]"}], "]"}], ",", "4"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fie", "=", 
   RowBox[{"res2m", "[", 
    RowBox[{"[", 
     RowBox[{"i1", ",", "i2", ",", "i3"}], "]"}], "]"}]}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\[Rho]=\>\"", ",", " ", 
    RowBox[{"\[Rho]", "=", 
     RowBox[{"fie", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], ",", "\"\<; U=\>\"", ",", 
    RowBox[{"U", "=", 
     RowBox[{"fie", "[", 
      RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SuperscriptBox[\(u\), \(\[Mu]\)]\)=\>\"", ",", 
    RowBox[{"uup", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"fie", "[", 
         RowBox[{"[", "5", "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{"fie", "[", 
          RowBox[{"[", "5", "]"}], "]"}], 
         RowBox[{"fie", "[", 
          RowBox[{"[", 
           RowBox[{"6", ";;", "8"}], "]"}], "]"}]}]}], "}"}], "]"}]}]}], 
   "]"}], ";", 
  RowBox[{"ulo", "=", 
   RowBox[{"gcov", ".", "uup"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<MKS \!\(\*SuperscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
    RowBox[{"bi", "=", 
     RowBox[{"fie", "[", 
      RowBox[{"[", 
       RowBox[{"9", ";;", "11"}], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<\!\(\*SuperscriptBox[\(b\), \(\[Mu]\)]\)=\>\"", ",", 
    RowBox[{"bup", "=", 
     RowBox[{"Flatten", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"bi", ".", 
         RowBox[{"ulo", "[", 
          RowBox[{"[", 
           RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], ",", 
        FractionBox[
         RowBox[{"bi", "+", 
          RowBox[{
           RowBox[{"bi", ".", 
            RowBox[{"ulo", "[", 
             RowBox[{"[", 
              RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], 
           RowBox[{"uup", "[", 
            RowBox[{"[", 
             RowBox[{"2", ";;", "4"}], "]"}], "]"}]}]}], 
         RowBox[{"uup", "[", 
          RowBox[{"[", "1", "]"}], "]"}]]}], "}"}], "]"}]}], ",", 
    "\"\<; \!\(\*SubscriptBox[SuperscriptBox[\(b\), \(\[Mu]\)], \
\(KS\)]\)=\>\"", ",", 
    RowBox[{"bupKS", "=", 
     RowBox[{"dxdxp", ".", "bup"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<In KS coordinates: \!\(\*SubscriptBox[SuperscriptBox[\(u\), \
\(\[Mu]\)], \(KS\)]\)=\>\"", ",", " ", 
    RowBox[{"uupKS", "=", 
     RowBox[{"dxdxp", ".", "uup"}]}], ",", 
    "\"\<;  \!\(\*SubscriptBox[\(u\), \(\[Mu]KS\)]\)=\>\"", ",", 
    RowBox[{"uloKS", "=", 
     RowBox[{
      RowBox[{"invgmnKS", ".", "uupKS"}], "/.", "sub"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<In BL coordinates: \!\(\*SubscriptBox[SuperscriptBox[\(u\), \
\(\[Mu]\)], \(BL\)]\)=\>\"", ",", " ", 
    RowBox[{"uupBL", "=", 
     RowBox[{
      RowBox[{"invAnumu", ".", "uupKS"}], "/.", "sub"}]}], ",", 
    "\"\<;  \!\(\*SubscriptBox[\(u\), \(\[Mu]BL\)]\)=\>\"", ",", 
    RowBox[{"uloBL", "=", 
     RowBox[{
      RowBox[{"invgmn", ".", "uupBL"}], "/.", "sub"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Back to KS coordinates: \!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\
\[Mu]\)], \(KS\)]\)=\>\"", ",", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"Transpose", "[", "Anumu", "]"}], ".", "uupBL"}], "/.", 
     "sub"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 1: \!\(\*SuperscriptBox[\(g\), \
\(\[Mu]\[Nu]\)]\)\!\(\*SubscriptBox[\(g\), \
\(\[Nu]\[Sigma]\)]\)==\!\(\*SubscriptBox[SuperscriptBox[\(\[Delta]\), \(\[Mu]\
\)], \(\[Sigma]\)]\); should be identity matrix:   \>\"", ",", 
   RowBox[{"Chop", "[", 
    RowBox[{
     RowBox[{"gcov", ".", "gcon"}], "//", "MatrixForm"}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 2: gdet==\!\(\*SqrtBox[\(-Det[gcov]\)]\);  should be unity:      \
\>\"", ",", 
   FractionBox[
    SqrtBox[
     RowBox[{"-", 
      RowBox[{"Det", "[", "gcov", "]"}]}]], "gdet"]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 3: normalization of velocity in MKS: \!\(\*SuperscriptBox[\(u\), \
\(\[Mu]\)]\)\!\(\*SubscriptBox[\(u\), \(\[Mu]\)]\)=-1:  \>\"", ",", 
   RowBox[{"ulo", ".", "uup"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Test 4: normalization of velocity in KS: \
\!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\[Mu]\)], \
\(KS\)]\)\!\(\*SubscriptBox[\(u\), SubscriptBox[\(\[Mu]\), \(KS\)]]\)=-1:  \>\
\"", ",", 
   RowBox[{"uupKS", ".", "uloKS"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Test 5: normalization of velocity in BL: \
\!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\[Mu]\)], \
\(BL\)]\)\!\(\*SubscriptBox[\(u\), SubscriptBox[\(\[Mu]\), \(BL\)]]\)=-1:  \>\
\"", ",", 
    RowBox[{"uupBL", ".", "uloBL"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"u", "[", "0", "]"}], ",", 
      RowBox[{"u", "[", "1", "]"}], ",", 
      RowBox[{"u", "[", "2", "]"}], ",", 
      RowBox[{"u", "[", "3", "]"}]}], "}"}], "=", "uupKS"}], "]"}], ";", 
  RowBox[{"Thread", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"uco", "[", "0", "]"}], ",", 
      RowBox[{"uco", "[", "1", "]"}], ",", 
      RowBox[{"uco", "[", "2", "]"}], ",", 
      RowBox[{"uco", "[", "3", "]"}]}], "}"}], "=", "uloKS"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "[", "0", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"u", "[", "0", "]"}], ",", 
     RowBox[{"u", "[", "1", "]"}], ",", 
     RowBox[{"u", "[", "2", "]"}], ",", 
     RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "0", "]"}], "=", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"invgmnKS", ".", 
      RowBox[{"xx", "[", "0", "]"}]}]}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "[", "2", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"uco", "[", "2", "]"}], 
      RowBox[{"u", "[", "0", "]"}]}], ",", 
     RowBox[{
      RowBox[{"uco", "[", "2", "]"}], 
      RowBox[{"u", "[", "1", "]"}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"uco", "[", "2", "]"}], 
       RowBox[{"u", "[", "2", "]"}]}], "+", "1"}], ",", 
     RowBox[{
      RowBox[{"uco", "[", "2", "]"}], 
      RowBox[{"u", "[", "3", "]"}]}]}], "}"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "2", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xx", "[", "2", "]"}]}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xx", "[", "3", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"uco", "[", "3", "]"}], 
       RowBox[{"uco", "[", "0", "]"}]]}], ",", "0", ",", "0", ",", "1"}], 
    "}"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "3", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xx", "[", "3", "]"}]}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"sc", "[", "0", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "0", "]"}], ".", 
      RowBox[{"xxlo", "[", "0", "]"}]}]], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"sc", "[", "3", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "3", "]"}], ".", 
      RowBox[{"xxlo", "[", "3", "]"}]}]], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"sc", "[", "2", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "2", "]"}], ".", 
      RowBox[{"xxlo", "[", "2", "]"}]}]], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"xx", "[", "0", "]"}], "/=", 
    RowBox[{"sc", "[", "0", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "0", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "0", "]"}], "/.", "sub"}]}], ";", 
   RowBox[{
    RowBox[{"xx", "[", "2", "]"}], "/=", 
    RowBox[{"sc", "[", "2", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "2", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "2", "]"}], "/.", "sub"}]}], ";", 
   RowBox[{
    RowBox[{"xx", "[", "3", "]"}], "/=", 
    RowBox[{"sc", "[", "3", "]"}]}], ";", 
   RowBox[{
    RowBox[{"xxlo", "[", "3", "]"}], "/=", 
    RowBox[{
     RowBox[{"sc", "[", "3", "]"}], "/.", "sub"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xpr", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], 
       RowBox[{"uco", "[", "1", "]"}]}], " ", ",", 
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"u", "[", "0", "]"}], 
          RowBox[{"uco", "[", "0", "]"}]}], "+", 
         RowBox[{
          RowBox[{"u", "[", "3", "]"}], 
          RowBox[{"uco", "[", "3", "]"}]}]}], ")"}]}], ",", "0", ",", 
      RowBox[{
       RowBox[{"u", "[", "3", "]"}], 
       RowBox[{"uco", "[", "1", "]"}]}]}], "}"}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xlopr", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"xx", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"xpr", "[", "1", "]"}], "-", 
    RowBox[{
     RowBox[{
      RowBox[{"xlopr", "[", "1", "]"}], ".", 
      RowBox[{"xx", "[", "3", "]"}]}], "*", 
     RowBox[{"xx", "[", "3", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xxlo", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xx", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"sc", "[", "1", "]"}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      RowBox[{"xx", "[", "1", "]"}], ".", 
      RowBox[{"xxlo", "[", "1", "]"}]}]], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"xlopr", "[", "1", "]"}], "=", 
   RowBox[{
    RowBox[{"invgmnKS", ".", 
     RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
  RowBox[{
   RowBox[{"xx", "[", "1", "]"}], "/=", 
   RowBox[{"sc", "[", "1", "]"}]}], ";", 
  RowBox[{
   RowBox[{"xxlo", "[", "1", "]"}], "/=", 
   RowBox[{
    RowBox[{"sc", "[", "1", "]"}], "/.", "sub"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"trxx", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"xxlo", "[", "0", "]"}], ",", 
      RowBox[{"xxlo", "[", "1", "]"}], ",", 
      RowBox[{"xxlo", "[", "2", "]"}], ",", 
      RowBox[{"xxlo", "[", "3", "]"}]}], "}"}]}], ";", 
   RowBox[{"trcoxx", "=", 
    RowBox[{"Transpose", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"xx", "[", "0", "]"}], ",", 
       RowBox[{"xx", "[", "1", "]"}], ",", 
       RowBox[{"xx", "[", "2", "]"}], ",", 
       RowBox[{"xx", "[", "3", "]"}]}], "}"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", "tests", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Test 6: \!\(\*SubscriptBox[\(u\), \(i\)]\)=\>\"", ",", 
    RowBox[{"trxx", ".", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], ",", 
       RowBox[{"u", "[", "1", "]"}], ",", 
       RowBox[{"u", "[", "2", "]"}], ",", 
       RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ",", 
    "\"\<;  should be {1,0,0,0}\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Test 7: co-moving \!\(\*SubscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
    RowBox[{"coB", "=", 
     RowBox[{
      RowBox[{"trxx", ".", "bupKS"}], "/.", "sub"}]}], ",", 
    "\"\<;  0-th component should be 0\>\""}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{
   "\"\<Back to KS frame: \!\(\*SubscriptBox[SuperscriptBox[\(b\), \
\(\[Mu]\)], \(KS\)]\)=\>\"", ",", 
    RowBox[{"trcoxx", ".", "coB"}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5454000162374997`*^9, 3.545400016674525*^9}, {
   3.5454021726668406`*^9, 3.5454021745119457`*^9}, {3.5454023760944757`*^9, 
   3.545402376496499*^9}, {3.545402495858326*^9, 3.5454025074229875`*^9}, 
   3.5454025825032816`*^9, {3.5454028874277225`*^9, 3.5454029476221657`*^9}, {
   3.545403011124798*^9, 3.545403016154085*^9}, {3.5454030531872034`*^9, 
   3.545403069655145*^9}, {3.5454031640715456`*^9, 3.545403172064003*^9}, {
   3.545403514974616*^9, 3.5454035544588747`*^9}, {3.5454036313522725`*^9, 
   3.5454036387846975`*^9}, {3.5454052181910343`*^9, 
   3.5454052978475904`*^9}, {3.54540581744831*^9, 3.54540581779533*^9}, {
   3.545408091542381*^9, 3.5454080920914125`*^9}, {3.546871327069433*^9, 
   3.5468713272944465`*^9}, {3.5468726464658985`*^9, 
   3.5468726465539036`*^9}, {3.5473040581236486`*^9, 
   3.5473040807089405`*^9}, {3.5473043892395873`*^9, 3.547304389324592*^9}, {
   3.547481920088093*^9, 3.5474819328308215`*^9}, {3.5474832134720697`*^9, 
   3.547483213591077*^9}, 3.547483332494878*^9, 3.550983343034961*^9, {
   3.5509842956194344`*^9, 3.5509842961810355`*^9}, {3.5519849897691307`*^9, 
   3.551985020398883*^9}, {3.5520158429974165`*^9, 3.552015863940614*^9}, {
   3.556021550055913*^9, 3.556021615787673*^9}, {3.557783907726701*^9, 
   3.5577839146710978`*^9}, {3.558953573988731*^9, 3.5589536396024837`*^9}}],

Cell[BoxData[{"uupKS", "\[IndentingNewLine]", "uloKS", "\[IndentingNewLine]", 
 RowBox[{"invgmnKS", ".", 
  RowBox[{"{", 
   RowBox[{"1", ",", "0", ",", "0", ",", "0"}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"dxdxp", ".", 
  RowBox[{"{", 
   RowBox[{"1", ",", "0", ",", "0", ",", "0"}], 
   "}"}]}], "\[IndentingNewLine]", "invgmnKS"}], "Input",
 CellChangeTimes->{{3.559066760250828*^9, 3.5590667802719727`*^9}, {
  3.559066847231803*^9, 3.559066854908242*^9}, {3.559067203094157*^9, 
  3.559067203334171*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"rtab11", "=", 
    RowBox[{"resgd", "[", 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"1", ";;", "ncut"}], ",", "1", ",", "1", ",", "7"}], "]"}], 
     "]"}]}], ";", 
   RowBox[{"rcut", "=", 
    RowBox[{"rtab11", "[", 
     RowBox[{"[", 
      RowBox[{"-", "1"}], "]"}], "]"}]}]}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"rtab11", "=", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{
       "Import", "[", "\"\<E:\\\\GRMHD\\\\a05\\\\Tsmap05.dat\>\"", "]"}], 
       "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", 
        RowBox[{"1", ";;", "ncut"}]}], "]"}], "]"}]}], ";", 
    RowBox[{"rcut", "=", 
     RowBox[{"rtab11", "[", 
      RowBox[{"[", 
       RowBox[{"-", "1"}], "]"}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rrmax", "=", "340000."}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rtab22", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"rcut", "*", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"rrmax", "/", "rcut"}], ")"}], 
       FractionBox[
        RowBox[{"k", "-", "ncut", "+", "1"}], 
        RowBox[{"ndd", "-", "ncut"}]]]}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "ncut", ",", 
       RowBox[{"ndd", "-", "1"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rtab", "=", 
    RowBox[{"Join", "[", 
     RowBox[{"rtab11", ",", "rtab22"}], "]"}]}], ";"}], "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"dxdxptab", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"DiagonalMatrix", "[", 
          RowBox[{"{", 
           RowBox[{"1.", ",", 
            RowBox[{"r", "-", "R0"}], ",", 
            RowBox[{"(", 
             RowBox[{"\[Pi]", 
              RowBox[{"(", 
               RowBox[{"h", "+", 
                RowBox[{"7", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "h"}], ")"}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"2", "x2"}], "-", "1"}], ")"}], "6"]}]}], ")"}]}],
              ")"}], ",", 
            RowBox[{"1.", "\[Pi]"}]}], "}"}], "]"}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"r", "\[Rule]", 
            RowBox[{"rtab", "[", 
             RowBox[{"[", "i1", "]"}], "]"}]}], ",", 
           RowBox[{"x2", "\[Rule]", 
            RowBox[{"x2tab", "[", 
             RowBox[{"[", "i2", "]"}], "]"}]}]}], "}"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"R0", "\[Rule]", "0.3"}], ",", 
          RowBox[{"h", "\[Rule]", "0.65"}]}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i1", ",", 
         RowBox[{"Length", "[", "rtab", "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i2", ",", 
         RowBox[{"Length", "[", "x2tab", "]"}]}], "}"}]}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rcmax", "=", 
   RowBox[{"resgd", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "7"}], "]"}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5560224429269824`*^9, 3.5560224691364813`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"np", "=", "64"}], ";", 
    RowBox[{"h", "=."}], ";", 
    RowBox[{"\[Theta]tab", "=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"h", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", "x2"}], "-", "1"}], ")"}]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "-", "h"}], ")"}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "x2"}], "-", "1"}], ")"}], "7"]}], "+", "1"}], 
         ")"}], 
        FractionBox["\[Pi]", "2"]}], "/.", 
       RowBox[{"x2", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"x2tab", "=", 
          RowBox[{"N", "[", 
           RowBox[{"Range", "[", 
            RowBox[{
             FractionBox["1", 
              RowBox[{"2", "np"}]], ",", 
             RowBox[{"1", "-", 
              FractionBox["1", 
               RowBox[{"2", "np"}]]}], ",", 
             FractionBox["1", "np"]}], "]"}], "]"}]}], ")"}]}]}], "/.", 
      RowBox[{"{", 
       RowBox[{"h", "\[Rule]", "0.65"}], "}"}]}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"coordx11", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"resgd", "[", 
            RowBox[{"[", 
             RowBox[{"num", ",", "All", ",", "1", ",", "7"}], "]"}], "]"}], 
           "]"}], ",", 
          RowBox[{"-", 
           RowBox[{"Cos", "[", 
            RowBox[{"resgd", "[", 
             RowBox[{"[", 
              RowBox[{"num", ",", "All", ",", "1", ",", "8"}], "]"}], "]"}], 
            "]"}]}]}], "}"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"num", ",", "ncut"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"dxdxptab11", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"resgd", "[", 
          RowBox[{"[", 
           RowBox[{"i1", ",", "i2", ",", "1", ",", 
            RowBox[{"111", ";;", "126"}]}], "]"}], "]"}], ",", "4"}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i1", ",", "ncut"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i2", ",", "thdim"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"dxdxptab22", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.", ",", "0.", ",", "0.", ",", "0."}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.", ",", 
           RowBox[{"rtab", "[", 
            RowBox[{"[", 
             RowBox[{"i1", "+", "1"}], "]"}], "]"}], ",", "0.", ",", "0."}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.", ",", "0.", ",", 
           FractionBox["\[Pi]", "2."], ",", "0."}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.", ",", "0.", ",", "0.", ",", 
           RowBox[{"2.", "\[Pi]"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i1", ",", "ncut", ",", 
         RowBox[{"ndd", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i2", ",", "thdim"}], "}"}]}], "]"}]}], ";", "\n", 
    RowBox[{"thtab22", "=", 
     RowBox[{"-", 
      RowBox[{"Cos", "[", 
       RowBox[{"resgd", "[", 
        RowBox[{"[", 
         RowBox[{"ncut", ",", "All", ",", "1", ",", "8"}], "]"}], "]"}], 
       "]"}]}]}], ";"}], "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"coordx11", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"resgd2d", "[", 
            RowBox[{"[", 
             RowBox[{"num", ",", "All", ",", "7"}], "]"}], "]"}], "]"}], ",", 
          RowBox[{"-", 
           RowBox[{"Cos", "[", 
            RowBox[{"resgd2d", "[", 
             RowBox[{"[", 
              RowBox[{"num", ",", "All", ",", "8"}], "]"}], "]"}], "]"}]}]}], 
         "}"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"num", ",", "ncut"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"dxdxptab11", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"resgd2d", "[", 
          RowBox[{"[", 
           RowBox[{"i1", ",", "i2", ",", 
            RowBox[{"111", ";;", "126"}]}], "]"}], "]"}], ",", "4"}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i1", ",", "ncut"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i2", ",", "thdim"}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"dxdxptab22", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.", ",", "0.", ",", "0.", ",", "0."}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.", ",", 
           RowBox[{"rtab", "[", 
            RowBox[{"[", 
             RowBox[{"i1", "+", "1"}], "]"}], "]"}], ",", "0.", ",", "0."}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.", ",", "0.", ",", 
           FractionBox["\[Pi]", "2."], ",", "0."}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0.", ",", "0.", ",", "0.", ",", 
           RowBox[{"2.", "\[Pi]"}]}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i1", ",", "ncut", ",", 
         RowBox[{"ndd", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i2", ",", "thdim"}], "}"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"thtab22", "=", 
     RowBox[{"-", 
      RowBox[{"Cos", "[", 
       RowBox[{"resgd2d", "[", 
        RowBox[{"[", 
         RowBox[{"ncut", ",", "All", ",", "8"}], "]"}], "]"}], "]"}]}]}], 
    ";"}], "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{"coordx22", "=", 
     RowBox[{"Outer", "[", 
      RowBox[{"List", ",", 
       RowBox[{"Log", "[", "rtab22", "]"}], ",", "thtab22"}], "]"}]}], ";"}], 
   "\n", 
   RowBox[{"Dimensions", "[", 
    RowBox[{"coordfin", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"coordx11", ",", "coordx22"}], "]"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Dimensions", "[", 
    RowBox[{"dxdxpfin", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"dxdxptab11", ",", "dxdxptab22"}], "]"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fif", "=", 
     RowBox[{"OpenWrite", "[", 
      RowBox[{
       RowBox[{
       "\"\<E:\\\\GRMHD\\\\Jon\\\\\>\"", "<>", "atab", "<>", 
        "\"\<\\\\dxdxp.dat\>\""}], ",", 
       RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"BinaryWrite", "[", 
    RowBox[{"fif", ",", 
     RowBox[{"Flatten", "[", "coordfin", "]"}], ",", "\"\<Real32\>\""}], 
    "]"}], "\[IndentingNewLine]", 
   RowBox[{"BinaryWrite", "[", 
    RowBox[{"fif", ",", 
     RowBox[{"Flatten", "[", "dxdxpfin", "]"}], ",", "\"\<Real32\>\""}], 
    "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Close", "[", "fif", "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"fullcoord", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Log", "[", 
            RowBox[{"resgd", "[", 
             RowBox[{"[", 
              RowBox[{"num", ",", "All", ",", "8"}], "]"}], "]"}], "]"}], ",", 
           RowBox[{"-", 
            RowBox[{"Cos", "[", 
             RowBox[{"resgd", "[", 
              RowBox[{"[", 
               RowBox[{"num", ",", "All", ",", "9"}], "]"}], "]"}], "]"}]}]}],
           "}"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"num", ",", "256"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"fullcoord", "=", 
      RowBox[{"Join", "[", 
       RowBox[{"fullcoord", ",", 
        RowBox[{"Abs", "[", 
         RowBox[{"Reverse", "[", 
          RowBox[{"fullcoord", ",", "2"}], "]"}], "]"}], ",", "2"}], "]"}]}], 
     ";"}], "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.5472945808155775`*^9, 3.5472946145585074`*^9}, {
   3.547294768023285*^9, 3.5472948032623005`*^9}, 3.5473953904776516`*^9, {
   3.5473957199844985`*^9, 3.5473957607268286`*^9}, 3.5473958009761305`*^9, {
   3.547395890562255*^9, 3.547395900555826*^9}, {3.5473959984834275`*^9, 
   3.547396012973256*^9}, {3.550989334627646*^9, 3.5509893802973127`*^9}, {
   3.5560223606612773`*^9, 3.556022439297775*^9}, {3.5560224814981885`*^9, 
   3.556022489817664*^9}, {3.5560225225775385`*^9, 3.55602253117603*^9}, {
   3.556022570526281*^9, 3.55602257191336*^9}, {3.5560226071303744`*^9, 
   3.5560226422103806`*^9}, {3.556022705240986*^9, 3.5560227053249907`*^9}, {
   3.558953752043915*^9, 3.5589537913421626`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tn", "=", "64"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"lpl22", "=", 
    RowBox[{"ListLogLogPlot", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab11", ",", 
        RowBox[{"dxdxptab11", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "tn", ",", "2", ",", "2"}], "]"}], "]"}]}], 
       "}"}], "]"}], "]"}]}], ",", 
   RowBox[{"ListLogPlot", "[", 
    RowBox[{"dxdxptab11", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "9", ",", "3", ",", "3"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"ListLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"dxdxptab11", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "tn", ",", "3", ",", "2"}], "]"}], "]"}], "]"}], 
    "]"}], ",", 
   RowBox[{"ListLogPlot", "[", 
    RowBox[{"dxdxptab11", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "tn", ",", "4", ",", "4"}], "]"}], "]"}], "]"}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl22", "=", 
   RowBox[{"LogLogPlot", "[", 
    RowBox[{"r", ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"rtab11", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{"rtab11", "[", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"lpl22", ",", "pl22"}], "]"}]}], "Input",
 CellChangeTimes->{{3.547306806114515*^9, 3.547306951926855*^9}, {
  3.547307018612669*^9, 3.5473070240999827`*^9}, {3.5473070998133135`*^9, 
  3.547307219210142*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"dxdxptab11", "[", 
   RowBox[{"[", 
    RowBox[{"ncut", ",", "50"}], "]"}], "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.5473070749838934`*^9, 3.547307077488036*^9}, {
  3.5553366230718164`*^9, 3.555336635950553*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ncut", "=", "143"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{"dxdxptab11", "[", 
       RowBox[{"[", 
        RowBox[{"ncut", ",", "All", ",", "3", ",", "3"}], "]"}], "]"}], "]"}],
      ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"dxdxptab11", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"ncut", "-", "10"}], ",", "All", ",", "3", ",", "3"}], 
         "]"}], "]"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}]}], "}"}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"th", "-", "th"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"GraphicsRow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{"dxdxptab11", "[", 
       RowBox[{"[", 
        RowBox[{"ncut", ",", "All", ",", "3", ",", "2"}], "]"}], "]"}], "]"}],
      ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"dxdxptab11", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"ncut", "-", "10"}], ",", "All", ",", "3", ",", "2"}], "]"}],
        "]"}], "]"}]}], "}"}], "]"}], 
  RowBox[{"(*", 
   RowBox[{"r", "-", "th"}], "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.547307317726777*^9, 3.5473073258712435`*^9}, {
   3.547307363135374*^9, 3.5473073719098763`*^9}, {3.5553366842123137`*^9, 
   3.5553366901756544`*^9}, {3.5553367517131743`*^9, 
   3.5553367983578424`*^9}, {3.5553368449555073`*^9, 
   3.5553368507738404`*^9}, {3.555336922396937*^9, 3.5553369242060404`*^9}, {
   3.5553369647013564`*^9, 3.5553370332362766`*^9}, 3.5553372305785637`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"0", ",", "0"}], ")"}], " ", "\[Rule]", " ", "1"}], ";", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", ",", "1"}], ")"}], " ", "\[Rule]", " ", "r"}], ";", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"2", ",", "2"}], ")"}], " ", "\[Rule]", " ", 
     RowBox[{"\[Pi]", "/", "2"}]}], ";", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"3", ",", "3"}], ")"}], " ", "\[Rule]", " ", 
     RowBox[{"2", "\[Pi]"}]}], ";", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"3", ",", "2"}], ")"}], " ", "\[Rule]", " ", "0"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1.", ",", "0.", ",", "0.", ",", "0."}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.", ",", "r", ",", "0.", ",", "0."}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.", ",", "0.", ",", 
      FractionBox["\[Pi]", "2."], ",", "0."}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.", ",", "0.", ",", "0.", ",", 
      RowBox[{"2.", "\[Pi]"}]}], "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.547307048512379*^9, 3.54730708804064*^9}, {
  3.547307127464895*^9, 3.547307128463952*^9}, {3.5473072327269154`*^9, 
  3.547307292712346*^9}, {3.5473073390079947`*^9, 3.5473074308502474`*^9}}],

Cell[BoxData[{
 RowBox[{"11", "*", "272", " ", "128", " ", "256", "*", 
  "4"}], "\[IndentingNewLine]", 
 RowBox[{"382976", " ", 
  "1024"}], "\[IndentingNewLine]", "8984199561", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NDIM", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"272", " ", "128", " ", "256", "*", "8", 
  RowBox[{"(", 
   RowBox[{"3", "+", "3", "+", "3", "+", 
    SuperscriptBox["NDIM", "3"], "+", 
    SuperscriptBox["NDIM", "2"], "+", 
    SuperscriptBox["NDIM", "2"], "+", "1", "+", "NDIM", "+", 
    SuperscriptBox["NDIM", "2"]}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{"3", "+", "3", "+", "3", "+", 
  SuperscriptBox["NDIM", "3"], "+", 
  SuperscriptBox["NDIM", "2"], "+", 
  SuperscriptBox["NDIM", "2"], "+", "1", "+", "NDIM", "+", 
  SuperscriptBox["NDIM", "2"]}]}], "Input",
 CellChangeTimes->{
  3.555331643325991*^9, {3.5553317196283555`*^9, 3.555331726653757*^9}, {
   3.5553334114591227`*^9, 3.555333429317144*^9}, {3.5553335535872517`*^9, 
   3.5553335802567773`*^9}, {3.55533377926116*^9, 3.5553337929499426`*^9}, {
   3.5553350033811755`*^9, 3.5553350037331953`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
testing for zeros in Jon\[CloseCurlyQuote]s simulations\
\>", "Subsubsection",
 CellChangeTimes->{{3.5553303735213623`*^9, 3.5553303963886704`*^9}, {
  3.566959416904355*^9, 3.5669594221771646`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", " ", "=", " ", 
   RowBox[{"NotebookDirectory", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ndd", "=", "650"}], ";", 
  RowBox[{"ncut", "=", "120"}], ";", 
  RowBox[{"NDIM", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dirin", "=", "\"\<E:\\\\GRMHD\\\\Jon\\\\\>\""}], ";", 
  RowBox[{"anum", "=", "0.9375"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", 
    RowBox[{"spstr_", ",", "fnum_"}], "]"}], " ", ":=", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", " ", "=", 
      RowBox[{
      "dirin", "<>", "spstr", "<>", "\"\<\\\\fieldlines\\\\fieldline\>\"", 
       " ", "<>", " ", 
       RowBox[{"StringJoin", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", "#", "]"}], " ", "&"}], " ", "/@", " ", 
         RowBox[{"PadLeft", "[", 
          RowBox[{
           RowBox[{"IntegerDigits", "[", "fnum", "]"}], ",", " ", "4"}], 
          "]"}]}], "]"}], " ", "<>", " ", "\"\<.bin\>\""}]}], ";", "\n", 
     "   ", 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "272", " ", "128", " ", "256", "*", "4"}]}], ";", 
     "\n", "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"str", "=", 
      RowBox[{"StringToStream", "[", "strrr", "]"}]}], ";", 
     RowBox[{"param", "=", 
      RowBox[{"ReadList", "[", 
       RowBox[{"str", ",", "Number"}], "]"}]}], ";", 
     RowBox[{"Close", "[", "str", "]"}], ";", "\n", "   ", 
     RowBox[{"res2m", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"llist", " ", "=", " ", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"BinaryReadList", "[", 
                RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                 RowBox[{"xs", "/", "4"}]}], "]"}], ",", " ", "11"}], "]"}], 
             ",", " ", "272"}], "]"}], ",", " ", "128"}], "]"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], "}"}]}], 
       "]"}]}], ";", "\n", "   ", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"atab", "=", "\"\<thickdisk7\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "res2m", "]"}]}], "Input",
 CellChangeTimes->{{3.48199863871*^9, 3.4819986488344*^9}, {
   3.4821459308244*^9, 3.4821459311208*^9}, 3.4834575605388002`*^9, {
   3.4834576012392*^9, 3.4834576140312*^9}, {3.4834576807524*^9, 
   3.4834576815011997`*^9}, {3.4834577493612003`*^9, 3.4834577829636*^9}, {
   3.4834578209184*^9, 3.4834578352236*^9}, {3.5057603089278*^9, 
   3.5057603097546*^9}, {3.541203794809623*^9, 3.541203794981223*^9}, {
   3.5412043045883183`*^9, 3.5412043088003254`*^9}, {3.541204501242264*^9, 
   3.541204515750289*^9}, {3.5414588063706646`*^9, 3.541458813749087*^9}, {
   3.541458983765811*^9, 3.541459124153841*^9}, {3.5414592320200105`*^9, 
   3.5414592345781565`*^9}, {3.5414593414802713`*^9, 
   3.5414593601943417`*^9}, {3.541459447008307*^9, 3.54145948395142*^9}, {
   3.5414595323981915`*^9, 3.5414595580486584`*^9}, {3.541459622176326*^9, 
   3.541459622384338*^9}, {3.5414622654635134`*^9, 3.5414622660455465`*^9}, {
   3.5414623043457375`*^9, 3.541462304989774*^9}, {3.541462385373372*^9, 
   3.541462386052411*^9}, {3.5414624305879583`*^9, 3.5414624889242945`*^9}, {
   3.541462537932098*^9, 3.541462545298519*^9}, 3.545409232910663*^9, {
   3.5454092720989046`*^9, 3.5454092728439474`*^9}, {3.5472560730601273`*^9, 
   3.5472560743392005`*^9}, {3.547294353431572*^9, 3.5472945377361135`*^9}, {
   3.547294775668722*^9, 3.547294776171751*^9}, {3.5473042542098637`*^9, 
   3.547304254696892*^9}, {3.547306391910824*^9, 3.547306489613412*^9}, {
   3.5474815714911537`*^9, 3.547481571546157*^9}, {3.547481738490706*^9, 
   3.5474817391217422`*^9}, {3.5474831480233264`*^9, 3.547483148102331*^9}, {
   3.547483180727197*^9, 3.5474831966611085`*^9}, {3.547483265239031*^9, 
   3.547483270429328*^9}, {3.5474833051833153`*^9, 3.5474833174870195`*^9}, {
   3.547483360174461*^9, 3.547483367973907*^9}, {3.5509830780684958`*^9, 
   3.550983139501404*^9}, {3.550983213024333*^9, 3.5509832275791583`*^9}, {
   3.550983262164419*^9, 3.5509832622112193`*^9}, {3.550983454840358*^9, 
   3.550983520407273*^9}, {3.550983558159339*^9, 3.550983584180185*^9}, {
   3.5509892690699368`*^9, 3.5509892702867393`*^9}, {3.551984022106784*^9, 
   3.551984034410487*^9}, {3.5519848768126698`*^9, 3.551984877178691*^9}, {
   3.551984946135635*^9, 3.5519849468806777`*^9}, {3.5520152453262315`*^9, 
   3.552015245423237*^9}, {3.552015752103217*^9, 3.552015764120905*^9}, {
   3.552015816751915*^9, 3.552015817034931*^9}, {3.552015919532794*^9, 
   3.5520159394539332`*^9}, {3.555330639087552*^9, 3.5553306893434267`*^9}, {
   3.555331083042945*^9, 3.5553312104602327`*^9}, {3.555331279890204*^9, 
   3.555331310157935*^9}, {3.5553313474530687`*^9, 3.555331360302803*^9}, {
   3.5553315883518467`*^9, 3.5553316129072514`*^9}, {3.5553318323728037`*^9, 
   3.5553318328688326`*^9}, {3.5553320868213577`*^9, 
   3.5553320935707436`*^9}, {3.5553338103389373`*^9, 
   3.5553338177593617`*^9}, {3.55533395812339*^9, 3.555333966842889*^9}, {
   3.5553342131089745`*^9, 3.5553342298939342`*^9}, {3.5553342896843543`*^9, 
   3.555334303208128*^9}, {3.5553343658997135`*^9, 3.555334410294253*^9}, {
   3.555334517746399*^9, 3.5553345518263483`*^9}, {3.5553347214450493`*^9, 
   3.555334723306156*^9}, {3.5553347975003996`*^9, 3.555334798799474*^9}, {
   3.555334883553322*^9, 3.555334884325366*^9}, {3.555335011605646*^9, 
   3.555335042397407*^9}, 3.5553352514763656`*^9, {3.555336466198844*^9, 
   3.5553364663468523`*^9}, 3.5560223428512583`*^9, 3.5560292045947275`*^9, {
   3.558953002857064*^9, 3.5589530326087656`*^9}, {3.558953140646945*^9, 
   3.558953181559285*^9}, {3.5589532335192566`*^9, 3.558953292772646*^9}, {
   3.5589533325199194`*^9, 3.5589533745173216`*^9}, {3.5669593879819045`*^9, 
   3.5669594315683813`*^9}, {3.5669595097245183`*^9, 
   3.5669595103173194`*^9}, {3.566960728338851*^9, 3.5669607287132516`*^9}, {
   3.5669627862324886`*^9, 3.5669627990401115`*^9}, {3.5673543495236053`*^9, 
   3.567354350099638*^9}, 3.5673544529225197`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"272", ",", "128", ",", "256", ",", "11"}], "}"}]], "Output",
 CellChangeTimes->{
  3.566959515465328*^9, 3.5673532355196095`*^9, {3.5673544373306274`*^9, 
   3.567354454877631*^9}, 3.567355459818956*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"arr", "=", 
   RowBox[{"{", 
    RowBox[{
    "3786", ",", "3790", ",", "3791", ",", "3888", ",", "3891", ",", "3892", 
     ",", "3893", ",", "3894", ",", "3896", ",", "5000", ",", "5001", ",", 
     "5002"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ftest", "[", "fnum_", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"read11", "[", 
     RowBox[{"atab", ",", "fnum"}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"\"\<fnum=\>\"", ",", "fnum"}], "]"}], ";", 
    RowBox[{"Print", "[", 
     RowBox[{"Union", "[", 
      RowBox[{
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"res2m", "[", 
          RowBox[{"[", "50", "]"}], "]"}], ",", "0."}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"Union", "[", 
      RowBox[{
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "All", ",", "All", ",", "1"}], "]"}], "]"}], ",",
          "0."}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}], "]"}], ";"}], 
   ")"}]}]}], "Input",
 CellChangeTimes->{{3.5669607411776733`*^9, 3.566960742612876*^9}, {
   3.566960964299266*^9, 3.566960964673667*^9}, {3.5669612663937964`*^9, 
   3.5669612683126*^9}, {3.566961567670249*^9, 3.566961594096695*^9}, {
   3.5669625298312407`*^9, 3.566962604486971*^9}, 3.566962656705062*^9, {
   3.566962694301527*^9, 3.5669627266091843`*^9}, {3.5673543392080154`*^9, 
   3.5673543449443436`*^9}, {3.5673544650382123`*^9, 3.567354465630246*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ftest", "[", "#", "]"}], "&"}], "/@", "arr"}]], "Input",
 CellChangeTimes->{{3.566962606764575*^9, 3.566962613644187*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"fnum=\"\>", "\[InvisibleSpace]", "3786"}],
  SequenceForm["fnum=", 3786],
  Editable->False]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673554852668467`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"248", ",", "249", ",", "253", ",", "254"}], "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673554853343477`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"248", ",", "249", ",", "253", ",", "254"}], "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673554853593483`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"fnum=\"\>", "\[InvisibleSpace]", "3790"}],
  SequenceForm["fnum=", 3790],
  Editable->False]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.56735548937191*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673554894444113`*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673554894544115`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"fnum=\"\>", "\[InvisibleSpace]", "3791"}],
  SequenceForm["fnum=", 3791],
  Editable->False]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673554934819727`*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.567355493559474*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673554935869746`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"fnum=\"\>", "\[InvisibleSpace]", "3888"}],
  SequenceForm["fnum=", 3888],
  Editable->False]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.567355497702038*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.567355497774539*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.567355497799539*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"fnum=\"\>", "\[InvisibleSpace]", "3891"}],
  SequenceForm["fnum=", 3891],
  Editable->False]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673555017896004`*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673555018596015`*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.567355501877102*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"fnum=\"\>", "\[InvisibleSpace]", "3892"}],
  SequenceForm["fnum=", 3892],
  Editable->False]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673555060421658`*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673555060996666`*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673555061346674`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"fnum=\"\>", "\[InvisibleSpace]", "3893"}],
  SequenceForm["fnum=", 3893],
  Editable->False]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673555102522306`*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673555103222313`*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.567355510347232*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"fnum=\"\>", "\[InvisibleSpace]", "3894"}],
  SequenceForm["fnum=", 3894],
  Editable->False]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.567355514424795*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673555144897957`*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.567355514509796*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"fnum=\"\>", "\[InvisibleSpace]", "3896"}],
  SequenceForm["fnum=", 3896],
  Editable->False]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673555185148573`*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673555185823584`*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.567355518609859*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"fnum=\"\>", "\[InvisibleSpace]", "5000"}],
  SequenceForm["fnum=", 5000],
  Editable->False]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673555227524223`*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.567355522822424*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.567355522839924*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"fnum=\"\>", "\[InvisibleSpace]", "5001"}],
  SequenceForm["fnum=", 5001],
  Editable->False]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.567355526867486*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.567355526927487*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673555269399867`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"fnum=\"\>", "\[InvisibleSpace]", "5002"}],
  SequenceForm["fnum=", 5002],
  Editable->False]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673555309825487`*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.56735553105005*^9}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Print",
 CellChangeTimes->{3.5669626185269957`*^9, 3.5669626656750774`*^9, 
  3.566965268737962*^9, 3.567353252772374*^9, 3.5673544452410803`*^9, 
  3.5673555310575504`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Null", ",", "Null", ",", "Null", ",", "Null", ",", "Null", ",", "Null", 
   ",", "Null", ",", "Null", ",", "Null", ",", "Null", ",", "Null", ",", 
   "Null"}], "}"}]], "Output",
 CellChangeTimes->{3.5669626274238105`*^9, 3.5669626742238927`*^9, 
  3.566965316238043*^9, 3.5673532630975327`*^9, 3.567354445299083*^9, 
  3.56735553106505*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ftest", "[", "3893", "]"}]], "Input",
 CellChangeTimes->{{3.5669653802137556`*^9, 3.5669653820389585`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"fnum=\"\>", "\[InvisibleSpace]", "3893"}],
  SequenceForm["fnum=", 3893],
  Editable->False]], "Print",
 CellChangeTimes->{3.5669653865629663`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "106", ",", "107", ",", "108", ",", "109", ",", "110", ",", "111", ",", 
   "112", ",", "113", ",", "114", ",", "115", ",", "116", ",", "117", ",", 
   "118", ",", "119", ",", "120", ",", "121", ",", "122", ",", "123", ",", 
   "124", ",", "125", ",", "126", ",", "127", ",", "128", ",", "129", ",", 
   "130", ",", "131", ",", "132", ",", "133", ",", "134", ",", "135", ",", 
   "136", ",", "137"}], "}"}]], "Print",
 CellChangeTimes->{3.566965386640967*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "106", ",", "107", ",", "108", ",", "109", ",", "110", ",", "111", ",", 
   "112", ",", "113", ",", "114", ",", "115", ",", "116", ",", "117", ",", 
   "118", ",", "119", ",", "120", ",", "121", ",", "122", ",", "123", ",", 
   "124", ",", "125", ",", "126", ",", "127", ",", "128", ",", "129", ",", 
   "130", ",", "131", ",", "132", ",", "133", ",", "134", ",", "135", ",", 
   "136", ",", "137"}], "}"}]], "Print",
 CellChangeTimes->{3.566965386672167*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Length", "[", 
  RowBox[{"p1", "=", 
   RowBox[{"Position", "[", 
    RowBox[{
     RowBox[{"res2m", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "All", ",", "All", ",", "1"}], "]"}], "]"}], 
     ",", "0."}], "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "[", 
  RowBox[{"p2", "=", 
   RowBox[{"Position", "[", 
    RowBox[{
     RowBox[{"res2m", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"-", "10"}], ",", "All", ",", "All", ",", "1"}], "]"}], "]"}],
      ",", "0."}], "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "[", 
  RowBox[{"p3", "=", 
   RowBox[{"Position", "[", 
    RowBox[{
     RowBox[{"res2m", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "All", ",", "All", ",", "1"}], "]"}], "]"}], ",", 
     "0."}], "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "[", 
  RowBox[{"p4", "=", 
   RowBox[{"Position", "[", 
    RowBox[{
     RowBox[{"res2m", "[", 
      RowBox[{"[", 
       RowBox[{"130", ",", "All", ",", "All", ",", "1"}], "]"}], "]"}], ",", 
     "0."}], "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.566965473589517*^9, 3.566965481919932*^9}, {
  3.566965512246385*^9, 3.566965556129262*^9}, {3.566965618700972*^9, 
  3.566965639121408*^9}, {3.5669658193239202`*^9, 3.5669658263907323`*^9}}],

Cell[BoxData["2301"], "Output",
 CellChangeTimes->{
  3.5669653949401813`*^9, {3.5669654742291183`*^9, 3.566965482341132*^9}, {
   3.5669655155379906`*^9, 3.5669655565504627`*^9}, {3.566965620354575*^9, 
   3.5669656394022083`*^9}, 3.5669658268743334`*^9}],

Cell[BoxData["2299"], "Output",
 CellChangeTimes->{
  3.5669653949401813`*^9, {3.5669654742291183`*^9, 3.566965482341132*^9}, {
   3.5669655155379906`*^9, 3.5669655565504627`*^9}, {3.566965620354575*^9, 
   3.5669656394022083`*^9}, 3.566965826889933*^9}],

Cell[BoxData["2300"], "Output",
 CellChangeTimes->{
  3.5669653949401813`*^9, {3.5669654742291183`*^9, 3.566965482341132*^9}, {
   3.5669655155379906`*^9, 3.5669655565504627`*^9}, {3.566965620354575*^9, 
   3.5669656394022083`*^9}, 3.566965826889933*^9}],

Cell[BoxData["2301"], "Output",
 CellChangeTimes->{
  3.5669653949401813`*^9, {3.5669654742291183`*^9, 3.566965482341132*^9}, {
   3.5669655155379906`*^9, 3.5669655565504627`*^9}, {3.566965620354575*^9, 
   3.5669656394022083`*^9}, 3.566965826921133*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["p1"], "Input",
 CellChangeTimes->{{3.566965659760244*^9, 3.5669656598694444`*^9}}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   PanelBox[GridBox[{
      {
       StyleBox[
        StyleBox[
         DynamicBox[ToBoxes[
           FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
           StandardForm],
          ImageSizeCache->{379., {3., 11.}}],
         StripOnInput->False,
         DynamicUpdating->True], "Panel",
        StripOnInput->False,
        Background->None]},
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "109"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "110"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "113"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "114"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "118"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "123"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "124"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "126"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "127"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "128"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "129"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "132"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "133"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "134"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "135"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "136"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "137"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "109"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "110"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "113"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "114"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "118"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "123"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "124"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "126"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "127"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "128"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "129"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "132"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "133"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "134"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "135"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "136"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "137"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "109"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "110"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "113"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "114"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "117"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "118"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "123"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "124"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "126"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "127"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "128"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "129"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "132"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "133"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "134"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "135"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "136"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "137"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4", ",", "109"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4", ",", "110"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4", ",", "113"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4", ",", "114"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4", ",", "117"}], "}"}], ",", 
           RowBox[{"\[LeftSkeleton]", "2187", "\[RightSkeleton]"}], ",", 
           RowBox[{"{", 
            RowBox[{"125", ",", "131"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"125", ",", "132"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"125", ",", "133"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"125", ",", "134"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"125", ",", "135"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"125", ",", "136"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "108"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "109"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "112"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "113"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "117"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "122"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "123"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "125"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "126"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "127"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "128"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "131"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "132"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "133"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "134"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "135"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"126", ",", "136"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "108"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "109"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "112"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "113"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "117"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "122"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "123"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "125"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "126"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "127"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "128"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "131"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "132"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "133"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "134"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "135"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"127", ",", "136"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "108"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "109"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "112"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "113"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "117"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "122"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "123"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "125"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "126"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "127"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "128"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "131"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "132"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "133"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "134"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "135"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"128", ",", "136"}], "}"}]}], "}"}],
         Short[#, 10]& ],
        Background->GrayLevel[1],
        BaseStyle->{Deployed -> False},
        Frame->True,
        FrameStyle->GrayLevel[0, 0.2],
        StripOnInput->False]},
      {
       RowBox[{
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
             StandardForm],
            ImageSizeCache->{67., {1., 11.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>OutputSizeLimit`ButtonFunction[
          Identity, 152, 30328085175324601730, 10/2],
         Enabled->True,
         Evaluator->Automatic,
         Method->"Queued"], "\[ThinSpace]", 
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
             StandardForm],
            ImageSizeCache->{75., {1., 11.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>OutputSizeLimit`ButtonFunction[
          Identity, 152, 30328085175324601730, 10 2],
         Enabled->True,
         Evaluator->Automatic,
         Method->"Queued"], "\[ThinSpace]", 
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
             StandardForm],
            ImageSizeCache->{113., {3., 11.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>OutputSizeLimit`ButtonFunction[
          Identity, 152, 30328085175324601730, Infinity],
         Enabled->True,
         Evaluator->Automatic,
         Method->"Queued"], "\[ThinSpace]", 
        ButtonBox[
         StyleBox[
          StyleBox[
           DynamicBox[ToBoxes[
             FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
             StandardForm],
            ImageSizeCache->{98., {1., 11.}}],
           StripOnInput->False,
           DynamicUpdating->True], "Panel",
          StripOnInput->False,
          Background->None],
         Appearance->Automatic,
         ButtonFunction:>FrontEndExecute[{
            FrontEnd`SetOptions[
            FrontEnd`$FrontEnd, 
             FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
            FrontEnd`FrontEndToken["PreferencesDialog"]}],
         Evaluator->None,
         Method->"Preemptive"]}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[1.2]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    DefaultBaseStyle->{},
    FrameMargins->5],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[152]]], "Output",
 CellChangeTimes->{3.566965660321845*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Complement", "[", 
  RowBox[{"p2", ",", "p1"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Complement", "[", 
  RowBox[{"p4", ",", "p1"}], "]"}]}], "Input",
 CellChangeTimes->{{3.566965559998069*^9, 3.566965600074539*^9}, {
  3.5669658365775504`*^9, 3.5669658384339533`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"52", ",", "125"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.566965601166541*^9, 3.5669656401978097`*^9}, 
   3.5669658389019547`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"5", ",", "124"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", "126"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"23", ",", "110"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"24", ",", "136"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"33", ",", "113"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"36", ",", "133"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"47", ",", "117"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"48", ",", "111"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"52", ",", "125"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"66", ",", "129"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"86", ",", "122"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"94", ",", "118"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"99", ",", "113"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"101", ",", "120"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"102", ",", "114"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"103", ",", "127"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"109", ",", "116"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"110", ",", "129"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"113", ",", "130"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"114", ",", "111"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.566965601166541*^9, 3.5669656401978097`*^9}, 
   3.5669658389019547`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Poloidal grid", "Subsection",
 CellChangeTimes->{{3.545407968184325*^9, 3.545407984615265*^9}}],

Cell[CellGroupData[{

Cell["multilinear inverse lookup and interpolation", "Subsubsection",
 CellChangeTimes->{{3.545408529004402*^9, 3.545408537868909*^9}, {
  3.5454135184167805`*^9, 3.54541352366508*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"grid", "=", 
   RowBox[{"resgd", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", 
      RowBox[{"8", ";;", "10"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rt", "=", "5.6"}], ";", 
   RowBox[{"\[Theta]t", "=", "2.3"}], ";", 
   RowBox[{"\[Phi]t", "=", "1.2"}], ";", 
   RowBox[{"rlen", "=", 
    RowBox[{
     RowBox[{"Dimensions", "[", "grid", "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}]}], ";", 
   RowBox[{"thlen", "=", 
    RowBox[{
     RowBox[{"Dimensions", "[", "grid", "]"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}]}], ";", 
   RowBox[{"phlen", "=", 
    RowBox[{
     RowBox[{"Dimensions", "[", "res2m", "]"}], "[", 
     RowBox[{"[", "3", "]"}], "]"}]}], ";", 
   RowBox[{"rmin", "=", 
    RowBox[{"grid", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}]}], ";", 
   RowBox[{"rmax", "=", 
    RowBox[{"grid", "[", 
     RowBox[{"[", 
      RowBox[{"rlen", ",", "1", ",", "1"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "Find", " ", "out", " ", "if", " ", "the", " ", "point", " ", "is", " ", 
     "on", " ", "the", " ", "grid"}], ";"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"radgrid", "=", 
     RowBox[{"grid", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "1", ",", "1"}], "]"}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"for", " ", "tests"}], "*)"}], 
  RowBox[{
   RowBox[{"intercomp", "[", 
    RowBox[{"rt_", ",", "\[Theta]t_", ",", "\[Phi]t_"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"rt", "<", "rmin"}], ")"}], "||", 
        RowBox[{"rt", ">", "rmax"}]}], ",", 
       RowBox[{"Print", "[", "\"\<Outside of radial extent\>\"", "]"}]}], 
      "]"}], ";", "\n", 
     RowBox[{"ra", "=", "1"}], ";", 
     RowBox[{"rb", "=", "rlen"}], ";", "\[IndentingNewLine]", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"rb", "-", "ra"}], ">", "1"}], ",", 
       RowBox[{
        RowBox[{"rx", "=", 
         RowBox[{"Quotient", "[", 
          RowBox[{
           RowBox[{"rb", "+", "ra"}], ",", "2"}], "]"}]}], ";", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"rt", ">", 
           RowBox[{"(", 
            RowBox[{"rfin", "=", 
             RowBox[{"grid", "[", 
              RowBox[{"[", 
               RowBox[{"rx", ",", "1", ",", "1"}], "]"}], "]"}]}], ")"}]}], 
          ",", 
          RowBox[{"ra", "=", "rx"}], ",", 
          RowBox[{"rb", "=", "rx"}]}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"rlo", "=", 
        RowBox[{"grid", "[", 
         RowBox[{"[", 
          RowBox[{"ra", ",", "1", ",", "1"}], "]"}], "]"}]}], ",", 
       RowBox[{"rhi", "=", 
        RowBox[{"grid", "[", 
         RowBox[{"[", 
          RowBox[{"rb", ",", "1", ",", "1"}], "]"}], "]"}]}]}], "}"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"rman", "=", 
      FractionBox[
       RowBox[{"rt", "-", "rlo"}], 
       RowBox[{"rhi", "-", "rlo"}]]}], ";", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"thmin", "=", 
        RowBox[{
         RowBox[{"rman", " ", 
          RowBox[{"grid", "[", 
           RowBox[{"[", 
            RowBox[{"rb", ",", "1", ",", "2"}], "]"}], "]"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", "rman"}], ")"}], 
          RowBox[{"grid", "[", 
           RowBox[{"[", 
            RowBox[{"ra", ",", "1", ",", "2"}], "]"}], "]"}]}]}]}], ",", 
       RowBox[{"thmax", "=", 
        RowBox[{"\[Pi]", "-", "thmin"}]}]}], "}"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"\[Theta]t", "<", "thmin"}], ")"}], "||", 
        RowBox[{"\[Theta]t", ">", "thmax"}]}], ",", 
       RowBox[{"Print", "[", "\"\<Outside of polar extent\>\"", "]"}]}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"tha", "=", "1"}], ";", 
     RowBox[{"thb", "=", "thlen"}], ";", "\[IndentingNewLine]", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"thb", "-", "tha"}], ">", "1"}], ",", 
       RowBox[{
        RowBox[{"thx", "=", 
         RowBox[{"Quotient", "[", 
          RowBox[{
           RowBox[{"thb", "+", "tha"}], ",", "2"}], "]"}]}], ";", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"\[Theta]t", ">", 
           RowBox[{"(", 
            RowBox[{"thfin", "=", 
             RowBox[{
              RowBox[{"rman", " ", 
               RowBox[{"grid", "[", 
                RowBox[{"[", 
                 RowBox[{"rb", ",", "thx", ",", "2"}], "]"}], "]"}]}], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"1", "-", "rman"}], ")"}], 
               RowBox[{"grid", "[", 
                RowBox[{"[", 
                 RowBox[{"ra", ",", "thx", ",", "2"}], "]"}], "]"}]}]}]}], 
            ")"}]}], ",", 
          RowBox[{"tha", "=", "thx"}], ",", 
          RowBox[{"thb", "=", "thx"}]}], "]"}]}]}], "]"}], ";", "\n", 
     RowBox[{"{", 
      RowBox[{"thb", ",", "tha"}], "}"}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"thlo", "=", 
        RowBox[{
         RowBox[{"rman", " ", 
          RowBox[{"grid", "[", 
           RowBox[{"[", 
            RowBox[{"rb", ",", "tha", ",", "2"}], "]"}], "]"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", "rman"}], ")"}], 
          RowBox[{"grid", "[", 
           RowBox[{"[", 
            RowBox[{"ra", ",", "tha", ",", "2"}], "]"}], "]"}]}]}]}], ",", 
       RowBox[{"thhi", "=", 
        RowBox[{
         RowBox[{"rman", " ", 
          RowBox[{"grid", "[", 
           RowBox[{"[", 
            RowBox[{"rb", ",", "thb", ",", "2"}], "]"}], "]"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", "rman"}], ")"}], 
          RowBox[{"grid", "[", 
           RowBox[{"[", 
            RowBox[{"ra", ",", "thb", ",", "2"}], "]"}], "]"}]}]}]}]}], "}"}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"thman", "=", 
      FractionBox[
       RowBox[{"\[Theta]t", "-", "thlo"}], 
       RowBox[{"thhi", "-", "thlo"}]]}], ";", 
     RowBox[{"phx", "=", 
      RowBox[{
       FractionBox["\[Phi]t", 
        RowBox[{"2", "\[Pi]"}]], "thlen"}]}], ";", 
     RowBox[{"pha", "=", 
      RowBox[{"Floor", "[", "phx", "]"}]}], ";", 
     RowBox[{"phb", "=", 
      RowBox[{"pha", "+", "1"}]}], ";", 
     RowBox[{"phman", "=", 
      RowBox[{"phx", "-", "pha"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"\[Rho]", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", "thman"}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"rman", " ", 
           RowBox[{"res2m", "[", 
            RowBox[{"[", 
             RowBox[{"rb", ",", "tha", ",", "5", ",", "1"}], "]"}], "]"}]}], 
          "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "-", "rman"}], ")"}], 
           RowBox[{"res2m", "[", 
            RowBox[{"[", 
             RowBox[{"ra", ",", "tha", ",", "5", ",", "1"}], "]"}], "]"}]}]}],
          ")"}]}], "+", 
       RowBox[{"thman", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"rman", " ", 
           RowBox[{"res2m", "[", 
            RowBox[{"[", 
             RowBox[{"rb", ",", "thb", ",", "5", ",", "1"}], "]"}], "]"}]}], 
          "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "-", "rman"}], ")"}], 
           RowBox[{"res2m", "[", 
            RowBox[{"[", 
             RowBox[{"ra", ",", "thb", ",", "5", ",", "1"}], "]"}], "]"}]}]}],
          ")"}]}]}]}], ";", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"not", " ", "\[Phi]"}], "-", "dependent"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"\[Rho]", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", "phman"}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "-", "thman"}], ")"}], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"rman", " ", 
              RowBox[{"res2m", "[", 
               RowBox[{"[", 
                RowBox[{"rb", ",", "tha", ",", "pha", ",", "1"}], "]"}], 
               "]"}]}], "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"1", "-", "rman"}], ")"}], 
              RowBox[{"res2m", "[", 
               RowBox[{"[", 
                RowBox[{"ra", ",", "tha", ",", "pha", ",", "1"}], "]"}], 
               "]"}]}]}], ")"}]}], "+", 
          RowBox[{"thman", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"rman", " ", 
              RowBox[{"res2m", "[", 
               RowBox[{"[", 
                RowBox[{"rb", ",", "thb", ",", "pha", ",", "1"}], "]"}], 
               "]"}]}], "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"1", "-", "rman"}], ")"}], 
              RowBox[{"res2m", "[", 
               RowBox[{"[", 
                RowBox[{"ra", ",", "thb", ",", "pha", ",", "1"}], "]"}], 
               "]"}]}]}], ")"}]}]}], ")"}]}], "+", 
       RowBox[{"phman", "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "-", "thman"}], ")"}], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"rman", " ", 
              RowBox[{"res2m", "[", 
               RowBox[{"[", 
                RowBox[{"rb", ",", "tha", ",", "phb", ",", "1"}], "]"}], 
               "]"}]}], "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"1", "-", "rman"}], ")"}], 
              RowBox[{"res2m", "[", 
               RowBox[{"[", 
                RowBox[{"ra", ",", "tha", ",", "phb", ",", "1"}], "]"}], 
               "]"}]}]}], ")"}]}], "+", 
          RowBox[{"thman", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"rman", " ", 
              RowBox[{"res2m", "[", 
               RowBox[{"[", 
                RowBox[{"rb", ",", "thb", ",", "phb", ",", "1"}], "]"}], 
               "]"}]}], "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"1", "-", "rman"}], ")"}], 
              RowBox[{"res2m", "[", 
               RowBox[{"[", 
                RowBox[{"ra", ",", "thb", ",", "phb", ",", "1"}], "]"}], 
               "]"}]}]}], ")"}]}]}], ")"}]}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"\[Rho]x", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"3", "-", "rman", "-", "thman", "-", "phman"}], " ", ")"}], 
          RowBox[{"res2m", "[", 
           RowBox[{"[", 
            RowBox[{"ra", ",", "tha", ",", "pha", ",", "1"}], "]"}], "]"}]}], 
         "+", 
         RowBox[{"rman", " ", 
          RowBox[{"res2m", "[", 
           RowBox[{"[", 
            RowBox[{"rb", ",", "tha", ",", "pha", ",", "1"}], "]"}], "]"}]}], 
         "+", 
         RowBox[{"thman", " ", 
          RowBox[{"res2m", "[", 
           RowBox[{"[", 
            RowBox[{"ra", ",", "thb", ",", "pha", ",", "1"}], "]"}], "]"}]}], 
         "+", 
         RowBox[{"phman", " ", 
          RowBox[{"res2m", "[", 
           RowBox[{"[", 
            RowBox[{"ra", ",", "tha", ",", "phb", ",", "1"}], "]"}], 
           "]"}]}]}], ")"}], "/", "3"}]}]}], 
    RowBox[{"(*", 
     RowBox[{"\[Phi]", "-", "dependent"}], "*)"}], ")"}]}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"\[Rho]", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", "thman"}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"rman", " ", 
          RowBox[{"res2m", "[", 
           RowBox[{"[", 
            RowBox[{"rb", ",", "tha", ",", "5", ",", "1"}], "]"}], "]"}]}], 
         "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", "rman"}], ")"}], 
          RowBox[{"res2m", "[", 
           RowBox[{"[", 
            RowBox[{"ra", ",", "tha", ",", "5", ",", "1"}], "]"}], "]"}]}]}], 
        ")"}]}], "+", 
      RowBox[{"thman", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"rman", " ", 
          RowBox[{"res2m", "[", 
           RowBox[{"[", 
            RowBox[{"rb", ",", "thb", ",", "5", ",", "1"}], "]"}], "]"}]}], 
         "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", "rman"}], ")"}], 
          RowBox[{"res2m", "[", 
           RowBox[{"[", 
            RowBox[{"ra", ",", "thb", ",", "5", ",", "1"}], "]"}], "]"}]}]}], 
        ")"}]}]}]}], ";"}], 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"not", " ", "\[Phi]"}], "-", "dependent"}], "*)"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tab1x", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"intercomp", "[", 
       RowBox[{"rt", ",", "\[Theta]t", ",", "\[Phi]t"}], "]"}], ";", 
      RowBox[{"{", 
       RowBox[{"\[Phi]t", ",", "\[Rho]x"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Phi]t", ",", "0.9", ",", 
       RowBox[{"0.9", "+", 
        RowBox[{"2", "\[Pi]", 
         FractionBox["4", "phlen"]}]}], ",", 
       FractionBox["0.1", "phlen"]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tab2x", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"intercomp", "[", 
       RowBox[{"rt", ",", "\[Theta]t", ",", "\[Phi]t"}], "]"}], ";", 
      RowBox[{"{", 
       RowBox[{"\[Theta]t", ",", "\[Rho]x"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Theta]t", ",", "0.9", ",", 
       RowBox[{"0.9", "+", 
        RowBox[{"2", "\[Pi]", 
         FractionBox["4", "thlen"]}]}], ",", 
       FractionBox["0.1", "thlen"]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tab3x", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"intercomp", "[", 
       RowBox[{"rt", ",", "\[Theta]t", ",", "\[Phi]t"}], "]"}], ";", 
      RowBox[{"{", 
       RowBox[{"rt", ",", "\[Rho]x"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"rt", ",", "1.9", ",", "2.9", ",", "0.02"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tab1", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"intercomp", "[", 
       RowBox[{"rt", ",", "\[Theta]t", ",", "\[Phi]t"}], "]"}], ";", 
      RowBox[{"{", 
       RowBox[{"\[Phi]t", ",", "\[Rho]"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Phi]t", ",", "0.9", ",", 
       RowBox[{"0.9", "+", 
        RowBox[{"2", "\[Pi]", 
         FractionBox["4", "phlen"]}]}], ",", 
       FractionBox["0.1", "phlen"]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tab2", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"intercomp", "[", 
       RowBox[{"rt", ",", "\[Theta]t", ",", "\[Phi]t"}], "]"}], ";", 
      RowBox[{"{", 
       RowBox[{"\[Theta]t", ",", "\[Rho]"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Theta]t", ",", "0.9", ",", 
       RowBox[{"0.9", "+", 
        RowBox[{"2", "\[Pi]", 
         FractionBox["4", "thlen"]}]}], ",", 
       FractionBox["0.1", "thlen"]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tab3", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"intercomp", "[", 
       RowBox[{"rt", ",", "\[Theta]t", ",", "\[Phi]t"}], "]"}], ";", 
      RowBox[{"{", 
       RowBox[{"rt", ",", "\[Rho]"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"rt", ",", "1.9", ",", "2.9", ",", "0.02"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"tab1", ",", "tab1x"}], "}"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Blue", ",", "Red"}], "}"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"tab2", ",", "tab2x"}], "}"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Blue", ",", "Red"}], "}"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"tab3", ",", "tab3x"}], "}"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Blue", ",", "Red"}], "}"}]}]}], "]"}], "\n"}], "Input",
 CellChangeTimes->CompressedData["
1:eJwdzk0ow3Ecx/FFVsacPJQZoeQyaZJykK05bAdjjWWZ9hBb20G0tEap9V9K
JpZozVMbRh5yWP4psfK4lR3YwWi2kixmimRH+/wO316X7/fdt1o7LBvMYTAY
FdmBHL1KITe+C6hpgRLSP91jsK2+ywI9jzoK/jESdihsOpmBjXHaCbcjgTV4
tMHzweuQbBfKVeJjaNrh8nuyPnMXiZkVsRie7rdI4FLY3Qm3hHYpZJXnumFk
b8hHdFYdwKvSTRraRhwB0nH8XkJ+3lsQhpLhezg6QEWhMZQkGtjncSj6mEiQ
P9h9r9B/a07D2Xlmfi+60UgBjBmYxTBlLiqBaluKA7X2BT6sXBe1Q4svI4EN
UxYp2aM0/bDm4k4Ny3gKEzxsPrPCoLVuHBZyNTbSWzW44Lej1QufzF6iy9Px
AG/0yhdyH5v8hLra5TTkhFl+RdbPuS8a/gOZOOB/
  "]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"computation", " ", "of", " ", "all", " ", "matrices"}], "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{"\[CapitalDelta]", "=", 
     RowBox[{
      SuperscriptBox["r", "2"], "-", 
      RowBox[{"2", "r"}], "+", 
      SuperscriptBox["a", "2"]}]}], ";", 
    RowBox[{"\[Rho]sq", "=", 
     RowBox[{
      SuperscriptBox["r", "2"], "+", 
      RowBox[{
       SuperscriptBox["a", "2"], 
       SuperscriptBox[
        RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}]}], ";", 
    RowBox[{"\[CapitalSigma]sq", "=", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["r", "2"], "+", 
         SuperscriptBox["a", "2"]}], ")"}], "2"], "-", 
      RowBox[{
       SuperscriptBox["a", "2"], "\[CapitalDelta]", " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"gmn", "=", 
       RowBox[{"-", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            FractionBox["\[CapitalSigma]sq", 
             RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", 
            "0", ",", 
            FractionBox[
             RowBox[{"2", "a", " ", "r"}], 
             RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"-", 
             FractionBox["\[CapitalDelta]", "\[Rho]sq"]}], ",", "0", ",", 
            "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", 
            RowBox[{"-", 
             SuperscriptBox["\[Rho]sq", 
              RowBox[{"-", "1"}]]}], ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            FractionBox[
             RowBox[{"2", "a", " ", "r"}], 
             RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]"}]], ",", "0", ",", 
            "0", ",", 
            RowBox[{"-", 
             FractionBox[
              RowBox[{"(", 
               RowBox[{"\[CapitalDelta]", "-", 
                RowBox[{
                 SuperscriptBox["a", "2"], 
                 SuperscriptBox[
                  RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}], 
              RowBox[{"\[Rho]sq", " ", "\[CapitalDelta]", " ", 
               SuperscriptBox[
                RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]]}]}], "}"}]}], 
         "}"}]}]}], ")"}], "//", "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"invgmn", "=", 
       RowBox[{"FullSimplify", "[", 
        RowBox[{
         RowBox[{"Inverse", "[", "gmn", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"r", ">", "0"}], "}"}]}], "]"}]}], ")"}], "//", 
     "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "[", "1", "]"}], "=", "t"}], ";", 
    RowBox[{
     RowBox[{"x", "[", "2", "]"}], "=", "r"}], ";", 
    RowBox[{
     RowBox[{"x", "[", "3", "]"}], "=", "\[Theta]"}], ";", 
    RowBox[{
     RowBox[{"x", "[", "4", "]"}], "=", "\[Phi]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"G", "[", 
       RowBox[{"1", ",", "1", ",", "1"}], "]"}], "=", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"gmn", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "m"}], "]"}], "]"}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"invgmn", "[", 
              RowBox[{"[", 
               RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
             RowBox[{"x", "[", "1", "]"}]}], "]"}], "+", 
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"invgmn", "[", 
              RowBox[{"[", 
               RowBox[{"m", ",", "1"}], "]"}], "]"}], ",", 
             RowBox[{"x", "[", "1", "]"}]}], "]"}], "-", 
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"invgmn", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
             RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"G", "[", 
         RowBox[{"i", ",", "k", ",", "l"}], "]"}], "=", 
        RowBox[{"Simplify", "[", 
         RowBox[{
          FractionBox["1", "2"], 
          RowBox[{"Sum", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"gmn", "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "m"}], "]"}], "]"}], "*", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"D", "[", 
                RowBox[{
                 RowBox[{"invgmn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "k"}], "]"}], "]"}], ",", 
                 RowBox[{"x", "[", "l", "]"}]}], "]"}], "+", 
               RowBox[{"D", "[", 
                RowBox[{
                 RowBox[{"invgmn", "[", 
                  RowBox[{"[", 
                   RowBox[{"m", ",", "l"}], "]"}], "]"}], ",", 
                 RowBox[{"x", "[", "k", "]"}]}], "]"}], "-", 
               RowBox[{"D", "[", 
                RowBox[{
                 RowBox[{"invgmn", "[", 
                  RowBox[{"[", 
                   RowBox[{"k", ",", "l"}], "]"}], "]"}], ",", 
                 RowBox[{"x", "[", "m", "]"}]}], "]"}]}], ")"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"m", ",", "1", ",", "4"}], "}"}]}], "]"}]}], "]"}]}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "1", ",", "4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"l", ",", "1", ",", "4"}], "}"}]}], "]"}], ";"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"gmn", "=", 
     RowBox[{"Simplify", "[", "gmn", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"invgmn", "=", 
       RowBox[{"Simplify", "[", 
        RowBox[{"invgmn", "/.", 
         RowBox[{
          RowBox[{"Cos", "[", 
           RowBox[{"2", "\[Theta]"}], "]"}], "\[Rule]", 
          RowBox[{
           RowBox[{"2", 
            SuperscriptBox[
             RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}], "-", "1"}]}]}], 
        "]"}]}], ")"}], "//", "MatrixForm"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"invgmnKS", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            FractionBox[
             RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", 
           FractionBox[
            RowBox[{"2", "r"}], "\[Rho]sq"], ",", "0", ",", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"2", "a", " ", "r", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}]}],
           "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           FractionBox[
            RowBox[{"2", "r"}], "\[Rho]sq"], ",", 
           RowBox[{"1", "+", 
            FractionBox[
             RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", "0", ",", 
           RowBox[{
            RowBox[{"-", "a"}], 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              FractionBox[
               RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "\[Rho]sq", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"2", "a", " ", "r", " ", 
              SuperscriptBox[
               RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}], 
           ",", 
           RowBox[{
            RowBox[{"-", "a"}], 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              FractionBox[
               RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], ",", "0", ",", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
            RowBox[{"(", 
             RowBox[{"\[Rho]sq", "+", 
              RowBox[{
               SuperscriptBox["a", "2"], 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 FractionBox[
                  RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
               SuperscriptBox[
                RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}]}]}], 
          "}"}]}], "}"}]}], ")"}], "//", "MatrixForm"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Anumu", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          FractionBox[
           RowBox[{"2", "r"}], "\[CapitalDelta]"], ",", "1", ",", "0", ",", 
          FractionBox["a", "\[CapitalDelta]"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ")"}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"invAnumu", "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"Inverse", "[", "Anumu", "]"}], "]"}]}], ")"}], "//", 
     "MatrixForm"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"smart", " ", "inverse", " ", "lookup"}], "*)"}], 
   RowBox[{
    RowBox[{"sinter", "[", 
     RowBox[{"rt_", ",", "\[Theta]t_", ",", "\[Phi]t_"}], "]"}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"ra", "=", "1"}], ";", 
      RowBox[{"rb", "=", "rlen"}], ";", 
      RowBox[{"While", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"rb", "-", "ra"}], ">", "1"}], ",", 
        RowBox[{
         RowBox[{"rx", "=", 
          RowBox[{"Quotient", "[", 
           RowBox[{
            RowBox[{"rb", "+", "ra"}], ",", "2"}], "]"}]}], ";", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"rt", ">", 
            RowBox[{"(", 
             RowBox[{"rfin", "=", 
              RowBox[{"grid", "[", 
               RowBox[{"[", 
                RowBox[{"rx", ",", "1", ",", "1"}], "]"}], "]"}]}], ")"}]}], 
           ",", 
           RowBox[{"ra", "=", "rx"}], ",", 
           RowBox[{"rb", "=", "rx"}]}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"rlo", "=", 
         RowBox[{"grid", "[", 
          RowBox[{"[", 
           RowBox[{"ra", ",", "1", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"rhi", "=", 
         RowBox[{"grid", "[", 
          RowBox[{"[", 
           RowBox[{"rb", ",", "1", ",", "1"}], "]"}], "]"}]}]}], "}"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"rman", "=", 
       FractionBox[
        RowBox[{"rt", "-", "rlo"}], 
        RowBox[{"rhi", "-", "rlo"}]]}], ";", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"thmin", "=", 
         RowBox[{
          RowBox[{"rman", " ", 
           RowBox[{"grid", "[", 
            RowBox[{"[", 
             RowBox[{"rb", ",", "1", ",", "2"}], "]"}], "]"}]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "-", "rman"}], ")"}], 
           RowBox[{"grid", "[", 
            RowBox[{"[", 
             RowBox[{"ra", ",", "1", ",", "2"}], "]"}], "]"}]}]}]}], ",", 
        RowBox[{"thmax", "=", 
         RowBox[{"\[Pi]", "-", "thmin"}]}]}], "}"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"tha", "=", "1"}], ";", 
      RowBox[{"thb", "=", "thlen"}], ";", 
      RowBox[{"While", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"thb", "-", "tha"}], ">", "1"}], ",", 
        RowBox[{
         RowBox[{"thx", "=", 
          RowBox[{"Quotient", "[", 
           RowBox[{
            RowBox[{"thb", "+", "tha"}], ",", "2"}], "]"}]}], ";", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"\[Theta]t", ">", 
            RowBox[{"(", 
             RowBox[{"thfin", "=", 
              RowBox[{
               RowBox[{"rman", " ", 
                RowBox[{"grid", "[", 
                 RowBox[{"[", 
                  RowBox[{"rb", ",", "thx", ",", "2"}], "]"}], "]"}]}], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "-", "rman"}], ")"}], 
                RowBox[{"grid", "[", 
                 RowBox[{"[", 
                  RowBox[{"ra", ",", "thx", ",", "2"}], "]"}], "]"}]}]}]}], 
             ")"}]}], ",", 
           RowBox[{"tha", "=", "thx"}], ",", 
           RowBox[{"thb", "=", "thx"}]}], "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"{", 
       RowBox[{"thb", ",", "tha"}], "}"}], ";", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"thlo", "=", 
         RowBox[{
          RowBox[{"rman", " ", 
           RowBox[{"grid", "[", 
            RowBox[{"[", 
             RowBox[{"rb", ",", "tha", ",", "2"}], "]"}], "]"}]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "-", "rman"}], ")"}], 
           RowBox[{"grid", "[", 
            RowBox[{"[", 
             RowBox[{"ra", ",", "tha", ",", "2"}], "]"}], "]"}]}]}]}], ",", 
        RowBox[{"thhi", "=", 
         RowBox[{
          RowBox[{"rman", " ", 
           RowBox[{"grid", "[", 
            RowBox[{"[", 
             RowBox[{"rb", ",", "thb", ",", "2"}], "]"}], "]"}]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "-", "rman"}], ")"}], 
           RowBox[{"grid", "[", 
            RowBox[{"[", 
             RowBox[{"ra", ",", "thb", ",", "2"}], "]"}], "]"}]}]}]}]}], 
       "}"}], ";", "\[IndentingNewLine]", 
      RowBox[{"thman", "=", 
       FractionBox[
        RowBox[{"\[Theta]t", "-", "thlo"}], 
        RowBox[{"thhi", "-", "thlo"}]]}], ";", 
      RowBox[{"phx", "=", 
       RowBox[{
        FractionBox["\[Phi]t", 
         RowBox[{"2", "\[Pi]"}]], "thlen"}]}], ";", 
      RowBox[{"pha", "=", 
       RowBox[{"Floor", "[", "phx", "]"}]}], ";", 
      RowBox[{"phb", "=", 
       RowBox[{"pha", "+", "1"}]}], ";", 
      RowBox[{"phman", "=", 
       RowBox[{"phx", "-", "pha"}]}], ";"}], ")"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rt", "=", "2.3"}], ";", 
    RowBox[{"\[Theta]t", "=", "2.0"}], ";", 
    RowBox[{"\[Phi]t", "=", "1.2"}], ";", 
    RowBox[{"sinter", "[", 
     RowBox[{"rt", ",", "\[Theta]t", ",", "\[Phi]t"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"avggd", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "thman"}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"rman", " ", 
         RowBox[{"resgd", "[", 
          RowBox[{"[", 
           RowBox[{"rb", ",", "tha", ",", "All"}], "]"}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", "rman"}], ")"}], 
         RowBox[{"resgd", "[", 
          RowBox[{"[", 
           RowBox[{"ra", ",", "tha", ",", "All"}], "]"}], "]"}]}]}], ")"}]}], 
     "+", 
     RowBox[{"thman", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"rman", " ", 
         RowBox[{"resgd", "[", 
          RowBox[{"[", 
           RowBox[{"rb", ",", "thb", ",", "All"}], "]"}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", "rman"}], ")"}], 
         RowBox[{"resgd", "[", 
          RowBox[{"[", 
           RowBox[{"ra", ",", "thb", ",", "All"}], "]"}], "]"}]}]}], 
       ")"}]}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rtp", "=", 
     RowBox[{"avggd", "[", 
      RowBox[{"[", 
       RowBox[{"8", ";;", "10"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xxx", "=", 
     RowBox[{"avggd", "[", 
      RowBox[{"[", 
       RowBox[{"5", ";;", "7"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Coord (x1,x2): \>\"", " ", ",", 
      RowBox[{"xxx", "[", 
       RowBox[{"[", 
        RowBox[{"1", ";;", "2"}], "]"}], "]"}], ",", 
      "\"\<; (r,\[Theta]): \>\"", ",", " ", 
      RowBox[{"rtp", "[", 
       RowBox[{"[", 
        RowBox[{"1", ";;", "2"}], "]"}], "]"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sub", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"r", "\[Rule]", 
        RowBox[{"rtp", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ",", 
       RowBox[{"x1", "\[Rule]", 
        RowBox[{"xxx", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ",", 
       RowBox[{"\[Theta]", "\[Rule]", 
        RowBox[{"rtp", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", 
       RowBox[{"x2", "\[Rule]", 
        RowBox[{"xxx", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ",", 
       RowBox[{"a", "\[Rule]", "0.0"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"gcon", "=", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"avggd", "[", 
        RowBox[{"[", 
         RowBox[{"11", ";;", "26"}], "]"}], "]"}], ",", "4"}], "]"}]}], ";", 
    RowBox[{"gcov", "=", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"avggd", "[", 
        RowBox[{"[", 
         RowBox[{"27", ";;", "42"}], "]"}], "]"}], ",", "4"}], "]"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"gdet", "=", 
     RowBox[{"avggd", "[", 
      RowBox[{"[", "43", "]"}], "]"}]}], ";", 
    RowBox[{"dxdxp", "=", 
     RowBox[{"Partition", "[", 
      RowBox[{
       RowBox[{"avggd", "[", 
        RowBox[{"[", 
         RowBox[{"48", ";;", "63"}], "]"}], "]"}], ",", "4"}], "]"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fie", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"3", "-", "rman", "-", "thman", "-", "phman"}], " ", ")"}], 
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"ra", ",", "tha", ",", "pha"}], "]"}], "]"}]}], "+", 
        RowBox[{"rman", " ", 
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"rb", ",", "tha", ",", "pha"}], "]"}], "]"}]}], "+", 
        RowBox[{"thman", " ", 
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"ra", ",", "thb", ",", "pha"}], "]"}], "]"}]}], "+", 
        RowBox[{"phman", " ", 
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"ra", ",", "tha", ",", "phb"}], "]"}], "]"}]}]}], ")"}], 
      "/", "3"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"imprecise", " ", "\[Implies]", " ", 
       RowBox[{"1", "*", 
        SuperscriptBox["10", 
         RowBox[{"-", "2"}]], " ", "for", " ", "rt"}]}], "=", "2.6"}], ";", 
     RowBox[{"\[Theta]t", "=", "2.1"}], ";", 
     RowBox[{"\[Phi]t", "=", "1.2"}], ";", " ", 
     RowBox[{
      RowBox[{
      "when", " ", "matrices", " ", "except", " ", "transformation", " ", 
       "are", " ", "pre"}], "-", "computed"}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fie", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", "phman"}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", "thman"}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"rman", " ", 
             RowBox[{"res2m", "[", 
              RowBox[{"[", 
               RowBox[{"rb", ",", "tha", ",", "pha"}], "]"}], "]"}]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "-", "rman"}], ")"}], 
             RowBox[{"res2m", "[", 
              RowBox[{"[", 
               RowBox[{"ra", ",", "tha", ",", "pha"}], "]"}], "]"}]}]}], 
           ")"}]}], "+", 
         RowBox[{"thman", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"rman", " ", 
             RowBox[{"res2m", "[", 
              RowBox[{"[", 
               RowBox[{"rb", ",", "thb", ",", "pha"}], "]"}], "]"}]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "-", "rman"}], ")"}], 
             RowBox[{"res2m", "[", 
              RowBox[{"[", 
               RowBox[{"ra", ",", "thb", ",", "pha"}], "]"}], "]"}]}]}], 
           ")"}]}]}], ")"}]}], "+", 
      RowBox[{"phman", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", "thman"}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"rman", " ", 
             RowBox[{"res2m", "[", 
              RowBox[{"[", 
               RowBox[{"rb", ",", "tha", ",", "phb"}], "]"}], "]"}]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "-", "rman"}], ")"}], 
             RowBox[{"res2m", "[", 
              RowBox[{"[", 
               RowBox[{"ra", ",", "tha", ",", "phb"}], "]"}], "]"}]}]}], 
           ")"}]}], "+", 
         RowBox[{"thman", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"rman", " ", 
             RowBox[{"res2m", "[", 
              RowBox[{"[", 
               RowBox[{"rb", ",", "thb", ",", "phb"}], "]"}], "]"}]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "-", "rman"}], ")"}], 
             RowBox[{"res2m", "[", 
              RowBox[{"[", 
               RowBox[{"ra", ",", "thb", ",", "phb"}], "]"}], "]"}]}]}], 
           ")"}]}]}], ")"}]}]}]}], ";"}], 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"precise", " ", "multilinear"}], " ", "\[Implies]", " ", 
       RowBox[{"3", "*", 
        SuperscriptBox["10", 
         RowBox[{"-", "3"}]], " ", "for", " ", "rt"}]}], "=", "2.6"}], ";", 
     RowBox[{"\[Theta]t", "=", "2.1"}], ";", 
     RowBox[{"\[Phi]t", "=", "1.2"}], ";", "  ", 
     RowBox[{
      RowBox[{
      "when", " ", "matrices", " ", "except", " ", "transformation", " ", 
       "are", " ", "pre"}], "-", "computed"}]}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<\[Rho]=\>\"", ",", " ", 
      RowBox[{"\[Rho]", "=", 
       RowBox[{"fie", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ",", "\"\<; U=\>\"", ",", 
      RowBox[{"U", "=", 
       RowBox[{"fie", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<\!\(\*SuperscriptBox[\(u\), \(\[Mu]\)]\)=\>\"", ",", 
      RowBox[{"uup", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"fie", "[", 
           RowBox[{"[", "5", "]"}], "]"}], ",", 
          RowBox[{
           RowBox[{"fie", "[", 
            RowBox[{"[", "5", "]"}], "]"}], 
           RowBox[{"fie", "[", 
            RowBox[{"[", 
             RowBox[{"6", ";;", "8"}], "]"}], "]"}]}]}], "}"}], "]"}]}]}], 
     "]"}], ";", 
    RowBox[{"ulo", "=", 
     RowBox[{"gcov", ".", "uup"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<MKS \!\(\*SuperscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
      RowBox[{"bi", "=", 
       RowBox[{"fie", "[", 
        RowBox[{"[", 
         RowBox[{"9", ";;", "11"}], "]"}], "]"}]}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<\!\(\*SuperscriptBox[\(b\), \(\[Mu]\)]\)=\>\"", ",", 
      RowBox[{"bup", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"bi", ".", 
           RowBox[{"ulo", "[", 
            RowBox[{"[", 
             RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], ",", 
          FractionBox[
           RowBox[{"bi", "+", 
            RowBox[{
             RowBox[{"bi", ".", 
              RowBox[{"ulo", "[", 
               RowBox[{"[", 
                RowBox[{"2", ";;", "4"}], "]"}], "]"}]}], 
             RowBox[{"uup", "[", 
              RowBox[{"[", 
               RowBox[{"2", ";;", "4"}], "]"}], "]"}]}]}], 
           RowBox[{"uup", "[", 
            RowBox[{"[", "1", "]"}], "]"}]]}], "}"}], "]"}]}], ",", 
      "\"\<; \!\(\*SubscriptBox[SuperscriptBox[\(b\), \(\[Mu]\)], \
\(KS\)]\)=\>\"", ",", 
      RowBox[{"bupKS", "=", 
       RowBox[{"dxdxp", ".", "bup"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<In KS coordinates: \!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\[Mu]\
\)], \(KS\)]\)=\>\"", ",", " ", 
      RowBox[{"uupKS", "=", 
       RowBox[{"dxdxp", ".", "uup"}]}], ",", 
      "\"\<;  \!\(\*SubscriptBox[\(u\), \(\[Mu]KS\)]\)=\>\"", ",", 
      RowBox[{"uloKS", "=", 
       RowBox[{
        RowBox[{"invgmnKS", ".", "uupKS"}], "/.", "sub"}]}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<In BL coordinates: \!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\[Mu]\
\)], \(BL\)]\)=\>\"", ",", " ", 
      RowBox[{"uupBL", "=", 
       RowBox[{
        RowBox[{"invAnumu", ".", "uupKS"}], "/.", "sub"}]}], ",", 
      "\"\<;  \!\(\*SubscriptBox[\(u\), \(\[Mu]BL\)]\)=\>\"", ",", 
      RowBox[{"uloBL", "=", 
       RowBox[{
        RowBox[{"invgmn", ".", "uupBL"}], "/.", "sub"}]}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<Back to KS coordinates: \!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\
\[Mu]\)], \(KS\)]\)=\>\"", ",", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"Transpose", "[", "Anumu", "]"}], ".", "uupBL"}], "/.", 
       "sub"}]}], "]"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{
    "\"\<Test 1: \!\(\*SuperscriptBox[\(g\), \
\(\[Mu]\[Nu]\)]\)\!\(\*SubscriptBox[\(g\), \
\(\[Nu]\[Sigma]\)]\)==\!\(\*SubscriptBox[SuperscriptBox[\(\[Delta]\), \(\[Mu]\
\)], \(\[Sigma]\)]\); should be identity matrix:   \>\"", ",", 
     RowBox[{"Chop", "[", 
      RowBox[{
       RowBox[{"gcov", ".", "gcon"}], "//", "MatrixForm"}], "]"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{
    "\"\<Test 2: gdet==\!\(\*SqrtBox[\(-Det[gcov]\)]\);  should be unity:     \
 \>\"", ",", 
     FractionBox[
      SqrtBox[
       RowBox[{"-", 
        RowBox[{"Det", "[", "gcov", "]"}]}]], "gdet"]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{
    "\"\<Test 3: normalization of velocity in MKS: \
\!\(\*SuperscriptBox[\(u\), \(\[Mu]\)]\)\!\(\*SubscriptBox[\(u\), \
\(\[Mu]\)]\)=-1:  \>\"", ",", 
     RowBox[{"ulo", ".", "uup"}]}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{
    "\"\<Test 4: normalization of velocity in KS: \
\!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\[Mu]\)], \
\(KS\)]\)\!\(\*SubscriptBox[\(u\), SubscriptBox[\(\[Mu]\), \(KS\)]]\)=-1:  \>\
\"", ",", 
     RowBox[{"uupKS", ".", "uloKS"}]}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{
    "\"\<Test 5: normalization of velocity in BL: \
\!\(\*SubscriptBox[SuperscriptBox[\(u\), \(\[Mu]\)], \
\(BL\)]\)\!\(\*SubscriptBox[\(u\), SubscriptBox[\(\[Mu]\), \(BL\)]]\)=-1:  \>\
\"", ",", 
     RowBox[{"uupBL", ".", "uloBL"}]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"u", "[", "0", "]"}], ",", 
        RowBox[{"u", "[", "1", "]"}], ",", 
        RowBox[{"u", "[", "2", "]"}], ",", 
        RowBox[{"u", "[", "3", "]"}]}], "}"}], "=", "uupKS"}], "]"}], ";", 
    RowBox[{"Thread", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"uco", "[", "0", "]"}], ",", 
        RowBox[{"uco", "[", "1", "]"}], ",", 
        RowBox[{"uco", "[", "2", "]"}], ",", 
        RowBox[{"uco", "[", "3", "]"}]}], "}"}], "=", "uloKS"}], "]"}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xx", "[", "0", "]"}], "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"u", "[", "0", "]"}], ",", 
       RowBox[{"u", "[", "1", "]"}], ",", 
       RowBox[{"u", "[", "2", "]"}], ",", 
       RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ";", 
    RowBox[{
     RowBox[{"xxlo", "[", "0", "]"}], "=", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"invgmnKS", ".", 
        RowBox[{"xx", "[", "0", "]"}]}]}], "/.", "sub"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xx", "[", "2", "]"}], "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"uco", "[", "2", "]"}], 
        RowBox[{"u", "[", "0", "]"}]}], ",", 
       RowBox[{
        RowBox[{"uco", "[", "2", "]"}], 
        RowBox[{"u", "[", "1", "]"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"uco", "[", "2", "]"}], 
         RowBox[{"u", "[", "2", "]"}]}], "+", "1"}], ",", 
       RowBox[{
        RowBox[{"uco", "[", "2", "]"}], 
        RowBox[{"u", "[", "3", "]"}]}]}], "}"}]}], ";", 
    RowBox[{
     RowBox[{"xxlo", "[", "2", "]"}], "=", 
     RowBox[{
      RowBox[{"invgmnKS", ".", 
       RowBox[{"xx", "[", "2", "]"}]}], "/.", "sub"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xx", "[", "3", "]"}], "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"uco", "[", "3", "]"}], 
         RowBox[{"uco", "[", "0", "]"}]]}], ",", "0", ",", "0", ",", "1"}], 
      "}"}]}], ";", 
    RowBox[{
     RowBox[{"xxlo", "[", "3", "]"}], "=", 
     RowBox[{
      RowBox[{"invgmnKS", ".", 
       RowBox[{"xx", "[", "3", "]"}]}], "/.", "sub"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"sc", "[", "0", "]"}], "=", 
     RowBox[{
      SqrtBox[
       RowBox[{
        RowBox[{"xx", "[", "0", "]"}], ".", 
        RowBox[{"xxlo", "[", "0", "]"}]}]], "/.", "sub"}]}], ";", 
    RowBox[{
     RowBox[{"sc", "[", "3", "]"}], "=", 
     RowBox[{
      SqrtBox[
       RowBox[{
        RowBox[{"xx", "[", "3", "]"}], ".", 
        RowBox[{"xxlo", "[", "3", "]"}]}]], "/.", "sub"}]}], ";", 
    RowBox[{
     RowBox[{"sc", "[", "2", "]"}], "=", 
     RowBox[{
      SqrtBox[
       RowBox[{
        RowBox[{"xx", "[", "2", "]"}], ".", 
        RowBox[{"xxlo", "[", "2", "]"}]}]], "/.", "sub"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xx", "[", "0", "]"}], "/=", 
     RowBox[{"sc", "[", "0", "]"}]}], ";", 
    RowBox[{
     RowBox[{"xxlo", "[", "0", "]"}], "/=", 
     RowBox[{
      RowBox[{"sc", "[", "0", "]"}], "/.", "sub"}]}], ";", 
    RowBox[{
     RowBox[{"xx", "[", "2", "]"}], "/=", 
     RowBox[{"sc", "[", "2", "]"}]}], ";", 
    RowBox[{
     RowBox[{"xxlo", "[", "2", "]"}], "/=", 
     RowBox[{
      RowBox[{"sc", "[", "2", "]"}], "/.", "sub"}]}], ";", 
    RowBox[{
     RowBox[{"xx", "[", "3", "]"}], "/=", 
     RowBox[{"sc", "[", "3", "]"}]}], ";", 
    RowBox[{
     RowBox[{"xxlo", "[", "3", "]"}], "/=", 
     RowBox[{
      RowBox[{"sc", "[", "3", "]"}], "/.", "sub"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xpr", "[", "1", "]"}], "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"u", "[", "0", "]"}], 
         RowBox[{"uco", "[", "1", "]"}]}], " ", ",", 
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"u", "[", "0", "]"}], 
            RowBox[{"uco", "[", "0", "]"}]}], "+", 
           RowBox[{
            RowBox[{"u", "[", "3", "]"}], 
            RowBox[{"uco", "[", "3", "]"}]}]}], ")"}]}], ",", "0", ",", 
        RowBox[{
         RowBox[{"u", "[", "3", "]"}], 
         RowBox[{"uco", "[", "1", "]"}]}]}], "}"}], "/.", "sub"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xlopr", "[", "1", "]"}], "=", 
     RowBox[{
      RowBox[{"invgmnKS", ".", 
       RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
    RowBox[{
     RowBox[{"xx", "[", "1", "]"}], "=", 
     RowBox[{
      RowBox[{"xpr", "[", "1", "]"}], "-", 
      RowBox[{
       RowBox[{
        RowBox[{"xlopr", "[", "1", "]"}], ".", 
        RowBox[{"xx", "[", "3", "]"}]}], "*", 
       RowBox[{"xx", "[", "3", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xxlo", "[", "1", "]"}], "=", 
     RowBox[{
      RowBox[{"invgmnKS", ".", 
       RowBox[{"xx", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
    RowBox[{
     RowBox[{"sc", "[", "1", "]"}], "=", 
     RowBox[{
      SqrtBox[
       RowBox[{
        RowBox[{"xx", "[", "1", "]"}], ".", 
        RowBox[{"xxlo", "[", "1", "]"}]}]], "/.", "sub"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"xlopr", "[", "1", "]"}], "=", 
     RowBox[{
      RowBox[{"invgmnKS", ".", 
       RowBox[{"xpr", "[", "1", "]"}]}], "/.", "sub"}]}], ";", 
    RowBox[{
     RowBox[{"xx", "[", "1", "]"}], "/=", 
     RowBox[{"sc", "[", "1", "]"}]}], ";", 
    RowBox[{
     RowBox[{"xxlo", "[", "1", "]"}], "/=", 
     RowBox[{
      RowBox[{"sc", "[", "1", "]"}], "/.", "sub"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"trxx", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"xxlo", "[", "0", "]"}], ",", 
       RowBox[{"xxlo", "[", "1", "]"}], ",", 
       RowBox[{"xxlo", "[", "2", "]"}], ",", 
       RowBox[{"xxlo", "[", "3", "]"}]}], "}"}]}], ";", 
    RowBox[{"trcoxx", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xx", "[", "0", "]"}], ",", 
        RowBox[{"xx", "[", "1", "]"}], ",", 
        RowBox[{"xx", "[", "2", "]"}], ",", 
        RowBox[{"xx", "[", "3", "]"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", "tests", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Test 6: \!\(\*SubscriptBox[\(u\), \(i\)]\)=\>\"", ",", 
      RowBox[{"trxx", ".", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"u", "[", "0", "]"}], ",", 
         RowBox[{"u", "[", "1", "]"}], ",", 
         RowBox[{"u", "[", "2", "]"}], ",", 
         RowBox[{"u", "[", "3", "]"}]}], "}"}]}], ",", 
      "\"\<;  should be {1,0,0,0}\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<Test 7: co-moving \!\(\*SubscriptBox[\(B\), \(i\)]\)=\>\"", ",", 
      RowBox[{"coB", "=", 
       RowBox[{
        RowBox[{"trxx", ".", "bupKS"}], "/.", "sub"}]}], ",", 
      "\"\<;  0-th component should be 0\>\""}], "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<Back to KS frame: \!\(\*SubscriptBox[SuperscriptBox[\(b\), \
\(\[Mu]\)], \(KS\)]\)=\>\"", ",", 
      RowBox[{"trcoxx", ".", "coB"}]}], "]"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.545413411707677*^9, 3.5454134197411366`*^9}, {
   3.545413477252426*^9, 3.545413477824458*^9}, {3.5454135382819166`*^9, 
   3.545413583418498*^9}, {3.545413614010248*^9, 3.5454137975267444`*^9}, {
   3.545413835841936*^9, 3.5454138398131633`*^9}, {3.5454138966144123`*^9, 
   3.5454139905137825`*^9}, {3.545414145349639*^9, 3.545414174514307*^9}, {
   3.545414257145033*^9, 3.5454142577420673`*^9}, {3.5454142930780883`*^9, 
   3.5454144509511185`*^9}, {3.5454147104849625`*^9, 3.54541472880001*^9}, {
   3.5454149794303455`*^9, 3.5454149938361692`*^9}, {3.545415077609961*^9, 
   3.5454150835503006`*^9}, {3.545415125935725*^9, 3.5454151961577415`*^9}, 
   3.5454757881681643`*^9, {3.546861456953895*^9, 3.5468614921229067`*^9}, {
   3.546861618784151*^9, 3.5468616240984554`*^9}, 3.546870065629283*^9}],

Cell[BoxData[{"dxdxp", "\[IndentingNewLine]", 
 RowBox[{"Inverse", "[", "dxdxp", "]"}]}], "Input",
 CellChangeTimes->{{3.546863393992687*^9, 3.5468634120037174`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Transpose", "[", "Anumu", "]"}], ".", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"kBL", "[", "0", "]"}], ",", 
    RowBox[{"kBL", "[", "1", "]"}], ",", 
    RowBox[{"kBL", "[", "2", "]"}], ",", 
    RowBox[{"kBL", "[", "3", "]"}]}], 
   "}"}]}], "\[IndentingNewLine]", "\[CapitalDelta]"}], "Input",
 CellChangeTimes->{{3.546861544257889*^9, 3.5468615450009313`*^9}, {
  3.546861584361182*^9, 3.546861604464332*^9}, {3.5468616372652082`*^9, 
  3.546861691472309*^9}}],

Cell[BoxData[
 RowBox[{"3.", " ", 
  RowBox[{
   SuperscriptBox["10", "10"], "/", 
   RowBox[{"(", 
    RowBox[{"4", " ", 
     SuperscriptBox["10", "12"]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.5474008140298615`*^9, 3.547400840794392*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["new simulations till 10^5M radial grid", "Subsubsection",
 CellChangeTimes->{{3.541203862326542*^9, 3.541203880703374*^9}}],

Cell[BoxData[
 RowBox[{"xxx", "[", 
  RowBox[{"[", 
   RowBox[{"1", ";;", "2"}], "]"}], "]"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", " ", "=", " ", 
   RowBox[{"NotebookDirectory", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", "fnum_", "]"}], " ", ":=", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", " ", "=", 
      RowBox[{
      "\"\<E:\\\\GRMHD\\\\new\\\\a0\\\\fieldlines\\\\fieldline\>\"", " ", "<>",
        " ", 
       RowBox[{"StringJoin", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", "#", "]"}], " ", "&"}], " ", "/@", " ", 
         RowBox[{"PadLeft", "[", 
          RowBox[{
           RowBox[{"IntegerDigits", "[", "fnum", "]"}], ",", " ", "4"}], 
          "]"}]}], "]"}], " ", "<>", " ", "\"\<.bin\>\""}]}], ";", "\n", 
     "   ", 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "256", "*", "128", "*", "64", "*", "4"}]}], ";", 
     "\n", "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\n", "   ", 
     RowBox[{"res2m", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"llist", " ", "=", " ", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"BinaryReadList", "[", 
                RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                 RowBox[{"11", "*", "64", "*", "128", "*", "256"}]}], "]"}], 
               ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], ",", " ", 
           "128"}], "]"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], "}"}]}], 
       "]"}]}], ";", "\n", "   ", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], "\n", 
 RowBox[{"read11", "[", "9900", "]"}]}], "Input",
 CellChangeTimes->{{3.48199863871*^9, 3.4819986488344*^9}, {
   3.4821459308244*^9, 3.4821459311208*^9}, 3.4834575605388002`*^9, {
   3.4834576012392*^9, 3.4834576140312*^9}, {3.4834576807524*^9, 
   3.4834576815011997`*^9}, {3.4834577493612003`*^9, 3.4834577829636*^9}, {
   3.4834578209184*^9, 3.4834578352236*^9}, {3.5057603089278*^9, 
   3.5057603097546*^9}, {3.541203794809623*^9, 3.541203794981223*^9}, {
   3.5412043045883183`*^9, 3.5412043088003254`*^9}, {3.541204501242264*^9, 
   3.541204515750289*^9}, 3.5454092631583934`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"stt", "=", 
   RowBox[{"StringToStream", "[", "strrr", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"x1min", "=", 
    RowBox[{"Read", "[", 
     RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "5"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"dx1", "=", 
    RowBox[{"Read", "[", 
     RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"off", "=", 
    RowBox[{"Read", "[", 
     RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "6"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Close", "[", "stt", "]"}], ";"}], "\n", 
 RowBox[{"rtab", "=", 
  RowBox[{"off", "+", 
   RowBox[{"Exp", "[", 
    RowBox[{"x1min", "+", 
     RowBox[{"dx1", " ", 
      RowBox[{"Range", "[", 
       RowBox[{"0", ",", "255"}], "]"}]}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.4834577893908*^9, 3.4834577902799997`*^9}, {
   3.4834578852528*^9, 3.4834579287455997`*^9}, {3.483457985436*^9, 
   3.4834580282892*^9}, {3.4834580820156*^9, 3.4834581050411997`*^9}, {
   3.4834581675348*^9, 3.483458214756*^9}, {3.4834583189484*^9, 
   3.4834583413812*^9}, 3.4840505656378*^9}],

Cell[BoxData["strrr"], "Input",
 CellChangeTimes->{{3.5412044600581913`*^9, 3.5412044605105925`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x1min", ",", "dx1", ",", "off"}], "}"}]], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Limiting the polar region", "Subsection",
 CellChangeTimes->{{3.55891106416823*^9, 3.5589110673974147`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", " ", "=", " ", 
   RowBox[{"NotebookDirectory", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ndd", "=", "650"}], ";", 
  RowBox[{"ncut", "=", "120"}], ";", 
  RowBox[{"NDIM", "=", "4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dirin", "=", "\"\<E:\\\\GRMHD\\\\Jon\\\\\>\""}], ";", 
  RowBox[{"anum", "=", "0.9375"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"readgd", "[", "spstr_", "]"}], " ", ":=", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", " ", "=", 
      RowBox[{"dirin", "<>", "atab", "<>", "\"\<\\\\gdump.bin\>\""}]}], ";", 
     "\n", "   ", 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"272", "*", "128", "*", "256", "*", "8", "*", "126"}]}], ";", 
     "\n", "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", "156"}], 
        "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetStreamPosition", "[", 
      RowBox[{"fi11", ",", 
       RowBox[{"siz", "-", "xs"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"resgd", " ", "=", " ", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"BinaryReadList", "[", 
               RowBox[{"fi11", ",", " ", "\"\<Real64\>\"", ",", 
                RowBox[{"xs", "/", "8"}]}], "]"}], ",", 
              SuperscriptBox["NDIM", "2"]}], "]"}], ",", "272"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";"}], "*)"}],
      "\[IndentingNewLine]", 
     RowBox[{"resgd", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"BinaryReadList", "[", 
               RowBox[{"fi11", ",", " ", "\"\<Real64\>\"", ",", 
                RowBox[{"xs", "/", "8"}]}], "]"}], ",", "126"}], "]"}], ",", 
            "272"}], "]"}], ",", "128"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"resgd", " ", "=", " ", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"llist", " ", "=", " ", 
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"Partition", "[", 
                RowBox[{
                 RowBox[{"BinaryReadList", "[", 
                  RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                   RowBox[{"11", "*", "64", "*", "128", "*", "256"}]}], "]"}],
                  ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], ",", " ",
              "128"}], "]"}]}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], 
           "}"}]}], "]"}]}], ";"}], "*)"}], "\n", "   ", 
     RowBox[{"Close", "[", "fi11", "]"}], ";"}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"readgd2d", "[", "spstr_", "]"}], " ", ":=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"namefile", " ", "=", 
       RowBox[{"dirin", "<>", "atab", "<>", "\"\<\\\\gdump.bin\>\""}]}], ";", 
      "\n", "   ", 
      RowBox[{"siz", " ", "=", " ", 
       RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
      RowBox[{"phlen", "=", "256"}], ";", 
      RowBox[{"xs", " ", "=", " ", 
       RowBox[{"272", "*", "128", "*", "phlen", "*", "8", "*", "126"}]}], ";",
       "\n", "   ", 
      RowBox[{"fi11", " ", "=", " ", 
       RowBox[{"OpenRead", "[", 
        RowBox[{"namefile", ",", " ", 
         RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
      RowBox[{"strrr", " ", "=", " ", 
       RowBox[{"StringJoin", "[", 
        RowBox[{"BinaryReadList", "[", 
         RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", "156"}], 
         "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"SetStreamPosition", "[", 
       RowBox[{"fi11", ",", 
        RowBox[{"siz", "-", "xs"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"resgd", " ", "=", " ", 
         RowBox[{"Transpose", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"BinaryReadList", "[", 
                RowBox[{"fi11", ",", " ", "\"\<Real64\>\"", ",", 
                 RowBox[{"xs", "/", "8"}]}], "]"}], ",", 
               SuperscriptBox["NDIM", "2"]}], "]"}], ",", "272"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"resgd2d", " ", "=", " ", 
       RowBox[{"Transpose", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"BinaryReadList", "[", 
              RowBox[{"fi11", ",", " ", "\"\<Real64\>\"", ",", 
               RowBox[{
                RowBox[{"xs", "/", "8"}], "/", "phlen"}]}], "]"}], ",", 
             "126"}], "]"}], ",", "272"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ";", "\n", 
      "   ", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"resgd", " ", "=", " ", 
         RowBox[{"Transpose", "[", 
          RowBox[{
           RowBox[{"llist", " ", "=", " ", 
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"Partition", "[", 
               RowBox[{
                RowBox[{"Partition", "[", 
                 RowBox[{
                  RowBox[{"BinaryReadList", "[", 
                   RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                    RowBox[{"11", "*", "64", "*", "128", "*", "256"}]}], 
                   "]"}], ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], 
              ",", " ", "128"}], "]"}]}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], 
            "}"}]}], "]"}]}], ";"}], "*)"}], "\n", "   ", 
      RowBox[{"Close", "[", "fi11", "]"}], ";"}], ")"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", 
    RowBox[{"spstr_", ",", "fnum_"}], "]"}], " ", ":=", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", " ", "=", 
      RowBox[{
      "dirin", "<>", "spstr", "<>", "\"\<\\\\fieldlines\\\\fieldline\>\"", 
       " ", "<>", " ", 
       RowBox[{"StringJoin", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", "#", "]"}], " ", "&"}], " ", "/@", " ", 
         RowBox[{"PadLeft", "[", 
          RowBox[{
           RowBox[{"IntegerDigits", "[", "fnum", "]"}], ",", " ", "4"}], 
          "]"}]}], "]"}], " ", "<>", " ", "\"\<.bin\>\""}]}], ";", "\n", 
     "   ", 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "272", " ", "128", " ", "256", "*", "4"}]}], ";", 
     "\n", "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"str", "=", 
      RowBox[{"StringToStream", "[", "strrr", "]"}]}], ";", 
     RowBox[{"param", "=", 
      RowBox[{"ReadList", "[", 
       RowBox[{"str", ",", "Number"}], "]"}]}], ";", 
     RowBox[{"Close", "[", "str", "]"}], ";", "\n", "   ", 
     RowBox[{"res2m", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"llist", " ", "=", " ", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"BinaryReadList", "[", 
                RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                 RowBox[{"xs", "/", "4"}]}], "]"}], ",", " ", "11"}], "]"}], 
             ",", " ", "272"}], "]"}], ",", " ", "128"}], "]"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], "}"}]}], 
       "]"}]}], ";", "\n", "   ", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"atab", "=", "\"\<thickdisk7\>\""}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"readgd", "[", "atab", "]"}], "*)"}]}], "\n", 
 RowBox[{"readgd2d", "[", "atab", "]"}], "\[IndentingNewLine]", 
 RowBox[{"read11", "[", 
  RowBox[{"atab", ",", "7034"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "res2m", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "resgd", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "resgd2d", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"extension", " ", "to", " ", "large", " ", 
     RowBox[{"radius", ":", " ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"quantities", " ", "extended", " ", "as", " ", "power"}], "-", 
       "laws"}]}]}], ";", " ", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
     "elements", " ", "of", " ", "dxdxp", " ", "matrices", " ", "are", " ", 
      "extended", " ", "as", " ", "power"}], "-", "laws"}], ";", " ", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"grids", " ", "are", " ", "extended", " ", "as", " ", "power"}], 
     "-", "laws"}], ";", " ", 
    RowBox[{
    "theta", " ", "grid", " ", "is", " ", "fixed", " ", "at", " ", "40", "M", 
     " ", "boundary"}], ";"}], "*)"}]}]}], "Input",
 CellChangeTimes->{3.5589541300835376`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"rtab", "=", 
   RowBox[{"resgd2d", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1", ",", "7"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"thtab", "=", 
   RowBox[{"resgd2d", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "All", ",", "8"}], "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{3.5589541626053977`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nm", "=", "10"}], ";", 
  RowBox[{"nx", "=", "130"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"rtab", "[", 
  RowBox[{"[", 
   RowBox[{"1", ";;", "nx"}], "]"}], 
  "]"}], "\[IndentingNewLine]", "thtab", "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", 
  RowBox[{"ytab", "=", 
   RowBox[{"Outer", "[", 
    RowBox[{"Times", ",", 
     RowBox[{"rtab", "[", 
      RowBox[{"[", 
       RowBox[{"nm", ";;", "nx"}], "]"}], "]"}], ",", 
     RowBox[{"Cos", "[", "thtab", "]"}]}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", 
  RowBox[{"xtab", "=", 
   RowBox[{"Outer", "[", 
    RowBox[{"Times", ",", 
     RowBox[{"rtab", "[", 
      RowBox[{"[", 
       RowBox[{"nm", ";;", "nx"}], "]"}], "]"}], ",", 
     RowBox[{"Sin", "[", "thtab", "]"}]}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Flatten", "[", "xtab", "]"}], ",", 
      RowBox[{"Flatten", "[", "ytab", "]"}]}], "}"}], "]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "2"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.558954163680459*^9, 3.558954189988964*^9}, {
  3.5589542518215003`*^9, 3.558954424292365*^9}, {3.5589544798755445`*^9, 
  3.5589545460173273`*^9}, {3.5589545942570868`*^9, 3.558954696166916*^9}, {
  3.5589549196046953`*^9, 3.558954922235846*^9}, {3.5589563818733325`*^9, 
  3.558956382038342*^9}}],

Cell[BoxData[
 RowBox[{"ListDensityPlot", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Flatten", "[", "xtab", "]"}], ",", 
      RowBox[{"Flatten", "[", "ytab", "]"}], ",", 
      RowBox[{"Flatten", "[", 
       RowBox[{"res2m", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"nm", ";;", "nx"}], ",", "All", ",", "1", ",", "1"}], "]"}],
         "]"}], "]"}]}], "}"}], "]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "2"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5589549382807636`*^9, 3.558954991259794*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["180", "\[Pi]"], 
  RowBox[{"thtab", "[", 
   RowBox[{"[", "10", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.558955708274805*^9, 3.55895573109811*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nm", "=", "1"}], ";", 
  RowBox[{"nx", "=", "130"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListLogLogPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"rtab", "[", 
         RowBox[{"[", 
          RowBox[{"nm", ";;", "nx"}], "]"}], "]"}], ",", 
        FractionBox[
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"nm", ";;", "nx"}], ",", "10", ",", "1", ",", "2"}], 
           "]"}], "]"}], 
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"nm", ";;", "nx"}], ",", "10", ",", "1", ",", "1"}], 
           "]"}], "]"}]]}], "}"}], "]"}], ",", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"rtab", "[", 
         RowBox[{"[", 
          RowBox[{"nm", ";;", "nx"}], "]"}], "]"}], ",", 
        RowBox[{"Log", "[", 
         RowBox[{"1", "+", 
          FractionBox[
           RowBox[{"res2m", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"nm", ";;", "nx"}], ",", "10", ",", "1", ",", "2"}], 
             "]"}], "]"}], 
           RowBox[{"res2m", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"nm", ";;", "nx"}], ",", "10", ",", "1", ",", "1"}], 
             "]"}], "]"}]]}], "]"}]}], "}"}], "]"}]}], "}"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "450"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Blue", ",", "Red"}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5589557853412127`*^9, 3.5589560023136225`*^9}}],

Cell[BoxData[
 RowBox[{"ListContourPlot", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Flatten", "[", "xtab", "]"}], ",", 
      RowBox[{"Flatten", "[", "ytab", "]"}], ",", 
      RowBox[{"Log", "[", 
       RowBox[{"Flatten", "[", 
        RowBox[{"res2m", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"nm", ";;", "nx"}], ",", "All", ",", "1", ",", "1"}], 
          "]"}], "]"}], "]"}], "]"}]}], "}"}], "]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "2"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5589550347842836`*^9, 3.5589550608287735`*^9}}],

Cell[BoxData[
 RowBox[{"ListPlot3D", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Flatten", "[", "xtab", "]"}], ",", 
      RowBox[{"Flatten", "[", "ytab", "]"}], ",", 
      RowBox[{"Log", "[", 
       RowBox[{"Flatten", "[", 
        RowBox[{"res2m", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"nm", ";;", "nx"}], ",", "All", ",", "1", ",", "2"}], 
          "]"}], "]"}], "]"}], "]"}]}], "}"}], "]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", "2"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5589551352100277`*^9, 3.5589551373101473`*^9}, {
  3.558956348490423*^9, 3.5589563498785024`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"imp", "=", 
   RowBox[{
    RowBox[{
    "Import", "[", 
     "\"\<E:\\\\GRMHD\\\\Jon\\\\thickdisk7\\\\Tsmapthickdisk7.dat\>\"", "]"}],
     "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", 
      RowBox[{"1", ";;", "2"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rtabx", "=", 
   RowBox[{"imp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"U\[Rho]tab", "=", 
   FractionBox[
    RowBox[{"imp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "2"}], "]"}], "]"}], 
    RowBox[{
     RowBox[{"mp", "*", "cc", "*", 
      RowBox[{
       RowBox[{"cc", "/", "3"}], "/", "kb"}]}], "/.", "ruru"}]]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5589572563573503`*^9, 3.5589573130645933`*^9}}],

Cell[BoxData[{
 RowBox[{"Max", "[", 
  RowBox[{"res2m", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "All", ",", "1", ",", "2"}], "]"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Position", "[", 
   RowBox[{
    RowBox[{"res2m", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "All", ",", "1", ",", "2"}], "]"}], "]"}], ",", 
    RowBox[{"Max", "[", 
     RowBox[{"res2m", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "All", ",", "1", ",", "2"}], "]"}], "]"}], "]"}]}], 
   "]"}], "[", 
  RowBox[{"[", "1", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListLogPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"thtab", ",", 
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "All", ",", "1", ",", "2"}], "]"}], "]"}]}], 
        "}"}], "]"}], ",", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"thtab", ",", 
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"7", ",", "All", ",", "1", ",", "2"}], "]"}], "]"}]}], 
        "}"}], "]"}], ",", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"thtab", ",", 
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"12", ",", "All", ",", "1", ",", "2"}], "]"}], "]"}]}], 
        "}"}], "]"}]}], "}"}], ",", 
    RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListLogPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"thtab", ",", 
        FractionBox[
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "All", ",", "1", ",", "2"}], "]"}], "]"}], 
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "All", ",", "1", ",", "1"}], "]"}], "]"}]]}], 
       "}"}], "]"}], ",", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"thtab", ",", 
        FractionBox[
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"7", ",", "All", ",", "1", ",", "2"}], "]"}], "]"}], 
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"7", ",", "All", ",", "1", ",", "1"}], "]"}], "]"}]]}], 
       "}"}], "]"}], ",", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"thtab", ",", 
        FractionBox[
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"12", ",", "All", ",", "1", ",", "2"}], "]"}], "]"}], 
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"12", ",", "All", ",", "1", ",", "1"}], "]"}], "]"}]]}], 
       "}"}], "]"}], ",", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"thtab", ",", 
        FractionBox[
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"20", ",", "All", ",", "1", ",", "2"}], "]"}], "]"}], 
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{"20", ",", "All", ",", "1", ",", "1"}], "]"}], "]"}]]}], 
       "}"}], "]"}]}], "}"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Black", ",", "Blue", ",", "Green", ",", "Red"}], "}"}]}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\< \>\"", ",", 
   RowBox[{"U\[Rho]tab", "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", "\"\< \>\"", ",", 
   RowBox[{"U\[Rho]tab", "[", 
    RowBox[{"[", "7", "]"}], "]"}], ",", "\"\< \>\"", ",", 
   RowBox[{"U\[Rho]tab", "[", 
    RowBox[{"[", "12", "]"}], "]"}], ",", "\"\< \>\"", ",", 
   RowBox[{"U\[Rho]tab", "[", 
    RowBox[{"[", "20", "]"}], "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5589564803429646`*^9, 3.5589566234981527`*^9}, {
   3.558957059772106*^9, 3.5589570806923027`*^9}, {3.558957205390435*^9, 
   3.5589572452977176`*^9}, 3.5589572979967318`*^9, {3.5589574236549187`*^9, 
   3.5589574595779734`*^9}, {3.5589575355913215`*^9, 3.5589575899444304`*^9}}],

Cell[BoxData[{
 RowBox[{"rtab", "[", 
  RowBox[{"[", "1", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"rtab", "[", 
  RowBox[{"[", "7", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"rtab", "[", 
  RowBox[{"[", "12", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"rtab", "[", 
  RowBox[{"[", "20", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.558957509236814*^9, 3.5589575275038586`*^9}, {
  3.5589575949837184`*^9, 3.5589575964358015`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"cpl1", "=", 
    RowBox[{"ListContourPlot", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Flatten", "[", "xtab", "]"}], ",", 
         RowBox[{"Flatten", "[", "ytab", "]"}], ",", 
         RowBox[{"Log", "[", 
          RowBox[{"Flatten", "[", 
           FractionBox[
            RowBox[{"res2m", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"nm", ";;", "nx"}], ",", "All", ",", "1", ",", "2"}], 
              "]"}], "]"}], 
            RowBox[{"res2m", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"nm", ";;", "nx"}], ",", "All", ",", "1", ",", "1"}], 
              "]"}], "]"}]], "]"}], "]"}]}], "}"}], "]"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
      RowBox[{"AspectRatio", "\[Rule]", "2"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
      RowBox[{"Contours", "\[Rule]", "30"}]}], "]"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"cpl2", "=", 
    RowBox[{"ListContourPlot", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Flatten", "[", "xtab", "]"}], ",", 
         RowBox[{"Flatten", "[", "ytab", "]"}], ",", 
         RowBox[{"Log", "[", 
          RowBox[{"Log", "[", 
           RowBox[{"1", "+", 
            RowBox[{"Flatten", "[", 
             FractionBox[
              RowBox[{"res2m", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"nm", ";;", "nx"}], ",", "All", ",", "1", ",", "2"}],
                 "]"}], "]"}], 
              RowBox[{"res2m", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"nm", ";;", "nx"}], ",", "All", ",", "1", ",", "1"}],
                 "]"}], "]"}]], "]"}]}], "]"}], "]"}]}], "}"}], "]"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
      RowBox[{"AspectRatio", "\[Rule]", "2"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "300"}], ",", 
      RowBox[{"Contours", "\[Rule]", "30"}]}], "]"}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.5589552411060843`*^9, 3.5589552431231995`*^9}, {
  3.558955373273644*^9, 3.558955387598463*^9}, {3.5589554241785555`*^9, 
  3.5589554515171194`*^9}, {3.5589694694228973`*^9, 3.5589694791644545`*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.558969826047295*^9, 3.558969835637844*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dcos1", "=", "0.02"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Angle = \>\"", ",", 
    RowBox[{
     FractionBox["180", "\[Pi]"], 
     RowBox[{"ArcCos", "[", 
      RowBox[{"1", "-", "dcos1"}], "]"}]}], ",", "\"\<\[Degree]\>\""}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dcos2", "=", "0.05"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Angle = \>\"", ",", 
    RowBox[{
     FractionBox["180", "\[Pi]"], 
     RowBox[{"ArcCos", "[", 
      RowBox[{"1", "-", "dcos2"}], "]"}]}], ",", "\"\<\[Degree]\>\""}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dcos3", "=", "0.1"}], ";", 
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Angle = \>\"", ",", 
    RowBox[{
     FractionBox["180", "\[Pi]"], 
     RowBox[{"ArcCos", "[", 
      RowBox[{"1", "-", "dcos3"}], "]"}]}], ",", "\"\<\[Degree]\>\""}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
  "\"\<Jet boundary from numerical simulations at 50M radius: \>\"", ",", 
   RowBox[{
    FractionBox["180", "\[Pi]"], 
    RowBox[{"ArcTan", "[", 
     FractionBox["16.", "50"], "]"}]}], ",", "\"\<\[Degree]\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rx", "=", 
   RowBox[{"rtab", "[", 
    RowBox[{"[", "nx", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl1", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Cot", "[", 
         RowBox[{"ArcCos", "[", 
          RowBox[{"1", "-", "dcos1"}], "]"}], "]"}], "t"}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Cot", "[", 
          RowBox[{"ArcCos", "[", 
           RowBox[{"1", "-", "dcos1"}], "]"}], "]"}]}], "t"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "rx"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "rx"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "rx"}], ",", "rx"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "2"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "3", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", 
          RowBox[{"AbsoluteThickness", "[", "3", "]"}]}], "}"}]}], "}"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl2", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Cot", "[", 
         RowBox[{"ArcCos", "[", 
          RowBox[{"1", "-", "dcos2"}], "]"}], "]"}], "t"}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Cot", "[", 
          RowBox[{"ArcCos", "[", 
           RowBox[{"1", "-", "dcos2"}], "]"}], "]"}]}], "t"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "rx"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "rx"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "rx"}], ",", "rx"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "2"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Red", ",", 
          RowBox[{"AbsoluteThickness", "[", "3", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Red", ",", 
          RowBox[{"AbsoluteThickness", "[", "3", "]"}]}], "}"}]}], "}"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pl3", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Cot", "[", 
         RowBox[{"ArcCos", "[", 
          RowBox[{"1", "-", "dcos3"}], "]"}], "]"}], "t"}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Cot", "[", 
          RowBox[{"ArcCos", "[", 
           RowBox[{"1", "-", "dcos3"}], "]"}], "]"}]}], "t"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "rx"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "rx"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "rx"}], ",", "rx"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "2"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Green", ",", 
          RowBox[{"AbsoluteThickness", "[", "3", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Green", ",", 
          RowBox[{"AbsoluteThickness", "[", "3", "]"}]}], "}"}]}], "}"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"cpl1", ",", "pl1", ",", "pl2", ",", "pl3"}], "]"}]}], "Input",
 CellChangeTimes->{{3.558969490771118*^9, 3.5589695000896516`*^9}, {
  3.5589696574216504`*^9, 3.558969687053345*^9}, {3.558969751698043*^9, 
  3.558969866410604*^9}, {3.5589699929808435`*^9, 3.558970073577453*^9}, {
  3.558970196165465*^9, 3.558970295837166*^9}, {3.558970413634903*^9, 
  3.55897043577617*^9}}],

Cell[BoxData[
 RowBox[{"Dimensions", "[", "res2m", "]"}]], "Input",
 CellChangeTimes->{{3.558954970990635*^9, 3.558954973825797*^9}}],

Cell[BoxData[{
 RowBox[{
  FractionBox["180", "\[Pi]"], 
  RowBox[{"ArcCos", "[", 
   RowBox[{"1", "-", "0.02"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox["180", "\[Pi]"], 
  RowBox[{"ArcCos", "[", 
   RowBox[{"1", "-", "0.05"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox["180", "\[Pi]"], 
  RowBox[{"ArcCos", "[", 
   RowBox[{"1", "-", "0.1"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.55896412877843*^9, 3.558964152332777*^9}, {
  3.5589652327615747`*^9, 3.5589652364477854`*^9}}],

Cell[BoxData[{
 FractionBox["0.249", "0.194"], "\[IndentingNewLine]", 
 FractionBox["1.484", "1.101"], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5589664960018277`*^9, 3.558966525980542*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   SuperscriptBox["1000", "2"], 
   RowBox[{"4", "\[Pi]", " ", 
    SuperscriptBox["10", "6.5"], "mp", " ", 
    SuperscriptBox["cc", "2"]}]], "/.", "ruru"}]], "Input",
 CellChangeTimes->{{3.558965749183112*^9, 3.558965768091193*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["m_space functions", "Section",
 CellChangeTimes->{{3.528656313069495*^9, 3.528656320636928*^9}}],

Cell[CellGroupData[{

Cell["Minimization of \[Chi]^2", "Subsection",
 CellChangeTimes->{{3.5286615330930634`*^9, 3.528661543588664*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"matrix", " ", "inversion"}], "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{"ord", "=", "2"}], ";", 
    RowBox[{"ma", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"matr", "[", "i", "]"}], "[", "j", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{"ord", "-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "0", ",", 
         RowBox[{"ord", "-", "1"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"bta", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"bb", "[", "i", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{"ord", "-", "1"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{
      RowBox[{"Inverse", "[", "ma", "]"}], ".", "bta"}]}], "//", 
    "MatrixForm"}]}]}]], "Input",
 CellChangeTimes->{{3.5286615610636635`*^9, 3.5286615656139235`*^9}, {
  3.5286617147424536`*^9, 3.528661828214944*^9}, {3.5286618797478914`*^9, 
  3.528661909345584*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ord", "=", "3"}], ";", 
  RowBox[{"ma", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"matr", "[", "i", "]"}], "[", "j", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "0", ",", 
       RowBox[{"ord", "-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "0", ",", 
       RowBox[{"ord", "-", "1"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"bta", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"bb", "[", "i", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "0", ",", 
       RowBox[{"ord", "-", "1"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"den", "=", 
   RowBox[{"Denominator", "[", 
    RowBox[{
     RowBox[{"Inverse", "[", "ma", "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"fuss", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "det"}], " ", 
     RowBox[{
      RowBox[{"Inverse", "[", "ma", "]"}], ".", "bta"}]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "/", "den"}], "\[Rule]", 
      RowBox[{"1", "/", "det"}]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"InputForm", "[", "den", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"InputForm", "[", 
     RowBox[{"fuss", "[", 
      RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "ord"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.528662168248392*^9, 3.528662240098502*^9}, {
  3.5286688502835827`*^9, 3.5286689279810266`*^9}, {3.5286689813680806`*^9, 
  3.5286690655288944`*^9}, {3.528669297426158*^9, 3.5286693648570147`*^9}, {
  3.5286695224100266`*^9, 3.528669522489031*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["m_conv functions", "Section",
 CellChangeTimes->{{3.5286789804974313`*^9, 3.528678983377596*^9}}],

Cell[CellGroupData[{

Cell["test steps for minimization of square sums", "Subsection",
 CellChangeTimes->{{3.528678986697786*^9, 3.528679011609211*^9}}],

Cell[CellGroupData[{

Cell["averaged over 3", "Subsubsection",
 CellChangeTimes->{{3.528730092801629*^9, 3.5287300977529125`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"dheat", " ", "step"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"stheat", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.192", ",", "6.67601"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.096", ",", "2.67034"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.048", ",", "0.69097"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.024", ",", "0.17334"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.012", ",", "0.04627"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.006", ",", "0.01321"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.003", ",", "0.00402"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.0015", ",", "0.00114"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"afin", "=", 
     RowBox[{"a", "/.", 
      RowBox[{"FindFit", "[", 
       RowBox[{"stheat", ",", 
        RowBox[{"a", " ", 
         SuperscriptBox["x", "2"]}], ",", 
        RowBox[{"{", "a", "}"}], ",", "x"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lpl", "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"stheat", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"pl", "=", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{
       RowBox[{"1.6", "afin", " ", 
        SuperscriptBox["x", "2"]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"stheat", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"stheat", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Blue"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{"pl", ",", "lpl", ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
     RowBox[{
     "PlotLabel", "\[Rule]", 
      "\"\<\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\) vs dheat\>\""}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.528679021575781*^9, 3.5286791444118066`*^9}, {
  3.528679219164082*^9, 3.5286792641886573`*^9}, {3.5286793107553205`*^9, 
  3.5286794800400033`*^9}, {3.5286796256243305`*^9, 3.5286796294565496`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"drho", " ", "step"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"strho", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.16", ",", "1.49231"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.08", ",", "0.56627"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.04", ",", "0.17515"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.02", ",", "0.04414"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.01", ",", "0.01266"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.005", ",", "0.00302"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.0025", ",", "0.00154"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"afin", "=", 
     RowBox[{"a", "/.", 
      RowBox[{"FindFit", "[", 
       RowBox[{"strho", ",", 
        RowBox[{"a", " ", 
         SuperscriptBox["x", "2"]}], ",", 
        RowBox[{"{", "a", "}"}], ",", "x"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lpl", "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"strho", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"pl", "=", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{
       RowBox[{"1.85", "afin", " ", 
        SuperscriptBox["x", "2"]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"strho", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"strho", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Blue"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{"pl", ",", "lpl", ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
     RowBox[{
     "PlotLabel", "\[Rule]", 
      "\"\<\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\) vs drho\>\""}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.528679021575781*^9, 3.5286791444118066`*^9}, {
   3.528679219164082*^9, 3.5286792641886573`*^9}, {3.5286793107553205`*^9, 
   3.5286794800400033`*^9}, {3.5286796256243305`*^9, 
   3.5286796529908953`*^9}, {3.528679918375075*^9, 3.528680004503001*^9}, 
   3.5286800946651583`*^9, {3.528680333369811*^9, 3.5286804310884*^9}, {
   3.5286805863422804`*^9, 3.5286805882703905`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"dtheta", " ", "step"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"sttheta", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.08", ",", "2.42186"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.04", ",", "0.53909"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.02", ",", "0.53535"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.01", ",", "0.18599"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.005", ",", "0.07712"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.0025", ",", "0.20468"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.00125", ",", "0.09617"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.000625", ",", "0.01878"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"afin", "=", 
     RowBox[{"a", "/.", 
      RowBox[{"FindFit", "[", 
       RowBox[{"sttheta", ",", 
        RowBox[{"a", " ", 
         SuperscriptBox["x", "2"]}], ",", 
        RowBox[{"{", "a", "}"}], ",", "x"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lpl", "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"sttheta", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"pl", "=", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{
       RowBox[{"4", "afin", " ", 
        SuperscriptBox["x", "2"]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"sttheta", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"sttheta", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Blue"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{"pl", ",", "lpl", ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
     RowBox[{
     "PlotLabel", "\[Rule]", 
      "\"\<\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\) vs dtheta\>\""}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.528679021575781*^9, 3.5286791444118066`*^9}, {
   3.528679219164082*^9, 3.5286792641886573`*^9}, {3.5286793107553205`*^9, 
   3.5286794800400033`*^9}, {3.5286796256243305`*^9, 
   3.5286796529908953`*^9}, {3.528679918375075*^9, 3.528680004503001*^9}, 
   3.5286800946651583`*^9, {3.528680333369811*^9, 3.5286804310884*^9}, {
   3.5286805863422804`*^9, 3.528680640199361*^9}, 3.5286807704888124`*^9, 
   3.528681043578433*^9, 3.5286813160570173`*^9, {3.5286814274963913`*^9, 
   3.528681463031424*^9}, 3.528681576897937*^9, 3.528681851307632*^9, 
   3.528682239032809*^9, 3.5286825291694036`*^9, {3.5286828274884663`*^9, 
   3.5286828524878964`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["averaged over 11", "Subsubsection",
 CellChangeTimes->{{3.528730092801629*^9, 3.528730114552873*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"dheat", " ", "step"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"stheat", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.192", ",", "7.48061"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.096", ",", "1.80863"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.048", ",", "0.42979"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.024", ",", "0.10569"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.012", ",", "0.02651"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.006", ",", "0.00697"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.003", ",", "0.00186"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.0015", ",", "0.00044"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"afin", "=", 
     RowBox[{"a", "/.", 
      RowBox[{"FindFit", "[", 
       RowBox[{"stheat", ",", 
        RowBox[{"a", " ", 
         SuperscriptBox["x", "2"]}], ",", 
        RowBox[{"{", "a", "}"}], ",", "x"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lpl", "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"stheat", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"pl", "=", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{
       RowBox[{"0.95", "afin", " ", 
        SuperscriptBox["x", "2"]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"stheat", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"stheat", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Blue"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{"pl", ",", "lpl", ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
     RowBox[{
     "PlotLabel", "\[Rule]", 
      "\"\<\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\) vs dheat\>\""}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.528679021575781*^9, 3.5286791444118066`*^9}, {
   3.528679219164082*^9, 3.5286792641886573`*^9}, {3.5286793107553205`*^9, 
   3.5286794800400033`*^9}, {3.5286796256243305`*^9, 3.5286796294565496`*^9}, 
   3.528730227873355*^9, 3.528730272664917*^9, {3.5287303163204136`*^9, 
   3.528730333681407*^9}, 3.528730363848132*^9, {3.5287304749134846`*^9, 
   3.528730510866541*^9}, {3.528730869992082*^9, 3.5287308821517773`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"drho", " ", "step"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"strho", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.32", ",", "6.57651"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.16", ",", "1.48534"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.08", ",", "0.33530"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.04", ",", "0.08119"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.02", ",", "0.01985"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.01", ",", "0.00540"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.005", ",", "0.00151"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.0025", ",", "0.00041"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"afin", "=", 
     RowBox[{"a", "/.", 
      RowBox[{"FindFit", "[", 
       RowBox[{"strho", ",", 
        RowBox[{"a", " ", 
         SuperscriptBox["x", "2"]}], ",", 
        RowBox[{"{", "a", "}"}], ",", "x"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lpl", "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"strho", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"pl", "=", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{
       RowBox[{"0.8", "afin", " ", 
        SuperscriptBox["x", "2"]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"strho", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"strho", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Blue"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{"pl", ",", "lpl", ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
     RowBox[{
     "PlotLabel", "\[Rule]", 
      "\"\<\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\) vs drho\>\""}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.528679021575781*^9, 3.5286791444118066`*^9}, {
   3.528679219164082*^9, 3.5286792641886573`*^9}, {3.5286793107553205`*^9, 
   3.5286794800400033`*^9}, {3.5286796256243305`*^9, 
   3.5286796529908953`*^9}, {3.528679918375075*^9, 3.528680004503001*^9}, 
   3.5286800946651583`*^9, {3.528680333369811*^9, 3.5286804310884*^9}, {
   3.5286805863422804`*^9, 3.5286805882703905`*^9}, {3.528730647968383*^9, 
   3.528730650751542*^9}, {3.5287307066167374`*^9, 3.5287307438568673`*^9}, {
   3.528730804696347*^9, 3.5287308595044823`*^9}, {3.528730958904167*^9, 
   3.528731030041236*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"dtheta", " ", "step"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"sttheta", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.08", ",", "1.06372"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.04", ",", "0.52826"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.02", ",", "0.13402"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.01", ",", "0.06745"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.005", ",", "0.03317"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.0025", ",", "0.03555"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.00125", ",", "0.01417"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.000625", ",", "0.00258"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"afin", "=", 
     RowBox[{"a", "/.", 
      RowBox[{"FindFit", "[", 
       RowBox[{"sttheta", ",", 
        RowBox[{"a", " ", 
         SuperscriptBox["x", "2"]}], ",", 
        RowBox[{"{", "a", "}"}], ",", "x"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lpl", "=", 
     RowBox[{"ListLogLogPlot", "[", 
      RowBox[{"sttheta", ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"pl", "=", 
     RowBox[{"LogLogPlot", "[", 
      RowBox[{
       RowBox[{"4", "afin", " ", 
        SuperscriptBox["x", "2"]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"sttheta", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"sttheta", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Blue"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{"pl", ",", "lpl", ",", 
     RowBox[{"Frame", "\[Rule]", "True"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
     RowBox[{
     "PlotLabel", "\[Rule]", 
      "\"\<\!\(\*SuperscriptBox[\(\[Chi]\), \(2\)]\) vs dtheta\>\""}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.528679021575781*^9, 3.5286791444118066`*^9}, {
   3.528679219164082*^9, 3.5286792641886573`*^9}, {3.5286793107553205`*^9, 
   3.5286794800400033`*^9}, {3.5286796256243305`*^9, 
   3.5286796529908953`*^9}, {3.528679918375075*^9, 3.528680004503001*^9}, 
   3.5286800946651583`*^9, {3.528680333369811*^9, 3.5286804310884*^9}, {
   3.5286805863422804`*^9, 3.528680640199361*^9}, 3.5286807704888124`*^9, 
   3.528681043578433*^9, 3.5286813160570173`*^9, {3.5286814274963913`*^9, 
   3.528681463031424*^9}, 3.528681576897937*^9, 3.528681851307632*^9, 
   3.528682239032809*^9, 3.5286825291694036`*^9, {3.5286828274884663`*^9, 
   3.5286828524878964`*^9}, {3.528731136952351*^9, 3.528731234728944*^9}}]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Evolving the simulation along the geodesics Feb2012", "Section",
 CellChangeTimes->{{3.5386740721726365`*^9, 3.538674095068946*^9}, {
  3.5386741321250653`*^9, 3.538674140372537*^9}}],

Cell["\<\
6850 - 6950=6900+/-50  - simulation numbers, whereas times are \
13700-13900=13800+/-100 M with time step 2M; can also try time step 4M.
Geodesics start at t=0 at certain location and are near the BH some time \
around t=1;
timescales should be multiplied by 20,000 to get time in M, and multiplied by \
10,000 to get time in \[CloseCurlyDoubleQuote]fnum\[CloseCurlyDoubleQuote].
Thus, need to consider times from tmin=0.995 till tmax=1.005
fdiff=50;//subject to change from 0 to 50; at fdiff=0 - dealing with a single \
snapshot.
fnmin=fnum-fdiff;// corresponds to tmax; for t>tmax - use fnmin snapshot
fnmax=fnum+fdiff;//corresponds to tmin; for t<tmin - use fnmax snapshot.
Multilinear in time - find nearest 2 neighbours and interpolate.\
\>", "Text",
 CellChangeTimes->{{3.538674106210583*^9, 3.538674128916882*^9}, {
   3.538674229011607*^9, 3.538674305516983*^9}, {3.538674345187252*^9, 
   3.5386744412977495`*^9}, {3.538674654555947*^9, 3.538674691144039*^9}, {
   3.5386747220728083`*^9, 3.5386747279371443`*^9}, {3.538674767577411*^9, 
   3.5386748279028616`*^9}, {3.538674857991583*^9, 3.53867490130206*^9}, {
   3.5386759272877426`*^9, 3.5386759751194787`*^9}, 3.538676419276883*^9, {
   3.5386765190675907`*^9, 3.5386766223544984`*^9}}],

Cell[BoxData[{
 RowBox[{"1", "+", 
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{"Sinh", "[", 
     RowBox[{"-", "9.498"}], "]"}]}], "20000"]}], "\[IndentingNewLine]", 
 RowBox[{"1", "+", 
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{"Sinh", "[", "9.5", "]"}]}], "20000"]}]}], "Input",
 CellChangeTimes->{{3.53867635576225*^9, 3.538676393084385*^9}}],

Cell[BoxData[
 RowBox[{"81", " ", "4", " ", "32", " ", "64", " ", "256", " ", 
  "11"}]], "Input",
 CellChangeTimes->{{3.538677095728574*^9, 3.538677118322866*^9}, {
  3.538678469778165*^9, 3.5386784698731704`*^9}}],

Cell[BoxData["2147483647"], "Input",
 CellChangeTimes->{{3.538678466899*^9, 3.5386784669010005`*^9}}],

Cell[BoxData[
 RowBox[{"Print", "[", 
  RowBox[{
   RowBox[{"N", "[", 
    RowBox[{"Integrate", "[", 
     RowBox[{
      RowBox[{
       FractionBox["1", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox["rg", "r"]}]]], "-", "1"}], ",", 
      RowBox[{"{", 
       RowBox[{"r", ",", "rg", ",", 
        RowBox[{"20000", "rg"}]}], "}"}], ",", 
      RowBox[{"GenerateConditions", "\[Rule]", "False"}]}], "]"}], "]"}], 
   ",", "\"\< - time difference for ray propagation with/without the \
BH\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.538712276413794*^9, 3.53871238036874*^9}, {
  3.5387124545449824`*^9, 3.5387124739170904`*^9}}],

Cell[BoxData[
 FractionBox["92", "1.5"]], "Input",
 CellChangeTimes->{{3.538753955775166*^9, 3.5387539583533134`*^9}}],

Cell[CellGroupData[{

Cell["Throughput", "Subsection",
 CellChangeTimes->{{3.5388281047004213`*^9, 3.5388281089476643`*^9}}],

Cell[BoxData[{
 RowBox[{
  FractionBox[
   RowBox[{"5", 
    RowBox[{"(*", "spins", "*)"}], "7", 
    RowBox[{"(*", "models", "*)"}], "21", 
    RowBox[{"(*", "periods", "*)"}], "120", 
    RowBox[{"(*", "snapshots", "*)"}], "4", 
    RowBox[{"(*", 
     RowBox[{"computations", " ", "of", " ", "spectrum"}], "*)"}], "23", 
    RowBox[{"(*", 
     RowBox[{"MB", " ", "-", " ", 
      RowBox[{"size", " ", "of", " ", "snapshot"}]}], "*)"}]}], 
   RowBox[{"3", " ", "60", " ", "60."}]], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"MB", "/", "sec"}], " ", "-", " ", "actual"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"5", " ", "7", 
   FractionBox[
    RowBox[{"120", " ", "23"}], "60."]}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"MB", "/", "sec"}], " ", "-", " ", "needed"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{
   RowBox[{"CPUhrs", "=", 
    RowBox[{
     FractionBox["1.", "3600"], "4", 
     RowBox[{"(*", "cores", "*)"}], "41", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"s", " ", "-", " ", 
        RowBox[{
        "per", " ", "single", " ", "computation", " ", "on", " ", "4", " ", 
         "cores"}]}], ";"}], " ", "*)"}], "21", 
     RowBox[{"(*", "evaluations", "*)"}], "40", 
     RowBox[{"(*", 
      RowBox[{"values", " ", "of", " ", "temperature"}], "*)"}], 
     RowBox[{"(", 
      RowBox[{"7", "+", "6"}], ")"}], 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"values", " ", "of", " ", "density"}], " ", "+", " ", 
       "convergence"}], "*)"}], "50", 
     RowBox[{"(*", 
      RowBox[{"values", " ", "of", " ", "inclination", " ", "angle"}], "*)"}], 
     RowBox[{"(", 
      RowBox[{"5", "+", "6"}], ")"}]}]}], 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"values", " ", "of", " ", "spin"}], " ", "+", " ", 
     "convergence"}], "*)"}], ",", "\"\< CPU-hours\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Can run \>\"", ",", 
   RowBox[{"jobs", "=", "20"}], 
   RowBox[{"(*", 
    RowBox[{"4", "-", 
     RowBox[{"core", " ", "jobs"}]}], "*)"}], ",", 
   "\"\< 4-core jobs in parallel\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<Then computation is done in \>\"", ",", 
   FractionBox["CPUhrs", 
    RowBox[{"4.", " ", "jobs", " ", "24", 
     RowBox[{"(*", 
      RowBox[{"hrs", " ", "a", " ", "day"}], "*)"}]}]], ",", 
   "\"\< days\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Print", "[", 
  RowBox[{"\"\<One thread needs \>\"", ",", 
   RowBox[{
    FractionBox["1.", 
     RowBox[{"24", " ", "3600"}]], "41", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"s", " ", "-", " ", 
       RowBox[{
       "per", " ", "single", " ", "computation", " ", "on", " ", "4", " ", 
        "cores"}]}], ";"}], " ", "*)"}], "21", 
    RowBox[{"(*", "evaluations", "*)"}], " ", "40", 
    RowBox[{"(*", 
     RowBox[{"values", " ", "of", " ", "temperature"}], "*)"}], 
    RowBox[{"(", 
     RowBox[{"7", "+", "6"}], ")"}]}], 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"values", " ", "of", " ", "density"}], " ", "+", " ", 
     "convergence"}], "*)"}], ",", "\"\< days\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "3", "hr10min", " ", "for", " ", "13", "x21", " ", "evaluations"}], " ", 
    "\[Implies]", " ", 
    RowBox[{"41", "s", " ", "per", " ", "evaluation"}]}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.538828119320257*^9, 3.538828193817518*^9}, {
  3.5388283158714995`*^9, 3.5388283370737123`*^9}, {3.538828512553749*^9, 
  3.53882855260804*^9}, {3.539559042400628*^9, 3.5395590575638547`*^9}, {
  3.5395591046759377`*^9, 3.5395591685268497`*^9}, {3.539559327273729*^9, 
  3.539559449156743*^9}, {3.5395594928680196`*^9, 3.539559530136485*^9}, {
  3.5395595809613743`*^9, 3.53955963007026*^9}, {3.5395597025167875`*^9, 
  3.5395597304252367`*^9}, {3.539559991226495*^9, 3.5395599971545053`*^9}, {
  3.539560311885058*^9, 3.5395603292010884`*^9}, {3.539560368091957*^9, 
  3.539560453954508*^9}}],

Cell[BoxData[
 RowBox[{"60", 
  FractionBox[
   RowBox[{
    RowBox[{"3", " ", "60"}], "+", "10"}], 
   RowBox[{"13", " ", "21."}]]}]], "Input",
 CellChangeTimes->{{3.5395603331322956`*^9, 3.539560364784751*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Characterizing best fits", "Subsection",
 CellChangeTimes->{{3.5403091500990515`*^9, 3.5403091552103443`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"if", 
   RowBox[{"(", 
    RowBox[{"sp", "\[Equal]", "0"}], ")"}], 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rhonor", "=", "1030713.25"}], ";", 
     RowBox[{"heat", "=", "0.42107"}], ";", 
     RowBox[{"th", "=", "0.7328"}], ";", 
     RowBox[{"fdiff", "=", "60"}], ";"}], "}"}]}], "//", "4.2802"}], "\n", 
 RowBox[{
  RowBox[{"if", 
   RowBox[{"(", 
    RowBox[{"sp", "\[Equal]", "1"}], ")"}], 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rhonor", "=", "988988.82"}], ";", 
     RowBox[{"heat", "=", "0.37012"}], ";", 
     RowBox[{"th", "=", "1.8407"}], ";", 
     RowBox[{"fdiff", "=", "60"}], ";"}], "}"}]}], "//", "2.9363"}], "\n", 
 RowBox[{
  RowBox[{"if", 
   RowBox[{"(", 
    RowBox[{"sp", "\[Equal]", "2"}], ")"}], 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rhonor", "=", "817113.52"}], ";", 
     RowBox[{"heat", "=", "0.37239"}], ";", 
     RowBox[{"th", "=", "2.0159"}], ";", 
     RowBox[{"fdiff", "=", "60"}], ";"}], "}"}]}], "//", "3.0837"}], "\n", 
 RowBox[{
  RowBox[{"if", 
   RowBox[{"(", 
    RowBox[{"sp", "\[Equal]", "3"}], ")"}], 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rhonor", "=", "656228.94"}], ";", 
     RowBox[{"heat", "=", "0.39849"}], ";", 
     RowBox[{"th", "=", "2.2074"}], ";", 
     RowBox[{"fdiff", "=", "60"}], ";"}], "}"}]}], "//", "4.1912"}], "\n", 
 RowBox[{
  RowBox[{"if", 
   RowBox[{"(", 
    RowBox[{"sp", "\[Equal]", "4"}], ")"}], 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rhonor", "=", "397281.19"}], ";", 
     RowBox[{"heat", "=", "0.41343"}], ";", 
     RowBox[{"th", "=", "2.1439"}], ";", 
     RowBox[{"fdiff", "=", "60"}], ";"}], "}"}]}], "//", "3.0059"}]}], "Input",
 CellChangeTimes->{{3.540309155962387*^9, 3.5403091601496267`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["180", "\[Pi]"], 
  RowBox[{"(", 
   RowBox[{"\[Pi]", "-", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[Pi]", "-", "0.7328"}], ",", "1.8407", ",", "2.0159", ",", 
      "2.2074", ",", "2.1439"}], "}"}]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.540309162147741*^9, 3.540309200923959*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["de", "Section",
 CellChangeTimes->{{3.4841391124778*^9, 3.484139114849*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[Pi]", "/", "2."}], "*", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", "*", "cas"}], "-", "1"}], ")"}], "/", "30"}]}], "/.", 
  RowBox[{"cas", "\[Rule]", "21"}]}]], "Input",
 CellChangeTimes->{{3.4841391514622*^9, 3.4841391656582003`*^9}, {
  3.4842679354554*^9, 3.484267935627*^9}, {3.4842680780706*^9, 
  3.4842680782422*^9}, {3.4843807399816*^9, 3.4843807400439997`*^9}, {
  3.484390987216*^9, 3.4843909897276*^9}, {3.4844138946064*^9, 
  3.48441389704*^9}, {3.4844140674076*^9, 3.4844140712608*^9}, {
  3.4846188120906*^9, 3.4846188285018*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", "=", "\"\<G:\\\\mathematica\\\\3DMHD\\\\a\>\""}], ";", 
  RowBox[{"atab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
     ",", "\"\<098\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", "n_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", "=", 
      RowBox[{"dir", "<>", 
       RowBox[{"atab", "[", 
        RowBox[{"[", "n", "]"}], "]"}], "<>", 
       "\"\<\\\\fieldline00-1.bin\>\""}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"fi11", "=", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", 
        RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Character8\>\"", ",", "374"}], "]"}], 
         "]"}], "]"}], ";"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"res2m", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"BinaryReadList", "[", 
               RowBox[{"fi11", ",", "\"\<Real32\>\"", ",", 
                RowBox[{"11", "*", "32", "*", "64", "*", "256"}]}], "]"}], 
              ",", "11"}], "]"}], ",", "256"}], "]"}], ",", "64"}], "]"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Close", "[", "namefile", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"namefile", " ", "=", 
      RowBox[{"dir", "<>", 
       RowBox[{"atab", "[", 
        RowBox[{"[", "n", "]"}], "]"}], "<>", 
       "\"\<\\\\fieldline0000.bin\>\""}]}], ";", "\n", "   ", 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "256", "*", "64", "*", "32", "*", "4"}]}], ";", "\n",
      "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\n", "   ", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"res2m", " ", "=", " ", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"llist", " ", "=", " ", 
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"Partition", "[", 
                RowBox[{
                 RowBox[{"BinaryReadList", "[", 
                  RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                   RowBox[{"11", "*", "32", "*", "64", "*", "256"}]}], "]"}], 
                 ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], ",", " ", 
             "64"}], "]"}]}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], 
           "}"}]}], "]"}]}], ";"}], "*)"}], "\n", "   ", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], "\n", 
 RowBox[{"read11", "[", "3", "]"}]}], "Input",
 CellChangeTimes->{{3.484313790834*^9, 3.4843137909119997`*^9}, {
  3.4843138433436003`*^9, 3.4843138545912*^9}, {3.4843145887878*^9, 
  3.4843146010025997`*^9}, {3.4843149258414*^9, 3.4843149426738*^9}, {
  3.484381920184*^9, 3.4843819244896*^9}}],

Cell[BoxData[{
 RowBox[{"Total", "[", 
  RowBox[{
   RowBox[{"res2m", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "All", ",", "All", ",", "All"}], "]"}], "]"}], ",", 
   "3"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Union", "[", 
   RowBox[{"Flatten", "[", "res2m", "]"}], "]"}], "[", 
  RowBox[{"[", 
   RowBox[{
    RowBox[{"-", "100"}], ";;", 
    RowBox[{"-", "1"}]}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.4843137950148*^9, 3.48431383974*^9}, {
  3.4843819325236*^9, 3.4843819895572*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Check spin 0.5 simulation", "Section",
 CellChangeTimes->{{3.5057382470386*^9, 3.5057382495346003`*^9}, {
  3.505738371199*^9, 3.5057383747246*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "dir", "=", "\"\<G:\\\\GRMHD\\\\a05\\\\fieldlines\\\\1\\\\fieldline\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dir", "=", 
   "\"\<G:\\\\GRMHD\\\\a05\\\\fieldlines\\\\new2\\\\fieldline\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dir", "=", 
   "\"\<G:\\\\GRMHD\\\\a05\\\\fieldlines\\\\new\\\\fieldline\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "dir", "=", 
   "\"\<G:\\\\GRMHD\\\\a05\\\\fieldlines\\\\new3\\\\fieldline\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", "n_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", "=", 
      RowBox[{"dir", "<>", 
       RowBox[{"ToString", "[", "n", "]"}], "<>", "\"\<.bin\>\""}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"fi11", "=", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", 
        RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "256", "*", "64", "*", "32", "*", "4"}]}], ";", "\n",
      "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\n", "   ", 
     RowBox[{"res2m", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"llist", " ", "=", " ", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"BinaryReadList", "[", 
                RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                 RowBox[{"11", "*", "32", "*", "64", "*", "256"}]}], "]"}], 
               ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], ",", " ", 
           "64"}], "]"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], "}"}]}], 
       "]"}]}], ";", "\n", "   ", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5057382510634003`*^9, 3.5057382524049997`*^9}, {
   3.5057383571745996`*^9, 3.505738421041*^9}, {3.5057385203038*^9, 
   3.5057385408178*^9}, {3.505738605667*^9, 3.505738611205*^9}, 
   3.5057387339614*^9, {3.5057625654198*^9, 3.5057625827826*^9}, {
   3.5060770727678003`*^9, 3.5060770736414003`*^9}, {3.506077354847*^9, 
   3.5060773549874*^9}, {3.5068664133618*^9, 3.5068664138297997`*^9}, {
   3.5079832724674*^9, 3.5079832932934*^9}, {3.5080745284252*^9, 
   3.5080745355699997`*^9}, {3.5081380505307736`*^9, 
   3.5081380530891733`*^9}, {3.508870726699421*^9, 3.508870728680421*^9}}],

Cell[BoxData[
 RowBox[{"Dimensions", "[", "res2m", "]"}]], "Input",
 CellChangeTimes->{{3.5057386226865997`*^9, 3.5057386269454*^9}}],

Cell[BoxData[
 RowBox[{"ListDensityPlot", "[", 
  RowBox[{
   RowBox[{"Log", "[", 
    RowBox[{"Transpose", "[", 
     RowBox[{"res2m", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"1", ";;", "160"}], ",", "32", ",", "All", ",", "1"}], "]"}], 
      "]"}], "]"}], "]"}], ",", 
   RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5057393440618*^9, 3.5057393559021997`*^9}, {
  3.505748574336*^9, 3.5057485759896*^9}, {3.5057511800148*^9, 
  3.505751202432*^9}, {3.5057512981535997`*^9, 3.5057513272476*^9}}],

Cell[BoxData[{
 RowBox[{"Dynamic", "[", "i", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"read11", "[", "i", "]"}], ";", 
    RowBox[{"ListDensityPlot", "[", 
     RowBox[{
      FractionBox[
       RowBox[{"Transpose", "[", 
        RowBox[{"res2m", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"1", ";;", "160"}], ",", "All", ",", "1", ",", "1"}], 
          "]"}], "]"}], "]"}], "20"], ",", 
      RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "4950", ",", "9950", ",", "100"}], "}"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.5057389427206*^9, 3.5057390312194*^9}, {
  3.5057392325685997`*^9, 3.5057392486366*^9}, {3.5057394678634*^9, 
  3.505739468035*^9}, {3.5057452478662*^9, 3.5057452782394*^9}}],

Cell[BoxData[
 RowBox[{"ListDensityPlot", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"Transpose", "[", 
     RowBox[{"res2m", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"1", ";;", "160"}], ",", "All", ",", "1", ",", "1"}], "]"}], 
      "]"}], "]"}], "20"], ",", 
   RowBox[{"Epilog", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Inset", "[", 
      RowBox[{
       RowBox[{"Style", "[", 
        RowBox[{"i", ",", "White", ",", "Bold", ",", "16"}], "]"}], ",", 
       RowBox[{"ImageScaled", "[", 
        RowBox[{"{", 
         RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}]}], "]"}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5057455446562*^9, 3.5057456734653997`*^9}}],

Cell[BoxData["ListAnimate"], "Input",
 CellChangeTimes->{{3.5057458408066*^9, 3.5057458424446*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Dynamic", "[", "i", "]"}], 
  RowBox[{"(*", 
   RowBox[{
   "\[Rho]", " ", "and", " ", "U", " ", "near", " ", "the", " ", "jump"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"read11", "[", "i", "]"}], ";", 
    RowBox[{"pl", "=", 
     RowBox[{"ListDensityPlot", "[", 
      RowBox[{
       RowBox[{"0.5", "+", 
        RowBox[{"0.2", 
         RowBox[{"Log", "[", 
          RowBox[{"Transpose", "[", 
           RowBox[{"res2m", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"1", ";;", "160"}], ",", "All", ",", "1", ",", "1"}], 
             "]"}], "]"}], "]"}], "]"}]}]}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Inset", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"i", ",", "White", ",", "Bold", ",", "16"}], "]"}], ",", 
           RowBox[{"ImageScaled", "[", 
            RowBox[{"{", 
             RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}]}], "]"}], "}"}]}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"plen", "=", 
     RowBox[{"ListDensityPlot", "[", 
      RowBox[{
       RowBox[{"1", "+", 
        RowBox[{"0.2", 
         RowBox[{"Log", "[", 
          RowBox[{"Transpose", "[", 
           RowBox[{"res2m", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"1", ";;", "160"}], ",", "All", ",", "1", ",", "2"}], 
             "]"}], "]"}], "]"}], "]"}]}]}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Inset", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"i", ",", "White", ",", "Bold", ",", "16"}], "]"}], ",", 
           RowBox[{"ImageScaled", "[", 
            RowBox[{"{", 
             RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}]}], "]"}], "}"}]}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}]}], "]"}]}], ";", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"\"\<G:\\\\GRMHD\\\\movies\\\\rate05\\\\img\>\"", "<>", 
       RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\<.jpg\>\""}], ",", 
      "pl"}], "]"}], ";", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"\"\<G:\\\\GRMHD\\\\movies\\\\rate05en\\\\img\>\"", "<>", 
       RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\<.jpg\>\""}], ",", 
      "plen"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "6550", 
     RowBox[{"(*", "4950", "*)"}], ",", "6950", 
     RowBox[{"(*", "9950", "*)"}], ",", "1"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5057453891242*^9, 3.505745391277*^9}, {
   3.5057456949622*^9, 3.5057456974894*^9}, {3.5057458926454*^9, 
   3.5057458944082003`*^9}, {3.505746428017*^9, 3.505746438001*^9}, {
   3.5057464882174*^9, 3.5057465051902*^9}, {3.505746536203*^9, 
   3.5057465687446003`*^9}, {3.5057466593494*^9, 3.5057467218898*^9}, {
   3.5057475498442*^9, 3.5057475517005997`*^9}, {3.5057512882632*^9, 
   3.5057512884504004`*^9}, {3.5057513444076*^9, 3.505751361942*^9}, {
   3.5057514422508*^9, 3.5057515163508*^9}, {3.5057517920495996`*^9, 
   3.5057518055903997`*^9}, {3.5057518488648*^9, 3.5057518503*^9}, 
   3.505752122598*^9, {3.5057521569491997`*^9, 3.505752166356*^9}, {
   3.5057584518948*^9, 3.5057584617852*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Dynamic", "[", "i", "]"}], 
  RowBox[{"(*", 
   RowBox[{
   "\[Rho]", " ", "and", " ", "U", " ", "over", " ", "the", " ", "whole", " ",
     "simulation"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"read11", "[", "i", "]"}], ";", 
    RowBox[{"pl", "=", 
     RowBox[{"ListDensityPlot", "[", 
      RowBox[{
       RowBox[{"0.5", "+", 
        RowBox[{"0.2", 
         RowBox[{"Log", "[", 
          RowBox[{"Transpose", "[", 
           RowBox[{"res2m", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"1", ";;", "160"}], ",", "All", ",", "1", ",", "1"}], 
             "]"}], "]"}], "]"}], "]"}]}]}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Inset", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"i", ",", "White", ",", "Bold", ",", "16"}], "]"}], ",", 
           RowBox[{"ImageScaled", "[", 
            RowBox[{"{", 
             RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}]}], "]"}], "}"}]}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"plen", "=", 
     RowBox[{"ListDensityPlot", "[", 
      RowBox[{
       RowBox[{"1", "+", 
        RowBox[{"0.2", 
         RowBox[{"Log", "[", 
          RowBox[{"Transpose", "[", 
           RowBox[{"res2m", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"1", ";;", "160"}], ",", "All", ",", "1", ",", "2"}], 
             "]"}], "]"}], "]"}], "]"}]}]}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Inset", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"i", ",", "White", ",", "Bold", ",", "16"}], "]"}], ",", 
           RowBox[{"ImageScaled", "[", 
            RowBox[{"{", 
             RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}]}], "]"}], "}"}]}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}]}], "]"}]}], ";", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"\"\<G:\\\\GRMHD\\\\movies\\\\rate05\\\\img\>\"", "<>", 
       RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\<.jpg\>\""}], ",", 
      "pl"}], "]"}], ";", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"\"\<G:\\\\GRMHD\\\\movies\\\\rate05en\\\\img\>\"", "<>", 
       RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\<.jpg\>\""}], ",", 
      "plen"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "4950", ",", "9950", ",", "10"}], "}"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.5057522184288*^9, 3.5057522264316*^9}, {
  3.5057584672764*^9, 3.5057584766675997`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "gamma", " ", "factor", " ", "near", " ", "the", " ", "jump", " ", "and", 
    " ", "in", " ", "the", " ", "whole", " ", "simulation"}], "*)"}], 
  RowBox[{
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"read11", "[", "i", "]"}], ";", 
      RowBox[{"plgam", "=", 
       RowBox[{"ListDensityPlot", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"Transpose", "[", 
           RowBox[{"res2m", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"1", ";;", "160"}], ",", "All", ",", "1", ",", "5"}], 
             "]"}], "]"}], "]"}], "]"}], ",", 
         RowBox[{"Epilog", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Inset", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"i", ",", "White", ",", "Bold", ",", "16"}], "]"}], ",", 
             RowBox[{"ImageScaled", "[", 
              RowBox[{"{", 
               RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}]}], "]"}], "}"}]}], 
         ",", 
         RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}], ",", 
         RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}]}], "]"}]}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{"\"\<G:\\\\GRMHD\\\\movies\\\\rate05gam\\\\img\>\"", "<>", 
         RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\<.jpg\>\""}], ",", 
        "plgam"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "6550", 
       RowBox[{"(*", "4950", "*)"}], ",", "6950", 
       RowBox[{"(*", "9950", "*)"}], ",", "1"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Do", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"read11", "[", "i", "]"}], ";", 
      RowBox[{"plgam", "=", 
       RowBox[{"ListDensityPlot", "[", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"Transpose", "[", 
           RowBox[{"res2m", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"1", ";;", "160"}], ",", "All", ",", "1", ",", "5"}], 
             "]"}], "]"}], "]"}], "]"}], ",", 
         RowBox[{"Epilog", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Inset", "[", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"i", ",", "White", ",", "Bold", ",", "16"}], "]"}], ",", 
             RowBox[{"ImageScaled", "[", 
              RowBox[{"{", 
               RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}]}], "]"}], "}"}]}], 
         ",", 
         RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}], ",", 
         RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}]}], "]"}]}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{"\"\<G:\\\\GRMHD\\\\movies\\\\rate05gam\\\\img\>\"", "<>", 
         RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\<.jpg\>\""}], ",", 
        "plgam"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "4950", ",", "9950", ",", "10"}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5057581808915997`*^9, 3.5057582283780003`*^9}, {
  3.5057583888708*^9, 3.5057583916008*^9}, {3.5057584289628*^9, 
  3.505758446466*^9}, {3.505758497634*^9, 3.505758549192*^9}}],

Cell[BoxData[{
 RowBox[{"ListDensityPlot", "[", 
  RowBox[{
   RowBox[{"0.5", "+", 
    RowBox[{"0.2", 
     RowBox[{"Log", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"res2m", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"1", ";;", "160"}], ",", "All", ",", "1", ",", "1"}], "]"}],
         "]"}], "]"}], "]"}]}]}], ",", 
   RowBox[{"Epilog", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Inset", "[", 
      RowBox[{
       RowBox[{"Style", "[", 
        RowBox[{"i", ",", "White", ",", "Bold", ",", "16"}], "]"}], ",", 
       RowBox[{"ImageScaled", "[", 
        RowBox[{"{", 
         RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}]}], "]"}], "}"}]}], ",", 
   RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}], ",", 
   RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"ListDensityPlot", "[", 
  RowBox[{
   RowBox[{"1", "+", 
    RowBox[{"0.2", 
     RowBox[{"Log", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"res2m", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"1", ";;", "160"}], ",", "All", ",", "1", ",", "2"}], "]"}],
         "]"}], "]"}], "]"}]}]}], ",", 
   RowBox[{"Epilog", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Inset", "[", 
      RowBox[{
       RowBox[{"Style", "[", 
        RowBox[{"i", ",", "White", ",", "Bold", ",", "16"}], "]"}], ",", 
       RowBox[{"ImageScaled", "[", 
        RowBox[{"{", 
         RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}]}], "]"}], "}"}]}], ",", 
   RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}], ",", 
   RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5057516138664*^9, 3.505751773626*^9}}],

Cell[BoxData[{
 RowBox[{"Dynamic", "[", "i", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"read11", "[", "i", "]"}], ";", 
    RowBox[{"pl", "=", 
     RowBox[{"ListDensityPlot", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"Transpose", "[", 
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"1", ";;", "160"}], ",", "32", ",", "All", ",", "1"}], 
           "]"}], "]"}], "]"}], "20"], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Inset", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"i", ",", "White", ",", "Bold", ",", "16"}], "]"}], ",", 
           RowBox[{"ImageScaled", "[", 
            RowBox[{"{", 
             RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}]}], "]"}], "}"}]}]}], 
      "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"\"\<G:\\\\GRMHD\\\\movies\\\\rate05phi\\\\img\>\"", "<>", 
       RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\<.jpg\>\""}], ",", 
      "pl"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "4950", ",", "9950", ",", "10"}], "}"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.505748596332*^9, 3.5057486280312*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"read11", "[", "550", "]"}], ";", 
  RowBox[{"plgam", "=", 
   RowBox[{"ListDensityPlot", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"res2m", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"1", ";;", "160"}], ",", "All", ",", "1", ",", "5"}], "]"}],
         "]"}], "]"}], "]"}], ",", 
     RowBox[{"Epilog", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Inset", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{"i", ",", "White", ",", "Bold", ",", "16"}], "]"}], ",", 
         RowBox[{"ImageScaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}]}], "]"}], "}"}]}], ",", 
     RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}], ",", 
     RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5057602743894*^9, 3.505760276745*^9}, {
  3.5057624994630003`*^9, 3.505762502193*^9}, {3.5057625328938*^9, 
  3.505762574811*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"read11", "[", "6650", "]"}], ";", 
  RowBox[{"ListDensityPlot", "[", 
   RowBox[{
    FractionBox[
     RowBox[{"Transpose", "[", 
      RowBox[{"res2m", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"1", ";;", "160"}], ",", "All", ",", "1", ",", "8"}], "]"}], 
       "]"}], "]"}], "3"], ",", 
    RowBox[{"Epilog", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Inset", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"i", ",", "White", ",", "Bold", ",", "16"}], "]"}], ",", 
        RowBox[{"ImageScaled", "[", 
         RowBox[{"{", 
          RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}]}], "]"}], "}"}]}], ",", 
    RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"read11", "[", "6651", "]"}], ";", 
  RowBox[{"ListDensityPlot", "[", 
   RowBox[{
    FractionBox[
     RowBox[{"Transpose", "[", 
      RowBox[{"res2m", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"1", ";;", "160"}], ",", "All", ",", "1", ",", "8"}], "]"}], 
       "]"}], "]"}], "3"], ",", 
    RowBox[{"Epilog", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"Inset", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"i", ",", "White", ",", "Bold", ",", "16"}], "]"}], ",", 
        RowBox[{"ImageScaled", "[", 
         RowBox[{"{", 
          RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}]}], "]"}], "}"}]}], ",", 
    RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.5057625965106*^9, 3.505762609131*^9}, {
  3.5058234912198*^9, 3.5058235333398*^9}, {3.5058235666614*^9, 
  3.5058236064882*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"np", "=", "32"}], ";", 
  RowBox[{"\[Theta]xx", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "x2"}], "-", "1"}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", "h"}], ")"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "x2"}], "-", "1"}], ")"}], "7"]}], "+", "1"}], ")"}], 
      FractionBox["\[Pi]", "2"]}], "/.", 
     RowBox[{"h", "\[Rule]", "0.65"}]}], "/.", 
    RowBox[{"x2", "\[Rule]", 
     RowBox[{"(", 
      RowBox[{"x2tab", "=", 
       RowBox[{"N", "[", 
        RowBox[{"Range", "[", 
         RowBox[{
          FractionBox["1", 
           RowBox[{"4", "np"}]], ",", 
          RowBox[{"1", "-", 
           FractionBox["1", 
            RowBox[{"4", "np"}]]}], ",", 
          FractionBox["1", 
           RowBox[{"2", "np"}]]}], "]"}], "]"}]}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"theta", "=", 
   RowBox[{"Cos", "[", "\[Theta]xx", "]"}]}], ";", 
  RowBox[{"rate", "=", "0."}], ";", 
  RowBox[{"nx", "=", "10"}], ";", 
  RowBox[{"diff", "=", 
   RowBox[{"Differences", "[", "theta", "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.474038462528*^9, 3.474038532538*^9}, {3.47403863959*^9, 
   3.4740386858199997`*^9}, {3.474038725953*^9, 3.474038739874*^9}, {
   3.474038771481*^9, 3.4740388137650003`*^9}, 3.474038845924*^9, {
   3.47403895655*^9, 3.474039045752*^9}, 3.474121703814*^9, {
   3.4834567714908*^9, 3.4834567957176*^9}, {3.4834569155256*^9, 
   3.483456918552*^9}, {3.505760235171*^9, 3.5057602420973997`*^9}, {
   3.5057603316882*^9, 3.5057603390046*^9}, {3.5057606042981997`*^9, 
   3.505760634141*^9}}],

Cell[BoxData[
 RowBox[{"accr", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"read11", "[", "i", "]"}], ";", 
     RowBox[{"rate", "=", 
      RowBox[{
       RowBox[{"res2m", "[", 
        RowBox[{"[", 
         RowBox[{"nx", ",", 
          RowBox[{"1", ";;", 
           RowBox[{"-", "2"}]}], ",", "All", ",", "1"}], "]"}], "]"}], "*", 
       RowBox[{"res2m", "[", 
        RowBox[{"[", 
         RowBox[{"nx", ",", 
          RowBox[{"1", ";;", 
           RowBox[{"-", "2"}]}], ",", "All", ",", "5"}], "]"}], "]"}], "*", 
       RowBox[{"res2m", "[", 
        RowBox[{"[", 
         RowBox[{"nx", ",", 
          RowBox[{"1", ";;", 
           RowBox[{"-", "2"}]}], ",", "All", ",", "6"}], "]"}], "]"}]}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"rate", "=", 
      RowBox[{"Total", "[", 
       RowBox[{"diff", ".", "rate"}], "]"}]}], ";", 
     RowBox[{"{", 
      RowBox[{"i", ",", "rate"}], "}"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "8020", 
      RowBox[{"(*", "4950", "*)"}], ",", "8138", 
      RowBox[{"(*", "9950", "*)"}], ",", "2"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.505759855389*^9, 3.5057598875406*^9}, {
   3.5057603567574*^9, 3.5057604813546*^9}, {3.5057605124922*^9, 
   3.5057605851258*^9}, 3.5057606323314*^9, {3.505760688663*^9, 
   3.5057607778014*^9}, {3.506076163553*^9, 3.506076177047*^9}, {
   3.5060762569346*^9, 3.506076260663*^9}, {3.5060780272693996`*^9, 
   3.5060780408726*^9}, {3.5060825803946*^9, 3.506082590675*^9}, {
   3.5068691669334*^9, 3.5068691720814*^9}, {3.5068692897366*^9, 
   3.5068692908598003`*^9}, {3.5079833329018*^9, 3.5079833402650003`*^9}, {
   3.5079833793118*^9, 3.5079833800917997`*^9}, {3.5079834268450003`*^9, 
   3.507983427625*^9}, {3.5080745446804*^9, 3.5080745559435997`*^9}, {
   3.5081380840863733`*^9, 3.508138093368374*^9}, {3.508870749171421*^9, 
   3.5088707636184206`*^9}, {3.508871212556421*^9, 3.5088712128354206`*^9}}],

Cell[BoxData[
 RowBox[{"ListLogPlot", "[", 
  RowBox[{"accr", ",", 
   RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5079834365794*^9, 3.5079834367665997`*^9}}],

Cell[BoxData["5"], "Input",
 CellChangeTimes->{3.5088708006514206`*^9}],

Cell[BoxData["4"], "Input",
 CellChangeTimes->{3.5080745791096*^9}],

Cell[BoxData["3"], "Input",
 CellChangeTimes->{3.5080745751628*^9}],

Cell[BoxData["2"], "Input",
 CellChangeTimes->{3.5079827765122004`*^9}],

Cell[BoxData["1"], "Input",
 CellChangeTimes->{3.5068691645622*^9}],

Cell[BoxData[
 RowBox[{"ListLogPlot", "[", 
  RowBox[{"accr", ",", 
   RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"ListLogPlot", "[", 
  RowBox[{"accr", ",", 
   RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.505760752467*^9, 3.5057607690654*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"read11", "[", "i", "]"}], ";", 
    RowBox[{"plgam", "=", 
     RowBox[{"ListDensityPlot", "[", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{"Transpose", "[", 
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"1", ";;", "160"}], ",", "All", ",", "1", ",", "5"}], 
           "]"}], "]"}], "]"}], "]"}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Inset", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"i", ",", "White", ",", "Bold", ",", "16"}], "]"}], ",", 
           RowBox[{"ImageScaled", "[", 
            RowBox[{"{", 
             RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}]}], "]"}], "}"}]}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "6547", 
     RowBox[{"(*", "4950", "*)"}], ",", "6563", 
     RowBox[{"(*", "9950", "*)"}], ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.505760490699*^9, 3.5057604931482*^9}, 
   3.5060763944174*^9, {3.5060768180198*^9, 3.5060768362562*^9}, {
   3.506076939653*^9, 3.5060769400586*^9}, {3.506869400793*^9, 
   3.5068694063934*^9}}],

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"read11", "[", "i", "]"}], ";", 
    RowBox[{"plgam", "=", 
     RowBox[{"ListDensityPlot", "[", 
      RowBox[{
       RowBox[{"Log", "[", 
        RowBox[{"Transpose", "[", 
         RowBox[{"res2m", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"1", ";;", "160"}], ",", "All", ",", "1", ",", "5"}], 
           "]"}], "]"}], "]"}], "]"}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Inset", "[", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"i", ",", "White", ",", "Bold", ",", "16"}], "]"}], ",", 
           RowBox[{"ImageScaled", "[", 
            RowBox[{"{", 
             RowBox[{"0.5", ",", "0.9"}], "}"}], "]"}]}], "]"}], "}"}]}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "False"}]}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "7347", ",", "7353", ",", "2"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5060771184602003`*^9, 3.5060771311742*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.505760374869*^9, 3.505760378925*^9}, 3.5057605370934*^9}
  ],

Cell[BoxData[
 RowBox[{"lis", "=", "%"}]], "Input",
 CellChangeTimes->{{3.5057459310369997`*^9, 3.5057459323786*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"anim", "=", 
     RowBox[{"ListAnimate", "[", "lis", "]"}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Export", "[", 
   RowBox[{"\"\<G:\\\\GRMHD\\\\movie05.avi\>\"", ",", "lis"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5057459398666*^9, 3.5057460029374*^9}, {
   3.5057461101717997`*^9, 3.5057461128862*^9}, {3.5057463623556004`*^9, 
   3.5057463824494*^9}, 3.506087542193*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"read11", "[", "6597", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.5060773898222*^9, 3.5060773906646*^9}, {
  3.5060775072278*^9, 3.5060775123602*^9}, {3.5060775523118*^9, 
  3.5060775525302*^9}}],

Cell[BoxData[
 RowBox[{"Dimensions", "[", "res2m", "]"}]], "Input",
 CellChangeTimes->{{3.5060773942058*^9, 3.5060773981682*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nm", "=", "256"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"read11", "[", "6597", "]"}], ";", 
  RowBox[{"res6597", "=", 
   RowBox[{"res2m", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"30", ";;", "nm"}], ",", "32", ",", "1", ",", "5"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"read11", "[", "6599", "]"}], ";", 
  RowBox[{"res6599", "=", 
   RowBox[{"res2m", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"30", ";;", "nm"}], ",", "32", ",", "1", ",", "5"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"read11", "[", "6601", "]"}], ";", 
  RowBox[{"res6601", "=", 
   RowBox[{"res2m", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"30", ";;", "nm"}], ",", "32", ",", "1", ",", "5"}], "]"}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5060775339505997`*^9, 3.5060775782234*^9}, {
  3.5060827857218*^9, 3.5060828018834*^9}, {3.506082935903*^9, 
  3.5060829670094*^9}, {3.5060830519358*^9, 3.5060830524818*^9}, {
  3.506087490167*^9, 3.5060875004161997`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"ListLogPlot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"res6597", ",", "res6599", ",", "res6601"}], "}"}], "-", "1"}],
      ",", 
     RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"ListLogPlot", "[", 
    RowBox[{
     RowBox[{"1", "/", 
      FractionBox[
       RowBox[{"res6601", "-", "1"}], 
       RowBox[{"res6599", "-", "1"}]]}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.506082812117*^9, 3.5060828355794*^9}, {
  3.5060829066842003`*^9, 3.5060829242342*^9}, {3.5060829820945997`*^9, 
  3.506082987071*^9}, {3.5060831854718*^9, 3.506083205783*^9}, {
  3.5060875032242002`*^9, 3.5060875050025997`*^9}}],

Cell[BoxData[
 RowBox[{"rho", ",", "u", ",", 
  RowBox[{"-", 
   RowBox[{"u", "^", "t"}]}], ",", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"T", "^", "r_t"}]}], "/", 
   RowBox[{"(", 
    RowBox[{"rho", " ", 
     RowBox[{"u", "^", "r"}]}], ")"}]}], ",", 
  RowBox[{"u", "^", "t"}], ",", 
  RowBox[{"v", "^", "r"}], ",", 
  RowBox[{"v", "^", "theta"}], ",", 
  RowBox[{"v", "^", "phi"}], ",", 
  RowBox[{"B", "^", "r"}], ",", 
  RowBox[{"B", "^", "theta"}], ",", 
  RowBox[{"B", "^", "phi"}]}]], "Input",
 CellChangeTimes->{{3.5060777551742*^9, 3.5060777597606*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ruru", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rg", "\[Rule]", 
      FractionBox[
       RowBox[{"6.67", " ", 
        SuperscriptBox["10", 
         RowBox[{"-", "8"}]], "4.5", " ", 
        SuperscriptBox["10", "6"], "2", " ", 
        SuperscriptBox["10", "33"]}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"3", " ", 
          SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
     RowBox[{"arcsec", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
        SuperscriptBox["10", "3"], "3.08", " ", 
        SuperscriptBox["10", "18"]}], 
       RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
     RowBox[{"pc", "\[Rule]", 
      RowBox[{"3.08", " ", 
       SuperscriptBox["10", "18"]}]}], ",", 
     RowBox[{"year", "\[Rule]", 
      RowBox[{"365.35", " ", "86400"}]}], ",", 
     RowBox[{"cc", "\[Rule]", 
      RowBox[{"3.", " ", 
       SuperscriptBox["10", "10"]}]}], ",", 
     RowBox[{"Msun", "\[Rule]", 
      RowBox[{"2.", " ", 
       SuperscriptBox["10", "33"]}]}], ",", 
     RowBox[{"mp", "\[Rule]", 
      RowBox[{"1.67", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "24"}]]}]}], ",", 
     RowBox[{"me", "\[Rule]", 
      RowBox[{"9.1", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "28"}]]}]}], ",", 
     RowBox[{"kb", "\[Rule]", 
      RowBox[{"1.38", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "16"}]]}]}], ",", 
     RowBox[{"h", "\[Rule]", 
      RowBox[{"6.626", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "27"}]]}]}], ",", 
     RowBox[{"ee", "\[Rule]", 
      RowBox[{"4.8", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "10"}]]}]}], ",", 
     RowBox[{"keV", "->", 
      RowBox[{"1000", " ", "1.602", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"torb", "=", 
  RowBox[{
   RowBox[{"40", 
    FractionBox[
     RowBox[{"2", "\[Pi]"}], 
     SqrtBox[
      RowBox[{"rg", " ", 
       SuperscriptBox["cc", "2"]}]]], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"20", "rg"}], ")"}], 
     RowBox[{"3", "/", "2"}]]}], "/.", "ruru"}]}], "\[IndentingNewLine]", 
 RowBox[{"tunit", "=", 
  RowBox[{
   FractionBox["rg", "cc"], "/.", "ruru"}]}], "\[IndentingNewLine]", 
 RowBox[{"torb", "/", "tunit"}]}], "Input",
 CellChangeTimes->{{3.5127491272908*^9, 3.512749156183*^9}, {
  3.5127491932174*^9, 3.5127491941378*^9}, {3.5127492501261997`*^9, 
  3.5127492674578*^9}, {3.5127493053346*^9, 3.5127493804486*^9}, {
  3.5127494483710003`*^9, 3.5127494529418*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Dynamical model for Lei", "Section",
 CellChangeTimes->{{3.485272008183237*^9, 3.4852720114904366`*^9}}],

Cell[TextData[{
 "Te=8*10^10/",
 Cell[BoxData[
  FormBox[
   SqrtBox["rr"], TraditionalForm]]],
 ";\n\[Theta]=2.146755 - inclination angle\n\nrho\[Rule]n\nut \[Rule] u[0]\n\
ur \[Rule] u[1]\nutheta \[Rule] u[2]\nuphi \[Rule] u[3]\nBi1\[Rule] Bi[1]\n\
Bi2\[Rule] Bi[2]\nBi3\[Rule] Bi[3]\ndoub \
blo=(ulo[1]*Bi[1]+ulo[2]*Bi[2]+ulo[3]*Bi[3]);\n\
Bup[0]=blo;for(m=1;m<4;m++)Bup[m]=(Bi[m]+blo*u[m])/u[0];"
}], "Text",
 CellChangeTimes->{{3.4852724220044365`*^9, 3.485272422503637*^9}, {
  3.485272866387037*^9, 3.485272887930637*^9}, {3.485274124709437*^9, 
  3.485274135676237*^9}, {3.485274537376237*^9, 3.485274537657037*^9}, {
  3.4852747222362366`*^9, 3.4852747286166368`*^9}, {3.485275001203037*^9, 
  3.4852751085466366`*^9}, {3.4858715955502157`*^9, 3.485871595581415*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dir", "=", "\"\<G:\\\\mathematica\\\\3DMHD\\\\a\>\""}], ";", 
  RowBox[{"atab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<0\>\"", ",", "\"\<05\>\"", ",", "\"\<07\>\"", ",", "\"\<09\>\"", 
     ",", "\"\<098\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"read11", "[", "n_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"namefile", "=", 
      RowBox[{"dir", "<>", 
       RowBox[{"atab", "[", 
        RowBox[{"[", "n", "]"}], "]"}], "<>", 
       "\"\<\\\\fieldline00-1.bin\>\""}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"fi11", "=", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", 
        RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"fi11", ",", "\"\<Character8\>\"", ",", "374"}], "]"}], 
         "]"}], "]"}], ";"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"res2m", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"brl", "=", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"BinaryReadList", "[", 
                RowBox[{"fi11", ",", "\"\<Real32\>\"", ",", 
                 RowBox[{"11", "*", "32", "*", "64", "*", "256"}]}], "]"}], 
               ",", "11"}], "]"}], ",", "256"}], "]"}], ",", "64"}], "]"}]}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Close", "[", "namefile", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"namefile", " ", "=", 
      RowBox[{"dir", "<>", 
       RowBox[{"atab", "[", 
        RowBox[{"[", "n", "]"}], "]"}], "<>", 
       "\"\<\\\\fieldline0000.bin\>\""}]}], ";", "\n", "   ", 
     RowBox[{"siz", " ", "=", " ", 
      RowBox[{"FileByteCount", "[", "namefile", "]"}]}], ";", " ", 
     RowBox[{"xs", " ", "=", " ", 
      RowBox[{"11", "*", "256", "*", "64", "*", "32", "*", "4"}]}], ";", "\n",
      "   ", 
     RowBox[{"fi11", " ", "=", " ", 
      RowBox[{"OpenRead", "[", 
       RowBox[{"namefile", ",", " ", 
        RowBox[{"BinaryFormat", " ", "->", " ", "True"}]}], "]"}]}], ";", 
     "\n", "   ", 
     RowBox[{"strrr", " ", "=", " ", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"BinaryReadList", "[", 
        RowBox[{"fi11", ",", " ", "\"\<Character8\>\"", ",", " ", 
         RowBox[{
          RowBox[{"FileByteCount", "[", "namefile", "]"}], " ", "-", " ", 
          "xs"}]}], "]"}], "]"}]}], ";", "\n", "   ", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"res2m", " ", "=", " ", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"llist", " ", "=", " ", 
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"Partition", "[", 
                RowBox[{
                 RowBox[{"BinaryReadList", "[", 
                  RowBox[{"fi11", ",", " ", "\"\<Real32\>\"", ",", " ", 
                   RowBox[{"11", "*", "32", "*", "64", "*", "256"}]}], "]"}], 
                 ",", " ", "11"}], "]"}], ",", " ", "256"}], "]"}], ",", " ", 
             "64"}], "]"}]}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"3", ",", " ", "2", ",", " ", "1", ",", " ", "4"}], 
           "}"}]}], "]"}]}], ";"}], "*)"}], "\n", "   ", 
     RowBox[{"Close", "[", "namefile", "]"}], ";"}], ")"}]}], ";"}], "\n", 
 RowBox[{"read11", "[", "5", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stt", "=", 
   RowBox[{"StringToStream", "[", "strrr", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"x1min", "=", 
    RowBox[{"Read", "[", 
     RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "5"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"dx1", "=", 
    RowBox[{"Read", "[", 
     RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Do", "[", 
  RowBox[{
   RowBox[{"off", "=", 
    RowBox[{"Read", "[", 
     RowBox[{"stt", ",", "Number"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "6"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Close", "[", "stt", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"x1min", "=", 
   RowBox[{"-", "0.238785893239999`"}]}], ";", 
  RowBox[{"off", "=", "0.3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dx1", "=", "0.0216657617755842`"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"rtab", "=", 
   RowBox[{"off", "+", 
    RowBox[{"Exp", "[", 
     RowBox[{"x1min", "+", 
      RowBox[{"dx1", " ", 
       RowBox[{"Range", "[", 
        RowBox[{"0", ",", "255"}], "]"}]}]}], "]"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x1min", ",", "x2min", ",", "x3min"}], "}"}], "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}], ",", 
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}], ",", 
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"dx1", ",", "dx2", ",", "dx3"}], "}"}], "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}], ",", 
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}], ",", 
       RowBox[{"BinaryRead", "[", 
        RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}]}], "}"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Do", "[", 
     RowBox[{
      RowBox[{"BinaryRead", "[", 
       RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "8"}], "}"}]}], "]"}], ";", 
    RowBox[{"BinaryRead", "[", 
     RowBox[{"fi11", ",", "\"\<Real32\>\""}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"ress", "=", 
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Partition", "[", 
            RowBox[{
             RowBox[{"BinaryReadList", "[", 
              RowBox[{"fi11", ",", "\"\<Real32\>\"", ",", 
               RowBox[{"30", "*", "32", "*", "64", "*", "256"}]}], "]"}], ",",
              "30"}], "]"}], ",", "256"}], "]"}], ",", "64"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "2", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Close", "[", "namefile", "]"}], ";"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.474395330177*^9, 3.4743954013129997`*^9}, {
   3.4743954785486*^9, 3.474395507549*^9}, {3.4743955492321997`*^9, 
   3.4743956059538*^9}, {3.4743956815358*^9, 3.474395682347*^9}, {
   3.4743957318458*^9, 3.4743958939454*^9}, 3.4743961811882*^9, {
   3.474396341837*^9, 3.4743963751274*^9}, {3.4743965493014*^9, 
   3.4743965682242002`*^9}, {3.4743967252538*^9, 3.4743967672958*^9}, {
   3.4743968341261997`*^9, 3.474396836123*^9}, {3.4744626708473997`*^9, 
   3.474462676869*^9}, {3.4744629273738003`*^9, 3.4744629351893997`*^9}, {
   3.474464462878333*^9, 3.474464485005333*^9}, {3.474849252384719*^9, 
   3.4748492674855194`*^9}, {3.474851530561719*^9, 3.474851533993719*^9}, {
   3.474851599981719*^9, 3.4748516129141192`*^9}, {3.474851968999719*^9, 
   3.4748519790305195`*^9}, {3.4748932293839192`*^9, 3.474893229758319*^9}, {
   3.474894184072719*^9, 3.474894191311119*^9}, {3.4748951725747194`*^9, 
   3.4748951818879194`*^9}, {3.474895252805519*^9, 3.4748952572671194`*^9}, {
   3.474895323879119*^9, 3.474895324440719*^9}, {3.474896254980719*^9, 
   3.474896259364319*^9}, {3.4748967491575193`*^9, 3.474896751606719*^9}, {
   3.474911094340319*^9, 3.4749110979127192`*^9}, {3.4766324628285313`*^9, 
   3.4766324638581314`*^9}, {3.4840501346722*^9, 3.4840501482441998`*^9}, {
   3.484050200941*^9, 3.484050207883*^9}, {3.4840502848534*^9, 
   3.4840503104217997`*^9}, {3.4840503488445997`*^9, 
   3.4840504036006002`*^9}, {3.4840505983978*^9, 3.4840507457866*^9}, {
   3.484051655797*^9, 3.4840516572634*^9}, {3.4840518824494*^9, 
   3.4840519349902*^9}, {3.485272406544837*^9, 3.485272406966037*^9}, {
   3.4852725279294367`*^9, 3.485272528085437*^9}, {3.485272987942237*^9, 
   3.4852729948062367`*^9}, {3.4858749214078155`*^9, 3.4858749371950154`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Dimensions", "[", 
   RowBox[{"avgres", "=", 
    FractionBox[
     RowBox[{"Total", "[", 
      RowBox[{
       RowBox[{"res2m", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", "All", ",", "All"}], "]"}], "]"}], 
       ",", 
       RowBox[{"{", "3", "}"}]}], "]"}], "32"]}], "]"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"uup", "=", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"fie", "[", 
        RowBox[{"[", "5", "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{"fie", "[", 
         RowBox[{"[", "5", "]"}], "]"}], 
        RowBox[{"fie", "[", 
         RowBox[{"[", 
          RowBox[{"6", ";;", "8"}], "]"}], "]"}]}]}], "}"}], "]"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl3", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "5"}], "]"}], "]"}], "*", 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "6"}], "]"}], "]"}]}]}], "}"}], 
      "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl3", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"0.7", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "2.5"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "5"}], "]"}], "]"}], "*", 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "8"}], "]"}], "]"}]}]}], "}"}], 
      "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"0.3", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "1.5"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "5"}], "]"}], "]"}], "*", 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "7"}], "]"}], "]"}]}]}], "}"}], 
      "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"0.03", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "1.5"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{"lpl3", ",", "pl3", ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(u\), \(r\)]\)-upper index\>\""}]}], "]"}],
      ",", 
     RowBox[{"Show", "[", 
      RowBox[{"lpl1", ",", "pl1", ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(u\), \(\[Phi]\)]\)-upper index\>\""}]}], 
      "]"}], ",", 
     RowBox[{"Show", "[", 
      RowBox[{"lpl2", ",", "pl2", ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(u\), \(\[Theta]\)]\)-upper index\>\""}]}],
       "]"}]}], "}"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "1200"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"Abs", "[", 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "9"}], "]"}], "]"}], "]"}]}], "}"}],
       "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"0.8", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "2.5"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"Abs", "[", 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "10"}], "]"}], "]"}], "]"}]}], 
       "}"}], "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"0.01", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "1.5"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl3", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"Abs", "[", 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "11"}], "]"}], "]"}], "]"}]}], 
       "}"}], "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl3", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"0.8", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "2.5"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{"lpl1", ",", "pl1", ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(B\), \(r\)]\)-upper index\>\""}]}], "]"}],
      ",", 
     RowBox[{"Show", "[", 
      RowBox[{"lpl2", ",", "pl2", ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(B\), \(\[Theta]\)]\)-upper index\>\""}]}],
       "]"}], ",", 
     RowBox[{"Show", "[", 
      RowBox[{"lpl3", ",", "pl3", ",", 
       RowBox[{
       "PlotLabel", "\[Rule]", 
        "\"\<\!\(\*SuperscriptBox[\(B\), \(\[Phi]\)]\)-upper index\>\""}]}], 
      "]"}]}], "}"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "1200"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"Abs", "[", 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "1"}], "]"}], "]"}], "]"}]}], "}"}],
       "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl1", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"6", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "0.8"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lpl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{"Abs", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        FractionBox[
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "2"}], "]"}], "]"}], 
         RowBox[{"avgres", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "34", ",", "1"}], "]"}], "]"}]]}], "}"}], 
      "]"}], "]"}], "]"}]}], ";", 
  RowBox[{"pl2", "=", 
   RowBox[{"ListLogLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"rtab", ",", 
        RowBox[{"0.25", 
         SuperscriptBox["rtab", 
          RowBox[{"-", "0.8"}]]}]}], "}"}], "]"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{"lpl1", ",", "pl1", ",", 
       RowBox[{"PlotLabel", "\[Rule]", "\"\<\[Rho]\>\""}]}], "]"}], ",", 
     RowBox[{"Show", "[", 
      RowBox[{"lpl2", ",", "pl2", ",", 
       RowBox[{"PlotLabel", "\[Rule]", "\"\<U\>\""}]}], "]"}]}], "}"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "800"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.4770740564309373`*^9, 3.4770741419657373`*^9}, {
   3.4770741761921372`*^9, 3.4770741848969374`*^9}, {3.4840507559578*^9, 
   3.4840507562074003`*^9}, 3.4840516442218*^9, {3.484051709851*^9, 
   3.4840518415306*^9}, {3.484070100304*^9, 3.4840701156076*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", 
  RowBox[{"tofile", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{"avgres", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "32"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "2", ",", "4"}], "}"}]}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "brl", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"namefile", "=", 
   RowBox[{"dir", "<>", 
    RowBox[{"atab", "[", 
     RowBox[{"[", "5", "]"}], "]"}], "<>", 
    "\"\<\\\\fieldline0-10.bin\>\""}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fi22", "=", 
   RowBox[{"OpenWrite", "[", 
    RowBox[{"namefile", ",", 
     RowBox[{"BinaryFormat", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"BinaryWrite", "[", 
  RowBox[{"fi22", ",", "tofile", ",", "\"\<Real32\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Close", "[", "namefile", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.485272948209037*^9, 3.485273029563037*^9}, {
  3.4852731853134365`*^9, 3.4852732193838367`*^9}, {3.485273252877037*^9, 
  3.4852733285994368`*^9}, {3.485273488983037*^9, 3.485273491978237*^9}, {
  3.4852737302790365`*^9, 3.485273732946637*^9}, {3.485273804831437*^9, 
  3.485273806360237*^9}}],

Cell[BoxData[{
 RowBox[{"Dimensions", "[", "avgres", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "tofile", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "brl", "]"}]}], "Input",
 CellChangeTimes->{{3.4864640489844*^9, 3.4864640917284*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ruru", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"rg", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "6.67", " ", 
        SuperscriptBox["10", 
         RowBox[{"-", "8"}]], "4.5", " ", 
        SuperscriptBox["10", "6"], "2", " ", 
        SuperscriptBox["10", "33"]}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"3", " ", 
          SuperscriptBox["10", "10"]}], ")"}], "2"]]}], ",", 
     RowBox[{"arcsec", "\[Rule]", 
      FractionBox[
       RowBox[{"2", " ", "\[Pi]", " ", "8.4", " ", 
        SuperscriptBox["10", "3"], "3.08", " ", 
        SuperscriptBox["10", "18"]}], 
       RowBox[{"360", " ", "60", " ", "60"}]]}], ",", 
     RowBox[{"pc", "\[Rule]", 
      RowBox[{"3.08", " ", 
       SuperscriptBox["10", "18"]}]}], ",", 
     RowBox[{"year", "\[Rule]", 
      RowBox[{"365.35", " ", "86400"}]}], ",", 
     RowBox[{"cc", "\[Rule]", 
      RowBox[{"3.", " ", 
       SuperscriptBox["10", "10"]}]}], ",", 
     RowBox[{"Msun", "\[Rule]", 
      RowBox[{"2.", " ", 
       SuperscriptBox["10", "33"]}]}], ",", 
     RowBox[{"mp", "\[Rule]", 
      RowBox[{"1.67", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "24"}]]}]}], ",", 
     RowBox[{"me", "\[Rule]", 
      RowBox[{"9.1", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "28"}]]}]}], ",", 
     RowBox[{"kb", "\[Rule]", 
      RowBox[{"1.38", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "16"}]]}]}], ",", 
     RowBox[{"h", "\[Rule]", 
      RowBox[{"6.626", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "27"}]]}]}], ",", 
     RowBox[{"ee", "\[Rule]", 
      RowBox[{"4.8", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "10"}]]}]}], ",", 
     RowBox[{"keV", "->", 
      RowBox[{"1000", " ", "1.602", " ", 
       SuperscriptBox["10", 
        RowBox[{"-", "12"}]]}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhonor", "=", 
   RowBox[{"6", " ", 
    SuperscriptBox["10", "5"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Bnor", "=", 
  RowBox[{
   RowBox[{
    SqrtBox[
     RowBox[{"4.", "*", "\[Pi]", "*", "rhonor", "*", "mp"}]], "*", "cc"}], "/.",
    "ruru"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rgrav", "\[Rule]", "rg"}], "/.", "ruru"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"dir", "<>", 
     RowBox[{"atab", "[", 
      RowBox[{"[", "5", "]"}], "]"}], "<>", "\"\<\\\\rho.dat\>\""}], ",", 
    RowBox[{"rhonor", " ", 
     RowBox[{"avgres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"dir", "<>", 
     RowBox[{"atab", "[", 
      RowBox[{"[", "5", "]"}], "]"}], "<>", "\"\<\\\\ut.dat\>\""}], ",", 
    RowBox[{"avgres", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "All", ",", "5"}], "]"}], "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"dir", "<>", 
     RowBox[{"atab", "[", 
      RowBox[{"[", "5", "]"}], "]"}], "<>", "\"\<\\\\ur.dat\>\""}], ",", 
    RowBox[{
     RowBox[{"avgres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "5"}], "]"}], "]"}], "*", 
     RowBox[{"avgres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "6"}], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"dir", "<>", 
     RowBox[{"atab", "[", 
      RowBox[{"[", "5", "]"}], "]"}], "<>", "\"\<\\\\utheta.dat\>\""}], ",", 
    RowBox[{
     RowBox[{"avgres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "5"}], "]"}], "]"}], "*", 
     RowBox[{"avgres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "7"}], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"dir", "<>", 
     RowBox[{"atab", "[", 
      RowBox[{"[", "5", "]"}], "]"}], "<>", "\"\<\\\\uphi.dat\>\""}], ",", 
    RowBox[{
     RowBox[{"avgres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "5"}], "]"}], "]"}], "*", 
     RowBox[{"avgres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "8"}], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"dir", "<>", 
     RowBox[{"atab", "[", 
      RowBox[{"[", "5", "]"}], "]"}], "<>", "\"\<\\\\Bi1.dat\>\""}], ",", 
    RowBox[{"Bnor", " ", 
     RowBox[{"avgres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "9"}], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"dir", "<>", 
     RowBox[{"atab", "[", 
      RowBox[{"[", "5", "]"}], "]"}], "<>", "\"\<\\\\Bi2.dat\>\""}], ",", 
    RowBox[{"Bnor", " ", 
     RowBox[{"avgres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "10"}], "]"}], "]"}]}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"dir", "<>", 
     RowBox[{"atab", "[", 
      RowBox[{"[", "5", "]"}], "]"}], "<>", "\"\<\\\\Bi3.dat\>\""}], ",", 
    RowBox[{"Bnor", " ", 
     RowBox[{"avgres", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "All", ",", "11"}], "]"}], "]"}]}]}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.4852742831274366`*^9, 3.485274332563837*^9}, {
  3.485274438737437*^9, 3.4852744568490367`*^9}, {3.485274601991437*^9, 
  3.485274675873037*^9}, {3.485274818956237*^9, 3.4852748248218365`*^9}, {
  3.485274955807037*^9, 3.4852749578506365`*^9}, {3.4858717173550158`*^9, 
  3.4858717198666153`*^9}, {3.485871834230215*^9, 3.485871865227415*^9}, {
  3.4858719605122156`*^9, 3.4858719606058154`*^9}, {3.4864645127412*^9, 
  3.4864645282788*^9}}],

Cell[CellGroupData[{

Cell["send", "Subsection",
 CellChangeTimes->{{3.4852753734658365`*^9, 3.485275374167837*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalDelta]", "=", 
    RowBox[{
     SuperscriptBox["r", "2"], "-", 
     RowBox[{"2", "r"}], "+", 
     SuperscriptBox["a", "2"]}]}], ";", 
   RowBox[{"\[Rho]sq", "=", 
    RowBox[{
     SuperscriptBox["r", "2"], "+", 
     RowBox[{
      SuperscriptBox["a", "2"], 
      SuperscriptBox[
       RowBox[{"Cos", "[", "\[Theta]", "]"}], "2"]}]}]}], ";", 
   RowBox[{"\[CapitalSigma]sq", "=", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["r", "2"], "+", 
        SuperscriptBox["a", "2"]}], ")"}], "2"], "-", 
     RowBox[{
      SuperscriptBox["a", "2"], "\[CapitalDelta]", " ", 
      SuperscriptBox[
       RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}]}], ";", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"invgmnKS", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           FractionBox[
            RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", 
          FractionBox[
           RowBox[{"2", "r"}], "\[Rho]sq"], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"2", "a", " ", "r", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          FractionBox[
           RowBox[{"2", "r"}], "\[Rho]sq"], ",", 
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{"2", "r"}], "\[Rho]sq"]}], ",", "0", ",", 
          RowBox[{
           RowBox[{"-", "a"}], 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             FractionBox[
              RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
           SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "\[Rho]sq", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"2", "a", " ", "r", " ", 
             SuperscriptBox[
              RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], "\[Rho]sq"]}], 
          ",", 
          RowBox[{
           RowBox[{"-", "a"}], 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             FractionBox[
              RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
           SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}], ",", "0", ",", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"], 
           RowBox[{"(", 
            RowBox[{"\[Rho]sq", "+", 
             RowBox[{
              SuperscriptBox["a", "2"], 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                FractionBox[
                 RowBox[{"2", "r"}], "\[Rho]sq"]}], ")"}], 
              SuperscriptBox[
               RowBox[{"Sin", "[", "\[Theta]", "]"}], "2"]}]}], ")"}]}]}], 
         "}"}]}], "}"}]}], ")"}], "//", "MatrixForm"}], ";"}], 
  RowBox[{"(*", 
   RowBox[{"lower", "-", 
    RowBox[{"index", " ", "KS", " ", "metrics"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AMKS", "=", 
   RowBox[{"DiagonalMatrix", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      FractionBox["1", 
       RowBox[{"r", "-", "R0"}]], ",", 
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{"h", "+", 
           RowBox[{"7", 
            RowBox[{"(", 
             RowBox[{"1", "-", "h"}], ")"}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", "x2"}], "-", "1"}], ")"}], "6"]}]}], ")"}]}], 
        ")"}]}], ",", 
      RowBox[{"1", "/", "\[Pi]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"invnew", "=", 
    RowBox[{
     RowBox[{"Inverse", "[", "AMKS", "]"}], ".", "invgmnKS", ".", 
     RowBox[{"Inverse", "[", "AMKS", "]"}]}]}], ")"}], "//", "MatrixForm", 
  RowBox[{"(*", 
   RowBox[{"lower", "-", 
    RowBox[{"index", " ", "MKS", " ", "metrics"}], " ", "-", " ", 
    RowBox[{
    "used", " ", "for", " ", "the", " ", "dynamical", " ", "model"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.4852753434982367`*^9, 3.485275357865837*^9}, {
  3.485275476987437*^9, 3.485275502134637*^9}, {3.485275544738237*^9, 
  3.4852755576238365`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"velocity", "  ", 
   RowBox[{"extension", ":", " ", 
    RowBox[{
     SuperscriptBox["u", "r"], " ", "\[Proportional]", " ", 
     SuperscriptBox["r", 
      RowBox[{
       RowBox[{"-", "5"}], "/", "2"}]]}]}]}], ";", " ", 
  RowBox[{
   SuperscriptBox["u", "\[Theta]"], " ", "\[Proportional]", " ", 
   SuperscriptBox["r", 
    RowBox[{
     RowBox[{"-", "3"}], "/", "2"}]]}], ";", " ", 
  RowBox[{
   SuperscriptBox["u", "\[Phi]"], " ", "\[Proportional]", " ", 
   SuperscriptBox["r", 
    RowBox[{
     RowBox[{"-", "3"}], "/", "2"}]]}], ";", " ", 
  RowBox[{
   SuperscriptBox["u", "t"], "\[Proportional]", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["v", "\[Theta]"], "=", 
   RowBox[{
    RowBox[{
     SuperscriptBox["u", "\[Theta]"], 
     SqrtBox[
      SubscriptBox["g", "\[Theta]\[Theta]"]]}], " ", "\[Proportional]", " ", 
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "1"}], "/", "2"}]]}]}], ";", " ", 
  RowBox[{
   SubscriptBox["v", "\[Phi]"], "=", 
   RowBox[{
    RowBox[{
     SuperscriptBox["u", "\[Phi]"], 
     SqrtBox[
      SubscriptBox["g", "\[Phi]\[Phi]"]]}], " ", "\[Proportional]", " ", 
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "1"}], "/", "2"}]]}]}], ";", 
  RowBox[{
   SubscriptBox["v", "r"], "\[Tilde]", 
   RowBox[{
    SuperscriptBox["u", "r"], 
    SqrtBox[
     SubscriptBox["g", "rr"]]}], " ", "\[Proportional]", " ", 
   SuperscriptBox["r", 
    RowBox[{
     RowBox[{"-", "3"}], "/", "2"}]]}], ";", "     ", 
  RowBox[{
   SubscriptBox["u", "r"], " ", "\[Proportional]", 
   SuperscriptBox["r", 
    RowBox[{
     RowBox[{"-", "1"}], "/", "2"}]]}], ";", " ", 
  RowBox[{
   SubscriptBox["u", "\[Theta]"], "\[Proportional]", " ", 
   SuperscriptBox["r", 
    RowBox[{"1", "/", "2"}]]}], ";", " ", 
  RowBox[{
   SubscriptBox["u", "\[Phi]"], "\[Proportional]", " ", 
   SuperscriptBox["r", 
    RowBox[{"1", "/", "2"}]]}], ";", " ", 
  RowBox[{
   SubscriptBox["u", "t"], "\[Proportional]", " ", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"magnetic", "   ", "field", "   ", 
   RowBox[{"extension", ":", " ", 
    RowBox[{"Bi1", " ", "\[Proportional]", " ", 
     SuperscriptBox["r", 
      RowBox[{
       RowBox[{"-", "5"}], "/", "2"}]]}]}]}], ";", " ", 
  RowBox[{"Bi2", " ", "\[Proportional]", " ", 
   SuperscriptBox["r", 
    RowBox[{
     RowBox[{"-", "3"}], "/", "2"}]]}], ";", " ", 
  RowBox[{"Bi3", " ", "\[Proportional]", " ", 
   SuperscriptBox["r", 
    RowBox[{
     RowBox[{"-", "5"}], "/", "2"}]]}], ";", " ", 
  RowBox[{
   RowBox[{"then", "   ", "blo"}], "=", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      SubscriptBox["u", "i"], " ", 
      RowBox[{"Bi", "[", "i", "]"}]}], "]"}], "=", 
    RowBox[{
     RowBox[{
      SubscriptBox["u", "\[Theta]"], "Bi2"}], "\[Proportional]", 
     SuperscriptBox["r", 
      RowBox[{"-", "1"}]]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Bup", "[", "m", "]"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Bi", "[", "m", "]"}], "+", 
      RowBox[{"blo", "*", 
       RowBox[{"u", "[", "m", "]"}]}]}], ")"}], "/", 
    RowBox[{"u", "[", "0", "]"}]}]}], ";", 
  RowBox[{
   SuperscriptBox["B", "r"], "\[Proportional]", " ", 
   RowBox[{
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "5"}], "/", "2"}]], "+", 
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "1"}], "-", 
      RowBox[{"5", "/", "2"}]}]]}], " ", "\[Proportional]", " ", 
   SuperscriptBox["r", 
    RowBox[{
     RowBox[{"-", "5"}], "/", "2"}]]}], ";", 
  RowBox[{
   SuperscriptBox["B", "\[Theta]"], "\[Proportional]", " ", 
   RowBox[{
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "3"}], "/", "2"}]], "+", 
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "1"}], "-", 
      RowBox[{"3", "/", "2"}]}]]}], " ", "\[Proportional]", " ", 
   SuperscriptBox["r", 
    RowBox[{
     RowBox[{"-", "3"}], "/", "2"}]]}], ";", 
  RowBox[{
   SuperscriptBox["B", "\[Phi]"], "\[Proportional]", " ", 
   RowBox[{
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "5"}], "/", "2"}]], "+", 
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "1"}], "-", 
      RowBox[{"3", "/", "2"}]}]]}], " ", "\[Proportional]", " ", 
   SuperscriptBox["r", 
    RowBox[{
     RowBox[{"-", "5"}], "/", "2"}]]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    SubscriptBox["b", "r"], "\[Proportional]", " ", 
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "3"}], "/", "2"}]]}], ";", 
   RowBox[{
    SubscriptBox["b", "\[Theta]"], "\[Proportional]", 
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "1"}], "/", "2"}]]}], ";", 
   RowBox[{
    SubscriptBox["b", "\[Phi]"], "\[Proportional]", 
    RowBox[{
     SuperscriptBox["r", 
      RowBox[{
       RowBox[{"-", "3"}], "/", "2"}]], " ", "-", " ", 
     RowBox[{"physical", " ", "fields"}]}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"density", "  ", "n"}], " ", "\[Proportional]", " ", 
   SuperscriptBox["r", 
    RowBox[{"-", "0.8"}]]}], ";", " ", 
  RowBox[{
   RowBox[{"temperature", " ", "T"}], "\[Proportional]", " ", 
   SuperscriptBox["r", 
    RowBox[{"-", "1"}]]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    FractionBox[
     SuperscriptBox["B", "2"], "nkT"], "=", 
    RowBox[{
     RowBox[{
      FractionBox[
       SuperscriptBox[
        SubscriptBox["b", "\[Theta]"], "2"], "nkT"], "\[Proportional]", " ", 
      RowBox[{
       SuperscriptBox["r", "0.8"], " ", "-", " ", 
       RowBox[{"growing", " ", "with", " ", 
        RowBox[{
         RowBox[{"radius", "!"}], "?"}]}]}]}], " ", "\[Implies]", " ", 
     RowBox[{
      RowBox[{"change", " ", "Bi2"}], " ", "\[Proportional]", " ", 
      SuperscriptBox["r", 
       RowBox[{
        RowBox[{"-", "5"}], "/", "2"}]]}]}]}], ";", " ", 
   RowBox[{
    RowBox[{"then", "  ", "blo"}], "\[Proportional]", 
    SuperscriptBox["r", 
     RowBox[{"-", "2"}]]}], ";", " ", 
   RowBox[{
    SubscriptBox["b", "r"], "\[Proportional]", " ", 
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "3"}], "/", "2"}]]}], ";", 
   RowBox[{
    SubscriptBox["b", "\[Theta]"], "\[Proportional]", 
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "3"}], "/", "2"}]]}], ";", 
   RowBox[{
    SubscriptBox["b", "\[Phi]"], "\[Proportional]", 
    SuperscriptBox["r", 
     RowBox[{
      RowBox[{"-", "3"}], "/", "2"}]]}]}], " "}], "\[IndentingNewLine]", 
 RowBox[{
  FractionBox[
   SuperscriptBox["B", "2"], "nkT"], "\[Proportional]", 
  SuperscriptBox["r", 
   RowBox[{"-", "0.2"}]]}]}], "Text",
 CellChangeTimes->{{3.5014207802264*^9, 3.5014207997888002`*^9}, {
  3.501420965882*^9, 3.50142100262*^9}, {3.5014210550828*^9, 
  3.5014211956544*^9}, {3.5014212593648*^9, 3.5014213425752*^9}, {
  3.5014214317136*^9, 3.5014214808068*^9}, {3.5014215543608*^9, 
  3.5014215721448*^9}, {3.5014216194440002`*^9, 3.5014217089412003`*^9}, {
  3.5014218074084*^9, 3.5014218855332003`*^9}, {3.5014219666688004`*^9, 
  3.5014220368688*^9}, {3.5014223457644*^9, 3.5014224318608*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"invnew", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "\[Rule]", "0"}], ",", 
      RowBox[{"R0", "\[Rule]", "0"}], ",", 
      RowBox[{"h", "\[Rule]", "0"}], ",", 
      RowBox[{"x2", "\[Rule]", "0"}], ",", 
      RowBox[{"\[Theta]", "\[Rule]", 
       FractionBox["\[Pi]", "2"]}], ",", 
      RowBox[{"\[Pi]", "\[Rule]", "1"}]}], "}"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.5014200239077997`*^9, 3.5014201080854*^9}, {
  3.5014202000629997`*^9, 3.5014202741162*^9}, {3.5014203877934*^9, 
  3.5014204240945997`*^9}, {3.5014204704110003`*^9, 3.5014206461762*^9}, {
  3.5014207716308002`*^9, 3.5014207729568*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BLtoMKS", "=", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1", 
        FractionBox[
         RowBox[{"2", " ", "r"}], "Del"], "0", "0"},
       {"0", 
        FractionBox["1", 
         RowBox[{"r", "-", "R0"}]], "0", "0"},
       {"0", "0", 
        FractionBox["1", "x2temp"], "0"},
       {"0", 
        FractionBox["a", 
         RowBox[{"Del", " ", "\[Pi]"}]], "0", 
        FractionBox["1", "\[Pi]"]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], ";", 
  RowBox[{"uupMKS", "=", 
   RowBox[{"BLtoMKS", ".", "uupBL"}]}], 
  RowBox[{"(*", 
   RowBox[{"multiplication", " ", "from", " ", "the", " ", "right"}], "*)"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Del", "=", 
   RowBox[{
    SuperscriptBox["a", "2"], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "r"}], ")"}], " ", "r"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"x2temp", "=", 
   RowBox[{"(", 
    RowBox[{"\[Pi]", " ", 
     RowBox[{"(", 
      RowBox[{"h", "+", 
       RowBox[{"7", " ", 
        RowBox[{"(", 
         RowBox[{"1", "-", "h"}], ")"}], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"2", " ", "x2"}]}], ")"}], "6"]}]}], ")"}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"h", "=", "0.65"}], ";", 
  RowBox[{"R0", "=", "0.3"}], ";"}]}], "Input",
 CellChangeTimes->{{3.485275290489437*^9, 3.485275341407837*^9}, {
  3.485275379986637*^9, 3.485275432652237*^9}, {3.485275513429037*^9, 
  3.4852755191386366`*^9}, {3.485275639757837*^9, 3.4852756585246367`*^9}}],

Cell[CellGroupData[{

Cell["coordinates", "Subsubsection",
 CellChangeTimes->{{3.4858749600334153`*^9, 3.4858749615934153`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"x1min", "=", 
   RowBox[{"-", "0.238785893239999`"}]}], ";", 
  RowBox[{"off", "=", "0.3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dx1", "=", "0.0216657617755842`"}], ";"}], "\n", 
 RowBox[{"rtab", "=", 
  RowBox[{"off", "+", 
   RowBox[{"Exp", "[", 
    RowBox[{"x1min", "+", 
     RowBox[{"dx1", " ", 
      RowBox[{"Range", "[", 
       RowBox[{"0", ",", "255"}], "]"}]}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{3.4858749513130155`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"np", "=", "32"}], ";", 
  RowBox[{"\[Theta]xx", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "x2"}], "-", "1"}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", "h"}], ")"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "x2"}], "-", "1"}], ")"}], "7"]}], "+", "1"}], ")"}], 
      FractionBox["\[Pi]", "2"]}], "/.", 
     RowBox[{"h", "\[Rule]", "0.65"}]}], "/.", 
    RowBox[{"x2", "\[Rule]", 
     RowBox[{"(", 
      RowBox[{"x2tab", "=", 
       RowBox[{"N", "[", 
        RowBox[{"Range", "[", 
         RowBox[{
          FractionBox["1", 
           RowBox[{"4", "np"}]], ",", 
          RowBox[{"1", "-", 
           FractionBox["1", 
            RowBox[{"4", "np"}]]}], ",", 
          FractionBox["1", 
           RowBox[{"2", "np"}]]}], "]"}], "]"}]}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Cos", "[", "\[Theta]xx", 
  "]"}], "\[IndentingNewLine]", "x2tab", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"x2tab", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"1", "/", 
            RowBox[{"(", 
             RowBox[{
              FractionBox["\[Pi]", "2"], 
              RowBox[{"(", 
               RowBox[{"h", "-", 
                RowBox[{"7", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "h"}], ")"}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{"x2", "-", "1"}], ")"}], "6"]}]}], ")"}]}], 
             ")"}]}], "/.", 
           RowBox[{"h", "\[Rule]", "0.65"}]}], "/.", 
          RowBox[{"x2", "\[Rule]", "x2tab"}]}]}], "}"}], "]"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "\[IndentingNewLine]", 
    RowBox[{"ListPlot", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"x2tab", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "/", 
           RowBox[{"(", 
            RowBox[{"\[Pi]", "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"1", "-", "h"}], ")"}], " ", "\[Pi]", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"2", " ", "\[Pi]", " ", "x2"}], "]"}]}]}], ")"}]}], "/.", 
          RowBox[{"h", "\[Rule]", "0.65"}]}], "/.", 
         RowBox[{"x2", "\[Rule]", "x2tab"}]}]}], "}"}], "]"}], "]"}]}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.474038462528*^9, 3.474038532538*^9}, {3.47403863959*^9, 
   3.4740386858199997`*^9}, {3.474038725953*^9, 3.474038739874*^9}, {
   3.474038771481*^9, 3.4740388137650003`*^9}, 3.474038845924*^9, {
   3.47403895655*^9, 3.474039045752*^9}, 3.474121703814*^9, {
   3.4834567714908*^9, 3.4834567957176*^9}, {3.4834569155256*^9, 
   3.483456918552*^9}}]
}, Closed]]
}, Closed]]
}, Closed]]
},
WindowSize->{1904, 955},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (November 20, 2012)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 98, 1, 98, "Section"],
Cell[680, 25, 141, 3, 53, "Subsection"],
Cell[CellGroupData[{
Cell[846, 32, 126, 1, 42, "Subsection"],
Cell[975, 35, 234, 7, 36, "Input"],
Cell[1212, 44, 1124, 34, 87, "Input"],
Cell[2339, 80, 193, 5, 36, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[2569, 90, 100, 1, 42, "Subsection"],
Cell[CellGroupData[{
Cell[2694, 95, 132, 1, 42, "Subsubsection"],
Cell[2829, 98, 3040, 85, 150, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[5906, 188, 133, 1, 33, "Subsubsection"],
Cell[6042, 191, 1389, 40, 106, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[7480, 237, 103, 1, 42, "Subsection"],
Cell[CellGroupData[{
Cell[7608, 242, 130, 1, 42, "Subsubsection"],
Cell[7741, 245, 2761, 63, 175, "Input"],
Cell[10505, 310, 349, 6, 36, "Input"],
Cell[10857, 318, 1394, 39, 152, "Input"],
Cell[12254, 359, 146, 3, 36, "Input"],
Cell[12403, 364, 97, 1, 36, "Input"],
Cell[12503, 367, 207, 4, 36, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[12759, 377, 111, 1, 42, "Subsection"],
Cell[12873, 380, 16191, 284, 163, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[29101, 669, 104, 1, 42, "Subsection"],
Cell[29208, 672, 17041, 493, 939, "Input"],
Cell[46252, 1167, 3101, 91, 279, "Input"],
Cell[CellGroupData[{
Cell[49378, 1262, 107, 1, 22, "Subsubsection"],
Cell[49488, 1265, 10244, 203, 194, "Text"],
Cell[59735, 1470, 253, 6, 35, "Input"],
Cell[59991, 1478, 2381, 67, 168, "Input"],
Cell[62375, 1547, 19876, 561, 998, "Input"],
Cell[82254, 2110, 96, 1, 35, "Input"],
Cell[82353, 2113, 97, 1, 35, "Input"],
Cell[82453, 2116, 103, 1, 35, "Input"],
Cell[82559, 2119, 126, 2, 35, "Input"],
Cell[82688, 2123, 129, 2, 35, "Input"],
Cell[82820, 2127, 774, 23, 54, "Input"],
Cell[83597, 2152, 706, 16, 80, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[84352, 2174, 107, 1, 42, "Subsection"],
Cell[84462, 2177, 19616, 571, 667, "Input"],
Cell[104081, 2750, 998, 31, 59, "Input"],
Cell[105082, 2783, 2671, 81, 49, "Text"],
Cell[107756, 2866, 506, 13, 35, "Input"],
Cell[108265, 2881, 629, 20, 49, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[108943, 2907, 104, 1, 60, "Section"],
Cell[CellGroupData[{
Cell[109072, 2912, 120, 1, 45, "Subsection"],
Cell[109195, 2915, 37, 0, 34, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[109269, 2920, 186, 4, 35, "Subsection"],
Cell[109458, 2926, 3436, 95, 101, "Input"],
Cell[112897, 3023, 636, 22, 35, "Input"],
Cell[113536, 3047, 5429, 148, 151, "Input"],
Cell[118968, 3197, 163, 3, 70, "Input"],
Cell[119134, 3202, 634, 19, 39, "Input"],
Cell[119771, 3223, 495, 10, 138, "Text"],
Cell[120269, 3235, 492, 14, 49, "Input"],
Cell[120764, 3251, 379, 7, 54, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[121180, 3263, 124, 1, 35, "Subsection"],
Cell[121307, 3266, 26374, 442, 434, "Input"],
Cell[147684, 3710, 13925, 354, 552, "Input"],
Cell[161612, 4066, 4762, 128, 168, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[166411, 4199, 214, 4, 35, "Subsection"],
Cell[166628, 4205, 96, 1, 34, "Text"],
Cell[166727, 4208, 2476, 75, 135, "Input"],
Cell[169206, 4285, 231, 6, 50, "Input"],
Cell[169440, 4293, 2591, 84, 169, "Input"],
Cell[172034, 4379, 898, 27, 101, "Text"]
}, Closed]],
Cell[172947, 4409, 129, 1, 35, "Subsection"],
Cell[173079, 4412, 129, 1, 35, "Subsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[173245, 4418, 97, 1, 60, "Section"],
Cell[173345, 4421, 133, 1, 45, "Subsection"],
Cell[CellGroupData[{
Cell[173503, 4426, 126, 1, 35, "Subsection"],
Cell[173632, 4429, 4297, 110, 150, "Input"],
Cell[177932, 4541, 848, 16, 58, "Input"],
Cell[178783, 4559, 520, 16, 53, "Input"],
Cell[179306, 4577, 3065, 85, 336, "Text"],
Cell[182374, 4664, 68837, 1138, 484, "Input"],
Cell[251214, 5804, 7847, 206, 209, "Input"],
Cell[259064, 6012, 6908, 181, 229, "Input"],
Cell[265975, 6195, 604, 19, 39, "Input"],
Cell[266582, 6216, 4179, 119, 157, "Input"],
Cell[270764, 6337, 118, 1, 34, "Text"],
Cell[270885, 6340, 2590, 71, 168, "Input"],
Cell[273478, 6413, 15511, 399, 622, "Input"],
Cell[288992, 6814, 94, 1, 35, "Input"],
Cell[289089, 6817, 92, 1, 35, "Input"],
Cell[289184, 6820, 2482, 67, 58, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[291703, 6892, 143, 1, 35, "Subsection"],
Cell[291849, 6895, 1156, 35, 109, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[293054, 6936, 101, 1, 60, "Section"],
Cell[CellGroupData[{
Cell[293180, 6941, 133, 1, 45, "Subsection"],
Cell[293316, 6944, 88, 1, 35, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[293441, 6950, 117, 1, 35, "Subsection"],
Cell[293561, 6953, 9344, 256, 377, "Input"],
Cell[302908, 7211, 5616, 135, 182, "Input"],
Cell[308527, 7348, 9146, 209, 402, "Input"],
Cell[317676, 7559, 98, 1, 27, "Input"],
Cell[317777, 7562, 975, 30, 55, "Input"],
Cell[318755, 7594, 6729, 173, 235, "Input"],
Cell[325487, 7769, 74347, 1232, 329, "Input"],
Cell[399837, 9003, 2481, 73, 124, "Input"],
Cell[402321, 9078, 924, 19, 278, "Input"],
Cell[403248, 9099, 752, 13, 146, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[404049, 9118, 146, 2, 60, "Section"],
Cell[404198, 9122, 107, 1, 45, "Subsection"],
Cell[404308, 9125, 127, 1, 35, "Subsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[404472, 9131, 102, 1, 60, "Section"],
Cell[CellGroupData[{
Cell[404599, 9136, 131, 1, 45, "Subsection"],
Cell[404733, 9139, 3485, 97, 101, "Input"],
Cell[408221, 9238, 606, 21, 35, "Input"],
Cell[408830, 9261, 5429, 148, 151, "Input"],
Cell[414262, 9411, 403, 12, 39, "Input"],
Cell[414668, 9425, 4580, 122, 377, "Text"],
Cell[419251, 9549, 975, 19, 179, "Text"],
Cell[420229, 9570, 163, 3, 35, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[420429, 9578, 99, 1, 35, "Subsection"],
Cell[420531, 9581, 34616, 603, 397, "Text"],
Cell[455150, 10186, 1682, 53, 124, "Input"],
Cell[456835, 10241, 2167, 61, 116, "Input"],
Cell[459005, 10304, 2313, 60, 182, "Input"],
Cell[461321, 10366, 389, 7, 54, "Text"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[461759, 10379, 94, 1, 60, "Section"],
Cell[CellGroupData[{
Cell[461878, 10384, 124, 1, 53, "Subsection"],
Cell[462005, 10387, 11537, 302, 695, "Input"],
Cell[473545, 10691, 1183, 28, 129, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[474765, 10724, 127, 1, 42, "Subsection"],
Cell[474895, 10727, 3856, 110, 124, "Input"],
Cell[478754, 10839, 2449, 74, 101, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[481252, 10919, 173, 2, 60, "Section"],
Cell[481428, 10923, 131, 1, 45, "Subsection"],
Cell[CellGroupData[{
Cell[481584, 10928, 195, 2, 35, "Subsection"],
Cell[481782, 10932, 20000, 580, 689, "Input"],
Cell[501785, 11514, 1582, 41, 49, "Input"],
Cell[503370, 11557, 1724, 45, 109, "Input"]
}, Closed]],
Cell[505109, 11605, 135, 1, 35, "Subsection"],
Cell[CellGroupData[{
Cell[505269, 11610, 121, 1, 35, "Subsection"],
Cell[505393, 11613, 8409, 203, 564, "Input"],
Cell[513805, 11818, 9376, 283, 357, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[523218, 12106, 101, 1, 35, "Subsection"],
Cell[523322, 12109, 1191, 35, 35, "Input"],
Cell[524516, 12146, 1014, 28, 35, "Input"],
Cell[525533, 12176, 1055, 28, 35, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[526625, 12209, 86, 1, 35, "Subsection"],
Cell[CellGroupData[{
Cell[526736, 12214, 109, 1, 31, "Subsubsection"],
Cell[526848, 12217, 154, 2, 35, "Input"],
Cell[527005, 12221, 9544, 258, 650, "Input"],
Cell[536552, 12481, 13429, 376, 522, "Input"],
Cell[549984, 12859, 13119, 356, 677, "Input"],
Cell[563106, 13217, 4044, 112, 213, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[567187, 13334, 158, 2, 22, "Subsubsection"],
Cell[567348, 13338, 735, 20, 101, "Input"],
Cell[568086, 13360, 1006, 27, 98, "Input"],
Cell[569095, 13389, 10576, 280, 663, "Input"],
Cell[579674, 13671, 13428, 375, 522, "Input"],
Cell[593105, 14048, 1775, 53, 124, "Input"],
Cell[594883, 14103, 14147, 367, 677, "Input"],
Cell[609033, 14472, 4044, 112, 213, "Input"]
}, Open  ]]
}, Closed]],
Cell[613104, 14588, 118, 1, 35, "Subsection"],
Cell[CellGroupData[{
Cell[613247, 14593, 162, 3, 35, "Subsection"],
Cell[613412, 14598, 5548, 142, 432, "Input"],
Cell[618963, 14742, 13379, 375, 522, "Input"],
Cell[632345, 15119, 12919, 350, 647, "Input"],
Cell[645267, 15471, 167, 2, 58, "Input"],
Cell[645437, 15475, 14933, 380, 678, "Input"]
}, Closed]],
Cell[660385, 15858, 120, 1, 35, "Subsection"],
Cell[CellGroupData[{
Cell[660530, 15863, 226, 3, 35, "Subsection"],
Cell[660759, 15868, 14543, 433, 722, "Input"],
Cell[675305, 16303, 1297, 40, 103, "Input"],
Cell[676605, 16345, 10749, 303, 474, "Input"],
Cell[687357, 16650, 5885, 168, 258, "Input"],
Cell[CellGroupData[{
Cell[693267, 16822, 135, 1, 31, "Subsubsection"],
Cell[693405, 16825, 2037, 60, 133, "Input"],
Cell[695445, 16887, 361, 9, 58, "Input"],
Cell[695809, 16898, 499, 14, 39, "Input"],
Cell[696311, 16914, 229, 6, 27, "Input"],
Cell[696543, 16922, 998, 28, 58, "Input"],
Cell[697544, 16952, 861, 25, 99, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[698454, 16983, 115, 1, 35, "Subsection"],
Cell[698572, 16986, 102, 1, 34, "Text"],
Cell[698677, 16989, 101868, 1684, 484, "Input"],
Cell[800548, 18675, 11117, 186, 50, "Input"],
Cell[811668, 18863, 105, 1, 34, "Text"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[811822, 18870, 260, 3, 60, "Section"],
Cell[CellGroupData[{
Cell[812107, 18877, 228, 3, 53, "Subsection"],
Cell[CellGroupData[{
Cell[812360, 18884, 110, 1, 42, "Subsubsection"],
Cell[812473, 18887, 131, 4, 35, "Input"],
Cell[812607, 18893, 835, 18, 101, "Input"],
Cell[813445, 18913, 7415, 167, 497, "Input"],
Cell[820863, 19082, 187, 4, 35, "Input"],
Cell[821053, 19088, 24530, 729, 1279, "Input"],
Cell[845586, 19819, 2913, 84, 148, "Input"],
Cell[848502, 19905, 6254, 180, 404, "Input"],
Cell[854759, 20087, 235, 4, 27, "Input"],
Cell[854997, 20093, 193, 5, 35, "Input"],
Cell[855193, 20100, 240, 4, 58, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[855470, 20109, 111, 1, 33, "Subsubsection"],
Cell[855584, 20112, 173, 5, 35, "Input"],
Cell[855760, 20119, 887, 19, 101, "Input"],
Cell[856650, 20140, 178, 3, 35, "Input"],
Cell[856831, 20145, 139, 2, 35, "Input"],
Cell[856973, 20149, 8425, 187, 585, "Input"],
Cell[865401, 20338, 1782, 52, 139, "Input"],
Cell[867186, 20392, 1257, 32, 172, "Input"],
Cell[868446, 20426, 369, 8, 80, "Input"],
Cell[868818, 20436, 24922, 739, 1279, "Input"],
Cell[893743, 21177, 10237, 300, 625, "Input"],
Cell[903983, 21479, 978, 29, 168, "Input"],
Cell[904964, 21510, 1640, 46, 124, "Input"],
Cell[906607, 21558, 131, 2, 35, "Input"],
Cell[906741, 21562, 470, 12, 58, "Input"],
Cell[907214, 21576, 1330, 36, 71, "Input"],
Cell[908547, 21614, 301, 6, 80, "Input"],
Cell[908851, 21622, 583, 14, 71, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[909471, 21641, 165, 2, 33, "Subsubsection"],
Cell[909639, 21645, 173, 5, 35, "Input"],
Cell[909815, 21652, 489, 11, 80, "Input"],
Cell[910307, 21665, 9081, 196, 585, "Input"],
Cell[919391, 21863, 294, 6, 58, "Input"],
Cell[919688, 21871, 1835, 53, 139, "Input"],
Cell[921526, 21926, 1257, 32, 172, "Input"],
Cell[922786, 21960, 369, 8, 80, "Input"],
Cell[923158, 21970, 25097, 741, 1279, "Input"],
Cell[948258, 22713, 10287, 300, 625, "Input"],
Cell[958548, 23015, 978, 29, 168, "Input"],
Cell[959529, 23046, 1640, 46, 124, "Input"],
Cell[961172, 23094, 131, 2, 35, "Input"],
Cell[961306, 23098, 470, 12, 58, "Input"],
Cell[961779, 23112, 1330, 36, 71, "Input"],
Cell[963112, 23150, 301, 6, 80, "Input"],
Cell[963416, 23158, 583, 14, 80, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[964036, 23177, 173, 3, 33, "Subsubsection"],
Cell[964212, 23182, 14447, 310, 930, "Input"],
Cell[978662, 23494, 3790, 112, 325, "Input"],
Cell[982455, 23608, 27809, 817, 1672, "Input"],
Cell[1010267, 24427, 519, 11, 129, "Input"],
Cell[1010789, 24440, 3261, 101, 196, "Input"],
Cell[1014053, 24543, 8921, 252, 485, "Input"],
Cell[1022977, 24797, 1640, 46, 129, "Input"],
Cell[1024620, 24845, 268, 6, 36, "Input"],
Cell[1024891, 24853, 1681, 44, 106, "Input"],
Cell[1026575, 24899, 1330, 36, 74, "Input"],
Cell[1027908, 24937, 1108, 23, 159, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1029053, 24965, 209, 4, 33, "Subsubsection"],
Cell[CellGroupData[{
Cell[1029287, 24973, 6971, 127, 290, "Input"],
Cell[1036261, 25102, 243, 5, 36, "Output"]
}, Open  ]],
Cell[1036519, 25110, 1738, 43, 106, "Input"],
Cell[CellGroupData[{
Cell[1038282, 25157, 169, 4, 36, "Input"],
Cell[CellGroupData[{
Cell[1038476, 25165, 318, 7, 27, "Print"],
Cell[1038797, 25174, 266, 5, 27, "Print"],
Cell[1039066, 25181, 266, 5, 27, "Print"],
Cell[1039335, 25188, 315, 7, 27, "Print"],
Cell[1039653, 25197, 210, 4, 27, "Print"],
Cell[1039866, 25203, 210, 4, 27, "Print"],
Cell[1040079, 25209, 318, 7, 27, "Print"],
Cell[1040400, 25218, 208, 4, 27, "Print"],
Cell[1040611, 25224, 210, 4, 27, "Print"],
Cell[1040824, 25230, 316, 7, 27, "Print"],
Cell[1041143, 25239, 208, 4, 27, "Print"],
Cell[1041354, 25245, 208, 4, 27, "Print"],
Cell[1041565, 25251, 318, 7, 27, "Print"],
Cell[1041886, 25260, 210, 4, 27, "Print"],
Cell[1042099, 25266, 208, 4, 27, "Print"],
Cell[1042310, 25272, 318, 7, 27, "Print"],
Cell[1042631, 25281, 210, 4, 27, "Print"],
Cell[1042844, 25287, 210, 4, 27, "Print"],
Cell[1043057, 25293, 318, 7, 27, "Print"],
Cell[1043378, 25302, 210, 4, 27, "Print"],
Cell[1043591, 25308, 208, 4, 27, "Print"],
Cell[1043802, 25314, 316, 7, 27, "Print"],
Cell[1044121, 25323, 210, 4, 27, "Print"],
Cell[1044334, 25329, 208, 4, 27, "Print"],
Cell[1044545, 25335, 318, 7, 27, "Print"],
Cell[1044866, 25344, 210, 4, 27, "Print"],
Cell[1045079, 25350, 208, 4, 27, "Print"],
Cell[1045290, 25356, 318, 7, 27, "Print"],
Cell[1045611, 25365, 208, 4, 27, "Print"],
Cell[1045822, 25371, 208, 4, 27, "Print"],
Cell[1046033, 25377, 316, 7, 27, "Print"],
Cell[1046352, 25386, 208, 4, 27, "Print"],
Cell[1046563, 25392, 210, 4, 27, "Print"],
Cell[1046776, 25398, 318, 7, 27, "Print"],
Cell[1047097, 25407, 207, 4, 27, "Print"],
Cell[1047307, 25413, 210, 4, 27, "Print"]
}, Open  ]],
Cell[1047532, 25420, 383, 8, 36, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1047952, 25433, 131, 2, 36, "Input"],
Cell[CellGroupData[{
Cell[1048108, 25439, 196, 5, 27, "Print"],
Cell[1048307, 25446, 501, 9, 27, "Print"],
Cell[1048811, 25457, 501, 9, 27, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1049361, 25472, 1330, 37, 106, "Input"],
Cell[1050694, 25511, 256, 4, 36, "Output"],
Cell[1050953, 25517, 254, 4, 36, "Output"],
Cell[1051210, 25523, 254, 4, 36, "Output"],
Cell[1051467, 25529, 254, 4, 36, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1051758, 25538, 96, 1, 36, "Input"],
Cell[1051857, 25541, 13108, 350, 307, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1065002, 25896, 298, 6, 60, "Input"],
Cell[1065303, 25904, 196, 5, 36, "Output"],
Cell[1065502, 25911, 1395, 44, 60, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1066958, 25962, 101, 1, 53, "Subsection"],
Cell[CellGroupData[{
Cell[1067084, 25967, 185, 2, 31, "Subsubsection"],
Cell[1067272, 25971, 17408, 504, 820, "Input"],
Cell[1084683, 26477, 35973, 1019, 1654, "Input"],
Cell[1120659, 27498, 166, 2, 58, "Input"],
Cell[1120828, 27502, 500, 12, 58, "Input"],
Cell[1121331, 27516, 246, 7, 39, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1121614, 27528, 129, 1, 22, "Subsubsection"],
Cell[1121746, 27531, 104, 3, 35, "Input"],
Cell[1121853, 27536, 2927, 66, 189, "Input"],
Cell[1124783, 27604, 1394, 39, 146, "Input"],
Cell[1126180, 27645, 101, 1, 35, "Input"],
Cell[1126284, 27648, 90, 2, 35, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1126423, 27656, 114, 1, 42, "Subsection"],
Cell[1126540, 27659, 10787, 260, 872, "Input"],
Cell[1137330, 27921, 387, 12, 58, "Input"],
Cell[1137720, 27935, 1552, 40, 146, "Input"],
Cell[1139275, 27977, 678, 17, 35, "Input"],
Cell[1139956, 27996, 193, 5, 53, "Input"],
Cell[1140152, 28003, 1724, 49, 109, "Input"],
Cell[1141879, 28054, 721, 18, 35, "Input"],
Cell[1142603, 28074, 767, 19, 35, "Input"],
Cell[1143373, 28095, 836, 28, 99, "Input"],
Cell[1144212, 28125, 4059, 112, 177, "Input"],
Cell[1148274, 28239, 448, 10, 101, "Input"],
Cell[1148725, 28251, 2365, 58, 99, "Input"],
Cell[1151093, 28311, 92, 1, 35, "Input"],
Cell[1151188, 28314, 5273, 154, 281, "Input"],
Cell[1156464, 28470, 133, 2, 35, "Input"],
Cell[1156600, 28474, 514, 14, 131, "Input"],
Cell[1157117, 28490, 204, 3, 114, "Input"],
Cell[1157324, 28495, 273, 7, 58, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1157646, 28508, 102, 1, 98, "Section"],
Cell[CellGroupData[{
Cell[1157773, 28513, 114, 1, 45, "Subsection"],
Cell[1157890, 28516, 1144, 35, 80, "Input"],
Cell[1159037, 28553, 1894, 56, 146, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1160980, 28615, 103, 1, 60, "Section"],
Cell[CellGroupData[{
Cell[1161108, 28620, 130, 1, 45, "Subsection"],
Cell[CellGroupData[{
Cell[1161263, 28625, 108, 1, 31, "Subsubsection"],
Cell[1161374, 28628, 2479, 69, 152, "Input"],
Cell[1163856, 28699, 2569, 70, 152, "Input"],
Cell[1166428, 28771, 2935, 76, 152, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1169400, 28852, 107, 1, 22, "Subsubsection"],
Cell[1169510, 28855, 2704, 72, 152, "Input"],
Cell[1172217, 28929, 2846, 75, 152, "Input"],
Cell[1175066, 29006, 2981, 76, 152, "Input"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1178108, 29089, 189, 2, 60, "Section"],
Cell[1178300, 29093, 1260, 20, 179, "Text"],
Cell[1179563, 29115, 357, 10, 91, "Input"],
Cell[1179923, 29127, 215, 4, 35, "Input"],
Cell[1180141, 29133, 101, 1, 35, "Input"],
Cell[1180245, 29136, 653, 18, 67, "Input"],
Cell[1180901, 29156, 118, 2, 53, "Input"],
Cell[CellGroupData[{
Cell[1181044, 29162, 102, 1, 45, "Subsection"],
Cell[1181149, 29165, 4017, 106, 291, "Input"],
Cell[1185169, 29273, 212, 6, 53, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1185418, 29284, 116, 1, 35, "Subsection"],
Cell[1185537, 29287, 1742, 51, 124, "Input"],
Cell[1187282, 29340, 332, 9, 53, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1187663, 29355, 82, 1, 60, "Section"],
Cell[1187748, 29358, 614, 14, 35, "Input"],
Cell[1188365, 29374, 3961, 95, 300, "Input"],
Cell[1192329, 29471, 520, 15, 58, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1192886, 29491, 154, 2, 60, "Section"],
Cell[1193043, 29495, 2991, 72, 212, "Input"],
Cell[1196037, 29569, 133, 2, 35, "Input"],
Cell[1196173, 29573, 568, 13, 35, "Input"],
Cell[1196744, 29588, 840, 21, 75, "Input"],
Cell[1197587, 29611, 694, 20, 53, "Input"],
Cell[1198284, 29633, 99, 1, 35, "Input"],
Cell[1198386, 29636, 3499, 82, 124, "Input"],
Cell[1201888, 29720, 2835, 72, 124, "Input"],
Cell[1204726, 29794, 3251, 81, 168, "Input"],
Cell[1207980, 29877, 1713, 46, 80, "Input"],
Cell[1209696, 29925, 1285, 34, 106, "Input"],
Cell[1210984, 29961, 1044, 27, 58, "Input"],
Cell[1212031, 29990, 1696, 47, 91, "Input"],
Cell[1213730, 30039, 1819, 50, 79, "Input"],
Cell[1215552, 30091, 1957, 44, 58, "Input"],
Cell[1217512, 30137, 194, 4, 35, "Input"],
Cell[1217709, 30143, 71, 1, 35, "Input"],
Cell[1217783, 30146, 67, 1, 35, "Input"],
Cell[1217853, 30149, 67, 1, 35, "Input"],
Cell[1217923, 30152, 71, 1, 35, "Input"],
Cell[1217997, 30155, 67, 1, 35, "Input"],
Cell[1218067, 30158, 128, 3, 27, "Input"],
Cell[1218198, 30163, 189, 4, 35, "Input"],
Cell[1218390, 30169, 1349, 33, 58, "Input"],
Cell[1219742, 30204, 1129, 29, 58, "Input"],
Cell[1220874, 30235, 109, 2, 35, "Input"],
Cell[1220986, 30239, 117, 2, 35, "Input"],
Cell[1221106, 30243, 462, 12, 58, "Input"],
Cell[1221571, 30257, 232, 5, 35, "Input"],
Cell[1221806, 30264, 129, 2, 35, "Input"],
Cell[1221938, 30268, 1097, 30, 101, "Input"],
Cell[1223038, 30300, 793, 21, 84, "Input"],
Cell[1223834, 30323, 564, 17, 39, "Input"],
Cell[1224401, 30342, 2625, 76, 208, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1227063, 30423, 110, 1, 60, "Section"],
Cell[1227176, 30426, 776, 15, 287, "Text"],
Cell[1227955, 30443, 8883, 212, 608, "Input"],
Cell[1236841, 30657, 9376, 283, 357, "Input"],
Cell[1246220, 30942, 1338, 34, 146, "Input"],
Cell[1247561, 30978, 267, 4, 80, "Input"],
Cell[1247831, 30984, 5924, 173, 352, "Input"],
Cell[CellGroupData[{
Cell[1253780, 31161, 94, 1, 45, "Subsection"],
Cell[1253877, 31164, 4446, 132, 171, "Input"],
Cell[1258326, 31298, 7166, 223, 262, "Text"],
Cell[1265495, 31523, 706, 17, 49, "Input"],
Cell[1266204, 31542, 2133, 64, 213, "Input"],
Cell[CellGroupData[{
Cell[1268362, 31610, 106, 1, 31, "Subsubsection"],
Cell[1268471, 31613, 493, 14, 80, "Input"],
Cell[1268967, 31629, 3019, 86, 150, "Input"]
}, Closed]]
}, Closed]]
}, Closed]]
}
]
*)

(* End of internal cache information *)
